#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 3602
#define LARGE_STATE_COUNT 1000
#define SYMBOL_COUNT 341
#define ALIAS_COUNT 4
#define TOKEN_COUNT 153
#define EXTERNAL_TOKEN_COUNT 10
#define FIELD_COUNT 31
#define MAX_ALIAS_SEQUENCE_LENGTH 10
#define PRODUCTION_ID_COUNT 279

enum ts_symbol_identifiers {
  sym_identifier = 1,
  anon_sym_SEMI = 2,
  anon_sym_macro_rules_BANG = 3,
  anon_sym_LPAREN = 4,
  anon_sym_RPAREN = 5,
  anon_sym_LBRACK = 6,
  anon_sym_RBRACK = 7,
  anon_sym_LBRACE = 8,
  anon_sym_RBRACE = 9,
  anon_sym_EQ_GT = 10,
  anon_sym_COLON = 11,
  anon_sym_DOLLAR = 12,
  aux_sym_token_repetition_pattern_token1 = 13,
  anon_sym_PLUS = 14,
  anon_sym_STAR = 15,
  anon_sym_QMARK = 16,
  anon_sym_block = 17,
  anon_sym_expr = 18,
  anon_sym_ident = 19,
  anon_sym_item = 20,
  anon_sym_lifetime = 21,
  anon_sym_literal = 22,
  anon_sym_meta = 23,
  anon_sym_pat = 24,
  anon_sym_path = 25,
  anon_sym_stmt = 26,
  anon_sym_tt = 27,
  anon_sym_ty = 28,
  anon_sym_vis = 29,
  anon_sym_u8 = 30,
  anon_sym_i8 = 31,
  anon_sym_u16 = 32,
  anon_sym_i16 = 33,
  anon_sym_u32 = 34,
  anon_sym_i32 = 35,
  anon_sym_u64 = 36,
  anon_sym_i64 = 37,
  anon_sym_u128 = 38,
  anon_sym_i128 = 39,
  anon_sym_isize = 40,
  anon_sym_usize = 41,
  anon_sym_f32 = 42,
  anon_sym_f64 = 43,
  anon_sym_bool = 44,
  anon_sym_str = 45,
  anon_sym_char = 46,
  anon_sym_DASH = 47,
  anon_sym_SLASH = 48,
  anon_sym_PERCENT = 49,
  anon_sym_CARET = 50,
  anon_sym_BANG = 51,
  anon_sym_AMP = 52,
  anon_sym_PIPE = 53,
  anon_sym_AMP_AMP = 54,
  anon_sym_PIPE_PIPE = 55,
  anon_sym_LT_LT = 56,
  anon_sym_GT_GT = 57,
  anon_sym_PLUS_EQ = 58,
  anon_sym_DASH_EQ = 59,
  anon_sym_STAR_EQ = 60,
  anon_sym_SLASH_EQ = 61,
  anon_sym_PERCENT_EQ = 62,
  anon_sym_CARET_EQ = 63,
  anon_sym_AMP_EQ = 64,
  anon_sym_PIPE_EQ = 65,
  anon_sym_LT_LT_EQ = 66,
  anon_sym_GT_GT_EQ = 67,
  anon_sym_EQ = 68,
  anon_sym_EQ_EQ = 69,
  anon_sym_BANG_EQ = 70,
  anon_sym_GT = 71,
  anon_sym_LT = 72,
  anon_sym_GT_EQ = 73,
  anon_sym_LT_EQ = 74,
  anon_sym_AT = 75,
  anon_sym__ = 76,
  anon_sym_DOT = 77,
  anon_sym_DOT_DOT = 78,
  anon_sym_DOT_DOT_DOT = 79,
  anon_sym_DOT_DOT_EQ = 80,
  anon_sym_COMMA = 81,
  anon_sym_COLON_COLON = 82,
  anon_sym_DASH_GT = 83,
  anon_sym_POUND = 84,
  anon_sym_SQUOTE = 85,
  anon_sym_as = 86,
  anon_sym_async = 87,
  anon_sym_await = 88,
  anon_sym_break = 89,
  anon_sym_const = 90,
  anon_sym_continue = 91,
  anon_sym_default = 92,
  anon_sym_enum = 93,
  anon_sym_fn = 94,
  anon_sym_for = 95,
  anon_sym_if = 96,
  anon_sym_impl = 97,
  anon_sym_let = 98,
  anon_sym_loop = 99,
  anon_sym_match = 100,
  anon_sym_mod = 101,
  anon_sym_pub = 102,
  anon_sym_return = 103,
  anon_sym_static = 104,
  anon_sym_struct = 105,
  anon_sym_trait = 106,
  anon_sym_type = 107,
  anon_sym_union = 108,
  anon_sym_unsafe = 109,
  anon_sym_use = 110,
  anon_sym_where = 111,
  anon_sym_while = 112,
  anon_sym_extern = 113,
  anon_sym_ref = 114,
  anon_sym_else = 115,
  anon_sym_in = 116,
  anon_sym_LT2 = 117,
  anon_sym_dyn = 118,
  sym_mutable_specifier = 119,
  anon_sym_yield = 120,
  anon_sym_move = 121,
  anon_sym_try = 122,
  sym_integer_literal = 123,
  aux_sym_string_literal_token1 = 124,
  anon_sym_DQUOTE = 125,
  sym_char_literal = 126,
  sym_escape_sequence = 127,
  anon_sym_true = 128,
  anon_sym_false = 129,
  anon_sym_SLASH_SLASH = 130,
  aux_sym_line_comment_token1 = 131,
  aux_sym_line_comment_token2 = 132,
  aux_sym_line_comment_token3 = 133,
  sym__inner_line_doc_comment_marker = 134,
  sym__outer_line_doc_comment_marker = 135,
  anon_sym_SLASH_STAR = 136,
  anon_sym_STAR_SLASH = 137,
  sym_shebang = 138,
  sym_self = 139,
  sym_super = 140,
  sym_crate = 141,
  sym_metavariable = 142,
  sym_string_content = 143,
  sym__raw_string_literal_start = 144,
  sym_raw_string_literal_content = 145,
  sym__raw_string_literal_end = 146,
  sym_float_literal = 147,
  sym__outer_block_doc_comment_marker = 148,
  sym__inner_block_doc_comment_marker = 149,
  sym__block_comment_content = 150,
  sym__line_doc_content = 151,
  sym__error_sentinel = 152,
  sym_source_file = 153,
  sym__statement = 154,
  sym_empty_statement = 155,
  sym_expression_statement = 156,
  sym_macro_definition = 157,
  sym_macro_rule = 158,
  sym__token_pattern = 159,
  sym_token_tree_pattern = 160,
  sym_token_binding_pattern = 161,
  sym_token_repetition_pattern = 162,
  sym_fragment_specifier = 163,
  sym_token_tree = 164,
  sym_token_repetition = 165,
  sym_attribute_item = 166,
  sym_inner_attribute_item = 167,
  sym_attribute = 168,
  sym_mod_item = 169,
  sym_foreign_mod_item = 170,
  sym_declaration_list = 171,
  sym_struct_item = 172,
  sym_union_item = 173,
  sym_enum_item = 174,
  sym_enum_variant_list = 175,
  sym_enum_variant = 176,
  sym_field_declaration_list = 177,
  sym_field_declaration = 178,
  sym_ordered_field_declaration_list = 179,
  sym_extern_crate_declaration = 180,
  sym_const_item = 181,
  sym_static_item = 182,
  sym_type_item = 183,
  sym_function_item = 184,
  sym_function_signature_item = 185,
  sym_function_modifiers = 186,
  sym_where_clause = 187,
  sym_where_predicate = 188,
  sym_impl_item = 189,
  sym_trait_item = 190,
  sym_associated_type = 191,
  sym_trait_bounds = 192,
  sym_higher_ranked_trait_bound = 193,
  sym_removed_trait_bound = 194,
  sym_type_parameters = 195,
  sym_const_parameter = 196,
  sym_constrained_type_parameter = 197,
  sym_optional_type_parameter = 198,
  sym_let_declaration = 199,
  sym_use_declaration = 200,
  sym__use_clause = 201,
  sym_scoped_use_list = 202,
  sym_use_list = 203,
  sym_use_as_clause = 204,
  sym_use_wildcard = 205,
  sym_parameters = 206,
  sym_self_parameter = 207,
  sym_variadic_parameter = 208,
  sym_parameter = 209,
  sym_extern_modifier = 210,
  sym_visibility_modifier = 211,
  sym__type = 212,
  sym_bracketed_type = 213,
  sym_qualified_type = 214,
  sym_lifetime = 215,
  sym_array_type = 216,
  sym_for_lifetimes = 217,
  sym_function_type = 218,
  sym_tuple_type = 219,
  sym_unit_type = 220,
  sym_generic_function = 221,
  sym_generic_type = 222,
  sym_generic_type_with_turbofish = 223,
  sym_bounded_type = 224,
  sym_type_arguments = 225,
  sym_type_binding = 226,
  sym_reference_type = 227,
  sym_pointer_type = 228,
  sym_never_type = 229,
  sym_abstract_type = 230,
  sym_dynamic_type = 231,
  sym__expression_except_range = 232,
  sym__expression = 233,
  sym_macro_invocation = 234,
  sym_delim_token_tree = 235,
  sym__delim_tokens = 236,
  sym__non_delim_token = 237,
  sym_scoped_identifier = 238,
  sym_scoped_type_identifier_in_expression_position = 239,
  sym_scoped_type_identifier = 240,
  sym_range_expression = 241,
  sym_unary_expression = 242,
  sym_try_expression = 243,
  sym_reference_expression = 244,
  sym_binary_expression = 245,
  sym_assignment_expression = 246,
  sym_compound_assignment_expr = 247,
  sym_type_cast_expression = 248,
  sym_return_expression = 249,
  sym_yield_expression = 250,
  sym_call_expression = 251,
  sym_arguments = 252,
  sym_array_expression = 253,
  sym_parenthesized_expression = 254,
  sym_tuple_expression = 255,
  sym_unit_expression = 256,
  sym_struct_expression = 257,
  sym_field_initializer_list = 258,
  sym_shorthand_field_initializer = 259,
  sym_field_initializer = 260,
  sym_base_field_initializer = 261,
  sym_if_expression = 262,
  sym_let_condition = 263,
  sym__let_chain = 264,
  sym__condition = 265,
  sym_else_clause = 266,
  sym_match_expression = 267,
  sym_match_block = 268,
  sym_match_arm = 269,
  sym_last_match_arm = 270,
  sym_match_pattern = 271,
  sym_while_expression = 272,
  sym_loop_expression = 273,
  sym_for_expression = 274,
  sym_const_block = 275,
  sym_closure_expression = 276,
  sym_closure_parameters = 277,
  sym_label = 278,
  sym_break_expression = 279,
  sym_continue_expression = 280,
  sym_index_expression = 281,
  sym_await_expression = 282,
  sym_field_expression = 283,
  sym_unsafe_block = 284,
  sym_async_block = 285,
  sym_try_block = 286,
  sym_block = 287,
  sym__pattern = 288,
  sym_tuple_pattern = 289,
  sym_slice_pattern = 290,
  sym_tuple_struct_pattern = 291,
  sym_struct_pattern = 292,
  sym_field_pattern = 293,
  sym_remaining_field_pattern = 294,
  sym_mut_pattern = 295,
  sym_range_pattern = 296,
  sym_ref_pattern = 297,
  sym_captured_pattern = 298,
  sym_reference_pattern = 299,
  sym_or_pattern = 300,
  sym__literal = 301,
  sym__literal_pattern = 302,
  sym_negative_literal = 303,
  sym_string_literal = 304,
  sym_raw_string_literal = 305,
  sym_boolean_literal = 306,
  sym_line_comment = 307,
  sym__line_doc_comment_marker = 308,
  sym_block_comment = 309,
  sym__block_doc_comment_marker = 310,
  aux_sym_source_file_repeat1 = 311,
  aux_sym_macro_definition_repeat1 = 312,
  aux_sym_token_tree_pattern_repeat1 = 313,
  aux_sym_token_tree_repeat1 = 314,
  aux_sym__non_special_token_repeat1 = 315,
  aux_sym_declaration_list_repeat1 = 316,
  aux_sym_enum_variant_list_repeat1 = 317,
  aux_sym_enum_variant_list_repeat2 = 318,
  aux_sym_field_declaration_list_repeat1 = 319,
  aux_sym_ordered_field_declaration_list_repeat1 = 320,
  aux_sym_function_modifiers_repeat1 = 321,
  aux_sym_where_clause_repeat1 = 322,
  aux_sym_trait_bounds_repeat1 = 323,
  aux_sym_type_parameters_repeat1 = 324,
  aux_sym_use_list_repeat1 = 325,
  aux_sym_parameters_repeat1 = 326,
  aux_sym_for_lifetimes_repeat1 = 327,
  aux_sym_tuple_type_repeat1 = 328,
  aux_sym_type_arguments_repeat1 = 329,
  aux_sym_delim_token_tree_repeat1 = 330,
  aux_sym_arguments_repeat1 = 331,
  aux_sym_tuple_expression_repeat1 = 332,
  aux_sym_field_initializer_list_repeat1 = 333,
  aux_sym_match_block_repeat1 = 334,
  aux_sym_match_arm_repeat1 = 335,
  aux_sym_closure_parameters_repeat1 = 336,
  aux_sym_tuple_pattern_repeat1 = 337,
  aux_sym_slice_pattern_repeat1 = 338,
  aux_sym_struct_pattern_repeat1 = 339,
  aux_sym_string_literal_repeat1 = 340,
  alias_sym_field_identifier = 341,
  alias_sym_let_chain = 342,
  alias_sym_shorthand_field_identifier = 343,
  alias_sym_type_identifier = 344,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym_SEMI] = ";",
  [anon_sym_macro_rules_BANG] = "macro_rules!",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_COLON] = ":",
  [anon_sym_DOLLAR] = "$",
  [aux_sym_token_repetition_pattern_token1] = "token_repetition_pattern_token1",
  [anon_sym_PLUS] = "+",
  [anon_sym_STAR] = "*",
  [anon_sym_QMARK] = "\?",
  [anon_sym_block] = "block",
  [anon_sym_expr] = "expr",
  [anon_sym_ident] = "ident",
  [anon_sym_item] = "item",
  [anon_sym_lifetime] = "lifetime",
  [anon_sym_literal] = "literal",
  [anon_sym_meta] = "meta",
  [anon_sym_pat] = "pat",
  [anon_sym_path] = "path",
  [anon_sym_stmt] = "stmt",
  [anon_sym_tt] = "tt",
  [anon_sym_ty] = "ty",
  [anon_sym_vis] = "vis",
  [anon_sym_u8] = "primitive_type",
  [anon_sym_i8] = "primitive_type",
  [anon_sym_u16] = "primitive_type",
  [anon_sym_i16] = "primitive_type",
  [anon_sym_u32] = "primitive_type",
  [anon_sym_i32] = "primitive_type",
  [anon_sym_u64] = "primitive_type",
  [anon_sym_i64] = "primitive_type",
  [anon_sym_u128] = "primitive_type",
  [anon_sym_i128] = "primitive_type",
  [anon_sym_isize] = "primitive_type",
  [anon_sym_usize] = "primitive_type",
  [anon_sym_f32] = "primitive_type",
  [anon_sym_f64] = "primitive_type",
  [anon_sym_bool] = "primitive_type",
  [anon_sym_str] = "primitive_type",
  [anon_sym_char] = "primitive_type",
  [anon_sym_DASH] = "-",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_CARET] = "^",
  [anon_sym_BANG] = "!",
  [anon_sym_AMP] = "&",
  [anon_sym_PIPE] = "|",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_EQ] = "=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_GT] = ">",
  [anon_sym_LT] = "<",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_AT] = "@",
  [anon_sym__] = "_",
  [anon_sym_DOT] = ".",
  [anon_sym_DOT_DOT] = "..",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_DOT_DOT_EQ] = "..=",
  [anon_sym_COMMA] = ",",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_POUND] = "#",
  [anon_sym_SQUOTE] = "'",
  [anon_sym_as] = "as",
  [anon_sym_async] = "async",
  [anon_sym_await] = "await",
  [anon_sym_break] = "break",
  [anon_sym_const] = "const",
  [anon_sym_continue] = "continue",
  [anon_sym_default] = "default",
  [anon_sym_enum] = "enum",
  [anon_sym_fn] = "fn",
  [anon_sym_for] = "for",
  [anon_sym_if] = "if",
  [anon_sym_impl] = "impl",
  [anon_sym_let] = "let",
  [anon_sym_loop] = "loop",
  [anon_sym_match] = "match",
  [anon_sym_mod] = "mod",
  [anon_sym_pub] = "pub",
  [anon_sym_return] = "return",
  [anon_sym_static] = "static",
  [anon_sym_struct] = "struct",
  [anon_sym_trait] = "trait",
  [anon_sym_type] = "type",
  [anon_sym_union] = "union",
  [anon_sym_unsafe] = "unsafe",
  [anon_sym_use] = "use",
  [anon_sym_where] = "where",
  [anon_sym_while] = "while",
  [anon_sym_extern] = "extern",
  [anon_sym_ref] = "ref",
  [anon_sym_else] = "else",
  [anon_sym_in] = "in",
  [anon_sym_LT2] = "<",
  [anon_sym_dyn] = "dyn",
  [sym_mutable_specifier] = "mutable_specifier",
  [anon_sym_yield] = "yield",
  [anon_sym_move] = "move",
  [anon_sym_try] = "try",
  [sym_integer_literal] = "integer_literal",
  [aux_sym_string_literal_token1] = "\"",
  [anon_sym_DQUOTE] = "\"",
  [sym_char_literal] = "char_literal",
  [sym_escape_sequence] = "escape_sequence",
  [anon_sym_true] = "true",
  [anon_sym_false] = "false",
  [anon_sym_SLASH_SLASH] = "//",
  [aux_sym_line_comment_token1] = "line_comment_token1",
  [aux_sym_line_comment_token2] = "line_comment_token2",
  [aux_sym_line_comment_token3] = "line_comment_token3",
  [sym__inner_line_doc_comment_marker] = "inner_doc_comment_marker",
  [sym__outer_line_doc_comment_marker] = "outer_doc_comment_marker",
  [anon_sym_SLASH_STAR] = "/*",
  [anon_sym_STAR_SLASH] = "*/",
  [sym_shebang] = "shebang",
  [sym_self] = "self",
  [sym_super] = "super",
  [sym_crate] = "crate",
  [sym_metavariable] = "metavariable",
  [sym_string_content] = "string_content",
  [sym__raw_string_literal_start] = "_raw_string_literal_start",
  [sym_raw_string_literal_content] = "string_content",
  [sym__raw_string_literal_end] = "_raw_string_literal_end",
  [sym_float_literal] = "float_literal",
  [sym__outer_block_doc_comment_marker] = "outer_doc_comment_marker",
  [sym__inner_block_doc_comment_marker] = "inner_doc_comment_marker",
  [sym__block_comment_content] = "_block_comment_content",
  [sym__line_doc_content] = "doc_comment",
  [sym__error_sentinel] = "_error_sentinel",
  [sym_source_file] = "source_file",
  [sym__statement] = "_statement",
  [sym_empty_statement] = "empty_statement",
  [sym_expression_statement] = "expression_statement",
  [sym_macro_definition] = "macro_definition",
  [sym_macro_rule] = "macro_rule",
  [sym__token_pattern] = "_token_pattern",
  [sym_token_tree_pattern] = "token_tree_pattern",
  [sym_token_binding_pattern] = "token_binding_pattern",
  [sym_token_repetition_pattern] = "token_repetition_pattern",
  [sym_fragment_specifier] = "fragment_specifier",
  [sym_token_tree] = "token_tree",
  [sym_token_repetition] = "token_repetition",
  [sym_attribute_item] = "attribute_item",
  [sym_inner_attribute_item] = "inner_attribute_item",
  [sym_attribute] = "attribute",
  [sym_mod_item] = "mod_item",
  [sym_foreign_mod_item] = "foreign_mod_item",
  [sym_declaration_list] = "declaration_list",
  [sym_struct_item] = "struct_item",
  [sym_union_item] = "union_item",
  [sym_enum_item] = "enum_item",
  [sym_enum_variant_list] = "enum_variant_list",
  [sym_enum_variant] = "enum_variant",
  [sym_field_declaration_list] = "field_declaration_list",
  [sym_field_declaration] = "field_declaration",
  [sym_ordered_field_declaration_list] = "ordered_field_declaration_list",
  [sym_extern_crate_declaration] = "extern_crate_declaration",
  [sym_const_item] = "const_item",
  [sym_static_item] = "static_item",
  [sym_type_item] = "type_item",
  [sym_function_item] = "function_item",
  [sym_function_signature_item] = "function_signature_item",
  [sym_function_modifiers] = "function_modifiers",
  [sym_where_clause] = "where_clause",
  [sym_where_predicate] = "where_predicate",
  [sym_impl_item] = "impl_item",
  [sym_trait_item] = "trait_item",
  [sym_associated_type] = "associated_type",
  [sym_trait_bounds] = "trait_bounds",
  [sym_higher_ranked_trait_bound] = "higher_ranked_trait_bound",
  [sym_removed_trait_bound] = "removed_trait_bound",
  [sym_type_parameters] = "type_parameters",
  [sym_const_parameter] = "const_parameter",
  [sym_constrained_type_parameter] = "constrained_type_parameter",
  [sym_optional_type_parameter] = "optional_type_parameter",
  [sym_let_declaration] = "let_declaration",
  [sym_use_declaration] = "use_declaration",
  [sym__use_clause] = "_use_clause",
  [sym_scoped_use_list] = "scoped_use_list",
  [sym_use_list] = "use_list",
  [sym_use_as_clause] = "use_as_clause",
  [sym_use_wildcard] = "use_wildcard",
  [sym_parameters] = "parameters",
  [sym_self_parameter] = "self_parameter",
  [sym_variadic_parameter] = "variadic_parameter",
  [sym_parameter] = "parameter",
  [sym_extern_modifier] = "extern_modifier",
  [sym_visibility_modifier] = "visibility_modifier",
  [sym__type] = "_type",
  [sym_bracketed_type] = "bracketed_type",
  [sym_qualified_type] = "qualified_type",
  [sym_lifetime] = "lifetime",
  [sym_array_type] = "array_type",
  [sym_for_lifetimes] = "for_lifetimes",
  [sym_function_type] = "function_type",
  [sym_tuple_type] = "tuple_type",
  [sym_unit_type] = "unit_type",
  [sym_generic_function] = "generic_function",
  [sym_generic_type] = "generic_type",
  [sym_generic_type_with_turbofish] = "generic_type_with_turbofish",
  [sym_bounded_type] = "bounded_type",
  [sym_type_arguments] = "type_arguments",
  [sym_type_binding] = "type_binding",
  [sym_reference_type] = "reference_type",
  [sym_pointer_type] = "pointer_type",
  [sym_never_type] = "never_type",
  [sym_abstract_type] = "abstract_type",
  [sym_dynamic_type] = "dynamic_type",
  [sym__expression_except_range] = "_expression_except_range",
  [sym__expression] = "_expression",
  [sym_macro_invocation] = "macro_invocation",
  [sym_delim_token_tree] = "token_tree",
  [sym__delim_tokens] = "_delim_tokens",
  [sym__non_delim_token] = "_non_delim_token",
  [sym_scoped_identifier] = "scoped_identifier",
  [sym_scoped_type_identifier_in_expression_position] = "scoped_type_identifier",
  [sym_scoped_type_identifier] = "scoped_type_identifier",
  [sym_range_expression] = "range_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_try_expression] = "try_expression",
  [sym_reference_expression] = "reference_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_compound_assignment_expr] = "compound_assignment_expr",
  [sym_type_cast_expression] = "type_cast_expression",
  [sym_return_expression] = "return_expression",
  [sym_yield_expression] = "yield_expression",
  [sym_call_expression] = "call_expression",
  [sym_arguments] = "arguments",
  [sym_array_expression] = "array_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_tuple_expression] = "tuple_expression",
  [sym_unit_expression] = "unit_expression",
  [sym_struct_expression] = "struct_expression",
  [sym_field_initializer_list] = "field_initializer_list",
  [sym_shorthand_field_initializer] = "shorthand_field_initializer",
  [sym_field_initializer] = "field_initializer",
  [sym_base_field_initializer] = "base_field_initializer",
  [sym_if_expression] = "if_expression",
  [sym_let_condition] = "let_condition",
  [sym__let_chain] = "_let_chain",
  [sym__condition] = "_condition",
  [sym_else_clause] = "else_clause",
  [sym_match_expression] = "match_expression",
  [sym_match_block] = "match_block",
  [sym_match_arm] = "match_arm",
  [sym_last_match_arm] = "match_arm",
  [sym_match_pattern] = "match_pattern",
  [sym_while_expression] = "while_expression",
  [sym_loop_expression] = "loop_expression",
  [sym_for_expression] = "for_expression",
  [sym_const_block] = "const_block",
  [sym_closure_expression] = "closure_expression",
  [sym_closure_parameters] = "closure_parameters",
  [sym_label] = "label",
  [sym_break_expression] = "break_expression",
  [sym_continue_expression] = "continue_expression",
  [sym_index_expression] = "index_expression",
  [sym_await_expression] = "await_expression",
  [sym_field_expression] = "field_expression",
  [sym_unsafe_block] = "unsafe_block",
  [sym_async_block] = "async_block",
  [sym_try_block] = "try_block",
  [sym_block] = "block",
  [sym__pattern] = "_pattern",
  [sym_tuple_pattern] = "tuple_pattern",
  [sym_slice_pattern] = "slice_pattern",
  [sym_tuple_struct_pattern] = "tuple_struct_pattern",
  [sym_struct_pattern] = "struct_pattern",
  [sym_field_pattern] = "field_pattern",
  [sym_remaining_field_pattern] = "remaining_field_pattern",
  [sym_mut_pattern] = "mut_pattern",
  [sym_range_pattern] = "range_pattern",
  [sym_ref_pattern] = "ref_pattern",
  [sym_captured_pattern] = "captured_pattern",
  [sym_reference_pattern] = "reference_pattern",
  [sym_or_pattern] = "or_pattern",
  [sym__literal] = "_literal",
  [sym__literal_pattern] = "_literal_pattern",
  [sym_negative_literal] = "negative_literal",
  [sym_string_literal] = "string_literal",
  [sym_raw_string_literal] = "raw_string_literal",
  [sym_boolean_literal] = "boolean_literal",
  [sym_line_comment] = "line_comment",
  [sym__line_doc_comment_marker] = "_line_doc_comment_marker",
  [sym_block_comment] = "block_comment",
  [sym__block_doc_comment_marker] = "_block_doc_comment_marker",
  [aux_sym_source_file_repeat1] = "source_file_repeat1",
  [aux_sym_macro_definition_repeat1] = "macro_definition_repeat1",
  [aux_sym_token_tree_pattern_repeat1] = "token_tree_pattern_repeat1",
  [aux_sym_token_tree_repeat1] = "token_tree_repeat1",
  [aux_sym__non_special_token_repeat1] = "_non_special_token_repeat1",
  [aux_sym_declaration_list_repeat1] = "declaration_list_repeat1",
  [aux_sym_enum_variant_list_repeat1] = "enum_variant_list_repeat1",
  [aux_sym_enum_variant_list_repeat2] = "enum_variant_list_repeat2",
  [aux_sym_field_declaration_list_repeat1] = "field_declaration_list_repeat1",
  [aux_sym_ordered_field_declaration_list_repeat1] = "ordered_field_declaration_list_repeat1",
  [aux_sym_function_modifiers_repeat1] = "function_modifiers_repeat1",
  [aux_sym_where_clause_repeat1] = "where_clause_repeat1",
  [aux_sym_trait_bounds_repeat1] = "trait_bounds_repeat1",
  [aux_sym_type_parameters_repeat1] = "type_parameters_repeat1",
  [aux_sym_use_list_repeat1] = "use_list_repeat1",
  [aux_sym_parameters_repeat1] = "parameters_repeat1",
  [aux_sym_for_lifetimes_repeat1] = "for_lifetimes_repeat1",
  [aux_sym_tuple_type_repeat1] = "tuple_type_repeat1",
  [aux_sym_type_arguments_repeat1] = "type_arguments_repeat1",
  [aux_sym_delim_token_tree_repeat1] = "delim_token_tree_repeat1",
  [aux_sym_arguments_repeat1] = "arguments_repeat1",
  [aux_sym_tuple_expression_repeat1] = "tuple_expression_repeat1",
  [aux_sym_field_initializer_list_repeat1] = "field_initializer_list_repeat1",
  [aux_sym_match_block_repeat1] = "match_block_repeat1",
  [aux_sym_match_arm_repeat1] = "match_arm_repeat1",
  [aux_sym_closure_parameters_repeat1] = "closure_parameters_repeat1",
  [aux_sym_tuple_pattern_repeat1] = "tuple_pattern_repeat1",
  [aux_sym_slice_pattern_repeat1] = "slice_pattern_repeat1",
  [aux_sym_struct_pattern_repeat1] = "struct_pattern_repeat1",
  [aux_sym_string_literal_repeat1] = "string_literal_repeat1",
  [alias_sym_field_identifier] = "field_identifier",
  [alias_sym_let_chain] = "let_chain",
  [alias_sym_shorthand_field_identifier] = "shorthand_field_identifier",
  [alias_sym_type_identifier] = "type_identifier",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_macro_rules_BANG] = anon_sym_macro_rules_BANG,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_DOLLAR] = anon_sym_DOLLAR,
  [aux_sym_token_repetition_pattern_token1] = aux_sym_token_repetition_pattern_token1,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_block] = anon_sym_block,
  [anon_sym_expr] = anon_sym_expr,
  [anon_sym_ident] = anon_sym_ident,
  [anon_sym_item] = anon_sym_item,
  [anon_sym_lifetime] = anon_sym_lifetime,
  [anon_sym_literal] = anon_sym_literal,
  [anon_sym_meta] = anon_sym_meta,
  [anon_sym_pat] = anon_sym_pat,
  [anon_sym_path] = anon_sym_path,
  [anon_sym_stmt] = anon_sym_stmt,
  [anon_sym_tt] = anon_sym_tt,
  [anon_sym_ty] = anon_sym_ty,
  [anon_sym_vis] = anon_sym_vis,
  [anon_sym_u8] = anon_sym_u8,
  [anon_sym_i8] = anon_sym_u8,
  [anon_sym_u16] = anon_sym_u8,
  [anon_sym_i16] = anon_sym_u8,
  [anon_sym_u32] = anon_sym_u8,
  [anon_sym_i32] = anon_sym_u8,
  [anon_sym_u64] = anon_sym_u8,
  [anon_sym_i64] = anon_sym_u8,
  [anon_sym_u128] = anon_sym_u8,
  [anon_sym_i128] = anon_sym_u8,
  [anon_sym_isize] = anon_sym_u8,
  [anon_sym_usize] = anon_sym_u8,
  [anon_sym_f32] = anon_sym_u8,
  [anon_sym_f64] = anon_sym_u8,
  [anon_sym_bool] = anon_sym_u8,
  [anon_sym_str] = anon_sym_u8,
  [anon_sym_char] = anon_sym_u8,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym__] = anon_sym__,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_DOT_DOT] = anon_sym_DOT_DOT,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_DOT_DOT_EQ] = anon_sym_DOT_DOT_EQ,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_POUND] = anon_sym_POUND,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_async] = anon_sym_async,
  [anon_sym_await] = anon_sym_await,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_fn] = anon_sym_fn,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_impl] = anon_sym_impl,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_loop] = anon_sym_loop,
  [anon_sym_match] = anon_sym_match,
  [anon_sym_mod] = anon_sym_mod,
  [anon_sym_pub] = anon_sym_pub,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_struct] = anon_sym_struct,
  [anon_sym_trait] = anon_sym_trait,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_union] = anon_sym_union,
  [anon_sym_unsafe] = anon_sym_unsafe,
  [anon_sym_use] = anon_sym_use,
  [anon_sym_where] = anon_sym_where,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_extern] = anon_sym_extern,
  [anon_sym_ref] = anon_sym_ref,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_LT2] = anon_sym_LT,
  [anon_sym_dyn] = anon_sym_dyn,
  [sym_mutable_specifier] = sym_mutable_specifier,
  [anon_sym_yield] = anon_sym_yield,
  [anon_sym_move] = anon_sym_move,
  [anon_sym_try] = anon_sym_try,
  [sym_integer_literal] = sym_integer_literal,
  [aux_sym_string_literal_token1] = anon_sym_DQUOTE,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [sym_char_literal] = sym_char_literal,
  [sym_escape_sequence] = sym_escape_sequence,
  [anon_sym_true] = anon_sym_true,
  [anon_sym_false] = anon_sym_false,
  [anon_sym_SLASH_SLASH] = anon_sym_SLASH_SLASH,
  [aux_sym_line_comment_token1] = aux_sym_line_comment_token1,
  [aux_sym_line_comment_token2] = aux_sym_line_comment_token2,
  [aux_sym_line_comment_token3] = aux_sym_line_comment_token3,
  [sym__inner_line_doc_comment_marker] = sym__inner_block_doc_comment_marker,
  [sym__outer_line_doc_comment_marker] = sym__outer_block_doc_comment_marker,
  [anon_sym_SLASH_STAR] = anon_sym_SLASH_STAR,
  [anon_sym_STAR_SLASH] = anon_sym_STAR_SLASH,
  [sym_shebang] = sym_shebang,
  [sym_self] = sym_self,
  [sym_super] = sym_super,
  [sym_crate] = sym_crate,
  [sym_metavariable] = sym_metavariable,
  [sym_string_content] = sym_string_content,
  [sym__raw_string_literal_start] = sym__raw_string_literal_start,
  [sym_raw_string_literal_content] = sym_string_content,
  [sym__raw_string_literal_end] = sym__raw_string_literal_end,
  [sym_float_literal] = sym_float_literal,
  [sym__outer_block_doc_comment_marker] = sym__outer_block_doc_comment_marker,
  [sym__inner_block_doc_comment_marker] = sym__inner_block_doc_comment_marker,
  [sym__block_comment_content] = sym__block_comment_content,
  [sym__line_doc_content] = sym__line_doc_content,
  [sym__error_sentinel] = sym__error_sentinel,
  [sym_source_file] = sym_source_file,
  [sym__statement] = sym__statement,
  [sym_empty_statement] = sym_empty_statement,
  [sym_expression_statement] = sym_expression_statement,
  [sym_macro_definition] = sym_macro_definition,
  [sym_macro_rule] = sym_macro_rule,
  [sym__token_pattern] = sym__token_pattern,
  [sym_token_tree_pattern] = sym_token_tree_pattern,
  [sym_token_binding_pattern] = sym_token_binding_pattern,
  [sym_token_repetition_pattern] = sym_token_repetition_pattern,
  [sym_fragment_specifier] = sym_fragment_specifier,
  [sym_token_tree] = sym_token_tree,
  [sym_token_repetition] = sym_token_repetition,
  [sym_attribute_item] = sym_attribute_item,
  [sym_inner_attribute_item] = sym_inner_attribute_item,
  [sym_attribute] = sym_attribute,
  [sym_mod_item] = sym_mod_item,
  [sym_foreign_mod_item] = sym_foreign_mod_item,
  [sym_declaration_list] = sym_declaration_list,
  [sym_struct_item] = sym_struct_item,
  [sym_union_item] = sym_union_item,
  [sym_enum_item] = sym_enum_item,
  [sym_enum_variant_list] = sym_enum_variant_list,
  [sym_enum_variant] = sym_enum_variant,
  [sym_field_declaration_list] = sym_field_declaration_list,
  [sym_field_declaration] = sym_field_declaration,
  [sym_ordered_field_declaration_list] = sym_ordered_field_declaration_list,
  [sym_extern_crate_declaration] = sym_extern_crate_declaration,
  [sym_const_item] = sym_const_item,
  [sym_static_item] = sym_static_item,
  [sym_type_item] = sym_type_item,
  [sym_function_item] = sym_function_item,
  [sym_function_signature_item] = sym_function_signature_item,
  [sym_function_modifiers] = sym_function_modifiers,
  [sym_where_clause] = sym_where_clause,
  [sym_where_predicate] = sym_where_predicate,
  [sym_impl_item] = sym_impl_item,
  [sym_trait_item] = sym_trait_item,
  [sym_associated_type] = sym_associated_type,
  [sym_trait_bounds] = sym_trait_bounds,
  [sym_higher_ranked_trait_bound] = sym_higher_ranked_trait_bound,
  [sym_removed_trait_bound] = sym_removed_trait_bound,
  [sym_type_parameters] = sym_type_parameters,
  [sym_const_parameter] = sym_const_parameter,
  [sym_constrained_type_parameter] = sym_constrained_type_parameter,
  [sym_optional_type_parameter] = sym_optional_type_parameter,
  [sym_let_declaration] = sym_let_declaration,
  [sym_use_declaration] = sym_use_declaration,
  [sym__use_clause] = sym__use_clause,
  [sym_scoped_use_list] = sym_scoped_use_list,
  [sym_use_list] = sym_use_list,
  [sym_use_as_clause] = sym_use_as_clause,
  [sym_use_wildcard] = sym_use_wildcard,
  [sym_parameters] = sym_parameters,
  [sym_self_parameter] = sym_self_parameter,
  [sym_variadic_parameter] = sym_variadic_parameter,
  [sym_parameter] = sym_parameter,
  [sym_extern_modifier] = sym_extern_modifier,
  [sym_visibility_modifier] = sym_visibility_modifier,
  [sym__type] = sym__type,
  [sym_bracketed_type] = sym_bracketed_type,
  [sym_qualified_type] = sym_qualified_type,
  [sym_lifetime] = sym_lifetime,
  [sym_array_type] = sym_array_type,
  [sym_for_lifetimes] = sym_for_lifetimes,
  [sym_function_type] = sym_function_type,
  [sym_tuple_type] = sym_tuple_type,
  [sym_unit_type] = sym_unit_type,
  [sym_generic_function] = sym_generic_function,
  [sym_generic_type] = sym_generic_type,
  [sym_generic_type_with_turbofish] = sym_generic_type_with_turbofish,
  [sym_bounded_type] = sym_bounded_type,
  [sym_type_arguments] = sym_type_arguments,
  [sym_type_binding] = sym_type_binding,
  [sym_reference_type] = sym_reference_type,
  [sym_pointer_type] = sym_pointer_type,
  [sym_never_type] = sym_never_type,
  [sym_abstract_type] = sym_abstract_type,
  [sym_dynamic_type] = sym_dynamic_type,
  [sym__expression_except_range] = sym__expression_except_range,
  [sym__expression] = sym__expression,
  [sym_macro_invocation] = sym_macro_invocation,
  [sym_delim_token_tree] = sym_token_tree,
  [sym__delim_tokens] = sym__delim_tokens,
  [sym__non_delim_token] = sym__non_delim_token,
  [sym_scoped_identifier] = sym_scoped_identifier,
  [sym_scoped_type_identifier_in_expression_position] = sym_scoped_type_identifier,
  [sym_scoped_type_identifier] = sym_scoped_type_identifier,
  [sym_range_expression] = sym_range_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_try_expression] = sym_try_expression,
  [sym_reference_expression] = sym_reference_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym_compound_assignment_expr] = sym_compound_assignment_expr,
  [sym_type_cast_expression] = sym_type_cast_expression,
  [sym_return_expression] = sym_return_expression,
  [sym_yield_expression] = sym_yield_expression,
  [sym_call_expression] = sym_call_expression,
  [sym_arguments] = sym_arguments,
  [sym_array_expression] = sym_array_expression,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_tuple_expression] = sym_tuple_expression,
  [sym_unit_expression] = sym_unit_expression,
  [sym_struct_expression] = sym_struct_expression,
  [sym_field_initializer_list] = sym_field_initializer_list,
  [sym_shorthand_field_initializer] = sym_shorthand_field_initializer,
  [sym_field_initializer] = sym_field_initializer,
  [sym_base_field_initializer] = sym_base_field_initializer,
  [sym_if_expression] = sym_if_expression,
  [sym_let_condition] = sym_let_condition,
  [sym__let_chain] = sym__let_chain,
  [sym__condition] = sym__condition,
  [sym_else_clause] = sym_else_clause,
  [sym_match_expression] = sym_match_expression,
  [sym_match_block] = sym_match_block,
  [sym_match_arm] = sym_match_arm,
  [sym_last_match_arm] = sym_match_arm,
  [sym_match_pattern] = sym_match_pattern,
  [sym_while_expression] = sym_while_expression,
  [sym_loop_expression] = sym_loop_expression,
  [sym_for_expression] = sym_for_expression,
  [sym_const_block] = sym_const_block,
  [sym_closure_expression] = sym_closure_expression,
  [sym_closure_parameters] = sym_closure_parameters,
  [sym_label] = sym_label,
  [sym_break_expression] = sym_break_expression,
  [sym_continue_expression] = sym_continue_expression,
  [sym_index_expression] = sym_index_expression,
  [sym_await_expression] = sym_await_expression,
  [sym_field_expression] = sym_field_expression,
  [sym_unsafe_block] = sym_unsafe_block,
  [sym_async_block] = sym_async_block,
  [sym_try_block] = sym_try_block,
  [sym_block] = sym_block,
  [sym__pattern] = sym__pattern,
  [sym_tuple_pattern] = sym_tuple_pattern,
  [sym_slice_pattern] = sym_slice_pattern,
  [sym_tuple_struct_pattern] = sym_tuple_struct_pattern,
  [sym_struct_pattern] = sym_struct_pattern,
  [sym_field_pattern] = sym_field_pattern,
  [sym_remaining_field_pattern] = sym_remaining_field_pattern,
  [sym_mut_pattern] = sym_mut_pattern,
  [sym_range_pattern] = sym_range_pattern,
  [sym_ref_pattern] = sym_ref_pattern,
  [sym_captured_pattern] = sym_captured_pattern,
  [sym_reference_pattern] = sym_reference_pattern,
  [sym_or_pattern] = sym_or_pattern,
  [sym__literal] = sym__literal,
  [sym__literal_pattern] = sym__literal_pattern,
  [sym_negative_literal] = sym_negative_literal,
  [sym_string_literal] = sym_string_literal,
  [sym_raw_string_literal] = sym_raw_string_literal,
  [sym_boolean_literal] = sym_boolean_literal,
  [sym_line_comment] = sym_line_comment,
  [sym__line_doc_comment_marker] = sym__line_doc_comment_marker,
  [sym_block_comment] = sym_block_comment,
  [sym__block_doc_comment_marker] = sym__block_doc_comment_marker,
  [aux_sym_source_file_repeat1] = aux_sym_source_file_repeat1,
  [aux_sym_macro_definition_repeat1] = aux_sym_macro_definition_repeat1,
  [aux_sym_token_tree_pattern_repeat1] = aux_sym_token_tree_pattern_repeat1,
  [aux_sym_token_tree_repeat1] = aux_sym_token_tree_repeat1,
  [aux_sym__non_special_token_repeat1] = aux_sym__non_special_token_repeat1,
  [aux_sym_declaration_list_repeat1] = aux_sym_declaration_list_repeat1,
  [aux_sym_enum_variant_list_repeat1] = aux_sym_enum_variant_list_repeat1,
  [aux_sym_enum_variant_list_repeat2] = aux_sym_enum_variant_list_repeat2,
  [aux_sym_field_declaration_list_repeat1] = aux_sym_field_declaration_list_repeat1,
  [aux_sym_ordered_field_declaration_list_repeat1] = aux_sym_ordered_field_declaration_list_repeat1,
  [aux_sym_function_modifiers_repeat1] = aux_sym_function_modifiers_repeat1,
  [aux_sym_where_clause_repeat1] = aux_sym_where_clause_repeat1,
  [aux_sym_trait_bounds_repeat1] = aux_sym_trait_bounds_repeat1,
  [aux_sym_type_parameters_repeat1] = aux_sym_type_parameters_repeat1,
  [aux_sym_use_list_repeat1] = aux_sym_use_list_repeat1,
  [aux_sym_parameters_repeat1] = aux_sym_parameters_repeat1,
  [aux_sym_for_lifetimes_repeat1] = aux_sym_for_lifetimes_repeat1,
  [aux_sym_tuple_type_repeat1] = aux_sym_tuple_type_repeat1,
  [aux_sym_type_arguments_repeat1] = aux_sym_type_arguments_repeat1,
  [aux_sym_delim_token_tree_repeat1] = aux_sym_delim_token_tree_repeat1,
  [aux_sym_arguments_repeat1] = aux_sym_arguments_repeat1,
  [aux_sym_tuple_expression_repeat1] = aux_sym_tuple_expression_repeat1,
  [aux_sym_field_initializer_list_repeat1] = aux_sym_field_initializer_list_repeat1,
  [aux_sym_match_block_repeat1] = aux_sym_match_block_repeat1,
  [aux_sym_match_arm_repeat1] = aux_sym_match_arm_repeat1,
  [aux_sym_closure_parameters_repeat1] = aux_sym_closure_parameters_repeat1,
  [aux_sym_tuple_pattern_repeat1] = aux_sym_tuple_pattern_repeat1,
  [aux_sym_slice_pattern_repeat1] = aux_sym_slice_pattern_repeat1,
  [aux_sym_struct_pattern_repeat1] = aux_sym_struct_pattern_repeat1,
  [aux_sym_string_literal_repeat1] = aux_sym_string_literal_repeat1,
  [alias_sym_field_identifier] = alias_sym_field_identifier,
  [alias_sym_let_chain] = alias_sym_let_chain,
  [alias_sym_shorthand_field_identifier] = alias_sym_shorthand_field_identifier,
  [alias_sym_type_identifier] = alias_sym_type_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_macro_rules_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_token_repetition_pattern_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_block] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_expr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ident] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_item] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_lifetime] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_literal] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_meta] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pat] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_path] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_stmt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_tt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ty] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_vis] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u8] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_i8] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_u16] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_i16] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_u32] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_i32] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_u64] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_i64] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_u128] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_i128] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_isize] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_usize] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_f32] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_f64] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_bool] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_str] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_char] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_impl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_loop] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_match] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mod] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pub] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_trait] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_union] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsafe] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_use] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_where] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extern] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ref] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dyn] = {
    .visible = true,
    .named = false,
  },
  [sym_mutable_specifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_move] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [sym_integer_literal] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_string_literal_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym_char_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_SLASH] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_line_comment_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_line_comment_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_line_comment_token3] = {
    .visible = false,
    .named = false,
  },
  [sym__inner_line_doc_comment_marker] = {
    .visible = true,
    .named = true,
  },
  [sym__outer_line_doc_comment_marker] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SLASH_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_SLASH] = {
    .visible = true,
    .named = false,
  },
  [sym_shebang] = {
    .visible = true,
    .named = true,
  },
  [sym_self] = {
    .visible = true,
    .named = true,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [sym_crate] = {
    .visible = true,
    .named = true,
  },
  [sym_metavariable] = {
    .visible = true,
    .named = true,
  },
  [sym_string_content] = {
    .visible = true,
    .named = true,
  },
  [sym__raw_string_literal_start] = {
    .visible = false,
    .named = true,
  },
  [sym_raw_string_literal_content] = {
    .visible = true,
    .named = true,
  },
  [sym__raw_string_literal_end] = {
    .visible = false,
    .named = true,
  },
  [sym_float_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__outer_block_doc_comment_marker] = {
    .visible = true,
    .named = true,
  },
  [sym__inner_block_doc_comment_marker] = {
    .visible = true,
    .named = true,
  },
  [sym__block_comment_content] = {
    .visible = false,
    .named = true,
  },
  [sym__line_doc_content] = {
    .visible = true,
    .named = true,
  },
  [sym__error_sentinel] = {
    .visible = false,
    .named = true,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_macro_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_macro_rule] = {
    .visible = true,
    .named = true,
  },
  [sym__token_pattern] = {
    .visible = false,
    .named = true,
  },
  [sym_token_tree_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_token_binding_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_token_repetition_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_fragment_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_token_tree] = {
    .visible = true,
    .named = true,
  },
  [sym_token_repetition] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_item] = {
    .visible = true,
    .named = true,
  },
  [sym_inner_attribute_item] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_mod_item] = {
    .visible = true,
    .named = true,
  },
  [sym_foreign_mod_item] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_item] = {
    .visible = true,
    .named = true,
  },
  [sym_union_item] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_item] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_variant_list] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_variant] = {
    .visible = true,
    .named = true,
  },
  [sym_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_field_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_ordered_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_extern_crate_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_const_item] = {
    .visible = true,
    .named = true,
  },
  [sym_static_item] = {
    .visible = true,
    .named = true,
  },
  [sym_type_item] = {
    .visible = true,
    .named = true,
  },
  [sym_function_item] = {
    .visible = true,
    .named = true,
  },
  [sym_function_signature_item] = {
    .visible = true,
    .named = true,
  },
  [sym_function_modifiers] = {
    .visible = true,
    .named = true,
  },
  [sym_where_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_where_predicate] = {
    .visible = true,
    .named = true,
  },
  [sym_impl_item] = {
    .visible = true,
    .named = true,
  },
  [sym_trait_item] = {
    .visible = true,
    .named = true,
  },
  [sym_associated_type] = {
    .visible = true,
    .named = true,
  },
  [sym_trait_bounds] = {
    .visible = true,
    .named = true,
  },
  [sym_higher_ranked_trait_bound] = {
    .visible = true,
    .named = true,
  },
  [sym_removed_trait_bound] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_const_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_constrained_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_let_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_use_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__use_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_scoped_use_list] = {
    .visible = true,
    .named = true,
  },
  [sym_use_list] = {
    .visible = true,
    .named = true,
  },
  [sym_use_as_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_use_wildcard] = {
    .visible = true,
    .named = true,
  },
  [sym_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_self_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_extern_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_visibility_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_bracketed_type] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_type] = {
    .visible = true,
    .named = true,
  },
  [sym_lifetime] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_for_lifetimes] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym_unit_type] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_function] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_type_with_turbofish] = {
    .visible = true,
    .named = true,
  },
  [sym_bounded_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_type_binding] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_type] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_type] = {
    .visible = true,
    .named = true,
  },
  [sym_never_type] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_type] = {
    .visible = true,
    .named = true,
  },
  [sym_dynamic_type] = {
    .visible = true,
    .named = true,
  },
  [sym__expression_except_range] = {
    .visible = false,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_macro_invocation] = {
    .visible = true,
    .named = true,
  },
  [sym_delim_token_tree] = {
    .visible = true,
    .named = true,
  },
  [sym__delim_tokens] = {
    .visible = false,
    .named = true,
  },
  [sym__non_delim_token] = {
    .visible = false,
    .named = true,
  },
  [sym_scoped_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_scoped_type_identifier_in_expression_position] = {
    .visible = true,
    .named = true,
  },
  [sym_scoped_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_range_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_try_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_assignment_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_type_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_return_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_yield_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_array_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unit_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_field_initializer_list] = {
    .visible = true,
    .named = true,
  },
  [sym_shorthand_field_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_field_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_base_field_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_if_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_let_condition] = {
    .visible = true,
    .named = true,
  },
  [sym__let_chain] = {
    .visible = false,
    .named = true,
  },
  [sym__condition] = {
    .visible = false,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_match_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_match_block] = {
    .visible = true,
    .named = true,
  },
  [sym_match_arm] = {
    .visible = true,
    .named = true,
  },
  [sym_last_match_arm] = {
    .visible = true,
    .named = true,
  },
  [sym_match_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_while_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_loop_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_for_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_const_block] = {
    .visible = true,
    .named = true,
  },
  [sym_closure_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_closure_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_label] = {
    .visible = true,
    .named = true,
  },
  [sym_break_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_index_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_await_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_field_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unsafe_block] = {
    .visible = true,
    .named = true,
  },
  [sym_async_block] = {
    .visible = true,
    .named = true,
  },
  [sym_try_block] = {
    .visible = true,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_tuple_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_slice_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_struct_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_field_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_remaining_field_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_mut_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_range_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_ref_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_captured_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_or_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__literal] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__literal_pattern] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_negative_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_raw_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_line_comment] = {
    .visible = true,
    .named = true,
  },
  [sym__line_doc_comment_marker] = {
    .visible = false,
    .named = true,
  },
  [sym_block_comment] = {
    .visible = true,
    .named = true,
  },
  [sym__block_doc_comment_marker] = {
    .visible = false,
    .named = true,
  },
  [aux_sym_source_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_macro_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_token_tree_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_token_tree_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__non_special_token_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_variant_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_variant_list_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_ordered_field_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_modifiers_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_where_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_trait_bounds_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_use_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_lifetimes_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_delim_token_tree_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_initializer_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_match_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_match_arm_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_closure_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_slice_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_struct_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_let_chain] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_shorthand_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_alias = 1,
  field_alternative = 2,
  field_argument = 3,
  field_arguments = 4,
  field_body = 5,
  field_bounds = 6,
  field_condition = 7,
  field_consequence = 8,
  field_default_type = 9,
  field_doc = 10,
  field_element = 11,
  field_field = 12,
  field_function = 13,
  field_inner = 14,
  field_left = 15,
  field_length = 16,
  field_list = 17,
  field_macro = 18,
  field_name = 19,
  field_operator = 20,
  field_outer = 21,
  field_parameters = 22,
  field_path = 23,
  field_pattern = 24,
  field_return_type = 25,
  field_right = 26,
  field_trait = 27,
  field_type = 28,
  field_type_arguments = 29,
  field_type_parameters = 30,
  field_value = 31,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_body] = "body",
  [field_bounds] = "bounds",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_default_type] = "default_type",
  [field_doc] = "doc",
  [field_element] = "element",
  [field_field] = "field",
  [field_function] = "function",
  [field_inner] = "inner",
  [field_left] = "left",
  [field_length] = "length",
  [field_list] = "list",
  [field_macro] = "macro",
  [field_name] = "name",
  [field_operator] = "operator",
  [field_outer] = "outer",
  [field_parameters] = "parameters",
  [field_path] = "path",
  [field_pattern] = "pattern",
  [field_return_type] = "return_type",
  [field_right] = "right",
  [field_trait] = "trait",
  [field_type] = "type",
  [field_type_arguments] = "type_arguments",
  [field_type_parameters] = "type_parameters",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [2] = {.index = 0, .length = 1},
  [3] = {.index = 1, .length = 1},
  [4] = {.index = 2, .length = 1},
  [6] = {.index = 3, .length = 1},
  [7] = {.index = 3, .length = 1},
  [8] = {.index = 4, .length = 1},
  [10] = {.index = 5, .length = 2},
  [11] = {.index = 5, .length = 2},
  [12] = {.index = 7, .length = 2},
  [13] = {.index = 9, .length = 2},
  [14] = {.index = 11, .length = 3},
  [15] = {.index = 14, .length = 2},
  [16] = {.index = 16, .length = 2},
  [17] = {.index = 16, .length = 2},
  [18] = {.index = 18, .length = 1},
  [19] = {.index = 19, .length = 2},
  [20] = {.index = 19, .length = 2},
  [21] = {.index = 19, .length = 2},
  [22] = {.index = 21, .length = 1},
  [23] = {.index = 22, .length = 1},
  [24] = {.index = 23, .length = 1},
  [25] = {.index = 23, .length = 1},
  [26] = {.index = 24, .length = 2},
  [27] = {.index = 24, .length = 2},
  [28] = {.index = 26, .length = 1},
  [29] = {.index = 27, .length = 2},
  [30] = {.index = 29, .length = 2},
  [31] = {.index = 31, .length = 2},
  [32] = {.index = 33, .length = 1},
  [33] = {.index = 34, .length = 2},
  [34] = {.index = 27, .length = 2},
  [35] = {.index = 36, .length = 2},
  [36] = {.index = 38, .length = 1},
  [37] = {.index = 39, .length = 1},
  [38] = {.index = 40, .length = 2},
  [39] = {.index = 26, .length = 1},
  [40] = {.index = 16, .length = 2},
  [41] = {.index = 16, .length = 2},
  [42] = {.index = 42, .length = 2},
  [43] = {.index = 44, .length = 2},
  [44] = {.index = 46, .length = 1},
  [45] = {.index = 16, .length = 2},
  [46] = {.index = 16, .length = 2},
  [47] = {.index = 47, .length = 3},
  [48] = {.index = 50, .length = 2},
  [49] = {.index = 52, .length = 2},
  [50] = {.index = 52, .length = 2},
  [51] = {.index = 54, .length = 2},
  [52] = {.index = 44, .length = 2},
  [53] = {.index = 11, .length = 3},
  [54] = {.index = 3, .length = 1},
  [56] = {.index = 56, .length = 1},
  [57] = {.index = 56, .length = 1},
  [58] = {.index = 57, .length = 1},
  [60] = {.index = 58, .length = 2},
  [61] = {.index = 56, .length = 1},
  [62] = {.index = 60, .length = 1},
  [63] = {.index = 61, .length = 1},
  [64] = {.index = 62, .length = 1},
  [65] = {.index = 63, .length = 2},
  [66] = {.index = 65, .length = 2},
  [67] = {.index = 65, .length = 2},
  [68] = {.index = 67, .length = 1},
  [69] = {.index = 67, .length = 1},
  [70] = {.index = 57, .length = 1},
  [71] = {.index = 68, .length = 2},
  [72] = {.index = 70, .length = 3},
  [73] = {.index = 73, .length = 2},
  [74] = {.index = 75, .length = 3},
  [75] = {.index = 78, .length = 3},
  [77] = {.index = 81, .length = 2},
  [78] = {.index = 81, .length = 2},
  [79] = {.index = 83, .length = 2},
  [80] = {.index = 85, .length = 3},
  [81] = {.index = 88, .length = 2},
  [82] = {.index = 90, .length = 1},
  [83] = {.index = 91, .length = 2},
  [84] = {.index = 93, .length = 2},
  [85] = {.index = 95, .length = 3},
  [86] = {.index = 98, .length = 2},
  [87] = {.index = 100, .length = 2},
  [88] = {.index = 102, .length = 2},
  [89] = {.index = 104, .length = 2},
  [90] = {.index = 106, .length = 2},
  [91] = {.index = 104, .length = 2},
  [92] = {.index = 106, .length = 2},
  [93] = {.index = 108, .length = 1},
  [94] = {.index = 102, .length = 2},
  [95] = {.index = 108, .length = 1},
  [96] = {.index = 109, .length = 1},
  [97] = {.index = 110, .length = 3},
  [98] = {.index = 113, .length = 1},
  [99] = {.index = 114, .length = 1},
  [100] = {.index = 115, .length = 2},
  [101] = {.index = 3, .length = 1},
  [102] = {.index = 117, .length = 1},
  [103] = {.index = 118, .length = 2},
  [104] = {.index = 120, .length = 1},
  [105] = {.index = 120, .length = 1},
  [106] = {.index = 121, .length = 3},
  [107] = {.index = 124, .length = 1},
  [108] = {.index = 121, .length = 3},
  [109] = {.index = 18, .length = 1},
  [110] = {.index = 125, .length = 2},
  [111] = {.index = 127, .length = 3},
  [112] = {.index = 130, .length = 3},
  [113] = {.index = 133, .length = 4},
  [114] = {.index = 137, .length = 3},
  [115] = {.index = 140, .length = 3},
  [116] = {.index = 143, .length = 2},
  [117] = {.index = 145, .length = 2},
  [118] = {.index = 145, .length = 2},
  [120] = {.index = 147, .length = 2},
  [121] = {.index = 149, .length = 3},
  [122] = {.index = 152, .length = 3},
  [123] = {.index = 147, .length = 2},
  [124] = {.index = 149, .length = 3},
  [125] = {.index = 155, .length = 2},
  [127] = {.index = 157, .length = 3},
  [128] = {.index = 160, .length = 3},
  [129] = {.index = 163, .length = 4},
  [130] = {.index = 125, .length = 2},
  [131] = {.index = 167, .length = 3},
  [132] = {.index = 170, .length = 2},
  [133] = {.index = 172, .length = 3},
  [134] = {.index = 175, .length = 2},
  [135] = {.index = 177, .length = 2},
  [136] = {.index = 179, .length = 3},
  [137] = {.index = 182, .length = 3},
  [138] = {.index = 185, .length = 2},
  [139] = {.index = 185, .length = 2},
  [140] = {.index = 187, .length = 2},
  [141] = {.index = 189, .length = 3},
  [142] = {.index = 192, .length = 2},
  [143] = {.index = 194, .length = 2},
  [144] = {.index = 196, .length = 1},
  [145] = {.index = 197, .length = 2},
  [146] = {.index = 199, .length = 1},
  [147] = {.index = 200, .length = 2},
  [148] = {.index = 108, .length = 1},
  [149] = {.index = 202, .length = 2},
  [150] = {.index = 204, .length = 2},
  [151] = {.index = 206, .length = 1},
  [152] = {.index = 207, .length = 2},
  [153] = {.index = 209, .length = 3},
  [154] = {.index = 209, .length = 3},
  [155] = {.index = 212, .length = 2},
  [156] = {.index = 214, .length = 4},
  [157] = {.index = 218, .length = 3},
  [158] = {.index = 221, .length = 4},
  [159] = {.index = 225, .length = 2},
  [160] = {.index = 227, .length = 3},
  [161] = {.index = 225, .length = 2},
  [162] = {.index = 227, .length = 3},
  [163] = {.index = 230, .length = 3},
  [164] = {.index = 233, .length = 3},
  [165] = {.index = 236, .length = 4},
  [166] = {.index = 233, .length = 3},
  [167] = {.index = 236, .length = 4},
  [168] = {.index = 230, .length = 3},
  [169] = {.index = 240, .length = 2},
  [170] = {.index = 242, .length = 2},
  [171] = {.index = 244, .length = 2},
  [172] = {.index = 246, .length = 2},
  [173] = {.index = 248, .length = 1},
  [174] = {.index = 249, .length = 2},
  [175] = {.index = 251, .length = 3},
  [176] = {.index = 254, .length = 2},
  [177] = {.index = 256, .length = 2},
  [178] = {.index = 200, .length = 2},
  [179] = {.index = 258, .length = 4},
  [180] = {.index = 262, .length = 3},
  [181] = {.index = 265, .length = 3},
  [182] = {.index = 268, .length = 3},
  [183] = {.index = 271, .length = 3},
  [184] = {.index = 274, .length = 4},
  [185] = {.index = 278, .length = 2},
  [186] = {.index = 280, .length = 2},
  [187] = {.index = 280, .length = 2},
  [188] = {.index = 282, .length = 3},
  [189] = {.index = 285, .length = 4},
  [190] = {.index = 289, .length = 3},
  [191] = {.index = 249, .length = 2},
  [192] = {.index = 292, .length = 2},
  [193] = {.index = 294, .length = 3},
  [194] = {.index = 297, .length = 3},
  [195] = {.index = 300, .length = 2},
  [196] = {.index = 302, .length = 3},
  [197] = {.index = 200, .length = 2},
  [198] = {.index = 305, .length = 3},
  [199] = {.index = 308, .length = 2},
  [200] = {.index = 310, .length = 2},
  [201] = {.index = 312, .length = 3},
  [202] = {.index = 315, .length = 3},
  [203] = {.index = 318, .length = 2},
  [204] = {.index = 320, .length = 4},
  [205] = {.index = 324, .length = 5},
  [206] = {.index = 329, .length = 4},
  [207] = {.index = 333, .length = 3},
  [208] = {.index = 333, .length = 3},
  [209] = {.index = 336, .length = 3},
  [210] = {.index = 339, .length = 4},
  [211] = {.index = 336, .length = 3},
  [212] = {.index = 339, .length = 4},
  [213] = {.index = 343, .length = 4},
  [214] = {.index = 343, .length = 4},
  [215] = {.index = 347, .length = 3},
  [216] = {.index = 350, .length = 3},
  [217] = {.index = 353, .length = 3},
  [218] = {.index = 356, .length = 2},
  [219] = {.index = 358, .length = 2},
  [220] = {.index = 125, .length = 2},
  [221] = {.index = 360, .length = 2},
  [222] = {.index = 362, .length = 3},
  [223] = {.index = 360, .length = 2},
  [224] = {.index = 362, .length = 3},
  [225] = {.index = 365, .length = 3},
  [226] = {.index = 368, .length = 4},
  [227] = {.index = 365, .length = 3},
  [228] = {.index = 368, .length = 4},
  [229] = {.index = 372, .length = 4},
  [230] = {.index = 376, .length = 4},
  [231] = {.index = 380, .length = 3},
  [232] = {.index = 383, .length = 4},
  [233] = {.index = 387, .length = 3},
  [234] = {.index = 390, .length = 3},
  [235] = {.index = 393, .length = 3},
  [236] = {.index = 396, .length = 4},
  [237] = {.index = 400, .length = 2},
  [238] = {.index = 402, .length = 3},
  [239] = {.index = 405, .length = 4},
  [240] = {.index = 409, .length = 3},
  [241] = {.index = 412, .length = 3},
  [242] = {.index = 415, .length = 2},
  [243] = {.index = 417, .length = 3},
  [244] = {.index = 420, .length = 5},
  [245] = {.index = 425, .length = 4},
  [246] = {.index = 425, .length = 4},
  [247] = {.index = 429, .length = 3},
  [248] = {.index = 432, .length = 3},
  [249] = {.index = 435, .length = 3},
  [250] = {.index = 438, .length = 3},
  [251] = {.index = 441, .length = 2},
  [252] = {.index = 443, .length = 3},
  [253] = {.index = 443, .length = 3},
  [254] = {.index = 446, .length = 3},
  [255] = {.index = 449, .length = 4},
  [256] = {.index = 446, .length = 3},
  [257] = {.index = 449, .length = 4},
  [258] = {.index = 453, .length = 4},
  [259] = {.index = 453, .length = 4},
  [260] = {.index = 457, .length = 4},
  [261] = {.index = 461, .length = 5},
  [262] = {.index = 466, .length = 4},
  [263] = {.index = 470, .length = 2},
  [264] = {.index = 472, .length = 4},
  [265] = {.index = 476, .length = 4},
  [266] = {.index = 480, .length = 3},
  [267] = {.index = 483, .length = 4},
  [268] = {.index = 487, .length = 4},
  [269] = {.index = 491, .length = 3},
  [270] = {.index = 494, .length = 4},
  [271] = {.index = 494, .length = 4},
  [272] = {.index = 498, .length = 5},
  [273] = {.index = 503, .length = 4},
  [274] = {.index = 507, .length = 5},
  [275] = {.index = 512, .length = 4},
  [276] = {.index = 516, .length = 4},
  [277] = {.index = 520, .length = 3},
  [278] = {.index = 523, .length = 5},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_inner, 0},
  [1] =
    {field_outer, 0},
  [2] =
    {field_value, 1},
  [3] =
    {field_name, 1},
  [4] =
    {field_body, 1},
  [5] =
    {field_body, 1},
    {field_name, 0},
  [7] =
    {field_arguments, 1},
    {field_function, 0},
  [9] =
    {field_body, 1},
    {field_parameters, 0},
  [11] =
    {field_doc, 2},
    {field_inner, 1, .inherited = true},
    {field_outer, 1, .inherited = true},
  [14] =
    {field_inner, 1, .inherited = true},
    {field_outer, 1, .inherited = true},
  [16] =
    {field_name, 2},
    {field_path, 0},
  [18] =
    {field_value, 2},
  [19] =
    {field_type, 0},
    {field_type_arguments, 1},
  [21] =
    {field_type, 1},
  [22] =
    {field_parameters, 1},
  [23] =
    {field_trait, 1},
  [24] =
    {field_parameters, 1},
    {field_trait, 0},
  [26] =
    {field_macro, 0},
  [27] =
    {field_body, 2},
    {field_name, 1},
  [29] =
    {field_condition, 1},
    {field_consequence, 2},
  [31] =
    {field_body, 2},
    {field_type, 1},
  [33] =
    {field_pattern, 1},
  [34] =
    {field_body, 2},
    {field_value, 1},
  [36] =
    {field_body, 2},
    {field_parameters, 1},
  [38] =
    {field_list, 1},
  [39] =
    {field_argument, 1},
  [40] =
    {field_body, 2},
    {field_condition, 1},
  [42] =
    {field_function, 0},
    {field_type_arguments, 2},
  [44] =
    {field_type, 0},
    {field_type_arguments, 2},
  [46] =
    {field_body, 2},
  [47] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [50] =
    {field_left, 0},
    {field_right, 2},
  [52] =
    {field_field, 2},
    {field_value, 0},
  [54] =
    {field_type, 2},
    {field_value, 0},
  [56] =
    {field_type, 0},
  [57] =
    {field_name, 0},
  [58] =
    {field_pattern, 0},
    {field_type, 2},
  [60] =
    {field_element, 1},
  [61] =
    {field_type, 2},
  [62] =
    {field_parameters, 2},
  [63] =
    {field_alias, 2},
    {field_type, 0},
  [65] =
    {field_parameters, 2},
    {field_trait, 1},
  [67] =
    {field_arguments, 1},
  [68] =
    {field_body, 3},
    {field_name, 1},
  [70] =
    {field_body, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [73] =
    {field_name, 1},
    {field_parameters, 2},
  [75] =
    {field_body, 3},
    {field_name, 1},
    {field_parameters, 2},
  [78] =
    {field_alternative, 3},
    {field_condition, 1},
    {field_consequence, 2},
  [81] =
    {field_bounds, 1},
    {field_left, 0},
  [83] =
    {field_type, 2},
    {field_type_parameters, 1},
  [85] =
    {field_body, 3},
    {field_type, 2},
    {field_type_parameters, 1},
  [88] =
    {field_body, 3},
    {field_type, 1},
  [90] =
    {field_pattern, 2},
  [91] =
    {field_body, 3},
    {field_parameters, 2},
  [93] =
    {field_name, 1},
    {field_type_parameters, 2},
  [95] =
    {field_body, 3},
    {field_bounds, 2},
    {field_name, 1},
  [98] =
    {field_bounds, 2},
    {field_name, 1},
  [100] =
    {field_body, 3},
    {field_type, 2},
  [102] =
    {field_body, 3},
    {field_name, 2},
  [104] =
    {field_list, 2},
    {field_path, 0},
  [106] =
    {field_alias, 2},
    {field_path, 0},
  [108] =
    {field_name, 2},
  [109] =
    {field_argument, 2},
  [110] =
    {field_body, 3},
    {field_parameters, 0},
    {field_return_type, 2},
  [113] =
    {field_body, 3},
  [114] =
    {field_length, 3},
  [115] =
    {field_pattern, 1},
    {field_type, 3},
  [117] =
    {field_type, 3},
  [118] =
    {field_parameters, 1},
    {field_return_type, 3},
  [120] =
    {field_trait, 3},
  [121] =
    {field_parameters, 1},
    {field_return_type, 3},
    {field_trait, 0},
  [124] =
    {field_parameters, 3},
  [125] =
    {field_name, 1},
    {field_type, 3},
  [127] =
    {field_body, 4},
    {field_name, 1},
    {field_type_parameters, 2},
  [130] =
    {field_name, 1},
    {field_parameters, 3},
    {field_type_parameters, 2},
  [133] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 3},
    {field_type_parameters, 2},
  [137] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 2},
  [140] =
    {field_body, 4},
    {field_pattern, 1},
    {field_value, 3},
  [143] =
    {field_pattern, 1},
    {field_value, 3},
  [145] =
    {field_default_type, 2},
    {field_name, 0},
  [147] =
    {field_trait, 1},
    {field_type, 3},
  [149] =
    {field_body, 4},
    {field_trait, 1},
    {field_type, 3},
  [152] =
    {field_body, 4},
    {field_type, 2},
    {field_type_parameters, 1},
  [155] =
    {field_alternative, 3},
    {field_pattern, 1},
  [157] =
    {field_body, 4},
    {field_parameters, 1},
    {field_return_type, 3},
  [160] =
    {field_body, 4},
    {field_bounds, 2},
    {field_name, 1},
  [163] =
    {field_body, 4},
    {field_bounds, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [167] =
    {field_bounds, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [170] =
    {field_type, 3},
    {field_type_parameters, 2},
  [172] =
    {field_body, 4},
    {field_type, 3},
    {field_type_parameters, 2},
  [175] =
    {field_body, 4},
    {field_type, 2},
  [177] =
    {field_body, 4},
    {field_name, 2},
  [179] =
    {field_body, 4},
    {field_bounds, 3},
    {field_name, 2},
  [182] =
    {field_body, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [185] =
    {field_field, 0},
    {field_value, 2},
  [187] =
    {field_name, 2},
    {field_parameters, 3},
  [189] =
    {field_body, 4},
    {field_name, 2},
    {field_parameters, 3},
  [192] =
    {field_name, 2},
    {field_type_parameters, 3},
  [194] =
    {field_body, 4},
    {field_name, 3},
  [196] =
    {field_name, 3},
  [197] =
    {field_body, 4},
    {field_condition, 3},
  [199] =
    {field_length, 4},
  [200] =
    {field_name, 0},
    {field_type, 2},
  [202] =
    {field_name, 0},
    {field_pattern, 2},
  [204] =
    {field_element, 1},
    {field_length, 3},
  [206] =
    {field_pattern, 0},
  [207] =
    {field_parameters, 2},
    {field_return_type, 4},
  [209] =
    {field_parameters, 2},
    {field_return_type, 4},
    {field_trait, 1},
  [212] =
    {field_name, 0},
    {field_value, 2},
  [214] =
    {field_body, 5},
    {field_name, 1},
    {field_parameters, 3},
    {field_type_parameters, 2},
  [218] =
    {field_name, 1},
    {field_parameters, 2},
    {field_return_type, 4},
  [221] =
    {field_body, 5},
    {field_name, 1},
    {field_parameters, 2},
    {field_return_type, 4},
  [225] =
    {field_trait, 2},
    {field_type, 4},
  [227] =
    {field_body, 5},
    {field_trait, 2},
    {field_type, 4},
  [230] =
    {field_body, 5},
    {field_trait, 1},
    {field_type, 3},
  [233] =
    {field_trait, 2},
    {field_type, 4},
    {field_type_parameters, 1},
  [236] =
    {field_body, 5},
    {field_trait, 2},
    {field_type, 4},
    {field_type_parameters, 1},
  [240] =
    {field_pattern, 2},
    {field_type, 4},
  [242] =
    {field_pattern, 2},
    {field_value, 4},
  [244] =
    {field_alternative, 4},
    {field_pattern, 2},
  [246] =
    {field_pattern, 0},
    {field_value, 2},
  [248] =
    {field_condition, 2},
  [249] =
    {field_name, 2},
    {field_type, 4},
  [251] =
    {field_body, 5},
    {field_parameters, 2},
    {field_return_type, 4},
  [254] =
    {field_type, 1},
    {field_type, 2, .inherited = true},
  [256] =
    {field_type, 0, .inherited = true},
    {field_type, 1, .inherited = true},
  [258] =
    {field_body, 5},
    {field_bounds, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [262] =
    {field_name, 1},
    {field_type, 4},
    {field_type_parameters, 2},
  [265] =
    {field_body, 5},
    {field_type, 3},
    {field_type_parameters, 2},
  [268] =
    {field_body, 5},
    {field_bounds, 3},
    {field_name, 2},
  [271] =
    {field_body, 5},
    {field_name, 2},
    {field_type_parameters, 3},
  [274] =
    {field_body, 5},
    {field_bounds, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [278] =
    {field_alias, 4},
    {field_name, 2},
  [280] =
    {field_field, 1},
    {field_value, 3},
  [282] =
    {field_name, 2},
    {field_parameters, 4},
    {field_type_parameters, 3},
  [285] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 4},
    {field_type_parameters, 3},
  [289] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 3},
  [292] =
    {field_body, 5},
    {field_name, 3},
  [294] =
    {field_body, 5},
    {field_bounds, 4},
    {field_name, 3},
  [297] =
    {field_body, 5},
    {field_name, 3},
    {field_type_parameters, 4},
  [300] =
    {field_name, 3},
    {field_parameters, 4},
  [302] =
    {field_body, 5},
    {field_name, 3},
    {field_parameters, 4},
  [305] =
    {field_name, 0},
    {field_type, 3},
    {field_type_arguments, 1},
  [308] =
    {field_name, 1},
    {field_pattern, 3},
  [310] =
    {field_parameters, 3},
    {field_return_type, 5},
  [312] =
    {field_name, 1},
    {field_type, 3},
    {field_value, 5},
  [315] =
    {field_body, 1},
    {field_name, 0},
    {field_value, 3},
  [318] =
    {field_name, 1},
    {field_value, 3},
  [320] =
    {field_name, 1},
    {field_parameters, 3},
    {field_return_type, 5},
    {field_type_parameters, 2},
  [324] =
    {field_body, 6},
    {field_name, 1},
    {field_parameters, 3},
    {field_return_type, 5},
    {field_type_parameters, 2},
  [329] =
    {field_body, 6},
    {field_name, 1},
    {field_parameters, 2},
    {field_return_type, 4},
  [333] =
    {field_body, 6},
    {field_trait, 2},
    {field_type, 4},
  [336] =
    {field_trait, 3},
    {field_type, 5},
    {field_type_parameters, 1},
  [339] =
    {field_body, 6},
    {field_trait, 3},
    {field_type, 5},
    {field_type_parameters, 1},
  [343] =
    {field_body, 6},
    {field_trait, 2},
    {field_type, 4},
    {field_type_parameters, 1},
  [347] =
    {field_pattern, 1},
    {field_type, 3},
    {field_value, 5},
  [350] =
    {field_alternative, 5},
    {field_pattern, 1},
    {field_type, 3},
  [353] =
    {field_alternative, 5},
    {field_pattern, 1},
    {field_value, 3},
  [356] =
    {field_name, 3},
    {field_type, 5},
  [358] =
    {field_type, 2},
    {field_type, 3, .inherited = true},
  [360] =
    {field_trait, 3},
    {field_type, 5},
  [362] =
    {field_body, 6},
    {field_trait, 3},
    {field_type, 5},
  [365] =
    {field_trait, 3},
    {field_type, 5},
    {field_type_parameters, 2},
  [368] =
    {field_body, 6},
    {field_trait, 3},
    {field_type, 5},
    {field_type_parameters, 2},
  [372] =
    {field_body, 6},
    {field_bounds, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [376] =
    {field_body, 6},
    {field_name, 2},
    {field_parameters, 4},
    {field_type_parameters, 3},
  [380] =
    {field_name, 2},
    {field_parameters, 3},
    {field_return_type, 5},
  [383] =
    {field_body, 6},
    {field_name, 2},
    {field_parameters, 3},
    {field_return_type, 5},
  [387] =
    {field_name, 2},
    {field_type, 5},
    {field_type_parameters, 3},
  [390] =
    {field_body, 6},
    {field_bounds, 4},
    {field_name, 3},
  [393] =
    {field_body, 6},
    {field_name, 3},
    {field_type_parameters, 4},
  [396] =
    {field_body, 6},
    {field_bounds, 5},
    {field_name, 3},
    {field_type_parameters, 4},
  [400] =
    {field_alias, 5},
    {field_name, 3},
  [402] =
    {field_name, 3},
    {field_parameters, 5},
    {field_type_parameters, 4},
  [405] =
    {field_body, 6},
    {field_name, 3},
    {field_parameters, 5},
    {field_type_parameters, 4},
  [409] =
    {field_body, 6},
    {field_name, 3},
    {field_parameters, 4},
  [412] =
    {field_body, 6},
    {field_pattern, 3},
    {field_value, 5},
  [415] =
    {field_name, 2},
    {field_pattern, 4},
  [417] =
    {field_body, 2},
    {field_name, 1},
    {field_value, 4},
  [420] =
    {field_body, 7},
    {field_name, 1},
    {field_parameters, 3},
    {field_return_type, 5},
    {field_type_parameters, 2},
  [425] =
    {field_body, 7},
    {field_trait, 3},
    {field_type, 5},
    {field_type_parameters, 1},
  [429] =
    {field_pattern, 2},
    {field_type, 4},
    {field_value, 6},
  [432] =
    {field_alternative, 6},
    {field_pattern, 2},
    {field_type, 4},
  [435] =
    {field_alternative, 6},
    {field_pattern, 2},
    {field_value, 4},
  [438] =
    {field_name, 2},
    {field_type, 4},
    {field_value, 6},
  [441] =
    {field_type, 3},
    {field_type, 4, .inherited = true},
  [443] =
    {field_body, 7},
    {field_trait, 3},
    {field_type, 5},
  [446] =
    {field_trait, 4},
    {field_type, 6},
    {field_type_parameters, 2},
  [449] =
    {field_body, 7},
    {field_trait, 4},
    {field_type, 6},
    {field_type_parameters, 2},
  [453] =
    {field_body, 7},
    {field_trait, 3},
    {field_type, 5},
    {field_type_parameters, 2},
  [457] =
    {field_name, 2},
    {field_parameters, 4},
    {field_return_type, 6},
    {field_type_parameters, 3},
  [461] =
    {field_body, 7},
    {field_name, 2},
    {field_parameters, 4},
    {field_return_type, 6},
    {field_type_parameters, 3},
  [466] =
    {field_body, 7},
    {field_name, 2},
    {field_parameters, 3},
    {field_return_type, 5},
  [470] =
    {field_name, 4},
    {field_type, 6},
  [472] =
    {field_body, 7},
    {field_bounds, 5},
    {field_name, 3},
    {field_type_parameters, 4},
  [476] =
    {field_body, 7},
    {field_name, 3},
    {field_parameters, 5},
    {field_type_parameters, 4},
  [480] =
    {field_name, 3},
    {field_parameters, 4},
    {field_return_type, 6},
  [483] =
    {field_body, 7},
    {field_name, 3},
    {field_parameters, 4},
    {field_return_type, 6},
  [487] =
    {field_alternative, 7},
    {field_pattern, 1},
    {field_type, 3},
    {field_value, 5},
  [491] =
    {field_name, 3},
    {field_type, 5},
    {field_value, 7},
  [494] =
    {field_body, 8},
    {field_trait, 4},
    {field_type, 6},
    {field_type_parameters, 2},
  [498] =
    {field_body, 8},
    {field_name, 2},
    {field_parameters, 4},
    {field_return_type, 6},
    {field_type_parameters, 3},
  [503] =
    {field_name, 3},
    {field_parameters, 5},
    {field_return_type, 7},
    {field_type_parameters, 4},
  [507] =
    {field_body, 8},
    {field_name, 3},
    {field_parameters, 5},
    {field_return_type, 7},
    {field_type_parameters, 4},
  [512] =
    {field_body, 8},
    {field_name, 3},
    {field_parameters, 4},
    {field_return_type, 6},
  [516] =
    {field_alternative, 8},
    {field_pattern, 2},
    {field_type, 4},
    {field_value, 6},
  [520] =
    {field_name, 4},
    {field_type, 6},
    {field_value, 8},
  [523] =
    {field_body, 9},
    {field_name, 3},
    {field_parameters, 5},
    {field_return_type, 7},
    {field_type_parameters, 4},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_identifier,
  },
  [5] = {
    [0] = alias_sym_type_identifier,
  },
  [7] = {
    [1] = alias_sym_type_identifier,
  },
  [9] = {
    [0] = alias_sym_let_chain,
  },
  [10] = {
    [0] = alias_sym_type_identifier,
  },
  [16] = {
    [0] = sym_identifier,
  },
  [17] = {
    [0] = sym_identifier,
    [2] = alias_sym_type_identifier,
  },
  [19] = {
    [0] = sym_identifier,
  },
  [20] = {
    [0] = alias_sym_type_identifier,
  },
  [24] = {
    [1] = alias_sym_type_identifier,
  },
  [26] = {
    [0] = alias_sym_type_identifier,
  },
  [28] = {
    [0] = sym_identifier,
  },
  [29] = {
    [1] = alias_sym_type_identifier,
  },
  [41] = {
    [2] = alias_sym_type_identifier,
  },
  [43] = {
    [0] = alias_sym_type_identifier,
  },
  [45] = {
    [0] = sym_generic_type,
  },
  [46] = {
    [0] = sym_generic_type,
    [2] = alias_sym_type_identifier,
  },
  [50] = {
    [2] = alias_sym_field_identifier,
  },
  [53] = {
    [2] = sym__line_doc_content,
  },
  [54] = {
    [1] = sym_identifier,
  },
  [55] = {
    [0] = sym_identifier,
    [2] = sym_identifier,
  },
  [57] = {
    [0] = alias_sym_type_identifier,
  },
  [58] = {
    [0] = alias_sym_shorthand_field_identifier,
  },
  [59] = {
    [2] = sym_identifier,
  },
  [61] = {
    [0] = sym_generic_type,
  },
  [66] = {
    [1] = alias_sym_type_identifier,
  },
  [68] = {
    [0] = sym_identifier,
  },
  [71] = {
    [1] = alias_sym_type_identifier,
  },
  [72] = {
    [1] = alias_sym_type_identifier,
  },
  [76] = {
    [1] = alias_sym_type_identifier,
  },
  [77] = {
    [0] = alias_sym_type_identifier,
  },
  [84] = {
    [1] = alias_sym_type_identifier,
  },
  [85] = {
    [1] = alias_sym_type_identifier,
  },
  [86] = {
    [1] = alias_sym_type_identifier,
  },
  [88] = {
    [2] = alias_sym_type_identifier,
  },
  [89] = {
    [0] = sym_identifier,
  },
  [90] = {
    [0] = sym_identifier,
  },
  [95] = {
    [2] = alias_sym_type_identifier,
  },
  [101] = {
    [1] = alias_sym_shorthand_field_identifier,
  },
  [104] = {
    [3] = alias_sym_type_identifier,
  },
  [106] = {
    [0] = alias_sym_type_identifier,
  },
  [109] = {
    [0] = sym_identifier,
  },
  [111] = {
    [1] = alias_sym_type_identifier,
  },
  [117] = {
    [0] = alias_sym_type_identifier,
  },
  [119] = {
    [2] = alias_sym_type_identifier,
  },
  [120] = {
    [1] = alias_sym_type_identifier,
  },
  [121] = {
    [1] = alias_sym_type_identifier,
  },
  [126] = {
    [3] = sym_identifier,
  },
  [128] = {
    [1] = alias_sym_type_identifier,
  },
  [129] = {
    [1] = alias_sym_type_identifier,
  },
  [130] = {
    [1] = alias_sym_type_identifier,
  },
  [131] = {
    [1] = alias_sym_type_identifier,
  },
  [135] = {
    [2] = alias_sym_type_identifier,
  },
  [136] = {
    [2] = alias_sym_type_identifier,
  },
  [137] = {
    [2] = alias_sym_type_identifier,
  },
  [139] = {
    [0] = alias_sym_field_identifier,
  },
  [142] = {
    [2] = alias_sym_type_identifier,
  },
  [143] = {
    [3] = alias_sym_type_identifier,
  },
  [147] = {
    [0] = alias_sym_type_identifier,
  },
  [148] = {
    [2] = alias_sym_shorthand_field_identifier,
  },
  [149] = {
    [0] = alias_sym_field_identifier,
  },
  [153] = {
    [1] = alias_sym_type_identifier,
  },
  [159] = {
    [2] = alias_sym_type_identifier,
  },
  [160] = {
    [2] = alias_sym_type_identifier,
  },
  [163] = {
    [1] = alias_sym_type_identifier,
  },
  [164] = {
    [2] = alias_sym_type_identifier,
  },
  [165] = {
    [2] = alias_sym_type_identifier,
  },
  [178] = {
    [0] = alias_sym_field_identifier,
  },
  [179] = {
    [1] = alias_sym_type_identifier,
  },
  [180] = {
    [1] = alias_sym_type_identifier,
  },
  [182] = {
    [2] = alias_sym_type_identifier,
  },
  [183] = {
    [2] = alias_sym_type_identifier,
  },
  [184] = {
    [2] = alias_sym_type_identifier,
  },
  [187] = {
    [1] = alias_sym_field_identifier,
  },
  [191] = {
    [2] = alias_sym_type_identifier,
  },
  [192] = {
    [3] = alias_sym_type_identifier,
  },
  [193] = {
    [3] = alias_sym_type_identifier,
  },
  [194] = {
    [3] = alias_sym_type_identifier,
  },
  [198] = {
    [0] = alias_sym_type_identifier,
  },
  [199] = {
    [1] = alias_sym_field_identifier,
  },
  [207] = {
    [2] = alias_sym_type_identifier,
  },
  [209] = {
    [3] = alias_sym_type_identifier,
  },
  [210] = {
    [3] = alias_sym_type_identifier,
  },
  [213] = {
    [2] = alias_sym_type_identifier,
  },
  [220] = {
    [1] = alias_sym_field_identifier,
  },
  [221] = {
    [3] = alias_sym_type_identifier,
  },
  [222] = {
    [3] = alias_sym_type_identifier,
  },
  [225] = {
    [3] = alias_sym_type_identifier,
  },
  [226] = {
    [3] = alias_sym_type_identifier,
  },
  [229] = {
    [2] = alias_sym_type_identifier,
  },
  [233] = {
    [2] = alias_sym_type_identifier,
  },
  [234] = {
    [3] = alias_sym_type_identifier,
  },
  [235] = {
    [3] = alias_sym_type_identifier,
  },
  [236] = {
    [3] = alias_sym_type_identifier,
  },
  [242] = {
    [2] = alias_sym_field_identifier,
  },
  [245] = {
    [3] = alias_sym_type_identifier,
  },
  [252] = {
    [3] = alias_sym_type_identifier,
  },
  [254] = {
    [4] = alias_sym_type_identifier,
  },
  [255] = {
    [4] = alias_sym_type_identifier,
  },
  [258] = {
    [3] = alias_sym_type_identifier,
  },
  [264] = {
    [3] = alias_sym_type_identifier,
  },
  [270] = {
    [4] = alias_sym_type_identifier,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym_generic_type_with_turbofish, 2,
    sym_generic_type_with_turbofish,
    sym_generic_type,
  sym__let_chain, 2,
    sym__let_chain,
    alias_sym_let_chain,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 2,
  [6] = 6,
  [7] = 4,
  [8] = 2,
  [9] = 9,
  [10] = 2,
  [11] = 11,
  [12] = 11,
  [13] = 9,
  [14] = 2,
  [15] = 9,
  [16] = 11,
  [17] = 11,
  [18] = 4,
  [19] = 2,
  [20] = 11,
  [21] = 2,
  [22] = 22,
  [23] = 22,
  [24] = 4,
  [25] = 9,
  [26] = 9,
  [27] = 27,
  [28] = 4,
  [29] = 11,
  [30] = 4,
  [31] = 9,
  [32] = 4,
  [33] = 11,
  [34] = 9,
  [35] = 35,
  [36] = 36,
  [37] = 37,
  [38] = 38,
  [39] = 39,
  [40] = 36,
  [41] = 41,
  [42] = 41,
  [43] = 35,
  [44] = 36,
  [45] = 35,
  [46] = 39,
  [47] = 37,
  [48] = 38,
  [49] = 36,
  [50] = 41,
  [51] = 35,
  [52] = 41,
  [53] = 38,
  [54] = 36,
  [55] = 41,
  [56] = 38,
  [57] = 37,
  [58] = 39,
  [59] = 37,
  [60] = 41,
  [61] = 39,
  [62] = 41,
  [63] = 36,
  [64] = 36,
  [65] = 36,
  [66] = 41,
  [67] = 67,
  [68] = 68,
  [69] = 69,
  [70] = 70,
  [71] = 71,
  [72] = 72,
  [73] = 73,
  [74] = 71,
  [75] = 75,
  [76] = 70,
  [77] = 68,
  [78] = 78,
  [79] = 79,
  [80] = 75,
  [81] = 81,
  [82] = 78,
  [83] = 79,
  [84] = 84,
  [85] = 85,
  [86] = 86,
  [87] = 85,
  [88] = 85,
  [89] = 89,
  [90] = 90,
  [91] = 91,
  [92] = 92,
  [93] = 93,
  [94] = 86,
  [95] = 86,
  [96] = 84,
  [97] = 97,
  [98] = 98,
  [99] = 89,
  [100] = 85,
  [101] = 101,
  [102] = 102,
  [103] = 103,
  [104] = 101,
  [105] = 92,
  [106] = 85,
  [107] = 84,
  [108] = 92,
  [109] = 101,
  [110] = 86,
  [111] = 84,
  [112] = 89,
  [113] = 89,
  [114] = 114,
  [115] = 92,
  [116] = 92,
  [117] = 89,
  [118] = 85,
  [119] = 89,
  [120] = 101,
  [121] = 86,
  [122] = 84,
  [123] = 101,
  [124] = 90,
  [125] = 91,
  [126] = 93,
  [127] = 97,
  [128] = 98,
  [129] = 92,
  [130] = 86,
  [131] = 84,
  [132] = 101,
  [133] = 102,
  [134] = 134,
  [135] = 135,
  [136] = 136,
  [137] = 137,
  [138] = 138,
  [139] = 139,
  [140] = 140,
  [141] = 141,
  [142] = 142,
  [143] = 139,
  [144] = 134,
  [145] = 145,
  [146] = 146,
  [147] = 147,
  [148] = 148,
  [149] = 149,
  [150] = 150,
  [151] = 151,
  [152] = 152,
  [153] = 153,
  [154] = 154,
  [155] = 155,
  [156] = 156,
  [157] = 157,
  [158] = 154,
  [159] = 159,
  [160] = 160,
  [161] = 161,
  [162] = 156,
  [163] = 163,
  [164] = 164,
  [165] = 165,
  [166] = 166,
  [167] = 150,
  [168] = 168,
  [169] = 169,
  [170] = 170,
  [171] = 171,
  [172] = 172,
  [173] = 173,
  [174] = 173,
  [175] = 171,
  [176] = 176,
  [177] = 177,
  [178] = 178,
  [179] = 179,
  [180] = 153,
  [181] = 169,
  [182] = 145,
  [183] = 137,
  [184] = 184,
  [185] = 185,
  [186] = 172,
  [187] = 147,
  [188] = 140,
  [189] = 189,
  [190] = 173,
  [191] = 170,
  [192] = 178,
  [193] = 193,
  [194] = 194,
  [195] = 171,
  [196] = 178,
  [197] = 179,
  [198] = 194,
  [199] = 171,
  [200] = 146,
  [201] = 173,
  [202] = 202,
  [203] = 203,
  [204] = 176,
  [205] = 202,
  [206] = 177,
  [207] = 178,
  [208] = 208,
  [209] = 209,
  [210] = 210,
  [211] = 210,
  [212] = 212,
  [213] = 213,
  [214] = 212,
  [215] = 215,
  [216] = 216,
  [217] = 215,
  [218] = 215,
  [219] = 219,
  [220] = 220,
  [221] = 221,
  [222] = 219,
  [223] = 223,
  [224] = 215,
  [225] = 216,
  [226] = 216,
  [227] = 227,
  [228] = 228,
  [229] = 219,
  [230] = 219,
  [231] = 220,
  [232] = 223,
  [233] = 221,
  [234] = 228,
  [235] = 227,
  [236] = 215,
  [237] = 216,
  [238] = 238,
  [239] = 238,
  [240] = 240,
  [241] = 216,
  [242] = 219,
  [243] = 243,
  [244] = 244,
  [245] = 243,
  [246] = 243,
  [247] = 243,
  [248] = 248,
  [249] = 249,
  [250] = 250,
  [251] = 251,
  [252] = 252,
  [253] = 253,
  [254] = 253,
  [255] = 255,
  [256] = 248,
  [257] = 257,
  [258] = 258,
  [259] = 259,
  [260] = 260,
  [261] = 261,
  [262] = 262,
  [263] = 263,
  [264] = 264,
  [265] = 265,
  [266] = 266,
  [267] = 264,
  [268] = 268,
  [269] = 250,
  [270] = 270,
  [271] = 251,
  [272] = 252,
  [273] = 257,
  [274] = 258,
  [275] = 260,
  [276] = 261,
  [277] = 263,
  [278] = 265,
  [279] = 266,
  [280] = 270,
  [281] = 266,
  [282] = 270,
  [283] = 283,
  [284] = 284,
  [285] = 265,
  [286] = 286,
  [287] = 287,
  [288] = 288,
  [289] = 289,
  [290] = 263,
  [291] = 291,
  [292] = 261,
  [293] = 260,
  [294] = 258,
  [295] = 295,
  [296] = 257,
  [297] = 297,
  [298] = 252,
  [299] = 299,
  [300] = 248,
  [301] = 251,
  [302] = 302,
  [303] = 250,
  [304] = 268,
  [305] = 270,
  [306] = 306,
  [307] = 259,
  [308] = 308,
  [309] = 309,
  [310] = 266,
  [311] = 265,
  [312] = 263,
  [313] = 313,
  [314] = 314,
  [315] = 314,
  [316] = 253,
  [317] = 261,
  [318] = 260,
  [319] = 270,
  [320] = 299,
  [321] = 284,
  [322] = 258,
  [323] = 257,
  [324] = 324,
  [325] = 252,
  [326] = 326,
  [327] = 324,
  [328] = 251,
  [329] = 283,
  [330] = 308,
  [331] = 324,
  [332] = 302,
  [333] = 250,
  [334] = 287,
  [335] = 335,
  [336] = 268,
  [337] = 337,
  [338] = 338,
  [339] = 270,
  [340] = 299,
  [341] = 255,
  [342] = 342,
  [343] = 288,
  [344] = 270,
  [345] = 324,
  [346] = 346,
  [347] = 270,
  [348] = 348,
  [349] = 308,
  [350] = 299,
  [351] = 351,
  [352] = 352,
  [353] = 353,
  [354] = 354,
  [355] = 352,
  [356] = 295,
  [357] = 249,
  [358] = 288,
  [359] = 248,
  [360] = 360,
  [361] = 326,
  [362] = 354,
  [363] = 363,
  [364] = 268,
  [365] = 365,
  [366] = 253,
  [367] = 308,
  [368] = 368,
  [369] = 369,
  [370] = 346,
  [371] = 371,
  [372] = 372,
  [373] = 373,
  [374] = 374,
  [375] = 375,
  [376] = 185,
  [377] = 377,
  [378] = 378,
  [379] = 379,
  [380] = 380,
  [381] = 381,
  [382] = 382,
  [383] = 381,
  [384] = 384,
  [385] = 385,
  [386] = 184,
  [387] = 387,
  [388] = 388,
  [389] = 389,
  [390] = 375,
  [391] = 391,
  [392] = 392,
  [393] = 393,
  [394] = 375,
  [395] = 381,
  [396] = 396,
  [397] = 397,
  [398] = 398,
  [399] = 399,
  [400] = 400,
  [401] = 397,
  [402] = 400,
  [403] = 403,
  [404] = 403,
  [405] = 405,
  [406] = 400,
  [407] = 405,
  [408] = 405,
  [409] = 403,
  [410] = 410,
  [411] = 410,
  [412] = 412,
  [413] = 410,
  [414] = 414,
  [415] = 415,
  [416] = 415,
  [417] = 415,
  [418] = 418,
  [419] = 419,
  [420] = 420,
  [421] = 420,
  [422] = 420,
  [423] = 423,
  [424] = 423,
  [425] = 419,
  [426] = 426,
  [427] = 426,
  [428] = 423,
  [429] = 429,
  [430] = 429,
  [431] = 431,
  [432] = 432,
  [433] = 433,
  [434] = 434,
  [435] = 435,
  [436] = 434,
  [437] = 435,
  [438] = 433,
  [439] = 434,
  [440] = 435,
  [441] = 433,
  [442] = 442,
  [443] = 443,
  [444] = 443,
  [445] = 443,
  [446] = 244,
  [447] = 369,
  [448] = 365,
  [449] = 297,
  [450] = 335,
  [451] = 313,
  [452] = 371,
  [453] = 388,
  [454] = 398,
  [455] = 455,
  [456] = 456,
  [457] = 393,
  [458] = 458,
  [459] = 392,
  [460] = 374,
  [461] = 391,
  [462] = 382,
  [463] = 372,
  [464] = 456,
  [465] = 384,
  [466] = 387,
  [467] = 456,
  [468] = 399,
  [469] = 379,
  [470] = 456,
  [471] = 373,
  [472] = 389,
  [473] = 396,
  [474] = 377,
  [475] = 475,
  [476] = 475,
  [477] = 475,
  [478] = 475,
  [479] = 479,
  [480] = 480,
  [481] = 481,
  [482] = 482,
  [483] = 483,
  [484] = 484,
  [485] = 485,
  [486] = 486,
  [487] = 487,
  [488] = 488,
  [489] = 489,
  [490] = 490,
  [491] = 491,
  [492] = 492,
  [493] = 493,
  [494] = 494,
  [495] = 495,
  [496] = 496,
  [497] = 497,
  [498] = 498,
  [499] = 499,
  [500] = 500,
  [501] = 501,
  [502] = 502,
  [503] = 503,
  [504] = 504,
  [505] = 505,
  [506] = 506,
  [507] = 507,
  [508] = 508,
  [509] = 509,
  [510] = 510,
  [511] = 511,
  [512] = 512,
  [513] = 513,
  [514] = 514,
  [515] = 515,
  [516] = 516,
  [517] = 517,
  [518] = 518,
  [519] = 519,
  [520] = 520,
  [521] = 521,
  [522] = 522,
  [523] = 523,
  [524] = 524,
  [525] = 525,
  [526] = 526,
  [527] = 527,
  [528] = 528,
  [529] = 529,
  [530] = 530,
  [531] = 531,
  [532] = 532,
  [533] = 533,
  [534] = 534,
  [535] = 535,
  [536] = 536,
  [537] = 537,
  [538] = 538,
  [539] = 539,
  [540] = 540,
  [541] = 541,
  [542] = 542,
  [543] = 543,
  [544] = 544,
  [545] = 545,
  [546] = 546,
  [547] = 547,
  [548] = 548,
  [549] = 369,
  [550] = 550,
  [551] = 551,
  [552] = 552,
  [553] = 553,
  [554] = 554,
  [555] = 555,
  [556] = 556,
  [557] = 557,
  [558] = 558,
  [559] = 559,
  [560] = 560,
  [561] = 561,
  [562] = 562,
  [563] = 563,
  [564] = 564,
  [565] = 565,
  [566] = 566,
  [567] = 567,
  [568] = 568,
  [569] = 569,
  [570] = 570,
  [571] = 571,
  [572] = 572,
  [573] = 573,
  [574] = 574,
  [575] = 575,
  [576] = 576,
  [577] = 577,
  [578] = 578,
  [579] = 579,
  [580] = 580,
  [581] = 581,
  [582] = 582,
  [583] = 583,
  [584] = 584,
  [585] = 585,
  [586] = 586,
  [587] = 587,
  [588] = 588,
  [589] = 589,
  [590] = 590,
  [591] = 591,
  [592] = 592,
  [593] = 593,
  [594] = 594,
  [595] = 595,
  [596] = 596,
  [597] = 597,
  [598] = 598,
  [599] = 599,
  [600] = 600,
  [601] = 601,
  [602] = 602,
  [603] = 603,
  [604] = 604,
  [605] = 605,
  [606] = 606,
  [607] = 607,
  [608] = 608,
  [609] = 609,
  [610] = 610,
  [611] = 611,
  [612] = 612,
  [613] = 613,
  [614] = 614,
  [615] = 615,
  [616] = 616,
  [617] = 617,
  [618] = 618,
  [619] = 619,
  [620] = 620,
  [621] = 621,
  [622] = 622,
  [623] = 623,
  [624] = 624,
  [625] = 625,
  [626] = 626,
  [627] = 627,
  [628] = 628,
  [629] = 525,
  [630] = 313,
  [631] = 631,
  [632] = 632,
  [633] = 633,
  [634] = 634,
  [635] = 635,
  [636] = 636,
  [637] = 637,
  [638] = 638,
  [639] = 639,
  [640] = 640,
  [641] = 641,
  [642] = 642,
  [643] = 643,
  [644] = 644,
  [645] = 645,
  [646] = 646,
  [647] = 647,
  [648] = 648,
  [649] = 649,
  [650] = 650,
  [651] = 651,
  [652] = 652,
  [653] = 653,
  [654] = 654,
  [655] = 655,
  [656] = 656,
  [657] = 657,
  [658] = 658,
  [659] = 659,
  [660] = 660,
  [661] = 661,
  [662] = 662,
  [663] = 663,
  [664] = 664,
  [665] = 665,
  [666] = 335,
  [667] = 667,
  [668] = 668,
  [669] = 581,
  [670] = 670,
  [671] = 671,
  [672] = 672,
  [673] = 673,
  [674] = 674,
  [675] = 675,
  [676] = 676,
  [677] = 677,
  [678] = 678,
  [679] = 679,
  [680] = 297,
  [681] = 681,
  [682] = 682,
  [683] = 683,
  [684] = 684,
  [685] = 685,
  [686] = 365,
  [687] = 687,
  [688] = 688,
  [689] = 689,
  [690] = 690,
  [691] = 691,
  [692] = 692,
  [693] = 693,
  [694] = 694,
  [695] = 695,
  [696] = 696,
  [697] = 697,
  [698] = 698,
  [699] = 699,
  [700] = 700,
  [701] = 701,
  [702] = 702,
  [703] = 703,
  [704] = 704,
  [705] = 705,
  [706] = 706,
  [707] = 707,
  [708] = 708,
  [709] = 709,
  [710] = 710,
  [711] = 711,
  [712] = 712,
  [713] = 713,
  [714] = 714,
  [715] = 715,
  [716] = 716,
  [717] = 717,
  [718] = 718,
  [719] = 719,
  [720] = 720,
  [721] = 721,
  [722] = 722,
  [723] = 723,
  [724] = 724,
  [725] = 725,
  [726] = 726,
  [727] = 727,
  [728] = 728,
  [729] = 729,
  [730] = 730,
  [731] = 731,
  [732] = 732,
  [733] = 733,
  [734] = 734,
  [735] = 735,
  [736] = 736,
  [737] = 737,
  [738] = 738,
  [739] = 739,
  [740] = 740,
  [741] = 741,
  [742] = 742,
  [743] = 743,
  [744] = 744,
  [745] = 745,
  [746] = 746,
  [747] = 747,
  [748] = 748,
  [749] = 749,
  [750] = 750,
  [751] = 750,
  [752] = 752,
  [753] = 753,
  [754] = 754,
  [755] = 754,
  [756] = 756,
  [757] = 753,
  [758] = 758,
  [759] = 759,
  [760] = 760,
  [761] = 761,
  [762] = 762,
  [763] = 763,
  [764] = 764,
  [765] = 765,
  [766] = 766,
  [767] = 767,
  [768] = 768,
  [769] = 768,
  [770] = 770,
  [771] = 771,
  [772] = 772,
  [773] = 770,
  [774] = 774,
  [775] = 774,
  [776] = 776,
  [777] = 777,
  [778] = 778,
  [779] = 779,
  [780] = 780,
  [781] = 781,
  [782] = 777,
  [783] = 783,
  [784] = 776,
  [785] = 785,
  [786] = 783,
  [787] = 781,
  [788] = 780,
  [789] = 789,
  [790] = 778,
  [791] = 791,
  [792] = 792,
  [793] = 793,
  [794] = 794,
  [795] = 795,
  [796] = 796,
  [797] = 793,
  [798] = 798,
  [799] = 799,
  [800] = 800,
  [801] = 801,
  [802] = 799,
  [803] = 803,
  [804] = 804,
  [805] = 805,
  [806] = 806,
  [807] = 804,
  [808] = 808,
  [809] = 800,
  [810] = 810,
  [811] = 811,
  [812] = 801,
  [813] = 792,
  [814] = 808,
  [815] = 815,
  [816] = 801,
  [817] = 815,
  [818] = 805,
  [819] = 810,
  [820] = 800,
  [821] = 795,
  [822] = 801,
  [823] = 800,
  [824] = 803,
  [825] = 825,
  [826] = 825,
  [827] = 827,
  [828] = 825,
  [829] = 825,
  [830] = 830,
  [831] = 831,
  [832] = 832,
  [833] = 833,
  [834] = 831,
  [835] = 835,
  [836] = 836,
  [837] = 837,
  [838] = 837,
  [839] = 832,
  [840] = 840,
  [841] = 840,
  [842] = 836,
  [843] = 843,
  [844] = 844,
  [845] = 837,
  [846] = 831,
  [847] = 844,
  [848] = 848,
  [849] = 836,
  [850] = 850,
  [851] = 851,
  [852] = 840,
  [853] = 840,
  [854] = 854,
  [855] = 855,
  [856] = 856,
  [857] = 857,
  [858] = 858,
  [859] = 859,
  [860] = 860,
  [861] = 861,
  [862] = 854,
  [863] = 863,
  [864] = 864,
  [865] = 865,
  [866] = 866,
  [867] = 867,
  [868] = 868,
  [869] = 869,
  [870] = 870,
  [871] = 871,
  [872] = 863,
  [873] = 873,
  [874] = 874,
  [875] = 875,
  [876] = 876,
  [877] = 877,
  [878] = 870,
  [879] = 879,
  [880] = 880,
  [881] = 881,
  [882] = 880,
  [883] = 883,
  [884] = 884,
  [885] = 885,
  [886] = 861,
  [887] = 887,
  [888] = 867,
  [889] = 889,
  [890] = 890,
  [891] = 891,
  [892] = 892,
  [893] = 893,
  [894] = 876,
  [895] = 864,
  [896] = 896,
  [897] = 897,
  [898] = 898,
  [899] = 858,
  [900] = 854,
  [901] = 860,
  [902] = 902,
  [903] = 859,
  [904] = 904,
  [905] = 885,
  [906] = 906,
  [907] = 864,
  [908] = 908,
  [909] = 902,
  [910] = 910,
  [911] = 911,
  [912] = 912,
  [913] = 913,
  [914] = 914,
  [915] = 915,
  [916] = 857,
  [917] = 705,
  [918] = 856,
  [919] = 919,
  [920] = 920,
  [921] = 921,
  [922] = 892,
  [923] = 919,
  [924] = 881,
  [925] = 860,
  [926] = 904,
  [927] = 927,
  [928] = 928,
  [929] = 863,
  [930] = 877,
  [931] = 908,
  [932] = 871,
  [933] = 933,
  [934] = 934,
  [935] = 935,
  [936] = 936,
  [937] = 937,
  [938] = 938,
  [939] = 890,
  [940] = 940,
  [941] = 857,
  [942] = 937,
  [943] = 904,
  [944] = 944,
  [945] = 868,
  [946] = 946,
  [947] = 947,
  [948] = 911,
  [949] = 858,
  [950] = 927,
  [951] = 936,
  [952] = 906,
  [953] = 940,
  [954] = 954,
  [955] = 887,
  [956] = 956,
  [957] = 957,
  [958] = 898,
  [959] = 869,
  [960] = 947,
  [961] = 879,
  [962] = 934,
  [963] = 940,
  [964] = 865,
  [965] = 910,
  [966] = 966,
  [967] = 928,
  [968] = 968,
  [969] = 864,
  [970] = 863,
  [971] = 944,
  [972] = 854,
  [973] = 973,
  [974] = 974,
  [975] = 859,
  [976] = 957,
  [977] = 954,
  [978] = 897,
  [979] = 857,
  [980] = 912,
  [981] = 856,
  [982] = 938,
  [983] = 933,
  [984] = 875,
  [985] = 883,
  [986] = 986,
  [987] = 974,
  [988] = 873,
  [989] = 879,
  [990] = 921,
  [991] = 869,
  [992] = 883,
  [993] = 911,
  [994] = 893,
  [995] = 874,
  [996] = 913,
  [997] = 868,
  [998] = 998,
  [999] = 999,
  [1000] = 1000,
  [1001] = 1001,
  [1002] = 1002,
  [1003] = 705,
  [1004] = 1004,
  [1005] = 1005,
  [1006] = 1006,
  [1007] = 1007,
  [1008] = 1008,
  [1009] = 1009,
  [1010] = 1010,
  [1011] = 1011,
  [1012] = 184,
  [1013] = 1013,
  [1014] = 1014,
  [1015] = 1015,
  [1016] = 313,
  [1017] = 1017,
  [1018] = 297,
  [1019] = 185,
  [1020] = 335,
  [1021] = 1021,
  [1022] = 1022,
  [1023] = 369,
  [1024] = 380,
  [1025] = 365,
  [1026] = 1026,
  [1027] = 385,
  [1028] = 1028,
  [1029] = 578,
  [1030] = 1030,
  [1031] = 722,
  [1032] = 521,
  [1033] = 1033,
  [1034] = 709,
  [1035] = 1035,
  [1036] = 1036,
  [1037] = 542,
  [1038] = 1038,
  [1039] = 1039,
  [1040] = 1004,
  [1041] = 998,
  [1042] = 1042,
  [1043] = 1043,
  [1044] = 1044,
  [1045] = 1045,
  [1046] = 1046,
  [1047] = 1047,
  [1048] = 1048,
  [1049] = 1049,
  [1050] = 244,
  [1051] = 1051,
  [1052] = 1052,
  [1053] = 1053,
  [1054] = 1054,
  [1055] = 1055,
  [1056] = 1056,
  [1057] = 1056,
  [1058] = 1058,
  [1059] = 1059,
  [1060] = 1060,
  [1061] = 1061,
  [1062] = 1062,
  [1063] = 1043,
  [1064] = 1056,
  [1065] = 1065,
  [1066] = 1066,
  [1067] = 1067,
  [1068] = 1043,
  [1069] = 1069,
  [1070] = 1070,
  [1071] = 1071,
  [1072] = 1072,
  [1073] = 1073,
  [1074] = 1074,
  [1075] = 1075,
  [1076] = 1076,
  [1077] = 1077,
  [1078] = 1078,
  [1079] = 1079,
  [1080] = 1080,
  [1081] = 1081,
  [1082] = 1082,
  [1083] = 1083,
  [1084] = 429,
  [1085] = 1085,
  [1086] = 1086,
  [1087] = 675,
  [1088] = 599,
  [1089] = 1006,
  [1090] = 580,
  [1091] = 519,
  [1092] = 662,
  [1093] = 485,
  [1094] = 696,
  [1095] = 488,
  [1096] = 585,
  [1097] = 1097,
  [1098] = 695,
  [1099] = 490,
  [1100] = 502,
  [1101] = 571,
  [1102] = 377,
  [1103] = 380,
  [1104] = 1104,
  [1105] = 1105,
  [1106] = 693,
  [1107] = 664,
  [1108] = 663,
  [1109] = 392,
  [1110] = 147,
  [1111] = 297,
  [1112] = 657,
  [1113] = 628,
  [1114] = 692,
  [1115] = 514,
  [1116] = 649,
  [1117] = 741,
  [1118] = 1118,
  [1119] = 648,
  [1120] = 538,
  [1121] = 1121,
  [1122] = 645,
  [1123] = 137,
  [1124] = 1124,
  [1125] = 626,
  [1126] = 1126,
  [1127] = 1127,
  [1128] = 681,
  [1129] = 625,
  [1130] = 643,
  [1131] = 1131,
  [1132] = 1132,
  [1133] = 641,
  [1134] = 1134,
  [1135] = 640,
  [1136] = 1005,
  [1137] = 679,
  [1138] = 678,
  [1139] = 638,
  [1140] = 1140,
  [1141] = 637,
  [1142] = 636,
  [1143] = 1143,
  [1144] = 624,
  [1145] = 1145,
  [1146] = 1146,
  [1147] = 621,
  [1148] = 313,
  [1149] = 619,
  [1150] = 618,
  [1151] = 1151,
  [1152] = 632,
  [1153] = 1153,
  [1154] = 1154,
  [1155] = 1155,
  [1156] = 617,
  [1157] = 1157,
  [1158] = 623,
  [1159] = 1159,
  [1160] = 616,
  [1161] = 582,
  [1162] = 576,
  [1163] = 609,
  [1164] = 1164,
  [1165] = 1165,
  [1166] = 399,
  [1167] = 579,
  [1168] = 398,
  [1169] = 587,
  [1170] = 153,
  [1171] = 335,
  [1172] = 382,
  [1173] = 1173,
  [1174] = 700,
  [1175] = 1175,
  [1176] = 1176,
  [1177] = 608,
  [1178] = 702,
  [1179] = 703,
  [1180] = 1180,
  [1181] = 607,
  [1182] = 704,
  [1183] = 706,
  [1184] = 707,
  [1185] = 1185,
  [1186] = 716,
  [1187] = 615,
  [1188] = 717,
  [1189] = 719,
  [1190] = 614,
  [1191] = 613,
  [1192] = 612,
  [1193] = 1193,
  [1194] = 720,
  [1195] = 393,
  [1196] = 731,
  [1197] = 391,
  [1198] = 1198,
  [1199] = 379,
  [1200] = 1200,
  [1201] = 1201,
  [1202] = 611,
  [1203] = 746,
  [1204] = 745,
  [1205] = 388,
  [1206] = 610,
  [1207] = 602,
  [1208] = 601,
  [1209] = 1209,
  [1210] = 1210,
  [1211] = 1211,
  [1212] = 600,
  [1213] = 1213,
  [1214] = 570,
  [1215] = 1215,
  [1216] = 1216,
  [1217] = 1217,
  [1218] = 1218,
  [1219] = 597,
  [1220] = 743,
  [1221] = 1221,
  [1222] = 1222,
  [1223] = 480,
  [1224] = 1224,
  [1225] = 1225,
  [1226] = 1226,
  [1227] = 1227,
  [1228] = 705,
  [1229] = 596,
  [1230] = 1230,
  [1231] = 1231,
  [1232] = 595,
  [1233] = 606,
  [1234] = 603,
  [1235] = 740,
  [1236] = 738,
  [1237] = 590,
  [1238] = 598,
  [1239] = 574,
  [1240] = 677,
  [1241] = 676,
  [1242] = 737,
  [1243] = 593,
  [1244] = 1244,
  [1245] = 1245,
  [1246] = 1246,
  [1247] = 673,
  [1248] = 672,
  [1249] = 588,
  [1250] = 1250,
  [1251] = 699,
  [1252] = 671,
  [1253] = 734,
  [1254] = 727,
  [1255] = 726,
  [1256] = 670,
  [1257] = 667,
  [1258] = 577,
  [1259] = 1259,
  [1260] = 185,
  [1261] = 718,
  [1262] = 592,
  [1263] = 735,
  [1264] = 736,
  [1265] = 739,
  [1266] = 369,
  [1267] = 742,
  [1268] = 591,
  [1269] = 575,
  [1270] = 589,
  [1271] = 586,
  [1272] = 572,
  [1273] = 569,
  [1274] = 568,
  [1275] = 584,
  [1276] = 633,
  [1277] = 566,
  [1278] = 384,
  [1279] = 564,
  [1280] = 724,
  [1281] = 1281,
  [1282] = 583,
  [1283] = 563,
  [1284] = 1284,
  [1285] = 573,
  [1286] = 562,
  [1287] = 561,
  [1288] = 371,
  [1289] = 567,
  [1290] = 145,
  [1291] = 723,
  [1292] = 733,
  [1293] = 732,
  [1294] = 560,
  [1295] = 730,
  [1296] = 729,
  [1297] = 728,
  [1298] = 559,
  [1299] = 374,
  [1300] = 1300,
  [1301] = 565,
  [1302] = 540,
  [1303] = 1303,
  [1304] = 479,
  [1305] = 1305,
  [1306] = 558,
  [1307] = 1307,
  [1308] = 687,
  [1309] = 1309,
  [1310] = 1310,
  [1311] = 660,
  [1312] = 557,
  [1313] = 708,
  [1314] = 698,
  [1315] = 556,
  [1316] = 697,
  [1317] = 1317,
  [1318] = 372,
  [1319] = 555,
  [1320] = 694,
  [1321] = 535,
  [1322] = 691,
  [1323] = 690,
  [1324] = 689,
  [1325] = 685,
  [1326] = 684,
  [1327] = 534,
  [1328] = 1328,
  [1329] = 683,
  [1330] = 554,
  [1331] = 682,
  [1332] = 1332,
  [1333] = 483,
  [1334] = 1334,
  [1335] = 674,
  [1336] = 749,
  [1337] = 668,
  [1338] = 748,
  [1339] = 653,
  [1340] = 1340,
  [1341] = 747,
  [1342] = 484,
  [1343] = 486,
  [1344] = 1344,
  [1345] = 489,
  [1346] = 701,
  [1347] = 492,
  [1348] = 688,
  [1349] = 656,
  [1350] = 494,
  [1351] = 652,
  [1352] = 665,
  [1353] = 642,
  [1354] = 661,
  [1355] = 639,
  [1356] = 635,
  [1357] = 482,
  [1358] = 537,
  [1359] = 497,
  [1360] = 631,
  [1361] = 627,
  [1362] = 658,
  [1363] = 655,
  [1364] = 594,
  [1365] = 654,
  [1366] = 508,
  [1367] = 481,
  [1368] = 634,
  [1369] = 487,
  [1370] = 491,
  [1371] = 493,
  [1372] = 553,
  [1373] = 1373,
  [1374] = 651,
  [1375] = 495,
  [1376] = 496,
  [1377] = 498,
  [1378] = 647,
  [1379] = 644,
  [1380] = 499,
  [1381] = 387,
  [1382] = 620,
  [1383] = 500,
  [1384] = 604,
  [1385] = 721,
  [1386] = 552,
  [1387] = 501,
  [1388] = 503,
  [1389] = 715,
  [1390] = 1390,
  [1391] = 1391,
  [1392] = 504,
  [1393] = 365,
  [1394] = 1394,
  [1395] = 714,
  [1396] = 713,
  [1397] = 505,
  [1398] = 712,
  [1399] = 506,
  [1400] = 711,
  [1401] = 1401,
  [1402] = 1402,
  [1403] = 710,
  [1404] = 385,
  [1405] = 622,
  [1406] = 646,
  [1407] = 551,
  [1408] = 507,
  [1409] = 1409,
  [1410] = 1410,
  [1411] = 510,
  [1412] = 512,
  [1413] = 1413,
  [1414] = 1414,
  [1415] = 550,
  [1416] = 513,
  [1417] = 373,
  [1418] = 515,
  [1419] = 516,
  [1420] = 518,
  [1421] = 520,
  [1422] = 548,
  [1423] = 1423,
  [1424] = 1424,
  [1425] = 1425,
  [1426] = 1426,
  [1427] = 1427,
  [1428] = 533,
  [1429] = 547,
  [1430] = 523,
  [1431] = 532,
  [1432] = 1432,
  [1433] = 389,
  [1434] = 524,
  [1435] = 526,
  [1436] = 1436,
  [1437] = 650,
  [1438] = 1438,
  [1439] = 1439,
  [1440] = 1440,
  [1441] = 140,
  [1442] = 184,
  [1443] = 1443,
  [1444] = 1444,
  [1445] = 527,
  [1446] = 528,
  [1447] = 531,
  [1448] = 529,
  [1449] = 522,
  [1450] = 530,
  [1451] = 546,
  [1452] = 539,
  [1453] = 541,
  [1454] = 543,
  [1455] = 544,
  [1456] = 545,
  [1457] = 1457,
  [1458] = 509,
  [1459] = 517,
  [1460] = 396,
  [1461] = 511,
  [1462] = 1462,
  [1463] = 1463,
  [1464] = 1464,
  [1465] = 1465,
  [1466] = 1466,
  [1467] = 533,
  [1468] = 999,
  [1469] = 705,
  [1470] = 1470,
  [1471] = 1471,
  [1472] = 1472,
  [1473] = 1473,
  [1474] = 1474,
  [1475] = 1475,
  [1476] = 1476,
  [1477] = 1477,
  [1478] = 1478,
  [1479] = 1479,
  [1480] = 1480,
  [1481] = 1028,
  [1482] = 1482,
  [1483] = 1483,
  [1484] = 1007,
  [1485] = 1485,
  [1486] = 1486,
  [1487] = 1487,
  [1488] = 1488,
  [1489] = 1489,
  [1490] = 1490,
  [1491] = 1491,
  [1492] = 1476,
  [1493] = 1493,
  [1494] = 1494,
  [1495] = 1495,
  [1496] = 1496,
  [1497] = 1476,
  [1498] = 1498,
  [1499] = 1028,
  [1500] = 1500,
  [1501] = 1500,
  [1502] = 1028,
  [1503] = 1498,
  [1504] = 1010,
  [1505] = 1505,
  [1506] = 1008,
  [1507] = 1009,
  [1508] = 1026,
  [1509] = 1048,
  [1510] = 1017,
  [1511] = 1011,
  [1512] = 1014,
  [1513] = 1015,
  [1514] = 1013,
  [1515] = 1047,
  [1516] = 1516,
  [1517] = 1121,
  [1518] = 1518,
  [1519] = 1121,
  [1520] = 1022,
  [1521] = 1021,
  [1522] = 1081,
  [1523] = 1523,
  [1524] = 1078,
  [1525] = 1081,
  [1526] = 1048,
  [1527] = 1527,
  [1528] = 1528,
  [1529] = 1529,
  [1530] = 1078,
  [1531] = 1462,
  [1532] = 1532,
  [1533] = 1047,
  [1534] = 1038,
  [1535] = 244,
  [1536] = 1121,
  [1537] = 1052,
  [1538] = 1058,
  [1539] = 1462,
  [1540] = 1540,
  [1541] = 1541,
  [1542] = 1542,
  [1543] = 1030,
  [1544] = 1544,
  [1545] = 1544,
  [1546] = 1544,
  [1547] = 1065,
  [1548] = 1127,
  [1549] = 1085,
  [1550] = 1033,
  [1551] = 1464,
  [1552] = 1231,
  [1553] = 1044,
  [1554] = 1542,
  [1555] = 1465,
  [1556] = 1541,
  [1557] = 1039,
  [1558] = 1540,
  [1559] = 1127,
  [1560] = 1542,
  [1561] = 1544,
  [1562] = 1231,
  [1563] = 1542,
  [1564] = 1085,
  [1565] = 1565,
  [1566] = 1482,
  [1567] = 1465,
  [1568] = 1494,
  [1569] = 369,
  [1570] = 1570,
  [1571] = 313,
  [1572] = 335,
  [1573] = 297,
  [1574] = 365,
  [1575] = 1046,
  [1576] = 1066,
  [1577] = 1061,
  [1578] = 1079,
  [1579] = 1487,
  [1580] = 1055,
  [1581] = 1581,
  [1582] = 1565,
  [1583] = 1583,
  [1584] = 1570,
  [1585] = 1076,
  [1586] = 1045,
  [1587] = 1587,
  [1588] = 1062,
  [1589] = 1475,
  [1590] = 1054,
  [1591] = 1080,
  [1592] = 1483,
  [1593] = 1480,
  [1594] = 1051,
  [1595] = 1477,
  [1596] = 1071,
  [1597] = 1070,
  [1598] = 1491,
  [1599] = 1489,
  [1600] = 1486,
  [1601] = 1474,
  [1602] = 1602,
  [1603] = 1479,
  [1604] = 1082,
  [1605] = 1496,
  [1606] = 1490,
  [1607] = 1053,
  [1608] = 1495,
  [1609] = 1493,
  [1610] = 1485,
  [1611] = 1581,
  [1612] = 1488,
  [1613] = 1083,
  [1614] = 1587,
  [1615] = 1069,
  [1616] = 1086,
  [1617] = 1072,
  [1618] = 1478,
  [1619] = 1059,
  [1620] = 1464,
  [1621] = 1077,
  [1622] = 1587,
  [1623] = 1060,
  [1624] = 1042,
  [1625] = 1049,
  [1626] = 1073,
  [1627] = 1075,
  [1628] = 1474,
  [1629] = 1173,
  [1630] = 384,
  [1631] = 1631,
  [1632] = 1227,
  [1633] = 1226,
  [1634] = 1217,
  [1635] = 1635,
  [1636] = 1475,
  [1637] = 1637,
  [1638] = 1638,
  [1639] = 1444,
  [1640] = 1494,
  [1641] = 1443,
  [1642] = 1477,
  [1643] = 387,
  [1644] = 1482,
  [1645] = 1216,
  [1646] = 1646,
  [1647] = 1647,
  [1648] = 1648,
  [1649] = 1213,
  [1650] = 1489,
  [1651] = 1200,
  [1652] = 1486,
  [1653] = 1496,
  [1654] = 1654,
  [1655] = 1344,
  [1656] = 1656,
  [1657] = 1646,
  [1658] = 1490,
  [1659] = 1495,
  [1660] = 1493,
  [1661] = 1661,
  [1662] = 1662,
  [1663] = 1663,
  [1664] = 1485,
  [1665] = 1402,
  [1666] = 1666,
  [1667] = 1193,
  [1668] = 1661,
  [1669] = 1426,
  [1670] = 377,
  [1671] = 1671,
  [1672] = 1483,
  [1673] = 1673,
  [1674] = 1674,
  [1675] = 1478,
  [1676] = 1157,
  [1677] = 1230,
  [1678] = 1215,
  [1679] = 1491,
  [1680] = 388,
  [1681] = 1487,
  [1682] = 1682,
  [1683] = 1683,
  [1684] = 1684,
  [1685] = 1394,
  [1686] = 1479,
  [1687] = 371,
  [1688] = 1688,
  [1689] = 1155,
  [1690] = 1390,
  [1691] = 1488,
  [1692] = 1438,
  [1693] = 1631,
  [1694] = 1682,
  [1695] = 1440,
  [1696] = 1439,
  [1697] = 1697,
  [1698] = 1436,
  [1699] = 1699,
  [1700] = 1432,
  [1701] = 1303,
  [1702] = 1300,
  [1703] = 1126,
  [1704] = 1475,
  [1705] = 1104,
  [1706] = 1656,
  [1707] = 1673,
  [1708] = 1682,
  [1709] = 1699,
  [1710] = 1480,
  [1711] = 1250,
  [1712] = 1656,
  [1713] = 1244,
  [1714] = 1425,
  [1715] = 1222,
  [1716] = 1004,
  [1717] = 1671,
  [1718] = 1631,
  [1719] = 1483,
  [1720] = 1317,
  [1721] = 1673,
  [1722] = 1480,
  [1723] = 1682,
  [1724] = 1491,
  [1725] = 1631,
  [1726] = 1673,
  [1727] = 1198,
  [1728] = 1218,
  [1729] = 1487,
  [1730] = 1209,
  [1731] = 1656,
  [1732] = 1479,
  [1733] = 1684,
  [1734] = 1478,
  [1735] = 1488,
  [1736] = 1736,
  [1737] = 1673,
  [1738] = 1118,
  [1739] = 1684,
  [1740] = 1631,
  [1741] = 1145,
  [1742] = 1165,
  [1743] = 1656,
  [1744] = 1654,
  [1745] = 1146,
  [1746] = 1132,
  [1747] = 1134,
  [1748] = 1688,
  [1749] = 1749,
  [1750] = 1750,
  [1751] = 1485,
  [1752] = 389,
  [1753] = 399,
  [1754] = 398,
  [1755] = 1493,
  [1756] = 1140,
  [1757] = 1151,
  [1758] = 1495,
  [1759] = 1153,
  [1760] = 1175,
  [1761] = 374,
  [1762] = 1490,
  [1763] = 1185,
  [1764] = 1496,
  [1765] = 1474,
  [1766] = 1176,
  [1767] = 1259,
  [1768] = 1486,
  [1769] = 1489,
  [1770] = 1482,
  [1771] = 1477,
  [1772] = 1772,
  [1773] = 1180,
  [1774] = 1224,
  [1775] = 1225,
  [1776] = 1682,
  [1777] = 1673,
  [1778] = 1211,
  [1779] = 1656,
  [1780] = 1245,
  [1781] = 184,
  [1782] = 1246,
  [1783] = 1674,
  [1784] = 185,
  [1785] = 1684,
  [1786] = 1494,
  [1787] = 1787,
  [1788] = 1631,
  [1789] = 1401,
  [1790] = 1697,
  [1791] = 1494,
  [1792] = 1413,
  [1793] = 1414,
  [1794] = 1794,
  [1795] = 1424,
  [1796] = 1427,
  [1797] = 1281,
  [1798] = 1201,
  [1799] = 1284,
  [1800] = 1682,
  [1801] = 382,
  [1802] = 1164,
  [1803] = 380,
  [1804] = 137,
  [1805] = 1478,
  [1806] = 385,
  [1807] = 373,
  [1808] = 153,
  [1809] = 1391,
  [1810] = 1480,
  [1811] = 1682,
  [1812] = 372,
  [1813] = 1097,
  [1814] = 1673,
  [1815] = 391,
  [1816] = 147,
  [1817] = 1631,
  [1818] = 1221,
  [1819] = 1373,
  [1820] = 429,
  [1821] = 1131,
  [1822] = 1410,
  [1823] = 1159,
  [1824] = 1423,
  [1825] = 392,
  [1826] = 393,
  [1827] = 1656,
  [1828] = 379,
  [1829] = 145,
  [1830] = 396,
  [1831] = 140,
  [1832] = 1124,
  [1833] = 1105,
  [1834] = 1834,
  [1835] = 1835,
  [1836] = 1836,
  [1837] = 1837,
  [1838] = 1838,
  [1839] = 1836,
  [1840] = 1840,
  [1841] = 1787,
  [1842] = 1842,
  [1843] = 1843,
  [1844] = 1844,
  [1845] = 1845,
  [1846] = 1835,
  [1847] = 1847,
  [1848] = 1848,
  [1849] = 1849,
  [1850] = 1844,
  [1851] = 1851,
  [1852] = 1852,
  [1853] = 1847,
  [1854] = 1736,
  [1855] = 1794,
  [1856] = 1856,
  [1857] = 1857,
  [1858] = 1851,
  [1859] = 1859,
  [1860] = 1848,
  [1861] = 1861,
  [1862] = 1861,
  [1863] = 1856,
  [1864] = 1849,
  [1865] = 1859,
  [1866] = 1837,
  [1867] = 1848,
  [1868] = 1868,
  [1869] = 1869,
  [1870] = 1868,
  [1871] = 1869,
  [1872] = 1872,
  [1873] = 1873,
  [1874] = 1874,
  [1875] = 1875,
  [1876] = 1875,
  [1877] = 1874,
  [1878] = 1878,
  [1879] = 1873,
  [1880] = 1878,
  [1881] = 1881,
  [1882] = 1882,
  [1883] = 1883,
  [1884] = 1884,
  [1885] = 1884,
  [1886] = 1886,
  [1887] = 1884,
  [1888] = 1884,
  [1889] = 1886,
  [1890] = 1886,
  [1891] = 1884,
  [1892] = 1892,
  [1893] = 1892,
  [1894] = 147,
  [1895] = 137,
  [1896] = 1007,
  [1897] = 1014,
  [1898] = 1009,
  [1899] = 1010,
  [1900] = 1011,
  [1901] = 1017,
  [1902] = 1008,
  [1903] = 1903,
  [1904] = 1021,
  [1905] = 1013,
  [1906] = 1017,
  [1907] = 1026,
  [1908] = 1021,
  [1909] = 1014,
  [1910] = 1011,
  [1911] = 1015,
  [1912] = 1022,
  [1913] = 1044,
  [1914] = 1083,
  [1915] = 1039,
  [1916] = 1065,
  [1917] = 1038,
  [1918] = 1030,
  [1919] = 1052,
  [1920] = 1033,
  [1921] = 1058,
  [1922] = 1075,
  [1923] = 1072,
  [1924] = 1924,
  [1925] = 1086,
  [1926] = 1926,
  [1927] = 1926,
  [1928] = 1928,
  [1929] = 1066,
  [1930] = 1080,
  [1931] = 385,
  [1932] = 380,
  [1933] = 1077,
  [1934] = 1934,
  [1935] = 1060,
  [1936] = 184,
  [1937] = 1061,
  [1938] = 1082,
  [1939] = 1046,
  [1940] = 1940,
  [1941] = 1045,
  [1942] = 1079,
  [1943] = 1042,
  [1944] = 1940,
  [1945] = 1527,
  [1946] = 185,
  [1947] = 1062,
  [1948] = 1070,
  [1949] = 1076,
  [1950] = 1059,
  [1951] = 1924,
  [1952] = 1053,
  [1953] = 1940,
  [1954] = 1071,
  [1955] = 1073,
  [1956] = 1069,
  [1957] = 1245,
  [1958] = 1225,
  [1959] = 1105,
  [1960] = 1227,
  [1961] = 1401,
  [1962] = 1962,
  [1963] = 1402,
  [1964] = 1528,
  [1965] = 1523,
  [1966] = 1966,
  [1967] = 1516,
  [1968] = 1215,
  [1969] = 1423,
  [1970] = 1244,
  [1971] = 1410,
  [1972] = 1425,
  [1973] = 1390,
  [1974] = 1373,
  [1975] = 1230,
  [1976] = 1413,
  [1977] = 1317,
  [1978] = 1414,
  [1979] = 1427,
  [1980] = 1246,
  [1981] = 1221,
  [1982] = 1097,
  [1983] = 1218,
  [1984] = 1126,
  [1985] = 1226,
  [1986] = 1924,
  [1987] = 1224,
  [1988] = 1424,
  [1989] = 153,
  [1990] = 1990,
  [1991] = 1991,
  [1992] = 145,
  [1993] = 1993,
  [1994] = 1017,
  [1995] = 1903,
  [1996] = 1011,
  [1997] = 1021,
  [1998] = 1014,
  [1999] = 1021,
  [2000] = 1014,
  [2001] = 2001,
  [2002] = 1021,
  [2003] = 1011,
  [2004] = 1017,
  [2005] = 2005,
  [2006] = 2006,
  [2007] = 1011,
  [2008] = 1014,
  [2009] = 1017,
  [2010] = 2010,
  [2011] = 2011,
  [2012] = 2011,
  [2013] = 2013,
  [2014] = 2010,
  [2015] = 2015,
  [2016] = 2013,
  [2017] = 2017,
  [2018] = 2018,
  [2019] = 2019,
  [2020] = 2017,
  [2021] = 2021,
  [2022] = 2018,
  [2023] = 2015,
  [2024] = 2019,
  [2025] = 2025,
  [2026] = 2026,
  [2027] = 2027,
  [2028] = 2028,
  [2029] = 297,
  [2030] = 2030,
  [2031] = 2028,
  [2032] = 2032,
  [2033] = 365,
  [2034] = 2034,
  [2035] = 2035,
  [2036] = 2036,
  [2037] = 2037,
  [2038] = 335,
  [2039] = 1014,
  [2040] = 1011,
  [2041] = 2036,
  [2042] = 2042,
  [2043] = 369,
  [2044] = 2044,
  [2045] = 2045,
  [2046] = 1017,
  [2047] = 2047,
  [2048] = 1021,
  [2049] = 2049,
  [2050] = 2050,
  [2051] = 2051,
  [2052] = 2052,
  [2053] = 313,
  [2054] = 2054,
  [2055] = 2050,
  [2056] = 2034,
  [2057] = 2057,
  [2058] = 2058,
  [2059] = 2059,
  [2060] = 2060,
  [2061] = 2032,
  [2062] = 2026,
  [2063] = 1928,
  [2064] = 2057,
  [2065] = 2030,
  [2066] = 2047,
  [2067] = 2067,
  [2068] = 2068,
  [2069] = 2069,
  [2070] = 2070,
  [2071] = 2071,
  [2072] = 2072,
  [2073] = 2073,
  [2074] = 2074,
  [2075] = 2075,
  [2076] = 393,
  [2077] = 2077,
  [2078] = 2078,
  [2079] = 2079,
  [2080] = 2080,
  [2081] = 2077,
  [2082] = 2075,
  [2083] = 2083,
  [2084] = 2084,
  [2085] = 2085,
  [2086] = 2086,
  [2087] = 2087,
  [2088] = 2088,
  [2089] = 2089,
  [2090] = 2090,
  [2091] = 2091,
  [2092] = 2092,
  [2093] = 2068,
  [2094] = 1928,
  [2095] = 2095,
  [2096] = 2096,
  [2097] = 2097,
  [2098] = 2098,
  [2099] = 2080,
  [2100] = 2100,
  [2101] = 1934,
  [2102] = 2079,
  [2103] = 2103,
  [2104] = 2104,
  [2105] = 2105,
  [2106] = 2106,
  [2107] = 2107,
  [2108] = 2079,
  [2109] = 2109,
  [2110] = 2110,
  [2111] = 2111,
  [2112] = 2112,
  [2113] = 2113,
  [2114] = 2114,
  [2115] = 2115,
  [2116] = 2116,
  [2117] = 2117,
  [2118] = 1928,
  [2119] = 2119,
  [2120] = 2120,
  [2121] = 2121,
  [2122] = 2122,
  [2123] = 2123,
  [2124] = 2124,
  [2125] = 2121,
  [2126] = 2126,
  [2127] = 2127,
  [2128] = 2128,
  [2129] = 2129,
  [2130] = 2130,
  [2131] = 2120,
  [2132] = 2132,
  [2133] = 2133,
  [2134] = 2134,
  [2135] = 2128,
  [2136] = 2136,
  [2137] = 1934,
  [2138] = 2123,
  [2139] = 2139,
  [2140] = 2140,
  [2141] = 1039,
  [2142] = 2142,
  [2143] = 2143,
  [2144] = 2130,
  [2145] = 2134,
  [2146] = 1038,
  [2147] = 2147,
  [2148] = 2148,
  [2149] = 2148,
  [2150] = 2133,
  [2151] = 1928,
  [2152] = 1030,
  [2153] = 2153,
  [2154] = 2154,
  [2155] = 2155,
  [2156] = 2124,
  [2157] = 2129,
  [2158] = 2147,
  [2159] = 2140,
  [2160] = 1934,
  [2161] = 2142,
  [2162] = 2136,
  [2163] = 2122,
  [2164] = 2142,
  [2165] = 1033,
  [2166] = 2147,
  [2167] = 2155,
  [2168] = 2168,
  [2169] = 2169,
  [2170] = 2170,
  [2171] = 2171,
  [2172] = 2172,
  [2173] = 2173,
  [2174] = 2174,
  [2175] = 2169,
  [2176] = 2176,
  [2177] = 2177,
  [2178] = 2173,
  [2179] = 2179,
  [2180] = 2180,
  [2181] = 2181,
  [2182] = 2182,
  [2183] = 2183,
  [2184] = 2179,
  [2185] = 2185,
  [2186] = 2186,
  [2187] = 2187,
  [2188] = 2188,
  [2189] = 2189,
  [2190] = 2190,
  [2191] = 2190,
  [2192] = 2181,
  [2193] = 2172,
  [2194] = 2177,
  [2195] = 2195,
  [2196] = 2196,
  [2197] = 2197,
  [2198] = 2198,
  [2199] = 2180,
  [2200] = 2182,
  [2201] = 2201,
  [2202] = 2195,
  [2203] = 2174,
  [2204] = 2204,
  [2205] = 2196,
  [2206] = 2189,
  [2207] = 2187,
  [2208] = 2208,
  [2209] = 2209,
  [2210] = 2210,
  [2211] = 2211,
  [2212] = 2171,
  [2213] = 2213,
  [2214] = 1934,
  [2215] = 2215,
  [2216] = 2170,
  [2217] = 2217,
  [2218] = 2176,
  [2219] = 2219,
  [2220] = 2219,
  [2221] = 2211,
  [2222] = 2222,
  [2223] = 2223,
  [2224] = 2224,
  [2225] = 2225,
  [2226] = 2226,
  [2227] = 2227,
  [2228] = 2228,
  [2229] = 2229,
  [2230] = 2223,
  [2231] = 2231,
  [2232] = 2232,
  [2233] = 2233,
  [2234] = 2234,
  [2235] = 2235,
  [2236] = 2234,
  [2237] = 2237,
  [2238] = 2238,
  [2239] = 2239,
  [2240] = 2240,
  [2241] = 2241,
  [2242] = 1993,
  [2243] = 2232,
  [2244] = 2244,
  [2245] = 2245,
  [2246] = 2246,
  [2247] = 2247,
  [2248] = 2248,
  [2249] = 2240,
  [2250] = 2250,
  [2251] = 2251,
  [2252] = 2252,
  [2253] = 2229,
  [2254] = 2237,
  [2255] = 2255,
  [2256] = 2256,
  [2257] = 2239,
  [2258] = 2231,
  [2259] = 2259,
  [2260] = 2241,
  [2261] = 2261,
  [2262] = 2262,
  [2263] = 2263,
  [2264] = 2262,
  [2265] = 2251,
  [2266] = 2266,
  [2267] = 2263,
  [2268] = 2225,
  [2269] = 2252,
  [2270] = 2228,
  [2271] = 2224,
  [2272] = 2244,
  [2273] = 2233,
  [2274] = 2227,
  [2275] = 2255,
  [2276] = 2235,
  [2277] = 2259,
  [2278] = 2262,
  [2279] = 2279,
  [2280] = 2280,
  [2281] = 2281,
  [2282] = 2282,
  [2283] = 2283,
  [2284] = 2284,
  [2285] = 137,
  [2286] = 2286,
  [2287] = 2287,
  [2288] = 153,
  [2289] = 147,
  [2290] = 145,
  [2291] = 2291,
  [2292] = 2292,
  [2293] = 2293,
  [2294] = 2294,
  [2295] = 2295,
  [2296] = 2296,
  [2297] = 2297,
  [2298] = 2298,
  [2299] = 2299,
  [2300] = 2294,
  [2301] = 2301,
  [2302] = 2302,
  [2303] = 2286,
  [2304] = 2304,
  [2305] = 2281,
  [2306] = 2306,
  [2307] = 2296,
  [2308] = 2297,
  [2309] = 2309,
  [2310] = 2310,
  [2311] = 2298,
  [2312] = 2312,
  [2313] = 2313,
  [2314] = 2314,
  [2315] = 2315,
  [2316] = 2280,
  [2317] = 2317,
  [2318] = 2318,
  [2319] = 2319,
  [2320] = 2320,
  [2321] = 2313,
  [2322] = 2322,
  [2323] = 2323,
  [2324] = 2324,
  [2325] = 2325,
  [2326] = 2326,
  [2327] = 2306,
  [2328] = 2314,
  [2329] = 2279,
  [2330] = 2304,
  [2331] = 2301,
  [2332] = 2319,
  [2333] = 2333,
  [2334] = 2309,
  [2335] = 2005,
  [2336] = 2001,
  [2337] = 2302,
  [2338] = 2299,
  [2339] = 2339,
  [2340] = 2340,
  [2341] = 2339,
  [2342] = 2340,
  [2343] = 2291,
  [2344] = 2287,
  [2345] = 2006,
  [2346] = 2284,
  [2347] = 2282,
  [2348] = 2282,
  [2349] = 2349,
  [2350] = 2350,
  [2351] = 2325,
  [2352] = 2312,
  [2353] = 2353,
  [2354] = 2354,
  [2355] = 2298,
  [2356] = 2349,
  [2357] = 2357,
  [2358] = 2358,
  [2359] = 2359,
  [2360] = 2358,
  [2361] = 2354,
  [2362] = 2323,
  [2363] = 2363,
  [2364] = 2322,
  [2365] = 2349,
  [2366] = 2354,
  [2367] = 2292,
  [2368] = 2350,
  [2369] = 2293,
  [2370] = 2358,
  [2371] = 2282,
  [2372] = 2333,
  [2373] = 2283,
  [2374] = 2320,
  [2375] = 2318,
  [2376] = 2317,
  [2377] = 2326,
  [2378] = 2378,
  [2379] = 2379,
  [2380] = 2380,
  [2381] = 2381,
  [2382] = 2382,
  [2383] = 2383,
  [2384] = 2384,
  [2385] = 2385,
  [2386] = 2386,
  [2387] = 2387,
  [2388] = 2388,
  [2389] = 2389,
  [2390] = 2390,
  [2391] = 2391,
  [2392] = 2392,
  [2393] = 2393,
  [2394] = 2394,
  [2395] = 2395,
  [2396] = 2385,
  [2397] = 2397,
  [2398] = 2398,
  [2399] = 2399,
  [2400] = 2400,
  [2401] = 1334,
  [2402] = 2402,
  [2403] = 1340,
  [2404] = 2404,
  [2405] = 2405,
  [2406] = 2406,
  [2407] = 2385,
  [2408] = 2408,
  [2409] = 2409,
  [2410] = 2410,
  [2411] = 2411,
  [2412] = 2412,
  [2413] = 2395,
  [2414] = 2414,
  [2415] = 2383,
  [2416] = 2416,
  [2417] = 2417,
  [2418] = 2395,
  [2419] = 2419,
  [2420] = 2420,
  [2421] = 2388,
  [2422] = 2422,
  [2423] = 2423,
  [2424] = 2402,
  [2425] = 2425,
  [2426] = 2426,
  [2427] = 2427,
  [2428] = 2402,
  [2429] = 2429,
  [2430] = 2391,
  [2431] = 2431,
  [2432] = 2432,
  [2433] = 2378,
  [2434] = 2383,
  [2435] = 2429,
  [2436] = 2398,
  [2437] = 2437,
  [2438] = 2438,
  [2439] = 2386,
  [2440] = 2390,
  [2441] = 2427,
  [2442] = 2442,
  [2443] = 2432,
  [2444] = 2432,
  [2445] = 2445,
  [2446] = 2395,
  [2447] = 2390,
  [2448] = 1310,
  [2449] = 1309,
  [2450] = 2450,
  [2451] = 2420,
  [2452] = 2452,
  [2453] = 2453,
  [2454] = 1307,
  [2455] = 2455,
  [2456] = 1328,
  [2457] = 1004,
  [2458] = 2458,
  [2459] = 2459,
  [2460] = 2460,
  [2461] = 2388,
  [2462] = 1210,
  [2463] = 1457,
  [2464] = 2458,
  [2465] = 1409,
  [2466] = 2431,
  [2467] = 2467,
  [2468] = 1332,
  [2469] = 2426,
  [2470] = 2470,
  [2471] = 2389,
  [2472] = 2472,
  [2473] = 2425,
  [2474] = 2397,
  [2475] = 2475,
  [2476] = 2476,
  [2477] = 2400,
  [2478] = 2478,
  [2479] = 2408,
  [2480] = 2423,
  [2481] = 2409,
  [2482] = 2414,
  [2483] = 2422,
  [2484] = 2484,
  [2485] = 2485,
  [2486] = 2486,
  [2487] = 2487,
  [2488] = 2488,
  [2489] = 2489,
  [2490] = 2490,
  [2491] = 2491,
  [2492] = 2492,
  [2493] = 2493,
  [2494] = 2494,
  [2495] = 2495,
  [2496] = 2496,
  [2497] = 2494,
  [2498] = 2496,
  [2499] = 2499,
  [2500] = 2060,
  [2501] = 2501,
  [2502] = 2502,
  [2503] = 2503,
  [2504] = 2504,
  [2505] = 2505,
  [2506] = 2059,
  [2507] = 2488,
  [2508] = 2058,
  [2509] = 2054,
  [2510] = 2510,
  [2511] = 2511,
  [2512] = 2496,
  [2513] = 2513,
  [2514] = 2514,
  [2515] = 2515,
  [2516] = 2516,
  [2517] = 2517,
  [2518] = 2518,
  [2519] = 2519,
  [2520] = 2515,
  [2521] = 2027,
  [2522] = 2522,
  [2523] = 2523,
  [2524] = 2524,
  [2525] = 2525,
  [2526] = 2045,
  [2527] = 2527,
  [2528] = 2528,
  [2529] = 2044,
  [2530] = 2042,
  [2531] = 2531,
  [2532] = 2532,
  [2533] = 2533,
  [2534] = 2534,
  [2535] = 2535,
  [2536] = 2536,
  [2537] = 2537,
  [2538] = 2494,
  [2539] = 2539,
  [2540] = 2523,
  [2541] = 2541,
  [2542] = 2542,
  [2543] = 2533,
  [2544] = 2544,
  [2545] = 2528,
  [2546] = 2546,
  [2547] = 2547,
  [2548] = 2496,
  [2549] = 2489,
  [2550] = 2550,
  [2551] = 2551,
  [2552] = 2550,
  [2553] = 2553,
  [2554] = 2551,
  [2555] = 2555,
  [2556] = 2550,
  [2557] = 2551,
  [2558] = 2550,
  [2559] = 2551,
  [2560] = 2550,
  [2561] = 2551,
  [2562] = 2562,
  [2563] = 2563,
  [2564] = 2494,
  [2565] = 2550,
  [2566] = 2566,
  [2567] = 2551,
  [2568] = 2504,
  [2569] = 164,
  [2570] = 2570,
  [2571] = 2550,
  [2572] = 2551,
  [2573] = 2544,
  [2574] = 2492,
  [2575] = 2575,
  [2576] = 2576,
  [2577] = 2550,
  [2578] = 2551,
  [2579] = 2546,
  [2580] = 2544,
  [2581] = 2524,
  [2582] = 2551,
  [2583] = 2501,
  [2584] = 2492,
  [2585] = 2503,
  [2586] = 2486,
  [2587] = 2550,
  [2588] = 2491,
  [2589] = 2492,
  [2590] = 2590,
  [2591] = 2591,
  [2592] = 2550,
  [2593] = 2551,
  [2594] = 2546,
  [2595] = 2501,
  [2596] = 2544,
  [2597] = 2502,
  [2598] = 2493,
  [2599] = 2541,
  [2600] = 2531,
  [2601] = 2495,
  [2602] = 2524,
  [2603] = 2522,
  [2604] = 2505,
  [2605] = 2501,
  [2606] = 2492,
  [2607] = 2491,
  [2608] = 2486,
  [2609] = 2496,
  [2610] = 2610,
  [2611] = 2611,
  [2612] = 2612,
  [2613] = 2613,
  [2614] = 2503,
  [2615] = 2615,
  [2616] = 2490,
  [2617] = 2617,
  [2618] = 2519,
  [2619] = 2619,
  [2620] = 2620,
  [2621] = 2619,
  [2622] = 2522,
  [2623] = 2591,
  [2624] = 2524,
  [2625] = 2625,
  [2626] = 2626,
  [2627] = 138,
  [2628] = 2531,
  [2629] = 2629,
  [2630] = 2630,
  [2631] = 2610,
  [2632] = 2632,
  [2633] = 2633,
  [2634] = 2590,
  [2635] = 2550,
  [2636] = 2551,
  [2637] = 2534,
  [2638] = 2563,
  [2639] = 2547,
  [2640] = 2541,
  [2641] = 2546,
  [2642] = 2544,
  [2643] = 2544,
  [2644] = 2546,
  [2645] = 2547,
  [2646] = 2541,
  [2647] = 2531,
  [2648] = 2524,
  [2649] = 2649,
  [2650] = 2522,
  [2651] = 2519,
  [2652] = 2652,
  [2653] = 2502,
  [2654] = 2563,
  [2655] = 2501,
  [2656] = 2492,
  [2657] = 2657,
  [2658] = 2491,
  [2659] = 2611,
  [2660] = 2486,
  [2661] = 2661,
  [2662] = 2662,
  [2663] = 2663,
  [2664] = 2513,
  [2665] = 2514,
  [2666] = 2666,
  [2667] = 2575,
  [2668] = 2632,
  [2669] = 2576,
  [2670] = 2649,
  [2671] = 2671,
  [2672] = 2672,
  [2673] = 2551,
  [2674] = 2674,
  [2675] = 2532,
  [2676] = 2676,
  [2677] = 2677,
  [2678] = 2550,
  [2679] = 2679,
  [2680] = 2590,
  [2681] = 2681,
  [2682] = 2682,
  [2683] = 2683,
  [2684] = 2485,
  [2685] = 2685,
  [2686] = 2686,
  [2687] = 2611,
  [2688] = 2679,
  [2689] = 2591,
  [2690] = 2681,
  [2691] = 2503,
  [2692] = 2692,
  [2693] = 2527,
  [2694] = 2610,
  [2695] = 2555,
  [2696] = 2499,
  [2697] = 2510,
  [2698] = 2511,
  [2699] = 2699,
  [2700] = 2539,
  [2701] = 2553,
  [2702] = 2612,
  [2703] = 2703,
  [2704] = 2682,
  [2705] = 2487,
  [2706] = 2625,
  [2707] = 2683,
  [2708] = 2493,
  [2709] = 2495,
  [2710] = 2710,
  [2711] = 2619,
  [2712] = 2712,
  [2713] = 2676,
  [2714] = 2714,
  [2715] = 2715,
  [2716] = 2517,
  [2717] = 2652,
  [2718] = 2518,
  [2719] = 2714,
  [2720] = 2661,
  [2721] = 2591,
  [2722] = 2662,
  [2723] = 2723,
  [2724] = 2724,
  [2725] = 2074,
  [2726] = 2726,
  [2727] = 2727,
  [2728] = 2728,
  [2729] = 2729,
  [2730] = 2078,
  [2731] = 2731,
  [2732] = 2732,
  [2733] = 2733,
  [2734] = 2734,
  [2735] = 2735,
  [2736] = 2736,
  [2737] = 2737,
  [2738] = 2072,
  [2739] = 2073,
  [2740] = 2740,
  [2741] = 2741,
  [2742] = 2742,
  [2743] = 2743,
  [2744] = 2744,
  [2745] = 2116,
  [2746] = 2112,
  [2747] = 2107,
  [2748] = 2105,
  [2749] = 2749,
  [2750] = 2750,
  [2751] = 2751,
  [2752] = 2097,
  [2753] = 2089,
  [2754] = 2754,
  [2755] = 2755,
  [2756] = 2756,
  [2757] = 2757,
  [2758] = 2758,
  [2759] = 2759,
  [2760] = 2757,
  [2761] = 2761,
  [2762] = 2728,
  [2763] = 2763,
  [2764] = 2764,
  [2765] = 2765,
  [2766] = 2766,
  [2767] = 2744,
  [2768] = 2768,
  [2769] = 2769,
  [2770] = 2770,
  [2771] = 2771,
  [2772] = 2758,
  [2773] = 2773,
  [2774] = 2110,
  [2775] = 2115,
  [2776] = 2071,
  [2777] = 2777,
  [2778] = 2778,
  [2779] = 2779,
  [2780] = 2755,
  [2781] = 2111,
  [2782] = 2782,
  [2783] = 2783,
  [2784] = 2784,
  [2785] = 2785,
  [2786] = 2740,
  [2787] = 2787,
  [2788] = 2788,
  [2789] = 2789,
  [2790] = 2790,
  [2791] = 2791,
  [2792] = 2792,
  [2793] = 2793,
  [2794] = 2737,
  [2795] = 2113,
  [2796] = 2796,
  [2797] = 2797,
  [2798] = 2096,
  [2799] = 2095,
  [2800] = 2800,
  [2801] = 2801,
  [2802] = 2802,
  [2803] = 2803,
  [2804] = 2804,
  [2805] = 2805,
  [2806] = 2091,
  [2807] = 2807,
  [2808] = 2808,
  [2809] = 2793,
  [2810] = 2810,
  [2811] = 2090,
  [2812] = 2812,
  [2813] = 2813,
  [2814] = 2814,
  [2815] = 2815,
  [2816] = 2088,
  [2817] = 2087,
  [2818] = 2092,
  [2819] = 2813,
  [2820] = 2820,
  [2821] = 2098,
  [2822] = 2812,
  [2823] = 2106,
  [2824] = 2802,
  [2825] = 2109,
  [2826] = 2114,
  [2827] = 2827,
  [2828] = 2828,
  [2829] = 2829,
  [2830] = 2117,
  [2831] = 2104,
  [2832] = 2832,
  [2833] = 2783,
  [2834] = 2103,
  [2835] = 140,
  [2836] = 2836,
  [2837] = 2837,
  [2838] = 2732,
  [2839] = 2839,
  [2840] = 2119,
  [2841] = 2083,
  [2842] = 2842,
  [2843] = 2084,
  [2844] = 2085,
  [2845] = 2792,
  [2846] = 2086,
  [2847] = 2847,
  [2848] = 2848,
  [2849] = 2741,
  [2850] = 2791,
  [2851] = 2797,
  [2852] = 2852,
  [2853] = 2853,
  [2854] = 2854,
  [2855] = 2782,
  [2856] = 2777,
  [2857] = 2857,
  [2858] = 2768,
  [2859] = 2729,
  [2860] = 2860,
  [2861] = 2842,
  [2862] = 2805,
  [2863] = 2863,
  [2864] = 2803,
  [2865] = 2801,
  [2866] = 2866,
  [2867] = 2867,
  [2868] = 2868,
  [2869] = 2869,
  [2870] = 2870,
  [2871] = 2871,
  [2872] = 2872,
  [2873] = 2873,
  [2874] = 2874,
  [2875] = 2875,
  [2876] = 2876,
  [2877] = 2877,
  [2878] = 2878,
  [2879] = 2879,
  [2880] = 2880,
  [2881] = 2743,
  [2882] = 2882,
  [2883] = 2883,
  [2884] = 2884,
  [2885] = 2734,
  [2886] = 2886,
  [2887] = 2887,
  [2888] = 2866,
  [2889] = 2889,
  [2890] = 2854,
  [2891] = 2829,
  [2892] = 2892,
  [2893] = 2893,
  [2894] = 2894,
  [2895] = 2070,
  [2896] = 2896,
  [2897] = 2787,
  [2898] = 2785,
  [2899] = 2727,
  [2900] = 2733,
  [2901] = 2735,
  [2902] = 393,
  [2903] = 2903,
  [2904] = 2736,
  [2905] = 2905,
  [2906] = 2906,
  [2907] = 2907,
  [2908] = 2908,
  [2909] = 2751,
  [2910] = 2910,
  [2911] = 2911,
  [2912] = 2761,
  [2913] = 2723,
  [2914] = 2914,
  [2915] = 2768,
  [2916] = 2916,
  [2917] = 2917,
  [2918] = 2796,
  [2919] = 2878,
  [2920] = 2878,
  [2921] = 2921,
  [2922] = 2922,
  [2923] = 2923,
  [2924] = 2924,
  [2925] = 2785,
  [2926] = 2790,
  [2927] = 2785,
  [2928] = 2928,
  [2929] = 2847,
  [2930] = 2930,
  [2931] = 2931,
  [2932] = 2910,
  [2933] = 2933,
  [2934] = 2916,
  [2935] = 2887,
  [2936] = 2936,
  [2937] = 2937,
  [2938] = 2886,
  [2939] = 2939,
  [2940] = 2940,
  [2941] = 2941,
  [2942] = 2884,
  [2943] = 2871,
  [2944] = 2870,
  [2945] = 2945,
  [2946] = 2946,
  [2947] = 2947,
  [2948] = 2910,
  [2949] = 2731,
  [2950] = 2950,
  [2951] = 2951,
  [2952] = 2749,
  [2953] = 2953,
  [2954] = 2778,
  [2955] = 2778,
  [2956] = 2930,
  [2957] = 2773,
  [2958] = 2930,
  [2959] = 2959,
  [2960] = 2800,
  [2961] = 2961,
  [2962] = 2962,
  [2963] = 2963,
  [2964] = 2788,
  [2965] = 2965,
  [2966] = 2966,
  [2967] = 2967,
  [2968] = 2968,
  [2969] = 2969,
  [2970] = 2870,
  [2971] = 2871,
  [2972] = 2873,
  [2973] = 2973,
  [2974] = 2827,
  [2975] = 2878,
  [2976] = 2976,
  [2977] = 2916,
  [2978] = 2978,
  [2979] = 2979,
  [2980] = 2959,
  [2981] = 2962,
  [2982] = 2963,
  [2983] = 2983,
  [2984] = 2984,
  [2985] = 2985,
  [2986] = 2986,
  [2987] = 2968,
  [2988] = 2969,
  [2989] = 2933,
  [2990] = 2931,
  [2991] = 2991,
  [2992] = 2883,
  [2993] = 2893,
  [2994] = 2837,
  [2995] = 2892,
  [2996] = 2889,
  [2997] = 2973,
  [2998] = 2882,
  [2999] = 2999,
  [3000] = 3000,
  [3001] = 3001,
  [3002] = 2857,
  [3003] = 2853,
  [3004] = 3004,
  [3005] = 3005,
  [3006] = 2976,
  [3007] = 2876,
  [3008] = 2771,
  [3009] = 2887,
  [3010] = 2773,
  [3011] = 2785,
  [3012] = 3012,
  [3013] = 2894,
  [3014] = 2779,
  [3015] = 2884,
  [3016] = 3016,
  [3017] = 3017,
  [3018] = 2879,
  [3019] = 2877,
  [3020] = 2875,
  [3021] = 3021,
  [3022] = 3022,
  [3023] = 3023,
  [3024] = 3024,
  [3025] = 3025,
  [3026] = 3026,
  [3027] = 3027,
  [3028] = 3028,
  [3029] = 3029,
  [3030] = 3030,
  [3031] = 3031,
  [3032] = 3032,
  [3033] = 3033,
  [3034] = 3029,
  [3035] = 3035,
  [3036] = 3036,
  [3037] = 3037,
  [3038] = 3028,
  [3039] = 3039,
  [3040] = 3037,
  [3041] = 3041,
  [3042] = 3042,
  [3043] = 3039,
  [3044] = 3031,
  [3045] = 3045,
  [3046] = 3046,
  [3047] = 3037,
  [3048] = 3048,
  [3049] = 3049,
  [3050] = 3050,
  [3051] = 3051,
  [3052] = 3052,
  [3053] = 3053,
  [3054] = 3054,
  [3055] = 3055,
  [3056] = 1126,
  [3057] = 3057,
  [3058] = 3058,
  [3059] = 3022,
  [3060] = 3060,
  [3061] = 3061,
  [3062] = 3062,
  [3063] = 3050,
  [3064] = 1402,
  [3065] = 3065,
  [3066] = 3066,
  [3067] = 3067,
  [3068] = 3068,
  [3069] = 3055,
  [3070] = 3070,
  [3071] = 3071,
  [3072] = 3072,
  [3073] = 1227,
  [3074] = 3074,
  [3075] = 3041,
  [3076] = 3076,
  [3077] = 3066,
  [3078] = 3065,
  [3079] = 3039,
  [3080] = 1226,
  [3081] = 3029,
  [3082] = 3033,
  [3083] = 3083,
  [3084] = 3031,
  [3085] = 3085,
  [3086] = 3086,
  [3087] = 3087,
  [3088] = 3061,
  [3089] = 3026,
  [3090] = 3070,
  [3091] = 3086,
  [3092] = 3021,
  [3093] = 3093,
  [3094] = 3094,
  [3095] = 3095,
  [3096] = 3083,
  [3097] = 3097,
  [3098] = 3098,
  [3099] = 3099,
  [3100] = 3100,
  [3101] = 2815,
  [3102] = 3023,
  [3103] = 2814,
  [3104] = 3036,
  [3105] = 3105,
  [3106] = 3023,
  [3107] = 3027,
  [3108] = 3108,
  [3109] = 3109,
  [3110] = 3110,
  [3111] = 3111,
  [3112] = 3112,
  [3113] = 3113,
  [3114] = 3114,
  [3115] = 3086,
  [3116] = 3114,
  [3117] = 3021,
  [3118] = 3118,
  [3119] = 3068,
  [3120] = 3037,
  [3121] = 3121,
  [3122] = 3122,
  [3123] = 3067,
  [3124] = 3124,
  [3125] = 3076,
  [3126] = 3058,
  [3127] = 3127,
  [3128] = 3024,
  [3129] = 3051,
  [3130] = 3028,
  [3131] = 3131,
  [3132] = 3132,
  [3133] = 3057,
  [3134] = 3134,
  [3135] = 3135,
  [3136] = 3136,
  [3137] = 3137,
  [3138] = 3052,
  [3139] = 3139,
  [3140] = 3140,
  [3141] = 3141,
  [3142] = 3142,
  [3143] = 3143,
  [3144] = 3045,
  [3145] = 3145,
  [3146] = 3074,
  [3147] = 3147,
  [3148] = 3029,
  [3149] = 3054,
  [3150] = 3150,
  [3151] = 3151,
  [3152] = 3041,
  [3153] = 3052,
  [3154] = 3134,
  [3155] = 3155,
  [3156] = 3156,
  [3157] = 3157,
  [3158] = 3054,
  [3159] = 3114,
  [3160] = 3052,
  [3161] = 3161,
  [3162] = 3051,
  [3163] = 3163,
  [3164] = 3058,
  [3165] = 3121,
  [3166] = 3070,
  [3167] = 3167,
  [3168] = 3168,
  [3169] = 3169,
  [3170] = 3066,
  [3171] = 3094,
  [3172] = 3029,
  [3173] = 3029,
  [3174] = 3083,
  [3175] = 3085,
  [3176] = 3131,
  [3177] = 3177,
  [3178] = 3178,
  [3179] = 3093,
  [3180] = 3180,
  [3181] = 3161,
  [3182] = 3110,
  [3183] = 3167,
  [3184] = 3095,
  [3185] = 3185,
  [3186] = 3186,
  [3187] = 3147,
  [3188] = 3113,
  [3189] = 3097,
  [3190] = 3190,
  [3191] = 3039,
  [3192] = 3192,
  [3193] = 3041,
  [3194] = 3194,
  [3195] = 3085,
  [3196] = 3196,
  [3197] = 3197,
  [3198] = 3041,
  [3199] = 3197,
  [3200] = 3196,
  [3201] = 3201,
  [3202] = 1390,
  [3203] = 3083,
  [3204] = 3204,
  [3205] = 3052,
  [3206] = 3206,
  [3207] = 3070,
  [3208] = 3155,
  [3209] = 3163,
  [3210] = 3210,
  [3211] = 3029,
  [3212] = 3157,
  [3213] = 3083,
  [3214] = 3085,
  [3215] = 3215,
  [3216] = 3216,
  [3217] = 3143,
  [3218] = 3216,
  [3219] = 3219,
  [3220] = 3029,
  [3221] = 3140,
  [3222] = 3029,
  [3223] = 3194,
  [3224] = 3085,
  [3225] = 3192,
  [3226] = 3226,
  [3227] = 3035,
  [3228] = 3070,
  [3229] = 3135,
  [3230] = 3230,
  [3231] = 3032,
  [3232] = 3052,
  [3233] = 3233,
  [3234] = 3234,
  [3235] = 3029,
  [3236] = 3177,
  [3237] = 3083,
  [3238] = 3085,
  [3239] = 3239,
  [3240] = 3150,
  [3241] = 3127,
  [3242] = 3087,
  [3243] = 3169,
  [3244] = 3244,
  [3245] = 3178,
  [3246] = 3141,
  [3247] = 3110,
  [3248] = 3248,
  [3249] = 3086,
  [3250] = 3250,
  [3251] = 3190,
  [3252] = 3252,
  [3253] = 3052,
  [3254] = 3048,
  [3255] = 3029,
  [3256] = 3256,
  [3257] = 3083,
  [3258] = 3085,
  [3259] = 3074,
  [3260] = 3145,
  [3261] = 3185,
  [3262] = 3230,
  [3263] = 3065,
  [3264] = 3052,
  [3265] = 3029,
  [3266] = 3180,
  [3267] = 3083,
  [3268] = 3085,
  [3269] = 3248,
  [3270] = 3052,
  [3271] = 3226,
  [3272] = 3083,
  [3273] = 3085,
  [3274] = 3060,
  [3275] = 3052,
  [3276] = 3062,
  [3277] = 3083,
  [3278] = 3085,
  [3279] = 3142,
  [3280] = 3052,
  [3281] = 3093,
  [3282] = 3083,
  [3283] = 3085,
  [3284] = 3052,
  [3285] = 3083,
  [3286] = 3085,
  [3287] = 3066,
  [3288] = 3233,
  [3289] = 3289,
  [3290] = 3219,
  [3291] = 3072,
  [3292] = 3094,
  [3293] = 3250,
  [3294] = 3086,
  [3295] = 3151,
  [3296] = 3076,
  [3297] = 3054,
  [3298] = 3289,
  [3299] = 3113,
  [3300] = 3300,
  [3301] = 3301,
  [3302] = 3302,
  [3303] = 3301,
  [3304] = 3304,
  [3305] = 3305,
  [3306] = 3306,
  [3307] = 3307,
  [3308] = 3308,
  [3309] = 3309,
  [3310] = 3310,
  [3311] = 3311,
  [3312] = 3312,
  [3313] = 3313,
  [3314] = 3312,
  [3315] = 3315,
  [3316] = 3316,
  [3317] = 3317,
  [3318] = 3318,
  [3319] = 3319,
  [3320] = 3320,
  [3321] = 3321,
  [3322] = 3322,
  [3323] = 3323,
  [3324] = 3324,
  [3325] = 3325,
  [3326] = 3310,
  [3327] = 3309,
  [3328] = 3328,
  [3329] = 3329,
  [3330] = 3330,
  [3331] = 3331,
  [3332] = 3332,
  [3333] = 3333,
  [3334] = 3331,
  [3335] = 3306,
  [3336] = 3304,
  [3337] = 3302,
  [3338] = 3319,
  [3339] = 3339,
  [3340] = 3340,
  [3341] = 3333,
  [3342] = 3342,
  [3343] = 3343,
  [3344] = 3344,
  [3345] = 3345,
  [3346] = 3346,
  [3347] = 3347,
  [3348] = 3348,
  [3349] = 3349,
  [3350] = 3350,
  [3351] = 3351,
  [3352] = 3352,
  [3353] = 3353,
  [3354] = 3354,
  [3355] = 3355,
  [3356] = 3356,
  [3357] = 3357,
  [3358] = 3318,
  [3359] = 3359,
  [3360] = 3332,
  [3361] = 3361,
  [3362] = 3362,
  [3363] = 3363,
  [3364] = 3364,
  [3365] = 3365,
  [3366] = 3366,
  [3367] = 3347,
  [3368] = 3368,
  [3369] = 3369,
  [3370] = 141,
  [3371] = 3371,
  [3372] = 3372,
  [3373] = 3359,
  [3374] = 3339,
  [3375] = 3375,
  [3376] = 3376,
  [3377] = 3377,
  [3378] = 3349,
  [3379] = 3351,
  [3380] = 3317,
  [3381] = 3381,
  [3382] = 3382,
  [3383] = 3383,
  [3384] = 3384,
  [3385] = 3385,
  [3386] = 3386,
  [3387] = 3347,
  [3388] = 3388,
  [3389] = 3389,
  [3390] = 3390,
  [3391] = 3391,
  [3392] = 3392,
  [3393] = 3392,
  [3394] = 3350,
  [3395] = 3395,
  [3396] = 3396,
  [3397] = 3397,
  [3398] = 3398,
  [3399] = 3384,
  [3400] = 3400,
  [3401] = 3401,
  [3402] = 3350,
  [3403] = 3345,
  [3404] = 3323,
  [3405] = 3405,
  [3406] = 3406,
  [3407] = 3407,
  [3408] = 3408,
  [3409] = 3409,
  [3410] = 3351,
  [3411] = 3411,
  [3412] = 3353,
  [3413] = 3317,
  [3414] = 3414,
  [3415] = 3371,
  [3416] = 3321,
  [3417] = 3347,
  [3418] = 3418,
  [3419] = 3419,
  [3420] = 3382,
  [3421] = 3421,
  [3422] = 3422,
  [3423] = 3423,
  [3424] = 3424,
  [3425] = 3425,
  [3426] = 3425,
  [3427] = 3354,
  [3428] = 3343,
  [3429] = 3429,
  [3430] = 3362,
  [3431] = 3390,
  [3432] = 3432,
  [3433] = 3388,
  [3434] = 3315,
  [3435] = 3435,
  [3436] = 3436,
  [3437] = 3385,
  [3438] = 3438,
  [3439] = 3439,
  [3440] = 3317,
  [3441] = 3366,
  [3442] = 3392,
  [3443] = 3421,
  [3444] = 3356,
  [3445] = 3376,
  [3446] = 3418,
  [3447] = 3447,
  [3448] = 3350,
  [3449] = 3310,
  [3450] = 3386,
  [3451] = 3451,
  [3452] = 3439,
  [3453] = 3305,
  [3454] = 3307,
  [3455] = 3455,
  [3456] = 3456,
  [3457] = 3457,
  [3458] = 3315,
  [3459] = 3386,
  [3460] = 3460,
  [3461] = 3461,
  [3462] = 3321,
  [3463] = 3347,
  [3464] = 3323,
  [3465] = 3407,
  [3466] = 3439,
  [3467] = 3333,
  [3468] = 142,
  [3469] = 3469,
  [3470] = 3351,
  [3471] = 3346,
  [3472] = 3353,
  [3473] = 3354,
  [3474] = 3474,
  [3475] = 3356,
  [3476] = 3476,
  [3477] = 3477,
  [3478] = 3478,
  [3479] = 3479,
  [3480] = 3406,
  [3481] = 3481,
  [3482] = 3388,
  [3483] = 3483,
  [3484] = 3310,
  [3485] = 3485,
  [3486] = 3486,
  [3487] = 3317,
  [3488] = 3307,
  [3489] = 3469,
  [3490] = 3395,
  [3491] = 3315,
  [3492] = 3447,
  [3493] = 3493,
  [3494] = 3323,
  [3495] = 3495,
  [3496] = 3438,
  [3497] = 3353,
  [3498] = 3356,
  [3499] = 3307,
  [3500] = 3500,
  [3501] = 3501,
  [3502] = 3502,
  [3503] = 3310,
  [3504] = 3315,
  [3505] = 3505,
  [3506] = 3323,
  [3507] = 3305,
  [3508] = 3356,
  [3509] = 3310,
  [3510] = 3315,
  [3511] = 3323,
  [3512] = 3356,
  [3513] = 3315,
  [3514] = 3323,
  [3515] = 3356,
  [3516] = 3315,
  [3517] = 3315,
  [3518] = 3315,
  [3519] = 3315,
  [3520] = 3315,
  [3521] = 3521,
  [3522] = 3361,
  [3523] = 3390,
  [3524] = 3524,
  [3525] = 3486,
  [3526] = 3455,
  [3527] = 3372,
  [3528] = 3401,
  [3529] = 3398,
  [3530] = 3397,
  [3531] = 3531,
  [3532] = 3348,
  [3533] = 3533,
  [3534] = 3346,
  [3535] = 3365,
  [3536] = 3425,
  [3537] = 3537,
  [3538] = 3325,
  [3539] = 3461,
  [3540] = 3540,
  [3541] = 3541,
  [3542] = 3324,
  [3543] = 3392,
  [3544] = 3544,
  [3545] = 3544,
  [3546] = 3322,
  [3547] = 3414,
  [3548] = 3548,
  [3549] = 3383,
  [3550] = 3550,
  [3551] = 3407,
  [3552] = 3521,
  [3553] = 3485,
  [3554] = 3308,
  [3555] = 3391,
  [3556] = 3405,
  [3557] = 3550,
  [3558] = 3389,
  [3559] = 3476,
  [3560] = 3500,
  [3561] = 3425,
  [3562] = 3342,
  [3563] = 3424,
  [3564] = 3564,
  [3565] = 3565,
  [3566] = 3329,
  [3567] = 3357,
  [3568] = 3505,
  [3569] = 3486,
  [3570] = 3455,
  [3571] = 3401,
  [3572] = 3398,
  [3573] = 3347,
  [3574] = 3364,
  [3575] = 3486,
  [3576] = 3398,
  [3577] = 3435,
  [3578] = 3388,
  [3579] = 3398,
  [3580] = 3398,
  [3581] = 3398,
  [3582] = 3320,
  [3583] = 3501,
  [3584] = 3340,
  [3585] = 3363,
  [3586] = 3368,
  [3587] = 3587,
  [3588] = 3460,
  [3589] = 3451,
  [3590] = 3316,
  [3591] = 3493,
  [3592] = 3540,
  [3593] = 3313,
  [3594] = 3436,
  [3595] = 3595,
  [3596] = 3596,
  [3597] = 3597,
  [3598] = 3598,
  [3599] = 3599,
  [3600] = 3600,
  [3601] = 3601,
};

static inline bool sym_identifier_character_set_1(int32_t c) {
  return (c < 43514
    ? (c < 4193
      ? (c < 2707
        ? (c < 1994
          ? (c < 931
            ? (c < 748
              ? (c < 192
                ? (c < 170
                  ? (c < 'a'
                    ? (c >= 'A' && c <= '_')
                    : c <= 'z')
                  : (c <= 170 || (c < 186
                    ? c == 181
                    : c <= 186)))
                : (c <= 214 || (c < 710
                  ? (c < 248
                    ? (c >= 216 && c <= 246)
                    : c <= 705)
                  : (c <= 721 || (c >= 736 && c <= 740)))))
              : (c <= 748 || (c < 895
                ? (c < 886
                  ? (c < 880
                    ? c == 750
                    : c <= 884)
                  : (c <= 887 || (c >= 891 && c <= 893)))
                : (c <= 895 || (c < 908
                  ? (c < 904
                    ? c == 902
                    : c <= 906)
                  : (c <= 908 || (c >= 910 && c <= 929)))))))
            : (c <= 1013 || (c < 1649
              ? (c < 1376
                ? (c < 1329
                  ? (c < 1162
                    ? (c >= 1015 && c <= 1153)
                    : c <= 1327)
                  : (c <= 1366 || c == 1369))
                : (c <= 1416 || (c < 1568
                  ? (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)
                  : (c <= 1610 || (c >= 1646 && c <= 1647)))))
              : (c <= 1747 || (c < 1791
                ? (c < 1774
                  ? (c < 1765
                    ? c == 1749
                    : c <= 1766)
                  : (c <= 1775 || (c >= 1786 && c <= 1788)))
                : (c <= 1791 || (c < 1869
                  ? (c < 1810
                    ? c == 1808
                    : c <= 1839)
                  : (c <= 1957 || c == 1969))))))))
          : (c <= 2026 || (c < 2482
            ? (c < 2208
              ? (c < 2088
                ? (c < 2048
                  ? (c < 2042
                    ? (c >= 2036 && c <= 2037)
                    : c <= 2042)
                  : (c <= 2069 || (c < 2084
                    ? c == 2074
                    : c <= 2084)))
                : (c <= 2088 || (c < 2160
                  ? (c < 2144
                    ? (c >= 2112 && c <= 2136)
                    : c <= 2154)
                  : (c <= 2183 || (c >= 2185 && c <= 2190)))))
              : (c <= 2249 || (c < 2417
                ? (c < 2384
                  ? (c < 2365
                    ? (c >= 2308 && c <= 2361)
                    : c <= 2365)
                  : (c <= 2384 || (c >= 2392 && c <= 2401)))
                : (c <= 2432 || (c < 2451
                  ? (c < 2447
                    ? (c >= 2437 && c <= 2444)
                    : c <= 2448)
                  : (c <= 2472 || (c >= 2474 && c <= 2480)))))))
            : (c <= 2482 || (c < 2579
              ? (c < 2527
                ? (c < 2510
                  ? (c < 2493
                    ? (c >= 2486 && c <= 2489)
                    : c <= 2493)
                  : (c <= 2510 || (c >= 2524 && c <= 2525)))
                : (c <= 2529 || (c < 2565
                  ? (c < 2556
                    ? (c >= 2544 && c <= 2545)
                    : c <= 2556)
                  : (c <= 2570 || (c >= 2575 && c <= 2576)))))
              : (c <= 2600 || (c < 2649
                ? (c < 2613
                  ? (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)
                  : (c <= 2614 || (c >= 2616 && c <= 2617)))
                : (c <= 2652 || (c < 2693
                  ? (c < 2674
                    ? c == 2654
                    : c <= 2676)
                  : (c <= 2701 || (c >= 2703 && c <= 2705)))))))))))
        : (c <= 2728 || (c < 3242
          ? (c < 2962
            ? (c < 2858
              ? (c < 2784
                ? (c < 2741
                  ? (c < 2738
                    ? (c >= 2730 && c <= 2736)
                    : c <= 2739)
                  : (c <= 2745 || (c < 2768
                    ? c == 2749
                    : c <= 2768)))
                : (c <= 2785 || (c < 2831
                  ? (c < 2821
                    ? c == 2809
                    : c <= 2828)
                  : (c <= 2832 || (c >= 2835 && c <= 2856)))))
              : (c <= 2864 || (c < 2911
                ? (c < 2877
                  ? (c < 2869
                    ? (c >= 2866 && c <= 2867)
                    : c <= 2873)
                  : (c <= 2877 || (c >= 2908 && c <= 2909)))
                : (c <= 2913 || (c < 2949
                  ? (c < 2947
                    ? c == 2929
                    : c <= 2947)
                  : (c <= 2954 || (c >= 2958 && c <= 2960)))))))
            : (c <= 2965 || (c < 3090
              ? (c < 2984
                ? (c < 2974
                  ? (c < 2972
                    ? (c >= 2969 && c <= 2970)
                    : c <= 2972)
                  : (c <= 2975 || (c >= 2979 && c <= 2980)))
                : (c <= 2986 || (c < 3077
                  ? (c < 3024
                    ? (c >= 2990 && c <= 3001)
                    : c <= 3024)
                  : (c <= 3084 || (c >= 3086 && c <= 3088)))))
              : (c <= 3112 || (c < 3168
                ? (c < 3160
                  ? (c < 3133
                    ? (c >= 3114 && c <= 3129)
                    : c <= 3133)
                  : (c <= 3162 || c == 3165))
                : (c <= 3169 || (c < 3214
                  ? (c < 3205
                    ? c == 3200
                    : c <= 3212)
                  : (c <= 3216 || (c >= 3218 && c <= 3240)))))))))
          : (c <= 3251 || (c < 3648
            ? (c < 3412
              ? (c < 3332
                ? (c < 3293
                  ? (c < 3261
                    ? (c >= 3253 && c <= 3257)
                    : c <= 3261)
                  : (c <= 3294 || (c < 3313
                    ? (c >= 3296 && c <= 3297)
                    : c <= 3314)))
                : (c <= 3340 || (c < 3389
                  ? (c < 3346
                    ? (c >= 3342 && c <= 3344)
                    : c <= 3386)
                  : (c <= 3389 || c == 3406))))
              : (c <= 3414 || (c < 3507
                ? (c < 3461
                  ? (c < 3450
                    ? (c >= 3423 && c <= 3425)
                    : c <= 3455)
                  : (c <= 3478 || (c >= 3482 && c <= 3505)))
                : (c <= 3515 || (c < 3585
                  ? (c < 3520
                    ? c == 3517
                    : c <= 3526)
                  : (c <= 3632 || c == 3634))))))
            : (c <= 3654 || (c < 3782
              ? (c < 3749
                ? (c < 3718
                  ? (c < 3716
                    ? (c >= 3713 && c <= 3714)
                    : c <= 3716)
                  : (c <= 3722 || (c >= 3724 && c <= 3747)))
                : (c <= 3749 || (c < 3773
                  ? (c < 3762
                    ? (c >= 3751 && c <= 3760)
                    : c <= 3762)
                  : (c <= 3773 || (c >= 3776 && c <= 3780)))))
              : (c <= 3782 || (c < 3976
                ? (c < 3904
                  ? (c < 3840
                    ? (c >= 3804 && c <= 3807)
                    : c <= 3840)
                  : (c <= 3911 || (c >= 3913 && c <= 3948)))
                : (c <= 3980 || (c < 4176
                  ? (c < 4159
                    ? (c >= 4096 && c <= 4138)
                    : c <= 4159)
                  : (c <= 4181 || (c >= 4186 && c <= 4189)))))))))))))
      : (c <= 4193 || (c < 8134
        ? (c < 6176
          ? (c < 4808
            ? (c < 4688
              ? (c < 4295
                ? (c < 4213
                  ? (c < 4206
                    ? (c >= 4197 && c <= 4198)
                    : c <= 4208)
                  : (c <= 4225 || (c < 4256
                    ? c == 4238
                    : c <= 4293)))
                : (c <= 4295 || (c < 4348
                  ? (c < 4304
                    ? c == 4301
                    : c <= 4346)
                  : (c <= 4680 || (c >= 4682 && c <= 4685)))))
              : (c <= 4694 || (c < 4752
                ? (c < 4704
                  ? (c < 4698
                    ? c == 4696
                    : c <= 4701)
                  : (c <= 4744 || (c >= 4746 && c <= 4749)))
                : (c <= 4784 || (c < 4800
                  ? (c < 4792
                    ? (c >= 4786 && c <= 4789)
                    : c <= 4798)
                  : (c <= 4800 || (c >= 4802 && c <= 4805)))))))
            : (c <= 4822 || (c < 5792
              ? (c < 5024
                ? (c < 4888
                  ? (c < 4882
                    ? (c >= 4824 && c <= 4880)
                    : c <= 4885)
                  : (c <= 4954 || (c >= 4992 && c <= 5007)))
                : (c <= 5109 || (c < 5743
                  ? (c < 5121
                    ? (c >= 5112 && c <= 5117)
                    : c <= 5740)
                  : (c <= 5759 || (c >= 5761 && c <= 5786)))))
              : (c <= 5866 || (c < 5984
                ? (c < 5919
                  ? (c < 5888
                    ? (c >= 5870 && c <= 5880)
                    : c <= 5905)
                  : (c <= 5937 || (c >= 5952 && c <= 5969)))
                : (c <= 5996 || (c < 6103
                  ? (c < 6016
                    ? (c >= 5998 && c <= 6000)
                    : c <= 6067)
                  : (c <= 6103 || c == 6108))))))))
          : (c <= 6264 || (c < 7312
            ? (c < 6823
              ? (c < 6512
                ? (c < 6320
                  ? (c < 6314
                    ? (c >= 6272 && c <= 6312)
                    : c <= 6314)
                  : (c <= 6389 || (c < 6480
                    ? (c >= 6400 && c <= 6430)
                    : c <= 6509)))
                : (c <= 6516 || (c < 6656
                  ? (c < 6576
                    ? (c >= 6528 && c <= 6571)
                    : c <= 6601)
                  : (c <= 6678 || (c >= 6688 && c <= 6740)))))
              : (c <= 6823 || (c < 7098
                ? (c < 7043
                  ? (c < 6981
                    ? (c >= 6917 && c <= 6963)
                    : c <= 6988)
                  : (c <= 7072 || (c >= 7086 && c <= 7087)))
                : (c <= 7141 || (c < 7258
                  ? (c < 7245
                    ? (c >= 7168 && c <= 7203)
                    : c <= 7247)
                  : (c <= 7293 || (c >= 7296 && c <= 7304)))))))
            : (c <= 7354 || (c < 8008
              ? (c < 7418
                ? (c < 7406
                  ? (c < 7401
                    ? (c >= 7357 && c <= 7359)
                    : c <= 7404)
                  : (c <= 7411 || (c >= 7413 && c <= 7414)))
                : (c <= 7418 || (c < 7960
                  ? (c < 7680
                    ? (c >= 7424 && c <= 7615)
                    : c <= 7957)
                  : (c <= 7965 || (c >= 7968 && c <= 8005)))))
              : (c <= 8013 || (c < 8031
                ? (c < 8027
                  ? (c < 8025
                    ? (c >= 8016 && c <= 8023)
                    : c <= 8025)
                  : (c <= 8027 || c == 8029))
                : (c <= 8061 || (c < 8126
                  ? (c < 8118
                    ? (c >= 8064 && c <= 8116)
                    : c <= 8124)
                  : (c <= 8126 || (c >= 8130 && c <= 8132)))))))))))
        : (c <= 8140 || (c < 12337
          ? (c < 8544
            ? (c < 8458
              ? (c < 8305
                ? (c < 8160
                  ? (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)
                  : (c <= 8172 || (c < 8182
                    ? (c >= 8178 && c <= 8180)
                    : c <= 8188)))
                : (c <= 8305 || (c < 8450
                  ? (c < 8336
                    ? c == 8319
                    : c <= 8348)
                  : (c <= 8450 || c == 8455))))
              : (c <= 8467 || (c < 8488
                ? (c < 8484
                  ? (c < 8472
                    ? c == 8469
                    : c <= 8477)
                  : (c <= 8484 || c == 8486))
                : (c <= 8488 || (c < 8517
                  ? (c < 8508
                    ? (c >= 8490 && c <= 8505)
                    : c <= 8511)
                  : (c <= 8521 || c == 8526))))))
            : (c <= 8584 || (c < 11680
              ? (c < 11559
                ? (c < 11506
                  ? (c < 11499
                    ? (c >= 11264 && c <= 11492)
                    : c <= 11502)
                  : (c <= 11507 || (c >= 11520 && c <= 11557)))
                : (c <= 11559 || (c < 11631
                  ? (c < 11568
                    ? c == 11565
                    : c <= 11623)
                  : (c <= 11631 || (c >= 11648 && c <= 11670)))))
              : (c <= 11686 || (c < 11720
                ? (c < 11704
                  ? (c < 11696
                    ? (c >= 11688 && c <= 11694)
                    : c <= 11702)
                  : (c <= 11710 || (c >= 11712 && c <= 11718)))
                : (c <= 11726 || (c < 12293
                  ? (c < 11736
                    ? (c >= 11728 && c <= 11734)
                    : c <= 11742)
                  : (c <= 12295 || (c >= 12321 && c <= 12329)))))))))
          : (c <= 12341 || (c < 42891
            ? (c < 19968
              ? (c < 12549
                ? (c < 12445
                  ? (c < 12353
                    ? (c >= 12344 && c <= 12348)
                    : c <= 12438)
                  : (c <= 12447 || (c < 12540
                    ? (c >= 12449 && c <= 12538)
                    : c <= 12543)))
                : (c <= 12591 || (c < 12784
                  ? (c < 12704
                    ? (c >= 12593 && c <= 12686)
                    : c <= 12735)
                  : (c <= 12799 || (c >= 13312 && c <= 19903)))))
              : (c <= 42124 || (c < 42560
                ? (c < 42512
                  ? (c < 42240
                    ? (c >= 42192 && c <= 42237)
                    : c <= 42508)
                  : (c <= 42527 || (c >= 42538 && c <= 42539)))
                : (c <= 42606 || (c < 42775
                  ? (c < 42656
                    ? (c >= 42623 && c <= 42653)
                    : c <= 42735)
                  : (c <= 42783 || (c >= 42786 && c <= 42888)))))))
            : (c <= 42954 || (c < 43250
              ? (c < 43011
                ? (c < 42965
                  ? (c < 42963
                    ? (c >= 42960 && c <= 42961)
                    : c <= 42963)
                  : (c <= 42969 || (c >= 42994 && c <= 43009)))
                : (c <= 43013 || (c < 43072
                  ? (c < 43020
                    ? (c >= 43015 && c <= 43018)
                    : c <= 43042)
                  : (c <= 43123 || (c >= 43138 && c <= 43187)))))
              : (c <= 43255 || (c < 43360
                ? (c < 43274
                  ? (c < 43261
                    ? c == 43259
                    : c <= 43262)
                  : (c <= 43301 || (c >= 43312 && c <= 43334)))
                : (c <= 43388 || (c < 43488
                  ? (c < 43471
                    ? (c >= 43396 && c <= 43442)
                    : c <= 43471)
                  : (c <= 43492 || (c >= 43494 && c <= 43503)))))))))))))))
    : (c <= 43518 || (c < 70727
      ? (c < 66956
        ? (c < 64914
          ? (c < 43868
            ? (c < 43714
              ? (c < 43646
                ? (c < 43588
                  ? (c < 43584
                    ? (c >= 43520 && c <= 43560)
                    : c <= 43586)
                  : (c <= 43595 || (c < 43642
                    ? (c >= 43616 && c <= 43638)
                    : c <= 43642)))
                : (c <= 43695 || (c < 43705
                  ? (c < 43701
                    ? c == 43697
                    : c <= 43702)
                  : (c <= 43709 || c == 43712))))
              : (c <= 43714 || (c < 43785
                ? (c < 43762
                  ? (c < 43744
                    ? (c >= 43739 && c <= 43741)
                    : c <= 43754)
                  : (c <= 43764 || (c >= 43777 && c <= 43782)))
                : (c <= 43790 || (c < 43816
                  ? (c < 43808
                    ? (c >= 43793 && c <= 43798)
                    : c <= 43814)
                  : (c <= 43822 || (c >= 43824 && c <= 43866)))))))
            : (c <= 43881 || (c < 64287
              ? (c < 63744
                ? (c < 55216
                  ? (c < 44032
                    ? (c >= 43888 && c <= 44002)
                    : c <= 55203)
                  : (c <= 55238 || (c >= 55243 && c <= 55291)))
                : (c <= 64109 || (c < 64275
                  ? (c < 64256
                    ? (c >= 64112 && c <= 64217)
                    : c <= 64262)
                  : (c <= 64279 || c == 64285))))
              : (c <= 64296 || (c < 64323
                ? (c < 64318
                  ? (c < 64312
                    ? (c >= 64298 && c <= 64310)
                    : c <= 64316)
                  : (c <= 64318 || (c >= 64320 && c <= 64321)))
                : (c <= 64324 || (c < 64612
                  ? (c < 64467
                    ? (c >= 64326 && c <= 64433)
                    : c <= 64605)
                  : (c <= 64829 || (c >= 64848 && c <= 64911)))))))))
          : (c <= 64967 || (c < 65599
            ? (c < 65382
              ? (c < 65147
                ? (c < 65139
                  ? (c < 65137
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65137)
                  : (c <= 65139 || (c < 65145
                    ? c == 65143
                    : c <= 65145)))
                : (c <= 65147 || (c < 65313
                  ? (c < 65151
                    ? c == 65149
                    : c <= 65276)
                  : (c <= 65338 || (c >= 65345 && c <= 65370)))))
              : (c <= 65437 || (c < 65498
                ? (c < 65482
                  ? (c < 65474
                    ? (c >= 65440 && c <= 65470)
                    : c <= 65479)
                  : (c <= 65487 || (c >= 65490 && c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c >= 65596 && c <= 65597)))))))
            : (c <= 65613 || (c < 66464
              ? (c < 66208
                ? (c < 65856
                  ? (c < 65664
                    ? (c >= 65616 && c <= 65629)
                    : c <= 65786)
                  : (c <= 65908 || (c >= 66176 && c <= 66204)))
                : (c <= 66256 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66421 || (c >= 66432 && c <= 66461)))))
              : (c <= 66499 || (c < 66776
                ? (c < 66560
                  ? (c < 66513
                    ? (c >= 66504 && c <= 66511)
                    : c <= 66517)
                  : (c <= 66717 || (c >= 66736 && c <= 66771)))
                : (c <= 66811 || (c < 66928
                  ? (c < 66864
                    ? (c >= 66816 && c <= 66855)
                    : c <= 66915)
                  : (c <= 66938 || (c >= 66940 && c <= 66954)))))))))))
        : (c <= 66962 || (c < 68864
          ? (c < 67828
            ? (c < 67506
              ? (c < 67072
                ? (c < 66979
                  ? (c < 66967
                    ? (c >= 66964 && c <= 66965)
                    : c <= 66977)
                  : (c <= 66993 || (c < 67003
                    ? (c >= 66995 && c <= 67001)
                    : c <= 67004)))
                : (c <= 67382 || (c < 67456
                  ? (c < 67424
                    ? (c >= 67392 && c <= 67413)
                    : c <= 67431)
                  : (c <= 67461 || (c >= 67463 && c <= 67504)))))
              : (c <= 67514 || (c < 67644
                ? (c < 67594
                  ? (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)
                  : (c <= 67637 || (c >= 67639 && c <= 67640)))
                : (c <= 67644 || (c < 67712
                  ? (c < 67680
                    ? (c >= 67647 && c <= 67669)
                    : c <= 67702)
                  : (c <= 67742 || (c >= 67808 && c <= 67826)))))))
            : (c <= 67829 || (c < 68224
              ? (c < 68096
                ? (c < 67968
                  ? (c < 67872
                    ? (c >= 67840 && c <= 67861)
                    : c <= 67897)
                  : (c <= 68023 || (c >= 68030 && c <= 68031)))
                : (c <= 68096 || (c < 68121
                  ? (c < 68117
                    ? (c >= 68112 && c <= 68115)
                    : c <= 68119)
                  : (c <= 68149 || (c >= 68192 && c <= 68220)))))
              : (c <= 68252 || (c < 68448
                ? (c < 68352
                  ? (c < 68297
                    ? (c >= 68288 && c <= 68295)
                    : c <= 68324)
                  : (c <= 68405 || (c >= 68416 && c <= 68437)))
                : (c <= 68466 || (c < 68736
                  ? (c < 68608
                    ? (c >= 68480 && c <= 68497)
                    : c <= 68680)
                  : (c <= 68786 || (c >= 68800 && c <= 68850)))))))))
          : (c <= 68899 || (c < 70106
            ? (c < 69749
              ? (c < 69488
                ? (c < 69376
                  ? (c < 69296
                    ? (c >= 69248 && c <= 69289)
                    : c <= 69297)
                  : (c <= 69404 || (c < 69424
                    ? c == 69415
                    : c <= 69445)))
                : (c <= 69505 || (c < 69635
                  ? (c < 69600
                    ? (c >= 69552 && c <= 69572)
                    : c <= 69622)
                  : (c <= 69687 || (c >= 69745 && c <= 69746)))))
              : (c <= 69749 || (c < 69959
                ? (c < 69891
                  ? (c < 69840
                    ? (c >= 69763 && c <= 69807)
                    : c <= 69864)
                  : (c <= 69926 || c == 69956))
                : (c <= 69959 || (c < 70019
                  ? (c < 70006
                    ? (c >= 69968 && c <= 70002)
                    : c <= 70006)
                  : (c <= 70066 || (c >= 70081 && c <= 70084)))))))
            : (c <= 70106 || (c < 70405
              ? (c < 70280
                ? (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70187 || (c >= 70272 && c <= 70278)))
                : (c <= 70280 || (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c >= 70320 && c <= 70366)))))
              : (c <= 70412 || (c < 70453
                ? (c < 70442
                  ? (c < 70419
                    ? (c >= 70415 && c <= 70416)
                    : c <= 70440)
                  : (c <= 70448 || (c >= 70450 && c <= 70451)))
                : (c <= 70457 || (c < 70493
                  ? (c < 70480
                    ? c == 70461
                    : c <= 70480)
                  : (c <= 70497 || (c >= 70656 && c <= 70708)))))))))))))
      : (c <= 70730 || (c < 119894
        ? (c < 73056
          ? (c < 72001
            ? (c < 71424
              ? (c < 71128
                ? (c < 70852
                  ? (c < 70784
                    ? (c >= 70751 && c <= 70753)
                    : c <= 70831)
                  : (c <= 70853 || (c < 71040
                    ? c == 70855
                    : c <= 71086)))
                : (c <= 71131 || (c < 71296
                  ? (c < 71236
                    ? (c >= 71168 && c <= 71215)
                    : c <= 71236)
                  : (c <= 71338 || c == 71352))))
              : (c <= 71450 || (c < 71945
                ? (c < 71840
                  ? (c < 71680
                    ? (c >= 71488 && c <= 71494)
                    : c <= 71723)
                  : (c <= 71903 || (c >= 71935 && c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71983 || c == 71999))))))
            : (c <= 72001 || (c < 72349
              ? (c < 72192
                ? (c < 72161
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72144)
                  : (c <= 72161 || c == 72163))
                : (c <= 72192 || (c < 72272
                  ? (c < 72250
                    ? (c >= 72203 && c <= 72242)
                    : c <= 72250)
                  : (c <= 72272 || (c >= 72284 && c <= 72329)))))
              : (c <= 72349 || (c < 72818
                ? (c < 72714
                  ? (c < 72704
                    ? (c >= 72368 && c <= 72440)
                    : c <= 72712)
                  : (c <= 72750 || c == 72768))
                : (c <= 72847 || (c < 72971
                  ? (c < 72968
                    ? (c >= 72960 && c <= 72966)
                    : c <= 72969)
                  : (c <= 73008 || c == 73030))))))))
          : (c <= 73061 || (c < 93952
            ? (c < 82944
              ? (c < 73728
                ? (c < 73112
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73097)
                  : (c <= 73112 || (c < 73648
                    ? (c >= 73440 && c <= 73458)
                    : c <= 73648)))
                : (c <= 74649 || (c < 77712
                  ? (c < 74880
                    ? (c >= 74752 && c <= 74862)
                    : c <= 75075)
                  : (c <= 77808 || (c >= 77824 && c <= 78894)))))
              : (c <= 83526 || (c < 92928
                ? (c < 92784
                  ? (c < 92736
                    ? (c >= 92160 && c <= 92728)
                    : c <= 92766)
                  : (c <= 92862 || (c >= 92880 && c <= 92909)))
                : (c <= 92975 || (c < 93053
                  ? (c < 93027
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93047)
                  : (c <= 93071 || (c >= 93760 && c <= 93823)))))))
            : (c <= 94026 || (c < 110589
              ? (c < 94208
                ? (c < 94176
                  ? (c < 94099
                    ? c == 94032
                    : c <= 94111)
                  : (c <= 94177 || c == 94179))
                : (c <= 100343 || (c < 110576
                  ? (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)
                  : (c <= 110579 || (c >= 110581 && c <= 110587)))))
              : (c <= 110590 || (c < 113664
                ? (c < 110948
                  ? (c < 110928
                    ? (c >= 110592 && c <= 110882)
                    : c <= 110930)
                  : (c <= 110951 || (c >= 110960 && c <= 111355)))
                : (c <= 113770 || (c < 113808
                  ? (c < 113792
                    ? (c >= 113776 && c <= 113788)
                    : c <= 113800)
                  : (c <= 113817 || (c >= 119808 && c <= 119892)))))))))))
        : (c <= 119964 || (c < 125259
          ? (c < 120572
            ? (c < 120086
              ? (c < 119995
                ? (c < 119973
                  ? (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)
                  : (c <= 119974 || (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)))
                : (c <= 119995 || (c < 120071
                  ? (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)
                  : (c <= 120074 || (c >= 120077 && c <= 120084)))))
              : (c <= 120092 || (c < 120138
                ? (c < 120128
                  ? (c < 120123
                    ? (c >= 120094 && c <= 120121)
                    : c <= 120126)
                  : (c <= 120132 || c == 120134))
                : (c <= 120144 || (c < 120514
                  ? (c < 120488
                    ? (c >= 120146 && c <= 120485)
                    : c <= 120512)
                  : (c <= 120538 || (c >= 120540 && c <= 120570)))))))
            : (c <= 120596 || (c < 123191
              ? (c < 120714
                ? (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c >= 120688 && c <= 120712)))
                : (c <= 120744 || (c < 122624
                  ? (c < 120772
                    ? (c >= 120746 && c <= 120770)
                    : c <= 120779)
                  : (c <= 122654 || (c >= 123136 && c <= 123180)))))
              : (c <= 123197 || (c < 124904
                ? (c < 123584
                  ? (c < 123536
                    ? c == 123214
                    : c <= 123565)
                  : (c <= 123627 || (c >= 124896 && c <= 124902)))
                : (c <= 124907 || (c < 124928
                  ? (c < 124912
                    ? (c >= 124909 && c <= 124910)
                    : c <= 124926)
                  : (c <= 125124 || (c >= 125184 && c <= 125251)))))))))
          : (c <= 125259 || (c < 126559
            ? (c < 126535
              ? (c < 126505
                ? (c < 126497
                  ? (c < 126469
                    ? (c >= 126464 && c <= 126467)
                    : c <= 126495)
                  : (c <= 126498 || (c < 126503
                    ? c == 126500
                    : c <= 126503)))
                : (c <= 126514 || (c < 126523
                  ? (c < 126521
                    ? (c >= 126516 && c <= 126519)
                    : c <= 126521)
                  : (c <= 126523 || c == 126530))))
              : (c <= 126535 || (c < 126548
                ? (c < 126541
                  ? (c < 126539
                    ? c == 126537
                    : c <= 126539)
                  : (c <= 126543 || (c >= 126545 && c <= 126546)))
                : (c <= 126548 || (c < 126555
                  ? (c < 126553
                    ? c == 126551
                    : c <= 126553)
                  : (c <= 126555 || c == 126557))))))
            : (c <= 126559 || (c < 126625
              ? (c < 126580
                ? (c < 126567
                  ? (c < 126564
                    ? (c >= 126561 && c <= 126562)
                    : c <= 126564)
                  : (c <= 126570 || (c >= 126572 && c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c >= 126603 && c <= 126619)))))
              : (c <= 126627 || (c < 177984
                ? (c < 131072
                  ? (c < 126635
                    ? (c >= 126629 && c <= 126633)
                    : c <= 126651)
                  : (c <= 173791 || (c >= 173824 && c <= 177976)))
                : (c <= 178205 || (c < 194560
                  ? (c < 183984
                    ? (c >= 178208 && c <= 183969)
                    : c <= 191456)
                  : (c <= 195101 || (c >= 196608 && c <= 201546)))))))))))))))));
}

static inline bool sym_identifier_character_set_2(int32_t c) {
  return (c < 43514
    ? (c < 4193
      ? (c < 2707
        ? (c < 1994
          ? (c < 910
            ? (c < 736
              ? (c < 186
                ? (c < 'a'
                  ? (c < '_'
                    ? (c >= 'A' && c <= 'Z')
                    : c <= '_')
                  : (c <= 'z' || (c < 181
                    ? c == 170
                    : c <= 181)))
                : (c <= 186 || (c < 248
                  ? (c < 216
                    ? (c >= 192 && c <= 214)
                    : c <= 246)
                  : (c <= 705 || (c >= 710 && c <= 721)))))
              : (c <= 740 || (c < 891
                ? (c < 880
                  ? (c < 750
                    ? c == 748
                    : c <= 750)
                  : (c <= 884 || (c >= 886 && c <= 887)))
                : (c <= 893 || (c < 904
                  ? (c < 902
                    ? c == 895
                    : c <= 902)
                  : (c <= 906 || c == 908))))))
            : (c <= 929 || (c < 1649
              ? (c < 1376
                ? (c < 1162
                  ? (c < 1015
                    ? (c >= 931 && c <= 1013)
                    : c <= 1153)
                  : (c <= 1327 || (c < 1369
                    ? (c >= 1329 && c <= 1366)
                    : c <= 1369)))
                : (c <= 1416 || (c < 1568
                  ? (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)
                  : (c <= 1610 || (c >= 1646 && c <= 1647)))))
              : (c <= 1747 || (c < 1791
                ? (c < 1774
                  ? (c < 1765
                    ? c == 1749
                    : c <= 1766)
                  : (c <= 1775 || (c >= 1786 && c <= 1788)))
                : (c <= 1791 || (c < 1869
                  ? (c < 1810
                    ? c == 1808
                    : c <= 1839)
                  : (c <= 1957 || c == 1969))))))))
          : (c <= 2026 || (c < 2482
            ? (c < 2208
              ? (c < 2088
                ? (c < 2048
                  ? (c < 2042
                    ? (c >= 2036 && c <= 2037)
                    : c <= 2042)
                  : (c <= 2069 || (c < 2084
                    ? c == 2074
                    : c <= 2084)))
                : (c <= 2088 || (c < 2160
                  ? (c < 2144
                    ? (c >= 2112 && c <= 2136)
                    : c <= 2154)
                  : (c <= 2183 || (c >= 2185 && c <= 2190)))))
              : (c <= 2249 || (c < 2417
                ? (c < 2384
                  ? (c < 2365
                    ? (c >= 2308 && c <= 2361)
                    : c <= 2365)
                  : (c <= 2384 || (c >= 2392 && c <= 2401)))
                : (c <= 2432 || (c < 2451
                  ? (c < 2447
                    ? (c >= 2437 && c <= 2444)
                    : c <= 2448)
                  : (c <= 2472 || (c >= 2474 && c <= 2480)))))))
            : (c <= 2482 || (c < 2579
              ? (c < 2527
                ? (c < 2510
                  ? (c < 2493
                    ? (c >= 2486 && c <= 2489)
                    : c <= 2493)
                  : (c <= 2510 || (c >= 2524 && c <= 2525)))
                : (c <= 2529 || (c < 2565
                  ? (c < 2556
                    ? (c >= 2544 && c <= 2545)
                    : c <= 2556)
                  : (c <= 2570 || (c >= 2575 && c <= 2576)))))
              : (c <= 2600 || (c < 2649
                ? (c < 2613
                  ? (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)
                  : (c <= 2614 || (c >= 2616 && c <= 2617)))
                : (c <= 2652 || (c < 2693
                  ? (c < 2674
                    ? c == 2654
                    : c <= 2676)
                  : (c <= 2701 || (c >= 2703 && c <= 2705)))))))))))
        : (c <= 2728 || (c < 3242
          ? (c < 2962
            ? (c < 2858
              ? (c < 2784
                ? (c < 2741
                  ? (c < 2738
                    ? (c >= 2730 && c <= 2736)
                    : c <= 2739)
                  : (c <= 2745 || (c < 2768
                    ? c == 2749
                    : c <= 2768)))
                : (c <= 2785 || (c < 2831
                  ? (c < 2821
                    ? c == 2809
                    : c <= 2828)
                  : (c <= 2832 || (c >= 2835 && c <= 2856)))))
              : (c <= 2864 || (c < 2911
                ? (c < 2877
                  ? (c < 2869
                    ? (c >= 2866 && c <= 2867)
                    : c <= 2873)
                  : (c <= 2877 || (c >= 2908 && c <= 2909)))
                : (c <= 2913 || (c < 2949
                  ? (c < 2947
                    ? c == 2929
                    : c <= 2947)
                  : (c <= 2954 || (c >= 2958 && c <= 2960)))))))
            : (c <= 2965 || (c < 3090
              ? (c < 2984
                ? (c < 2974
                  ? (c < 2972
                    ? (c >= 2969 && c <= 2970)
                    : c <= 2972)
                  : (c <= 2975 || (c >= 2979 && c <= 2980)))
                : (c <= 2986 || (c < 3077
                  ? (c < 3024
                    ? (c >= 2990 && c <= 3001)
                    : c <= 3024)
                  : (c <= 3084 || (c >= 3086 && c <= 3088)))))
              : (c <= 3112 || (c < 3168
                ? (c < 3160
                  ? (c < 3133
                    ? (c >= 3114 && c <= 3129)
                    : c <= 3133)
                  : (c <= 3162 || c == 3165))
                : (c <= 3169 || (c < 3214
                  ? (c < 3205
                    ? c == 3200
                    : c <= 3212)
                  : (c <= 3216 || (c >= 3218 && c <= 3240)))))))))
          : (c <= 3251 || (c < 3648
            ? (c < 3412
              ? (c < 3332
                ? (c < 3293
                  ? (c < 3261
                    ? (c >= 3253 && c <= 3257)
                    : c <= 3261)
                  : (c <= 3294 || (c < 3313
                    ? (c >= 3296 && c <= 3297)
                    : c <= 3314)))
                : (c <= 3340 || (c < 3389
                  ? (c < 3346
                    ? (c >= 3342 && c <= 3344)
                    : c <= 3386)
                  : (c <= 3389 || c == 3406))))
              : (c <= 3414 || (c < 3507
                ? (c < 3461
                  ? (c < 3450
                    ? (c >= 3423 && c <= 3425)
                    : c <= 3455)
                  : (c <= 3478 || (c >= 3482 && c <= 3505)))
                : (c <= 3515 || (c < 3585
                  ? (c < 3520
                    ? c == 3517
                    : c <= 3526)
                  : (c <= 3632 || c == 3634))))))
            : (c <= 3654 || (c < 3782
              ? (c < 3749
                ? (c < 3718
                  ? (c < 3716
                    ? (c >= 3713 && c <= 3714)
                    : c <= 3716)
                  : (c <= 3722 || (c >= 3724 && c <= 3747)))
                : (c <= 3749 || (c < 3773
                  ? (c < 3762
                    ? (c >= 3751 && c <= 3760)
                    : c <= 3762)
                  : (c <= 3773 || (c >= 3776 && c <= 3780)))))
              : (c <= 3782 || (c < 3976
                ? (c < 3904
                  ? (c < 3840
                    ? (c >= 3804 && c <= 3807)
                    : c <= 3840)
                  : (c <= 3911 || (c >= 3913 && c <= 3948)))
                : (c <= 3980 || (c < 4176
                  ? (c < 4159
                    ? (c >= 4096 && c <= 4138)
                    : c <= 4159)
                  : (c <= 4181 || (c >= 4186 && c <= 4189)))))))))))))
      : (c <= 4193 || (c < 8134
        ? (c < 6176
          ? (c < 4808
            ? (c < 4688
              ? (c < 4295
                ? (c < 4213
                  ? (c < 4206
                    ? (c >= 4197 && c <= 4198)
                    : c <= 4208)
                  : (c <= 4225 || (c < 4256
                    ? c == 4238
                    : c <= 4293)))
                : (c <= 4295 || (c < 4348
                  ? (c < 4304
                    ? c == 4301
                    : c <= 4346)
                  : (c <= 4680 || (c >= 4682 && c <= 4685)))))
              : (c <= 4694 || (c < 4752
                ? (c < 4704
                  ? (c < 4698
                    ? c == 4696
                    : c <= 4701)
                  : (c <= 4744 || (c >= 4746 && c <= 4749)))
                : (c <= 4784 || (c < 4800
                  ? (c < 4792
                    ? (c >= 4786 && c <= 4789)
                    : c <= 4798)
                  : (c <= 4800 || (c >= 4802 && c <= 4805)))))))
            : (c <= 4822 || (c < 5792
              ? (c < 5024
                ? (c < 4888
                  ? (c < 4882
                    ? (c >= 4824 && c <= 4880)
                    : c <= 4885)
                  : (c <= 4954 || (c >= 4992 && c <= 5007)))
                : (c <= 5109 || (c < 5743
                  ? (c < 5121
                    ? (c >= 5112 && c <= 5117)
                    : c <= 5740)
                  : (c <= 5759 || (c >= 5761 && c <= 5786)))))
              : (c <= 5866 || (c < 5984
                ? (c < 5919
                  ? (c < 5888
                    ? (c >= 5870 && c <= 5880)
                    : c <= 5905)
                  : (c <= 5937 || (c >= 5952 && c <= 5969)))
                : (c <= 5996 || (c < 6103
                  ? (c < 6016
                    ? (c >= 5998 && c <= 6000)
                    : c <= 6067)
                  : (c <= 6103 || c == 6108))))))))
          : (c <= 6264 || (c < 7312
            ? (c < 6823
              ? (c < 6512
                ? (c < 6320
                  ? (c < 6314
                    ? (c >= 6272 && c <= 6312)
                    : c <= 6314)
                  : (c <= 6389 || (c < 6480
                    ? (c >= 6400 && c <= 6430)
                    : c <= 6509)))
                : (c <= 6516 || (c < 6656
                  ? (c < 6576
                    ? (c >= 6528 && c <= 6571)
                    : c <= 6601)
                  : (c <= 6678 || (c >= 6688 && c <= 6740)))))
              : (c <= 6823 || (c < 7098
                ? (c < 7043
                  ? (c < 6981
                    ? (c >= 6917 && c <= 6963)
                    : c <= 6988)
                  : (c <= 7072 || (c >= 7086 && c <= 7087)))
                : (c <= 7141 || (c < 7258
                  ? (c < 7245
                    ? (c >= 7168 && c <= 7203)
                    : c <= 7247)
                  : (c <= 7293 || (c >= 7296 && c <= 7304)))))))
            : (c <= 7354 || (c < 8008
              ? (c < 7418
                ? (c < 7406
                  ? (c < 7401
                    ? (c >= 7357 && c <= 7359)
                    : c <= 7404)
                  : (c <= 7411 || (c >= 7413 && c <= 7414)))
                : (c <= 7418 || (c < 7960
                  ? (c < 7680
                    ? (c >= 7424 && c <= 7615)
                    : c <= 7957)
                  : (c <= 7965 || (c >= 7968 && c <= 8005)))))
              : (c <= 8013 || (c < 8031
                ? (c < 8027
                  ? (c < 8025
                    ? (c >= 8016 && c <= 8023)
                    : c <= 8025)
                  : (c <= 8027 || c == 8029))
                : (c <= 8061 || (c < 8126
                  ? (c < 8118
                    ? (c >= 8064 && c <= 8116)
                    : c <= 8124)
                  : (c <= 8126 || (c >= 8130 && c <= 8132)))))))))))
        : (c <= 8140 || (c < 12337
          ? (c < 8544
            ? (c < 8458
              ? (c < 8305
                ? (c < 8160
                  ? (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)
                  : (c <= 8172 || (c < 8182
                    ? (c >= 8178 && c <= 8180)
                    : c <= 8188)))
                : (c <= 8305 || (c < 8450
                  ? (c < 8336
                    ? c == 8319
                    : c <= 8348)
                  : (c <= 8450 || c == 8455))))
              : (c <= 8467 || (c < 8488
                ? (c < 8484
                  ? (c < 8472
                    ? c == 8469
                    : c <= 8477)
                  : (c <= 8484 || c == 8486))
                : (c <= 8488 || (c < 8517
                  ? (c < 8508
                    ? (c >= 8490 && c <= 8505)
                    : c <= 8511)
                  : (c <= 8521 || c == 8526))))))
            : (c <= 8584 || (c < 11680
              ? (c < 11559
                ? (c < 11506
                  ? (c < 11499
                    ? (c >= 11264 && c <= 11492)
                    : c <= 11502)
                  : (c <= 11507 || (c >= 11520 && c <= 11557)))
                : (c <= 11559 || (c < 11631
                  ? (c < 11568
                    ? c == 11565
                    : c <= 11623)
                  : (c <= 11631 || (c >= 11648 && c <= 11670)))))
              : (c <= 11686 || (c < 11720
                ? (c < 11704
                  ? (c < 11696
                    ? (c >= 11688 && c <= 11694)
                    : c <= 11702)
                  : (c <= 11710 || (c >= 11712 && c <= 11718)))
                : (c <= 11726 || (c < 12293
                  ? (c < 11736
                    ? (c >= 11728 && c <= 11734)
                    : c <= 11742)
                  : (c <= 12295 || (c >= 12321 && c <= 12329)))))))))
          : (c <= 12341 || (c < 42891
            ? (c < 19968
              ? (c < 12549
                ? (c < 12445
                  ? (c < 12353
                    ? (c >= 12344 && c <= 12348)
                    : c <= 12438)
                  : (c <= 12447 || (c < 12540
                    ? (c >= 12449 && c <= 12538)
                    : c <= 12543)))
                : (c <= 12591 || (c < 12784
                  ? (c < 12704
                    ? (c >= 12593 && c <= 12686)
                    : c <= 12735)
                  : (c <= 12799 || (c >= 13312 && c <= 19903)))))
              : (c <= 42124 || (c < 42560
                ? (c < 42512
                  ? (c < 42240
                    ? (c >= 42192 && c <= 42237)
                    : c <= 42508)
                  : (c <= 42527 || (c >= 42538 && c <= 42539)))
                : (c <= 42606 || (c < 42775
                  ? (c < 42656
                    ? (c >= 42623 && c <= 42653)
                    : c <= 42735)
                  : (c <= 42783 || (c >= 42786 && c <= 42888)))))))
            : (c <= 42954 || (c < 43250
              ? (c < 43011
                ? (c < 42965
                  ? (c < 42963
                    ? (c >= 42960 && c <= 42961)
                    : c <= 42963)
                  : (c <= 42969 || (c >= 42994 && c <= 43009)))
                : (c <= 43013 || (c < 43072
                  ? (c < 43020
                    ? (c >= 43015 && c <= 43018)
                    : c <= 43042)
                  : (c <= 43123 || (c >= 43138 && c <= 43187)))))
              : (c <= 43255 || (c < 43360
                ? (c < 43274
                  ? (c < 43261
                    ? c == 43259
                    : c <= 43262)
                  : (c <= 43301 || (c >= 43312 && c <= 43334)))
                : (c <= 43388 || (c < 43488
                  ? (c < 43471
                    ? (c >= 43396 && c <= 43442)
                    : c <= 43471)
                  : (c <= 43492 || (c >= 43494 && c <= 43503)))))))))))))))
    : (c <= 43518 || (c < 70727
      ? (c < 66956
        ? (c < 64914
          ? (c < 43868
            ? (c < 43714
              ? (c < 43646
                ? (c < 43588
                  ? (c < 43584
                    ? (c >= 43520 && c <= 43560)
                    : c <= 43586)
                  : (c <= 43595 || (c < 43642
                    ? (c >= 43616 && c <= 43638)
                    : c <= 43642)))
                : (c <= 43695 || (c < 43705
                  ? (c < 43701
                    ? c == 43697
                    : c <= 43702)
                  : (c <= 43709 || c == 43712))))
              : (c <= 43714 || (c < 43785
                ? (c < 43762
                  ? (c < 43744
                    ? (c >= 43739 && c <= 43741)
                    : c <= 43754)
                  : (c <= 43764 || (c >= 43777 && c <= 43782)))
                : (c <= 43790 || (c < 43816
                  ? (c < 43808
                    ? (c >= 43793 && c <= 43798)
                    : c <= 43814)
                  : (c <= 43822 || (c >= 43824 && c <= 43866)))))))
            : (c <= 43881 || (c < 64287
              ? (c < 63744
                ? (c < 55216
                  ? (c < 44032
                    ? (c >= 43888 && c <= 44002)
                    : c <= 55203)
                  : (c <= 55238 || (c >= 55243 && c <= 55291)))
                : (c <= 64109 || (c < 64275
                  ? (c < 64256
                    ? (c >= 64112 && c <= 64217)
                    : c <= 64262)
                  : (c <= 64279 || c == 64285))))
              : (c <= 64296 || (c < 64323
                ? (c < 64318
                  ? (c < 64312
                    ? (c >= 64298 && c <= 64310)
                    : c <= 64316)
                  : (c <= 64318 || (c >= 64320 && c <= 64321)))
                : (c <= 64324 || (c < 64612
                  ? (c < 64467
                    ? (c >= 64326 && c <= 64433)
                    : c <= 64605)
                  : (c <= 64829 || (c >= 64848 && c <= 64911)))))))))
          : (c <= 64967 || (c < 65599
            ? (c < 65382
              ? (c < 65147
                ? (c < 65139
                  ? (c < 65137
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65137)
                  : (c <= 65139 || (c < 65145
                    ? c == 65143
                    : c <= 65145)))
                : (c <= 65147 || (c < 65313
                  ? (c < 65151
                    ? c == 65149
                    : c <= 65276)
                  : (c <= 65338 || (c >= 65345 && c <= 65370)))))
              : (c <= 65437 || (c < 65498
                ? (c < 65482
                  ? (c < 65474
                    ? (c >= 65440 && c <= 65470)
                    : c <= 65479)
                  : (c <= 65487 || (c >= 65490 && c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c >= 65596 && c <= 65597)))))))
            : (c <= 65613 || (c < 66464
              ? (c < 66208
                ? (c < 65856
                  ? (c < 65664
                    ? (c >= 65616 && c <= 65629)
                    : c <= 65786)
                  : (c <= 65908 || (c >= 66176 && c <= 66204)))
                : (c <= 66256 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66421 || (c >= 66432 && c <= 66461)))))
              : (c <= 66499 || (c < 66776
                ? (c < 66560
                  ? (c < 66513
                    ? (c >= 66504 && c <= 66511)
                    : c <= 66517)
                  : (c <= 66717 || (c >= 66736 && c <= 66771)))
                : (c <= 66811 || (c < 66928
                  ? (c < 66864
                    ? (c >= 66816 && c <= 66855)
                    : c <= 66915)
                  : (c <= 66938 || (c >= 66940 && c <= 66954)))))))))))
        : (c <= 66962 || (c < 68864
          ? (c < 67828
            ? (c < 67506
              ? (c < 67072
                ? (c < 66979
                  ? (c < 66967
                    ? (c >= 66964 && c <= 66965)
                    : c <= 66977)
                  : (c <= 66993 || (c < 67003
                    ? (c >= 66995 && c <= 67001)
                    : c <= 67004)))
                : (c <= 67382 || (c < 67456
                  ? (c < 67424
                    ? (c >= 67392 && c <= 67413)
                    : c <= 67431)
                  : (c <= 67461 || (c >= 67463 && c <= 67504)))))
              : (c <= 67514 || (c < 67644
                ? (c < 67594
                  ? (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)
                  : (c <= 67637 || (c >= 67639 && c <= 67640)))
                : (c <= 67644 || (c < 67712
                  ? (c < 67680
                    ? (c >= 67647 && c <= 67669)
                    : c <= 67702)
                  : (c <= 67742 || (c >= 67808 && c <= 67826)))))))
            : (c <= 67829 || (c < 68224
              ? (c < 68096
                ? (c < 67968
                  ? (c < 67872
                    ? (c >= 67840 && c <= 67861)
                    : c <= 67897)
                  : (c <= 68023 || (c >= 68030 && c <= 68031)))
                : (c <= 68096 || (c < 68121
                  ? (c < 68117
                    ? (c >= 68112 && c <= 68115)
                    : c <= 68119)
                  : (c <= 68149 || (c >= 68192 && c <= 68220)))))
              : (c <= 68252 || (c < 68448
                ? (c < 68352
                  ? (c < 68297
                    ? (c >= 68288 && c <= 68295)
                    : c <= 68324)
                  : (c <= 68405 || (c >= 68416 && c <= 68437)))
                : (c <= 68466 || (c < 68736
                  ? (c < 68608
                    ? (c >= 68480 && c <= 68497)
                    : c <= 68680)
                  : (c <= 68786 || (c >= 68800 && c <= 68850)))))))))
          : (c <= 68899 || (c < 70106
            ? (c < 69749
              ? (c < 69488
                ? (c < 69376
                  ? (c < 69296
                    ? (c >= 69248 && c <= 69289)
                    : c <= 69297)
                  : (c <= 69404 || (c < 69424
                    ? c == 69415
                    : c <= 69445)))
                : (c <= 69505 || (c < 69635
                  ? (c < 69600
                    ? (c >= 69552 && c <= 69572)
                    : c <= 69622)
                  : (c <= 69687 || (c >= 69745 && c <= 69746)))))
              : (c <= 69749 || (c < 69959
                ? (c < 69891
                  ? (c < 69840
                    ? (c >= 69763 && c <= 69807)
                    : c <= 69864)
                  : (c <= 69926 || c == 69956))
                : (c <= 69959 || (c < 70019
                  ? (c < 70006
                    ? (c >= 69968 && c <= 70002)
                    : c <= 70006)
                  : (c <= 70066 || (c >= 70081 && c <= 70084)))))))
            : (c <= 70106 || (c < 70405
              ? (c < 70280
                ? (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70187 || (c >= 70272 && c <= 70278)))
                : (c <= 70280 || (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c >= 70320 && c <= 70366)))))
              : (c <= 70412 || (c < 70453
                ? (c < 70442
                  ? (c < 70419
                    ? (c >= 70415 && c <= 70416)
                    : c <= 70440)
                  : (c <= 70448 || (c >= 70450 && c <= 70451)))
                : (c <= 70457 || (c < 70493
                  ? (c < 70480
                    ? c == 70461
                    : c <= 70480)
                  : (c <= 70497 || (c >= 70656 && c <= 70708)))))))))))))
      : (c <= 70730 || (c < 119894
        ? (c < 73056
          ? (c < 72001
            ? (c < 71424
              ? (c < 71128
                ? (c < 70852
                  ? (c < 70784
                    ? (c >= 70751 && c <= 70753)
                    : c <= 70831)
                  : (c <= 70853 || (c < 71040
                    ? c == 70855
                    : c <= 71086)))
                : (c <= 71131 || (c < 71296
                  ? (c < 71236
                    ? (c >= 71168 && c <= 71215)
                    : c <= 71236)
                  : (c <= 71338 || c == 71352))))
              : (c <= 71450 || (c < 71945
                ? (c < 71840
                  ? (c < 71680
                    ? (c >= 71488 && c <= 71494)
                    : c <= 71723)
                  : (c <= 71903 || (c >= 71935 && c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71983 || c == 71999))))))
            : (c <= 72001 || (c < 72349
              ? (c < 72192
                ? (c < 72161
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72144)
                  : (c <= 72161 || c == 72163))
                : (c <= 72192 || (c < 72272
                  ? (c < 72250
                    ? (c >= 72203 && c <= 72242)
                    : c <= 72250)
                  : (c <= 72272 || (c >= 72284 && c <= 72329)))))
              : (c <= 72349 || (c < 72818
                ? (c < 72714
                  ? (c < 72704
                    ? (c >= 72368 && c <= 72440)
                    : c <= 72712)
                  : (c <= 72750 || c == 72768))
                : (c <= 72847 || (c < 72971
                  ? (c < 72968
                    ? (c >= 72960 && c <= 72966)
                    : c <= 72969)
                  : (c <= 73008 || c == 73030))))))))
          : (c <= 73061 || (c < 93952
            ? (c < 82944
              ? (c < 73728
                ? (c < 73112
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73097)
                  : (c <= 73112 || (c < 73648
                    ? (c >= 73440 && c <= 73458)
                    : c <= 73648)))
                : (c <= 74649 || (c < 77712
                  ? (c < 74880
                    ? (c >= 74752 && c <= 74862)
                    : c <= 75075)
                  : (c <= 77808 || (c >= 77824 && c <= 78894)))))
              : (c <= 83526 || (c < 92928
                ? (c < 92784
                  ? (c < 92736
                    ? (c >= 92160 && c <= 92728)
                    : c <= 92766)
                  : (c <= 92862 || (c >= 92880 && c <= 92909)))
                : (c <= 92975 || (c < 93053
                  ? (c < 93027
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93047)
                  : (c <= 93071 || (c >= 93760 && c <= 93823)))))))
            : (c <= 94026 || (c < 110589
              ? (c < 94208
                ? (c < 94176
                  ? (c < 94099
                    ? c == 94032
                    : c <= 94111)
                  : (c <= 94177 || c == 94179))
                : (c <= 100343 || (c < 110576
                  ? (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)
                  : (c <= 110579 || (c >= 110581 && c <= 110587)))))
              : (c <= 110590 || (c < 113664
                ? (c < 110948
                  ? (c < 110928
                    ? (c >= 110592 && c <= 110882)
                    : c <= 110930)
                  : (c <= 110951 || (c >= 110960 && c <= 111355)))
                : (c <= 113770 || (c < 113808
                  ? (c < 113792
                    ? (c >= 113776 && c <= 113788)
                    : c <= 113800)
                  : (c <= 113817 || (c >= 119808 && c <= 119892)))))))))))
        : (c <= 119964 || (c < 125259
          ? (c < 120572
            ? (c < 120086
              ? (c < 119995
                ? (c < 119973
                  ? (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)
                  : (c <= 119974 || (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)))
                : (c <= 119995 || (c < 120071
                  ? (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)
                  : (c <= 120074 || (c >= 120077 && c <= 120084)))))
              : (c <= 120092 || (c < 120138
                ? (c < 120128
                  ? (c < 120123
                    ? (c >= 120094 && c <= 120121)
                    : c <= 120126)
                  : (c <= 120132 || c == 120134))
                : (c <= 120144 || (c < 120514
                  ? (c < 120488
                    ? (c >= 120146 && c <= 120485)
                    : c <= 120512)
                  : (c <= 120538 || (c >= 120540 && c <= 120570)))))))
            : (c <= 120596 || (c < 123191
              ? (c < 120714
                ? (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c >= 120688 && c <= 120712)))
                : (c <= 120744 || (c < 122624
                  ? (c < 120772
                    ? (c >= 120746 && c <= 120770)
                    : c <= 120779)
                  : (c <= 122654 || (c >= 123136 && c <= 123180)))))
              : (c <= 123197 || (c < 124904
                ? (c < 123584
                  ? (c < 123536
                    ? c == 123214
                    : c <= 123565)
                  : (c <= 123627 || (c >= 124896 && c <= 124902)))
                : (c <= 124907 || (c < 124928
                  ? (c < 124912
                    ? (c >= 124909 && c <= 124910)
                    : c <= 124926)
                  : (c <= 125124 || (c >= 125184 && c <= 125251)))))))))
          : (c <= 125259 || (c < 126559
            ? (c < 126535
              ? (c < 126505
                ? (c < 126497
                  ? (c < 126469
                    ? (c >= 126464 && c <= 126467)
                    : c <= 126495)
                  : (c <= 126498 || (c < 126503
                    ? c == 126500
                    : c <= 126503)))
                : (c <= 126514 || (c < 126523
                  ? (c < 126521
                    ? (c >= 126516 && c <= 126519)
                    : c <= 126521)
                  : (c <= 126523 || c == 126530))))
              : (c <= 126535 || (c < 126548
                ? (c < 126541
                  ? (c < 126539
                    ? c == 126537
                    : c <= 126539)
                  : (c <= 126543 || (c >= 126545 && c <= 126546)))
                : (c <= 126548 || (c < 126555
                  ? (c < 126553
                    ? c == 126551
                    : c <= 126553)
                  : (c <= 126555 || c == 126557))))))
            : (c <= 126559 || (c < 126625
              ? (c < 126580
                ? (c < 126567
                  ? (c < 126564
                    ? (c >= 126561 && c <= 126562)
                    : c <= 126564)
                  : (c <= 126570 || (c >= 126572 && c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c >= 126603 && c <= 126619)))))
              : (c <= 126627 || (c < 177984
                ? (c < 131072
                  ? (c < 126635
                    ? (c >= 126629 && c <= 126633)
                    : c <= 126651)
                  : (c <= 173791 || (c >= 173824 && c <= 177976)))
                : (c <= 178205 || (c < 194560
                  ? (c < 183984
                    ? (c >= 178208 && c <= 183969)
                    : c <= 191456)
                  : (c <= 195101 || (c >= 196608 && c <= 201546)))))))))))))))));
}

static inline bool sym_identifier_character_set_3(int32_t c) {
  return (c < 43616
    ? (c < 3782
      ? (c < 2748
        ? (c < 2045
          ? (c < 1015
            ? (c < 710
              ? (c < 181
                ? (c < '_'
                  ? (c < 'A'
                    ? (c >= '0' && c <= '9')
                    : c <= 'Z')
                  : (c <= '_' || (c < 170
                    ? (c >= 'a' && c <= 'z')
                    : c <= 170)))
                : (c <= 181 || (c < 192
                  ? (c < 186
                    ? c == 183
                    : c <= 186)
                  : (c <= 214 || (c < 248
                    ? (c >= 216 && c <= 246)
                    : c <= 705)))))
              : (c <= 721 || (c < 891
                ? (c < 750
                  ? (c < 748
                    ? (c >= 736 && c <= 740)
                    : c <= 748)
                  : (c <= 750 || (c < 886
                    ? (c >= 768 && c <= 884)
                    : c <= 887)))
                : (c <= 893 || (c < 908
                  ? (c < 902
                    ? c == 895
                    : c <= 906)
                  : (c <= 908 || (c < 931
                    ? (c >= 910 && c <= 929)
                    : c <= 1013)))))))
            : (c <= 1153 || (c < 1519
              ? (c < 1425
                ? (c < 1329
                  ? (c < 1162
                    ? (c >= 1155 && c <= 1159)
                    : c <= 1327)
                  : (c <= 1366 || (c < 1376
                    ? c == 1369
                    : c <= 1416)))
                : (c <= 1469 || (c < 1476
                  ? (c < 1473
                    ? c == 1471
                    : c <= 1474)
                  : (c <= 1477 || (c < 1488
                    ? c == 1479
                    : c <= 1514)))))
              : (c <= 1522 || (c < 1770
                ? (c < 1646
                  ? (c < 1568
                    ? (c >= 1552 && c <= 1562)
                    : c <= 1641)
                  : (c <= 1747 || (c < 1759
                    ? (c >= 1749 && c <= 1756)
                    : c <= 1768)))
                : (c <= 1788 || (c < 1869
                  ? (c < 1808
                    ? c == 1791
                    : c <= 1866)
                  : (c <= 1969 || (c < 2042
                    ? (c >= 1984 && c <= 2037)
                    : c <= 2042)))))))))
          : (c <= 2045 || (c < 2558
            ? (c < 2451
              ? (c < 2200
                ? (c < 2144
                  ? (c < 2112
                    ? (c >= 2048 && c <= 2093)
                    : c <= 2139)
                  : (c <= 2154 || (c < 2185
                    ? (c >= 2160 && c <= 2183)
                    : c <= 2190)))
                : (c <= 2273 || (c < 2417
                  ? (c < 2406
                    ? (c >= 2275 && c <= 2403)
                    : c <= 2415)
                  : (c <= 2435 || (c < 2447
                    ? (c >= 2437 && c <= 2444)
                    : c <= 2448)))))
              : (c <= 2472 || (c < 2507
                ? (c < 2486
                  ? (c < 2482
                    ? (c >= 2474 && c <= 2480)
                    : c <= 2482)
                  : (c <= 2489 || (c < 2503
                    ? (c >= 2492 && c <= 2500)
                    : c <= 2504)))
                : (c <= 2510 || (c < 2527
                  ? (c < 2524
                    ? c == 2519
                    : c <= 2525)
                  : (c <= 2531 || (c < 2556
                    ? (c >= 2534 && c <= 2545)
                    : c <= 2556)))))))
            : (c <= 2558 || (c < 2635
              ? (c < 2610
                ? (c < 2575
                  ? (c < 2565
                    ? (c >= 2561 && c <= 2563)
                    : c <= 2570)
                  : (c <= 2576 || (c < 2602
                    ? (c >= 2579 && c <= 2600)
                    : c <= 2608)))
                : (c <= 2611 || (c < 2620
                  ? (c < 2616
                    ? (c >= 2613 && c <= 2614)
                    : c <= 2617)
                  : (c <= 2620 || (c < 2631
                    ? (c >= 2622 && c <= 2626)
                    : c <= 2632)))))
              : (c <= 2637 || (c < 2693
                ? (c < 2654
                  ? (c < 2649
                    ? c == 2641
                    : c <= 2652)
                  : (c <= 2654 || (c < 2689
                    ? (c >= 2662 && c <= 2677)
                    : c <= 2691)))
                : (c <= 2701 || (c < 2730
                  ? (c < 2707
                    ? (c >= 2703 && c <= 2705)
                    : c <= 2728)
                  : (c <= 2736 || (c < 2741
                    ? (c >= 2738 && c <= 2739)
                    : c <= 2745)))))))))))
        : (c <= 2757 || (c < 3168
          ? (c < 2958
            ? (c < 2866
              ? (c < 2809
                ? (c < 2768
                  ? (c < 2763
                    ? (c >= 2759 && c <= 2761)
                    : c <= 2765)
                  : (c <= 2768 || (c < 2790
                    ? (c >= 2784 && c <= 2787)
                    : c <= 2799)))
                : (c <= 2815 || (c < 2831
                  ? (c < 2821
                    ? (c >= 2817 && c <= 2819)
                    : c <= 2828)
                  : (c <= 2832 || (c < 2858
                    ? (c >= 2835 && c <= 2856)
                    : c <= 2864)))))
              : (c <= 2867 || (c < 2908
                ? (c < 2887
                  ? (c < 2876
                    ? (c >= 2869 && c <= 2873)
                    : c <= 2884)
                  : (c <= 2888 || (c < 2901
                    ? (c >= 2891 && c <= 2893)
                    : c <= 2903)))
                : (c <= 2909 || (c < 2929
                  ? (c < 2918
                    ? (c >= 2911 && c <= 2915)
                    : c <= 2927)
                  : (c <= 2929 || (c < 2949
                    ? (c >= 2946 && c <= 2947)
                    : c <= 2954)))))))
            : (c <= 2960 || (c < 3031
              ? (c < 2984
                ? (c < 2972
                  ? (c < 2969
                    ? (c >= 2962 && c <= 2965)
                    : c <= 2970)
                  : (c <= 2972 || (c < 2979
                    ? (c >= 2974 && c <= 2975)
                    : c <= 2980)))
                : (c <= 2986 || (c < 3014
                  ? (c < 3006
                    ? (c >= 2990 && c <= 3001)
                    : c <= 3010)
                  : (c <= 3016 || (c < 3024
                    ? (c >= 3018 && c <= 3021)
                    : c <= 3024)))))
              : (c <= 3031 || (c < 3132
                ? (c < 3086
                  ? (c < 3072
                    ? (c >= 3046 && c <= 3055)
                    : c <= 3084)
                  : (c <= 3088 || (c < 3114
                    ? (c >= 3090 && c <= 3112)
                    : c <= 3129)))
                : (c <= 3140 || (c < 3157
                  ? (c < 3146
                    ? (c >= 3142 && c <= 3144)
                    : c <= 3149)
                  : (c <= 3158 || (c < 3165
                    ? (c >= 3160 && c <= 3162)
                    : c <= 3165)))))))))
          : (c <= 3171 || (c < 3450
            ? (c < 3293
              ? (c < 3242
                ? (c < 3205
                  ? (c < 3200
                    ? (c >= 3174 && c <= 3183)
                    : c <= 3203)
                  : (c <= 3212 || (c < 3218
                    ? (c >= 3214 && c <= 3216)
                    : c <= 3240)))
                : (c <= 3251 || (c < 3270
                  ? (c < 3260
                    ? (c >= 3253 && c <= 3257)
                    : c <= 3268)
                  : (c <= 3272 || (c < 3285
                    ? (c >= 3274 && c <= 3277)
                    : c <= 3286)))))
              : (c <= 3294 || (c < 3346
                ? (c < 3313
                  ? (c < 3302
                    ? (c >= 3296 && c <= 3299)
                    : c <= 3311)
                  : (c <= 3314 || (c < 3342
                    ? (c >= 3328 && c <= 3340)
                    : c <= 3344)))
                : (c <= 3396 || (c < 3412
                  ? (c < 3402
                    ? (c >= 3398 && c <= 3400)
                    : c <= 3406)
                  : (c <= 3415 || (c < 3430
                    ? (c >= 3423 && c <= 3427)
                    : c <= 3439)))))))
            : (c <= 3455 || (c < 3570
              ? (c < 3520
                ? (c < 3482
                  ? (c < 3461
                    ? (c >= 3457 && c <= 3459)
                    : c <= 3478)
                  : (c <= 3505 || (c < 3517
                    ? (c >= 3507 && c <= 3515)
                    : c <= 3517)))
                : (c <= 3526 || (c < 3542
                  ? (c < 3535
                    ? c == 3530
                    : c <= 3540)
                  : (c <= 3542 || (c < 3558
                    ? (c >= 3544 && c <= 3551)
                    : c <= 3567)))))
              : (c <= 3571 || (c < 3718
                ? (c < 3664
                  ? (c < 3648
                    ? (c >= 3585 && c <= 3642)
                    : c <= 3662)
                  : (c <= 3673 || (c < 3716
                    ? (c >= 3713 && c <= 3714)
                    : c <= 3716)))
                : (c <= 3722 || (c < 3751
                  ? (c < 3749
                    ? (c >= 3724 && c <= 3747)
                    : c <= 3749)
                  : (c <= 3773 || (c >= 3776 && c <= 3780)))))))))))))
      : (c <= 3782 || (c < 8025
        ? (c < 5888
          ? (c < 4688
            ? (c < 3953
              ? (c < 3872
                ? (c < 3804
                  ? (c < 3792
                    ? (c >= 3784 && c <= 3789)
                    : c <= 3801)
                  : (c <= 3807 || (c < 3864
                    ? c == 3840
                    : c <= 3865)))
                : (c <= 3881 || (c < 3897
                  ? (c < 3895
                    ? c == 3893
                    : c <= 3895)
                  : (c <= 3897 || (c < 3913
                    ? (c >= 3902 && c <= 3911)
                    : c <= 3948)))))
              : (c <= 3972 || (c < 4256
                ? (c < 4038
                  ? (c < 3993
                    ? (c >= 3974 && c <= 3991)
                    : c <= 4028)
                  : (c <= 4038 || (c < 4176
                    ? (c >= 4096 && c <= 4169)
                    : c <= 4253)))
                : (c <= 4293 || (c < 4304
                  ? (c < 4301
                    ? c == 4295
                    : c <= 4301)
                  : (c <= 4346 || (c < 4682
                    ? (c >= 4348 && c <= 4680)
                    : c <= 4685)))))))
            : (c <= 4694 || (c < 4882
              ? (c < 4786
                ? (c < 4704
                  ? (c < 4698
                    ? c == 4696
                    : c <= 4701)
                  : (c <= 4744 || (c < 4752
                    ? (c >= 4746 && c <= 4749)
                    : c <= 4784)))
                : (c <= 4789 || (c < 4802
                  ? (c < 4800
                    ? (c >= 4792 && c <= 4798)
                    : c <= 4800)
                  : (c <= 4805 || (c < 4824
                    ? (c >= 4808 && c <= 4822)
                    : c <= 4880)))))
              : (c <= 4885 || (c < 5112
                ? (c < 4969
                  ? (c < 4957
                    ? (c >= 4888 && c <= 4954)
                    : c <= 4959)
                  : (c <= 4977 || (c < 5024
                    ? (c >= 4992 && c <= 5007)
                    : c <= 5109)))
                : (c <= 5117 || (c < 5761
                  ? (c < 5743
                    ? (c >= 5121 && c <= 5740)
                    : c <= 5759)
                  : (c <= 5786 || (c < 5870
                    ? (c >= 5792 && c <= 5866)
                    : c <= 5880)))))))))
          : (c <= 5909 || (c < 6688
            ? (c < 6176
              ? (c < 6016
                ? (c < 5984
                  ? (c < 5952
                    ? (c >= 5919 && c <= 5940)
                    : c <= 5971)
                  : (c <= 5996 || (c < 6002
                    ? (c >= 5998 && c <= 6000)
                    : c <= 6003)))
                : (c <= 6099 || (c < 6112
                  ? (c < 6108
                    ? c == 6103
                    : c <= 6109)
                  : (c <= 6121 || (c < 6159
                    ? (c >= 6155 && c <= 6157)
                    : c <= 6169)))))
              : (c <= 6264 || (c < 6470
                ? (c < 6400
                  ? (c < 6320
                    ? (c >= 6272 && c <= 6314)
                    : c <= 6389)
                  : (c <= 6430 || (c < 6448
                    ? (c >= 6432 && c <= 6443)
                    : c <= 6459)))
                : (c <= 6509 || (c < 6576
                  ? (c < 6528
                    ? (c >= 6512 && c <= 6516)
                    : c <= 6571)
                  : (c <= 6601 || (c < 6656
                    ? (c >= 6608 && c <= 6618)
                    : c <= 6683)))))))
            : (c <= 6750 || (c < 7232
              ? (c < 6847
                ? (c < 6800
                  ? (c < 6783
                    ? (c >= 6752 && c <= 6780)
                    : c <= 6793)
                  : (c <= 6809 || (c < 6832
                    ? c == 6823
                    : c <= 6845)))
                : (c <= 6862 || (c < 7019
                  ? (c < 6992
                    ? (c >= 6912 && c <= 6988)
                    : c <= 7001)
                  : (c <= 7027 || (c < 7168
                    ? (c >= 7040 && c <= 7155)
                    : c <= 7223)))))
              : (c <= 7241 || (c < 7380
                ? (c < 7312
                  ? (c < 7296
                    ? (c >= 7245 && c <= 7293)
                    : c <= 7304)
                  : (c <= 7354 || (c < 7376
                    ? (c >= 7357 && c <= 7359)
                    : c <= 7378)))
                : (c <= 7418 || (c < 7968
                  ? (c < 7960
                    ? (c >= 7424 && c <= 7957)
                    : c <= 7965)
                  : (c <= 8005 || (c < 8016
                    ? (c >= 8008 && c <= 8013)
                    : c <= 8023)))))))))))
        : (c <= 8025 || (c < 11720
          ? (c < 8458
            ? (c < 8178
              ? (c < 8126
                ? (c < 8031
                  ? (c < 8029
                    ? c == 8027
                    : c <= 8029)
                  : (c <= 8061 || (c < 8118
                    ? (c >= 8064 && c <= 8116)
                    : c <= 8124)))
                : (c <= 8126 || (c < 8144
                  ? (c < 8134
                    ? (c >= 8130 && c <= 8132)
                    : c <= 8140)
                  : (c <= 8147 || (c < 8160
                    ? (c >= 8150 && c <= 8155)
                    : c <= 8172)))))
              : (c <= 8180 || (c < 8336
                ? (c < 8276
                  ? (c < 8255
                    ? (c >= 8182 && c <= 8188)
                    : c <= 8256)
                  : (c <= 8276 || (c < 8319
                    ? c == 8305
                    : c <= 8319)))
                : (c <= 8348 || (c < 8421
                  ? (c < 8417
                    ? (c >= 8400 && c <= 8412)
                    : c <= 8417)
                  : (c <= 8432 || (c < 8455
                    ? c == 8450
                    : c <= 8455)))))))
            : (c <= 8467 || (c < 11499
              ? (c < 8490
                ? (c < 8484
                  ? (c < 8472
                    ? c == 8469
                    : c <= 8477)
                  : (c <= 8484 || (c < 8488
                    ? c == 8486
                    : c <= 8488)))
                : (c <= 8505 || (c < 8526
                  ? (c < 8517
                    ? (c >= 8508 && c <= 8511)
                    : c <= 8521)
                  : (c <= 8526 || (c < 11264
                    ? (c >= 8544 && c <= 8584)
                    : c <= 11492)))))
              : (c <= 11507 || (c < 11647
                ? (c < 11565
                  ? (c < 11559
                    ? (c >= 11520 && c <= 11557)
                    : c <= 11559)
                  : (c <= 11565 || (c < 11631
                    ? (c >= 11568 && c <= 11623)
                    : c <= 11631)))
                : (c <= 11670 || (c < 11696
                  ? (c < 11688
                    ? (c >= 11680 && c <= 11686)
                    : c <= 11694)
                  : (c <= 11702 || (c < 11712
                    ? (c >= 11704 && c <= 11710)
                    : c <= 11718)))))))))
          : (c <= 11726 || (c < 42623
            ? (c < 12540
              ? (c < 12337
                ? (c < 11744
                  ? (c < 11736
                    ? (c >= 11728 && c <= 11734)
                    : c <= 11742)
                  : (c <= 11775 || (c < 12321
                    ? (c >= 12293 && c <= 12295)
                    : c <= 12335)))
                : (c <= 12341 || (c < 12441
                  ? (c < 12353
                    ? (c >= 12344 && c <= 12348)
                    : c <= 12438)
                  : (c <= 12442 || (c < 12449
                    ? (c >= 12445 && c <= 12447)
                    : c <= 12538)))))
              : (c <= 12543 || (c < 19968
                ? (c < 12704
                  ? (c < 12593
                    ? (c >= 12549 && c <= 12591)
                    : c <= 12686)
                  : (c <= 12735 || (c < 13312
                    ? (c >= 12784 && c <= 12799)
                    : c <= 19903)))
                : (c <= 42124 || (c < 42512
                  ? (c < 42240
                    ? (c >= 42192 && c <= 42237)
                    : c <= 42508)
                  : (c <= 42539 || (c < 42612
                    ? (c >= 42560 && c <= 42607)
                    : c <= 42621)))))))
            : (c <= 42737 || (c < 43232
              ? (c < 42965
                ? (c < 42891
                  ? (c < 42786
                    ? (c >= 42775 && c <= 42783)
                    : c <= 42888)
                  : (c <= 42954 || (c < 42963
                    ? (c >= 42960 && c <= 42961)
                    : c <= 42963)))
                : (c <= 42969 || (c < 43072
                  ? (c < 43052
                    ? (c >= 42994 && c <= 43047)
                    : c <= 43052)
                  : (c <= 43123 || (c < 43216
                    ? (c >= 43136 && c <= 43205)
                    : c <= 43225)))))
              : (c <= 43255 || (c < 43471
                ? (c < 43312
                  ? (c < 43261
                    ? c == 43259
                    : c <= 43309)
                  : (c <= 43347 || (c < 43392
                    ? (c >= 43360 && c <= 43388)
                    : c <= 43456)))
                : (c <= 43481 || (c < 43584
                  ? (c < 43520
                    ? (c >= 43488 && c <= 43518)
                    : c <= 43574)
                  : (c <= 43597 || (c >= 43600 && c <= 43609)))))))))))))))
    : (c <= 43638 || (c < 71453
      ? (c < 67639
        ? (c < 65345
          ? (c < 64312
            ? (c < 43888
              ? (c < 43785
                ? (c < 43744
                  ? (c < 43739
                    ? (c >= 43642 && c <= 43714)
                    : c <= 43741)
                  : (c <= 43759 || (c < 43777
                    ? (c >= 43762 && c <= 43766)
                    : c <= 43782)))
                : (c <= 43790 || (c < 43816
                  ? (c < 43808
                    ? (c >= 43793 && c <= 43798)
                    : c <= 43814)
                  : (c <= 43822 || (c < 43868
                    ? (c >= 43824 && c <= 43866)
                    : c <= 43881)))))
              : (c <= 44010 || (c < 63744
                ? (c < 44032
                  ? (c < 44016
                    ? (c >= 44012 && c <= 44013)
                    : c <= 44025)
                  : (c <= 55203 || (c < 55243
                    ? (c >= 55216 && c <= 55238)
                    : c <= 55291)))
                : (c <= 64109 || (c < 64275
                  ? (c < 64256
                    ? (c >= 64112 && c <= 64217)
                    : c <= 64262)
                  : (c <= 64279 || (c < 64298
                    ? (c >= 64285 && c <= 64296)
                    : c <= 64310)))))))
            : (c <= 64316 || (c < 65075
              ? (c < 64612
                ? (c < 64323
                  ? (c < 64320
                    ? c == 64318
                    : c <= 64321)
                  : (c <= 64324 || (c < 64467
                    ? (c >= 64326 && c <= 64433)
                    : c <= 64605)))
                : (c <= 64829 || (c < 65008
                  ? (c < 64914
                    ? (c >= 64848 && c <= 64911)
                    : c <= 64967)
                  : (c <= 65017 || (c < 65056
                    ? (c >= 65024 && c <= 65039)
                    : c <= 65071)))))
              : (c <= 65076 || (c < 65147
                ? (c < 65139
                  ? (c < 65137
                    ? (c >= 65101 && c <= 65103)
                    : c <= 65137)
                  : (c <= 65139 || (c < 65145
                    ? c == 65143
                    : c <= 65145)))
                : (c <= 65147 || (c < 65296
                  ? (c < 65151
                    ? c == 65149
                    : c <= 65276)
                  : (c <= 65305 || (c < 65343
                    ? (c >= 65313 && c <= 65338)
                    : c <= 65343)))))))))
          : (c <= 65370 || (c < 66513
            ? (c < 65664
              ? (c < 65536
                ? (c < 65482
                  ? (c < 65474
                    ? (c >= 65382 && c <= 65470)
                    : c <= 65479)
                  : (c <= 65487 || (c < 65498
                    ? (c >= 65490 && c <= 65495)
                    : c <= 65500)))
                : (c <= 65547 || (c < 65596
                  ? (c < 65576
                    ? (c >= 65549 && c <= 65574)
                    : c <= 65594)
                  : (c <= 65597 || (c < 65616
                    ? (c >= 65599 && c <= 65613)
                    : c <= 65629)))))
              : (c <= 65786 || (c < 66304
                ? (c < 66176
                  ? (c < 66045
                    ? (c >= 65856 && c <= 65908)
                    : c <= 66045)
                  : (c <= 66204 || (c < 66272
                    ? (c >= 66208 && c <= 66256)
                    : c <= 66272)))
                : (c <= 66335 || (c < 66432
                  ? (c < 66384
                    ? (c >= 66349 && c <= 66378)
                    : c <= 66426)
                  : (c <= 66461 || (c < 66504
                    ? (c >= 66464 && c <= 66499)
                    : c <= 66511)))))))
            : (c <= 66517 || (c < 66979
              ? (c < 66864
                ? (c < 66736
                  ? (c < 66720
                    ? (c >= 66560 && c <= 66717)
                    : c <= 66729)
                  : (c <= 66771 || (c < 66816
                    ? (c >= 66776 && c <= 66811)
                    : c <= 66855)))
                : (c <= 66915 || (c < 66956
                  ? (c < 66940
                    ? (c >= 66928 && c <= 66938)
                    : c <= 66954)
                  : (c <= 66962 || (c < 66967
                    ? (c >= 66964 && c <= 66965)
                    : c <= 66977)))))
              : (c <= 66993 || (c < 67456
                ? (c < 67072
                  ? (c < 67003
                    ? (c >= 66995 && c <= 67001)
                    : c <= 67004)
                  : (c <= 67382 || (c < 67424
                    ? (c >= 67392 && c <= 67413)
                    : c <= 67431)))
                : (c <= 67461 || (c < 67584
                  ? (c < 67506
                    ? (c >= 67463 && c <= 67504)
                    : c <= 67514)
                  : (c <= 67589 || (c < 67594
                    ? c == 67592
                    : c <= 67637)))))))))))
        : (c <= 67640 || (c < 69956
          ? (c < 68448
            ? (c < 68101
              ? (c < 67828
                ? (c < 67680
                  ? (c < 67647
                    ? c == 67644
                    : c <= 67669)
                  : (c <= 67702 || (c < 67808
                    ? (c >= 67712 && c <= 67742)
                    : c <= 67826)))
                : (c <= 67829 || (c < 67968
                  ? (c < 67872
                    ? (c >= 67840 && c <= 67861)
                    : c <= 67897)
                  : (c <= 68023 || (c < 68096
                    ? (c >= 68030 && c <= 68031)
                    : c <= 68099)))))
              : (c <= 68102 || (c < 68192
                ? (c < 68121
                  ? (c < 68117
                    ? (c >= 68108 && c <= 68115)
                    : c <= 68119)
                  : (c <= 68149 || (c < 68159
                    ? (c >= 68152 && c <= 68154)
                    : c <= 68159)))
                : (c <= 68220 || (c < 68297
                  ? (c < 68288
                    ? (c >= 68224 && c <= 68252)
                    : c <= 68295)
                  : (c <= 68326 || (c < 68416
                    ? (c >= 68352 && c <= 68405)
                    : c <= 68437)))))))
            : (c <= 68466 || (c < 69424
              ? (c < 68912
                ? (c < 68736
                  ? (c < 68608
                    ? (c >= 68480 && c <= 68497)
                    : c <= 68680)
                  : (c <= 68786 || (c < 68864
                    ? (c >= 68800 && c <= 68850)
                    : c <= 68903)))
                : (c <= 68921 || (c < 69296
                  ? (c < 69291
                    ? (c >= 69248 && c <= 69289)
                    : c <= 69292)
                  : (c <= 69297 || (c < 69415
                    ? (c >= 69376 && c <= 69404)
                    : c <= 69415)))))
              : (c <= 69456 || (c < 69759
                ? (c < 69600
                  ? (c < 69552
                    ? (c >= 69488 && c <= 69509)
                    : c <= 69572)
                  : (c <= 69622 || (c < 69734
                    ? (c >= 69632 && c <= 69702)
                    : c <= 69749)))
                : (c <= 69818 || (c < 69872
                  ? (c < 69840
                    ? c == 69826
                    : c <= 69864)
                  : (c <= 69881 || (c < 69942
                    ? (c >= 69888 && c <= 69940)
                    : c <= 69951)))))))))
          : (c <= 69959 || (c < 70459
            ? (c < 70282
              ? (c < 70108
                ? (c < 70016
                  ? (c < 70006
                    ? (c >= 69968 && c <= 70003)
                    : c <= 70006)
                  : (c <= 70084 || (c < 70094
                    ? (c >= 70089 && c <= 70092)
                    : c <= 70106)))
                : (c <= 70108 || (c < 70206
                  ? (c < 70163
                    ? (c >= 70144 && c <= 70161)
                    : c <= 70199)
                  : (c <= 70206 || (c < 70280
                    ? (c >= 70272 && c <= 70278)
                    : c <= 70280)))))
              : (c <= 70285 || (c < 70405
                ? (c < 70320
                  ? (c < 70303
                    ? (c >= 70287 && c <= 70301)
                    : c <= 70312)
                  : (c <= 70378 || (c < 70400
                    ? (c >= 70384 && c <= 70393)
                    : c <= 70403)))
                : (c <= 70412 || (c < 70442
                  ? (c < 70419
                    ? (c >= 70415 && c <= 70416)
                    : c <= 70440)
                  : (c <= 70448 || (c < 70453
                    ? (c >= 70450 && c <= 70451)
                    : c <= 70457)))))))
            : (c <= 70468 || (c < 70855
              ? (c < 70502
                ? (c < 70480
                  ? (c < 70475
                    ? (c >= 70471 && c <= 70472)
                    : c <= 70477)
                  : (c <= 70480 || (c < 70493
                    ? c == 70487
                    : c <= 70499)))
                : (c <= 70508 || (c < 70736
                  ? (c < 70656
                    ? (c >= 70512 && c <= 70516)
                    : c <= 70730)
                  : (c <= 70745 || (c < 70784
                    ? (c >= 70750 && c <= 70753)
                    : c <= 70853)))))
              : (c <= 70855 || (c < 71236
                ? (c < 71096
                  ? (c < 71040
                    ? (c >= 70864 && c <= 70873)
                    : c <= 71093)
                  : (c <= 71104 || (c < 71168
                    ? (c >= 71128 && c <= 71133)
                    : c <= 71232)))
                : (c <= 71236 || (c < 71360
                  ? (c < 71296
                    ? (c >= 71248 && c <= 71257)
                    : c <= 71352)
                  : (c <= 71369 || (c >= 71424 && c <= 71450)))))))))))))
      : (c <= 71467 || (c < 119973
        ? (c < 77824
          ? (c < 72760
            ? (c < 72016
              ? (c < 71945
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71472 && c <= 71481)
                    : c <= 71494)
                  : (c <= 71738 || (c < 71935
                    ? (c >= 71840 && c <= 71913)
                    : c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71989 || (c < 71995
                    ? (c >= 71991 && c <= 71992)
                    : c <= 72003)))))
              : (c <= 72025 || (c < 72263
                ? (c < 72154
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72151)
                  : (c <= 72161 || (c < 72192
                    ? (c >= 72163 && c <= 72164)
                    : c <= 72254)))
                : (c <= 72263 || (c < 72368
                  ? (c < 72349
                    ? (c >= 72272 && c <= 72345)
                    : c <= 72349)
                  : (c <= 72440 || (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72758)))))))
            : (c <= 72768 || (c < 73056
              ? (c < 72968
                ? (c < 72850
                  ? (c < 72818
                    ? (c >= 72784 && c <= 72793)
                    : c <= 72847)
                  : (c <= 72871 || (c < 72960
                    ? (c >= 72873 && c <= 72886)
                    : c <= 72966)))
                : (c <= 72969 || (c < 73020
                  ? (c < 73018
                    ? (c >= 72971 && c <= 73014)
                    : c <= 73018)
                  : (c <= 73021 || (c < 73040
                    ? (c >= 73023 && c <= 73031)
                    : c <= 73049)))))
              : (c <= 73061 || (c < 73440
                ? (c < 73104
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73102)
                  : (c <= 73105 || (c < 73120
                    ? (c >= 73107 && c <= 73112)
                    : c <= 73129)))
                : (c <= 73462 || (c < 74752
                  ? (c < 73728
                    ? c == 73648
                    : c <= 74649)
                  : (c <= 74862 || (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)))))))))
          : (c <= 78894 || (c < 110576
            ? (c < 93027
              ? (c < 92864
                ? (c < 92736
                  ? (c < 92160
                    ? (c >= 82944 && c <= 83526)
                    : c <= 92728)
                  : (c <= 92766 || (c < 92784
                    ? (c >= 92768 && c <= 92777)
                    : c <= 92862)))
                : (c <= 92873 || (c < 92928
                  ? (c < 92912
                    ? (c >= 92880 && c <= 92909)
                    : c <= 92916)
                  : (c <= 92982 || (c < 93008
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93017)))))
              : (c <= 93047 || (c < 94176
                ? (c < 93952
                  ? (c < 93760
                    ? (c >= 93053 && c <= 93071)
                    : c <= 93823)
                  : (c <= 94026 || (c < 94095
                    ? (c >= 94031 && c <= 94087)
                    : c <= 94111)))
                : (c <= 94177 || (c < 94208
                  ? (c < 94192
                    ? (c >= 94179 && c <= 94180)
                    : c <= 94193)
                  : (c <= 100343 || (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)))))))
            : (c <= 110579 || (c < 118528
              ? (c < 110960
                ? (c < 110592
                  ? (c < 110589
                    ? (c >= 110581 && c <= 110587)
                    : c <= 110590)
                  : (c <= 110882 || (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)))
                : (c <= 111355 || (c < 113792
                  ? (c < 113776
                    ? (c >= 113664 && c <= 113770)
                    : c <= 113788)
                  : (c <= 113800 || (c < 113821
                    ? (c >= 113808 && c <= 113817)
                    : c <= 113822)))))
              : (c <= 118573 || (c < 119210
                ? (c < 119149
                  ? (c < 119141
                    ? (c >= 118576 && c <= 118598)
                    : c <= 119145)
                  : (c <= 119154 || (c < 119173
                    ? (c >= 119163 && c <= 119170)
                    : c <= 119179)))
                : (c <= 119213 || (c < 119894
                  ? (c < 119808
                    ? (c >= 119362 && c <= 119364)
                    : c <= 119892)
                  : (c <= 119964 || (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static inline bool sym_identifier_character_set_4(int32_t c) {
  return (c < 43642
    ? (c < 3784
      ? (c < 2759
        ? (c < 2048
          ? (c < 1155
            ? (c < 736
              ? (c < 183
                ? (c < 'a'
                  ? (c < 'A'
                    ? (c >= '0' && c <= '9')
                    : c <= 'Z')
                  : (c <= 'z' || (c < 181
                    ? c == 170
                    : c <= 181)))
                : (c <= 183 || (c < 216
                  ? (c < 192
                    ? c == 186
                    : c <= 214)
                  : (c <= 246 || (c < 710
                    ? (c >= 248 && c <= 705)
                    : c <= 721)))))
              : (c <= 740 || (c < 895
                ? (c < 768
                  ? (c < 750
                    ? c == 748
                    : c <= 750)
                  : (c <= 884 || (c < 891
                    ? (c >= 886 && c <= 887)
                    : c <= 893)))
                : (c <= 895 || (c < 910
                  ? (c < 908
                    ? (c >= 902 && c <= 906)
                    : c <= 908)
                  : (c <= 929 || (c < 1015
                    ? (c >= 931 && c <= 1013)
                    : c <= 1153)))))))
            : (c <= 1159 || (c < 1552
              ? (c < 1471
                ? (c < 1369
                  ? (c < 1329
                    ? (c >= 1162 && c <= 1327)
                    : c <= 1366)
                  : (c <= 1369 || (c < 1425
                    ? (c >= 1376 && c <= 1416)
                    : c <= 1469)))
                : (c <= 1471 || (c < 1479
                  ? (c < 1476
                    ? (c >= 1473 && c <= 1474)
                    : c <= 1477)
                  : (c <= 1479 || (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)))))
              : (c <= 1562 || (c < 1791
                ? (c < 1749
                  ? (c < 1646
                    ? (c >= 1568 && c <= 1641)
                    : c <= 1747)
                  : (c <= 1756 || (c < 1770
                    ? (c >= 1759 && c <= 1768)
                    : c <= 1788)))
                : (c <= 1791 || (c < 1984
                  ? (c < 1869
                    ? (c >= 1808 && c <= 1866)
                    : c <= 1969)
                  : (c <= 2037 || (c < 2045
                    ? c == 2042
                    : c <= 2045)))))))))
          : (c <= 2093 || (c < 2561
            ? (c < 2474
              ? (c < 2275
                ? (c < 2160
                  ? (c < 2144
                    ? (c >= 2112 && c <= 2139)
                    : c <= 2154)
                  : (c <= 2183 || (c < 2200
                    ? (c >= 2185 && c <= 2190)
                    : c <= 2273)))
                : (c <= 2403 || (c < 2437
                  ? (c < 2417
                    ? (c >= 2406 && c <= 2415)
                    : c <= 2435)
                  : (c <= 2444 || (c < 2451
                    ? (c >= 2447 && c <= 2448)
                    : c <= 2472)))))
              : (c <= 2480 || (c < 2519
                ? (c < 2492
                  ? (c < 2486
                    ? c == 2482
                    : c <= 2489)
                  : (c <= 2500 || (c < 2507
                    ? (c >= 2503 && c <= 2504)
                    : c <= 2510)))
                : (c <= 2519 || (c < 2534
                  ? (c < 2527
                    ? (c >= 2524 && c <= 2525)
                    : c <= 2531)
                  : (c <= 2545 || (c < 2558
                    ? c == 2556
                    : c <= 2558)))))))
            : (c <= 2563 || (c < 2641
              ? (c < 2613
                ? (c < 2579
                  ? (c < 2575
                    ? (c >= 2565 && c <= 2570)
                    : c <= 2576)
                  : (c <= 2600 || (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)))
                : (c <= 2614 || (c < 2622
                  ? (c < 2620
                    ? (c >= 2616 && c <= 2617)
                    : c <= 2620)
                  : (c <= 2626 || (c < 2635
                    ? (c >= 2631 && c <= 2632)
                    : c <= 2637)))))
              : (c <= 2641 || (c < 2703
                ? (c < 2662
                  ? (c < 2654
                    ? (c >= 2649 && c <= 2652)
                    : c <= 2654)
                  : (c <= 2677 || (c < 2693
                    ? (c >= 2689 && c <= 2691)
                    : c <= 2701)))
                : (c <= 2705 || (c < 2738
                  ? (c < 2730
                    ? (c >= 2707 && c <= 2728)
                    : c <= 2736)
                  : (c <= 2739 || (c < 2748
                    ? (c >= 2741 && c <= 2745)
                    : c <= 2757)))))))))))
        : (c <= 2761 || (c < 3174
          ? (c < 2962
            ? (c < 2869
              ? (c < 2817
                ? (c < 2784
                  ? (c < 2768
                    ? (c >= 2763 && c <= 2765)
                    : c <= 2768)
                  : (c <= 2787 || (c < 2809
                    ? (c >= 2790 && c <= 2799)
                    : c <= 2815)))
                : (c <= 2819 || (c < 2835
                  ? (c < 2831
                    ? (c >= 2821 && c <= 2828)
                    : c <= 2832)
                  : (c <= 2856 || (c < 2866
                    ? (c >= 2858 && c <= 2864)
                    : c <= 2867)))))
              : (c <= 2873 || (c < 2911
                ? (c < 2891
                  ? (c < 2887
                    ? (c >= 2876 && c <= 2884)
                    : c <= 2888)
                  : (c <= 2893 || (c < 2908
                    ? (c >= 2901 && c <= 2903)
                    : c <= 2909)))
                : (c <= 2915 || (c < 2946
                  ? (c < 2929
                    ? (c >= 2918 && c <= 2927)
                    : c <= 2929)
                  : (c <= 2947 || (c < 2958
                    ? (c >= 2949 && c <= 2954)
                    : c <= 2960)))))))
            : (c <= 2965 || (c < 3046
              ? (c < 2990
                ? (c < 2974
                  ? (c < 2972
                    ? (c >= 2969 && c <= 2970)
                    : c <= 2972)
                  : (c <= 2975 || (c < 2984
                    ? (c >= 2979 && c <= 2980)
                    : c <= 2986)))
                : (c <= 3001 || (c < 3018
                  ? (c < 3014
                    ? (c >= 3006 && c <= 3010)
                    : c <= 3016)
                  : (c <= 3021 || (c < 3031
                    ? c == 3024
                    : c <= 3031)))))
              : (c <= 3055 || (c < 3142
                ? (c < 3090
                  ? (c < 3086
                    ? (c >= 3072 && c <= 3084)
                    : c <= 3088)
                  : (c <= 3112 || (c < 3132
                    ? (c >= 3114 && c <= 3129)
                    : c <= 3140)))
                : (c <= 3144 || (c < 3160
                  ? (c < 3157
                    ? (c >= 3146 && c <= 3149)
                    : c <= 3158)
                  : (c <= 3162 || (c < 3168
                    ? c == 3165
                    : c <= 3171)))))))))
          : (c <= 3183 || (c < 3457
            ? (c < 3296
              ? (c < 3253
                ? (c < 3214
                  ? (c < 3205
                    ? (c >= 3200 && c <= 3203)
                    : c <= 3212)
                  : (c <= 3216 || (c < 3242
                    ? (c >= 3218 && c <= 3240)
                    : c <= 3251)))
                : (c <= 3257 || (c < 3274
                  ? (c < 3270
                    ? (c >= 3260 && c <= 3268)
                    : c <= 3272)
                  : (c <= 3277 || (c < 3293
                    ? (c >= 3285 && c <= 3286)
                    : c <= 3294)))))
              : (c <= 3299 || (c < 3398
                ? (c < 3328
                  ? (c < 3313
                    ? (c >= 3302 && c <= 3311)
                    : c <= 3314)
                  : (c <= 3340 || (c < 3346
                    ? (c >= 3342 && c <= 3344)
                    : c <= 3396)))
                : (c <= 3400 || (c < 3423
                  ? (c < 3412
                    ? (c >= 3402 && c <= 3406)
                    : c <= 3415)
                  : (c <= 3427 || (c < 3450
                    ? (c >= 3430 && c <= 3439)
                    : c <= 3455)))))))
            : (c <= 3459 || (c < 3585
              ? (c < 3530
                ? (c < 3507
                  ? (c < 3482
                    ? (c >= 3461 && c <= 3478)
                    : c <= 3505)
                  : (c <= 3515 || (c < 3520
                    ? c == 3517
                    : c <= 3526)))
                : (c <= 3530 || (c < 3544
                  ? (c < 3542
                    ? (c >= 3535 && c <= 3540)
                    : c <= 3542)
                  : (c <= 3551 || (c < 3570
                    ? (c >= 3558 && c <= 3567)
                    : c <= 3571)))))
              : (c <= 3642 || (c < 3724
                ? (c < 3713
                  ? (c < 3664
                    ? (c >= 3648 && c <= 3662)
                    : c <= 3673)
                  : (c <= 3714 || (c < 3718
                    ? c == 3716
                    : c <= 3722)))
                : (c <= 3747 || (c < 3776
                  ? (c < 3751
                    ? c == 3749
                    : c <= 3773)
                  : (c <= 3780 || c == 3782))))))))))))
      : (c <= 3789 || (c < 8027
        ? (c < 5919
          ? (c < 4696
            ? (c < 3974
              ? (c < 3893
                ? (c < 3840
                  ? (c < 3804
                    ? (c >= 3792 && c <= 3801)
                    : c <= 3807)
                  : (c <= 3840 || (c < 3872
                    ? (c >= 3864 && c <= 3865)
                    : c <= 3881)))
                : (c <= 3893 || (c < 3902
                  ? (c < 3897
                    ? c == 3895
                    : c <= 3897)
                  : (c <= 3911 || (c < 3953
                    ? (c >= 3913 && c <= 3948)
                    : c <= 3972)))))
              : (c <= 3991 || (c < 4295
                ? (c < 4096
                  ? (c < 4038
                    ? (c >= 3993 && c <= 4028)
                    : c <= 4038)
                  : (c <= 4169 || (c < 4256
                    ? (c >= 4176 && c <= 4253)
                    : c <= 4293)))
                : (c <= 4295 || (c < 4348
                  ? (c < 4304
                    ? c == 4301
                    : c <= 4346)
                  : (c <= 4680 || (c < 4688
                    ? (c >= 4682 && c <= 4685)
                    : c <= 4694)))))))
            : (c <= 4696 || (c < 4888
              ? (c < 4792
                ? (c < 4746
                  ? (c < 4704
                    ? (c >= 4698 && c <= 4701)
                    : c <= 4744)
                  : (c <= 4749 || (c < 4786
                    ? (c >= 4752 && c <= 4784)
                    : c <= 4789)))
                : (c <= 4798 || (c < 4808
                  ? (c < 4802
                    ? c == 4800
                    : c <= 4805)
                  : (c <= 4822 || (c < 4882
                    ? (c >= 4824 && c <= 4880)
                    : c <= 4885)))))
              : (c <= 4954 || (c < 5121
                ? (c < 4992
                  ? (c < 4969
                    ? (c >= 4957 && c <= 4959)
                    : c <= 4977)
                  : (c <= 5007 || (c < 5112
                    ? (c >= 5024 && c <= 5109)
                    : c <= 5117)))
                : (c <= 5740 || (c < 5792
                  ? (c < 5761
                    ? (c >= 5743 && c <= 5759)
                    : c <= 5786)
                  : (c <= 5866 || (c < 5888
                    ? (c >= 5870 && c <= 5880)
                    : c <= 5909)))))))))
          : (c <= 5940 || (c < 6752
            ? (c < 6272
              ? (c < 6103
                ? (c < 5998
                  ? (c < 5984
                    ? (c >= 5952 && c <= 5971)
                    : c <= 5996)
                  : (c <= 6000 || (c < 6016
                    ? (c >= 6002 && c <= 6003)
                    : c <= 6099)))
                : (c <= 6103 || (c < 6155
                  ? (c < 6112
                    ? (c >= 6108 && c <= 6109)
                    : c <= 6121)
                  : (c <= 6157 || (c < 6176
                    ? (c >= 6159 && c <= 6169)
                    : c <= 6264)))))
              : (c <= 6314 || (c < 6512
                ? (c < 6432
                  ? (c < 6400
                    ? (c >= 6320 && c <= 6389)
                    : c <= 6430)
                  : (c <= 6443 || (c < 6470
                    ? (c >= 6448 && c <= 6459)
                    : c <= 6509)))
                : (c <= 6516 || (c < 6608
                  ? (c < 6576
                    ? (c >= 6528 && c <= 6571)
                    : c <= 6601)
                  : (c <= 6618 || (c < 6688
                    ? (c >= 6656 && c <= 6683)
                    : c <= 6750)))))))
            : (c <= 6780 || (c < 7245
              ? (c < 6912
                ? (c < 6823
                  ? (c < 6800
                    ? (c >= 6783 && c <= 6793)
                    : c <= 6809)
                  : (c <= 6823 || (c < 6847
                    ? (c >= 6832 && c <= 6845)
                    : c <= 6862)))
                : (c <= 6988 || (c < 7040
                  ? (c < 7019
                    ? (c >= 6992 && c <= 7001)
                    : c <= 7027)
                  : (c <= 7155 || (c < 7232
                    ? (c >= 7168 && c <= 7223)
                    : c <= 7241)))))
              : (c <= 7293 || (c < 7424
                ? (c < 7357
                  ? (c < 7312
                    ? (c >= 7296 && c <= 7304)
                    : c <= 7354)
                  : (c <= 7359 || (c < 7380
                    ? (c >= 7376 && c <= 7378)
                    : c <= 7418)))
                : (c <= 7957 || (c < 8008
                  ? (c < 7968
                    ? (c >= 7960 && c <= 7965)
                    : c <= 8005)
                  : (c <= 8013 || (c < 8025
                    ? (c >= 8016 && c <= 8023)
                    : c <= 8025)))))))))))
        : (c <= 8027 || (c < 11728
          ? (c < 8469
            ? (c < 8182
              ? (c < 8130
                ? (c < 8064
                  ? (c < 8031
                    ? c == 8029
                    : c <= 8061)
                  : (c <= 8116 || (c < 8126
                    ? (c >= 8118 && c <= 8124)
                    : c <= 8126)))
                : (c <= 8132 || (c < 8150
                  ? (c < 8144
                    ? (c >= 8134 && c <= 8140)
                    : c <= 8147)
                  : (c <= 8155 || (c < 8178
                    ? (c >= 8160 && c <= 8172)
                    : c <= 8180)))))
              : (c <= 8188 || (c < 8400
                ? (c < 8305
                  ? (c < 8276
                    ? (c >= 8255 && c <= 8256)
                    : c <= 8276)
                  : (c <= 8305 || (c < 8336
                    ? c == 8319
                    : c <= 8348)))
                : (c <= 8412 || (c < 8450
                  ? (c < 8421
                    ? c == 8417
                    : c <= 8432)
                  : (c <= 8450 || (c < 8458
                    ? c == 8455
                    : c <= 8467)))))))
            : (c <= 8469 || (c < 11520
              ? (c < 8508
                ? (c < 8486
                  ? (c < 8484
                    ? (c >= 8472 && c <= 8477)
                    : c <= 8484)
                  : (c <= 8486 || (c < 8490
                    ? c == 8488
                    : c <= 8505)))
                : (c <= 8511 || (c < 8544
                  ? (c < 8526
                    ? (c >= 8517 && c <= 8521)
                    : c <= 8526)
                  : (c <= 8584 || (c < 11499
                    ? (c >= 11264 && c <= 11492)
                    : c <= 11507)))))
              : (c <= 11557 || (c < 11680
                ? (c < 11568
                  ? (c < 11565
                    ? c == 11559
                    : c <= 11565)
                  : (c <= 11623 || (c < 11647
                    ? c == 11631
                    : c <= 11670)))
                : (c <= 11686 || (c < 11704
                  ? (c < 11696
                    ? (c >= 11688 && c <= 11694)
                    : c <= 11702)
                  : (c <= 11710 || (c < 11720
                    ? (c >= 11712 && c <= 11718)
                    : c <= 11726)))))))))
          : (c <= 11734 || (c < 42775
            ? (c < 12549
              ? (c < 12344
                ? (c < 12293
                  ? (c < 11744
                    ? (c >= 11736 && c <= 11742)
                    : c <= 11775)
                  : (c <= 12295 || (c < 12337
                    ? (c >= 12321 && c <= 12335)
                    : c <= 12341)))
                : (c <= 12348 || (c < 12445
                  ? (c < 12441
                    ? (c >= 12353 && c <= 12438)
                    : c <= 12442)
                  : (c <= 12447 || (c < 12540
                    ? (c >= 12449 && c <= 12538)
                    : c <= 12543)))))
              : (c <= 12591 || (c < 42192
                ? (c < 12784
                  ? (c < 12704
                    ? (c >= 12593 && c <= 12686)
                    : c <= 12735)
                  : (c <= 12799 || (c < 19968
                    ? (c >= 13312 && c <= 19903)
                    : c <= 42124)))
                : (c <= 42237 || (c < 42560
                  ? (c < 42512
                    ? (c >= 42240 && c <= 42508)
                    : c <= 42539)
                  : (c <= 42607 || (c < 42623
                    ? (c >= 42612 && c <= 42621)
                    : c <= 42737)))))))
            : (c <= 42783 || (c < 43259
              ? (c < 42994
                ? (c < 42960
                  ? (c < 42891
                    ? (c >= 42786 && c <= 42888)
                    : c <= 42954)
                  : (c <= 42961 || (c < 42965
                    ? c == 42963
                    : c <= 42969)))
                : (c <= 43047 || (c < 43136
                  ? (c < 43072
                    ? c == 43052
                    : c <= 43123)
                  : (c <= 43205 || (c < 43232
                    ? (c >= 43216 && c <= 43225)
                    : c <= 43255)))))
              : (c <= 43259 || (c < 43488
                ? (c < 43360
                  ? (c < 43312
                    ? (c >= 43261 && c <= 43309)
                    : c <= 43347)
                  : (c <= 43388 || (c < 43471
                    ? (c >= 43392 && c <= 43456)
                    : c <= 43481)))
                : (c <= 43518 || (c < 43600
                  ? (c < 43584
                    ? (c >= 43520 && c <= 43574)
                    : c <= 43597)
                  : (c <= 43609 || (c >= 43616 && c <= 43638)))))))))))))))
    : (c <= 43714 || (c < 71472
      ? (c < 67644
        ? (c < 65382
          ? (c < 64318
            ? (c < 44012
              ? (c < 43793
                ? (c < 43762
                  ? (c < 43744
                    ? (c >= 43739 && c <= 43741)
                    : c <= 43759)
                  : (c <= 43766 || (c < 43785
                    ? (c >= 43777 && c <= 43782)
                    : c <= 43790)))
                : (c <= 43798 || (c < 43824
                  ? (c < 43816
                    ? (c >= 43808 && c <= 43814)
                    : c <= 43822)
                  : (c <= 43866 || (c < 43888
                    ? (c >= 43868 && c <= 43881)
                    : c <= 44010)))))
              : (c <= 44013 || (c < 64112
                ? (c < 55216
                  ? (c < 44032
                    ? (c >= 44016 && c <= 44025)
                    : c <= 55203)
                  : (c <= 55238 || (c < 63744
                    ? (c >= 55243 && c <= 55291)
                    : c <= 64109)))
                : (c <= 64217 || (c < 64285
                  ? (c < 64275
                    ? (c >= 64256 && c <= 64262)
                    : c <= 64279)
                  : (c <= 64296 || (c < 64312
                    ? (c >= 64298 && c <= 64310)
                    : c <= 64316)))))))
            : (c <= 64318 || (c < 65101
              ? (c < 64848
                ? (c < 64326
                  ? (c < 64323
                    ? (c >= 64320 && c <= 64321)
                    : c <= 64324)
                  : (c <= 64433 || (c < 64612
                    ? (c >= 64467 && c <= 64605)
                    : c <= 64829)))
                : (c <= 64911 || (c < 65024
                  ? (c < 65008
                    ? (c >= 64914 && c <= 64967)
                    : c <= 65017)
                  : (c <= 65039 || (c < 65075
                    ? (c >= 65056 && c <= 65071)
                    : c <= 65076)))))
              : (c <= 65103 || (c < 65149
                ? (c < 65143
                  ? (c < 65139
                    ? c == 65137
                    : c <= 65139)
                  : (c <= 65143 || (c < 65147
                    ? c == 65145
                    : c <= 65147)))
                : (c <= 65149 || (c < 65313
                  ? (c < 65296
                    ? (c >= 65151 && c <= 65276)
                    : c <= 65305)
                  : (c <= 65338 || (c < 65345
                    ? c == 65343
                    : c <= 65370)))))))))
          : (c <= 65470 || (c < 66560
            ? (c < 65856
              ? (c < 65549
                ? (c < 65490
                  ? (c < 65482
                    ? (c >= 65474 && c <= 65479)
                    : c <= 65487)
                  : (c <= 65495 || (c < 65536
                    ? (c >= 65498 && c <= 65500)
                    : c <= 65547)))
                : (c <= 65574 || (c < 65599
                  ? (c < 65596
                    ? (c >= 65576 && c <= 65594)
                    : c <= 65597)
                  : (c <= 65613 || (c < 65664
                    ? (c >= 65616 && c <= 65629)
                    : c <= 65786)))))
              : (c <= 65908 || (c < 66349
                ? (c < 66208
                  ? (c < 66176
                    ? c == 66045
                    : c <= 66204)
                  : (c <= 66256 || (c < 66304
                    ? c == 66272
                    : c <= 66335)))
                : (c <= 66378 || (c < 66464
                  ? (c < 66432
                    ? (c >= 66384 && c <= 66426)
                    : c <= 66461)
                  : (c <= 66499 || (c < 66513
                    ? (c >= 66504 && c <= 66511)
                    : c <= 66517)))))))
            : (c <= 66717 || (c < 66995
              ? (c < 66928
                ? (c < 66776
                  ? (c < 66736
                    ? (c >= 66720 && c <= 66729)
                    : c <= 66771)
                  : (c <= 66811 || (c < 66864
                    ? (c >= 66816 && c <= 66855)
                    : c <= 66915)))
                : (c <= 66938 || (c < 66964
                  ? (c < 66956
                    ? (c >= 66940 && c <= 66954)
                    : c <= 66962)
                  : (c <= 66965 || (c < 66979
                    ? (c >= 66967 && c <= 66977)
                    : c <= 66993)))))
              : (c <= 67001 || (c < 67463
                ? (c < 67392
                  ? (c < 67072
                    ? (c >= 67003 && c <= 67004)
                    : c <= 67382)
                  : (c <= 67413 || (c < 67456
                    ? (c >= 67424 && c <= 67431)
                    : c <= 67461)))
                : (c <= 67504 || (c < 67592
                  ? (c < 67584
                    ? (c >= 67506 && c <= 67514)
                    : c <= 67589)
                  : (c <= 67592 || (c < 67639
                    ? (c >= 67594 && c <= 67637)
                    : c <= 67640)))))))))))
        : (c <= 67644 || (c < 69968
          ? (c < 68480
            ? (c < 68108
              ? (c < 67840
                ? (c < 67712
                  ? (c < 67680
                    ? (c >= 67647 && c <= 67669)
                    : c <= 67702)
                  : (c <= 67742 || (c < 67828
                    ? (c >= 67808 && c <= 67826)
                    : c <= 67829)))
                : (c <= 67861 || (c < 68030
                  ? (c < 67968
                    ? (c >= 67872 && c <= 67897)
                    : c <= 68023)
                  : (c <= 68031 || (c < 68101
                    ? (c >= 68096 && c <= 68099)
                    : c <= 68102)))))
              : (c <= 68115 || (c < 68224
                ? (c < 68152
                  ? (c < 68121
                    ? (c >= 68117 && c <= 68119)
                    : c <= 68149)
                  : (c <= 68154 || (c < 68192
                    ? c == 68159
                    : c <= 68220)))
                : (c <= 68252 || (c < 68352
                  ? (c < 68297
                    ? (c >= 68288 && c <= 68295)
                    : c <= 68326)
                  : (c <= 68405 || (c < 68448
                    ? (c >= 68416 && c <= 68437)
                    : c <= 68466)))))))
            : (c <= 68497 || (c < 69488
              ? (c < 69248
                ? (c < 68800
                  ? (c < 68736
                    ? (c >= 68608 && c <= 68680)
                    : c <= 68786)
                  : (c <= 68850 || (c < 68912
                    ? (c >= 68864 && c <= 68903)
                    : c <= 68921)))
                : (c <= 69289 || (c < 69376
                  ? (c < 69296
                    ? (c >= 69291 && c <= 69292)
                    : c <= 69297)
                  : (c <= 69404 || (c < 69424
                    ? c == 69415
                    : c <= 69456)))))
              : (c <= 69509 || (c < 69826
                ? (c < 69632
                  ? (c < 69600
                    ? (c >= 69552 && c <= 69572)
                    : c <= 69622)
                  : (c <= 69702 || (c < 69759
                    ? (c >= 69734 && c <= 69749)
                    : c <= 69818)))
                : (c <= 69826 || (c < 69888
                  ? (c < 69872
                    ? (c >= 69840 && c <= 69864)
                    : c <= 69881)
                  : (c <= 69940 || (c < 69956
                    ? (c >= 69942 && c <= 69951)
                    : c <= 69959)))))))))
          : (c <= 70003 || (c < 70471
            ? (c < 70287
              ? (c < 70144
                ? (c < 70089
                  ? (c < 70016
                    ? c == 70006
                    : c <= 70084)
                  : (c <= 70092 || (c < 70108
                    ? (c >= 70094 && c <= 70106)
                    : c <= 70108)))
                : (c <= 70161 || (c < 70272
                  ? (c < 70206
                    ? (c >= 70163 && c <= 70199)
                    : c <= 70206)
                  : (c <= 70278 || (c < 70282
                    ? c == 70280
                    : c <= 70285)))))
              : (c <= 70301 || (c < 70415
                ? (c < 70384
                  ? (c < 70320
                    ? (c >= 70303 && c <= 70312)
                    : c <= 70378)
                  : (c <= 70393 || (c < 70405
                    ? (c >= 70400 && c <= 70403)
                    : c <= 70412)))
                : (c <= 70416 || (c < 70450
                  ? (c < 70442
                    ? (c >= 70419 && c <= 70440)
                    : c <= 70448)
                  : (c <= 70451 || (c < 70459
                    ? (c >= 70453 && c <= 70457)
                    : c <= 70468)))))))
            : (c <= 70472 || (c < 70864
              ? (c < 70512
                ? (c < 70487
                  ? (c < 70480
                    ? (c >= 70475 && c <= 70477)
                    : c <= 70480)
                  : (c <= 70487 || (c < 70502
                    ? (c >= 70493 && c <= 70499)
                    : c <= 70508)))
                : (c <= 70516 || (c < 70750
                  ? (c < 70736
                    ? (c >= 70656 && c <= 70730)
                    : c <= 70745)
                  : (c <= 70753 || (c < 70855
                    ? (c >= 70784 && c <= 70853)
                    : c <= 70855)))))
              : (c <= 70873 || (c < 71248
                ? (c < 71128
                  ? (c < 71096
                    ? (c >= 71040 && c <= 71093)
                    : c <= 71104)
                  : (c <= 71133 || (c < 71236
                    ? (c >= 71168 && c <= 71232)
                    : c <= 71236)))
                : (c <= 71257 || (c < 71424
                  ? (c < 71360
                    ? (c >= 71296 && c <= 71352)
                    : c <= 71369)
                  : (c <= 71450 || (c >= 71453 && c <= 71467)))))))))))))
      : (c <= 71481 || (c < 119973
        ? (c < 82944
          ? (c < 72784
            ? (c < 72096
              ? (c < 71948
                ? (c < 71840
                  ? (c < 71680
                    ? (c >= 71488 && c <= 71494)
                    : c <= 71738)
                  : (c <= 71913 || (c < 71945
                    ? (c >= 71935 && c <= 71942)
                    : c <= 71945)))
                : (c <= 71955 || (c < 71991
                  ? (c < 71960
                    ? (c >= 71957 && c <= 71958)
                    : c <= 71989)
                  : (c <= 71992 || (c < 72016
                    ? (c >= 71995 && c <= 72003)
                    : c <= 72025)))))
              : (c <= 72103 || (c < 72272
                ? (c < 72163
                  ? (c < 72154
                    ? (c >= 72106 && c <= 72151)
                    : c <= 72161)
                  : (c <= 72164 || (c < 72263
                    ? (c >= 72192 && c <= 72254)
                    : c <= 72263)))
                : (c <= 72345 || (c < 72704
                  ? (c < 72368
                    ? c == 72349
                    : c <= 72440)
                  : (c <= 72712 || (c < 72760
                    ? (c >= 72714 && c <= 72758)
                    : c <= 72768)))))))
            : (c <= 72793 || (c < 73063
              ? (c < 72971
                ? (c < 72873
                  ? (c < 72850
                    ? (c >= 72818 && c <= 72847)
                    : c <= 72871)
                  : (c <= 72886 || (c < 72968
                    ? (c >= 72960 && c <= 72966)
                    : c <= 72969)))
                : (c <= 73014 || (c < 73023
                  ? (c < 73020
                    ? c == 73018
                    : c <= 73021)
                  : (c <= 73031 || (c < 73056
                    ? (c >= 73040 && c <= 73049)
                    : c <= 73061)))))
              : (c <= 73064 || (c < 73648
                ? (c < 73107
                  ? (c < 73104
                    ? (c >= 73066 && c <= 73102)
                    : c <= 73105)
                  : (c <= 73112 || (c < 73440
                    ? (c >= 73120 && c <= 73129)
                    : c <= 73462)))
                : (c <= 73648 || (c < 74880
                  ? (c < 74752
                    ? (c >= 73728 && c <= 74649)
                    : c <= 74862)
                  : (c <= 75075 || (c < 77824
                    ? (c >= 77712 && c <= 77808)
                    : c <= 78894)))))))))
          : (c <= 83526 || (c < 110581
            ? (c < 93053
              ? (c < 92880
                ? (c < 92768
                  ? (c < 92736
                    ? (c >= 92160 && c <= 92728)
                    : c <= 92766)
                  : (c <= 92777 || (c < 92864
                    ? (c >= 92784 && c <= 92862)
                    : c <= 92873)))
                : (c <= 92909 || (c < 92992
                  ? (c < 92928
                    ? (c >= 92912 && c <= 92916)
                    : c <= 92982)
                  : (c <= 92995 || (c < 93027
                    ? (c >= 93008 && c <= 93017)
                    : c <= 93047)))))
              : (c <= 93071 || (c < 94179
                ? (c < 94031
                  ? (c < 93952
                    ? (c >= 93760 && c <= 93823)
                    : c <= 94026)
                  : (c <= 94087 || (c < 94176
                    ? (c >= 94095 && c <= 94111)
                    : c <= 94177)))
                : (c <= 94180 || (c < 100352
                  ? (c < 94208
                    ? (c >= 94192 && c <= 94193)
                    : c <= 100343)
                  : (c <= 101589 || (c < 110576
                    ? (c >= 101632 && c <= 101640)
                    : c <= 110579)))))))
            : (c <= 110587 || (c < 118576
              ? (c < 113664
                ? (c < 110928
                  ? (c < 110592
                    ? (c >= 110589 && c <= 110590)
                    : c <= 110882)
                  : (c <= 110930 || (c < 110960
                    ? (c >= 110948 && c <= 110951)
                    : c <= 111355)))
                : (c <= 113770 || (c < 113808
                  ? (c < 113792
                    ? (c >= 113776 && c <= 113788)
                    : c <= 113800)
                  : (c <= 113817 || (c < 118528
                    ? (c >= 113821 && c <= 113822)
                    : c <= 118573)))))
              : (c <= 118598 || (c < 119362
                ? (c < 119163
                  ? (c < 119149
                    ? (c >= 119141 && c <= 119145)
                    : c <= 119154)
                  : (c <= 119170 || (c < 119210
                    ? (c >= 119173 && c <= 119179)
                    : c <= 119213)))
                : (c <= 119364 || (c < 119966
                  ? (c < 119894
                    ? (c >= 119808 && c <= 119892)
                    : c <= 119964)
                  : (c <= 119967 || c == 119970))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static inline bool sym_identifier_character_set_5(int32_t c) {
  return (c < 43616
    ? (c < 3782
      ? (c < 2748
        ? (c < 2045
          ? (c < 1015
            ? (c < 710
              ? (c < 181
                ? (c < '_'
                  ? (c < 'A'
                    ? (c >= '0' && c <= '9')
                    : c <= 'Z')
                  : (c <= '_' || (c < 170
                    ? (c >= 'b' && c <= 'z')
                    : c <= 170)))
                : (c <= 181 || (c < 192
                  ? (c < 186
                    ? c == 183
                    : c <= 186)
                  : (c <= 214 || (c < 248
                    ? (c >= 216 && c <= 246)
                    : c <= 705)))))
              : (c <= 721 || (c < 891
                ? (c < 750
                  ? (c < 748
                    ? (c >= 736 && c <= 740)
                    : c <= 748)
                  : (c <= 750 || (c < 886
                    ? (c >= 768 && c <= 884)
                    : c <= 887)))
                : (c <= 893 || (c < 908
                  ? (c < 902
                    ? c == 895
                    : c <= 906)
                  : (c <= 908 || (c < 931
                    ? (c >= 910 && c <= 929)
                    : c <= 1013)))))))
            : (c <= 1153 || (c < 1519
              ? (c < 1425
                ? (c < 1329
                  ? (c < 1162
                    ? (c >= 1155 && c <= 1159)
                    : c <= 1327)
                  : (c <= 1366 || (c < 1376
                    ? c == 1369
                    : c <= 1416)))
                : (c <= 1469 || (c < 1476
                  ? (c < 1473
                    ? c == 1471
                    : c <= 1474)
                  : (c <= 1477 || (c < 1488
                    ? c == 1479
                    : c <= 1514)))))
              : (c <= 1522 || (c < 1770
                ? (c < 1646
                  ? (c < 1568
                    ? (c >= 1552 && c <= 1562)
                    : c <= 1641)
                  : (c <= 1747 || (c < 1759
                    ? (c >= 1749 && c <= 1756)
                    : c <= 1768)))
                : (c <= 1788 || (c < 1869
                  ? (c < 1808
                    ? c == 1791
                    : c <= 1866)
                  : (c <= 1969 || (c < 2042
                    ? (c >= 1984 && c <= 2037)
                    : c <= 2042)))))))))
          : (c <= 2045 || (c < 2558
            ? (c < 2451
              ? (c < 2200
                ? (c < 2144
                  ? (c < 2112
                    ? (c >= 2048 && c <= 2093)
                    : c <= 2139)
                  : (c <= 2154 || (c < 2185
                    ? (c >= 2160 && c <= 2183)
                    : c <= 2190)))
                : (c <= 2273 || (c < 2417
                  ? (c < 2406
                    ? (c >= 2275 && c <= 2403)
                    : c <= 2415)
                  : (c <= 2435 || (c < 2447
                    ? (c >= 2437 && c <= 2444)
                    : c <= 2448)))))
              : (c <= 2472 || (c < 2507
                ? (c < 2486
                  ? (c < 2482
                    ? (c >= 2474 && c <= 2480)
                    : c <= 2482)
                  : (c <= 2489 || (c < 2503
                    ? (c >= 2492 && c <= 2500)
                    : c <= 2504)))
                : (c <= 2510 || (c < 2527
                  ? (c < 2524
                    ? c == 2519
                    : c <= 2525)
                  : (c <= 2531 || (c < 2556
                    ? (c >= 2534 && c <= 2545)
                    : c <= 2556)))))))
            : (c <= 2558 || (c < 2635
              ? (c < 2610
                ? (c < 2575
                  ? (c < 2565
                    ? (c >= 2561 && c <= 2563)
                    : c <= 2570)
                  : (c <= 2576 || (c < 2602
                    ? (c >= 2579 && c <= 2600)
                    : c <= 2608)))
                : (c <= 2611 || (c < 2620
                  ? (c < 2616
                    ? (c >= 2613 && c <= 2614)
                    : c <= 2617)
                  : (c <= 2620 || (c < 2631
                    ? (c >= 2622 && c <= 2626)
                    : c <= 2632)))))
              : (c <= 2637 || (c < 2693
                ? (c < 2654
                  ? (c < 2649
                    ? c == 2641
                    : c <= 2652)
                  : (c <= 2654 || (c < 2689
                    ? (c >= 2662 && c <= 2677)
                    : c <= 2691)))
                : (c <= 2701 || (c < 2730
                  ? (c < 2707
                    ? (c >= 2703 && c <= 2705)
                    : c <= 2728)
                  : (c <= 2736 || (c < 2741
                    ? (c >= 2738 && c <= 2739)
                    : c <= 2745)))))))))))
        : (c <= 2757 || (c < 3168
          ? (c < 2958
            ? (c < 2866
              ? (c < 2809
                ? (c < 2768
                  ? (c < 2763
                    ? (c >= 2759 && c <= 2761)
                    : c <= 2765)
                  : (c <= 2768 || (c < 2790
                    ? (c >= 2784 && c <= 2787)
                    : c <= 2799)))
                : (c <= 2815 || (c < 2831
                  ? (c < 2821
                    ? (c >= 2817 && c <= 2819)
                    : c <= 2828)
                  : (c <= 2832 || (c < 2858
                    ? (c >= 2835 && c <= 2856)
                    : c <= 2864)))))
              : (c <= 2867 || (c < 2908
                ? (c < 2887
                  ? (c < 2876
                    ? (c >= 2869 && c <= 2873)
                    : c <= 2884)
                  : (c <= 2888 || (c < 2901
                    ? (c >= 2891 && c <= 2893)
                    : c <= 2903)))
                : (c <= 2909 || (c < 2929
                  ? (c < 2918
                    ? (c >= 2911 && c <= 2915)
                    : c <= 2927)
                  : (c <= 2929 || (c < 2949
                    ? (c >= 2946 && c <= 2947)
                    : c <= 2954)))))))
            : (c <= 2960 || (c < 3031
              ? (c < 2984
                ? (c < 2972
                  ? (c < 2969
                    ? (c >= 2962 && c <= 2965)
                    : c <= 2970)
                  : (c <= 2972 || (c < 2979
                    ? (c >= 2974 && c <= 2975)
                    : c <= 2980)))
                : (c <= 2986 || (c < 3014
                  ? (c < 3006
                    ? (c >= 2990 && c <= 3001)
                    : c <= 3010)
                  : (c <= 3016 || (c < 3024
                    ? (c >= 3018 && c <= 3021)
                    : c <= 3024)))))
              : (c <= 3031 || (c < 3132
                ? (c < 3086
                  ? (c < 3072
                    ? (c >= 3046 && c <= 3055)
                    : c <= 3084)
                  : (c <= 3088 || (c < 3114
                    ? (c >= 3090 && c <= 3112)
                    : c <= 3129)))
                : (c <= 3140 || (c < 3157
                  ? (c < 3146
                    ? (c >= 3142 && c <= 3144)
                    : c <= 3149)
                  : (c <= 3158 || (c < 3165
                    ? (c >= 3160 && c <= 3162)
                    : c <= 3165)))))))))
          : (c <= 3171 || (c < 3450
            ? (c < 3293
              ? (c < 3242
                ? (c < 3205
                  ? (c < 3200
                    ? (c >= 3174 && c <= 3183)
                    : c <= 3203)
                  : (c <= 3212 || (c < 3218
                    ? (c >= 3214 && c <= 3216)
                    : c <= 3240)))
                : (c <= 3251 || (c < 3270
                  ? (c < 3260
                    ? (c >= 3253 && c <= 3257)
                    : c <= 3268)
                  : (c <= 3272 || (c < 3285
                    ? (c >= 3274 && c <= 3277)
                    : c <= 3286)))))
              : (c <= 3294 || (c < 3346
                ? (c < 3313
                  ? (c < 3302
                    ? (c >= 3296 && c <= 3299)
                    : c <= 3311)
                  : (c <= 3314 || (c < 3342
                    ? (c >= 3328 && c <= 3340)
                    : c <= 3344)))
                : (c <= 3396 || (c < 3412
                  ? (c < 3402
                    ? (c >= 3398 && c <= 3400)
                    : c <= 3406)
                  : (c <= 3415 || (c < 3430
                    ? (c >= 3423 && c <= 3427)
                    : c <= 3439)))))))
            : (c <= 3455 || (c < 3570
              ? (c < 3520
                ? (c < 3482
                  ? (c < 3461
                    ? (c >= 3457 && c <= 3459)
                    : c <= 3478)
                  : (c <= 3505 || (c < 3517
                    ? (c >= 3507 && c <= 3515)
                    : c <= 3517)))
                : (c <= 3526 || (c < 3542
                  ? (c < 3535
                    ? c == 3530
                    : c <= 3540)
                  : (c <= 3542 || (c < 3558
                    ? (c >= 3544 && c <= 3551)
                    : c <= 3567)))))
              : (c <= 3571 || (c < 3718
                ? (c < 3664
                  ? (c < 3648
                    ? (c >= 3585 && c <= 3642)
                    : c <= 3662)
                  : (c <= 3673 || (c < 3716
                    ? (c >= 3713 && c <= 3714)
                    : c <= 3716)))
                : (c <= 3722 || (c < 3751
                  ? (c < 3749
                    ? (c >= 3724 && c <= 3747)
                    : c <= 3749)
                  : (c <= 3773 || (c >= 3776 && c <= 3780)))))))))))))
      : (c <= 3782 || (c < 8025
        ? (c < 5888
          ? (c < 4688
            ? (c < 3953
              ? (c < 3872
                ? (c < 3804
                  ? (c < 3792
                    ? (c >= 3784 && c <= 3789)
                    : c <= 3801)
                  : (c <= 3807 || (c < 3864
                    ? c == 3840
                    : c <= 3865)))
                : (c <= 3881 || (c < 3897
                  ? (c < 3895
                    ? c == 3893
                    : c <= 3895)
                  : (c <= 3897 || (c < 3913
                    ? (c >= 3902 && c <= 3911)
                    : c <= 3948)))))
              : (c <= 3972 || (c < 4256
                ? (c < 4038
                  ? (c < 3993
                    ? (c >= 3974 && c <= 3991)
                    : c <= 4028)
                  : (c <= 4038 || (c < 4176
                    ? (c >= 4096 && c <= 4169)
                    : c <= 4253)))
                : (c <= 4293 || (c < 4304
                  ? (c < 4301
                    ? c == 4295
                    : c <= 4301)
                  : (c <= 4346 || (c < 4682
                    ? (c >= 4348 && c <= 4680)
                    : c <= 4685)))))))
            : (c <= 4694 || (c < 4882
              ? (c < 4786
                ? (c < 4704
                  ? (c < 4698
                    ? c == 4696
                    : c <= 4701)
                  : (c <= 4744 || (c < 4752
                    ? (c >= 4746 && c <= 4749)
                    : c <= 4784)))
                : (c <= 4789 || (c < 4802
                  ? (c < 4800
                    ? (c >= 4792 && c <= 4798)
                    : c <= 4800)
                  : (c <= 4805 || (c < 4824
                    ? (c >= 4808 && c <= 4822)
                    : c <= 4880)))))
              : (c <= 4885 || (c < 5112
                ? (c < 4969
                  ? (c < 4957
                    ? (c >= 4888 && c <= 4954)
                    : c <= 4959)
                  : (c <= 4977 || (c < 5024
                    ? (c >= 4992 && c <= 5007)
                    : c <= 5109)))
                : (c <= 5117 || (c < 5761
                  ? (c < 5743
                    ? (c >= 5121 && c <= 5740)
                    : c <= 5759)
                  : (c <= 5786 || (c < 5870
                    ? (c >= 5792 && c <= 5866)
                    : c <= 5880)))))))))
          : (c <= 5909 || (c < 6688
            ? (c < 6176
              ? (c < 6016
                ? (c < 5984
                  ? (c < 5952
                    ? (c >= 5919 && c <= 5940)
                    : c <= 5971)
                  : (c <= 5996 || (c < 6002
                    ? (c >= 5998 && c <= 6000)
                    : c <= 6003)))
                : (c <= 6099 || (c < 6112
                  ? (c < 6108
                    ? c == 6103
                    : c <= 6109)
                  : (c <= 6121 || (c < 6159
                    ? (c >= 6155 && c <= 6157)
                    : c <= 6169)))))
              : (c <= 6264 || (c < 6470
                ? (c < 6400
                  ? (c < 6320
                    ? (c >= 6272 && c <= 6314)
                    : c <= 6389)
                  : (c <= 6430 || (c < 6448
                    ? (c >= 6432 && c <= 6443)
                    : c <= 6459)))
                : (c <= 6509 || (c < 6576
                  ? (c < 6528
                    ? (c >= 6512 && c <= 6516)
                    : c <= 6571)
                  : (c <= 6601 || (c < 6656
                    ? (c >= 6608 && c <= 6618)
                    : c <= 6683)))))))
            : (c <= 6750 || (c < 7232
              ? (c < 6847
                ? (c < 6800
                  ? (c < 6783
                    ? (c >= 6752 && c <= 6780)
                    : c <= 6793)
                  : (c <= 6809 || (c < 6832
                    ? c == 6823
                    : c <= 6845)))
                : (c <= 6862 || (c < 7019
                  ? (c < 6992
                    ? (c >= 6912 && c <= 6988)
                    : c <= 7001)
                  : (c <= 7027 || (c < 7168
                    ? (c >= 7040 && c <= 7155)
                    : c <= 7223)))))
              : (c <= 7241 || (c < 7380
                ? (c < 7312
                  ? (c < 7296
                    ? (c >= 7245 && c <= 7293)
                    : c <= 7304)
                  : (c <= 7354 || (c < 7376
                    ? (c >= 7357 && c <= 7359)
                    : c <= 7378)))
                : (c <= 7418 || (c < 7968
                  ? (c < 7960
                    ? (c >= 7424 && c <= 7957)
                    : c <= 7965)
                  : (c <= 8005 || (c < 8016
                    ? (c >= 8008 && c <= 8013)
                    : c <= 8023)))))))))))
        : (c <= 8025 || (c < 11720
          ? (c < 8458
            ? (c < 8178
              ? (c < 8126
                ? (c < 8031
                  ? (c < 8029
                    ? c == 8027
                    : c <= 8029)
                  : (c <= 8061 || (c < 8118
                    ? (c >= 8064 && c <= 8116)
                    : c <= 8124)))
                : (c <= 8126 || (c < 8144
                  ? (c < 8134
                    ? (c >= 8130 && c <= 8132)
                    : c <= 8140)
                  : (c <= 8147 || (c < 8160
                    ? (c >= 8150 && c <= 8155)
                    : c <= 8172)))))
              : (c <= 8180 || (c < 8336
                ? (c < 8276
                  ? (c < 8255
                    ? (c >= 8182 && c <= 8188)
                    : c <= 8256)
                  : (c <= 8276 || (c < 8319
                    ? c == 8305
                    : c <= 8319)))
                : (c <= 8348 || (c < 8421
                  ? (c < 8417
                    ? (c >= 8400 && c <= 8412)
                    : c <= 8417)
                  : (c <= 8432 || (c < 8455
                    ? c == 8450
                    : c <= 8455)))))))
            : (c <= 8467 || (c < 11499
              ? (c < 8490
                ? (c < 8484
                  ? (c < 8472
                    ? c == 8469
                    : c <= 8477)
                  : (c <= 8484 || (c < 8488
                    ? c == 8486
                    : c <= 8488)))
                : (c <= 8505 || (c < 8526
                  ? (c < 8517
                    ? (c >= 8508 && c <= 8511)
                    : c <= 8521)
                  : (c <= 8526 || (c < 11264
                    ? (c >= 8544 && c <= 8584)
                    : c <= 11492)))))
              : (c <= 11507 || (c < 11647
                ? (c < 11565
                  ? (c < 11559
                    ? (c >= 11520 && c <= 11557)
                    : c <= 11559)
                  : (c <= 11565 || (c < 11631
                    ? (c >= 11568 && c <= 11623)
                    : c <= 11631)))
                : (c <= 11670 || (c < 11696
                  ? (c < 11688
                    ? (c >= 11680 && c <= 11686)
                    : c <= 11694)
                  : (c <= 11702 || (c < 11712
                    ? (c >= 11704 && c <= 11710)
                    : c <= 11718)))))))))
          : (c <= 11726 || (c < 42623
            ? (c < 12540
              ? (c < 12337
                ? (c < 11744
                  ? (c < 11736
                    ? (c >= 11728 && c <= 11734)
                    : c <= 11742)
                  : (c <= 11775 || (c < 12321
                    ? (c >= 12293 && c <= 12295)
                    : c <= 12335)))
                : (c <= 12341 || (c < 12441
                  ? (c < 12353
                    ? (c >= 12344 && c <= 12348)
                    : c <= 12438)
                  : (c <= 12442 || (c < 12449
                    ? (c >= 12445 && c <= 12447)
                    : c <= 12538)))))
              : (c <= 12543 || (c < 19968
                ? (c < 12704
                  ? (c < 12593
                    ? (c >= 12549 && c <= 12591)
                    : c <= 12686)
                  : (c <= 12735 || (c < 13312
                    ? (c >= 12784 && c <= 12799)
                    : c <= 19903)))
                : (c <= 42124 || (c < 42512
                  ? (c < 42240
                    ? (c >= 42192 && c <= 42237)
                    : c <= 42508)
                  : (c <= 42539 || (c < 42612
                    ? (c >= 42560 && c <= 42607)
                    : c <= 42621)))))))
            : (c <= 42737 || (c < 43232
              ? (c < 42965
                ? (c < 42891
                  ? (c < 42786
                    ? (c >= 42775 && c <= 42783)
                    : c <= 42888)
                  : (c <= 42954 || (c < 42963
                    ? (c >= 42960 && c <= 42961)
                    : c <= 42963)))
                : (c <= 42969 || (c < 43072
                  ? (c < 43052
                    ? (c >= 42994 && c <= 43047)
                    : c <= 43052)
                  : (c <= 43123 || (c < 43216
                    ? (c >= 43136 && c <= 43205)
                    : c <= 43225)))))
              : (c <= 43255 || (c < 43471
                ? (c < 43312
                  ? (c < 43261
                    ? c == 43259
                    : c <= 43309)
                  : (c <= 43347 || (c < 43392
                    ? (c >= 43360 && c <= 43388)
                    : c <= 43456)))
                : (c <= 43481 || (c < 43584
                  ? (c < 43520
                    ? (c >= 43488 && c <= 43518)
                    : c <= 43574)
                  : (c <= 43597 || (c >= 43600 && c <= 43609)))))))))))))))
    : (c <= 43638 || (c < 71453
      ? (c < 67639
        ? (c < 65345
          ? (c < 64312
            ? (c < 43888
              ? (c < 43785
                ? (c < 43744
                  ? (c < 43739
                    ? (c >= 43642 && c <= 43714)
                    : c <= 43741)
                  : (c <= 43759 || (c < 43777
                    ? (c >= 43762 && c <= 43766)
                    : c <= 43782)))
                : (c <= 43790 || (c < 43816
                  ? (c < 43808
                    ? (c >= 43793 && c <= 43798)
                    : c <= 43814)
                  : (c <= 43822 || (c < 43868
                    ? (c >= 43824 && c <= 43866)
                    : c <= 43881)))))
              : (c <= 44010 || (c < 63744
                ? (c < 44032
                  ? (c < 44016
                    ? (c >= 44012 && c <= 44013)
                    : c <= 44025)
                  : (c <= 55203 || (c < 55243
                    ? (c >= 55216 && c <= 55238)
                    : c <= 55291)))
                : (c <= 64109 || (c < 64275
                  ? (c < 64256
                    ? (c >= 64112 && c <= 64217)
                    : c <= 64262)
                  : (c <= 64279 || (c < 64298
                    ? (c >= 64285 && c <= 64296)
                    : c <= 64310)))))))
            : (c <= 64316 || (c < 65075
              ? (c < 64612
                ? (c < 64323
                  ? (c < 64320
                    ? c == 64318
                    : c <= 64321)
                  : (c <= 64324 || (c < 64467
                    ? (c >= 64326 && c <= 64433)
                    : c <= 64605)))
                : (c <= 64829 || (c < 65008
                  ? (c < 64914
                    ? (c >= 64848 && c <= 64911)
                    : c <= 64967)
                  : (c <= 65017 || (c < 65056
                    ? (c >= 65024 && c <= 65039)
                    : c <= 65071)))))
              : (c <= 65076 || (c < 65147
                ? (c < 65139
                  ? (c < 65137
                    ? (c >= 65101 && c <= 65103)
                    : c <= 65137)
                  : (c <= 65139 || (c < 65145
                    ? c == 65143
                    : c <= 65145)))
                : (c <= 65147 || (c < 65296
                  ? (c < 65151
                    ? c == 65149
                    : c <= 65276)
                  : (c <= 65305 || (c < 65343
                    ? (c >= 65313 && c <= 65338)
                    : c <= 65343)))))))))
          : (c <= 65370 || (c < 66513
            ? (c < 65664
              ? (c < 65536
                ? (c < 65482
                  ? (c < 65474
                    ? (c >= 65382 && c <= 65470)
                    : c <= 65479)
                  : (c <= 65487 || (c < 65498
                    ? (c >= 65490 && c <= 65495)
                    : c <= 65500)))
                : (c <= 65547 || (c < 65596
                  ? (c < 65576
                    ? (c >= 65549 && c <= 65574)
                    : c <= 65594)
                  : (c <= 65597 || (c < 65616
                    ? (c >= 65599 && c <= 65613)
                    : c <= 65629)))))
              : (c <= 65786 || (c < 66304
                ? (c < 66176
                  ? (c < 66045
                    ? (c >= 65856 && c <= 65908)
                    : c <= 66045)
                  : (c <= 66204 || (c < 66272
                    ? (c >= 66208 && c <= 66256)
                    : c <= 66272)))
                : (c <= 66335 || (c < 66432
                  ? (c < 66384
                    ? (c >= 66349 && c <= 66378)
                    : c <= 66426)
                  : (c <= 66461 || (c < 66504
                    ? (c >= 66464 && c <= 66499)
                    : c <= 66511)))))))
            : (c <= 66517 || (c < 66979
              ? (c < 66864
                ? (c < 66736
                  ? (c < 66720
                    ? (c >= 66560 && c <= 66717)
                    : c <= 66729)
                  : (c <= 66771 || (c < 66816
                    ? (c >= 66776 && c <= 66811)
                    : c <= 66855)))
                : (c <= 66915 || (c < 66956
                  ? (c < 66940
                    ? (c >= 66928 && c <= 66938)
                    : c <= 66954)
                  : (c <= 66962 || (c < 66967
                    ? (c >= 66964 && c <= 66965)
                    : c <= 66977)))))
              : (c <= 66993 || (c < 67456
                ? (c < 67072
                  ? (c < 67003
                    ? (c >= 66995 && c <= 67001)
                    : c <= 67004)
                  : (c <= 67382 || (c < 67424
                    ? (c >= 67392 && c <= 67413)
                    : c <= 67431)))
                : (c <= 67461 || (c < 67584
                  ? (c < 67506
                    ? (c >= 67463 && c <= 67504)
                    : c <= 67514)
                  : (c <= 67589 || (c < 67594
                    ? c == 67592
                    : c <= 67637)))))))))))
        : (c <= 67640 || (c < 69956
          ? (c < 68448
            ? (c < 68101
              ? (c < 67828
                ? (c < 67680
                  ? (c < 67647
                    ? c == 67644
                    : c <= 67669)
                  : (c <= 67702 || (c < 67808
                    ? (c >= 67712 && c <= 67742)
                    : c <= 67826)))
                : (c <= 67829 || (c < 67968
                  ? (c < 67872
                    ? (c >= 67840 && c <= 67861)
                    : c <= 67897)
                  : (c <= 68023 || (c < 68096
                    ? (c >= 68030 && c <= 68031)
                    : c <= 68099)))))
              : (c <= 68102 || (c < 68192
                ? (c < 68121
                  ? (c < 68117
                    ? (c >= 68108 && c <= 68115)
                    : c <= 68119)
                  : (c <= 68149 || (c < 68159
                    ? (c >= 68152 && c <= 68154)
                    : c <= 68159)))
                : (c <= 68220 || (c < 68297
                  ? (c < 68288
                    ? (c >= 68224 && c <= 68252)
                    : c <= 68295)
                  : (c <= 68326 || (c < 68416
                    ? (c >= 68352 && c <= 68405)
                    : c <= 68437)))))))
            : (c <= 68466 || (c < 69424
              ? (c < 68912
                ? (c < 68736
                  ? (c < 68608
                    ? (c >= 68480 && c <= 68497)
                    : c <= 68680)
                  : (c <= 68786 || (c < 68864
                    ? (c >= 68800 && c <= 68850)
                    : c <= 68903)))
                : (c <= 68921 || (c < 69296
                  ? (c < 69291
                    ? (c >= 69248 && c <= 69289)
                    : c <= 69292)
                  : (c <= 69297 || (c < 69415
                    ? (c >= 69376 && c <= 69404)
                    : c <= 69415)))))
              : (c <= 69456 || (c < 69759
                ? (c < 69600
                  ? (c < 69552
                    ? (c >= 69488 && c <= 69509)
                    : c <= 69572)
                  : (c <= 69622 || (c < 69734
                    ? (c >= 69632 && c <= 69702)
                    : c <= 69749)))
                : (c <= 69818 || (c < 69872
                  ? (c < 69840
                    ? c == 69826
                    : c <= 69864)
                  : (c <= 69881 || (c < 69942
                    ? (c >= 69888 && c <= 69940)
                    : c <= 69951)))))))))
          : (c <= 69959 || (c < 70459
            ? (c < 70282
              ? (c < 70108
                ? (c < 70016
                  ? (c < 70006
                    ? (c >= 69968 && c <= 70003)
                    : c <= 70006)
                  : (c <= 70084 || (c < 70094
                    ? (c >= 70089 && c <= 70092)
                    : c <= 70106)))
                : (c <= 70108 || (c < 70206
                  ? (c < 70163
                    ? (c >= 70144 && c <= 70161)
                    : c <= 70199)
                  : (c <= 70206 || (c < 70280
                    ? (c >= 70272 && c <= 70278)
                    : c <= 70280)))))
              : (c <= 70285 || (c < 70405
                ? (c < 70320
                  ? (c < 70303
                    ? (c >= 70287 && c <= 70301)
                    : c <= 70312)
                  : (c <= 70378 || (c < 70400
                    ? (c >= 70384 && c <= 70393)
                    : c <= 70403)))
                : (c <= 70412 || (c < 70442
                  ? (c < 70419
                    ? (c >= 70415 && c <= 70416)
                    : c <= 70440)
                  : (c <= 70448 || (c < 70453
                    ? (c >= 70450 && c <= 70451)
                    : c <= 70457)))))))
            : (c <= 70468 || (c < 70855
              ? (c < 70502
                ? (c < 70480
                  ? (c < 70475
                    ? (c >= 70471 && c <= 70472)
                    : c <= 70477)
                  : (c <= 70480 || (c < 70493
                    ? c == 70487
                    : c <= 70499)))
                : (c <= 70508 || (c < 70736
                  ? (c < 70656
                    ? (c >= 70512 && c <= 70516)
                    : c <= 70730)
                  : (c <= 70745 || (c < 70784
                    ? (c >= 70750 && c <= 70753)
                    : c <= 70853)))))
              : (c <= 70855 || (c < 71236
                ? (c < 71096
                  ? (c < 71040
                    ? (c >= 70864 && c <= 70873)
                    : c <= 71093)
                  : (c <= 71104 || (c < 71168
                    ? (c >= 71128 && c <= 71133)
                    : c <= 71232)))
                : (c <= 71236 || (c < 71360
                  ? (c < 71296
                    ? (c >= 71248 && c <= 71257)
                    : c <= 71352)
                  : (c <= 71369 || (c >= 71424 && c <= 71450)))))))))))))
      : (c <= 71467 || (c < 119973
        ? (c < 77824
          ? (c < 72760
            ? (c < 72016
              ? (c < 71945
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71472 && c <= 71481)
                    : c <= 71494)
                  : (c <= 71738 || (c < 71935
                    ? (c >= 71840 && c <= 71913)
                    : c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71989 || (c < 71995
                    ? (c >= 71991 && c <= 71992)
                    : c <= 72003)))))
              : (c <= 72025 || (c < 72263
                ? (c < 72154
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72151)
                  : (c <= 72161 || (c < 72192
                    ? (c >= 72163 && c <= 72164)
                    : c <= 72254)))
                : (c <= 72263 || (c < 72368
                  ? (c < 72349
                    ? (c >= 72272 && c <= 72345)
                    : c <= 72349)
                  : (c <= 72440 || (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72758)))))))
            : (c <= 72768 || (c < 73056
              ? (c < 72968
                ? (c < 72850
                  ? (c < 72818
                    ? (c >= 72784 && c <= 72793)
                    : c <= 72847)
                  : (c <= 72871 || (c < 72960
                    ? (c >= 72873 && c <= 72886)
                    : c <= 72966)))
                : (c <= 72969 || (c < 73020
                  ? (c < 73018
                    ? (c >= 72971 && c <= 73014)
                    : c <= 73018)
                  : (c <= 73021 || (c < 73040
                    ? (c >= 73023 && c <= 73031)
                    : c <= 73049)))))
              : (c <= 73061 || (c < 73440
                ? (c < 73104
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73102)
                  : (c <= 73105 || (c < 73120
                    ? (c >= 73107 && c <= 73112)
                    : c <= 73129)))
                : (c <= 73462 || (c < 74752
                  ? (c < 73728
                    ? c == 73648
                    : c <= 74649)
                  : (c <= 74862 || (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)))))))))
          : (c <= 78894 || (c < 110576
            ? (c < 93027
              ? (c < 92864
                ? (c < 92736
                  ? (c < 92160
                    ? (c >= 82944 && c <= 83526)
                    : c <= 92728)
                  : (c <= 92766 || (c < 92784
                    ? (c >= 92768 && c <= 92777)
                    : c <= 92862)))
                : (c <= 92873 || (c < 92928
                  ? (c < 92912
                    ? (c >= 92880 && c <= 92909)
                    : c <= 92916)
                  : (c <= 92982 || (c < 93008
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93017)))))
              : (c <= 93047 || (c < 94176
                ? (c < 93952
                  ? (c < 93760
                    ? (c >= 93053 && c <= 93071)
                    : c <= 93823)
                  : (c <= 94026 || (c < 94095
                    ? (c >= 94031 && c <= 94087)
                    : c <= 94111)))
                : (c <= 94177 || (c < 94208
                  ? (c < 94192
                    ? (c >= 94179 && c <= 94180)
                    : c <= 94193)
                  : (c <= 100343 || (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)))))))
            : (c <= 110579 || (c < 118528
              ? (c < 110960
                ? (c < 110592
                  ? (c < 110589
                    ? (c >= 110581 && c <= 110587)
                    : c <= 110590)
                  : (c <= 110882 || (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)))
                : (c <= 111355 || (c < 113792
                  ? (c < 113776
                    ? (c >= 113664 && c <= 113770)
                    : c <= 113788)
                  : (c <= 113800 || (c < 113821
                    ? (c >= 113808 && c <= 113817)
                    : c <= 113822)))))
              : (c <= 118573 || (c < 119210
                ? (c < 119149
                  ? (c < 119141
                    ? (c >= 118576 && c <= 118598)
                    : c <= 119145)
                  : (c <= 119154 || (c < 119173
                    ? (c >= 119163 && c <= 119170)
                    : c <= 119179)))
                : (c <= 119213 || (c < 119894
                  ? (c < 119808
                    ? (c >= 119362 && c <= 119364)
                    : c <= 119892)
                  : (c <= 119964 || (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(70);
      if (lookahead == '!') ADVANCE(169);
      if (lookahead == '"') ADVANCE(155);
      if (lookahead == '#') ADVANCE(141);
      if (lookahead == '$') ADVANCE(83);
      if (lookahead == '%') ADVANCE(97);
      if (lookahead == '&') ADVANCE(102);
      if (lookahead == '\'') ADVANCE(143);
      if (lookahead == '(') ADVANCE(73);
      if (lookahead == ')') ADVANCE(74);
      if (lookahead == '*') ADVANCE(90);
      if (lookahead == '+') ADVANCE(88);
      if (lookahead == ',') ADVANCE(137);
      if (lookahead == '-') ADVANCE(94);
      if (lookahead == '.') ADVANCE(131);
      if (lookahead == '/') ADVANCE(170);
      if (lookahead == '0') ADVANCE(149);
      if (lookahead == ':') ADVANCE(81);
      if (lookahead == ';') ADVANCE(71);
      if (lookahead == '<') ADVANCE(144);
      if (lookahead == '=') ADVANCE(121);
      if (lookahead == '>') ADVANCE(125);
      if (lookahead == '?') ADVANCE(91);
      if (lookahead == '@') ADVANCE(130);
      if (lookahead == '[') ADVANCE(75);
      if (lookahead == '\\') ADVANCE(45);
      if (lookahead == ']') ADVANCE(76);
      if (lookahead == '^') ADVANCE(98);
      if (lookahead == 'b') ADVANCE(176);
      if (lookahead == 'c') ADVANCE(177);
      if (lookahead == 'm') ADVANCE(180);
      if (lookahead == 'r') ADVANCE(178);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(104);
      if (lookahead == '}') ADVANCE(78);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(66)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(152);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(189);
      END_STATE();
    case 1:
      if (lookahead == '!') ADVANCE(100);
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == '#') ADVANCE(140);
      if (lookahead == '$') ADVANCE(83);
      if (lookahead == '%') ADVANCE(97);
      if (lookahead == '&') ADVANCE(102);
      if (lookahead == '\'') ADVANCE(143);
      if (lookahead == '(') ADVANCE(73);
      if (lookahead == ')') ADVANCE(74);
      if (lookahead == '*') ADVANCE(90);
      if (lookahead == '+') ADVANCE(88);
      if (lookahead == ',') ADVANCE(137);
      if (lookahead == '-') ADVANCE(94);
      if (lookahead == '.') ADVANCE(131);
      if (lookahead == '/') ADVANCE(96);
      if (lookahead == '0') ADVANCE(149);
      if (lookahead == ':') ADVANCE(81);
      if (lookahead == ';') ADVANCE(71);
      if (lookahead == '<') ADVANCE(127);
      if (lookahead == '=') ADVANCE(121);
      if (lookahead == '>') ADVANCE(125);
      if (lookahead == '?') ADVANCE(91);
      if (lookahead == '@') ADVANCE(130);
      if (lookahead == '[') ADVANCE(75);
      if (lookahead == ']') ADVANCE(76);
      if (lookahead == '^') ADVANCE(98);
      if (lookahead == 'b') ADVANCE(176);
      if (lookahead == 'c') ADVANCE(177);
      if (lookahead == 'r') ADVANCE(178);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(104);
      if (lookahead == '}') ADVANCE(78);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(1)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(152);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(189);
      END_STATE();
    case 2:
      if (lookahead == '!') ADVANCE(100);
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == '#') ADVANCE(140);
      if (lookahead == '$') ADVANCE(64);
      if (lookahead == '%') ADVANCE(97);
      if (lookahead == '&') ADVANCE(102);
      if (lookahead == '\'') ADVANCE(143);
      if (lookahead == '(') ADVANCE(73);
      if (lookahead == ')') ADVANCE(74);
      if (lookahead == '*') ADVANCE(90);
      if (lookahead == '+') ADVANCE(88);
      if (lookahead == ',') ADVANCE(137);
      if (lookahead == '-') ADVANCE(93);
      if (lookahead == '.') ADVANCE(131);
      if (lookahead == '/') ADVANCE(96);
      if (lookahead == '0') ADVANCE(149);
      if (lookahead == ':') ADVANCE(81);
      if (lookahead == ';') ADVANCE(71);
      if (lookahead == '<') ADVANCE(127);
      if (lookahead == '=') ADVANCE(120);
      if (lookahead == '>') ADVANCE(125);
      if (lookahead == '?') ADVANCE(91);
      if (lookahead == '[') ADVANCE(75);
      if (lookahead == ']') ADVANCE(76);
      if (lookahead == '^') ADVANCE(98);
      if (lookahead == 'b') ADVANCE(176);
      if (lookahead == 'c') ADVANCE(177);
      if (lookahead == 'r') ADVANCE(178);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(104);
      if (lookahead == '}') ADVANCE(78);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(2)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(152);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(189);
      END_STATE();
    case 3:
      if (lookahead == '!') ADVANCE(100);
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == '#') ADVANCE(140);
      if (lookahead == '$') ADVANCE(82);
      if (lookahead == '%') ADVANCE(97);
      if (lookahead == '&') ADVANCE(102);
      if (lookahead == '\'') ADVANCE(143);
      if (lookahead == '(') ADVANCE(73);
      if (lookahead == ')') ADVANCE(74);
      if (lookahead == '*') ADVANCE(90);
      if (lookahead == '+') ADVANCE(88);
      if (lookahead == ',') ADVANCE(137);
      if (lookahead == '-') ADVANCE(94);
      if (lookahead == '.') ADVANCE(131);
      if (lookahead == '/') ADVANCE(96);
      if (lookahead == '0') ADVANCE(149);
      if (lookahead == ':') ADVANCE(81);
      if (lookahead == ';') ADVANCE(71);
      if (lookahead == '<') ADVANCE(127);
      if (lookahead == '=') ADVANCE(121);
      if (lookahead == '>') ADVANCE(125);
      if (lookahead == '?') ADVANCE(91);
      if (lookahead == '@') ADVANCE(130);
      if (lookahead == '[') ADVANCE(75);
      if (lookahead == ']') ADVANCE(76);
      if (lookahead == '^') ADVANCE(98);
      if (lookahead == 'b') ADVANCE(176);
      if (lookahead == 'c') ADVANCE(177);
      if (lookahead == 'r') ADVANCE(178);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(104);
      if (lookahead == '}') ADVANCE(78);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(3)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(152);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(189);
      END_STATE();
    case 4:
      if (lookahead == '!') ADVANCE(100);
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == '$') ADVANCE(64);
      if (lookahead == '%') ADVANCE(97);
      if (lookahead == '&') ADVANCE(102);
      if (lookahead == '\'') ADVANCE(143);
      if (lookahead == '(') ADVANCE(73);
      if (lookahead == '*') ADVANCE(90);
      if (lookahead == '+') ADVANCE(88);
      if (lookahead == '-') ADVANCE(93);
      if (lookahead == '.') ADVANCE(131);
      if (lookahead == '/') ADVANCE(96);
      if (lookahead == '0') ADVANCE(149);
      if (lookahead == ':') ADVANCE(81);
      if (lookahead == '<') ADVANCE(127);
      if (lookahead == '=') ADVANCE(121);
      if (lookahead == '>') ADVANCE(125);
      if (lookahead == '?') ADVANCE(91);
      if (lookahead == '[') ADVANCE(75);
      if (lookahead == '^') ADVANCE(98);
      if (lookahead == 'b') ADVANCE(176);
      if (lookahead == 'c') ADVANCE(177);
      if (lookahead == 'r') ADVANCE(178);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(104);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(4)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(152);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(189);
      END_STATE();
    case 5:
      if (lookahead == '!') ADVANCE(100);
      if (lookahead == '%') ADVANCE(97);
      if (lookahead == '&') ADVANCE(102);
      if (lookahead == '\'') ADVANCE(142);
      if (lookahead == '(') ADVANCE(73);
      if (lookahead == ')') ADVANCE(74);
      if (lookahead == '*') ADVANCE(90);
      if (lookahead == '+') ADVANCE(88);
      if (lookahead == ',') ADVANCE(137);
      if (lookahead == '-') ADVANCE(93);
      if (lookahead == '.') ADVANCE(131);
      if (lookahead == '/') ADVANCE(96);
      if (lookahead == ':') ADVANCE(81);
      if (lookahead == ';') ADVANCE(71);
      if (lookahead == '<') ADVANCE(144);
      if (lookahead == '=') ADVANCE(120);
      if (lookahead == '>') ADVANCE(125);
      if (lookahead == '?') ADVANCE(91);
      if (lookahead == '[') ADVANCE(75);
      if (lookahead == ']') ADVANCE(76);
      if (lookahead == '^') ADVANCE(98);
      if (lookahead == 'r') ADVANCE(178);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(104);
      if (lookahead == '}') ADVANCE(78);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(5)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(189);
      END_STATE();
    case 6:
      if (lookahead == '!') ADVANCE(100);
      if (lookahead == '%') ADVANCE(97);
      if (lookahead == '&') ADVANCE(102);
      if (lookahead == '\'') ADVANCE(142);
      if (lookahead == '(') ADVANCE(73);
      if (lookahead == ')') ADVANCE(74);
      if (lookahead == '*') ADVANCE(90);
      if (lookahead == '+') ADVANCE(88);
      if (lookahead == ',') ADVANCE(137);
      if (lookahead == '-') ADVANCE(93);
      if (lookahead == '.') ADVANCE(131);
      if (lookahead == '/') ADVANCE(96);
      if (lookahead == ':') ADVANCE(39);
      if (lookahead == ';') ADVANCE(71);
      if (lookahead == '<') ADVANCE(127);
      if (lookahead == '=') ADVANCE(120);
      if (lookahead == '>') ADVANCE(125);
      if (lookahead == '?') ADVANCE(91);
      if (lookahead == '[') ADVANCE(75);
      if (lookahead == ']') ADVANCE(76);
      if (lookahead == '^') ADVANCE(98);
      if (lookahead == 'r') ADVANCE(178);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(104);
      if (lookahead == '}') ADVANCE(78);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(6)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(189);
      END_STATE();
    case 7:
      if (lookahead == '!') ADVANCE(100);
      if (lookahead == '%') ADVANCE(97);
      if (lookahead == '&') ADVANCE(102);
      if (lookahead == '\'') ADVANCE(142);
      if (lookahead == '(') ADVANCE(73);
      if (lookahead == '*') ADVANCE(90);
      if (lookahead == '+') ADVANCE(88);
      if (lookahead == '-') ADVANCE(93);
      if (lookahead == '.') ADVANCE(131);
      if (lookahead == '/') ADVANCE(96);
      if (lookahead == ':') ADVANCE(39);
      if (lookahead == '<') ADVANCE(127);
      if (lookahead == '=') ADVANCE(121);
      if (lookahead == '>') ADVANCE(125);
      if (lookahead == '?') ADVANCE(91);
      if (lookahead == '[') ADVANCE(75);
      if (lookahead == '^') ADVANCE(98);
      if (lookahead == 'r') ADVANCE(178);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(104);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(7)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(189);
      END_STATE();
    case 8:
      if (lookahead == '!') ADVANCE(100);
      if (lookahead == '%') ADVANCE(97);
      if (lookahead == '&') ADVANCE(102);
      if (lookahead == '(') ADVANCE(73);
      if (lookahead == '*') ADVANCE(90);
      if (lookahead == '+') ADVANCE(88);
      if (lookahead == '-') ADVANCE(93);
      if (lookahead == '.') ADVANCE(131);
      if (lookahead == '/') ADVANCE(96);
      if (lookahead == ':') ADVANCE(39);
      if (lookahead == '<') ADVANCE(144);
      if (lookahead == '=') ADVANCE(121);
      if (lookahead == '>') ADVANCE(125);
      if (lookahead == '?') ADVANCE(91);
      if (lookahead == '[') ADVANCE(75);
      if (lookahead == '^') ADVANCE(98);
      if (lookahead == 'r') ADVANCE(178);
      if (lookahead == '|') ADVANCE(104);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(8)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(189);
      END_STATE();
    case 9:
      if (lookahead == '!') ADVANCE(99);
      if (lookahead == '"') ADVANCE(155);
      if (lookahead == '#') ADVANCE(140);
      if (lookahead == '$') ADVANCE(64);
      if (lookahead == '&') ADVANCE(23);
      if (lookahead == '\'') ADVANCE(142);
      if (lookahead == '(') ADVANCE(73);
      if (lookahead == ')') ADVANCE(74);
      if (lookahead == '*') ADVANCE(32);
      if (lookahead == '+') ADVANCE(87);
      if (lookahead == ',') ADVANCE(137);
      if (lookahead == '.') ADVANCE(29);
      if (lookahead == '/') ADVANCE(27);
      if (lookahead == ':') ADVANCE(81);
      if (lookahead == ';') ADVANCE(71);
      if (lookahead == '<') ADVANCE(126);
      if (lookahead == '=') ADVANCE(42);
      if (lookahead == '>') ADVANCE(124);
      if (lookahead == '\\') ADVANCE(45);
      if (lookahead == ']') ADVANCE(76);
      if (lookahead == 'm') ADVANCE(180);
      if (lookahead == 'r') ADVANCE(178);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(103);
      if (lookahead == '}') ADVANCE(78);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(14)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(189);
      END_STATE();
    case 10:
      if (lookahead == '!') ADVANCE(99);
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == '#') ADVANCE(140);
      if (lookahead == '$') ADVANCE(64);
      if (lookahead == '&') ADVANCE(101);
      if (lookahead == '\'') ADVANCE(143);
      if (lookahead == '(') ADVANCE(73);
      if (lookahead == ')') ADVANCE(74);
      if (lookahead == '*') ADVANCE(89);
      if (lookahead == ',') ADVANCE(137);
      if (lookahead == '-') ADVANCE(92);
      if (lookahead == '.') ADVANCE(30);
      if (lookahead == '/') ADVANCE(27);
      if (lookahead == '0') ADVANCE(149);
      if (lookahead == ':') ADVANCE(81);
      if (lookahead == ';') ADVANCE(71);
      if (lookahead == '<') ADVANCE(126);
      if (lookahead == '=') ADVANCE(119);
      if (lookahead == '>') ADVANCE(124);
      if (lookahead == '?') ADVANCE(91);
      if (lookahead == '[') ADVANCE(75);
      if (lookahead == ']') ADVANCE(76);
      if (lookahead == 'b') ADVANCE(176);
      if (lookahead == 'c') ADVANCE(177);
      if (lookahead == 'r') ADVANCE(178);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(103);
      if (lookahead == '}') ADVANCE(78);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(10)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(152);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(189);
      END_STATE();
    case 11:
      if (lookahead == '!') ADVANCE(99);
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == '#') ADVANCE(140);
      if (lookahead == '$') ADVANCE(64);
      if (lookahead == '&') ADVANCE(101);
      if (lookahead == '\'') ADVANCE(143);
      if (lookahead == '(') ADVANCE(73);
      if (lookahead == ')') ADVANCE(74);
      if (lookahead == '*') ADVANCE(89);
      if (lookahead == ',') ADVANCE(137);
      if (lookahead == '-') ADVANCE(92);
      if (lookahead == '.') ADVANCE(31);
      if (lookahead == '/') ADVANCE(27);
      if (lookahead == '0') ADVANCE(149);
      if (lookahead == ':') ADVANCE(39);
      if (lookahead == '<') ADVANCE(126);
      if (lookahead == '=') ADVANCE(42);
      if (lookahead == '?') ADVANCE(91);
      if (lookahead == '[') ADVANCE(75);
      if (lookahead == 'b') ADVANCE(176);
      if (lookahead == 'c') ADVANCE(177);
      if (lookahead == 'r') ADVANCE(178);
      if (lookahead == '|') ADVANCE(103);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(11)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(152);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(189);
      END_STATE();
    case 12:
      if (lookahead == '!') ADVANCE(99);
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == '$') ADVANCE(64);
      if (lookahead == '&') ADVANCE(101);
      if (lookahead == '\'') ADVANCE(143);
      if (lookahead == '(') ADVANCE(73);
      if (lookahead == '*') ADVANCE(89);
      if (lookahead == '+') ADVANCE(87);
      if (lookahead == ',') ADVANCE(137);
      if (lookahead == '-') ADVANCE(95);
      if (lookahead == '.') ADVANCE(30);
      if (lookahead == '/') ADVANCE(27);
      if (lookahead == '0') ADVANCE(149);
      if (lookahead == ':') ADVANCE(39);
      if (lookahead == ';') ADVANCE(71);
      if (lookahead == '<') ADVANCE(126);
      if (lookahead == '[') ADVANCE(75);
      if (lookahead == ']') ADVANCE(76);
      if (lookahead == 'b') ADVANCE(176);
      if (lookahead == 'c') ADVANCE(177);
      if (lookahead == 'r') ADVANCE(178);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(103);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(12)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(152);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(189);
      END_STATE();
    case 13:
      if (lookahead == '!') ADVANCE(99);
      if (lookahead == '#') ADVANCE(140);
      if (lookahead == '$') ADVANCE(64);
      if (lookahead == '&') ADVANCE(101);
      if (lookahead == '\'') ADVANCE(142);
      if (lookahead == '(') ADVANCE(73);
      if (lookahead == ')') ADVANCE(74);
      if (lookahead == '*') ADVANCE(89);
      if (lookahead == '+') ADVANCE(87);
      if (lookahead == ',') ADVANCE(137);
      if (lookahead == '-') ADVANCE(41);
      if (lookahead == '.') ADVANCE(29);
      if (lookahead == '/') ADVANCE(27);
      if (lookahead == '0') ADVANCE(149);
      if (lookahead == ':') ADVANCE(81);
      if (lookahead == ';') ADVANCE(71);
      if (lookahead == '<') ADVANCE(126);
      if (lookahead == '=') ADVANCE(119);
      if (lookahead == '>') ADVANCE(124);
      if (lookahead == '?') ADVANCE(91);
      if (lookahead == '[') ADVANCE(75);
      if (lookahead == ']') ADVANCE(76);
      if (lookahead == 'r') ADVANCE(178);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(103);
      if (lookahead == '}') ADVANCE(78);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(13)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(152);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(189);
      END_STATE();
    case 14:
      if (lookahead == '!') ADVANCE(99);
      if (lookahead == '#') ADVANCE(140);
      if (lookahead == '$') ADVANCE(64);
      if (lookahead == '&') ADVANCE(23);
      if (lookahead == '\'') ADVANCE(142);
      if (lookahead == '(') ADVANCE(73);
      if (lookahead == ')') ADVANCE(74);
      if (lookahead == '*') ADVANCE(32);
      if (lookahead == '+') ADVANCE(87);
      if (lookahead == ',') ADVANCE(137);
      if (lookahead == '.') ADVANCE(29);
      if (lookahead == '/') ADVANCE(27);
      if (lookahead == ':') ADVANCE(81);
      if (lookahead == ';') ADVANCE(71);
      if (lookahead == '<') ADVANCE(126);
      if (lookahead == '=') ADVANCE(42);
      if (lookahead == '>') ADVANCE(124);
      if (lookahead == ']') ADVANCE(76);
      if (lookahead == 'm') ADVANCE(180);
      if (lookahead == 'r') ADVANCE(178);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(103);
      if (lookahead == '}') ADVANCE(78);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(14)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(189);
      END_STATE();
    case 15:
      if (lookahead == '!') ADVANCE(99);
      if (lookahead == '\'') ADVANCE(142);
      if (lookahead == '(') ADVANCE(73);
      if (lookahead == ')') ADVANCE(74);
      if (lookahead == '+') ADVANCE(87);
      if (lookahead == ',') ADVANCE(137);
      if (lookahead == '.') ADVANCE(29);
      if (lookahead == '/') ADVANCE(27);
      if (lookahead == ':') ADVANCE(81);
      if (lookahead == ';') ADVANCE(71);
      if (lookahead == '<') ADVANCE(144);
      if (lookahead == '=') ADVANCE(119);
      if (lookahead == '>') ADVANCE(124);
      if (lookahead == '@') ADVANCE(130);
      if (lookahead == ']') ADVANCE(76);
      if (lookahead == 'r') ADVANCE(178);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(103);
      if (lookahead == '}') ADVANCE(78);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(15)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(189);
      END_STATE();
    case 16:
      if (lookahead == '!') ADVANCE(99);
      if (lookahead == '(') ADVANCE(73);
      if (lookahead == '.') ADVANCE(29);
      if (lookahead == '/') ADVANCE(27);
      if (lookahead == ':') ADVANCE(39);
      if (lookahead == '<') ADVANCE(144);
      if (lookahead == '=') ADVANCE(42);
      if (lookahead == '@') ADVANCE(130);
      if (lookahead == 'r') ADVANCE(178);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(103);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(16)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(189);
      END_STATE();
    case 17:
      if (lookahead == '!') ADVANCE(40);
      if (lookahead == '%') ADVANCE(97);
      if (lookahead == '&') ADVANCE(102);
      if (lookahead == '\'') ADVANCE(142);
      if (lookahead == '(') ADVANCE(73);
      if (lookahead == ')') ADVANCE(74);
      if (lookahead == '*') ADVANCE(90);
      if (lookahead == '+') ADVANCE(88);
      if (lookahead == ',') ADVANCE(137);
      if (lookahead == '-') ADVANCE(94);
      if (lookahead == '.') ADVANCE(131);
      if (lookahead == '/') ADVANCE(96);
      if (lookahead == ';') ADVANCE(71);
      if (lookahead == '<') ADVANCE(127);
      if (lookahead == '=') ADVANCE(120);
      if (lookahead == '>') ADVANCE(125);
      if (lookahead == '?') ADVANCE(91);
      if (lookahead == '[') ADVANCE(75);
      if (lookahead == ']') ADVANCE(76);
      if (lookahead == '^') ADVANCE(98);
      if (lookahead == 'r') ADVANCE(178);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(104);
      if (lookahead == '}') ADVANCE(78);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(17)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(189);
      END_STATE();
    case 18:
      if (lookahead == '!') ADVANCE(40);
      if (lookahead == '%') ADVANCE(97);
      if (lookahead == '&') ADVANCE(102);
      if (lookahead == '\'') ADVANCE(142);
      if (lookahead == '(') ADVANCE(73);
      if (lookahead == ')') ADVANCE(74);
      if (lookahead == '*') ADVANCE(90);
      if (lookahead == '+') ADVANCE(88);
      if (lookahead == ',') ADVANCE(137);
      if (lookahead == '-') ADVANCE(93);
      if (lookahead == '.') ADVANCE(131);
      if (lookahead == '/') ADVANCE(96);
      if (lookahead == ':') ADVANCE(80);
      if (lookahead == ';') ADVANCE(71);
      if (lookahead == '<') ADVANCE(127);
      if (lookahead == '=') ADVANCE(120);
      if (lookahead == '>') ADVANCE(125);
      if (lookahead == '?') ADVANCE(91);
      if (lookahead == '[') ADVANCE(75);
      if (lookahead == ']') ADVANCE(76);
      if (lookahead == '^') ADVANCE(98);
      if (lookahead == 'r') ADVANCE(178);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(104);
      if (lookahead == '}') ADVANCE(78);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(18)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(189);
      END_STATE();
    case 19:
      if (lookahead == '!') ADVANCE(40);
      if (lookahead == '%') ADVANCE(97);
      if (lookahead == '&') ADVANCE(102);
      if (lookahead == '(') ADVANCE(73);
      if (lookahead == '*') ADVANCE(90);
      if (lookahead == '+') ADVANCE(88);
      if (lookahead == '-') ADVANCE(94);
      if (lookahead == '.') ADVANCE(131);
      if (lookahead == '/') ADVANCE(96);
      if (lookahead == '<') ADVANCE(127);
      if (lookahead == '=') ADVANCE(121);
      if (lookahead == '>') ADVANCE(125);
      if (lookahead == '?') ADVANCE(91);
      if (lookahead == '[') ADVANCE(75);
      if (lookahead == '^') ADVANCE(98);
      if (lookahead == 'r') ADVANCE(178);
      if (lookahead == '|') ADVANCE(104);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(19)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(189);
      END_STATE();
    case 20:
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == '/') ADVANCE(27);
      if (lookahead == ';') ADVANCE(71);
      if (lookahead == 'r') ADVANCE(178);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == 'b' ||
          lookahead == 'c') ADVANCE(177);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(20)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(189);
      END_STATE();
    case 21:
      if (lookahead == '#') ADVANCE(140);
      if (lookahead == '$') ADVANCE(64);
      if (lookahead == ',') ADVANCE(137);
      if (lookahead == '/') ADVANCE(27);
      if (lookahead == ':') ADVANCE(39);
      if (lookahead == ';') ADVANCE(71);
      if (lookahead == '<') ADVANCE(126);
      if (lookahead == '=') ADVANCE(119);
      if (lookahead == 'm') ADVANCE(180);
      if (lookahead == 'r') ADVANCE(178);
      if (lookahead == '}') ADVANCE(78);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(21)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(189);
      END_STATE();
    case 22:
      if (lookahead == '#') ADVANCE(140);
      if (lookahead == ',') ADVANCE(137);
      if (lookahead == '.') ADVANCE(30);
      if (lookahead == '/') ADVANCE(27);
      if (lookahead == '0') ADVANCE(149);
      if (lookahead == ':') ADVANCE(80);
      if (lookahead == ';') ADVANCE(71);
      if (lookahead == '<') ADVANCE(126);
      if (lookahead == '=') ADVANCE(119);
      if (lookahead == 'r') ADVANCE(178);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '}') ADVANCE(78);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(22)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(152);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(189);
      END_STATE();
    case 23:
      if (lookahead == '&') ADVANCE(105);
      END_STATE();
    case 24:
      if (lookahead == '\'') ADVANCE(156);
      END_STATE();
    case 25:
      if (lookahead == '\'') ADVANCE(156);
      if (lookahead == '\\') ADVANCE(46);
      if (lookahead != 0) ADVANCE(24);
      END_STATE();
    case 26:
      if (lookahead == '\'') ADVANCE(142);
      if (lookahead == '(') ADVANCE(73);
      if (lookahead == ')') ADVANCE(74);
      if (lookahead == '*') ADVANCE(89);
      if (lookahead == '+') ADVANCE(87);
      if (lookahead == ',') ADVANCE(137);
      if (lookahead == '-') ADVANCE(41);
      if (lookahead == '.') ADVANCE(29);
      if (lookahead == '/') ADVANCE(27);
      if (lookahead == ':') ADVANCE(80);
      if (lookahead == ';') ADVANCE(71);
      if (lookahead == '<') ADVANCE(144);
      if (lookahead == '=') ADVANCE(119);
      if (lookahead == '>') ADVANCE(124);
      if (lookahead == ']') ADVANCE(76);
      if (lookahead == 'r') ADVANCE(178);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(103);
      if (lookahead == '}') ADVANCE(78);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(26)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(189);
      END_STATE();
    case 27:
      if (lookahead == '*') ADVANCE(172);
      if (lookahead == '/') ADVANCE(158);
      END_STATE();
    case 28:
      if (lookahead == '*') ADVANCE(89);
      if (lookahead == '+') ADVANCE(87);
      if (lookahead == '/') ADVANCE(84);
      if (lookahead == '?') ADVANCE(91);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(85);
      if (lookahead != 0) ADVANCE(86);
      END_STATE();
    case 29:
      if (lookahead == '.') ADVANCE(134);
      END_STATE();
    case 30:
      if (lookahead == '.') ADVANCE(132);
      END_STATE();
    case 31:
      if (lookahead == '.') ADVANCE(133);
      END_STATE();
    case 32:
      if (lookahead == '/') ADVANCE(174);
      END_STATE();
    case 33:
      if (lookahead == '1') ADVANCE(35);
      if (lookahead == '3') ADVANCE(34);
      if (lookahead == '6') ADVANCE(37);
      if (lookahead == '8') ADVANCE(145);
      if (lookahead == 's') ADVANCE(44);
      END_STATE();
    case 34:
      if (lookahead == '2') ADVANCE(145);
      END_STATE();
    case 35:
      if (lookahead == '2') ADVANCE(38);
      if (lookahead == '6') ADVANCE(145);
      END_STATE();
    case 36:
      if (lookahead == '3') ADVANCE(34);
      if (lookahead == '6') ADVANCE(37);
      END_STATE();
    case 37:
      if (lookahead == '4') ADVANCE(145);
      END_STATE();
    case 38:
      if (lookahead == '8') ADVANCE(145);
      END_STATE();
    case 39:
      if (lookahead == ':') ADVANCE(138);
      END_STATE();
    case 40:
      if (lookahead == '=') ADVANCE(123);
      END_STATE();
    case 41:
      if (lookahead == '>') ADVANCE(139);
      END_STATE();
    case 42:
      if (lookahead == '>') ADVANCE(79);
      END_STATE();
    case 43:
      if (lookahead == 'e') ADVANCE(145);
      END_STATE();
    case 44:
      if (lookahead == 'i') ADVANCE(47);
      END_STATE();
    case 45:
      if (lookahead == 'u') ADVANCE(48);
      if (lookahead == 'x') ADVANCE(60);
      if (lookahead != 0) ADVANCE(157);
      END_STATE();
    case 46:
      if (lookahead == 'u') ADVANCE(49);
      if (lookahead == 'x') ADVANCE(61);
      if (lookahead != 0) ADVANCE(24);
      END_STATE();
    case 47:
      if (lookahead == 'z') ADVANCE(43);
      END_STATE();
    case 48:
      if (lookahead == '{') ADVANCE(58);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(56);
      END_STATE();
    case 49:
      if (lookahead == '{') ADVANCE(59);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(62);
      END_STATE();
    case 50:
      if (lookahead == '}') ADVANCE(24);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(50);
      END_STATE();
    case 51:
      if (lookahead == '}') ADVANCE(157);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(51);
      END_STATE();
    case 52:
      if (lookahead == '0' ||
          lookahead == '1' ||
          lookahead == '_') ADVANCE(150);
      END_STATE();
    case 53:
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(53);
      if (lookahead != 0 &&
          lookahead != '[') ADVANCE(190);
      END_STATE();
    case 54:
      if (('0' <= lookahead && lookahead <= '7') ||
          lookahead == '_') ADVANCE(151);
      END_STATE();
    case 55:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(24);
      END_STATE();
    case 56:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(60);
      END_STATE();
    case 57:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(157);
      END_STATE();
    case 58:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(51);
      END_STATE();
    case 59:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(50);
      END_STATE();
    case 60:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(57);
      END_STATE();
    case 61:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(55);
      END_STATE();
    case 62:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(61);
      END_STATE();
    case 63:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(153);
      END_STATE();
    case 64:
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(191);
      END_STATE();
    case 65:
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(189);
      END_STATE();
    case 66:
      if (eof) ADVANCE(70);
      if (lookahead == '!') ADVANCE(100);
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == '#') ADVANCE(141);
      if (lookahead == '$') ADVANCE(83);
      if (lookahead == '%') ADVANCE(97);
      if (lookahead == '&') ADVANCE(102);
      if (lookahead == '\'') ADVANCE(143);
      if (lookahead == '(') ADVANCE(73);
      if (lookahead == ')') ADVANCE(74);
      if (lookahead == '*') ADVANCE(90);
      if (lookahead == '+') ADVANCE(88);
      if (lookahead == ',') ADVANCE(137);
      if (lookahead == '-') ADVANCE(94);
      if (lookahead == '.') ADVANCE(131);
      if (lookahead == '/') ADVANCE(96);
      if (lookahead == '0') ADVANCE(149);
      if (lookahead == ':') ADVANCE(81);
      if (lookahead == ';') ADVANCE(71);
      if (lookahead == '<') ADVANCE(144);
      if (lookahead == '=') ADVANCE(121);
      if (lookahead == '>') ADVANCE(125);
      if (lookahead == '?') ADVANCE(91);
      if (lookahead == '@') ADVANCE(130);
      if (lookahead == '[') ADVANCE(75);
      if (lookahead == ']') ADVANCE(76);
      if (lookahead == '^') ADVANCE(98);
      if (lookahead == 'b') ADVANCE(176);
      if (lookahead == 'c') ADVANCE(177);
      if (lookahead == 'm') ADVANCE(180);
      if (lookahead == 'r') ADVANCE(178);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(104);
      if (lookahead == '}') ADVANCE(78);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(66)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(152);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(189);
      END_STATE();
    case 67:
      if (eof) ADVANCE(70);
      if (lookahead == '!') ADVANCE(100);
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == '#') ADVANCE(140);
      if (lookahead == '$') ADVANCE(64);
      if (lookahead == '%') ADVANCE(97);
      if (lookahead == '&') ADVANCE(102);
      if (lookahead == '\'') ADVANCE(143);
      if (lookahead == '(') ADVANCE(73);
      if (lookahead == '*') ADVANCE(90);
      if (lookahead == '+') ADVANCE(88);
      if (lookahead == '-') ADVANCE(93);
      if (lookahead == '.') ADVANCE(131);
      if (lookahead == '/') ADVANCE(96);
      if (lookahead == '0') ADVANCE(149);
      if (lookahead == ':') ADVANCE(39);
      if (lookahead == ';') ADVANCE(71);
      if (lookahead == '<') ADVANCE(127);
      if (lookahead == '=') ADVANCE(120);
      if (lookahead == '>') ADVANCE(125);
      if (lookahead == '?') ADVANCE(91);
      if (lookahead == '[') ADVANCE(75);
      if (lookahead == '^') ADVANCE(98);
      if (lookahead == 'b') ADVANCE(176);
      if (lookahead == 'c') ADVANCE(177);
      if (lookahead == 'm') ADVANCE(180);
      if (lookahead == 'r') ADVANCE(178);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(104);
      if (lookahead == '}') ADVANCE(78);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(67)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(152);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(189);
      END_STATE();
    case 68:
      if (eof) ADVANCE(70);
      if (lookahead == '!') ADVANCE(99);
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == '#') ADVANCE(141);
      if (lookahead == '$') ADVANCE(64);
      if (lookahead == '&') ADVANCE(101);
      if (lookahead == '\'') ADVANCE(143);
      if (lookahead == '(') ADVANCE(73);
      if (lookahead == ')') ADVANCE(74);
      if (lookahead == '*') ADVANCE(89);
      if (lookahead == '+') ADVANCE(87);
      if (lookahead == ',') ADVANCE(137);
      if (lookahead == '-') ADVANCE(92);
      if (lookahead == '.') ADVANCE(30);
      if (lookahead == '/') ADVANCE(27);
      if (lookahead == '0') ADVANCE(149);
      if (lookahead == ':') ADVANCE(81);
      if (lookahead == ';') ADVANCE(71);
      if (lookahead == '<') ADVANCE(126);
      if (lookahead == '=') ADVANCE(119);
      if (lookahead == '>') ADVANCE(124);
      if (lookahead == '?') ADVANCE(91);
      if (lookahead == '[') ADVANCE(75);
      if (lookahead == ']') ADVANCE(76);
      if (lookahead == 'b') ADVANCE(176);
      if (lookahead == 'c') ADVANCE(177);
      if (lookahead == 'm') ADVANCE(180);
      if (lookahead == 'r') ADVANCE(178);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(103);
      if (lookahead == '}') ADVANCE(78);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(68)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(152);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(189);
      END_STATE();
    case 69:
      if (eof) ADVANCE(70);
      if (lookahead == '!') ADVANCE(99);
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == '#') ADVANCE(140);
      if (lookahead == '$') ADVANCE(64);
      if (lookahead == '&') ADVANCE(101);
      if (lookahead == '\'') ADVANCE(143);
      if (lookahead == '(') ADVANCE(73);
      if (lookahead == '*') ADVANCE(89);
      if (lookahead == '-') ADVANCE(92);
      if (lookahead == '.') ADVANCE(30);
      if (lookahead == '/') ADVANCE(27);
      if (lookahead == '0') ADVANCE(149);
      if (lookahead == ':') ADVANCE(39);
      if (lookahead == ';') ADVANCE(71);
      if (lookahead == '<') ADVANCE(126);
      if (lookahead == '=') ADVANCE(42);
      if (lookahead == '[') ADVANCE(75);
      if (lookahead == 'b') ADVANCE(176);
      if (lookahead == 'c') ADVANCE(177);
      if (lookahead == 'm') ADVANCE(180);
      if (lookahead == 'r') ADVANCE(178);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(103);
      if (lookahead == '}') ADVANCE(78);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(69)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(152);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(189);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_macro_rules_BANG);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(138);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(191);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(aux_sym_token_repetition_pattern_token1);
      if (lookahead == '*') ADVANCE(172);
      if (lookahead == '/') ADVANCE(159);
      if (lookahead != 0 &&
          lookahead != '+' &&
          lookahead != '?') ADVANCE(86);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(aux_sym_token_repetition_pattern_token1);
      if (lookahead == '/') ADVANCE(84);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(85);
      if (lookahead != 0 &&
          lookahead != '*' &&
          lookahead != '+' &&
          lookahead != '?') ADVANCE(86);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(aux_sym_token_repetition_pattern_token1);
      if (lookahead != 0 &&
          lookahead != '*' &&
          lookahead != '+' &&
          lookahead != '?') ADVANCE(86);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(109);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=') ADVANCE(111);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(110);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(110);
      if (lookahead == '>') ADVANCE(139);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '>') ADVANCE(139);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(172);
      if (lookahead == '/') ADVANCE(158);
      if (lookahead == '=') ADVANCE(112);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(113);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(114);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(123);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(105);
      if (lookahead == '=') ADVANCE(115);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(116);
      if (lookahead == '|') ADVANCE(106);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(117);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(118);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(122);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(122);
      if (lookahead == '>') ADVANCE(79);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(128);
      if (lookahead == '>') ADVANCE(108);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(107);
      if (lookahead == '=') ADVANCE(129);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(134);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      if (lookahead == '.') ADVANCE(135);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      if (lookahead == '.') ADVANCE(135);
      if (lookahead == '=') ADVANCE(136);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_EQ);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_POUND);
      if (lookahead == '!') ADVANCE(53);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      if (lookahead == '\'') ADVANCE(156);
      if (lookahead == '\\') ADVANCE(46);
      if (lookahead != 0) ADVANCE(24);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_LT2);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(sym_integer_literal);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == '2') ADVANCE(153);
      if (lookahead == 'f') ADVANCE(147);
      if (lookahead == 'i') ADVANCE(33);
      if (lookahead == 'u') ADVANCE(33);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'e')) ADVANCE(153);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == '3') ADVANCE(146);
      if (lookahead == '6') ADVANCE(148);
      if (lookahead == 'f') ADVANCE(147);
      if (lookahead == 'i') ADVANCE(33);
      if (lookahead == 'u') ADVANCE(33);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'e')) ADVANCE(153);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == '4') ADVANCE(153);
      if (lookahead == 'f') ADVANCE(147);
      if (lookahead == 'i') ADVANCE(33);
      if (lookahead == 'u') ADVANCE(33);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'e')) ADVANCE(153);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == 'b') ADVANCE(52);
      if (lookahead == 'f') ADVANCE(36);
      if (lookahead == 'i') ADVANCE(33);
      if (lookahead == 'o') ADVANCE(54);
      if (lookahead == 'u') ADVANCE(33);
      if (lookahead == 'x') ADVANCE(63);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(152);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == 'f') ADVANCE(36);
      if (lookahead == 'i') ADVANCE(33);
      if (lookahead == 'u') ADVANCE(33);
      if (lookahead == '0' ||
          lookahead == '1' ||
          lookahead == '_') ADVANCE(150);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == 'f') ADVANCE(36);
      if (lookahead == 'i') ADVANCE(33);
      if (lookahead == 'u') ADVANCE(33);
      if (('0' <= lookahead && lookahead <= '7') ||
          lookahead == '_') ADVANCE(151);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == 'f') ADVANCE(36);
      if (lookahead == 'i') ADVANCE(33);
      if (lookahead == 'u') ADVANCE(33);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(152);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == 'f') ADVANCE(147);
      if (lookahead == 'i') ADVANCE(33);
      if (lookahead == 'u') ADVANCE(33);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'e')) ADVANCE(153);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(sym_char_literal);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      if (lookahead != 0 &&
          lookahead != '*' &&
          lookahead != '+' &&
          lookahead != '?') ADVANCE(86);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(164);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(aux_sym_line_comment_token1);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(aux_sym_line_comment_token2);
      if (lookahead == '*') ADVANCE(173);
      if (lookahead == '/') ADVANCE(160);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(164);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(aux_sym_line_comment_token2);
      if (lookahead == '/') ADVANCE(162);
      if (lookahead == '\t' ||
          (11 <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(163);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(164);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(aux_sym_line_comment_token2);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(164);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(aux_sym_line_comment_token3);
      if (lookahead == '!') ADVANCE(169);
      if (lookahead == '/') ADVANCE(171);
      if (lookahead == '\t' ||
          (11 <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(167);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(168);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(aux_sym_line_comment_token3);
      if (lookahead == '*') ADVANCE(168);
      if (lookahead == '/') ADVANCE(168);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(168);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(aux_sym_line_comment_token3);
      if (lookahead == '/') ADVANCE(166);
      if (lookahead == '\t' ||
          (11 <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(167);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(168);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(aux_sym_line_comment_token3);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(168);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(sym__inner_line_doc_comment_marker);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(sym__outer_line_doc_comment_marker);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(sym__outer_line_doc_comment_marker);
      if (lookahead == '/') ADVANCE(161);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_SLASH_STAR);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_SLASH_STAR);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(164);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_STAR_SLASH);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '!') ADVANCE(72);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(189);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == '\'') ADVANCE(25);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(189);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(154);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(189);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '#') ADVANCE(65);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(189);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_') ADVANCE(186);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(189);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a') ADVANCE(181);
      if (sym_identifier_character_set_5(lookahead)) ADVANCE(189);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c') ADVANCE(185);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(189);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(187);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(189);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l') ADVANCE(182);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(189);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o') ADVANCE(179);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(189);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r') ADVANCE(184);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(189);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r') ADVANCE(188);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(189);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's') ADVANCE(175);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(189);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'u') ADVANCE(183);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(189);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(189);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(sym_shebang);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '[') ADVANCE(190);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(sym_metavariable);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(191);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == '_') ADVANCE(1);
      if (lookahead == 'a') ADVANCE(2);
      if (lookahead == 'b') ADVANCE(3);
      if (lookahead == 'c') ADVANCE(4);
      if (lookahead == 'd') ADVANCE(5);
      if (lookahead == 'e') ADVANCE(6);
      if (lookahead == 'f') ADVANCE(7);
      if (lookahead == 'i') ADVANCE(8);
      if (lookahead == 'l') ADVANCE(9);
      if (lookahead == 'm') ADVANCE(10);
      if (lookahead == 'p') ADVANCE(11);
      if (lookahead == 'r') ADVANCE(12);
      if (lookahead == 's') ADVANCE(13);
      if (lookahead == 't') ADVANCE(14);
      if (lookahead == 'u') ADVANCE(15);
      if (lookahead == 'v') ADVANCE(16);
      if (lookahead == 'w') ADVANCE(17);
      if (lookahead == 'y') ADVANCE(18);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(0)
      END_STATE();
    case 1:
      ACCEPT_TOKEN(anon_sym__);
      END_STATE();
    case 2:
      if (lookahead == 's') ADVANCE(19);
      if (lookahead == 'w') ADVANCE(20);
      END_STATE();
    case 3:
      if (lookahead == 'l') ADVANCE(21);
      if (lookahead == 'o') ADVANCE(22);
      if (lookahead == 'r') ADVANCE(23);
      END_STATE();
    case 4:
      if (lookahead == 'h') ADVANCE(24);
      if (lookahead == 'o') ADVANCE(25);
      if (lookahead == 'r') ADVANCE(26);
      END_STATE();
    case 5:
      if (lookahead == 'e') ADVANCE(27);
      if (lookahead == 'y') ADVANCE(28);
      END_STATE();
    case 6:
      if (lookahead == 'l') ADVANCE(29);
      if (lookahead == 'n') ADVANCE(30);
      if (lookahead == 'x') ADVANCE(31);
      END_STATE();
    case 7:
      if (lookahead == '3') ADVANCE(32);
      if (lookahead == '6') ADVANCE(33);
      if (lookahead == 'a') ADVANCE(34);
      if (lookahead == 'n') ADVANCE(35);
      if (lookahead == 'o') ADVANCE(36);
      END_STATE();
    case 8:
      if (lookahead == '1') ADVANCE(37);
      if (lookahead == '3') ADVANCE(38);
      if (lookahead == '6') ADVANCE(39);
      if (lookahead == '8') ADVANCE(40);
      if (lookahead == 'd') ADVANCE(41);
      if (lookahead == 'f') ADVANCE(42);
      if (lookahead == 'm') ADVANCE(43);
      if (lookahead == 'n') ADVANCE(44);
      if (lookahead == 's') ADVANCE(45);
      if (lookahead == 't') ADVANCE(46);
      END_STATE();
    case 9:
      if (lookahead == 'e') ADVANCE(47);
      if (lookahead == 'i') ADVANCE(48);
      if (lookahead == 'o') ADVANCE(49);
      END_STATE();
    case 10:
      if (lookahead == 'a') ADVANCE(50);
      if (lookahead == 'e') ADVANCE(51);
      if (lookahead == 'o') ADVANCE(52);
      if (lookahead == 'u') ADVANCE(53);
      END_STATE();
    case 11:
      if (lookahead == 'a') ADVANCE(54);
      if (lookahead == 'u') ADVANCE(55);
      END_STATE();
    case 12:
      if (lookahead == 'e') ADVANCE(56);
      END_STATE();
    case 13:
      if (lookahead == 'e') ADVANCE(57);
      if (lookahead == 't') ADVANCE(58);
      if (lookahead == 'u') ADVANCE(59);
      END_STATE();
    case 14:
      if (lookahead == 'r') ADVANCE(60);
      if (lookahead == 't') ADVANCE(61);
      if (lookahead == 'y') ADVANCE(62);
      END_STATE();
    case 15:
      if (lookahead == '1') ADVANCE(63);
      if (lookahead == '3') ADVANCE(64);
      if (lookahead == '6') ADVANCE(65);
      if (lookahead == '8') ADVANCE(66);
      if (lookahead == 'n') ADVANCE(67);
      if (lookahead == 's') ADVANCE(68);
      END_STATE();
    case 16:
      if (lookahead == 'i') ADVANCE(69);
      END_STATE();
    case 17:
      if (lookahead == 'h') ADVANCE(70);
      END_STATE();
    case 18:
      if (lookahead == 'i') ADVANCE(71);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 'y') ADVANCE(72);
      END_STATE();
    case 20:
      if (lookahead == 'a') ADVANCE(73);
      END_STATE();
    case 21:
      if (lookahead == 'o') ADVANCE(74);
      END_STATE();
    case 22:
      if (lookahead == 'o') ADVANCE(75);
      END_STATE();
    case 23:
      if (lookahead == 'e') ADVANCE(76);
      END_STATE();
    case 24:
      if (lookahead == 'a') ADVANCE(77);
      END_STATE();
    case 25:
      if (lookahead == 'n') ADVANCE(78);
      END_STATE();
    case 26:
      if (lookahead == 'a') ADVANCE(79);
      END_STATE();
    case 27:
      if (lookahead == 'f') ADVANCE(80);
      END_STATE();
    case 28:
      if (lookahead == 'n') ADVANCE(81);
      END_STATE();
    case 29:
      if (lookahead == 's') ADVANCE(82);
      END_STATE();
    case 30:
      if (lookahead == 'u') ADVANCE(83);
      END_STATE();
    case 31:
      if (lookahead == 'p') ADVANCE(84);
      if (lookahead == 't') ADVANCE(85);
      END_STATE();
    case 32:
      if (lookahead == '2') ADVANCE(86);
      END_STATE();
    case 33:
      if (lookahead == '4') ADVANCE(87);
      END_STATE();
    case 34:
      if (lookahead == 'l') ADVANCE(88);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_fn);
      END_STATE();
    case 36:
      if (lookahead == 'r') ADVANCE(89);
      END_STATE();
    case 37:
      if (lookahead == '2') ADVANCE(90);
      if (lookahead == '6') ADVANCE(91);
      END_STATE();
    case 38:
      if (lookahead == '2') ADVANCE(92);
      END_STATE();
    case 39:
      if (lookahead == '4') ADVANCE(93);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_i8);
      END_STATE();
    case 41:
      if (lookahead == 'e') ADVANCE(94);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 43:
      if (lookahead == 'p') ADVANCE(95);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 45:
      if (lookahead == 'i') ADVANCE(96);
      END_STATE();
    case 46:
      if (lookahead == 'e') ADVANCE(97);
      END_STATE();
    case 47:
      if (lookahead == 't') ADVANCE(98);
      END_STATE();
    case 48:
      if (lookahead == 'f') ADVANCE(99);
      if (lookahead == 't') ADVANCE(100);
      END_STATE();
    case 49:
      if (lookahead == 'o') ADVANCE(101);
      END_STATE();
    case 50:
      if (lookahead == 't') ADVANCE(102);
      END_STATE();
    case 51:
      if (lookahead == 't') ADVANCE(103);
      END_STATE();
    case 52:
      if (lookahead == 'd') ADVANCE(104);
      if (lookahead == 'v') ADVANCE(105);
      END_STATE();
    case 53:
      if (lookahead == 't') ADVANCE(106);
      END_STATE();
    case 54:
      if (lookahead == 't') ADVANCE(107);
      END_STATE();
    case 55:
      if (lookahead == 'b') ADVANCE(108);
      END_STATE();
    case 56:
      if (lookahead == 'f') ADVANCE(109);
      if (lookahead == 't') ADVANCE(110);
      END_STATE();
    case 57:
      if (lookahead == 'l') ADVANCE(111);
      END_STATE();
    case 58:
      if (lookahead == 'a') ADVANCE(112);
      if (lookahead == 'm') ADVANCE(113);
      if (lookahead == 'r') ADVANCE(114);
      END_STATE();
    case 59:
      if (lookahead == 'p') ADVANCE(115);
      END_STATE();
    case 60:
      if (lookahead == 'a') ADVANCE(116);
      if (lookahead == 'u') ADVANCE(117);
      if (lookahead == 'y') ADVANCE(118);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_tt);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_ty);
      if (lookahead == 'p') ADVANCE(119);
      END_STATE();
    case 63:
      if (lookahead == '2') ADVANCE(120);
      if (lookahead == '6') ADVANCE(121);
      END_STATE();
    case 64:
      if (lookahead == '2') ADVANCE(122);
      END_STATE();
    case 65:
      if (lookahead == '4') ADVANCE(123);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_u8);
      END_STATE();
    case 67:
      if (lookahead == 'i') ADVANCE(124);
      if (lookahead == 's') ADVANCE(125);
      END_STATE();
    case 68:
      if (lookahead == 'e') ADVANCE(126);
      if (lookahead == 'i') ADVANCE(127);
      END_STATE();
    case 69:
      if (lookahead == 's') ADVANCE(128);
      END_STATE();
    case 70:
      if (lookahead == 'e') ADVANCE(129);
      if (lookahead == 'i') ADVANCE(130);
      END_STATE();
    case 71:
      if (lookahead == 'e') ADVANCE(131);
      END_STATE();
    case 72:
      if (lookahead == 'n') ADVANCE(132);
      END_STATE();
    case 73:
      if (lookahead == 'i') ADVANCE(133);
      END_STATE();
    case 74:
      if (lookahead == 'c') ADVANCE(134);
      END_STATE();
    case 75:
      if (lookahead == 'l') ADVANCE(135);
      END_STATE();
    case 76:
      if (lookahead == 'a') ADVANCE(136);
      END_STATE();
    case 77:
      if (lookahead == 'r') ADVANCE(137);
      END_STATE();
    case 78:
      if (lookahead == 's') ADVANCE(138);
      if (lookahead == 't') ADVANCE(139);
      END_STATE();
    case 79:
      if (lookahead == 't') ADVANCE(140);
      END_STATE();
    case 80:
      if (lookahead == 'a') ADVANCE(141);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_dyn);
      END_STATE();
    case 82:
      if (lookahead == 'e') ADVANCE(142);
      END_STATE();
    case 83:
      if (lookahead == 'm') ADVANCE(143);
      END_STATE();
    case 84:
      if (lookahead == 'r') ADVANCE(144);
      END_STATE();
    case 85:
      if (lookahead == 'e') ADVANCE(145);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_f32);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_f64);
      END_STATE();
    case 88:
      if (lookahead == 's') ADVANCE(146);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 90:
      if (lookahead == '8') ADVANCE(147);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_i16);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_i32);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_i64);
      END_STATE();
    case 94:
      if (lookahead == 'n') ADVANCE(148);
      END_STATE();
    case 95:
      if (lookahead == 'l') ADVANCE(149);
      END_STATE();
    case 96:
      if (lookahead == 'z') ADVANCE(150);
      END_STATE();
    case 97:
      if (lookahead == 'm') ADVANCE(151);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 99:
      if (lookahead == 'e') ADVANCE(152);
      END_STATE();
    case 100:
      if (lookahead == 'e') ADVANCE(153);
      END_STATE();
    case 101:
      if (lookahead == 'p') ADVANCE(154);
      END_STATE();
    case 102:
      if (lookahead == 'c') ADVANCE(155);
      END_STATE();
    case 103:
      if (lookahead == 'a') ADVANCE(156);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_mod);
      END_STATE();
    case 105:
      if (lookahead == 'e') ADVANCE(157);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(sym_mutable_specifier);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_pat);
      if (lookahead == 'h') ADVANCE(158);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_pub);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_ref);
      END_STATE();
    case 110:
      if (lookahead == 'u') ADVANCE(159);
      END_STATE();
    case 111:
      if (lookahead == 'f') ADVANCE(160);
      END_STATE();
    case 112:
      if (lookahead == 't') ADVANCE(161);
      END_STATE();
    case 113:
      if (lookahead == 't') ADVANCE(162);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_str);
      if (lookahead == 'u') ADVANCE(163);
      END_STATE();
    case 115:
      if (lookahead == 'e') ADVANCE(164);
      END_STATE();
    case 116:
      if (lookahead == 'i') ADVANCE(165);
      END_STATE();
    case 117:
      if (lookahead == 'e') ADVANCE(166);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 119:
      if (lookahead == 'e') ADVANCE(167);
      END_STATE();
    case 120:
      if (lookahead == '8') ADVANCE(168);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_u16);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_u32);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_u64);
      END_STATE();
    case 124:
      if (lookahead == 'o') ADVANCE(169);
      END_STATE();
    case 125:
      if (lookahead == 'a') ADVANCE(170);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_use);
      END_STATE();
    case 127:
      if (lookahead == 'z') ADVANCE(171);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_vis);
      END_STATE();
    case 129:
      if (lookahead == 'r') ADVANCE(172);
      END_STATE();
    case 130:
      if (lookahead == 'l') ADVANCE(173);
      END_STATE();
    case 131:
      if (lookahead == 'l') ADVANCE(174);
      END_STATE();
    case 132:
      if (lookahead == 'c') ADVANCE(175);
      END_STATE();
    case 133:
      if (lookahead == 't') ADVANCE(176);
      END_STATE();
    case 134:
      if (lookahead == 'k') ADVANCE(177);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_bool);
      END_STATE();
    case 136:
      if (lookahead == 'k') ADVANCE(178);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_char);
      END_STATE();
    case 138:
      if (lookahead == 't') ADVANCE(179);
      END_STATE();
    case 139:
      if (lookahead == 'i') ADVANCE(180);
      END_STATE();
    case 140:
      if (lookahead == 'e') ADVANCE(181);
      END_STATE();
    case 141:
      if (lookahead == 'u') ADVANCE(182);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_expr);
      END_STATE();
    case 145:
      if (lookahead == 'r') ADVANCE(183);
      END_STATE();
    case 146:
      if (lookahead == 'e') ADVANCE(184);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_i128);
      END_STATE();
    case 148:
      if (lookahead == 't') ADVANCE(185);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_impl);
      END_STATE();
    case 150:
      if (lookahead == 'e') ADVANCE(186);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_item);
      END_STATE();
    case 152:
      if (lookahead == 't') ADVANCE(187);
      END_STATE();
    case 153:
      if (lookahead == 'r') ADVANCE(188);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_loop);
      END_STATE();
    case 155:
      if (lookahead == 'h') ADVANCE(189);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_meta);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_move);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_path);
      END_STATE();
    case 159:
      if (lookahead == 'r') ADVANCE(190);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(sym_self);
      END_STATE();
    case 161:
      if (lookahead == 'i') ADVANCE(191);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_stmt);
      END_STATE();
    case 163:
      if (lookahead == 'c') ADVANCE(192);
      END_STATE();
    case 164:
      if (lookahead == 'r') ADVANCE(193);
      END_STATE();
    case 165:
      if (lookahead == 't') ADVANCE(194);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_type);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_u128);
      END_STATE();
    case 169:
      if (lookahead == 'n') ADVANCE(195);
      END_STATE();
    case 170:
      if (lookahead == 'f') ADVANCE(196);
      END_STATE();
    case 171:
      if (lookahead == 'e') ADVANCE(197);
      END_STATE();
    case 172:
      if (lookahead == 'e') ADVANCE(198);
      END_STATE();
    case 173:
      if (lookahead == 'e') ADVANCE(199);
      END_STATE();
    case 174:
      if (lookahead == 'd') ADVANCE(200);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_block);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 180:
      if (lookahead == 'n') ADVANCE(201);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(sym_crate);
      END_STATE();
    case 182:
      if (lookahead == 'l') ADVANCE(202);
      END_STATE();
    case 183:
      if (lookahead == 'n') ADVANCE(203);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_ident);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_isize);
      END_STATE();
    case 187:
      if (lookahead == 'i') ADVANCE(204);
      END_STATE();
    case 188:
      if (lookahead == 'a') ADVANCE(205);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_match);
      END_STATE();
    case 190:
      if (lookahead == 'n') ADVANCE(206);
      END_STATE();
    case 191:
      if (lookahead == 'c') ADVANCE(207);
      END_STATE();
    case 192:
      if (lookahead == 't') ADVANCE(208);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_trait);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_union);
      END_STATE();
    case 196:
      if (lookahead == 'e') ADVANCE(209);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(anon_sym_usize);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(anon_sym_where);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 201:
      if (lookahead == 'u') ADVANCE(210);
      END_STATE();
    case 202:
      if (lookahead == 't') ADVANCE(211);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_extern);
      END_STATE();
    case 204:
      if (lookahead == 'm') ADVANCE(212);
      END_STATE();
    case 205:
      if (lookahead == 'l') ADVANCE(213);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(anon_sym_unsafe);
      END_STATE();
    case 210:
      if (lookahead == 'e') ADVANCE(214);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 212:
      if (lookahead == 'e') ADVANCE(215);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(anon_sym_literal);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(anon_sym_lifetime);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 68, .external_lex_state = 2},
  [2] = {.lex_state = 69, .external_lex_state = 2},
  [3] = {.lex_state = 69, .external_lex_state = 2},
  [4] = {.lex_state = 69, .external_lex_state = 2},
  [5] = {.lex_state = 69, .external_lex_state = 2},
  [6] = {.lex_state = 69, .external_lex_state = 2},
  [7] = {.lex_state = 69, .external_lex_state = 2},
  [8] = {.lex_state = 69, .external_lex_state = 2},
  [9] = {.lex_state = 69, .external_lex_state = 2},
  [10] = {.lex_state = 69, .external_lex_state = 2},
  [11] = {.lex_state = 69, .external_lex_state = 2},
  [12] = {.lex_state = 69, .external_lex_state = 2},
  [13] = {.lex_state = 69, .external_lex_state = 2},
  [14] = {.lex_state = 69, .external_lex_state = 2},
  [15] = {.lex_state = 69, .external_lex_state = 2},
  [16] = {.lex_state = 69, .external_lex_state = 2},
  [17] = {.lex_state = 69, .external_lex_state = 2},
  [18] = {.lex_state = 69, .external_lex_state = 2},
  [19] = {.lex_state = 69, .external_lex_state = 2},
  [20] = {.lex_state = 69, .external_lex_state = 2},
  [21] = {.lex_state = 69, .external_lex_state = 2},
  [22] = {.lex_state = 69, .external_lex_state = 2},
  [23] = {.lex_state = 69, .external_lex_state = 2},
  [24] = {.lex_state = 69, .external_lex_state = 2},
  [25] = {.lex_state = 69, .external_lex_state = 2},
  [26] = {.lex_state = 69, .external_lex_state = 2},
  [27] = {.lex_state = 69, .external_lex_state = 2},
  [28] = {.lex_state = 69, .external_lex_state = 2},
  [29] = {.lex_state = 69, .external_lex_state = 2},
  [30] = {.lex_state = 69, .external_lex_state = 2},
  [31] = {.lex_state = 69, .external_lex_state = 2},
  [32] = {.lex_state = 69, .external_lex_state = 2},
  [33] = {.lex_state = 69, .external_lex_state = 2},
  [34] = {.lex_state = 69, .external_lex_state = 2},
  [35] = {.lex_state = 2, .external_lex_state = 2},
  [36] = {.lex_state = 2, .external_lex_state = 2},
  [37] = {.lex_state = 2, .external_lex_state = 2},
  [38] = {.lex_state = 2, .external_lex_state = 2},
  [39] = {.lex_state = 2, .external_lex_state = 2},
  [40] = {.lex_state = 2, .external_lex_state = 2},
  [41] = {.lex_state = 2, .external_lex_state = 2},
  [42] = {.lex_state = 2, .external_lex_state = 2},
  [43] = {.lex_state = 4, .external_lex_state = 2},
  [44] = {.lex_state = 4, .external_lex_state = 2},
  [45] = {.lex_state = 2, .external_lex_state = 2},
  [46] = {.lex_state = 4, .external_lex_state = 2},
  [47] = {.lex_state = 4, .external_lex_state = 2},
  [48] = {.lex_state = 4, .external_lex_state = 2},
  [49] = {.lex_state = 4, .external_lex_state = 2},
  [50] = {.lex_state = 4, .external_lex_state = 2},
  [51] = {.lex_state = 2, .external_lex_state = 2},
  [52] = {.lex_state = 4, .external_lex_state = 2},
  [53] = {.lex_state = 2, .external_lex_state = 2},
  [54] = {.lex_state = 2, .external_lex_state = 2},
  [55] = {.lex_state = 2, .external_lex_state = 2},
  [56] = {.lex_state = 2, .external_lex_state = 2},
  [57] = {.lex_state = 2, .external_lex_state = 2},
  [58] = {.lex_state = 2, .external_lex_state = 2},
  [59] = {.lex_state = 2, .external_lex_state = 2},
  [60] = {.lex_state = 2, .external_lex_state = 2},
  [61] = {.lex_state = 2, .external_lex_state = 2},
  [62] = {.lex_state = 2, .external_lex_state = 2},
  [63] = {.lex_state = 2, .external_lex_state = 2},
  [64] = {.lex_state = 2, .external_lex_state = 2},
  [65] = {.lex_state = 2, .external_lex_state = 2},
  [66] = {.lex_state = 2, .external_lex_state = 2},
  [67] = {.lex_state = 1, .external_lex_state = 2},
  [68] = {.lex_state = 1, .external_lex_state = 2},
  [69] = {.lex_state = 1, .external_lex_state = 2},
  [70] = {.lex_state = 1, .external_lex_state = 2},
  [71] = {.lex_state = 1, .external_lex_state = 2},
  [72] = {.lex_state = 1, .external_lex_state = 2},
  [73] = {.lex_state = 3, .external_lex_state = 2},
  [74] = {.lex_state = 1, .external_lex_state = 2},
  [75] = {.lex_state = 1, .external_lex_state = 2},
  [76] = {.lex_state = 1, .external_lex_state = 2},
  [77] = {.lex_state = 1, .external_lex_state = 2},
  [78] = {.lex_state = 1, .external_lex_state = 2},
  [79] = {.lex_state = 1, .external_lex_state = 2},
  [80] = {.lex_state = 1, .external_lex_state = 2},
  [81] = {.lex_state = 1, .external_lex_state = 2},
  [82] = {.lex_state = 1, .external_lex_state = 2},
  [83] = {.lex_state = 1, .external_lex_state = 2},
  [84] = {.lex_state = 3, .external_lex_state = 2},
  [85] = {.lex_state = 3, .external_lex_state = 2},
  [86] = {.lex_state = 3, .external_lex_state = 2},
  [87] = {.lex_state = 3, .external_lex_state = 2},
  [88] = {.lex_state = 3, .external_lex_state = 2},
  [89] = {.lex_state = 3, .external_lex_state = 2},
  [90] = {.lex_state = 1, .external_lex_state = 2},
  [91] = {.lex_state = 1, .external_lex_state = 2},
  [92] = {.lex_state = 3, .external_lex_state = 2},
  [93] = {.lex_state = 1, .external_lex_state = 2},
  [94] = {.lex_state = 3, .external_lex_state = 2},
  [95] = {.lex_state = 3, .external_lex_state = 2},
  [96] = {.lex_state = 3, .external_lex_state = 2},
  [97] = {.lex_state = 1, .external_lex_state = 2},
  [98] = {.lex_state = 1, .external_lex_state = 2},
  [99] = {.lex_state = 3, .external_lex_state = 2},
  [100] = {.lex_state = 3, .external_lex_state = 2},
  [101] = {.lex_state = 3, .external_lex_state = 2},
  [102] = {.lex_state = 1, .external_lex_state = 2},
  [103] = {.lex_state = 1, .external_lex_state = 2},
  [104] = {.lex_state = 3, .external_lex_state = 2},
  [105] = {.lex_state = 3, .external_lex_state = 2},
  [106] = {.lex_state = 3, .external_lex_state = 2},
  [107] = {.lex_state = 3, .external_lex_state = 2},
  [108] = {.lex_state = 3, .external_lex_state = 2},
  [109] = {.lex_state = 3, .external_lex_state = 2},
  [110] = {.lex_state = 3, .external_lex_state = 2},
  [111] = {.lex_state = 3, .external_lex_state = 2},
  [112] = {.lex_state = 3, .external_lex_state = 2},
  [113] = {.lex_state = 3, .external_lex_state = 2},
  [114] = {.lex_state = 1, .external_lex_state = 2},
  [115] = {.lex_state = 3, .external_lex_state = 2},
  [116] = {.lex_state = 3, .external_lex_state = 2},
  [117] = {.lex_state = 3, .external_lex_state = 2},
  [118] = {.lex_state = 3, .external_lex_state = 2},
  [119] = {.lex_state = 3, .external_lex_state = 2},
  [120] = {.lex_state = 3, .external_lex_state = 2},
  [121] = {.lex_state = 3, .external_lex_state = 2},
  [122] = {.lex_state = 3, .external_lex_state = 2},
  [123] = {.lex_state = 3, .external_lex_state = 2},
  [124] = {.lex_state = 1, .external_lex_state = 2},
  [125] = {.lex_state = 1, .external_lex_state = 2},
  [126] = {.lex_state = 1, .external_lex_state = 2},
  [127] = {.lex_state = 1, .external_lex_state = 2},
  [128] = {.lex_state = 1, .external_lex_state = 2},
  [129] = {.lex_state = 3, .external_lex_state = 2},
  [130] = {.lex_state = 3, .external_lex_state = 2},
  [131] = {.lex_state = 3, .external_lex_state = 2},
  [132] = {.lex_state = 3, .external_lex_state = 2},
  [133] = {.lex_state = 1, .external_lex_state = 2},
  [134] = {.lex_state = 1, .external_lex_state = 2},
  [135] = {.lex_state = 1, .external_lex_state = 2},
  [136] = {.lex_state = 1, .external_lex_state = 2},
  [137] = {.lex_state = 1, .external_lex_state = 2},
  [138] = {.lex_state = 1, .external_lex_state = 2},
  [139] = {.lex_state = 10, .external_lex_state = 2},
  [140] = {.lex_state = 1, .external_lex_state = 2},
  [141] = {.lex_state = 1, .external_lex_state = 2},
  [142] = {.lex_state = 1, .external_lex_state = 2},
  [143] = {.lex_state = 10, .external_lex_state = 2},
  [144] = {.lex_state = 3, .external_lex_state = 2},
  [145] = {.lex_state = 1, .external_lex_state = 2},
  [146] = {.lex_state = 1, .external_lex_state = 2},
  [147] = {.lex_state = 1, .external_lex_state = 2},
  [148] = {.lex_state = 3, .external_lex_state = 2},
  [149] = {.lex_state = 1, .external_lex_state = 2},
  [150] = {.lex_state = 10, .external_lex_state = 2},
  [151] = {.lex_state = 1, .external_lex_state = 2},
  [152] = {.lex_state = 1, .external_lex_state = 2},
  [153] = {.lex_state = 1, .external_lex_state = 2},
  [154] = {.lex_state = 10, .external_lex_state = 2},
  [155] = {.lex_state = 1, .external_lex_state = 2},
  [156] = {.lex_state = 10, .external_lex_state = 2},
  [157] = {.lex_state = 1, .external_lex_state = 2},
  [158] = {.lex_state = 10, .external_lex_state = 2},
  [159] = {.lex_state = 1, .external_lex_state = 2},
  [160] = {.lex_state = 1, .external_lex_state = 2},
  [161] = {.lex_state = 1, .external_lex_state = 2},
  [162] = {.lex_state = 10, .external_lex_state = 2},
  [163] = {.lex_state = 1, .external_lex_state = 2},
  [164] = {.lex_state = 1, .external_lex_state = 2},
  [165] = {.lex_state = 1, .external_lex_state = 2},
  [166] = {.lex_state = 1, .external_lex_state = 2},
  [167] = {.lex_state = 10, .external_lex_state = 2},
  [168] = {.lex_state = 1, .external_lex_state = 2},
  [169] = {.lex_state = 10, .external_lex_state = 2},
  [170] = {.lex_state = 10, .external_lex_state = 2},
  [171] = {.lex_state = 10, .external_lex_state = 2},
  [172] = {.lex_state = 10, .external_lex_state = 2},
  [173] = {.lex_state = 10, .external_lex_state = 2},
  [174] = {.lex_state = 10, .external_lex_state = 2},
  [175] = {.lex_state = 10, .external_lex_state = 2},
  [176] = {.lex_state = 10, .external_lex_state = 2},
  [177] = {.lex_state = 10, .external_lex_state = 2},
  [178] = {.lex_state = 10, .external_lex_state = 2},
  [179] = {.lex_state = 10, .external_lex_state = 2},
  [180] = {.lex_state = 3, .external_lex_state = 2},
  [181] = {.lex_state = 10, .external_lex_state = 2},
  [182] = {.lex_state = 3, .external_lex_state = 2},
  [183] = {.lex_state = 3, .external_lex_state = 2},
  [184] = {.lex_state = 3, .external_lex_state = 2},
  [185] = {.lex_state = 3, .external_lex_state = 2},
  [186] = {.lex_state = 10, .external_lex_state = 2},
  [187] = {.lex_state = 3, .external_lex_state = 2},
  [188] = {.lex_state = 3, .external_lex_state = 2},
  [189] = {.lex_state = 10, .external_lex_state = 2},
  [190] = {.lex_state = 10, .external_lex_state = 2},
  [191] = {.lex_state = 10, .external_lex_state = 2},
  [192] = {.lex_state = 10, .external_lex_state = 2},
  [193] = {.lex_state = 3, .external_lex_state = 2},
  [194] = {.lex_state = 10, .external_lex_state = 2},
  [195] = {.lex_state = 10, .external_lex_state = 2},
  [196] = {.lex_state = 10, .external_lex_state = 2},
  [197] = {.lex_state = 10, .external_lex_state = 2},
  [198] = {.lex_state = 10, .external_lex_state = 2},
  [199] = {.lex_state = 10, .external_lex_state = 2},
  [200] = {.lex_state = 3, .external_lex_state = 2},
  [201] = {.lex_state = 10, .external_lex_state = 2},
  [202] = {.lex_state = 10, .external_lex_state = 2},
  [203] = {.lex_state = 3, .external_lex_state = 2},
  [204] = {.lex_state = 10, .external_lex_state = 2},
  [205] = {.lex_state = 10, .external_lex_state = 2},
  [206] = {.lex_state = 10, .external_lex_state = 2},
  [207] = {.lex_state = 10, .external_lex_state = 2},
  [208] = {.lex_state = 3, .external_lex_state = 2},
  [209] = {.lex_state = 10, .external_lex_state = 2},
  [210] = {.lex_state = 10, .external_lex_state = 2},
  [211] = {.lex_state = 10, .external_lex_state = 2},
  [212] = {.lex_state = 10, .external_lex_state = 2},
  [213] = {.lex_state = 10, .external_lex_state = 2},
  [214] = {.lex_state = 10, .external_lex_state = 2},
  [215] = {.lex_state = 12, .external_lex_state = 2},
  [216] = {.lex_state = 12, .external_lex_state = 2},
  [217] = {.lex_state = 12, .external_lex_state = 2},
  [218] = {.lex_state = 12, .external_lex_state = 2},
  [219] = {.lex_state = 12, .external_lex_state = 2},
  [220] = {.lex_state = 10, .external_lex_state = 2},
  [221] = {.lex_state = 10, .external_lex_state = 2},
  [222] = {.lex_state = 12, .external_lex_state = 2},
  [223] = {.lex_state = 10, .external_lex_state = 2},
  [224] = {.lex_state = 12, .external_lex_state = 2},
  [225] = {.lex_state = 12, .external_lex_state = 2},
  [226] = {.lex_state = 12, .external_lex_state = 2},
  [227] = {.lex_state = 10, .external_lex_state = 2},
  [228] = {.lex_state = 10, .external_lex_state = 2},
  [229] = {.lex_state = 12, .external_lex_state = 2},
  [230] = {.lex_state = 12, .external_lex_state = 2},
  [231] = {.lex_state = 10, .external_lex_state = 2},
  [232] = {.lex_state = 10, .external_lex_state = 2},
  [233] = {.lex_state = 10, .external_lex_state = 2},
  [234] = {.lex_state = 10, .external_lex_state = 2},
  [235] = {.lex_state = 10, .external_lex_state = 2},
  [236] = {.lex_state = 12, .external_lex_state = 2},
  [237] = {.lex_state = 12, .external_lex_state = 2},
  [238] = {.lex_state = 10, .external_lex_state = 2},
  [239] = {.lex_state = 10, .external_lex_state = 2},
  [240] = {.lex_state = 10, .external_lex_state = 2},
  [241] = {.lex_state = 12, .external_lex_state = 2},
  [242] = {.lex_state = 12, .external_lex_state = 2},
  [243] = {.lex_state = 10, .external_lex_state = 2},
  [244] = {.lex_state = 67, .external_lex_state = 2},
  [245] = {.lex_state = 10, .external_lex_state = 2},
  [246] = {.lex_state = 10, .external_lex_state = 2},
  [247] = {.lex_state = 10, .external_lex_state = 2},
  [248] = {.lex_state = 10, .external_lex_state = 2},
  [249] = {.lex_state = 10, .external_lex_state = 2},
  [250] = {.lex_state = 10, .external_lex_state = 2},
  [251] = {.lex_state = 10, .external_lex_state = 2},
  [252] = {.lex_state = 10, .external_lex_state = 2},
  [253] = {.lex_state = 10, .external_lex_state = 2},
  [254] = {.lex_state = 10, .external_lex_state = 2},
  [255] = {.lex_state = 10, .external_lex_state = 2},
  [256] = {.lex_state = 10, .external_lex_state = 2},
  [257] = {.lex_state = 10, .external_lex_state = 2},
  [258] = {.lex_state = 10, .external_lex_state = 2},
  [259] = {.lex_state = 10, .external_lex_state = 2},
  [260] = {.lex_state = 10, .external_lex_state = 2},
  [261] = {.lex_state = 10, .external_lex_state = 2},
  [262] = {.lex_state = 10, .external_lex_state = 2},
  [263] = {.lex_state = 10, .external_lex_state = 2},
  [264] = {.lex_state = 10, .external_lex_state = 2},
  [265] = {.lex_state = 10, .external_lex_state = 2},
  [266] = {.lex_state = 10, .external_lex_state = 2},
  [267] = {.lex_state = 10, .external_lex_state = 2},
  [268] = {.lex_state = 10, .external_lex_state = 2},
  [269] = {.lex_state = 10, .external_lex_state = 2},
  [270] = {.lex_state = 10, .external_lex_state = 2},
  [271] = {.lex_state = 10, .external_lex_state = 2},
  [272] = {.lex_state = 10, .external_lex_state = 2},
  [273] = {.lex_state = 10, .external_lex_state = 2},
  [274] = {.lex_state = 10, .external_lex_state = 2},
  [275] = {.lex_state = 10, .external_lex_state = 2},
  [276] = {.lex_state = 10, .external_lex_state = 2},
  [277] = {.lex_state = 10, .external_lex_state = 2},
  [278] = {.lex_state = 10, .external_lex_state = 2},
  [279] = {.lex_state = 10, .external_lex_state = 2},
  [280] = {.lex_state = 10, .external_lex_state = 2},
  [281] = {.lex_state = 10, .external_lex_state = 2},
  [282] = {.lex_state = 10, .external_lex_state = 2},
  [283] = {.lex_state = 10, .external_lex_state = 2},
  [284] = {.lex_state = 10, .external_lex_state = 2},
  [285] = {.lex_state = 10, .external_lex_state = 2},
  [286] = {.lex_state = 10, .external_lex_state = 2},
  [287] = {.lex_state = 10, .external_lex_state = 2},
  [288] = {.lex_state = 10, .external_lex_state = 2},
  [289] = {.lex_state = 10, .external_lex_state = 2},
  [290] = {.lex_state = 10, .external_lex_state = 2},
  [291] = {.lex_state = 10, .external_lex_state = 2},
  [292] = {.lex_state = 10, .external_lex_state = 2},
  [293] = {.lex_state = 10, .external_lex_state = 2},
  [294] = {.lex_state = 10, .external_lex_state = 2},
  [295] = {.lex_state = 10, .external_lex_state = 2},
  [296] = {.lex_state = 10, .external_lex_state = 2},
  [297] = {.lex_state = 67, .external_lex_state = 2},
  [298] = {.lex_state = 10, .external_lex_state = 2},
  [299] = {.lex_state = 10, .external_lex_state = 2},
  [300] = {.lex_state = 10, .external_lex_state = 2},
  [301] = {.lex_state = 10, .external_lex_state = 2},
  [302] = {.lex_state = 10, .external_lex_state = 2},
  [303] = {.lex_state = 10, .external_lex_state = 2},
  [304] = {.lex_state = 10, .external_lex_state = 2},
  [305] = {.lex_state = 10, .external_lex_state = 2},
  [306] = {.lex_state = 10, .external_lex_state = 2},
  [307] = {.lex_state = 10, .external_lex_state = 2},
  [308] = {.lex_state = 10, .external_lex_state = 2},
  [309] = {.lex_state = 10, .external_lex_state = 2},
  [310] = {.lex_state = 10, .external_lex_state = 2},
  [311] = {.lex_state = 10, .external_lex_state = 2},
  [312] = {.lex_state = 10, .external_lex_state = 2},
  [313] = {.lex_state = 67, .external_lex_state = 2},
  [314] = {.lex_state = 10, .external_lex_state = 2},
  [315] = {.lex_state = 10, .external_lex_state = 2},
  [316] = {.lex_state = 10, .external_lex_state = 2},
  [317] = {.lex_state = 10, .external_lex_state = 2},
  [318] = {.lex_state = 10, .external_lex_state = 2},
  [319] = {.lex_state = 10, .external_lex_state = 2},
  [320] = {.lex_state = 10, .external_lex_state = 2},
  [321] = {.lex_state = 10, .external_lex_state = 2},
  [322] = {.lex_state = 10, .external_lex_state = 2},
  [323] = {.lex_state = 10, .external_lex_state = 2},
  [324] = {.lex_state = 10, .external_lex_state = 2},
  [325] = {.lex_state = 10, .external_lex_state = 2},
  [326] = {.lex_state = 10, .external_lex_state = 2},
  [327] = {.lex_state = 10, .external_lex_state = 2},
  [328] = {.lex_state = 10, .external_lex_state = 2},
  [329] = {.lex_state = 10, .external_lex_state = 2},
  [330] = {.lex_state = 10, .external_lex_state = 2},
  [331] = {.lex_state = 10, .external_lex_state = 2},
  [332] = {.lex_state = 10, .external_lex_state = 2},
  [333] = {.lex_state = 10, .external_lex_state = 2},
  [334] = {.lex_state = 10, .external_lex_state = 2},
  [335] = {.lex_state = 67, .external_lex_state = 2},
  [336] = {.lex_state = 10, .external_lex_state = 2},
  [337] = {.lex_state = 10, .external_lex_state = 2},
  [338] = {.lex_state = 10, .external_lex_state = 2},
  [339] = {.lex_state = 10, .external_lex_state = 2},
  [340] = {.lex_state = 10, .external_lex_state = 2},
  [341] = {.lex_state = 10, .external_lex_state = 2},
  [342] = {.lex_state = 10, .external_lex_state = 2},
  [343] = {.lex_state = 10, .external_lex_state = 2},
  [344] = {.lex_state = 10, .external_lex_state = 2},
  [345] = {.lex_state = 10, .external_lex_state = 2},
  [346] = {.lex_state = 10, .external_lex_state = 2},
  [347] = {.lex_state = 10, .external_lex_state = 2},
  [348] = {.lex_state = 10, .external_lex_state = 2},
  [349] = {.lex_state = 10, .external_lex_state = 2},
  [350] = {.lex_state = 10, .external_lex_state = 2},
  [351] = {.lex_state = 10, .external_lex_state = 2},
  [352] = {.lex_state = 10, .external_lex_state = 2},
  [353] = {.lex_state = 10, .external_lex_state = 2},
  [354] = {.lex_state = 10, .external_lex_state = 2},
  [355] = {.lex_state = 10, .external_lex_state = 2},
  [356] = {.lex_state = 10, .external_lex_state = 2},
  [357] = {.lex_state = 10, .external_lex_state = 2},
  [358] = {.lex_state = 10, .external_lex_state = 2},
  [359] = {.lex_state = 10, .external_lex_state = 2},
  [360] = {.lex_state = 10, .external_lex_state = 2},
  [361] = {.lex_state = 10, .external_lex_state = 2},
  [362] = {.lex_state = 10, .external_lex_state = 2},
  [363] = {.lex_state = 10, .external_lex_state = 2},
  [364] = {.lex_state = 10, .external_lex_state = 2},
  [365] = {.lex_state = 67, .external_lex_state = 2},
  [366] = {.lex_state = 10, .external_lex_state = 2},
  [367] = {.lex_state = 10, .external_lex_state = 2},
  [368] = {.lex_state = 10, .external_lex_state = 2},
  [369] = {.lex_state = 67, .external_lex_state = 2},
  [370] = {.lex_state = 10, .external_lex_state = 2},
  [371] = {.lex_state = 67, .external_lex_state = 2},
  [372] = {.lex_state = 67, .external_lex_state = 2},
  [373] = {.lex_state = 67, .external_lex_state = 2},
  [374] = {.lex_state = 67, .external_lex_state = 2},
  [375] = {.lex_state = 11, .external_lex_state = 2},
  [376] = {.lex_state = 67, .external_lex_state = 2},
  [377] = {.lex_state = 67, .external_lex_state = 2},
  [378] = {.lex_state = 67, .external_lex_state = 2},
  [379] = {.lex_state = 67, .external_lex_state = 2},
  [380] = {.lex_state = 67, .external_lex_state = 2},
  [381] = {.lex_state = 11, .external_lex_state = 2},
  [382] = {.lex_state = 67, .external_lex_state = 2},
  [383] = {.lex_state = 11, .external_lex_state = 2},
  [384] = {.lex_state = 67, .external_lex_state = 2},
  [385] = {.lex_state = 67, .external_lex_state = 2},
  [386] = {.lex_state = 67, .external_lex_state = 2},
  [387] = {.lex_state = 67, .external_lex_state = 2},
  [388] = {.lex_state = 67, .external_lex_state = 2},
  [389] = {.lex_state = 67, .external_lex_state = 2},
  [390] = {.lex_state = 11, .external_lex_state = 2},
  [391] = {.lex_state = 67, .external_lex_state = 2},
  [392] = {.lex_state = 67, .external_lex_state = 2},
  [393] = {.lex_state = 67, .external_lex_state = 2},
  [394] = {.lex_state = 11, .external_lex_state = 2},
  [395] = {.lex_state = 11, .external_lex_state = 2},
  [396] = {.lex_state = 67, .external_lex_state = 2},
  [397] = {.lex_state = 67, .external_lex_state = 2},
  [398] = {.lex_state = 67, .external_lex_state = 2},
  [399] = {.lex_state = 67, .external_lex_state = 2},
  [400] = {.lex_state = 11, .external_lex_state = 2},
  [401] = {.lex_state = 67, .external_lex_state = 2},
  [402] = {.lex_state = 11, .external_lex_state = 2},
  [403] = {.lex_state = 11, .external_lex_state = 2},
  [404] = {.lex_state = 11, .external_lex_state = 2},
  [405] = {.lex_state = 11, .external_lex_state = 2},
  [406] = {.lex_state = 11, .external_lex_state = 2},
  [407] = {.lex_state = 11, .external_lex_state = 2},
  [408] = {.lex_state = 11, .external_lex_state = 2},
  [409] = {.lex_state = 11, .external_lex_state = 2},
  [410] = {.lex_state = 10, .external_lex_state = 2},
  [411] = {.lex_state = 10, .external_lex_state = 2},
  [412] = {.lex_state = 11, .external_lex_state = 2},
  [413] = {.lex_state = 10, .external_lex_state = 2},
  [414] = {.lex_state = 11, .external_lex_state = 2},
  [415] = {.lex_state = 11, .external_lex_state = 2},
  [416] = {.lex_state = 11, .external_lex_state = 2},
  [417] = {.lex_state = 11, .external_lex_state = 2},
  [418] = {.lex_state = 10, .external_lex_state = 2},
  [419] = {.lex_state = 10, .external_lex_state = 2},
  [420] = {.lex_state = 10, .external_lex_state = 2},
  [421] = {.lex_state = 10, .external_lex_state = 2},
  [422] = {.lex_state = 10, .external_lex_state = 2},
  [423] = {.lex_state = 10, .external_lex_state = 2},
  [424] = {.lex_state = 10, .external_lex_state = 2},
  [425] = {.lex_state = 10, .external_lex_state = 2},
  [426] = {.lex_state = 10, .external_lex_state = 2},
  [427] = {.lex_state = 10, .external_lex_state = 2},
  [428] = {.lex_state = 10, .external_lex_state = 2},
  [429] = {.lex_state = 2, .external_lex_state = 2},
  [430] = {.lex_state = 4, .external_lex_state = 2},
  [431] = {.lex_state = 12, .external_lex_state = 2},
  [432] = {.lex_state = 12, .external_lex_state = 2},
  [433] = {.lex_state = 10, .external_lex_state = 2},
  [434] = {.lex_state = 10, .external_lex_state = 2},
  [435] = {.lex_state = 10, .external_lex_state = 2},
  [436] = {.lex_state = 10, .external_lex_state = 2},
  [437] = {.lex_state = 10, .external_lex_state = 2},
  [438] = {.lex_state = 10, .external_lex_state = 2},
  [439] = {.lex_state = 10, .external_lex_state = 2},
  [440] = {.lex_state = 10, .external_lex_state = 2},
  [441] = {.lex_state = 10, .external_lex_state = 2},
  [442] = {.lex_state = 10, .external_lex_state = 2},
  [443] = {.lex_state = 10, .external_lex_state = 2},
  [444] = {.lex_state = 10, .external_lex_state = 2},
  [445] = {.lex_state = 10, .external_lex_state = 2},
  [446] = {.lex_state = 2, .external_lex_state = 2},
  [447] = {.lex_state = 2, .external_lex_state = 2},
  [448] = {.lex_state = 2, .external_lex_state = 2},
  [449] = {.lex_state = 2, .external_lex_state = 2},
  [450] = {.lex_state = 2, .external_lex_state = 2},
  [451] = {.lex_state = 2, .external_lex_state = 2},
  [452] = {.lex_state = 2, .external_lex_state = 2},
  [453] = {.lex_state = 2, .external_lex_state = 2},
  [454] = {.lex_state = 2, .external_lex_state = 2},
  [455] = {.lex_state = 2, .external_lex_state = 2},
  [456] = {.lex_state = 10, .external_lex_state = 2},
  [457] = {.lex_state = 2, .external_lex_state = 2},
  [458] = {.lex_state = 2, .external_lex_state = 2},
  [459] = {.lex_state = 2, .external_lex_state = 2},
  [460] = {.lex_state = 2, .external_lex_state = 2},
  [461] = {.lex_state = 2, .external_lex_state = 2},
  [462] = {.lex_state = 2, .external_lex_state = 2},
  [463] = {.lex_state = 2, .external_lex_state = 2},
  [464] = {.lex_state = 10, .external_lex_state = 2},
  [465] = {.lex_state = 2, .external_lex_state = 2},
  [466] = {.lex_state = 2, .external_lex_state = 2},
  [467] = {.lex_state = 10, .external_lex_state = 2},
  [468] = {.lex_state = 2, .external_lex_state = 2},
  [469] = {.lex_state = 2, .external_lex_state = 2},
  [470] = {.lex_state = 10, .external_lex_state = 2},
  [471] = {.lex_state = 2, .external_lex_state = 2},
  [472] = {.lex_state = 2, .external_lex_state = 2},
  [473] = {.lex_state = 2, .external_lex_state = 2},
  [474] = {.lex_state = 2, .external_lex_state = 2},
  [475] = {.lex_state = 10, .external_lex_state = 2},
  [476] = {.lex_state = 10, .external_lex_state = 2},
  [477] = {.lex_state = 10, .external_lex_state = 2},
  [478] = {.lex_state = 10, .external_lex_state = 2},
  [479] = {.lex_state = 69, .external_lex_state = 2},
  [480] = {.lex_state = 69, .external_lex_state = 2},
  [481] = {.lex_state = 69, .external_lex_state = 2},
  [482] = {.lex_state = 69, .external_lex_state = 2},
  [483] = {.lex_state = 69, .external_lex_state = 2},
  [484] = {.lex_state = 69, .external_lex_state = 2},
  [485] = {.lex_state = 69, .external_lex_state = 2},
  [486] = {.lex_state = 69, .external_lex_state = 2},
  [487] = {.lex_state = 69, .external_lex_state = 2},
  [488] = {.lex_state = 69, .external_lex_state = 2},
  [489] = {.lex_state = 69, .external_lex_state = 2},
  [490] = {.lex_state = 69, .external_lex_state = 2},
  [491] = {.lex_state = 69, .external_lex_state = 2},
  [492] = {.lex_state = 69, .external_lex_state = 2},
  [493] = {.lex_state = 69, .external_lex_state = 2},
  [494] = {.lex_state = 69, .external_lex_state = 2},
  [495] = {.lex_state = 69, .external_lex_state = 2},
  [496] = {.lex_state = 69, .external_lex_state = 2},
  [497] = {.lex_state = 69, .external_lex_state = 2},
  [498] = {.lex_state = 69, .external_lex_state = 2},
  [499] = {.lex_state = 69, .external_lex_state = 2},
  [500] = {.lex_state = 69, .external_lex_state = 2},
  [501] = {.lex_state = 69, .external_lex_state = 2},
  [502] = {.lex_state = 69, .external_lex_state = 2},
  [503] = {.lex_state = 69, .external_lex_state = 2},
  [504] = {.lex_state = 69, .external_lex_state = 2},
  [505] = {.lex_state = 69, .external_lex_state = 2},
  [506] = {.lex_state = 69, .external_lex_state = 2},
  [507] = {.lex_state = 69, .external_lex_state = 2},
  [508] = {.lex_state = 69, .external_lex_state = 2},
  [509] = {.lex_state = 69, .external_lex_state = 2},
  [510] = {.lex_state = 69, .external_lex_state = 2},
  [511] = {.lex_state = 69, .external_lex_state = 2},
  [512] = {.lex_state = 69, .external_lex_state = 2},
  [513] = {.lex_state = 69, .external_lex_state = 2},
  [514] = {.lex_state = 69, .external_lex_state = 2},
  [515] = {.lex_state = 69, .external_lex_state = 2},
  [516] = {.lex_state = 69, .external_lex_state = 2},
  [517] = {.lex_state = 69, .external_lex_state = 2},
  [518] = {.lex_state = 69, .external_lex_state = 2},
  [519] = {.lex_state = 69, .external_lex_state = 2},
  [520] = {.lex_state = 69, .external_lex_state = 2},
  [521] = {.lex_state = 69, .external_lex_state = 2},
  [522] = {.lex_state = 69, .external_lex_state = 2},
  [523] = {.lex_state = 69, .external_lex_state = 2},
  [524] = {.lex_state = 69, .external_lex_state = 2},
  [525] = {.lex_state = 9},
  [526] = {.lex_state = 69, .external_lex_state = 2},
  [527] = {.lex_state = 69, .external_lex_state = 2},
  [528] = {.lex_state = 69, .external_lex_state = 2},
  [529] = {.lex_state = 69, .external_lex_state = 2},
  [530] = {.lex_state = 69, .external_lex_state = 2},
  [531] = {.lex_state = 69, .external_lex_state = 2},
  [532] = {.lex_state = 69, .external_lex_state = 2},
  [533] = {.lex_state = 69, .external_lex_state = 2},
  [534] = {.lex_state = 69, .external_lex_state = 2},
  [535] = {.lex_state = 69, .external_lex_state = 2},
  [536] = {.lex_state = 10, .external_lex_state = 2},
  [537] = {.lex_state = 69, .external_lex_state = 2},
  [538] = {.lex_state = 69, .external_lex_state = 2},
  [539] = {.lex_state = 69, .external_lex_state = 2},
  [540] = {.lex_state = 69, .external_lex_state = 2},
  [541] = {.lex_state = 69, .external_lex_state = 2},
  [542] = {.lex_state = 69, .external_lex_state = 2},
  [543] = {.lex_state = 69, .external_lex_state = 2},
  [544] = {.lex_state = 69, .external_lex_state = 2},
  [545] = {.lex_state = 69, .external_lex_state = 2},
  [546] = {.lex_state = 69, .external_lex_state = 2},
  [547] = {.lex_state = 69, .external_lex_state = 2},
  [548] = {.lex_state = 69, .external_lex_state = 2},
  [549] = {.lex_state = 69, .external_lex_state = 2},
  [550] = {.lex_state = 69, .external_lex_state = 2},
  [551] = {.lex_state = 69, .external_lex_state = 2},
  [552] = {.lex_state = 69, .external_lex_state = 2},
  [553] = {.lex_state = 69, .external_lex_state = 2},
  [554] = {.lex_state = 69, .external_lex_state = 2},
  [555] = {.lex_state = 69, .external_lex_state = 2},
  [556] = {.lex_state = 69, .external_lex_state = 2},
  [557] = {.lex_state = 69, .external_lex_state = 2},
  [558] = {.lex_state = 69, .external_lex_state = 2},
  [559] = {.lex_state = 69, .external_lex_state = 2},
  [560] = {.lex_state = 69, .external_lex_state = 2},
  [561] = {.lex_state = 69, .external_lex_state = 2},
  [562] = {.lex_state = 69, .external_lex_state = 2},
  [563] = {.lex_state = 69, .external_lex_state = 2},
  [564] = {.lex_state = 69, .external_lex_state = 2},
  [565] = {.lex_state = 69, .external_lex_state = 2},
  [566] = {.lex_state = 69, .external_lex_state = 2},
  [567] = {.lex_state = 69, .external_lex_state = 2},
  [568] = {.lex_state = 69, .external_lex_state = 2},
  [569] = {.lex_state = 69, .external_lex_state = 2},
  [570] = {.lex_state = 69, .external_lex_state = 2},
  [571] = {.lex_state = 69, .external_lex_state = 2},
  [572] = {.lex_state = 69, .external_lex_state = 2},
  [573] = {.lex_state = 69, .external_lex_state = 2},
  [574] = {.lex_state = 69, .external_lex_state = 2},
  [575] = {.lex_state = 69, .external_lex_state = 2},
  [576] = {.lex_state = 69, .external_lex_state = 2},
  [577] = {.lex_state = 69, .external_lex_state = 2},
  [578] = {.lex_state = 69, .external_lex_state = 2},
  [579] = {.lex_state = 69, .external_lex_state = 2},
  [580] = {.lex_state = 69, .external_lex_state = 2},
  [581] = {.lex_state = 9},
  [582] = {.lex_state = 69, .external_lex_state = 2},
  [583] = {.lex_state = 69, .external_lex_state = 2},
  [584] = {.lex_state = 69, .external_lex_state = 2},
  [585] = {.lex_state = 69, .external_lex_state = 2},
  [586] = {.lex_state = 69, .external_lex_state = 2},
  [587] = {.lex_state = 69, .external_lex_state = 2},
  [588] = {.lex_state = 69, .external_lex_state = 2},
  [589] = {.lex_state = 69, .external_lex_state = 2},
  [590] = {.lex_state = 69, .external_lex_state = 2},
  [591] = {.lex_state = 69, .external_lex_state = 2},
  [592] = {.lex_state = 69, .external_lex_state = 2},
  [593] = {.lex_state = 69, .external_lex_state = 2},
  [594] = {.lex_state = 69, .external_lex_state = 2},
  [595] = {.lex_state = 69, .external_lex_state = 2},
  [596] = {.lex_state = 69, .external_lex_state = 2},
  [597] = {.lex_state = 69, .external_lex_state = 2},
  [598] = {.lex_state = 69, .external_lex_state = 2},
  [599] = {.lex_state = 69, .external_lex_state = 2},
  [600] = {.lex_state = 69, .external_lex_state = 2},
  [601] = {.lex_state = 69, .external_lex_state = 2},
  [602] = {.lex_state = 69, .external_lex_state = 2},
  [603] = {.lex_state = 69, .external_lex_state = 2},
  [604] = {.lex_state = 69, .external_lex_state = 2},
  [605] = {.lex_state = 69, .external_lex_state = 2},
  [606] = {.lex_state = 69, .external_lex_state = 2},
  [607] = {.lex_state = 69, .external_lex_state = 2},
  [608] = {.lex_state = 69, .external_lex_state = 2},
  [609] = {.lex_state = 69, .external_lex_state = 2},
  [610] = {.lex_state = 69, .external_lex_state = 2},
  [611] = {.lex_state = 69, .external_lex_state = 2},
  [612] = {.lex_state = 69, .external_lex_state = 2},
  [613] = {.lex_state = 69, .external_lex_state = 2},
  [614] = {.lex_state = 69, .external_lex_state = 2},
  [615] = {.lex_state = 69, .external_lex_state = 2},
  [616] = {.lex_state = 69, .external_lex_state = 2},
  [617] = {.lex_state = 69, .external_lex_state = 2},
  [618] = {.lex_state = 69, .external_lex_state = 2},
  [619] = {.lex_state = 69, .external_lex_state = 2},
  [620] = {.lex_state = 69, .external_lex_state = 2},
  [621] = {.lex_state = 69, .external_lex_state = 2},
  [622] = {.lex_state = 69, .external_lex_state = 2},
  [623] = {.lex_state = 69, .external_lex_state = 2},
  [624] = {.lex_state = 69, .external_lex_state = 2},
  [625] = {.lex_state = 69, .external_lex_state = 2},
  [626] = {.lex_state = 69, .external_lex_state = 2},
  [627] = {.lex_state = 69, .external_lex_state = 2},
  [628] = {.lex_state = 69, .external_lex_state = 2},
  [629] = {.lex_state = 9},
  [630] = {.lex_state = 69, .external_lex_state = 2},
  [631] = {.lex_state = 69, .external_lex_state = 2},
  [632] = {.lex_state = 69, .external_lex_state = 2},
  [633] = {.lex_state = 69, .external_lex_state = 2},
  [634] = {.lex_state = 69, .external_lex_state = 2},
  [635] = {.lex_state = 69, .external_lex_state = 2},
  [636] = {.lex_state = 69, .external_lex_state = 2},
  [637] = {.lex_state = 69, .external_lex_state = 2},
  [638] = {.lex_state = 69, .external_lex_state = 2},
  [639] = {.lex_state = 69, .external_lex_state = 2},
  [640] = {.lex_state = 69, .external_lex_state = 2},
  [641] = {.lex_state = 69, .external_lex_state = 2},
  [642] = {.lex_state = 69, .external_lex_state = 2},
  [643] = {.lex_state = 69, .external_lex_state = 2},
  [644] = {.lex_state = 69, .external_lex_state = 2},
  [645] = {.lex_state = 69, .external_lex_state = 2},
  [646] = {.lex_state = 69, .external_lex_state = 2},
  [647] = {.lex_state = 69, .external_lex_state = 2},
  [648] = {.lex_state = 69, .external_lex_state = 2},
  [649] = {.lex_state = 69, .external_lex_state = 2},
  [650] = {.lex_state = 69, .external_lex_state = 2},
  [651] = {.lex_state = 69, .external_lex_state = 2},
  [652] = {.lex_state = 69, .external_lex_state = 2},
  [653] = {.lex_state = 69, .external_lex_state = 2},
  [654] = {.lex_state = 69, .external_lex_state = 2},
  [655] = {.lex_state = 69, .external_lex_state = 2},
  [656] = {.lex_state = 69, .external_lex_state = 2},
  [657] = {.lex_state = 69, .external_lex_state = 2},
  [658] = {.lex_state = 69, .external_lex_state = 2},
  [659] = {.lex_state = 9},
  [660] = {.lex_state = 69, .external_lex_state = 2},
  [661] = {.lex_state = 69, .external_lex_state = 2},
  [662] = {.lex_state = 69, .external_lex_state = 2},
  [663] = {.lex_state = 69, .external_lex_state = 2},
  [664] = {.lex_state = 69, .external_lex_state = 2},
  [665] = {.lex_state = 69, .external_lex_state = 2},
  [666] = {.lex_state = 69, .external_lex_state = 2},
  [667] = {.lex_state = 69, .external_lex_state = 2},
  [668] = {.lex_state = 69, .external_lex_state = 2},
  [669] = {.lex_state = 9},
  [670] = {.lex_state = 69, .external_lex_state = 2},
  [671] = {.lex_state = 69, .external_lex_state = 2},
  [672] = {.lex_state = 69, .external_lex_state = 2},
  [673] = {.lex_state = 69, .external_lex_state = 2},
  [674] = {.lex_state = 69, .external_lex_state = 2},
  [675] = {.lex_state = 69, .external_lex_state = 2},
  [676] = {.lex_state = 69, .external_lex_state = 2},
  [677] = {.lex_state = 69, .external_lex_state = 2},
  [678] = {.lex_state = 69, .external_lex_state = 2},
  [679] = {.lex_state = 69, .external_lex_state = 2},
  [680] = {.lex_state = 69, .external_lex_state = 2},
  [681] = {.lex_state = 69, .external_lex_state = 2},
  [682] = {.lex_state = 69, .external_lex_state = 2},
  [683] = {.lex_state = 69, .external_lex_state = 2},
  [684] = {.lex_state = 69, .external_lex_state = 2},
  [685] = {.lex_state = 69, .external_lex_state = 2},
  [686] = {.lex_state = 69, .external_lex_state = 2},
  [687] = {.lex_state = 69, .external_lex_state = 2},
  [688] = {.lex_state = 69, .external_lex_state = 2},
  [689] = {.lex_state = 69, .external_lex_state = 2},
  [690] = {.lex_state = 69, .external_lex_state = 2},
  [691] = {.lex_state = 69, .external_lex_state = 2},
  [692] = {.lex_state = 69, .external_lex_state = 2},
  [693] = {.lex_state = 69, .external_lex_state = 2},
  [694] = {.lex_state = 69, .external_lex_state = 2},
  [695] = {.lex_state = 69, .external_lex_state = 2},
  [696] = {.lex_state = 69, .external_lex_state = 2},
  [697] = {.lex_state = 69, .external_lex_state = 2},
  [698] = {.lex_state = 69, .external_lex_state = 2},
  [699] = {.lex_state = 69, .external_lex_state = 2},
  [700] = {.lex_state = 69, .external_lex_state = 2},
  [701] = {.lex_state = 69, .external_lex_state = 2},
  [702] = {.lex_state = 69, .external_lex_state = 2},
  [703] = {.lex_state = 69, .external_lex_state = 2},
  [704] = {.lex_state = 69, .external_lex_state = 2},
  [705] = {.lex_state = 69, .external_lex_state = 2},
  [706] = {.lex_state = 69, .external_lex_state = 2},
  [707] = {.lex_state = 69, .external_lex_state = 2},
  [708] = {.lex_state = 69, .external_lex_state = 2},
  [709] = {.lex_state = 69, .external_lex_state = 2},
  [710] = {.lex_state = 69, .external_lex_state = 2},
  [711] = {.lex_state = 69, .external_lex_state = 2},
  [712] = {.lex_state = 69, .external_lex_state = 2},
  [713] = {.lex_state = 69, .external_lex_state = 2},
  [714] = {.lex_state = 69, .external_lex_state = 2},
  [715] = {.lex_state = 69, .external_lex_state = 2},
  [716] = {.lex_state = 69, .external_lex_state = 2},
  [717] = {.lex_state = 69, .external_lex_state = 2},
  [718] = {.lex_state = 69, .external_lex_state = 2},
  [719] = {.lex_state = 69, .external_lex_state = 2},
  [720] = {.lex_state = 69, .external_lex_state = 2},
  [721] = {.lex_state = 69, .external_lex_state = 2},
  [722] = {.lex_state = 69, .external_lex_state = 2},
  [723] = {.lex_state = 69, .external_lex_state = 2},
  [724] = {.lex_state = 69, .external_lex_state = 2},
  [725] = {.lex_state = 69, .external_lex_state = 2},
  [726] = {.lex_state = 69, .external_lex_state = 2},
  [727] = {.lex_state = 69, .external_lex_state = 2},
  [728] = {.lex_state = 69, .external_lex_state = 2},
  [729] = {.lex_state = 69, .external_lex_state = 2},
  [730] = {.lex_state = 69, .external_lex_state = 2},
  [731] = {.lex_state = 69, .external_lex_state = 2},
  [732] = {.lex_state = 69, .external_lex_state = 2},
  [733] = {.lex_state = 69, .external_lex_state = 2},
  [734] = {.lex_state = 69, .external_lex_state = 2},
  [735] = {.lex_state = 69, .external_lex_state = 2},
  [736] = {.lex_state = 69, .external_lex_state = 2},
  [737] = {.lex_state = 69, .external_lex_state = 2},
  [738] = {.lex_state = 69, .external_lex_state = 2},
  [739] = {.lex_state = 69, .external_lex_state = 2},
  [740] = {.lex_state = 69, .external_lex_state = 2},
  [741] = {.lex_state = 69, .external_lex_state = 2},
  [742] = {.lex_state = 69, .external_lex_state = 2},
  [743] = {.lex_state = 69, .external_lex_state = 2},
  [744] = {.lex_state = 69, .external_lex_state = 2},
  [745] = {.lex_state = 69, .external_lex_state = 2},
  [746] = {.lex_state = 69, .external_lex_state = 2},
  [747] = {.lex_state = 69, .external_lex_state = 2},
  [748] = {.lex_state = 69, .external_lex_state = 2},
  [749] = {.lex_state = 69, .external_lex_state = 2},
  [750] = {.lex_state = 10, .external_lex_state = 2},
  [751] = {.lex_state = 10, .external_lex_state = 2},
  [752] = {.lex_state = 10, .external_lex_state = 2},
  [753] = {.lex_state = 10, .external_lex_state = 2},
  [754] = {.lex_state = 10, .external_lex_state = 2},
  [755] = {.lex_state = 10, .external_lex_state = 2},
  [756] = {.lex_state = 10, .external_lex_state = 2},
  [757] = {.lex_state = 10, .external_lex_state = 2},
  [758] = {.lex_state = 13},
  [759] = {.lex_state = 13},
  [760] = {.lex_state = 10, .external_lex_state = 2},
  [761] = {.lex_state = 13},
  [762] = {.lex_state = 13},
  [763] = {.lex_state = 13},
  [764] = {.lex_state = 13},
  [765] = {.lex_state = 13},
  [766] = {.lex_state = 13},
  [767] = {.lex_state = 13},
  [768] = {.lex_state = 10, .external_lex_state = 2},
  [769] = {.lex_state = 10, .external_lex_state = 2},
  [770] = {.lex_state = 10, .external_lex_state = 2},
  [771] = {.lex_state = 13},
  [772] = {.lex_state = 13},
  [773] = {.lex_state = 10, .external_lex_state = 2},
  [774] = {.lex_state = 10, .external_lex_state = 2},
  [775] = {.lex_state = 10, .external_lex_state = 2},
  [776] = {.lex_state = 10, .external_lex_state = 2},
  [777] = {.lex_state = 10, .external_lex_state = 2},
  [778] = {.lex_state = 10, .external_lex_state = 2},
  [779] = {.lex_state = 11, .external_lex_state = 2},
  [780] = {.lex_state = 10, .external_lex_state = 2},
  [781] = {.lex_state = 10, .external_lex_state = 2},
  [782] = {.lex_state = 10, .external_lex_state = 2},
  [783] = {.lex_state = 10, .external_lex_state = 2},
  [784] = {.lex_state = 10, .external_lex_state = 2},
  [785] = {.lex_state = 10, .external_lex_state = 2},
  [786] = {.lex_state = 10, .external_lex_state = 2},
  [787] = {.lex_state = 10, .external_lex_state = 2},
  [788] = {.lex_state = 10, .external_lex_state = 2},
  [789] = {.lex_state = 10, .external_lex_state = 2},
  [790] = {.lex_state = 10, .external_lex_state = 2},
  [791] = {.lex_state = 10, .external_lex_state = 2},
  [792] = {.lex_state = 10, .external_lex_state = 2},
  [793] = {.lex_state = 10, .external_lex_state = 2},
  [794] = {.lex_state = 10, .external_lex_state = 2},
  [795] = {.lex_state = 10, .external_lex_state = 2},
  [796] = {.lex_state = 10, .external_lex_state = 2},
  [797] = {.lex_state = 10, .external_lex_state = 2},
  [798] = {.lex_state = 10, .external_lex_state = 2},
  [799] = {.lex_state = 10, .external_lex_state = 2},
  [800] = {.lex_state = 10, .external_lex_state = 2},
  [801] = {.lex_state = 10, .external_lex_state = 2},
  [802] = {.lex_state = 10, .external_lex_state = 2},
  [803] = {.lex_state = 10, .external_lex_state = 2},
  [804] = {.lex_state = 10, .external_lex_state = 2},
  [805] = {.lex_state = 10, .external_lex_state = 2},
  [806] = {.lex_state = 10, .external_lex_state = 2},
  [807] = {.lex_state = 10, .external_lex_state = 2},
  [808] = {.lex_state = 10, .external_lex_state = 2},
  [809] = {.lex_state = 10, .external_lex_state = 2},
  [810] = {.lex_state = 10, .external_lex_state = 2},
  [811] = {.lex_state = 10, .external_lex_state = 2},
  [812] = {.lex_state = 10, .external_lex_state = 2},
  [813] = {.lex_state = 10, .external_lex_state = 2},
  [814] = {.lex_state = 10, .external_lex_state = 2},
  [815] = {.lex_state = 10, .external_lex_state = 2},
  [816] = {.lex_state = 10, .external_lex_state = 2},
  [817] = {.lex_state = 10, .external_lex_state = 2},
  [818] = {.lex_state = 10, .external_lex_state = 2},
  [819] = {.lex_state = 10, .external_lex_state = 2},
  [820] = {.lex_state = 10, .external_lex_state = 2},
  [821] = {.lex_state = 10, .external_lex_state = 2},
  [822] = {.lex_state = 10, .external_lex_state = 2},
  [823] = {.lex_state = 10, .external_lex_state = 2},
  [824] = {.lex_state = 10, .external_lex_state = 2},
  [825] = {.lex_state = 13},
  [826] = {.lex_state = 13},
  [827] = {.lex_state = 13},
  [828] = {.lex_state = 13},
  [829] = {.lex_state = 13},
  [830] = {.lex_state = 13},
  [831] = {.lex_state = 13},
  [832] = {.lex_state = 13},
  [833] = {.lex_state = 13},
  [834] = {.lex_state = 13},
  [835] = {.lex_state = 13},
  [836] = {.lex_state = 13},
  [837] = {.lex_state = 13},
  [838] = {.lex_state = 13},
  [839] = {.lex_state = 13},
  [840] = {.lex_state = 13},
  [841] = {.lex_state = 13},
  [842] = {.lex_state = 13},
  [843] = {.lex_state = 13},
  [844] = {.lex_state = 13},
  [845] = {.lex_state = 13},
  [846] = {.lex_state = 13},
  [847] = {.lex_state = 13},
  [848] = {.lex_state = 13},
  [849] = {.lex_state = 13},
  [850] = {.lex_state = 13},
  [851] = {.lex_state = 13},
  [852] = {.lex_state = 13},
  [853] = {.lex_state = 13},
  [854] = {.lex_state = 13},
  [855] = {.lex_state = 13},
  [856] = {.lex_state = 13},
  [857] = {.lex_state = 13},
  [858] = {.lex_state = 13},
  [859] = {.lex_state = 13},
  [860] = {.lex_state = 13},
  [861] = {.lex_state = 13},
  [862] = {.lex_state = 13},
  [863] = {.lex_state = 13},
  [864] = {.lex_state = 13},
  [865] = {.lex_state = 13},
  [866] = {.lex_state = 13},
  [867] = {.lex_state = 13},
  [868] = {.lex_state = 13},
  [869] = {.lex_state = 13},
  [870] = {.lex_state = 13},
  [871] = {.lex_state = 13},
  [872] = {.lex_state = 13},
  [873] = {.lex_state = 13},
  [874] = {.lex_state = 13},
  [875] = {.lex_state = 13},
  [876] = {.lex_state = 13},
  [877] = {.lex_state = 13},
  [878] = {.lex_state = 13},
  [879] = {.lex_state = 13},
  [880] = {.lex_state = 13},
  [881] = {.lex_state = 13},
  [882] = {.lex_state = 13},
  [883] = {.lex_state = 13},
  [884] = {.lex_state = 13},
  [885] = {.lex_state = 13},
  [886] = {.lex_state = 13},
  [887] = {.lex_state = 13},
  [888] = {.lex_state = 13},
  [889] = {.lex_state = 13},
  [890] = {.lex_state = 13},
  [891] = {.lex_state = 13},
  [892] = {.lex_state = 13},
  [893] = {.lex_state = 13},
  [894] = {.lex_state = 13},
  [895] = {.lex_state = 13},
  [896] = {.lex_state = 13},
  [897] = {.lex_state = 13},
  [898] = {.lex_state = 13},
  [899] = {.lex_state = 13},
  [900] = {.lex_state = 13},
  [901] = {.lex_state = 13},
  [902] = {.lex_state = 13},
  [903] = {.lex_state = 13},
  [904] = {.lex_state = 13},
  [905] = {.lex_state = 13},
  [906] = {.lex_state = 13},
  [907] = {.lex_state = 13},
  [908] = {.lex_state = 13},
  [909] = {.lex_state = 13},
  [910] = {.lex_state = 13},
  [911] = {.lex_state = 13},
  [912] = {.lex_state = 13},
  [913] = {.lex_state = 13},
  [914] = {.lex_state = 13},
  [915] = {.lex_state = 13},
  [916] = {.lex_state = 13},
  [917] = {.lex_state = 10, .external_lex_state = 2},
  [918] = {.lex_state = 13},
  [919] = {.lex_state = 13},
  [920] = {.lex_state = 13},
  [921] = {.lex_state = 13},
  [922] = {.lex_state = 13},
  [923] = {.lex_state = 13},
  [924] = {.lex_state = 13},
  [925] = {.lex_state = 13},
  [926] = {.lex_state = 13},
  [927] = {.lex_state = 13},
  [928] = {.lex_state = 13},
  [929] = {.lex_state = 13},
  [930] = {.lex_state = 13},
  [931] = {.lex_state = 13},
  [932] = {.lex_state = 13},
  [933] = {.lex_state = 13},
  [934] = {.lex_state = 13},
  [935] = {.lex_state = 13},
  [936] = {.lex_state = 13},
  [937] = {.lex_state = 13},
  [938] = {.lex_state = 13},
  [939] = {.lex_state = 13},
  [940] = {.lex_state = 13},
  [941] = {.lex_state = 13},
  [942] = {.lex_state = 13},
  [943] = {.lex_state = 13},
  [944] = {.lex_state = 13},
  [945] = {.lex_state = 13},
  [946] = {.lex_state = 13},
  [947] = {.lex_state = 13},
  [948] = {.lex_state = 13},
  [949] = {.lex_state = 13},
  [950] = {.lex_state = 13},
  [951] = {.lex_state = 13},
  [952] = {.lex_state = 13},
  [953] = {.lex_state = 13},
  [954] = {.lex_state = 13},
  [955] = {.lex_state = 13},
  [956] = {.lex_state = 13},
  [957] = {.lex_state = 13},
  [958] = {.lex_state = 13},
  [959] = {.lex_state = 13},
  [960] = {.lex_state = 13},
  [961] = {.lex_state = 13},
  [962] = {.lex_state = 13},
  [963] = {.lex_state = 13},
  [964] = {.lex_state = 13},
  [965] = {.lex_state = 13},
  [966] = {.lex_state = 13},
  [967] = {.lex_state = 13},
  [968] = {.lex_state = 13},
  [969] = {.lex_state = 13},
  [970] = {.lex_state = 13},
  [971] = {.lex_state = 13},
  [972] = {.lex_state = 13},
  [973] = {.lex_state = 13},
  [974] = {.lex_state = 13},
  [975] = {.lex_state = 13},
  [976] = {.lex_state = 13},
  [977] = {.lex_state = 13},
  [978] = {.lex_state = 13},
  [979] = {.lex_state = 13},
  [980] = {.lex_state = 13},
  [981] = {.lex_state = 13},
  [982] = {.lex_state = 13},
  [983] = {.lex_state = 13},
  [984] = {.lex_state = 13},
  [985] = {.lex_state = 13},
  [986] = {.lex_state = 13},
  [987] = {.lex_state = 13},
  [988] = {.lex_state = 13},
  [989] = {.lex_state = 13},
  [990] = {.lex_state = 13},
  [991] = {.lex_state = 13},
  [992] = {.lex_state = 13},
  [993] = {.lex_state = 13},
  [994] = {.lex_state = 13},
  [995] = {.lex_state = 13},
  [996] = {.lex_state = 13},
  [997] = {.lex_state = 13},
  [998] = {.lex_state = 10, .external_lex_state = 2},
  [999] = {.lex_state = 10, .external_lex_state = 2},
  [1000] = {.lex_state = 12, .external_lex_state = 2},
  [1001] = {.lex_state = 12, .external_lex_state = 2},
  [1002] = {.lex_state = 10, .external_lex_state = 2},
  [1003] = {.lex_state = 11, .external_lex_state = 2},
  [1004] = {.lex_state = 13},
  [1005] = {.lex_state = 10, .external_lex_state = 2},
  [1006] = {.lex_state = 10, .external_lex_state = 2},
  [1007] = {.lex_state = 5},
  [1008] = {.lex_state = 5},
  [1009] = {.lex_state = 5},
  [1010] = {.lex_state = 5},
  [1011] = {.lex_state = 5},
  [1012] = {.lex_state = 9},
  [1013] = {.lex_state = 5},
  [1014] = {.lex_state = 5},
  [1015] = {.lex_state = 5},
  [1016] = {.lex_state = 9},
  [1017] = {.lex_state = 5},
  [1018] = {.lex_state = 9},
  [1019] = {.lex_state = 9},
  [1020] = {.lex_state = 9},
  [1021] = {.lex_state = 5},
  [1022] = {.lex_state = 5},
  [1023] = {.lex_state = 9},
  [1024] = {.lex_state = 9},
  [1025] = {.lex_state = 9},
  [1026] = {.lex_state = 5},
  [1027] = {.lex_state = 9},
  [1028] = {.lex_state = 6},
  [1029] = {.lex_state = 21},
  [1030] = {.lex_state = 6},
  [1031] = {.lex_state = 21},
  [1032] = {.lex_state = 21},
  [1033] = {.lex_state = 6},
  [1034] = {.lex_state = 21},
  [1035] = {.lex_state = 6},
  [1036] = {.lex_state = 10, .external_lex_state = 2},
  [1037] = {.lex_state = 21},
  [1038] = {.lex_state = 6},
  [1039] = {.lex_state = 6},
  [1040] = {.lex_state = 18},
  [1041] = {.lex_state = 13},
  [1042] = {.lex_state = 17},
  [1043] = {.lex_state = 13},
  [1044] = {.lex_state = 6},
  [1045] = {.lex_state = 17},
  [1046] = {.lex_state = 6},
  [1047] = {.lex_state = 6},
  [1048] = {.lex_state = 6},
  [1049] = {.lex_state = 6},
  [1050] = {.lex_state = 6},
  [1051] = {.lex_state = 6},
  [1052] = {.lex_state = 6},
  [1053] = {.lex_state = 17},
  [1054] = {.lex_state = 6},
  [1055] = {.lex_state = 6},
  [1056] = {.lex_state = 13},
  [1057] = {.lex_state = 13},
  [1058] = {.lex_state = 6},
  [1059] = {.lex_state = 17},
  [1060] = {.lex_state = 17},
  [1061] = {.lex_state = 6},
  [1062] = {.lex_state = 17},
  [1063] = {.lex_state = 13},
  [1064] = {.lex_state = 13},
  [1065] = {.lex_state = 6},
  [1066] = {.lex_state = 17},
  [1067] = {.lex_state = 13},
  [1068] = {.lex_state = 13},
  [1069] = {.lex_state = 17},
  [1070] = {.lex_state = 6},
  [1071] = {.lex_state = 17},
  [1072] = {.lex_state = 6},
  [1073] = {.lex_state = 17},
  [1074] = {.lex_state = 13},
  [1075] = {.lex_state = 6},
  [1076] = {.lex_state = 6},
  [1077] = {.lex_state = 17},
  [1078] = {.lex_state = 6},
  [1079] = {.lex_state = 17},
  [1080] = {.lex_state = 6},
  [1081] = {.lex_state = 6},
  [1082] = {.lex_state = 6},
  [1083] = {.lex_state = 5},
  [1084] = {.lex_state = 18},
  [1085] = {.lex_state = 6},
  [1086] = {.lex_state = 6},
  [1087] = {.lex_state = 9},
  [1088] = {.lex_state = 9},
  [1089] = {.lex_state = 11, .external_lex_state = 2},
  [1090] = {.lex_state = 9},
  [1091] = {.lex_state = 9},
  [1092] = {.lex_state = 9},
  [1093] = {.lex_state = 9},
  [1094] = {.lex_state = 9},
  [1095] = {.lex_state = 9},
  [1096] = {.lex_state = 9},
  [1097] = {.lex_state = 6},
  [1098] = {.lex_state = 9},
  [1099] = {.lex_state = 9},
  [1100] = {.lex_state = 9},
  [1101] = {.lex_state = 9},
  [1102] = {.lex_state = 6},
  [1103] = {.lex_state = 6},
  [1104] = {.lex_state = 6},
  [1105] = {.lex_state = 6},
  [1106] = {.lex_state = 9},
  [1107] = {.lex_state = 9},
  [1108] = {.lex_state = 9},
  [1109] = {.lex_state = 6},
  [1110] = {.lex_state = 6},
  [1111] = {.lex_state = 6},
  [1112] = {.lex_state = 9},
  [1113] = {.lex_state = 9},
  [1114] = {.lex_state = 9},
  [1115] = {.lex_state = 9},
  [1116] = {.lex_state = 9},
  [1117] = {.lex_state = 9},
  [1118] = {.lex_state = 6},
  [1119] = {.lex_state = 9},
  [1120] = {.lex_state = 9},
  [1121] = {.lex_state = 6},
  [1122] = {.lex_state = 9},
  [1123] = {.lex_state = 6},
  [1124] = {.lex_state = 6},
  [1125] = {.lex_state = 9},
  [1126] = {.lex_state = 6},
  [1127] = {.lex_state = 6},
  [1128] = {.lex_state = 9},
  [1129] = {.lex_state = 9},
  [1130] = {.lex_state = 9},
  [1131] = {.lex_state = 6},
  [1132] = {.lex_state = 6},
  [1133] = {.lex_state = 9},
  [1134] = {.lex_state = 6},
  [1135] = {.lex_state = 9},
  [1136] = {.lex_state = 11, .external_lex_state = 2},
  [1137] = {.lex_state = 9},
  [1138] = {.lex_state = 9},
  [1139] = {.lex_state = 9},
  [1140] = {.lex_state = 6},
  [1141] = {.lex_state = 9},
  [1142] = {.lex_state = 9},
  [1143] = {.lex_state = 9},
  [1144] = {.lex_state = 9},
  [1145] = {.lex_state = 6},
  [1146] = {.lex_state = 6},
  [1147] = {.lex_state = 9},
  [1148] = {.lex_state = 6},
  [1149] = {.lex_state = 9},
  [1150] = {.lex_state = 9},
  [1151] = {.lex_state = 6},
  [1152] = {.lex_state = 9},
  [1153] = {.lex_state = 6},
  [1154] = {.lex_state = 10, .external_lex_state = 2},
  [1155] = {.lex_state = 6},
  [1156] = {.lex_state = 9},
  [1157] = {.lex_state = 6},
  [1158] = {.lex_state = 9},
  [1159] = {.lex_state = 6},
  [1160] = {.lex_state = 9},
  [1161] = {.lex_state = 9},
  [1162] = {.lex_state = 9},
  [1163] = {.lex_state = 9},
  [1164] = {.lex_state = 6},
  [1165] = {.lex_state = 6},
  [1166] = {.lex_state = 6},
  [1167] = {.lex_state = 9},
  [1168] = {.lex_state = 6},
  [1169] = {.lex_state = 9},
  [1170] = {.lex_state = 6},
  [1171] = {.lex_state = 6},
  [1172] = {.lex_state = 6},
  [1173] = {.lex_state = 6},
  [1174] = {.lex_state = 9},
  [1175] = {.lex_state = 6},
  [1176] = {.lex_state = 6},
  [1177] = {.lex_state = 9},
  [1178] = {.lex_state = 9},
  [1179] = {.lex_state = 9},
  [1180] = {.lex_state = 6},
  [1181] = {.lex_state = 9},
  [1182] = {.lex_state = 9},
  [1183] = {.lex_state = 9},
  [1184] = {.lex_state = 9},
  [1185] = {.lex_state = 6},
  [1186] = {.lex_state = 9},
  [1187] = {.lex_state = 9},
  [1188] = {.lex_state = 9},
  [1189] = {.lex_state = 9},
  [1190] = {.lex_state = 9},
  [1191] = {.lex_state = 9},
  [1192] = {.lex_state = 9},
  [1193] = {.lex_state = 6},
  [1194] = {.lex_state = 9},
  [1195] = {.lex_state = 6},
  [1196] = {.lex_state = 9},
  [1197] = {.lex_state = 6},
  [1198] = {.lex_state = 6},
  [1199] = {.lex_state = 6},
  [1200] = {.lex_state = 6},
  [1201] = {.lex_state = 6},
  [1202] = {.lex_state = 9},
  [1203] = {.lex_state = 9},
  [1204] = {.lex_state = 9},
  [1205] = {.lex_state = 6},
  [1206] = {.lex_state = 9},
  [1207] = {.lex_state = 9},
  [1208] = {.lex_state = 9},
  [1209] = {.lex_state = 6},
  [1210] = {.lex_state = 13},
  [1211] = {.lex_state = 6},
  [1212] = {.lex_state = 9},
  [1213] = {.lex_state = 6},
  [1214] = {.lex_state = 9},
  [1215] = {.lex_state = 6},
  [1216] = {.lex_state = 6},
  [1217] = {.lex_state = 6},
  [1218] = {.lex_state = 6},
  [1219] = {.lex_state = 9},
  [1220] = {.lex_state = 9},
  [1221] = {.lex_state = 6},
  [1222] = {.lex_state = 6},
  [1223] = {.lex_state = 9},
  [1224] = {.lex_state = 6},
  [1225] = {.lex_state = 6},
  [1226] = {.lex_state = 6},
  [1227] = {.lex_state = 6},
  [1228] = {.lex_state = 9},
  [1229] = {.lex_state = 9},
  [1230] = {.lex_state = 6},
  [1231] = {.lex_state = 6},
  [1232] = {.lex_state = 9},
  [1233] = {.lex_state = 9},
  [1234] = {.lex_state = 9},
  [1235] = {.lex_state = 9},
  [1236] = {.lex_state = 9},
  [1237] = {.lex_state = 9},
  [1238] = {.lex_state = 9},
  [1239] = {.lex_state = 9},
  [1240] = {.lex_state = 9},
  [1241] = {.lex_state = 9},
  [1242] = {.lex_state = 9},
  [1243] = {.lex_state = 9},
  [1244] = {.lex_state = 6},
  [1245] = {.lex_state = 6},
  [1246] = {.lex_state = 6},
  [1247] = {.lex_state = 9},
  [1248] = {.lex_state = 9},
  [1249] = {.lex_state = 9},
  [1250] = {.lex_state = 6},
  [1251] = {.lex_state = 9},
  [1252] = {.lex_state = 9},
  [1253] = {.lex_state = 9},
  [1254] = {.lex_state = 9},
  [1255] = {.lex_state = 9},
  [1256] = {.lex_state = 9},
  [1257] = {.lex_state = 9},
  [1258] = {.lex_state = 9},
  [1259] = {.lex_state = 6},
  [1260] = {.lex_state = 6},
  [1261] = {.lex_state = 9},
  [1262] = {.lex_state = 9},
  [1263] = {.lex_state = 9},
  [1264] = {.lex_state = 9},
  [1265] = {.lex_state = 9},
  [1266] = {.lex_state = 6},
  [1267] = {.lex_state = 9},
  [1268] = {.lex_state = 9},
  [1269] = {.lex_state = 9},
  [1270] = {.lex_state = 9},
  [1271] = {.lex_state = 9},
  [1272] = {.lex_state = 9},
  [1273] = {.lex_state = 9},
  [1274] = {.lex_state = 9},
  [1275] = {.lex_state = 9},
  [1276] = {.lex_state = 9},
  [1277] = {.lex_state = 9},
  [1278] = {.lex_state = 6},
  [1279] = {.lex_state = 9},
  [1280] = {.lex_state = 9},
  [1281] = {.lex_state = 6},
  [1282] = {.lex_state = 9},
  [1283] = {.lex_state = 9},
  [1284] = {.lex_state = 6},
  [1285] = {.lex_state = 9},
  [1286] = {.lex_state = 9},
  [1287] = {.lex_state = 9},
  [1288] = {.lex_state = 6},
  [1289] = {.lex_state = 9},
  [1290] = {.lex_state = 6},
  [1291] = {.lex_state = 9},
  [1292] = {.lex_state = 9},
  [1293] = {.lex_state = 9},
  [1294] = {.lex_state = 9},
  [1295] = {.lex_state = 9},
  [1296] = {.lex_state = 9},
  [1297] = {.lex_state = 9},
  [1298] = {.lex_state = 9},
  [1299] = {.lex_state = 6},
  [1300] = {.lex_state = 6},
  [1301] = {.lex_state = 9},
  [1302] = {.lex_state = 9},
  [1303] = {.lex_state = 6},
  [1304] = {.lex_state = 9},
  [1305] = {.lex_state = 10, .external_lex_state = 2},
  [1306] = {.lex_state = 9},
  [1307] = {.lex_state = 13},
  [1308] = {.lex_state = 9},
  [1309] = {.lex_state = 13},
  [1310] = {.lex_state = 13},
  [1311] = {.lex_state = 9},
  [1312] = {.lex_state = 9},
  [1313] = {.lex_state = 9},
  [1314] = {.lex_state = 9},
  [1315] = {.lex_state = 9},
  [1316] = {.lex_state = 9},
  [1317] = {.lex_state = 6},
  [1318] = {.lex_state = 6},
  [1319] = {.lex_state = 9},
  [1320] = {.lex_state = 9},
  [1321] = {.lex_state = 9},
  [1322] = {.lex_state = 9},
  [1323] = {.lex_state = 9},
  [1324] = {.lex_state = 9},
  [1325] = {.lex_state = 9},
  [1326] = {.lex_state = 9},
  [1327] = {.lex_state = 9},
  [1328] = {.lex_state = 13},
  [1329] = {.lex_state = 9},
  [1330] = {.lex_state = 9},
  [1331] = {.lex_state = 9},
  [1332] = {.lex_state = 13},
  [1333] = {.lex_state = 9},
  [1334] = {.lex_state = 13},
  [1335] = {.lex_state = 9},
  [1336] = {.lex_state = 9},
  [1337] = {.lex_state = 9},
  [1338] = {.lex_state = 9},
  [1339] = {.lex_state = 9},
  [1340] = {.lex_state = 13},
  [1341] = {.lex_state = 9},
  [1342] = {.lex_state = 9},
  [1343] = {.lex_state = 9},
  [1344] = {.lex_state = 6},
  [1345] = {.lex_state = 9},
  [1346] = {.lex_state = 9},
  [1347] = {.lex_state = 9},
  [1348] = {.lex_state = 9},
  [1349] = {.lex_state = 9},
  [1350] = {.lex_state = 9},
  [1351] = {.lex_state = 9},
  [1352] = {.lex_state = 9},
  [1353] = {.lex_state = 9},
  [1354] = {.lex_state = 9},
  [1355] = {.lex_state = 9},
  [1356] = {.lex_state = 9},
  [1357] = {.lex_state = 9},
  [1358] = {.lex_state = 9},
  [1359] = {.lex_state = 9},
  [1360] = {.lex_state = 9},
  [1361] = {.lex_state = 9},
  [1362] = {.lex_state = 9},
  [1363] = {.lex_state = 9},
  [1364] = {.lex_state = 9},
  [1365] = {.lex_state = 9},
  [1366] = {.lex_state = 9},
  [1367] = {.lex_state = 9},
  [1368] = {.lex_state = 9},
  [1369] = {.lex_state = 9},
  [1370] = {.lex_state = 9},
  [1371] = {.lex_state = 9},
  [1372] = {.lex_state = 9},
  [1373] = {.lex_state = 6},
  [1374] = {.lex_state = 9},
  [1375] = {.lex_state = 9},
  [1376] = {.lex_state = 9},
  [1377] = {.lex_state = 9},
  [1378] = {.lex_state = 9},
  [1379] = {.lex_state = 9},
  [1380] = {.lex_state = 9},
  [1381] = {.lex_state = 6},
  [1382] = {.lex_state = 9},
  [1383] = {.lex_state = 9},
  [1384] = {.lex_state = 9},
  [1385] = {.lex_state = 9},
  [1386] = {.lex_state = 9},
  [1387] = {.lex_state = 9},
  [1388] = {.lex_state = 9},
  [1389] = {.lex_state = 9},
  [1390] = {.lex_state = 6},
  [1391] = {.lex_state = 6},
  [1392] = {.lex_state = 9},
  [1393] = {.lex_state = 6},
  [1394] = {.lex_state = 6},
  [1395] = {.lex_state = 9},
  [1396] = {.lex_state = 9},
  [1397] = {.lex_state = 9},
  [1398] = {.lex_state = 9},
  [1399] = {.lex_state = 9},
  [1400] = {.lex_state = 9},
  [1401] = {.lex_state = 6},
  [1402] = {.lex_state = 6},
  [1403] = {.lex_state = 9},
  [1404] = {.lex_state = 6},
  [1405] = {.lex_state = 9},
  [1406] = {.lex_state = 9},
  [1407] = {.lex_state = 9},
  [1408] = {.lex_state = 9},
  [1409] = {.lex_state = 13},
  [1410] = {.lex_state = 6},
  [1411] = {.lex_state = 9},
  [1412] = {.lex_state = 9},
  [1413] = {.lex_state = 6},
  [1414] = {.lex_state = 6},
  [1415] = {.lex_state = 9},
  [1416] = {.lex_state = 9},
  [1417] = {.lex_state = 6},
  [1418] = {.lex_state = 9},
  [1419] = {.lex_state = 9},
  [1420] = {.lex_state = 9},
  [1421] = {.lex_state = 9},
  [1422] = {.lex_state = 9},
  [1423] = {.lex_state = 6},
  [1424] = {.lex_state = 6},
  [1425] = {.lex_state = 6},
  [1426] = {.lex_state = 6},
  [1427] = {.lex_state = 6},
  [1428] = {.lex_state = 9},
  [1429] = {.lex_state = 9},
  [1430] = {.lex_state = 9},
  [1431] = {.lex_state = 9},
  [1432] = {.lex_state = 6},
  [1433] = {.lex_state = 6},
  [1434] = {.lex_state = 9},
  [1435] = {.lex_state = 9},
  [1436] = {.lex_state = 6},
  [1437] = {.lex_state = 9},
  [1438] = {.lex_state = 6},
  [1439] = {.lex_state = 6},
  [1440] = {.lex_state = 6},
  [1441] = {.lex_state = 6},
  [1442] = {.lex_state = 6},
  [1443] = {.lex_state = 6},
  [1444] = {.lex_state = 6},
  [1445] = {.lex_state = 9},
  [1446] = {.lex_state = 9},
  [1447] = {.lex_state = 9},
  [1448] = {.lex_state = 9},
  [1449] = {.lex_state = 9},
  [1450] = {.lex_state = 9},
  [1451] = {.lex_state = 9},
  [1452] = {.lex_state = 9},
  [1453] = {.lex_state = 9},
  [1454] = {.lex_state = 9},
  [1455] = {.lex_state = 9},
  [1456] = {.lex_state = 9},
  [1457] = {.lex_state = 13},
  [1458] = {.lex_state = 9},
  [1459] = {.lex_state = 9},
  [1460] = {.lex_state = 6},
  [1461] = {.lex_state = 9},
  [1462] = {.lex_state = 6},
  [1463] = {.lex_state = 10, .external_lex_state = 2},
  [1464] = {.lex_state = 6},
  [1465] = {.lex_state = 6},
  [1466] = {.lex_state = 13},
  [1467] = {.lex_state = 10, .external_lex_state = 2},
  [1468] = {.lex_state = 13},
  [1469] = {.lex_state = 13},
  [1470] = {.lex_state = 10, .external_lex_state = 2},
  [1471] = {.lex_state = 10, .external_lex_state = 2},
  [1472] = {.lex_state = 13},
  [1473] = {.lex_state = 10, .external_lex_state = 2},
  [1474] = {.lex_state = 6},
  [1475] = {.lex_state = 6},
  [1476] = {.lex_state = 13},
  [1477] = {.lex_state = 6},
  [1478] = {.lex_state = 6},
  [1479] = {.lex_state = 6},
  [1480] = {.lex_state = 6},
  [1481] = {.lex_state = 6},
  [1482] = {.lex_state = 6},
  [1483] = {.lex_state = 6},
  [1484] = {.lex_state = 8},
  [1485] = {.lex_state = 6},
  [1486] = {.lex_state = 6},
  [1487] = {.lex_state = 6},
  [1488] = {.lex_state = 6},
  [1489] = {.lex_state = 6},
  [1490] = {.lex_state = 6},
  [1491] = {.lex_state = 6},
  [1492] = {.lex_state = 13},
  [1493] = {.lex_state = 6},
  [1494] = {.lex_state = 6},
  [1495] = {.lex_state = 6},
  [1496] = {.lex_state = 6},
  [1497] = {.lex_state = 13},
  [1498] = {.lex_state = 10, .external_lex_state = 2},
  [1499] = {.lex_state = 6},
  [1500] = {.lex_state = 10, .external_lex_state = 2},
  [1501] = {.lex_state = 10, .external_lex_state = 2},
  [1502] = {.lex_state = 7},
  [1503] = {.lex_state = 10, .external_lex_state = 2},
  [1504] = {.lex_state = 8},
  [1505] = {.lex_state = 6},
  [1506] = {.lex_state = 8},
  [1507] = {.lex_state = 8},
  [1508] = {.lex_state = 8},
  [1509] = {.lex_state = 7},
  [1510] = {.lex_state = 8},
  [1511] = {.lex_state = 8},
  [1512] = {.lex_state = 8},
  [1513] = {.lex_state = 8},
  [1514] = {.lex_state = 8},
  [1515] = {.lex_state = 7},
  [1516] = {.lex_state = 13},
  [1517] = {.lex_state = 6},
  [1518] = {.lex_state = 13},
  [1519] = {.lex_state = 6},
  [1520] = {.lex_state = 8},
  [1521] = {.lex_state = 8},
  [1522] = {.lex_state = 7},
  [1523] = {.lex_state = 13},
  [1524] = {.lex_state = 6},
  [1525] = {.lex_state = 6},
  [1526] = {.lex_state = 6},
  [1527] = {.lex_state = 13},
  [1528] = {.lex_state = 13},
  [1529] = {.lex_state = 13},
  [1530] = {.lex_state = 7},
  [1531] = {.lex_state = 6},
  [1532] = {.lex_state = 13},
  [1533] = {.lex_state = 6},
  [1534] = {.lex_state = 7},
  [1535] = {.lex_state = 7},
  [1536] = {.lex_state = 7},
  [1537] = {.lex_state = 7},
  [1538] = {.lex_state = 7},
  [1539] = {.lex_state = 7},
  [1540] = {.lex_state = 6},
  [1541] = {.lex_state = 6},
  [1542] = {.lex_state = 6},
  [1543] = {.lex_state = 7},
  [1544] = {.lex_state = 6},
  [1545] = {.lex_state = 6},
  [1546] = {.lex_state = 6},
  [1547] = {.lex_state = 7},
  [1548] = {.lex_state = 6},
  [1549] = {.lex_state = 6},
  [1550] = {.lex_state = 7},
  [1551] = {.lex_state = 6},
  [1552] = {.lex_state = 7},
  [1553] = {.lex_state = 7},
  [1554] = {.lex_state = 6},
  [1555] = {.lex_state = 6},
  [1556] = {.lex_state = 6},
  [1557] = {.lex_state = 7},
  [1558] = {.lex_state = 6},
  [1559] = {.lex_state = 7},
  [1560] = {.lex_state = 6},
  [1561] = {.lex_state = 6},
  [1562] = {.lex_state = 6},
  [1563] = {.lex_state = 6},
  [1564] = {.lex_state = 7},
  [1565] = {.lex_state = 6},
  [1566] = {.lex_state = 6},
  [1567] = {.lex_state = 7},
  [1568] = {.lex_state = 6},
  [1569] = {.lex_state = 7},
  [1570] = {.lex_state = 6},
  [1571] = {.lex_state = 7},
  [1572] = {.lex_state = 7},
  [1573] = {.lex_state = 7},
  [1574] = {.lex_state = 7},
  [1575] = {.lex_state = 7},
  [1576] = {.lex_state = 19},
  [1577] = {.lex_state = 7},
  [1578] = {.lex_state = 19},
  [1579] = {.lex_state = 6},
  [1580] = {.lex_state = 7},
  [1581] = {.lex_state = 6},
  [1582] = {.lex_state = 6},
  [1583] = {.lex_state = 6},
  [1584] = {.lex_state = 6},
  [1585] = {.lex_state = 7},
  [1586] = {.lex_state = 19},
  [1587] = {.lex_state = 13},
  [1588] = {.lex_state = 19},
  [1589] = {.lex_state = 6},
  [1590] = {.lex_state = 7},
  [1591] = {.lex_state = 7},
  [1592] = {.lex_state = 6},
  [1593] = {.lex_state = 6},
  [1594] = {.lex_state = 7},
  [1595] = {.lex_state = 6},
  [1596] = {.lex_state = 19},
  [1597] = {.lex_state = 7},
  [1598] = {.lex_state = 6},
  [1599] = {.lex_state = 6},
  [1600] = {.lex_state = 6},
  [1601] = {.lex_state = 6},
  [1602] = {.lex_state = 6},
  [1603] = {.lex_state = 6},
  [1604] = {.lex_state = 7},
  [1605] = {.lex_state = 6},
  [1606] = {.lex_state = 6},
  [1607] = {.lex_state = 19},
  [1608] = {.lex_state = 6},
  [1609] = {.lex_state = 6},
  [1610] = {.lex_state = 6},
  [1611] = {.lex_state = 6},
  [1612] = {.lex_state = 6},
  [1613] = {.lex_state = 8},
  [1614] = {.lex_state = 13},
  [1615] = {.lex_state = 19},
  [1616] = {.lex_state = 7},
  [1617] = {.lex_state = 7},
  [1618] = {.lex_state = 6},
  [1619] = {.lex_state = 19},
  [1620] = {.lex_state = 7},
  [1621] = {.lex_state = 19},
  [1622] = {.lex_state = 13},
  [1623] = {.lex_state = 19},
  [1624] = {.lex_state = 19},
  [1625] = {.lex_state = 7},
  [1626] = {.lex_state = 19},
  [1627] = {.lex_state = 7},
  [1628] = {.lex_state = 7},
  [1629] = {.lex_state = 7},
  [1630] = {.lex_state = 7},
  [1631] = {.lex_state = 6},
  [1632] = {.lex_state = 7},
  [1633] = {.lex_state = 7},
  [1634] = {.lex_state = 7},
  [1635] = {.lex_state = 6},
  [1636] = {.lex_state = 7},
  [1637] = {.lex_state = 6},
  [1638] = {.lex_state = 6},
  [1639] = {.lex_state = 7},
  [1640] = {.lex_state = 6},
  [1641] = {.lex_state = 7},
  [1642] = {.lex_state = 7},
  [1643] = {.lex_state = 7},
  [1644] = {.lex_state = 7},
  [1645] = {.lex_state = 7},
  [1646] = {.lex_state = 6},
  [1647] = {.lex_state = 6},
  [1648] = {.lex_state = 6},
  [1649] = {.lex_state = 7},
  [1650] = {.lex_state = 7},
  [1651] = {.lex_state = 7},
  [1652] = {.lex_state = 7},
  [1653] = {.lex_state = 7},
  [1654] = {.lex_state = 6},
  [1655] = {.lex_state = 7},
  [1656] = {.lex_state = 6},
  [1657] = {.lex_state = 6},
  [1658] = {.lex_state = 7},
  [1659] = {.lex_state = 7},
  [1660] = {.lex_state = 7},
  [1661] = {.lex_state = 6},
  [1662] = {.lex_state = 6},
  [1663] = {.lex_state = 6},
  [1664] = {.lex_state = 7},
  [1665] = {.lex_state = 7},
  [1666] = {.lex_state = 6},
  [1667] = {.lex_state = 7},
  [1668] = {.lex_state = 6},
  [1669] = {.lex_state = 7},
  [1670] = {.lex_state = 7},
  [1671] = {.lex_state = 6},
  [1672] = {.lex_state = 6},
  [1673] = {.lex_state = 6},
  [1674] = {.lex_state = 6},
  [1675] = {.lex_state = 6},
  [1676] = {.lex_state = 7},
  [1677] = {.lex_state = 7},
  [1678] = {.lex_state = 7},
  [1679] = {.lex_state = 6},
  [1680] = {.lex_state = 7},
  [1681] = {.lex_state = 7},
  [1682] = {.lex_state = 6},
  [1683] = {.lex_state = 6},
  [1684] = {.lex_state = 6},
  [1685] = {.lex_state = 7},
  [1686] = {.lex_state = 6},
  [1687] = {.lex_state = 7},
  [1688] = {.lex_state = 6},
  [1689] = {.lex_state = 7},
  [1690] = {.lex_state = 7},
  [1691] = {.lex_state = 6},
  [1692] = {.lex_state = 7},
  [1693] = {.lex_state = 6},
  [1694] = {.lex_state = 6},
  [1695] = {.lex_state = 7},
  [1696] = {.lex_state = 7},
  [1697] = {.lex_state = 6},
  [1698] = {.lex_state = 7},
  [1699] = {.lex_state = 6},
  [1700] = {.lex_state = 7},
  [1701] = {.lex_state = 7},
  [1702] = {.lex_state = 7},
  [1703] = {.lex_state = 7},
  [1704] = {.lex_state = 6},
  [1705] = {.lex_state = 7},
  [1706] = {.lex_state = 6},
  [1707] = {.lex_state = 6},
  [1708] = {.lex_state = 6},
  [1709] = {.lex_state = 6},
  [1710] = {.lex_state = 6},
  [1711] = {.lex_state = 7},
  [1712] = {.lex_state = 6},
  [1713] = {.lex_state = 7},
  [1714] = {.lex_state = 7},
  [1715] = {.lex_state = 7},
  [1716] = {.lex_state = 7},
  [1717] = {.lex_state = 6},
  [1718] = {.lex_state = 6},
  [1719] = {.lex_state = 7},
  [1720] = {.lex_state = 7},
  [1721] = {.lex_state = 6},
  [1722] = {.lex_state = 6},
  [1723] = {.lex_state = 6},
  [1724] = {.lex_state = 7},
  [1725] = {.lex_state = 6},
  [1726] = {.lex_state = 6},
  [1727] = {.lex_state = 7},
  [1728] = {.lex_state = 7},
  [1729] = {.lex_state = 6},
  [1730] = {.lex_state = 7},
  [1731] = {.lex_state = 6},
  [1732] = {.lex_state = 7},
  [1733] = {.lex_state = 6},
  [1734] = {.lex_state = 6},
  [1735] = {.lex_state = 7},
  [1736] = {.lex_state = 6},
  [1737] = {.lex_state = 6},
  [1738] = {.lex_state = 7},
  [1739] = {.lex_state = 6},
  [1740] = {.lex_state = 6},
  [1741] = {.lex_state = 7},
  [1742] = {.lex_state = 7},
  [1743] = {.lex_state = 6},
  [1744] = {.lex_state = 6},
  [1745] = {.lex_state = 7},
  [1746] = {.lex_state = 7},
  [1747] = {.lex_state = 7},
  [1748] = {.lex_state = 6},
  [1749] = {.lex_state = 6},
  [1750] = {.lex_state = 6},
  [1751] = {.lex_state = 6},
  [1752] = {.lex_state = 7},
  [1753] = {.lex_state = 7},
  [1754] = {.lex_state = 7},
  [1755] = {.lex_state = 6},
  [1756] = {.lex_state = 7},
  [1757] = {.lex_state = 7},
  [1758] = {.lex_state = 6},
  [1759] = {.lex_state = 7},
  [1760] = {.lex_state = 7},
  [1761] = {.lex_state = 7},
  [1762] = {.lex_state = 6},
  [1763] = {.lex_state = 7},
  [1764] = {.lex_state = 6},
  [1765] = {.lex_state = 6},
  [1766] = {.lex_state = 7},
  [1767] = {.lex_state = 7},
  [1768] = {.lex_state = 6},
  [1769] = {.lex_state = 6},
  [1770] = {.lex_state = 6},
  [1771] = {.lex_state = 6},
  [1772] = {.lex_state = 13},
  [1773] = {.lex_state = 7},
  [1774] = {.lex_state = 7},
  [1775] = {.lex_state = 7},
  [1776] = {.lex_state = 6},
  [1777] = {.lex_state = 6},
  [1778] = {.lex_state = 7},
  [1779] = {.lex_state = 6},
  [1780] = {.lex_state = 7},
  [1781] = {.lex_state = 7},
  [1782] = {.lex_state = 7},
  [1783] = {.lex_state = 6},
  [1784] = {.lex_state = 7},
  [1785] = {.lex_state = 6},
  [1786] = {.lex_state = 6},
  [1787] = {.lex_state = 6},
  [1788] = {.lex_state = 6},
  [1789] = {.lex_state = 7},
  [1790] = {.lex_state = 6},
  [1791] = {.lex_state = 7},
  [1792] = {.lex_state = 7},
  [1793] = {.lex_state = 7},
  [1794] = {.lex_state = 6},
  [1795] = {.lex_state = 7},
  [1796] = {.lex_state = 7},
  [1797] = {.lex_state = 7},
  [1798] = {.lex_state = 7},
  [1799] = {.lex_state = 7},
  [1800] = {.lex_state = 6},
  [1801] = {.lex_state = 7},
  [1802] = {.lex_state = 7},
  [1803] = {.lex_state = 7},
  [1804] = {.lex_state = 7},
  [1805] = {.lex_state = 7},
  [1806] = {.lex_state = 7},
  [1807] = {.lex_state = 7},
  [1808] = {.lex_state = 7},
  [1809] = {.lex_state = 7},
  [1810] = {.lex_state = 7},
  [1811] = {.lex_state = 6},
  [1812] = {.lex_state = 7},
  [1813] = {.lex_state = 7},
  [1814] = {.lex_state = 6},
  [1815] = {.lex_state = 7},
  [1816] = {.lex_state = 7},
  [1817] = {.lex_state = 6},
  [1818] = {.lex_state = 7},
  [1819] = {.lex_state = 7},
  [1820] = {.lex_state = 7},
  [1821] = {.lex_state = 7},
  [1822] = {.lex_state = 7},
  [1823] = {.lex_state = 7},
  [1824] = {.lex_state = 7},
  [1825] = {.lex_state = 7},
  [1826] = {.lex_state = 7},
  [1827] = {.lex_state = 6},
  [1828] = {.lex_state = 7},
  [1829] = {.lex_state = 7},
  [1830] = {.lex_state = 7},
  [1831] = {.lex_state = 7},
  [1832] = {.lex_state = 7},
  [1833] = {.lex_state = 7},
  [1834] = {.lex_state = 6},
  [1835] = {.lex_state = 6},
  [1836] = {.lex_state = 6},
  [1837] = {.lex_state = 6},
  [1838] = {.lex_state = 13},
  [1839] = {.lex_state = 6},
  [1840] = {.lex_state = 6},
  [1841] = {.lex_state = 7},
  [1842] = {.lex_state = 6},
  [1843] = {.lex_state = 6},
  [1844] = {.lex_state = 6},
  [1845] = {.lex_state = 13},
  [1846] = {.lex_state = 6},
  [1847] = {.lex_state = 6},
  [1848] = {.lex_state = 6},
  [1849] = {.lex_state = 6},
  [1850] = {.lex_state = 6},
  [1851] = {.lex_state = 6},
  [1852] = {.lex_state = 6},
  [1853] = {.lex_state = 6},
  [1854] = {.lex_state = 7},
  [1855] = {.lex_state = 7},
  [1856] = {.lex_state = 6},
  [1857] = {.lex_state = 6},
  [1858] = {.lex_state = 6},
  [1859] = {.lex_state = 6},
  [1860] = {.lex_state = 6},
  [1861] = {.lex_state = 6},
  [1862] = {.lex_state = 6},
  [1863] = {.lex_state = 6},
  [1864] = {.lex_state = 6},
  [1865] = {.lex_state = 6},
  [1866] = {.lex_state = 6},
  [1867] = {.lex_state = 6},
  [1868] = {.lex_state = 13},
  [1869] = {.lex_state = 13},
  [1870] = {.lex_state = 13},
  [1871] = {.lex_state = 13},
  [1872] = {.lex_state = 13},
  [1873] = {.lex_state = 13},
  [1874] = {.lex_state = 13},
  [1875] = {.lex_state = 13},
  [1876] = {.lex_state = 13},
  [1877] = {.lex_state = 13},
  [1878] = {.lex_state = 13},
  [1879] = {.lex_state = 13},
  [1880] = {.lex_state = 13},
  [1881] = {.lex_state = 13},
  [1882] = {.lex_state = 13},
  [1883] = {.lex_state = 13},
  [1884] = {.lex_state = 13},
  [1885] = {.lex_state = 13},
  [1886] = {.lex_state = 13},
  [1887] = {.lex_state = 13},
  [1888] = {.lex_state = 13},
  [1889] = {.lex_state = 13},
  [1890] = {.lex_state = 13},
  [1891] = {.lex_state = 13},
  [1892] = {.lex_state = 13},
  [1893] = {.lex_state = 13},
  [1894] = {.lex_state = 26},
  [1895] = {.lex_state = 26},
  [1896] = {.lex_state = 15},
  [1897] = {.lex_state = 15},
  [1898] = {.lex_state = 15},
  [1899] = {.lex_state = 15},
  [1900] = {.lex_state = 15},
  [1901] = {.lex_state = 15},
  [1902] = {.lex_state = 15},
  [1903] = {.lex_state = 15},
  [1904] = {.lex_state = 15},
  [1905] = {.lex_state = 26},
  [1906] = {.lex_state = 15},
  [1907] = {.lex_state = 26},
  [1908] = {.lex_state = 15},
  [1909] = {.lex_state = 15},
  [1910] = {.lex_state = 15},
  [1911] = {.lex_state = 26},
  [1912] = {.lex_state = 26},
  [1913] = {.lex_state = 13},
  [1914] = {.lex_state = 26},
  [1915] = {.lex_state = 13},
  [1916] = {.lex_state = 13},
  [1917] = {.lex_state = 13},
  [1918] = {.lex_state = 13},
  [1919] = {.lex_state = 13},
  [1920] = {.lex_state = 13},
  [1921] = {.lex_state = 13},
  [1922] = {.lex_state = 13},
  [1923] = {.lex_state = 13},
  [1924] = {.lex_state = 15},
  [1925] = {.lex_state = 13},
  [1926] = {.lex_state = 13},
  [1927] = {.lex_state = 13},
  [1928] = {.lex_state = 15},
  [1929] = {.lex_state = 26},
  [1930] = {.lex_state = 13},
  [1931] = {.lex_state = 26},
  [1932] = {.lex_state = 26},
  [1933] = {.lex_state = 26},
  [1934] = {.lex_state = 13},
  [1935] = {.lex_state = 26},
  [1936] = {.lex_state = 26},
  [1937] = {.lex_state = 13},
  [1938] = {.lex_state = 13},
  [1939] = {.lex_state = 13},
  [1940] = {.lex_state = 15},
  [1941] = {.lex_state = 26},
  [1942] = {.lex_state = 26},
  [1943] = {.lex_state = 26},
  [1944] = {.lex_state = 15},
  [1945] = {.lex_state = 13},
  [1946] = {.lex_state = 26},
  [1947] = {.lex_state = 26},
  [1948] = {.lex_state = 13},
  [1949] = {.lex_state = 13},
  [1950] = {.lex_state = 26},
  [1951] = {.lex_state = 15},
  [1952] = {.lex_state = 26},
  [1953] = {.lex_state = 15},
  [1954] = {.lex_state = 26},
  [1955] = {.lex_state = 26},
  [1956] = {.lex_state = 26},
  [1957] = {.lex_state = 26},
  [1958] = {.lex_state = 26},
  [1959] = {.lex_state = 26},
  [1960] = {.lex_state = 26},
  [1961] = {.lex_state = 26},
  [1962] = {.lex_state = 13},
  [1963] = {.lex_state = 26},
  [1964] = {.lex_state = 13},
  [1965] = {.lex_state = 13},
  [1966] = {.lex_state = 13},
  [1967] = {.lex_state = 13},
  [1968] = {.lex_state = 26},
  [1969] = {.lex_state = 26},
  [1970] = {.lex_state = 26},
  [1971] = {.lex_state = 26},
  [1972] = {.lex_state = 26},
  [1973] = {.lex_state = 26},
  [1974] = {.lex_state = 26},
  [1975] = {.lex_state = 26},
  [1976] = {.lex_state = 26},
  [1977] = {.lex_state = 26},
  [1978] = {.lex_state = 26},
  [1979] = {.lex_state = 26},
  [1980] = {.lex_state = 26},
  [1981] = {.lex_state = 26},
  [1982] = {.lex_state = 26},
  [1983] = {.lex_state = 26},
  [1984] = {.lex_state = 26},
  [1985] = {.lex_state = 26},
  [1986] = {.lex_state = 15},
  [1987] = {.lex_state = 26},
  [1988] = {.lex_state = 26},
  [1989] = {.lex_state = 26},
  [1990] = {.lex_state = 13},
  [1991] = {.lex_state = 15},
  [1992] = {.lex_state = 26},
  [1993] = {.lex_state = 13},
  [1994] = {.lex_state = 15},
  [1995] = {.lex_state = 16},
  [1996] = {.lex_state = 15},
  [1997] = {.lex_state = 15},
  [1998] = {.lex_state = 15},
  [1999] = {.lex_state = 15},
  [2000] = {.lex_state = 15},
  [2001] = {.lex_state = 26},
  [2002] = {.lex_state = 15},
  [2003] = {.lex_state = 15},
  [2004] = {.lex_state = 15},
  [2005] = {.lex_state = 26},
  [2006] = {.lex_state = 26},
  [2007] = {.lex_state = 15},
  [2008] = {.lex_state = 15},
  [2009] = {.lex_state = 15},
  [2010] = {.lex_state = 13},
  [2011] = {.lex_state = 13},
  [2012] = {.lex_state = 13},
  [2013] = {.lex_state = 13},
  [2014] = {.lex_state = 13},
  [2015] = {.lex_state = 13},
  [2016] = {.lex_state = 13},
  [2017] = {.lex_state = 13},
  [2018] = {.lex_state = 13},
  [2019] = {.lex_state = 13},
  [2020] = {.lex_state = 13},
  [2021] = {.lex_state = 13},
  [2022] = {.lex_state = 13},
  [2023] = {.lex_state = 13},
  [2024] = {.lex_state = 13},
  [2025] = {.lex_state = 13},
  [2026] = {.lex_state = 13},
  [2027] = {.lex_state = 13},
  [2028] = {.lex_state = 15},
  [2029] = {.lex_state = 26},
  [2030] = {.lex_state = 15},
  [2031] = {.lex_state = 15},
  [2032] = {.lex_state = 15},
  [2033] = {.lex_state = 26},
  [2034] = {.lex_state = 22},
  [2035] = {.lex_state = 13},
  [2036] = {.lex_state = 20},
  [2037] = {.lex_state = 13},
  [2038] = {.lex_state = 26},
  [2039] = {.lex_state = 16},
  [2040] = {.lex_state = 16},
  [2041] = {.lex_state = 20},
  [2042] = {.lex_state = 13},
  [2043] = {.lex_state = 26},
  [2044] = {.lex_state = 13},
  [2045] = {.lex_state = 13},
  [2046] = {.lex_state = 16},
  [2047] = {.lex_state = 13},
  [2048] = {.lex_state = 16},
  [2049] = {.lex_state = 13},
  [2050] = {.lex_state = 15},
  [2051] = {.lex_state = 13},
  [2052] = {.lex_state = 15},
  [2053] = {.lex_state = 26},
  [2054] = {.lex_state = 13},
  [2055] = {.lex_state = 15},
  [2056] = {.lex_state = 22},
  [2057] = {.lex_state = 20},
  [2058] = {.lex_state = 13},
  [2059] = {.lex_state = 13},
  [2060] = {.lex_state = 13},
  [2061] = {.lex_state = 15},
  [2062] = {.lex_state = 13},
  [2063] = {.lex_state = 15},
  [2064] = {.lex_state = 20},
  [2065] = {.lex_state = 15},
  [2066] = {.lex_state = 13},
  [2067] = {.lex_state = 13},
  [2068] = {.lex_state = 13},
  [2069] = {.lex_state = 13},
  [2070] = {.lex_state = 26},
  [2071] = {.lex_state = 26},
  [2072] = {.lex_state = 26},
  [2073] = {.lex_state = 26},
  [2074] = {.lex_state = 26},
  [2075] = {.lex_state = 22},
  [2076] = {.lex_state = 26},
  [2077] = {.lex_state = 22},
  [2078] = {.lex_state = 26},
  [2079] = {.lex_state = 15},
  [2080] = {.lex_state = 13},
  [2081] = {.lex_state = 22},
  [2082] = {.lex_state = 22},
  [2083] = {.lex_state = 26},
  [2084] = {.lex_state = 26},
  [2085] = {.lex_state = 26},
  [2086] = {.lex_state = 26},
  [2087] = {.lex_state = 26},
  [2088] = {.lex_state = 26},
  [2089] = {.lex_state = 26},
  [2090] = {.lex_state = 26},
  [2091] = {.lex_state = 26},
  [2092] = {.lex_state = 26},
  [2093] = {.lex_state = 13},
  [2094] = {.lex_state = 15},
  [2095] = {.lex_state = 26},
  [2096] = {.lex_state = 26},
  [2097] = {.lex_state = 26},
  [2098] = {.lex_state = 26},
  [2099] = {.lex_state = 13},
  [2100] = {.lex_state = 26},
  [2101] = {.lex_state = 9},
  [2102] = {.lex_state = 15},
  [2103] = {.lex_state = 26},
  [2104] = {.lex_state = 26},
  [2105] = {.lex_state = 26},
  [2106] = {.lex_state = 26},
  [2107] = {.lex_state = 26},
  [2108] = {.lex_state = 15},
  [2109] = {.lex_state = 26},
  [2110] = {.lex_state = 26},
  [2111] = {.lex_state = 26},
  [2112] = {.lex_state = 26},
  [2113] = {.lex_state = 26},
  [2114] = {.lex_state = 26},
  [2115] = {.lex_state = 26},
  [2116] = {.lex_state = 26},
  [2117] = {.lex_state = 26},
  [2118] = {.lex_state = 16},
  [2119] = {.lex_state = 26},
  [2120] = {.lex_state = 13},
  [2121] = {.lex_state = 13},
  [2122] = {.lex_state = 13},
  [2123] = {.lex_state = 26},
  [2124] = {.lex_state = 13},
  [2125] = {.lex_state = 13},
  [2126] = {.lex_state = 13},
  [2127] = {.lex_state = 13},
  [2128] = {.lex_state = 13},
  [2129] = {.lex_state = 13},
  [2130] = {.lex_state = 26},
  [2131] = {.lex_state = 13},
  [2132] = {.lex_state = 13},
  [2133] = {.lex_state = 26},
  [2134] = {.lex_state = 13},
  [2135] = {.lex_state = 13},
  [2136] = {.lex_state = 13},
  [2137] = {.lex_state = 16},
  [2138] = {.lex_state = 26},
  [2139] = {.lex_state = 13},
  [2140] = {.lex_state = 13},
  [2141] = {.lex_state = 16},
  [2142] = {.lex_state = 9},
  [2143] = {.lex_state = 22},
  [2144] = {.lex_state = 26},
  [2145] = {.lex_state = 13},
  [2146] = {.lex_state = 16},
  [2147] = {.lex_state = 5},
  [2148] = {.lex_state = 26},
  [2149] = {.lex_state = 26},
  [2150] = {.lex_state = 26},
  [2151] = {.lex_state = 15},
  [2152] = {.lex_state = 16},
  [2153] = {.lex_state = 68},
  [2154] = {.lex_state = 13},
  [2155] = {.lex_state = 13},
  [2156] = {.lex_state = 13},
  [2157] = {.lex_state = 13},
  [2158] = {.lex_state = 5},
  [2159] = {.lex_state = 13},
  [2160] = {.lex_state = 9},
  [2161] = {.lex_state = 9},
  [2162] = {.lex_state = 13},
  [2163] = {.lex_state = 13},
  [2164] = {.lex_state = 9},
  [2165] = {.lex_state = 16},
  [2166] = {.lex_state = 5},
  [2167] = {.lex_state = 13},
  [2168] = {.lex_state = 13},
  [2169] = {.lex_state = 13},
  [2170] = {.lex_state = 13},
  [2171] = {.lex_state = 13},
  [2172] = {.lex_state = 13},
  [2173] = {.lex_state = 13},
  [2174] = {.lex_state = 13},
  [2175] = {.lex_state = 13},
  [2176] = {.lex_state = 13},
  [2177] = {.lex_state = 13},
  [2178] = {.lex_state = 13},
  [2179] = {.lex_state = 13},
  [2180] = {.lex_state = 13},
  [2181] = {.lex_state = 13},
  [2182] = {.lex_state = 13},
  [2183] = {.lex_state = 20},
  [2184] = {.lex_state = 13},
  [2185] = {.lex_state = 13},
  [2186] = {.lex_state = 13},
  [2187] = {.lex_state = 22},
  [2188] = {.lex_state = 13},
  [2189] = {.lex_state = 22},
  [2190] = {.lex_state = 22},
  [2191] = {.lex_state = 22},
  [2192] = {.lex_state = 13},
  [2193] = {.lex_state = 13},
  [2194] = {.lex_state = 13},
  [2195] = {.lex_state = 22},
  [2196] = {.lex_state = 13},
  [2197] = {.lex_state = 13},
  [2198] = {.lex_state = 13},
  [2199] = {.lex_state = 13},
  [2200] = {.lex_state = 13},
  [2201] = {.lex_state = 13},
  [2202] = {.lex_state = 22},
  [2203] = {.lex_state = 13},
  [2204] = {.lex_state = 13},
  [2205] = {.lex_state = 13},
  [2206] = {.lex_state = 22},
  [2207] = {.lex_state = 22},
  [2208] = {.lex_state = 13},
  [2209] = {.lex_state = 13},
  [2210] = {.lex_state = 13},
  [2211] = {.lex_state = 22},
  [2212] = {.lex_state = 13},
  [2213] = {.lex_state = 13},
  [2214] = {.lex_state = 9},
  [2215] = {.lex_state = 13},
  [2216] = {.lex_state = 13},
  [2217] = {.lex_state = 13},
  [2218] = {.lex_state = 13},
  [2219] = {.lex_state = 13},
  [2220] = {.lex_state = 13},
  [2221] = {.lex_state = 22},
  [2222] = {.lex_state = 68},
  [2223] = {.lex_state = 68},
  [2224] = {.lex_state = 68},
  [2225] = {.lex_state = 68},
  [2226] = {.lex_state = 68},
  [2227] = {.lex_state = 68},
  [2228] = {.lex_state = 68},
  [2229] = {.lex_state = 68},
  [2230] = {.lex_state = 68},
  [2231] = {.lex_state = 22},
  [2232] = {.lex_state = 22},
  [2233] = {.lex_state = 68},
  [2234] = {.lex_state = 13},
  [2235] = {.lex_state = 68},
  [2236] = {.lex_state = 13},
  [2237] = {.lex_state = 68},
  [2238] = {.lex_state = 2},
  [2239] = {.lex_state = 68},
  [2240] = {.lex_state = 13},
  [2241] = {.lex_state = 68},
  [2242] = {.lex_state = 16},
  [2243] = {.lex_state = 22},
  [2244] = {.lex_state = 13},
  [2245] = {.lex_state = 68},
  [2246] = {.lex_state = 13},
  [2247] = {.lex_state = 26},
  [2248] = {.lex_state = 68},
  [2249] = {.lex_state = 13},
  [2250] = {.lex_state = 68},
  [2251] = {.lex_state = 13},
  [2252] = {.lex_state = 22},
  [2253] = {.lex_state = 68},
  [2254] = {.lex_state = 68},
  [2255] = {.lex_state = 22},
  [2256] = {.lex_state = 68},
  [2257] = {.lex_state = 68},
  [2258] = {.lex_state = 22},
  [2259] = {.lex_state = 2},
  [2260] = {.lex_state = 68},
  [2261] = {.lex_state = 13},
  [2262] = {.lex_state = 9},
  [2263] = {.lex_state = 68},
  [2264] = {.lex_state = 9},
  [2265] = {.lex_state = 13},
  [2266] = {.lex_state = 26},
  [2267] = {.lex_state = 68},
  [2268] = {.lex_state = 68},
  [2269] = {.lex_state = 22},
  [2270] = {.lex_state = 68},
  [2271] = {.lex_state = 68},
  [2272] = {.lex_state = 13},
  [2273] = {.lex_state = 68},
  [2274] = {.lex_state = 68},
  [2275] = {.lex_state = 22},
  [2276] = {.lex_state = 68},
  [2277] = {.lex_state = 2},
  [2278] = {.lex_state = 9},
  [2279] = {.lex_state = 13},
  [2280] = {.lex_state = 13},
  [2281] = {.lex_state = 13},
  [2282] = {.lex_state = 13},
  [2283] = {.lex_state = 13},
  [2284] = {.lex_state = 26},
  [2285] = {.lex_state = 16},
  [2286] = {.lex_state = 13},
  [2287] = {.lex_state = 13},
  [2288] = {.lex_state = 16},
  [2289] = {.lex_state = 16},
  [2290] = {.lex_state = 16},
  [2291] = {.lex_state = 13},
  [2292] = {.lex_state = 13},
  [2293] = {.lex_state = 13},
  [2294] = {.lex_state = 13},
  [2295] = {.lex_state = 13},
  [2296] = {.lex_state = 13},
  [2297] = {.lex_state = 13},
  [2298] = {.lex_state = 26},
  [2299] = {.lex_state = 13},
  [2300] = {.lex_state = 13},
  [2301] = {.lex_state = 13},
  [2302] = {.lex_state = 18},
  [2303] = {.lex_state = 13},
  [2304] = {.lex_state = 13},
  [2305] = {.lex_state = 13},
  [2306] = {.lex_state = 13},
  [2307] = {.lex_state = 13},
  [2308] = {.lex_state = 13},
  [2309] = {.lex_state = 13},
  [2310] = {.lex_state = 68},
  [2311] = {.lex_state = 26},
  [2312] = {.lex_state = 26},
  [2313] = {.lex_state = 2},
  [2314] = {.lex_state = 18},
  [2315] = {.lex_state = 68},
  [2316] = {.lex_state = 13},
  [2317] = {.lex_state = 13},
  [2318] = {.lex_state = 13},
  [2319] = {.lex_state = 13},
  [2320] = {.lex_state = 13},
  [2321] = {.lex_state = 2},
  [2322] = {.lex_state = 13},
  [2323] = {.lex_state = 13},
  [2324] = {.lex_state = 13},
  [2325] = {.lex_state = 2},
  [2326] = {.lex_state = 13},
  [2327] = {.lex_state = 13},
  [2328] = {.lex_state = 18},
  [2329] = {.lex_state = 13},
  [2330] = {.lex_state = 13},
  [2331] = {.lex_state = 13},
  [2332] = {.lex_state = 13},
  [2333] = {.lex_state = 18},
  [2334] = {.lex_state = 13},
  [2335] = {.lex_state = 16},
  [2336] = {.lex_state = 16},
  [2337] = {.lex_state = 18},
  [2338] = {.lex_state = 13},
  [2339] = {.lex_state = 22},
  [2340] = {.lex_state = 13},
  [2341] = {.lex_state = 22},
  [2342] = {.lex_state = 13},
  [2343] = {.lex_state = 13},
  [2344] = {.lex_state = 13},
  [2345] = {.lex_state = 16},
  [2346] = {.lex_state = 26},
  [2347] = {.lex_state = 13},
  [2348] = {.lex_state = 13},
  [2349] = {.lex_state = 12},
  [2350] = {.lex_state = 13},
  [2351] = {.lex_state = 2},
  [2352] = {.lex_state = 26},
  [2353] = {.lex_state = 26},
  [2354] = {.lex_state = 26},
  [2355] = {.lex_state = 12},
  [2356] = {.lex_state = 26},
  [2357] = {.lex_state = 22},
  [2358] = {.lex_state = 26},
  [2359] = {.lex_state = 26},
  [2360] = {.lex_state = 26},
  [2361] = {.lex_state = 26},
  [2362] = {.lex_state = 13},
  [2363] = {.lex_state = 13},
  [2364] = {.lex_state = 13},
  [2365] = {.lex_state = 26},
  [2366] = {.lex_state = 26},
  [2367] = {.lex_state = 13},
  [2368] = {.lex_state = 13},
  [2369] = {.lex_state = 13},
  [2370] = {.lex_state = 26},
  [2371] = {.lex_state = 13},
  [2372] = {.lex_state = 18},
  [2373] = {.lex_state = 13},
  [2374] = {.lex_state = 13},
  [2375] = {.lex_state = 13},
  [2376] = {.lex_state = 13},
  [2377] = {.lex_state = 13},
  [2378] = {.lex_state = 9},
  [2379] = {.lex_state = 13},
  [2380] = {.lex_state = 13},
  [2381] = {.lex_state = 13},
  [2382] = {.lex_state = 2},
  [2383] = {.lex_state = 26},
  [2384] = {.lex_state = 13},
  [2385] = {.lex_state = 26},
  [2386] = {.lex_state = 9},
  [2387] = {.lex_state = 13},
  [2388] = {.lex_state = 68},
  [2389] = {.lex_state = 9},
  [2390] = {.lex_state = 68},
  [2391] = {.lex_state = 26},
  [2392] = {.lex_state = 13},
  [2393] = {.lex_state = 26},
  [2394] = {.lex_state = 9, .external_lex_state = 3},
  [2395] = {.lex_state = 26},
  [2396] = {.lex_state = 26},
  [2397] = {.lex_state = 9},
  [2398] = {.lex_state = 9},
  [2399] = {.lex_state = 9},
  [2400] = {.lex_state = 9},
  [2401] = {.lex_state = 26},
  [2402] = {.lex_state = 5},
  [2403] = {.lex_state = 26},
  [2404] = {.lex_state = 13},
  [2405] = {.lex_state = 13},
  [2406] = {.lex_state = 13},
  [2407] = {.lex_state = 26},
  [2408] = {.lex_state = 9},
  [2409] = {.lex_state = 9},
  [2410] = {.lex_state = 26},
  [2411] = {.lex_state = 13},
  [2412] = {.lex_state = 13},
  [2413] = {.lex_state = 26},
  [2414] = {.lex_state = 9},
  [2415] = {.lex_state = 26},
  [2416] = {.lex_state = 13},
  [2417] = {.lex_state = 13},
  [2418] = {.lex_state = 26},
  [2419] = {.lex_state = 13},
  [2420] = {.lex_state = 26},
  [2421] = {.lex_state = 26},
  [2422] = {.lex_state = 9},
  [2423] = {.lex_state = 26},
  [2424] = {.lex_state = 5},
  [2425] = {.lex_state = 9},
  [2426] = {.lex_state = 9},
  [2427] = {.lex_state = 9},
  [2428] = {.lex_state = 5},
  [2429] = {.lex_state = 26},
  [2430] = {.lex_state = 26},
  [2431] = {.lex_state = 9},
  [2432] = {.lex_state = 13},
  [2433] = {.lex_state = 9},
  [2434] = {.lex_state = 26},
  [2435] = {.lex_state = 26},
  [2436] = {.lex_state = 9},
  [2437] = {.lex_state = 26},
  [2438] = {.lex_state = 26},
  [2439] = {.lex_state = 9},
  [2440] = {.lex_state = 26},
  [2441] = {.lex_state = 9},
  [2442] = {.lex_state = 2},
  [2443] = {.lex_state = 13},
  [2444] = {.lex_state = 13},
  [2445] = {.lex_state = 165},
  [2446] = {.lex_state = 26},
  [2447] = {.lex_state = 26},
  [2448] = {.lex_state = 26},
  [2449] = {.lex_state = 26},
  [2450] = {.lex_state = 13},
  [2451] = {.lex_state = 26},
  [2452] = {.lex_state = 5},
  [2453] = {.lex_state = 9},
  [2454] = {.lex_state = 26},
  [2455] = {.lex_state = 26},
  [2456] = {.lex_state = 26},
  [2457] = {.lex_state = 26},
  [2458] = {.lex_state = 9},
  [2459] = {.lex_state = 13},
  [2460] = {.lex_state = 9},
  [2461] = {.lex_state = 26},
  [2462] = {.lex_state = 26},
  [2463] = {.lex_state = 26},
  [2464] = {.lex_state = 9},
  [2465] = {.lex_state = 26},
  [2466] = {.lex_state = 9},
  [2467] = {.lex_state = 26},
  [2468] = {.lex_state = 26},
  [2469] = {.lex_state = 9},
  [2470] = {.lex_state = 13},
  [2471] = {.lex_state = 9},
  [2472] = {.lex_state = 13},
  [2473] = {.lex_state = 9},
  [2474] = {.lex_state = 9},
  [2475] = {.lex_state = 13},
  [2476] = {.lex_state = 13},
  [2477] = {.lex_state = 9},
  [2478] = {.lex_state = 13},
  [2479] = {.lex_state = 9},
  [2480] = {.lex_state = 26},
  [2481] = {.lex_state = 9},
  [2482] = {.lex_state = 9},
  [2483] = {.lex_state = 9},
  [2484] = {.lex_state = 26},
  [2485] = {.lex_state = 13},
  [2486] = {.lex_state = 9},
  [2487] = {.lex_state = 5},
  [2488] = {.lex_state = 5},
  [2489] = {.lex_state = 5},
  [2490] = {.lex_state = 5},
  [2491] = {.lex_state = 9},
  [2492] = {.lex_state = 9, .external_lex_state = 4},
  [2493] = {.lex_state = 5},
  [2494] = {.lex_state = 13},
  [2495] = {.lex_state = 5},
  [2496] = {.lex_state = 2},
  [2497] = {.lex_state = 13},
  [2498] = {.lex_state = 2},
  [2499] = {.lex_state = 13},
  [2500] = {.lex_state = 16},
  [2501] = {.lex_state = 9},
  [2502] = {.lex_state = 9},
  [2503] = {.lex_state = 9},
  [2504] = {.lex_state = 9},
  [2505] = {.lex_state = 9},
  [2506] = {.lex_state = 16},
  [2507] = {.lex_state = 5},
  [2508] = {.lex_state = 16},
  [2509] = {.lex_state = 16},
  [2510] = {.lex_state = 13},
  [2511] = {.lex_state = 13},
  [2512] = {.lex_state = 2},
  [2513] = {.lex_state = 9},
  [2514] = {.lex_state = 9},
  [2515] = {.lex_state = 68},
  [2516] = {.lex_state = 26},
  [2517] = {.lex_state = 9},
  [2518] = {.lex_state = 9},
  [2519] = {.lex_state = 15},
  [2520] = {.lex_state = 68},
  [2521] = {.lex_state = 16},
  [2522] = {.lex_state = 9},
  [2523] = {.lex_state = 9},
  [2524] = {.lex_state = 68},
  [2525] = {.lex_state = 68},
  [2526] = {.lex_state = 16},
  [2527] = {.lex_state = 13},
  [2528] = {.lex_state = 68},
  [2529] = {.lex_state = 16},
  [2530] = {.lex_state = 16},
  [2531] = {.lex_state = 9},
  [2532] = {.lex_state = 68},
  [2533] = {.lex_state = 13},
  [2534] = {.lex_state = 9},
  [2535] = {.lex_state = 13},
  [2536] = {.lex_state = 28},
  [2537] = {.lex_state = 28},
  [2538] = {.lex_state = 13},
  [2539] = {.lex_state = 13},
  [2540] = {.lex_state = 9},
  [2541] = {.lex_state = 9},
  [2542] = {.lex_state = 68},
  [2543] = {.lex_state = 13},
  [2544] = {.lex_state = 9, .external_lex_state = 4},
  [2545] = {.lex_state = 68},
  [2546] = {.lex_state = 68},
  [2547] = {.lex_state = 5},
  [2548] = {.lex_state = 2},
  [2549] = {.lex_state = 5},
  [2550] = {.lex_state = 5},
  [2551] = {.lex_state = 5},
  [2552] = {.lex_state = 5},
  [2553] = {.lex_state = 68},
  [2554] = {.lex_state = 5},
  [2555] = {.lex_state = 13},
  [2556] = {.lex_state = 5},
  [2557] = {.lex_state = 5},
  [2558] = {.lex_state = 5},
  [2559] = {.lex_state = 5},
  [2560] = {.lex_state = 5},
  [2561] = {.lex_state = 5},
  [2562] = {.lex_state = 9},
  [2563] = {.lex_state = 5},
  [2564] = {.lex_state = 13},
  [2565] = {.lex_state = 5},
  [2566] = {.lex_state = 26},
  [2567] = {.lex_state = 5},
  [2568] = {.lex_state = 9},
  [2569] = {.lex_state = 68},
  [2570] = {.lex_state = 28},
  [2571] = {.lex_state = 5},
  [2572] = {.lex_state = 5},
  [2573] = {.lex_state = 9, .external_lex_state = 4},
  [2574] = {.lex_state = 9, .external_lex_state = 4},
  [2575] = {.lex_state = 68},
  [2576] = {.lex_state = 68},
  [2577] = {.lex_state = 5},
  [2578] = {.lex_state = 5},
  [2579] = {.lex_state = 68},
  [2580] = {.lex_state = 9, .external_lex_state = 4},
  [2581] = {.lex_state = 68},
  [2582] = {.lex_state = 5},
  [2583] = {.lex_state = 9},
  [2584] = {.lex_state = 9, .external_lex_state = 4},
  [2585] = {.lex_state = 9},
  [2586] = {.lex_state = 9},
  [2587] = {.lex_state = 5},
  [2588] = {.lex_state = 9},
  [2589] = {.lex_state = 9, .external_lex_state = 4},
  [2590] = {.lex_state = 68},
  [2591] = {.lex_state = 9},
  [2592] = {.lex_state = 5},
  [2593] = {.lex_state = 5},
  [2594] = {.lex_state = 68},
  [2595] = {.lex_state = 9},
  [2596] = {.lex_state = 9, .external_lex_state = 4},
  [2597] = {.lex_state = 9},
  [2598] = {.lex_state = 5},
  [2599] = {.lex_state = 9},
  [2600] = {.lex_state = 9},
  [2601] = {.lex_state = 5},
  [2602] = {.lex_state = 68},
  [2603] = {.lex_state = 9},
  [2604] = {.lex_state = 9},
  [2605] = {.lex_state = 9},
  [2606] = {.lex_state = 9, .external_lex_state = 4},
  [2607] = {.lex_state = 9},
  [2608] = {.lex_state = 9},
  [2609] = {.lex_state = 2},
  [2610] = {.lex_state = 5},
  [2611] = {.lex_state = 68},
  [2612] = {.lex_state = 13},
  [2613] = {.lex_state = 68},
  [2614] = {.lex_state = 9},
  [2615] = {.lex_state = 68},
  [2616] = {.lex_state = 5},
  [2617] = {.lex_state = 26},
  [2618] = {.lex_state = 15},
  [2619] = {.lex_state = 68},
  [2620] = {.lex_state = 26},
  [2621] = {.lex_state = 68},
  [2622] = {.lex_state = 9},
  [2623] = {.lex_state = 9},
  [2624] = {.lex_state = 68},
  [2625] = {.lex_state = 68},
  [2626] = {.lex_state = 26},
  [2627] = {.lex_state = 68},
  [2628] = {.lex_state = 9},
  [2629] = {.lex_state = 28},
  [2630] = {.lex_state = 68},
  [2631] = {.lex_state = 5},
  [2632] = {.lex_state = 13},
  [2633] = {.lex_state = 26},
  [2634] = {.lex_state = 68},
  [2635] = {.lex_state = 5},
  [2636] = {.lex_state = 5},
  [2637] = {.lex_state = 9},
  [2638] = {.lex_state = 5},
  [2639] = {.lex_state = 5},
  [2640] = {.lex_state = 9},
  [2641] = {.lex_state = 68},
  [2642] = {.lex_state = 9, .external_lex_state = 4},
  [2643] = {.lex_state = 9, .external_lex_state = 4},
  [2644] = {.lex_state = 68},
  [2645] = {.lex_state = 5},
  [2646] = {.lex_state = 9},
  [2647] = {.lex_state = 9},
  [2648] = {.lex_state = 68},
  [2649] = {.lex_state = 13},
  [2650] = {.lex_state = 9},
  [2651] = {.lex_state = 15},
  [2652] = {.lex_state = 13},
  [2653] = {.lex_state = 9},
  [2654] = {.lex_state = 5},
  [2655] = {.lex_state = 9},
  [2656] = {.lex_state = 9, .external_lex_state = 4},
  [2657] = {.lex_state = 26},
  [2658] = {.lex_state = 9},
  [2659] = {.lex_state = 68},
  [2660] = {.lex_state = 9},
  [2661] = {.lex_state = 26},
  [2662] = {.lex_state = 13},
  [2663] = {.lex_state = 68},
  [2664] = {.lex_state = 9},
  [2665] = {.lex_state = 9},
  [2666] = {.lex_state = 26},
  [2667] = {.lex_state = 68},
  [2668] = {.lex_state = 13},
  [2669] = {.lex_state = 68},
  [2670] = {.lex_state = 13},
  [2671] = {.lex_state = 9},
  [2672] = {.lex_state = 68},
  [2673] = {.lex_state = 5},
  [2674] = {.lex_state = 9, .external_lex_state = 4},
  [2675] = {.lex_state = 68},
  [2676] = {.lex_state = 68},
  [2677] = {.lex_state = 26},
  [2678] = {.lex_state = 5},
  [2679] = {.lex_state = 13},
  [2680] = {.lex_state = 68},
  [2681] = {.lex_state = 13},
  [2682] = {.lex_state = 13},
  [2683] = {.lex_state = 13},
  [2684] = {.lex_state = 13},
  [2685] = {.lex_state = 26},
  [2686] = {.lex_state = 26},
  [2687] = {.lex_state = 68},
  [2688] = {.lex_state = 13},
  [2689] = {.lex_state = 9},
  [2690] = {.lex_state = 13},
  [2691] = {.lex_state = 9},
  [2692] = {.lex_state = 68},
  [2693] = {.lex_state = 13},
  [2694] = {.lex_state = 5},
  [2695] = {.lex_state = 13},
  [2696] = {.lex_state = 13},
  [2697] = {.lex_state = 13},
  [2698] = {.lex_state = 13},
  [2699] = {.lex_state = 9},
  [2700] = {.lex_state = 13},
  [2701] = {.lex_state = 68},
  [2702] = {.lex_state = 13},
  [2703] = {.lex_state = 9},
  [2704] = {.lex_state = 13},
  [2705] = {.lex_state = 5},
  [2706] = {.lex_state = 68},
  [2707] = {.lex_state = 13},
  [2708] = {.lex_state = 5},
  [2709] = {.lex_state = 5},
  [2710] = {.lex_state = 68},
  [2711] = {.lex_state = 68},
  [2712] = {.lex_state = 26},
  [2713] = {.lex_state = 68},
  [2714] = {.lex_state = 68},
  [2715] = {.lex_state = 68},
  [2716] = {.lex_state = 9},
  [2717] = {.lex_state = 13},
  [2718] = {.lex_state = 9},
  [2719] = {.lex_state = 68},
  [2720] = {.lex_state = 26},
  [2721] = {.lex_state = 9},
  [2722] = {.lex_state = 13},
  [2723] = {.lex_state = 68},
  [2724] = {.lex_state = 18},
  [2725] = {.lex_state = 16},
  [2726] = {.lex_state = 68},
  [2727] = {.lex_state = 68},
  [2728] = {.lex_state = 13},
  [2729] = {.lex_state = 13},
  [2730] = {.lex_state = 16},
  [2731] = {.lex_state = 68},
  [2732] = {.lex_state = 68},
  [2733] = {.lex_state = 68},
  [2734] = {.lex_state = 68},
  [2735] = {.lex_state = 68},
  [2736] = {.lex_state = 68},
  [2737] = {.lex_state = 5},
  [2738] = {.lex_state = 16},
  [2739] = {.lex_state = 16},
  [2740] = {.lex_state = 5},
  [2741] = {.lex_state = 5},
  [2742] = {.lex_state = 68},
  [2743] = {.lex_state = 68},
  [2744] = {.lex_state = 68},
  [2745] = {.lex_state = 16},
  [2746] = {.lex_state = 16},
  [2747] = {.lex_state = 16},
  [2748] = {.lex_state = 16},
  [2749] = {.lex_state = 5},
  [2750] = {.lex_state = 68},
  [2751] = {.lex_state = 68},
  [2752] = {.lex_state = 16},
  [2753] = {.lex_state = 16},
  [2754] = {.lex_state = 68},
  [2755] = {.lex_state = 68},
  [2756] = {.lex_state = 68},
  [2757] = {.lex_state = 68},
  [2758] = {.lex_state = 68},
  [2759] = {.lex_state = 68},
  [2760] = {.lex_state = 68},
  [2761] = {.lex_state = 68},
  [2762] = {.lex_state = 13},
  [2763] = {.lex_state = 18},
  [2764] = {.lex_state = 68},
  [2765] = {.lex_state = 68},
  [2766] = {.lex_state = 68},
  [2767] = {.lex_state = 68},
  [2768] = {.lex_state = 68},
  [2769] = {.lex_state = 68},
  [2770] = {.lex_state = 68},
  [2771] = {.lex_state = 68},
  [2772] = {.lex_state = 68},
  [2773] = {.lex_state = 68},
  [2774] = {.lex_state = 16},
  [2775] = {.lex_state = 16},
  [2776] = {.lex_state = 16},
  [2777] = {.lex_state = 68},
  [2778] = {.lex_state = 68},
  [2779] = {.lex_state = 13},
  [2780] = {.lex_state = 68},
  [2781] = {.lex_state = 16},
  [2782] = {.lex_state = 68},
  [2783] = {.lex_state = 68},
  [2784] = {.lex_state = 68},
  [2785] = {.lex_state = 13},
  [2786] = {.lex_state = 5},
  [2787] = {.lex_state = 68},
  [2788] = {.lex_state = 68},
  [2789] = {.lex_state = 68},
  [2790] = {.lex_state = 68},
  [2791] = {.lex_state = 68},
  [2792] = {.lex_state = 68},
  [2793] = {.lex_state = 68},
  [2794] = {.lex_state = 5},
  [2795] = {.lex_state = 16},
  [2796] = {.lex_state = 68},
  [2797] = {.lex_state = 5},
  [2798] = {.lex_state = 16},
  [2799] = {.lex_state = 16},
  [2800] = {.lex_state = 68},
  [2801] = {.lex_state = 68},
  [2802] = {.lex_state = 13},
  [2803] = {.lex_state = 68},
  [2804] = {.lex_state = 68},
  [2805] = {.lex_state = 68},
  [2806] = {.lex_state = 16},
  [2807] = {.lex_state = 13},
  [2808] = {.lex_state = 68},
  [2809] = {.lex_state = 68},
  [2810] = {.lex_state = 68},
  [2811] = {.lex_state = 16},
  [2812] = {.lex_state = 68},
  [2813] = {.lex_state = 68},
  [2814] = {.lex_state = 9},
  [2815] = {.lex_state = 9},
  [2816] = {.lex_state = 16},
  [2817] = {.lex_state = 16},
  [2818] = {.lex_state = 16},
  [2819] = {.lex_state = 68},
  [2820] = {.lex_state = 68},
  [2821] = {.lex_state = 16},
  [2822] = {.lex_state = 68},
  [2823] = {.lex_state = 16},
  [2824] = {.lex_state = 13},
  [2825] = {.lex_state = 16},
  [2826] = {.lex_state = 16},
  [2827] = {.lex_state = 68},
  [2828] = {.lex_state = 16},
  [2829] = {.lex_state = 68},
  [2830] = {.lex_state = 16},
  [2831] = {.lex_state = 16},
  [2832] = {.lex_state = 68},
  [2833] = {.lex_state = 68},
  [2834] = {.lex_state = 16},
  [2835] = {.lex_state = 26},
  [2836] = {.lex_state = 68},
  [2837] = {.lex_state = 68},
  [2838] = {.lex_state = 68},
  [2839] = {.lex_state = 68},
  [2840] = {.lex_state = 16},
  [2841] = {.lex_state = 16},
  [2842] = {.lex_state = 13},
  [2843] = {.lex_state = 16},
  [2844] = {.lex_state = 16},
  [2845] = {.lex_state = 68},
  [2846] = {.lex_state = 16},
  [2847] = {.lex_state = 13},
  [2848] = {.lex_state = 9, .external_lex_state = 4},
  [2849] = {.lex_state = 5},
  [2850] = {.lex_state = 68},
  [2851] = {.lex_state = 5},
  [2852] = {.lex_state = 68},
  [2853] = {.lex_state = 68},
  [2854] = {.lex_state = 68},
  [2855] = {.lex_state = 68},
  [2856] = {.lex_state = 68},
  [2857] = {.lex_state = 68},
  [2858] = {.lex_state = 68},
  [2859] = {.lex_state = 13},
  [2860] = {.lex_state = 68},
  [2861] = {.lex_state = 13},
  [2862] = {.lex_state = 68},
  [2863] = {.lex_state = 68},
  [2864] = {.lex_state = 68},
  [2865] = {.lex_state = 68},
  [2866] = {.lex_state = 68},
  [2867] = {.lex_state = 68},
  [2868] = {.lex_state = 68},
  [2869] = {.lex_state = 68},
  [2870] = {.lex_state = 68},
  [2871] = {.lex_state = 68},
  [2872] = {.lex_state = 68},
  [2873] = {.lex_state = 68},
  [2874] = {.lex_state = 68},
  [2875] = {.lex_state = 68},
  [2876] = {.lex_state = 68},
  [2877] = {.lex_state = 68},
  [2878] = {.lex_state = 5},
  [2879] = {.lex_state = 68},
  [2880] = {.lex_state = 68},
  [2881] = {.lex_state = 68},
  [2882] = {.lex_state = 68},
  [2883] = {.lex_state = 68},
  [2884] = {.lex_state = 68},
  [2885] = {.lex_state = 68},
  [2886] = {.lex_state = 68},
  [2887] = {.lex_state = 68},
  [2888] = {.lex_state = 68},
  [2889] = {.lex_state = 68},
  [2890] = {.lex_state = 68},
  [2891] = {.lex_state = 68},
  [2892] = {.lex_state = 68},
  [2893] = {.lex_state = 68},
  [2894] = {.lex_state = 13},
  [2895] = {.lex_state = 16},
  [2896] = {.lex_state = 68},
  [2897] = {.lex_state = 68},
  [2898] = {.lex_state = 13},
  [2899] = {.lex_state = 68},
  [2900] = {.lex_state = 68},
  [2901] = {.lex_state = 68},
  [2902] = {.lex_state = 16},
  [2903] = {.lex_state = 18},
  [2904] = {.lex_state = 68},
  [2905] = {.lex_state = 26},
  [2906] = {.lex_state = 68},
  [2907] = {.lex_state = 68},
  [2908] = {.lex_state = 68},
  [2909] = {.lex_state = 68},
  [2910] = {.lex_state = 68},
  [2911] = {.lex_state = 68},
  [2912] = {.lex_state = 68},
  [2913] = {.lex_state = 68},
  [2914] = {.lex_state = 68},
  [2915] = {.lex_state = 68},
  [2916] = {.lex_state = 68},
  [2917] = {.lex_state = 68},
  [2918] = {.lex_state = 68},
  [2919] = {.lex_state = 5},
  [2920] = {.lex_state = 5},
  [2921] = {.lex_state = 68},
  [2922] = {.lex_state = 68},
  [2923] = {.lex_state = 18},
  [2924] = {.lex_state = 68},
  [2925] = {.lex_state = 13},
  [2926] = {.lex_state = 68},
  [2927] = {.lex_state = 13},
  [2928] = {.lex_state = 68},
  [2929] = {.lex_state = 13},
  [2930] = {.lex_state = 68},
  [2931] = {.lex_state = 68},
  [2932] = {.lex_state = 68},
  [2933] = {.lex_state = 68},
  [2934] = {.lex_state = 68},
  [2935] = {.lex_state = 68},
  [2936] = {.lex_state = 68},
  [2937] = {.lex_state = 68},
  [2938] = {.lex_state = 68},
  [2939] = {.lex_state = 13},
  [2940] = {.lex_state = 13},
  [2941] = {.lex_state = 9},
  [2942] = {.lex_state = 68},
  [2943] = {.lex_state = 68},
  [2944] = {.lex_state = 68},
  [2945] = {.lex_state = 68},
  [2946] = {.lex_state = 13},
  [2947] = {.lex_state = 68},
  [2948] = {.lex_state = 68},
  [2949] = {.lex_state = 68},
  [2950] = {.lex_state = 68},
  [2951] = {.lex_state = 18},
  [2952] = {.lex_state = 5},
  [2953] = {.lex_state = 68},
  [2954] = {.lex_state = 68},
  [2955] = {.lex_state = 68},
  [2956] = {.lex_state = 68},
  [2957] = {.lex_state = 68},
  [2958] = {.lex_state = 68},
  [2959] = {.lex_state = 68},
  [2960] = {.lex_state = 68},
  [2961] = {.lex_state = 68},
  [2962] = {.lex_state = 68},
  [2963] = {.lex_state = 68},
  [2964] = {.lex_state = 68},
  [2965] = {.lex_state = 68},
  [2966] = {.lex_state = 9},
  [2967] = {.lex_state = 68},
  [2968] = {.lex_state = 68},
  [2969] = {.lex_state = 68},
  [2970] = {.lex_state = 68},
  [2971] = {.lex_state = 68},
  [2972] = {.lex_state = 68},
  [2973] = {.lex_state = 68},
  [2974] = {.lex_state = 68},
  [2975] = {.lex_state = 5},
  [2976] = {.lex_state = 68},
  [2977] = {.lex_state = 68},
  [2978] = {.lex_state = 68},
  [2979] = {.lex_state = 68},
  [2980] = {.lex_state = 68},
  [2981] = {.lex_state = 68},
  [2982] = {.lex_state = 68},
  [2983] = {.lex_state = 68},
  [2984] = {.lex_state = 68},
  [2985] = {.lex_state = 68},
  [2986] = {.lex_state = 68},
  [2987] = {.lex_state = 68},
  [2988] = {.lex_state = 68},
  [2989] = {.lex_state = 68},
  [2990] = {.lex_state = 68},
  [2991] = {.lex_state = 68},
  [2992] = {.lex_state = 68},
  [2993] = {.lex_state = 68},
  [2994] = {.lex_state = 68},
  [2995] = {.lex_state = 68},
  [2996] = {.lex_state = 68},
  [2997] = {.lex_state = 68},
  [2998] = {.lex_state = 68},
  [2999] = {.lex_state = 68},
  [3000] = {.lex_state = 68},
  [3001] = {.lex_state = 68},
  [3002] = {.lex_state = 68},
  [3003] = {.lex_state = 68},
  [3004] = {.lex_state = 68},
  [3005] = {.lex_state = 68},
  [3006] = {.lex_state = 68},
  [3007] = {.lex_state = 68},
  [3008] = {.lex_state = 68},
  [3009] = {.lex_state = 68},
  [3010] = {.lex_state = 68},
  [3011] = {.lex_state = 13},
  [3012] = {.lex_state = 68},
  [3013] = {.lex_state = 13},
  [3014] = {.lex_state = 13},
  [3015] = {.lex_state = 68},
  [3016] = {.lex_state = 68},
  [3017] = {.lex_state = 68},
  [3018] = {.lex_state = 68},
  [3019] = {.lex_state = 68},
  [3020] = {.lex_state = 68},
  [3021] = {.lex_state = 13},
  [3022] = {.lex_state = 13},
  [3023] = {.lex_state = 13},
  [3024] = {.lex_state = 13},
  [3025] = {.lex_state = 68},
  [3026] = {.lex_state = 68},
  [3027] = {.lex_state = 68},
  [3028] = {.lex_state = 13},
  [3029] = {.lex_state = 13},
  [3030] = {.lex_state = 68},
  [3031] = {.lex_state = 68},
  [3032] = {.lex_state = 13},
  [3033] = {.lex_state = 13},
  [3034] = {.lex_state = 13},
  [3035] = {.lex_state = 13},
  [3036] = {.lex_state = 68},
  [3037] = {.lex_state = 13},
  [3038] = {.lex_state = 13},
  [3039] = {.lex_state = 13},
  [3040] = {.lex_state = 13},
  [3041] = {.lex_state = 68},
  [3042] = {.lex_state = 68},
  [3043] = {.lex_state = 13},
  [3044] = {.lex_state = 68},
  [3045] = {.lex_state = 13},
  [3046] = {.lex_state = 68},
  [3047] = {.lex_state = 13},
  [3048] = {.lex_state = 5},
  [3049] = {.lex_state = 13},
  [3050] = {.lex_state = 68},
  [3051] = {.lex_state = 13},
  [3052] = {.lex_state = 13},
  [3053] = {.lex_state = 68},
  [3054] = {.lex_state = 13},
  [3055] = {.lex_state = 68},
  [3056] = {.lex_state = 26},
  [3057] = {.lex_state = 13},
  [3058] = {.lex_state = 68},
  [3059] = {.lex_state = 13},
  [3060] = {.lex_state = 13},
  [3061] = {.lex_state = 68},
  [3062] = {.lex_state = 68},
  [3063] = {.lex_state = 68},
  [3064] = {.lex_state = 26},
  [3065] = {.lex_state = 13},
  [3066] = {.lex_state = 13},
  [3067] = {.lex_state = 68},
  [3068] = {.lex_state = 13},
  [3069] = {.lex_state = 68},
  [3070] = {.lex_state = 68},
  [3071] = {.lex_state = 68},
  [3072] = {.lex_state = 13},
  [3073] = {.lex_state = 26},
  [3074] = {.lex_state = 13},
  [3075] = {.lex_state = 68},
  [3076] = {.lex_state = 13},
  [3077] = {.lex_state = 13},
  [3078] = {.lex_state = 13},
  [3079] = {.lex_state = 13},
  [3080] = {.lex_state = 26},
  [3081] = {.lex_state = 13},
  [3082] = {.lex_state = 13},
  [3083] = {.lex_state = 13},
  [3084] = {.lex_state = 68},
  [3085] = {.lex_state = 13},
  [3086] = {.lex_state = 68},
  [3087] = {.lex_state = 68},
  [3088] = {.lex_state = 68},
  [3089] = {.lex_state = 68},
  [3090] = {.lex_state = 68},
  [3091] = {.lex_state = 68},
  [3092] = {.lex_state = 13},
  [3093] = {.lex_state = 68},
  [3094] = {.lex_state = 68},
  [3095] = {.lex_state = 68},
  [3096] = {.lex_state = 13},
  [3097] = {.lex_state = 68},
  [3098] = {.lex_state = 68},
  [3099] = {.lex_state = 9, .external_lex_state = 5},
  [3100] = {.lex_state = 9, .external_lex_state = 5},
  [3101] = {.lex_state = 4},
  [3102] = {.lex_state = 13},
  [3103] = {.lex_state = 4},
  [3104] = {.lex_state = 68},
  [3105] = {.lex_state = 68},
  [3106] = {.lex_state = 13},
  [3107] = {.lex_state = 68},
  [3108] = {.lex_state = 68},
  [3109] = {.lex_state = 68},
  [3110] = {.lex_state = 68},
  [3111] = {.lex_state = 68},
  [3112] = {.lex_state = 9, .external_lex_state = 5},
  [3113] = {.lex_state = 68},
  [3114] = {.lex_state = 68},
  [3115] = {.lex_state = 68},
  [3116] = {.lex_state = 68},
  [3117] = {.lex_state = 13},
  [3118] = {.lex_state = 68},
  [3119] = {.lex_state = 13},
  [3120] = {.lex_state = 13},
  [3121] = {.lex_state = 68},
  [3122] = {.lex_state = 68},
  [3123] = {.lex_state = 68},
  [3124] = {.lex_state = 9},
  [3125] = {.lex_state = 13},
  [3126] = {.lex_state = 68},
  [3127] = {.lex_state = 68},
  [3128] = {.lex_state = 13},
  [3129] = {.lex_state = 13},
  [3130] = {.lex_state = 13},
  [3131] = {.lex_state = 68},
  [3132] = {.lex_state = 68},
  [3133] = {.lex_state = 13},
  [3134] = {.lex_state = 68, .external_lex_state = 6},
  [3135] = {.lex_state = 68},
  [3136] = {.lex_state = 68},
  [3137] = {.lex_state = 26},
  [3138] = {.lex_state = 13},
  [3139] = {.lex_state = 68},
  [3140] = {.lex_state = 68},
  [3141] = {.lex_state = 68},
  [3142] = {.lex_state = 68},
  [3143] = {.lex_state = 68},
  [3144] = {.lex_state = 13},
  [3145] = {.lex_state = 68},
  [3146] = {.lex_state = 13},
  [3147] = {.lex_state = 68},
  [3148] = {.lex_state = 13},
  [3149] = {.lex_state = 13},
  [3150] = {.lex_state = 68},
  [3151] = {.lex_state = 68},
  [3152] = {.lex_state = 68},
  [3153] = {.lex_state = 13},
  [3154] = {.lex_state = 68, .external_lex_state = 6},
  [3155] = {.lex_state = 68},
  [3156] = {.lex_state = 68},
  [3157] = {.lex_state = 68},
  [3158] = {.lex_state = 13},
  [3159] = {.lex_state = 68},
  [3160] = {.lex_state = 13},
  [3161] = {.lex_state = 68},
  [3162] = {.lex_state = 13},
  [3163] = {.lex_state = 68},
  [3164] = {.lex_state = 68},
  [3165] = {.lex_state = 68},
  [3166] = {.lex_state = 68},
  [3167] = {.lex_state = 68},
  [3168] = {.lex_state = 68},
  [3169] = {.lex_state = 68},
  [3170] = {.lex_state = 13},
  [3171] = {.lex_state = 68},
  [3172] = {.lex_state = 13},
  [3173] = {.lex_state = 13},
  [3174] = {.lex_state = 13},
  [3175] = {.lex_state = 13},
  [3176] = {.lex_state = 68},
  [3177] = {.lex_state = 68},
  [3178] = {.lex_state = 68},
  [3179] = {.lex_state = 68},
  [3180] = {.lex_state = 68},
  [3181] = {.lex_state = 68},
  [3182] = {.lex_state = 68},
  [3183] = {.lex_state = 68},
  [3184] = {.lex_state = 68},
  [3185] = {.lex_state = 68},
  [3186] = {.lex_state = 9},
  [3187] = {.lex_state = 68},
  [3188] = {.lex_state = 68},
  [3189] = {.lex_state = 68},
  [3190] = {.lex_state = 68},
  [3191] = {.lex_state = 13},
  [3192] = {.lex_state = 68},
  [3193] = {.lex_state = 68},
  [3194] = {.lex_state = 68},
  [3195] = {.lex_state = 13},
  [3196] = {.lex_state = 68},
  [3197] = {.lex_state = 68},
  [3198] = {.lex_state = 68},
  [3199] = {.lex_state = 68},
  [3200] = {.lex_state = 68},
  [3201] = {.lex_state = 68},
  [3202] = {.lex_state = 26},
  [3203] = {.lex_state = 13},
  [3204] = {.lex_state = 68},
  [3205] = {.lex_state = 13},
  [3206] = {.lex_state = 68},
  [3207] = {.lex_state = 68},
  [3208] = {.lex_state = 68},
  [3209] = {.lex_state = 68},
  [3210] = {.lex_state = 68},
  [3211] = {.lex_state = 13},
  [3212] = {.lex_state = 68},
  [3213] = {.lex_state = 13},
  [3214] = {.lex_state = 13},
  [3215] = {.lex_state = 68},
  [3216] = {.lex_state = 68},
  [3217] = {.lex_state = 68},
  [3218] = {.lex_state = 68},
  [3219] = {.lex_state = 68},
  [3220] = {.lex_state = 13},
  [3221] = {.lex_state = 68},
  [3222] = {.lex_state = 13},
  [3223] = {.lex_state = 68},
  [3224] = {.lex_state = 13},
  [3225] = {.lex_state = 68},
  [3226] = {.lex_state = 13},
  [3227] = {.lex_state = 13},
  [3228] = {.lex_state = 68},
  [3229] = {.lex_state = 68},
  [3230] = {.lex_state = 68},
  [3231] = {.lex_state = 13},
  [3232] = {.lex_state = 13},
  [3233] = {.lex_state = 68},
  [3234] = {.lex_state = 68},
  [3235] = {.lex_state = 13},
  [3236] = {.lex_state = 68},
  [3237] = {.lex_state = 13},
  [3238] = {.lex_state = 13},
  [3239] = {.lex_state = 68},
  [3240] = {.lex_state = 68},
  [3241] = {.lex_state = 68},
  [3242] = {.lex_state = 68},
  [3243] = {.lex_state = 68},
  [3244] = {.lex_state = 68},
  [3245] = {.lex_state = 68},
  [3246] = {.lex_state = 68},
  [3247] = {.lex_state = 68},
  [3248] = {.lex_state = 68},
  [3249] = {.lex_state = 68},
  [3250] = {.lex_state = 68},
  [3251] = {.lex_state = 68},
  [3252] = {.lex_state = 68},
  [3253] = {.lex_state = 13},
  [3254] = {.lex_state = 5},
  [3255] = {.lex_state = 13},
  [3256] = {.lex_state = 18},
  [3257] = {.lex_state = 13},
  [3258] = {.lex_state = 13},
  [3259] = {.lex_state = 13},
  [3260] = {.lex_state = 68},
  [3261] = {.lex_state = 68},
  [3262] = {.lex_state = 68},
  [3263] = {.lex_state = 13},
  [3264] = {.lex_state = 13},
  [3265] = {.lex_state = 13},
  [3266] = {.lex_state = 68},
  [3267] = {.lex_state = 13},
  [3268] = {.lex_state = 13},
  [3269] = {.lex_state = 68},
  [3270] = {.lex_state = 13},
  [3271] = {.lex_state = 13},
  [3272] = {.lex_state = 13},
  [3273] = {.lex_state = 13},
  [3274] = {.lex_state = 13},
  [3275] = {.lex_state = 13},
  [3276] = {.lex_state = 68},
  [3277] = {.lex_state = 13},
  [3278] = {.lex_state = 13},
  [3279] = {.lex_state = 68},
  [3280] = {.lex_state = 13},
  [3281] = {.lex_state = 68},
  [3282] = {.lex_state = 13},
  [3283] = {.lex_state = 13},
  [3284] = {.lex_state = 13},
  [3285] = {.lex_state = 13},
  [3286] = {.lex_state = 13},
  [3287] = {.lex_state = 13},
  [3288] = {.lex_state = 68},
  [3289] = {.lex_state = 68},
  [3290] = {.lex_state = 68},
  [3291] = {.lex_state = 13},
  [3292] = {.lex_state = 68},
  [3293] = {.lex_state = 68},
  [3294] = {.lex_state = 68},
  [3295] = {.lex_state = 68},
  [3296] = {.lex_state = 13},
  [3297] = {.lex_state = 13},
  [3298] = {.lex_state = 68},
  [3299] = {.lex_state = 68},
  [3300] = {.lex_state = 68},
  [3301] = {.lex_state = 68},
  [3302] = {.lex_state = 13},
  [3303] = {.lex_state = 68},
  [3304] = {.lex_state = 13},
  [3305] = {.lex_state = 68},
  [3306] = {.lex_state = 13},
  [3307] = {.lex_state = 68},
  [3308] = {.lex_state = 68},
  [3309] = {.lex_state = 68},
  [3310] = {.lex_state = 68, .external_lex_state = 7},
  [3311] = {.lex_state = 69},
  [3312] = {.lex_state = 68},
  [3313] = {.lex_state = 13},
  [3314] = {.lex_state = 68},
  [3315] = {.lex_state = 68},
  [3316] = {.lex_state = 13},
  [3317] = {.lex_state = 68},
  [3318] = {.lex_state = 13},
  [3319] = {.lex_state = 13},
  [3320] = {.lex_state = 13},
  [3321] = {.lex_state = 13},
  [3322] = {.lex_state = 13},
  [3323] = {.lex_state = 68},
  [3324] = {.lex_state = 13},
  [3325] = {.lex_state = 13},
  [3326] = {.lex_state = 68, .external_lex_state = 7},
  [3327] = {.lex_state = 68},
  [3328] = {.lex_state = 68},
  [3329] = {.lex_state = 68},
  [3330] = {.lex_state = 18},
  [3331] = {.lex_state = 13},
  [3332] = {.lex_state = 13},
  [3333] = {.lex_state = 68},
  [3334] = {.lex_state = 13},
  [3335] = {.lex_state = 13},
  [3336] = {.lex_state = 13},
  [3337] = {.lex_state = 13},
  [3338] = {.lex_state = 13},
  [3339] = {.lex_state = 13},
  [3340] = {.lex_state = 68},
  [3341] = {.lex_state = 68},
  [3342] = {.lex_state = 68},
  [3343] = {.lex_state = 68},
  [3344] = {.lex_state = 13},
  [3345] = {.lex_state = 68},
  [3346] = {.lex_state = 68},
  [3347] = {.lex_state = 68, .external_lex_state = 8},
  [3348] = {.lex_state = 68},
  [3349] = {.lex_state = 68},
  [3350] = {.lex_state = 68},
  [3351] = {.lex_state = 68},
  [3352] = {.lex_state = 9},
  [3353] = {.lex_state = 68},
  [3354] = {.lex_state = 13},
  [3355] = {.lex_state = 69},
  [3356] = {.lex_state = 68},
  [3357] = {.lex_state = 18},
  [3358] = {.lex_state = 13},
  [3359] = {.lex_state = 13},
  [3360] = {.lex_state = 13},
  [3361] = {.lex_state = 68},
  [3362] = {.lex_state = 13},
  [3363] = {.lex_state = 68},
  [3364] = {.lex_state = 68},
  [3365] = {.lex_state = 18},
  [3366] = {.lex_state = 68},
  [3367] = {.lex_state = 68, .external_lex_state = 8},
  [3368] = {.lex_state = 13},
  [3369] = {.lex_state = 13},
  [3370] = {.lex_state = 69},
  [3371] = {.lex_state = 68},
  [3372] = {.lex_state = 68},
  [3373] = {.lex_state = 13},
  [3374] = {.lex_state = 13},
  [3375] = {.lex_state = 13},
  [3376] = {.lex_state = 68},
  [3377] = {.lex_state = 68},
  [3378] = {.lex_state = 68},
  [3379] = {.lex_state = 68},
  [3380] = {.lex_state = 68},
  [3381] = {.lex_state = 13},
  [3382] = {.lex_state = 68},
  [3383] = {.lex_state = 18},
  [3384] = {.lex_state = 68},
  [3385] = {.lex_state = 68},
  [3386] = {.lex_state = 68},
  [3387] = {.lex_state = 68, .external_lex_state = 8},
  [3388] = {.lex_state = 13},
  [3389] = {.lex_state = 68},
  [3390] = {.lex_state = 13},
  [3391] = {.lex_state = 18},
  [3392] = {.lex_state = 68},
  [3393] = {.lex_state = 68},
  [3394] = {.lex_state = 68},
  [3395] = {.lex_state = 68},
  [3396] = {.lex_state = 68},
  [3397] = {.lex_state = 18},
  [3398] = {.lex_state = 18},
  [3399] = {.lex_state = 68},
  [3400] = {.lex_state = 18},
  [3401] = {.lex_state = 68},
  [3402] = {.lex_state = 68},
  [3403] = {.lex_state = 68},
  [3404] = {.lex_state = 68},
  [3405] = {.lex_state = 13},
  [3406] = {.lex_state = 68},
  [3407] = {.lex_state = 68},
  [3408] = {.lex_state = 68},
  [3409] = {.lex_state = 13},
  [3410] = {.lex_state = 68},
  [3411] = {.lex_state = 69},
  [3412] = {.lex_state = 68},
  [3413] = {.lex_state = 68},
  [3414] = {.lex_state = 68},
  [3415] = {.lex_state = 68},
  [3416] = {.lex_state = 13},
  [3417] = {.lex_state = 68, .external_lex_state = 8},
  [3418] = {.lex_state = 68},
  [3419] = {.lex_state = 68},
  [3420] = {.lex_state = 68},
  [3421] = {.lex_state = 68},
  [3422] = {.lex_state = 68},
  [3423] = {.lex_state = 68},
  [3424] = {.lex_state = 68},
  [3425] = {.lex_state = 13},
  [3426] = {.lex_state = 13},
  [3427] = {.lex_state = 13},
  [3428] = {.lex_state = 68},
  [3429] = {.lex_state = 9},
  [3430] = {.lex_state = 13},
  [3431] = {.lex_state = 13},
  [3432] = {.lex_state = 68},
  [3433] = {.lex_state = 13},
  [3434] = {.lex_state = 68},
  [3435] = {.lex_state = 68},
  [3436] = {.lex_state = 68},
  [3437] = {.lex_state = 68},
  [3438] = {.lex_state = 68},
  [3439] = {.lex_state = 68},
  [3440] = {.lex_state = 68},
  [3441] = {.lex_state = 68},
  [3442] = {.lex_state = 68},
  [3443] = {.lex_state = 68},
  [3444] = {.lex_state = 68},
  [3445] = {.lex_state = 68},
  [3446] = {.lex_state = 68},
  [3447] = {.lex_state = 68},
  [3448] = {.lex_state = 68},
  [3449] = {.lex_state = 68, .external_lex_state = 7},
  [3450] = {.lex_state = 68},
  [3451] = {.lex_state = 13},
  [3452] = {.lex_state = 68},
  [3453] = {.lex_state = 68},
  [3454] = {.lex_state = 68},
  [3455] = {.lex_state = 68},
  [3456] = {.lex_state = 18},
  [3457] = {.lex_state = 18},
  [3458] = {.lex_state = 68},
  [3459] = {.lex_state = 68},
  [3460] = {.lex_state = 68},
  [3461] = {.lex_state = 68},
  [3462] = {.lex_state = 13},
  [3463] = {.lex_state = 68, .external_lex_state = 8},
  [3464] = {.lex_state = 68},
  [3465] = {.lex_state = 68},
  [3466] = {.lex_state = 68},
  [3467] = {.lex_state = 68},
  [3468] = {.lex_state = 69},
  [3469] = {.lex_state = 68},
  [3470] = {.lex_state = 68},
  [3471] = {.lex_state = 68},
  [3472] = {.lex_state = 68},
  [3473] = {.lex_state = 13},
  [3474] = {.lex_state = 68},
  [3475] = {.lex_state = 68},
  [3476] = {.lex_state = 68},
  [3477] = {.lex_state = 68},
  [3478] = {.lex_state = 68, .external_lex_state = 9},
  [3479] = {.lex_state = 68, .external_lex_state = 9},
  [3480] = {.lex_state = 68},
  [3481] = {.lex_state = 68, .external_lex_state = 9},
  [3482] = {.lex_state = 13},
  [3483] = {.lex_state = 163},
  [3484] = {.lex_state = 68, .external_lex_state = 7},
  [3485] = {.lex_state = 68},
  [3486] = {.lex_state = 18},
  [3487] = {.lex_state = 68},
  [3488] = {.lex_state = 68},
  [3489] = {.lex_state = 68},
  [3490] = {.lex_state = 68},
  [3491] = {.lex_state = 68},
  [3492] = {.lex_state = 68},
  [3493] = {.lex_state = 68},
  [3494] = {.lex_state = 68},
  [3495] = {.lex_state = 13},
  [3496] = {.lex_state = 68},
  [3497] = {.lex_state = 68},
  [3498] = {.lex_state = 68},
  [3499] = {.lex_state = 68},
  [3500] = {.lex_state = 68},
  [3501] = {.lex_state = 13},
  [3502] = {.lex_state = 68},
  [3503] = {.lex_state = 68, .external_lex_state = 7},
  [3504] = {.lex_state = 68},
  [3505] = {.lex_state = 68},
  [3506] = {.lex_state = 68},
  [3507] = {.lex_state = 68},
  [3508] = {.lex_state = 68},
  [3509] = {.lex_state = 68, .external_lex_state = 7},
  [3510] = {.lex_state = 68},
  [3511] = {.lex_state = 68},
  [3512] = {.lex_state = 68},
  [3513] = {.lex_state = 68},
  [3514] = {.lex_state = 68},
  [3515] = {.lex_state = 68},
  [3516] = {.lex_state = 68},
  [3517] = {.lex_state = 68},
  [3518] = {.lex_state = 68},
  [3519] = {.lex_state = 68},
  [3520] = {.lex_state = 68},
  [3521] = {.lex_state = 68},
  [3522] = {.lex_state = 68},
  [3523] = {.lex_state = 13},
  [3524] = {.lex_state = 18},
  [3525] = {.lex_state = 18},
  [3526] = {.lex_state = 68},
  [3527] = {.lex_state = 68},
  [3528] = {.lex_state = 68},
  [3529] = {.lex_state = 18},
  [3530] = {.lex_state = 18},
  [3531] = {.lex_state = 13},
  [3532] = {.lex_state = 68},
  [3533] = {.lex_state = 69},
  [3534] = {.lex_state = 68},
  [3535] = {.lex_state = 18},
  [3536] = {.lex_state = 13},
  [3537] = {.lex_state = 13},
  [3538] = {.lex_state = 13},
  [3539] = {.lex_state = 68},
  [3540] = {.lex_state = 13},
  [3541] = {.lex_state = 69},
  [3542] = {.lex_state = 13},
  [3543] = {.lex_state = 68},
  [3544] = {.lex_state = 18},
  [3545] = {.lex_state = 18},
  [3546] = {.lex_state = 13},
  [3547] = {.lex_state = 68},
  [3548] = {.lex_state = 69},
  [3549] = {.lex_state = 18},
  [3550] = {.lex_state = 68},
  [3551] = {.lex_state = 68},
  [3552] = {.lex_state = 68},
  [3553] = {.lex_state = 68},
  [3554] = {.lex_state = 68},
  [3555] = {.lex_state = 18},
  [3556] = {.lex_state = 13},
  [3557] = {.lex_state = 68},
  [3558] = {.lex_state = 68},
  [3559] = {.lex_state = 68},
  [3560] = {.lex_state = 68},
  [3561] = {.lex_state = 13},
  [3562] = {.lex_state = 68},
  [3563] = {.lex_state = 68},
  [3564] = {.lex_state = 68},
  [3565] = {.lex_state = 13},
  [3566] = {.lex_state = 68},
  [3567] = {.lex_state = 18},
  [3568] = {.lex_state = 68},
  [3569] = {.lex_state = 18},
  [3570] = {.lex_state = 68},
  [3571] = {.lex_state = 68},
  [3572] = {.lex_state = 18},
  [3573] = {.lex_state = 68, .external_lex_state = 8},
  [3574] = {.lex_state = 68},
  [3575] = {.lex_state = 18},
  [3576] = {.lex_state = 18},
  [3577] = {.lex_state = 68},
  [3578] = {.lex_state = 13},
  [3579] = {.lex_state = 18},
  [3580] = {.lex_state = 18},
  [3581] = {.lex_state = 18},
  [3582] = {.lex_state = 13},
  [3583] = {.lex_state = 13},
  [3584] = {.lex_state = 68},
  [3585] = {.lex_state = 68},
  [3586] = {.lex_state = 13},
  [3587] = {.lex_state = 13},
  [3588] = {.lex_state = 68},
  [3589] = {.lex_state = 13},
  [3590] = {.lex_state = 13},
  [3591] = {.lex_state = 68},
  [3592] = {.lex_state = 13},
  [3593] = {.lex_state = 13},
  [3594] = {.lex_state = 68},
  [3595] = {(TSStateId)(-1)},
  [3596] = {(TSStateId)(-1)},
  [3597] = {(TSStateId)(-1)},
  [3598] = {(TSStateId)(-1)},
  [3599] = {(TSStateId)(-1)},
  [3600] = {(TSStateId)(-1)},
  [3601] = {(TSStateId)(-1)},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_line_comment] = STATE(0),
    [sym_block_comment] = STATE(0),
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_macro_rules_BANG] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_block] = ACTIONS(1),
    [anon_sym_expr] = ACTIONS(1),
    [anon_sym_ident] = ACTIONS(1),
    [anon_sym_item] = ACTIONS(1),
    [anon_sym_lifetime] = ACTIONS(1),
    [anon_sym_literal] = ACTIONS(1),
    [anon_sym_meta] = ACTIONS(1),
    [anon_sym_pat] = ACTIONS(1),
    [anon_sym_path] = ACTIONS(1),
    [anon_sym_stmt] = ACTIONS(1),
    [anon_sym_tt] = ACTIONS(1),
    [anon_sym_ty] = ACTIONS(1),
    [anon_sym_vis] = ACTIONS(1),
    [anon_sym_u8] = ACTIONS(1),
    [anon_sym_i8] = ACTIONS(1),
    [anon_sym_u16] = ACTIONS(1),
    [anon_sym_i16] = ACTIONS(1),
    [anon_sym_u32] = ACTIONS(1),
    [anon_sym_i32] = ACTIONS(1),
    [anon_sym_u64] = ACTIONS(1),
    [anon_sym_i64] = ACTIONS(1),
    [anon_sym_u128] = ACTIONS(1),
    [anon_sym_i128] = ACTIONS(1),
    [anon_sym_isize] = ACTIONS(1),
    [anon_sym_usize] = ACTIONS(1),
    [anon_sym_f32] = ACTIONS(1),
    [anon_sym_f64] = ACTIONS(1),
    [anon_sym_bool] = ACTIONS(1),
    [anon_sym_str] = ACTIONS(1),
    [anon_sym_char] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym__] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_DOT_DOT] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_fn] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_impl] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_loop] = ACTIONS(1),
    [anon_sym_match] = ACTIONS(1),
    [anon_sym_mod] = ACTIONS(1),
    [anon_sym_pub] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_struct] = ACTIONS(1),
    [anon_sym_trait] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_union] = ACTIONS(1),
    [anon_sym_unsafe] = ACTIONS(1),
    [anon_sym_use] = ACTIONS(1),
    [anon_sym_where] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_extern] = ACTIONS(1),
    [anon_sym_ref] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_LT2] = ACTIONS(1),
    [anon_sym_dyn] = ACTIONS(1),
    [sym_mutable_specifier] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [anon_sym_move] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [sym_integer_literal] = ACTIONS(1),
    [aux_sym_string_literal_token1] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [sym_char_literal] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [sym__inner_line_doc_comment_marker] = ACTIONS(1),
    [sym__outer_line_doc_comment_marker] = ACTIONS(1),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [sym_shebang] = ACTIONS(1),
    [sym_self] = ACTIONS(1),
    [sym_super] = ACTIONS(1),
    [sym_crate] = ACTIONS(1),
    [sym_metavariable] = ACTIONS(1),
    [sym_string_content] = ACTIONS(1),
    [sym__raw_string_literal_start] = ACTIONS(1),
    [sym_raw_string_literal_content] = ACTIONS(1),
    [sym__raw_string_literal_end] = ACTIONS(1),
    [sym_float_literal] = ACTIONS(1),
    [sym__outer_block_doc_comment_marker] = ACTIONS(1),
    [sym__inner_block_doc_comment_marker] = ACTIONS(1),
    [sym__block_comment_content] = ACTIONS(1),
    [sym__line_doc_content] = ACTIONS(1),
    [sym__error_sentinel] = ACTIONS(1),
  },
  [1] = {
    [sym_source_file] = STATE(3502),
    [sym__statement] = STATE(725),
    [sym_empty_statement] = STATE(744),
    [sym_expression_statement] = STATE(744),
    [sym_macro_definition] = STATE(744),
    [sym_attribute_item] = STATE(744),
    [sym_inner_attribute_item] = STATE(744),
    [sym_mod_item] = STATE(744),
    [sym_foreign_mod_item] = STATE(744),
    [sym_struct_item] = STATE(744),
    [sym_union_item] = STATE(744),
    [sym_enum_item] = STATE(744),
    [sym_extern_crate_declaration] = STATE(744),
    [sym_const_item] = STATE(744),
    [sym_static_item] = STATE(744),
    [sym_type_item] = STATE(744),
    [sym_function_item] = STATE(744),
    [sym_function_signature_item] = STATE(744),
    [sym_function_modifiers] = STATE(3501),
    [sym_impl_item] = STATE(744),
    [sym_trait_item] = STATE(744),
    [sym_associated_type] = STATE(744),
    [sym_let_declaration] = STATE(744),
    [sym_use_declaration] = STATE(744),
    [sym_extern_modifier] = STATE(2155),
    [sym_visibility_modifier] = STATE(1926),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1852),
    [sym_macro_invocation] = STATE(397),
    [sym_scoped_identifier] = STATE(1519),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(378),
    [sym_match_expression] = STATE(378),
    [sym_while_expression] = STATE(378),
    [sym_loop_expression] = STATE(378),
    [sym_for_expression] = STATE(378),
    [sym_const_block] = STATE(378),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3486),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(378),
    [sym_async_block] = STATE(378),
    [sym_try_block] = STATE(378),
    [sym_block] = STATE(378),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(1),
    [sym_block_comment] = STATE(1),
    [aux_sym_source_file_repeat1] = STATE(6),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [ts_builtin_sym_end] = ACTIONS(7),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(35),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_shebang] = ACTIONS(105),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [2] = {
    [sym__statement] = STATE(725),
    [sym_empty_statement] = STATE(744),
    [sym_expression_statement] = STATE(744),
    [sym_macro_definition] = STATE(744),
    [sym_attribute_item] = STATE(744),
    [sym_inner_attribute_item] = STATE(744),
    [sym_mod_item] = STATE(744),
    [sym_foreign_mod_item] = STATE(744),
    [sym_struct_item] = STATE(744),
    [sym_union_item] = STATE(744),
    [sym_enum_item] = STATE(744),
    [sym_extern_crate_declaration] = STATE(744),
    [sym_const_item] = STATE(744),
    [sym_static_item] = STATE(744),
    [sym_type_item] = STATE(744),
    [sym_function_item] = STATE(744),
    [sym_function_signature_item] = STATE(744),
    [sym_function_modifiers] = STATE(3501),
    [sym_impl_item] = STATE(744),
    [sym_trait_item] = STATE(744),
    [sym_associated_type] = STATE(744),
    [sym_let_declaration] = STATE(744),
    [sym_use_declaration] = STATE(744),
    [sym_extern_modifier] = STATE(2155),
    [sym_visibility_modifier] = STATE(1926),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1779),
    [sym_macro_invocation] = STATE(397),
    [sym_scoped_identifier] = STATE(1519),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(378),
    [sym_match_expression] = STATE(378),
    [sym_while_expression] = STATE(378),
    [sym_loop_expression] = STATE(378),
    [sym_for_expression] = STATE(378),
    [sym_const_block] = STATE(378),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3486),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(378),
    [sym_async_block] = STATE(378),
    [sym_try_block] = STATE(378),
    [sym_block] = STATE(378),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(2),
    [sym_block_comment] = STATE(2),
    [aux_sym_source_file_repeat1] = STATE(9),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(117),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [3] = {
    [sym__statement] = STATE(725),
    [sym_empty_statement] = STATE(744),
    [sym_expression_statement] = STATE(744),
    [sym_macro_definition] = STATE(744),
    [sym_attribute_item] = STATE(744),
    [sym_inner_attribute_item] = STATE(744),
    [sym_mod_item] = STATE(744),
    [sym_foreign_mod_item] = STATE(744),
    [sym_struct_item] = STATE(744),
    [sym_union_item] = STATE(744),
    [sym_enum_item] = STATE(744),
    [sym_extern_crate_declaration] = STATE(744),
    [sym_const_item] = STATE(744),
    [sym_static_item] = STATE(744),
    [sym_type_item] = STATE(744),
    [sym_function_item] = STATE(744),
    [sym_function_signature_item] = STATE(744),
    [sym_function_modifiers] = STATE(3501),
    [sym_impl_item] = STATE(744),
    [sym_trait_item] = STATE(744),
    [sym_associated_type] = STATE(744),
    [sym_let_declaration] = STATE(744),
    [sym_use_declaration] = STATE(744),
    [sym_extern_modifier] = STATE(2155),
    [sym_visibility_modifier] = STATE(1926),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1852),
    [sym_macro_invocation] = STATE(397),
    [sym_scoped_identifier] = STATE(1519),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(378),
    [sym_match_expression] = STATE(378),
    [sym_while_expression] = STATE(378),
    [sym_loop_expression] = STATE(378),
    [sym_for_expression] = STATE(378),
    [sym_const_block] = STATE(378),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3486),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(378),
    [sym_async_block] = STATE(378),
    [sym_try_block] = STATE(378),
    [sym_block] = STATE(378),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(3),
    [sym_block_comment] = STATE(3),
    [aux_sym_source_file_repeat1] = STATE(23),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [ts_builtin_sym_end] = ACTIONS(121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [4] = {
    [sym__statement] = STATE(725),
    [sym_empty_statement] = STATE(744),
    [sym_expression_statement] = STATE(744),
    [sym_macro_definition] = STATE(744),
    [sym_attribute_item] = STATE(744),
    [sym_inner_attribute_item] = STATE(744),
    [sym_mod_item] = STATE(744),
    [sym_foreign_mod_item] = STATE(744),
    [sym_struct_item] = STATE(744),
    [sym_union_item] = STATE(744),
    [sym_enum_item] = STATE(744),
    [sym_extern_crate_declaration] = STATE(744),
    [sym_const_item] = STATE(744),
    [sym_static_item] = STATE(744),
    [sym_type_item] = STATE(744),
    [sym_function_item] = STATE(744),
    [sym_function_signature_item] = STATE(744),
    [sym_function_modifiers] = STATE(3501),
    [sym_impl_item] = STATE(744),
    [sym_trait_item] = STATE(744),
    [sym_associated_type] = STATE(744),
    [sym_let_declaration] = STATE(744),
    [sym_use_declaration] = STATE(744),
    [sym_extern_modifier] = STATE(2155),
    [sym_visibility_modifier] = STATE(1926),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1811),
    [sym_macro_invocation] = STATE(397),
    [sym_scoped_identifier] = STATE(1519),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(378),
    [sym_match_expression] = STATE(378),
    [sym_while_expression] = STATE(378),
    [sym_loop_expression] = STATE(378),
    [sym_for_expression] = STATE(378),
    [sym_const_block] = STATE(378),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3486),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(378),
    [sym_async_block] = STATE(378),
    [sym_try_block] = STATE(378),
    [sym_block] = STATE(378),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(4),
    [sym_block_comment] = STATE(4),
    [aux_sym_source_file_repeat1] = STATE(16),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [5] = {
    [sym__statement] = STATE(725),
    [sym_empty_statement] = STATE(744),
    [sym_expression_statement] = STATE(744),
    [sym_macro_definition] = STATE(744),
    [sym_attribute_item] = STATE(744),
    [sym_inner_attribute_item] = STATE(744),
    [sym_mod_item] = STATE(744),
    [sym_foreign_mod_item] = STATE(744),
    [sym_struct_item] = STATE(744),
    [sym_union_item] = STATE(744),
    [sym_enum_item] = STATE(744),
    [sym_extern_crate_declaration] = STATE(744),
    [sym_const_item] = STATE(744),
    [sym_static_item] = STATE(744),
    [sym_type_item] = STATE(744),
    [sym_function_item] = STATE(744),
    [sym_function_signature_item] = STATE(744),
    [sym_function_modifiers] = STATE(3501),
    [sym_impl_item] = STATE(744),
    [sym_trait_item] = STATE(744),
    [sym_associated_type] = STATE(744),
    [sym_let_declaration] = STATE(744),
    [sym_use_declaration] = STATE(744),
    [sym_extern_modifier] = STATE(2155),
    [sym_visibility_modifier] = STATE(1926),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1706),
    [sym_macro_invocation] = STATE(397),
    [sym_scoped_identifier] = STATE(1519),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(378),
    [sym_match_expression] = STATE(378),
    [sym_while_expression] = STATE(378),
    [sym_loop_expression] = STATE(378),
    [sym_for_expression] = STATE(378),
    [sym_const_block] = STATE(378),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3486),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(378),
    [sym_async_block] = STATE(378),
    [sym_try_block] = STATE(378),
    [sym_block] = STATE(378),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(5),
    [sym_block_comment] = STATE(5),
    [aux_sym_source_file_repeat1] = STATE(13),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(125),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [6] = {
    [sym__statement] = STATE(725),
    [sym_empty_statement] = STATE(744),
    [sym_expression_statement] = STATE(744),
    [sym_macro_definition] = STATE(744),
    [sym_attribute_item] = STATE(744),
    [sym_inner_attribute_item] = STATE(744),
    [sym_mod_item] = STATE(744),
    [sym_foreign_mod_item] = STATE(744),
    [sym_struct_item] = STATE(744),
    [sym_union_item] = STATE(744),
    [sym_enum_item] = STATE(744),
    [sym_extern_crate_declaration] = STATE(744),
    [sym_const_item] = STATE(744),
    [sym_static_item] = STATE(744),
    [sym_type_item] = STATE(744),
    [sym_function_item] = STATE(744),
    [sym_function_signature_item] = STATE(744),
    [sym_function_modifiers] = STATE(3501),
    [sym_impl_item] = STATE(744),
    [sym_trait_item] = STATE(744),
    [sym_associated_type] = STATE(744),
    [sym_let_declaration] = STATE(744),
    [sym_use_declaration] = STATE(744),
    [sym_extern_modifier] = STATE(2155),
    [sym_visibility_modifier] = STATE(1926),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1852),
    [sym_macro_invocation] = STATE(397),
    [sym_scoped_identifier] = STATE(1519),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(378),
    [sym_match_expression] = STATE(378),
    [sym_while_expression] = STATE(378),
    [sym_loop_expression] = STATE(378),
    [sym_for_expression] = STATE(378),
    [sym_const_block] = STATE(378),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3486),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(378),
    [sym_async_block] = STATE(378),
    [sym_try_block] = STATE(378),
    [sym_block] = STATE(378),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(6),
    [sym_block_comment] = STATE(6),
    [aux_sym_source_file_repeat1] = STATE(23),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [ts_builtin_sym_end] = ACTIONS(127),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [7] = {
    [sym__statement] = STATE(725),
    [sym_empty_statement] = STATE(744),
    [sym_expression_statement] = STATE(744),
    [sym_macro_definition] = STATE(744),
    [sym_attribute_item] = STATE(744),
    [sym_inner_attribute_item] = STATE(744),
    [sym_mod_item] = STATE(744),
    [sym_foreign_mod_item] = STATE(744),
    [sym_struct_item] = STATE(744),
    [sym_union_item] = STATE(744),
    [sym_enum_item] = STATE(744),
    [sym_extern_crate_declaration] = STATE(744),
    [sym_const_item] = STATE(744),
    [sym_static_item] = STATE(744),
    [sym_type_item] = STATE(744),
    [sym_function_item] = STATE(744),
    [sym_function_signature_item] = STATE(744),
    [sym_function_modifiers] = STATE(3501),
    [sym_impl_item] = STATE(744),
    [sym_trait_item] = STATE(744),
    [sym_associated_type] = STATE(744),
    [sym_let_declaration] = STATE(744),
    [sym_use_declaration] = STATE(744),
    [sym_extern_modifier] = STATE(2155),
    [sym_visibility_modifier] = STATE(1926),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1694),
    [sym_macro_invocation] = STATE(397),
    [sym_scoped_identifier] = STATE(1519),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(378),
    [sym_match_expression] = STATE(378),
    [sym_while_expression] = STATE(378),
    [sym_loop_expression] = STATE(378),
    [sym_for_expression] = STATE(378),
    [sym_const_block] = STATE(378),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3486),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(378),
    [sym_async_block] = STATE(378),
    [sym_try_block] = STATE(378),
    [sym_block] = STATE(378),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(7),
    [sym_block_comment] = STATE(7),
    [aux_sym_source_file_repeat1] = STATE(33),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [8] = {
    [sym__statement] = STATE(725),
    [sym_empty_statement] = STATE(744),
    [sym_expression_statement] = STATE(744),
    [sym_macro_definition] = STATE(744),
    [sym_attribute_item] = STATE(744),
    [sym_inner_attribute_item] = STATE(744),
    [sym_mod_item] = STATE(744),
    [sym_foreign_mod_item] = STATE(744),
    [sym_struct_item] = STATE(744),
    [sym_union_item] = STATE(744),
    [sym_enum_item] = STATE(744),
    [sym_extern_crate_declaration] = STATE(744),
    [sym_const_item] = STATE(744),
    [sym_static_item] = STATE(744),
    [sym_type_item] = STATE(744),
    [sym_function_item] = STATE(744),
    [sym_function_signature_item] = STATE(744),
    [sym_function_modifiers] = STATE(3501),
    [sym_impl_item] = STATE(744),
    [sym_trait_item] = STATE(744),
    [sym_associated_type] = STATE(744),
    [sym_let_declaration] = STATE(744),
    [sym_use_declaration] = STATE(744),
    [sym_extern_modifier] = STATE(2155),
    [sym_visibility_modifier] = STATE(1926),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1743),
    [sym_macro_invocation] = STATE(397),
    [sym_scoped_identifier] = STATE(1519),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(378),
    [sym_match_expression] = STATE(378),
    [sym_while_expression] = STATE(378),
    [sym_loop_expression] = STATE(378),
    [sym_for_expression] = STATE(378),
    [sym_const_block] = STATE(378),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3486),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(378),
    [sym_async_block] = STATE(378),
    [sym_try_block] = STATE(378),
    [sym_block] = STATE(378),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(8),
    [sym_block_comment] = STATE(8),
    [aux_sym_source_file_repeat1] = STATE(26),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(131),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [9] = {
    [sym__statement] = STATE(725),
    [sym_empty_statement] = STATE(744),
    [sym_expression_statement] = STATE(744),
    [sym_macro_definition] = STATE(744),
    [sym_attribute_item] = STATE(744),
    [sym_inner_attribute_item] = STATE(744),
    [sym_mod_item] = STATE(744),
    [sym_foreign_mod_item] = STATE(744),
    [sym_struct_item] = STATE(744),
    [sym_union_item] = STATE(744),
    [sym_enum_item] = STATE(744),
    [sym_extern_crate_declaration] = STATE(744),
    [sym_const_item] = STATE(744),
    [sym_static_item] = STATE(744),
    [sym_type_item] = STATE(744),
    [sym_function_item] = STATE(744),
    [sym_function_signature_item] = STATE(744),
    [sym_function_modifiers] = STATE(3501),
    [sym_impl_item] = STATE(744),
    [sym_trait_item] = STATE(744),
    [sym_associated_type] = STATE(744),
    [sym_let_declaration] = STATE(744),
    [sym_use_declaration] = STATE(744),
    [sym_extern_modifier] = STATE(2155),
    [sym_visibility_modifier] = STATE(1926),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1788),
    [sym_macro_invocation] = STATE(397),
    [sym_scoped_identifier] = STATE(1519),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(378),
    [sym_match_expression] = STATE(378),
    [sym_while_expression] = STATE(378),
    [sym_loop_expression] = STATE(378),
    [sym_for_expression] = STATE(378),
    [sym_const_block] = STATE(378),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3486),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(378),
    [sym_async_block] = STATE(378),
    [sym_try_block] = STATE(378),
    [sym_block] = STATE(378),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(9),
    [sym_block_comment] = STATE(9),
    [aux_sym_source_file_repeat1] = STATE(22),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [10] = {
    [sym__statement] = STATE(725),
    [sym_empty_statement] = STATE(744),
    [sym_expression_statement] = STATE(744),
    [sym_macro_definition] = STATE(744),
    [sym_attribute_item] = STATE(744),
    [sym_inner_attribute_item] = STATE(744),
    [sym_mod_item] = STATE(744),
    [sym_foreign_mod_item] = STATE(744),
    [sym_struct_item] = STATE(744),
    [sym_union_item] = STATE(744),
    [sym_enum_item] = STATE(744),
    [sym_extern_crate_declaration] = STATE(744),
    [sym_const_item] = STATE(744),
    [sym_static_item] = STATE(744),
    [sym_type_item] = STATE(744),
    [sym_function_item] = STATE(744),
    [sym_function_signature_item] = STATE(744),
    [sym_function_modifiers] = STATE(3501),
    [sym_impl_item] = STATE(744),
    [sym_trait_item] = STATE(744),
    [sym_associated_type] = STATE(744),
    [sym_let_declaration] = STATE(744),
    [sym_use_declaration] = STATE(744),
    [sym_extern_modifier] = STATE(2155),
    [sym_visibility_modifier] = STATE(1926),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1656),
    [sym_macro_invocation] = STATE(397),
    [sym_scoped_identifier] = STATE(1519),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(378),
    [sym_match_expression] = STATE(378),
    [sym_while_expression] = STATE(378),
    [sym_loop_expression] = STATE(378),
    [sym_for_expression] = STATE(378),
    [sym_const_block] = STATE(378),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3486),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(378),
    [sym_async_block] = STATE(378),
    [sym_try_block] = STATE(378),
    [sym_block] = STATE(378),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(10),
    [sym_block_comment] = STATE(10),
    [aux_sym_source_file_repeat1] = STATE(34),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [11] = {
    [sym__statement] = STATE(725),
    [sym_empty_statement] = STATE(744),
    [sym_expression_statement] = STATE(744),
    [sym_macro_definition] = STATE(744),
    [sym_attribute_item] = STATE(744),
    [sym_inner_attribute_item] = STATE(744),
    [sym_mod_item] = STATE(744),
    [sym_foreign_mod_item] = STATE(744),
    [sym_struct_item] = STATE(744),
    [sym_union_item] = STATE(744),
    [sym_enum_item] = STATE(744),
    [sym_extern_crate_declaration] = STATE(744),
    [sym_const_item] = STATE(744),
    [sym_static_item] = STATE(744),
    [sym_type_item] = STATE(744),
    [sym_function_item] = STATE(744),
    [sym_function_signature_item] = STATE(744),
    [sym_function_modifiers] = STATE(3501),
    [sym_impl_item] = STATE(744),
    [sym_trait_item] = STATE(744),
    [sym_associated_type] = STATE(744),
    [sym_let_declaration] = STATE(744),
    [sym_use_declaration] = STATE(744),
    [sym_extern_modifier] = STATE(2155),
    [sym_visibility_modifier] = STATE(1926),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1721),
    [sym_macro_invocation] = STATE(397),
    [sym_scoped_identifier] = STATE(1519),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(378),
    [sym_match_expression] = STATE(378),
    [sym_while_expression] = STATE(378),
    [sym_loop_expression] = STATE(378),
    [sym_for_expression] = STATE(378),
    [sym_const_block] = STATE(378),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3486),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(378),
    [sym_async_block] = STATE(378),
    [sym_try_block] = STATE(378),
    [sym_block] = STATE(378),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(11),
    [sym_block_comment] = STATE(11),
    [aux_sym_source_file_repeat1] = STATE(22),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [12] = {
    [sym__statement] = STATE(725),
    [sym_empty_statement] = STATE(744),
    [sym_expression_statement] = STATE(744),
    [sym_macro_definition] = STATE(744),
    [sym_attribute_item] = STATE(744),
    [sym_inner_attribute_item] = STATE(744),
    [sym_mod_item] = STATE(744),
    [sym_foreign_mod_item] = STATE(744),
    [sym_struct_item] = STATE(744),
    [sym_union_item] = STATE(744),
    [sym_enum_item] = STATE(744),
    [sym_extern_crate_declaration] = STATE(744),
    [sym_const_item] = STATE(744),
    [sym_static_item] = STATE(744),
    [sym_type_item] = STATE(744),
    [sym_function_item] = STATE(744),
    [sym_function_signature_item] = STATE(744),
    [sym_function_modifiers] = STATE(3501),
    [sym_impl_item] = STATE(744),
    [sym_trait_item] = STATE(744),
    [sym_associated_type] = STATE(744),
    [sym_let_declaration] = STATE(744),
    [sym_use_declaration] = STATE(744),
    [sym_extern_modifier] = STATE(2155),
    [sym_visibility_modifier] = STATE(1926),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1737),
    [sym_macro_invocation] = STATE(397),
    [sym_scoped_identifier] = STATE(1519),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(378),
    [sym_match_expression] = STATE(378),
    [sym_while_expression] = STATE(378),
    [sym_loop_expression] = STATE(378),
    [sym_for_expression] = STATE(378),
    [sym_const_block] = STATE(378),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3486),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(378),
    [sym_async_block] = STATE(378),
    [sym_try_block] = STATE(378),
    [sym_block] = STATE(378),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(12),
    [sym_block_comment] = STATE(12),
    [aux_sym_source_file_repeat1] = STATE(22),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [13] = {
    [sym__statement] = STATE(725),
    [sym_empty_statement] = STATE(744),
    [sym_expression_statement] = STATE(744),
    [sym_macro_definition] = STATE(744),
    [sym_attribute_item] = STATE(744),
    [sym_inner_attribute_item] = STATE(744),
    [sym_mod_item] = STATE(744),
    [sym_foreign_mod_item] = STATE(744),
    [sym_struct_item] = STATE(744),
    [sym_union_item] = STATE(744),
    [sym_enum_item] = STATE(744),
    [sym_extern_crate_declaration] = STATE(744),
    [sym_const_item] = STATE(744),
    [sym_static_item] = STATE(744),
    [sym_type_item] = STATE(744),
    [sym_function_item] = STATE(744),
    [sym_function_signature_item] = STATE(744),
    [sym_function_modifiers] = STATE(3501),
    [sym_impl_item] = STATE(744),
    [sym_trait_item] = STATE(744),
    [sym_associated_type] = STATE(744),
    [sym_let_declaration] = STATE(744),
    [sym_use_declaration] = STATE(744),
    [sym_extern_modifier] = STATE(2155),
    [sym_visibility_modifier] = STATE(1926),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1693),
    [sym_macro_invocation] = STATE(397),
    [sym_scoped_identifier] = STATE(1519),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(378),
    [sym_match_expression] = STATE(378),
    [sym_while_expression] = STATE(378),
    [sym_loop_expression] = STATE(378),
    [sym_for_expression] = STATE(378),
    [sym_const_block] = STATE(378),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3486),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(378),
    [sym_async_block] = STATE(378),
    [sym_try_block] = STATE(378),
    [sym_block] = STATE(378),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(13),
    [sym_block_comment] = STATE(13),
    [aux_sym_source_file_repeat1] = STATE(22),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(141),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [14] = {
    [sym__statement] = STATE(725),
    [sym_empty_statement] = STATE(744),
    [sym_expression_statement] = STATE(744),
    [sym_macro_definition] = STATE(744),
    [sym_attribute_item] = STATE(744),
    [sym_inner_attribute_item] = STATE(744),
    [sym_mod_item] = STATE(744),
    [sym_foreign_mod_item] = STATE(744),
    [sym_struct_item] = STATE(744),
    [sym_union_item] = STATE(744),
    [sym_enum_item] = STATE(744),
    [sym_extern_crate_declaration] = STATE(744),
    [sym_const_item] = STATE(744),
    [sym_static_item] = STATE(744),
    [sym_type_item] = STATE(744),
    [sym_function_item] = STATE(744),
    [sym_function_signature_item] = STATE(744),
    [sym_function_modifiers] = STATE(3501),
    [sym_impl_item] = STATE(744),
    [sym_trait_item] = STATE(744),
    [sym_associated_type] = STATE(744),
    [sym_let_declaration] = STATE(744),
    [sym_use_declaration] = STATE(744),
    [sym_extern_modifier] = STATE(2155),
    [sym_visibility_modifier] = STATE(1926),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1731),
    [sym_macro_invocation] = STATE(397),
    [sym_scoped_identifier] = STATE(1519),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(378),
    [sym_match_expression] = STATE(378),
    [sym_while_expression] = STATE(378),
    [sym_loop_expression] = STATE(378),
    [sym_for_expression] = STATE(378),
    [sym_const_block] = STATE(378),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3486),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(378),
    [sym_async_block] = STATE(378),
    [sym_try_block] = STATE(378),
    [sym_block] = STATE(378),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(14),
    [sym_block_comment] = STATE(14),
    [aux_sym_source_file_repeat1] = STATE(15),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(143),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [15] = {
    [sym__statement] = STATE(725),
    [sym_empty_statement] = STATE(744),
    [sym_expression_statement] = STATE(744),
    [sym_macro_definition] = STATE(744),
    [sym_attribute_item] = STATE(744),
    [sym_inner_attribute_item] = STATE(744),
    [sym_mod_item] = STATE(744),
    [sym_foreign_mod_item] = STATE(744),
    [sym_struct_item] = STATE(744),
    [sym_union_item] = STATE(744),
    [sym_enum_item] = STATE(744),
    [sym_extern_crate_declaration] = STATE(744),
    [sym_const_item] = STATE(744),
    [sym_static_item] = STATE(744),
    [sym_type_item] = STATE(744),
    [sym_function_item] = STATE(744),
    [sym_function_signature_item] = STATE(744),
    [sym_function_modifiers] = STATE(3501),
    [sym_impl_item] = STATE(744),
    [sym_trait_item] = STATE(744),
    [sym_associated_type] = STATE(744),
    [sym_let_declaration] = STATE(744),
    [sym_use_declaration] = STATE(744),
    [sym_extern_modifier] = STATE(2155),
    [sym_visibility_modifier] = STATE(1926),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1740),
    [sym_macro_invocation] = STATE(397),
    [sym_scoped_identifier] = STATE(1519),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(378),
    [sym_match_expression] = STATE(378),
    [sym_while_expression] = STATE(378),
    [sym_loop_expression] = STATE(378),
    [sym_for_expression] = STATE(378),
    [sym_const_block] = STATE(378),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3486),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(378),
    [sym_async_block] = STATE(378),
    [sym_try_block] = STATE(378),
    [sym_block] = STATE(378),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(15),
    [sym_block_comment] = STATE(15),
    [aux_sym_source_file_repeat1] = STATE(22),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(145),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [16] = {
    [sym__statement] = STATE(725),
    [sym_empty_statement] = STATE(744),
    [sym_expression_statement] = STATE(744),
    [sym_macro_definition] = STATE(744),
    [sym_attribute_item] = STATE(744),
    [sym_inner_attribute_item] = STATE(744),
    [sym_mod_item] = STATE(744),
    [sym_foreign_mod_item] = STATE(744),
    [sym_struct_item] = STATE(744),
    [sym_union_item] = STATE(744),
    [sym_enum_item] = STATE(744),
    [sym_extern_crate_declaration] = STATE(744),
    [sym_const_item] = STATE(744),
    [sym_static_item] = STATE(744),
    [sym_type_item] = STATE(744),
    [sym_function_item] = STATE(744),
    [sym_function_signature_item] = STATE(744),
    [sym_function_modifiers] = STATE(3501),
    [sym_impl_item] = STATE(744),
    [sym_trait_item] = STATE(744),
    [sym_associated_type] = STATE(744),
    [sym_let_declaration] = STATE(744),
    [sym_use_declaration] = STATE(744),
    [sym_extern_modifier] = STATE(2155),
    [sym_visibility_modifier] = STATE(1926),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1814),
    [sym_macro_invocation] = STATE(397),
    [sym_scoped_identifier] = STATE(1519),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(378),
    [sym_match_expression] = STATE(378),
    [sym_while_expression] = STATE(378),
    [sym_loop_expression] = STATE(378),
    [sym_for_expression] = STATE(378),
    [sym_const_block] = STATE(378),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3486),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(378),
    [sym_async_block] = STATE(378),
    [sym_try_block] = STATE(378),
    [sym_block] = STATE(378),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(16),
    [sym_block_comment] = STATE(16),
    [aux_sym_source_file_repeat1] = STATE(22),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [17] = {
    [sym__statement] = STATE(725),
    [sym_empty_statement] = STATE(744),
    [sym_expression_statement] = STATE(744),
    [sym_macro_definition] = STATE(744),
    [sym_attribute_item] = STATE(744),
    [sym_inner_attribute_item] = STATE(744),
    [sym_mod_item] = STATE(744),
    [sym_foreign_mod_item] = STATE(744),
    [sym_struct_item] = STATE(744),
    [sym_union_item] = STATE(744),
    [sym_enum_item] = STATE(744),
    [sym_extern_crate_declaration] = STATE(744),
    [sym_const_item] = STATE(744),
    [sym_static_item] = STATE(744),
    [sym_type_item] = STATE(744),
    [sym_function_item] = STATE(744),
    [sym_function_signature_item] = STATE(744),
    [sym_function_modifiers] = STATE(3501),
    [sym_impl_item] = STATE(744),
    [sym_trait_item] = STATE(744),
    [sym_associated_type] = STATE(744),
    [sym_let_declaration] = STATE(744),
    [sym_use_declaration] = STATE(744),
    [sym_extern_modifier] = STATE(2155),
    [sym_visibility_modifier] = STATE(1926),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1707),
    [sym_macro_invocation] = STATE(397),
    [sym_scoped_identifier] = STATE(1519),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(378),
    [sym_match_expression] = STATE(378),
    [sym_while_expression] = STATE(378),
    [sym_loop_expression] = STATE(378),
    [sym_for_expression] = STATE(378),
    [sym_const_block] = STATE(378),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3486),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(378),
    [sym_async_block] = STATE(378),
    [sym_try_block] = STATE(378),
    [sym_block] = STATE(378),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(17),
    [sym_block_comment] = STATE(17),
    [aux_sym_source_file_repeat1] = STATE(22),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(149),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [18] = {
    [sym__statement] = STATE(725),
    [sym_empty_statement] = STATE(744),
    [sym_expression_statement] = STATE(744),
    [sym_macro_definition] = STATE(744),
    [sym_attribute_item] = STATE(744),
    [sym_inner_attribute_item] = STATE(744),
    [sym_mod_item] = STATE(744),
    [sym_foreign_mod_item] = STATE(744),
    [sym_struct_item] = STATE(744),
    [sym_union_item] = STATE(744),
    [sym_enum_item] = STATE(744),
    [sym_extern_crate_declaration] = STATE(744),
    [sym_const_item] = STATE(744),
    [sym_static_item] = STATE(744),
    [sym_type_item] = STATE(744),
    [sym_function_item] = STATE(744),
    [sym_function_signature_item] = STATE(744),
    [sym_function_modifiers] = STATE(3501),
    [sym_impl_item] = STATE(744),
    [sym_trait_item] = STATE(744),
    [sym_associated_type] = STATE(744),
    [sym_let_declaration] = STATE(744),
    [sym_use_declaration] = STATE(744),
    [sym_extern_modifier] = STATE(2155),
    [sym_visibility_modifier] = STATE(1926),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1800),
    [sym_macro_invocation] = STATE(397),
    [sym_scoped_identifier] = STATE(1519),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(378),
    [sym_match_expression] = STATE(378),
    [sym_while_expression] = STATE(378),
    [sym_loop_expression] = STATE(378),
    [sym_for_expression] = STATE(378),
    [sym_const_block] = STATE(378),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3486),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(378),
    [sym_async_block] = STATE(378),
    [sym_try_block] = STATE(378),
    [sym_block] = STATE(378),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(18),
    [sym_block_comment] = STATE(18),
    [aux_sym_source_file_repeat1] = STATE(17),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(151),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [19] = {
    [sym__statement] = STATE(725),
    [sym_empty_statement] = STATE(744),
    [sym_expression_statement] = STATE(744),
    [sym_macro_definition] = STATE(744),
    [sym_attribute_item] = STATE(744),
    [sym_inner_attribute_item] = STATE(744),
    [sym_mod_item] = STATE(744),
    [sym_foreign_mod_item] = STATE(744),
    [sym_struct_item] = STATE(744),
    [sym_union_item] = STATE(744),
    [sym_enum_item] = STATE(744),
    [sym_extern_crate_declaration] = STATE(744),
    [sym_const_item] = STATE(744),
    [sym_static_item] = STATE(744),
    [sym_type_item] = STATE(744),
    [sym_function_item] = STATE(744),
    [sym_function_signature_item] = STATE(744),
    [sym_function_modifiers] = STATE(3501),
    [sym_impl_item] = STATE(744),
    [sym_trait_item] = STATE(744),
    [sym_associated_type] = STATE(744),
    [sym_let_declaration] = STATE(744),
    [sym_use_declaration] = STATE(744),
    [sym_extern_modifier] = STATE(2155),
    [sym_visibility_modifier] = STATE(1926),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1827),
    [sym_macro_invocation] = STATE(397),
    [sym_scoped_identifier] = STATE(1519),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(378),
    [sym_match_expression] = STATE(378),
    [sym_while_expression] = STATE(378),
    [sym_loop_expression] = STATE(378),
    [sym_for_expression] = STATE(378),
    [sym_const_block] = STATE(378),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3486),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(378),
    [sym_async_block] = STATE(378),
    [sym_try_block] = STATE(378),
    [sym_block] = STATE(378),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(19),
    [sym_block_comment] = STATE(19),
    [aux_sym_source_file_repeat1] = STATE(31),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(153),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [20] = {
    [sym__statement] = STATE(725),
    [sym_empty_statement] = STATE(744),
    [sym_expression_statement] = STATE(744),
    [sym_macro_definition] = STATE(744),
    [sym_attribute_item] = STATE(744),
    [sym_inner_attribute_item] = STATE(744),
    [sym_mod_item] = STATE(744),
    [sym_foreign_mod_item] = STATE(744),
    [sym_struct_item] = STATE(744),
    [sym_union_item] = STATE(744),
    [sym_enum_item] = STATE(744),
    [sym_extern_crate_declaration] = STATE(744),
    [sym_const_item] = STATE(744),
    [sym_static_item] = STATE(744),
    [sym_type_item] = STATE(744),
    [sym_function_item] = STATE(744),
    [sym_function_signature_item] = STATE(744),
    [sym_function_modifiers] = STATE(3501),
    [sym_impl_item] = STATE(744),
    [sym_trait_item] = STATE(744),
    [sym_associated_type] = STATE(744),
    [sym_let_declaration] = STATE(744),
    [sym_use_declaration] = STATE(744),
    [sym_extern_modifier] = STATE(2155),
    [sym_visibility_modifier] = STATE(1926),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1726),
    [sym_macro_invocation] = STATE(397),
    [sym_scoped_identifier] = STATE(1519),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(378),
    [sym_match_expression] = STATE(378),
    [sym_while_expression] = STATE(378),
    [sym_loop_expression] = STATE(378),
    [sym_for_expression] = STATE(378),
    [sym_const_block] = STATE(378),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3486),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(378),
    [sym_async_block] = STATE(378),
    [sym_try_block] = STATE(378),
    [sym_block] = STATE(378),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(20),
    [sym_block_comment] = STATE(20),
    [aux_sym_source_file_repeat1] = STATE(22),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(155),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [21] = {
    [sym__statement] = STATE(725),
    [sym_empty_statement] = STATE(744),
    [sym_expression_statement] = STATE(744),
    [sym_macro_definition] = STATE(744),
    [sym_attribute_item] = STATE(744),
    [sym_inner_attribute_item] = STATE(744),
    [sym_mod_item] = STATE(744),
    [sym_foreign_mod_item] = STATE(744),
    [sym_struct_item] = STATE(744),
    [sym_union_item] = STATE(744),
    [sym_enum_item] = STATE(744),
    [sym_extern_crate_declaration] = STATE(744),
    [sym_const_item] = STATE(744),
    [sym_static_item] = STATE(744),
    [sym_type_item] = STATE(744),
    [sym_function_item] = STATE(744),
    [sym_function_signature_item] = STATE(744),
    [sym_function_modifiers] = STATE(3501),
    [sym_impl_item] = STATE(744),
    [sym_trait_item] = STATE(744),
    [sym_associated_type] = STATE(744),
    [sym_let_declaration] = STATE(744),
    [sym_use_declaration] = STATE(744),
    [sym_extern_modifier] = STATE(2155),
    [sym_visibility_modifier] = STATE(1926),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1712),
    [sym_macro_invocation] = STATE(397),
    [sym_scoped_identifier] = STATE(1519),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(378),
    [sym_match_expression] = STATE(378),
    [sym_while_expression] = STATE(378),
    [sym_loop_expression] = STATE(378),
    [sym_for_expression] = STATE(378),
    [sym_const_block] = STATE(378),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3486),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(378),
    [sym_async_block] = STATE(378),
    [sym_try_block] = STATE(378),
    [sym_block] = STATE(378),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(21),
    [sym_block_comment] = STATE(21),
    [aux_sym_source_file_repeat1] = STATE(25),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(157),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [22] = {
    [sym__statement] = STATE(725),
    [sym_empty_statement] = STATE(744),
    [sym_expression_statement] = STATE(744),
    [sym_macro_definition] = STATE(744),
    [sym_attribute_item] = STATE(744),
    [sym_inner_attribute_item] = STATE(744),
    [sym_mod_item] = STATE(744),
    [sym_foreign_mod_item] = STATE(744),
    [sym_struct_item] = STATE(744),
    [sym_union_item] = STATE(744),
    [sym_enum_item] = STATE(744),
    [sym_extern_crate_declaration] = STATE(744),
    [sym_const_item] = STATE(744),
    [sym_static_item] = STATE(744),
    [sym_type_item] = STATE(744),
    [sym_function_item] = STATE(744),
    [sym_function_signature_item] = STATE(744),
    [sym_function_modifiers] = STATE(3501),
    [sym_impl_item] = STATE(744),
    [sym_trait_item] = STATE(744),
    [sym_associated_type] = STATE(744),
    [sym_let_declaration] = STATE(744),
    [sym_use_declaration] = STATE(744),
    [sym_extern_modifier] = STATE(2155),
    [sym_visibility_modifier] = STATE(1926),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1852),
    [sym_macro_invocation] = STATE(401),
    [sym_scoped_identifier] = STATE(1519),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(378),
    [sym_match_expression] = STATE(378),
    [sym_while_expression] = STATE(378),
    [sym_loop_expression] = STATE(378),
    [sym_for_expression] = STATE(378),
    [sym_const_block] = STATE(378),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3486),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(378),
    [sym_async_block] = STATE(378),
    [sym_try_block] = STATE(378),
    [sym_block] = STATE(378),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(22),
    [sym_block_comment] = STATE(22),
    [aux_sym_source_file_repeat1] = STATE(22),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(159),
    [anon_sym_SEMI] = ACTIONS(162),
    [anon_sym_macro_rules_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(168),
    [anon_sym_LBRACK] = ACTIONS(171),
    [anon_sym_LBRACE] = ACTIONS(174),
    [anon_sym_RBRACE] = ACTIONS(177),
    [anon_sym_STAR] = ACTIONS(179),
    [anon_sym_u8] = ACTIONS(182),
    [anon_sym_i8] = ACTIONS(182),
    [anon_sym_u16] = ACTIONS(182),
    [anon_sym_i16] = ACTIONS(182),
    [anon_sym_u32] = ACTIONS(182),
    [anon_sym_i32] = ACTIONS(182),
    [anon_sym_u64] = ACTIONS(182),
    [anon_sym_i64] = ACTIONS(182),
    [anon_sym_u128] = ACTIONS(182),
    [anon_sym_i128] = ACTIONS(182),
    [anon_sym_isize] = ACTIONS(182),
    [anon_sym_usize] = ACTIONS(182),
    [anon_sym_f32] = ACTIONS(182),
    [anon_sym_f64] = ACTIONS(182),
    [anon_sym_bool] = ACTIONS(182),
    [anon_sym_str] = ACTIONS(182),
    [anon_sym_char] = ACTIONS(182),
    [anon_sym_DASH] = ACTIONS(179),
    [anon_sym_BANG] = ACTIONS(179),
    [anon_sym_AMP] = ACTIONS(185),
    [anon_sym_PIPE] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(191),
    [anon_sym_DOT_DOT] = ACTIONS(194),
    [anon_sym_COLON_COLON] = ACTIONS(197),
    [anon_sym_POUND] = ACTIONS(200),
    [anon_sym_SQUOTE] = ACTIONS(203),
    [anon_sym_async] = ACTIONS(206),
    [anon_sym_break] = ACTIONS(209),
    [anon_sym_const] = ACTIONS(212),
    [anon_sym_continue] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(218),
    [anon_sym_enum] = ACTIONS(221),
    [anon_sym_fn] = ACTIONS(224),
    [anon_sym_for] = ACTIONS(227),
    [anon_sym_if] = ACTIONS(230),
    [anon_sym_impl] = ACTIONS(233),
    [anon_sym_let] = ACTIONS(236),
    [anon_sym_loop] = ACTIONS(239),
    [anon_sym_match] = ACTIONS(242),
    [anon_sym_mod] = ACTIONS(245),
    [anon_sym_pub] = ACTIONS(248),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_static] = ACTIONS(254),
    [anon_sym_struct] = ACTIONS(257),
    [anon_sym_trait] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(263),
    [anon_sym_union] = ACTIONS(266),
    [anon_sym_unsafe] = ACTIONS(269),
    [anon_sym_use] = ACTIONS(272),
    [anon_sym_while] = ACTIONS(275),
    [anon_sym_extern] = ACTIONS(278),
    [anon_sym_yield] = ACTIONS(281),
    [anon_sym_move] = ACTIONS(284),
    [anon_sym_try] = ACTIONS(287),
    [sym_integer_literal] = ACTIONS(290),
    [aux_sym_string_literal_token1] = ACTIONS(293),
    [sym_char_literal] = ACTIONS(290),
    [anon_sym_true] = ACTIONS(296),
    [anon_sym_false] = ACTIONS(296),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(299),
    [sym_super] = ACTIONS(302),
    [sym_crate] = ACTIONS(305),
    [sym_metavariable] = ACTIONS(308),
    [sym__raw_string_literal_start] = ACTIONS(311),
    [sym_float_literal] = ACTIONS(290),
  },
  [23] = {
    [sym__statement] = STATE(725),
    [sym_empty_statement] = STATE(744),
    [sym_expression_statement] = STATE(744),
    [sym_macro_definition] = STATE(744),
    [sym_attribute_item] = STATE(744),
    [sym_inner_attribute_item] = STATE(744),
    [sym_mod_item] = STATE(744),
    [sym_foreign_mod_item] = STATE(744),
    [sym_struct_item] = STATE(744),
    [sym_union_item] = STATE(744),
    [sym_enum_item] = STATE(744),
    [sym_extern_crate_declaration] = STATE(744),
    [sym_const_item] = STATE(744),
    [sym_static_item] = STATE(744),
    [sym_type_item] = STATE(744),
    [sym_function_item] = STATE(744),
    [sym_function_signature_item] = STATE(744),
    [sym_function_modifiers] = STATE(3501),
    [sym_impl_item] = STATE(744),
    [sym_trait_item] = STATE(744),
    [sym_associated_type] = STATE(744),
    [sym_let_declaration] = STATE(744),
    [sym_use_declaration] = STATE(744),
    [sym_extern_modifier] = STATE(2155),
    [sym_visibility_modifier] = STATE(1926),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1852),
    [sym_macro_invocation] = STATE(397),
    [sym_scoped_identifier] = STATE(1519),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(378),
    [sym_match_expression] = STATE(378),
    [sym_while_expression] = STATE(378),
    [sym_loop_expression] = STATE(378),
    [sym_for_expression] = STATE(378),
    [sym_const_block] = STATE(378),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3486),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(378),
    [sym_async_block] = STATE(378),
    [sym_try_block] = STATE(378),
    [sym_block] = STATE(378),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(23),
    [sym_block_comment] = STATE(23),
    [aux_sym_source_file_repeat1] = STATE(23),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [ts_builtin_sym_end] = ACTIONS(177),
    [sym_identifier] = ACTIONS(159),
    [anon_sym_SEMI] = ACTIONS(162),
    [anon_sym_macro_rules_BANG] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(168),
    [anon_sym_LBRACK] = ACTIONS(171),
    [anon_sym_LBRACE] = ACTIONS(174),
    [anon_sym_STAR] = ACTIONS(179),
    [anon_sym_u8] = ACTIONS(182),
    [anon_sym_i8] = ACTIONS(182),
    [anon_sym_u16] = ACTIONS(182),
    [anon_sym_i16] = ACTIONS(182),
    [anon_sym_u32] = ACTIONS(182),
    [anon_sym_i32] = ACTIONS(182),
    [anon_sym_u64] = ACTIONS(182),
    [anon_sym_i64] = ACTIONS(182),
    [anon_sym_u128] = ACTIONS(182),
    [anon_sym_i128] = ACTIONS(182),
    [anon_sym_isize] = ACTIONS(182),
    [anon_sym_usize] = ACTIONS(182),
    [anon_sym_f32] = ACTIONS(182),
    [anon_sym_f64] = ACTIONS(182),
    [anon_sym_bool] = ACTIONS(182),
    [anon_sym_str] = ACTIONS(182),
    [anon_sym_char] = ACTIONS(182),
    [anon_sym_DASH] = ACTIONS(179),
    [anon_sym_BANG] = ACTIONS(179),
    [anon_sym_AMP] = ACTIONS(185),
    [anon_sym_PIPE] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(191),
    [anon_sym_DOT_DOT] = ACTIONS(194),
    [anon_sym_COLON_COLON] = ACTIONS(197),
    [anon_sym_POUND] = ACTIONS(200),
    [anon_sym_SQUOTE] = ACTIONS(203),
    [anon_sym_async] = ACTIONS(206),
    [anon_sym_break] = ACTIONS(209),
    [anon_sym_const] = ACTIONS(212),
    [anon_sym_continue] = ACTIONS(215),
    [anon_sym_default] = ACTIONS(218),
    [anon_sym_enum] = ACTIONS(221),
    [anon_sym_fn] = ACTIONS(224),
    [anon_sym_for] = ACTIONS(227),
    [anon_sym_if] = ACTIONS(230),
    [anon_sym_impl] = ACTIONS(233),
    [anon_sym_let] = ACTIONS(236),
    [anon_sym_loop] = ACTIONS(239),
    [anon_sym_match] = ACTIONS(242),
    [anon_sym_mod] = ACTIONS(245),
    [anon_sym_pub] = ACTIONS(248),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_static] = ACTIONS(254),
    [anon_sym_struct] = ACTIONS(257),
    [anon_sym_trait] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(263),
    [anon_sym_union] = ACTIONS(266),
    [anon_sym_unsafe] = ACTIONS(269),
    [anon_sym_use] = ACTIONS(272),
    [anon_sym_while] = ACTIONS(275),
    [anon_sym_extern] = ACTIONS(278),
    [anon_sym_yield] = ACTIONS(281),
    [anon_sym_move] = ACTIONS(284),
    [anon_sym_try] = ACTIONS(287),
    [sym_integer_literal] = ACTIONS(290),
    [aux_sym_string_literal_token1] = ACTIONS(293),
    [sym_char_literal] = ACTIONS(290),
    [anon_sym_true] = ACTIONS(296),
    [anon_sym_false] = ACTIONS(296),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(299),
    [sym_super] = ACTIONS(302),
    [sym_crate] = ACTIONS(305),
    [sym_metavariable] = ACTIONS(308),
    [sym__raw_string_literal_start] = ACTIONS(311),
    [sym_float_literal] = ACTIONS(290),
  },
  [24] = {
    [sym__statement] = STATE(725),
    [sym_empty_statement] = STATE(744),
    [sym_expression_statement] = STATE(744),
    [sym_macro_definition] = STATE(744),
    [sym_attribute_item] = STATE(744),
    [sym_inner_attribute_item] = STATE(744),
    [sym_mod_item] = STATE(744),
    [sym_foreign_mod_item] = STATE(744),
    [sym_struct_item] = STATE(744),
    [sym_union_item] = STATE(744),
    [sym_enum_item] = STATE(744),
    [sym_extern_crate_declaration] = STATE(744),
    [sym_const_item] = STATE(744),
    [sym_static_item] = STATE(744),
    [sym_type_item] = STATE(744),
    [sym_function_item] = STATE(744),
    [sym_function_signature_item] = STATE(744),
    [sym_function_modifiers] = STATE(3501),
    [sym_impl_item] = STATE(744),
    [sym_trait_item] = STATE(744),
    [sym_associated_type] = STATE(744),
    [sym_let_declaration] = STATE(744),
    [sym_use_declaration] = STATE(744),
    [sym_extern_modifier] = STATE(2155),
    [sym_visibility_modifier] = STATE(1926),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1682),
    [sym_macro_invocation] = STATE(397),
    [sym_scoped_identifier] = STATE(1519),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(378),
    [sym_match_expression] = STATE(378),
    [sym_while_expression] = STATE(378),
    [sym_loop_expression] = STATE(378),
    [sym_for_expression] = STATE(378),
    [sym_const_block] = STATE(378),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3486),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(378),
    [sym_async_block] = STATE(378),
    [sym_try_block] = STATE(378),
    [sym_block] = STATE(378),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(24),
    [sym_block_comment] = STATE(24),
    [aux_sym_source_file_repeat1] = STATE(20),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(314),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [25] = {
    [sym__statement] = STATE(725),
    [sym_empty_statement] = STATE(744),
    [sym_expression_statement] = STATE(744),
    [sym_macro_definition] = STATE(744),
    [sym_attribute_item] = STATE(744),
    [sym_inner_attribute_item] = STATE(744),
    [sym_mod_item] = STATE(744),
    [sym_foreign_mod_item] = STATE(744),
    [sym_struct_item] = STATE(744),
    [sym_union_item] = STATE(744),
    [sym_enum_item] = STATE(744),
    [sym_extern_crate_declaration] = STATE(744),
    [sym_const_item] = STATE(744),
    [sym_static_item] = STATE(744),
    [sym_type_item] = STATE(744),
    [sym_function_item] = STATE(744),
    [sym_function_signature_item] = STATE(744),
    [sym_function_modifiers] = STATE(3501),
    [sym_impl_item] = STATE(744),
    [sym_trait_item] = STATE(744),
    [sym_associated_type] = STATE(744),
    [sym_let_declaration] = STATE(744),
    [sym_use_declaration] = STATE(744),
    [sym_extern_modifier] = STATE(2155),
    [sym_visibility_modifier] = STATE(1926),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1718),
    [sym_macro_invocation] = STATE(397),
    [sym_scoped_identifier] = STATE(1519),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(378),
    [sym_match_expression] = STATE(378),
    [sym_while_expression] = STATE(378),
    [sym_loop_expression] = STATE(378),
    [sym_for_expression] = STATE(378),
    [sym_const_block] = STATE(378),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3486),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(378),
    [sym_async_block] = STATE(378),
    [sym_try_block] = STATE(378),
    [sym_block] = STATE(378),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(25),
    [sym_block_comment] = STATE(25),
    [aux_sym_source_file_repeat1] = STATE(22),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(316),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [26] = {
    [sym__statement] = STATE(725),
    [sym_empty_statement] = STATE(744),
    [sym_expression_statement] = STATE(744),
    [sym_macro_definition] = STATE(744),
    [sym_attribute_item] = STATE(744),
    [sym_inner_attribute_item] = STATE(744),
    [sym_mod_item] = STATE(744),
    [sym_foreign_mod_item] = STATE(744),
    [sym_struct_item] = STATE(744),
    [sym_union_item] = STATE(744),
    [sym_enum_item] = STATE(744),
    [sym_extern_crate_declaration] = STATE(744),
    [sym_const_item] = STATE(744),
    [sym_static_item] = STATE(744),
    [sym_type_item] = STATE(744),
    [sym_function_item] = STATE(744),
    [sym_function_signature_item] = STATE(744),
    [sym_function_modifiers] = STATE(3501),
    [sym_impl_item] = STATE(744),
    [sym_trait_item] = STATE(744),
    [sym_associated_type] = STATE(744),
    [sym_let_declaration] = STATE(744),
    [sym_use_declaration] = STATE(744),
    [sym_extern_modifier] = STATE(2155),
    [sym_visibility_modifier] = STATE(1926),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1725),
    [sym_macro_invocation] = STATE(397),
    [sym_scoped_identifier] = STATE(1519),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(378),
    [sym_match_expression] = STATE(378),
    [sym_while_expression] = STATE(378),
    [sym_loop_expression] = STATE(378),
    [sym_for_expression] = STATE(378),
    [sym_const_block] = STATE(378),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3486),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(378),
    [sym_async_block] = STATE(378),
    [sym_try_block] = STATE(378),
    [sym_block] = STATE(378),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(26),
    [sym_block_comment] = STATE(26),
    [aux_sym_source_file_repeat1] = STATE(22),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(318),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [27] = {
    [sym__statement] = STATE(725),
    [sym_empty_statement] = STATE(744),
    [sym_expression_statement] = STATE(744),
    [sym_macro_definition] = STATE(744),
    [sym_attribute_item] = STATE(744),
    [sym_inner_attribute_item] = STATE(744),
    [sym_mod_item] = STATE(744),
    [sym_foreign_mod_item] = STATE(744),
    [sym_struct_item] = STATE(744),
    [sym_union_item] = STATE(744),
    [sym_enum_item] = STATE(744),
    [sym_extern_crate_declaration] = STATE(744),
    [sym_const_item] = STATE(744),
    [sym_static_item] = STATE(744),
    [sym_type_item] = STATE(744),
    [sym_function_item] = STATE(744),
    [sym_function_signature_item] = STATE(744),
    [sym_function_modifiers] = STATE(3501),
    [sym_impl_item] = STATE(744),
    [sym_trait_item] = STATE(744),
    [sym_associated_type] = STATE(744),
    [sym_let_declaration] = STATE(744),
    [sym_use_declaration] = STATE(744),
    [sym_extern_modifier] = STATE(2155),
    [sym_visibility_modifier] = STATE(1926),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1852),
    [sym_macro_invocation] = STATE(397),
    [sym_scoped_identifier] = STATE(1519),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(378),
    [sym_match_expression] = STATE(378),
    [sym_while_expression] = STATE(378),
    [sym_loop_expression] = STATE(378),
    [sym_for_expression] = STATE(378),
    [sym_const_block] = STATE(378),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3486),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(378),
    [sym_async_block] = STATE(378),
    [sym_try_block] = STATE(378),
    [sym_block] = STATE(378),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(27),
    [sym_block_comment] = STATE(27),
    [aux_sym_source_file_repeat1] = STATE(3),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [ts_builtin_sym_end] = ACTIONS(127),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [28] = {
    [sym__statement] = STATE(725),
    [sym_empty_statement] = STATE(744),
    [sym_expression_statement] = STATE(744),
    [sym_macro_definition] = STATE(744),
    [sym_attribute_item] = STATE(744),
    [sym_inner_attribute_item] = STATE(744),
    [sym_mod_item] = STATE(744),
    [sym_foreign_mod_item] = STATE(744),
    [sym_struct_item] = STATE(744),
    [sym_union_item] = STATE(744),
    [sym_enum_item] = STATE(744),
    [sym_extern_crate_declaration] = STATE(744),
    [sym_const_item] = STATE(744),
    [sym_static_item] = STATE(744),
    [sym_type_item] = STATE(744),
    [sym_function_item] = STATE(744),
    [sym_function_signature_item] = STATE(744),
    [sym_function_modifiers] = STATE(3501),
    [sym_impl_item] = STATE(744),
    [sym_trait_item] = STATE(744),
    [sym_associated_type] = STATE(744),
    [sym_let_declaration] = STATE(744),
    [sym_use_declaration] = STATE(744),
    [sym_extern_modifier] = STATE(2155),
    [sym_visibility_modifier] = STATE(1926),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1723),
    [sym_macro_invocation] = STATE(397),
    [sym_scoped_identifier] = STATE(1519),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(378),
    [sym_match_expression] = STATE(378),
    [sym_while_expression] = STATE(378),
    [sym_loop_expression] = STATE(378),
    [sym_for_expression] = STATE(378),
    [sym_const_block] = STATE(378),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3486),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(378),
    [sym_async_block] = STATE(378),
    [sym_try_block] = STATE(378),
    [sym_block] = STATE(378),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(28),
    [sym_block_comment] = STATE(28),
    [aux_sym_source_file_repeat1] = STATE(12),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(320),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [29] = {
    [sym__statement] = STATE(725),
    [sym_empty_statement] = STATE(744),
    [sym_expression_statement] = STATE(744),
    [sym_macro_definition] = STATE(744),
    [sym_attribute_item] = STATE(744),
    [sym_inner_attribute_item] = STATE(744),
    [sym_mod_item] = STATE(744),
    [sym_foreign_mod_item] = STATE(744),
    [sym_struct_item] = STATE(744),
    [sym_union_item] = STATE(744),
    [sym_enum_item] = STATE(744),
    [sym_extern_crate_declaration] = STATE(744),
    [sym_const_item] = STATE(744),
    [sym_static_item] = STATE(744),
    [sym_type_item] = STATE(744),
    [sym_function_item] = STATE(744),
    [sym_function_signature_item] = STATE(744),
    [sym_function_modifiers] = STATE(3501),
    [sym_impl_item] = STATE(744),
    [sym_trait_item] = STATE(744),
    [sym_associated_type] = STATE(744),
    [sym_let_declaration] = STATE(744),
    [sym_use_declaration] = STATE(744),
    [sym_extern_modifier] = STATE(2155),
    [sym_visibility_modifier] = STATE(1926),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1777),
    [sym_macro_invocation] = STATE(397),
    [sym_scoped_identifier] = STATE(1519),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(378),
    [sym_match_expression] = STATE(378),
    [sym_while_expression] = STATE(378),
    [sym_loop_expression] = STATE(378),
    [sym_for_expression] = STATE(378),
    [sym_const_block] = STATE(378),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3486),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(378),
    [sym_async_block] = STATE(378),
    [sym_try_block] = STATE(378),
    [sym_block] = STATE(378),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(29),
    [sym_block_comment] = STATE(29),
    [aux_sym_source_file_repeat1] = STATE(22),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(322),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [30] = {
    [sym__statement] = STATE(725),
    [sym_empty_statement] = STATE(744),
    [sym_expression_statement] = STATE(744),
    [sym_macro_definition] = STATE(744),
    [sym_attribute_item] = STATE(744),
    [sym_inner_attribute_item] = STATE(744),
    [sym_mod_item] = STATE(744),
    [sym_foreign_mod_item] = STATE(744),
    [sym_struct_item] = STATE(744),
    [sym_union_item] = STATE(744),
    [sym_enum_item] = STATE(744),
    [sym_extern_crate_declaration] = STATE(744),
    [sym_const_item] = STATE(744),
    [sym_static_item] = STATE(744),
    [sym_type_item] = STATE(744),
    [sym_function_item] = STATE(744),
    [sym_function_signature_item] = STATE(744),
    [sym_function_modifiers] = STATE(3501),
    [sym_impl_item] = STATE(744),
    [sym_trait_item] = STATE(744),
    [sym_associated_type] = STATE(744),
    [sym_let_declaration] = STATE(744),
    [sym_use_declaration] = STATE(744),
    [sym_extern_modifier] = STATE(2155),
    [sym_visibility_modifier] = STATE(1926),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1708),
    [sym_macro_invocation] = STATE(397),
    [sym_scoped_identifier] = STATE(1519),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(378),
    [sym_match_expression] = STATE(378),
    [sym_while_expression] = STATE(378),
    [sym_loop_expression] = STATE(378),
    [sym_for_expression] = STATE(378),
    [sym_const_block] = STATE(378),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3486),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(378),
    [sym_async_block] = STATE(378),
    [sym_try_block] = STATE(378),
    [sym_block] = STATE(378),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(30),
    [sym_block_comment] = STATE(30),
    [aux_sym_source_file_repeat1] = STATE(11),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(324),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [31] = {
    [sym__statement] = STATE(725),
    [sym_empty_statement] = STATE(744),
    [sym_expression_statement] = STATE(744),
    [sym_macro_definition] = STATE(744),
    [sym_attribute_item] = STATE(744),
    [sym_inner_attribute_item] = STATE(744),
    [sym_mod_item] = STATE(744),
    [sym_foreign_mod_item] = STATE(744),
    [sym_struct_item] = STATE(744),
    [sym_union_item] = STATE(744),
    [sym_enum_item] = STATE(744),
    [sym_extern_crate_declaration] = STATE(744),
    [sym_const_item] = STATE(744),
    [sym_static_item] = STATE(744),
    [sym_type_item] = STATE(744),
    [sym_function_item] = STATE(744),
    [sym_function_signature_item] = STATE(744),
    [sym_function_modifiers] = STATE(3501),
    [sym_impl_item] = STATE(744),
    [sym_trait_item] = STATE(744),
    [sym_associated_type] = STATE(744),
    [sym_let_declaration] = STATE(744),
    [sym_use_declaration] = STATE(744),
    [sym_extern_modifier] = STATE(2155),
    [sym_visibility_modifier] = STATE(1926),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1817),
    [sym_macro_invocation] = STATE(397),
    [sym_scoped_identifier] = STATE(1519),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(378),
    [sym_match_expression] = STATE(378),
    [sym_while_expression] = STATE(378),
    [sym_loop_expression] = STATE(378),
    [sym_for_expression] = STATE(378),
    [sym_const_block] = STATE(378),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3486),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(378),
    [sym_async_block] = STATE(378),
    [sym_try_block] = STATE(378),
    [sym_block] = STATE(378),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(31),
    [sym_block_comment] = STATE(31),
    [aux_sym_source_file_repeat1] = STATE(22),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(326),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [32] = {
    [sym__statement] = STATE(725),
    [sym_empty_statement] = STATE(744),
    [sym_expression_statement] = STATE(744),
    [sym_macro_definition] = STATE(744),
    [sym_attribute_item] = STATE(744),
    [sym_inner_attribute_item] = STATE(744),
    [sym_mod_item] = STATE(744),
    [sym_foreign_mod_item] = STATE(744),
    [sym_struct_item] = STATE(744),
    [sym_union_item] = STATE(744),
    [sym_enum_item] = STATE(744),
    [sym_extern_crate_declaration] = STATE(744),
    [sym_const_item] = STATE(744),
    [sym_static_item] = STATE(744),
    [sym_type_item] = STATE(744),
    [sym_function_item] = STATE(744),
    [sym_function_signature_item] = STATE(744),
    [sym_function_modifiers] = STATE(3501),
    [sym_impl_item] = STATE(744),
    [sym_trait_item] = STATE(744),
    [sym_associated_type] = STATE(744),
    [sym_let_declaration] = STATE(744),
    [sym_use_declaration] = STATE(744),
    [sym_extern_modifier] = STATE(2155),
    [sym_visibility_modifier] = STATE(1926),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1776),
    [sym_macro_invocation] = STATE(397),
    [sym_scoped_identifier] = STATE(1519),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(378),
    [sym_match_expression] = STATE(378),
    [sym_while_expression] = STATE(378),
    [sym_loop_expression] = STATE(378),
    [sym_for_expression] = STATE(378),
    [sym_const_block] = STATE(378),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3486),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(378),
    [sym_async_block] = STATE(378),
    [sym_try_block] = STATE(378),
    [sym_block] = STATE(378),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(32),
    [sym_block_comment] = STATE(32),
    [aux_sym_source_file_repeat1] = STATE(29),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(328),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [33] = {
    [sym__statement] = STATE(725),
    [sym_empty_statement] = STATE(744),
    [sym_expression_statement] = STATE(744),
    [sym_macro_definition] = STATE(744),
    [sym_attribute_item] = STATE(744),
    [sym_inner_attribute_item] = STATE(744),
    [sym_mod_item] = STATE(744),
    [sym_foreign_mod_item] = STATE(744),
    [sym_struct_item] = STATE(744),
    [sym_union_item] = STATE(744),
    [sym_enum_item] = STATE(744),
    [sym_extern_crate_declaration] = STATE(744),
    [sym_const_item] = STATE(744),
    [sym_static_item] = STATE(744),
    [sym_type_item] = STATE(744),
    [sym_function_item] = STATE(744),
    [sym_function_signature_item] = STATE(744),
    [sym_function_modifiers] = STATE(3501),
    [sym_impl_item] = STATE(744),
    [sym_trait_item] = STATE(744),
    [sym_associated_type] = STATE(744),
    [sym_let_declaration] = STATE(744),
    [sym_use_declaration] = STATE(744),
    [sym_extern_modifier] = STATE(2155),
    [sym_visibility_modifier] = STATE(1926),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1673),
    [sym_macro_invocation] = STATE(397),
    [sym_scoped_identifier] = STATE(1519),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(378),
    [sym_match_expression] = STATE(378),
    [sym_while_expression] = STATE(378),
    [sym_loop_expression] = STATE(378),
    [sym_for_expression] = STATE(378),
    [sym_const_block] = STATE(378),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3486),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(378),
    [sym_async_block] = STATE(378),
    [sym_try_block] = STATE(378),
    [sym_block] = STATE(378),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(33),
    [sym_block_comment] = STATE(33),
    [aux_sym_source_file_repeat1] = STATE(22),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(330),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [34] = {
    [sym__statement] = STATE(725),
    [sym_empty_statement] = STATE(744),
    [sym_expression_statement] = STATE(744),
    [sym_macro_definition] = STATE(744),
    [sym_attribute_item] = STATE(744),
    [sym_inner_attribute_item] = STATE(744),
    [sym_mod_item] = STATE(744),
    [sym_foreign_mod_item] = STATE(744),
    [sym_struct_item] = STATE(744),
    [sym_union_item] = STATE(744),
    [sym_enum_item] = STATE(744),
    [sym_extern_crate_declaration] = STATE(744),
    [sym_const_item] = STATE(744),
    [sym_static_item] = STATE(744),
    [sym_type_item] = STATE(744),
    [sym_function_item] = STATE(744),
    [sym_function_signature_item] = STATE(744),
    [sym_function_modifiers] = STATE(3501),
    [sym_impl_item] = STATE(744),
    [sym_trait_item] = STATE(744),
    [sym_associated_type] = STATE(744),
    [sym_let_declaration] = STATE(744),
    [sym_use_declaration] = STATE(744),
    [sym_extern_modifier] = STATE(2155),
    [sym_visibility_modifier] = STATE(1926),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1631),
    [sym_macro_invocation] = STATE(397),
    [sym_scoped_identifier] = STATE(1519),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(378),
    [sym_match_expression] = STATE(378),
    [sym_while_expression] = STATE(378),
    [sym_loop_expression] = STATE(378),
    [sym_for_expression] = STATE(378),
    [sym_const_block] = STATE(378),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3486),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(378),
    [sym_async_block] = STATE(378),
    [sym_try_block] = STATE(378),
    [sym_block] = STATE(378),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(34),
    [sym_block_comment] = STATE(34),
    [aux_sym_source_file_repeat1] = STATE(22),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(332),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_enum] = ACTIONS(49),
    [anon_sym_fn] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_impl] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(59),
    [anon_sym_loop] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(63),
    [anon_sym_mod] = ACTIONS(65),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_trait] = ACTIONS(75),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_use] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(87),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(111),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [35] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1487),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(35),
    [sym_block_comment] = STATE(35),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_SEMI] = ACTIONS(336),
    [anon_sym_LPAREN] = ACTIONS(336),
    [anon_sym_RPAREN] = ACTIONS(336),
    [anon_sym_LBRACK] = ACTIONS(336),
    [anon_sym_RBRACK] = ACTIONS(336),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_RBRACE] = ACTIONS(336),
    [anon_sym_COLON] = ACTIONS(340),
    [anon_sym_PLUS] = ACTIONS(342),
    [anon_sym_STAR] = ACTIONS(342),
    [anon_sym_QMARK] = ACTIONS(336),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(342),
    [anon_sym_SLASH] = ACTIONS(342),
    [anon_sym_PERCENT] = ACTIONS(342),
    [anon_sym_CARET] = ACTIONS(342),
    [anon_sym_BANG] = ACTIONS(344),
    [anon_sym_AMP] = ACTIONS(342),
    [anon_sym_PIPE] = ACTIONS(342),
    [anon_sym_AMP_AMP] = ACTIONS(336),
    [anon_sym_PIPE_PIPE] = ACTIONS(336),
    [anon_sym_LT_LT] = ACTIONS(342),
    [anon_sym_GT_GT] = ACTIONS(342),
    [anon_sym_PLUS_EQ] = ACTIONS(336),
    [anon_sym_DASH_EQ] = ACTIONS(336),
    [anon_sym_STAR_EQ] = ACTIONS(336),
    [anon_sym_SLASH_EQ] = ACTIONS(336),
    [anon_sym_PERCENT_EQ] = ACTIONS(336),
    [anon_sym_CARET_EQ] = ACTIONS(336),
    [anon_sym_AMP_EQ] = ACTIONS(336),
    [anon_sym_PIPE_EQ] = ACTIONS(336),
    [anon_sym_LT_LT_EQ] = ACTIONS(336),
    [anon_sym_GT_GT_EQ] = ACTIONS(336),
    [anon_sym_EQ] = ACTIONS(342),
    [anon_sym_EQ_EQ] = ACTIONS(336),
    [anon_sym_BANG_EQ] = ACTIONS(336),
    [anon_sym_GT] = ACTIONS(342),
    [anon_sym_LT] = ACTIONS(342),
    [anon_sym_GT_EQ] = ACTIONS(336),
    [anon_sym_LT_EQ] = ACTIONS(336),
    [anon_sym_DOT] = ACTIONS(342),
    [anon_sym_DOT_DOT] = ACTIONS(342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(336),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(336),
    [anon_sym_COMMA] = ACTIONS(336),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(342),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_else] = ACTIONS(342),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [36] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1483),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(36),
    [sym_block_comment] = STATE(36),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_SEMI] = ACTIONS(368),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(368),
    [anon_sym_LBRACK] = ACTIONS(368),
    [anon_sym_RBRACK] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_RBRACE] = ACTIONS(368),
    [anon_sym_PLUS] = ACTIONS(370),
    [anon_sym_STAR] = ACTIONS(370),
    [anon_sym_QMARK] = ACTIONS(368),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(370),
    [anon_sym_SLASH] = ACTIONS(370),
    [anon_sym_PERCENT] = ACTIONS(370),
    [anon_sym_CARET] = ACTIONS(370),
    [anon_sym_BANG] = ACTIONS(344),
    [anon_sym_AMP] = ACTIONS(370),
    [anon_sym_PIPE] = ACTIONS(370),
    [anon_sym_AMP_AMP] = ACTIONS(368),
    [anon_sym_PIPE_PIPE] = ACTIONS(368),
    [anon_sym_LT_LT] = ACTIONS(370),
    [anon_sym_GT_GT] = ACTIONS(370),
    [anon_sym_PLUS_EQ] = ACTIONS(368),
    [anon_sym_DASH_EQ] = ACTIONS(368),
    [anon_sym_STAR_EQ] = ACTIONS(368),
    [anon_sym_SLASH_EQ] = ACTIONS(368),
    [anon_sym_PERCENT_EQ] = ACTIONS(368),
    [anon_sym_CARET_EQ] = ACTIONS(368),
    [anon_sym_AMP_EQ] = ACTIONS(368),
    [anon_sym_PIPE_EQ] = ACTIONS(368),
    [anon_sym_LT_LT_EQ] = ACTIONS(368),
    [anon_sym_GT_GT_EQ] = ACTIONS(368),
    [anon_sym_EQ] = ACTIONS(370),
    [anon_sym_EQ_EQ] = ACTIONS(368),
    [anon_sym_BANG_EQ] = ACTIONS(368),
    [anon_sym_GT] = ACTIONS(370),
    [anon_sym_LT] = ACTIONS(370),
    [anon_sym_GT_EQ] = ACTIONS(368),
    [anon_sym_LT_EQ] = ACTIONS(368),
    [anon_sym_DOT] = ACTIONS(370),
    [anon_sym_DOT_DOT] = ACTIONS(370),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(368),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(368),
    [anon_sym_COMMA] = ACTIONS(368),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(370),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_else] = ACTIONS(370),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [37] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1479),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(37),
    [sym_block_comment] = STATE(37),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_SEMI] = ACTIONS(372),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(372),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(372),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_RBRACE] = ACTIONS(372),
    [anon_sym_PLUS] = ACTIONS(374),
    [anon_sym_STAR] = ACTIONS(344),
    [anon_sym_QMARK] = ACTIONS(372),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_SLASH] = ACTIONS(374),
    [anon_sym_PERCENT] = ACTIONS(374),
    [anon_sym_CARET] = ACTIONS(374),
    [anon_sym_BANG] = ACTIONS(344),
    [anon_sym_AMP] = ACTIONS(376),
    [anon_sym_PIPE] = ACTIONS(378),
    [anon_sym_AMP_AMP] = ACTIONS(372),
    [anon_sym_PIPE_PIPE] = ACTIONS(372),
    [anon_sym_LT_LT] = ACTIONS(374),
    [anon_sym_GT_GT] = ACTIONS(374),
    [anon_sym_PLUS_EQ] = ACTIONS(372),
    [anon_sym_DASH_EQ] = ACTIONS(372),
    [anon_sym_STAR_EQ] = ACTIONS(372),
    [anon_sym_SLASH_EQ] = ACTIONS(372),
    [anon_sym_PERCENT_EQ] = ACTIONS(372),
    [anon_sym_CARET_EQ] = ACTIONS(372),
    [anon_sym_AMP_EQ] = ACTIONS(372),
    [anon_sym_PIPE_EQ] = ACTIONS(372),
    [anon_sym_LT_LT_EQ] = ACTIONS(372),
    [anon_sym_GT_GT_EQ] = ACTIONS(372),
    [anon_sym_EQ] = ACTIONS(374),
    [anon_sym_EQ_EQ] = ACTIONS(372),
    [anon_sym_BANG_EQ] = ACTIONS(372),
    [anon_sym_GT] = ACTIONS(374),
    [anon_sym_LT] = ACTIONS(380),
    [anon_sym_GT_EQ] = ACTIONS(372),
    [anon_sym_LT_EQ] = ACTIONS(372),
    [anon_sym_DOT] = ACTIONS(374),
    [anon_sym_DOT_DOT] = ACTIONS(382),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(372),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(372),
    [anon_sym_COMMA] = ACTIONS(372),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(374),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_else] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [38] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1488),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(38),
    [sym_block_comment] = STATE(38),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_SEMI] = ACTIONS(384),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(384),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(384),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_RBRACE] = ACTIONS(384),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_STAR] = ACTIONS(344),
    [anon_sym_QMARK] = ACTIONS(384),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_SLASH] = ACTIONS(386),
    [anon_sym_PERCENT] = ACTIONS(386),
    [anon_sym_CARET] = ACTIONS(386),
    [anon_sym_BANG] = ACTIONS(344),
    [anon_sym_AMP] = ACTIONS(376),
    [anon_sym_PIPE] = ACTIONS(378),
    [anon_sym_AMP_AMP] = ACTIONS(384),
    [anon_sym_PIPE_PIPE] = ACTIONS(384),
    [anon_sym_LT_LT] = ACTIONS(386),
    [anon_sym_GT_GT] = ACTIONS(386),
    [anon_sym_PLUS_EQ] = ACTIONS(384),
    [anon_sym_DASH_EQ] = ACTIONS(384),
    [anon_sym_STAR_EQ] = ACTIONS(384),
    [anon_sym_SLASH_EQ] = ACTIONS(384),
    [anon_sym_PERCENT_EQ] = ACTIONS(384),
    [anon_sym_CARET_EQ] = ACTIONS(384),
    [anon_sym_AMP_EQ] = ACTIONS(384),
    [anon_sym_PIPE_EQ] = ACTIONS(384),
    [anon_sym_LT_LT_EQ] = ACTIONS(384),
    [anon_sym_GT_GT_EQ] = ACTIONS(384),
    [anon_sym_EQ] = ACTIONS(386),
    [anon_sym_EQ_EQ] = ACTIONS(384),
    [anon_sym_BANG_EQ] = ACTIONS(384),
    [anon_sym_GT] = ACTIONS(386),
    [anon_sym_LT] = ACTIONS(380),
    [anon_sym_GT_EQ] = ACTIONS(384),
    [anon_sym_LT_EQ] = ACTIONS(384),
    [anon_sym_DOT] = ACTIONS(386),
    [anon_sym_DOT_DOT] = ACTIONS(382),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(384),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(384),
    [anon_sym_COMMA] = ACTIONS(384),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(386),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_else] = ACTIONS(386),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [39] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1491),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(35),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(39),
    [sym_block_comment] = STATE(39),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_SEMI] = ACTIONS(388),
    [anon_sym_LPAREN] = ACTIONS(388),
    [anon_sym_RPAREN] = ACTIONS(388),
    [anon_sym_LBRACK] = ACTIONS(388),
    [anon_sym_RBRACK] = ACTIONS(388),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_RBRACE] = ACTIONS(388),
    [anon_sym_PLUS] = ACTIONS(390),
    [anon_sym_STAR] = ACTIONS(390),
    [anon_sym_QMARK] = ACTIONS(388),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(390),
    [anon_sym_SLASH] = ACTIONS(390),
    [anon_sym_PERCENT] = ACTIONS(390),
    [anon_sym_CARET] = ACTIONS(390),
    [anon_sym_BANG] = ACTIONS(344),
    [anon_sym_AMP] = ACTIONS(390),
    [anon_sym_PIPE] = ACTIONS(390),
    [anon_sym_AMP_AMP] = ACTIONS(388),
    [anon_sym_PIPE_PIPE] = ACTIONS(388),
    [anon_sym_LT_LT] = ACTIONS(390),
    [anon_sym_GT_GT] = ACTIONS(390),
    [anon_sym_PLUS_EQ] = ACTIONS(388),
    [anon_sym_DASH_EQ] = ACTIONS(388),
    [anon_sym_STAR_EQ] = ACTIONS(388),
    [anon_sym_SLASH_EQ] = ACTIONS(388),
    [anon_sym_PERCENT_EQ] = ACTIONS(388),
    [anon_sym_CARET_EQ] = ACTIONS(388),
    [anon_sym_AMP_EQ] = ACTIONS(388),
    [anon_sym_PIPE_EQ] = ACTIONS(388),
    [anon_sym_LT_LT_EQ] = ACTIONS(388),
    [anon_sym_GT_GT_EQ] = ACTIONS(388),
    [anon_sym_EQ] = ACTIONS(390),
    [anon_sym_EQ_EQ] = ACTIONS(388),
    [anon_sym_BANG_EQ] = ACTIONS(388),
    [anon_sym_GT] = ACTIONS(390),
    [anon_sym_LT] = ACTIONS(390),
    [anon_sym_GT_EQ] = ACTIONS(388),
    [anon_sym_LT_EQ] = ACTIONS(388),
    [anon_sym_DOT] = ACTIONS(390),
    [anon_sym_DOT_DOT] = ACTIONS(390),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(388),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(388),
    [anon_sym_COMMA] = ACTIONS(388),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(392),
    [anon_sym_as] = ACTIONS(390),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_else] = ACTIONS(390),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [40] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1483),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(40),
    [sym_block_comment] = STATE(40),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_SEMI] = ACTIONS(368),
    [anon_sym_LPAREN] = ACTIONS(368),
    [anon_sym_RPAREN] = ACTIONS(368),
    [anon_sym_LBRACK] = ACTIONS(368),
    [anon_sym_RBRACK] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_RBRACE] = ACTIONS(368),
    [anon_sym_PLUS] = ACTIONS(370),
    [anon_sym_STAR] = ACTIONS(370),
    [anon_sym_QMARK] = ACTIONS(368),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(370),
    [anon_sym_SLASH] = ACTIONS(370),
    [anon_sym_PERCENT] = ACTIONS(370),
    [anon_sym_CARET] = ACTIONS(370),
    [anon_sym_BANG] = ACTIONS(344),
    [anon_sym_AMP] = ACTIONS(370),
    [anon_sym_PIPE] = ACTIONS(370),
    [anon_sym_AMP_AMP] = ACTIONS(368),
    [anon_sym_PIPE_PIPE] = ACTIONS(368),
    [anon_sym_LT_LT] = ACTIONS(370),
    [anon_sym_GT_GT] = ACTIONS(370),
    [anon_sym_PLUS_EQ] = ACTIONS(368),
    [anon_sym_DASH_EQ] = ACTIONS(368),
    [anon_sym_STAR_EQ] = ACTIONS(368),
    [anon_sym_SLASH_EQ] = ACTIONS(368),
    [anon_sym_PERCENT_EQ] = ACTIONS(368),
    [anon_sym_CARET_EQ] = ACTIONS(368),
    [anon_sym_AMP_EQ] = ACTIONS(368),
    [anon_sym_PIPE_EQ] = ACTIONS(368),
    [anon_sym_LT_LT_EQ] = ACTIONS(368),
    [anon_sym_GT_GT_EQ] = ACTIONS(368),
    [anon_sym_EQ] = ACTIONS(370),
    [anon_sym_EQ_EQ] = ACTIONS(368),
    [anon_sym_BANG_EQ] = ACTIONS(368),
    [anon_sym_GT] = ACTIONS(370),
    [anon_sym_LT] = ACTIONS(370),
    [anon_sym_GT_EQ] = ACTIONS(368),
    [anon_sym_LT_EQ] = ACTIONS(368),
    [anon_sym_DOT] = ACTIONS(370),
    [anon_sym_DOT_DOT] = ACTIONS(370),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(368),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(368),
    [anon_sym_COMMA] = ACTIONS(368),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(370),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_else] = ACTIONS(370),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [41] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1475),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(41),
    [sym_block_comment] = STATE(41),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_SEMI] = ACTIONS(394),
    [anon_sym_LPAREN] = ACTIONS(394),
    [anon_sym_RPAREN] = ACTIONS(394),
    [anon_sym_LBRACK] = ACTIONS(394),
    [anon_sym_RBRACK] = ACTIONS(394),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_RBRACE] = ACTIONS(394),
    [anon_sym_PLUS] = ACTIONS(396),
    [anon_sym_STAR] = ACTIONS(396),
    [anon_sym_QMARK] = ACTIONS(394),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(396),
    [anon_sym_SLASH] = ACTIONS(396),
    [anon_sym_PERCENT] = ACTIONS(396),
    [anon_sym_CARET] = ACTIONS(396),
    [anon_sym_BANG] = ACTIONS(344),
    [anon_sym_AMP] = ACTIONS(396),
    [anon_sym_PIPE] = ACTIONS(396),
    [anon_sym_AMP_AMP] = ACTIONS(394),
    [anon_sym_PIPE_PIPE] = ACTIONS(394),
    [anon_sym_LT_LT] = ACTIONS(396),
    [anon_sym_GT_GT] = ACTIONS(396),
    [anon_sym_PLUS_EQ] = ACTIONS(394),
    [anon_sym_DASH_EQ] = ACTIONS(394),
    [anon_sym_STAR_EQ] = ACTIONS(394),
    [anon_sym_SLASH_EQ] = ACTIONS(394),
    [anon_sym_PERCENT_EQ] = ACTIONS(394),
    [anon_sym_CARET_EQ] = ACTIONS(394),
    [anon_sym_AMP_EQ] = ACTIONS(394),
    [anon_sym_PIPE_EQ] = ACTIONS(394),
    [anon_sym_LT_LT_EQ] = ACTIONS(394),
    [anon_sym_GT_GT_EQ] = ACTIONS(394),
    [anon_sym_EQ] = ACTIONS(396),
    [anon_sym_EQ_EQ] = ACTIONS(394),
    [anon_sym_BANG_EQ] = ACTIONS(394),
    [anon_sym_GT] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(396),
    [anon_sym_GT_EQ] = ACTIONS(394),
    [anon_sym_LT_EQ] = ACTIONS(394),
    [anon_sym_DOT] = ACTIONS(396),
    [anon_sym_DOT_DOT] = ACTIONS(396),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(394),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(394),
    [anon_sym_COMMA] = ACTIONS(394),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(396),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_else] = ACTIONS(396),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [42] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1475),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(42),
    [sym_block_comment] = STATE(42),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_SEMI] = ACTIONS(394),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(394),
    [anon_sym_LBRACK] = ACTIONS(394),
    [anon_sym_RBRACK] = ACTIONS(394),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_RBRACE] = ACTIONS(394),
    [anon_sym_PLUS] = ACTIONS(396),
    [anon_sym_STAR] = ACTIONS(396),
    [anon_sym_QMARK] = ACTIONS(394),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(396),
    [anon_sym_SLASH] = ACTIONS(396),
    [anon_sym_PERCENT] = ACTIONS(396),
    [anon_sym_CARET] = ACTIONS(396),
    [anon_sym_BANG] = ACTIONS(344),
    [anon_sym_AMP] = ACTIONS(396),
    [anon_sym_PIPE] = ACTIONS(396),
    [anon_sym_AMP_AMP] = ACTIONS(394),
    [anon_sym_PIPE_PIPE] = ACTIONS(394),
    [anon_sym_LT_LT] = ACTIONS(396),
    [anon_sym_GT_GT] = ACTIONS(396),
    [anon_sym_PLUS_EQ] = ACTIONS(394),
    [anon_sym_DASH_EQ] = ACTIONS(394),
    [anon_sym_STAR_EQ] = ACTIONS(394),
    [anon_sym_SLASH_EQ] = ACTIONS(394),
    [anon_sym_PERCENT_EQ] = ACTIONS(394),
    [anon_sym_CARET_EQ] = ACTIONS(394),
    [anon_sym_AMP_EQ] = ACTIONS(394),
    [anon_sym_PIPE_EQ] = ACTIONS(394),
    [anon_sym_LT_LT_EQ] = ACTIONS(394),
    [anon_sym_GT_GT_EQ] = ACTIONS(394),
    [anon_sym_EQ] = ACTIONS(396),
    [anon_sym_EQ_EQ] = ACTIONS(394),
    [anon_sym_BANG_EQ] = ACTIONS(394),
    [anon_sym_GT] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(396),
    [anon_sym_GT_EQ] = ACTIONS(394),
    [anon_sym_LT_EQ] = ACTIONS(394),
    [anon_sym_DOT] = ACTIONS(396),
    [anon_sym_DOT_DOT] = ACTIONS(396),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(394),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(394),
    [anon_sym_COMMA] = ACTIONS(394),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(396),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_else] = ACTIONS(396),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [43] = {
    [sym_bracketed_type] = STATE(3488),
    [sym_generic_function] = STATE(1685),
    [sym_generic_type_with_turbofish] = STATE(2915),
    [sym__expression_except_range] = STATE(1580),
    [sym__expression] = STATE(1681),
    [sym_macro_invocation] = STATE(1695),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3184),
    [sym_range_expression] = STATE(1689),
    [sym_unary_expression] = STATE(1685),
    [sym_try_expression] = STATE(1685),
    [sym_reference_expression] = STATE(1685),
    [sym_binary_expression] = STATE(1685),
    [sym_assignment_expression] = STATE(1685),
    [sym_compound_assignment_expr] = STATE(1685),
    [sym_type_cast_expression] = STATE(1685),
    [sym_return_expression] = STATE(1685),
    [sym_yield_expression] = STATE(1685),
    [sym_call_expression] = STATE(1685),
    [sym_array_expression] = STATE(1685),
    [sym_parenthesized_expression] = STATE(1685),
    [sym_tuple_expression] = STATE(1685),
    [sym_unit_expression] = STATE(1685),
    [sym_struct_expression] = STATE(1685),
    [sym_if_expression] = STATE(1685),
    [sym_match_expression] = STATE(1685),
    [sym_while_expression] = STATE(1685),
    [sym_loop_expression] = STATE(1685),
    [sym_for_expression] = STATE(1685),
    [sym_const_block] = STATE(1685),
    [sym_closure_expression] = STATE(1685),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3575),
    [sym_break_expression] = STATE(1685),
    [sym_continue_expression] = STATE(1685),
    [sym_index_expression] = STATE(1685),
    [sym_await_expression] = STATE(1685),
    [sym_field_expression] = STATE(1625),
    [sym_unsafe_block] = STATE(1685),
    [sym_async_block] = STATE(1685),
    [sym_try_block] = STATE(1685),
    [sym_block] = STATE(1685),
    [sym__literal] = STATE(1685),
    [sym_string_literal] = STATE(1831),
    [sym_raw_string_literal] = STATE(1831),
    [sym_boolean_literal] = STATE(1831),
    [sym_line_comment] = STATE(43),
    [sym_block_comment] = STATE(43),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(336),
    [anon_sym_LBRACK] = ACTIONS(336),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_EQ_GT] = ACTIONS(336),
    [anon_sym_COLON] = ACTIONS(402),
    [anon_sym_PLUS] = ACTIONS(342),
    [anon_sym_STAR] = ACTIONS(342),
    [anon_sym_QMARK] = ACTIONS(336),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(342),
    [anon_sym_SLASH] = ACTIONS(342),
    [anon_sym_PERCENT] = ACTIONS(342),
    [anon_sym_CARET] = ACTIONS(342),
    [anon_sym_BANG] = ACTIONS(406),
    [anon_sym_AMP] = ACTIONS(342),
    [anon_sym_PIPE] = ACTIONS(342),
    [anon_sym_AMP_AMP] = ACTIONS(336),
    [anon_sym_PIPE_PIPE] = ACTIONS(336),
    [anon_sym_LT_LT] = ACTIONS(342),
    [anon_sym_GT_GT] = ACTIONS(342),
    [anon_sym_PLUS_EQ] = ACTIONS(336),
    [anon_sym_DASH_EQ] = ACTIONS(336),
    [anon_sym_STAR_EQ] = ACTIONS(336),
    [anon_sym_SLASH_EQ] = ACTIONS(336),
    [anon_sym_PERCENT_EQ] = ACTIONS(336),
    [anon_sym_CARET_EQ] = ACTIONS(336),
    [anon_sym_AMP_EQ] = ACTIONS(336),
    [anon_sym_PIPE_EQ] = ACTIONS(336),
    [anon_sym_LT_LT_EQ] = ACTIONS(336),
    [anon_sym_GT_GT_EQ] = ACTIONS(336),
    [anon_sym_EQ] = ACTIONS(342),
    [anon_sym_EQ_EQ] = ACTIONS(336),
    [anon_sym_BANG_EQ] = ACTIONS(336),
    [anon_sym_GT] = ACTIONS(342),
    [anon_sym_LT] = ACTIONS(342),
    [anon_sym_GT_EQ] = ACTIONS(336),
    [anon_sym_LT_EQ] = ACTIONS(336),
    [anon_sym_DOT] = ACTIONS(342),
    [anon_sym_DOT_DOT] = ACTIONS(342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(336),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(336),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(342),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [44] = {
    [sym_bracketed_type] = STATE(3488),
    [sym_generic_function] = STATE(1685),
    [sym_generic_type_with_turbofish] = STATE(2915),
    [sym__expression_except_range] = STATE(1580),
    [sym__expression] = STATE(1719),
    [sym_macro_invocation] = STATE(1695),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3184),
    [sym_range_expression] = STATE(1689),
    [sym_unary_expression] = STATE(1685),
    [sym_try_expression] = STATE(1685),
    [sym_reference_expression] = STATE(1685),
    [sym_binary_expression] = STATE(1685),
    [sym_assignment_expression] = STATE(1685),
    [sym_compound_assignment_expr] = STATE(1685),
    [sym_type_cast_expression] = STATE(1685),
    [sym_return_expression] = STATE(1685),
    [sym_yield_expression] = STATE(1685),
    [sym_call_expression] = STATE(1685),
    [sym_array_expression] = STATE(1685),
    [sym_parenthesized_expression] = STATE(1685),
    [sym_tuple_expression] = STATE(1685),
    [sym_unit_expression] = STATE(1685),
    [sym_struct_expression] = STATE(1685),
    [sym_if_expression] = STATE(1685),
    [sym_match_expression] = STATE(1685),
    [sym_while_expression] = STATE(1685),
    [sym_loop_expression] = STATE(1685),
    [sym_for_expression] = STATE(1685),
    [sym_const_block] = STATE(1685),
    [sym_closure_expression] = STATE(1685),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3575),
    [sym_break_expression] = STATE(1685),
    [sym_continue_expression] = STATE(1685),
    [sym_index_expression] = STATE(1685),
    [sym_await_expression] = STATE(1685),
    [sym_field_expression] = STATE(1625),
    [sym_unsafe_block] = STATE(1685),
    [sym_async_block] = STATE(1685),
    [sym_try_block] = STATE(1685),
    [sym_block] = STATE(1685),
    [sym__literal] = STATE(1685),
    [sym_string_literal] = STATE(1831),
    [sym_raw_string_literal] = STATE(1831),
    [sym_boolean_literal] = STATE(1831),
    [sym_line_comment] = STATE(44),
    [sym_block_comment] = STATE(44),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(368),
    [anon_sym_LBRACK] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_EQ_GT] = ACTIONS(368),
    [anon_sym_PLUS] = ACTIONS(370),
    [anon_sym_STAR] = ACTIONS(370),
    [anon_sym_QMARK] = ACTIONS(368),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(370),
    [anon_sym_SLASH] = ACTIONS(370),
    [anon_sym_PERCENT] = ACTIONS(370),
    [anon_sym_CARET] = ACTIONS(370),
    [anon_sym_BANG] = ACTIONS(406),
    [anon_sym_AMP] = ACTIONS(370),
    [anon_sym_PIPE] = ACTIONS(370),
    [anon_sym_AMP_AMP] = ACTIONS(368),
    [anon_sym_PIPE_PIPE] = ACTIONS(368),
    [anon_sym_LT_LT] = ACTIONS(370),
    [anon_sym_GT_GT] = ACTIONS(370),
    [anon_sym_PLUS_EQ] = ACTIONS(368),
    [anon_sym_DASH_EQ] = ACTIONS(368),
    [anon_sym_STAR_EQ] = ACTIONS(368),
    [anon_sym_SLASH_EQ] = ACTIONS(368),
    [anon_sym_PERCENT_EQ] = ACTIONS(368),
    [anon_sym_CARET_EQ] = ACTIONS(368),
    [anon_sym_AMP_EQ] = ACTIONS(368),
    [anon_sym_PIPE_EQ] = ACTIONS(368),
    [anon_sym_LT_LT_EQ] = ACTIONS(368),
    [anon_sym_GT_GT_EQ] = ACTIONS(368),
    [anon_sym_EQ] = ACTIONS(370),
    [anon_sym_EQ_EQ] = ACTIONS(368),
    [anon_sym_BANG_EQ] = ACTIONS(368),
    [anon_sym_GT] = ACTIONS(370),
    [anon_sym_LT] = ACTIONS(370),
    [anon_sym_GT_EQ] = ACTIONS(368),
    [anon_sym_LT_EQ] = ACTIONS(368),
    [anon_sym_DOT] = ACTIONS(370),
    [anon_sym_DOT_DOT] = ACTIONS(370),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(368),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(368),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(370),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [45] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1579),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(45),
    [sym_block_comment] = STATE(45),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(336),
    [anon_sym_LBRACK] = ACTIONS(336),
    [anon_sym_LBRACE] = ACTIONS(336),
    [anon_sym_COLON] = ACTIONS(340),
    [anon_sym_PLUS] = ACTIONS(342),
    [anon_sym_STAR] = ACTIONS(342),
    [anon_sym_QMARK] = ACTIONS(336),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(342),
    [anon_sym_SLASH] = ACTIONS(342),
    [anon_sym_PERCENT] = ACTIONS(342),
    [anon_sym_CARET] = ACTIONS(342),
    [anon_sym_BANG] = ACTIONS(460),
    [anon_sym_AMP] = ACTIONS(342),
    [anon_sym_PIPE] = ACTIONS(342),
    [anon_sym_AMP_AMP] = ACTIONS(336),
    [anon_sym_PIPE_PIPE] = ACTIONS(336),
    [anon_sym_LT_LT] = ACTIONS(342),
    [anon_sym_GT_GT] = ACTIONS(342),
    [anon_sym_PLUS_EQ] = ACTIONS(336),
    [anon_sym_DASH_EQ] = ACTIONS(336),
    [anon_sym_STAR_EQ] = ACTIONS(336),
    [anon_sym_SLASH_EQ] = ACTIONS(336),
    [anon_sym_PERCENT_EQ] = ACTIONS(336),
    [anon_sym_CARET_EQ] = ACTIONS(336),
    [anon_sym_AMP_EQ] = ACTIONS(336),
    [anon_sym_PIPE_EQ] = ACTIONS(336),
    [anon_sym_LT_LT_EQ] = ACTIONS(336),
    [anon_sym_GT_GT_EQ] = ACTIONS(336),
    [anon_sym_EQ] = ACTIONS(342),
    [anon_sym_EQ_EQ] = ACTIONS(336),
    [anon_sym_BANG_EQ] = ACTIONS(336),
    [anon_sym_GT] = ACTIONS(342),
    [anon_sym_LT] = ACTIONS(342),
    [anon_sym_GT_EQ] = ACTIONS(336),
    [anon_sym_LT_EQ] = ACTIONS(336),
    [anon_sym_DOT] = ACTIONS(342),
    [anon_sym_DOT_DOT] = ACTIONS(342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(336),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(336),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(342),
    [anon_sym_as] = ACTIONS(342),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(466),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(472),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(474),
    [anon_sym_move] = ACTIONS(476),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [46] = {
    [sym_bracketed_type] = STATE(3488),
    [sym_generic_function] = STATE(1685),
    [sym_generic_type_with_turbofish] = STATE(2915),
    [sym__expression_except_range] = STATE(1580),
    [sym__expression] = STATE(1724),
    [sym_macro_invocation] = STATE(1695),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3184),
    [sym_range_expression] = STATE(1689),
    [sym_unary_expression] = STATE(1685),
    [sym_try_expression] = STATE(1685),
    [sym_reference_expression] = STATE(1685),
    [sym_binary_expression] = STATE(1685),
    [sym_assignment_expression] = STATE(1685),
    [sym_compound_assignment_expr] = STATE(1685),
    [sym_type_cast_expression] = STATE(1685),
    [sym_return_expression] = STATE(1685),
    [sym_yield_expression] = STATE(1685),
    [sym_call_expression] = STATE(1685),
    [sym_array_expression] = STATE(1685),
    [sym_parenthesized_expression] = STATE(1685),
    [sym_tuple_expression] = STATE(1685),
    [sym_unit_expression] = STATE(1685),
    [sym_struct_expression] = STATE(1685),
    [sym_if_expression] = STATE(1685),
    [sym_match_expression] = STATE(1685),
    [sym_while_expression] = STATE(1685),
    [sym_loop_expression] = STATE(1685),
    [sym_for_expression] = STATE(1685),
    [sym_const_block] = STATE(1685),
    [sym_closure_expression] = STATE(1685),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(43),
    [sym_break_expression] = STATE(1685),
    [sym_continue_expression] = STATE(1685),
    [sym_index_expression] = STATE(1685),
    [sym_await_expression] = STATE(1685),
    [sym_field_expression] = STATE(1625),
    [sym_unsafe_block] = STATE(1685),
    [sym_async_block] = STATE(1685),
    [sym_try_block] = STATE(1685),
    [sym_block] = STATE(1685),
    [sym__literal] = STATE(1685),
    [sym_string_literal] = STATE(1831),
    [sym_raw_string_literal] = STATE(1831),
    [sym_boolean_literal] = STATE(1831),
    [sym_line_comment] = STATE(46),
    [sym_block_comment] = STATE(46),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(388),
    [anon_sym_LBRACK] = ACTIONS(388),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_EQ_GT] = ACTIONS(388),
    [anon_sym_PLUS] = ACTIONS(390),
    [anon_sym_STAR] = ACTIONS(390),
    [anon_sym_QMARK] = ACTIONS(388),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(390),
    [anon_sym_SLASH] = ACTIONS(390),
    [anon_sym_PERCENT] = ACTIONS(390),
    [anon_sym_CARET] = ACTIONS(390),
    [anon_sym_BANG] = ACTIONS(406),
    [anon_sym_AMP] = ACTIONS(390),
    [anon_sym_PIPE] = ACTIONS(390),
    [anon_sym_AMP_AMP] = ACTIONS(388),
    [anon_sym_PIPE_PIPE] = ACTIONS(388),
    [anon_sym_LT_LT] = ACTIONS(390),
    [anon_sym_GT_GT] = ACTIONS(390),
    [anon_sym_PLUS_EQ] = ACTIONS(388),
    [anon_sym_DASH_EQ] = ACTIONS(388),
    [anon_sym_STAR_EQ] = ACTIONS(388),
    [anon_sym_SLASH_EQ] = ACTIONS(388),
    [anon_sym_PERCENT_EQ] = ACTIONS(388),
    [anon_sym_CARET_EQ] = ACTIONS(388),
    [anon_sym_AMP_EQ] = ACTIONS(388),
    [anon_sym_PIPE_EQ] = ACTIONS(388),
    [anon_sym_LT_LT_EQ] = ACTIONS(388),
    [anon_sym_GT_GT_EQ] = ACTIONS(388),
    [anon_sym_EQ] = ACTIONS(390),
    [anon_sym_EQ_EQ] = ACTIONS(388),
    [anon_sym_BANG_EQ] = ACTIONS(388),
    [anon_sym_GT] = ACTIONS(390),
    [anon_sym_LT] = ACTIONS(390),
    [anon_sym_GT_EQ] = ACTIONS(388),
    [anon_sym_LT_EQ] = ACTIONS(388),
    [anon_sym_DOT] = ACTIONS(390),
    [anon_sym_DOT_DOT] = ACTIONS(390),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(388),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(388),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [anon_sym_as] = ACTIONS(390),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [47] = {
    [sym_bracketed_type] = STATE(3488),
    [sym_generic_function] = STATE(1685),
    [sym_generic_type_with_turbofish] = STATE(2915),
    [sym__expression_except_range] = STATE(1580),
    [sym__expression] = STATE(1732),
    [sym_macro_invocation] = STATE(1695),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3184),
    [sym_range_expression] = STATE(1689),
    [sym_unary_expression] = STATE(1685),
    [sym_try_expression] = STATE(1685),
    [sym_reference_expression] = STATE(1685),
    [sym_binary_expression] = STATE(1685),
    [sym_assignment_expression] = STATE(1685),
    [sym_compound_assignment_expr] = STATE(1685),
    [sym_type_cast_expression] = STATE(1685),
    [sym_return_expression] = STATE(1685),
    [sym_yield_expression] = STATE(1685),
    [sym_call_expression] = STATE(1685),
    [sym_array_expression] = STATE(1685),
    [sym_parenthesized_expression] = STATE(1685),
    [sym_tuple_expression] = STATE(1685),
    [sym_unit_expression] = STATE(1685),
    [sym_struct_expression] = STATE(1685),
    [sym_if_expression] = STATE(1685),
    [sym_match_expression] = STATE(1685),
    [sym_while_expression] = STATE(1685),
    [sym_loop_expression] = STATE(1685),
    [sym_for_expression] = STATE(1685),
    [sym_const_block] = STATE(1685),
    [sym_closure_expression] = STATE(1685),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3575),
    [sym_break_expression] = STATE(1685),
    [sym_continue_expression] = STATE(1685),
    [sym_index_expression] = STATE(1685),
    [sym_await_expression] = STATE(1685),
    [sym_field_expression] = STATE(1625),
    [sym_unsafe_block] = STATE(1685),
    [sym_async_block] = STATE(1685),
    [sym_try_block] = STATE(1685),
    [sym_block] = STATE(1685),
    [sym__literal] = STATE(1685),
    [sym_string_literal] = STATE(1831),
    [sym_raw_string_literal] = STATE(1831),
    [sym_boolean_literal] = STATE(1831),
    [sym_line_comment] = STATE(47),
    [sym_block_comment] = STATE(47),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_LBRACK] = ACTIONS(488),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_EQ_GT] = ACTIONS(372),
    [anon_sym_PLUS] = ACTIONS(374),
    [anon_sym_STAR] = ACTIONS(406),
    [anon_sym_QMARK] = ACTIONS(372),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(406),
    [anon_sym_SLASH] = ACTIONS(374),
    [anon_sym_PERCENT] = ACTIONS(374),
    [anon_sym_CARET] = ACTIONS(374),
    [anon_sym_BANG] = ACTIONS(406),
    [anon_sym_AMP] = ACTIONS(490),
    [anon_sym_PIPE] = ACTIONS(378),
    [anon_sym_AMP_AMP] = ACTIONS(372),
    [anon_sym_PIPE_PIPE] = ACTIONS(372),
    [anon_sym_LT_LT] = ACTIONS(374),
    [anon_sym_GT_GT] = ACTIONS(374),
    [anon_sym_PLUS_EQ] = ACTIONS(372),
    [anon_sym_DASH_EQ] = ACTIONS(372),
    [anon_sym_STAR_EQ] = ACTIONS(372),
    [anon_sym_SLASH_EQ] = ACTIONS(372),
    [anon_sym_PERCENT_EQ] = ACTIONS(372),
    [anon_sym_CARET_EQ] = ACTIONS(372),
    [anon_sym_AMP_EQ] = ACTIONS(372),
    [anon_sym_PIPE_EQ] = ACTIONS(372),
    [anon_sym_LT_LT_EQ] = ACTIONS(372),
    [anon_sym_GT_GT_EQ] = ACTIONS(372),
    [anon_sym_EQ] = ACTIONS(374),
    [anon_sym_EQ_EQ] = ACTIONS(372),
    [anon_sym_BANG_EQ] = ACTIONS(372),
    [anon_sym_GT] = ACTIONS(374),
    [anon_sym_LT] = ACTIONS(380),
    [anon_sym_GT_EQ] = ACTIONS(372),
    [anon_sym_LT_EQ] = ACTIONS(372),
    [anon_sym_DOT] = ACTIONS(374),
    [anon_sym_DOT_DOT] = ACTIONS(492),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(372),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(372),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(374),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [48] = {
    [sym_bracketed_type] = STATE(3488),
    [sym_generic_function] = STATE(1685),
    [sym_generic_type_with_turbofish] = STATE(2915),
    [sym__expression_except_range] = STATE(1580),
    [sym__expression] = STATE(1735),
    [sym_macro_invocation] = STATE(1695),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3184),
    [sym_range_expression] = STATE(1689),
    [sym_unary_expression] = STATE(1685),
    [sym_try_expression] = STATE(1685),
    [sym_reference_expression] = STATE(1685),
    [sym_binary_expression] = STATE(1685),
    [sym_assignment_expression] = STATE(1685),
    [sym_compound_assignment_expr] = STATE(1685),
    [sym_type_cast_expression] = STATE(1685),
    [sym_return_expression] = STATE(1685),
    [sym_yield_expression] = STATE(1685),
    [sym_call_expression] = STATE(1685),
    [sym_array_expression] = STATE(1685),
    [sym_parenthesized_expression] = STATE(1685),
    [sym_tuple_expression] = STATE(1685),
    [sym_unit_expression] = STATE(1685),
    [sym_struct_expression] = STATE(1685),
    [sym_if_expression] = STATE(1685),
    [sym_match_expression] = STATE(1685),
    [sym_while_expression] = STATE(1685),
    [sym_loop_expression] = STATE(1685),
    [sym_for_expression] = STATE(1685),
    [sym_const_block] = STATE(1685),
    [sym_closure_expression] = STATE(1685),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3575),
    [sym_break_expression] = STATE(1685),
    [sym_continue_expression] = STATE(1685),
    [sym_index_expression] = STATE(1685),
    [sym_await_expression] = STATE(1685),
    [sym_field_expression] = STATE(1625),
    [sym_unsafe_block] = STATE(1685),
    [sym_async_block] = STATE(1685),
    [sym_try_block] = STATE(1685),
    [sym_block] = STATE(1685),
    [sym__literal] = STATE(1685),
    [sym_string_literal] = STATE(1831),
    [sym_raw_string_literal] = STATE(1831),
    [sym_boolean_literal] = STATE(1831),
    [sym_line_comment] = STATE(48),
    [sym_block_comment] = STATE(48),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_LBRACK] = ACTIONS(488),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_EQ_GT] = ACTIONS(384),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_STAR] = ACTIONS(406),
    [anon_sym_QMARK] = ACTIONS(384),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(406),
    [anon_sym_SLASH] = ACTIONS(386),
    [anon_sym_PERCENT] = ACTIONS(386),
    [anon_sym_CARET] = ACTIONS(386),
    [anon_sym_BANG] = ACTIONS(406),
    [anon_sym_AMP] = ACTIONS(490),
    [anon_sym_PIPE] = ACTIONS(378),
    [anon_sym_AMP_AMP] = ACTIONS(384),
    [anon_sym_PIPE_PIPE] = ACTIONS(384),
    [anon_sym_LT_LT] = ACTIONS(386),
    [anon_sym_GT_GT] = ACTIONS(386),
    [anon_sym_PLUS_EQ] = ACTIONS(384),
    [anon_sym_DASH_EQ] = ACTIONS(384),
    [anon_sym_STAR_EQ] = ACTIONS(384),
    [anon_sym_SLASH_EQ] = ACTIONS(384),
    [anon_sym_PERCENT_EQ] = ACTIONS(384),
    [anon_sym_CARET_EQ] = ACTIONS(384),
    [anon_sym_AMP_EQ] = ACTIONS(384),
    [anon_sym_PIPE_EQ] = ACTIONS(384),
    [anon_sym_LT_LT_EQ] = ACTIONS(384),
    [anon_sym_GT_GT_EQ] = ACTIONS(384),
    [anon_sym_EQ] = ACTIONS(386),
    [anon_sym_EQ_EQ] = ACTIONS(384),
    [anon_sym_BANG_EQ] = ACTIONS(384),
    [anon_sym_GT] = ACTIONS(386),
    [anon_sym_LT] = ACTIONS(380),
    [anon_sym_GT_EQ] = ACTIONS(384),
    [anon_sym_LT_EQ] = ACTIONS(384),
    [anon_sym_DOT] = ACTIONS(386),
    [anon_sym_DOT_DOT] = ACTIONS(492),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(384),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(384),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(386),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [49] = {
    [sym_bracketed_type] = STATE(3488),
    [sym_generic_function] = STATE(1685),
    [sym_generic_type_with_turbofish] = STATE(2915),
    [sym__expression_except_range] = STATE(1580),
    [sym__expression] = STATE(1719),
    [sym_macro_invocation] = STATE(1695),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3184),
    [sym_range_expression] = STATE(1689),
    [sym_unary_expression] = STATE(1685),
    [sym_try_expression] = STATE(1685),
    [sym_reference_expression] = STATE(1685),
    [sym_binary_expression] = STATE(1685),
    [sym_assignment_expression] = STATE(1685),
    [sym_compound_assignment_expr] = STATE(1685),
    [sym_type_cast_expression] = STATE(1685),
    [sym_return_expression] = STATE(1685),
    [sym_yield_expression] = STATE(1685),
    [sym_call_expression] = STATE(1685),
    [sym_array_expression] = STATE(1685),
    [sym_parenthesized_expression] = STATE(1685),
    [sym_tuple_expression] = STATE(1685),
    [sym_unit_expression] = STATE(1685),
    [sym_struct_expression] = STATE(1685),
    [sym_if_expression] = STATE(1685),
    [sym_match_expression] = STATE(1685),
    [sym_while_expression] = STATE(1685),
    [sym_loop_expression] = STATE(1685),
    [sym_for_expression] = STATE(1685),
    [sym_const_block] = STATE(1685),
    [sym_closure_expression] = STATE(1685),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3575),
    [sym_break_expression] = STATE(1685),
    [sym_continue_expression] = STATE(1685),
    [sym_index_expression] = STATE(1685),
    [sym_await_expression] = STATE(1685),
    [sym_field_expression] = STATE(1625),
    [sym_unsafe_block] = STATE(1685),
    [sym_async_block] = STATE(1685),
    [sym_try_block] = STATE(1685),
    [sym_block] = STATE(1685),
    [sym__literal] = STATE(1685),
    [sym_string_literal] = STATE(1831),
    [sym_raw_string_literal] = STATE(1831),
    [sym_boolean_literal] = STATE(1831),
    [sym_line_comment] = STATE(49),
    [sym_block_comment] = STATE(49),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_LBRACK] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_EQ_GT] = ACTIONS(368),
    [anon_sym_PLUS] = ACTIONS(370),
    [anon_sym_STAR] = ACTIONS(370),
    [anon_sym_QMARK] = ACTIONS(368),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(370),
    [anon_sym_SLASH] = ACTIONS(370),
    [anon_sym_PERCENT] = ACTIONS(370),
    [anon_sym_CARET] = ACTIONS(370),
    [anon_sym_BANG] = ACTIONS(406),
    [anon_sym_AMP] = ACTIONS(370),
    [anon_sym_PIPE] = ACTIONS(370),
    [anon_sym_AMP_AMP] = ACTIONS(368),
    [anon_sym_PIPE_PIPE] = ACTIONS(368),
    [anon_sym_LT_LT] = ACTIONS(370),
    [anon_sym_GT_GT] = ACTIONS(370),
    [anon_sym_PLUS_EQ] = ACTIONS(368),
    [anon_sym_DASH_EQ] = ACTIONS(368),
    [anon_sym_STAR_EQ] = ACTIONS(368),
    [anon_sym_SLASH_EQ] = ACTIONS(368),
    [anon_sym_PERCENT_EQ] = ACTIONS(368),
    [anon_sym_CARET_EQ] = ACTIONS(368),
    [anon_sym_AMP_EQ] = ACTIONS(368),
    [anon_sym_PIPE_EQ] = ACTIONS(368),
    [anon_sym_LT_LT_EQ] = ACTIONS(368),
    [anon_sym_GT_GT_EQ] = ACTIONS(368),
    [anon_sym_EQ] = ACTIONS(370),
    [anon_sym_EQ_EQ] = ACTIONS(368),
    [anon_sym_BANG_EQ] = ACTIONS(368),
    [anon_sym_GT] = ACTIONS(370),
    [anon_sym_LT] = ACTIONS(370),
    [anon_sym_GT_EQ] = ACTIONS(368),
    [anon_sym_LT_EQ] = ACTIONS(368),
    [anon_sym_DOT] = ACTIONS(370),
    [anon_sym_DOT_DOT] = ACTIONS(370),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(368),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(368),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(370),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [50] = {
    [sym_bracketed_type] = STATE(3488),
    [sym_generic_function] = STATE(1685),
    [sym_generic_type_with_turbofish] = STATE(2915),
    [sym__expression_except_range] = STATE(1580),
    [sym__expression] = STATE(1636),
    [sym_macro_invocation] = STATE(1695),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3184),
    [sym_range_expression] = STATE(1689),
    [sym_unary_expression] = STATE(1685),
    [sym_try_expression] = STATE(1685),
    [sym_reference_expression] = STATE(1685),
    [sym_binary_expression] = STATE(1685),
    [sym_assignment_expression] = STATE(1685),
    [sym_compound_assignment_expr] = STATE(1685),
    [sym_type_cast_expression] = STATE(1685),
    [sym_return_expression] = STATE(1685),
    [sym_yield_expression] = STATE(1685),
    [sym_call_expression] = STATE(1685),
    [sym_array_expression] = STATE(1685),
    [sym_parenthesized_expression] = STATE(1685),
    [sym_tuple_expression] = STATE(1685),
    [sym_unit_expression] = STATE(1685),
    [sym_struct_expression] = STATE(1685),
    [sym_if_expression] = STATE(1685),
    [sym_match_expression] = STATE(1685),
    [sym_while_expression] = STATE(1685),
    [sym_loop_expression] = STATE(1685),
    [sym_for_expression] = STATE(1685),
    [sym_const_block] = STATE(1685),
    [sym_closure_expression] = STATE(1685),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3575),
    [sym_break_expression] = STATE(1685),
    [sym_continue_expression] = STATE(1685),
    [sym_index_expression] = STATE(1685),
    [sym_await_expression] = STATE(1685),
    [sym_field_expression] = STATE(1625),
    [sym_unsafe_block] = STATE(1685),
    [sym_async_block] = STATE(1685),
    [sym_try_block] = STATE(1685),
    [sym_block] = STATE(1685),
    [sym__literal] = STATE(1685),
    [sym_string_literal] = STATE(1831),
    [sym_raw_string_literal] = STATE(1831),
    [sym_boolean_literal] = STATE(1831),
    [sym_line_comment] = STATE(50),
    [sym_block_comment] = STATE(50),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_LBRACK] = ACTIONS(394),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_EQ_GT] = ACTIONS(394),
    [anon_sym_PLUS] = ACTIONS(396),
    [anon_sym_STAR] = ACTIONS(396),
    [anon_sym_QMARK] = ACTIONS(394),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(396),
    [anon_sym_SLASH] = ACTIONS(396),
    [anon_sym_PERCENT] = ACTIONS(396),
    [anon_sym_CARET] = ACTIONS(396),
    [anon_sym_BANG] = ACTIONS(406),
    [anon_sym_AMP] = ACTIONS(396),
    [anon_sym_PIPE] = ACTIONS(396),
    [anon_sym_AMP_AMP] = ACTIONS(394),
    [anon_sym_PIPE_PIPE] = ACTIONS(394),
    [anon_sym_LT_LT] = ACTIONS(396),
    [anon_sym_GT_GT] = ACTIONS(396),
    [anon_sym_PLUS_EQ] = ACTIONS(394),
    [anon_sym_DASH_EQ] = ACTIONS(394),
    [anon_sym_STAR_EQ] = ACTIONS(394),
    [anon_sym_SLASH_EQ] = ACTIONS(394),
    [anon_sym_PERCENT_EQ] = ACTIONS(394),
    [anon_sym_CARET_EQ] = ACTIONS(394),
    [anon_sym_AMP_EQ] = ACTIONS(394),
    [anon_sym_PIPE_EQ] = ACTIONS(394),
    [anon_sym_LT_LT_EQ] = ACTIONS(394),
    [anon_sym_GT_GT_EQ] = ACTIONS(394),
    [anon_sym_EQ] = ACTIONS(396),
    [anon_sym_EQ_EQ] = ACTIONS(394),
    [anon_sym_BANG_EQ] = ACTIONS(394),
    [anon_sym_GT] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(396),
    [anon_sym_GT_EQ] = ACTIONS(394),
    [anon_sym_LT_EQ] = ACTIONS(394),
    [anon_sym_DOT] = ACTIONS(396),
    [anon_sym_DOT_DOT] = ACTIONS(396),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(394),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(394),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(396),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [51] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1729),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(225),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(51),
    [sym_block_comment] = STATE(51),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(336),
    [anon_sym_LBRACK] = ACTIONS(336),
    [anon_sym_LBRACE] = ACTIONS(336),
    [anon_sym_COLON] = ACTIONS(340),
    [anon_sym_PLUS] = ACTIONS(342),
    [anon_sym_STAR] = ACTIONS(342),
    [anon_sym_QMARK] = ACTIONS(336),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(342),
    [anon_sym_SLASH] = ACTIONS(342),
    [anon_sym_PERCENT] = ACTIONS(342),
    [anon_sym_CARET] = ACTIONS(342),
    [anon_sym_BANG] = ACTIONS(494),
    [anon_sym_AMP] = ACTIONS(342),
    [anon_sym_PIPE] = ACTIONS(342),
    [anon_sym_AMP_AMP] = ACTIONS(336),
    [anon_sym_PIPE_PIPE] = ACTIONS(336),
    [anon_sym_LT_LT] = ACTIONS(342),
    [anon_sym_GT_GT] = ACTIONS(342),
    [anon_sym_PLUS_EQ] = ACTIONS(336),
    [anon_sym_DASH_EQ] = ACTIONS(336),
    [anon_sym_STAR_EQ] = ACTIONS(336),
    [anon_sym_SLASH_EQ] = ACTIONS(336),
    [anon_sym_PERCENT_EQ] = ACTIONS(336),
    [anon_sym_CARET_EQ] = ACTIONS(336),
    [anon_sym_AMP_EQ] = ACTIONS(336),
    [anon_sym_PIPE_EQ] = ACTIONS(336),
    [anon_sym_LT_LT_EQ] = ACTIONS(336),
    [anon_sym_GT_GT_EQ] = ACTIONS(336),
    [anon_sym_EQ] = ACTIONS(342),
    [anon_sym_EQ_EQ] = ACTIONS(336),
    [anon_sym_BANG_EQ] = ACTIONS(336),
    [anon_sym_GT] = ACTIONS(342),
    [anon_sym_LT] = ACTIONS(342),
    [anon_sym_GT_EQ] = ACTIONS(336),
    [anon_sym_LT_EQ] = ACTIONS(336),
    [anon_sym_DOT] = ACTIONS(342),
    [anon_sym_DOT_DOT] = ACTIONS(342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(336),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(336),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(342),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(496),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [52] = {
    [sym_bracketed_type] = STATE(3488),
    [sym_generic_function] = STATE(1685),
    [sym_generic_type_with_turbofish] = STATE(2915),
    [sym__expression_except_range] = STATE(1580),
    [sym__expression] = STATE(1636),
    [sym_macro_invocation] = STATE(1695),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3184),
    [sym_range_expression] = STATE(1689),
    [sym_unary_expression] = STATE(1685),
    [sym_try_expression] = STATE(1685),
    [sym_reference_expression] = STATE(1685),
    [sym_binary_expression] = STATE(1685),
    [sym_assignment_expression] = STATE(1685),
    [sym_compound_assignment_expr] = STATE(1685),
    [sym_type_cast_expression] = STATE(1685),
    [sym_return_expression] = STATE(1685),
    [sym_yield_expression] = STATE(1685),
    [sym_call_expression] = STATE(1685),
    [sym_array_expression] = STATE(1685),
    [sym_parenthesized_expression] = STATE(1685),
    [sym_tuple_expression] = STATE(1685),
    [sym_unit_expression] = STATE(1685),
    [sym_struct_expression] = STATE(1685),
    [sym_if_expression] = STATE(1685),
    [sym_match_expression] = STATE(1685),
    [sym_while_expression] = STATE(1685),
    [sym_loop_expression] = STATE(1685),
    [sym_for_expression] = STATE(1685),
    [sym_const_block] = STATE(1685),
    [sym_closure_expression] = STATE(1685),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3575),
    [sym_break_expression] = STATE(1685),
    [sym_continue_expression] = STATE(1685),
    [sym_index_expression] = STATE(1685),
    [sym_await_expression] = STATE(1685),
    [sym_field_expression] = STATE(1625),
    [sym_unsafe_block] = STATE(1685),
    [sym_async_block] = STATE(1685),
    [sym_try_block] = STATE(1685),
    [sym_block] = STATE(1685),
    [sym__literal] = STATE(1685),
    [sym_string_literal] = STATE(1831),
    [sym_raw_string_literal] = STATE(1831),
    [sym_boolean_literal] = STATE(1831),
    [sym_line_comment] = STATE(52),
    [sym_block_comment] = STATE(52),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(394),
    [anon_sym_LBRACK] = ACTIONS(394),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_EQ_GT] = ACTIONS(394),
    [anon_sym_PLUS] = ACTIONS(396),
    [anon_sym_STAR] = ACTIONS(396),
    [anon_sym_QMARK] = ACTIONS(394),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(396),
    [anon_sym_SLASH] = ACTIONS(396),
    [anon_sym_PERCENT] = ACTIONS(396),
    [anon_sym_CARET] = ACTIONS(396),
    [anon_sym_BANG] = ACTIONS(406),
    [anon_sym_AMP] = ACTIONS(396),
    [anon_sym_PIPE] = ACTIONS(396),
    [anon_sym_AMP_AMP] = ACTIONS(394),
    [anon_sym_PIPE_PIPE] = ACTIONS(394),
    [anon_sym_LT_LT] = ACTIONS(396),
    [anon_sym_GT_GT] = ACTIONS(396),
    [anon_sym_PLUS_EQ] = ACTIONS(394),
    [anon_sym_DASH_EQ] = ACTIONS(394),
    [anon_sym_STAR_EQ] = ACTIONS(394),
    [anon_sym_SLASH_EQ] = ACTIONS(394),
    [anon_sym_PERCENT_EQ] = ACTIONS(394),
    [anon_sym_CARET_EQ] = ACTIONS(394),
    [anon_sym_AMP_EQ] = ACTIONS(394),
    [anon_sym_PIPE_EQ] = ACTIONS(394),
    [anon_sym_LT_LT_EQ] = ACTIONS(394),
    [anon_sym_GT_GT_EQ] = ACTIONS(394),
    [anon_sym_EQ] = ACTIONS(396),
    [anon_sym_EQ_EQ] = ACTIONS(394),
    [anon_sym_BANG_EQ] = ACTIONS(394),
    [anon_sym_GT] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(396),
    [anon_sym_GT_EQ] = ACTIONS(394),
    [anon_sym_LT_EQ] = ACTIONS(394),
    [anon_sym_DOT] = ACTIONS(396),
    [anon_sym_DOT_DOT] = ACTIONS(396),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(394),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(394),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(396),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [53] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1612),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(53),
    [sym_block_comment] = STATE(53),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_STAR] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(384),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(460),
    [anon_sym_SLASH] = ACTIONS(386),
    [anon_sym_PERCENT] = ACTIONS(386),
    [anon_sym_CARET] = ACTIONS(386),
    [anon_sym_BANG] = ACTIONS(460),
    [anon_sym_AMP] = ACTIONS(506),
    [anon_sym_PIPE] = ACTIONS(378),
    [anon_sym_AMP_AMP] = ACTIONS(384),
    [anon_sym_PIPE_PIPE] = ACTIONS(384),
    [anon_sym_LT_LT] = ACTIONS(386),
    [anon_sym_GT_GT] = ACTIONS(386),
    [anon_sym_PLUS_EQ] = ACTIONS(384),
    [anon_sym_DASH_EQ] = ACTIONS(384),
    [anon_sym_STAR_EQ] = ACTIONS(384),
    [anon_sym_SLASH_EQ] = ACTIONS(384),
    [anon_sym_PERCENT_EQ] = ACTIONS(384),
    [anon_sym_CARET_EQ] = ACTIONS(384),
    [anon_sym_AMP_EQ] = ACTIONS(384),
    [anon_sym_PIPE_EQ] = ACTIONS(384),
    [anon_sym_LT_LT_EQ] = ACTIONS(384),
    [anon_sym_GT_GT_EQ] = ACTIONS(384),
    [anon_sym_EQ] = ACTIONS(386),
    [anon_sym_EQ_EQ] = ACTIONS(384),
    [anon_sym_BANG_EQ] = ACTIONS(384),
    [anon_sym_GT] = ACTIONS(386),
    [anon_sym_LT] = ACTIONS(380),
    [anon_sym_GT_EQ] = ACTIONS(384),
    [anon_sym_LT_EQ] = ACTIONS(384),
    [anon_sym_DOT] = ACTIONS(386),
    [anon_sym_DOT_DOT] = ACTIONS(508),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(384),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(384),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(386),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(466),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(472),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(474),
    [anon_sym_move] = ACTIONS(476),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [54] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1672),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(225),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(54),
    [sym_block_comment] = STATE(54),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(368),
    [anon_sym_PLUS] = ACTIONS(370),
    [anon_sym_STAR] = ACTIONS(370),
    [anon_sym_QMARK] = ACTIONS(368),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(370),
    [anon_sym_SLASH] = ACTIONS(370),
    [anon_sym_PERCENT] = ACTIONS(370),
    [anon_sym_CARET] = ACTIONS(370),
    [anon_sym_BANG] = ACTIONS(494),
    [anon_sym_AMP] = ACTIONS(370),
    [anon_sym_PIPE] = ACTIONS(370),
    [anon_sym_AMP_AMP] = ACTIONS(368),
    [anon_sym_PIPE_PIPE] = ACTIONS(368),
    [anon_sym_LT_LT] = ACTIONS(370),
    [anon_sym_GT_GT] = ACTIONS(370),
    [anon_sym_PLUS_EQ] = ACTIONS(368),
    [anon_sym_DASH_EQ] = ACTIONS(368),
    [anon_sym_STAR_EQ] = ACTIONS(368),
    [anon_sym_SLASH_EQ] = ACTIONS(368),
    [anon_sym_PERCENT_EQ] = ACTIONS(368),
    [anon_sym_CARET_EQ] = ACTIONS(368),
    [anon_sym_AMP_EQ] = ACTIONS(368),
    [anon_sym_PIPE_EQ] = ACTIONS(368),
    [anon_sym_LT_LT_EQ] = ACTIONS(368),
    [anon_sym_GT_GT_EQ] = ACTIONS(368),
    [anon_sym_EQ] = ACTIONS(370),
    [anon_sym_EQ_EQ] = ACTIONS(368),
    [anon_sym_BANG_EQ] = ACTIONS(368),
    [anon_sym_GT] = ACTIONS(370),
    [anon_sym_LT] = ACTIONS(370),
    [anon_sym_GT_EQ] = ACTIONS(368),
    [anon_sym_LT_EQ] = ACTIONS(368),
    [anon_sym_DOT] = ACTIONS(370),
    [anon_sym_DOT_DOT] = ACTIONS(370),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(368),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(368),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(370),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(496),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [55] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1704),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(225),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(55),
    [sym_block_comment] = STATE(55),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(394),
    [anon_sym_LBRACE] = ACTIONS(394),
    [anon_sym_PLUS] = ACTIONS(396),
    [anon_sym_STAR] = ACTIONS(396),
    [anon_sym_QMARK] = ACTIONS(394),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(396),
    [anon_sym_SLASH] = ACTIONS(396),
    [anon_sym_PERCENT] = ACTIONS(396),
    [anon_sym_CARET] = ACTIONS(396),
    [anon_sym_BANG] = ACTIONS(494),
    [anon_sym_AMP] = ACTIONS(396),
    [anon_sym_PIPE] = ACTIONS(396),
    [anon_sym_AMP_AMP] = ACTIONS(394),
    [anon_sym_PIPE_PIPE] = ACTIONS(394),
    [anon_sym_LT_LT] = ACTIONS(396),
    [anon_sym_GT_GT] = ACTIONS(396),
    [anon_sym_PLUS_EQ] = ACTIONS(394),
    [anon_sym_DASH_EQ] = ACTIONS(394),
    [anon_sym_STAR_EQ] = ACTIONS(394),
    [anon_sym_SLASH_EQ] = ACTIONS(394),
    [anon_sym_PERCENT_EQ] = ACTIONS(394),
    [anon_sym_CARET_EQ] = ACTIONS(394),
    [anon_sym_AMP_EQ] = ACTIONS(394),
    [anon_sym_PIPE_EQ] = ACTIONS(394),
    [anon_sym_LT_LT_EQ] = ACTIONS(394),
    [anon_sym_GT_GT_EQ] = ACTIONS(394),
    [anon_sym_EQ] = ACTIONS(396),
    [anon_sym_EQ_EQ] = ACTIONS(394),
    [anon_sym_BANG_EQ] = ACTIONS(394),
    [anon_sym_GT] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(396),
    [anon_sym_GT_EQ] = ACTIONS(394),
    [anon_sym_LT_EQ] = ACTIONS(394),
    [anon_sym_DOT] = ACTIONS(396),
    [anon_sym_DOT_DOT] = ACTIONS(396),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(394),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(394),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(396),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(496),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [56] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1691),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(225),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(56),
    [sym_block_comment] = STATE(56),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_STAR] = ACTIONS(494),
    [anon_sym_QMARK] = ACTIONS(384),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_SLASH] = ACTIONS(386),
    [anon_sym_PERCENT] = ACTIONS(386),
    [anon_sym_CARET] = ACTIONS(386),
    [anon_sym_BANG] = ACTIONS(494),
    [anon_sym_AMP] = ACTIONS(510),
    [anon_sym_PIPE] = ACTIONS(378),
    [anon_sym_AMP_AMP] = ACTIONS(384),
    [anon_sym_PIPE_PIPE] = ACTIONS(384),
    [anon_sym_LT_LT] = ACTIONS(386),
    [anon_sym_GT_GT] = ACTIONS(386),
    [anon_sym_PLUS_EQ] = ACTIONS(384),
    [anon_sym_DASH_EQ] = ACTIONS(384),
    [anon_sym_STAR_EQ] = ACTIONS(384),
    [anon_sym_SLASH_EQ] = ACTIONS(384),
    [anon_sym_PERCENT_EQ] = ACTIONS(384),
    [anon_sym_CARET_EQ] = ACTIONS(384),
    [anon_sym_AMP_EQ] = ACTIONS(384),
    [anon_sym_PIPE_EQ] = ACTIONS(384),
    [anon_sym_LT_LT_EQ] = ACTIONS(384),
    [anon_sym_GT_GT_EQ] = ACTIONS(384),
    [anon_sym_EQ] = ACTIONS(386),
    [anon_sym_EQ_EQ] = ACTIONS(384),
    [anon_sym_BANG_EQ] = ACTIONS(384),
    [anon_sym_GT] = ACTIONS(386),
    [anon_sym_LT] = ACTIONS(380),
    [anon_sym_GT_EQ] = ACTIONS(384),
    [anon_sym_LT_EQ] = ACTIONS(384),
    [anon_sym_DOT] = ACTIONS(386),
    [anon_sym_DOT_DOT] = ACTIONS(512),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(384),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(384),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(386),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(496),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [57] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1686),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(225),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(57),
    [sym_block_comment] = STATE(57),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_PLUS] = ACTIONS(374),
    [anon_sym_STAR] = ACTIONS(494),
    [anon_sym_QMARK] = ACTIONS(372),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_SLASH] = ACTIONS(374),
    [anon_sym_PERCENT] = ACTIONS(374),
    [anon_sym_CARET] = ACTIONS(374),
    [anon_sym_BANG] = ACTIONS(494),
    [anon_sym_AMP] = ACTIONS(510),
    [anon_sym_PIPE] = ACTIONS(378),
    [anon_sym_AMP_AMP] = ACTIONS(372),
    [anon_sym_PIPE_PIPE] = ACTIONS(372),
    [anon_sym_LT_LT] = ACTIONS(374),
    [anon_sym_GT_GT] = ACTIONS(374),
    [anon_sym_PLUS_EQ] = ACTIONS(372),
    [anon_sym_DASH_EQ] = ACTIONS(372),
    [anon_sym_STAR_EQ] = ACTIONS(372),
    [anon_sym_SLASH_EQ] = ACTIONS(372),
    [anon_sym_PERCENT_EQ] = ACTIONS(372),
    [anon_sym_CARET_EQ] = ACTIONS(372),
    [anon_sym_AMP_EQ] = ACTIONS(372),
    [anon_sym_PIPE_EQ] = ACTIONS(372),
    [anon_sym_LT_LT_EQ] = ACTIONS(372),
    [anon_sym_GT_GT_EQ] = ACTIONS(372),
    [anon_sym_EQ] = ACTIONS(374),
    [anon_sym_EQ_EQ] = ACTIONS(372),
    [anon_sym_BANG_EQ] = ACTIONS(372),
    [anon_sym_GT] = ACTIONS(374),
    [anon_sym_LT] = ACTIONS(380),
    [anon_sym_GT_EQ] = ACTIONS(372),
    [anon_sym_LT_EQ] = ACTIONS(372),
    [anon_sym_DOT] = ACTIONS(374),
    [anon_sym_DOT_DOT] = ACTIONS(512),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(372),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(372),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(374),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(496),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [58] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1598),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(45),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(58),
    [sym_block_comment] = STATE(58),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(388),
    [anon_sym_LBRACK] = ACTIONS(388),
    [anon_sym_LBRACE] = ACTIONS(388),
    [anon_sym_PLUS] = ACTIONS(390),
    [anon_sym_STAR] = ACTIONS(390),
    [anon_sym_QMARK] = ACTIONS(388),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(390),
    [anon_sym_SLASH] = ACTIONS(390),
    [anon_sym_PERCENT] = ACTIONS(390),
    [anon_sym_CARET] = ACTIONS(390),
    [anon_sym_BANG] = ACTIONS(460),
    [anon_sym_AMP] = ACTIONS(390),
    [anon_sym_PIPE] = ACTIONS(390),
    [anon_sym_AMP_AMP] = ACTIONS(388),
    [anon_sym_PIPE_PIPE] = ACTIONS(388),
    [anon_sym_LT_LT] = ACTIONS(390),
    [anon_sym_GT_GT] = ACTIONS(390),
    [anon_sym_PLUS_EQ] = ACTIONS(388),
    [anon_sym_DASH_EQ] = ACTIONS(388),
    [anon_sym_STAR_EQ] = ACTIONS(388),
    [anon_sym_SLASH_EQ] = ACTIONS(388),
    [anon_sym_PERCENT_EQ] = ACTIONS(388),
    [anon_sym_CARET_EQ] = ACTIONS(388),
    [anon_sym_AMP_EQ] = ACTIONS(388),
    [anon_sym_PIPE_EQ] = ACTIONS(388),
    [anon_sym_LT_LT_EQ] = ACTIONS(388),
    [anon_sym_GT_GT_EQ] = ACTIONS(388),
    [anon_sym_EQ] = ACTIONS(390),
    [anon_sym_EQ_EQ] = ACTIONS(388),
    [anon_sym_BANG_EQ] = ACTIONS(388),
    [anon_sym_GT] = ACTIONS(390),
    [anon_sym_LT] = ACTIONS(390),
    [anon_sym_GT_EQ] = ACTIONS(388),
    [anon_sym_LT_EQ] = ACTIONS(388),
    [anon_sym_DOT] = ACTIONS(390),
    [anon_sym_DOT_DOT] = ACTIONS(390),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(388),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(388),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(390),
    [anon_sym_as] = ACTIONS(390),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(466),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(472),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(474),
    [anon_sym_move] = ACTIONS(476),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [59] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1603),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(59),
    [sym_block_comment] = STATE(59),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_PLUS] = ACTIONS(374),
    [anon_sym_STAR] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(372),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(460),
    [anon_sym_SLASH] = ACTIONS(374),
    [anon_sym_PERCENT] = ACTIONS(374),
    [anon_sym_CARET] = ACTIONS(374),
    [anon_sym_BANG] = ACTIONS(460),
    [anon_sym_AMP] = ACTIONS(506),
    [anon_sym_PIPE] = ACTIONS(378),
    [anon_sym_AMP_AMP] = ACTIONS(372),
    [anon_sym_PIPE_PIPE] = ACTIONS(372),
    [anon_sym_LT_LT] = ACTIONS(374),
    [anon_sym_GT_GT] = ACTIONS(374),
    [anon_sym_PLUS_EQ] = ACTIONS(372),
    [anon_sym_DASH_EQ] = ACTIONS(372),
    [anon_sym_STAR_EQ] = ACTIONS(372),
    [anon_sym_SLASH_EQ] = ACTIONS(372),
    [anon_sym_PERCENT_EQ] = ACTIONS(372),
    [anon_sym_CARET_EQ] = ACTIONS(372),
    [anon_sym_AMP_EQ] = ACTIONS(372),
    [anon_sym_PIPE_EQ] = ACTIONS(372),
    [anon_sym_LT_LT_EQ] = ACTIONS(372),
    [anon_sym_GT_GT_EQ] = ACTIONS(372),
    [anon_sym_EQ] = ACTIONS(374),
    [anon_sym_EQ_EQ] = ACTIONS(372),
    [anon_sym_BANG_EQ] = ACTIONS(372),
    [anon_sym_GT] = ACTIONS(374),
    [anon_sym_LT] = ACTIONS(380),
    [anon_sym_GT_EQ] = ACTIONS(372),
    [anon_sym_LT_EQ] = ACTIONS(372),
    [anon_sym_DOT] = ACTIONS(374),
    [anon_sym_DOT_DOT] = ACTIONS(508),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(372),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(372),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(374),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(466),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(472),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(474),
    [anon_sym_move] = ACTIONS(476),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [60] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1589),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(60),
    [sym_block_comment] = STATE(60),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(394),
    [anon_sym_LBRACE] = ACTIONS(394),
    [anon_sym_PLUS] = ACTIONS(396),
    [anon_sym_STAR] = ACTIONS(396),
    [anon_sym_QMARK] = ACTIONS(394),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(396),
    [anon_sym_SLASH] = ACTIONS(396),
    [anon_sym_PERCENT] = ACTIONS(396),
    [anon_sym_CARET] = ACTIONS(396),
    [anon_sym_BANG] = ACTIONS(460),
    [anon_sym_AMP] = ACTIONS(396),
    [anon_sym_PIPE] = ACTIONS(396),
    [anon_sym_AMP_AMP] = ACTIONS(394),
    [anon_sym_PIPE_PIPE] = ACTIONS(394),
    [anon_sym_LT_LT] = ACTIONS(396),
    [anon_sym_GT_GT] = ACTIONS(396),
    [anon_sym_PLUS_EQ] = ACTIONS(394),
    [anon_sym_DASH_EQ] = ACTIONS(394),
    [anon_sym_STAR_EQ] = ACTIONS(394),
    [anon_sym_SLASH_EQ] = ACTIONS(394),
    [anon_sym_PERCENT_EQ] = ACTIONS(394),
    [anon_sym_CARET_EQ] = ACTIONS(394),
    [anon_sym_AMP_EQ] = ACTIONS(394),
    [anon_sym_PIPE_EQ] = ACTIONS(394),
    [anon_sym_LT_LT_EQ] = ACTIONS(394),
    [anon_sym_GT_GT_EQ] = ACTIONS(394),
    [anon_sym_EQ] = ACTIONS(396),
    [anon_sym_EQ_EQ] = ACTIONS(394),
    [anon_sym_BANG_EQ] = ACTIONS(394),
    [anon_sym_GT] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(396),
    [anon_sym_GT_EQ] = ACTIONS(394),
    [anon_sym_LT_EQ] = ACTIONS(394),
    [anon_sym_DOT] = ACTIONS(396),
    [anon_sym_DOT_DOT] = ACTIONS(396),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(394),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(394),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(396),
    [anon_sym_as] = ACTIONS(396),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(466),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(472),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(474),
    [anon_sym_move] = ACTIONS(476),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [61] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1679),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(225),
    [sym_label] = STATE(51),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(61),
    [sym_block_comment] = STATE(61),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(388),
    [anon_sym_LBRACK] = ACTIONS(388),
    [anon_sym_LBRACE] = ACTIONS(388),
    [anon_sym_PLUS] = ACTIONS(390),
    [anon_sym_STAR] = ACTIONS(390),
    [anon_sym_QMARK] = ACTIONS(388),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(390),
    [anon_sym_SLASH] = ACTIONS(390),
    [anon_sym_PERCENT] = ACTIONS(390),
    [anon_sym_CARET] = ACTIONS(390),
    [anon_sym_BANG] = ACTIONS(494),
    [anon_sym_AMP] = ACTIONS(390),
    [anon_sym_PIPE] = ACTIONS(390),
    [anon_sym_AMP_AMP] = ACTIONS(388),
    [anon_sym_PIPE_PIPE] = ACTIONS(388),
    [anon_sym_LT_LT] = ACTIONS(390),
    [anon_sym_GT_GT] = ACTIONS(390),
    [anon_sym_PLUS_EQ] = ACTIONS(388),
    [anon_sym_DASH_EQ] = ACTIONS(388),
    [anon_sym_STAR_EQ] = ACTIONS(388),
    [anon_sym_SLASH_EQ] = ACTIONS(388),
    [anon_sym_PERCENT_EQ] = ACTIONS(388),
    [anon_sym_CARET_EQ] = ACTIONS(388),
    [anon_sym_AMP_EQ] = ACTIONS(388),
    [anon_sym_PIPE_EQ] = ACTIONS(388),
    [anon_sym_LT_LT_EQ] = ACTIONS(388),
    [anon_sym_GT_GT_EQ] = ACTIONS(388),
    [anon_sym_EQ] = ACTIONS(390),
    [anon_sym_EQ_EQ] = ACTIONS(388),
    [anon_sym_BANG_EQ] = ACTIONS(388),
    [anon_sym_GT] = ACTIONS(390),
    [anon_sym_LT] = ACTIONS(390),
    [anon_sym_GT_EQ] = ACTIONS(388),
    [anon_sym_LT_EQ] = ACTIONS(388),
    [anon_sym_DOT] = ACTIONS(390),
    [anon_sym_DOT_DOT] = ACTIONS(390),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(388),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(388),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(392),
    [anon_sym_as] = ACTIONS(390),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(496),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [62] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1704),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(225),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(62),
    [sym_block_comment] = STATE(62),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(394),
    [anon_sym_LBRACK] = ACTIONS(394),
    [anon_sym_LBRACE] = ACTIONS(394),
    [anon_sym_PLUS] = ACTIONS(396),
    [anon_sym_STAR] = ACTIONS(396),
    [anon_sym_QMARK] = ACTIONS(394),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(396),
    [anon_sym_SLASH] = ACTIONS(396),
    [anon_sym_PERCENT] = ACTIONS(396),
    [anon_sym_CARET] = ACTIONS(396),
    [anon_sym_BANG] = ACTIONS(494),
    [anon_sym_AMP] = ACTIONS(396),
    [anon_sym_PIPE] = ACTIONS(396),
    [anon_sym_AMP_AMP] = ACTIONS(394),
    [anon_sym_PIPE_PIPE] = ACTIONS(394),
    [anon_sym_LT_LT] = ACTIONS(396),
    [anon_sym_GT_GT] = ACTIONS(396),
    [anon_sym_PLUS_EQ] = ACTIONS(394),
    [anon_sym_DASH_EQ] = ACTIONS(394),
    [anon_sym_STAR_EQ] = ACTIONS(394),
    [anon_sym_SLASH_EQ] = ACTIONS(394),
    [anon_sym_PERCENT_EQ] = ACTIONS(394),
    [anon_sym_CARET_EQ] = ACTIONS(394),
    [anon_sym_AMP_EQ] = ACTIONS(394),
    [anon_sym_PIPE_EQ] = ACTIONS(394),
    [anon_sym_LT_LT_EQ] = ACTIONS(394),
    [anon_sym_GT_GT_EQ] = ACTIONS(394),
    [anon_sym_EQ] = ACTIONS(396),
    [anon_sym_EQ_EQ] = ACTIONS(394),
    [anon_sym_BANG_EQ] = ACTIONS(394),
    [anon_sym_GT] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(396),
    [anon_sym_GT_EQ] = ACTIONS(394),
    [anon_sym_LT_EQ] = ACTIONS(394),
    [anon_sym_DOT] = ACTIONS(396),
    [anon_sym_DOT_DOT] = ACTIONS(396),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(394),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(394),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(396),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(496),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [63] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1592),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(63),
    [sym_block_comment] = STATE(63),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(368),
    [anon_sym_LBRACK] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(368),
    [anon_sym_PLUS] = ACTIONS(370),
    [anon_sym_STAR] = ACTIONS(370),
    [anon_sym_QMARK] = ACTIONS(368),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(370),
    [anon_sym_SLASH] = ACTIONS(370),
    [anon_sym_PERCENT] = ACTIONS(370),
    [anon_sym_CARET] = ACTIONS(370),
    [anon_sym_BANG] = ACTIONS(460),
    [anon_sym_AMP] = ACTIONS(370),
    [anon_sym_PIPE] = ACTIONS(370),
    [anon_sym_AMP_AMP] = ACTIONS(368),
    [anon_sym_PIPE_PIPE] = ACTIONS(368),
    [anon_sym_LT_LT] = ACTIONS(370),
    [anon_sym_GT_GT] = ACTIONS(370),
    [anon_sym_PLUS_EQ] = ACTIONS(368),
    [anon_sym_DASH_EQ] = ACTIONS(368),
    [anon_sym_STAR_EQ] = ACTIONS(368),
    [anon_sym_SLASH_EQ] = ACTIONS(368),
    [anon_sym_PERCENT_EQ] = ACTIONS(368),
    [anon_sym_CARET_EQ] = ACTIONS(368),
    [anon_sym_AMP_EQ] = ACTIONS(368),
    [anon_sym_PIPE_EQ] = ACTIONS(368),
    [anon_sym_LT_LT_EQ] = ACTIONS(368),
    [anon_sym_GT_GT_EQ] = ACTIONS(368),
    [anon_sym_EQ] = ACTIONS(370),
    [anon_sym_EQ_EQ] = ACTIONS(368),
    [anon_sym_BANG_EQ] = ACTIONS(368),
    [anon_sym_GT] = ACTIONS(370),
    [anon_sym_LT] = ACTIONS(370),
    [anon_sym_GT_EQ] = ACTIONS(368),
    [anon_sym_LT_EQ] = ACTIONS(368),
    [anon_sym_DOT] = ACTIONS(370),
    [anon_sym_DOT_DOT] = ACTIONS(370),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(368),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(368),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(370),
    [anon_sym_as] = ACTIONS(370),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(466),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(472),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(474),
    [anon_sym_move] = ACTIONS(476),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [64] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1592),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(64),
    [sym_block_comment] = STATE(64),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(368),
    [anon_sym_PLUS] = ACTIONS(370),
    [anon_sym_STAR] = ACTIONS(370),
    [anon_sym_QMARK] = ACTIONS(368),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(370),
    [anon_sym_SLASH] = ACTIONS(370),
    [anon_sym_PERCENT] = ACTIONS(370),
    [anon_sym_CARET] = ACTIONS(370),
    [anon_sym_BANG] = ACTIONS(460),
    [anon_sym_AMP] = ACTIONS(370),
    [anon_sym_PIPE] = ACTIONS(370),
    [anon_sym_AMP_AMP] = ACTIONS(368),
    [anon_sym_PIPE_PIPE] = ACTIONS(368),
    [anon_sym_LT_LT] = ACTIONS(370),
    [anon_sym_GT_GT] = ACTIONS(370),
    [anon_sym_PLUS_EQ] = ACTIONS(368),
    [anon_sym_DASH_EQ] = ACTIONS(368),
    [anon_sym_STAR_EQ] = ACTIONS(368),
    [anon_sym_SLASH_EQ] = ACTIONS(368),
    [anon_sym_PERCENT_EQ] = ACTIONS(368),
    [anon_sym_CARET_EQ] = ACTIONS(368),
    [anon_sym_AMP_EQ] = ACTIONS(368),
    [anon_sym_PIPE_EQ] = ACTIONS(368),
    [anon_sym_LT_LT_EQ] = ACTIONS(368),
    [anon_sym_GT_GT_EQ] = ACTIONS(368),
    [anon_sym_EQ] = ACTIONS(370),
    [anon_sym_EQ_EQ] = ACTIONS(368),
    [anon_sym_BANG_EQ] = ACTIONS(368),
    [anon_sym_GT] = ACTIONS(370),
    [anon_sym_LT] = ACTIONS(370),
    [anon_sym_GT_EQ] = ACTIONS(368),
    [anon_sym_LT_EQ] = ACTIONS(368),
    [anon_sym_DOT] = ACTIONS(370),
    [anon_sym_DOT_DOT] = ACTIONS(370),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(368),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(368),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(370),
    [anon_sym_as] = ACTIONS(370),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(466),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(472),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(474),
    [anon_sym_move] = ACTIONS(476),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [65] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1672),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(225),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(65),
    [sym_block_comment] = STATE(65),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(368),
    [anon_sym_LBRACK] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(368),
    [anon_sym_PLUS] = ACTIONS(370),
    [anon_sym_STAR] = ACTIONS(370),
    [anon_sym_QMARK] = ACTIONS(368),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(370),
    [anon_sym_SLASH] = ACTIONS(370),
    [anon_sym_PERCENT] = ACTIONS(370),
    [anon_sym_CARET] = ACTIONS(370),
    [anon_sym_BANG] = ACTIONS(494),
    [anon_sym_AMP] = ACTIONS(370),
    [anon_sym_PIPE] = ACTIONS(370),
    [anon_sym_AMP_AMP] = ACTIONS(368),
    [anon_sym_PIPE_PIPE] = ACTIONS(368),
    [anon_sym_LT_LT] = ACTIONS(370),
    [anon_sym_GT_GT] = ACTIONS(370),
    [anon_sym_PLUS_EQ] = ACTIONS(368),
    [anon_sym_DASH_EQ] = ACTIONS(368),
    [anon_sym_STAR_EQ] = ACTIONS(368),
    [anon_sym_SLASH_EQ] = ACTIONS(368),
    [anon_sym_PERCENT_EQ] = ACTIONS(368),
    [anon_sym_CARET_EQ] = ACTIONS(368),
    [anon_sym_AMP_EQ] = ACTIONS(368),
    [anon_sym_PIPE_EQ] = ACTIONS(368),
    [anon_sym_LT_LT_EQ] = ACTIONS(368),
    [anon_sym_GT_GT_EQ] = ACTIONS(368),
    [anon_sym_EQ] = ACTIONS(370),
    [anon_sym_EQ_EQ] = ACTIONS(368),
    [anon_sym_BANG_EQ] = ACTIONS(368),
    [anon_sym_GT] = ACTIONS(370),
    [anon_sym_LT] = ACTIONS(370),
    [anon_sym_GT_EQ] = ACTIONS(368),
    [anon_sym_LT_EQ] = ACTIONS(368),
    [anon_sym_DOT] = ACTIONS(370),
    [anon_sym_DOT_DOT] = ACTIONS(370),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(368),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(368),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_as] = ACTIONS(370),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(496),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [66] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1589),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(66),
    [sym_block_comment] = STATE(66),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(394),
    [anon_sym_LBRACK] = ACTIONS(394),
    [anon_sym_LBRACE] = ACTIONS(394),
    [anon_sym_PLUS] = ACTIONS(396),
    [anon_sym_STAR] = ACTIONS(396),
    [anon_sym_QMARK] = ACTIONS(394),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(396),
    [anon_sym_SLASH] = ACTIONS(396),
    [anon_sym_PERCENT] = ACTIONS(396),
    [anon_sym_CARET] = ACTIONS(396),
    [anon_sym_BANG] = ACTIONS(460),
    [anon_sym_AMP] = ACTIONS(396),
    [anon_sym_PIPE] = ACTIONS(396),
    [anon_sym_AMP_AMP] = ACTIONS(394),
    [anon_sym_PIPE_PIPE] = ACTIONS(394),
    [anon_sym_LT_LT] = ACTIONS(396),
    [anon_sym_GT_GT] = ACTIONS(396),
    [anon_sym_PLUS_EQ] = ACTIONS(394),
    [anon_sym_DASH_EQ] = ACTIONS(394),
    [anon_sym_STAR_EQ] = ACTIONS(394),
    [anon_sym_SLASH_EQ] = ACTIONS(394),
    [anon_sym_PERCENT_EQ] = ACTIONS(394),
    [anon_sym_CARET_EQ] = ACTIONS(394),
    [anon_sym_AMP_EQ] = ACTIONS(394),
    [anon_sym_PIPE_EQ] = ACTIONS(394),
    [anon_sym_LT_LT_EQ] = ACTIONS(394),
    [anon_sym_GT_GT_EQ] = ACTIONS(394),
    [anon_sym_EQ] = ACTIONS(396),
    [anon_sym_EQ_EQ] = ACTIONS(394),
    [anon_sym_BANG_EQ] = ACTIONS(394),
    [anon_sym_GT] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(396),
    [anon_sym_GT_EQ] = ACTIONS(394),
    [anon_sym_LT_EQ] = ACTIONS(394),
    [anon_sym_DOT] = ACTIONS(396),
    [anon_sym_DOT_DOT] = ACTIONS(396),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(394),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(394),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(396),
    [anon_sym_as] = ACTIONS(396),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(466),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(472),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(474),
    [anon_sym_move] = ACTIONS(476),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [67] = {
    [sym__token_pattern] = STATE(155),
    [sym_token_tree_pattern] = STATE(163),
    [sym_token_binding_pattern] = STATE(163),
    [sym_token_repetition_pattern] = STATE(163),
    [sym__literal] = STATE(163),
    [sym_string_literal] = STATE(140),
    [sym_raw_string_literal] = STATE(140),
    [sym_boolean_literal] = STATE(140),
    [sym_line_comment] = STATE(67),
    [sym_block_comment] = STATE(67),
    [aux_sym_token_tree_pattern_repeat1] = STATE(67),
    [aux_sym__non_special_token_repeat1] = STATE(136),
    [sym_identifier] = ACTIONS(514),
    [anon_sym_SEMI] = ACTIONS(517),
    [anon_sym_LPAREN] = ACTIONS(520),
    [anon_sym_RPAREN] = ACTIONS(523),
    [anon_sym_LBRACK] = ACTIONS(525),
    [anon_sym_RBRACK] = ACTIONS(523),
    [anon_sym_LBRACE] = ACTIONS(528),
    [anon_sym_RBRACE] = ACTIONS(523),
    [anon_sym_EQ_GT] = ACTIONS(517),
    [anon_sym_COLON] = ACTIONS(531),
    [anon_sym_DOLLAR] = ACTIONS(534),
    [anon_sym_PLUS] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(531),
    [anon_sym_QMARK] = ACTIONS(517),
    [anon_sym_u8] = ACTIONS(514),
    [anon_sym_i8] = ACTIONS(514),
    [anon_sym_u16] = ACTIONS(514),
    [anon_sym_i16] = ACTIONS(514),
    [anon_sym_u32] = ACTIONS(514),
    [anon_sym_i32] = ACTIONS(514),
    [anon_sym_u64] = ACTIONS(514),
    [anon_sym_i64] = ACTIONS(514),
    [anon_sym_u128] = ACTIONS(514),
    [anon_sym_i128] = ACTIONS(514),
    [anon_sym_isize] = ACTIONS(514),
    [anon_sym_usize] = ACTIONS(514),
    [anon_sym_f32] = ACTIONS(514),
    [anon_sym_f64] = ACTIONS(514),
    [anon_sym_bool] = ACTIONS(514),
    [anon_sym_str] = ACTIONS(514),
    [anon_sym_char] = ACTIONS(514),
    [anon_sym_DASH] = ACTIONS(531),
    [anon_sym_SLASH] = ACTIONS(531),
    [anon_sym_PERCENT] = ACTIONS(531),
    [anon_sym_CARET] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(531),
    [anon_sym_AMP] = ACTIONS(531),
    [anon_sym_PIPE] = ACTIONS(531),
    [anon_sym_AMP_AMP] = ACTIONS(517),
    [anon_sym_PIPE_PIPE] = ACTIONS(517),
    [anon_sym_LT_LT] = ACTIONS(531),
    [anon_sym_GT_GT] = ACTIONS(531),
    [anon_sym_PLUS_EQ] = ACTIONS(517),
    [anon_sym_DASH_EQ] = ACTIONS(517),
    [anon_sym_STAR_EQ] = ACTIONS(517),
    [anon_sym_SLASH_EQ] = ACTIONS(517),
    [anon_sym_PERCENT_EQ] = ACTIONS(517),
    [anon_sym_CARET_EQ] = ACTIONS(517),
    [anon_sym_AMP_EQ] = ACTIONS(517),
    [anon_sym_PIPE_EQ] = ACTIONS(517),
    [anon_sym_LT_LT_EQ] = ACTIONS(517),
    [anon_sym_GT_GT_EQ] = ACTIONS(517),
    [anon_sym_EQ] = ACTIONS(531),
    [anon_sym_EQ_EQ] = ACTIONS(517),
    [anon_sym_BANG_EQ] = ACTIONS(517),
    [anon_sym_GT] = ACTIONS(531),
    [anon_sym_LT] = ACTIONS(531),
    [anon_sym_GT_EQ] = ACTIONS(517),
    [anon_sym_LT_EQ] = ACTIONS(517),
    [anon_sym_AT] = ACTIONS(517),
    [anon_sym__] = ACTIONS(531),
    [anon_sym_DOT] = ACTIONS(531),
    [anon_sym_DOT_DOT] = ACTIONS(531),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(517),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(517),
    [anon_sym_COMMA] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(517),
    [anon_sym_DASH_GT] = ACTIONS(517),
    [anon_sym_POUND] = ACTIONS(517),
    [anon_sym_SQUOTE] = ACTIONS(514),
    [anon_sym_as] = ACTIONS(514),
    [anon_sym_async] = ACTIONS(514),
    [anon_sym_await] = ACTIONS(514),
    [anon_sym_break] = ACTIONS(514),
    [anon_sym_const] = ACTIONS(514),
    [anon_sym_continue] = ACTIONS(514),
    [anon_sym_default] = ACTIONS(514),
    [anon_sym_enum] = ACTIONS(514),
    [anon_sym_fn] = ACTIONS(514),
    [anon_sym_for] = ACTIONS(514),
    [anon_sym_if] = ACTIONS(514),
    [anon_sym_impl] = ACTIONS(514),
    [anon_sym_let] = ACTIONS(514),
    [anon_sym_loop] = ACTIONS(514),
    [anon_sym_match] = ACTIONS(514),
    [anon_sym_mod] = ACTIONS(514),
    [anon_sym_pub] = ACTIONS(514),
    [anon_sym_return] = ACTIONS(514),
    [anon_sym_static] = ACTIONS(514),
    [anon_sym_struct] = ACTIONS(514),
    [anon_sym_trait] = ACTIONS(514),
    [anon_sym_type] = ACTIONS(514),
    [anon_sym_union] = ACTIONS(514),
    [anon_sym_unsafe] = ACTIONS(514),
    [anon_sym_use] = ACTIONS(514),
    [anon_sym_where] = ACTIONS(514),
    [anon_sym_while] = ACTIONS(514),
    [sym_mutable_specifier] = ACTIONS(514),
    [sym_integer_literal] = ACTIONS(537),
    [aux_sym_string_literal_token1] = ACTIONS(540),
    [sym_char_literal] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(543),
    [anon_sym_false] = ACTIONS(543),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(514),
    [sym_super] = ACTIONS(514),
    [sym_crate] = ACTIONS(514),
    [sym_metavariable] = ACTIONS(546),
    [sym__raw_string_literal_start] = ACTIONS(549),
    [sym_float_literal] = ACTIONS(537),
  },
  [68] = {
    [sym__token_pattern] = STATE(155),
    [sym_token_tree_pattern] = STATE(163),
    [sym_token_binding_pattern] = STATE(163),
    [sym_token_repetition_pattern] = STATE(163),
    [sym__literal] = STATE(163),
    [sym_string_literal] = STATE(140),
    [sym_raw_string_literal] = STATE(140),
    [sym_boolean_literal] = STATE(140),
    [sym_line_comment] = STATE(68),
    [sym_block_comment] = STATE(68),
    [aux_sym_token_tree_pattern_repeat1] = STATE(75),
    [aux_sym__non_special_token_repeat1] = STATE(136),
    [sym_identifier] = ACTIONS(552),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(558),
    [anon_sym_LBRACE] = ACTIONS(560),
    [anon_sym_RBRACE] = ACTIONS(562),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(566),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(552),
    [anon_sym_i8] = ACTIONS(552),
    [anon_sym_u16] = ACTIONS(552),
    [anon_sym_i16] = ACTIONS(552),
    [anon_sym_u32] = ACTIONS(552),
    [anon_sym_i32] = ACTIONS(552),
    [anon_sym_u64] = ACTIONS(552),
    [anon_sym_i64] = ACTIONS(552),
    [anon_sym_u128] = ACTIONS(552),
    [anon_sym_i128] = ACTIONS(552),
    [anon_sym_isize] = ACTIONS(552),
    [anon_sym_usize] = ACTIONS(552),
    [anon_sym_f32] = ACTIONS(552),
    [anon_sym_f64] = ACTIONS(552),
    [anon_sym_bool] = ACTIONS(552),
    [anon_sym_str] = ACTIONS(552),
    [anon_sym_char] = ACTIONS(552),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(552),
    [anon_sym_as] = ACTIONS(552),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_await] = ACTIONS(552),
    [anon_sym_break] = ACTIONS(552),
    [anon_sym_const] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(552),
    [anon_sym_default] = ACTIONS(552),
    [anon_sym_enum] = ACTIONS(552),
    [anon_sym_fn] = ACTIONS(552),
    [anon_sym_for] = ACTIONS(552),
    [anon_sym_if] = ACTIONS(552),
    [anon_sym_impl] = ACTIONS(552),
    [anon_sym_let] = ACTIONS(552),
    [anon_sym_loop] = ACTIONS(552),
    [anon_sym_match] = ACTIONS(552),
    [anon_sym_mod] = ACTIONS(552),
    [anon_sym_pub] = ACTIONS(552),
    [anon_sym_return] = ACTIONS(552),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(552),
    [anon_sym_trait] = ACTIONS(552),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_union] = ACTIONS(552),
    [anon_sym_unsafe] = ACTIONS(552),
    [anon_sym_use] = ACTIONS(552),
    [anon_sym_where] = ACTIONS(552),
    [anon_sym_while] = ACTIONS(552),
    [sym_mutable_specifier] = ACTIONS(552),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(552),
    [sym_super] = ACTIONS(552),
    [sym_crate] = ACTIONS(552),
    [sym_metavariable] = ACTIONS(574),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [69] = {
    [sym_token_tree] = STATE(152),
    [sym_token_repetition] = STATE(152),
    [sym__literal] = STATE(152),
    [sym_string_literal] = STATE(140),
    [sym_raw_string_literal] = STATE(140),
    [sym_boolean_literal] = STATE(140),
    [sym_line_comment] = STATE(69),
    [sym_block_comment] = STATE(69),
    [aux_sym_token_tree_repeat1] = STATE(69),
    [aux_sym__non_special_token_repeat1] = STATE(135),
    [sym_identifier] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(581),
    [anon_sym_LPAREN] = ACTIONS(584),
    [anon_sym_RPAREN] = ACTIONS(587),
    [anon_sym_LBRACK] = ACTIONS(589),
    [anon_sym_RBRACK] = ACTIONS(587),
    [anon_sym_LBRACE] = ACTIONS(592),
    [anon_sym_RBRACE] = ACTIONS(587),
    [anon_sym_EQ_GT] = ACTIONS(581),
    [anon_sym_COLON] = ACTIONS(595),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_STAR] = ACTIONS(595),
    [anon_sym_QMARK] = ACTIONS(581),
    [anon_sym_u8] = ACTIONS(578),
    [anon_sym_i8] = ACTIONS(578),
    [anon_sym_u16] = ACTIONS(578),
    [anon_sym_i16] = ACTIONS(578),
    [anon_sym_u32] = ACTIONS(578),
    [anon_sym_i32] = ACTIONS(578),
    [anon_sym_u64] = ACTIONS(578),
    [anon_sym_i64] = ACTIONS(578),
    [anon_sym_u128] = ACTIONS(578),
    [anon_sym_i128] = ACTIONS(578),
    [anon_sym_isize] = ACTIONS(578),
    [anon_sym_usize] = ACTIONS(578),
    [anon_sym_f32] = ACTIONS(578),
    [anon_sym_f64] = ACTIONS(578),
    [anon_sym_bool] = ACTIONS(578),
    [anon_sym_str] = ACTIONS(578),
    [anon_sym_char] = ACTIONS(578),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_SLASH] = ACTIONS(595),
    [anon_sym_PERCENT] = ACTIONS(595),
    [anon_sym_CARET] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(595),
    [anon_sym_AMP] = ACTIONS(595),
    [anon_sym_PIPE] = ACTIONS(595),
    [anon_sym_AMP_AMP] = ACTIONS(581),
    [anon_sym_PIPE_PIPE] = ACTIONS(581),
    [anon_sym_LT_LT] = ACTIONS(595),
    [anon_sym_GT_GT] = ACTIONS(595),
    [anon_sym_PLUS_EQ] = ACTIONS(581),
    [anon_sym_DASH_EQ] = ACTIONS(581),
    [anon_sym_STAR_EQ] = ACTIONS(581),
    [anon_sym_SLASH_EQ] = ACTIONS(581),
    [anon_sym_PERCENT_EQ] = ACTIONS(581),
    [anon_sym_CARET_EQ] = ACTIONS(581),
    [anon_sym_AMP_EQ] = ACTIONS(581),
    [anon_sym_PIPE_EQ] = ACTIONS(581),
    [anon_sym_LT_LT_EQ] = ACTIONS(581),
    [anon_sym_GT_GT_EQ] = ACTIONS(581),
    [anon_sym_EQ] = ACTIONS(595),
    [anon_sym_EQ_EQ] = ACTIONS(581),
    [anon_sym_BANG_EQ] = ACTIONS(581),
    [anon_sym_GT] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(595),
    [anon_sym_GT_EQ] = ACTIONS(581),
    [anon_sym_LT_EQ] = ACTIONS(581),
    [anon_sym_AT] = ACTIONS(581),
    [anon_sym__] = ACTIONS(595),
    [anon_sym_DOT] = ACTIONS(595),
    [anon_sym_DOT_DOT] = ACTIONS(595),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(581),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(581),
    [anon_sym_COMMA] = ACTIONS(581),
    [anon_sym_COLON_COLON] = ACTIONS(581),
    [anon_sym_DASH_GT] = ACTIONS(581),
    [anon_sym_POUND] = ACTIONS(581),
    [anon_sym_SQUOTE] = ACTIONS(578),
    [anon_sym_as] = ACTIONS(578),
    [anon_sym_async] = ACTIONS(578),
    [anon_sym_await] = ACTIONS(578),
    [anon_sym_break] = ACTIONS(578),
    [anon_sym_const] = ACTIONS(578),
    [anon_sym_continue] = ACTIONS(578),
    [anon_sym_default] = ACTIONS(578),
    [anon_sym_enum] = ACTIONS(578),
    [anon_sym_fn] = ACTIONS(578),
    [anon_sym_for] = ACTIONS(578),
    [anon_sym_if] = ACTIONS(578),
    [anon_sym_impl] = ACTIONS(578),
    [anon_sym_let] = ACTIONS(578),
    [anon_sym_loop] = ACTIONS(578),
    [anon_sym_match] = ACTIONS(578),
    [anon_sym_mod] = ACTIONS(578),
    [anon_sym_pub] = ACTIONS(578),
    [anon_sym_return] = ACTIONS(578),
    [anon_sym_static] = ACTIONS(578),
    [anon_sym_struct] = ACTIONS(578),
    [anon_sym_trait] = ACTIONS(578),
    [anon_sym_type] = ACTIONS(578),
    [anon_sym_union] = ACTIONS(578),
    [anon_sym_unsafe] = ACTIONS(578),
    [anon_sym_use] = ACTIONS(578),
    [anon_sym_where] = ACTIONS(578),
    [anon_sym_while] = ACTIONS(578),
    [sym_mutable_specifier] = ACTIONS(578),
    [sym_integer_literal] = ACTIONS(601),
    [aux_sym_string_literal_token1] = ACTIONS(604),
    [sym_char_literal] = ACTIONS(601),
    [anon_sym_true] = ACTIONS(607),
    [anon_sym_false] = ACTIONS(607),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(578),
    [sym_super] = ACTIONS(578),
    [sym_crate] = ACTIONS(578),
    [sym_metavariable] = ACTIONS(610),
    [sym__raw_string_literal_start] = ACTIONS(613),
    [sym_float_literal] = ACTIONS(601),
  },
  [70] = {
    [sym__token_pattern] = STATE(155),
    [sym_token_tree_pattern] = STATE(163),
    [sym_token_binding_pattern] = STATE(163),
    [sym_token_repetition_pattern] = STATE(163),
    [sym__literal] = STATE(163),
    [sym_string_literal] = STATE(140),
    [sym_raw_string_literal] = STATE(140),
    [sym_boolean_literal] = STATE(140),
    [sym_line_comment] = STATE(70),
    [sym_block_comment] = STATE(70),
    [aux_sym_token_tree_pattern_repeat1] = STATE(78),
    [aux_sym__non_special_token_repeat1] = STATE(136),
    [sym_identifier] = ACTIONS(552),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(558),
    [anon_sym_RBRACK] = ACTIONS(562),
    [anon_sym_LBRACE] = ACTIONS(560),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(566),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(552),
    [anon_sym_i8] = ACTIONS(552),
    [anon_sym_u16] = ACTIONS(552),
    [anon_sym_i16] = ACTIONS(552),
    [anon_sym_u32] = ACTIONS(552),
    [anon_sym_i32] = ACTIONS(552),
    [anon_sym_u64] = ACTIONS(552),
    [anon_sym_i64] = ACTIONS(552),
    [anon_sym_u128] = ACTIONS(552),
    [anon_sym_i128] = ACTIONS(552),
    [anon_sym_isize] = ACTIONS(552),
    [anon_sym_usize] = ACTIONS(552),
    [anon_sym_f32] = ACTIONS(552),
    [anon_sym_f64] = ACTIONS(552),
    [anon_sym_bool] = ACTIONS(552),
    [anon_sym_str] = ACTIONS(552),
    [anon_sym_char] = ACTIONS(552),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(552),
    [anon_sym_as] = ACTIONS(552),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_await] = ACTIONS(552),
    [anon_sym_break] = ACTIONS(552),
    [anon_sym_const] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(552),
    [anon_sym_default] = ACTIONS(552),
    [anon_sym_enum] = ACTIONS(552),
    [anon_sym_fn] = ACTIONS(552),
    [anon_sym_for] = ACTIONS(552),
    [anon_sym_if] = ACTIONS(552),
    [anon_sym_impl] = ACTIONS(552),
    [anon_sym_let] = ACTIONS(552),
    [anon_sym_loop] = ACTIONS(552),
    [anon_sym_match] = ACTIONS(552),
    [anon_sym_mod] = ACTIONS(552),
    [anon_sym_pub] = ACTIONS(552),
    [anon_sym_return] = ACTIONS(552),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(552),
    [anon_sym_trait] = ACTIONS(552),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_union] = ACTIONS(552),
    [anon_sym_unsafe] = ACTIONS(552),
    [anon_sym_use] = ACTIONS(552),
    [anon_sym_where] = ACTIONS(552),
    [anon_sym_while] = ACTIONS(552),
    [sym_mutable_specifier] = ACTIONS(552),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(552),
    [sym_super] = ACTIONS(552),
    [sym_crate] = ACTIONS(552),
    [sym_metavariable] = ACTIONS(574),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [71] = {
    [sym__token_pattern] = STATE(155),
    [sym_token_tree_pattern] = STATE(163),
    [sym_token_binding_pattern] = STATE(163),
    [sym_token_repetition_pattern] = STATE(163),
    [sym__literal] = STATE(163),
    [sym_string_literal] = STATE(140),
    [sym_raw_string_literal] = STATE(140),
    [sym_boolean_literal] = STATE(140),
    [sym_line_comment] = STATE(71),
    [sym_block_comment] = STATE(71),
    [aux_sym_token_tree_pattern_repeat1] = STATE(79),
    [aux_sym__non_special_token_repeat1] = STATE(136),
    [sym_identifier] = ACTIONS(552),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_RPAREN] = ACTIONS(562),
    [anon_sym_LBRACK] = ACTIONS(558),
    [anon_sym_LBRACE] = ACTIONS(560),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(566),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(552),
    [anon_sym_i8] = ACTIONS(552),
    [anon_sym_u16] = ACTIONS(552),
    [anon_sym_i16] = ACTIONS(552),
    [anon_sym_u32] = ACTIONS(552),
    [anon_sym_i32] = ACTIONS(552),
    [anon_sym_u64] = ACTIONS(552),
    [anon_sym_i64] = ACTIONS(552),
    [anon_sym_u128] = ACTIONS(552),
    [anon_sym_i128] = ACTIONS(552),
    [anon_sym_isize] = ACTIONS(552),
    [anon_sym_usize] = ACTIONS(552),
    [anon_sym_f32] = ACTIONS(552),
    [anon_sym_f64] = ACTIONS(552),
    [anon_sym_bool] = ACTIONS(552),
    [anon_sym_str] = ACTIONS(552),
    [anon_sym_char] = ACTIONS(552),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(552),
    [anon_sym_as] = ACTIONS(552),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_await] = ACTIONS(552),
    [anon_sym_break] = ACTIONS(552),
    [anon_sym_const] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(552),
    [anon_sym_default] = ACTIONS(552),
    [anon_sym_enum] = ACTIONS(552),
    [anon_sym_fn] = ACTIONS(552),
    [anon_sym_for] = ACTIONS(552),
    [anon_sym_if] = ACTIONS(552),
    [anon_sym_impl] = ACTIONS(552),
    [anon_sym_let] = ACTIONS(552),
    [anon_sym_loop] = ACTIONS(552),
    [anon_sym_match] = ACTIONS(552),
    [anon_sym_mod] = ACTIONS(552),
    [anon_sym_pub] = ACTIONS(552),
    [anon_sym_return] = ACTIONS(552),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(552),
    [anon_sym_trait] = ACTIONS(552),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_union] = ACTIONS(552),
    [anon_sym_unsafe] = ACTIONS(552),
    [anon_sym_use] = ACTIONS(552),
    [anon_sym_where] = ACTIONS(552),
    [anon_sym_while] = ACTIONS(552),
    [sym_mutable_specifier] = ACTIONS(552),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(552),
    [sym_super] = ACTIONS(552),
    [sym_crate] = ACTIONS(552),
    [sym_metavariable] = ACTIONS(574),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [72] = {
    [sym__token_pattern] = STATE(155),
    [sym_token_tree_pattern] = STATE(163),
    [sym_token_binding_pattern] = STATE(163),
    [sym_token_repetition_pattern] = STATE(163),
    [sym__literal] = STATE(163),
    [sym_string_literal] = STATE(140),
    [sym_raw_string_literal] = STATE(140),
    [sym_boolean_literal] = STATE(140),
    [sym_line_comment] = STATE(72),
    [sym_block_comment] = STATE(72),
    [aux_sym_token_tree_pattern_repeat1] = STATE(81),
    [aux_sym__non_special_token_repeat1] = STATE(136),
    [sym_identifier] = ACTIONS(552),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_RPAREN] = ACTIONS(616),
    [anon_sym_LBRACK] = ACTIONS(558),
    [anon_sym_LBRACE] = ACTIONS(560),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(566),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(552),
    [anon_sym_i8] = ACTIONS(552),
    [anon_sym_u16] = ACTIONS(552),
    [anon_sym_i16] = ACTIONS(552),
    [anon_sym_u32] = ACTIONS(552),
    [anon_sym_i32] = ACTIONS(552),
    [anon_sym_u64] = ACTIONS(552),
    [anon_sym_i64] = ACTIONS(552),
    [anon_sym_u128] = ACTIONS(552),
    [anon_sym_i128] = ACTIONS(552),
    [anon_sym_isize] = ACTIONS(552),
    [anon_sym_usize] = ACTIONS(552),
    [anon_sym_f32] = ACTIONS(552),
    [anon_sym_f64] = ACTIONS(552),
    [anon_sym_bool] = ACTIONS(552),
    [anon_sym_str] = ACTIONS(552),
    [anon_sym_char] = ACTIONS(552),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(552),
    [anon_sym_as] = ACTIONS(552),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_await] = ACTIONS(552),
    [anon_sym_break] = ACTIONS(552),
    [anon_sym_const] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(552),
    [anon_sym_default] = ACTIONS(552),
    [anon_sym_enum] = ACTIONS(552),
    [anon_sym_fn] = ACTIONS(552),
    [anon_sym_for] = ACTIONS(552),
    [anon_sym_if] = ACTIONS(552),
    [anon_sym_impl] = ACTIONS(552),
    [anon_sym_let] = ACTIONS(552),
    [anon_sym_loop] = ACTIONS(552),
    [anon_sym_match] = ACTIONS(552),
    [anon_sym_mod] = ACTIONS(552),
    [anon_sym_pub] = ACTIONS(552),
    [anon_sym_return] = ACTIONS(552),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(552),
    [anon_sym_trait] = ACTIONS(552),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_union] = ACTIONS(552),
    [anon_sym_unsafe] = ACTIONS(552),
    [anon_sym_use] = ACTIONS(552),
    [anon_sym_where] = ACTIONS(552),
    [anon_sym_while] = ACTIONS(552),
    [sym_mutable_specifier] = ACTIONS(552),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(552),
    [sym_super] = ACTIONS(552),
    [sym_crate] = ACTIONS(552),
    [sym_metavariable] = ACTIONS(574),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [73] = {
    [sym_delim_token_tree] = STATE(193),
    [sym__delim_tokens] = STATE(203),
    [sym__non_delim_token] = STATE(193),
    [sym__literal] = STATE(208),
    [sym_string_literal] = STATE(188),
    [sym_raw_string_literal] = STATE(188),
    [sym_boolean_literal] = STATE(188),
    [sym_line_comment] = STATE(73),
    [sym_block_comment] = STATE(73),
    [aux_sym__non_special_token_repeat1] = STATE(148),
    [aux_sym_delim_token_tree_repeat1] = STATE(73),
    [sym_identifier] = ACTIONS(618),
    [anon_sym_SEMI] = ACTIONS(621),
    [anon_sym_LPAREN] = ACTIONS(624),
    [anon_sym_RPAREN] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(629),
    [anon_sym_RBRACK] = ACTIONS(627),
    [anon_sym_LBRACE] = ACTIONS(632),
    [anon_sym_RBRACE] = ACTIONS(627),
    [anon_sym_EQ_GT] = ACTIONS(621),
    [anon_sym_COLON] = ACTIONS(635),
    [anon_sym_DOLLAR] = ACTIONS(638),
    [anon_sym_PLUS] = ACTIONS(635),
    [anon_sym_STAR] = ACTIONS(635),
    [anon_sym_QMARK] = ACTIONS(621),
    [anon_sym_u8] = ACTIONS(618),
    [anon_sym_i8] = ACTIONS(618),
    [anon_sym_u16] = ACTIONS(618),
    [anon_sym_i16] = ACTIONS(618),
    [anon_sym_u32] = ACTIONS(618),
    [anon_sym_i32] = ACTIONS(618),
    [anon_sym_u64] = ACTIONS(618),
    [anon_sym_i64] = ACTIONS(618),
    [anon_sym_u128] = ACTIONS(618),
    [anon_sym_i128] = ACTIONS(618),
    [anon_sym_isize] = ACTIONS(618),
    [anon_sym_usize] = ACTIONS(618),
    [anon_sym_f32] = ACTIONS(618),
    [anon_sym_f64] = ACTIONS(618),
    [anon_sym_bool] = ACTIONS(618),
    [anon_sym_str] = ACTIONS(618),
    [anon_sym_char] = ACTIONS(618),
    [anon_sym_DASH] = ACTIONS(635),
    [anon_sym_SLASH] = ACTIONS(635),
    [anon_sym_PERCENT] = ACTIONS(635),
    [anon_sym_CARET] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AMP] = ACTIONS(635),
    [anon_sym_PIPE] = ACTIONS(635),
    [anon_sym_AMP_AMP] = ACTIONS(621),
    [anon_sym_PIPE_PIPE] = ACTIONS(621),
    [anon_sym_LT_LT] = ACTIONS(635),
    [anon_sym_GT_GT] = ACTIONS(635),
    [anon_sym_PLUS_EQ] = ACTIONS(621),
    [anon_sym_DASH_EQ] = ACTIONS(621),
    [anon_sym_STAR_EQ] = ACTIONS(621),
    [anon_sym_SLASH_EQ] = ACTIONS(621),
    [anon_sym_PERCENT_EQ] = ACTIONS(621),
    [anon_sym_CARET_EQ] = ACTIONS(621),
    [anon_sym_AMP_EQ] = ACTIONS(621),
    [anon_sym_PIPE_EQ] = ACTIONS(621),
    [anon_sym_LT_LT_EQ] = ACTIONS(621),
    [anon_sym_GT_GT_EQ] = ACTIONS(621),
    [anon_sym_EQ] = ACTIONS(635),
    [anon_sym_EQ_EQ] = ACTIONS(621),
    [anon_sym_BANG_EQ] = ACTIONS(621),
    [anon_sym_GT] = ACTIONS(635),
    [anon_sym_LT] = ACTIONS(635),
    [anon_sym_GT_EQ] = ACTIONS(621),
    [anon_sym_LT_EQ] = ACTIONS(621),
    [anon_sym_AT] = ACTIONS(621),
    [anon_sym__] = ACTIONS(635),
    [anon_sym_DOT] = ACTIONS(635),
    [anon_sym_DOT_DOT] = ACTIONS(635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(621),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(621),
    [anon_sym_COMMA] = ACTIONS(621),
    [anon_sym_COLON_COLON] = ACTIONS(621),
    [anon_sym_DASH_GT] = ACTIONS(621),
    [anon_sym_POUND] = ACTIONS(621),
    [anon_sym_SQUOTE] = ACTIONS(618),
    [anon_sym_as] = ACTIONS(618),
    [anon_sym_async] = ACTIONS(618),
    [anon_sym_await] = ACTIONS(618),
    [anon_sym_break] = ACTIONS(618),
    [anon_sym_const] = ACTIONS(618),
    [anon_sym_continue] = ACTIONS(618),
    [anon_sym_default] = ACTIONS(618),
    [anon_sym_enum] = ACTIONS(618),
    [anon_sym_fn] = ACTIONS(618),
    [anon_sym_for] = ACTIONS(618),
    [anon_sym_if] = ACTIONS(618),
    [anon_sym_impl] = ACTIONS(618),
    [anon_sym_let] = ACTIONS(618),
    [anon_sym_loop] = ACTIONS(618),
    [anon_sym_match] = ACTIONS(618),
    [anon_sym_mod] = ACTIONS(618),
    [anon_sym_pub] = ACTIONS(618),
    [anon_sym_return] = ACTIONS(618),
    [anon_sym_static] = ACTIONS(618),
    [anon_sym_struct] = ACTIONS(618),
    [anon_sym_trait] = ACTIONS(618),
    [anon_sym_type] = ACTIONS(618),
    [anon_sym_union] = ACTIONS(618),
    [anon_sym_unsafe] = ACTIONS(618),
    [anon_sym_use] = ACTIONS(618),
    [anon_sym_where] = ACTIONS(618),
    [anon_sym_while] = ACTIONS(618),
    [sym_mutable_specifier] = ACTIONS(618),
    [sym_integer_literal] = ACTIONS(641),
    [aux_sym_string_literal_token1] = ACTIONS(644),
    [sym_char_literal] = ACTIONS(641),
    [anon_sym_true] = ACTIONS(647),
    [anon_sym_false] = ACTIONS(647),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(618),
    [sym_super] = ACTIONS(618),
    [sym_crate] = ACTIONS(618),
    [sym__raw_string_literal_start] = ACTIONS(650),
    [sym_float_literal] = ACTIONS(641),
  },
  [74] = {
    [sym__token_pattern] = STATE(155),
    [sym_token_tree_pattern] = STATE(163),
    [sym_token_binding_pattern] = STATE(163),
    [sym_token_repetition_pattern] = STATE(163),
    [sym__literal] = STATE(163),
    [sym_string_literal] = STATE(140),
    [sym_raw_string_literal] = STATE(140),
    [sym_boolean_literal] = STATE(140),
    [sym_line_comment] = STATE(74),
    [sym_block_comment] = STATE(74),
    [aux_sym_token_tree_pattern_repeat1] = STATE(83),
    [aux_sym__non_special_token_repeat1] = STATE(136),
    [sym_identifier] = ACTIONS(552),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_RPAREN] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(558),
    [anon_sym_LBRACE] = ACTIONS(560),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(566),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(552),
    [anon_sym_i8] = ACTIONS(552),
    [anon_sym_u16] = ACTIONS(552),
    [anon_sym_i16] = ACTIONS(552),
    [anon_sym_u32] = ACTIONS(552),
    [anon_sym_i32] = ACTIONS(552),
    [anon_sym_u64] = ACTIONS(552),
    [anon_sym_i64] = ACTIONS(552),
    [anon_sym_u128] = ACTIONS(552),
    [anon_sym_i128] = ACTIONS(552),
    [anon_sym_isize] = ACTIONS(552),
    [anon_sym_usize] = ACTIONS(552),
    [anon_sym_f32] = ACTIONS(552),
    [anon_sym_f64] = ACTIONS(552),
    [anon_sym_bool] = ACTIONS(552),
    [anon_sym_str] = ACTIONS(552),
    [anon_sym_char] = ACTIONS(552),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(552),
    [anon_sym_as] = ACTIONS(552),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_await] = ACTIONS(552),
    [anon_sym_break] = ACTIONS(552),
    [anon_sym_const] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(552),
    [anon_sym_default] = ACTIONS(552),
    [anon_sym_enum] = ACTIONS(552),
    [anon_sym_fn] = ACTIONS(552),
    [anon_sym_for] = ACTIONS(552),
    [anon_sym_if] = ACTIONS(552),
    [anon_sym_impl] = ACTIONS(552),
    [anon_sym_let] = ACTIONS(552),
    [anon_sym_loop] = ACTIONS(552),
    [anon_sym_match] = ACTIONS(552),
    [anon_sym_mod] = ACTIONS(552),
    [anon_sym_pub] = ACTIONS(552),
    [anon_sym_return] = ACTIONS(552),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(552),
    [anon_sym_trait] = ACTIONS(552),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_union] = ACTIONS(552),
    [anon_sym_unsafe] = ACTIONS(552),
    [anon_sym_use] = ACTIONS(552),
    [anon_sym_where] = ACTIONS(552),
    [anon_sym_while] = ACTIONS(552),
    [sym_mutable_specifier] = ACTIONS(552),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(552),
    [sym_super] = ACTIONS(552),
    [sym_crate] = ACTIONS(552),
    [sym_metavariable] = ACTIONS(574),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [75] = {
    [sym__token_pattern] = STATE(155),
    [sym_token_tree_pattern] = STATE(163),
    [sym_token_binding_pattern] = STATE(163),
    [sym_token_repetition_pattern] = STATE(163),
    [sym__literal] = STATE(163),
    [sym_string_literal] = STATE(140),
    [sym_raw_string_literal] = STATE(140),
    [sym_boolean_literal] = STATE(140),
    [sym_line_comment] = STATE(75),
    [sym_block_comment] = STATE(75),
    [aux_sym_token_tree_pattern_repeat1] = STATE(67),
    [aux_sym__non_special_token_repeat1] = STATE(136),
    [sym_identifier] = ACTIONS(552),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(558),
    [anon_sym_LBRACE] = ACTIONS(560),
    [anon_sym_RBRACE] = ACTIONS(655),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(566),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(552),
    [anon_sym_i8] = ACTIONS(552),
    [anon_sym_u16] = ACTIONS(552),
    [anon_sym_i16] = ACTIONS(552),
    [anon_sym_u32] = ACTIONS(552),
    [anon_sym_i32] = ACTIONS(552),
    [anon_sym_u64] = ACTIONS(552),
    [anon_sym_i64] = ACTIONS(552),
    [anon_sym_u128] = ACTIONS(552),
    [anon_sym_i128] = ACTIONS(552),
    [anon_sym_isize] = ACTIONS(552),
    [anon_sym_usize] = ACTIONS(552),
    [anon_sym_f32] = ACTIONS(552),
    [anon_sym_f64] = ACTIONS(552),
    [anon_sym_bool] = ACTIONS(552),
    [anon_sym_str] = ACTIONS(552),
    [anon_sym_char] = ACTIONS(552),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(552),
    [anon_sym_as] = ACTIONS(552),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_await] = ACTIONS(552),
    [anon_sym_break] = ACTIONS(552),
    [anon_sym_const] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(552),
    [anon_sym_default] = ACTIONS(552),
    [anon_sym_enum] = ACTIONS(552),
    [anon_sym_fn] = ACTIONS(552),
    [anon_sym_for] = ACTIONS(552),
    [anon_sym_if] = ACTIONS(552),
    [anon_sym_impl] = ACTIONS(552),
    [anon_sym_let] = ACTIONS(552),
    [anon_sym_loop] = ACTIONS(552),
    [anon_sym_match] = ACTIONS(552),
    [anon_sym_mod] = ACTIONS(552),
    [anon_sym_pub] = ACTIONS(552),
    [anon_sym_return] = ACTIONS(552),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(552),
    [anon_sym_trait] = ACTIONS(552),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_union] = ACTIONS(552),
    [anon_sym_unsafe] = ACTIONS(552),
    [anon_sym_use] = ACTIONS(552),
    [anon_sym_where] = ACTIONS(552),
    [anon_sym_while] = ACTIONS(552),
    [sym_mutable_specifier] = ACTIONS(552),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(552),
    [sym_super] = ACTIONS(552),
    [sym_crate] = ACTIONS(552),
    [sym_metavariable] = ACTIONS(574),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [76] = {
    [sym__token_pattern] = STATE(155),
    [sym_token_tree_pattern] = STATE(163),
    [sym_token_binding_pattern] = STATE(163),
    [sym_token_repetition_pattern] = STATE(163),
    [sym__literal] = STATE(163),
    [sym_string_literal] = STATE(140),
    [sym_raw_string_literal] = STATE(140),
    [sym_boolean_literal] = STATE(140),
    [sym_line_comment] = STATE(76),
    [sym_block_comment] = STATE(76),
    [aux_sym_token_tree_pattern_repeat1] = STATE(82),
    [aux_sym__non_special_token_repeat1] = STATE(136),
    [sym_identifier] = ACTIONS(552),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(558),
    [anon_sym_RBRACK] = ACTIONS(653),
    [anon_sym_LBRACE] = ACTIONS(560),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(566),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(552),
    [anon_sym_i8] = ACTIONS(552),
    [anon_sym_u16] = ACTIONS(552),
    [anon_sym_i16] = ACTIONS(552),
    [anon_sym_u32] = ACTIONS(552),
    [anon_sym_i32] = ACTIONS(552),
    [anon_sym_u64] = ACTIONS(552),
    [anon_sym_i64] = ACTIONS(552),
    [anon_sym_u128] = ACTIONS(552),
    [anon_sym_i128] = ACTIONS(552),
    [anon_sym_isize] = ACTIONS(552),
    [anon_sym_usize] = ACTIONS(552),
    [anon_sym_f32] = ACTIONS(552),
    [anon_sym_f64] = ACTIONS(552),
    [anon_sym_bool] = ACTIONS(552),
    [anon_sym_str] = ACTIONS(552),
    [anon_sym_char] = ACTIONS(552),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(552),
    [anon_sym_as] = ACTIONS(552),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_await] = ACTIONS(552),
    [anon_sym_break] = ACTIONS(552),
    [anon_sym_const] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(552),
    [anon_sym_default] = ACTIONS(552),
    [anon_sym_enum] = ACTIONS(552),
    [anon_sym_fn] = ACTIONS(552),
    [anon_sym_for] = ACTIONS(552),
    [anon_sym_if] = ACTIONS(552),
    [anon_sym_impl] = ACTIONS(552),
    [anon_sym_let] = ACTIONS(552),
    [anon_sym_loop] = ACTIONS(552),
    [anon_sym_match] = ACTIONS(552),
    [anon_sym_mod] = ACTIONS(552),
    [anon_sym_pub] = ACTIONS(552),
    [anon_sym_return] = ACTIONS(552),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(552),
    [anon_sym_trait] = ACTIONS(552),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_union] = ACTIONS(552),
    [anon_sym_unsafe] = ACTIONS(552),
    [anon_sym_use] = ACTIONS(552),
    [anon_sym_where] = ACTIONS(552),
    [anon_sym_while] = ACTIONS(552),
    [sym_mutable_specifier] = ACTIONS(552),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(552),
    [sym_super] = ACTIONS(552),
    [sym_crate] = ACTIONS(552),
    [sym_metavariable] = ACTIONS(574),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [77] = {
    [sym__token_pattern] = STATE(155),
    [sym_token_tree_pattern] = STATE(163),
    [sym_token_binding_pattern] = STATE(163),
    [sym_token_repetition_pattern] = STATE(163),
    [sym__literal] = STATE(163),
    [sym_string_literal] = STATE(140),
    [sym_raw_string_literal] = STATE(140),
    [sym_boolean_literal] = STATE(140),
    [sym_line_comment] = STATE(77),
    [sym_block_comment] = STATE(77),
    [aux_sym_token_tree_pattern_repeat1] = STATE(80),
    [aux_sym__non_special_token_repeat1] = STATE(136),
    [sym_identifier] = ACTIONS(552),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(558),
    [anon_sym_LBRACE] = ACTIONS(560),
    [anon_sym_RBRACE] = ACTIONS(653),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(566),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(552),
    [anon_sym_i8] = ACTIONS(552),
    [anon_sym_u16] = ACTIONS(552),
    [anon_sym_i16] = ACTIONS(552),
    [anon_sym_u32] = ACTIONS(552),
    [anon_sym_i32] = ACTIONS(552),
    [anon_sym_u64] = ACTIONS(552),
    [anon_sym_i64] = ACTIONS(552),
    [anon_sym_u128] = ACTIONS(552),
    [anon_sym_i128] = ACTIONS(552),
    [anon_sym_isize] = ACTIONS(552),
    [anon_sym_usize] = ACTIONS(552),
    [anon_sym_f32] = ACTIONS(552),
    [anon_sym_f64] = ACTIONS(552),
    [anon_sym_bool] = ACTIONS(552),
    [anon_sym_str] = ACTIONS(552),
    [anon_sym_char] = ACTIONS(552),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(552),
    [anon_sym_as] = ACTIONS(552),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_await] = ACTIONS(552),
    [anon_sym_break] = ACTIONS(552),
    [anon_sym_const] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(552),
    [anon_sym_default] = ACTIONS(552),
    [anon_sym_enum] = ACTIONS(552),
    [anon_sym_fn] = ACTIONS(552),
    [anon_sym_for] = ACTIONS(552),
    [anon_sym_if] = ACTIONS(552),
    [anon_sym_impl] = ACTIONS(552),
    [anon_sym_let] = ACTIONS(552),
    [anon_sym_loop] = ACTIONS(552),
    [anon_sym_match] = ACTIONS(552),
    [anon_sym_mod] = ACTIONS(552),
    [anon_sym_pub] = ACTIONS(552),
    [anon_sym_return] = ACTIONS(552),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(552),
    [anon_sym_trait] = ACTIONS(552),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_union] = ACTIONS(552),
    [anon_sym_unsafe] = ACTIONS(552),
    [anon_sym_use] = ACTIONS(552),
    [anon_sym_where] = ACTIONS(552),
    [anon_sym_while] = ACTIONS(552),
    [sym_mutable_specifier] = ACTIONS(552),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(552),
    [sym_super] = ACTIONS(552),
    [sym_crate] = ACTIONS(552),
    [sym_metavariable] = ACTIONS(574),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [78] = {
    [sym__token_pattern] = STATE(155),
    [sym_token_tree_pattern] = STATE(163),
    [sym_token_binding_pattern] = STATE(163),
    [sym_token_repetition_pattern] = STATE(163),
    [sym__literal] = STATE(163),
    [sym_string_literal] = STATE(140),
    [sym_raw_string_literal] = STATE(140),
    [sym_boolean_literal] = STATE(140),
    [sym_line_comment] = STATE(78),
    [sym_block_comment] = STATE(78),
    [aux_sym_token_tree_pattern_repeat1] = STATE(67),
    [aux_sym__non_special_token_repeat1] = STATE(136),
    [sym_identifier] = ACTIONS(552),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(558),
    [anon_sym_RBRACK] = ACTIONS(655),
    [anon_sym_LBRACE] = ACTIONS(560),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(566),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(552),
    [anon_sym_i8] = ACTIONS(552),
    [anon_sym_u16] = ACTIONS(552),
    [anon_sym_i16] = ACTIONS(552),
    [anon_sym_u32] = ACTIONS(552),
    [anon_sym_i32] = ACTIONS(552),
    [anon_sym_u64] = ACTIONS(552),
    [anon_sym_i64] = ACTIONS(552),
    [anon_sym_u128] = ACTIONS(552),
    [anon_sym_i128] = ACTIONS(552),
    [anon_sym_isize] = ACTIONS(552),
    [anon_sym_usize] = ACTIONS(552),
    [anon_sym_f32] = ACTIONS(552),
    [anon_sym_f64] = ACTIONS(552),
    [anon_sym_bool] = ACTIONS(552),
    [anon_sym_str] = ACTIONS(552),
    [anon_sym_char] = ACTIONS(552),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(552),
    [anon_sym_as] = ACTIONS(552),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_await] = ACTIONS(552),
    [anon_sym_break] = ACTIONS(552),
    [anon_sym_const] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(552),
    [anon_sym_default] = ACTIONS(552),
    [anon_sym_enum] = ACTIONS(552),
    [anon_sym_fn] = ACTIONS(552),
    [anon_sym_for] = ACTIONS(552),
    [anon_sym_if] = ACTIONS(552),
    [anon_sym_impl] = ACTIONS(552),
    [anon_sym_let] = ACTIONS(552),
    [anon_sym_loop] = ACTIONS(552),
    [anon_sym_match] = ACTIONS(552),
    [anon_sym_mod] = ACTIONS(552),
    [anon_sym_pub] = ACTIONS(552),
    [anon_sym_return] = ACTIONS(552),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(552),
    [anon_sym_trait] = ACTIONS(552),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_union] = ACTIONS(552),
    [anon_sym_unsafe] = ACTIONS(552),
    [anon_sym_use] = ACTIONS(552),
    [anon_sym_where] = ACTIONS(552),
    [anon_sym_while] = ACTIONS(552),
    [sym_mutable_specifier] = ACTIONS(552),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(552),
    [sym_super] = ACTIONS(552),
    [sym_crate] = ACTIONS(552),
    [sym_metavariable] = ACTIONS(574),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [79] = {
    [sym__token_pattern] = STATE(155),
    [sym_token_tree_pattern] = STATE(163),
    [sym_token_binding_pattern] = STATE(163),
    [sym_token_repetition_pattern] = STATE(163),
    [sym__literal] = STATE(163),
    [sym_string_literal] = STATE(140),
    [sym_raw_string_literal] = STATE(140),
    [sym_boolean_literal] = STATE(140),
    [sym_line_comment] = STATE(79),
    [sym_block_comment] = STATE(79),
    [aux_sym_token_tree_pattern_repeat1] = STATE(67),
    [aux_sym__non_special_token_repeat1] = STATE(136),
    [sym_identifier] = ACTIONS(552),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_RPAREN] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(558),
    [anon_sym_LBRACE] = ACTIONS(560),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(566),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(552),
    [anon_sym_i8] = ACTIONS(552),
    [anon_sym_u16] = ACTIONS(552),
    [anon_sym_i16] = ACTIONS(552),
    [anon_sym_u32] = ACTIONS(552),
    [anon_sym_i32] = ACTIONS(552),
    [anon_sym_u64] = ACTIONS(552),
    [anon_sym_i64] = ACTIONS(552),
    [anon_sym_u128] = ACTIONS(552),
    [anon_sym_i128] = ACTIONS(552),
    [anon_sym_isize] = ACTIONS(552),
    [anon_sym_usize] = ACTIONS(552),
    [anon_sym_f32] = ACTIONS(552),
    [anon_sym_f64] = ACTIONS(552),
    [anon_sym_bool] = ACTIONS(552),
    [anon_sym_str] = ACTIONS(552),
    [anon_sym_char] = ACTIONS(552),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(552),
    [anon_sym_as] = ACTIONS(552),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_await] = ACTIONS(552),
    [anon_sym_break] = ACTIONS(552),
    [anon_sym_const] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(552),
    [anon_sym_default] = ACTIONS(552),
    [anon_sym_enum] = ACTIONS(552),
    [anon_sym_fn] = ACTIONS(552),
    [anon_sym_for] = ACTIONS(552),
    [anon_sym_if] = ACTIONS(552),
    [anon_sym_impl] = ACTIONS(552),
    [anon_sym_let] = ACTIONS(552),
    [anon_sym_loop] = ACTIONS(552),
    [anon_sym_match] = ACTIONS(552),
    [anon_sym_mod] = ACTIONS(552),
    [anon_sym_pub] = ACTIONS(552),
    [anon_sym_return] = ACTIONS(552),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(552),
    [anon_sym_trait] = ACTIONS(552),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_union] = ACTIONS(552),
    [anon_sym_unsafe] = ACTIONS(552),
    [anon_sym_use] = ACTIONS(552),
    [anon_sym_where] = ACTIONS(552),
    [anon_sym_while] = ACTIONS(552),
    [sym_mutable_specifier] = ACTIONS(552),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(552),
    [sym_super] = ACTIONS(552),
    [sym_crate] = ACTIONS(552),
    [sym_metavariable] = ACTIONS(574),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [80] = {
    [sym__token_pattern] = STATE(155),
    [sym_token_tree_pattern] = STATE(163),
    [sym_token_binding_pattern] = STATE(163),
    [sym_token_repetition_pattern] = STATE(163),
    [sym__literal] = STATE(163),
    [sym_string_literal] = STATE(140),
    [sym_raw_string_literal] = STATE(140),
    [sym_boolean_literal] = STATE(140),
    [sym_line_comment] = STATE(80),
    [sym_block_comment] = STATE(80),
    [aux_sym_token_tree_pattern_repeat1] = STATE(67),
    [aux_sym__non_special_token_repeat1] = STATE(136),
    [sym_identifier] = ACTIONS(552),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(558),
    [anon_sym_LBRACE] = ACTIONS(560),
    [anon_sym_RBRACE] = ACTIONS(657),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(566),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(552),
    [anon_sym_i8] = ACTIONS(552),
    [anon_sym_u16] = ACTIONS(552),
    [anon_sym_i16] = ACTIONS(552),
    [anon_sym_u32] = ACTIONS(552),
    [anon_sym_i32] = ACTIONS(552),
    [anon_sym_u64] = ACTIONS(552),
    [anon_sym_i64] = ACTIONS(552),
    [anon_sym_u128] = ACTIONS(552),
    [anon_sym_i128] = ACTIONS(552),
    [anon_sym_isize] = ACTIONS(552),
    [anon_sym_usize] = ACTIONS(552),
    [anon_sym_f32] = ACTIONS(552),
    [anon_sym_f64] = ACTIONS(552),
    [anon_sym_bool] = ACTIONS(552),
    [anon_sym_str] = ACTIONS(552),
    [anon_sym_char] = ACTIONS(552),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(552),
    [anon_sym_as] = ACTIONS(552),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_await] = ACTIONS(552),
    [anon_sym_break] = ACTIONS(552),
    [anon_sym_const] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(552),
    [anon_sym_default] = ACTIONS(552),
    [anon_sym_enum] = ACTIONS(552),
    [anon_sym_fn] = ACTIONS(552),
    [anon_sym_for] = ACTIONS(552),
    [anon_sym_if] = ACTIONS(552),
    [anon_sym_impl] = ACTIONS(552),
    [anon_sym_let] = ACTIONS(552),
    [anon_sym_loop] = ACTIONS(552),
    [anon_sym_match] = ACTIONS(552),
    [anon_sym_mod] = ACTIONS(552),
    [anon_sym_pub] = ACTIONS(552),
    [anon_sym_return] = ACTIONS(552),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(552),
    [anon_sym_trait] = ACTIONS(552),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_union] = ACTIONS(552),
    [anon_sym_unsafe] = ACTIONS(552),
    [anon_sym_use] = ACTIONS(552),
    [anon_sym_where] = ACTIONS(552),
    [anon_sym_while] = ACTIONS(552),
    [sym_mutable_specifier] = ACTIONS(552),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(552),
    [sym_super] = ACTIONS(552),
    [sym_crate] = ACTIONS(552),
    [sym_metavariable] = ACTIONS(574),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [81] = {
    [sym__token_pattern] = STATE(155),
    [sym_token_tree_pattern] = STATE(163),
    [sym_token_binding_pattern] = STATE(163),
    [sym_token_repetition_pattern] = STATE(163),
    [sym__literal] = STATE(163),
    [sym_string_literal] = STATE(140),
    [sym_raw_string_literal] = STATE(140),
    [sym_boolean_literal] = STATE(140),
    [sym_line_comment] = STATE(81),
    [sym_block_comment] = STATE(81),
    [aux_sym_token_tree_pattern_repeat1] = STATE(67),
    [aux_sym__non_special_token_repeat1] = STATE(136),
    [sym_identifier] = ACTIONS(552),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_RPAREN] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(558),
    [anon_sym_LBRACE] = ACTIONS(560),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(566),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(552),
    [anon_sym_i8] = ACTIONS(552),
    [anon_sym_u16] = ACTIONS(552),
    [anon_sym_i16] = ACTIONS(552),
    [anon_sym_u32] = ACTIONS(552),
    [anon_sym_i32] = ACTIONS(552),
    [anon_sym_u64] = ACTIONS(552),
    [anon_sym_i64] = ACTIONS(552),
    [anon_sym_u128] = ACTIONS(552),
    [anon_sym_i128] = ACTIONS(552),
    [anon_sym_isize] = ACTIONS(552),
    [anon_sym_usize] = ACTIONS(552),
    [anon_sym_f32] = ACTIONS(552),
    [anon_sym_f64] = ACTIONS(552),
    [anon_sym_bool] = ACTIONS(552),
    [anon_sym_str] = ACTIONS(552),
    [anon_sym_char] = ACTIONS(552),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(552),
    [anon_sym_as] = ACTIONS(552),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_await] = ACTIONS(552),
    [anon_sym_break] = ACTIONS(552),
    [anon_sym_const] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(552),
    [anon_sym_default] = ACTIONS(552),
    [anon_sym_enum] = ACTIONS(552),
    [anon_sym_fn] = ACTIONS(552),
    [anon_sym_for] = ACTIONS(552),
    [anon_sym_if] = ACTIONS(552),
    [anon_sym_impl] = ACTIONS(552),
    [anon_sym_let] = ACTIONS(552),
    [anon_sym_loop] = ACTIONS(552),
    [anon_sym_match] = ACTIONS(552),
    [anon_sym_mod] = ACTIONS(552),
    [anon_sym_pub] = ACTIONS(552),
    [anon_sym_return] = ACTIONS(552),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(552),
    [anon_sym_trait] = ACTIONS(552),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_union] = ACTIONS(552),
    [anon_sym_unsafe] = ACTIONS(552),
    [anon_sym_use] = ACTIONS(552),
    [anon_sym_where] = ACTIONS(552),
    [anon_sym_while] = ACTIONS(552),
    [sym_mutable_specifier] = ACTIONS(552),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(552),
    [sym_super] = ACTIONS(552),
    [sym_crate] = ACTIONS(552),
    [sym_metavariable] = ACTIONS(574),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [82] = {
    [sym__token_pattern] = STATE(155),
    [sym_token_tree_pattern] = STATE(163),
    [sym_token_binding_pattern] = STATE(163),
    [sym_token_repetition_pattern] = STATE(163),
    [sym__literal] = STATE(163),
    [sym_string_literal] = STATE(140),
    [sym_raw_string_literal] = STATE(140),
    [sym_boolean_literal] = STATE(140),
    [sym_line_comment] = STATE(82),
    [sym_block_comment] = STATE(82),
    [aux_sym_token_tree_pattern_repeat1] = STATE(67),
    [aux_sym__non_special_token_repeat1] = STATE(136),
    [sym_identifier] = ACTIONS(552),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(558),
    [anon_sym_RBRACK] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(560),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(566),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(552),
    [anon_sym_i8] = ACTIONS(552),
    [anon_sym_u16] = ACTIONS(552),
    [anon_sym_i16] = ACTIONS(552),
    [anon_sym_u32] = ACTIONS(552),
    [anon_sym_i32] = ACTIONS(552),
    [anon_sym_u64] = ACTIONS(552),
    [anon_sym_i64] = ACTIONS(552),
    [anon_sym_u128] = ACTIONS(552),
    [anon_sym_i128] = ACTIONS(552),
    [anon_sym_isize] = ACTIONS(552),
    [anon_sym_usize] = ACTIONS(552),
    [anon_sym_f32] = ACTIONS(552),
    [anon_sym_f64] = ACTIONS(552),
    [anon_sym_bool] = ACTIONS(552),
    [anon_sym_str] = ACTIONS(552),
    [anon_sym_char] = ACTIONS(552),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(552),
    [anon_sym_as] = ACTIONS(552),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_await] = ACTIONS(552),
    [anon_sym_break] = ACTIONS(552),
    [anon_sym_const] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(552),
    [anon_sym_default] = ACTIONS(552),
    [anon_sym_enum] = ACTIONS(552),
    [anon_sym_fn] = ACTIONS(552),
    [anon_sym_for] = ACTIONS(552),
    [anon_sym_if] = ACTIONS(552),
    [anon_sym_impl] = ACTIONS(552),
    [anon_sym_let] = ACTIONS(552),
    [anon_sym_loop] = ACTIONS(552),
    [anon_sym_match] = ACTIONS(552),
    [anon_sym_mod] = ACTIONS(552),
    [anon_sym_pub] = ACTIONS(552),
    [anon_sym_return] = ACTIONS(552),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(552),
    [anon_sym_trait] = ACTIONS(552),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_union] = ACTIONS(552),
    [anon_sym_unsafe] = ACTIONS(552),
    [anon_sym_use] = ACTIONS(552),
    [anon_sym_where] = ACTIONS(552),
    [anon_sym_while] = ACTIONS(552),
    [sym_mutable_specifier] = ACTIONS(552),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(552),
    [sym_super] = ACTIONS(552),
    [sym_crate] = ACTIONS(552),
    [sym_metavariable] = ACTIONS(574),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [83] = {
    [sym__token_pattern] = STATE(155),
    [sym_token_tree_pattern] = STATE(163),
    [sym_token_binding_pattern] = STATE(163),
    [sym_token_repetition_pattern] = STATE(163),
    [sym__literal] = STATE(163),
    [sym_string_literal] = STATE(140),
    [sym_raw_string_literal] = STATE(140),
    [sym_boolean_literal] = STATE(140),
    [sym_line_comment] = STATE(83),
    [sym_block_comment] = STATE(83),
    [aux_sym_token_tree_pattern_repeat1] = STATE(67),
    [aux_sym__non_special_token_repeat1] = STATE(136),
    [sym_identifier] = ACTIONS(552),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_RPAREN] = ACTIONS(657),
    [anon_sym_LBRACK] = ACTIONS(558),
    [anon_sym_LBRACE] = ACTIONS(560),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(566),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(552),
    [anon_sym_i8] = ACTIONS(552),
    [anon_sym_u16] = ACTIONS(552),
    [anon_sym_i16] = ACTIONS(552),
    [anon_sym_u32] = ACTIONS(552),
    [anon_sym_i32] = ACTIONS(552),
    [anon_sym_u64] = ACTIONS(552),
    [anon_sym_i64] = ACTIONS(552),
    [anon_sym_u128] = ACTIONS(552),
    [anon_sym_i128] = ACTIONS(552),
    [anon_sym_isize] = ACTIONS(552),
    [anon_sym_usize] = ACTIONS(552),
    [anon_sym_f32] = ACTIONS(552),
    [anon_sym_f64] = ACTIONS(552),
    [anon_sym_bool] = ACTIONS(552),
    [anon_sym_str] = ACTIONS(552),
    [anon_sym_char] = ACTIONS(552),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(552),
    [anon_sym_as] = ACTIONS(552),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_await] = ACTIONS(552),
    [anon_sym_break] = ACTIONS(552),
    [anon_sym_const] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(552),
    [anon_sym_default] = ACTIONS(552),
    [anon_sym_enum] = ACTIONS(552),
    [anon_sym_fn] = ACTIONS(552),
    [anon_sym_for] = ACTIONS(552),
    [anon_sym_if] = ACTIONS(552),
    [anon_sym_impl] = ACTIONS(552),
    [anon_sym_let] = ACTIONS(552),
    [anon_sym_loop] = ACTIONS(552),
    [anon_sym_match] = ACTIONS(552),
    [anon_sym_mod] = ACTIONS(552),
    [anon_sym_pub] = ACTIONS(552),
    [anon_sym_return] = ACTIONS(552),
    [anon_sym_static] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(552),
    [anon_sym_trait] = ACTIONS(552),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_union] = ACTIONS(552),
    [anon_sym_unsafe] = ACTIONS(552),
    [anon_sym_use] = ACTIONS(552),
    [anon_sym_where] = ACTIONS(552),
    [anon_sym_while] = ACTIONS(552),
    [sym_mutable_specifier] = ACTIONS(552),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(552),
    [sym_super] = ACTIONS(552),
    [sym_crate] = ACTIONS(552),
    [sym_metavariable] = ACTIONS(574),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [84] = {
    [sym_delim_token_tree] = STATE(193),
    [sym__delim_tokens] = STATE(203),
    [sym__non_delim_token] = STATE(193),
    [sym__literal] = STATE(208),
    [sym_string_literal] = STATE(188),
    [sym_raw_string_literal] = STATE(188),
    [sym_boolean_literal] = STATE(188),
    [sym_line_comment] = STATE(84),
    [sym_block_comment] = STATE(84),
    [aux_sym__non_special_token_repeat1] = STATE(148),
    [aux_sym_delim_token_tree_repeat1] = STATE(87),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(667),
    [anon_sym_RBRACK] = ACTIONS(669),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [85] = {
    [sym_delim_token_tree] = STATE(193),
    [sym__delim_tokens] = STATE(203),
    [sym__non_delim_token] = STATE(193),
    [sym__literal] = STATE(208),
    [sym_string_literal] = STATE(188),
    [sym_raw_string_literal] = STATE(188),
    [sym_boolean_literal] = STATE(188),
    [sym_line_comment] = STATE(85),
    [sym_block_comment] = STATE(85),
    [aux_sym__non_special_token_repeat1] = STATE(148),
    [aux_sym_delim_token_tree_repeat1] = STATE(73),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(667),
    [anon_sym_RBRACK] = ACTIONS(685),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [86] = {
    [sym_delim_token_tree] = STATE(193),
    [sym__delim_tokens] = STATE(203),
    [sym__non_delim_token] = STATE(193),
    [sym__literal] = STATE(208),
    [sym_string_literal] = STATE(188),
    [sym_raw_string_literal] = STATE(188),
    [sym_boolean_literal] = STATE(188),
    [sym_line_comment] = STATE(86),
    [sym_block_comment] = STATE(86),
    [aux_sym__non_special_token_repeat1] = STATE(148),
    [aux_sym_delim_token_tree_repeat1] = STATE(105),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(687),
    [anon_sym_LBRACK] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [87] = {
    [sym_delim_token_tree] = STATE(193),
    [sym__delim_tokens] = STATE(203),
    [sym__non_delim_token] = STATE(193),
    [sym__literal] = STATE(208),
    [sym_string_literal] = STATE(188),
    [sym_raw_string_literal] = STATE(188),
    [sym_boolean_literal] = STATE(188),
    [sym_line_comment] = STATE(87),
    [sym_block_comment] = STATE(87),
    [aux_sym__non_special_token_repeat1] = STATE(148),
    [aux_sym_delim_token_tree_repeat1] = STATE(73),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(667),
    [anon_sym_RBRACK] = ACTIONS(689),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [88] = {
    [sym_delim_token_tree] = STATE(193),
    [sym__delim_tokens] = STATE(203),
    [sym__non_delim_token] = STATE(193),
    [sym__literal] = STATE(208),
    [sym_string_literal] = STATE(188),
    [sym_raw_string_literal] = STATE(188),
    [sym_boolean_literal] = STATE(188),
    [sym_line_comment] = STATE(88),
    [sym_block_comment] = STATE(88),
    [aux_sym__non_special_token_repeat1] = STATE(148),
    [aux_sym_delim_token_tree_repeat1] = STATE(73),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(667),
    [anon_sym_RBRACK] = ACTIONS(691),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [89] = {
    [sym_delim_token_tree] = STATE(193),
    [sym__delim_tokens] = STATE(203),
    [sym__non_delim_token] = STATE(193),
    [sym__literal] = STATE(208),
    [sym_string_literal] = STATE(188),
    [sym_raw_string_literal] = STATE(188),
    [sym_boolean_literal] = STATE(188),
    [sym_line_comment] = STATE(89),
    [sym_block_comment] = STATE(89),
    [aux_sym__non_special_token_repeat1] = STATE(148),
    [aux_sym_delim_token_tree_repeat1] = STATE(73),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_RBRACE] = ACTIONS(689),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [90] = {
    [sym_token_tree] = STATE(152),
    [sym_token_repetition] = STATE(152),
    [sym__literal] = STATE(152),
    [sym_string_literal] = STATE(140),
    [sym_raw_string_literal] = STATE(140),
    [sym_boolean_literal] = STATE(140),
    [sym_line_comment] = STATE(90),
    [sym_block_comment] = STATE(90),
    [aux_sym_token_tree_repeat1] = STATE(102),
    [aux_sym__non_special_token_repeat1] = STATE(135),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(695),
    [anon_sym_RPAREN] = ACTIONS(697),
    [anon_sym_LBRACK] = ACTIONS(699),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(703),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(693),
    [anon_sym_i8] = ACTIONS(693),
    [anon_sym_u16] = ACTIONS(693),
    [anon_sym_i16] = ACTIONS(693),
    [anon_sym_u32] = ACTIONS(693),
    [anon_sym_i32] = ACTIONS(693),
    [anon_sym_u64] = ACTIONS(693),
    [anon_sym_i64] = ACTIONS(693),
    [anon_sym_u128] = ACTIONS(693),
    [anon_sym_i128] = ACTIONS(693),
    [anon_sym_isize] = ACTIONS(693),
    [anon_sym_usize] = ACTIONS(693),
    [anon_sym_f32] = ACTIONS(693),
    [anon_sym_f64] = ACTIONS(693),
    [anon_sym_bool] = ACTIONS(693),
    [anon_sym_str] = ACTIONS(693),
    [anon_sym_char] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(693),
    [anon_sym_as] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(693),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_break] = ACTIONS(693),
    [anon_sym_const] = ACTIONS(693),
    [anon_sym_continue] = ACTIONS(693),
    [anon_sym_default] = ACTIONS(693),
    [anon_sym_enum] = ACTIONS(693),
    [anon_sym_fn] = ACTIONS(693),
    [anon_sym_for] = ACTIONS(693),
    [anon_sym_if] = ACTIONS(693),
    [anon_sym_impl] = ACTIONS(693),
    [anon_sym_let] = ACTIONS(693),
    [anon_sym_loop] = ACTIONS(693),
    [anon_sym_match] = ACTIONS(693),
    [anon_sym_mod] = ACTIONS(693),
    [anon_sym_pub] = ACTIONS(693),
    [anon_sym_return] = ACTIONS(693),
    [anon_sym_static] = ACTIONS(693),
    [anon_sym_struct] = ACTIONS(693),
    [anon_sym_trait] = ACTIONS(693),
    [anon_sym_type] = ACTIONS(693),
    [anon_sym_union] = ACTIONS(693),
    [anon_sym_unsafe] = ACTIONS(693),
    [anon_sym_use] = ACTIONS(693),
    [anon_sym_where] = ACTIONS(693),
    [anon_sym_while] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(693),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(693),
    [sym_super] = ACTIONS(693),
    [sym_crate] = ACTIONS(693),
    [sym_metavariable] = ACTIONS(705),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [91] = {
    [sym_token_tree] = STATE(152),
    [sym_token_repetition] = STATE(152),
    [sym__literal] = STATE(152),
    [sym_string_literal] = STATE(140),
    [sym_raw_string_literal] = STATE(140),
    [sym_boolean_literal] = STATE(140),
    [sym_line_comment] = STATE(91),
    [sym_block_comment] = STATE(91),
    [aux_sym_token_tree_repeat1] = STATE(98),
    [aux_sym__non_special_token_repeat1] = STATE(135),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(695),
    [anon_sym_LBRACK] = ACTIONS(699),
    [anon_sym_RBRACK] = ACTIONS(697),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(703),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(693),
    [anon_sym_i8] = ACTIONS(693),
    [anon_sym_u16] = ACTIONS(693),
    [anon_sym_i16] = ACTIONS(693),
    [anon_sym_u32] = ACTIONS(693),
    [anon_sym_i32] = ACTIONS(693),
    [anon_sym_u64] = ACTIONS(693),
    [anon_sym_i64] = ACTIONS(693),
    [anon_sym_u128] = ACTIONS(693),
    [anon_sym_i128] = ACTIONS(693),
    [anon_sym_isize] = ACTIONS(693),
    [anon_sym_usize] = ACTIONS(693),
    [anon_sym_f32] = ACTIONS(693),
    [anon_sym_f64] = ACTIONS(693),
    [anon_sym_bool] = ACTIONS(693),
    [anon_sym_str] = ACTIONS(693),
    [anon_sym_char] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(693),
    [anon_sym_as] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(693),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_break] = ACTIONS(693),
    [anon_sym_const] = ACTIONS(693),
    [anon_sym_continue] = ACTIONS(693),
    [anon_sym_default] = ACTIONS(693),
    [anon_sym_enum] = ACTIONS(693),
    [anon_sym_fn] = ACTIONS(693),
    [anon_sym_for] = ACTIONS(693),
    [anon_sym_if] = ACTIONS(693),
    [anon_sym_impl] = ACTIONS(693),
    [anon_sym_let] = ACTIONS(693),
    [anon_sym_loop] = ACTIONS(693),
    [anon_sym_match] = ACTIONS(693),
    [anon_sym_mod] = ACTIONS(693),
    [anon_sym_pub] = ACTIONS(693),
    [anon_sym_return] = ACTIONS(693),
    [anon_sym_static] = ACTIONS(693),
    [anon_sym_struct] = ACTIONS(693),
    [anon_sym_trait] = ACTIONS(693),
    [anon_sym_type] = ACTIONS(693),
    [anon_sym_union] = ACTIONS(693),
    [anon_sym_unsafe] = ACTIONS(693),
    [anon_sym_use] = ACTIONS(693),
    [anon_sym_where] = ACTIONS(693),
    [anon_sym_while] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(693),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(693),
    [sym_super] = ACTIONS(693),
    [sym_crate] = ACTIONS(693),
    [sym_metavariable] = ACTIONS(705),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [92] = {
    [sym_delim_token_tree] = STATE(193),
    [sym__delim_tokens] = STATE(203),
    [sym__non_delim_token] = STATE(193),
    [sym__literal] = STATE(208),
    [sym_string_literal] = STATE(188),
    [sym_raw_string_literal] = STATE(188),
    [sym_boolean_literal] = STATE(188),
    [sym_line_comment] = STATE(92),
    [sym_block_comment] = STATE(92),
    [aux_sym__non_special_token_repeat1] = STATE(148),
    [aux_sym_delim_token_tree_repeat1] = STATE(73),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(691),
    [anon_sym_LBRACK] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [93] = {
    [sym_token_tree] = STATE(152),
    [sym_token_repetition] = STATE(152),
    [sym__literal] = STATE(152),
    [sym_string_literal] = STATE(140),
    [sym_raw_string_literal] = STATE(140),
    [sym_boolean_literal] = STATE(140),
    [sym_line_comment] = STATE(93),
    [sym_block_comment] = STATE(93),
    [aux_sym_token_tree_repeat1] = STATE(97),
    [aux_sym__non_special_token_repeat1] = STATE(135),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(695),
    [anon_sym_LBRACK] = ACTIONS(699),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_RBRACE] = ACTIONS(697),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(703),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(693),
    [anon_sym_i8] = ACTIONS(693),
    [anon_sym_u16] = ACTIONS(693),
    [anon_sym_i16] = ACTIONS(693),
    [anon_sym_u32] = ACTIONS(693),
    [anon_sym_i32] = ACTIONS(693),
    [anon_sym_u64] = ACTIONS(693),
    [anon_sym_i64] = ACTIONS(693),
    [anon_sym_u128] = ACTIONS(693),
    [anon_sym_i128] = ACTIONS(693),
    [anon_sym_isize] = ACTIONS(693),
    [anon_sym_usize] = ACTIONS(693),
    [anon_sym_f32] = ACTIONS(693),
    [anon_sym_f64] = ACTIONS(693),
    [anon_sym_bool] = ACTIONS(693),
    [anon_sym_str] = ACTIONS(693),
    [anon_sym_char] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(693),
    [anon_sym_as] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(693),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_break] = ACTIONS(693),
    [anon_sym_const] = ACTIONS(693),
    [anon_sym_continue] = ACTIONS(693),
    [anon_sym_default] = ACTIONS(693),
    [anon_sym_enum] = ACTIONS(693),
    [anon_sym_fn] = ACTIONS(693),
    [anon_sym_for] = ACTIONS(693),
    [anon_sym_if] = ACTIONS(693),
    [anon_sym_impl] = ACTIONS(693),
    [anon_sym_let] = ACTIONS(693),
    [anon_sym_loop] = ACTIONS(693),
    [anon_sym_match] = ACTIONS(693),
    [anon_sym_mod] = ACTIONS(693),
    [anon_sym_pub] = ACTIONS(693),
    [anon_sym_return] = ACTIONS(693),
    [anon_sym_static] = ACTIONS(693),
    [anon_sym_struct] = ACTIONS(693),
    [anon_sym_trait] = ACTIONS(693),
    [anon_sym_type] = ACTIONS(693),
    [anon_sym_union] = ACTIONS(693),
    [anon_sym_unsafe] = ACTIONS(693),
    [anon_sym_use] = ACTIONS(693),
    [anon_sym_where] = ACTIONS(693),
    [anon_sym_while] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(693),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(693),
    [sym_super] = ACTIONS(693),
    [sym_crate] = ACTIONS(693),
    [sym_metavariable] = ACTIONS(705),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [94] = {
    [sym_delim_token_tree] = STATE(193),
    [sym__delim_tokens] = STATE(203),
    [sym__non_delim_token] = STATE(193),
    [sym__literal] = STATE(208),
    [sym_string_literal] = STATE(188),
    [sym_raw_string_literal] = STATE(188),
    [sym_boolean_literal] = STATE(188),
    [sym_line_comment] = STATE(94),
    [sym_block_comment] = STATE(94),
    [aux_sym__non_special_token_repeat1] = STATE(148),
    [aux_sym_delim_token_tree_repeat1] = STATE(116),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [95] = {
    [sym_delim_token_tree] = STATE(193),
    [sym__delim_tokens] = STATE(203),
    [sym__non_delim_token] = STATE(193),
    [sym__literal] = STATE(208),
    [sym_string_literal] = STATE(188),
    [sym_raw_string_literal] = STATE(188),
    [sym_boolean_literal] = STATE(188),
    [sym_line_comment] = STATE(95),
    [sym_block_comment] = STATE(95),
    [aux_sym__non_special_token_repeat1] = STATE(148),
    [aux_sym_delim_token_tree_repeat1] = STATE(108),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(707),
    [anon_sym_LBRACK] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [96] = {
    [sym_delim_token_tree] = STATE(193),
    [sym__delim_tokens] = STATE(203),
    [sym__non_delim_token] = STATE(193),
    [sym__literal] = STATE(208),
    [sym_string_literal] = STATE(188),
    [sym_raw_string_literal] = STATE(188),
    [sym_boolean_literal] = STATE(188),
    [sym_line_comment] = STATE(96),
    [sym_block_comment] = STATE(96),
    [aux_sym__non_special_token_repeat1] = STATE(148),
    [aux_sym_delim_token_tree_repeat1] = STATE(85),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(667),
    [anon_sym_RBRACK] = ACTIONS(707),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [97] = {
    [sym_token_tree] = STATE(152),
    [sym_token_repetition] = STATE(152),
    [sym__literal] = STATE(152),
    [sym_string_literal] = STATE(140),
    [sym_raw_string_literal] = STATE(140),
    [sym_boolean_literal] = STATE(140),
    [sym_line_comment] = STATE(97),
    [sym_block_comment] = STATE(97),
    [aux_sym_token_tree_repeat1] = STATE(69),
    [aux_sym__non_special_token_repeat1] = STATE(135),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(695),
    [anon_sym_LBRACK] = ACTIONS(699),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_RBRACE] = ACTIONS(709),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(703),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(693),
    [anon_sym_i8] = ACTIONS(693),
    [anon_sym_u16] = ACTIONS(693),
    [anon_sym_i16] = ACTIONS(693),
    [anon_sym_u32] = ACTIONS(693),
    [anon_sym_i32] = ACTIONS(693),
    [anon_sym_u64] = ACTIONS(693),
    [anon_sym_i64] = ACTIONS(693),
    [anon_sym_u128] = ACTIONS(693),
    [anon_sym_i128] = ACTIONS(693),
    [anon_sym_isize] = ACTIONS(693),
    [anon_sym_usize] = ACTIONS(693),
    [anon_sym_f32] = ACTIONS(693),
    [anon_sym_f64] = ACTIONS(693),
    [anon_sym_bool] = ACTIONS(693),
    [anon_sym_str] = ACTIONS(693),
    [anon_sym_char] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(693),
    [anon_sym_as] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(693),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_break] = ACTIONS(693),
    [anon_sym_const] = ACTIONS(693),
    [anon_sym_continue] = ACTIONS(693),
    [anon_sym_default] = ACTIONS(693),
    [anon_sym_enum] = ACTIONS(693),
    [anon_sym_fn] = ACTIONS(693),
    [anon_sym_for] = ACTIONS(693),
    [anon_sym_if] = ACTIONS(693),
    [anon_sym_impl] = ACTIONS(693),
    [anon_sym_let] = ACTIONS(693),
    [anon_sym_loop] = ACTIONS(693),
    [anon_sym_match] = ACTIONS(693),
    [anon_sym_mod] = ACTIONS(693),
    [anon_sym_pub] = ACTIONS(693),
    [anon_sym_return] = ACTIONS(693),
    [anon_sym_static] = ACTIONS(693),
    [anon_sym_struct] = ACTIONS(693),
    [anon_sym_trait] = ACTIONS(693),
    [anon_sym_type] = ACTIONS(693),
    [anon_sym_union] = ACTIONS(693),
    [anon_sym_unsafe] = ACTIONS(693),
    [anon_sym_use] = ACTIONS(693),
    [anon_sym_where] = ACTIONS(693),
    [anon_sym_while] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(693),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(693),
    [sym_super] = ACTIONS(693),
    [sym_crate] = ACTIONS(693),
    [sym_metavariable] = ACTIONS(705),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [98] = {
    [sym_token_tree] = STATE(152),
    [sym_token_repetition] = STATE(152),
    [sym__literal] = STATE(152),
    [sym_string_literal] = STATE(140),
    [sym_raw_string_literal] = STATE(140),
    [sym_boolean_literal] = STATE(140),
    [sym_line_comment] = STATE(98),
    [sym_block_comment] = STATE(98),
    [aux_sym_token_tree_repeat1] = STATE(69),
    [aux_sym__non_special_token_repeat1] = STATE(135),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(695),
    [anon_sym_LBRACK] = ACTIONS(699),
    [anon_sym_RBRACK] = ACTIONS(709),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(703),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(693),
    [anon_sym_i8] = ACTIONS(693),
    [anon_sym_u16] = ACTIONS(693),
    [anon_sym_i16] = ACTIONS(693),
    [anon_sym_u32] = ACTIONS(693),
    [anon_sym_i32] = ACTIONS(693),
    [anon_sym_u64] = ACTIONS(693),
    [anon_sym_i64] = ACTIONS(693),
    [anon_sym_u128] = ACTIONS(693),
    [anon_sym_i128] = ACTIONS(693),
    [anon_sym_isize] = ACTIONS(693),
    [anon_sym_usize] = ACTIONS(693),
    [anon_sym_f32] = ACTIONS(693),
    [anon_sym_f64] = ACTIONS(693),
    [anon_sym_bool] = ACTIONS(693),
    [anon_sym_str] = ACTIONS(693),
    [anon_sym_char] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(693),
    [anon_sym_as] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(693),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_break] = ACTIONS(693),
    [anon_sym_const] = ACTIONS(693),
    [anon_sym_continue] = ACTIONS(693),
    [anon_sym_default] = ACTIONS(693),
    [anon_sym_enum] = ACTIONS(693),
    [anon_sym_fn] = ACTIONS(693),
    [anon_sym_for] = ACTIONS(693),
    [anon_sym_if] = ACTIONS(693),
    [anon_sym_impl] = ACTIONS(693),
    [anon_sym_let] = ACTIONS(693),
    [anon_sym_loop] = ACTIONS(693),
    [anon_sym_match] = ACTIONS(693),
    [anon_sym_mod] = ACTIONS(693),
    [anon_sym_pub] = ACTIONS(693),
    [anon_sym_return] = ACTIONS(693),
    [anon_sym_static] = ACTIONS(693),
    [anon_sym_struct] = ACTIONS(693),
    [anon_sym_trait] = ACTIONS(693),
    [anon_sym_type] = ACTIONS(693),
    [anon_sym_union] = ACTIONS(693),
    [anon_sym_unsafe] = ACTIONS(693),
    [anon_sym_use] = ACTIONS(693),
    [anon_sym_where] = ACTIONS(693),
    [anon_sym_while] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(693),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(693),
    [sym_super] = ACTIONS(693),
    [sym_crate] = ACTIONS(693),
    [sym_metavariable] = ACTIONS(705),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [99] = {
    [sym_delim_token_tree] = STATE(193),
    [sym__delim_tokens] = STATE(203),
    [sym__non_delim_token] = STATE(193),
    [sym__literal] = STATE(208),
    [sym_string_literal] = STATE(188),
    [sym_raw_string_literal] = STATE(188),
    [sym_boolean_literal] = STATE(188),
    [sym_line_comment] = STATE(99),
    [sym_block_comment] = STATE(99),
    [aux_sym__non_special_token_repeat1] = STATE(148),
    [aux_sym_delim_token_tree_repeat1] = STATE(73),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_RBRACE] = ACTIONS(711),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [100] = {
    [sym_delim_token_tree] = STATE(193),
    [sym__delim_tokens] = STATE(203),
    [sym__non_delim_token] = STATE(193),
    [sym__literal] = STATE(208),
    [sym_string_literal] = STATE(188),
    [sym_raw_string_literal] = STATE(188),
    [sym_boolean_literal] = STATE(188),
    [sym_line_comment] = STATE(100),
    [sym_block_comment] = STATE(100),
    [aux_sym__non_special_token_repeat1] = STATE(148),
    [aux_sym_delim_token_tree_repeat1] = STATE(73),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(667),
    [anon_sym_RBRACK] = ACTIONS(711),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [101] = {
    [sym_delim_token_tree] = STATE(193),
    [sym__delim_tokens] = STATE(203),
    [sym__non_delim_token] = STATE(193),
    [sym__literal] = STATE(208),
    [sym_string_literal] = STATE(188),
    [sym_raw_string_literal] = STATE(188),
    [sym_boolean_literal] = STATE(188),
    [sym_line_comment] = STATE(101),
    [sym_block_comment] = STATE(101),
    [aux_sym__non_special_token_repeat1] = STATE(148),
    [aux_sym_delim_token_tree_repeat1] = STATE(112),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_RBRACE] = ACTIONS(707),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [102] = {
    [sym_token_tree] = STATE(152),
    [sym_token_repetition] = STATE(152),
    [sym__literal] = STATE(152),
    [sym_string_literal] = STATE(140),
    [sym_raw_string_literal] = STATE(140),
    [sym_boolean_literal] = STATE(140),
    [sym_line_comment] = STATE(102),
    [sym_block_comment] = STATE(102),
    [aux_sym_token_tree_repeat1] = STATE(69),
    [aux_sym__non_special_token_repeat1] = STATE(135),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(695),
    [anon_sym_RPAREN] = ACTIONS(709),
    [anon_sym_LBRACK] = ACTIONS(699),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(703),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(693),
    [anon_sym_i8] = ACTIONS(693),
    [anon_sym_u16] = ACTIONS(693),
    [anon_sym_i16] = ACTIONS(693),
    [anon_sym_u32] = ACTIONS(693),
    [anon_sym_i32] = ACTIONS(693),
    [anon_sym_u64] = ACTIONS(693),
    [anon_sym_i64] = ACTIONS(693),
    [anon_sym_u128] = ACTIONS(693),
    [anon_sym_i128] = ACTIONS(693),
    [anon_sym_isize] = ACTIONS(693),
    [anon_sym_usize] = ACTIONS(693),
    [anon_sym_f32] = ACTIONS(693),
    [anon_sym_f64] = ACTIONS(693),
    [anon_sym_bool] = ACTIONS(693),
    [anon_sym_str] = ACTIONS(693),
    [anon_sym_char] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(693),
    [anon_sym_as] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(693),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_break] = ACTIONS(693),
    [anon_sym_const] = ACTIONS(693),
    [anon_sym_continue] = ACTIONS(693),
    [anon_sym_default] = ACTIONS(693),
    [anon_sym_enum] = ACTIONS(693),
    [anon_sym_fn] = ACTIONS(693),
    [anon_sym_for] = ACTIONS(693),
    [anon_sym_if] = ACTIONS(693),
    [anon_sym_impl] = ACTIONS(693),
    [anon_sym_let] = ACTIONS(693),
    [anon_sym_loop] = ACTIONS(693),
    [anon_sym_match] = ACTIONS(693),
    [anon_sym_mod] = ACTIONS(693),
    [anon_sym_pub] = ACTIONS(693),
    [anon_sym_return] = ACTIONS(693),
    [anon_sym_static] = ACTIONS(693),
    [anon_sym_struct] = ACTIONS(693),
    [anon_sym_trait] = ACTIONS(693),
    [anon_sym_type] = ACTIONS(693),
    [anon_sym_union] = ACTIONS(693),
    [anon_sym_unsafe] = ACTIONS(693),
    [anon_sym_use] = ACTIONS(693),
    [anon_sym_where] = ACTIONS(693),
    [anon_sym_while] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(693),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(693),
    [sym_super] = ACTIONS(693),
    [sym_crate] = ACTIONS(693),
    [sym_metavariable] = ACTIONS(705),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [103] = {
    [sym_token_tree] = STATE(152),
    [sym_token_repetition] = STATE(152),
    [sym__literal] = STATE(152),
    [sym_string_literal] = STATE(140),
    [sym_raw_string_literal] = STATE(140),
    [sym_boolean_literal] = STATE(140),
    [sym_line_comment] = STATE(103),
    [sym_block_comment] = STATE(103),
    [aux_sym_token_tree_repeat1] = STATE(114),
    [aux_sym__non_special_token_repeat1] = STATE(135),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(695),
    [anon_sym_RPAREN] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(699),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(703),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(693),
    [anon_sym_i8] = ACTIONS(693),
    [anon_sym_u16] = ACTIONS(693),
    [anon_sym_i16] = ACTIONS(693),
    [anon_sym_u32] = ACTIONS(693),
    [anon_sym_i32] = ACTIONS(693),
    [anon_sym_u64] = ACTIONS(693),
    [anon_sym_i64] = ACTIONS(693),
    [anon_sym_u128] = ACTIONS(693),
    [anon_sym_i128] = ACTIONS(693),
    [anon_sym_isize] = ACTIONS(693),
    [anon_sym_usize] = ACTIONS(693),
    [anon_sym_f32] = ACTIONS(693),
    [anon_sym_f64] = ACTIONS(693),
    [anon_sym_bool] = ACTIONS(693),
    [anon_sym_str] = ACTIONS(693),
    [anon_sym_char] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(693),
    [anon_sym_as] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(693),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_break] = ACTIONS(693),
    [anon_sym_const] = ACTIONS(693),
    [anon_sym_continue] = ACTIONS(693),
    [anon_sym_default] = ACTIONS(693),
    [anon_sym_enum] = ACTIONS(693),
    [anon_sym_fn] = ACTIONS(693),
    [anon_sym_for] = ACTIONS(693),
    [anon_sym_if] = ACTIONS(693),
    [anon_sym_impl] = ACTIONS(693),
    [anon_sym_let] = ACTIONS(693),
    [anon_sym_loop] = ACTIONS(693),
    [anon_sym_match] = ACTIONS(693),
    [anon_sym_mod] = ACTIONS(693),
    [anon_sym_pub] = ACTIONS(693),
    [anon_sym_return] = ACTIONS(693),
    [anon_sym_static] = ACTIONS(693),
    [anon_sym_struct] = ACTIONS(693),
    [anon_sym_trait] = ACTIONS(693),
    [anon_sym_type] = ACTIONS(693),
    [anon_sym_union] = ACTIONS(693),
    [anon_sym_unsafe] = ACTIONS(693),
    [anon_sym_use] = ACTIONS(693),
    [anon_sym_where] = ACTIONS(693),
    [anon_sym_while] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(693),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(693),
    [sym_super] = ACTIONS(693),
    [sym_crate] = ACTIONS(693),
    [sym_metavariable] = ACTIONS(705),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [104] = {
    [sym_delim_token_tree] = STATE(193),
    [sym__delim_tokens] = STATE(203),
    [sym__non_delim_token] = STATE(193),
    [sym__literal] = STATE(208),
    [sym_string_literal] = STATE(188),
    [sym_raw_string_literal] = STATE(188),
    [sym_boolean_literal] = STATE(188),
    [sym_line_comment] = STATE(104),
    [sym_block_comment] = STATE(104),
    [aux_sym__non_special_token_repeat1] = STATE(148),
    [aux_sym_delim_token_tree_repeat1] = STATE(117),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_RBRACE] = ACTIONS(715),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [105] = {
    [sym_delim_token_tree] = STATE(193),
    [sym__delim_tokens] = STATE(203),
    [sym__non_delim_token] = STATE(193),
    [sym__literal] = STATE(208),
    [sym_string_literal] = STATE(188),
    [sym_raw_string_literal] = STATE(188),
    [sym_boolean_literal] = STATE(188),
    [sym_line_comment] = STATE(105),
    [sym_block_comment] = STATE(105),
    [aux_sym__non_special_token_repeat1] = STATE(148),
    [aux_sym_delim_token_tree_repeat1] = STATE(73),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [106] = {
    [sym_delim_token_tree] = STATE(193),
    [sym__delim_tokens] = STATE(203),
    [sym__non_delim_token] = STATE(193),
    [sym__literal] = STATE(208),
    [sym_string_literal] = STATE(188),
    [sym_raw_string_literal] = STATE(188),
    [sym_boolean_literal] = STATE(188),
    [sym_line_comment] = STATE(106),
    [sym_block_comment] = STATE(106),
    [aux_sym__non_special_token_repeat1] = STATE(148),
    [aux_sym_delim_token_tree_repeat1] = STATE(73),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(667),
    [anon_sym_RBRACK] = ACTIONS(717),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [107] = {
    [sym_delim_token_tree] = STATE(193),
    [sym__delim_tokens] = STATE(203),
    [sym__non_delim_token] = STATE(193),
    [sym__literal] = STATE(208),
    [sym_string_literal] = STATE(188),
    [sym_raw_string_literal] = STATE(188),
    [sym_boolean_literal] = STATE(188),
    [sym_line_comment] = STATE(107),
    [sym_block_comment] = STATE(107),
    [aux_sym__non_special_token_repeat1] = STATE(148),
    [aux_sym_delim_token_tree_repeat1] = STATE(88),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(667),
    [anon_sym_RBRACK] = ACTIONS(715),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [108] = {
    [sym_delim_token_tree] = STATE(193),
    [sym__delim_tokens] = STATE(203),
    [sym__non_delim_token] = STATE(193),
    [sym__literal] = STATE(208),
    [sym_string_literal] = STATE(188),
    [sym_raw_string_literal] = STATE(188),
    [sym_boolean_literal] = STATE(188),
    [sym_line_comment] = STATE(108),
    [sym_block_comment] = STATE(108),
    [aux_sym__non_special_token_repeat1] = STATE(148),
    [aux_sym_delim_token_tree_repeat1] = STATE(73),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(685),
    [anon_sym_LBRACK] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [109] = {
    [sym_delim_token_tree] = STATE(193),
    [sym__delim_tokens] = STATE(203),
    [sym__non_delim_token] = STATE(193),
    [sym__literal] = STATE(208),
    [sym_string_literal] = STATE(188),
    [sym_raw_string_literal] = STATE(188),
    [sym_boolean_literal] = STATE(188),
    [sym_line_comment] = STATE(109),
    [sym_block_comment] = STATE(109),
    [aux_sym__non_special_token_repeat1] = STATE(148),
    [aux_sym_delim_token_tree_repeat1] = STATE(113),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_RBRACE] = ACTIONS(687),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [110] = {
    [sym_delim_token_tree] = STATE(193),
    [sym__delim_tokens] = STATE(203),
    [sym__non_delim_token] = STATE(193),
    [sym__literal] = STATE(208),
    [sym_string_literal] = STATE(188),
    [sym_raw_string_literal] = STATE(188),
    [sym_boolean_literal] = STATE(188),
    [sym_line_comment] = STATE(110),
    [sym_block_comment] = STATE(110),
    [aux_sym__non_special_token_repeat1] = STATE(148),
    [aux_sym_delim_token_tree_repeat1] = STATE(92),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(715),
    [anon_sym_LBRACK] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [111] = {
    [sym_delim_token_tree] = STATE(193),
    [sym__delim_tokens] = STATE(203),
    [sym__non_delim_token] = STATE(193),
    [sym__literal] = STATE(208),
    [sym_string_literal] = STATE(188),
    [sym_raw_string_literal] = STATE(188),
    [sym_boolean_literal] = STATE(188),
    [sym_line_comment] = STATE(111),
    [sym_block_comment] = STATE(111),
    [aux_sym__non_special_token_repeat1] = STATE(148),
    [aux_sym_delim_token_tree_repeat1] = STATE(106),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(667),
    [anon_sym_RBRACK] = ACTIONS(687),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [112] = {
    [sym_delim_token_tree] = STATE(193),
    [sym__delim_tokens] = STATE(203),
    [sym__non_delim_token] = STATE(193),
    [sym__literal] = STATE(208),
    [sym_string_literal] = STATE(188),
    [sym_raw_string_literal] = STATE(188),
    [sym_boolean_literal] = STATE(188),
    [sym_line_comment] = STATE(112),
    [sym_block_comment] = STATE(112),
    [aux_sym__non_special_token_repeat1] = STATE(148),
    [aux_sym_delim_token_tree_repeat1] = STATE(73),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_RBRACE] = ACTIONS(685),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [113] = {
    [sym_delim_token_tree] = STATE(193),
    [sym__delim_tokens] = STATE(203),
    [sym__non_delim_token] = STATE(193),
    [sym__literal] = STATE(208),
    [sym_string_literal] = STATE(188),
    [sym_raw_string_literal] = STATE(188),
    [sym_boolean_literal] = STATE(188),
    [sym_line_comment] = STATE(113),
    [sym_block_comment] = STATE(113),
    [aux_sym__non_special_token_repeat1] = STATE(148),
    [aux_sym_delim_token_tree_repeat1] = STATE(73),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_RBRACE] = ACTIONS(717),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [114] = {
    [sym_token_tree] = STATE(152),
    [sym_token_repetition] = STATE(152),
    [sym__literal] = STATE(152),
    [sym_string_literal] = STATE(140),
    [sym_raw_string_literal] = STATE(140),
    [sym_boolean_literal] = STATE(140),
    [sym_line_comment] = STATE(114),
    [sym_block_comment] = STATE(114),
    [aux_sym_token_tree_repeat1] = STATE(69),
    [aux_sym__non_special_token_repeat1] = STATE(135),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(695),
    [anon_sym_RPAREN] = ACTIONS(719),
    [anon_sym_LBRACK] = ACTIONS(699),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(703),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(693),
    [anon_sym_i8] = ACTIONS(693),
    [anon_sym_u16] = ACTIONS(693),
    [anon_sym_i16] = ACTIONS(693),
    [anon_sym_u32] = ACTIONS(693),
    [anon_sym_i32] = ACTIONS(693),
    [anon_sym_u64] = ACTIONS(693),
    [anon_sym_i64] = ACTIONS(693),
    [anon_sym_u128] = ACTIONS(693),
    [anon_sym_i128] = ACTIONS(693),
    [anon_sym_isize] = ACTIONS(693),
    [anon_sym_usize] = ACTIONS(693),
    [anon_sym_f32] = ACTIONS(693),
    [anon_sym_f64] = ACTIONS(693),
    [anon_sym_bool] = ACTIONS(693),
    [anon_sym_str] = ACTIONS(693),
    [anon_sym_char] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(693),
    [anon_sym_as] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(693),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_break] = ACTIONS(693),
    [anon_sym_const] = ACTIONS(693),
    [anon_sym_continue] = ACTIONS(693),
    [anon_sym_default] = ACTIONS(693),
    [anon_sym_enum] = ACTIONS(693),
    [anon_sym_fn] = ACTIONS(693),
    [anon_sym_for] = ACTIONS(693),
    [anon_sym_if] = ACTIONS(693),
    [anon_sym_impl] = ACTIONS(693),
    [anon_sym_let] = ACTIONS(693),
    [anon_sym_loop] = ACTIONS(693),
    [anon_sym_match] = ACTIONS(693),
    [anon_sym_mod] = ACTIONS(693),
    [anon_sym_pub] = ACTIONS(693),
    [anon_sym_return] = ACTIONS(693),
    [anon_sym_static] = ACTIONS(693),
    [anon_sym_struct] = ACTIONS(693),
    [anon_sym_trait] = ACTIONS(693),
    [anon_sym_type] = ACTIONS(693),
    [anon_sym_union] = ACTIONS(693),
    [anon_sym_unsafe] = ACTIONS(693),
    [anon_sym_use] = ACTIONS(693),
    [anon_sym_where] = ACTIONS(693),
    [anon_sym_while] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(693),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(693),
    [sym_super] = ACTIONS(693),
    [sym_crate] = ACTIONS(693),
    [sym_metavariable] = ACTIONS(705),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [115] = {
    [sym_delim_token_tree] = STATE(193),
    [sym__delim_tokens] = STATE(203),
    [sym__non_delim_token] = STATE(193),
    [sym__literal] = STATE(208),
    [sym_string_literal] = STATE(188),
    [sym_raw_string_literal] = STATE(188),
    [sym_boolean_literal] = STATE(188),
    [sym_line_comment] = STATE(115),
    [sym_block_comment] = STATE(115),
    [aux_sym__non_special_token_repeat1] = STATE(148),
    [aux_sym_delim_token_tree_repeat1] = STATE(73),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [116] = {
    [sym_delim_token_tree] = STATE(193),
    [sym__delim_tokens] = STATE(203),
    [sym__non_delim_token] = STATE(193),
    [sym__literal] = STATE(208),
    [sym_string_literal] = STATE(188),
    [sym_raw_string_literal] = STATE(188),
    [sym_boolean_literal] = STATE(188),
    [sym_line_comment] = STATE(116),
    [sym_block_comment] = STATE(116),
    [aux_sym__non_special_token_repeat1] = STATE(148),
    [aux_sym_delim_token_tree_repeat1] = STATE(73),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(689),
    [anon_sym_LBRACK] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [117] = {
    [sym_delim_token_tree] = STATE(193),
    [sym__delim_tokens] = STATE(203),
    [sym__non_delim_token] = STATE(193),
    [sym__literal] = STATE(208),
    [sym_string_literal] = STATE(188),
    [sym_raw_string_literal] = STATE(188),
    [sym_boolean_literal] = STATE(188),
    [sym_line_comment] = STATE(117),
    [sym_block_comment] = STATE(117),
    [aux_sym__non_special_token_repeat1] = STATE(148),
    [aux_sym_delim_token_tree_repeat1] = STATE(73),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_RBRACE] = ACTIONS(691),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [118] = {
    [sym_delim_token_tree] = STATE(193),
    [sym__delim_tokens] = STATE(203),
    [sym__non_delim_token] = STATE(193),
    [sym__literal] = STATE(208),
    [sym_string_literal] = STATE(188),
    [sym_raw_string_literal] = STATE(188),
    [sym_boolean_literal] = STATE(188),
    [sym_line_comment] = STATE(118),
    [sym_block_comment] = STATE(118),
    [aux_sym__non_special_token_repeat1] = STATE(148),
    [aux_sym_delim_token_tree_repeat1] = STATE(73),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(667),
    [anon_sym_RBRACK] = ACTIONS(721),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [119] = {
    [sym_delim_token_tree] = STATE(193),
    [sym__delim_tokens] = STATE(203),
    [sym__non_delim_token] = STATE(193),
    [sym__literal] = STATE(208),
    [sym_string_literal] = STATE(188),
    [sym_raw_string_literal] = STATE(188),
    [sym_boolean_literal] = STATE(188),
    [sym_line_comment] = STATE(119),
    [sym_block_comment] = STATE(119),
    [aux_sym__non_special_token_repeat1] = STATE(148),
    [aux_sym_delim_token_tree_repeat1] = STATE(73),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_RBRACE] = ACTIONS(721),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [120] = {
    [sym_delim_token_tree] = STATE(193),
    [sym__delim_tokens] = STATE(203),
    [sym__non_delim_token] = STATE(193),
    [sym__literal] = STATE(208),
    [sym_string_literal] = STATE(188),
    [sym_raw_string_literal] = STATE(188),
    [sym_boolean_literal] = STATE(188),
    [sym_line_comment] = STATE(120),
    [sym_block_comment] = STATE(120),
    [aux_sym__non_special_token_repeat1] = STATE(148),
    [aux_sym_delim_token_tree_repeat1] = STATE(89),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_RBRACE] = ACTIONS(669),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [121] = {
    [sym_delim_token_tree] = STATE(193),
    [sym__delim_tokens] = STATE(203),
    [sym__non_delim_token] = STATE(193),
    [sym__literal] = STATE(208),
    [sym_string_literal] = STATE(188),
    [sym_raw_string_literal] = STATE(188),
    [sym_boolean_literal] = STATE(188),
    [sym_line_comment] = STATE(121),
    [sym_block_comment] = STATE(121),
    [aux_sym__non_special_token_repeat1] = STATE(148),
    [aux_sym_delim_token_tree_repeat1] = STATE(115),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [122] = {
    [sym_delim_token_tree] = STATE(193),
    [sym__delim_tokens] = STATE(203),
    [sym__non_delim_token] = STATE(193),
    [sym__literal] = STATE(208),
    [sym_string_literal] = STATE(188),
    [sym_raw_string_literal] = STATE(188),
    [sym_boolean_literal] = STATE(188),
    [sym_line_comment] = STATE(122),
    [sym_block_comment] = STATE(122),
    [aux_sym__non_special_token_repeat1] = STATE(148),
    [aux_sym_delim_token_tree_repeat1] = STATE(118),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(667),
    [anon_sym_RBRACK] = ACTIONS(723),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [123] = {
    [sym_delim_token_tree] = STATE(193),
    [sym__delim_tokens] = STATE(203),
    [sym__non_delim_token] = STATE(193),
    [sym__literal] = STATE(208),
    [sym_string_literal] = STATE(188),
    [sym_raw_string_literal] = STATE(188),
    [sym_boolean_literal] = STATE(188),
    [sym_line_comment] = STATE(123),
    [sym_block_comment] = STATE(123),
    [aux_sym__non_special_token_repeat1] = STATE(148),
    [aux_sym_delim_token_tree_repeat1] = STATE(119),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_RBRACE] = ACTIONS(723),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [124] = {
    [sym_token_tree] = STATE(152),
    [sym_token_repetition] = STATE(152),
    [sym__literal] = STATE(152),
    [sym_string_literal] = STATE(140),
    [sym_raw_string_literal] = STATE(140),
    [sym_boolean_literal] = STATE(140),
    [sym_line_comment] = STATE(124),
    [sym_block_comment] = STATE(124),
    [aux_sym_token_tree_repeat1] = STATE(133),
    [aux_sym__non_special_token_repeat1] = STATE(135),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(695),
    [anon_sym_RPAREN] = ACTIONS(725),
    [anon_sym_LBRACK] = ACTIONS(699),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(703),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(693),
    [anon_sym_i8] = ACTIONS(693),
    [anon_sym_u16] = ACTIONS(693),
    [anon_sym_i16] = ACTIONS(693),
    [anon_sym_u32] = ACTIONS(693),
    [anon_sym_i32] = ACTIONS(693),
    [anon_sym_u64] = ACTIONS(693),
    [anon_sym_i64] = ACTIONS(693),
    [anon_sym_u128] = ACTIONS(693),
    [anon_sym_i128] = ACTIONS(693),
    [anon_sym_isize] = ACTIONS(693),
    [anon_sym_usize] = ACTIONS(693),
    [anon_sym_f32] = ACTIONS(693),
    [anon_sym_f64] = ACTIONS(693),
    [anon_sym_bool] = ACTIONS(693),
    [anon_sym_str] = ACTIONS(693),
    [anon_sym_char] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(693),
    [anon_sym_as] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(693),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_break] = ACTIONS(693),
    [anon_sym_const] = ACTIONS(693),
    [anon_sym_continue] = ACTIONS(693),
    [anon_sym_default] = ACTIONS(693),
    [anon_sym_enum] = ACTIONS(693),
    [anon_sym_fn] = ACTIONS(693),
    [anon_sym_for] = ACTIONS(693),
    [anon_sym_if] = ACTIONS(693),
    [anon_sym_impl] = ACTIONS(693),
    [anon_sym_let] = ACTIONS(693),
    [anon_sym_loop] = ACTIONS(693),
    [anon_sym_match] = ACTIONS(693),
    [anon_sym_mod] = ACTIONS(693),
    [anon_sym_pub] = ACTIONS(693),
    [anon_sym_return] = ACTIONS(693),
    [anon_sym_static] = ACTIONS(693),
    [anon_sym_struct] = ACTIONS(693),
    [anon_sym_trait] = ACTIONS(693),
    [anon_sym_type] = ACTIONS(693),
    [anon_sym_union] = ACTIONS(693),
    [anon_sym_unsafe] = ACTIONS(693),
    [anon_sym_use] = ACTIONS(693),
    [anon_sym_where] = ACTIONS(693),
    [anon_sym_while] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(693),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(693),
    [sym_super] = ACTIONS(693),
    [sym_crate] = ACTIONS(693),
    [sym_metavariable] = ACTIONS(705),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [125] = {
    [sym_token_tree] = STATE(152),
    [sym_token_repetition] = STATE(152),
    [sym__literal] = STATE(152),
    [sym_string_literal] = STATE(140),
    [sym_raw_string_literal] = STATE(140),
    [sym_boolean_literal] = STATE(140),
    [sym_line_comment] = STATE(125),
    [sym_block_comment] = STATE(125),
    [aux_sym_token_tree_repeat1] = STATE(128),
    [aux_sym__non_special_token_repeat1] = STATE(135),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(695),
    [anon_sym_LBRACK] = ACTIONS(699),
    [anon_sym_RBRACK] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(703),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(693),
    [anon_sym_i8] = ACTIONS(693),
    [anon_sym_u16] = ACTIONS(693),
    [anon_sym_i16] = ACTIONS(693),
    [anon_sym_u32] = ACTIONS(693),
    [anon_sym_i32] = ACTIONS(693),
    [anon_sym_u64] = ACTIONS(693),
    [anon_sym_i64] = ACTIONS(693),
    [anon_sym_u128] = ACTIONS(693),
    [anon_sym_i128] = ACTIONS(693),
    [anon_sym_isize] = ACTIONS(693),
    [anon_sym_usize] = ACTIONS(693),
    [anon_sym_f32] = ACTIONS(693),
    [anon_sym_f64] = ACTIONS(693),
    [anon_sym_bool] = ACTIONS(693),
    [anon_sym_str] = ACTIONS(693),
    [anon_sym_char] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(693),
    [anon_sym_as] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(693),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_break] = ACTIONS(693),
    [anon_sym_const] = ACTIONS(693),
    [anon_sym_continue] = ACTIONS(693),
    [anon_sym_default] = ACTIONS(693),
    [anon_sym_enum] = ACTIONS(693),
    [anon_sym_fn] = ACTIONS(693),
    [anon_sym_for] = ACTIONS(693),
    [anon_sym_if] = ACTIONS(693),
    [anon_sym_impl] = ACTIONS(693),
    [anon_sym_let] = ACTIONS(693),
    [anon_sym_loop] = ACTIONS(693),
    [anon_sym_match] = ACTIONS(693),
    [anon_sym_mod] = ACTIONS(693),
    [anon_sym_pub] = ACTIONS(693),
    [anon_sym_return] = ACTIONS(693),
    [anon_sym_static] = ACTIONS(693),
    [anon_sym_struct] = ACTIONS(693),
    [anon_sym_trait] = ACTIONS(693),
    [anon_sym_type] = ACTIONS(693),
    [anon_sym_union] = ACTIONS(693),
    [anon_sym_unsafe] = ACTIONS(693),
    [anon_sym_use] = ACTIONS(693),
    [anon_sym_where] = ACTIONS(693),
    [anon_sym_while] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(693),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(693),
    [sym_super] = ACTIONS(693),
    [sym_crate] = ACTIONS(693),
    [sym_metavariable] = ACTIONS(705),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [126] = {
    [sym_token_tree] = STATE(152),
    [sym_token_repetition] = STATE(152),
    [sym__literal] = STATE(152),
    [sym_string_literal] = STATE(140),
    [sym_raw_string_literal] = STATE(140),
    [sym_boolean_literal] = STATE(140),
    [sym_line_comment] = STATE(126),
    [sym_block_comment] = STATE(126),
    [aux_sym_token_tree_repeat1] = STATE(127),
    [aux_sym__non_special_token_repeat1] = STATE(135),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(695),
    [anon_sym_LBRACK] = ACTIONS(699),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_RBRACE] = ACTIONS(725),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(703),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(693),
    [anon_sym_i8] = ACTIONS(693),
    [anon_sym_u16] = ACTIONS(693),
    [anon_sym_i16] = ACTIONS(693),
    [anon_sym_u32] = ACTIONS(693),
    [anon_sym_i32] = ACTIONS(693),
    [anon_sym_u64] = ACTIONS(693),
    [anon_sym_i64] = ACTIONS(693),
    [anon_sym_u128] = ACTIONS(693),
    [anon_sym_i128] = ACTIONS(693),
    [anon_sym_isize] = ACTIONS(693),
    [anon_sym_usize] = ACTIONS(693),
    [anon_sym_f32] = ACTIONS(693),
    [anon_sym_f64] = ACTIONS(693),
    [anon_sym_bool] = ACTIONS(693),
    [anon_sym_str] = ACTIONS(693),
    [anon_sym_char] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(693),
    [anon_sym_as] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(693),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_break] = ACTIONS(693),
    [anon_sym_const] = ACTIONS(693),
    [anon_sym_continue] = ACTIONS(693),
    [anon_sym_default] = ACTIONS(693),
    [anon_sym_enum] = ACTIONS(693),
    [anon_sym_fn] = ACTIONS(693),
    [anon_sym_for] = ACTIONS(693),
    [anon_sym_if] = ACTIONS(693),
    [anon_sym_impl] = ACTIONS(693),
    [anon_sym_let] = ACTIONS(693),
    [anon_sym_loop] = ACTIONS(693),
    [anon_sym_match] = ACTIONS(693),
    [anon_sym_mod] = ACTIONS(693),
    [anon_sym_pub] = ACTIONS(693),
    [anon_sym_return] = ACTIONS(693),
    [anon_sym_static] = ACTIONS(693),
    [anon_sym_struct] = ACTIONS(693),
    [anon_sym_trait] = ACTIONS(693),
    [anon_sym_type] = ACTIONS(693),
    [anon_sym_union] = ACTIONS(693),
    [anon_sym_unsafe] = ACTIONS(693),
    [anon_sym_use] = ACTIONS(693),
    [anon_sym_where] = ACTIONS(693),
    [anon_sym_while] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(693),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(693),
    [sym_super] = ACTIONS(693),
    [sym_crate] = ACTIONS(693),
    [sym_metavariable] = ACTIONS(705),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [127] = {
    [sym_token_tree] = STATE(152),
    [sym_token_repetition] = STATE(152),
    [sym__literal] = STATE(152),
    [sym_string_literal] = STATE(140),
    [sym_raw_string_literal] = STATE(140),
    [sym_boolean_literal] = STATE(140),
    [sym_line_comment] = STATE(127),
    [sym_block_comment] = STATE(127),
    [aux_sym_token_tree_repeat1] = STATE(69),
    [aux_sym__non_special_token_repeat1] = STATE(135),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(695),
    [anon_sym_LBRACK] = ACTIONS(699),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_RBRACE] = ACTIONS(727),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(703),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(693),
    [anon_sym_i8] = ACTIONS(693),
    [anon_sym_u16] = ACTIONS(693),
    [anon_sym_i16] = ACTIONS(693),
    [anon_sym_u32] = ACTIONS(693),
    [anon_sym_i32] = ACTIONS(693),
    [anon_sym_u64] = ACTIONS(693),
    [anon_sym_i64] = ACTIONS(693),
    [anon_sym_u128] = ACTIONS(693),
    [anon_sym_i128] = ACTIONS(693),
    [anon_sym_isize] = ACTIONS(693),
    [anon_sym_usize] = ACTIONS(693),
    [anon_sym_f32] = ACTIONS(693),
    [anon_sym_f64] = ACTIONS(693),
    [anon_sym_bool] = ACTIONS(693),
    [anon_sym_str] = ACTIONS(693),
    [anon_sym_char] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(693),
    [anon_sym_as] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(693),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_break] = ACTIONS(693),
    [anon_sym_const] = ACTIONS(693),
    [anon_sym_continue] = ACTIONS(693),
    [anon_sym_default] = ACTIONS(693),
    [anon_sym_enum] = ACTIONS(693),
    [anon_sym_fn] = ACTIONS(693),
    [anon_sym_for] = ACTIONS(693),
    [anon_sym_if] = ACTIONS(693),
    [anon_sym_impl] = ACTIONS(693),
    [anon_sym_let] = ACTIONS(693),
    [anon_sym_loop] = ACTIONS(693),
    [anon_sym_match] = ACTIONS(693),
    [anon_sym_mod] = ACTIONS(693),
    [anon_sym_pub] = ACTIONS(693),
    [anon_sym_return] = ACTIONS(693),
    [anon_sym_static] = ACTIONS(693),
    [anon_sym_struct] = ACTIONS(693),
    [anon_sym_trait] = ACTIONS(693),
    [anon_sym_type] = ACTIONS(693),
    [anon_sym_union] = ACTIONS(693),
    [anon_sym_unsafe] = ACTIONS(693),
    [anon_sym_use] = ACTIONS(693),
    [anon_sym_where] = ACTIONS(693),
    [anon_sym_while] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(693),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(693),
    [sym_super] = ACTIONS(693),
    [sym_crate] = ACTIONS(693),
    [sym_metavariable] = ACTIONS(705),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [128] = {
    [sym_token_tree] = STATE(152),
    [sym_token_repetition] = STATE(152),
    [sym__literal] = STATE(152),
    [sym_string_literal] = STATE(140),
    [sym_raw_string_literal] = STATE(140),
    [sym_boolean_literal] = STATE(140),
    [sym_line_comment] = STATE(128),
    [sym_block_comment] = STATE(128),
    [aux_sym_token_tree_repeat1] = STATE(69),
    [aux_sym__non_special_token_repeat1] = STATE(135),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(695),
    [anon_sym_LBRACK] = ACTIONS(699),
    [anon_sym_RBRACK] = ACTIONS(727),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(703),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(693),
    [anon_sym_i8] = ACTIONS(693),
    [anon_sym_u16] = ACTIONS(693),
    [anon_sym_i16] = ACTIONS(693),
    [anon_sym_u32] = ACTIONS(693),
    [anon_sym_i32] = ACTIONS(693),
    [anon_sym_u64] = ACTIONS(693),
    [anon_sym_i64] = ACTIONS(693),
    [anon_sym_u128] = ACTIONS(693),
    [anon_sym_i128] = ACTIONS(693),
    [anon_sym_isize] = ACTIONS(693),
    [anon_sym_usize] = ACTIONS(693),
    [anon_sym_f32] = ACTIONS(693),
    [anon_sym_f64] = ACTIONS(693),
    [anon_sym_bool] = ACTIONS(693),
    [anon_sym_str] = ACTIONS(693),
    [anon_sym_char] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(693),
    [anon_sym_as] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(693),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_break] = ACTIONS(693),
    [anon_sym_const] = ACTIONS(693),
    [anon_sym_continue] = ACTIONS(693),
    [anon_sym_default] = ACTIONS(693),
    [anon_sym_enum] = ACTIONS(693),
    [anon_sym_fn] = ACTIONS(693),
    [anon_sym_for] = ACTIONS(693),
    [anon_sym_if] = ACTIONS(693),
    [anon_sym_impl] = ACTIONS(693),
    [anon_sym_let] = ACTIONS(693),
    [anon_sym_loop] = ACTIONS(693),
    [anon_sym_match] = ACTIONS(693),
    [anon_sym_mod] = ACTIONS(693),
    [anon_sym_pub] = ACTIONS(693),
    [anon_sym_return] = ACTIONS(693),
    [anon_sym_static] = ACTIONS(693),
    [anon_sym_struct] = ACTIONS(693),
    [anon_sym_trait] = ACTIONS(693),
    [anon_sym_type] = ACTIONS(693),
    [anon_sym_union] = ACTIONS(693),
    [anon_sym_unsafe] = ACTIONS(693),
    [anon_sym_use] = ACTIONS(693),
    [anon_sym_where] = ACTIONS(693),
    [anon_sym_while] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(693),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(693),
    [sym_super] = ACTIONS(693),
    [sym_crate] = ACTIONS(693),
    [sym_metavariable] = ACTIONS(705),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [129] = {
    [sym_delim_token_tree] = STATE(193),
    [sym__delim_tokens] = STATE(203),
    [sym__non_delim_token] = STATE(193),
    [sym__literal] = STATE(208),
    [sym_string_literal] = STATE(188),
    [sym_raw_string_literal] = STATE(188),
    [sym_boolean_literal] = STATE(188),
    [sym_line_comment] = STATE(129),
    [sym_block_comment] = STATE(129),
    [aux_sym__non_special_token_repeat1] = STATE(148),
    [aux_sym_delim_token_tree_repeat1] = STATE(73),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(711),
    [anon_sym_LBRACK] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [130] = {
    [sym_delim_token_tree] = STATE(193),
    [sym__delim_tokens] = STATE(203),
    [sym__non_delim_token] = STATE(193),
    [sym__literal] = STATE(208),
    [sym_string_literal] = STATE(188),
    [sym_raw_string_literal] = STATE(188),
    [sym_boolean_literal] = STATE(188),
    [sym_line_comment] = STATE(130),
    [sym_block_comment] = STATE(130),
    [aux_sym__non_special_token_repeat1] = STATE(148),
    [aux_sym_delim_token_tree_repeat1] = STATE(129),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(729),
    [anon_sym_LBRACK] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [131] = {
    [sym_delim_token_tree] = STATE(193),
    [sym__delim_tokens] = STATE(203),
    [sym__non_delim_token] = STATE(193),
    [sym__literal] = STATE(208),
    [sym_string_literal] = STATE(188),
    [sym_raw_string_literal] = STATE(188),
    [sym_boolean_literal] = STATE(188),
    [sym_line_comment] = STATE(131),
    [sym_block_comment] = STATE(131),
    [aux_sym__non_special_token_repeat1] = STATE(148),
    [aux_sym_delim_token_tree_repeat1] = STATE(100),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(667),
    [anon_sym_RBRACK] = ACTIONS(729),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [132] = {
    [sym_delim_token_tree] = STATE(193),
    [sym__delim_tokens] = STATE(203),
    [sym__non_delim_token] = STATE(193),
    [sym__literal] = STATE(208),
    [sym_string_literal] = STATE(188),
    [sym_raw_string_literal] = STATE(188),
    [sym_boolean_literal] = STATE(188),
    [sym_line_comment] = STATE(132),
    [sym_block_comment] = STATE(132),
    [aux_sym__non_special_token_repeat1] = STATE(148),
    [aux_sym_delim_token_tree_repeat1] = STATE(99),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_RBRACE] = ACTIONS(729),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(661),
    [anon_sym_i8] = ACTIONS(661),
    [anon_sym_u16] = ACTIONS(661),
    [anon_sym_i16] = ACTIONS(661),
    [anon_sym_u32] = ACTIONS(661),
    [anon_sym_i32] = ACTIONS(661),
    [anon_sym_u64] = ACTIONS(661),
    [anon_sym_i64] = ACTIONS(661),
    [anon_sym_u128] = ACTIONS(661),
    [anon_sym_i128] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_str] = ACTIONS(661),
    [anon_sym_char] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_as] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_default] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_impl] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(661),
    [anon_sym_loop] = ACTIONS(661),
    [anon_sym_match] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_static] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_trait] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_unsafe] = ACTIONS(661),
    [anon_sym_use] = ACTIONS(661),
    [anon_sym_where] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [sym_mutable_specifier] = ACTIONS(661),
    [sym_integer_literal] = ACTIONS(677),
    [aux_sym_string_literal_token1] = ACTIONS(679),
    [sym_char_literal] = ACTIONS(677),
    [anon_sym_true] = ACTIONS(681),
    [anon_sym_false] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(661),
    [sym_super] = ACTIONS(661),
    [sym_crate] = ACTIONS(661),
    [sym__raw_string_literal_start] = ACTIONS(683),
    [sym_float_literal] = ACTIONS(677),
  },
  [133] = {
    [sym_token_tree] = STATE(152),
    [sym_token_repetition] = STATE(152),
    [sym__literal] = STATE(152),
    [sym_string_literal] = STATE(140),
    [sym_raw_string_literal] = STATE(140),
    [sym_boolean_literal] = STATE(140),
    [sym_line_comment] = STATE(133),
    [sym_block_comment] = STATE(133),
    [aux_sym_token_tree_repeat1] = STATE(69),
    [aux_sym__non_special_token_repeat1] = STATE(135),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(695),
    [anon_sym_RPAREN] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(699),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(703),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(693),
    [anon_sym_i8] = ACTIONS(693),
    [anon_sym_u16] = ACTIONS(693),
    [anon_sym_i16] = ACTIONS(693),
    [anon_sym_u32] = ACTIONS(693),
    [anon_sym_i32] = ACTIONS(693),
    [anon_sym_u64] = ACTIONS(693),
    [anon_sym_i64] = ACTIONS(693),
    [anon_sym_u128] = ACTIONS(693),
    [anon_sym_i128] = ACTIONS(693),
    [anon_sym_isize] = ACTIONS(693),
    [anon_sym_usize] = ACTIONS(693),
    [anon_sym_f32] = ACTIONS(693),
    [anon_sym_f64] = ACTIONS(693),
    [anon_sym_bool] = ACTIONS(693),
    [anon_sym_str] = ACTIONS(693),
    [anon_sym_char] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(693),
    [anon_sym_as] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(693),
    [anon_sym_await] = ACTIONS(693),
    [anon_sym_break] = ACTIONS(693),
    [anon_sym_const] = ACTIONS(693),
    [anon_sym_continue] = ACTIONS(693),
    [anon_sym_default] = ACTIONS(693),
    [anon_sym_enum] = ACTIONS(693),
    [anon_sym_fn] = ACTIONS(693),
    [anon_sym_for] = ACTIONS(693),
    [anon_sym_if] = ACTIONS(693),
    [anon_sym_impl] = ACTIONS(693),
    [anon_sym_let] = ACTIONS(693),
    [anon_sym_loop] = ACTIONS(693),
    [anon_sym_match] = ACTIONS(693),
    [anon_sym_mod] = ACTIONS(693),
    [anon_sym_pub] = ACTIONS(693),
    [anon_sym_return] = ACTIONS(693),
    [anon_sym_static] = ACTIONS(693),
    [anon_sym_struct] = ACTIONS(693),
    [anon_sym_trait] = ACTIONS(693),
    [anon_sym_type] = ACTIONS(693),
    [anon_sym_union] = ACTIONS(693),
    [anon_sym_unsafe] = ACTIONS(693),
    [anon_sym_use] = ACTIONS(693),
    [anon_sym_where] = ACTIONS(693),
    [anon_sym_while] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(693),
    [sym_integer_literal] = ACTIONS(568),
    [aux_sym_string_literal_token1] = ACTIONS(570),
    [sym_char_literal] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(693),
    [sym_super] = ACTIONS(693),
    [sym_crate] = ACTIONS(693),
    [sym_metavariable] = ACTIONS(705),
    [sym__raw_string_literal_start] = ACTIONS(576),
    [sym_float_literal] = ACTIONS(568),
  },
  [134] = {
    [sym_line_comment] = STATE(134),
    [sym_block_comment] = STATE(134),
    [aux_sym__non_special_token_repeat1] = STATE(134),
    [sym_identifier] = ACTIONS(731),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(736),
    [anon_sym_RPAREN] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(736),
    [anon_sym_RBRACK] = ACTIONS(736),
    [anon_sym_LBRACE] = ACTIONS(736),
    [anon_sym_RBRACE] = ACTIONS(736),
    [anon_sym_EQ_GT] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(738),
    [anon_sym_DOLLAR] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(738),
    [anon_sym_STAR] = ACTIONS(738),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(731),
    [anon_sym_i8] = ACTIONS(731),
    [anon_sym_u16] = ACTIONS(731),
    [anon_sym_i16] = ACTIONS(731),
    [anon_sym_u32] = ACTIONS(731),
    [anon_sym_i32] = ACTIONS(731),
    [anon_sym_u64] = ACTIONS(731),
    [anon_sym_i64] = ACTIONS(731),
    [anon_sym_u128] = ACTIONS(731),
    [anon_sym_i128] = ACTIONS(731),
    [anon_sym_isize] = ACTIONS(731),
    [anon_sym_usize] = ACTIONS(731),
    [anon_sym_f32] = ACTIONS(731),
    [anon_sym_f64] = ACTIONS(731),
    [anon_sym_bool] = ACTIONS(731),
    [anon_sym_str] = ACTIONS(731),
    [anon_sym_char] = ACTIONS(731),
    [anon_sym_DASH] = ACTIONS(738),
    [anon_sym_SLASH] = ACTIONS(738),
    [anon_sym_PERCENT] = ACTIONS(738),
    [anon_sym_CARET] = ACTIONS(738),
    [anon_sym_BANG] = ACTIONS(738),
    [anon_sym_AMP] = ACTIONS(738),
    [anon_sym_PIPE] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(738),
    [anon_sym_GT_GT] = ACTIONS(738),
    [anon_sym_PLUS_EQ] = ACTIONS(733),
    [anon_sym_DASH_EQ] = ACTIONS(733),
    [anon_sym_STAR_EQ] = ACTIONS(733),
    [anon_sym_SLASH_EQ] = ACTIONS(733),
    [anon_sym_PERCENT_EQ] = ACTIONS(733),
    [anon_sym_CARET_EQ] = ACTIONS(733),
    [anon_sym_AMP_EQ] = ACTIONS(733),
    [anon_sym_PIPE_EQ] = ACTIONS(733),
    [anon_sym_LT_LT_EQ] = ACTIONS(733),
    [anon_sym_GT_GT_EQ] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(738),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(738),
    [anon_sym_LT] = ACTIONS(738),
    [anon_sym_GT_EQ] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_AT] = ACTIONS(733),
    [anon_sym__] = ACTIONS(738),
    [anon_sym_DOT] = ACTIONS(738),
    [anon_sym_DOT_DOT] = ACTIONS(738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(733),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_DASH_GT] = ACTIONS(733),
    [anon_sym_POUND] = ACTIONS(733),
    [anon_sym_SQUOTE] = ACTIONS(731),
    [anon_sym_as] = ACTIONS(731),
    [anon_sym_async] = ACTIONS(731),
    [anon_sym_await] = ACTIONS(731),
    [anon_sym_break] = ACTIONS(731),
    [anon_sym_const] = ACTIONS(731),
    [anon_sym_continue] = ACTIONS(731),
    [anon_sym_default] = ACTIONS(731),
    [anon_sym_enum] = ACTIONS(731),
    [anon_sym_fn] = ACTIONS(731),
    [anon_sym_for] = ACTIONS(731),
    [anon_sym_if] = ACTIONS(731),
    [anon_sym_impl] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(731),
    [anon_sym_loop] = ACTIONS(731),
    [anon_sym_match] = ACTIONS(731),
    [anon_sym_mod] = ACTIONS(731),
    [anon_sym_pub] = ACTIONS(731),
    [anon_sym_return] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_struct] = ACTIONS(731),
    [anon_sym_trait] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_union] = ACTIONS(731),
    [anon_sym_unsafe] = ACTIONS(731),
    [anon_sym_use] = ACTIONS(731),
    [anon_sym_where] = ACTIONS(731),
    [anon_sym_while] = ACTIONS(731),
    [sym_mutable_specifier] = ACTIONS(731),
    [sym_integer_literal] = ACTIONS(736),
    [aux_sym_string_literal_token1] = ACTIONS(736),
    [sym_char_literal] = ACTIONS(736),
    [anon_sym_true] = ACTIONS(731),
    [anon_sym_false] = ACTIONS(731),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(731),
    [sym_super] = ACTIONS(731),
    [sym_crate] = ACTIONS(731),
    [sym_metavariable] = ACTIONS(736),
    [sym__raw_string_literal_start] = ACTIONS(736),
    [sym_float_literal] = ACTIONS(736),
  },
  [135] = {
    [sym_line_comment] = STATE(135),
    [sym_block_comment] = STATE(135),
    [aux_sym__non_special_token_repeat1] = STATE(134),
    [sym_identifier] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_RBRACK] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(741),
    [anon_sym_i8] = ACTIONS(741),
    [anon_sym_u16] = ACTIONS(741),
    [anon_sym_i16] = ACTIONS(741),
    [anon_sym_u32] = ACTIONS(741),
    [anon_sym_i32] = ACTIONS(741),
    [anon_sym_u64] = ACTIONS(741),
    [anon_sym_i64] = ACTIONS(741),
    [anon_sym_u128] = ACTIONS(741),
    [anon_sym_i128] = ACTIONS(741),
    [anon_sym_isize] = ACTIONS(741),
    [anon_sym_usize] = ACTIONS(741),
    [anon_sym_f32] = ACTIONS(741),
    [anon_sym_f64] = ACTIONS(741),
    [anon_sym_bool] = ACTIONS(741),
    [anon_sym_str] = ACTIONS(741),
    [anon_sym_char] = ACTIONS(741),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(741),
    [anon_sym_as] = ACTIONS(741),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_await] = ACTIONS(741),
    [anon_sym_break] = ACTIONS(741),
    [anon_sym_const] = ACTIONS(741),
    [anon_sym_continue] = ACTIONS(741),
    [anon_sym_default] = ACTIONS(741),
    [anon_sym_enum] = ACTIONS(741),
    [anon_sym_fn] = ACTIONS(741),
    [anon_sym_for] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(741),
    [anon_sym_impl] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(741),
    [anon_sym_loop] = ACTIONS(741),
    [anon_sym_match] = ACTIONS(741),
    [anon_sym_mod] = ACTIONS(741),
    [anon_sym_pub] = ACTIONS(741),
    [anon_sym_return] = ACTIONS(741),
    [anon_sym_static] = ACTIONS(741),
    [anon_sym_struct] = ACTIONS(741),
    [anon_sym_trait] = ACTIONS(741),
    [anon_sym_type] = ACTIONS(741),
    [anon_sym_union] = ACTIONS(741),
    [anon_sym_unsafe] = ACTIONS(741),
    [anon_sym_use] = ACTIONS(741),
    [anon_sym_where] = ACTIONS(741),
    [anon_sym_while] = ACTIONS(741),
    [sym_mutable_specifier] = ACTIONS(741),
    [sym_integer_literal] = ACTIONS(743),
    [aux_sym_string_literal_token1] = ACTIONS(743),
    [sym_char_literal] = ACTIONS(743),
    [anon_sym_true] = ACTIONS(741),
    [anon_sym_false] = ACTIONS(741),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(741),
    [sym_super] = ACTIONS(741),
    [sym_crate] = ACTIONS(741),
    [sym_metavariable] = ACTIONS(743),
    [sym__raw_string_literal_start] = ACTIONS(743),
    [sym_float_literal] = ACTIONS(743),
  },
  [136] = {
    [sym_line_comment] = STATE(136),
    [sym_block_comment] = STATE(136),
    [aux_sym__non_special_token_repeat1] = STATE(134),
    [sym_identifier] = ACTIONS(745),
    [anon_sym_SEMI] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(747),
    [anon_sym_RPAREN] = ACTIONS(747),
    [anon_sym_LBRACK] = ACTIONS(747),
    [anon_sym_RBRACK] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_RBRACE] = ACTIONS(747),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_u8] = ACTIONS(745),
    [anon_sym_i8] = ACTIONS(745),
    [anon_sym_u16] = ACTIONS(745),
    [anon_sym_i16] = ACTIONS(745),
    [anon_sym_u32] = ACTIONS(745),
    [anon_sym_i32] = ACTIONS(745),
    [anon_sym_u64] = ACTIONS(745),
    [anon_sym_i64] = ACTIONS(745),
    [anon_sym_u128] = ACTIONS(745),
    [anon_sym_i128] = ACTIONS(745),
    [anon_sym_isize] = ACTIONS(745),
    [anon_sym_usize] = ACTIONS(745),
    [anon_sym_f32] = ACTIONS(745),
    [anon_sym_f64] = ACTIONS(745),
    [anon_sym_bool] = ACTIONS(745),
    [anon_sym_str] = ACTIONS(745),
    [anon_sym_char] = ACTIONS(745),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_PLUS_EQ] = ACTIONS(554),
    [anon_sym_DASH_EQ] = ACTIONS(554),
    [anon_sym_STAR_EQ] = ACTIONS(554),
    [anon_sym_SLASH_EQ] = ACTIONS(554),
    [anon_sym_PERCENT_EQ] = ACTIONS(554),
    [anon_sym_CARET_EQ] = ACTIONS(554),
    [anon_sym_AMP_EQ] = ACTIONS(554),
    [anon_sym_PIPE_EQ] = ACTIONS(554),
    [anon_sym_LT_LT_EQ] = ACTIONS(554),
    [anon_sym_GT_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT] = ACTIONS(564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(554),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_COLON_COLON] = ACTIONS(554),
    [anon_sym_DASH_GT] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(745),
    [anon_sym_as] = ACTIONS(745),
    [anon_sym_async] = ACTIONS(745),
    [anon_sym_await] = ACTIONS(745),
    [anon_sym_break] = ACTIONS(745),
    [anon_sym_const] = ACTIONS(745),
    [anon_sym_continue] = ACTIONS(745),
    [anon_sym_default] = ACTIONS(745),
    [anon_sym_enum] = ACTIONS(745),
    [anon_sym_fn] = ACTIONS(745),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_if] = ACTIONS(745),
    [anon_sym_impl] = ACTIONS(745),
    [anon_sym_let] = ACTIONS(745),
    [anon_sym_loop] = ACTIONS(745),
    [anon_sym_match] = ACTIONS(745),
    [anon_sym_mod] = ACTIONS(745),
    [anon_sym_pub] = ACTIONS(745),
    [anon_sym_return] = ACTIONS(745),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_struct] = ACTIONS(745),
    [anon_sym_trait] = ACTIONS(745),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_union] = ACTIONS(745),
    [anon_sym_unsafe] = ACTIONS(745),
    [anon_sym_use] = ACTIONS(745),
    [anon_sym_where] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(745),
    [sym_mutable_specifier] = ACTIONS(745),
    [sym_integer_literal] = ACTIONS(747),
    [aux_sym_string_literal_token1] = ACTIONS(747),
    [sym_char_literal] = ACTIONS(747),
    [anon_sym_true] = ACTIONS(745),
    [anon_sym_false] = ACTIONS(745),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(745),
    [sym_super] = ACTIONS(745),
    [sym_crate] = ACTIONS(745),
    [sym_metavariable] = ACTIONS(747),
    [sym__raw_string_literal_start] = ACTIONS(747),
    [sym_float_literal] = ACTIONS(747),
  },
  [137] = {
    [sym_line_comment] = STATE(137),
    [sym_block_comment] = STATE(137),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(751),
    [anon_sym_RPAREN] = ACTIONS(751),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_RBRACK] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym_RBRACE] = ACTIONS(751),
    [anon_sym_EQ_GT] = ACTIONS(751),
    [anon_sym_COLON] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(749),
    [anon_sym_PLUS] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(751),
    [anon_sym_u8] = ACTIONS(749),
    [anon_sym_i8] = ACTIONS(749),
    [anon_sym_u16] = ACTIONS(749),
    [anon_sym_i16] = ACTIONS(749),
    [anon_sym_u32] = ACTIONS(749),
    [anon_sym_i32] = ACTIONS(749),
    [anon_sym_u64] = ACTIONS(749),
    [anon_sym_i64] = ACTIONS(749),
    [anon_sym_u128] = ACTIONS(749),
    [anon_sym_i128] = ACTIONS(749),
    [anon_sym_isize] = ACTIONS(749),
    [anon_sym_usize] = ACTIONS(749),
    [anon_sym_f32] = ACTIONS(749),
    [anon_sym_f64] = ACTIONS(749),
    [anon_sym_bool] = ACTIONS(749),
    [anon_sym_str] = ACTIONS(749),
    [anon_sym_char] = ACTIONS(749),
    [anon_sym_DASH] = ACTIONS(749),
    [anon_sym_SLASH] = ACTIONS(749),
    [anon_sym_PERCENT] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(749),
    [anon_sym_BANG] = ACTIONS(749),
    [anon_sym_AMP] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(749),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(749),
    [anon_sym_GT_GT] = ACTIONS(749),
    [anon_sym_PLUS_EQ] = ACTIONS(751),
    [anon_sym_DASH_EQ] = ACTIONS(751),
    [anon_sym_STAR_EQ] = ACTIONS(751),
    [anon_sym_SLASH_EQ] = ACTIONS(751),
    [anon_sym_PERCENT_EQ] = ACTIONS(751),
    [anon_sym_CARET_EQ] = ACTIONS(751),
    [anon_sym_AMP_EQ] = ACTIONS(751),
    [anon_sym_PIPE_EQ] = ACTIONS(751),
    [anon_sym_LT_LT_EQ] = ACTIONS(751),
    [anon_sym_GT_GT_EQ] = ACTIONS(751),
    [anon_sym_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ] = ACTIONS(751),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_GT] = ACTIONS(749),
    [anon_sym_LT] = ACTIONS(749),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [anon_sym_LT_EQ] = ACTIONS(751),
    [anon_sym_AT] = ACTIONS(751),
    [anon_sym__] = ACTIONS(749),
    [anon_sym_DOT] = ACTIONS(749),
    [anon_sym_DOT_DOT] = ACTIONS(749),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(751),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(751),
    [anon_sym_DASH_GT] = ACTIONS(751),
    [anon_sym_POUND] = ACTIONS(751),
    [anon_sym_SQUOTE] = ACTIONS(749),
    [anon_sym_as] = ACTIONS(749),
    [anon_sym_async] = ACTIONS(749),
    [anon_sym_await] = ACTIONS(749),
    [anon_sym_break] = ACTIONS(749),
    [anon_sym_const] = ACTIONS(749),
    [anon_sym_continue] = ACTIONS(749),
    [anon_sym_default] = ACTIONS(749),
    [anon_sym_enum] = ACTIONS(749),
    [anon_sym_fn] = ACTIONS(749),
    [anon_sym_for] = ACTIONS(749),
    [anon_sym_if] = ACTIONS(749),
    [anon_sym_impl] = ACTIONS(749),
    [anon_sym_let] = ACTIONS(749),
    [anon_sym_loop] = ACTIONS(749),
    [anon_sym_match] = ACTIONS(749),
    [anon_sym_mod] = ACTIONS(749),
    [anon_sym_pub] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(749),
    [anon_sym_static] = ACTIONS(749),
    [anon_sym_struct] = ACTIONS(749),
    [anon_sym_trait] = ACTIONS(749),
    [anon_sym_type] = ACTIONS(749),
    [anon_sym_union] = ACTIONS(749),
    [anon_sym_unsafe] = ACTIONS(749),
    [anon_sym_use] = ACTIONS(749),
    [anon_sym_where] = ACTIONS(749),
    [anon_sym_while] = ACTIONS(749),
    [sym_mutable_specifier] = ACTIONS(749),
    [sym_integer_literal] = ACTIONS(751),
    [aux_sym_string_literal_token1] = ACTIONS(751),
    [sym_char_literal] = ACTIONS(751),
    [anon_sym_true] = ACTIONS(749),
    [anon_sym_false] = ACTIONS(749),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(749),
    [sym_super] = ACTIONS(749),
    [sym_crate] = ACTIONS(749),
    [sym_metavariable] = ACTIONS(751),
    [sym__raw_string_literal_start] = ACTIONS(751),
    [sym_float_literal] = ACTIONS(751),
  },
  [138] = {
    [sym_line_comment] = STATE(138),
    [sym_block_comment] = STATE(138),
    [sym_identifier] = ACTIONS(753),
    [anon_sym_SEMI] = ACTIONS(755),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_RPAREN] = ACTIONS(755),
    [anon_sym_LBRACK] = ACTIONS(755),
    [anon_sym_RBRACK] = ACTIONS(755),
    [anon_sym_LBRACE] = ACTIONS(755),
    [anon_sym_RBRACE] = ACTIONS(755),
    [anon_sym_EQ_GT] = ACTIONS(755),
    [anon_sym_COLON] = ACTIONS(753),
    [anon_sym_DOLLAR] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(755),
    [anon_sym_u8] = ACTIONS(753),
    [anon_sym_i8] = ACTIONS(753),
    [anon_sym_u16] = ACTIONS(753),
    [anon_sym_i16] = ACTIONS(753),
    [anon_sym_u32] = ACTIONS(753),
    [anon_sym_i32] = ACTIONS(753),
    [anon_sym_u64] = ACTIONS(753),
    [anon_sym_i64] = ACTIONS(753),
    [anon_sym_u128] = ACTIONS(753),
    [anon_sym_i128] = ACTIONS(753),
    [anon_sym_isize] = ACTIONS(753),
    [anon_sym_usize] = ACTIONS(753),
    [anon_sym_f32] = ACTIONS(753),
    [anon_sym_f64] = ACTIONS(753),
    [anon_sym_bool] = ACTIONS(753),
    [anon_sym_str] = ACTIONS(753),
    [anon_sym_char] = ACTIONS(753),
    [anon_sym_DASH] = ACTIONS(753),
    [anon_sym_SLASH] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_AMP_AMP] = ACTIONS(755),
    [anon_sym_PIPE_PIPE] = ACTIONS(755),
    [anon_sym_LT_LT] = ACTIONS(753),
    [anon_sym_GT_GT] = ACTIONS(753),
    [anon_sym_PLUS_EQ] = ACTIONS(755),
    [anon_sym_DASH_EQ] = ACTIONS(755),
    [anon_sym_STAR_EQ] = ACTIONS(755),
    [anon_sym_SLASH_EQ] = ACTIONS(755),
    [anon_sym_PERCENT_EQ] = ACTIONS(755),
    [anon_sym_CARET_EQ] = ACTIONS(755),
    [anon_sym_AMP_EQ] = ACTIONS(755),
    [anon_sym_PIPE_EQ] = ACTIONS(755),
    [anon_sym_LT_LT_EQ] = ACTIONS(755),
    [anon_sym_GT_GT_EQ] = ACTIONS(755),
    [anon_sym_EQ] = ACTIONS(753),
    [anon_sym_EQ_EQ] = ACTIONS(755),
    [anon_sym_BANG_EQ] = ACTIONS(755),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_GT_EQ] = ACTIONS(755),
    [anon_sym_LT_EQ] = ACTIONS(755),
    [anon_sym_AT] = ACTIONS(755),
    [anon_sym__] = ACTIONS(753),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(755),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(755),
    [anon_sym_COMMA] = ACTIONS(755),
    [anon_sym_COLON_COLON] = ACTIONS(755),
    [anon_sym_DASH_GT] = ACTIONS(755),
    [anon_sym_POUND] = ACTIONS(755),
    [anon_sym_SQUOTE] = ACTIONS(753),
    [anon_sym_as] = ACTIONS(753),
    [anon_sym_async] = ACTIONS(753),
    [anon_sym_await] = ACTIONS(753),
    [anon_sym_break] = ACTIONS(753),
    [anon_sym_const] = ACTIONS(753),
    [anon_sym_continue] = ACTIONS(753),
    [anon_sym_default] = ACTIONS(753),
    [anon_sym_enum] = ACTIONS(753),
    [anon_sym_fn] = ACTIONS(753),
    [anon_sym_for] = ACTIONS(753),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_impl] = ACTIONS(753),
    [anon_sym_let] = ACTIONS(753),
    [anon_sym_loop] = ACTIONS(753),
    [anon_sym_match] = ACTIONS(753),
    [anon_sym_mod] = ACTIONS(753),
    [anon_sym_pub] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(753),
    [anon_sym_static] = ACTIONS(753),
    [anon_sym_struct] = ACTIONS(753),
    [anon_sym_trait] = ACTIONS(753),
    [anon_sym_type] = ACTIONS(753),
    [anon_sym_union] = ACTIONS(753),
    [anon_sym_unsafe] = ACTIONS(753),
    [anon_sym_use] = ACTIONS(753),
    [anon_sym_where] = ACTIONS(753),
    [anon_sym_while] = ACTIONS(753),
    [sym_mutable_specifier] = ACTIONS(753),
    [sym_integer_literal] = ACTIONS(755),
    [aux_sym_string_literal_token1] = ACTIONS(755),
    [sym_char_literal] = ACTIONS(755),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(753),
    [sym_super] = ACTIONS(753),
    [sym_crate] = ACTIONS(753),
    [sym_metavariable] = ACTIONS(755),
    [sym__raw_string_literal_start] = ACTIONS(755),
    [sym_float_literal] = ACTIONS(755),
  },
  [139] = {
    [sym_attribute_item] = STATE(999),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1558),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(139),
    [sym_block_comment] = STATE(139),
    [aux_sym_enum_variant_list_repeat1] = STATE(162),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(757),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(759),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [140] = {
    [sym_line_comment] = STATE(140),
    [sym_block_comment] = STATE(140),
    [sym_identifier] = ACTIONS(763),
    [anon_sym_SEMI] = ACTIONS(765),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_RPAREN] = ACTIONS(765),
    [anon_sym_LBRACK] = ACTIONS(765),
    [anon_sym_RBRACK] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(765),
    [anon_sym_RBRACE] = ACTIONS(765),
    [anon_sym_EQ_GT] = ACTIONS(765),
    [anon_sym_COLON] = ACTIONS(763),
    [anon_sym_DOLLAR] = ACTIONS(763),
    [anon_sym_PLUS] = ACTIONS(763),
    [anon_sym_STAR] = ACTIONS(763),
    [anon_sym_QMARK] = ACTIONS(765),
    [anon_sym_u8] = ACTIONS(763),
    [anon_sym_i8] = ACTIONS(763),
    [anon_sym_u16] = ACTIONS(763),
    [anon_sym_i16] = ACTIONS(763),
    [anon_sym_u32] = ACTIONS(763),
    [anon_sym_i32] = ACTIONS(763),
    [anon_sym_u64] = ACTIONS(763),
    [anon_sym_i64] = ACTIONS(763),
    [anon_sym_u128] = ACTIONS(763),
    [anon_sym_i128] = ACTIONS(763),
    [anon_sym_isize] = ACTIONS(763),
    [anon_sym_usize] = ACTIONS(763),
    [anon_sym_f32] = ACTIONS(763),
    [anon_sym_f64] = ACTIONS(763),
    [anon_sym_bool] = ACTIONS(763),
    [anon_sym_str] = ACTIONS(763),
    [anon_sym_char] = ACTIONS(763),
    [anon_sym_DASH] = ACTIONS(763),
    [anon_sym_SLASH] = ACTIONS(763),
    [anon_sym_PERCENT] = ACTIONS(763),
    [anon_sym_CARET] = ACTIONS(763),
    [anon_sym_BANG] = ACTIONS(763),
    [anon_sym_AMP] = ACTIONS(763),
    [anon_sym_PIPE] = ACTIONS(763),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_LT_LT] = ACTIONS(763),
    [anon_sym_GT_GT] = ACTIONS(763),
    [anon_sym_PLUS_EQ] = ACTIONS(765),
    [anon_sym_DASH_EQ] = ACTIONS(765),
    [anon_sym_STAR_EQ] = ACTIONS(765),
    [anon_sym_SLASH_EQ] = ACTIONS(765),
    [anon_sym_PERCENT_EQ] = ACTIONS(765),
    [anon_sym_CARET_EQ] = ACTIONS(765),
    [anon_sym_AMP_EQ] = ACTIONS(765),
    [anon_sym_PIPE_EQ] = ACTIONS(765),
    [anon_sym_LT_LT_EQ] = ACTIONS(765),
    [anon_sym_GT_GT_EQ] = ACTIONS(765),
    [anon_sym_EQ] = ACTIONS(763),
    [anon_sym_EQ_EQ] = ACTIONS(765),
    [anon_sym_BANG_EQ] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(763),
    [anon_sym_LT] = ACTIONS(763),
    [anon_sym_GT_EQ] = ACTIONS(765),
    [anon_sym_LT_EQ] = ACTIONS(765),
    [anon_sym_AT] = ACTIONS(765),
    [anon_sym__] = ACTIONS(763),
    [anon_sym_DOT] = ACTIONS(763),
    [anon_sym_DOT_DOT] = ACTIONS(763),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(765),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(765),
    [anon_sym_COMMA] = ACTIONS(765),
    [anon_sym_COLON_COLON] = ACTIONS(765),
    [anon_sym_DASH_GT] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(765),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_as] = ACTIONS(763),
    [anon_sym_async] = ACTIONS(763),
    [anon_sym_await] = ACTIONS(763),
    [anon_sym_break] = ACTIONS(763),
    [anon_sym_const] = ACTIONS(763),
    [anon_sym_continue] = ACTIONS(763),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_enum] = ACTIONS(763),
    [anon_sym_fn] = ACTIONS(763),
    [anon_sym_for] = ACTIONS(763),
    [anon_sym_if] = ACTIONS(763),
    [anon_sym_impl] = ACTIONS(763),
    [anon_sym_let] = ACTIONS(763),
    [anon_sym_loop] = ACTIONS(763),
    [anon_sym_match] = ACTIONS(763),
    [anon_sym_mod] = ACTIONS(763),
    [anon_sym_pub] = ACTIONS(763),
    [anon_sym_return] = ACTIONS(763),
    [anon_sym_static] = ACTIONS(763),
    [anon_sym_struct] = ACTIONS(763),
    [anon_sym_trait] = ACTIONS(763),
    [anon_sym_type] = ACTIONS(763),
    [anon_sym_union] = ACTIONS(763),
    [anon_sym_unsafe] = ACTIONS(763),
    [anon_sym_use] = ACTIONS(763),
    [anon_sym_where] = ACTIONS(763),
    [anon_sym_while] = ACTIONS(763),
    [sym_mutable_specifier] = ACTIONS(763),
    [sym_integer_literal] = ACTIONS(765),
    [aux_sym_string_literal_token1] = ACTIONS(765),
    [sym_char_literal] = ACTIONS(765),
    [anon_sym_true] = ACTIONS(763),
    [anon_sym_false] = ACTIONS(763),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(763),
    [sym_super] = ACTIONS(763),
    [sym_crate] = ACTIONS(763),
    [sym_metavariable] = ACTIONS(765),
    [sym__raw_string_literal_start] = ACTIONS(765),
    [sym_float_literal] = ACTIONS(765),
  },
  [141] = {
    [sym_line_comment] = STATE(141),
    [sym_block_comment] = STATE(141),
    [sym_identifier] = ACTIONS(767),
    [anon_sym_SEMI] = ACTIONS(769),
    [anon_sym_LPAREN] = ACTIONS(769),
    [anon_sym_RPAREN] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(769),
    [anon_sym_RBRACK] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(769),
    [anon_sym_RBRACE] = ACTIONS(769),
    [anon_sym_EQ_GT] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_u8] = ACTIONS(767),
    [anon_sym_i8] = ACTIONS(767),
    [anon_sym_u16] = ACTIONS(767),
    [anon_sym_i16] = ACTIONS(767),
    [anon_sym_u32] = ACTIONS(767),
    [anon_sym_i32] = ACTIONS(767),
    [anon_sym_u64] = ACTIONS(767),
    [anon_sym_i64] = ACTIONS(767),
    [anon_sym_u128] = ACTIONS(767),
    [anon_sym_i128] = ACTIONS(767),
    [anon_sym_isize] = ACTIONS(767),
    [anon_sym_usize] = ACTIONS(767),
    [anon_sym_f32] = ACTIONS(767),
    [anon_sym_f64] = ACTIONS(767),
    [anon_sym_bool] = ACTIONS(767),
    [anon_sym_str] = ACTIONS(767),
    [anon_sym_char] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_PERCENT] = ACTIONS(767),
    [anon_sym_CARET] = ACTIONS(767),
    [anon_sym_BANG] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(767),
    [anon_sym_GT_GT] = ACTIONS(767),
    [anon_sym_PLUS_EQ] = ACTIONS(769),
    [anon_sym_DASH_EQ] = ACTIONS(769),
    [anon_sym_STAR_EQ] = ACTIONS(769),
    [anon_sym_SLASH_EQ] = ACTIONS(769),
    [anon_sym_PERCENT_EQ] = ACTIONS(769),
    [anon_sym_CARET_EQ] = ACTIONS(769),
    [anon_sym_AMP_EQ] = ACTIONS(769),
    [anon_sym_PIPE_EQ] = ACTIONS(769),
    [anon_sym_LT_LT_EQ] = ACTIONS(769),
    [anon_sym_GT_GT_EQ] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_GT_EQ] = ACTIONS(769),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_AT] = ACTIONS(769),
    [anon_sym__] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(767),
    [anon_sym_DOT_DOT] = ACTIONS(767),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(769),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(769),
    [anon_sym_COMMA] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(769),
    [anon_sym_DASH_GT] = ACTIONS(769),
    [anon_sym_POUND] = ACTIONS(769),
    [anon_sym_SQUOTE] = ACTIONS(767),
    [anon_sym_as] = ACTIONS(767),
    [anon_sym_async] = ACTIONS(767),
    [anon_sym_await] = ACTIONS(767),
    [anon_sym_break] = ACTIONS(767),
    [anon_sym_const] = ACTIONS(767),
    [anon_sym_continue] = ACTIONS(767),
    [anon_sym_default] = ACTIONS(767),
    [anon_sym_enum] = ACTIONS(767),
    [anon_sym_fn] = ACTIONS(767),
    [anon_sym_for] = ACTIONS(767),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_impl] = ACTIONS(767),
    [anon_sym_let] = ACTIONS(767),
    [anon_sym_loop] = ACTIONS(767),
    [anon_sym_match] = ACTIONS(767),
    [anon_sym_mod] = ACTIONS(767),
    [anon_sym_pub] = ACTIONS(767),
    [anon_sym_return] = ACTIONS(767),
    [anon_sym_static] = ACTIONS(767),
    [anon_sym_struct] = ACTIONS(767),
    [anon_sym_trait] = ACTIONS(767),
    [anon_sym_type] = ACTIONS(767),
    [anon_sym_union] = ACTIONS(767),
    [anon_sym_unsafe] = ACTIONS(767),
    [anon_sym_use] = ACTIONS(767),
    [anon_sym_where] = ACTIONS(767),
    [anon_sym_while] = ACTIONS(767),
    [sym_mutable_specifier] = ACTIONS(767),
    [sym_integer_literal] = ACTIONS(769),
    [aux_sym_string_literal_token1] = ACTIONS(769),
    [sym_char_literal] = ACTIONS(769),
    [anon_sym_true] = ACTIONS(767),
    [anon_sym_false] = ACTIONS(767),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(767),
    [sym_super] = ACTIONS(767),
    [sym_crate] = ACTIONS(767),
    [sym_metavariable] = ACTIONS(769),
    [sym__raw_string_literal_start] = ACTIONS(769),
    [sym_float_literal] = ACTIONS(769),
  },
  [142] = {
    [sym_line_comment] = STATE(142),
    [sym_block_comment] = STATE(142),
    [sym_identifier] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(773),
    [anon_sym_RPAREN] = ACTIONS(773),
    [anon_sym_LBRACK] = ACTIONS(773),
    [anon_sym_RBRACK] = ACTIONS(773),
    [anon_sym_LBRACE] = ACTIONS(773),
    [anon_sym_RBRACE] = ACTIONS(773),
    [anon_sym_EQ_GT] = ACTIONS(773),
    [anon_sym_COLON] = ACTIONS(771),
    [anon_sym_DOLLAR] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_QMARK] = ACTIONS(773),
    [anon_sym_u8] = ACTIONS(771),
    [anon_sym_i8] = ACTIONS(771),
    [anon_sym_u16] = ACTIONS(771),
    [anon_sym_i16] = ACTIONS(771),
    [anon_sym_u32] = ACTIONS(771),
    [anon_sym_i32] = ACTIONS(771),
    [anon_sym_u64] = ACTIONS(771),
    [anon_sym_i64] = ACTIONS(771),
    [anon_sym_u128] = ACTIONS(771),
    [anon_sym_i128] = ACTIONS(771),
    [anon_sym_isize] = ACTIONS(771),
    [anon_sym_usize] = ACTIONS(771),
    [anon_sym_f32] = ACTIONS(771),
    [anon_sym_f64] = ACTIONS(771),
    [anon_sym_bool] = ACTIONS(771),
    [anon_sym_str] = ACTIONS(771),
    [anon_sym_char] = ACTIONS(771),
    [anon_sym_DASH] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_BANG] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(773),
    [anon_sym_PIPE_PIPE] = ACTIONS(773),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_PLUS_EQ] = ACTIONS(773),
    [anon_sym_DASH_EQ] = ACTIONS(773),
    [anon_sym_STAR_EQ] = ACTIONS(773),
    [anon_sym_SLASH_EQ] = ACTIONS(773),
    [anon_sym_PERCENT_EQ] = ACTIONS(773),
    [anon_sym_CARET_EQ] = ACTIONS(773),
    [anon_sym_AMP_EQ] = ACTIONS(773),
    [anon_sym_PIPE_EQ] = ACTIONS(773),
    [anon_sym_LT_LT_EQ] = ACTIONS(773),
    [anon_sym_GT_GT_EQ] = ACTIONS(773),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(773),
    [anon_sym_BANG_EQ] = ACTIONS(773),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(773),
    [anon_sym_LT_EQ] = ACTIONS(773),
    [anon_sym_AT] = ACTIONS(773),
    [anon_sym__] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(773),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(773),
    [anon_sym_COMMA] = ACTIONS(773),
    [anon_sym_COLON_COLON] = ACTIONS(773),
    [anon_sym_DASH_GT] = ACTIONS(773),
    [anon_sym_POUND] = ACTIONS(773),
    [anon_sym_SQUOTE] = ACTIONS(771),
    [anon_sym_as] = ACTIONS(771),
    [anon_sym_async] = ACTIONS(771),
    [anon_sym_await] = ACTIONS(771),
    [anon_sym_break] = ACTIONS(771),
    [anon_sym_const] = ACTIONS(771),
    [anon_sym_continue] = ACTIONS(771),
    [anon_sym_default] = ACTIONS(771),
    [anon_sym_enum] = ACTIONS(771),
    [anon_sym_fn] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(771),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_impl] = ACTIONS(771),
    [anon_sym_let] = ACTIONS(771),
    [anon_sym_loop] = ACTIONS(771),
    [anon_sym_match] = ACTIONS(771),
    [anon_sym_mod] = ACTIONS(771),
    [anon_sym_pub] = ACTIONS(771),
    [anon_sym_return] = ACTIONS(771),
    [anon_sym_static] = ACTIONS(771),
    [anon_sym_struct] = ACTIONS(771),
    [anon_sym_trait] = ACTIONS(771),
    [anon_sym_type] = ACTIONS(771),
    [anon_sym_union] = ACTIONS(771),
    [anon_sym_unsafe] = ACTIONS(771),
    [anon_sym_use] = ACTIONS(771),
    [anon_sym_where] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [sym_mutable_specifier] = ACTIONS(771),
    [sym_integer_literal] = ACTIONS(773),
    [aux_sym_string_literal_token1] = ACTIONS(773),
    [sym_char_literal] = ACTIONS(773),
    [anon_sym_true] = ACTIONS(771),
    [anon_sym_false] = ACTIONS(771),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(771),
    [sym_super] = ACTIONS(771),
    [sym_crate] = ACTIONS(771),
    [sym_metavariable] = ACTIONS(773),
    [sym__raw_string_literal_start] = ACTIONS(773),
    [sym_float_literal] = ACTIONS(773),
  },
  [143] = {
    [sym_attribute_item] = STATE(999),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1540),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(143),
    [sym_block_comment] = STATE(143),
    [aux_sym_enum_variant_list_repeat1] = STATE(156),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [144] = {
    [sym_line_comment] = STATE(144),
    [sym_block_comment] = STATE(144),
    [aux_sym__non_special_token_repeat1] = STATE(144),
    [sym_identifier] = ACTIONS(731),
    [anon_sym_SEMI] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(736),
    [anon_sym_RPAREN] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(736),
    [anon_sym_RBRACK] = ACTIONS(736),
    [anon_sym_LBRACE] = ACTIONS(736),
    [anon_sym_RBRACE] = ACTIONS(736),
    [anon_sym_EQ_GT] = ACTIONS(779),
    [anon_sym_COLON] = ACTIONS(782),
    [anon_sym_DOLLAR] = ACTIONS(736),
    [anon_sym_PLUS] = ACTIONS(782),
    [anon_sym_STAR] = ACTIONS(782),
    [anon_sym_QMARK] = ACTIONS(779),
    [anon_sym_u8] = ACTIONS(731),
    [anon_sym_i8] = ACTIONS(731),
    [anon_sym_u16] = ACTIONS(731),
    [anon_sym_i16] = ACTIONS(731),
    [anon_sym_u32] = ACTIONS(731),
    [anon_sym_i32] = ACTIONS(731),
    [anon_sym_u64] = ACTIONS(731),
    [anon_sym_i64] = ACTIONS(731),
    [anon_sym_u128] = ACTIONS(731),
    [anon_sym_i128] = ACTIONS(731),
    [anon_sym_isize] = ACTIONS(731),
    [anon_sym_usize] = ACTIONS(731),
    [anon_sym_f32] = ACTIONS(731),
    [anon_sym_f64] = ACTIONS(731),
    [anon_sym_bool] = ACTIONS(731),
    [anon_sym_str] = ACTIONS(731),
    [anon_sym_char] = ACTIONS(731),
    [anon_sym_DASH] = ACTIONS(782),
    [anon_sym_SLASH] = ACTIONS(782),
    [anon_sym_PERCENT] = ACTIONS(782),
    [anon_sym_CARET] = ACTIONS(782),
    [anon_sym_BANG] = ACTIONS(782),
    [anon_sym_AMP] = ACTIONS(782),
    [anon_sym_PIPE] = ACTIONS(782),
    [anon_sym_AMP_AMP] = ACTIONS(779),
    [anon_sym_PIPE_PIPE] = ACTIONS(779),
    [anon_sym_LT_LT] = ACTIONS(782),
    [anon_sym_GT_GT] = ACTIONS(782),
    [anon_sym_PLUS_EQ] = ACTIONS(779),
    [anon_sym_DASH_EQ] = ACTIONS(779),
    [anon_sym_STAR_EQ] = ACTIONS(779),
    [anon_sym_SLASH_EQ] = ACTIONS(779),
    [anon_sym_PERCENT_EQ] = ACTIONS(779),
    [anon_sym_CARET_EQ] = ACTIONS(779),
    [anon_sym_AMP_EQ] = ACTIONS(779),
    [anon_sym_PIPE_EQ] = ACTIONS(779),
    [anon_sym_LT_LT_EQ] = ACTIONS(779),
    [anon_sym_GT_GT_EQ] = ACTIONS(779),
    [anon_sym_EQ] = ACTIONS(782),
    [anon_sym_EQ_EQ] = ACTIONS(779),
    [anon_sym_BANG_EQ] = ACTIONS(779),
    [anon_sym_GT] = ACTIONS(782),
    [anon_sym_LT] = ACTIONS(782),
    [anon_sym_GT_EQ] = ACTIONS(779),
    [anon_sym_LT_EQ] = ACTIONS(779),
    [anon_sym_AT] = ACTIONS(779),
    [anon_sym__] = ACTIONS(782),
    [anon_sym_DOT] = ACTIONS(782),
    [anon_sym_DOT_DOT] = ACTIONS(782),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(779),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(779),
    [anon_sym_COMMA] = ACTIONS(779),
    [anon_sym_COLON_COLON] = ACTIONS(779),
    [anon_sym_DASH_GT] = ACTIONS(779),
    [anon_sym_POUND] = ACTIONS(779),
    [anon_sym_SQUOTE] = ACTIONS(731),
    [anon_sym_as] = ACTIONS(731),
    [anon_sym_async] = ACTIONS(731),
    [anon_sym_await] = ACTIONS(731),
    [anon_sym_break] = ACTIONS(731),
    [anon_sym_const] = ACTIONS(731),
    [anon_sym_continue] = ACTIONS(731),
    [anon_sym_default] = ACTIONS(731),
    [anon_sym_enum] = ACTIONS(731),
    [anon_sym_fn] = ACTIONS(731),
    [anon_sym_for] = ACTIONS(731),
    [anon_sym_if] = ACTIONS(731),
    [anon_sym_impl] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(731),
    [anon_sym_loop] = ACTIONS(731),
    [anon_sym_match] = ACTIONS(731),
    [anon_sym_mod] = ACTIONS(731),
    [anon_sym_pub] = ACTIONS(731),
    [anon_sym_return] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_struct] = ACTIONS(731),
    [anon_sym_trait] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_union] = ACTIONS(731),
    [anon_sym_unsafe] = ACTIONS(731),
    [anon_sym_use] = ACTIONS(731),
    [anon_sym_where] = ACTIONS(731),
    [anon_sym_while] = ACTIONS(731),
    [sym_mutable_specifier] = ACTIONS(731),
    [sym_integer_literal] = ACTIONS(736),
    [aux_sym_string_literal_token1] = ACTIONS(736),
    [sym_char_literal] = ACTIONS(736),
    [anon_sym_true] = ACTIONS(731),
    [anon_sym_false] = ACTIONS(731),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(731),
    [sym_super] = ACTIONS(731),
    [sym_crate] = ACTIONS(731),
    [sym__raw_string_literal_start] = ACTIONS(736),
    [sym_float_literal] = ACTIONS(736),
  },
  [145] = {
    [sym_line_comment] = STATE(145),
    [sym_block_comment] = STATE(145),
    [sym_identifier] = ACTIONS(785),
    [anon_sym_SEMI] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(787),
    [anon_sym_RPAREN] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(787),
    [anon_sym_RBRACK] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(787),
    [anon_sym_RBRACE] = ACTIONS(787),
    [anon_sym_EQ_GT] = ACTIONS(787),
    [anon_sym_COLON] = ACTIONS(785),
    [anon_sym_DOLLAR] = ACTIONS(785),
    [anon_sym_PLUS] = ACTIONS(785),
    [anon_sym_STAR] = ACTIONS(785),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_u8] = ACTIONS(785),
    [anon_sym_i8] = ACTIONS(785),
    [anon_sym_u16] = ACTIONS(785),
    [anon_sym_i16] = ACTIONS(785),
    [anon_sym_u32] = ACTIONS(785),
    [anon_sym_i32] = ACTIONS(785),
    [anon_sym_u64] = ACTIONS(785),
    [anon_sym_i64] = ACTIONS(785),
    [anon_sym_u128] = ACTIONS(785),
    [anon_sym_i128] = ACTIONS(785),
    [anon_sym_isize] = ACTIONS(785),
    [anon_sym_usize] = ACTIONS(785),
    [anon_sym_f32] = ACTIONS(785),
    [anon_sym_f64] = ACTIONS(785),
    [anon_sym_bool] = ACTIONS(785),
    [anon_sym_str] = ACTIONS(785),
    [anon_sym_char] = ACTIONS(785),
    [anon_sym_DASH] = ACTIONS(785),
    [anon_sym_SLASH] = ACTIONS(785),
    [anon_sym_PERCENT] = ACTIONS(785),
    [anon_sym_CARET] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(785),
    [anon_sym_AMP] = ACTIONS(785),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_AMP_AMP] = ACTIONS(787),
    [anon_sym_PIPE_PIPE] = ACTIONS(787),
    [anon_sym_LT_LT] = ACTIONS(785),
    [anon_sym_GT_GT] = ACTIONS(785),
    [anon_sym_PLUS_EQ] = ACTIONS(787),
    [anon_sym_DASH_EQ] = ACTIONS(787),
    [anon_sym_STAR_EQ] = ACTIONS(787),
    [anon_sym_SLASH_EQ] = ACTIONS(787),
    [anon_sym_PERCENT_EQ] = ACTIONS(787),
    [anon_sym_CARET_EQ] = ACTIONS(787),
    [anon_sym_AMP_EQ] = ACTIONS(787),
    [anon_sym_PIPE_EQ] = ACTIONS(787),
    [anon_sym_LT_LT_EQ] = ACTIONS(787),
    [anon_sym_GT_GT_EQ] = ACTIONS(787),
    [anon_sym_EQ] = ACTIONS(785),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(785),
    [anon_sym_LT] = ACTIONS(785),
    [anon_sym_GT_EQ] = ACTIONS(787),
    [anon_sym_LT_EQ] = ACTIONS(787),
    [anon_sym_AT] = ACTIONS(787),
    [anon_sym__] = ACTIONS(785),
    [anon_sym_DOT] = ACTIONS(785),
    [anon_sym_DOT_DOT] = ACTIONS(785),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(787),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(787),
    [anon_sym_COMMA] = ACTIONS(787),
    [anon_sym_COLON_COLON] = ACTIONS(787),
    [anon_sym_DASH_GT] = ACTIONS(787),
    [anon_sym_POUND] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(785),
    [anon_sym_as] = ACTIONS(785),
    [anon_sym_async] = ACTIONS(785),
    [anon_sym_await] = ACTIONS(785),
    [anon_sym_break] = ACTIONS(785),
    [anon_sym_const] = ACTIONS(785),
    [anon_sym_continue] = ACTIONS(785),
    [anon_sym_default] = ACTIONS(785),
    [anon_sym_enum] = ACTIONS(785),
    [anon_sym_fn] = ACTIONS(785),
    [anon_sym_for] = ACTIONS(785),
    [anon_sym_if] = ACTIONS(785),
    [anon_sym_impl] = ACTIONS(785),
    [anon_sym_let] = ACTIONS(785),
    [anon_sym_loop] = ACTIONS(785),
    [anon_sym_match] = ACTIONS(785),
    [anon_sym_mod] = ACTIONS(785),
    [anon_sym_pub] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(785),
    [anon_sym_static] = ACTIONS(785),
    [anon_sym_struct] = ACTIONS(785),
    [anon_sym_trait] = ACTIONS(785),
    [anon_sym_type] = ACTIONS(785),
    [anon_sym_union] = ACTIONS(785),
    [anon_sym_unsafe] = ACTIONS(785),
    [anon_sym_use] = ACTIONS(785),
    [anon_sym_where] = ACTIONS(785),
    [anon_sym_while] = ACTIONS(785),
    [sym_mutable_specifier] = ACTIONS(785),
    [sym_integer_literal] = ACTIONS(787),
    [aux_sym_string_literal_token1] = ACTIONS(787),
    [sym_char_literal] = ACTIONS(787),
    [anon_sym_true] = ACTIONS(785),
    [anon_sym_false] = ACTIONS(785),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(785),
    [sym_super] = ACTIONS(785),
    [sym_crate] = ACTIONS(785),
    [sym_metavariable] = ACTIONS(787),
    [sym__raw_string_literal_start] = ACTIONS(787),
    [sym_float_literal] = ACTIONS(787),
  },
  [146] = {
    [sym_line_comment] = STATE(146),
    [sym_block_comment] = STATE(146),
    [sym_identifier] = ACTIONS(789),
    [anon_sym_SEMI] = ACTIONS(791),
    [anon_sym_LPAREN] = ACTIONS(791),
    [anon_sym_RPAREN] = ACTIONS(791),
    [anon_sym_LBRACK] = ACTIONS(791),
    [anon_sym_RBRACK] = ACTIONS(791),
    [anon_sym_LBRACE] = ACTIONS(791),
    [anon_sym_RBRACE] = ACTIONS(791),
    [anon_sym_EQ_GT] = ACTIONS(791),
    [anon_sym_COLON] = ACTIONS(789),
    [anon_sym_DOLLAR] = ACTIONS(789),
    [anon_sym_PLUS] = ACTIONS(789),
    [anon_sym_STAR] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_u8] = ACTIONS(789),
    [anon_sym_i8] = ACTIONS(789),
    [anon_sym_u16] = ACTIONS(789),
    [anon_sym_i16] = ACTIONS(789),
    [anon_sym_u32] = ACTIONS(789),
    [anon_sym_i32] = ACTIONS(789),
    [anon_sym_u64] = ACTIONS(789),
    [anon_sym_i64] = ACTIONS(789),
    [anon_sym_u128] = ACTIONS(789),
    [anon_sym_i128] = ACTIONS(789),
    [anon_sym_isize] = ACTIONS(789),
    [anon_sym_usize] = ACTIONS(789),
    [anon_sym_f32] = ACTIONS(789),
    [anon_sym_f64] = ACTIONS(789),
    [anon_sym_bool] = ACTIONS(789),
    [anon_sym_str] = ACTIONS(789),
    [anon_sym_char] = ACTIONS(789),
    [anon_sym_DASH] = ACTIONS(789),
    [anon_sym_SLASH] = ACTIONS(789),
    [anon_sym_PERCENT] = ACTIONS(789),
    [anon_sym_CARET] = ACTIONS(789),
    [anon_sym_BANG] = ACTIONS(789),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(789),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [anon_sym_LT_LT] = ACTIONS(789),
    [anon_sym_GT_GT] = ACTIONS(789),
    [anon_sym_PLUS_EQ] = ACTIONS(791),
    [anon_sym_DASH_EQ] = ACTIONS(791),
    [anon_sym_STAR_EQ] = ACTIONS(791),
    [anon_sym_SLASH_EQ] = ACTIONS(791),
    [anon_sym_PERCENT_EQ] = ACTIONS(791),
    [anon_sym_CARET_EQ] = ACTIONS(791),
    [anon_sym_AMP_EQ] = ACTIONS(791),
    [anon_sym_PIPE_EQ] = ACTIONS(791),
    [anon_sym_LT_LT_EQ] = ACTIONS(791),
    [anon_sym_GT_GT_EQ] = ACTIONS(791),
    [anon_sym_EQ] = ACTIONS(789),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_BANG_EQ] = ACTIONS(791),
    [anon_sym_GT] = ACTIONS(789),
    [anon_sym_LT] = ACTIONS(789),
    [anon_sym_GT_EQ] = ACTIONS(791),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_AT] = ACTIONS(791),
    [anon_sym__] = ACTIONS(789),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_DOT_DOT] = ACTIONS(789),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(791),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(791),
    [anon_sym_COMMA] = ACTIONS(791),
    [anon_sym_COLON_COLON] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(791),
    [anon_sym_POUND] = ACTIONS(791),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [anon_sym_as] = ACTIONS(789),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_await] = ACTIONS(789),
    [anon_sym_break] = ACTIONS(789),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_continue] = ACTIONS(789),
    [anon_sym_default] = ACTIONS(789),
    [anon_sym_enum] = ACTIONS(789),
    [anon_sym_fn] = ACTIONS(789),
    [anon_sym_for] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_impl] = ACTIONS(789),
    [anon_sym_let] = ACTIONS(789),
    [anon_sym_loop] = ACTIONS(789),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_mod] = ACTIONS(789),
    [anon_sym_pub] = ACTIONS(789),
    [anon_sym_return] = ACTIONS(789),
    [anon_sym_static] = ACTIONS(789),
    [anon_sym_struct] = ACTIONS(789),
    [anon_sym_trait] = ACTIONS(789),
    [anon_sym_type] = ACTIONS(789),
    [anon_sym_union] = ACTIONS(789),
    [anon_sym_unsafe] = ACTIONS(789),
    [anon_sym_use] = ACTIONS(789),
    [anon_sym_where] = ACTIONS(789),
    [anon_sym_while] = ACTIONS(789),
    [sym_mutable_specifier] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [aux_sym_string_literal_token1] = ACTIONS(791),
    [sym_char_literal] = ACTIONS(791),
    [anon_sym_true] = ACTIONS(789),
    [anon_sym_false] = ACTIONS(789),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(789),
    [sym_super] = ACTIONS(789),
    [sym_crate] = ACTIONS(789),
    [sym_metavariable] = ACTIONS(791),
    [sym__raw_string_literal_start] = ACTIONS(791),
    [sym_float_literal] = ACTIONS(791),
  },
  [147] = {
    [sym_line_comment] = STATE(147),
    [sym_block_comment] = STATE(147),
    [sym_identifier] = ACTIONS(793),
    [anon_sym_SEMI] = ACTIONS(795),
    [anon_sym_LPAREN] = ACTIONS(795),
    [anon_sym_RPAREN] = ACTIONS(795),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_RBRACK] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(795),
    [anon_sym_RBRACE] = ACTIONS(795),
    [anon_sym_EQ_GT] = ACTIONS(795),
    [anon_sym_COLON] = ACTIONS(793),
    [anon_sym_DOLLAR] = ACTIONS(793),
    [anon_sym_PLUS] = ACTIONS(793),
    [anon_sym_STAR] = ACTIONS(793),
    [anon_sym_QMARK] = ACTIONS(795),
    [anon_sym_u8] = ACTIONS(793),
    [anon_sym_i8] = ACTIONS(793),
    [anon_sym_u16] = ACTIONS(793),
    [anon_sym_i16] = ACTIONS(793),
    [anon_sym_u32] = ACTIONS(793),
    [anon_sym_i32] = ACTIONS(793),
    [anon_sym_u64] = ACTIONS(793),
    [anon_sym_i64] = ACTIONS(793),
    [anon_sym_u128] = ACTIONS(793),
    [anon_sym_i128] = ACTIONS(793),
    [anon_sym_isize] = ACTIONS(793),
    [anon_sym_usize] = ACTIONS(793),
    [anon_sym_f32] = ACTIONS(793),
    [anon_sym_f64] = ACTIONS(793),
    [anon_sym_bool] = ACTIONS(793),
    [anon_sym_str] = ACTIONS(793),
    [anon_sym_char] = ACTIONS(793),
    [anon_sym_DASH] = ACTIONS(793),
    [anon_sym_SLASH] = ACTIONS(793),
    [anon_sym_PERCENT] = ACTIONS(793),
    [anon_sym_CARET] = ACTIONS(793),
    [anon_sym_BANG] = ACTIONS(793),
    [anon_sym_AMP] = ACTIONS(793),
    [anon_sym_PIPE] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(795),
    [anon_sym_PIPE_PIPE] = ACTIONS(795),
    [anon_sym_LT_LT] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(795),
    [anon_sym_DASH_EQ] = ACTIONS(795),
    [anon_sym_STAR_EQ] = ACTIONS(795),
    [anon_sym_SLASH_EQ] = ACTIONS(795),
    [anon_sym_PERCENT_EQ] = ACTIONS(795),
    [anon_sym_CARET_EQ] = ACTIONS(795),
    [anon_sym_AMP_EQ] = ACTIONS(795),
    [anon_sym_PIPE_EQ] = ACTIONS(795),
    [anon_sym_LT_LT_EQ] = ACTIONS(795),
    [anon_sym_GT_GT_EQ] = ACTIONS(795),
    [anon_sym_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(795),
    [anon_sym_BANG_EQ] = ACTIONS(795),
    [anon_sym_GT] = ACTIONS(793),
    [anon_sym_LT] = ACTIONS(793),
    [anon_sym_GT_EQ] = ACTIONS(795),
    [anon_sym_LT_EQ] = ACTIONS(795),
    [anon_sym_AT] = ACTIONS(795),
    [anon_sym__] = ACTIONS(793),
    [anon_sym_DOT] = ACTIONS(793),
    [anon_sym_DOT_DOT] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(795),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(795),
    [anon_sym_COMMA] = ACTIONS(795),
    [anon_sym_COLON_COLON] = ACTIONS(795),
    [anon_sym_DASH_GT] = ACTIONS(795),
    [anon_sym_POUND] = ACTIONS(795),
    [anon_sym_SQUOTE] = ACTIONS(793),
    [anon_sym_as] = ACTIONS(793),
    [anon_sym_async] = ACTIONS(793),
    [anon_sym_await] = ACTIONS(793),
    [anon_sym_break] = ACTIONS(793),
    [anon_sym_const] = ACTIONS(793),
    [anon_sym_continue] = ACTIONS(793),
    [anon_sym_default] = ACTIONS(793),
    [anon_sym_enum] = ACTIONS(793),
    [anon_sym_fn] = ACTIONS(793),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_if] = ACTIONS(793),
    [anon_sym_impl] = ACTIONS(793),
    [anon_sym_let] = ACTIONS(793),
    [anon_sym_loop] = ACTIONS(793),
    [anon_sym_match] = ACTIONS(793),
    [anon_sym_mod] = ACTIONS(793),
    [anon_sym_pub] = ACTIONS(793),
    [anon_sym_return] = ACTIONS(793),
    [anon_sym_static] = ACTIONS(793),
    [anon_sym_struct] = ACTIONS(793),
    [anon_sym_trait] = ACTIONS(793),
    [anon_sym_type] = ACTIONS(793),
    [anon_sym_union] = ACTIONS(793),
    [anon_sym_unsafe] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(793),
    [anon_sym_where] = ACTIONS(793),
    [anon_sym_while] = ACTIONS(793),
    [sym_mutable_specifier] = ACTIONS(793),
    [sym_integer_literal] = ACTIONS(795),
    [aux_sym_string_literal_token1] = ACTIONS(795),
    [sym_char_literal] = ACTIONS(795),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(793),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(793),
    [sym_super] = ACTIONS(793),
    [sym_crate] = ACTIONS(793),
    [sym_metavariable] = ACTIONS(795),
    [sym__raw_string_literal_start] = ACTIONS(795),
    [sym_float_literal] = ACTIONS(795),
  },
  [148] = {
    [sym_line_comment] = STATE(148),
    [sym_block_comment] = STATE(148),
    [aux_sym__non_special_token_repeat1] = STATE(144),
    [sym_identifier] = ACTIONS(797),
    [anon_sym_SEMI] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(799),
    [anon_sym_RPAREN] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(799),
    [anon_sym_RBRACK] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(799),
    [anon_sym_RBRACE] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_COLON] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_QMARK] = ACTIONS(663),
    [anon_sym_u8] = ACTIONS(797),
    [anon_sym_i8] = ACTIONS(797),
    [anon_sym_u16] = ACTIONS(797),
    [anon_sym_i16] = ACTIONS(797),
    [anon_sym_u32] = ACTIONS(797),
    [anon_sym_i32] = ACTIONS(797),
    [anon_sym_u64] = ACTIONS(797),
    [anon_sym_i64] = ACTIONS(797),
    [anon_sym_u128] = ACTIONS(797),
    [anon_sym_i128] = ACTIONS(797),
    [anon_sym_isize] = ACTIONS(797),
    [anon_sym_usize] = ACTIONS(797),
    [anon_sym_f32] = ACTIONS(797),
    [anon_sym_f64] = ACTIONS(797),
    [anon_sym_bool] = ACTIONS(797),
    [anon_sym_str] = ACTIONS(797),
    [anon_sym_char] = ACTIONS(797),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(663),
    [anon_sym_DASH_EQ] = ACTIONS(663),
    [anon_sym_STAR_EQ] = ACTIONS(663),
    [anon_sym_SLASH_EQ] = ACTIONS(663),
    [anon_sym_PERCENT_EQ] = ACTIONS(663),
    [anon_sym_CARET_EQ] = ACTIONS(663),
    [anon_sym_AMP_EQ] = ACTIONS(663),
    [anon_sym_PIPE_EQ] = ACTIONS(663),
    [anon_sym_LT_LT_EQ] = ACTIONS(663),
    [anon_sym_GT_GT_EQ] = ACTIONS(663),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(663),
    [anon_sym_BANG_EQ] = ACTIONS(663),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT_EQ] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym__] = ACTIONS(673),
    [anon_sym_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(663),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(663),
    [anon_sym_SQUOTE] = ACTIONS(797),
    [anon_sym_as] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(797),
    [anon_sym_await] = ACTIONS(797),
    [anon_sym_break] = ACTIONS(797),
    [anon_sym_const] = ACTIONS(797),
    [anon_sym_continue] = ACTIONS(797),
    [anon_sym_default] = ACTIONS(797),
    [anon_sym_enum] = ACTIONS(797),
    [anon_sym_fn] = ACTIONS(797),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_if] = ACTIONS(797),
    [anon_sym_impl] = ACTIONS(797),
    [anon_sym_let] = ACTIONS(797),
    [anon_sym_loop] = ACTIONS(797),
    [anon_sym_match] = ACTIONS(797),
    [anon_sym_mod] = ACTIONS(797),
    [anon_sym_pub] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(797),
    [anon_sym_static] = ACTIONS(797),
    [anon_sym_struct] = ACTIONS(797),
    [anon_sym_trait] = ACTIONS(797),
    [anon_sym_type] = ACTIONS(797),
    [anon_sym_union] = ACTIONS(797),
    [anon_sym_unsafe] = ACTIONS(797),
    [anon_sym_use] = ACTIONS(797),
    [anon_sym_where] = ACTIONS(797),
    [anon_sym_while] = ACTIONS(797),
    [sym_mutable_specifier] = ACTIONS(797),
    [sym_integer_literal] = ACTIONS(799),
    [aux_sym_string_literal_token1] = ACTIONS(799),
    [sym_char_literal] = ACTIONS(799),
    [anon_sym_true] = ACTIONS(797),
    [anon_sym_false] = ACTIONS(797),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(797),
    [sym_super] = ACTIONS(797),
    [sym_crate] = ACTIONS(797),
    [sym__raw_string_literal_start] = ACTIONS(799),
    [sym_float_literal] = ACTIONS(799),
  },
  [149] = {
    [sym_line_comment] = STATE(149),
    [sym_block_comment] = STATE(149),
    [sym_identifier] = ACTIONS(801),
    [anon_sym_SEMI] = ACTIONS(803),
    [anon_sym_LPAREN] = ACTIONS(803),
    [anon_sym_RPAREN] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(803),
    [anon_sym_RBRACK] = ACTIONS(803),
    [anon_sym_LBRACE] = ACTIONS(803),
    [anon_sym_RBRACE] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(803),
    [anon_sym_COLON] = ACTIONS(801),
    [anon_sym_DOLLAR] = ACTIONS(801),
    [anon_sym_PLUS] = ACTIONS(801),
    [anon_sym_STAR] = ACTIONS(801),
    [anon_sym_QMARK] = ACTIONS(803),
    [anon_sym_u8] = ACTIONS(801),
    [anon_sym_i8] = ACTIONS(801),
    [anon_sym_u16] = ACTIONS(801),
    [anon_sym_i16] = ACTIONS(801),
    [anon_sym_u32] = ACTIONS(801),
    [anon_sym_i32] = ACTIONS(801),
    [anon_sym_u64] = ACTIONS(801),
    [anon_sym_i64] = ACTIONS(801),
    [anon_sym_u128] = ACTIONS(801),
    [anon_sym_i128] = ACTIONS(801),
    [anon_sym_isize] = ACTIONS(801),
    [anon_sym_usize] = ACTIONS(801),
    [anon_sym_f32] = ACTIONS(801),
    [anon_sym_f64] = ACTIONS(801),
    [anon_sym_bool] = ACTIONS(801),
    [anon_sym_str] = ACTIONS(801),
    [anon_sym_char] = ACTIONS(801),
    [anon_sym_DASH] = ACTIONS(801),
    [anon_sym_SLASH] = ACTIONS(801),
    [anon_sym_PERCENT] = ACTIONS(801),
    [anon_sym_CARET] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(801),
    [anon_sym_AMP] = ACTIONS(801),
    [anon_sym_PIPE] = ACTIONS(801),
    [anon_sym_AMP_AMP] = ACTIONS(803),
    [anon_sym_PIPE_PIPE] = ACTIONS(803),
    [anon_sym_LT_LT] = ACTIONS(801),
    [anon_sym_GT_GT] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_EQ] = ACTIONS(801),
    [anon_sym_EQ_EQ] = ACTIONS(803),
    [anon_sym_BANG_EQ] = ACTIONS(803),
    [anon_sym_GT] = ACTIONS(801),
    [anon_sym_LT] = ACTIONS(801),
    [anon_sym_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_EQ] = ACTIONS(803),
    [anon_sym_AT] = ACTIONS(803),
    [anon_sym__] = ACTIONS(801),
    [anon_sym_DOT] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(801),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(803),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(803),
    [anon_sym_COMMA] = ACTIONS(803),
    [anon_sym_COLON_COLON] = ACTIONS(803),
    [anon_sym_DASH_GT] = ACTIONS(803),
    [anon_sym_POUND] = ACTIONS(803),
    [anon_sym_SQUOTE] = ACTIONS(801),
    [anon_sym_as] = ACTIONS(801),
    [anon_sym_async] = ACTIONS(801),
    [anon_sym_await] = ACTIONS(801),
    [anon_sym_break] = ACTIONS(801),
    [anon_sym_const] = ACTIONS(801),
    [anon_sym_continue] = ACTIONS(801),
    [anon_sym_default] = ACTIONS(801),
    [anon_sym_enum] = ACTIONS(801),
    [anon_sym_fn] = ACTIONS(801),
    [anon_sym_for] = ACTIONS(801),
    [anon_sym_if] = ACTIONS(801),
    [anon_sym_impl] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_loop] = ACTIONS(801),
    [anon_sym_match] = ACTIONS(801),
    [anon_sym_mod] = ACTIONS(801),
    [anon_sym_pub] = ACTIONS(801),
    [anon_sym_return] = ACTIONS(801),
    [anon_sym_static] = ACTIONS(801),
    [anon_sym_struct] = ACTIONS(801),
    [anon_sym_trait] = ACTIONS(801),
    [anon_sym_type] = ACTIONS(801),
    [anon_sym_union] = ACTIONS(801),
    [anon_sym_unsafe] = ACTIONS(801),
    [anon_sym_use] = ACTIONS(801),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_while] = ACTIONS(801),
    [sym_mutable_specifier] = ACTIONS(801),
    [sym_integer_literal] = ACTIONS(803),
    [aux_sym_string_literal_token1] = ACTIONS(803),
    [sym_char_literal] = ACTIONS(803),
    [anon_sym_true] = ACTIONS(801),
    [anon_sym_false] = ACTIONS(801),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(801),
    [sym_super] = ACTIONS(801),
    [sym_crate] = ACTIONS(801),
    [sym_metavariable] = ACTIONS(803),
    [sym__raw_string_literal_start] = ACTIONS(803),
    [sym_float_literal] = ACTIONS(803),
  },
  [150] = {
    [sym_attribute_item] = STATE(999),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1581),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(150),
    [sym_block_comment] = STATE(150),
    [aux_sym_enum_variant_list_repeat1] = STATE(210),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(805),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(807),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [151] = {
    [sym_line_comment] = STATE(151),
    [sym_block_comment] = STATE(151),
    [sym_identifier] = ACTIONS(809),
    [anon_sym_SEMI] = ACTIONS(811),
    [anon_sym_LPAREN] = ACTIONS(811),
    [anon_sym_RPAREN] = ACTIONS(811),
    [anon_sym_LBRACK] = ACTIONS(811),
    [anon_sym_RBRACK] = ACTIONS(811),
    [anon_sym_LBRACE] = ACTIONS(811),
    [anon_sym_RBRACE] = ACTIONS(811),
    [anon_sym_EQ_GT] = ACTIONS(811),
    [anon_sym_COLON] = ACTIONS(809),
    [anon_sym_DOLLAR] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(809),
    [anon_sym_STAR] = ACTIONS(809),
    [anon_sym_QMARK] = ACTIONS(811),
    [anon_sym_u8] = ACTIONS(809),
    [anon_sym_i8] = ACTIONS(809),
    [anon_sym_u16] = ACTIONS(809),
    [anon_sym_i16] = ACTIONS(809),
    [anon_sym_u32] = ACTIONS(809),
    [anon_sym_i32] = ACTIONS(809),
    [anon_sym_u64] = ACTIONS(809),
    [anon_sym_i64] = ACTIONS(809),
    [anon_sym_u128] = ACTIONS(809),
    [anon_sym_i128] = ACTIONS(809),
    [anon_sym_isize] = ACTIONS(809),
    [anon_sym_usize] = ACTIONS(809),
    [anon_sym_f32] = ACTIONS(809),
    [anon_sym_f64] = ACTIONS(809),
    [anon_sym_bool] = ACTIONS(809),
    [anon_sym_str] = ACTIONS(809),
    [anon_sym_char] = ACTIONS(809),
    [anon_sym_DASH] = ACTIONS(809),
    [anon_sym_SLASH] = ACTIONS(809),
    [anon_sym_PERCENT] = ACTIONS(809),
    [anon_sym_CARET] = ACTIONS(809),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_AMP] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(809),
    [anon_sym_AMP_AMP] = ACTIONS(811),
    [anon_sym_PIPE_PIPE] = ACTIONS(811),
    [anon_sym_LT_LT] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(809),
    [anon_sym_PLUS_EQ] = ACTIONS(811),
    [anon_sym_DASH_EQ] = ACTIONS(811),
    [anon_sym_STAR_EQ] = ACTIONS(811),
    [anon_sym_SLASH_EQ] = ACTIONS(811),
    [anon_sym_PERCENT_EQ] = ACTIONS(811),
    [anon_sym_CARET_EQ] = ACTIONS(811),
    [anon_sym_AMP_EQ] = ACTIONS(811),
    [anon_sym_PIPE_EQ] = ACTIONS(811),
    [anon_sym_LT_LT_EQ] = ACTIONS(811),
    [anon_sym_GT_GT_EQ] = ACTIONS(811),
    [anon_sym_EQ] = ACTIONS(809),
    [anon_sym_EQ_EQ] = ACTIONS(811),
    [anon_sym_BANG_EQ] = ACTIONS(811),
    [anon_sym_GT] = ACTIONS(809),
    [anon_sym_LT] = ACTIONS(809),
    [anon_sym_GT_EQ] = ACTIONS(811),
    [anon_sym_LT_EQ] = ACTIONS(811),
    [anon_sym_AT] = ACTIONS(811),
    [anon_sym__] = ACTIONS(809),
    [anon_sym_DOT] = ACTIONS(809),
    [anon_sym_DOT_DOT] = ACTIONS(809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(811),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(811),
    [anon_sym_COMMA] = ACTIONS(811),
    [anon_sym_COLON_COLON] = ACTIONS(811),
    [anon_sym_DASH_GT] = ACTIONS(811),
    [anon_sym_POUND] = ACTIONS(811),
    [anon_sym_SQUOTE] = ACTIONS(809),
    [anon_sym_as] = ACTIONS(809),
    [anon_sym_async] = ACTIONS(809),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_break] = ACTIONS(809),
    [anon_sym_const] = ACTIONS(809),
    [anon_sym_continue] = ACTIONS(809),
    [anon_sym_default] = ACTIONS(809),
    [anon_sym_enum] = ACTIONS(809),
    [anon_sym_fn] = ACTIONS(809),
    [anon_sym_for] = ACTIONS(809),
    [anon_sym_if] = ACTIONS(809),
    [anon_sym_impl] = ACTIONS(809),
    [anon_sym_let] = ACTIONS(809),
    [anon_sym_loop] = ACTIONS(809),
    [anon_sym_match] = ACTIONS(809),
    [anon_sym_mod] = ACTIONS(809),
    [anon_sym_pub] = ACTIONS(809),
    [anon_sym_return] = ACTIONS(809),
    [anon_sym_static] = ACTIONS(809),
    [anon_sym_struct] = ACTIONS(809),
    [anon_sym_trait] = ACTIONS(809),
    [anon_sym_type] = ACTIONS(809),
    [anon_sym_union] = ACTIONS(809),
    [anon_sym_unsafe] = ACTIONS(809),
    [anon_sym_use] = ACTIONS(809),
    [anon_sym_where] = ACTIONS(809),
    [anon_sym_while] = ACTIONS(809),
    [sym_mutable_specifier] = ACTIONS(809),
    [sym_integer_literal] = ACTIONS(811),
    [aux_sym_string_literal_token1] = ACTIONS(811),
    [sym_char_literal] = ACTIONS(811),
    [anon_sym_true] = ACTIONS(809),
    [anon_sym_false] = ACTIONS(809),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(809),
    [sym_super] = ACTIONS(809),
    [sym_crate] = ACTIONS(809),
    [sym_metavariable] = ACTIONS(811),
    [sym__raw_string_literal_start] = ACTIONS(811),
    [sym_float_literal] = ACTIONS(811),
  },
  [152] = {
    [sym_line_comment] = STATE(152),
    [sym_block_comment] = STATE(152),
    [sym_identifier] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_LPAREN] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_RBRACK] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(741),
    [anon_sym_DOLLAR] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_u8] = ACTIONS(741),
    [anon_sym_i8] = ACTIONS(741),
    [anon_sym_u16] = ACTIONS(741),
    [anon_sym_i16] = ACTIONS(741),
    [anon_sym_u32] = ACTIONS(741),
    [anon_sym_i32] = ACTIONS(741),
    [anon_sym_u64] = ACTIONS(741),
    [anon_sym_i64] = ACTIONS(741),
    [anon_sym_u128] = ACTIONS(741),
    [anon_sym_i128] = ACTIONS(741),
    [anon_sym_isize] = ACTIONS(741),
    [anon_sym_usize] = ACTIONS(741),
    [anon_sym_f32] = ACTIONS(741),
    [anon_sym_f64] = ACTIONS(741),
    [anon_sym_bool] = ACTIONS(741),
    [anon_sym_str] = ACTIONS(741),
    [anon_sym_char] = ACTIONS(741),
    [anon_sym_DASH] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_CARET] = ACTIONS(741),
    [anon_sym_BANG] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(743),
    [anon_sym_AT] = ACTIONS(743),
    [anon_sym__] = ACTIONS(741),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_COLON_COLON] = ACTIONS(743),
    [anon_sym_DASH_GT] = ACTIONS(743),
    [anon_sym_POUND] = ACTIONS(743),
    [anon_sym_SQUOTE] = ACTIONS(741),
    [anon_sym_as] = ACTIONS(741),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_await] = ACTIONS(741),
    [anon_sym_break] = ACTIONS(741),
    [anon_sym_const] = ACTIONS(741),
    [anon_sym_continue] = ACTIONS(741),
    [anon_sym_default] = ACTIONS(741),
    [anon_sym_enum] = ACTIONS(741),
    [anon_sym_fn] = ACTIONS(741),
    [anon_sym_for] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(741),
    [anon_sym_impl] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(741),
    [anon_sym_loop] = ACTIONS(741),
    [anon_sym_match] = ACTIONS(741),
    [anon_sym_mod] = ACTIONS(741),
    [anon_sym_pub] = ACTIONS(741),
    [anon_sym_return] = ACTIONS(741),
    [anon_sym_static] = ACTIONS(741),
    [anon_sym_struct] = ACTIONS(741),
    [anon_sym_trait] = ACTIONS(741),
    [anon_sym_type] = ACTIONS(741),
    [anon_sym_union] = ACTIONS(741),
    [anon_sym_unsafe] = ACTIONS(741),
    [anon_sym_use] = ACTIONS(741),
    [anon_sym_where] = ACTIONS(741),
    [anon_sym_while] = ACTIONS(741),
    [sym_mutable_specifier] = ACTIONS(741),
    [sym_integer_literal] = ACTIONS(743),
    [aux_sym_string_literal_token1] = ACTIONS(743),
    [sym_char_literal] = ACTIONS(743),
    [anon_sym_true] = ACTIONS(741),
    [anon_sym_false] = ACTIONS(741),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(741),
    [sym_super] = ACTIONS(741),
    [sym_crate] = ACTIONS(741),
    [sym_metavariable] = ACTIONS(743),
    [sym__raw_string_literal_start] = ACTIONS(743),
    [sym_float_literal] = ACTIONS(743),
  },
  [153] = {
    [sym_line_comment] = STATE(153),
    [sym_block_comment] = STATE(153),
    [sym_identifier] = ACTIONS(813),
    [anon_sym_SEMI] = ACTIONS(815),
    [anon_sym_LPAREN] = ACTIONS(815),
    [anon_sym_RPAREN] = ACTIONS(815),
    [anon_sym_LBRACK] = ACTIONS(815),
    [anon_sym_RBRACK] = ACTIONS(815),
    [anon_sym_LBRACE] = ACTIONS(815),
    [anon_sym_RBRACE] = ACTIONS(815),
    [anon_sym_EQ_GT] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(813),
    [anon_sym_DOLLAR] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_STAR] = ACTIONS(813),
    [anon_sym_QMARK] = ACTIONS(815),
    [anon_sym_u8] = ACTIONS(813),
    [anon_sym_i8] = ACTIONS(813),
    [anon_sym_u16] = ACTIONS(813),
    [anon_sym_i16] = ACTIONS(813),
    [anon_sym_u32] = ACTIONS(813),
    [anon_sym_i32] = ACTIONS(813),
    [anon_sym_u64] = ACTIONS(813),
    [anon_sym_i64] = ACTIONS(813),
    [anon_sym_u128] = ACTIONS(813),
    [anon_sym_i128] = ACTIONS(813),
    [anon_sym_isize] = ACTIONS(813),
    [anon_sym_usize] = ACTIONS(813),
    [anon_sym_f32] = ACTIONS(813),
    [anon_sym_f64] = ACTIONS(813),
    [anon_sym_bool] = ACTIONS(813),
    [anon_sym_str] = ACTIONS(813),
    [anon_sym_char] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_AMP_AMP] = ACTIONS(815),
    [anon_sym_PIPE_PIPE] = ACTIONS(815),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_PLUS_EQ] = ACTIONS(815),
    [anon_sym_DASH_EQ] = ACTIONS(815),
    [anon_sym_STAR_EQ] = ACTIONS(815),
    [anon_sym_SLASH_EQ] = ACTIONS(815),
    [anon_sym_PERCENT_EQ] = ACTIONS(815),
    [anon_sym_CARET_EQ] = ACTIONS(815),
    [anon_sym_AMP_EQ] = ACTIONS(815),
    [anon_sym_PIPE_EQ] = ACTIONS(815),
    [anon_sym_LT_LT_EQ] = ACTIONS(815),
    [anon_sym_GT_GT_EQ] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(815),
    [anon_sym_BANG_EQ] = ACTIONS(815),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(815),
    [anon_sym_LT_EQ] = ACTIONS(815),
    [anon_sym_AT] = ACTIONS(815),
    [anon_sym__] = ACTIONS(813),
    [anon_sym_DOT] = ACTIONS(813),
    [anon_sym_DOT_DOT] = ACTIONS(813),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(815),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(815),
    [anon_sym_COMMA] = ACTIONS(815),
    [anon_sym_COLON_COLON] = ACTIONS(815),
    [anon_sym_DASH_GT] = ACTIONS(815),
    [anon_sym_POUND] = ACTIONS(815),
    [anon_sym_SQUOTE] = ACTIONS(813),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_async] = ACTIONS(813),
    [anon_sym_await] = ACTIONS(813),
    [anon_sym_break] = ACTIONS(813),
    [anon_sym_const] = ACTIONS(813),
    [anon_sym_continue] = ACTIONS(813),
    [anon_sym_default] = ACTIONS(813),
    [anon_sym_enum] = ACTIONS(813),
    [anon_sym_fn] = ACTIONS(813),
    [anon_sym_for] = ACTIONS(813),
    [anon_sym_if] = ACTIONS(813),
    [anon_sym_impl] = ACTIONS(813),
    [anon_sym_let] = ACTIONS(813),
    [anon_sym_loop] = ACTIONS(813),
    [anon_sym_match] = ACTIONS(813),
    [anon_sym_mod] = ACTIONS(813),
    [anon_sym_pub] = ACTIONS(813),
    [anon_sym_return] = ACTIONS(813),
    [anon_sym_static] = ACTIONS(813),
    [anon_sym_struct] = ACTIONS(813),
    [anon_sym_trait] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(813),
    [anon_sym_union] = ACTIONS(813),
    [anon_sym_unsafe] = ACTIONS(813),
    [anon_sym_use] = ACTIONS(813),
    [anon_sym_where] = ACTIONS(813),
    [anon_sym_while] = ACTIONS(813),
    [sym_mutable_specifier] = ACTIONS(813),
    [sym_integer_literal] = ACTIONS(815),
    [aux_sym_string_literal_token1] = ACTIONS(815),
    [sym_char_literal] = ACTIONS(815),
    [anon_sym_true] = ACTIONS(813),
    [anon_sym_false] = ACTIONS(813),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(813),
    [sym_super] = ACTIONS(813),
    [sym_crate] = ACTIONS(813),
    [sym_metavariable] = ACTIONS(815),
    [sym__raw_string_literal_start] = ACTIONS(815),
    [sym_float_literal] = ACTIONS(815),
  },
  [154] = {
    [sym_attribute_item] = STATE(999),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1570),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(154),
    [sym_block_comment] = STATE(154),
    [aux_sym_enum_variant_list_repeat1] = STATE(998),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LPAREN] = ACTIONS(820),
    [anon_sym_LBRACK] = ACTIONS(823),
    [anon_sym_RBRACK] = ACTIONS(826),
    [anon_sym_LBRACE] = ACTIONS(828),
    [anon_sym_STAR] = ACTIONS(831),
    [anon_sym_u8] = ACTIONS(834),
    [anon_sym_i8] = ACTIONS(834),
    [anon_sym_u16] = ACTIONS(834),
    [anon_sym_i16] = ACTIONS(834),
    [anon_sym_u32] = ACTIONS(834),
    [anon_sym_i32] = ACTIONS(834),
    [anon_sym_u64] = ACTIONS(834),
    [anon_sym_i64] = ACTIONS(834),
    [anon_sym_u128] = ACTIONS(834),
    [anon_sym_i128] = ACTIONS(834),
    [anon_sym_isize] = ACTIONS(834),
    [anon_sym_usize] = ACTIONS(834),
    [anon_sym_f32] = ACTIONS(834),
    [anon_sym_f64] = ACTIONS(834),
    [anon_sym_bool] = ACTIONS(834),
    [anon_sym_str] = ACTIONS(834),
    [anon_sym_char] = ACTIONS(834),
    [anon_sym_DASH] = ACTIONS(831),
    [anon_sym_BANG] = ACTIONS(831),
    [anon_sym_AMP] = ACTIONS(837),
    [anon_sym_PIPE] = ACTIONS(840),
    [anon_sym_LT] = ACTIONS(843),
    [anon_sym_DOT_DOT] = ACTIONS(846),
    [anon_sym_COMMA] = ACTIONS(826),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_POUND] = ACTIONS(852),
    [anon_sym_SQUOTE] = ACTIONS(855),
    [anon_sym_async] = ACTIONS(858),
    [anon_sym_break] = ACTIONS(861),
    [anon_sym_const] = ACTIONS(864),
    [anon_sym_continue] = ACTIONS(867),
    [anon_sym_default] = ACTIONS(870),
    [anon_sym_for] = ACTIONS(873),
    [anon_sym_if] = ACTIONS(876),
    [anon_sym_loop] = ACTIONS(879),
    [anon_sym_match] = ACTIONS(882),
    [anon_sym_return] = ACTIONS(885),
    [anon_sym_static] = ACTIONS(888),
    [anon_sym_union] = ACTIONS(870),
    [anon_sym_unsafe] = ACTIONS(891),
    [anon_sym_while] = ACTIONS(894),
    [anon_sym_yield] = ACTIONS(897),
    [anon_sym_move] = ACTIONS(900),
    [anon_sym_try] = ACTIONS(903),
    [sym_integer_literal] = ACTIONS(906),
    [aux_sym_string_literal_token1] = ACTIONS(909),
    [sym_char_literal] = ACTIONS(906),
    [anon_sym_true] = ACTIONS(912),
    [anon_sym_false] = ACTIONS(912),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(915),
    [sym_super] = ACTIONS(918),
    [sym_crate] = ACTIONS(918),
    [sym_metavariable] = ACTIONS(921),
    [sym__raw_string_literal_start] = ACTIONS(924),
    [sym_float_literal] = ACTIONS(906),
  },
  [155] = {
    [sym_line_comment] = STATE(155),
    [sym_block_comment] = STATE(155),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_SEMI] = ACTIONS(929),
    [anon_sym_LPAREN] = ACTIONS(929),
    [anon_sym_RPAREN] = ACTIONS(929),
    [anon_sym_LBRACK] = ACTIONS(929),
    [anon_sym_RBRACK] = ACTIONS(929),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_RBRACE] = ACTIONS(929),
    [anon_sym_EQ_GT] = ACTIONS(929),
    [anon_sym_COLON] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(927),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_STAR] = ACTIONS(927),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_u8] = ACTIONS(927),
    [anon_sym_i8] = ACTIONS(927),
    [anon_sym_u16] = ACTIONS(927),
    [anon_sym_i16] = ACTIONS(927),
    [anon_sym_u32] = ACTIONS(927),
    [anon_sym_i32] = ACTIONS(927),
    [anon_sym_u64] = ACTIONS(927),
    [anon_sym_i64] = ACTIONS(927),
    [anon_sym_u128] = ACTIONS(927),
    [anon_sym_i128] = ACTIONS(927),
    [anon_sym_isize] = ACTIONS(927),
    [anon_sym_usize] = ACTIONS(927),
    [anon_sym_f32] = ACTIONS(927),
    [anon_sym_f64] = ACTIONS(927),
    [anon_sym_bool] = ACTIONS(927),
    [anon_sym_str] = ACTIONS(927),
    [anon_sym_char] = ACTIONS(927),
    [anon_sym_DASH] = ACTIONS(927),
    [anon_sym_SLASH] = ACTIONS(927),
    [anon_sym_PERCENT] = ACTIONS(927),
    [anon_sym_CARET] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(927),
    [anon_sym_AMP] = ACTIONS(927),
    [anon_sym_PIPE] = ACTIONS(927),
    [anon_sym_AMP_AMP] = ACTIONS(929),
    [anon_sym_PIPE_PIPE] = ACTIONS(929),
    [anon_sym_LT_LT] = ACTIONS(927),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_PLUS_EQ] = ACTIONS(929),
    [anon_sym_DASH_EQ] = ACTIONS(929),
    [anon_sym_STAR_EQ] = ACTIONS(929),
    [anon_sym_SLASH_EQ] = ACTIONS(929),
    [anon_sym_PERCENT_EQ] = ACTIONS(929),
    [anon_sym_CARET_EQ] = ACTIONS(929),
    [anon_sym_AMP_EQ] = ACTIONS(929),
    [anon_sym_PIPE_EQ] = ACTIONS(929),
    [anon_sym_LT_LT_EQ] = ACTIONS(929),
    [anon_sym_GT_GT_EQ] = ACTIONS(929),
    [anon_sym_EQ] = ACTIONS(927),
    [anon_sym_EQ_EQ] = ACTIONS(929),
    [anon_sym_BANG_EQ] = ACTIONS(929),
    [anon_sym_GT] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(927),
    [anon_sym_GT_EQ] = ACTIONS(929),
    [anon_sym_LT_EQ] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym__] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(927),
    [anon_sym_DOT_DOT] = ACTIONS(927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(929),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(929),
    [anon_sym_COMMA] = ACTIONS(929),
    [anon_sym_COLON_COLON] = ACTIONS(929),
    [anon_sym_DASH_GT] = ACTIONS(929),
    [anon_sym_POUND] = ACTIONS(929),
    [anon_sym_SQUOTE] = ACTIONS(927),
    [anon_sym_as] = ACTIONS(927),
    [anon_sym_async] = ACTIONS(927),
    [anon_sym_await] = ACTIONS(927),
    [anon_sym_break] = ACTIONS(927),
    [anon_sym_const] = ACTIONS(927),
    [anon_sym_continue] = ACTIONS(927),
    [anon_sym_default] = ACTIONS(927),
    [anon_sym_enum] = ACTIONS(927),
    [anon_sym_fn] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(927),
    [anon_sym_if] = ACTIONS(927),
    [anon_sym_impl] = ACTIONS(927),
    [anon_sym_let] = ACTIONS(927),
    [anon_sym_loop] = ACTIONS(927),
    [anon_sym_match] = ACTIONS(927),
    [anon_sym_mod] = ACTIONS(927),
    [anon_sym_pub] = ACTIONS(927),
    [anon_sym_return] = ACTIONS(927),
    [anon_sym_static] = ACTIONS(927),
    [anon_sym_struct] = ACTIONS(927),
    [anon_sym_trait] = ACTIONS(927),
    [anon_sym_type] = ACTIONS(927),
    [anon_sym_union] = ACTIONS(927),
    [anon_sym_unsafe] = ACTIONS(927),
    [anon_sym_use] = ACTIONS(927),
    [anon_sym_where] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(927),
    [sym_mutable_specifier] = ACTIONS(927),
    [sym_integer_literal] = ACTIONS(929),
    [aux_sym_string_literal_token1] = ACTIONS(929),
    [sym_char_literal] = ACTIONS(929),
    [anon_sym_true] = ACTIONS(927),
    [anon_sym_false] = ACTIONS(927),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(927),
    [sym_super] = ACTIONS(927),
    [sym_crate] = ACTIONS(927),
    [sym_metavariable] = ACTIONS(929),
    [sym__raw_string_literal_start] = ACTIONS(929),
    [sym_float_literal] = ACTIONS(929),
  },
  [156] = {
    [sym_attribute_item] = STATE(999),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1556),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(156),
    [sym_block_comment] = STATE(156),
    [aux_sym_enum_variant_list_repeat1] = STATE(154),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(933),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [157] = {
    [sym_line_comment] = STATE(157),
    [sym_block_comment] = STATE(157),
    [sym_identifier] = ACTIONS(935),
    [anon_sym_SEMI] = ACTIONS(937),
    [anon_sym_LPAREN] = ACTIONS(937),
    [anon_sym_RPAREN] = ACTIONS(937),
    [anon_sym_LBRACK] = ACTIONS(937),
    [anon_sym_RBRACK] = ACTIONS(937),
    [anon_sym_LBRACE] = ACTIONS(937),
    [anon_sym_RBRACE] = ACTIONS(937),
    [anon_sym_EQ_GT] = ACTIONS(937),
    [anon_sym_COLON] = ACTIONS(935),
    [anon_sym_DOLLAR] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_STAR] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(937),
    [anon_sym_u8] = ACTIONS(935),
    [anon_sym_i8] = ACTIONS(935),
    [anon_sym_u16] = ACTIONS(935),
    [anon_sym_i16] = ACTIONS(935),
    [anon_sym_u32] = ACTIONS(935),
    [anon_sym_i32] = ACTIONS(935),
    [anon_sym_u64] = ACTIONS(935),
    [anon_sym_i64] = ACTIONS(935),
    [anon_sym_u128] = ACTIONS(935),
    [anon_sym_i128] = ACTIONS(935),
    [anon_sym_isize] = ACTIONS(935),
    [anon_sym_usize] = ACTIONS(935),
    [anon_sym_f32] = ACTIONS(935),
    [anon_sym_f64] = ACTIONS(935),
    [anon_sym_bool] = ACTIONS(935),
    [anon_sym_str] = ACTIONS(935),
    [anon_sym_char] = ACTIONS(935),
    [anon_sym_DASH] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_BANG] = ACTIONS(935),
    [anon_sym_AMP] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(937),
    [anon_sym_DASH_EQ] = ACTIONS(937),
    [anon_sym_STAR_EQ] = ACTIONS(937),
    [anon_sym_SLASH_EQ] = ACTIONS(937),
    [anon_sym_PERCENT_EQ] = ACTIONS(937),
    [anon_sym_CARET_EQ] = ACTIONS(937),
    [anon_sym_AMP_EQ] = ACTIONS(937),
    [anon_sym_PIPE_EQ] = ACTIONS(937),
    [anon_sym_LT_LT_EQ] = ACTIONS(937),
    [anon_sym_GT_GT_EQ] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(935),
    [anon_sym_LT] = ACTIONS(935),
    [anon_sym_GT_EQ] = ACTIONS(937),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_AT] = ACTIONS(937),
    [anon_sym__] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(935),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(937),
    [anon_sym_COLON_COLON] = ACTIONS(937),
    [anon_sym_DASH_GT] = ACTIONS(937),
    [anon_sym_POUND] = ACTIONS(937),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_as] = ACTIONS(935),
    [anon_sym_async] = ACTIONS(935),
    [anon_sym_await] = ACTIONS(935),
    [anon_sym_break] = ACTIONS(935),
    [anon_sym_const] = ACTIONS(935),
    [anon_sym_continue] = ACTIONS(935),
    [anon_sym_default] = ACTIONS(935),
    [anon_sym_enum] = ACTIONS(935),
    [anon_sym_fn] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_impl] = ACTIONS(935),
    [anon_sym_let] = ACTIONS(935),
    [anon_sym_loop] = ACTIONS(935),
    [anon_sym_match] = ACTIONS(935),
    [anon_sym_mod] = ACTIONS(935),
    [anon_sym_pub] = ACTIONS(935),
    [anon_sym_return] = ACTIONS(935),
    [anon_sym_static] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(935),
    [anon_sym_trait] = ACTIONS(935),
    [anon_sym_type] = ACTIONS(935),
    [anon_sym_union] = ACTIONS(935),
    [anon_sym_unsafe] = ACTIONS(935),
    [anon_sym_use] = ACTIONS(935),
    [anon_sym_where] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [sym_mutable_specifier] = ACTIONS(935),
    [sym_integer_literal] = ACTIONS(937),
    [aux_sym_string_literal_token1] = ACTIONS(937),
    [sym_char_literal] = ACTIONS(937),
    [anon_sym_true] = ACTIONS(935),
    [anon_sym_false] = ACTIONS(935),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(935),
    [sym_super] = ACTIONS(935),
    [sym_crate] = ACTIONS(935),
    [sym_metavariable] = ACTIONS(937),
    [sym__raw_string_literal_start] = ACTIONS(937),
    [sym_float_literal] = ACTIONS(937),
  },
  [158] = {
    [sym_attribute_item] = STATE(999),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1584),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(158),
    [sym_block_comment] = STATE(158),
    [aux_sym_enum_variant_list_repeat1] = STATE(998),
    [sym_identifier] = ACTIONS(817),
    [anon_sym_LPAREN] = ACTIONS(820),
    [anon_sym_LBRACK] = ACTIONS(823),
    [anon_sym_RBRACK] = ACTIONS(826),
    [anon_sym_LBRACE] = ACTIONS(828),
    [anon_sym_STAR] = ACTIONS(831),
    [anon_sym_u8] = ACTIONS(834),
    [anon_sym_i8] = ACTIONS(834),
    [anon_sym_u16] = ACTIONS(834),
    [anon_sym_i16] = ACTIONS(834),
    [anon_sym_u32] = ACTIONS(834),
    [anon_sym_i32] = ACTIONS(834),
    [anon_sym_u64] = ACTIONS(834),
    [anon_sym_i64] = ACTIONS(834),
    [anon_sym_u128] = ACTIONS(834),
    [anon_sym_i128] = ACTIONS(834),
    [anon_sym_isize] = ACTIONS(834),
    [anon_sym_usize] = ACTIONS(834),
    [anon_sym_f32] = ACTIONS(834),
    [anon_sym_f64] = ACTIONS(834),
    [anon_sym_bool] = ACTIONS(834),
    [anon_sym_str] = ACTIONS(834),
    [anon_sym_char] = ACTIONS(834),
    [anon_sym_DASH] = ACTIONS(831),
    [anon_sym_BANG] = ACTIONS(831),
    [anon_sym_AMP] = ACTIONS(837),
    [anon_sym_PIPE] = ACTIONS(840),
    [anon_sym_LT] = ACTIONS(843),
    [anon_sym_DOT_DOT] = ACTIONS(846),
    [anon_sym_COMMA] = ACTIONS(826),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_POUND] = ACTIONS(852),
    [anon_sym_SQUOTE] = ACTIONS(855),
    [anon_sym_async] = ACTIONS(858),
    [anon_sym_break] = ACTIONS(861),
    [anon_sym_const] = ACTIONS(864),
    [anon_sym_continue] = ACTIONS(867),
    [anon_sym_default] = ACTIONS(870),
    [anon_sym_for] = ACTIONS(873),
    [anon_sym_if] = ACTIONS(876),
    [anon_sym_loop] = ACTIONS(879),
    [anon_sym_match] = ACTIONS(882),
    [anon_sym_return] = ACTIONS(885),
    [anon_sym_static] = ACTIONS(888),
    [anon_sym_union] = ACTIONS(870),
    [anon_sym_unsafe] = ACTIONS(891),
    [anon_sym_while] = ACTIONS(894),
    [anon_sym_yield] = ACTIONS(897),
    [anon_sym_move] = ACTIONS(900),
    [anon_sym_try] = ACTIONS(903),
    [sym_integer_literal] = ACTIONS(906),
    [aux_sym_string_literal_token1] = ACTIONS(909),
    [sym_char_literal] = ACTIONS(906),
    [anon_sym_true] = ACTIONS(912),
    [anon_sym_false] = ACTIONS(912),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(915),
    [sym_super] = ACTIONS(918),
    [sym_crate] = ACTIONS(918),
    [sym_metavariable] = ACTIONS(921),
    [sym__raw_string_literal_start] = ACTIONS(924),
    [sym_float_literal] = ACTIONS(906),
  },
  [159] = {
    [sym_line_comment] = STATE(159),
    [sym_block_comment] = STATE(159),
    [sym_identifier] = ACTIONS(939),
    [anon_sym_SEMI] = ACTIONS(941),
    [anon_sym_LPAREN] = ACTIONS(941),
    [anon_sym_RPAREN] = ACTIONS(941),
    [anon_sym_LBRACK] = ACTIONS(941),
    [anon_sym_RBRACK] = ACTIONS(941),
    [anon_sym_LBRACE] = ACTIONS(941),
    [anon_sym_RBRACE] = ACTIONS(941),
    [anon_sym_EQ_GT] = ACTIONS(941),
    [anon_sym_COLON] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_STAR] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(941),
    [anon_sym_u8] = ACTIONS(939),
    [anon_sym_i8] = ACTIONS(939),
    [anon_sym_u16] = ACTIONS(939),
    [anon_sym_i16] = ACTIONS(939),
    [anon_sym_u32] = ACTIONS(939),
    [anon_sym_i32] = ACTIONS(939),
    [anon_sym_u64] = ACTIONS(939),
    [anon_sym_i64] = ACTIONS(939),
    [anon_sym_u128] = ACTIONS(939),
    [anon_sym_i128] = ACTIONS(939),
    [anon_sym_isize] = ACTIONS(939),
    [anon_sym_usize] = ACTIONS(939),
    [anon_sym_f32] = ACTIONS(939),
    [anon_sym_f64] = ACTIONS(939),
    [anon_sym_bool] = ACTIONS(939),
    [anon_sym_str] = ACTIONS(939),
    [anon_sym_char] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_BANG] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(941),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_PLUS_EQ] = ACTIONS(941),
    [anon_sym_DASH_EQ] = ACTIONS(941),
    [anon_sym_STAR_EQ] = ACTIONS(941),
    [anon_sym_SLASH_EQ] = ACTIONS(941),
    [anon_sym_PERCENT_EQ] = ACTIONS(941),
    [anon_sym_CARET_EQ] = ACTIONS(941),
    [anon_sym_AMP_EQ] = ACTIONS(941),
    [anon_sym_PIPE_EQ] = ACTIONS(941),
    [anon_sym_LT_LT_EQ] = ACTIONS(941),
    [anon_sym_GT_GT_EQ] = ACTIONS(941),
    [anon_sym_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_GT_EQ] = ACTIONS(941),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_AT] = ACTIONS(941),
    [anon_sym__] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(939),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(941),
    [anon_sym_COLON_COLON] = ACTIONS(941),
    [anon_sym_DASH_GT] = ACTIONS(941),
    [anon_sym_POUND] = ACTIONS(941),
    [anon_sym_SQUOTE] = ACTIONS(939),
    [anon_sym_as] = ACTIONS(939),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_await] = ACTIONS(939),
    [anon_sym_break] = ACTIONS(939),
    [anon_sym_const] = ACTIONS(939),
    [anon_sym_continue] = ACTIONS(939),
    [anon_sym_default] = ACTIONS(939),
    [anon_sym_enum] = ACTIONS(939),
    [anon_sym_fn] = ACTIONS(939),
    [anon_sym_for] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_impl] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(939),
    [anon_sym_loop] = ACTIONS(939),
    [anon_sym_match] = ACTIONS(939),
    [anon_sym_mod] = ACTIONS(939),
    [anon_sym_pub] = ACTIONS(939),
    [anon_sym_return] = ACTIONS(939),
    [anon_sym_static] = ACTIONS(939),
    [anon_sym_struct] = ACTIONS(939),
    [anon_sym_trait] = ACTIONS(939),
    [anon_sym_type] = ACTIONS(939),
    [anon_sym_union] = ACTIONS(939),
    [anon_sym_unsafe] = ACTIONS(939),
    [anon_sym_use] = ACTIONS(939),
    [anon_sym_where] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [sym_mutable_specifier] = ACTIONS(939),
    [sym_integer_literal] = ACTIONS(941),
    [aux_sym_string_literal_token1] = ACTIONS(941),
    [sym_char_literal] = ACTIONS(941),
    [anon_sym_true] = ACTIONS(939),
    [anon_sym_false] = ACTIONS(939),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(939),
    [sym_super] = ACTIONS(939),
    [sym_crate] = ACTIONS(939),
    [sym_metavariable] = ACTIONS(941),
    [sym__raw_string_literal_start] = ACTIONS(941),
    [sym_float_literal] = ACTIONS(941),
  },
  [160] = {
    [sym_line_comment] = STATE(160),
    [sym_block_comment] = STATE(160),
    [sym_identifier] = ACTIONS(745),
    [anon_sym_SEMI] = ACTIONS(747),
    [anon_sym_LPAREN] = ACTIONS(747),
    [anon_sym_RPAREN] = ACTIONS(747),
    [anon_sym_LBRACK] = ACTIONS(747),
    [anon_sym_RBRACK] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_RBRACE] = ACTIONS(747),
    [anon_sym_EQ_GT] = ACTIONS(747),
    [anon_sym_COLON] = ACTIONS(943),
    [anon_sym_DOLLAR] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(747),
    [anon_sym_u8] = ACTIONS(745),
    [anon_sym_i8] = ACTIONS(745),
    [anon_sym_u16] = ACTIONS(745),
    [anon_sym_i16] = ACTIONS(745),
    [anon_sym_u32] = ACTIONS(745),
    [anon_sym_i32] = ACTIONS(745),
    [anon_sym_u64] = ACTIONS(745),
    [anon_sym_i64] = ACTIONS(745),
    [anon_sym_u128] = ACTIONS(745),
    [anon_sym_i128] = ACTIONS(745),
    [anon_sym_isize] = ACTIONS(745),
    [anon_sym_usize] = ACTIONS(745),
    [anon_sym_f32] = ACTIONS(745),
    [anon_sym_f64] = ACTIONS(745),
    [anon_sym_bool] = ACTIONS(745),
    [anon_sym_str] = ACTIONS(745),
    [anon_sym_char] = ACTIONS(745),
    [anon_sym_DASH] = ACTIONS(745),
    [anon_sym_SLASH] = ACTIONS(745),
    [anon_sym_PERCENT] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(745),
    [anon_sym_BANG] = ACTIONS(745),
    [anon_sym_AMP] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(745),
    [anon_sym_AMP_AMP] = ACTIONS(747),
    [anon_sym_PIPE_PIPE] = ACTIONS(747),
    [anon_sym_LT_LT] = ACTIONS(745),
    [anon_sym_GT_GT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(747),
    [anon_sym_DASH_EQ] = ACTIONS(747),
    [anon_sym_STAR_EQ] = ACTIONS(747),
    [anon_sym_SLASH_EQ] = ACTIONS(747),
    [anon_sym_PERCENT_EQ] = ACTIONS(747),
    [anon_sym_CARET_EQ] = ACTIONS(747),
    [anon_sym_AMP_EQ] = ACTIONS(747),
    [anon_sym_PIPE_EQ] = ACTIONS(747),
    [anon_sym_LT_LT_EQ] = ACTIONS(747),
    [anon_sym_GT_GT_EQ] = ACTIONS(747),
    [anon_sym_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ] = ACTIONS(747),
    [anon_sym_BANG_EQ] = ACTIONS(747),
    [anon_sym_GT] = ACTIONS(745),
    [anon_sym_LT] = ACTIONS(745),
    [anon_sym_GT_EQ] = ACTIONS(747),
    [anon_sym_LT_EQ] = ACTIONS(747),
    [anon_sym_AT] = ACTIONS(747),
    [anon_sym__] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(747),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(747),
    [anon_sym_COMMA] = ACTIONS(747),
    [anon_sym_COLON_COLON] = ACTIONS(747),
    [anon_sym_DASH_GT] = ACTIONS(747),
    [anon_sym_POUND] = ACTIONS(747),
    [anon_sym_SQUOTE] = ACTIONS(745),
    [anon_sym_as] = ACTIONS(745),
    [anon_sym_async] = ACTIONS(745),
    [anon_sym_await] = ACTIONS(745),
    [anon_sym_break] = ACTIONS(745),
    [anon_sym_const] = ACTIONS(745),
    [anon_sym_continue] = ACTIONS(745),
    [anon_sym_default] = ACTIONS(745),
    [anon_sym_enum] = ACTIONS(745),
    [anon_sym_fn] = ACTIONS(745),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_if] = ACTIONS(745),
    [anon_sym_impl] = ACTIONS(745),
    [anon_sym_let] = ACTIONS(745),
    [anon_sym_loop] = ACTIONS(745),
    [anon_sym_match] = ACTIONS(745),
    [anon_sym_mod] = ACTIONS(745),
    [anon_sym_pub] = ACTIONS(745),
    [anon_sym_return] = ACTIONS(745),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_struct] = ACTIONS(745),
    [anon_sym_trait] = ACTIONS(745),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_union] = ACTIONS(745),
    [anon_sym_unsafe] = ACTIONS(745),
    [anon_sym_use] = ACTIONS(745),
    [anon_sym_where] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(745),
    [sym_mutable_specifier] = ACTIONS(745),
    [sym_integer_literal] = ACTIONS(747),
    [aux_sym_string_literal_token1] = ACTIONS(747),
    [sym_char_literal] = ACTIONS(747),
    [anon_sym_true] = ACTIONS(745),
    [anon_sym_false] = ACTIONS(745),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(745),
    [sym_super] = ACTIONS(745),
    [sym_crate] = ACTIONS(745),
    [sym_metavariable] = ACTIONS(747),
    [sym__raw_string_literal_start] = ACTIONS(747),
    [sym_float_literal] = ACTIONS(747),
  },
  [161] = {
    [sym_line_comment] = STATE(161),
    [sym_block_comment] = STATE(161),
    [sym_identifier] = ACTIONS(945),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(947),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(947),
    [anon_sym_RBRACK] = ACTIONS(947),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_RBRACE] = ACTIONS(947),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_COLON] = ACTIONS(945),
    [anon_sym_DOLLAR] = ACTIONS(945),
    [anon_sym_PLUS] = ACTIONS(945),
    [anon_sym_STAR] = ACTIONS(945),
    [anon_sym_QMARK] = ACTIONS(947),
    [anon_sym_u8] = ACTIONS(945),
    [anon_sym_i8] = ACTIONS(945),
    [anon_sym_u16] = ACTIONS(945),
    [anon_sym_i16] = ACTIONS(945),
    [anon_sym_u32] = ACTIONS(945),
    [anon_sym_i32] = ACTIONS(945),
    [anon_sym_u64] = ACTIONS(945),
    [anon_sym_i64] = ACTIONS(945),
    [anon_sym_u128] = ACTIONS(945),
    [anon_sym_i128] = ACTIONS(945),
    [anon_sym_isize] = ACTIONS(945),
    [anon_sym_usize] = ACTIONS(945),
    [anon_sym_f32] = ACTIONS(945),
    [anon_sym_f64] = ACTIONS(945),
    [anon_sym_bool] = ACTIONS(945),
    [anon_sym_str] = ACTIONS(945),
    [anon_sym_char] = ACTIONS(945),
    [anon_sym_DASH] = ACTIONS(945),
    [anon_sym_SLASH] = ACTIONS(945),
    [anon_sym_PERCENT] = ACTIONS(945),
    [anon_sym_CARET] = ACTIONS(945),
    [anon_sym_BANG] = ACTIONS(945),
    [anon_sym_AMP] = ACTIONS(945),
    [anon_sym_PIPE] = ACTIONS(945),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(945),
    [anon_sym_GT_GT] = ACTIONS(945),
    [anon_sym_PLUS_EQ] = ACTIONS(947),
    [anon_sym_DASH_EQ] = ACTIONS(947),
    [anon_sym_STAR_EQ] = ACTIONS(947),
    [anon_sym_SLASH_EQ] = ACTIONS(947),
    [anon_sym_PERCENT_EQ] = ACTIONS(947),
    [anon_sym_CARET_EQ] = ACTIONS(947),
    [anon_sym_AMP_EQ] = ACTIONS(947),
    [anon_sym_PIPE_EQ] = ACTIONS(947),
    [anon_sym_LT_LT_EQ] = ACTIONS(947),
    [anon_sym_GT_GT_EQ] = ACTIONS(947),
    [anon_sym_EQ] = ACTIONS(945),
    [anon_sym_EQ_EQ] = ACTIONS(947),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_GT] = ACTIONS(945),
    [anon_sym_LT] = ACTIONS(945),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(947),
    [anon_sym_AT] = ACTIONS(947),
    [anon_sym__] = ACTIONS(945),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_DOT_DOT] = ACTIONS(945),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(947),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(947),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_COLON_COLON] = ACTIONS(947),
    [anon_sym_DASH_GT] = ACTIONS(947),
    [anon_sym_POUND] = ACTIONS(947),
    [anon_sym_SQUOTE] = ACTIONS(945),
    [anon_sym_as] = ACTIONS(945),
    [anon_sym_async] = ACTIONS(945),
    [anon_sym_await] = ACTIONS(945),
    [anon_sym_break] = ACTIONS(945),
    [anon_sym_const] = ACTIONS(945),
    [anon_sym_continue] = ACTIONS(945),
    [anon_sym_default] = ACTIONS(945),
    [anon_sym_enum] = ACTIONS(945),
    [anon_sym_fn] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(945),
    [anon_sym_impl] = ACTIONS(945),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_loop] = ACTIONS(945),
    [anon_sym_match] = ACTIONS(945),
    [anon_sym_mod] = ACTIONS(945),
    [anon_sym_pub] = ACTIONS(945),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_static] = ACTIONS(945),
    [anon_sym_struct] = ACTIONS(945),
    [anon_sym_trait] = ACTIONS(945),
    [anon_sym_type] = ACTIONS(945),
    [anon_sym_union] = ACTIONS(945),
    [anon_sym_unsafe] = ACTIONS(945),
    [anon_sym_use] = ACTIONS(945),
    [anon_sym_where] = ACTIONS(945),
    [anon_sym_while] = ACTIONS(945),
    [sym_mutable_specifier] = ACTIONS(945),
    [sym_integer_literal] = ACTIONS(947),
    [aux_sym_string_literal_token1] = ACTIONS(947),
    [sym_char_literal] = ACTIONS(947),
    [anon_sym_true] = ACTIONS(945),
    [anon_sym_false] = ACTIONS(945),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(945),
    [sym_super] = ACTIONS(945),
    [sym_crate] = ACTIONS(945),
    [sym_metavariable] = ACTIONS(947),
    [sym__raw_string_literal_start] = ACTIONS(947),
    [sym_float_literal] = ACTIONS(947),
  },
  [162] = {
    [sym_attribute_item] = STATE(999),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1541),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(162),
    [sym_block_comment] = STATE(162),
    [aux_sym_enum_variant_list_repeat1] = STATE(158),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(949),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(951),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [163] = {
    [sym_line_comment] = STATE(163),
    [sym_block_comment] = STATE(163),
    [sym_identifier] = ACTIONS(745),
    [anon_sym_SEMI] = ACTIONS(747),
    [anon_sym_LPAREN] = ACTIONS(747),
    [anon_sym_RPAREN] = ACTIONS(747),
    [anon_sym_LBRACK] = ACTIONS(747),
    [anon_sym_RBRACK] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_RBRACE] = ACTIONS(747),
    [anon_sym_EQ_GT] = ACTIONS(747),
    [anon_sym_COLON] = ACTIONS(745),
    [anon_sym_DOLLAR] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(747),
    [anon_sym_u8] = ACTIONS(745),
    [anon_sym_i8] = ACTIONS(745),
    [anon_sym_u16] = ACTIONS(745),
    [anon_sym_i16] = ACTIONS(745),
    [anon_sym_u32] = ACTIONS(745),
    [anon_sym_i32] = ACTIONS(745),
    [anon_sym_u64] = ACTIONS(745),
    [anon_sym_i64] = ACTIONS(745),
    [anon_sym_u128] = ACTIONS(745),
    [anon_sym_i128] = ACTIONS(745),
    [anon_sym_isize] = ACTIONS(745),
    [anon_sym_usize] = ACTIONS(745),
    [anon_sym_f32] = ACTIONS(745),
    [anon_sym_f64] = ACTIONS(745),
    [anon_sym_bool] = ACTIONS(745),
    [anon_sym_str] = ACTIONS(745),
    [anon_sym_char] = ACTIONS(745),
    [anon_sym_DASH] = ACTIONS(745),
    [anon_sym_SLASH] = ACTIONS(745),
    [anon_sym_PERCENT] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(745),
    [anon_sym_BANG] = ACTIONS(745),
    [anon_sym_AMP] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(745),
    [anon_sym_AMP_AMP] = ACTIONS(747),
    [anon_sym_PIPE_PIPE] = ACTIONS(747),
    [anon_sym_LT_LT] = ACTIONS(745),
    [anon_sym_GT_GT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(747),
    [anon_sym_DASH_EQ] = ACTIONS(747),
    [anon_sym_STAR_EQ] = ACTIONS(747),
    [anon_sym_SLASH_EQ] = ACTIONS(747),
    [anon_sym_PERCENT_EQ] = ACTIONS(747),
    [anon_sym_CARET_EQ] = ACTIONS(747),
    [anon_sym_AMP_EQ] = ACTIONS(747),
    [anon_sym_PIPE_EQ] = ACTIONS(747),
    [anon_sym_LT_LT_EQ] = ACTIONS(747),
    [anon_sym_GT_GT_EQ] = ACTIONS(747),
    [anon_sym_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ] = ACTIONS(747),
    [anon_sym_BANG_EQ] = ACTIONS(747),
    [anon_sym_GT] = ACTIONS(745),
    [anon_sym_LT] = ACTIONS(745),
    [anon_sym_GT_EQ] = ACTIONS(747),
    [anon_sym_LT_EQ] = ACTIONS(747),
    [anon_sym_AT] = ACTIONS(747),
    [anon_sym__] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(747),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(747),
    [anon_sym_COMMA] = ACTIONS(747),
    [anon_sym_COLON_COLON] = ACTIONS(747),
    [anon_sym_DASH_GT] = ACTIONS(747),
    [anon_sym_POUND] = ACTIONS(747),
    [anon_sym_SQUOTE] = ACTIONS(745),
    [anon_sym_as] = ACTIONS(745),
    [anon_sym_async] = ACTIONS(745),
    [anon_sym_await] = ACTIONS(745),
    [anon_sym_break] = ACTIONS(745),
    [anon_sym_const] = ACTIONS(745),
    [anon_sym_continue] = ACTIONS(745),
    [anon_sym_default] = ACTIONS(745),
    [anon_sym_enum] = ACTIONS(745),
    [anon_sym_fn] = ACTIONS(745),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_if] = ACTIONS(745),
    [anon_sym_impl] = ACTIONS(745),
    [anon_sym_let] = ACTIONS(745),
    [anon_sym_loop] = ACTIONS(745),
    [anon_sym_match] = ACTIONS(745),
    [anon_sym_mod] = ACTIONS(745),
    [anon_sym_pub] = ACTIONS(745),
    [anon_sym_return] = ACTIONS(745),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_struct] = ACTIONS(745),
    [anon_sym_trait] = ACTIONS(745),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_union] = ACTIONS(745),
    [anon_sym_unsafe] = ACTIONS(745),
    [anon_sym_use] = ACTIONS(745),
    [anon_sym_where] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(745),
    [sym_mutable_specifier] = ACTIONS(745),
    [sym_integer_literal] = ACTIONS(747),
    [aux_sym_string_literal_token1] = ACTIONS(747),
    [sym_char_literal] = ACTIONS(747),
    [anon_sym_true] = ACTIONS(745),
    [anon_sym_false] = ACTIONS(745),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(745),
    [sym_super] = ACTIONS(745),
    [sym_crate] = ACTIONS(745),
    [sym_metavariable] = ACTIONS(747),
    [sym__raw_string_literal_start] = ACTIONS(747),
    [sym_float_literal] = ACTIONS(747),
  },
  [164] = {
    [sym_line_comment] = STATE(164),
    [sym_block_comment] = STATE(164),
    [sym_identifier] = ACTIONS(953),
    [anon_sym_SEMI] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(955),
    [anon_sym_RPAREN] = ACTIONS(955),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_RBRACK] = ACTIONS(955),
    [anon_sym_LBRACE] = ACTIONS(955),
    [anon_sym_RBRACE] = ACTIONS(955),
    [anon_sym_EQ_GT] = ACTIONS(955),
    [anon_sym_COLON] = ACTIONS(953),
    [anon_sym_DOLLAR] = ACTIONS(953),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_STAR] = ACTIONS(953),
    [anon_sym_QMARK] = ACTIONS(955),
    [anon_sym_u8] = ACTIONS(953),
    [anon_sym_i8] = ACTIONS(953),
    [anon_sym_u16] = ACTIONS(953),
    [anon_sym_i16] = ACTIONS(953),
    [anon_sym_u32] = ACTIONS(953),
    [anon_sym_i32] = ACTIONS(953),
    [anon_sym_u64] = ACTIONS(953),
    [anon_sym_i64] = ACTIONS(953),
    [anon_sym_u128] = ACTIONS(953),
    [anon_sym_i128] = ACTIONS(953),
    [anon_sym_isize] = ACTIONS(953),
    [anon_sym_usize] = ACTIONS(953),
    [anon_sym_f32] = ACTIONS(953),
    [anon_sym_f64] = ACTIONS(953),
    [anon_sym_bool] = ACTIONS(953),
    [anon_sym_str] = ACTIONS(953),
    [anon_sym_char] = ACTIONS(953),
    [anon_sym_DASH] = ACTIONS(953),
    [anon_sym_SLASH] = ACTIONS(953),
    [anon_sym_PERCENT] = ACTIONS(953),
    [anon_sym_CARET] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(953),
    [anon_sym_AMP] = ACTIONS(953),
    [anon_sym_PIPE] = ACTIONS(953),
    [anon_sym_AMP_AMP] = ACTIONS(955),
    [anon_sym_PIPE_PIPE] = ACTIONS(955),
    [anon_sym_LT_LT] = ACTIONS(953),
    [anon_sym_GT_GT] = ACTIONS(953),
    [anon_sym_PLUS_EQ] = ACTIONS(955),
    [anon_sym_DASH_EQ] = ACTIONS(955),
    [anon_sym_STAR_EQ] = ACTIONS(955),
    [anon_sym_SLASH_EQ] = ACTIONS(955),
    [anon_sym_PERCENT_EQ] = ACTIONS(955),
    [anon_sym_CARET_EQ] = ACTIONS(955),
    [anon_sym_AMP_EQ] = ACTIONS(955),
    [anon_sym_PIPE_EQ] = ACTIONS(955),
    [anon_sym_LT_LT_EQ] = ACTIONS(955),
    [anon_sym_GT_GT_EQ] = ACTIONS(955),
    [anon_sym_EQ] = ACTIONS(953),
    [anon_sym_EQ_EQ] = ACTIONS(955),
    [anon_sym_BANG_EQ] = ACTIONS(955),
    [anon_sym_GT] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(953),
    [anon_sym_GT_EQ] = ACTIONS(955),
    [anon_sym_LT_EQ] = ACTIONS(955),
    [anon_sym_AT] = ACTIONS(955),
    [anon_sym__] = ACTIONS(953),
    [anon_sym_DOT] = ACTIONS(953),
    [anon_sym_DOT_DOT] = ACTIONS(953),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(955),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(955),
    [anon_sym_COMMA] = ACTIONS(955),
    [anon_sym_COLON_COLON] = ACTIONS(955),
    [anon_sym_DASH_GT] = ACTIONS(955),
    [anon_sym_POUND] = ACTIONS(955),
    [anon_sym_SQUOTE] = ACTIONS(953),
    [anon_sym_as] = ACTIONS(953),
    [anon_sym_async] = ACTIONS(953),
    [anon_sym_await] = ACTIONS(953),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(953),
    [anon_sym_continue] = ACTIONS(953),
    [anon_sym_default] = ACTIONS(953),
    [anon_sym_enum] = ACTIONS(953),
    [anon_sym_fn] = ACTIONS(953),
    [anon_sym_for] = ACTIONS(953),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_impl] = ACTIONS(953),
    [anon_sym_let] = ACTIONS(953),
    [anon_sym_loop] = ACTIONS(953),
    [anon_sym_match] = ACTIONS(953),
    [anon_sym_mod] = ACTIONS(953),
    [anon_sym_pub] = ACTIONS(953),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_struct] = ACTIONS(953),
    [anon_sym_trait] = ACTIONS(953),
    [anon_sym_type] = ACTIONS(953),
    [anon_sym_union] = ACTIONS(953),
    [anon_sym_unsafe] = ACTIONS(953),
    [anon_sym_use] = ACTIONS(953),
    [anon_sym_where] = ACTIONS(953),
    [anon_sym_while] = ACTIONS(953),
    [sym_mutable_specifier] = ACTIONS(953),
    [sym_integer_literal] = ACTIONS(955),
    [aux_sym_string_literal_token1] = ACTIONS(955),
    [sym_char_literal] = ACTIONS(955),
    [anon_sym_true] = ACTIONS(953),
    [anon_sym_false] = ACTIONS(953),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(953),
    [sym_super] = ACTIONS(953),
    [sym_crate] = ACTIONS(953),
    [sym_metavariable] = ACTIONS(955),
    [sym__raw_string_literal_start] = ACTIONS(955),
    [sym_float_literal] = ACTIONS(955),
  },
  [165] = {
    [sym_line_comment] = STATE(165),
    [sym_block_comment] = STATE(165),
    [sym_identifier] = ACTIONS(957),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(959),
    [anon_sym_RPAREN] = ACTIONS(959),
    [anon_sym_LBRACK] = ACTIONS(959),
    [anon_sym_RBRACK] = ACTIONS(959),
    [anon_sym_LBRACE] = ACTIONS(959),
    [anon_sym_RBRACE] = ACTIONS(959),
    [anon_sym_EQ_GT] = ACTIONS(959),
    [anon_sym_COLON] = ACTIONS(957),
    [anon_sym_DOLLAR] = ACTIONS(957),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(957),
    [anon_sym_QMARK] = ACTIONS(959),
    [anon_sym_u8] = ACTIONS(957),
    [anon_sym_i8] = ACTIONS(957),
    [anon_sym_u16] = ACTIONS(957),
    [anon_sym_i16] = ACTIONS(957),
    [anon_sym_u32] = ACTIONS(957),
    [anon_sym_i32] = ACTIONS(957),
    [anon_sym_u64] = ACTIONS(957),
    [anon_sym_i64] = ACTIONS(957),
    [anon_sym_u128] = ACTIONS(957),
    [anon_sym_i128] = ACTIONS(957),
    [anon_sym_isize] = ACTIONS(957),
    [anon_sym_usize] = ACTIONS(957),
    [anon_sym_f32] = ACTIONS(957),
    [anon_sym_f64] = ACTIONS(957),
    [anon_sym_bool] = ACTIONS(957),
    [anon_sym_str] = ACTIONS(957),
    [anon_sym_char] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_SLASH] = ACTIONS(957),
    [anon_sym_PERCENT] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(957),
    [anon_sym_PIPE] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(959),
    [anon_sym_PIPE_PIPE] = ACTIONS(959),
    [anon_sym_LT_LT] = ACTIONS(957),
    [anon_sym_GT_GT] = ACTIONS(957),
    [anon_sym_PLUS_EQ] = ACTIONS(959),
    [anon_sym_DASH_EQ] = ACTIONS(959),
    [anon_sym_STAR_EQ] = ACTIONS(959),
    [anon_sym_SLASH_EQ] = ACTIONS(959),
    [anon_sym_PERCENT_EQ] = ACTIONS(959),
    [anon_sym_CARET_EQ] = ACTIONS(959),
    [anon_sym_AMP_EQ] = ACTIONS(959),
    [anon_sym_PIPE_EQ] = ACTIONS(959),
    [anon_sym_LT_LT_EQ] = ACTIONS(959),
    [anon_sym_GT_GT_EQ] = ACTIONS(959),
    [anon_sym_EQ] = ACTIONS(957),
    [anon_sym_EQ_EQ] = ACTIONS(959),
    [anon_sym_BANG_EQ] = ACTIONS(959),
    [anon_sym_GT] = ACTIONS(957),
    [anon_sym_LT] = ACTIONS(957),
    [anon_sym_GT_EQ] = ACTIONS(959),
    [anon_sym_LT_EQ] = ACTIONS(959),
    [anon_sym_AT] = ACTIONS(959),
    [anon_sym__] = ACTIONS(957),
    [anon_sym_DOT] = ACTIONS(957),
    [anon_sym_DOT_DOT] = ACTIONS(957),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(959),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(959),
    [anon_sym_COMMA] = ACTIONS(959),
    [anon_sym_COLON_COLON] = ACTIONS(959),
    [anon_sym_DASH_GT] = ACTIONS(959),
    [anon_sym_POUND] = ACTIONS(959),
    [anon_sym_SQUOTE] = ACTIONS(957),
    [anon_sym_as] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(957),
    [anon_sym_await] = ACTIONS(957),
    [anon_sym_break] = ACTIONS(957),
    [anon_sym_const] = ACTIONS(957),
    [anon_sym_continue] = ACTIONS(957),
    [anon_sym_default] = ACTIONS(957),
    [anon_sym_enum] = ACTIONS(957),
    [anon_sym_fn] = ACTIONS(957),
    [anon_sym_for] = ACTIONS(957),
    [anon_sym_if] = ACTIONS(957),
    [anon_sym_impl] = ACTIONS(957),
    [anon_sym_let] = ACTIONS(957),
    [anon_sym_loop] = ACTIONS(957),
    [anon_sym_match] = ACTIONS(957),
    [anon_sym_mod] = ACTIONS(957),
    [anon_sym_pub] = ACTIONS(957),
    [anon_sym_return] = ACTIONS(957),
    [anon_sym_static] = ACTIONS(957),
    [anon_sym_struct] = ACTIONS(957),
    [anon_sym_trait] = ACTIONS(957),
    [anon_sym_type] = ACTIONS(957),
    [anon_sym_union] = ACTIONS(957),
    [anon_sym_unsafe] = ACTIONS(957),
    [anon_sym_use] = ACTIONS(957),
    [anon_sym_where] = ACTIONS(957),
    [anon_sym_while] = ACTIONS(957),
    [sym_mutable_specifier] = ACTIONS(957),
    [sym_integer_literal] = ACTIONS(959),
    [aux_sym_string_literal_token1] = ACTIONS(959),
    [sym_char_literal] = ACTIONS(959),
    [anon_sym_true] = ACTIONS(957),
    [anon_sym_false] = ACTIONS(957),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(957),
    [sym_super] = ACTIONS(957),
    [sym_crate] = ACTIONS(957),
    [sym_metavariable] = ACTIONS(959),
    [sym__raw_string_literal_start] = ACTIONS(959),
    [sym_float_literal] = ACTIONS(959),
  },
  [166] = {
    [sym_line_comment] = STATE(166),
    [sym_block_comment] = STATE(166),
    [sym_identifier] = ACTIONS(961),
    [anon_sym_SEMI] = ACTIONS(963),
    [anon_sym_LPAREN] = ACTIONS(963),
    [anon_sym_RPAREN] = ACTIONS(963),
    [anon_sym_LBRACK] = ACTIONS(963),
    [anon_sym_RBRACK] = ACTIONS(963),
    [anon_sym_LBRACE] = ACTIONS(963),
    [anon_sym_RBRACE] = ACTIONS(963),
    [anon_sym_EQ_GT] = ACTIONS(963),
    [anon_sym_COLON] = ACTIONS(961),
    [anon_sym_DOLLAR] = ACTIONS(961),
    [anon_sym_PLUS] = ACTIONS(961),
    [anon_sym_STAR] = ACTIONS(961),
    [anon_sym_QMARK] = ACTIONS(963),
    [anon_sym_u8] = ACTIONS(961),
    [anon_sym_i8] = ACTIONS(961),
    [anon_sym_u16] = ACTIONS(961),
    [anon_sym_i16] = ACTIONS(961),
    [anon_sym_u32] = ACTIONS(961),
    [anon_sym_i32] = ACTIONS(961),
    [anon_sym_u64] = ACTIONS(961),
    [anon_sym_i64] = ACTIONS(961),
    [anon_sym_u128] = ACTIONS(961),
    [anon_sym_i128] = ACTIONS(961),
    [anon_sym_isize] = ACTIONS(961),
    [anon_sym_usize] = ACTIONS(961),
    [anon_sym_f32] = ACTIONS(961),
    [anon_sym_f64] = ACTIONS(961),
    [anon_sym_bool] = ACTIONS(961),
    [anon_sym_str] = ACTIONS(961),
    [anon_sym_char] = ACTIONS(961),
    [anon_sym_DASH] = ACTIONS(961),
    [anon_sym_SLASH] = ACTIONS(961),
    [anon_sym_PERCENT] = ACTIONS(961),
    [anon_sym_CARET] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(961),
    [anon_sym_AMP] = ACTIONS(961),
    [anon_sym_PIPE] = ACTIONS(961),
    [anon_sym_AMP_AMP] = ACTIONS(963),
    [anon_sym_PIPE_PIPE] = ACTIONS(963),
    [anon_sym_LT_LT] = ACTIONS(961),
    [anon_sym_GT_GT] = ACTIONS(961),
    [anon_sym_PLUS_EQ] = ACTIONS(963),
    [anon_sym_DASH_EQ] = ACTIONS(963),
    [anon_sym_STAR_EQ] = ACTIONS(963),
    [anon_sym_SLASH_EQ] = ACTIONS(963),
    [anon_sym_PERCENT_EQ] = ACTIONS(963),
    [anon_sym_CARET_EQ] = ACTIONS(963),
    [anon_sym_AMP_EQ] = ACTIONS(963),
    [anon_sym_PIPE_EQ] = ACTIONS(963),
    [anon_sym_LT_LT_EQ] = ACTIONS(963),
    [anon_sym_GT_GT_EQ] = ACTIONS(963),
    [anon_sym_EQ] = ACTIONS(961),
    [anon_sym_EQ_EQ] = ACTIONS(963),
    [anon_sym_BANG_EQ] = ACTIONS(963),
    [anon_sym_GT] = ACTIONS(961),
    [anon_sym_LT] = ACTIONS(961),
    [anon_sym_GT_EQ] = ACTIONS(963),
    [anon_sym_LT_EQ] = ACTIONS(963),
    [anon_sym_AT] = ACTIONS(963),
    [anon_sym__] = ACTIONS(961),
    [anon_sym_DOT] = ACTIONS(961),
    [anon_sym_DOT_DOT] = ACTIONS(961),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(963),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(963),
    [anon_sym_COMMA] = ACTIONS(963),
    [anon_sym_COLON_COLON] = ACTIONS(963),
    [anon_sym_DASH_GT] = ACTIONS(963),
    [anon_sym_POUND] = ACTIONS(963),
    [anon_sym_SQUOTE] = ACTIONS(961),
    [anon_sym_as] = ACTIONS(961),
    [anon_sym_async] = ACTIONS(961),
    [anon_sym_await] = ACTIONS(961),
    [anon_sym_break] = ACTIONS(961),
    [anon_sym_const] = ACTIONS(961),
    [anon_sym_continue] = ACTIONS(961),
    [anon_sym_default] = ACTIONS(961),
    [anon_sym_enum] = ACTIONS(961),
    [anon_sym_fn] = ACTIONS(961),
    [anon_sym_for] = ACTIONS(961),
    [anon_sym_if] = ACTIONS(961),
    [anon_sym_impl] = ACTIONS(961),
    [anon_sym_let] = ACTIONS(961),
    [anon_sym_loop] = ACTIONS(961),
    [anon_sym_match] = ACTIONS(961),
    [anon_sym_mod] = ACTIONS(961),
    [anon_sym_pub] = ACTIONS(961),
    [anon_sym_return] = ACTIONS(961),
    [anon_sym_static] = ACTIONS(961),
    [anon_sym_struct] = ACTIONS(961),
    [anon_sym_trait] = ACTIONS(961),
    [anon_sym_type] = ACTIONS(961),
    [anon_sym_union] = ACTIONS(961),
    [anon_sym_unsafe] = ACTIONS(961),
    [anon_sym_use] = ACTIONS(961),
    [anon_sym_where] = ACTIONS(961),
    [anon_sym_while] = ACTIONS(961),
    [sym_mutable_specifier] = ACTIONS(961),
    [sym_integer_literal] = ACTIONS(963),
    [aux_sym_string_literal_token1] = ACTIONS(963),
    [sym_char_literal] = ACTIONS(963),
    [anon_sym_true] = ACTIONS(961),
    [anon_sym_false] = ACTIONS(961),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(961),
    [sym_super] = ACTIONS(961),
    [sym_crate] = ACTIONS(961),
    [sym_metavariable] = ACTIONS(963),
    [sym__raw_string_literal_start] = ACTIONS(963),
    [sym_float_literal] = ACTIONS(963),
  },
  [167] = {
    [sym_attribute_item] = STATE(999),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1611),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(167),
    [sym_block_comment] = STATE(167),
    [aux_sym_enum_variant_list_repeat1] = STATE(211),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(965),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(967),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [168] = {
    [sym_line_comment] = STATE(168),
    [sym_block_comment] = STATE(168),
    [sym_identifier] = ACTIONS(969),
    [anon_sym_SEMI] = ACTIONS(971),
    [anon_sym_LPAREN] = ACTIONS(971),
    [anon_sym_RPAREN] = ACTIONS(971),
    [anon_sym_LBRACK] = ACTIONS(971),
    [anon_sym_RBRACK] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(971),
    [anon_sym_RBRACE] = ACTIONS(971),
    [anon_sym_EQ_GT] = ACTIONS(971),
    [anon_sym_COLON] = ACTIONS(969),
    [anon_sym_DOLLAR] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(969),
    [anon_sym_STAR] = ACTIONS(969),
    [anon_sym_QMARK] = ACTIONS(971),
    [anon_sym_u8] = ACTIONS(969),
    [anon_sym_i8] = ACTIONS(969),
    [anon_sym_u16] = ACTIONS(969),
    [anon_sym_i16] = ACTIONS(969),
    [anon_sym_u32] = ACTIONS(969),
    [anon_sym_i32] = ACTIONS(969),
    [anon_sym_u64] = ACTIONS(969),
    [anon_sym_i64] = ACTIONS(969),
    [anon_sym_u128] = ACTIONS(969),
    [anon_sym_i128] = ACTIONS(969),
    [anon_sym_isize] = ACTIONS(969),
    [anon_sym_usize] = ACTIONS(969),
    [anon_sym_f32] = ACTIONS(969),
    [anon_sym_f64] = ACTIONS(969),
    [anon_sym_bool] = ACTIONS(969),
    [anon_sym_str] = ACTIONS(969),
    [anon_sym_char] = ACTIONS(969),
    [anon_sym_DASH] = ACTIONS(969),
    [anon_sym_SLASH] = ACTIONS(969),
    [anon_sym_PERCENT] = ACTIONS(969),
    [anon_sym_CARET] = ACTIONS(969),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_AMP] = ACTIONS(969),
    [anon_sym_PIPE] = ACTIONS(969),
    [anon_sym_AMP_AMP] = ACTIONS(971),
    [anon_sym_PIPE_PIPE] = ACTIONS(971),
    [anon_sym_LT_LT] = ACTIONS(969),
    [anon_sym_GT_GT] = ACTIONS(969),
    [anon_sym_PLUS_EQ] = ACTIONS(971),
    [anon_sym_DASH_EQ] = ACTIONS(971),
    [anon_sym_STAR_EQ] = ACTIONS(971),
    [anon_sym_SLASH_EQ] = ACTIONS(971),
    [anon_sym_PERCENT_EQ] = ACTIONS(971),
    [anon_sym_CARET_EQ] = ACTIONS(971),
    [anon_sym_AMP_EQ] = ACTIONS(971),
    [anon_sym_PIPE_EQ] = ACTIONS(971),
    [anon_sym_LT_LT_EQ] = ACTIONS(971),
    [anon_sym_GT_GT_EQ] = ACTIONS(971),
    [anon_sym_EQ] = ACTIONS(969),
    [anon_sym_EQ_EQ] = ACTIONS(971),
    [anon_sym_BANG_EQ] = ACTIONS(971),
    [anon_sym_GT] = ACTIONS(969),
    [anon_sym_LT] = ACTIONS(969),
    [anon_sym_GT_EQ] = ACTIONS(971),
    [anon_sym_LT_EQ] = ACTIONS(971),
    [anon_sym_AT] = ACTIONS(971),
    [anon_sym__] = ACTIONS(969),
    [anon_sym_DOT] = ACTIONS(969),
    [anon_sym_DOT_DOT] = ACTIONS(969),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(971),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(971),
    [anon_sym_COMMA] = ACTIONS(971),
    [anon_sym_COLON_COLON] = ACTIONS(971),
    [anon_sym_DASH_GT] = ACTIONS(971),
    [anon_sym_POUND] = ACTIONS(971),
    [anon_sym_SQUOTE] = ACTIONS(969),
    [anon_sym_as] = ACTIONS(969),
    [anon_sym_async] = ACTIONS(969),
    [anon_sym_await] = ACTIONS(969),
    [anon_sym_break] = ACTIONS(969),
    [anon_sym_const] = ACTIONS(969),
    [anon_sym_continue] = ACTIONS(969),
    [anon_sym_default] = ACTIONS(969),
    [anon_sym_enum] = ACTIONS(969),
    [anon_sym_fn] = ACTIONS(969),
    [anon_sym_for] = ACTIONS(969),
    [anon_sym_if] = ACTIONS(969),
    [anon_sym_impl] = ACTIONS(969),
    [anon_sym_let] = ACTIONS(969),
    [anon_sym_loop] = ACTIONS(969),
    [anon_sym_match] = ACTIONS(969),
    [anon_sym_mod] = ACTIONS(969),
    [anon_sym_pub] = ACTIONS(969),
    [anon_sym_return] = ACTIONS(969),
    [anon_sym_static] = ACTIONS(969),
    [anon_sym_struct] = ACTIONS(969),
    [anon_sym_trait] = ACTIONS(969),
    [anon_sym_type] = ACTIONS(969),
    [anon_sym_union] = ACTIONS(969),
    [anon_sym_unsafe] = ACTIONS(969),
    [anon_sym_use] = ACTIONS(969),
    [anon_sym_where] = ACTIONS(969),
    [anon_sym_while] = ACTIONS(969),
    [sym_mutable_specifier] = ACTIONS(969),
    [sym_integer_literal] = ACTIONS(971),
    [aux_sym_string_literal_token1] = ACTIONS(971),
    [sym_char_literal] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(969),
    [anon_sym_false] = ACTIONS(969),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(969),
    [sym_super] = ACTIONS(969),
    [sym_crate] = ACTIONS(969),
    [sym_metavariable] = ACTIONS(971),
    [sym__raw_string_literal_start] = ACTIONS(971),
    [sym_float_literal] = ACTIONS(971),
  },
  [169] = {
    [sym_attribute_item] = STATE(999),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1583),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(169),
    [sym_block_comment] = STATE(169),
    [aux_sym_enum_variant_list_repeat1] = STATE(213),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(973),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [170] = {
    [sym_attribute_item] = STATE(999),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1583),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(170),
    [sym_block_comment] = STATE(170),
    [aux_sym_enum_variant_list_repeat1] = STATE(213),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(975),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [171] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1736),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_let_condition] = STATE(2814),
    [sym__let_chain] = STATE(2815),
    [sym__condition] = STATE(2600),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(171),
    [sym_block_comment] = STATE(171),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(981),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(466),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_let] = ACTIONS(983),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(472),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(474),
    [anon_sym_move] = ACTIONS(476),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [172] = {
    [sym_attribute_item] = STATE(999),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1583),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(172),
    [sym_block_comment] = STATE(172),
    [aux_sym_enum_variant_list_repeat1] = STATE(213),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(985),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [173] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1736),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_let_condition] = STATE(2814),
    [sym__let_chain] = STATE(2815),
    [sym__condition] = STATE(2646),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(173),
    [sym_block_comment] = STATE(173),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(981),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(466),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_let] = ACTIONS(983),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(472),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(474),
    [anon_sym_move] = ACTIONS(476),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [174] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1736),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_let_condition] = STATE(2814),
    [sym__let_chain] = STATE(2815),
    [sym__condition] = STATE(2599),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(174),
    [sym_block_comment] = STATE(174),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(981),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(466),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_let] = ACTIONS(983),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(472),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(474),
    [anon_sym_move] = ACTIONS(476),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [175] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1736),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_let_condition] = STATE(2814),
    [sym__let_chain] = STATE(2815),
    [sym__condition] = STATE(2647),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(175),
    [sym_block_comment] = STATE(175),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(981),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(466),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_let] = ACTIONS(983),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(472),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(474),
    [anon_sym_move] = ACTIONS(476),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [176] = {
    [sym_attribute_item] = STATE(999),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1583),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(176),
    [sym_block_comment] = STATE(176),
    [aux_sym_enum_variant_list_repeat1] = STATE(213),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(987),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [177] = {
    [sym_attribute_item] = STATE(999),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1583),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(177),
    [sym_block_comment] = STATE(177),
    [aux_sym_enum_variant_list_repeat1] = STATE(213),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(989),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [178] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1736),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_let_condition] = STATE(2814),
    [sym__let_chain] = STATE(2815),
    [sym__condition] = STATE(2585),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(178),
    [sym_block_comment] = STATE(178),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(981),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(466),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_let] = ACTIONS(983),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(472),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(474),
    [anon_sym_move] = ACTIONS(476),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [179] = {
    [sym_attribute_item] = STATE(999),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1583),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(179),
    [sym_block_comment] = STATE(179),
    [aux_sym_enum_variant_list_repeat1] = STATE(213),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(991),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [180] = {
    [sym_line_comment] = STATE(180),
    [sym_block_comment] = STATE(180),
    [sym_identifier] = ACTIONS(813),
    [anon_sym_SEMI] = ACTIONS(815),
    [anon_sym_LPAREN] = ACTIONS(815),
    [anon_sym_RPAREN] = ACTIONS(815),
    [anon_sym_LBRACK] = ACTIONS(815),
    [anon_sym_RBRACK] = ACTIONS(815),
    [anon_sym_LBRACE] = ACTIONS(815),
    [anon_sym_RBRACE] = ACTIONS(815),
    [anon_sym_EQ_GT] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(813),
    [anon_sym_DOLLAR] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_STAR] = ACTIONS(813),
    [anon_sym_QMARK] = ACTIONS(815),
    [anon_sym_u8] = ACTIONS(813),
    [anon_sym_i8] = ACTIONS(813),
    [anon_sym_u16] = ACTIONS(813),
    [anon_sym_i16] = ACTIONS(813),
    [anon_sym_u32] = ACTIONS(813),
    [anon_sym_i32] = ACTIONS(813),
    [anon_sym_u64] = ACTIONS(813),
    [anon_sym_i64] = ACTIONS(813),
    [anon_sym_u128] = ACTIONS(813),
    [anon_sym_i128] = ACTIONS(813),
    [anon_sym_isize] = ACTIONS(813),
    [anon_sym_usize] = ACTIONS(813),
    [anon_sym_f32] = ACTIONS(813),
    [anon_sym_f64] = ACTIONS(813),
    [anon_sym_bool] = ACTIONS(813),
    [anon_sym_str] = ACTIONS(813),
    [anon_sym_char] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_AMP_AMP] = ACTIONS(815),
    [anon_sym_PIPE_PIPE] = ACTIONS(815),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(813),
    [anon_sym_PLUS_EQ] = ACTIONS(815),
    [anon_sym_DASH_EQ] = ACTIONS(815),
    [anon_sym_STAR_EQ] = ACTIONS(815),
    [anon_sym_SLASH_EQ] = ACTIONS(815),
    [anon_sym_PERCENT_EQ] = ACTIONS(815),
    [anon_sym_CARET_EQ] = ACTIONS(815),
    [anon_sym_AMP_EQ] = ACTIONS(815),
    [anon_sym_PIPE_EQ] = ACTIONS(815),
    [anon_sym_LT_LT_EQ] = ACTIONS(815),
    [anon_sym_GT_GT_EQ] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(815),
    [anon_sym_BANG_EQ] = ACTIONS(815),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(815),
    [anon_sym_LT_EQ] = ACTIONS(815),
    [anon_sym_AT] = ACTIONS(815),
    [anon_sym__] = ACTIONS(813),
    [anon_sym_DOT] = ACTIONS(813),
    [anon_sym_DOT_DOT] = ACTIONS(813),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(815),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(815),
    [anon_sym_COMMA] = ACTIONS(815),
    [anon_sym_COLON_COLON] = ACTIONS(815),
    [anon_sym_DASH_GT] = ACTIONS(815),
    [anon_sym_POUND] = ACTIONS(815),
    [anon_sym_SQUOTE] = ACTIONS(813),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_async] = ACTIONS(813),
    [anon_sym_await] = ACTIONS(813),
    [anon_sym_break] = ACTIONS(813),
    [anon_sym_const] = ACTIONS(813),
    [anon_sym_continue] = ACTIONS(813),
    [anon_sym_default] = ACTIONS(813),
    [anon_sym_enum] = ACTIONS(813),
    [anon_sym_fn] = ACTIONS(813),
    [anon_sym_for] = ACTIONS(813),
    [anon_sym_if] = ACTIONS(813),
    [anon_sym_impl] = ACTIONS(813),
    [anon_sym_let] = ACTIONS(813),
    [anon_sym_loop] = ACTIONS(813),
    [anon_sym_match] = ACTIONS(813),
    [anon_sym_mod] = ACTIONS(813),
    [anon_sym_pub] = ACTIONS(813),
    [anon_sym_return] = ACTIONS(813),
    [anon_sym_static] = ACTIONS(813),
    [anon_sym_struct] = ACTIONS(813),
    [anon_sym_trait] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(813),
    [anon_sym_union] = ACTIONS(813),
    [anon_sym_unsafe] = ACTIONS(813),
    [anon_sym_use] = ACTIONS(813),
    [anon_sym_where] = ACTIONS(813),
    [anon_sym_while] = ACTIONS(813),
    [sym_mutable_specifier] = ACTIONS(813),
    [sym_integer_literal] = ACTIONS(815),
    [aux_sym_string_literal_token1] = ACTIONS(815),
    [sym_char_literal] = ACTIONS(815),
    [anon_sym_true] = ACTIONS(813),
    [anon_sym_false] = ACTIONS(813),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(813),
    [sym_super] = ACTIONS(813),
    [sym_crate] = ACTIONS(813),
    [sym__raw_string_literal_start] = ACTIONS(815),
    [sym_float_literal] = ACTIONS(815),
  },
  [181] = {
    [sym_attribute_item] = STATE(999),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1583),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(181),
    [sym_block_comment] = STATE(181),
    [aux_sym_enum_variant_list_repeat1] = STATE(213),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(993),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [182] = {
    [sym_line_comment] = STATE(182),
    [sym_block_comment] = STATE(182),
    [sym_identifier] = ACTIONS(785),
    [anon_sym_SEMI] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(787),
    [anon_sym_RPAREN] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(787),
    [anon_sym_RBRACK] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(787),
    [anon_sym_RBRACE] = ACTIONS(787),
    [anon_sym_EQ_GT] = ACTIONS(787),
    [anon_sym_COLON] = ACTIONS(785),
    [anon_sym_DOLLAR] = ACTIONS(787),
    [anon_sym_PLUS] = ACTIONS(785),
    [anon_sym_STAR] = ACTIONS(785),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_u8] = ACTIONS(785),
    [anon_sym_i8] = ACTIONS(785),
    [anon_sym_u16] = ACTIONS(785),
    [anon_sym_i16] = ACTIONS(785),
    [anon_sym_u32] = ACTIONS(785),
    [anon_sym_i32] = ACTIONS(785),
    [anon_sym_u64] = ACTIONS(785),
    [anon_sym_i64] = ACTIONS(785),
    [anon_sym_u128] = ACTIONS(785),
    [anon_sym_i128] = ACTIONS(785),
    [anon_sym_isize] = ACTIONS(785),
    [anon_sym_usize] = ACTIONS(785),
    [anon_sym_f32] = ACTIONS(785),
    [anon_sym_f64] = ACTIONS(785),
    [anon_sym_bool] = ACTIONS(785),
    [anon_sym_str] = ACTIONS(785),
    [anon_sym_char] = ACTIONS(785),
    [anon_sym_DASH] = ACTIONS(785),
    [anon_sym_SLASH] = ACTIONS(785),
    [anon_sym_PERCENT] = ACTIONS(785),
    [anon_sym_CARET] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(785),
    [anon_sym_AMP] = ACTIONS(785),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_AMP_AMP] = ACTIONS(787),
    [anon_sym_PIPE_PIPE] = ACTIONS(787),
    [anon_sym_LT_LT] = ACTIONS(785),
    [anon_sym_GT_GT] = ACTIONS(785),
    [anon_sym_PLUS_EQ] = ACTIONS(787),
    [anon_sym_DASH_EQ] = ACTIONS(787),
    [anon_sym_STAR_EQ] = ACTIONS(787),
    [anon_sym_SLASH_EQ] = ACTIONS(787),
    [anon_sym_PERCENT_EQ] = ACTIONS(787),
    [anon_sym_CARET_EQ] = ACTIONS(787),
    [anon_sym_AMP_EQ] = ACTIONS(787),
    [anon_sym_PIPE_EQ] = ACTIONS(787),
    [anon_sym_LT_LT_EQ] = ACTIONS(787),
    [anon_sym_GT_GT_EQ] = ACTIONS(787),
    [anon_sym_EQ] = ACTIONS(785),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(785),
    [anon_sym_LT] = ACTIONS(785),
    [anon_sym_GT_EQ] = ACTIONS(787),
    [anon_sym_LT_EQ] = ACTIONS(787),
    [anon_sym_AT] = ACTIONS(787),
    [anon_sym__] = ACTIONS(785),
    [anon_sym_DOT] = ACTIONS(785),
    [anon_sym_DOT_DOT] = ACTIONS(785),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(787),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(787),
    [anon_sym_COMMA] = ACTIONS(787),
    [anon_sym_COLON_COLON] = ACTIONS(787),
    [anon_sym_DASH_GT] = ACTIONS(787),
    [anon_sym_POUND] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(785),
    [anon_sym_as] = ACTIONS(785),
    [anon_sym_async] = ACTIONS(785),
    [anon_sym_await] = ACTIONS(785),
    [anon_sym_break] = ACTIONS(785),
    [anon_sym_const] = ACTIONS(785),
    [anon_sym_continue] = ACTIONS(785),
    [anon_sym_default] = ACTIONS(785),
    [anon_sym_enum] = ACTIONS(785),
    [anon_sym_fn] = ACTIONS(785),
    [anon_sym_for] = ACTIONS(785),
    [anon_sym_if] = ACTIONS(785),
    [anon_sym_impl] = ACTIONS(785),
    [anon_sym_let] = ACTIONS(785),
    [anon_sym_loop] = ACTIONS(785),
    [anon_sym_match] = ACTIONS(785),
    [anon_sym_mod] = ACTIONS(785),
    [anon_sym_pub] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(785),
    [anon_sym_static] = ACTIONS(785),
    [anon_sym_struct] = ACTIONS(785),
    [anon_sym_trait] = ACTIONS(785),
    [anon_sym_type] = ACTIONS(785),
    [anon_sym_union] = ACTIONS(785),
    [anon_sym_unsafe] = ACTIONS(785),
    [anon_sym_use] = ACTIONS(785),
    [anon_sym_where] = ACTIONS(785),
    [anon_sym_while] = ACTIONS(785),
    [sym_mutable_specifier] = ACTIONS(785),
    [sym_integer_literal] = ACTIONS(787),
    [aux_sym_string_literal_token1] = ACTIONS(787),
    [sym_char_literal] = ACTIONS(787),
    [anon_sym_true] = ACTIONS(785),
    [anon_sym_false] = ACTIONS(785),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(785),
    [sym_super] = ACTIONS(785),
    [sym_crate] = ACTIONS(785),
    [sym__raw_string_literal_start] = ACTIONS(787),
    [sym_float_literal] = ACTIONS(787),
  },
  [183] = {
    [sym_line_comment] = STATE(183),
    [sym_block_comment] = STATE(183),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(751),
    [anon_sym_RPAREN] = ACTIONS(751),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_RBRACK] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym_RBRACE] = ACTIONS(751),
    [anon_sym_EQ_GT] = ACTIONS(751),
    [anon_sym_COLON] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(751),
    [anon_sym_u8] = ACTIONS(749),
    [anon_sym_i8] = ACTIONS(749),
    [anon_sym_u16] = ACTIONS(749),
    [anon_sym_i16] = ACTIONS(749),
    [anon_sym_u32] = ACTIONS(749),
    [anon_sym_i32] = ACTIONS(749),
    [anon_sym_u64] = ACTIONS(749),
    [anon_sym_i64] = ACTIONS(749),
    [anon_sym_u128] = ACTIONS(749),
    [anon_sym_i128] = ACTIONS(749),
    [anon_sym_isize] = ACTIONS(749),
    [anon_sym_usize] = ACTIONS(749),
    [anon_sym_f32] = ACTIONS(749),
    [anon_sym_f64] = ACTIONS(749),
    [anon_sym_bool] = ACTIONS(749),
    [anon_sym_str] = ACTIONS(749),
    [anon_sym_char] = ACTIONS(749),
    [anon_sym_DASH] = ACTIONS(749),
    [anon_sym_SLASH] = ACTIONS(749),
    [anon_sym_PERCENT] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(749),
    [anon_sym_BANG] = ACTIONS(749),
    [anon_sym_AMP] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(749),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(749),
    [anon_sym_GT_GT] = ACTIONS(749),
    [anon_sym_PLUS_EQ] = ACTIONS(751),
    [anon_sym_DASH_EQ] = ACTIONS(751),
    [anon_sym_STAR_EQ] = ACTIONS(751),
    [anon_sym_SLASH_EQ] = ACTIONS(751),
    [anon_sym_PERCENT_EQ] = ACTIONS(751),
    [anon_sym_CARET_EQ] = ACTIONS(751),
    [anon_sym_AMP_EQ] = ACTIONS(751),
    [anon_sym_PIPE_EQ] = ACTIONS(751),
    [anon_sym_LT_LT_EQ] = ACTIONS(751),
    [anon_sym_GT_GT_EQ] = ACTIONS(751),
    [anon_sym_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ] = ACTIONS(751),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_GT] = ACTIONS(749),
    [anon_sym_LT] = ACTIONS(749),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [anon_sym_LT_EQ] = ACTIONS(751),
    [anon_sym_AT] = ACTIONS(751),
    [anon_sym__] = ACTIONS(749),
    [anon_sym_DOT] = ACTIONS(749),
    [anon_sym_DOT_DOT] = ACTIONS(749),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(751),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(751),
    [anon_sym_DASH_GT] = ACTIONS(751),
    [anon_sym_POUND] = ACTIONS(751),
    [anon_sym_SQUOTE] = ACTIONS(749),
    [anon_sym_as] = ACTIONS(749),
    [anon_sym_async] = ACTIONS(749),
    [anon_sym_await] = ACTIONS(749),
    [anon_sym_break] = ACTIONS(749),
    [anon_sym_const] = ACTIONS(749),
    [anon_sym_continue] = ACTIONS(749),
    [anon_sym_default] = ACTIONS(749),
    [anon_sym_enum] = ACTIONS(749),
    [anon_sym_fn] = ACTIONS(749),
    [anon_sym_for] = ACTIONS(749),
    [anon_sym_if] = ACTIONS(749),
    [anon_sym_impl] = ACTIONS(749),
    [anon_sym_let] = ACTIONS(749),
    [anon_sym_loop] = ACTIONS(749),
    [anon_sym_match] = ACTIONS(749),
    [anon_sym_mod] = ACTIONS(749),
    [anon_sym_pub] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(749),
    [anon_sym_static] = ACTIONS(749),
    [anon_sym_struct] = ACTIONS(749),
    [anon_sym_trait] = ACTIONS(749),
    [anon_sym_type] = ACTIONS(749),
    [anon_sym_union] = ACTIONS(749),
    [anon_sym_unsafe] = ACTIONS(749),
    [anon_sym_use] = ACTIONS(749),
    [anon_sym_where] = ACTIONS(749),
    [anon_sym_while] = ACTIONS(749),
    [sym_mutable_specifier] = ACTIONS(749),
    [sym_integer_literal] = ACTIONS(751),
    [aux_sym_string_literal_token1] = ACTIONS(751),
    [sym_char_literal] = ACTIONS(751),
    [anon_sym_true] = ACTIONS(749),
    [anon_sym_false] = ACTIONS(749),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(749),
    [sym_super] = ACTIONS(749),
    [sym_crate] = ACTIONS(749),
    [sym__raw_string_literal_start] = ACTIONS(751),
    [sym_float_literal] = ACTIONS(751),
  },
  [184] = {
    [sym_line_comment] = STATE(184),
    [sym_block_comment] = STATE(184),
    [sym_identifier] = ACTIONS(995),
    [anon_sym_SEMI] = ACTIONS(997),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_RPAREN] = ACTIONS(997),
    [anon_sym_LBRACK] = ACTIONS(997),
    [anon_sym_RBRACK] = ACTIONS(997),
    [anon_sym_LBRACE] = ACTIONS(997),
    [anon_sym_RBRACE] = ACTIONS(997),
    [anon_sym_EQ_GT] = ACTIONS(997),
    [anon_sym_COLON] = ACTIONS(995),
    [anon_sym_DOLLAR] = ACTIONS(997),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(995),
    [anon_sym_QMARK] = ACTIONS(997),
    [anon_sym_u8] = ACTIONS(995),
    [anon_sym_i8] = ACTIONS(995),
    [anon_sym_u16] = ACTIONS(995),
    [anon_sym_i16] = ACTIONS(995),
    [anon_sym_u32] = ACTIONS(995),
    [anon_sym_i32] = ACTIONS(995),
    [anon_sym_u64] = ACTIONS(995),
    [anon_sym_i64] = ACTIONS(995),
    [anon_sym_u128] = ACTIONS(995),
    [anon_sym_i128] = ACTIONS(995),
    [anon_sym_isize] = ACTIONS(995),
    [anon_sym_usize] = ACTIONS(995),
    [anon_sym_f32] = ACTIONS(995),
    [anon_sym_f64] = ACTIONS(995),
    [anon_sym_bool] = ACTIONS(995),
    [anon_sym_str] = ACTIONS(995),
    [anon_sym_char] = ACTIONS(995),
    [anon_sym_DASH] = ACTIONS(995),
    [anon_sym_SLASH] = ACTIONS(995),
    [anon_sym_PERCENT] = ACTIONS(995),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_BANG] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_AMP_AMP] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(997),
    [anon_sym_LT_LT] = ACTIONS(995),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_PLUS_EQ] = ACTIONS(997),
    [anon_sym_DASH_EQ] = ACTIONS(997),
    [anon_sym_STAR_EQ] = ACTIONS(997),
    [anon_sym_SLASH_EQ] = ACTIONS(997),
    [anon_sym_PERCENT_EQ] = ACTIONS(997),
    [anon_sym_CARET_EQ] = ACTIONS(997),
    [anon_sym_AMP_EQ] = ACTIONS(997),
    [anon_sym_PIPE_EQ] = ACTIONS(997),
    [anon_sym_LT_LT_EQ] = ACTIONS(997),
    [anon_sym_GT_GT_EQ] = ACTIONS(997),
    [anon_sym_EQ] = ACTIONS(995),
    [anon_sym_EQ_EQ] = ACTIONS(997),
    [anon_sym_BANG_EQ] = ACTIONS(997),
    [anon_sym_GT] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(997),
    [anon_sym_AT] = ACTIONS(997),
    [anon_sym__] = ACTIONS(995),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(997),
    [anon_sym_COMMA] = ACTIONS(997),
    [anon_sym_COLON_COLON] = ACTIONS(997),
    [anon_sym_DASH_GT] = ACTIONS(997),
    [anon_sym_POUND] = ACTIONS(997),
    [anon_sym_SQUOTE] = ACTIONS(995),
    [anon_sym_as] = ACTIONS(995),
    [anon_sym_async] = ACTIONS(995),
    [anon_sym_await] = ACTIONS(995),
    [anon_sym_break] = ACTIONS(995),
    [anon_sym_const] = ACTIONS(995),
    [anon_sym_continue] = ACTIONS(995),
    [anon_sym_default] = ACTIONS(995),
    [anon_sym_enum] = ACTIONS(995),
    [anon_sym_fn] = ACTIONS(995),
    [anon_sym_for] = ACTIONS(995),
    [anon_sym_if] = ACTIONS(995),
    [anon_sym_impl] = ACTIONS(995),
    [anon_sym_let] = ACTIONS(995),
    [anon_sym_loop] = ACTIONS(995),
    [anon_sym_match] = ACTIONS(995),
    [anon_sym_mod] = ACTIONS(995),
    [anon_sym_pub] = ACTIONS(995),
    [anon_sym_return] = ACTIONS(995),
    [anon_sym_static] = ACTIONS(995),
    [anon_sym_struct] = ACTIONS(995),
    [anon_sym_trait] = ACTIONS(995),
    [anon_sym_type] = ACTIONS(995),
    [anon_sym_union] = ACTIONS(995),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_use] = ACTIONS(995),
    [anon_sym_where] = ACTIONS(995),
    [anon_sym_while] = ACTIONS(995),
    [sym_mutable_specifier] = ACTIONS(995),
    [sym_integer_literal] = ACTIONS(997),
    [aux_sym_string_literal_token1] = ACTIONS(997),
    [sym_char_literal] = ACTIONS(997),
    [anon_sym_true] = ACTIONS(995),
    [anon_sym_false] = ACTIONS(995),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(995),
    [sym_super] = ACTIONS(995),
    [sym_crate] = ACTIONS(995),
    [sym__raw_string_literal_start] = ACTIONS(997),
    [sym_float_literal] = ACTIONS(997),
  },
  [185] = {
    [sym_line_comment] = STATE(185),
    [sym_block_comment] = STATE(185),
    [sym_identifier] = ACTIONS(999),
    [anon_sym_SEMI] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1001),
    [anon_sym_RPAREN] = ACTIONS(1001),
    [anon_sym_LBRACK] = ACTIONS(1001),
    [anon_sym_RBRACK] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(1001),
    [anon_sym_RBRACE] = ACTIONS(1001),
    [anon_sym_EQ_GT] = ACTIONS(1001),
    [anon_sym_COLON] = ACTIONS(999),
    [anon_sym_DOLLAR] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_STAR] = ACTIONS(999),
    [anon_sym_QMARK] = ACTIONS(1001),
    [anon_sym_u8] = ACTIONS(999),
    [anon_sym_i8] = ACTIONS(999),
    [anon_sym_u16] = ACTIONS(999),
    [anon_sym_i16] = ACTIONS(999),
    [anon_sym_u32] = ACTIONS(999),
    [anon_sym_i32] = ACTIONS(999),
    [anon_sym_u64] = ACTIONS(999),
    [anon_sym_i64] = ACTIONS(999),
    [anon_sym_u128] = ACTIONS(999),
    [anon_sym_i128] = ACTIONS(999),
    [anon_sym_isize] = ACTIONS(999),
    [anon_sym_usize] = ACTIONS(999),
    [anon_sym_f32] = ACTIONS(999),
    [anon_sym_f64] = ACTIONS(999),
    [anon_sym_bool] = ACTIONS(999),
    [anon_sym_str] = ACTIONS(999),
    [anon_sym_char] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(999),
    [anon_sym_PERCENT] = ACTIONS(999),
    [anon_sym_CARET] = ACTIONS(999),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_AMP] = ACTIONS(999),
    [anon_sym_PIPE] = ACTIONS(999),
    [anon_sym_AMP_AMP] = ACTIONS(1001),
    [anon_sym_PIPE_PIPE] = ACTIONS(1001),
    [anon_sym_LT_LT] = ACTIONS(999),
    [anon_sym_GT_GT] = ACTIONS(999),
    [anon_sym_PLUS_EQ] = ACTIONS(1001),
    [anon_sym_DASH_EQ] = ACTIONS(1001),
    [anon_sym_STAR_EQ] = ACTIONS(1001),
    [anon_sym_SLASH_EQ] = ACTIONS(1001),
    [anon_sym_PERCENT_EQ] = ACTIONS(1001),
    [anon_sym_CARET_EQ] = ACTIONS(1001),
    [anon_sym_AMP_EQ] = ACTIONS(1001),
    [anon_sym_PIPE_EQ] = ACTIONS(1001),
    [anon_sym_LT_LT_EQ] = ACTIONS(1001),
    [anon_sym_GT_GT_EQ] = ACTIONS(1001),
    [anon_sym_EQ] = ACTIONS(999),
    [anon_sym_EQ_EQ] = ACTIONS(1001),
    [anon_sym_BANG_EQ] = ACTIONS(1001),
    [anon_sym_GT] = ACTIONS(999),
    [anon_sym_LT] = ACTIONS(999),
    [anon_sym_GT_EQ] = ACTIONS(1001),
    [anon_sym_LT_EQ] = ACTIONS(1001),
    [anon_sym_AT] = ACTIONS(1001),
    [anon_sym__] = ACTIONS(999),
    [anon_sym_DOT] = ACTIONS(999),
    [anon_sym_DOT_DOT] = ACTIONS(999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1001),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1001),
    [anon_sym_COMMA] = ACTIONS(1001),
    [anon_sym_COLON_COLON] = ACTIONS(1001),
    [anon_sym_DASH_GT] = ACTIONS(1001),
    [anon_sym_POUND] = ACTIONS(1001),
    [anon_sym_SQUOTE] = ACTIONS(999),
    [anon_sym_as] = ACTIONS(999),
    [anon_sym_async] = ACTIONS(999),
    [anon_sym_await] = ACTIONS(999),
    [anon_sym_break] = ACTIONS(999),
    [anon_sym_const] = ACTIONS(999),
    [anon_sym_continue] = ACTIONS(999),
    [anon_sym_default] = ACTIONS(999),
    [anon_sym_enum] = ACTIONS(999),
    [anon_sym_fn] = ACTIONS(999),
    [anon_sym_for] = ACTIONS(999),
    [anon_sym_if] = ACTIONS(999),
    [anon_sym_impl] = ACTIONS(999),
    [anon_sym_let] = ACTIONS(999),
    [anon_sym_loop] = ACTIONS(999),
    [anon_sym_match] = ACTIONS(999),
    [anon_sym_mod] = ACTIONS(999),
    [anon_sym_pub] = ACTIONS(999),
    [anon_sym_return] = ACTIONS(999),
    [anon_sym_static] = ACTIONS(999),
    [anon_sym_struct] = ACTIONS(999),
    [anon_sym_trait] = ACTIONS(999),
    [anon_sym_type] = ACTIONS(999),
    [anon_sym_union] = ACTIONS(999),
    [anon_sym_unsafe] = ACTIONS(999),
    [anon_sym_use] = ACTIONS(999),
    [anon_sym_where] = ACTIONS(999),
    [anon_sym_while] = ACTIONS(999),
    [sym_mutable_specifier] = ACTIONS(999),
    [sym_integer_literal] = ACTIONS(1001),
    [aux_sym_string_literal_token1] = ACTIONS(1001),
    [sym_char_literal] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(999),
    [anon_sym_false] = ACTIONS(999),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(999),
    [sym_super] = ACTIONS(999),
    [sym_crate] = ACTIONS(999),
    [sym__raw_string_literal_start] = ACTIONS(1001),
    [sym_float_literal] = ACTIONS(1001),
  },
  [186] = {
    [sym_attribute_item] = STATE(999),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1583),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(186),
    [sym_block_comment] = STATE(186),
    [aux_sym_enum_variant_list_repeat1] = STATE(213),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(1003),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [187] = {
    [sym_line_comment] = STATE(187),
    [sym_block_comment] = STATE(187),
    [sym_identifier] = ACTIONS(793),
    [anon_sym_SEMI] = ACTIONS(795),
    [anon_sym_LPAREN] = ACTIONS(795),
    [anon_sym_RPAREN] = ACTIONS(795),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_RBRACK] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(795),
    [anon_sym_RBRACE] = ACTIONS(795),
    [anon_sym_EQ_GT] = ACTIONS(795),
    [anon_sym_COLON] = ACTIONS(793),
    [anon_sym_DOLLAR] = ACTIONS(795),
    [anon_sym_PLUS] = ACTIONS(793),
    [anon_sym_STAR] = ACTIONS(793),
    [anon_sym_QMARK] = ACTIONS(795),
    [anon_sym_u8] = ACTIONS(793),
    [anon_sym_i8] = ACTIONS(793),
    [anon_sym_u16] = ACTIONS(793),
    [anon_sym_i16] = ACTIONS(793),
    [anon_sym_u32] = ACTIONS(793),
    [anon_sym_i32] = ACTIONS(793),
    [anon_sym_u64] = ACTIONS(793),
    [anon_sym_i64] = ACTIONS(793),
    [anon_sym_u128] = ACTIONS(793),
    [anon_sym_i128] = ACTIONS(793),
    [anon_sym_isize] = ACTIONS(793),
    [anon_sym_usize] = ACTIONS(793),
    [anon_sym_f32] = ACTIONS(793),
    [anon_sym_f64] = ACTIONS(793),
    [anon_sym_bool] = ACTIONS(793),
    [anon_sym_str] = ACTIONS(793),
    [anon_sym_char] = ACTIONS(793),
    [anon_sym_DASH] = ACTIONS(793),
    [anon_sym_SLASH] = ACTIONS(793),
    [anon_sym_PERCENT] = ACTIONS(793),
    [anon_sym_CARET] = ACTIONS(793),
    [anon_sym_BANG] = ACTIONS(793),
    [anon_sym_AMP] = ACTIONS(793),
    [anon_sym_PIPE] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(795),
    [anon_sym_PIPE_PIPE] = ACTIONS(795),
    [anon_sym_LT_LT] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(795),
    [anon_sym_DASH_EQ] = ACTIONS(795),
    [anon_sym_STAR_EQ] = ACTIONS(795),
    [anon_sym_SLASH_EQ] = ACTIONS(795),
    [anon_sym_PERCENT_EQ] = ACTIONS(795),
    [anon_sym_CARET_EQ] = ACTIONS(795),
    [anon_sym_AMP_EQ] = ACTIONS(795),
    [anon_sym_PIPE_EQ] = ACTIONS(795),
    [anon_sym_LT_LT_EQ] = ACTIONS(795),
    [anon_sym_GT_GT_EQ] = ACTIONS(795),
    [anon_sym_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(795),
    [anon_sym_BANG_EQ] = ACTIONS(795),
    [anon_sym_GT] = ACTIONS(793),
    [anon_sym_LT] = ACTIONS(793),
    [anon_sym_GT_EQ] = ACTIONS(795),
    [anon_sym_LT_EQ] = ACTIONS(795),
    [anon_sym_AT] = ACTIONS(795),
    [anon_sym__] = ACTIONS(793),
    [anon_sym_DOT] = ACTIONS(793),
    [anon_sym_DOT_DOT] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(795),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(795),
    [anon_sym_COMMA] = ACTIONS(795),
    [anon_sym_COLON_COLON] = ACTIONS(795),
    [anon_sym_DASH_GT] = ACTIONS(795),
    [anon_sym_POUND] = ACTIONS(795),
    [anon_sym_SQUOTE] = ACTIONS(793),
    [anon_sym_as] = ACTIONS(793),
    [anon_sym_async] = ACTIONS(793),
    [anon_sym_await] = ACTIONS(793),
    [anon_sym_break] = ACTIONS(793),
    [anon_sym_const] = ACTIONS(793),
    [anon_sym_continue] = ACTIONS(793),
    [anon_sym_default] = ACTIONS(793),
    [anon_sym_enum] = ACTIONS(793),
    [anon_sym_fn] = ACTIONS(793),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_if] = ACTIONS(793),
    [anon_sym_impl] = ACTIONS(793),
    [anon_sym_let] = ACTIONS(793),
    [anon_sym_loop] = ACTIONS(793),
    [anon_sym_match] = ACTIONS(793),
    [anon_sym_mod] = ACTIONS(793),
    [anon_sym_pub] = ACTIONS(793),
    [anon_sym_return] = ACTIONS(793),
    [anon_sym_static] = ACTIONS(793),
    [anon_sym_struct] = ACTIONS(793),
    [anon_sym_trait] = ACTIONS(793),
    [anon_sym_type] = ACTIONS(793),
    [anon_sym_union] = ACTIONS(793),
    [anon_sym_unsafe] = ACTIONS(793),
    [anon_sym_use] = ACTIONS(793),
    [anon_sym_where] = ACTIONS(793),
    [anon_sym_while] = ACTIONS(793),
    [sym_mutable_specifier] = ACTIONS(793),
    [sym_integer_literal] = ACTIONS(795),
    [aux_sym_string_literal_token1] = ACTIONS(795),
    [sym_char_literal] = ACTIONS(795),
    [anon_sym_true] = ACTIONS(793),
    [anon_sym_false] = ACTIONS(793),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(793),
    [sym_super] = ACTIONS(793),
    [sym_crate] = ACTIONS(793),
    [sym__raw_string_literal_start] = ACTIONS(795),
    [sym_float_literal] = ACTIONS(795),
  },
  [188] = {
    [sym_line_comment] = STATE(188),
    [sym_block_comment] = STATE(188),
    [sym_identifier] = ACTIONS(763),
    [anon_sym_SEMI] = ACTIONS(765),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_RPAREN] = ACTIONS(765),
    [anon_sym_LBRACK] = ACTIONS(765),
    [anon_sym_RBRACK] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(765),
    [anon_sym_RBRACE] = ACTIONS(765),
    [anon_sym_EQ_GT] = ACTIONS(765),
    [anon_sym_COLON] = ACTIONS(763),
    [anon_sym_DOLLAR] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(763),
    [anon_sym_STAR] = ACTIONS(763),
    [anon_sym_QMARK] = ACTIONS(765),
    [anon_sym_u8] = ACTIONS(763),
    [anon_sym_i8] = ACTIONS(763),
    [anon_sym_u16] = ACTIONS(763),
    [anon_sym_i16] = ACTIONS(763),
    [anon_sym_u32] = ACTIONS(763),
    [anon_sym_i32] = ACTIONS(763),
    [anon_sym_u64] = ACTIONS(763),
    [anon_sym_i64] = ACTIONS(763),
    [anon_sym_u128] = ACTIONS(763),
    [anon_sym_i128] = ACTIONS(763),
    [anon_sym_isize] = ACTIONS(763),
    [anon_sym_usize] = ACTIONS(763),
    [anon_sym_f32] = ACTIONS(763),
    [anon_sym_f64] = ACTIONS(763),
    [anon_sym_bool] = ACTIONS(763),
    [anon_sym_str] = ACTIONS(763),
    [anon_sym_char] = ACTIONS(763),
    [anon_sym_DASH] = ACTIONS(763),
    [anon_sym_SLASH] = ACTIONS(763),
    [anon_sym_PERCENT] = ACTIONS(763),
    [anon_sym_CARET] = ACTIONS(763),
    [anon_sym_BANG] = ACTIONS(763),
    [anon_sym_AMP] = ACTIONS(763),
    [anon_sym_PIPE] = ACTIONS(763),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_LT_LT] = ACTIONS(763),
    [anon_sym_GT_GT] = ACTIONS(763),
    [anon_sym_PLUS_EQ] = ACTIONS(765),
    [anon_sym_DASH_EQ] = ACTIONS(765),
    [anon_sym_STAR_EQ] = ACTIONS(765),
    [anon_sym_SLASH_EQ] = ACTIONS(765),
    [anon_sym_PERCENT_EQ] = ACTIONS(765),
    [anon_sym_CARET_EQ] = ACTIONS(765),
    [anon_sym_AMP_EQ] = ACTIONS(765),
    [anon_sym_PIPE_EQ] = ACTIONS(765),
    [anon_sym_LT_LT_EQ] = ACTIONS(765),
    [anon_sym_GT_GT_EQ] = ACTIONS(765),
    [anon_sym_EQ] = ACTIONS(763),
    [anon_sym_EQ_EQ] = ACTIONS(765),
    [anon_sym_BANG_EQ] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(763),
    [anon_sym_LT] = ACTIONS(763),
    [anon_sym_GT_EQ] = ACTIONS(765),
    [anon_sym_LT_EQ] = ACTIONS(765),
    [anon_sym_AT] = ACTIONS(765),
    [anon_sym__] = ACTIONS(763),
    [anon_sym_DOT] = ACTIONS(763),
    [anon_sym_DOT_DOT] = ACTIONS(763),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(765),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(765),
    [anon_sym_COMMA] = ACTIONS(765),
    [anon_sym_COLON_COLON] = ACTIONS(765),
    [anon_sym_DASH_GT] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(765),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_as] = ACTIONS(763),
    [anon_sym_async] = ACTIONS(763),
    [anon_sym_await] = ACTIONS(763),
    [anon_sym_break] = ACTIONS(763),
    [anon_sym_const] = ACTIONS(763),
    [anon_sym_continue] = ACTIONS(763),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_enum] = ACTIONS(763),
    [anon_sym_fn] = ACTIONS(763),
    [anon_sym_for] = ACTIONS(763),
    [anon_sym_if] = ACTIONS(763),
    [anon_sym_impl] = ACTIONS(763),
    [anon_sym_let] = ACTIONS(763),
    [anon_sym_loop] = ACTIONS(763),
    [anon_sym_match] = ACTIONS(763),
    [anon_sym_mod] = ACTIONS(763),
    [anon_sym_pub] = ACTIONS(763),
    [anon_sym_return] = ACTIONS(763),
    [anon_sym_static] = ACTIONS(763),
    [anon_sym_struct] = ACTIONS(763),
    [anon_sym_trait] = ACTIONS(763),
    [anon_sym_type] = ACTIONS(763),
    [anon_sym_union] = ACTIONS(763),
    [anon_sym_unsafe] = ACTIONS(763),
    [anon_sym_use] = ACTIONS(763),
    [anon_sym_where] = ACTIONS(763),
    [anon_sym_while] = ACTIONS(763),
    [sym_mutable_specifier] = ACTIONS(763),
    [sym_integer_literal] = ACTIONS(765),
    [aux_sym_string_literal_token1] = ACTIONS(765),
    [sym_char_literal] = ACTIONS(765),
    [anon_sym_true] = ACTIONS(763),
    [anon_sym_false] = ACTIONS(763),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(763),
    [sym_super] = ACTIONS(763),
    [sym_crate] = ACTIONS(763),
    [sym__raw_string_literal_start] = ACTIONS(765),
    [sym_float_literal] = ACTIONS(765),
  },
  [189] = {
    [sym_bracketed_type] = STATE(3488),
    [sym_generic_function] = STATE(1685),
    [sym_generic_type_with_turbofish] = STATE(2915),
    [sym__expression_except_range] = STATE(1580),
    [sym__expression] = STATE(1854),
    [sym_macro_invocation] = STATE(1695),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3184),
    [sym_range_expression] = STATE(1689),
    [sym_unary_expression] = STATE(1685),
    [sym_try_expression] = STATE(1685),
    [sym_reference_expression] = STATE(1685),
    [sym_binary_expression] = STATE(1685),
    [sym_assignment_expression] = STATE(1685),
    [sym_compound_assignment_expr] = STATE(1685),
    [sym_type_cast_expression] = STATE(1685),
    [sym_return_expression] = STATE(1685),
    [sym_yield_expression] = STATE(1685),
    [sym_call_expression] = STATE(1685),
    [sym_array_expression] = STATE(1685),
    [sym_parenthesized_expression] = STATE(1685),
    [sym_tuple_expression] = STATE(1685),
    [sym_unit_expression] = STATE(1685),
    [sym_struct_expression] = STATE(1685),
    [sym_if_expression] = STATE(1685),
    [sym_let_condition] = STATE(3103),
    [sym__let_chain] = STATE(3101),
    [sym__condition] = STATE(3548),
    [sym_match_expression] = STATE(1685),
    [sym_while_expression] = STATE(1685),
    [sym_loop_expression] = STATE(1685),
    [sym_for_expression] = STATE(1685),
    [sym_const_block] = STATE(1685),
    [sym_closure_expression] = STATE(1685),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3575),
    [sym_break_expression] = STATE(1685),
    [sym_continue_expression] = STATE(1685),
    [sym_index_expression] = STATE(1685),
    [sym_await_expression] = STATE(1685),
    [sym_field_expression] = STATE(1625),
    [sym_unsafe_block] = STATE(1685),
    [sym_async_block] = STATE(1685),
    [sym_try_block] = STATE(1685),
    [sym_block] = STATE(1685),
    [sym__literal] = STATE(1685),
    [sym_string_literal] = STATE(1831),
    [sym_raw_string_literal] = STATE(1831),
    [sym_boolean_literal] = STATE(1831),
    [sym_line_comment] = STATE(189),
    [sym_block_comment] = STATE(189),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_LBRACK] = ACTIONS(488),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(1005),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(1005),
    [anon_sym_BANG] = ACTIONS(1005),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1009),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_let] = ACTIONS(1011),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [190] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1736),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_let_condition] = STATE(2814),
    [sym__let_chain] = STATE(2815),
    [sym__condition] = STATE(2541),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(190),
    [sym_block_comment] = STATE(190),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(981),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(466),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_let] = ACTIONS(983),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(472),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(474),
    [anon_sym_move] = ACTIONS(476),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [191] = {
    [sym_attribute_item] = STATE(999),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1583),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(191),
    [sym_block_comment] = STATE(191),
    [aux_sym_enum_variant_list_repeat1] = STATE(213),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(1013),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [192] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1736),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_let_condition] = STATE(2814),
    [sym__let_chain] = STATE(2815),
    [sym__condition] = STATE(2614),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(192),
    [sym_block_comment] = STATE(192),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(981),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(466),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_let] = ACTIONS(983),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(472),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(474),
    [anon_sym_move] = ACTIONS(476),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [193] = {
    [sym_line_comment] = STATE(193),
    [sym_block_comment] = STATE(193),
    [sym_identifier] = ACTIONS(1015),
    [anon_sym_SEMI] = ACTIONS(1017),
    [anon_sym_LPAREN] = ACTIONS(1017),
    [anon_sym_RPAREN] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(1017),
    [anon_sym_RBRACK] = ACTIONS(1017),
    [anon_sym_LBRACE] = ACTIONS(1017),
    [anon_sym_RBRACE] = ACTIONS(1017),
    [anon_sym_EQ_GT] = ACTIONS(1017),
    [anon_sym_COLON] = ACTIONS(1015),
    [anon_sym_DOLLAR] = ACTIONS(1017),
    [anon_sym_PLUS] = ACTIONS(1015),
    [anon_sym_STAR] = ACTIONS(1015),
    [anon_sym_QMARK] = ACTIONS(1017),
    [anon_sym_u8] = ACTIONS(1015),
    [anon_sym_i8] = ACTIONS(1015),
    [anon_sym_u16] = ACTIONS(1015),
    [anon_sym_i16] = ACTIONS(1015),
    [anon_sym_u32] = ACTIONS(1015),
    [anon_sym_i32] = ACTIONS(1015),
    [anon_sym_u64] = ACTIONS(1015),
    [anon_sym_i64] = ACTIONS(1015),
    [anon_sym_u128] = ACTIONS(1015),
    [anon_sym_i128] = ACTIONS(1015),
    [anon_sym_isize] = ACTIONS(1015),
    [anon_sym_usize] = ACTIONS(1015),
    [anon_sym_f32] = ACTIONS(1015),
    [anon_sym_f64] = ACTIONS(1015),
    [anon_sym_bool] = ACTIONS(1015),
    [anon_sym_str] = ACTIONS(1015),
    [anon_sym_char] = ACTIONS(1015),
    [anon_sym_DASH] = ACTIONS(1015),
    [anon_sym_SLASH] = ACTIONS(1015),
    [anon_sym_PERCENT] = ACTIONS(1015),
    [anon_sym_CARET] = ACTIONS(1015),
    [anon_sym_BANG] = ACTIONS(1015),
    [anon_sym_AMP] = ACTIONS(1015),
    [anon_sym_PIPE] = ACTIONS(1015),
    [anon_sym_AMP_AMP] = ACTIONS(1017),
    [anon_sym_PIPE_PIPE] = ACTIONS(1017),
    [anon_sym_LT_LT] = ACTIONS(1015),
    [anon_sym_GT_GT] = ACTIONS(1015),
    [anon_sym_PLUS_EQ] = ACTIONS(1017),
    [anon_sym_DASH_EQ] = ACTIONS(1017),
    [anon_sym_STAR_EQ] = ACTIONS(1017),
    [anon_sym_SLASH_EQ] = ACTIONS(1017),
    [anon_sym_PERCENT_EQ] = ACTIONS(1017),
    [anon_sym_CARET_EQ] = ACTIONS(1017),
    [anon_sym_AMP_EQ] = ACTIONS(1017),
    [anon_sym_PIPE_EQ] = ACTIONS(1017),
    [anon_sym_LT_LT_EQ] = ACTIONS(1017),
    [anon_sym_GT_GT_EQ] = ACTIONS(1017),
    [anon_sym_EQ] = ACTIONS(1015),
    [anon_sym_EQ_EQ] = ACTIONS(1017),
    [anon_sym_BANG_EQ] = ACTIONS(1017),
    [anon_sym_GT] = ACTIONS(1015),
    [anon_sym_LT] = ACTIONS(1015),
    [anon_sym_GT_EQ] = ACTIONS(1017),
    [anon_sym_LT_EQ] = ACTIONS(1017),
    [anon_sym_AT] = ACTIONS(1017),
    [anon_sym__] = ACTIONS(1015),
    [anon_sym_DOT] = ACTIONS(1015),
    [anon_sym_DOT_DOT] = ACTIONS(1015),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1017),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1017),
    [anon_sym_COMMA] = ACTIONS(1017),
    [anon_sym_COLON_COLON] = ACTIONS(1017),
    [anon_sym_DASH_GT] = ACTIONS(1017),
    [anon_sym_POUND] = ACTIONS(1017),
    [anon_sym_SQUOTE] = ACTIONS(1015),
    [anon_sym_as] = ACTIONS(1015),
    [anon_sym_async] = ACTIONS(1015),
    [anon_sym_await] = ACTIONS(1015),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_const] = ACTIONS(1015),
    [anon_sym_continue] = ACTIONS(1015),
    [anon_sym_default] = ACTIONS(1015),
    [anon_sym_enum] = ACTIONS(1015),
    [anon_sym_fn] = ACTIONS(1015),
    [anon_sym_for] = ACTIONS(1015),
    [anon_sym_if] = ACTIONS(1015),
    [anon_sym_impl] = ACTIONS(1015),
    [anon_sym_let] = ACTIONS(1015),
    [anon_sym_loop] = ACTIONS(1015),
    [anon_sym_match] = ACTIONS(1015),
    [anon_sym_mod] = ACTIONS(1015),
    [anon_sym_pub] = ACTIONS(1015),
    [anon_sym_return] = ACTIONS(1015),
    [anon_sym_static] = ACTIONS(1015),
    [anon_sym_struct] = ACTIONS(1015),
    [anon_sym_trait] = ACTIONS(1015),
    [anon_sym_type] = ACTIONS(1015),
    [anon_sym_union] = ACTIONS(1015),
    [anon_sym_unsafe] = ACTIONS(1015),
    [anon_sym_use] = ACTIONS(1015),
    [anon_sym_where] = ACTIONS(1015),
    [anon_sym_while] = ACTIONS(1015),
    [sym_mutable_specifier] = ACTIONS(1015),
    [sym_integer_literal] = ACTIONS(1017),
    [aux_sym_string_literal_token1] = ACTIONS(1017),
    [sym_char_literal] = ACTIONS(1017),
    [anon_sym_true] = ACTIONS(1015),
    [anon_sym_false] = ACTIONS(1015),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1015),
    [sym_super] = ACTIONS(1015),
    [sym_crate] = ACTIONS(1015),
    [sym__raw_string_literal_start] = ACTIONS(1017),
    [sym_float_literal] = ACTIONS(1017),
  },
  [194] = {
    [sym_attribute_item] = STATE(999),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1654),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(194),
    [sym_block_comment] = STATE(194),
    [aux_sym_enum_variant_list_repeat1] = STATE(214),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(1019),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [195] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1736),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_let_condition] = STATE(2814),
    [sym__let_chain] = STATE(2815),
    [sym__condition] = STATE(2531),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(195),
    [sym_block_comment] = STATE(195),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(981),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(466),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_let] = ACTIONS(983),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(472),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(474),
    [anon_sym_move] = ACTIONS(476),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [196] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1736),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_let_condition] = STATE(2814),
    [sym__let_chain] = STATE(2815),
    [sym__condition] = STATE(2503),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(196),
    [sym_block_comment] = STATE(196),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(981),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(466),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_let] = ACTIONS(983),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(472),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(474),
    [anon_sym_move] = ACTIONS(476),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [197] = {
    [sym_attribute_item] = STATE(999),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1583),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(197),
    [sym_block_comment] = STATE(197),
    [aux_sym_enum_variant_list_repeat1] = STATE(213),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [198] = {
    [sym_attribute_item] = STATE(999),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1744),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(198),
    [sym_block_comment] = STATE(198),
    [aux_sym_enum_variant_list_repeat1] = STATE(212),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(1023),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [199] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1736),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_let_condition] = STATE(2814),
    [sym__let_chain] = STATE(2815),
    [sym__condition] = STATE(2628),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(199),
    [sym_block_comment] = STATE(199),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(981),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(466),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_let] = ACTIONS(983),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(472),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(474),
    [anon_sym_move] = ACTIONS(476),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [200] = {
    [sym_line_comment] = STATE(200),
    [sym_block_comment] = STATE(200),
    [sym_identifier] = ACTIONS(789),
    [anon_sym_SEMI] = ACTIONS(791),
    [anon_sym_LPAREN] = ACTIONS(791),
    [anon_sym_RPAREN] = ACTIONS(791),
    [anon_sym_LBRACK] = ACTIONS(791),
    [anon_sym_RBRACK] = ACTIONS(791),
    [anon_sym_LBRACE] = ACTIONS(791),
    [anon_sym_RBRACE] = ACTIONS(791),
    [anon_sym_EQ_GT] = ACTIONS(791),
    [anon_sym_COLON] = ACTIONS(789),
    [anon_sym_DOLLAR] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(789),
    [anon_sym_STAR] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_u8] = ACTIONS(789),
    [anon_sym_i8] = ACTIONS(789),
    [anon_sym_u16] = ACTIONS(789),
    [anon_sym_i16] = ACTIONS(789),
    [anon_sym_u32] = ACTIONS(789),
    [anon_sym_i32] = ACTIONS(789),
    [anon_sym_u64] = ACTIONS(789),
    [anon_sym_i64] = ACTIONS(789),
    [anon_sym_u128] = ACTIONS(789),
    [anon_sym_i128] = ACTIONS(789),
    [anon_sym_isize] = ACTIONS(789),
    [anon_sym_usize] = ACTIONS(789),
    [anon_sym_f32] = ACTIONS(789),
    [anon_sym_f64] = ACTIONS(789),
    [anon_sym_bool] = ACTIONS(789),
    [anon_sym_str] = ACTIONS(789),
    [anon_sym_char] = ACTIONS(789),
    [anon_sym_DASH] = ACTIONS(789),
    [anon_sym_SLASH] = ACTIONS(789),
    [anon_sym_PERCENT] = ACTIONS(789),
    [anon_sym_CARET] = ACTIONS(789),
    [anon_sym_BANG] = ACTIONS(789),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(789),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [anon_sym_LT_LT] = ACTIONS(789),
    [anon_sym_GT_GT] = ACTIONS(789),
    [anon_sym_PLUS_EQ] = ACTIONS(791),
    [anon_sym_DASH_EQ] = ACTIONS(791),
    [anon_sym_STAR_EQ] = ACTIONS(791),
    [anon_sym_SLASH_EQ] = ACTIONS(791),
    [anon_sym_PERCENT_EQ] = ACTIONS(791),
    [anon_sym_CARET_EQ] = ACTIONS(791),
    [anon_sym_AMP_EQ] = ACTIONS(791),
    [anon_sym_PIPE_EQ] = ACTIONS(791),
    [anon_sym_LT_LT_EQ] = ACTIONS(791),
    [anon_sym_GT_GT_EQ] = ACTIONS(791),
    [anon_sym_EQ] = ACTIONS(789),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_BANG_EQ] = ACTIONS(791),
    [anon_sym_GT] = ACTIONS(789),
    [anon_sym_LT] = ACTIONS(789),
    [anon_sym_GT_EQ] = ACTIONS(791),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_AT] = ACTIONS(791),
    [anon_sym__] = ACTIONS(789),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_DOT_DOT] = ACTIONS(789),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(791),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(791),
    [anon_sym_COMMA] = ACTIONS(791),
    [anon_sym_COLON_COLON] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(791),
    [anon_sym_POUND] = ACTIONS(791),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [anon_sym_as] = ACTIONS(789),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_await] = ACTIONS(789),
    [anon_sym_break] = ACTIONS(789),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_continue] = ACTIONS(789),
    [anon_sym_default] = ACTIONS(789),
    [anon_sym_enum] = ACTIONS(789),
    [anon_sym_fn] = ACTIONS(789),
    [anon_sym_for] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_impl] = ACTIONS(789),
    [anon_sym_let] = ACTIONS(789),
    [anon_sym_loop] = ACTIONS(789),
    [anon_sym_match] = ACTIONS(789),
    [anon_sym_mod] = ACTIONS(789),
    [anon_sym_pub] = ACTIONS(789),
    [anon_sym_return] = ACTIONS(789),
    [anon_sym_static] = ACTIONS(789),
    [anon_sym_struct] = ACTIONS(789),
    [anon_sym_trait] = ACTIONS(789),
    [anon_sym_type] = ACTIONS(789),
    [anon_sym_union] = ACTIONS(789),
    [anon_sym_unsafe] = ACTIONS(789),
    [anon_sym_use] = ACTIONS(789),
    [anon_sym_where] = ACTIONS(789),
    [anon_sym_while] = ACTIONS(789),
    [sym_mutable_specifier] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [aux_sym_string_literal_token1] = ACTIONS(791),
    [sym_char_literal] = ACTIONS(791),
    [anon_sym_true] = ACTIONS(789),
    [anon_sym_false] = ACTIONS(789),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(789),
    [sym_super] = ACTIONS(789),
    [sym_crate] = ACTIONS(789),
    [sym__raw_string_literal_start] = ACTIONS(791),
    [sym_float_literal] = ACTIONS(791),
  },
  [201] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1736),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_let_condition] = STATE(2814),
    [sym__let_chain] = STATE(2815),
    [sym__condition] = STATE(2640),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(201),
    [sym_block_comment] = STATE(201),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(981),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(466),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_let] = ACTIONS(983),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(472),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(474),
    [anon_sym_move] = ACTIONS(476),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [202] = {
    [sym_attribute_item] = STATE(999),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1583),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(202),
    [sym_block_comment] = STATE(202),
    [aux_sym_enum_variant_list_repeat1] = STATE(213),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(1025),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [203] = {
    [sym_line_comment] = STATE(203),
    [sym_block_comment] = STATE(203),
    [sym_identifier] = ACTIONS(1027),
    [anon_sym_SEMI] = ACTIONS(1029),
    [anon_sym_LPAREN] = ACTIONS(1029),
    [anon_sym_RPAREN] = ACTIONS(1029),
    [anon_sym_LBRACK] = ACTIONS(1029),
    [anon_sym_RBRACK] = ACTIONS(1029),
    [anon_sym_LBRACE] = ACTIONS(1029),
    [anon_sym_RBRACE] = ACTIONS(1029),
    [anon_sym_EQ_GT] = ACTIONS(1029),
    [anon_sym_COLON] = ACTIONS(1027),
    [anon_sym_DOLLAR] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1027),
    [anon_sym_STAR] = ACTIONS(1027),
    [anon_sym_QMARK] = ACTIONS(1029),
    [anon_sym_u8] = ACTIONS(1027),
    [anon_sym_i8] = ACTIONS(1027),
    [anon_sym_u16] = ACTIONS(1027),
    [anon_sym_i16] = ACTIONS(1027),
    [anon_sym_u32] = ACTIONS(1027),
    [anon_sym_i32] = ACTIONS(1027),
    [anon_sym_u64] = ACTIONS(1027),
    [anon_sym_i64] = ACTIONS(1027),
    [anon_sym_u128] = ACTIONS(1027),
    [anon_sym_i128] = ACTIONS(1027),
    [anon_sym_isize] = ACTIONS(1027),
    [anon_sym_usize] = ACTIONS(1027),
    [anon_sym_f32] = ACTIONS(1027),
    [anon_sym_f64] = ACTIONS(1027),
    [anon_sym_bool] = ACTIONS(1027),
    [anon_sym_str] = ACTIONS(1027),
    [anon_sym_char] = ACTIONS(1027),
    [anon_sym_DASH] = ACTIONS(1027),
    [anon_sym_SLASH] = ACTIONS(1027),
    [anon_sym_PERCENT] = ACTIONS(1027),
    [anon_sym_CARET] = ACTIONS(1027),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_AMP] = ACTIONS(1027),
    [anon_sym_PIPE] = ACTIONS(1027),
    [anon_sym_AMP_AMP] = ACTIONS(1029),
    [anon_sym_PIPE_PIPE] = ACTIONS(1029),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1027),
    [anon_sym_PLUS_EQ] = ACTIONS(1029),
    [anon_sym_DASH_EQ] = ACTIONS(1029),
    [anon_sym_STAR_EQ] = ACTIONS(1029),
    [anon_sym_SLASH_EQ] = ACTIONS(1029),
    [anon_sym_PERCENT_EQ] = ACTIONS(1029),
    [anon_sym_CARET_EQ] = ACTIONS(1029),
    [anon_sym_AMP_EQ] = ACTIONS(1029),
    [anon_sym_PIPE_EQ] = ACTIONS(1029),
    [anon_sym_LT_LT_EQ] = ACTIONS(1029),
    [anon_sym_GT_GT_EQ] = ACTIONS(1029),
    [anon_sym_EQ] = ACTIONS(1027),
    [anon_sym_EQ_EQ] = ACTIONS(1029),
    [anon_sym_BANG_EQ] = ACTIONS(1029),
    [anon_sym_GT] = ACTIONS(1027),
    [anon_sym_LT] = ACTIONS(1027),
    [anon_sym_GT_EQ] = ACTIONS(1029),
    [anon_sym_LT_EQ] = ACTIONS(1029),
    [anon_sym_AT] = ACTIONS(1029),
    [anon_sym__] = ACTIONS(1027),
    [anon_sym_DOT] = ACTIONS(1027),
    [anon_sym_DOT_DOT] = ACTIONS(1027),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1029),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1029),
    [anon_sym_COMMA] = ACTIONS(1029),
    [anon_sym_COLON_COLON] = ACTIONS(1029),
    [anon_sym_DASH_GT] = ACTIONS(1029),
    [anon_sym_POUND] = ACTIONS(1029),
    [anon_sym_SQUOTE] = ACTIONS(1027),
    [anon_sym_as] = ACTIONS(1027),
    [anon_sym_async] = ACTIONS(1027),
    [anon_sym_await] = ACTIONS(1027),
    [anon_sym_break] = ACTIONS(1027),
    [anon_sym_const] = ACTIONS(1027),
    [anon_sym_continue] = ACTIONS(1027),
    [anon_sym_default] = ACTIONS(1027),
    [anon_sym_enum] = ACTIONS(1027),
    [anon_sym_fn] = ACTIONS(1027),
    [anon_sym_for] = ACTIONS(1027),
    [anon_sym_if] = ACTIONS(1027),
    [anon_sym_impl] = ACTIONS(1027),
    [anon_sym_let] = ACTIONS(1027),
    [anon_sym_loop] = ACTIONS(1027),
    [anon_sym_match] = ACTIONS(1027),
    [anon_sym_mod] = ACTIONS(1027),
    [anon_sym_pub] = ACTIONS(1027),
    [anon_sym_return] = ACTIONS(1027),
    [anon_sym_static] = ACTIONS(1027),
    [anon_sym_struct] = ACTIONS(1027),
    [anon_sym_trait] = ACTIONS(1027),
    [anon_sym_type] = ACTIONS(1027),
    [anon_sym_union] = ACTIONS(1027),
    [anon_sym_unsafe] = ACTIONS(1027),
    [anon_sym_use] = ACTIONS(1027),
    [anon_sym_where] = ACTIONS(1027),
    [anon_sym_while] = ACTIONS(1027),
    [sym_mutable_specifier] = ACTIONS(1027),
    [sym_integer_literal] = ACTIONS(1029),
    [aux_sym_string_literal_token1] = ACTIONS(1029),
    [sym_char_literal] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1027),
    [anon_sym_false] = ACTIONS(1027),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1027),
    [sym_super] = ACTIONS(1027),
    [sym_crate] = ACTIONS(1027),
    [sym__raw_string_literal_start] = ACTIONS(1029),
    [sym_float_literal] = ACTIONS(1029),
  },
  [204] = {
    [sym_attribute_item] = STATE(999),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1583),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(204),
    [sym_block_comment] = STATE(204),
    [aux_sym_enum_variant_list_repeat1] = STATE(213),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(1031),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [205] = {
    [sym_attribute_item] = STATE(999),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1583),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(205),
    [sym_block_comment] = STATE(205),
    [aux_sym_enum_variant_list_repeat1] = STATE(213),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(1033),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [206] = {
    [sym_attribute_item] = STATE(999),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1583),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(206),
    [sym_block_comment] = STATE(206),
    [aux_sym_enum_variant_list_repeat1] = STATE(213),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(1035),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [207] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1736),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_let_condition] = STATE(2814),
    [sym__let_chain] = STATE(2815),
    [sym__condition] = STATE(2691),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(207),
    [sym_block_comment] = STATE(207),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(981),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(466),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_let] = ACTIONS(983),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(472),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(474),
    [anon_sym_move] = ACTIONS(476),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [208] = {
    [sym_line_comment] = STATE(208),
    [sym_block_comment] = STATE(208),
    [sym_identifier] = ACTIONS(797),
    [anon_sym_SEMI] = ACTIONS(799),
    [anon_sym_LPAREN] = ACTIONS(799),
    [anon_sym_RPAREN] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(799),
    [anon_sym_RBRACK] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(799),
    [anon_sym_RBRACE] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(799),
    [anon_sym_COLON] = ACTIONS(797),
    [anon_sym_DOLLAR] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(797),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(799),
    [anon_sym_u8] = ACTIONS(797),
    [anon_sym_i8] = ACTIONS(797),
    [anon_sym_u16] = ACTIONS(797),
    [anon_sym_i16] = ACTIONS(797),
    [anon_sym_u32] = ACTIONS(797),
    [anon_sym_i32] = ACTIONS(797),
    [anon_sym_u64] = ACTIONS(797),
    [anon_sym_i64] = ACTIONS(797),
    [anon_sym_u128] = ACTIONS(797),
    [anon_sym_i128] = ACTIONS(797),
    [anon_sym_isize] = ACTIONS(797),
    [anon_sym_usize] = ACTIONS(797),
    [anon_sym_f32] = ACTIONS(797),
    [anon_sym_f64] = ACTIONS(797),
    [anon_sym_bool] = ACTIONS(797),
    [anon_sym_str] = ACTIONS(797),
    [anon_sym_char] = ACTIONS(797),
    [anon_sym_DASH] = ACTIONS(797),
    [anon_sym_SLASH] = ACTIONS(797),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(797),
    [anon_sym_BANG] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(797),
    [anon_sym_PIPE] = ACTIONS(797),
    [anon_sym_AMP_AMP] = ACTIONS(799),
    [anon_sym_PIPE_PIPE] = ACTIONS(799),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_GT_GT] = ACTIONS(797),
    [anon_sym_PLUS_EQ] = ACTIONS(799),
    [anon_sym_DASH_EQ] = ACTIONS(799),
    [anon_sym_STAR_EQ] = ACTIONS(799),
    [anon_sym_SLASH_EQ] = ACTIONS(799),
    [anon_sym_PERCENT_EQ] = ACTIONS(799),
    [anon_sym_CARET_EQ] = ACTIONS(799),
    [anon_sym_AMP_EQ] = ACTIONS(799),
    [anon_sym_PIPE_EQ] = ACTIONS(799),
    [anon_sym_LT_LT_EQ] = ACTIONS(799),
    [anon_sym_GT_GT_EQ] = ACTIONS(799),
    [anon_sym_EQ] = ACTIONS(797),
    [anon_sym_EQ_EQ] = ACTIONS(799),
    [anon_sym_BANG_EQ] = ACTIONS(799),
    [anon_sym_GT] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(797),
    [anon_sym_GT_EQ] = ACTIONS(799),
    [anon_sym_LT_EQ] = ACTIONS(799),
    [anon_sym_AT] = ACTIONS(799),
    [anon_sym__] = ACTIONS(797),
    [anon_sym_DOT] = ACTIONS(797),
    [anon_sym_DOT_DOT] = ACTIONS(797),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(799),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(799),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_COLON_COLON] = ACTIONS(799),
    [anon_sym_DASH_GT] = ACTIONS(799),
    [anon_sym_POUND] = ACTIONS(799),
    [anon_sym_SQUOTE] = ACTIONS(797),
    [anon_sym_as] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(797),
    [anon_sym_await] = ACTIONS(797),
    [anon_sym_break] = ACTIONS(797),
    [anon_sym_const] = ACTIONS(797),
    [anon_sym_continue] = ACTIONS(797),
    [anon_sym_default] = ACTIONS(797),
    [anon_sym_enum] = ACTIONS(797),
    [anon_sym_fn] = ACTIONS(797),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_if] = ACTIONS(797),
    [anon_sym_impl] = ACTIONS(797),
    [anon_sym_let] = ACTIONS(797),
    [anon_sym_loop] = ACTIONS(797),
    [anon_sym_match] = ACTIONS(797),
    [anon_sym_mod] = ACTIONS(797),
    [anon_sym_pub] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(797),
    [anon_sym_static] = ACTIONS(797),
    [anon_sym_struct] = ACTIONS(797),
    [anon_sym_trait] = ACTIONS(797),
    [anon_sym_type] = ACTIONS(797),
    [anon_sym_union] = ACTIONS(797),
    [anon_sym_unsafe] = ACTIONS(797),
    [anon_sym_use] = ACTIONS(797),
    [anon_sym_where] = ACTIONS(797),
    [anon_sym_while] = ACTIONS(797),
    [sym_mutable_specifier] = ACTIONS(797),
    [sym_integer_literal] = ACTIONS(799),
    [aux_sym_string_literal_token1] = ACTIONS(799),
    [sym_char_literal] = ACTIONS(799),
    [anon_sym_true] = ACTIONS(797),
    [anon_sym_false] = ACTIONS(797),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(797),
    [sym_super] = ACTIONS(797),
    [sym_crate] = ACTIONS(797),
    [sym__raw_string_literal_start] = ACTIONS(799),
    [sym_float_literal] = ACTIONS(799),
  },
  [209] = {
    [sym_attribute_item] = STATE(999),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1583),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(209),
    [sym_block_comment] = STATE(209),
    [aux_sym_enum_variant_list_repeat1] = STATE(213),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [210] = {
    [sym_attribute_item] = STATE(999),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1565),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(210),
    [sym_block_comment] = STATE(210),
    [aux_sym_enum_variant_list_repeat1] = STATE(998),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [211] = {
    [sym_attribute_item] = STATE(999),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1582),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(211),
    [sym_block_comment] = STATE(211),
    [aux_sym_enum_variant_list_repeat1] = STATE(998),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [212] = {
    [sym_attribute_item] = STATE(999),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1837),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(212),
    [sym_block_comment] = STATE(212),
    [aux_sym_enum_variant_list_repeat1] = STATE(998),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [213] = {
    [sym_attribute_item] = STATE(999),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1602),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(213),
    [sym_block_comment] = STATE(213),
    [aux_sym_enum_variant_list_repeat1] = STATE(998),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [214] = {
    [sym_attribute_item] = STATE(999),
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1866),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(214),
    [sym_block_comment] = STATE(214),
    [aux_sym_enum_variant_list_repeat1] = STATE(998),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_POUND] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [215] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1675),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1159),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(215),
    [sym_block_comment] = STATE(215),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1037),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_DASH_GT] = ACTIONS(1039),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [216] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1722),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1153),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(216),
    [sym_block_comment] = STATE(216),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1041),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_DASH_GT] = ACTIONS(1043),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [217] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1734),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(225),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1159),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(217),
    [sym_block_comment] = STATE(217),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1045),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_AMP] = ACTIONS(1047),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1037),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_DASH_GT] = ACTIONS(1039),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(496),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [218] = {
    [sym_bracketed_type] = STATE(3488),
    [sym_generic_function] = STATE(1685),
    [sym_generic_type_with_turbofish] = STATE(2915),
    [sym__expression_except_range] = STATE(1580),
    [sym__expression] = STATE(1805),
    [sym_macro_invocation] = STATE(1695),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3184),
    [sym_range_expression] = STATE(1689),
    [sym_unary_expression] = STATE(1685),
    [sym_try_expression] = STATE(1685),
    [sym_reference_expression] = STATE(1685),
    [sym_binary_expression] = STATE(1685),
    [sym_assignment_expression] = STATE(1685),
    [sym_compound_assignment_expr] = STATE(1685),
    [sym_type_cast_expression] = STATE(1685),
    [sym_return_expression] = STATE(1685),
    [sym_yield_expression] = STATE(1685),
    [sym_call_expression] = STATE(1685),
    [sym_array_expression] = STATE(1685),
    [sym_parenthesized_expression] = STATE(1685),
    [sym_tuple_expression] = STATE(1685),
    [sym_unit_expression] = STATE(1685),
    [sym_struct_expression] = STATE(1685),
    [sym_if_expression] = STATE(1685),
    [sym_match_expression] = STATE(1685),
    [sym_while_expression] = STATE(1685),
    [sym_loop_expression] = STATE(1685),
    [sym_for_expression] = STATE(1685),
    [sym_const_block] = STATE(1685),
    [sym_closure_expression] = STATE(1685),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3575),
    [sym_break_expression] = STATE(1685),
    [sym_continue_expression] = STATE(1685),
    [sym_index_expression] = STATE(1685),
    [sym_await_expression] = STATE(1685),
    [sym_field_expression] = STATE(1625),
    [sym_unsafe_block] = STATE(1685),
    [sym_async_block] = STATE(1685),
    [sym_try_block] = STATE(1685),
    [sym_block] = STATE(1823),
    [sym__literal] = STATE(1685),
    [sym_string_literal] = STATE(1831),
    [sym_raw_string_literal] = STATE(1831),
    [sym_boolean_literal] = STATE(1831),
    [sym_line_comment] = STATE(218),
    [sym_block_comment] = STATE(218),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_LBRACK] = ACTIONS(488),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(1005),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(406),
    [anon_sym_BANG] = ACTIONS(1005),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1051),
    [anon_sym_DOT_DOT] = ACTIONS(1053),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_DASH_GT] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [219] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1568),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1281),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(219),
    [sym_block_comment] = STATE(219),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(460),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1057),
    [anon_sym_DOT_DOT] = ACTIONS(1059),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_DASH_GT] = ACTIONS(1061),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(466),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(472),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(474),
    [anon_sym_move] = ACTIONS(476),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [220] = {
    [sym_bracketed_type] = STATE(3488),
    [sym_generic_function] = STATE(1685),
    [sym_generic_type_with_turbofish] = STATE(2915),
    [sym__expression_except_range] = STATE(1580),
    [sym__expression] = STATE(1841),
    [sym_macro_invocation] = STATE(1695),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3184),
    [sym_range_expression] = STATE(1689),
    [sym_unary_expression] = STATE(1685),
    [sym_try_expression] = STATE(1685),
    [sym_reference_expression] = STATE(1685),
    [sym_binary_expression] = STATE(1685),
    [sym_assignment_expression] = STATE(1685),
    [sym_compound_assignment_expr] = STATE(1685),
    [sym_type_cast_expression] = STATE(1685),
    [sym_return_expression] = STATE(1685),
    [sym_yield_expression] = STATE(1685),
    [sym_call_expression] = STATE(1685),
    [sym_array_expression] = STATE(1685),
    [sym_parenthesized_expression] = STATE(1685),
    [sym_tuple_expression] = STATE(1685),
    [sym_unit_expression] = STATE(1685),
    [sym_struct_expression] = STATE(1685),
    [sym_if_expression] = STATE(1685),
    [sym_let_condition] = STATE(2562),
    [sym_match_expression] = STATE(1685),
    [sym_while_expression] = STATE(1685),
    [sym_loop_expression] = STATE(1685),
    [sym_for_expression] = STATE(1685),
    [sym_const_block] = STATE(1685),
    [sym_closure_expression] = STATE(1685),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3575),
    [sym_break_expression] = STATE(1685),
    [sym_continue_expression] = STATE(1685),
    [sym_index_expression] = STATE(1685),
    [sym_await_expression] = STATE(1685),
    [sym_field_expression] = STATE(1625),
    [sym_unsafe_block] = STATE(1685),
    [sym_async_block] = STATE(1685),
    [sym_try_block] = STATE(1685),
    [sym_block] = STATE(1685),
    [sym__literal] = STATE(1685),
    [sym_string_literal] = STATE(1831),
    [sym_raw_string_literal] = STATE(1831),
    [sym_boolean_literal] = STATE(1831),
    [sym_line_comment] = STATE(220),
    [sym_block_comment] = STATE(220),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_LBRACK] = ACTIONS(488),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(1005),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(1005),
    [anon_sym_BANG] = ACTIONS(1005),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1009),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_let] = ACTIONS(1011),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [221] = {
    [sym_bracketed_type] = STATE(3488),
    [sym_generic_function] = STATE(1685),
    [sym_generic_type_with_turbofish] = STATE(2915),
    [sym__expression_except_range] = STATE(1580),
    [sym__expression] = STATE(1653),
    [sym_macro_invocation] = STATE(1695),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3184),
    [sym_range_expression] = STATE(1689),
    [sym_unary_expression] = STATE(1685),
    [sym_try_expression] = STATE(1685),
    [sym_reference_expression] = STATE(1685),
    [sym_binary_expression] = STATE(1685),
    [sym_assignment_expression] = STATE(1685),
    [sym_compound_assignment_expr] = STATE(1685),
    [sym_type_cast_expression] = STATE(1685),
    [sym_return_expression] = STATE(1685),
    [sym_yield_expression] = STATE(1685),
    [sym_call_expression] = STATE(1685),
    [sym_array_expression] = STATE(1685),
    [sym_parenthesized_expression] = STATE(1685),
    [sym_tuple_expression] = STATE(1685),
    [sym_unit_expression] = STATE(1685),
    [sym_struct_expression] = STATE(1685),
    [sym_if_expression] = STATE(1685),
    [sym_let_condition] = STATE(2562),
    [sym_match_expression] = STATE(1685),
    [sym_while_expression] = STATE(1685),
    [sym_loop_expression] = STATE(1685),
    [sym_for_expression] = STATE(1685),
    [sym_const_block] = STATE(1685),
    [sym_closure_expression] = STATE(1685),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3575),
    [sym_break_expression] = STATE(1685),
    [sym_continue_expression] = STATE(1685),
    [sym_index_expression] = STATE(1685),
    [sym_await_expression] = STATE(1685),
    [sym_field_expression] = STATE(1625),
    [sym_unsafe_block] = STATE(1685),
    [sym_async_block] = STATE(1685),
    [sym_try_block] = STATE(1685),
    [sym_block] = STATE(1685),
    [sym__literal] = STATE(1685),
    [sym_string_literal] = STATE(1831),
    [sym_raw_string_literal] = STATE(1831),
    [sym_boolean_literal] = STATE(1831),
    [sym_line_comment] = STATE(221),
    [sym_block_comment] = STATE(221),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_LBRACK] = ACTIONS(488),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(1005),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(1005),
    [anon_sym_BANG] = ACTIONS(1005),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1053),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_let] = ACTIONS(1011),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [222] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1494),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1281),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(222),
    [sym_block_comment] = STATE(222),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1057),
    [anon_sym_DOT_DOT] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_DASH_GT] = ACTIONS(1061),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [223] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1671),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(223),
    [sym_block_comment] = STATE(223),
    [aux_sym_tuple_expression_repeat1] = STATE(240),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(1065),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [224] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1618),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1159),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(224),
    [sym_block_comment] = STATE(224),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(460),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1037),
    [anon_sym_DOT_DOT] = ACTIONS(1059),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_DASH_GT] = ACTIONS(1039),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(466),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(472),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(474),
    [anon_sym_move] = ACTIONS(476),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [225] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1710),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(225),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1153),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(225),
    [sym_block_comment] = STATE(225),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1045),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_AMP] = ACTIONS(1047),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1041),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_DASH_GT] = ACTIONS(1043),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(496),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [226] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1593),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1153),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(226),
    [sym_block_comment] = STATE(226),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(460),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1041),
    [anon_sym_DOT_DOT] = ACTIONS(1059),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_DASH_GT] = ACTIONS(1043),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(466),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(472),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(474),
    [anon_sym_move] = ACTIONS(476),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [227] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1748),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(227),
    [sym_block_comment] = STATE(227),
    [aux_sym_tuple_expression_repeat1] = STATE(240),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(1067),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [228] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1748),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(228),
    [sym_block_comment] = STATE(228),
    [aux_sym_tuple_expression_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(1067),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [229] = {
    [sym_bracketed_type] = STATE(3488),
    [sym_generic_function] = STATE(1685),
    [sym_generic_type_with_turbofish] = STATE(2915),
    [sym__expression_except_range] = STATE(1580),
    [sym__expression] = STATE(1791),
    [sym_macro_invocation] = STATE(1695),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3184),
    [sym_range_expression] = STATE(1689),
    [sym_unary_expression] = STATE(1685),
    [sym_try_expression] = STATE(1685),
    [sym_reference_expression] = STATE(1685),
    [sym_binary_expression] = STATE(1685),
    [sym_assignment_expression] = STATE(1685),
    [sym_compound_assignment_expr] = STATE(1685),
    [sym_type_cast_expression] = STATE(1685),
    [sym_return_expression] = STATE(1685),
    [sym_yield_expression] = STATE(1685),
    [sym_call_expression] = STATE(1685),
    [sym_array_expression] = STATE(1685),
    [sym_parenthesized_expression] = STATE(1685),
    [sym_tuple_expression] = STATE(1685),
    [sym_unit_expression] = STATE(1685),
    [sym_struct_expression] = STATE(1685),
    [sym_if_expression] = STATE(1685),
    [sym_match_expression] = STATE(1685),
    [sym_while_expression] = STATE(1685),
    [sym_loop_expression] = STATE(1685),
    [sym_for_expression] = STATE(1685),
    [sym_const_block] = STATE(1685),
    [sym_closure_expression] = STATE(1685),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3575),
    [sym_break_expression] = STATE(1685),
    [sym_continue_expression] = STATE(1685),
    [sym_index_expression] = STATE(1685),
    [sym_await_expression] = STATE(1685),
    [sym_field_expression] = STATE(1625),
    [sym_unsafe_block] = STATE(1685),
    [sym_async_block] = STATE(1685),
    [sym_try_block] = STATE(1685),
    [sym_block] = STATE(1797),
    [sym__literal] = STATE(1685),
    [sym_string_literal] = STATE(1831),
    [sym_raw_string_literal] = STATE(1831),
    [sym_boolean_literal] = STATE(1831),
    [sym_line_comment] = STATE(229),
    [sym_block_comment] = STATE(229),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_LBRACK] = ACTIONS(488),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(1005),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(406),
    [anon_sym_BANG] = ACTIONS(1005),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1069),
    [anon_sym_DOT_DOT] = ACTIONS(1053),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_DASH_GT] = ACTIONS(1071),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [230] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1640),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1281),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(230),
    [sym_block_comment] = STATE(230),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1057),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_DASH_GT] = ACTIONS(1061),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [231] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1787),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_let_condition] = STATE(2562),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(231),
    [sym_block_comment] = STATE(231),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(981),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(466),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_let] = ACTIONS(983),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(472),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(474),
    [anon_sym_move] = ACTIONS(476),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [232] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1717),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(232),
    [sym_block_comment] = STATE(232),
    [aux_sym_tuple_expression_repeat1] = STATE(240),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(1073),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [233] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1605),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_let_condition] = STATE(2562),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(233),
    [sym_block_comment] = STATE(233),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1059),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(466),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_let] = ACTIONS(983),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(472),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(474),
    [anon_sym_move] = ACTIONS(476),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [234] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1688),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(234),
    [sym_block_comment] = STATE(234),
    [aux_sym_tuple_expression_repeat1] = STATE(223),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [235] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1688),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(235),
    [sym_block_comment] = STATE(235),
    [aux_sym_tuple_expression_repeat1] = STATE(240),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [236] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1478),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1159),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(236),
    [sym_block_comment] = STATE(236),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1037),
    [anon_sym_DOT_DOT] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_DASH_GT] = ACTIONS(1039),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [237] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1480),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1153),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(237),
    [sym_block_comment] = STATE(237),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1041),
    [anon_sym_DOT_DOT] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_DASH_GT] = ACTIONS(1043),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [238] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1709),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(238),
    [sym_block_comment] = STATE(238),
    [aux_sym_tuple_expression_repeat1] = STATE(235),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(1077),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [239] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1699),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(239),
    [sym_block_comment] = STATE(239),
    [aux_sym_tuple_expression_repeat1] = STATE(227),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(1079),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [240] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1857),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(240),
    [sym_block_comment] = STATE(240),
    [aux_sym_tuple_expression_repeat1] = STATE(240),
    [sym_identifier] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(1084),
    [anon_sym_RPAREN] = ACTIONS(1087),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1092),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_u8] = ACTIONS(1098),
    [anon_sym_i8] = ACTIONS(1098),
    [anon_sym_u16] = ACTIONS(1098),
    [anon_sym_i16] = ACTIONS(1098),
    [anon_sym_u32] = ACTIONS(1098),
    [anon_sym_i32] = ACTIONS(1098),
    [anon_sym_u64] = ACTIONS(1098),
    [anon_sym_i64] = ACTIONS(1098),
    [anon_sym_u128] = ACTIONS(1098),
    [anon_sym_i128] = ACTIONS(1098),
    [anon_sym_isize] = ACTIONS(1098),
    [anon_sym_usize] = ACTIONS(1098),
    [anon_sym_f32] = ACTIONS(1098),
    [anon_sym_f64] = ACTIONS(1098),
    [anon_sym_bool] = ACTIONS(1098),
    [anon_sym_str] = ACTIONS(1098),
    [anon_sym_char] = ACTIONS(1098),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1101),
    [anon_sym_PIPE] = ACTIONS(1104),
    [anon_sym_LT] = ACTIONS(1107),
    [anon_sym_DOT_DOT] = ACTIONS(1110),
    [anon_sym_COLON_COLON] = ACTIONS(1113),
    [anon_sym_SQUOTE] = ACTIONS(1116),
    [anon_sym_async] = ACTIONS(1119),
    [anon_sym_break] = ACTIONS(1122),
    [anon_sym_const] = ACTIONS(1125),
    [anon_sym_continue] = ACTIONS(1128),
    [anon_sym_default] = ACTIONS(1131),
    [anon_sym_for] = ACTIONS(1134),
    [anon_sym_if] = ACTIONS(1137),
    [anon_sym_loop] = ACTIONS(1140),
    [anon_sym_match] = ACTIONS(1143),
    [anon_sym_return] = ACTIONS(1146),
    [anon_sym_static] = ACTIONS(1149),
    [anon_sym_union] = ACTIONS(1131),
    [anon_sym_unsafe] = ACTIONS(1152),
    [anon_sym_while] = ACTIONS(1155),
    [anon_sym_yield] = ACTIONS(1158),
    [anon_sym_move] = ACTIONS(1161),
    [anon_sym_try] = ACTIONS(1164),
    [sym_integer_literal] = ACTIONS(1167),
    [aux_sym_string_literal_token1] = ACTIONS(1170),
    [sym_char_literal] = ACTIONS(1167),
    [anon_sym_true] = ACTIONS(1173),
    [anon_sym_false] = ACTIONS(1173),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1176),
    [sym_super] = ACTIONS(1179),
    [sym_crate] = ACTIONS(1179),
    [sym_metavariable] = ACTIONS(1182),
    [sym__raw_string_literal_start] = ACTIONS(1185),
    [sym_float_literal] = ACTIONS(1167),
  },
  [241] = {
    [sym_bracketed_type] = STATE(3488),
    [sym_generic_function] = STATE(1685),
    [sym_generic_type_with_turbofish] = STATE(2915),
    [sym__expression_except_range] = STATE(1580),
    [sym__expression] = STATE(1810),
    [sym_macro_invocation] = STATE(1695),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3184),
    [sym_range_expression] = STATE(1689),
    [sym_unary_expression] = STATE(1685),
    [sym_try_expression] = STATE(1685),
    [sym_reference_expression] = STATE(1685),
    [sym_binary_expression] = STATE(1685),
    [sym_assignment_expression] = STATE(1685),
    [sym_compound_assignment_expr] = STATE(1685),
    [sym_type_cast_expression] = STATE(1685),
    [sym_return_expression] = STATE(1685),
    [sym_yield_expression] = STATE(1685),
    [sym_call_expression] = STATE(1685),
    [sym_array_expression] = STATE(1685),
    [sym_parenthesized_expression] = STATE(1685),
    [sym_tuple_expression] = STATE(1685),
    [sym_unit_expression] = STATE(1685),
    [sym_struct_expression] = STATE(1685),
    [sym_if_expression] = STATE(1685),
    [sym_match_expression] = STATE(1685),
    [sym_while_expression] = STATE(1685),
    [sym_loop_expression] = STATE(1685),
    [sym_for_expression] = STATE(1685),
    [sym_const_block] = STATE(1685),
    [sym_closure_expression] = STATE(1685),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3575),
    [sym_break_expression] = STATE(1685),
    [sym_continue_expression] = STATE(1685),
    [sym_index_expression] = STATE(1685),
    [sym_await_expression] = STATE(1685),
    [sym_field_expression] = STATE(1625),
    [sym_unsafe_block] = STATE(1685),
    [sym_async_block] = STATE(1685),
    [sym_try_block] = STATE(1685),
    [sym_block] = STATE(1759),
    [sym__literal] = STATE(1685),
    [sym_string_literal] = STATE(1831),
    [sym_raw_string_literal] = STATE(1831),
    [sym_boolean_literal] = STATE(1831),
    [sym_line_comment] = STATE(241),
    [sym_block_comment] = STATE(241),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_LBRACK] = ACTIONS(488),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(1005),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(406),
    [anon_sym_BANG] = ACTIONS(1005),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1188),
    [anon_sym_DOT_DOT] = ACTIONS(1053),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_DASH_GT] = ACTIONS(1190),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [242] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1786),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(225),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1281),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(242),
    [sym_block_comment] = STATE(242),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1045),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_AMP] = ACTIONS(1047),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1057),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_DASH_GT] = ACTIONS(1061),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(496),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [243] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1432),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(243),
    [sym_block_comment] = STATE(243),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1059),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(466),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(472),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [sym_mutable_specifier] = ACTIONS(1192),
    [anon_sym_yield] = ACTIONS(474),
    [anon_sym_move] = ACTIONS(476),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [244] = {
    [sym_else_clause] = STATE(384),
    [sym_line_comment] = STATE(244),
    [sym_block_comment] = STATE(244),
    [ts_builtin_sym_end] = ACTIONS(1194),
    [sym_identifier] = ACTIONS(1196),
    [anon_sym_SEMI] = ACTIONS(1194),
    [anon_sym_macro_rules_BANG] = ACTIONS(1194),
    [anon_sym_LPAREN] = ACTIONS(1194),
    [anon_sym_LBRACK] = ACTIONS(1194),
    [anon_sym_LBRACE] = ACTIONS(1194),
    [anon_sym_RBRACE] = ACTIONS(1194),
    [anon_sym_PLUS] = ACTIONS(1196),
    [anon_sym_STAR] = ACTIONS(1196),
    [anon_sym_QMARK] = ACTIONS(1194),
    [anon_sym_u8] = ACTIONS(1196),
    [anon_sym_i8] = ACTIONS(1196),
    [anon_sym_u16] = ACTIONS(1196),
    [anon_sym_i16] = ACTIONS(1196),
    [anon_sym_u32] = ACTIONS(1196),
    [anon_sym_i32] = ACTIONS(1196),
    [anon_sym_u64] = ACTIONS(1196),
    [anon_sym_i64] = ACTIONS(1196),
    [anon_sym_u128] = ACTIONS(1196),
    [anon_sym_i128] = ACTIONS(1196),
    [anon_sym_isize] = ACTIONS(1196),
    [anon_sym_usize] = ACTIONS(1196),
    [anon_sym_f32] = ACTIONS(1196),
    [anon_sym_f64] = ACTIONS(1196),
    [anon_sym_bool] = ACTIONS(1196),
    [anon_sym_str] = ACTIONS(1196),
    [anon_sym_char] = ACTIONS(1196),
    [anon_sym_DASH] = ACTIONS(1196),
    [anon_sym_SLASH] = ACTIONS(1196),
    [anon_sym_PERCENT] = ACTIONS(1196),
    [anon_sym_CARET] = ACTIONS(1196),
    [anon_sym_BANG] = ACTIONS(1196),
    [anon_sym_AMP] = ACTIONS(1196),
    [anon_sym_PIPE] = ACTIONS(1196),
    [anon_sym_AMP_AMP] = ACTIONS(1194),
    [anon_sym_PIPE_PIPE] = ACTIONS(1194),
    [anon_sym_LT_LT] = ACTIONS(1196),
    [anon_sym_GT_GT] = ACTIONS(1196),
    [anon_sym_PLUS_EQ] = ACTIONS(1194),
    [anon_sym_DASH_EQ] = ACTIONS(1194),
    [anon_sym_STAR_EQ] = ACTIONS(1194),
    [anon_sym_SLASH_EQ] = ACTIONS(1194),
    [anon_sym_PERCENT_EQ] = ACTIONS(1194),
    [anon_sym_CARET_EQ] = ACTIONS(1194),
    [anon_sym_AMP_EQ] = ACTIONS(1194),
    [anon_sym_PIPE_EQ] = ACTIONS(1194),
    [anon_sym_LT_LT_EQ] = ACTIONS(1194),
    [anon_sym_GT_GT_EQ] = ACTIONS(1194),
    [anon_sym_EQ] = ACTIONS(1196),
    [anon_sym_EQ_EQ] = ACTIONS(1194),
    [anon_sym_BANG_EQ] = ACTIONS(1194),
    [anon_sym_GT] = ACTIONS(1196),
    [anon_sym_LT] = ACTIONS(1196),
    [anon_sym_GT_EQ] = ACTIONS(1194),
    [anon_sym_LT_EQ] = ACTIONS(1194),
    [anon_sym_DOT] = ACTIONS(1196),
    [anon_sym_DOT_DOT] = ACTIONS(1196),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1194),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1194),
    [anon_sym_COLON_COLON] = ACTIONS(1194),
    [anon_sym_POUND] = ACTIONS(1194),
    [anon_sym_SQUOTE] = ACTIONS(1196),
    [anon_sym_as] = ACTIONS(1196),
    [anon_sym_async] = ACTIONS(1196),
    [anon_sym_break] = ACTIONS(1196),
    [anon_sym_const] = ACTIONS(1196),
    [anon_sym_continue] = ACTIONS(1196),
    [anon_sym_default] = ACTIONS(1196),
    [anon_sym_enum] = ACTIONS(1196),
    [anon_sym_fn] = ACTIONS(1196),
    [anon_sym_for] = ACTIONS(1196),
    [anon_sym_if] = ACTIONS(1196),
    [anon_sym_impl] = ACTIONS(1196),
    [anon_sym_let] = ACTIONS(1196),
    [anon_sym_loop] = ACTIONS(1196),
    [anon_sym_match] = ACTIONS(1196),
    [anon_sym_mod] = ACTIONS(1196),
    [anon_sym_pub] = ACTIONS(1196),
    [anon_sym_return] = ACTIONS(1196),
    [anon_sym_static] = ACTIONS(1196),
    [anon_sym_struct] = ACTIONS(1196),
    [anon_sym_trait] = ACTIONS(1196),
    [anon_sym_type] = ACTIONS(1196),
    [anon_sym_union] = ACTIONS(1196),
    [anon_sym_unsafe] = ACTIONS(1196),
    [anon_sym_use] = ACTIONS(1196),
    [anon_sym_while] = ACTIONS(1196),
    [anon_sym_extern] = ACTIONS(1196),
    [anon_sym_else] = ACTIONS(1198),
    [anon_sym_yield] = ACTIONS(1196),
    [anon_sym_move] = ACTIONS(1196),
    [anon_sym_try] = ACTIONS(1196),
    [sym_integer_literal] = ACTIONS(1194),
    [aux_sym_string_literal_token1] = ACTIONS(1194),
    [sym_char_literal] = ACTIONS(1194),
    [anon_sym_true] = ACTIONS(1196),
    [anon_sym_false] = ACTIONS(1196),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1196),
    [sym_super] = ACTIONS(1196),
    [sym_crate] = ACTIONS(1196),
    [sym_metavariable] = ACTIONS(1194),
    [sym__raw_string_literal_start] = ACTIONS(1194),
    [sym_float_literal] = ACTIONS(1194),
  },
  [245] = {
    [sym_bracketed_type] = STATE(3488),
    [sym_generic_function] = STATE(1685),
    [sym_generic_type_with_turbofish] = STATE(2915),
    [sym__expression_except_range] = STATE(1580),
    [sym__expression] = STATE(1700),
    [sym_macro_invocation] = STATE(1695),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3184),
    [sym_range_expression] = STATE(1689),
    [sym_unary_expression] = STATE(1685),
    [sym_try_expression] = STATE(1685),
    [sym_reference_expression] = STATE(1685),
    [sym_binary_expression] = STATE(1685),
    [sym_assignment_expression] = STATE(1685),
    [sym_compound_assignment_expr] = STATE(1685),
    [sym_type_cast_expression] = STATE(1685),
    [sym_return_expression] = STATE(1685),
    [sym_yield_expression] = STATE(1685),
    [sym_call_expression] = STATE(1685),
    [sym_array_expression] = STATE(1685),
    [sym_parenthesized_expression] = STATE(1685),
    [sym_tuple_expression] = STATE(1685),
    [sym_unit_expression] = STATE(1685),
    [sym_struct_expression] = STATE(1685),
    [sym_if_expression] = STATE(1685),
    [sym_match_expression] = STATE(1685),
    [sym_while_expression] = STATE(1685),
    [sym_loop_expression] = STATE(1685),
    [sym_for_expression] = STATE(1685),
    [sym_const_block] = STATE(1685),
    [sym_closure_expression] = STATE(1685),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3575),
    [sym_break_expression] = STATE(1685),
    [sym_continue_expression] = STATE(1685),
    [sym_index_expression] = STATE(1685),
    [sym_await_expression] = STATE(1685),
    [sym_field_expression] = STATE(1625),
    [sym_unsafe_block] = STATE(1685),
    [sym_async_block] = STATE(1685),
    [sym_try_block] = STATE(1685),
    [sym_block] = STATE(1685),
    [sym__literal] = STATE(1685),
    [sym_string_literal] = STATE(1831),
    [sym_raw_string_literal] = STATE(1831),
    [sym_boolean_literal] = STATE(1831),
    [sym_line_comment] = STATE(245),
    [sym_block_comment] = STATE(245),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_LBRACK] = ACTIONS(488),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(1005),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(1005),
    [anon_sym_BANG] = ACTIONS(1005),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1053),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [sym_mutable_specifier] = ACTIONS(1200),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [246] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1432),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(246),
    [sym_block_comment] = STATE(246),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [sym_mutable_specifier] = ACTIONS(1202),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [247] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1432),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(225),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(247),
    [sym_block_comment] = STATE(247),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1045),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_AMP] = ACTIONS(1047),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(496),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [sym_mutable_specifier] = ACTIONS(1204),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [248] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1733),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(225),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(248),
    [sym_block_comment] = STATE(248),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1045),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_AMP] = ACTIONS(1047),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1206),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(496),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [249] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1846),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(249),
    [sym_block_comment] = STATE(249),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [250] = {
    [sym_bracketed_type] = STATE(3488),
    [sym_generic_function] = STATE(1685),
    [sym_generic_type_with_turbofish] = STATE(2915),
    [sym__expression_except_range] = STATE(1580),
    [sym__expression] = STATE(1798),
    [sym_macro_invocation] = STATE(1695),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3184),
    [sym_range_expression] = STATE(1689),
    [sym_unary_expression] = STATE(1685),
    [sym_try_expression] = STATE(1685),
    [sym_reference_expression] = STATE(1685),
    [sym_binary_expression] = STATE(1685),
    [sym_assignment_expression] = STATE(1685),
    [sym_compound_assignment_expr] = STATE(1685),
    [sym_type_cast_expression] = STATE(1685),
    [sym_return_expression] = STATE(1685),
    [sym_yield_expression] = STATE(1685),
    [sym_call_expression] = STATE(1685),
    [sym_array_expression] = STATE(1685),
    [sym_parenthesized_expression] = STATE(1685),
    [sym_tuple_expression] = STATE(1685),
    [sym_unit_expression] = STATE(1685),
    [sym_struct_expression] = STATE(1685),
    [sym_if_expression] = STATE(1685),
    [sym_match_expression] = STATE(1685),
    [sym_while_expression] = STATE(1685),
    [sym_loop_expression] = STATE(1685),
    [sym_for_expression] = STATE(1685),
    [sym_const_block] = STATE(1685),
    [sym_closure_expression] = STATE(1685),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3575),
    [sym_break_expression] = STATE(1685),
    [sym_continue_expression] = STATE(1685),
    [sym_index_expression] = STATE(1685),
    [sym_await_expression] = STATE(1685),
    [sym_field_expression] = STATE(1625),
    [sym_unsafe_block] = STATE(1685),
    [sym_async_block] = STATE(1685),
    [sym_try_block] = STATE(1685),
    [sym_block] = STATE(1685),
    [sym__literal] = STATE(1685),
    [sym_string_literal] = STATE(1831),
    [sym_raw_string_literal] = STATE(1831),
    [sym_boolean_literal] = STATE(1831),
    [sym_line_comment] = STATE(250),
    [sym_block_comment] = STATE(250),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_LBRACK] = ACTIONS(488),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(1005),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(1005),
    [anon_sym_BANG] = ACTIONS(1005),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1053),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [251] = {
    [sym_bracketed_type] = STATE(3488),
    [sym_generic_function] = STATE(1685),
    [sym_generic_type_with_turbofish] = STATE(2915),
    [sym__expression_except_range] = STATE(1580),
    [sym__expression] = STATE(1660),
    [sym_macro_invocation] = STATE(1695),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3184),
    [sym_range_expression] = STATE(1689),
    [sym_unary_expression] = STATE(1685),
    [sym_try_expression] = STATE(1685),
    [sym_reference_expression] = STATE(1685),
    [sym_binary_expression] = STATE(1685),
    [sym_assignment_expression] = STATE(1685),
    [sym_compound_assignment_expr] = STATE(1685),
    [sym_type_cast_expression] = STATE(1685),
    [sym_return_expression] = STATE(1685),
    [sym_yield_expression] = STATE(1685),
    [sym_call_expression] = STATE(1685),
    [sym_array_expression] = STATE(1685),
    [sym_parenthesized_expression] = STATE(1685),
    [sym_tuple_expression] = STATE(1685),
    [sym_unit_expression] = STATE(1685),
    [sym_struct_expression] = STATE(1685),
    [sym_if_expression] = STATE(1685),
    [sym_match_expression] = STATE(1685),
    [sym_while_expression] = STATE(1685),
    [sym_loop_expression] = STATE(1685),
    [sym_for_expression] = STATE(1685),
    [sym_const_block] = STATE(1685),
    [sym_closure_expression] = STATE(1685),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3575),
    [sym_break_expression] = STATE(1685),
    [sym_continue_expression] = STATE(1685),
    [sym_index_expression] = STATE(1685),
    [sym_await_expression] = STATE(1685),
    [sym_field_expression] = STATE(1625),
    [sym_unsafe_block] = STATE(1685),
    [sym_async_block] = STATE(1685),
    [sym_try_block] = STATE(1685),
    [sym_block] = STATE(1685),
    [sym__literal] = STATE(1685),
    [sym_string_literal] = STATE(1831),
    [sym_raw_string_literal] = STATE(1831),
    [sym_boolean_literal] = STATE(1831),
    [sym_line_comment] = STATE(251),
    [sym_block_comment] = STATE(251),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_LBRACK] = ACTIONS(488),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(1005),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(1005),
    [anon_sym_BANG] = ACTIONS(1005),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1053),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [252] = {
    [sym_bracketed_type] = STATE(3488),
    [sym_generic_function] = STATE(1685),
    [sym_generic_type_with_turbofish] = STATE(2915),
    [sym__expression_except_range] = STATE(1580),
    [sym__expression] = STATE(1659),
    [sym_macro_invocation] = STATE(1695),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3184),
    [sym_range_expression] = STATE(1689),
    [sym_unary_expression] = STATE(1685),
    [sym_try_expression] = STATE(1685),
    [sym_reference_expression] = STATE(1685),
    [sym_binary_expression] = STATE(1685),
    [sym_assignment_expression] = STATE(1685),
    [sym_compound_assignment_expr] = STATE(1685),
    [sym_type_cast_expression] = STATE(1685),
    [sym_return_expression] = STATE(1685),
    [sym_yield_expression] = STATE(1685),
    [sym_call_expression] = STATE(1685),
    [sym_array_expression] = STATE(1685),
    [sym_parenthesized_expression] = STATE(1685),
    [sym_tuple_expression] = STATE(1685),
    [sym_unit_expression] = STATE(1685),
    [sym_struct_expression] = STATE(1685),
    [sym_if_expression] = STATE(1685),
    [sym_match_expression] = STATE(1685),
    [sym_while_expression] = STATE(1685),
    [sym_loop_expression] = STATE(1685),
    [sym_for_expression] = STATE(1685),
    [sym_const_block] = STATE(1685),
    [sym_closure_expression] = STATE(1685),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3575),
    [sym_break_expression] = STATE(1685),
    [sym_continue_expression] = STATE(1685),
    [sym_index_expression] = STATE(1685),
    [sym_await_expression] = STATE(1685),
    [sym_field_expression] = STATE(1625),
    [sym_unsafe_block] = STATE(1685),
    [sym_async_block] = STATE(1685),
    [sym_try_block] = STATE(1685),
    [sym_block] = STATE(1685),
    [sym__literal] = STATE(1685),
    [sym_string_literal] = STATE(1831),
    [sym_raw_string_literal] = STATE(1831),
    [sym_boolean_literal] = STATE(1831),
    [sym_line_comment] = STATE(252),
    [sym_block_comment] = STATE(252),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_LBRACK] = ACTIONS(488),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(1005),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(1005),
    [anon_sym_BANG] = ACTIONS(1005),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1053),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [253] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1436),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(253),
    [sym_block_comment] = STATE(253),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [254] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1436),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(225),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(254),
    [sym_block_comment] = STATE(254),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1045),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_AMP] = ACTIONS(1047),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(496),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [255] = {
    [sym_bracketed_type] = STATE(3488),
    [sym_generic_function] = STATE(1685),
    [sym_generic_type_with_turbofish] = STATE(2915),
    [sym__expression_except_range] = STATE(1580),
    [sym__expression] = STATE(1855),
    [sym_macro_invocation] = STATE(1695),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3184),
    [sym_range_expression] = STATE(1689),
    [sym_unary_expression] = STATE(1685),
    [sym_try_expression] = STATE(1685),
    [sym_reference_expression] = STATE(1685),
    [sym_binary_expression] = STATE(1685),
    [sym_assignment_expression] = STATE(1685),
    [sym_compound_assignment_expr] = STATE(1685),
    [sym_type_cast_expression] = STATE(1685),
    [sym_return_expression] = STATE(1685),
    [sym_yield_expression] = STATE(1685),
    [sym_call_expression] = STATE(1685),
    [sym_array_expression] = STATE(1685),
    [sym_parenthesized_expression] = STATE(1685),
    [sym_tuple_expression] = STATE(1685),
    [sym_unit_expression] = STATE(1685),
    [sym_struct_expression] = STATE(1685),
    [sym_if_expression] = STATE(1685),
    [sym_match_expression] = STATE(1685),
    [sym_while_expression] = STATE(1685),
    [sym_loop_expression] = STATE(1685),
    [sym_for_expression] = STATE(1685),
    [sym_const_block] = STATE(1685),
    [sym_closure_expression] = STATE(1685),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3575),
    [sym_break_expression] = STATE(1685),
    [sym_continue_expression] = STATE(1685),
    [sym_index_expression] = STATE(1685),
    [sym_await_expression] = STATE(1685),
    [sym_field_expression] = STATE(1625),
    [sym_unsafe_block] = STATE(1685),
    [sym_async_block] = STATE(1685),
    [sym_try_block] = STATE(1685),
    [sym_block] = STATE(1685),
    [sym__literal] = STATE(1685),
    [sym_string_literal] = STATE(1831),
    [sym_raw_string_literal] = STATE(1831),
    [sym_boolean_literal] = STATE(1831),
    [sym_line_comment] = STATE(255),
    [sym_block_comment] = STATE(255),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_LBRACK] = ACTIONS(488),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(1005),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(1005),
    [anon_sym_BANG] = ACTIONS(1005),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1009),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [256] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1739),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(225),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(256),
    [sym_block_comment] = STATE(256),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1045),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_AMP] = ACTIONS(1047),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1206),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(496),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [257] = {
    [sym_bracketed_type] = STATE(3488),
    [sym_generic_function] = STATE(1685),
    [sym_generic_type_with_turbofish] = STATE(2915),
    [sym__expression_except_range] = STATE(1580),
    [sym__expression] = STATE(1658),
    [sym_macro_invocation] = STATE(1695),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3184),
    [sym_range_expression] = STATE(1689),
    [sym_unary_expression] = STATE(1685),
    [sym_try_expression] = STATE(1685),
    [sym_reference_expression] = STATE(1685),
    [sym_binary_expression] = STATE(1685),
    [sym_assignment_expression] = STATE(1685),
    [sym_compound_assignment_expr] = STATE(1685),
    [sym_type_cast_expression] = STATE(1685),
    [sym_return_expression] = STATE(1685),
    [sym_yield_expression] = STATE(1685),
    [sym_call_expression] = STATE(1685),
    [sym_array_expression] = STATE(1685),
    [sym_parenthesized_expression] = STATE(1685),
    [sym_tuple_expression] = STATE(1685),
    [sym_unit_expression] = STATE(1685),
    [sym_struct_expression] = STATE(1685),
    [sym_if_expression] = STATE(1685),
    [sym_match_expression] = STATE(1685),
    [sym_while_expression] = STATE(1685),
    [sym_loop_expression] = STATE(1685),
    [sym_for_expression] = STATE(1685),
    [sym_const_block] = STATE(1685),
    [sym_closure_expression] = STATE(1685),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3575),
    [sym_break_expression] = STATE(1685),
    [sym_continue_expression] = STATE(1685),
    [sym_index_expression] = STATE(1685),
    [sym_await_expression] = STATE(1685),
    [sym_field_expression] = STATE(1625),
    [sym_unsafe_block] = STATE(1685),
    [sym_async_block] = STATE(1685),
    [sym_try_block] = STATE(1685),
    [sym_block] = STATE(1685),
    [sym__literal] = STATE(1685),
    [sym_string_literal] = STATE(1831),
    [sym_raw_string_literal] = STATE(1831),
    [sym_boolean_literal] = STATE(1831),
    [sym_line_comment] = STATE(257),
    [sym_block_comment] = STATE(257),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_LBRACK] = ACTIONS(488),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(1005),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(1005),
    [anon_sym_BANG] = ACTIONS(1005),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1053),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [258] = {
    [sym_bracketed_type] = STATE(3488),
    [sym_generic_function] = STATE(1685),
    [sym_generic_type_with_turbofish] = STATE(2915),
    [sym__expression_except_range] = STATE(1580),
    [sym__expression] = STATE(1653),
    [sym_macro_invocation] = STATE(1695),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3184),
    [sym_range_expression] = STATE(1689),
    [sym_unary_expression] = STATE(1685),
    [sym_try_expression] = STATE(1685),
    [sym_reference_expression] = STATE(1685),
    [sym_binary_expression] = STATE(1685),
    [sym_assignment_expression] = STATE(1685),
    [sym_compound_assignment_expr] = STATE(1685),
    [sym_type_cast_expression] = STATE(1685),
    [sym_return_expression] = STATE(1685),
    [sym_yield_expression] = STATE(1685),
    [sym_call_expression] = STATE(1685),
    [sym_array_expression] = STATE(1685),
    [sym_parenthesized_expression] = STATE(1685),
    [sym_tuple_expression] = STATE(1685),
    [sym_unit_expression] = STATE(1685),
    [sym_struct_expression] = STATE(1685),
    [sym_if_expression] = STATE(1685),
    [sym_match_expression] = STATE(1685),
    [sym_while_expression] = STATE(1685),
    [sym_loop_expression] = STATE(1685),
    [sym_for_expression] = STATE(1685),
    [sym_const_block] = STATE(1685),
    [sym_closure_expression] = STATE(1685),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3575),
    [sym_break_expression] = STATE(1685),
    [sym_continue_expression] = STATE(1685),
    [sym_index_expression] = STATE(1685),
    [sym_await_expression] = STATE(1685),
    [sym_field_expression] = STATE(1625),
    [sym_unsafe_block] = STATE(1685),
    [sym_async_block] = STATE(1685),
    [sym_try_block] = STATE(1685),
    [sym_block] = STATE(1685),
    [sym__literal] = STATE(1685),
    [sym_string_literal] = STATE(1831),
    [sym_raw_string_literal] = STATE(1831),
    [sym_boolean_literal] = STATE(1831),
    [sym_line_comment] = STATE(258),
    [sym_block_comment] = STATE(258),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_LBRACK] = ACTIONS(488),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(1005),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(1005),
    [anon_sym_BANG] = ACTIONS(1005),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1053),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [259] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1861),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(259),
    [sym_block_comment] = STATE(259),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [260] = {
    [sym_bracketed_type] = STATE(3488),
    [sym_generic_function] = STATE(1685),
    [sym_generic_type_with_turbofish] = STATE(2915),
    [sym__expression_except_range] = STATE(1580),
    [sym__expression] = STATE(1628),
    [sym_macro_invocation] = STATE(1695),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3184),
    [sym_range_expression] = STATE(1689),
    [sym_unary_expression] = STATE(1685),
    [sym_try_expression] = STATE(1685),
    [sym_reference_expression] = STATE(1685),
    [sym_binary_expression] = STATE(1685),
    [sym_assignment_expression] = STATE(1685),
    [sym_compound_assignment_expr] = STATE(1685),
    [sym_type_cast_expression] = STATE(1685),
    [sym_return_expression] = STATE(1685),
    [sym_yield_expression] = STATE(1685),
    [sym_call_expression] = STATE(1685),
    [sym_array_expression] = STATE(1685),
    [sym_parenthesized_expression] = STATE(1685),
    [sym_tuple_expression] = STATE(1685),
    [sym_unit_expression] = STATE(1685),
    [sym_struct_expression] = STATE(1685),
    [sym_if_expression] = STATE(1685),
    [sym_match_expression] = STATE(1685),
    [sym_while_expression] = STATE(1685),
    [sym_loop_expression] = STATE(1685),
    [sym_for_expression] = STATE(1685),
    [sym_const_block] = STATE(1685),
    [sym_closure_expression] = STATE(1685),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3575),
    [sym_break_expression] = STATE(1685),
    [sym_continue_expression] = STATE(1685),
    [sym_index_expression] = STATE(1685),
    [sym_await_expression] = STATE(1685),
    [sym_field_expression] = STATE(1625),
    [sym_unsafe_block] = STATE(1685),
    [sym_async_block] = STATE(1685),
    [sym_try_block] = STATE(1685),
    [sym_block] = STATE(1685),
    [sym__literal] = STATE(1685),
    [sym_string_literal] = STATE(1831),
    [sym_raw_string_literal] = STATE(1831),
    [sym_boolean_literal] = STATE(1831),
    [sym_line_comment] = STATE(260),
    [sym_block_comment] = STATE(260),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_LBRACK] = ACTIONS(488),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(1005),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(1005),
    [anon_sym_BANG] = ACTIONS(1005),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1053),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [261] = {
    [sym_bracketed_type] = STATE(3488),
    [sym_generic_function] = STATE(1685),
    [sym_generic_type_with_turbofish] = STATE(2915),
    [sym__expression_except_range] = STATE(1580),
    [sym__expression] = STATE(1652),
    [sym_macro_invocation] = STATE(1695),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3184),
    [sym_range_expression] = STATE(1689),
    [sym_unary_expression] = STATE(1685),
    [sym_try_expression] = STATE(1685),
    [sym_reference_expression] = STATE(1685),
    [sym_binary_expression] = STATE(1685),
    [sym_assignment_expression] = STATE(1685),
    [sym_compound_assignment_expr] = STATE(1685),
    [sym_type_cast_expression] = STATE(1685),
    [sym_return_expression] = STATE(1685),
    [sym_yield_expression] = STATE(1685),
    [sym_call_expression] = STATE(1685),
    [sym_array_expression] = STATE(1685),
    [sym_parenthesized_expression] = STATE(1685),
    [sym_tuple_expression] = STATE(1685),
    [sym_unit_expression] = STATE(1685),
    [sym_struct_expression] = STATE(1685),
    [sym_if_expression] = STATE(1685),
    [sym_match_expression] = STATE(1685),
    [sym_while_expression] = STATE(1685),
    [sym_loop_expression] = STATE(1685),
    [sym_for_expression] = STATE(1685),
    [sym_const_block] = STATE(1685),
    [sym_closure_expression] = STATE(1685),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3575),
    [sym_break_expression] = STATE(1685),
    [sym_continue_expression] = STATE(1685),
    [sym_index_expression] = STATE(1685),
    [sym_await_expression] = STATE(1685),
    [sym_field_expression] = STATE(1625),
    [sym_unsafe_block] = STATE(1685),
    [sym_async_block] = STATE(1685),
    [sym_try_block] = STATE(1685),
    [sym_block] = STATE(1685),
    [sym__literal] = STATE(1685),
    [sym_string_literal] = STATE(1831),
    [sym_raw_string_literal] = STATE(1831),
    [sym_boolean_literal] = STATE(1831),
    [sym_line_comment] = STATE(261),
    [sym_block_comment] = STATE(261),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_LBRACK] = ACTIONS(488),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(1005),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(1005),
    [anon_sym_BANG] = ACTIONS(1005),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1053),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [262] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1637),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(262),
    [sym_block_comment] = STATE(262),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [263] = {
    [sym_bracketed_type] = STATE(3488),
    [sym_generic_function] = STATE(1685),
    [sym_generic_type_with_turbofish] = STATE(2915),
    [sym__expression_except_range] = STATE(1580),
    [sym__expression] = STATE(1650),
    [sym_macro_invocation] = STATE(1695),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3184),
    [sym_range_expression] = STATE(1689),
    [sym_unary_expression] = STATE(1685),
    [sym_try_expression] = STATE(1685),
    [sym_reference_expression] = STATE(1685),
    [sym_binary_expression] = STATE(1685),
    [sym_assignment_expression] = STATE(1685),
    [sym_compound_assignment_expr] = STATE(1685),
    [sym_type_cast_expression] = STATE(1685),
    [sym_return_expression] = STATE(1685),
    [sym_yield_expression] = STATE(1685),
    [sym_call_expression] = STATE(1685),
    [sym_array_expression] = STATE(1685),
    [sym_parenthesized_expression] = STATE(1685),
    [sym_tuple_expression] = STATE(1685),
    [sym_unit_expression] = STATE(1685),
    [sym_struct_expression] = STATE(1685),
    [sym_if_expression] = STATE(1685),
    [sym_match_expression] = STATE(1685),
    [sym_while_expression] = STATE(1685),
    [sym_loop_expression] = STATE(1685),
    [sym_for_expression] = STATE(1685),
    [sym_const_block] = STATE(1685),
    [sym_closure_expression] = STATE(1685),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3575),
    [sym_break_expression] = STATE(1685),
    [sym_continue_expression] = STATE(1685),
    [sym_index_expression] = STATE(1685),
    [sym_await_expression] = STATE(1685),
    [sym_field_expression] = STATE(1625),
    [sym_unsafe_block] = STATE(1685),
    [sym_async_block] = STATE(1685),
    [sym_try_block] = STATE(1685),
    [sym_block] = STATE(1685),
    [sym__literal] = STATE(1685),
    [sym_string_literal] = STATE(1831),
    [sym_raw_string_literal] = STATE(1831),
    [sym_boolean_literal] = STATE(1831),
    [sym_line_comment] = STATE(263),
    [sym_block_comment] = STATE(263),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_LBRACK] = ACTIONS(488),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(1005),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(1005),
    [anon_sym_BANG] = ACTIONS(1005),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1053),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [264] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1859),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(264),
    [sym_block_comment] = STATE(264),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [265] = {
    [sym_bracketed_type] = STATE(3488),
    [sym_generic_function] = STATE(1685),
    [sym_generic_type_with_turbofish] = STATE(2915),
    [sym__expression_except_range] = STATE(1580),
    [sym__expression] = STATE(1644),
    [sym_macro_invocation] = STATE(1695),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3184),
    [sym_range_expression] = STATE(1689),
    [sym_unary_expression] = STATE(1685),
    [sym_try_expression] = STATE(1685),
    [sym_reference_expression] = STATE(1685),
    [sym_binary_expression] = STATE(1685),
    [sym_assignment_expression] = STATE(1685),
    [sym_compound_assignment_expr] = STATE(1685),
    [sym_type_cast_expression] = STATE(1685),
    [sym_return_expression] = STATE(1685),
    [sym_yield_expression] = STATE(1685),
    [sym_call_expression] = STATE(1685),
    [sym_array_expression] = STATE(1685),
    [sym_parenthesized_expression] = STATE(1685),
    [sym_tuple_expression] = STATE(1685),
    [sym_unit_expression] = STATE(1685),
    [sym_struct_expression] = STATE(1685),
    [sym_if_expression] = STATE(1685),
    [sym_match_expression] = STATE(1685),
    [sym_while_expression] = STATE(1685),
    [sym_loop_expression] = STATE(1685),
    [sym_for_expression] = STATE(1685),
    [sym_const_block] = STATE(1685),
    [sym_closure_expression] = STATE(1685),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3575),
    [sym_break_expression] = STATE(1685),
    [sym_continue_expression] = STATE(1685),
    [sym_index_expression] = STATE(1685),
    [sym_await_expression] = STATE(1685),
    [sym_field_expression] = STATE(1625),
    [sym_unsafe_block] = STATE(1685),
    [sym_async_block] = STATE(1685),
    [sym_try_block] = STATE(1685),
    [sym_block] = STATE(1685),
    [sym__literal] = STATE(1685),
    [sym_string_literal] = STATE(1831),
    [sym_raw_string_literal] = STATE(1831),
    [sym_boolean_literal] = STATE(1831),
    [sym_line_comment] = STATE(265),
    [sym_block_comment] = STATE(265),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_LBRACK] = ACTIONS(488),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(1005),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(1005),
    [anon_sym_BANG] = ACTIONS(1005),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1053),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [266] = {
    [sym_bracketed_type] = STATE(3488),
    [sym_generic_function] = STATE(1685),
    [sym_generic_type_with_turbofish] = STATE(2915),
    [sym__expression_except_range] = STATE(1580),
    [sym__expression] = STATE(1642),
    [sym_macro_invocation] = STATE(1695),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3184),
    [sym_range_expression] = STATE(1689),
    [sym_unary_expression] = STATE(1685),
    [sym_try_expression] = STATE(1685),
    [sym_reference_expression] = STATE(1685),
    [sym_binary_expression] = STATE(1685),
    [sym_assignment_expression] = STATE(1685),
    [sym_compound_assignment_expr] = STATE(1685),
    [sym_type_cast_expression] = STATE(1685),
    [sym_return_expression] = STATE(1685),
    [sym_yield_expression] = STATE(1685),
    [sym_call_expression] = STATE(1685),
    [sym_array_expression] = STATE(1685),
    [sym_parenthesized_expression] = STATE(1685),
    [sym_tuple_expression] = STATE(1685),
    [sym_unit_expression] = STATE(1685),
    [sym_struct_expression] = STATE(1685),
    [sym_if_expression] = STATE(1685),
    [sym_match_expression] = STATE(1685),
    [sym_while_expression] = STATE(1685),
    [sym_loop_expression] = STATE(1685),
    [sym_for_expression] = STATE(1685),
    [sym_const_block] = STATE(1685),
    [sym_closure_expression] = STATE(1685),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3575),
    [sym_break_expression] = STATE(1685),
    [sym_continue_expression] = STATE(1685),
    [sym_index_expression] = STATE(1685),
    [sym_await_expression] = STATE(1685),
    [sym_field_expression] = STATE(1625),
    [sym_unsafe_block] = STATE(1685),
    [sym_async_block] = STATE(1685),
    [sym_try_block] = STATE(1685),
    [sym_block] = STATE(1685),
    [sym__literal] = STATE(1685),
    [sym_string_literal] = STATE(1831),
    [sym_raw_string_literal] = STATE(1831),
    [sym_boolean_literal] = STATE(1831),
    [sym_line_comment] = STATE(266),
    [sym_block_comment] = STATE(266),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_LBRACK] = ACTIONS(488),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(1005),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(1005),
    [anon_sym_BANG] = ACTIONS(1005),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1053),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [267] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1865),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(267),
    [sym_block_comment] = STATE(267),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [268] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1485),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(268),
    [sym_block_comment] = STATE(268),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [269] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1201),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(269),
    [sym_block_comment] = STATE(269),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [270] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1475),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(270),
    [sym_block_comment] = STATE(270),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [271] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1493),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(271),
    [sym_block_comment] = STATE(271),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [272] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1495),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(272),
    [sym_block_comment] = STATE(272),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [273] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1490),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(273),
    [sym_block_comment] = STATE(273),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [274] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1496),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(274),
    [sym_block_comment] = STATE(274),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [275] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1474),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(275),
    [sym_block_comment] = STATE(275),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [276] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1486),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(276),
    [sym_block_comment] = STATE(276),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [277] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1489),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(277),
    [sym_block_comment] = STATE(277),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [278] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1482),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(278),
    [sym_block_comment] = STATE(278),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [279] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1477),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(279),
    [sym_block_comment] = STATE(279),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [280] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1704),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(225),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(280),
    [sym_block_comment] = STATE(280),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1045),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_AMP] = ACTIONS(1047),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1206),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(496),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [281] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1595),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(281),
    [sym_block_comment] = STATE(281),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1059),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(466),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(472),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(474),
    [anon_sym_move] = ACTIONS(476),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [282] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1475),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(282),
    [sym_block_comment] = STATE(282),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [283] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1668),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(283),
    [sym_block_comment] = STATE(283),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [284] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1864),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(284),
    [sym_block_comment] = STATE(284),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [285] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1566),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(285),
    [sym_block_comment] = STATE(285),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1059),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(466),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(472),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(474),
    [anon_sym_move] = ACTIONS(476),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [286] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1666),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(458),
    [sym_match_expression] = STATE(458),
    [sym_while_expression] = STATE(458),
    [sym_loop_expression] = STATE(458),
    [sym_for_expression] = STATE(458),
    [sym_const_block] = STATE(458),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3569),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(458),
    [sym_async_block] = STATE(458),
    [sym_try_block] = STATE(458),
    [sym_block] = STATE(458),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(286),
    [sym_block_comment] = STATE(286),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(1208),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(1210),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(1212),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(1214),
    [anon_sym_if] = ACTIONS(1216),
    [anon_sym_loop] = ACTIONS(1218),
    [anon_sym_match] = ACTIONS(1220),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(1222),
    [anon_sym_while] = ACTIONS(1224),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(1226),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [287] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1863),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(287),
    [sym_block_comment] = STATE(287),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [288] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1867),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(288),
    [sym_block_comment] = STATE(288),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [289] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1663),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(289),
    [sym_block_comment] = STATE(289),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [290] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1599),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(290),
    [sym_block_comment] = STATE(290),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1059),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(466),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(472),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(474),
    [anon_sym_move] = ACTIONS(476),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [291] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1662),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(291),
    [sym_block_comment] = STATE(291),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [292] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1600),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(292),
    [sym_block_comment] = STATE(292),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1059),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(466),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(472),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(474),
    [anon_sym_move] = ACTIONS(476),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [293] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1601),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(293),
    [sym_block_comment] = STATE(293),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1059),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(466),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(472),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(474),
    [anon_sym_move] = ACTIONS(476),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [294] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1764),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(225),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(294),
    [sym_block_comment] = STATE(294),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1045),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_AMP] = ACTIONS(1047),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(496),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [295] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1790),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(295),
    [sym_block_comment] = STATE(295),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [296] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1606),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(296),
    [sym_block_comment] = STATE(296),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1059),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(466),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(472),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(474),
    [anon_sym_move] = ACTIONS(476),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [297] = {
    [sym_line_comment] = STATE(297),
    [sym_block_comment] = STATE(297),
    [ts_builtin_sym_end] = ACTIONS(1228),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_SEMI] = ACTIONS(1228),
    [anon_sym_macro_rules_BANG] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1228),
    [anon_sym_LBRACK] = ACTIONS(1228),
    [anon_sym_LBRACE] = ACTIONS(1228),
    [anon_sym_RBRACE] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(1230),
    [anon_sym_STAR] = ACTIONS(1230),
    [anon_sym_QMARK] = ACTIONS(1228),
    [anon_sym_u8] = ACTIONS(1230),
    [anon_sym_i8] = ACTIONS(1230),
    [anon_sym_u16] = ACTIONS(1230),
    [anon_sym_i16] = ACTIONS(1230),
    [anon_sym_u32] = ACTIONS(1230),
    [anon_sym_i32] = ACTIONS(1230),
    [anon_sym_u64] = ACTIONS(1230),
    [anon_sym_i64] = ACTIONS(1230),
    [anon_sym_u128] = ACTIONS(1230),
    [anon_sym_i128] = ACTIONS(1230),
    [anon_sym_isize] = ACTIONS(1230),
    [anon_sym_usize] = ACTIONS(1230),
    [anon_sym_f32] = ACTIONS(1230),
    [anon_sym_f64] = ACTIONS(1230),
    [anon_sym_bool] = ACTIONS(1230),
    [anon_sym_str] = ACTIONS(1230),
    [anon_sym_char] = ACTIONS(1230),
    [anon_sym_DASH] = ACTIONS(1230),
    [anon_sym_SLASH] = ACTIONS(1230),
    [anon_sym_PERCENT] = ACTIONS(1230),
    [anon_sym_CARET] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(1230),
    [anon_sym_AMP] = ACTIONS(1230),
    [anon_sym_PIPE] = ACTIONS(1230),
    [anon_sym_AMP_AMP] = ACTIONS(1228),
    [anon_sym_PIPE_PIPE] = ACTIONS(1228),
    [anon_sym_LT_LT] = ACTIONS(1230),
    [anon_sym_GT_GT] = ACTIONS(1230),
    [anon_sym_PLUS_EQ] = ACTIONS(1228),
    [anon_sym_DASH_EQ] = ACTIONS(1228),
    [anon_sym_STAR_EQ] = ACTIONS(1228),
    [anon_sym_SLASH_EQ] = ACTIONS(1228),
    [anon_sym_PERCENT_EQ] = ACTIONS(1228),
    [anon_sym_CARET_EQ] = ACTIONS(1228),
    [anon_sym_AMP_EQ] = ACTIONS(1228),
    [anon_sym_PIPE_EQ] = ACTIONS(1228),
    [anon_sym_LT_LT_EQ] = ACTIONS(1228),
    [anon_sym_GT_GT_EQ] = ACTIONS(1228),
    [anon_sym_EQ] = ACTIONS(1230),
    [anon_sym_EQ_EQ] = ACTIONS(1228),
    [anon_sym_BANG_EQ] = ACTIONS(1228),
    [anon_sym_GT] = ACTIONS(1230),
    [anon_sym_LT] = ACTIONS(1230),
    [anon_sym_GT_EQ] = ACTIONS(1228),
    [anon_sym_LT_EQ] = ACTIONS(1228),
    [anon_sym_DOT] = ACTIONS(1230),
    [anon_sym_DOT_DOT] = ACTIONS(1230),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1228),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1228),
    [anon_sym_COLON_COLON] = ACTIONS(1228),
    [anon_sym_POUND] = ACTIONS(1228),
    [anon_sym_SQUOTE] = ACTIONS(1230),
    [anon_sym_as] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1230),
    [anon_sym_break] = ACTIONS(1230),
    [anon_sym_const] = ACTIONS(1230),
    [anon_sym_continue] = ACTIONS(1230),
    [anon_sym_default] = ACTIONS(1230),
    [anon_sym_enum] = ACTIONS(1230),
    [anon_sym_fn] = ACTIONS(1230),
    [anon_sym_for] = ACTIONS(1230),
    [anon_sym_if] = ACTIONS(1230),
    [anon_sym_impl] = ACTIONS(1230),
    [anon_sym_let] = ACTIONS(1230),
    [anon_sym_loop] = ACTIONS(1230),
    [anon_sym_match] = ACTIONS(1230),
    [anon_sym_mod] = ACTIONS(1230),
    [anon_sym_pub] = ACTIONS(1230),
    [anon_sym_return] = ACTIONS(1230),
    [anon_sym_static] = ACTIONS(1230),
    [anon_sym_struct] = ACTIONS(1230),
    [anon_sym_trait] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_union] = ACTIONS(1230),
    [anon_sym_unsafe] = ACTIONS(1230),
    [anon_sym_use] = ACTIONS(1230),
    [anon_sym_while] = ACTIONS(1230),
    [anon_sym_extern] = ACTIONS(1230),
    [anon_sym_else] = ACTIONS(1230),
    [anon_sym_yield] = ACTIONS(1230),
    [anon_sym_move] = ACTIONS(1230),
    [anon_sym_try] = ACTIONS(1230),
    [sym_integer_literal] = ACTIONS(1228),
    [aux_sym_string_literal_token1] = ACTIONS(1228),
    [sym_char_literal] = ACTIONS(1228),
    [anon_sym_true] = ACTIONS(1230),
    [anon_sym_false] = ACTIONS(1230),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1230),
    [sym_super] = ACTIONS(1230),
    [sym_crate] = ACTIONS(1230),
    [sym_metavariable] = ACTIONS(1228),
    [sym__raw_string_literal_start] = ACTIONS(1228),
    [sym_float_literal] = ACTIONS(1228),
  },
  [298] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1608),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(298),
    [sym_block_comment] = STATE(298),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1059),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(466),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(472),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(474),
    [anon_sym_move] = ACTIONS(476),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [299] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1545),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(299),
    [sym_block_comment] = STATE(299),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(981),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(466),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(472),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(474),
    [anon_sym_move] = ACTIONS(476),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [300] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1785),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(225),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(300),
    [sym_block_comment] = STATE(300),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1045),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_AMP] = ACTIONS(1047),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1206),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(496),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [301] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1609),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(301),
    [sym_block_comment] = STATE(301),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1059),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(466),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(472),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(474),
    [anon_sym_move] = ACTIONS(476),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [302] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1674),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(302),
    [sym_block_comment] = STATE(302),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [303] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1201),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(303),
    [sym_block_comment] = STATE(303),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1059),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(466),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(472),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(474),
    [anon_sym_move] = ACTIONS(476),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [304] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1610),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(304),
    [sym_block_comment] = STATE(304),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1059),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(466),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(472),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(474),
    [anon_sym_move] = ACTIONS(476),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [305] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1589),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(305),
    [sym_block_comment] = STATE(305),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(981),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(466),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(472),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(474),
    [anon_sym_move] = ACTIONS(476),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [306] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1749),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(306),
    [sym_block_comment] = STATE(306),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [307] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1862),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(307),
    [sym_block_comment] = STATE(307),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [308] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1259),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(308),
    [sym_block_comment] = STATE(308),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1059),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(466),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(472),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(474),
    [anon_sym_move] = ACTIONS(476),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [309] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1750),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(309),
    [sym_block_comment] = STATE(309),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [310] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1771),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(225),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(310),
    [sym_block_comment] = STATE(310),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1045),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_AMP] = ACTIONS(1047),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(496),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [311] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1770),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(225),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(311),
    [sym_block_comment] = STATE(311),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1045),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_AMP] = ACTIONS(1047),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(496),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [312] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1769),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(225),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(312),
    [sym_block_comment] = STATE(312),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1045),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_AMP] = ACTIONS(1047),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(496),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [313] = {
    [sym_line_comment] = STATE(313),
    [sym_block_comment] = STATE(313),
    [ts_builtin_sym_end] = ACTIONS(1232),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_SEMI] = ACTIONS(1232),
    [anon_sym_macro_rules_BANG] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1232),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_LBRACE] = ACTIONS(1232),
    [anon_sym_RBRACE] = ACTIONS(1232),
    [anon_sym_PLUS] = ACTIONS(1234),
    [anon_sym_STAR] = ACTIONS(1234),
    [anon_sym_QMARK] = ACTIONS(1232),
    [anon_sym_u8] = ACTIONS(1234),
    [anon_sym_i8] = ACTIONS(1234),
    [anon_sym_u16] = ACTIONS(1234),
    [anon_sym_i16] = ACTIONS(1234),
    [anon_sym_u32] = ACTIONS(1234),
    [anon_sym_i32] = ACTIONS(1234),
    [anon_sym_u64] = ACTIONS(1234),
    [anon_sym_i64] = ACTIONS(1234),
    [anon_sym_u128] = ACTIONS(1234),
    [anon_sym_i128] = ACTIONS(1234),
    [anon_sym_isize] = ACTIONS(1234),
    [anon_sym_usize] = ACTIONS(1234),
    [anon_sym_f32] = ACTIONS(1234),
    [anon_sym_f64] = ACTIONS(1234),
    [anon_sym_bool] = ACTIONS(1234),
    [anon_sym_str] = ACTIONS(1234),
    [anon_sym_char] = ACTIONS(1234),
    [anon_sym_DASH] = ACTIONS(1234),
    [anon_sym_SLASH] = ACTIONS(1234),
    [anon_sym_PERCENT] = ACTIONS(1234),
    [anon_sym_CARET] = ACTIONS(1234),
    [anon_sym_BANG] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(1234),
    [anon_sym_PIPE] = ACTIONS(1234),
    [anon_sym_AMP_AMP] = ACTIONS(1232),
    [anon_sym_PIPE_PIPE] = ACTIONS(1232),
    [anon_sym_LT_LT] = ACTIONS(1234),
    [anon_sym_GT_GT] = ACTIONS(1234),
    [anon_sym_PLUS_EQ] = ACTIONS(1232),
    [anon_sym_DASH_EQ] = ACTIONS(1232),
    [anon_sym_STAR_EQ] = ACTIONS(1232),
    [anon_sym_SLASH_EQ] = ACTIONS(1232),
    [anon_sym_PERCENT_EQ] = ACTIONS(1232),
    [anon_sym_CARET_EQ] = ACTIONS(1232),
    [anon_sym_AMP_EQ] = ACTIONS(1232),
    [anon_sym_PIPE_EQ] = ACTIONS(1232),
    [anon_sym_LT_LT_EQ] = ACTIONS(1232),
    [anon_sym_GT_GT_EQ] = ACTIONS(1232),
    [anon_sym_EQ] = ACTIONS(1234),
    [anon_sym_EQ_EQ] = ACTIONS(1232),
    [anon_sym_BANG_EQ] = ACTIONS(1232),
    [anon_sym_GT] = ACTIONS(1234),
    [anon_sym_LT] = ACTIONS(1234),
    [anon_sym_GT_EQ] = ACTIONS(1232),
    [anon_sym_LT_EQ] = ACTIONS(1232),
    [anon_sym_DOT] = ACTIONS(1234),
    [anon_sym_DOT_DOT] = ACTIONS(1234),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1232),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(1232),
    [anon_sym_POUND] = ACTIONS(1232),
    [anon_sym_SQUOTE] = ACTIONS(1234),
    [anon_sym_as] = ACTIONS(1234),
    [anon_sym_async] = ACTIONS(1234),
    [anon_sym_break] = ACTIONS(1234),
    [anon_sym_const] = ACTIONS(1234),
    [anon_sym_continue] = ACTIONS(1234),
    [anon_sym_default] = ACTIONS(1234),
    [anon_sym_enum] = ACTIONS(1234),
    [anon_sym_fn] = ACTIONS(1234),
    [anon_sym_for] = ACTIONS(1234),
    [anon_sym_if] = ACTIONS(1234),
    [anon_sym_impl] = ACTIONS(1234),
    [anon_sym_let] = ACTIONS(1234),
    [anon_sym_loop] = ACTIONS(1234),
    [anon_sym_match] = ACTIONS(1234),
    [anon_sym_mod] = ACTIONS(1234),
    [anon_sym_pub] = ACTIONS(1234),
    [anon_sym_return] = ACTIONS(1234),
    [anon_sym_static] = ACTIONS(1234),
    [anon_sym_struct] = ACTIONS(1234),
    [anon_sym_trait] = ACTIONS(1234),
    [anon_sym_type] = ACTIONS(1234),
    [anon_sym_union] = ACTIONS(1234),
    [anon_sym_unsafe] = ACTIONS(1234),
    [anon_sym_use] = ACTIONS(1234),
    [anon_sym_while] = ACTIONS(1234),
    [anon_sym_extern] = ACTIONS(1234),
    [anon_sym_else] = ACTIONS(1234),
    [anon_sym_yield] = ACTIONS(1234),
    [anon_sym_move] = ACTIONS(1234),
    [anon_sym_try] = ACTIONS(1234),
    [sym_integer_literal] = ACTIONS(1232),
    [aux_sym_string_literal_token1] = ACTIONS(1232),
    [sym_char_literal] = ACTIONS(1232),
    [anon_sym_true] = ACTIONS(1234),
    [anon_sym_false] = ACTIONS(1234),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1234),
    [sym_super] = ACTIONS(1234),
    [sym_crate] = ACTIONS(1234),
    [sym_metavariable] = ACTIONS(1232),
    [sym__raw_string_literal_start] = ACTIONS(1232),
    [sym_float_literal] = ACTIONS(1232),
  },
  [314] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1858),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(314),
    [sym_block_comment] = STATE(314),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [315] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1851),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(315),
    [sym_block_comment] = STATE(315),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [316] = {
    [sym_bracketed_type] = STATE(3488),
    [sym_generic_function] = STATE(1685),
    [sym_generic_type_with_turbofish] = STATE(2915),
    [sym__expression_except_range] = STATE(1580),
    [sym__expression] = STATE(1698),
    [sym_macro_invocation] = STATE(1695),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3184),
    [sym_range_expression] = STATE(1689),
    [sym_unary_expression] = STATE(1685),
    [sym_try_expression] = STATE(1685),
    [sym_reference_expression] = STATE(1685),
    [sym_binary_expression] = STATE(1685),
    [sym_assignment_expression] = STATE(1685),
    [sym_compound_assignment_expr] = STATE(1685),
    [sym_type_cast_expression] = STATE(1685),
    [sym_return_expression] = STATE(1685),
    [sym_yield_expression] = STATE(1685),
    [sym_call_expression] = STATE(1685),
    [sym_array_expression] = STATE(1685),
    [sym_parenthesized_expression] = STATE(1685),
    [sym_tuple_expression] = STATE(1685),
    [sym_unit_expression] = STATE(1685),
    [sym_struct_expression] = STATE(1685),
    [sym_if_expression] = STATE(1685),
    [sym_match_expression] = STATE(1685),
    [sym_while_expression] = STATE(1685),
    [sym_loop_expression] = STATE(1685),
    [sym_for_expression] = STATE(1685),
    [sym_const_block] = STATE(1685),
    [sym_closure_expression] = STATE(1685),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3575),
    [sym_break_expression] = STATE(1685),
    [sym_continue_expression] = STATE(1685),
    [sym_index_expression] = STATE(1685),
    [sym_await_expression] = STATE(1685),
    [sym_field_expression] = STATE(1625),
    [sym_unsafe_block] = STATE(1685),
    [sym_async_block] = STATE(1685),
    [sym_try_block] = STATE(1685),
    [sym_block] = STATE(1685),
    [sym__literal] = STATE(1685),
    [sym_string_literal] = STATE(1831),
    [sym_raw_string_literal] = STATE(1831),
    [sym_boolean_literal] = STATE(1831),
    [sym_line_comment] = STATE(316),
    [sym_block_comment] = STATE(316),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_LBRACK] = ACTIONS(488),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(1005),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(1005),
    [anon_sym_BANG] = ACTIONS(1005),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1053),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [317] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1768),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(225),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(317),
    [sym_block_comment] = STATE(317),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1045),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_AMP] = ACTIONS(1047),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(496),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [318] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1765),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(225),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(318),
    [sym_block_comment] = STATE(318),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1045),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_AMP] = ACTIONS(1047),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(496),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [319] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1589),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(319),
    [sym_block_comment] = STATE(319),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1059),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(466),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(472),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(474),
    [anon_sym_move] = ACTIONS(476),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [320] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1561),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(320),
    [sym_block_comment] = STATE(320),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(981),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(466),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(472),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(474),
    [anon_sym_move] = ACTIONS(476),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [321] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1849),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(321),
    [sym_block_comment] = STATE(321),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [322] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1605),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(322),
    [sym_block_comment] = STATE(322),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1059),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(466),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(472),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(474),
    [anon_sym_move] = ACTIONS(476),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [323] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1762),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(225),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(323),
    [sym_block_comment] = STATE(323),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1045),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_AMP] = ACTIONS(1047),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(496),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [324] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1560),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(324),
    [sym_block_comment] = STATE(324),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(981),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(466),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(472),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(474),
    [anon_sym_move] = ACTIONS(476),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [325] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1758),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(225),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(325),
    [sym_block_comment] = STATE(325),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1045),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_AMP] = ACTIONS(1047),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(496),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [326] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1844),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(326),
    [sym_block_comment] = STATE(326),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [327] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1554),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(327),
    [sym_block_comment] = STATE(327),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(981),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(466),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(472),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(474),
    [anon_sym_move] = ACTIONS(476),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [328] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1755),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(225),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(328),
    [sym_block_comment] = STATE(328),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1045),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_AMP] = ACTIONS(1047),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(496),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [329] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1661),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(329),
    [sym_block_comment] = STATE(329),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [330] = {
    [sym_bracketed_type] = STATE(3488),
    [sym_generic_function] = STATE(1685),
    [sym_generic_type_with_turbofish] = STATE(2915),
    [sym__expression_except_range] = STATE(1580),
    [sym__expression] = STATE(1767),
    [sym_macro_invocation] = STATE(1695),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3184),
    [sym_range_expression] = STATE(1689),
    [sym_unary_expression] = STATE(1685),
    [sym_try_expression] = STATE(1685),
    [sym_reference_expression] = STATE(1685),
    [sym_binary_expression] = STATE(1685),
    [sym_assignment_expression] = STATE(1685),
    [sym_compound_assignment_expr] = STATE(1685),
    [sym_type_cast_expression] = STATE(1685),
    [sym_return_expression] = STATE(1685),
    [sym_yield_expression] = STATE(1685),
    [sym_call_expression] = STATE(1685),
    [sym_array_expression] = STATE(1685),
    [sym_parenthesized_expression] = STATE(1685),
    [sym_tuple_expression] = STATE(1685),
    [sym_unit_expression] = STATE(1685),
    [sym_struct_expression] = STATE(1685),
    [sym_if_expression] = STATE(1685),
    [sym_match_expression] = STATE(1685),
    [sym_while_expression] = STATE(1685),
    [sym_loop_expression] = STATE(1685),
    [sym_for_expression] = STATE(1685),
    [sym_const_block] = STATE(1685),
    [sym_closure_expression] = STATE(1685),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3575),
    [sym_break_expression] = STATE(1685),
    [sym_continue_expression] = STATE(1685),
    [sym_index_expression] = STATE(1685),
    [sym_await_expression] = STATE(1685),
    [sym_field_expression] = STATE(1625),
    [sym_unsafe_block] = STATE(1685),
    [sym_async_block] = STATE(1685),
    [sym_try_block] = STATE(1685),
    [sym_block] = STATE(1685),
    [sym__literal] = STATE(1685),
    [sym_string_literal] = STATE(1831),
    [sym_raw_string_literal] = STATE(1831),
    [sym_boolean_literal] = STATE(1831),
    [sym_line_comment] = STATE(330),
    [sym_block_comment] = STATE(330),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_LBRACK] = ACTIONS(488),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(1005),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(1005),
    [anon_sym_BANG] = ACTIONS(1005),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1053),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [331] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1542),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(331),
    [sym_block_comment] = STATE(331),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(981),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(466),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(472),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(474),
    [anon_sym_move] = ACTIONS(476),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [332] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1783),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(332),
    [sym_block_comment] = STATE(332),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [333] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1201),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(225),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(333),
    [sym_block_comment] = STATE(333),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1045),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_AMP] = ACTIONS(1047),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(496),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [334] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1856),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(334),
    [sym_block_comment] = STATE(334),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [335] = {
    [sym_line_comment] = STATE(335),
    [sym_block_comment] = STATE(335),
    [ts_builtin_sym_end] = ACTIONS(1236),
    [sym_identifier] = ACTIONS(1238),
    [anon_sym_SEMI] = ACTIONS(1236),
    [anon_sym_macro_rules_BANG] = ACTIONS(1236),
    [anon_sym_LPAREN] = ACTIONS(1236),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LBRACE] = ACTIONS(1236),
    [anon_sym_RBRACE] = ACTIONS(1236),
    [anon_sym_PLUS] = ACTIONS(1238),
    [anon_sym_STAR] = ACTIONS(1238),
    [anon_sym_QMARK] = ACTIONS(1236),
    [anon_sym_u8] = ACTIONS(1238),
    [anon_sym_i8] = ACTIONS(1238),
    [anon_sym_u16] = ACTIONS(1238),
    [anon_sym_i16] = ACTIONS(1238),
    [anon_sym_u32] = ACTIONS(1238),
    [anon_sym_i32] = ACTIONS(1238),
    [anon_sym_u64] = ACTIONS(1238),
    [anon_sym_i64] = ACTIONS(1238),
    [anon_sym_u128] = ACTIONS(1238),
    [anon_sym_i128] = ACTIONS(1238),
    [anon_sym_isize] = ACTIONS(1238),
    [anon_sym_usize] = ACTIONS(1238),
    [anon_sym_f32] = ACTIONS(1238),
    [anon_sym_f64] = ACTIONS(1238),
    [anon_sym_bool] = ACTIONS(1238),
    [anon_sym_str] = ACTIONS(1238),
    [anon_sym_char] = ACTIONS(1238),
    [anon_sym_DASH] = ACTIONS(1238),
    [anon_sym_SLASH] = ACTIONS(1238),
    [anon_sym_PERCENT] = ACTIONS(1238),
    [anon_sym_CARET] = ACTIONS(1238),
    [anon_sym_BANG] = ACTIONS(1238),
    [anon_sym_AMP] = ACTIONS(1238),
    [anon_sym_PIPE] = ACTIONS(1238),
    [anon_sym_AMP_AMP] = ACTIONS(1236),
    [anon_sym_PIPE_PIPE] = ACTIONS(1236),
    [anon_sym_LT_LT] = ACTIONS(1238),
    [anon_sym_GT_GT] = ACTIONS(1238),
    [anon_sym_PLUS_EQ] = ACTIONS(1236),
    [anon_sym_DASH_EQ] = ACTIONS(1236),
    [anon_sym_STAR_EQ] = ACTIONS(1236),
    [anon_sym_SLASH_EQ] = ACTIONS(1236),
    [anon_sym_PERCENT_EQ] = ACTIONS(1236),
    [anon_sym_CARET_EQ] = ACTIONS(1236),
    [anon_sym_AMP_EQ] = ACTIONS(1236),
    [anon_sym_PIPE_EQ] = ACTIONS(1236),
    [anon_sym_LT_LT_EQ] = ACTIONS(1236),
    [anon_sym_GT_GT_EQ] = ACTIONS(1236),
    [anon_sym_EQ] = ACTIONS(1238),
    [anon_sym_EQ_EQ] = ACTIONS(1236),
    [anon_sym_BANG_EQ] = ACTIONS(1236),
    [anon_sym_GT] = ACTIONS(1238),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_GT_EQ] = ACTIONS(1236),
    [anon_sym_LT_EQ] = ACTIONS(1236),
    [anon_sym_DOT] = ACTIONS(1238),
    [anon_sym_DOT_DOT] = ACTIONS(1238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1236),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1236),
    [anon_sym_COLON_COLON] = ACTIONS(1236),
    [anon_sym_POUND] = ACTIONS(1236),
    [anon_sym_SQUOTE] = ACTIONS(1238),
    [anon_sym_as] = ACTIONS(1238),
    [anon_sym_async] = ACTIONS(1238),
    [anon_sym_break] = ACTIONS(1238),
    [anon_sym_const] = ACTIONS(1238),
    [anon_sym_continue] = ACTIONS(1238),
    [anon_sym_default] = ACTIONS(1238),
    [anon_sym_enum] = ACTIONS(1238),
    [anon_sym_fn] = ACTIONS(1238),
    [anon_sym_for] = ACTIONS(1238),
    [anon_sym_if] = ACTIONS(1238),
    [anon_sym_impl] = ACTIONS(1238),
    [anon_sym_let] = ACTIONS(1238),
    [anon_sym_loop] = ACTIONS(1238),
    [anon_sym_match] = ACTIONS(1238),
    [anon_sym_mod] = ACTIONS(1238),
    [anon_sym_pub] = ACTIONS(1238),
    [anon_sym_return] = ACTIONS(1238),
    [anon_sym_static] = ACTIONS(1238),
    [anon_sym_struct] = ACTIONS(1238),
    [anon_sym_trait] = ACTIONS(1238),
    [anon_sym_type] = ACTIONS(1238),
    [anon_sym_union] = ACTIONS(1238),
    [anon_sym_unsafe] = ACTIONS(1238),
    [anon_sym_use] = ACTIONS(1238),
    [anon_sym_while] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(1238),
    [anon_sym_else] = ACTIONS(1238),
    [anon_sym_yield] = ACTIONS(1238),
    [anon_sym_move] = ACTIONS(1238),
    [anon_sym_try] = ACTIONS(1238),
    [sym_integer_literal] = ACTIONS(1236),
    [aux_sym_string_literal_token1] = ACTIONS(1236),
    [sym_char_literal] = ACTIONS(1236),
    [anon_sym_true] = ACTIONS(1238),
    [anon_sym_false] = ACTIONS(1238),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1238),
    [sym_super] = ACTIONS(1238),
    [sym_crate] = ACTIONS(1238),
    [sym_metavariable] = ACTIONS(1236),
    [sym__raw_string_literal_start] = ACTIONS(1236),
    [sym_float_literal] = ACTIONS(1236),
  },
  [336] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1751),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(225),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(336),
    [sym_block_comment] = STATE(336),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1045),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_AMP] = ACTIONS(1047),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(496),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [337] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1834),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(455),
    [sym_match_expression] = STATE(455),
    [sym_while_expression] = STATE(455),
    [sym_loop_expression] = STATE(455),
    [sym_for_expression] = STATE(455),
    [sym_const_block] = STATE(455),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3569),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(455),
    [sym_async_block] = STATE(455),
    [sym_try_block] = STATE(455),
    [sym_block] = STATE(455),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(337),
    [sym_block_comment] = STATE(337),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(1208),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(1210),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(1212),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(1214),
    [anon_sym_if] = ACTIONS(1216),
    [anon_sym_loop] = ACTIONS(1218),
    [anon_sym_match] = ACTIONS(1220),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(1222),
    [anon_sym_while] = ACTIONS(1224),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(1226),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [338] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1683),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(338),
    [sym_block_comment] = STATE(338),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [339] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1704),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(225),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(339),
    [sym_block_comment] = STATE(339),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1045),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_AMP] = ACTIONS(1047),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(496),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [340] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1544),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(340),
    [sym_block_comment] = STATE(340),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(981),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(466),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(472),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(474),
    [anon_sym_move] = ACTIONS(476),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [341] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1794),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(341),
    [sym_block_comment] = STATE(341),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(981),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(466),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(472),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(474),
    [anon_sym_move] = ACTIONS(476),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [342] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1648),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(342),
    [sym_block_comment] = STATE(342),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [343] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1860),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(343),
    [sym_block_comment] = STATE(343),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [344] = {
    [sym_bracketed_type] = STATE(3488),
    [sym_generic_function] = STATE(1685),
    [sym_generic_type_with_turbofish] = STATE(2915),
    [sym__expression_except_range] = STATE(1580),
    [sym__expression] = STATE(1636),
    [sym_macro_invocation] = STATE(1695),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3184),
    [sym_range_expression] = STATE(1689),
    [sym_unary_expression] = STATE(1685),
    [sym_try_expression] = STATE(1685),
    [sym_reference_expression] = STATE(1685),
    [sym_binary_expression] = STATE(1685),
    [sym_assignment_expression] = STATE(1685),
    [sym_compound_assignment_expr] = STATE(1685),
    [sym_type_cast_expression] = STATE(1685),
    [sym_return_expression] = STATE(1685),
    [sym_yield_expression] = STATE(1685),
    [sym_call_expression] = STATE(1685),
    [sym_array_expression] = STATE(1685),
    [sym_parenthesized_expression] = STATE(1685),
    [sym_tuple_expression] = STATE(1685),
    [sym_unit_expression] = STATE(1685),
    [sym_struct_expression] = STATE(1685),
    [sym_if_expression] = STATE(1685),
    [sym_match_expression] = STATE(1685),
    [sym_while_expression] = STATE(1685),
    [sym_loop_expression] = STATE(1685),
    [sym_for_expression] = STATE(1685),
    [sym_const_block] = STATE(1685),
    [sym_closure_expression] = STATE(1685),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3575),
    [sym_break_expression] = STATE(1685),
    [sym_continue_expression] = STATE(1685),
    [sym_index_expression] = STATE(1685),
    [sym_await_expression] = STATE(1685),
    [sym_field_expression] = STATE(1625),
    [sym_unsafe_block] = STATE(1685),
    [sym_async_block] = STATE(1685),
    [sym_try_block] = STATE(1685),
    [sym_block] = STATE(1685),
    [sym__literal] = STATE(1685),
    [sym_string_literal] = STATE(1831),
    [sym_raw_string_literal] = STATE(1831),
    [sym_boolean_literal] = STATE(1831),
    [sym_line_comment] = STATE(344),
    [sym_block_comment] = STATE(344),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_LBRACK] = ACTIONS(488),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(1005),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(1005),
    [anon_sym_BANG] = ACTIONS(1005),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1009),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [345] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1563),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(345),
    [sym_block_comment] = STATE(345),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(981),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(466),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(472),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(474),
    [anon_sym_move] = ACTIONS(476),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [346] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1836),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(346),
    [sym_block_comment] = STATE(346),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [347] = {
    [sym_bracketed_type] = STATE(3488),
    [sym_generic_function] = STATE(1685),
    [sym_generic_type_with_turbofish] = STATE(2915),
    [sym__expression_except_range] = STATE(1580),
    [sym__expression] = STATE(1636),
    [sym_macro_invocation] = STATE(1695),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3184),
    [sym_range_expression] = STATE(1689),
    [sym_unary_expression] = STATE(1685),
    [sym_try_expression] = STATE(1685),
    [sym_reference_expression] = STATE(1685),
    [sym_binary_expression] = STATE(1685),
    [sym_assignment_expression] = STATE(1685),
    [sym_compound_assignment_expr] = STATE(1685),
    [sym_type_cast_expression] = STATE(1685),
    [sym_return_expression] = STATE(1685),
    [sym_yield_expression] = STATE(1685),
    [sym_call_expression] = STATE(1685),
    [sym_array_expression] = STATE(1685),
    [sym_parenthesized_expression] = STATE(1685),
    [sym_tuple_expression] = STATE(1685),
    [sym_unit_expression] = STATE(1685),
    [sym_struct_expression] = STATE(1685),
    [sym_if_expression] = STATE(1685),
    [sym_match_expression] = STATE(1685),
    [sym_while_expression] = STATE(1685),
    [sym_loop_expression] = STATE(1685),
    [sym_for_expression] = STATE(1685),
    [sym_const_block] = STATE(1685),
    [sym_closure_expression] = STATE(1685),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3575),
    [sym_break_expression] = STATE(1685),
    [sym_continue_expression] = STATE(1685),
    [sym_index_expression] = STATE(1685),
    [sym_await_expression] = STATE(1685),
    [sym_field_expression] = STATE(1625),
    [sym_unsafe_block] = STATE(1685),
    [sym_async_block] = STATE(1685),
    [sym_try_block] = STATE(1685),
    [sym_block] = STATE(1685),
    [sym__literal] = STATE(1685),
    [sym_string_literal] = STATE(1831),
    [sym_raw_string_literal] = STATE(1831),
    [sym_boolean_literal] = STATE(1831),
    [sym_line_comment] = STATE(347),
    [sym_block_comment] = STATE(347),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_LBRACK] = ACTIONS(488),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(1005),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(1005),
    [anon_sym_BANG] = ACTIONS(1005),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1053),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [348] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1647),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(348),
    [sym_block_comment] = STATE(348),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [349] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1259),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(225),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(349),
    [sym_block_comment] = STATE(349),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1045),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_AMP] = ACTIONS(1047),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(496),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [350] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1546),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(350),
    [sym_block_comment] = STATE(350),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(981),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(466),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(472),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(474),
    [anon_sym_move] = ACTIONS(476),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [351] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1840),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(458),
    [sym_match_expression] = STATE(458),
    [sym_while_expression] = STATE(458),
    [sym_loop_expression] = STATE(458),
    [sym_for_expression] = STATE(458),
    [sym_const_block] = STATE(458),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3569),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(458),
    [sym_async_block] = STATE(458),
    [sym_try_block] = STATE(458),
    [sym_block] = STATE(458),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(351),
    [sym_block_comment] = STATE(351),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(1208),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(1210),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(1212),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(1214),
    [anon_sym_if] = ACTIONS(1216),
    [anon_sym_loop] = ACTIONS(1218),
    [anon_sym_match] = ACTIONS(1220),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(1222),
    [anon_sym_while] = ACTIONS(1224),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(1226),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [352] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1657),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(352),
    [sym_block_comment] = STATE(352),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [353] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1635),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(353),
    [sym_block_comment] = STATE(353),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [354] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1853),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(354),
    [sym_block_comment] = STATE(354),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [355] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1646),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(355),
    [sym_block_comment] = STATE(355),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [356] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1697),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(356),
    [sym_block_comment] = STATE(356),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [357] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1835),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(357),
    [sym_block_comment] = STATE(357),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [358] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1848),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(358),
    [sym_block_comment] = STATE(358),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [359] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1684),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(225),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(359),
    [sym_block_comment] = STATE(359),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(1045),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_AMP] = ACTIONS(1047),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1206),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(496),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(502),
    [anon_sym_move] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [360] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1638),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(455),
    [sym_match_expression] = STATE(455),
    [sym_while_expression] = STATE(455),
    [sym_loop_expression] = STATE(455),
    [sym_for_expression] = STATE(455),
    [sym_const_block] = STATE(455),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3569),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(455),
    [sym_async_block] = STATE(455),
    [sym_try_block] = STATE(455),
    [sym_block] = STATE(455),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(360),
    [sym_block_comment] = STATE(360),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(1208),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(1210),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(1212),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(1214),
    [anon_sym_if] = ACTIONS(1216),
    [anon_sym_loop] = ACTIONS(1218),
    [anon_sym_match] = ACTIONS(1220),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(1222),
    [anon_sym_while] = ACTIONS(1224),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(1226),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [361] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1850),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(361),
    [sym_block_comment] = STATE(361),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [362] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1847),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(362),
    [sym_block_comment] = STATE(362),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [363] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1842),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(363),
    [sym_block_comment] = STATE(363),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [364] = {
    [sym_bracketed_type] = STATE(3488),
    [sym_generic_function] = STATE(1685),
    [sym_generic_type_with_turbofish] = STATE(2915),
    [sym__expression_except_range] = STATE(1580),
    [sym__expression] = STATE(1664),
    [sym_macro_invocation] = STATE(1695),
    [sym_scoped_identifier] = STATE(1536),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3184),
    [sym_range_expression] = STATE(1689),
    [sym_unary_expression] = STATE(1685),
    [sym_try_expression] = STATE(1685),
    [sym_reference_expression] = STATE(1685),
    [sym_binary_expression] = STATE(1685),
    [sym_assignment_expression] = STATE(1685),
    [sym_compound_assignment_expr] = STATE(1685),
    [sym_type_cast_expression] = STATE(1685),
    [sym_return_expression] = STATE(1685),
    [sym_yield_expression] = STATE(1685),
    [sym_call_expression] = STATE(1685),
    [sym_array_expression] = STATE(1685),
    [sym_parenthesized_expression] = STATE(1685),
    [sym_tuple_expression] = STATE(1685),
    [sym_unit_expression] = STATE(1685),
    [sym_struct_expression] = STATE(1685),
    [sym_if_expression] = STATE(1685),
    [sym_match_expression] = STATE(1685),
    [sym_while_expression] = STATE(1685),
    [sym_loop_expression] = STATE(1685),
    [sym_for_expression] = STATE(1685),
    [sym_const_block] = STATE(1685),
    [sym_closure_expression] = STATE(1685),
    [sym_closure_parameters] = STATE(241),
    [sym_label] = STATE(3575),
    [sym_break_expression] = STATE(1685),
    [sym_continue_expression] = STATE(1685),
    [sym_index_expression] = STATE(1685),
    [sym_await_expression] = STATE(1685),
    [sym_field_expression] = STATE(1625),
    [sym_unsafe_block] = STATE(1685),
    [sym_async_block] = STATE(1685),
    [sym_try_block] = STATE(1685),
    [sym_block] = STATE(1685),
    [sym__literal] = STATE(1685),
    [sym_string_literal] = STATE(1831),
    [sym_raw_string_literal] = STATE(1831),
    [sym_boolean_literal] = STATE(1831),
    [sym_line_comment] = STATE(364),
    [sym_block_comment] = STATE(364),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_LBRACK] = ACTIONS(488),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(1005),
    [anon_sym_u8] = ACTIONS(404),
    [anon_sym_i8] = ACTIONS(404),
    [anon_sym_u16] = ACTIONS(404),
    [anon_sym_i16] = ACTIONS(404),
    [anon_sym_u32] = ACTIONS(404),
    [anon_sym_i32] = ACTIONS(404),
    [anon_sym_u64] = ACTIONS(404),
    [anon_sym_i64] = ACTIONS(404),
    [anon_sym_u128] = ACTIONS(404),
    [anon_sym_i128] = ACTIONS(404),
    [anon_sym_isize] = ACTIONS(404),
    [anon_sym_usize] = ACTIONS(404),
    [anon_sym_f32] = ACTIONS(404),
    [anon_sym_f64] = ACTIONS(404),
    [anon_sym_bool] = ACTIONS(404),
    [anon_sym_str] = ACTIONS(404),
    [anon_sym_char] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(1005),
    [anon_sym_BANG] = ACTIONS(1005),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1053),
    [anon_sym_COLON_COLON] = ACTIONS(408),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(410),
    [anon_sym_break] = ACTIONS(412),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_loop] = ACTIONS(424),
    [anon_sym_match] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(428),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_union] = ACTIONS(418),
    [anon_sym_unsafe] = ACTIONS(432),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_move] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(440),
    [sym_integer_literal] = ACTIONS(442),
    [aux_sym_string_literal_token1] = ACTIONS(444),
    [sym_char_literal] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(448),
    [sym_super] = ACTIONS(450),
    [sym_crate] = ACTIONS(450),
    [sym_metavariable] = ACTIONS(452),
    [sym__raw_string_literal_start] = ACTIONS(454),
    [sym_float_literal] = ACTIONS(442),
  },
  [365] = {
    [sym_line_comment] = STATE(365),
    [sym_block_comment] = STATE(365),
    [ts_builtin_sym_end] = ACTIONS(1240),
    [sym_identifier] = ACTIONS(1242),
    [anon_sym_SEMI] = ACTIONS(1240),
    [anon_sym_macro_rules_BANG] = ACTIONS(1240),
    [anon_sym_LPAREN] = ACTIONS(1240),
    [anon_sym_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(1240),
    [anon_sym_RBRACE] = ACTIONS(1240),
    [anon_sym_PLUS] = ACTIONS(1242),
    [anon_sym_STAR] = ACTIONS(1242),
    [anon_sym_QMARK] = ACTIONS(1240),
    [anon_sym_u8] = ACTIONS(1242),
    [anon_sym_i8] = ACTIONS(1242),
    [anon_sym_u16] = ACTIONS(1242),
    [anon_sym_i16] = ACTIONS(1242),
    [anon_sym_u32] = ACTIONS(1242),
    [anon_sym_i32] = ACTIONS(1242),
    [anon_sym_u64] = ACTIONS(1242),
    [anon_sym_i64] = ACTIONS(1242),
    [anon_sym_u128] = ACTIONS(1242),
    [anon_sym_i128] = ACTIONS(1242),
    [anon_sym_isize] = ACTIONS(1242),
    [anon_sym_usize] = ACTIONS(1242),
    [anon_sym_f32] = ACTIONS(1242),
    [anon_sym_f64] = ACTIONS(1242),
    [anon_sym_bool] = ACTIONS(1242),
    [anon_sym_str] = ACTIONS(1242),
    [anon_sym_char] = ACTIONS(1242),
    [anon_sym_DASH] = ACTIONS(1242),
    [anon_sym_SLASH] = ACTIONS(1242),
    [anon_sym_PERCENT] = ACTIONS(1242),
    [anon_sym_CARET] = ACTIONS(1242),
    [anon_sym_BANG] = ACTIONS(1242),
    [anon_sym_AMP] = ACTIONS(1242),
    [anon_sym_PIPE] = ACTIONS(1242),
    [anon_sym_AMP_AMP] = ACTIONS(1240),
    [anon_sym_PIPE_PIPE] = ACTIONS(1240),
    [anon_sym_LT_LT] = ACTIONS(1242),
    [anon_sym_GT_GT] = ACTIONS(1242),
    [anon_sym_PLUS_EQ] = ACTIONS(1240),
    [anon_sym_DASH_EQ] = ACTIONS(1240),
    [anon_sym_STAR_EQ] = ACTIONS(1240),
    [anon_sym_SLASH_EQ] = ACTIONS(1240),
    [anon_sym_PERCENT_EQ] = ACTIONS(1240),
    [anon_sym_CARET_EQ] = ACTIONS(1240),
    [anon_sym_AMP_EQ] = ACTIONS(1240),
    [anon_sym_PIPE_EQ] = ACTIONS(1240),
    [anon_sym_LT_LT_EQ] = ACTIONS(1240),
    [anon_sym_GT_GT_EQ] = ACTIONS(1240),
    [anon_sym_EQ] = ACTIONS(1242),
    [anon_sym_EQ_EQ] = ACTIONS(1240),
    [anon_sym_BANG_EQ] = ACTIONS(1240),
    [anon_sym_GT] = ACTIONS(1242),
    [anon_sym_LT] = ACTIONS(1242),
    [anon_sym_GT_EQ] = ACTIONS(1240),
    [anon_sym_LT_EQ] = ACTIONS(1240),
    [anon_sym_DOT] = ACTIONS(1242),
    [anon_sym_DOT_DOT] = ACTIONS(1242),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1240),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1240),
    [anon_sym_COLON_COLON] = ACTIONS(1240),
    [anon_sym_POUND] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [anon_sym_as] = ACTIONS(1242),
    [anon_sym_async] = ACTIONS(1242),
    [anon_sym_break] = ACTIONS(1242),
    [anon_sym_const] = ACTIONS(1242),
    [anon_sym_continue] = ACTIONS(1242),
    [anon_sym_default] = ACTIONS(1242),
    [anon_sym_enum] = ACTIONS(1242),
    [anon_sym_fn] = ACTIONS(1242),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_if] = ACTIONS(1242),
    [anon_sym_impl] = ACTIONS(1242),
    [anon_sym_let] = ACTIONS(1242),
    [anon_sym_loop] = ACTIONS(1242),
    [anon_sym_match] = ACTIONS(1242),
    [anon_sym_mod] = ACTIONS(1242),
    [anon_sym_pub] = ACTIONS(1242),
    [anon_sym_return] = ACTIONS(1242),
    [anon_sym_static] = ACTIONS(1242),
    [anon_sym_struct] = ACTIONS(1242),
    [anon_sym_trait] = ACTIONS(1242),
    [anon_sym_type] = ACTIONS(1242),
    [anon_sym_union] = ACTIONS(1242),
    [anon_sym_unsafe] = ACTIONS(1242),
    [anon_sym_use] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(1242),
    [anon_sym_extern] = ACTIONS(1242),
    [anon_sym_else] = ACTIONS(1242),
    [anon_sym_yield] = ACTIONS(1242),
    [anon_sym_move] = ACTIONS(1242),
    [anon_sym_try] = ACTIONS(1242),
    [sym_integer_literal] = ACTIONS(1240),
    [aux_sym_string_literal_token1] = ACTIONS(1240),
    [sym_char_literal] = ACTIONS(1240),
    [anon_sym_true] = ACTIONS(1242),
    [anon_sym_false] = ACTIONS(1242),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1242),
    [sym_super] = ACTIONS(1242),
    [sym_crate] = ACTIONS(1242),
    [sym_metavariable] = ACTIONS(1240),
    [sym__raw_string_literal_start] = ACTIONS(1240),
    [sym_float_literal] = ACTIONS(1240),
  },
  [366] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2858),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1436),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1517),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(226),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(366),
    [sym_block_comment] = STATE(366),
    [sym_identifier] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_u8] = ACTIONS(458),
    [anon_sym_i8] = ACTIONS(458),
    [anon_sym_u16] = ACTIONS(458),
    [anon_sym_i16] = ACTIONS(458),
    [anon_sym_u32] = ACTIONS(458),
    [anon_sym_i32] = ACTIONS(458),
    [anon_sym_u64] = ACTIONS(458),
    [anon_sym_i64] = ACTIONS(458),
    [anon_sym_u128] = ACTIONS(458),
    [anon_sym_i128] = ACTIONS(458),
    [anon_sym_isize] = ACTIONS(458),
    [anon_sym_usize] = ACTIONS(458),
    [anon_sym_f32] = ACTIONS(458),
    [anon_sym_f64] = ACTIONS(458),
    [anon_sym_bool] = ACTIONS(458),
    [anon_sym_str] = ACTIONS(458),
    [anon_sym_char] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1059),
    [anon_sym_COLON_COLON] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(466),
    [anon_sym_default] = ACTIONS(468),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(472),
    [anon_sym_union] = ACTIONS(468),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(474),
    [anon_sym_move] = ACTIONS(476),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(478),
    [sym_super] = ACTIONS(480),
    [sym_crate] = ACTIONS(480),
    [sym_metavariable] = ACTIONS(482),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [367] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1259),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(367),
    [sym_block_comment] = STATE(367),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [368] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1843),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(368),
    [sym_block_comment] = STATE(368),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [369] = {
    [sym_line_comment] = STATE(369),
    [sym_block_comment] = STATE(369),
    [ts_builtin_sym_end] = ACTIONS(1244),
    [sym_identifier] = ACTIONS(1246),
    [anon_sym_SEMI] = ACTIONS(1244),
    [anon_sym_macro_rules_BANG] = ACTIONS(1244),
    [anon_sym_LPAREN] = ACTIONS(1244),
    [anon_sym_LBRACK] = ACTIONS(1244),
    [anon_sym_LBRACE] = ACTIONS(1244),
    [anon_sym_RBRACE] = ACTIONS(1244),
    [anon_sym_PLUS] = ACTIONS(1246),
    [anon_sym_STAR] = ACTIONS(1246),
    [anon_sym_QMARK] = ACTIONS(1244),
    [anon_sym_u8] = ACTIONS(1246),
    [anon_sym_i8] = ACTIONS(1246),
    [anon_sym_u16] = ACTIONS(1246),
    [anon_sym_i16] = ACTIONS(1246),
    [anon_sym_u32] = ACTIONS(1246),
    [anon_sym_i32] = ACTIONS(1246),
    [anon_sym_u64] = ACTIONS(1246),
    [anon_sym_i64] = ACTIONS(1246),
    [anon_sym_u128] = ACTIONS(1246),
    [anon_sym_i128] = ACTIONS(1246),
    [anon_sym_isize] = ACTIONS(1246),
    [anon_sym_usize] = ACTIONS(1246),
    [anon_sym_f32] = ACTIONS(1246),
    [anon_sym_f64] = ACTIONS(1246),
    [anon_sym_bool] = ACTIONS(1246),
    [anon_sym_str] = ACTIONS(1246),
    [anon_sym_char] = ACTIONS(1246),
    [anon_sym_DASH] = ACTIONS(1246),
    [anon_sym_SLASH] = ACTIONS(1246),
    [anon_sym_PERCENT] = ACTIONS(1246),
    [anon_sym_CARET] = ACTIONS(1246),
    [anon_sym_BANG] = ACTIONS(1246),
    [anon_sym_AMP] = ACTIONS(1246),
    [anon_sym_PIPE] = ACTIONS(1246),
    [anon_sym_AMP_AMP] = ACTIONS(1244),
    [anon_sym_PIPE_PIPE] = ACTIONS(1244),
    [anon_sym_LT_LT] = ACTIONS(1246),
    [anon_sym_GT_GT] = ACTIONS(1246),
    [anon_sym_PLUS_EQ] = ACTIONS(1244),
    [anon_sym_DASH_EQ] = ACTIONS(1244),
    [anon_sym_STAR_EQ] = ACTIONS(1244),
    [anon_sym_SLASH_EQ] = ACTIONS(1244),
    [anon_sym_PERCENT_EQ] = ACTIONS(1244),
    [anon_sym_CARET_EQ] = ACTIONS(1244),
    [anon_sym_AMP_EQ] = ACTIONS(1244),
    [anon_sym_PIPE_EQ] = ACTIONS(1244),
    [anon_sym_LT_LT_EQ] = ACTIONS(1244),
    [anon_sym_GT_GT_EQ] = ACTIONS(1244),
    [anon_sym_EQ] = ACTIONS(1246),
    [anon_sym_EQ_EQ] = ACTIONS(1244),
    [anon_sym_BANG_EQ] = ACTIONS(1244),
    [anon_sym_GT] = ACTIONS(1246),
    [anon_sym_LT] = ACTIONS(1246),
    [anon_sym_GT_EQ] = ACTIONS(1244),
    [anon_sym_LT_EQ] = ACTIONS(1244),
    [anon_sym_DOT] = ACTIONS(1246),
    [anon_sym_DOT_DOT] = ACTIONS(1246),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1244),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1244),
    [anon_sym_COLON_COLON] = ACTIONS(1244),
    [anon_sym_POUND] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [anon_sym_as] = ACTIONS(1246),
    [anon_sym_async] = ACTIONS(1246),
    [anon_sym_break] = ACTIONS(1246),
    [anon_sym_const] = ACTIONS(1246),
    [anon_sym_continue] = ACTIONS(1246),
    [anon_sym_default] = ACTIONS(1246),
    [anon_sym_enum] = ACTIONS(1246),
    [anon_sym_fn] = ACTIONS(1246),
    [anon_sym_for] = ACTIONS(1246),
    [anon_sym_if] = ACTIONS(1246),
    [anon_sym_impl] = ACTIONS(1246),
    [anon_sym_let] = ACTIONS(1246),
    [anon_sym_loop] = ACTIONS(1246),
    [anon_sym_match] = ACTIONS(1246),
    [anon_sym_mod] = ACTIONS(1246),
    [anon_sym_pub] = ACTIONS(1246),
    [anon_sym_return] = ACTIONS(1246),
    [anon_sym_static] = ACTIONS(1246),
    [anon_sym_struct] = ACTIONS(1246),
    [anon_sym_trait] = ACTIONS(1246),
    [anon_sym_type] = ACTIONS(1246),
    [anon_sym_union] = ACTIONS(1246),
    [anon_sym_unsafe] = ACTIONS(1246),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_while] = ACTIONS(1246),
    [anon_sym_extern] = ACTIONS(1246),
    [anon_sym_else] = ACTIONS(1246),
    [anon_sym_yield] = ACTIONS(1246),
    [anon_sym_move] = ACTIONS(1246),
    [anon_sym_try] = ACTIONS(1246),
    [sym_integer_literal] = ACTIONS(1244),
    [aux_sym_string_literal_token1] = ACTIONS(1244),
    [sym_char_literal] = ACTIONS(1244),
    [anon_sym_true] = ACTIONS(1246),
    [anon_sym_false] = ACTIONS(1246),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1246),
    [sym_super] = ACTIONS(1246),
    [sym_crate] = ACTIONS(1246),
    [sym_metavariable] = ACTIONS(1244),
    [sym__raw_string_literal_start] = ACTIONS(1244),
    [sym_float_literal] = ACTIONS(1244),
  },
  [370] = {
    [sym_bracketed_type] = STATE(3499),
    [sym_generic_function] = STATE(1394),
    [sym_generic_type_with_turbofish] = STATE(2768),
    [sym__expression_except_range] = STATE(1055),
    [sym__expression] = STATE(1839),
    [sym_macro_invocation] = STATE(1440),
    [sym_scoped_identifier] = STATE(1121),
    [sym_scoped_type_identifier_in_expression_position] = STATE(3095),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1394),
    [sym_try_expression] = STATE(1394),
    [sym_reference_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_assignment_expression] = STATE(1394),
    [sym_compound_assignment_expr] = STATE(1394),
    [sym_type_cast_expression] = STATE(1394),
    [sym_return_expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_array_expression] = STATE(1394),
    [sym_parenthesized_expression] = STATE(1394),
    [sym_tuple_expression] = STATE(1394),
    [sym_unit_expression] = STATE(1394),
    [sym_struct_expression] = STATE(1394),
    [sym_if_expression] = STATE(1394),
    [sym_match_expression] = STATE(1394),
    [sym_while_expression] = STATE(1394),
    [sym_loop_expression] = STATE(1394),
    [sym_for_expression] = STATE(1394),
    [sym_const_block] = STATE(1394),
    [sym_closure_expression] = STATE(1394),
    [sym_closure_parameters] = STATE(237),
    [sym_label] = STATE(3525),
    [sym_break_expression] = STATE(1394),
    [sym_continue_expression] = STATE(1394),
    [sym_index_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_field_expression] = STATE(1049),
    [sym_unsafe_block] = STATE(1394),
    [sym_async_block] = STATE(1394),
    [sym_try_block] = STATE(1394),
    [sym_block] = STATE(1394),
    [sym__literal] = STATE(1394),
    [sym_string_literal] = STATE(1441),
    [sym_raw_string_literal] = STATE(1441),
    [sym_boolean_literal] = STATE(1441),
    [sym_line_comment] = STATE(370),
    [sym_block_comment] = STATE(370),
    [sym_identifier] = ACTIONS(334),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(338),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(348),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(354),
    [anon_sym_loop] = ACTIONS(356),
    [anon_sym_match] = ACTIONS(358),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_static] = ACTIONS(360),
    [anon_sym_union] = ACTIONS(350),
    [anon_sym_unsafe] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(364),
    [anon_sym_yield] = ACTIONS(89),
    [anon_sym_move] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(366),
    [sym_integer_literal] = ACTIONS(95),
    [aux_sym_string_literal_token1] = ACTIONS(97),
    [sym_char_literal] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(99),
    [anon_sym_false] = ACTIONS(99),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(107),
    [sym_super] = ACTIONS(109),
    [sym_crate] = ACTIONS(109),
    [sym_metavariable] = ACTIONS(113),
    [sym__raw_string_literal_start] = ACTIONS(115),
    [sym_float_literal] = ACTIONS(95),
  },
  [371] = {
    [sym_line_comment] = STATE(371),
    [sym_block_comment] = STATE(371),
    [ts_builtin_sym_end] = ACTIONS(1248),
    [sym_identifier] = ACTIONS(1250),
    [anon_sym_SEMI] = ACTIONS(1248),
    [anon_sym_macro_rules_BANG] = ACTIONS(1248),
    [anon_sym_LPAREN] = ACTIONS(1248),
    [anon_sym_LBRACK] = ACTIONS(1248),
    [anon_sym_LBRACE] = ACTIONS(1248),
    [anon_sym_RBRACE] = ACTIONS(1248),
    [anon_sym_PLUS] = ACTIONS(1250),
    [anon_sym_STAR] = ACTIONS(1250),
    [anon_sym_QMARK] = ACTIONS(1248),
    [anon_sym_u8] = ACTIONS(1250),
    [anon_sym_i8] = ACTIONS(1250),
    [anon_sym_u16] = ACTIONS(1250),
    [anon_sym_i16] = ACTIONS(1250),
    [anon_sym_u32] = ACTIONS(1250),
    [anon_sym_i32] = ACTIONS(1250),
    [anon_sym_u64] = ACTIONS(1250),
    [anon_sym_i64] = ACTIONS(1250),
    [anon_sym_u128] = ACTIONS(1250),
    [anon_sym_i128] = ACTIONS(1250),
    [anon_sym_isize] = ACTIONS(1250),
    [anon_sym_usize] = ACTIONS(1250),
    [anon_sym_f32] = ACTIONS(1250),
    [anon_sym_f64] = ACTIONS(1250),
    [anon_sym_bool] = ACTIONS(1250),
    [anon_sym_str] = ACTIONS(1250),
    [anon_sym_char] = ACTIONS(1250),
    [anon_sym_DASH] = ACTIONS(1250),
    [anon_sym_SLASH] = ACTIONS(1250),
    [anon_sym_PERCENT] = ACTIONS(1250),
    [anon_sym_CARET] = ACTIONS(1250),
    [anon_sym_BANG] = ACTIONS(1250),
    [anon_sym_AMP] = ACTIONS(1250),
    [anon_sym_PIPE] = ACTIONS(1250),
    [anon_sym_AMP_AMP] = ACTIONS(1248),
    [anon_sym_PIPE_PIPE] = ACTIONS(1248),
    [anon_sym_LT_LT] = ACTIONS(1250),
    [anon_sym_GT_GT] = ACTIONS(1250),
    [anon_sym_PLUS_EQ] = ACTIONS(1248),
    [anon_sym_DASH_EQ] = ACTIONS(1248),
    [anon_sym_STAR_EQ] = ACTIONS(1248),
    [anon_sym_SLASH_EQ] = ACTIONS(1248),
    [anon_sym_PERCENT_EQ] = ACTIONS(1248),
    [anon_sym_CARET_EQ] = ACTIONS(1248),
    [anon_sym_AMP_EQ] = ACTIONS(1248),
    [anon_sym_PIPE_EQ] = ACTIONS(1248),
    [anon_sym_LT_LT_EQ] = ACTIONS(1248),
    [anon_sym_GT_GT_EQ] = ACTIONS(1248),
    [anon_sym_EQ] = ACTIONS(1250),
    [anon_sym_EQ_EQ] = ACTIONS(1248),
    [anon_sym_BANG_EQ] = ACTIONS(1248),
    [anon_sym_GT] = ACTIONS(1250),
    [anon_sym_LT] = ACTIONS(1250),
    [anon_sym_GT_EQ] = ACTIONS(1248),
    [anon_sym_LT_EQ] = ACTIONS(1248),
    [anon_sym_DOT] = ACTIONS(1250),
    [anon_sym_DOT_DOT] = ACTIONS(1250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1248),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1248),
    [anon_sym_COLON_COLON] = ACTIONS(1248),
    [anon_sym_POUND] = ACTIONS(1248),
    [anon_sym_SQUOTE] = ACTIONS(1250),
    [anon_sym_as] = ACTIONS(1250),
    [anon_sym_async] = ACTIONS(1250),
    [anon_sym_break] = ACTIONS(1250),
    [anon_sym_const] = ACTIONS(1250),
    [anon_sym_continue] = ACTIONS(1250),
    [anon_sym_default] = ACTIONS(1250),
    [anon_sym_enum] = ACTIONS(1250),
    [anon_sym_fn] = ACTIONS(1250),
    [anon_sym_for] = ACTIONS(1250),
    [anon_sym_if] = ACTIONS(1250),
    [anon_sym_impl] = ACTIONS(1250),
    [anon_sym_let] = ACTIONS(1250),
    [anon_sym_loop] = ACTIONS(1250),
    [anon_sym_match] = ACTIONS(1250),
    [anon_sym_mod] = ACTIONS(1250),
    [anon_sym_pub] = ACTIONS(1250),
    [anon_sym_return] = ACTIONS(1250),
    [anon_sym_static] = ACTIONS(1250),
    [anon_sym_struct] = ACTIONS(1250),
    [anon_sym_trait] = ACTIONS(1250),
    [anon_sym_type] = ACTIONS(1250),
    [anon_sym_union] = ACTIONS(1250),
    [anon_sym_unsafe] = ACTIONS(1250),
    [anon_sym_use] = ACTIONS(1250),
    [anon_sym_while] = ACTIONS(1250),
    [anon_sym_extern] = ACTIONS(1250),
    [anon_sym_yield] = ACTIONS(1250),
    [anon_sym_move] = ACTIONS(1250),
    [anon_sym_try] = ACTIONS(1250),
    [sym_integer_literal] = ACTIONS(1248),
    [aux_sym_string_literal_token1] = ACTIONS(1248),
    [sym_char_literal] = ACTIONS(1248),
    [anon_sym_true] = ACTIONS(1250),
    [anon_sym_false] = ACTIONS(1250),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1250),
    [sym_super] = ACTIONS(1250),
    [sym_crate] = ACTIONS(1250),
    [sym_metavariable] = ACTIONS(1248),
    [sym__raw_string_literal_start] = ACTIONS(1248),
    [sym_float_literal] = ACTIONS(1248),
  },
  [372] = {
    [sym_line_comment] = STATE(372),
    [sym_block_comment] = STATE(372),
    [ts_builtin_sym_end] = ACTIONS(1252),
    [sym_identifier] = ACTIONS(1254),
    [anon_sym_SEMI] = ACTIONS(1252),
    [anon_sym_macro_rules_BANG] = ACTIONS(1252),
    [anon_sym_LPAREN] = ACTIONS(1252),
    [anon_sym_LBRACK] = ACTIONS(1252),
    [anon_sym_LBRACE] = ACTIONS(1252),
    [anon_sym_RBRACE] = ACTIONS(1252),
    [anon_sym_PLUS] = ACTIONS(1254),
    [anon_sym_STAR] = ACTIONS(1254),
    [anon_sym_QMARK] = ACTIONS(1252),
    [anon_sym_u8] = ACTIONS(1254),
    [anon_sym_i8] = ACTIONS(1254),
    [anon_sym_u16] = ACTIONS(1254),
    [anon_sym_i16] = ACTIONS(1254),
    [anon_sym_u32] = ACTIONS(1254),
    [anon_sym_i32] = ACTIONS(1254),
    [anon_sym_u64] = ACTIONS(1254),
    [anon_sym_i64] = ACTIONS(1254),
    [anon_sym_u128] = ACTIONS(1254),
    [anon_sym_i128] = ACTIONS(1254),
    [anon_sym_isize] = ACTIONS(1254),
    [anon_sym_usize] = ACTIONS(1254),
    [anon_sym_f32] = ACTIONS(1254),
    [anon_sym_f64] = ACTIONS(1254),
    [anon_sym_bool] = ACTIONS(1254),
    [anon_sym_str] = ACTIONS(1254),
    [anon_sym_char] = ACTIONS(1254),
    [anon_sym_DASH] = ACTIONS(1254),
    [anon_sym_SLASH] = ACTIONS(1254),
    [anon_sym_PERCENT] = ACTIONS(1254),
    [anon_sym_CARET] = ACTIONS(1254),
    [anon_sym_BANG] = ACTIONS(1254),
    [anon_sym_AMP] = ACTIONS(1254),
    [anon_sym_PIPE] = ACTIONS(1254),
    [anon_sym_AMP_AMP] = ACTIONS(1252),
    [anon_sym_PIPE_PIPE] = ACTIONS(1252),
    [anon_sym_LT_LT] = ACTIONS(1254),
    [anon_sym_GT_GT] = ACTIONS(1254),
    [anon_sym_PLUS_EQ] = ACTIONS(1252),
    [anon_sym_DASH_EQ] = ACTIONS(1252),
    [anon_sym_STAR_EQ] = ACTIONS(1252),
    [anon_sym_SLASH_EQ] = ACTIONS(1252),
    [anon_sym_PERCENT_EQ] = ACTIONS(1252),
    [anon_sym_CARET_EQ] = ACTIONS(1252),
    [anon_sym_AMP_EQ] = ACTIONS(1252),
    [anon_sym_PIPE_EQ] = ACTIONS(1252),
    [anon_sym_LT_LT_EQ] = ACTIONS(1252),
    [anon_sym_GT_GT_EQ] = ACTIONS(1252),
    [anon_sym_EQ] = ACTIONS(1254),
    [anon_sym_EQ_EQ] = ACTIONS(1252),
    [anon_sym_BANG_EQ] = ACTIONS(1252),
    [anon_sym_GT] = ACTIONS(1254),
    [anon_sym_LT] = ACTIONS(1254),
    [anon_sym_GT_EQ] = ACTIONS(1252),
    [anon_sym_LT_EQ] = ACTIONS(1252),
    [anon_sym_DOT] = ACTIONS(1254),
    [anon_sym_DOT_DOT] = ACTIONS(1254),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1252),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1252),
    [anon_sym_COLON_COLON] = ACTIONS(1252),
    [anon_sym_POUND] = ACTIONS(1252),
    [anon_sym_SQUOTE] = ACTIONS(1254),
    [anon_sym_as] = ACTIONS(1254),
    [anon_sym_async] = ACTIONS(1254),
    [anon_sym_break] = ACTIONS(1254),
    [anon_sym_const] = ACTIONS(1254),
    [anon_sym_continue] = ACTIONS(1254),
    [anon_sym_default] = ACTIONS(1254),
    [anon_sym_enum] = ACTIONS(1254),
    [anon_sym_fn] = ACTIONS(1254),
    [anon_sym_for] = ACTIONS(1254),
    [anon_sym_if] = ACTIONS(1254),
    [anon_sym_impl] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(1254),
    [anon_sym_loop] = ACTIONS(1254),
    [anon_sym_match] = ACTIONS(1254),
    [anon_sym_mod] = ACTIONS(1254),
    [anon_sym_pub] = ACTIONS(1254),
    [anon_sym_return] = ACTIONS(1254),
    [anon_sym_static] = ACTIONS(1254),
    [anon_sym_struct] = ACTIONS(1254),
    [anon_sym_trait] = ACTIONS(1254),
    [anon_sym_type] = ACTIONS(1254),
    [anon_sym_union] = ACTIONS(1254),
    [anon_sym_unsafe] = ACTIONS(1254),
    [anon_sym_use] = ACTIONS(1254),
    [anon_sym_while] = ACTIONS(1254),
    [anon_sym_extern] = ACTIONS(1254),
    [anon_sym_yield] = ACTIONS(1254),
    [anon_sym_move] = ACTIONS(1254),
    [anon_sym_try] = ACTIONS(1254),
    [sym_integer_literal] = ACTIONS(1252),
    [aux_sym_string_literal_token1] = ACTIONS(1252),
    [sym_char_literal] = ACTIONS(1252),
    [anon_sym_true] = ACTIONS(1254),
    [anon_sym_false] = ACTIONS(1254),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1254),
    [sym_super] = ACTIONS(1254),
    [sym_crate] = ACTIONS(1254),
    [sym_metavariable] = ACTIONS(1252),
    [sym__raw_string_literal_start] = ACTIONS(1252),
    [sym_float_literal] = ACTIONS(1252),
  },
  [373] = {
    [sym_line_comment] = STATE(373),
    [sym_block_comment] = STATE(373),
    [ts_builtin_sym_end] = ACTIONS(1256),
    [sym_identifier] = ACTIONS(1258),
    [anon_sym_SEMI] = ACTIONS(1256),
    [anon_sym_macro_rules_BANG] = ACTIONS(1256),
    [anon_sym_LPAREN] = ACTIONS(1256),
    [anon_sym_LBRACK] = ACTIONS(1256),
    [anon_sym_LBRACE] = ACTIONS(1256),
    [anon_sym_RBRACE] = ACTIONS(1256),
    [anon_sym_PLUS] = ACTIONS(1258),
    [anon_sym_STAR] = ACTIONS(1258),
    [anon_sym_QMARK] = ACTIONS(1256),
    [anon_sym_u8] = ACTIONS(1258),
    [anon_sym_i8] = ACTIONS(1258),
    [anon_sym_u16] = ACTIONS(1258),
    [anon_sym_i16] = ACTIONS(1258),
    [anon_sym_u32] = ACTIONS(1258),
    [anon_sym_i32] = ACTIONS(1258),
    [anon_sym_u64] = ACTIONS(1258),
    [anon_sym_i64] = ACTIONS(1258),
    [anon_sym_u128] = ACTIONS(1258),
    [anon_sym_i128] = ACTIONS(1258),
    [anon_sym_isize] = ACTIONS(1258),
    [anon_sym_usize] = ACTIONS(1258),
    [anon_sym_f32] = ACTIONS(1258),
    [anon_sym_f64] = ACTIONS(1258),
    [anon_sym_bool] = ACTIONS(1258),
    [anon_sym_str] = ACTIONS(1258),
    [anon_sym_char] = ACTIONS(1258),
    [anon_sym_DASH] = ACTIONS(1258),
    [anon_sym_SLASH] = ACTIONS(1258),
    [anon_sym_PERCENT] = ACTIONS(1258),
    [anon_sym_CARET] = ACTIONS(1258),
    [anon_sym_BANG] = ACTIONS(1258),
    [anon_sym_AMP] = ACTIONS(1258),
    [anon_sym_PIPE] = ACTIONS(1258),
    [anon_sym_AMP_AMP] = ACTIONS(1256),
    [anon_sym_PIPE_PIPE] = ACTIONS(1256),
    [anon_sym_LT_LT] = ACTIONS(1258),
    [anon_sym_GT_GT] = ACTIONS(1258),
    [anon_sym_PLUS_EQ] = ACTIONS(1256),
    [anon_sym_DASH_EQ] = ACTIONS(1256),
    [anon_sym_STAR_EQ] = ACTIONS(1256),
    [anon_sym_SLASH_EQ] = ACTIONS(1256),
    [anon_sym_PERCENT_EQ] = ACTIONS(1256),
    [anon_sym_CARET_EQ] = ACTIONS(1256),
    [anon_sym_AMP_EQ] = ACTIONS(1256),
    [anon_sym_PIPE_EQ] = ACTIONS(1256),
    [anon_sym_LT_LT_EQ] = ACTIONS(1256),
    [anon_sym_GT_GT_EQ] = ACTIONS(1256),
    [anon_sym_EQ] = ACTIONS(1258),
    [anon_sym_EQ_EQ] = ACTIONS(1256),
    [anon_sym_BANG_EQ] = ACTIONS(1256),
    [anon_sym_GT] = ACTIONS(1258),
    [anon_sym_LT] = ACTIONS(1258),
    [anon_sym_GT_EQ] = ACTIONS(1256),
    [anon_sym_LT_EQ] = ACTIONS(1256),
    [anon_sym_DOT] = ACTIONS(1258),
    [anon_sym_DOT_DOT] = ACTIONS(1258),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1256),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1256),
    [anon_sym_COLON_COLON] = ACTIONS(1256),
    [anon_sym_POUND] = ACTIONS(1256),
    [anon_sym_SQUOTE] = ACTIONS(1258),
    [anon_sym_as] = ACTIONS(1258),
    [anon_sym_async] = ACTIONS(1258),
    [anon_sym_break] = ACTIONS(1258),
    [anon_sym_const] = ACTIONS(1258),
    [anon_sym_continue] = ACTIONS(1258),
    [anon_sym_default] = ACTIONS(1258),
    [anon_sym_enum] = ACTIONS(1258),
    [anon_sym_fn] = ACTIONS(1258),
    [anon_sym_for] = ACTIONS(1258),
    [anon_sym_if] = ACTIONS(1258),
    [anon_sym_impl] = ACTIONS(1258),
    [anon_sym_let] = ACTIONS(1258),
    [anon_sym_loop] = ACTIONS(1258),
    [anon_sym_match] = ACTIONS(1258),
    [anon_sym_mod] = ACTIONS(1258),
    [anon_sym_pub] = ACTIONS(1258),
    [anon_sym_return] = ACTIONS(1258),
    [anon_sym_static] = ACTIONS(1258),
    [anon_sym_struct] = ACTIONS(1258),
    [anon_sym_trait] = ACTIONS(1258),
    [anon_sym_type] = ACTIONS(1258),
    [anon_sym_union] = ACTIONS(1258),
    [anon_sym_unsafe] = ACTIONS(1258),
    [anon_sym_use] = ACTIONS(1258),
    [anon_sym_while] = ACTIONS(1258),
    [anon_sym_extern] = ACTIONS(1258),
    [anon_sym_yield] = ACTIONS(1258),
    [anon_sym_move] = ACTIONS(1258),
    [anon_sym_try] = ACTIONS(1258),
    [sym_integer_literal] = ACTIONS(1256),
    [aux_sym_string_literal_token1] = ACTIONS(1256),
    [sym_char_literal] = ACTIONS(1256),
    [anon_sym_true] = ACTIONS(1258),
    [anon_sym_false] = ACTIONS(1258),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1258),
    [sym_super] = ACTIONS(1258),
    [sym_crate] = ACTIONS(1258),
    [sym_metavariable] = ACTIONS(1256),
    [sym__raw_string_literal_start] = ACTIONS(1256),
    [sym_float_literal] = ACTIONS(1256),
  },
  [374] = {
    [sym_line_comment] = STATE(374),
    [sym_block_comment] = STATE(374),
    [ts_builtin_sym_end] = ACTIONS(1260),
    [sym_identifier] = ACTIONS(1262),
    [anon_sym_SEMI] = ACTIONS(1260),
    [anon_sym_macro_rules_BANG] = ACTIONS(1260),
    [anon_sym_LPAREN] = ACTIONS(1260),
    [anon_sym_LBRACK] = ACTIONS(1260),
    [anon_sym_LBRACE] = ACTIONS(1260),
    [anon_sym_RBRACE] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(1262),
    [anon_sym_STAR] = ACTIONS(1262),
    [anon_sym_QMARK] = ACTIONS(1260),
    [anon_sym_u8] = ACTIONS(1262),
    [anon_sym_i8] = ACTIONS(1262),
    [anon_sym_u16] = ACTIONS(1262),
    [anon_sym_i16] = ACTIONS(1262),
    [anon_sym_u32] = ACTIONS(1262),
    [anon_sym_i32] = ACTIONS(1262),
    [anon_sym_u64] = ACTIONS(1262),
    [anon_sym_i64] = ACTIONS(1262),
    [anon_sym_u128] = ACTIONS(1262),
    [anon_sym_i128] = ACTIONS(1262),
    [anon_sym_isize] = ACTIONS(1262),
    [anon_sym_usize] = ACTIONS(1262),
    [anon_sym_f32] = ACTIONS(1262),
    [anon_sym_f64] = ACTIONS(1262),
    [anon_sym_bool] = ACTIONS(1262),
    [anon_sym_str] = ACTIONS(1262),
    [anon_sym_char] = ACTIONS(1262),
    [anon_sym_DASH] = ACTIONS(1262),
    [anon_sym_SLASH] = ACTIONS(1262),
    [anon_sym_PERCENT] = ACTIONS(1262),
    [anon_sym_CARET] = ACTIONS(1262),
    [anon_sym_BANG] = ACTIONS(1262),
    [anon_sym_AMP] = ACTIONS(1262),
    [anon_sym_PIPE] = ACTIONS(1262),
    [anon_sym_AMP_AMP] = ACTIONS(1260),
    [anon_sym_PIPE_PIPE] = ACTIONS(1260),
    [anon_sym_LT_LT] = ACTIONS(1262),
    [anon_sym_GT_GT] = ACTIONS(1262),
    [anon_sym_PLUS_EQ] = ACTIONS(1260),
    [anon_sym_DASH_EQ] = ACTIONS(1260),
    [anon_sym_STAR_EQ] = ACTIONS(1260),
    [anon_sym_SLASH_EQ] = ACTIONS(1260),
    [anon_sym_PERCENT_EQ] = ACTIONS(1260),
    [anon_sym_CARET_EQ] = ACTIONS(1260),
    [anon_sym_AMP_EQ] = ACTIONS(1260),
    [anon_sym_PIPE_EQ] = ACTIONS(1260),
    [anon_sym_LT_LT_EQ] = ACTIONS(1260),
    [anon_sym_GT_GT_EQ] = ACTIONS(1260),
    [anon_sym_EQ] = ACTIONS(1262),
    [anon_sym_EQ_EQ] = ACTIONS(1260),
    [anon_sym_BANG_EQ] = ACTIONS(1260),
    [anon_sym_GT] = ACTIONS(1262),
    [anon_sym_LT] = ACTIONS(1262),
    [anon_sym_GT_EQ] = ACTIONS(1260),
    [anon_sym_LT_EQ] = ACTIONS(1260),
    [anon_sym_DOT] = ACTIONS(1262),
    [anon_sym_DOT_DOT] = ACTIONS(1262),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1260),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1260),
    [anon_sym_COLON_COLON] = ACTIONS(1260),
    [anon_sym_POUND] = ACTIONS(1260),
    [anon_sym_SQUOTE] = ACTIONS(1262),
    [anon_sym_as] = ACTIONS(1262),
    [anon_sym_async] = ACTIONS(1262),
    [anon_sym_break] = ACTIONS(1262),
    [anon_sym_const] = ACTIONS(1262),
    [anon_sym_continue] = ACTIONS(1262),
    [anon_sym_default] = ACTIONS(1262),
    [anon_sym_enum] = ACTIONS(1262),
    [anon_sym_fn] = ACTIONS(1262),
    [anon_sym_for] = ACTIONS(1262),
    [anon_sym_if] = ACTIONS(1262),
    [anon_sym_impl] = ACTIONS(1262),
    [anon_sym_let] = ACTIONS(1262),
    [anon_sym_loop] = ACTIONS(1262),
    [anon_sym_match] = ACTIONS(1262),
    [anon_sym_mod] = ACTIONS(1262),
    [anon_sym_pub] = ACTIONS(1262),
    [anon_sym_return] = ACTIONS(1262),
    [anon_sym_static] = ACTIONS(1262),
    [anon_sym_struct] = ACTIONS(1262),
    [anon_sym_trait] = ACTIONS(1262),
    [anon_sym_type] = ACTIONS(1262),
    [anon_sym_union] = ACTIONS(1262),
    [anon_sym_unsafe] = ACTIONS(1262),
    [anon_sym_use] = ACTIONS(1262),
    [anon_sym_while] = ACTIONS(1262),
    [anon_sym_extern] = ACTIONS(1262),
    [anon_sym_yield] = ACTIONS(1262),
    [anon_sym_move] = ACTIONS(1262),
    [anon_sym_try] = ACTIONS(1262),
    [sym_integer_literal] = ACTIONS(1260),
    [aux_sym_string_literal_token1] = ACTIONS(1260),
    [sym_char_literal] = ACTIONS(1260),
    [anon_sym_true] = ACTIONS(1262),
    [anon_sym_false] = ACTIONS(1262),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1262),
    [sym_super] = ACTIONS(1262),
    [sym_crate] = ACTIONS(1262),
    [sym_metavariable] = ACTIONS(1260),
    [sym__raw_string_literal_start] = ACTIONS(1260),
    [sym_float_literal] = ACTIONS(1260),
  },
  [375] = {
    [sym_attribute_item] = STATE(416),
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_self_parameter] = STATE(2955),
    [sym_variadic_parameter] = STATE(2955),
    [sym_parameter] = STATE(2955),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2621),
    [sym_bracketed_type] = STATE(3510),
    [sym_lifetime] = STATE(2946),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3294),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(2440),
    [sym_scoped_identifier] = STATE(2214),
    [sym_scoped_type_identifier] = STATE(2100),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(3137),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(375),
    [sym_block_comment] = STATE(375),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_LPAREN] = ACTIONS(1266),
    [anon_sym_RPAREN] = ACTIONS(1268),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1276),
    [anon_sym_i8] = ACTIONS(1276),
    [anon_sym_u16] = ACTIONS(1276),
    [anon_sym_i16] = ACTIONS(1276),
    [anon_sym_u32] = ACTIONS(1276),
    [anon_sym_i32] = ACTIONS(1276),
    [anon_sym_u64] = ACTIONS(1276),
    [anon_sym_i64] = ACTIONS(1276),
    [anon_sym_u128] = ACTIONS(1276),
    [anon_sym_i128] = ACTIONS(1276),
    [anon_sym_isize] = ACTIONS(1276),
    [anon_sym_usize] = ACTIONS(1276),
    [anon_sym_f32] = ACTIONS(1276),
    [anon_sym_f64] = ACTIONS(1276),
    [anon_sym_bool] = ACTIONS(1276),
    [anon_sym_str] = ACTIONS(1276),
    [anon_sym_char] = ACTIONS(1276),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1282),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1286),
    [anon_sym_DOT_DOT] = ACTIONS(1288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1290),
    [anon_sym_COMMA] = ACTIONS(1292),
    [anon_sym_COLON_COLON] = ACTIONS(1294),
    [anon_sym_POUND] = ACTIONS(1296),
    [anon_sym_SQUOTE] = ACTIONS(1298),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1302),
    [anon_sym_default] = ACTIONS(1304),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1312),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_ref] = ACTIONS(1316),
    [anon_sym_dyn] = ACTIONS(1318),
    [sym_mutable_specifier] = ACTIONS(1320),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1328),
    [sym_super] = ACTIONS(1330),
    [sym_crate] = ACTIONS(1330),
    [sym_metavariable] = ACTIONS(1332),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [376] = {
    [sym_line_comment] = STATE(376),
    [sym_block_comment] = STATE(376),
    [ts_builtin_sym_end] = ACTIONS(1001),
    [sym_identifier] = ACTIONS(999),
    [anon_sym_SEMI] = ACTIONS(1001),
    [anon_sym_macro_rules_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1001),
    [anon_sym_LBRACK] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(1001),
    [anon_sym_RBRACE] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_STAR] = ACTIONS(999),
    [anon_sym_QMARK] = ACTIONS(1001),
    [anon_sym_u8] = ACTIONS(999),
    [anon_sym_i8] = ACTIONS(999),
    [anon_sym_u16] = ACTIONS(999),
    [anon_sym_i16] = ACTIONS(999),
    [anon_sym_u32] = ACTIONS(999),
    [anon_sym_i32] = ACTIONS(999),
    [anon_sym_u64] = ACTIONS(999),
    [anon_sym_i64] = ACTIONS(999),
    [anon_sym_u128] = ACTIONS(999),
    [anon_sym_i128] = ACTIONS(999),
    [anon_sym_isize] = ACTIONS(999),
    [anon_sym_usize] = ACTIONS(999),
    [anon_sym_f32] = ACTIONS(999),
    [anon_sym_f64] = ACTIONS(999),
    [anon_sym_bool] = ACTIONS(999),
    [anon_sym_str] = ACTIONS(999),
    [anon_sym_char] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(999),
    [anon_sym_PERCENT] = ACTIONS(999),
    [anon_sym_CARET] = ACTIONS(999),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_AMP] = ACTIONS(999),
    [anon_sym_PIPE] = ACTIONS(999),
    [anon_sym_AMP_AMP] = ACTIONS(1001),
    [anon_sym_PIPE_PIPE] = ACTIONS(1001),
    [anon_sym_LT_LT] = ACTIONS(999),
    [anon_sym_GT_GT] = ACTIONS(999),
    [anon_sym_PLUS_EQ] = ACTIONS(1001),
    [anon_sym_DASH_EQ] = ACTIONS(1001),
    [anon_sym_STAR_EQ] = ACTIONS(1001),
    [anon_sym_SLASH_EQ] = ACTIONS(1001),
    [anon_sym_PERCENT_EQ] = ACTIONS(1001),
    [anon_sym_CARET_EQ] = ACTIONS(1001),
    [anon_sym_AMP_EQ] = ACTIONS(1001),
    [anon_sym_PIPE_EQ] = ACTIONS(1001),
    [anon_sym_LT_LT_EQ] = ACTIONS(1001),
    [anon_sym_GT_GT_EQ] = ACTIONS(1001),
    [anon_sym_EQ] = ACTIONS(999),
    [anon_sym_EQ_EQ] = ACTIONS(1001),
    [anon_sym_BANG_EQ] = ACTIONS(1001),
    [anon_sym_GT] = ACTIONS(999),
    [anon_sym_LT] = ACTIONS(999),
    [anon_sym_GT_EQ] = ACTIONS(1001),
    [anon_sym_LT_EQ] = ACTIONS(1001),
    [anon_sym_DOT] = ACTIONS(999),
    [anon_sym_DOT_DOT] = ACTIONS(999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1001),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1001),
    [anon_sym_COLON_COLON] = ACTIONS(1001),
    [anon_sym_POUND] = ACTIONS(1001),
    [anon_sym_SQUOTE] = ACTIONS(999),
    [anon_sym_as] = ACTIONS(999),
    [anon_sym_async] = ACTIONS(999),
    [anon_sym_break] = ACTIONS(999),
    [anon_sym_const] = ACTIONS(999),
    [anon_sym_continue] = ACTIONS(999),
    [anon_sym_default] = ACTIONS(999),
    [anon_sym_enum] = ACTIONS(999),
    [anon_sym_fn] = ACTIONS(999),
    [anon_sym_for] = ACTIONS(999),
    [anon_sym_if] = ACTIONS(999),
    [anon_sym_impl] = ACTIONS(999),
    [anon_sym_let] = ACTIONS(999),
    [anon_sym_loop] = ACTIONS(999),
    [anon_sym_match] = ACTIONS(999),
    [anon_sym_mod] = ACTIONS(999),
    [anon_sym_pub] = ACTIONS(999),
    [anon_sym_return] = ACTIONS(999),
    [anon_sym_static] = ACTIONS(999),
    [anon_sym_struct] = ACTIONS(999),
    [anon_sym_trait] = ACTIONS(999),
    [anon_sym_type] = ACTIONS(999),
    [anon_sym_union] = ACTIONS(999),
    [anon_sym_unsafe] = ACTIONS(999),
    [anon_sym_use] = ACTIONS(999),
    [anon_sym_while] = ACTIONS(999),
    [anon_sym_extern] = ACTIONS(999),
    [anon_sym_yield] = ACTIONS(999),
    [anon_sym_move] = ACTIONS(999),
    [anon_sym_try] = ACTIONS(999),
    [sym_integer_literal] = ACTIONS(1001),
    [aux_sym_string_literal_token1] = ACTIONS(1001),
    [sym_char_literal] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(999),
    [anon_sym_false] = ACTIONS(999),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(999),
    [sym_super] = ACTIONS(999),
    [sym_crate] = ACTIONS(999),
    [sym_metavariable] = ACTIONS(1001),
    [sym__raw_string_literal_start] = ACTIONS(1001),
    [sym_float_literal] = ACTIONS(1001),
  },
  [377] = {
    [sym_line_comment] = STATE(377),
    [sym_block_comment] = STATE(377),
    [ts_builtin_sym_end] = ACTIONS(1336),
    [sym_identifier] = ACTIONS(1338),
    [anon_sym_SEMI] = ACTIONS(1336),
    [anon_sym_macro_rules_BANG] = ACTIONS(1336),
    [anon_sym_LPAREN] = ACTIONS(1336),
    [anon_sym_LBRACK] = ACTIONS(1336),
    [anon_sym_LBRACE] = ACTIONS(1336),
    [anon_sym_RBRACE] = ACTIONS(1336),
    [anon_sym_PLUS] = ACTIONS(1338),
    [anon_sym_STAR] = ACTIONS(1338),
    [anon_sym_QMARK] = ACTIONS(1336),
    [anon_sym_u8] = ACTIONS(1338),
    [anon_sym_i8] = ACTIONS(1338),
    [anon_sym_u16] = ACTIONS(1338),
    [anon_sym_i16] = ACTIONS(1338),
    [anon_sym_u32] = ACTIONS(1338),
    [anon_sym_i32] = ACTIONS(1338),
    [anon_sym_u64] = ACTIONS(1338),
    [anon_sym_i64] = ACTIONS(1338),
    [anon_sym_u128] = ACTIONS(1338),
    [anon_sym_i128] = ACTIONS(1338),
    [anon_sym_isize] = ACTIONS(1338),
    [anon_sym_usize] = ACTIONS(1338),
    [anon_sym_f32] = ACTIONS(1338),
    [anon_sym_f64] = ACTIONS(1338),
    [anon_sym_bool] = ACTIONS(1338),
    [anon_sym_str] = ACTIONS(1338),
    [anon_sym_char] = ACTIONS(1338),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_SLASH] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_CARET] = ACTIONS(1338),
    [anon_sym_BANG] = ACTIONS(1338),
    [anon_sym_AMP] = ACTIONS(1338),
    [anon_sym_PIPE] = ACTIONS(1338),
    [anon_sym_AMP_AMP] = ACTIONS(1336),
    [anon_sym_PIPE_PIPE] = ACTIONS(1336),
    [anon_sym_LT_LT] = ACTIONS(1338),
    [anon_sym_GT_GT] = ACTIONS(1338),
    [anon_sym_PLUS_EQ] = ACTIONS(1336),
    [anon_sym_DASH_EQ] = ACTIONS(1336),
    [anon_sym_STAR_EQ] = ACTIONS(1336),
    [anon_sym_SLASH_EQ] = ACTIONS(1336),
    [anon_sym_PERCENT_EQ] = ACTIONS(1336),
    [anon_sym_CARET_EQ] = ACTIONS(1336),
    [anon_sym_AMP_EQ] = ACTIONS(1336),
    [anon_sym_PIPE_EQ] = ACTIONS(1336),
    [anon_sym_LT_LT_EQ] = ACTIONS(1336),
    [anon_sym_GT_GT_EQ] = ACTIONS(1336),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_EQ_EQ] = ACTIONS(1336),
    [anon_sym_BANG_EQ] = ACTIONS(1336),
    [anon_sym_GT] = ACTIONS(1338),
    [anon_sym_LT] = ACTIONS(1338),
    [anon_sym_GT_EQ] = ACTIONS(1336),
    [anon_sym_LT_EQ] = ACTIONS(1336),
    [anon_sym_DOT] = ACTIONS(1338),
    [anon_sym_DOT_DOT] = ACTIONS(1338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1336),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1336),
    [anon_sym_COLON_COLON] = ACTIONS(1336),
    [anon_sym_POUND] = ACTIONS(1336),
    [anon_sym_SQUOTE] = ACTIONS(1338),
    [anon_sym_as] = ACTIONS(1338),
    [anon_sym_async] = ACTIONS(1338),
    [anon_sym_break] = ACTIONS(1338),
    [anon_sym_const] = ACTIONS(1338),
    [anon_sym_continue] = ACTIONS(1338),
    [anon_sym_default] = ACTIONS(1338),
    [anon_sym_enum] = ACTIONS(1338),
    [anon_sym_fn] = ACTIONS(1338),
    [anon_sym_for] = ACTIONS(1338),
    [anon_sym_if] = ACTIONS(1338),
    [anon_sym_impl] = ACTIONS(1338),
    [anon_sym_let] = ACTIONS(1338),
    [anon_sym_loop] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1338),
    [anon_sym_mod] = ACTIONS(1338),
    [anon_sym_pub] = ACTIONS(1338),
    [anon_sym_return] = ACTIONS(1338),
    [anon_sym_static] = ACTIONS(1338),
    [anon_sym_struct] = ACTIONS(1338),
    [anon_sym_trait] = ACTIONS(1338),
    [anon_sym_type] = ACTIONS(1338),
    [anon_sym_union] = ACTIONS(1338),
    [anon_sym_unsafe] = ACTIONS(1338),
    [anon_sym_use] = ACTIONS(1338),
    [anon_sym_while] = ACTIONS(1338),
    [anon_sym_extern] = ACTIONS(1338),
    [anon_sym_yield] = ACTIONS(1338),
    [anon_sym_move] = ACTIONS(1338),
    [anon_sym_try] = ACTIONS(1338),
    [sym_integer_literal] = ACTIONS(1336),
    [aux_sym_string_literal_token1] = ACTIONS(1336),
    [sym_char_literal] = ACTIONS(1336),
    [anon_sym_true] = ACTIONS(1338),
    [anon_sym_false] = ACTIONS(1338),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1338),
    [sym_super] = ACTIONS(1338),
    [sym_crate] = ACTIONS(1338),
    [sym_metavariable] = ACTIONS(1336),
    [sym__raw_string_literal_start] = ACTIONS(1336),
    [sym_float_literal] = ACTIONS(1336),
  },
  [378] = {
    [sym_line_comment] = STATE(378),
    [sym_block_comment] = STATE(378),
    [ts_builtin_sym_end] = ACTIONS(1340),
    [sym_identifier] = ACTIONS(1342),
    [anon_sym_SEMI] = ACTIONS(1340),
    [anon_sym_macro_rules_BANG] = ACTIONS(1340),
    [anon_sym_LPAREN] = ACTIONS(1340),
    [anon_sym_LBRACK] = ACTIONS(1340),
    [anon_sym_LBRACE] = ACTIONS(1340),
    [anon_sym_RBRACE] = ACTIONS(1340),
    [anon_sym_PLUS] = ACTIONS(1344),
    [anon_sym_STAR] = ACTIONS(1342),
    [anon_sym_QMARK] = ACTIONS(1346),
    [anon_sym_u8] = ACTIONS(1342),
    [anon_sym_i8] = ACTIONS(1342),
    [anon_sym_u16] = ACTIONS(1342),
    [anon_sym_i16] = ACTIONS(1342),
    [anon_sym_u32] = ACTIONS(1342),
    [anon_sym_i32] = ACTIONS(1342),
    [anon_sym_u64] = ACTIONS(1342),
    [anon_sym_i64] = ACTIONS(1342),
    [anon_sym_u128] = ACTIONS(1342),
    [anon_sym_i128] = ACTIONS(1342),
    [anon_sym_isize] = ACTIONS(1342),
    [anon_sym_usize] = ACTIONS(1342),
    [anon_sym_f32] = ACTIONS(1342),
    [anon_sym_f64] = ACTIONS(1342),
    [anon_sym_bool] = ACTIONS(1342),
    [anon_sym_str] = ACTIONS(1342),
    [anon_sym_char] = ACTIONS(1342),
    [anon_sym_DASH] = ACTIONS(1342),
    [anon_sym_SLASH] = ACTIONS(1344),
    [anon_sym_PERCENT] = ACTIONS(1344),
    [anon_sym_CARET] = ACTIONS(1344),
    [anon_sym_BANG] = ACTIONS(1342),
    [anon_sym_AMP] = ACTIONS(1342),
    [anon_sym_PIPE] = ACTIONS(1342),
    [anon_sym_AMP_AMP] = ACTIONS(1346),
    [anon_sym_PIPE_PIPE] = ACTIONS(1346),
    [anon_sym_LT_LT] = ACTIONS(1344),
    [anon_sym_GT_GT] = ACTIONS(1344),
    [anon_sym_PLUS_EQ] = ACTIONS(1346),
    [anon_sym_DASH_EQ] = ACTIONS(1346),
    [anon_sym_STAR_EQ] = ACTIONS(1346),
    [anon_sym_SLASH_EQ] = ACTIONS(1346),
    [anon_sym_PERCENT_EQ] = ACTIONS(1346),
    [anon_sym_CARET_EQ] = ACTIONS(1346),
    [anon_sym_AMP_EQ] = ACTIONS(1346),
    [anon_sym_PIPE_EQ] = ACTIONS(1346),
    [anon_sym_LT_LT_EQ] = ACTIONS(1346),
    [anon_sym_GT_GT_EQ] = ACTIONS(1346),
    [anon_sym_EQ] = ACTIONS(1344),
    [anon_sym_EQ_EQ] = ACTIONS(1346),
    [anon_sym_BANG_EQ] = ACTIONS(1346),
    [anon_sym_GT] = ACTIONS(1344),
    [anon_sym_LT] = ACTIONS(1342),
    [anon_sym_GT_EQ] = ACTIONS(1346),
    [anon_sym_LT_EQ] = ACTIONS(1346),
    [anon_sym_DOT] = ACTIONS(1344),
    [anon_sym_DOT_DOT] = ACTIONS(1342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1346),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1346),
    [anon_sym_COLON_COLON] = ACTIONS(1340),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_SQUOTE] = ACTIONS(1342),
    [anon_sym_as] = ACTIONS(1344),
    [anon_sym_async] = ACTIONS(1342),
    [anon_sym_break] = ACTIONS(1342),
    [anon_sym_const] = ACTIONS(1342),
    [anon_sym_continue] = ACTIONS(1342),
    [anon_sym_default] = ACTIONS(1342),
    [anon_sym_enum] = ACTIONS(1342),
    [anon_sym_fn] = ACTIONS(1342),
    [anon_sym_for] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(1342),
    [anon_sym_impl] = ACTIONS(1342),
    [anon_sym_let] = ACTIONS(1342),
    [anon_sym_loop] = ACTIONS(1342),
    [anon_sym_match] = ACTIONS(1342),
    [anon_sym_mod] = ACTIONS(1342),
    [anon_sym_pub] = ACTIONS(1342),
    [anon_sym_return] = ACTIONS(1342),
    [anon_sym_static] = ACTIONS(1342),
    [anon_sym_struct] = ACTIONS(1342),
    [anon_sym_trait] = ACTIONS(1342),
    [anon_sym_type] = ACTIONS(1342),
    [anon_sym_union] = ACTIONS(1342),
    [anon_sym_unsafe] = ACTIONS(1342),
    [anon_sym_use] = ACTIONS(1342),
    [anon_sym_while] = ACTIONS(1342),
    [anon_sym_extern] = ACTIONS(1342),
    [anon_sym_yield] = ACTIONS(1342),
    [anon_sym_move] = ACTIONS(1342),
    [anon_sym_try] = ACTIONS(1342),
    [sym_integer_literal] = ACTIONS(1340),
    [aux_sym_string_literal_token1] = ACTIONS(1340),
    [sym_char_literal] = ACTIONS(1340),
    [anon_sym_true] = ACTIONS(1342),
    [anon_sym_false] = ACTIONS(1342),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1342),
    [sym_super] = ACTIONS(1342),
    [sym_crate] = ACTIONS(1342),
    [sym_metavariable] = ACTIONS(1340),
    [sym__raw_string_literal_start] = ACTIONS(1340),
    [sym_float_literal] = ACTIONS(1340),
  },
  [379] = {
    [sym_line_comment] = STATE(379),
    [sym_block_comment] = STATE(379),
    [ts_builtin_sym_end] = ACTIONS(1348),
    [sym_identifier] = ACTIONS(1350),
    [anon_sym_SEMI] = ACTIONS(1348),
    [anon_sym_macro_rules_BANG] = ACTIONS(1348),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACK] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(1348),
    [anon_sym_RBRACE] = ACTIONS(1348),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1350),
    [anon_sym_QMARK] = ACTIONS(1348),
    [anon_sym_u8] = ACTIONS(1350),
    [anon_sym_i8] = ACTIONS(1350),
    [anon_sym_u16] = ACTIONS(1350),
    [anon_sym_i16] = ACTIONS(1350),
    [anon_sym_u32] = ACTIONS(1350),
    [anon_sym_i32] = ACTIONS(1350),
    [anon_sym_u64] = ACTIONS(1350),
    [anon_sym_i64] = ACTIONS(1350),
    [anon_sym_u128] = ACTIONS(1350),
    [anon_sym_i128] = ACTIONS(1350),
    [anon_sym_isize] = ACTIONS(1350),
    [anon_sym_usize] = ACTIONS(1350),
    [anon_sym_f32] = ACTIONS(1350),
    [anon_sym_f64] = ACTIONS(1350),
    [anon_sym_bool] = ACTIONS(1350),
    [anon_sym_str] = ACTIONS(1350),
    [anon_sym_char] = ACTIONS(1350),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_SLASH] = ACTIONS(1350),
    [anon_sym_PERCENT] = ACTIONS(1350),
    [anon_sym_CARET] = ACTIONS(1350),
    [anon_sym_BANG] = ACTIONS(1350),
    [anon_sym_AMP] = ACTIONS(1350),
    [anon_sym_PIPE] = ACTIONS(1350),
    [anon_sym_AMP_AMP] = ACTIONS(1348),
    [anon_sym_PIPE_PIPE] = ACTIONS(1348),
    [anon_sym_LT_LT] = ACTIONS(1350),
    [anon_sym_GT_GT] = ACTIONS(1350),
    [anon_sym_PLUS_EQ] = ACTIONS(1348),
    [anon_sym_DASH_EQ] = ACTIONS(1348),
    [anon_sym_STAR_EQ] = ACTIONS(1348),
    [anon_sym_SLASH_EQ] = ACTIONS(1348),
    [anon_sym_PERCENT_EQ] = ACTIONS(1348),
    [anon_sym_CARET_EQ] = ACTIONS(1348),
    [anon_sym_AMP_EQ] = ACTIONS(1348),
    [anon_sym_PIPE_EQ] = ACTIONS(1348),
    [anon_sym_LT_LT_EQ] = ACTIONS(1348),
    [anon_sym_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_EQ] = ACTIONS(1350),
    [anon_sym_EQ_EQ] = ACTIONS(1348),
    [anon_sym_BANG_EQ] = ACTIONS(1348),
    [anon_sym_GT] = ACTIONS(1350),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_GT_EQ] = ACTIONS(1348),
    [anon_sym_LT_EQ] = ACTIONS(1348),
    [anon_sym_DOT] = ACTIONS(1350),
    [anon_sym_DOT_DOT] = ACTIONS(1350),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1348),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1348),
    [anon_sym_COLON_COLON] = ACTIONS(1348),
    [anon_sym_POUND] = ACTIONS(1348),
    [anon_sym_SQUOTE] = ACTIONS(1350),
    [anon_sym_as] = ACTIONS(1350),
    [anon_sym_async] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_fn] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_impl] = ACTIONS(1350),
    [anon_sym_let] = ACTIONS(1350),
    [anon_sym_loop] = ACTIONS(1350),
    [anon_sym_match] = ACTIONS(1350),
    [anon_sym_mod] = ACTIONS(1350),
    [anon_sym_pub] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_trait] = ACTIONS(1350),
    [anon_sym_type] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_unsafe] = ACTIONS(1350),
    [anon_sym_use] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym_yield] = ACTIONS(1350),
    [anon_sym_move] = ACTIONS(1350),
    [anon_sym_try] = ACTIONS(1350),
    [sym_integer_literal] = ACTIONS(1348),
    [aux_sym_string_literal_token1] = ACTIONS(1348),
    [sym_char_literal] = ACTIONS(1348),
    [anon_sym_true] = ACTIONS(1350),
    [anon_sym_false] = ACTIONS(1350),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1350),
    [sym_super] = ACTIONS(1350),
    [sym_crate] = ACTIONS(1350),
    [sym_metavariable] = ACTIONS(1348),
    [sym__raw_string_literal_start] = ACTIONS(1348),
    [sym_float_literal] = ACTIONS(1348),
  },
  [380] = {
    [sym_line_comment] = STATE(380),
    [sym_block_comment] = STATE(380),
    [ts_builtin_sym_end] = ACTIONS(1352),
    [sym_identifier] = ACTIONS(1354),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym_macro_rules_BANG] = ACTIONS(1352),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACK] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_RBRACE] = ACTIONS(1352),
    [anon_sym_PLUS] = ACTIONS(1354),
    [anon_sym_STAR] = ACTIONS(1354),
    [anon_sym_QMARK] = ACTIONS(1352),
    [anon_sym_u8] = ACTIONS(1354),
    [anon_sym_i8] = ACTIONS(1354),
    [anon_sym_u16] = ACTIONS(1354),
    [anon_sym_i16] = ACTIONS(1354),
    [anon_sym_u32] = ACTIONS(1354),
    [anon_sym_i32] = ACTIONS(1354),
    [anon_sym_u64] = ACTIONS(1354),
    [anon_sym_i64] = ACTIONS(1354),
    [anon_sym_u128] = ACTIONS(1354),
    [anon_sym_i128] = ACTIONS(1354),
    [anon_sym_isize] = ACTIONS(1354),
    [anon_sym_usize] = ACTIONS(1354),
    [anon_sym_f32] = ACTIONS(1354),
    [anon_sym_f64] = ACTIONS(1354),
    [anon_sym_bool] = ACTIONS(1354),
    [anon_sym_str] = ACTIONS(1354),
    [anon_sym_char] = ACTIONS(1354),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_SLASH] = ACTIONS(1354),
    [anon_sym_PERCENT] = ACTIONS(1354),
    [anon_sym_CARET] = ACTIONS(1354),
    [anon_sym_BANG] = ACTIONS(1354),
    [anon_sym_AMP] = ACTIONS(1354),
    [anon_sym_PIPE] = ACTIONS(1354),
    [anon_sym_AMP_AMP] = ACTIONS(1352),
    [anon_sym_PIPE_PIPE] = ACTIONS(1352),
    [anon_sym_LT_LT] = ACTIONS(1354),
    [anon_sym_GT_GT] = ACTIONS(1354),
    [anon_sym_PLUS_EQ] = ACTIONS(1352),
    [anon_sym_DASH_EQ] = ACTIONS(1352),
    [anon_sym_STAR_EQ] = ACTIONS(1352),
    [anon_sym_SLASH_EQ] = ACTIONS(1352),
    [anon_sym_PERCENT_EQ] = ACTIONS(1352),
    [anon_sym_CARET_EQ] = ACTIONS(1352),
    [anon_sym_AMP_EQ] = ACTIONS(1352),
    [anon_sym_PIPE_EQ] = ACTIONS(1352),
    [anon_sym_LT_LT_EQ] = ACTIONS(1352),
    [anon_sym_GT_GT_EQ] = ACTIONS(1352),
    [anon_sym_EQ] = ACTIONS(1354),
    [anon_sym_EQ_EQ] = ACTIONS(1352),
    [anon_sym_BANG_EQ] = ACTIONS(1352),
    [anon_sym_GT] = ACTIONS(1354),
    [anon_sym_LT] = ACTIONS(1354),
    [anon_sym_GT_EQ] = ACTIONS(1352),
    [anon_sym_LT_EQ] = ACTIONS(1352),
    [anon_sym_DOT] = ACTIONS(1354),
    [anon_sym_DOT_DOT] = ACTIONS(1354),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1352),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1352),
    [anon_sym_COLON_COLON] = ACTIONS(1352),
    [anon_sym_POUND] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1354),
    [anon_sym_as] = ACTIONS(1354),
    [anon_sym_async] = ACTIONS(1354),
    [anon_sym_break] = ACTIONS(1354),
    [anon_sym_const] = ACTIONS(1354),
    [anon_sym_continue] = ACTIONS(1354),
    [anon_sym_default] = ACTIONS(1354),
    [anon_sym_enum] = ACTIONS(1354),
    [anon_sym_fn] = ACTIONS(1354),
    [anon_sym_for] = ACTIONS(1354),
    [anon_sym_if] = ACTIONS(1354),
    [anon_sym_impl] = ACTIONS(1354),
    [anon_sym_let] = ACTIONS(1354),
    [anon_sym_loop] = ACTIONS(1354),
    [anon_sym_match] = ACTIONS(1354),
    [anon_sym_mod] = ACTIONS(1354),
    [anon_sym_pub] = ACTIONS(1354),
    [anon_sym_return] = ACTIONS(1354),
    [anon_sym_static] = ACTIONS(1354),
    [anon_sym_struct] = ACTIONS(1354),
    [anon_sym_trait] = ACTIONS(1354),
    [anon_sym_type] = ACTIONS(1354),
    [anon_sym_union] = ACTIONS(1354),
    [anon_sym_unsafe] = ACTIONS(1354),
    [anon_sym_use] = ACTIONS(1354),
    [anon_sym_while] = ACTIONS(1354),
    [anon_sym_extern] = ACTIONS(1354),
    [anon_sym_yield] = ACTIONS(1354),
    [anon_sym_move] = ACTIONS(1354),
    [anon_sym_try] = ACTIONS(1354),
    [sym_integer_literal] = ACTIONS(1352),
    [aux_sym_string_literal_token1] = ACTIONS(1352),
    [sym_char_literal] = ACTIONS(1352),
    [anon_sym_true] = ACTIONS(1354),
    [anon_sym_false] = ACTIONS(1354),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1354),
    [sym_super] = ACTIONS(1354),
    [sym_crate] = ACTIONS(1354),
    [sym_metavariable] = ACTIONS(1352),
    [sym__raw_string_literal_start] = ACTIONS(1352),
    [sym_float_literal] = ACTIONS(1352),
  },
  [381] = {
    [sym_attribute_item] = STATE(416),
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_self_parameter] = STATE(2955),
    [sym_variadic_parameter] = STATE(2955),
    [sym_parameter] = STATE(2955),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2621),
    [sym_bracketed_type] = STATE(3517),
    [sym_lifetime] = STATE(2946),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3091),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(2447),
    [sym_scoped_identifier] = STATE(2101),
    [sym_scoped_type_identifier] = STATE(2100),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2455),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(381),
    [sym_block_comment] = STATE(381),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(1356),
    [anon_sym_LPAREN] = ACTIONS(1358),
    [anon_sym_RPAREN] = ACTIONS(1360),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1362),
    [anon_sym_i8] = ACTIONS(1362),
    [anon_sym_u16] = ACTIONS(1362),
    [anon_sym_i16] = ACTIONS(1362),
    [anon_sym_u32] = ACTIONS(1362),
    [anon_sym_i32] = ACTIONS(1362),
    [anon_sym_u64] = ACTIONS(1362),
    [anon_sym_i64] = ACTIONS(1362),
    [anon_sym_u128] = ACTIONS(1362),
    [anon_sym_i128] = ACTIONS(1362),
    [anon_sym_isize] = ACTIONS(1362),
    [anon_sym_usize] = ACTIONS(1362),
    [anon_sym_f32] = ACTIONS(1362),
    [anon_sym_f64] = ACTIONS(1362),
    [anon_sym_bool] = ACTIONS(1362),
    [anon_sym_str] = ACTIONS(1362),
    [anon_sym_char] = ACTIONS(1362),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1364),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1366),
    [anon_sym_DOT_DOT] = ACTIONS(1288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1290),
    [anon_sym_COMMA] = ACTIONS(1368),
    [anon_sym_COLON_COLON] = ACTIONS(1370),
    [anon_sym_POUND] = ACTIONS(1296),
    [anon_sym_SQUOTE] = ACTIONS(1298),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1302),
    [anon_sym_default] = ACTIONS(1372),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1374),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_ref] = ACTIONS(1316),
    [anon_sym_dyn] = ACTIONS(1318),
    [sym_mutable_specifier] = ACTIONS(1320),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1376),
    [sym_super] = ACTIONS(1378),
    [sym_crate] = ACTIONS(1378),
    [sym_metavariable] = ACTIONS(1380),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [382] = {
    [sym_line_comment] = STATE(382),
    [sym_block_comment] = STATE(382),
    [ts_builtin_sym_end] = ACTIONS(1382),
    [sym_identifier] = ACTIONS(1384),
    [anon_sym_SEMI] = ACTIONS(1382),
    [anon_sym_macro_rules_BANG] = ACTIONS(1382),
    [anon_sym_LPAREN] = ACTIONS(1382),
    [anon_sym_LBRACK] = ACTIONS(1382),
    [anon_sym_LBRACE] = ACTIONS(1382),
    [anon_sym_RBRACE] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(1384),
    [anon_sym_STAR] = ACTIONS(1384),
    [anon_sym_QMARK] = ACTIONS(1382),
    [anon_sym_u8] = ACTIONS(1384),
    [anon_sym_i8] = ACTIONS(1384),
    [anon_sym_u16] = ACTIONS(1384),
    [anon_sym_i16] = ACTIONS(1384),
    [anon_sym_u32] = ACTIONS(1384),
    [anon_sym_i32] = ACTIONS(1384),
    [anon_sym_u64] = ACTIONS(1384),
    [anon_sym_i64] = ACTIONS(1384),
    [anon_sym_u128] = ACTIONS(1384),
    [anon_sym_i128] = ACTIONS(1384),
    [anon_sym_isize] = ACTIONS(1384),
    [anon_sym_usize] = ACTIONS(1384),
    [anon_sym_f32] = ACTIONS(1384),
    [anon_sym_f64] = ACTIONS(1384),
    [anon_sym_bool] = ACTIONS(1384),
    [anon_sym_str] = ACTIONS(1384),
    [anon_sym_char] = ACTIONS(1384),
    [anon_sym_DASH] = ACTIONS(1384),
    [anon_sym_SLASH] = ACTIONS(1384),
    [anon_sym_PERCENT] = ACTIONS(1384),
    [anon_sym_CARET] = ACTIONS(1384),
    [anon_sym_BANG] = ACTIONS(1384),
    [anon_sym_AMP] = ACTIONS(1384),
    [anon_sym_PIPE] = ACTIONS(1384),
    [anon_sym_AMP_AMP] = ACTIONS(1382),
    [anon_sym_PIPE_PIPE] = ACTIONS(1382),
    [anon_sym_LT_LT] = ACTIONS(1384),
    [anon_sym_GT_GT] = ACTIONS(1384),
    [anon_sym_PLUS_EQ] = ACTIONS(1382),
    [anon_sym_DASH_EQ] = ACTIONS(1382),
    [anon_sym_STAR_EQ] = ACTIONS(1382),
    [anon_sym_SLASH_EQ] = ACTIONS(1382),
    [anon_sym_PERCENT_EQ] = ACTIONS(1382),
    [anon_sym_CARET_EQ] = ACTIONS(1382),
    [anon_sym_AMP_EQ] = ACTIONS(1382),
    [anon_sym_PIPE_EQ] = ACTIONS(1382),
    [anon_sym_LT_LT_EQ] = ACTIONS(1382),
    [anon_sym_GT_GT_EQ] = ACTIONS(1382),
    [anon_sym_EQ] = ACTIONS(1384),
    [anon_sym_EQ_EQ] = ACTIONS(1382),
    [anon_sym_BANG_EQ] = ACTIONS(1382),
    [anon_sym_GT] = ACTIONS(1384),
    [anon_sym_LT] = ACTIONS(1384),
    [anon_sym_GT_EQ] = ACTIONS(1382),
    [anon_sym_LT_EQ] = ACTIONS(1382),
    [anon_sym_DOT] = ACTIONS(1384),
    [anon_sym_DOT_DOT] = ACTIONS(1384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1382),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1382),
    [anon_sym_COLON_COLON] = ACTIONS(1382),
    [anon_sym_POUND] = ACTIONS(1382),
    [anon_sym_SQUOTE] = ACTIONS(1384),
    [anon_sym_as] = ACTIONS(1384),
    [anon_sym_async] = ACTIONS(1384),
    [anon_sym_break] = ACTIONS(1384),
    [anon_sym_const] = ACTIONS(1384),
    [anon_sym_continue] = ACTIONS(1384),
    [anon_sym_default] = ACTIONS(1384),
    [anon_sym_enum] = ACTIONS(1384),
    [anon_sym_fn] = ACTIONS(1384),
    [anon_sym_for] = ACTIONS(1384),
    [anon_sym_if] = ACTIONS(1384),
    [anon_sym_impl] = ACTIONS(1384),
    [anon_sym_let] = ACTIONS(1384),
    [anon_sym_loop] = ACTIONS(1384),
    [anon_sym_match] = ACTIONS(1384),
    [anon_sym_mod] = ACTIONS(1384),
    [anon_sym_pub] = ACTIONS(1384),
    [anon_sym_return] = ACTIONS(1384),
    [anon_sym_static] = ACTIONS(1384),
    [anon_sym_struct] = ACTIONS(1384),
    [anon_sym_trait] = ACTIONS(1384),
    [anon_sym_type] = ACTIONS(1384),
    [anon_sym_union] = ACTIONS(1384),
    [anon_sym_unsafe] = ACTIONS(1384),
    [anon_sym_use] = ACTIONS(1384),
    [anon_sym_while] = ACTIONS(1384),
    [anon_sym_extern] = ACTIONS(1384),
    [anon_sym_yield] = ACTIONS(1384),
    [anon_sym_move] = ACTIONS(1384),
    [anon_sym_try] = ACTIONS(1384),
    [sym_integer_literal] = ACTIONS(1382),
    [aux_sym_string_literal_token1] = ACTIONS(1382),
    [sym_char_literal] = ACTIONS(1382),
    [anon_sym_true] = ACTIONS(1384),
    [anon_sym_false] = ACTIONS(1384),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1384),
    [sym_super] = ACTIONS(1384),
    [sym_crate] = ACTIONS(1384),
    [sym_metavariable] = ACTIONS(1382),
    [sym__raw_string_literal_start] = ACTIONS(1382),
    [sym_float_literal] = ACTIONS(1382),
  },
  [383] = {
    [sym_attribute_item] = STATE(416),
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_self_parameter] = STATE(2955),
    [sym_variadic_parameter] = STATE(2955),
    [sym_parameter] = STATE(2955),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2621),
    [sym_bracketed_type] = STATE(3517),
    [sym_lifetime] = STATE(2946),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3091),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(2447),
    [sym_scoped_identifier] = STATE(2101),
    [sym_scoped_type_identifier] = STATE(2100),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2455),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(383),
    [sym_block_comment] = STATE(383),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(1356),
    [anon_sym_LPAREN] = ACTIONS(1358),
    [anon_sym_RPAREN] = ACTIONS(1386),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1362),
    [anon_sym_i8] = ACTIONS(1362),
    [anon_sym_u16] = ACTIONS(1362),
    [anon_sym_i16] = ACTIONS(1362),
    [anon_sym_u32] = ACTIONS(1362),
    [anon_sym_i32] = ACTIONS(1362),
    [anon_sym_u64] = ACTIONS(1362),
    [anon_sym_i64] = ACTIONS(1362),
    [anon_sym_u128] = ACTIONS(1362),
    [anon_sym_i128] = ACTIONS(1362),
    [anon_sym_isize] = ACTIONS(1362),
    [anon_sym_usize] = ACTIONS(1362),
    [anon_sym_f32] = ACTIONS(1362),
    [anon_sym_f64] = ACTIONS(1362),
    [anon_sym_bool] = ACTIONS(1362),
    [anon_sym_str] = ACTIONS(1362),
    [anon_sym_char] = ACTIONS(1362),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1364),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1366),
    [anon_sym_DOT_DOT] = ACTIONS(1288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1290),
    [anon_sym_COMMA] = ACTIONS(1388),
    [anon_sym_COLON_COLON] = ACTIONS(1370),
    [anon_sym_POUND] = ACTIONS(1296),
    [anon_sym_SQUOTE] = ACTIONS(1298),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1302),
    [anon_sym_default] = ACTIONS(1372),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1374),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_ref] = ACTIONS(1316),
    [anon_sym_dyn] = ACTIONS(1318),
    [sym_mutable_specifier] = ACTIONS(1320),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1376),
    [sym_super] = ACTIONS(1378),
    [sym_crate] = ACTIONS(1378),
    [sym_metavariable] = ACTIONS(1380),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [384] = {
    [sym_line_comment] = STATE(384),
    [sym_block_comment] = STATE(384),
    [ts_builtin_sym_end] = ACTIONS(1390),
    [sym_identifier] = ACTIONS(1392),
    [anon_sym_SEMI] = ACTIONS(1390),
    [anon_sym_macro_rules_BANG] = ACTIONS(1390),
    [anon_sym_LPAREN] = ACTIONS(1390),
    [anon_sym_LBRACK] = ACTIONS(1390),
    [anon_sym_LBRACE] = ACTIONS(1390),
    [anon_sym_RBRACE] = ACTIONS(1390),
    [anon_sym_PLUS] = ACTIONS(1392),
    [anon_sym_STAR] = ACTIONS(1392),
    [anon_sym_QMARK] = ACTIONS(1390),
    [anon_sym_u8] = ACTIONS(1392),
    [anon_sym_i8] = ACTIONS(1392),
    [anon_sym_u16] = ACTIONS(1392),
    [anon_sym_i16] = ACTIONS(1392),
    [anon_sym_u32] = ACTIONS(1392),
    [anon_sym_i32] = ACTIONS(1392),
    [anon_sym_u64] = ACTIONS(1392),
    [anon_sym_i64] = ACTIONS(1392),
    [anon_sym_u128] = ACTIONS(1392),
    [anon_sym_i128] = ACTIONS(1392),
    [anon_sym_isize] = ACTIONS(1392),
    [anon_sym_usize] = ACTIONS(1392),
    [anon_sym_f32] = ACTIONS(1392),
    [anon_sym_f64] = ACTIONS(1392),
    [anon_sym_bool] = ACTIONS(1392),
    [anon_sym_str] = ACTIONS(1392),
    [anon_sym_char] = ACTIONS(1392),
    [anon_sym_DASH] = ACTIONS(1392),
    [anon_sym_SLASH] = ACTIONS(1392),
    [anon_sym_PERCENT] = ACTIONS(1392),
    [anon_sym_CARET] = ACTIONS(1392),
    [anon_sym_BANG] = ACTIONS(1392),
    [anon_sym_AMP] = ACTIONS(1392),
    [anon_sym_PIPE] = ACTIONS(1392),
    [anon_sym_AMP_AMP] = ACTIONS(1390),
    [anon_sym_PIPE_PIPE] = ACTIONS(1390),
    [anon_sym_LT_LT] = ACTIONS(1392),
    [anon_sym_GT_GT] = ACTIONS(1392),
    [anon_sym_PLUS_EQ] = ACTIONS(1390),
    [anon_sym_DASH_EQ] = ACTIONS(1390),
    [anon_sym_STAR_EQ] = ACTIONS(1390),
    [anon_sym_SLASH_EQ] = ACTIONS(1390),
    [anon_sym_PERCENT_EQ] = ACTIONS(1390),
    [anon_sym_CARET_EQ] = ACTIONS(1390),
    [anon_sym_AMP_EQ] = ACTIONS(1390),
    [anon_sym_PIPE_EQ] = ACTIONS(1390),
    [anon_sym_LT_LT_EQ] = ACTIONS(1390),
    [anon_sym_GT_GT_EQ] = ACTIONS(1390),
    [anon_sym_EQ] = ACTIONS(1392),
    [anon_sym_EQ_EQ] = ACTIONS(1390),
    [anon_sym_BANG_EQ] = ACTIONS(1390),
    [anon_sym_GT] = ACTIONS(1392),
    [anon_sym_LT] = ACTIONS(1392),
    [anon_sym_GT_EQ] = ACTIONS(1390),
    [anon_sym_LT_EQ] = ACTIONS(1390),
    [anon_sym_DOT] = ACTIONS(1392),
    [anon_sym_DOT_DOT] = ACTIONS(1392),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1390),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1390),
    [anon_sym_COLON_COLON] = ACTIONS(1390),
    [anon_sym_POUND] = ACTIONS(1390),
    [anon_sym_SQUOTE] = ACTIONS(1392),
    [anon_sym_as] = ACTIONS(1392),
    [anon_sym_async] = ACTIONS(1392),
    [anon_sym_break] = ACTIONS(1392),
    [anon_sym_const] = ACTIONS(1392),
    [anon_sym_continue] = ACTIONS(1392),
    [anon_sym_default] = ACTIONS(1392),
    [anon_sym_enum] = ACTIONS(1392),
    [anon_sym_fn] = ACTIONS(1392),
    [anon_sym_for] = ACTIONS(1392),
    [anon_sym_if] = ACTIONS(1392),
    [anon_sym_impl] = ACTIONS(1392),
    [anon_sym_let] = ACTIONS(1392),
    [anon_sym_loop] = ACTIONS(1392),
    [anon_sym_match] = ACTIONS(1392),
    [anon_sym_mod] = ACTIONS(1392),
    [anon_sym_pub] = ACTIONS(1392),
    [anon_sym_return] = ACTIONS(1392),
    [anon_sym_static] = ACTIONS(1392),
    [anon_sym_struct] = ACTIONS(1392),
    [anon_sym_trait] = ACTIONS(1392),
    [anon_sym_type] = ACTIONS(1392),
    [anon_sym_union] = ACTIONS(1392),
    [anon_sym_unsafe] = ACTIONS(1392),
    [anon_sym_use] = ACTIONS(1392),
    [anon_sym_while] = ACTIONS(1392),
    [anon_sym_extern] = ACTIONS(1392),
    [anon_sym_yield] = ACTIONS(1392),
    [anon_sym_move] = ACTIONS(1392),
    [anon_sym_try] = ACTIONS(1392),
    [sym_integer_literal] = ACTIONS(1390),
    [aux_sym_string_literal_token1] = ACTIONS(1390),
    [sym_char_literal] = ACTIONS(1390),
    [anon_sym_true] = ACTIONS(1392),
    [anon_sym_false] = ACTIONS(1392),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1392),
    [sym_super] = ACTIONS(1392),
    [sym_crate] = ACTIONS(1392),
    [sym_metavariable] = ACTIONS(1390),
    [sym__raw_string_literal_start] = ACTIONS(1390),
    [sym_float_literal] = ACTIONS(1390),
  },
  [385] = {
    [sym_line_comment] = STATE(385),
    [sym_block_comment] = STATE(385),
    [ts_builtin_sym_end] = ACTIONS(1394),
    [sym_identifier] = ACTIONS(1396),
    [anon_sym_SEMI] = ACTIONS(1394),
    [anon_sym_macro_rules_BANG] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(1394),
    [anon_sym_LBRACK] = ACTIONS(1394),
    [anon_sym_LBRACE] = ACTIONS(1394),
    [anon_sym_RBRACE] = ACTIONS(1394),
    [anon_sym_PLUS] = ACTIONS(1396),
    [anon_sym_STAR] = ACTIONS(1396),
    [anon_sym_QMARK] = ACTIONS(1394),
    [anon_sym_u8] = ACTIONS(1396),
    [anon_sym_i8] = ACTIONS(1396),
    [anon_sym_u16] = ACTIONS(1396),
    [anon_sym_i16] = ACTIONS(1396),
    [anon_sym_u32] = ACTIONS(1396),
    [anon_sym_i32] = ACTIONS(1396),
    [anon_sym_u64] = ACTIONS(1396),
    [anon_sym_i64] = ACTIONS(1396),
    [anon_sym_u128] = ACTIONS(1396),
    [anon_sym_i128] = ACTIONS(1396),
    [anon_sym_isize] = ACTIONS(1396),
    [anon_sym_usize] = ACTIONS(1396),
    [anon_sym_f32] = ACTIONS(1396),
    [anon_sym_f64] = ACTIONS(1396),
    [anon_sym_bool] = ACTIONS(1396),
    [anon_sym_str] = ACTIONS(1396),
    [anon_sym_char] = ACTIONS(1396),
    [anon_sym_DASH] = ACTIONS(1396),
    [anon_sym_SLASH] = ACTIONS(1396),
    [anon_sym_PERCENT] = ACTIONS(1396),
    [anon_sym_CARET] = ACTIONS(1396),
    [anon_sym_BANG] = ACTIONS(1396),
    [anon_sym_AMP] = ACTIONS(1396),
    [anon_sym_PIPE] = ACTIONS(1396),
    [anon_sym_AMP_AMP] = ACTIONS(1394),
    [anon_sym_PIPE_PIPE] = ACTIONS(1394),
    [anon_sym_LT_LT] = ACTIONS(1396),
    [anon_sym_GT_GT] = ACTIONS(1396),
    [anon_sym_PLUS_EQ] = ACTIONS(1394),
    [anon_sym_DASH_EQ] = ACTIONS(1394),
    [anon_sym_STAR_EQ] = ACTIONS(1394),
    [anon_sym_SLASH_EQ] = ACTIONS(1394),
    [anon_sym_PERCENT_EQ] = ACTIONS(1394),
    [anon_sym_CARET_EQ] = ACTIONS(1394),
    [anon_sym_AMP_EQ] = ACTIONS(1394),
    [anon_sym_PIPE_EQ] = ACTIONS(1394),
    [anon_sym_LT_LT_EQ] = ACTIONS(1394),
    [anon_sym_GT_GT_EQ] = ACTIONS(1394),
    [anon_sym_EQ] = ACTIONS(1396),
    [anon_sym_EQ_EQ] = ACTIONS(1394),
    [anon_sym_BANG_EQ] = ACTIONS(1394),
    [anon_sym_GT] = ACTIONS(1396),
    [anon_sym_LT] = ACTIONS(1396),
    [anon_sym_GT_EQ] = ACTIONS(1394),
    [anon_sym_LT_EQ] = ACTIONS(1394),
    [anon_sym_DOT] = ACTIONS(1396),
    [anon_sym_DOT_DOT] = ACTIONS(1396),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1394),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1394),
    [anon_sym_COLON_COLON] = ACTIONS(1394),
    [anon_sym_POUND] = ACTIONS(1394),
    [anon_sym_SQUOTE] = ACTIONS(1396),
    [anon_sym_as] = ACTIONS(1396),
    [anon_sym_async] = ACTIONS(1396),
    [anon_sym_break] = ACTIONS(1396),
    [anon_sym_const] = ACTIONS(1396),
    [anon_sym_continue] = ACTIONS(1396),
    [anon_sym_default] = ACTIONS(1396),
    [anon_sym_enum] = ACTIONS(1396),
    [anon_sym_fn] = ACTIONS(1396),
    [anon_sym_for] = ACTIONS(1396),
    [anon_sym_if] = ACTIONS(1396),
    [anon_sym_impl] = ACTIONS(1396),
    [anon_sym_let] = ACTIONS(1396),
    [anon_sym_loop] = ACTIONS(1396),
    [anon_sym_match] = ACTIONS(1396),
    [anon_sym_mod] = ACTIONS(1396),
    [anon_sym_pub] = ACTIONS(1396),
    [anon_sym_return] = ACTIONS(1396),
    [anon_sym_static] = ACTIONS(1396),
    [anon_sym_struct] = ACTIONS(1396),
    [anon_sym_trait] = ACTIONS(1396),
    [anon_sym_type] = ACTIONS(1396),
    [anon_sym_union] = ACTIONS(1396),
    [anon_sym_unsafe] = ACTIONS(1396),
    [anon_sym_use] = ACTIONS(1396),
    [anon_sym_while] = ACTIONS(1396),
    [anon_sym_extern] = ACTIONS(1396),
    [anon_sym_yield] = ACTIONS(1396),
    [anon_sym_move] = ACTIONS(1396),
    [anon_sym_try] = ACTIONS(1396),
    [sym_integer_literal] = ACTIONS(1394),
    [aux_sym_string_literal_token1] = ACTIONS(1394),
    [sym_char_literal] = ACTIONS(1394),
    [anon_sym_true] = ACTIONS(1396),
    [anon_sym_false] = ACTIONS(1396),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1396),
    [sym_super] = ACTIONS(1396),
    [sym_crate] = ACTIONS(1396),
    [sym_metavariable] = ACTIONS(1394),
    [sym__raw_string_literal_start] = ACTIONS(1394),
    [sym_float_literal] = ACTIONS(1394),
  },
  [386] = {
    [sym_line_comment] = STATE(386),
    [sym_block_comment] = STATE(386),
    [ts_builtin_sym_end] = ACTIONS(997),
    [sym_identifier] = ACTIONS(995),
    [anon_sym_SEMI] = ACTIONS(997),
    [anon_sym_macro_rules_BANG] = ACTIONS(997),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_LBRACK] = ACTIONS(997),
    [anon_sym_LBRACE] = ACTIONS(997),
    [anon_sym_RBRACE] = ACTIONS(997),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(995),
    [anon_sym_QMARK] = ACTIONS(997),
    [anon_sym_u8] = ACTIONS(995),
    [anon_sym_i8] = ACTIONS(995),
    [anon_sym_u16] = ACTIONS(995),
    [anon_sym_i16] = ACTIONS(995),
    [anon_sym_u32] = ACTIONS(995),
    [anon_sym_i32] = ACTIONS(995),
    [anon_sym_u64] = ACTIONS(995),
    [anon_sym_i64] = ACTIONS(995),
    [anon_sym_u128] = ACTIONS(995),
    [anon_sym_i128] = ACTIONS(995),
    [anon_sym_isize] = ACTIONS(995),
    [anon_sym_usize] = ACTIONS(995),
    [anon_sym_f32] = ACTIONS(995),
    [anon_sym_f64] = ACTIONS(995),
    [anon_sym_bool] = ACTIONS(995),
    [anon_sym_str] = ACTIONS(995),
    [anon_sym_char] = ACTIONS(995),
    [anon_sym_DASH] = ACTIONS(995),
    [anon_sym_SLASH] = ACTIONS(995),
    [anon_sym_PERCENT] = ACTIONS(995),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_BANG] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_AMP_AMP] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(997),
    [anon_sym_LT_LT] = ACTIONS(995),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_PLUS_EQ] = ACTIONS(997),
    [anon_sym_DASH_EQ] = ACTIONS(997),
    [anon_sym_STAR_EQ] = ACTIONS(997),
    [anon_sym_SLASH_EQ] = ACTIONS(997),
    [anon_sym_PERCENT_EQ] = ACTIONS(997),
    [anon_sym_CARET_EQ] = ACTIONS(997),
    [anon_sym_AMP_EQ] = ACTIONS(997),
    [anon_sym_PIPE_EQ] = ACTIONS(997),
    [anon_sym_LT_LT_EQ] = ACTIONS(997),
    [anon_sym_GT_GT_EQ] = ACTIONS(997),
    [anon_sym_EQ] = ACTIONS(995),
    [anon_sym_EQ_EQ] = ACTIONS(997),
    [anon_sym_BANG_EQ] = ACTIONS(997),
    [anon_sym_GT] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(997),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(997),
    [anon_sym_COLON_COLON] = ACTIONS(997),
    [anon_sym_POUND] = ACTIONS(997),
    [anon_sym_SQUOTE] = ACTIONS(995),
    [anon_sym_as] = ACTIONS(995),
    [anon_sym_async] = ACTIONS(995),
    [anon_sym_break] = ACTIONS(995),
    [anon_sym_const] = ACTIONS(995),
    [anon_sym_continue] = ACTIONS(995),
    [anon_sym_default] = ACTIONS(995),
    [anon_sym_enum] = ACTIONS(995),
    [anon_sym_fn] = ACTIONS(995),
    [anon_sym_for] = ACTIONS(995),
    [anon_sym_if] = ACTIONS(995),
    [anon_sym_impl] = ACTIONS(995),
    [anon_sym_let] = ACTIONS(995),
    [anon_sym_loop] = ACTIONS(995),
    [anon_sym_match] = ACTIONS(995),
    [anon_sym_mod] = ACTIONS(995),
    [anon_sym_pub] = ACTIONS(995),
    [anon_sym_return] = ACTIONS(995),
    [anon_sym_static] = ACTIONS(995),
    [anon_sym_struct] = ACTIONS(995),
    [anon_sym_trait] = ACTIONS(995),
    [anon_sym_type] = ACTIONS(995),
    [anon_sym_union] = ACTIONS(995),
    [anon_sym_unsafe] = ACTIONS(995),
    [anon_sym_use] = ACTIONS(995),
    [anon_sym_while] = ACTIONS(995),
    [anon_sym_extern] = ACTIONS(995),
    [anon_sym_yield] = ACTIONS(995),
    [anon_sym_move] = ACTIONS(995),
    [anon_sym_try] = ACTIONS(995),
    [sym_integer_literal] = ACTIONS(997),
    [aux_sym_string_literal_token1] = ACTIONS(997),
    [sym_char_literal] = ACTIONS(997),
    [anon_sym_true] = ACTIONS(995),
    [anon_sym_false] = ACTIONS(995),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(995),
    [sym_super] = ACTIONS(995),
    [sym_crate] = ACTIONS(995),
    [sym_metavariable] = ACTIONS(997),
    [sym__raw_string_literal_start] = ACTIONS(997),
    [sym_float_literal] = ACTIONS(997),
  },
  [387] = {
    [sym_line_comment] = STATE(387),
    [sym_block_comment] = STATE(387),
    [ts_builtin_sym_end] = ACTIONS(1398),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_SEMI] = ACTIONS(1398),
    [anon_sym_macro_rules_BANG] = ACTIONS(1398),
    [anon_sym_LPAREN] = ACTIONS(1398),
    [anon_sym_LBRACK] = ACTIONS(1398),
    [anon_sym_LBRACE] = ACTIONS(1398),
    [anon_sym_RBRACE] = ACTIONS(1398),
    [anon_sym_PLUS] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(1400),
    [anon_sym_QMARK] = ACTIONS(1398),
    [anon_sym_u8] = ACTIONS(1400),
    [anon_sym_i8] = ACTIONS(1400),
    [anon_sym_u16] = ACTIONS(1400),
    [anon_sym_i16] = ACTIONS(1400),
    [anon_sym_u32] = ACTIONS(1400),
    [anon_sym_i32] = ACTIONS(1400),
    [anon_sym_u64] = ACTIONS(1400),
    [anon_sym_i64] = ACTIONS(1400),
    [anon_sym_u128] = ACTIONS(1400),
    [anon_sym_i128] = ACTIONS(1400),
    [anon_sym_isize] = ACTIONS(1400),
    [anon_sym_usize] = ACTIONS(1400),
    [anon_sym_f32] = ACTIONS(1400),
    [anon_sym_f64] = ACTIONS(1400),
    [anon_sym_bool] = ACTIONS(1400),
    [anon_sym_str] = ACTIONS(1400),
    [anon_sym_char] = ACTIONS(1400),
    [anon_sym_DASH] = ACTIONS(1400),
    [anon_sym_SLASH] = ACTIONS(1400),
    [anon_sym_PERCENT] = ACTIONS(1400),
    [anon_sym_CARET] = ACTIONS(1400),
    [anon_sym_BANG] = ACTIONS(1400),
    [anon_sym_AMP] = ACTIONS(1400),
    [anon_sym_PIPE] = ACTIONS(1400),
    [anon_sym_AMP_AMP] = ACTIONS(1398),
    [anon_sym_PIPE_PIPE] = ACTIONS(1398),
    [anon_sym_LT_LT] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1400),
    [anon_sym_PLUS_EQ] = ACTIONS(1398),
    [anon_sym_DASH_EQ] = ACTIONS(1398),
    [anon_sym_STAR_EQ] = ACTIONS(1398),
    [anon_sym_SLASH_EQ] = ACTIONS(1398),
    [anon_sym_PERCENT_EQ] = ACTIONS(1398),
    [anon_sym_CARET_EQ] = ACTIONS(1398),
    [anon_sym_AMP_EQ] = ACTIONS(1398),
    [anon_sym_PIPE_EQ] = ACTIONS(1398),
    [anon_sym_LT_LT_EQ] = ACTIONS(1398),
    [anon_sym_GT_GT_EQ] = ACTIONS(1398),
    [anon_sym_EQ] = ACTIONS(1400),
    [anon_sym_EQ_EQ] = ACTIONS(1398),
    [anon_sym_BANG_EQ] = ACTIONS(1398),
    [anon_sym_GT] = ACTIONS(1400),
    [anon_sym_LT] = ACTIONS(1400),
    [anon_sym_GT_EQ] = ACTIONS(1398),
    [anon_sym_LT_EQ] = ACTIONS(1398),
    [anon_sym_DOT] = ACTIONS(1400),
    [anon_sym_DOT_DOT] = ACTIONS(1400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1398),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1398),
    [anon_sym_COLON_COLON] = ACTIONS(1398),
    [anon_sym_POUND] = ACTIONS(1398),
    [anon_sym_SQUOTE] = ACTIONS(1400),
    [anon_sym_as] = ACTIONS(1400),
    [anon_sym_async] = ACTIONS(1400),
    [anon_sym_break] = ACTIONS(1400),
    [anon_sym_const] = ACTIONS(1400),
    [anon_sym_continue] = ACTIONS(1400),
    [anon_sym_default] = ACTIONS(1400),
    [anon_sym_enum] = ACTIONS(1400),
    [anon_sym_fn] = ACTIONS(1400),
    [anon_sym_for] = ACTIONS(1400),
    [anon_sym_if] = ACTIONS(1400),
    [anon_sym_impl] = ACTIONS(1400),
    [anon_sym_let] = ACTIONS(1400),
    [anon_sym_loop] = ACTIONS(1400),
    [anon_sym_match] = ACTIONS(1400),
    [anon_sym_mod] = ACTIONS(1400),
    [anon_sym_pub] = ACTIONS(1400),
    [anon_sym_return] = ACTIONS(1400),
    [anon_sym_static] = ACTIONS(1400),
    [anon_sym_struct] = ACTIONS(1400),
    [anon_sym_trait] = ACTIONS(1400),
    [anon_sym_type] = ACTIONS(1400),
    [anon_sym_union] = ACTIONS(1400),
    [anon_sym_unsafe] = ACTIONS(1400),
    [anon_sym_use] = ACTIONS(1400),
    [anon_sym_while] = ACTIONS(1400),
    [anon_sym_extern] = ACTIONS(1400),
    [anon_sym_yield] = ACTIONS(1400),
    [anon_sym_move] = ACTIONS(1400),
    [anon_sym_try] = ACTIONS(1400),
    [sym_integer_literal] = ACTIONS(1398),
    [aux_sym_string_literal_token1] = ACTIONS(1398),
    [sym_char_literal] = ACTIONS(1398),
    [anon_sym_true] = ACTIONS(1400),
    [anon_sym_false] = ACTIONS(1400),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1400),
    [sym_super] = ACTIONS(1400),
    [sym_crate] = ACTIONS(1400),
    [sym_metavariable] = ACTIONS(1398),
    [sym__raw_string_literal_start] = ACTIONS(1398),
    [sym_float_literal] = ACTIONS(1398),
  },
  [388] = {
    [sym_line_comment] = STATE(388),
    [sym_block_comment] = STATE(388),
    [ts_builtin_sym_end] = ACTIONS(1402),
    [sym_identifier] = ACTIONS(1404),
    [anon_sym_SEMI] = ACTIONS(1402),
    [anon_sym_macro_rules_BANG] = ACTIONS(1402),
    [anon_sym_LPAREN] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1402),
    [anon_sym_LBRACE] = ACTIONS(1402),
    [anon_sym_RBRACE] = ACTIONS(1402),
    [anon_sym_PLUS] = ACTIONS(1404),
    [anon_sym_STAR] = ACTIONS(1404),
    [anon_sym_QMARK] = ACTIONS(1402),
    [anon_sym_u8] = ACTIONS(1404),
    [anon_sym_i8] = ACTIONS(1404),
    [anon_sym_u16] = ACTIONS(1404),
    [anon_sym_i16] = ACTIONS(1404),
    [anon_sym_u32] = ACTIONS(1404),
    [anon_sym_i32] = ACTIONS(1404),
    [anon_sym_u64] = ACTIONS(1404),
    [anon_sym_i64] = ACTIONS(1404),
    [anon_sym_u128] = ACTIONS(1404),
    [anon_sym_i128] = ACTIONS(1404),
    [anon_sym_isize] = ACTIONS(1404),
    [anon_sym_usize] = ACTIONS(1404),
    [anon_sym_f32] = ACTIONS(1404),
    [anon_sym_f64] = ACTIONS(1404),
    [anon_sym_bool] = ACTIONS(1404),
    [anon_sym_str] = ACTIONS(1404),
    [anon_sym_char] = ACTIONS(1404),
    [anon_sym_DASH] = ACTIONS(1404),
    [anon_sym_SLASH] = ACTIONS(1404),
    [anon_sym_PERCENT] = ACTIONS(1404),
    [anon_sym_CARET] = ACTIONS(1404),
    [anon_sym_BANG] = ACTIONS(1404),
    [anon_sym_AMP] = ACTIONS(1404),
    [anon_sym_PIPE] = ACTIONS(1404),
    [anon_sym_AMP_AMP] = ACTIONS(1402),
    [anon_sym_PIPE_PIPE] = ACTIONS(1402),
    [anon_sym_LT_LT] = ACTIONS(1404),
    [anon_sym_GT_GT] = ACTIONS(1404),
    [anon_sym_PLUS_EQ] = ACTIONS(1402),
    [anon_sym_DASH_EQ] = ACTIONS(1402),
    [anon_sym_STAR_EQ] = ACTIONS(1402),
    [anon_sym_SLASH_EQ] = ACTIONS(1402),
    [anon_sym_PERCENT_EQ] = ACTIONS(1402),
    [anon_sym_CARET_EQ] = ACTIONS(1402),
    [anon_sym_AMP_EQ] = ACTIONS(1402),
    [anon_sym_PIPE_EQ] = ACTIONS(1402),
    [anon_sym_LT_LT_EQ] = ACTIONS(1402),
    [anon_sym_GT_GT_EQ] = ACTIONS(1402),
    [anon_sym_EQ] = ACTIONS(1404),
    [anon_sym_EQ_EQ] = ACTIONS(1402),
    [anon_sym_BANG_EQ] = ACTIONS(1402),
    [anon_sym_GT] = ACTIONS(1404),
    [anon_sym_LT] = ACTIONS(1404),
    [anon_sym_GT_EQ] = ACTIONS(1402),
    [anon_sym_LT_EQ] = ACTIONS(1402),
    [anon_sym_DOT] = ACTIONS(1404),
    [anon_sym_DOT_DOT] = ACTIONS(1404),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1402),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1402),
    [anon_sym_COLON_COLON] = ACTIONS(1402),
    [anon_sym_POUND] = ACTIONS(1402),
    [anon_sym_SQUOTE] = ACTIONS(1404),
    [anon_sym_as] = ACTIONS(1404),
    [anon_sym_async] = ACTIONS(1404),
    [anon_sym_break] = ACTIONS(1404),
    [anon_sym_const] = ACTIONS(1404),
    [anon_sym_continue] = ACTIONS(1404),
    [anon_sym_default] = ACTIONS(1404),
    [anon_sym_enum] = ACTIONS(1404),
    [anon_sym_fn] = ACTIONS(1404),
    [anon_sym_for] = ACTIONS(1404),
    [anon_sym_if] = ACTIONS(1404),
    [anon_sym_impl] = ACTIONS(1404),
    [anon_sym_let] = ACTIONS(1404),
    [anon_sym_loop] = ACTIONS(1404),
    [anon_sym_match] = ACTIONS(1404),
    [anon_sym_mod] = ACTIONS(1404),
    [anon_sym_pub] = ACTIONS(1404),
    [anon_sym_return] = ACTIONS(1404),
    [anon_sym_static] = ACTIONS(1404),
    [anon_sym_struct] = ACTIONS(1404),
    [anon_sym_trait] = ACTIONS(1404),
    [anon_sym_type] = ACTIONS(1404),
    [anon_sym_union] = ACTIONS(1404),
    [anon_sym_unsafe] = ACTIONS(1404),
    [anon_sym_use] = ACTIONS(1404),
    [anon_sym_while] = ACTIONS(1404),
    [anon_sym_extern] = ACTIONS(1404),
    [anon_sym_yield] = ACTIONS(1404),
    [anon_sym_move] = ACTIONS(1404),
    [anon_sym_try] = ACTIONS(1404),
    [sym_integer_literal] = ACTIONS(1402),
    [aux_sym_string_literal_token1] = ACTIONS(1402),
    [sym_char_literal] = ACTIONS(1402),
    [anon_sym_true] = ACTIONS(1404),
    [anon_sym_false] = ACTIONS(1404),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1404),
    [sym_super] = ACTIONS(1404),
    [sym_crate] = ACTIONS(1404),
    [sym_metavariable] = ACTIONS(1402),
    [sym__raw_string_literal_start] = ACTIONS(1402),
    [sym_float_literal] = ACTIONS(1402),
  },
  [389] = {
    [sym_line_comment] = STATE(389),
    [sym_block_comment] = STATE(389),
    [ts_builtin_sym_end] = ACTIONS(1406),
    [sym_identifier] = ACTIONS(1408),
    [anon_sym_SEMI] = ACTIONS(1406),
    [anon_sym_macro_rules_BANG] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1406),
    [anon_sym_LBRACK] = ACTIONS(1406),
    [anon_sym_LBRACE] = ACTIONS(1406),
    [anon_sym_RBRACE] = ACTIONS(1406),
    [anon_sym_PLUS] = ACTIONS(1408),
    [anon_sym_STAR] = ACTIONS(1408),
    [anon_sym_QMARK] = ACTIONS(1406),
    [anon_sym_u8] = ACTIONS(1408),
    [anon_sym_i8] = ACTIONS(1408),
    [anon_sym_u16] = ACTIONS(1408),
    [anon_sym_i16] = ACTIONS(1408),
    [anon_sym_u32] = ACTIONS(1408),
    [anon_sym_i32] = ACTIONS(1408),
    [anon_sym_u64] = ACTIONS(1408),
    [anon_sym_i64] = ACTIONS(1408),
    [anon_sym_u128] = ACTIONS(1408),
    [anon_sym_i128] = ACTIONS(1408),
    [anon_sym_isize] = ACTIONS(1408),
    [anon_sym_usize] = ACTIONS(1408),
    [anon_sym_f32] = ACTIONS(1408),
    [anon_sym_f64] = ACTIONS(1408),
    [anon_sym_bool] = ACTIONS(1408),
    [anon_sym_str] = ACTIONS(1408),
    [anon_sym_char] = ACTIONS(1408),
    [anon_sym_DASH] = ACTIONS(1408),
    [anon_sym_SLASH] = ACTIONS(1408),
    [anon_sym_PERCENT] = ACTIONS(1408),
    [anon_sym_CARET] = ACTIONS(1408),
    [anon_sym_BANG] = ACTIONS(1408),
    [anon_sym_AMP] = ACTIONS(1408),
    [anon_sym_PIPE] = ACTIONS(1408),
    [anon_sym_AMP_AMP] = ACTIONS(1406),
    [anon_sym_PIPE_PIPE] = ACTIONS(1406),
    [anon_sym_LT_LT] = ACTIONS(1408),
    [anon_sym_GT_GT] = ACTIONS(1408),
    [anon_sym_PLUS_EQ] = ACTIONS(1406),
    [anon_sym_DASH_EQ] = ACTIONS(1406),
    [anon_sym_STAR_EQ] = ACTIONS(1406),
    [anon_sym_SLASH_EQ] = ACTIONS(1406),
    [anon_sym_PERCENT_EQ] = ACTIONS(1406),
    [anon_sym_CARET_EQ] = ACTIONS(1406),
    [anon_sym_AMP_EQ] = ACTIONS(1406),
    [anon_sym_PIPE_EQ] = ACTIONS(1406),
    [anon_sym_LT_LT_EQ] = ACTIONS(1406),
    [anon_sym_GT_GT_EQ] = ACTIONS(1406),
    [anon_sym_EQ] = ACTIONS(1408),
    [anon_sym_EQ_EQ] = ACTIONS(1406),
    [anon_sym_BANG_EQ] = ACTIONS(1406),
    [anon_sym_GT] = ACTIONS(1408),
    [anon_sym_LT] = ACTIONS(1408),
    [anon_sym_GT_EQ] = ACTIONS(1406),
    [anon_sym_LT_EQ] = ACTIONS(1406),
    [anon_sym_DOT] = ACTIONS(1408),
    [anon_sym_DOT_DOT] = ACTIONS(1408),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1406),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1406),
    [anon_sym_COLON_COLON] = ACTIONS(1406),
    [anon_sym_POUND] = ACTIONS(1406),
    [anon_sym_SQUOTE] = ACTIONS(1408),
    [anon_sym_as] = ACTIONS(1408),
    [anon_sym_async] = ACTIONS(1408),
    [anon_sym_break] = ACTIONS(1408),
    [anon_sym_const] = ACTIONS(1408),
    [anon_sym_continue] = ACTIONS(1408),
    [anon_sym_default] = ACTIONS(1408),
    [anon_sym_enum] = ACTIONS(1408),
    [anon_sym_fn] = ACTIONS(1408),
    [anon_sym_for] = ACTIONS(1408),
    [anon_sym_if] = ACTIONS(1408),
    [anon_sym_impl] = ACTIONS(1408),
    [anon_sym_let] = ACTIONS(1408),
    [anon_sym_loop] = ACTIONS(1408),
    [anon_sym_match] = ACTIONS(1408),
    [anon_sym_mod] = ACTIONS(1408),
    [anon_sym_pub] = ACTIONS(1408),
    [anon_sym_return] = ACTIONS(1408),
    [anon_sym_static] = ACTIONS(1408),
    [anon_sym_struct] = ACTIONS(1408),
    [anon_sym_trait] = ACTIONS(1408),
    [anon_sym_type] = ACTIONS(1408),
    [anon_sym_union] = ACTIONS(1408),
    [anon_sym_unsafe] = ACTIONS(1408),
    [anon_sym_use] = ACTIONS(1408),
    [anon_sym_while] = ACTIONS(1408),
    [anon_sym_extern] = ACTIONS(1408),
    [anon_sym_yield] = ACTIONS(1408),
    [anon_sym_move] = ACTIONS(1408),
    [anon_sym_try] = ACTIONS(1408),
    [sym_integer_literal] = ACTIONS(1406),
    [aux_sym_string_literal_token1] = ACTIONS(1406),
    [sym_char_literal] = ACTIONS(1406),
    [anon_sym_true] = ACTIONS(1408),
    [anon_sym_false] = ACTIONS(1408),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1408),
    [sym_super] = ACTIONS(1408),
    [sym_crate] = ACTIONS(1408),
    [sym_metavariable] = ACTIONS(1406),
    [sym__raw_string_literal_start] = ACTIONS(1406),
    [sym_float_literal] = ACTIONS(1406),
  },
  [390] = {
    [sym_attribute_item] = STATE(415),
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_self_parameter] = STATE(2778),
    [sym_variadic_parameter] = STATE(2778),
    [sym_parameter] = STATE(2778),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2711),
    [sym_bracketed_type] = STATE(3510),
    [sym_lifetime] = STATE(2946),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3294),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(2440),
    [sym_scoped_identifier] = STATE(2214),
    [sym_scoped_type_identifier] = STATE(2100),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(3137),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(390),
    [sym_block_comment] = STATE(390),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_LPAREN] = ACTIONS(1266),
    [anon_sym_RPAREN] = ACTIONS(1410),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1276),
    [anon_sym_i8] = ACTIONS(1276),
    [anon_sym_u16] = ACTIONS(1276),
    [anon_sym_i16] = ACTIONS(1276),
    [anon_sym_u32] = ACTIONS(1276),
    [anon_sym_i32] = ACTIONS(1276),
    [anon_sym_u64] = ACTIONS(1276),
    [anon_sym_i64] = ACTIONS(1276),
    [anon_sym_u128] = ACTIONS(1276),
    [anon_sym_i128] = ACTIONS(1276),
    [anon_sym_isize] = ACTIONS(1276),
    [anon_sym_usize] = ACTIONS(1276),
    [anon_sym_f32] = ACTIONS(1276),
    [anon_sym_f64] = ACTIONS(1276),
    [anon_sym_bool] = ACTIONS(1276),
    [anon_sym_str] = ACTIONS(1276),
    [anon_sym_char] = ACTIONS(1276),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1282),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1412),
    [anon_sym_DOT_DOT] = ACTIONS(1288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1290),
    [anon_sym_COMMA] = ACTIONS(1414),
    [anon_sym_COLON_COLON] = ACTIONS(1294),
    [anon_sym_POUND] = ACTIONS(1296),
    [anon_sym_SQUOTE] = ACTIONS(1298),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1302),
    [anon_sym_default] = ACTIONS(1304),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1312),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_ref] = ACTIONS(1316),
    [anon_sym_dyn] = ACTIONS(1318),
    [sym_mutable_specifier] = ACTIONS(1320),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1328),
    [sym_super] = ACTIONS(1330),
    [sym_crate] = ACTIONS(1330),
    [sym_metavariable] = ACTIONS(1332),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [391] = {
    [sym_line_comment] = STATE(391),
    [sym_block_comment] = STATE(391),
    [ts_builtin_sym_end] = ACTIONS(1416),
    [sym_identifier] = ACTIONS(1418),
    [anon_sym_SEMI] = ACTIONS(1416),
    [anon_sym_macro_rules_BANG] = ACTIONS(1416),
    [anon_sym_LPAREN] = ACTIONS(1416),
    [anon_sym_LBRACK] = ACTIONS(1416),
    [anon_sym_LBRACE] = ACTIONS(1416),
    [anon_sym_RBRACE] = ACTIONS(1416),
    [anon_sym_PLUS] = ACTIONS(1418),
    [anon_sym_STAR] = ACTIONS(1418),
    [anon_sym_QMARK] = ACTIONS(1416),
    [anon_sym_u8] = ACTIONS(1418),
    [anon_sym_i8] = ACTIONS(1418),
    [anon_sym_u16] = ACTIONS(1418),
    [anon_sym_i16] = ACTIONS(1418),
    [anon_sym_u32] = ACTIONS(1418),
    [anon_sym_i32] = ACTIONS(1418),
    [anon_sym_u64] = ACTIONS(1418),
    [anon_sym_i64] = ACTIONS(1418),
    [anon_sym_u128] = ACTIONS(1418),
    [anon_sym_i128] = ACTIONS(1418),
    [anon_sym_isize] = ACTIONS(1418),
    [anon_sym_usize] = ACTIONS(1418),
    [anon_sym_f32] = ACTIONS(1418),
    [anon_sym_f64] = ACTIONS(1418),
    [anon_sym_bool] = ACTIONS(1418),
    [anon_sym_str] = ACTIONS(1418),
    [anon_sym_char] = ACTIONS(1418),
    [anon_sym_DASH] = ACTIONS(1418),
    [anon_sym_SLASH] = ACTIONS(1418),
    [anon_sym_PERCENT] = ACTIONS(1418),
    [anon_sym_CARET] = ACTIONS(1418),
    [anon_sym_BANG] = ACTIONS(1418),
    [anon_sym_AMP] = ACTIONS(1418),
    [anon_sym_PIPE] = ACTIONS(1418),
    [anon_sym_AMP_AMP] = ACTIONS(1416),
    [anon_sym_PIPE_PIPE] = ACTIONS(1416),
    [anon_sym_LT_LT] = ACTIONS(1418),
    [anon_sym_GT_GT] = ACTIONS(1418),
    [anon_sym_PLUS_EQ] = ACTIONS(1416),
    [anon_sym_DASH_EQ] = ACTIONS(1416),
    [anon_sym_STAR_EQ] = ACTIONS(1416),
    [anon_sym_SLASH_EQ] = ACTIONS(1416),
    [anon_sym_PERCENT_EQ] = ACTIONS(1416),
    [anon_sym_CARET_EQ] = ACTIONS(1416),
    [anon_sym_AMP_EQ] = ACTIONS(1416),
    [anon_sym_PIPE_EQ] = ACTIONS(1416),
    [anon_sym_LT_LT_EQ] = ACTIONS(1416),
    [anon_sym_GT_GT_EQ] = ACTIONS(1416),
    [anon_sym_EQ] = ACTIONS(1418),
    [anon_sym_EQ_EQ] = ACTIONS(1416),
    [anon_sym_BANG_EQ] = ACTIONS(1416),
    [anon_sym_GT] = ACTIONS(1418),
    [anon_sym_LT] = ACTIONS(1418),
    [anon_sym_GT_EQ] = ACTIONS(1416),
    [anon_sym_LT_EQ] = ACTIONS(1416),
    [anon_sym_DOT] = ACTIONS(1418),
    [anon_sym_DOT_DOT] = ACTIONS(1418),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1416),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1416),
    [anon_sym_COLON_COLON] = ACTIONS(1416),
    [anon_sym_POUND] = ACTIONS(1416),
    [anon_sym_SQUOTE] = ACTIONS(1418),
    [anon_sym_as] = ACTIONS(1418),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_break] = ACTIONS(1418),
    [anon_sym_const] = ACTIONS(1418),
    [anon_sym_continue] = ACTIONS(1418),
    [anon_sym_default] = ACTIONS(1418),
    [anon_sym_enum] = ACTIONS(1418),
    [anon_sym_fn] = ACTIONS(1418),
    [anon_sym_for] = ACTIONS(1418),
    [anon_sym_if] = ACTIONS(1418),
    [anon_sym_impl] = ACTIONS(1418),
    [anon_sym_let] = ACTIONS(1418),
    [anon_sym_loop] = ACTIONS(1418),
    [anon_sym_match] = ACTIONS(1418),
    [anon_sym_mod] = ACTIONS(1418),
    [anon_sym_pub] = ACTIONS(1418),
    [anon_sym_return] = ACTIONS(1418),
    [anon_sym_static] = ACTIONS(1418),
    [anon_sym_struct] = ACTIONS(1418),
    [anon_sym_trait] = ACTIONS(1418),
    [anon_sym_type] = ACTIONS(1418),
    [anon_sym_union] = ACTIONS(1418),
    [anon_sym_unsafe] = ACTIONS(1418),
    [anon_sym_use] = ACTIONS(1418),
    [anon_sym_while] = ACTIONS(1418),
    [anon_sym_extern] = ACTIONS(1418),
    [anon_sym_yield] = ACTIONS(1418),
    [anon_sym_move] = ACTIONS(1418),
    [anon_sym_try] = ACTIONS(1418),
    [sym_integer_literal] = ACTIONS(1416),
    [aux_sym_string_literal_token1] = ACTIONS(1416),
    [sym_char_literal] = ACTIONS(1416),
    [anon_sym_true] = ACTIONS(1418),
    [anon_sym_false] = ACTIONS(1418),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1418),
    [sym_super] = ACTIONS(1418),
    [sym_crate] = ACTIONS(1418),
    [sym_metavariable] = ACTIONS(1416),
    [sym__raw_string_literal_start] = ACTIONS(1416),
    [sym_float_literal] = ACTIONS(1416),
  },
  [392] = {
    [sym_line_comment] = STATE(392),
    [sym_block_comment] = STATE(392),
    [ts_builtin_sym_end] = ACTIONS(1420),
    [sym_identifier] = ACTIONS(1422),
    [anon_sym_SEMI] = ACTIONS(1420),
    [anon_sym_macro_rules_BANG] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(1420),
    [anon_sym_LBRACK] = ACTIONS(1420),
    [anon_sym_LBRACE] = ACTIONS(1420),
    [anon_sym_RBRACE] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1422),
    [anon_sym_STAR] = ACTIONS(1422),
    [anon_sym_QMARK] = ACTIONS(1420),
    [anon_sym_u8] = ACTIONS(1422),
    [anon_sym_i8] = ACTIONS(1422),
    [anon_sym_u16] = ACTIONS(1422),
    [anon_sym_i16] = ACTIONS(1422),
    [anon_sym_u32] = ACTIONS(1422),
    [anon_sym_i32] = ACTIONS(1422),
    [anon_sym_u64] = ACTIONS(1422),
    [anon_sym_i64] = ACTIONS(1422),
    [anon_sym_u128] = ACTIONS(1422),
    [anon_sym_i128] = ACTIONS(1422),
    [anon_sym_isize] = ACTIONS(1422),
    [anon_sym_usize] = ACTIONS(1422),
    [anon_sym_f32] = ACTIONS(1422),
    [anon_sym_f64] = ACTIONS(1422),
    [anon_sym_bool] = ACTIONS(1422),
    [anon_sym_str] = ACTIONS(1422),
    [anon_sym_char] = ACTIONS(1422),
    [anon_sym_DASH] = ACTIONS(1422),
    [anon_sym_SLASH] = ACTIONS(1422),
    [anon_sym_PERCENT] = ACTIONS(1422),
    [anon_sym_CARET] = ACTIONS(1422),
    [anon_sym_BANG] = ACTIONS(1422),
    [anon_sym_AMP] = ACTIONS(1422),
    [anon_sym_PIPE] = ACTIONS(1422),
    [anon_sym_AMP_AMP] = ACTIONS(1420),
    [anon_sym_PIPE_PIPE] = ACTIONS(1420),
    [anon_sym_LT_LT] = ACTIONS(1422),
    [anon_sym_GT_GT] = ACTIONS(1422),
    [anon_sym_PLUS_EQ] = ACTIONS(1420),
    [anon_sym_DASH_EQ] = ACTIONS(1420),
    [anon_sym_STAR_EQ] = ACTIONS(1420),
    [anon_sym_SLASH_EQ] = ACTIONS(1420),
    [anon_sym_PERCENT_EQ] = ACTIONS(1420),
    [anon_sym_CARET_EQ] = ACTIONS(1420),
    [anon_sym_AMP_EQ] = ACTIONS(1420),
    [anon_sym_PIPE_EQ] = ACTIONS(1420),
    [anon_sym_LT_LT_EQ] = ACTIONS(1420),
    [anon_sym_GT_GT_EQ] = ACTIONS(1420),
    [anon_sym_EQ] = ACTIONS(1422),
    [anon_sym_EQ_EQ] = ACTIONS(1420),
    [anon_sym_BANG_EQ] = ACTIONS(1420),
    [anon_sym_GT] = ACTIONS(1422),
    [anon_sym_LT] = ACTIONS(1422),
    [anon_sym_GT_EQ] = ACTIONS(1420),
    [anon_sym_LT_EQ] = ACTIONS(1420),
    [anon_sym_DOT] = ACTIONS(1422),
    [anon_sym_DOT_DOT] = ACTIONS(1422),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1420),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1420),
    [anon_sym_COLON_COLON] = ACTIONS(1420),
    [anon_sym_POUND] = ACTIONS(1420),
    [anon_sym_SQUOTE] = ACTIONS(1422),
    [anon_sym_as] = ACTIONS(1422),
    [anon_sym_async] = ACTIONS(1422),
    [anon_sym_break] = ACTIONS(1422),
    [anon_sym_const] = ACTIONS(1422),
    [anon_sym_continue] = ACTIONS(1422),
    [anon_sym_default] = ACTIONS(1422),
    [anon_sym_enum] = ACTIONS(1422),
    [anon_sym_fn] = ACTIONS(1422),
    [anon_sym_for] = ACTIONS(1422),
    [anon_sym_if] = ACTIONS(1422),
    [anon_sym_impl] = ACTIONS(1422),
    [anon_sym_let] = ACTIONS(1422),
    [anon_sym_loop] = ACTIONS(1422),
    [anon_sym_match] = ACTIONS(1422),
    [anon_sym_mod] = ACTIONS(1422),
    [anon_sym_pub] = ACTIONS(1422),
    [anon_sym_return] = ACTIONS(1422),
    [anon_sym_static] = ACTIONS(1422),
    [anon_sym_struct] = ACTIONS(1422),
    [anon_sym_trait] = ACTIONS(1422),
    [anon_sym_type] = ACTIONS(1422),
    [anon_sym_union] = ACTIONS(1422),
    [anon_sym_unsafe] = ACTIONS(1422),
    [anon_sym_use] = ACTIONS(1422),
    [anon_sym_while] = ACTIONS(1422),
    [anon_sym_extern] = ACTIONS(1422),
    [anon_sym_yield] = ACTIONS(1422),
    [anon_sym_move] = ACTIONS(1422),
    [anon_sym_try] = ACTIONS(1422),
    [sym_integer_literal] = ACTIONS(1420),
    [aux_sym_string_literal_token1] = ACTIONS(1420),
    [sym_char_literal] = ACTIONS(1420),
    [anon_sym_true] = ACTIONS(1422),
    [anon_sym_false] = ACTIONS(1422),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1422),
    [sym_super] = ACTIONS(1422),
    [sym_crate] = ACTIONS(1422),
    [sym_metavariable] = ACTIONS(1420),
    [sym__raw_string_literal_start] = ACTIONS(1420),
    [sym_float_literal] = ACTIONS(1420),
  },
  [393] = {
    [sym_line_comment] = STATE(393),
    [sym_block_comment] = STATE(393),
    [ts_builtin_sym_end] = ACTIONS(1424),
    [sym_identifier] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(1424),
    [anon_sym_macro_rules_BANG] = ACTIONS(1424),
    [anon_sym_LPAREN] = ACTIONS(1424),
    [anon_sym_LBRACK] = ACTIONS(1424),
    [anon_sym_LBRACE] = ACTIONS(1424),
    [anon_sym_RBRACE] = ACTIONS(1424),
    [anon_sym_PLUS] = ACTIONS(1426),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_QMARK] = ACTIONS(1424),
    [anon_sym_u8] = ACTIONS(1426),
    [anon_sym_i8] = ACTIONS(1426),
    [anon_sym_u16] = ACTIONS(1426),
    [anon_sym_i16] = ACTIONS(1426),
    [anon_sym_u32] = ACTIONS(1426),
    [anon_sym_i32] = ACTIONS(1426),
    [anon_sym_u64] = ACTIONS(1426),
    [anon_sym_i64] = ACTIONS(1426),
    [anon_sym_u128] = ACTIONS(1426),
    [anon_sym_i128] = ACTIONS(1426),
    [anon_sym_isize] = ACTIONS(1426),
    [anon_sym_usize] = ACTIONS(1426),
    [anon_sym_f32] = ACTIONS(1426),
    [anon_sym_f64] = ACTIONS(1426),
    [anon_sym_bool] = ACTIONS(1426),
    [anon_sym_str] = ACTIONS(1426),
    [anon_sym_char] = ACTIONS(1426),
    [anon_sym_DASH] = ACTIONS(1426),
    [anon_sym_SLASH] = ACTIONS(1426),
    [anon_sym_PERCENT] = ACTIONS(1426),
    [anon_sym_CARET] = ACTIONS(1426),
    [anon_sym_BANG] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_PIPE] = ACTIONS(1426),
    [anon_sym_AMP_AMP] = ACTIONS(1424),
    [anon_sym_PIPE_PIPE] = ACTIONS(1424),
    [anon_sym_LT_LT] = ACTIONS(1426),
    [anon_sym_GT_GT] = ACTIONS(1426),
    [anon_sym_PLUS_EQ] = ACTIONS(1424),
    [anon_sym_DASH_EQ] = ACTIONS(1424),
    [anon_sym_STAR_EQ] = ACTIONS(1424),
    [anon_sym_SLASH_EQ] = ACTIONS(1424),
    [anon_sym_PERCENT_EQ] = ACTIONS(1424),
    [anon_sym_CARET_EQ] = ACTIONS(1424),
    [anon_sym_AMP_EQ] = ACTIONS(1424),
    [anon_sym_PIPE_EQ] = ACTIONS(1424),
    [anon_sym_LT_LT_EQ] = ACTIONS(1424),
    [anon_sym_GT_GT_EQ] = ACTIONS(1424),
    [anon_sym_EQ] = ACTIONS(1426),
    [anon_sym_EQ_EQ] = ACTIONS(1424),
    [anon_sym_BANG_EQ] = ACTIONS(1424),
    [anon_sym_GT] = ACTIONS(1426),
    [anon_sym_LT] = ACTIONS(1426),
    [anon_sym_GT_EQ] = ACTIONS(1424),
    [anon_sym_LT_EQ] = ACTIONS(1424),
    [anon_sym_DOT] = ACTIONS(1426),
    [anon_sym_DOT_DOT] = ACTIONS(1426),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1424),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1424),
    [anon_sym_COLON_COLON] = ACTIONS(1424),
    [anon_sym_POUND] = ACTIONS(1424),
    [anon_sym_SQUOTE] = ACTIONS(1426),
    [anon_sym_as] = ACTIONS(1426),
    [anon_sym_async] = ACTIONS(1426),
    [anon_sym_break] = ACTIONS(1426),
    [anon_sym_const] = ACTIONS(1426),
    [anon_sym_continue] = ACTIONS(1426),
    [anon_sym_default] = ACTIONS(1426),
    [anon_sym_enum] = ACTIONS(1426),
    [anon_sym_fn] = ACTIONS(1426),
    [anon_sym_for] = ACTIONS(1426),
    [anon_sym_if] = ACTIONS(1426),
    [anon_sym_impl] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(1426),
    [anon_sym_loop] = ACTIONS(1426),
    [anon_sym_match] = ACTIONS(1426),
    [anon_sym_mod] = ACTIONS(1426),
    [anon_sym_pub] = ACTIONS(1426),
    [anon_sym_return] = ACTIONS(1426),
    [anon_sym_static] = ACTIONS(1426),
    [anon_sym_struct] = ACTIONS(1426),
    [anon_sym_trait] = ACTIONS(1426),
    [anon_sym_type] = ACTIONS(1426),
    [anon_sym_union] = ACTIONS(1426),
    [anon_sym_unsafe] = ACTIONS(1426),
    [anon_sym_use] = ACTIONS(1426),
    [anon_sym_while] = ACTIONS(1426),
    [anon_sym_extern] = ACTIONS(1426),
    [anon_sym_yield] = ACTIONS(1426),
    [anon_sym_move] = ACTIONS(1426),
    [anon_sym_try] = ACTIONS(1426),
    [sym_integer_literal] = ACTIONS(1424),
    [aux_sym_string_literal_token1] = ACTIONS(1424),
    [sym_char_literal] = ACTIONS(1424),
    [anon_sym_true] = ACTIONS(1426),
    [anon_sym_false] = ACTIONS(1426),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1426),
    [sym_super] = ACTIONS(1426),
    [sym_crate] = ACTIONS(1426),
    [sym_metavariable] = ACTIONS(1424),
    [sym__raw_string_literal_start] = ACTIONS(1424),
    [sym_float_literal] = ACTIONS(1424),
  },
  [394] = {
    [sym_attribute_item] = STATE(417),
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_self_parameter] = STATE(2954),
    [sym_variadic_parameter] = STATE(2954),
    [sym_parameter] = STATE(2954),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2619),
    [sym_bracketed_type] = STATE(3510),
    [sym_lifetime] = STATE(2946),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3294),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(2440),
    [sym_scoped_identifier] = STATE(2214),
    [sym_scoped_type_identifier] = STATE(2100),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(3137),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(394),
    [sym_block_comment] = STATE(394),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_LPAREN] = ACTIONS(1266),
    [anon_sym_RPAREN] = ACTIONS(1428),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1276),
    [anon_sym_i8] = ACTIONS(1276),
    [anon_sym_u16] = ACTIONS(1276),
    [anon_sym_i16] = ACTIONS(1276),
    [anon_sym_u32] = ACTIONS(1276),
    [anon_sym_i32] = ACTIONS(1276),
    [anon_sym_u64] = ACTIONS(1276),
    [anon_sym_i64] = ACTIONS(1276),
    [anon_sym_u128] = ACTIONS(1276),
    [anon_sym_i128] = ACTIONS(1276),
    [anon_sym_isize] = ACTIONS(1276),
    [anon_sym_usize] = ACTIONS(1276),
    [anon_sym_f32] = ACTIONS(1276),
    [anon_sym_f64] = ACTIONS(1276),
    [anon_sym_bool] = ACTIONS(1276),
    [anon_sym_str] = ACTIONS(1276),
    [anon_sym_char] = ACTIONS(1276),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1282),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1430),
    [anon_sym_DOT_DOT] = ACTIONS(1288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1290),
    [anon_sym_COMMA] = ACTIONS(1432),
    [anon_sym_COLON_COLON] = ACTIONS(1294),
    [anon_sym_POUND] = ACTIONS(1296),
    [anon_sym_SQUOTE] = ACTIONS(1298),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1302),
    [anon_sym_default] = ACTIONS(1304),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1312),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_ref] = ACTIONS(1316),
    [anon_sym_dyn] = ACTIONS(1318),
    [sym_mutable_specifier] = ACTIONS(1320),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1328),
    [sym_super] = ACTIONS(1330),
    [sym_crate] = ACTIONS(1330),
    [sym_metavariable] = ACTIONS(1332),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [395] = {
    [sym_attribute_item] = STATE(416),
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_self_parameter] = STATE(2955),
    [sym_variadic_parameter] = STATE(2955),
    [sym_parameter] = STATE(2955),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2621),
    [sym_bracketed_type] = STATE(3517),
    [sym_lifetime] = STATE(2946),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3091),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(2447),
    [sym_scoped_identifier] = STATE(2101),
    [sym_scoped_type_identifier] = STATE(2100),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2455),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(395),
    [sym_block_comment] = STATE(395),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(1356),
    [anon_sym_LPAREN] = ACTIONS(1358),
    [anon_sym_RPAREN] = ACTIONS(1434),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1362),
    [anon_sym_i8] = ACTIONS(1362),
    [anon_sym_u16] = ACTIONS(1362),
    [anon_sym_i16] = ACTIONS(1362),
    [anon_sym_u32] = ACTIONS(1362),
    [anon_sym_i32] = ACTIONS(1362),
    [anon_sym_u64] = ACTIONS(1362),
    [anon_sym_i64] = ACTIONS(1362),
    [anon_sym_u128] = ACTIONS(1362),
    [anon_sym_i128] = ACTIONS(1362),
    [anon_sym_isize] = ACTIONS(1362),
    [anon_sym_usize] = ACTIONS(1362),
    [anon_sym_f32] = ACTIONS(1362),
    [anon_sym_f64] = ACTIONS(1362),
    [anon_sym_bool] = ACTIONS(1362),
    [anon_sym_str] = ACTIONS(1362),
    [anon_sym_char] = ACTIONS(1362),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1364),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1366),
    [anon_sym_DOT_DOT] = ACTIONS(1288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1290),
    [anon_sym_COMMA] = ACTIONS(1436),
    [anon_sym_COLON_COLON] = ACTIONS(1370),
    [anon_sym_POUND] = ACTIONS(1296),
    [anon_sym_SQUOTE] = ACTIONS(1298),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1302),
    [anon_sym_default] = ACTIONS(1372),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1374),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_ref] = ACTIONS(1316),
    [anon_sym_dyn] = ACTIONS(1318),
    [sym_mutable_specifier] = ACTIONS(1320),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1376),
    [sym_super] = ACTIONS(1378),
    [sym_crate] = ACTIONS(1378),
    [sym_metavariable] = ACTIONS(1380),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [396] = {
    [sym_line_comment] = STATE(396),
    [sym_block_comment] = STATE(396),
    [ts_builtin_sym_end] = ACTIONS(1438),
    [sym_identifier] = ACTIONS(1440),
    [anon_sym_SEMI] = ACTIONS(1438),
    [anon_sym_macro_rules_BANG] = ACTIONS(1438),
    [anon_sym_LPAREN] = ACTIONS(1438),
    [anon_sym_LBRACK] = ACTIONS(1438),
    [anon_sym_LBRACE] = ACTIONS(1438),
    [anon_sym_RBRACE] = ACTIONS(1438),
    [anon_sym_PLUS] = ACTIONS(1440),
    [anon_sym_STAR] = ACTIONS(1440),
    [anon_sym_QMARK] = ACTIONS(1438),
    [anon_sym_u8] = ACTIONS(1440),
    [anon_sym_i8] = ACTIONS(1440),
    [anon_sym_u16] = ACTIONS(1440),
    [anon_sym_i16] = ACTIONS(1440),
    [anon_sym_u32] = ACTIONS(1440),
    [anon_sym_i32] = ACTIONS(1440),
    [anon_sym_u64] = ACTIONS(1440),
    [anon_sym_i64] = ACTIONS(1440),
    [anon_sym_u128] = ACTIONS(1440),
    [anon_sym_i128] = ACTIONS(1440),
    [anon_sym_isize] = ACTIONS(1440),
    [anon_sym_usize] = ACTIONS(1440),
    [anon_sym_f32] = ACTIONS(1440),
    [anon_sym_f64] = ACTIONS(1440),
    [anon_sym_bool] = ACTIONS(1440),
    [anon_sym_str] = ACTIONS(1440),
    [anon_sym_char] = ACTIONS(1440),
    [anon_sym_DASH] = ACTIONS(1440),
    [anon_sym_SLASH] = ACTIONS(1440),
    [anon_sym_PERCENT] = ACTIONS(1440),
    [anon_sym_CARET] = ACTIONS(1440),
    [anon_sym_BANG] = ACTIONS(1440),
    [anon_sym_AMP] = ACTIONS(1440),
    [anon_sym_PIPE] = ACTIONS(1440),
    [anon_sym_AMP_AMP] = ACTIONS(1438),
    [anon_sym_PIPE_PIPE] = ACTIONS(1438),
    [anon_sym_LT_LT] = ACTIONS(1440),
    [anon_sym_GT_GT] = ACTIONS(1440),
    [anon_sym_PLUS_EQ] = ACTIONS(1438),
    [anon_sym_DASH_EQ] = ACTIONS(1438),
    [anon_sym_STAR_EQ] = ACTIONS(1438),
    [anon_sym_SLASH_EQ] = ACTIONS(1438),
    [anon_sym_PERCENT_EQ] = ACTIONS(1438),
    [anon_sym_CARET_EQ] = ACTIONS(1438),
    [anon_sym_AMP_EQ] = ACTIONS(1438),
    [anon_sym_PIPE_EQ] = ACTIONS(1438),
    [anon_sym_LT_LT_EQ] = ACTIONS(1438),
    [anon_sym_GT_GT_EQ] = ACTIONS(1438),
    [anon_sym_EQ] = ACTIONS(1440),
    [anon_sym_EQ_EQ] = ACTIONS(1438),
    [anon_sym_BANG_EQ] = ACTIONS(1438),
    [anon_sym_GT] = ACTIONS(1440),
    [anon_sym_LT] = ACTIONS(1440),
    [anon_sym_GT_EQ] = ACTIONS(1438),
    [anon_sym_LT_EQ] = ACTIONS(1438),
    [anon_sym_DOT] = ACTIONS(1440),
    [anon_sym_DOT_DOT] = ACTIONS(1440),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1438),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1438),
    [anon_sym_COLON_COLON] = ACTIONS(1438),
    [anon_sym_POUND] = ACTIONS(1438),
    [anon_sym_SQUOTE] = ACTIONS(1440),
    [anon_sym_as] = ACTIONS(1440),
    [anon_sym_async] = ACTIONS(1440),
    [anon_sym_break] = ACTIONS(1440),
    [anon_sym_const] = ACTIONS(1440),
    [anon_sym_continue] = ACTIONS(1440),
    [anon_sym_default] = ACTIONS(1440),
    [anon_sym_enum] = ACTIONS(1440),
    [anon_sym_fn] = ACTIONS(1440),
    [anon_sym_for] = ACTIONS(1440),
    [anon_sym_if] = ACTIONS(1440),
    [anon_sym_impl] = ACTIONS(1440),
    [anon_sym_let] = ACTIONS(1440),
    [anon_sym_loop] = ACTIONS(1440),
    [anon_sym_match] = ACTIONS(1440),
    [anon_sym_mod] = ACTIONS(1440),
    [anon_sym_pub] = ACTIONS(1440),
    [anon_sym_return] = ACTIONS(1440),
    [anon_sym_static] = ACTIONS(1440),
    [anon_sym_struct] = ACTIONS(1440),
    [anon_sym_trait] = ACTIONS(1440),
    [anon_sym_type] = ACTIONS(1440),
    [anon_sym_union] = ACTIONS(1440),
    [anon_sym_unsafe] = ACTIONS(1440),
    [anon_sym_use] = ACTIONS(1440),
    [anon_sym_while] = ACTIONS(1440),
    [anon_sym_extern] = ACTIONS(1440),
    [anon_sym_yield] = ACTIONS(1440),
    [anon_sym_move] = ACTIONS(1440),
    [anon_sym_try] = ACTIONS(1440),
    [sym_integer_literal] = ACTIONS(1438),
    [aux_sym_string_literal_token1] = ACTIONS(1438),
    [sym_char_literal] = ACTIONS(1438),
    [anon_sym_true] = ACTIONS(1440),
    [anon_sym_false] = ACTIONS(1440),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1440),
    [sym_super] = ACTIONS(1440),
    [sym_crate] = ACTIONS(1440),
    [sym_metavariable] = ACTIONS(1438),
    [sym__raw_string_literal_start] = ACTIONS(1438),
    [sym_float_literal] = ACTIONS(1438),
  },
  [397] = {
    [sym_line_comment] = STATE(397),
    [sym_block_comment] = STATE(397),
    [ts_builtin_sym_end] = ACTIONS(1442),
    [sym_identifier] = ACTIONS(1444),
    [anon_sym_SEMI] = ACTIONS(1346),
    [anon_sym_macro_rules_BANG] = ACTIONS(1442),
    [anon_sym_LPAREN] = ACTIONS(1346),
    [anon_sym_LBRACK] = ACTIONS(1346),
    [anon_sym_LBRACE] = ACTIONS(1442),
    [anon_sym_RBRACE] = ACTIONS(1346),
    [anon_sym_PLUS] = ACTIONS(1344),
    [anon_sym_STAR] = ACTIONS(1344),
    [anon_sym_QMARK] = ACTIONS(1346),
    [anon_sym_u8] = ACTIONS(1444),
    [anon_sym_i8] = ACTIONS(1444),
    [anon_sym_u16] = ACTIONS(1444),
    [anon_sym_i16] = ACTIONS(1444),
    [anon_sym_u32] = ACTIONS(1444),
    [anon_sym_i32] = ACTIONS(1444),
    [anon_sym_u64] = ACTIONS(1444),
    [anon_sym_i64] = ACTIONS(1444),
    [anon_sym_u128] = ACTIONS(1444),
    [anon_sym_i128] = ACTIONS(1444),
    [anon_sym_isize] = ACTIONS(1444),
    [anon_sym_usize] = ACTIONS(1444),
    [anon_sym_f32] = ACTIONS(1444),
    [anon_sym_f64] = ACTIONS(1444),
    [anon_sym_bool] = ACTIONS(1444),
    [anon_sym_str] = ACTIONS(1444),
    [anon_sym_char] = ACTIONS(1444),
    [anon_sym_DASH] = ACTIONS(1344),
    [anon_sym_SLASH] = ACTIONS(1344),
    [anon_sym_PERCENT] = ACTIONS(1344),
    [anon_sym_CARET] = ACTIONS(1344),
    [anon_sym_BANG] = ACTIONS(1444),
    [anon_sym_AMP] = ACTIONS(1344),
    [anon_sym_PIPE] = ACTIONS(1344),
    [anon_sym_AMP_AMP] = ACTIONS(1346),
    [anon_sym_PIPE_PIPE] = ACTIONS(1346),
    [anon_sym_LT_LT] = ACTIONS(1344),
    [anon_sym_GT_GT] = ACTIONS(1344),
    [anon_sym_PLUS_EQ] = ACTIONS(1346),
    [anon_sym_DASH_EQ] = ACTIONS(1346),
    [anon_sym_STAR_EQ] = ACTIONS(1346),
    [anon_sym_SLASH_EQ] = ACTIONS(1346),
    [anon_sym_PERCENT_EQ] = ACTIONS(1346),
    [anon_sym_CARET_EQ] = ACTIONS(1346),
    [anon_sym_AMP_EQ] = ACTIONS(1346),
    [anon_sym_PIPE_EQ] = ACTIONS(1346),
    [anon_sym_LT_LT_EQ] = ACTIONS(1346),
    [anon_sym_GT_GT_EQ] = ACTIONS(1346),
    [anon_sym_EQ] = ACTIONS(1344),
    [anon_sym_EQ_EQ] = ACTIONS(1346),
    [anon_sym_BANG_EQ] = ACTIONS(1346),
    [anon_sym_GT] = ACTIONS(1344),
    [anon_sym_LT] = ACTIONS(1344),
    [anon_sym_GT_EQ] = ACTIONS(1346),
    [anon_sym_LT_EQ] = ACTIONS(1346),
    [anon_sym_DOT] = ACTIONS(1344),
    [anon_sym_DOT_DOT] = ACTIONS(1344),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1346),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1346),
    [anon_sym_COLON_COLON] = ACTIONS(1442),
    [anon_sym_POUND] = ACTIONS(1442),
    [anon_sym_SQUOTE] = ACTIONS(1444),
    [anon_sym_as] = ACTIONS(1344),
    [anon_sym_async] = ACTIONS(1444),
    [anon_sym_break] = ACTIONS(1444),
    [anon_sym_const] = ACTIONS(1444),
    [anon_sym_continue] = ACTIONS(1444),
    [anon_sym_default] = ACTIONS(1444),
    [anon_sym_enum] = ACTIONS(1444),
    [anon_sym_fn] = ACTIONS(1444),
    [anon_sym_for] = ACTIONS(1444),
    [anon_sym_if] = ACTIONS(1444),
    [anon_sym_impl] = ACTIONS(1444),
    [anon_sym_let] = ACTIONS(1444),
    [anon_sym_loop] = ACTIONS(1444),
    [anon_sym_match] = ACTIONS(1444),
    [anon_sym_mod] = ACTIONS(1444),
    [anon_sym_pub] = ACTIONS(1444),
    [anon_sym_return] = ACTIONS(1444),
    [anon_sym_static] = ACTIONS(1444),
    [anon_sym_struct] = ACTIONS(1444),
    [anon_sym_trait] = ACTIONS(1444),
    [anon_sym_type] = ACTIONS(1444),
    [anon_sym_union] = ACTIONS(1444),
    [anon_sym_unsafe] = ACTIONS(1444),
    [anon_sym_use] = ACTIONS(1444),
    [anon_sym_while] = ACTIONS(1444),
    [anon_sym_extern] = ACTIONS(1444),
    [anon_sym_yield] = ACTIONS(1444),
    [anon_sym_move] = ACTIONS(1444),
    [anon_sym_try] = ACTIONS(1444),
    [sym_integer_literal] = ACTIONS(1442),
    [aux_sym_string_literal_token1] = ACTIONS(1442),
    [sym_char_literal] = ACTIONS(1442),
    [anon_sym_true] = ACTIONS(1444),
    [anon_sym_false] = ACTIONS(1444),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1444),
    [sym_super] = ACTIONS(1444),
    [sym_crate] = ACTIONS(1444),
    [sym_metavariable] = ACTIONS(1442),
    [sym__raw_string_literal_start] = ACTIONS(1442),
    [sym_float_literal] = ACTIONS(1442),
  },
  [398] = {
    [sym_line_comment] = STATE(398),
    [sym_block_comment] = STATE(398),
    [ts_builtin_sym_end] = ACTIONS(1446),
    [sym_identifier] = ACTIONS(1448),
    [anon_sym_SEMI] = ACTIONS(1446),
    [anon_sym_macro_rules_BANG] = ACTIONS(1446),
    [anon_sym_LPAREN] = ACTIONS(1446),
    [anon_sym_LBRACK] = ACTIONS(1446),
    [anon_sym_LBRACE] = ACTIONS(1446),
    [anon_sym_RBRACE] = ACTIONS(1446),
    [anon_sym_PLUS] = ACTIONS(1448),
    [anon_sym_STAR] = ACTIONS(1448),
    [anon_sym_QMARK] = ACTIONS(1446),
    [anon_sym_u8] = ACTIONS(1448),
    [anon_sym_i8] = ACTIONS(1448),
    [anon_sym_u16] = ACTIONS(1448),
    [anon_sym_i16] = ACTIONS(1448),
    [anon_sym_u32] = ACTIONS(1448),
    [anon_sym_i32] = ACTIONS(1448),
    [anon_sym_u64] = ACTIONS(1448),
    [anon_sym_i64] = ACTIONS(1448),
    [anon_sym_u128] = ACTIONS(1448),
    [anon_sym_i128] = ACTIONS(1448),
    [anon_sym_isize] = ACTIONS(1448),
    [anon_sym_usize] = ACTIONS(1448),
    [anon_sym_f32] = ACTIONS(1448),
    [anon_sym_f64] = ACTIONS(1448),
    [anon_sym_bool] = ACTIONS(1448),
    [anon_sym_str] = ACTIONS(1448),
    [anon_sym_char] = ACTIONS(1448),
    [anon_sym_DASH] = ACTIONS(1448),
    [anon_sym_SLASH] = ACTIONS(1448),
    [anon_sym_PERCENT] = ACTIONS(1448),
    [anon_sym_CARET] = ACTIONS(1448),
    [anon_sym_BANG] = ACTIONS(1448),
    [anon_sym_AMP] = ACTIONS(1448),
    [anon_sym_PIPE] = ACTIONS(1448),
    [anon_sym_AMP_AMP] = ACTIONS(1446),
    [anon_sym_PIPE_PIPE] = ACTIONS(1446),
    [anon_sym_LT_LT] = ACTIONS(1448),
    [anon_sym_GT_GT] = ACTIONS(1448),
    [anon_sym_PLUS_EQ] = ACTIONS(1446),
    [anon_sym_DASH_EQ] = ACTIONS(1446),
    [anon_sym_STAR_EQ] = ACTIONS(1446),
    [anon_sym_SLASH_EQ] = ACTIONS(1446),
    [anon_sym_PERCENT_EQ] = ACTIONS(1446),
    [anon_sym_CARET_EQ] = ACTIONS(1446),
    [anon_sym_AMP_EQ] = ACTIONS(1446),
    [anon_sym_PIPE_EQ] = ACTIONS(1446),
    [anon_sym_LT_LT_EQ] = ACTIONS(1446),
    [anon_sym_GT_GT_EQ] = ACTIONS(1446),
    [anon_sym_EQ] = ACTIONS(1448),
    [anon_sym_EQ_EQ] = ACTIONS(1446),
    [anon_sym_BANG_EQ] = ACTIONS(1446),
    [anon_sym_GT] = ACTIONS(1448),
    [anon_sym_LT] = ACTIONS(1448),
    [anon_sym_GT_EQ] = ACTIONS(1446),
    [anon_sym_LT_EQ] = ACTIONS(1446),
    [anon_sym_DOT] = ACTIONS(1448),
    [anon_sym_DOT_DOT] = ACTIONS(1448),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1446),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1446),
    [anon_sym_COLON_COLON] = ACTIONS(1446),
    [anon_sym_POUND] = ACTIONS(1446),
    [anon_sym_SQUOTE] = ACTIONS(1448),
    [anon_sym_as] = ACTIONS(1448),
    [anon_sym_async] = ACTIONS(1448),
    [anon_sym_break] = ACTIONS(1448),
    [anon_sym_const] = ACTIONS(1448),
    [anon_sym_continue] = ACTIONS(1448),
    [anon_sym_default] = ACTIONS(1448),
    [anon_sym_enum] = ACTIONS(1448),
    [anon_sym_fn] = ACTIONS(1448),
    [anon_sym_for] = ACTIONS(1448),
    [anon_sym_if] = ACTIONS(1448),
    [anon_sym_impl] = ACTIONS(1448),
    [anon_sym_let] = ACTIONS(1448),
    [anon_sym_loop] = ACTIONS(1448),
    [anon_sym_match] = ACTIONS(1448),
    [anon_sym_mod] = ACTIONS(1448),
    [anon_sym_pub] = ACTIONS(1448),
    [anon_sym_return] = ACTIONS(1448),
    [anon_sym_static] = ACTIONS(1448),
    [anon_sym_struct] = ACTIONS(1448),
    [anon_sym_trait] = ACTIONS(1448),
    [anon_sym_type] = ACTIONS(1448),
    [anon_sym_union] = ACTIONS(1448),
    [anon_sym_unsafe] = ACTIONS(1448),
    [anon_sym_use] = ACTIONS(1448),
    [anon_sym_while] = ACTIONS(1448),
    [anon_sym_extern] = ACTIONS(1448),
    [anon_sym_yield] = ACTIONS(1448),
    [anon_sym_move] = ACTIONS(1448),
    [anon_sym_try] = ACTIONS(1448),
    [sym_integer_literal] = ACTIONS(1446),
    [aux_sym_string_literal_token1] = ACTIONS(1446),
    [sym_char_literal] = ACTIONS(1446),
    [anon_sym_true] = ACTIONS(1448),
    [anon_sym_false] = ACTIONS(1448),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1448),
    [sym_super] = ACTIONS(1448),
    [sym_crate] = ACTIONS(1448),
    [sym_metavariable] = ACTIONS(1446),
    [sym__raw_string_literal_start] = ACTIONS(1446),
    [sym_float_literal] = ACTIONS(1446),
  },
  [399] = {
    [sym_line_comment] = STATE(399),
    [sym_block_comment] = STATE(399),
    [ts_builtin_sym_end] = ACTIONS(1450),
    [sym_identifier] = ACTIONS(1452),
    [anon_sym_SEMI] = ACTIONS(1450),
    [anon_sym_macro_rules_BANG] = ACTIONS(1450),
    [anon_sym_LPAREN] = ACTIONS(1450),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_LBRACE] = ACTIONS(1450),
    [anon_sym_RBRACE] = ACTIONS(1450),
    [anon_sym_PLUS] = ACTIONS(1452),
    [anon_sym_STAR] = ACTIONS(1452),
    [anon_sym_QMARK] = ACTIONS(1450),
    [anon_sym_u8] = ACTIONS(1452),
    [anon_sym_i8] = ACTIONS(1452),
    [anon_sym_u16] = ACTIONS(1452),
    [anon_sym_i16] = ACTIONS(1452),
    [anon_sym_u32] = ACTIONS(1452),
    [anon_sym_i32] = ACTIONS(1452),
    [anon_sym_u64] = ACTIONS(1452),
    [anon_sym_i64] = ACTIONS(1452),
    [anon_sym_u128] = ACTIONS(1452),
    [anon_sym_i128] = ACTIONS(1452),
    [anon_sym_isize] = ACTIONS(1452),
    [anon_sym_usize] = ACTIONS(1452),
    [anon_sym_f32] = ACTIONS(1452),
    [anon_sym_f64] = ACTIONS(1452),
    [anon_sym_bool] = ACTIONS(1452),
    [anon_sym_str] = ACTIONS(1452),
    [anon_sym_char] = ACTIONS(1452),
    [anon_sym_DASH] = ACTIONS(1452),
    [anon_sym_SLASH] = ACTIONS(1452),
    [anon_sym_PERCENT] = ACTIONS(1452),
    [anon_sym_CARET] = ACTIONS(1452),
    [anon_sym_BANG] = ACTIONS(1452),
    [anon_sym_AMP] = ACTIONS(1452),
    [anon_sym_PIPE] = ACTIONS(1452),
    [anon_sym_AMP_AMP] = ACTIONS(1450),
    [anon_sym_PIPE_PIPE] = ACTIONS(1450),
    [anon_sym_LT_LT] = ACTIONS(1452),
    [anon_sym_GT_GT] = ACTIONS(1452),
    [anon_sym_PLUS_EQ] = ACTIONS(1450),
    [anon_sym_DASH_EQ] = ACTIONS(1450),
    [anon_sym_STAR_EQ] = ACTIONS(1450),
    [anon_sym_SLASH_EQ] = ACTIONS(1450),
    [anon_sym_PERCENT_EQ] = ACTIONS(1450),
    [anon_sym_CARET_EQ] = ACTIONS(1450),
    [anon_sym_AMP_EQ] = ACTIONS(1450),
    [anon_sym_PIPE_EQ] = ACTIONS(1450),
    [anon_sym_LT_LT_EQ] = ACTIONS(1450),
    [anon_sym_GT_GT_EQ] = ACTIONS(1450),
    [anon_sym_EQ] = ACTIONS(1452),
    [anon_sym_EQ_EQ] = ACTIONS(1450),
    [anon_sym_BANG_EQ] = ACTIONS(1450),
    [anon_sym_GT] = ACTIONS(1452),
    [anon_sym_LT] = ACTIONS(1452),
    [anon_sym_GT_EQ] = ACTIONS(1450),
    [anon_sym_LT_EQ] = ACTIONS(1450),
    [anon_sym_DOT] = ACTIONS(1452),
    [anon_sym_DOT_DOT] = ACTIONS(1452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1450),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1450),
    [anon_sym_COLON_COLON] = ACTIONS(1450),
    [anon_sym_POUND] = ACTIONS(1450),
    [anon_sym_SQUOTE] = ACTIONS(1452),
    [anon_sym_as] = ACTIONS(1452),
    [anon_sym_async] = ACTIONS(1452),
    [anon_sym_break] = ACTIONS(1452),
    [anon_sym_const] = ACTIONS(1452),
    [anon_sym_continue] = ACTIONS(1452),
    [anon_sym_default] = ACTIONS(1452),
    [anon_sym_enum] = ACTIONS(1452),
    [anon_sym_fn] = ACTIONS(1452),
    [anon_sym_for] = ACTIONS(1452),
    [anon_sym_if] = ACTIONS(1452),
    [anon_sym_impl] = ACTIONS(1452),
    [anon_sym_let] = ACTIONS(1452),
    [anon_sym_loop] = ACTIONS(1452),
    [anon_sym_match] = ACTIONS(1452),
    [anon_sym_mod] = ACTIONS(1452),
    [anon_sym_pub] = ACTIONS(1452),
    [anon_sym_return] = ACTIONS(1452),
    [anon_sym_static] = ACTIONS(1452),
    [anon_sym_struct] = ACTIONS(1452),
    [anon_sym_trait] = ACTIONS(1452),
    [anon_sym_type] = ACTIONS(1452),
    [anon_sym_union] = ACTIONS(1452),
    [anon_sym_unsafe] = ACTIONS(1452),
    [anon_sym_use] = ACTIONS(1452),
    [anon_sym_while] = ACTIONS(1452),
    [anon_sym_extern] = ACTIONS(1452),
    [anon_sym_yield] = ACTIONS(1452),
    [anon_sym_move] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(1452),
    [sym_integer_literal] = ACTIONS(1450),
    [aux_sym_string_literal_token1] = ACTIONS(1450),
    [sym_char_literal] = ACTIONS(1450),
    [anon_sym_true] = ACTIONS(1452),
    [anon_sym_false] = ACTIONS(1452),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1452),
    [sym_super] = ACTIONS(1452),
    [sym_crate] = ACTIONS(1452),
    [sym_metavariable] = ACTIONS(1450),
    [sym__raw_string_literal_start] = ACTIONS(1450),
    [sym_float_literal] = ACTIONS(1450),
  },
  [400] = {
    [sym_attribute_item] = STATE(414),
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_self_parameter] = STATE(3136),
    [sym_variadic_parameter] = STATE(3136),
    [sym_parameter] = STATE(3136),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2947),
    [sym_bracketed_type] = STATE(3510),
    [sym_lifetime] = STATE(2946),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3294),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(2440),
    [sym_scoped_identifier] = STATE(2214),
    [sym_scoped_type_identifier] = STATE(2100),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(3137),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(400),
    [sym_block_comment] = STATE(400),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_LPAREN] = ACTIONS(1266),
    [anon_sym_RPAREN] = ACTIONS(1454),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1276),
    [anon_sym_i8] = ACTIONS(1276),
    [anon_sym_u16] = ACTIONS(1276),
    [anon_sym_i16] = ACTIONS(1276),
    [anon_sym_u32] = ACTIONS(1276),
    [anon_sym_i32] = ACTIONS(1276),
    [anon_sym_u64] = ACTIONS(1276),
    [anon_sym_i64] = ACTIONS(1276),
    [anon_sym_u128] = ACTIONS(1276),
    [anon_sym_i128] = ACTIONS(1276),
    [anon_sym_isize] = ACTIONS(1276),
    [anon_sym_usize] = ACTIONS(1276),
    [anon_sym_f32] = ACTIONS(1276),
    [anon_sym_f64] = ACTIONS(1276),
    [anon_sym_bool] = ACTIONS(1276),
    [anon_sym_str] = ACTIONS(1276),
    [anon_sym_char] = ACTIONS(1276),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1282),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1456),
    [anon_sym_DOT_DOT] = ACTIONS(1288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1290),
    [anon_sym_COLON_COLON] = ACTIONS(1294),
    [anon_sym_POUND] = ACTIONS(1296),
    [anon_sym_SQUOTE] = ACTIONS(1298),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1302),
    [anon_sym_default] = ACTIONS(1304),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1312),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_ref] = ACTIONS(1316),
    [anon_sym_dyn] = ACTIONS(1318),
    [sym_mutable_specifier] = ACTIONS(1320),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1328),
    [sym_super] = ACTIONS(1330),
    [sym_crate] = ACTIONS(1330),
    [sym_metavariable] = ACTIONS(1332),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [401] = {
    [sym_line_comment] = STATE(401),
    [sym_block_comment] = STATE(401),
    [sym_identifier] = ACTIONS(1444),
    [anon_sym_SEMI] = ACTIONS(1346),
    [anon_sym_macro_rules_BANG] = ACTIONS(1442),
    [anon_sym_LPAREN] = ACTIONS(1346),
    [anon_sym_LBRACK] = ACTIONS(1346),
    [anon_sym_LBRACE] = ACTIONS(1442),
    [anon_sym_RBRACE] = ACTIONS(1442),
    [anon_sym_PLUS] = ACTIONS(1344),
    [anon_sym_STAR] = ACTIONS(1344),
    [anon_sym_QMARK] = ACTIONS(1346),
    [anon_sym_u8] = ACTIONS(1444),
    [anon_sym_i8] = ACTIONS(1444),
    [anon_sym_u16] = ACTIONS(1444),
    [anon_sym_i16] = ACTIONS(1444),
    [anon_sym_u32] = ACTIONS(1444),
    [anon_sym_i32] = ACTIONS(1444),
    [anon_sym_u64] = ACTIONS(1444),
    [anon_sym_i64] = ACTIONS(1444),
    [anon_sym_u128] = ACTIONS(1444),
    [anon_sym_i128] = ACTIONS(1444),
    [anon_sym_isize] = ACTIONS(1444),
    [anon_sym_usize] = ACTIONS(1444),
    [anon_sym_f32] = ACTIONS(1444),
    [anon_sym_f64] = ACTIONS(1444),
    [anon_sym_bool] = ACTIONS(1444),
    [anon_sym_str] = ACTIONS(1444),
    [anon_sym_char] = ACTIONS(1444),
    [anon_sym_DASH] = ACTIONS(1344),
    [anon_sym_SLASH] = ACTIONS(1344),
    [anon_sym_PERCENT] = ACTIONS(1344),
    [anon_sym_CARET] = ACTIONS(1344),
    [anon_sym_BANG] = ACTIONS(1444),
    [anon_sym_AMP] = ACTIONS(1344),
    [anon_sym_PIPE] = ACTIONS(1344),
    [anon_sym_AMP_AMP] = ACTIONS(1346),
    [anon_sym_PIPE_PIPE] = ACTIONS(1346),
    [anon_sym_LT_LT] = ACTIONS(1344),
    [anon_sym_GT_GT] = ACTIONS(1344),
    [anon_sym_PLUS_EQ] = ACTIONS(1346),
    [anon_sym_DASH_EQ] = ACTIONS(1346),
    [anon_sym_STAR_EQ] = ACTIONS(1346),
    [anon_sym_SLASH_EQ] = ACTIONS(1346),
    [anon_sym_PERCENT_EQ] = ACTIONS(1346),
    [anon_sym_CARET_EQ] = ACTIONS(1346),
    [anon_sym_AMP_EQ] = ACTIONS(1346),
    [anon_sym_PIPE_EQ] = ACTIONS(1346),
    [anon_sym_LT_LT_EQ] = ACTIONS(1346),
    [anon_sym_GT_GT_EQ] = ACTIONS(1346),
    [anon_sym_EQ] = ACTIONS(1344),
    [anon_sym_EQ_EQ] = ACTIONS(1346),
    [anon_sym_BANG_EQ] = ACTIONS(1346),
    [anon_sym_GT] = ACTIONS(1344),
    [anon_sym_LT] = ACTIONS(1344),
    [anon_sym_GT_EQ] = ACTIONS(1346),
    [anon_sym_LT_EQ] = ACTIONS(1346),
    [anon_sym_DOT] = ACTIONS(1344),
    [anon_sym_DOT_DOT] = ACTIONS(1344),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1346),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1346),
    [anon_sym_COLON_COLON] = ACTIONS(1442),
    [anon_sym_POUND] = ACTIONS(1442),
    [anon_sym_SQUOTE] = ACTIONS(1444),
    [anon_sym_as] = ACTIONS(1344),
    [anon_sym_async] = ACTIONS(1444),
    [anon_sym_break] = ACTIONS(1444),
    [anon_sym_const] = ACTIONS(1444),
    [anon_sym_continue] = ACTIONS(1444),
    [anon_sym_default] = ACTIONS(1444),
    [anon_sym_enum] = ACTIONS(1444),
    [anon_sym_fn] = ACTIONS(1444),
    [anon_sym_for] = ACTIONS(1444),
    [anon_sym_if] = ACTIONS(1444),
    [anon_sym_impl] = ACTIONS(1444),
    [anon_sym_let] = ACTIONS(1444),
    [anon_sym_loop] = ACTIONS(1444),
    [anon_sym_match] = ACTIONS(1444),
    [anon_sym_mod] = ACTIONS(1444),
    [anon_sym_pub] = ACTIONS(1444),
    [anon_sym_return] = ACTIONS(1444),
    [anon_sym_static] = ACTIONS(1444),
    [anon_sym_struct] = ACTIONS(1444),
    [anon_sym_trait] = ACTIONS(1444),
    [anon_sym_type] = ACTIONS(1444),
    [anon_sym_union] = ACTIONS(1444),
    [anon_sym_unsafe] = ACTIONS(1444),
    [anon_sym_use] = ACTIONS(1444),
    [anon_sym_while] = ACTIONS(1444),
    [anon_sym_extern] = ACTIONS(1444),
    [anon_sym_yield] = ACTIONS(1444),
    [anon_sym_move] = ACTIONS(1444),
    [anon_sym_try] = ACTIONS(1444),
    [sym_integer_literal] = ACTIONS(1442),
    [aux_sym_string_literal_token1] = ACTIONS(1442),
    [sym_char_literal] = ACTIONS(1442),
    [anon_sym_true] = ACTIONS(1444),
    [anon_sym_false] = ACTIONS(1444),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1444),
    [sym_super] = ACTIONS(1444),
    [sym_crate] = ACTIONS(1444),
    [sym_metavariable] = ACTIONS(1442),
    [sym__raw_string_literal_start] = ACTIONS(1442),
    [sym_float_literal] = ACTIONS(1442),
  },
  [402] = {
    [sym_attribute_item] = STATE(414),
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_self_parameter] = STATE(3136),
    [sym_variadic_parameter] = STATE(3136),
    [sym_parameter] = STATE(3136),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2947),
    [sym_bracketed_type] = STATE(3510),
    [sym_lifetime] = STATE(2946),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3294),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(2440),
    [sym_scoped_identifier] = STATE(2214),
    [sym_scoped_type_identifier] = STATE(2100),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(3137),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(402),
    [sym_block_comment] = STATE(402),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_LPAREN] = ACTIONS(1266),
    [anon_sym_RPAREN] = ACTIONS(1458),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1276),
    [anon_sym_i8] = ACTIONS(1276),
    [anon_sym_u16] = ACTIONS(1276),
    [anon_sym_i16] = ACTIONS(1276),
    [anon_sym_u32] = ACTIONS(1276),
    [anon_sym_i32] = ACTIONS(1276),
    [anon_sym_u64] = ACTIONS(1276),
    [anon_sym_i64] = ACTIONS(1276),
    [anon_sym_u128] = ACTIONS(1276),
    [anon_sym_i128] = ACTIONS(1276),
    [anon_sym_isize] = ACTIONS(1276),
    [anon_sym_usize] = ACTIONS(1276),
    [anon_sym_f32] = ACTIONS(1276),
    [anon_sym_f64] = ACTIONS(1276),
    [anon_sym_bool] = ACTIONS(1276),
    [anon_sym_str] = ACTIONS(1276),
    [anon_sym_char] = ACTIONS(1276),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1282),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1456),
    [anon_sym_DOT_DOT] = ACTIONS(1288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1290),
    [anon_sym_COLON_COLON] = ACTIONS(1294),
    [anon_sym_POUND] = ACTIONS(1296),
    [anon_sym_SQUOTE] = ACTIONS(1298),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1302),
    [anon_sym_default] = ACTIONS(1304),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1312),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_ref] = ACTIONS(1316),
    [anon_sym_dyn] = ACTIONS(1318),
    [sym_mutable_specifier] = ACTIONS(1320),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1328),
    [sym_super] = ACTIONS(1330),
    [sym_crate] = ACTIONS(1330),
    [sym_metavariable] = ACTIONS(1332),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [403] = {
    [sym_attribute_item] = STATE(414),
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_self_parameter] = STATE(3136),
    [sym_variadic_parameter] = STATE(3136),
    [sym_parameter] = STATE(3136),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2947),
    [sym_bracketed_type] = STATE(3510),
    [sym_lifetime] = STATE(2946),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3294),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(2440),
    [sym_scoped_identifier] = STATE(2214),
    [sym_scoped_type_identifier] = STATE(2100),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(3137),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(403),
    [sym_block_comment] = STATE(403),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_LPAREN] = ACTIONS(1266),
    [anon_sym_RPAREN] = ACTIONS(1460),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1276),
    [anon_sym_i8] = ACTIONS(1276),
    [anon_sym_u16] = ACTIONS(1276),
    [anon_sym_i16] = ACTIONS(1276),
    [anon_sym_u32] = ACTIONS(1276),
    [anon_sym_i32] = ACTIONS(1276),
    [anon_sym_u64] = ACTIONS(1276),
    [anon_sym_i64] = ACTIONS(1276),
    [anon_sym_u128] = ACTIONS(1276),
    [anon_sym_i128] = ACTIONS(1276),
    [anon_sym_isize] = ACTIONS(1276),
    [anon_sym_usize] = ACTIONS(1276),
    [anon_sym_f32] = ACTIONS(1276),
    [anon_sym_f64] = ACTIONS(1276),
    [anon_sym_bool] = ACTIONS(1276),
    [anon_sym_str] = ACTIONS(1276),
    [anon_sym_char] = ACTIONS(1276),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1282),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1456),
    [anon_sym_DOT_DOT] = ACTIONS(1288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1290),
    [anon_sym_COLON_COLON] = ACTIONS(1294),
    [anon_sym_POUND] = ACTIONS(1296),
    [anon_sym_SQUOTE] = ACTIONS(1298),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1302),
    [anon_sym_default] = ACTIONS(1304),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1312),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_ref] = ACTIONS(1316),
    [anon_sym_dyn] = ACTIONS(1318),
    [sym_mutable_specifier] = ACTIONS(1320),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1328),
    [sym_super] = ACTIONS(1330),
    [sym_crate] = ACTIONS(1330),
    [sym_metavariable] = ACTIONS(1332),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [404] = {
    [sym_attribute_item] = STATE(414),
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_self_parameter] = STATE(3136),
    [sym_variadic_parameter] = STATE(3136),
    [sym_parameter] = STATE(3136),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2947),
    [sym_bracketed_type] = STATE(3510),
    [sym_lifetime] = STATE(2946),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3294),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(2440),
    [sym_scoped_identifier] = STATE(2214),
    [sym_scoped_type_identifier] = STATE(2100),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(3137),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(404),
    [sym_block_comment] = STATE(404),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_LPAREN] = ACTIONS(1266),
    [anon_sym_RPAREN] = ACTIONS(1462),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1276),
    [anon_sym_i8] = ACTIONS(1276),
    [anon_sym_u16] = ACTIONS(1276),
    [anon_sym_i16] = ACTIONS(1276),
    [anon_sym_u32] = ACTIONS(1276),
    [anon_sym_i32] = ACTIONS(1276),
    [anon_sym_u64] = ACTIONS(1276),
    [anon_sym_i64] = ACTIONS(1276),
    [anon_sym_u128] = ACTIONS(1276),
    [anon_sym_i128] = ACTIONS(1276),
    [anon_sym_isize] = ACTIONS(1276),
    [anon_sym_usize] = ACTIONS(1276),
    [anon_sym_f32] = ACTIONS(1276),
    [anon_sym_f64] = ACTIONS(1276),
    [anon_sym_bool] = ACTIONS(1276),
    [anon_sym_str] = ACTIONS(1276),
    [anon_sym_char] = ACTIONS(1276),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1282),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1456),
    [anon_sym_DOT_DOT] = ACTIONS(1288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1290),
    [anon_sym_COLON_COLON] = ACTIONS(1294),
    [anon_sym_POUND] = ACTIONS(1296),
    [anon_sym_SQUOTE] = ACTIONS(1298),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1302),
    [anon_sym_default] = ACTIONS(1304),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1312),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_ref] = ACTIONS(1316),
    [anon_sym_dyn] = ACTIONS(1318),
    [sym_mutable_specifier] = ACTIONS(1320),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1328),
    [sym_super] = ACTIONS(1330),
    [sym_crate] = ACTIONS(1330),
    [sym_metavariable] = ACTIONS(1332),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [405] = {
    [sym_attribute_item] = STATE(414),
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_self_parameter] = STATE(3136),
    [sym_variadic_parameter] = STATE(3136),
    [sym_parameter] = STATE(3136),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2947),
    [sym_bracketed_type] = STATE(3510),
    [sym_lifetime] = STATE(2946),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3294),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(2440),
    [sym_scoped_identifier] = STATE(2214),
    [sym_scoped_type_identifier] = STATE(2100),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(3137),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(405),
    [sym_block_comment] = STATE(405),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_LPAREN] = ACTIONS(1266),
    [anon_sym_RPAREN] = ACTIONS(1464),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1276),
    [anon_sym_i8] = ACTIONS(1276),
    [anon_sym_u16] = ACTIONS(1276),
    [anon_sym_i16] = ACTIONS(1276),
    [anon_sym_u32] = ACTIONS(1276),
    [anon_sym_i32] = ACTIONS(1276),
    [anon_sym_u64] = ACTIONS(1276),
    [anon_sym_i64] = ACTIONS(1276),
    [anon_sym_u128] = ACTIONS(1276),
    [anon_sym_i128] = ACTIONS(1276),
    [anon_sym_isize] = ACTIONS(1276),
    [anon_sym_usize] = ACTIONS(1276),
    [anon_sym_f32] = ACTIONS(1276),
    [anon_sym_f64] = ACTIONS(1276),
    [anon_sym_bool] = ACTIONS(1276),
    [anon_sym_str] = ACTIONS(1276),
    [anon_sym_char] = ACTIONS(1276),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1282),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1456),
    [anon_sym_DOT_DOT] = ACTIONS(1288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1290),
    [anon_sym_COLON_COLON] = ACTIONS(1294),
    [anon_sym_POUND] = ACTIONS(1296),
    [anon_sym_SQUOTE] = ACTIONS(1298),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1302),
    [anon_sym_default] = ACTIONS(1304),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1312),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_ref] = ACTIONS(1316),
    [anon_sym_dyn] = ACTIONS(1318),
    [sym_mutable_specifier] = ACTIONS(1320),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1328),
    [sym_super] = ACTIONS(1330),
    [sym_crate] = ACTIONS(1330),
    [sym_metavariable] = ACTIONS(1332),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [406] = {
    [sym_attribute_item] = STATE(414),
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_self_parameter] = STATE(3136),
    [sym_variadic_parameter] = STATE(3136),
    [sym_parameter] = STATE(3136),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2947),
    [sym_bracketed_type] = STATE(3510),
    [sym_lifetime] = STATE(2946),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3294),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(2440),
    [sym_scoped_identifier] = STATE(2214),
    [sym_scoped_type_identifier] = STATE(2100),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(3137),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(406),
    [sym_block_comment] = STATE(406),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_LPAREN] = ACTIONS(1266),
    [anon_sym_RPAREN] = ACTIONS(1466),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1276),
    [anon_sym_i8] = ACTIONS(1276),
    [anon_sym_u16] = ACTIONS(1276),
    [anon_sym_i16] = ACTIONS(1276),
    [anon_sym_u32] = ACTIONS(1276),
    [anon_sym_i32] = ACTIONS(1276),
    [anon_sym_u64] = ACTIONS(1276),
    [anon_sym_i64] = ACTIONS(1276),
    [anon_sym_u128] = ACTIONS(1276),
    [anon_sym_i128] = ACTIONS(1276),
    [anon_sym_isize] = ACTIONS(1276),
    [anon_sym_usize] = ACTIONS(1276),
    [anon_sym_f32] = ACTIONS(1276),
    [anon_sym_f64] = ACTIONS(1276),
    [anon_sym_bool] = ACTIONS(1276),
    [anon_sym_str] = ACTIONS(1276),
    [anon_sym_char] = ACTIONS(1276),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1282),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1456),
    [anon_sym_DOT_DOT] = ACTIONS(1288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1290),
    [anon_sym_COLON_COLON] = ACTIONS(1294),
    [anon_sym_POUND] = ACTIONS(1296),
    [anon_sym_SQUOTE] = ACTIONS(1298),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1302),
    [anon_sym_default] = ACTIONS(1304),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1312),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_ref] = ACTIONS(1316),
    [anon_sym_dyn] = ACTIONS(1318),
    [sym_mutable_specifier] = ACTIONS(1320),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1328),
    [sym_super] = ACTIONS(1330),
    [sym_crate] = ACTIONS(1330),
    [sym_metavariable] = ACTIONS(1332),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [407] = {
    [sym_attribute_item] = STATE(414),
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_self_parameter] = STATE(3136),
    [sym_variadic_parameter] = STATE(3136),
    [sym_parameter] = STATE(3136),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2947),
    [sym_bracketed_type] = STATE(3510),
    [sym_lifetime] = STATE(2946),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3294),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(2440),
    [sym_scoped_identifier] = STATE(2214),
    [sym_scoped_type_identifier] = STATE(2100),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(3137),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(407),
    [sym_block_comment] = STATE(407),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_LPAREN] = ACTIONS(1266),
    [anon_sym_RPAREN] = ACTIONS(1468),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1276),
    [anon_sym_i8] = ACTIONS(1276),
    [anon_sym_u16] = ACTIONS(1276),
    [anon_sym_i16] = ACTIONS(1276),
    [anon_sym_u32] = ACTIONS(1276),
    [anon_sym_i32] = ACTIONS(1276),
    [anon_sym_u64] = ACTIONS(1276),
    [anon_sym_i64] = ACTIONS(1276),
    [anon_sym_u128] = ACTIONS(1276),
    [anon_sym_i128] = ACTIONS(1276),
    [anon_sym_isize] = ACTIONS(1276),
    [anon_sym_usize] = ACTIONS(1276),
    [anon_sym_f32] = ACTIONS(1276),
    [anon_sym_f64] = ACTIONS(1276),
    [anon_sym_bool] = ACTIONS(1276),
    [anon_sym_str] = ACTIONS(1276),
    [anon_sym_char] = ACTIONS(1276),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1282),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1456),
    [anon_sym_DOT_DOT] = ACTIONS(1288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1290),
    [anon_sym_COLON_COLON] = ACTIONS(1294),
    [anon_sym_POUND] = ACTIONS(1296),
    [anon_sym_SQUOTE] = ACTIONS(1298),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1302),
    [anon_sym_default] = ACTIONS(1304),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1312),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_ref] = ACTIONS(1316),
    [anon_sym_dyn] = ACTIONS(1318),
    [sym_mutable_specifier] = ACTIONS(1320),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1328),
    [sym_super] = ACTIONS(1330),
    [sym_crate] = ACTIONS(1330),
    [sym_metavariable] = ACTIONS(1332),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [408] = {
    [sym_attribute_item] = STATE(414),
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_self_parameter] = STATE(3136),
    [sym_variadic_parameter] = STATE(3136),
    [sym_parameter] = STATE(3136),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2947),
    [sym_bracketed_type] = STATE(3510),
    [sym_lifetime] = STATE(2946),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3294),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(2440),
    [sym_scoped_identifier] = STATE(2214),
    [sym_scoped_type_identifier] = STATE(2100),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(3137),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(408),
    [sym_block_comment] = STATE(408),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_LPAREN] = ACTIONS(1266),
    [anon_sym_RPAREN] = ACTIONS(1470),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1276),
    [anon_sym_i8] = ACTIONS(1276),
    [anon_sym_u16] = ACTIONS(1276),
    [anon_sym_i16] = ACTIONS(1276),
    [anon_sym_u32] = ACTIONS(1276),
    [anon_sym_i32] = ACTIONS(1276),
    [anon_sym_u64] = ACTIONS(1276),
    [anon_sym_i64] = ACTIONS(1276),
    [anon_sym_u128] = ACTIONS(1276),
    [anon_sym_i128] = ACTIONS(1276),
    [anon_sym_isize] = ACTIONS(1276),
    [anon_sym_usize] = ACTIONS(1276),
    [anon_sym_f32] = ACTIONS(1276),
    [anon_sym_f64] = ACTIONS(1276),
    [anon_sym_bool] = ACTIONS(1276),
    [anon_sym_str] = ACTIONS(1276),
    [anon_sym_char] = ACTIONS(1276),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1282),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1456),
    [anon_sym_DOT_DOT] = ACTIONS(1288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1290),
    [anon_sym_COLON_COLON] = ACTIONS(1294),
    [anon_sym_POUND] = ACTIONS(1296),
    [anon_sym_SQUOTE] = ACTIONS(1298),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1302),
    [anon_sym_default] = ACTIONS(1304),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1312),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_ref] = ACTIONS(1316),
    [anon_sym_dyn] = ACTIONS(1318),
    [sym_mutable_specifier] = ACTIONS(1320),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1328),
    [sym_super] = ACTIONS(1330),
    [sym_crate] = ACTIONS(1330),
    [sym_metavariable] = ACTIONS(1332),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [409] = {
    [sym_attribute_item] = STATE(414),
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_self_parameter] = STATE(3136),
    [sym_variadic_parameter] = STATE(3136),
    [sym_parameter] = STATE(3136),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2947),
    [sym_bracketed_type] = STATE(3510),
    [sym_lifetime] = STATE(2946),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3294),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(2440),
    [sym_scoped_identifier] = STATE(2214),
    [sym_scoped_type_identifier] = STATE(2100),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(3137),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(409),
    [sym_block_comment] = STATE(409),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_LPAREN] = ACTIONS(1266),
    [anon_sym_RPAREN] = ACTIONS(1472),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1276),
    [anon_sym_i8] = ACTIONS(1276),
    [anon_sym_u16] = ACTIONS(1276),
    [anon_sym_i16] = ACTIONS(1276),
    [anon_sym_u32] = ACTIONS(1276),
    [anon_sym_i32] = ACTIONS(1276),
    [anon_sym_u64] = ACTIONS(1276),
    [anon_sym_i64] = ACTIONS(1276),
    [anon_sym_u128] = ACTIONS(1276),
    [anon_sym_i128] = ACTIONS(1276),
    [anon_sym_isize] = ACTIONS(1276),
    [anon_sym_usize] = ACTIONS(1276),
    [anon_sym_f32] = ACTIONS(1276),
    [anon_sym_f64] = ACTIONS(1276),
    [anon_sym_bool] = ACTIONS(1276),
    [anon_sym_str] = ACTIONS(1276),
    [anon_sym_char] = ACTIONS(1276),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1282),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1456),
    [anon_sym_DOT_DOT] = ACTIONS(1288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1290),
    [anon_sym_COLON_COLON] = ACTIONS(1294),
    [anon_sym_POUND] = ACTIONS(1296),
    [anon_sym_SQUOTE] = ACTIONS(1298),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1302),
    [anon_sym_default] = ACTIONS(1304),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1312),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_ref] = ACTIONS(1316),
    [anon_sym_dyn] = ACTIONS(1318),
    [sym_mutable_specifier] = ACTIONS(1320),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1328),
    [sym_super] = ACTIONS(1330),
    [sym_crate] = ACTIONS(1330),
    [sym_metavariable] = ACTIONS(1332),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [410] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2590),
    [sym_bracketed_type] = STATE(3517),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3091),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(2447),
    [sym_scoped_identifier] = STATE(2101),
    [sym_scoped_type_identifier] = STATE(2100),
    [sym_const_block] = STATE(2103),
    [sym_closure_expression] = STATE(2883),
    [sym_closure_parameters] = STATE(216),
    [sym__pattern] = STATE(2575),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(410),
    [sym_block_comment] = STATE(410),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(1356),
    [anon_sym_LPAREN] = ACTIONS(1358),
    [anon_sym_RPAREN] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1362),
    [anon_sym_i8] = ACTIONS(1362),
    [anon_sym_u16] = ACTIONS(1362),
    [anon_sym_i16] = ACTIONS(1362),
    [anon_sym_u32] = ACTIONS(1362),
    [anon_sym_i32] = ACTIONS(1362),
    [anon_sym_u64] = ACTIONS(1362),
    [anon_sym_i64] = ACTIONS(1362),
    [anon_sym_u128] = ACTIONS(1362),
    [anon_sym_i128] = ACTIONS(1362),
    [anon_sym_isize] = ACTIONS(1362),
    [anon_sym_usize] = ACTIONS(1362),
    [anon_sym_f32] = ACTIONS(1362),
    [anon_sym_f64] = ACTIONS(1362),
    [anon_sym_bool] = ACTIONS(1362),
    [anon_sym_str] = ACTIONS(1362),
    [anon_sym_char] = ACTIONS(1362),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(1484),
    [anon_sym_COLON_COLON] = ACTIONS(1370),
    [anon_sym_SQUOTE] = ACTIONS(1298),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1302),
    [anon_sym_default] = ACTIONS(1372),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_static] = ACTIONS(1486),
    [anon_sym_union] = ACTIONS(1374),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_ref] = ACTIONS(1316),
    [anon_sym_dyn] = ACTIONS(1318),
    [sym_mutable_specifier] = ACTIONS(1488),
    [anon_sym_move] = ACTIONS(1490),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1378),
    [sym_super] = ACTIONS(1378),
    [sym_crate] = ACTIONS(1378),
    [sym_metavariable] = ACTIONS(1380),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [411] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2590),
    [sym_bracketed_type] = STATE(3517),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3091),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(2447),
    [sym_scoped_identifier] = STATE(2101),
    [sym_scoped_type_identifier] = STATE(2100),
    [sym_const_block] = STATE(2103),
    [sym_closure_expression] = STATE(2883),
    [sym_closure_parameters] = STATE(216),
    [sym__pattern] = STATE(2575),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(411),
    [sym_block_comment] = STATE(411),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(1356),
    [anon_sym_LPAREN] = ACTIONS(1358),
    [anon_sym_RPAREN] = ACTIONS(1492),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1362),
    [anon_sym_i8] = ACTIONS(1362),
    [anon_sym_u16] = ACTIONS(1362),
    [anon_sym_i16] = ACTIONS(1362),
    [anon_sym_u32] = ACTIONS(1362),
    [anon_sym_i32] = ACTIONS(1362),
    [anon_sym_u64] = ACTIONS(1362),
    [anon_sym_i64] = ACTIONS(1362),
    [anon_sym_u128] = ACTIONS(1362),
    [anon_sym_i128] = ACTIONS(1362),
    [anon_sym_isize] = ACTIONS(1362),
    [anon_sym_usize] = ACTIONS(1362),
    [anon_sym_f32] = ACTIONS(1362),
    [anon_sym_f64] = ACTIONS(1362),
    [anon_sym_bool] = ACTIONS(1362),
    [anon_sym_str] = ACTIONS(1362),
    [anon_sym_char] = ACTIONS(1362),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(1484),
    [anon_sym_COLON_COLON] = ACTIONS(1370),
    [anon_sym_SQUOTE] = ACTIONS(1298),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1302),
    [anon_sym_default] = ACTIONS(1372),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_static] = ACTIONS(1486),
    [anon_sym_union] = ACTIONS(1374),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_ref] = ACTIONS(1316),
    [anon_sym_dyn] = ACTIONS(1318),
    [sym_mutable_specifier] = ACTIONS(1488),
    [anon_sym_move] = ACTIONS(1490),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1378),
    [sym_super] = ACTIONS(1378),
    [sym_crate] = ACTIONS(1378),
    [sym_metavariable] = ACTIONS(1380),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [412] = {
    [sym_attribute_item] = STATE(414),
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_self_parameter] = STATE(3136),
    [sym_variadic_parameter] = STATE(3136),
    [sym_parameter] = STATE(3136),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2947),
    [sym_bracketed_type] = STATE(3510),
    [sym_lifetime] = STATE(2946),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3294),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(2440),
    [sym_scoped_identifier] = STATE(2214),
    [sym_scoped_type_identifier] = STATE(2100),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(3137),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(412),
    [sym_block_comment] = STATE(412),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_LPAREN] = ACTIONS(1266),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1276),
    [anon_sym_i8] = ACTIONS(1276),
    [anon_sym_u16] = ACTIONS(1276),
    [anon_sym_i16] = ACTIONS(1276),
    [anon_sym_u32] = ACTIONS(1276),
    [anon_sym_i32] = ACTIONS(1276),
    [anon_sym_u64] = ACTIONS(1276),
    [anon_sym_i64] = ACTIONS(1276),
    [anon_sym_u128] = ACTIONS(1276),
    [anon_sym_i128] = ACTIONS(1276),
    [anon_sym_isize] = ACTIONS(1276),
    [anon_sym_usize] = ACTIONS(1276),
    [anon_sym_f32] = ACTIONS(1276),
    [anon_sym_f64] = ACTIONS(1276),
    [anon_sym_bool] = ACTIONS(1276),
    [anon_sym_str] = ACTIONS(1276),
    [anon_sym_char] = ACTIONS(1276),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1282),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1456),
    [anon_sym_DOT_DOT] = ACTIONS(1288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1290),
    [anon_sym_COLON_COLON] = ACTIONS(1294),
    [anon_sym_POUND] = ACTIONS(1296),
    [anon_sym_SQUOTE] = ACTIONS(1298),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1302),
    [anon_sym_default] = ACTIONS(1304),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1312),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_ref] = ACTIONS(1316),
    [anon_sym_dyn] = ACTIONS(1318),
    [sym_mutable_specifier] = ACTIONS(1320),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1328),
    [sym_super] = ACTIONS(1330),
    [sym_crate] = ACTIONS(1330),
    [sym_metavariable] = ACTIONS(1332),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [413] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2590),
    [sym_bracketed_type] = STATE(3517),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3091),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(2447),
    [sym_scoped_identifier] = STATE(2101),
    [sym_scoped_type_identifier] = STATE(2100),
    [sym_const_block] = STATE(2103),
    [sym_closure_expression] = STATE(2883),
    [sym_closure_parameters] = STATE(216),
    [sym__pattern] = STATE(2575),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(413),
    [sym_block_comment] = STATE(413),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(1356),
    [anon_sym_LPAREN] = ACTIONS(1358),
    [anon_sym_RPAREN] = ACTIONS(1494),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1362),
    [anon_sym_i8] = ACTIONS(1362),
    [anon_sym_u16] = ACTIONS(1362),
    [anon_sym_i16] = ACTIONS(1362),
    [anon_sym_u32] = ACTIONS(1362),
    [anon_sym_i32] = ACTIONS(1362),
    [anon_sym_u64] = ACTIONS(1362),
    [anon_sym_i64] = ACTIONS(1362),
    [anon_sym_u128] = ACTIONS(1362),
    [anon_sym_i128] = ACTIONS(1362),
    [anon_sym_isize] = ACTIONS(1362),
    [anon_sym_usize] = ACTIONS(1362),
    [anon_sym_f32] = ACTIONS(1362),
    [anon_sym_f64] = ACTIONS(1362),
    [anon_sym_bool] = ACTIONS(1362),
    [anon_sym_str] = ACTIONS(1362),
    [anon_sym_char] = ACTIONS(1362),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(1484),
    [anon_sym_COLON_COLON] = ACTIONS(1370),
    [anon_sym_SQUOTE] = ACTIONS(1298),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1302),
    [anon_sym_default] = ACTIONS(1372),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_static] = ACTIONS(1486),
    [anon_sym_union] = ACTIONS(1374),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_ref] = ACTIONS(1316),
    [anon_sym_dyn] = ACTIONS(1318),
    [sym_mutable_specifier] = ACTIONS(1488),
    [anon_sym_move] = ACTIONS(1490),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1378),
    [sym_super] = ACTIONS(1378),
    [sym_crate] = ACTIONS(1378),
    [sym_metavariable] = ACTIONS(1380),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [414] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_self_parameter] = STATE(3111),
    [sym_variadic_parameter] = STATE(3111),
    [sym_parameter] = STATE(3111),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2953),
    [sym_bracketed_type] = STATE(3510),
    [sym_lifetime] = STATE(2946),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3294),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(2440),
    [sym_scoped_identifier] = STATE(2214),
    [sym_scoped_type_identifier] = STATE(2100),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(3137),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(414),
    [sym_block_comment] = STATE(414),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_LPAREN] = ACTIONS(1266),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1276),
    [anon_sym_i8] = ACTIONS(1276),
    [anon_sym_u16] = ACTIONS(1276),
    [anon_sym_i16] = ACTIONS(1276),
    [anon_sym_u32] = ACTIONS(1276),
    [anon_sym_i32] = ACTIONS(1276),
    [anon_sym_u64] = ACTIONS(1276),
    [anon_sym_i64] = ACTIONS(1276),
    [anon_sym_u128] = ACTIONS(1276),
    [anon_sym_i128] = ACTIONS(1276),
    [anon_sym_isize] = ACTIONS(1276),
    [anon_sym_usize] = ACTIONS(1276),
    [anon_sym_f32] = ACTIONS(1276),
    [anon_sym_f64] = ACTIONS(1276),
    [anon_sym_bool] = ACTIONS(1276),
    [anon_sym_str] = ACTIONS(1276),
    [anon_sym_char] = ACTIONS(1276),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1282),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1496),
    [anon_sym_DOT_DOT] = ACTIONS(1288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1290),
    [anon_sym_COLON_COLON] = ACTIONS(1294),
    [anon_sym_SQUOTE] = ACTIONS(1298),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1302),
    [anon_sym_default] = ACTIONS(1304),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1312),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_ref] = ACTIONS(1316),
    [anon_sym_dyn] = ACTIONS(1318),
    [sym_mutable_specifier] = ACTIONS(1320),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1328),
    [sym_super] = ACTIONS(1330),
    [sym_crate] = ACTIONS(1330),
    [sym_metavariable] = ACTIONS(1332),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [415] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_self_parameter] = STATE(2887),
    [sym_variadic_parameter] = STATE(2887),
    [sym_parameter] = STATE(2887),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2687),
    [sym_bracketed_type] = STATE(3510),
    [sym_lifetime] = STATE(2946),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3294),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(2440),
    [sym_scoped_identifier] = STATE(2214),
    [sym_scoped_type_identifier] = STATE(2100),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(3137),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(415),
    [sym_block_comment] = STATE(415),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_LPAREN] = ACTIONS(1266),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1276),
    [anon_sym_i8] = ACTIONS(1276),
    [anon_sym_u16] = ACTIONS(1276),
    [anon_sym_i16] = ACTIONS(1276),
    [anon_sym_u32] = ACTIONS(1276),
    [anon_sym_i32] = ACTIONS(1276),
    [anon_sym_u64] = ACTIONS(1276),
    [anon_sym_i64] = ACTIONS(1276),
    [anon_sym_u128] = ACTIONS(1276),
    [anon_sym_i128] = ACTIONS(1276),
    [anon_sym_isize] = ACTIONS(1276),
    [anon_sym_usize] = ACTIONS(1276),
    [anon_sym_f32] = ACTIONS(1276),
    [anon_sym_f64] = ACTIONS(1276),
    [anon_sym_bool] = ACTIONS(1276),
    [anon_sym_str] = ACTIONS(1276),
    [anon_sym_char] = ACTIONS(1276),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1282),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1498),
    [anon_sym_DOT_DOT] = ACTIONS(1288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1290),
    [anon_sym_COLON_COLON] = ACTIONS(1294),
    [anon_sym_SQUOTE] = ACTIONS(1298),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1302),
    [anon_sym_default] = ACTIONS(1304),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1312),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_ref] = ACTIONS(1316),
    [anon_sym_dyn] = ACTIONS(1318),
    [sym_mutable_specifier] = ACTIONS(1320),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1328),
    [sym_super] = ACTIONS(1330),
    [sym_crate] = ACTIONS(1330),
    [sym_metavariable] = ACTIONS(1332),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [416] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_self_parameter] = STATE(3009),
    [sym_variadic_parameter] = STATE(3009),
    [sym_parameter] = STATE(3009),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2659),
    [sym_bracketed_type] = STATE(3510),
    [sym_lifetime] = STATE(2946),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3294),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(2440),
    [sym_scoped_identifier] = STATE(2214),
    [sym_scoped_type_identifier] = STATE(2100),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(3137),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(416),
    [sym_block_comment] = STATE(416),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_LPAREN] = ACTIONS(1266),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1276),
    [anon_sym_i8] = ACTIONS(1276),
    [anon_sym_u16] = ACTIONS(1276),
    [anon_sym_i16] = ACTIONS(1276),
    [anon_sym_u32] = ACTIONS(1276),
    [anon_sym_i32] = ACTIONS(1276),
    [anon_sym_u64] = ACTIONS(1276),
    [anon_sym_i64] = ACTIONS(1276),
    [anon_sym_u128] = ACTIONS(1276),
    [anon_sym_i128] = ACTIONS(1276),
    [anon_sym_isize] = ACTIONS(1276),
    [anon_sym_usize] = ACTIONS(1276),
    [anon_sym_f32] = ACTIONS(1276),
    [anon_sym_f64] = ACTIONS(1276),
    [anon_sym_bool] = ACTIONS(1276),
    [anon_sym_str] = ACTIONS(1276),
    [anon_sym_char] = ACTIONS(1276),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1282),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1500),
    [anon_sym_DOT_DOT] = ACTIONS(1288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1290),
    [anon_sym_COLON_COLON] = ACTIONS(1294),
    [anon_sym_SQUOTE] = ACTIONS(1298),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1302),
    [anon_sym_default] = ACTIONS(1304),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1312),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_ref] = ACTIONS(1316),
    [anon_sym_dyn] = ACTIONS(1318),
    [sym_mutable_specifier] = ACTIONS(1320),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1328),
    [sym_super] = ACTIONS(1330),
    [sym_crate] = ACTIONS(1330),
    [sym_metavariable] = ACTIONS(1332),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [417] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_self_parameter] = STATE(2935),
    [sym_variadic_parameter] = STATE(2935),
    [sym_parameter] = STATE(2935),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2611),
    [sym_bracketed_type] = STATE(3510),
    [sym_lifetime] = STATE(2946),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3294),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(2440),
    [sym_scoped_identifier] = STATE(2214),
    [sym_scoped_type_identifier] = STATE(2100),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(3137),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(417),
    [sym_block_comment] = STATE(417),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_LPAREN] = ACTIONS(1266),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1276),
    [anon_sym_i8] = ACTIONS(1276),
    [anon_sym_u16] = ACTIONS(1276),
    [anon_sym_i16] = ACTIONS(1276),
    [anon_sym_u32] = ACTIONS(1276),
    [anon_sym_i32] = ACTIONS(1276),
    [anon_sym_u64] = ACTIONS(1276),
    [anon_sym_i64] = ACTIONS(1276),
    [anon_sym_u128] = ACTIONS(1276),
    [anon_sym_i128] = ACTIONS(1276),
    [anon_sym_isize] = ACTIONS(1276),
    [anon_sym_usize] = ACTIONS(1276),
    [anon_sym_f32] = ACTIONS(1276),
    [anon_sym_f64] = ACTIONS(1276),
    [anon_sym_bool] = ACTIONS(1276),
    [anon_sym_str] = ACTIONS(1276),
    [anon_sym_char] = ACTIONS(1276),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1282),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1502),
    [anon_sym_DOT_DOT] = ACTIONS(1288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1290),
    [anon_sym_COLON_COLON] = ACTIONS(1294),
    [anon_sym_SQUOTE] = ACTIONS(1298),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1302),
    [anon_sym_default] = ACTIONS(1304),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1312),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_ref] = ACTIONS(1316),
    [anon_sym_dyn] = ACTIONS(1318),
    [sym_mutable_specifier] = ACTIONS(1320),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1328),
    [sym_super] = ACTIONS(1330),
    [sym_crate] = ACTIONS(1330),
    [sym_metavariable] = ACTIONS(1332),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [418] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2916),
    [sym_bracketed_type] = STATE(3518),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3086),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(2390),
    [sym_scoped_identifier] = STATE(2160),
    [sym_scoped_type_identifier] = STATE(2100),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2576),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(418),
    [sym_block_comment] = STATE(418),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(1504),
    [anon_sym_LPAREN] = ACTIONS(1506),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_RBRACK] = ACTIONS(1508),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1510),
    [anon_sym_i8] = ACTIONS(1510),
    [anon_sym_u16] = ACTIONS(1510),
    [anon_sym_i16] = ACTIONS(1510),
    [anon_sym_u32] = ACTIONS(1510),
    [anon_sym_i32] = ACTIONS(1510),
    [anon_sym_u64] = ACTIONS(1510),
    [anon_sym_i64] = ACTIONS(1510),
    [anon_sym_u128] = ACTIONS(1510),
    [anon_sym_i128] = ACTIONS(1510),
    [anon_sym_isize] = ACTIONS(1510),
    [anon_sym_usize] = ACTIONS(1510),
    [anon_sym_f32] = ACTIONS(1510),
    [anon_sym_f64] = ACTIONS(1510),
    [anon_sym_bool] = ACTIONS(1510),
    [anon_sym_str] = ACTIONS(1510),
    [anon_sym_char] = ACTIONS(1510),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1512),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(1514),
    [anon_sym_COLON_COLON] = ACTIONS(1516),
    [anon_sym_SQUOTE] = ACTIONS(1298),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1302),
    [anon_sym_default] = ACTIONS(1518),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1520),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_ref] = ACTIONS(1316),
    [anon_sym_dyn] = ACTIONS(1318),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1522),
    [sym_super] = ACTIONS(1522),
    [sym_crate] = ACTIONS(1522),
    [sym_metavariable] = ACTIONS(1524),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [419] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1960),
    [sym_bracketed_type] = STATE(3517),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3091),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(2447),
    [sym_scoped_identifier] = STATE(2101),
    [sym_scoped_type_identifier] = STATE(2100),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2091),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(419),
    [sym_block_comment] = STATE(419),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(1356),
    [anon_sym_LPAREN] = ACTIONS(1358),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1362),
    [anon_sym_i8] = ACTIONS(1362),
    [anon_sym_u16] = ACTIONS(1362),
    [anon_sym_i16] = ACTIONS(1362),
    [anon_sym_u32] = ACTIONS(1362),
    [anon_sym_i32] = ACTIONS(1362),
    [anon_sym_u64] = ACTIONS(1362),
    [anon_sym_i64] = ACTIONS(1362),
    [anon_sym_u128] = ACTIONS(1362),
    [anon_sym_i128] = ACTIONS(1362),
    [anon_sym_isize] = ACTIONS(1362),
    [anon_sym_usize] = ACTIONS(1362),
    [anon_sym_f32] = ACTIONS(1362),
    [anon_sym_f64] = ACTIONS(1362),
    [anon_sym_bool] = ACTIONS(1362),
    [anon_sym_str] = ACTIONS(1362),
    [anon_sym_char] = ACTIONS(1362),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(1370),
    [anon_sym_SQUOTE] = ACTIONS(1298),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1302),
    [anon_sym_default] = ACTIONS(1372),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1374),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_ref] = ACTIONS(1316),
    [anon_sym_dyn] = ACTIONS(1318),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1526),
    [sym_super] = ACTIONS(1378),
    [sym_crate] = ACTIONS(1378),
    [sym_metavariable] = ACTIONS(1380),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [420] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1973),
    [sym_bracketed_type] = STATE(3510),
    [sym_lifetime] = STATE(828),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3294),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(2440),
    [sym_scoped_identifier] = STATE(2214),
    [sym_scoped_type_identifier] = STATE(2100),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2109),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(420),
    [sym_block_comment] = STATE(420),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_LPAREN] = ACTIONS(1266),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1276),
    [anon_sym_i8] = ACTIONS(1276),
    [anon_sym_u16] = ACTIONS(1276),
    [anon_sym_i16] = ACTIONS(1276),
    [anon_sym_u32] = ACTIONS(1276),
    [anon_sym_i32] = ACTIONS(1276),
    [anon_sym_u64] = ACTIONS(1276),
    [anon_sym_i64] = ACTIONS(1276),
    [anon_sym_u128] = ACTIONS(1276),
    [anon_sym_i128] = ACTIONS(1276),
    [anon_sym_isize] = ACTIONS(1276),
    [anon_sym_usize] = ACTIONS(1276),
    [anon_sym_f32] = ACTIONS(1276),
    [anon_sym_f64] = ACTIONS(1276),
    [anon_sym_bool] = ACTIONS(1276),
    [anon_sym_str] = ACTIONS(1276),
    [anon_sym_char] = ACTIONS(1276),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1528),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(1294),
    [anon_sym_SQUOTE] = ACTIONS(1298),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1302),
    [anon_sym_default] = ACTIONS(1304),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1312),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_ref] = ACTIONS(1316),
    [anon_sym_dyn] = ACTIONS(1318),
    [sym_mutable_specifier] = ACTIONS(1530),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1330),
    [sym_super] = ACTIONS(1330),
    [sym_crate] = ACTIONS(1330),
    [sym_metavariable] = ACTIONS(1332),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [421] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1973),
    [sym_bracketed_type] = STATE(3517),
    [sym_lifetime] = STATE(828),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3091),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(2447),
    [sym_scoped_identifier] = STATE(2101),
    [sym_scoped_type_identifier] = STATE(2100),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2109),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(421),
    [sym_block_comment] = STATE(421),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(1356),
    [anon_sym_LPAREN] = ACTIONS(1358),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1362),
    [anon_sym_i8] = ACTIONS(1362),
    [anon_sym_u16] = ACTIONS(1362),
    [anon_sym_i16] = ACTIONS(1362),
    [anon_sym_u32] = ACTIONS(1362),
    [anon_sym_i32] = ACTIONS(1362),
    [anon_sym_u64] = ACTIONS(1362),
    [anon_sym_i64] = ACTIONS(1362),
    [anon_sym_u128] = ACTIONS(1362),
    [anon_sym_i128] = ACTIONS(1362),
    [anon_sym_isize] = ACTIONS(1362),
    [anon_sym_usize] = ACTIONS(1362),
    [anon_sym_f32] = ACTIONS(1362),
    [anon_sym_f64] = ACTIONS(1362),
    [anon_sym_bool] = ACTIONS(1362),
    [anon_sym_str] = ACTIONS(1362),
    [anon_sym_char] = ACTIONS(1362),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(1370),
    [anon_sym_SQUOTE] = ACTIONS(1298),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1302),
    [anon_sym_default] = ACTIONS(1372),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1374),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_ref] = ACTIONS(1316),
    [anon_sym_dyn] = ACTIONS(1318),
    [sym_mutable_specifier] = ACTIONS(1532),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1378),
    [sym_super] = ACTIONS(1378),
    [sym_crate] = ACTIONS(1378),
    [sym_metavariable] = ACTIONS(1380),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [422] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1973),
    [sym_bracketed_type] = STATE(3518),
    [sym_lifetime] = STATE(828),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3086),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(2390),
    [sym_scoped_identifier] = STATE(2160),
    [sym_scoped_type_identifier] = STATE(2100),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2109),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(422),
    [sym_block_comment] = STATE(422),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(1504),
    [anon_sym_LPAREN] = ACTIONS(1506),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1510),
    [anon_sym_i8] = ACTIONS(1510),
    [anon_sym_u16] = ACTIONS(1510),
    [anon_sym_i16] = ACTIONS(1510),
    [anon_sym_u32] = ACTIONS(1510),
    [anon_sym_i32] = ACTIONS(1510),
    [anon_sym_u64] = ACTIONS(1510),
    [anon_sym_i64] = ACTIONS(1510),
    [anon_sym_u128] = ACTIONS(1510),
    [anon_sym_i128] = ACTIONS(1510),
    [anon_sym_isize] = ACTIONS(1510),
    [anon_sym_usize] = ACTIONS(1510),
    [anon_sym_f32] = ACTIONS(1510),
    [anon_sym_f64] = ACTIONS(1510),
    [anon_sym_bool] = ACTIONS(1510),
    [anon_sym_str] = ACTIONS(1510),
    [anon_sym_char] = ACTIONS(1510),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1512),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(1516),
    [anon_sym_SQUOTE] = ACTIONS(1298),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1302),
    [anon_sym_default] = ACTIONS(1518),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1520),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_ref] = ACTIONS(1316),
    [anon_sym_dyn] = ACTIONS(1318),
    [sym_mutable_specifier] = ACTIONS(1534),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1522),
    [sym_super] = ACTIONS(1522),
    [sym_crate] = ACTIONS(1522),
    [sym_metavariable] = ACTIONS(1524),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [423] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1960),
    [sym_bracketed_type] = STATE(3510),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3294),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(2440),
    [sym_scoped_identifier] = STATE(2214),
    [sym_scoped_type_identifier] = STATE(2100),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2091),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(423),
    [sym_block_comment] = STATE(423),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_LPAREN] = ACTIONS(1266),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1276),
    [anon_sym_i8] = ACTIONS(1276),
    [anon_sym_u16] = ACTIONS(1276),
    [anon_sym_i16] = ACTIONS(1276),
    [anon_sym_u32] = ACTIONS(1276),
    [anon_sym_i32] = ACTIONS(1276),
    [anon_sym_u64] = ACTIONS(1276),
    [anon_sym_i64] = ACTIONS(1276),
    [anon_sym_u128] = ACTIONS(1276),
    [anon_sym_i128] = ACTIONS(1276),
    [anon_sym_isize] = ACTIONS(1276),
    [anon_sym_usize] = ACTIONS(1276),
    [anon_sym_f32] = ACTIONS(1276),
    [anon_sym_f64] = ACTIONS(1276),
    [anon_sym_bool] = ACTIONS(1276),
    [anon_sym_str] = ACTIONS(1276),
    [anon_sym_char] = ACTIONS(1276),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1528),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(1294),
    [anon_sym_SQUOTE] = ACTIONS(1298),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1302),
    [anon_sym_default] = ACTIONS(1304),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1312),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_ref] = ACTIONS(1316),
    [anon_sym_dyn] = ACTIONS(1318),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1330),
    [sym_super] = ACTIONS(1330),
    [sym_crate] = ACTIONS(1330),
    [sym_metavariable] = ACTIONS(1332),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [424] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1960),
    [sym_bracketed_type] = STATE(3517),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3091),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(2447),
    [sym_scoped_identifier] = STATE(2101),
    [sym_scoped_type_identifier] = STATE(2100),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2091),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(424),
    [sym_block_comment] = STATE(424),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(1356),
    [anon_sym_LPAREN] = ACTIONS(1358),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1362),
    [anon_sym_i8] = ACTIONS(1362),
    [anon_sym_u16] = ACTIONS(1362),
    [anon_sym_i16] = ACTIONS(1362),
    [anon_sym_u32] = ACTIONS(1362),
    [anon_sym_i32] = ACTIONS(1362),
    [anon_sym_u64] = ACTIONS(1362),
    [anon_sym_i64] = ACTIONS(1362),
    [anon_sym_u128] = ACTIONS(1362),
    [anon_sym_i128] = ACTIONS(1362),
    [anon_sym_isize] = ACTIONS(1362),
    [anon_sym_usize] = ACTIONS(1362),
    [anon_sym_f32] = ACTIONS(1362),
    [anon_sym_f64] = ACTIONS(1362),
    [anon_sym_bool] = ACTIONS(1362),
    [anon_sym_str] = ACTIONS(1362),
    [anon_sym_char] = ACTIONS(1362),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(1370),
    [anon_sym_SQUOTE] = ACTIONS(1298),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1302),
    [anon_sym_default] = ACTIONS(1372),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1374),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_ref] = ACTIONS(1316),
    [anon_sym_dyn] = ACTIONS(1318),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1378),
    [sym_super] = ACTIONS(1378),
    [sym_crate] = ACTIONS(1378),
    [sym_metavariable] = ACTIONS(1380),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [425] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1960),
    [sym_bracketed_type] = STATE(3510),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3294),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(2440),
    [sym_scoped_identifier] = STATE(2214),
    [sym_scoped_type_identifier] = STATE(2100),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2091),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(425),
    [sym_block_comment] = STATE(425),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_LPAREN] = ACTIONS(1266),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1276),
    [anon_sym_i8] = ACTIONS(1276),
    [anon_sym_u16] = ACTIONS(1276),
    [anon_sym_i16] = ACTIONS(1276),
    [anon_sym_u32] = ACTIONS(1276),
    [anon_sym_i32] = ACTIONS(1276),
    [anon_sym_u64] = ACTIONS(1276),
    [anon_sym_i64] = ACTIONS(1276),
    [anon_sym_u128] = ACTIONS(1276),
    [anon_sym_i128] = ACTIONS(1276),
    [anon_sym_isize] = ACTIONS(1276),
    [anon_sym_usize] = ACTIONS(1276),
    [anon_sym_f32] = ACTIONS(1276),
    [anon_sym_f64] = ACTIONS(1276),
    [anon_sym_bool] = ACTIONS(1276),
    [anon_sym_str] = ACTIONS(1276),
    [anon_sym_char] = ACTIONS(1276),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1528),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(1294),
    [anon_sym_SQUOTE] = ACTIONS(1298),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1302),
    [anon_sym_default] = ACTIONS(1304),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1312),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_ref] = ACTIONS(1316),
    [anon_sym_dyn] = ACTIONS(1318),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1536),
    [sym_super] = ACTIONS(1330),
    [sym_crate] = ACTIONS(1330),
    [sym_metavariable] = ACTIONS(1332),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [426] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1973),
    [sym_bracketed_type] = STATE(3517),
    [sym_lifetime] = STATE(827),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3091),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(2447),
    [sym_scoped_identifier] = STATE(2101),
    [sym_scoped_type_identifier] = STATE(2100),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2109),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(426),
    [sym_block_comment] = STATE(426),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(1356),
    [anon_sym_LPAREN] = ACTIONS(1358),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1362),
    [anon_sym_i8] = ACTIONS(1362),
    [anon_sym_u16] = ACTIONS(1362),
    [anon_sym_i16] = ACTIONS(1362),
    [anon_sym_u32] = ACTIONS(1362),
    [anon_sym_i32] = ACTIONS(1362),
    [anon_sym_u64] = ACTIONS(1362),
    [anon_sym_i64] = ACTIONS(1362),
    [anon_sym_u128] = ACTIONS(1362),
    [anon_sym_i128] = ACTIONS(1362),
    [anon_sym_isize] = ACTIONS(1362),
    [anon_sym_usize] = ACTIONS(1362),
    [anon_sym_f32] = ACTIONS(1362),
    [anon_sym_f64] = ACTIONS(1362),
    [anon_sym_bool] = ACTIONS(1362),
    [anon_sym_str] = ACTIONS(1362),
    [anon_sym_char] = ACTIONS(1362),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(1370),
    [anon_sym_SQUOTE] = ACTIONS(1298),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1302),
    [anon_sym_default] = ACTIONS(1372),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1374),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_ref] = ACTIONS(1316),
    [anon_sym_dyn] = ACTIONS(1318),
    [sym_mutable_specifier] = ACTIONS(1538),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1540),
    [sym_super] = ACTIONS(1378),
    [sym_crate] = ACTIONS(1378),
    [sym_metavariable] = ACTIONS(1380),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [427] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1973),
    [sym_bracketed_type] = STATE(3510),
    [sym_lifetime] = STATE(827),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3294),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(2440),
    [sym_scoped_identifier] = STATE(2214),
    [sym_scoped_type_identifier] = STATE(2100),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2109),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(427),
    [sym_block_comment] = STATE(427),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_LPAREN] = ACTIONS(1266),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1276),
    [anon_sym_i8] = ACTIONS(1276),
    [anon_sym_u16] = ACTIONS(1276),
    [anon_sym_i16] = ACTIONS(1276),
    [anon_sym_u32] = ACTIONS(1276),
    [anon_sym_i32] = ACTIONS(1276),
    [anon_sym_u64] = ACTIONS(1276),
    [anon_sym_i64] = ACTIONS(1276),
    [anon_sym_u128] = ACTIONS(1276),
    [anon_sym_i128] = ACTIONS(1276),
    [anon_sym_isize] = ACTIONS(1276),
    [anon_sym_usize] = ACTIONS(1276),
    [anon_sym_f32] = ACTIONS(1276),
    [anon_sym_f64] = ACTIONS(1276),
    [anon_sym_bool] = ACTIONS(1276),
    [anon_sym_str] = ACTIONS(1276),
    [anon_sym_char] = ACTIONS(1276),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1528),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(1294),
    [anon_sym_SQUOTE] = ACTIONS(1298),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1302),
    [anon_sym_default] = ACTIONS(1304),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1312),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_ref] = ACTIONS(1316),
    [anon_sym_dyn] = ACTIONS(1318),
    [sym_mutable_specifier] = ACTIONS(1542),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1544),
    [sym_super] = ACTIONS(1330),
    [sym_crate] = ACTIONS(1330),
    [sym_metavariable] = ACTIONS(1332),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [428] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1960),
    [sym_bracketed_type] = STATE(3518),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3086),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(2390),
    [sym_scoped_identifier] = STATE(2160),
    [sym_scoped_type_identifier] = STATE(2100),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2091),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(428),
    [sym_block_comment] = STATE(428),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(1504),
    [anon_sym_LPAREN] = ACTIONS(1506),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1510),
    [anon_sym_i8] = ACTIONS(1510),
    [anon_sym_u16] = ACTIONS(1510),
    [anon_sym_i16] = ACTIONS(1510),
    [anon_sym_u32] = ACTIONS(1510),
    [anon_sym_i32] = ACTIONS(1510),
    [anon_sym_u64] = ACTIONS(1510),
    [anon_sym_i64] = ACTIONS(1510),
    [anon_sym_u128] = ACTIONS(1510),
    [anon_sym_i128] = ACTIONS(1510),
    [anon_sym_isize] = ACTIONS(1510),
    [anon_sym_usize] = ACTIONS(1510),
    [anon_sym_f32] = ACTIONS(1510),
    [anon_sym_f64] = ACTIONS(1510),
    [anon_sym_bool] = ACTIONS(1510),
    [anon_sym_str] = ACTIONS(1510),
    [anon_sym_char] = ACTIONS(1510),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1512),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(1516),
    [anon_sym_SQUOTE] = ACTIONS(1298),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1302),
    [anon_sym_default] = ACTIONS(1518),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1520),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_ref] = ACTIONS(1316),
    [anon_sym_dyn] = ACTIONS(1318),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1522),
    [sym_super] = ACTIONS(1522),
    [sym_crate] = ACTIONS(1522),
    [sym_metavariable] = ACTIONS(1524),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [429] = {
    [sym_line_comment] = STATE(429),
    [sym_block_comment] = STATE(429),
    [sym_identifier] = ACTIONS(1546),
    [anon_sym_SEMI] = ACTIONS(1548),
    [anon_sym_LPAREN] = ACTIONS(1548),
    [anon_sym_RPAREN] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_RBRACK] = ACTIONS(1548),
    [anon_sym_LBRACE] = ACTIONS(1548),
    [anon_sym_RBRACE] = ACTIONS(1548),
    [anon_sym_COLON] = ACTIONS(1546),
    [anon_sym_PLUS] = ACTIONS(1546),
    [anon_sym_STAR] = ACTIONS(1546),
    [anon_sym_QMARK] = ACTIONS(1548),
    [anon_sym_u8] = ACTIONS(1546),
    [anon_sym_i8] = ACTIONS(1546),
    [anon_sym_u16] = ACTIONS(1546),
    [anon_sym_i16] = ACTIONS(1546),
    [anon_sym_u32] = ACTIONS(1546),
    [anon_sym_i32] = ACTIONS(1546),
    [anon_sym_u64] = ACTIONS(1546),
    [anon_sym_i64] = ACTIONS(1546),
    [anon_sym_u128] = ACTIONS(1546),
    [anon_sym_i128] = ACTIONS(1546),
    [anon_sym_isize] = ACTIONS(1546),
    [anon_sym_usize] = ACTIONS(1546),
    [anon_sym_f32] = ACTIONS(1546),
    [anon_sym_f64] = ACTIONS(1546),
    [anon_sym_bool] = ACTIONS(1546),
    [anon_sym_str] = ACTIONS(1546),
    [anon_sym_char] = ACTIONS(1546),
    [anon_sym_DASH] = ACTIONS(1546),
    [anon_sym_SLASH] = ACTIONS(1546),
    [anon_sym_PERCENT] = ACTIONS(1546),
    [anon_sym_CARET] = ACTIONS(1546),
    [anon_sym_BANG] = ACTIONS(1546),
    [anon_sym_AMP] = ACTIONS(1546),
    [anon_sym_PIPE] = ACTIONS(1546),
    [anon_sym_AMP_AMP] = ACTIONS(1548),
    [anon_sym_PIPE_PIPE] = ACTIONS(1548),
    [anon_sym_LT_LT] = ACTIONS(1546),
    [anon_sym_GT_GT] = ACTIONS(1546),
    [anon_sym_PLUS_EQ] = ACTIONS(1548),
    [anon_sym_DASH_EQ] = ACTIONS(1548),
    [anon_sym_STAR_EQ] = ACTIONS(1548),
    [anon_sym_SLASH_EQ] = ACTIONS(1548),
    [anon_sym_PERCENT_EQ] = ACTIONS(1548),
    [anon_sym_CARET_EQ] = ACTIONS(1548),
    [anon_sym_AMP_EQ] = ACTIONS(1548),
    [anon_sym_PIPE_EQ] = ACTIONS(1548),
    [anon_sym_LT_LT_EQ] = ACTIONS(1548),
    [anon_sym_GT_GT_EQ] = ACTIONS(1548),
    [anon_sym_EQ] = ACTIONS(1546),
    [anon_sym_EQ_EQ] = ACTIONS(1548),
    [anon_sym_BANG_EQ] = ACTIONS(1548),
    [anon_sym_GT] = ACTIONS(1546),
    [anon_sym_LT] = ACTIONS(1546),
    [anon_sym_GT_EQ] = ACTIONS(1548),
    [anon_sym_LT_EQ] = ACTIONS(1548),
    [anon_sym_DOT] = ACTIONS(1546),
    [anon_sym_DOT_DOT] = ACTIONS(1546),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1548),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1548),
    [anon_sym_COMMA] = ACTIONS(1548),
    [anon_sym_COLON_COLON] = ACTIONS(1548),
    [anon_sym_SQUOTE] = ACTIONS(1546),
    [anon_sym_as] = ACTIONS(1546),
    [anon_sym_async] = ACTIONS(1546),
    [anon_sym_break] = ACTIONS(1546),
    [anon_sym_const] = ACTIONS(1546),
    [anon_sym_continue] = ACTIONS(1546),
    [anon_sym_default] = ACTIONS(1546),
    [anon_sym_for] = ACTIONS(1546),
    [anon_sym_if] = ACTIONS(1546),
    [anon_sym_loop] = ACTIONS(1546),
    [anon_sym_match] = ACTIONS(1546),
    [anon_sym_return] = ACTIONS(1546),
    [anon_sym_static] = ACTIONS(1546),
    [anon_sym_union] = ACTIONS(1546),
    [anon_sym_unsafe] = ACTIONS(1546),
    [anon_sym_while] = ACTIONS(1546),
    [anon_sym_else] = ACTIONS(1546),
    [anon_sym_yield] = ACTIONS(1546),
    [anon_sym_move] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1546),
    [sym_integer_literal] = ACTIONS(1548),
    [aux_sym_string_literal_token1] = ACTIONS(1548),
    [sym_char_literal] = ACTIONS(1548),
    [anon_sym_true] = ACTIONS(1546),
    [anon_sym_false] = ACTIONS(1546),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1546),
    [sym_super] = ACTIONS(1546),
    [sym_crate] = ACTIONS(1546),
    [sym_metavariable] = ACTIONS(1548),
    [sym__raw_string_literal_start] = ACTIONS(1548),
    [sym_float_literal] = ACTIONS(1548),
  },
  [430] = {
    [sym_line_comment] = STATE(430),
    [sym_block_comment] = STATE(430),
    [sym_identifier] = ACTIONS(1546),
    [anon_sym_LPAREN] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_LBRACE] = ACTIONS(1548),
    [anon_sym_EQ_GT] = ACTIONS(1548),
    [anon_sym_COLON] = ACTIONS(1546),
    [anon_sym_PLUS] = ACTIONS(1546),
    [anon_sym_STAR] = ACTIONS(1546),
    [anon_sym_QMARK] = ACTIONS(1548),
    [anon_sym_u8] = ACTIONS(1546),
    [anon_sym_i8] = ACTIONS(1546),
    [anon_sym_u16] = ACTIONS(1546),
    [anon_sym_i16] = ACTIONS(1546),
    [anon_sym_u32] = ACTIONS(1546),
    [anon_sym_i32] = ACTIONS(1546),
    [anon_sym_u64] = ACTIONS(1546),
    [anon_sym_i64] = ACTIONS(1546),
    [anon_sym_u128] = ACTIONS(1546),
    [anon_sym_i128] = ACTIONS(1546),
    [anon_sym_isize] = ACTIONS(1546),
    [anon_sym_usize] = ACTIONS(1546),
    [anon_sym_f32] = ACTIONS(1546),
    [anon_sym_f64] = ACTIONS(1546),
    [anon_sym_bool] = ACTIONS(1546),
    [anon_sym_str] = ACTIONS(1546),
    [anon_sym_char] = ACTIONS(1546),
    [anon_sym_DASH] = ACTIONS(1546),
    [anon_sym_SLASH] = ACTIONS(1546),
    [anon_sym_PERCENT] = ACTIONS(1546),
    [anon_sym_CARET] = ACTIONS(1546),
    [anon_sym_BANG] = ACTIONS(1546),
    [anon_sym_AMP] = ACTIONS(1546),
    [anon_sym_PIPE] = ACTIONS(1546),
    [anon_sym_AMP_AMP] = ACTIONS(1548),
    [anon_sym_PIPE_PIPE] = ACTIONS(1548),
    [anon_sym_LT_LT] = ACTIONS(1546),
    [anon_sym_GT_GT] = ACTIONS(1546),
    [anon_sym_PLUS_EQ] = ACTIONS(1548),
    [anon_sym_DASH_EQ] = ACTIONS(1548),
    [anon_sym_STAR_EQ] = ACTIONS(1548),
    [anon_sym_SLASH_EQ] = ACTIONS(1548),
    [anon_sym_PERCENT_EQ] = ACTIONS(1548),
    [anon_sym_CARET_EQ] = ACTIONS(1548),
    [anon_sym_AMP_EQ] = ACTIONS(1548),
    [anon_sym_PIPE_EQ] = ACTIONS(1548),
    [anon_sym_LT_LT_EQ] = ACTIONS(1548),
    [anon_sym_GT_GT_EQ] = ACTIONS(1548),
    [anon_sym_EQ] = ACTIONS(1546),
    [anon_sym_EQ_EQ] = ACTIONS(1548),
    [anon_sym_BANG_EQ] = ACTIONS(1548),
    [anon_sym_GT] = ACTIONS(1546),
    [anon_sym_LT] = ACTIONS(1546),
    [anon_sym_GT_EQ] = ACTIONS(1548),
    [anon_sym_LT_EQ] = ACTIONS(1548),
    [anon_sym_DOT] = ACTIONS(1546),
    [anon_sym_DOT_DOT] = ACTIONS(1546),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1548),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1548),
    [anon_sym_COLON_COLON] = ACTIONS(1548),
    [anon_sym_SQUOTE] = ACTIONS(1546),
    [anon_sym_as] = ACTIONS(1546),
    [anon_sym_async] = ACTIONS(1546),
    [anon_sym_break] = ACTIONS(1546),
    [anon_sym_const] = ACTIONS(1546),
    [anon_sym_continue] = ACTIONS(1546),
    [anon_sym_default] = ACTIONS(1546),
    [anon_sym_for] = ACTIONS(1546),
    [anon_sym_if] = ACTIONS(1546),
    [anon_sym_loop] = ACTIONS(1546),
    [anon_sym_match] = ACTIONS(1546),
    [anon_sym_return] = ACTIONS(1546),
    [anon_sym_static] = ACTIONS(1546),
    [anon_sym_union] = ACTIONS(1546),
    [anon_sym_unsafe] = ACTIONS(1546),
    [anon_sym_while] = ACTIONS(1546),
    [anon_sym_yield] = ACTIONS(1546),
    [anon_sym_move] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1546),
    [sym_integer_literal] = ACTIONS(1548),
    [aux_sym_string_literal_token1] = ACTIONS(1548),
    [sym_char_literal] = ACTIONS(1548),
    [anon_sym_true] = ACTIONS(1546),
    [anon_sym_false] = ACTIONS(1546),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1546),
    [sym_super] = ACTIONS(1546),
    [sym_crate] = ACTIONS(1546),
    [sym_metavariable] = ACTIONS(1548),
    [sym__raw_string_literal_start] = ACTIONS(1548),
    [sym_float_literal] = ACTIONS(1548),
  },
  [431] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2106),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(431),
    [sym_block_comment] = STATE(431),
    [sym_identifier] = ACTIONS(1550),
    [anon_sym_LPAREN] = ACTIONS(1552),
    [anon_sym_LBRACK] = ACTIONS(1552),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [anon_sym_STAR] = ACTIONS(1552),
    [anon_sym_u8] = ACTIONS(1550),
    [anon_sym_i8] = ACTIONS(1550),
    [anon_sym_u16] = ACTIONS(1550),
    [anon_sym_i16] = ACTIONS(1550),
    [anon_sym_u32] = ACTIONS(1550),
    [anon_sym_i32] = ACTIONS(1550),
    [anon_sym_u64] = ACTIONS(1550),
    [anon_sym_i64] = ACTIONS(1550),
    [anon_sym_u128] = ACTIONS(1550),
    [anon_sym_i128] = ACTIONS(1550),
    [anon_sym_isize] = ACTIONS(1550),
    [anon_sym_usize] = ACTIONS(1550),
    [anon_sym_f32] = ACTIONS(1550),
    [anon_sym_f64] = ACTIONS(1550),
    [anon_sym_bool] = ACTIONS(1550),
    [anon_sym_str] = ACTIONS(1550),
    [anon_sym_char] = ACTIONS(1550),
    [anon_sym_DASH] = ACTIONS(1550),
    [anon_sym_BANG] = ACTIONS(1552),
    [anon_sym_AMP] = ACTIONS(1552),
    [anon_sym_PIPE] = ACTIONS(1552),
    [anon_sym_LT] = ACTIONS(1552),
    [anon_sym__] = ACTIONS(1550),
    [anon_sym_DOT_DOT] = ACTIONS(1552),
    [anon_sym_COLON_COLON] = ACTIONS(1552),
    [anon_sym_DASH_GT] = ACTIONS(1552),
    [anon_sym_SQUOTE] = ACTIONS(1550),
    [anon_sym_async] = ACTIONS(1550),
    [anon_sym_break] = ACTIONS(1550),
    [anon_sym_const] = ACTIONS(1550),
    [anon_sym_continue] = ACTIONS(1550),
    [anon_sym_default] = ACTIONS(1550),
    [anon_sym_for] = ACTIONS(1550),
    [anon_sym_if] = ACTIONS(1550),
    [anon_sym_loop] = ACTIONS(1550),
    [anon_sym_match] = ACTIONS(1550),
    [anon_sym_return] = ACTIONS(1550),
    [anon_sym_static] = ACTIONS(1550),
    [anon_sym_union] = ACTIONS(1550),
    [anon_sym_unsafe] = ACTIONS(1550),
    [anon_sym_while] = ACTIONS(1550),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(1488),
    [anon_sym_yield] = ACTIONS(1550),
    [anon_sym_move] = ACTIONS(1550),
    [anon_sym_try] = ACTIONS(1550),
    [sym_integer_literal] = ACTIONS(1552),
    [aux_sym_string_literal_token1] = ACTIONS(1552),
    [sym_char_literal] = ACTIONS(1552),
    [anon_sym_true] = ACTIONS(1550),
    [anon_sym_false] = ACTIONS(1550),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1550),
    [sym_super] = ACTIONS(1550),
    [sym_crate] = ACTIONS(1550),
    [sym_metavariable] = ACTIONS(1552),
    [sym__raw_string_literal_start] = ACTIONS(1552),
    [sym_float_literal] = ACTIONS(1552),
  },
  [432] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2110),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(432),
    [sym_block_comment] = STATE(432),
    [sym_identifier] = ACTIONS(1554),
    [anon_sym_LPAREN] = ACTIONS(1556),
    [anon_sym_LBRACK] = ACTIONS(1556),
    [anon_sym_LBRACE] = ACTIONS(1556),
    [anon_sym_STAR] = ACTIONS(1556),
    [anon_sym_u8] = ACTIONS(1554),
    [anon_sym_i8] = ACTIONS(1554),
    [anon_sym_u16] = ACTIONS(1554),
    [anon_sym_i16] = ACTIONS(1554),
    [anon_sym_u32] = ACTIONS(1554),
    [anon_sym_i32] = ACTIONS(1554),
    [anon_sym_u64] = ACTIONS(1554),
    [anon_sym_i64] = ACTIONS(1554),
    [anon_sym_u128] = ACTIONS(1554),
    [anon_sym_i128] = ACTIONS(1554),
    [anon_sym_isize] = ACTIONS(1554),
    [anon_sym_usize] = ACTIONS(1554),
    [anon_sym_f32] = ACTIONS(1554),
    [anon_sym_f64] = ACTIONS(1554),
    [anon_sym_bool] = ACTIONS(1554),
    [anon_sym_str] = ACTIONS(1554),
    [anon_sym_char] = ACTIONS(1554),
    [anon_sym_DASH] = ACTIONS(1554),
    [anon_sym_BANG] = ACTIONS(1556),
    [anon_sym_AMP] = ACTIONS(1556),
    [anon_sym_PIPE] = ACTIONS(1556),
    [anon_sym_LT] = ACTIONS(1556),
    [anon_sym__] = ACTIONS(1554),
    [anon_sym_DOT_DOT] = ACTIONS(1556),
    [anon_sym_COLON_COLON] = ACTIONS(1556),
    [anon_sym_DASH_GT] = ACTIONS(1556),
    [anon_sym_SQUOTE] = ACTIONS(1554),
    [anon_sym_async] = ACTIONS(1554),
    [anon_sym_break] = ACTIONS(1554),
    [anon_sym_const] = ACTIONS(1554),
    [anon_sym_continue] = ACTIONS(1554),
    [anon_sym_default] = ACTIONS(1554),
    [anon_sym_for] = ACTIONS(1554),
    [anon_sym_if] = ACTIONS(1554),
    [anon_sym_loop] = ACTIONS(1554),
    [anon_sym_match] = ACTIONS(1554),
    [anon_sym_return] = ACTIONS(1554),
    [anon_sym_static] = ACTIONS(1554),
    [anon_sym_union] = ACTIONS(1554),
    [anon_sym_unsafe] = ACTIONS(1554),
    [anon_sym_while] = ACTIONS(1554),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(1488),
    [anon_sym_yield] = ACTIONS(1554),
    [anon_sym_move] = ACTIONS(1554),
    [anon_sym_try] = ACTIONS(1554),
    [sym_integer_literal] = ACTIONS(1556),
    [aux_sym_string_literal_token1] = ACTIONS(1556),
    [sym_char_literal] = ACTIONS(1556),
    [anon_sym_true] = ACTIONS(1554),
    [anon_sym_false] = ACTIONS(1554),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1554),
    [sym_super] = ACTIONS(1554),
    [sym_crate] = ACTIONS(1554),
    [sym_metavariable] = ACTIONS(1556),
    [sym__raw_string_literal_start] = ACTIONS(1556),
    [sym_float_literal] = ACTIONS(1556),
  },
  [433] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2437),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(2438),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_type_binding] = STATE(2685),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_label] = STATE(3572),
    [sym_block] = STATE(2685),
    [sym__literal] = STATE(2685),
    [sym_string_literal] = STATE(2835),
    [sym_raw_string_literal] = STATE(2835),
    [sym_boolean_literal] = STATE(2835),
    [sym_line_comment] = STATE(433),
    [sym_block_comment] = STATE(433),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(1558),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_LBRACE] = ACTIONS(1564),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_GT] = ACTIONS(1570),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(1574),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [sym_integer_literal] = ACTIONS(1580),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1580),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1580),
  },
  [434] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2437),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(2438),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_type_binding] = STATE(2685),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_label] = STATE(3572),
    [sym_block] = STATE(2685),
    [sym__literal] = STATE(2685),
    [sym_string_literal] = STATE(2835),
    [sym_raw_string_literal] = STATE(2835),
    [sym_boolean_literal] = STATE(2835),
    [sym_line_comment] = STATE(434),
    [sym_block_comment] = STATE(434),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(1558),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_LBRACE] = ACTIONS(1564),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_GT] = ACTIONS(1586),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(1574),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [sym_integer_literal] = ACTIONS(1580),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1580),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1580),
  },
  [435] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2437),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(2438),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_type_binding] = STATE(2685),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_label] = STATE(3572),
    [sym_block] = STATE(2685),
    [sym__literal] = STATE(2685),
    [sym_string_literal] = STATE(2835),
    [sym_raw_string_literal] = STATE(2835),
    [sym_boolean_literal] = STATE(2835),
    [sym_line_comment] = STATE(435),
    [sym_block_comment] = STATE(435),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(1558),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_LBRACE] = ACTIONS(1564),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_GT] = ACTIONS(1588),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(1574),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [sym_integer_literal] = ACTIONS(1580),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1580),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1580),
  },
  [436] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2437),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(2438),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_type_binding] = STATE(2685),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_label] = STATE(3572),
    [sym_block] = STATE(2685),
    [sym__literal] = STATE(2685),
    [sym_string_literal] = STATE(2835),
    [sym_raw_string_literal] = STATE(2835),
    [sym_boolean_literal] = STATE(2835),
    [sym_line_comment] = STATE(436),
    [sym_block_comment] = STATE(436),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(1558),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_LBRACE] = ACTIONS(1564),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_GT] = ACTIONS(1590),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(1574),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [sym_integer_literal] = ACTIONS(1580),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1580),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1580),
  },
  [437] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2437),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(2438),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_type_binding] = STATE(2685),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_label] = STATE(3572),
    [sym_block] = STATE(2685),
    [sym__literal] = STATE(2685),
    [sym_string_literal] = STATE(2835),
    [sym_raw_string_literal] = STATE(2835),
    [sym_boolean_literal] = STATE(2835),
    [sym_line_comment] = STATE(437),
    [sym_block_comment] = STATE(437),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(1558),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_LBRACE] = ACTIONS(1564),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_GT] = ACTIONS(1592),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(1574),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [sym_integer_literal] = ACTIONS(1580),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1580),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1580),
  },
  [438] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2437),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(2438),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_type_binding] = STATE(2685),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_label] = STATE(3572),
    [sym_block] = STATE(2685),
    [sym__literal] = STATE(2685),
    [sym_string_literal] = STATE(2835),
    [sym_raw_string_literal] = STATE(2835),
    [sym_boolean_literal] = STATE(2835),
    [sym_line_comment] = STATE(438),
    [sym_block_comment] = STATE(438),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(1558),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_LBRACE] = ACTIONS(1564),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_GT] = ACTIONS(1594),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(1574),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [sym_integer_literal] = ACTIONS(1580),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1580),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1580),
  },
  [439] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2437),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(2438),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_type_binding] = STATE(2685),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_label] = STATE(3572),
    [sym_block] = STATE(2685),
    [sym__literal] = STATE(2685),
    [sym_string_literal] = STATE(2835),
    [sym_raw_string_literal] = STATE(2835),
    [sym_boolean_literal] = STATE(2835),
    [sym_line_comment] = STATE(439),
    [sym_block_comment] = STATE(439),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(1558),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_LBRACE] = ACTIONS(1564),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_GT] = ACTIONS(1596),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(1574),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [sym_integer_literal] = ACTIONS(1580),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1580),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1580),
  },
  [440] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2437),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(2438),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_type_binding] = STATE(2685),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_label] = STATE(3572),
    [sym_block] = STATE(2685),
    [sym__literal] = STATE(2685),
    [sym_string_literal] = STATE(2835),
    [sym_raw_string_literal] = STATE(2835),
    [sym_boolean_literal] = STATE(2835),
    [sym_line_comment] = STATE(440),
    [sym_block_comment] = STATE(440),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(1558),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_LBRACE] = ACTIONS(1564),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_GT] = ACTIONS(1598),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(1574),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [sym_integer_literal] = ACTIONS(1580),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1580),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1580),
  },
  [441] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2437),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(2438),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_type_binding] = STATE(2685),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_label] = STATE(3572),
    [sym_block] = STATE(2685),
    [sym__literal] = STATE(2685),
    [sym_string_literal] = STATE(2835),
    [sym_raw_string_literal] = STATE(2835),
    [sym_boolean_literal] = STATE(2835),
    [sym_line_comment] = STATE(441),
    [sym_block_comment] = STATE(441),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(1558),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_LBRACE] = ACTIONS(1564),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_GT] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(1574),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [sym_integer_literal] = ACTIONS(1580),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1580),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1580),
  },
  [442] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2437),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(2438),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_type_binding] = STATE(2685),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_label] = STATE(3572),
    [sym_block] = STATE(2685),
    [sym__literal] = STATE(2685),
    [sym_string_literal] = STATE(2835),
    [sym_raw_string_literal] = STATE(2835),
    [sym_boolean_literal] = STATE(2835),
    [sym_line_comment] = STATE(442),
    [sym_block_comment] = STATE(442),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(1558),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_LBRACE] = ACTIONS(1564),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(1574),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [sym_integer_literal] = ACTIONS(1580),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1580),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1580),
  },
  [443] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2366),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(2370),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_type_binding] = STATE(2385),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_label] = STATE(3572),
    [sym_block] = STATE(2385),
    [sym__literal] = STATE(2385),
    [sym_string_literal] = STATE(2835),
    [sym_raw_string_literal] = STATE(2835),
    [sym_boolean_literal] = STATE(2835),
    [sym_line_comment] = STATE(443),
    [sym_block_comment] = STATE(443),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(1558),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_LBRACE] = ACTIONS(1564),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(1574),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [sym_integer_literal] = ACTIONS(1580),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1580),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1580),
  },
  [444] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2354),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(2358),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_type_binding] = STATE(2396),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_label] = STATE(3572),
    [sym_block] = STATE(2396),
    [sym__literal] = STATE(2396),
    [sym_string_literal] = STATE(2835),
    [sym_raw_string_literal] = STATE(2835),
    [sym_boolean_literal] = STATE(2835),
    [sym_line_comment] = STATE(444),
    [sym_block_comment] = STATE(444),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(1558),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_LBRACE] = ACTIONS(1564),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(1574),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [sym_integer_literal] = ACTIONS(1580),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1580),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1580),
  },
  [445] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2361),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(2360),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_type_binding] = STATE(2407),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_label] = STATE(3572),
    [sym_block] = STATE(2407),
    [sym__literal] = STATE(2407),
    [sym_string_literal] = STATE(2835),
    [sym_raw_string_literal] = STATE(2835),
    [sym_boolean_literal] = STATE(2835),
    [sym_line_comment] = STATE(445),
    [sym_block_comment] = STATE(445),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(1558),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_LBRACE] = ACTIONS(1564),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(1574),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [sym_integer_literal] = ACTIONS(1580),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1580),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1580),
  },
  [446] = {
    [sym_else_clause] = STATE(465),
    [sym_line_comment] = STATE(446),
    [sym_block_comment] = STATE(446),
    [sym_identifier] = ACTIONS(1196),
    [anon_sym_LPAREN] = ACTIONS(1194),
    [anon_sym_LBRACK] = ACTIONS(1194),
    [anon_sym_RBRACE] = ACTIONS(1194),
    [anon_sym_PLUS] = ACTIONS(1196),
    [anon_sym_STAR] = ACTIONS(1196),
    [anon_sym_QMARK] = ACTIONS(1194),
    [anon_sym_u8] = ACTIONS(1196),
    [anon_sym_i8] = ACTIONS(1196),
    [anon_sym_u16] = ACTIONS(1196),
    [anon_sym_i16] = ACTIONS(1196),
    [anon_sym_u32] = ACTIONS(1196),
    [anon_sym_i32] = ACTIONS(1196),
    [anon_sym_u64] = ACTIONS(1196),
    [anon_sym_i64] = ACTIONS(1196),
    [anon_sym_u128] = ACTIONS(1196),
    [anon_sym_i128] = ACTIONS(1196),
    [anon_sym_isize] = ACTIONS(1196),
    [anon_sym_usize] = ACTIONS(1196),
    [anon_sym_f32] = ACTIONS(1196),
    [anon_sym_f64] = ACTIONS(1196),
    [anon_sym_bool] = ACTIONS(1196),
    [anon_sym_str] = ACTIONS(1196),
    [anon_sym_char] = ACTIONS(1196),
    [anon_sym_DASH] = ACTIONS(1196),
    [anon_sym_SLASH] = ACTIONS(1196),
    [anon_sym_PERCENT] = ACTIONS(1196),
    [anon_sym_CARET] = ACTIONS(1196),
    [anon_sym_AMP] = ACTIONS(1196),
    [anon_sym_PIPE] = ACTIONS(1196),
    [anon_sym_AMP_AMP] = ACTIONS(1194),
    [anon_sym_PIPE_PIPE] = ACTIONS(1194),
    [anon_sym_LT_LT] = ACTIONS(1196),
    [anon_sym_GT_GT] = ACTIONS(1196),
    [anon_sym_PLUS_EQ] = ACTIONS(1194),
    [anon_sym_DASH_EQ] = ACTIONS(1194),
    [anon_sym_STAR_EQ] = ACTIONS(1194),
    [anon_sym_SLASH_EQ] = ACTIONS(1194),
    [anon_sym_PERCENT_EQ] = ACTIONS(1194),
    [anon_sym_CARET_EQ] = ACTIONS(1194),
    [anon_sym_AMP_EQ] = ACTIONS(1194),
    [anon_sym_PIPE_EQ] = ACTIONS(1194),
    [anon_sym_LT_LT_EQ] = ACTIONS(1194),
    [anon_sym_GT_GT_EQ] = ACTIONS(1194),
    [anon_sym_EQ] = ACTIONS(1196),
    [anon_sym_EQ_EQ] = ACTIONS(1194),
    [anon_sym_BANG_EQ] = ACTIONS(1194),
    [anon_sym_GT] = ACTIONS(1196),
    [anon_sym_LT] = ACTIONS(1196),
    [anon_sym_GT_EQ] = ACTIONS(1194),
    [anon_sym_LT_EQ] = ACTIONS(1194),
    [anon_sym__] = ACTIONS(1196),
    [anon_sym_DOT] = ACTIONS(1196),
    [anon_sym_DOT_DOT] = ACTIONS(1196),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1194),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1194),
    [anon_sym_COMMA] = ACTIONS(1194),
    [anon_sym_COLON_COLON] = ACTIONS(1194),
    [anon_sym_POUND] = ACTIONS(1194),
    [anon_sym_as] = ACTIONS(1196),
    [anon_sym_const] = ACTIONS(1196),
    [anon_sym_default] = ACTIONS(1196),
    [anon_sym_union] = ACTIONS(1196),
    [anon_sym_ref] = ACTIONS(1196),
    [anon_sym_else] = ACTIONS(1602),
    [sym_mutable_specifier] = ACTIONS(1196),
    [sym_integer_literal] = ACTIONS(1194),
    [aux_sym_string_literal_token1] = ACTIONS(1194),
    [sym_char_literal] = ACTIONS(1194),
    [anon_sym_true] = ACTIONS(1196),
    [anon_sym_false] = ACTIONS(1196),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1196),
    [sym_super] = ACTIONS(1196),
    [sym_crate] = ACTIONS(1196),
    [sym_metavariable] = ACTIONS(1194),
    [sym__raw_string_literal_start] = ACTIONS(1194),
    [sym_float_literal] = ACTIONS(1194),
  },
  [447] = {
    [sym_line_comment] = STATE(447),
    [sym_block_comment] = STATE(447),
    [sym_identifier] = ACTIONS(1246),
    [anon_sym_LPAREN] = ACTIONS(1244),
    [anon_sym_LBRACK] = ACTIONS(1244),
    [anon_sym_RBRACE] = ACTIONS(1244),
    [anon_sym_PLUS] = ACTIONS(1246),
    [anon_sym_STAR] = ACTIONS(1246),
    [anon_sym_QMARK] = ACTIONS(1244),
    [anon_sym_u8] = ACTIONS(1246),
    [anon_sym_i8] = ACTIONS(1246),
    [anon_sym_u16] = ACTIONS(1246),
    [anon_sym_i16] = ACTIONS(1246),
    [anon_sym_u32] = ACTIONS(1246),
    [anon_sym_i32] = ACTIONS(1246),
    [anon_sym_u64] = ACTIONS(1246),
    [anon_sym_i64] = ACTIONS(1246),
    [anon_sym_u128] = ACTIONS(1246),
    [anon_sym_i128] = ACTIONS(1246),
    [anon_sym_isize] = ACTIONS(1246),
    [anon_sym_usize] = ACTIONS(1246),
    [anon_sym_f32] = ACTIONS(1246),
    [anon_sym_f64] = ACTIONS(1246),
    [anon_sym_bool] = ACTIONS(1246),
    [anon_sym_str] = ACTIONS(1246),
    [anon_sym_char] = ACTIONS(1246),
    [anon_sym_DASH] = ACTIONS(1246),
    [anon_sym_SLASH] = ACTIONS(1246),
    [anon_sym_PERCENT] = ACTIONS(1246),
    [anon_sym_CARET] = ACTIONS(1246),
    [anon_sym_AMP] = ACTIONS(1246),
    [anon_sym_PIPE] = ACTIONS(1246),
    [anon_sym_AMP_AMP] = ACTIONS(1244),
    [anon_sym_PIPE_PIPE] = ACTIONS(1244),
    [anon_sym_LT_LT] = ACTIONS(1246),
    [anon_sym_GT_GT] = ACTIONS(1246),
    [anon_sym_PLUS_EQ] = ACTIONS(1244),
    [anon_sym_DASH_EQ] = ACTIONS(1244),
    [anon_sym_STAR_EQ] = ACTIONS(1244),
    [anon_sym_SLASH_EQ] = ACTIONS(1244),
    [anon_sym_PERCENT_EQ] = ACTIONS(1244),
    [anon_sym_CARET_EQ] = ACTIONS(1244),
    [anon_sym_AMP_EQ] = ACTIONS(1244),
    [anon_sym_PIPE_EQ] = ACTIONS(1244),
    [anon_sym_LT_LT_EQ] = ACTIONS(1244),
    [anon_sym_GT_GT_EQ] = ACTIONS(1244),
    [anon_sym_EQ] = ACTIONS(1246),
    [anon_sym_EQ_EQ] = ACTIONS(1244),
    [anon_sym_BANG_EQ] = ACTIONS(1244),
    [anon_sym_GT] = ACTIONS(1246),
    [anon_sym_LT] = ACTIONS(1246),
    [anon_sym_GT_EQ] = ACTIONS(1244),
    [anon_sym_LT_EQ] = ACTIONS(1244),
    [anon_sym__] = ACTIONS(1246),
    [anon_sym_DOT] = ACTIONS(1246),
    [anon_sym_DOT_DOT] = ACTIONS(1246),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1244),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1244),
    [anon_sym_COMMA] = ACTIONS(1244),
    [anon_sym_COLON_COLON] = ACTIONS(1244),
    [anon_sym_POUND] = ACTIONS(1244),
    [anon_sym_as] = ACTIONS(1246),
    [anon_sym_const] = ACTIONS(1246),
    [anon_sym_default] = ACTIONS(1246),
    [anon_sym_union] = ACTIONS(1246),
    [anon_sym_ref] = ACTIONS(1246),
    [anon_sym_else] = ACTIONS(1246),
    [sym_mutable_specifier] = ACTIONS(1246),
    [sym_integer_literal] = ACTIONS(1244),
    [aux_sym_string_literal_token1] = ACTIONS(1244),
    [sym_char_literal] = ACTIONS(1244),
    [anon_sym_true] = ACTIONS(1246),
    [anon_sym_false] = ACTIONS(1246),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1246),
    [sym_super] = ACTIONS(1246),
    [sym_crate] = ACTIONS(1246),
    [sym_metavariable] = ACTIONS(1244),
    [sym__raw_string_literal_start] = ACTIONS(1244),
    [sym_float_literal] = ACTIONS(1244),
  },
  [448] = {
    [sym_line_comment] = STATE(448),
    [sym_block_comment] = STATE(448),
    [sym_identifier] = ACTIONS(1242),
    [anon_sym_LPAREN] = ACTIONS(1240),
    [anon_sym_LBRACK] = ACTIONS(1240),
    [anon_sym_RBRACE] = ACTIONS(1240),
    [anon_sym_PLUS] = ACTIONS(1242),
    [anon_sym_STAR] = ACTIONS(1242),
    [anon_sym_QMARK] = ACTIONS(1240),
    [anon_sym_u8] = ACTIONS(1242),
    [anon_sym_i8] = ACTIONS(1242),
    [anon_sym_u16] = ACTIONS(1242),
    [anon_sym_i16] = ACTIONS(1242),
    [anon_sym_u32] = ACTIONS(1242),
    [anon_sym_i32] = ACTIONS(1242),
    [anon_sym_u64] = ACTIONS(1242),
    [anon_sym_i64] = ACTIONS(1242),
    [anon_sym_u128] = ACTIONS(1242),
    [anon_sym_i128] = ACTIONS(1242),
    [anon_sym_isize] = ACTIONS(1242),
    [anon_sym_usize] = ACTIONS(1242),
    [anon_sym_f32] = ACTIONS(1242),
    [anon_sym_f64] = ACTIONS(1242),
    [anon_sym_bool] = ACTIONS(1242),
    [anon_sym_str] = ACTIONS(1242),
    [anon_sym_char] = ACTIONS(1242),
    [anon_sym_DASH] = ACTIONS(1242),
    [anon_sym_SLASH] = ACTIONS(1242),
    [anon_sym_PERCENT] = ACTIONS(1242),
    [anon_sym_CARET] = ACTIONS(1242),
    [anon_sym_AMP] = ACTIONS(1242),
    [anon_sym_PIPE] = ACTIONS(1242),
    [anon_sym_AMP_AMP] = ACTIONS(1240),
    [anon_sym_PIPE_PIPE] = ACTIONS(1240),
    [anon_sym_LT_LT] = ACTIONS(1242),
    [anon_sym_GT_GT] = ACTIONS(1242),
    [anon_sym_PLUS_EQ] = ACTIONS(1240),
    [anon_sym_DASH_EQ] = ACTIONS(1240),
    [anon_sym_STAR_EQ] = ACTIONS(1240),
    [anon_sym_SLASH_EQ] = ACTIONS(1240),
    [anon_sym_PERCENT_EQ] = ACTIONS(1240),
    [anon_sym_CARET_EQ] = ACTIONS(1240),
    [anon_sym_AMP_EQ] = ACTIONS(1240),
    [anon_sym_PIPE_EQ] = ACTIONS(1240),
    [anon_sym_LT_LT_EQ] = ACTIONS(1240),
    [anon_sym_GT_GT_EQ] = ACTIONS(1240),
    [anon_sym_EQ] = ACTIONS(1242),
    [anon_sym_EQ_EQ] = ACTIONS(1240),
    [anon_sym_BANG_EQ] = ACTIONS(1240),
    [anon_sym_GT] = ACTIONS(1242),
    [anon_sym_LT] = ACTIONS(1242),
    [anon_sym_GT_EQ] = ACTIONS(1240),
    [anon_sym_LT_EQ] = ACTIONS(1240),
    [anon_sym__] = ACTIONS(1242),
    [anon_sym_DOT] = ACTIONS(1242),
    [anon_sym_DOT_DOT] = ACTIONS(1242),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1240),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1240),
    [anon_sym_COMMA] = ACTIONS(1240),
    [anon_sym_COLON_COLON] = ACTIONS(1240),
    [anon_sym_POUND] = ACTIONS(1240),
    [anon_sym_as] = ACTIONS(1242),
    [anon_sym_const] = ACTIONS(1242),
    [anon_sym_default] = ACTIONS(1242),
    [anon_sym_union] = ACTIONS(1242),
    [anon_sym_ref] = ACTIONS(1242),
    [anon_sym_else] = ACTIONS(1242),
    [sym_mutable_specifier] = ACTIONS(1242),
    [sym_integer_literal] = ACTIONS(1240),
    [aux_sym_string_literal_token1] = ACTIONS(1240),
    [sym_char_literal] = ACTIONS(1240),
    [anon_sym_true] = ACTIONS(1242),
    [anon_sym_false] = ACTIONS(1242),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1242),
    [sym_super] = ACTIONS(1242),
    [sym_crate] = ACTIONS(1242),
    [sym_metavariable] = ACTIONS(1240),
    [sym__raw_string_literal_start] = ACTIONS(1240),
    [sym_float_literal] = ACTIONS(1240),
  },
  [449] = {
    [sym_line_comment] = STATE(449),
    [sym_block_comment] = STATE(449),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1228),
    [anon_sym_LBRACK] = ACTIONS(1228),
    [anon_sym_RBRACE] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(1230),
    [anon_sym_STAR] = ACTIONS(1230),
    [anon_sym_QMARK] = ACTIONS(1228),
    [anon_sym_u8] = ACTIONS(1230),
    [anon_sym_i8] = ACTIONS(1230),
    [anon_sym_u16] = ACTIONS(1230),
    [anon_sym_i16] = ACTIONS(1230),
    [anon_sym_u32] = ACTIONS(1230),
    [anon_sym_i32] = ACTIONS(1230),
    [anon_sym_u64] = ACTIONS(1230),
    [anon_sym_i64] = ACTIONS(1230),
    [anon_sym_u128] = ACTIONS(1230),
    [anon_sym_i128] = ACTIONS(1230),
    [anon_sym_isize] = ACTIONS(1230),
    [anon_sym_usize] = ACTIONS(1230),
    [anon_sym_f32] = ACTIONS(1230),
    [anon_sym_f64] = ACTIONS(1230),
    [anon_sym_bool] = ACTIONS(1230),
    [anon_sym_str] = ACTIONS(1230),
    [anon_sym_char] = ACTIONS(1230),
    [anon_sym_DASH] = ACTIONS(1230),
    [anon_sym_SLASH] = ACTIONS(1230),
    [anon_sym_PERCENT] = ACTIONS(1230),
    [anon_sym_CARET] = ACTIONS(1230),
    [anon_sym_AMP] = ACTIONS(1230),
    [anon_sym_PIPE] = ACTIONS(1230),
    [anon_sym_AMP_AMP] = ACTIONS(1228),
    [anon_sym_PIPE_PIPE] = ACTIONS(1228),
    [anon_sym_LT_LT] = ACTIONS(1230),
    [anon_sym_GT_GT] = ACTIONS(1230),
    [anon_sym_PLUS_EQ] = ACTIONS(1228),
    [anon_sym_DASH_EQ] = ACTIONS(1228),
    [anon_sym_STAR_EQ] = ACTIONS(1228),
    [anon_sym_SLASH_EQ] = ACTIONS(1228),
    [anon_sym_PERCENT_EQ] = ACTIONS(1228),
    [anon_sym_CARET_EQ] = ACTIONS(1228),
    [anon_sym_AMP_EQ] = ACTIONS(1228),
    [anon_sym_PIPE_EQ] = ACTIONS(1228),
    [anon_sym_LT_LT_EQ] = ACTIONS(1228),
    [anon_sym_GT_GT_EQ] = ACTIONS(1228),
    [anon_sym_EQ] = ACTIONS(1230),
    [anon_sym_EQ_EQ] = ACTIONS(1228),
    [anon_sym_BANG_EQ] = ACTIONS(1228),
    [anon_sym_GT] = ACTIONS(1230),
    [anon_sym_LT] = ACTIONS(1230),
    [anon_sym_GT_EQ] = ACTIONS(1228),
    [anon_sym_LT_EQ] = ACTIONS(1228),
    [anon_sym__] = ACTIONS(1230),
    [anon_sym_DOT] = ACTIONS(1230),
    [anon_sym_DOT_DOT] = ACTIONS(1230),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1228),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1228),
    [anon_sym_COMMA] = ACTIONS(1228),
    [anon_sym_COLON_COLON] = ACTIONS(1228),
    [anon_sym_POUND] = ACTIONS(1228),
    [anon_sym_as] = ACTIONS(1230),
    [anon_sym_const] = ACTIONS(1230),
    [anon_sym_default] = ACTIONS(1230),
    [anon_sym_union] = ACTIONS(1230),
    [anon_sym_ref] = ACTIONS(1230),
    [anon_sym_else] = ACTIONS(1230),
    [sym_mutable_specifier] = ACTIONS(1230),
    [sym_integer_literal] = ACTIONS(1228),
    [aux_sym_string_literal_token1] = ACTIONS(1228),
    [sym_char_literal] = ACTIONS(1228),
    [anon_sym_true] = ACTIONS(1230),
    [anon_sym_false] = ACTIONS(1230),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1230),
    [sym_super] = ACTIONS(1230),
    [sym_crate] = ACTIONS(1230),
    [sym_metavariable] = ACTIONS(1228),
    [sym__raw_string_literal_start] = ACTIONS(1228),
    [sym_float_literal] = ACTIONS(1228),
  },
  [450] = {
    [sym_line_comment] = STATE(450),
    [sym_block_comment] = STATE(450),
    [sym_identifier] = ACTIONS(1238),
    [anon_sym_LPAREN] = ACTIONS(1236),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_RBRACE] = ACTIONS(1236),
    [anon_sym_PLUS] = ACTIONS(1238),
    [anon_sym_STAR] = ACTIONS(1238),
    [anon_sym_QMARK] = ACTIONS(1236),
    [anon_sym_u8] = ACTIONS(1238),
    [anon_sym_i8] = ACTIONS(1238),
    [anon_sym_u16] = ACTIONS(1238),
    [anon_sym_i16] = ACTIONS(1238),
    [anon_sym_u32] = ACTIONS(1238),
    [anon_sym_i32] = ACTIONS(1238),
    [anon_sym_u64] = ACTIONS(1238),
    [anon_sym_i64] = ACTIONS(1238),
    [anon_sym_u128] = ACTIONS(1238),
    [anon_sym_i128] = ACTIONS(1238),
    [anon_sym_isize] = ACTIONS(1238),
    [anon_sym_usize] = ACTIONS(1238),
    [anon_sym_f32] = ACTIONS(1238),
    [anon_sym_f64] = ACTIONS(1238),
    [anon_sym_bool] = ACTIONS(1238),
    [anon_sym_str] = ACTIONS(1238),
    [anon_sym_char] = ACTIONS(1238),
    [anon_sym_DASH] = ACTIONS(1238),
    [anon_sym_SLASH] = ACTIONS(1238),
    [anon_sym_PERCENT] = ACTIONS(1238),
    [anon_sym_CARET] = ACTIONS(1238),
    [anon_sym_AMP] = ACTIONS(1238),
    [anon_sym_PIPE] = ACTIONS(1238),
    [anon_sym_AMP_AMP] = ACTIONS(1236),
    [anon_sym_PIPE_PIPE] = ACTIONS(1236),
    [anon_sym_LT_LT] = ACTIONS(1238),
    [anon_sym_GT_GT] = ACTIONS(1238),
    [anon_sym_PLUS_EQ] = ACTIONS(1236),
    [anon_sym_DASH_EQ] = ACTIONS(1236),
    [anon_sym_STAR_EQ] = ACTIONS(1236),
    [anon_sym_SLASH_EQ] = ACTIONS(1236),
    [anon_sym_PERCENT_EQ] = ACTIONS(1236),
    [anon_sym_CARET_EQ] = ACTIONS(1236),
    [anon_sym_AMP_EQ] = ACTIONS(1236),
    [anon_sym_PIPE_EQ] = ACTIONS(1236),
    [anon_sym_LT_LT_EQ] = ACTIONS(1236),
    [anon_sym_GT_GT_EQ] = ACTIONS(1236),
    [anon_sym_EQ] = ACTIONS(1238),
    [anon_sym_EQ_EQ] = ACTIONS(1236),
    [anon_sym_BANG_EQ] = ACTIONS(1236),
    [anon_sym_GT] = ACTIONS(1238),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_GT_EQ] = ACTIONS(1236),
    [anon_sym_LT_EQ] = ACTIONS(1236),
    [anon_sym__] = ACTIONS(1238),
    [anon_sym_DOT] = ACTIONS(1238),
    [anon_sym_DOT_DOT] = ACTIONS(1238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1236),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1236),
    [anon_sym_COMMA] = ACTIONS(1236),
    [anon_sym_COLON_COLON] = ACTIONS(1236),
    [anon_sym_POUND] = ACTIONS(1236),
    [anon_sym_as] = ACTIONS(1238),
    [anon_sym_const] = ACTIONS(1238),
    [anon_sym_default] = ACTIONS(1238),
    [anon_sym_union] = ACTIONS(1238),
    [anon_sym_ref] = ACTIONS(1238),
    [anon_sym_else] = ACTIONS(1238),
    [sym_mutable_specifier] = ACTIONS(1238),
    [sym_integer_literal] = ACTIONS(1236),
    [aux_sym_string_literal_token1] = ACTIONS(1236),
    [sym_char_literal] = ACTIONS(1236),
    [anon_sym_true] = ACTIONS(1238),
    [anon_sym_false] = ACTIONS(1238),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1238),
    [sym_super] = ACTIONS(1238),
    [sym_crate] = ACTIONS(1238),
    [sym_metavariable] = ACTIONS(1236),
    [sym__raw_string_literal_start] = ACTIONS(1236),
    [sym_float_literal] = ACTIONS(1236),
  },
  [451] = {
    [sym_line_comment] = STATE(451),
    [sym_block_comment] = STATE(451),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_LPAREN] = ACTIONS(1232),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_RBRACE] = ACTIONS(1232),
    [anon_sym_PLUS] = ACTIONS(1234),
    [anon_sym_STAR] = ACTIONS(1234),
    [anon_sym_QMARK] = ACTIONS(1232),
    [anon_sym_u8] = ACTIONS(1234),
    [anon_sym_i8] = ACTIONS(1234),
    [anon_sym_u16] = ACTIONS(1234),
    [anon_sym_i16] = ACTIONS(1234),
    [anon_sym_u32] = ACTIONS(1234),
    [anon_sym_i32] = ACTIONS(1234),
    [anon_sym_u64] = ACTIONS(1234),
    [anon_sym_i64] = ACTIONS(1234),
    [anon_sym_u128] = ACTIONS(1234),
    [anon_sym_i128] = ACTIONS(1234),
    [anon_sym_isize] = ACTIONS(1234),
    [anon_sym_usize] = ACTIONS(1234),
    [anon_sym_f32] = ACTIONS(1234),
    [anon_sym_f64] = ACTIONS(1234),
    [anon_sym_bool] = ACTIONS(1234),
    [anon_sym_str] = ACTIONS(1234),
    [anon_sym_char] = ACTIONS(1234),
    [anon_sym_DASH] = ACTIONS(1234),
    [anon_sym_SLASH] = ACTIONS(1234),
    [anon_sym_PERCENT] = ACTIONS(1234),
    [anon_sym_CARET] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(1234),
    [anon_sym_PIPE] = ACTIONS(1234),
    [anon_sym_AMP_AMP] = ACTIONS(1232),
    [anon_sym_PIPE_PIPE] = ACTIONS(1232),
    [anon_sym_LT_LT] = ACTIONS(1234),
    [anon_sym_GT_GT] = ACTIONS(1234),
    [anon_sym_PLUS_EQ] = ACTIONS(1232),
    [anon_sym_DASH_EQ] = ACTIONS(1232),
    [anon_sym_STAR_EQ] = ACTIONS(1232),
    [anon_sym_SLASH_EQ] = ACTIONS(1232),
    [anon_sym_PERCENT_EQ] = ACTIONS(1232),
    [anon_sym_CARET_EQ] = ACTIONS(1232),
    [anon_sym_AMP_EQ] = ACTIONS(1232),
    [anon_sym_PIPE_EQ] = ACTIONS(1232),
    [anon_sym_LT_LT_EQ] = ACTIONS(1232),
    [anon_sym_GT_GT_EQ] = ACTIONS(1232),
    [anon_sym_EQ] = ACTIONS(1234),
    [anon_sym_EQ_EQ] = ACTIONS(1232),
    [anon_sym_BANG_EQ] = ACTIONS(1232),
    [anon_sym_GT] = ACTIONS(1234),
    [anon_sym_LT] = ACTIONS(1234),
    [anon_sym_GT_EQ] = ACTIONS(1232),
    [anon_sym_LT_EQ] = ACTIONS(1232),
    [anon_sym__] = ACTIONS(1234),
    [anon_sym_DOT] = ACTIONS(1234),
    [anon_sym_DOT_DOT] = ACTIONS(1234),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1232),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1232),
    [anon_sym_COMMA] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(1232),
    [anon_sym_POUND] = ACTIONS(1232),
    [anon_sym_as] = ACTIONS(1234),
    [anon_sym_const] = ACTIONS(1234),
    [anon_sym_default] = ACTIONS(1234),
    [anon_sym_union] = ACTIONS(1234),
    [anon_sym_ref] = ACTIONS(1234),
    [anon_sym_else] = ACTIONS(1234),
    [sym_mutable_specifier] = ACTIONS(1234),
    [sym_integer_literal] = ACTIONS(1232),
    [aux_sym_string_literal_token1] = ACTIONS(1232),
    [sym_char_literal] = ACTIONS(1232),
    [anon_sym_true] = ACTIONS(1234),
    [anon_sym_false] = ACTIONS(1234),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1234),
    [sym_super] = ACTIONS(1234),
    [sym_crate] = ACTIONS(1234),
    [sym_metavariable] = ACTIONS(1232),
    [sym__raw_string_literal_start] = ACTIONS(1232),
    [sym_float_literal] = ACTIONS(1232),
  },
  [452] = {
    [sym_line_comment] = STATE(452),
    [sym_block_comment] = STATE(452),
    [sym_identifier] = ACTIONS(1250),
    [anon_sym_LPAREN] = ACTIONS(1248),
    [anon_sym_LBRACK] = ACTIONS(1248),
    [anon_sym_RBRACE] = ACTIONS(1248),
    [anon_sym_PLUS] = ACTIONS(1250),
    [anon_sym_STAR] = ACTIONS(1250),
    [anon_sym_QMARK] = ACTIONS(1248),
    [anon_sym_u8] = ACTIONS(1250),
    [anon_sym_i8] = ACTIONS(1250),
    [anon_sym_u16] = ACTIONS(1250),
    [anon_sym_i16] = ACTIONS(1250),
    [anon_sym_u32] = ACTIONS(1250),
    [anon_sym_i32] = ACTIONS(1250),
    [anon_sym_u64] = ACTIONS(1250),
    [anon_sym_i64] = ACTIONS(1250),
    [anon_sym_u128] = ACTIONS(1250),
    [anon_sym_i128] = ACTIONS(1250),
    [anon_sym_isize] = ACTIONS(1250),
    [anon_sym_usize] = ACTIONS(1250),
    [anon_sym_f32] = ACTIONS(1250),
    [anon_sym_f64] = ACTIONS(1250),
    [anon_sym_bool] = ACTIONS(1250),
    [anon_sym_str] = ACTIONS(1250),
    [anon_sym_char] = ACTIONS(1250),
    [anon_sym_DASH] = ACTIONS(1250),
    [anon_sym_SLASH] = ACTIONS(1250),
    [anon_sym_PERCENT] = ACTIONS(1250),
    [anon_sym_CARET] = ACTIONS(1250),
    [anon_sym_AMP] = ACTIONS(1250),
    [anon_sym_PIPE] = ACTIONS(1250),
    [anon_sym_AMP_AMP] = ACTIONS(1248),
    [anon_sym_PIPE_PIPE] = ACTIONS(1248),
    [anon_sym_LT_LT] = ACTIONS(1250),
    [anon_sym_GT_GT] = ACTIONS(1250),
    [anon_sym_PLUS_EQ] = ACTIONS(1248),
    [anon_sym_DASH_EQ] = ACTIONS(1248),
    [anon_sym_STAR_EQ] = ACTIONS(1248),
    [anon_sym_SLASH_EQ] = ACTIONS(1248),
    [anon_sym_PERCENT_EQ] = ACTIONS(1248),
    [anon_sym_CARET_EQ] = ACTIONS(1248),
    [anon_sym_AMP_EQ] = ACTIONS(1248),
    [anon_sym_PIPE_EQ] = ACTIONS(1248),
    [anon_sym_LT_LT_EQ] = ACTIONS(1248),
    [anon_sym_GT_GT_EQ] = ACTIONS(1248),
    [anon_sym_EQ] = ACTIONS(1250),
    [anon_sym_EQ_EQ] = ACTIONS(1248),
    [anon_sym_BANG_EQ] = ACTIONS(1248),
    [anon_sym_GT] = ACTIONS(1250),
    [anon_sym_LT] = ACTIONS(1250),
    [anon_sym_GT_EQ] = ACTIONS(1248),
    [anon_sym_LT_EQ] = ACTIONS(1248),
    [anon_sym__] = ACTIONS(1250),
    [anon_sym_DOT] = ACTIONS(1250),
    [anon_sym_DOT_DOT] = ACTIONS(1250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1248),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1248),
    [anon_sym_COMMA] = ACTIONS(1248),
    [anon_sym_COLON_COLON] = ACTIONS(1248),
    [anon_sym_POUND] = ACTIONS(1248),
    [anon_sym_as] = ACTIONS(1250),
    [anon_sym_const] = ACTIONS(1250),
    [anon_sym_default] = ACTIONS(1250),
    [anon_sym_union] = ACTIONS(1250),
    [anon_sym_ref] = ACTIONS(1250),
    [sym_mutable_specifier] = ACTIONS(1250),
    [sym_integer_literal] = ACTIONS(1248),
    [aux_sym_string_literal_token1] = ACTIONS(1248),
    [sym_char_literal] = ACTIONS(1248),
    [anon_sym_true] = ACTIONS(1250),
    [anon_sym_false] = ACTIONS(1250),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1250),
    [sym_super] = ACTIONS(1250),
    [sym_crate] = ACTIONS(1250),
    [sym_metavariable] = ACTIONS(1248),
    [sym__raw_string_literal_start] = ACTIONS(1248),
    [sym_float_literal] = ACTIONS(1248),
  },
  [453] = {
    [sym_line_comment] = STATE(453),
    [sym_block_comment] = STATE(453),
    [sym_identifier] = ACTIONS(1404),
    [anon_sym_LPAREN] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1402),
    [anon_sym_RBRACE] = ACTIONS(1402),
    [anon_sym_PLUS] = ACTIONS(1404),
    [anon_sym_STAR] = ACTIONS(1404),
    [anon_sym_QMARK] = ACTIONS(1402),
    [anon_sym_u8] = ACTIONS(1404),
    [anon_sym_i8] = ACTIONS(1404),
    [anon_sym_u16] = ACTIONS(1404),
    [anon_sym_i16] = ACTIONS(1404),
    [anon_sym_u32] = ACTIONS(1404),
    [anon_sym_i32] = ACTIONS(1404),
    [anon_sym_u64] = ACTIONS(1404),
    [anon_sym_i64] = ACTIONS(1404),
    [anon_sym_u128] = ACTIONS(1404),
    [anon_sym_i128] = ACTIONS(1404),
    [anon_sym_isize] = ACTIONS(1404),
    [anon_sym_usize] = ACTIONS(1404),
    [anon_sym_f32] = ACTIONS(1404),
    [anon_sym_f64] = ACTIONS(1404),
    [anon_sym_bool] = ACTIONS(1404),
    [anon_sym_str] = ACTIONS(1404),
    [anon_sym_char] = ACTIONS(1404),
    [anon_sym_DASH] = ACTIONS(1404),
    [anon_sym_SLASH] = ACTIONS(1404),
    [anon_sym_PERCENT] = ACTIONS(1404),
    [anon_sym_CARET] = ACTIONS(1404),
    [anon_sym_AMP] = ACTIONS(1404),
    [anon_sym_PIPE] = ACTIONS(1404),
    [anon_sym_AMP_AMP] = ACTIONS(1402),
    [anon_sym_PIPE_PIPE] = ACTIONS(1402),
    [anon_sym_LT_LT] = ACTIONS(1404),
    [anon_sym_GT_GT] = ACTIONS(1404),
    [anon_sym_PLUS_EQ] = ACTIONS(1402),
    [anon_sym_DASH_EQ] = ACTIONS(1402),
    [anon_sym_STAR_EQ] = ACTIONS(1402),
    [anon_sym_SLASH_EQ] = ACTIONS(1402),
    [anon_sym_PERCENT_EQ] = ACTIONS(1402),
    [anon_sym_CARET_EQ] = ACTIONS(1402),
    [anon_sym_AMP_EQ] = ACTIONS(1402),
    [anon_sym_PIPE_EQ] = ACTIONS(1402),
    [anon_sym_LT_LT_EQ] = ACTIONS(1402),
    [anon_sym_GT_GT_EQ] = ACTIONS(1402),
    [anon_sym_EQ] = ACTIONS(1404),
    [anon_sym_EQ_EQ] = ACTIONS(1402),
    [anon_sym_BANG_EQ] = ACTIONS(1402),
    [anon_sym_GT] = ACTIONS(1404),
    [anon_sym_LT] = ACTIONS(1404),
    [anon_sym_GT_EQ] = ACTIONS(1402),
    [anon_sym_LT_EQ] = ACTIONS(1402),
    [anon_sym__] = ACTIONS(1404),
    [anon_sym_DOT] = ACTIONS(1404),
    [anon_sym_DOT_DOT] = ACTIONS(1404),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1402),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1402),
    [anon_sym_COMMA] = ACTIONS(1402),
    [anon_sym_COLON_COLON] = ACTIONS(1402),
    [anon_sym_POUND] = ACTIONS(1402),
    [anon_sym_as] = ACTIONS(1404),
    [anon_sym_const] = ACTIONS(1404),
    [anon_sym_default] = ACTIONS(1404),
    [anon_sym_union] = ACTIONS(1404),
    [anon_sym_ref] = ACTIONS(1404),
    [sym_mutable_specifier] = ACTIONS(1404),
    [sym_integer_literal] = ACTIONS(1402),
    [aux_sym_string_literal_token1] = ACTIONS(1402),
    [sym_char_literal] = ACTIONS(1402),
    [anon_sym_true] = ACTIONS(1404),
    [anon_sym_false] = ACTIONS(1404),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1404),
    [sym_super] = ACTIONS(1404),
    [sym_crate] = ACTIONS(1404),
    [sym_metavariable] = ACTIONS(1402),
    [sym__raw_string_literal_start] = ACTIONS(1402),
    [sym_float_literal] = ACTIONS(1402),
  },
  [454] = {
    [sym_line_comment] = STATE(454),
    [sym_block_comment] = STATE(454),
    [sym_identifier] = ACTIONS(1448),
    [anon_sym_LPAREN] = ACTIONS(1446),
    [anon_sym_LBRACK] = ACTIONS(1446),
    [anon_sym_RBRACE] = ACTIONS(1446),
    [anon_sym_PLUS] = ACTIONS(1448),
    [anon_sym_STAR] = ACTIONS(1448),
    [anon_sym_QMARK] = ACTIONS(1446),
    [anon_sym_u8] = ACTIONS(1448),
    [anon_sym_i8] = ACTIONS(1448),
    [anon_sym_u16] = ACTIONS(1448),
    [anon_sym_i16] = ACTIONS(1448),
    [anon_sym_u32] = ACTIONS(1448),
    [anon_sym_i32] = ACTIONS(1448),
    [anon_sym_u64] = ACTIONS(1448),
    [anon_sym_i64] = ACTIONS(1448),
    [anon_sym_u128] = ACTIONS(1448),
    [anon_sym_i128] = ACTIONS(1448),
    [anon_sym_isize] = ACTIONS(1448),
    [anon_sym_usize] = ACTIONS(1448),
    [anon_sym_f32] = ACTIONS(1448),
    [anon_sym_f64] = ACTIONS(1448),
    [anon_sym_bool] = ACTIONS(1448),
    [anon_sym_str] = ACTIONS(1448),
    [anon_sym_char] = ACTIONS(1448),
    [anon_sym_DASH] = ACTIONS(1448),
    [anon_sym_SLASH] = ACTIONS(1448),
    [anon_sym_PERCENT] = ACTIONS(1448),
    [anon_sym_CARET] = ACTIONS(1448),
    [anon_sym_AMP] = ACTIONS(1448),
    [anon_sym_PIPE] = ACTIONS(1448),
    [anon_sym_AMP_AMP] = ACTIONS(1446),
    [anon_sym_PIPE_PIPE] = ACTIONS(1446),
    [anon_sym_LT_LT] = ACTIONS(1448),
    [anon_sym_GT_GT] = ACTIONS(1448),
    [anon_sym_PLUS_EQ] = ACTIONS(1446),
    [anon_sym_DASH_EQ] = ACTIONS(1446),
    [anon_sym_STAR_EQ] = ACTIONS(1446),
    [anon_sym_SLASH_EQ] = ACTIONS(1446),
    [anon_sym_PERCENT_EQ] = ACTIONS(1446),
    [anon_sym_CARET_EQ] = ACTIONS(1446),
    [anon_sym_AMP_EQ] = ACTIONS(1446),
    [anon_sym_PIPE_EQ] = ACTIONS(1446),
    [anon_sym_LT_LT_EQ] = ACTIONS(1446),
    [anon_sym_GT_GT_EQ] = ACTIONS(1446),
    [anon_sym_EQ] = ACTIONS(1448),
    [anon_sym_EQ_EQ] = ACTIONS(1446),
    [anon_sym_BANG_EQ] = ACTIONS(1446),
    [anon_sym_GT] = ACTIONS(1448),
    [anon_sym_LT] = ACTIONS(1448),
    [anon_sym_GT_EQ] = ACTIONS(1446),
    [anon_sym_LT_EQ] = ACTIONS(1446),
    [anon_sym__] = ACTIONS(1448),
    [anon_sym_DOT] = ACTIONS(1448),
    [anon_sym_DOT_DOT] = ACTIONS(1448),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1446),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1446),
    [anon_sym_COMMA] = ACTIONS(1446),
    [anon_sym_COLON_COLON] = ACTIONS(1446),
    [anon_sym_POUND] = ACTIONS(1446),
    [anon_sym_as] = ACTIONS(1448),
    [anon_sym_const] = ACTIONS(1448),
    [anon_sym_default] = ACTIONS(1448),
    [anon_sym_union] = ACTIONS(1448),
    [anon_sym_ref] = ACTIONS(1448),
    [sym_mutable_specifier] = ACTIONS(1448),
    [sym_integer_literal] = ACTIONS(1446),
    [aux_sym_string_literal_token1] = ACTIONS(1446),
    [sym_char_literal] = ACTIONS(1446),
    [anon_sym_true] = ACTIONS(1448),
    [anon_sym_false] = ACTIONS(1448),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1448),
    [sym_super] = ACTIONS(1448),
    [sym_crate] = ACTIONS(1448),
    [sym_metavariable] = ACTIONS(1446),
    [sym__raw_string_literal_start] = ACTIONS(1446),
    [sym_float_literal] = ACTIONS(1446),
  },
  [455] = {
    [sym_line_comment] = STATE(455),
    [sym_block_comment] = STATE(455),
    [sym_identifier] = ACTIONS(1604),
    [anon_sym_LPAREN] = ACTIONS(1606),
    [anon_sym_LBRACK] = ACTIONS(1606),
    [anon_sym_RBRACE] = ACTIONS(1346),
    [anon_sym_PLUS] = ACTIONS(1344),
    [anon_sym_STAR] = ACTIONS(1344),
    [anon_sym_QMARK] = ACTIONS(1346),
    [anon_sym_u8] = ACTIONS(1604),
    [anon_sym_i8] = ACTIONS(1604),
    [anon_sym_u16] = ACTIONS(1604),
    [anon_sym_i16] = ACTIONS(1604),
    [anon_sym_u32] = ACTIONS(1604),
    [anon_sym_i32] = ACTIONS(1604),
    [anon_sym_u64] = ACTIONS(1604),
    [anon_sym_i64] = ACTIONS(1604),
    [anon_sym_u128] = ACTIONS(1604),
    [anon_sym_i128] = ACTIONS(1604),
    [anon_sym_isize] = ACTIONS(1604),
    [anon_sym_usize] = ACTIONS(1604),
    [anon_sym_f32] = ACTIONS(1604),
    [anon_sym_f64] = ACTIONS(1604),
    [anon_sym_bool] = ACTIONS(1604),
    [anon_sym_str] = ACTIONS(1604),
    [anon_sym_char] = ACTIONS(1604),
    [anon_sym_DASH] = ACTIONS(1604),
    [anon_sym_SLASH] = ACTIONS(1344),
    [anon_sym_PERCENT] = ACTIONS(1344),
    [anon_sym_CARET] = ACTIONS(1344),
    [anon_sym_AMP] = ACTIONS(1604),
    [anon_sym_PIPE] = ACTIONS(1604),
    [anon_sym_AMP_AMP] = ACTIONS(1346),
    [anon_sym_PIPE_PIPE] = ACTIONS(1346),
    [anon_sym_LT_LT] = ACTIONS(1344),
    [anon_sym_GT_GT] = ACTIONS(1344),
    [anon_sym_PLUS_EQ] = ACTIONS(1346),
    [anon_sym_DASH_EQ] = ACTIONS(1346),
    [anon_sym_STAR_EQ] = ACTIONS(1346),
    [anon_sym_SLASH_EQ] = ACTIONS(1346),
    [anon_sym_PERCENT_EQ] = ACTIONS(1346),
    [anon_sym_CARET_EQ] = ACTIONS(1346),
    [anon_sym_AMP_EQ] = ACTIONS(1346),
    [anon_sym_PIPE_EQ] = ACTIONS(1346),
    [anon_sym_LT_LT_EQ] = ACTIONS(1346),
    [anon_sym_GT_GT_EQ] = ACTIONS(1346),
    [anon_sym_EQ] = ACTIONS(1344),
    [anon_sym_EQ_EQ] = ACTIONS(1346),
    [anon_sym_BANG_EQ] = ACTIONS(1346),
    [anon_sym_GT] = ACTIONS(1344),
    [anon_sym_LT] = ACTIONS(1604),
    [anon_sym_GT_EQ] = ACTIONS(1346),
    [anon_sym_LT_EQ] = ACTIONS(1346),
    [anon_sym__] = ACTIONS(1604),
    [anon_sym_DOT] = ACTIONS(1344),
    [anon_sym_DOT_DOT] = ACTIONS(1604),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1346),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1346),
    [anon_sym_COMMA] = ACTIONS(1346),
    [anon_sym_COLON_COLON] = ACTIONS(1606),
    [anon_sym_POUND] = ACTIONS(1606),
    [anon_sym_as] = ACTIONS(1344),
    [anon_sym_const] = ACTIONS(1604),
    [anon_sym_default] = ACTIONS(1604),
    [anon_sym_union] = ACTIONS(1604),
    [anon_sym_ref] = ACTIONS(1604),
    [sym_mutable_specifier] = ACTIONS(1604),
    [sym_integer_literal] = ACTIONS(1606),
    [aux_sym_string_literal_token1] = ACTIONS(1606),
    [sym_char_literal] = ACTIONS(1606),
    [anon_sym_true] = ACTIONS(1604),
    [anon_sym_false] = ACTIONS(1604),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1604),
    [sym_super] = ACTIONS(1604),
    [sym_crate] = ACTIONS(1604),
    [sym_metavariable] = ACTIONS(1606),
    [sym__raw_string_literal_start] = ACTIONS(1606),
    [sym_float_literal] = ACTIONS(1606),
  },
  [456] = {
    [sym_attribute_item] = STATE(1471),
    [sym_inner_attribute_item] = STATE(1471),
    [sym_bracketed_type] = STATE(3513),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3115),
    [sym_macro_invocation] = STATE(2834),
    [sym_scoped_identifier] = STATE(2137),
    [sym_scoped_type_identifier] = STATE(2851),
    [sym_match_arm] = STATE(1473),
    [sym_last_match_arm] = STATE(3394),
    [sym_match_pattern] = STATE(3355),
    [sym_const_block] = STATE(2834),
    [sym__pattern] = STATE(2828),
    [sym_tuple_pattern] = STATE(2834),
    [sym_slice_pattern] = STATE(2834),
    [sym_tuple_struct_pattern] = STATE(2834),
    [sym_struct_pattern] = STATE(2834),
    [sym_remaining_field_pattern] = STATE(2834),
    [sym_mut_pattern] = STATE(2834),
    [sym_range_pattern] = STATE(2834),
    [sym_ref_pattern] = STATE(2834),
    [sym_captured_pattern] = STATE(2834),
    [sym_reference_pattern] = STATE(2834),
    [sym_or_pattern] = STATE(2834),
    [sym__literal_pattern] = STATE(2336),
    [sym_negative_literal] = STATE(2345),
    [sym_string_literal] = STATE(2345),
    [sym_raw_string_literal] = STATE(2345),
    [sym_boolean_literal] = STATE(2345),
    [sym_line_comment] = STATE(456),
    [sym_block_comment] = STATE(456),
    [aux_sym_match_block_repeat1] = STATE(478),
    [aux_sym_match_arm_repeat1] = STATE(752),
    [sym_identifier] = ACTIONS(1608),
    [anon_sym_LPAREN] = ACTIONS(1610),
    [anon_sym_LBRACK] = ACTIONS(1612),
    [anon_sym_RBRACE] = ACTIONS(1614),
    [anon_sym_u8] = ACTIONS(1616),
    [anon_sym_i8] = ACTIONS(1616),
    [anon_sym_u16] = ACTIONS(1616),
    [anon_sym_i16] = ACTIONS(1616),
    [anon_sym_u32] = ACTIONS(1616),
    [anon_sym_i32] = ACTIONS(1616),
    [anon_sym_u64] = ACTIONS(1616),
    [anon_sym_i64] = ACTIONS(1616),
    [anon_sym_u128] = ACTIONS(1616),
    [anon_sym_i128] = ACTIONS(1616),
    [anon_sym_isize] = ACTIONS(1616),
    [anon_sym_usize] = ACTIONS(1616),
    [anon_sym_f32] = ACTIONS(1616),
    [anon_sym_f64] = ACTIONS(1616),
    [anon_sym_bool] = ACTIONS(1616),
    [anon_sym_str] = ACTIONS(1616),
    [anon_sym_char] = ACTIONS(1616),
    [anon_sym_DASH] = ACTIONS(1618),
    [anon_sym_AMP] = ACTIONS(1620),
    [anon_sym_PIPE] = ACTIONS(1622),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1624),
    [anon_sym_DOT_DOT] = ACTIONS(1626),
    [anon_sym_COLON_COLON] = ACTIONS(1628),
    [anon_sym_POUND] = ACTIONS(1630),
    [anon_sym_const] = ACTIONS(1632),
    [anon_sym_default] = ACTIONS(1634),
    [anon_sym_union] = ACTIONS(1634),
    [anon_sym_ref] = ACTIONS(1636),
    [sym_mutable_specifier] = ACTIONS(1638),
    [sym_integer_literal] = ACTIONS(1640),
    [aux_sym_string_literal_token1] = ACTIONS(1642),
    [sym_char_literal] = ACTIONS(1640),
    [anon_sym_true] = ACTIONS(1644),
    [anon_sym_false] = ACTIONS(1644),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1646),
    [sym_super] = ACTIONS(1646),
    [sym_crate] = ACTIONS(1646),
    [sym_metavariable] = ACTIONS(1648),
    [sym__raw_string_literal_start] = ACTIONS(1650),
    [sym_float_literal] = ACTIONS(1640),
  },
  [457] = {
    [sym_line_comment] = STATE(457),
    [sym_block_comment] = STATE(457),
    [sym_identifier] = ACTIONS(1426),
    [anon_sym_LPAREN] = ACTIONS(1424),
    [anon_sym_LBRACK] = ACTIONS(1424),
    [anon_sym_RBRACE] = ACTIONS(1424),
    [anon_sym_PLUS] = ACTIONS(1426),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_QMARK] = ACTIONS(1424),
    [anon_sym_u8] = ACTIONS(1426),
    [anon_sym_i8] = ACTIONS(1426),
    [anon_sym_u16] = ACTIONS(1426),
    [anon_sym_i16] = ACTIONS(1426),
    [anon_sym_u32] = ACTIONS(1426),
    [anon_sym_i32] = ACTIONS(1426),
    [anon_sym_u64] = ACTIONS(1426),
    [anon_sym_i64] = ACTIONS(1426),
    [anon_sym_u128] = ACTIONS(1426),
    [anon_sym_i128] = ACTIONS(1426),
    [anon_sym_isize] = ACTIONS(1426),
    [anon_sym_usize] = ACTIONS(1426),
    [anon_sym_f32] = ACTIONS(1426),
    [anon_sym_f64] = ACTIONS(1426),
    [anon_sym_bool] = ACTIONS(1426),
    [anon_sym_str] = ACTIONS(1426),
    [anon_sym_char] = ACTIONS(1426),
    [anon_sym_DASH] = ACTIONS(1426),
    [anon_sym_SLASH] = ACTIONS(1426),
    [anon_sym_PERCENT] = ACTIONS(1426),
    [anon_sym_CARET] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_PIPE] = ACTIONS(1426),
    [anon_sym_AMP_AMP] = ACTIONS(1424),
    [anon_sym_PIPE_PIPE] = ACTIONS(1424),
    [anon_sym_LT_LT] = ACTIONS(1426),
    [anon_sym_GT_GT] = ACTIONS(1426),
    [anon_sym_PLUS_EQ] = ACTIONS(1424),
    [anon_sym_DASH_EQ] = ACTIONS(1424),
    [anon_sym_STAR_EQ] = ACTIONS(1424),
    [anon_sym_SLASH_EQ] = ACTIONS(1424),
    [anon_sym_PERCENT_EQ] = ACTIONS(1424),
    [anon_sym_CARET_EQ] = ACTIONS(1424),
    [anon_sym_AMP_EQ] = ACTIONS(1424),
    [anon_sym_PIPE_EQ] = ACTIONS(1424),
    [anon_sym_LT_LT_EQ] = ACTIONS(1424),
    [anon_sym_GT_GT_EQ] = ACTIONS(1424),
    [anon_sym_EQ] = ACTIONS(1426),
    [anon_sym_EQ_EQ] = ACTIONS(1424),
    [anon_sym_BANG_EQ] = ACTIONS(1424),
    [anon_sym_GT] = ACTIONS(1426),
    [anon_sym_LT] = ACTIONS(1426),
    [anon_sym_GT_EQ] = ACTIONS(1424),
    [anon_sym_LT_EQ] = ACTIONS(1424),
    [anon_sym__] = ACTIONS(1426),
    [anon_sym_DOT] = ACTIONS(1426),
    [anon_sym_DOT_DOT] = ACTIONS(1426),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1424),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1424),
    [anon_sym_COMMA] = ACTIONS(1424),
    [anon_sym_COLON_COLON] = ACTIONS(1424),
    [anon_sym_POUND] = ACTIONS(1424),
    [anon_sym_as] = ACTIONS(1426),
    [anon_sym_const] = ACTIONS(1426),
    [anon_sym_default] = ACTIONS(1426),
    [anon_sym_union] = ACTIONS(1426),
    [anon_sym_ref] = ACTIONS(1426),
    [sym_mutable_specifier] = ACTIONS(1426),
    [sym_integer_literal] = ACTIONS(1424),
    [aux_sym_string_literal_token1] = ACTIONS(1424),
    [sym_char_literal] = ACTIONS(1424),
    [anon_sym_true] = ACTIONS(1426),
    [anon_sym_false] = ACTIONS(1426),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1426),
    [sym_super] = ACTIONS(1426),
    [sym_crate] = ACTIONS(1426),
    [sym_metavariable] = ACTIONS(1424),
    [sym__raw_string_literal_start] = ACTIONS(1424),
    [sym_float_literal] = ACTIONS(1424),
  },
  [458] = {
    [sym_line_comment] = STATE(458),
    [sym_block_comment] = STATE(458),
    [sym_identifier] = ACTIONS(1652),
    [anon_sym_LPAREN] = ACTIONS(1654),
    [anon_sym_LBRACK] = ACTIONS(1654),
    [anon_sym_RBRACE] = ACTIONS(1346),
    [anon_sym_PLUS] = ACTIONS(1344),
    [anon_sym_STAR] = ACTIONS(1344),
    [anon_sym_QMARK] = ACTIONS(1346),
    [anon_sym_u8] = ACTIONS(1652),
    [anon_sym_i8] = ACTIONS(1652),
    [anon_sym_u16] = ACTIONS(1652),
    [anon_sym_i16] = ACTIONS(1652),
    [anon_sym_u32] = ACTIONS(1652),
    [anon_sym_i32] = ACTIONS(1652),
    [anon_sym_u64] = ACTIONS(1652),
    [anon_sym_i64] = ACTIONS(1652),
    [anon_sym_u128] = ACTIONS(1652),
    [anon_sym_i128] = ACTIONS(1652),
    [anon_sym_isize] = ACTIONS(1652),
    [anon_sym_usize] = ACTIONS(1652),
    [anon_sym_f32] = ACTIONS(1652),
    [anon_sym_f64] = ACTIONS(1652),
    [anon_sym_bool] = ACTIONS(1652),
    [anon_sym_str] = ACTIONS(1652),
    [anon_sym_char] = ACTIONS(1652),
    [anon_sym_DASH] = ACTIONS(1652),
    [anon_sym_SLASH] = ACTIONS(1344),
    [anon_sym_PERCENT] = ACTIONS(1344),
    [anon_sym_CARET] = ACTIONS(1344),
    [anon_sym_AMP] = ACTIONS(1652),
    [anon_sym_PIPE] = ACTIONS(1652),
    [anon_sym_AMP_AMP] = ACTIONS(1346),
    [anon_sym_PIPE_PIPE] = ACTIONS(1346),
    [anon_sym_LT_LT] = ACTIONS(1344),
    [anon_sym_GT_GT] = ACTIONS(1344),
    [anon_sym_PLUS_EQ] = ACTIONS(1346),
    [anon_sym_DASH_EQ] = ACTIONS(1346),
    [anon_sym_STAR_EQ] = ACTIONS(1346),
    [anon_sym_SLASH_EQ] = ACTIONS(1346),
    [anon_sym_PERCENT_EQ] = ACTIONS(1346),
    [anon_sym_CARET_EQ] = ACTIONS(1346),
    [anon_sym_AMP_EQ] = ACTIONS(1346),
    [anon_sym_PIPE_EQ] = ACTIONS(1346),
    [anon_sym_LT_LT_EQ] = ACTIONS(1346),
    [anon_sym_GT_GT_EQ] = ACTIONS(1346),
    [anon_sym_EQ] = ACTIONS(1344),
    [anon_sym_EQ_EQ] = ACTIONS(1346),
    [anon_sym_BANG_EQ] = ACTIONS(1346),
    [anon_sym_GT] = ACTIONS(1344),
    [anon_sym_LT] = ACTIONS(1652),
    [anon_sym_GT_EQ] = ACTIONS(1346),
    [anon_sym_LT_EQ] = ACTIONS(1346),
    [anon_sym__] = ACTIONS(1652),
    [anon_sym_DOT] = ACTIONS(1344),
    [anon_sym_DOT_DOT] = ACTIONS(1652),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1346),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1346),
    [anon_sym_COMMA] = ACTIONS(1346),
    [anon_sym_COLON_COLON] = ACTIONS(1654),
    [anon_sym_POUND] = ACTIONS(1654),
    [anon_sym_as] = ACTIONS(1344),
    [anon_sym_const] = ACTIONS(1652),
    [anon_sym_default] = ACTIONS(1652),
    [anon_sym_union] = ACTIONS(1652),
    [anon_sym_ref] = ACTIONS(1652),
    [sym_mutable_specifier] = ACTIONS(1652),
    [sym_integer_literal] = ACTIONS(1654),
    [aux_sym_string_literal_token1] = ACTIONS(1654),
    [sym_char_literal] = ACTIONS(1654),
    [anon_sym_true] = ACTIONS(1652),
    [anon_sym_false] = ACTIONS(1652),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1652),
    [sym_super] = ACTIONS(1652),
    [sym_crate] = ACTIONS(1652),
    [sym_metavariable] = ACTIONS(1654),
    [sym__raw_string_literal_start] = ACTIONS(1654),
    [sym_float_literal] = ACTIONS(1654),
  },
  [459] = {
    [sym_line_comment] = STATE(459),
    [sym_block_comment] = STATE(459),
    [sym_identifier] = ACTIONS(1422),
    [anon_sym_LPAREN] = ACTIONS(1420),
    [anon_sym_LBRACK] = ACTIONS(1420),
    [anon_sym_RBRACE] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1422),
    [anon_sym_STAR] = ACTIONS(1422),
    [anon_sym_QMARK] = ACTIONS(1420),
    [anon_sym_u8] = ACTIONS(1422),
    [anon_sym_i8] = ACTIONS(1422),
    [anon_sym_u16] = ACTIONS(1422),
    [anon_sym_i16] = ACTIONS(1422),
    [anon_sym_u32] = ACTIONS(1422),
    [anon_sym_i32] = ACTIONS(1422),
    [anon_sym_u64] = ACTIONS(1422),
    [anon_sym_i64] = ACTIONS(1422),
    [anon_sym_u128] = ACTIONS(1422),
    [anon_sym_i128] = ACTIONS(1422),
    [anon_sym_isize] = ACTIONS(1422),
    [anon_sym_usize] = ACTIONS(1422),
    [anon_sym_f32] = ACTIONS(1422),
    [anon_sym_f64] = ACTIONS(1422),
    [anon_sym_bool] = ACTIONS(1422),
    [anon_sym_str] = ACTIONS(1422),
    [anon_sym_char] = ACTIONS(1422),
    [anon_sym_DASH] = ACTIONS(1422),
    [anon_sym_SLASH] = ACTIONS(1422),
    [anon_sym_PERCENT] = ACTIONS(1422),
    [anon_sym_CARET] = ACTIONS(1422),
    [anon_sym_AMP] = ACTIONS(1422),
    [anon_sym_PIPE] = ACTIONS(1422),
    [anon_sym_AMP_AMP] = ACTIONS(1420),
    [anon_sym_PIPE_PIPE] = ACTIONS(1420),
    [anon_sym_LT_LT] = ACTIONS(1422),
    [anon_sym_GT_GT] = ACTIONS(1422),
    [anon_sym_PLUS_EQ] = ACTIONS(1420),
    [anon_sym_DASH_EQ] = ACTIONS(1420),
    [anon_sym_STAR_EQ] = ACTIONS(1420),
    [anon_sym_SLASH_EQ] = ACTIONS(1420),
    [anon_sym_PERCENT_EQ] = ACTIONS(1420),
    [anon_sym_CARET_EQ] = ACTIONS(1420),
    [anon_sym_AMP_EQ] = ACTIONS(1420),
    [anon_sym_PIPE_EQ] = ACTIONS(1420),
    [anon_sym_LT_LT_EQ] = ACTIONS(1420),
    [anon_sym_GT_GT_EQ] = ACTIONS(1420),
    [anon_sym_EQ] = ACTIONS(1422),
    [anon_sym_EQ_EQ] = ACTIONS(1420),
    [anon_sym_BANG_EQ] = ACTIONS(1420),
    [anon_sym_GT] = ACTIONS(1422),
    [anon_sym_LT] = ACTIONS(1422),
    [anon_sym_GT_EQ] = ACTIONS(1420),
    [anon_sym_LT_EQ] = ACTIONS(1420),
    [anon_sym__] = ACTIONS(1422),
    [anon_sym_DOT] = ACTIONS(1422),
    [anon_sym_DOT_DOT] = ACTIONS(1422),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1420),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1420),
    [anon_sym_COMMA] = ACTIONS(1420),
    [anon_sym_COLON_COLON] = ACTIONS(1420),
    [anon_sym_POUND] = ACTIONS(1420),
    [anon_sym_as] = ACTIONS(1422),
    [anon_sym_const] = ACTIONS(1422),
    [anon_sym_default] = ACTIONS(1422),
    [anon_sym_union] = ACTIONS(1422),
    [anon_sym_ref] = ACTIONS(1422),
    [sym_mutable_specifier] = ACTIONS(1422),
    [sym_integer_literal] = ACTIONS(1420),
    [aux_sym_string_literal_token1] = ACTIONS(1420),
    [sym_char_literal] = ACTIONS(1420),
    [anon_sym_true] = ACTIONS(1422),
    [anon_sym_false] = ACTIONS(1422),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1422),
    [sym_super] = ACTIONS(1422),
    [sym_crate] = ACTIONS(1422),
    [sym_metavariable] = ACTIONS(1420),
    [sym__raw_string_literal_start] = ACTIONS(1420),
    [sym_float_literal] = ACTIONS(1420),
  },
  [460] = {
    [sym_line_comment] = STATE(460),
    [sym_block_comment] = STATE(460),
    [sym_identifier] = ACTIONS(1262),
    [anon_sym_LPAREN] = ACTIONS(1260),
    [anon_sym_LBRACK] = ACTIONS(1260),
    [anon_sym_RBRACE] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(1262),
    [anon_sym_STAR] = ACTIONS(1262),
    [anon_sym_QMARK] = ACTIONS(1260),
    [anon_sym_u8] = ACTIONS(1262),
    [anon_sym_i8] = ACTIONS(1262),
    [anon_sym_u16] = ACTIONS(1262),
    [anon_sym_i16] = ACTIONS(1262),
    [anon_sym_u32] = ACTIONS(1262),
    [anon_sym_i32] = ACTIONS(1262),
    [anon_sym_u64] = ACTIONS(1262),
    [anon_sym_i64] = ACTIONS(1262),
    [anon_sym_u128] = ACTIONS(1262),
    [anon_sym_i128] = ACTIONS(1262),
    [anon_sym_isize] = ACTIONS(1262),
    [anon_sym_usize] = ACTIONS(1262),
    [anon_sym_f32] = ACTIONS(1262),
    [anon_sym_f64] = ACTIONS(1262),
    [anon_sym_bool] = ACTIONS(1262),
    [anon_sym_str] = ACTIONS(1262),
    [anon_sym_char] = ACTIONS(1262),
    [anon_sym_DASH] = ACTIONS(1262),
    [anon_sym_SLASH] = ACTIONS(1262),
    [anon_sym_PERCENT] = ACTIONS(1262),
    [anon_sym_CARET] = ACTIONS(1262),
    [anon_sym_AMP] = ACTIONS(1262),
    [anon_sym_PIPE] = ACTIONS(1262),
    [anon_sym_AMP_AMP] = ACTIONS(1260),
    [anon_sym_PIPE_PIPE] = ACTIONS(1260),
    [anon_sym_LT_LT] = ACTIONS(1262),
    [anon_sym_GT_GT] = ACTIONS(1262),
    [anon_sym_PLUS_EQ] = ACTIONS(1260),
    [anon_sym_DASH_EQ] = ACTIONS(1260),
    [anon_sym_STAR_EQ] = ACTIONS(1260),
    [anon_sym_SLASH_EQ] = ACTIONS(1260),
    [anon_sym_PERCENT_EQ] = ACTIONS(1260),
    [anon_sym_CARET_EQ] = ACTIONS(1260),
    [anon_sym_AMP_EQ] = ACTIONS(1260),
    [anon_sym_PIPE_EQ] = ACTIONS(1260),
    [anon_sym_LT_LT_EQ] = ACTIONS(1260),
    [anon_sym_GT_GT_EQ] = ACTIONS(1260),
    [anon_sym_EQ] = ACTIONS(1262),
    [anon_sym_EQ_EQ] = ACTIONS(1260),
    [anon_sym_BANG_EQ] = ACTIONS(1260),
    [anon_sym_GT] = ACTIONS(1262),
    [anon_sym_LT] = ACTIONS(1262),
    [anon_sym_GT_EQ] = ACTIONS(1260),
    [anon_sym_LT_EQ] = ACTIONS(1260),
    [anon_sym__] = ACTIONS(1262),
    [anon_sym_DOT] = ACTIONS(1262),
    [anon_sym_DOT_DOT] = ACTIONS(1262),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1260),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1260),
    [anon_sym_COMMA] = ACTIONS(1260),
    [anon_sym_COLON_COLON] = ACTIONS(1260),
    [anon_sym_POUND] = ACTIONS(1260),
    [anon_sym_as] = ACTIONS(1262),
    [anon_sym_const] = ACTIONS(1262),
    [anon_sym_default] = ACTIONS(1262),
    [anon_sym_union] = ACTIONS(1262),
    [anon_sym_ref] = ACTIONS(1262),
    [sym_mutable_specifier] = ACTIONS(1262),
    [sym_integer_literal] = ACTIONS(1260),
    [aux_sym_string_literal_token1] = ACTIONS(1260),
    [sym_char_literal] = ACTIONS(1260),
    [anon_sym_true] = ACTIONS(1262),
    [anon_sym_false] = ACTIONS(1262),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1262),
    [sym_super] = ACTIONS(1262),
    [sym_crate] = ACTIONS(1262),
    [sym_metavariable] = ACTIONS(1260),
    [sym__raw_string_literal_start] = ACTIONS(1260),
    [sym_float_literal] = ACTIONS(1260),
  },
  [461] = {
    [sym_line_comment] = STATE(461),
    [sym_block_comment] = STATE(461),
    [sym_identifier] = ACTIONS(1418),
    [anon_sym_LPAREN] = ACTIONS(1416),
    [anon_sym_LBRACK] = ACTIONS(1416),
    [anon_sym_RBRACE] = ACTIONS(1416),
    [anon_sym_PLUS] = ACTIONS(1418),
    [anon_sym_STAR] = ACTIONS(1418),
    [anon_sym_QMARK] = ACTIONS(1416),
    [anon_sym_u8] = ACTIONS(1418),
    [anon_sym_i8] = ACTIONS(1418),
    [anon_sym_u16] = ACTIONS(1418),
    [anon_sym_i16] = ACTIONS(1418),
    [anon_sym_u32] = ACTIONS(1418),
    [anon_sym_i32] = ACTIONS(1418),
    [anon_sym_u64] = ACTIONS(1418),
    [anon_sym_i64] = ACTIONS(1418),
    [anon_sym_u128] = ACTIONS(1418),
    [anon_sym_i128] = ACTIONS(1418),
    [anon_sym_isize] = ACTIONS(1418),
    [anon_sym_usize] = ACTIONS(1418),
    [anon_sym_f32] = ACTIONS(1418),
    [anon_sym_f64] = ACTIONS(1418),
    [anon_sym_bool] = ACTIONS(1418),
    [anon_sym_str] = ACTIONS(1418),
    [anon_sym_char] = ACTIONS(1418),
    [anon_sym_DASH] = ACTIONS(1418),
    [anon_sym_SLASH] = ACTIONS(1418),
    [anon_sym_PERCENT] = ACTIONS(1418),
    [anon_sym_CARET] = ACTIONS(1418),
    [anon_sym_AMP] = ACTIONS(1418),
    [anon_sym_PIPE] = ACTIONS(1418),
    [anon_sym_AMP_AMP] = ACTIONS(1416),
    [anon_sym_PIPE_PIPE] = ACTIONS(1416),
    [anon_sym_LT_LT] = ACTIONS(1418),
    [anon_sym_GT_GT] = ACTIONS(1418),
    [anon_sym_PLUS_EQ] = ACTIONS(1416),
    [anon_sym_DASH_EQ] = ACTIONS(1416),
    [anon_sym_STAR_EQ] = ACTIONS(1416),
    [anon_sym_SLASH_EQ] = ACTIONS(1416),
    [anon_sym_PERCENT_EQ] = ACTIONS(1416),
    [anon_sym_CARET_EQ] = ACTIONS(1416),
    [anon_sym_AMP_EQ] = ACTIONS(1416),
    [anon_sym_PIPE_EQ] = ACTIONS(1416),
    [anon_sym_LT_LT_EQ] = ACTIONS(1416),
    [anon_sym_GT_GT_EQ] = ACTIONS(1416),
    [anon_sym_EQ] = ACTIONS(1418),
    [anon_sym_EQ_EQ] = ACTIONS(1416),
    [anon_sym_BANG_EQ] = ACTIONS(1416),
    [anon_sym_GT] = ACTIONS(1418),
    [anon_sym_LT] = ACTIONS(1418),
    [anon_sym_GT_EQ] = ACTIONS(1416),
    [anon_sym_LT_EQ] = ACTIONS(1416),
    [anon_sym__] = ACTIONS(1418),
    [anon_sym_DOT] = ACTIONS(1418),
    [anon_sym_DOT_DOT] = ACTIONS(1418),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1416),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1416),
    [anon_sym_COMMA] = ACTIONS(1416),
    [anon_sym_COLON_COLON] = ACTIONS(1416),
    [anon_sym_POUND] = ACTIONS(1416),
    [anon_sym_as] = ACTIONS(1418),
    [anon_sym_const] = ACTIONS(1418),
    [anon_sym_default] = ACTIONS(1418),
    [anon_sym_union] = ACTIONS(1418),
    [anon_sym_ref] = ACTIONS(1418),
    [sym_mutable_specifier] = ACTIONS(1418),
    [sym_integer_literal] = ACTIONS(1416),
    [aux_sym_string_literal_token1] = ACTIONS(1416),
    [sym_char_literal] = ACTIONS(1416),
    [anon_sym_true] = ACTIONS(1418),
    [anon_sym_false] = ACTIONS(1418),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1418),
    [sym_super] = ACTIONS(1418),
    [sym_crate] = ACTIONS(1418),
    [sym_metavariable] = ACTIONS(1416),
    [sym__raw_string_literal_start] = ACTIONS(1416),
    [sym_float_literal] = ACTIONS(1416),
  },
  [462] = {
    [sym_line_comment] = STATE(462),
    [sym_block_comment] = STATE(462),
    [sym_identifier] = ACTIONS(1384),
    [anon_sym_LPAREN] = ACTIONS(1382),
    [anon_sym_LBRACK] = ACTIONS(1382),
    [anon_sym_RBRACE] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(1384),
    [anon_sym_STAR] = ACTIONS(1384),
    [anon_sym_QMARK] = ACTIONS(1382),
    [anon_sym_u8] = ACTIONS(1384),
    [anon_sym_i8] = ACTIONS(1384),
    [anon_sym_u16] = ACTIONS(1384),
    [anon_sym_i16] = ACTIONS(1384),
    [anon_sym_u32] = ACTIONS(1384),
    [anon_sym_i32] = ACTIONS(1384),
    [anon_sym_u64] = ACTIONS(1384),
    [anon_sym_i64] = ACTIONS(1384),
    [anon_sym_u128] = ACTIONS(1384),
    [anon_sym_i128] = ACTIONS(1384),
    [anon_sym_isize] = ACTIONS(1384),
    [anon_sym_usize] = ACTIONS(1384),
    [anon_sym_f32] = ACTIONS(1384),
    [anon_sym_f64] = ACTIONS(1384),
    [anon_sym_bool] = ACTIONS(1384),
    [anon_sym_str] = ACTIONS(1384),
    [anon_sym_char] = ACTIONS(1384),
    [anon_sym_DASH] = ACTIONS(1384),
    [anon_sym_SLASH] = ACTIONS(1384),
    [anon_sym_PERCENT] = ACTIONS(1384),
    [anon_sym_CARET] = ACTIONS(1384),
    [anon_sym_AMP] = ACTIONS(1384),
    [anon_sym_PIPE] = ACTIONS(1384),
    [anon_sym_AMP_AMP] = ACTIONS(1382),
    [anon_sym_PIPE_PIPE] = ACTIONS(1382),
    [anon_sym_LT_LT] = ACTIONS(1384),
    [anon_sym_GT_GT] = ACTIONS(1384),
    [anon_sym_PLUS_EQ] = ACTIONS(1382),
    [anon_sym_DASH_EQ] = ACTIONS(1382),
    [anon_sym_STAR_EQ] = ACTIONS(1382),
    [anon_sym_SLASH_EQ] = ACTIONS(1382),
    [anon_sym_PERCENT_EQ] = ACTIONS(1382),
    [anon_sym_CARET_EQ] = ACTIONS(1382),
    [anon_sym_AMP_EQ] = ACTIONS(1382),
    [anon_sym_PIPE_EQ] = ACTIONS(1382),
    [anon_sym_LT_LT_EQ] = ACTIONS(1382),
    [anon_sym_GT_GT_EQ] = ACTIONS(1382),
    [anon_sym_EQ] = ACTIONS(1384),
    [anon_sym_EQ_EQ] = ACTIONS(1382),
    [anon_sym_BANG_EQ] = ACTIONS(1382),
    [anon_sym_GT] = ACTIONS(1384),
    [anon_sym_LT] = ACTIONS(1384),
    [anon_sym_GT_EQ] = ACTIONS(1382),
    [anon_sym_LT_EQ] = ACTIONS(1382),
    [anon_sym__] = ACTIONS(1384),
    [anon_sym_DOT] = ACTIONS(1384),
    [anon_sym_DOT_DOT] = ACTIONS(1384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1382),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1382),
    [anon_sym_COMMA] = ACTIONS(1382),
    [anon_sym_COLON_COLON] = ACTIONS(1382),
    [anon_sym_POUND] = ACTIONS(1382),
    [anon_sym_as] = ACTIONS(1384),
    [anon_sym_const] = ACTIONS(1384),
    [anon_sym_default] = ACTIONS(1384),
    [anon_sym_union] = ACTIONS(1384),
    [anon_sym_ref] = ACTIONS(1384),
    [sym_mutable_specifier] = ACTIONS(1384),
    [sym_integer_literal] = ACTIONS(1382),
    [aux_sym_string_literal_token1] = ACTIONS(1382),
    [sym_char_literal] = ACTIONS(1382),
    [anon_sym_true] = ACTIONS(1384),
    [anon_sym_false] = ACTIONS(1384),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1384),
    [sym_super] = ACTIONS(1384),
    [sym_crate] = ACTIONS(1384),
    [sym_metavariable] = ACTIONS(1382),
    [sym__raw_string_literal_start] = ACTIONS(1382),
    [sym_float_literal] = ACTIONS(1382),
  },
  [463] = {
    [sym_line_comment] = STATE(463),
    [sym_block_comment] = STATE(463),
    [sym_identifier] = ACTIONS(1254),
    [anon_sym_LPAREN] = ACTIONS(1252),
    [anon_sym_LBRACK] = ACTIONS(1252),
    [anon_sym_RBRACE] = ACTIONS(1252),
    [anon_sym_PLUS] = ACTIONS(1254),
    [anon_sym_STAR] = ACTIONS(1254),
    [anon_sym_QMARK] = ACTIONS(1252),
    [anon_sym_u8] = ACTIONS(1254),
    [anon_sym_i8] = ACTIONS(1254),
    [anon_sym_u16] = ACTIONS(1254),
    [anon_sym_i16] = ACTIONS(1254),
    [anon_sym_u32] = ACTIONS(1254),
    [anon_sym_i32] = ACTIONS(1254),
    [anon_sym_u64] = ACTIONS(1254),
    [anon_sym_i64] = ACTIONS(1254),
    [anon_sym_u128] = ACTIONS(1254),
    [anon_sym_i128] = ACTIONS(1254),
    [anon_sym_isize] = ACTIONS(1254),
    [anon_sym_usize] = ACTIONS(1254),
    [anon_sym_f32] = ACTIONS(1254),
    [anon_sym_f64] = ACTIONS(1254),
    [anon_sym_bool] = ACTIONS(1254),
    [anon_sym_str] = ACTIONS(1254),
    [anon_sym_char] = ACTIONS(1254),
    [anon_sym_DASH] = ACTIONS(1254),
    [anon_sym_SLASH] = ACTIONS(1254),
    [anon_sym_PERCENT] = ACTIONS(1254),
    [anon_sym_CARET] = ACTIONS(1254),
    [anon_sym_AMP] = ACTIONS(1254),
    [anon_sym_PIPE] = ACTIONS(1254),
    [anon_sym_AMP_AMP] = ACTIONS(1252),
    [anon_sym_PIPE_PIPE] = ACTIONS(1252),
    [anon_sym_LT_LT] = ACTIONS(1254),
    [anon_sym_GT_GT] = ACTIONS(1254),
    [anon_sym_PLUS_EQ] = ACTIONS(1252),
    [anon_sym_DASH_EQ] = ACTIONS(1252),
    [anon_sym_STAR_EQ] = ACTIONS(1252),
    [anon_sym_SLASH_EQ] = ACTIONS(1252),
    [anon_sym_PERCENT_EQ] = ACTIONS(1252),
    [anon_sym_CARET_EQ] = ACTIONS(1252),
    [anon_sym_AMP_EQ] = ACTIONS(1252),
    [anon_sym_PIPE_EQ] = ACTIONS(1252),
    [anon_sym_LT_LT_EQ] = ACTIONS(1252),
    [anon_sym_GT_GT_EQ] = ACTIONS(1252),
    [anon_sym_EQ] = ACTIONS(1254),
    [anon_sym_EQ_EQ] = ACTIONS(1252),
    [anon_sym_BANG_EQ] = ACTIONS(1252),
    [anon_sym_GT] = ACTIONS(1254),
    [anon_sym_LT] = ACTIONS(1254),
    [anon_sym_GT_EQ] = ACTIONS(1252),
    [anon_sym_LT_EQ] = ACTIONS(1252),
    [anon_sym__] = ACTIONS(1254),
    [anon_sym_DOT] = ACTIONS(1254),
    [anon_sym_DOT_DOT] = ACTIONS(1254),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1252),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1252),
    [anon_sym_COMMA] = ACTIONS(1252),
    [anon_sym_COLON_COLON] = ACTIONS(1252),
    [anon_sym_POUND] = ACTIONS(1252),
    [anon_sym_as] = ACTIONS(1254),
    [anon_sym_const] = ACTIONS(1254),
    [anon_sym_default] = ACTIONS(1254),
    [anon_sym_union] = ACTIONS(1254),
    [anon_sym_ref] = ACTIONS(1254),
    [sym_mutable_specifier] = ACTIONS(1254),
    [sym_integer_literal] = ACTIONS(1252),
    [aux_sym_string_literal_token1] = ACTIONS(1252),
    [sym_char_literal] = ACTIONS(1252),
    [anon_sym_true] = ACTIONS(1254),
    [anon_sym_false] = ACTIONS(1254),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1254),
    [sym_super] = ACTIONS(1254),
    [sym_crate] = ACTIONS(1254),
    [sym_metavariable] = ACTIONS(1252),
    [sym__raw_string_literal_start] = ACTIONS(1252),
    [sym_float_literal] = ACTIONS(1252),
  },
  [464] = {
    [sym_attribute_item] = STATE(1471),
    [sym_inner_attribute_item] = STATE(1471),
    [sym_bracketed_type] = STATE(3513),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3115),
    [sym_macro_invocation] = STATE(2834),
    [sym_scoped_identifier] = STATE(2137),
    [sym_scoped_type_identifier] = STATE(2851),
    [sym_match_arm] = STATE(1473),
    [sym_last_match_arm] = STATE(3448),
    [sym_match_pattern] = STATE(3355),
    [sym_const_block] = STATE(2834),
    [sym__pattern] = STATE(2828),
    [sym_tuple_pattern] = STATE(2834),
    [sym_slice_pattern] = STATE(2834),
    [sym_tuple_struct_pattern] = STATE(2834),
    [sym_struct_pattern] = STATE(2834),
    [sym_remaining_field_pattern] = STATE(2834),
    [sym_mut_pattern] = STATE(2834),
    [sym_range_pattern] = STATE(2834),
    [sym_ref_pattern] = STATE(2834),
    [sym_captured_pattern] = STATE(2834),
    [sym_reference_pattern] = STATE(2834),
    [sym_or_pattern] = STATE(2834),
    [sym__literal_pattern] = STATE(2336),
    [sym_negative_literal] = STATE(2345),
    [sym_string_literal] = STATE(2345),
    [sym_raw_string_literal] = STATE(2345),
    [sym_boolean_literal] = STATE(2345),
    [sym_line_comment] = STATE(464),
    [sym_block_comment] = STATE(464),
    [aux_sym_match_block_repeat1] = STATE(476),
    [aux_sym_match_arm_repeat1] = STATE(752),
    [sym_identifier] = ACTIONS(1608),
    [anon_sym_LPAREN] = ACTIONS(1610),
    [anon_sym_LBRACK] = ACTIONS(1612),
    [anon_sym_RBRACE] = ACTIONS(1656),
    [anon_sym_u8] = ACTIONS(1616),
    [anon_sym_i8] = ACTIONS(1616),
    [anon_sym_u16] = ACTIONS(1616),
    [anon_sym_i16] = ACTIONS(1616),
    [anon_sym_u32] = ACTIONS(1616),
    [anon_sym_i32] = ACTIONS(1616),
    [anon_sym_u64] = ACTIONS(1616),
    [anon_sym_i64] = ACTIONS(1616),
    [anon_sym_u128] = ACTIONS(1616),
    [anon_sym_i128] = ACTIONS(1616),
    [anon_sym_isize] = ACTIONS(1616),
    [anon_sym_usize] = ACTIONS(1616),
    [anon_sym_f32] = ACTIONS(1616),
    [anon_sym_f64] = ACTIONS(1616),
    [anon_sym_bool] = ACTIONS(1616),
    [anon_sym_str] = ACTIONS(1616),
    [anon_sym_char] = ACTIONS(1616),
    [anon_sym_DASH] = ACTIONS(1618),
    [anon_sym_AMP] = ACTIONS(1620),
    [anon_sym_PIPE] = ACTIONS(1622),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1624),
    [anon_sym_DOT_DOT] = ACTIONS(1626),
    [anon_sym_COLON_COLON] = ACTIONS(1628),
    [anon_sym_POUND] = ACTIONS(1630),
    [anon_sym_const] = ACTIONS(1632),
    [anon_sym_default] = ACTIONS(1634),
    [anon_sym_union] = ACTIONS(1634),
    [anon_sym_ref] = ACTIONS(1636),
    [sym_mutable_specifier] = ACTIONS(1638),
    [sym_integer_literal] = ACTIONS(1640),
    [aux_sym_string_literal_token1] = ACTIONS(1642),
    [sym_char_literal] = ACTIONS(1640),
    [anon_sym_true] = ACTIONS(1644),
    [anon_sym_false] = ACTIONS(1644),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1646),
    [sym_super] = ACTIONS(1646),
    [sym_crate] = ACTIONS(1646),
    [sym_metavariable] = ACTIONS(1648),
    [sym__raw_string_literal_start] = ACTIONS(1650),
    [sym_float_literal] = ACTIONS(1640),
  },
  [465] = {
    [sym_line_comment] = STATE(465),
    [sym_block_comment] = STATE(465),
    [sym_identifier] = ACTIONS(1392),
    [anon_sym_LPAREN] = ACTIONS(1390),
    [anon_sym_LBRACK] = ACTIONS(1390),
    [anon_sym_RBRACE] = ACTIONS(1390),
    [anon_sym_PLUS] = ACTIONS(1392),
    [anon_sym_STAR] = ACTIONS(1392),
    [anon_sym_QMARK] = ACTIONS(1390),
    [anon_sym_u8] = ACTIONS(1392),
    [anon_sym_i8] = ACTIONS(1392),
    [anon_sym_u16] = ACTIONS(1392),
    [anon_sym_i16] = ACTIONS(1392),
    [anon_sym_u32] = ACTIONS(1392),
    [anon_sym_i32] = ACTIONS(1392),
    [anon_sym_u64] = ACTIONS(1392),
    [anon_sym_i64] = ACTIONS(1392),
    [anon_sym_u128] = ACTIONS(1392),
    [anon_sym_i128] = ACTIONS(1392),
    [anon_sym_isize] = ACTIONS(1392),
    [anon_sym_usize] = ACTIONS(1392),
    [anon_sym_f32] = ACTIONS(1392),
    [anon_sym_f64] = ACTIONS(1392),
    [anon_sym_bool] = ACTIONS(1392),
    [anon_sym_str] = ACTIONS(1392),
    [anon_sym_char] = ACTIONS(1392),
    [anon_sym_DASH] = ACTIONS(1392),
    [anon_sym_SLASH] = ACTIONS(1392),
    [anon_sym_PERCENT] = ACTIONS(1392),
    [anon_sym_CARET] = ACTIONS(1392),
    [anon_sym_AMP] = ACTIONS(1392),
    [anon_sym_PIPE] = ACTIONS(1392),
    [anon_sym_AMP_AMP] = ACTIONS(1390),
    [anon_sym_PIPE_PIPE] = ACTIONS(1390),
    [anon_sym_LT_LT] = ACTIONS(1392),
    [anon_sym_GT_GT] = ACTIONS(1392),
    [anon_sym_PLUS_EQ] = ACTIONS(1390),
    [anon_sym_DASH_EQ] = ACTIONS(1390),
    [anon_sym_STAR_EQ] = ACTIONS(1390),
    [anon_sym_SLASH_EQ] = ACTIONS(1390),
    [anon_sym_PERCENT_EQ] = ACTIONS(1390),
    [anon_sym_CARET_EQ] = ACTIONS(1390),
    [anon_sym_AMP_EQ] = ACTIONS(1390),
    [anon_sym_PIPE_EQ] = ACTIONS(1390),
    [anon_sym_LT_LT_EQ] = ACTIONS(1390),
    [anon_sym_GT_GT_EQ] = ACTIONS(1390),
    [anon_sym_EQ] = ACTIONS(1392),
    [anon_sym_EQ_EQ] = ACTIONS(1390),
    [anon_sym_BANG_EQ] = ACTIONS(1390),
    [anon_sym_GT] = ACTIONS(1392),
    [anon_sym_LT] = ACTIONS(1392),
    [anon_sym_GT_EQ] = ACTIONS(1390),
    [anon_sym_LT_EQ] = ACTIONS(1390),
    [anon_sym__] = ACTIONS(1392),
    [anon_sym_DOT] = ACTIONS(1392),
    [anon_sym_DOT_DOT] = ACTIONS(1392),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1390),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1390),
    [anon_sym_COMMA] = ACTIONS(1390),
    [anon_sym_COLON_COLON] = ACTIONS(1390),
    [anon_sym_POUND] = ACTIONS(1390),
    [anon_sym_as] = ACTIONS(1392),
    [anon_sym_const] = ACTIONS(1392),
    [anon_sym_default] = ACTIONS(1392),
    [anon_sym_union] = ACTIONS(1392),
    [anon_sym_ref] = ACTIONS(1392),
    [sym_mutable_specifier] = ACTIONS(1392),
    [sym_integer_literal] = ACTIONS(1390),
    [aux_sym_string_literal_token1] = ACTIONS(1390),
    [sym_char_literal] = ACTIONS(1390),
    [anon_sym_true] = ACTIONS(1392),
    [anon_sym_false] = ACTIONS(1392),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1392),
    [sym_super] = ACTIONS(1392),
    [sym_crate] = ACTIONS(1392),
    [sym_metavariable] = ACTIONS(1390),
    [sym__raw_string_literal_start] = ACTIONS(1390),
    [sym_float_literal] = ACTIONS(1390),
  },
  [466] = {
    [sym_line_comment] = STATE(466),
    [sym_block_comment] = STATE(466),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_LPAREN] = ACTIONS(1398),
    [anon_sym_LBRACK] = ACTIONS(1398),
    [anon_sym_RBRACE] = ACTIONS(1398),
    [anon_sym_PLUS] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(1400),
    [anon_sym_QMARK] = ACTIONS(1398),
    [anon_sym_u8] = ACTIONS(1400),
    [anon_sym_i8] = ACTIONS(1400),
    [anon_sym_u16] = ACTIONS(1400),
    [anon_sym_i16] = ACTIONS(1400),
    [anon_sym_u32] = ACTIONS(1400),
    [anon_sym_i32] = ACTIONS(1400),
    [anon_sym_u64] = ACTIONS(1400),
    [anon_sym_i64] = ACTIONS(1400),
    [anon_sym_u128] = ACTIONS(1400),
    [anon_sym_i128] = ACTIONS(1400),
    [anon_sym_isize] = ACTIONS(1400),
    [anon_sym_usize] = ACTIONS(1400),
    [anon_sym_f32] = ACTIONS(1400),
    [anon_sym_f64] = ACTIONS(1400),
    [anon_sym_bool] = ACTIONS(1400),
    [anon_sym_str] = ACTIONS(1400),
    [anon_sym_char] = ACTIONS(1400),
    [anon_sym_DASH] = ACTIONS(1400),
    [anon_sym_SLASH] = ACTIONS(1400),
    [anon_sym_PERCENT] = ACTIONS(1400),
    [anon_sym_CARET] = ACTIONS(1400),
    [anon_sym_AMP] = ACTIONS(1400),
    [anon_sym_PIPE] = ACTIONS(1400),
    [anon_sym_AMP_AMP] = ACTIONS(1398),
    [anon_sym_PIPE_PIPE] = ACTIONS(1398),
    [anon_sym_LT_LT] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1400),
    [anon_sym_PLUS_EQ] = ACTIONS(1398),
    [anon_sym_DASH_EQ] = ACTIONS(1398),
    [anon_sym_STAR_EQ] = ACTIONS(1398),
    [anon_sym_SLASH_EQ] = ACTIONS(1398),
    [anon_sym_PERCENT_EQ] = ACTIONS(1398),
    [anon_sym_CARET_EQ] = ACTIONS(1398),
    [anon_sym_AMP_EQ] = ACTIONS(1398),
    [anon_sym_PIPE_EQ] = ACTIONS(1398),
    [anon_sym_LT_LT_EQ] = ACTIONS(1398),
    [anon_sym_GT_GT_EQ] = ACTIONS(1398),
    [anon_sym_EQ] = ACTIONS(1400),
    [anon_sym_EQ_EQ] = ACTIONS(1398),
    [anon_sym_BANG_EQ] = ACTIONS(1398),
    [anon_sym_GT] = ACTIONS(1400),
    [anon_sym_LT] = ACTIONS(1400),
    [anon_sym_GT_EQ] = ACTIONS(1398),
    [anon_sym_LT_EQ] = ACTIONS(1398),
    [anon_sym__] = ACTIONS(1400),
    [anon_sym_DOT] = ACTIONS(1400),
    [anon_sym_DOT_DOT] = ACTIONS(1400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1398),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1398),
    [anon_sym_COMMA] = ACTIONS(1398),
    [anon_sym_COLON_COLON] = ACTIONS(1398),
    [anon_sym_POUND] = ACTIONS(1398),
    [anon_sym_as] = ACTIONS(1400),
    [anon_sym_const] = ACTIONS(1400),
    [anon_sym_default] = ACTIONS(1400),
    [anon_sym_union] = ACTIONS(1400),
    [anon_sym_ref] = ACTIONS(1400),
    [sym_mutable_specifier] = ACTIONS(1400),
    [sym_integer_literal] = ACTIONS(1398),
    [aux_sym_string_literal_token1] = ACTIONS(1398),
    [sym_char_literal] = ACTIONS(1398),
    [anon_sym_true] = ACTIONS(1400),
    [anon_sym_false] = ACTIONS(1400),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1400),
    [sym_super] = ACTIONS(1400),
    [sym_crate] = ACTIONS(1400),
    [sym_metavariable] = ACTIONS(1398),
    [sym__raw_string_literal_start] = ACTIONS(1398),
    [sym_float_literal] = ACTIONS(1398),
  },
  [467] = {
    [sym_attribute_item] = STATE(1471),
    [sym_inner_attribute_item] = STATE(1471),
    [sym_bracketed_type] = STATE(3513),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3115),
    [sym_macro_invocation] = STATE(2834),
    [sym_scoped_identifier] = STATE(2137),
    [sym_scoped_type_identifier] = STATE(2851),
    [sym_match_arm] = STATE(1473),
    [sym_last_match_arm] = STATE(3402),
    [sym_match_pattern] = STATE(3355),
    [sym_const_block] = STATE(2834),
    [sym__pattern] = STATE(2828),
    [sym_tuple_pattern] = STATE(2834),
    [sym_slice_pattern] = STATE(2834),
    [sym_tuple_struct_pattern] = STATE(2834),
    [sym_struct_pattern] = STATE(2834),
    [sym_remaining_field_pattern] = STATE(2834),
    [sym_mut_pattern] = STATE(2834),
    [sym_range_pattern] = STATE(2834),
    [sym_ref_pattern] = STATE(2834),
    [sym_captured_pattern] = STATE(2834),
    [sym_reference_pattern] = STATE(2834),
    [sym_or_pattern] = STATE(2834),
    [sym__literal_pattern] = STATE(2336),
    [sym_negative_literal] = STATE(2345),
    [sym_string_literal] = STATE(2345),
    [sym_raw_string_literal] = STATE(2345),
    [sym_boolean_literal] = STATE(2345),
    [sym_line_comment] = STATE(467),
    [sym_block_comment] = STATE(467),
    [aux_sym_match_block_repeat1] = STATE(477),
    [aux_sym_match_arm_repeat1] = STATE(752),
    [sym_identifier] = ACTIONS(1608),
    [anon_sym_LPAREN] = ACTIONS(1610),
    [anon_sym_LBRACK] = ACTIONS(1612),
    [anon_sym_RBRACE] = ACTIONS(1658),
    [anon_sym_u8] = ACTIONS(1616),
    [anon_sym_i8] = ACTIONS(1616),
    [anon_sym_u16] = ACTIONS(1616),
    [anon_sym_i16] = ACTIONS(1616),
    [anon_sym_u32] = ACTIONS(1616),
    [anon_sym_i32] = ACTIONS(1616),
    [anon_sym_u64] = ACTIONS(1616),
    [anon_sym_i64] = ACTIONS(1616),
    [anon_sym_u128] = ACTIONS(1616),
    [anon_sym_i128] = ACTIONS(1616),
    [anon_sym_isize] = ACTIONS(1616),
    [anon_sym_usize] = ACTIONS(1616),
    [anon_sym_f32] = ACTIONS(1616),
    [anon_sym_f64] = ACTIONS(1616),
    [anon_sym_bool] = ACTIONS(1616),
    [anon_sym_str] = ACTIONS(1616),
    [anon_sym_char] = ACTIONS(1616),
    [anon_sym_DASH] = ACTIONS(1618),
    [anon_sym_AMP] = ACTIONS(1620),
    [anon_sym_PIPE] = ACTIONS(1622),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1624),
    [anon_sym_DOT_DOT] = ACTIONS(1626),
    [anon_sym_COLON_COLON] = ACTIONS(1628),
    [anon_sym_POUND] = ACTIONS(1630),
    [anon_sym_const] = ACTIONS(1632),
    [anon_sym_default] = ACTIONS(1634),
    [anon_sym_union] = ACTIONS(1634),
    [anon_sym_ref] = ACTIONS(1636),
    [sym_mutable_specifier] = ACTIONS(1638),
    [sym_integer_literal] = ACTIONS(1640),
    [aux_sym_string_literal_token1] = ACTIONS(1642),
    [sym_char_literal] = ACTIONS(1640),
    [anon_sym_true] = ACTIONS(1644),
    [anon_sym_false] = ACTIONS(1644),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1646),
    [sym_super] = ACTIONS(1646),
    [sym_crate] = ACTIONS(1646),
    [sym_metavariable] = ACTIONS(1648),
    [sym__raw_string_literal_start] = ACTIONS(1650),
    [sym_float_literal] = ACTIONS(1640),
  },
  [468] = {
    [sym_line_comment] = STATE(468),
    [sym_block_comment] = STATE(468),
    [sym_identifier] = ACTIONS(1452),
    [anon_sym_LPAREN] = ACTIONS(1450),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_RBRACE] = ACTIONS(1450),
    [anon_sym_PLUS] = ACTIONS(1452),
    [anon_sym_STAR] = ACTIONS(1452),
    [anon_sym_QMARK] = ACTIONS(1450),
    [anon_sym_u8] = ACTIONS(1452),
    [anon_sym_i8] = ACTIONS(1452),
    [anon_sym_u16] = ACTIONS(1452),
    [anon_sym_i16] = ACTIONS(1452),
    [anon_sym_u32] = ACTIONS(1452),
    [anon_sym_i32] = ACTIONS(1452),
    [anon_sym_u64] = ACTIONS(1452),
    [anon_sym_i64] = ACTIONS(1452),
    [anon_sym_u128] = ACTIONS(1452),
    [anon_sym_i128] = ACTIONS(1452),
    [anon_sym_isize] = ACTIONS(1452),
    [anon_sym_usize] = ACTIONS(1452),
    [anon_sym_f32] = ACTIONS(1452),
    [anon_sym_f64] = ACTIONS(1452),
    [anon_sym_bool] = ACTIONS(1452),
    [anon_sym_str] = ACTIONS(1452),
    [anon_sym_char] = ACTIONS(1452),
    [anon_sym_DASH] = ACTIONS(1452),
    [anon_sym_SLASH] = ACTIONS(1452),
    [anon_sym_PERCENT] = ACTIONS(1452),
    [anon_sym_CARET] = ACTIONS(1452),
    [anon_sym_AMP] = ACTIONS(1452),
    [anon_sym_PIPE] = ACTIONS(1452),
    [anon_sym_AMP_AMP] = ACTIONS(1450),
    [anon_sym_PIPE_PIPE] = ACTIONS(1450),
    [anon_sym_LT_LT] = ACTIONS(1452),
    [anon_sym_GT_GT] = ACTIONS(1452),
    [anon_sym_PLUS_EQ] = ACTIONS(1450),
    [anon_sym_DASH_EQ] = ACTIONS(1450),
    [anon_sym_STAR_EQ] = ACTIONS(1450),
    [anon_sym_SLASH_EQ] = ACTIONS(1450),
    [anon_sym_PERCENT_EQ] = ACTIONS(1450),
    [anon_sym_CARET_EQ] = ACTIONS(1450),
    [anon_sym_AMP_EQ] = ACTIONS(1450),
    [anon_sym_PIPE_EQ] = ACTIONS(1450),
    [anon_sym_LT_LT_EQ] = ACTIONS(1450),
    [anon_sym_GT_GT_EQ] = ACTIONS(1450),
    [anon_sym_EQ] = ACTIONS(1452),
    [anon_sym_EQ_EQ] = ACTIONS(1450),
    [anon_sym_BANG_EQ] = ACTIONS(1450),
    [anon_sym_GT] = ACTIONS(1452),
    [anon_sym_LT] = ACTIONS(1452),
    [anon_sym_GT_EQ] = ACTIONS(1450),
    [anon_sym_LT_EQ] = ACTIONS(1450),
    [anon_sym__] = ACTIONS(1452),
    [anon_sym_DOT] = ACTIONS(1452),
    [anon_sym_DOT_DOT] = ACTIONS(1452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1450),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1450),
    [anon_sym_COMMA] = ACTIONS(1450),
    [anon_sym_COLON_COLON] = ACTIONS(1450),
    [anon_sym_POUND] = ACTIONS(1450),
    [anon_sym_as] = ACTIONS(1452),
    [anon_sym_const] = ACTIONS(1452),
    [anon_sym_default] = ACTIONS(1452),
    [anon_sym_union] = ACTIONS(1452),
    [anon_sym_ref] = ACTIONS(1452),
    [sym_mutable_specifier] = ACTIONS(1452),
    [sym_integer_literal] = ACTIONS(1450),
    [aux_sym_string_literal_token1] = ACTIONS(1450),
    [sym_char_literal] = ACTIONS(1450),
    [anon_sym_true] = ACTIONS(1452),
    [anon_sym_false] = ACTIONS(1452),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1452),
    [sym_super] = ACTIONS(1452),
    [sym_crate] = ACTIONS(1452),
    [sym_metavariable] = ACTIONS(1450),
    [sym__raw_string_literal_start] = ACTIONS(1450),
    [sym_float_literal] = ACTIONS(1450),
  },
  [469] = {
    [sym_line_comment] = STATE(469),
    [sym_block_comment] = STATE(469),
    [sym_identifier] = ACTIONS(1350),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACK] = ACTIONS(1348),
    [anon_sym_RBRACE] = ACTIONS(1348),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1350),
    [anon_sym_QMARK] = ACTIONS(1348),
    [anon_sym_u8] = ACTIONS(1350),
    [anon_sym_i8] = ACTIONS(1350),
    [anon_sym_u16] = ACTIONS(1350),
    [anon_sym_i16] = ACTIONS(1350),
    [anon_sym_u32] = ACTIONS(1350),
    [anon_sym_i32] = ACTIONS(1350),
    [anon_sym_u64] = ACTIONS(1350),
    [anon_sym_i64] = ACTIONS(1350),
    [anon_sym_u128] = ACTIONS(1350),
    [anon_sym_i128] = ACTIONS(1350),
    [anon_sym_isize] = ACTIONS(1350),
    [anon_sym_usize] = ACTIONS(1350),
    [anon_sym_f32] = ACTIONS(1350),
    [anon_sym_f64] = ACTIONS(1350),
    [anon_sym_bool] = ACTIONS(1350),
    [anon_sym_str] = ACTIONS(1350),
    [anon_sym_char] = ACTIONS(1350),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_SLASH] = ACTIONS(1350),
    [anon_sym_PERCENT] = ACTIONS(1350),
    [anon_sym_CARET] = ACTIONS(1350),
    [anon_sym_AMP] = ACTIONS(1350),
    [anon_sym_PIPE] = ACTIONS(1350),
    [anon_sym_AMP_AMP] = ACTIONS(1348),
    [anon_sym_PIPE_PIPE] = ACTIONS(1348),
    [anon_sym_LT_LT] = ACTIONS(1350),
    [anon_sym_GT_GT] = ACTIONS(1350),
    [anon_sym_PLUS_EQ] = ACTIONS(1348),
    [anon_sym_DASH_EQ] = ACTIONS(1348),
    [anon_sym_STAR_EQ] = ACTIONS(1348),
    [anon_sym_SLASH_EQ] = ACTIONS(1348),
    [anon_sym_PERCENT_EQ] = ACTIONS(1348),
    [anon_sym_CARET_EQ] = ACTIONS(1348),
    [anon_sym_AMP_EQ] = ACTIONS(1348),
    [anon_sym_PIPE_EQ] = ACTIONS(1348),
    [anon_sym_LT_LT_EQ] = ACTIONS(1348),
    [anon_sym_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_EQ] = ACTIONS(1350),
    [anon_sym_EQ_EQ] = ACTIONS(1348),
    [anon_sym_BANG_EQ] = ACTIONS(1348),
    [anon_sym_GT] = ACTIONS(1350),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_GT_EQ] = ACTIONS(1348),
    [anon_sym_LT_EQ] = ACTIONS(1348),
    [anon_sym__] = ACTIONS(1350),
    [anon_sym_DOT] = ACTIONS(1350),
    [anon_sym_DOT_DOT] = ACTIONS(1350),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1348),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1348),
    [anon_sym_COMMA] = ACTIONS(1348),
    [anon_sym_COLON_COLON] = ACTIONS(1348),
    [anon_sym_POUND] = ACTIONS(1348),
    [anon_sym_as] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_ref] = ACTIONS(1350),
    [sym_mutable_specifier] = ACTIONS(1350),
    [sym_integer_literal] = ACTIONS(1348),
    [aux_sym_string_literal_token1] = ACTIONS(1348),
    [sym_char_literal] = ACTIONS(1348),
    [anon_sym_true] = ACTIONS(1350),
    [anon_sym_false] = ACTIONS(1350),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1350),
    [sym_super] = ACTIONS(1350),
    [sym_crate] = ACTIONS(1350),
    [sym_metavariable] = ACTIONS(1348),
    [sym__raw_string_literal_start] = ACTIONS(1348),
    [sym_float_literal] = ACTIONS(1348),
  },
  [470] = {
    [sym_attribute_item] = STATE(1471),
    [sym_inner_attribute_item] = STATE(1471),
    [sym_bracketed_type] = STATE(3513),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3115),
    [sym_macro_invocation] = STATE(2834),
    [sym_scoped_identifier] = STATE(2137),
    [sym_scoped_type_identifier] = STATE(2851),
    [sym_match_arm] = STATE(1473),
    [sym_last_match_arm] = STATE(3350),
    [sym_match_pattern] = STATE(3355),
    [sym_const_block] = STATE(2834),
    [sym__pattern] = STATE(2828),
    [sym_tuple_pattern] = STATE(2834),
    [sym_slice_pattern] = STATE(2834),
    [sym_tuple_struct_pattern] = STATE(2834),
    [sym_struct_pattern] = STATE(2834),
    [sym_remaining_field_pattern] = STATE(2834),
    [sym_mut_pattern] = STATE(2834),
    [sym_range_pattern] = STATE(2834),
    [sym_ref_pattern] = STATE(2834),
    [sym_captured_pattern] = STATE(2834),
    [sym_reference_pattern] = STATE(2834),
    [sym_or_pattern] = STATE(2834),
    [sym__literal_pattern] = STATE(2336),
    [sym_negative_literal] = STATE(2345),
    [sym_string_literal] = STATE(2345),
    [sym_raw_string_literal] = STATE(2345),
    [sym_boolean_literal] = STATE(2345),
    [sym_line_comment] = STATE(470),
    [sym_block_comment] = STATE(470),
    [aux_sym_match_block_repeat1] = STATE(475),
    [aux_sym_match_arm_repeat1] = STATE(752),
    [sym_identifier] = ACTIONS(1608),
    [anon_sym_LPAREN] = ACTIONS(1610),
    [anon_sym_LBRACK] = ACTIONS(1612),
    [anon_sym_RBRACE] = ACTIONS(1660),
    [anon_sym_u8] = ACTIONS(1616),
    [anon_sym_i8] = ACTIONS(1616),
    [anon_sym_u16] = ACTIONS(1616),
    [anon_sym_i16] = ACTIONS(1616),
    [anon_sym_u32] = ACTIONS(1616),
    [anon_sym_i32] = ACTIONS(1616),
    [anon_sym_u64] = ACTIONS(1616),
    [anon_sym_i64] = ACTIONS(1616),
    [anon_sym_u128] = ACTIONS(1616),
    [anon_sym_i128] = ACTIONS(1616),
    [anon_sym_isize] = ACTIONS(1616),
    [anon_sym_usize] = ACTIONS(1616),
    [anon_sym_f32] = ACTIONS(1616),
    [anon_sym_f64] = ACTIONS(1616),
    [anon_sym_bool] = ACTIONS(1616),
    [anon_sym_str] = ACTIONS(1616),
    [anon_sym_char] = ACTIONS(1616),
    [anon_sym_DASH] = ACTIONS(1618),
    [anon_sym_AMP] = ACTIONS(1620),
    [anon_sym_PIPE] = ACTIONS(1622),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1624),
    [anon_sym_DOT_DOT] = ACTIONS(1626),
    [anon_sym_COLON_COLON] = ACTIONS(1628),
    [anon_sym_POUND] = ACTIONS(1630),
    [anon_sym_const] = ACTIONS(1632),
    [anon_sym_default] = ACTIONS(1634),
    [anon_sym_union] = ACTIONS(1634),
    [anon_sym_ref] = ACTIONS(1636),
    [sym_mutable_specifier] = ACTIONS(1638),
    [sym_integer_literal] = ACTIONS(1640),
    [aux_sym_string_literal_token1] = ACTIONS(1642),
    [sym_char_literal] = ACTIONS(1640),
    [anon_sym_true] = ACTIONS(1644),
    [anon_sym_false] = ACTIONS(1644),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1646),
    [sym_super] = ACTIONS(1646),
    [sym_crate] = ACTIONS(1646),
    [sym_metavariable] = ACTIONS(1648),
    [sym__raw_string_literal_start] = ACTIONS(1650),
    [sym_float_literal] = ACTIONS(1640),
  },
  [471] = {
    [sym_line_comment] = STATE(471),
    [sym_block_comment] = STATE(471),
    [sym_identifier] = ACTIONS(1258),
    [anon_sym_LPAREN] = ACTIONS(1256),
    [anon_sym_LBRACK] = ACTIONS(1256),
    [anon_sym_RBRACE] = ACTIONS(1256),
    [anon_sym_PLUS] = ACTIONS(1258),
    [anon_sym_STAR] = ACTIONS(1258),
    [anon_sym_QMARK] = ACTIONS(1256),
    [anon_sym_u8] = ACTIONS(1258),
    [anon_sym_i8] = ACTIONS(1258),
    [anon_sym_u16] = ACTIONS(1258),
    [anon_sym_i16] = ACTIONS(1258),
    [anon_sym_u32] = ACTIONS(1258),
    [anon_sym_i32] = ACTIONS(1258),
    [anon_sym_u64] = ACTIONS(1258),
    [anon_sym_i64] = ACTIONS(1258),
    [anon_sym_u128] = ACTIONS(1258),
    [anon_sym_i128] = ACTIONS(1258),
    [anon_sym_isize] = ACTIONS(1258),
    [anon_sym_usize] = ACTIONS(1258),
    [anon_sym_f32] = ACTIONS(1258),
    [anon_sym_f64] = ACTIONS(1258),
    [anon_sym_bool] = ACTIONS(1258),
    [anon_sym_str] = ACTIONS(1258),
    [anon_sym_char] = ACTIONS(1258),
    [anon_sym_DASH] = ACTIONS(1258),
    [anon_sym_SLASH] = ACTIONS(1258),
    [anon_sym_PERCENT] = ACTIONS(1258),
    [anon_sym_CARET] = ACTIONS(1258),
    [anon_sym_AMP] = ACTIONS(1258),
    [anon_sym_PIPE] = ACTIONS(1258),
    [anon_sym_AMP_AMP] = ACTIONS(1256),
    [anon_sym_PIPE_PIPE] = ACTIONS(1256),
    [anon_sym_LT_LT] = ACTIONS(1258),
    [anon_sym_GT_GT] = ACTIONS(1258),
    [anon_sym_PLUS_EQ] = ACTIONS(1256),
    [anon_sym_DASH_EQ] = ACTIONS(1256),
    [anon_sym_STAR_EQ] = ACTIONS(1256),
    [anon_sym_SLASH_EQ] = ACTIONS(1256),
    [anon_sym_PERCENT_EQ] = ACTIONS(1256),
    [anon_sym_CARET_EQ] = ACTIONS(1256),
    [anon_sym_AMP_EQ] = ACTIONS(1256),
    [anon_sym_PIPE_EQ] = ACTIONS(1256),
    [anon_sym_LT_LT_EQ] = ACTIONS(1256),
    [anon_sym_GT_GT_EQ] = ACTIONS(1256),
    [anon_sym_EQ] = ACTIONS(1258),
    [anon_sym_EQ_EQ] = ACTIONS(1256),
    [anon_sym_BANG_EQ] = ACTIONS(1256),
    [anon_sym_GT] = ACTIONS(1258),
    [anon_sym_LT] = ACTIONS(1258),
    [anon_sym_GT_EQ] = ACTIONS(1256),
    [anon_sym_LT_EQ] = ACTIONS(1256),
    [anon_sym__] = ACTIONS(1258),
    [anon_sym_DOT] = ACTIONS(1258),
    [anon_sym_DOT_DOT] = ACTIONS(1258),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1256),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1256),
    [anon_sym_COMMA] = ACTIONS(1256),
    [anon_sym_COLON_COLON] = ACTIONS(1256),
    [anon_sym_POUND] = ACTIONS(1256),
    [anon_sym_as] = ACTIONS(1258),
    [anon_sym_const] = ACTIONS(1258),
    [anon_sym_default] = ACTIONS(1258),
    [anon_sym_union] = ACTIONS(1258),
    [anon_sym_ref] = ACTIONS(1258),
    [sym_mutable_specifier] = ACTIONS(1258),
    [sym_integer_literal] = ACTIONS(1256),
    [aux_sym_string_literal_token1] = ACTIONS(1256),
    [sym_char_literal] = ACTIONS(1256),
    [anon_sym_true] = ACTIONS(1258),
    [anon_sym_false] = ACTIONS(1258),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1258),
    [sym_super] = ACTIONS(1258),
    [sym_crate] = ACTIONS(1258),
    [sym_metavariable] = ACTIONS(1256),
    [sym__raw_string_literal_start] = ACTIONS(1256),
    [sym_float_literal] = ACTIONS(1256),
  },
  [472] = {
    [sym_line_comment] = STATE(472),
    [sym_block_comment] = STATE(472),
    [sym_identifier] = ACTIONS(1408),
    [anon_sym_LPAREN] = ACTIONS(1406),
    [anon_sym_LBRACK] = ACTIONS(1406),
    [anon_sym_RBRACE] = ACTIONS(1406),
    [anon_sym_PLUS] = ACTIONS(1408),
    [anon_sym_STAR] = ACTIONS(1408),
    [anon_sym_QMARK] = ACTIONS(1406),
    [anon_sym_u8] = ACTIONS(1408),
    [anon_sym_i8] = ACTIONS(1408),
    [anon_sym_u16] = ACTIONS(1408),
    [anon_sym_i16] = ACTIONS(1408),
    [anon_sym_u32] = ACTIONS(1408),
    [anon_sym_i32] = ACTIONS(1408),
    [anon_sym_u64] = ACTIONS(1408),
    [anon_sym_i64] = ACTIONS(1408),
    [anon_sym_u128] = ACTIONS(1408),
    [anon_sym_i128] = ACTIONS(1408),
    [anon_sym_isize] = ACTIONS(1408),
    [anon_sym_usize] = ACTIONS(1408),
    [anon_sym_f32] = ACTIONS(1408),
    [anon_sym_f64] = ACTIONS(1408),
    [anon_sym_bool] = ACTIONS(1408),
    [anon_sym_str] = ACTIONS(1408),
    [anon_sym_char] = ACTIONS(1408),
    [anon_sym_DASH] = ACTIONS(1408),
    [anon_sym_SLASH] = ACTIONS(1408),
    [anon_sym_PERCENT] = ACTIONS(1408),
    [anon_sym_CARET] = ACTIONS(1408),
    [anon_sym_AMP] = ACTIONS(1408),
    [anon_sym_PIPE] = ACTIONS(1408),
    [anon_sym_AMP_AMP] = ACTIONS(1406),
    [anon_sym_PIPE_PIPE] = ACTIONS(1406),
    [anon_sym_LT_LT] = ACTIONS(1408),
    [anon_sym_GT_GT] = ACTIONS(1408),
    [anon_sym_PLUS_EQ] = ACTIONS(1406),
    [anon_sym_DASH_EQ] = ACTIONS(1406),
    [anon_sym_STAR_EQ] = ACTIONS(1406),
    [anon_sym_SLASH_EQ] = ACTIONS(1406),
    [anon_sym_PERCENT_EQ] = ACTIONS(1406),
    [anon_sym_CARET_EQ] = ACTIONS(1406),
    [anon_sym_AMP_EQ] = ACTIONS(1406),
    [anon_sym_PIPE_EQ] = ACTIONS(1406),
    [anon_sym_LT_LT_EQ] = ACTIONS(1406),
    [anon_sym_GT_GT_EQ] = ACTIONS(1406),
    [anon_sym_EQ] = ACTIONS(1408),
    [anon_sym_EQ_EQ] = ACTIONS(1406),
    [anon_sym_BANG_EQ] = ACTIONS(1406),
    [anon_sym_GT] = ACTIONS(1408),
    [anon_sym_LT] = ACTIONS(1408),
    [anon_sym_GT_EQ] = ACTIONS(1406),
    [anon_sym_LT_EQ] = ACTIONS(1406),
    [anon_sym__] = ACTIONS(1408),
    [anon_sym_DOT] = ACTIONS(1408),
    [anon_sym_DOT_DOT] = ACTIONS(1408),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1406),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1406),
    [anon_sym_COMMA] = ACTIONS(1406),
    [anon_sym_COLON_COLON] = ACTIONS(1406),
    [anon_sym_POUND] = ACTIONS(1406),
    [anon_sym_as] = ACTIONS(1408),
    [anon_sym_const] = ACTIONS(1408),
    [anon_sym_default] = ACTIONS(1408),
    [anon_sym_union] = ACTIONS(1408),
    [anon_sym_ref] = ACTIONS(1408),
    [sym_mutable_specifier] = ACTIONS(1408),
    [sym_integer_literal] = ACTIONS(1406),
    [aux_sym_string_literal_token1] = ACTIONS(1406),
    [sym_char_literal] = ACTIONS(1406),
    [anon_sym_true] = ACTIONS(1408),
    [anon_sym_false] = ACTIONS(1408),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1408),
    [sym_super] = ACTIONS(1408),
    [sym_crate] = ACTIONS(1408),
    [sym_metavariable] = ACTIONS(1406),
    [sym__raw_string_literal_start] = ACTIONS(1406),
    [sym_float_literal] = ACTIONS(1406),
  },
  [473] = {
    [sym_line_comment] = STATE(473),
    [sym_block_comment] = STATE(473),
    [sym_identifier] = ACTIONS(1440),
    [anon_sym_LPAREN] = ACTIONS(1438),
    [anon_sym_LBRACK] = ACTIONS(1438),
    [anon_sym_RBRACE] = ACTIONS(1438),
    [anon_sym_PLUS] = ACTIONS(1440),
    [anon_sym_STAR] = ACTIONS(1440),
    [anon_sym_QMARK] = ACTIONS(1438),
    [anon_sym_u8] = ACTIONS(1440),
    [anon_sym_i8] = ACTIONS(1440),
    [anon_sym_u16] = ACTIONS(1440),
    [anon_sym_i16] = ACTIONS(1440),
    [anon_sym_u32] = ACTIONS(1440),
    [anon_sym_i32] = ACTIONS(1440),
    [anon_sym_u64] = ACTIONS(1440),
    [anon_sym_i64] = ACTIONS(1440),
    [anon_sym_u128] = ACTIONS(1440),
    [anon_sym_i128] = ACTIONS(1440),
    [anon_sym_isize] = ACTIONS(1440),
    [anon_sym_usize] = ACTIONS(1440),
    [anon_sym_f32] = ACTIONS(1440),
    [anon_sym_f64] = ACTIONS(1440),
    [anon_sym_bool] = ACTIONS(1440),
    [anon_sym_str] = ACTIONS(1440),
    [anon_sym_char] = ACTIONS(1440),
    [anon_sym_DASH] = ACTIONS(1440),
    [anon_sym_SLASH] = ACTIONS(1440),
    [anon_sym_PERCENT] = ACTIONS(1440),
    [anon_sym_CARET] = ACTIONS(1440),
    [anon_sym_AMP] = ACTIONS(1440),
    [anon_sym_PIPE] = ACTIONS(1440),
    [anon_sym_AMP_AMP] = ACTIONS(1438),
    [anon_sym_PIPE_PIPE] = ACTIONS(1438),
    [anon_sym_LT_LT] = ACTIONS(1440),
    [anon_sym_GT_GT] = ACTIONS(1440),
    [anon_sym_PLUS_EQ] = ACTIONS(1438),
    [anon_sym_DASH_EQ] = ACTIONS(1438),
    [anon_sym_STAR_EQ] = ACTIONS(1438),
    [anon_sym_SLASH_EQ] = ACTIONS(1438),
    [anon_sym_PERCENT_EQ] = ACTIONS(1438),
    [anon_sym_CARET_EQ] = ACTIONS(1438),
    [anon_sym_AMP_EQ] = ACTIONS(1438),
    [anon_sym_PIPE_EQ] = ACTIONS(1438),
    [anon_sym_LT_LT_EQ] = ACTIONS(1438),
    [anon_sym_GT_GT_EQ] = ACTIONS(1438),
    [anon_sym_EQ] = ACTIONS(1440),
    [anon_sym_EQ_EQ] = ACTIONS(1438),
    [anon_sym_BANG_EQ] = ACTIONS(1438),
    [anon_sym_GT] = ACTIONS(1440),
    [anon_sym_LT] = ACTIONS(1440),
    [anon_sym_GT_EQ] = ACTIONS(1438),
    [anon_sym_LT_EQ] = ACTIONS(1438),
    [anon_sym__] = ACTIONS(1440),
    [anon_sym_DOT] = ACTIONS(1440),
    [anon_sym_DOT_DOT] = ACTIONS(1440),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1438),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1438),
    [anon_sym_COMMA] = ACTIONS(1438),
    [anon_sym_COLON_COLON] = ACTIONS(1438),
    [anon_sym_POUND] = ACTIONS(1438),
    [anon_sym_as] = ACTIONS(1440),
    [anon_sym_const] = ACTIONS(1440),
    [anon_sym_default] = ACTIONS(1440),
    [anon_sym_union] = ACTIONS(1440),
    [anon_sym_ref] = ACTIONS(1440),
    [sym_mutable_specifier] = ACTIONS(1440),
    [sym_integer_literal] = ACTIONS(1438),
    [aux_sym_string_literal_token1] = ACTIONS(1438),
    [sym_char_literal] = ACTIONS(1438),
    [anon_sym_true] = ACTIONS(1440),
    [anon_sym_false] = ACTIONS(1440),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1440),
    [sym_super] = ACTIONS(1440),
    [sym_crate] = ACTIONS(1440),
    [sym_metavariable] = ACTIONS(1438),
    [sym__raw_string_literal_start] = ACTIONS(1438),
    [sym_float_literal] = ACTIONS(1438),
  },
  [474] = {
    [sym_line_comment] = STATE(474),
    [sym_block_comment] = STATE(474),
    [sym_identifier] = ACTIONS(1338),
    [anon_sym_LPAREN] = ACTIONS(1336),
    [anon_sym_LBRACK] = ACTIONS(1336),
    [anon_sym_RBRACE] = ACTIONS(1336),
    [anon_sym_PLUS] = ACTIONS(1338),
    [anon_sym_STAR] = ACTIONS(1338),
    [anon_sym_QMARK] = ACTIONS(1336),
    [anon_sym_u8] = ACTIONS(1338),
    [anon_sym_i8] = ACTIONS(1338),
    [anon_sym_u16] = ACTIONS(1338),
    [anon_sym_i16] = ACTIONS(1338),
    [anon_sym_u32] = ACTIONS(1338),
    [anon_sym_i32] = ACTIONS(1338),
    [anon_sym_u64] = ACTIONS(1338),
    [anon_sym_i64] = ACTIONS(1338),
    [anon_sym_u128] = ACTIONS(1338),
    [anon_sym_i128] = ACTIONS(1338),
    [anon_sym_isize] = ACTIONS(1338),
    [anon_sym_usize] = ACTIONS(1338),
    [anon_sym_f32] = ACTIONS(1338),
    [anon_sym_f64] = ACTIONS(1338),
    [anon_sym_bool] = ACTIONS(1338),
    [anon_sym_str] = ACTIONS(1338),
    [anon_sym_char] = ACTIONS(1338),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_SLASH] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_CARET] = ACTIONS(1338),
    [anon_sym_AMP] = ACTIONS(1338),
    [anon_sym_PIPE] = ACTIONS(1338),
    [anon_sym_AMP_AMP] = ACTIONS(1336),
    [anon_sym_PIPE_PIPE] = ACTIONS(1336),
    [anon_sym_LT_LT] = ACTIONS(1338),
    [anon_sym_GT_GT] = ACTIONS(1338),
    [anon_sym_PLUS_EQ] = ACTIONS(1336),
    [anon_sym_DASH_EQ] = ACTIONS(1336),
    [anon_sym_STAR_EQ] = ACTIONS(1336),
    [anon_sym_SLASH_EQ] = ACTIONS(1336),
    [anon_sym_PERCENT_EQ] = ACTIONS(1336),
    [anon_sym_CARET_EQ] = ACTIONS(1336),
    [anon_sym_AMP_EQ] = ACTIONS(1336),
    [anon_sym_PIPE_EQ] = ACTIONS(1336),
    [anon_sym_LT_LT_EQ] = ACTIONS(1336),
    [anon_sym_GT_GT_EQ] = ACTIONS(1336),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_EQ_EQ] = ACTIONS(1336),
    [anon_sym_BANG_EQ] = ACTIONS(1336),
    [anon_sym_GT] = ACTIONS(1338),
    [anon_sym_LT] = ACTIONS(1338),
    [anon_sym_GT_EQ] = ACTIONS(1336),
    [anon_sym_LT_EQ] = ACTIONS(1336),
    [anon_sym__] = ACTIONS(1338),
    [anon_sym_DOT] = ACTIONS(1338),
    [anon_sym_DOT_DOT] = ACTIONS(1338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1336),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1336),
    [anon_sym_COMMA] = ACTIONS(1336),
    [anon_sym_COLON_COLON] = ACTIONS(1336),
    [anon_sym_POUND] = ACTIONS(1336),
    [anon_sym_as] = ACTIONS(1338),
    [anon_sym_const] = ACTIONS(1338),
    [anon_sym_default] = ACTIONS(1338),
    [anon_sym_union] = ACTIONS(1338),
    [anon_sym_ref] = ACTIONS(1338),
    [sym_mutable_specifier] = ACTIONS(1338),
    [sym_integer_literal] = ACTIONS(1336),
    [aux_sym_string_literal_token1] = ACTIONS(1336),
    [sym_char_literal] = ACTIONS(1336),
    [anon_sym_true] = ACTIONS(1338),
    [anon_sym_false] = ACTIONS(1338),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1338),
    [sym_super] = ACTIONS(1338),
    [sym_crate] = ACTIONS(1338),
    [sym_metavariable] = ACTIONS(1336),
    [sym__raw_string_literal_start] = ACTIONS(1336),
    [sym_float_literal] = ACTIONS(1336),
  },
  [475] = {
    [sym_attribute_item] = STATE(1471),
    [sym_inner_attribute_item] = STATE(1471),
    [sym_bracketed_type] = STATE(3513),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3115),
    [sym_macro_invocation] = STATE(2834),
    [sym_scoped_identifier] = STATE(2137),
    [sym_scoped_type_identifier] = STATE(2851),
    [sym_match_arm] = STATE(1473),
    [sym_last_match_arm] = STATE(3543),
    [sym_match_pattern] = STATE(3355),
    [sym_const_block] = STATE(2834),
    [sym__pattern] = STATE(2828),
    [sym_tuple_pattern] = STATE(2834),
    [sym_slice_pattern] = STATE(2834),
    [sym_tuple_struct_pattern] = STATE(2834),
    [sym_struct_pattern] = STATE(2834),
    [sym_remaining_field_pattern] = STATE(2834),
    [sym_mut_pattern] = STATE(2834),
    [sym_range_pattern] = STATE(2834),
    [sym_ref_pattern] = STATE(2834),
    [sym_captured_pattern] = STATE(2834),
    [sym_reference_pattern] = STATE(2834),
    [sym_or_pattern] = STATE(2834),
    [sym__literal_pattern] = STATE(2336),
    [sym_negative_literal] = STATE(2345),
    [sym_string_literal] = STATE(2345),
    [sym_raw_string_literal] = STATE(2345),
    [sym_boolean_literal] = STATE(2345),
    [sym_line_comment] = STATE(475),
    [sym_block_comment] = STATE(475),
    [aux_sym_match_block_repeat1] = STATE(536),
    [aux_sym_match_arm_repeat1] = STATE(752),
    [sym_identifier] = ACTIONS(1608),
    [anon_sym_LPAREN] = ACTIONS(1610),
    [anon_sym_LBRACK] = ACTIONS(1612),
    [anon_sym_u8] = ACTIONS(1616),
    [anon_sym_i8] = ACTIONS(1616),
    [anon_sym_u16] = ACTIONS(1616),
    [anon_sym_i16] = ACTIONS(1616),
    [anon_sym_u32] = ACTIONS(1616),
    [anon_sym_i32] = ACTIONS(1616),
    [anon_sym_u64] = ACTIONS(1616),
    [anon_sym_i64] = ACTIONS(1616),
    [anon_sym_u128] = ACTIONS(1616),
    [anon_sym_i128] = ACTIONS(1616),
    [anon_sym_isize] = ACTIONS(1616),
    [anon_sym_usize] = ACTIONS(1616),
    [anon_sym_f32] = ACTIONS(1616),
    [anon_sym_f64] = ACTIONS(1616),
    [anon_sym_bool] = ACTIONS(1616),
    [anon_sym_str] = ACTIONS(1616),
    [anon_sym_char] = ACTIONS(1616),
    [anon_sym_DASH] = ACTIONS(1618),
    [anon_sym_AMP] = ACTIONS(1620),
    [anon_sym_PIPE] = ACTIONS(1622),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1624),
    [anon_sym_DOT_DOT] = ACTIONS(1626),
    [anon_sym_COLON_COLON] = ACTIONS(1628),
    [anon_sym_POUND] = ACTIONS(1630),
    [anon_sym_const] = ACTIONS(1632),
    [anon_sym_default] = ACTIONS(1634),
    [anon_sym_union] = ACTIONS(1634),
    [anon_sym_ref] = ACTIONS(1636),
    [sym_mutable_specifier] = ACTIONS(1638),
    [sym_integer_literal] = ACTIONS(1640),
    [aux_sym_string_literal_token1] = ACTIONS(1642),
    [sym_char_literal] = ACTIONS(1640),
    [anon_sym_true] = ACTIONS(1644),
    [anon_sym_false] = ACTIONS(1644),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1646),
    [sym_super] = ACTIONS(1646),
    [sym_crate] = ACTIONS(1646),
    [sym_metavariable] = ACTIONS(1648),
    [sym__raw_string_literal_start] = ACTIONS(1650),
    [sym_float_literal] = ACTIONS(1640),
  },
  [476] = {
    [sym_attribute_item] = STATE(1471),
    [sym_inner_attribute_item] = STATE(1471),
    [sym_bracketed_type] = STATE(3513),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3115),
    [sym_macro_invocation] = STATE(2834),
    [sym_scoped_identifier] = STATE(2137),
    [sym_scoped_type_identifier] = STATE(2851),
    [sym_match_arm] = STATE(1473),
    [sym_last_match_arm] = STATE(3442),
    [sym_match_pattern] = STATE(3355),
    [sym_const_block] = STATE(2834),
    [sym__pattern] = STATE(2828),
    [sym_tuple_pattern] = STATE(2834),
    [sym_slice_pattern] = STATE(2834),
    [sym_tuple_struct_pattern] = STATE(2834),
    [sym_struct_pattern] = STATE(2834),
    [sym_remaining_field_pattern] = STATE(2834),
    [sym_mut_pattern] = STATE(2834),
    [sym_range_pattern] = STATE(2834),
    [sym_ref_pattern] = STATE(2834),
    [sym_captured_pattern] = STATE(2834),
    [sym_reference_pattern] = STATE(2834),
    [sym_or_pattern] = STATE(2834),
    [sym__literal_pattern] = STATE(2336),
    [sym_negative_literal] = STATE(2345),
    [sym_string_literal] = STATE(2345),
    [sym_raw_string_literal] = STATE(2345),
    [sym_boolean_literal] = STATE(2345),
    [sym_line_comment] = STATE(476),
    [sym_block_comment] = STATE(476),
    [aux_sym_match_block_repeat1] = STATE(536),
    [aux_sym_match_arm_repeat1] = STATE(752),
    [sym_identifier] = ACTIONS(1608),
    [anon_sym_LPAREN] = ACTIONS(1610),
    [anon_sym_LBRACK] = ACTIONS(1612),
    [anon_sym_u8] = ACTIONS(1616),
    [anon_sym_i8] = ACTIONS(1616),
    [anon_sym_u16] = ACTIONS(1616),
    [anon_sym_i16] = ACTIONS(1616),
    [anon_sym_u32] = ACTIONS(1616),
    [anon_sym_i32] = ACTIONS(1616),
    [anon_sym_u64] = ACTIONS(1616),
    [anon_sym_i64] = ACTIONS(1616),
    [anon_sym_u128] = ACTIONS(1616),
    [anon_sym_i128] = ACTIONS(1616),
    [anon_sym_isize] = ACTIONS(1616),
    [anon_sym_usize] = ACTIONS(1616),
    [anon_sym_f32] = ACTIONS(1616),
    [anon_sym_f64] = ACTIONS(1616),
    [anon_sym_bool] = ACTIONS(1616),
    [anon_sym_str] = ACTIONS(1616),
    [anon_sym_char] = ACTIONS(1616),
    [anon_sym_DASH] = ACTIONS(1618),
    [anon_sym_AMP] = ACTIONS(1620),
    [anon_sym_PIPE] = ACTIONS(1622),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1624),
    [anon_sym_DOT_DOT] = ACTIONS(1626),
    [anon_sym_COLON_COLON] = ACTIONS(1628),
    [anon_sym_POUND] = ACTIONS(1630),
    [anon_sym_const] = ACTIONS(1632),
    [anon_sym_default] = ACTIONS(1634),
    [anon_sym_union] = ACTIONS(1634),
    [anon_sym_ref] = ACTIONS(1636),
    [sym_mutable_specifier] = ACTIONS(1638),
    [sym_integer_literal] = ACTIONS(1640),
    [aux_sym_string_literal_token1] = ACTIONS(1642),
    [sym_char_literal] = ACTIONS(1640),
    [anon_sym_true] = ACTIONS(1644),
    [anon_sym_false] = ACTIONS(1644),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1646),
    [sym_super] = ACTIONS(1646),
    [sym_crate] = ACTIONS(1646),
    [sym_metavariable] = ACTIONS(1648),
    [sym__raw_string_literal_start] = ACTIONS(1650),
    [sym_float_literal] = ACTIONS(1640),
  },
  [477] = {
    [sym_attribute_item] = STATE(1471),
    [sym_inner_attribute_item] = STATE(1471),
    [sym_bracketed_type] = STATE(3513),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3115),
    [sym_macro_invocation] = STATE(2834),
    [sym_scoped_identifier] = STATE(2137),
    [sym_scoped_type_identifier] = STATE(2851),
    [sym_match_arm] = STATE(1473),
    [sym_last_match_arm] = STATE(3392),
    [sym_match_pattern] = STATE(3355),
    [sym_const_block] = STATE(2834),
    [sym__pattern] = STATE(2828),
    [sym_tuple_pattern] = STATE(2834),
    [sym_slice_pattern] = STATE(2834),
    [sym_tuple_struct_pattern] = STATE(2834),
    [sym_struct_pattern] = STATE(2834),
    [sym_remaining_field_pattern] = STATE(2834),
    [sym_mut_pattern] = STATE(2834),
    [sym_range_pattern] = STATE(2834),
    [sym_ref_pattern] = STATE(2834),
    [sym_captured_pattern] = STATE(2834),
    [sym_reference_pattern] = STATE(2834),
    [sym_or_pattern] = STATE(2834),
    [sym__literal_pattern] = STATE(2336),
    [sym_negative_literal] = STATE(2345),
    [sym_string_literal] = STATE(2345),
    [sym_raw_string_literal] = STATE(2345),
    [sym_boolean_literal] = STATE(2345),
    [sym_line_comment] = STATE(477),
    [sym_block_comment] = STATE(477),
    [aux_sym_match_block_repeat1] = STATE(536),
    [aux_sym_match_arm_repeat1] = STATE(752),
    [sym_identifier] = ACTIONS(1608),
    [anon_sym_LPAREN] = ACTIONS(1610),
    [anon_sym_LBRACK] = ACTIONS(1612),
    [anon_sym_u8] = ACTIONS(1616),
    [anon_sym_i8] = ACTIONS(1616),
    [anon_sym_u16] = ACTIONS(1616),
    [anon_sym_i16] = ACTIONS(1616),
    [anon_sym_u32] = ACTIONS(1616),
    [anon_sym_i32] = ACTIONS(1616),
    [anon_sym_u64] = ACTIONS(1616),
    [anon_sym_i64] = ACTIONS(1616),
    [anon_sym_u128] = ACTIONS(1616),
    [anon_sym_i128] = ACTIONS(1616),
    [anon_sym_isize] = ACTIONS(1616),
    [anon_sym_usize] = ACTIONS(1616),
    [anon_sym_f32] = ACTIONS(1616),
    [anon_sym_f64] = ACTIONS(1616),
    [anon_sym_bool] = ACTIONS(1616),
    [anon_sym_str] = ACTIONS(1616),
    [anon_sym_char] = ACTIONS(1616),
    [anon_sym_DASH] = ACTIONS(1618),
    [anon_sym_AMP] = ACTIONS(1620),
    [anon_sym_PIPE] = ACTIONS(1622),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1624),
    [anon_sym_DOT_DOT] = ACTIONS(1626),
    [anon_sym_COLON_COLON] = ACTIONS(1628),
    [anon_sym_POUND] = ACTIONS(1630),
    [anon_sym_const] = ACTIONS(1632),
    [anon_sym_default] = ACTIONS(1634),
    [anon_sym_union] = ACTIONS(1634),
    [anon_sym_ref] = ACTIONS(1636),
    [sym_mutable_specifier] = ACTIONS(1638),
    [sym_integer_literal] = ACTIONS(1640),
    [aux_sym_string_literal_token1] = ACTIONS(1642),
    [sym_char_literal] = ACTIONS(1640),
    [anon_sym_true] = ACTIONS(1644),
    [anon_sym_false] = ACTIONS(1644),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1646),
    [sym_super] = ACTIONS(1646),
    [sym_crate] = ACTIONS(1646),
    [sym_metavariable] = ACTIONS(1648),
    [sym__raw_string_literal_start] = ACTIONS(1650),
    [sym_float_literal] = ACTIONS(1640),
  },
  [478] = {
    [sym_attribute_item] = STATE(1471),
    [sym_inner_attribute_item] = STATE(1471),
    [sym_bracketed_type] = STATE(3513),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3115),
    [sym_macro_invocation] = STATE(2834),
    [sym_scoped_identifier] = STATE(2137),
    [sym_scoped_type_identifier] = STATE(2851),
    [sym_match_arm] = STATE(1473),
    [sym_last_match_arm] = STATE(3393),
    [sym_match_pattern] = STATE(3355),
    [sym_const_block] = STATE(2834),
    [sym__pattern] = STATE(2828),
    [sym_tuple_pattern] = STATE(2834),
    [sym_slice_pattern] = STATE(2834),
    [sym_tuple_struct_pattern] = STATE(2834),
    [sym_struct_pattern] = STATE(2834),
    [sym_remaining_field_pattern] = STATE(2834),
    [sym_mut_pattern] = STATE(2834),
    [sym_range_pattern] = STATE(2834),
    [sym_ref_pattern] = STATE(2834),
    [sym_captured_pattern] = STATE(2834),
    [sym_reference_pattern] = STATE(2834),
    [sym_or_pattern] = STATE(2834),
    [sym__literal_pattern] = STATE(2336),
    [sym_negative_literal] = STATE(2345),
    [sym_string_literal] = STATE(2345),
    [sym_raw_string_literal] = STATE(2345),
    [sym_boolean_literal] = STATE(2345),
    [sym_line_comment] = STATE(478),
    [sym_block_comment] = STATE(478),
    [aux_sym_match_block_repeat1] = STATE(536),
    [aux_sym_match_arm_repeat1] = STATE(752),
    [sym_identifier] = ACTIONS(1608),
    [anon_sym_LPAREN] = ACTIONS(1610),
    [anon_sym_LBRACK] = ACTIONS(1612),
    [anon_sym_u8] = ACTIONS(1616),
    [anon_sym_i8] = ACTIONS(1616),
    [anon_sym_u16] = ACTIONS(1616),
    [anon_sym_i16] = ACTIONS(1616),
    [anon_sym_u32] = ACTIONS(1616),
    [anon_sym_i32] = ACTIONS(1616),
    [anon_sym_u64] = ACTIONS(1616),
    [anon_sym_i64] = ACTIONS(1616),
    [anon_sym_u128] = ACTIONS(1616),
    [anon_sym_i128] = ACTIONS(1616),
    [anon_sym_isize] = ACTIONS(1616),
    [anon_sym_usize] = ACTIONS(1616),
    [anon_sym_f32] = ACTIONS(1616),
    [anon_sym_f64] = ACTIONS(1616),
    [anon_sym_bool] = ACTIONS(1616),
    [anon_sym_str] = ACTIONS(1616),
    [anon_sym_char] = ACTIONS(1616),
    [anon_sym_DASH] = ACTIONS(1618),
    [anon_sym_AMP] = ACTIONS(1620),
    [anon_sym_PIPE] = ACTIONS(1622),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1624),
    [anon_sym_DOT_DOT] = ACTIONS(1626),
    [anon_sym_COLON_COLON] = ACTIONS(1628),
    [anon_sym_POUND] = ACTIONS(1630),
    [anon_sym_const] = ACTIONS(1632),
    [anon_sym_default] = ACTIONS(1634),
    [anon_sym_union] = ACTIONS(1634),
    [anon_sym_ref] = ACTIONS(1636),
    [sym_mutable_specifier] = ACTIONS(1638),
    [sym_integer_literal] = ACTIONS(1640),
    [aux_sym_string_literal_token1] = ACTIONS(1642),
    [sym_char_literal] = ACTIONS(1640),
    [anon_sym_true] = ACTIONS(1644),
    [anon_sym_false] = ACTIONS(1644),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1646),
    [sym_super] = ACTIONS(1646),
    [sym_crate] = ACTIONS(1646),
    [sym_metavariable] = ACTIONS(1648),
    [sym__raw_string_literal_start] = ACTIONS(1650),
    [sym_float_literal] = ACTIONS(1640),
  },
  [479] = {
    [sym_line_comment] = STATE(479),
    [sym_block_comment] = STATE(479),
    [ts_builtin_sym_end] = ACTIONS(1662),
    [sym_identifier] = ACTIONS(1664),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_macro_rules_BANG] = ACTIONS(1662),
    [anon_sym_LPAREN] = ACTIONS(1662),
    [anon_sym_LBRACK] = ACTIONS(1662),
    [anon_sym_LBRACE] = ACTIONS(1662),
    [anon_sym_RBRACE] = ACTIONS(1662),
    [anon_sym_STAR] = ACTIONS(1662),
    [anon_sym_u8] = ACTIONS(1664),
    [anon_sym_i8] = ACTIONS(1664),
    [anon_sym_u16] = ACTIONS(1664),
    [anon_sym_i16] = ACTIONS(1664),
    [anon_sym_u32] = ACTIONS(1664),
    [anon_sym_i32] = ACTIONS(1664),
    [anon_sym_u64] = ACTIONS(1664),
    [anon_sym_i64] = ACTIONS(1664),
    [anon_sym_u128] = ACTIONS(1664),
    [anon_sym_i128] = ACTIONS(1664),
    [anon_sym_isize] = ACTIONS(1664),
    [anon_sym_usize] = ACTIONS(1664),
    [anon_sym_f32] = ACTIONS(1664),
    [anon_sym_f64] = ACTIONS(1664),
    [anon_sym_bool] = ACTIONS(1664),
    [anon_sym_str] = ACTIONS(1664),
    [anon_sym_char] = ACTIONS(1664),
    [anon_sym_DASH] = ACTIONS(1662),
    [anon_sym_BANG] = ACTIONS(1662),
    [anon_sym_AMP] = ACTIONS(1662),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_LT] = ACTIONS(1662),
    [anon_sym_DOT_DOT] = ACTIONS(1662),
    [anon_sym_COLON_COLON] = ACTIONS(1662),
    [anon_sym_POUND] = ACTIONS(1662),
    [anon_sym_SQUOTE] = ACTIONS(1664),
    [anon_sym_async] = ACTIONS(1664),
    [anon_sym_break] = ACTIONS(1664),
    [anon_sym_const] = ACTIONS(1664),
    [anon_sym_continue] = ACTIONS(1664),
    [anon_sym_default] = ACTIONS(1664),
    [anon_sym_enum] = ACTIONS(1664),
    [anon_sym_fn] = ACTIONS(1664),
    [anon_sym_for] = ACTIONS(1664),
    [anon_sym_if] = ACTIONS(1664),
    [anon_sym_impl] = ACTIONS(1664),
    [anon_sym_let] = ACTIONS(1664),
    [anon_sym_loop] = ACTIONS(1664),
    [anon_sym_match] = ACTIONS(1664),
    [anon_sym_mod] = ACTIONS(1664),
    [anon_sym_pub] = ACTIONS(1664),
    [anon_sym_return] = ACTIONS(1664),
    [anon_sym_static] = ACTIONS(1664),
    [anon_sym_struct] = ACTIONS(1664),
    [anon_sym_trait] = ACTIONS(1664),
    [anon_sym_type] = ACTIONS(1664),
    [anon_sym_union] = ACTIONS(1664),
    [anon_sym_unsafe] = ACTIONS(1664),
    [anon_sym_use] = ACTIONS(1664),
    [anon_sym_while] = ACTIONS(1664),
    [anon_sym_extern] = ACTIONS(1664),
    [anon_sym_yield] = ACTIONS(1664),
    [anon_sym_move] = ACTIONS(1664),
    [anon_sym_try] = ACTIONS(1664),
    [sym_integer_literal] = ACTIONS(1662),
    [aux_sym_string_literal_token1] = ACTIONS(1662),
    [sym_char_literal] = ACTIONS(1662),
    [anon_sym_true] = ACTIONS(1664),
    [anon_sym_false] = ACTIONS(1664),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1664),
    [sym_super] = ACTIONS(1664),
    [sym_crate] = ACTIONS(1664),
    [sym_metavariable] = ACTIONS(1662),
    [sym__raw_string_literal_start] = ACTIONS(1662),
    [sym_float_literal] = ACTIONS(1662),
  },
  [480] = {
    [sym_line_comment] = STATE(480),
    [sym_block_comment] = STATE(480),
    [ts_builtin_sym_end] = ACTIONS(1666),
    [sym_identifier] = ACTIONS(1668),
    [anon_sym_SEMI] = ACTIONS(1666),
    [anon_sym_macro_rules_BANG] = ACTIONS(1666),
    [anon_sym_LPAREN] = ACTIONS(1666),
    [anon_sym_LBRACK] = ACTIONS(1666),
    [anon_sym_LBRACE] = ACTIONS(1666),
    [anon_sym_RBRACE] = ACTIONS(1666),
    [anon_sym_STAR] = ACTIONS(1666),
    [anon_sym_u8] = ACTIONS(1668),
    [anon_sym_i8] = ACTIONS(1668),
    [anon_sym_u16] = ACTIONS(1668),
    [anon_sym_i16] = ACTIONS(1668),
    [anon_sym_u32] = ACTIONS(1668),
    [anon_sym_i32] = ACTIONS(1668),
    [anon_sym_u64] = ACTIONS(1668),
    [anon_sym_i64] = ACTIONS(1668),
    [anon_sym_u128] = ACTIONS(1668),
    [anon_sym_i128] = ACTIONS(1668),
    [anon_sym_isize] = ACTIONS(1668),
    [anon_sym_usize] = ACTIONS(1668),
    [anon_sym_f32] = ACTIONS(1668),
    [anon_sym_f64] = ACTIONS(1668),
    [anon_sym_bool] = ACTIONS(1668),
    [anon_sym_str] = ACTIONS(1668),
    [anon_sym_char] = ACTIONS(1668),
    [anon_sym_DASH] = ACTIONS(1666),
    [anon_sym_BANG] = ACTIONS(1666),
    [anon_sym_AMP] = ACTIONS(1666),
    [anon_sym_PIPE] = ACTIONS(1666),
    [anon_sym_LT] = ACTIONS(1666),
    [anon_sym_DOT_DOT] = ACTIONS(1666),
    [anon_sym_COLON_COLON] = ACTIONS(1666),
    [anon_sym_POUND] = ACTIONS(1666),
    [anon_sym_SQUOTE] = ACTIONS(1668),
    [anon_sym_async] = ACTIONS(1668),
    [anon_sym_break] = ACTIONS(1668),
    [anon_sym_const] = ACTIONS(1668),
    [anon_sym_continue] = ACTIONS(1668),
    [anon_sym_default] = ACTIONS(1668),
    [anon_sym_enum] = ACTIONS(1668),
    [anon_sym_fn] = ACTIONS(1668),
    [anon_sym_for] = ACTIONS(1668),
    [anon_sym_if] = ACTIONS(1668),
    [anon_sym_impl] = ACTIONS(1668),
    [anon_sym_let] = ACTIONS(1668),
    [anon_sym_loop] = ACTIONS(1668),
    [anon_sym_match] = ACTIONS(1668),
    [anon_sym_mod] = ACTIONS(1668),
    [anon_sym_pub] = ACTIONS(1668),
    [anon_sym_return] = ACTIONS(1668),
    [anon_sym_static] = ACTIONS(1668),
    [anon_sym_struct] = ACTIONS(1668),
    [anon_sym_trait] = ACTIONS(1668),
    [anon_sym_type] = ACTIONS(1668),
    [anon_sym_union] = ACTIONS(1668),
    [anon_sym_unsafe] = ACTIONS(1668),
    [anon_sym_use] = ACTIONS(1668),
    [anon_sym_while] = ACTIONS(1668),
    [anon_sym_extern] = ACTIONS(1668),
    [anon_sym_yield] = ACTIONS(1668),
    [anon_sym_move] = ACTIONS(1668),
    [anon_sym_try] = ACTIONS(1668),
    [sym_integer_literal] = ACTIONS(1666),
    [aux_sym_string_literal_token1] = ACTIONS(1666),
    [sym_char_literal] = ACTIONS(1666),
    [anon_sym_true] = ACTIONS(1668),
    [anon_sym_false] = ACTIONS(1668),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1668),
    [sym_super] = ACTIONS(1668),
    [sym_crate] = ACTIONS(1668),
    [sym_metavariable] = ACTIONS(1666),
    [sym__raw_string_literal_start] = ACTIONS(1666),
    [sym_float_literal] = ACTIONS(1666),
  },
  [481] = {
    [sym_line_comment] = STATE(481),
    [sym_block_comment] = STATE(481),
    [ts_builtin_sym_end] = ACTIONS(1670),
    [sym_identifier] = ACTIONS(1672),
    [anon_sym_SEMI] = ACTIONS(1670),
    [anon_sym_macro_rules_BANG] = ACTIONS(1670),
    [anon_sym_LPAREN] = ACTIONS(1670),
    [anon_sym_LBRACK] = ACTIONS(1670),
    [anon_sym_LBRACE] = ACTIONS(1670),
    [anon_sym_RBRACE] = ACTIONS(1670),
    [anon_sym_STAR] = ACTIONS(1670),
    [anon_sym_u8] = ACTIONS(1672),
    [anon_sym_i8] = ACTIONS(1672),
    [anon_sym_u16] = ACTIONS(1672),
    [anon_sym_i16] = ACTIONS(1672),
    [anon_sym_u32] = ACTIONS(1672),
    [anon_sym_i32] = ACTIONS(1672),
    [anon_sym_u64] = ACTIONS(1672),
    [anon_sym_i64] = ACTIONS(1672),
    [anon_sym_u128] = ACTIONS(1672),
    [anon_sym_i128] = ACTIONS(1672),
    [anon_sym_isize] = ACTIONS(1672),
    [anon_sym_usize] = ACTIONS(1672),
    [anon_sym_f32] = ACTIONS(1672),
    [anon_sym_f64] = ACTIONS(1672),
    [anon_sym_bool] = ACTIONS(1672),
    [anon_sym_str] = ACTIONS(1672),
    [anon_sym_char] = ACTIONS(1672),
    [anon_sym_DASH] = ACTIONS(1670),
    [anon_sym_BANG] = ACTIONS(1670),
    [anon_sym_AMP] = ACTIONS(1670),
    [anon_sym_PIPE] = ACTIONS(1670),
    [anon_sym_LT] = ACTIONS(1670),
    [anon_sym_DOT_DOT] = ACTIONS(1670),
    [anon_sym_COLON_COLON] = ACTIONS(1670),
    [anon_sym_POUND] = ACTIONS(1670),
    [anon_sym_SQUOTE] = ACTIONS(1672),
    [anon_sym_async] = ACTIONS(1672),
    [anon_sym_break] = ACTIONS(1672),
    [anon_sym_const] = ACTIONS(1672),
    [anon_sym_continue] = ACTIONS(1672),
    [anon_sym_default] = ACTIONS(1672),
    [anon_sym_enum] = ACTIONS(1672),
    [anon_sym_fn] = ACTIONS(1672),
    [anon_sym_for] = ACTIONS(1672),
    [anon_sym_if] = ACTIONS(1672),
    [anon_sym_impl] = ACTIONS(1672),
    [anon_sym_let] = ACTIONS(1672),
    [anon_sym_loop] = ACTIONS(1672),
    [anon_sym_match] = ACTIONS(1672),
    [anon_sym_mod] = ACTIONS(1672),
    [anon_sym_pub] = ACTIONS(1672),
    [anon_sym_return] = ACTIONS(1672),
    [anon_sym_static] = ACTIONS(1672),
    [anon_sym_struct] = ACTIONS(1672),
    [anon_sym_trait] = ACTIONS(1672),
    [anon_sym_type] = ACTIONS(1672),
    [anon_sym_union] = ACTIONS(1672),
    [anon_sym_unsafe] = ACTIONS(1672),
    [anon_sym_use] = ACTIONS(1672),
    [anon_sym_while] = ACTIONS(1672),
    [anon_sym_extern] = ACTIONS(1672),
    [anon_sym_yield] = ACTIONS(1672),
    [anon_sym_move] = ACTIONS(1672),
    [anon_sym_try] = ACTIONS(1672),
    [sym_integer_literal] = ACTIONS(1670),
    [aux_sym_string_literal_token1] = ACTIONS(1670),
    [sym_char_literal] = ACTIONS(1670),
    [anon_sym_true] = ACTIONS(1672),
    [anon_sym_false] = ACTIONS(1672),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1672),
    [sym_super] = ACTIONS(1672),
    [sym_crate] = ACTIONS(1672),
    [sym_metavariable] = ACTIONS(1670),
    [sym__raw_string_literal_start] = ACTIONS(1670),
    [sym_float_literal] = ACTIONS(1670),
  },
  [482] = {
    [sym_line_comment] = STATE(482),
    [sym_block_comment] = STATE(482),
    [ts_builtin_sym_end] = ACTIONS(1674),
    [sym_identifier] = ACTIONS(1676),
    [anon_sym_SEMI] = ACTIONS(1674),
    [anon_sym_macro_rules_BANG] = ACTIONS(1674),
    [anon_sym_LPAREN] = ACTIONS(1674),
    [anon_sym_LBRACK] = ACTIONS(1674),
    [anon_sym_LBRACE] = ACTIONS(1674),
    [anon_sym_RBRACE] = ACTIONS(1674),
    [anon_sym_STAR] = ACTIONS(1674),
    [anon_sym_u8] = ACTIONS(1676),
    [anon_sym_i8] = ACTIONS(1676),
    [anon_sym_u16] = ACTIONS(1676),
    [anon_sym_i16] = ACTIONS(1676),
    [anon_sym_u32] = ACTIONS(1676),
    [anon_sym_i32] = ACTIONS(1676),
    [anon_sym_u64] = ACTIONS(1676),
    [anon_sym_i64] = ACTIONS(1676),
    [anon_sym_u128] = ACTIONS(1676),
    [anon_sym_i128] = ACTIONS(1676),
    [anon_sym_isize] = ACTIONS(1676),
    [anon_sym_usize] = ACTIONS(1676),
    [anon_sym_f32] = ACTIONS(1676),
    [anon_sym_f64] = ACTIONS(1676),
    [anon_sym_bool] = ACTIONS(1676),
    [anon_sym_str] = ACTIONS(1676),
    [anon_sym_char] = ACTIONS(1676),
    [anon_sym_DASH] = ACTIONS(1674),
    [anon_sym_BANG] = ACTIONS(1674),
    [anon_sym_AMP] = ACTIONS(1674),
    [anon_sym_PIPE] = ACTIONS(1674),
    [anon_sym_LT] = ACTIONS(1674),
    [anon_sym_DOT_DOT] = ACTIONS(1674),
    [anon_sym_COLON_COLON] = ACTIONS(1674),
    [anon_sym_POUND] = ACTIONS(1674),
    [anon_sym_SQUOTE] = ACTIONS(1676),
    [anon_sym_async] = ACTIONS(1676),
    [anon_sym_break] = ACTIONS(1676),
    [anon_sym_const] = ACTIONS(1676),
    [anon_sym_continue] = ACTIONS(1676),
    [anon_sym_default] = ACTIONS(1676),
    [anon_sym_enum] = ACTIONS(1676),
    [anon_sym_fn] = ACTIONS(1676),
    [anon_sym_for] = ACTIONS(1676),
    [anon_sym_if] = ACTIONS(1676),
    [anon_sym_impl] = ACTIONS(1676),
    [anon_sym_let] = ACTIONS(1676),
    [anon_sym_loop] = ACTIONS(1676),
    [anon_sym_match] = ACTIONS(1676),
    [anon_sym_mod] = ACTIONS(1676),
    [anon_sym_pub] = ACTIONS(1676),
    [anon_sym_return] = ACTIONS(1676),
    [anon_sym_static] = ACTIONS(1676),
    [anon_sym_struct] = ACTIONS(1676),
    [anon_sym_trait] = ACTIONS(1676),
    [anon_sym_type] = ACTIONS(1676),
    [anon_sym_union] = ACTIONS(1676),
    [anon_sym_unsafe] = ACTIONS(1676),
    [anon_sym_use] = ACTIONS(1676),
    [anon_sym_while] = ACTIONS(1676),
    [anon_sym_extern] = ACTIONS(1676),
    [anon_sym_yield] = ACTIONS(1676),
    [anon_sym_move] = ACTIONS(1676),
    [anon_sym_try] = ACTIONS(1676),
    [sym_integer_literal] = ACTIONS(1674),
    [aux_sym_string_literal_token1] = ACTIONS(1674),
    [sym_char_literal] = ACTIONS(1674),
    [anon_sym_true] = ACTIONS(1676),
    [anon_sym_false] = ACTIONS(1676),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1676),
    [sym_super] = ACTIONS(1676),
    [sym_crate] = ACTIONS(1676),
    [sym_metavariable] = ACTIONS(1674),
    [sym__raw_string_literal_start] = ACTIONS(1674),
    [sym_float_literal] = ACTIONS(1674),
  },
  [483] = {
    [sym_line_comment] = STATE(483),
    [sym_block_comment] = STATE(483),
    [ts_builtin_sym_end] = ACTIONS(1678),
    [sym_identifier] = ACTIONS(1680),
    [anon_sym_SEMI] = ACTIONS(1678),
    [anon_sym_macro_rules_BANG] = ACTIONS(1678),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [anon_sym_LBRACK] = ACTIONS(1678),
    [anon_sym_LBRACE] = ACTIONS(1678),
    [anon_sym_RBRACE] = ACTIONS(1678),
    [anon_sym_STAR] = ACTIONS(1678),
    [anon_sym_u8] = ACTIONS(1680),
    [anon_sym_i8] = ACTIONS(1680),
    [anon_sym_u16] = ACTIONS(1680),
    [anon_sym_i16] = ACTIONS(1680),
    [anon_sym_u32] = ACTIONS(1680),
    [anon_sym_i32] = ACTIONS(1680),
    [anon_sym_u64] = ACTIONS(1680),
    [anon_sym_i64] = ACTIONS(1680),
    [anon_sym_u128] = ACTIONS(1680),
    [anon_sym_i128] = ACTIONS(1680),
    [anon_sym_isize] = ACTIONS(1680),
    [anon_sym_usize] = ACTIONS(1680),
    [anon_sym_f32] = ACTIONS(1680),
    [anon_sym_f64] = ACTIONS(1680),
    [anon_sym_bool] = ACTIONS(1680),
    [anon_sym_str] = ACTIONS(1680),
    [anon_sym_char] = ACTIONS(1680),
    [anon_sym_DASH] = ACTIONS(1678),
    [anon_sym_BANG] = ACTIONS(1678),
    [anon_sym_AMP] = ACTIONS(1678),
    [anon_sym_PIPE] = ACTIONS(1678),
    [anon_sym_LT] = ACTIONS(1678),
    [anon_sym_DOT_DOT] = ACTIONS(1678),
    [anon_sym_COLON_COLON] = ACTIONS(1678),
    [anon_sym_POUND] = ACTIONS(1678),
    [anon_sym_SQUOTE] = ACTIONS(1680),
    [anon_sym_async] = ACTIONS(1680),
    [anon_sym_break] = ACTIONS(1680),
    [anon_sym_const] = ACTIONS(1680),
    [anon_sym_continue] = ACTIONS(1680),
    [anon_sym_default] = ACTIONS(1680),
    [anon_sym_enum] = ACTIONS(1680),
    [anon_sym_fn] = ACTIONS(1680),
    [anon_sym_for] = ACTIONS(1680),
    [anon_sym_if] = ACTIONS(1680),
    [anon_sym_impl] = ACTIONS(1680),
    [anon_sym_let] = ACTIONS(1680),
    [anon_sym_loop] = ACTIONS(1680),
    [anon_sym_match] = ACTIONS(1680),
    [anon_sym_mod] = ACTIONS(1680),
    [anon_sym_pub] = ACTIONS(1680),
    [anon_sym_return] = ACTIONS(1680),
    [anon_sym_static] = ACTIONS(1680),
    [anon_sym_struct] = ACTIONS(1680),
    [anon_sym_trait] = ACTIONS(1680),
    [anon_sym_type] = ACTIONS(1680),
    [anon_sym_union] = ACTIONS(1680),
    [anon_sym_unsafe] = ACTIONS(1680),
    [anon_sym_use] = ACTIONS(1680),
    [anon_sym_while] = ACTIONS(1680),
    [anon_sym_extern] = ACTIONS(1680),
    [anon_sym_yield] = ACTIONS(1680),
    [anon_sym_move] = ACTIONS(1680),
    [anon_sym_try] = ACTIONS(1680),
    [sym_integer_literal] = ACTIONS(1678),
    [aux_sym_string_literal_token1] = ACTIONS(1678),
    [sym_char_literal] = ACTIONS(1678),
    [anon_sym_true] = ACTIONS(1680),
    [anon_sym_false] = ACTIONS(1680),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1680),
    [sym_super] = ACTIONS(1680),
    [sym_crate] = ACTIONS(1680),
    [sym_metavariable] = ACTIONS(1678),
    [sym__raw_string_literal_start] = ACTIONS(1678),
    [sym_float_literal] = ACTIONS(1678),
  },
  [484] = {
    [sym_line_comment] = STATE(484),
    [sym_block_comment] = STATE(484),
    [ts_builtin_sym_end] = ACTIONS(1682),
    [sym_identifier] = ACTIONS(1684),
    [anon_sym_SEMI] = ACTIONS(1682),
    [anon_sym_macro_rules_BANG] = ACTIONS(1682),
    [anon_sym_LPAREN] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1682),
    [anon_sym_LBRACE] = ACTIONS(1682),
    [anon_sym_RBRACE] = ACTIONS(1682),
    [anon_sym_STAR] = ACTIONS(1682),
    [anon_sym_u8] = ACTIONS(1684),
    [anon_sym_i8] = ACTIONS(1684),
    [anon_sym_u16] = ACTIONS(1684),
    [anon_sym_i16] = ACTIONS(1684),
    [anon_sym_u32] = ACTIONS(1684),
    [anon_sym_i32] = ACTIONS(1684),
    [anon_sym_u64] = ACTIONS(1684),
    [anon_sym_i64] = ACTIONS(1684),
    [anon_sym_u128] = ACTIONS(1684),
    [anon_sym_i128] = ACTIONS(1684),
    [anon_sym_isize] = ACTIONS(1684),
    [anon_sym_usize] = ACTIONS(1684),
    [anon_sym_f32] = ACTIONS(1684),
    [anon_sym_f64] = ACTIONS(1684),
    [anon_sym_bool] = ACTIONS(1684),
    [anon_sym_str] = ACTIONS(1684),
    [anon_sym_char] = ACTIONS(1684),
    [anon_sym_DASH] = ACTIONS(1682),
    [anon_sym_BANG] = ACTIONS(1682),
    [anon_sym_AMP] = ACTIONS(1682),
    [anon_sym_PIPE] = ACTIONS(1682),
    [anon_sym_LT] = ACTIONS(1682),
    [anon_sym_DOT_DOT] = ACTIONS(1682),
    [anon_sym_COLON_COLON] = ACTIONS(1682),
    [anon_sym_POUND] = ACTIONS(1682),
    [anon_sym_SQUOTE] = ACTIONS(1684),
    [anon_sym_async] = ACTIONS(1684),
    [anon_sym_break] = ACTIONS(1684),
    [anon_sym_const] = ACTIONS(1684),
    [anon_sym_continue] = ACTIONS(1684),
    [anon_sym_default] = ACTIONS(1684),
    [anon_sym_enum] = ACTIONS(1684),
    [anon_sym_fn] = ACTIONS(1684),
    [anon_sym_for] = ACTIONS(1684),
    [anon_sym_if] = ACTIONS(1684),
    [anon_sym_impl] = ACTIONS(1684),
    [anon_sym_let] = ACTIONS(1684),
    [anon_sym_loop] = ACTIONS(1684),
    [anon_sym_match] = ACTIONS(1684),
    [anon_sym_mod] = ACTIONS(1684),
    [anon_sym_pub] = ACTIONS(1684),
    [anon_sym_return] = ACTIONS(1684),
    [anon_sym_static] = ACTIONS(1684),
    [anon_sym_struct] = ACTIONS(1684),
    [anon_sym_trait] = ACTIONS(1684),
    [anon_sym_type] = ACTIONS(1684),
    [anon_sym_union] = ACTIONS(1684),
    [anon_sym_unsafe] = ACTIONS(1684),
    [anon_sym_use] = ACTIONS(1684),
    [anon_sym_while] = ACTIONS(1684),
    [anon_sym_extern] = ACTIONS(1684),
    [anon_sym_yield] = ACTIONS(1684),
    [anon_sym_move] = ACTIONS(1684),
    [anon_sym_try] = ACTIONS(1684),
    [sym_integer_literal] = ACTIONS(1682),
    [aux_sym_string_literal_token1] = ACTIONS(1682),
    [sym_char_literal] = ACTIONS(1682),
    [anon_sym_true] = ACTIONS(1684),
    [anon_sym_false] = ACTIONS(1684),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1684),
    [sym_super] = ACTIONS(1684),
    [sym_crate] = ACTIONS(1684),
    [sym_metavariable] = ACTIONS(1682),
    [sym__raw_string_literal_start] = ACTIONS(1682),
    [sym_float_literal] = ACTIONS(1682),
  },
  [485] = {
    [sym_line_comment] = STATE(485),
    [sym_block_comment] = STATE(485),
    [ts_builtin_sym_end] = ACTIONS(1686),
    [sym_identifier] = ACTIONS(1688),
    [anon_sym_SEMI] = ACTIONS(1686),
    [anon_sym_macro_rules_BANG] = ACTIONS(1686),
    [anon_sym_LPAREN] = ACTIONS(1686),
    [anon_sym_LBRACK] = ACTIONS(1686),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [anon_sym_RBRACE] = ACTIONS(1686),
    [anon_sym_STAR] = ACTIONS(1686),
    [anon_sym_u8] = ACTIONS(1688),
    [anon_sym_i8] = ACTIONS(1688),
    [anon_sym_u16] = ACTIONS(1688),
    [anon_sym_i16] = ACTIONS(1688),
    [anon_sym_u32] = ACTIONS(1688),
    [anon_sym_i32] = ACTIONS(1688),
    [anon_sym_u64] = ACTIONS(1688),
    [anon_sym_i64] = ACTIONS(1688),
    [anon_sym_u128] = ACTIONS(1688),
    [anon_sym_i128] = ACTIONS(1688),
    [anon_sym_isize] = ACTIONS(1688),
    [anon_sym_usize] = ACTIONS(1688),
    [anon_sym_f32] = ACTIONS(1688),
    [anon_sym_f64] = ACTIONS(1688),
    [anon_sym_bool] = ACTIONS(1688),
    [anon_sym_str] = ACTIONS(1688),
    [anon_sym_char] = ACTIONS(1688),
    [anon_sym_DASH] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1686),
    [anon_sym_AMP] = ACTIONS(1686),
    [anon_sym_PIPE] = ACTIONS(1686),
    [anon_sym_LT] = ACTIONS(1686),
    [anon_sym_DOT_DOT] = ACTIONS(1686),
    [anon_sym_COLON_COLON] = ACTIONS(1686),
    [anon_sym_POUND] = ACTIONS(1686),
    [anon_sym_SQUOTE] = ACTIONS(1688),
    [anon_sym_async] = ACTIONS(1688),
    [anon_sym_break] = ACTIONS(1688),
    [anon_sym_const] = ACTIONS(1688),
    [anon_sym_continue] = ACTIONS(1688),
    [anon_sym_default] = ACTIONS(1688),
    [anon_sym_enum] = ACTIONS(1688),
    [anon_sym_fn] = ACTIONS(1688),
    [anon_sym_for] = ACTIONS(1688),
    [anon_sym_if] = ACTIONS(1688),
    [anon_sym_impl] = ACTIONS(1688),
    [anon_sym_let] = ACTIONS(1688),
    [anon_sym_loop] = ACTIONS(1688),
    [anon_sym_match] = ACTIONS(1688),
    [anon_sym_mod] = ACTIONS(1688),
    [anon_sym_pub] = ACTIONS(1688),
    [anon_sym_return] = ACTIONS(1688),
    [anon_sym_static] = ACTIONS(1688),
    [anon_sym_struct] = ACTIONS(1688),
    [anon_sym_trait] = ACTIONS(1688),
    [anon_sym_type] = ACTIONS(1688),
    [anon_sym_union] = ACTIONS(1688),
    [anon_sym_unsafe] = ACTIONS(1688),
    [anon_sym_use] = ACTIONS(1688),
    [anon_sym_while] = ACTIONS(1688),
    [anon_sym_extern] = ACTIONS(1688),
    [anon_sym_yield] = ACTIONS(1688),
    [anon_sym_move] = ACTIONS(1688),
    [anon_sym_try] = ACTIONS(1688),
    [sym_integer_literal] = ACTIONS(1686),
    [aux_sym_string_literal_token1] = ACTIONS(1686),
    [sym_char_literal] = ACTIONS(1686),
    [anon_sym_true] = ACTIONS(1688),
    [anon_sym_false] = ACTIONS(1688),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1688),
    [sym_super] = ACTIONS(1688),
    [sym_crate] = ACTIONS(1688),
    [sym_metavariable] = ACTIONS(1686),
    [sym__raw_string_literal_start] = ACTIONS(1686),
    [sym_float_literal] = ACTIONS(1686),
  },
  [486] = {
    [sym_line_comment] = STATE(486),
    [sym_block_comment] = STATE(486),
    [ts_builtin_sym_end] = ACTIONS(1690),
    [sym_identifier] = ACTIONS(1692),
    [anon_sym_SEMI] = ACTIONS(1690),
    [anon_sym_macro_rules_BANG] = ACTIONS(1690),
    [anon_sym_LPAREN] = ACTIONS(1690),
    [anon_sym_LBRACK] = ACTIONS(1690),
    [anon_sym_LBRACE] = ACTIONS(1690),
    [anon_sym_RBRACE] = ACTIONS(1690),
    [anon_sym_STAR] = ACTIONS(1690),
    [anon_sym_u8] = ACTIONS(1692),
    [anon_sym_i8] = ACTIONS(1692),
    [anon_sym_u16] = ACTIONS(1692),
    [anon_sym_i16] = ACTIONS(1692),
    [anon_sym_u32] = ACTIONS(1692),
    [anon_sym_i32] = ACTIONS(1692),
    [anon_sym_u64] = ACTIONS(1692),
    [anon_sym_i64] = ACTIONS(1692),
    [anon_sym_u128] = ACTIONS(1692),
    [anon_sym_i128] = ACTIONS(1692),
    [anon_sym_isize] = ACTIONS(1692),
    [anon_sym_usize] = ACTIONS(1692),
    [anon_sym_f32] = ACTIONS(1692),
    [anon_sym_f64] = ACTIONS(1692),
    [anon_sym_bool] = ACTIONS(1692),
    [anon_sym_str] = ACTIONS(1692),
    [anon_sym_char] = ACTIONS(1692),
    [anon_sym_DASH] = ACTIONS(1690),
    [anon_sym_BANG] = ACTIONS(1690),
    [anon_sym_AMP] = ACTIONS(1690),
    [anon_sym_PIPE] = ACTIONS(1690),
    [anon_sym_LT] = ACTIONS(1690),
    [anon_sym_DOT_DOT] = ACTIONS(1690),
    [anon_sym_COLON_COLON] = ACTIONS(1690),
    [anon_sym_POUND] = ACTIONS(1690),
    [anon_sym_SQUOTE] = ACTIONS(1692),
    [anon_sym_async] = ACTIONS(1692),
    [anon_sym_break] = ACTIONS(1692),
    [anon_sym_const] = ACTIONS(1692),
    [anon_sym_continue] = ACTIONS(1692),
    [anon_sym_default] = ACTIONS(1692),
    [anon_sym_enum] = ACTIONS(1692),
    [anon_sym_fn] = ACTIONS(1692),
    [anon_sym_for] = ACTIONS(1692),
    [anon_sym_if] = ACTIONS(1692),
    [anon_sym_impl] = ACTIONS(1692),
    [anon_sym_let] = ACTIONS(1692),
    [anon_sym_loop] = ACTIONS(1692),
    [anon_sym_match] = ACTIONS(1692),
    [anon_sym_mod] = ACTIONS(1692),
    [anon_sym_pub] = ACTIONS(1692),
    [anon_sym_return] = ACTIONS(1692),
    [anon_sym_static] = ACTIONS(1692),
    [anon_sym_struct] = ACTIONS(1692),
    [anon_sym_trait] = ACTIONS(1692),
    [anon_sym_type] = ACTIONS(1692),
    [anon_sym_union] = ACTIONS(1692),
    [anon_sym_unsafe] = ACTIONS(1692),
    [anon_sym_use] = ACTIONS(1692),
    [anon_sym_while] = ACTIONS(1692),
    [anon_sym_extern] = ACTIONS(1692),
    [anon_sym_yield] = ACTIONS(1692),
    [anon_sym_move] = ACTIONS(1692),
    [anon_sym_try] = ACTIONS(1692),
    [sym_integer_literal] = ACTIONS(1690),
    [aux_sym_string_literal_token1] = ACTIONS(1690),
    [sym_char_literal] = ACTIONS(1690),
    [anon_sym_true] = ACTIONS(1692),
    [anon_sym_false] = ACTIONS(1692),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1692),
    [sym_super] = ACTIONS(1692),
    [sym_crate] = ACTIONS(1692),
    [sym_metavariable] = ACTIONS(1690),
    [sym__raw_string_literal_start] = ACTIONS(1690),
    [sym_float_literal] = ACTIONS(1690),
  },
  [487] = {
    [sym_line_comment] = STATE(487),
    [sym_block_comment] = STATE(487),
    [ts_builtin_sym_end] = ACTIONS(1694),
    [sym_identifier] = ACTIONS(1696),
    [anon_sym_SEMI] = ACTIONS(1694),
    [anon_sym_macro_rules_BANG] = ACTIONS(1694),
    [anon_sym_LPAREN] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(1694),
    [anon_sym_LBRACE] = ACTIONS(1694),
    [anon_sym_RBRACE] = ACTIONS(1694),
    [anon_sym_STAR] = ACTIONS(1694),
    [anon_sym_u8] = ACTIONS(1696),
    [anon_sym_i8] = ACTIONS(1696),
    [anon_sym_u16] = ACTIONS(1696),
    [anon_sym_i16] = ACTIONS(1696),
    [anon_sym_u32] = ACTIONS(1696),
    [anon_sym_i32] = ACTIONS(1696),
    [anon_sym_u64] = ACTIONS(1696),
    [anon_sym_i64] = ACTIONS(1696),
    [anon_sym_u128] = ACTIONS(1696),
    [anon_sym_i128] = ACTIONS(1696),
    [anon_sym_isize] = ACTIONS(1696),
    [anon_sym_usize] = ACTIONS(1696),
    [anon_sym_f32] = ACTIONS(1696),
    [anon_sym_f64] = ACTIONS(1696),
    [anon_sym_bool] = ACTIONS(1696),
    [anon_sym_str] = ACTIONS(1696),
    [anon_sym_char] = ACTIONS(1696),
    [anon_sym_DASH] = ACTIONS(1694),
    [anon_sym_BANG] = ACTIONS(1694),
    [anon_sym_AMP] = ACTIONS(1694),
    [anon_sym_PIPE] = ACTIONS(1694),
    [anon_sym_LT] = ACTIONS(1694),
    [anon_sym_DOT_DOT] = ACTIONS(1694),
    [anon_sym_COLON_COLON] = ACTIONS(1694),
    [anon_sym_POUND] = ACTIONS(1694),
    [anon_sym_SQUOTE] = ACTIONS(1696),
    [anon_sym_async] = ACTIONS(1696),
    [anon_sym_break] = ACTIONS(1696),
    [anon_sym_const] = ACTIONS(1696),
    [anon_sym_continue] = ACTIONS(1696),
    [anon_sym_default] = ACTIONS(1696),
    [anon_sym_enum] = ACTIONS(1696),
    [anon_sym_fn] = ACTIONS(1696),
    [anon_sym_for] = ACTIONS(1696),
    [anon_sym_if] = ACTIONS(1696),
    [anon_sym_impl] = ACTIONS(1696),
    [anon_sym_let] = ACTIONS(1696),
    [anon_sym_loop] = ACTIONS(1696),
    [anon_sym_match] = ACTIONS(1696),
    [anon_sym_mod] = ACTIONS(1696),
    [anon_sym_pub] = ACTIONS(1696),
    [anon_sym_return] = ACTIONS(1696),
    [anon_sym_static] = ACTIONS(1696),
    [anon_sym_struct] = ACTIONS(1696),
    [anon_sym_trait] = ACTIONS(1696),
    [anon_sym_type] = ACTIONS(1696),
    [anon_sym_union] = ACTIONS(1696),
    [anon_sym_unsafe] = ACTIONS(1696),
    [anon_sym_use] = ACTIONS(1696),
    [anon_sym_while] = ACTIONS(1696),
    [anon_sym_extern] = ACTIONS(1696),
    [anon_sym_yield] = ACTIONS(1696),
    [anon_sym_move] = ACTIONS(1696),
    [anon_sym_try] = ACTIONS(1696),
    [sym_integer_literal] = ACTIONS(1694),
    [aux_sym_string_literal_token1] = ACTIONS(1694),
    [sym_char_literal] = ACTIONS(1694),
    [anon_sym_true] = ACTIONS(1696),
    [anon_sym_false] = ACTIONS(1696),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1696),
    [sym_super] = ACTIONS(1696),
    [sym_crate] = ACTIONS(1696),
    [sym_metavariable] = ACTIONS(1694),
    [sym__raw_string_literal_start] = ACTIONS(1694),
    [sym_float_literal] = ACTIONS(1694),
  },
  [488] = {
    [sym_line_comment] = STATE(488),
    [sym_block_comment] = STATE(488),
    [ts_builtin_sym_end] = ACTIONS(1698),
    [sym_identifier] = ACTIONS(1700),
    [anon_sym_SEMI] = ACTIONS(1698),
    [anon_sym_macro_rules_BANG] = ACTIONS(1698),
    [anon_sym_LPAREN] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1698),
    [anon_sym_LBRACE] = ACTIONS(1698),
    [anon_sym_RBRACE] = ACTIONS(1698),
    [anon_sym_STAR] = ACTIONS(1698),
    [anon_sym_u8] = ACTIONS(1700),
    [anon_sym_i8] = ACTIONS(1700),
    [anon_sym_u16] = ACTIONS(1700),
    [anon_sym_i16] = ACTIONS(1700),
    [anon_sym_u32] = ACTIONS(1700),
    [anon_sym_i32] = ACTIONS(1700),
    [anon_sym_u64] = ACTIONS(1700),
    [anon_sym_i64] = ACTIONS(1700),
    [anon_sym_u128] = ACTIONS(1700),
    [anon_sym_i128] = ACTIONS(1700),
    [anon_sym_isize] = ACTIONS(1700),
    [anon_sym_usize] = ACTIONS(1700),
    [anon_sym_f32] = ACTIONS(1700),
    [anon_sym_f64] = ACTIONS(1700),
    [anon_sym_bool] = ACTIONS(1700),
    [anon_sym_str] = ACTIONS(1700),
    [anon_sym_char] = ACTIONS(1700),
    [anon_sym_DASH] = ACTIONS(1698),
    [anon_sym_BANG] = ACTIONS(1698),
    [anon_sym_AMP] = ACTIONS(1698),
    [anon_sym_PIPE] = ACTIONS(1698),
    [anon_sym_LT] = ACTIONS(1698),
    [anon_sym_DOT_DOT] = ACTIONS(1698),
    [anon_sym_COLON_COLON] = ACTIONS(1698),
    [anon_sym_POUND] = ACTIONS(1698),
    [anon_sym_SQUOTE] = ACTIONS(1700),
    [anon_sym_async] = ACTIONS(1700),
    [anon_sym_break] = ACTIONS(1700),
    [anon_sym_const] = ACTIONS(1700),
    [anon_sym_continue] = ACTIONS(1700),
    [anon_sym_default] = ACTIONS(1700),
    [anon_sym_enum] = ACTIONS(1700),
    [anon_sym_fn] = ACTIONS(1700),
    [anon_sym_for] = ACTIONS(1700),
    [anon_sym_if] = ACTIONS(1700),
    [anon_sym_impl] = ACTIONS(1700),
    [anon_sym_let] = ACTIONS(1700),
    [anon_sym_loop] = ACTIONS(1700),
    [anon_sym_match] = ACTIONS(1700),
    [anon_sym_mod] = ACTIONS(1700),
    [anon_sym_pub] = ACTIONS(1700),
    [anon_sym_return] = ACTIONS(1700),
    [anon_sym_static] = ACTIONS(1700),
    [anon_sym_struct] = ACTIONS(1700),
    [anon_sym_trait] = ACTIONS(1700),
    [anon_sym_type] = ACTIONS(1700),
    [anon_sym_union] = ACTIONS(1700),
    [anon_sym_unsafe] = ACTIONS(1700),
    [anon_sym_use] = ACTIONS(1700),
    [anon_sym_while] = ACTIONS(1700),
    [anon_sym_extern] = ACTIONS(1700),
    [anon_sym_yield] = ACTIONS(1700),
    [anon_sym_move] = ACTIONS(1700),
    [anon_sym_try] = ACTIONS(1700),
    [sym_integer_literal] = ACTIONS(1698),
    [aux_sym_string_literal_token1] = ACTIONS(1698),
    [sym_char_literal] = ACTIONS(1698),
    [anon_sym_true] = ACTIONS(1700),
    [anon_sym_false] = ACTIONS(1700),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1700),
    [sym_super] = ACTIONS(1700),
    [sym_crate] = ACTIONS(1700),
    [sym_metavariable] = ACTIONS(1698),
    [sym__raw_string_literal_start] = ACTIONS(1698),
    [sym_float_literal] = ACTIONS(1698),
  },
  [489] = {
    [sym_line_comment] = STATE(489),
    [sym_block_comment] = STATE(489),
    [ts_builtin_sym_end] = ACTIONS(1702),
    [sym_identifier] = ACTIONS(1704),
    [anon_sym_SEMI] = ACTIONS(1702),
    [anon_sym_macro_rules_BANG] = ACTIONS(1702),
    [anon_sym_LPAREN] = ACTIONS(1702),
    [anon_sym_LBRACK] = ACTIONS(1702),
    [anon_sym_LBRACE] = ACTIONS(1702),
    [anon_sym_RBRACE] = ACTIONS(1702),
    [anon_sym_STAR] = ACTIONS(1702),
    [anon_sym_u8] = ACTIONS(1704),
    [anon_sym_i8] = ACTIONS(1704),
    [anon_sym_u16] = ACTIONS(1704),
    [anon_sym_i16] = ACTIONS(1704),
    [anon_sym_u32] = ACTIONS(1704),
    [anon_sym_i32] = ACTIONS(1704),
    [anon_sym_u64] = ACTIONS(1704),
    [anon_sym_i64] = ACTIONS(1704),
    [anon_sym_u128] = ACTIONS(1704),
    [anon_sym_i128] = ACTIONS(1704),
    [anon_sym_isize] = ACTIONS(1704),
    [anon_sym_usize] = ACTIONS(1704),
    [anon_sym_f32] = ACTIONS(1704),
    [anon_sym_f64] = ACTIONS(1704),
    [anon_sym_bool] = ACTIONS(1704),
    [anon_sym_str] = ACTIONS(1704),
    [anon_sym_char] = ACTIONS(1704),
    [anon_sym_DASH] = ACTIONS(1702),
    [anon_sym_BANG] = ACTIONS(1702),
    [anon_sym_AMP] = ACTIONS(1702),
    [anon_sym_PIPE] = ACTIONS(1702),
    [anon_sym_LT] = ACTIONS(1702),
    [anon_sym_DOT_DOT] = ACTIONS(1702),
    [anon_sym_COLON_COLON] = ACTIONS(1702),
    [anon_sym_POUND] = ACTIONS(1702),
    [anon_sym_SQUOTE] = ACTIONS(1704),
    [anon_sym_async] = ACTIONS(1704),
    [anon_sym_break] = ACTIONS(1704),
    [anon_sym_const] = ACTIONS(1704),
    [anon_sym_continue] = ACTIONS(1704),
    [anon_sym_default] = ACTIONS(1704),
    [anon_sym_enum] = ACTIONS(1704),
    [anon_sym_fn] = ACTIONS(1704),
    [anon_sym_for] = ACTIONS(1704),
    [anon_sym_if] = ACTIONS(1704),
    [anon_sym_impl] = ACTIONS(1704),
    [anon_sym_let] = ACTIONS(1704),
    [anon_sym_loop] = ACTIONS(1704),
    [anon_sym_match] = ACTIONS(1704),
    [anon_sym_mod] = ACTIONS(1704),
    [anon_sym_pub] = ACTIONS(1704),
    [anon_sym_return] = ACTIONS(1704),
    [anon_sym_static] = ACTIONS(1704),
    [anon_sym_struct] = ACTIONS(1704),
    [anon_sym_trait] = ACTIONS(1704),
    [anon_sym_type] = ACTIONS(1704),
    [anon_sym_union] = ACTIONS(1704),
    [anon_sym_unsafe] = ACTIONS(1704),
    [anon_sym_use] = ACTIONS(1704),
    [anon_sym_while] = ACTIONS(1704),
    [anon_sym_extern] = ACTIONS(1704),
    [anon_sym_yield] = ACTIONS(1704),
    [anon_sym_move] = ACTIONS(1704),
    [anon_sym_try] = ACTIONS(1704),
    [sym_integer_literal] = ACTIONS(1702),
    [aux_sym_string_literal_token1] = ACTIONS(1702),
    [sym_char_literal] = ACTIONS(1702),
    [anon_sym_true] = ACTIONS(1704),
    [anon_sym_false] = ACTIONS(1704),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1704),
    [sym_super] = ACTIONS(1704),
    [sym_crate] = ACTIONS(1704),
    [sym_metavariable] = ACTIONS(1702),
    [sym__raw_string_literal_start] = ACTIONS(1702),
    [sym_float_literal] = ACTIONS(1702),
  },
  [490] = {
    [sym_line_comment] = STATE(490),
    [sym_block_comment] = STATE(490),
    [ts_builtin_sym_end] = ACTIONS(1706),
    [sym_identifier] = ACTIONS(1708),
    [anon_sym_SEMI] = ACTIONS(1706),
    [anon_sym_macro_rules_BANG] = ACTIONS(1706),
    [anon_sym_LPAREN] = ACTIONS(1706),
    [anon_sym_LBRACK] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(1706),
    [anon_sym_RBRACE] = ACTIONS(1706),
    [anon_sym_STAR] = ACTIONS(1706),
    [anon_sym_u8] = ACTIONS(1708),
    [anon_sym_i8] = ACTIONS(1708),
    [anon_sym_u16] = ACTIONS(1708),
    [anon_sym_i16] = ACTIONS(1708),
    [anon_sym_u32] = ACTIONS(1708),
    [anon_sym_i32] = ACTIONS(1708),
    [anon_sym_u64] = ACTIONS(1708),
    [anon_sym_i64] = ACTIONS(1708),
    [anon_sym_u128] = ACTIONS(1708),
    [anon_sym_i128] = ACTIONS(1708),
    [anon_sym_isize] = ACTIONS(1708),
    [anon_sym_usize] = ACTIONS(1708),
    [anon_sym_f32] = ACTIONS(1708),
    [anon_sym_f64] = ACTIONS(1708),
    [anon_sym_bool] = ACTIONS(1708),
    [anon_sym_str] = ACTIONS(1708),
    [anon_sym_char] = ACTIONS(1708),
    [anon_sym_DASH] = ACTIONS(1706),
    [anon_sym_BANG] = ACTIONS(1706),
    [anon_sym_AMP] = ACTIONS(1706),
    [anon_sym_PIPE] = ACTIONS(1706),
    [anon_sym_LT] = ACTIONS(1706),
    [anon_sym_DOT_DOT] = ACTIONS(1706),
    [anon_sym_COLON_COLON] = ACTIONS(1706),
    [anon_sym_POUND] = ACTIONS(1706),
    [anon_sym_SQUOTE] = ACTIONS(1708),
    [anon_sym_async] = ACTIONS(1708),
    [anon_sym_break] = ACTIONS(1708),
    [anon_sym_const] = ACTIONS(1708),
    [anon_sym_continue] = ACTIONS(1708),
    [anon_sym_default] = ACTIONS(1708),
    [anon_sym_enum] = ACTIONS(1708),
    [anon_sym_fn] = ACTIONS(1708),
    [anon_sym_for] = ACTIONS(1708),
    [anon_sym_if] = ACTIONS(1708),
    [anon_sym_impl] = ACTIONS(1708),
    [anon_sym_let] = ACTIONS(1708),
    [anon_sym_loop] = ACTIONS(1708),
    [anon_sym_match] = ACTIONS(1708),
    [anon_sym_mod] = ACTIONS(1708),
    [anon_sym_pub] = ACTIONS(1708),
    [anon_sym_return] = ACTIONS(1708),
    [anon_sym_static] = ACTIONS(1708),
    [anon_sym_struct] = ACTIONS(1708),
    [anon_sym_trait] = ACTIONS(1708),
    [anon_sym_type] = ACTIONS(1708),
    [anon_sym_union] = ACTIONS(1708),
    [anon_sym_unsafe] = ACTIONS(1708),
    [anon_sym_use] = ACTIONS(1708),
    [anon_sym_while] = ACTIONS(1708),
    [anon_sym_extern] = ACTIONS(1708),
    [anon_sym_yield] = ACTIONS(1708),
    [anon_sym_move] = ACTIONS(1708),
    [anon_sym_try] = ACTIONS(1708),
    [sym_integer_literal] = ACTIONS(1706),
    [aux_sym_string_literal_token1] = ACTIONS(1706),
    [sym_char_literal] = ACTIONS(1706),
    [anon_sym_true] = ACTIONS(1708),
    [anon_sym_false] = ACTIONS(1708),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1708),
    [sym_super] = ACTIONS(1708),
    [sym_crate] = ACTIONS(1708),
    [sym_metavariable] = ACTIONS(1706),
    [sym__raw_string_literal_start] = ACTIONS(1706),
    [sym_float_literal] = ACTIONS(1706),
  },
  [491] = {
    [sym_line_comment] = STATE(491),
    [sym_block_comment] = STATE(491),
    [ts_builtin_sym_end] = ACTIONS(1710),
    [sym_identifier] = ACTIONS(1712),
    [anon_sym_SEMI] = ACTIONS(1710),
    [anon_sym_macro_rules_BANG] = ACTIONS(1710),
    [anon_sym_LPAREN] = ACTIONS(1710),
    [anon_sym_LBRACK] = ACTIONS(1710),
    [anon_sym_LBRACE] = ACTIONS(1710),
    [anon_sym_RBRACE] = ACTIONS(1710),
    [anon_sym_STAR] = ACTIONS(1710),
    [anon_sym_u8] = ACTIONS(1712),
    [anon_sym_i8] = ACTIONS(1712),
    [anon_sym_u16] = ACTIONS(1712),
    [anon_sym_i16] = ACTIONS(1712),
    [anon_sym_u32] = ACTIONS(1712),
    [anon_sym_i32] = ACTIONS(1712),
    [anon_sym_u64] = ACTIONS(1712),
    [anon_sym_i64] = ACTIONS(1712),
    [anon_sym_u128] = ACTIONS(1712),
    [anon_sym_i128] = ACTIONS(1712),
    [anon_sym_isize] = ACTIONS(1712),
    [anon_sym_usize] = ACTIONS(1712),
    [anon_sym_f32] = ACTIONS(1712),
    [anon_sym_f64] = ACTIONS(1712),
    [anon_sym_bool] = ACTIONS(1712),
    [anon_sym_str] = ACTIONS(1712),
    [anon_sym_char] = ACTIONS(1712),
    [anon_sym_DASH] = ACTIONS(1710),
    [anon_sym_BANG] = ACTIONS(1710),
    [anon_sym_AMP] = ACTIONS(1710),
    [anon_sym_PIPE] = ACTIONS(1710),
    [anon_sym_LT] = ACTIONS(1710),
    [anon_sym_DOT_DOT] = ACTIONS(1710),
    [anon_sym_COLON_COLON] = ACTIONS(1710),
    [anon_sym_POUND] = ACTIONS(1710),
    [anon_sym_SQUOTE] = ACTIONS(1712),
    [anon_sym_async] = ACTIONS(1712),
    [anon_sym_break] = ACTIONS(1712),
    [anon_sym_const] = ACTIONS(1712),
    [anon_sym_continue] = ACTIONS(1712),
    [anon_sym_default] = ACTIONS(1712),
    [anon_sym_enum] = ACTIONS(1712),
    [anon_sym_fn] = ACTIONS(1712),
    [anon_sym_for] = ACTIONS(1712),
    [anon_sym_if] = ACTIONS(1712),
    [anon_sym_impl] = ACTIONS(1712),
    [anon_sym_let] = ACTIONS(1712),
    [anon_sym_loop] = ACTIONS(1712),
    [anon_sym_match] = ACTIONS(1712),
    [anon_sym_mod] = ACTIONS(1712),
    [anon_sym_pub] = ACTIONS(1712),
    [anon_sym_return] = ACTIONS(1712),
    [anon_sym_static] = ACTIONS(1712),
    [anon_sym_struct] = ACTIONS(1712),
    [anon_sym_trait] = ACTIONS(1712),
    [anon_sym_type] = ACTIONS(1712),
    [anon_sym_union] = ACTIONS(1712),
    [anon_sym_unsafe] = ACTIONS(1712),
    [anon_sym_use] = ACTIONS(1712),
    [anon_sym_while] = ACTIONS(1712),
    [anon_sym_extern] = ACTIONS(1712),
    [anon_sym_yield] = ACTIONS(1712),
    [anon_sym_move] = ACTIONS(1712),
    [anon_sym_try] = ACTIONS(1712),
    [sym_integer_literal] = ACTIONS(1710),
    [aux_sym_string_literal_token1] = ACTIONS(1710),
    [sym_char_literal] = ACTIONS(1710),
    [anon_sym_true] = ACTIONS(1712),
    [anon_sym_false] = ACTIONS(1712),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1712),
    [sym_super] = ACTIONS(1712),
    [sym_crate] = ACTIONS(1712),
    [sym_metavariable] = ACTIONS(1710),
    [sym__raw_string_literal_start] = ACTIONS(1710),
    [sym_float_literal] = ACTIONS(1710),
  },
  [492] = {
    [sym_line_comment] = STATE(492),
    [sym_block_comment] = STATE(492),
    [ts_builtin_sym_end] = ACTIONS(1714),
    [sym_identifier] = ACTIONS(1716),
    [anon_sym_SEMI] = ACTIONS(1714),
    [anon_sym_macro_rules_BANG] = ACTIONS(1714),
    [anon_sym_LPAREN] = ACTIONS(1714),
    [anon_sym_LBRACK] = ACTIONS(1714),
    [anon_sym_LBRACE] = ACTIONS(1714),
    [anon_sym_RBRACE] = ACTIONS(1714),
    [anon_sym_STAR] = ACTIONS(1714),
    [anon_sym_u8] = ACTIONS(1716),
    [anon_sym_i8] = ACTIONS(1716),
    [anon_sym_u16] = ACTIONS(1716),
    [anon_sym_i16] = ACTIONS(1716),
    [anon_sym_u32] = ACTIONS(1716),
    [anon_sym_i32] = ACTIONS(1716),
    [anon_sym_u64] = ACTIONS(1716),
    [anon_sym_i64] = ACTIONS(1716),
    [anon_sym_u128] = ACTIONS(1716),
    [anon_sym_i128] = ACTIONS(1716),
    [anon_sym_isize] = ACTIONS(1716),
    [anon_sym_usize] = ACTIONS(1716),
    [anon_sym_f32] = ACTIONS(1716),
    [anon_sym_f64] = ACTIONS(1716),
    [anon_sym_bool] = ACTIONS(1716),
    [anon_sym_str] = ACTIONS(1716),
    [anon_sym_char] = ACTIONS(1716),
    [anon_sym_DASH] = ACTIONS(1714),
    [anon_sym_BANG] = ACTIONS(1714),
    [anon_sym_AMP] = ACTIONS(1714),
    [anon_sym_PIPE] = ACTIONS(1714),
    [anon_sym_LT] = ACTIONS(1714),
    [anon_sym_DOT_DOT] = ACTIONS(1714),
    [anon_sym_COLON_COLON] = ACTIONS(1714),
    [anon_sym_POUND] = ACTIONS(1714),
    [anon_sym_SQUOTE] = ACTIONS(1716),
    [anon_sym_async] = ACTIONS(1716),
    [anon_sym_break] = ACTIONS(1716),
    [anon_sym_const] = ACTIONS(1716),
    [anon_sym_continue] = ACTIONS(1716),
    [anon_sym_default] = ACTIONS(1716),
    [anon_sym_enum] = ACTIONS(1716),
    [anon_sym_fn] = ACTIONS(1716),
    [anon_sym_for] = ACTIONS(1716),
    [anon_sym_if] = ACTIONS(1716),
    [anon_sym_impl] = ACTIONS(1716),
    [anon_sym_let] = ACTIONS(1716),
    [anon_sym_loop] = ACTIONS(1716),
    [anon_sym_match] = ACTIONS(1716),
    [anon_sym_mod] = ACTIONS(1716),
    [anon_sym_pub] = ACTIONS(1716),
    [anon_sym_return] = ACTIONS(1716),
    [anon_sym_static] = ACTIONS(1716),
    [anon_sym_struct] = ACTIONS(1716),
    [anon_sym_trait] = ACTIONS(1716),
    [anon_sym_type] = ACTIONS(1716),
    [anon_sym_union] = ACTIONS(1716),
    [anon_sym_unsafe] = ACTIONS(1716),
    [anon_sym_use] = ACTIONS(1716),
    [anon_sym_while] = ACTIONS(1716),
    [anon_sym_extern] = ACTIONS(1716),
    [anon_sym_yield] = ACTIONS(1716),
    [anon_sym_move] = ACTIONS(1716),
    [anon_sym_try] = ACTIONS(1716),
    [sym_integer_literal] = ACTIONS(1714),
    [aux_sym_string_literal_token1] = ACTIONS(1714),
    [sym_char_literal] = ACTIONS(1714),
    [anon_sym_true] = ACTIONS(1716),
    [anon_sym_false] = ACTIONS(1716),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1716),
    [sym_super] = ACTIONS(1716),
    [sym_crate] = ACTIONS(1716),
    [sym_metavariable] = ACTIONS(1714),
    [sym__raw_string_literal_start] = ACTIONS(1714),
    [sym_float_literal] = ACTIONS(1714),
  },
  [493] = {
    [sym_line_comment] = STATE(493),
    [sym_block_comment] = STATE(493),
    [ts_builtin_sym_end] = ACTIONS(1718),
    [sym_identifier] = ACTIONS(1720),
    [anon_sym_SEMI] = ACTIONS(1718),
    [anon_sym_macro_rules_BANG] = ACTIONS(1718),
    [anon_sym_LPAREN] = ACTIONS(1718),
    [anon_sym_LBRACK] = ACTIONS(1718),
    [anon_sym_LBRACE] = ACTIONS(1718),
    [anon_sym_RBRACE] = ACTIONS(1718),
    [anon_sym_STAR] = ACTIONS(1718),
    [anon_sym_u8] = ACTIONS(1720),
    [anon_sym_i8] = ACTIONS(1720),
    [anon_sym_u16] = ACTIONS(1720),
    [anon_sym_i16] = ACTIONS(1720),
    [anon_sym_u32] = ACTIONS(1720),
    [anon_sym_i32] = ACTIONS(1720),
    [anon_sym_u64] = ACTIONS(1720),
    [anon_sym_i64] = ACTIONS(1720),
    [anon_sym_u128] = ACTIONS(1720),
    [anon_sym_i128] = ACTIONS(1720),
    [anon_sym_isize] = ACTIONS(1720),
    [anon_sym_usize] = ACTIONS(1720),
    [anon_sym_f32] = ACTIONS(1720),
    [anon_sym_f64] = ACTIONS(1720),
    [anon_sym_bool] = ACTIONS(1720),
    [anon_sym_str] = ACTIONS(1720),
    [anon_sym_char] = ACTIONS(1720),
    [anon_sym_DASH] = ACTIONS(1718),
    [anon_sym_BANG] = ACTIONS(1718),
    [anon_sym_AMP] = ACTIONS(1718),
    [anon_sym_PIPE] = ACTIONS(1718),
    [anon_sym_LT] = ACTIONS(1718),
    [anon_sym_DOT_DOT] = ACTIONS(1718),
    [anon_sym_COLON_COLON] = ACTIONS(1718),
    [anon_sym_POUND] = ACTIONS(1718),
    [anon_sym_SQUOTE] = ACTIONS(1720),
    [anon_sym_async] = ACTIONS(1720),
    [anon_sym_break] = ACTIONS(1720),
    [anon_sym_const] = ACTIONS(1720),
    [anon_sym_continue] = ACTIONS(1720),
    [anon_sym_default] = ACTIONS(1720),
    [anon_sym_enum] = ACTIONS(1720),
    [anon_sym_fn] = ACTIONS(1720),
    [anon_sym_for] = ACTIONS(1720),
    [anon_sym_if] = ACTIONS(1720),
    [anon_sym_impl] = ACTIONS(1720),
    [anon_sym_let] = ACTIONS(1720),
    [anon_sym_loop] = ACTIONS(1720),
    [anon_sym_match] = ACTIONS(1720),
    [anon_sym_mod] = ACTIONS(1720),
    [anon_sym_pub] = ACTIONS(1720),
    [anon_sym_return] = ACTIONS(1720),
    [anon_sym_static] = ACTIONS(1720),
    [anon_sym_struct] = ACTIONS(1720),
    [anon_sym_trait] = ACTIONS(1720),
    [anon_sym_type] = ACTIONS(1720),
    [anon_sym_union] = ACTIONS(1720),
    [anon_sym_unsafe] = ACTIONS(1720),
    [anon_sym_use] = ACTIONS(1720),
    [anon_sym_while] = ACTIONS(1720),
    [anon_sym_extern] = ACTIONS(1720),
    [anon_sym_yield] = ACTIONS(1720),
    [anon_sym_move] = ACTIONS(1720),
    [anon_sym_try] = ACTIONS(1720),
    [sym_integer_literal] = ACTIONS(1718),
    [aux_sym_string_literal_token1] = ACTIONS(1718),
    [sym_char_literal] = ACTIONS(1718),
    [anon_sym_true] = ACTIONS(1720),
    [anon_sym_false] = ACTIONS(1720),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1720),
    [sym_super] = ACTIONS(1720),
    [sym_crate] = ACTIONS(1720),
    [sym_metavariable] = ACTIONS(1718),
    [sym__raw_string_literal_start] = ACTIONS(1718),
    [sym_float_literal] = ACTIONS(1718),
  },
  [494] = {
    [sym_line_comment] = STATE(494),
    [sym_block_comment] = STATE(494),
    [ts_builtin_sym_end] = ACTIONS(1722),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_SEMI] = ACTIONS(1722),
    [anon_sym_macro_rules_BANG] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(1722),
    [anon_sym_LBRACK] = ACTIONS(1722),
    [anon_sym_LBRACE] = ACTIONS(1722),
    [anon_sym_RBRACE] = ACTIONS(1722),
    [anon_sym_STAR] = ACTIONS(1722),
    [anon_sym_u8] = ACTIONS(1724),
    [anon_sym_i8] = ACTIONS(1724),
    [anon_sym_u16] = ACTIONS(1724),
    [anon_sym_i16] = ACTIONS(1724),
    [anon_sym_u32] = ACTIONS(1724),
    [anon_sym_i32] = ACTIONS(1724),
    [anon_sym_u64] = ACTIONS(1724),
    [anon_sym_i64] = ACTIONS(1724),
    [anon_sym_u128] = ACTIONS(1724),
    [anon_sym_i128] = ACTIONS(1724),
    [anon_sym_isize] = ACTIONS(1724),
    [anon_sym_usize] = ACTIONS(1724),
    [anon_sym_f32] = ACTIONS(1724),
    [anon_sym_f64] = ACTIONS(1724),
    [anon_sym_bool] = ACTIONS(1724),
    [anon_sym_str] = ACTIONS(1724),
    [anon_sym_char] = ACTIONS(1724),
    [anon_sym_DASH] = ACTIONS(1722),
    [anon_sym_BANG] = ACTIONS(1722),
    [anon_sym_AMP] = ACTIONS(1722),
    [anon_sym_PIPE] = ACTIONS(1722),
    [anon_sym_LT] = ACTIONS(1722),
    [anon_sym_DOT_DOT] = ACTIONS(1722),
    [anon_sym_COLON_COLON] = ACTIONS(1722),
    [anon_sym_POUND] = ACTIONS(1722),
    [anon_sym_SQUOTE] = ACTIONS(1724),
    [anon_sym_async] = ACTIONS(1724),
    [anon_sym_break] = ACTIONS(1724),
    [anon_sym_const] = ACTIONS(1724),
    [anon_sym_continue] = ACTIONS(1724),
    [anon_sym_default] = ACTIONS(1724),
    [anon_sym_enum] = ACTIONS(1724),
    [anon_sym_fn] = ACTIONS(1724),
    [anon_sym_for] = ACTIONS(1724),
    [anon_sym_if] = ACTIONS(1724),
    [anon_sym_impl] = ACTIONS(1724),
    [anon_sym_let] = ACTIONS(1724),
    [anon_sym_loop] = ACTIONS(1724),
    [anon_sym_match] = ACTIONS(1724),
    [anon_sym_mod] = ACTIONS(1724),
    [anon_sym_pub] = ACTIONS(1724),
    [anon_sym_return] = ACTIONS(1724),
    [anon_sym_static] = ACTIONS(1724),
    [anon_sym_struct] = ACTIONS(1724),
    [anon_sym_trait] = ACTIONS(1724),
    [anon_sym_type] = ACTIONS(1724),
    [anon_sym_union] = ACTIONS(1724),
    [anon_sym_unsafe] = ACTIONS(1724),
    [anon_sym_use] = ACTIONS(1724),
    [anon_sym_while] = ACTIONS(1724),
    [anon_sym_extern] = ACTIONS(1724),
    [anon_sym_yield] = ACTIONS(1724),
    [anon_sym_move] = ACTIONS(1724),
    [anon_sym_try] = ACTIONS(1724),
    [sym_integer_literal] = ACTIONS(1722),
    [aux_sym_string_literal_token1] = ACTIONS(1722),
    [sym_char_literal] = ACTIONS(1722),
    [anon_sym_true] = ACTIONS(1724),
    [anon_sym_false] = ACTIONS(1724),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1724),
    [sym_super] = ACTIONS(1724),
    [sym_crate] = ACTIONS(1724),
    [sym_metavariable] = ACTIONS(1722),
    [sym__raw_string_literal_start] = ACTIONS(1722),
    [sym_float_literal] = ACTIONS(1722),
  },
  [495] = {
    [sym_line_comment] = STATE(495),
    [sym_block_comment] = STATE(495),
    [ts_builtin_sym_end] = ACTIONS(1726),
    [sym_identifier] = ACTIONS(1728),
    [anon_sym_SEMI] = ACTIONS(1726),
    [anon_sym_macro_rules_BANG] = ACTIONS(1726),
    [anon_sym_LPAREN] = ACTIONS(1726),
    [anon_sym_LBRACK] = ACTIONS(1726),
    [anon_sym_LBRACE] = ACTIONS(1726),
    [anon_sym_RBRACE] = ACTIONS(1726),
    [anon_sym_STAR] = ACTIONS(1726),
    [anon_sym_u8] = ACTIONS(1728),
    [anon_sym_i8] = ACTIONS(1728),
    [anon_sym_u16] = ACTIONS(1728),
    [anon_sym_i16] = ACTIONS(1728),
    [anon_sym_u32] = ACTIONS(1728),
    [anon_sym_i32] = ACTIONS(1728),
    [anon_sym_u64] = ACTIONS(1728),
    [anon_sym_i64] = ACTIONS(1728),
    [anon_sym_u128] = ACTIONS(1728),
    [anon_sym_i128] = ACTIONS(1728),
    [anon_sym_isize] = ACTIONS(1728),
    [anon_sym_usize] = ACTIONS(1728),
    [anon_sym_f32] = ACTIONS(1728),
    [anon_sym_f64] = ACTIONS(1728),
    [anon_sym_bool] = ACTIONS(1728),
    [anon_sym_str] = ACTIONS(1728),
    [anon_sym_char] = ACTIONS(1728),
    [anon_sym_DASH] = ACTIONS(1726),
    [anon_sym_BANG] = ACTIONS(1726),
    [anon_sym_AMP] = ACTIONS(1726),
    [anon_sym_PIPE] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1726),
    [anon_sym_DOT_DOT] = ACTIONS(1726),
    [anon_sym_COLON_COLON] = ACTIONS(1726),
    [anon_sym_POUND] = ACTIONS(1726),
    [anon_sym_SQUOTE] = ACTIONS(1728),
    [anon_sym_async] = ACTIONS(1728),
    [anon_sym_break] = ACTIONS(1728),
    [anon_sym_const] = ACTIONS(1728),
    [anon_sym_continue] = ACTIONS(1728),
    [anon_sym_default] = ACTIONS(1728),
    [anon_sym_enum] = ACTIONS(1728),
    [anon_sym_fn] = ACTIONS(1728),
    [anon_sym_for] = ACTIONS(1728),
    [anon_sym_if] = ACTIONS(1728),
    [anon_sym_impl] = ACTIONS(1728),
    [anon_sym_let] = ACTIONS(1728),
    [anon_sym_loop] = ACTIONS(1728),
    [anon_sym_match] = ACTIONS(1728),
    [anon_sym_mod] = ACTIONS(1728),
    [anon_sym_pub] = ACTIONS(1728),
    [anon_sym_return] = ACTIONS(1728),
    [anon_sym_static] = ACTIONS(1728),
    [anon_sym_struct] = ACTIONS(1728),
    [anon_sym_trait] = ACTIONS(1728),
    [anon_sym_type] = ACTIONS(1728),
    [anon_sym_union] = ACTIONS(1728),
    [anon_sym_unsafe] = ACTIONS(1728),
    [anon_sym_use] = ACTIONS(1728),
    [anon_sym_while] = ACTIONS(1728),
    [anon_sym_extern] = ACTIONS(1728),
    [anon_sym_yield] = ACTIONS(1728),
    [anon_sym_move] = ACTIONS(1728),
    [anon_sym_try] = ACTIONS(1728),
    [sym_integer_literal] = ACTIONS(1726),
    [aux_sym_string_literal_token1] = ACTIONS(1726),
    [sym_char_literal] = ACTIONS(1726),
    [anon_sym_true] = ACTIONS(1728),
    [anon_sym_false] = ACTIONS(1728),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1728),
    [sym_super] = ACTIONS(1728),
    [sym_crate] = ACTIONS(1728),
    [sym_metavariable] = ACTIONS(1726),
    [sym__raw_string_literal_start] = ACTIONS(1726),
    [sym_float_literal] = ACTIONS(1726),
  },
  [496] = {
    [sym_line_comment] = STATE(496),
    [sym_block_comment] = STATE(496),
    [ts_builtin_sym_end] = ACTIONS(1730),
    [sym_identifier] = ACTIONS(1732),
    [anon_sym_SEMI] = ACTIONS(1730),
    [anon_sym_macro_rules_BANG] = ACTIONS(1730),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_LBRACK] = ACTIONS(1730),
    [anon_sym_LBRACE] = ACTIONS(1730),
    [anon_sym_RBRACE] = ACTIONS(1730),
    [anon_sym_STAR] = ACTIONS(1730),
    [anon_sym_u8] = ACTIONS(1732),
    [anon_sym_i8] = ACTIONS(1732),
    [anon_sym_u16] = ACTIONS(1732),
    [anon_sym_i16] = ACTIONS(1732),
    [anon_sym_u32] = ACTIONS(1732),
    [anon_sym_i32] = ACTIONS(1732),
    [anon_sym_u64] = ACTIONS(1732),
    [anon_sym_i64] = ACTIONS(1732),
    [anon_sym_u128] = ACTIONS(1732),
    [anon_sym_i128] = ACTIONS(1732),
    [anon_sym_isize] = ACTIONS(1732),
    [anon_sym_usize] = ACTIONS(1732),
    [anon_sym_f32] = ACTIONS(1732),
    [anon_sym_f64] = ACTIONS(1732),
    [anon_sym_bool] = ACTIONS(1732),
    [anon_sym_str] = ACTIONS(1732),
    [anon_sym_char] = ACTIONS(1732),
    [anon_sym_DASH] = ACTIONS(1730),
    [anon_sym_BANG] = ACTIONS(1730),
    [anon_sym_AMP] = ACTIONS(1730),
    [anon_sym_PIPE] = ACTIONS(1730),
    [anon_sym_LT] = ACTIONS(1730),
    [anon_sym_DOT_DOT] = ACTIONS(1730),
    [anon_sym_COLON_COLON] = ACTIONS(1730),
    [anon_sym_POUND] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_async] = ACTIONS(1732),
    [anon_sym_break] = ACTIONS(1732),
    [anon_sym_const] = ACTIONS(1732),
    [anon_sym_continue] = ACTIONS(1732),
    [anon_sym_default] = ACTIONS(1732),
    [anon_sym_enum] = ACTIONS(1732),
    [anon_sym_fn] = ACTIONS(1732),
    [anon_sym_for] = ACTIONS(1732),
    [anon_sym_if] = ACTIONS(1732),
    [anon_sym_impl] = ACTIONS(1732),
    [anon_sym_let] = ACTIONS(1732),
    [anon_sym_loop] = ACTIONS(1732),
    [anon_sym_match] = ACTIONS(1732),
    [anon_sym_mod] = ACTIONS(1732),
    [anon_sym_pub] = ACTIONS(1732),
    [anon_sym_return] = ACTIONS(1732),
    [anon_sym_static] = ACTIONS(1732),
    [anon_sym_struct] = ACTIONS(1732),
    [anon_sym_trait] = ACTIONS(1732),
    [anon_sym_type] = ACTIONS(1732),
    [anon_sym_union] = ACTIONS(1732),
    [anon_sym_unsafe] = ACTIONS(1732),
    [anon_sym_use] = ACTIONS(1732),
    [anon_sym_while] = ACTIONS(1732),
    [anon_sym_extern] = ACTIONS(1732),
    [anon_sym_yield] = ACTIONS(1732),
    [anon_sym_move] = ACTIONS(1732),
    [anon_sym_try] = ACTIONS(1732),
    [sym_integer_literal] = ACTIONS(1730),
    [aux_sym_string_literal_token1] = ACTIONS(1730),
    [sym_char_literal] = ACTIONS(1730),
    [anon_sym_true] = ACTIONS(1732),
    [anon_sym_false] = ACTIONS(1732),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1732),
    [sym_super] = ACTIONS(1732),
    [sym_crate] = ACTIONS(1732),
    [sym_metavariable] = ACTIONS(1730),
    [sym__raw_string_literal_start] = ACTIONS(1730),
    [sym_float_literal] = ACTIONS(1730),
  },
  [497] = {
    [sym_line_comment] = STATE(497),
    [sym_block_comment] = STATE(497),
    [ts_builtin_sym_end] = ACTIONS(1734),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_SEMI] = ACTIONS(1734),
    [anon_sym_macro_rules_BANG] = ACTIONS(1734),
    [anon_sym_LPAREN] = ACTIONS(1734),
    [anon_sym_LBRACK] = ACTIONS(1734),
    [anon_sym_LBRACE] = ACTIONS(1734),
    [anon_sym_RBRACE] = ACTIONS(1734),
    [anon_sym_STAR] = ACTIONS(1734),
    [anon_sym_u8] = ACTIONS(1736),
    [anon_sym_i8] = ACTIONS(1736),
    [anon_sym_u16] = ACTIONS(1736),
    [anon_sym_i16] = ACTIONS(1736),
    [anon_sym_u32] = ACTIONS(1736),
    [anon_sym_i32] = ACTIONS(1736),
    [anon_sym_u64] = ACTIONS(1736),
    [anon_sym_i64] = ACTIONS(1736),
    [anon_sym_u128] = ACTIONS(1736),
    [anon_sym_i128] = ACTIONS(1736),
    [anon_sym_isize] = ACTIONS(1736),
    [anon_sym_usize] = ACTIONS(1736),
    [anon_sym_f32] = ACTIONS(1736),
    [anon_sym_f64] = ACTIONS(1736),
    [anon_sym_bool] = ACTIONS(1736),
    [anon_sym_str] = ACTIONS(1736),
    [anon_sym_char] = ACTIONS(1736),
    [anon_sym_DASH] = ACTIONS(1734),
    [anon_sym_BANG] = ACTIONS(1734),
    [anon_sym_AMP] = ACTIONS(1734),
    [anon_sym_PIPE] = ACTIONS(1734),
    [anon_sym_LT] = ACTIONS(1734),
    [anon_sym_DOT_DOT] = ACTIONS(1734),
    [anon_sym_COLON_COLON] = ACTIONS(1734),
    [anon_sym_POUND] = ACTIONS(1734),
    [anon_sym_SQUOTE] = ACTIONS(1736),
    [anon_sym_async] = ACTIONS(1736),
    [anon_sym_break] = ACTIONS(1736),
    [anon_sym_const] = ACTIONS(1736),
    [anon_sym_continue] = ACTIONS(1736),
    [anon_sym_default] = ACTIONS(1736),
    [anon_sym_enum] = ACTIONS(1736),
    [anon_sym_fn] = ACTIONS(1736),
    [anon_sym_for] = ACTIONS(1736),
    [anon_sym_if] = ACTIONS(1736),
    [anon_sym_impl] = ACTIONS(1736),
    [anon_sym_let] = ACTIONS(1736),
    [anon_sym_loop] = ACTIONS(1736),
    [anon_sym_match] = ACTIONS(1736),
    [anon_sym_mod] = ACTIONS(1736),
    [anon_sym_pub] = ACTIONS(1736),
    [anon_sym_return] = ACTIONS(1736),
    [anon_sym_static] = ACTIONS(1736),
    [anon_sym_struct] = ACTIONS(1736),
    [anon_sym_trait] = ACTIONS(1736),
    [anon_sym_type] = ACTIONS(1736),
    [anon_sym_union] = ACTIONS(1736),
    [anon_sym_unsafe] = ACTIONS(1736),
    [anon_sym_use] = ACTIONS(1736),
    [anon_sym_while] = ACTIONS(1736),
    [anon_sym_extern] = ACTIONS(1736),
    [anon_sym_yield] = ACTIONS(1736),
    [anon_sym_move] = ACTIONS(1736),
    [anon_sym_try] = ACTIONS(1736),
    [sym_integer_literal] = ACTIONS(1734),
    [aux_sym_string_literal_token1] = ACTIONS(1734),
    [sym_char_literal] = ACTIONS(1734),
    [anon_sym_true] = ACTIONS(1736),
    [anon_sym_false] = ACTIONS(1736),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1736),
    [sym_super] = ACTIONS(1736),
    [sym_crate] = ACTIONS(1736),
    [sym_metavariable] = ACTIONS(1734),
    [sym__raw_string_literal_start] = ACTIONS(1734),
    [sym_float_literal] = ACTIONS(1734),
  },
  [498] = {
    [sym_line_comment] = STATE(498),
    [sym_block_comment] = STATE(498),
    [ts_builtin_sym_end] = ACTIONS(1738),
    [sym_identifier] = ACTIONS(1740),
    [anon_sym_SEMI] = ACTIONS(1738),
    [anon_sym_macro_rules_BANG] = ACTIONS(1738),
    [anon_sym_LPAREN] = ACTIONS(1738),
    [anon_sym_LBRACK] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(1738),
    [anon_sym_RBRACE] = ACTIONS(1738),
    [anon_sym_STAR] = ACTIONS(1738),
    [anon_sym_u8] = ACTIONS(1740),
    [anon_sym_i8] = ACTIONS(1740),
    [anon_sym_u16] = ACTIONS(1740),
    [anon_sym_i16] = ACTIONS(1740),
    [anon_sym_u32] = ACTIONS(1740),
    [anon_sym_i32] = ACTIONS(1740),
    [anon_sym_u64] = ACTIONS(1740),
    [anon_sym_i64] = ACTIONS(1740),
    [anon_sym_u128] = ACTIONS(1740),
    [anon_sym_i128] = ACTIONS(1740),
    [anon_sym_isize] = ACTIONS(1740),
    [anon_sym_usize] = ACTIONS(1740),
    [anon_sym_f32] = ACTIONS(1740),
    [anon_sym_f64] = ACTIONS(1740),
    [anon_sym_bool] = ACTIONS(1740),
    [anon_sym_str] = ACTIONS(1740),
    [anon_sym_char] = ACTIONS(1740),
    [anon_sym_DASH] = ACTIONS(1738),
    [anon_sym_BANG] = ACTIONS(1738),
    [anon_sym_AMP] = ACTIONS(1738),
    [anon_sym_PIPE] = ACTIONS(1738),
    [anon_sym_LT] = ACTIONS(1738),
    [anon_sym_DOT_DOT] = ACTIONS(1738),
    [anon_sym_COLON_COLON] = ACTIONS(1738),
    [anon_sym_POUND] = ACTIONS(1738),
    [anon_sym_SQUOTE] = ACTIONS(1740),
    [anon_sym_async] = ACTIONS(1740),
    [anon_sym_break] = ACTIONS(1740),
    [anon_sym_const] = ACTIONS(1740),
    [anon_sym_continue] = ACTIONS(1740),
    [anon_sym_default] = ACTIONS(1740),
    [anon_sym_enum] = ACTIONS(1740),
    [anon_sym_fn] = ACTIONS(1740),
    [anon_sym_for] = ACTIONS(1740),
    [anon_sym_if] = ACTIONS(1740),
    [anon_sym_impl] = ACTIONS(1740),
    [anon_sym_let] = ACTIONS(1740),
    [anon_sym_loop] = ACTIONS(1740),
    [anon_sym_match] = ACTIONS(1740),
    [anon_sym_mod] = ACTIONS(1740),
    [anon_sym_pub] = ACTIONS(1740),
    [anon_sym_return] = ACTIONS(1740),
    [anon_sym_static] = ACTIONS(1740),
    [anon_sym_struct] = ACTIONS(1740),
    [anon_sym_trait] = ACTIONS(1740),
    [anon_sym_type] = ACTIONS(1740),
    [anon_sym_union] = ACTIONS(1740),
    [anon_sym_unsafe] = ACTIONS(1740),
    [anon_sym_use] = ACTIONS(1740),
    [anon_sym_while] = ACTIONS(1740),
    [anon_sym_extern] = ACTIONS(1740),
    [anon_sym_yield] = ACTIONS(1740),
    [anon_sym_move] = ACTIONS(1740),
    [anon_sym_try] = ACTIONS(1740),
    [sym_integer_literal] = ACTIONS(1738),
    [aux_sym_string_literal_token1] = ACTIONS(1738),
    [sym_char_literal] = ACTIONS(1738),
    [anon_sym_true] = ACTIONS(1740),
    [anon_sym_false] = ACTIONS(1740),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1740),
    [sym_super] = ACTIONS(1740),
    [sym_crate] = ACTIONS(1740),
    [sym_metavariable] = ACTIONS(1738),
    [sym__raw_string_literal_start] = ACTIONS(1738),
    [sym_float_literal] = ACTIONS(1738),
  },
  [499] = {
    [sym_line_comment] = STATE(499),
    [sym_block_comment] = STATE(499),
    [ts_builtin_sym_end] = ACTIONS(1742),
    [sym_identifier] = ACTIONS(1744),
    [anon_sym_SEMI] = ACTIONS(1742),
    [anon_sym_macro_rules_BANG] = ACTIONS(1742),
    [anon_sym_LPAREN] = ACTIONS(1742),
    [anon_sym_LBRACK] = ACTIONS(1742),
    [anon_sym_LBRACE] = ACTIONS(1742),
    [anon_sym_RBRACE] = ACTIONS(1742),
    [anon_sym_STAR] = ACTIONS(1742),
    [anon_sym_u8] = ACTIONS(1744),
    [anon_sym_i8] = ACTIONS(1744),
    [anon_sym_u16] = ACTIONS(1744),
    [anon_sym_i16] = ACTIONS(1744),
    [anon_sym_u32] = ACTIONS(1744),
    [anon_sym_i32] = ACTIONS(1744),
    [anon_sym_u64] = ACTIONS(1744),
    [anon_sym_i64] = ACTIONS(1744),
    [anon_sym_u128] = ACTIONS(1744),
    [anon_sym_i128] = ACTIONS(1744),
    [anon_sym_isize] = ACTIONS(1744),
    [anon_sym_usize] = ACTIONS(1744),
    [anon_sym_f32] = ACTIONS(1744),
    [anon_sym_f64] = ACTIONS(1744),
    [anon_sym_bool] = ACTIONS(1744),
    [anon_sym_str] = ACTIONS(1744),
    [anon_sym_char] = ACTIONS(1744),
    [anon_sym_DASH] = ACTIONS(1742),
    [anon_sym_BANG] = ACTIONS(1742),
    [anon_sym_AMP] = ACTIONS(1742),
    [anon_sym_PIPE] = ACTIONS(1742),
    [anon_sym_LT] = ACTIONS(1742),
    [anon_sym_DOT_DOT] = ACTIONS(1742),
    [anon_sym_COLON_COLON] = ACTIONS(1742),
    [anon_sym_POUND] = ACTIONS(1742),
    [anon_sym_SQUOTE] = ACTIONS(1744),
    [anon_sym_async] = ACTIONS(1744),
    [anon_sym_break] = ACTIONS(1744),
    [anon_sym_const] = ACTIONS(1744),
    [anon_sym_continue] = ACTIONS(1744),
    [anon_sym_default] = ACTIONS(1744),
    [anon_sym_enum] = ACTIONS(1744),
    [anon_sym_fn] = ACTIONS(1744),
    [anon_sym_for] = ACTIONS(1744),
    [anon_sym_if] = ACTIONS(1744),
    [anon_sym_impl] = ACTIONS(1744),
    [anon_sym_let] = ACTIONS(1744),
    [anon_sym_loop] = ACTIONS(1744),
    [anon_sym_match] = ACTIONS(1744),
    [anon_sym_mod] = ACTIONS(1744),
    [anon_sym_pub] = ACTIONS(1744),
    [anon_sym_return] = ACTIONS(1744),
    [anon_sym_static] = ACTIONS(1744),
    [anon_sym_struct] = ACTIONS(1744),
    [anon_sym_trait] = ACTIONS(1744),
    [anon_sym_type] = ACTIONS(1744),
    [anon_sym_union] = ACTIONS(1744),
    [anon_sym_unsafe] = ACTIONS(1744),
    [anon_sym_use] = ACTIONS(1744),
    [anon_sym_while] = ACTIONS(1744),
    [anon_sym_extern] = ACTIONS(1744),
    [anon_sym_yield] = ACTIONS(1744),
    [anon_sym_move] = ACTIONS(1744),
    [anon_sym_try] = ACTIONS(1744),
    [sym_integer_literal] = ACTIONS(1742),
    [aux_sym_string_literal_token1] = ACTIONS(1742),
    [sym_char_literal] = ACTIONS(1742),
    [anon_sym_true] = ACTIONS(1744),
    [anon_sym_false] = ACTIONS(1744),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1744),
    [sym_super] = ACTIONS(1744),
    [sym_crate] = ACTIONS(1744),
    [sym_metavariable] = ACTIONS(1742),
    [sym__raw_string_literal_start] = ACTIONS(1742),
    [sym_float_literal] = ACTIONS(1742),
  },
  [500] = {
    [sym_line_comment] = STATE(500),
    [sym_block_comment] = STATE(500),
    [ts_builtin_sym_end] = ACTIONS(1746),
    [sym_identifier] = ACTIONS(1748),
    [anon_sym_SEMI] = ACTIONS(1746),
    [anon_sym_macro_rules_BANG] = ACTIONS(1746),
    [anon_sym_LPAREN] = ACTIONS(1746),
    [anon_sym_LBRACK] = ACTIONS(1746),
    [anon_sym_LBRACE] = ACTIONS(1746),
    [anon_sym_RBRACE] = ACTIONS(1746),
    [anon_sym_STAR] = ACTIONS(1746),
    [anon_sym_u8] = ACTIONS(1748),
    [anon_sym_i8] = ACTIONS(1748),
    [anon_sym_u16] = ACTIONS(1748),
    [anon_sym_i16] = ACTIONS(1748),
    [anon_sym_u32] = ACTIONS(1748),
    [anon_sym_i32] = ACTIONS(1748),
    [anon_sym_u64] = ACTIONS(1748),
    [anon_sym_i64] = ACTIONS(1748),
    [anon_sym_u128] = ACTIONS(1748),
    [anon_sym_i128] = ACTIONS(1748),
    [anon_sym_isize] = ACTIONS(1748),
    [anon_sym_usize] = ACTIONS(1748),
    [anon_sym_f32] = ACTIONS(1748),
    [anon_sym_f64] = ACTIONS(1748),
    [anon_sym_bool] = ACTIONS(1748),
    [anon_sym_str] = ACTIONS(1748),
    [anon_sym_char] = ACTIONS(1748),
    [anon_sym_DASH] = ACTIONS(1746),
    [anon_sym_BANG] = ACTIONS(1746),
    [anon_sym_AMP] = ACTIONS(1746),
    [anon_sym_PIPE] = ACTIONS(1746),
    [anon_sym_LT] = ACTIONS(1746),
    [anon_sym_DOT_DOT] = ACTIONS(1746),
    [anon_sym_COLON_COLON] = ACTIONS(1746),
    [anon_sym_POUND] = ACTIONS(1746),
    [anon_sym_SQUOTE] = ACTIONS(1748),
    [anon_sym_async] = ACTIONS(1748),
    [anon_sym_break] = ACTIONS(1748),
    [anon_sym_const] = ACTIONS(1748),
    [anon_sym_continue] = ACTIONS(1748),
    [anon_sym_default] = ACTIONS(1748),
    [anon_sym_enum] = ACTIONS(1748),
    [anon_sym_fn] = ACTIONS(1748),
    [anon_sym_for] = ACTIONS(1748),
    [anon_sym_if] = ACTIONS(1748),
    [anon_sym_impl] = ACTIONS(1748),
    [anon_sym_let] = ACTIONS(1748),
    [anon_sym_loop] = ACTIONS(1748),
    [anon_sym_match] = ACTIONS(1748),
    [anon_sym_mod] = ACTIONS(1748),
    [anon_sym_pub] = ACTIONS(1748),
    [anon_sym_return] = ACTIONS(1748),
    [anon_sym_static] = ACTIONS(1748),
    [anon_sym_struct] = ACTIONS(1748),
    [anon_sym_trait] = ACTIONS(1748),
    [anon_sym_type] = ACTIONS(1748),
    [anon_sym_union] = ACTIONS(1748),
    [anon_sym_unsafe] = ACTIONS(1748),
    [anon_sym_use] = ACTIONS(1748),
    [anon_sym_while] = ACTIONS(1748),
    [anon_sym_extern] = ACTIONS(1748),
    [anon_sym_yield] = ACTIONS(1748),
    [anon_sym_move] = ACTIONS(1748),
    [anon_sym_try] = ACTIONS(1748),
    [sym_integer_literal] = ACTIONS(1746),
    [aux_sym_string_literal_token1] = ACTIONS(1746),
    [sym_char_literal] = ACTIONS(1746),
    [anon_sym_true] = ACTIONS(1748),
    [anon_sym_false] = ACTIONS(1748),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1748),
    [sym_super] = ACTIONS(1748),
    [sym_crate] = ACTIONS(1748),
    [sym_metavariable] = ACTIONS(1746),
    [sym__raw_string_literal_start] = ACTIONS(1746),
    [sym_float_literal] = ACTIONS(1746),
  },
  [501] = {
    [sym_line_comment] = STATE(501),
    [sym_block_comment] = STATE(501),
    [ts_builtin_sym_end] = ACTIONS(1750),
    [sym_identifier] = ACTIONS(1752),
    [anon_sym_SEMI] = ACTIONS(1750),
    [anon_sym_macro_rules_BANG] = ACTIONS(1750),
    [anon_sym_LPAREN] = ACTIONS(1750),
    [anon_sym_LBRACK] = ACTIONS(1750),
    [anon_sym_LBRACE] = ACTIONS(1750),
    [anon_sym_RBRACE] = ACTIONS(1750),
    [anon_sym_STAR] = ACTIONS(1750),
    [anon_sym_u8] = ACTIONS(1752),
    [anon_sym_i8] = ACTIONS(1752),
    [anon_sym_u16] = ACTIONS(1752),
    [anon_sym_i16] = ACTIONS(1752),
    [anon_sym_u32] = ACTIONS(1752),
    [anon_sym_i32] = ACTIONS(1752),
    [anon_sym_u64] = ACTIONS(1752),
    [anon_sym_i64] = ACTIONS(1752),
    [anon_sym_u128] = ACTIONS(1752),
    [anon_sym_i128] = ACTIONS(1752),
    [anon_sym_isize] = ACTIONS(1752),
    [anon_sym_usize] = ACTIONS(1752),
    [anon_sym_f32] = ACTIONS(1752),
    [anon_sym_f64] = ACTIONS(1752),
    [anon_sym_bool] = ACTIONS(1752),
    [anon_sym_str] = ACTIONS(1752),
    [anon_sym_char] = ACTIONS(1752),
    [anon_sym_DASH] = ACTIONS(1750),
    [anon_sym_BANG] = ACTIONS(1750),
    [anon_sym_AMP] = ACTIONS(1750),
    [anon_sym_PIPE] = ACTIONS(1750),
    [anon_sym_LT] = ACTIONS(1750),
    [anon_sym_DOT_DOT] = ACTIONS(1750),
    [anon_sym_COLON_COLON] = ACTIONS(1750),
    [anon_sym_POUND] = ACTIONS(1750),
    [anon_sym_SQUOTE] = ACTIONS(1752),
    [anon_sym_async] = ACTIONS(1752),
    [anon_sym_break] = ACTIONS(1752),
    [anon_sym_const] = ACTIONS(1752),
    [anon_sym_continue] = ACTIONS(1752),
    [anon_sym_default] = ACTIONS(1752),
    [anon_sym_enum] = ACTIONS(1752),
    [anon_sym_fn] = ACTIONS(1752),
    [anon_sym_for] = ACTIONS(1752),
    [anon_sym_if] = ACTIONS(1752),
    [anon_sym_impl] = ACTIONS(1752),
    [anon_sym_let] = ACTIONS(1752),
    [anon_sym_loop] = ACTIONS(1752),
    [anon_sym_match] = ACTIONS(1752),
    [anon_sym_mod] = ACTIONS(1752),
    [anon_sym_pub] = ACTIONS(1752),
    [anon_sym_return] = ACTIONS(1752),
    [anon_sym_static] = ACTIONS(1752),
    [anon_sym_struct] = ACTIONS(1752),
    [anon_sym_trait] = ACTIONS(1752),
    [anon_sym_type] = ACTIONS(1752),
    [anon_sym_union] = ACTIONS(1752),
    [anon_sym_unsafe] = ACTIONS(1752),
    [anon_sym_use] = ACTIONS(1752),
    [anon_sym_while] = ACTIONS(1752),
    [anon_sym_extern] = ACTIONS(1752),
    [anon_sym_yield] = ACTIONS(1752),
    [anon_sym_move] = ACTIONS(1752),
    [anon_sym_try] = ACTIONS(1752),
    [sym_integer_literal] = ACTIONS(1750),
    [aux_sym_string_literal_token1] = ACTIONS(1750),
    [sym_char_literal] = ACTIONS(1750),
    [anon_sym_true] = ACTIONS(1752),
    [anon_sym_false] = ACTIONS(1752),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1752),
    [sym_super] = ACTIONS(1752),
    [sym_crate] = ACTIONS(1752),
    [sym_metavariable] = ACTIONS(1750),
    [sym__raw_string_literal_start] = ACTIONS(1750),
    [sym_float_literal] = ACTIONS(1750),
  },
  [502] = {
    [sym_line_comment] = STATE(502),
    [sym_block_comment] = STATE(502),
    [ts_builtin_sym_end] = ACTIONS(1754),
    [sym_identifier] = ACTIONS(1756),
    [anon_sym_SEMI] = ACTIONS(1754),
    [anon_sym_macro_rules_BANG] = ACTIONS(1754),
    [anon_sym_LPAREN] = ACTIONS(1754),
    [anon_sym_LBRACK] = ACTIONS(1754),
    [anon_sym_LBRACE] = ACTIONS(1754),
    [anon_sym_RBRACE] = ACTIONS(1754),
    [anon_sym_STAR] = ACTIONS(1754),
    [anon_sym_u8] = ACTIONS(1756),
    [anon_sym_i8] = ACTIONS(1756),
    [anon_sym_u16] = ACTIONS(1756),
    [anon_sym_i16] = ACTIONS(1756),
    [anon_sym_u32] = ACTIONS(1756),
    [anon_sym_i32] = ACTIONS(1756),
    [anon_sym_u64] = ACTIONS(1756),
    [anon_sym_i64] = ACTIONS(1756),
    [anon_sym_u128] = ACTIONS(1756),
    [anon_sym_i128] = ACTIONS(1756),
    [anon_sym_isize] = ACTIONS(1756),
    [anon_sym_usize] = ACTIONS(1756),
    [anon_sym_f32] = ACTIONS(1756),
    [anon_sym_f64] = ACTIONS(1756),
    [anon_sym_bool] = ACTIONS(1756),
    [anon_sym_str] = ACTIONS(1756),
    [anon_sym_char] = ACTIONS(1756),
    [anon_sym_DASH] = ACTIONS(1754),
    [anon_sym_BANG] = ACTIONS(1754),
    [anon_sym_AMP] = ACTIONS(1754),
    [anon_sym_PIPE] = ACTIONS(1754),
    [anon_sym_LT] = ACTIONS(1754),
    [anon_sym_DOT_DOT] = ACTIONS(1754),
    [anon_sym_COLON_COLON] = ACTIONS(1754),
    [anon_sym_POUND] = ACTIONS(1754),
    [anon_sym_SQUOTE] = ACTIONS(1756),
    [anon_sym_async] = ACTIONS(1756),
    [anon_sym_break] = ACTIONS(1756),
    [anon_sym_const] = ACTIONS(1756),
    [anon_sym_continue] = ACTIONS(1756),
    [anon_sym_default] = ACTIONS(1756),
    [anon_sym_enum] = ACTIONS(1756),
    [anon_sym_fn] = ACTIONS(1756),
    [anon_sym_for] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(1756),
    [anon_sym_impl] = ACTIONS(1756),
    [anon_sym_let] = ACTIONS(1756),
    [anon_sym_loop] = ACTIONS(1756),
    [anon_sym_match] = ACTIONS(1756),
    [anon_sym_mod] = ACTIONS(1756),
    [anon_sym_pub] = ACTIONS(1756),
    [anon_sym_return] = ACTIONS(1756),
    [anon_sym_static] = ACTIONS(1756),
    [anon_sym_struct] = ACTIONS(1756),
    [anon_sym_trait] = ACTIONS(1756),
    [anon_sym_type] = ACTIONS(1756),
    [anon_sym_union] = ACTIONS(1756),
    [anon_sym_unsafe] = ACTIONS(1756),
    [anon_sym_use] = ACTIONS(1756),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_extern] = ACTIONS(1756),
    [anon_sym_yield] = ACTIONS(1756),
    [anon_sym_move] = ACTIONS(1756),
    [anon_sym_try] = ACTIONS(1756),
    [sym_integer_literal] = ACTIONS(1754),
    [aux_sym_string_literal_token1] = ACTIONS(1754),
    [sym_char_literal] = ACTIONS(1754),
    [anon_sym_true] = ACTIONS(1756),
    [anon_sym_false] = ACTIONS(1756),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1756),
    [sym_super] = ACTIONS(1756),
    [sym_crate] = ACTIONS(1756),
    [sym_metavariable] = ACTIONS(1754),
    [sym__raw_string_literal_start] = ACTIONS(1754),
    [sym_float_literal] = ACTIONS(1754),
  },
  [503] = {
    [sym_line_comment] = STATE(503),
    [sym_block_comment] = STATE(503),
    [ts_builtin_sym_end] = ACTIONS(1758),
    [sym_identifier] = ACTIONS(1760),
    [anon_sym_SEMI] = ACTIONS(1758),
    [anon_sym_macro_rules_BANG] = ACTIONS(1758),
    [anon_sym_LPAREN] = ACTIONS(1758),
    [anon_sym_LBRACK] = ACTIONS(1758),
    [anon_sym_LBRACE] = ACTIONS(1758),
    [anon_sym_RBRACE] = ACTIONS(1758),
    [anon_sym_STAR] = ACTIONS(1758),
    [anon_sym_u8] = ACTIONS(1760),
    [anon_sym_i8] = ACTIONS(1760),
    [anon_sym_u16] = ACTIONS(1760),
    [anon_sym_i16] = ACTIONS(1760),
    [anon_sym_u32] = ACTIONS(1760),
    [anon_sym_i32] = ACTIONS(1760),
    [anon_sym_u64] = ACTIONS(1760),
    [anon_sym_i64] = ACTIONS(1760),
    [anon_sym_u128] = ACTIONS(1760),
    [anon_sym_i128] = ACTIONS(1760),
    [anon_sym_isize] = ACTIONS(1760),
    [anon_sym_usize] = ACTIONS(1760),
    [anon_sym_f32] = ACTIONS(1760),
    [anon_sym_f64] = ACTIONS(1760),
    [anon_sym_bool] = ACTIONS(1760),
    [anon_sym_str] = ACTIONS(1760),
    [anon_sym_char] = ACTIONS(1760),
    [anon_sym_DASH] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1758),
    [anon_sym_AMP] = ACTIONS(1758),
    [anon_sym_PIPE] = ACTIONS(1758),
    [anon_sym_LT] = ACTIONS(1758),
    [anon_sym_DOT_DOT] = ACTIONS(1758),
    [anon_sym_COLON_COLON] = ACTIONS(1758),
    [anon_sym_POUND] = ACTIONS(1758),
    [anon_sym_SQUOTE] = ACTIONS(1760),
    [anon_sym_async] = ACTIONS(1760),
    [anon_sym_break] = ACTIONS(1760),
    [anon_sym_const] = ACTIONS(1760),
    [anon_sym_continue] = ACTIONS(1760),
    [anon_sym_default] = ACTIONS(1760),
    [anon_sym_enum] = ACTIONS(1760),
    [anon_sym_fn] = ACTIONS(1760),
    [anon_sym_for] = ACTIONS(1760),
    [anon_sym_if] = ACTIONS(1760),
    [anon_sym_impl] = ACTIONS(1760),
    [anon_sym_let] = ACTIONS(1760),
    [anon_sym_loop] = ACTIONS(1760),
    [anon_sym_match] = ACTIONS(1760),
    [anon_sym_mod] = ACTIONS(1760),
    [anon_sym_pub] = ACTIONS(1760),
    [anon_sym_return] = ACTIONS(1760),
    [anon_sym_static] = ACTIONS(1760),
    [anon_sym_struct] = ACTIONS(1760),
    [anon_sym_trait] = ACTIONS(1760),
    [anon_sym_type] = ACTIONS(1760),
    [anon_sym_union] = ACTIONS(1760),
    [anon_sym_unsafe] = ACTIONS(1760),
    [anon_sym_use] = ACTIONS(1760),
    [anon_sym_while] = ACTIONS(1760),
    [anon_sym_extern] = ACTIONS(1760),
    [anon_sym_yield] = ACTIONS(1760),
    [anon_sym_move] = ACTIONS(1760),
    [anon_sym_try] = ACTIONS(1760),
    [sym_integer_literal] = ACTIONS(1758),
    [aux_sym_string_literal_token1] = ACTIONS(1758),
    [sym_char_literal] = ACTIONS(1758),
    [anon_sym_true] = ACTIONS(1760),
    [anon_sym_false] = ACTIONS(1760),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1760),
    [sym_super] = ACTIONS(1760),
    [sym_crate] = ACTIONS(1760),
    [sym_metavariable] = ACTIONS(1758),
    [sym__raw_string_literal_start] = ACTIONS(1758),
    [sym_float_literal] = ACTIONS(1758),
  },
  [504] = {
    [sym_line_comment] = STATE(504),
    [sym_block_comment] = STATE(504),
    [ts_builtin_sym_end] = ACTIONS(1762),
    [sym_identifier] = ACTIONS(1764),
    [anon_sym_SEMI] = ACTIONS(1762),
    [anon_sym_macro_rules_BANG] = ACTIONS(1762),
    [anon_sym_LPAREN] = ACTIONS(1762),
    [anon_sym_LBRACK] = ACTIONS(1762),
    [anon_sym_LBRACE] = ACTIONS(1762),
    [anon_sym_RBRACE] = ACTIONS(1762),
    [anon_sym_STAR] = ACTIONS(1762),
    [anon_sym_u8] = ACTIONS(1764),
    [anon_sym_i8] = ACTIONS(1764),
    [anon_sym_u16] = ACTIONS(1764),
    [anon_sym_i16] = ACTIONS(1764),
    [anon_sym_u32] = ACTIONS(1764),
    [anon_sym_i32] = ACTIONS(1764),
    [anon_sym_u64] = ACTIONS(1764),
    [anon_sym_i64] = ACTIONS(1764),
    [anon_sym_u128] = ACTIONS(1764),
    [anon_sym_i128] = ACTIONS(1764),
    [anon_sym_isize] = ACTIONS(1764),
    [anon_sym_usize] = ACTIONS(1764),
    [anon_sym_f32] = ACTIONS(1764),
    [anon_sym_f64] = ACTIONS(1764),
    [anon_sym_bool] = ACTIONS(1764),
    [anon_sym_str] = ACTIONS(1764),
    [anon_sym_char] = ACTIONS(1764),
    [anon_sym_DASH] = ACTIONS(1762),
    [anon_sym_BANG] = ACTIONS(1762),
    [anon_sym_AMP] = ACTIONS(1762),
    [anon_sym_PIPE] = ACTIONS(1762),
    [anon_sym_LT] = ACTIONS(1762),
    [anon_sym_DOT_DOT] = ACTIONS(1762),
    [anon_sym_COLON_COLON] = ACTIONS(1762),
    [anon_sym_POUND] = ACTIONS(1762),
    [anon_sym_SQUOTE] = ACTIONS(1764),
    [anon_sym_async] = ACTIONS(1764),
    [anon_sym_break] = ACTIONS(1764),
    [anon_sym_const] = ACTIONS(1764),
    [anon_sym_continue] = ACTIONS(1764),
    [anon_sym_default] = ACTIONS(1764),
    [anon_sym_enum] = ACTIONS(1764),
    [anon_sym_fn] = ACTIONS(1764),
    [anon_sym_for] = ACTIONS(1764),
    [anon_sym_if] = ACTIONS(1764),
    [anon_sym_impl] = ACTIONS(1764),
    [anon_sym_let] = ACTIONS(1764),
    [anon_sym_loop] = ACTIONS(1764),
    [anon_sym_match] = ACTIONS(1764),
    [anon_sym_mod] = ACTIONS(1764),
    [anon_sym_pub] = ACTIONS(1764),
    [anon_sym_return] = ACTIONS(1764),
    [anon_sym_static] = ACTIONS(1764),
    [anon_sym_struct] = ACTIONS(1764),
    [anon_sym_trait] = ACTIONS(1764),
    [anon_sym_type] = ACTIONS(1764),
    [anon_sym_union] = ACTIONS(1764),
    [anon_sym_unsafe] = ACTIONS(1764),
    [anon_sym_use] = ACTIONS(1764),
    [anon_sym_while] = ACTIONS(1764),
    [anon_sym_extern] = ACTIONS(1764),
    [anon_sym_yield] = ACTIONS(1764),
    [anon_sym_move] = ACTIONS(1764),
    [anon_sym_try] = ACTIONS(1764),
    [sym_integer_literal] = ACTIONS(1762),
    [aux_sym_string_literal_token1] = ACTIONS(1762),
    [sym_char_literal] = ACTIONS(1762),
    [anon_sym_true] = ACTIONS(1764),
    [anon_sym_false] = ACTIONS(1764),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1764),
    [sym_super] = ACTIONS(1764),
    [sym_crate] = ACTIONS(1764),
    [sym_metavariable] = ACTIONS(1762),
    [sym__raw_string_literal_start] = ACTIONS(1762),
    [sym_float_literal] = ACTIONS(1762),
  },
  [505] = {
    [sym_line_comment] = STATE(505),
    [sym_block_comment] = STATE(505),
    [ts_builtin_sym_end] = ACTIONS(1766),
    [sym_identifier] = ACTIONS(1768),
    [anon_sym_SEMI] = ACTIONS(1766),
    [anon_sym_macro_rules_BANG] = ACTIONS(1766),
    [anon_sym_LPAREN] = ACTIONS(1766),
    [anon_sym_LBRACK] = ACTIONS(1766),
    [anon_sym_LBRACE] = ACTIONS(1766),
    [anon_sym_RBRACE] = ACTIONS(1766),
    [anon_sym_STAR] = ACTIONS(1766),
    [anon_sym_u8] = ACTIONS(1768),
    [anon_sym_i8] = ACTIONS(1768),
    [anon_sym_u16] = ACTIONS(1768),
    [anon_sym_i16] = ACTIONS(1768),
    [anon_sym_u32] = ACTIONS(1768),
    [anon_sym_i32] = ACTIONS(1768),
    [anon_sym_u64] = ACTIONS(1768),
    [anon_sym_i64] = ACTIONS(1768),
    [anon_sym_u128] = ACTIONS(1768),
    [anon_sym_i128] = ACTIONS(1768),
    [anon_sym_isize] = ACTIONS(1768),
    [anon_sym_usize] = ACTIONS(1768),
    [anon_sym_f32] = ACTIONS(1768),
    [anon_sym_f64] = ACTIONS(1768),
    [anon_sym_bool] = ACTIONS(1768),
    [anon_sym_str] = ACTIONS(1768),
    [anon_sym_char] = ACTIONS(1768),
    [anon_sym_DASH] = ACTIONS(1766),
    [anon_sym_BANG] = ACTIONS(1766),
    [anon_sym_AMP] = ACTIONS(1766),
    [anon_sym_PIPE] = ACTIONS(1766),
    [anon_sym_LT] = ACTIONS(1766),
    [anon_sym_DOT_DOT] = ACTIONS(1766),
    [anon_sym_COLON_COLON] = ACTIONS(1766),
    [anon_sym_POUND] = ACTIONS(1766),
    [anon_sym_SQUOTE] = ACTIONS(1768),
    [anon_sym_async] = ACTIONS(1768),
    [anon_sym_break] = ACTIONS(1768),
    [anon_sym_const] = ACTIONS(1768),
    [anon_sym_continue] = ACTIONS(1768),
    [anon_sym_default] = ACTIONS(1768),
    [anon_sym_enum] = ACTIONS(1768),
    [anon_sym_fn] = ACTIONS(1768),
    [anon_sym_for] = ACTIONS(1768),
    [anon_sym_if] = ACTIONS(1768),
    [anon_sym_impl] = ACTIONS(1768),
    [anon_sym_let] = ACTIONS(1768),
    [anon_sym_loop] = ACTIONS(1768),
    [anon_sym_match] = ACTIONS(1768),
    [anon_sym_mod] = ACTIONS(1768),
    [anon_sym_pub] = ACTIONS(1768),
    [anon_sym_return] = ACTIONS(1768),
    [anon_sym_static] = ACTIONS(1768),
    [anon_sym_struct] = ACTIONS(1768),
    [anon_sym_trait] = ACTIONS(1768),
    [anon_sym_type] = ACTIONS(1768),
    [anon_sym_union] = ACTIONS(1768),
    [anon_sym_unsafe] = ACTIONS(1768),
    [anon_sym_use] = ACTIONS(1768),
    [anon_sym_while] = ACTIONS(1768),
    [anon_sym_extern] = ACTIONS(1768),
    [anon_sym_yield] = ACTIONS(1768),
    [anon_sym_move] = ACTIONS(1768),
    [anon_sym_try] = ACTIONS(1768),
    [sym_integer_literal] = ACTIONS(1766),
    [aux_sym_string_literal_token1] = ACTIONS(1766),
    [sym_char_literal] = ACTIONS(1766),
    [anon_sym_true] = ACTIONS(1768),
    [anon_sym_false] = ACTIONS(1768),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1768),
    [sym_super] = ACTIONS(1768),
    [sym_crate] = ACTIONS(1768),
    [sym_metavariable] = ACTIONS(1766),
    [sym__raw_string_literal_start] = ACTIONS(1766),
    [sym_float_literal] = ACTIONS(1766),
  },
  [506] = {
    [sym_line_comment] = STATE(506),
    [sym_block_comment] = STATE(506),
    [ts_builtin_sym_end] = ACTIONS(1770),
    [sym_identifier] = ACTIONS(1772),
    [anon_sym_SEMI] = ACTIONS(1770),
    [anon_sym_macro_rules_BANG] = ACTIONS(1770),
    [anon_sym_LPAREN] = ACTIONS(1770),
    [anon_sym_LBRACK] = ACTIONS(1770),
    [anon_sym_LBRACE] = ACTIONS(1770),
    [anon_sym_RBRACE] = ACTIONS(1770),
    [anon_sym_STAR] = ACTIONS(1770),
    [anon_sym_u8] = ACTIONS(1772),
    [anon_sym_i8] = ACTIONS(1772),
    [anon_sym_u16] = ACTIONS(1772),
    [anon_sym_i16] = ACTIONS(1772),
    [anon_sym_u32] = ACTIONS(1772),
    [anon_sym_i32] = ACTIONS(1772),
    [anon_sym_u64] = ACTIONS(1772),
    [anon_sym_i64] = ACTIONS(1772),
    [anon_sym_u128] = ACTIONS(1772),
    [anon_sym_i128] = ACTIONS(1772),
    [anon_sym_isize] = ACTIONS(1772),
    [anon_sym_usize] = ACTIONS(1772),
    [anon_sym_f32] = ACTIONS(1772),
    [anon_sym_f64] = ACTIONS(1772),
    [anon_sym_bool] = ACTIONS(1772),
    [anon_sym_str] = ACTIONS(1772),
    [anon_sym_char] = ACTIONS(1772),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_BANG] = ACTIONS(1770),
    [anon_sym_AMP] = ACTIONS(1770),
    [anon_sym_PIPE] = ACTIONS(1770),
    [anon_sym_LT] = ACTIONS(1770),
    [anon_sym_DOT_DOT] = ACTIONS(1770),
    [anon_sym_COLON_COLON] = ACTIONS(1770),
    [anon_sym_POUND] = ACTIONS(1770),
    [anon_sym_SQUOTE] = ACTIONS(1772),
    [anon_sym_async] = ACTIONS(1772),
    [anon_sym_break] = ACTIONS(1772),
    [anon_sym_const] = ACTIONS(1772),
    [anon_sym_continue] = ACTIONS(1772),
    [anon_sym_default] = ACTIONS(1772),
    [anon_sym_enum] = ACTIONS(1772),
    [anon_sym_fn] = ACTIONS(1772),
    [anon_sym_for] = ACTIONS(1772),
    [anon_sym_if] = ACTIONS(1772),
    [anon_sym_impl] = ACTIONS(1772),
    [anon_sym_let] = ACTIONS(1772),
    [anon_sym_loop] = ACTIONS(1772),
    [anon_sym_match] = ACTIONS(1772),
    [anon_sym_mod] = ACTIONS(1772),
    [anon_sym_pub] = ACTIONS(1772),
    [anon_sym_return] = ACTIONS(1772),
    [anon_sym_static] = ACTIONS(1772),
    [anon_sym_struct] = ACTIONS(1772),
    [anon_sym_trait] = ACTIONS(1772),
    [anon_sym_type] = ACTIONS(1772),
    [anon_sym_union] = ACTIONS(1772),
    [anon_sym_unsafe] = ACTIONS(1772),
    [anon_sym_use] = ACTIONS(1772),
    [anon_sym_while] = ACTIONS(1772),
    [anon_sym_extern] = ACTIONS(1772),
    [anon_sym_yield] = ACTIONS(1772),
    [anon_sym_move] = ACTIONS(1772),
    [anon_sym_try] = ACTIONS(1772),
    [sym_integer_literal] = ACTIONS(1770),
    [aux_sym_string_literal_token1] = ACTIONS(1770),
    [sym_char_literal] = ACTIONS(1770),
    [anon_sym_true] = ACTIONS(1772),
    [anon_sym_false] = ACTIONS(1772),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1772),
    [sym_super] = ACTIONS(1772),
    [sym_crate] = ACTIONS(1772),
    [sym_metavariable] = ACTIONS(1770),
    [sym__raw_string_literal_start] = ACTIONS(1770),
    [sym_float_literal] = ACTIONS(1770),
  },
  [507] = {
    [sym_line_comment] = STATE(507),
    [sym_block_comment] = STATE(507),
    [ts_builtin_sym_end] = ACTIONS(1774),
    [sym_identifier] = ACTIONS(1776),
    [anon_sym_SEMI] = ACTIONS(1774),
    [anon_sym_macro_rules_BANG] = ACTIONS(1774),
    [anon_sym_LPAREN] = ACTIONS(1774),
    [anon_sym_LBRACK] = ACTIONS(1774),
    [anon_sym_LBRACE] = ACTIONS(1774),
    [anon_sym_RBRACE] = ACTIONS(1774),
    [anon_sym_STAR] = ACTIONS(1774),
    [anon_sym_u8] = ACTIONS(1776),
    [anon_sym_i8] = ACTIONS(1776),
    [anon_sym_u16] = ACTIONS(1776),
    [anon_sym_i16] = ACTIONS(1776),
    [anon_sym_u32] = ACTIONS(1776),
    [anon_sym_i32] = ACTIONS(1776),
    [anon_sym_u64] = ACTIONS(1776),
    [anon_sym_i64] = ACTIONS(1776),
    [anon_sym_u128] = ACTIONS(1776),
    [anon_sym_i128] = ACTIONS(1776),
    [anon_sym_isize] = ACTIONS(1776),
    [anon_sym_usize] = ACTIONS(1776),
    [anon_sym_f32] = ACTIONS(1776),
    [anon_sym_f64] = ACTIONS(1776),
    [anon_sym_bool] = ACTIONS(1776),
    [anon_sym_str] = ACTIONS(1776),
    [anon_sym_char] = ACTIONS(1776),
    [anon_sym_DASH] = ACTIONS(1774),
    [anon_sym_BANG] = ACTIONS(1774),
    [anon_sym_AMP] = ACTIONS(1774),
    [anon_sym_PIPE] = ACTIONS(1774),
    [anon_sym_LT] = ACTIONS(1774),
    [anon_sym_DOT_DOT] = ACTIONS(1774),
    [anon_sym_COLON_COLON] = ACTIONS(1774),
    [anon_sym_POUND] = ACTIONS(1774),
    [anon_sym_SQUOTE] = ACTIONS(1776),
    [anon_sym_async] = ACTIONS(1776),
    [anon_sym_break] = ACTIONS(1776),
    [anon_sym_const] = ACTIONS(1776),
    [anon_sym_continue] = ACTIONS(1776),
    [anon_sym_default] = ACTIONS(1776),
    [anon_sym_enum] = ACTIONS(1776),
    [anon_sym_fn] = ACTIONS(1776),
    [anon_sym_for] = ACTIONS(1776),
    [anon_sym_if] = ACTIONS(1776),
    [anon_sym_impl] = ACTIONS(1776),
    [anon_sym_let] = ACTIONS(1776),
    [anon_sym_loop] = ACTIONS(1776),
    [anon_sym_match] = ACTIONS(1776),
    [anon_sym_mod] = ACTIONS(1776),
    [anon_sym_pub] = ACTIONS(1776),
    [anon_sym_return] = ACTIONS(1776),
    [anon_sym_static] = ACTIONS(1776),
    [anon_sym_struct] = ACTIONS(1776),
    [anon_sym_trait] = ACTIONS(1776),
    [anon_sym_type] = ACTIONS(1776),
    [anon_sym_union] = ACTIONS(1776),
    [anon_sym_unsafe] = ACTIONS(1776),
    [anon_sym_use] = ACTIONS(1776),
    [anon_sym_while] = ACTIONS(1776),
    [anon_sym_extern] = ACTIONS(1776),
    [anon_sym_yield] = ACTIONS(1776),
    [anon_sym_move] = ACTIONS(1776),
    [anon_sym_try] = ACTIONS(1776),
    [sym_integer_literal] = ACTIONS(1774),
    [aux_sym_string_literal_token1] = ACTIONS(1774),
    [sym_char_literal] = ACTIONS(1774),
    [anon_sym_true] = ACTIONS(1776),
    [anon_sym_false] = ACTIONS(1776),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1776),
    [sym_super] = ACTIONS(1776),
    [sym_crate] = ACTIONS(1776),
    [sym_metavariable] = ACTIONS(1774),
    [sym__raw_string_literal_start] = ACTIONS(1774),
    [sym_float_literal] = ACTIONS(1774),
  },
  [508] = {
    [sym_line_comment] = STATE(508),
    [sym_block_comment] = STATE(508),
    [ts_builtin_sym_end] = ACTIONS(1778),
    [sym_identifier] = ACTIONS(1780),
    [anon_sym_SEMI] = ACTIONS(1778),
    [anon_sym_macro_rules_BANG] = ACTIONS(1778),
    [anon_sym_LPAREN] = ACTIONS(1778),
    [anon_sym_LBRACK] = ACTIONS(1778),
    [anon_sym_LBRACE] = ACTIONS(1778),
    [anon_sym_RBRACE] = ACTIONS(1778),
    [anon_sym_STAR] = ACTIONS(1778),
    [anon_sym_u8] = ACTIONS(1780),
    [anon_sym_i8] = ACTIONS(1780),
    [anon_sym_u16] = ACTIONS(1780),
    [anon_sym_i16] = ACTIONS(1780),
    [anon_sym_u32] = ACTIONS(1780),
    [anon_sym_i32] = ACTIONS(1780),
    [anon_sym_u64] = ACTIONS(1780),
    [anon_sym_i64] = ACTIONS(1780),
    [anon_sym_u128] = ACTIONS(1780),
    [anon_sym_i128] = ACTIONS(1780),
    [anon_sym_isize] = ACTIONS(1780),
    [anon_sym_usize] = ACTIONS(1780),
    [anon_sym_f32] = ACTIONS(1780),
    [anon_sym_f64] = ACTIONS(1780),
    [anon_sym_bool] = ACTIONS(1780),
    [anon_sym_str] = ACTIONS(1780),
    [anon_sym_char] = ACTIONS(1780),
    [anon_sym_DASH] = ACTIONS(1778),
    [anon_sym_BANG] = ACTIONS(1778),
    [anon_sym_AMP] = ACTIONS(1778),
    [anon_sym_PIPE] = ACTIONS(1778),
    [anon_sym_LT] = ACTIONS(1778),
    [anon_sym_DOT_DOT] = ACTIONS(1778),
    [anon_sym_COLON_COLON] = ACTIONS(1778),
    [anon_sym_POUND] = ACTIONS(1778),
    [anon_sym_SQUOTE] = ACTIONS(1780),
    [anon_sym_async] = ACTIONS(1780),
    [anon_sym_break] = ACTIONS(1780),
    [anon_sym_const] = ACTIONS(1780),
    [anon_sym_continue] = ACTIONS(1780),
    [anon_sym_default] = ACTIONS(1780),
    [anon_sym_enum] = ACTIONS(1780),
    [anon_sym_fn] = ACTIONS(1780),
    [anon_sym_for] = ACTIONS(1780),
    [anon_sym_if] = ACTIONS(1780),
    [anon_sym_impl] = ACTIONS(1780),
    [anon_sym_let] = ACTIONS(1780),
    [anon_sym_loop] = ACTIONS(1780),
    [anon_sym_match] = ACTIONS(1780),
    [anon_sym_mod] = ACTIONS(1780),
    [anon_sym_pub] = ACTIONS(1780),
    [anon_sym_return] = ACTIONS(1780),
    [anon_sym_static] = ACTIONS(1780),
    [anon_sym_struct] = ACTIONS(1780),
    [anon_sym_trait] = ACTIONS(1780),
    [anon_sym_type] = ACTIONS(1780),
    [anon_sym_union] = ACTIONS(1780),
    [anon_sym_unsafe] = ACTIONS(1780),
    [anon_sym_use] = ACTIONS(1780),
    [anon_sym_while] = ACTIONS(1780),
    [anon_sym_extern] = ACTIONS(1780),
    [anon_sym_yield] = ACTIONS(1780),
    [anon_sym_move] = ACTIONS(1780),
    [anon_sym_try] = ACTIONS(1780),
    [sym_integer_literal] = ACTIONS(1778),
    [aux_sym_string_literal_token1] = ACTIONS(1778),
    [sym_char_literal] = ACTIONS(1778),
    [anon_sym_true] = ACTIONS(1780),
    [anon_sym_false] = ACTIONS(1780),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1780),
    [sym_super] = ACTIONS(1780),
    [sym_crate] = ACTIONS(1780),
    [sym_metavariable] = ACTIONS(1778),
    [sym__raw_string_literal_start] = ACTIONS(1778),
    [sym_float_literal] = ACTIONS(1778),
  },
  [509] = {
    [sym_line_comment] = STATE(509),
    [sym_block_comment] = STATE(509),
    [ts_builtin_sym_end] = ACTIONS(1782),
    [sym_identifier] = ACTIONS(1784),
    [anon_sym_SEMI] = ACTIONS(1782),
    [anon_sym_macro_rules_BANG] = ACTIONS(1782),
    [anon_sym_LPAREN] = ACTIONS(1782),
    [anon_sym_LBRACK] = ACTIONS(1782),
    [anon_sym_LBRACE] = ACTIONS(1782),
    [anon_sym_RBRACE] = ACTIONS(1782),
    [anon_sym_STAR] = ACTIONS(1782),
    [anon_sym_u8] = ACTIONS(1784),
    [anon_sym_i8] = ACTIONS(1784),
    [anon_sym_u16] = ACTIONS(1784),
    [anon_sym_i16] = ACTIONS(1784),
    [anon_sym_u32] = ACTIONS(1784),
    [anon_sym_i32] = ACTIONS(1784),
    [anon_sym_u64] = ACTIONS(1784),
    [anon_sym_i64] = ACTIONS(1784),
    [anon_sym_u128] = ACTIONS(1784),
    [anon_sym_i128] = ACTIONS(1784),
    [anon_sym_isize] = ACTIONS(1784),
    [anon_sym_usize] = ACTIONS(1784),
    [anon_sym_f32] = ACTIONS(1784),
    [anon_sym_f64] = ACTIONS(1784),
    [anon_sym_bool] = ACTIONS(1784),
    [anon_sym_str] = ACTIONS(1784),
    [anon_sym_char] = ACTIONS(1784),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_BANG] = ACTIONS(1782),
    [anon_sym_AMP] = ACTIONS(1782),
    [anon_sym_PIPE] = ACTIONS(1782),
    [anon_sym_LT] = ACTIONS(1782),
    [anon_sym_DOT_DOT] = ACTIONS(1782),
    [anon_sym_COLON_COLON] = ACTIONS(1782),
    [anon_sym_POUND] = ACTIONS(1782),
    [anon_sym_SQUOTE] = ACTIONS(1784),
    [anon_sym_async] = ACTIONS(1784),
    [anon_sym_break] = ACTIONS(1784),
    [anon_sym_const] = ACTIONS(1784),
    [anon_sym_continue] = ACTIONS(1784),
    [anon_sym_default] = ACTIONS(1784),
    [anon_sym_enum] = ACTIONS(1784),
    [anon_sym_fn] = ACTIONS(1784),
    [anon_sym_for] = ACTIONS(1784),
    [anon_sym_if] = ACTIONS(1784),
    [anon_sym_impl] = ACTIONS(1784),
    [anon_sym_let] = ACTIONS(1784),
    [anon_sym_loop] = ACTIONS(1784),
    [anon_sym_match] = ACTIONS(1784),
    [anon_sym_mod] = ACTIONS(1784),
    [anon_sym_pub] = ACTIONS(1784),
    [anon_sym_return] = ACTIONS(1784),
    [anon_sym_static] = ACTIONS(1784),
    [anon_sym_struct] = ACTIONS(1784),
    [anon_sym_trait] = ACTIONS(1784),
    [anon_sym_type] = ACTIONS(1784),
    [anon_sym_union] = ACTIONS(1784),
    [anon_sym_unsafe] = ACTIONS(1784),
    [anon_sym_use] = ACTIONS(1784),
    [anon_sym_while] = ACTIONS(1784),
    [anon_sym_extern] = ACTIONS(1784),
    [anon_sym_yield] = ACTIONS(1784),
    [anon_sym_move] = ACTIONS(1784),
    [anon_sym_try] = ACTIONS(1784),
    [sym_integer_literal] = ACTIONS(1782),
    [aux_sym_string_literal_token1] = ACTIONS(1782),
    [sym_char_literal] = ACTIONS(1782),
    [anon_sym_true] = ACTIONS(1784),
    [anon_sym_false] = ACTIONS(1784),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1784),
    [sym_super] = ACTIONS(1784),
    [sym_crate] = ACTIONS(1784),
    [sym_metavariable] = ACTIONS(1782),
    [sym__raw_string_literal_start] = ACTIONS(1782),
    [sym_float_literal] = ACTIONS(1782),
  },
  [510] = {
    [sym_line_comment] = STATE(510),
    [sym_block_comment] = STATE(510),
    [ts_builtin_sym_end] = ACTIONS(1786),
    [sym_identifier] = ACTIONS(1788),
    [anon_sym_SEMI] = ACTIONS(1786),
    [anon_sym_macro_rules_BANG] = ACTIONS(1786),
    [anon_sym_LPAREN] = ACTIONS(1786),
    [anon_sym_LBRACK] = ACTIONS(1786),
    [anon_sym_LBRACE] = ACTIONS(1786),
    [anon_sym_RBRACE] = ACTIONS(1786),
    [anon_sym_STAR] = ACTIONS(1786),
    [anon_sym_u8] = ACTIONS(1788),
    [anon_sym_i8] = ACTIONS(1788),
    [anon_sym_u16] = ACTIONS(1788),
    [anon_sym_i16] = ACTIONS(1788),
    [anon_sym_u32] = ACTIONS(1788),
    [anon_sym_i32] = ACTIONS(1788),
    [anon_sym_u64] = ACTIONS(1788),
    [anon_sym_i64] = ACTIONS(1788),
    [anon_sym_u128] = ACTIONS(1788),
    [anon_sym_i128] = ACTIONS(1788),
    [anon_sym_isize] = ACTIONS(1788),
    [anon_sym_usize] = ACTIONS(1788),
    [anon_sym_f32] = ACTIONS(1788),
    [anon_sym_f64] = ACTIONS(1788),
    [anon_sym_bool] = ACTIONS(1788),
    [anon_sym_str] = ACTIONS(1788),
    [anon_sym_char] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1786),
    [anon_sym_BANG] = ACTIONS(1786),
    [anon_sym_AMP] = ACTIONS(1786),
    [anon_sym_PIPE] = ACTIONS(1786),
    [anon_sym_LT] = ACTIONS(1786),
    [anon_sym_DOT_DOT] = ACTIONS(1786),
    [anon_sym_COLON_COLON] = ACTIONS(1786),
    [anon_sym_POUND] = ACTIONS(1786),
    [anon_sym_SQUOTE] = ACTIONS(1788),
    [anon_sym_async] = ACTIONS(1788),
    [anon_sym_break] = ACTIONS(1788),
    [anon_sym_const] = ACTIONS(1788),
    [anon_sym_continue] = ACTIONS(1788),
    [anon_sym_default] = ACTIONS(1788),
    [anon_sym_enum] = ACTIONS(1788),
    [anon_sym_fn] = ACTIONS(1788),
    [anon_sym_for] = ACTIONS(1788),
    [anon_sym_if] = ACTIONS(1788),
    [anon_sym_impl] = ACTIONS(1788),
    [anon_sym_let] = ACTIONS(1788),
    [anon_sym_loop] = ACTIONS(1788),
    [anon_sym_match] = ACTIONS(1788),
    [anon_sym_mod] = ACTIONS(1788),
    [anon_sym_pub] = ACTIONS(1788),
    [anon_sym_return] = ACTIONS(1788),
    [anon_sym_static] = ACTIONS(1788),
    [anon_sym_struct] = ACTIONS(1788),
    [anon_sym_trait] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(1788),
    [anon_sym_union] = ACTIONS(1788),
    [anon_sym_unsafe] = ACTIONS(1788),
    [anon_sym_use] = ACTIONS(1788),
    [anon_sym_while] = ACTIONS(1788),
    [anon_sym_extern] = ACTIONS(1788),
    [anon_sym_yield] = ACTIONS(1788),
    [anon_sym_move] = ACTIONS(1788),
    [anon_sym_try] = ACTIONS(1788),
    [sym_integer_literal] = ACTIONS(1786),
    [aux_sym_string_literal_token1] = ACTIONS(1786),
    [sym_char_literal] = ACTIONS(1786),
    [anon_sym_true] = ACTIONS(1788),
    [anon_sym_false] = ACTIONS(1788),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1788),
    [sym_super] = ACTIONS(1788),
    [sym_crate] = ACTIONS(1788),
    [sym_metavariable] = ACTIONS(1786),
    [sym__raw_string_literal_start] = ACTIONS(1786),
    [sym_float_literal] = ACTIONS(1786),
  },
  [511] = {
    [sym_line_comment] = STATE(511),
    [sym_block_comment] = STATE(511),
    [ts_builtin_sym_end] = ACTIONS(1790),
    [sym_identifier] = ACTIONS(1792),
    [anon_sym_SEMI] = ACTIONS(1790),
    [anon_sym_macro_rules_BANG] = ACTIONS(1790),
    [anon_sym_LPAREN] = ACTIONS(1790),
    [anon_sym_LBRACK] = ACTIONS(1790),
    [anon_sym_LBRACE] = ACTIONS(1790),
    [anon_sym_RBRACE] = ACTIONS(1790),
    [anon_sym_STAR] = ACTIONS(1790),
    [anon_sym_u8] = ACTIONS(1792),
    [anon_sym_i8] = ACTIONS(1792),
    [anon_sym_u16] = ACTIONS(1792),
    [anon_sym_i16] = ACTIONS(1792),
    [anon_sym_u32] = ACTIONS(1792),
    [anon_sym_i32] = ACTIONS(1792),
    [anon_sym_u64] = ACTIONS(1792),
    [anon_sym_i64] = ACTIONS(1792),
    [anon_sym_u128] = ACTIONS(1792),
    [anon_sym_i128] = ACTIONS(1792),
    [anon_sym_isize] = ACTIONS(1792),
    [anon_sym_usize] = ACTIONS(1792),
    [anon_sym_f32] = ACTIONS(1792),
    [anon_sym_f64] = ACTIONS(1792),
    [anon_sym_bool] = ACTIONS(1792),
    [anon_sym_str] = ACTIONS(1792),
    [anon_sym_char] = ACTIONS(1792),
    [anon_sym_DASH] = ACTIONS(1790),
    [anon_sym_BANG] = ACTIONS(1790),
    [anon_sym_AMP] = ACTIONS(1790),
    [anon_sym_PIPE] = ACTIONS(1790),
    [anon_sym_LT] = ACTIONS(1790),
    [anon_sym_DOT_DOT] = ACTIONS(1790),
    [anon_sym_COLON_COLON] = ACTIONS(1790),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_SQUOTE] = ACTIONS(1792),
    [anon_sym_async] = ACTIONS(1792),
    [anon_sym_break] = ACTIONS(1792),
    [anon_sym_const] = ACTIONS(1792),
    [anon_sym_continue] = ACTIONS(1792),
    [anon_sym_default] = ACTIONS(1792),
    [anon_sym_enum] = ACTIONS(1792),
    [anon_sym_fn] = ACTIONS(1792),
    [anon_sym_for] = ACTIONS(1792),
    [anon_sym_if] = ACTIONS(1792),
    [anon_sym_impl] = ACTIONS(1792),
    [anon_sym_let] = ACTIONS(1792),
    [anon_sym_loop] = ACTIONS(1792),
    [anon_sym_match] = ACTIONS(1792),
    [anon_sym_mod] = ACTIONS(1792),
    [anon_sym_pub] = ACTIONS(1792),
    [anon_sym_return] = ACTIONS(1792),
    [anon_sym_static] = ACTIONS(1792),
    [anon_sym_struct] = ACTIONS(1792),
    [anon_sym_trait] = ACTIONS(1792),
    [anon_sym_type] = ACTIONS(1792),
    [anon_sym_union] = ACTIONS(1792),
    [anon_sym_unsafe] = ACTIONS(1792),
    [anon_sym_use] = ACTIONS(1792),
    [anon_sym_while] = ACTIONS(1792),
    [anon_sym_extern] = ACTIONS(1792),
    [anon_sym_yield] = ACTIONS(1792),
    [anon_sym_move] = ACTIONS(1792),
    [anon_sym_try] = ACTIONS(1792),
    [sym_integer_literal] = ACTIONS(1790),
    [aux_sym_string_literal_token1] = ACTIONS(1790),
    [sym_char_literal] = ACTIONS(1790),
    [anon_sym_true] = ACTIONS(1792),
    [anon_sym_false] = ACTIONS(1792),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1792),
    [sym_super] = ACTIONS(1792),
    [sym_crate] = ACTIONS(1792),
    [sym_metavariable] = ACTIONS(1790),
    [sym__raw_string_literal_start] = ACTIONS(1790),
    [sym_float_literal] = ACTIONS(1790),
  },
  [512] = {
    [sym_line_comment] = STATE(512),
    [sym_block_comment] = STATE(512),
    [ts_builtin_sym_end] = ACTIONS(1794),
    [sym_identifier] = ACTIONS(1796),
    [anon_sym_SEMI] = ACTIONS(1794),
    [anon_sym_macro_rules_BANG] = ACTIONS(1794),
    [anon_sym_LPAREN] = ACTIONS(1794),
    [anon_sym_LBRACK] = ACTIONS(1794),
    [anon_sym_LBRACE] = ACTIONS(1794),
    [anon_sym_RBRACE] = ACTIONS(1794),
    [anon_sym_STAR] = ACTIONS(1794),
    [anon_sym_u8] = ACTIONS(1796),
    [anon_sym_i8] = ACTIONS(1796),
    [anon_sym_u16] = ACTIONS(1796),
    [anon_sym_i16] = ACTIONS(1796),
    [anon_sym_u32] = ACTIONS(1796),
    [anon_sym_i32] = ACTIONS(1796),
    [anon_sym_u64] = ACTIONS(1796),
    [anon_sym_i64] = ACTIONS(1796),
    [anon_sym_u128] = ACTIONS(1796),
    [anon_sym_i128] = ACTIONS(1796),
    [anon_sym_isize] = ACTIONS(1796),
    [anon_sym_usize] = ACTIONS(1796),
    [anon_sym_f32] = ACTIONS(1796),
    [anon_sym_f64] = ACTIONS(1796),
    [anon_sym_bool] = ACTIONS(1796),
    [anon_sym_str] = ACTIONS(1796),
    [anon_sym_char] = ACTIONS(1796),
    [anon_sym_DASH] = ACTIONS(1794),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_AMP] = ACTIONS(1794),
    [anon_sym_PIPE] = ACTIONS(1794),
    [anon_sym_LT] = ACTIONS(1794),
    [anon_sym_DOT_DOT] = ACTIONS(1794),
    [anon_sym_COLON_COLON] = ACTIONS(1794),
    [anon_sym_POUND] = ACTIONS(1794),
    [anon_sym_SQUOTE] = ACTIONS(1796),
    [anon_sym_async] = ACTIONS(1796),
    [anon_sym_break] = ACTIONS(1796),
    [anon_sym_const] = ACTIONS(1796),
    [anon_sym_continue] = ACTIONS(1796),
    [anon_sym_default] = ACTIONS(1796),
    [anon_sym_enum] = ACTIONS(1796),
    [anon_sym_fn] = ACTIONS(1796),
    [anon_sym_for] = ACTIONS(1796),
    [anon_sym_if] = ACTIONS(1796),
    [anon_sym_impl] = ACTIONS(1796),
    [anon_sym_let] = ACTIONS(1796),
    [anon_sym_loop] = ACTIONS(1796),
    [anon_sym_match] = ACTIONS(1796),
    [anon_sym_mod] = ACTIONS(1796),
    [anon_sym_pub] = ACTIONS(1796),
    [anon_sym_return] = ACTIONS(1796),
    [anon_sym_static] = ACTIONS(1796),
    [anon_sym_struct] = ACTIONS(1796),
    [anon_sym_trait] = ACTIONS(1796),
    [anon_sym_type] = ACTIONS(1796),
    [anon_sym_union] = ACTIONS(1796),
    [anon_sym_unsafe] = ACTIONS(1796),
    [anon_sym_use] = ACTIONS(1796),
    [anon_sym_while] = ACTIONS(1796),
    [anon_sym_extern] = ACTIONS(1796),
    [anon_sym_yield] = ACTIONS(1796),
    [anon_sym_move] = ACTIONS(1796),
    [anon_sym_try] = ACTIONS(1796),
    [sym_integer_literal] = ACTIONS(1794),
    [aux_sym_string_literal_token1] = ACTIONS(1794),
    [sym_char_literal] = ACTIONS(1794),
    [anon_sym_true] = ACTIONS(1796),
    [anon_sym_false] = ACTIONS(1796),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1796),
    [sym_super] = ACTIONS(1796),
    [sym_crate] = ACTIONS(1796),
    [sym_metavariable] = ACTIONS(1794),
    [sym__raw_string_literal_start] = ACTIONS(1794),
    [sym_float_literal] = ACTIONS(1794),
  },
  [513] = {
    [sym_line_comment] = STATE(513),
    [sym_block_comment] = STATE(513),
    [ts_builtin_sym_end] = ACTIONS(1798),
    [sym_identifier] = ACTIONS(1800),
    [anon_sym_SEMI] = ACTIONS(1798),
    [anon_sym_macro_rules_BANG] = ACTIONS(1798),
    [anon_sym_LPAREN] = ACTIONS(1798),
    [anon_sym_LBRACK] = ACTIONS(1798),
    [anon_sym_LBRACE] = ACTIONS(1798),
    [anon_sym_RBRACE] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1798),
    [anon_sym_u8] = ACTIONS(1800),
    [anon_sym_i8] = ACTIONS(1800),
    [anon_sym_u16] = ACTIONS(1800),
    [anon_sym_i16] = ACTIONS(1800),
    [anon_sym_u32] = ACTIONS(1800),
    [anon_sym_i32] = ACTIONS(1800),
    [anon_sym_u64] = ACTIONS(1800),
    [anon_sym_i64] = ACTIONS(1800),
    [anon_sym_u128] = ACTIONS(1800),
    [anon_sym_i128] = ACTIONS(1800),
    [anon_sym_isize] = ACTIONS(1800),
    [anon_sym_usize] = ACTIONS(1800),
    [anon_sym_f32] = ACTIONS(1800),
    [anon_sym_f64] = ACTIONS(1800),
    [anon_sym_bool] = ACTIONS(1800),
    [anon_sym_str] = ACTIONS(1800),
    [anon_sym_char] = ACTIONS(1800),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_BANG] = ACTIONS(1798),
    [anon_sym_AMP] = ACTIONS(1798),
    [anon_sym_PIPE] = ACTIONS(1798),
    [anon_sym_LT] = ACTIONS(1798),
    [anon_sym_DOT_DOT] = ACTIONS(1798),
    [anon_sym_COLON_COLON] = ACTIONS(1798),
    [anon_sym_POUND] = ACTIONS(1798),
    [anon_sym_SQUOTE] = ACTIONS(1800),
    [anon_sym_async] = ACTIONS(1800),
    [anon_sym_break] = ACTIONS(1800),
    [anon_sym_const] = ACTIONS(1800),
    [anon_sym_continue] = ACTIONS(1800),
    [anon_sym_default] = ACTIONS(1800),
    [anon_sym_enum] = ACTIONS(1800),
    [anon_sym_fn] = ACTIONS(1800),
    [anon_sym_for] = ACTIONS(1800),
    [anon_sym_if] = ACTIONS(1800),
    [anon_sym_impl] = ACTIONS(1800),
    [anon_sym_let] = ACTIONS(1800),
    [anon_sym_loop] = ACTIONS(1800),
    [anon_sym_match] = ACTIONS(1800),
    [anon_sym_mod] = ACTIONS(1800),
    [anon_sym_pub] = ACTIONS(1800),
    [anon_sym_return] = ACTIONS(1800),
    [anon_sym_static] = ACTIONS(1800),
    [anon_sym_struct] = ACTIONS(1800),
    [anon_sym_trait] = ACTIONS(1800),
    [anon_sym_type] = ACTIONS(1800),
    [anon_sym_union] = ACTIONS(1800),
    [anon_sym_unsafe] = ACTIONS(1800),
    [anon_sym_use] = ACTIONS(1800),
    [anon_sym_while] = ACTIONS(1800),
    [anon_sym_extern] = ACTIONS(1800),
    [anon_sym_yield] = ACTIONS(1800),
    [anon_sym_move] = ACTIONS(1800),
    [anon_sym_try] = ACTIONS(1800),
    [sym_integer_literal] = ACTIONS(1798),
    [aux_sym_string_literal_token1] = ACTIONS(1798),
    [sym_char_literal] = ACTIONS(1798),
    [anon_sym_true] = ACTIONS(1800),
    [anon_sym_false] = ACTIONS(1800),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1800),
    [sym_super] = ACTIONS(1800),
    [sym_crate] = ACTIONS(1800),
    [sym_metavariable] = ACTIONS(1798),
    [sym__raw_string_literal_start] = ACTIONS(1798),
    [sym_float_literal] = ACTIONS(1798),
  },
  [514] = {
    [sym_line_comment] = STATE(514),
    [sym_block_comment] = STATE(514),
    [ts_builtin_sym_end] = ACTIONS(1802),
    [sym_identifier] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(1802),
    [anon_sym_macro_rules_BANG] = ACTIONS(1802),
    [anon_sym_LPAREN] = ACTIONS(1802),
    [anon_sym_LBRACK] = ACTIONS(1802),
    [anon_sym_LBRACE] = ACTIONS(1802),
    [anon_sym_RBRACE] = ACTIONS(1802),
    [anon_sym_STAR] = ACTIONS(1802),
    [anon_sym_u8] = ACTIONS(1804),
    [anon_sym_i8] = ACTIONS(1804),
    [anon_sym_u16] = ACTIONS(1804),
    [anon_sym_i16] = ACTIONS(1804),
    [anon_sym_u32] = ACTIONS(1804),
    [anon_sym_i32] = ACTIONS(1804),
    [anon_sym_u64] = ACTIONS(1804),
    [anon_sym_i64] = ACTIONS(1804),
    [anon_sym_u128] = ACTIONS(1804),
    [anon_sym_i128] = ACTIONS(1804),
    [anon_sym_isize] = ACTIONS(1804),
    [anon_sym_usize] = ACTIONS(1804),
    [anon_sym_f32] = ACTIONS(1804),
    [anon_sym_f64] = ACTIONS(1804),
    [anon_sym_bool] = ACTIONS(1804),
    [anon_sym_str] = ACTIONS(1804),
    [anon_sym_char] = ACTIONS(1804),
    [anon_sym_DASH] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(1802),
    [anon_sym_AMP] = ACTIONS(1802),
    [anon_sym_PIPE] = ACTIONS(1802),
    [anon_sym_LT] = ACTIONS(1802),
    [anon_sym_DOT_DOT] = ACTIONS(1802),
    [anon_sym_COLON_COLON] = ACTIONS(1802),
    [anon_sym_POUND] = ACTIONS(1802),
    [anon_sym_SQUOTE] = ACTIONS(1804),
    [anon_sym_async] = ACTIONS(1804),
    [anon_sym_break] = ACTIONS(1804),
    [anon_sym_const] = ACTIONS(1804),
    [anon_sym_continue] = ACTIONS(1804),
    [anon_sym_default] = ACTIONS(1804),
    [anon_sym_enum] = ACTIONS(1804),
    [anon_sym_fn] = ACTIONS(1804),
    [anon_sym_for] = ACTIONS(1804),
    [anon_sym_if] = ACTIONS(1804),
    [anon_sym_impl] = ACTIONS(1804),
    [anon_sym_let] = ACTIONS(1804),
    [anon_sym_loop] = ACTIONS(1804),
    [anon_sym_match] = ACTIONS(1804),
    [anon_sym_mod] = ACTIONS(1804),
    [anon_sym_pub] = ACTIONS(1804),
    [anon_sym_return] = ACTIONS(1804),
    [anon_sym_static] = ACTIONS(1804),
    [anon_sym_struct] = ACTIONS(1804),
    [anon_sym_trait] = ACTIONS(1804),
    [anon_sym_type] = ACTIONS(1804),
    [anon_sym_union] = ACTIONS(1804),
    [anon_sym_unsafe] = ACTIONS(1804),
    [anon_sym_use] = ACTIONS(1804),
    [anon_sym_while] = ACTIONS(1804),
    [anon_sym_extern] = ACTIONS(1804),
    [anon_sym_yield] = ACTIONS(1804),
    [anon_sym_move] = ACTIONS(1804),
    [anon_sym_try] = ACTIONS(1804),
    [sym_integer_literal] = ACTIONS(1802),
    [aux_sym_string_literal_token1] = ACTIONS(1802),
    [sym_char_literal] = ACTIONS(1802),
    [anon_sym_true] = ACTIONS(1804),
    [anon_sym_false] = ACTIONS(1804),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1804),
    [sym_super] = ACTIONS(1804),
    [sym_crate] = ACTIONS(1804),
    [sym_metavariable] = ACTIONS(1802),
    [sym__raw_string_literal_start] = ACTIONS(1802),
    [sym_float_literal] = ACTIONS(1802),
  },
  [515] = {
    [sym_line_comment] = STATE(515),
    [sym_block_comment] = STATE(515),
    [ts_builtin_sym_end] = ACTIONS(1806),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_SEMI] = ACTIONS(1806),
    [anon_sym_macro_rules_BANG] = ACTIONS(1806),
    [anon_sym_LPAREN] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(1806),
    [anon_sym_LBRACE] = ACTIONS(1806),
    [anon_sym_RBRACE] = ACTIONS(1806),
    [anon_sym_STAR] = ACTIONS(1806),
    [anon_sym_u8] = ACTIONS(1808),
    [anon_sym_i8] = ACTIONS(1808),
    [anon_sym_u16] = ACTIONS(1808),
    [anon_sym_i16] = ACTIONS(1808),
    [anon_sym_u32] = ACTIONS(1808),
    [anon_sym_i32] = ACTIONS(1808),
    [anon_sym_u64] = ACTIONS(1808),
    [anon_sym_i64] = ACTIONS(1808),
    [anon_sym_u128] = ACTIONS(1808),
    [anon_sym_i128] = ACTIONS(1808),
    [anon_sym_isize] = ACTIONS(1808),
    [anon_sym_usize] = ACTIONS(1808),
    [anon_sym_f32] = ACTIONS(1808),
    [anon_sym_f64] = ACTIONS(1808),
    [anon_sym_bool] = ACTIONS(1808),
    [anon_sym_str] = ACTIONS(1808),
    [anon_sym_char] = ACTIONS(1808),
    [anon_sym_DASH] = ACTIONS(1806),
    [anon_sym_BANG] = ACTIONS(1806),
    [anon_sym_AMP] = ACTIONS(1806),
    [anon_sym_PIPE] = ACTIONS(1806),
    [anon_sym_LT] = ACTIONS(1806),
    [anon_sym_DOT_DOT] = ACTIONS(1806),
    [anon_sym_COLON_COLON] = ACTIONS(1806),
    [anon_sym_POUND] = ACTIONS(1806),
    [anon_sym_SQUOTE] = ACTIONS(1808),
    [anon_sym_async] = ACTIONS(1808),
    [anon_sym_break] = ACTIONS(1808),
    [anon_sym_const] = ACTIONS(1808),
    [anon_sym_continue] = ACTIONS(1808),
    [anon_sym_default] = ACTIONS(1808),
    [anon_sym_enum] = ACTIONS(1808),
    [anon_sym_fn] = ACTIONS(1808),
    [anon_sym_for] = ACTIONS(1808),
    [anon_sym_if] = ACTIONS(1808),
    [anon_sym_impl] = ACTIONS(1808),
    [anon_sym_let] = ACTIONS(1808),
    [anon_sym_loop] = ACTIONS(1808),
    [anon_sym_match] = ACTIONS(1808),
    [anon_sym_mod] = ACTIONS(1808),
    [anon_sym_pub] = ACTIONS(1808),
    [anon_sym_return] = ACTIONS(1808),
    [anon_sym_static] = ACTIONS(1808),
    [anon_sym_struct] = ACTIONS(1808),
    [anon_sym_trait] = ACTIONS(1808),
    [anon_sym_type] = ACTIONS(1808),
    [anon_sym_union] = ACTIONS(1808),
    [anon_sym_unsafe] = ACTIONS(1808),
    [anon_sym_use] = ACTIONS(1808),
    [anon_sym_while] = ACTIONS(1808),
    [anon_sym_extern] = ACTIONS(1808),
    [anon_sym_yield] = ACTIONS(1808),
    [anon_sym_move] = ACTIONS(1808),
    [anon_sym_try] = ACTIONS(1808),
    [sym_integer_literal] = ACTIONS(1806),
    [aux_sym_string_literal_token1] = ACTIONS(1806),
    [sym_char_literal] = ACTIONS(1806),
    [anon_sym_true] = ACTIONS(1808),
    [anon_sym_false] = ACTIONS(1808),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1808),
    [sym_super] = ACTIONS(1808),
    [sym_crate] = ACTIONS(1808),
    [sym_metavariable] = ACTIONS(1806),
    [sym__raw_string_literal_start] = ACTIONS(1806),
    [sym_float_literal] = ACTIONS(1806),
  },
  [516] = {
    [sym_line_comment] = STATE(516),
    [sym_block_comment] = STATE(516),
    [ts_builtin_sym_end] = ACTIONS(1810),
    [sym_identifier] = ACTIONS(1812),
    [anon_sym_SEMI] = ACTIONS(1810),
    [anon_sym_macro_rules_BANG] = ACTIONS(1810),
    [anon_sym_LPAREN] = ACTIONS(1810),
    [anon_sym_LBRACK] = ACTIONS(1810),
    [anon_sym_LBRACE] = ACTIONS(1810),
    [anon_sym_RBRACE] = ACTIONS(1810),
    [anon_sym_STAR] = ACTIONS(1810),
    [anon_sym_u8] = ACTIONS(1812),
    [anon_sym_i8] = ACTIONS(1812),
    [anon_sym_u16] = ACTIONS(1812),
    [anon_sym_i16] = ACTIONS(1812),
    [anon_sym_u32] = ACTIONS(1812),
    [anon_sym_i32] = ACTIONS(1812),
    [anon_sym_u64] = ACTIONS(1812),
    [anon_sym_i64] = ACTIONS(1812),
    [anon_sym_u128] = ACTIONS(1812),
    [anon_sym_i128] = ACTIONS(1812),
    [anon_sym_isize] = ACTIONS(1812),
    [anon_sym_usize] = ACTIONS(1812),
    [anon_sym_f32] = ACTIONS(1812),
    [anon_sym_f64] = ACTIONS(1812),
    [anon_sym_bool] = ACTIONS(1812),
    [anon_sym_str] = ACTIONS(1812),
    [anon_sym_char] = ACTIONS(1812),
    [anon_sym_DASH] = ACTIONS(1810),
    [anon_sym_BANG] = ACTIONS(1810),
    [anon_sym_AMP] = ACTIONS(1810),
    [anon_sym_PIPE] = ACTIONS(1810),
    [anon_sym_LT] = ACTIONS(1810),
    [anon_sym_DOT_DOT] = ACTIONS(1810),
    [anon_sym_COLON_COLON] = ACTIONS(1810),
    [anon_sym_POUND] = ACTIONS(1810),
    [anon_sym_SQUOTE] = ACTIONS(1812),
    [anon_sym_async] = ACTIONS(1812),
    [anon_sym_break] = ACTIONS(1812),
    [anon_sym_const] = ACTIONS(1812),
    [anon_sym_continue] = ACTIONS(1812),
    [anon_sym_default] = ACTIONS(1812),
    [anon_sym_enum] = ACTIONS(1812),
    [anon_sym_fn] = ACTIONS(1812),
    [anon_sym_for] = ACTIONS(1812),
    [anon_sym_if] = ACTIONS(1812),
    [anon_sym_impl] = ACTIONS(1812),
    [anon_sym_let] = ACTIONS(1812),
    [anon_sym_loop] = ACTIONS(1812),
    [anon_sym_match] = ACTIONS(1812),
    [anon_sym_mod] = ACTIONS(1812),
    [anon_sym_pub] = ACTIONS(1812),
    [anon_sym_return] = ACTIONS(1812),
    [anon_sym_static] = ACTIONS(1812),
    [anon_sym_struct] = ACTIONS(1812),
    [anon_sym_trait] = ACTIONS(1812),
    [anon_sym_type] = ACTIONS(1812),
    [anon_sym_union] = ACTIONS(1812),
    [anon_sym_unsafe] = ACTIONS(1812),
    [anon_sym_use] = ACTIONS(1812),
    [anon_sym_while] = ACTIONS(1812),
    [anon_sym_extern] = ACTIONS(1812),
    [anon_sym_yield] = ACTIONS(1812),
    [anon_sym_move] = ACTIONS(1812),
    [anon_sym_try] = ACTIONS(1812),
    [sym_integer_literal] = ACTIONS(1810),
    [aux_sym_string_literal_token1] = ACTIONS(1810),
    [sym_char_literal] = ACTIONS(1810),
    [anon_sym_true] = ACTIONS(1812),
    [anon_sym_false] = ACTIONS(1812),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1812),
    [sym_super] = ACTIONS(1812),
    [sym_crate] = ACTIONS(1812),
    [sym_metavariable] = ACTIONS(1810),
    [sym__raw_string_literal_start] = ACTIONS(1810),
    [sym_float_literal] = ACTIONS(1810),
  },
  [517] = {
    [sym_line_comment] = STATE(517),
    [sym_block_comment] = STATE(517),
    [ts_builtin_sym_end] = ACTIONS(1814),
    [sym_identifier] = ACTIONS(1816),
    [anon_sym_SEMI] = ACTIONS(1814),
    [anon_sym_macro_rules_BANG] = ACTIONS(1814),
    [anon_sym_LPAREN] = ACTIONS(1814),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [anon_sym_LBRACE] = ACTIONS(1814),
    [anon_sym_RBRACE] = ACTIONS(1814),
    [anon_sym_STAR] = ACTIONS(1814),
    [anon_sym_u8] = ACTIONS(1816),
    [anon_sym_i8] = ACTIONS(1816),
    [anon_sym_u16] = ACTIONS(1816),
    [anon_sym_i16] = ACTIONS(1816),
    [anon_sym_u32] = ACTIONS(1816),
    [anon_sym_i32] = ACTIONS(1816),
    [anon_sym_u64] = ACTIONS(1816),
    [anon_sym_i64] = ACTIONS(1816),
    [anon_sym_u128] = ACTIONS(1816),
    [anon_sym_i128] = ACTIONS(1816),
    [anon_sym_isize] = ACTIONS(1816),
    [anon_sym_usize] = ACTIONS(1816),
    [anon_sym_f32] = ACTIONS(1816),
    [anon_sym_f64] = ACTIONS(1816),
    [anon_sym_bool] = ACTIONS(1816),
    [anon_sym_str] = ACTIONS(1816),
    [anon_sym_char] = ACTIONS(1816),
    [anon_sym_DASH] = ACTIONS(1814),
    [anon_sym_BANG] = ACTIONS(1814),
    [anon_sym_AMP] = ACTIONS(1814),
    [anon_sym_PIPE] = ACTIONS(1814),
    [anon_sym_LT] = ACTIONS(1814),
    [anon_sym_DOT_DOT] = ACTIONS(1814),
    [anon_sym_COLON_COLON] = ACTIONS(1814),
    [anon_sym_POUND] = ACTIONS(1814),
    [anon_sym_SQUOTE] = ACTIONS(1816),
    [anon_sym_async] = ACTIONS(1816),
    [anon_sym_break] = ACTIONS(1816),
    [anon_sym_const] = ACTIONS(1816),
    [anon_sym_continue] = ACTIONS(1816),
    [anon_sym_default] = ACTIONS(1816),
    [anon_sym_enum] = ACTIONS(1816),
    [anon_sym_fn] = ACTIONS(1816),
    [anon_sym_for] = ACTIONS(1816),
    [anon_sym_if] = ACTIONS(1816),
    [anon_sym_impl] = ACTIONS(1816),
    [anon_sym_let] = ACTIONS(1816),
    [anon_sym_loop] = ACTIONS(1816),
    [anon_sym_match] = ACTIONS(1816),
    [anon_sym_mod] = ACTIONS(1816),
    [anon_sym_pub] = ACTIONS(1816),
    [anon_sym_return] = ACTIONS(1816),
    [anon_sym_static] = ACTIONS(1816),
    [anon_sym_struct] = ACTIONS(1816),
    [anon_sym_trait] = ACTIONS(1816),
    [anon_sym_type] = ACTIONS(1816),
    [anon_sym_union] = ACTIONS(1816),
    [anon_sym_unsafe] = ACTIONS(1816),
    [anon_sym_use] = ACTIONS(1816),
    [anon_sym_while] = ACTIONS(1816),
    [anon_sym_extern] = ACTIONS(1816),
    [anon_sym_yield] = ACTIONS(1816),
    [anon_sym_move] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(1816),
    [sym_integer_literal] = ACTIONS(1814),
    [aux_sym_string_literal_token1] = ACTIONS(1814),
    [sym_char_literal] = ACTIONS(1814),
    [anon_sym_true] = ACTIONS(1816),
    [anon_sym_false] = ACTIONS(1816),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1816),
    [sym_super] = ACTIONS(1816),
    [sym_crate] = ACTIONS(1816),
    [sym_metavariable] = ACTIONS(1814),
    [sym__raw_string_literal_start] = ACTIONS(1814),
    [sym_float_literal] = ACTIONS(1814),
  },
  [518] = {
    [sym_line_comment] = STATE(518),
    [sym_block_comment] = STATE(518),
    [ts_builtin_sym_end] = ACTIONS(1818),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(1818),
    [anon_sym_macro_rules_BANG] = ACTIONS(1818),
    [anon_sym_LPAREN] = ACTIONS(1818),
    [anon_sym_LBRACK] = ACTIONS(1818),
    [anon_sym_LBRACE] = ACTIONS(1818),
    [anon_sym_RBRACE] = ACTIONS(1818),
    [anon_sym_STAR] = ACTIONS(1818),
    [anon_sym_u8] = ACTIONS(1820),
    [anon_sym_i8] = ACTIONS(1820),
    [anon_sym_u16] = ACTIONS(1820),
    [anon_sym_i16] = ACTIONS(1820),
    [anon_sym_u32] = ACTIONS(1820),
    [anon_sym_i32] = ACTIONS(1820),
    [anon_sym_u64] = ACTIONS(1820),
    [anon_sym_i64] = ACTIONS(1820),
    [anon_sym_u128] = ACTIONS(1820),
    [anon_sym_i128] = ACTIONS(1820),
    [anon_sym_isize] = ACTIONS(1820),
    [anon_sym_usize] = ACTIONS(1820),
    [anon_sym_f32] = ACTIONS(1820),
    [anon_sym_f64] = ACTIONS(1820),
    [anon_sym_bool] = ACTIONS(1820),
    [anon_sym_str] = ACTIONS(1820),
    [anon_sym_char] = ACTIONS(1820),
    [anon_sym_DASH] = ACTIONS(1818),
    [anon_sym_BANG] = ACTIONS(1818),
    [anon_sym_AMP] = ACTIONS(1818),
    [anon_sym_PIPE] = ACTIONS(1818),
    [anon_sym_LT] = ACTIONS(1818),
    [anon_sym_DOT_DOT] = ACTIONS(1818),
    [anon_sym_COLON_COLON] = ACTIONS(1818),
    [anon_sym_POUND] = ACTIONS(1818),
    [anon_sym_SQUOTE] = ACTIONS(1820),
    [anon_sym_async] = ACTIONS(1820),
    [anon_sym_break] = ACTIONS(1820),
    [anon_sym_const] = ACTIONS(1820),
    [anon_sym_continue] = ACTIONS(1820),
    [anon_sym_default] = ACTIONS(1820),
    [anon_sym_enum] = ACTIONS(1820),
    [anon_sym_fn] = ACTIONS(1820),
    [anon_sym_for] = ACTIONS(1820),
    [anon_sym_if] = ACTIONS(1820),
    [anon_sym_impl] = ACTIONS(1820),
    [anon_sym_let] = ACTIONS(1820),
    [anon_sym_loop] = ACTIONS(1820),
    [anon_sym_match] = ACTIONS(1820),
    [anon_sym_mod] = ACTIONS(1820),
    [anon_sym_pub] = ACTIONS(1820),
    [anon_sym_return] = ACTIONS(1820),
    [anon_sym_static] = ACTIONS(1820),
    [anon_sym_struct] = ACTIONS(1820),
    [anon_sym_trait] = ACTIONS(1820),
    [anon_sym_type] = ACTIONS(1820),
    [anon_sym_union] = ACTIONS(1820),
    [anon_sym_unsafe] = ACTIONS(1820),
    [anon_sym_use] = ACTIONS(1820),
    [anon_sym_while] = ACTIONS(1820),
    [anon_sym_extern] = ACTIONS(1820),
    [anon_sym_yield] = ACTIONS(1820),
    [anon_sym_move] = ACTIONS(1820),
    [anon_sym_try] = ACTIONS(1820),
    [sym_integer_literal] = ACTIONS(1818),
    [aux_sym_string_literal_token1] = ACTIONS(1818),
    [sym_char_literal] = ACTIONS(1818),
    [anon_sym_true] = ACTIONS(1820),
    [anon_sym_false] = ACTIONS(1820),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1820),
    [sym_super] = ACTIONS(1820),
    [sym_crate] = ACTIONS(1820),
    [sym_metavariable] = ACTIONS(1818),
    [sym__raw_string_literal_start] = ACTIONS(1818),
    [sym_float_literal] = ACTIONS(1818),
  },
  [519] = {
    [sym_line_comment] = STATE(519),
    [sym_block_comment] = STATE(519),
    [ts_builtin_sym_end] = ACTIONS(1822),
    [sym_identifier] = ACTIONS(1824),
    [anon_sym_SEMI] = ACTIONS(1822),
    [anon_sym_macro_rules_BANG] = ACTIONS(1822),
    [anon_sym_LPAREN] = ACTIONS(1822),
    [anon_sym_LBRACK] = ACTIONS(1822),
    [anon_sym_LBRACE] = ACTIONS(1822),
    [anon_sym_RBRACE] = ACTIONS(1822),
    [anon_sym_STAR] = ACTIONS(1822),
    [anon_sym_u8] = ACTIONS(1824),
    [anon_sym_i8] = ACTIONS(1824),
    [anon_sym_u16] = ACTIONS(1824),
    [anon_sym_i16] = ACTIONS(1824),
    [anon_sym_u32] = ACTIONS(1824),
    [anon_sym_i32] = ACTIONS(1824),
    [anon_sym_u64] = ACTIONS(1824),
    [anon_sym_i64] = ACTIONS(1824),
    [anon_sym_u128] = ACTIONS(1824),
    [anon_sym_i128] = ACTIONS(1824),
    [anon_sym_isize] = ACTIONS(1824),
    [anon_sym_usize] = ACTIONS(1824),
    [anon_sym_f32] = ACTIONS(1824),
    [anon_sym_f64] = ACTIONS(1824),
    [anon_sym_bool] = ACTIONS(1824),
    [anon_sym_str] = ACTIONS(1824),
    [anon_sym_char] = ACTIONS(1824),
    [anon_sym_DASH] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1822),
    [anon_sym_AMP] = ACTIONS(1822),
    [anon_sym_PIPE] = ACTIONS(1822),
    [anon_sym_LT] = ACTIONS(1822),
    [anon_sym_DOT_DOT] = ACTIONS(1822),
    [anon_sym_COLON_COLON] = ACTIONS(1822),
    [anon_sym_POUND] = ACTIONS(1822),
    [anon_sym_SQUOTE] = ACTIONS(1824),
    [anon_sym_async] = ACTIONS(1824),
    [anon_sym_break] = ACTIONS(1824),
    [anon_sym_const] = ACTIONS(1824),
    [anon_sym_continue] = ACTIONS(1824),
    [anon_sym_default] = ACTIONS(1824),
    [anon_sym_enum] = ACTIONS(1824),
    [anon_sym_fn] = ACTIONS(1824),
    [anon_sym_for] = ACTIONS(1824),
    [anon_sym_if] = ACTIONS(1824),
    [anon_sym_impl] = ACTIONS(1824),
    [anon_sym_let] = ACTIONS(1824),
    [anon_sym_loop] = ACTIONS(1824),
    [anon_sym_match] = ACTIONS(1824),
    [anon_sym_mod] = ACTIONS(1824),
    [anon_sym_pub] = ACTIONS(1824),
    [anon_sym_return] = ACTIONS(1824),
    [anon_sym_static] = ACTIONS(1824),
    [anon_sym_struct] = ACTIONS(1824),
    [anon_sym_trait] = ACTIONS(1824),
    [anon_sym_type] = ACTIONS(1824),
    [anon_sym_union] = ACTIONS(1824),
    [anon_sym_unsafe] = ACTIONS(1824),
    [anon_sym_use] = ACTIONS(1824),
    [anon_sym_while] = ACTIONS(1824),
    [anon_sym_extern] = ACTIONS(1824),
    [anon_sym_yield] = ACTIONS(1824),
    [anon_sym_move] = ACTIONS(1824),
    [anon_sym_try] = ACTIONS(1824),
    [sym_integer_literal] = ACTIONS(1822),
    [aux_sym_string_literal_token1] = ACTIONS(1822),
    [sym_char_literal] = ACTIONS(1822),
    [anon_sym_true] = ACTIONS(1824),
    [anon_sym_false] = ACTIONS(1824),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1824),
    [sym_super] = ACTIONS(1824),
    [sym_crate] = ACTIONS(1824),
    [sym_metavariable] = ACTIONS(1822),
    [sym__raw_string_literal_start] = ACTIONS(1822),
    [sym_float_literal] = ACTIONS(1822),
  },
  [520] = {
    [sym_line_comment] = STATE(520),
    [sym_block_comment] = STATE(520),
    [ts_builtin_sym_end] = ACTIONS(1826),
    [sym_identifier] = ACTIONS(1828),
    [anon_sym_SEMI] = ACTIONS(1826),
    [anon_sym_macro_rules_BANG] = ACTIONS(1826),
    [anon_sym_LPAREN] = ACTIONS(1826),
    [anon_sym_LBRACK] = ACTIONS(1826),
    [anon_sym_LBRACE] = ACTIONS(1826),
    [anon_sym_RBRACE] = ACTIONS(1826),
    [anon_sym_STAR] = ACTIONS(1826),
    [anon_sym_u8] = ACTIONS(1828),
    [anon_sym_i8] = ACTIONS(1828),
    [anon_sym_u16] = ACTIONS(1828),
    [anon_sym_i16] = ACTIONS(1828),
    [anon_sym_u32] = ACTIONS(1828),
    [anon_sym_i32] = ACTIONS(1828),
    [anon_sym_u64] = ACTIONS(1828),
    [anon_sym_i64] = ACTIONS(1828),
    [anon_sym_u128] = ACTIONS(1828),
    [anon_sym_i128] = ACTIONS(1828),
    [anon_sym_isize] = ACTIONS(1828),
    [anon_sym_usize] = ACTIONS(1828),
    [anon_sym_f32] = ACTIONS(1828),
    [anon_sym_f64] = ACTIONS(1828),
    [anon_sym_bool] = ACTIONS(1828),
    [anon_sym_str] = ACTIONS(1828),
    [anon_sym_char] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1826),
    [anon_sym_BANG] = ACTIONS(1826),
    [anon_sym_AMP] = ACTIONS(1826),
    [anon_sym_PIPE] = ACTIONS(1826),
    [anon_sym_LT] = ACTIONS(1826),
    [anon_sym_DOT_DOT] = ACTIONS(1826),
    [anon_sym_COLON_COLON] = ACTIONS(1826),
    [anon_sym_POUND] = ACTIONS(1826),
    [anon_sym_SQUOTE] = ACTIONS(1828),
    [anon_sym_async] = ACTIONS(1828),
    [anon_sym_break] = ACTIONS(1828),
    [anon_sym_const] = ACTIONS(1828),
    [anon_sym_continue] = ACTIONS(1828),
    [anon_sym_default] = ACTIONS(1828),
    [anon_sym_enum] = ACTIONS(1828),
    [anon_sym_fn] = ACTIONS(1828),
    [anon_sym_for] = ACTIONS(1828),
    [anon_sym_if] = ACTIONS(1828),
    [anon_sym_impl] = ACTIONS(1828),
    [anon_sym_let] = ACTIONS(1828),
    [anon_sym_loop] = ACTIONS(1828),
    [anon_sym_match] = ACTIONS(1828),
    [anon_sym_mod] = ACTIONS(1828),
    [anon_sym_pub] = ACTIONS(1828),
    [anon_sym_return] = ACTIONS(1828),
    [anon_sym_static] = ACTIONS(1828),
    [anon_sym_struct] = ACTIONS(1828),
    [anon_sym_trait] = ACTIONS(1828),
    [anon_sym_type] = ACTIONS(1828),
    [anon_sym_union] = ACTIONS(1828),
    [anon_sym_unsafe] = ACTIONS(1828),
    [anon_sym_use] = ACTIONS(1828),
    [anon_sym_while] = ACTIONS(1828),
    [anon_sym_extern] = ACTIONS(1828),
    [anon_sym_yield] = ACTIONS(1828),
    [anon_sym_move] = ACTIONS(1828),
    [anon_sym_try] = ACTIONS(1828),
    [sym_integer_literal] = ACTIONS(1826),
    [aux_sym_string_literal_token1] = ACTIONS(1826),
    [sym_char_literal] = ACTIONS(1826),
    [anon_sym_true] = ACTIONS(1828),
    [anon_sym_false] = ACTIONS(1828),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1828),
    [sym_super] = ACTIONS(1828),
    [sym_crate] = ACTIONS(1828),
    [sym_metavariable] = ACTIONS(1826),
    [sym__raw_string_literal_start] = ACTIONS(1826),
    [sym_float_literal] = ACTIONS(1826),
  },
  [521] = {
    [sym_line_comment] = STATE(521),
    [sym_block_comment] = STATE(521),
    [ts_builtin_sym_end] = ACTIONS(1830),
    [sym_identifier] = ACTIONS(1832),
    [anon_sym_SEMI] = ACTIONS(1830),
    [anon_sym_macro_rules_BANG] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(1830),
    [anon_sym_LBRACK] = ACTIONS(1830),
    [anon_sym_LBRACE] = ACTIONS(1830),
    [anon_sym_RBRACE] = ACTIONS(1830),
    [anon_sym_STAR] = ACTIONS(1830),
    [anon_sym_u8] = ACTIONS(1832),
    [anon_sym_i8] = ACTIONS(1832),
    [anon_sym_u16] = ACTIONS(1832),
    [anon_sym_i16] = ACTIONS(1832),
    [anon_sym_u32] = ACTIONS(1832),
    [anon_sym_i32] = ACTIONS(1832),
    [anon_sym_u64] = ACTIONS(1832),
    [anon_sym_i64] = ACTIONS(1832),
    [anon_sym_u128] = ACTIONS(1832),
    [anon_sym_i128] = ACTIONS(1832),
    [anon_sym_isize] = ACTIONS(1832),
    [anon_sym_usize] = ACTIONS(1832),
    [anon_sym_f32] = ACTIONS(1832),
    [anon_sym_f64] = ACTIONS(1832),
    [anon_sym_bool] = ACTIONS(1832),
    [anon_sym_str] = ACTIONS(1832),
    [anon_sym_char] = ACTIONS(1832),
    [anon_sym_DASH] = ACTIONS(1830),
    [anon_sym_BANG] = ACTIONS(1830),
    [anon_sym_AMP] = ACTIONS(1830),
    [anon_sym_PIPE] = ACTIONS(1830),
    [anon_sym_LT] = ACTIONS(1830),
    [anon_sym_DOT_DOT] = ACTIONS(1830),
    [anon_sym_COLON_COLON] = ACTIONS(1830),
    [anon_sym_POUND] = ACTIONS(1830),
    [anon_sym_SQUOTE] = ACTIONS(1832),
    [anon_sym_async] = ACTIONS(1832),
    [anon_sym_break] = ACTIONS(1832),
    [anon_sym_const] = ACTIONS(1832),
    [anon_sym_continue] = ACTIONS(1832),
    [anon_sym_default] = ACTIONS(1832),
    [anon_sym_enum] = ACTIONS(1832),
    [anon_sym_fn] = ACTIONS(1832),
    [anon_sym_for] = ACTIONS(1832),
    [anon_sym_if] = ACTIONS(1832),
    [anon_sym_impl] = ACTIONS(1832),
    [anon_sym_let] = ACTIONS(1832),
    [anon_sym_loop] = ACTIONS(1832),
    [anon_sym_match] = ACTIONS(1832),
    [anon_sym_mod] = ACTIONS(1832),
    [anon_sym_pub] = ACTIONS(1832),
    [anon_sym_return] = ACTIONS(1832),
    [anon_sym_static] = ACTIONS(1832),
    [anon_sym_struct] = ACTIONS(1832),
    [anon_sym_trait] = ACTIONS(1832),
    [anon_sym_type] = ACTIONS(1832),
    [anon_sym_union] = ACTIONS(1832),
    [anon_sym_unsafe] = ACTIONS(1832),
    [anon_sym_use] = ACTIONS(1832),
    [anon_sym_while] = ACTIONS(1832),
    [anon_sym_extern] = ACTIONS(1832),
    [anon_sym_yield] = ACTIONS(1832),
    [anon_sym_move] = ACTIONS(1832),
    [anon_sym_try] = ACTIONS(1832),
    [sym_integer_literal] = ACTIONS(1830),
    [aux_sym_string_literal_token1] = ACTIONS(1830),
    [sym_char_literal] = ACTIONS(1830),
    [anon_sym_true] = ACTIONS(1832),
    [anon_sym_false] = ACTIONS(1832),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1832),
    [sym_super] = ACTIONS(1832),
    [sym_crate] = ACTIONS(1832),
    [sym_metavariable] = ACTIONS(1830),
    [sym__raw_string_literal_start] = ACTIONS(1830),
    [sym_float_literal] = ACTIONS(1830),
  },
  [522] = {
    [sym_line_comment] = STATE(522),
    [sym_block_comment] = STATE(522),
    [ts_builtin_sym_end] = ACTIONS(1834),
    [sym_identifier] = ACTIONS(1836),
    [anon_sym_SEMI] = ACTIONS(1834),
    [anon_sym_macro_rules_BANG] = ACTIONS(1834),
    [anon_sym_LPAREN] = ACTIONS(1834),
    [anon_sym_LBRACK] = ACTIONS(1834),
    [anon_sym_LBRACE] = ACTIONS(1834),
    [anon_sym_RBRACE] = ACTIONS(1834),
    [anon_sym_STAR] = ACTIONS(1834),
    [anon_sym_u8] = ACTIONS(1836),
    [anon_sym_i8] = ACTIONS(1836),
    [anon_sym_u16] = ACTIONS(1836),
    [anon_sym_i16] = ACTIONS(1836),
    [anon_sym_u32] = ACTIONS(1836),
    [anon_sym_i32] = ACTIONS(1836),
    [anon_sym_u64] = ACTIONS(1836),
    [anon_sym_i64] = ACTIONS(1836),
    [anon_sym_u128] = ACTIONS(1836),
    [anon_sym_i128] = ACTIONS(1836),
    [anon_sym_isize] = ACTIONS(1836),
    [anon_sym_usize] = ACTIONS(1836),
    [anon_sym_f32] = ACTIONS(1836),
    [anon_sym_f64] = ACTIONS(1836),
    [anon_sym_bool] = ACTIONS(1836),
    [anon_sym_str] = ACTIONS(1836),
    [anon_sym_char] = ACTIONS(1836),
    [anon_sym_DASH] = ACTIONS(1834),
    [anon_sym_BANG] = ACTIONS(1834),
    [anon_sym_AMP] = ACTIONS(1834),
    [anon_sym_PIPE] = ACTIONS(1834),
    [anon_sym_LT] = ACTIONS(1834),
    [anon_sym_DOT_DOT] = ACTIONS(1834),
    [anon_sym_COLON_COLON] = ACTIONS(1834),
    [anon_sym_POUND] = ACTIONS(1834),
    [anon_sym_SQUOTE] = ACTIONS(1836),
    [anon_sym_async] = ACTIONS(1836),
    [anon_sym_break] = ACTIONS(1836),
    [anon_sym_const] = ACTIONS(1836),
    [anon_sym_continue] = ACTIONS(1836),
    [anon_sym_default] = ACTIONS(1836),
    [anon_sym_enum] = ACTIONS(1836),
    [anon_sym_fn] = ACTIONS(1836),
    [anon_sym_for] = ACTIONS(1836),
    [anon_sym_if] = ACTIONS(1836),
    [anon_sym_impl] = ACTIONS(1836),
    [anon_sym_let] = ACTIONS(1836),
    [anon_sym_loop] = ACTIONS(1836),
    [anon_sym_match] = ACTIONS(1836),
    [anon_sym_mod] = ACTIONS(1836),
    [anon_sym_pub] = ACTIONS(1836),
    [anon_sym_return] = ACTIONS(1836),
    [anon_sym_static] = ACTIONS(1836),
    [anon_sym_struct] = ACTIONS(1836),
    [anon_sym_trait] = ACTIONS(1836),
    [anon_sym_type] = ACTIONS(1836),
    [anon_sym_union] = ACTIONS(1836),
    [anon_sym_unsafe] = ACTIONS(1836),
    [anon_sym_use] = ACTIONS(1836),
    [anon_sym_while] = ACTIONS(1836),
    [anon_sym_extern] = ACTIONS(1836),
    [anon_sym_yield] = ACTIONS(1836),
    [anon_sym_move] = ACTIONS(1836),
    [anon_sym_try] = ACTIONS(1836),
    [sym_integer_literal] = ACTIONS(1834),
    [aux_sym_string_literal_token1] = ACTIONS(1834),
    [sym_char_literal] = ACTIONS(1834),
    [anon_sym_true] = ACTIONS(1836),
    [anon_sym_false] = ACTIONS(1836),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1836),
    [sym_super] = ACTIONS(1836),
    [sym_crate] = ACTIONS(1836),
    [sym_metavariable] = ACTIONS(1834),
    [sym__raw_string_literal_start] = ACTIONS(1834),
    [sym_float_literal] = ACTIONS(1834),
  },
  [523] = {
    [sym_line_comment] = STATE(523),
    [sym_block_comment] = STATE(523),
    [ts_builtin_sym_end] = ACTIONS(1838),
    [sym_identifier] = ACTIONS(1840),
    [anon_sym_SEMI] = ACTIONS(1838),
    [anon_sym_macro_rules_BANG] = ACTIONS(1838),
    [anon_sym_LPAREN] = ACTIONS(1838),
    [anon_sym_LBRACK] = ACTIONS(1838),
    [anon_sym_LBRACE] = ACTIONS(1838),
    [anon_sym_RBRACE] = ACTIONS(1838),
    [anon_sym_STAR] = ACTIONS(1838),
    [anon_sym_u8] = ACTIONS(1840),
    [anon_sym_i8] = ACTIONS(1840),
    [anon_sym_u16] = ACTIONS(1840),
    [anon_sym_i16] = ACTIONS(1840),
    [anon_sym_u32] = ACTIONS(1840),
    [anon_sym_i32] = ACTIONS(1840),
    [anon_sym_u64] = ACTIONS(1840),
    [anon_sym_i64] = ACTIONS(1840),
    [anon_sym_u128] = ACTIONS(1840),
    [anon_sym_i128] = ACTIONS(1840),
    [anon_sym_isize] = ACTIONS(1840),
    [anon_sym_usize] = ACTIONS(1840),
    [anon_sym_f32] = ACTIONS(1840),
    [anon_sym_f64] = ACTIONS(1840),
    [anon_sym_bool] = ACTIONS(1840),
    [anon_sym_str] = ACTIONS(1840),
    [anon_sym_char] = ACTIONS(1840),
    [anon_sym_DASH] = ACTIONS(1838),
    [anon_sym_BANG] = ACTIONS(1838),
    [anon_sym_AMP] = ACTIONS(1838),
    [anon_sym_PIPE] = ACTIONS(1838),
    [anon_sym_LT] = ACTIONS(1838),
    [anon_sym_DOT_DOT] = ACTIONS(1838),
    [anon_sym_COLON_COLON] = ACTIONS(1838),
    [anon_sym_POUND] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1840),
    [anon_sym_async] = ACTIONS(1840),
    [anon_sym_break] = ACTIONS(1840),
    [anon_sym_const] = ACTIONS(1840),
    [anon_sym_continue] = ACTIONS(1840),
    [anon_sym_default] = ACTIONS(1840),
    [anon_sym_enum] = ACTIONS(1840),
    [anon_sym_fn] = ACTIONS(1840),
    [anon_sym_for] = ACTIONS(1840),
    [anon_sym_if] = ACTIONS(1840),
    [anon_sym_impl] = ACTIONS(1840),
    [anon_sym_let] = ACTIONS(1840),
    [anon_sym_loop] = ACTIONS(1840),
    [anon_sym_match] = ACTIONS(1840),
    [anon_sym_mod] = ACTIONS(1840),
    [anon_sym_pub] = ACTIONS(1840),
    [anon_sym_return] = ACTIONS(1840),
    [anon_sym_static] = ACTIONS(1840),
    [anon_sym_struct] = ACTIONS(1840),
    [anon_sym_trait] = ACTIONS(1840),
    [anon_sym_type] = ACTIONS(1840),
    [anon_sym_union] = ACTIONS(1840),
    [anon_sym_unsafe] = ACTIONS(1840),
    [anon_sym_use] = ACTIONS(1840),
    [anon_sym_while] = ACTIONS(1840),
    [anon_sym_extern] = ACTIONS(1840),
    [anon_sym_yield] = ACTIONS(1840),
    [anon_sym_move] = ACTIONS(1840),
    [anon_sym_try] = ACTIONS(1840),
    [sym_integer_literal] = ACTIONS(1838),
    [aux_sym_string_literal_token1] = ACTIONS(1838),
    [sym_char_literal] = ACTIONS(1838),
    [anon_sym_true] = ACTIONS(1840),
    [anon_sym_false] = ACTIONS(1840),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1840),
    [sym_super] = ACTIONS(1840),
    [sym_crate] = ACTIONS(1840),
    [sym_metavariable] = ACTIONS(1838),
    [sym__raw_string_literal_start] = ACTIONS(1838),
    [sym_float_literal] = ACTIONS(1838),
  },
  [524] = {
    [sym_line_comment] = STATE(524),
    [sym_block_comment] = STATE(524),
    [ts_builtin_sym_end] = ACTIONS(1842),
    [sym_identifier] = ACTIONS(1844),
    [anon_sym_SEMI] = ACTIONS(1842),
    [anon_sym_macro_rules_BANG] = ACTIONS(1842),
    [anon_sym_LPAREN] = ACTIONS(1842),
    [anon_sym_LBRACK] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(1842),
    [anon_sym_RBRACE] = ACTIONS(1842),
    [anon_sym_STAR] = ACTIONS(1842),
    [anon_sym_u8] = ACTIONS(1844),
    [anon_sym_i8] = ACTIONS(1844),
    [anon_sym_u16] = ACTIONS(1844),
    [anon_sym_i16] = ACTIONS(1844),
    [anon_sym_u32] = ACTIONS(1844),
    [anon_sym_i32] = ACTIONS(1844),
    [anon_sym_u64] = ACTIONS(1844),
    [anon_sym_i64] = ACTIONS(1844),
    [anon_sym_u128] = ACTIONS(1844),
    [anon_sym_i128] = ACTIONS(1844),
    [anon_sym_isize] = ACTIONS(1844),
    [anon_sym_usize] = ACTIONS(1844),
    [anon_sym_f32] = ACTIONS(1844),
    [anon_sym_f64] = ACTIONS(1844),
    [anon_sym_bool] = ACTIONS(1844),
    [anon_sym_str] = ACTIONS(1844),
    [anon_sym_char] = ACTIONS(1844),
    [anon_sym_DASH] = ACTIONS(1842),
    [anon_sym_BANG] = ACTIONS(1842),
    [anon_sym_AMP] = ACTIONS(1842),
    [anon_sym_PIPE] = ACTIONS(1842),
    [anon_sym_LT] = ACTIONS(1842),
    [anon_sym_DOT_DOT] = ACTIONS(1842),
    [anon_sym_COLON_COLON] = ACTIONS(1842),
    [anon_sym_POUND] = ACTIONS(1842),
    [anon_sym_SQUOTE] = ACTIONS(1844),
    [anon_sym_async] = ACTIONS(1844),
    [anon_sym_break] = ACTIONS(1844),
    [anon_sym_const] = ACTIONS(1844),
    [anon_sym_continue] = ACTIONS(1844),
    [anon_sym_default] = ACTIONS(1844),
    [anon_sym_enum] = ACTIONS(1844),
    [anon_sym_fn] = ACTIONS(1844),
    [anon_sym_for] = ACTIONS(1844),
    [anon_sym_if] = ACTIONS(1844),
    [anon_sym_impl] = ACTIONS(1844),
    [anon_sym_let] = ACTIONS(1844),
    [anon_sym_loop] = ACTIONS(1844),
    [anon_sym_match] = ACTIONS(1844),
    [anon_sym_mod] = ACTIONS(1844),
    [anon_sym_pub] = ACTIONS(1844),
    [anon_sym_return] = ACTIONS(1844),
    [anon_sym_static] = ACTIONS(1844),
    [anon_sym_struct] = ACTIONS(1844),
    [anon_sym_trait] = ACTIONS(1844),
    [anon_sym_type] = ACTIONS(1844),
    [anon_sym_union] = ACTIONS(1844),
    [anon_sym_unsafe] = ACTIONS(1844),
    [anon_sym_use] = ACTIONS(1844),
    [anon_sym_while] = ACTIONS(1844),
    [anon_sym_extern] = ACTIONS(1844),
    [anon_sym_yield] = ACTIONS(1844),
    [anon_sym_move] = ACTIONS(1844),
    [anon_sym_try] = ACTIONS(1844),
    [sym_integer_literal] = ACTIONS(1842),
    [aux_sym_string_literal_token1] = ACTIONS(1842),
    [sym_char_literal] = ACTIONS(1842),
    [anon_sym_true] = ACTIONS(1844),
    [anon_sym_false] = ACTIONS(1844),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1844),
    [sym_super] = ACTIONS(1844),
    [sym_crate] = ACTIONS(1844),
    [sym_metavariable] = ACTIONS(1842),
    [sym__raw_string_literal_start] = ACTIONS(1842),
    [sym_float_literal] = ACTIONS(1842),
  },
  [525] = {
    [sym_empty_statement] = STATE(1143),
    [sym_macro_definition] = STATE(1143),
    [sym_attribute_item] = STATE(1143),
    [sym_inner_attribute_item] = STATE(1143),
    [sym_mod_item] = STATE(1143),
    [sym_foreign_mod_item] = STATE(1143),
    [sym_struct_item] = STATE(1143),
    [sym_union_item] = STATE(1143),
    [sym_enum_item] = STATE(1143),
    [sym_extern_crate_declaration] = STATE(1143),
    [sym_const_item] = STATE(1143),
    [sym_static_item] = STATE(1143),
    [sym_type_item] = STATE(1143),
    [sym_function_item] = STATE(1143),
    [sym_function_signature_item] = STATE(1143),
    [sym_function_modifiers] = STATE(3583),
    [sym_impl_item] = STATE(1143),
    [sym_trait_item] = STATE(1143),
    [sym_associated_type] = STATE(1143),
    [sym_let_declaration] = STATE(1143),
    [sym_use_declaration] = STATE(1143),
    [sym_extern_modifier] = STATE(2167),
    [sym_visibility_modifier] = STATE(1927),
    [sym_bracketed_type] = STATE(3307),
    [sym_generic_type_with_turbofish] = STATE(3333),
    [sym_macro_invocation] = STATE(1143),
    [sym_scoped_identifier] = STATE(3206),
    [sym_line_comment] = STATE(525),
    [sym_block_comment] = STATE(525),
    [aux_sym_declaration_list_repeat1] = STATE(659),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(1846),
    [anon_sym_SEMI] = ACTIONS(1848),
    [anon_sym_macro_rules_BANG] = ACTIONS(1850),
    [anon_sym_RBRACE] = ACTIONS(1852),
    [anon_sym_u8] = ACTIONS(1854),
    [anon_sym_i8] = ACTIONS(1854),
    [anon_sym_u16] = ACTIONS(1854),
    [anon_sym_i16] = ACTIONS(1854),
    [anon_sym_u32] = ACTIONS(1854),
    [anon_sym_i32] = ACTIONS(1854),
    [anon_sym_u64] = ACTIONS(1854),
    [anon_sym_i64] = ACTIONS(1854),
    [anon_sym_u128] = ACTIONS(1854),
    [anon_sym_i128] = ACTIONS(1854),
    [anon_sym_isize] = ACTIONS(1854),
    [anon_sym_usize] = ACTIONS(1854),
    [anon_sym_f32] = ACTIONS(1854),
    [anon_sym_f64] = ACTIONS(1854),
    [anon_sym_bool] = ACTIONS(1854),
    [anon_sym_str] = ACTIONS(1854),
    [anon_sym_char] = ACTIONS(1854),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1856),
    [anon_sym_POUND] = ACTIONS(1858),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1860),
    [anon_sym_default] = ACTIONS(1862),
    [anon_sym_enum] = ACTIONS(1864),
    [anon_sym_fn] = ACTIONS(1866),
    [anon_sym_impl] = ACTIONS(1868),
    [anon_sym_let] = ACTIONS(1870),
    [anon_sym_mod] = ACTIONS(1872),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(1874),
    [anon_sym_struct] = ACTIONS(1876),
    [anon_sym_trait] = ACTIONS(1878),
    [anon_sym_type] = ACTIONS(1880),
    [anon_sym_union] = ACTIONS(1882),
    [anon_sym_unsafe] = ACTIONS(1884),
    [anon_sym_use] = ACTIONS(1886),
    [anon_sym_extern] = ACTIONS(1888),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1890),
    [sym_super] = ACTIONS(1890),
    [sym_crate] = ACTIONS(1892),
    [sym_metavariable] = ACTIONS(1894),
  },
  [526] = {
    [sym_line_comment] = STATE(526),
    [sym_block_comment] = STATE(526),
    [ts_builtin_sym_end] = ACTIONS(1896),
    [sym_identifier] = ACTIONS(1898),
    [anon_sym_SEMI] = ACTIONS(1896),
    [anon_sym_macro_rules_BANG] = ACTIONS(1896),
    [anon_sym_LPAREN] = ACTIONS(1896),
    [anon_sym_LBRACK] = ACTIONS(1896),
    [anon_sym_LBRACE] = ACTIONS(1896),
    [anon_sym_RBRACE] = ACTIONS(1896),
    [anon_sym_STAR] = ACTIONS(1896),
    [anon_sym_u8] = ACTIONS(1898),
    [anon_sym_i8] = ACTIONS(1898),
    [anon_sym_u16] = ACTIONS(1898),
    [anon_sym_i16] = ACTIONS(1898),
    [anon_sym_u32] = ACTIONS(1898),
    [anon_sym_i32] = ACTIONS(1898),
    [anon_sym_u64] = ACTIONS(1898),
    [anon_sym_i64] = ACTIONS(1898),
    [anon_sym_u128] = ACTIONS(1898),
    [anon_sym_i128] = ACTIONS(1898),
    [anon_sym_isize] = ACTIONS(1898),
    [anon_sym_usize] = ACTIONS(1898),
    [anon_sym_f32] = ACTIONS(1898),
    [anon_sym_f64] = ACTIONS(1898),
    [anon_sym_bool] = ACTIONS(1898),
    [anon_sym_str] = ACTIONS(1898),
    [anon_sym_char] = ACTIONS(1898),
    [anon_sym_DASH] = ACTIONS(1896),
    [anon_sym_BANG] = ACTIONS(1896),
    [anon_sym_AMP] = ACTIONS(1896),
    [anon_sym_PIPE] = ACTIONS(1896),
    [anon_sym_LT] = ACTIONS(1896),
    [anon_sym_DOT_DOT] = ACTIONS(1896),
    [anon_sym_COLON_COLON] = ACTIONS(1896),
    [anon_sym_POUND] = ACTIONS(1896),
    [anon_sym_SQUOTE] = ACTIONS(1898),
    [anon_sym_async] = ACTIONS(1898),
    [anon_sym_break] = ACTIONS(1898),
    [anon_sym_const] = ACTIONS(1898),
    [anon_sym_continue] = ACTIONS(1898),
    [anon_sym_default] = ACTIONS(1898),
    [anon_sym_enum] = ACTIONS(1898),
    [anon_sym_fn] = ACTIONS(1898),
    [anon_sym_for] = ACTIONS(1898),
    [anon_sym_if] = ACTIONS(1898),
    [anon_sym_impl] = ACTIONS(1898),
    [anon_sym_let] = ACTIONS(1898),
    [anon_sym_loop] = ACTIONS(1898),
    [anon_sym_match] = ACTIONS(1898),
    [anon_sym_mod] = ACTIONS(1898),
    [anon_sym_pub] = ACTIONS(1898),
    [anon_sym_return] = ACTIONS(1898),
    [anon_sym_static] = ACTIONS(1898),
    [anon_sym_struct] = ACTIONS(1898),
    [anon_sym_trait] = ACTIONS(1898),
    [anon_sym_type] = ACTIONS(1898),
    [anon_sym_union] = ACTIONS(1898),
    [anon_sym_unsafe] = ACTIONS(1898),
    [anon_sym_use] = ACTIONS(1898),
    [anon_sym_while] = ACTIONS(1898),
    [anon_sym_extern] = ACTIONS(1898),
    [anon_sym_yield] = ACTIONS(1898),
    [anon_sym_move] = ACTIONS(1898),
    [anon_sym_try] = ACTIONS(1898),
    [sym_integer_literal] = ACTIONS(1896),
    [aux_sym_string_literal_token1] = ACTIONS(1896),
    [sym_char_literal] = ACTIONS(1896),
    [anon_sym_true] = ACTIONS(1898),
    [anon_sym_false] = ACTIONS(1898),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1898),
    [sym_super] = ACTIONS(1898),
    [sym_crate] = ACTIONS(1898),
    [sym_metavariable] = ACTIONS(1896),
    [sym__raw_string_literal_start] = ACTIONS(1896),
    [sym_float_literal] = ACTIONS(1896),
  },
  [527] = {
    [sym_line_comment] = STATE(527),
    [sym_block_comment] = STATE(527),
    [ts_builtin_sym_end] = ACTIONS(1900),
    [sym_identifier] = ACTIONS(1902),
    [anon_sym_SEMI] = ACTIONS(1900),
    [anon_sym_macro_rules_BANG] = ACTIONS(1900),
    [anon_sym_LPAREN] = ACTIONS(1900),
    [anon_sym_LBRACK] = ACTIONS(1900),
    [anon_sym_LBRACE] = ACTIONS(1900),
    [anon_sym_RBRACE] = ACTIONS(1900),
    [anon_sym_STAR] = ACTIONS(1900),
    [anon_sym_u8] = ACTIONS(1902),
    [anon_sym_i8] = ACTIONS(1902),
    [anon_sym_u16] = ACTIONS(1902),
    [anon_sym_i16] = ACTIONS(1902),
    [anon_sym_u32] = ACTIONS(1902),
    [anon_sym_i32] = ACTIONS(1902),
    [anon_sym_u64] = ACTIONS(1902),
    [anon_sym_i64] = ACTIONS(1902),
    [anon_sym_u128] = ACTIONS(1902),
    [anon_sym_i128] = ACTIONS(1902),
    [anon_sym_isize] = ACTIONS(1902),
    [anon_sym_usize] = ACTIONS(1902),
    [anon_sym_f32] = ACTIONS(1902),
    [anon_sym_f64] = ACTIONS(1902),
    [anon_sym_bool] = ACTIONS(1902),
    [anon_sym_str] = ACTIONS(1902),
    [anon_sym_char] = ACTIONS(1902),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_BANG] = ACTIONS(1900),
    [anon_sym_AMP] = ACTIONS(1900),
    [anon_sym_PIPE] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1900),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_COLON_COLON] = ACTIONS(1900),
    [anon_sym_POUND] = ACTIONS(1900),
    [anon_sym_SQUOTE] = ACTIONS(1902),
    [anon_sym_async] = ACTIONS(1902),
    [anon_sym_break] = ACTIONS(1902),
    [anon_sym_const] = ACTIONS(1902),
    [anon_sym_continue] = ACTIONS(1902),
    [anon_sym_default] = ACTIONS(1902),
    [anon_sym_enum] = ACTIONS(1902),
    [anon_sym_fn] = ACTIONS(1902),
    [anon_sym_for] = ACTIONS(1902),
    [anon_sym_if] = ACTIONS(1902),
    [anon_sym_impl] = ACTIONS(1902),
    [anon_sym_let] = ACTIONS(1902),
    [anon_sym_loop] = ACTIONS(1902),
    [anon_sym_match] = ACTIONS(1902),
    [anon_sym_mod] = ACTIONS(1902),
    [anon_sym_pub] = ACTIONS(1902),
    [anon_sym_return] = ACTIONS(1902),
    [anon_sym_static] = ACTIONS(1902),
    [anon_sym_struct] = ACTIONS(1902),
    [anon_sym_trait] = ACTIONS(1902),
    [anon_sym_type] = ACTIONS(1902),
    [anon_sym_union] = ACTIONS(1902),
    [anon_sym_unsafe] = ACTIONS(1902),
    [anon_sym_use] = ACTIONS(1902),
    [anon_sym_while] = ACTIONS(1902),
    [anon_sym_extern] = ACTIONS(1902),
    [anon_sym_yield] = ACTIONS(1902),
    [anon_sym_move] = ACTIONS(1902),
    [anon_sym_try] = ACTIONS(1902),
    [sym_integer_literal] = ACTIONS(1900),
    [aux_sym_string_literal_token1] = ACTIONS(1900),
    [sym_char_literal] = ACTIONS(1900),
    [anon_sym_true] = ACTIONS(1902),
    [anon_sym_false] = ACTIONS(1902),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1902),
    [sym_super] = ACTIONS(1902),
    [sym_crate] = ACTIONS(1902),
    [sym_metavariable] = ACTIONS(1900),
    [sym__raw_string_literal_start] = ACTIONS(1900),
    [sym_float_literal] = ACTIONS(1900),
  },
  [528] = {
    [sym_line_comment] = STATE(528),
    [sym_block_comment] = STATE(528),
    [ts_builtin_sym_end] = ACTIONS(1904),
    [sym_identifier] = ACTIONS(1906),
    [anon_sym_SEMI] = ACTIONS(1904),
    [anon_sym_macro_rules_BANG] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1904),
    [anon_sym_LBRACK] = ACTIONS(1904),
    [anon_sym_LBRACE] = ACTIONS(1904),
    [anon_sym_RBRACE] = ACTIONS(1904),
    [anon_sym_STAR] = ACTIONS(1904),
    [anon_sym_u8] = ACTIONS(1906),
    [anon_sym_i8] = ACTIONS(1906),
    [anon_sym_u16] = ACTIONS(1906),
    [anon_sym_i16] = ACTIONS(1906),
    [anon_sym_u32] = ACTIONS(1906),
    [anon_sym_i32] = ACTIONS(1906),
    [anon_sym_u64] = ACTIONS(1906),
    [anon_sym_i64] = ACTIONS(1906),
    [anon_sym_u128] = ACTIONS(1906),
    [anon_sym_i128] = ACTIONS(1906),
    [anon_sym_isize] = ACTIONS(1906),
    [anon_sym_usize] = ACTIONS(1906),
    [anon_sym_f32] = ACTIONS(1906),
    [anon_sym_f64] = ACTIONS(1906),
    [anon_sym_bool] = ACTIONS(1906),
    [anon_sym_str] = ACTIONS(1906),
    [anon_sym_char] = ACTIONS(1906),
    [anon_sym_DASH] = ACTIONS(1904),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_AMP] = ACTIONS(1904),
    [anon_sym_PIPE] = ACTIONS(1904),
    [anon_sym_LT] = ACTIONS(1904),
    [anon_sym_DOT_DOT] = ACTIONS(1904),
    [anon_sym_COLON_COLON] = ACTIONS(1904),
    [anon_sym_POUND] = ACTIONS(1904),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [anon_sym_async] = ACTIONS(1906),
    [anon_sym_break] = ACTIONS(1906),
    [anon_sym_const] = ACTIONS(1906),
    [anon_sym_continue] = ACTIONS(1906),
    [anon_sym_default] = ACTIONS(1906),
    [anon_sym_enum] = ACTIONS(1906),
    [anon_sym_fn] = ACTIONS(1906),
    [anon_sym_for] = ACTIONS(1906),
    [anon_sym_if] = ACTIONS(1906),
    [anon_sym_impl] = ACTIONS(1906),
    [anon_sym_let] = ACTIONS(1906),
    [anon_sym_loop] = ACTIONS(1906),
    [anon_sym_match] = ACTIONS(1906),
    [anon_sym_mod] = ACTIONS(1906),
    [anon_sym_pub] = ACTIONS(1906),
    [anon_sym_return] = ACTIONS(1906),
    [anon_sym_static] = ACTIONS(1906),
    [anon_sym_struct] = ACTIONS(1906),
    [anon_sym_trait] = ACTIONS(1906),
    [anon_sym_type] = ACTIONS(1906),
    [anon_sym_union] = ACTIONS(1906),
    [anon_sym_unsafe] = ACTIONS(1906),
    [anon_sym_use] = ACTIONS(1906),
    [anon_sym_while] = ACTIONS(1906),
    [anon_sym_extern] = ACTIONS(1906),
    [anon_sym_yield] = ACTIONS(1906),
    [anon_sym_move] = ACTIONS(1906),
    [anon_sym_try] = ACTIONS(1906),
    [sym_integer_literal] = ACTIONS(1904),
    [aux_sym_string_literal_token1] = ACTIONS(1904),
    [sym_char_literal] = ACTIONS(1904),
    [anon_sym_true] = ACTIONS(1906),
    [anon_sym_false] = ACTIONS(1906),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1906),
    [sym_super] = ACTIONS(1906),
    [sym_crate] = ACTIONS(1906),
    [sym_metavariable] = ACTIONS(1904),
    [sym__raw_string_literal_start] = ACTIONS(1904),
    [sym_float_literal] = ACTIONS(1904),
  },
  [529] = {
    [sym_line_comment] = STATE(529),
    [sym_block_comment] = STATE(529),
    [ts_builtin_sym_end] = ACTIONS(1908),
    [sym_identifier] = ACTIONS(1910),
    [anon_sym_SEMI] = ACTIONS(1908),
    [anon_sym_macro_rules_BANG] = ACTIONS(1908),
    [anon_sym_LPAREN] = ACTIONS(1908),
    [anon_sym_LBRACK] = ACTIONS(1908),
    [anon_sym_LBRACE] = ACTIONS(1908),
    [anon_sym_RBRACE] = ACTIONS(1908),
    [anon_sym_STAR] = ACTIONS(1908),
    [anon_sym_u8] = ACTIONS(1910),
    [anon_sym_i8] = ACTIONS(1910),
    [anon_sym_u16] = ACTIONS(1910),
    [anon_sym_i16] = ACTIONS(1910),
    [anon_sym_u32] = ACTIONS(1910),
    [anon_sym_i32] = ACTIONS(1910),
    [anon_sym_u64] = ACTIONS(1910),
    [anon_sym_i64] = ACTIONS(1910),
    [anon_sym_u128] = ACTIONS(1910),
    [anon_sym_i128] = ACTIONS(1910),
    [anon_sym_isize] = ACTIONS(1910),
    [anon_sym_usize] = ACTIONS(1910),
    [anon_sym_f32] = ACTIONS(1910),
    [anon_sym_f64] = ACTIONS(1910),
    [anon_sym_bool] = ACTIONS(1910),
    [anon_sym_str] = ACTIONS(1910),
    [anon_sym_char] = ACTIONS(1910),
    [anon_sym_DASH] = ACTIONS(1908),
    [anon_sym_BANG] = ACTIONS(1908),
    [anon_sym_AMP] = ACTIONS(1908),
    [anon_sym_PIPE] = ACTIONS(1908),
    [anon_sym_LT] = ACTIONS(1908),
    [anon_sym_DOT_DOT] = ACTIONS(1908),
    [anon_sym_COLON_COLON] = ACTIONS(1908),
    [anon_sym_POUND] = ACTIONS(1908),
    [anon_sym_SQUOTE] = ACTIONS(1910),
    [anon_sym_async] = ACTIONS(1910),
    [anon_sym_break] = ACTIONS(1910),
    [anon_sym_const] = ACTIONS(1910),
    [anon_sym_continue] = ACTIONS(1910),
    [anon_sym_default] = ACTIONS(1910),
    [anon_sym_enum] = ACTIONS(1910),
    [anon_sym_fn] = ACTIONS(1910),
    [anon_sym_for] = ACTIONS(1910),
    [anon_sym_if] = ACTIONS(1910),
    [anon_sym_impl] = ACTIONS(1910),
    [anon_sym_let] = ACTIONS(1910),
    [anon_sym_loop] = ACTIONS(1910),
    [anon_sym_match] = ACTIONS(1910),
    [anon_sym_mod] = ACTIONS(1910),
    [anon_sym_pub] = ACTIONS(1910),
    [anon_sym_return] = ACTIONS(1910),
    [anon_sym_static] = ACTIONS(1910),
    [anon_sym_struct] = ACTIONS(1910),
    [anon_sym_trait] = ACTIONS(1910),
    [anon_sym_type] = ACTIONS(1910),
    [anon_sym_union] = ACTIONS(1910),
    [anon_sym_unsafe] = ACTIONS(1910),
    [anon_sym_use] = ACTIONS(1910),
    [anon_sym_while] = ACTIONS(1910),
    [anon_sym_extern] = ACTIONS(1910),
    [anon_sym_yield] = ACTIONS(1910),
    [anon_sym_move] = ACTIONS(1910),
    [anon_sym_try] = ACTIONS(1910),
    [sym_integer_literal] = ACTIONS(1908),
    [aux_sym_string_literal_token1] = ACTIONS(1908),
    [sym_char_literal] = ACTIONS(1908),
    [anon_sym_true] = ACTIONS(1910),
    [anon_sym_false] = ACTIONS(1910),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1910),
    [sym_super] = ACTIONS(1910),
    [sym_crate] = ACTIONS(1910),
    [sym_metavariable] = ACTIONS(1908),
    [sym__raw_string_literal_start] = ACTIONS(1908),
    [sym_float_literal] = ACTIONS(1908),
  },
  [530] = {
    [sym_line_comment] = STATE(530),
    [sym_block_comment] = STATE(530),
    [ts_builtin_sym_end] = ACTIONS(1912),
    [sym_identifier] = ACTIONS(1914),
    [anon_sym_SEMI] = ACTIONS(1912),
    [anon_sym_macro_rules_BANG] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1912),
    [anon_sym_LBRACK] = ACTIONS(1912),
    [anon_sym_LBRACE] = ACTIONS(1912),
    [anon_sym_RBRACE] = ACTIONS(1912),
    [anon_sym_STAR] = ACTIONS(1912),
    [anon_sym_u8] = ACTIONS(1914),
    [anon_sym_i8] = ACTIONS(1914),
    [anon_sym_u16] = ACTIONS(1914),
    [anon_sym_i16] = ACTIONS(1914),
    [anon_sym_u32] = ACTIONS(1914),
    [anon_sym_i32] = ACTIONS(1914),
    [anon_sym_u64] = ACTIONS(1914),
    [anon_sym_i64] = ACTIONS(1914),
    [anon_sym_u128] = ACTIONS(1914),
    [anon_sym_i128] = ACTIONS(1914),
    [anon_sym_isize] = ACTIONS(1914),
    [anon_sym_usize] = ACTIONS(1914),
    [anon_sym_f32] = ACTIONS(1914),
    [anon_sym_f64] = ACTIONS(1914),
    [anon_sym_bool] = ACTIONS(1914),
    [anon_sym_str] = ACTIONS(1914),
    [anon_sym_char] = ACTIONS(1914),
    [anon_sym_DASH] = ACTIONS(1912),
    [anon_sym_BANG] = ACTIONS(1912),
    [anon_sym_AMP] = ACTIONS(1912),
    [anon_sym_PIPE] = ACTIONS(1912),
    [anon_sym_LT] = ACTIONS(1912),
    [anon_sym_DOT_DOT] = ACTIONS(1912),
    [anon_sym_COLON_COLON] = ACTIONS(1912),
    [anon_sym_POUND] = ACTIONS(1912),
    [anon_sym_SQUOTE] = ACTIONS(1914),
    [anon_sym_async] = ACTIONS(1914),
    [anon_sym_break] = ACTIONS(1914),
    [anon_sym_const] = ACTIONS(1914),
    [anon_sym_continue] = ACTIONS(1914),
    [anon_sym_default] = ACTIONS(1914),
    [anon_sym_enum] = ACTIONS(1914),
    [anon_sym_fn] = ACTIONS(1914),
    [anon_sym_for] = ACTIONS(1914),
    [anon_sym_if] = ACTIONS(1914),
    [anon_sym_impl] = ACTIONS(1914),
    [anon_sym_let] = ACTIONS(1914),
    [anon_sym_loop] = ACTIONS(1914),
    [anon_sym_match] = ACTIONS(1914),
    [anon_sym_mod] = ACTIONS(1914),
    [anon_sym_pub] = ACTIONS(1914),
    [anon_sym_return] = ACTIONS(1914),
    [anon_sym_static] = ACTIONS(1914),
    [anon_sym_struct] = ACTIONS(1914),
    [anon_sym_trait] = ACTIONS(1914),
    [anon_sym_type] = ACTIONS(1914),
    [anon_sym_union] = ACTIONS(1914),
    [anon_sym_unsafe] = ACTIONS(1914),
    [anon_sym_use] = ACTIONS(1914),
    [anon_sym_while] = ACTIONS(1914),
    [anon_sym_extern] = ACTIONS(1914),
    [anon_sym_yield] = ACTIONS(1914),
    [anon_sym_move] = ACTIONS(1914),
    [anon_sym_try] = ACTIONS(1914),
    [sym_integer_literal] = ACTIONS(1912),
    [aux_sym_string_literal_token1] = ACTIONS(1912),
    [sym_char_literal] = ACTIONS(1912),
    [anon_sym_true] = ACTIONS(1914),
    [anon_sym_false] = ACTIONS(1914),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1914),
    [sym_super] = ACTIONS(1914),
    [sym_crate] = ACTIONS(1914),
    [sym_metavariable] = ACTIONS(1912),
    [sym__raw_string_literal_start] = ACTIONS(1912),
    [sym_float_literal] = ACTIONS(1912),
  },
  [531] = {
    [sym_line_comment] = STATE(531),
    [sym_block_comment] = STATE(531),
    [ts_builtin_sym_end] = ACTIONS(1916),
    [sym_identifier] = ACTIONS(1918),
    [anon_sym_SEMI] = ACTIONS(1916),
    [anon_sym_macro_rules_BANG] = ACTIONS(1916),
    [anon_sym_LPAREN] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1916),
    [anon_sym_LBRACE] = ACTIONS(1916),
    [anon_sym_RBRACE] = ACTIONS(1916),
    [anon_sym_STAR] = ACTIONS(1916),
    [anon_sym_u8] = ACTIONS(1918),
    [anon_sym_i8] = ACTIONS(1918),
    [anon_sym_u16] = ACTIONS(1918),
    [anon_sym_i16] = ACTIONS(1918),
    [anon_sym_u32] = ACTIONS(1918),
    [anon_sym_i32] = ACTIONS(1918),
    [anon_sym_u64] = ACTIONS(1918),
    [anon_sym_i64] = ACTIONS(1918),
    [anon_sym_u128] = ACTIONS(1918),
    [anon_sym_i128] = ACTIONS(1918),
    [anon_sym_isize] = ACTIONS(1918),
    [anon_sym_usize] = ACTIONS(1918),
    [anon_sym_f32] = ACTIONS(1918),
    [anon_sym_f64] = ACTIONS(1918),
    [anon_sym_bool] = ACTIONS(1918),
    [anon_sym_str] = ACTIONS(1918),
    [anon_sym_char] = ACTIONS(1918),
    [anon_sym_DASH] = ACTIONS(1916),
    [anon_sym_BANG] = ACTIONS(1916),
    [anon_sym_AMP] = ACTIONS(1916),
    [anon_sym_PIPE] = ACTIONS(1916),
    [anon_sym_LT] = ACTIONS(1916),
    [anon_sym_DOT_DOT] = ACTIONS(1916),
    [anon_sym_COLON_COLON] = ACTIONS(1916),
    [anon_sym_POUND] = ACTIONS(1916),
    [anon_sym_SQUOTE] = ACTIONS(1918),
    [anon_sym_async] = ACTIONS(1918),
    [anon_sym_break] = ACTIONS(1918),
    [anon_sym_const] = ACTIONS(1918),
    [anon_sym_continue] = ACTIONS(1918),
    [anon_sym_default] = ACTIONS(1918),
    [anon_sym_enum] = ACTIONS(1918),
    [anon_sym_fn] = ACTIONS(1918),
    [anon_sym_for] = ACTIONS(1918),
    [anon_sym_if] = ACTIONS(1918),
    [anon_sym_impl] = ACTIONS(1918),
    [anon_sym_let] = ACTIONS(1918),
    [anon_sym_loop] = ACTIONS(1918),
    [anon_sym_match] = ACTIONS(1918),
    [anon_sym_mod] = ACTIONS(1918),
    [anon_sym_pub] = ACTIONS(1918),
    [anon_sym_return] = ACTIONS(1918),
    [anon_sym_static] = ACTIONS(1918),
    [anon_sym_struct] = ACTIONS(1918),
    [anon_sym_trait] = ACTIONS(1918),
    [anon_sym_type] = ACTIONS(1918),
    [anon_sym_union] = ACTIONS(1918),
    [anon_sym_unsafe] = ACTIONS(1918),
    [anon_sym_use] = ACTIONS(1918),
    [anon_sym_while] = ACTIONS(1918),
    [anon_sym_extern] = ACTIONS(1918),
    [anon_sym_yield] = ACTIONS(1918),
    [anon_sym_move] = ACTIONS(1918),
    [anon_sym_try] = ACTIONS(1918),
    [sym_integer_literal] = ACTIONS(1916),
    [aux_sym_string_literal_token1] = ACTIONS(1916),
    [sym_char_literal] = ACTIONS(1916),
    [anon_sym_true] = ACTIONS(1918),
    [anon_sym_false] = ACTIONS(1918),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1918),
    [sym_super] = ACTIONS(1918),
    [sym_crate] = ACTIONS(1918),
    [sym_metavariable] = ACTIONS(1916),
    [sym__raw_string_literal_start] = ACTIONS(1916),
    [sym_float_literal] = ACTIONS(1916),
  },
  [532] = {
    [sym_line_comment] = STATE(532),
    [sym_block_comment] = STATE(532),
    [ts_builtin_sym_end] = ACTIONS(1920),
    [sym_identifier] = ACTIONS(1922),
    [anon_sym_SEMI] = ACTIONS(1920),
    [anon_sym_macro_rules_BANG] = ACTIONS(1920),
    [anon_sym_LPAREN] = ACTIONS(1920),
    [anon_sym_LBRACK] = ACTIONS(1920),
    [anon_sym_LBRACE] = ACTIONS(1920),
    [anon_sym_RBRACE] = ACTIONS(1920),
    [anon_sym_STAR] = ACTIONS(1920),
    [anon_sym_u8] = ACTIONS(1922),
    [anon_sym_i8] = ACTIONS(1922),
    [anon_sym_u16] = ACTIONS(1922),
    [anon_sym_i16] = ACTIONS(1922),
    [anon_sym_u32] = ACTIONS(1922),
    [anon_sym_i32] = ACTIONS(1922),
    [anon_sym_u64] = ACTIONS(1922),
    [anon_sym_i64] = ACTIONS(1922),
    [anon_sym_u128] = ACTIONS(1922),
    [anon_sym_i128] = ACTIONS(1922),
    [anon_sym_isize] = ACTIONS(1922),
    [anon_sym_usize] = ACTIONS(1922),
    [anon_sym_f32] = ACTIONS(1922),
    [anon_sym_f64] = ACTIONS(1922),
    [anon_sym_bool] = ACTIONS(1922),
    [anon_sym_str] = ACTIONS(1922),
    [anon_sym_char] = ACTIONS(1922),
    [anon_sym_DASH] = ACTIONS(1920),
    [anon_sym_BANG] = ACTIONS(1920),
    [anon_sym_AMP] = ACTIONS(1920),
    [anon_sym_PIPE] = ACTIONS(1920),
    [anon_sym_LT] = ACTIONS(1920),
    [anon_sym_DOT_DOT] = ACTIONS(1920),
    [anon_sym_COLON_COLON] = ACTIONS(1920),
    [anon_sym_POUND] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_async] = ACTIONS(1922),
    [anon_sym_break] = ACTIONS(1922),
    [anon_sym_const] = ACTIONS(1922),
    [anon_sym_continue] = ACTIONS(1922),
    [anon_sym_default] = ACTIONS(1922),
    [anon_sym_enum] = ACTIONS(1922),
    [anon_sym_fn] = ACTIONS(1922),
    [anon_sym_for] = ACTIONS(1922),
    [anon_sym_if] = ACTIONS(1922),
    [anon_sym_impl] = ACTIONS(1922),
    [anon_sym_let] = ACTIONS(1922),
    [anon_sym_loop] = ACTIONS(1922),
    [anon_sym_match] = ACTIONS(1922),
    [anon_sym_mod] = ACTIONS(1922),
    [anon_sym_pub] = ACTIONS(1922),
    [anon_sym_return] = ACTIONS(1922),
    [anon_sym_static] = ACTIONS(1922),
    [anon_sym_struct] = ACTIONS(1922),
    [anon_sym_trait] = ACTIONS(1922),
    [anon_sym_type] = ACTIONS(1922),
    [anon_sym_union] = ACTIONS(1922),
    [anon_sym_unsafe] = ACTIONS(1922),
    [anon_sym_use] = ACTIONS(1922),
    [anon_sym_while] = ACTIONS(1922),
    [anon_sym_extern] = ACTIONS(1922),
    [anon_sym_yield] = ACTIONS(1922),
    [anon_sym_move] = ACTIONS(1922),
    [anon_sym_try] = ACTIONS(1922),
    [sym_integer_literal] = ACTIONS(1920),
    [aux_sym_string_literal_token1] = ACTIONS(1920),
    [sym_char_literal] = ACTIONS(1920),
    [anon_sym_true] = ACTIONS(1922),
    [anon_sym_false] = ACTIONS(1922),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1922),
    [sym_super] = ACTIONS(1922),
    [sym_crate] = ACTIONS(1922),
    [sym_metavariable] = ACTIONS(1920),
    [sym__raw_string_literal_start] = ACTIONS(1920),
    [sym_float_literal] = ACTIONS(1920),
  },
  [533] = {
    [sym_line_comment] = STATE(533),
    [sym_block_comment] = STATE(533),
    [ts_builtin_sym_end] = ACTIONS(1924),
    [sym_identifier] = ACTIONS(1926),
    [anon_sym_SEMI] = ACTIONS(1924),
    [anon_sym_macro_rules_BANG] = ACTIONS(1924),
    [anon_sym_LPAREN] = ACTIONS(1924),
    [anon_sym_LBRACK] = ACTIONS(1924),
    [anon_sym_LBRACE] = ACTIONS(1924),
    [anon_sym_RBRACE] = ACTIONS(1924),
    [anon_sym_STAR] = ACTIONS(1924),
    [anon_sym_u8] = ACTIONS(1926),
    [anon_sym_i8] = ACTIONS(1926),
    [anon_sym_u16] = ACTIONS(1926),
    [anon_sym_i16] = ACTIONS(1926),
    [anon_sym_u32] = ACTIONS(1926),
    [anon_sym_i32] = ACTIONS(1926),
    [anon_sym_u64] = ACTIONS(1926),
    [anon_sym_i64] = ACTIONS(1926),
    [anon_sym_u128] = ACTIONS(1926),
    [anon_sym_i128] = ACTIONS(1926),
    [anon_sym_isize] = ACTIONS(1926),
    [anon_sym_usize] = ACTIONS(1926),
    [anon_sym_f32] = ACTIONS(1926),
    [anon_sym_f64] = ACTIONS(1926),
    [anon_sym_bool] = ACTIONS(1926),
    [anon_sym_str] = ACTIONS(1926),
    [anon_sym_char] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1924),
    [anon_sym_BANG] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1924),
    [anon_sym_PIPE] = ACTIONS(1924),
    [anon_sym_LT] = ACTIONS(1924),
    [anon_sym_DOT_DOT] = ACTIONS(1924),
    [anon_sym_COLON_COLON] = ACTIONS(1924),
    [anon_sym_POUND] = ACTIONS(1924),
    [anon_sym_SQUOTE] = ACTIONS(1926),
    [anon_sym_async] = ACTIONS(1926),
    [anon_sym_break] = ACTIONS(1926),
    [anon_sym_const] = ACTIONS(1926),
    [anon_sym_continue] = ACTIONS(1926),
    [anon_sym_default] = ACTIONS(1926),
    [anon_sym_enum] = ACTIONS(1926),
    [anon_sym_fn] = ACTIONS(1926),
    [anon_sym_for] = ACTIONS(1926),
    [anon_sym_if] = ACTIONS(1926),
    [anon_sym_impl] = ACTIONS(1926),
    [anon_sym_let] = ACTIONS(1926),
    [anon_sym_loop] = ACTIONS(1926),
    [anon_sym_match] = ACTIONS(1926),
    [anon_sym_mod] = ACTIONS(1926),
    [anon_sym_pub] = ACTIONS(1926),
    [anon_sym_return] = ACTIONS(1926),
    [anon_sym_static] = ACTIONS(1926),
    [anon_sym_struct] = ACTIONS(1926),
    [anon_sym_trait] = ACTIONS(1926),
    [anon_sym_type] = ACTIONS(1926),
    [anon_sym_union] = ACTIONS(1926),
    [anon_sym_unsafe] = ACTIONS(1926),
    [anon_sym_use] = ACTIONS(1926),
    [anon_sym_while] = ACTIONS(1926),
    [anon_sym_extern] = ACTIONS(1926),
    [anon_sym_yield] = ACTIONS(1926),
    [anon_sym_move] = ACTIONS(1926),
    [anon_sym_try] = ACTIONS(1926),
    [sym_integer_literal] = ACTIONS(1924),
    [aux_sym_string_literal_token1] = ACTIONS(1924),
    [sym_char_literal] = ACTIONS(1924),
    [anon_sym_true] = ACTIONS(1926),
    [anon_sym_false] = ACTIONS(1926),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1926),
    [sym_super] = ACTIONS(1926),
    [sym_crate] = ACTIONS(1926),
    [sym_metavariable] = ACTIONS(1924),
    [sym__raw_string_literal_start] = ACTIONS(1924),
    [sym_float_literal] = ACTIONS(1924),
  },
  [534] = {
    [sym_line_comment] = STATE(534),
    [sym_block_comment] = STATE(534),
    [ts_builtin_sym_end] = ACTIONS(1928),
    [sym_identifier] = ACTIONS(1930),
    [anon_sym_SEMI] = ACTIONS(1928),
    [anon_sym_macro_rules_BANG] = ACTIONS(1928),
    [anon_sym_LPAREN] = ACTIONS(1928),
    [anon_sym_LBRACK] = ACTIONS(1928),
    [anon_sym_LBRACE] = ACTIONS(1928),
    [anon_sym_RBRACE] = ACTIONS(1928),
    [anon_sym_STAR] = ACTIONS(1928),
    [anon_sym_u8] = ACTIONS(1930),
    [anon_sym_i8] = ACTIONS(1930),
    [anon_sym_u16] = ACTIONS(1930),
    [anon_sym_i16] = ACTIONS(1930),
    [anon_sym_u32] = ACTIONS(1930),
    [anon_sym_i32] = ACTIONS(1930),
    [anon_sym_u64] = ACTIONS(1930),
    [anon_sym_i64] = ACTIONS(1930),
    [anon_sym_u128] = ACTIONS(1930),
    [anon_sym_i128] = ACTIONS(1930),
    [anon_sym_isize] = ACTIONS(1930),
    [anon_sym_usize] = ACTIONS(1930),
    [anon_sym_f32] = ACTIONS(1930),
    [anon_sym_f64] = ACTIONS(1930),
    [anon_sym_bool] = ACTIONS(1930),
    [anon_sym_str] = ACTIONS(1930),
    [anon_sym_char] = ACTIONS(1930),
    [anon_sym_DASH] = ACTIONS(1928),
    [anon_sym_BANG] = ACTIONS(1928),
    [anon_sym_AMP] = ACTIONS(1928),
    [anon_sym_PIPE] = ACTIONS(1928),
    [anon_sym_LT] = ACTIONS(1928),
    [anon_sym_DOT_DOT] = ACTIONS(1928),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_POUND] = ACTIONS(1928),
    [anon_sym_SQUOTE] = ACTIONS(1930),
    [anon_sym_async] = ACTIONS(1930),
    [anon_sym_break] = ACTIONS(1930),
    [anon_sym_const] = ACTIONS(1930),
    [anon_sym_continue] = ACTIONS(1930),
    [anon_sym_default] = ACTIONS(1930),
    [anon_sym_enum] = ACTIONS(1930),
    [anon_sym_fn] = ACTIONS(1930),
    [anon_sym_for] = ACTIONS(1930),
    [anon_sym_if] = ACTIONS(1930),
    [anon_sym_impl] = ACTIONS(1930),
    [anon_sym_let] = ACTIONS(1930),
    [anon_sym_loop] = ACTIONS(1930),
    [anon_sym_match] = ACTIONS(1930),
    [anon_sym_mod] = ACTIONS(1930),
    [anon_sym_pub] = ACTIONS(1930),
    [anon_sym_return] = ACTIONS(1930),
    [anon_sym_static] = ACTIONS(1930),
    [anon_sym_struct] = ACTIONS(1930),
    [anon_sym_trait] = ACTIONS(1930),
    [anon_sym_type] = ACTIONS(1930),
    [anon_sym_union] = ACTIONS(1930),
    [anon_sym_unsafe] = ACTIONS(1930),
    [anon_sym_use] = ACTIONS(1930),
    [anon_sym_while] = ACTIONS(1930),
    [anon_sym_extern] = ACTIONS(1930),
    [anon_sym_yield] = ACTIONS(1930),
    [anon_sym_move] = ACTIONS(1930),
    [anon_sym_try] = ACTIONS(1930),
    [sym_integer_literal] = ACTIONS(1928),
    [aux_sym_string_literal_token1] = ACTIONS(1928),
    [sym_char_literal] = ACTIONS(1928),
    [anon_sym_true] = ACTIONS(1930),
    [anon_sym_false] = ACTIONS(1930),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1930),
    [sym_super] = ACTIONS(1930),
    [sym_crate] = ACTIONS(1930),
    [sym_metavariable] = ACTIONS(1928),
    [sym__raw_string_literal_start] = ACTIONS(1928),
    [sym_float_literal] = ACTIONS(1928),
  },
  [535] = {
    [sym_line_comment] = STATE(535),
    [sym_block_comment] = STATE(535),
    [ts_builtin_sym_end] = ACTIONS(1932),
    [sym_identifier] = ACTIONS(1934),
    [anon_sym_SEMI] = ACTIONS(1932),
    [anon_sym_macro_rules_BANG] = ACTIONS(1932),
    [anon_sym_LPAREN] = ACTIONS(1932),
    [anon_sym_LBRACK] = ACTIONS(1932),
    [anon_sym_LBRACE] = ACTIONS(1932),
    [anon_sym_RBRACE] = ACTIONS(1932),
    [anon_sym_STAR] = ACTIONS(1932),
    [anon_sym_u8] = ACTIONS(1934),
    [anon_sym_i8] = ACTIONS(1934),
    [anon_sym_u16] = ACTIONS(1934),
    [anon_sym_i16] = ACTIONS(1934),
    [anon_sym_u32] = ACTIONS(1934),
    [anon_sym_i32] = ACTIONS(1934),
    [anon_sym_u64] = ACTIONS(1934),
    [anon_sym_i64] = ACTIONS(1934),
    [anon_sym_u128] = ACTIONS(1934),
    [anon_sym_i128] = ACTIONS(1934),
    [anon_sym_isize] = ACTIONS(1934),
    [anon_sym_usize] = ACTIONS(1934),
    [anon_sym_f32] = ACTIONS(1934),
    [anon_sym_f64] = ACTIONS(1934),
    [anon_sym_bool] = ACTIONS(1934),
    [anon_sym_str] = ACTIONS(1934),
    [anon_sym_char] = ACTIONS(1934),
    [anon_sym_DASH] = ACTIONS(1932),
    [anon_sym_BANG] = ACTIONS(1932),
    [anon_sym_AMP] = ACTIONS(1932),
    [anon_sym_PIPE] = ACTIONS(1932),
    [anon_sym_LT] = ACTIONS(1932),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_COLON_COLON] = ACTIONS(1932),
    [anon_sym_POUND] = ACTIONS(1932),
    [anon_sym_SQUOTE] = ACTIONS(1934),
    [anon_sym_async] = ACTIONS(1934),
    [anon_sym_break] = ACTIONS(1934),
    [anon_sym_const] = ACTIONS(1934),
    [anon_sym_continue] = ACTIONS(1934),
    [anon_sym_default] = ACTIONS(1934),
    [anon_sym_enum] = ACTIONS(1934),
    [anon_sym_fn] = ACTIONS(1934),
    [anon_sym_for] = ACTIONS(1934),
    [anon_sym_if] = ACTIONS(1934),
    [anon_sym_impl] = ACTIONS(1934),
    [anon_sym_let] = ACTIONS(1934),
    [anon_sym_loop] = ACTIONS(1934),
    [anon_sym_match] = ACTIONS(1934),
    [anon_sym_mod] = ACTIONS(1934),
    [anon_sym_pub] = ACTIONS(1934),
    [anon_sym_return] = ACTIONS(1934),
    [anon_sym_static] = ACTIONS(1934),
    [anon_sym_struct] = ACTIONS(1934),
    [anon_sym_trait] = ACTIONS(1934),
    [anon_sym_type] = ACTIONS(1934),
    [anon_sym_union] = ACTIONS(1934),
    [anon_sym_unsafe] = ACTIONS(1934),
    [anon_sym_use] = ACTIONS(1934),
    [anon_sym_while] = ACTIONS(1934),
    [anon_sym_extern] = ACTIONS(1934),
    [anon_sym_yield] = ACTIONS(1934),
    [anon_sym_move] = ACTIONS(1934),
    [anon_sym_try] = ACTIONS(1934),
    [sym_integer_literal] = ACTIONS(1932),
    [aux_sym_string_literal_token1] = ACTIONS(1932),
    [sym_char_literal] = ACTIONS(1932),
    [anon_sym_true] = ACTIONS(1934),
    [anon_sym_false] = ACTIONS(1934),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1934),
    [sym_super] = ACTIONS(1934),
    [sym_crate] = ACTIONS(1934),
    [sym_metavariable] = ACTIONS(1932),
    [sym__raw_string_literal_start] = ACTIONS(1932),
    [sym_float_literal] = ACTIONS(1932),
  },
  [536] = {
    [sym_attribute_item] = STATE(1471),
    [sym_inner_attribute_item] = STATE(1471),
    [sym_bracketed_type] = STATE(3513),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3115),
    [sym_macro_invocation] = STATE(2834),
    [sym_scoped_identifier] = STATE(2137),
    [sym_scoped_type_identifier] = STATE(2851),
    [sym_match_arm] = STATE(1473),
    [sym_match_pattern] = STATE(3533),
    [sym_const_block] = STATE(2834),
    [sym__pattern] = STATE(2828),
    [sym_tuple_pattern] = STATE(2834),
    [sym_slice_pattern] = STATE(2834),
    [sym_tuple_struct_pattern] = STATE(2834),
    [sym_struct_pattern] = STATE(2834),
    [sym_remaining_field_pattern] = STATE(2834),
    [sym_mut_pattern] = STATE(2834),
    [sym_range_pattern] = STATE(2834),
    [sym_ref_pattern] = STATE(2834),
    [sym_captured_pattern] = STATE(2834),
    [sym_reference_pattern] = STATE(2834),
    [sym_or_pattern] = STATE(2834),
    [sym__literal_pattern] = STATE(2336),
    [sym_negative_literal] = STATE(2345),
    [sym_string_literal] = STATE(2345),
    [sym_raw_string_literal] = STATE(2345),
    [sym_boolean_literal] = STATE(2345),
    [sym_line_comment] = STATE(536),
    [sym_block_comment] = STATE(536),
    [aux_sym_match_block_repeat1] = STATE(536),
    [aux_sym_match_arm_repeat1] = STATE(756),
    [sym_identifier] = ACTIONS(1936),
    [anon_sym_LPAREN] = ACTIONS(1939),
    [anon_sym_LBRACK] = ACTIONS(1942),
    [anon_sym_u8] = ACTIONS(1945),
    [anon_sym_i8] = ACTIONS(1945),
    [anon_sym_u16] = ACTIONS(1945),
    [anon_sym_i16] = ACTIONS(1945),
    [anon_sym_u32] = ACTIONS(1945),
    [anon_sym_i32] = ACTIONS(1945),
    [anon_sym_u64] = ACTIONS(1945),
    [anon_sym_i64] = ACTIONS(1945),
    [anon_sym_u128] = ACTIONS(1945),
    [anon_sym_i128] = ACTIONS(1945),
    [anon_sym_isize] = ACTIONS(1945),
    [anon_sym_usize] = ACTIONS(1945),
    [anon_sym_f32] = ACTIONS(1945),
    [anon_sym_f64] = ACTIONS(1945),
    [anon_sym_bool] = ACTIONS(1945),
    [anon_sym_str] = ACTIONS(1945),
    [anon_sym_char] = ACTIONS(1945),
    [anon_sym_DASH] = ACTIONS(1948),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_PIPE] = ACTIONS(1954),
    [anon_sym_LT] = ACTIONS(1957),
    [anon_sym__] = ACTIONS(1960),
    [anon_sym_DOT_DOT] = ACTIONS(1963),
    [anon_sym_COLON_COLON] = ACTIONS(1966),
    [anon_sym_POUND] = ACTIONS(1969),
    [anon_sym_const] = ACTIONS(1972),
    [anon_sym_default] = ACTIONS(1975),
    [anon_sym_union] = ACTIONS(1975),
    [anon_sym_ref] = ACTIONS(1978),
    [sym_mutable_specifier] = ACTIONS(1981),
    [sym_integer_literal] = ACTIONS(1984),
    [aux_sym_string_literal_token1] = ACTIONS(1987),
    [sym_char_literal] = ACTIONS(1984),
    [anon_sym_true] = ACTIONS(1990),
    [anon_sym_false] = ACTIONS(1990),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1993),
    [sym_super] = ACTIONS(1993),
    [sym_crate] = ACTIONS(1993),
    [sym_metavariable] = ACTIONS(1996),
    [sym__raw_string_literal_start] = ACTIONS(1999),
    [sym_float_literal] = ACTIONS(1984),
  },
  [537] = {
    [sym_line_comment] = STATE(537),
    [sym_block_comment] = STATE(537),
    [ts_builtin_sym_end] = ACTIONS(2002),
    [sym_identifier] = ACTIONS(2004),
    [anon_sym_SEMI] = ACTIONS(2002),
    [anon_sym_macro_rules_BANG] = ACTIONS(2002),
    [anon_sym_LPAREN] = ACTIONS(2002),
    [anon_sym_LBRACK] = ACTIONS(2002),
    [anon_sym_LBRACE] = ACTIONS(2002),
    [anon_sym_RBRACE] = ACTIONS(2002),
    [anon_sym_STAR] = ACTIONS(2002),
    [anon_sym_u8] = ACTIONS(2004),
    [anon_sym_i8] = ACTIONS(2004),
    [anon_sym_u16] = ACTIONS(2004),
    [anon_sym_i16] = ACTIONS(2004),
    [anon_sym_u32] = ACTIONS(2004),
    [anon_sym_i32] = ACTIONS(2004),
    [anon_sym_u64] = ACTIONS(2004),
    [anon_sym_i64] = ACTIONS(2004),
    [anon_sym_u128] = ACTIONS(2004),
    [anon_sym_i128] = ACTIONS(2004),
    [anon_sym_isize] = ACTIONS(2004),
    [anon_sym_usize] = ACTIONS(2004),
    [anon_sym_f32] = ACTIONS(2004),
    [anon_sym_f64] = ACTIONS(2004),
    [anon_sym_bool] = ACTIONS(2004),
    [anon_sym_str] = ACTIONS(2004),
    [anon_sym_char] = ACTIONS(2004),
    [anon_sym_DASH] = ACTIONS(2002),
    [anon_sym_BANG] = ACTIONS(2002),
    [anon_sym_AMP] = ACTIONS(2002),
    [anon_sym_PIPE] = ACTIONS(2002),
    [anon_sym_LT] = ACTIONS(2002),
    [anon_sym_DOT_DOT] = ACTIONS(2002),
    [anon_sym_COLON_COLON] = ACTIONS(2002),
    [anon_sym_POUND] = ACTIONS(2002),
    [anon_sym_SQUOTE] = ACTIONS(2004),
    [anon_sym_async] = ACTIONS(2004),
    [anon_sym_break] = ACTIONS(2004),
    [anon_sym_const] = ACTIONS(2004),
    [anon_sym_continue] = ACTIONS(2004),
    [anon_sym_default] = ACTIONS(2004),
    [anon_sym_enum] = ACTIONS(2004),
    [anon_sym_fn] = ACTIONS(2004),
    [anon_sym_for] = ACTIONS(2004),
    [anon_sym_if] = ACTIONS(2004),
    [anon_sym_impl] = ACTIONS(2004),
    [anon_sym_let] = ACTIONS(2004),
    [anon_sym_loop] = ACTIONS(2004),
    [anon_sym_match] = ACTIONS(2004),
    [anon_sym_mod] = ACTIONS(2004),
    [anon_sym_pub] = ACTIONS(2004),
    [anon_sym_return] = ACTIONS(2004),
    [anon_sym_static] = ACTIONS(2004),
    [anon_sym_struct] = ACTIONS(2004),
    [anon_sym_trait] = ACTIONS(2004),
    [anon_sym_type] = ACTIONS(2004),
    [anon_sym_union] = ACTIONS(2004),
    [anon_sym_unsafe] = ACTIONS(2004),
    [anon_sym_use] = ACTIONS(2004),
    [anon_sym_while] = ACTIONS(2004),
    [anon_sym_extern] = ACTIONS(2004),
    [anon_sym_yield] = ACTIONS(2004),
    [anon_sym_move] = ACTIONS(2004),
    [anon_sym_try] = ACTIONS(2004),
    [sym_integer_literal] = ACTIONS(2002),
    [aux_sym_string_literal_token1] = ACTIONS(2002),
    [sym_char_literal] = ACTIONS(2002),
    [anon_sym_true] = ACTIONS(2004),
    [anon_sym_false] = ACTIONS(2004),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2004),
    [sym_super] = ACTIONS(2004),
    [sym_crate] = ACTIONS(2004),
    [sym_metavariable] = ACTIONS(2002),
    [sym__raw_string_literal_start] = ACTIONS(2002),
    [sym_float_literal] = ACTIONS(2002),
  },
  [538] = {
    [sym_line_comment] = STATE(538),
    [sym_block_comment] = STATE(538),
    [ts_builtin_sym_end] = ACTIONS(2006),
    [sym_identifier] = ACTIONS(2008),
    [anon_sym_SEMI] = ACTIONS(2006),
    [anon_sym_macro_rules_BANG] = ACTIONS(2006),
    [anon_sym_LPAREN] = ACTIONS(2006),
    [anon_sym_LBRACK] = ACTIONS(2006),
    [anon_sym_LBRACE] = ACTIONS(2006),
    [anon_sym_RBRACE] = ACTIONS(2006),
    [anon_sym_STAR] = ACTIONS(2006),
    [anon_sym_u8] = ACTIONS(2008),
    [anon_sym_i8] = ACTIONS(2008),
    [anon_sym_u16] = ACTIONS(2008),
    [anon_sym_i16] = ACTIONS(2008),
    [anon_sym_u32] = ACTIONS(2008),
    [anon_sym_i32] = ACTIONS(2008),
    [anon_sym_u64] = ACTIONS(2008),
    [anon_sym_i64] = ACTIONS(2008),
    [anon_sym_u128] = ACTIONS(2008),
    [anon_sym_i128] = ACTIONS(2008),
    [anon_sym_isize] = ACTIONS(2008),
    [anon_sym_usize] = ACTIONS(2008),
    [anon_sym_f32] = ACTIONS(2008),
    [anon_sym_f64] = ACTIONS(2008),
    [anon_sym_bool] = ACTIONS(2008),
    [anon_sym_str] = ACTIONS(2008),
    [anon_sym_char] = ACTIONS(2008),
    [anon_sym_DASH] = ACTIONS(2006),
    [anon_sym_BANG] = ACTIONS(2006),
    [anon_sym_AMP] = ACTIONS(2006),
    [anon_sym_PIPE] = ACTIONS(2006),
    [anon_sym_LT] = ACTIONS(2006),
    [anon_sym_DOT_DOT] = ACTIONS(2006),
    [anon_sym_COLON_COLON] = ACTIONS(2006),
    [anon_sym_POUND] = ACTIONS(2006),
    [anon_sym_SQUOTE] = ACTIONS(2008),
    [anon_sym_async] = ACTIONS(2008),
    [anon_sym_break] = ACTIONS(2008),
    [anon_sym_const] = ACTIONS(2008),
    [anon_sym_continue] = ACTIONS(2008),
    [anon_sym_default] = ACTIONS(2008),
    [anon_sym_enum] = ACTIONS(2008),
    [anon_sym_fn] = ACTIONS(2008),
    [anon_sym_for] = ACTIONS(2008),
    [anon_sym_if] = ACTIONS(2008),
    [anon_sym_impl] = ACTIONS(2008),
    [anon_sym_let] = ACTIONS(2008),
    [anon_sym_loop] = ACTIONS(2008),
    [anon_sym_match] = ACTIONS(2008),
    [anon_sym_mod] = ACTIONS(2008),
    [anon_sym_pub] = ACTIONS(2008),
    [anon_sym_return] = ACTIONS(2008),
    [anon_sym_static] = ACTIONS(2008),
    [anon_sym_struct] = ACTIONS(2008),
    [anon_sym_trait] = ACTIONS(2008),
    [anon_sym_type] = ACTIONS(2008),
    [anon_sym_union] = ACTIONS(2008),
    [anon_sym_unsafe] = ACTIONS(2008),
    [anon_sym_use] = ACTIONS(2008),
    [anon_sym_while] = ACTIONS(2008),
    [anon_sym_extern] = ACTIONS(2008),
    [anon_sym_yield] = ACTIONS(2008),
    [anon_sym_move] = ACTIONS(2008),
    [anon_sym_try] = ACTIONS(2008),
    [sym_integer_literal] = ACTIONS(2006),
    [aux_sym_string_literal_token1] = ACTIONS(2006),
    [sym_char_literal] = ACTIONS(2006),
    [anon_sym_true] = ACTIONS(2008),
    [anon_sym_false] = ACTIONS(2008),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2008),
    [sym_super] = ACTIONS(2008),
    [sym_crate] = ACTIONS(2008),
    [sym_metavariable] = ACTIONS(2006),
    [sym__raw_string_literal_start] = ACTIONS(2006),
    [sym_float_literal] = ACTIONS(2006),
  },
  [539] = {
    [sym_line_comment] = STATE(539),
    [sym_block_comment] = STATE(539),
    [ts_builtin_sym_end] = ACTIONS(2010),
    [sym_identifier] = ACTIONS(2012),
    [anon_sym_SEMI] = ACTIONS(2010),
    [anon_sym_macro_rules_BANG] = ACTIONS(2010),
    [anon_sym_LPAREN] = ACTIONS(2010),
    [anon_sym_LBRACK] = ACTIONS(2010),
    [anon_sym_LBRACE] = ACTIONS(2010),
    [anon_sym_RBRACE] = ACTIONS(2010),
    [anon_sym_STAR] = ACTIONS(2010),
    [anon_sym_u8] = ACTIONS(2012),
    [anon_sym_i8] = ACTIONS(2012),
    [anon_sym_u16] = ACTIONS(2012),
    [anon_sym_i16] = ACTIONS(2012),
    [anon_sym_u32] = ACTIONS(2012),
    [anon_sym_i32] = ACTIONS(2012),
    [anon_sym_u64] = ACTIONS(2012),
    [anon_sym_i64] = ACTIONS(2012),
    [anon_sym_u128] = ACTIONS(2012),
    [anon_sym_i128] = ACTIONS(2012),
    [anon_sym_isize] = ACTIONS(2012),
    [anon_sym_usize] = ACTIONS(2012),
    [anon_sym_f32] = ACTIONS(2012),
    [anon_sym_f64] = ACTIONS(2012),
    [anon_sym_bool] = ACTIONS(2012),
    [anon_sym_str] = ACTIONS(2012),
    [anon_sym_char] = ACTIONS(2012),
    [anon_sym_DASH] = ACTIONS(2010),
    [anon_sym_BANG] = ACTIONS(2010),
    [anon_sym_AMP] = ACTIONS(2010),
    [anon_sym_PIPE] = ACTIONS(2010),
    [anon_sym_LT] = ACTIONS(2010),
    [anon_sym_DOT_DOT] = ACTIONS(2010),
    [anon_sym_COLON_COLON] = ACTIONS(2010),
    [anon_sym_POUND] = ACTIONS(2010),
    [anon_sym_SQUOTE] = ACTIONS(2012),
    [anon_sym_async] = ACTIONS(2012),
    [anon_sym_break] = ACTIONS(2012),
    [anon_sym_const] = ACTIONS(2012),
    [anon_sym_continue] = ACTIONS(2012),
    [anon_sym_default] = ACTIONS(2012),
    [anon_sym_enum] = ACTIONS(2012),
    [anon_sym_fn] = ACTIONS(2012),
    [anon_sym_for] = ACTIONS(2012),
    [anon_sym_if] = ACTIONS(2012),
    [anon_sym_impl] = ACTIONS(2012),
    [anon_sym_let] = ACTIONS(2012),
    [anon_sym_loop] = ACTIONS(2012),
    [anon_sym_match] = ACTIONS(2012),
    [anon_sym_mod] = ACTIONS(2012),
    [anon_sym_pub] = ACTIONS(2012),
    [anon_sym_return] = ACTIONS(2012),
    [anon_sym_static] = ACTIONS(2012),
    [anon_sym_struct] = ACTIONS(2012),
    [anon_sym_trait] = ACTIONS(2012),
    [anon_sym_type] = ACTIONS(2012),
    [anon_sym_union] = ACTIONS(2012),
    [anon_sym_unsafe] = ACTIONS(2012),
    [anon_sym_use] = ACTIONS(2012),
    [anon_sym_while] = ACTIONS(2012),
    [anon_sym_extern] = ACTIONS(2012),
    [anon_sym_yield] = ACTIONS(2012),
    [anon_sym_move] = ACTIONS(2012),
    [anon_sym_try] = ACTIONS(2012),
    [sym_integer_literal] = ACTIONS(2010),
    [aux_sym_string_literal_token1] = ACTIONS(2010),
    [sym_char_literal] = ACTIONS(2010),
    [anon_sym_true] = ACTIONS(2012),
    [anon_sym_false] = ACTIONS(2012),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2012),
    [sym_super] = ACTIONS(2012),
    [sym_crate] = ACTIONS(2012),
    [sym_metavariable] = ACTIONS(2010),
    [sym__raw_string_literal_start] = ACTIONS(2010),
    [sym_float_literal] = ACTIONS(2010),
  },
  [540] = {
    [sym_line_comment] = STATE(540),
    [sym_block_comment] = STATE(540),
    [ts_builtin_sym_end] = ACTIONS(2014),
    [sym_identifier] = ACTIONS(2016),
    [anon_sym_SEMI] = ACTIONS(2014),
    [anon_sym_macro_rules_BANG] = ACTIONS(2014),
    [anon_sym_LPAREN] = ACTIONS(2014),
    [anon_sym_LBRACK] = ACTIONS(2014),
    [anon_sym_LBRACE] = ACTIONS(2014),
    [anon_sym_RBRACE] = ACTIONS(2014),
    [anon_sym_STAR] = ACTIONS(2014),
    [anon_sym_u8] = ACTIONS(2016),
    [anon_sym_i8] = ACTIONS(2016),
    [anon_sym_u16] = ACTIONS(2016),
    [anon_sym_i16] = ACTIONS(2016),
    [anon_sym_u32] = ACTIONS(2016),
    [anon_sym_i32] = ACTIONS(2016),
    [anon_sym_u64] = ACTIONS(2016),
    [anon_sym_i64] = ACTIONS(2016),
    [anon_sym_u128] = ACTIONS(2016),
    [anon_sym_i128] = ACTIONS(2016),
    [anon_sym_isize] = ACTIONS(2016),
    [anon_sym_usize] = ACTIONS(2016),
    [anon_sym_f32] = ACTIONS(2016),
    [anon_sym_f64] = ACTIONS(2016),
    [anon_sym_bool] = ACTIONS(2016),
    [anon_sym_str] = ACTIONS(2016),
    [anon_sym_char] = ACTIONS(2016),
    [anon_sym_DASH] = ACTIONS(2014),
    [anon_sym_BANG] = ACTIONS(2014),
    [anon_sym_AMP] = ACTIONS(2014),
    [anon_sym_PIPE] = ACTIONS(2014),
    [anon_sym_LT] = ACTIONS(2014),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_COLON_COLON] = ACTIONS(2014),
    [anon_sym_POUND] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_async] = ACTIONS(2016),
    [anon_sym_break] = ACTIONS(2016),
    [anon_sym_const] = ACTIONS(2016),
    [anon_sym_continue] = ACTIONS(2016),
    [anon_sym_default] = ACTIONS(2016),
    [anon_sym_enum] = ACTIONS(2016),
    [anon_sym_fn] = ACTIONS(2016),
    [anon_sym_for] = ACTIONS(2016),
    [anon_sym_if] = ACTIONS(2016),
    [anon_sym_impl] = ACTIONS(2016),
    [anon_sym_let] = ACTIONS(2016),
    [anon_sym_loop] = ACTIONS(2016),
    [anon_sym_match] = ACTIONS(2016),
    [anon_sym_mod] = ACTIONS(2016),
    [anon_sym_pub] = ACTIONS(2016),
    [anon_sym_return] = ACTIONS(2016),
    [anon_sym_static] = ACTIONS(2016),
    [anon_sym_struct] = ACTIONS(2016),
    [anon_sym_trait] = ACTIONS(2016),
    [anon_sym_type] = ACTIONS(2016),
    [anon_sym_union] = ACTIONS(2016),
    [anon_sym_unsafe] = ACTIONS(2016),
    [anon_sym_use] = ACTIONS(2016),
    [anon_sym_while] = ACTIONS(2016),
    [anon_sym_extern] = ACTIONS(2016),
    [anon_sym_yield] = ACTIONS(2016),
    [anon_sym_move] = ACTIONS(2016),
    [anon_sym_try] = ACTIONS(2016),
    [sym_integer_literal] = ACTIONS(2014),
    [aux_sym_string_literal_token1] = ACTIONS(2014),
    [sym_char_literal] = ACTIONS(2014),
    [anon_sym_true] = ACTIONS(2016),
    [anon_sym_false] = ACTIONS(2016),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2016),
    [sym_super] = ACTIONS(2016),
    [sym_crate] = ACTIONS(2016),
    [sym_metavariable] = ACTIONS(2014),
    [sym__raw_string_literal_start] = ACTIONS(2014),
    [sym_float_literal] = ACTIONS(2014),
  },
  [541] = {
    [sym_line_comment] = STATE(541),
    [sym_block_comment] = STATE(541),
    [ts_builtin_sym_end] = ACTIONS(2018),
    [sym_identifier] = ACTIONS(2020),
    [anon_sym_SEMI] = ACTIONS(2018),
    [anon_sym_macro_rules_BANG] = ACTIONS(2018),
    [anon_sym_LPAREN] = ACTIONS(2018),
    [anon_sym_LBRACK] = ACTIONS(2018),
    [anon_sym_LBRACE] = ACTIONS(2018),
    [anon_sym_RBRACE] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(2018),
    [anon_sym_u8] = ACTIONS(2020),
    [anon_sym_i8] = ACTIONS(2020),
    [anon_sym_u16] = ACTIONS(2020),
    [anon_sym_i16] = ACTIONS(2020),
    [anon_sym_u32] = ACTIONS(2020),
    [anon_sym_i32] = ACTIONS(2020),
    [anon_sym_u64] = ACTIONS(2020),
    [anon_sym_i64] = ACTIONS(2020),
    [anon_sym_u128] = ACTIONS(2020),
    [anon_sym_i128] = ACTIONS(2020),
    [anon_sym_isize] = ACTIONS(2020),
    [anon_sym_usize] = ACTIONS(2020),
    [anon_sym_f32] = ACTIONS(2020),
    [anon_sym_f64] = ACTIONS(2020),
    [anon_sym_bool] = ACTIONS(2020),
    [anon_sym_str] = ACTIONS(2020),
    [anon_sym_char] = ACTIONS(2020),
    [anon_sym_DASH] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(2018),
    [anon_sym_AMP] = ACTIONS(2018),
    [anon_sym_PIPE] = ACTIONS(2018),
    [anon_sym_LT] = ACTIONS(2018),
    [anon_sym_DOT_DOT] = ACTIONS(2018),
    [anon_sym_COLON_COLON] = ACTIONS(2018),
    [anon_sym_POUND] = ACTIONS(2018),
    [anon_sym_SQUOTE] = ACTIONS(2020),
    [anon_sym_async] = ACTIONS(2020),
    [anon_sym_break] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(2020),
    [anon_sym_continue] = ACTIONS(2020),
    [anon_sym_default] = ACTIONS(2020),
    [anon_sym_enum] = ACTIONS(2020),
    [anon_sym_fn] = ACTIONS(2020),
    [anon_sym_for] = ACTIONS(2020),
    [anon_sym_if] = ACTIONS(2020),
    [anon_sym_impl] = ACTIONS(2020),
    [anon_sym_let] = ACTIONS(2020),
    [anon_sym_loop] = ACTIONS(2020),
    [anon_sym_match] = ACTIONS(2020),
    [anon_sym_mod] = ACTIONS(2020),
    [anon_sym_pub] = ACTIONS(2020),
    [anon_sym_return] = ACTIONS(2020),
    [anon_sym_static] = ACTIONS(2020),
    [anon_sym_struct] = ACTIONS(2020),
    [anon_sym_trait] = ACTIONS(2020),
    [anon_sym_type] = ACTIONS(2020),
    [anon_sym_union] = ACTIONS(2020),
    [anon_sym_unsafe] = ACTIONS(2020),
    [anon_sym_use] = ACTIONS(2020),
    [anon_sym_while] = ACTIONS(2020),
    [anon_sym_extern] = ACTIONS(2020),
    [anon_sym_yield] = ACTIONS(2020),
    [anon_sym_move] = ACTIONS(2020),
    [anon_sym_try] = ACTIONS(2020),
    [sym_integer_literal] = ACTIONS(2018),
    [aux_sym_string_literal_token1] = ACTIONS(2018),
    [sym_char_literal] = ACTIONS(2018),
    [anon_sym_true] = ACTIONS(2020),
    [anon_sym_false] = ACTIONS(2020),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2020),
    [sym_super] = ACTIONS(2020),
    [sym_crate] = ACTIONS(2020),
    [sym_metavariable] = ACTIONS(2018),
    [sym__raw_string_literal_start] = ACTIONS(2018),
    [sym_float_literal] = ACTIONS(2018),
  },
  [542] = {
    [sym_line_comment] = STATE(542),
    [sym_block_comment] = STATE(542),
    [ts_builtin_sym_end] = ACTIONS(2022),
    [sym_identifier] = ACTIONS(2024),
    [anon_sym_SEMI] = ACTIONS(2022),
    [anon_sym_macro_rules_BANG] = ACTIONS(2022),
    [anon_sym_LPAREN] = ACTIONS(2022),
    [anon_sym_LBRACK] = ACTIONS(2022),
    [anon_sym_LBRACE] = ACTIONS(2022),
    [anon_sym_RBRACE] = ACTIONS(2022),
    [anon_sym_STAR] = ACTIONS(2022),
    [anon_sym_u8] = ACTIONS(2024),
    [anon_sym_i8] = ACTIONS(2024),
    [anon_sym_u16] = ACTIONS(2024),
    [anon_sym_i16] = ACTIONS(2024),
    [anon_sym_u32] = ACTIONS(2024),
    [anon_sym_i32] = ACTIONS(2024),
    [anon_sym_u64] = ACTIONS(2024),
    [anon_sym_i64] = ACTIONS(2024),
    [anon_sym_u128] = ACTIONS(2024),
    [anon_sym_i128] = ACTIONS(2024),
    [anon_sym_isize] = ACTIONS(2024),
    [anon_sym_usize] = ACTIONS(2024),
    [anon_sym_f32] = ACTIONS(2024),
    [anon_sym_f64] = ACTIONS(2024),
    [anon_sym_bool] = ACTIONS(2024),
    [anon_sym_str] = ACTIONS(2024),
    [anon_sym_char] = ACTIONS(2024),
    [anon_sym_DASH] = ACTIONS(2022),
    [anon_sym_BANG] = ACTIONS(2022),
    [anon_sym_AMP] = ACTIONS(2022),
    [anon_sym_PIPE] = ACTIONS(2022),
    [anon_sym_LT] = ACTIONS(2022),
    [anon_sym_DOT_DOT] = ACTIONS(2022),
    [anon_sym_COLON_COLON] = ACTIONS(2022),
    [anon_sym_POUND] = ACTIONS(2022),
    [anon_sym_SQUOTE] = ACTIONS(2024),
    [anon_sym_async] = ACTIONS(2024),
    [anon_sym_break] = ACTIONS(2024),
    [anon_sym_const] = ACTIONS(2024),
    [anon_sym_continue] = ACTIONS(2024),
    [anon_sym_default] = ACTIONS(2024),
    [anon_sym_enum] = ACTIONS(2024),
    [anon_sym_fn] = ACTIONS(2024),
    [anon_sym_for] = ACTIONS(2024),
    [anon_sym_if] = ACTIONS(2024),
    [anon_sym_impl] = ACTIONS(2024),
    [anon_sym_let] = ACTIONS(2024),
    [anon_sym_loop] = ACTIONS(2024),
    [anon_sym_match] = ACTIONS(2024),
    [anon_sym_mod] = ACTIONS(2024),
    [anon_sym_pub] = ACTIONS(2024),
    [anon_sym_return] = ACTIONS(2024),
    [anon_sym_static] = ACTIONS(2024),
    [anon_sym_struct] = ACTIONS(2024),
    [anon_sym_trait] = ACTIONS(2024),
    [anon_sym_type] = ACTIONS(2024),
    [anon_sym_union] = ACTIONS(2024),
    [anon_sym_unsafe] = ACTIONS(2024),
    [anon_sym_use] = ACTIONS(2024),
    [anon_sym_while] = ACTIONS(2024),
    [anon_sym_extern] = ACTIONS(2024),
    [anon_sym_yield] = ACTIONS(2024),
    [anon_sym_move] = ACTIONS(2024),
    [anon_sym_try] = ACTIONS(2024),
    [sym_integer_literal] = ACTIONS(2022),
    [aux_sym_string_literal_token1] = ACTIONS(2022),
    [sym_char_literal] = ACTIONS(2022),
    [anon_sym_true] = ACTIONS(2024),
    [anon_sym_false] = ACTIONS(2024),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2024),
    [sym_super] = ACTIONS(2024),
    [sym_crate] = ACTIONS(2024),
    [sym_metavariable] = ACTIONS(2022),
    [sym__raw_string_literal_start] = ACTIONS(2022),
    [sym_float_literal] = ACTIONS(2022),
  },
  [543] = {
    [sym_line_comment] = STATE(543),
    [sym_block_comment] = STATE(543),
    [ts_builtin_sym_end] = ACTIONS(2026),
    [sym_identifier] = ACTIONS(2028),
    [anon_sym_SEMI] = ACTIONS(2026),
    [anon_sym_macro_rules_BANG] = ACTIONS(2026),
    [anon_sym_LPAREN] = ACTIONS(2026),
    [anon_sym_LBRACK] = ACTIONS(2026),
    [anon_sym_LBRACE] = ACTIONS(2026),
    [anon_sym_RBRACE] = ACTIONS(2026),
    [anon_sym_STAR] = ACTIONS(2026),
    [anon_sym_u8] = ACTIONS(2028),
    [anon_sym_i8] = ACTIONS(2028),
    [anon_sym_u16] = ACTIONS(2028),
    [anon_sym_i16] = ACTIONS(2028),
    [anon_sym_u32] = ACTIONS(2028),
    [anon_sym_i32] = ACTIONS(2028),
    [anon_sym_u64] = ACTIONS(2028),
    [anon_sym_i64] = ACTIONS(2028),
    [anon_sym_u128] = ACTIONS(2028),
    [anon_sym_i128] = ACTIONS(2028),
    [anon_sym_isize] = ACTIONS(2028),
    [anon_sym_usize] = ACTIONS(2028),
    [anon_sym_f32] = ACTIONS(2028),
    [anon_sym_f64] = ACTIONS(2028),
    [anon_sym_bool] = ACTIONS(2028),
    [anon_sym_str] = ACTIONS(2028),
    [anon_sym_char] = ACTIONS(2028),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_BANG] = ACTIONS(2026),
    [anon_sym_AMP] = ACTIONS(2026),
    [anon_sym_PIPE] = ACTIONS(2026),
    [anon_sym_LT] = ACTIONS(2026),
    [anon_sym_DOT_DOT] = ACTIONS(2026),
    [anon_sym_COLON_COLON] = ACTIONS(2026),
    [anon_sym_POUND] = ACTIONS(2026),
    [anon_sym_SQUOTE] = ACTIONS(2028),
    [anon_sym_async] = ACTIONS(2028),
    [anon_sym_break] = ACTIONS(2028),
    [anon_sym_const] = ACTIONS(2028),
    [anon_sym_continue] = ACTIONS(2028),
    [anon_sym_default] = ACTIONS(2028),
    [anon_sym_enum] = ACTIONS(2028),
    [anon_sym_fn] = ACTIONS(2028),
    [anon_sym_for] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(2028),
    [anon_sym_impl] = ACTIONS(2028),
    [anon_sym_let] = ACTIONS(2028),
    [anon_sym_loop] = ACTIONS(2028),
    [anon_sym_match] = ACTIONS(2028),
    [anon_sym_mod] = ACTIONS(2028),
    [anon_sym_pub] = ACTIONS(2028),
    [anon_sym_return] = ACTIONS(2028),
    [anon_sym_static] = ACTIONS(2028),
    [anon_sym_struct] = ACTIONS(2028),
    [anon_sym_trait] = ACTIONS(2028),
    [anon_sym_type] = ACTIONS(2028),
    [anon_sym_union] = ACTIONS(2028),
    [anon_sym_unsafe] = ACTIONS(2028),
    [anon_sym_use] = ACTIONS(2028),
    [anon_sym_while] = ACTIONS(2028),
    [anon_sym_extern] = ACTIONS(2028),
    [anon_sym_yield] = ACTIONS(2028),
    [anon_sym_move] = ACTIONS(2028),
    [anon_sym_try] = ACTIONS(2028),
    [sym_integer_literal] = ACTIONS(2026),
    [aux_sym_string_literal_token1] = ACTIONS(2026),
    [sym_char_literal] = ACTIONS(2026),
    [anon_sym_true] = ACTIONS(2028),
    [anon_sym_false] = ACTIONS(2028),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2028),
    [sym_super] = ACTIONS(2028),
    [sym_crate] = ACTIONS(2028),
    [sym_metavariable] = ACTIONS(2026),
    [sym__raw_string_literal_start] = ACTIONS(2026),
    [sym_float_literal] = ACTIONS(2026),
  },
  [544] = {
    [sym_line_comment] = STATE(544),
    [sym_block_comment] = STATE(544),
    [ts_builtin_sym_end] = ACTIONS(2030),
    [sym_identifier] = ACTIONS(2032),
    [anon_sym_SEMI] = ACTIONS(2030),
    [anon_sym_macro_rules_BANG] = ACTIONS(2030),
    [anon_sym_LPAREN] = ACTIONS(2030),
    [anon_sym_LBRACK] = ACTIONS(2030),
    [anon_sym_LBRACE] = ACTIONS(2030),
    [anon_sym_RBRACE] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(2030),
    [anon_sym_u8] = ACTIONS(2032),
    [anon_sym_i8] = ACTIONS(2032),
    [anon_sym_u16] = ACTIONS(2032),
    [anon_sym_i16] = ACTIONS(2032),
    [anon_sym_u32] = ACTIONS(2032),
    [anon_sym_i32] = ACTIONS(2032),
    [anon_sym_u64] = ACTIONS(2032),
    [anon_sym_i64] = ACTIONS(2032),
    [anon_sym_u128] = ACTIONS(2032),
    [anon_sym_i128] = ACTIONS(2032),
    [anon_sym_isize] = ACTIONS(2032),
    [anon_sym_usize] = ACTIONS(2032),
    [anon_sym_f32] = ACTIONS(2032),
    [anon_sym_f64] = ACTIONS(2032),
    [anon_sym_bool] = ACTIONS(2032),
    [anon_sym_str] = ACTIONS(2032),
    [anon_sym_char] = ACTIONS(2032),
    [anon_sym_DASH] = ACTIONS(2030),
    [anon_sym_BANG] = ACTIONS(2030),
    [anon_sym_AMP] = ACTIONS(2030),
    [anon_sym_PIPE] = ACTIONS(2030),
    [anon_sym_LT] = ACTIONS(2030),
    [anon_sym_DOT_DOT] = ACTIONS(2030),
    [anon_sym_COLON_COLON] = ACTIONS(2030),
    [anon_sym_POUND] = ACTIONS(2030),
    [anon_sym_SQUOTE] = ACTIONS(2032),
    [anon_sym_async] = ACTIONS(2032),
    [anon_sym_break] = ACTIONS(2032),
    [anon_sym_const] = ACTIONS(2032),
    [anon_sym_continue] = ACTIONS(2032),
    [anon_sym_default] = ACTIONS(2032),
    [anon_sym_enum] = ACTIONS(2032),
    [anon_sym_fn] = ACTIONS(2032),
    [anon_sym_for] = ACTIONS(2032),
    [anon_sym_if] = ACTIONS(2032),
    [anon_sym_impl] = ACTIONS(2032),
    [anon_sym_let] = ACTIONS(2032),
    [anon_sym_loop] = ACTIONS(2032),
    [anon_sym_match] = ACTIONS(2032),
    [anon_sym_mod] = ACTIONS(2032),
    [anon_sym_pub] = ACTIONS(2032),
    [anon_sym_return] = ACTIONS(2032),
    [anon_sym_static] = ACTIONS(2032),
    [anon_sym_struct] = ACTIONS(2032),
    [anon_sym_trait] = ACTIONS(2032),
    [anon_sym_type] = ACTIONS(2032),
    [anon_sym_union] = ACTIONS(2032),
    [anon_sym_unsafe] = ACTIONS(2032),
    [anon_sym_use] = ACTIONS(2032),
    [anon_sym_while] = ACTIONS(2032),
    [anon_sym_extern] = ACTIONS(2032),
    [anon_sym_yield] = ACTIONS(2032),
    [anon_sym_move] = ACTIONS(2032),
    [anon_sym_try] = ACTIONS(2032),
    [sym_integer_literal] = ACTIONS(2030),
    [aux_sym_string_literal_token1] = ACTIONS(2030),
    [sym_char_literal] = ACTIONS(2030),
    [anon_sym_true] = ACTIONS(2032),
    [anon_sym_false] = ACTIONS(2032),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2032),
    [sym_super] = ACTIONS(2032),
    [sym_crate] = ACTIONS(2032),
    [sym_metavariable] = ACTIONS(2030),
    [sym__raw_string_literal_start] = ACTIONS(2030),
    [sym_float_literal] = ACTIONS(2030),
  },
  [545] = {
    [sym_line_comment] = STATE(545),
    [sym_block_comment] = STATE(545),
    [ts_builtin_sym_end] = ACTIONS(2034),
    [sym_identifier] = ACTIONS(2036),
    [anon_sym_SEMI] = ACTIONS(2034),
    [anon_sym_macro_rules_BANG] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(2034),
    [anon_sym_LBRACK] = ACTIONS(2034),
    [anon_sym_LBRACE] = ACTIONS(2034),
    [anon_sym_RBRACE] = ACTIONS(2034),
    [anon_sym_STAR] = ACTIONS(2034),
    [anon_sym_u8] = ACTIONS(2036),
    [anon_sym_i8] = ACTIONS(2036),
    [anon_sym_u16] = ACTIONS(2036),
    [anon_sym_i16] = ACTIONS(2036),
    [anon_sym_u32] = ACTIONS(2036),
    [anon_sym_i32] = ACTIONS(2036),
    [anon_sym_u64] = ACTIONS(2036),
    [anon_sym_i64] = ACTIONS(2036),
    [anon_sym_u128] = ACTIONS(2036),
    [anon_sym_i128] = ACTIONS(2036),
    [anon_sym_isize] = ACTIONS(2036),
    [anon_sym_usize] = ACTIONS(2036),
    [anon_sym_f32] = ACTIONS(2036),
    [anon_sym_f64] = ACTIONS(2036),
    [anon_sym_bool] = ACTIONS(2036),
    [anon_sym_str] = ACTIONS(2036),
    [anon_sym_char] = ACTIONS(2036),
    [anon_sym_DASH] = ACTIONS(2034),
    [anon_sym_BANG] = ACTIONS(2034),
    [anon_sym_AMP] = ACTIONS(2034),
    [anon_sym_PIPE] = ACTIONS(2034),
    [anon_sym_LT] = ACTIONS(2034),
    [anon_sym_DOT_DOT] = ACTIONS(2034),
    [anon_sym_COLON_COLON] = ACTIONS(2034),
    [anon_sym_POUND] = ACTIONS(2034),
    [anon_sym_SQUOTE] = ACTIONS(2036),
    [anon_sym_async] = ACTIONS(2036),
    [anon_sym_break] = ACTIONS(2036),
    [anon_sym_const] = ACTIONS(2036),
    [anon_sym_continue] = ACTIONS(2036),
    [anon_sym_default] = ACTIONS(2036),
    [anon_sym_enum] = ACTIONS(2036),
    [anon_sym_fn] = ACTIONS(2036),
    [anon_sym_for] = ACTIONS(2036),
    [anon_sym_if] = ACTIONS(2036),
    [anon_sym_impl] = ACTIONS(2036),
    [anon_sym_let] = ACTIONS(2036),
    [anon_sym_loop] = ACTIONS(2036),
    [anon_sym_match] = ACTIONS(2036),
    [anon_sym_mod] = ACTIONS(2036),
    [anon_sym_pub] = ACTIONS(2036),
    [anon_sym_return] = ACTIONS(2036),
    [anon_sym_static] = ACTIONS(2036),
    [anon_sym_struct] = ACTIONS(2036),
    [anon_sym_trait] = ACTIONS(2036),
    [anon_sym_type] = ACTIONS(2036),
    [anon_sym_union] = ACTIONS(2036),
    [anon_sym_unsafe] = ACTIONS(2036),
    [anon_sym_use] = ACTIONS(2036),
    [anon_sym_while] = ACTIONS(2036),
    [anon_sym_extern] = ACTIONS(2036),
    [anon_sym_yield] = ACTIONS(2036),
    [anon_sym_move] = ACTIONS(2036),
    [anon_sym_try] = ACTIONS(2036),
    [sym_integer_literal] = ACTIONS(2034),
    [aux_sym_string_literal_token1] = ACTIONS(2034),
    [sym_char_literal] = ACTIONS(2034),
    [anon_sym_true] = ACTIONS(2036),
    [anon_sym_false] = ACTIONS(2036),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2036),
    [sym_super] = ACTIONS(2036),
    [sym_crate] = ACTIONS(2036),
    [sym_metavariable] = ACTIONS(2034),
    [sym__raw_string_literal_start] = ACTIONS(2034),
    [sym_float_literal] = ACTIONS(2034),
  },
  [546] = {
    [sym_line_comment] = STATE(546),
    [sym_block_comment] = STATE(546),
    [ts_builtin_sym_end] = ACTIONS(2038),
    [sym_identifier] = ACTIONS(2040),
    [anon_sym_SEMI] = ACTIONS(2038),
    [anon_sym_macro_rules_BANG] = ACTIONS(2038),
    [anon_sym_LPAREN] = ACTIONS(2038),
    [anon_sym_LBRACK] = ACTIONS(2038),
    [anon_sym_LBRACE] = ACTIONS(2038),
    [anon_sym_RBRACE] = ACTIONS(2038),
    [anon_sym_STAR] = ACTIONS(2038),
    [anon_sym_u8] = ACTIONS(2040),
    [anon_sym_i8] = ACTIONS(2040),
    [anon_sym_u16] = ACTIONS(2040),
    [anon_sym_i16] = ACTIONS(2040),
    [anon_sym_u32] = ACTIONS(2040),
    [anon_sym_i32] = ACTIONS(2040),
    [anon_sym_u64] = ACTIONS(2040),
    [anon_sym_i64] = ACTIONS(2040),
    [anon_sym_u128] = ACTIONS(2040),
    [anon_sym_i128] = ACTIONS(2040),
    [anon_sym_isize] = ACTIONS(2040),
    [anon_sym_usize] = ACTIONS(2040),
    [anon_sym_f32] = ACTIONS(2040),
    [anon_sym_f64] = ACTIONS(2040),
    [anon_sym_bool] = ACTIONS(2040),
    [anon_sym_str] = ACTIONS(2040),
    [anon_sym_char] = ACTIONS(2040),
    [anon_sym_DASH] = ACTIONS(2038),
    [anon_sym_BANG] = ACTIONS(2038),
    [anon_sym_AMP] = ACTIONS(2038),
    [anon_sym_PIPE] = ACTIONS(2038),
    [anon_sym_LT] = ACTIONS(2038),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_COLON_COLON] = ACTIONS(2038),
    [anon_sym_POUND] = ACTIONS(2038),
    [anon_sym_SQUOTE] = ACTIONS(2040),
    [anon_sym_async] = ACTIONS(2040),
    [anon_sym_break] = ACTIONS(2040),
    [anon_sym_const] = ACTIONS(2040),
    [anon_sym_continue] = ACTIONS(2040),
    [anon_sym_default] = ACTIONS(2040),
    [anon_sym_enum] = ACTIONS(2040),
    [anon_sym_fn] = ACTIONS(2040),
    [anon_sym_for] = ACTIONS(2040),
    [anon_sym_if] = ACTIONS(2040),
    [anon_sym_impl] = ACTIONS(2040),
    [anon_sym_let] = ACTIONS(2040),
    [anon_sym_loop] = ACTIONS(2040),
    [anon_sym_match] = ACTIONS(2040),
    [anon_sym_mod] = ACTIONS(2040),
    [anon_sym_pub] = ACTIONS(2040),
    [anon_sym_return] = ACTIONS(2040),
    [anon_sym_static] = ACTIONS(2040),
    [anon_sym_struct] = ACTIONS(2040),
    [anon_sym_trait] = ACTIONS(2040),
    [anon_sym_type] = ACTIONS(2040),
    [anon_sym_union] = ACTIONS(2040),
    [anon_sym_unsafe] = ACTIONS(2040),
    [anon_sym_use] = ACTIONS(2040),
    [anon_sym_while] = ACTIONS(2040),
    [anon_sym_extern] = ACTIONS(2040),
    [anon_sym_yield] = ACTIONS(2040),
    [anon_sym_move] = ACTIONS(2040),
    [anon_sym_try] = ACTIONS(2040),
    [sym_integer_literal] = ACTIONS(2038),
    [aux_sym_string_literal_token1] = ACTIONS(2038),
    [sym_char_literal] = ACTIONS(2038),
    [anon_sym_true] = ACTIONS(2040),
    [anon_sym_false] = ACTIONS(2040),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2040),
    [sym_super] = ACTIONS(2040),
    [sym_crate] = ACTIONS(2040),
    [sym_metavariable] = ACTIONS(2038),
    [sym__raw_string_literal_start] = ACTIONS(2038),
    [sym_float_literal] = ACTIONS(2038),
  },
  [547] = {
    [sym_line_comment] = STATE(547),
    [sym_block_comment] = STATE(547),
    [ts_builtin_sym_end] = ACTIONS(2042),
    [sym_identifier] = ACTIONS(2044),
    [anon_sym_SEMI] = ACTIONS(2042),
    [anon_sym_macro_rules_BANG] = ACTIONS(2042),
    [anon_sym_LPAREN] = ACTIONS(2042),
    [anon_sym_LBRACK] = ACTIONS(2042),
    [anon_sym_LBRACE] = ACTIONS(2042),
    [anon_sym_RBRACE] = ACTIONS(2042),
    [anon_sym_STAR] = ACTIONS(2042),
    [anon_sym_u8] = ACTIONS(2044),
    [anon_sym_i8] = ACTIONS(2044),
    [anon_sym_u16] = ACTIONS(2044),
    [anon_sym_i16] = ACTIONS(2044),
    [anon_sym_u32] = ACTIONS(2044),
    [anon_sym_i32] = ACTIONS(2044),
    [anon_sym_u64] = ACTIONS(2044),
    [anon_sym_i64] = ACTIONS(2044),
    [anon_sym_u128] = ACTIONS(2044),
    [anon_sym_i128] = ACTIONS(2044),
    [anon_sym_isize] = ACTIONS(2044),
    [anon_sym_usize] = ACTIONS(2044),
    [anon_sym_f32] = ACTIONS(2044),
    [anon_sym_f64] = ACTIONS(2044),
    [anon_sym_bool] = ACTIONS(2044),
    [anon_sym_str] = ACTIONS(2044),
    [anon_sym_char] = ACTIONS(2044),
    [anon_sym_DASH] = ACTIONS(2042),
    [anon_sym_BANG] = ACTIONS(2042),
    [anon_sym_AMP] = ACTIONS(2042),
    [anon_sym_PIPE] = ACTIONS(2042),
    [anon_sym_LT] = ACTIONS(2042),
    [anon_sym_DOT_DOT] = ACTIONS(2042),
    [anon_sym_COLON_COLON] = ACTIONS(2042),
    [anon_sym_POUND] = ACTIONS(2042),
    [anon_sym_SQUOTE] = ACTIONS(2044),
    [anon_sym_async] = ACTIONS(2044),
    [anon_sym_break] = ACTIONS(2044),
    [anon_sym_const] = ACTIONS(2044),
    [anon_sym_continue] = ACTIONS(2044),
    [anon_sym_default] = ACTIONS(2044),
    [anon_sym_enum] = ACTIONS(2044),
    [anon_sym_fn] = ACTIONS(2044),
    [anon_sym_for] = ACTIONS(2044),
    [anon_sym_if] = ACTIONS(2044),
    [anon_sym_impl] = ACTIONS(2044),
    [anon_sym_let] = ACTIONS(2044),
    [anon_sym_loop] = ACTIONS(2044),
    [anon_sym_match] = ACTIONS(2044),
    [anon_sym_mod] = ACTIONS(2044),
    [anon_sym_pub] = ACTIONS(2044),
    [anon_sym_return] = ACTIONS(2044),
    [anon_sym_static] = ACTIONS(2044),
    [anon_sym_struct] = ACTIONS(2044),
    [anon_sym_trait] = ACTIONS(2044),
    [anon_sym_type] = ACTIONS(2044),
    [anon_sym_union] = ACTIONS(2044),
    [anon_sym_unsafe] = ACTIONS(2044),
    [anon_sym_use] = ACTIONS(2044),
    [anon_sym_while] = ACTIONS(2044),
    [anon_sym_extern] = ACTIONS(2044),
    [anon_sym_yield] = ACTIONS(2044),
    [anon_sym_move] = ACTIONS(2044),
    [anon_sym_try] = ACTIONS(2044),
    [sym_integer_literal] = ACTIONS(2042),
    [aux_sym_string_literal_token1] = ACTIONS(2042),
    [sym_char_literal] = ACTIONS(2042),
    [anon_sym_true] = ACTIONS(2044),
    [anon_sym_false] = ACTIONS(2044),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2044),
    [sym_super] = ACTIONS(2044),
    [sym_crate] = ACTIONS(2044),
    [sym_metavariable] = ACTIONS(2042),
    [sym__raw_string_literal_start] = ACTIONS(2042),
    [sym_float_literal] = ACTIONS(2042),
  },
  [548] = {
    [sym_line_comment] = STATE(548),
    [sym_block_comment] = STATE(548),
    [ts_builtin_sym_end] = ACTIONS(2046),
    [sym_identifier] = ACTIONS(2048),
    [anon_sym_SEMI] = ACTIONS(2046),
    [anon_sym_macro_rules_BANG] = ACTIONS(2046),
    [anon_sym_LPAREN] = ACTIONS(2046),
    [anon_sym_LBRACK] = ACTIONS(2046),
    [anon_sym_LBRACE] = ACTIONS(2046),
    [anon_sym_RBRACE] = ACTIONS(2046),
    [anon_sym_STAR] = ACTIONS(2046),
    [anon_sym_u8] = ACTIONS(2048),
    [anon_sym_i8] = ACTIONS(2048),
    [anon_sym_u16] = ACTIONS(2048),
    [anon_sym_i16] = ACTIONS(2048),
    [anon_sym_u32] = ACTIONS(2048),
    [anon_sym_i32] = ACTIONS(2048),
    [anon_sym_u64] = ACTIONS(2048),
    [anon_sym_i64] = ACTIONS(2048),
    [anon_sym_u128] = ACTIONS(2048),
    [anon_sym_i128] = ACTIONS(2048),
    [anon_sym_isize] = ACTIONS(2048),
    [anon_sym_usize] = ACTIONS(2048),
    [anon_sym_f32] = ACTIONS(2048),
    [anon_sym_f64] = ACTIONS(2048),
    [anon_sym_bool] = ACTIONS(2048),
    [anon_sym_str] = ACTIONS(2048),
    [anon_sym_char] = ACTIONS(2048),
    [anon_sym_DASH] = ACTIONS(2046),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_AMP] = ACTIONS(2046),
    [anon_sym_PIPE] = ACTIONS(2046),
    [anon_sym_LT] = ACTIONS(2046),
    [anon_sym_DOT_DOT] = ACTIONS(2046),
    [anon_sym_COLON_COLON] = ACTIONS(2046),
    [anon_sym_POUND] = ACTIONS(2046),
    [anon_sym_SQUOTE] = ACTIONS(2048),
    [anon_sym_async] = ACTIONS(2048),
    [anon_sym_break] = ACTIONS(2048),
    [anon_sym_const] = ACTIONS(2048),
    [anon_sym_continue] = ACTIONS(2048),
    [anon_sym_default] = ACTIONS(2048),
    [anon_sym_enum] = ACTIONS(2048),
    [anon_sym_fn] = ACTIONS(2048),
    [anon_sym_for] = ACTIONS(2048),
    [anon_sym_if] = ACTIONS(2048),
    [anon_sym_impl] = ACTIONS(2048),
    [anon_sym_let] = ACTIONS(2048),
    [anon_sym_loop] = ACTIONS(2048),
    [anon_sym_match] = ACTIONS(2048),
    [anon_sym_mod] = ACTIONS(2048),
    [anon_sym_pub] = ACTIONS(2048),
    [anon_sym_return] = ACTIONS(2048),
    [anon_sym_static] = ACTIONS(2048),
    [anon_sym_struct] = ACTIONS(2048),
    [anon_sym_trait] = ACTIONS(2048),
    [anon_sym_type] = ACTIONS(2048),
    [anon_sym_union] = ACTIONS(2048),
    [anon_sym_unsafe] = ACTIONS(2048),
    [anon_sym_use] = ACTIONS(2048),
    [anon_sym_while] = ACTIONS(2048),
    [anon_sym_extern] = ACTIONS(2048),
    [anon_sym_yield] = ACTIONS(2048),
    [anon_sym_move] = ACTIONS(2048),
    [anon_sym_try] = ACTIONS(2048),
    [sym_integer_literal] = ACTIONS(2046),
    [aux_sym_string_literal_token1] = ACTIONS(2046),
    [sym_char_literal] = ACTIONS(2046),
    [anon_sym_true] = ACTIONS(2048),
    [anon_sym_false] = ACTIONS(2048),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2048),
    [sym_super] = ACTIONS(2048),
    [sym_crate] = ACTIONS(2048),
    [sym_metavariable] = ACTIONS(2046),
    [sym__raw_string_literal_start] = ACTIONS(2046),
    [sym_float_literal] = ACTIONS(2046),
  },
  [549] = {
    [sym_line_comment] = STATE(549),
    [sym_block_comment] = STATE(549),
    [ts_builtin_sym_end] = ACTIONS(1244),
    [sym_identifier] = ACTIONS(1246),
    [anon_sym_SEMI] = ACTIONS(1244),
    [anon_sym_macro_rules_BANG] = ACTIONS(1244),
    [anon_sym_LPAREN] = ACTIONS(1244),
    [anon_sym_LBRACK] = ACTIONS(1244),
    [anon_sym_LBRACE] = ACTIONS(1244),
    [anon_sym_RBRACE] = ACTIONS(1244),
    [anon_sym_STAR] = ACTIONS(1244),
    [anon_sym_u8] = ACTIONS(1246),
    [anon_sym_i8] = ACTIONS(1246),
    [anon_sym_u16] = ACTIONS(1246),
    [anon_sym_i16] = ACTIONS(1246),
    [anon_sym_u32] = ACTIONS(1246),
    [anon_sym_i32] = ACTIONS(1246),
    [anon_sym_u64] = ACTIONS(1246),
    [anon_sym_i64] = ACTIONS(1246),
    [anon_sym_u128] = ACTIONS(1246),
    [anon_sym_i128] = ACTIONS(1246),
    [anon_sym_isize] = ACTIONS(1246),
    [anon_sym_usize] = ACTIONS(1246),
    [anon_sym_f32] = ACTIONS(1246),
    [anon_sym_f64] = ACTIONS(1246),
    [anon_sym_bool] = ACTIONS(1246),
    [anon_sym_str] = ACTIONS(1246),
    [anon_sym_char] = ACTIONS(1246),
    [anon_sym_DASH] = ACTIONS(1244),
    [anon_sym_BANG] = ACTIONS(1244),
    [anon_sym_AMP] = ACTIONS(1244),
    [anon_sym_PIPE] = ACTIONS(1244),
    [anon_sym_LT] = ACTIONS(1244),
    [anon_sym_DOT_DOT] = ACTIONS(1244),
    [anon_sym_COLON_COLON] = ACTIONS(1244),
    [anon_sym_POUND] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [anon_sym_async] = ACTIONS(1246),
    [anon_sym_break] = ACTIONS(1246),
    [anon_sym_const] = ACTIONS(1246),
    [anon_sym_continue] = ACTIONS(1246),
    [anon_sym_default] = ACTIONS(1246),
    [anon_sym_enum] = ACTIONS(1246),
    [anon_sym_fn] = ACTIONS(1246),
    [anon_sym_for] = ACTIONS(1246),
    [anon_sym_if] = ACTIONS(1246),
    [anon_sym_impl] = ACTIONS(1246),
    [anon_sym_let] = ACTIONS(1246),
    [anon_sym_loop] = ACTIONS(1246),
    [anon_sym_match] = ACTIONS(1246),
    [anon_sym_mod] = ACTIONS(1246),
    [anon_sym_pub] = ACTIONS(1246),
    [anon_sym_return] = ACTIONS(1246),
    [anon_sym_static] = ACTIONS(1246),
    [anon_sym_struct] = ACTIONS(1246),
    [anon_sym_trait] = ACTIONS(1246),
    [anon_sym_type] = ACTIONS(1246),
    [anon_sym_union] = ACTIONS(1246),
    [anon_sym_unsafe] = ACTIONS(1246),
    [anon_sym_use] = ACTIONS(1246),
    [anon_sym_while] = ACTIONS(1246),
    [anon_sym_extern] = ACTIONS(1246),
    [anon_sym_yield] = ACTIONS(1246),
    [anon_sym_move] = ACTIONS(1246),
    [anon_sym_try] = ACTIONS(1246),
    [sym_integer_literal] = ACTIONS(1244),
    [aux_sym_string_literal_token1] = ACTIONS(1244),
    [sym_char_literal] = ACTIONS(1244),
    [anon_sym_true] = ACTIONS(1246),
    [anon_sym_false] = ACTIONS(1246),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1246),
    [sym_super] = ACTIONS(1246),
    [sym_crate] = ACTIONS(1246),
    [sym_metavariable] = ACTIONS(1244),
    [sym__raw_string_literal_start] = ACTIONS(1244),
    [sym_float_literal] = ACTIONS(1244),
  },
  [550] = {
    [sym_line_comment] = STATE(550),
    [sym_block_comment] = STATE(550),
    [ts_builtin_sym_end] = ACTIONS(2050),
    [sym_identifier] = ACTIONS(2052),
    [anon_sym_SEMI] = ACTIONS(2050),
    [anon_sym_macro_rules_BANG] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(2050),
    [anon_sym_LBRACK] = ACTIONS(2050),
    [anon_sym_LBRACE] = ACTIONS(2050),
    [anon_sym_RBRACE] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(2050),
    [anon_sym_u8] = ACTIONS(2052),
    [anon_sym_i8] = ACTIONS(2052),
    [anon_sym_u16] = ACTIONS(2052),
    [anon_sym_i16] = ACTIONS(2052),
    [anon_sym_u32] = ACTIONS(2052),
    [anon_sym_i32] = ACTIONS(2052),
    [anon_sym_u64] = ACTIONS(2052),
    [anon_sym_i64] = ACTIONS(2052),
    [anon_sym_u128] = ACTIONS(2052),
    [anon_sym_i128] = ACTIONS(2052),
    [anon_sym_isize] = ACTIONS(2052),
    [anon_sym_usize] = ACTIONS(2052),
    [anon_sym_f32] = ACTIONS(2052),
    [anon_sym_f64] = ACTIONS(2052),
    [anon_sym_bool] = ACTIONS(2052),
    [anon_sym_str] = ACTIONS(2052),
    [anon_sym_char] = ACTIONS(2052),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_BANG] = ACTIONS(2050),
    [anon_sym_AMP] = ACTIONS(2050),
    [anon_sym_PIPE] = ACTIONS(2050),
    [anon_sym_LT] = ACTIONS(2050),
    [anon_sym_DOT_DOT] = ACTIONS(2050),
    [anon_sym_COLON_COLON] = ACTIONS(2050),
    [anon_sym_POUND] = ACTIONS(2050),
    [anon_sym_SQUOTE] = ACTIONS(2052),
    [anon_sym_async] = ACTIONS(2052),
    [anon_sym_break] = ACTIONS(2052),
    [anon_sym_const] = ACTIONS(2052),
    [anon_sym_continue] = ACTIONS(2052),
    [anon_sym_default] = ACTIONS(2052),
    [anon_sym_enum] = ACTIONS(2052),
    [anon_sym_fn] = ACTIONS(2052),
    [anon_sym_for] = ACTIONS(2052),
    [anon_sym_if] = ACTIONS(2052),
    [anon_sym_impl] = ACTIONS(2052),
    [anon_sym_let] = ACTIONS(2052),
    [anon_sym_loop] = ACTIONS(2052),
    [anon_sym_match] = ACTIONS(2052),
    [anon_sym_mod] = ACTIONS(2052),
    [anon_sym_pub] = ACTIONS(2052),
    [anon_sym_return] = ACTIONS(2052),
    [anon_sym_static] = ACTIONS(2052),
    [anon_sym_struct] = ACTIONS(2052),
    [anon_sym_trait] = ACTIONS(2052),
    [anon_sym_type] = ACTIONS(2052),
    [anon_sym_union] = ACTIONS(2052),
    [anon_sym_unsafe] = ACTIONS(2052),
    [anon_sym_use] = ACTIONS(2052),
    [anon_sym_while] = ACTIONS(2052),
    [anon_sym_extern] = ACTIONS(2052),
    [anon_sym_yield] = ACTIONS(2052),
    [anon_sym_move] = ACTIONS(2052),
    [anon_sym_try] = ACTIONS(2052),
    [sym_integer_literal] = ACTIONS(2050),
    [aux_sym_string_literal_token1] = ACTIONS(2050),
    [sym_char_literal] = ACTIONS(2050),
    [anon_sym_true] = ACTIONS(2052),
    [anon_sym_false] = ACTIONS(2052),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2052),
    [sym_super] = ACTIONS(2052),
    [sym_crate] = ACTIONS(2052),
    [sym_metavariable] = ACTIONS(2050),
    [sym__raw_string_literal_start] = ACTIONS(2050),
    [sym_float_literal] = ACTIONS(2050),
  },
  [551] = {
    [sym_line_comment] = STATE(551),
    [sym_block_comment] = STATE(551),
    [ts_builtin_sym_end] = ACTIONS(2054),
    [sym_identifier] = ACTIONS(2056),
    [anon_sym_SEMI] = ACTIONS(2054),
    [anon_sym_macro_rules_BANG] = ACTIONS(2054),
    [anon_sym_LPAREN] = ACTIONS(2054),
    [anon_sym_LBRACK] = ACTIONS(2054),
    [anon_sym_LBRACE] = ACTIONS(2054),
    [anon_sym_RBRACE] = ACTIONS(2054),
    [anon_sym_STAR] = ACTIONS(2054),
    [anon_sym_u8] = ACTIONS(2056),
    [anon_sym_i8] = ACTIONS(2056),
    [anon_sym_u16] = ACTIONS(2056),
    [anon_sym_i16] = ACTIONS(2056),
    [anon_sym_u32] = ACTIONS(2056),
    [anon_sym_i32] = ACTIONS(2056),
    [anon_sym_u64] = ACTIONS(2056),
    [anon_sym_i64] = ACTIONS(2056),
    [anon_sym_u128] = ACTIONS(2056),
    [anon_sym_i128] = ACTIONS(2056),
    [anon_sym_isize] = ACTIONS(2056),
    [anon_sym_usize] = ACTIONS(2056),
    [anon_sym_f32] = ACTIONS(2056),
    [anon_sym_f64] = ACTIONS(2056),
    [anon_sym_bool] = ACTIONS(2056),
    [anon_sym_str] = ACTIONS(2056),
    [anon_sym_char] = ACTIONS(2056),
    [anon_sym_DASH] = ACTIONS(2054),
    [anon_sym_BANG] = ACTIONS(2054),
    [anon_sym_AMP] = ACTIONS(2054),
    [anon_sym_PIPE] = ACTIONS(2054),
    [anon_sym_LT] = ACTIONS(2054),
    [anon_sym_DOT_DOT] = ACTIONS(2054),
    [anon_sym_COLON_COLON] = ACTIONS(2054),
    [anon_sym_POUND] = ACTIONS(2054),
    [anon_sym_SQUOTE] = ACTIONS(2056),
    [anon_sym_async] = ACTIONS(2056),
    [anon_sym_break] = ACTIONS(2056),
    [anon_sym_const] = ACTIONS(2056),
    [anon_sym_continue] = ACTIONS(2056),
    [anon_sym_default] = ACTIONS(2056),
    [anon_sym_enum] = ACTIONS(2056),
    [anon_sym_fn] = ACTIONS(2056),
    [anon_sym_for] = ACTIONS(2056),
    [anon_sym_if] = ACTIONS(2056),
    [anon_sym_impl] = ACTIONS(2056),
    [anon_sym_let] = ACTIONS(2056),
    [anon_sym_loop] = ACTIONS(2056),
    [anon_sym_match] = ACTIONS(2056),
    [anon_sym_mod] = ACTIONS(2056),
    [anon_sym_pub] = ACTIONS(2056),
    [anon_sym_return] = ACTIONS(2056),
    [anon_sym_static] = ACTIONS(2056),
    [anon_sym_struct] = ACTIONS(2056),
    [anon_sym_trait] = ACTIONS(2056),
    [anon_sym_type] = ACTIONS(2056),
    [anon_sym_union] = ACTIONS(2056),
    [anon_sym_unsafe] = ACTIONS(2056),
    [anon_sym_use] = ACTIONS(2056),
    [anon_sym_while] = ACTIONS(2056),
    [anon_sym_extern] = ACTIONS(2056),
    [anon_sym_yield] = ACTIONS(2056),
    [anon_sym_move] = ACTIONS(2056),
    [anon_sym_try] = ACTIONS(2056),
    [sym_integer_literal] = ACTIONS(2054),
    [aux_sym_string_literal_token1] = ACTIONS(2054),
    [sym_char_literal] = ACTIONS(2054),
    [anon_sym_true] = ACTIONS(2056),
    [anon_sym_false] = ACTIONS(2056),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2056),
    [sym_super] = ACTIONS(2056),
    [sym_crate] = ACTIONS(2056),
    [sym_metavariable] = ACTIONS(2054),
    [sym__raw_string_literal_start] = ACTIONS(2054),
    [sym_float_literal] = ACTIONS(2054),
  },
  [552] = {
    [sym_line_comment] = STATE(552),
    [sym_block_comment] = STATE(552),
    [ts_builtin_sym_end] = ACTIONS(2058),
    [sym_identifier] = ACTIONS(2060),
    [anon_sym_SEMI] = ACTIONS(2058),
    [anon_sym_macro_rules_BANG] = ACTIONS(2058),
    [anon_sym_LPAREN] = ACTIONS(2058),
    [anon_sym_LBRACK] = ACTIONS(2058),
    [anon_sym_LBRACE] = ACTIONS(2058),
    [anon_sym_RBRACE] = ACTIONS(2058),
    [anon_sym_STAR] = ACTIONS(2058),
    [anon_sym_u8] = ACTIONS(2060),
    [anon_sym_i8] = ACTIONS(2060),
    [anon_sym_u16] = ACTIONS(2060),
    [anon_sym_i16] = ACTIONS(2060),
    [anon_sym_u32] = ACTIONS(2060),
    [anon_sym_i32] = ACTIONS(2060),
    [anon_sym_u64] = ACTIONS(2060),
    [anon_sym_i64] = ACTIONS(2060),
    [anon_sym_u128] = ACTIONS(2060),
    [anon_sym_i128] = ACTIONS(2060),
    [anon_sym_isize] = ACTIONS(2060),
    [anon_sym_usize] = ACTIONS(2060),
    [anon_sym_f32] = ACTIONS(2060),
    [anon_sym_f64] = ACTIONS(2060),
    [anon_sym_bool] = ACTIONS(2060),
    [anon_sym_str] = ACTIONS(2060),
    [anon_sym_char] = ACTIONS(2060),
    [anon_sym_DASH] = ACTIONS(2058),
    [anon_sym_BANG] = ACTIONS(2058),
    [anon_sym_AMP] = ACTIONS(2058),
    [anon_sym_PIPE] = ACTIONS(2058),
    [anon_sym_LT] = ACTIONS(2058),
    [anon_sym_DOT_DOT] = ACTIONS(2058),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_POUND] = ACTIONS(2058),
    [anon_sym_SQUOTE] = ACTIONS(2060),
    [anon_sym_async] = ACTIONS(2060),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_const] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2060),
    [anon_sym_default] = ACTIONS(2060),
    [anon_sym_enum] = ACTIONS(2060),
    [anon_sym_fn] = ACTIONS(2060),
    [anon_sym_for] = ACTIONS(2060),
    [anon_sym_if] = ACTIONS(2060),
    [anon_sym_impl] = ACTIONS(2060),
    [anon_sym_let] = ACTIONS(2060),
    [anon_sym_loop] = ACTIONS(2060),
    [anon_sym_match] = ACTIONS(2060),
    [anon_sym_mod] = ACTIONS(2060),
    [anon_sym_pub] = ACTIONS(2060),
    [anon_sym_return] = ACTIONS(2060),
    [anon_sym_static] = ACTIONS(2060),
    [anon_sym_struct] = ACTIONS(2060),
    [anon_sym_trait] = ACTIONS(2060),
    [anon_sym_type] = ACTIONS(2060),
    [anon_sym_union] = ACTIONS(2060),
    [anon_sym_unsafe] = ACTIONS(2060),
    [anon_sym_use] = ACTIONS(2060),
    [anon_sym_while] = ACTIONS(2060),
    [anon_sym_extern] = ACTIONS(2060),
    [anon_sym_yield] = ACTIONS(2060),
    [anon_sym_move] = ACTIONS(2060),
    [anon_sym_try] = ACTIONS(2060),
    [sym_integer_literal] = ACTIONS(2058),
    [aux_sym_string_literal_token1] = ACTIONS(2058),
    [sym_char_literal] = ACTIONS(2058),
    [anon_sym_true] = ACTIONS(2060),
    [anon_sym_false] = ACTIONS(2060),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2060),
    [sym_super] = ACTIONS(2060),
    [sym_crate] = ACTIONS(2060),
    [sym_metavariable] = ACTIONS(2058),
    [sym__raw_string_literal_start] = ACTIONS(2058),
    [sym_float_literal] = ACTIONS(2058),
  },
  [553] = {
    [sym_line_comment] = STATE(553),
    [sym_block_comment] = STATE(553),
    [ts_builtin_sym_end] = ACTIONS(2062),
    [sym_identifier] = ACTIONS(2064),
    [anon_sym_SEMI] = ACTIONS(2062),
    [anon_sym_macro_rules_BANG] = ACTIONS(2062),
    [anon_sym_LPAREN] = ACTIONS(2062),
    [anon_sym_LBRACK] = ACTIONS(2062),
    [anon_sym_LBRACE] = ACTIONS(2062),
    [anon_sym_RBRACE] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(2062),
    [anon_sym_u8] = ACTIONS(2064),
    [anon_sym_i8] = ACTIONS(2064),
    [anon_sym_u16] = ACTIONS(2064),
    [anon_sym_i16] = ACTIONS(2064),
    [anon_sym_u32] = ACTIONS(2064),
    [anon_sym_i32] = ACTIONS(2064),
    [anon_sym_u64] = ACTIONS(2064),
    [anon_sym_i64] = ACTIONS(2064),
    [anon_sym_u128] = ACTIONS(2064),
    [anon_sym_i128] = ACTIONS(2064),
    [anon_sym_isize] = ACTIONS(2064),
    [anon_sym_usize] = ACTIONS(2064),
    [anon_sym_f32] = ACTIONS(2064),
    [anon_sym_f64] = ACTIONS(2064),
    [anon_sym_bool] = ACTIONS(2064),
    [anon_sym_str] = ACTIONS(2064),
    [anon_sym_char] = ACTIONS(2064),
    [anon_sym_DASH] = ACTIONS(2062),
    [anon_sym_BANG] = ACTIONS(2062),
    [anon_sym_AMP] = ACTIONS(2062),
    [anon_sym_PIPE] = ACTIONS(2062),
    [anon_sym_LT] = ACTIONS(2062),
    [anon_sym_DOT_DOT] = ACTIONS(2062),
    [anon_sym_COLON_COLON] = ACTIONS(2062),
    [anon_sym_POUND] = ACTIONS(2062),
    [anon_sym_SQUOTE] = ACTIONS(2064),
    [anon_sym_async] = ACTIONS(2064),
    [anon_sym_break] = ACTIONS(2064),
    [anon_sym_const] = ACTIONS(2064),
    [anon_sym_continue] = ACTIONS(2064),
    [anon_sym_default] = ACTIONS(2064),
    [anon_sym_enum] = ACTIONS(2064),
    [anon_sym_fn] = ACTIONS(2064),
    [anon_sym_for] = ACTIONS(2064),
    [anon_sym_if] = ACTIONS(2064),
    [anon_sym_impl] = ACTIONS(2064),
    [anon_sym_let] = ACTIONS(2064),
    [anon_sym_loop] = ACTIONS(2064),
    [anon_sym_match] = ACTIONS(2064),
    [anon_sym_mod] = ACTIONS(2064),
    [anon_sym_pub] = ACTIONS(2064),
    [anon_sym_return] = ACTIONS(2064),
    [anon_sym_static] = ACTIONS(2064),
    [anon_sym_struct] = ACTIONS(2064),
    [anon_sym_trait] = ACTIONS(2064),
    [anon_sym_type] = ACTIONS(2064),
    [anon_sym_union] = ACTIONS(2064),
    [anon_sym_unsafe] = ACTIONS(2064),
    [anon_sym_use] = ACTIONS(2064),
    [anon_sym_while] = ACTIONS(2064),
    [anon_sym_extern] = ACTIONS(2064),
    [anon_sym_yield] = ACTIONS(2064),
    [anon_sym_move] = ACTIONS(2064),
    [anon_sym_try] = ACTIONS(2064),
    [sym_integer_literal] = ACTIONS(2062),
    [aux_sym_string_literal_token1] = ACTIONS(2062),
    [sym_char_literal] = ACTIONS(2062),
    [anon_sym_true] = ACTIONS(2064),
    [anon_sym_false] = ACTIONS(2064),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2064),
    [sym_super] = ACTIONS(2064),
    [sym_crate] = ACTIONS(2064),
    [sym_metavariable] = ACTIONS(2062),
    [sym__raw_string_literal_start] = ACTIONS(2062),
    [sym_float_literal] = ACTIONS(2062),
  },
  [554] = {
    [sym_line_comment] = STATE(554),
    [sym_block_comment] = STATE(554),
    [ts_builtin_sym_end] = ACTIONS(2066),
    [sym_identifier] = ACTIONS(2068),
    [anon_sym_SEMI] = ACTIONS(2066),
    [anon_sym_macro_rules_BANG] = ACTIONS(2066),
    [anon_sym_LPAREN] = ACTIONS(2066),
    [anon_sym_LBRACK] = ACTIONS(2066),
    [anon_sym_LBRACE] = ACTIONS(2066),
    [anon_sym_RBRACE] = ACTIONS(2066),
    [anon_sym_STAR] = ACTIONS(2066),
    [anon_sym_u8] = ACTIONS(2068),
    [anon_sym_i8] = ACTIONS(2068),
    [anon_sym_u16] = ACTIONS(2068),
    [anon_sym_i16] = ACTIONS(2068),
    [anon_sym_u32] = ACTIONS(2068),
    [anon_sym_i32] = ACTIONS(2068),
    [anon_sym_u64] = ACTIONS(2068),
    [anon_sym_i64] = ACTIONS(2068),
    [anon_sym_u128] = ACTIONS(2068),
    [anon_sym_i128] = ACTIONS(2068),
    [anon_sym_isize] = ACTIONS(2068),
    [anon_sym_usize] = ACTIONS(2068),
    [anon_sym_f32] = ACTIONS(2068),
    [anon_sym_f64] = ACTIONS(2068),
    [anon_sym_bool] = ACTIONS(2068),
    [anon_sym_str] = ACTIONS(2068),
    [anon_sym_char] = ACTIONS(2068),
    [anon_sym_DASH] = ACTIONS(2066),
    [anon_sym_BANG] = ACTIONS(2066),
    [anon_sym_AMP] = ACTIONS(2066),
    [anon_sym_PIPE] = ACTIONS(2066),
    [anon_sym_LT] = ACTIONS(2066),
    [anon_sym_DOT_DOT] = ACTIONS(2066),
    [anon_sym_COLON_COLON] = ACTIONS(2066),
    [anon_sym_POUND] = ACTIONS(2066),
    [anon_sym_SQUOTE] = ACTIONS(2068),
    [anon_sym_async] = ACTIONS(2068),
    [anon_sym_break] = ACTIONS(2068),
    [anon_sym_const] = ACTIONS(2068),
    [anon_sym_continue] = ACTIONS(2068),
    [anon_sym_default] = ACTIONS(2068),
    [anon_sym_enum] = ACTIONS(2068),
    [anon_sym_fn] = ACTIONS(2068),
    [anon_sym_for] = ACTIONS(2068),
    [anon_sym_if] = ACTIONS(2068),
    [anon_sym_impl] = ACTIONS(2068),
    [anon_sym_let] = ACTIONS(2068),
    [anon_sym_loop] = ACTIONS(2068),
    [anon_sym_match] = ACTIONS(2068),
    [anon_sym_mod] = ACTIONS(2068),
    [anon_sym_pub] = ACTIONS(2068),
    [anon_sym_return] = ACTIONS(2068),
    [anon_sym_static] = ACTIONS(2068),
    [anon_sym_struct] = ACTIONS(2068),
    [anon_sym_trait] = ACTIONS(2068),
    [anon_sym_type] = ACTIONS(2068),
    [anon_sym_union] = ACTIONS(2068),
    [anon_sym_unsafe] = ACTIONS(2068),
    [anon_sym_use] = ACTIONS(2068),
    [anon_sym_while] = ACTIONS(2068),
    [anon_sym_extern] = ACTIONS(2068),
    [anon_sym_yield] = ACTIONS(2068),
    [anon_sym_move] = ACTIONS(2068),
    [anon_sym_try] = ACTIONS(2068),
    [sym_integer_literal] = ACTIONS(2066),
    [aux_sym_string_literal_token1] = ACTIONS(2066),
    [sym_char_literal] = ACTIONS(2066),
    [anon_sym_true] = ACTIONS(2068),
    [anon_sym_false] = ACTIONS(2068),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2068),
    [sym_super] = ACTIONS(2068),
    [sym_crate] = ACTIONS(2068),
    [sym_metavariable] = ACTIONS(2066),
    [sym__raw_string_literal_start] = ACTIONS(2066),
    [sym_float_literal] = ACTIONS(2066),
  },
  [555] = {
    [sym_line_comment] = STATE(555),
    [sym_block_comment] = STATE(555),
    [ts_builtin_sym_end] = ACTIONS(2070),
    [sym_identifier] = ACTIONS(2072),
    [anon_sym_SEMI] = ACTIONS(2070),
    [anon_sym_macro_rules_BANG] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(2070),
    [anon_sym_LBRACK] = ACTIONS(2070),
    [anon_sym_LBRACE] = ACTIONS(2070),
    [anon_sym_RBRACE] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(2070),
    [anon_sym_u8] = ACTIONS(2072),
    [anon_sym_i8] = ACTIONS(2072),
    [anon_sym_u16] = ACTIONS(2072),
    [anon_sym_i16] = ACTIONS(2072),
    [anon_sym_u32] = ACTIONS(2072),
    [anon_sym_i32] = ACTIONS(2072),
    [anon_sym_u64] = ACTIONS(2072),
    [anon_sym_i64] = ACTIONS(2072),
    [anon_sym_u128] = ACTIONS(2072),
    [anon_sym_i128] = ACTIONS(2072),
    [anon_sym_isize] = ACTIONS(2072),
    [anon_sym_usize] = ACTIONS(2072),
    [anon_sym_f32] = ACTIONS(2072),
    [anon_sym_f64] = ACTIONS(2072),
    [anon_sym_bool] = ACTIONS(2072),
    [anon_sym_str] = ACTIONS(2072),
    [anon_sym_char] = ACTIONS(2072),
    [anon_sym_DASH] = ACTIONS(2070),
    [anon_sym_BANG] = ACTIONS(2070),
    [anon_sym_AMP] = ACTIONS(2070),
    [anon_sym_PIPE] = ACTIONS(2070),
    [anon_sym_LT] = ACTIONS(2070),
    [anon_sym_DOT_DOT] = ACTIONS(2070),
    [anon_sym_COLON_COLON] = ACTIONS(2070),
    [anon_sym_POUND] = ACTIONS(2070),
    [anon_sym_SQUOTE] = ACTIONS(2072),
    [anon_sym_async] = ACTIONS(2072),
    [anon_sym_break] = ACTIONS(2072),
    [anon_sym_const] = ACTIONS(2072),
    [anon_sym_continue] = ACTIONS(2072),
    [anon_sym_default] = ACTIONS(2072),
    [anon_sym_enum] = ACTIONS(2072),
    [anon_sym_fn] = ACTIONS(2072),
    [anon_sym_for] = ACTIONS(2072),
    [anon_sym_if] = ACTIONS(2072),
    [anon_sym_impl] = ACTIONS(2072),
    [anon_sym_let] = ACTIONS(2072),
    [anon_sym_loop] = ACTIONS(2072),
    [anon_sym_match] = ACTIONS(2072),
    [anon_sym_mod] = ACTIONS(2072),
    [anon_sym_pub] = ACTIONS(2072),
    [anon_sym_return] = ACTIONS(2072),
    [anon_sym_static] = ACTIONS(2072),
    [anon_sym_struct] = ACTIONS(2072),
    [anon_sym_trait] = ACTIONS(2072),
    [anon_sym_type] = ACTIONS(2072),
    [anon_sym_union] = ACTIONS(2072),
    [anon_sym_unsafe] = ACTIONS(2072),
    [anon_sym_use] = ACTIONS(2072),
    [anon_sym_while] = ACTIONS(2072),
    [anon_sym_extern] = ACTIONS(2072),
    [anon_sym_yield] = ACTIONS(2072),
    [anon_sym_move] = ACTIONS(2072),
    [anon_sym_try] = ACTIONS(2072),
    [sym_integer_literal] = ACTIONS(2070),
    [aux_sym_string_literal_token1] = ACTIONS(2070),
    [sym_char_literal] = ACTIONS(2070),
    [anon_sym_true] = ACTIONS(2072),
    [anon_sym_false] = ACTIONS(2072),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2072),
    [sym_super] = ACTIONS(2072),
    [sym_crate] = ACTIONS(2072),
    [sym_metavariable] = ACTIONS(2070),
    [sym__raw_string_literal_start] = ACTIONS(2070),
    [sym_float_literal] = ACTIONS(2070),
  },
  [556] = {
    [sym_line_comment] = STATE(556),
    [sym_block_comment] = STATE(556),
    [ts_builtin_sym_end] = ACTIONS(2074),
    [sym_identifier] = ACTIONS(2076),
    [anon_sym_SEMI] = ACTIONS(2074),
    [anon_sym_macro_rules_BANG] = ACTIONS(2074),
    [anon_sym_LPAREN] = ACTIONS(2074),
    [anon_sym_LBRACK] = ACTIONS(2074),
    [anon_sym_LBRACE] = ACTIONS(2074),
    [anon_sym_RBRACE] = ACTIONS(2074),
    [anon_sym_STAR] = ACTIONS(2074),
    [anon_sym_u8] = ACTIONS(2076),
    [anon_sym_i8] = ACTIONS(2076),
    [anon_sym_u16] = ACTIONS(2076),
    [anon_sym_i16] = ACTIONS(2076),
    [anon_sym_u32] = ACTIONS(2076),
    [anon_sym_i32] = ACTIONS(2076),
    [anon_sym_u64] = ACTIONS(2076),
    [anon_sym_i64] = ACTIONS(2076),
    [anon_sym_u128] = ACTIONS(2076),
    [anon_sym_i128] = ACTIONS(2076),
    [anon_sym_isize] = ACTIONS(2076),
    [anon_sym_usize] = ACTIONS(2076),
    [anon_sym_f32] = ACTIONS(2076),
    [anon_sym_f64] = ACTIONS(2076),
    [anon_sym_bool] = ACTIONS(2076),
    [anon_sym_str] = ACTIONS(2076),
    [anon_sym_char] = ACTIONS(2076),
    [anon_sym_DASH] = ACTIONS(2074),
    [anon_sym_BANG] = ACTIONS(2074),
    [anon_sym_AMP] = ACTIONS(2074),
    [anon_sym_PIPE] = ACTIONS(2074),
    [anon_sym_LT] = ACTIONS(2074),
    [anon_sym_DOT_DOT] = ACTIONS(2074),
    [anon_sym_COLON_COLON] = ACTIONS(2074),
    [anon_sym_POUND] = ACTIONS(2074),
    [anon_sym_SQUOTE] = ACTIONS(2076),
    [anon_sym_async] = ACTIONS(2076),
    [anon_sym_break] = ACTIONS(2076),
    [anon_sym_const] = ACTIONS(2076),
    [anon_sym_continue] = ACTIONS(2076),
    [anon_sym_default] = ACTIONS(2076),
    [anon_sym_enum] = ACTIONS(2076),
    [anon_sym_fn] = ACTIONS(2076),
    [anon_sym_for] = ACTIONS(2076),
    [anon_sym_if] = ACTIONS(2076),
    [anon_sym_impl] = ACTIONS(2076),
    [anon_sym_let] = ACTIONS(2076),
    [anon_sym_loop] = ACTIONS(2076),
    [anon_sym_match] = ACTIONS(2076),
    [anon_sym_mod] = ACTIONS(2076),
    [anon_sym_pub] = ACTIONS(2076),
    [anon_sym_return] = ACTIONS(2076),
    [anon_sym_static] = ACTIONS(2076),
    [anon_sym_struct] = ACTIONS(2076),
    [anon_sym_trait] = ACTIONS(2076),
    [anon_sym_type] = ACTIONS(2076),
    [anon_sym_union] = ACTIONS(2076),
    [anon_sym_unsafe] = ACTIONS(2076),
    [anon_sym_use] = ACTIONS(2076),
    [anon_sym_while] = ACTIONS(2076),
    [anon_sym_extern] = ACTIONS(2076),
    [anon_sym_yield] = ACTIONS(2076),
    [anon_sym_move] = ACTIONS(2076),
    [anon_sym_try] = ACTIONS(2076),
    [sym_integer_literal] = ACTIONS(2074),
    [aux_sym_string_literal_token1] = ACTIONS(2074),
    [sym_char_literal] = ACTIONS(2074),
    [anon_sym_true] = ACTIONS(2076),
    [anon_sym_false] = ACTIONS(2076),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2076),
    [sym_super] = ACTIONS(2076),
    [sym_crate] = ACTIONS(2076),
    [sym_metavariable] = ACTIONS(2074),
    [sym__raw_string_literal_start] = ACTIONS(2074),
    [sym_float_literal] = ACTIONS(2074),
  },
  [557] = {
    [sym_line_comment] = STATE(557),
    [sym_block_comment] = STATE(557),
    [ts_builtin_sym_end] = ACTIONS(2078),
    [sym_identifier] = ACTIONS(2080),
    [anon_sym_SEMI] = ACTIONS(2078),
    [anon_sym_macro_rules_BANG] = ACTIONS(2078),
    [anon_sym_LPAREN] = ACTIONS(2078),
    [anon_sym_LBRACK] = ACTIONS(2078),
    [anon_sym_LBRACE] = ACTIONS(2078),
    [anon_sym_RBRACE] = ACTIONS(2078),
    [anon_sym_STAR] = ACTIONS(2078),
    [anon_sym_u8] = ACTIONS(2080),
    [anon_sym_i8] = ACTIONS(2080),
    [anon_sym_u16] = ACTIONS(2080),
    [anon_sym_i16] = ACTIONS(2080),
    [anon_sym_u32] = ACTIONS(2080),
    [anon_sym_i32] = ACTIONS(2080),
    [anon_sym_u64] = ACTIONS(2080),
    [anon_sym_i64] = ACTIONS(2080),
    [anon_sym_u128] = ACTIONS(2080),
    [anon_sym_i128] = ACTIONS(2080),
    [anon_sym_isize] = ACTIONS(2080),
    [anon_sym_usize] = ACTIONS(2080),
    [anon_sym_f32] = ACTIONS(2080),
    [anon_sym_f64] = ACTIONS(2080),
    [anon_sym_bool] = ACTIONS(2080),
    [anon_sym_str] = ACTIONS(2080),
    [anon_sym_char] = ACTIONS(2080),
    [anon_sym_DASH] = ACTIONS(2078),
    [anon_sym_BANG] = ACTIONS(2078),
    [anon_sym_AMP] = ACTIONS(2078),
    [anon_sym_PIPE] = ACTIONS(2078),
    [anon_sym_LT] = ACTIONS(2078),
    [anon_sym_DOT_DOT] = ACTIONS(2078),
    [anon_sym_COLON_COLON] = ACTIONS(2078),
    [anon_sym_POUND] = ACTIONS(2078),
    [anon_sym_SQUOTE] = ACTIONS(2080),
    [anon_sym_async] = ACTIONS(2080),
    [anon_sym_break] = ACTIONS(2080),
    [anon_sym_const] = ACTIONS(2080),
    [anon_sym_continue] = ACTIONS(2080),
    [anon_sym_default] = ACTIONS(2080),
    [anon_sym_enum] = ACTIONS(2080),
    [anon_sym_fn] = ACTIONS(2080),
    [anon_sym_for] = ACTIONS(2080),
    [anon_sym_if] = ACTIONS(2080),
    [anon_sym_impl] = ACTIONS(2080),
    [anon_sym_let] = ACTIONS(2080),
    [anon_sym_loop] = ACTIONS(2080),
    [anon_sym_match] = ACTIONS(2080),
    [anon_sym_mod] = ACTIONS(2080),
    [anon_sym_pub] = ACTIONS(2080),
    [anon_sym_return] = ACTIONS(2080),
    [anon_sym_static] = ACTIONS(2080),
    [anon_sym_struct] = ACTIONS(2080),
    [anon_sym_trait] = ACTIONS(2080),
    [anon_sym_type] = ACTIONS(2080),
    [anon_sym_union] = ACTIONS(2080),
    [anon_sym_unsafe] = ACTIONS(2080),
    [anon_sym_use] = ACTIONS(2080),
    [anon_sym_while] = ACTIONS(2080),
    [anon_sym_extern] = ACTIONS(2080),
    [anon_sym_yield] = ACTIONS(2080),
    [anon_sym_move] = ACTIONS(2080),
    [anon_sym_try] = ACTIONS(2080),
    [sym_integer_literal] = ACTIONS(2078),
    [aux_sym_string_literal_token1] = ACTIONS(2078),
    [sym_char_literal] = ACTIONS(2078),
    [anon_sym_true] = ACTIONS(2080),
    [anon_sym_false] = ACTIONS(2080),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2080),
    [sym_super] = ACTIONS(2080),
    [sym_crate] = ACTIONS(2080),
    [sym_metavariable] = ACTIONS(2078),
    [sym__raw_string_literal_start] = ACTIONS(2078),
    [sym_float_literal] = ACTIONS(2078),
  },
  [558] = {
    [sym_line_comment] = STATE(558),
    [sym_block_comment] = STATE(558),
    [ts_builtin_sym_end] = ACTIONS(2082),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_SEMI] = ACTIONS(2082),
    [anon_sym_macro_rules_BANG] = ACTIONS(2082),
    [anon_sym_LPAREN] = ACTIONS(2082),
    [anon_sym_LBRACK] = ACTIONS(2082),
    [anon_sym_LBRACE] = ACTIONS(2082),
    [anon_sym_RBRACE] = ACTIONS(2082),
    [anon_sym_STAR] = ACTIONS(2082),
    [anon_sym_u8] = ACTIONS(2084),
    [anon_sym_i8] = ACTIONS(2084),
    [anon_sym_u16] = ACTIONS(2084),
    [anon_sym_i16] = ACTIONS(2084),
    [anon_sym_u32] = ACTIONS(2084),
    [anon_sym_i32] = ACTIONS(2084),
    [anon_sym_u64] = ACTIONS(2084),
    [anon_sym_i64] = ACTIONS(2084),
    [anon_sym_u128] = ACTIONS(2084),
    [anon_sym_i128] = ACTIONS(2084),
    [anon_sym_isize] = ACTIONS(2084),
    [anon_sym_usize] = ACTIONS(2084),
    [anon_sym_f32] = ACTIONS(2084),
    [anon_sym_f64] = ACTIONS(2084),
    [anon_sym_bool] = ACTIONS(2084),
    [anon_sym_str] = ACTIONS(2084),
    [anon_sym_char] = ACTIONS(2084),
    [anon_sym_DASH] = ACTIONS(2082),
    [anon_sym_BANG] = ACTIONS(2082),
    [anon_sym_AMP] = ACTIONS(2082),
    [anon_sym_PIPE] = ACTIONS(2082),
    [anon_sym_LT] = ACTIONS(2082),
    [anon_sym_DOT_DOT] = ACTIONS(2082),
    [anon_sym_COLON_COLON] = ACTIONS(2082),
    [anon_sym_POUND] = ACTIONS(2082),
    [anon_sym_SQUOTE] = ACTIONS(2084),
    [anon_sym_async] = ACTIONS(2084),
    [anon_sym_break] = ACTIONS(2084),
    [anon_sym_const] = ACTIONS(2084),
    [anon_sym_continue] = ACTIONS(2084),
    [anon_sym_default] = ACTIONS(2084),
    [anon_sym_enum] = ACTIONS(2084),
    [anon_sym_fn] = ACTIONS(2084),
    [anon_sym_for] = ACTIONS(2084),
    [anon_sym_if] = ACTIONS(2084),
    [anon_sym_impl] = ACTIONS(2084),
    [anon_sym_let] = ACTIONS(2084),
    [anon_sym_loop] = ACTIONS(2084),
    [anon_sym_match] = ACTIONS(2084),
    [anon_sym_mod] = ACTIONS(2084),
    [anon_sym_pub] = ACTIONS(2084),
    [anon_sym_return] = ACTIONS(2084),
    [anon_sym_static] = ACTIONS(2084),
    [anon_sym_struct] = ACTIONS(2084),
    [anon_sym_trait] = ACTIONS(2084),
    [anon_sym_type] = ACTIONS(2084),
    [anon_sym_union] = ACTIONS(2084),
    [anon_sym_unsafe] = ACTIONS(2084),
    [anon_sym_use] = ACTIONS(2084),
    [anon_sym_while] = ACTIONS(2084),
    [anon_sym_extern] = ACTIONS(2084),
    [anon_sym_yield] = ACTIONS(2084),
    [anon_sym_move] = ACTIONS(2084),
    [anon_sym_try] = ACTIONS(2084),
    [sym_integer_literal] = ACTIONS(2082),
    [aux_sym_string_literal_token1] = ACTIONS(2082),
    [sym_char_literal] = ACTIONS(2082),
    [anon_sym_true] = ACTIONS(2084),
    [anon_sym_false] = ACTIONS(2084),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2084),
    [sym_super] = ACTIONS(2084),
    [sym_crate] = ACTIONS(2084),
    [sym_metavariable] = ACTIONS(2082),
    [sym__raw_string_literal_start] = ACTIONS(2082),
    [sym_float_literal] = ACTIONS(2082),
  },
  [559] = {
    [sym_line_comment] = STATE(559),
    [sym_block_comment] = STATE(559),
    [ts_builtin_sym_end] = ACTIONS(2086),
    [sym_identifier] = ACTIONS(2088),
    [anon_sym_SEMI] = ACTIONS(2086),
    [anon_sym_macro_rules_BANG] = ACTIONS(2086),
    [anon_sym_LPAREN] = ACTIONS(2086),
    [anon_sym_LBRACK] = ACTIONS(2086),
    [anon_sym_LBRACE] = ACTIONS(2086),
    [anon_sym_RBRACE] = ACTIONS(2086),
    [anon_sym_STAR] = ACTIONS(2086),
    [anon_sym_u8] = ACTIONS(2088),
    [anon_sym_i8] = ACTIONS(2088),
    [anon_sym_u16] = ACTIONS(2088),
    [anon_sym_i16] = ACTIONS(2088),
    [anon_sym_u32] = ACTIONS(2088),
    [anon_sym_i32] = ACTIONS(2088),
    [anon_sym_u64] = ACTIONS(2088),
    [anon_sym_i64] = ACTIONS(2088),
    [anon_sym_u128] = ACTIONS(2088),
    [anon_sym_i128] = ACTIONS(2088),
    [anon_sym_isize] = ACTIONS(2088),
    [anon_sym_usize] = ACTIONS(2088),
    [anon_sym_f32] = ACTIONS(2088),
    [anon_sym_f64] = ACTIONS(2088),
    [anon_sym_bool] = ACTIONS(2088),
    [anon_sym_str] = ACTIONS(2088),
    [anon_sym_char] = ACTIONS(2088),
    [anon_sym_DASH] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(2086),
    [anon_sym_AMP] = ACTIONS(2086),
    [anon_sym_PIPE] = ACTIONS(2086),
    [anon_sym_LT] = ACTIONS(2086),
    [anon_sym_DOT_DOT] = ACTIONS(2086),
    [anon_sym_COLON_COLON] = ACTIONS(2086),
    [anon_sym_POUND] = ACTIONS(2086),
    [anon_sym_SQUOTE] = ACTIONS(2088),
    [anon_sym_async] = ACTIONS(2088),
    [anon_sym_break] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(2088),
    [anon_sym_continue] = ACTIONS(2088),
    [anon_sym_default] = ACTIONS(2088),
    [anon_sym_enum] = ACTIONS(2088),
    [anon_sym_fn] = ACTIONS(2088),
    [anon_sym_for] = ACTIONS(2088),
    [anon_sym_if] = ACTIONS(2088),
    [anon_sym_impl] = ACTIONS(2088),
    [anon_sym_let] = ACTIONS(2088),
    [anon_sym_loop] = ACTIONS(2088),
    [anon_sym_match] = ACTIONS(2088),
    [anon_sym_mod] = ACTIONS(2088),
    [anon_sym_pub] = ACTIONS(2088),
    [anon_sym_return] = ACTIONS(2088),
    [anon_sym_static] = ACTIONS(2088),
    [anon_sym_struct] = ACTIONS(2088),
    [anon_sym_trait] = ACTIONS(2088),
    [anon_sym_type] = ACTIONS(2088),
    [anon_sym_union] = ACTIONS(2088),
    [anon_sym_unsafe] = ACTIONS(2088),
    [anon_sym_use] = ACTIONS(2088),
    [anon_sym_while] = ACTIONS(2088),
    [anon_sym_extern] = ACTIONS(2088),
    [anon_sym_yield] = ACTIONS(2088),
    [anon_sym_move] = ACTIONS(2088),
    [anon_sym_try] = ACTIONS(2088),
    [sym_integer_literal] = ACTIONS(2086),
    [aux_sym_string_literal_token1] = ACTIONS(2086),
    [sym_char_literal] = ACTIONS(2086),
    [anon_sym_true] = ACTIONS(2088),
    [anon_sym_false] = ACTIONS(2088),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2088),
    [sym_super] = ACTIONS(2088),
    [sym_crate] = ACTIONS(2088),
    [sym_metavariable] = ACTIONS(2086),
    [sym__raw_string_literal_start] = ACTIONS(2086),
    [sym_float_literal] = ACTIONS(2086),
  },
  [560] = {
    [sym_line_comment] = STATE(560),
    [sym_block_comment] = STATE(560),
    [ts_builtin_sym_end] = ACTIONS(2090),
    [sym_identifier] = ACTIONS(2092),
    [anon_sym_SEMI] = ACTIONS(2090),
    [anon_sym_macro_rules_BANG] = ACTIONS(2090),
    [anon_sym_LPAREN] = ACTIONS(2090),
    [anon_sym_LBRACK] = ACTIONS(2090),
    [anon_sym_LBRACE] = ACTIONS(2090),
    [anon_sym_RBRACE] = ACTIONS(2090),
    [anon_sym_STAR] = ACTIONS(2090),
    [anon_sym_u8] = ACTIONS(2092),
    [anon_sym_i8] = ACTIONS(2092),
    [anon_sym_u16] = ACTIONS(2092),
    [anon_sym_i16] = ACTIONS(2092),
    [anon_sym_u32] = ACTIONS(2092),
    [anon_sym_i32] = ACTIONS(2092),
    [anon_sym_u64] = ACTIONS(2092),
    [anon_sym_i64] = ACTIONS(2092),
    [anon_sym_u128] = ACTIONS(2092),
    [anon_sym_i128] = ACTIONS(2092),
    [anon_sym_isize] = ACTIONS(2092),
    [anon_sym_usize] = ACTIONS(2092),
    [anon_sym_f32] = ACTIONS(2092),
    [anon_sym_f64] = ACTIONS(2092),
    [anon_sym_bool] = ACTIONS(2092),
    [anon_sym_str] = ACTIONS(2092),
    [anon_sym_char] = ACTIONS(2092),
    [anon_sym_DASH] = ACTIONS(2090),
    [anon_sym_BANG] = ACTIONS(2090),
    [anon_sym_AMP] = ACTIONS(2090),
    [anon_sym_PIPE] = ACTIONS(2090),
    [anon_sym_LT] = ACTIONS(2090),
    [anon_sym_DOT_DOT] = ACTIONS(2090),
    [anon_sym_COLON_COLON] = ACTIONS(2090),
    [anon_sym_POUND] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2092),
    [anon_sym_async] = ACTIONS(2092),
    [anon_sym_break] = ACTIONS(2092),
    [anon_sym_const] = ACTIONS(2092),
    [anon_sym_continue] = ACTIONS(2092),
    [anon_sym_default] = ACTIONS(2092),
    [anon_sym_enum] = ACTIONS(2092),
    [anon_sym_fn] = ACTIONS(2092),
    [anon_sym_for] = ACTIONS(2092),
    [anon_sym_if] = ACTIONS(2092),
    [anon_sym_impl] = ACTIONS(2092),
    [anon_sym_let] = ACTIONS(2092),
    [anon_sym_loop] = ACTIONS(2092),
    [anon_sym_match] = ACTIONS(2092),
    [anon_sym_mod] = ACTIONS(2092),
    [anon_sym_pub] = ACTIONS(2092),
    [anon_sym_return] = ACTIONS(2092),
    [anon_sym_static] = ACTIONS(2092),
    [anon_sym_struct] = ACTIONS(2092),
    [anon_sym_trait] = ACTIONS(2092),
    [anon_sym_type] = ACTIONS(2092),
    [anon_sym_union] = ACTIONS(2092),
    [anon_sym_unsafe] = ACTIONS(2092),
    [anon_sym_use] = ACTIONS(2092),
    [anon_sym_while] = ACTIONS(2092),
    [anon_sym_extern] = ACTIONS(2092),
    [anon_sym_yield] = ACTIONS(2092),
    [anon_sym_move] = ACTIONS(2092),
    [anon_sym_try] = ACTIONS(2092),
    [sym_integer_literal] = ACTIONS(2090),
    [aux_sym_string_literal_token1] = ACTIONS(2090),
    [sym_char_literal] = ACTIONS(2090),
    [anon_sym_true] = ACTIONS(2092),
    [anon_sym_false] = ACTIONS(2092),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2092),
    [sym_super] = ACTIONS(2092),
    [sym_crate] = ACTIONS(2092),
    [sym_metavariable] = ACTIONS(2090),
    [sym__raw_string_literal_start] = ACTIONS(2090),
    [sym_float_literal] = ACTIONS(2090),
  },
  [561] = {
    [sym_line_comment] = STATE(561),
    [sym_block_comment] = STATE(561),
    [ts_builtin_sym_end] = ACTIONS(2094),
    [sym_identifier] = ACTIONS(2096),
    [anon_sym_SEMI] = ACTIONS(2094),
    [anon_sym_macro_rules_BANG] = ACTIONS(2094),
    [anon_sym_LPAREN] = ACTIONS(2094),
    [anon_sym_LBRACK] = ACTIONS(2094),
    [anon_sym_LBRACE] = ACTIONS(2094),
    [anon_sym_RBRACE] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(2094),
    [anon_sym_u8] = ACTIONS(2096),
    [anon_sym_i8] = ACTIONS(2096),
    [anon_sym_u16] = ACTIONS(2096),
    [anon_sym_i16] = ACTIONS(2096),
    [anon_sym_u32] = ACTIONS(2096),
    [anon_sym_i32] = ACTIONS(2096),
    [anon_sym_u64] = ACTIONS(2096),
    [anon_sym_i64] = ACTIONS(2096),
    [anon_sym_u128] = ACTIONS(2096),
    [anon_sym_i128] = ACTIONS(2096),
    [anon_sym_isize] = ACTIONS(2096),
    [anon_sym_usize] = ACTIONS(2096),
    [anon_sym_f32] = ACTIONS(2096),
    [anon_sym_f64] = ACTIONS(2096),
    [anon_sym_bool] = ACTIONS(2096),
    [anon_sym_str] = ACTIONS(2096),
    [anon_sym_char] = ACTIONS(2096),
    [anon_sym_DASH] = ACTIONS(2094),
    [anon_sym_BANG] = ACTIONS(2094),
    [anon_sym_AMP] = ACTIONS(2094),
    [anon_sym_PIPE] = ACTIONS(2094),
    [anon_sym_LT] = ACTIONS(2094),
    [anon_sym_DOT_DOT] = ACTIONS(2094),
    [anon_sym_COLON_COLON] = ACTIONS(2094),
    [anon_sym_POUND] = ACTIONS(2094),
    [anon_sym_SQUOTE] = ACTIONS(2096),
    [anon_sym_async] = ACTIONS(2096),
    [anon_sym_break] = ACTIONS(2096),
    [anon_sym_const] = ACTIONS(2096),
    [anon_sym_continue] = ACTIONS(2096),
    [anon_sym_default] = ACTIONS(2096),
    [anon_sym_enum] = ACTIONS(2096),
    [anon_sym_fn] = ACTIONS(2096),
    [anon_sym_for] = ACTIONS(2096),
    [anon_sym_if] = ACTIONS(2096),
    [anon_sym_impl] = ACTIONS(2096),
    [anon_sym_let] = ACTIONS(2096),
    [anon_sym_loop] = ACTIONS(2096),
    [anon_sym_match] = ACTIONS(2096),
    [anon_sym_mod] = ACTIONS(2096),
    [anon_sym_pub] = ACTIONS(2096),
    [anon_sym_return] = ACTIONS(2096),
    [anon_sym_static] = ACTIONS(2096),
    [anon_sym_struct] = ACTIONS(2096),
    [anon_sym_trait] = ACTIONS(2096),
    [anon_sym_type] = ACTIONS(2096),
    [anon_sym_union] = ACTIONS(2096),
    [anon_sym_unsafe] = ACTIONS(2096),
    [anon_sym_use] = ACTIONS(2096),
    [anon_sym_while] = ACTIONS(2096),
    [anon_sym_extern] = ACTIONS(2096),
    [anon_sym_yield] = ACTIONS(2096),
    [anon_sym_move] = ACTIONS(2096),
    [anon_sym_try] = ACTIONS(2096),
    [sym_integer_literal] = ACTIONS(2094),
    [aux_sym_string_literal_token1] = ACTIONS(2094),
    [sym_char_literal] = ACTIONS(2094),
    [anon_sym_true] = ACTIONS(2096),
    [anon_sym_false] = ACTIONS(2096),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2096),
    [sym_super] = ACTIONS(2096),
    [sym_crate] = ACTIONS(2096),
    [sym_metavariable] = ACTIONS(2094),
    [sym__raw_string_literal_start] = ACTIONS(2094),
    [sym_float_literal] = ACTIONS(2094),
  },
  [562] = {
    [sym_line_comment] = STATE(562),
    [sym_block_comment] = STATE(562),
    [ts_builtin_sym_end] = ACTIONS(2098),
    [sym_identifier] = ACTIONS(2100),
    [anon_sym_SEMI] = ACTIONS(2098),
    [anon_sym_macro_rules_BANG] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(2098),
    [anon_sym_LBRACK] = ACTIONS(2098),
    [anon_sym_LBRACE] = ACTIONS(2098),
    [anon_sym_RBRACE] = ACTIONS(2098),
    [anon_sym_STAR] = ACTIONS(2098),
    [anon_sym_u8] = ACTIONS(2100),
    [anon_sym_i8] = ACTIONS(2100),
    [anon_sym_u16] = ACTIONS(2100),
    [anon_sym_i16] = ACTIONS(2100),
    [anon_sym_u32] = ACTIONS(2100),
    [anon_sym_i32] = ACTIONS(2100),
    [anon_sym_u64] = ACTIONS(2100),
    [anon_sym_i64] = ACTIONS(2100),
    [anon_sym_u128] = ACTIONS(2100),
    [anon_sym_i128] = ACTIONS(2100),
    [anon_sym_isize] = ACTIONS(2100),
    [anon_sym_usize] = ACTIONS(2100),
    [anon_sym_f32] = ACTIONS(2100),
    [anon_sym_f64] = ACTIONS(2100),
    [anon_sym_bool] = ACTIONS(2100),
    [anon_sym_str] = ACTIONS(2100),
    [anon_sym_char] = ACTIONS(2100),
    [anon_sym_DASH] = ACTIONS(2098),
    [anon_sym_BANG] = ACTIONS(2098),
    [anon_sym_AMP] = ACTIONS(2098),
    [anon_sym_PIPE] = ACTIONS(2098),
    [anon_sym_LT] = ACTIONS(2098),
    [anon_sym_DOT_DOT] = ACTIONS(2098),
    [anon_sym_COLON_COLON] = ACTIONS(2098),
    [anon_sym_POUND] = ACTIONS(2098),
    [anon_sym_SQUOTE] = ACTIONS(2100),
    [anon_sym_async] = ACTIONS(2100),
    [anon_sym_break] = ACTIONS(2100),
    [anon_sym_const] = ACTIONS(2100),
    [anon_sym_continue] = ACTIONS(2100),
    [anon_sym_default] = ACTIONS(2100),
    [anon_sym_enum] = ACTIONS(2100),
    [anon_sym_fn] = ACTIONS(2100),
    [anon_sym_for] = ACTIONS(2100),
    [anon_sym_if] = ACTIONS(2100),
    [anon_sym_impl] = ACTIONS(2100),
    [anon_sym_let] = ACTIONS(2100),
    [anon_sym_loop] = ACTIONS(2100),
    [anon_sym_match] = ACTIONS(2100),
    [anon_sym_mod] = ACTIONS(2100),
    [anon_sym_pub] = ACTIONS(2100),
    [anon_sym_return] = ACTIONS(2100),
    [anon_sym_static] = ACTIONS(2100),
    [anon_sym_struct] = ACTIONS(2100),
    [anon_sym_trait] = ACTIONS(2100),
    [anon_sym_type] = ACTIONS(2100),
    [anon_sym_union] = ACTIONS(2100),
    [anon_sym_unsafe] = ACTIONS(2100),
    [anon_sym_use] = ACTIONS(2100),
    [anon_sym_while] = ACTIONS(2100),
    [anon_sym_extern] = ACTIONS(2100),
    [anon_sym_yield] = ACTIONS(2100),
    [anon_sym_move] = ACTIONS(2100),
    [anon_sym_try] = ACTIONS(2100),
    [sym_integer_literal] = ACTIONS(2098),
    [aux_sym_string_literal_token1] = ACTIONS(2098),
    [sym_char_literal] = ACTIONS(2098),
    [anon_sym_true] = ACTIONS(2100),
    [anon_sym_false] = ACTIONS(2100),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2100),
    [sym_super] = ACTIONS(2100),
    [sym_crate] = ACTIONS(2100),
    [sym_metavariable] = ACTIONS(2098),
    [sym__raw_string_literal_start] = ACTIONS(2098),
    [sym_float_literal] = ACTIONS(2098),
  },
  [563] = {
    [sym_line_comment] = STATE(563),
    [sym_block_comment] = STATE(563),
    [ts_builtin_sym_end] = ACTIONS(2102),
    [sym_identifier] = ACTIONS(2104),
    [anon_sym_SEMI] = ACTIONS(2102),
    [anon_sym_macro_rules_BANG] = ACTIONS(2102),
    [anon_sym_LPAREN] = ACTIONS(2102),
    [anon_sym_LBRACK] = ACTIONS(2102),
    [anon_sym_LBRACE] = ACTIONS(2102),
    [anon_sym_RBRACE] = ACTIONS(2102),
    [anon_sym_STAR] = ACTIONS(2102),
    [anon_sym_u8] = ACTIONS(2104),
    [anon_sym_i8] = ACTIONS(2104),
    [anon_sym_u16] = ACTIONS(2104),
    [anon_sym_i16] = ACTIONS(2104),
    [anon_sym_u32] = ACTIONS(2104),
    [anon_sym_i32] = ACTIONS(2104),
    [anon_sym_u64] = ACTIONS(2104),
    [anon_sym_i64] = ACTIONS(2104),
    [anon_sym_u128] = ACTIONS(2104),
    [anon_sym_i128] = ACTIONS(2104),
    [anon_sym_isize] = ACTIONS(2104),
    [anon_sym_usize] = ACTIONS(2104),
    [anon_sym_f32] = ACTIONS(2104),
    [anon_sym_f64] = ACTIONS(2104),
    [anon_sym_bool] = ACTIONS(2104),
    [anon_sym_str] = ACTIONS(2104),
    [anon_sym_char] = ACTIONS(2104),
    [anon_sym_DASH] = ACTIONS(2102),
    [anon_sym_BANG] = ACTIONS(2102),
    [anon_sym_AMP] = ACTIONS(2102),
    [anon_sym_PIPE] = ACTIONS(2102),
    [anon_sym_LT] = ACTIONS(2102),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_COLON_COLON] = ACTIONS(2102),
    [anon_sym_POUND] = ACTIONS(2102),
    [anon_sym_SQUOTE] = ACTIONS(2104),
    [anon_sym_async] = ACTIONS(2104),
    [anon_sym_break] = ACTIONS(2104),
    [anon_sym_const] = ACTIONS(2104),
    [anon_sym_continue] = ACTIONS(2104),
    [anon_sym_default] = ACTIONS(2104),
    [anon_sym_enum] = ACTIONS(2104),
    [anon_sym_fn] = ACTIONS(2104),
    [anon_sym_for] = ACTIONS(2104),
    [anon_sym_if] = ACTIONS(2104),
    [anon_sym_impl] = ACTIONS(2104),
    [anon_sym_let] = ACTIONS(2104),
    [anon_sym_loop] = ACTIONS(2104),
    [anon_sym_match] = ACTIONS(2104),
    [anon_sym_mod] = ACTIONS(2104),
    [anon_sym_pub] = ACTIONS(2104),
    [anon_sym_return] = ACTIONS(2104),
    [anon_sym_static] = ACTIONS(2104),
    [anon_sym_struct] = ACTIONS(2104),
    [anon_sym_trait] = ACTIONS(2104),
    [anon_sym_type] = ACTIONS(2104),
    [anon_sym_union] = ACTIONS(2104),
    [anon_sym_unsafe] = ACTIONS(2104),
    [anon_sym_use] = ACTIONS(2104),
    [anon_sym_while] = ACTIONS(2104),
    [anon_sym_extern] = ACTIONS(2104),
    [anon_sym_yield] = ACTIONS(2104),
    [anon_sym_move] = ACTIONS(2104),
    [anon_sym_try] = ACTIONS(2104),
    [sym_integer_literal] = ACTIONS(2102),
    [aux_sym_string_literal_token1] = ACTIONS(2102),
    [sym_char_literal] = ACTIONS(2102),
    [anon_sym_true] = ACTIONS(2104),
    [anon_sym_false] = ACTIONS(2104),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2104),
    [sym_super] = ACTIONS(2104),
    [sym_crate] = ACTIONS(2104),
    [sym_metavariable] = ACTIONS(2102),
    [sym__raw_string_literal_start] = ACTIONS(2102),
    [sym_float_literal] = ACTIONS(2102),
  },
  [564] = {
    [sym_line_comment] = STATE(564),
    [sym_block_comment] = STATE(564),
    [ts_builtin_sym_end] = ACTIONS(2106),
    [sym_identifier] = ACTIONS(2108),
    [anon_sym_SEMI] = ACTIONS(2106),
    [anon_sym_macro_rules_BANG] = ACTIONS(2106),
    [anon_sym_LPAREN] = ACTIONS(2106),
    [anon_sym_LBRACK] = ACTIONS(2106),
    [anon_sym_LBRACE] = ACTIONS(2106),
    [anon_sym_RBRACE] = ACTIONS(2106),
    [anon_sym_STAR] = ACTIONS(2106),
    [anon_sym_u8] = ACTIONS(2108),
    [anon_sym_i8] = ACTIONS(2108),
    [anon_sym_u16] = ACTIONS(2108),
    [anon_sym_i16] = ACTIONS(2108),
    [anon_sym_u32] = ACTIONS(2108),
    [anon_sym_i32] = ACTIONS(2108),
    [anon_sym_u64] = ACTIONS(2108),
    [anon_sym_i64] = ACTIONS(2108),
    [anon_sym_u128] = ACTIONS(2108),
    [anon_sym_i128] = ACTIONS(2108),
    [anon_sym_isize] = ACTIONS(2108),
    [anon_sym_usize] = ACTIONS(2108),
    [anon_sym_f32] = ACTIONS(2108),
    [anon_sym_f64] = ACTIONS(2108),
    [anon_sym_bool] = ACTIONS(2108),
    [anon_sym_str] = ACTIONS(2108),
    [anon_sym_char] = ACTIONS(2108),
    [anon_sym_DASH] = ACTIONS(2106),
    [anon_sym_BANG] = ACTIONS(2106),
    [anon_sym_AMP] = ACTIONS(2106),
    [anon_sym_PIPE] = ACTIONS(2106),
    [anon_sym_LT] = ACTIONS(2106),
    [anon_sym_DOT_DOT] = ACTIONS(2106),
    [anon_sym_COLON_COLON] = ACTIONS(2106),
    [anon_sym_POUND] = ACTIONS(2106),
    [anon_sym_SQUOTE] = ACTIONS(2108),
    [anon_sym_async] = ACTIONS(2108),
    [anon_sym_break] = ACTIONS(2108),
    [anon_sym_const] = ACTIONS(2108),
    [anon_sym_continue] = ACTIONS(2108),
    [anon_sym_default] = ACTIONS(2108),
    [anon_sym_enum] = ACTIONS(2108),
    [anon_sym_fn] = ACTIONS(2108),
    [anon_sym_for] = ACTIONS(2108),
    [anon_sym_if] = ACTIONS(2108),
    [anon_sym_impl] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(2108),
    [anon_sym_loop] = ACTIONS(2108),
    [anon_sym_match] = ACTIONS(2108),
    [anon_sym_mod] = ACTIONS(2108),
    [anon_sym_pub] = ACTIONS(2108),
    [anon_sym_return] = ACTIONS(2108),
    [anon_sym_static] = ACTIONS(2108),
    [anon_sym_struct] = ACTIONS(2108),
    [anon_sym_trait] = ACTIONS(2108),
    [anon_sym_type] = ACTIONS(2108),
    [anon_sym_union] = ACTIONS(2108),
    [anon_sym_unsafe] = ACTIONS(2108),
    [anon_sym_use] = ACTIONS(2108),
    [anon_sym_while] = ACTIONS(2108),
    [anon_sym_extern] = ACTIONS(2108),
    [anon_sym_yield] = ACTIONS(2108),
    [anon_sym_move] = ACTIONS(2108),
    [anon_sym_try] = ACTIONS(2108),
    [sym_integer_literal] = ACTIONS(2106),
    [aux_sym_string_literal_token1] = ACTIONS(2106),
    [sym_char_literal] = ACTIONS(2106),
    [anon_sym_true] = ACTIONS(2108),
    [anon_sym_false] = ACTIONS(2108),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2108),
    [sym_super] = ACTIONS(2108),
    [sym_crate] = ACTIONS(2108),
    [sym_metavariable] = ACTIONS(2106),
    [sym__raw_string_literal_start] = ACTIONS(2106),
    [sym_float_literal] = ACTIONS(2106),
  },
  [565] = {
    [sym_line_comment] = STATE(565),
    [sym_block_comment] = STATE(565),
    [ts_builtin_sym_end] = ACTIONS(2110),
    [sym_identifier] = ACTIONS(2112),
    [anon_sym_SEMI] = ACTIONS(2110),
    [anon_sym_macro_rules_BANG] = ACTIONS(2110),
    [anon_sym_LPAREN] = ACTIONS(2110),
    [anon_sym_LBRACK] = ACTIONS(2110),
    [anon_sym_LBRACE] = ACTIONS(2110),
    [anon_sym_RBRACE] = ACTIONS(2110),
    [anon_sym_STAR] = ACTIONS(2110),
    [anon_sym_u8] = ACTIONS(2112),
    [anon_sym_i8] = ACTIONS(2112),
    [anon_sym_u16] = ACTIONS(2112),
    [anon_sym_i16] = ACTIONS(2112),
    [anon_sym_u32] = ACTIONS(2112),
    [anon_sym_i32] = ACTIONS(2112),
    [anon_sym_u64] = ACTIONS(2112),
    [anon_sym_i64] = ACTIONS(2112),
    [anon_sym_u128] = ACTIONS(2112),
    [anon_sym_i128] = ACTIONS(2112),
    [anon_sym_isize] = ACTIONS(2112),
    [anon_sym_usize] = ACTIONS(2112),
    [anon_sym_f32] = ACTIONS(2112),
    [anon_sym_f64] = ACTIONS(2112),
    [anon_sym_bool] = ACTIONS(2112),
    [anon_sym_str] = ACTIONS(2112),
    [anon_sym_char] = ACTIONS(2112),
    [anon_sym_DASH] = ACTIONS(2110),
    [anon_sym_BANG] = ACTIONS(2110),
    [anon_sym_AMP] = ACTIONS(2110),
    [anon_sym_PIPE] = ACTIONS(2110),
    [anon_sym_LT] = ACTIONS(2110),
    [anon_sym_DOT_DOT] = ACTIONS(2110),
    [anon_sym_COLON_COLON] = ACTIONS(2110),
    [anon_sym_POUND] = ACTIONS(2110),
    [anon_sym_SQUOTE] = ACTIONS(2112),
    [anon_sym_async] = ACTIONS(2112),
    [anon_sym_break] = ACTIONS(2112),
    [anon_sym_const] = ACTIONS(2112),
    [anon_sym_continue] = ACTIONS(2112),
    [anon_sym_default] = ACTIONS(2112),
    [anon_sym_enum] = ACTIONS(2112),
    [anon_sym_fn] = ACTIONS(2112),
    [anon_sym_for] = ACTIONS(2112),
    [anon_sym_if] = ACTIONS(2112),
    [anon_sym_impl] = ACTIONS(2112),
    [anon_sym_let] = ACTIONS(2112),
    [anon_sym_loop] = ACTIONS(2112),
    [anon_sym_match] = ACTIONS(2112),
    [anon_sym_mod] = ACTIONS(2112),
    [anon_sym_pub] = ACTIONS(2112),
    [anon_sym_return] = ACTIONS(2112),
    [anon_sym_static] = ACTIONS(2112),
    [anon_sym_struct] = ACTIONS(2112),
    [anon_sym_trait] = ACTIONS(2112),
    [anon_sym_type] = ACTIONS(2112),
    [anon_sym_union] = ACTIONS(2112),
    [anon_sym_unsafe] = ACTIONS(2112),
    [anon_sym_use] = ACTIONS(2112),
    [anon_sym_while] = ACTIONS(2112),
    [anon_sym_extern] = ACTIONS(2112),
    [anon_sym_yield] = ACTIONS(2112),
    [anon_sym_move] = ACTIONS(2112),
    [anon_sym_try] = ACTIONS(2112),
    [sym_integer_literal] = ACTIONS(2110),
    [aux_sym_string_literal_token1] = ACTIONS(2110),
    [sym_char_literal] = ACTIONS(2110),
    [anon_sym_true] = ACTIONS(2112),
    [anon_sym_false] = ACTIONS(2112),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2112),
    [sym_super] = ACTIONS(2112),
    [sym_crate] = ACTIONS(2112),
    [sym_metavariable] = ACTIONS(2110),
    [sym__raw_string_literal_start] = ACTIONS(2110),
    [sym_float_literal] = ACTIONS(2110),
  },
  [566] = {
    [sym_line_comment] = STATE(566),
    [sym_block_comment] = STATE(566),
    [ts_builtin_sym_end] = ACTIONS(2114),
    [sym_identifier] = ACTIONS(2116),
    [anon_sym_SEMI] = ACTIONS(2114),
    [anon_sym_macro_rules_BANG] = ACTIONS(2114),
    [anon_sym_LPAREN] = ACTIONS(2114),
    [anon_sym_LBRACK] = ACTIONS(2114),
    [anon_sym_LBRACE] = ACTIONS(2114),
    [anon_sym_RBRACE] = ACTIONS(2114),
    [anon_sym_STAR] = ACTIONS(2114),
    [anon_sym_u8] = ACTIONS(2116),
    [anon_sym_i8] = ACTIONS(2116),
    [anon_sym_u16] = ACTIONS(2116),
    [anon_sym_i16] = ACTIONS(2116),
    [anon_sym_u32] = ACTIONS(2116),
    [anon_sym_i32] = ACTIONS(2116),
    [anon_sym_u64] = ACTIONS(2116),
    [anon_sym_i64] = ACTIONS(2116),
    [anon_sym_u128] = ACTIONS(2116),
    [anon_sym_i128] = ACTIONS(2116),
    [anon_sym_isize] = ACTIONS(2116),
    [anon_sym_usize] = ACTIONS(2116),
    [anon_sym_f32] = ACTIONS(2116),
    [anon_sym_f64] = ACTIONS(2116),
    [anon_sym_bool] = ACTIONS(2116),
    [anon_sym_str] = ACTIONS(2116),
    [anon_sym_char] = ACTIONS(2116),
    [anon_sym_DASH] = ACTIONS(2114),
    [anon_sym_BANG] = ACTIONS(2114),
    [anon_sym_AMP] = ACTIONS(2114),
    [anon_sym_PIPE] = ACTIONS(2114),
    [anon_sym_LT] = ACTIONS(2114),
    [anon_sym_DOT_DOT] = ACTIONS(2114),
    [anon_sym_COLON_COLON] = ACTIONS(2114),
    [anon_sym_POUND] = ACTIONS(2114),
    [anon_sym_SQUOTE] = ACTIONS(2116),
    [anon_sym_async] = ACTIONS(2116),
    [anon_sym_break] = ACTIONS(2116),
    [anon_sym_const] = ACTIONS(2116),
    [anon_sym_continue] = ACTIONS(2116),
    [anon_sym_default] = ACTIONS(2116),
    [anon_sym_enum] = ACTIONS(2116),
    [anon_sym_fn] = ACTIONS(2116),
    [anon_sym_for] = ACTIONS(2116),
    [anon_sym_if] = ACTIONS(2116),
    [anon_sym_impl] = ACTIONS(2116),
    [anon_sym_let] = ACTIONS(2116),
    [anon_sym_loop] = ACTIONS(2116),
    [anon_sym_match] = ACTIONS(2116),
    [anon_sym_mod] = ACTIONS(2116),
    [anon_sym_pub] = ACTIONS(2116),
    [anon_sym_return] = ACTIONS(2116),
    [anon_sym_static] = ACTIONS(2116),
    [anon_sym_struct] = ACTIONS(2116),
    [anon_sym_trait] = ACTIONS(2116),
    [anon_sym_type] = ACTIONS(2116),
    [anon_sym_union] = ACTIONS(2116),
    [anon_sym_unsafe] = ACTIONS(2116),
    [anon_sym_use] = ACTIONS(2116),
    [anon_sym_while] = ACTIONS(2116),
    [anon_sym_extern] = ACTIONS(2116),
    [anon_sym_yield] = ACTIONS(2116),
    [anon_sym_move] = ACTIONS(2116),
    [anon_sym_try] = ACTIONS(2116),
    [sym_integer_literal] = ACTIONS(2114),
    [aux_sym_string_literal_token1] = ACTIONS(2114),
    [sym_char_literal] = ACTIONS(2114),
    [anon_sym_true] = ACTIONS(2116),
    [anon_sym_false] = ACTIONS(2116),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2116),
    [sym_super] = ACTIONS(2116),
    [sym_crate] = ACTIONS(2116),
    [sym_metavariable] = ACTIONS(2114),
    [sym__raw_string_literal_start] = ACTIONS(2114),
    [sym_float_literal] = ACTIONS(2114),
  },
  [567] = {
    [sym_line_comment] = STATE(567),
    [sym_block_comment] = STATE(567),
    [ts_builtin_sym_end] = ACTIONS(2118),
    [sym_identifier] = ACTIONS(2120),
    [anon_sym_SEMI] = ACTIONS(2118),
    [anon_sym_macro_rules_BANG] = ACTIONS(2118),
    [anon_sym_LPAREN] = ACTIONS(2118),
    [anon_sym_LBRACK] = ACTIONS(2118),
    [anon_sym_LBRACE] = ACTIONS(2118),
    [anon_sym_RBRACE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2118),
    [anon_sym_u8] = ACTIONS(2120),
    [anon_sym_i8] = ACTIONS(2120),
    [anon_sym_u16] = ACTIONS(2120),
    [anon_sym_i16] = ACTIONS(2120),
    [anon_sym_u32] = ACTIONS(2120),
    [anon_sym_i32] = ACTIONS(2120),
    [anon_sym_u64] = ACTIONS(2120),
    [anon_sym_i64] = ACTIONS(2120),
    [anon_sym_u128] = ACTIONS(2120),
    [anon_sym_i128] = ACTIONS(2120),
    [anon_sym_isize] = ACTIONS(2120),
    [anon_sym_usize] = ACTIONS(2120),
    [anon_sym_f32] = ACTIONS(2120),
    [anon_sym_f64] = ACTIONS(2120),
    [anon_sym_bool] = ACTIONS(2120),
    [anon_sym_str] = ACTIONS(2120),
    [anon_sym_char] = ACTIONS(2120),
    [anon_sym_DASH] = ACTIONS(2118),
    [anon_sym_BANG] = ACTIONS(2118),
    [anon_sym_AMP] = ACTIONS(2118),
    [anon_sym_PIPE] = ACTIONS(2118),
    [anon_sym_LT] = ACTIONS(2118),
    [anon_sym_DOT_DOT] = ACTIONS(2118),
    [anon_sym_COLON_COLON] = ACTIONS(2118),
    [anon_sym_POUND] = ACTIONS(2118),
    [anon_sym_SQUOTE] = ACTIONS(2120),
    [anon_sym_async] = ACTIONS(2120),
    [anon_sym_break] = ACTIONS(2120),
    [anon_sym_const] = ACTIONS(2120),
    [anon_sym_continue] = ACTIONS(2120),
    [anon_sym_default] = ACTIONS(2120),
    [anon_sym_enum] = ACTIONS(2120),
    [anon_sym_fn] = ACTIONS(2120),
    [anon_sym_for] = ACTIONS(2120),
    [anon_sym_if] = ACTIONS(2120),
    [anon_sym_impl] = ACTIONS(2120),
    [anon_sym_let] = ACTIONS(2120),
    [anon_sym_loop] = ACTIONS(2120),
    [anon_sym_match] = ACTIONS(2120),
    [anon_sym_mod] = ACTIONS(2120),
    [anon_sym_pub] = ACTIONS(2120),
    [anon_sym_return] = ACTIONS(2120),
    [anon_sym_static] = ACTIONS(2120),
    [anon_sym_struct] = ACTIONS(2120),
    [anon_sym_trait] = ACTIONS(2120),
    [anon_sym_type] = ACTIONS(2120),
    [anon_sym_union] = ACTIONS(2120),
    [anon_sym_unsafe] = ACTIONS(2120),
    [anon_sym_use] = ACTIONS(2120),
    [anon_sym_while] = ACTIONS(2120),
    [anon_sym_extern] = ACTIONS(2120),
    [anon_sym_yield] = ACTIONS(2120),
    [anon_sym_move] = ACTIONS(2120),
    [anon_sym_try] = ACTIONS(2120),
    [sym_integer_literal] = ACTIONS(2118),
    [aux_sym_string_literal_token1] = ACTIONS(2118),
    [sym_char_literal] = ACTIONS(2118),
    [anon_sym_true] = ACTIONS(2120),
    [anon_sym_false] = ACTIONS(2120),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2120),
    [sym_super] = ACTIONS(2120),
    [sym_crate] = ACTIONS(2120),
    [sym_metavariable] = ACTIONS(2118),
    [sym__raw_string_literal_start] = ACTIONS(2118),
    [sym_float_literal] = ACTIONS(2118),
  },
  [568] = {
    [sym_line_comment] = STATE(568),
    [sym_block_comment] = STATE(568),
    [ts_builtin_sym_end] = ACTIONS(2122),
    [sym_identifier] = ACTIONS(2124),
    [anon_sym_SEMI] = ACTIONS(2122),
    [anon_sym_macro_rules_BANG] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(2122),
    [anon_sym_LBRACK] = ACTIONS(2122),
    [anon_sym_LBRACE] = ACTIONS(2122),
    [anon_sym_RBRACE] = ACTIONS(2122),
    [anon_sym_STAR] = ACTIONS(2122),
    [anon_sym_u8] = ACTIONS(2124),
    [anon_sym_i8] = ACTIONS(2124),
    [anon_sym_u16] = ACTIONS(2124),
    [anon_sym_i16] = ACTIONS(2124),
    [anon_sym_u32] = ACTIONS(2124),
    [anon_sym_i32] = ACTIONS(2124),
    [anon_sym_u64] = ACTIONS(2124),
    [anon_sym_i64] = ACTIONS(2124),
    [anon_sym_u128] = ACTIONS(2124),
    [anon_sym_i128] = ACTIONS(2124),
    [anon_sym_isize] = ACTIONS(2124),
    [anon_sym_usize] = ACTIONS(2124),
    [anon_sym_f32] = ACTIONS(2124),
    [anon_sym_f64] = ACTIONS(2124),
    [anon_sym_bool] = ACTIONS(2124),
    [anon_sym_str] = ACTIONS(2124),
    [anon_sym_char] = ACTIONS(2124),
    [anon_sym_DASH] = ACTIONS(2122),
    [anon_sym_BANG] = ACTIONS(2122),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym_PIPE] = ACTIONS(2122),
    [anon_sym_LT] = ACTIONS(2122),
    [anon_sym_DOT_DOT] = ACTIONS(2122),
    [anon_sym_COLON_COLON] = ACTIONS(2122),
    [anon_sym_POUND] = ACTIONS(2122),
    [anon_sym_SQUOTE] = ACTIONS(2124),
    [anon_sym_async] = ACTIONS(2124),
    [anon_sym_break] = ACTIONS(2124),
    [anon_sym_const] = ACTIONS(2124),
    [anon_sym_continue] = ACTIONS(2124),
    [anon_sym_default] = ACTIONS(2124),
    [anon_sym_enum] = ACTIONS(2124),
    [anon_sym_fn] = ACTIONS(2124),
    [anon_sym_for] = ACTIONS(2124),
    [anon_sym_if] = ACTIONS(2124),
    [anon_sym_impl] = ACTIONS(2124),
    [anon_sym_let] = ACTIONS(2124),
    [anon_sym_loop] = ACTIONS(2124),
    [anon_sym_match] = ACTIONS(2124),
    [anon_sym_mod] = ACTIONS(2124),
    [anon_sym_pub] = ACTIONS(2124),
    [anon_sym_return] = ACTIONS(2124),
    [anon_sym_static] = ACTIONS(2124),
    [anon_sym_struct] = ACTIONS(2124),
    [anon_sym_trait] = ACTIONS(2124),
    [anon_sym_type] = ACTIONS(2124),
    [anon_sym_union] = ACTIONS(2124),
    [anon_sym_unsafe] = ACTIONS(2124),
    [anon_sym_use] = ACTIONS(2124),
    [anon_sym_while] = ACTIONS(2124),
    [anon_sym_extern] = ACTIONS(2124),
    [anon_sym_yield] = ACTIONS(2124),
    [anon_sym_move] = ACTIONS(2124),
    [anon_sym_try] = ACTIONS(2124),
    [sym_integer_literal] = ACTIONS(2122),
    [aux_sym_string_literal_token1] = ACTIONS(2122),
    [sym_char_literal] = ACTIONS(2122),
    [anon_sym_true] = ACTIONS(2124),
    [anon_sym_false] = ACTIONS(2124),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2124),
    [sym_super] = ACTIONS(2124),
    [sym_crate] = ACTIONS(2124),
    [sym_metavariable] = ACTIONS(2122),
    [sym__raw_string_literal_start] = ACTIONS(2122),
    [sym_float_literal] = ACTIONS(2122),
  },
  [569] = {
    [sym_line_comment] = STATE(569),
    [sym_block_comment] = STATE(569),
    [ts_builtin_sym_end] = ACTIONS(2126),
    [sym_identifier] = ACTIONS(2128),
    [anon_sym_SEMI] = ACTIONS(2126),
    [anon_sym_macro_rules_BANG] = ACTIONS(2126),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(2126),
    [anon_sym_LBRACE] = ACTIONS(2126),
    [anon_sym_RBRACE] = ACTIONS(2126),
    [anon_sym_STAR] = ACTIONS(2126),
    [anon_sym_u8] = ACTIONS(2128),
    [anon_sym_i8] = ACTIONS(2128),
    [anon_sym_u16] = ACTIONS(2128),
    [anon_sym_i16] = ACTIONS(2128),
    [anon_sym_u32] = ACTIONS(2128),
    [anon_sym_i32] = ACTIONS(2128),
    [anon_sym_u64] = ACTIONS(2128),
    [anon_sym_i64] = ACTIONS(2128),
    [anon_sym_u128] = ACTIONS(2128),
    [anon_sym_i128] = ACTIONS(2128),
    [anon_sym_isize] = ACTIONS(2128),
    [anon_sym_usize] = ACTIONS(2128),
    [anon_sym_f32] = ACTIONS(2128),
    [anon_sym_f64] = ACTIONS(2128),
    [anon_sym_bool] = ACTIONS(2128),
    [anon_sym_str] = ACTIONS(2128),
    [anon_sym_char] = ACTIONS(2128),
    [anon_sym_DASH] = ACTIONS(2126),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_AMP] = ACTIONS(2126),
    [anon_sym_PIPE] = ACTIONS(2126),
    [anon_sym_LT] = ACTIONS(2126),
    [anon_sym_DOT_DOT] = ACTIONS(2126),
    [anon_sym_COLON_COLON] = ACTIONS(2126),
    [anon_sym_POUND] = ACTIONS(2126),
    [anon_sym_SQUOTE] = ACTIONS(2128),
    [anon_sym_async] = ACTIONS(2128),
    [anon_sym_break] = ACTIONS(2128),
    [anon_sym_const] = ACTIONS(2128),
    [anon_sym_continue] = ACTIONS(2128),
    [anon_sym_default] = ACTIONS(2128),
    [anon_sym_enum] = ACTIONS(2128),
    [anon_sym_fn] = ACTIONS(2128),
    [anon_sym_for] = ACTIONS(2128),
    [anon_sym_if] = ACTIONS(2128),
    [anon_sym_impl] = ACTIONS(2128),
    [anon_sym_let] = ACTIONS(2128),
    [anon_sym_loop] = ACTIONS(2128),
    [anon_sym_match] = ACTIONS(2128),
    [anon_sym_mod] = ACTIONS(2128),
    [anon_sym_pub] = ACTIONS(2128),
    [anon_sym_return] = ACTIONS(2128),
    [anon_sym_static] = ACTIONS(2128),
    [anon_sym_struct] = ACTIONS(2128),
    [anon_sym_trait] = ACTIONS(2128),
    [anon_sym_type] = ACTIONS(2128),
    [anon_sym_union] = ACTIONS(2128),
    [anon_sym_unsafe] = ACTIONS(2128),
    [anon_sym_use] = ACTIONS(2128),
    [anon_sym_while] = ACTIONS(2128),
    [anon_sym_extern] = ACTIONS(2128),
    [anon_sym_yield] = ACTIONS(2128),
    [anon_sym_move] = ACTIONS(2128),
    [anon_sym_try] = ACTIONS(2128),
    [sym_integer_literal] = ACTIONS(2126),
    [aux_sym_string_literal_token1] = ACTIONS(2126),
    [sym_char_literal] = ACTIONS(2126),
    [anon_sym_true] = ACTIONS(2128),
    [anon_sym_false] = ACTIONS(2128),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2128),
    [sym_super] = ACTIONS(2128),
    [sym_crate] = ACTIONS(2128),
    [sym_metavariable] = ACTIONS(2126),
    [sym__raw_string_literal_start] = ACTIONS(2126),
    [sym_float_literal] = ACTIONS(2126),
  },
  [570] = {
    [sym_line_comment] = STATE(570),
    [sym_block_comment] = STATE(570),
    [ts_builtin_sym_end] = ACTIONS(2130),
    [sym_identifier] = ACTIONS(2132),
    [anon_sym_SEMI] = ACTIONS(2130),
    [anon_sym_macro_rules_BANG] = ACTIONS(2130),
    [anon_sym_LPAREN] = ACTIONS(2130),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_LBRACE] = ACTIONS(2130),
    [anon_sym_RBRACE] = ACTIONS(2130),
    [anon_sym_STAR] = ACTIONS(2130),
    [anon_sym_u8] = ACTIONS(2132),
    [anon_sym_i8] = ACTIONS(2132),
    [anon_sym_u16] = ACTIONS(2132),
    [anon_sym_i16] = ACTIONS(2132),
    [anon_sym_u32] = ACTIONS(2132),
    [anon_sym_i32] = ACTIONS(2132),
    [anon_sym_u64] = ACTIONS(2132),
    [anon_sym_i64] = ACTIONS(2132),
    [anon_sym_u128] = ACTIONS(2132),
    [anon_sym_i128] = ACTIONS(2132),
    [anon_sym_isize] = ACTIONS(2132),
    [anon_sym_usize] = ACTIONS(2132),
    [anon_sym_f32] = ACTIONS(2132),
    [anon_sym_f64] = ACTIONS(2132),
    [anon_sym_bool] = ACTIONS(2132),
    [anon_sym_str] = ACTIONS(2132),
    [anon_sym_char] = ACTIONS(2132),
    [anon_sym_DASH] = ACTIONS(2130),
    [anon_sym_BANG] = ACTIONS(2130),
    [anon_sym_AMP] = ACTIONS(2130),
    [anon_sym_PIPE] = ACTIONS(2130),
    [anon_sym_LT] = ACTIONS(2130),
    [anon_sym_DOT_DOT] = ACTIONS(2130),
    [anon_sym_COLON_COLON] = ACTIONS(2130),
    [anon_sym_POUND] = ACTIONS(2130),
    [anon_sym_SQUOTE] = ACTIONS(2132),
    [anon_sym_async] = ACTIONS(2132),
    [anon_sym_break] = ACTIONS(2132),
    [anon_sym_const] = ACTIONS(2132),
    [anon_sym_continue] = ACTIONS(2132),
    [anon_sym_default] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(2132),
    [anon_sym_fn] = ACTIONS(2132),
    [anon_sym_for] = ACTIONS(2132),
    [anon_sym_if] = ACTIONS(2132),
    [anon_sym_impl] = ACTIONS(2132),
    [anon_sym_let] = ACTIONS(2132),
    [anon_sym_loop] = ACTIONS(2132),
    [anon_sym_match] = ACTIONS(2132),
    [anon_sym_mod] = ACTIONS(2132),
    [anon_sym_pub] = ACTIONS(2132),
    [anon_sym_return] = ACTIONS(2132),
    [anon_sym_static] = ACTIONS(2132),
    [anon_sym_struct] = ACTIONS(2132),
    [anon_sym_trait] = ACTIONS(2132),
    [anon_sym_type] = ACTIONS(2132),
    [anon_sym_union] = ACTIONS(2132),
    [anon_sym_unsafe] = ACTIONS(2132),
    [anon_sym_use] = ACTIONS(2132),
    [anon_sym_while] = ACTIONS(2132),
    [anon_sym_extern] = ACTIONS(2132),
    [anon_sym_yield] = ACTIONS(2132),
    [anon_sym_move] = ACTIONS(2132),
    [anon_sym_try] = ACTIONS(2132),
    [sym_integer_literal] = ACTIONS(2130),
    [aux_sym_string_literal_token1] = ACTIONS(2130),
    [sym_char_literal] = ACTIONS(2130),
    [anon_sym_true] = ACTIONS(2132),
    [anon_sym_false] = ACTIONS(2132),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2132),
    [sym_super] = ACTIONS(2132),
    [sym_crate] = ACTIONS(2132),
    [sym_metavariable] = ACTIONS(2130),
    [sym__raw_string_literal_start] = ACTIONS(2130),
    [sym_float_literal] = ACTIONS(2130),
  },
  [571] = {
    [sym_line_comment] = STATE(571),
    [sym_block_comment] = STATE(571),
    [ts_builtin_sym_end] = ACTIONS(2134),
    [sym_identifier] = ACTIONS(2136),
    [anon_sym_SEMI] = ACTIONS(2134),
    [anon_sym_macro_rules_BANG] = ACTIONS(2134),
    [anon_sym_LPAREN] = ACTIONS(2134),
    [anon_sym_LBRACK] = ACTIONS(2134),
    [anon_sym_LBRACE] = ACTIONS(2134),
    [anon_sym_RBRACE] = ACTIONS(2134),
    [anon_sym_STAR] = ACTIONS(2134),
    [anon_sym_u8] = ACTIONS(2136),
    [anon_sym_i8] = ACTIONS(2136),
    [anon_sym_u16] = ACTIONS(2136),
    [anon_sym_i16] = ACTIONS(2136),
    [anon_sym_u32] = ACTIONS(2136),
    [anon_sym_i32] = ACTIONS(2136),
    [anon_sym_u64] = ACTIONS(2136),
    [anon_sym_i64] = ACTIONS(2136),
    [anon_sym_u128] = ACTIONS(2136),
    [anon_sym_i128] = ACTIONS(2136),
    [anon_sym_isize] = ACTIONS(2136),
    [anon_sym_usize] = ACTIONS(2136),
    [anon_sym_f32] = ACTIONS(2136),
    [anon_sym_f64] = ACTIONS(2136),
    [anon_sym_bool] = ACTIONS(2136),
    [anon_sym_str] = ACTIONS(2136),
    [anon_sym_char] = ACTIONS(2136),
    [anon_sym_DASH] = ACTIONS(2134),
    [anon_sym_BANG] = ACTIONS(2134),
    [anon_sym_AMP] = ACTIONS(2134),
    [anon_sym_PIPE] = ACTIONS(2134),
    [anon_sym_LT] = ACTIONS(2134),
    [anon_sym_DOT_DOT] = ACTIONS(2134),
    [anon_sym_COLON_COLON] = ACTIONS(2134),
    [anon_sym_POUND] = ACTIONS(2134),
    [anon_sym_SQUOTE] = ACTIONS(2136),
    [anon_sym_async] = ACTIONS(2136),
    [anon_sym_break] = ACTIONS(2136),
    [anon_sym_const] = ACTIONS(2136),
    [anon_sym_continue] = ACTIONS(2136),
    [anon_sym_default] = ACTIONS(2136),
    [anon_sym_enum] = ACTIONS(2136),
    [anon_sym_fn] = ACTIONS(2136),
    [anon_sym_for] = ACTIONS(2136),
    [anon_sym_if] = ACTIONS(2136),
    [anon_sym_impl] = ACTIONS(2136),
    [anon_sym_let] = ACTIONS(2136),
    [anon_sym_loop] = ACTIONS(2136),
    [anon_sym_match] = ACTIONS(2136),
    [anon_sym_mod] = ACTIONS(2136),
    [anon_sym_pub] = ACTIONS(2136),
    [anon_sym_return] = ACTIONS(2136),
    [anon_sym_static] = ACTIONS(2136),
    [anon_sym_struct] = ACTIONS(2136),
    [anon_sym_trait] = ACTIONS(2136),
    [anon_sym_type] = ACTIONS(2136),
    [anon_sym_union] = ACTIONS(2136),
    [anon_sym_unsafe] = ACTIONS(2136),
    [anon_sym_use] = ACTIONS(2136),
    [anon_sym_while] = ACTIONS(2136),
    [anon_sym_extern] = ACTIONS(2136),
    [anon_sym_yield] = ACTIONS(2136),
    [anon_sym_move] = ACTIONS(2136),
    [anon_sym_try] = ACTIONS(2136),
    [sym_integer_literal] = ACTIONS(2134),
    [aux_sym_string_literal_token1] = ACTIONS(2134),
    [sym_char_literal] = ACTIONS(2134),
    [anon_sym_true] = ACTIONS(2136),
    [anon_sym_false] = ACTIONS(2136),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2136),
    [sym_super] = ACTIONS(2136),
    [sym_crate] = ACTIONS(2136),
    [sym_metavariable] = ACTIONS(2134),
    [sym__raw_string_literal_start] = ACTIONS(2134),
    [sym_float_literal] = ACTIONS(2134),
  },
  [572] = {
    [sym_line_comment] = STATE(572),
    [sym_block_comment] = STATE(572),
    [ts_builtin_sym_end] = ACTIONS(2138),
    [sym_identifier] = ACTIONS(2140),
    [anon_sym_SEMI] = ACTIONS(2138),
    [anon_sym_macro_rules_BANG] = ACTIONS(2138),
    [anon_sym_LPAREN] = ACTIONS(2138),
    [anon_sym_LBRACK] = ACTIONS(2138),
    [anon_sym_LBRACE] = ACTIONS(2138),
    [anon_sym_RBRACE] = ACTIONS(2138),
    [anon_sym_STAR] = ACTIONS(2138),
    [anon_sym_u8] = ACTIONS(2140),
    [anon_sym_i8] = ACTIONS(2140),
    [anon_sym_u16] = ACTIONS(2140),
    [anon_sym_i16] = ACTIONS(2140),
    [anon_sym_u32] = ACTIONS(2140),
    [anon_sym_i32] = ACTIONS(2140),
    [anon_sym_u64] = ACTIONS(2140),
    [anon_sym_i64] = ACTIONS(2140),
    [anon_sym_u128] = ACTIONS(2140),
    [anon_sym_i128] = ACTIONS(2140),
    [anon_sym_isize] = ACTIONS(2140),
    [anon_sym_usize] = ACTIONS(2140),
    [anon_sym_f32] = ACTIONS(2140),
    [anon_sym_f64] = ACTIONS(2140),
    [anon_sym_bool] = ACTIONS(2140),
    [anon_sym_str] = ACTIONS(2140),
    [anon_sym_char] = ACTIONS(2140),
    [anon_sym_DASH] = ACTIONS(2138),
    [anon_sym_BANG] = ACTIONS(2138),
    [anon_sym_AMP] = ACTIONS(2138),
    [anon_sym_PIPE] = ACTIONS(2138),
    [anon_sym_LT] = ACTIONS(2138),
    [anon_sym_DOT_DOT] = ACTIONS(2138),
    [anon_sym_COLON_COLON] = ACTIONS(2138),
    [anon_sym_POUND] = ACTIONS(2138),
    [anon_sym_SQUOTE] = ACTIONS(2140),
    [anon_sym_async] = ACTIONS(2140),
    [anon_sym_break] = ACTIONS(2140),
    [anon_sym_const] = ACTIONS(2140),
    [anon_sym_continue] = ACTIONS(2140),
    [anon_sym_default] = ACTIONS(2140),
    [anon_sym_enum] = ACTIONS(2140),
    [anon_sym_fn] = ACTIONS(2140),
    [anon_sym_for] = ACTIONS(2140),
    [anon_sym_if] = ACTIONS(2140),
    [anon_sym_impl] = ACTIONS(2140),
    [anon_sym_let] = ACTIONS(2140),
    [anon_sym_loop] = ACTIONS(2140),
    [anon_sym_match] = ACTIONS(2140),
    [anon_sym_mod] = ACTIONS(2140),
    [anon_sym_pub] = ACTIONS(2140),
    [anon_sym_return] = ACTIONS(2140),
    [anon_sym_static] = ACTIONS(2140),
    [anon_sym_struct] = ACTIONS(2140),
    [anon_sym_trait] = ACTIONS(2140),
    [anon_sym_type] = ACTIONS(2140),
    [anon_sym_union] = ACTIONS(2140),
    [anon_sym_unsafe] = ACTIONS(2140),
    [anon_sym_use] = ACTIONS(2140),
    [anon_sym_while] = ACTIONS(2140),
    [anon_sym_extern] = ACTIONS(2140),
    [anon_sym_yield] = ACTIONS(2140),
    [anon_sym_move] = ACTIONS(2140),
    [anon_sym_try] = ACTIONS(2140),
    [sym_integer_literal] = ACTIONS(2138),
    [aux_sym_string_literal_token1] = ACTIONS(2138),
    [sym_char_literal] = ACTIONS(2138),
    [anon_sym_true] = ACTIONS(2140),
    [anon_sym_false] = ACTIONS(2140),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2140),
    [sym_super] = ACTIONS(2140),
    [sym_crate] = ACTIONS(2140),
    [sym_metavariable] = ACTIONS(2138),
    [sym__raw_string_literal_start] = ACTIONS(2138),
    [sym_float_literal] = ACTIONS(2138),
  },
  [573] = {
    [sym_line_comment] = STATE(573),
    [sym_block_comment] = STATE(573),
    [ts_builtin_sym_end] = ACTIONS(2142),
    [sym_identifier] = ACTIONS(2144),
    [anon_sym_SEMI] = ACTIONS(2142),
    [anon_sym_macro_rules_BANG] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(2142),
    [anon_sym_LBRACK] = ACTIONS(2142),
    [anon_sym_LBRACE] = ACTIONS(2142),
    [anon_sym_RBRACE] = ACTIONS(2142),
    [anon_sym_STAR] = ACTIONS(2142),
    [anon_sym_u8] = ACTIONS(2144),
    [anon_sym_i8] = ACTIONS(2144),
    [anon_sym_u16] = ACTIONS(2144),
    [anon_sym_i16] = ACTIONS(2144),
    [anon_sym_u32] = ACTIONS(2144),
    [anon_sym_i32] = ACTIONS(2144),
    [anon_sym_u64] = ACTIONS(2144),
    [anon_sym_i64] = ACTIONS(2144),
    [anon_sym_u128] = ACTIONS(2144),
    [anon_sym_i128] = ACTIONS(2144),
    [anon_sym_isize] = ACTIONS(2144),
    [anon_sym_usize] = ACTIONS(2144),
    [anon_sym_f32] = ACTIONS(2144),
    [anon_sym_f64] = ACTIONS(2144),
    [anon_sym_bool] = ACTIONS(2144),
    [anon_sym_str] = ACTIONS(2144),
    [anon_sym_char] = ACTIONS(2144),
    [anon_sym_DASH] = ACTIONS(2142),
    [anon_sym_BANG] = ACTIONS(2142),
    [anon_sym_AMP] = ACTIONS(2142),
    [anon_sym_PIPE] = ACTIONS(2142),
    [anon_sym_LT] = ACTIONS(2142),
    [anon_sym_DOT_DOT] = ACTIONS(2142),
    [anon_sym_COLON_COLON] = ACTIONS(2142),
    [anon_sym_POUND] = ACTIONS(2142),
    [anon_sym_SQUOTE] = ACTIONS(2144),
    [anon_sym_async] = ACTIONS(2144),
    [anon_sym_break] = ACTIONS(2144),
    [anon_sym_const] = ACTIONS(2144),
    [anon_sym_continue] = ACTIONS(2144),
    [anon_sym_default] = ACTIONS(2144),
    [anon_sym_enum] = ACTIONS(2144),
    [anon_sym_fn] = ACTIONS(2144),
    [anon_sym_for] = ACTIONS(2144),
    [anon_sym_if] = ACTIONS(2144),
    [anon_sym_impl] = ACTIONS(2144),
    [anon_sym_let] = ACTIONS(2144),
    [anon_sym_loop] = ACTIONS(2144),
    [anon_sym_match] = ACTIONS(2144),
    [anon_sym_mod] = ACTIONS(2144),
    [anon_sym_pub] = ACTIONS(2144),
    [anon_sym_return] = ACTIONS(2144),
    [anon_sym_static] = ACTIONS(2144),
    [anon_sym_struct] = ACTIONS(2144),
    [anon_sym_trait] = ACTIONS(2144),
    [anon_sym_type] = ACTIONS(2144),
    [anon_sym_union] = ACTIONS(2144),
    [anon_sym_unsafe] = ACTIONS(2144),
    [anon_sym_use] = ACTIONS(2144),
    [anon_sym_while] = ACTIONS(2144),
    [anon_sym_extern] = ACTIONS(2144),
    [anon_sym_yield] = ACTIONS(2144),
    [anon_sym_move] = ACTIONS(2144),
    [anon_sym_try] = ACTIONS(2144),
    [sym_integer_literal] = ACTIONS(2142),
    [aux_sym_string_literal_token1] = ACTIONS(2142),
    [sym_char_literal] = ACTIONS(2142),
    [anon_sym_true] = ACTIONS(2144),
    [anon_sym_false] = ACTIONS(2144),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2144),
    [sym_super] = ACTIONS(2144),
    [sym_crate] = ACTIONS(2144),
    [sym_metavariable] = ACTIONS(2142),
    [sym__raw_string_literal_start] = ACTIONS(2142),
    [sym_float_literal] = ACTIONS(2142),
  },
  [574] = {
    [sym_line_comment] = STATE(574),
    [sym_block_comment] = STATE(574),
    [ts_builtin_sym_end] = ACTIONS(2146),
    [sym_identifier] = ACTIONS(2148),
    [anon_sym_SEMI] = ACTIONS(2146),
    [anon_sym_macro_rules_BANG] = ACTIONS(2146),
    [anon_sym_LPAREN] = ACTIONS(2146),
    [anon_sym_LBRACK] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(2146),
    [anon_sym_RBRACE] = ACTIONS(2146),
    [anon_sym_STAR] = ACTIONS(2146),
    [anon_sym_u8] = ACTIONS(2148),
    [anon_sym_i8] = ACTIONS(2148),
    [anon_sym_u16] = ACTIONS(2148),
    [anon_sym_i16] = ACTIONS(2148),
    [anon_sym_u32] = ACTIONS(2148),
    [anon_sym_i32] = ACTIONS(2148),
    [anon_sym_u64] = ACTIONS(2148),
    [anon_sym_i64] = ACTIONS(2148),
    [anon_sym_u128] = ACTIONS(2148),
    [anon_sym_i128] = ACTIONS(2148),
    [anon_sym_isize] = ACTIONS(2148),
    [anon_sym_usize] = ACTIONS(2148),
    [anon_sym_f32] = ACTIONS(2148),
    [anon_sym_f64] = ACTIONS(2148),
    [anon_sym_bool] = ACTIONS(2148),
    [anon_sym_str] = ACTIONS(2148),
    [anon_sym_char] = ACTIONS(2148),
    [anon_sym_DASH] = ACTIONS(2146),
    [anon_sym_BANG] = ACTIONS(2146),
    [anon_sym_AMP] = ACTIONS(2146),
    [anon_sym_PIPE] = ACTIONS(2146),
    [anon_sym_LT] = ACTIONS(2146),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_COLON_COLON] = ACTIONS(2146),
    [anon_sym_POUND] = ACTIONS(2146),
    [anon_sym_SQUOTE] = ACTIONS(2148),
    [anon_sym_async] = ACTIONS(2148),
    [anon_sym_break] = ACTIONS(2148),
    [anon_sym_const] = ACTIONS(2148),
    [anon_sym_continue] = ACTIONS(2148),
    [anon_sym_default] = ACTIONS(2148),
    [anon_sym_enum] = ACTIONS(2148),
    [anon_sym_fn] = ACTIONS(2148),
    [anon_sym_for] = ACTIONS(2148),
    [anon_sym_if] = ACTIONS(2148),
    [anon_sym_impl] = ACTIONS(2148),
    [anon_sym_let] = ACTIONS(2148),
    [anon_sym_loop] = ACTIONS(2148),
    [anon_sym_match] = ACTIONS(2148),
    [anon_sym_mod] = ACTIONS(2148),
    [anon_sym_pub] = ACTIONS(2148),
    [anon_sym_return] = ACTIONS(2148),
    [anon_sym_static] = ACTIONS(2148),
    [anon_sym_struct] = ACTIONS(2148),
    [anon_sym_trait] = ACTIONS(2148),
    [anon_sym_type] = ACTIONS(2148),
    [anon_sym_union] = ACTIONS(2148),
    [anon_sym_unsafe] = ACTIONS(2148),
    [anon_sym_use] = ACTIONS(2148),
    [anon_sym_while] = ACTIONS(2148),
    [anon_sym_extern] = ACTIONS(2148),
    [anon_sym_yield] = ACTIONS(2148),
    [anon_sym_move] = ACTIONS(2148),
    [anon_sym_try] = ACTIONS(2148),
    [sym_integer_literal] = ACTIONS(2146),
    [aux_sym_string_literal_token1] = ACTIONS(2146),
    [sym_char_literal] = ACTIONS(2146),
    [anon_sym_true] = ACTIONS(2148),
    [anon_sym_false] = ACTIONS(2148),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2148),
    [sym_super] = ACTIONS(2148),
    [sym_crate] = ACTIONS(2148),
    [sym_metavariable] = ACTIONS(2146),
    [sym__raw_string_literal_start] = ACTIONS(2146),
    [sym_float_literal] = ACTIONS(2146),
  },
  [575] = {
    [sym_line_comment] = STATE(575),
    [sym_block_comment] = STATE(575),
    [ts_builtin_sym_end] = ACTIONS(2150),
    [sym_identifier] = ACTIONS(2152),
    [anon_sym_SEMI] = ACTIONS(2150),
    [anon_sym_macro_rules_BANG] = ACTIONS(2150),
    [anon_sym_LPAREN] = ACTIONS(2150),
    [anon_sym_LBRACK] = ACTIONS(2150),
    [anon_sym_LBRACE] = ACTIONS(2150),
    [anon_sym_RBRACE] = ACTIONS(2150),
    [anon_sym_STAR] = ACTIONS(2150),
    [anon_sym_u8] = ACTIONS(2152),
    [anon_sym_i8] = ACTIONS(2152),
    [anon_sym_u16] = ACTIONS(2152),
    [anon_sym_i16] = ACTIONS(2152),
    [anon_sym_u32] = ACTIONS(2152),
    [anon_sym_i32] = ACTIONS(2152),
    [anon_sym_u64] = ACTIONS(2152),
    [anon_sym_i64] = ACTIONS(2152),
    [anon_sym_u128] = ACTIONS(2152),
    [anon_sym_i128] = ACTIONS(2152),
    [anon_sym_isize] = ACTIONS(2152),
    [anon_sym_usize] = ACTIONS(2152),
    [anon_sym_f32] = ACTIONS(2152),
    [anon_sym_f64] = ACTIONS(2152),
    [anon_sym_bool] = ACTIONS(2152),
    [anon_sym_str] = ACTIONS(2152),
    [anon_sym_char] = ACTIONS(2152),
    [anon_sym_DASH] = ACTIONS(2150),
    [anon_sym_BANG] = ACTIONS(2150),
    [anon_sym_AMP] = ACTIONS(2150),
    [anon_sym_PIPE] = ACTIONS(2150),
    [anon_sym_LT] = ACTIONS(2150),
    [anon_sym_DOT_DOT] = ACTIONS(2150),
    [anon_sym_COLON_COLON] = ACTIONS(2150),
    [anon_sym_POUND] = ACTIONS(2150),
    [anon_sym_SQUOTE] = ACTIONS(2152),
    [anon_sym_async] = ACTIONS(2152),
    [anon_sym_break] = ACTIONS(2152),
    [anon_sym_const] = ACTIONS(2152),
    [anon_sym_continue] = ACTIONS(2152),
    [anon_sym_default] = ACTIONS(2152),
    [anon_sym_enum] = ACTIONS(2152),
    [anon_sym_fn] = ACTIONS(2152),
    [anon_sym_for] = ACTIONS(2152),
    [anon_sym_if] = ACTIONS(2152),
    [anon_sym_impl] = ACTIONS(2152),
    [anon_sym_let] = ACTIONS(2152),
    [anon_sym_loop] = ACTIONS(2152),
    [anon_sym_match] = ACTIONS(2152),
    [anon_sym_mod] = ACTIONS(2152),
    [anon_sym_pub] = ACTIONS(2152),
    [anon_sym_return] = ACTIONS(2152),
    [anon_sym_static] = ACTIONS(2152),
    [anon_sym_struct] = ACTIONS(2152),
    [anon_sym_trait] = ACTIONS(2152),
    [anon_sym_type] = ACTIONS(2152),
    [anon_sym_union] = ACTIONS(2152),
    [anon_sym_unsafe] = ACTIONS(2152),
    [anon_sym_use] = ACTIONS(2152),
    [anon_sym_while] = ACTIONS(2152),
    [anon_sym_extern] = ACTIONS(2152),
    [anon_sym_yield] = ACTIONS(2152),
    [anon_sym_move] = ACTIONS(2152),
    [anon_sym_try] = ACTIONS(2152),
    [sym_integer_literal] = ACTIONS(2150),
    [aux_sym_string_literal_token1] = ACTIONS(2150),
    [sym_char_literal] = ACTIONS(2150),
    [anon_sym_true] = ACTIONS(2152),
    [anon_sym_false] = ACTIONS(2152),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2152),
    [sym_super] = ACTIONS(2152),
    [sym_crate] = ACTIONS(2152),
    [sym_metavariable] = ACTIONS(2150),
    [sym__raw_string_literal_start] = ACTIONS(2150),
    [sym_float_literal] = ACTIONS(2150),
  },
  [576] = {
    [sym_line_comment] = STATE(576),
    [sym_block_comment] = STATE(576),
    [ts_builtin_sym_end] = ACTIONS(2154),
    [sym_identifier] = ACTIONS(2156),
    [anon_sym_SEMI] = ACTIONS(2154),
    [anon_sym_macro_rules_BANG] = ACTIONS(2154),
    [anon_sym_LPAREN] = ACTIONS(2154),
    [anon_sym_LBRACK] = ACTIONS(2154),
    [anon_sym_LBRACE] = ACTIONS(2154),
    [anon_sym_RBRACE] = ACTIONS(2154),
    [anon_sym_STAR] = ACTIONS(2154),
    [anon_sym_u8] = ACTIONS(2156),
    [anon_sym_i8] = ACTIONS(2156),
    [anon_sym_u16] = ACTIONS(2156),
    [anon_sym_i16] = ACTIONS(2156),
    [anon_sym_u32] = ACTIONS(2156),
    [anon_sym_i32] = ACTIONS(2156),
    [anon_sym_u64] = ACTIONS(2156),
    [anon_sym_i64] = ACTIONS(2156),
    [anon_sym_u128] = ACTIONS(2156),
    [anon_sym_i128] = ACTIONS(2156),
    [anon_sym_isize] = ACTIONS(2156),
    [anon_sym_usize] = ACTIONS(2156),
    [anon_sym_f32] = ACTIONS(2156),
    [anon_sym_f64] = ACTIONS(2156),
    [anon_sym_bool] = ACTIONS(2156),
    [anon_sym_str] = ACTIONS(2156),
    [anon_sym_char] = ACTIONS(2156),
    [anon_sym_DASH] = ACTIONS(2154),
    [anon_sym_BANG] = ACTIONS(2154),
    [anon_sym_AMP] = ACTIONS(2154),
    [anon_sym_PIPE] = ACTIONS(2154),
    [anon_sym_LT] = ACTIONS(2154),
    [anon_sym_DOT_DOT] = ACTIONS(2154),
    [anon_sym_COLON_COLON] = ACTIONS(2154),
    [anon_sym_POUND] = ACTIONS(2154),
    [anon_sym_SQUOTE] = ACTIONS(2156),
    [anon_sym_async] = ACTIONS(2156),
    [anon_sym_break] = ACTIONS(2156),
    [anon_sym_const] = ACTIONS(2156),
    [anon_sym_continue] = ACTIONS(2156),
    [anon_sym_default] = ACTIONS(2156),
    [anon_sym_enum] = ACTIONS(2156),
    [anon_sym_fn] = ACTIONS(2156),
    [anon_sym_for] = ACTIONS(2156),
    [anon_sym_if] = ACTIONS(2156),
    [anon_sym_impl] = ACTIONS(2156),
    [anon_sym_let] = ACTIONS(2156),
    [anon_sym_loop] = ACTIONS(2156),
    [anon_sym_match] = ACTIONS(2156),
    [anon_sym_mod] = ACTIONS(2156),
    [anon_sym_pub] = ACTIONS(2156),
    [anon_sym_return] = ACTIONS(2156),
    [anon_sym_static] = ACTIONS(2156),
    [anon_sym_struct] = ACTIONS(2156),
    [anon_sym_trait] = ACTIONS(2156),
    [anon_sym_type] = ACTIONS(2156),
    [anon_sym_union] = ACTIONS(2156),
    [anon_sym_unsafe] = ACTIONS(2156),
    [anon_sym_use] = ACTIONS(2156),
    [anon_sym_while] = ACTIONS(2156),
    [anon_sym_extern] = ACTIONS(2156),
    [anon_sym_yield] = ACTIONS(2156),
    [anon_sym_move] = ACTIONS(2156),
    [anon_sym_try] = ACTIONS(2156),
    [sym_integer_literal] = ACTIONS(2154),
    [aux_sym_string_literal_token1] = ACTIONS(2154),
    [sym_char_literal] = ACTIONS(2154),
    [anon_sym_true] = ACTIONS(2156),
    [anon_sym_false] = ACTIONS(2156),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2156),
    [sym_super] = ACTIONS(2156),
    [sym_crate] = ACTIONS(2156),
    [sym_metavariable] = ACTIONS(2154),
    [sym__raw_string_literal_start] = ACTIONS(2154),
    [sym_float_literal] = ACTIONS(2154),
  },
  [577] = {
    [sym_line_comment] = STATE(577),
    [sym_block_comment] = STATE(577),
    [ts_builtin_sym_end] = ACTIONS(2158),
    [sym_identifier] = ACTIONS(2160),
    [anon_sym_SEMI] = ACTIONS(2158),
    [anon_sym_macro_rules_BANG] = ACTIONS(2158),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_RBRACE] = ACTIONS(2158),
    [anon_sym_STAR] = ACTIONS(2158),
    [anon_sym_u8] = ACTIONS(2160),
    [anon_sym_i8] = ACTIONS(2160),
    [anon_sym_u16] = ACTIONS(2160),
    [anon_sym_i16] = ACTIONS(2160),
    [anon_sym_u32] = ACTIONS(2160),
    [anon_sym_i32] = ACTIONS(2160),
    [anon_sym_u64] = ACTIONS(2160),
    [anon_sym_i64] = ACTIONS(2160),
    [anon_sym_u128] = ACTIONS(2160),
    [anon_sym_i128] = ACTIONS(2160),
    [anon_sym_isize] = ACTIONS(2160),
    [anon_sym_usize] = ACTIONS(2160),
    [anon_sym_f32] = ACTIONS(2160),
    [anon_sym_f64] = ACTIONS(2160),
    [anon_sym_bool] = ACTIONS(2160),
    [anon_sym_str] = ACTIONS(2160),
    [anon_sym_char] = ACTIONS(2160),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_BANG] = ACTIONS(2158),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_PIPE] = ACTIONS(2158),
    [anon_sym_LT] = ACTIONS(2158),
    [anon_sym_DOT_DOT] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2158),
    [anon_sym_POUND] = ACTIONS(2158),
    [anon_sym_SQUOTE] = ACTIONS(2160),
    [anon_sym_async] = ACTIONS(2160),
    [anon_sym_break] = ACTIONS(2160),
    [anon_sym_const] = ACTIONS(2160),
    [anon_sym_continue] = ACTIONS(2160),
    [anon_sym_default] = ACTIONS(2160),
    [anon_sym_enum] = ACTIONS(2160),
    [anon_sym_fn] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2160),
    [anon_sym_if] = ACTIONS(2160),
    [anon_sym_impl] = ACTIONS(2160),
    [anon_sym_let] = ACTIONS(2160),
    [anon_sym_loop] = ACTIONS(2160),
    [anon_sym_match] = ACTIONS(2160),
    [anon_sym_mod] = ACTIONS(2160),
    [anon_sym_pub] = ACTIONS(2160),
    [anon_sym_return] = ACTIONS(2160),
    [anon_sym_static] = ACTIONS(2160),
    [anon_sym_struct] = ACTIONS(2160),
    [anon_sym_trait] = ACTIONS(2160),
    [anon_sym_type] = ACTIONS(2160),
    [anon_sym_union] = ACTIONS(2160),
    [anon_sym_unsafe] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2160),
    [anon_sym_while] = ACTIONS(2160),
    [anon_sym_extern] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2160),
    [anon_sym_move] = ACTIONS(2160),
    [anon_sym_try] = ACTIONS(2160),
    [sym_integer_literal] = ACTIONS(2158),
    [aux_sym_string_literal_token1] = ACTIONS(2158),
    [sym_char_literal] = ACTIONS(2158),
    [anon_sym_true] = ACTIONS(2160),
    [anon_sym_false] = ACTIONS(2160),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2160),
    [sym_super] = ACTIONS(2160),
    [sym_crate] = ACTIONS(2160),
    [sym_metavariable] = ACTIONS(2158),
    [sym__raw_string_literal_start] = ACTIONS(2158),
    [sym_float_literal] = ACTIONS(2158),
  },
  [578] = {
    [sym_line_comment] = STATE(578),
    [sym_block_comment] = STATE(578),
    [ts_builtin_sym_end] = ACTIONS(2162),
    [sym_identifier] = ACTIONS(2164),
    [anon_sym_SEMI] = ACTIONS(2162),
    [anon_sym_macro_rules_BANG] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(2162),
    [anon_sym_LBRACK] = ACTIONS(2162),
    [anon_sym_LBRACE] = ACTIONS(2162),
    [anon_sym_RBRACE] = ACTIONS(2162),
    [anon_sym_STAR] = ACTIONS(2162),
    [anon_sym_u8] = ACTIONS(2164),
    [anon_sym_i8] = ACTIONS(2164),
    [anon_sym_u16] = ACTIONS(2164),
    [anon_sym_i16] = ACTIONS(2164),
    [anon_sym_u32] = ACTIONS(2164),
    [anon_sym_i32] = ACTIONS(2164),
    [anon_sym_u64] = ACTIONS(2164),
    [anon_sym_i64] = ACTIONS(2164),
    [anon_sym_u128] = ACTIONS(2164),
    [anon_sym_i128] = ACTIONS(2164),
    [anon_sym_isize] = ACTIONS(2164),
    [anon_sym_usize] = ACTIONS(2164),
    [anon_sym_f32] = ACTIONS(2164),
    [anon_sym_f64] = ACTIONS(2164),
    [anon_sym_bool] = ACTIONS(2164),
    [anon_sym_str] = ACTIONS(2164),
    [anon_sym_char] = ACTIONS(2164),
    [anon_sym_DASH] = ACTIONS(2162),
    [anon_sym_BANG] = ACTIONS(2162),
    [anon_sym_AMP] = ACTIONS(2162),
    [anon_sym_PIPE] = ACTIONS(2162),
    [anon_sym_LT] = ACTIONS(2162),
    [anon_sym_DOT_DOT] = ACTIONS(2162),
    [anon_sym_COLON_COLON] = ACTIONS(2162),
    [anon_sym_POUND] = ACTIONS(2162),
    [anon_sym_SQUOTE] = ACTIONS(2164),
    [anon_sym_async] = ACTIONS(2164),
    [anon_sym_break] = ACTIONS(2164),
    [anon_sym_const] = ACTIONS(2164),
    [anon_sym_continue] = ACTIONS(2164),
    [anon_sym_default] = ACTIONS(2164),
    [anon_sym_enum] = ACTIONS(2164),
    [anon_sym_fn] = ACTIONS(2164),
    [anon_sym_for] = ACTIONS(2164),
    [anon_sym_if] = ACTIONS(2164),
    [anon_sym_impl] = ACTIONS(2164),
    [anon_sym_let] = ACTIONS(2164),
    [anon_sym_loop] = ACTIONS(2164),
    [anon_sym_match] = ACTIONS(2164),
    [anon_sym_mod] = ACTIONS(2164),
    [anon_sym_pub] = ACTIONS(2164),
    [anon_sym_return] = ACTIONS(2164),
    [anon_sym_static] = ACTIONS(2164),
    [anon_sym_struct] = ACTIONS(2164),
    [anon_sym_trait] = ACTIONS(2164),
    [anon_sym_type] = ACTIONS(2164),
    [anon_sym_union] = ACTIONS(2164),
    [anon_sym_unsafe] = ACTIONS(2164),
    [anon_sym_use] = ACTIONS(2164),
    [anon_sym_while] = ACTIONS(2164),
    [anon_sym_extern] = ACTIONS(2164),
    [anon_sym_yield] = ACTIONS(2164),
    [anon_sym_move] = ACTIONS(2164),
    [anon_sym_try] = ACTIONS(2164),
    [sym_integer_literal] = ACTIONS(2162),
    [aux_sym_string_literal_token1] = ACTIONS(2162),
    [sym_char_literal] = ACTIONS(2162),
    [anon_sym_true] = ACTIONS(2164),
    [anon_sym_false] = ACTIONS(2164),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2164),
    [sym_super] = ACTIONS(2164),
    [sym_crate] = ACTIONS(2164),
    [sym_metavariable] = ACTIONS(2162),
    [sym__raw_string_literal_start] = ACTIONS(2162),
    [sym_float_literal] = ACTIONS(2162),
  },
  [579] = {
    [sym_line_comment] = STATE(579),
    [sym_block_comment] = STATE(579),
    [ts_builtin_sym_end] = ACTIONS(2166),
    [sym_identifier] = ACTIONS(2168),
    [anon_sym_SEMI] = ACTIONS(2166),
    [anon_sym_macro_rules_BANG] = ACTIONS(2166),
    [anon_sym_LPAREN] = ACTIONS(2166),
    [anon_sym_LBRACK] = ACTIONS(2166),
    [anon_sym_LBRACE] = ACTIONS(2166),
    [anon_sym_RBRACE] = ACTIONS(2166),
    [anon_sym_STAR] = ACTIONS(2166),
    [anon_sym_u8] = ACTIONS(2168),
    [anon_sym_i8] = ACTIONS(2168),
    [anon_sym_u16] = ACTIONS(2168),
    [anon_sym_i16] = ACTIONS(2168),
    [anon_sym_u32] = ACTIONS(2168),
    [anon_sym_i32] = ACTIONS(2168),
    [anon_sym_u64] = ACTIONS(2168),
    [anon_sym_i64] = ACTIONS(2168),
    [anon_sym_u128] = ACTIONS(2168),
    [anon_sym_i128] = ACTIONS(2168),
    [anon_sym_isize] = ACTIONS(2168),
    [anon_sym_usize] = ACTIONS(2168),
    [anon_sym_f32] = ACTIONS(2168),
    [anon_sym_f64] = ACTIONS(2168),
    [anon_sym_bool] = ACTIONS(2168),
    [anon_sym_str] = ACTIONS(2168),
    [anon_sym_char] = ACTIONS(2168),
    [anon_sym_DASH] = ACTIONS(2166),
    [anon_sym_BANG] = ACTIONS(2166),
    [anon_sym_AMP] = ACTIONS(2166),
    [anon_sym_PIPE] = ACTIONS(2166),
    [anon_sym_LT] = ACTIONS(2166),
    [anon_sym_DOT_DOT] = ACTIONS(2166),
    [anon_sym_COLON_COLON] = ACTIONS(2166),
    [anon_sym_POUND] = ACTIONS(2166),
    [anon_sym_SQUOTE] = ACTIONS(2168),
    [anon_sym_async] = ACTIONS(2168),
    [anon_sym_break] = ACTIONS(2168),
    [anon_sym_const] = ACTIONS(2168),
    [anon_sym_continue] = ACTIONS(2168),
    [anon_sym_default] = ACTIONS(2168),
    [anon_sym_enum] = ACTIONS(2168),
    [anon_sym_fn] = ACTIONS(2168),
    [anon_sym_for] = ACTIONS(2168),
    [anon_sym_if] = ACTIONS(2168),
    [anon_sym_impl] = ACTIONS(2168),
    [anon_sym_let] = ACTIONS(2168),
    [anon_sym_loop] = ACTIONS(2168),
    [anon_sym_match] = ACTIONS(2168),
    [anon_sym_mod] = ACTIONS(2168),
    [anon_sym_pub] = ACTIONS(2168),
    [anon_sym_return] = ACTIONS(2168),
    [anon_sym_static] = ACTIONS(2168),
    [anon_sym_struct] = ACTIONS(2168),
    [anon_sym_trait] = ACTIONS(2168),
    [anon_sym_type] = ACTIONS(2168),
    [anon_sym_union] = ACTIONS(2168),
    [anon_sym_unsafe] = ACTIONS(2168),
    [anon_sym_use] = ACTIONS(2168),
    [anon_sym_while] = ACTIONS(2168),
    [anon_sym_extern] = ACTIONS(2168),
    [anon_sym_yield] = ACTIONS(2168),
    [anon_sym_move] = ACTIONS(2168),
    [anon_sym_try] = ACTIONS(2168),
    [sym_integer_literal] = ACTIONS(2166),
    [aux_sym_string_literal_token1] = ACTIONS(2166),
    [sym_char_literal] = ACTIONS(2166),
    [anon_sym_true] = ACTIONS(2168),
    [anon_sym_false] = ACTIONS(2168),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2168),
    [sym_super] = ACTIONS(2168),
    [sym_crate] = ACTIONS(2168),
    [sym_metavariable] = ACTIONS(2166),
    [sym__raw_string_literal_start] = ACTIONS(2166),
    [sym_float_literal] = ACTIONS(2166),
  },
  [580] = {
    [sym_line_comment] = STATE(580),
    [sym_block_comment] = STATE(580),
    [ts_builtin_sym_end] = ACTIONS(2170),
    [sym_identifier] = ACTIONS(2172),
    [anon_sym_SEMI] = ACTIONS(2170),
    [anon_sym_macro_rules_BANG] = ACTIONS(2170),
    [anon_sym_LPAREN] = ACTIONS(2170),
    [anon_sym_LBRACK] = ACTIONS(2170),
    [anon_sym_LBRACE] = ACTIONS(2170),
    [anon_sym_RBRACE] = ACTIONS(2170),
    [anon_sym_STAR] = ACTIONS(2170),
    [anon_sym_u8] = ACTIONS(2172),
    [anon_sym_i8] = ACTIONS(2172),
    [anon_sym_u16] = ACTIONS(2172),
    [anon_sym_i16] = ACTIONS(2172),
    [anon_sym_u32] = ACTIONS(2172),
    [anon_sym_i32] = ACTIONS(2172),
    [anon_sym_u64] = ACTIONS(2172),
    [anon_sym_i64] = ACTIONS(2172),
    [anon_sym_u128] = ACTIONS(2172),
    [anon_sym_i128] = ACTIONS(2172),
    [anon_sym_isize] = ACTIONS(2172),
    [anon_sym_usize] = ACTIONS(2172),
    [anon_sym_f32] = ACTIONS(2172),
    [anon_sym_f64] = ACTIONS(2172),
    [anon_sym_bool] = ACTIONS(2172),
    [anon_sym_str] = ACTIONS(2172),
    [anon_sym_char] = ACTIONS(2172),
    [anon_sym_DASH] = ACTIONS(2170),
    [anon_sym_BANG] = ACTIONS(2170),
    [anon_sym_AMP] = ACTIONS(2170),
    [anon_sym_PIPE] = ACTIONS(2170),
    [anon_sym_LT] = ACTIONS(2170),
    [anon_sym_DOT_DOT] = ACTIONS(2170),
    [anon_sym_COLON_COLON] = ACTIONS(2170),
    [anon_sym_POUND] = ACTIONS(2170),
    [anon_sym_SQUOTE] = ACTIONS(2172),
    [anon_sym_async] = ACTIONS(2172),
    [anon_sym_break] = ACTIONS(2172),
    [anon_sym_const] = ACTIONS(2172),
    [anon_sym_continue] = ACTIONS(2172),
    [anon_sym_default] = ACTIONS(2172),
    [anon_sym_enum] = ACTIONS(2172),
    [anon_sym_fn] = ACTIONS(2172),
    [anon_sym_for] = ACTIONS(2172),
    [anon_sym_if] = ACTIONS(2172),
    [anon_sym_impl] = ACTIONS(2172),
    [anon_sym_let] = ACTIONS(2172),
    [anon_sym_loop] = ACTIONS(2172),
    [anon_sym_match] = ACTIONS(2172),
    [anon_sym_mod] = ACTIONS(2172),
    [anon_sym_pub] = ACTIONS(2172),
    [anon_sym_return] = ACTIONS(2172),
    [anon_sym_static] = ACTIONS(2172),
    [anon_sym_struct] = ACTIONS(2172),
    [anon_sym_trait] = ACTIONS(2172),
    [anon_sym_type] = ACTIONS(2172),
    [anon_sym_union] = ACTIONS(2172),
    [anon_sym_unsafe] = ACTIONS(2172),
    [anon_sym_use] = ACTIONS(2172),
    [anon_sym_while] = ACTIONS(2172),
    [anon_sym_extern] = ACTIONS(2172),
    [anon_sym_yield] = ACTIONS(2172),
    [anon_sym_move] = ACTIONS(2172),
    [anon_sym_try] = ACTIONS(2172),
    [sym_integer_literal] = ACTIONS(2170),
    [aux_sym_string_literal_token1] = ACTIONS(2170),
    [sym_char_literal] = ACTIONS(2170),
    [anon_sym_true] = ACTIONS(2172),
    [anon_sym_false] = ACTIONS(2172),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2172),
    [sym_super] = ACTIONS(2172),
    [sym_crate] = ACTIONS(2172),
    [sym_metavariable] = ACTIONS(2170),
    [sym__raw_string_literal_start] = ACTIONS(2170),
    [sym_float_literal] = ACTIONS(2170),
  },
  [581] = {
    [sym_empty_statement] = STATE(1143),
    [sym_macro_definition] = STATE(1143),
    [sym_attribute_item] = STATE(1143),
    [sym_inner_attribute_item] = STATE(1143),
    [sym_mod_item] = STATE(1143),
    [sym_foreign_mod_item] = STATE(1143),
    [sym_struct_item] = STATE(1143),
    [sym_union_item] = STATE(1143),
    [sym_enum_item] = STATE(1143),
    [sym_extern_crate_declaration] = STATE(1143),
    [sym_const_item] = STATE(1143),
    [sym_static_item] = STATE(1143),
    [sym_type_item] = STATE(1143),
    [sym_function_item] = STATE(1143),
    [sym_function_signature_item] = STATE(1143),
    [sym_function_modifiers] = STATE(3583),
    [sym_impl_item] = STATE(1143),
    [sym_trait_item] = STATE(1143),
    [sym_associated_type] = STATE(1143),
    [sym_let_declaration] = STATE(1143),
    [sym_use_declaration] = STATE(1143),
    [sym_extern_modifier] = STATE(2167),
    [sym_visibility_modifier] = STATE(1927),
    [sym_bracketed_type] = STATE(3307),
    [sym_generic_type_with_turbofish] = STATE(3333),
    [sym_macro_invocation] = STATE(1143),
    [sym_scoped_identifier] = STATE(3206),
    [sym_line_comment] = STATE(581),
    [sym_block_comment] = STATE(581),
    [aux_sym_declaration_list_repeat1] = STATE(525),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(1846),
    [anon_sym_SEMI] = ACTIONS(1848),
    [anon_sym_macro_rules_BANG] = ACTIONS(1850),
    [anon_sym_RBRACE] = ACTIONS(2174),
    [anon_sym_u8] = ACTIONS(1854),
    [anon_sym_i8] = ACTIONS(1854),
    [anon_sym_u16] = ACTIONS(1854),
    [anon_sym_i16] = ACTIONS(1854),
    [anon_sym_u32] = ACTIONS(1854),
    [anon_sym_i32] = ACTIONS(1854),
    [anon_sym_u64] = ACTIONS(1854),
    [anon_sym_i64] = ACTIONS(1854),
    [anon_sym_u128] = ACTIONS(1854),
    [anon_sym_i128] = ACTIONS(1854),
    [anon_sym_isize] = ACTIONS(1854),
    [anon_sym_usize] = ACTIONS(1854),
    [anon_sym_f32] = ACTIONS(1854),
    [anon_sym_f64] = ACTIONS(1854),
    [anon_sym_bool] = ACTIONS(1854),
    [anon_sym_str] = ACTIONS(1854),
    [anon_sym_char] = ACTIONS(1854),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1856),
    [anon_sym_POUND] = ACTIONS(1858),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1860),
    [anon_sym_default] = ACTIONS(1862),
    [anon_sym_enum] = ACTIONS(1864),
    [anon_sym_fn] = ACTIONS(1866),
    [anon_sym_impl] = ACTIONS(1868),
    [anon_sym_let] = ACTIONS(1870),
    [anon_sym_mod] = ACTIONS(1872),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(1874),
    [anon_sym_struct] = ACTIONS(1876),
    [anon_sym_trait] = ACTIONS(1878),
    [anon_sym_type] = ACTIONS(1880),
    [anon_sym_union] = ACTIONS(1882),
    [anon_sym_unsafe] = ACTIONS(1884),
    [anon_sym_use] = ACTIONS(1886),
    [anon_sym_extern] = ACTIONS(1888),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1890),
    [sym_super] = ACTIONS(1890),
    [sym_crate] = ACTIONS(1892),
    [sym_metavariable] = ACTIONS(1894),
  },
  [582] = {
    [sym_line_comment] = STATE(582),
    [sym_block_comment] = STATE(582),
    [ts_builtin_sym_end] = ACTIONS(2176),
    [sym_identifier] = ACTIONS(2178),
    [anon_sym_SEMI] = ACTIONS(2176),
    [anon_sym_macro_rules_BANG] = ACTIONS(2176),
    [anon_sym_LPAREN] = ACTIONS(2176),
    [anon_sym_LBRACK] = ACTIONS(2176),
    [anon_sym_LBRACE] = ACTIONS(2176),
    [anon_sym_RBRACE] = ACTIONS(2176),
    [anon_sym_STAR] = ACTIONS(2176),
    [anon_sym_u8] = ACTIONS(2178),
    [anon_sym_i8] = ACTIONS(2178),
    [anon_sym_u16] = ACTIONS(2178),
    [anon_sym_i16] = ACTIONS(2178),
    [anon_sym_u32] = ACTIONS(2178),
    [anon_sym_i32] = ACTIONS(2178),
    [anon_sym_u64] = ACTIONS(2178),
    [anon_sym_i64] = ACTIONS(2178),
    [anon_sym_u128] = ACTIONS(2178),
    [anon_sym_i128] = ACTIONS(2178),
    [anon_sym_isize] = ACTIONS(2178),
    [anon_sym_usize] = ACTIONS(2178),
    [anon_sym_f32] = ACTIONS(2178),
    [anon_sym_f64] = ACTIONS(2178),
    [anon_sym_bool] = ACTIONS(2178),
    [anon_sym_str] = ACTIONS(2178),
    [anon_sym_char] = ACTIONS(2178),
    [anon_sym_DASH] = ACTIONS(2176),
    [anon_sym_BANG] = ACTIONS(2176),
    [anon_sym_AMP] = ACTIONS(2176),
    [anon_sym_PIPE] = ACTIONS(2176),
    [anon_sym_LT] = ACTIONS(2176),
    [anon_sym_DOT_DOT] = ACTIONS(2176),
    [anon_sym_COLON_COLON] = ACTIONS(2176),
    [anon_sym_POUND] = ACTIONS(2176),
    [anon_sym_SQUOTE] = ACTIONS(2178),
    [anon_sym_async] = ACTIONS(2178),
    [anon_sym_break] = ACTIONS(2178),
    [anon_sym_const] = ACTIONS(2178),
    [anon_sym_continue] = ACTIONS(2178),
    [anon_sym_default] = ACTIONS(2178),
    [anon_sym_enum] = ACTIONS(2178),
    [anon_sym_fn] = ACTIONS(2178),
    [anon_sym_for] = ACTIONS(2178),
    [anon_sym_if] = ACTIONS(2178),
    [anon_sym_impl] = ACTIONS(2178),
    [anon_sym_let] = ACTIONS(2178),
    [anon_sym_loop] = ACTIONS(2178),
    [anon_sym_match] = ACTIONS(2178),
    [anon_sym_mod] = ACTIONS(2178),
    [anon_sym_pub] = ACTIONS(2178),
    [anon_sym_return] = ACTIONS(2178),
    [anon_sym_static] = ACTIONS(2178),
    [anon_sym_struct] = ACTIONS(2178),
    [anon_sym_trait] = ACTIONS(2178),
    [anon_sym_type] = ACTIONS(2178),
    [anon_sym_union] = ACTIONS(2178),
    [anon_sym_unsafe] = ACTIONS(2178),
    [anon_sym_use] = ACTIONS(2178),
    [anon_sym_while] = ACTIONS(2178),
    [anon_sym_extern] = ACTIONS(2178),
    [anon_sym_yield] = ACTIONS(2178),
    [anon_sym_move] = ACTIONS(2178),
    [anon_sym_try] = ACTIONS(2178),
    [sym_integer_literal] = ACTIONS(2176),
    [aux_sym_string_literal_token1] = ACTIONS(2176),
    [sym_char_literal] = ACTIONS(2176),
    [anon_sym_true] = ACTIONS(2178),
    [anon_sym_false] = ACTIONS(2178),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2178),
    [sym_super] = ACTIONS(2178),
    [sym_crate] = ACTIONS(2178),
    [sym_metavariable] = ACTIONS(2176),
    [sym__raw_string_literal_start] = ACTIONS(2176),
    [sym_float_literal] = ACTIONS(2176),
  },
  [583] = {
    [sym_line_comment] = STATE(583),
    [sym_block_comment] = STATE(583),
    [ts_builtin_sym_end] = ACTIONS(2180),
    [sym_identifier] = ACTIONS(2182),
    [anon_sym_SEMI] = ACTIONS(2180),
    [anon_sym_macro_rules_BANG] = ACTIONS(2180),
    [anon_sym_LPAREN] = ACTIONS(2180),
    [anon_sym_LBRACK] = ACTIONS(2180),
    [anon_sym_LBRACE] = ACTIONS(2180),
    [anon_sym_RBRACE] = ACTIONS(2180),
    [anon_sym_STAR] = ACTIONS(2180),
    [anon_sym_u8] = ACTIONS(2182),
    [anon_sym_i8] = ACTIONS(2182),
    [anon_sym_u16] = ACTIONS(2182),
    [anon_sym_i16] = ACTIONS(2182),
    [anon_sym_u32] = ACTIONS(2182),
    [anon_sym_i32] = ACTIONS(2182),
    [anon_sym_u64] = ACTIONS(2182),
    [anon_sym_i64] = ACTIONS(2182),
    [anon_sym_u128] = ACTIONS(2182),
    [anon_sym_i128] = ACTIONS(2182),
    [anon_sym_isize] = ACTIONS(2182),
    [anon_sym_usize] = ACTIONS(2182),
    [anon_sym_f32] = ACTIONS(2182),
    [anon_sym_f64] = ACTIONS(2182),
    [anon_sym_bool] = ACTIONS(2182),
    [anon_sym_str] = ACTIONS(2182),
    [anon_sym_char] = ACTIONS(2182),
    [anon_sym_DASH] = ACTIONS(2180),
    [anon_sym_BANG] = ACTIONS(2180),
    [anon_sym_AMP] = ACTIONS(2180),
    [anon_sym_PIPE] = ACTIONS(2180),
    [anon_sym_LT] = ACTIONS(2180),
    [anon_sym_DOT_DOT] = ACTIONS(2180),
    [anon_sym_COLON_COLON] = ACTIONS(2180),
    [anon_sym_POUND] = ACTIONS(2180),
    [anon_sym_SQUOTE] = ACTIONS(2182),
    [anon_sym_async] = ACTIONS(2182),
    [anon_sym_break] = ACTIONS(2182),
    [anon_sym_const] = ACTIONS(2182),
    [anon_sym_continue] = ACTIONS(2182),
    [anon_sym_default] = ACTIONS(2182),
    [anon_sym_enum] = ACTIONS(2182),
    [anon_sym_fn] = ACTIONS(2182),
    [anon_sym_for] = ACTIONS(2182),
    [anon_sym_if] = ACTIONS(2182),
    [anon_sym_impl] = ACTIONS(2182),
    [anon_sym_let] = ACTIONS(2182),
    [anon_sym_loop] = ACTIONS(2182),
    [anon_sym_match] = ACTIONS(2182),
    [anon_sym_mod] = ACTIONS(2182),
    [anon_sym_pub] = ACTIONS(2182),
    [anon_sym_return] = ACTIONS(2182),
    [anon_sym_static] = ACTIONS(2182),
    [anon_sym_struct] = ACTIONS(2182),
    [anon_sym_trait] = ACTIONS(2182),
    [anon_sym_type] = ACTIONS(2182),
    [anon_sym_union] = ACTIONS(2182),
    [anon_sym_unsafe] = ACTIONS(2182),
    [anon_sym_use] = ACTIONS(2182),
    [anon_sym_while] = ACTIONS(2182),
    [anon_sym_extern] = ACTIONS(2182),
    [anon_sym_yield] = ACTIONS(2182),
    [anon_sym_move] = ACTIONS(2182),
    [anon_sym_try] = ACTIONS(2182),
    [sym_integer_literal] = ACTIONS(2180),
    [aux_sym_string_literal_token1] = ACTIONS(2180),
    [sym_char_literal] = ACTIONS(2180),
    [anon_sym_true] = ACTIONS(2182),
    [anon_sym_false] = ACTIONS(2182),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2182),
    [sym_super] = ACTIONS(2182),
    [sym_crate] = ACTIONS(2182),
    [sym_metavariable] = ACTIONS(2180),
    [sym__raw_string_literal_start] = ACTIONS(2180),
    [sym_float_literal] = ACTIONS(2180),
  },
  [584] = {
    [sym_line_comment] = STATE(584),
    [sym_block_comment] = STATE(584),
    [ts_builtin_sym_end] = ACTIONS(2184),
    [sym_identifier] = ACTIONS(2186),
    [anon_sym_SEMI] = ACTIONS(2184),
    [anon_sym_macro_rules_BANG] = ACTIONS(2184),
    [anon_sym_LPAREN] = ACTIONS(2184),
    [anon_sym_LBRACK] = ACTIONS(2184),
    [anon_sym_LBRACE] = ACTIONS(2184),
    [anon_sym_RBRACE] = ACTIONS(2184),
    [anon_sym_STAR] = ACTIONS(2184),
    [anon_sym_u8] = ACTIONS(2186),
    [anon_sym_i8] = ACTIONS(2186),
    [anon_sym_u16] = ACTIONS(2186),
    [anon_sym_i16] = ACTIONS(2186),
    [anon_sym_u32] = ACTIONS(2186),
    [anon_sym_i32] = ACTIONS(2186),
    [anon_sym_u64] = ACTIONS(2186),
    [anon_sym_i64] = ACTIONS(2186),
    [anon_sym_u128] = ACTIONS(2186),
    [anon_sym_i128] = ACTIONS(2186),
    [anon_sym_isize] = ACTIONS(2186),
    [anon_sym_usize] = ACTIONS(2186),
    [anon_sym_f32] = ACTIONS(2186),
    [anon_sym_f64] = ACTIONS(2186),
    [anon_sym_bool] = ACTIONS(2186),
    [anon_sym_str] = ACTIONS(2186),
    [anon_sym_char] = ACTIONS(2186),
    [anon_sym_DASH] = ACTIONS(2184),
    [anon_sym_BANG] = ACTIONS(2184),
    [anon_sym_AMP] = ACTIONS(2184),
    [anon_sym_PIPE] = ACTIONS(2184),
    [anon_sym_LT] = ACTIONS(2184),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_COLON_COLON] = ACTIONS(2184),
    [anon_sym_POUND] = ACTIONS(2184),
    [anon_sym_SQUOTE] = ACTIONS(2186),
    [anon_sym_async] = ACTIONS(2186),
    [anon_sym_break] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_continue] = ACTIONS(2186),
    [anon_sym_default] = ACTIONS(2186),
    [anon_sym_enum] = ACTIONS(2186),
    [anon_sym_fn] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_impl] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_loop] = ACTIONS(2186),
    [anon_sym_match] = ACTIONS(2186),
    [anon_sym_mod] = ACTIONS(2186),
    [anon_sym_pub] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_static] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_trait] = ACTIONS(2186),
    [anon_sym_type] = ACTIONS(2186),
    [anon_sym_union] = ACTIONS(2186),
    [anon_sym_unsafe] = ACTIONS(2186),
    [anon_sym_use] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [anon_sym_extern] = ACTIONS(2186),
    [anon_sym_yield] = ACTIONS(2186),
    [anon_sym_move] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [sym_integer_literal] = ACTIONS(2184),
    [aux_sym_string_literal_token1] = ACTIONS(2184),
    [sym_char_literal] = ACTIONS(2184),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2186),
    [sym_super] = ACTIONS(2186),
    [sym_crate] = ACTIONS(2186),
    [sym_metavariable] = ACTIONS(2184),
    [sym__raw_string_literal_start] = ACTIONS(2184),
    [sym_float_literal] = ACTIONS(2184),
  },
  [585] = {
    [sym_line_comment] = STATE(585),
    [sym_block_comment] = STATE(585),
    [ts_builtin_sym_end] = ACTIONS(2188),
    [sym_identifier] = ACTIONS(2190),
    [anon_sym_SEMI] = ACTIONS(2188),
    [anon_sym_macro_rules_BANG] = ACTIONS(2188),
    [anon_sym_LPAREN] = ACTIONS(2188),
    [anon_sym_LBRACK] = ACTIONS(2188),
    [anon_sym_LBRACE] = ACTIONS(2188),
    [anon_sym_RBRACE] = ACTIONS(2188),
    [anon_sym_STAR] = ACTIONS(2188),
    [anon_sym_u8] = ACTIONS(2190),
    [anon_sym_i8] = ACTIONS(2190),
    [anon_sym_u16] = ACTIONS(2190),
    [anon_sym_i16] = ACTIONS(2190),
    [anon_sym_u32] = ACTIONS(2190),
    [anon_sym_i32] = ACTIONS(2190),
    [anon_sym_u64] = ACTIONS(2190),
    [anon_sym_i64] = ACTIONS(2190),
    [anon_sym_u128] = ACTIONS(2190),
    [anon_sym_i128] = ACTIONS(2190),
    [anon_sym_isize] = ACTIONS(2190),
    [anon_sym_usize] = ACTIONS(2190),
    [anon_sym_f32] = ACTIONS(2190),
    [anon_sym_f64] = ACTIONS(2190),
    [anon_sym_bool] = ACTIONS(2190),
    [anon_sym_str] = ACTIONS(2190),
    [anon_sym_char] = ACTIONS(2190),
    [anon_sym_DASH] = ACTIONS(2188),
    [anon_sym_BANG] = ACTIONS(2188),
    [anon_sym_AMP] = ACTIONS(2188),
    [anon_sym_PIPE] = ACTIONS(2188),
    [anon_sym_LT] = ACTIONS(2188),
    [anon_sym_DOT_DOT] = ACTIONS(2188),
    [anon_sym_COLON_COLON] = ACTIONS(2188),
    [anon_sym_POUND] = ACTIONS(2188),
    [anon_sym_SQUOTE] = ACTIONS(2190),
    [anon_sym_async] = ACTIONS(2190),
    [anon_sym_break] = ACTIONS(2190),
    [anon_sym_const] = ACTIONS(2190),
    [anon_sym_continue] = ACTIONS(2190),
    [anon_sym_default] = ACTIONS(2190),
    [anon_sym_enum] = ACTIONS(2190),
    [anon_sym_fn] = ACTIONS(2190),
    [anon_sym_for] = ACTIONS(2190),
    [anon_sym_if] = ACTIONS(2190),
    [anon_sym_impl] = ACTIONS(2190),
    [anon_sym_let] = ACTIONS(2190),
    [anon_sym_loop] = ACTIONS(2190),
    [anon_sym_match] = ACTIONS(2190),
    [anon_sym_mod] = ACTIONS(2190),
    [anon_sym_pub] = ACTIONS(2190),
    [anon_sym_return] = ACTIONS(2190),
    [anon_sym_static] = ACTIONS(2190),
    [anon_sym_struct] = ACTIONS(2190),
    [anon_sym_trait] = ACTIONS(2190),
    [anon_sym_type] = ACTIONS(2190),
    [anon_sym_union] = ACTIONS(2190),
    [anon_sym_unsafe] = ACTIONS(2190),
    [anon_sym_use] = ACTIONS(2190),
    [anon_sym_while] = ACTIONS(2190),
    [anon_sym_extern] = ACTIONS(2190),
    [anon_sym_yield] = ACTIONS(2190),
    [anon_sym_move] = ACTIONS(2190),
    [anon_sym_try] = ACTIONS(2190),
    [sym_integer_literal] = ACTIONS(2188),
    [aux_sym_string_literal_token1] = ACTIONS(2188),
    [sym_char_literal] = ACTIONS(2188),
    [anon_sym_true] = ACTIONS(2190),
    [anon_sym_false] = ACTIONS(2190),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2190),
    [sym_super] = ACTIONS(2190),
    [sym_crate] = ACTIONS(2190),
    [sym_metavariable] = ACTIONS(2188),
    [sym__raw_string_literal_start] = ACTIONS(2188),
    [sym_float_literal] = ACTIONS(2188),
  },
  [586] = {
    [sym_line_comment] = STATE(586),
    [sym_block_comment] = STATE(586),
    [ts_builtin_sym_end] = ACTIONS(2192),
    [sym_identifier] = ACTIONS(2194),
    [anon_sym_SEMI] = ACTIONS(2192),
    [anon_sym_macro_rules_BANG] = ACTIONS(2192),
    [anon_sym_LPAREN] = ACTIONS(2192),
    [anon_sym_LBRACK] = ACTIONS(2192),
    [anon_sym_LBRACE] = ACTIONS(2192),
    [anon_sym_RBRACE] = ACTIONS(2192),
    [anon_sym_STAR] = ACTIONS(2192),
    [anon_sym_u8] = ACTIONS(2194),
    [anon_sym_i8] = ACTIONS(2194),
    [anon_sym_u16] = ACTIONS(2194),
    [anon_sym_i16] = ACTIONS(2194),
    [anon_sym_u32] = ACTIONS(2194),
    [anon_sym_i32] = ACTIONS(2194),
    [anon_sym_u64] = ACTIONS(2194),
    [anon_sym_i64] = ACTIONS(2194),
    [anon_sym_u128] = ACTIONS(2194),
    [anon_sym_i128] = ACTIONS(2194),
    [anon_sym_isize] = ACTIONS(2194),
    [anon_sym_usize] = ACTIONS(2194),
    [anon_sym_f32] = ACTIONS(2194),
    [anon_sym_f64] = ACTIONS(2194),
    [anon_sym_bool] = ACTIONS(2194),
    [anon_sym_str] = ACTIONS(2194),
    [anon_sym_char] = ACTIONS(2194),
    [anon_sym_DASH] = ACTIONS(2192),
    [anon_sym_BANG] = ACTIONS(2192),
    [anon_sym_AMP] = ACTIONS(2192),
    [anon_sym_PIPE] = ACTIONS(2192),
    [anon_sym_LT] = ACTIONS(2192),
    [anon_sym_DOT_DOT] = ACTIONS(2192),
    [anon_sym_COLON_COLON] = ACTIONS(2192),
    [anon_sym_POUND] = ACTIONS(2192),
    [anon_sym_SQUOTE] = ACTIONS(2194),
    [anon_sym_async] = ACTIONS(2194),
    [anon_sym_break] = ACTIONS(2194),
    [anon_sym_const] = ACTIONS(2194),
    [anon_sym_continue] = ACTIONS(2194),
    [anon_sym_default] = ACTIONS(2194),
    [anon_sym_enum] = ACTIONS(2194),
    [anon_sym_fn] = ACTIONS(2194),
    [anon_sym_for] = ACTIONS(2194),
    [anon_sym_if] = ACTIONS(2194),
    [anon_sym_impl] = ACTIONS(2194),
    [anon_sym_let] = ACTIONS(2194),
    [anon_sym_loop] = ACTIONS(2194),
    [anon_sym_match] = ACTIONS(2194),
    [anon_sym_mod] = ACTIONS(2194),
    [anon_sym_pub] = ACTIONS(2194),
    [anon_sym_return] = ACTIONS(2194),
    [anon_sym_static] = ACTIONS(2194),
    [anon_sym_struct] = ACTIONS(2194),
    [anon_sym_trait] = ACTIONS(2194),
    [anon_sym_type] = ACTIONS(2194),
    [anon_sym_union] = ACTIONS(2194),
    [anon_sym_unsafe] = ACTIONS(2194),
    [anon_sym_use] = ACTIONS(2194),
    [anon_sym_while] = ACTIONS(2194),
    [anon_sym_extern] = ACTIONS(2194),
    [anon_sym_yield] = ACTIONS(2194),
    [anon_sym_move] = ACTIONS(2194),
    [anon_sym_try] = ACTIONS(2194),
    [sym_integer_literal] = ACTIONS(2192),
    [aux_sym_string_literal_token1] = ACTIONS(2192),
    [sym_char_literal] = ACTIONS(2192),
    [anon_sym_true] = ACTIONS(2194),
    [anon_sym_false] = ACTIONS(2194),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2194),
    [sym_super] = ACTIONS(2194),
    [sym_crate] = ACTIONS(2194),
    [sym_metavariable] = ACTIONS(2192),
    [sym__raw_string_literal_start] = ACTIONS(2192),
    [sym_float_literal] = ACTIONS(2192),
  },
  [587] = {
    [sym_line_comment] = STATE(587),
    [sym_block_comment] = STATE(587),
    [ts_builtin_sym_end] = ACTIONS(2196),
    [sym_identifier] = ACTIONS(2198),
    [anon_sym_SEMI] = ACTIONS(2196),
    [anon_sym_macro_rules_BANG] = ACTIONS(2196),
    [anon_sym_LPAREN] = ACTIONS(2196),
    [anon_sym_LBRACK] = ACTIONS(2196),
    [anon_sym_LBRACE] = ACTIONS(2196),
    [anon_sym_RBRACE] = ACTIONS(2196),
    [anon_sym_STAR] = ACTIONS(2196),
    [anon_sym_u8] = ACTIONS(2198),
    [anon_sym_i8] = ACTIONS(2198),
    [anon_sym_u16] = ACTIONS(2198),
    [anon_sym_i16] = ACTIONS(2198),
    [anon_sym_u32] = ACTIONS(2198),
    [anon_sym_i32] = ACTIONS(2198),
    [anon_sym_u64] = ACTIONS(2198),
    [anon_sym_i64] = ACTIONS(2198),
    [anon_sym_u128] = ACTIONS(2198),
    [anon_sym_i128] = ACTIONS(2198),
    [anon_sym_isize] = ACTIONS(2198),
    [anon_sym_usize] = ACTIONS(2198),
    [anon_sym_f32] = ACTIONS(2198),
    [anon_sym_f64] = ACTIONS(2198),
    [anon_sym_bool] = ACTIONS(2198),
    [anon_sym_str] = ACTIONS(2198),
    [anon_sym_char] = ACTIONS(2198),
    [anon_sym_DASH] = ACTIONS(2196),
    [anon_sym_BANG] = ACTIONS(2196),
    [anon_sym_AMP] = ACTIONS(2196),
    [anon_sym_PIPE] = ACTIONS(2196),
    [anon_sym_LT] = ACTIONS(2196),
    [anon_sym_DOT_DOT] = ACTIONS(2196),
    [anon_sym_COLON_COLON] = ACTIONS(2196),
    [anon_sym_POUND] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(2198),
    [anon_sym_async] = ACTIONS(2198),
    [anon_sym_break] = ACTIONS(2198),
    [anon_sym_const] = ACTIONS(2198),
    [anon_sym_continue] = ACTIONS(2198),
    [anon_sym_default] = ACTIONS(2198),
    [anon_sym_enum] = ACTIONS(2198),
    [anon_sym_fn] = ACTIONS(2198),
    [anon_sym_for] = ACTIONS(2198),
    [anon_sym_if] = ACTIONS(2198),
    [anon_sym_impl] = ACTIONS(2198),
    [anon_sym_let] = ACTIONS(2198),
    [anon_sym_loop] = ACTIONS(2198),
    [anon_sym_match] = ACTIONS(2198),
    [anon_sym_mod] = ACTIONS(2198),
    [anon_sym_pub] = ACTIONS(2198),
    [anon_sym_return] = ACTIONS(2198),
    [anon_sym_static] = ACTIONS(2198),
    [anon_sym_struct] = ACTIONS(2198),
    [anon_sym_trait] = ACTIONS(2198),
    [anon_sym_type] = ACTIONS(2198),
    [anon_sym_union] = ACTIONS(2198),
    [anon_sym_unsafe] = ACTIONS(2198),
    [anon_sym_use] = ACTIONS(2198),
    [anon_sym_while] = ACTIONS(2198),
    [anon_sym_extern] = ACTIONS(2198),
    [anon_sym_yield] = ACTIONS(2198),
    [anon_sym_move] = ACTIONS(2198),
    [anon_sym_try] = ACTIONS(2198),
    [sym_integer_literal] = ACTIONS(2196),
    [aux_sym_string_literal_token1] = ACTIONS(2196),
    [sym_char_literal] = ACTIONS(2196),
    [anon_sym_true] = ACTIONS(2198),
    [anon_sym_false] = ACTIONS(2198),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2198),
    [sym_super] = ACTIONS(2198),
    [sym_crate] = ACTIONS(2198),
    [sym_metavariable] = ACTIONS(2196),
    [sym__raw_string_literal_start] = ACTIONS(2196),
    [sym_float_literal] = ACTIONS(2196),
  },
  [588] = {
    [sym_line_comment] = STATE(588),
    [sym_block_comment] = STATE(588),
    [ts_builtin_sym_end] = ACTIONS(2200),
    [sym_identifier] = ACTIONS(2202),
    [anon_sym_SEMI] = ACTIONS(2200),
    [anon_sym_macro_rules_BANG] = ACTIONS(2200),
    [anon_sym_LPAREN] = ACTIONS(2200),
    [anon_sym_LBRACK] = ACTIONS(2200),
    [anon_sym_LBRACE] = ACTIONS(2200),
    [anon_sym_RBRACE] = ACTIONS(2200),
    [anon_sym_STAR] = ACTIONS(2200),
    [anon_sym_u8] = ACTIONS(2202),
    [anon_sym_i8] = ACTIONS(2202),
    [anon_sym_u16] = ACTIONS(2202),
    [anon_sym_i16] = ACTIONS(2202),
    [anon_sym_u32] = ACTIONS(2202),
    [anon_sym_i32] = ACTIONS(2202),
    [anon_sym_u64] = ACTIONS(2202),
    [anon_sym_i64] = ACTIONS(2202),
    [anon_sym_u128] = ACTIONS(2202),
    [anon_sym_i128] = ACTIONS(2202),
    [anon_sym_isize] = ACTIONS(2202),
    [anon_sym_usize] = ACTIONS(2202),
    [anon_sym_f32] = ACTIONS(2202),
    [anon_sym_f64] = ACTIONS(2202),
    [anon_sym_bool] = ACTIONS(2202),
    [anon_sym_str] = ACTIONS(2202),
    [anon_sym_char] = ACTIONS(2202),
    [anon_sym_DASH] = ACTIONS(2200),
    [anon_sym_BANG] = ACTIONS(2200),
    [anon_sym_AMP] = ACTIONS(2200),
    [anon_sym_PIPE] = ACTIONS(2200),
    [anon_sym_LT] = ACTIONS(2200),
    [anon_sym_DOT_DOT] = ACTIONS(2200),
    [anon_sym_COLON_COLON] = ACTIONS(2200),
    [anon_sym_POUND] = ACTIONS(2200),
    [anon_sym_SQUOTE] = ACTIONS(2202),
    [anon_sym_async] = ACTIONS(2202),
    [anon_sym_break] = ACTIONS(2202),
    [anon_sym_const] = ACTIONS(2202),
    [anon_sym_continue] = ACTIONS(2202),
    [anon_sym_default] = ACTIONS(2202),
    [anon_sym_enum] = ACTIONS(2202),
    [anon_sym_fn] = ACTIONS(2202),
    [anon_sym_for] = ACTIONS(2202),
    [anon_sym_if] = ACTIONS(2202),
    [anon_sym_impl] = ACTIONS(2202),
    [anon_sym_let] = ACTIONS(2202),
    [anon_sym_loop] = ACTIONS(2202),
    [anon_sym_match] = ACTIONS(2202),
    [anon_sym_mod] = ACTIONS(2202),
    [anon_sym_pub] = ACTIONS(2202),
    [anon_sym_return] = ACTIONS(2202),
    [anon_sym_static] = ACTIONS(2202),
    [anon_sym_struct] = ACTIONS(2202),
    [anon_sym_trait] = ACTIONS(2202),
    [anon_sym_type] = ACTIONS(2202),
    [anon_sym_union] = ACTIONS(2202),
    [anon_sym_unsafe] = ACTIONS(2202),
    [anon_sym_use] = ACTIONS(2202),
    [anon_sym_while] = ACTIONS(2202),
    [anon_sym_extern] = ACTIONS(2202),
    [anon_sym_yield] = ACTIONS(2202),
    [anon_sym_move] = ACTIONS(2202),
    [anon_sym_try] = ACTIONS(2202),
    [sym_integer_literal] = ACTIONS(2200),
    [aux_sym_string_literal_token1] = ACTIONS(2200),
    [sym_char_literal] = ACTIONS(2200),
    [anon_sym_true] = ACTIONS(2202),
    [anon_sym_false] = ACTIONS(2202),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2202),
    [sym_super] = ACTIONS(2202),
    [sym_crate] = ACTIONS(2202),
    [sym_metavariable] = ACTIONS(2200),
    [sym__raw_string_literal_start] = ACTIONS(2200),
    [sym_float_literal] = ACTIONS(2200),
  },
  [589] = {
    [sym_line_comment] = STATE(589),
    [sym_block_comment] = STATE(589),
    [ts_builtin_sym_end] = ACTIONS(2204),
    [sym_identifier] = ACTIONS(2206),
    [anon_sym_SEMI] = ACTIONS(2204),
    [anon_sym_macro_rules_BANG] = ACTIONS(2204),
    [anon_sym_LPAREN] = ACTIONS(2204),
    [anon_sym_LBRACK] = ACTIONS(2204),
    [anon_sym_LBRACE] = ACTIONS(2204),
    [anon_sym_RBRACE] = ACTIONS(2204),
    [anon_sym_STAR] = ACTIONS(2204),
    [anon_sym_u8] = ACTIONS(2206),
    [anon_sym_i8] = ACTIONS(2206),
    [anon_sym_u16] = ACTIONS(2206),
    [anon_sym_i16] = ACTIONS(2206),
    [anon_sym_u32] = ACTIONS(2206),
    [anon_sym_i32] = ACTIONS(2206),
    [anon_sym_u64] = ACTIONS(2206),
    [anon_sym_i64] = ACTIONS(2206),
    [anon_sym_u128] = ACTIONS(2206),
    [anon_sym_i128] = ACTIONS(2206),
    [anon_sym_isize] = ACTIONS(2206),
    [anon_sym_usize] = ACTIONS(2206),
    [anon_sym_f32] = ACTIONS(2206),
    [anon_sym_f64] = ACTIONS(2206),
    [anon_sym_bool] = ACTIONS(2206),
    [anon_sym_str] = ACTIONS(2206),
    [anon_sym_char] = ACTIONS(2206),
    [anon_sym_DASH] = ACTIONS(2204),
    [anon_sym_BANG] = ACTIONS(2204),
    [anon_sym_AMP] = ACTIONS(2204),
    [anon_sym_PIPE] = ACTIONS(2204),
    [anon_sym_LT] = ACTIONS(2204),
    [anon_sym_DOT_DOT] = ACTIONS(2204),
    [anon_sym_COLON_COLON] = ACTIONS(2204),
    [anon_sym_POUND] = ACTIONS(2204),
    [anon_sym_SQUOTE] = ACTIONS(2206),
    [anon_sym_async] = ACTIONS(2206),
    [anon_sym_break] = ACTIONS(2206),
    [anon_sym_const] = ACTIONS(2206),
    [anon_sym_continue] = ACTIONS(2206),
    [anon_sym_default] = ACTIONS(2206),
    [anon_sym_enum] = ACTIONS(2206),
    [anon_sym_fn] = ACTIONS(2206),
    [anon_sym_for] = ACTIONS(2206),
    [anon_sym_if] = ACTIONS(2206),
    [anon_sym_impl] = ACTIONS(2206),
    [anon_sym_let] = ACTIONS(2206),
    [anon_sym_loop] = ACTIONS(2206),
    [anon_sym_match] = ACTIONS(2206),
    [anon_sym_mod] = ACTIONS(2206),
    [anon_sym_pub] = ACTIONS(2206),
    [anon_sym_return] = ACTIONS(2206),
    [anon_sym_static] = ACTIONS(2206),
    [anon_sym_struct] = ACTIONS(2206),
    [anon_sym_trait] = ACTIONS(2206),
    [anon_sym_type] = ACTIONS(2206),
    [anon_sym_union] = ACTIONS(2206),
    [anon_sym_unsafe] = ACTIONS(2206),
    [anon_sym_use] = ACTIONS(2206),
    [anon_sym_while] = ACTIONS(2206),
    [anon_sym_extern] = ACTIONS(2206),
    [anon_sym_yield] = ACTIONS(2206),
    [anon_sym_move] = ACTIONS(2206),
    [anon_sym_try] = ACTIONS(2206),
    [sym_integer_literal] = ACTIONS(2204),
    [aux_sym_string_literal_token1] = ACTIONS(2204),
    [sym_char_literal] = ACTIONS(2204),
    [anon_sym_true] = ACTIONS(2206),
    [anon_sym_false] = ACTIONS(2206),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2206),
    [sym_super] = ACTIONS(2206),
    [sym_crate] = ACTIONS(2206),
    [sym_metavariable] = ACTIONS(2204),
    [sym__raw_string_literal_start] = ACTIONS(2204),
    [sym_float_literal] = ACTIONS(2204),
  },
  [590] = {
    [sym_line_comment] = STATE(590),
    [sym_block_comment] = STATE(590),
    [ts_builtin_sym_end] = ACTIONS(2208),
    [sym_identifier] = ACTIONS(2210),
    [anon_sym_SEMI] = ACTIONS(2208),
    [anon_sym_macro_rules_BANG] = ACTIONS(2208),
    [anon_sym_LPAREN] = ACTIONS(2208),
    [anon_sym_LBRACK] = ACTIONS(2208),
    [anon_sym_LBRACE] = ACTIONS(2208),
    [anon_sym_RBRACE] = ACTIONS(2208),
    [anon_sym_STAR] = ACTIONS(2208),
    [anon_sym_u8] = ACTIONS(2210),
    [anon_sym_i8] = ACTIONS(2210),
    [anon_sym_u16] = ACTIONS(2210),
    [anon_sym_i16] = ACTIONS(2210),
    [anon_sym_u32] = ACTIONS(2210),
    [anon_sym_i32] = ACTIONS(2210),
    [anon_sym_u64] = ACTIONS(2210),
    [anon_sym_i64] = ACTIONS(2210),
    [anon_sym_u128] = ACTIONS(2210),
    [anon_sym_i128] = ACTIONS(2210),
    [anon_sym_isize] = ACTIONS(2210),
    [anon_sym_usize] = ACTIONS(2210),
    [anon_sym_f32] = ACTIONS(2210),
    [anon_sym_f64] = ACTIONS(2210),
    [anon_sym_bool] = ACTIONS(2210),
    [anon_sym_str] = ACTIONS(2210),
    [anon_sym_char] = ACTIONS(2210),
    [anon_sym_DASH] = ACTIONS(2208),
    [anon_sym_BANG] = ACTIONS(2208),
    [anon_sym_AMP] = ACTIONS(2208),
    [anon_sym_PIPE] = ACTIONS(2208),
    [anon_sym_LT] = ACTIONS(2208),
    [anon_sym_DOT_DOT] = ACTIONS(2208),
    [anon_sym_COLON_COLON] = ACTIONS(2208),
    [anon_sym_POUND] = ACTIONS(2208),
    [anon_sym_SQUOTE] = ACTIONS(2210),
    [anon_sym_async] = ACTIONS(2210),
    [anon_sym_break] = ACTIONS(2210),
    [anon_sym_const] = ACTIONS(2210),
    [anon_sym_continue] = ACTIONS(2210),
    [anon_sym_default] = ACTIONS(2210),
    [anon_sym_enum] = ACTIONS(2210),
    [anon_sym_fn] = ACTIONS(2210),
    [anon_sym_for] = ACTIONS(2210),
    [anon_sym_if] = ACTIONS(2210),
    [anon_sym_impl] = ACTIONS(2210),
    [anon_sym_let] = ACTIONS(2210),
    [anon_sym_loop] = ACTIONS(2210),
    [anon_sym_match] = ACTIONS(2210),
    [anon_sym_mod] = ACTIONS(2210),
    [anon_sym_pub] = ACTIONS(2210),
    [anon_sym_return] = ACTIONS(2210),
    [anon_sym_static] = ACTIONS(2210),
    [anon_sym_struct] = ACTIONS(2210),
    [anon_sym_trait] = ACTIONS(2210),
    [anon_sym_type] = ACTIONS(2210),
    [anon_sym_union] = ACTIONS(2210),
    [anon_sym_unsafe] = ACTIONS(2210),
    [anon_sym_use] = ACTIONS(2210),
    [anon_sym_while] = ACTIONS(2210),
    [anon_sym_extern] = ACTIONS(2210),
    [anon_sym_yield] = ACTIONS(2210),
    [anon_sym_move] = ACTIONS(2210),
    [anon_sym_try] = ACTIONS(2210),
    [sym_integer_literal] = ACTIONS(2208),
    [aux_sym_string_literal_token1] = ACTIONS(2208),
    [sym_char_literal] = ACTIONS(2208),
    [anon_sym_true] = ACTIONS(2210),
    [anon_sym_false] = ACTIONS(2210),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2210),
    [sym_super] = ACTIONS(2210),
    [sym_crate] = ACTIONS(2210),
    [sym_metavariable] = ACTIONS(2208),
    [sym__raw_string_literal_start] = ACTIONS(2208),
    [sym_float_literal] = ACTIONS(2208),
  },
  [591] = {
    [sym_line_comment] = STATE(591),
    [sym_block_comment] = STATE(591),
    [ts_builtin_sym_end] = ACTIONS(2212),
    [sym_identifier] = ACTIONS(2214),
    [anon_sym_SEMI] = ACTIONS(2212),
    [anon_sym_macro_rules_BANG] = ACTIONS(2212),
    [anon_sym_LPAREN] = ACTIONS(2212),
    [anon_sym_LBRACK] = ACTIONS(2212),
    [anon_sym_LBRACE] = ACTIONS(2212),
    [anon_sym_RBRACE] = ACTIONS(2212),
    [anon_sym_STAR] = ACTIONS(2212),
    [anon_sym_u8] = ACTIONS(2214),
    [anon_sym_i8] = ACTIONS(2214),
    [anon_sym_u16] = ACTIONS(2214),
    [anon_sym_i16] = ACTIONS(2214),
    [anon_sym_u32] = ACTIONS(2214),
    [anon_sym_i32] = ACTIONS(2214),
    [anon_sym_u64] = ACTIONS(2214),
    [anon_sym_i64] = ACTIONS(2214),
    [anon_sym_u128] = ACTIONS(2214),
    [anon_sym_i128] = ACTIONS(2214),
    [anon_sym_isize] = ACTIONS(2214),
    [anon_sym_usize] = ACTIONS(2214),
    [anon_sym_f32] = ACTIONS(2214),
    [anon_sym_f64] = ACTIONS(2214),
    [anon_sym_bool] = ACTIONS(2214),
    [anon_sym_str] = ACTIONS(2214),
    [anon_sym_char] = ACTIONS(2214),
    [anon_sym_DASH] = ACTIONS(2212),
    [anon_sym_BANG] = ACTIONS(2212),
    [anon_sym_AMP] = ACTIONS(2212),
    [anon_sym_PIPE] = ACTIONS(2212),
    [anon_sym_LT] = ACTIONS(2212),
    [anon_sym_DOT_DOT] = ACTIONS(2212),
    [anon_sym_COLON_COLON] = ACTIONS(2212),
    [anon_sym_POUND] = ACTIONS(2212),
    [anon_sym_SQUOTE] = ACTIONS(2214),
    [anon_sym_async] = ACTIONS(2214),
    [anon_sym_break] = ACTIONS(2214),
    [anon_sym_const] = ACTIONS(2214),
    [anon_sym_continue] = ACTIONS(2214),
    [anon_sym_default] = ACTIONS(2214),
    [anon_sym_enum] = ACTIONS(2214),
    [anon_sym_fn] = ACTIONS(2214),
    [anon_sym_for] = ACTIONS(2214),
    [anon_sym_if] = ACTIONS(2214),
    [anon_sym_impl] = ACTIONS(2214),
    [anon_sym_let] = ACTIONS(2214),
    [anon_sym_loop] = ACTIONS(2214),
    [anon_sym_match] = ACTIONS(2214),
    [anon_sym_mod] = ACTIONS(2214),
    [anon_sym_pub] = ACTIONS(2214),
    [anon_sym_return] = ACTIONS(2214),
    [anon_sym_static] = ACTIONS(2214),
    [anon_sym_struct] = ACTIONS(2214),
    [anon_sym_trait] = ACTIONS(2214),
    [anon_sym_type] = ACTIONS(2214),
    [anon_sym_union] = ACTIONS(2214),
    [anon_sym_unsafe] = ACTIONS(2214),
    [anon_sym_use] = ACTIONS(2214),
    [anon_sym_while] = ACTIONS(2214),
    [anon_sym_extern] = ACTIONS(2214),
    [anon_sym_yield] = ACTIONS(2214),
    [anon_sym_move] = ACTIONS(2214),
    [anon_sym_try] = ACTIONS(2214),
    [sym_integer_literal] = ACTIONS(2212),
    [aux_sym_string_literal_token1] = ACTIONS(2212),
    [sym_char_literal] = ACTIONS(2212),
    [anon_sym_true] = ACTIONS(2214),
    [anon_sym_false] = ACTIONS(2214),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2214),
    [sym_super] = ACTIONS(2214),
    [sym_crate] = ACTIONS(2214),
    [sym_metavariable] = ACTIONS(2212),
    [sym__raw_string_literal_start] = ACTIONS(2212),
    [sym_float_literal] = ACTIONS(2212),
  },
  [592] = {
    [sym_line_comment] = STATE(592),
    [sym_block_comment] = STATE(592),
    [ts_builtin_sym_end] = ACTIONS(2216),
    [sym_identifier] = ACTIONS(2218),
    [anon_sym_SEMI] = ACTIONS(2216),
    [anon_sym_macro_rules_BANG] = ACTIONS(2216),
    [anon_sym_LPAREN] = ACTIONS(2216),
    [anon_sym_LBRACK] = ACTIONS(2216),
    [anon_sym_LBRACE] = ACTIONS(2216),
    [anon_sym_RBRACE] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(2216),
    [anon_sym_u8] = ACTIONS(2218),
    [anon_sym_i8] = ACTIONS(2218),
    [anon_sym_u16] = ACTIONS(2218),
    [anon_sym_i16] = ACTIONS(2218),
    [anon_sym_u32] = ACTIONS(2218),
    [anon_sym_i32] = ACTIONS(2218),
    [anon_sym_u64] = ACTIONS(2218),
    [anon_sym_i64] = ACTIONS(2218),
    [anon_sym_u128] = ACTIONS(2218),
    [anon_sym_i128] = ACTIONS(2218),
    [anon_sym_isize] = ACTIONS(2218),
    [anon_sym_usize] = ACTIONS(2218),
    [anon_sym_f32] = ACTIONS(2218),
    [anon_sym_f64] = ACTIONS(2218),
    [anon_sym_bool] = ACTIONS(2218),
    [anon_sym_str] = ACTIONS(2218),
    [anon_sym_char] = ACTIONS(2218),
    [anon_sym_DASH] = ACTIONS(2216),
    [anon_sym_BANG] = ACTIONS(2216),
    [anon_sym_AMP] = ACTIONS(2216),
    [anon_sym_PIPE] = ACTIONS(2216),
    [anon_sym_LT] = ACTIONS(2216),
    [anon_sym_DOT_DOT] = ACTIONS(2216),
    [anon_sym_COLON_COLON] = ACTIONS(2216),
    [anon_sym_POUND] = ACTIONS(2216),
    [anon_sym_SQUOTE] = ACTIONS(2218),
    [anon_sym_async] = ACTIONS(2218),
    [anon_sym_break] = ACTIONS(2218),
    [anon_sym_const] = ACTIONS(2218),
    [anon_sym_continue] = ACTIONS(2218),
    [anon_sym_default] = ACTIONS(2218),
    [anon_sym_enum] = ACTIONS(2218),
    [anon_sym_fn] = ACTIONS(2218),
    [anon_sym_for] = ACTIONS(2218),
    [anon_sym_if] = ACTIONS(2218),
    [anon_sym_impl] = ACTIONS(2218),
    [anon_sym_let] = ACTIONS(2218),
    [anon_sym_loop] = ACTIONS(2218),
    [anon_sym_match] = ACTIONS(2218),
    [anon_sym_mod] = ACTIONS(2218),
    [anon_sym_pub] = ACTIONS(2218),
    [anon_sym_return] = ACTIONS(2218),
    [anon_sym_static] = ACTIONS(2218),
    [anon_sym_struct] = ACTIONS(2218),
    [anon_sym_trait] = ACTIONS(2218),
    [anon_sym_type] = ACTIONS(2218),
    [anon_sym_union] = ACTIONS(2218),
    [anon_sym_unsafe] = ACTIONS(2218),
    [anon_sym_use] = ACTIONS(2218),
    [anon_sym_while] = ACTIONS(2218),
    [anon_sym_extern] = ACTIONS(2218),
    [anon_sym_yield] = ACTIONS(2218),
    [anon_sym_move] = ACTIONS(2218),
    [anon_sym_try] = ACTIONS(2218),
    [sym_integer_literal] = ACTIONS(2216),
    [aux_sym_string_literal_token1] = ACTIONS(2216),
    [sym_char_literal] = ACTIONS(2216),
    [anon_sym_true] = ACTIONS(2218),
    [anon_sym_false] = ACTIONS(2218),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2218),
    [sym_super] = ACTIONS(2218),
    [sym_crate] = ACTIONS(2218),
    [sym_metavariable] = ACTIONS(2216),
    [sym__raw_string_literal_start] = ACTIONS(2216),
    [sym_float_literal] = ACTIONS(2216),
  },
  [593] = {
    [sym_line_comment] = STATE(593),
    [sym_block_comment] = STATE(593),
    [ts_builtin_sym_end] = ACTIONS(2220),
    [sym_identifier] = ACTIONS(2222),
    [anon_sym_SEMI] = ACTIONS(2220),
    [anon_sym_macro_rules_BANG] = ACTIONS(2220),
    [anon_sym_LPAREN] = ACTIONS(2220),
    [anon_sym_LBRACK] = ACTIONS(2220),
    [anon_sym_LBRACE] = ACTIONS(2220),
    [anon_sym_RBRACE] = ACTIONS(2220),
    [anon_sym_STAR] = ACTIONS(2220),
    [anon_sym_u8] = ACTIONS(2222),
    [anon_sym_i8] = ACTIONS(2222),
    [anon_sym_u16] = ACTIONS(2222),
    [anon_sym_i16] = ACTIONS(2222),
    [anon_sym_u32] = ACTIONS(2222),
    [anon_sym_i32] = ACTIONS(2222),
    [anon_sym_u64] = ACTIONS(2222),
    [anon_sym_i64] = ACTIONS(2222),
    [anon_sym_u128] = ACTIONS(2222),
    [anon_sym_i128] = ACTIONS(2222),
    [anon_sym_isize] = ACTIONS(2222),
    [anon_sym_usize] = ACTIONS(2222),
    [anon_sym_f32] = ACTIONS(2222),
    [anon_sym_f64] = ACTIONS(2222),
    [anon_sym_bool] = ACTIONS(2222),
    [anon_sym_str] = ACTIONS(2222),
    [anon_sym_char] = ACTIONS(2222),
    [anon_sym_DASH] = ACTIONS(2220),
    [anon_sym_BANG] = ACTIONS(2220),
    [anon_sym_AMP] = ACTIONS(2220),
    [anon_sym_PIPE] = ACTIONS(2220),
    [anon_sym_LT] = ACTIONS(2220),
    [anon_sym_DOT_DOT] = ACTIONS(2220),
    [anon_sym_COLON_COLON] = ACTIONS(2220),
    [anon_sym_POUND] = ACTIONS(2220),
    [anon_sym_SQUOTE] = ACTIONS(2222),
    [anon_sym_async] = ACTIONS(2222),
    [anon_sym_break] = ACTIONS(2222),
    [anon_sym_const] = ACTIONS(2222),
    [anon_sym_continue] = ACTIONS(2222),
    [anon_sym_default] = ACTIONS(2222),
    [anon_sym_enum] = ACTIONS(2222),
    [anon_sym_fn] = ACTIONS(2222),
    [anon_sym_for] = ACTIONS(2222),
    [anon_sym_if] = ACTIONS(2222),
    [anon_sym_impl] = ACTIONS(2222),
    [anon_sym_let] = ACTIONS(2222),
    [anon_sym_loop] = ACTIONS(2222),
    [anon_sym_match] = ACTIONS(2222),
    [anon_sym_mod] = ACTIONS(2222),
    [anon_sym_pub] = ACTIONS(2222),
    [anon_sym_return] = ACTIONS(2222),
    [anon_sym_static] = ACTIONS(2222),
    [anon_sym_struct] = ACTIONS(2222),
    [anon_sym_trait] = ACTIONS(2222),
    [anon_sym_type] = ACTIONS(2222),
    [anon_sym_union] = ACTIONS(2222),
    [anon_sym_unsafe] = ACTIONS(2222),
    [anon_sym_use] = ACTIONS(2222),
    [anon_sym_while] = ACTIONS(2222),
    [anon_sym_extern] = ACTIONS(2222),
    [anon_sym_yield] = ACTIONS(2222),
    [anon_sym_move] = ACTIONS(2222),
    [anon_sym_try] = ACTIONS(2222),
    [sym_integer_literal] = ACTIONS(2220),
    [aux_sym_string_literal_token1] = ACTIONS(2220),
    [sym_char_literal] = ACTIONS(2220),
    [anon_sym_true] = ACTIONS(2222),
    [anon_sym_false] = ACTIONS(2222),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2222),
    [sym_super] = ACTIONS(2222),
    [sym_crate] = ACTIONS(2222),
    [sym_metavariable] = ACTIONS(2220),
    [sym__raw_string_literal_start] = ACTIONS(2220),
    [sym_float_literal] = ACTIONS(2220),
  },
  [594] = {
    [sym_line_comment] = STATE(594),
    [sym_block_comment] = STATE(594),
    [ts_builtin_sym_end] = ACTIONS(2224),
    [sym_identifier] = ACTIONS(2226),
    [anon_sym_SEMI] = ACTIONS(2224),
    [anon_sym_macro_rules_BANG] = ACTIONS(2224),
    [anon_sym_LPAREN] = ACTIONS(2224),
    [anon_sym_LBRACK] = ACTIONS(2224),
    [anon_sym_LBRACE] = ACTIONS(2224),
    [anon_sym_RBRACE] = ACTIONS(2224),
    [anon_sym_STAR] = ACTIONS(2224),
    [anon_sym_u8] = ACTIONS(2226),
    [anon_sym_i8] = ACTIONS(2226),
    [anon_sym_u16] = ACTIONS(2226),
    [anon_sym_i16] = ACTIONS(2226),
    [anon_sym_u32] = ACTIONS(2226),
    [anon_sym_i32] = ACTIONS(2226),
    [anon_sym_u64] = ACTIONS(2226),
    [anon_sym_i64] = ACTIONS(2226),
    [anon_sym_u128] = ACTIONS(2226),
    [anon_sym_i128] = ACTIONS(2226),
    [anon_sym_isize] = ACTIONS(2226),
    [anon_sym_usize] = ACTIONS(2226),
    [anon_sym_f32] = ACTIONS(2226),
    [anon_sym_f64] = ACTIONS(2226),
    [anon_sym_bool] = ACTIONS(2226),
    [anon_sym_str] = ACTIONS(2226),
    [anon_sym_char] = ACTIONS(2226),
    [anon_sym_DASH] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2224),
    [anon_sym_AMP] = ACTIONS(2224),
    [anon_sym_PIPE] = ACTIONS(2224),
    [anon_sym_LT] = ACTIONS(2224),
    [anon_sym_DOT_DOT] = ACTIONS(2224),
    [anon_sym_COLON_COLON] = ACTIONS(2224),
    [anon_sym_POUND] = ACTIONS(2224),
    [anon_sym_SQUOTE] = ACTIONS(2226),
    [anon_sym_async] = ACTIONS(2226),
    [anon_sym_break] = ACTIONS(2226),
    [anon_sym_const] = ACTIONS(2226),
    [anon_sym_continue] = ACTIONS(2226),
    [anon_sym_default] = ACTIONS(2226),
    [anon_sym_enum] = ACTIONS(2226),
    [anon_sym_fn] = ACTIONS(2226),
    [anon_sym_for] = ACTIONS(2226),
    [anon_sym_if] = ACTIONS(2226),
    [anon_sym_impl] = ACTIONS(2226),
    [anon_sym_let] = ACTIONS(2226),
    [anon_sym_loop] = ACTIONS(2226),
    [anon_sym_match] = ACTIONS(2226),
    [anon_sym_mod] = ACTIONS(2226),
    [anon_sym_pub] = ACTIONS(2226),
    [anon_sym_return] = ACTIONS(2226),
    [anon_sym_static] = ACTIONS(2226),
    [anon_sym_struct] = ACTIONS(2226),
    [anon_sym_trait] = ACTIONS(2226),
    [anon_sym_type] = ACTIONS(2226),
    [anon_sym_union] = ACTIONS(2226),
    [anon_sym_unsafe] = ACTIONS(2226),
    [anon_sym_use] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2226),
    [anon_sym_extern] = ACTIONS(2226),
    [anon_sym_yield] = ACTIONS(2226),
    [anon_sym_move] = ACTIONS(2226),
    [anon_sym_try] = ACTIONS(2226),
    [sym_integer_literal] = ACTIONS(2224),
    [aux_sym_string_literal_token1] = ACTIONS(2224),
    [sym_char_literal] = ACTIONS(2224),
    [anon_sym_true] = ACTIONS(2226),
    [anon_sym_false] = ACTIONS(2226),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2226),
    [sym_super] = ACTIONS(2226),
    [sym_crate] = ACTIONS(2226),
    [sym_metavariable] = ACTIONS(2224),
    [sym__raw_string_literal_start] = ACTIONS(2224),
    [sym_float_literal] = ACTIONS(2224),
  },
  [595] = {
    [sym_line_comment] = STATE(595),
    [sym_block_comment] = STATE(595),
    [ts_builtin_sym_end] = ACTIONS(2228),
    [sym_identifier] = ACTIONS(2230),
    [anon_sym_SEMI] = ACTIONS(2228),
    [anon_sym_macro_rules_BANG] = ACTIONS(2228),
    [anon_sym_LPAREN] = ACTIONS(2228),
    [anon_sym_LBRACK] = ACTIONS(2228),
    [anon_sym_LBRACE] = ACTIONS(2228),
    [anon_sym_RBRACE] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(2228),
    [anon_sym_u8] = ACTIONS(2230),
    [anon_sym_i8] = ACTIONS(2230),
    [anon_sym_u16] = ACTIONS(2230),
    [anon_sym_i16] = ACTIONS(2230),
    [anon_sym_u32] = ACTIONS(2230),
    [anon_sym_i32] = ACTIONS(2230),
    [anon_sym_u64] = ACTIONS(2230),
    [anon_sym_i64] = ACTIONS(2230),
    [anon_sym_u128] = ACTIONS(2230),
    [anon_sym_i128] = ACTIONS(2230),
    [anon_sym_isize] = ACTIONS(2230),
    [anon_sym_usize] = ACTIONS(2230),
    [anon_sym_f32] = ACTIONS(2230),
    [anon_sym_f64] = ACTIONS(2230),
    [anon_sym_bool] = ACTIONS(2230),
    [anon_sym_str] = ACTIONS(2230),
    [anon_sym_char] = ACTIONS(2230),
    [anon_sym_DASH] = ACTIONS(2228),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_AMP] = ACTIONS(2228),
    [anon_sym_PIPE] = ACTIONS(2228),
    [anon_sym_LT] = ACTIONS(2228),
    [anon_sym_DOT_DOT] = ACTIONS(2228),
    [anon_sym_COLON_COLON] = ACTIONS(2228),
    [anon_sym_POUND] = ACTIONS(2228),
    [anon_sym_SQUOTE] = ACTIONS(2230),
    [anon_sym_async] = ACTIONS(2230),
    [anon_sym_break] = ACTIONS(2230),
    [anon_sym_const] = ACTIONS(2230),
    [anon_sym_continue] = ACTIONS(2230),
    [anon_sym_default] = ACTIONS(2230),
    [anon_sym_enum] = ACTIONS(2230),
    [anon_sym_fn] = ACTIONS(2230),
    [anon_sym_for] = ACTIONS(2230),
    [anon_sym_if] = ACTIONS(2230),
    [anon_sym_impl] = ACTIONS(2230),
    [anon_sym_let] = ACTIONS(2230),
    [anon_sym_loop] = ACTIONS(2230),
    [anon_sym_match] = ACTIONS(2230),
    [anon_sym_mod] = ACTIONS(2230),
    [anon_sym_pub] = ACTIONS(2230),
    [anon_sym_return] = ACTIONS(2230),
    [anon_sym_static] = ACTIONS(2230),
    [anon_sym_struct] = ACTIONS(2230),
    [anon_sym_trait] = ACTIONS(2230),
    [anon_sym_type] = ACTIONS(2230),
    [anon_sym_union] = ACTIONS(2230),
    [anon_sym_unsafe] = ACTIONS(2230),
    [anon_sym_use] = ACTIONS(2230),
    [anon_sym_while] = ACTIONS(2230),
    [anon_sym_extern] = ACTIONS(2230),
    [anon_sym_yield] = ACTIONS(2230),
    [anon_sym_move] = ACTIONS(2230),
    [anon_sym_try] = ACTIONS(2230),
    [sym_integer_literal] = ACTIONS(2228),
    [aux_sym_string_literal_token1] = ACTIONS(2228),
    [sym_char_literal] = ACTIONS(2228),
    [anon_sym_true] = ACTIONS(2230),
    [anon_sym_false] = ACTIONS(2230),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2230),
    [sym_super] = ACTIONS(2230),
    [sym_crate] = ACTIONS(2230),
    [sym_metavariable] = ACTIONS(2228),
    [sym__raw_string_literal_start] = ACTIONS(2228),
    [sym_float_literal] = ACTIONS(2228),
  },
  [596] = {
    [sym_line_comment] = STATE(596),
    [sym_block_comment] = STATE(596),
    [ts_builtin_sym_end] = ACTIONS(2232),
    [sym_identifier] = ACTIONS(2234),
    [anon_sym_SEMI] = ACTIONS(2232),
    [anon_sym_macro_rules_BANG] = ACTIONS(2232),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_LBRACK] = ACTIONS(2232),
    [anon_sym_LBRACE] = ACTIONS(2232),
    [anon_sym_RBRACE] = ACTIONS(2232),
    [anon_sym_STAR] = ACTIONS(2232),
    [anon_sym_u8] = ACTIONS(2234),
    [anon_sym_i8] = ACTIONS(2234),
    [anon_sym_u16] = ACTIONS(2234),
    [anon_sym_i16] = ACTIONS(2234),
    [anon_sym_u32] = ACTIONS(2234),
    [anon_sym_i32] = ACTIONS(2234),
    [anon_sym_u64] = ACTIONS(2234),
    [anon_sym_i64] = ACTIONS(2234),
    [anon_sym_u128] = ACTIONS(2234),
    [anon_sym_i128] = ACTIONS(2234),
    [anon_sym_isize] = ACTIONS(2234),
    [anon_sym_usize] = ACTIONS(2234),
    [anon_sym_f32] = ACTIONS(2234),
    [anon_sym_f64] = ACTIONS(2234),
    [anon_sym_bool] = ACTIONS(2234),
    [anon_sym_str] = ACTIONS(2234),
    [anon_sym_char] = ACTIONS(2234),
    [anon_sym_DASH] = ACTIONS(2232),
    [anon_sym_BANG] = ACTIONS(2232),
    [anon_sym_AMP] = ACTIONS(2232),
    [anon_sym_PIPE] = ACTIONS(2232),
    [anon_sym_LT] = ACTIONS(2232),
    [anon_sym_DOT_DOT] = ACTIONS(2232),
    [anon_sym_COLON_COLON] = ACTIONS(2232),
    [anon_sym_POUND] = ACTIONS(2232),
    [anon_sym_SQUOTE] = ACTIONS(2234),
    [anon_sym_async] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2234),
    [anon_sym_const] = ACTIONS(2234),
    [anon_sym_continue] = ACTIONS(2234),
    [anon_sym_default] = ACTIONS(2234),
    [anon_sym_enum] = ACTIONS(2234),
    [anon_sym_fn] = ACTIONS(2234),
    [anon_sym_for] = ACTIONS(2234),
    [anon_sym_if] = ACTIONS(2234),
    [anon_sym_impl] = ACTIONS(2234),
    [anon_sym_let] = ACTIONS(2234),
    [anon_sym_loop] = ACTIONS(2234),
    [anon_sym_match] = ACTIONS(2234),
    [anon_sym_mod] = ACTIONS(2234),
    [anon_sym_pub] = ACTIONS(2234),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_static] = ACTIONS(2234),
    [anon_sym_struct] = ACTIONS(2234),
    [anon_sym_trait] = ACTIONS(2234),
    [anon_sym_type] = ACTIONS(2234),
    [anon_sym_union] = ACTIONS(2234),
    [anon_sym_unsafe] = ACTIONS(2234),
    [anon_sym_use] = ACTIONS(2234),
    [anon_sym_while] = ACTIONS(2234),
    [anon_sym_extern] = ACTIONS(2234),
    [anon_sym_yield] = ACTIONS(2234),
    [anon_sym_move] = ACTIONS(2234),
    [anon_sym_try] = ACTIONS(2234),
    [sym_integer_literal] = ACTIONS(2232),
    [aux_sym_string_literal_token1] = ACTIONS(2232),
    [sym_char_literal] = ACTIONS(2232),
    [anon_sym_true] = ACTIONS(2234),
    [anon_sym_false] = ACTIONS(2234),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2234),
    [sym_super] = ACTIONS(2234),
    [sym_crate] = ACTIONS(2234),
    [sym_metavariable] = ACTIONS(2232),
    [sym__raw_string_literal_start] = ACTIONS(2232),
    [sym_float_literal] = ACTIONS(2232),
  },
  [597] = {
    [sym_line_comment] = STATE(597),
    [sym_block_comment] = STATE(597),
    [ts_builtin_sym_end] = ACTIONS(2236),
    [sym_identifier] = ACTIONS(2238),
    [anon_sym_SEMI] = ACTIONS(2236),
    [anon_sym_macro_rules_BANG] = ACTIONS(2236),
    [anon_sym_LPAREN] = ACTIONS(2236),
    [anon_sym_LBRACK] = ACTIONS(2236),
    [anon_sym_LBRACE] = ACTIONS(2236),
    [anon_sym_RBRACE] = ACTIONS(2236),
    [anon_sym_STAR] = ACTIONS(2236),
    [anon_sym_u8] = ACTIONS(2238),
    [anon_sym_i8] = ACTIONS(2238),
    [anon_sym_u16] = ACTIONS(2238),
    [anon_sym_i16] = ACTIONS(2238),
    [anon_sym_u32] = ACTIONS(2238),
    [anon_sym_i32] = ACTIONS(2238),
    [anon_sym_u64] = ACTIONS(2238),
    [anon_sym_i64] = ACTIONS(2238),
    [anon_sym_u128] = ACTIONS(2238),
    [anon_sym_i128] = ACTIONS(2238),
    [anon_sym_isize] = ACTIONS(2238),
    [anon_sym_usize] = ACTIONS(2238),
    [anon_sym_f32] = ACTIONS(2238),
    [anon_sym_f64] = ACTIONS(2238),
    [anon_sym_bool] = ACTIONS(2238),
    [anon_sym_str] = ACTIONS(2238),
    [anon_sym_char] = ACTIONS(2238),
    [anon_sym_DASH] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2236),
    [anon_sym_AMP] = ACTIONS(2236),
    [anon_sym_PIPE] = ACTIONS(2236),
    [anon_sym_LT] = ACTIONS(2236),
    [anon_sym_DOT_DOT] = ACTIONS(2236),
    [anon_sym_COLON_COLON] = ACTIONS(2236),
    [anon_sym_POUND] = ACTIONS(2236),
    [anon_sym_SQUOTE] = ACTIONS(2238),
    [anon_sym_async] = ACTIONS(2238),
    [anon_sym_break] = ACTIONS(2238),
    [anon_sym_const] = ACTIONS(2238),
    [anon_sym_continue] = ACTIONS(2238),
    [anon_sym_default] = ACTIONS(2238),
    [anon_sym_enum] = ACTIONS(2238),
    [anon_sym_fn] = ACTIONS(2238),
    [anon_sym_for] = ACTIONS(2238),
    [anon_sym_if] = ACTIONS(2238),
    [anon_sym_impl] = ACTIONS(2238),
    [anon_sym_let] = ACTIONS(2238),
    [anon_sym_loop] = ACTIONS(2238),
    [anon_sym_match] = ACTIONS(2238),
    [anon_sym_mod] = ACTIONS(2238),
    [anon_sym_pub] = ACTIONS(2238),
    [anon_sym_return] = ACTIONS(2238),
    [anon_sym_static] = ACTIONS(2238),
    [anon_sym_struct] = ACTIONS(2238),
    [anon_sym_trait] = ACTIONS(2238),
    [anon_sym_type] = ACTIONS(2238),
    [anon_sym_union] = ACTIONS(2238),
    [anon_sym_unsafe] = ACTIONS(2238),
    [anon_sym_use] = ACTIONS(2238),
    [anon_sym_while] = ACTIONS(2238),
    [anon_sym_extern] = ACTIONS(2238),
    [anon_sym_yield] = ACTIONS(2238),
    [anon_sym_move] = ACTIONS(2238),
    [anon_sym_try] = ACTIONS(2238),
    [sym_integer_literal] = ACTIONS(2236),
    [aux_sym_string_literal_token1] = ACTIONS(2236),
    [sym_char_literal] = ACTIONS(2236),
    [anon_sym_true] = ACTIONS(2238),
    [anon_sym_false] = ACTIONS(2238),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2238),
    [sym_super] = ACTIONS(2238),
    [sym_crate] = ACTIONS(2238),
    [sym_metavariable] = ACTIONS(2236),
    [sym__raw_string_literal_start] = ACTIONS(2236),
    [sym_float_literal] = ACTIONS(2236),
  },
  [598] = {
    [sym_line_comment] = STATE(598),
    [sym_block_comment] = STATE(598),
    [ts_builtin_sym_end] = ACTIONS(2240),
    [sym_identifier] = ACTIONS(2242),
    [anon_sym_SEMI] = ACTIONS(2240),
    [anon_sym_macro_rules_BANG] = ACTIONS(2240),
    [anon_sym_LPAREN] = ACTIONS(2240),
    [anon_sym_LBRACK] = ACTIONS(2240),
    [anon_sym_LBRACE] = ACTIONS(2240),
    [anon_sym_RBRACE] = ACTIONS(2240),
    [anon_sym_STAR] = ACTIONS(2240),
    [anon_sym_u8] = ACTIONS(2242),
    [anon_sym_i8] = ACTIONS(2242),
    [anon_sym_u16] = ACTIONS(2242),
    [anon_sym_i16] = ACTIONS(2242),
    [anon_sym_u32] = ACTIONS(2242),
    [anon_sym_i32] = ACTIONS(2242),
    [anon_sym_u64] = ACTIONS(2242),
    [anon_sym_i64] = ACTIONS(2242),
    [anon_sym_u128] = ACTIONS(2242),
    [anon_sym_i128] = ACTIONS(2242),
    [anon_sym_isize] = ACTIONS(2242),
    [anon_sym_usize] = ACTIONS(2242),
    [anon_sym_f32] = ACTIONS(2242),
    [anon_sym_f64] = ACTIONS(2242),
    [anon_sym_bool] = ACTIONS(2242),
    [anon_sym_str] = ACTIONS(2242),
    [anon_sym_char] = ACTIONS(2242),
    [anon_sym_DASH] = ACTIONS(2240),
    [anon_sym_BANG] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2240),
    [anon_sym_PIPE] = ACTIONS(2240),
    [anon_sym_LT] = ACTIONS(2240),
    [anon_sym_DOT_DOT] = ACTIONS(2240),
    [anon_sym_COLON_COLON] = ACTIONS(2240),
    [anon_sym_POUND] = ACTIONS(2240),
    [anon_sym_SQUOTE] = ACTIONS(2242),
    [anon_sym_async] = ACTIONS(2242),
    [anon_sym_break] = ACTIONS(2242),
    [anon_sym_const] = ACTIONS(2242),
    [anon_sym_continue] = ACTIONS(2242),
    [anon_sym_default] = ACTIONS(2242),
    [anon_sym_enum] = ACTIONS(2242),
    [anon_sym_fn] = ACTIONS(2242),
    [anon_sym_for] = ACTIONS(2242),
    [anon_sym_if] = ACTIONS(2242),
    [anon_sym_impl] = ACTIONS(2242),
    [anon_sym_let] = ACTIONS(2242),
    [anon_sym_loop] = ACTIONS(2242),
    [anon_sym_match] = ACTIONS(2242),
    [anon_sym_mod] = ACTIONS(2242),
    [anon_sym_pub] = ACTIONS(2242),
    [anon_sym_return] = ACTIONS(2242),
    [anon_sym_static] = ACTIONS(2242),
    [anon_sym_struct] = ACTIONS(2242),
    [anon_sym_trait] = ACTIONS(2242),
    [anon_sym_type] = ACTIONS(2242),
    [anon_sym_union] = ACTIONS(2242),
    [anon_sym_unsafe] = ACTIONS(2242),
    [anon_sym_use] = ACTIONS(2242),
    [anon_sym_while] = ACTIONS(2242),
    [anon_sym_extern] = ACTIONS(2242),
    [anon_sym_yield] = ACTIONS(2242),
    [anon_sym_move] = ACTIONS(2242),
    [anon_sym_try] = ACTIONS(2242),
    [sym_integer_literal] = ACTIONS(2240),
    [aux_sym_string_literal_token1] = ACTIONS(2240),
    [sym_char_literal] = ACTIONS(2240),
    [anon_sym_true] = ACTIONS(2242),
    [anon_sym_false] = ACTIONS(2242),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2242),
    [sym_super] = ACTIONS(2242),
    [sym_crate] = ACTIONS(2242),
    [sym_metavariable] = ACTIONS(2240),
    [sym__raw_string_literal_start] = ACTIONS(2240),
    [sym_float_literal] = ACTIONS(2240),
  },
  [599] = {
    [sym_line_comment] = STATE(599),
    [sym_block_comment] = STATE(599),
    [ts_builtin_sym_end] = ACTIONS(2244),
    [sym_identifier] = ACTIONS(2246),
    [anon_sym_SEMI] = ACTIONS(2244),
    [anon_sym_macro_rules_BANG] = ACTIONS(2244),
    [anon_sym_LPAREN] = ACTIONS(2244),
    [anon_sym_LBRACK] = ACTIONS(2244),
    [anon_sym_LBRACE] = ACTIONS(2244),
    [anon_sym_RBRACE] = ACTIONS(2244),
    [anon_sym_STAR] = ACTIONS(2244),
    [anon_sym_u8] = ACTIONS(2246),
    [anon_sym_i8] = ACTIONS(2246),
    [anon_sym_u16] = ACTIONS(2246),
    [anon_sym_i16] = ACTIONS(2246),
    [anon_sym_u32] = ACTIONS(2246),
    [anon_sym_i32] = ACTIONS(2246),
    [anon_sym_u64] = ACTIONS(2246),
    [anon_sym_i64] = ACTIONS(2246),
    [anon_sym_u128] = ACTIONS(2246),
    [anon_sym_i128] = ACTIONS(2246),
    [anon_sym_isize] = ACTIONS(2246),
    [anon_sym_usize] = ACTIONS(2246),
    [anon_sym_f32] = ACTIONS(2246),
    [anon_sym_f64] = ACTIONS(2246),
    [anon_sym_bool] = ACTIONS(2246),
    [anon_sym_str] = ACTIONS(2246),
    [anon_sym_char] = ACTIONS(2246),
    [anon_sym_DASH] = ACTIONS(2244),
    [anon_sym_BANG] = ACTIONS(2244),
    [anon_sym_AMP] = ACTIONS(2244),
    [anon_sym_PIPE] = ACTIONS(2244),
    [anon_sym_LT] = ACTIONS(2244),
    [anon_sym_DOT_DOT] = ACTIONS(2244),
    [anon_sym_COLON_COLON] = ACTIONS(2244),
    [anon_sym_POUND] = ACTIONS(2244),
    [anon_sym_SQUOTE] = ACTIONS(2246),
    [anon_sym_async] = ACTIONS(2246),
    [anon_sym_break] = ACTIONS(2246),
    [anon_sym_const] = ACTIONS(2246),
    [anon_sym_continue] = ACTIONS(2246),
    [anon_sym_default] = ACTIONS(2246),
    [anon_sym_enum] = ACTIONS(2246),
    [anon_sym_fn] = ACTIONS(2246),
    [anon_sym_for] = ACTIONS(2246),
    [anon_sym_if] = ACTIONS(2246),
    [anon_sym_impl] = ACTIONS(2246),
    [anon_sym_let] = ACTIONS(2246),
    [anon_sym_loop] = ACTIONS(2246),
    [anon_sym_match] = ACTIONS(2246),
    [anon_sym_mod] = ACTIONS(2246),
    [anon_sym_pub] = ACTIONS(2246),
    [anon_sym_return] = ACTIONS(2246),
    [anon_sym_static] = ACTIONS(2246),
    [anon_sym_struct] = ACTIONS(2246),
    [anon_sym_trait] = ACTIONS(2246),
    [anon_sym_type] = ACTIONS(2246),
    [anon_sym_union] = ACTIONS(2246),
    [anon_sym_unsafe] = ACTIONS(2246),
    [anon_sym_use] = ACTIONS(2246),
    [anon_sym_while] = ACTIONS(2246),
    [anon_sym_extern] = ACTIONS(2246),
    [anon_sym_yield] = ACTIONS(2246),
    [anon_sym_move] = ACTIONS(2246),
    [anon_sym_try] = ACTIONS(2246),
    [sym_integer_literal] = ACTIONS(2244),
    [aux_sym_string_literal_token1] = ACTIONS(2244),
    [sym_char_literal] = ACTIONS(2244),
    [anon_sym_true] = ACTIONS(2246),
    [anon_sym_false] = ACTIONS(2246),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2246),
    [sym_super] = ACTIONS(2246),
    [sym_crate] = ACTIONS(2246),
    [sym_metavariable] = ACTIONS(2244),
    [sym__raw_string_literal_start] = ACTIONS(2244),
    [sym_float_literal] = ACTIONS(2244),
  },
  [600] = {
    [sym_line_comment] = STATE(600),
    [sym_block_comment] = STATE(600),
    [ts_builtin_sym_end] = ACTIONS(2248),
    [sym_identifier] = ACTIONS(2250),
    [anon_sym_SEMI] = ACTIONS(2248),
    [anon_sym_macro_rules_BANG] = ACTIONS(2248),
    [anon_sym_LPAREN] = ACTIONS(2248),
    [anon_sym_LBRACK] = ACTIONS(2248),
    [anon_sym_LBRACE] = ACTIONS(2248),
    [anon_sym_RBRACE] = ACTIONS(2248),
    [anon_sym_STAR] = ACTIONS(2248),
    [anon_sym_u8] = ACTIONS(2250),
    [anon_sym_i8] = ACTIONS(2250),
    [anon_sym_u16] = ACTIONS(2250),
    [anon_sym_i16] = ACTIONS(2250),
    [anon_sym_u32] = ACTIONS(2250),
    [anon_sym_i32] = ACTIONS(2250),
    [anon_sym_u64] = ACTIONS(2250),
    [anon_sym_i64] = ACTIONS(2250),
    [anon_sym_u128] = ACTIONS(2250),
    [anon_sym_i128] = ACTIONS(2250),
    [anon_sym_isize] = ACTIONS(2250),
    [anon_sym_usize] = ACTIONS(2250),
    [anon_sym_f32] = ACTIONS(2250),
    [anon_sym_f64] = ACTIONS(2250),
    [anon_sym_bool] = ACTIONS(2250),
    [anon_sym_str] = ACTIONS(2250),
    [anon_sym_char] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2248),
    [anon_sym_BANG] = ACTIONS(2248),
    [anon_sym_AMP] = ACTIONS(2248),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_LT] = ACTIONS(2248),
    [anon_sym_DOT_DOT] = ACTIONS(2248),
    [anon_sym_COLON_COLON] = ACTIONS(2248),
    [anon_sym_POUND] = ACTIONS(2248),
    [anon_sym_SQUOTE] = ACTIONS(2250),
    [anon_sym_async] = ACTIONS(2250),
    [anon_sym_break] = ACTIONS(2250),
    [anon_sym_const] = ACTIONS(2250),
    [anon_sym_continue] = ACTIONS(2250),
    [anon_sym_default] = ACTIONS(2250),
    [anon_sym_enum] = ACTIONS(2250),
    [anon_sym_fn] = ACTIONS(2250),
    [anon_sym_for] = ACTIONS(2250),
    [anon_sym_if] = ACTIONS(2250),
    [anon_sym_impl] = ACTIONS(2250),
    [anon_sym_let] = ACTIONS(2250),
    [anon_sym_loop] = ACTIONS(2250),
    [anon_sym_match] = ACTIONS(2250),
    [anon_sym_mod] = ACTIONS(2250),
    [anon_sym_pub] = ACTIONS(2250),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_static] = ACTIONS(2250),
    [anon_sym_struct] = ACTIONS(2250),
    [anon_sym_trait] = ACTIONS(2250),
    [anon_sym_type] = ACTIONS(2250),
    [anon_sym_union] = ACTIONS(2250),
    [anon_sym_unsafe] = ACTIONS(2250),
    [anon_sym_use] = ACTIONS(2250),
    [anon_sym_while] = ACTIONS(2250),
    [anon_sym_extern] = ACTIONS(2250),
    [anon_sym_yield] = ACTIONS(2250),
    [anon_sym_move] = ACTIONS(2250),
    [anon_sym_try] = ACTIONS(2250),
    [sym_integer_literal] = ACTIONS(2248),
    [aux_sym_string_literal_token1] = ACTIONS(2248),
    [sym_char_literal] = ACTIONS(2248),
    [anon_sym_true] = ACTIONS(2250),
    [anon_sym_false] = ACTIONS(2250),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2250),
    [sym_super] = ACTIONS(2250),
    [sym_crate] = ACTIONS(2250),
    [sym_metavariable] = ACTIONS(2248),
    [sym__raw_string_literal_start] = ACTIONS(2248),
    [sym_float_literal] = ACTIONS(2248),
  },
  [601] = {
    [sym_line_comment] = STATE(601),
    [sym_block_comment] = STATE(601),
    [ts_builtin_sym_end] = ACTIONS(2252),
    [sym_identifier] = ACTIONS(2254),
    [anon_sym_SEMI] = ACTIONS(2252),
    [anon_sym_macro_rules_BANG] = ACTIONS(2252),
    [anon_sym_LPAREN] = ACTIONS(2252),
    [anon_sym_LBRACK] = ACTIONS(2252),
    [anon_sym_LBRACE] = ACTIONS(2252),
    [anon_sym_RBRACE] = ACTIONS(2252),
    [anon_sym_STAR] = ACTIONS(2252),
    [anon_sym_u8] = ACTIONS(2254),
    [anon_sym_i8] = ACTIONS(2254),
    [anon_sym_u16] = ACTIONS(2254),
    [anon_sym_i16] = ACTIONS(2254),
    [anon_sym_u32] = ACTIONS(2254),
    [anon_sym_i32] = ACTIONS(2254),
    [anon_sym_u64] = ACTIONS(2254),
    [anon_sym_i64] = ACTIONS(2254),
    [anon_sym_u128] = ACTIONS(2254),
    [anon_sym_i128] = ACTIONS(2254),
    [anon_sym_isize] = ACTIONS(2254),
    [anon_sym_usize] = ACTIONS(2254),
    [anon_sym_f32] = ACTIONS(2254),
    [anon_sym_f64] = ACTIONS(2254),
    [anon_sym_bool] = ACTIONS(2254),
    [anon_sym_str] = ACTIONS(2254),
    [anon_sym_char] = ACTIONS(2254),
    [anon_sym_DASH] = ACTIONS(2252),
    [anon_sym_BANG] = ACTIONS(2252),
    [anon_sym_AMP] = ACTIONS(2252),
    [anon_sym_PIPE] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2252),
    [anon_sym_DOT_DOT] = ACTIONS(2252),
    [anon_sym_COLON_COLON] = ACTIONS(2252),
    [anon_sym_POUND] = ACTIONS(2252),
    [anon_sym_SQUOTE] = ACTIONS(2254),
    [anon_sym_async] = ACTIONS(2254),
    [anon_sym_break] = ACTIONS(2254),
    [anon_sym_const] = ACTIONS(2254),
    [anon_sym_continue] = ACTIONS(2254),
    [anon_sym_default] = ACTIONS(2254),
    [anon_sym_enum] = ACTIONS(2254),
    [anon_sym_fn] = ACTIONS(2254),
    [anon_sym_for] = ACTIONS(2254),
    [anon_sym_if] = ACTIONS(2254),
    [anon_sym_impl] = ACTIONS(2254),
    [anon_sym_let] = ACTIONS(2254),
    [anon_sym_loop] = ACTIONS(2254),
    [anon_sym_match] = ACTIONS(2254),
    [anon_sym_mod] = ACTIONS(2254),
    [anon_sym_pub] = ACTIONS(2254),
    [anon_sym_return] = ACTIONS(2254),
    [anon_sym_static] = ACTIONS(2254),
    [anon_sym_struct] = ACTIONS(2254),
    [anon_sym_trait] = ACTIONS(2254),
    [anon_sym_type] = ACTIONS(2254),
    [anon_sym_union] = ACTIONS(2254),
    [anon_sym_unsafe] = ACTIONS(2254),
    [anon_sym_use] = ACTIONS(2254),
    [anon_sym_while] = ACTIONS(2254),
    [anon_sym_extern] = ACTIONS(2254),
    [anon_sym_yield] = ACTIONS(2254),
    [anon_sym_move] = ACTIONS(2254),
    [anon_sym_try] = ACTIONS(2254),
    [sym_integer_literal] = ACTIONS(2252),
    [aux_sym_string_literal_token1] = ACTIONS(2252),
    [sym_char_literal] = ACTIONS(2252),
    [anon_sym_true] = ACTIONS(2254),
    [anon_sym_false] = ACTIONS(2254),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2254),
    [sym_super] = ACTIONS(2254),
    [sym_crate] = ACTIONS(2254),
    [sym_metavariable] = ACTIONS(2252),
    [sym__raw_string_literal_start] = ACTIONS(2252),
    [sym_float_literal] = ACTIONS(2252),
  },
  [602] = {
    [sym_line_comment] = STATE(602),
    [sym_block_comment] = STATE(602),
    [ts_builtin_sym_end] = ACTIONS(2256),
    [sym_identifier] = ACTIONS(2258),
    [anon_sym_SEMI] = ACTIONS(2256),
    [anon_sym_macro_rules_BANG] = ACTIONS(2256),
    [anon_sym_LPAREN] = ACTIONS(2256),
    [anon_sym_LBRACK] = ACTIONS(2256),
    [anon_sym_LBRACE] = ACTIONS(2256),
    [anon_sym_RBRACE] = ACTIONS(2256),
    [anon_sym_STAR] = ACTIONS(2256),
    [anon_sym_u8] = ACTIONS(2258),
    [anon_sym_i8] = ACTIONS(2258),
    [anon_sym_u16] = ACTIONS(2258),
    [anon_sym_i16] = ACTIONS(2258),
    [anon_sym_u32] = ACTIONS(2258),
    [anon_sym_i32] = ACTIONS(2258),
    [anon_sym_u64] = ACTIONS(2258),
    [anon_sym_i64] = ACTIONS(2258),
    [anon_sym_u128] = ACTIONS(2258),
    [anon_sym_i128] = ACTIONS(2258),
    [anon_sym_isize] = ACTIONS(2258),
    [anon_sym_usize] = ACTIONS(2258),
    [anon_sym_f32] = ACTIONS(2258),
    [anon_sym_f64] = ACTIONS(2258),
    [anon_sym_bool] = ACTIONS(2258),
    [anon_sym_str] = ACTIONS(2258),
    [anon_sym_char] = ACTIONS(2258),
    [anon_sym_DASH] = ACTIONS(2256),
    [anon_sym_BANG] = ACTIONS(2256),
    [anon_sym_AMP] = ACTIONS(2256),
    [anon_sym_PIPE] = ACTIONS(2256),
    [anon_sym_LT] = ACTIONS(2256),
    [anon_sym_DOT_DOT] = ACTIONS(2256),
    [anon_sym_COLON_COLON] = ACTIONS(2256),
    [anon_sym_POUND] = ACTIONS(2256),
    [anon_sym_SQUOTE] = ACTIONS(2258),
    [anon_sym_async] = ACTIONS(2258),
    [anon_sym_break] = ACTIONS(2258),
    [anon_sym_const] = ACTIONS(2258),
    [anon_sym_continue] = ACTIONS(2258),
    [anon_sym_default] = ACTIONS(2258),
    [anon_sym_enum] = ACTIONS(2258),
    [anon_sym_fn] = ACTIONS(2258),
    [anon_sym_for] = ACTIONS(2258),
    [anon_sym_if] = ACTIONS(2258),
    [anon_sym_impl] = ACTIONS(2258),
    [anon_sym_let] = ACTIONS(2258),
    [anon_sym_loop] = ACTIONS(2258),
    [anon_sym_match] = ACTIONS(2258),
    [anon_sym_mod] = ACTIONS(2258),
    [anon_sym_pub] = ACTIONS(2258),
    [anon_sym_return] = ACTIONS(2258),
    [anon_sym_static] = ACTIONS(2258),
    [anon_sym_struct] = ACTIONS(2258),
    [anon_sym_trait] = ACTIONS(2258),
    [anon_sym_type] = ACTIONS(2258),
    [anon_sym_union] = ACTIONS(2258),
    [anon_sym_unsafe] = ACTIONS(2258),
    [anon_sym_use] = ACTIONS(2258),
    [anon_sym_while] = ACTIONS(2258),
    [anon_sym_extern] = ACTIONS(2258),
    [anon_sym_yield] = ACTIONS(2258),
    [anon_sym_move] = ACTIONS(2258),
    [anon_sym_try] = ACTIONS(2258),
    [sym_integer_literal] = ACTIONS(2256),
    [aux_sym_string_literal_token1] = ACTIONS(2256),
    [sym_char_literal] = ACTIONS(2256),
    [anon_sym_true] = ACTIONS(2258),
    [anon_sym_false] = ACTIONS(2258),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2258),
    [sym_super] = ACTIONS(2258),
    [sym_crate] = ACTIONS(2258),
    [sym_metavariable] = ACTIONS(2256),
    [sym__raw_string_literal_start] = ACTIONS(2256),
    [sym_float_literal] = ACTIONS(2256),
  },
  [603] = {
    [sym_line_comment] = STATE(603),
    [sym_block_comment] = STATE(603),
    [ts_builtin_sym_end] = ACTIONS(2260),
    [sym_identifier] = ACTIONS(2262),
    [anon_sym_SEMI] = ACTIONS(2260),
    [anon_sym_macro_rules_BANG] = ACTIONS(2260),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_LBRACK] = ACTIONS(2260),
    [anon_sym_LBRACE] = ACTIONS(2260),
    [anon_sym_RBRACE] = ACTIONS(2260),
    [anon_sym_STAR] = ACTIONS(2260),
    [anon_sym_u8] = ACTIONS(2262),
    [anon_sym_i8] = ACTIONS(2262),
    [anon_sym_u16] = ACTIONS(2262),
    [anon_sym_i16] = ACTIONS(2262),
    [anon_sym_u32] = ACTIONS(2262),
    [anon_sym_i32] = ACTIONS(2262),
    [anon_sym_u64] = ACTIONS(2262),
    [anon_sym_i64] = ACTIONS(2262),
    [anon_sym_u128] = ACTIONS(2262),
    [anon_sym_i128] = ACTIONS(2262),
    [anon_sym_isize] = ACTIONS(2262),
    [anon_sym_usize] = ACTIONS(2262),
    [anon_sym_f32] = ACTIONS(2262),
    [anon_sym_f64] = ACTIONS(2262),
    [anon_sym_bool] = ACTIONS(2262),
    [anon_sym_str] = ACTIONS(2262),
    [anon_sym_char] = ACTIONS(2262),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_BANG] = ACTIONS(2260),
    [anon_sym_AMP] = ACTIONS(2260),
    [anon_sym_PIPE] = ACTIONS(2260),
    [anon_sym_LT] = ACTIONS(2260),
    [anon_sym_DOT_DOT] = ACTIONS(2260),
    [anon_sym_COLON_COLON] = ACTIONS(2260),
    [anon_sym_POUND] = ACTIONS(2260),
    [anon_sym_SQUOTE] = ACTIONS(2262),
    [anon_sym_async] = ACTIONS(2262),
    [anon_sym_break] = ACTIONS(2262),
    [anon_sym_const] = ACTIONS(2262),
    [anon_sym_continue] = ACTIONS(2262),
    [anon_sym_default] = ACTIONS(2262),
    [anon_sym_enum] = ACTIONS(2262),
    [anon_sym_fn] = ACTIONS(2262),
    [anon_sym_for] = ACTIONS(2262),
    [anon_sym_if] = ACTIONS(2262),
    [anon_sym_impl] = ACTIONS(2262),
    [anon_sym_let] = ACTIONS(2262),
    [anon_sym_loop] = ACTIONS(2262),
    [anon_sym_match] = ACTIONS(2262),
    [anon_sym_mod] = ACTIONS(2262),
    [anon_sym_pub] = ACTIONS(2262),
    [anon_sym_return] = ACTIONS(2262),
    [anon_sym_static] = ACTIONS(2262),
    [anon_sym_struct] = ACTIONS(2262),
    [anon_sym_trait] = ACTIONS(2262),
    [anon_sym_type] = ACTIONS(2262),
    [anon_sym_union] = ACTIONS(2262),
    [anon_sym_unsafe] = ACTIONS(2262),
    [anon_sym_use] = ACTIONS(2262),
    [anon_sym_while] = ACTIONS(2262),
    [anon_sym_extern] = ACTIONS(2262),
    [anon_sym_yield] = ACTIONS(2262),
    [anon_sym_move] = ACTIONS(2262),
    [anon_sym_try] = ACTIONS(2262),
    [sym_integer_literal] = ACTIONS(2260),
    [aux_sym_string_literal_token1] = ACTIONS(2260),
    [sym_char_literal] = ACTIONS(2260),
    [anon_sym_true] = ACTIONS(2262),
    [anon_sym_false] = ACTIONS(2262),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2262),
    [sym_super] = ACTIONS(2262),
    [sym_crate] = ACTIONS(2262),
    [sym_metavariable] = ACTIONS(2260),
    [sym__raw_string_literal_start] = ACTIONS(2260),
    [sym_float_literal] = ACTIONS(2260),
  },
  [604] = {
    [sym_line_comment] = STATE(604),
    [sym_block_comment] = STATE(604),
    [ts_builtin_sym_end] = ACTIONS(2264),
    [sym_identifier] = ACTIONS(2266),
    [anon_sym_SEMI] = ACTIONS(2264),
    [anon_sym_macro_rules_BANG] = ACTIONS(2264),
    [anon_sym_LPAREN] = ACTIONS(2264),
    [anon_sym_LBRACK] = ACTIONS(2264),
    [anon_sym_LBRACE] = ACTIONS(2264),
    [anon_sym_RBRACE] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(2264),
    [anon_sym_u8] = ACTIONS(2266),
    [anon_sym_i8] = ACTIONS(2266),
    [anon_sym_u16] = ACTIONS(2266),
    [anon_sym_i16] = ACTIONS(2266),
    [anon_sym_u32] = ACTIONS(2266),
    [anon_sym_i32] = ACTIONS(2266),
    [anon_sym_u64] = ACTIONS(2266),
    [anon_sym_i64] = ACTIONS(2266),
    [anon_sym_u128] = ACTIONS(2266),
    [anon_sym_i128] = ACTIONS(2266),
    [anon_sym_isize] = ACTIONS(2266),
    [anon_sym_usize] = ACTIONS(2266),
    [anon_sym_f32] = ACTIONS(2266),
    [anon_sym_f64] = ACTIONS(2266),
    [anon_sym_bool] = ACTIONS(2266),
    [anon_sym_str] = ACTIONS(2266),
    [anon_sym_char] = ACTIONS(2266),
    [anon_sym_DASH] = ACTIONS(2264),
    [anon_sym_BANG] = ACTIONS(2264),
    [anon_sym_AMP] = ACTIONS(2264),
    [anon_sym_PIPE] = ACTIONS(2264),
    [anon_sym_LT] = ACTIONS(2264),
    [anon_sym_DOT_DOT] = ACTIONS(2264),
    [anon_sym_COLON_COLON] = ACTIONS(2264),
    [anon_sym_POUND] = ACTIONS(2264),
    [anon_sym_SQUOTE] = ACTIONS(2266),
    [anon_sym_async] = ACTIONS(2266),
    [anon_sym_break] = ACTIONS(2266),
    [anon_sym_const] = ACTIONS(2266),
    [anon_sym_continue] = ACTIONS(2266),
    [anon_sym_default] = ACTIONS(2266),
    [anon_sym_enum] = ACTIONS(2266),
    [anon_sym_fn] = ACTIONS(2266),
    [anon_sym_for] = ACTIONS(2266),
    [anon_sym_if] = ACTIONS(2266),
    [anon_sym_impl] = ACTIONS(2266),
    [anon_sym_let] = ACTIONS(2266),
    [anon_sym_loop] = ACTIONS(2266),
    [anon_sym_match] = ACTIONS(2266),
    [anon_sym_mod] = ACTIONS(2266),
    [anon_sym_pub] = ACTIONS(2266),
    [anon_sym_return] = ACTIONS(2266),
    [anon_sym_static] = ACTIONS(2266),
    [anon_sym_struct] = ACTIONS(2266),
    [anon_sym_trait] = ACTIONS(2266),
    [anon_sym_type] = ACTIONS(2266),
    [anon_sym_union] = ACTIONS(2266),
    [anon_sym_unsafe] = ACTIONS(2266),
    [anon_sym_use] = ACTIONS(2266),
    [anon_sym_while] = ACTIONS(2266),
    [anon_sym_extern] = ACTIONS(2266),
    [anon_sym_yield] = ACTIONS(2266),
    [anon_sym_move] = ACTIONS(2266),
    [anon_sym_try] = ACTIONS(2266),
    [sym_integer_literal] = ACTIONS(2264),
    [aux_sym_string_literal_token1] = ACTIONS(2264),
    [sym_char_literal] = ACTIONS(2264),
    [anon_sym_true] = ACTIONS(2266),
    [anon_sym_false] = ACTIONS(2266),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2266),
    [sym_super] = ACTIONS(2266),
    [sym_crate] = ACTIONS(2266),
    [sym_metavariable] = ACTIONS(2264),
    [sym__raw_string_literal_start] = ACTIONS(2264),
    [sym_float_literal] = ACTIONS(2264),
  },
  [605] = {
    [sym_line_comment] = STATE(605),
    [sym_block_comment] = STATE(605),
    [ts_builtin_sym_end] = ACTIONS(2268),
    [sym_identifier] = ACTIONS(2270),
    [anon_sym_SEMI] = ACTIONS(2268),
    [anon_sym_macro_rules_BANG] = ACTIONS(2268),
    [anon_sym_LPAREN] = ACTIONS(2268),
    [anon_sym_LBRACK] = ACTIONS(2268),
    [anon_sym_LBRACE] = ACTIONS(2268),
    [anon_sym_RBRACE] = ACTIONS(2268),
    [anon_sym_STAR] = ACTIONS(2268),
    [anon_sym_u8] = ACTIONS(2270),
    [anon_sym_i8] = ACTIONS(2270),
    [anon_sym_u16] = ACTIONS(2270),
    [anon_sym_i16] = ACTIONS(2270),
    [anon_sym_u32] = ACTIONS(2270),
    [anon_sym_i32] = ACTIONS(2270),
    [anon_sym_u64] = ACTIONS(2270),
    [anon_sym_i64] = ACTIONS(2270),
    [anon_sym_u128] = ACTIONS(2270),
    [anon_sym_i128] = ACTIONS(2270),
    [anon_sym_isize] = ACTIONS(2270),
    [anon_sym_usize] = ACTIONS(2270),
    [anon_sym_f32] = ACTIONS(2270),
    [anon_sym_f64] = ACTIONS(2270),
    [anon_sym_bool] = ACTIONS(2270),
    [anon_sym_str] = ACTIONS(2270),
    [anon_sym_char] = ACTIONS(2270),
    [anon_sym_DASH] = ACTIONS(2268),
    [anon_sym_BANG] = ACTIONS(2268),
    [anon_sym_AMP] = ACTIONS(2268),
    [anon_sym_PIPE] = ACTIONS(2268),
    [anon_sym_LT] = ACTIONS(2268),
    [anon_sym_DOT_DOT] = ACTIONS(2268),
    [anon_sym_COLON_COLON] = ACTIONS(2268),
    [anon_sym_POUND] = ACTIONS(2268),
    [anon_sym_SQUOTE] = ACTIONS(2270),
    [anon_sym_async] = ACTIONS(2270),
    [anon_sym_break] = ACTIONS(2270),
    [anon_sym_const] = ACTIONS(2270),
    [anon_sym_continue] = ACTIONS(2270),
    [anon_sym_default] = ACTIONS(2270),
    [anon_sym_enum] = ACTIONS(2270),
    [anon_sym_fn] = ACTIONS(2270),
    [anon_sym_for] = ACTIONS(2270),
    [anon_sym_if] = ACTIONS(2270),
    [anon_sym_impl] = ACTIONS(2270),
    [anon_sym_let] = ACTIONS(2270),
    [anon_sym_loop] = ACTIONS(2270),
    [anon_sym_match] = ACTIONS(2270),
    [anon_sym_mod] = ACTIONS(2270),
    [anon_sym_pub] = ACTIONS(2270),
    [anon_sym_return] = ACTIONS(2270),
    [anon_sym_static] = ACTIONS(2270),
    [anon_sym_struct] = ACTIONS(2270),
    [anon_sym_trait] = ACTIONS(2270),
    [anon_sym_type] = ACTIONS(2270),
    [anon_sym_union] = ACTIONS(2270),
    [anon_sym_unsafe] = ACTIONS(2270),
    [anon_sym_use] = ACTIONS(2270),
    [anon_sym_while] = ACTIONS(2270),
    [anon_sym_extern] = ACTIONS(2270),
    [anon_sym_yield] = ACTIONS(2270),
    [anon_sym_move] = ACTIONS(2270),
    [anon_sym_try] = ACTIONS(2270),
    [sym_integer_literal] = ACTIONS(2268),
    [aux_sym_string_literal_token1] = ACTIONS(2268),
    [sym_char_literal] = ACTIONS(2268),
    [anon_sym_true] = ACTIONS(2270),
    [anon_sym_false] = ACTIONS(2270),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2270),
    [sym_super] = ACTIONS(2270),
    [sym_crate] = ACTIONS(2270),
    [sym_metavariable] = ACTIONS(2268),
    [sym__raw_string_literal_start] = ACTIONS(2268),
    [sym_float_literal] = ACTIONS(2268),
  },
  [606] = {
    [sym_line_comment] = STATE(606),
    [sym_block_comment] = STATE(606),
    [ts_builtin_sym_end] = ACTIONS(2272),
    [sym_identifier] = ACTIONS(2274),
    [anon_sym_SEMI] = ACTIONS(2272),
    [anon_sym_macro_rules_BANG] = ACTIONS(2272),
    [anon_sym_LPAREN] = ACTIONS(2272),
    [anon_sym_LBRACK] = ACTIONS(2272),
    [anon_sym_LBRACE] = ACTIONS(2272),
    [anon_sym_RBRACE] = ACTIONS(2272),
    [anon_sym_STAR] = ACTIONS(2272),
    [anon_sym_u8] = ACTIONS(2274),
    [anon_sym_i8] = ACTIONS(2274),
    [anon_sym_u16] = ACTIONS(2274),
    [anon_sym_i16] = ACTIONS(2274),
    [anon_sym_u32] = ACTIONS(2274),
    [anon_sym_i32] = ACTIONS(2274),
    [anon_sym_u64] = ACTIONS(2274),
    [anon_sym_i64] = ACTIONS(2274),
    [anon_sym_u128] = ACTIONS(2274),
    [anon_sym_i128] = ACTIONS(2274),
    [anon_sym_isize] = ACTIONS(2274),
    [anon_sym_usize] = ACTIONS(2274),
    [anon_sym_f32] = ACTIONS(2274),
    [anon_sym_f64] = ACTIONS(2274),
    [anon_sym_bool] = ACTIONS(2274),
    [anon_sym_str] = ACTIONS(2274),
    [anon_sym_char] = ACTIONS(2274),
    [anon_sym_DASH] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2272),
    [anon_sym_AMP] = ACTIONS(2272),
    [anon_sym_PIPE] = ACTIONS(2272),
    [anon_sym_LT] = ACTIONS(2272),
    [anon_sym_DOT_DOT] = ACTIONS(2272),
    [anon_sym_COLON_COLON] = ACTIONS(2272),
    [anon_sym_POUND] = ACTIONS(2272),
    [anon_sym_SQUOTE] = ACTIONS(2274),
    [anon_sym_async] = ACTIONS(2274),
    [anon_sym_break] = ACTIONS(2274),
    [anon_sym_const] = ACTIONS(2274),
    [anon_sym_continue] = ACTIONS(2274),
    [anon_sym_default] = ACTIONS(2274),
    [anon_sym_enum] = ACTIONS(2274),
    [anon_sym_fn] = ACTIONS(2274),
    [anon_sym_for] = ACTIONS(2274),
    [anon_sym_if] = ACTIONS(2274),
    [anon_sym_impl] = ACTIONS(2274),
    [anon_sym_let] = ACTIONS(2274),
    [anon_sym_loop] = ACTIONS(2274),
    [anon_sym_match] = ACTIONS(2274),
    [anon_sym_mod] = ACTIONS(2274),
    [anon_sym_pub] = ACTIONS(2274),
    [anon_sym_return] = ACTIONS(2274),
    [anon_sym_static] = ACTIONS(2274),
    [anon_sym_struct] = ACTIONS(2274),
    [anon_sym_trait] = ACTIONS(2274),
    [anon_sym_type] = ACTIONS(2274),
    [anon_sym_union] = ACTIONS(2274),
    [anon_sym_unsafe] = ACTIONS(2274),
    [anon_sym_use] = ACTIONS(2274),
    [anon_sym_while] = ACTIONS(2274),
    [anon_sym_extern] = ACTIONS(2274),
    [anon_sym_yield] = ACTIONS(2274),
    [anon_sym_move] = ACTIONS(2274),
    [anon_sym_try] = ACTIONS(2274),
    [sym_integer_literal] = ACTIONS(2272),
    [aux_sym_string_literal_token1] = ACTIONS(2272),
    [sym_char_literal] = ACTIONS(2272),
    [anon_sym_true] = ACTIONS(2274),
    [anon_sym_false] = ACTIONS(2274),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2274),
    [sym_super] = ACTIONS(2274),
    [sym_crate] = ACTIONS(2274),
    [sym_metavariable] = ACTIONS(2272),
    [sym__raw_string_literal_start] = ACTIONS(2272),
    [sym_float_literal] = ACTIONS(2272),
  },
  [607] = {
    [sym_line_comment] = STATE(607),
    [sym_block_comment] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(2276),
    [sym_identifier] = ACTIONS(2278),
    [anon_sym_SEMI] = ACTIONS(2276),
    [anon_sym_macro_rules_BANG] = ACTIONS(2276),
    [anon_sym_LPAREN] = ACTIONS(2276),
    [anon_sym_LBRACK] = ACTIONS(2276),
    [anon_sym_LBRACE] = ACTIONS(2276),
    [anon_sym_RBRACE] = ACTIONS(2276),
    [anon_sym_STAR] = ACTIONS(2276),
    [anon_sym_u8] = ACTIONS(2278),
    [anon_sym_i8] = ACTIONS(2278),
    [anon_sym_u16] = ACTIONS(2278),
    [anon_sym_i16] = ACTIONS(2278),
    [anon_sym_u32] = ACTIONS(2278),
    [anon_sym_i32] = ACTIONS(2278),
    [anon_sym_u64] = ACTIONS(2278),
    [anon_sym_i64] = ACTIONS(2278),
    [anon_sym_u128] = ACTIONS(2278),
    [anon_sym_i128] = ACTIONS(2278),
    [anon_sym_isize] = ACTIONS(2278),
    [anon_sym_usize] = ACTIONS(2278),
    [anon_sym_f32] = ACTIONS(2278),
    [anon_sym_f64] = ACTIONS(2278),
    [anon_sym_bool] = ACTIONS(2278),
    [anon_sym_str] = ACTIONS(2278),
    [anon_sym_char] = ACTIONS(2278),
    [anon_sym_DASH] = ACTIONS(2276),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_AMP] = ACTIONS(2276),
    [anon_sym_PIPE] = ACTIONS(2276),
    [anon_sym_LT] = ACTIONS(2276),
    [anon_sym_DOT_DOT] = ACTIONS(2276),
    [anon_sym_COLON_COLON] = ACTIONS(2276),
    [anon_sym_POUND] = ACTIONS(2276),
    [anon_sym_SQUOTE] = ACTIONS(2278),
    [anon_sym_async] = ACTIONS(2278),
    [anon_sym_break] = ACTIONS(2278),
    [anon_sym_const] = ACTIONS(2278),
    [anon_sym_continue] = ACTIONS(2278),
    [anon_sym_default] = ACTIONS(2278),
    [anon_sym_enum] = ACTIONS(2278),
    [anon_sym_fn] = ACTIONS(2278),
    [anon_sym_for] = ACTIONS(2278),
    [anon_sym_if] = ACTIONS(2278),
    [anon_sym_impl] = ACTIONS(2278),
    [anon_sym_let] = ACTIONS(2278),
    [anon_sym_loop] = ACTIONS(2278),
    [anon_sym_match] = ACTIONS(2278),
    [anon_sym_mod] = ACTIONS(2278),
    [anon_sym_pub] = ACTIONS(2278),
    [anon_sym_return] = ACTIONS(2278),
    [anon_sym_static] = ACTIONS(2278),
    [anon_sym_struct] = ACTIONS(2278),
    [anon_sym_trait] = ACTIONS(2278),
    [anon_sym_type] = ACTIONS(2278),
    [anon_sym_union] = ACTIONS(2278),
    [anon_sym_unsafe] = ACTIONS(2278),
    [anon_sym_use] = ACTIONS(2278),
    [anon_sym_while] = ACTIONS(2278),
    [anon_sym_extern] = ACTIONS(2278),
    [anon_sym_yield] = ACTIONS(2278),
    [anon_sym_move] = ACTIONS(2278),
    [anon_sym_try] = ACTIONS(2278),
    [sym_integer_literal] = ACTIONS(2276),
    [aux_sym_string_literal_token1] = ACTIONS(2276),
    [sym_char_literal] = ACTIONS(2276),
    [anon_sym_true] = ACTIONS(2278),
    [anon_sym_false] = ACTIONS(2278),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2278),
    [sym_super] = ACTIONS(2278),
    [sym_crate] = ACTIONS(2278),
    [sym_metavariable] = ACTIONS(2276),
    [sym__raw_string_literal_start] = ACTIONS(2276),
    [sym_float_literal] = ACTIONS(2276),
  },
  [608] = {
    [sym_line_comment] = STATE(608),
    [sym_block_comment] = STATE(608),
    [ts_builtin_sym_end] = ACTIONS(2280),
    [sym_identifier] = ACTIONS(2282),
    [anon_sym_SEMI] = ACTIONS(2280),
    [anon_sym_macro_rules_BANG] = ACTIONS(2280),
    [anon_sym_LPAREN] = ACTIONS(2280),
    [anon_sym_LBRACK] = ACTIONS(2280),
    [anon_sym_LBRACE] = ACTIONS(2280),
    [anon_sym_RBRACE] = ACTIONS(2280),
    [anon_sym_STAR] = ACTIONS(2280),
    [anon_sym_u8] = ACTIONS(2282),
    [anon_sym_i8] = ACTIONS(2282),
    [anon_sym_u16] = ACTIONS(2282),
    [anon_sym_i16] = ACTIONS(2282),
    [anon_sym_u32] = ACTIONS(2282),
    [anon_sym_i32] = ACTIONS(2282),
    [anon_sym_u64] = ACTIONS(2282),
    [anon_sym_i64] = ACTIONS(2282),
    [anon_sym_u128] = ACTIONS(2282),
    [anon_sym_i128] = ACTIONS(2282),
    [anon_sym_isize] = ACTIONS(2282),
    [anon_sym_usize] = ACTIONS(2282),
    [anon_sym_f32] = ACTIONS(2282),
    [anon_sym_f64] = ACTIONS(2282),
    [anon_sym_bool] = ACTIONS(2282),
    [anon_sym_str] = ACTIONS(2282),
    [anon_sym_char] = ACTIONS(2282),
    [anon_sym_DASH] = ACTIONS(2280),
    [anon_sym_BANG] = ACTIONS(2280),
    [anon_sym_AMP] = ACTIONS(2280),
    [anon_sym_PIPE] = ACTIONS(2280),
    [anon_sym_LT] = ACTIONS(2280),
    [anon_sym_DOT_DOT] = ACTIONS(2280),
    [anon_sym_COLON_COLON] = ACTIONS(2280),
    [anon_sym_POUND] = ACTIONS(2280),
    [anon_sym_SQUOTE] = ACTIONS(2282),
    [anon_sym_async] = ACTIONS(2282),
    [anon_sym_break] = ACTIONS(2282),
    [anon_sym_const] = ACTIONS(2282),
    [anon_sym_continue] = ACTIONS(2282),
    [anon_sym_default] = ACTIONS(2282),
    [anon_sym_enum] = ACTIONS(2282),
    [anon_sym_fn] = ACTIONS(2282),
    [anon_sym_for] = ACTIONS(2282),
    [anon_sym_if] = ACTIONS(2282),
    [anon_sym_impl] = ACTIONS(2282),
    [anon_sym_let] = ACTIONS(2282),
    [anon_sym_loop] = ACTIONS(2282),
    [anon_sym_match] = ACTIONS(2282),
    [anon_sym_mod] = ACTIONS(2282),
    [anon_sym_pub] = ACTIONS(2282),
    [anon_sym_return] = ACTIONS(2282),
    [anon_sym_static] = ACTIONS(2282),
    [anon_sym_struct] = ACTIONS(2282),
    [anon_sym_trait] = ACTIONS(2282),
    [anon_sym_type] = ACTIONS(2282),
    [anon_sym_union] = ACTIONS(2282),
    [anon_sym_unsafe] = ACTIONS(2282),
    [anon_sym_use] = ACTIONS(2282),
    [anon_sym_while] = ACTIONS(2282),
    [anon_sym_extern] = ACTIONS(2282),
    [anon_sym_yield] = ACTIONS(2282),
    [anon_sym_move] = ACTIONS(2282),
    [anon_sym_try] = ACTIONS(2282),
    [sym_integer_literal] = ACTIONS(2280),
    [aux_sym_string_literal_token1] = ACTIONS(2280),
    [sym_char_literal] = ACTIONS(2280),
    [anon_sym_true] = ACTIONS(2282),
    [anon_sym_false] = ACTIONS(2282),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2282),
    [sym_super] = ACTIONS(2282),
    [sym_crate] = ACTIONS(2282),
    [sym_metavariable] = ACTIONS(2280),
    [sym__raw_string_literal_start] = ACTIONS(2280),
    [sym_float_literal] = ACTIONS(2280),
  },
  [609] = {
    [sym_line_comment] = STATE(609),
    [sym_block_comment] = STATE(609),
    [ts_builtin_sym_end] = ACTIONS(2284),
    [sym_identifier] = ACTIONS(2286),
    [anon_sym_SEMI] = ACTIONS(2284),
    [anon_sym_macro_rules_BANG] = ACTIONS(2284),
    [anon_sym_LPAREN] = ACTIONS(2284),
    [anon_sym_LBRACK] = ACTIONS(2284),
    [anon_sym_LBRACE] = ACTIONS(2284),
    [anon_sym_RBRACE] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(2284),
    [anon_sym_u8] = ACTIONS(2286),
    [anon_sym_i8] = ACTIONS(2286),
    [anon_sym_u16] = ACTIONS(2286),
    [anon_sym_i16] = ACTIONS(2286),
    [anon_sym_u32] = ACTIONS(2286),
    [anon_sym_i32] = ACTIONS(2286),
    [anon_sym_u64] = ACTIONS(2286),
    [anon_sym_i64] = ACTIONS(2286),
    [anon_sym_u128] = ACTIONS(2286),
    [anon_sym_i128] = ACTIONS(2286),
    [anon_sym_isize] = ACTIONS(2286),
    [anon_sym_usize] = ACTIONS(2286),
    [anon_sym_f32] = ACTIONS(2286),
    [anon_sym_f64] = ACTIONS(2286),
    [anon_sym_bool] = ACTIONS(2286),
    [anon_sym_str] = ACTIONS(2286),
    [anon_sym_char] = ACTIONS(2286),
    [anon_sym_DASH] = ACTIONS(2284),
    [anon_sym_BANG] = ACTIONS(2284),
    [anon_sym_AMP] = ACTIONS(2284),
    [anon_sym_PIPE] = ACTIONS(2284),
    [anon_sym_LT] = ACTIONS(2284),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_COLON_COLON] = ACTIONS(2284),
    [anon_sym_POUND] = ACTIONS(2284),
    [anon_sym_SQUOTE] = ACTIONS(2286),
    [anon_sym_async] = ACTIONS(2286),
    [anon_sym_break] = ACTIONS(2286),
    [anon_sym_const] = ACTIONS(2286),
    [anon_sym_continue] = ACTIONS(2286),
    [anon_sym_default] = ACTIONS(2286),
    [anon_sym_enum] = ACTIONS(2286),
    [anon_sym_fn] = ACTIONS(2286),
    [anon_sym_for] = ACTIONS(2286),
    [anon_sym_if] = ACTIONS(2286),
    [anon_sym_impl] = ACTIONS(2286),
    [anon_sym_let] = ACTIONS(2286),
    [anon_sym_loop] = ACTIONS(2286),
    [anon_sym_match] = ACTIONS(2286),
    [anon_sym_mod] = ACTIONS(2286),
    [anon_sym_pub] = ACTIONS(2286),
    [anon_sym_return] = ACTIONS(2286),
    [anon_sym_static] = ACTIONS(2286),
    [anon_sym_struct] = ACTIONS(2286),
    [anon_sym_trait] = ACTIONS(2286),
    [anon_sym_type] = ACTIONS(2286),
    [anon_sym_union] = ACTIONS(2286),
    [anon_sym_unsafe] = ACTIONS(2286),
    [anon_sym_use] = ACTIONS(2286),
    [anon_sym_while] = ACTIONS(2286),
    [anon_sym_extern] = ACTIONS(2286),
    [anon_sym_yield] = ACTIONS(2286),
    [anon_sym_move] = ACTIONS(2286),
    [anon_sym_try] = ACTIONS(2286),
    [sym_integer_literal] = ACTIONS(2284),
    [aux_sym_string_literal_token1] = ACTIONS(2284),
    [sym_char_literal] = ACTIONS(2284),
    [anon_sym_true] = ACTIONS(2286),
    [anon_sym_false] = ACTIONS(2286),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2286),
    [sym_super] = ACTIONS(2286),
    [sym_crate] = ACTIONS(2286),
    [sym_metavariable] = ACTIONS(2284),
    [sym__raw_string_literal_start] = ACTIONS(2284),
    [sym_float_literal] = ACTIONS(2284),
  },
  [610] = {
    [sym_line_comment] = STATE(610),
    [sym_block_comment] = STATE(610),
    [ts_builtin_sym_end] = ACTIONS(2288),
    [sym_identifier] = ACTIONS(2290),
    [anon_sym_SEMI] = ACTIONS(2288),
    [anon_sym_macro_rules_BANG] = ACTIONS(2288),
    [anon_sym_LPAREN] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2288),
    [anon_sym_RBRACE] = ACTIONS(2288),
    [anon_sym_STAR] = ACTIONS(2288),
    [anon_sym_u8] = ACTIONS(2290),
    [anon_sym_i8] = ACTIONS(2290),
    [anon_sym_u16] = ACTIONS(2290),
    [anon_sym_i16] = ACTIONS(2290),
    [anon_sym_u32] = ACTIONS(2290),
    [anon_sym_i32] = ACTIONS(2290),
    [anon_sym_u64] = ACTIONS(2290),
    [anon_sym_i64] = ACTIONS(2290),
    [anon_sym_u128] = ACTIONS(2290),
    [anon_sym_i128] = ACTIONS(2290),
    [anon_sym_isize] = ACTIONS(2290),
    [anon_sym_usize] = ACTIONS(2290),
    [anon_sym_f32] = ACTIONS(2290),
    [anon_sym_f64] = ACTIONS(2290),
    [anon_sym_bool] = ACTIONS(2290),
    [anon_sym_str] = ACTIONS(2290),
    [anon_sym_char] = ACTIONS(2290),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_BANG] = ACTIONS(2288),
    [anon_sym_AMP] = ACTIONS(2288),
    [anon_sym_PIPE] = ACTIONS(2288),
    [anon_sym_LT] = ACTIONS(2288),
    [anon_sym_DOT_DOT] = ACTIONS(2288),
    [anon_sym_COLON_COLON] = ACTIONS(2288),
    [anon_sym_POUND] = ACTIONS(2288),
    [anon_sym_SQUOTE] = ACTIONS(2290),
    [anon_sym_async] = ACTIONS(2290),
    [anon_sym_break] = ACTIONS(2290),
    [anon_sym_const] = ACTIONS(2290),
    [anon_sym_continue] = ACTIONS(2290),
    [anon_sym_default] = ACTIONS(2290),
    [anon_sym_enum] = ACTIONS(2290),
    [anon_sym_fn] = ACTIONS(2290),
    [anon_sym_for] = ACTIONS(2290),
    [anon_sym_if] = ACTIONS(2290),
    [anon_sym_impl] = ACTIONS(2290),
    [anon_sym_let] = ACTIONS(2290),
    [anon_sym_loop] = ACTIONS(2290),
    [anon_sym_match] = ACTIONS(2290),
    [anon_sym_mod] = ACTIONS(2290),
    [anon_sym_pub] = ACTIONS(2290),
    [anon_sym_return] = ACTIONS(2290),
    [anon_sym_static] = ACTIONS(2290),
    [anon_sym_struct] = ACTIONS(2290),
    [anon_sym_trait] = ACTIONS(2290),
    [anon_sym_type] = ACTIONS(2290),
    [anon_sym_union] = ACTIONS(2290),
    [anon_sym_unsafe] = ACTIONS(2290),
    [anon_sym_use] = ACTIONS(2290),
    [anon_sym_while] = ACTIONS(2290),
    [anon_sym_extern] = ACTIONS(2290),
    [anon_sym_yield] = ACTIONS(2290),
    [anon_sym_move] = ACTIONS(2290),
    [anon_sym_try] = ACTIONS(2290),
    [sym_integer_literal] = ACTIONS(2288),
    [aux_sym_string_literal_token1] = ACTIONS(2288),
    [sym_char_literal] = ACTIONS(2288),
    [anon_sym_true] = ACTIONS(2290),
    [anon_sym_false] = ACTIONS(2290),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2290),
    [sym_super] = ACTIONS(2290),
    [sym_crate] = ACTIONS(2290),
    [sym_metavariable] = ACTIONS(2288),
    [sym__raw_string_literal_start] = ACTIONS(2288),
    [sym_float_literal] = ACTIONS(2288),
  },
  [611] = {
    [sym_line_comment] = STATE(611),
    [sym_block_comment] = STATE(611),
    [ts_builtin_sym_end] = ACTIONS(2292),
    [sym_identifier] = ACTIONS(2294),
    [anon_sym_SEMI] = ACTIONS(2292),
    [anon_sym_macro_rules_BANG] = ACTIONS(2292),
    [anon_sym_LPAREN] = ACTIONS(2292),
    [anon_sym_LBRACK] = ACTIONS(2292),
    [anon_sym_LBRACE] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(2292),
    [anon_sym_STAR] = ACTIONS(2292),
    [anon_sym_u8] = ACTIONS(2294),
    [anon_sym_i8] = ACTIONS(2294),
    [anon_sym_u16] = ACTIONS(2294),
    [anon_sym_i16] = ACTIONS(2294),
    [anon_sym_u32] = ACTIONS(2294),
    [anon_sym_i32] = ACTIONS(2294),
    [anon_sym_u64] = ACTIONS(2294),
    [anon_sym_i64] = ACTIONS(2294),
    [anon_sym_u128] = ACTIONS(2294),
    [anon_sym_i128] = ACTIONS(2294),
    [anon_sym_isize] = ACTIONS(2294),
    [anon_sym_usize] = ACTIONS(2294),
    [anon_sym_f32] = ACTIONS(2294),
    [anon_sym_f64] = ACTIONS(2294),
    [anon_sym_bool] = ACTIONS(2294),
    [anon_sym_str] = ACTIONS(2294),
    [anon_sym_char] = ACTIONS(2294),
    [anon_sym_DASH] = ACTIONS(2292),
    [anon_sym_BANG] = ACTIONS(2292),
    [anon_sym_AMP] = ACTIONS(2292),
    [anon_sym_PIPE] = ACTIONS(2292),
    [anon_sym_LT] = ACTIONS(2292),
    [anon_sym_DOT_DOT] = ACTIONS(2292),
    [anon_sym_COLON_COLON] = ACTIONS(2292),
    [anon_sym_POUND] = ACTIONS(2292),
    [anon_sym_SQUOTE] = ACTIONS(2294),
    [anon_sym_async] = ACTIONS(2294),
    [anon_sym_break] = ACTIONS(2294),
    [anon_sym_const] = ACTIONS(2294),
    [anon_sym_continue] = ACTIONS(2294),
    [anon_sym_default] = ACTIONS(2294),
    [anon_sym_enum] = ACTIONS(2294),
    [anon_sym_fn] = ACTIONS(2294),
    [anon_sym_for] = ACTIONS(2294),
    [anon_sym_if] = ACTIONS(2294),
    [anon_sym_impl] = ACTIONS(2294),
    [anon_sym_let] = ACTIONS(2294),
    [anon_sym_loop] = ACTIONS(2294),
    [anon_sym_match] = ACTIONS(2294),
    [anon_sym_mod] = ACTIONS(2294),
    [anon_sym_pub] = ACTIONS(2294),
    [anon_sym_return] = ACTIONS(2294),
    [anon_sym_static] = ACTIONS(2294),
    [anon_sym_struct] = ACTIONS(2294),
    [anon_sym_trait] = ACTIONS(2294),
    [anon_sym_type] = ACTIONS(2294),
    [anon_sym_union] = ACTIONS(2294),
    [anon_sym_unsafe] = ACTIONS(2294),
    [anon_sym_use] = ACTIONS(2294),
    [anon_sym_while] = ACTIONS(2294),
    [anon_sym_extern] = ACTIONS(2294),
    [anon_sym_yield] = ACTIONS(2294),
    [anon_sym_move] = ACTIONS(2294),
    [anon_sym_try] = ACTIONS(2294),
    [sym_integer_literal] = ACTIONS(2292),
    [aux_sym_string_literal_token1] = ACTIONS(2292),
    [sym_char_literal] = ACTIONS(2292),
    [anon_sym_true] = ACTIONS(2294),
    [anon_sym_false] = ACTIONS(2294),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2294),
    [sym_super] = ACTIONS(2294),
    [sym_crate] = ACTIONS(2294),
    [sym_metavariable] = ACTIONS(2292),
    [sym__raw_string_literal_start] = ACTIONS(2292),
    [sym_float_literal] = ACTIONS(2292),
  },
  [612] = {
    [sym_line_comment] = STATE(612),
    [sym_block_comment] = STATE(612),
    [ts_builtin_sym_end] = ACTIONS(2296),
    [sym_identifier] = ACTIONS(2298),
    [anon_sym_SEMI] = ACTIONS(2296),
    [anon_sym_macro_rules_BANG] = ACTIONS(2296),
    [anon_sym_LPAREN] = ACTIONS(2296),
    [anon_sym_LBRACK] = ACTIONS(2296),
    [anon_sym_LBRACE] = ACTIONS(2296),
    [anon_sym_RBRACE] = ACTIONS(2296),
    [anon_sym_STAR] = ACTIONS(2296),
    [anon_sym_u8] = ACTIONS(2298),
    [anon_sym_i8] = ACTIONS(2298),
    [anon_sym_u16] = ACTIONS(2298),
    [anon_sym_i16] = ACTIONS(2298),
    [anon_sym_u32] = ACTIONS(2298),
    [anon_sym_i32] = ACTIONS(2298),
    [anon_sym_u64] = ACTIONS(2298),
    [anon_sym_i64] = ACTIONS(2298),
    [anon_sym_u128] = ACTIONS(2298),
    [anon_sym_i128] = ACTIONS(2298),
    [anon_sym_isize] = ACTIONS(2298),
    [anon_sym_usize] = ACTIONS(2298),
    [anon_sym_f32] = ACTIONS(2298),
    [anon_sym_f64] = ACTIONS(2298),
    [anon_sym_bool] = ACTIONS(2298),
    [anon_sym_str] = ACTIONS(2298),
    [anon_sym_char] = ACTIONS(2298),
    [anon_sym_DASH] = ACTIONS(2296),
    [anon_sym_BANG] = ACTIONS(2296),
    [anon_sym_AMP] = ACTIONS(2296),
    [anon_sym_PIPE] = ACTIONS(2296),
    [anon_sym_LT] = ACTIONS(2296),
    [anon_sym_DOT_DOT] = ACTIONS(2296),
    [anon_sym_COLON_COLON] = ACTIONS(2296),
    [anon_sym_POUND] = ACTIONS(2296),
    [anon_sym_SQUOTE] = ACTIONS(2298),
    [anon_sym_async] = ACTIONS(2298),
    [anon_sym_break] = ACTIONS(2298),
    [anon_sym_const] = ACTIONS(2298),
    [anon_sym_continue] = ACTIONS(2298),
    [anon_sym_default] = ACTIONS(2298),
    [anon_sym_enum] = ACTIONS(2298),
    [anon_sym_fn] = ACTIONS(2298),
    [anon_sym_for] = ACTIONS(2298),
    [anon_sym_if] = ACTIONS(2298),
    [anon_sym_impl] = ACTIONS(2298),
    [anon_sym_let] = ACTIONS(2298),
    [anon_sym_loop] = ACTIONS(2298),
    [anon_sym_match] = ACTIONS(2298),
    [anon_sym_mod] = ACTIONS(2298),
    [anon_sym_pub] = ACTIONS(2298),
    [anon_sym_return] = ACTIONS(2298),
    [anon_sym_static] = ACTIONS(2298),
    [anon_sym_struct] = ACTIONS(2298),
    [anon_sym_trait] = ACTIONS(2298),
    [anon_sym_type] = ACTIONS(2298),
    [anon_sym_union] = ACTIONS(2298),
    [anon_sym_unsafe] = ACTIONS(2298),
    [anon_sym_use] = ACTIONS(2298),
    [anon_sym_while] = ACTIONS(2298),
    [anon_sym_extern] = ACTIONS(2298),
    [anon_sym_yield] = ACTIONS(2298),
    [anon_sym_move] = ACTIONS(2298),
    [anon_sym_try] = ACTIONS(2298),
    [sym_integer_literal] = ACTIONS(2296),
    [aux_sym_string_literal_token1] = ACTIONS(2296),
    [sym_char_literal] = ACTIONS(2296),
    [anon_sym_true] = ACTIONS(2298),
    [anon_sym_false] = ACTIONS(2298),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2298),
    [sym_super] = ACTIONS(2298),
    [sym_crate] = ACTIONS(2298),
    [sym_metavariable] = ACTIONS(2296),
    [sym__raw_string_literal_start] = ACTIONS(2296),
    [sym_float_literal] = ACTIONS(2296),
  },
  [613] = {
    [sym_line_comment] = STATE(613),
    [sym_block_comment] = STATE(613),
    [ts_builtin_sym_end] = ACTIONS(2300),
    [sym_identifier] = ACTIONS(2302),
    [anon_sym_SEMI] = ACTIONS(2300),
    [anon_sym_macro_rules_BANG] = ACTIONS(2300),
    [anon_sym_LPAREN] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(2300),
    [anon_sym_RBRACE] = ACTIONS(2300),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_u8] = ACTIONS(2302),
    [anon_sym_i8] = ACTIONS(2302),
    [anon_sym_u16] = ACTIONS(2302),
    [anon_sym_i16] = ACTIONS(2302),
    [anon_sym_u32] = ACTIONS(2302),
    [anon_sym_i32] = ACTIONS(2302),
    [anon_sym_u64] = ACTIONS(2302),
    [anon_sym_i64] = ACTIONS(2302),
    [anon_sym_u128] = ACTIONS(2302),
    [anon_sym_i128] = ACTIONS(2302),
    [anon_sym_isize] = ACTIONS(2302),
    [anon_sym_usize] = ACTIONS(2302),
    [anon_sym_f32] = ACTIONS(2302),
    [anon_sym_f64] = ACTIONS(2302),
    [anon_sym_bool] = ACTIONS(2302),
    [anon_sym_str] = ACTIONS(2302),
    [anon_sym_char] = ACTIONS(2302),
    [anon_sym_DASH] = ACTIONS(2300),
    [anon_sym_BANG] = ACTIONS(2300),
    [anon_sym_AMP] = ACTIONS(2300),
    [anon_sym_PIPE] = ACTIONS(2300),
    [anon_sym_LT] = ACTIONS(2300),
    [anon_sym_DOT_DOT] = ACTIONS(2300),
    [anon_sym_COLON_COLON] = ACTIONS(2300),
    [anon_sym_POUND] = ACTIONS(2300),
    [anon_sym_SQUOTE] = ACTIONS(2302),
    [anon_sym_async] = ACTIONS(2302),
    [anon_sym_break] = ACTIONS(2302),
    [anon_sym_const] = ACTIONS(2302),
    [anon_sym_continue] = ACTIONS(2302),
    [anon_sym_default] = ACTIONS(2302),
    [anon_sym_enum] = ACTIONS(2302),
    [anon_sym_fn] = ACTIONS(2302),
    [anon_sym_for] = ACTIONS(2302),
    [anon_sym_if] = ACTIONS(2302),
    [anon_sym_impl] = ACTIONS(2302),
    [anon_sym_let] = ACTIONS(2302),
    [anon_sym_loop] = ACTIONS(2302),
    [anon_sym_match] = ACTIONS(2302),
    [anon_sym_mod] = ACTIONS(2302),
    [anon_sym_pub] = ACTIONS(2302),
    [anon_sym_return] = ACTIONS(2302),
    [anon_sym_static] = ACTIONS(2302),
    [anon_sym_struct] = ACTIONS(2302),
    [anon_sym_trait] = ACTIONS(2302),
    [anon_sym_type] = ACTIONS(2302),
    [anon_sym_union] = ACTIONS(2302),
    [anon_sym_unsafe] = ACTIONS(2302),
    [anon_sym_use] = ACTIONS(2302),
    [anon_sym_while] = ACTIONS(2302),
    [anon_sym_extern] = ACTIONS(2302),
    [anon_sym_yield] = ACTIONS(2302),
    [anon_sym_move] = ACTIONS(2302),
    [anon_sym_try] = ACTIONS(2302),
    [sym_integer_literal] = ACTIONS(2300),
    [aux_sym_string_literal_token1] = ACTIONS(2300),
    [sym_char_literal] = ACTIONS(2300),
    [anon_sym_true] = ACTIONS(2302),
    [anon_sym_false] = ACTIONS(2302),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2302),
    [sym_super] = ACTIONS(2302),
    [sym_crate] = ACTIONS(2302),
    [sym_metavariable] = ACTIONS(2300),
    [sym__raw_string_literal_start] = ACTIONS(2300),
    [sym_float_literal] = ACTIONS(2300),
  },
  [614] = {
    [sym_line_comment] = STATE(614),
    [sym_block_comment] = STATE(614),
    [ts_builtin_sym_end] = ACTIONS(2304),
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2304),
    [anon_sym_macro_rules_BANG] = ACTIONS(2304),
    [anon_sym_LPAREN] = ACTIONS(2304),
    [anon_sym_LBRACK] = ACTIONS(2304),
    [anon_sym_LBRACE] = ACTIONS(2304),
    [anon_sym_RBRACE] = ACTIONS(2304),
    [anon_sym_STAR] = ACTIONS(2304),
    [anon_sym_u8] = ACTIONS(2306),
    [anon_sym_i8] = ACTIONS(2306),
    [anon_sym_u16] = ACTIONS(2306),
    [anon_sym_i16] = ACTIONS(2306),
    [anon_sym_u32] = ACTIONS(2306),
    [anon_sym_i32] = ACTIONS(2306),
    [anon_sym_u64] = ACTIONS(2306),
    [anon_sym_i64] = ACTIONS(2306),
    [anon_sym_u128] = ACTIONS(2306),
    [anon_sym_i128] = ACTIONS(2306),
    [anon_sym_isize] = ACTIONS(2306),
    [anon_sym_usize] = ACTIONS(2306),
    [anon_sym_f32] = ACTIONS(2306),
    [anon_sym_f64] = ACTIONS(2306),
    [anon_sym_bool] = ACTIONS(2306),
    [anon_sym_str] = ACTIONS(2306),
    [anon_sym_char] = ACTIONS(2306),
    [anon_sym_DASH] = ACTIONS(2304),
    [anon_sym_BANG] = ACTIONS(2304),
    [anon_sym_AMP] = ACTIONS(2304),
    [anon_sym_PIPE] = ACTIONS(2304),
    [anon_sym_LT] = ACTIONS(2304),
    [anon_sym_DOT_DOT] = ACTIONS(2304),
    [anon_sym_COLON_COLON] = ACTIONS(2304),
    [anon_sym_POUND] = ACTIONS(2304),
    [anon_sym_SQUOTE] = ACTIONS(2306),
    [anon_sym_async] = ACTIONS(2306),
    [anon_sym_break] = ACTIONS(2306),
    [anon_sym_const] = ACTIONS(2306),
    [anon_sym_continue] = ACTIONS(2306),
    [anon_sym_default] = ACTIONS(2306),
    [anon_sym_enum] = ACTIONS(2306),
    [anon_sym_fn] = ACTIONS(2306),
    [anon_sym_for] = ACTIONS(2306),
    [anon_sym_if] = ACTIONS(2306),
    [anon_sym_impl] = ACTIONS(2306),
    [anon_sym_let] = ACTIONS(2306),
    [anon_sym_loop] = ACTIONS(2306),
    [anon_sym_match] = ACTIONS(2306),
    [anon_sym_mod] = ACTIONS(2306),
    [anon_sym_pub] = ACTIONS(2306),
    [anon_sym_return] = ACTIONS(2306),
    [anon_sym_static] = ACTIONS(2306),
    [anon_sym_struct] = ACTIONS(2306),
    [anon_sym_trait] = ACTIONS(2306),
    [anon_sym_type] = ACTIONS(2306),
    [anon_sym_union] = ACTIONS(2306),
    [anon_sym_unsafe] = ACTIONS(2306),
    [anon_sym_use] = ACTIONS(2306),
    [anon_sym_while] = ACTIONS(2306),
    [anon_sym_extern] = ACTIONS(2306),
    [anon_sym_yield] = ACTIONS(2306),
    [anon_sym_move] = ACTIONS(2306),
    [anon_sym_try] = ACTIONS(2306),
    [sym_integer_literal] = ACTIONS(2304),
    [aux_sym_string_literal_token1] = ACTIONS(2304),
    [sym_char_literal] = ACTIONS(2304),
    [anon_sym_true] = ACTIONS(2306),
    [anon_sym_false] = ACTIONS(2306),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2306),
    [sym_super] = ACTIONS(2306),
    [sym_crate] = ACTIONS(2306),
    [sym_metavariable] = ACTIONS(2304),
    [sym__raw_string_literal_start] = ACTIONS(2304),
    [sym_float_literal] = ACTIONS(2304),
  },
  [615] = {
    [sym_line_comment] = STATE(615),
    [sym_block_comment] = STATE(615),
    [ts_builtin_sym_end] = ACTIONS(2308),
    [sym_identifier] = ACTIONS(2310),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_macro_rules_BANG] = ACTIONS(2308),
    [anon_sym_LPAREN] = ACTIONS(2308),
    [anon_sym_LBRACK] = ACTIONS(2308),
    [anon_sym_LBRACE] = ACTIONS(2308),
    [anon_sym_RBRACE] = ACTIONS(2308),
    [anon_sym_STAR] = ACTIONS(2308),
    [anon_sym_u8] = ACTIONS(2310),
    [anon_sym_i8] = ACTIONS(2310),
    [anon_sym_u16] = ACTIONS(2310),
    [anon_sym_i16] = ACTIONS(2310),
    [anon_sym_u32] = ACTIONS(2310),
    [anon_sym_i32] = ACTIONS(2310),
    [anon_sym_u64] = ACTIONS(2310),
    [anon_sym_i64] = ACTIONS(2310),
    [anon_sym_u128] = ACTIONS(2310),
    [anon_sym_i128] = ACTIONS(2310),
    [anon_sym_isize] = ACTIONS(2310),
    [anon_sym_usize] = ACTIONS(2310),
    [anon_sym_f32] = ACTIONS(2310),
    [anon_sym_f64] = ACTIONS(2310),
    [anon_sym_bool] = ACTIONS(2310),
    [anon_sym_str] = ACTIONS(2310),
    [anon_sym_char] = ACTIONS(2310),
    [anon_sym_DASH] = ACTIONS(2308),
    [anon_sym_BANG] = ACTIONS(2308),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_DOT_DOT] = ACTIONS(2308),
    [anon_sym_COLON_COLON] = ACTIONS(2308),
    [anon_sym_POUND] = ACTIONS(2308),
    [anon_sym_SQUOTE] = ACTIONS(2310),
    [anon_sym_async] = ACTIONS(2310),
    [anon_sym_break] = ACTIONS(2310),
    [anon_sym_const] = ACTIONS(2310),
    [anon_sym_continue] = ACTIONS(2310),
    [anon_sym_default] = ACTIONS(2310),
    [anon_sym_enum] = ACTIONS(2310),
    [anon_sym_fn] = ACTIONS(2310),
    [anon_sym_for] = ACTIONS(2310),
    [anon_sym_if] = ACTIONS(2310),
    [anon_sym_impl] = ACTIONS(2310),
    [anon_sym_let] = ACTIONS(2310),
    [anon_sym_loop] = ACTIONS(2310),
    [anon_sym_match] = ACTIONS(2310),
    [anon_sym_mod] = ACTIONS(2310),
    [anon_sym_pub] = ACTIONS(2310),
    [anon_sym_return] = ACTIONS(2310),
    [anon_sym_static] = ACTIONS(2310),
    [anon_sym_struct] = ACTIONS(2310),
    [anon_sym_trait] = ACTIONS(2310),
    [anon_sym_type] = ACTIONS(2310),
    [anon_sym_union] = ACTIONS(2310),
    [anon_sym_unsafe] = ACTIONS(2310),
    [anon_sym_use] = ACTIONS(2310),
    [anon_sym_while] = ACTIONS(2310),
    [anon_sym_extern] = ACTIONS(2310),
    [anon_sym_yield] = ACTIONS(2310),
    [anon_sym_move] = ACTIONS(2310),
    [anon_sym_try] = ACTIONS(2310),
    [sym_integer_literal] = ACTIONS(2308),
    [aux_sym_string_literal_token1] = ACTIONS(2308),
    [sym_char_literal] = ACTIONS(2308),
    [anon_sym_true] = ACTIONS(2310),
    [anon_sym_false] = ACTIONS(2310),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2310),
    [sym_super] = ACTIONS(2310),
    [sym_crate] = ACTIONS(2310),
    [sym_metavariable] = ACTIONS(2308),
    [sym__raw_string_literal_start] = ACTIONS(2308),
    [sym_float_literal] = ACTIONS(2308),
  },
  [616] = {
    [sym_line_comment] = STATE(616),
    [sym_block_comment] = STATE(616),
    [ts_builtin_sym_end] = ACTIONS(2312),
    [sym_identifier] = ACTIONS(2314),
    [anon_sym_SEMI] = ACTIONS(2312),
    [anon_sym_macro_rules_BANG] = ACTIONS(2312),
    [anon_sym_LPAREN] = ACTIONS(2312),
    [anon_sym_LBRACK] = ACTIONS(2312),
    [anon_sym_LBRACE] = ACTIONS(2312),
    [anon_sym_RBRACE] = ACTIONS(2312),
    [anon_sym_STAR] = ACTIONS(2312),
    [anon_sym_u8] = ACTIONS(2314),
    [anon_sym_i8] = ACTIONS(2314),
    [anon_sym_u16] = ACTIONS(2314),
    [anon_sym_i16] = ACTIONS(2314),
    [anon_sym_u32] = ACTIONS(2314),
    [anon_sym_i32] = ACTIONS(2314),
    [anon_sym_u64] = ACTIONS(2314),
    [anon_sym_i64] = ACTIONS(2314),
    [anon_sym_u128] = ACTIONS(2314),
    [anon_sym_i128] = ACTIONS(2314),
    [anon_sym_isize] = ACTIONS(2314),
    [anon_sym_usize] = ACTIONS(2314),
    [anon_sym_f32] = ACTIONS(2314),
    [anon_sym_f64] = ACTIONS(2314),
    [anon_sym_bool] = ACTIONS(2314),
    [anon_sym_str] = ACTIONS(2314),
    [anon_sym_char] = ACTIONS(2314),
    [anon_sym_DASH] = ACTIONS(2312),
    [anon_sym_BANG] = ACTIONS(2312),
    [anon_sym_AMP] = ACTIONS(2312),
    [anon_sym_PIPE] = ACTIONS(2312),
    [anon_sym_LT] = ACTIONS(2312),
    [anon_sym_DOT_DOT] = ACTIONS(2312),
    [anon_sym_COLON_COLON] = ACTIONS(2312),
    [anon_sym_POUND] = ACTIONS(2312),
    [anon_sym_SQUOTE] = ACTIONS(2314),
    [anon_sym_async] = ACTIONS(2314),
    [anon_sym_break] = ACTIONS(2314),
    [anon_sym_const] = ACTIONS(2314),
    [anon_sym_continue] = ACTIONS(2314),
    [anon_sym_default] = ACTIONS(2314),
    [anon_sym_enum] = ACTIONS(2314),
    [anon_sym_fn] = ACTIONS(2314),
    [anon_sym_for] = ACTIONS(2314),
    [anon_sym_if] = ACTIONS(2314),
    [anon_sym_impl] = ACTIONS(2314),
    [anon_sym_let] = ACTIONS(2314),
    [anon_sym_loop] = ACTIONS(2314),
    [anon_sym_match] = ACTIONS(2314),
    [anon_sym_mod] = ACTIONS(2314),
    [anon_sym_pub] = ACTIONS(2314),
    [anon_sym_return] = ACTIONS(2314),
    [anon_sym_static] = ACTIONS(2314),
    [anon_sym_struct] = ACTIONS(2314),
    [anon_sym_trait] = ACTIONS(2314),
    [anon_sym_type] = ACTIONS(2314),
    [anon_sym_union] = ACTIONS(2314),
    [anon_sym_unsafe] = ACTIONS(2314),
    [anon_sym_use] = ACTIONS(2314),
    [anon_sym_while] = ACTIONS(2314),
    [anon_sym_extern] = ACTIONS(2314),
    [anon_sym_yield] = ACTIONS(2314),
    [anon_sym_move] = ACTIONS(2314),
    [anon_sym_try] = ACTIONS(2314),
    [sym_integer_literal] = ACTIONS(2312),
    [aux_sym_string_literal_token1] = ACTIONS(2312),
    [sym_char_literal] = ACTIONS(2312),
    [anon_sym_true] = ACTIONS(2314),
    [anon_sym_false] = ACTIONS(2314),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2314),
    [sym_super] = ACTIONS(2314),
    [sym_crate] = ACTIONS(2314),
    [sym_metavariable] = ACTIONS(2312),
    [sym__raw_string_literal_start] = ACTIONS(2312),
    [sym_float_literal] = ACTIONS(2312),
  },
  [617] = {
    [sym_line_comment] = STATE(617),
    [sym_block_comment] = STATE(617),
    [ts_builtin_sym_end] = ACTIONS(2316),
    [sym_identifier] = ACTIONS(2318),
    [anon_sym_SEMI] = ACTIONS(2316),
    [anon_sym_macro_rules_BANG] = ACTIONS(2316),
    [anon_sym_LPAREN] = ACTIONS(2316),
    [anon_sym_LBRACK] = ACTIONS(2316),
    [anon_sym_LBRACE] = ACTIONS(2316),
    [anon_sym_RBRACE] = ACTIONS(2316),
    [anon_sym_STAR] = ACTIONS(2316),
    [anon_sym_u8] = ACTIONS(2318),
    [anon_sym_i8] = ACTIONS(2318),
    [anon_sym_u16] = ACTIONS(2318),
    [anon_sym_i16] = ACTIONS(2318),
    [anon_sym_u32] = ACTIONS(2318),
    [anon_sym_i32] = ACTIONS(2318),
    [anon_sym_u64] = ACTIONS(2318),
    [anon_sym_i64] = ACTIONS(2318),
    [anon_sym_u128] = ACTIONS(2318),
    [anon_sym_i128] = ACTIONS(2318),
    [anon_sym_isize] = ACTIONS(2318),
    [anon_sym_usize] = ACTIONS(2318),
    [anon_sym_f32] = ACTIONS(2318),
    [anon_sym_f64] = ACTIONS(2318),
    [anon_sym_bool] = ACTIONS(2318),
    [anon_sym_str] = ACTIONS(2318),
    [anon_sym_char] = ACTIONS(2318),
    [anon_sym_DASH] = ACTIONS(2316),
    [anon_sym_BANG] = ACTIONS(2316),
    [anon_sym_AMP] = ACTIONS(2316),
    [anon_sym_PIPE] = ACTIONS(2316),
    [anon_sym_LT] = ACTIONS(2316),
    [anon_sym_DOT_DOT] = ACTIONS(2316),
    [anon_sym_COLON_COLON] = ACTIONS(2316),
    [anon_sym_POUND] = ACTIONS(2316),
    [anon_sym_SQUOTE] = ACTIONS(2318),
    [anon_sym_async] = ACTIONS(2318),
    [anon_sym_break] = ACTIONS(2318),
    [anon_sym_const] = ACTIONS(2318),
    [anon_sym_continue] = ACTIONS(2318),
    [anon_sym_default] = ACTIONS(2318),
    [anon_sym_enum] = ACTIONS(2318),
    [anon_sym_fn] = ACTIONS(2318),
    [anon_sym_for] = ACTIONS(2318),
    [anon_sym_if] = ACTIONS(2318),
    [anon_sym_impl] = ACTIONS(2318),
    [anon_sym_let] = ACTIONS(2318),
    [anon_sym_loop] = ACTIONS(2318),
    [anon_sym_match] = ACTIONS(2318),
    [anon_sym_mod] = ACTIONS(2318),
    [anon_sym_pub] = ACTIONS(2318),
    [anon_sym_return] = ACTIONS(2318),
    [anon_sym_static] = ACTIONS(2318),
    [anon_sym_struct] = ACTIONS(2318),
    [anon_sym_trait] = ACTIONS(2318),
    [anon_sym_type] = ACTIONS(2318),
    [anon_sym_union] = ACTIONS(2318),
    [anon_sym_unsafe] = ACTIONS(2318),
    [anon_sym_use] = ACTIONS(2318),
    [anon_sym_while] = ACTIONS(2318),
    [anon_sym_extern] = ACTIONS(2318),
    [anon_sym_yield] = ACTIONS(2318),
    [anon_sym_move] = ACTIONS(2318),
    [anon_sym_try] = ACTIONS(2318),
    [sym_integer_literal] = ACTIONS(2316),
    [aux_sym_string_literal_token1] = ACTIONS(2316),
    [sym_char_literal] = ACTIONS(2316),
    [anon_sym_true] = ACTIONS(2318),
    [anon_sym_false] = ACTIONS(2318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2318),
    [sym_super] = ACTIONS(2318),
    [sym_crate] = ACTIONS(2318),
    [sym_metavariable] = ACTIONS(2316),
    [sym__raw_string_literal_start] = ACTIONS(2316),
    [sym_float_literal] = ACTIONS(2316),
  },
  [618] = {
    [sym_line_comment] = STATE(618),
    [sym_block_comment] = STATE(618),
    [ts_builtin_sym_end] = ACTIONS(2320),
    [sym_identifier] = ACTIONS(2322),
    [anon_sym_SEMI] = ACTIONS(2320),
    [anon_sym_macro_rules_BANG] = ACTIONS(2320),
    [anon_sym_LPAREN] = ACTIONS(2320),
    [anon_sym_LBRACK] = ACTIONS(2320),
    [anon_sym_LBRACE] = ACTIONS(2320),
    [anon_sym_RBRACE] = ACTIONS(2320),
    [anon_sym_STAR] = ACTIONS(2320),
    [anon_sym_u8] = ACTIONS(2322),
    [anon_sym_i8] = ACTIONS(2322),
    [anon_sym_u16] = ACTIONS(2322),
    [anon_sym_i16] = ACTIONS(2322),
    [anon_sym_u32] = ACTIONS(2322),
    [anon_sym_i32] = ACTIONS(2322),
    [anon_sym_u64] = ACTIONS(2322),
    [anon_sym_i64] = ACTIONS(2322),
    [anon_sym_u128] = ACTIONS(2322),
    [anon_sym_i128] = ACTIONS(2322),
    [anon_sym_isize] = ACTIONS(2322),
    [anon_sym_usize] = ACTIONS(2322),
    [anon_sym_f32] = ACTIONS(2322),
    [anon_sym_f64] = ACTIONS(2322),
    [anon_sym_bool] = ACTIONS(2322),
    [anon_sym_str] = ACTIONS(2322),
    [anon_sym_char] = ACTIONS(2322),
    [anon_sym_DASH] = ACTIONS(2320),
    [anon_sym_BANG] = ACTIONS(2320),
    [anon_sym_AMP] = ACTIONS(2320),
    [anon_sym_PIPE] = ACTIONS(2320),
    [anon_sym_LT] = ACTIONS(2320),
    [anon_sym_DOT_DOT] = ACTIONS(2320),
    [anon_sym_COLON_COLON] = ACTIONS(2320),
    [anon_sym_POUND] = ACTIONS(2320),
    [anon_sym_SQUOTE] = ACTIONS(2322),
    [anon_sym_async] = ACTIONS(2322),
    [anon_sym_break] = ACTIONS(2322),
    [anon_sym_const] = ACTIONS(2322),
    [anon_sym_continue] = ACTIONS(2322),
    [anon_sym_default] = ACTIONS(2322),
    [anon_sym_enum] = ACTIONS(2322),
    [anon_sym_fn] = ACTIONS(2322),
    [anon_sym_for] = ACTIONS(2322),
    [anon_sym_if] = ACTIONS(2322),
    [anon_sym_impl] = ACTIONS(2322),
    [anon_sym_let] = ACTIONS(2322),
    [anon_sym_loop] = ACTIONS(2322),
    [anon_sym_match] = ACTIONS(2322),
    [anon_sym_mod] = ACTIONS(2322),
    [anon_sym_pub] = ACTIONS(2322),
    [anon_sym_return] = ACTIONS(2322),
    [anon_sym_static] = ACTIONS(2322),
    [anon_sym_struct] = ACTIONS(2322),
    [anon_sym_trait] = ACTIONS(2322),
    [anon_sym_type] = ACTIONS(2322),
    [anon_sym_union] = ACTIONS(2322),
    [anon_sym_unsafe] = ACTIONS(2322),
    [anon_sym_use] = ACTIONS(2322),
    [anon_sym_while] = ACTIONS(2322),
    [anon_sym_extern] = ACTIONS(2322),
    [anon_sym_yield] = ACTIONS(2322),
    [anon_sym_move] = ACTIONS(2322),
    [anon_sym_try] = ACTIONS(2322),
    [sym_integer_literal] = ACTIONS(2320),
    [aux_sym_string_literal_token1] = ACTIONS(2320),
    [sym_char_literal] = ACTIONS(2320),
    [anon_sym_true] = ACTIONS(2322),
    [anon_sym_false] = ACTIONS(2322),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2322),
    [sym_super] = ACTIONS(2322),
    [sym_crate] = ACTIONS(2322),
    [sym_metavariable] = ACTIONS(2320),
    [sym__raw_string_literal_start] = ACTIONS(2320),
    [sym_float_literal] = ACTIONS(2320),
  },
  [619] = {
    [sym_line_comment] = STATE(619),
    [sym_block_comment] = STATE(619),
    [ts_builtin_sym_end] = ACTIONS(2324),
    [sym_identifier] = ACTIONS(2326),
    [anon_sym_SEMI] = ACTIONS(2324),
    [anon_sym_macro_rules_BANG] = ACTIONS(2324),
    [anon_sym_LPAREN] = ACTIONS(2324),
    [anon_sym_LBRACK] = ACTIONS(2324),
    [anon_sym_LBRACE] = ACTIONS(2324),
    [anon_sym_RBRACE] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(2324),
    [anon_sym_u8] = ACTIONS(2326),
    [anon_sym_i8] = ACTIONS(2326),
    [anon_sym_u16] = ACTIONS(2326),
    [anon_sym_i16] = ACTIONS(2326),
    [anon_sym_u32] = ACTIONS(2326),
    [anon_sym_i32] = ACTIONS(2326),
    [anon_sym_u64] = ACTIONS(2326),
    [anon_sym_i64] = ACTIONS(2326),
    [anon_sym_u128] = ACTIONS(2326),
    [anon_sym_i128] = ACTIONS(2326),
    [anon_sym_isize] = ACTIONS(2326),
    [anon_sym_usize] = ACTIONS(2326),
    [anon_sym_f32] = ACTIONS(2326),
    [anon_sym_f64] = ACTIONS(2326),
    [anon_sym_bool] = ACTIONS(2326),
    [anon_sym_str] = ACTIONS(2326),
    [anon_sym_char] = ACTIONS(2326),
    [anon_sym_DASH] = ACTIONS(2324),
    [anon_sym_BANG] = ACTIONS(2324),
    [anon_sym_AMP] = ACTIONS(2324),
    [anon_sym_PIPE] = ACTIONS(2324),
    [anon_sym_LT] = ACTIONS(2324),
    [anon_sym_DOT_DOT] = ACTIONS(2324),
    [anon_sym_COLON_COLON] = ACTIONS(2324),
    [anon_sym_POUND] = ACTIONS(2324),
    [anon_sym_SQUOTE] = ACTIONS(2326),
    [anon_sym_async] = ACTIONS(2326),
    [anon_sym_break] = ACTIONS(2326),
    [anon_sym_const] = ACTIONS(2326),
    [anon_sym_continue] = ACTIONS(2326),
    [anon_sym_default] = ACTIONS(2326),
    [anon_sym_enum] = ACTIONS(2326),
    [anon_sym_fn] = ACTIONS(2326),
    [anon_sym_for] = ACTIONS(2326),
    [anon_sym_if] = ACTIONS(2326),
    [anon_sym_impl] = ACTIONS(2326),
    [anon_sym_let] = ACTIONS(2326),
    [anon_sym_loop] = ACTIONS(2326),
    [anon_sym_match] = ACTIONS(2326),
    [anon_sym_mod] = ACTIONS(2326),
    [anon_sym_pub] = ACTIONS(2326),
    [anon_sym_return] = ACTIONS(2326),
    [anon_sym_static] = ACTIONS(2326),
    [anon_sym_struct] = ACTIONS(2326),
    [anon_sym_trait] = ACTIONS(2326),
    [anon_sym_type] = ACTIONS(2326),
    [anon_sym_union] = ACTIONS(2326),
    [anon_sym_unsafe] = ACTIONS(2326),
    [anon_sym_use] = ACTIONS(2326),
    [anon_sym_while] = ACTIONS(2326),
    [anon_sym_extern] = ACTIONS(2326),
    [anon_sym_yield] = ACTIONS(2326),
    [anon_sym_move] = ACTIONS(2326),
    [anon_sym_try] = ACTIONS(2326),
    [sym_integer_literal] = ACTIONS(2324),
    [aux_sym_string_literal_token1] = ACTIONS(2324),
    [sym_char_literal] = ACTIONS(2324),
    [anon_sym_true] = ACTIONS(2326),
    [anon_sym_false] = ACTIONS(2326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2326),
    [sym_super] = ACTIONS(2326),
    [sym_crate] = ACTIONS(2326),
    [sym_metavariable] = ACTIONS(2324),
    [sym__raw_string_literal_start] = ACTIONS(2324),
    [sym_float_literal] = ACTIONS(2324),
  },
  [620] = {
    [sym_line_comment] = STATE(620),
    [sym_block_comment] = STATE(620),
    [ts_builtin_sym_end] = ACTIONS(2328),
    [sym_identifier] = ACTIONS(2330),
    [anon_sym_SEMI] = ACTIONS(2328),
    [anon_sym_macro_rules_BANG] = ACTIONS(2328),
    [anon_sym_LPAREN] = ACTIONS(2328),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_LBRACE] = ACTIONS(2328),
    [anon_sym_RBRACE] = ACTIONS(2328),
    [anon_sym_STAR] = ACTIONS(2328),
    [anon_sym_u8] = ACTIONS(2330),
    [anon_sym_i8] = ACTIONS(2330),
    [anon_sym_u16] = ACTIONS(2330),
    [anon_sym_i16] = ACTIONS(2330),
    [anon_sym_u32] = ACTIONS(2330),
    [anon_sym_i32] = ACTIONS(2330),
    [anon_sym_u64] = ACTIONS(2330),
    [anon_sym_i64] = ACTIONS(2330),
    [anon_sym_u128] = ACTIONS(2330),
    [anon_sym_i128] = ACTIONS(2330),
    [anon_sym_isize] = ACTIONS(2330),
    [anon_sym_usize] = ACTIONS(2330),
    [anon_sym_f32] = ACTIONS(2330),
    [anon_sym_f64] = ACTIONS(2330),
    [anon_sym_bool] = ACTIONS(2330),
    [anon_sym_str] = ACTIONS(2330),
    [anon_sym_char] = ACTIONS(2330),
    [anon_sym_DASH] = ACTIONS(2328),
    [anon_sym_BANG] = ACTIONS(2328),
    [anon_sym_AMP] = ACTIONS(2328),
    [anon_sym_PIPE] = ACTIONS(2328),
    [anon_sym_LT] = ACTIONS(2328),
    [anon_sym_DOT_DOT] = ACTIONS(2328),
    [anon_sym_COLON_COLON] = ACTIONS(2328),
    [anon_sym_POUND] = ACTIONS(2328),
    [anon_sym_SQUOTE] = ACTIONS(2330),
    [anon_sym_async] = ACTIONS(2330),
    [anon_sym_break] = ACTIONS(2330),
    [anon_sym_const] = ACTIONS(2330),
    [anon_sym_continue] = ACTIONS(2330),
    [anon_sym_default] = ACTIONS(2330),
    [anon_sym_enum] = ACTIONS(2330),
    [anon_sym_fn] = ACTIONS(2330),
    [anon_sym_for] = ACTIONS(2330),
    [anon_sym_if] = ACTIONS(2330),
    [anon_sym_impl] = ACTIONS(2330),
    [anon_sym_let] = ACTIONS(2330),
    [anon_sym_loop] = ACTIONS(2330),
    [anon_sym_match] = ACTIONS(2330),
    [anon_sym_mod] = ACTIONS(2330),
    [anon_sym_pub] = ACTIONS(2330),
    [anon_sym_return] = ACTIONS(2330),
    [anon_sym_static] = ACTIONS(2330),
    [anon_sym_struct] = ACTIONS(2330),
    [anon_sym_trait] = ACTIONS(2330),
    [anon_sym_type] = ACTIONS(2330),
    [anon_sym_union] = ACTIONS(2330),
    [anon_sym_unsafe] = ACTIONS(2330),
    [anon_sym_use] = ACTIONS(2330),
    [anon_sym_while] = ACTIONS(2330),
    [anon_sym_extern] = ACTIONS(2330),
    [anon_sym_yield] = ACTIONS(2330),
    [anon_sym_move] = ACTIONS(2330),
    [anon_sym_try] = ACTIONS(2330),
    [sym_integer_literal] = ACTIONS(2328),
    [aux_sym_string_literal_token1] = ACTIONS(2328),
    [sym_char_literal] = ACTIONS(2328),
    [anon_sym_true] = ACTIONS(2330),
    [anon_sym_false] = ACTIONS(2330),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2330),
    [sym_super] = ACTIONS(2330),
    [sym_crate] = ACTIONS(2330),
    [sym_metavariable] = ACTIONS(2328),
    [sym__raw_string_literal_start] = ACTIONS(2328),
    [sym_float_literal] = ACTIONS(2328),
  },
  [621] = {
    [sym_line_comment] = STATE(621),
    [sym_block_comment] = STATE(621),
    [ts_builtin_sym_end] = ACTIONS(2332),
    [sym_identifier] = ACTIONS(2334),
    [anon_sym_SEMI] = ACTIONS(2332),
    [anon_sym_macro_rules_BANG] = ACTIONS(2332),
    [anon_sym_LPAREN] = ACTIONS(2332),
    [anon_sym_LBRACK] = ACTIONS(2332),
    [anon_sym_LBRACE] = ACTIONS(2332),
    [anon_sym_RBRACE] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2332),
    [anon_sym_u8] = ACTIONS(2334),
    [anon_sym_i8] = ACTIONS(2334),
    [anon_sym_u16] = ACTIONS(2334),
    [anon_sym_i16] = ACTIONS(2334),
    [anon_sym_u32] = ACTIONS(2334),
    [anon_sym_i32] = ACTIONS(2334),
    [anon_sym_u64] = ACTIONS(2334),
    [anon_sym_i64] = ACTIONS(2334),
    [anon_sym_u128] = ACTIONS(2334),
    [anon_sym_i128] = ACTIONS(2334),
    [anon_sym_isize] = ACTIONS(2334),
    [anon_sym_usize] = ACTIONS(2334),
    [anon_sym_f32] = ACTIONS(2334),
    [anon_sym_f64] = ACTIONS(2334),
    [anon_sym_bool] = ACTIONS(2334),
    [anon_sym_str] = ACTIONS(2334),
    [anon_sym_char] = ACTIONS(2334),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2332),
    [anon_sym_AMP] = ACTIONS(2332),
    [anon_sym_PIPE] = ACTIONS(2332),
    [anon_sym_LT] = ACTIONS(2332),
    [anon_sym_DOT_DOT] = ACTIONS(2332),
    [anon_sym_COLON_COLON] = ACTIONS(2332),
    [anon_sym_POUND] = ACTIONS(2332),
    [anon_sym_SQUOTE] = ACTIONS(2334),
    [anon_sym_async] = ACTIONS(2334),
    [anon_sym_break] = ACTIONS(2334),
    [anon_sym_const] = ACTIONS(2334),
    [anon_sym_continue] = ACTIONS(2334),
    [anon_sym_default] = ACTIONS(2334),
    [anon_sym_enum] = ACTIONS(2334),
    [anon_sym_fn] = ACTIONS(2334),
    [anon_sym_for] = ACTIONS(2334),
    [anon_sym_if] = ACTIONS(2334),
    [anon_sym_impl] = ACTIONS(2334),
    [anon_sym_let] = ACTIONS(2334),
    [anon_sym_loop] = ACTIONS(2334),
    [anon_sym_match] = ACTIONS(2334),
    [anon_sym_mod] = ACTIONS(2334),
    [anon_sym_pub] = ACTIONS(2334),
    [anon_sym_return] = ACTIONS(2334),
    [anon_sym_static] = ACTIONS(2334),
    [anon_sym_struct] = ACTIONS(2334),
    [anon_sym_trait] = ACTIONS(2334),
    [anon_sym_type] = ACTIONS(2334),
    [anon_sym_union] = ACTIONS(2334),
    [anon_sym_unsafe] = ACTIONS(2334),
    [anon_sym_use] = ACTIONS(2334),
    [anon_sym_while] = ACTIONS(2334),
    [anon_sym_extern] = ACTIONS(2334),
    [anon_sym_yield] = ACTIONS(2334),
    [anon_sym_move] = ACTIONS(2334),
    [anon_sym_try] = ACTIONS(2334),
    [sym_integer_literal] = ACTIONS(2332),
    [aux_sym_string_literal_token1] = ACTIONS(2332),
    [sym_char_literal] = ACTIONS(2332),
    [anon_sym_true] = ACTIONS(2334),
    [anon_sym_false] = ACTIONS(2334),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2334),
    [sym_super] = ACTIONS(2334),
    [sym_crate] = ACTIONS(2334),
    [sym_metavariable] = ACTIONS(2332),
    [sym__raw_string_literal_start] = ACTIONS(2332),
    [sym_float_literal] = ACTIONS(2332),
  },
  [622] = {
    [sym_line_comment] = STATE(622),
    [sym_block_comment] = STATE(622),
    [ts_builtin_sym_end] = ACTIONS(2336),
    [sym_identifier] = ACTIONS(2338),
    [anon_sym_SEMI] = ACTIONS(2336),
    [anon_sym_macro_rules_BANG] = ACTIONS(2336),
    [anon_sym_LPAREN] = ACTIONS(2336),
    [anon_sym_LBRACK] = ACTIONS(2336),
    [anon_sym_LBRACE] = ACTIONS(2336),
    [anon_sym_RBRACE] = ACTIONS(2336),
    [anon_sym_STAR] = ACTIONS(2336),
    [anon_sym_u8] = ACTIONS(2338),
    [anon_sym_i8] = ACTIONS(2338),
    [anon_sym_u16] = ACTIONS(2338),
    [anon_sym_i16] = ACTIONS(2338),
    [anon_sym_u32] = ACTIONS(2338),
    [anon_sym_i32] = ACTIONS(2338),
    [anon_sym_u64] = ACTIONS(2338),
    [anon_sym_i64] = ACTIONS(2338),
    [anon_sym_u128] = ACTIONS(2338),
    [anon_sym_i128] = ACTIONS(2338),
    [anon_sym_isize] = ACTIONS(2338),
    [anon_sym_usize] = ACTIONS(2338),
    [anon_sym_f32] = ACTIONS(2338),
    [anon_sym_f64] = ACTIONS(2338),
    [anon_sym_bool] = ACTIONS(2338),
    [anon_sym_str] = ACTIONS(2338),
    [anon_sym_char] = ACTIONS(2338),
    [anon_sym_DASH] = ACTIONS(2336),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_AMP] = ACTIONS(2336),
    [anon_sym_PIPE] = ACTIONS(2336),
    [anon_sym_LT] = ACTIONS(2336),
    [anon_sym_DOT_DOT] = ACTIONS(2336),
    [anon_sym_COLON_COLON] = ACTIONS(2336),
    [anon_sym_POUND] = ACTIONS(2336),
    [anon_sym_SQUOTE] = ACTIONS(2338),
    [anon_sym_async] = ACTIONS(2338),
    [anon_sym_break] = ACTIONS(2338),
    [anon_sym_const] = ACTIONS(2338),
    [anon_sym_continue] = ACTIONS(2338),
    [anon_sym_default] = ACTIONS(2338),
    [anon_sym_enum] = ACTIONS(2338),
    [anon_sym_fn] = ACTIONS(2338),
    [anon_sym_for] = ACTIONS(2338),
    [anon_sym_if] = ACTIONS(2338),
    [anon_sym_impl] = ACTIONS(2338),
    [anon_sym_let] = ACTIONS(2338),
    [anon_sym_loop] = ACTIONS(2338),
    [anon_sym_match] = ACTIONS(2338),
    [anon_sym_mod] = ACTIONS(2338),
    [anon_sym_pub] = ACTIONS(2338),
    [anon_sym_return] = ACTIONS(2338),
    [anon_sym_static] = ACTIONS(2338),
    [anon_sym_struct] = ACTIONS(2338),
    [anon_sym_trait] = ACTIONS(2338),
    [anon_sym_type] = ACTIONS(2338),
    [anon_sym_union] = ACTIONS(2338),
    [anon_sym_unsafe] = ACTIONS(2338),
    [anon_sym_use] = ACTIONS(2338),
    [anon_sym_while] = ACTIONS(2338),
    [anon_sym_extern] = ACTIONS(2338),
    [anon_sym_yield] = ACTIONS(2338),
    [anon_sym_move] = ACTIONS(2338),
    [anon_sym_try] = ACTIONS(2338),
    [sym_integer_literal] = ACTIONS(2336),
    [aux_sym_string_literal_token1] = ACTIONS(2336),
    [sym_char_literal] = ACTIONS(2336),
    [anon_sym_true] = ACTIONS(2338),
    [anon_sym_false] = ACTIONS(2338),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2338),
    [sym_super] = ACTIONS(2338),
    [sym_crate] = ACTIONS(2338),
    [sym_metavariable] = ACTIONS(2336),
    [sym__raw_string_literal_start] = ACTIONS(2336),
    [sym_float_literal] = ACTIONS(2336),
  },
  [623] = {
    [sym_line_comment] = STATE(623),
    [sym_block_comment] = STATE(623),
    [ts_builtin_sym_end] = ACTIONS(2340),
    [sym_identifier] = ACTIONS(2342),
    [anon_sym_SEMI] = ACTIONS(2340),
    [anon_sym_macro_rules_BANG] = ACTIONS(2340),
    [anon_sym_LPAREN] = ACTIONS(2340),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2340),
    [anon_sym_RBRACE] = ACTIONS(2340),
    [anon_sym_STAR] = ACTIONS(2340),
    [anon_sym_u8] = ACTIONS(2342),
    [anon_sym_i8] = ACTIONS(2342),
    [anon_sym_u16] = ACTIONS(2342),
    [anon_sym_i16] = ACTIONS(2342),
    [anon_sym_u32] = ACTIONS(2342),
    [anon_sym_i32] = ACTIONS(2342),
    [anon_sym_u64] = ACTIONS(2342),
    [anon_sym_i64] = ACTIONS(2342),
    [anon_sym_u128] = ACTIONS(2342),
    [anon_sym_i128] = ACTIONS(2342),
    [anon_sym_isize] = ACTIONS(2342),
    [anon_sym_usize] = ACTIONS(2342),
    [anon_sym_f32] = ACTIONS(2342),
    [anon_sym_f64] = ACTIONS(2342),
    [anon_sym_bool] = ACTIONS(2342),
    [anon_sym_str] = ACTIONS(2342),
    [anon_sym_char] = ACTIONS(2342),
    [anon_sym_DASH] = ACTIONS(2340),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_AMP] = ACTIONS(2340),
    [anon_sym_PIPE] = ACTIONS(2340),
    [anon_sym_LT] = ACTIONS(2340),
    [anon_sym_DOT_DOT] = ACTIONS(2340),
    [anon_sym_COLON_COLON] = ACTIONS(2340),
    [anon_sym_POUND] = ACTIONS(2340),
    [anon_sym_SQUOTE] = ACTIONS(2342),
    [anon_sym_async] = ACTIONS(2342),
    [anon_sym_break] = ACTIONS(2342),
    [anon_sym_const] = ACTIONS(2342),
    [anon_sym_continue] = ACTIONS(2342),
    [anon_sym_default] = ACTIONS(2342),
    [anon_sym_enum] = ACTIONS(2342),
    [anon_sym_fn] = ACTIONS(2342),
    [anon_sym_for] = ACTIONS(2342),
    [anon_sym_if] = ACTIONS(2342),
    [anon_sym_impl] = ACTIONS(2342),
    [anon_sym_let] = ACTIONS(2342),
    [anon_sym_loop] = ACTIONS(2342),
    [anon_sym_match] = ACTIONS(2342),
    [anon_sym_mod] = ACTIONS(2342),
    [anon_sym_pub] = ACTIONS(2342),
    [anon_sym_return] = ACTIONS(2342),
    [anon_sym_static] = ACTIONS(2342),
    [anon_sym_struct] = ACTIONS(2342),
    [anon_sym_trait] = ACTIONS(2342),
    [anon_sym_type] = ACTIONS(2342),
    [anon_sym_union] = ACTIONS(2342),
    [anon_sym_unsafe] = ACTIONS(2342),
    [anon_sym_use] = ACTIONS(2342),
    [anon_sym_while] = ACTIONS(2342),
    [anon_sym_extern] = ACTIONS(2342),
    [anon_sym_yield] = ACTIONS(2342),
    [anon_sym_move] = ACTIONS(2342),
    [anon_sym_try] = ACTIONS(2342),
    [sym_integer_literal] = ACTIONS(2340),
    [aux_sym_string_literal_token1] = ACTIONS(2340),
    [sym_char_literal] = ACTIONS(2340),
    [anon_sym_true] = ACTIONS(2342),
    [anon_sym_false] = ACTIONS(2342),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2342),
    [sym_super] = ACTIONS(2342),
    [sym_crate] = ACTIONS(2342),
    [sym_metavariable] = ACTIONS(2340),
    [sym__raw_string_literal_start] = ACTIONS(2340),
    [sym_float_literal] = ACTIONS(2340),
  },
  [624] = {
    [sym_line_comment] = STATE(624),
    [sym_block_comment] = STATE(624),
    [ts_builtin_sym_end] = ACTIONS(2344),
    [sym_identifier] = ACTIONS(2346),
    [anon_sym_SEMI] = ACTIONS(2344),
    [anon_sym_macro_rules_BANG] = ACTIONS(2344),
    [anon_sym_LPAREN] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(2344),
    [anon_sym_LBRACE] = ACTIONS(2344),
    [anon_sym_RBRACE] = ACTIONS(2344),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_u8] = ACTIONS(2346),
    [anon_sym_i8] = ACTIONS(2346),
    [anon_sym_u16] = ACTIONS(2346),
    [anon_sym_i16] = ACTIONS(2346),
    [anon_sym_u32] = ACTIONS(2346),
    [anon_sym_i32] = ACTIONS(2346),
    [anon_sym_u64] = ACTIONS(2346),
    [anon_sym_i64] = ACTIONS(2346),
    [anon_sym_u128] = ACTIONS(2346),
    [anon_sym_i128] = ACTIONS(2346),
    [anon_sym_isize] = ACTIONS(2346),
    [anon_sym_usize] = ACTIONS(2346),
    [anon_sym_f32] = ACTIONS(2346),
    [anon_sym_f64] = ACTIONS(2346),
    [anon_sym_bool] = ACTIONS(2346),
    [anon_sym_str] = ACTIONS(2346),
    [anon_sym_char] = ACTIONS(2346),
    [anon_sym_DASH] = ACTIONS(2344),
    [anon_sym_BANG] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2344),
    [anon_sym_DOT_DOT] = ACTIONS(2344),
    [anon_sym_COLON_COLON] = ACTIONS(2344),
    [anon_sym_POUND] = ACTIONS(2344),
    [anon_sym_SQUOTE] = ACTIONS(2346),
    [anon_sym_async] = ACTIONS(2346),
    [anon_sym_break] = ACTIONS(2346),
    [anon_sym_const] = ACTIONS(2346),
    [anon_sym_continue] = ACTIONS(2346),
    [anon_sym_default] = ACTIONS(2346),
    [anon_sym_enum] = ACTIONS(2346),
    [anon_sym_fn] = ACTIONS(2346),
    [anon_sym_for] = ACTIONS(2346),
    [anon_sym_if] = ACTIONS(2346),
    [anon_sym_impl] = ACTIONS(2346),
    [anon_sym_let] = ACTIONS(2346),
    [anon_sym_loop] = ACTIONS(2346),
    [anon_sym_match] = ACTIONS(2346),
    [anon_sym_mod] = ACTIONS(2346),
    [anon_sym_pub] = ACTIONS(2346),
    [anon_sym_return] = ACTIONS(2346),
    [anon_sym_static] = ACTIONS(2346),
    [anon_sym_struct] = ACTIONS(2346),
    [anon_sym_trait] = ACTIONS(2346),
    [anon_sym_type] = ACTIONS(2346),
    [anon_sym_union] = ACTIONS(2346),
    [anon_sym_unsafe] = ACTIONS(2346),
    [anon_sym_use] = ACTIONS(2346),
    [anon_sym_while] = ACTIONS(2346),
    [anon_sym_extern] = ACTIONS(2346),
    [anon_sym_yield] = ACTIONS(2346),
    [anon_sym_move] = ACTIONS(2346),
    [anon_sym_try] = ACTIONS(2346),
    [sym_integer_literal] = ACTIONS(2344),
    [aux_sym_string_literal_token1] = ACTIONS(2344),
    [sym_char_literal] = ACTIONS(2344),
    [anon_sym_true] = ACTIONS(2346),
    [anon_sym_false] = ACTIONS(2346),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2346),
    [sym_super] = ACTIONS(2346),
    [sym_crate] = ACTIONS(2346),
    [sym_metavariable] = ACTIONS(2344),
    [sym__raw_string_literal_start] = ACTIONS(2344),
    [sym_float_literal] = ACTIONS(2344),
  },
  [625] = {
    [sym_line_comment] = STATE(625),
    [sym_block_comment] = STATE(625),
    [ts_builtin_sym_end] = ACTIONS(2348),
    [sym_identifier] = ACTIONS(2350),
    [anon_sym_SEMI] = ACTIONS(2348),
    [anon_sym_macro_rules_BANG] = ACTIONS(2348),
    [anon_sym_LPAREN] = ACTIONS(2348),
    [anon_sym_LBRACK] = ACTIONS(2348),
    [anon_sym_LBRACE] = ACTIONS(2348),
    [anon_sym_RBRACE] = ACTIONS(2348),
    [anon_sym_STAR] = ACTIONS(2348),
    [anon_sym_u8] = ACTIONS(2350),
    [anon_sym_i8] = ACTIONS(2350),
    [anon_sym_u16] = ACTIONS(2350),
    [anon_sym_i16] = ACTIONS(2350),
    [anon_sym_u32] = ACTIONS(2350),
    [anon_sym_i32] = ACTIONS(2350),
    [anon_sym_u64] = ACTIONS(2350),
    [anon_sym_i64] = ACTIONS(2350),
    [anon_sym_u128] = ACTIONS(2350),
    [anon_sym_i128] = ACTIONS(2350),
    [anon_sym_isize] = ACTIONS(2350),
    [anon_sym_usize] = ACTIONS(2350),
    [anon_sym_f32] = ACTIONS(2350),
    [anon_sym_f64] = ACTIONS(2350),
    [anon_sym_bool] = ACTIONS(2350),
    [anon_sym_str] = ACTIONS(2350),
    [anon_sym_char] = ACTIONS(2350),
    [anon_sym_DASH] = ACTIONS(2348),
    [anon_sym_BANG] = ACTIONS(2348),
    [anon_sym_AMP] = ACTIONS(2348),
    [anon_sym_PIPE] = ACTIONS(2348),
    [anon_sym_LT] = ACTIONS(2348),
    [anon_sym_DOT_DOT] = ACTIONS(2348),
    [anon_sym_COLON_COLON] = ACTIONS(2348),
    [anon_sym_POUND] = ACTIONS(2348),
    [anon_sym_SQUOTE] = ACTIONS(2350),
    [anon_sym_async] = ACTIONS(2350),
    [anon_sym_break] = ACTIONS(2350),
    [anon_sym_const] = ACTIONS(2350),
    [anon_sym_continue] = ACTIONS(2350),
    [anon_sym_default] = ACTIONS(2350),
    [anon_sym_enum] = ACTIONS(2350),
    [anon_sym_fn] = ACTIONS(2350),
    [anon_sym_for] = ACTIONS(2350),
    [anon_sym_if] = ACTIONS(2350),
    [anon_sym_impl] = ACTIONS(2350),
    [anon_sym_let] = ACTIONS(2350),
    [anon_sym_loop] = ACTIONS(2350),
    [anon_sym_match] = ACTIONS(2350),
    [anon_sym_mod] = ACTIONS(2350),
    [anon_sym_pub] = ACTIONS(2350),
    [anon_sym_return] = ACTIONS(2350),
    [anon_sym_static] = ACTIONS(2350),
    [anon_sym_struct] = ACTIONS(2350),
    [anon_sym_trait] = ACTIONS(2350),
    [anon_sym_type] = ACTIONS(2350),
    [anon_sym_union] = ACTIONS(2350),
    [anon_sym_unsafe] = ACTIONS(2350),
    [anon_sym_use] = ACTIONS(2350),
    [anon_sym_while] = ACTIONS(2350),
    [anon_sym_extern] = ACTIONS(2350),
    [anon_sym_yield] = ACTIONS(2350),
    [anon_sym_move] = ACTIONS(2350),
    [anon_sym_try] = ACTIONS(2350),
    [sym_integer_literal] = ACTIONS(2348),
    [aux_sym_string_literal_token1] = ACTIONS(2348),
    [sym_char_literal] = ACTIONS(2348),
    [anon_sym_true] = ACTIONS(2350),
    [anon_sym_false] = ACTIONS(2350),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2350),
    [sym_super] = ACTIONS(2350),
    [sym_crate] = ACTIONS(2350),
    [sym_metavariable] = ACTIONS(2348),
    [sym__raw_string_literal_start] = ACTIONS(2348),
    [sym_float_literal] = ACTIONS(2348),
  },
  [626] = {
    [sym_line_comment] = STATE(626),
    [sym_block_comment] = STATE(626),
    [ts_builtin_sym_end] = ACTIONS(2352),
    [sym_identifier] = ACTIONS(2354),
    [anon_sym_SEMI] = ACTIONS(2352),
    [anon_sym_macro_rules_BANG] = ACTIONS(2352),
    [anon_sym_LPAREN] = ACTIONS(2352),
    [anon_sym_LBRACK] = ACTIONS(2352),
    [anon_sym_LBRACE] = ACTIONS(2352),
    [anon_sym_RBRACE] = ACTIONS(2352),
    [anon_sym_STAR] = ACTIONS(2352),
    [anon_sym_u8] = ACTIONS(2354),
    [anon_sym_i8] = ACTIONS(2354),
    [anon_sym_u16] = ACTIONS(2354),
    [anon_sym_i16] = ACTIONS(2354),
    [anon_sym_u32] = ACTIONS(2354),
    [anon_sym_i32] = ACTIONS(2354),
    [anon_sym_u64] = ACTIONS(2354),
    [anon_sym_i64] = ACTIONS(2354),
    [anon_sym_u128] = ACTIONS(2354),
    [anon_sym_i128] = ACTIONS(2354),
    [anon_sym_isize] = ACTIONS(2354),
    [anon_sym_usize] = ACTIONS(2354),
    [anon_sym_f32] = ACTIONS(2354),
    [anon_sym_f64] = ACTIONS(2354),
    [anon_sym_bool] = ACTIONS(2354),
    [anon_sym_str] = ACTIONS(2354),
    [anon_sym_char] = ACTIONS(2354),
    [anon_sym_DASH] = ACTIONS(2352),
    [anon_sym_BANG] = ACTIONS(2352),
    [anon_sym_AMP] = ACTIONS(2352),
    [anon_sym_PIPE] = ACTIONS(2352),
    [anon_sym_LT] = ACTIONS(2352),
    [anon_sym_DOT_DOT] = ACTIONS(2352),
    [anon_sym_COLON_COLON] = ACTIONS(2352),
    [anon_sym_POUND] = ACTIONS(2352),
    [anon_sym_SQUOTE] = ACTIONS(2354),
    [anon_sym_async] = ACTIONS(2354),
    [anon_sym_break] = ACTIONS(2354),
    [anon_sym_const] = ACTIONS(2354),
    [anon_sym_continue] = ACTIONS(2354),
    [anon_sym_default] = ACTIONS(2354),
    [anon_sym_enum] = ACTIONS(2354),
    [anon_sym_fn] = ACTIONS(2354),
    [anon_sym_for] = ACTIONS(2354),
    [anon_sym_if] = ACTIONS(2354),
    [anon_sym_impl] = ACTIONS(2354),
    [anon_sym_let] = ACTIONS(2354),
    [anon_sym_loop] = ACTIONS(2354),
    [anon_sym_match] = ACTIONS(2354),
    [anon_sym_mod] = ACTIONS(2354),
    [anon_sym_pub] = ACTIONS(2354),
    [anon_sym_return] = ACTIONS(2354),
    [anon_sym_static] = ACTIONS(2354),
    [anon_sym_struct] = ACTIONS(2354),
    [anon_sym_trait] = ACTIONS(2354),
    [anon_sym_type] = ACTIONS(2354),
    [anon_sym_union] = ACTIONS(2354),
    [anon_sym_unsafe] = ACTIONS(2354),
    [anon_sym_use] = ACTIONS(2354),
    [anon_sym_while] = ACTIONS(2354),
    [anon_sym_extern] = ACTIONS(2354),
    [anon_sym_yield] = ACTIONS(2354),
    [anon_sym_move] = ACTIONS(2354),
    [anon_sym_try] = ACTIONS(2354),
    [sym_integer_literal] = ACTIONS(2352),
    [aux_sym_string_literal_token1] = ACTIONS(2352),
    [sym_char_literal] = ACTIONS(2352),
    [anon_sym_true] = ACTIONS(2354),
    [anon_sym_false] = ACTIONS(2354),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2354),
    [sym_super] = ACTIONS(2354),
    [sym_crate] = ACTIONS(2354),
    [sym_metavariable] = ACTIONS(2352),
    [sym__raw_string_literal_start] = ACTIONS(2352),
    [sym_float_literal] = ACTIONS(2352),
  },
  [627] = {
    [sym_line_comment] = STATE(627),
    [sym_block_comment] = STATE(627),
    [ts_builtin_sym_end] = ACTIONS(2356),
    [sym_identifier] = ACTIONS(2358),
    [anon_sym_SEMI] = ACTIONS(2356),
    [anon_sym_macro_rules_BANG] = ACTIONS(2356),
    [anon_sym_LPAREN] = ACTIONS(2356),
    [anon_sym_LBRACK] = ACTIONS(2356),
    [anon_sym_LBRACE] = ACTIONS(2356),
    [anon_sym_RBRACE] = ACTIONS(2356),
    [anon_sym_STAR] = ACTIONS(2356),
    [anon_sym_u8] = ACTIONS(2358),
    [anon_sym_i8] = ACTIONS(2358),
    [anon_sym_u16] = ACTIONS(2358),
    [anon_sym_i16] = ACTIONS(2358),
    [anon_sym_u32] = ACTIONS(2358),
    [anon_sym_i32] = ACTIONS(2358),
    [anon_sym_u64] = ACTIONS(2358),
    [anon_sym_i64] = ACTIONS(2358),
    [anon_sym_u128] = ACTIONS(2358),
    [anon_sym_i128] = ACTIONS(2358),
    [anon_sym_isize] = ACTIONS(2358),
    [anon_sym_usize] = ACTIONS(2358),
    [anon_sym_f32] = ACTIONS(2358),
    [anon_sym_f64] = ACTIONS(2358),
    [anon_sym_bool] = ACTIONS(2358),
    [anon_sym_str] = ACTIONS(2358),
    [anon_sym_char] = ACTIONS(2358),
    [anon_sym_DASH] = ACTIONS(2356),
    [anon_sym_BANG] = ACTIONS(2356),
    [anon_sym_AMP] = ACTIONS(2356),
    [anon_sym_PIPE] = ACTIONS(2356),
    [anon_sym_LT] = ACTIONS(2356),
    [anon_sym_DOT_DOT] = ACTIONS(2356),
    [anon_sym_COLON_COLON] = ACTIONS(2356),
    [anon_sym_POUND] = ACTIONS(2356),
    [anon_sym_SQUOTE] = ACTIONS(2358),
    [anon_sym_async] = ACTIONS(2358),
    [anon_sym_break] = ACTIONS(2358),
    [anon_sym_const] = ACTIONS(2358),
    [anon_sym_continue] = ACTIONS(2358),
    [anon_sym_default] = ACTIONS(2358),
    [anon_sym_enum] = ACTIONS(2358),
    [anon_sym_fn] = ACTIONS(2358),
    [anon_sym_for] = ACTIONS(2358),
    [anon_sym_if] = ACTIONS(2358),
    [anon_sym_impl] = ACTIONS(2358),
    [anon_sym_let] = ACTIONS(2358),
    [anon_sym_loop] = ACTIONS(2358),
    [anon_sym_match] = ACTIONS(2358),
    [anon_sym_mod] = ACTIONS(2358),
    [anon_sym_pub] = ACTIONS(2358),
    [anon_sym_return] = ACTIONS(2358),
    [anon_sym_static] = ACTIONS(2358),
    [anon_sym_struct] = ACTIONS(2358),
    [anon_sym_trait] = ACTIONS(2358),
    [anon_sym_type] = ACTIONS(2358),
    [anon_sym_union] = ACTIONS(2358),
    [anon_sym_unsafe] = ACTIONS(2358),
    [anon_sym_use] = ACTIONS(2358),
    [anon_sym_while] = ACTIONS(2358),
    [anon_sym_extern] = ACTIONS(2358),
    [anon_sym_yield] = ACTIONS(2358),
    [anon_sym_move] = ACTIONS(2358),
    [anon_sym_try] = ACTIONS(2358),
    [sym_integer_literal] = ACTIONS(2356),
    [aux_sym_string_literal_token1] = ACTIONS(2356),
    [sym_char_literal] = ACTIONS(2356),
    [anon_sym_true] = ACTIONS(2358),
    [anon_sym_false] = ACTIONS(2358),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2358),
    [sym_super] = ACTIONS(2358),
    [sym_crate] = ACTIONS(2358),
    [sym_metavariable] = ACTIONS(2356),
    [sym__raw_string_literal_start] = ACTIONS(2356),
    [sym_float_literal] = ACTIONS(2356),
  },
  [628] = {
    [sym_line_comment] = STATE(628),
    [sym_block_comment] = STATE(628),
    [ts_builtin_sym_end] = ACTIONS(2360),
    [sym_identifier] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2360),
    [anon_sym_macro_rules_BANG] = ACTIONS(2360),
    [anon_sym_LPAREN] = ACTIONS(2360),
    [anon_sym_LBRACK] = ACTIONS(2360),
    [anon_sym_LBRACE] = ACTIONS(2360),
    [anon_sym_RBRACE] = ACTIONS(2360),
    [anon_sym_STAR] = ACTIONS(2360),
    [anon_sym_u8] = ACTIONS(2362),
    [anon_sym_i8] = ACTIONS(2362),
    [anon_sym_u16] = ACTIONS(2362),
    [anon_sym_i16] = ACTIONS(2362),
    [anon_sym_u32] = ACTIONS(2362),
    [anon_sym_i32] = ACTIONS(2362),
    [anon_sym_u64] = ACTIONS(2362),
    [anon_sym_i64] = ACTIONS(2362),
    [anon_sym_u128] = ACTIONS(2362),
    [anon_sym_i128] = ACTIONS(2362),
    [anon_sym_isize] = ACTIONS(2362),
    [anon_sym_usize] = ACTIONS(2362),
    [anon_sym_f32] = ACTIONS(2362),
    [anon_sym_f64] = ACTIONS(2362),
    [anon_sym_bool] = ACTIONS(2362),
    [anon_sym_str] = ACTIONS(2362),
    [anon_sym_char] = ACTIONS(2362),
    [anon_sym_DASH] = ACTIONS(2360),
    [anon_sym_BANG] = ACTIONS(2360),
    [anon_sym_AMP] = ACTIONS(2360),
    [anon_sym_PIPE] = ACTIONS(2360),
    [anon_sym_LT] = ACTIONS(2360),
    [anon_sym_DOT_DOT] = ACTIONS(2360),
    [anon_sym_COLON_COLON] = ACTIONS(2360),
    [anon_sym_POUND] = ACTIONS(2360),
    [anon_sym_SQUOTE] = ACTIONS(2362),
    [anon_sym_async] = ACTIONS(2362),
    [anon_sym_break] = ACTIONS(2362),
    [anon_sym_const] = ACTIONS(2362),
    [anon_sym_continue] = ACTIONS(2362),
    [anon_sym_default] = ACTIONS(2362),
    [anon_sym_enum] = ACTIONS(2362),
    [anon_sym_fn] = ACTIONS(2362),
    [anon_sym_for] = ACTIONS(2362),
    [anon_sym_if] = ACTIONS(2362),
    [anon_sym_impl] = ACTIONS(2362),
    [anon_sym_let] = ACTIONS(2362),
    [anon_sym_loop] = ACTIONS(2362),
    [anon_sym_match] = ACTIONS(2362),
    [anon_sym_mod] = ACTIONS(2362),
    [anon_sym_pub] = ACTIONS(2362),
    [anon_sym_return] = ACTIONS(2362),
    [anon_sym_static] = ACTIONS(2362),
    [anon_sym_struct] = ACTIONS(2362),
    [anon_sym_trait] = ACTIONS(2362),
    [anon_sym_type] = ACTIONS(2362),
    [anon_sym_union] = ACTIONS(2362),
    [anon_sym_unsafe] = ACTIONS(2362),
    [anon_sym_use] = ACTIONS(2362),
    [anon_sym_while] = ACTIONS(2362),
    [anon_sym_extern] = ACTIONS(2362),
    [anon_sym_yield] = ACTIONS(2362),
    [anon_sym_move] = ACTIONS(2362),
    [anon_sym_try] = ACTIONS(2362),
    [sym_integer_literal] = ACTIONS(2360),
    [aux_sym_string_literal_token1] = ACTIONS(2360),
    [sym_char_literal] = ACTIONS(2360),
    [anon_sym_true] = ACTIONS(2362),
    [anon_sym_false] = ACTIONS(2362),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2362),
    [sym_super] = ACTIONS(2362),
    [sym_crate] = ACTIONS(2362),
    [sym_metavariable] = ACTIONS(2360),
    [sym__raw_string_literal_start] = ACTIONS(2360),
    [sym_float_literal] = ACTIONS(2360),
  },
  [629] = {
    [sym_empty_statement] = STATE(1143),
    [sym_macro_definition] = STATE(1143),
    [sym_attribute_item] = STATE(1143),
    [sym_inner_attribute_item] = STATE(1143),
    [sym_mod_item] = STATE(1143),
    [sym_foreign_mod_item] = STATE(1143),
    [sym_struct_item] = STATE(1143),
    [sym_union_item] = STATE(1143),
    [sym_enum_item] = STATE(1143),
    [sym_extern_crate_declaration] = STATE(1143),
    [sym_const_item] = STATE(1143),
    [sym_static_item] = STATE(1143),
    [sym_type_item] = STATE(1143),
    [sym_function_item] = STATE(1143),
    [sym_function_signature_item] = STATE(1143),
    [sym_function_modifiers] = STATE(3583),
    [sym_impl_item] = STATE(1143),
    [sym_trait_item] = STATE(1143),
    [sym_associated_type] = STATE(1143),
    [sym_let_declaration] = STATE(1143),
    [sym_use_declaration] = STATE(1143),
    [sym_extern_modifier] = STATE(2167),
    [sym_visibility_modifier] = STATE(1927),
    [sym_bracketed_type] = STATE(3307),
    [sym_generic_type_with_turbofish] = STATE(3333),
    [sym_macro_invocation] = STATE(1143),
    [sym_scoped_identifier] = STATE(3206),
    [sym_line_comment] = STATE(629),
    [sym_block_comment] = STATE(629),
    [aux_sym_declaration_list_repeat1] = STATE(659),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(1846),
    [anon_sym_SEMI] = ACTIONS(1848),
    [anon_sym_macro_rules_BANG] = ACTIONS(1850),
    [anon_sym_RBRACE] = ACTIONS(2364),
    [anon_sym_u8] = ACTIONS(1854),
    [anon_sym_i8] = ACTIONS(1854),
    [anon_sym_u16] = ACTIONS(1854),
    [anon_sym_i16] = ACTIONS(1854),
    [anon_sym_u32] = ACTIONS(1854),
    [anon_sym_i32] = ACTIONS(1854),
    [anon_sym_u64] = ACTIONS(1854),
    [anon_sym_i64] = ACTIONS(1854),
    [anon_sym_u128] = ACTIONS(1854),
    [anon_sym_i128] = ACTIONS(1854),
    [anon_sym_isize] = ACTIONS(1854),
    [anon_sym_usize] = ACTIONS(1854),
    [anon_sym_f32] = ACTIONS(1854),
    [anon_sym_f64] = ACTIONS(1854),
    [anon_sym_bool] = ACTIONS(1854),
    [anon_sym_str] = ACTIONS(1854),
    [anon_sym_char] = ACTIONS(1854),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1856),
    [anon_sym_POUND] = ACTIONS(1858),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1860),
    [anon_sym_default] = ACTIONS(1862),
    [anon_sym_enum] = ACTIONS(1864),
    [anon_sym_fn] = ACTIONS(1866),
    [anon_sym_impl] = ACTIONS(1868),
    [anon_sym_let] = ACTIONS(1870),
    [anon_sym_mod] = ACTIONS(1872),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(1874),
    [anon_sym_struct] = ACTIONS(1876),
    [anon_sym_trait] = ACTIONS(1878),
    [anon_sym_type] = ACTIONS(1880),
    [anon_sym_union] = ACTIONS(1882),
    [anon_sym_unsafe] = ACTIONS(1884),
    [anon_sym_use] = ACTIONS(1886),
    [anon_sym_extern] = ACTIONS(1888),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1890),
    [sym_super] = ACTIONS(1890),
    [sym_crate] = ACTIONS(1892),
    [sym_metavariable] = ACTIONS(1894),
  },
  [630] = {
    [sym_line_comment] = STATE(630),
    [sym_block_comment] = STATE(630),
    [ts_builtin_sym_end] = ACTIONS(1232),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_SEMI] = ACTIONS(1232),
    [anon_sym_macro_rules_BANG] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1232),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_LBRACE] = ACTIONS(1232),
    [anon_sym_RBRACE] = ACTIONS(1232),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_u8] = ACTIONS(1234),
    [anon_sym_i8] = ACTIONS(1234),
    [anon_sym_u16] = ACTIONS(1234),
    [anon_sym_i16] = ACTIONS(1234),
    [anon_sym_u32] = ACTIONS(1234),
    [anon_sym_i32] = ACTIONS(1234),
    [anon_sym_u64] = ACTIONS(1234),
    [anon_sym_i64] = ACTIONS(1234),
    [anon_sym_u128] = ACTIONS(1234),
    [anon_sym_i128] = ACTIONS(1234),
    [anon_sym_isize] = ACTIONS(1234),
    [anon_sym_usize] = ACTIONS(1234),
    [anon_sym_f32] = ACTIONS(1234),
    [anon_sym_f64] = ACTIONS(1234),
    [anon_sym_bool] = ACTIONS(1234),
    [anon_sym_str] = ACTIONS(1234),
    [anon_sym_char] = ACTIONS(1234),
    [anon_sym_DASH] = ACTIONS(1232),
    [anon_sym_BANG] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_PIPE] = ACTIONS(1232),
    [anon_sym_LT] = ACTIONS(1232),
    [anon_sym_DOT_DOT] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(1232),
    [anon_sym_POUND] = ACTIONS(1232),
    [anon_sym_SQUOTE] = ACTIONS(1234),
    [anon_sym_async] = ACTIONS(1234),
    [anon_sym_break] = ACTIONS(1234),
    [anon_sym_const] = ACTIONS(1234),
    [anon_sym_continue] = ACTIONS(1234),
    [anon_sym_default] = ACTIONS(1234),
    [anon_sym_enum] = ACTIONS(1234),
    [anon_sym_fn] = ACTIONS(1234),
    [anon_sym_for] = ACTIONS(1234),
    [anon_sym_if] = ACTIONS(1234),
    [anon_sym_impl] = ACTIONS(1234),
    [anon_sym_let] = ACTIONS(1234),
    [anon_sym_loop] = ACTIONS(1234),
    [anon_sym_match] = ACTIONS(1234),
    [anon_sym_mod] = ACTIONS(1234),
    [anon_sym_pub] = ACTIONS(1234),
    [anon_sym_return] = ACTIONS(1234),
    [anon_sym_static] = ACTIONS(1234),
    [anon_sym_struct] = ACTIONS(1234),
    [anon_sym_trait] = ACTIONS(1234),
    [anon_sym_type] = ACTIONS(1234),
    [anon_sym_union] = ACTIONS(1234),
    [anon_sym_unsafe] = ACTIONS(1234),
    [anon_sym_use] = ACTIONS(1234),
    [anon_sym_while] = ACTIONS(1234),
    [anon_sym_extern] = ACTIONS(1234),
    [anon_sym_yield] = ACTIONS(1234),
    [anon_sym_move] = ACTIONS(1234),
    [anon_sym_try] = ACTIONS(1234),
    [sym_integer_literal] = ACTIONS(1232),
    [aux_sym_string_literal_token1] = ACTIONS(1232),
    [sym_char_literal] = ACTIONS(1232),
    [anon_sym_true] = ACTIONS(1234),
    [anon_sym_false] = ACTIONS(1234),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1234),
    [sym_super] = ACTIONS(1234),
    [sym_crate] = ACTIONS(1234),
    [sym_metavariable] = ACTIONS(1232),
    [sym__raw_string_literal_start] = ACTIONS(1232),
    [sym_float_literal] = ACTIONS(1232),
  },
  [631] = {
    [sym_line_comment] = STATE(631),
    [sym_block_comment] = STATE(631),
    [ts_builtin_sym_end] = ACTIONS(2366),
    [sym_identifier] = ACTIONS(2368),
    [anon_sym_SEMI] = ACTIONS(2366),
    [anon_sym_macro_rules_BANG] = ACTIONS(2366),
    [anon_sym_LPAREN] = ACTIONS(2366),
    [anon_sym_LBRACK] = ACTIONS(2366),
    [anon_sym_LBRACE] = ACTIONS(2366),
    [anon_sym_RBRACE] = ACTIONS(2366),
    [anon_sym_STAR] = ACTIONS(2366),
    [anon_sym_u8] = ACTIONS(2368),
    [anon_sym_i8] = ACTIONS(2368),
    [anon_sym_u16] = ACTIONS(2368),
    [anon_sym_i16] = ACTIONS(2368),
    [anon_sym_u32] = ACTIONS(2368),
    [anon_sym_i32] = ACTIONS(2368),
    [anon_sym_u64] = ACTIONS(2368),
    [anon_sym_i64] = ACTIONS(2368),
    [anon_sym_u128] = ACTIONS(2368),
    [anon_sym_i128] = ACTIONS(2368),
    [anon_sym_isize] = ACTIONS(2368),
    [anon_sym_usize] = ACTIONS(2368),
    [anon_sym_f32] = ACTIONS(2368),
    [anon_sym_f64] = ACTIONS(2368),
    [anon_sym_bool] = ACTIONS(2368),
    [anon_sym_str] = ACTIONS(2368),
    [anon_sym_char] = ACTIONS(2368),
    [anon_sym_DASH] = ACTIONS(2366),
    [anon_sym_BANG] = ACTIONS(2366),
    [anon_sym_AMP] = ACTIONS(2366),
    [anon_sym_PIPE] = ACTIONS(2366),
    [anon_sym_LT] = ACTIONS(2366),
    [anon_sym_DOT_DOT] = ACTIONS(2366),
    [anon_sym_COLON_COLON] = ACTIONS(2366),
    [anon_sym_POUND] = ACTIONS(2366),
    [anon_sym_SQUOTE] = ACTIONS(2368),
    [anon_sym_async] = ACTIONS(2368),
    [anon_sym_break] = ACTIONS(2368),
    [anon_sym_const] = ACTIONS(2368),
    [anon_sym_continue] = ACTIONS(2368),
    [anon_sym_default] = ACTIONS(2368),
    [anon_sym_enum] = ACTIONS(2368),
    [anon_sym_fn] = ACTIONS(2368),
    [anon_sym_for] = ACTIONS(2368),
    [anon_sym_if] = ACTIONS(2368),
    [anon_sym_impl] = ACTIONS(2368),
    [anon_sym_let] = ACTIONS(2368),
    [anon_sym_loop] = ACTIONS(2368),
    [anon_sym_match] = ACTIONS(2368),
    [anon_sym_mod] = ACTIONS(2368),
    [anon_sym_pub] = ACTIONS(2368),
    [anon_sym_return] = ACTIONS(2368),
    [anon_sym_static] = ACTIONS(2368),
    [anon_sym_struct] = ACTIONS(2368),
    [anon_sym_trait] = ACTIONS(2368),
    [anon_sym_type] = ACTIONS(2368),
    [anon_sym_union] = ACTIONS(2368),
    [anon_sym_unsafe] = ACTIONS(2368),
    [anon_sym_use] = ACTIONS(2368),
    [anon_sym_while] = ACTIONS(2368),
    [anon_sym_extern] = ACTIONS(2368),
    [anon_sym_yield] = ACTIONS(2368),
    [anon_sym_move] = ACTIONS(2368),
    [anon_sym_try] = ACTIONS(2368),
    [sym_integer_literal] = ACTIONS(2366),
    [aux_sym_string_literal_token1] = ACTIONS(2366),
    [sym_char_literal] = ACTIONS(2366),
    [anon_sym_true] = ACTIONS(2368),
    [anon_sym_false] = ACTIONS(2368),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2368),
    [sym_super] = ACTIONS(2368),
    [sym_crate] = ACTIONS(2368),
    [sym_metavariable] = ACTIONS(2366),
    [sym__raw_string_literal_start] = ACTIONS(2366),
    [sym_float_literal] = ACTIONS(2366),
  },
  [632] = {
    [sym_line_comment] = STATE(632),
    [sym_block_comment] = STATE(632),
    [ts_builtin_sym_end] = ACTIONS(2370),
    [sym_identifier] = ACTIONS(2372),
    [anon_sym_SEMI] = ACTIONS(2370),
    [anon_sym_macro_rules_BANG] = ACTIONS(2370),
    [anon_sym_LPAREN] = ACTIONS(2370),
    [anon_sym_LBRACK] = ACTIONS(2370),
    [anon_sym_LBRACE] = ACTIONS(2370),
    [anon_sym_RBRACE] = ACTIONS(2370),
    [anon_sym_STAR] = ACTIONS(2370),
    [anon_sym_u8] = ACTIONS(2372),
    [anon_sym_i8] = ACTIONS(2372),
    [anon_sym_u16] = ACTIONS(2372),
    [anon_sym_i16] = ACTIONS(2372),
    [anon_sym_u32] = ACTIONS(2372),
    [anon_sym_i32] = ACTIONS(2372),
    [anon_sym_u64] = ACTIONS(2372),
    [anon_sym_i64] = ACTIONS(2372),
    [anon_sym_u128] = ACTIONS(2372),
    [anon_sym_i128] = ACTIONS(2372),
    [anon_sym_isize] = ACTIONS(2372),
    [anon_sym_usize] = ACTIONS(2372),
    [anon_sym_f32] = ACTIONS(2372),
    [anon_sym_f64] = ACTIONS(2372),
    [anon_sym_bool] = ACTIONS(2372),
    [anon_sym_str] = ACTIONS(2372),
    [anon_sym_char] = ACTIONS(2372),
    [anon_sym_DASH] = ACTIONS(2370),
    [anon_sym_BANG] = ACTIONS(2370),
    [anon_sym_AMP] = ACTIONS(2370),
    [anon_sym_PIPE] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2370),
    [anon_sym_DOT_DOT] = ACTIONS(2370),
    [anon_sym_COLON_COLON] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [anon_sym_async] = ACTIONS(2372),
    [anon_sym_break] = ACTIONS(2372),
    [anon_sym_const] = ACTIONS(2372),
    [anon_sym_continue] = ACTIONS(2372),
    [anon_sym_default] = ACTIONS(2372),
    [anon_sym_enum] = ACTIONS(2372),
    [anon_sym_fn] = ACTIONS(2372),
    [anon_sym_for] = ACTIONS(2372),
    [anon_sym_if] = ACTIONS(2372),
    [anon_sym_impl] = ACTIONS(2372),
    [anon_sym_let] = ACTIONS(2372),
    [anon_sym_loop] = ACTIONS(2372),
    [anon_sym_match] = ACTIONS(2372),
    [anon_sym_mod] = ACTIONS(2372),
    [anon_sym_pub] = ACTIONS(2372),
    [anon_sym_return] = ACTIONS(2372),
    [anon_sym_static] = ACTIONS(2372),
    [anon_sym_struct] = ACTIONS(2372),
    [anon_sym_trait] = ACTIONS(2372),
    [anon_sym_type] = ACTIONS(2372),
    [anon_sym_union] = ACTIONS(2372),
    [anon_sym_unsafe] = ACTIONS(2372),
    [anon_sym_use] = ACTIONS(2372),
    [anon_sym_while] = ACTIONS(2372),
    [anon_sym_extern] = ACTIONS(2372),
    [anon_sym_yield] = ACTIONS(2372),
    [anon_sym_move] = ACTIONS(2372),
    [anon_sym_try] = ACTIONS(2372),
    [sym_integer_literal] = ACTIONS(2370),
    [aux_sym_string_literal_token1] = ACTIONS(2370),
    [sym_char_literal] = ACTIONS(2370),
    [anon_sym_true] = ACTIONS(2372),
    [anon_sym_false] = ACTIONS(2372),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2372),
    [sym_super] = ACTIONS(2372),
    [sym_crate] = ACTIONS(2372),
    [sym_metavariable] = ACTIONS(2370),
    [sym__raw_string_literal_start] = ACTIONS(2370),
    [sym_float_literal] = ACTIONS(2370),
  },
  [633] = {
    [sym_line_comment] = STATE(633),
    [sym_block_comment] = STATE(633),
    [ts_builtin_sym_end] = ACTIONS(2374),
    [sym_identifier] = ACTIONS(2376),
    [anon_sym_SEMI] = ACTIONS(2374),
    [anon_sym_macro_rules_BANG] = ACTIONS(2374),
    [anon_sym_LPAREN] = ACTIONS(2374),
    [anon_sym_LBRACK] = ACTIONS(2374),
    [anon_sym_LBRACE] = ACTIONS(2374),
    [anon_sym_RBRACE] = ACTIONS(2374),
    [anon_sym_STAR] = ACTIONS(2374),
    [anon_sym_u8] = ACTIONS(2376),
    [anon_sym_i8] = ACTIONS(2376),
    [anon_sym_u16] = ACTIONS(2376),
    [anon_sym_i16] = ACTIONS(2376),
    [anon_sym_u32] = ACTIONS(2376),
    [anon_sym_i32] = ACTIONS(2376),
    [anon_sym_u64] = ACTIONS(2376),
    [anon_sym_i64] = ACTIONS(2376),
    [anon_sym_u128] = ACTIONS(2376),
    [anon_sym_i128] = ACTIONS(2376),
    [anon_sym_isize] = ACTIONS(2376),
    [anon_sym_usize] = ACTIONS(2376),
    [anon_sym_f32] = ACTIONS(2376),
    [anon_sym_f64] = ACTIONS(2376),
    [anon_sym_bool] = ACTIONS(2376),
    [anon_sym_str] = ACTIONS(2376),
    [anon_sym_char] = ACTIONS(2376),
    [anon_sym_DASH] = ACTIONS(2374),
    [anon_sym_BANG] = ACTIONS(2374),
    [anon_sym_AMP] = ACTIONS(2374),
    [anon_sym_PIPE] = ACTIONS(2374),
    [anon_sym_LT] = ACTIONS(2374),
    [anon_sym_DOT_DOT] = ACTIONS(2374),
    [anon_sym_COLON_COLON] = ACTIONS(2374),
    [anon_sym_POUND] = ACTIONS(2374),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_async] = ACTIONS(2376),
    [anon_sym_break] = ACTIONS(2376),
    [anon_sym_const] = ACTIONS(2376),
    [anon_sym_continue] = ACTIONS(2376),
    [anon_sym_default] = ACTIONS(2376),
    [anon_sym_enum] = ACTIONS(2376),
    [anon_sym_fn] = ACTIONS(2376),
    [anon_sym_for] = ACTIONS(2376),
    [anon_sym_if] = ACTIONS(2376),
    [anon_sym_impl] = ACTIONS(2376),
    [anon_sym_let] = ACTIONS(2376),
    [anon_sym_loop] = ACTIONS(2376),
    [anon_sym_match] = ACTIONS(2376),
    [anon_sym_mod] = ACTIONS(2376),
    [anon_sym_pub] = ACTIONS(2376),
    [anon_sym_return] = ACTIONS(2376),
    [anon_sym_static] = ACTIONS(2376),
    [anon_sym_struct] = ACTIONS(2376),
    [anon_sym_trait] = ACTIONS(2376),
    [anon_sym_type] = ACTIONS(2376),
    [anon_sym_union] = ACTIONS(2376),
    [anon_sym_unsafe] = ACTIONS(2376),
    [anon_sym_use] = ACTIONS(2376),
    [anon_sym_while] = ACTIONS(2376),
    [anon_sym_extern] = ACTIONS(2376),
    [anon_sym_yield] = ACTIONS(2376),
    [anon_sym_move] = ACTIONS(2376),
    [anon_sym_try] = ACTIONS(2376),
    [sym_integer_literal] = ACTIONS(2374),
    [aux_sym_string_literal_token1] = ACTIONS(2374),
    [sym_char_literal] = ACTIONS(2374),
    [anon_sym_true] = ACTIONS(2376),
    [anon_sym_false] = ACTIONS(2376),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2376),
    [sym_super] = ACTIONS(2376),
    [sym_crate] = ACTIONS(2376),
    [sym_metavariable] = ACTIONS(2374),
    [sym__raw_string_literal_start] = ACTIONS(2374),
    [sym_float_literal] = ACTIONS(2374),
  },
  [634] = {
    [sym_line_comment] = STATE(634),
    [sym_block_comment] = STATE(634),
    [ts_builtin_sym_end] = ACTIONS(2378),
    [sym_identifier] = ACTIONS(2380),
    [anon_sym_SEMI] = ACTIONS(2378),
    [anon_sym_macro_rules_BANG] = ACTIONS(2378),
    [anon_sym_LPAREN] = ACTIONS(2378),
    [anon_sym_LBRACK] = ACTIONS(2378),
    [anon_sym_LBRACE] = ACTIONS(2378),
    [anon_sym_RBRACE] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(2378),
    [anon_sym_u8] = ACTIONS(2380),
    [anon_sym_i8] = ACTIONS(2380),
    [anon_sym_u16] = ACTIONS(2380),
    [anon_sym_i16] = ACTIONS(2380),
    [anon_sym_u32] = ACTIONS(2380),
    [anon_sym_i32] = ACTIONS(2380),
    [anon_sym_u64] = ACTIONS(2380),
    [anon_sym_i64] = ACTIONS(2380),
    [anon_sym_u128] = ACTIONS(2380),
    [anon_sym_i128] = ACTIONS(2380),
    [anon_sym_isize] = ACTIONS(2380),
    [anon_sym_usize] = ACTIONS(2380),
    [anon_sym_f32] = ACTIONS(2380),
    [anon_sym_f64] = ACTIONS(2380),
    [anon_sym_bool] = ACTIONS(2380),
    [anon_sym_str] = ACTIONS(2380),
    [anon_sym_char] = ACTIONS(2380),
    [anon_sym_DASH] = ACTIONS(2378),
    [anon_sym_BANG] = ACTIONS(2378),
    [anon_sym_AMP] = ACTIONS(2378),
    [anon_sym_PIPE] = ACTIONS(2378),
    [anon_sym_LT] = ACTIONS(2378),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym_COLON_COLON] = ACTIONS(2378),
    [anon_sym_POUND] = ACTIONS(2378),
    [anon_sym_SQUOTE] = ACTIONS(2380),
    [anon_sym_async] = ACTIONS(2380),
    [anon_sym_break] = ACTIONS(2380),
    [anon_sym_const] = ACTIONS(2380),
    [anon_sym_continue] = ACTIONS(2380),
    [anon_sym_default] = ACTIONS(2380),
    [anon_sym_enum] = ACTIONS(2380),
    [anon_sym_fn] = ACTIONS(2380),
    [anon_sym_for] = ACTIONS(2380),
    [anon_sym_if] = ACTIONS(2380),
    [anon_sym_impl] = ACTIONS(2380),
    [anon_sym_let] = ACTIONS(2380),
    [anon_sym_loop] = ACTIONS(2380),
    [anon_sym_match] = ACTIONS(2380),
    [anon_sym_mod] = ACTIONS(2380),
    [anon_sym_pub] = ACTIONS(2380),
    [anon_sym_return] = ACTIONS(2380),
    [anon_sym_static] = ACTIONS(2380),
    [anon_sym_struct] = ACTIONS(2380),
    [anon_sym_trait] = ACTIONS(2380),
    [anon_sym_type] = ACTIONS(2380),
    [anon_sym_union] = ACTIONS(2380),
    [anon_sym_unsafe] = ACTIONS(2380),
    [anon_sym_use] = ACTIONS(2380),
    [anon_sym_while] = ACTIONS(2380),
    [anon_sym_extern] = ACTIONS(2380),
    [anon_sym_yield] = ACTIONS(2380),
    [anon_sym_move] = ACTIONS(2380),
    [anon_sym_try] = ACTIONS(2380),
    [sym_integer_literal] = ACTIONS(2378),
    [aux_sym_string_literal_token1] = ACTIONS(2378),
    [sym_char_literal] = ACTIONS(2378),
    [anon_sym_true] = ACTIONS(2380),
    [anon_sym_false] = ACTIONS(2380),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2380),
    [sym_super] = ACTIONS(2380),
    [sym_crate] = ACTIONS(2380),
    [sym_metavariable] = ACTIONS(2378),
    [sym__raw_string_literal_start] = ACTIONS(2378),
    [sym_float_literal] = ACTIONS(2378),
  },
  [635] = {
    [sym_line_comment] = STATE(635),
    [sym_block_comment] = STATE(635),
    [ts_builtin_sym_end] = ACTIONS(2382),
    [sym_identifier] = ACTIONS(2384),
    [anon_sym_SEMI] = ACTIONS(2382),
    [anon_sym_macro_rules_BANG] = ACTIONS(2382),
    [anon_sym_LPAREN] = ACTIONS(2382),
    [anon_sym_LBRACK] = ACTIONS(2382),
    [anon_sym_LBRACE] = ACTIONS(2382),
    [anon_sym_RBRACE] = ACTIONS(2382),
    [anon_sym_STAR] = ACTIONS(2382),
    [anon_sym_u8] = ACTIONS(2384),
    [anon_sym_i8] = ACTIONS(2384),
    [anon_sym_u16] = ACTIONS(2384),
    [anon_sym_i16] = ACTIONS(2384),
    [anon_sym_u32] = ACTIONS(2384),
    [anon_sym_i32] = ACTIONS(2384),
    [anon_sym_u64] = ACTIONS(2384),
    [anon_sym_i64] = ACTIONS(2384),
    [anon_sym_u128] = ACTIONS(2384),
    [anon_sym_i128] = ACTIONS(2384),
    [anon_sym_isize] = ACTIONS(2384),
    [anon_sym_usize] = ACTIONS(2384),
    [anon_sym_f32] = ACTIONS(2384),
    [anon_sym_f64] = ACTIONS(2384),
    [anon_sym_bool] = ACTIONS(2384),
    [anon_sym_str] = ACTIONS(2384),
    [anon_sym_char] = ACTIONS(2384),
    [anon_sym_DASH] = ACTIONS(2382),
    [anon_sym_BANG] = ACTIONS(2382),
    [anon_sym_AMP] = ACTIONS(2382),
    [anon_sym_PIPE] = ACTIONS(2382),
    [anon_sym_LT] = ACTIONS(2382),
    [anon_sym_DOT_DOT] = ACTIONS(2382),
    [anon_sym_COLON_COLON] = ACTIONS(2382),
    [anon_sym_POUND] = ACTIONS(2382),
    [anon_sym_SQUOTE] = ACTIONS(2384),
    [anon_sym_async] = ACTIONS(2384),
    [anon_sym_break] = ACTIONS(2384),
    [anon_sym_const] = ACTIONS(2384),
    [anon_sym_continue] = ACTIONS(2384),
    [anon_sym_default] = ACTIONS(2384),
    [anon_sym_enum] = ACTIONS(2384),
    [anon_sym_fn] = ACTIONS(2384),
    [anon_sym_for] = ACTIONS(2384),
    [anon_sym_if] = ACTIONS(2384),
    [anon_sym_impl] = ACTIONS(2384),
    [anon_sym_let] = ACTIONS(2384),
    [anon_sym_loop] = ACTIONS(2384),
    [anon_sym_match] = ACTIONS(2384),
    [anon_sym_mod] = ACTIONS(2384),
    [anon_sym_pub] = ACTIONS(2384),
    [anon_sym_return] = ACTIONS(2384),
    [anon_sym_static] = ACTIONS(2384),
    [anon_sym_struct] = ACTIONS(2384),
    [anon_sym_trait] = ACTIONS(2384),
    [anon_sym_type] = ACTIONS(2384),
    [anon_sym_union] = ACTIONS(2384),
    [anon_sym_unsafe] = ACTIONS(2384),
    [anon_sym_use] = ACTIONS(2384),
    [anon_sym_while] = ACTIONS(2384),
    [anon_sym_extern] = ACTIONS(2384),
    [anon_sym_yield] = ACTIONS(2384),
    [anon_sym_move] = ACTIONS(2384),
    [anon_sym_try] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2382),
    [aux_sym_string_literal_token1] = ACTIONS(2382),
    [sym_char_literal] = ACTIONS(2382),
    [anon_sym_true] = ACTIONS(2384),
    [anon_sym_false] = ACTIONS(2384),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2384),
    [sym_super] = ACTIONS(2384),
    [sym_crate] = ACTIONS(2384),
    [sym_metavariable] = ACTIONS(2382),
    [sym__raw_string_literal_start] = ACTIONS(2382),
    [sym_float_literal] = ACTIONS(2382),
  },
  [636] = {
    [sym_line_comment] = STATE(636),
    [sym_block_comment] = STATE(636),
    [ts_builtin_sym_end] = ACTIONS(2386),
    [sym_identifier] = ACTIONS(2388),
    [anon_sym_SEMI] = ACTIONS(2386),
    [anon_sym_macro_rules_BANG] = ACTIONS(2386),
    [anon_sym_LPAREN] = ACTIONS(2386),
    [anon_sym_LBRACK] = ACTIONS(2386),
    [anon_sym_LBRACE] = ACTIONS(2386),
    [anon_sym_RBRACE] = ACTIONS(2386),
    [anon_sym_STAR] = ACTIONS(2386),
    [anon_sym_u8] = ACTIONS(2388),
    [anon_sym_i8] = ACTIONS(2388),
    [anon_sym_u16] = ACTIONS(2388),
    [anon_sym_i16] = ACTIONS(2388),
    [anon_sym_u32] = ACTIONS(2388),
    [anon_sym_i32] = ACTIONS(2388),
    [anon_sym_u64] = ACTIONS(2388),
    [anon_sym_i64] = ACTIONS(2388),
    [anon_sym_u128] = ACTIONS(2388),
    [anon_sym_i128] = ACTIONS(2388),
    [anon_sym_isize] = ACTIONS(2388),
    [anon_sym_usize] = ACTIONS(2388),
    [anon_sym_f32] = ACTIONS(2388),
    [anon_sym_f64] = ACTIONS(2388),
    [anon_sym_bool] = ACTIONS(2388),
    [anon_sym_str] = ACTIONS(2388),
    [anon_sym_char] = ACTIONS(2388),
    [anon_sym_DASH] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2386),
    [anon_sym_AMP] = ACTIONS(2386),
    [anon_sym_PIPE] = ACTIONS(2386),
    [anon_sym_LT] = ACTIONS(2386),
    [anon_sym_DOT_DOT] = ACTIONS(2386),
    [anon_sym_COLON_COLON] = ACTIONS(2386),
    [anon_sym_POUND] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_async] = ACTIONS(2388),
    [anon_sym_break] = ACTIONS(2388),
    [anon_sym_const] = ACTIONS(2388),
    [anon_sym_continue] = ACTIONS(2388),
    [anon_sym_default] = ACTIONS(2388),
    [anon_sym_enum] = ACTIONS(2388),
    [anon_sym_fn] = ACTIONS(2388),
    [anon_sym_for] = ACTIONS(2388),
    [anon_sym_if] = ACTIONS(2388),
    [anon_sym_impl] = ACTIONS(2388),
    [anon_sym_let] = ACTIONS(2388),
    [anon_sym_loop] = ACTIONS(2388),
    [anon_sym_match] = ACTIONS(2388),
    [anon_sym_mod] = ACTIONS(2388),
    [anon_sym_pub] = ACTIONS(2388),
    [anon_sym_return] = ACTIONS(2388),
    [anon_sym_static] = ACTIONS(2388),
    [anon_sym_struct] = ACTIONS(2388),
    [anon_sym_trait] = ACTIONS(2388),
    [anon_sym_type] = ACTIONS(2388),
    [anon_sym_union] = ACTIONS(2388),
    [anon_sym_unsafe] = ACTIONS(2388),
    [anon_sym_use] = ACTIONS(2388),
    [anon_sym_while] = ACTIONS(2388),
    [anon_sym_extern] = ACTIONS(2388),
    [anon_sym_yield] = ACTIONS(2388),
    [anon_sym_move] = ACTIONS(2388),
    [anon_sym_try] = ACTIONS(2388),
    [sym_integer_literal] = ACTIONS(2386),
    [aux_sym_string_literal_token1] = ACTIONS(2386),
    [sym_char_literal] = ACTIONS(2386),
    [anon_sym_true] = ACTIONS(2388),
    [anon_sym_false] = ACTIONS(2388),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2388),
    [sym_super] = ACTIONS(2388),
    [sym_crate] = ACTIONS(2388),
    [sym_metavariable] = ACTIONS(2386),
    [sym__raw_string_literal_start] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
  },
  [637] = {
    [sym_line_comment] = STATE(637),
    [sym_block_comment] = STATE(637),
    [ts_builtin_sym_end] = ACTIONS(2390),
    [sym_identifier] = ACTIONS(2392),
    [anon_sym_SEMI] = ACTIONS(2390),
    [anon_sym_macro_rules_BANG] = ACTIONS(2390),
    [anon_sym_LPAREN] = ACTIONS(2390),
    [anon_sym_LBRACK] = ACTIONS(2390),
    [anon_sym_LBRACE] = ACTIONS(2390),
    [anon_sym_RBRACE] = ACTIONS(2390),
    [anon_sym_STAR] = ACTIONS(2390),
    [anon_sym_u8] = ACTIONS(2392),
    [anon_sym_i8] = ACTIONS(2392),
    [anon_sym_u16] = ACTIONS(2392),
    [anon_sym_i16] = ACTIONS(2392),
    [anon_sym_u32] = ACTIONS(2392),
    [anon_sym_i32] = ACTIONS(2392),
    [anon_sym_u64] = ACTIONS(2392),
    [anon_sym_i64] = ACTIONS(2392),
    [anon_sym_u128] = ACTIONS(2392),
    [anon_sym_i128] = ACTIONS(2392),
    [anon_sym_isize] = ACTIONS(2392),
    [anon_sym_usize] = ACTIONS(2392),
    [anon_sym_f32] = ACTIONS(2392),
    [anon_sym_f64] = ACTIONS(2392),
    [anon_sym_bool] = ACTIONS(2392),
    [anon_sym_str] = ACTIONS(2392),
    [anon_sym_char] = ACTIONS(2392),
    [anon_sym_DASH] = ACTIONS(2390),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_AMP] = ACTIONS(2390),
    [anon_sym_PIPE] = ACTIONS(2390),
    [anon_sym_LT] = ACTIONS(2390),
    [anon_sym_DOT_DOT] = ACTIONS(2390),
    [anon_sym_COLON_COLON] = ACTIONS(2390),
    [anon_sym_POUND] = ACTIONS(2390),
    [anon_sym_SQUOTE] = ACTIONS(2392),
    [anon_sym_async] = ACTIONS(2392),
    [anon_sym_break] = ACTIONS(2392),
    [anon_sym_const] = ACTIONS(2392),
    [anon_sym_continue] = ACTIONS(2392),
    [anon_sym_default] = ACTIONS(2392),
    [anon_sym_enum] = ACTIONS(2392),
    [anon_sym_fn] = ACTIONS(2392),
    [anon_sym_for] = ACTIONS(2392),
    [anon_sym_if] = ACTIONS(2392),
    [anon_sym_impl] = ACTIONS(2392),
    [anon_sym_let] = ACTIONS(2392),
    [anon_sym_loop] = ACTIONS(2392),
    [anon_sym_match] = ACTIONS(2392),
    [anon_sym_mod] = ACTIONS(2392),
    [anon_sym_pub] = ACTIONS(2392),
    [anon_sym_return] = ACTIONS(2392),
    [anon_sym_static] = ACTIONS(2392),
    [anon_sym_struct] = ACTIONS(2392),
    [anon_sym_trait] = ACTIONS(2392),
    [anon_sym_type] = ACTIONS(2392),
    [anon_sym_union] = ACTIONS(2392),
    [anon_sym_unsafe] = ACTIONS(2392),
    [anon_sym_use] = ACTIONS(2392),
    [anon_sym_while] = ACTIONS(2392),
    [anon_sym_extern] = ACTIONS(2392),
    [anon_sym_yield] = ACTIONS(2392),
    [anon_sym_move] = ACTIONS(2392),
    [anon_sym_try] = ACTIONS(2392),
    [sym_integer_literal] = ACTIONS(2390),
    [aux_sym_string_literal_token1] = ACTIONS(2390),
    [sym_char_literal] = ACTIONS(2390),
    [anon_sym_true] = ACTIONS(2392),
    [anon_sym_false] = ACTIONS(2392),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2392),
    [sym_super] = ACTIONS(2392),
    [sym_crate] = ACTIONS(2392),
    [sym_metavariable] = ACTIONS(2390),
    [sym__raw_string_literal_start] = ACTIONS(2390),
    [sym_float_literal] = ACTIONS(2390),
  },
  [638] = {
    [sym_line_comment] = STATE(638),
    [sym_block_comment] = STATE(638),
    [ts_builtin_sym_end] = ACTIONS(2394),
    [sym_identifier] = ACTIONS(2396),
    [anon_sym_SEMI] = ACTIONS(2394),
    [anon_sym_macro_rules_BANG] = ACTIONS(2394),
    [anon_sym_LPAREN] = ACTIONS(2394),
    [anon_sym_LBRACK] = ACTIONS(2394),
    [anon_sym_LBRACE] = ACTIONS(2394),
    [anon_sym_RBRACE] = ACTIONS(2394),
    [anon_sym_STAR] = ACTIONS(2394),
    [anon_sym_u8] = ACTIONS(2396),
    [anon_sym_i8] = ACTIONS(2396),
    [anon_sym_u16] = ACTIONS(2396),
    [anon_sym_i16] = ACTIONS(2396),
    [anon_sym_u32] = ACTIONS(2396),
    [anon_sym_i32] = ACTIONS(2396),
    [anon_sym_u64] = ACTIONS(2396),
    [anon_sym_i64] = ACTIONS(2396),
    [anon_sym_u128] = ACTIONS(2396),
    [anon_sym_i128] = ACTIONS(2396),
    [anon_sym_isize] = ACTIONS(2396),
    [anon_sym_usize] = ACTIONS(2396),
    [anon_sym_f32] = ACTIONS(2396),
    [anon_sym_f64] = ACTIONS(2396),
    [anon_sym_bool] = ACTIONS(2396),
    [anon_sym_str] = ACTIONS(2396),
    [anon_sym_char] = ACTIONS(2396),
    [anon_sym_DASH] = ACTIONS(2394),
    [anon_sym_BANG] = ACTIONS(2394),
    [anon_sym_AMP] = ACTIONS(2394),
    [anon_sym_PIPE] = ACTIONS(2394),
    [anon_sym_LT] = ACTIONS(2394),
    [anon_sym_DOT_DOT] = ACTIONS(2394),
    [anon_sym_COLON_COLON] = ACTIONS(2394),
    [anon_sym_POUND] = ACTIONS(2394),
    [anon_sym_SQUOTE] = ACTIONS(2396),
    [anon_sym_async] = ACTIONS(2396),
    [anon_sym_break] = ACTIONS(2396),
    [anon_sym_const] = ACTIONS(2396),
    [anon_sym_continue] = ACTIONS(2396),
    [anon_sym_default] = ACTIONS(2396),
    [anon_sym_enum] = ACTIONS(2396),
    [anon_sym_fn] = ACTIONS(2396),
    [anon_sym_for] = ACTIONS(2396),
    [anon_sym_if] = ACTIONS(2396),
    [anon_sym_impl] = ACTIONS(2396),
    [anon_sym_let] = ACTIONS(2396),
    [anon_sym_loop] = ACTIONS(2396),
    [anon_sym_match] = ACTIONS(2396),
    [anon_sym_mod] = ACTIONS(2396),
    [anon_sym_pub] = ACTIONS(2396),
    [anon_sym_return] = ACTIONS(2396),
    [anon_sym_static] = ACTIONS(2396),
    [anon_sym_struct] = ACTIONS(2396),
    [anon_sym_trait] = ACTIONS(2396),
    [anon_sym_type] = ACTIONS(2396),
    [anon_sym_union] = ACTIONS(2396),
    [anon_sym_unsafe] = ACTIONS(2396),
    [anon_sym_use] = ACTIONS(2396),
    [anon_sym_while] = ACTIONS(2396),
    [anon_sym_extern] = ACTIONS(2396),
    [anon_sym_yield] = ACTIONS(2396),
    [anon_sym_move] = ACTIONS(2396),
    [anon_sym_try] = ACTIONS(2396),
    [sym_integer_literal] = ACTIONS(2394),
    [aux_sym_string_literal_token1] = ACTIONS(2394),
    [sym_char_literal] = ACTIONS(2394),
    [anon_sym_true] = ACTIONS(2396),
    [anon_sym_false] = ACTIONS(2396),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2396),
    [sym_super] = ACTIONS(2396),
    [sym_crate] = ACTIONS(2396),
    [sym_metavariable] = ACTIONS(2394),
    [sym__raw_string_literal_start] = ACTIONS(2394),
    [sym_float_literal] = ACTIONS(2394),
  },
  [639] = {
    [sym_line_comment] = STATE(639),
    [sym_block_comment] = STATE(639),
    [ts_builtin_sym_end] = ACTIONS(2398),
    [sym_identifier] = ACTIONS(2400),
    [anon_sym_SEMI] = ACTIONS(2398),
    [anon_sym_macro_rules_BANG] = ACTIONS(2398),
    [anon_sym_LPAREN] = ACTIONS(2398),
    [anon_sym_LBRACK] = ACTIONS(2398),
    [anon_sym_LBRACE] = ACTIONS(2398),
    [anon_sym_RBRACE] = ACTIONS(2398),
    [anon_sym_STAR] = ACTIONS(2398),
    [anon_sym_u8] = ACTIONS(2400),
    [anon_sym_i8] = ACTIONS(2400),
    [anon_sym_u16] = ACTIONS(2400),
    [anon_sym_i16] = ACTIONS(2400),
    [anon_sym_u32] = ACTIONS(2400),
    [anon_sym_i32] = ACTIONS(2400),
    [anon_sym_u64] = ACTIONS(2400),
    [anon_sym_i64] = ACTIONS(2400),
    [anon_sym_u128] = ACTIONS(2400),
    [anon_sym_i128] = ACTIONS(2400),
    [anon_sym_isize] = ACTIONS(2400),
    [anon_sym_usize] = ACTIONS(2400),
    [anon_sym_f32] = ACTIONS(2400),
    [anon_sym_f64] = ACTIONS(2400),
    [anon_sym_bool] = ACTIONS(2400),
    [anon_sym_str] = ACTIONS(2400),
    [anon_sym_char] = ACTIONS(2400),
    [anon_sym_DASH] = ACTIONS(2398),
    [anon_sym_BANG] = ACTIONS(2398),
    [anon_sym_AMP] = ACTIONS(2398),
    [anon_sym_PIPE] = ACTIONS(2398),
    [anon_sym_LT] = ACTIONS(2398),
    [anon_sym_DOT_DOT] = ACTIONS(2398),
    [anon_sym_COLON_COLON] = ACTIONS(2398),
    [anon_sym_POUND] = ACTIONS(2398),
    [anon_sym_SQUOTE] = ACTIONS(2400),
    [anon_sym_async] = ACTIONS(2400),
    [anon_sym_break] = ACTIONS(2400),
    [anon_sym_const] = ACTIONS(2400),
    [anon_sym_continue] = ACTIONS(2400),
    [anon_sym_default] = ACTIONS(2400),
    [anon_sym_enum] = ACTIONS(2400),
    [anon_sym_fn] = ACTIONS(2400),
    [anon_sym_for] = ACTIONS(2400),
    [anon_sym_if] = ACTIONS(2400),
    [anon_sym_impl] = ACTIONS(2400),
    [anon_sym_let] = ACTIONS(2400),
    [anon_sym_loop] = ACTIONS(2400),
    [anon_sym_match] = ACTIONS(2400),
    [anon_sym_mod] = ACTIONS(2400),
    [anon_sym_pub] = ACTIONS(2400),
    [anon_sym_return] = ACTIONS(2400),
    [anon_sym_static] = ACTIONS(2400),
    [anon_sym_struct] = ACTIONS(2400),
    [anon_sym_trait] = ACTIONS(2400),
    [anon_sym_type] = ACTIONS(2400),
    [anon_sym_union] = ACTIONS(2400),
    [anon_sym_unsafe] = ACTIONS(2400),
    [anon_sym_use] = ACTIONS(2400),
    [anon_sym_while] = ACTIONS(2400),
    [anon_sym_extern] = ACTIONS(2400),
    [anon_sym_yield] = ACTIONS(2400),
    [anon_sym_move] = ACTIONS(2400),
    [anon_sym_try] = ACTIONS(2400),
    [sym_integer_literal] = ACTIONS(2398),
    [aux_sym_string_literal_token1] = ACTIONS(2398),
    [sym_char_literal] = ACTIONS(2398),
    [anon_sym_true] = ACTIONS(2400),
    [anon_sym_false] = ACTIONS(2400),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2400),
    [sym_super] = ACTIONS(2400),
    [sym_crate] = ACTIONS(2400),
    [sym_metavariable] = ACTIONS(2398),
    [sym__raw_string_literal_start] = ACTIONS(2398),
    [sym_float_literal] = ACTIONS(2398),
  },
  [640] = {
    [sym_line_comment] = STATE(640),
    [sym_block_comment] = STATE(640),
    [ts_builtin_sym_end] = ACTIONS(2402),
    [sym_identifier] = ACTIONS(2404),
    [anon_sym_SEMI] = ACTIONS(2402),
    [anon_sym_macro_rules_BANG] = ACTIONS(2402),
    [anon_sym_LPAREN] = ACTIONS(2402),
    [anon_sym_LBRACK] = ACTIONS(2402),
    [anon_sym_LBRACE] = ACTIONS(2402),
    [anon_sym_RBRACE] = ACTIONS(2402),
    [anon_sym_STAR] = ACTIONS(2402),
    [anon_sym_u8] = ACTIONS(2404),
    [anon_sym_i8] = ACTIONS(2404),
    [anon_sym_u16] = ACTIONS(2404),
    [anon_sym_i16] = ACTIONS(2404),
    [anon_sym_u32] = ACTIONS(2404),
    [anon_sym_i32] = ACTIONS(2404),
    [anon_sym_u64] = ACTIONS(2404),
    [anon_sym_i64] = ACTIONS(2404),
    [anon_sym_u128] = ACTIONS(2404),
    [anon_sym_i128] = ACTIONS(2404),
    [anon_sym_isize] = ACTIONS(2404),
    [anon_sym_usize] = ACTIONS(2404),
    [anon_sym_f32] = ACTIONS(2404),
    [anon_sym_f64] = ACTIONS(2404),
    [anon_sym_bool] = ACTIONS(2404),
    [anon_sym_str] = ACTIONS(2404),
    [anon_sym_char] = ACTIONS(2404),
    [anon_sym_DASH] = ACTIONS(2402),
    [anon_sym_BANG] = ACTIONS(2402),
    [anon_sym_AMP] = ACTIONS(2402),
    [anon_sym_PIPE] = ACTIONS(2402),
    [anon_sym_LT] = ACTIONS(2402),
    [anon_sym_DOT_DOT] = ACTIONS(2402),
    [anon_sym_COLON_COLON] = ACTIONS(2402),
    [anon_sym_POUND] = ACTIONS(2402),
    [anon_sym_SQUOTE] = ACTIONS(2404),
    [anon_sym_async] = ACTIONS(2404),
    [anon_sym_break] = ACTIONS(2404),
    [anon_sym_const] = ACTIONS(2404),
    [anon_sym_continue] = ACTIONS(2404),
    [anon_sym_default] = ACTIONS(2404),
    [anon_sym_enum] = ACTIONS(2404),
    [anon_sym_fn] = ACTIONS(2404),
    [anon_sym_for] = ACTIONS(2404),
    [anon_sym_if] = ACTIONS(2404),
    [anon_sym_impl] = ACTIONS(2404),
    [anon_sym_let] = ACTIONS(2404),
    [anon_sym_loop] = ACTIONS(2404),
    [anon_sym_match] = ACTIONS(2404),
    [anon_sym_mod] = ACTIONS(2404),
    [anon_sym_pub] = ACTIONS(2404),
    [anon_sym_return] = ACTIONS(2404),
    [anon_sym_static] = ACTIONS(2404),
    [anon_sym_struct] = ACTIONS(2404),
    [anon_sym_trait] = ACTIONS(2404),
    [anon_sym_type] = ACTIONS(2404),
    [anon_sym_union] = ACTIONS(2404),
    [anon_sym_unsafe] = ACTIONS(2404),
    [anon_sym_use] = ACTIONS(2404),
    [anon_sym_while] = ACTIONS(2404),
    [anon_sym_extern] = ACTIONS(2404),
    [anon_sym_yield] = ACTIONS(2404),
    [anon_sym_move] = ACTIONS(2404),
    [anon_sym_try] = ACTIONS(2404),
    [sym_integer_literal] = ACTIONS(2402),
    [aux_sym_string_literal_token1] = ACTIONS(2402),
    [sym_char_literal] = ACTIONS(2402),
    [anon_sym_true] = ACTIONS(2404),
    [anon_sym_false] = ACTIONS(2404),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2404),
    [sym_super] = ACTIONS(2404),
    [sym_crate] = ACTIONS(2404),
    [sym_metavariable] = ACTIONS(2402),
    [sym__raw_string_literal_start] = ACTIONS(2402),
    [sym_float_literal] = ACTIONS(2402),
  },
  [641] = {
    [sym_line_comment] = STATE(641),
    [sym_block_comment] = STATE(641),
    [ts_builtin_sym_end] = ACTIONS(2406),
    [sym_identifier] = ACTIONS(2408),
    [anon_sym_SEMI] = ACTIONS(2406),
    [anon_sym_macro_rules_BANG] = ACTIONS(2406),
    [anon_sym_LPAREN] = ACTIONS(2406),
    [anon_sym_LBRACK] = ACTIONS(2406),
    [anon_sym_LBRACE] = ACTIONS(2406),
    [anon_sym_RBRACE] = ACTIONS(2406),
    [anon_sym_STAR] = ACTIONS(2406),
    [anon_sym_u8] = ACTIONS(2408),
    [anon_sym_i8] = ACTIONS(2408),
    [anon_sym_u16] = ACTIONS(2408),
    [anon_sym_i16] = ACTIONS(2408),
    [anon_sym_u32] = ACTIONS(2408),
    [anon_sym_i32] = ACTIONS(2408),
    [anon_sym_u64] = ACTIONS(2408),
    [anon_sym_i64] = ACTIONS(2408),
    [anon_sym_u128] = ACTIONS(2408),
    [anon_sym_i128] = ACTIONS(2408),
    [anon_sym_isize] = ACTIONS(2408),
    [anon_sym_usize] = ACTIONS(2408),
    [anon_sym_f32] = ACTIONS(2408),
    [anon_sym_f64] = ACTIONS(2408),
    [anon_sym_bool] = ACTIONS(2408),
    [anon_sym_str] = ACTIONS(2408),
    [anon_sym_char] = ACTIONS(2408),
    [anon_sym_DASH] = ACTIONS(2406),
    [anon_sym_BANG] = ACTIONS(2406),
    [anon_sym_AMP] = ACTIONS(2406),
    [anon_sym_PIPE] = ACTIONS(2406),
    [anon_sym_LT] = ACTIONS(2406),
    [anon_sym_DOT_DOT] = ACTIONS(2406),
    [anon_sym_COLON_COLON] = ACTIONS(2406),
    [anon_sym_POUND] = ACTIONS(2406),
    [anon_sym_SQUOTE] = ACTIONS(2408),
    [anon_sym_async] = ACTIONS(2408),
    [anon_sym_break] = ACTIONS(2408),
    [anon_sym_const] = ACTIONS(2408),
    [anon_sym_continue] = ACTIONS(2408),
    [anon_sym_default] = ACTIONS(2408),
    [anon_sym_enum] = ACTIONS(2408),
    [anon_sym_fn] = ACTIONS(2408),
    [anon_sym_for] = ACTIONS(2408),
    [anon_sym_if] = ACTIONS(2408),
    [anon_sym_impl] = ACTIONS(2408),
    [anon_sym_let] = ACTIONS(2408),
    [anon_sym_loop] = ACTIONS(2408),
    [anon_sym_match] = ACTIONS(2408),
    [anon_sym_mod] = ACTIONS(2408),
    [anon_sym_pub] = ACTIONS(2408),
    [anon_sym_return] = ACTIONS(2408),
    [anon_sym_static] = ACTIONS(2408),
    [anon_sym_struct] = ACTIONS(2408),
    [anon_sym_trait] = ACTIONS(2408),
    [anon_sym_type] = ACTIONS(2408),
    [anon_sym_union] = ACTIONS(2408),
    [anon_sym_unsafe] = ACTIONS(2408),
    [anon_sym_use] = ACTIONS(2408),
    [anon_sym_while] = ACTIONS(2408),
    [anon_sym_extern] = ACTIONS(2408),
    [anon_sym_yield] = ACTIONS(2408),
    [anon_sym_move] = ACTIONS(2408),
    [anon_sym_try] = ACTIONS(2408),
    [sym_integer_literal] = ACTIONS(2406),
    [aux_sym_string_literal_token1] = ACTIONS(2406),
    [sym_char_literal] = ACTIONS(2406),
    [anon_sym_true] = ACTIONS(2408),
    [anon_sym_false] = ACTIONS(2408),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2408),
    [sym_super] = ACTIONS(2408),
    [sym_crate] = ACTIONS(2408),
    [sym_metavariable] = ACTIONS(2406),
    [sym__raw_string_literal_start] = ACTIONS(2406),
    [sym_float_literal] = ACTIONS(2406),
  },
  [642] = {
    [sym_line_comment] = STATE(642),
    [sym_block_comment] = STATE(642),
    [ts_builtin_sym_end] = ACTIONS(2410),
    [sym_identifier] = ACTIONS(2412),
    [anon_sym_SEMI] = ACTIONS(2410),
    [anon_sym_macro_rules_BANG] = ACTIONS(2410),
    [anon_sym_LPAREN] = ACTIONS(2410),
    [anon_sym_LBRACK] = ACTIONS(2410),
    [anon_sym_LBRACE] = ACTIONS(2410),
    [anon_sym_RBRACE] = ACTIONS(2410),
    [anon_sym_STAR] = ACTIONS(2410),
    [anon_sym_u8] = ACTIONS(2412),
    [anon_sym_i8] = ACTIONS(2412),
    [anon_sym_u16] = ACTIONS(2412),
    [anon_sym_i16] = ACTIONS(2412),
    [anon_sym_u32] = ACTIONS(2412),
    [anon_sym_i32] = ACTIONS(2412),
    [anon_sym_u64] = ACTIONS(2412),
    [anon_sym_i64] = ACTIONS(2412),
    [anon_sym_u128] = ACTIONS(2412),
    [anon_sym_i128] = ACTIONS(2412),
    [anon_sym_isize] = ACTIONS(2412),
    [anon_sym_usize] = ACTIONS(2412),
    [anon_sym_f32] = ACTIONS(2412),
    [anon_sym_f64] = ACTIONS(2412),
    [anon_sym_bool] = ACTIONS(2412),
    [anon_sym_str] = ACTIONS(2412),
    [anon_sym_char] = ACTIONS(2412),
    [anon_sym_DASH] = ACTIONS(2410),
    [anon_sym_BANG] = ACTIONS(2410),
    [anon_sym_AMP] = ACTIONS(2410),
    [anon_sym_PIPE] = ACTIONS(2410),
    [anon_sym_LT] = ACTIONS(2410),
    [anon_sym_DOT_DOT] = ACTIONS(2410),
    [anon_sym_COLON_COLON] = ACTIONS(2410),
    [anon_sym_POUND] = ACTIONS(2410),
    [anon_sym_SQUOTE] = ACTIONS(2412),
    [anon_sym_async] = ACTIONS(2412),
    [anon_sym_break] = ACTIONS(2412),
    [anon_sym_const] = ACTIONS(2412),
    [anon_sym_continue] = ACTIONS(2412),
    [anon_sym_default] = ACTIONS(2412),
    [anon_sym_enum] = ACTIONS(2412),
    [anon_sym_fn] = ACTIONS(2412),
    [anon_sym_for] = ACTIONS(2412),
    [anon_sym_if] = ACTIONS(2412),
    [anon_sym_impl] = ACTIONS(2412),
    [anon_sym_let] = ACTIONS(2412),
    [anon_sym_loop] = ACTIONS(2412),
    [anon_sym_match] = ACTIONS(2412),
    [anon_sym_mod] = ACTIONS(2412),
    [anon_sym_pub] = ACTIONS(2412),
    [anon_sym_return] = ACTIONS(2412),
    [anon_sym_static] = ACTIONS(2412),
    [anon_sym_struct] = ACTIONS(2412),
    [anon_sym_trait] = ACTIONS(2412),
    [anon_sym_type] = ACTIONS(2412),
    [anon_sym_union] = ACTIONS(2412),
    [anon_sym_unsafe] = ACTIONS(2412),
    [anon_sym_use] = ACTIONS(2412),
    [anon_sym_while] = ACTIONS(2412),
    [anon_sym_extern] = ACTIONS(2412),
    [anon_sym_yield] = ACTIONS(2412),
    [anon_sym_move] = ACTIONS(2412),
    [anon_sym_try] = ACTIONS(2412),
    [sym_integer_literal] = ACTIONS(2410),
    [aux_sym_string_literal_token1] = ACTIONS(2410),
    [sym_char_literal] = ACTIONS(2410),
    [anon_sym_true] = ACTIONS(2412),
    [anon_sym_false] = ACTIONS(2412),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2412),
    [sym_super] = ACTIONS(2412),
    [sym_crate] = ACTIONS(2412),
    [sym_metavariable] = ACTIONS(2410),
    [sym__raw_string_literal_start] = ACTIONS(2410),
    [sym_float_literal] = ACTIONS(2410),
  },
  [643] = {
    [sym_line_comment] = STATE(643),
    [sym_block_comment] = STATE(643),
    [ts_builtin_sym_end] = ACTIONS(2414),
    [sym_identifier] = ACTIONS(2416),
    [anon_sym_SEMI] = ACTIONS(2414),
    [anon_sym_macro_rules_BANG] = ACTIONS(2414),
    [anon_sym_LPAREN] = ACTIONS(2414),
    [anon_sym_LBRACK] = ACTIONS(2414),
    [anon_sym_LBRACE] = ACTIONS(2414),
    [anon_sym_RBRACE] = ACTIONS(2414),
    [anon_sym_STAR] = ACTIONS(2414),
    [anon_sym_u8] = ACTIONS(2416),
    [anon_sym_i8] = ACTIONS(2416),
    [anon_sym_u16] = ACTIONS(2416),
    [anon_sym_i16] = ACTIONS(2416),
    [anon_sym_u32] = ACTIONS(2416),
    [anon_sym_i32] = ACTIONS(2416),
    [anon_sym_u64] = ACTIONS(2416),
    [anon_sym_i64] = ACTIONS(2416),
    [anon_sym_u128] = ACTIONS(2416),
    [anon_sym_i128] = ACTIONS(2416),
    [anon_sym_isize] = ACTIONS(2416),
    [anon_sym_usize] = ACTIONS(2416),
    [anon_sym_f32] = ACTIONS(2416),
    [anon_sym_f64] = ACTIONS(2416),
    [anon_sym_bool] = ACTIONS(2416),
    [anon_sym_str] = ACTIONS(2416),
    [anon_sym_char] = ACTIONS(2416),
    [anon_sym_DASH] = ACTIONS(2414),
    [anon_sym_BANG] = ACTIONS(2414),
    [anon_sym_AMP] = ACTIONS(2414),
    [anon_sym_PIPE] = ACTIONS(2414),
    [anon_sym_LT] = ACTIONS(2414),
    [anon_sym_DOT_DOT] = ACTIONS(2414),
    [anon_sym_COLON_COLON] = ACTIONS(2414),
    [anon_sym_POUND] = ACTIONS(2414),
    [anon_sym_SQUOTE] = ACTIONS(2416),
    [anon_sym_async] = ACTIONS(2416),
    [anon_sym_break] = ACTIONS(2416),
    [anon_sym_const] = ACTIONS(2416),
    [anon_sym_continue] = ACTIONS(2416),
    [anon_sym_default] = ACTIONS(2416),
    [anon_sym_enum] = ACTIONS(2416),
    [anon_sym_fn] = ACTIONS(2416),
    [anon_sym_for] = ACTIONS(2416),
    [anon_sym_if] = ACTIONS(2416),
    [anon_sym_impl] = ACTIONS(2416),
    [anon_sym_let] = ACTIONS(2416),
    [anon_sym_loop] = ACTIONS(2416),
    [anon_sym_match] = ACTIONS(2416),
    [anon_sym_mod] = ACTIONS(2416),
    [anon_sym_pub] = ACTIONS(2416),
    [anon_sym_return] = ACTIONS(2416),
    [anon_sym_static] = ACTIONS(2416),
    [anon_sym_struct] = ACTIONS(2416),
    [anon_sym_trait] = ACTIONS(2416),
    [anon_sym_type] = ACTIONS(2416),
    [anon_sym_union] = ACTIONS(2416),
    [anon_sym_unsafe] = ACTIONS(2416),
    [anon_sym_use] = ACTIONS(2416),
    [anon_sym_while] = ACTIONS(2416),
    [anon_sym_extern] = ACTIONS(2416),
    [anon_sym_yield] = ACTIONS(2416),
    [anon_sym_move] = ACTIONS(2416),
    [anon_sym_try] = ACTIONS(2416),
    [sym_integer_literal] = ACTIONS(2414),
    [aux_sym_string_literal_token1] = ACTIONS(2414),
    [sym_char_literal] = ACTIONS(2414),
    [anon_sym_true] = ACTIONS(2416),
    [anon_sym_false] = ACTIONS(2416),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2416),
    [sym_super] = ACTIONS(2416),
    [sym_crate] = ACTIONS(2416),
    [sym_metavariable] = ACTIONS(2414),
    [sym__raw_string_literal_start] = ACTIONS(2414),
    [sym_float_literal] = ACTIONS(2414),
  },
  [644] = {
    [sym_line_comment] = STATE(644),
    [sym_block_comment] = STATE(644),
    [ts_builtin_sym_end] = ACTIONS(2418),
    [sym_identifier] = ACTIONS(2420),
    [anon_sym_SEMI] = ACTIONS(2418),
    [anon_sym_macro_rules_BANG] = ACTIONS(2418),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(2418),
    [anon_sym_LBRACE] = ACTIONS(2418),
    [anon_sym_RBRACE] = ACTIONS(2418),
    [anon_sym_STAR] = ACTIONS(2418),
    [anon_sym_u8] = ACTIONS(2420),
    [anon_sym_i8] = ACTIONS(2420),
    [anon_sym_u16] = ACTIONS(2420),
    [anon_sym_i16] = ACTIONS(2420),
    [anon_sym_u32] = ACTIONS(2420),
    [anon_sym_i32] = ACTIONS(2420),
    [anon_sym_u64] = ACTIONS(2420),
    [anon_sym_i64] = ACTIONS(2420),
    [anon_sym_u128] = ACTIONS(2420),
    [anon_sym_i128] = ACTIONS(2420),
    [anon_sym_isize] = ACTIONS(2420),
    [anon_sym_usize] = ACTIONS(2420),
    [anon_sym_f32] = ACTIONS(2420),
    [anon_sym_f64] = ACTIONS(2420),
    [anon_sym_bool] = ACTIONS(2420),
    [anon_sym_str] = ACTIONS(2420),
    [anon_sym_char] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_BANG] = ACTIONS(2418),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_PIPE] = ACTIONS(2418),
    [anon_sym_LT] = ACTIONS(2418),
    [anon_sym_DOT_DOT] = ACTIONS(2418),
    [anon_sym_COLON_COLON] = ACTIONS(2418),
    [anon_sym_POUND] = ACTIONS(2418),
    [anon_sym_SQUOTE] = ACTIONS(2420),
    [anon_sym_async] = ACTIONS(2420),
    [anon_sym_break] = ACTIONS(2420),
    [anon_sym_const] = ACTIONS(2420),
    [anon_sym_continue] = ACTIONS(2420),
    [anon_sym_default] = ACTIONS(2420),
    [anon_sym_enum] = ACTIONS(2420),
    [anon_sym_fn] = ACTIONS(2420),
    [anon_sym_for] = ACTIONS(2420),
    [anon_sym_if] = ACTIONS(2420),
    [anon_sym_impl] = ACTIONS(2420),
    [anon_sym_let] = ACTIONS(2420),
    [anon_sym_loop] = ACTIONS(2420),
    [anon_sym_match] = ACTIONS(2420),
    [anon_sym_mod] = ACTIONS(2420),
    [anon_sym_pub] = ACTIONS(2420),
    [anon_sym_return] = ACTIONS(2420),
    [anon_sym_static] = ACTIONS(2420),
    [anon_sym_struct] = ACTIONS(2420),
    [anon_sym_trait] = ACTIONS(2420),
    [anon_sym_type] = ACTIONS(2420),
    [anon_sym_union] = ACTIONS(2420),
    [anon_sym_unsafe] = ACTIONS(2420),
    [anon_sym_use] = ACTIONS(2420),
    [anon_sym_while] = ACTIONS(2420),
    [anon_sym_extern] = ACTIONS(2420),
    [anon_sym_yield] = ACTIONS(2420),
    [anon_sym_move] = ACTIONS(2420),
    [anon_sym_try] = ACTIONS(2420),
    [sym_integer_literal] = ACTIONS(2418),
    [aux_sym_string_literal_token1] = ACTIONS(2418),
    [sym_char_literal] = ACTIONS(2418),
    [anon_sym_true] = ACTIONS(2420),
    [anon_sym_false] = ACTIONS(2420),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2420),
    [sym_super] = ACTIONS(2420),
    [sym_crate] = ACTIONS(2420),
    [sym_metavariable] = ACTIONS(2418),
    [sym__raw_string_literal_start] = ACTIONS(2418),
    [sym_float_literal] = ACTIONS(2418),
  },
  [645] = {
    [sym_line_comment] = STATE(645),
    [sym_block_comment] = STATE(645),
    [ts_builtin_sym_end] = ACTIONS(2422),
    [sym_identifier] = ACTIONS(2424),
    [anon_sym_SEMI] = ACTIONS(2422),
    [anon_sym_macro_rules_BANG] = ACTIONS(2422),
    [anon_sym_LPAREN] = ACTIONS(2422),
    [anon_sym_LBRACK] = ACTIONS(2422),
    [anon_sym_LBRACE] = ACTIONS(2422),
    [anon_sym_RBRACE] = ACTIONS(2422),
    [anon_sym_STAR] = ACTIONS(2422),
    [anon_sym_u8] = ACTIONS(2424),
    [anon_sym_i8] = ACTIONS(2424),
    [anon_sym_u16] = ACTIONS(2424),
    [anon_sym_i16] = ACTIONS(2424),
    [anon_sym_u32] = ACTIONS(2424),
    [anon_sym_i32] = ACTIONS(2424),
    [anon_sym_u64] = ACTIONS(2424),
    [anon_sym_i64] = ACTIONS(2424),
    [anon_sym_u128] = ACTIONS(2424),
    [anon_sym_i128] = ACTIONS(2424),
    [anon_sym_isize] = ACTIONS(2424),
    [anon_sym_usize] = ACTIONS(2424),
    [anon_sym_f32] = ACTIONS(2424),
    [anon_sym_f64] = ACTIONS(2424),
    [anon_sym_bool] = ACTIONS(2424),
    [anon_sym_str] = ACTIONS(2424),
    [anon_sym_char] = ACTIONS(2424),
    [anon_sym_DASH] = ACTIONS(2422),
    [anon_sym_BANG] = ACTIONS(2422),
    [anon_sym_AMP] = ACTIONS(2422),
    [anon_sym_PIPE] = ACTIONS(2422),
    [anon_sym_LT] = ACTIONS(2422),
    [anon_sym_DOT_DOT] = ACTIONS(2422),
    [anon_sym_COLON_COLON] = ACTIONS(2422),
    [anon_sym_POUND] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [anon_sym_async] = ACTIONS(2424),
    [anon_sym_break] = ACTIONS(2424),
    [anon_sym_const] = ACTIONS(2424),
    [anon_sym_continue] = ACTIONS(2424),
    [anon_sym_default] = ACTIONS(2424),
    [anon_sym_enum] = ACTIONS(2424),
    [anon_sym_fn] = ACTIONS(2424),
    [anon_sym_for] = ACTIONS(2424),
    [anon_sym_if] = ACTIONS(2424),
    [anon_sym_impl] = ACTIONS(2424),
    [anon_sym_let] = ACTIONS(2424),
    [anon_sym_loop] = ACTIONS(2424),
    [anon_sym_match] = ACTIONS(2424),
    [anon_sym_mod] = ACTIONS(2424),
    [anon_sym_pub] = ACTIONS(2424),
    [anon_sym_return] = ACTIONS(2424),
    [anon_sym_static] = ACTIONS(2424),
    [anon_sym_struct] = ACTIONS(2424),
    [anon_sym_trait] = ACTIONS(2424),
    [anon_sym_type] = ACTIONS(2424),
    [anon_sym_union] = ACTIONS(2424),
    [anon_sym_unsafe] = ACTIONS(2424),
    [anon_sym_use] = ACTIONS(2424),
    [anon_sym_while] = ACTIONS(2424),
    [anon_sym_extern] = ACTIONS(2424),
    [anon_sym_yield] = ACTIONS(2424),
    [anon_sym_move] = ACTIONS(2424),
    [anon_sym_try] = ACTIONS(2424),
    [sym_integer_literal] = ACTIONS(2422),
    [aux_sym_string_literal_token1] = ACTIONS(2422),
    [sym_char_literal] = ACTIONS(2422),
    [anon_sym_true] = ACTIONS(2424),
    [anon_sym_false] = ACTIONS(2424),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2424),
    [sym_super] = ACTIONS(2424),
    [sym_crate] = ACTIONS(2424),
    [sym_metavariable] = ACTIONS(2422),
    [sym__raw_string_literal_start] = ACTIONS(2422),
    [sym_float_literal] = ACTIONS(2422),
  },
  [646] = {
    [sym_line_comment] = STATE(646),
    [sym_block_comment] = STATE(646),
    [ts_builtin_sym_end] = ACTIONS(2426),
    [sym_identifier] = ACTIONS(2428),
    [anon_sym_SEMI] = ACTIONS(2426),
    [anon_sym_macro_rules_BANG] = ACTIONS(2426),
    [anon_sym_LPAREN] = ACTIONS(2426),
    [anon_sym_LBRACK] = ACTIONS(2426),
    [anon_sym_LBRACE] = ACTIONS(2426),
    [anon_sym_RBRACE] = ACTIONS(2426),
    [anon_sym_STAR] = ACTIONS(2426),
    [anon_sym_u8] = ACTIONS(2428),
    [anon_sym_i8] = ACTIONS(2428),
    [anon_sym_u16] = ACTIONS(2428),
    [anon_sym_i16] = ACTIONS(2428),
    [anon_sym_u32] = ACTIONS(2428),
    [anon_sym_i32] = ACTIONS(2428),
    [anon_sym_u64] = ACTIONS(2428),
    [anon_sym_i64] = ACTIONS(2428),
    [anon_sym_u128] = ACTIONS(2428),
    [anon_sym_i128] = ACTIONS(2428),
    [anon_sym_isize] = ACTIONS(2428),
    [anon_sym_usize] = ACTIONS(2428),
    [anon_sym_f32] = ACTIONS(2428),
    [anon_sym_f64] = ACTIONS(2428),
    [anon_sym_bool] = ACTIONS(2428),
    [anon_sym_str] = ACTIONS(2428),
    [anon_sym_char] = ACTIONS(2428),
    [anon_sym_DASH] = ACTIONS(2426),
    [anon_sym_BANG] = ACTIONS(2426),
    [anon_sym_AMP] = ACTIONS(2426),
    [anon_sym_PIPE] = ACTIONS(2426),
    [anon_sym_LT] = ACTIONS(2426),
    [anon_sym_DOT_DOT] = ACTIONS(2426),
    [anon_sym_COLON_COLON] = ACTIONS(2426),
    [anon_sym_POUND] = ACTIONS(2426),
    [anon_sym_SQUOTE] = ACTIONS(2428),
    [anon_sym_async] = ACTIONS(2428),
    [anon_sym_break] = ACTIONS(2428),
    [anon_sym_const] = ACTIONS(2428),
    [anon_sym_continue] = ACTIONS(2428),
    [anon_sym_default] = ACTIONS(2428),
    [anon_sym_enum] = ACTIONS(2428),
    [anon_sym_fn] = ACTIONS(2428),
    [anon_sym_for] = ACTIONS(2428),
    [anon_sym_if] = ACTIONS(2428),
    [anon_sym_impl] = ACTIONS(2428),
    [anon_sym_let] = ACTIONS(2428),
    [anon_sym_loop] = ACTIONS(2428),
    [anon_sym_match] = ACTIONS(2428),
    [anon_sym_mod] = ACTIONS(2428),
    [anon_sym_pub] = ACTIONS(2428),
    [anon_sym_return] = ACTIONS(2428),
    [anon_sym_static] = ACTIONS(2428),
    [anon_sym_struct] = ACTIONS(2428),
    [anon_sym_trait] = ACTIONS(2428),
    [anon_sym_type] = ACTIONS(2428),
    [anon_sym_union] = ACTIONS(2428),
    [anon_sym_unsafe] = ACTIONS(2428),
    [anon_sym_use] = ACTIONS(2428),
    [anon_sym_while] = ACTIONS(2428),
    [anon_sym_extern] = ACTIONS(2428),
    [anon_sym_yield] = ACTIONS(2428),
    [anon_sym_move] = ACTIONS(2428),
    [anon_sym_try] = ACTIONS(2428),
    [sym_integer_literal] = ACTIONS(2426),
    [aux_sym_string_literal_token1] = ACTIONS(2426),
    [sym_char_literal] = ACTIONS(2426),
    [anon_sym_true] = ACTIONS(2428),
    [anon_sym_false] = ACTIONS(2428),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2428),
    [sym_super] = ACTIONS(2428),
    [sym_crate] = ACTIONS(2428),
    [sym_metavariable] = ACTIONS(2426),
    [sym__raw_string_literal_start] = ACTIONS(2426),
    [sym_float_literal] = ACTIONS(2426),
  },
  [647] = {
    [sym_line_comment] = STATE(647),
    [sym_block_comment] = STATE(647),
    [ts_builtin_sym_end] = ACTIONS(2430),
    [sym_identifier] = ACTIONS(2432),
    [anon_sym_SEMI] = ACTIONS(2430),
    [anon_sym_macro_rules_BANG] = ACTIONS(2430),
    [anon_sym_LPAREN] = ACTIONS(2430),
    [anon_sym_LBRACK] = ACTIONS(2430),
    [anon_sym_LBRACE] = ACTIONS(2430),
    [anon_sym_RBRACE] = ACTIONS(2430),
    [anon_sym_STAR] = ACTIONS(2430),
    [anon_sym_u8] = ACTIONS(2432),
    [anon_sym_i8] = ACTIONS(2432),
    [anon_sym_u16] = ACTIONS(2432),
    [anon_sym_i16] = ACTIONS(2432),
    [anon_sym_u32] = ACTIONS(2432),
    [anon_sym_i32] = ACTIONS(2432),
    [anon_sym_u64] = ACTIONS(2432),
    [anon_sym_i64] = ACTIONS(2432),
    [anon_sym_u128] = ACTIONS(2432),
    [anon_sym_i128] = ACTIONS(2432),
    [anon_sym_isize] = ACTIONS(2432),
    [anon_sym_usize] = ACTIONS(2432),
    [anon_sym_f32] = ACTIONS(2432),
    [anon_sym_f64] = ACTIONS(2432),
    [anon_sym_bool] = ACTIONS(2432),
    [anon_sym_str] = ACTIONS(2432),
    [anon_sym_char] = ACTIONS(2432),
    [anon_sym_DASH] = ACTIONS(2430),
    [anon_sym_BANG] = ACTIONS(2430),
    [anon_sym_AMP] = ACTIONS(2430),
    [anon_sym_PIPE] = ACTIONS(2430),
    [anon_sym_LT] = ACTIONS(2430),
    [anon_sym_DOT_DOT] = ACTIONS(2430),
    [anon_sym_COLON_COLON] = ACTIONS(2430),
    [anon_sym_POUND] = ACTIONS(2430),
    [anon_sym_SQUOTE] = ACTIONS(2432),
    [anon_sym_async] = ACTIONS(2432),
    [anon_sym_break] = ACTIONS(2432),
    [anon_sym_const] = ACTIONS(2432),
    [anon_sym_continue] = ACTIONS(2432),
    [anon_sym_default] = ACTIONS(2432),
    [anon_sym_enum] = ACTIONS(2432),
    [anon_sym_fn] = ACTIONS(2432),
    [anon_sym_for] = ACTIONS(2432),
    [anon_sym_if] = ACTIONS(2432),
    [anon_sym_impl] = ACTIONS(2432),
    [anon_sym_let] = ACTIONS(2432),
    [anon_sym_loop] = ACTIONS(2432),
    [anon_sym_match] = ACTIONS(2432),
    [anon_sym_mod] = ACTIONS(2432),
    [anon_sym_pub] = ACTIONS(2432),
    [anon_sym_return] = ACTIONS(2432),
    [anon_sym_static] = ACTIONS(2432),
    [anon_sym_struct] = ACTIONS(2432),
    [anon_sym_trait] = ACTIONS(2432),
    [anon_sym_type] = ACTIONS(2432),
    [anon_sym_union] = ACTIONS(2432),
    [anon_sym_unsafe] = ACTIONS(2432),
    [anon_sym_use] = ACTIONS(2432),
    [anon_sym_while] = ACTIONS(2432),
    [anon_sym_extern] = ACTIONS(2432),
    [anon_sym_yield] = ACTIONS(2432),
    [anon_sym_move] = ACTIONS(2432),
    [anon_sym_try] = ACTIONS(2432),
    [sym_integer_literal] = ACTIONS(2430),
    [aux_sym_string_literal_token1] = ACTIONS(2430),
    [sym_char_literal] = ACTIONS(2430),
    [anon_sym_true] = ACTIONS(2432),
    [anon_sym_false] = ACTIONS(2432),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2432),
    [sym_super] = ACTIONS(2432),
    [sym_crate] = ACTIONS(2432),
    [sym_metavariable] = ACTIONS(2430),
    [sym__raw_string_literal_start] = ACTIONS(2430),
    [sym_float_literal] = ACTIONS(2430),
  },
  [648] = {
    [sym_line_comment] = STATE(648),
    [sym_block_comment] = STATE(648),
    [ts_builtin_sym_end] = ACTIONS(2434),
    [sym_identifier] = ACTIONS(2436),
    [anon_sym_SEMI] = ACTIONS(2434),
    [anon_sym_macro_rules_BANG] = ACTIONS(2434),
    [anon_sym_LPAREN] = ACTIONS(2434),
    [anon_sym_LBRACK] = ACTIONS(2434),
    [anon_sym_LBRACE] = ACTIONS(2434),
    [anon_sym_RBRACE] = ACTIONS(2434),
    [anon_sym_STAR] = ACTIONS(2434),
    [anon_sym_u8] = ACTIONS(2436),
    [anon_sym_i8] = ACTIONS(2436),
    [anon_sym_u16] = ACTIONS(2436),
    [anon_sym_i16] = ACTIONS(2436),
    [anon_sym_u32] = ACTIONS(2436),
    [anon_sym_i32] = ACTIONS(2436),
    [anon_sym_u64] = ACTIONS(2436),
    [anon_sym_i64] = ACTIONS(2436),
    [anon_sym_u128] = ACTIONS(2436),
    [anon_sym_i128] = ACTIONS(2436),
    [anon_sym_isize] = ACTIONS(2436),
    [anon_sym_usize] = ACTIONS(2436),
    [anon_sym_f32] = ACTIONS(2436),
    [anon_sym_f64] = ACTIONS(2436),
    [anon_sym_bool] = ACTIONS(2436),
    [anon_sym_str] = ACTIONS(2436),
    [anon_sym_char] = ACTIONS(2436),
    [anon_sym_DASH] = ACTIONS(2434),
    [anon_sym_BANG] = ACTIONS(2434),
    [anon_sym_AMP] = ACTIONS(2434),
    [anon_sym_PIPE] = ACTIONS(2434),
    [anon_sym_LT] = ACTIONS(2434),
    [anon_sym_DOT_DOT] = ACTIONS(2434),
    [anon_sym_COLON_COLON] = ACTIONS(2434),
    [anon_sym_POUND] = ACTIONS(2434),
    [anon_sym_SQUOTE] = ACTIONS(2436),
    [anon_sym_async] = ACTIONS(2436),
    [anon_sym_break] = ACTIONS(2436),
    [anon_sym_const] = ACTIONS(2436),
    [anon_sym_continue] = ACTIONS(2436),
    [anon_sym_default] = ACTIONS(2436),
    [anon_sym_enum] = ACTIONS(2436),
    [anon_sym_fn] = ACTIONS(2436),
    [anon_sym_for] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(2436),
    [anon_sym_impl] = ACTIONS(2436),
    [anon_sym_let] = ACTIONS(2436),
    [anon_sym_loop] = ACTIONS(2436),
    [anon_sym_match] = ACTIONS(2436),
    [anon_sym_mod] = ACTIONS(2436),
    [anon_sym_pub] = ACTIONS(2436),
    [anon_sym_return] = ACTIONS(2436),
    [anon_sym_static] = ACTIONS(2436),
    [anon_sym_struct] = ACTIONS(2436),
    [anon_sym_trait] = ACTIONS(2436),
    [anon_sym_type] = ACTIONS(2436),
    [anon_sym_union] = ACTIONS(2436),
    [anon_sym_unsafe] = ACTIONS(2436),
    [anon_sym_use] = ACTIONS(2436),
    [anon_sym_while] = ACTIONS(2436),
    [anon_sym_extern] = ACTIONS(2436),
    [anon_sym_yield] = ACTIONS(2436),
    [anon_sym_move] = ACTIONS(2436),
    [anon_sym_try] = ACTIONS(2436),
    [sym_integer_literal] = ACTIONS(2434),
    [aux_sym_string_literal_token1] = ACTIONS(2434),
    [sym_char_literal] = ACTIONS(2434),
    [anon_sym_true] = ACTIONS(2436),
    [anon_sym_false] = ACTIONS(2436),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2436),
    [sym_super] = ACTIONS(2436),
    [sym_crate] = ACTIONS(2436),
    [sym_metavariable] = ACTIONS(2434),
    [sym__raw_string_literal_start] = ACTIONS(2434),
    [sym_float_literal] = ACTIONS(2434),
  },
  [649] = {
    [sym_line_comment] = STATE(649),
    [sym_block_comment] = STATE(649),
    [ts_builtin_sym_end] = ACTIONS(2438),
    [sym_identifier] = ACTIONS(2440),
    [anon_sym_SEMI] = ACTIONS(2438),
    [anon_sym_macro_rules_BANG] = ACTIONS(2438),
    [anon_sym_LPAREN] = ACTIONS(2438),
    [anon_sym_LBRACK] = ACTIONS(2438),
    [anon_sym_LBRACE] = ACTIONS(2438),
    [anon_sym_RBRACE] = ACTIONS(2438),
    [anon_sym_STAR] = ACTIONS(2438),
    [anon_sym_u8] = ACTIONS(2440),
    [anon_sym_i8] = ACTIONS(2440),
    [anon_sym_u16] = ACTIONS(2440),
    [anon_sym_i16] = ACTIONS(2440),
    [anon_sym_u32] = ACTIONS(2440),
    [anon_sym_i32] = ACTIONS(2440),
    [anon_sym_u64] = ACTIONS(2440),
    [anon_sym_i64] = ACTIONS(2440),
    [anon_sym_u128] = ACTIONS(2440),
    [anon_sym_i128] = ACTIONS(2440),
    [anon_sym_isize] = ACTIONS(2440),
    [anon_sym_usize] = ACTIONS(2440),
    [anon_sym_f32] = ACTIONS(2440),
    [anon_sym_f64] = ACTIONS(2440),
    [anon_sym_bool] = ACTIONS(2440),
    [anon_sym_str] = ACTIONS(2440),
    [anon_sym_char] = ACTIONS(2440),
    [anon_sym_DASH] = ACTIONS(2438),
    [anon_sym_BANG] = ACTIONS(2438),
    [anon_sym_AMP] = ACTIONS(2438),
    [anon_sym_PIPE] = ACTIONS(2438),
    [anon_sym_LT] = ACTIONS(2438),
    [anon_sym_DOT_DOT] = ACTIONS(2438),
    [anon_sym_COLON_COLON] = ACTIONS(2438),
    [anon_sym_POUND] = ACTIONS(2438),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_async] = ACTIONS(2440),
    [anon_sym_break] = ACTIONS(2440),
    [anon_sym_const] = ACTIONS(2440),
    [anon_sym_continue] = ACTIONS(2440),
    [anon_sym_default] = ACTIONS(2440),
    [anon_sym_enum] = ACTIONS(2440),
    [anon_sym_fn] = ACTIONS(2440),
    [anon_sym_for] = ACTIONS(2440),
    [anon_sym_if] = ACTIONS(2440),
    [anon_sym_impl] = ACTIONS(2440),
    [anon_sym_let] = ACTIONS(2440),
    [anon_sym_loop] = ACTIONS(2440),
    [anon_sym_match] = ACTIONS(2440),
    [anon_sym_mod] = ACTIONS(2440),
    [anon_sym_pub] = ACTIONS(2440),
    [anon_sym_return] = ACTIONS(2440),
    [anon_sym_static] = ACTIONS(2440),
    [anon_sym_struct] = ACTIONS(2440),
    [anon_sym_trait] = ACTIONS(2440),
    [anon_sym_type] = ACTIONS(2440),
    [anon_sym_union] = ACTIONS(2440),
    [anon_sym_unsafe] = ACTIONS(2440),
    [anon_sym_use] = ACTIONS(2440),
    [anon_sym_while] = ACTIONS(2440),
    [anon_sym_extern] = ACTIONS(2440),
    [anon_sym_yield] = ACTIONS(2440),
    [anon_sym_move] = ACTIONS(2440),
    [anon_sym_try] = ACTIONS(2440),
    [sym_integer_literal] = ACTIONS(2438),
    [aux_sym_string_literal_token1] = ACTIONS(2438),
    [sym_char_literal] = ACTIONS(2438),
    [anon_sym_true] = ACTIONS(2440),
    [anon_sym_false] = ACTIONS(2440),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2440),
    [sym_super] = ACTIONS(2440),
    [sym_crate] = ACTIONS(2440),
    [sym_metavariable] = ACTIONS(2438),
    [sym__raw_string_literal_start] = ACTIONS(2438),
    [sym_float_literal] = ACTIONS(2438),
  },
  [650] = {
    [sym_line_comment] = STATE(650),
    [sym_block_comment] = STATE(650),
    [ts_builtin_sym_end] = ACTIONS(2442),
    [sym_identifier] = ACTIONS(2444),
    [anon_sym_SEMI] = ACTIONS(2442),
    [anon_sym_macro_rules_BANG] = ACTIONS(2442),
    [anon_sym_LPAREN] = ACTIONS(2442),
    [anon_sym_LBRACK] = ACTIONS(2442),
    [anon_sym_LBRACE] = ACTIONS(2442),
    [anon_sym_RBRACE] = ACTIONS(2442),
    [anon_sym_STAR] = ACTIONS(2442),
    [anon_sym_u8] = ACTIONS(2444),
    [anon_sym_i8] = ACTIONS(2444),
    [anon_sym_u16] = ACTIONS(2444),
    [anon_sym_i16] = ACTIONS(2444),
    [anon_sym_u32] = ACTIONS(2444),
    [anon_sym_i32] = ACTIONS(2444),
    [anon_sym_u64] = ACTIONS(2444),
    [anon_sym_i64] = ACTIONS(2444),
    [anon_sym_u128] = ACTIONS(2444),
    [anon_sym_i128] = ACTIONS(2444),
    [anon_sym_isize] = ACTIONS(2444),
    [anon_sym_usize] = ACTIONS(2444),
    [anon_sym_f32] = ACTIONS(2444),
    [anon_sym_f64] = ACTIONS(2444),
    [anon_sym_bool] = ACTIONS(2444),
    [anon_sym_str] = ACTIONS(2444),
    [anon_sym_char] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2442),
    [anon_sym_BANG] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2442),
    [anon_sym_PIPE] = ACTIONS(2442),
    [anon_sym_LT] = ACTIONS(2442),
    [anon_sym_DOT_DOT] = ACTIONS(2442),
    [anon_sym_COLON_COLON] = ACTIONS(2442),
    [anon_sym_POUND] = ACTIONS(2442),
    [anon_sym_SQUOTE] = ACTIONS(2444),
    [anon_sym_async] = ACTIONS(2444),
    [anon_sym_break] = ACTIONS(2444),
    [anon_sym_const] = ACTIONS(2444),
    [anon_sym_continue] = ACTIONS(2444),
    [anon_sym_default] = ACTIONS(2444),
    [anon_sym_enum] = ACTIONS(2444),
    [anon_sym_fn] = ACTIONS(2444),
    [anon_sym_for] = ACTIONS(2444),
    [anon_sym_if] = ACTIONS(2444),
    [anon_sym_impl] = ACTIONS(2444),
    [anon_sym_let] = ACTIONS(2444),
    [anon_sym_loop] = ACTIONS(2444),
    [anon_sym_match] = ACTIONS(2444),
    [anon_sym_mod] = ACTIONS(2444),
    [anon_sym_pub] = ACTIONS(2444),
    [anon_sym_return] = ACTIONS(2444),
    [anon_sym_static] = ACTIONS(2444),
    [anon_sym_struct] = ACTIONS(2444),
    [anon_sym_trait] = ACTIONS(2444),
    [anon_sym_type] = ACTIONS(2444),
    [anon_sym_union] = ACTIONS(2444),
    [anon_sym_unsafe] = ACTIONS(2444),
    [anon_sym_use] = ACTIONS(2444),
    [anon_sym_while] = ACTIONS(2444),
    [anon_sym_extern] = ACTIONS(2444),
    [anon_sym_yield] = ACTIONS(2444),
    [anon_sym_move] = ACTIONS(2444),
    [anon_sym_try] = ACTIONS(2444),
    [sym_integer_literal] = ACTIONS(2442),
    [aux_sym_string_literal_token1] = ACTIONS(2442),
    [sym_char_literal] = ACTIONS(2442),
    [anon_sym_true] = ACTIONS(2444),
    [anon_sym_false] = ACTIONS(2444),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2444),
    [sym_super] = ACTIONS(2444),
    [sym_crate] = ACTIONS(2444),
    [sym_metavariable] = ACTIONS(2442),
    [sym__raw_string_literal_start] = ACTIONS(2442),
    [sym_float_literal] = ACTIONS(2442),
  },
  [651] = {
    [sym_line_comment] = STATE(651),
    [sym_block_comment] = STATE(651),
    [ts_builtin_sym_end] = ACTIONS(2446),
    [sym_identifier] = ACTIONS(2448),
    [anon_sym_SEMI] = ACTIONS(2446),
    [anon_sym_macro_rules_BANG] = ACTIONS(2446),
    [anon_sym_LPAREN] = ACTIONS(2446),
    [anon_sym_LBRACK] = ACTIONS(2446),
    [anon_sym_LBRACE] = ACTIONS(2446),
    [anon_sym_RBRACE] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2446),
    [anon_sym_u8] = ACTIONS(2448),
    [anon_sym_i8] = ACTIONS(2448),
    [anon_sym_u16] = ACTIONS(2448),
    [anon_sym_i16] = ACTIONS(2448),
    [anon_sym_u32] = ACTIONS(2448),
    [anon_sym_i32] = ACTIONS(2448),
    [anon_sym_u64] = ACTIONS(2448),
    [anon_sym_i64] = ACTIONS(2448),
    [anon_sym_u128] = ACTIONS(2448),
    [anon_sym_i128] = ACTIONS(2448),
    [anon_sym_isize] = ACTIONS(2448),
    [anon_sym_usize] = ACTIONS(2448),
    [anon_sym_f32] = ACTIONS(2448),
    [anon_sym_f64] = ACTIONS(2448),
    [anon_sym_bool] = ACTIONS(2448),
    [anon_sym_str] = ACTIONS(2448),
    [anon_sym_char] = ACTIONS(2448),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_BANG] = ACTIONS(2446),
    [anon_sym_AMP] = ACTIONS(2446),
    [anon_sym_PIPE] = ACTIONS(2446),
    [anon_sym_LT] = ACTIONS(2446),
    [anon_sym_DOT_DOT] = ACTIONS(2446),
    [anon_sym_COLON_COLON] = ACTIONS(2446),
    [anon_sym_POUND] = ACTIONS(2446),
    [anon_sym_SQUOTE] = ACTIONS(2448),
    [anon_sym_async] = ACTIONS(2448),
    [anon_sym_break] = ACTIONS(2448),
    [anon_sym_const] = ACTIONS(2448),
    [anon_sym_continue] = ACTIONS(2448),
    [anon_sym_default] = ACTIONS(2448),
    [anon_sym_enum] = ACTIONS(2448),
    [anon_sym_fn] = ACTIONS(2448),
    [anon_sym_for] = ACTIONS(2448),
    [anon_sym_if] = ACTIONS(2448),
    [anon_sym_impl] = ACTIONS(2448),
    [anon_sym_let] = ACTIONS(2448),
    [anon_sym_loop] = ACTIONS(2448),
    [anon_sym_match] = ACTIONS(2448),
    [anon_sym_mod] = ACTIONS(2448),
    [anon_sym_pub] = ACTIONS(2448),
    [anon_sym_return] = ACTIONS(2448),
    [anon_sym_static] = ACTIONS(2448),
    [anon_sym_struct] = ACTIONS(2448),
    [anon_sym_trait] = ACTIONS(2448),
    [anon_sym_type] = ACTIONS(2448),
    [anon_sym_union] = ACTIONS(2448),
    [anon_sym_unsafe] = ACTIONS(2448),
    [anon_sym_use] = ACTIONS(2448),
    [anon_sym_while] = ACTIONS(2448),
    [anon_sym_extern] = ACTIONS(2448),
    [anon_sym_yield] = ACTIONS(2448),
    [anon_sym_move] = ACTIONS(2448),
    [anon_sym_try] = ACTIONS(2448),
    [sym_integer_literal] = ACTIONS(2446),
    [aux_sym_string_literal_token1] = ACTIONS(2446),
    [sym_char_literal] = ACTIONS(2446),
    [anon_sym_true] = ACTIONS(2448),
    [anon_sym_false] = ACTIONS(2448),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2448),
    [sym_super] = ACTIONS(2448),
    [sym_crate] = ACTIONS(2448),
    [sym_metavariable] = ACTIONS(2446),
    [sym__raw_string_literal_start] = ACTIONS(2446),
    [sym_float_literal] = ACTIONS(2446),
  },
  [652] = {
    [sym_line_comment] = STATE(652),
    [sym_block_comment] = STATE(652),
    [ts_builtin_sym_end] = ACTIONS(2450),
    [sym_identifier] = ACTIONS(2452),
    [anon_sym_SEMI] = ACTIONS(2450),
    [anon_sym_macro_rules_BANG] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(2450),
    [anon_sym_LBRACK] = ACTIONS(2450),
    [anon_sym_LBRACE] = ACTIONS(2450),
    [anon_sym_RBRACE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2450),
    [anon_sym_u8] = ACTIONS(2452),
    [anon_sym_i8] = ACTIONS(2452),
    [anon_sym_u16] = ACTIONS(2452),
    [anon_sym_i16] = ACTIONS(2452),
    [anon_sym_u32] = ACTIONS(2452),
    [anon_sym_i32] = ACTIONS(2452),
    [anon_sym_u64] = ACTIONS(2452),
    [anon_sym_i64] = ACTIONS(2452),
    [anon_sym_u128] = ACTIONS(2452),
    [anon_sym_i128] = ACTIONS(2452),
    [anon_sym_isize] = ACTIONS(2452),
    [anon_sym_usize] = ACTIONS(2452),
    [anon_sym_f32] = ACTIONS(2452),
    [anon_sym_f64] = ACTIONS(2452),
    [anon_sym_bool] = ACTIONS(2452),
    [anon_sym_str] = ACTIONS(2452),
    [anon_sym_char] = ACTIONS(2452),
    [anon_sym_DASH] = ACTIONS(2450),
    [anon_sym_BANG] = ACTIONS(2450),
    [anon_sym_AMP] = ACTIONS(2450),
    [anon_sym_PIPE] = ACTIONS(2450),
    [anon_sym_LT] = ACTIONS(2450),
    [anon_sym_DOT_DOT] = ACTIONS(2450),
    [anon_sym_COLON_COLON] = ACTIONS(2450),
    [anon_sym_POUND] = ACTIONS(2450),
    [anon_sym_SQUOTE] = ACTIONS(2452),
    [anon_sym_async] = ACTIONS(2452),
    [anon_sym_break] = ACTIONS(2452),
    [anon_sym_const] = ACTIONS(2452),
    [anon_sym_continue] = ACTIONS(2452),
    [anon_sym_default] = ACTIONS(2452),
    [anon_sym_enum] = ACTIONS(2452),
    [anon_sym_fn] = ACTIONS(2452),
    [anon_sym_for] = ACTIONS(2452),
    [anon_sym_if] = ACTIONS(2452),
    [anon_sym_impl] = ACTIONS(2452),
    [anon_sym_let] = ACTIONS(2452),
    [anon_sym_loop] = ACTIONS(2452),
    [anon_sym_match] = ACTIONS(2452),
    [anon_sym_mod] = ACTIONS(2452),
    [anon_sym_pub] = ACTIONS(2452),
    [anon_sym_return] = ACTIONS(2452),
    [anon_sym_static] = ACTIONS(2452),
    [anon_sym_struct] = ACTIONS(2452),
    [anon_sym_trait] = ACTIONS(2452),
    [anon_sym_type] = ACTIONS(2452),
    [anon_sym_union] = ACTIONS(2452),
    [anon_sym_unsafe] = ACTIONS(2452),
    [anon_sym_use] = ACTIONS(2452),
    [anon_sym_while] = ACTIONS(2452),
    [anon_sym_extern] = ACTIONS(2452),
    [anon_sym_yield] = ACTIONS(2452),
    [anon_sym_move] = ACTIONS(2452),
    [anon_sym_try] = ACTIONS(2452),
    [sym_integer_literal] = ACTIONS(2450),
    [aux_sym_string_literal_token1] = ACTIONS(2450),
    [sym_char_literal] = ACTIONS(2450),
    [anon_sym_true] = ACTIONS(2452),
    [anon_sym_false] = ACTIONS(2452),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2452),
    [sym_super] = ACTIONS(2452),
    [sym_crate] = ACTIONS(2452),
    [sym_metavariable] = ACTIONS(2450),
    [sym__raw_string_literal_start] = ACTIONS(2450),
    [sym_float_literal] = ACTIONS(2450),
  },
  [653] = {
    [sym_line_comment] = STATE(653),
    [sym_block_comment] = STATE(653),
    [ts_builtin_sym_end] = ACTIONS(2454),
    [sym_identifier] = ACTIONS(2456),
    [anon_sym_SEMI] = ACTIONS(2454),
    [anon_sym_macro_rules_BANG] = ACTIONS(2454),
    [anon_sym_LPAREN] = ACTIONS(2454),
    [anon_sym_LBRACK] = ACTIONS(2454),
    [anon_sym_LBRACE] = ACTIONS(2454),
    [anon_sym_RBRACE] = ACTIONS(2454),
    [anon_sym_STAR] = ACTIONS(2454),
    [anon_sym_u8] = ACTIONS(2456),
    [anon_sym_i8] = ACTIONS(2456),
    [anon_sym_u16] = ACTIONS(2456),
    [anon_sym_i16] = ACTIONS(2456),
    [anon_sym_u32] = ACTIONS(2456),
    [anon_sym_i32] = ACTIONS(2456),
    [anon_sym_u64] = ACTIONS(2456),
    [anon_sym_i64] = ACTIONS(2456),
    [anon_sym_u128] = ACTIONS(2456),
    [anon_sym_i128] = ACTIONS(2456),
    [anon_sym_isize] = ACTIONS(2456),
    [anon_sym_usize] = ACTIONS(2456),
    [anon_sym_f32] = ACTIONS(2456),
    [anon_sym_f64] = ACTIONS(2456),
    [anon_sym_bool] = ACTIONS(2456),
    [anon_sym_str] = ACTIONS(2456),
    [anon_sym_char] = ACTIONS(2456),
    [anon_sym_DASH] = ACTIONS(2454),
    [anon_sym_BANG] = ACTIONS(2454),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_PIPE] = ACTIONS(2454),
    [anon_sym_LT] = ACTIONS(2454),
    [anon_sym_DOT_DOT] = ACTIONS(2454),
    [anon_sym_COLON_COLON] = ACTIONS(2454),
    [anon_sym_POUND] = ACTIONS(2454),
    [anon_sym_SQUOTE] = ACTIONS(2456),
    [anon_sym_async] = ACTIONS(2456),
    [anon_sym_break] = ACTIONS(2456),
    [anon_sym_const] = ACTIONS(2456),
    [anon_sym_continue] = ACTIONS(2456),
    [anon_sym_default] = ACTIONS(2456),
    [anon_sym_enum] = ACTIONS(2456),
    [anon_sym_fn] = ACTIONS(2456),
    [anon_sym_for] = ACTIONS(2456),
    [anon_sym_if] = ACTIONS(2456),
    [anon_sym_impl] = ACTIONS(2456),
    [anon_sym_let] = ACTIONS(2456),
    [anon_sym_loop] = ACTIONS(2456),
    [anon_sym_match] = ACTIONS(2456),
    [anon_sym_mod] = ACTIONS(2456),
    [anon_sym_pub] = ACTIONS(2456),
    [anon_sym_return] = ACTIONS(2456),
    [anon_sym_static] = ACTIONS(2456),
    [anon_sym_struct] = ACTIONS(2456),
    [anon_sym_trait] = ACTIONS(2456),
    [anon_sym_type] = ACTIONS(2456),
    [anon_sym_union] = ACTIONS(2456),
    [anon_sym_unsafe] = ACTIONS(2456),
    [anon_sym_use] = ACTIONS(2456),
    [anon_sym_while] = ACTIONS(2456),
    [anon_sym_extern] = ACTIONS(2456),
    [anon_sym_yield] = ACTIONS(2456),
    [anon_sym_move] = ACTIONS(2456),
    [anon_sym_try] = ACTIONS(2456),
    [sym_integer_literal] = ACTIONS(2454),
    [aux_sym_string_literal_token1] = ACTIONS(2454),
    [sym_char_literal] = ACTIONS(2454),
    [anon_sym_true] = ACTIONS(2456),
    [anon_sym_false] = ACTIONS(2456),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2456),
    [sym_super] = ACTIONS(2456),
    [sym_crate] = ACTIONS(2456),
    [sym_metavariable] = ACTIONS(2454),
    [sym__raw_string_literal_start] = ACTIONS(2454),
    [sym_float_literal] = ACTIONS(2454),
  },
  [654] = {
    [sym_line_comment] = STATE(654),
    [sym_block_comment] = STATE(654),
    [ts_builtin_sym_end] = ACTIONS(2458),
    [sym_identifier] = ACTIONS(2460),
    [anon_sym_SEMI] = ACTIONS(2458),
    [anon_sym_macro_rules_BANG] = ACTIONS(2458),
    [anon_sym_LPAREN] = ACTIONS(2458),
    [anon_sym_LBRACK] = ACTIONS(2458),
    [anon_sym_LBRACE] = ACTIONS(2458),
    [anon_sym_RBRACE] = ACTIONS(2458),
    [anon_sym_STAR] = ACTIONS(2458),
    [anon_sym_u8] = ACTIONS(2460),
    [anon_sym_i8] = ACTIONS(2460),
    [anon_sym_u16] = ACTIONS(2460),
    [anon_sym_i16] = ACTIONS(2460),
    [anon_sym_u32] = ACTIONS(2460),
    [anon_sym_i32] = ACTIONS(2460),
    [anon_sym_u64] = ACTIONS(2460),
    [anon_sym_i64] = ACTIONS(2460),
    [anon_sym_u128] = ACTIONS(2460),
    [anon_sym_i128] = ACTIONS(2460),
    [anon_sym_isize] = ACTIONS(2460),
    [anon_sym_usize] = ACTIONS(2460),
    [anon_sym_f32] = ACTIONS(2460),
    [anon_sym_f64] = ACTIONS(2460),
    [anon_sym_bool] = ACTIONS(2460),
    [anon_sym_str] = ACTIONS(2460),
    [anon_sym_char] = ACTIONS(2460),
    [anon_sym_DASH] = ACTIONS(2458),
    [anon_sym_BANG] = ACTIONS(2458),
    [anon_sym_AMP] = ACTIONS(2458),
    [anon_sym_PIPE] = ACTIONS(2458),
    [anon_sym_LT] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2458),
    [anon_sym_COLON_COLON] = ACTIONS(2458),
    [anon_sym_POUND] = ACTIONS(2458),
    [anon_sym_SQUOTE] = ACTIONS(2460),
    [anon_sym_async] = ACTIONS(2460),
    [anon_sym_break] = ACTIONS(2460),
    [anon_sym_const] = ACTIONS(2460),
    [anon_sym_continue] = ACTIONS(2460),
    [anon_sym_default] = ACTIONS(2460),
    [anon_sym_enum] = ACTIONS(2460),
    [anon_sym_fn] = ACTIONS(2460),
    [anon_sym_for] = ACTIONS(2460),
    [anon_sym_if] = ACTIONS(2460),
    [anon_sym_impl] = ACTIONS(2460),
    [anon_sym_let] = ACTIONS(2460),
    [anon_sym_loop] = ACTIONS(2460),
    [anon_sym_match] = ACTIONS(2460),
    [anon_sym_mod] = ACTIONS(2460),
    [anon_sym_pub] = ACTIONS(2460),
    [anon_sym_return] = ACTIONS(2460),
    [anon_sym_static] = ACTIONS(2460),
    [anon_sym_struct] = ACTIONS(2460),
    [anon_sym_trait] = ACTIONS(2460),
    [anon_sym_type] = ACTIONS(2460),
    [anon_sym_union] = ACTIONS(2460),
    [anon_sym_unsafe] = ACTIONS(2460),
    [anon_sym_use] = ACTIONS(2460),
    [anon_sym_while] = ACTIONS(2460),
    [anon_sym_extern] = ACTIONS(2460),
    [anon_sym_yield] = ACTIONS(2460),
    [anon_sym_move] = ACTIONS(2460),
    [anon_sym_try] = ACTIONS(2460),
    [sym_integer_literal] = ACTIONS(2458),
    [aux_sym_string_literal_token1] = ACTIONS(2458),
    [sym_char_literal] = ACTIONS(2458),
    [anon_sym_true] = ACTIONS(2460),
    [anon_sym_false] = ACTIONS(2460),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2460),
    [sym_super] = ACTIONS(2460),
    [sym_crate] = ACTIONS(2460),
    [sym_metavariable] = ACTIONS(2458),
    [sym__raw_string_literal_start] = ACTIONS(2458),
    [sym_float_literal] = ACTIONS(2458),
  },
  [655] = {
    [sym_line_comment] = STATE(655),
    [sym_block_comment] = STATE(655),
    [ts_builtin_sym_end] = ACTIONS(2462),
    [sym_identifier] = ACTIONS(2464),
    [anon_sym_SEMI] = ACTIONS(2462),
    [anon_sym_macro_rules_BANG] = ACTIONS(2462),
    [anon_sym_LPAREN] = ACTIONS(2462),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_LBRACE] = ACTIONS(2462),
    [anon_sym_RBRACE] = ACTIONS(2462),
    [anon_sym_STAR] = ACTIONS(2462),
    [anon_sym_u8] = ACTIONS(2464),
    [anon_sym_i8] = ACTIONS(2464),
    [anon_sym_u16] = ACTIONS(2464),
    [anon_sym_i16] = ACTIONS(2464),
    [anon_sym_u32] = ACTIONS(2464),
    [anon_sym_i32] = ACTIONS(2464),
    [anon_sym_u64] = ACTIONS(2464),
    [anon_sym_i64] = ACTIONS(2464),
    [anon_sym_u128] = ACTIONS(2464),
    [anon_sym_i128] = ACTIONS(2464),
    [anon_sym_isize] = ACTIONS(2464),
    [anon_sym_usize] = ACTIONS(2464),
    [anon_sym_f32] = ACTIONS(2464),
    [anon_sym_f64] = ACTIONS(2464),
    [anon_sym_bool] = ACTIONS(2464),
    [anon_sym_str] = ACTIONS(2464),
    [anon_sym_char] = ACTIONS(2464),
    [anon_sym_DASH] = ACTIONS(2462),
    [anon_sym_BANG] = ACTIONS(2462),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_PIPE] = ACTIONS(2462),
    [anon_sym_LT] = ACTIONS(2462),
    [anon_sym_DOT_DOT] = ACTIONS(2462),
    [anon_sym_COLON_COLON] = ACTIONS(2462),
    [anon_sym_POUND] = ACTIONS(2462),
    [anon_sym_SQUOTE] = ACTIONS(2464),
    [anon_sym_async] = ACTIONS(2464),
    [anon_sym_break] = ACTIONS(2464),
    [anon_sym_const] = ACTIONS(2464),
    [anon_sym_continue] = ACTIONS(2464),
    [anon_sym_default] = ACTIONS(2464),
    [anon_sym_enum] = ACTIONS(2464),
    [anon_sym_fn] = ACTIONS(2464),
    [anon_sym_for] = ACTIONS(2464),
    [anon_sym_if] = ACTIONS(2464),
    [anon_sym_impl] = ACTIONS(2464),
    [anon_sym_let] = ACTIONS(2464),
    [anon_sym_loop] = ACTIONS(2464),
    [anon_sym_match] = ACTIONS(2464),
    [anon_sym_mod] = ACTIONS(2464),
    [anon_sym_pub] = ACTIONS(2464),
    [anon_sym_return] = ACTIONS(2464),
    [anon_sym_static] = ACTIONS(2464),
    [anon_sym_struct] = ACTIONS(2464),
    [anon_sym_trait] = ACTIONS(2464),
    [anon_sym_type] = ACTIONS(2464),
    [anon_sym_union] = ACTIONS(2464),
    [anon_sym_unsafe] = ACTIONS(2464),
    [anon_sym_use] = ACTIONS(2464),
    [anon_sym_while] = ACTIONS(2464),
    [anon_sym_extern] = ACTIONS(2464),
    [anon_sym_yield] = ACTIONS(2464),
    [anon_sym_move] = ACTIONS(2464),
    [anon_sym_try] = ACTIONS(2464),
    [sym_integer_literal] = ACTIONS(2462),
    [aux_sym_string_literal_token1] = ACTIONS(2462),
    [sym_char_literal] = ACTIONS(2462),
    [anon_sym_true] = ACTIONS(2464),
    [anon_sym_false] = ACTIONS(2464),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2464),
    [sym_super] = ACTIONS(2464),
    [sym_crate] = ACTIONS(2464),
    [sym_metavariable] = ACTIONS(2462),
    [sym__raw_string_literal_start] = ACTIONS(2462),
    [sym_float_literal] = ACTIONS(2462),
  },
  [656] = {
    [sym_line_comment] = STATE(656),
    [sym_block_comment] = STATE(656),
    [ts_builtin_sym_end] = ACTIONS(2466),
    [sym_identifier] = ACTIONS(2468),
    [anon_sym_SEMI] = ACTIONS(2466),
    [anon_sym_macro_rules_BANG] = ACTIONS(2466),
    [anon_sym_LPAREN] = ACTIONS(2466),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_LBRACE] = ACTIONS(2466),
    [anon_sym_RBRACE] = ACTIONS(2466),
    [anon_sym_STAR] = ACTIONS(2466),
    [anon_sym_u8] = ACTIONS(2468),
    [anon_sym_i8] = ACTIONS(2468),
    [anon_sym_u16] = ACTIONS(2468),
    [anon_sym_i16] = ACTIONS(2468),
    [anon_sym_u32] = ACTIONS(2468),
    [anon_sym_i32] = ACTIONS(2468),
    [anon_sym_u64] = ACTIONS(2468),
    [anon_sym_i64] = ACTIONS(2468),
    [anon_sym_u128] = ACTIONS(2468),
    [anon_sym_i128] = ACTIONS(2468),
    [anon_sym_isize] = ACTIONS(2468),
    [anon_sym_usize] = ACTIONS(2468),
    [anon_sym_f32] = ACTIONS(2468),
    [anon_sym_f64] = ACTIONS(2468),
    [anon_sym_bool] = ACTIONS(2468),
    [anon_sym_str] = ACTIONS(2468),
    [anon_sym_char] = ACTIONS(2468),
    [anon_sym_DASH] = ACTIONS(2466),
    [anon_sym_BANG] = ACTIONS(2466),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_PIPE] = ACTIONS(2466),
    [anon_sym_LT] = ACTIONS(2466),
    [anon_sym_DOT_DOT] = ACTIONS(2466),
    [anon_sym_COLON_COLON] = ACTIONS(2466),
    [anon_sym_POUND] = ACTIONS(2466),
    [anon_sym_SQUOTE] = ACTIONS(2468),
    [anon_sym_async] = ACTIONS(2468),
    [anon_sym_break] = ACTIONS(2468),
    [anon_sym_const] = ACTIONS(2468),
    [anon_sym_continue] = ACTIONS(2468),
    [anon_sym_default] = ACTIONS(2468),
    [anon_sym_enum] = ACTIONS(2468),
    [anon_sym_fn] = ACTIONS(2468),
    [anon_sym_for] = ACTIONS(2468),
    [anon_sym_if] = ACTIONS(2468),
    [anon_sym_impl] = ACTIONS(2468),
    [anon_sym_let] = ACTIONS(2468),
    [anon_sym_loop] = ACTIONS(2468),
    [anon_sym_match] = ACTIONS(2468),
    [anon_sym_mod] = ACTIONS(2468),
    [anon_sym_pub] = ACTIONS(2468),
    [anon_sym_return] = ACTIONS(2468),
    [anon_sym_static] = ACTIONS(2468),
    [anon_sym_struct] = ACTIONS(2468),
    [anon_sym_trait] = ACTIONS(2468),
    [anon_sym_type] = ACTIONS(2468),
    [anon_sym_union] = ACTIONS(2468),
    [anon_sym_unsafe] = ACTIONS(2468),
    [anon_sym_use] = ACTIONS(2468),
    [anon_sym_while] = ACTIONS(2468),
    [anon_sym_extern] = ACTIONS(2468),
    [anon_sym_yield] = ACTIONS(2468),
    [anon_sym_move] = ACTIONS(2468),
    [anon_sym_try] = ACTIONS(2468),
    [sym_integer_literal] = ACTIONS(2466),
    [aux_sym_string_literal_token1] = ACTIONS(2466),
    [sym_char_literal] = ACTIONS(2466),
    [anon_sym_true] = ACTIONS(2468),
    [anon_sym_false] = ACTIONS(2468),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2468),
    [sym_super] = ACTIONS(2468),
    [sym_crate] = ACTIONS(2468),
    [sym_metavariable] = ACTIONS(2466),
    [sym__raw_string_literal_start] = ACTIONS(2466),
    [sym_float_literal] = ACTIONS(2466),
  },
  [657] = {
    [sym_line_comment] = STATE(657),
    [sym_block_comment] = STATE(657),
    [ts_builtin_sym_end] = ACTIONS(2470),
    [sym_identifier] = ACTIONS(2472),
    [anon_sym_SEMI] = ACTIONS(2470),
    [anon_sym_macro_rules_BANG] = ACTIONS(2470),
    [anon_sym_LPAREN] = ACTIONS(2470),
    [anon_sym_LBRACK] = ACTIONS(2470),
    [anon_sym_LBRACE] = ACTIONS(2470),
    [anon_sym_RBRACE] = ACTIONS(2470),
    [anon_sym_STAR] = ACTIONS(2470),
    [anon_sym_u8] = ACTIONS(2472),
    [anon_sym_i8] = ACTIONS(2472),
    [anon_sym_u16] = ACTIONS(2472),
    [anon_sym_i16] = ACTIONS(2472),
    [anon_sym_u32] = ACTIONS(2472),
    [anon_sym_i32] = ACTIONS(2472),
    [anon_sym_u64] = ACTIONS(2472),
    [anon_sym_i64] = ACTIONS(2472),
    [anon_sym_u128] = ACTIONS(2472),
    [anon_sym_i128] = ACTIONS(2472),
    [anon_sym_isize] = ACTIONS(2472),
    [anon_sym_usize] = ACTIONS(2472),
    [anon_sym_f32] = ACTIONS(2472),
    [anon_sym_f64] = ACTIONS(2472),
    [anon_sym_bool] = ACTIONS(2472),
    [anon_sym_str] = ACTIONS(2472),
    [anon_sym_char] = ACTIONS(2472),
    [anon_sym_DASH] = ACTIONS(2470),
    [anon_sym_BANG] = ACTIONS(2470),
    [anon_sym_AMP] = ACTIONS(2470),
    [anon_sym_PIPE] = ACTIONS(2470),
    [anon_sym_LT] = ACTIONS(2470),
    [anon_sym_DOT_DOT] = ACTIONS(2470),
    [anon_sym_COLON_COLON] = ACTIONS(2470),
    [anon_sym_POUND] = ACTIONS(2470),
    [anon_sym_SQUOTE] = ACTIONS(2472),
    [anon_sym_async] = ACTIONS(2472),
    [anon_sym_break] = ACTIONS(2472),
    [anon_sym_const] = ACTIONS(2472),
    [anon_sym_continue] = ACTIONS(2472),
    [anon_sym_default] = ACTIONS(2472),
    [anon_sym_enum] = ACTIONS(2472),
    [anon_sym_fn] = ACTIONS(2472),
    [anon_sym_for] = ACTIONS(2472),
    [anon_sym_if] = ACTIONS(2472),
    [anon_sym_impl] = ACTIONS(2472),
    [anon_sym_let] = ACTIONS(2472),
    [anon_sym_loop] = ACTIONS(2472),
    [anon_sym_match] = ACTIONS(2472),
    [anon_sym_mod] = ACTIONS(2472),
    [anon_sym_pub] = ACTIONS(2472),
    [anon_sym_return] = ACTIONS(2472),
    [anon_sym_static] = ACTIONS(2472),
    [anon_sym_struct] = ACTIONS(2472),
    [anon_sym_trait] = ACTIONS(2472),
    [anon_sym_type] = ACTIONS(2472),
    [anon_sym_union] = ACTIONS(2472),
    [anon_sym_unsafe] = ACTIONS(2472),
    [anon_sym_use] = ACTIONS(2472),
    [anon_sym_while] = ACTIONS(2472),
    [anon_sym_extern] = ACTIONS(2472),
    [anon_sym_yield] = ACTIONS(2472),
    [anon_sym_move] = ACTIONS(2472),
    [anon_sym_try] = ACTIONS(2472),
    [sym_integer_literal] = ACTIONS(2470),
    [aux_sym_string_literal_token1] = ACTIONS(2470),
    [sym_char_literal] = ACTIONS(2470),
    [anon_sym_true] = ACTIONS(2472),
    [anon_sym_false] = ACTIONS(2472),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2472),
    [sym_super] = ACTIONS(2472),
    [sym_crate] = ACTIONS(2472),
    [sym_metavariable] = ACTIONS(2470),
    [sym__raw_string_literal_start] = ACTIONS(2470),
    [sym_float_literal] = ACTIONS(2470),
  },
  [658] = {
    [sym_line_comment] = STATE(658),
    [sym_block_comment] = STATE(658),
    [ts_builtin_sym_end] = ACTIONS(2474),
    [sym_identifier] = ACTIONS(2476),
    [anon_sym_SEMI] = ACTIONS(2474),
    [anon_sym_macro_rules_BANG] = ACTIONS(2474),
    [anon_sym_LPAREN] = ACTIONS(2474),
    [anon_sym_LBRACK] = ACTIONS(2474),
    [anon_sym_LBRACE] = ACTIONS(2474),
    [anon_sym_RBRACE] = ACTIONS(2474),
    [anon_sym_STAR] = ACTIONS(2474),
    [anon_sym_u8] = ACTIONS(2476),
    [anon_sym_i8] = ACTIONS(2476),
    [anon_sym_u16] = ACTIONS(2476),
    [anon_sym_i16] = ACTIONS(2476),
    [anon_sym_u32] = ACTIONS(2476),
    [anon_sym_i32] = ACTIONS(2476),
    [anon_sym_u64] = ACTIONS(2476),
    [anon_sym_i64] = ACTIONS(2476),
    [anon_sym_u128] = ACTIONS(2476),
    [anon_sym_i128] = ACTIONS(2476),
    [anon_sym_isize] = ACTIONS(2476),
    [anon_sym_usize] = ACTIONS(2476),
    [anon_sym_f32] = ACTIONS(2476),
    [anon_sym_f64] = ACTIONS(2476),
    [anon_sym_bool] = ACTIONS(2476),
    [anon_sym_str] = ACTIONS(2476),
    [anon_sym_char] = ACTIONS(2476),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_BANG] = ACTIONS(2474),
    [anon_sym_AMP] = ACTIONS(2474),
    [anon_sym_PIPE] = ACTIONS(2474),
    [anon_sym_LT] = ACTIONS(2474),
    [anon_sym_DOT_DOT] = ACTIONS(2474),
    [anon_sym_COLON_COLON] = ACTIONS(2474),
    [anon_sym_POUND] = ACTIONS(2474),
    [anon_sym_SQUOTE] = ACTIONS(2476),
    [anon_sym_async] = ACTIONS(2476),
    [anon_sym_break] = ACTIONS(2476),
    [anon_sym_const] = ACTIONS(2476),
    [anon_sym_continue] = ACTIONS(2476),
    [anon_sym_default] = ACTIONS(2476),
    [anon_sym_enum] = ACTIONS(2476),
    [anon_sym_fn] = ACTIONS(2476),
    [anon_sym_for] = ACTIONS(2476),
    [anon_sym_if] = ACTIONS(2476),
    [anon_sym_impl] = ACTIONS(2476),
    [anon_sym_let] = ACTIONS(2476),
    [anon_sym_loop] = ACTIONS(2476),
    [anon_sym_match] = ACTIONS(2476),
    [anon_sym_mod] = ACTIONS(2476),
    [anon_sym_pub] = ACTIONS(2476),
    [anon_sym_return] = ACTIONS(2476),
    [anon_sym_static] = ACTIONS(2476),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_trait] = ACTIONS(2476),
    [anon_sym_type] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2476),
    [anon_sym_unsafe] = ACTIONS(2476),
    [anon_sym_use] = ACTIONS(2476),
    [anon_sym_while] = ACTIONS(2476),
    [anon_sym_extern] = ACTIONS(2476),
    [anon_sym_yield] = ACTIONS(2476),
    [anon_sym_move] = ACTIONS(2476),
    [anon_sym_try] = ACTIONS(2476),
    [sym_integer_literal] = ACTIONS(2474),
    [aux_sym_string_literal_token1] = ACTIONS(2474),
    [sym_char_literal] = ACTIONS(2474),
    [anon_sym_true] = ACTIONS(2476),
    [anon_sym_false] = ACTIONS(2476),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2476),
    [sym_super] = ACTIONS(2476),
    [sym_crate] = ACTIONS(2476),
    [sym_metavariable] = ACTIONS(2474),
    [sym__raw_string_literal_start] = ACTIONS(2474),
    [sym_float_literal] = ACTIONS(2474),
  },
  [659] = {
    [sym_empty_statement] = STATE(1143),
    [sym_macro_definition] = STATE(1143),
    [sym_attribute_item] = STATE(1143),
    [sym_inner_attribute_item] = STATE(1143),
    [sym_mod_item] = STATE(1143),
    [sym_foreign_mod_item] = STATE(1143),
    [sym_struct_item] = STATE(1143),
    [sym_union_item] = STATE(1143),
    [sym_enum_item] = STATE(1143),
    [sym_extern_crate_declaration] = STATE(1143),
    [sym_const_item] = STATE(1143),
    [sym_static_item] = STATE(1143),
    [sym_type_item] = STATE(1143),
    [sym_function_item] = STATE(1143),
    [sym_function_signature_item] = STATE(1143),
    [sym_function_modifiers] = STATE(3583),
    [sym_impl_item] = STATE(1143),
    [sym_trait_item] = STATE(1143),
    [sym_associated_type] = STATE(1143),
    [sym_let_declaration] = STATE(1143),
    [sym_use_declaration] = STATE(1143),
    [sym_extern_modifier] = STATE(2167),
    [sym_visibility_modifier] = STATE(1927),
    [sym_bracketed_type] = STATE(3307),
    [sym_generic_type_with_turbofish] = STATE(3333),
    [sym_macro_invocation] = STATE(1143),
    [sym_scoped_identifier] = STATE(3206),
    [sym_line_comment] = STATE(659),
    [sym_block_comment] = STATE(659),
    [aux_sym_declaration_list_repeat1] = STATE(659),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2478),
    [anon_sym_SEMI] = ACTIONS(2481),
    [anon_sym_macro_rules_BANG] = ACTIONS(2484),
    [anon_sym_RBRACE] = ACTIONS(2487),
    [anon_sym_u8] = ACTIONS(2489),
    [anon_sym_i8] = ACTIONS(2489),
    [anon_sym_u16] = ACTIONS(2489),
    [anon_sym_i16] = ACTIONS(2489),
    [anon_sym_u32] = ACTIONS(2489),
    [anon_sym_i32] = ACTIONS(2489),
    [anon_sym_u64] = ACTIONS(2489),
    [anon_sym_i64] = ACTIONS(2489),
    [anon_sym_u128] = ACTIONS(2489),
    [anon_sym_i128] = ACTIONS(2489),
    [anon_sym_isize] = ACTIONS(2489),
    [anon_sym_usize] = ACTIONS(2489),
    [anon_sym_f32] = ACTIONS(2489),
    [anon_sym_f64] = ACTIONS(2489),
    [anon_sym_bool] = ACTIONS(2489),
    [anon_sym_str] = ACTIONS(2489),
    [anon_sym_char] = ACTIONS(2489),
    [anon_sym_LT] = ACTIONS(2492),
    [anon_sym_COLON_COLON] = ACTIONS(2495),
    [anon_sym_POUND] = ACTIONS(2498),
    [anon_sym_async] = ACTIONS(2501),
    [anon_sym_const] = ACTIONS(2504),
    [anon_sym_default] = ACTIONS(2507),
    [anon_sym_enum] = ACTIONS(2510),
    [anon_sym_fn] = ACTIONS(2513),
    [anon_sym_impl] = ACTIONS(2516),
    [anon_sym_let] = ACTIONS(2519),
    [anon_sym_mod] = ACTIONS(2522),
    [anon_sym_pub] = ACTIONS(2525),
    [anon_sym_static] = ACTIONS(2528),
    [anon_sym_struct] = ACTIONS(2531),
    [anon_sym_trait] = ACTIONS(2534),
    [anon_sym_type] = ACTIONS(2537),
    [anon_sym_union] = ACTIONS(2540),
    [anon_sym_unsafe] = ACTIONS(2543),
    [anon_sym_use] = ACTIONS(2546),
    [anon_sym_extern] = ACTIONS(2549),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2552),
    [sym_super] = ACTIONS(2552),
    [sym_crate] = ACTIONS(2555),
    [sym_metavariable] = ACTIONS(2558),
  },
  [660] = {
    [sym_line_comment] = STATE(660),
    [sym_block_comment] = STATE(660),
    [ts_builtin_sym_end] = ACTIONS(2561),
    [sym_identifier] = ACTIONS(2563),
    [anon_sym_SEMI] = ACTIONS(2561),
    [anon_sym_macro_rules_BANG] = ACTIONS(2561),
    [anon_sym_LPAREN] = ACTIONS(2561),
    [anon_sym_LBRACK] = ACTIONS(2561),
    [anon_sym_LBRACE] = ACTIONS(2561),
    [anon_sym_RBRACE] = ACTIONS(2561),
    [anon_sym_STAR] = ACTIONS(2561),
    [anon_sym_u8] = ACTIONS(2563),
    [anon_sym_i8] = ACTIONS(2563),
    [anon_sym_u16] = ACTIONS(2563),
    [anon_sym_i16] = ACTIONS(2563),
    [anon_sym_u32] = ACTIONS(2563),
    [anon_sym_i32] = ACTIONS(2563),
    [anon_sym_u64] = ACTIONS(2563),
    [anon_sym_i64] = ACTIONS(2563),
    [anon_sym_u128] = ACTIONS(2563),
    [anon_sym_i128] = ACTIONS(2563),
    [anon_sym_isize] = ACTIONS(2563),
    [anon_sym_usize] = ACTIONS(2563),
    [anon_sym_f32] = ACTIONS(2563),
    [anon_sym_f64] = ACTIONS(2563),
    [anon_sym_bool] = ACTIONS(2563),
    [anon_sym_str] = ACTIONS(2563),
    [anon_sym_char] = ACTIONS(2563),
    [anon_sym_DASH] = ACTIONS(2561),
    [anon_sym_BANG] = ACTIONS(2561),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_PIPE] = ACTIONS(2561),
    [anon_sym_LT] = ACTIONS(2561),
    [anon_sym_DOT_DOT] = ACTIONS(2561),
    [anon_sym_COLON_COLON] = ACTIONS(2561),
    [anon_sym_POUND] = ACTIONS(2561),
    [anon_sym_SQUOTE] = ACTIONS(2563),
    [anon_sym_async] = ACTIONS(2563),
    [anon_sym_break] = ACTIONS(2563),
    [anon_sym_const] = ACTIONS(2563),
    [anon_sym_continue] = ACTIONS(2563),
    [anon_sym_default] = ACTIONS(2563),
    [anon_sym_enum] = ACTIONS(2563),
    [anon_sym_fn] = ACTIONS(2563),
    [anon_sym_for] = ACTIONS(2563),
    [anon_sym_if] = ACTIONS(2563),
    [anon_sym_impl] = ACTIONS(2563),
    [anon_sym_let] = ACTIONS(2563),
    [anon_sym_loop] = ACTIONS(2563),
    [anon_sym_match] = ACTIONS(2563),
    [anon_sym_mod] = ACTIONS(2563),
    [anon_sym_pub] = ACTIONS(2563),
    [anon_sym_return] = ACTIONS(2563),
    [anon_sym_static] = ACTIONS(2563),
    [anon_sym_struct] = ACTIONS(2563),
    [anon_sym_trait] = ACTIONS(2563),
    [anon_sym_type] = ACTIONS(2563),
    [anon_sym_union] = ACTIONS(2563),
    [anon_sym_unsafe] = ACTIONS(2563),
    [anon_sym_use] = ACTIONS(2563),
    [anon_sym_while] = ACTIONS(2563),
    [anon_sym_extern] = ACTIONS(2563),
    [anon_sym_yield] = ACTIONS(2563),
    [anon_sym_move] = ACTIONS(2563),
    [anon_sym_try] = ACTIONS(2563),
    [sym_integer_literal] = ACTIONS(2561),
    [aux_sym_string_literal_token1] = ACTIONS(2561),
    [sym_char_literal] = ACTIONS(2561),
    [anon_sym_true] = ACTIONS(2563),
    [anon_sym_false] = ACTIONS(2563),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2563),
    [sym_super] = ACTIONS(2563),
    [sym_crate] = ACTIONS(2563),
    [sym_metavariable] = ACTIONS(2561),
    [sym__raw_string_literal_start] = ACTIONS(2561),
    [sym_float_literal] = ACTIONS(2561),
  },
  [661] = {
    [sym_line_comment] = STATE(661),
    [sym_block_comment] = STATE(661),
    [ts_builtin_sym_end] = ACTIONS(2565),
    [sym_identifier] = ACTIONS(2567),
    [anon_sym_SEMI] = ACTIONS(2565),
    [anon_sym_macro_rules_BANG] = ACTIONS(2565),
    [anon_sym_LPAREN] = ACTIONS(2565),
    [anon_sym_LBRACK] = ACTIONS(2565),
    [anon_sym_LBRACE] = ACTIONS(2565),
    [anon_sym_RBRACE] = ACTIONS(2565),
    [anon_sym_STAR] = ACTIONS(2565),
    [anon_sym_u8] = ACTIONS(2567),
    [anon_sym_i8] = ACTIONS(2567),
    [anon_sym_u16] = ACTIONS(2567),
    [anon_sym_i16] = ACTIONS(2567),
    [anon_sym_u32] = ACTIONS(2567),
    [anon_sym_i32] = ACTIONS(2567),
    [anon_sym_u64] = ACTIONS(2567),
    [anon_sym_i64] = ACTIONS(2567),
    [anon_sym_u128] = ACTIONS(2567),
    [anon_sym_i128] = ACTIONS(2567),
    [anon_sym_isize] = ACTIONS(2567),
    [anon_sym_usize] = ACTIONS(2567),
    [anon_sym_f32] = ACTIONS(2567),
    [anon_sym_f64] = ACTIONS(2567),
    [anon_sym_bool] = ACTIONS(2567),
    [anon_sym_str] = ACTIONS(2567),
    [anon_sym_char] = ACTIONS(2567),
    [anon_sym_DASH] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2565),
    [anon_sym_AMP] = ACTIONS(2565),
    [anon_sym_PIPE] = ACTIONS(2565),
    [anon_sym_LT] = ACTIONS(2565),
    [anon_sym_DOT_DOT] = ACTIONS(2565),
    [anon_sym_COLON_COLON] = ACTIONS(2565),
    [anon_sym_POUND] = ACTIONS(2565),
    [anon_sym_SQUOTE] = ACTIONS(2567),
    [anon_sym_async] = ACTIONS(2567),
    [anon_sym_break] = ACTIONS(2567),
    [anon_sym_const] = ACTIONS(2567),
    [anon_sym_continue] = ACTIONS(2567),
    [anon_sym_default] = ACTIONS(2567),
    [anon_sym_enum] = ACTIONS(2567),
    [anon_sym_fn] = ACTIONS(2567),
    [anon_sym_for] = ACTIONS(2567),
    [anon_sym_if] = ACTIONS(2567),
    [anon_sym_impl] = ACTIONS(2567),
    [anon_sym_let] = ACTIONS(2567),
    [anon_sym_loop] = ACTIONS(2567),
    [anon_sym_match] = ACTIONS(2567),
    [anon_sym_mod] = ACTIONS(2567),
    [anon_sym_pub] = ACTIONS(2567),
    [anon_sym_return] = ACTIONS(2567),
    [anon_sym_static] = ACTIONS(2567),
    [anon_sym_struct] = ACTIONS(2567),
    [anon_sym_trait] = ACTIONS(2567),
    [anon_sym_type] = ACTIONS(2567),
    [anon_sym_union] = ACTIONS(2567),
    [anon_sym_unsafe] = ACTIONS(2567),
    [anon_sym_use] = ACTIONS(2567),
    [anon_sym_while] = ACTIONS(2567),
    [anon_sym_extern] = ACTIONS(2567),
    [anon_sym_yield] = ACTIONS(2567),
    [anon_sym_move] = ACTIONS(2567),
    [anon_sym_try] = ACTIONS(2567),
    [sym_integer_literal] = ACTIONS(2565),
    [aux_sym_string_literal_token1] = ACTIONS(2565),
    [sym_char_literal] = ACTIONS(2565),
    [anon_sym_true] = ACTIONS(2567),
    [anon_sym_false] = ACTIONS(2567),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2567),
    [sym_super] = ACTIONS(2567),
    [sym_crate] = ACTIONS(2567),
    [sym_metavariable] = ACTIONS(2565),
    [sym__raw_string_literal_start] = ACTIONS(2565),
    [sym_float_literal] = ACTIONS(2565),
  },
  [662] = {
    [sym_line_comment] = STATE(662),
    [sym_block_comment] = STATE(662),
    [ts_builtin_sym_end] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2571),
    [anon_sym_SEMI] = ACTIONS(2569),
    [anon_sym_macro_rules_BANG] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2569),
    [anon_sym_LBRACK] = ACTIONS(2569),
    [anon_sym_LBRACE] = ACTIONS(2569),
    [anon_sym_RBRACE] = ACTIONS(2569),
    [anon_sym_STAR] = ACTIONS(2569),
    [anon_sym_u8] = ACTIONS(2571),
    [anon_sym_i8] = ACTIONS(2571),
    [anon_sym_u16] = ACTIONS(2571),
    [anon_sym_i16] = ACTIONS(2571),
    [anon_sym_u32] = ACTIONS(2571),
    [anon_sym_i32] = ACTIONS(2571),
    [anon_sym_u64] = ACTIONS(2571),
    [anon_sym_i64] = ACTIONS(2571),
    [anon_sym_u128] = ACTIONS(2571),
    [anon_sym_i128] = ACTIONS(2571),
    [anon_sym_isize] = ACTIONS(2571),
    [anon_sym_usize] = ACTIONS(2571),
    [anon_sym_f32] = ACTIONS(2571),
    [anon_sym_f64] = ACTIONS(2571),
    [anon_sym_bool] = ACTIONS(2571),
    [anon_sym_str] = ACTIONS(2571),
    [anon_sym_char] = ACTIONS(2571),
    [anon_sym_DASH] = ACTIONS(2569),
    [anon_sym_BANG] = ACTIONS(2569),
    [anon_sym_AMP] = ACTIONS(2569),
    [anon_sym_PIPE] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(2569),
    [anon_sym_DOT_DOT] = ACTIONS(2569),
    [anon_sym_COLON_COLON] = ACTIONS(2569),
    [anon_sym_POUND] = ACTIONS(2569),
    [anon_sym_SQUOTE] = ACTIONS(2571),
    [anon_sym_async] = ACTIONS(2571),
    [anon_sym_break] = ACTIONS(2571),
    [anon_sym_const] = ACTIONS(2571),
    [anon_sym_continue] = ACTIONS(2571),
    [anon_sym_default] = ACTIONS(2571),
    [anon_sym_enum] = ACTIONS(2571),
    [anon_sym_fn] = ACTIONS(2571),
    [anon_sym_for] = ACTIONS(2571),
    [anon_sym_if] = ACTIONS(2571),
    [anon_sym_impl] = ACTIONS(2571),
    [anon_sym_let] = ACTIONS(2571),
    [anon_sym_loop] = ACTIONS(2571),
    [anon_sym_match] = ACTIONS(2571),
    [anon_sym_mod] = ACTIONS(2571),
    [anon_sym_pub] = ACTIONS(2571),
    [anon_sym_return] = ACTIONS(2571),
    [anon_sym_static] = ACTIONS(2571),
    [anon_sym_struct] = ACTIONS(2571),
    [anon_sym_trait] = ACTIONS(2571),
    [anon_sym_type] = ACTIONS(2571),
    [anon_sym_union] = ACTIONS(2571),
    [anon_sym_unsafe] = ACTIONS(2571),
    [anon_sym_use] = ACTIONS(2571),
    [anon_sym_while] = ACTIONS(2571),
    [anon_sym_extern] = ACTIONS(2571),
    [anon_sym_yield] = ACTIONS(2571),
    [anon_sym_move] = ACTIONS(2571),
    [anon_sym_try] = ACTIONS(2571),
    [sym_integer_literal] = ACTIONS(2569),
    [aux_sym_string_literal_token1] = ACTIONS(2569),
    [sym_char_literal] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(2571),
    [anon_sym_false] = ACTIONS(2571),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2571),
    [sym_super] = ACTIONS(2571),
    [sym_crate] = ACTIONS(2571),
    [sym_metavariable] = ACTIONS(2569),
    [sym__raw_string_literal_start] = ACTIONS(2569),
    [sym_float_literal] = ACTIONS(2569),
  },
  [663] = {
    [sym_line_comment] = STATE(663),
    [sym_block_comment] = STATE(663),
    [ts_builtin_sym_end] = ACTIONS(2573),
    [sym_identifier] = ACTIONS(2575),
    [anon_sym_SEMI] = ACTIONS(2573),
    [anon_sym_macro_rules_BANG] = ACTIONS(2573),
    [anon_sym_LPAREN] = ACTIONS(2573),
    [anon_sym_LBRACK] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2573),
    [anon_sym_RBRACE] = ACTIONS(2573),
    [anon_sym_STAR] = ACTIONS(2573),
    [anon_sym_u8] = ACTIONS(2575),
    [anon_sym_i8] = ACTIONS(2575),
    [anon_sym_u16] = ACTIONS(2575),
    [anon_sym_i16] = ACTIONS(2575),
    [anon_sym_u32] = ACTIONS(2575),
    [anon_sym_i32] = ACTIONS(2575),
    [anon_sym_u64] = ACTIONS(2575),
    [anon_sym_i64] = ACTIONS(2575),
    [anon_sym_u128] = ACTIONS(2575),
    [anon_sym_i128] = ACTIONS(2575),
    [anon_sym_isize] = ACTIONS(2575),
    [anon_sym_usize] = ACTIONS(2575),
    [anon_sym_f32] = ACTIONS(2575),
    [anon_sym_f64] = ACTIONS(2575),
    [anon_sym_bool] = ACTIONS(2575),
    [anon_sym_str] = ACTIONS(2575),
    [anon_sym_char] = ACTIONS(2575),
    [anon_sym_DASH] = ACTIONS(2573),
    [anon_sym_BANG] = ACTIONS(2573),
    [anon_sym_AMP] = ACTIONS(2573),
    [anon_sym_PIPE] = ACTIONS(2573),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_DOT_DOT] = ACTIONS(2573),
    [anon_sym_COLON_COLON] = ACTIONS(2573),
    [anon_sym_POUND] = ACTIONS(2573),
    [anon_sym_SQUOTE] = ACTIONS(2575),
    [anon_sym_async] = ACTIONS(2575),
    [anon_sym_break] = ACTIONS(2575),
    [anon_sym_const] = ACTIONS(2575),
    [anon_sym_continue] = ACTIONS(2575),
    [anon_sym_default] = ACTIONS(2575),
    [anon_sym_enum] = ACTIONS(2575),
    [anon_sym_fn] = ACTIONS(2575),
    [anon_sym_for] = ACTIONS(2575),
    [anon_sym_if] = ACTIONS(2575),
    [anon_sym_impl] = ACTIONS(2575),
    [anon_sym_let] = ACTIONS(2575),
    [anon_sym_loop] = ACTIONS(2575),
    [anon_sym_match] = ACTIONS(2575),
    [anon_sym_mod] = ACTIONS(2575),
    [anon_sym_pub] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(2575),
    [anon_sym_static] = ACTIONS(2575),
    [anon_sym_struct] = ACTIONS(2575),
    [anon_sym_trait] = ACTIONS(2575),
    [anon_sym_type] = ACTIONS(2575),
    [anon_sym_union] = ACTIONS(2575),
    [anon_sym_unsafe] = ACTIONS(2575),
    [anon_sym_use] = ACTIONS(2575),
    [anon_sym_while] = ACTIONS(2575),
    [anon_sym_extern] = ACTIONS(2575),
    [anon_sym_yield] = ACTIONS(2575),
    [anon_sym_move] = ACTIONS(2575),
    [anon_sym_try] = ACTIONS(2575),
    [sym_integer_literal] = ACTIONS(2573),
    [aux_sym_string_literal_token1] = ACTIONS(2573),
    [sym_char_literal] = ACTIONS(2573),
    [anon_sym_true] = ACTIONS(2575),
    [anon_sym_false] = ACTIONS(2575),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2575),
    [sym_super] = ACTIONS(2575),
    [sym_crate] = ACTIONS(2575),
    [sym_metavariable] = ACTIONS(2573),
    [sym__raw_string_literal_start] = ACTIONS(2573),
    [sym_float_literal] = ACTIONS(2573),
  },
  [664] = {
    [sym_line_comment] = STATE(664),
    [sym_block_comment] = STATE(664),
    [ts_builtin_sym_end] = ACTIONS(2577),
    [sym_identifier] = ACTIONS(2579),
    [anon_sym_SEMI] = ACTIONS(2577),
    [anon_sym_macro_rules_BANG] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2577),
    [anon_sym_LBRACK] = ACTIONS(2577),
    [anon_sym_LBRACE] = ACTIONS(2577),
    [anon_sym_RBRACE] = ACTIONS(2577),
    [anon_sym_STAR] = ACTIONS(2577),
    [anon_sym_u8] = ACTIONS(2579),
    [anon_sym_i8] = ACTIONS(2579),
    [anon_sym_u16] = ACTIONS(2579),
    [anon_sym_i16] = ACTIONS(2579),
    [anon_sym_u32] = ACTIONS(2579),
    [anon_sym_i32] = ACTIONS(2579),
    [anon_sym_u64] = ACTIONS(2579),
    [anon_sym_i64] = ACTIONS(2579),
    [anon_sym_u128] = ACTIONS(2579),
    [anon_sym_i128] = ACTIONS(2579),
    [anon_sym_isize] = ACTIONS(2579),
    [anon_sym_usize] = ACTIONS(2579),
    [anon_sym_f32] = ACTIONS(2579),
    [anon_sym_f64] = ACTIONS(2579),
    [anon_sym_bool] = ACTIONS(2579),
    [anon_sym_str] = ACTIONS(2579),
    [anon_sym_char] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2577),
    [anon_sym_BANG] = ACTIONS(2577),
    [anon_sym_AMP] = ACTIONS(2577),
    [anon_sym_PIPE] = ACTIONS(2577),
    [anon_sym_LT] = ACTIONS(2577),
    [anon_sym_DOT_DOT] = ACTIONS(2577),
    [anon_sym_COLON_COLON] = ACTIONS(2577),
    [anon_sym_POUND] = ACTIONS(2577),
    [anon_sym_SQUOTE] = ACTIONS(2579),
    [anon_sym_async] = ACTIONS(2579),
    [anon_sym_break] = ACTIONS(2579),
    [anon_sym_const] = ACTIONS(2579),
    [anon_sym_continue] = ACTIONS(2579),
    [anon_sym_default] = ACTIONS(2579),
    [anon_sym_enum] = ACTIONS(2579),
    [anon_sym_fn] = ACTIONS(2579),
    [anon_sym_for] = ACTIONS(2579),
    [anon_sym_if] = ACTIONS(2579),
    [anon_sym_impl] = ACTIONS(2579),
    [anon_sym_let] = ACTIONS(2579),
    [anon_sym_loop] = ACTIONS(2579),
    [anon_sym_match] = ACTIONS(2579),
    [anon_sym_mod] = ACTIONS(2579),
    [anon_sym_pub] = ACTIONS(2579),
    [anon_sym_return] = ACTIONS(2579),
    [anon_sym_static] = ACTIONS(2579),
    [anon_sym_struct] = ACTIONS(2579),
    [anon_sym_trait] = ACTIONS(2579),
    [anon_sym_type] = ACTIONS(2579),
    [anon_sym_union] = ACTIONS(2579),
    [anon_sym_unsafe] = ACTIONS(2579),
    [anon_sym_use] = ACTIONS(2579),
    [anon_sym_while] = ACTIONS(2579),
    [anon_sym_extern] = ACTIONS(2579),
    [anon_sym_yield] = ACTIONS(2579),
    [anon_sym_move] = ACTIONS(2579),
    [anon_sym_try] = ACTIONS(2579),
    [sym_integer_literal] = ACTIONS(2577),
    [aux_sym_string_literal_token1] = ACTIONS(2577),
    [sym_char_literal] = ACTIONS(2577),
    [anon_sym_true] = ACTIONS(2579),
    [anon_sym_false] = ACTIONS(2579),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2579),
    [sym_super] = ACTIONS(2579),
    [sym_crate] = ACTIONS(2579),
    [sym_metavariable] = ACTIONS(2577),
    [sym__raw_string_literal_start] = ACTIONS(2577),
    [sym_float_literal] = ACTIONS(2577),
  },
  [665] = {
    [sym_line_comment] = STATE(665),
    [sym_block_comment] = STATE(665),
    [ts_builtin_sym_end] = ACTIONS(2581),
    [sym_identifier] = ACTIONS(2583),
    [anon_sym_SEMI] = ACTIONS(2581),
    [anon_sym_macro_rules_BANG] = ACTIONS(2581),
    [anon_sym_LPAREN] = ACTIONS(2581),
    [anon_sym_LBRACK] = ACTIONS(2581),
    [anon_sym_LBRACE] = ACTIONS(2581),
    [anon_sym_RBRACE] = ACTIONS(2581),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_u8] = ACTIONS(2583),
    [anon_sym_i8] = ACTIONS(2583),
    [anon_sym_u16] = ACTIONS(2583),
    [anon_sym_i16] = ACTIONS(2583),
    [anon_sym_u32] = ACTIONS(2583),
    [anon_sym_i32] = ACTIONS(2583),
    [anon_sym_u64] = ACTIONS(2583),
    [anon_sym_i64] = ACTIONS(2583),
    [anon_sym_u128] = ACTIONS(2583),
    [anon_sym_i128] = ACTIONS(2583),
    [anon_sym_isize] = ACTIONS(2583),
    [anon_sym_usize] = ACTIONS(2583),
    [anon_sym_f32] = ACTIONS(2583),
    [anon_sym_f64] = ACTIONS(2583),
    [anon_sym_bool] = ACTIONS(2583),
    [anon_sym_str] = ACTIONS(2583),
    [anon_sym_char] = ACTIONS(2583),
    [anon_sym_DASH] = ACTIONS(2581),
    [anon_sym_BANG] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_PIPE] = ACTIONS(2581),
    [anon_sym_LT] = ACTIONS(2581),
    [anon_sym_DOT_DOT] = ACTIONS(2581),
    [anon_sym_COLON_COLON] = ACTIONS(2581),
    [anon_sym_POUND] = ACTIONS(2581),
    [anon_sym_SQUOTE] = ACTIONS(2583),
    [anon_sym_async] = ACTIONS(2583),
    [anon_sym_break] = ACTIONS(2583),
    [anon_sym_const] = ACTIONS(2583),
    [anon_sym_continue] = ACTIONS(2583),
    [anon_sym_default] = ACTIONS(2583),
    [anon_sym_enum] = ACTIONS(2583),
    [anon_sym_fn] = ACTIONS(2583),
    [anon_sym_for] = ACTIONS(2583),
    [anon_sym_if] = ACTIONS(2583),
    [anon_sym_impl] = ACTIONS(2583),
    [anon_sym_let] = ACTIONS(2583),
    [anon_sym_loop] = ACTIONS(2583),
    [anon_sym_match] = ACTIONS(2583),
    [anon_sym_mod] = ACTIONS(2583),
    [anon_sym_pub] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(2583),
    [anon_sym_static] = ACTIONS(2583),
    [anon_sym_struct] = ACTIONS(2583),
    [anon_sym_trait] = ACTIONS(2583),
    [anon_sym_type] = ACTIONS(2583),
    [anon_sym_union] = ACTIONS(2583),
    [anon_sym_unsafe] = ACTIONS(2583),
    [anon_sym_use] = ACTIONS(2583),
    [anon_sym_while] = ACTIONS(2583),
    [anon_sym_extern] = ACTIONS(2583),
    [anon_sym_yield] = ACTIONS(2583),
    [anon_sym_move] = ACTIONS(2583),
    [anon_sym_try] = ACTIONS(2583),
    [sym_integer_literal] = ACTIONS(2581),
    [aux_sym_string_literal_token1] = ACTIONS(2581),
    [sym_char_literal] = ACTIONS(2581),
    [anon_sym_true] = ACTIONS(2583),
    [anon_sym_false] = ACTIONS(2583),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2583),
    [sym_super] = ACTIONS(2583),
    [sym_crate] = ACTIONS(2583),
    [sym_metavariable] = ACTIONS(2581),
    [sym__raw_string_literal_start] = ACTIONS(2581),
    [sym_float_literal] = ACTIONS(2581),
  },
  [666] = {
    [sym_line_comment] = STATE(666),
    [sym_block_comment] = STATE(666),
    [ts_builtin_sym_end] = ACTIONS(1236),
    [sym_identifier] = ACTIONS(1238),
    [anon_sym_SEMI] = ACTIONS(1236),
    [anon_sym_macro_rules_BANG] = ACTIONS(1236),
    [anon_sym_LPAREN] = ACTIONS(1236),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_LBRACE] = ACTIONS(1236),
    [anon_sym_RBRACE] = ACTIONS(1236),
    [anon_sym_STAR] = ACTIONS(1236),
    [anon_sym_u8] = ACTIONS(1238),
    [anon_sym_i8] = ACTIONS(1238),
    [anon_sym_u16] = ACTIONS(1238),
    [anon_sym_i16] = ACTIONS(1238),
    [anon_sym_u32] = ACTIONS(1238),
    [anon_sym_i32] = ACTIONS(1238),
    [anon_sym_u64] = ACTIONS(1238),
    [anon_sym_i64] = ACTIONS(1238),
    [anon_sym_u128] = ACTIONS(1238),
    [anon_sym_i128] = ACTIONS(1238),
    [anon_sym_isize] = ACTIONS(1238),
    [anon_sym_usize] = ACTIONS(1238),
    [anon_sym_f32] = ACTIONS(1238),
    [anon_sym_f64] = ACTIONS(1238),
    [anon_sym_bool] = ACTIONS(1238),
    [anon_sym_str] = ACTIONS(1238),
    [anon_sym_char] = ACTIONS(1238),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_BANG] = ACTIONS(1236),
    [anon_sym_AMP] = ACTIONS(1236),
    [anon_sym_PIPE] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1236),
    [anon_sym_DOT_DOT] = ACTIONS(1236),
    [anon_sym_COLON_COLON] = ACTIONS(1236),
    [anon_sym_POUND] = ACTIONS(1236),
    [anon_sym_SQUOTE] = ACTIONS(1238),
    [anon_sym_async] = ACTIONS(1238),
    [anon_sym_break] = ACTIONS(1238),
    [anon_sym_const] = ACTIONS(1238),
    [anon_sym_continue] = ACTIONS(1238),
    [anon_sym_default] = ACTIONS(1238),
    [anon_sym_enum] = ACTIONS(1238),
    [anon_sym_fn] = ACTIONS(1238),
    [anon_sym_for] = ACTIONS(1238),
    [anon_sym_if] = ACTIONS(1238),
    [anon_sym_impl] = ACTIONS(1238),
    [anon_sym_let] = ACTIONS(1238),
    [anon_sym_loop] = ACTIONS(1238),
    [anon_sym_match] = ACTIONS(1238),
    [anon_sym_mod] = ACTIONS(1238),
    [anon_sym_pub] = ACTIONS(1238),
    [anon_sym_return] = ACTIONS(1238),
    [anon_sym_static] = ACTIONS(1238),
    [anon_sym_struct] = ACTIONS(1238),
    [anon_sym_trait] = ACTIONS(1238),
    [anon_sym_type] = ACTIONS(1238),
    [anon_sym_union] = ACTIONS(1238),
    [anon_sym_unsafe] = ACTIONS(1238),
    [anon_sym_use] = ACTIONS(1238),
    [anon_sym_while] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(1238),
    [anon_sym_yield] = ACTIONS(1238),
    [anon_sym_move] = ACTIONS(1238),
    [anon_sym_try] = ACTIONS(1238),
    [sym_integer_literal] = ACTIONS(1236),
    [aux_sym_string_literal_token1] = ACTIONS(1236),
    [sym_char_literal] = ACTIONS(1236),
    [anon_sym_true] = ACTIONS(1238),
    [anon_sym_false] = ACTIONS(1238),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1238),
    [sym_super] = ACTIONS(1238),
    [sym_crate] = ACTIONS(1238),
    [sym_metavariable] = ACTIONS(1236),
    [sym__raw_string_literal_start] = ACTIONS(1236),
    [sym_float_literal] = ACTIONS(1236),
  },
  [667] = {
    [sym_line_comment] = STATE(667),
    [sym_block_comment] = STATE(667),
    [ts_builtin_sym_end] = ACTIONS(2585),
    [sym_identifier] = ACTIONS(2587),
    [anon_sym_SEMI] = ACTIONS(2585),
    [anon_sym_macro_rules_BANG] = ACTIONS(2585),
    [anon_sym_LPAREN] = ACTIONS(2585),
    [anon_sym_LBRACK] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2585),
    [anon_sym_RBRACE] = ACTIONS(2585),
    [anon_sym_STAR] = ACTIONS(2585),
    [anon_sym_u8] = ACTIONS(2587),
    [anon_sym_i8] = ACTIONS(2587),
    [anon_sym_u16] = ACTIONS(2587),
    [anon_sym_i16] = ACTIONS(2587),
    [anon_sym_u32] = ACTIONS(2587),
    [anon_sym_i32] = ACTIONS(2587),
    [anon_sym_u64] = ACTIONS(2587),
    [anon_sym_i64] = ACTIONS(2587),
    [anon_sym_u128] = ACTIONS(2587),
    [anon_sym_i128] = ACTIONS(2587),
    [anon_sym_isize] = ACTIONS(2587),
    [anon_sym_usize] = ACTIONS(2587),
    [anon_sym_f32] = ACTIONS(2587),
    [anon_sym_f64] = ACTIONS(2587),
    [anon_sym_bool] = ACTIONS(2587),
    [anon_sym_str] = ACTIONS(2587),
    [anon_sym_char] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2585),
    [anon_sym_BANG] = ACTIONS(2585),
    [anon_sym_AMP] = ACTIONS(2585),
    [anon_sym_PIPE] = ACTIONS(2585),
    [anon_sym_LT] = ACTIONS(2585),
    [anon_sym_DOT_DOT] = ACTIONS(2585),
    [anon_sym_COLON_COLON] = ACTIONS(2585),
    [anon_sym_POUND] = ACTIONS(2585),
    [anon_sym_SQUOTE] = ACTIONS(2587),
    [anon_sym_async] = ACTIONS(2587),
    [anon_sym_break] = ACTIONS(2587),
    [anon_sym_const] = ACTIONS(2587),
    [anon_sym_continue] = ACTIONS(2587),
    [anon_sym_default] = ACTIONS(2587),
    [anon_sym_enum] = ACTIONS(2587),
    [anon_sym_fn] = ACTIONS(2587),
    [anon_sym_for] = ACTIONS(2587),
    [anon_sym_if] = ACTIONS(2587),
    [anon_sym_impl] = ACTIONS(2587),
    [anon_sym_let] = ACTIONS(2587),
    [anon_sym_loop] = ACTIONS(2587),
    [anon_sym_match] = ACTIONS(2587),
    [anon_sym_mod] = ACTIONS(2587),
    [anon_sym_pub] = ACTIONS(2587),
    [anon_sym_return] = ACTIONS(2587),
    [anon_sym_static] = ACTIONS(2587),
    [anon_sym_struct] = ACTIONS(2587),
    [anon_sym_trait] = ACTIONS(2587),
    [anon_sym_type] = ACTIONS(2587),
    [anon_sym_union] = ACTIONS(2587),
    [anon_sym_unsafe] = ACTIONS(2587),
    [anon_sym_use] = ACTIONS(2587),
    [anon_sym_while] = ACTIONS(2587),
    [anon_sym_extern] = ACTIONS(2587),
    [anon_sym_yield] = ACTIONS(2587),
    [anon_sym_move] = ACTIONS(2587),
    [anon_sym_try] = ACTIONS(2587),
    [sym_integer_literal] = ACTIONS(2585),
    [aux_sym_string_literal_token1] = ACTIONS(2585),
    [sym_char_literal] = ACTIONS(2585),
    [anon_sym_true] = ACTIONS(2587),
    [anon_sym_false] = ACTIONS(2587),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2587),
    [sym_super] = ACTIONS(2587),
    [sym_crate] = ACTIONS(2587),
    [sym_metavariable] = ACTIONS(2585),
    [sym__raw_string_literal_start] = ACTIONS(2585),
    [sym_float_literal] = ACTIONS(2585),
  },
  [668] = {
    [sym_line_comment] = STATE(668),
    [sym_block_comment] = STATE(668),
    [ts_builtin_sym_end] = ACTIONS(2589),
    [sym_identifier] = ACTIONS(2591),
    [anon_sym_SEMI] = ACTIONS(2589),
    [anon_sym_macro_rules_BANG] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(2589),
    [anon_sym_LBRACE] = ACTIONS(2589),
    [anon_sym_RBRACE] = ACTIONS(2589),
    [anon_sym_STAR] = ACTIONS(2589),
    [anon_sym_u8] = ACTIONS(2591),
    [anon_sym_i8] = ACTIONS(2591),
    [anon_sym_u16] = ACTIONS(2591),
    [anon_sym_i16] = ACTIONS(2591),
    [anon_sym_u32] = ACTIONS(2591),
    [anon_sym_i32] = ACTIONS(2591),
    [anon_sym_u64] = ACTIONS(2591),
    [anon_sym_i64] = ACTIONS(2591),
    [anon_sym_u128] = ACTIONS(2591),
    [anon_sym_i128] = ACTIONS(2591),
    [anon_sym_isize] = ACTIONS(2591),
    [anon_sym_usize] = ACTIONS(2591),
    [anon_sym_f32] = ACTIONS(2591),
    [anon_sym_f64] = ACTIONS(2591),
    [anon_sym_bool] = ACTIONS(2591),
    [anon_sym_str] = ACTIONS(2591),
    [anon_sym_char] = ACTIONS(2591),
    [anon_sym_DASH] = ACTIONS(2589),
    [anon_sym_BANG] = ACTIONS(2589),
    [anon_sym_AMP] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2589),
    [anon_sym_COLON_COLON] = ACTIONS(2589),
    [anon_sym_POUND] = ACTIONS(2589),
    [anon_sym_SQUOTE] = ACTIONS(2591),
    [anon_sym_async] = ACTIONS(2591),
    [anon_sym_break] = ACTIONS(2591),
    [anon_sym_const] = ACTIONS(2591),
    [anon_sym_continue] = ACTIONS(2591),
    [anon_sym_default] = ACTIONS(2591),
    [anon_sym_enum] = ACTIONS(2591),
    [anon_sym_fn] = ACTIONS(2591),
    [anon_sym_for] = ACTIONS(2591),
    [anon_sym_if] = ACTIONS(2591),
    [anon_sym_impl] = ACTIONS(2591),
    [anon_sym_let] = ACTIONS(2591),
    [anon_sym_loop] = ACTIONS(2591),
    [anon_sym_match] = ACTIONS(2591),
    [anon_sym_mod] = ACTIONS(2591),
    [anon_sym_pub] = ACTIONS(2591),
    [anon_sym_return] = ACTIONS(2591),
    [anon_sym_static] = ACTIONS(2591),
    [anon_sym_struct] = ACTIONS(2591),
    [anon_sym_trait] = ACTIONS(2591),
    [anon_sym_type] = ACTIONS(2591),
    [anon_sym_union] = ACTIONS(2591),
    [anon_sym_unsafe] = ACTIONS(2591),
    [anon_sym_use] = ACTIONS(2591),
    [anon_sym_while] = ACTIONS(2591),
    [anon_sym_extern] = ACTIONS(2591),
    [anon_sym_yield] = ACTIONS(2591),
    [anon_sym_move] = ACTIONS(2591),
    [anon_sym_try] = ACTIONS(2591),
    [sym_integer_literal] = ACTIONS(2589),
    [aux_sym_string_literal_token1] = ACTIONS(2589),
    [sym_char_literal] = ACTIONS(2589),
    [anon_sym_true] = ACTIONS(2591),
    [anon_sym_false] = ACTIONS(2591),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2591),
    [sym_super] = ACTIONS(2591),
    [sym_crate] = ACTIONS(2591),
    [sym_metavariable] = ACTIONS(2589),
    [sym__raw_string_literal_start] = ACTIONS(2589),
    [sym_float_literal] = ACTIONS(2589),
  },
  [669] = {
    [sym_empty_statement] = STATE(1143),
    [sym_macro_definition] = STATE(1143),
    [sym_attribute_item] = STATE(1143),
    [sym_inner_attribute_item] = STATE(1143),
    [sym_mod_item] = STATE(1143),
    [sym_foreign_mod_item] = STATE(1143),
    [sym_struct_item] = STATE(1143),
    [sym_union_item] = STATE(1143),
    [sym_enum_item] = STATE(1143),
    [sym_extern_crate_declaration] = STATE(1143),
    [sym_const_item] = STATE(1143),
    [sym_static_item] = STATE(1143),
    [sym_type_item] = STATE(1143),
    [sym_function_item] = STATE(1143),
    [sym_function_signature_item] = STATE(1143),
    [sym_function_modifiers] = STATE(3583),
    [sym_impl_item] = STATE(1143),
    [sym_trait_item] = STATE(1143),
    [sym_associated_type] = STATE(1143),
    [sym_let_declaration] = STATE(1143),
    [sym_use_declaration] = STATE(1143),
    [sym_extern_modifier] = STATE(2167),
    [sym_visibility_modifier] = STATE(1927),
    [sym_bracketed_type] = STATE(3307),
    [sym_generic_type_with_turbofish] = STATE(3333),
    [sym_macro_invocation] = STATE(1143),
    [sym_scoped_identifier] = STATE(3206),
    [sym_line_comment] = STATE(669),
    [sym_block_comment] = STATE(669),
    [aux_sym_declaration_list_repeat1] = STATE(629),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(1846),
    [anon_sym_SEMI] = ACTIONS(1848),
    [anon_sym_macro_rules_BANG] = ACTIONS(1850),
    [anon_sym_RBRACE] = ACTIONS(2593),
    [anon_sym_u8] = ACTIONS(1854),
    [anon_sym_i8] = ACTIONS(1854),
    [anon_sym_u16] = ACTIONS(1854),
    [anon_sym_i16] = ACTIONS(1854),
    [anon_sym_u32] = ACTIONS(1854),
    [anon_sym_i32] = ACTIONS(1854),
    [anon_sym_u64] = ACTIONS(1854),
    [anon_sym_i64] = ACTIONS(1854),
    [anon_sym_u128] = ACTIONS(1854),
    [anon_sym_i128] = ACTIONS(1854),
    [anon_sym_isize] = ACTIONS(1854),
    [anon_sym_usize] = ACTIONS(1854),
    [anon_sym_f32] = ACTIONS(1854),
    [anon_sym_f64] = ACTIONS(1854),
    [anon_sym_bool] = ACTIONS(1854),
    [anon_sym_str] = ACTIONS(1854),
    [anon_sym_char] = ACTIONS(1854),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1856),
    [anon_sym_POUND] = ACTIONS(1858),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1860),
    [anon_sym_default] = ACTIONS(1862),
    [anon_sym_enum] = ACTIONS(1864),
    [anon_sym_fn] = ACTIONS(1866),
    [anon_sym_impl] = ACTIONS(1868),
    [anon_sym_let] = ACTIONS(1870),
    [anon_sym_mod] = ACTIONS(1872),
    [anon_sym_pub] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(1874),
    [anon_sym_struct] = ACTIONS(1876),
    [anon_sym_trait] = ACTIONS(1878),
    [anon_sym_type] = ACTIONS(1880),
    [anon_sym_union] = ACTIONS(1882),
    [anon_sym_unsafe] = ACTIONS(1884),
    [anon_sym_use] = ACTIONS(1886),
    [anon_sym_extern] = ACTIONS(1888),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1890),
    [sym_super] = ACTIONS(1890),
    [sym_crate] = ACTIONS(1892),
    [sym_metavariable] = ACTIONS(1894),
  },
  [670] = {
    [sym_line_comment] = STATE(670),
    [sym_block_comment] = STATE(670),
    [ts_builtin_sym_end] = ACTIONS(2595),
    [sym_identifier] = ACTIONS(2597),
    [anon_sym_SEMI] = ACTIONS(2595),
    [anon_sym_macro_rules_BANG] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(2595),
    [anon_sym_LBRACK] = ACTIONS(2595),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_RBRACE] = ACTIONS(2595),
    [anon_sym_STAR] = ACTIONS(2595),
    [anon_sym_u8] = ACTIONS(2597),
    [anon_sym_i8] = ACTIONS(2597),
    [anon_sym_u16] = ACTIONS(2597),
    [anon_sym_i16] = ACTIONS(2597),
    [anon_sym_u32] = ACTIONS(2597),
    [anon_sym_i32] = ACTIONS(2597),
    [anon_sym_u64] = ACTIONS(2597),
    [anon_sym_i64] = ACTIONS(2597),
    [anon_sym_u128] = ACTIONS(2597),
    [anon_sym_i128] = ACTIONS(2597),
    [anon_sym_isize] = ACTIONS(2597),
    [anon_sym_usize] = ACTIONS(2597),
    [anon_sym_f32] = ACTIONS(2597),
    [anon_sym_f64] = ACTIONS(2597),
    [anon_sym_bool] = ACTIONS(2597),
    [anon_sym_str] = ACTIONS(2597),
    [anon_sym_char] = ACTIONS(2597),
    [anon_sym_DASH] = ACTIONS(2595),
    [anon_sym_BANG] = ACTIONS(2595),
    [anon_sym_AMP] = ACTIONS(2595),
    [anon_sym_PIPE] = ACTIONS(2595),
    [anon_sym_LT] = ACTIONS(2595),
    [anon_sym_DOT_DOT] = ACTIONS(2595),
    [anon_sym_COLON_COLON] = ACTIONS(2595),
    [anon_sym_POUND] = ACTIONS(2595),
    [anon_sym_SQUOTE] = ACTIONS(2597),
    [anon_sym_async] = ACTIONS(2597),
    [anon_sym_break] = ACTIONS(2597),
    [anon_sym_const] = ACTIONS(2597),
    [anon_sym_continue] = ACTIONS(2597),
    [anon_sym_default] = ACTIONS(2597),
    [anon_sym_enum] = ACTIONS(2597),
    [anon_sym_fn] = ACTIONS(2597),
    [anon_sym_for] = ACTIONS(2597),
    [anon_sym_if] = ACTIONS(2597),
    [anon_sym_impl] = ACTIONS(2597),
    [anon_sym_let] = ACTIONS(2597),
    [anon_sym_loop] = ACTIONS(2597),
    [anon_sym_match] = ACTIONS(2597),
    [anon_sym_mod] = ACTIONS(2597),
    [anon_sym_pub] = ACTIONS(2597),
    [anon_sym_return] = ACTIONS(2597),
    [anon_sym_static] = ACTIONS(2597),
    [anon_sym_struct] = ACTIONS(2597),
    [anon_sym_trait] = ACTIONS(2597),
    [anon_sym_type] = ACTIONS(2597),
    [anon_sym_union] = ACTIONS(2597),
    [anon_sym_unsafe] = ACTIONS(2597),
    [anon_sym_use] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2597),
    [anon_sym_extern] = ACTIONS(2597),
    [anon_sym_yield] = ACTIONS(2597),
    [anon_sym_move] = ACTIONS(2597),
    [anon_sym_try] = ACTIONS(2597),
    [sym_integer_literal] = ACTIONS(2595),
    [aux_sym_string_literal_token1] = ACTIONS(2595),
    [sym_char_literal] = ACTIONS(2595),
    [anon_sym_true] = ACTIONS(2597),
    [anon_sym_false] = ACTIONS(2597),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2597),
    [sym_super] = ACTIONS(2597),
    [sym_crate] = ACTIONS(2597),
    [sym_metavariable] = ACTIONS(2595),
    [sym__raw_string_literal_start] = ACTIONS(2595),
    [sym_float_literal] = ACTIONS(2595),
  },
  [671] = {
    [sym_line_comment] = STATE(671),
    [sym_block_comment] = STATE(671),
    [ts_builtin_sym_end] = ACTIONS(2599),
    [sym_identifier] = ACTIONS(2601),
    [anon_sym_SEMI] = ACTIONS(2599),
    [anon_sym_macro_rules_BANG] = ACTIONS(2599),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_LBRACK] = ACTIONS(2599),
    [anon_sym_LBRACE] = ACTIONS(2599),
    [anon_sym_RBRACE] = ACTIONS(2599),
    [anon_sym_STAR] = ACTIONS(2599),
    [anon_sym_u8] = ACTIONS(2601),
    [anon_sym_i8] = ACTIONS(2601),
    [anon_sym_u16] = ACTIONS(2601),
    [anon_sym_i16] = ACTIONS(2601),
    [anon_sym_u32] = ACTIONS(2601),
    [anon_sym_i32] = ACTIONS(2601),
    [anon_sym_u64] = ACTIONS(2601),
    [anon_sym_i64] = ACTIONS(2601),
    [anon_sym_u128] = ACTIONS(2601),
    [anon_sym_i128] = ACTIONS(2601),
    [anon_sym_isize] = ACTIONS(2601),
    [anon_sym_usize] = ACTIONS(2601),
    [anon_sym_f32] = ACTIONS(2601),
    [anon_sym_f64] = ACTIONS(2601),
    [anon_sym_bool] = ACTIONS(2601),
    [anon_sym_str] = ACTIONS(2601),
    [anon_sym_char] = ACTIONS(2601),
    [anon_sym_DASH] = ACTIONS(2599),
    [anon_sym_BANG] = ACTIONS(2599),
    [anon_sym_AMP] = ACTIONS(2599),
    [anon_sym_PIPE] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(2599),
    [anon_sym_DOT_DOT] = ACTIONS(2599),
    [anon_sym_COLON_COLON] = ACTIONS(2599),
    [anon_sym_POUND] = ACTIONS(2599),
    [anon_sym_SQUOTE] = ACTIONS(2601),
    [anon_sym_async] = ACTIONS(2601),
    [anon_sym_break] = ACTIONS(2601),
    [anon_sym_const] = ACTIONS(2601),
    [anon_sym_continue] = ACTIONS(2601),
    [anon_sym_default] = ACTIONS(2601),
    [anon_sym_enum] = ACTIONS(2601),
    [anon_sym_fn] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2601),
    [anon_sym_if] = ACTIONS(2601),
    [anon_sym_impl] = ACTIONS(2601),
    [anon_sym_let] = ACTIONS(2601),
    [anon_sym_loop] = ACTIONS(2601),
    [anon_sym_match] = ACTIONS(2601),
    [anon_sym_mod] = ACTIONS(2601),
    [anon_sym_pub] = ACTIONS(2601),
    [anon_sym_return] = ACTIONS(2601),
    [anon_sym_static] = ACTIONS(2601),
    [anon_sym_struct] = ACTIONS(2601),
    [anon_sym_trait] = ACTIONS(2601),
    [anon_sym_type] = ACTIONS(2601),
    [anon_sym_union] = ACTIONS(2601),
    [anon_sym_unsafe] = ACTIONS(2601),
    [anon_sym_use] = ACTIONS(2601),
    [anon_sym_while] = ACTIONS(2601),
    [anon_sym_extern] = ACTIONS(2601),
    [anon_sym_yield] = ACTIONS(2601),
    [anon_sym_move] = ACTIONS(2601),
    [anon_sym_try] = ACTIONS(2601),
    [sym_integer_literal] = ACTIONS(2599),
    [aux_sym_string_literal_token1] = ACTIONS(2599),
    [sym_char_literal] = ACTIONS(2599),
    [anon_sym_true] = ACTIONS(2601),
    [anon_sym_false] = ACTIONS(2601),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2601),
    [sym_super] = ACTIONS(2601),
    [sym_crate] = ACTIONS(2601),
    [sym_metavariable] = ACTIONS(2599),
    [sym__raw_string_literal_start] = ACTIONS(2599),
    [sym_float_literal] = ACTIONS(2599),
  },
  [672] = {
    [sym_line_comment] = STATE(672),
    [sym_block_comment] = STATE(672),
    [ts_builtin_sym_end] = ACTIONS(2603),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_SEMI] = ACTIONS(2603),
    [anon_sym_macro_rules_BANG] = ACTIONS(2603),
    [anon_sym_LPAREN] = ACTIONS(2603),
    [anon_sym_LBRACK] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(2603),
    [anon_sym_RBRACE] = ACTIONS(2603),
    [anon_sym_STAR] = ACTIONS(2603),
    [anon_sym_u8] = ACTIONS(2605),
    [anon_sym_i8] = ACTIONS(2605),
    [anon_sym_u16] = ACTIONS(2605),
    [anon_sym_i16] = ACTIONS(2605),
    [anon_sym_u32] = ACTIONS(2605),
    [anon_sym_i32] = ACTIONS(2605),
    [anon_sym_u64] = ACTIONS(2605),
    [anon_sym_i64] = ACTIONS(2605),
    [anon_sym_u128] = ACTIONS(2605),
    [anon_sym_i128] = ACTIONS(2605),
    [anon_sym_isize] = ACTIONS(2605),
    [anon_sym_usize] = ACTIONS(2605),
    [anon_sym_f32] = ACTIONS(2605),
    [anon_sym_f64] = ACTIONS(2605),
    [anon_sym_bool] = ACTIONS(2605),
    [anon_sym_str] = ACTIONS(2605),
    [anon_sym_char] = ACTIONS(2605),
    [anon_sym_DASH] = ACTIONS(2603),
    [anon_sym_BANG] = ACTIONS(2603),
    [anon_sym_AMP] = ACTIONS(2603),
    [anon_sym_PIPE] = ACTIONS(2603),
    [anon_sym_LT] = ACTIONS(2603),
    [anon_sym_DOT_DOT] = ACTIONS(2603),
    [anon_sym_COLON_COLON] = ACTIONS(2603),
    [anon_sym_POUND] = ACTIONS(2603),
    [anon_sym_SQUOTE] = ACTIONS(2605),
    [anon_sym_async] = ACTIONS(2605),
    [anon_sym_break] = ACTIONS(2605),
    [anon_sym_const] = ACTIONS(2605),
    [anon_sym_continue] = ACTIONS(2605),
    [anon_sym_default] = ACTIONS(2605),
    [anon_sym_enum] = ACTIONS(2605),
    [anon_sym_fn] = ACTIONS(2605),
    [anon_sym_for] = ACTIONS(2605),
    [anon_sym_if] = ACTIONS(2605),
    [anon_sym_impl] = ACTIONS(2605),
    [anon_sym_let] = ACTIONS(2605),
    [anon_sym_loop] = ACTIONS(2605),
    [anon_sym_match] = ACTIONS(2605),
    [anon_sym_mod] = ACTIONS(2605),
    [anon_sym_pub] = ACTIONS(2605),
    [anon_sym_return] = ACTIONS(2605),
    [anon_sym_static] = ACTIONS(2605),
    [anon_sym_struct] = ACTIONS(2605),
    [anon_sym_trait] = ACTIONS(2605),
    [anon_sym_type] = ACTIONS(2605),
    [anon_sym_union] = ACTIONS(2605),
    [anon_sym_unsafe] = ACTIONS(2605),
    [anon_sym_use] = ACTIONS(2605),
    [anon_sym_while] = ACTIONS(2605),
    [anon_sym_extern] = ACTIONS(2605),
    [anon_sym_yield] = ACTIONS(2605),
    [anon_sym_move] = ACTIONS(2605),
    [anon_sym_try] = ACTIONS(2605),
    [sym_integer_literal] = ACTIONS(2603),
    [aux_sym_string_literal_token1] = ACTIONS(2603),
    [sym_char_literal] = ACTIONS(2603),
    [anon_sym_true] = ACTIONS(2605),
    [anon_sym_false] = ACTIONS(2605),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2605),
    [sym_super] = ACTIONS(2605),
    [sym_crate] = ACTIONS(2605),
    [sym_metavariable] = ACTIONS(2603),
    [sym__raw_string_literal_start] = ACTIONS(2603),
    [sym_float_literal] = ACTIONS(2603),
  },
  [673] = {
    [sym_line_comment] = STATE(673),
    [sym_block_comment] = STATE(673),
    [ts_builtin_sym_end] = ACTIONS(2607),
    [sym_identifier] = ACTIONS(2609),
    [anon_sym_SEMI] = ACTIONS(2607),
    [anon_sym_macro_rules_BANG] = ACTIONS(2607),
    [anon_sym_LPAREN] = ACTIONS(2607),
    [anon_sym_LBRACK] = ACTIONS(2607),
    [anon_sym_LBRACE] = ACTIONS(2607),
    [anon_sym_RBRACE] = ACTIONS(2607),
    [anon_sym_STAR] = ACTIONS(2607),
    [anon_sym_u8] = ACTIONS(2609),
    [anon_sym_i8] = ACTIONS(2609),
    [anon_sym_u16] = ACTIONS(2609),
    [anon_sym_i16] = ACTIONS(2609),
    [anon_sym_u32] = ACTIONS(2609),
    [anon_sym_i32] = ACTIONS(2609),
    [anon_sym_u64] = ACTIONS(2609),
    [anon_sym_i64] = ACTIONS(2609),
    [anon_sym_u128] = ACTIONS(2609),
    [anon_sym_i128] = ACTIONS(2609),
    [anon_sym_isize] = ACTIONS(2609),
    [anon_sym_usize] = ACTIONS(2609),
    [anon_sym_f32] = ACTIONS(2609),
    [anon_sym_f64] = ACTIONS(2609),
    [anon_sym_bool] = ACTIONS(2609),
    [anon_sym_str] = ACTIONS(2609),
    [anon_sym_char] = ACTIONS(2609),
    [anon_sym_DASH] = ACTIONS(2607),
    [anon_sym_BANG] = ACTIONS(2607),
    [anon_sym_AMP] = ACTIONS(2607),
    [anon_sym_PIPE] = ACTIONS(2607),
    [anon_sym_LT] = ACTIONS(2607),
    [anon_sym_DOT_DOT] = ACTIONS(2607),
    [anon_sym_COLON_COLON] = ACTIONS(2607),
    [anon_sym_POUND] = ACTIONS(2607),
    [anon_sym_SQUOTE] = ACTIONS(2609),
    [anon_sym_async] = ACTIONS(2609),
    [anon_sym_break] = ACTIONS(2609),
    [anon_sym_const] = ACTIONS(2609),
    [anon_sym_continue] = ACTIONS(2609),
    [anon_sym_default] = ACTIONS(2609),
    [anon_sym_enum] = ACTIONS(2609),
    [anon_sym_fn] = ACTIONS(2609),
    [anon_sym_for] = ACTIONS(2609),
    [anon_sym_if] = ACTIONS(2609),
    [anon_sym_impl] = ACTIONS(2609),
    [anon_sym_let] = ACTIONS(2609),
    [anon_sym_loop] = ACTIONS(2609),
    [anon_sym_match] = ACTIONS(2609),
    [anon_sym_mod] = ACTIONS(2609),
    [anon_sym_pub] = ACTIONS(2609),
    [anon_sym_return] = ACTIONS(2609),
    [anon_sym_static] = ACTIONS(2609),
    [anon_sym_struct] = ACTIONS(2609),
    [anon_sym_trait] = ACTIONS(2609),
    [anon_sym_type] = ACTIONS(2609),
    [anon_sym_union] = ACTIONS(2609),
    [anon_sym_unsafe] = ACTIONS(2609),
    [anon_sym_use] = ACTIONS(2609),
    [anon_sym_while] = ACTIONS(2609),
    [anon_sym_extern] = ACTIONS(2609),
    [anon_sym_yield] = ACTIONS(2609),
    [anon_sym_move] = ACTIONS(2609),
    [anon_sym_try] = ACTIONS(2609),
    [sym_integer_literal] = ACTIONS(2607),
    [aux_sym_string_literal_token1] = ACTIONS(2607),
    [sym_char_literal] = ACTIONS(2607),
    [anon_sym_true] = ACTIONS(2609),
    [anon_sym_false] = ACTIONS(2609),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2609),
    [sym_super] = ACTIONS(2609),
    [sym_crate] = ACTIONS(2609),
    [sym_metavariable] = ACTIONS(2607),
    [sym__raw_string_literal_start] = ACTIONS(2607),
    [sym_float_literal] = ACTIONS(2607),
  },
  [674] = {
    [sym_line_comment] = STATE(674),
    [sym_block_comment] = STATE(674),
    [ts_builtin_sym_end] = ACTIONS(2611),
    [sym_identifier] = ACTIONS(2613),
    [anon_sym_SEMI] = ACTIONS(2611),
    [anon_sym_macro_rules_BANG] = ACTIONS(2611),
    [anon_sym_LPAREN] = ACTIONS(2611),
    [anon_sym_LBRACK] = ACTIONS(2611),
    [anon_sym_LBRACE] = ACTIONS(2611),
    [anon_sym_RBRACE] = ACTIONS(2611),
    [anon_sym_STAR] = ACTIONS(2611),
    [anon_sym_u8] = ACTIONS(2613),
    [anon_sym_i8] = ACTIONS(2613),
    [anon_sym_u16] = ACTIONS(2613),
    [anon_sym_i16] = ACTIONS(2613),
    [anon_sym_u32] = ACTIONS(2613),
    [anon_sym_i32] = ACTIONS(2613),
    [anon_sym_u64] = ACTIONS(2613),
    [anon_sym_i64] = ACTIONS(2613),
    [anon_sym_u128] = ACTIONS(2613),
    [anon_sym_i128] = ACTIONS(2613),
    [anon_sym_isize] = ACTIONS(2613),
    [anon_sym_usize] = ACTIONS(2613),
    [anon_sym_f32] = ACTIONS(2613),
    [anon_sym_f64] = ACTIONS(2613),
    [anon_sym_bool] = ACTIONS(2613),
    [anon_sym_str] = ACTIONS(2613),
    [anon_sym_char] = ACTIONS(2613),
    [anon_sym_DASH] = ACTIONS(2611),
    [anon_sym_BANG] = ACTIONS(2611),
    [anon_sym_AMP] = ACTIONS(2611),
    [anon_sym_PIPE] = ACTIONS(2611),
    [anon_sym_LT] = ACTIONS(2611),
    [anon_sym_DOT_DOT] = ACTIONS(2611),
    [anon_sym_COLON_COLON] = ACTIONS(2611),
    [anon_sym_POUND] = ACTIONS(2611),
    [anon_sym_SQUOTE] = ACTIONS(2613),
    [anon_sym_async] = ACTIONS(2613),
    [anon_sym_break] = ACTIONS(2613),
    [anon_sym_const] = ACTIONS(2613),
    [anon_sym_continue] = ACTIONS(2613),
    [anon_sym_default] = ACTIONS(2613),
    [anon_sym_enum] = ACTIONS(2613),
    [anon_sym_fn] = ACTIONS(2613),
    [anon_sym_for] = ACTIONS(2613),
    [anon_sym_if] = ACTIONS(2613),
    [anon_sym_impl] = ACTIONS(2613),
    [anon_sym_let] = ACTIONS(2613),
    [anon_sym_loop] = ACTIONS(2613),
    [anon_sym_match] = ACTIONS(2613),
    [anon_sym_mod] = ACTIONS(2613),
    [anon_sym_pub] = ACTIONS(2613),
    [anon_sym_return] = ACTIONS(2613),
    [anon_sym_static] = ACTIONS(2613),
    [anon_sym_struct] = ACTIONS(2613),
    [anon_sym_trait] = ACTIONS(2613),
    [anon_sym_type] = ACTIONS(2613),
    [anon_sym_union] = ACTIONS(2613),
    [anon_sym_unsafe] = ACTIONS(2613),
    [anon_sym_use] = ACTIONS(2613),
    [anon_sym_while] = ACTIONS(2613),
    [anon_sym_extern] = ACTIONS(2613),
    [anon_sym_yield] = ACTIONS(2613),
    [anon_sym_move] = ACTIONS(2613),
    [anon_sym_try] = ACTIONS(2613),
    [sym_integer_literal] = ACTIONS(2611),
    [aux_sym_string_literal_token1] = ACTIONS(2611),
    [sym_char_literal] = ACTIONS(2611),
    [anon_sym_true] = ACTIONS(2613),
    [anon_sym_false] = ACTIONS(2613),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2613),
    [sym_super] = ACTIONS(2613),
    [sym_crate] = ACTIONS(2613),
    [sym_metavariable] = ACTIONS(2611),
    [sym__raw_string_literal_start] = ACTIONS(2611),
    [sym_float_literal] = ACTIONS(2611),
  },
  [675] = {
    [sym_line_comment] = STATE(675),
    [sym_block_comment] = STATE(675),
    [ts_builtin_sym_end] = ACTIONS(2615),
    [sym_identifier] = ACTIONS(2617),
    [anon_sym_SEMI] = ACTIONS(2615),
    [anon_sym_macro_rules_BANG] = ACTIONS(2615),
    [anon_sym_LPAREN] = ACTIONS(2615),
    [anon_sym_LBRACK] = ACTIONS(2615),
    [anon_sym_LBRACE] = ACTIONS(2615),
    [anon_sym_RBRACE] = ACTIONS(2615),
    [anon_sym_STAR] = ACTIONS(2615),
    [anon_sym_u8] = ACTIONS(2617),
    [anon_sym_i8] = ACTIONS(2617),
    [anon_sym_u16] = ACTIONS(2617),
    [anon_sym_i16] = ACTIONS(2617),
    [anon_sym_u32] = ACTIONS(2617),
    [anon_sym_i32] = ACTIONS(2617),
    [anon_sym_u64] = ACTIONS(2617),
    [anon_sym_i64] = ACTIONS(2617),
    [anon_sym_u128] = ACTIONS(2617),
    [anon_sym_i128] = ACTIONS(2617),
    [anon_sym_isize] = ACTIONS(2617),
    [anon_sym_usize] = ACTIONS(2617),
    [anon_sym_f32] = ACTIONS(2617),
    [anon_sym_f64] = ACTIONS(2617),
    [anon_sym_bool] = ACTIONS(2617),
    [anon_sym_str] = ACTIONS(2617),
    [anon_sym_char] = ACTIONS(2617),
    [anon_sym_DASH] = ACTIONS(2615),
    [anon_sym_BANG] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2615),
    [anon_sym_PIPE] = ACTIONS(2615),
    [anon_sym_LT] = ACTIONS(2615),
    [anon_sym_DOT_DOT] = ACTIONS(2615),
    [anon_sym_COLON_COLON] = ACTIONS(2615),
    [anon_sym_POUND] = ACTIONS(2615),
    [anon_sym_SQUOTE] = ACTIONS(2617),
    [anon_sym_async] = ACTIONS(2617),
    [anon_sym_break] = ACTIONS(2617),
    [anon_sym_const] = ACTIONS(2617),
    [anon_sym_continue] = ACTIONS(2617),
    [anon_sym_default] = ACTIONS(2617),
    [anon_sym_enum] = ACTIONS(2617),
    [anon_sym_fn] = ACTIONS(2617),
    [anon_sym_for] = ACTIONS(2617),
    [anon_sym_if] = ACTIONS(2617),
    [anon_sym_impl] = ACTIONS(2617),
    [anon_sym_let] = ACTIONS(2617),
    [anon_sym_loop] = ACTIONS(2617),
    [anon_sym_match] = ACTIONS(2617),
    [anon_sym_mod] = ACTIONS(2617),
    [anon_sym_pub] = ACTIONS(2617),
    [anon_sym_return] = ACTIONS(2617),
    [anon_sym_static] = ACTIONS(2617),
    [anon_sym_struct] = ACTIONS(2617),
    [anon_sym_trait] = ACTIONS(2617),
    [anon_sym_type] = ACTIONS(2617),
    [anon_sym_union] = ACTIONS(2617),
    [anon_sym_unsafe] = ACTIONS(2617),
    [anon_sym_use] = ACTIONS(2617),
    [anon_sym_while] = ACTIONS(2617),
    [anon_sym_extern] = ACTIONS(2617),
    [anon_sym_yield] = ACTIONS(2617),
    [anon_sym_move] = ACTIONS(2617),
    [anon_sym_try] = ACTIONS(2617),
    [sym_integer_literal] = ACTIONS(2615),
    [aux_sym_string_literal_token1] = ACTIONS(2615),
    [sym_char_literal] = ACTIONS(2615),
    [anon_sym_true] = ACTIONS(2617),
    [anon_sym_false] = ACTIONS(2617),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2617),
    [sym_super] = ACTIONS(2617),
    [sym_crate] = ACTIONS(2617),
    [sym_metavariable] = ACTIONS(2615),
    [sym__raw_string_literal_start] = ACTIONS(2615),
    [sym_float_literal] = ACTIONS(2615),
  },
  [676] = {
    [sym_line_comment] = STATE(676),
    [sym_block_comment] = STATE(676),
    [ts_builtin_sym_end] = ACTIONS(2619),
    [sym_identifier] = ACTIONS(2621),
    [anon_sym_SEMI] = ACTIONS(2619),
    [anon_sym_macro_rules_BANG] = ACTIONS(2619),
    [anon_sym_LPAREN] = ACTIONS(2619),
    [anon_sym_LBRACK] = ACTIONS(2619),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_RBRACE] = ACTIONS(2619),
    [anon_sym_STAR] = ACTIONS(2619),
    [anon_sym_u8] = ACTIONS(2621),
    [anon_sym_i8] = ACTIONS(2621),
    [anon_sym_u16] = ACTIONS(2621),
    [anon_sym_i16] = ACTIONS(2621),
    [anon_sym_u32] = ACTIONS(2621),
    [anon_sym_i32] = ACTIONS(2621),
    [anon_sym_u64] = ACTIONS(2621),
    [anon_sym_i64] = ACTIONS(2621),
    [anon_sym_u128] = ACTIONS(2621),
    [anon_sym_i128] = ACTIONS(2621),
    [anon_sym_isize] = ACTIONS(2621),
    [anon_sym_usize] = ACTIONS(2621),
    [anon_sym_f32] = ACTIONS(2621),
    [anon_sym_f64] = ACTIONS(2621),
    [anon_sym_bool] = ACTIONS(2621),
    [anon_sym_str] = ACTIONS(2621),
    [anon_sym_char] = ACTIONS(2621),
    [anon_sym_DASH] = ACTIONS(2619),
    [anon_sym_BANG] = ACTIONS(2619),
    [anon_sym_AMP] = ACTIONS(2619),
    [anon_sym_PIPE] = ACTIONS(2619),
    [anon_sym_LT] = ACTIONS(2619),
    [anon_sym_DOT_DOT] = ACTIONS(2619),
    [anon_sym_COLON_COLON] = ACTIONS(2619),
    [anon_sym_POUND] = ACTIONS(2619),
    [anon_sym_SQUOTE] = ACTIONS(2621),
    [anon_sym_async] = ACTIONS(2621),
    [anon_sym_break] = ACTIONS(2621),
    [anon_sym_const] = ACTIONS(2621),
    [anon_sym_continue] = ACTIONS(2621),
    [anon_sym_default] = ACTIONS(2621),
    [anon_sym_enum] = ACTIONS(2621),
    [anon_sym_fn] = ACTIONS(2621),
    [anon_sym_for] = ACTIONS(2621),
    [anon_sym_if] = ACTIONS(2621),
    [anon_sym_impl] = ACTIONS(2621),
    [anon_sym_let] = ACTIONS(2621),
    [anon_sym_loop] = ACTIONS(2621),
    [anon_sym_match] = ACTIONS(2621),
    [anon_sym_mod] = ACTIONS(2621),
    [anon_sym_pub] = ACTIONS(2621),
    [anon_sym_return] = ACTIONS(2621),
    [anon_sym_static] = ACTIONS(2621),
    [anon_sym_struct] = ACTIONS(2621),
    [anon_sym_trait] = ACTIONS(2621),
    [anon_sym_type] = ACTIONS(2621),
    [anon_sym_union] = ACTIONS(2621),
    [anon_sym_unsafe] = ACTIONS(2621),
    [anon_sym_use] = ACTIONS(2621),
    [anon_sym_while] = ACTIONS(2621),
    [anon_sym_extern] = ACTIONS(2621),
    [anon_sym_yield] = ACTIONS(2621),
    [anon_sym_move] = ACTIONS(2621),
    [anon_sym_try] = ACTIONS(2621),
    [sym_integer_literal] = ACTIONS(2619),
    [aux_sym_string_literal_token1] = ACTIONS(2619),
    [sym_char_literal] = ACTIONS(2619),
    [anon_sym_true] = ACTIONS(2621),
    [anon_sym_false] = ACTIONS(2621),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2621),
    [sym_super] = ACTIONS(2621),
    [sym_crate] = ACTIONS(2621),
    [sym_metavariable] = ACTIONS(2619),
    [sym__raw_string_literal_start] = ACTIONS(2619),
    [sym_float_literal] = ACTIONS(2619),
  },
  [677] = {
    [sym_line_comment] = STATE(677),
    [sym_block_comment] = STATE(677),
    [ts_builtin_sym_end] = ACTIONS(2623),
    [sym_identifier] = ACTIONS(2625),
    [anon_sym_SEMI] = ACTIONS(2623),
    [anon_sym_macro_rules_BANG] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2623),
    [anon_sym_LBRACK] = ACTIONS(2623),
    [anon_sym_LBRACE] = ACTIONS(2623),
    [anon_sym_RBRACE] = ACTIONS(2623),
    [anon_sym_STAR] = ACTIONS(2623),
    [anon_sym_u8] = ACTIONS(2625),
    [anon_sym_i8] = ACTIONS(2625),
    [anon_sym_u16] = ACTIONS(2625),
    [anon_sym_i16] = ACTIONS(2625),
    [anon_sym_u32] = ACTIONS(2625),
    [anon_sym_i32] = ACTIONS(2625),
    [anon_sym_u64] = ACTIONS(2625),
    [anon_sym_i64] = ACTIONS(2625),
    [anon_sym_u128] = ACTIONS(2625),
    [anon_sym_i128] = ACTIONS(2625),
    [anon_sym_isize] = ACTIONS(2625),
    [anon_sym_usize] = ACTIONS(2625),
    [anon_sym_f32] = ACTIONS(2625),
    [anon_sym_f64] = ACTIONS(2625),
    [anon_sym_bool] = ACTIONS(2625),
    [anon_sym_str] = ACTIONS(2625),
    [anon_sym_char] = ACTIONS(2625),
    [anon_sym_DASH] = ACTIONS(2623),
    [anon_sym_BANG] = ACTIONS(2623),
    [anon_sym_AMP] = ACTIONS(2623),
    [anon_sym_PIPE] = ACTIONS(2623),
    [anon_sym_LT] = ACTIONS(2623),
    [anon_sym_DOT_DOT] = ACTIONS(2623),
    [anon_sym_COLON_COLON] = ACTIONS(2623),
    [anon_sym_POUND] = ACTIONS(2623),
    [anon_sym_SQUOTE] = ACTIONS(2625),
    [anon_sym_async] = ACTIONS(2625),
    [anon_sym_break] = ACTIONS(2625),
    [anon_sym_const] = ACTIONS(2625),
    [anon_sym_continue] = ACTIONS(2625),
    [anon_sym_default] = ACTIONS(2625),
    [anon_sym_enum] = ACTIONS(2625),
    [anon_sym_fn] = ACTIONS(2625),
    [anon_sym_for] = ACTIONS(2625),
    [anon_sym_if] = ACTIONS(2625),
    [anon_sym_impl] = ACTIONS(2625),
    [anon_sym_let] = ACTIONS(2625),
    [anon_sym_loop] = ACTIONS(2625),
    [anon_sym_match] = ACTIONS(2625),
    [anon_sym_mod] = ACTIONS(2625),
    [anon_sym_pub] = ACTIONS(2625),
    [anon_sym_return] = ACTIONS(2625),
    [anon_sym_static] = ACTIONS(2625),
    [anon_sym_struct] = ACTIONS(2625),
    [anon_sym_trait] = ACTIONS(2625),
    [anon_sym_type] = ACTIONS(2625),
    [anon_sym_union] = ACTIONS(2625),
    [anon_sym_unsafe] = ACTIONS(2625),
    [anon_sym_use] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(2625),
    [anon_sym_extern] = ACTIONS(2625),
    [anon_sym_yield] = ACTIONS(2625),
    [anon_sym_move] = ACTIONS(2625),
    [anon_sym_try] = ACTIONS(2625),
    [sym_integer_literal] = ACTIONS(2623),
    [aux_sym_string_literal_token1] = ACTIONS(2623),
    [sym_char_literal] = ACTIONS(2623),
    [anon_sym_true] = ACTIONS(2625),
    [anon_sym_false] = ACTIONS(2625),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2625),
    [sym_super] = ACTIONS(2625),
    [sym_crate] = ACTIONS(2625),
    [sym_metavariable] = ACTIONS(2623),
    [sym__raw_string_literal_start] = ACTIONS(2623),
    [sym_float_literal] = ACTIONS(2623),
  },
  [678] = {
    [sym_line_comment] = STATE(678),
    [sym_block_comment] = STATE(678),
    [ts_builtin_sym_end] = ACTIONS(2627),
    [sym_identifier] = ACTIONS(2629),
    [anon_sym_SEMI] = ACTIONS(2627),
    [anon_sym_macro_rules_BANG] = ACTIONS(2627),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [anon_sym_LBRACK] = ACTIONS(2627),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_RBRACE] = ACTIONS(2627),
    [anon_sym_STAR] = ACTIONS(2627),
    [anon_sym_u8] = ACTIONS(2629),
    [anon_sym_i8] = ACTIONS(2629),
    [anon_sym_u16] = ACTIONS(2629),
    [anon_sym_i16] = ACTIONS(2629),
    [anon_sym_u32] = ACTIONS(2629),
    [anon_sym_i32] = ACTIONS(2629),
    [anon_sym_u64] = ACTIONS(2629),
    [anon_sym_i64] = ACTIONS(2629),
    [anon_sym_u128] = ACTIONS(2629),
    [anon_sym_i128] = ACTIONS(2629),
    [anon_sym_isize] = ACTIONS(2629),
    [anon_sym_usize] = ACTIONS(2629),
    [anon_sym_f32] = ACTIONS(2629),
    [anon_sym_f64] = ACTIONS(2629),
    [anon_sym_bool] = ACTIONS(2629),
    [anon_sym_str] = ACTIONS(2629),
    [anon_sym_char] = ACTIONS(2629),
    [anon_sym_DASH] = ACTIONS(2627),
    [anon_sym_BANG] = ACTIONS(2627),
    [anon_sym_AMP] = ACTIONS(2627),
    [anon_sym_PIPE] = ACTIONS(2627),
    [anon_sym_LT] = ACTIONS(2627),
    [anon_sym_DOT_DOT] = ACTIONS(2627),
    [anon_sym_COLON_COLON] = ACTIONS(2627),
    [anon_sym_POUND] = ACTIONS(2627),
    [anon_sym_SQUOTE] = ACTIONS(2629),
    [anon_sym_async] = ACTIONS(2629),
    [anon_sym_break] = ACTIONS(2629),
    [anon_sym_const] = ACTIONS(2629),
    [anon_sym_continue] = ACTIONS(2629),
    [anon_sym_default] = ACTIONS(2629),
    [anon_sym_enum] = ACTIONS(2629),
    [anon_sym_fn] = ACTIONS(2629),
    [anon_sym_for] = ACTIONS(2629),
    [anon_sym_if] = ACTIONS(2629),
    [anon_sym_impl] = ACTIONS(2629),
    [anon_sym_let] = ACTIONS(2629),
    [anon_sym_loop] = ACTIONS(2629),
    [anon_sym_match] = ACTIONS(2629),
    [anon_sym_mod] = ACTIONS(2629),
    [anon_sym_pub] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(2629),
    [anon_sym_static] = ACTIONS(2629),
    [anon_sym_struct] = ACTIONS(2629),
    [anon_sym_trait] = ACTIONS(2629),
    [anon_sym_type] = ACTIONS(2629),
    [anon_sym_union] = ACTIONS(2629),
    [anon_sym_unsafe] = ACTIONS(2629),
    [anon_sym_use] = ACTIONS(2629),
    [anon_sym_while] = ACTIONS(2629),
    [anon_sym_extern] = ACTIONS(2629),
    [anon_sym_yield] = ACTIONS(2629),
    [anon_sym_move] = ACTIONS(2629),
    [anon_sym_try] = ACTIONS(2629),
    [sym_integer_literal] = ACTIONS(2627),
    [aux_sym_string_literal_token1] = ACTIONS(2627),
    [sym_char_literal] = ACTIONS(2627),
    [anon_sym_true] = ACTIONS(2629),
    [anon_sym_false] = ACTIONS(2629),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2629),
    [sym_super] = ACTIONS(2629),
    [sym_crate] = ACTIONS(2629),
    [sym_metavariable] = ACTIONS(2627),
    [sym__raw_string_literal_start] = ACTIONS(2627),
    [sym_float_literal] = ACTIONS(2627),
  },
  [679] = {
    [sym_line_comment] = STATE(679),
    [sym_block_comment] = STATE(679),
    [ts_builtin_sym_end] = ACTIONS(2631),
    [sym_identifier] = ACTIONS(2633),
    [anon_sym_SEMI] = ACTIONS(2631),
    [anon_sym_macro_rules_BANG] = ACTIONS(2631),
    [anon_sym_LPAREN] = ACTIONS(2631),
    [anon_sym_LBRACK] = ACTIONS(2631),
    [anon_sym_LBRACE] = ACTIONS(2631),
    [anon_sym_RBRACE] = ACTIONS(2631),
    [anon_sym_STAR] = ACTIONS(2631),
    [anon_sym_u8] = ACTIONS(2633),
    [anon_sym_i8] = ACTIONS(2633),
    [anon_sym_u16] = ACTIONS(2633),
    [anon_sym_i16] = ACTIONS(2633),
    [anon_sym_u32] = ACTIONS(2633),
    [anon_sym_i32] = ACTIONS(2633),
    [anon_sym_u64] = ACTIONS(2633),
    [anon_sym_i64] = ACTIONS(2633),
    [anon_sym_u128] = ACTIONS(2633),
    [anon_sym_i128] = ACTIONS(2633),
    [anon_sym_isize] = ACTIONS(2633),
    [anon_sym_usize] = ACTIONS(2633),
    [anon_sym_f32] = ACTIONS(2633),
    [anon_sym_f64] = ACTIONS(2633),
    [anon_sym_bool] = ACTIONS(2633),
    [anon_sym_str] = ACTIONS(2633),
    [anon_sym_char] = ACTIONS(2633),
    [anon_sym_DASH] = ACTIONS(2631),
    [anon_sym_BANG] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2631),
    [anon_sym_PIPE] = ACTIONS(2631),
    [anon_sym_LT] = ACTIONS(2631),
    [anon_sym_DOT_DOT] = ACTIONS(2631),
    [anon_sym_COLON_COLON] = ACTIONS(2631),
    [anon_sym_POUND] = ACTIONS(2631),
    [anon_sym_SQUOTE] = ACTIONS(2633),
    [anon_sym_async] = ACTIONS(2633),
    [anon_sym_break] = ACTIONS(2633),
    [anon_sym_const] = ACTIONS(2633),
    [anon_sym_continue] = ACTIONS(2633),
    [anon_sym_default] = ACTIONS(2633),
    [anon_sym_enum] = ACTIONS(2633),
    [anon_sym_fn] = ACTIONS(2633),
    [anon_sym_for] = ACTIONS(2633),
    [anon_sym_if] = ACTIONS(2633),
    [anon_sym_impl] = ACTIONS(2633),
    [anon_sym_let] = ACTIONS(2633),
    [anon_sym_loop] = ACTIONS(2633),
    [anon_sym_match] = ACTIONS(2633),
    [anon_sym_mod] = ACTIONS(2633),
    [anon_sym_pub] = ACTIONS(2633),
    [anon_sym_return] = ACTIONS(2633),
    [anon_sym_static] = ACTIONS(2633),
    [anon_sym_struct] = ACTIONS(2633),
    [anon_sym_trait] = ACTIONS(2633),
    [anon_sym_type] = ACTIONS(2633),
    [anon_sym_union] = ACTIONS(2633),
    [anon_sym_unsafe] = ACTIONS(2633),
    [anon_sym_use] = ACTIONS(2633),
    [anon_sym_while] = ACTIONS(2633),
    [anon_sym_extern] = ACTIONS(2633),
    [anon_sym_yield] = ACTIONS(2633),
    [anon_sym_move] = ACTIONS(2633),
    [anon_sym_try] = ACTIONS(2633),
    [sym_integer_literal] = ACTIONS(2631),
    [aux_sym_string_literal_token1] = ACTIONS(2631),
    [sym_char_literal] = ACTIONS(2631),
    [anon_sym_true] = ACTIONS(2633),
    [anon_sym_false] = ACTIONS(2633),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2633),
    [sym_super] = ACTIONS(2633),
    [sym_crate] = ACTIONS(2633),
    [sym_metavariable] = ACTIONS(2631),
    [sym__raw_string_literal_start] = ACTIONS(2631),
    [sym_float_literal] = ACTIONS(2631),
  },
  [680] = {
    [sym_line_comment] = STATE(680),
    [sym_block_comment] = STATE(680),
    [ts_builtin_sym_end] = ACTIONS(1228),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_SEMI] = ACTIONS(1228),
    [anon_sym_macro_rules_BANG] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1228),
    [anon_sym_LBRACK] = ACTIONS(1228),
    [anon_sym_LBRACE] = ACTIONS(1228),
    [anon_sym_RBRACE] = ACTIONS(1228),
    [anon_sym_STAR] = ACTIONS(1228),
    [anon_sym_u8] = ACTIONS(1230),
    [anon_sym_i8] = ACTIONS(1230),
    [anon_sym_u16] = ACTIONS(1230),
    [anon_sym_i16] = ACTIONS(1230),
    [anon_sym_u32] = ACTIONS(1230),
    [anon_sym_i32] = ACTIONS(1230),
    [anon_sym_u64] = ACTIONS(1230),
    [anon_sym_i64] = ACTIONS(1230),
    [anon_sym_u128] = ACTIONS(1230),
    [anon_sym_i128] = ACTIONS(1230),
    [anon_sym_isize] = ACTIONS(1230),
    [anon_sym_usize] = ACTIONS(1230),
    [anon_sym_f32] = ACTIONS(1230),
    [anon_sym_f64] = ACTIONS(1230),
    [anon_sym_bool] = ACTIONS(1230),
    [anon_sym_str] = ACTIONS(1230),
    [anon_sym_char] = ACTIONS(1230),
    [anon_sym_DASH] = ACTIONS(1228),
    [anon_sym_BANG] = ACTIONS(1228),
    [anon_sym_AMP] = ACTIONS(1228),
    [anon_sym_PIPE] = ACTIONS(1228),
    [anon_sym_LT] = ACTIONS(1228),
    [anon_sym_DOT_DOT] = ACTIONS(1228),
    [anon_sym_COLON_COLON] = ACTIONS(1228),
    [anon_sym_POUND] = ACTIONS(1228),
    [anon_sym_SQUOTE] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1230),
    [anon_sym_break] = ACTIONS(1230),
    [anon_sym_const] = ACTIONS(1230),
    [anon_sym_continue] = ACTIONS(1230),
    [anon_sym_default] = ACTIONS(1230),
    [anon_sym_enum] = ACTIONS(1230),
    [anon_sym_fn] = ACTIONS(1230),
    [anon_sym_for] = ACTIONS(1230),
    [anon_sym_if] = ACTIONS(1230),
    [anon_sym_impl] = ACTIONS(1230),
    [anon_sym_let] = ACTIONS(1230),
    [anon_sym_loop] = ACTIONS(1230),
    [anon_sym_match] = ACTIONS(1230),
    [anon_sym_mod] = ACTIONS(1230),
    [anon_sym_pub] = ACTIONS(1230),
    [anon_sym_return] = ACTIONS(1230),
    [anon_sym_static] = ACTIONS(1230),
    [anon_sym_struct] = ACTIONS(1230),
    [anon_sym_trait] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_union] = ACTIONS(1230),
    [anon_sym_unsafe] = ACTIONS(1230),
    [anon_sym_use] = ACTIONS(1230),
    [anon_sym_while] = ACTIONS(1230),
    [anon_sym_extern] = ACTIONS(1230),
    [anon_sym_yield] = ACTIONS(1230),
    [anon_sym_move] = ACTIONS(1230),
    [anon_sym_try] = ACTIONS(1230),
    [sym_integer_literal] = ACTIONS(1228),
    [aux_sym_string_literal_token1] = ACTIONS(1228),
    [sym_char_literal] = ACTIONS(1228),
    [anon_sym_true] = ACTIONS(1230),
    [anon_sym_false] = ACTIONS(1230),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1230),
    [sym_super] = ACTIONS(1230),
    [sym_crate] = ACTIONS(1230),
    [sym_metavariable] = ACTIONS(1228),
    [sym__raw_string_literal_start] = ACTIONS(1228),
    [sym_float_literal] = ACTIONS(1228),
  },
  [681] = {
    [sym_line_comment] = STATE(681),
    [sym_block_comment] = STATE(681),
    [ts_builtin_sym_end] = ACTIONS(2635),
    [sym_identifier] = ACTIONS(2637),
    [anon_sym_SEMI] = ACTIONS(2635),
    [anon_sym_macro_rules_BANG] = ACTIONS(2635),
    [anon_sym_LPAREN] = ACTIONS(2635),
    [anon_sym_LBRACK] = ACTIONS(2635),
    [anon_sym_LBRACE] = ACTIONS(2635),
    [anon_sym_RBRACE] = ACTIONS(2635),
    [anon_sym_STAR] = ACTIONS(2635),
    [anon_sym_u8] = ACTIONS(2637),
    [anon_sym_i8] = ACTIONS(2637),
    [anon_sym_u16] = ACTIONS(2637),
    [anon_sym_i16] = ACTIONS(2637),
    [anon_sym_u32] = ACTIONS(2637),
    [anon_sym_i32] = ACTIONS(2637),
    [anon_sym_u64] = ACTIONS(2637),
    [anon_sym_i64] = ACTIONS(2637),
    [anon_sym_u128] = ACTIONS(2637),
    [anon_sym_i128] = ACTIONS(2637),
    [anon_sym_isize] = ACTIONS(2637),
    [anon_sym_usize] = ACTIONS(2637),
    [anon_sym_f32] = ACTIONS(2637),
    [anon_sym_f64] = ACTIONS(2637),
    [anon_sym_bool] = ACTIONS(2637),
    [anon_sym_str] = ACTIONS(2637),
    [anon_sym_char] = ACTIONS(2637),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_BANG] = ACTIONS(2635),
    [anon_sym_AMP] = ACTIONS(2635),
    [anon_sym_PIPE] = ACTIONS(2635),
    [anon_sym_LT] = ACTIONS(2635),
    [anon_sym_DOT_DOT] = ACTIONS(2635),
    [anon_sym_COLON_COLON] = ACTIONS(2635),
    [anon_sym_POUND] = ACTIONS(2635),
    [anon_sym_SQUOTE] = ACTIONS(2637),
    [anon_sym_async] = ACTIONS(2637),
    [anon_sym_break] = ACTIONS(2637),
    [anon_sym_const] = ACTIONS(2637),
    [anon_sym_continue] = ACTIONS(2637),
    [anon_sym_default] = ACTIONS(2637),
    [anon_sym_enum] = ACTIONS(2637),
    [anon_sym_fn] = ACTIONS(2637),
    [anon_sym_for] = ACTIONS(2637),
    [anon_sym_if] = ACTIONS(2637),
    [anon_sym_impl] = ACTIONS(2637),
    [anon_sym_let] = ACTIONS(2637),
    [anon_sym_loop] = ACTIONS(2637),
    [anon_sym_match] = ACTIONS(2637),
    [anon_sym_mod] = ACTIONS(2637),
    [anon_sym_pub] = ACTIONS(2637),
    [anon_sym_return] = ACTIONS(2637),
    [anon_sym_static] = ACTIONS(2637),
    [anon_sym_struct] = ACTIONS(2637),
    [anon_sym_trait] = ACTIONS(2637),
    [anon_sym_type] = ACTIONS(2637),
    [anon_sym_union] = ACTIONS(2637),
    [anon_sym_unsafe] = ACTIONS(2637),
    [anon_sym_use] = ACTIONS(2637),
    [anon_sym_while] = ACTIONS(2637),
    [anon_sym_extern] = ACTIONS(2637),
    [anon_sym_yield] = ACTIONS(2637),
    [anon_sym_move] = ACTIONS(2637),
    [anon_sym_try] = ACTIONS(2637),
    [sym_integer_literal] = ACTIONS(2635),
    [aux_sym_string_literal_token1] = ACTIONS(2635),
    [sym_char_literal] = ACTIONS(2635),
    [anon_sym_true] = ACTIONS(2637),
    [anon_sym_false] = ACTIONS(2637),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2637),
    [sym_super] = ACTIONS(2637),
    [sym_crate] = ACTIONS(2637),
    [sym_metavariable] = ACTIONS(2635),
    [sym__raw_string_literal_start] = ACTIONS(2635),
    [sym_float_literal] = ACTIONS(2635),
  },
  [682] = {
    [sym_line_comment] = STATE(682),
    [sym_block_comment] = STATE(682),
    [ts_builtin_sym_end] = ACTIONS(2639),
    [sym_identifier] = ACTIONS(2641),
    [anon_sym_SEMI] = ACTIONS(2639),
    [anon_sym_macro_rules_BANG] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(2639),
    [anon_sym_LBRACK] = ACTIONS(2639),
    [anon_sym_LBRACE] = ACTIONS(2639),
    [anon_sym_RBRACE] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(2639),
    [anon_sym_u8] = ACTIONS(2641),
    [anon_sym_i8] = ACTIONS(2641),
    [anon_sym_u16] = ACTIONS(2641),
    [anon_sym_i16] = ACTIONS(2641),
    [anon_sym_u32] = ACTIONS(2641),
    [anon_sym_i32] = ACTIONS(2641),
    [anon_sym_u64] = ACTIONS(2641),
    [anon_sym_i64] = ACTIONS(2641),
    [anon_sym_u128] = ACTIONS(2641),
    [anon_sym_i128] = ACTIONS(2641),
    [anon_sym_isize] = ACTIONS(2641),
    [anon_sym_usize] = ACTIONS(2641),
    [anon_sym_f32] = ACTIONS(2641),
    [anon_sym_f64] = ACTIONS(2641),
    [anon_sym_bool] = ACTIONS(2641),
    [anon_sym_str] = ACTIONS(2641),
    [anon_sym_char] = ACTIONS(2641),
    [anon_sym_DASH] = ACTIONS(2639),
    [anon_sym_BANG] = ACTIONS(2639),
    [anon_sym_AMP] = ACTIONS(2639),
    [anon_sym_PIPE] = ACTIONS(2639),
    [anon_sym_LT] = ACTIONS(2639),
    [anon_sym_DOT_DOT] = ACTIONS(2639),
    [anon_sym_COLON_COLON] = ACTIONS(2639),
    [anon_sym_POUND] = ACTIONS(2639),
    [anon_sym_SQUOTE] = ACTIONS(2641),
    [anon_sym_async] = ACTIONS(2641),
    [anon_sym_break] = ACTIONS(2641),
    [anon_sym_const] = ACTIONS(2641),
    [anon_sym_continue] = ACTIONS(2641),
    [anon_sym_default] = ACTIONS(2641),
    [anon_sym_enum] = ACTIONS(2641),
    [anon_sym_fn] = ACTIONS(2641),
    [anon_sym_for] = ACTIONS(2641),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_impl] = ACTIONS(2641),
    [anon_sym_let] = ACTIONS(2641),
    [anon_sym_loop] = ACTIONS(2641),
    [anon_sym_match] = ACTIONS(2641),
    [anon_sym_mod] = ACTIONS(2641),
    [anon_sym_pub] = ACTIONS(2641),
    [anon_sym_return] = ACTIONS(2641),
    [anon_sym_static] = ACTIONS(2641),
    [anon_sym_struct] = ACTIONS(2641),
    [anon_sym_trait] = ACTIONS(2641),
    [anon_sym_type] = ACTIONS(2641),
    [anon_sym_union] = ACTIONS(2641),
    [anon_sym_unsafe] = ACTIONS(2641),
    [anon_sym_use] = ACTIONS(2641),
    [anon_sym_while] = ACTIONS(2641),
    [anon_sym_extern] = ACTIONS(2641),
    [anon_sym_yield] = ACTIONS(2641),
    [anon_sym_move] = ACTIONS(2641),
    [anon_sym_try] = ACTIONS(2641),
    [sym_integer_literal] = ACTIONS(2639),
    [aux_sym_string_literal_token1] = ACTIONS(2639),
    [sym_char_literal] = ACTIONS(2639),
    [anon_sym_true] = ACTIONS(2641),
    [anon_sym_false] = ACTIONS(2641),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2641),
    [sym_super] = ACTIONS(2641),
    [sym_crate] = ACTIONS(2641),
    [sym_metavariable] = ACTIONS(2639),
    [sym__raw_string_literal_start] = ACTIONS(2639),
    [sym_float_literal] = ACTIONS(2639),
  },
  [683] = {
    [sym_line_comment] = STATE(683),
    [sym_block_comment] = STATE(683),
    [ts_builtin_sym_end] = ACTIONS(2643),
    [sym_identifier] = ACTIONS(2645),
    [anon_sym_SEMI] = ACTIONS(2643),
    [anon_sym_macro_rules_BANG] = ACTIONS(2643),
    [anon_sym_LPAREN] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2643),
    [anon_sym_RBRACE] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2643),
    [anon_sym_u8] = ACTIONS(2645),
    [anon_sym_i8] = ACTIONS(2645),
    [anon_sym_u16] = ACTIONS(2645),
    [anon_sym_i16] = ACTIONS(2645),
    [anon_sym_u32] = ACTIONS(2645),
    [anon_sym_i32] = ACTIONS(2645),
    [anon_sym_u64] = ACTIONS(2645),
    [anon_sym_i64] = ACTIONS(2645),
    [anon_sym_u128] = ACTIONS(2645),
    [anon_sym_i128] = ACTIONS(2645),
    [anon_sym_isize] = ACTIONS(2645),
    [anon_sym_usize] = ACTIONS(2645),
    [anon_sym_f32] = ACTIONS(2645),
    [anon_sym_f64] = ACTIONS(2645),
    [anon_sym_bool] = ACTIONS(2645),
    [anon_sym_str] = ACTIONS(2645),
    [anon_sym_char] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_BANG] = ACTIONS(2643),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_PIPE] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(2643),
    [anon_sym_DOT_DOT] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2643),
    [anon_sym_POUND] = ACTIONS(2643),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_async] = ACTIONS(2645),
    [anon_sym_break] = ACTIONS(2645),
    [anon_sym_const] = ACTIONS(2645),
    [anon_sym_continue] = ACTIONS(2645),
    [anon_sym_default] = ACTIONS(2645),
    [anon_sym_enum] = ACTIONS(2645),
    [anon_sym_fn] = ACTIONS(2645),
    [anon_sym_for] = ACTIONS(2645),
    [anon_sym_if] = ACTIONS(2645),
    [anon_sym_impl] = ACTIONS(2645),
    [anon_sym_let] = ACTIONS(2645),
    [anon_sym_loop] = ACTIONS(2645),
    [anon_sym_match] = ACTIONS(2645),
    [anon_sym_mod] = ACTIONS(2645),
    [anon_sym_pub] = ACTIONS(2645),
    [anon_sym_return] = ACTIONS(2645),
    [anon_sym_static] = ACTIONS(2645),
    [anon_sym_struct] = ACTIONS(2645),
    [anon_sym_trait] = ACTIONS(2645),
    [anon_sym_type] = ACTIONS(2645),
    [anon_sym_union] = ACTIONS(2645),
    [anon_sym_unsafe] = ACTIONS(2645),
    [anon_sym_use] = ACTIONS(2645),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_extern] = ACTIONS(2645),
    [anon_sym_yield] = ACTIONS(2645),
    [anon_sym_move] = ACTIONS(2645),
    [anon_sym_try] = ACTIONS(2645),
    [sym_integer_literal] = ACTIONS(2643),
    [aux_sym_string_literal_token1] = ACTIONS(2643),
    [sym_char_literal] = ACTIONS(2643),
    [anon_sym_true] = ACTIONS(2645),
    [anon_sym_false] = ACTIONS(2645),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2645),
    [sym_super] = ACTIONS(2645),
    [sym_crate] = ACTIONS(2645),
    [sym_metavariable] = ACTIONS(2643),
    [sym__raw_string_literal_start] = ACTIONS(2643),
    [sym_float_literal] = ACTIONS(2643),
  },
  [684] = {
    [sym_line_comment] = STATE(684),
    [sym_block_comment] = STATE(684),
    [ts_builtin_sym_end] = ACTIONS(2647),
    [sym_identifier] = ACTIONS(2649),
    [anon_sym_SEMI] = ACTIONS(2647),
    [anon_sym_macro_rules_BANG] = ACTIONS(2647),
    [anon_sym_LPAREN] = ACTIONS(2647),
    [anon_sym_LBRACK] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2647),
    [anon_sym_RBRACE] = ACTIONS(2647),
    [anon_sym_STAR] = ACTIONS(2647),
    [anon_sym_u8] = ACTIONS(2649),
    [anon_sym_i8] = ACTIONS(2649),
    [anon_sym_u16] = ACTIONS(2649),
    [anon_sym_i16] = ACTIONS(2649),
    [anon_sym_u32] = ACTIONS(2649),
    [anon_sym_i32] = ACTIONS(2649),
    [anon_sym_u64] = ACTIONS(2649),
    [anon_sym_i64] = ACTIONS(2649),
    [anon_sym_u128] = ACTIONS(2649),
    [anon_sym_i128] = ACTIONS(2649),
    [anon_sym_isize] = ACTIONS(2649),
    [anon_sym_usize] = ACTIONS(2649),
    [anon_sym_f32] = ACTIONS(2649),
    [anon_sym_f64] = ACTIONS(2649),
    [anon_sym_bool] = ACTIONS(2649),
    [anon_sym_str] = ACTIONS(2649),
    [anon_sym_char] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2647),
    [anon_sym_BANG] = ACTIONS(2647),
    [anon_sym_AMP] = ACTIONS(2647),
    [anon_sym_PIPE] = ACTIONS(2647),
    [anon_sym_LT] = ACTIONS(2647),
    [anon_sym_DOT_DOT] = ACTIONS(2647),
    [anon_sym_COLON_COLON] = ACTIONS(2647),
    [anon_sym_POUND] = ACTIONS(2647),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_async] = ACTIONS(2649),
    [anon_sym_break] = ACTIONS(2649),
    [anon_sym_const] = ACTIONS(2649),
    [anon_sym_continue] = ACTIONS(2649),
    [anon_sym_default] = ACTIONS(2649),
    [anon_sym_enum] = ACTIONS(2649),
    [anon_sym_fn] = ACTIONS(2649),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_if] = ACTIONS(2649),
    [anon_sym_impl] = ACTIONS(2649),
    [anon_sym_let] = ACTIONS(2649),
    [anon_sym_loop] = ACTIONS(2649),
    [anon_sym_match] = ACTIONS(2649),
    [anon_sym_mod] = ACTIONS(2649),
    [anon_sym_pub] = ACTIONS(2649),
    [anon_sym_return] = ACTIONS(2649),
    [anon_sym_static] = ACTIONS(2649),
    [anon_sym_struct] = ACTIONS(2649),
    [anon_sym_trait] = ACTIONS(2649),
    [anon_sym_type] = ACTIONS(2649),
    [anon_sym_union] = ACTIONS(2649),
    [anon_sym_unsafe] = ACTIONS(2649),
    [anon_sym_use] = ACTIONS(2649),
    [anon_sym_while] = ACTIONS(2649),
    [anon_sym_extern] = ACTIONS(2649),
    [anon_sym_yield] = ACTIONS(2649),
    [anon_sym_move] = ACTIONS(2649),
    [anon_sym_try] = ACTIONS(2649),
    [sym_integer_literal] = ACTIONS(2647),
    [aux_sym_string_literal_token1] = ACTIONS(2647),
    [sym_char_literal] = ACTIONS(2647),
    [anon_sym_true] = ACTIONS(2649),
    [anon_sym_false] = ACTIONS(2649),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2649),
    [sym_super] = ACTIONS(2649),
    [sym_crate] = ACTIONS(2649),
    [sym_metavariable] = ACTIONS(2647),
    [sym__raw_string_literal_start] = ACTIONS(2647),
    [sym_float_literal] = ACTIONS(2647),
  },
  [685] = {
    [sym_line_comment] = STATE(685),
    [sym_block_comment] = STATE(685),
    [ts_builtin_sym_end] = ACTIONS(2651),
    [sym_identifier] = ACTIONS(2653),
    [anon_sym_SEMI] = ACTIONS(2651),
    [anon_sym_macro_rules_BANG] = ACTIONS(2651),
    [anon_sym_LPAREN] = ACTIONS(2651),
    [anon_sym_LBRACK] = ACTIONS(2651),
    [anon_sym_LBRACE] = ACTIONS(2651),
    [anon_sym_RBRACE] = ACTIONS(2651),
    [anon_sym_STAR] = ACTIONS(2651),
    [anon_sym_u8] = ACTIONS(2653),
    [anon_sym_i8] = ACTIONS(2653),
    [anon_sym_u16] = ACTIONS(2653),
    [anon_sym_i16] = ACTIONS(2653),
    [anon_sym_u32] = ACTIONS(2653),
    [anon_sym_i32] = ACTIONS(2653),
    [anon_sym_u64] = ACTIONS(2653),
    [anon_sym_i64] = ACTIONS(2653),
    [anon_sym_u128] = ACTIONS(2653),
    [anon_sym_i128] = ACTIONS(2653),
    [anon_sym_isize] = ACTIONS(2653),
    [anon_sym_usize] = ACTIONS(2653),
    [anon_sym_f32] = ACTIONS(2653),
    [anon_sym_f64] = ACTIONS(2653),
    [anon_sym_bool] = ACTIONS(2653),
    [anon_sym_str] = ACTIONS(2653),
    [anon_sym_char] = ACTIONS(2653),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_BANG] = ACTIONS(2651),
    [anon_sym_AMP] = ACTIONS(2651),
    [anon_sym_PIPE] = ACTIONS(2651),
    [anon_sym_LT] = ACTIONS(2651),
    [anon_sym_DOT_DOT] = ACTIONS(2651),
    [anon_sym_COLON_COLON] = ACTIONS(2651),
    [anon_sym_POUND] = ACTIONS(2651),
    [anon_sym_SQUOTE] = ACTIONS(2653),
    [anon_sym_async] = ACTIONS(2653),
    [anon_sym_break] = ACTIONS(2653),
    [anon_sym_const] = ACTIONS(2653),
    [anon_sym_continue] = ACTIONS(2653),
    [anon_sym_default] = ACTIONS(2653),
    [anon_sym_enum] = ACTIONS(2653),
    [anon_sym_fn] = ACTIONS(2653),
    [anon_sym_for] = ACTIONS(2653),
    [anon_sym_if] = ACTIONS(2653),
    [anon_sym_impl] = ACTIONS(2653),
    [anon_sym_let] = ACTIONS(2653),
    [anon_sym_loop] = ACTIONS(2653),
    [anon_sym_match] = ACTIONS(2653),
    [anon_sym_mod] = ACTIONS(2653),
    [anon_sym_pub] = ACTIONS(2653),
    [anon_sym_return] = ACTIONS(2653),
    [anon_sym_static] = ACTIONS(2653),
    [anon_sym_struct] = ACTIONS(2653),
    [anon_sym_trait] = ACTIONS(2653),
    [anon_sym_type] = ACTIONS(2653),
    [anon_sym_union] = ACTIONS(2653),
    [anon_sym_unsafe] = ACTIONS(2653),
    [anon_sym_use] = ACTIONS(2653),
    [anon_sym_while] = ACTIONS(2653),
    [anon_sym_extern] = ACTIONS(2653),
    [anon_sym_yield] = ACTIONS(2653),
    [anon_sym_move] = ACTIONS(2653),
    [anon_sym_try] = ACTIONS(2653),
    [sym_integer_literal] = ACTIONS(2651),
    [aux_sym_string_literal_token1] = ACTIONS(2651),
    [sym_char_literal] = ACTIONS(2651),
    [anon_sym_true] = ACTIONS(2653),
    [anon_sym_false] = ACTIONS(2653),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2653),
    [sym_super] = ACTIONS(2653),
    [sym_crate] = ACTIONS(2653),
    [sym_metavariable] = ACTIONS(2651),
    [sym__raw_string_literal_start] = ACTIONS(2651),
    [sym_float_literal] = ACTIONS(2651),
  },
  [686] = {
    [sym_line_comment] = STATE(686),
    [sym_block_comment] = STATE(686),
    [ts_builtin_sym_end] = ACTIONS(1240),
    [sym_identifier] = ACTIONS(1242),
    [anon_sym_SEMI] = ACTIONS(1240),
    [anon_sym_macro_rules_BANG] = ACTIONS(1240),
    [anon_sym_LPAREN] = ACTIONS(1240),
    [anon_sym_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(1240),
    [anon_sym_RBRACE] = ACTIONS(1240),
    [anon_sym_STAR] = ACTIONS(1240),
    [anon_sym_u8] = ACTIONS(1242),
    [anon_sym_i8] = ACTIONS(1242),
    [anon_sym_u16] = ACTIONS(1242),
    [anon_sym_i16] = ACTIONS(1242),
    [anon_sym_u32] = ACTIONS(1242),
    [anon_sym_i32] = ACTIONS(1242),
    [anon_sym_u64] = ACTIONS(1242),
    [anon_sym_i64] = ACTIONS(1242),
    [anon_sym_u128] = ACTIONS(1242),
    [anon_sym_i128] = ACTIONS(1242),
    [anon_sym_isize] = ACTIONS(1242),
    [anon_sym_usize] = ACTIONS(1242),
    [anon_sym_f32] = ACTIONS(1242),
    [anon_sym_f64] = ACTIONS(1242),
    [anon_sym_bool] = ACTIONS(1242),
    [anon_sym_str] = ACTIONS(1242),
    [anon_sym_char] = ACTIONS(1242),
    [anon_sym_DASH] = ACTIONS(1240),
    [anon_sym_BANG] = ACTIONS(1240),
    [anon_sym_AMP] = ACTIONS(1240),
    [anon_sym_PIPE] = ACTIONS(1240),
    [anon_sym_LT] = ACTIONS(1240),
    [anon_sym_DOT_DOT] = ACTIONS(1240),
    [anon_sym_COLON_COLON] = ACTIONS(1240),
    [anon_sym_POUND] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [anon_sym_async] = ACTIONS(1242),
    [anon_sym_break] = ACTIONS(1242),
    [anon_sym_const] = ACTIONS(1242),
    [anon_sym_continue] = ACTIONS(1242),
    [anon_sym_default] = ACTIONS(1242),
    [anon_sym_enum] = ACTIONS(1242),
    [anon_sym_fn] = ACTIONS(1242),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_if] = ACTIONS(1242),
    [anon_sym_impl] = ACTIONS(1242),
    [anon_sym_let] = ACTIONS(1242),
    [anon_sym_loop] = ACTIONS(1242),
    [anon_sym_match] = ACTIONS(1242),
    [anon_sym_mod] = ACTIONS(1242),
    [anon_sym_pub] = ACTIONS(1242),
    [anon_sym_return] = ACTIONS(1242),
    [anon_sym_static] = ACTIONS(1242),
    [anon_sym_struct] = ACTIONS(1242),
    [anon_sym_trait] = ACTIONS(1242),
    [anon_sym_type] = ACTIONS(1242),
    [anon_sym_union] = ACTIONS(1242),
    [anon_sym_unsafe] = ACTIONS(1242),
    [anon_sym_use] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(1242),
    [anon_sym_extern] = ACTIONS(1242),
    [anon_sym_yield] = ACTIONS(1242),
    [anon_sym_move] = ACTIONS(1242),
    [anon_sym_try] = ACTIONS(1242),
    [sym_integer_literal] = ACTIONS(1240),
    [aux_sym_string_literal_token1] = ACTIONS(1240),
    [sym_char_literal] = ACTIONS(1240),
    [anon_sym_true] = ACTIONS(1242),
    [anon_sym_false] = ACTIONS(1242),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1242),
    [sym_super] = ACTIONS(1242),
    [sym_crate] = ACTIONS(1242),
    [sym_metavariable] = ACTIONS(1240),
    [sym__raw_string_literal_start] = ACTIONS(1240),
    [sym_float_literal] = ACTIONS(1240),
  },
  [687] = {
    [sym_line_comment] = STATE(687),
    [sym_block_comment] = STATE(687),
    [ts_builtin_sym_end] = ACTIONS(2655),
    [sym_identifier] = ACTIONS(2657),
    [anon_sym_SEMI] = ACTIONS(2655),
    [anon_sym_macro_rules_BANG] = ACTIONS(2655),
    [anon_sym_LPAREN] = ACTIONS(2655),
    [anon_sym_LBRACK] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(2655),
    [anon_sym_RBRACE] = ACTIONS(2655),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_u8] = ACTIONS(2657),
    [anon_sym_i8] = ACTIONS(2657),
    [anon_sym_u16] = ACTIONS(2657),
    [anon_sym_i16] = ACTIONS(2657),
    [anon_sym_u32] = ACTIONS(2657),
    [anon_sym_i32] = ACTIONS(2657),
    [anon_sym_u64] = ACTIONS(2657),
    [anon_sym_i64] = ACTIONS(2657),
    [anon_sym_u128] = ACTIONS(2657),
    [anon_sym_i128] = ACTIONS(2657),
    [anon_sym_isize] = ACTIONS(2657),
    [anon_sym_usize] = ACTIONS(2657),
    [anon_sym_f32] = ACTIONS(2657),
    [anon_sym_f64] = ACTIONS(2657),
    [anon_sym_bool] = ACTIONS(2657),
    [anon_sym_str] = ACTIONS(2657),
    [anon_sym_char] = ACTIONS(2657),
    [anon_sym_DASH] = ACTIONS(2655),
    [anon_sym_BANG] = ACTIONS(2655),
    [anon_sym_AMP] = ACTIONS(2655),
    [anon_sym_PIPE] = ACTIONS(2655),
    [anon_sym_LT] = ACTIONS(2655),
    [anon_sym_DOT_DOT] = ACTIONS(2655),
    [anon_sym_COLON_COLON] = ACTIONS(2655),
    [anon_sym_POUND] = ACTIONS(2655),
    [anon_sym_SQUOTE] = ACTIONS(2657),
    [anon_sym_async] = ACTIONS(2657),
    [anon_sym_break] = ACTIONS(2657),
    [anon_sym_const] = ACTIONS(2657),
    [anon_sym_continue] = ACTIONS(2657),
    [anon_sym_default] = ACTIONS(2657),
    [anon_sym_enum] = ACTIONS(2657),
    [anon_sym_fn] = ACTIONS(2657),
    [anon_sym_for] = ACTIONS(2657),
    [anon_sym_if] = ACTIONS(2657),
    [anon_sym_impl] = ACTIONS(2657),
    [anon_sym_let] = ACTIONS(2657),
    [anon_sym_loop] = ACTIONS(2657),
    [anon_sym_match] = ACTIONS(2657),
    [anon_sym_mod] = ACTIONS(2657),
    [anon_sym_pub] = ACTIONS(2657),
    [anon_sym_return] = ACTIONS(2657),
    [anon_sym_static] = ACTIONS(2657),
    [anon_sym_struct] = ACTIONS(2657),
    [anon_sym_trait] = ACTIONS(2657),
    [anon_sym_type] = ACTIONS(2657),
    [anon_sym_union] = ACTIONS(2657),
    [anon_sym_unsafe] = ACTIONS(2657),
    [anon_sym_use] = ACTIONS(2657),
    [anon_sym_while] = ACTIONS(2657),
    [anon_sym_extern] = ACTIONS(2657),
    [anon_sym_yield] = ACTIONS(2657),
    [anon_sym_move] = ACTIONS(2657),
    [anon_sym_try] = ACTIONS(2657),
    [sym_integer_literal] = ACTIONS(2655),
    [aux_sym_string_literal_token1] = ACTIONS(2655),
    [sym_char_literal] = ACTIONS(2655),
    [anon_sym_true] = ACTIONS(2657),
    [anon_sym_false] = ACTIONS(2657),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2657),
    [sym_super] = ACTIONS(2657),
    [sym_crate] = ACTIONS(2657),
    [sym_metavariable] = ACTIONS(2655),
    [sym__raw_string_literal_start] = ACTIONS(2655),
    [sym_float_literal] = ACTIONS(2655),
  },
  [688] = {
    [sym_line_comment] = STATE(688),
    [sym_block_comment] = STATE(688),
    [ts_builtin_sym_end] = ACTIONS(2659),
    [sym_identifier] = ACTIONS(2661),
    [anon_sym_SEMI] = ACTIONS(2659),
    [anon_sym_macro_rules_BANG] = ACTIONS(2659),
    [anon_sym_LPAREN] = ACTIONS(2659),
    [anon_sym_LBRACK] = ACTIONS(2659),
    [anon_sym_LBRACE] = ACTIONS(2659),
    [anon_sym_RBRACE] = ACTIONS(2659),
    [anon_sym_STAR] = ACTIONS(2659),
    [anon_sym_u8] = ACTIONS(2661),
    [anon_sym_i8] = ACTIONS(2661),
    [anon_sym_u16] = ACTIONS(2661),
    [anon_sym_i16] = ACTIONS(2661),
    [anon_sym_u32] = ACTIONS(2661),
    [anon_sym_i32] = ACTIONS(2661),
    [anon_sym_u64] = ACTIONS(2661),
    [anon_sym_i64] = ACTIONS(2661),
    [anon_sym_u128] = ACTIONS(2661),
    [anon_sym_i128] = ACTIONS(2661),
    [anon_sym_isize] = ACTIONS(2661),
    [anon_sym_usize] = ACTIONS(2661),
    [anon_sym_f32] = ACTIONS(2661),
    [anon_sym_f64] = ACTIONS(2661),
    [anon_sym_bool] = ACTIONS(2661),
    [anon_sym_str] = ACTIONS(2661),
    [anon_sym_char] = ACTIONS(2661),
    [anon_sym_DASH] = ACTIONS(2659),
    [anon_sym_BANG] = ACTIONS(2659),
    [anon_sym_AMP] = ACTIONS(2659),
    [anon_sym_PIPE] = ACTIONS(2659),
    [anon_sym_LT] = ACTIONS(2659),
    [anon_sym_DOT_DOT] = ACTIONS(2659),
    [anon_sym_COLON_COLON] = ACTIONS(2659),
    [anon_sym_POUND] = ACTIONS(2659),
    [anon_sym_SQUOTE] = ACTIONS(2661),
    [anon_sym_async] = ACTIONS(2661),
    [anon_sym_break] = ACTIONS(2661),
    [anon_sym_const] = ACTIONS(2661),
    [anon_sym_continue] = ACTIONS(2661),
    [anon_sym_default] = ACTIONS(2661),
    [anon_sym_enum] = ACTIONS(2661),
    [anon_sym_fn] = ACTIONS(2661),
    [anon_sym_for] = ACTIONS(2661),
    [anon_sym_if] = ACTIONS(2661),
    [anon_sym_impl] = ACTIONS(2661),
    [anon_sym_let] = ACTIONS(2661),
    [anon_sym_loop] = ACTIONS(2661),
    [anon_sym_match] = ACTIONS(2661),
    [anon_sym_mod] = ACTIONS(2661),
    [anon_sym_pub] = ACTIONS(2661),
    [anon_sym_return] = ACTIONS(2661),
    [anon_sym_static] = ACTIONS(2661),
    [anon_sym_struct] = ACTIONS(2661),
    [anon_sym_trait] = ACTIONS(2661),
    [anon_sym_type] = ACTIONS(2661),
    [anon_sym_union] = ACTIONS(2661),
    [anon_sym_unsafe] = ACTIONS(2661),
    [anon_sym_use] = ACTIONS(2661),
    [anon_sym_while] = ACTIONS(2661),
    [anon_sym_extern] = ACTIONS(2661),
    [anon_sym_yield] = ACTIONS(2661),
    [anon_sym_move] = ACTIONS(2661),
    [anon_sym_try] = ACTIONS(2661),
    [sym_integer_literal] = ACTIONS(2659),
    [aux_sym_string_literal_token1] = ACTIONS(2659),
    [sym_char_literal] = ACTIONS(2659),
    [anon_sym_true] = ACTIONS(2661),
    [anon_sym_false] = ACTIONS(2661),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2661),
    [sym_super] = ACTIONS(2661),
    [sym_crate] = ACTIONS(2661),
    [sym_metavariable] = ACTIONS(2659),
    [sym__raw_string_literal_start] = ACTIONS(2659),
    [sym_float_literal] = ACTIONS(2659),
  },
  [689] = {
    [sym_line_comment] = STATE(689),
    [sym_block_comment] = STATE(689),
    [ts_builtin_sym_end] = ACTIONS(2663),
    [sym_identifier] = ACTIONS(2665),
    [anon_sym_SEMI] = ACTIONS(2663),
    [anon_sym_macro_rules_BANG] = ACTIONS(2663),
    [anon_sym_LPAREN] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2663),
    [anon_sym_LBRACE] = ACTIONS(2663),
    [anon_sym_RBRACE] = ACTIONS(2663),
    [anon_sym_STAR] = ACTIONS(2663),
    [anon_sym_u8] = ACTIONS(2665),
    [anon_sym_i8] = ACTIONS(2665),
    [anon_sym_u16] = ACTIONS(2665),
    [anon_sym_i16] = ACTIONS(2665),
    [anon_sym_u32] = ACTIONS(2665),
    [anon_sym_i32] = ACTIONS(2665),
    [anon_sym_u64] = ACTIONS(2665),
    [anon_sym_i64] = ACTIONS(2665),
    [anon_sym_u128] = ACTIONS(2665),
    [anon_sym_i128] = ACTIONS(2665),
    [anon_sym_isize] = ACTIONS(2665),
    [anon_sym_usize] = ACTIONS(2665),
    [anon_sym_f32] = ACTIONS(2665),
    [anon_sym_f64] = ACTIONS(2665),
    [anon_sym_bool] = ACTIONS(2665),
    [anon_sym_str] = ACTIONS(2665),
    [anon_sym_char] = ACTIONS(2665),
    [anon_sym_DASH] = ACTIONS(2663),
    [anon_sym_BANG] = ACTIONS(2663),
    [anon_sym_AMP] = ACTIONS(2663),
    [anon_sym_PIPE] = ACTIONS(2663),
    [anon_sym_LT] = ACTIONS(2663),
    [anon_sym_DOT_DOT] = ACTIONS(2663),
    [anon_sym_COLON_COLON] = ACTIONS(2663),
    [anon_sym_POUND] = ACTIONS(2663),
    [anon_sym_SQUOTE] = ACTIONS(2665),
    [anon_sym_async] = ACTIONS(2665),
    [anon_sym_break] = ACTIONS(2665),
    [anon_sym_const] = ACTIONS(2665),
    [anon_sym_continue] = ACTIONS(2665),
    [anon_sym_default] = ACTIONS(2665),
    [anon_sym_enum] = ACTIONS(2665),
    [anon_sym_fn] = ACTIONS(2665),
    [anon_sym_for] = ACTIONS(2665),
    [anon_sym_if] = ACTIONS(2665),
    [anon_sym_impl] = ACTIONS(2665),
    [anon_sym_let] = ACTIONS(2665),
    [anon_sym_loop] = ACTIONS(2665),
    [anon_sym_match] = ACTIONS(2665),
    [anon_sym_mod] = ACTIONS(2665),
    [anon_sym_pub] = ACTIONS(2665),
    [anon_sym_return] = ACTIONS(2665),
    [anon_sym_static] = ACTIONS(2665),
    [anon_sym_struct] = ACTIONS(2665),
    [anon_sym_trait] = ACTIONS(2665),
    [anon_sym_type] = ACTIONS(2665),
    [anon_sym_union] = ACTIONS(2665),
    [anon_sym_unsafe] = ACTIONS(2665),
    [anon_sym_use] = ACTIONS(2665),
    [anon_sym_while] = ACTIONS(2665),
    [anon_sym_extern] = ACTIONS(2665),
    [anon_sym_yield] = ACTIONS(2665),
    [anon_sym_move] = ACTIONS(2665),
    [anon_sym_try] = ACTIONS(2665),
    [sym_integer_literal] = ACTIONS(2663),
    [aux_sym_string_literal_token1] = ACTIONS(2663),
    [sym_char_literal] = ACTIONS(2663),
    [anon_sym_true] = ACTIONS(2665),
    [anon_sym_false] = ACTIONS(2665),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2665),
    [sym_super] = ACTIONS(2665),
    [sym_crate] = ACTIONS(2665),
    [sym_metavariable] = ACTIONS(2663),
    [sym__raw_string_literal_start] = ACTIONS(2663),
    [sym_float_literal] = ACTIONS(2663),
  },
  [690] = {
    [sym_line_comment] = STATE(690),
    [sym_block_comment] = STATE(690),
    [ts_builtin_sym_end] = ACTIONS(2667),
    [sym_identifier] = ACTIONS(2669),
    [anon_sym_SEMI] = ACTIONS(2667),
    [anon_sym_macro_rules_BANG] = ACTIONS(2667),
    [anon_sym_LPAREN] = ACTIONS(2667),
    [anon_sym_LBRACK] = ACTIONS(2667),
    [anon_sym_LBRACE] = ACTIONS(2667),
    [anon_sym_RBRACE] = ACTIONS(2667),
    [anon_sym_STAR] = ACTIONS(2667),
    [anon_sym_u8] = ACTIONS(2669),
    [anon_sym_i8] = ACTIONS(2669),
    [anon_sym_u16] = ACTIONS(2669),
    [anon_sym_i16] = ACTIONS(2669),
    [anon_sym_u32] = ACTIONS(2669),
    [anon_sym_i32] = ACTIONS(2669),
    [anon_sym_u64] = ACTIONS(2669),
    [anon_sym_i64] = ACTIONS(2669),
    [anon_sym_u128] = ACTIONS(2669),
    [anon_sym_i128] = ACTIONS(2669),
    [anon_sym_isize] = ACTIONS(2669),
    [anon_sym_usize] = ACTIONS(2669),
    [anon_sym_f32] = ACTIONS(2669),
    [anon_sym_f64] = ACTIONS(2669),
    [anon_sym_bool] = ACTIONS(2669),
    [anon_sym_str] = ACTIONS(2669),
    [anon_sym_char] = ACTIONS(2669),
    [anon_sym_DASH] = ACTIONS(2667),
    [anon_sym_BANG] = ACTIONS(2667),
    [anon_sym_AMP] = ACTIONS(2667),
    [anon_sym_PIPE] = ACTIONS(2667),
    [anon_sym_LT] = ACTIONS(2667),
    [anon_sym_DOT_DOT] = ACTIONS(2667),
    [anon_sym_COLON_COLON] = ACTIONS(2667),
    [anon_sym_POUND] = ACTIONS(2667),
    [anon_sym_SQUOTE] = ACTIONS(2669),
    [anon_sym_async] = ACTIONS(2669),
    [anon_sym_break] = ACTIONS(2669),
    [anon_sym_const] = ACTIONS(2669),
    [anon_sym_continue] = ACTIONS(2669),
    [anon_sym_default] = ACTIONS(2669),
    [anon_sym_enum] = ACTIONS(2669),
    [anon_sym_fn] = ACTIONS(2669),
    [anon_sym_for] = ACTIONS(2669),
    [anon_sym_if] = ACTIONS(2669),
    [anon_sym_impl] = ACTIONS(2669),
    [anon_sym_let] = ACTIONS(2669),
    [anon_sym_loop] = ACTIONS(2669),
    [anon_sym_match] = ACTIONS(2669),
    [anon_sym_mod] = ACTIONS(2669),
    [anon_sym_pub] = ACTIONS(2669),
    [anon_sym_return] = ACTIONS(2669),
    [anon_sym_static] = ACTIONS(2669),
    [anon_sym_struct] = ACTIONS(2669),
    [anon_sym_trait] = ACTIONS(2669),
    [anon_sym_type] = ACTIONS(2669),
    [anon_sym_union] = ACTIONS(2669),
    [anon_sym_unsafe] = ACTIONS(2669),
    [anon_sym_use] = ACTIONS(2669),
    [anon_sym_while] = ACTIONS(2669),
    [anon_sym_extern] = ACTIONS(2669),
    [anon_sym_yield] = ACTIONS(2669),
    [anon_sym_move] = ACTIONS(2669),
    [anon_sym_try] = ACTIONS(2669),
    [sym_integer_literal] = ACTIONS(2667),
    [aux_sym_string_literal_token1] = ACTIONS(2667),
    [sym_char_literal] = ACTIONS(2667),
    [anon_sym_true] = ACTIONS(2669),
    [anon_sym_false] = ACTIONS(2669),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2669),
    [sym_super] = ACTIONS(2669),
    [sym_crate] = ACTIONS(2669),
    [sym_metavariable] = ACTIONS(2667),
    [sym__raw_string_literal_start] = ACTIONS(2667),
    [sym_float_literal] = ACTIONS(2667),
  },
  [691] = {
    [sym_line_comment] = STATE(691),
    [sym_block_comment] = STATE(691),
    [ts_builtin_sym_end] = ACTIONS(2671),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_SEMI] = ACTIONS(2671),
    [anon_sym_macro_rules_BANG] = ACTIONS(2671),
    [anon_sym_LPAREN] = ACTIONS(2671),
    [anon_sym_LBRACK] = ACTIONS(2671),
    [anon_sym_LBRACE] = ACTIONS(2671),
    [anon_sym_RBRACE] = ACTIONS(2671),
    [anon_sym_STAR] = ACTIONS(2671),
    [anon_sym_u8] = ACTIONS(2673),
    [anon_sym_i8] = ACTIONS(2673),
    [anon_sym_u16] = ACTIONS(2673),
    [anon_sym_i16] = ACTIONS(2673),
    [anon_sym_u32] = ACTIONS(2673),
    [anon_sym_i32] = ACTIONS(2673),
    [anon_sym_u64] = ACTIONS(2673),
    [anon_sym_i64] = ACTIONS(2673),
    [anon_sym_u128] = ACTIONS(2673),
    [anon_sym_i128] = ACTIONS(2673),
    [anon_sym_isize] = ACTIONS(2673),
    [anon_sym_usize] = ACTIONS(2673),
    [anon_sym_f32] = ACTIONS(2673),
    [anon_sym_f64] = ACTIONS(2673),
    [anon_sym_bool] = ACTIONS(2673),
    [anon_sym_str] = ACTIONS(2673),
    [anon_sym_char] = ACTIONS(2673),
    [anon_sym_DASH] = ACTIONS(2671),
    [anon_sym_BANG] = ACTIONS(2671),
    [anon_sym_AMP] = ACTIONS(2671),
    [anon_sym_PIPE] = ACTIONS(2671),
    [anon_sym_LT] = ACTIONS(2671),
    [anon_sym_DOT_DOT] = ACTIONS(2671),
    [anon_sym_COLON_COLON] = ACTIONS(2671),
    [anon_sym_POUND] = ACTIONS(2671),
    [anon_sym_SQUOTE] = ACTIONS(2673),
    [anon_sym_async] = ACTIONS(2673),
    [anon_sym_break] = ACTIONS(2673),
    [anon_sym_const] = ACTIONS(2673),
    [anon_sym_continue] = ACTIONS(2673),
    [anon_sym_default] = ACTIONS(2673),
    [anon_sym_enum] = ACTIONS(2673),
    [anon_sym_fn] = ACTIONS(2673),
    [anon_sym_for] = ACTIONS(2673),
    [anon_sym_if] = ACTIONS(2673),
    [anon_sym_impl] = ACTIONS(2673),
    [anon_sym_let] = ACTIONS(2673),
    [anon_sym_loop] = ACTIONS(2673),
    [anon_sym_match] = ACTIONS(2673),
    [anon_sym_mod] = ACTIONS(2673),
    [anon_sym_pub] = ACTIONS(2673),
    [anon_sym_return] = ACTIONS(2673),
    [anon_sym_static] = ACTIONS(2673),
    [anon_sym_struct] = ACTIONS(2673),
    [anon_sym_trait] = ACTIONS(2673),
    [anon_sym_type] = ACTIONS(2673),
    [anon_sym_union] = ACTIONS(2673),
    [anon_sym_unsafe] = ACTIONS(2673),
    [anon_sym_use] = ACTIONS(2673),
    [anon_sym_while] = ACTIONS(2673),
    [anon_sym_extern] = ACTIONS(2673),
    [anon_sym_yield] = ACTIONS(2673),
    [anon_sym_move] = ACTIONS(2673),
    [anon_sym_try] = ACTIONS(2673),
    [sym_integer_literal] = ACTIONS(2671),
    [aux_sym_string_literal_token1] = ACTIONS(2671),
    [sym_char_literal] = ACTIONS(2671),
    [anon_sym_true] = ACTIONS(2673),
    [anon_sym_false] = ACTIONS(2673),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2673),
    [sym_super] = ACTIONS(2673),
    [sym_crate] = ACTIONS(2673),
    [sym_metavariable] = ACTIONS(2671),
    [sym__raw_string_literal_start] = ACTIONS(2671),
    [sym_float_literal] = ACTIONS(2671),
  },
  [692] = {
    [sym_line_comment] = STATE(692),
    [sym_block_comment] = STATE(692),
    [ts_builtin_sym_end] = ACTIONS(2675),
    [sym_identifier] = ACTIONS(2677),
    [anon_sym_SEMI] = ACTIONS(2675),
    [anon_sym_macro_rules_BANG] = ACTIONS(2675),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_LBRACK] = ACTIONS(2675),
    [anon_sym_LBRACE] = ACTIONS(2675),
    [anon_sym_RBRACE] = ACTIONS(2675),
    [anon_sym_STAR] = ACTIONS(2675),
    [anon_sym_u8] = ACTIONS(2677),
    [anon_sym_i8] = ACTIONS(2677),
    [anon_sym_u16] = ACTIONS(2677),
    [anon_sym_i16] = ACTIONS(2677),
    [anon_sym_u32] = ACTIONS(2677),
    [anon_sym_i32] = ACTIONS(2677),
    [anon_sym_u64] = ACTIONS(2677),
    [anon_sym_i64] = ACTIONS(2677),
    [anon_sym_u128] = ACTIONS(2677),
    [anon_sym_i128] = ACTIONS(2677),
    [anon_sym_isize] = ACTIONS(2677),
    [anon_sym_usize] = ACTIONS(2677),
    [anon_sym_f32] = ACTIONS(2677),
    [anon_sym_f64] = ACTIONS(2677),
    [anon_sym_bool] = ACTIONS(2677),
    [anon_sym_str] = ACTIONS(2677),
    [anon_sym_char] = ACTIONS(2677),
    [anon_sym_DASH] = ACTIONS(2675),
    [anon_sym_BANG] = ACTIONS(2675),
    [anon_sym_AMP] = ACTIONS(2675),
    [anon_sym_PIPE] = ACTIONS(2675),
    [anon_sym_LT] = ACTIONS(2675),
    [anon_sym_DOT_DOT] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(2675),
    [anon_sym_POUND] = ACTIONS(2675),
    [anon_sym_SQUOTE] = ACTIONS(2677),
    [anon_sym_async] = ACTIONS(2677),
    [anon_sym_break] = ACTIONS(2677),
    [anon_sym_const] = ACTIONS(2677),
    [anon_sym_continue] = ACTIONS(2677),
    [anon_sym_default] = ACTIONS(2677),
    [anon_sym_enum] = ACTIONS(2677),
    [anon_sym_fn] = ACTIONS(2677),
    [anon_sym_for] = ACTIONS(2677),
    [anon_sym_if] = ACTIONS(2677),
    [anon_sym_impl] = ACTIONS(2677),
    [anon_sym_let] = ACTIONS(2677),
    [anon_sym_loop] = ACTIONS(2677),
    [anon_sym_match] = ACTIONS(2677),
    [anon_sym_mod] = ACTIONS(2677),
    [anon_sym_pub] = ACTIONS(2677),
    [anon_sym_return] = ACTIONS(2677),
    [anon_sym_static] = ACTIONS(2677),
    [anon_sym_struct] = ACTIONS(2677),
    [anon_sym_trait] = ACTIONS(2677),
    [anon_sym_type] = ACTIONS(2677),
    [anon_sym_union] = ACTIONS(2677),
    [anon_sym_unsafe] = ACTIONS(2677),
    [anon_sym_use] = ACTIONS(2677),
    [anon_sym_while] = ACTIONS(2677),
    [anon_sym_extern] = ACTIONS(2677),
    [anon_sym_yield] = ACTIONS(2677),
    [anon_sym_move] = ACTIONS(2677),
    [anon_sym_try] = ACTIONS(2677),
    [sym_integer_literal] = ACTIONS(2675),
    [aux_sym_string_literal_token1] = ACTIONS(2675),
    [sym_char_literal] = ACTIONS(2675),
    [anon_sym_true] = ACTIONS(2677),
    [anon_sym_false] = ACTIONS(2677),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2677),
    [sym_super] = ACTIONS(2677),
    [sym_crate] = ACTIONS(2677),
    [sym_metavariable] = ACTIONS(2675),
    [sym__raw_string_literal_start] = ACTIONS(2675),
    [sym_float_literal] = ACTIONS(2675),
  },
  [693] = {
    [sym_line_comment] = STATE(693),
    [sym_block_comment] = STATE(693),
    [ts_builtin_sym_end] = ACTIONS(2679),
    [sym_identifier] = ACTIONS(2681),
    [anon_sym_SEMI] = ACTIONS(2679),
    [anon_sym_macro_rules_BANG] = ACTIONS(2679),
    [anon_sym_LPAREN] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2679),
    [anon_sym_RBRACE] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2679),
    [anon_sym_u8] = ACTIONS(2681),
    [anon_sym_i8] = ACTIONS(2681),
    [anon_sym_u16] = ACTIONS(2681),
    [anon_sym_i16] = ACTIONS(2681),
    [anon_sym_u32] = ACTIONS(2681),
    [anon_sym_i32] = ACTIONS(2681),
    [anon_sym_u64] = ACTIONS(2681),
    [anon_sym_i64] = ACTIONS(2681),
    [anon_sym_u128] = ACTIONS(2681),
    [anon_sym_i128] = ACTIONS(2681),
    [anon_sym_isize] = ACTIONS(2681),
    [anon_sym_usize] = ACTIONS(2681),
    [anon_sym_f32] = ACTIONS(2681),
    [anon_sym_f64] = ACTIONS(2681),
    [anon_sym_bool] = ACTIONS(2681),
    [anon_sym_str] = ACTIONS(2681),
    [anon_sym_char] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_PIPE] = ACTIONS(2679),
    [anon_sym_LT] = ACTIONS(2679),
    [anon_sym_DOT_DOT] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2679),
    [anon_sym_POUND] = ACTIONS(2679),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_async] = ACTIONS(2681),
    [anon_sym_break] = ACTIONS(2681),
    [anon_sym_const] = ACTIONS(2681),
    [anon_sym_continue] = ACTIONS(2681),
    [anon_sym_default] = ACTIONS(2681),
    [anon_sym_enum] = ACTIONS(2681),
    [anon_sym_fn] = ACTIONS(2681),
    [anon_sym_for] = ACTIONS(2681),
    [anon_sym_if] = ACTIONS(2681),
    [anon_sym_impl] = ACTIONS(2681),
    [anon_sym_let] = ACTIONS(2681),
    [anon_sym_loop] = ACTIONS(2681),
    [anon_sym_match] = ACTIONS(2681),
    [anon_sym_mod] = ACTIONS(2681),
    [anon_sym_pub] = ACTIONS(2681),
    [anon_sym_return] = ACTIONS(2681),
    [anon_sym_static] = ACTIONS(2681),
    [anon_sym_struct] = ACTIONS(2681),
    [anon_sym_trait] = ACTIONS(2681),
    [anon_sym_type] = ACTIONS(2681),
    [anon_sym_union] = ACTIONS(2681),
    [anon_sym_unsafe] = ACTIONS(2681),
    [anon_sym_use] = ACTIONS(2681),
    [anon_sym_while] = ACTIONS(2681),
    [anon_sym_extern] = ACTIONS(2681),
    [anon_sym_yield] = ACTIONS(2681),
    [anon_sym_move] = ACTIONS(2681),
    [anon_sym_try] = ACTIONS(2681),
    [sym_integer_literal] = ACTIONS(2679),
    [aux_sym_string_literal_token1] = ACTIONS(2679),
    [sym_char_literal] = ACTIONS(2679),
    [anon_sym_true] = ACTIONS(2681),
    [anon_sym_false] = ACTIONS(2681),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2681),
    [sym_super] = ACTIONS(2681),
    [sym_crate] = ACTIONS(2681),
    [sym_metavariable] = ACTIONS(2679),
    [sym__raw_string_literal_start] = ACTIONS(2679),
    [sym_float_literal] = ACTIONS(2679),
  },
  [694] = {
    [sym_line_comment] = STATE(694),
    [sym_block_comment] = STATE(694),
    [ts_builtin_sym_end] = ACTIONS(2683),
    [sym_identifier] = ACTIONS(2685),
    [anon_sym_SEMI] = ACTIONS(2683),
    [anon_sym_macro_rules_BANG] = ACTIONS(2683),
    [anon_sym_LPAREN] = ACTIONS(2683),
    [anon_sym_LBRACK] = ACTIONS(2683),
    [anon_sym_LBRACE] = ACTIONS(2683),
    [anon_sym_RBRACE] = ACTIONS(2683),
    [anon_sym_STAR] = ACTIONS(2683),
    [anon_sym_u8] = ACTIONS(2685),
    [anon_sym_i8] = ACTIONS(2685),
    [anon_sym_u16] = ACTIONS(2685),
    [anon_sym_i16] = ACTIONS(2685),
    [anon_sym_u32] = ACTIONS(2685),
    [anon_sym_i32] = ACTIONS(2685),
    [anon_sym_u64] = ACTIONS(2685),
    [anon_sym_i64] = ACTIONS(2685),
    [anon_sym_u128] = ACTIONS(2685),
    [anon_sym_i128] = ACTIONS(2685),
    [anon_sym_isize] = ACTIONS(2685),
    [anon_sym_usize] = ACTIONS(2685),
    [anon_sym_f32] = ACTIONS(2685),
    [anon_sym_f64] = ACTIONS(2685),
    [anon_sym_bool] = ACTIONS(2685),
    [anon_sym_str] = ACTIONS(2685),
    [anon_sym_char] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2683),
    [anon_sym_BANG] = ACTIONS(2683),
    [anon_sym_AMP] = ACTIONS(2683),
    [anon_sym_PIPE] = ACTIONS(2683),
    [anon_sym_LT] = ACTIONS(2683),
    [anon_sym_DOT_DOT] = ACTIONS(2683),
    [anon_sym_COLON_COLON] = ACTIONS(2683),
    [anon_sym_POUND] = ACTIONS(2683),
    [anon_sym_SQUOTE] = ACTIONS(2685),
    [anon_sym_async] = ACTIONS(2685),
    [anon_sym_break] = ACTIONS(2685),
    [anon_sym_const] = ACTIONS(2685),
    [anon_sym_continue] = ACTIONS(2685),
    [anon_sym_default] = ACTIONS(2685),
    [anon_sym_enum] = ACTIONS(2685),
    [anon_sym_fn] = ACTIONS(2685),
    [anon_sym_for] = ACTIONS(2685),
    [anon_sym_if] = ACTIONS(2685),
    [anon_sym_impl] = ACTIONS(2685),
    [anon_sym_let] = ACTIONS(2685),
    [anon_sym_loop] = ACTIONS(2685),
    [anon_sym_match] = ACTIONS(2685),
    [anon_sym_mod] = ACTIONS(2685),
    [anon_sym_pub] = ACTIONS(2685),
    [anon_sym_return] = ACTIONS(2685),
    [anon_sym_static] = ACTIONS(2685),
    [anon_sym_struct] = ACTIONS(2685),
    [anon_sym_trait] = ACTIONS(2685),
    [anon_sym_type] = ACTIONS(2685),
    [anon_sym_union] = ACTIONS(2685),
    [anon_sym_unsafe] = ACTIONS(2685),
    [anon_sym_use] = ACTIONS(2685),
    [anon_sym_while] = ACTIONS(2685),
    [anon_sym_extern] = ACTIONS(2685),
    [anon_sym_yield] = ACTIONS(2685),
    [anon_sym_move] = ACTIONS(2685),
    [anon_sym_try] = ACTIONS(2685),
    [sym_integer_literal] = ACTIONS(2683),
    [aux_sym_string_literal_token1] = ACTIONS(2683),
    [sym_char_literal] = ACTIONS(2683),
    [anon_sym_true] = ACTIONS(2685),
    [anon_sym_false] = ACTIONS(2685),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2685),
    [sym_super] = ACTIONS(2685),
    [sym_crate] = ACTIONS(2685),
    [sym_metavariable] = ACTIONS(2683),
    [sym__raw_string_literal_start] = ACTIONS(2683),
    [sym_float_literal] = ACTIONS(2683),
  },
  [695] = {
    [sym_line_comment] = STATE(695),
    [sym_block_comment] = STATE(695),
    [ts_builtin_sym_end] = ACTIONS(2687),
    [sym_identifier] = ACTIONS(2689),
    [anon_sym_SEMI] = ACTIONS(2687),
    [anon_sym_macro_rules_BANG] = ACTIONS(2687),
    [anon_sym_LPAREN] = ACTIONS(2687),
    [anon_sym_LBRACK] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2687),
    [anon_sym_RBRACE] = ACTIONS(2687),
    [anon_sym_STAR] = ACTIONS(2687),
    [anon_sym_u8] = ACTIONS(2689),
    [anon_sym_i8] = ACTIONS(2689),
    [anon_sym_u16] = ACTIONS(2689),
    [anon_sym_i16] = ACTIONS(2689),
    [anon_sym_u32] = ACTIONS(2689),
    [anon_sym_i32] = ACTIONS(2689),
    [anon_sym_u64] = ACTIONS(2689),
    [anon_sym_i64] = ACTIONS(2689),
    [anon_sym_u128] = ACTIONS(2689),
    [anon_sym_i128] = ACTIONS(2689),
    [anon_sym_isize] = ACTIONS(2689),
    [anon_sym_usize] = ACTIONS(2689),
    [anon_sym_f32] = ACTIONS(2689),
    [anon_sym_f64] = ACTIONS(2689),
    [anon_sym_bool] = ACTIONS(2689),
    [anon_sym_str] = ACTIONS(2689),
    [anon_sym_char] = ACTIONS(2689),
    [anon_sym_DASH] = ACTIONS(2687),
    [anon_sym_BANG] = ACTIONS(2687),
    [anon_sym_AMP] = ACTIONS(2687),
    [anon_sym_PIPE] = ACTIONS(2687),
    [anon_sym_LT] = ACTIONS(2687),
    [anon_sym_DOT_DOT] = ACTIONS(2687),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_POUND] = ACTIONS(2687),
    [anon_sym_SQUOTE] = ACTIONS(2689),
    [anon_sym_async] = ACTIONS(2689),
    [anon_sym_break] = ACTIONS(2689),
    [anon_sym_const] = ACTIONS(2689),
    [anon_sym_continue] = ACTIONS(2689),
    [anon_sym_default] = ACTIONS(2689),
    [anon_sym_enum] = ACTIONS(2689),
    [anon_sym_fn] = ACTIONS(2689),
    [anon_sym_for] = ACTIONS(2689),
    [anon_sym_if] = ACTIONS(2689),
    [anon_sym_impl] = ACTIONS(2689),
    [anon_sym_let] = ACTIONS(2689),
    [anon_sym_loop] = ACTIONS(2689),
    [anon_sym_match] = ACTIONS(2689),
    [anon_sym_mod] = ACTIONS(2689),
    [anon_sym_pub] = ACTIONS(2689),
    [anon_sym_return] = ACTIONS(2689),
    [anon_sym_static] = ACTIONS(2689),
    [anon_sym_struct] = ACTIONS(2689),
    [anon_sym_trait] = ACTIONS(2689),
    [anon_sym_type] = ACTIONS(2689),
    [anon_sym_union] = ACTIONS(2689),
    [anon_sym_unsafe] = ACTIONS(2689),
    [anon_sym_use] = ACTIONS(2689),
    [anon_sym_while] = ACTIONS(2689),
    [anon_sym_extern] = ACTIONS(2689),
    [anon_sym_yield] = ACTIONS(2689),
    [anon_sym_move] = ACTIONS(2689),
    [anon_sym_try] = ACTIONS(2689),
    [sym_integer_literal] = ACTIONS(2687),
    [aux_sym_string_literal_token1] = ACTIONS(2687),
    [sym_char_literal] = ACTIONS(2687),
    [anon_sym_true] = ACTIONS(2689),
    [anon_sym_false] = ACTIONS(2689),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2689),
    [sym_super] = ACTIONS(2689),
    [sym_crate] = ACTIONS(2689),
    [sym_metavariable] = ACTIONS(2687),
    [sym__raw_string_literal_start] = ACTIONS(2687),
    [sym_float_literal] = ACTIONS(2687),
  },
  [696] = {
    [sym_line_comment] = STATE(696),
    [sym_block_comment] = STATE(696),
    [ts_builtin_sym_end] = ACTIONS(2691),
    [sym_identifier] = ACTIONS(2693),
    [anon_sym_SEMI] = ACTIONS(2691),
    [anon_sym_macro_rules_BANG] = ACTIONS(2691),
    [anon_sym_LPAREN] = ACTIONS(2691),
    [anon_sym_LBRACK] = ACTIONS(2691),
    [anon_sym_LBRACE] = ACTIONS(2691),
    [anon_sym_RBRACE] = ACTIONS(2691),
    [anon_sym_STAR] = ACTIONS(2691),
    [anon_sym_u8] = ACTIONS(2693),
    [anon_sym_i8] = ACTIONS(2693),
    [anon_sym_u16] = ACTIONS(2693),
    [anon_sym_i16] = ACTIONS(2693),
    [anon_sym_u32] = ACTIONS(2693),
    [anon_sym_i32] = ACTIONS(2693),
    [anon_sym_u64] = ACTIONS(2693),
    [anon_sym_i64] = ACTIONS(2693),
    [anon_sym_u128] = ACTIONS(2693),
    [anon_sym_i128] = ACTIONS(2693),
    [anon_sym_isize] = ACTIONS(2693),
    [anon_sym_usize] = ACTIONS(2693),
    [anon_sym_f32] = ACTIONS(2693),
    [anon_sym_f64] = ACTIONS(2693),
    [anon_sym_bool] = ACTIONS(2693),
    [anon_sym_str] = ACTIONS(2693),
    [anon_sym_char] = ACTIONS(2693),
    [anon_sym_DASH] = ACTIONS(2691),
    [anon_sym_BANG] = ACTIONS(2691),
    [anon_sym_AMP] = ACTIONS(2691),
    [anon_sym_PIPE] = ACTIONS(2691),
    [anon_sym_LT] = ACTIONS(2691),
    [anon_sym_DOT_DOT] = ACTIONS(2691),
    [anon_sym_COLON_COLON] = ACTIONS(2691),
    [anon_sym_POUND] = ACTIONS(2691),
    [anon_sym_SQUOTE] = ACTIONS(2693),
    [anon_sym_async] = ACTIONS(2693),
    [anon_sym_break] = ACTIONS(2693),
    [anon_sym_const] = ACTIONS(2693),
    [anon_sym_continue] = ACTIONS(2693),
    [anon_sym_default] = ACTIONS(2693),
    [anon_sym_enum] = ACTIONS(2693),
    [anon_sym_fn] = ACTIONS(2693),
    [anon_sym_for] = ACTIONS(2693),
    [anon_sym_if] = ACTIONS(2693),
    [anon_sym_impl] = ACTIONS(2693),
    [anon_sym_let] = ACTIONS(2693),
    [anon_sym_loop] = ACTIONS(2693),
    [anon_sym_match] = ACTIONS(2693),
    [anon_sym_mod] = ACTIONS(2693),
    [anon_sym_pub] = ACTIONS(2693),
    [anon_sym_return] = ACTIONS(2693),
    [anon_sym_static] = ACTIONS(2693),
    [anon_sym_struct] = ACTIONS(2693),
    [anon_sym_trait] = ACTIONS(2693),
    [anon_sym_type] = ACTIONS(2693),
    [anon_sym_union] = ACTIONS(2693),
    [anon_sym_unsafe] = ACTIONS(2693),
    [anon_sym_use] = ACTIONS(2693),
    [anon_sym_while] = ACTIONS(2693),
    [anon_sym_extern] = ACTIONS(2693),
    [anon_sym_yield] = ACTIONS(2693),
    [anon_sym_move] = ACTIONS(2693),
    [anon_sym_try] = ACTIONS(2693),
    [sym_integer_literal] = ACTIONS(2691),
    [aux_sym_string_literal_token1] = ACTIONS(2691),
    [sym_char_literal] = ACTIONS(2691),
    [anon_sym_true] = ACTIONS(2693),
    [anon_sym_false] = ACTIONS(2693),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2693),
    [sym_super] = ACTIONS(2693),
    [sym_crate] = ACTIONS(2693),
    [sym_metavariable] = ACTIONS(2691),
    [sym__raw_string_literal_start] = ACTIONS(2691),
    [sym_float_literal] = ACTIONS(2691),
  },
  [697] = {
    [sym_line_comment] = STATE(697),
    [sym_block_comment] = STATE(697),
    [ts_builtin_sym_end] = ACTIONS(2695),
    [sym_identifier] = ACTIONS(2697),
    [anon_sym_SEMI] = ACTIONS(2695),
    [anon_sym_macro_rules_BANG] = ACTIONS(2695),
    [anon_sym_LPAREN] = ACTIONS(2695),
    [anon_sym_LBRACK] = ACTIONS(2695),
    [anon_sym_LBRACE] = ACTIONS(2695),
    [anon_sym_RBRACE] = ACTIONS(2695),
    [anon_sym_STAR] = ACTIONS(2695),
    [anon_sym_u8] = ACTIONS(2697),
    [anon_sym_i8] = ACTIONS(2697),
    [anon_sym_u16] = ACTIONS(2697),
    [anon_sym_i16] = ACTIONS(2697),
    [anon_sym_u32] = ACTIONS(2697),
    [anon_sym_i32] = ACTIONS(2697),
    [anon_sym_u64] = ACTIONS(2697),
    [anon_sym_i64] = ACTIONS(2697),
    [anon_sym_u128] = ACTIONS(2697),
    [anon_sym_i128] = ACTIONS(2697),
    [anon_sym_isize] = ACTIONS(2697),
    [anon_sym_usize] = ACTIONS(2697),
    [anon_sym_f32] = ACTIONS(2697),
    [anon_sym_f64] = ACTIONS(2697),
    [anon_sym_bool] = ACTIONS(2697),
    [anon_sym_str] = ACTIONS(2697),
    [anon_sym_char] = ACTIONS(2697),
    [anon_sym_DASH] = ACTIONS(2695),
    [anon_sym_BANG] = ACTIONS(2695),
    [anon_sym_AMP] = ACTIONS(2695),
    [anon_sym_PIPE] = ACTIONS(2695),
    [anon_sym_LT] = ACTIONS(2695),
    [anon_sym_DOT_DOT] = ACTIONS(2695),
    [anon_sym_COLON_COLON] = ACTIONS(2695),
    [anon_sym_POUND] = ACTIONS(2695),
    [anon_sym_SQUOTE] = ACTIONS(2697),
    [anon_sym_async] = ACTIONS(2697),
    [anon_sym_break] = ACTIONS(2697),
    [anon_sym_const] = ACTIONS(2697),
    [anon_sym_continue] = ACTIONS(2697),
    [anon_sym_default] = ACTIONS(2697),
    [anon_sym_enum] = ACTIONS(2697),
    [anon_sym_fn] = ACTIONS(2697),
    [anon_sym_for] = ACTIONS(2697),
    [anon_sym_if] = ACTIONS(2697),
    [anon_sym_impl] = ACTIONS(2697),
    [anon_sym_let] = ACTIONS(2697),
    [anon_sym_loop] = ACTIONS(2697),
    [anon_sym_match] = ACTIONS(2697),
    [anon_sym_mod] = ACTIONS(2697),
    [anon_sym_pub] = ACTIONS(2697),
    [anon_sym_return] = ACTIONS(2697),
    [anon_sym_static] = ACTIONS(2697),
    [anon_sym_struct] = ACTIONS(2697),
    [anon_sym_trait] = ACTIONS(2697),
    [anon_sym_type] = ACTIONS(2697),
    [anon_sym_union] = ACTIONS(2697),
    [anon_sym_unsafe] = ACTIONS(2697),
    [anon_sym_use] = ACTIONS(2697),
    [anon_sym_while] = ACTIONS(2697),
    [anon_sym_extern] = ACTIONS(2697),
    [anon_sym_yield] = ACTIONS(2697),
    [anon_sym_move] = ACTIONS(2697),
    [anon_sym_try] = ACTIONS(2697),
    [sym_integer_literal] = ACTIONS(2695),
    [aux_sym_string_literal_token1] = ACTIONS(2695),
    [sym_char_literal] = ACTIONS(2695),
    [anon_sym_true] = ACTIONS(2697),
    [anon_sym_false] = ACTIONS(2697),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2697),
    [sym_super] = ACTIONS(2697),
    [sym_crate] = ACTIONS(2697),
    [sym_metavariable] = ACTIONS(2695),
    [sym__raw_string_literal_start] = ACTIONS(2695),
    [sym_float_literal] = ACTIONS(2695),
  },
  [698] = {
    [sym_line_comment] = STATE(698),
    [sym_block_comment] = STATE(698),
    [ts_builtin_sym_end] = ACTIONS(2699),
    [sym_identifier] = ACTIONS(2701),
    [anon_sym_SEMI] = ACTIONS(2699),
    [anon_sym_macro_rules_BANG] = ACTIONS(2699),
    [anon_sym_LPAREN] = ACTIONS(2699),
    [anon_sym_LBRACK] = ACTIONS(2699),
    [anon_sym_LBRACE] = ACTIONS(2699),
    [anon_sym_RBRACE] = ACTIONS(2699),
    [anon_sym_STAR] = ACTIONS(2699),
    [anon_sym_u8] = ACTIONS(2701),
    [anon_sym_i8] = ACTIONS(2701),
    [anon_sym_u16] = ACTIONS(2701),
    [anon_sym_i16] = ACTIONS(2701),
    [anon_sym_u32] = ACTIONS(2701),
    [anon_sym_i32] = ACTIONS(2701),
    [anon_sym_u64] = ACTIONS(2701),
    [anon_sym_i64] = ACTIONS(2701),
    [anon_sym_u128] = ACTIONS(2701),
    [anon_sym_i128] = ACTIONS(2701),
    [anon_sym_isize] = ACTIONS(2701),
    [anon_sym_usize] = ACTIONS(2701),
    [anon_sym_f32] = ACTIONS(2701),
    [anon_sym_f64] = ACTIONS(2701),
    [anon_sym_bool] = ACTIONS(2701),
    [anon_sym_str] = ACTIONS(2701),
    [anon_sym_char] = ACTIONS(2701),
    [anon_sym_DASH] = ACTIONS(2699),
    [anon_sym_BANG] = ACTIONS(2699),
    [anon_sym_AMP] = ACTIONS(2699),
    [anon_sym_PIPE] = ACTIONS(2699),
    [anon_sym_LT] = ACTIONS(2699),
    [anon_sym_DOT_DOT] = ACTIONS(2699),
    [anon_sym_COLON_COLON] = ACTIONS(2699),
    [anon_sym_POUND] = ACTIONS(2699),
    [anon_sym_SQUOTE] = ACTIONS(2701),
    [anon_sym_async] = ACTIONS(2701),
    [anon_sym_break] = ACTIONS(2701),
    [anon_sym_const] = ACTIONS(2701),
    [anon_sym_continue] = ACTIONS(2701),
    [anon_sym_default] = ACTIONS(2701),
    [anon_sym_enum] = ACTIONS(2701),
    [anon_sym_fn] = ACTIONS(2701),
    [anon_sym_for] = ACTIONS(2701),
    [anon_sym_if] = ACTIONS(2701),
    [anon_sym_impl] = ACTIONS(2701),
    [anon_sym_let] = ACTIONS(2701),
    [anon_sym_loop] = ACTIONS(2701),
    [anon_sym_match] = ACTIONS(2701),
    [anon_sym_mod] = ACTIONS(2701),
    [anon_sym_pub] = ACTIONS(2701),
    [anon_sym_return] = ACTIONS(2701),
    [anon_sym_static] = ACTIONS(2701),
    [anon_sym_struct] = ACTIONS(2701),
    [anon_sym_trait] = ACTIONS(2701),
    [anon_sym_type] = ACTIONS(2701),
    [anon_sym_union] = ACTIONS(2701),
    [anon_sym_unsafe] = ACTIONS(2701),
    [anon_sym_use] = ACTIONS(2701),
    [anon_sym_while] = ACTIONS(2701),
    [anon_sym_extern] = ACTIONS(2701),
    [anon_sym_yield] = ACTIONS(2701),
    [anon_sym_move] = ACTIONS(2701),
    [anon_sym_try] = ACTIONS(2701),
    [sym_integer_literal] = ACTIONS(2699),
    [aux_sym_string_literal_token1] = ACTIONS(2699),
    [sym_char_literal] = ACTIONS(2699),
    [anon_sym_true] = ACTIONS(2701),
    [anon_sym_false] = ACTIONS(2701),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2701),
    [sym_super] = ACTIONS(2701),
    [sym_crate] = ACTIONS(2701),
    [sym_metavariable] = ACTIONS(2699),
    [sym__raw_string_literal_start] = ACTIONS(2699),
    [sym_float_literal] = ACTIONS(2699),
  },
  [699] = {
    [sym_line_comment] = STATE(699),
    [sym_block_comment] = STATE(699),
    [ts_builtin_sym_end] = ACTIONS(2703),
    [sym_identifier] = ACTIONS(2705),
    [anon_sym_SEMI] = ACTIONS(2703),
    [anon_sym_macro_rules_BANG] = ACTIONS(2703),
    [anon_sym_LPAREN] = ACTIONS(2703),
    [anon_sym_LBRACK] = ACTIONS(2703),
    [anon_sym_LBRACE] = ACTIONS(2703),
    [anon_sym_RBRACE] = ACTIONS(2703),
    [anon_sym_STAR] = ACTIONS(2703),
    [anon_sym_u8] = ACTIONS(2705),
    [anon_sym_i8] = ACTIONS(2705),
    [anon_sym_u16] = ACTIONS(2705),
    [anon_sym_i16] = ACTIONS(2705),
    [anon_sym_u32] = ACTIONS(2705),
    [anon_sym_i32] = ACTIONS(2705),
    [anon_sym_u64] = ACTIONS(2705),
    [anon_sym_i64] = ACTIONS(2705),
    [anon_sym_u128] = ACTIONS(2705),
    [anon_sym_i128] = ACTIONS(2705),
    [anon_sym_isize] = ACTIONS(2705),
    [anon_sym_usize] = ACTIONS(2705),
    [anon_sym_f32] = ACTIONS(2705),
    [anon_sym_f64] = ACTIONS(2705),
    [anon_sym_bool] = ACTIONS(2705),
    [anon_sym_str] = ACTIONS(2705),
    [anon_sym_char] = ACTIONS(2705),
    [anon_sym_DASH] = ACTIONS(2703),
    [anon_sym_BANG] = ACTIONS(2703),
    [anon_sym_AMP] = ACTIONS(2703),
    [anon_sym_PIPE] = ACTIONS(2703),
    [anon_sym_LT] = ACTIONS(2703),
    [anon_sym_DOT_DOT] = ACTIONS(2703),
    [anon_sym_COLON_COLON] = ACTIONS(2703),
    [anon_sym_POUND] = ACTIONS(2703),
    [anon_sym_SQUOTE] = ACTIONS(2705),
    [anon_sym_async] = ACTIONS(2705),
    [anon_sym_break] = ACTIONS(2705),
    [anon_sym_const] = ACTIONS(2705),
    [anon_sym_continue] = ACTIONS(2705),
    [anon_sym_default] = ACTIONS(2705),
    [anon_sym_enum] = ACTIONS(2705),
    [anon_sym_fn] = ACTIONS(2705),
    [anon_sym_for] = ACTIONS(2705),
    [anon_sym_if] = ACTIONS(2705),
    [anon_sym_impl] = ACTIONS(2705),
    [anon_sym_let] = ACTIONS(2705),
    [anon_sym_loop] = ACTIONS(2705),
    [anon_sym_match] = ACTIONS(2705),
    [anon_sym_mod] = ACTIONS(2705),
    [anon_sym_pub] = ACTIONS(2705),
    [anon_sym_return] = ACTIONS(2705),
    [anon_sym_static] = ACTIONS(2705),
    [anon_sym_struct] = ACTIONS(2705),
    [anon_sym_trait] = ACTIONS(2705),
    [anon_sym_type] = ACTIONS(2705),
    [anon_sym_union] = ACTIONS(2705),
    [anon_sym_unsafe] = ACTIONS(2705),
    [anon_sym_use] = ACTIONS(2705),
    [anon_sym_while] = ACTIONS(2705),
    [anon_sym_extern] = ACTIONS(2705),
    [anon_sym_yield] = ACTIONS(2705),
    [anon_sym_move] = ACTIONS(2705),
    [anon_sym_try] = ACTIONS(2705),
    [sym_integer_literal] = ACTIONS(2703),
    [aux_sym_string_literal_token1] = ACTIONS(2703),
    [sym_char_literal] = ACTIONS(2703),
    [anon_sym_true] = ACTIONS(2705),
    [anon_sym_false] = ACTIONS(2705),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2705),
    [sym_super] = ACTIONS(2705),
    [sym_crate] = ACTIONS(2705),
    [sym_metavariable] = ACTIONS(2703),
    [sym__raw_string_literal_start] = ACTIONS(2703),
    [sym_float_literal] = ACTIONS(2703),
  },
  [700] = {
    [sym_line_comment] = STATE(700),
    [sym_block_comment] = STATE(700),
    [ts_builtin_sym_end] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2709),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_macro_rules_BANG] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(2707),
    [anon_sym_LBRACK] = ACTIONS(2707),
    [anon_sym_LBRACE] = ACTIONS(2707),
    [anon_sym_RBRACE] = ACTIONS(2707),
    [anon_sym_STAR] = ACTIONS(2707),
    [anon_sym_u8] = ACTIONS(2709),
    [anon_sym_i8] = ACTIONS(2709),
    [anon_sym_u16] = ACTIONS(2709),
    [anon_sym_i16] = ACTIONS(2709),
    [anon_sym_u32] = ACTIONS(2709),
    [anon_sym_i32] = ACTIONS(2709),
    [anon_sym_u64] = ACTIONS(2709),
    [anon_sym_i64] = ACTIONS(2709),
    [anon_sym_u128] = ACTIONS(2709),
    [anon_sym_i128] = ACTIONS(2709),
    [anon_sym_isize] = ACTIONS(2709),
    [anon_sym_usize] = ACTIONS(2709),
    [anon_sym_f32] = ACTIONS(2709),
    [anon_sym_f64] = ACTIONS(2709),
    [anon_sym_bool] = ACTIONS(2709),
    [anon_sym_str] = ACTIONS(2709),
    [anon_sym_char] = ACTIONS(2709),
    [anon_sym_DASH] = ACTIONS(2707),
    [anon_sym_BANG] = ACTIONS(2707),
    [anon_sym_AMP] = ACTIONS(2707),
    [anon_sym_PIPE] = ACTIONS(2707),
    [anon_sym_LT] = ACTIONS(2707),
    [anon_sym_DOT_DOT] = ACTIONS(2707),
    [anon_sym_COLON_COLON] = ACTIONS(2707),
    [anon_sym_POUND] = ACTIONS(2707),
    [anon_sym_SQUOTE] = ACTIONS(2709),
    [anon_sym_async] = ACTIONS(2709),
    [anon_sym_break] = ACTIONS(2709),
    [anon_sym_const] = ACTIONS(2709),
    [anon_sym_continue] = ACTIONS(2709),
    [anon_sym_default] = ACTIONS(2709),
    [anon_sym_enum] = ACTIONS(2709),
    [anon_sym_fn] = ACTIONS(2709),
    [anon_sym_for] = ACTIONS(2709),
    [anon_sym_if] = ACTIONS(2709),
    [anon_sym_impl] = ACTIONS(2709),
    [anon_sym_let] = ACTIONS(2709),
    [anon_sym_loop] = ACTIONS(2709),
    [anon_sym_match] = ACTIONS(2709),
    [anon_sym_mod] = ACTIONS(2709),
    [anon_sym_pub] = ACTIONS(2709),
    [anon_sym_return] = ACTIONS(2709),
    [anon_sym_static] = ACTIONS(2709),
    [anon_sym_struct] = ACTIONS(2709),
    [anon_sym_trait] = ACTIONS(2709),
    [anon_sym_type] = ACTIONS(2709),
    [anon_sym_union] = ACTIONS(2709),
    [anon_sym_unsafe] = ACTIONS(2709),
    [anon_sym_use] = ACTIONS(2709),
    [anon_sym_while] = ACTIONS(2709),
    [anon_sym_extern] = ACTIONS(2709),
    [anon_sym_yield] = ACTIONS(2709),
    [anon_sym_move] = ACTIONS(2709),
    [anon_sym_try] = ACTIONS(2709),
    [sym_integer_literal] = ACTIONS(2707),
    [aux_sym_string_literal_token1] = ACTIONS(2707),
    [sym_char_literal] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(2709),
    [anon_sym_false] = ACTIONS(2709),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2709),
    [sym_super] = ACTIONS(2709),
    [sym_crate] = ACTIONS(2709),
    [sym_metavariable] = ACTIONS(2707),
    [sym__raw_string_literal_start] = ACTIONS(2707),
    [sym_float_literal] = ACTIONS(2707),
  },
  [701] = {
    [sym_line_comment] = STATE(701),
    [sym_block_comment] = STATE(701),
    [ts_builtin_sym_end] = ACTIONS(2711),
    [sym_identifier] = ACTIONS(2713),
    [anon_sym_SEMI] = ACTIONS(2711),
    [anon_sym_macro_rules_BANG] = ACTIONS(2711),
    [anon_sym_LPAREN] = ACTIONS(2711),
    [anon_sym_LBRACK] = ACTIONS(2711),
    [anon_sym_LBRACE] = ACTIONS(2711),
    [anon_sym_RBRACE] = ACTIONS(2711),
    [anon_sym_STAR] = ACTIONS(2711),
    [anon_sym_u8] = ACTIONS(2713),
    [anon_sym_i8] = ACTIONS(2713),
    [anon_sym_u16] = ACTIONS(2713),
    [anon_sym_i16] = ACTIONS(2713),
    [anon_sym_u32] = ACTIONS(2713),
    [anon_sym_i32] = ACTIONS(2713),
    [anon_sym_u64] = ACTIONS(2713),
    [anon_sym_i64] = ACTIONS(2713),
    [anon_sym_u128] = ACTIONS(2713),
    [anon_sym_i128] = ACTIONS(2713),
    [anon_sym_isize] = ACTIONS(2713),
    [anon_sym_usize] = ACTIONS(2713),
    [anon_sym_f32] = ACTIONS(2713),
    [anon_sym_f64] = ACTIONS(2713),
    [anon_sym_bool] = ACTIONS(2713),
    [anon_sym_str] = ACTIONS(2713),
    [anon_sym_char] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2711),
    [anon_sym_BANG] = ACTIONS(2711),
    [anon_sym_AMP] = ACTIONS(2711),
    [anon_sym_PIPE] = ACTIONS(2711),
    [anon_sym_LT] = ACTIONS(2711),
    [anon_sym_DOT_DOT] = ACTIONS(2711),
    [anon_sym_COLON_COLON] = ACTIONS(2711),
    [anon_sym_POUND] = ACTIONS(2711),
    [anon_sym_SQUOTE] = ACTIONS(2713),
    [anon_sym_async] = ACTIONS(2713),
    [anon_sym_break] = ACTIONS(2713),
    [anon_sym_const] = ACTIONS(2713),
    [anon_sym_continue] = ACTIONS(2713),
    [anon_sym_default] = ACTIONS(2713),
    [anon_sym_enum] = ACTIONS(2713),
    [anon_sym_fn] = ACTIONS(2713),
    [anon_sym_for] = ACTIONS(2713),
    [anon_sym_if] = ACTIONS(2713),
    [anon_sym_impl] = ACTIONS(2713),
    [anon_sym_let] = ACTIONS(2713),
    [anon_sym_loop] = ACTIONS(2713),
    [anon_sym_match] = ACTIONS(2713),
    [anon_sym_mod] = ACTIONS(2713),
    [anon_sym_pub] = ACTIONS(2713),
    [anon_sym_return] = ACTIONS(2713),
    [anon_sym_static] = ACTIONS(2713),
    [anon_sym_struct] = ACTIONS(2713),
    [anon_sym_trait] = ACTIONS(2713),
    [anon_sym_type] = ACTIONS(2713),
    [anon_sym_union] = ACTIONS(2713),
    [anon_sym_unsafe] = ACTIONS(2713),
    [anon_sym_use] = ACTIONS(2713),
    [anon_sym_while] = ACTIONS(2713),
    [anon_sym_extern] = ACTIONS(2713),
    [anon_sym_yield] = ACTIONS(2713),
    [anon_sym_move] = ACTIONS(2713),
    [anon_sym_try] = ACTIONS(2713),
    [sym_integer_literal] = ACTIONS(2711),
    [aux_sym_string_literal_token1] = ACTIONS(2711),
    [sym_char_literal] = ACTIONS(2711),
    [anon_sym_true] = ACTIONS(2713),
    [anon_sym_false] = ACTIONS(2713),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2713),
    [sym_super] = ACTIONS(2713),
    [sym_crate] = ACTIONS(2713),
    [sym_metavariable] = ACTIONS(2711),
    [sym__raw_string_literal_start] = ACTIONS(2711),
    [sym_float_literal] = ACTIONS(2711),
  },
  [702] = {
    [sym_line_comment] = STATE(702),
    [sym_block_comment] = STATE(702),
    [ts_builtin_sym_end] = ACTIONS(2715),
    [sym_identifier] = ACTIONS(2717),
    [anon_sym_SEMI] = ACTIONS(2715),
    [anon_sym_macro_rules_BANG] = ACTIONS(2715),
    [anon_sym_LPAREN] = ACTIONS(2715),
    [anon_sym_LBRACK] = ACTIONS(2715),
    [anon_sym_LBRACE] = ACTIONS(2715),
    [anon_sym_RBRACE] = ACTIONS(2715),
    [anon_sym_STAR] = ACTIONS(2715),
    [anon_sym_u8] = ACTIONS(2717),
    [anon_sym_i8] = ACTIONS(2717),
    [anon_sym_u16] = ACTIONS(2717),
    [anon_sym_i16] = ACTIONS(2717),
    [anon_sym_u32] = ACTIONS(2717),
    [anon_sym_i32] = ACTIONS(2717),
    [anon_sym_u64] = ACTIONS(2717),
    [anon_sym_i64] = ACTIONS(2717),
    [anon_sym_u128] = ACTIONS(2717),
    [anon_sym_i128] = ACTIONS(2717),
    [anon_sym_isize] = ACTIONS(2717),
    [anon_sym_usize] = ACTIONS(2717),
    [anon_sym_f32] = ACTIONS(2717),
    [anon_sym_f64] = ACTIONS(2717),
    [anon_sym_bool] = ACTIONS(2717),
    [anon_sym_str] = ACTIONS(2717),
    [anon_sym_char] = ACTIONS(2717),
    [anon_sym_DASH] = ACTIONS(2715),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_AMP] = ACTIONS(2715),
    [anon_sym_PIPE] = ACTIONS(2715),
    [anon_sym_LT] = ACTIONS(2715),
    [anon_sym_DOT_DOT] = ACTIONS(2715),
    [anon_sym_COLON_COLON] = ACTIONS(2715),
    [anon_sym_POUND] = ACTIONS(2715),
    [anon_sym_SQUOTE] = ACTIONS(2717),
    [anon_sym_async] = ACTIONS(2717),
    [anon_sym_break] = ACTIONS(2717),
    [anon_sym_const] = ACTIONS(2717),
    [anon_sym_continue] = ACTIONS(2717),
    [anon_sym_default] = ACTIONS(2717),
    [anon_sym_enum] = ACTIONS(2717),
    [anon_sym_fn] = ACTIONS(2717),
    [anon_sym_for] = ACTIONS(2717),
    [anon_sym_if] = ACTIONS(2717),
    [anon_sym_impl] = ACTIONS(2717),
    [anon_sym_let] = ACTIONS(2717),
    [anon_sym_loop] = ACTIONS(2717),
    [anon_sym_match] = ACTIONS(2717),
    [anon_sym_mod] = ACTIONS(2717),
    [anon_sym_pub] = ACTIONS(2717),
    [anon_sym_return] = ACTIONS(2717),
    [anon_sym_static] = ACTIONS(2717),
    [anon_sym_struct] = ACTIONS(2717),
    [anon_sym_trait] = ACTIONS(2717),
    [anon_sym_type] = ACTIONS(2717),
    [anon_sym_union] = ACTIONS(2717),
    [anon_sym_unsafe] = ACTIONS(2717),
    [anon_sym_use] = ACTIONS(2717),
    [anon_sym_while] = ACTIONS(2717),
    [anon_sym_extern] = ACTIONS(2717),
    [anon_sym_yield] = ACTIONS(2717),
    [anon_sym_move] = ACTIONS(2717),
    [anon_sym_try] = ACTIONS(2717),
    [sym_integer_literal] = ACTIONS(2715),
    [aux_sym_string_literal_token1] = ACTIONS(2715),
    [sym_char_literal] = ACTIONS(2715),
    [anon_sym_true] = ACTIONS(2717),
    [anon_sym_false] = ACTIONS(2717),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2717),
    [sym_super] = ACTIONS(2717),
    [sym_crate] = ACTIONS(2717),
    [sym_metavariable] = ACTIONS(2715),
    [sym__raw_string_literal_start] = ACTIONS(2715),
    [sym_float_literal] = ACTIONS(2715),
  },
  [703] = {
    [sym_line_comment] = STATE(703),
    [sym_block_comment] = STATE(703),
    [ts_builtin_sym_end] = ACTIONS(2719),
    [sym_identifier] = ACTIONS(2721),
    [anon_sym_SEMI] = ACTIONS(2719),
    [anon_sym_macro_rules_BANG] = ACTIONS(2719),
    [anon_sym_LPAREN] = ACTIONS(2719),
    [anon_sym_LBRACK] = ACTIONS(2719),
    [anon_sym_LBRACE] = ACTIONS(2719),
    [anon_sym_RBRACE] = ACTIONS(2719),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_u8] = ACTIONS(2721),
    [anon_sym_i8] = ACTIONS(2721),
    [anon_sym_u16] = ACTIONS(2721),
    [anon_sym_i16] = ACTIONS(2721),
    [anon_sym_u32] = ACTIONS(2721),
    [anon_sym_i32] = ACTIONS(2721),
    [anon_sym_u64] = ACTIONS(2721),
    [anon_sym_i64] = ACTIONS(2721),
    [anon_sym_u128] = ACTIONS(2721),
    [anon_sym_i128] = ACTIONS(2721),
    [anon_sym_isize] = ACTIONS(2721),
    [anon_sym_usize] = ACTIONS(2721),
    [anon_sym_f32] = ACTIONS(2721),
    [anon_sym_f64] = ACTIONS(2721),
    [anon_sym_bool] = ACTIONS(2721),
    [anon_sym_str] = ACTIONS(2721),
    [anon_sym_char] = ACTIONS(2721),
    [anon_sym_DASH] = ACTIONS(2719),
    [anon_sym_BANG] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym_PIPE] = ACTIONS(2719),
    [anon_sym_LT] = ACTIONS(2719),
    [anon_sym_DOT_DOT] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(2719),
    [anon_sym_POUND] = ACTIONS(2719),
    [anon_sym_SQUOTE] = ACTIONS(2721),
    [anon_sym_async] = ACTIONS(2721),
    [anon_sym_break] = ACTIONS(2721),
    [anon_sym_const] = ACTIONS(2721),
    [anon_sym_continue] = ACTIONS(2721),
    [anon_sym_default] = ACTIONS(2721),
    [anon_sym_enum] = ACTIONS(2721),
    [anon_sym_fn] = ACTIONS(2721),
    [anon_sym_for] = ACTIONS(2721),
    [anon_sym_if] = ACTIONS(2721),
    [anon_sym_impl] = ACTIONS(2721),
    [anon_sym_let] = ACTIONS(2721),
    [anon_sym_loop] = ACTIONS(2721),
    [anon_sym_match] = ACTIONS(2721),
    [anon_sym_mod] = ACTIONS(2721),
    [anon_sym_pub] = ACTIONS(2721),
    [anon_sym_return] = ACTIONS(2721),
    [anon_sym_static] = ACTIONS(2721),
    [anon_sym_struct] = ACTIONS(2721),
    [anon_sym_trait] = ACTIONS(2721),
    [anon_sym_type] = ACTIONS(2721),
    [anon_sym_union] = ACTIONS(2721),
    [anon_sym_unsafe] = ACTIONS(2721),
    [anon_sym_use] = ACTIONS(2721),
    [anon_sym_while] = ACTIONS(2721),
    [anon_sym_extern] = ACTIONS(2721),
    [anon_sym_yield] = ACTIONS(2721),
    [anon_sym_move] = ACTIONS(2721),
    [anon_sym_try] = ACTIONS(2721),
    [sym_integer_literal] = ACTIONS(2719),
    [aux_sym_string_literal_token1] = ACTIONS(2719),
    [sym_char_literal] = ACTIONS(2719),
    [anon_sym_true] = ACTIONS(2721),
    [anon_sym_false] = ACTIONS(2721),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2721),
    [sym_super] = ACTIONS(2721),
    [sym_crate] = ACTIONS(2721),
    [sym_metavariable] = ACTIONS(2719),
    [sym__raw_string_literal_start] = ACTIONS(2719),
    [sym_float_literal] = ACTIONS(2719),
  },
  [704] = {
    [sym_line_comment] = STATE(704),
    [sym_block_comment] = STATE(704),
    [ts_builtin_sym_end] = ACTIONS(2723),
    [sym_identifier] = ACTIONS(2725),
    [anon_sym_SEMI] = ACTIONS(2723),
    [anon_sym_macro_rules_BANG] = ACTIONS(2723),
    [anon_sym_LPAREN] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_LBRACE] = ACTIONS(2723),
    [anon_sym_RBRACE] = ACTIONS(2723),
    [anon_sym_STAR] = ACTIONS(2723),
    [anon_sym_u8] = ACTIONS(2725),
    [anon_sym_i8] = ACTIONS(2725),
    [anon_sym_u16] = ACTIONS(2725),
    [anon_sym_i16] = ACTIONS(2725),
    [anon_sym_u32] = ACTIONS(2725),
    [anon_sym_i32] = ACTIONS(2725),
    [anon_sym_u64] = ACTIONS(2725),
    [anon_sym_i64] = ACTIONS(2725),
    [anon_sym_u128] = ACTIONS(2725),
    [anon_sym_i128] = ACTIONS(2725),
    [anon_sym_isize] = ACTIONS(2725),
    [anon_sym_usize] = ACTIONS(2725),
    [anon_sym_f32] = ACTIONS(2725),
    [anon_sym_f64] = ACTIONS(2725),
    [anon_sym_bool] = ACTIONS(2725),
    [anon_sym_str] = ACTIONS(2725),
    [anon_sym_char] = ACTIONS(2725),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_BANG] = ACTIONS(2723),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_PIPE] = ACTIONS(2723),
    [anon_sym_LT] = ACTIONS(2723),
    [anon_sym_DOT_DOT] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2723),
    [anon_sym_POUND] = ACTIONS(2723),
    [anon_sym_SQUOTE] = ACTIONS(2725),
    [anon_sym_async] = ACTIONS(2725),
    [anon_sym_break] = ACTIONS(2725),
    [anon_sym_const] = ACTIONS(2725),
    [anon_sym_continue] = ACTIONS(2725),
    [anon_sym_default] = ACTIONS(2725),
    [anon_sym_enum] = ACTIONS(2725),
    [anon_sym_fn] = ACTIONS(2725),
    [anon_sym_for] = ACTIONS(2725),
    [anon_sym_if] = ACTIONS(2725),
    [anon_sym_impl] = ACTIONS(2725),
    [anon_sym_let] = ACTIONS(2725),
    [anon_sym_loop] = ACTIONS(2725),
    [anon_sym_match] = ACTIONS(2725),
    [anon_sym_mod] = ACTIONS(2725),
    [anon_sym_pub] = ACTIONS(2725),
    [anon_sym_return] = ACTIONS(2725),
    [anon_sym_static] = ACTIONS(2725),
    [anon_sym_struct] = ACTIONS(2725),
    [anon_sym_trait] = ACTIONS(2725),
    [anon_sym_type] = ACTIONS(2725),
    [anon_sym_union] = ACTIONS(2725),
    [anon_sym_unsafe] = ACTIONS(2725),
    [anon_sym_use] = ACTIONS(2725),
    [anon_sym_while] = ACTIONS(2725),
    [anon_sym_extern] = ACTIONS(2725),
    [anon_sym_yield] = ACTIONS(2725),
    [anon_sym_move] = ACTIONS(2725),
    [anon_sym_try] = ACTIONS(2725),
    [sym_integer_literal] = ACTIONS(2723),
    [aux_sym_string_literal_token1] = ACTIONS(2723),
    [sym_char_literal] = ACTIONS(2723),
    [anon_sym_true] = ACTIONS(2725),
    [anon_sym_false] = ACTIONS(2725),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2725),
    [sym_super] = ACTIONS(2725),
    [sym_crate] = ACTIONS(2725),
    [sym_metavariable] = ACTIONS(2723),
    [sym__raw_string_literal_start] = ACTIONS(2723),
    [sym_float_literal] = ACTIONS(2723),
  },
  [705] = {
    [sym_line_comment] = STATE(705),
    [sym_block_comment] = STATE(705),
    [ts_builtin_sym_end] = ACTIONS(2727),
    [sym_identifier] = ACTIONS(2729),
    [anon_sym_SEMI] = ACTIONS(2727),
    [anon_sym_macro_rules_BANG] = ACTIONS(2727),
    [anon_sym_LPAREN] = ACTIONS(2727),
    [anon_sym_LBRACK] = ACTIONS(2727),
    [anon_sym_LBRACE] = ACTIONS(2727),
    [anon_sym_RBRACE] = ACTIONS(2727),
    [anon_sym_STAR] = ACTIONS(2727),
    [anon_sym_u8] = ACTIONS(2729),
    [anon_sym_i8] = ACTIONS(2729),
    [anon_sym_u16] = ACTIONS(2729),
    [anon_sym_i16] = ACTIONS(2729),
    [anon_sym_u32] = ACTIONS(2729),
    [anon_sym_i32] = ACTIONS(2729),
    [anon_sym_u64] = ACTIONS(2729),
    [anon_sym_i64] = ACTIONS(2729),
    [anon_sym_u128] = ACTIONS(2729),
    [anon_sym_i128] = ACTIONS(2729),
    [anon_sym_isize] = ACTIONS(2729),
    [anon_sym_usize] = ACTIONS(2729),
    [anon_sym_f32] = ACTIONS(2729),
    [anon_sym_f64] = ACTIONS(2729),
    [anon_sym_bool] = ACTIONS(2729),
    [anon_sym_str] = ACTIONS(2729),
    [anon_sym_char] = ACTIONS(2729),
    [anon_sym_DASH] = ACTIONS(2727),
    [anon_sym_BANG] = ACTIONS(2727),
    [anon_sym_AMP] = ACTIONS(2727),
    [anon_sym_PIPE] = ACTIONS(2727),
    [anon_sym_LT] = ACTIONS(2727),
    [anon_sym_DOT_DOT] = ACTIONS(2727),
    [anon_sym_COLON_COLON] = ACTIONS(2727),
    [anon_sym_POUND] = ACTIONS(2727),
    [anon_sym_SQUOTE] = ACTIONS(2729),
    [anon_sym_async] = ACTIONS(2729),
    [anon_sym_break] = ACTIONS(2729),
    [anon_sym_const] = ACTIONS(2729),
    [anon_sym_continue] = ACTIONS(2729),
    [anon_sym_default] = ACTIONS(2729),
    [anon_sym_enum] = ACTIONS(2729),
    [anon_sym_fn] = ACTIONS(2729),
    [anon_sym_for] = ACTIONS(2729),
    [anon_sym_if] = ACTIONS(2729),
    [anon_sym_impl] = ACTIONS(2729),
    [anon_sym_let] = ACTIONS(2729),
    [anon_sym_loop] = ACTIONS(2729),
    [anon_sym_match] = ACTIONS(2729),
    [anon_sym_mod] = ACTIONS(2729),
    [anon_sym_pub] = ACTIONS(2729),
    [anon_sym_return] = ACTIONS(2729),
    [anon_sym_static] = ACTIONS(2729),
    [anon_sym_struct] = ACTIONS(2729),
    [anon_sym_trait] = ACTIONS(2729),
    [anon_sym_type] = ACTIONS(2729),
    [anon_sym_union] = ACTIONS(2729),
    [anon_sym_unsafe] = ACTIONS(2729),
    [anon_sym_use] = ACTIONS(2729),
    [anon_sym_while] = ACTIONS(2729),
    [anon_sym_extern] = ACTIONS(2729),
    [anon_sym_yield] = ACTIONS(2729),
    [anon_sym_move] = ACTIONS(2729),
    [anon_sym_try] = ACTIONS(2729),
    [sym_integer_literal] = ACTIONS(2727),
    [aux_sym_string_literal_token1] = ACTIONS(2727),
    [sym_char_literal] = ACTIONS(2727),
    [anon_sym_true] = ACTIONS(2729),
    [anon_sym_false] = ACTIONS(2729),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2729),
    [sym_super] = ACTIONS(2729),
    [sym_crate] = ACTIONS(2729),
    [sym_metavariable] = ACTIONS(2727),
    [sym__raw_string_literal_start] = ACTIONS(2727),
    [sym_float_literal] = ACTIONS(2727),
  },
  [706] = {
    [sym_line_comment] = STATE(706),
    [sym_block_comment] = STATE(706),
    [ts_builtin_sym_end] = ACTIONS(2731),
    [sym_identifier] = ACTIONS(2733),
    [anon_sym_SEMI] = ACTIONS(2731),
    [anon_sym_macro_rules_BANG] = ACTIONS(2731),
    [anon_sym_LPAREN] = ACTIONS(2731),
    [anon_sym_LBRACK] = ACTIONS(2731),
    [anon_sym_LBRACE] = ACTIONS(2731),
    [anon_sym_RBRACE] = ACTIONS(2731),
    [anon_sym_STAR] = ACTIONS(2731),
    [anon_sym_u8] = ACTIONS(2733),
    [anon_sym_i8] = ACTIONS(2733),
    [anon_sym_u16] = ACTIONS(2733),
    [anon_sym_i16] = ACTIONS(2733),
    [anon_sym_u32] = ACTIONS(2733),
    [anon_sym_i32] = ACTIONS(2733),
    [anon_sym_u64] = ACTIONS(2733),
    [anon_sym_i64] = ACTIONS(2733),
    [anon_sym_u128] = ACTIONS(2733),
    [anon_sym_i128] = ACTIONS(2733),
    [anon_sym_isize] = ACTIONS(2733),
    [anon_sym_usize] = ACTIONS(2733),
    [anon_sym_f32] = ACTIONS(2733),
    [anon_sym_f64] = ACTIONS(2733),
    [anon_sym_bool] = ACTIONS(2733),
    [anon_sym_str] = ACTIONS(2733),
    [anon_sym_char] = ACTIONS(2733),
    [anon_sym_DASH] = ACTIONS(2731),
    [anon_sym_BANG] = ACTIONS(2731),
    [anon_sym_AMP] = ACTIONS(2731),
    [anon_sym_PIPE] = ACTIONS(2731),
    [anon_sym_LT] = ACTIONS(2731),
    [anon_sym_DOT_DOT] = ACTIONS(2731),
    [anon_sym_COLON_COLON] = ACTIONS(2731),
    [anon_sym_POUND] = ACTIONS(2731),
    [anon_sym_SQUOTE] = ACTIONS(2733),
    [anon_sym_async] = ACTIONS(2733),
    [anon_sym_break] = ACTIONS(2733),
    [anon_sym_const] = ACTIONS(2733),
    [anon_sym_continue] = ACTIONS(2733),
    [anon_sym_default] = ACTIONS(2733),
    [anon_sym_enum] = ACTIONS(2733),
    [anon_sym_fn] = ACTIONS(2733),
    [anon_sym_for] = ACTIONS(2733),
    [anon_sym_if] = ACTIONS(2733),
    [anon_sym_impl] = ACTIONS(2733),
    [anon_sym_let] = ACTIONS(2733),
    [anon_sym_loop] = ACTIONS(2733),
    [anon_sym_match] = ACTIONS(2733),
    [anon_sym_mod] = ACTIONS(2733),
    [anon_sym_pub] = ACTIONS(2733),
    [anon_sym_return] = ACTIONS(2733),
    [anon_sym_static] = ACTIONS(2733),
    [anon_sym_struct] = ACTIONS(2733),
    [anon_sym_trait] = ACTIONS(2733),
    [anon_sym_type] = ACTIONS(2733),
    [anon_sym_union] = ACTIONS(2733),
    [anon_sym_unsafe] = ACTIONS(2733),
    [anon_sym_use] = ACTIONS(2733),
    [anon_sym_while] = ACTIONS(2733),
    [anon_sym_extern] = ACTIONS(2733),
    [anon_sym_yield] = ACTIONS(2733),
    [anon_sym_move] = ACTIONS(2733),
    [anon_sym_try] = ACTIONS(2733),
    [sym_integer_literal] = ACTIONS(2731),
    [aux_sym_string_literal_token1] = ACTIONS(2731),
    [sym_char_literal] = ACTIONS(2731),
    [anon_sym_true] = ACTIONS(2733),
    [anon_sym_false] = ACTIONS(2733),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2733),
    [sym_super] = ACTIONS(2733),
    [sym_crate] = ACTIONS(2733),
    [sym_metavariable] = ACTIONS(2731),
    [sym__raw_string_literal_start] = ACTIONS(2731),
    [sym_float_literal] = ACTIONS(2731),
  },
  [707] = {
    [sym_line_comment] = STATE(707),
    [sym_block_comment] = STATE(707),
    [ts_builtin_sym_end] = ACTIONS(2735),
    [sym_identifier] = ACTIONS(2737),
    [anon_sym_SEMI] = ACTIONS(2735),
    [anon_sym_macro_rules_BANG] = ACTIONS(2735),
    [anon_sym_LPAREN] = ACTIONS(2735),
    [anon_sym_LBRACK] = ACTIONS(2735),
    [anon_sym_LBRACE] = ACTIONS(2735),
    [anon_sym_RBRACE] = ACTIONS(2735),
    [anon_sym_STAR] = ACTIONS(2735),
    [anon_sym_u8] = ACTIONS(2737),
    [anon_sym_i8] = ACTIONS(2737),
    [anon_sym_u16] = ACTIONS(2737),
    [anon_sym_i16] = ACTIONS(2737),
    [anon_sym_u32] = ACTIONS(2737),
    [anon_sym_i32] = ACTIONS(2737),
    [anon_sym_u64] = ACTIONS(2737),
    [anon_sym_i64] = ACTIONS(2737),
    [anon_sym_u128] = ACTIONS(2737),
    [anon_sym_i128] = ACTIONS(2737),
    [anon_sym_isize] = ACTIONS(2737),
    [anon_sym_usize] = ACTIONS(2737),
    [anon_sym_f32] = ACTIONS(2737),
    [anon_sym_f64] = ACTIONS(2737),
    [anon_sym_bool] = ACTIONS(2737),
    [anon_sym_str] = ACTIONS(2737),
    [anon_sym_char] = ACTIONS(2737),
    [anon_sym_DASH] = ACTIONS(2735),
    [anon_sym_BANG] = ACTIONS(2735),
    [anon_sym_AMP] = ACTIONS(2735),
    [anon_sym_PIPE] = ACTIONS(2735),
    [anon_sym_LT] = ACTIONS(2735),
    [anon_sym_DOT_DOT] = ACTIONS(2735),
    [anon_sym_COLON_COLON] = ACTIONS(2735),
    [anon_sym_POUND] = ACTIONS(2735),
    [anon_sym_SQUOTE] = ACTIONS(2737),
    [anon_sym_async] = ACTIONS(2737),
    [anon_sym_break] = ACTIONS(2737),
    [anon_sym_const] = ACTIONS(2737),
    [anon_sym_continue] = ACTIONS(2737),
    [anon_sym_default] = ACTIONS(2737),
    [anon_sym_enum] = ACTIONS(2737),
    [anon_sym_fn] = ACTIONS(2737),
    [anon_sym_for] = ACTIONS(2737),
    [anon_sym_if] = ACTIONS(2737),
    [anon_sym_impl] = ACTIONS(2737),
    [anon_sym_let] = ACTIONS(2737),
    [anon_sym_loop] = ACTIONS(2737),
    [anon_sym_match] = ACTIONS(2737),
    [anon_sym_mod] = ACTIONS(2737),
    [anon_sym_pub] = ACTIONS(2737),
    [anon_sym_return] = ACTIONS(2737),
    [anon_sym_static] = ACTIONS(2737),
    [anon_sym_struct] = ACTIONS(2737),
    [anon_sym_trait] = ACTIONS(2737),
    [anon_sym_type] = ACTIONS(2737),
    [anon_sym_union] = ACTIONS(2737),
    [anon_sym_unsafe] = ACTIONS(2737),
    [anon_sym_use] = ACTIONS(2737),
    [anon_sym_while] = ACTIONS(2737),
    [anon_sym_extern] = ACTIONS(2737),
    [anon_sym_yield] = ACTIONS(2737),
    [anon_sym_move] = ACTIONS(2737),
    [anon_sym_try] = ACTIONS(2737),
    [sym_integer_literal] = ACTIONS(2735),
    [aux_sym_string_literal_token1] = ACTIONS(2735),
    [sym_char_literal] = ACTIONS(2735),
    [anon_sym_true] = ACTIONS(2737),
    [anon_sym_false] = ACTIONS(2737),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2737),
    [sym_super] = ACTIONS(2737),
    [sym_crate] = ACTIONS(2737),
    [sym_metavariable] = ACTIONS(2735),
    [sym__raw_string_literal_start] = ACTIONS(2735),
    [sym_float_literal] = ACTIONS(2735),
  },
  [708] = {
    [sym_line_comment] = STATE(708),
    [sym_block_comment] = STATE(708),
    [ts_builtin_sym_end] = ACTIONS(2739),
    [sym_identifier] = ACTIONS(2741),
    [anon_sym_SEMI] = ACTIONS(2739),
    [anon_sym_macro_rules_BANG] = ACTIONS(2739),
    [anon_sym_LPAREN] = ACTIONS(2739),
    [anon_sym_LBRACK] = ACTIONS(2739),
    [anon_sym_LBRACE] = ACTIONS(2739),
    [anon_sym_RBRACE] = ACTIONS(2739),
    [anon_sym_STAR] = ACTIONS(2739),
    [anon_sym_u8] = ACTIONS(2741),
    [anon_sym_i8] = ACTIONS(2741),
    [anon_sym_u16] = ACTIONS(2741),
    [anon_sym_i16] = ACTIONS(2741),
    [anon_sym_u32] = ACTIONS(2741),
    [anon_sym_i32] = ACTIONS(2741),
    [anon_sym_u64] = ACTIONS(2741),
    [anon_sym_i64] = ACTIONS(2741),
    [anon_sym_u128] = ACTIONS(2741),
    [anon_sym_i128] = ACTIONS(2741),
    [anon_sym_isize] = ACTIONS(2741),
    [anon_sym_usize] = ACTIONS(2741),
    [anon_sym_f32] = ACTIONS(2741),
    [anon_sym_f64] = ACTIONS(2741),
    [anon_sym_bool] = ACTIONS(2741),
    [anon_sym_str] = ACTIONS(2741),
    [anon_sym_char] = ACTIONS(2741),
    [anon_sym_DASH] = ACTIONS(2739),
    [anon_sym_BANG] = ACTIONS(2739),
    [anon_sym_AMP] = ACTIONS(2739),
    [anon_sym_PIPE] = ACTIONS(2739),
    [anon_sym_LT] = ACTIONS(2739),
    [anon_sym_DOT_DOT] = ACTIONS(2739),
    [anon_sym_COLON_COLON] = ACTIONS(2739),
    [anon_sym_POUND] = ACTIONS(2739),
    [anon_sym_SQUOTE] = ACTIONS(2741),
    [anon_sym_async] = ACTIONS(2741),
    [anon_sym_break] = ACTIONS(2741),
    [anon_sym_const] = ACTIONS(2741),
    [anon_sym_continue] = ACTIONS(2741),
    [anon_sym_default] = ACTIONS(2741),
    [anon_sym_enum] = ACTIONS(2741),
    [anon_sym_fn] = ACTIONS(2741),
    [anon_sym_for] = ACTIONS(2741),
    [anon_sym_if] = ACTIONS(2741),
    [anon_sym_impl] = ACTIONS(2741),
    [anon_sym_let] = ACTIONS(2741),
    [anon_sym_loop] = ACTIONS(2741),
    [anon_sym_match] = ACTIONS(2741),
    [anon_sym_mod] = ACTIONS(2741),
    [anon_sym_pub] = ACTIONS(2741),
    [anon_sym_return] = ACTIONS(2741),
    [anon_sym_static] = ACTIONS(2741),
    [anon_sym_struct] = ACTIONS(2741),
    [anon_sym_trait] = ACTIONS(2741),
    [anon_sym_type] = ACTIONS(2741),
    [anon_sym_union] = ACTIONS(2741),
    [anon_sym_unsafe] = ACTIONS(2741),
    [anon_sym_use] = ACTIONS(2741),
    [anon_sym_while] = ACTIONS(2741),
    [anon_sym_extern] = ACTIONS(2741),
    [anon_sym_yield] = ACTIONS(2741),
    [anon_sym_move] = ACTIONS(2741),
    [anon_sym_try] = ACTIONS(2741),
    [sym_integer_literal] = ACTIONS(2739),
    [aux_sym_string_literal_token1] = ACTIONS(2739),
    [sym_char_literal] = ACTIONS(2739),
    [anon_sym_true] = ACTIONS(2741),
    [anon_sym_false] = ACTIONS(2741),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2741),
    [sym_super] = ACTIONS(2741),
    [sym_crate] = ACTIONS(2741),
    [sym_metavariable] = ACTIONS(2739),
    [sym__raw_string_literal_start] = ACTIONS(2739),
    [sym_float_literal] = ACTIONS(2739),
  },
  [709] = {
    [sym_line_comment] = STATE(709),
    [sym_block_comment] = STATE(709),
    [ts_builtin_sym_end] = ACTIONS(2743),
    [sym_identifier] = ACTIONS(2745),
    [anon_sym_SEMI] = ACTIONS(2743),
    [anon_sym_macro_rules_BANG] = ACTIONS(2743),
    [anon_sym_LPAREN] = ACTIONS(2743),
    [anon_sym_LBRACK] = ACTIONS(2743),
    [anon_sym_LBRACE] = ACTIONS(2743),
    [anon_sym_RBRACE] = ACTIONS(2743),
    [anon_sym_STAR] = ACTIONS(2743),
    [anon_sym_u8] = ACTIONS(2745),
    [anon_sym_i8] = ACTIONS(2745),
    [anon_sym_u16] = ACTIONS(2745),
    [anon_sym_i16] = ACTIONS(2745),
    [anon_sym_u32] = ACTIONS(2745),
    [anon_sym_i32] = ACTIONS(2745),
    [anon_sym_u64] = ACTIONS(2745),
    [anon_sym_i64] = ACTIONS(2745),
    [anon_sym_u128] = ACTIONS(2745),
    [anon_sym_i128] = ACTIONS(2745),
    [anon_sym_isize] = ACTIONS(2745),
    [anon_sym_usize] = ACTIONS(2745),
    [anon_sym_f32] = ACTIONS(2745),
    [anon_sym_f64] = ACTIONS(2745),
    [anon_sym_bool] = ACTIONS(2745),
    [anon_sym_str] = ACTIONS(2745),
    [anon_sym_char] = ACTIONS(2745),
    [anon_sym_DASH] = ACTIONS(2743),
    [anon_sym_BANG] = ACTIONS(2743),
    [anon_sym_AMP] = ACTIONS(2743),
    [anon_sym_PIPE] = ACTIONS(2743),
    [anon_sym_LT] = ACTIONS(2743),
    [anon_sym_DOT_DOT] = ACTIONS(2743),
    [anon_sym_COLON_COLON] = ACTIONS(2743),
    [anon_sym_POUND] = ACTIONS(2743),
    [anon_sym_SQUOTE] = ACTIONS(2745),
    [anon_sym_async] = ACTIONS(2745),
    [anon_sym_break] = ACTIONS(2745),
    [anon_sym_const] = ACTIONS(2745),
    [anon_sym_continue] = ACTIONS(2745),
    [anon_sym_default] = ACTIONS(2745),
    [anon_sym_enum] = ACTIONS(2745),
    [anon_sym_fn] = ACTIONS(2745),
    [anon_sym_for] = ACTIONS(2745),
    [anon_sym_if] = ACTIONS(2745),
    [anon_sym_impl] = ACTIONS(2745),
    [anon_sym_let] = ACTIONS(2745),
    [anon_sym_loop] = ACTIONS(2745),
    [anon_sym_match] = ACTIONS(2745),
    [anon_sym_mod] = ACTIONS(2745),
    [anon_sym_pub] = ACTIONS(2745),
    [anon_sym_return] = ACTIONS(2745),
    [anon_sym_static] = ACTIONS(2745),
    [anon_sym_struct] = ACTIONS(2745),
    [anon_sym_trait] = ACTIONS(2745),
    [anon_sym_type] = ACTIONS(2745),
    [anon_sym_union] = ACTIONS(2745),
    [anon_sym_unsafe] = ACTIONS(2745),
    [anon_sym_use] = ACTIONS(2745),
    [anon_sym_while] = ACTIONS(2745),
    [anon_sym_extern] = ACTIONS(2745),
    [anon_sym_yield] = ACTIONS(2745),
    [anon_sym_move] = ACTIONS(2745),
    [anon_sym_try] = ACTIONS(2745),
    [sym_integer_literal] = ACTIONS(2743),
    [aux_sym_string_literal_token1] = ACTIONS(2743),
    [sym_char_literal] = ACTIONS(2743),
    [anon_sym_true] = ACTIONS(2745),
    [anon_sym_false] = ACTIONS(2745),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2745),
    [sym_super] = ACTIONS(2745),
    [sym_crate] = ACTIONS(2745),
    [sym_metavariable] = ACTIONS(2743),
    [sym__raw_string_literal_start] = ACTIONS(2743),
    [sym_float_literal] = ACTIONS(2743),
  },
  [710] = {
    [sym_line_comment] = STATE(710),
    [sym_block_comment] = STATE(710),
    [ts_builtin_sym_end] = ACTIONS(2747),
    [sym_identifier] = ACTIONS(2749),
    [anon_sym_SEMI] = ACTIONS(2747),
    [anon_sym_macro_rules_BANG] = ACTIONS(2747),
    [anon_sym_LPAREN] = ACTIONS(2747),
    [anon_sym_LBRACK] = ACTIONS(2747),
    [anon_sym_LBRACE] = ACTIONS(2747),
    [anon_sym_RBRACE] = ACTIONS(2747),
    [anon_sym_STAR] = ACTIONS(2747),
    [anon_sym_u8] = ACTIONS(2749),
    [anon_sym_i8] = ACTIONS(2749),
    [anon_sym_u16] = ACTIONS(2749),
    [anon_sym_i16] = ACTIONS(2749),
    [anon_sym_u32] = ACTIONS(2749),
    [anon_sym_i32] = ACTIONS(2749),
    [anon_sym_u64] = ACTIONS(2749),
    [anon_sym_i64] = ACTIONS(2749),
    [anon_sym_u128] = ACTIONS(2749),
    [anon_sym_i128] = ACTIONS(2749),
    [anon_sym_isize] = ACTIONS(2749),
    [anon_sym_usize] = ACTIONS(2749),
    [anon_sym_f32] = ACTIONS(2749),
    [anon_sym_f64] = ACTIONS(2749),
    [anon_sym_bool] = ACTIONS(2749),
    [anon_sym_str] = ACTIONS(2749),
    [anon_sym_char] = ACTIONS(2749),
    [anon_sym_DASH] = ACTIONS(2747),
    [anon_sym_BANG] = ACTIONS(2747),
    [anon_sym_AMP] = ACTIONS(2747),
    [anon_sym_PIPE] = ACTIONS(2747),
    [anon_sym_LT] = ACTIONS(2747),
    [anon_sym_DOT_DOT] = ACTIONS(2747),
    [anon_sym_COLON_COLON] = ACTIONS(2747),
    [anon_sym_POUND] = ACTIONS(2747),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_async] = ACTIONS(2749),
    [anon_sym_break] = ACTIONS(2749),
    [anon_sym_const] = ACTIONS(2749),
    [anon_sym_continue] = ACTIONS(2749),
    [anon_sym_default] = ACTIONS(2749),
    [anon_sym_enum] = ACTIONS(2749),
    [anon_sym_fn] = ACTIONS(2749),
    [anon_sym_for] = ACTIONS(2749),
    [anon_sym_if] = ACTIONS(2749),
    [anon_sym_impl] = ACTIONS(2749),
    [anon_sym_let] = ACTIONS(2749),
    [anon_sym_loop] = ACTIONS(2749),
    [anon_sym_match] = ACTIONS(2749),
    [anon_sym_mod] = ACTIONS(2749),
    [anon_sym_pub] = ACTIONS(2749),
    [anon_sym_return] = ACTIONS(2749),
    [anon_sym_static] = ACTIONS(2749),
    [anon_sym_struct] = ACTIONS(2749),
    [anon_sym_trait] = ACTIONS(2749),
    [anon_sym_type] = ACTIONS(2749),
    [anon_sym_union] = ACTIONS(2749),
    [anon_sym_unsafe] = ACTIONS(2749),
    [anon_sym_use] = ACTIONS(2749),
    [anon_sym_while] = ACTIONS(2749),
    [anon_sym_extern] = ACTIONS(2749),
    [anon_sym_yield] = ACTIONS(2749),
    [anon_sym_move] = ACTIONS(2749),
    [anon_sym_try] = ACTIONS(2749),
    [sym_integer_literal] = ACTIONS(2747),
    [aux_sym_string_literal_token1] = ACTIONS(2747),
    [sym_char_literal] = ACTIONS(2747),
    [anon_sym_true] = ACTIONS(2749),
    [anon_sym_false] = ACTIONS(2749),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2749),
    [sym_super] = ACTIONS(2749),
    [sym_crate] = ACTIONS(2749),
    [sym_metavariable] = ACTIONS(2747),
    [sym__raw_string_literal_start] = ACTIONS(2747),
    [sym_float_literal] = ACTIONS(2747),
  },
  [711] = {
    [sym_line_comment] = STATE(711),
    [sym_block_comment] = STATE(711),
    [ts_builtin_sym_end] = ACTIONS(2751),
    [sym_identifier] = ACTIONS(2753),
    [anon_sym_SEMI] = ACTIONS(2751),
    [anon_sym_macro_rules_BANG] = ACTIONS(2751),
    [anon_sym_LPAREN] = ACTIONS(2751),
    [anon_sym_LBRACK] = ACTIONS(2751),
    [anon_sym_LBRACE] = ACTIONS(2751),
    [anon_sym_RBRACE] = ACTIONS(2751),
    [anon_sym_STAR] = ACTIONS(2751),
    [anon_sym_u8] = ACTIONS(2753),
    [anon_sym_i8] = ACTIONS(2753),
    [anon_sym_u16] = ACTIONS(2753),
    [anon_sym_i16] = ACTIONS(2753),
    [anon_sym_u32] = ACTIONS(2753),
    [anon_sym_i32] = ACTIONS(2753),
    [anon_sym_u64] = ACTIONS(2753),
    [anon_sym_i64] = ACTIONS(2753),
    [anon_sym_u128] = ACTIONS(2753),
    [anon_sym_i128] = ACTIONS(2753),
    [anon_sym_isize] = ACTIONS(2753),
    [anon_sym_usize] = ACTIONS(2753),
    [anon_sym_f32] = ACTIONS(2753),
    [anon_sym_f64] = ACTIONS(2753),
    [anon_sym_bool] = ACTIONS(2753),
    [anon_sym_str] = ACTIONS(2753),
    [anon_sym_char] = ACTIONS(2753),
    [anon_sym_DASH] = ACTIONS(2751),
    [anon_sym_BANG] = ACTIONS(2751),
    [anon_sym_AMP] = ACTIONS(2751),
    [anon_sym_PIPE] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2751),
    [anon_sym_DOT_DOT] = ACTIONS(2751),
    [anon_sym_COLON_COLON] = ACTIONS(2751),
    [anon_sym_POUND] = ACTIONS(2751),
    [anon_sym_SQUOTE] = ACTIONS(2753),
    [anon_sym_async] = ACTIONS(2753),
    [anon_sym_break] = ACTIONS(2753),
    [anon_sym_const] = ACTIONS(2753),
    [anon_sym_continue] = ACTIONS(2753),
    [anon_sym_default] = ACTIONS(2753),
    [anon_sym_enum] = ACTIONS(2753),
    [anon_sym_fn] = ACTIONS(2753),
    [anon_sym_for] = ACTIONS(2753),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_impl] = ACTIONS(2753),
    [anon_sym_let] = ACTIONS(2753),
    [anon_sym_loop] = ACTIONS(2753),
    [anon_sym_match] = ACTIONS(2753),
    [anon_sym_mod] = ACTIONS(2753),
    [anon_sym_pub] = ACTIONS(2753),
    [anon_sym_return] = ACTIONS(2753),
    [anon_sym_static] = ACTIONS(2753),
    [anon_sym_struct] = ACTIONS(2753),
    [anon_sym_trait] = ACTIONS(2753),
    [anon_sym_type] = ACTIONS(2753),
    [anon_sym_union] = ACTIONS(2753),
    [anon_sym_unsafe] = ACTIONS(2753),
    [anon_sym_use] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_extern] = ACTIONS(2753),
    [anon_sym_yield] = ACTIONS(2753),
    [anon_sym_move] = ACTIONS(2753),
    [anon_sym_try] = ACTIONS(2753),
    [sym_integer_literal] = ACTIONS(2751),
    [aux_sym_string_literal_token1] = ACTIONS(2751),
    [sym_char_literal] = ACTIONS(2751),
    [anon_sym_true] = ACTIONS(2753),
    [anon_sym_false] = ACTIONS(2753),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2753),
    [sym_super] = ACTIONS(2753),
    [sym_crate] = ACTIONS(2753),
    [sym_metavariable] = ACTIONS(2751),
    [sym__raw_string_literal_start] = ACTIONS(2751),
    [sym_float_literal] = ACTIONS(2751),
  },
  [712] = {
    [sym_line_comment] = STATE(712),
    [sym_block_comment] = STATE(712),
    [ts_builtin_sym_end] = ACTIONS(2755),
    [sym_identifier] = ACTIONS(2757),
    [anon_sym_SEMI] = ACTIONS(2755),
    [anon_sym_macro_rules_BANG] = ACTIONS(2755),
    [anon_sym_LPAREN] = ACTIONS(2755),
    [anon_sym_LBRACK] = ACTIONS(2755),
    [anon_sym_LBRACE] = ACTIONS(2755),
    [anon_sym_RBRACE] = ACTIONS(2755),
    [anon_sym_STAR] = ACTIONS(2755),
    [anon_sym_u8] = ACTIONS(2757),
    [anon_sym_i8] = ACTIONS(2757),
    [anon_sym_u16] = ACTIONS(2757),
    [anon_sym_i16] = ACTIONS(2757),
    [anon_sym_u32] = ACTIONS(2757),
    [anon_sym_i32] = ACTIONS(2757),
    [anon_sym_u64] = ACTIONS(2757),
    [anon_sym_i64] = ACTIONS(2757),
    [anon_sym_u128] = ACTIONS(2757),
    [anon_sym_i128] = ACTIONS(2757),
    [anon_sym_isize] = ACTIONS(2757),
    [anon_sym_usize] = ACTIONS(2757),
    [anon_sym_f32] = ACTIONS(2757),
    [anon_sym_f64] = ACTIONS(2757),
    [anon_sym_bool] = ACTIONS(2757),
    [anon_sym_str] = ACTIONS(2757),
    [anon_sym_char] = ACTIONS(2757),
    [anon_sym_DASH] = ACTIONS(2755),
    [anon_sym_BANG] = ACTIONS(2755),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_PIPE] = ACTIONS(2755),
    [anon_sym_LT] = ACTIONS(2755),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym_COLON_COLON] = ACTIONS(2755),
    [anon_sym_POUND] = ACTIONS(2755),
    [anon_sym_SQUOTE] = ACTIONS(2757),
    [anon_sym_async] = ACTIONS(2757),
    [anon_sym_break] = ACTIONS(2757),
    [anon_sym_const] = ACTIONS(2757),
    [anon_sym_continue] = ACTIONS(2757),
    [anon_sym_default] = ACTIONS(2757),
    [anon_sym_enum] = ACTIONS(2757),
    [anon_sym_fn] = ACTIONS(2757),
    [anon_sym_for] = ACTIONS(2757),
    [anon_sym_if] = ACTIONS(2757),
    [anon_sym_impl] = ACTIONS(2757),
    [anon_sym_let] = ACTIONS(2757),
    [anon_sym_loop] = ACTIONS(2757),
    [anon_sym_match] = ACTIONS(2757),
    [anon_sym_mod] = ACTIONS(2757),
    [anon_sym_pub] = ACTIONS(2757),
    [anon_sym_return] = ACTIONS(2757),
    [anon_sym_static] = ACTIONS(2757),
    [anon_sym_struct] = ACTIONS(2757),
    [anon_sym_trait] = ACTIONS(2757),
    [anon_sym_type] = ACTIONS(2757),
    [anon_sym_union] = ACTIONS(2757),
    [anon_sym_unsafe] = ACTIONS(2757),
    [anon_sym_use] = ACTIONS(2757),
    [anon_sym_while] = ACTIONS(2757),
    [anon_sym_extern] = ACTIONS(2757),
    [anon_sym_yield] = ACTIONS(2757),
    [anon_sym_move] = ACTIONS(2757),
    [anon_sym_try] = ACTIONS(2757),
    [sym_integer_literal] = ACTIONS(2755),
    [aux_sym_string_literal_token1] = ACTIONS(2755),
    [sym_char_literal] = ACTIONS(2755),
    [anon_sym_true] = ACTIONS(2757),
    [anon_sym_false] = ACTIONS(2757),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2757),
    [sym_super] = ACTIONS(2757),
    [sym_crate] = ACTIONS(2757),
    [sym_metavariable] = ACTIONS(2755),
    [sym__raw_string_literal_start] = ACTIONS(2755),
    [sym_float_literal] = ACTIONS(2755),
  },
  [713] = {
    [sym_line_comment] = STATE(713),
    [sym_block_comment] = STATE(713),
    [ts_builtin_sym_end] = ACTIONS(2759),
    [sym_identifier] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_macro_rules_BANG] = ACTIONS(2759),
    [anon_sym_LPAREN] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_RBRACE] = ACTIONS(2759),
    [anon_sym_STAR] = ACTIONS(2759),
    [anon_sym_u8] = ACTIONS(2761),
    [anon_sym_i8] = ACTIONS(2761),
    [anon_sym_u16] = ACTIONS(2761),
    [anon_sym_i16] = ACTIONS(2761),
    [anon_sym_u32] = ACTIONS(2761),
    [anon_sym_i32] = ACTIONS(2761),
    [anon_sym_u64] = ACTIONS(2761),
    [anon_sym_i64] = ACTIONS(2761),
    [anon_sym_u128] = ACTIONS(2761),
    [anon_sym_i128] = ACTIONS(2761),
    [anon_sym_isize] = ACTIONS(2761),
    [anon_sym_usize] = ACTIONS(2761),
    [anon_sym_f32] = ACTIONS(2761),
    [anon_sym_f64] = ACTIONS(2761),
    [anon_sym_bool] = ACTIONS(2761),
    [anon_sym_str] = ACTIONS(2761),
    [anon_sym_char] = ACTIONS(2761),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_BANG] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2759),
    [anon_sym_LT] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2759),
    [anon_sym_COLON_COLON] = ACTIONS(2759),
    [anon_sym_POUND] = ACTIONS(2759),
    [anon_sym_SQUOTE] = ACTIONS(2761),
    [anon_sym_async] = ACTIONS(2761),
    [anon_sym_break] = ACTIONS(2761),
    [anon_sym_const] = ACTIONS(2761),
    [anon_sym_continue] = ACTIONS(2761),
    [anon_sym_default] = ACTIONS(2761),
    [anon_sym_enum] = ACTIONS(2761),
    [anon_sym_fn] = ACTIONS(2761),
    [anon_sym_for] = ACTIONS(2761),
    [anon_sym_if] = ACTIONS(2761),
    [anon_sym_impl] = ACTIONS(2761),
    [anon_sym_let] = ACTIONS(2761),
    [anon_sym_loop] = ACTIONS(2761),
    [anon_sym_match] = ACTIONS(2761),
    [anon_sym_mod] = ACTIONS(2761),
    [anon_sym_pub] = ACTIONS(2761),
    [anon_sym_return] = ACTIONS(2761),
    [anon_sym_static] = ACTIONS(2761),
    [anon_sym_struct] = ACTIONS(2761),
    [anon_sym_trait] = ACTIONS(2761),
    [anon_sym_type] = ACTIONS(2761),
    [anon_sym_union] = ACTIONS(2761),
    [anon_sym_unsafe] = ACTIONS(2761),
    [anon_sym_use] = ACTIONS(2761),
    [anon_sym_while] = ACTIONS(2761),
    [anon_sym_extern] = ACTIONS(2761),
    [anon_sym_yield] = ACTIONS(2761),
    [anon_sym_move] = ACTIONS(2761),
    [anon_sym_try] = ACTIONS(2761),
    [sym_integer_literal] = ACTIONS(2759),
    [aux_sym_string_literal_token1] = ACTIONS(2759),
    [sym_char_literal] = ACTIONS(2759),
    [anon_sym_true] = ACTIONS(2761),
    [anon_sym_false] = ACTIONS(2761),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2761),
    [sym_super] = ACTIONS(2761),
    [sym_crate] = ACTIONS(2761),
    [sym_metavariable] = ACTIONS(2759),
    [sym__raw_string_literal_start] = ACTIONS(2759),
    [sym_float_literal] = ACTIONS(2759),
  },
  [714] = {
    [sym_line_comment] = STATE(714),
    [sym_block_comment] = STATE(714),
    [ts_builtin_sym_end] = ACTIONS(2763),
    [sym_identifier] = ACTIONS(2765),
    [anon_sym_SEMI] = ACTIONS(2763),
    [anon_sym_macro_rules_BANG] = ACTIONS(2763),
    [anon_sym_LPAREN] = ACTIONS(2763),
    [anon_sym_LBRACK] = ACTIONS(2763),
    [anon_sym_LBRACE] = ACTIONS(2763),
    [anon_sym_RBRACE] = ACTIONS(2763),
    [anon_sym_STAR] = ACTIONS(2763),
    [anon_sym_u8] = ACTIONS(2765),
    [anon_sym_i8] = ACTIONS(2765),
    [anon_sym_u16] = ACTIONS(2765),
    [anon_sym_i16] = ACTIONS(2765),
    [anon_sym_u32] = ACTIONS(2765),
    [anon_sym_i32] = ACTIONS(2765),
    [anon_sym_u64] = ACTIONS(2765),
    [anon_sym_i64] = ACTIONS(2765),
    [anon_sym_u128] = ACTIONS(2765),
    [anon_sym_i128] = ACTIONS(2765),
    [anon_sym_isize] = ACTIONS(2765),
    [anon_sym_usize] = ACTIONS(2765),
    [anon_sym_f32] = ACTIONS(2765),
    [anon_sym_f64] = ACTIONS(2765),
    [anon_sym_bool] = ACTIONS(2765),
    [anon_sym_str] = ACTIONS(2765),
    [anon_sym_char] = ACTIONS(2765),
    [anon_sym_DASH] = ACTIONS(2763),
    [anon_sym_BANG] = ACTIONS(2763),
    [anon_sym_AMP] = ACTIONS(2763),
    [anon_sym_PIPE] = ACTIONS(2763),
    [anon_sym_LT] = ACTIONS(2763),
    [anon_sym_DOT_DOT] = ACTIONS(2763),
    [anon_sym_COLON_COLON] = ACTIONS(2763),
    [anon_sym_POUND] = ACTIONS(2763),
    [anon_sym_SQUOTE] = ACTIONS(2765),
    [anon_sym_async] = ACTIONS(2765),
    [anon_sym_break] = ACTIONS(2765),
    [anon_sym_const] = ACTIONS(2765),
    [anon_sym_continue] = ACTIONS(2765),
    [anon_sym_default] = ACTIONS(2765),
    [anon_sym_enum] = ACTIONS(2765),
    [anon_sym_fn] = ACTIONS(2765),
    [anon_sym_for] = ACTIONS(2765),
    [anon_sym_if] = ACTIONS(2765),
    [anon_sym_impl] = ACTIONS(2765),
    [anon_sym_let] = ACTIONS(2765),
    [anon_sym_loop] = ACTIONS(2765),
    [anon_sym_match] = ACTIONS(2765),
    [anon_sym_mod] = ACTIONS(2765),
    [anon_sym_pub] = ACTIONS(2765),
    [anon_sym_return] = ACTIONS(2765),
    [anon_sym_static] = ACTIONS(2765),
    [anon_sym_struct] = ACTIONS(2765),
    [anon_sym_trait] = ACTIONS(2765),
    [anon_sym_type] = ACTIONS(2765),
    [anon_sym_union] = ACTIONS(2765),
    [anon_sym_unsafe] = ACTIONS(2765),
    [anon_sym_use] = ACTIONS(2765),
    [anon_sym_while] = ACTIONS(2765),
    [anon_sym_extern] = ACTIONS(2765),
    [anon_sym_yield] = ACTIONS(2765),
    [anon_sym_move] = ACTIONS(2765),
    [anon_sym_try] = ACTIONS(2765),
    [sym_integer_literal] = ACTIONS(2763),
    [aux_sym_string_literal_token1] = ACTIONS(2763),
    [sym_char_literal] = ACTIONS(2763),
    [anon_sym_true] = ACTIONS(2765),
    [anon_sym_false] = ACTIONS(2765),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2765),
    [sym_super] = ACTIONS(2765),
    [sym_crate] = ACTIONS(2765),
    [sym_metavariable] = ACTIONS(2763),
    [sym__raw_string_literal_start] = ACTIONS(2763),
    [sym_float_literal] = ACTIONS(2763),
  },
  [715] = {
    [sym_line_comment] = STATE(715),
    [sym_block_comment] = STATE(715),
    [ts_builtin_sym_end] = ACTIONS(2767),
    [sym_identifier] = ACTIONS(2769),
    [anon_sym_SEMI] = ACTIONS(2767),
    [anon_sym_macro_rules_BANG] = ACTIONS(2767),
    [anon_sym_LPAREN] = ACTIONS(2767),
    [anon_sym_LBRACK] = ACTIONS(2767),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_RBRACE] = ACTIONS(2767),
    [anon_sym_STAR] = ACTIONS(2767),
    [anon_sym_u8] = ACTIONS(2769),
    [anon_sym_i8] = ACTIONS(2769),
    [anon_sym_u16] = ACTIONS(2769),
    [anon_sym_i16] = ACTIONS(2769),
    [anon_sym_u32] = ACTIONS(2769),
    [anon_sym_i32] = ACTIONS(2769),
    [anon_sym_u64] = ACTIONS(2769),
    [anon_sym_i64] = ACTIONS(2769),
    [anon_sym_u128] = ACTIONS(2769),
    [anon_sym_i128] = ACTIONS(2769),
    [anon_sym_isize] = ACTIONS(2769),
    [anon_sym_usize] = ACTIONS(2769),
    [anon_sym_f32] = ACTIONS(2769),
    [anon_sym_f64] = ACTIONS(2769),
    [anon_sym_bool] = ACTIONS(2769),
    [anon_sym_str] = ACTIONS(2769),
    [anon_sym_char] = ACTIONS(2769),
    [anon_sym_DASH] = ACTIONS(2767),
    [anon_sym_BANG] = ACTIONS(2767),
    [anon_sym_AMP] = ACTIONS(2767),
    [anon_sym_PIPE] = ACTIONS(2767),
    [anon_sym_LT] = ACTIONS(2767),
    [anon_sym_DOT_DOT] = ACTIONS(2767),
    [anon_sym_COLON_COLON] = ACTIONS(2767),
    [anon_sym_POUND] = ACTIONS(2767),
    [anon_sym_SQUOTE] = ACTIONS(2769),
    [anon_sym_async] = ACTIONS(2769),
    [anon_sym_break] = ACTIONS(2769),
    [anon_sym_const] = ACTIONS(2769),
    [anon_sym_continue] = ACTIONS(2769),
    [anon_sym_default] = ACTIONS(2769),
    [anon_sym_enum] = ACTIONS(2769),
    [anon_sym_fn] = ACTIONS(2769),
    [anon_sym_for] = ACTIONS(2769),
    [anon_sym_if] = ACTIONS(2769),
    [anon_sym_impl] = ACTIONS(2769),
    [anon_sym_let] = ACTIONS(2769),
    [anon_sym_loop] = ACTIONS(2769),
    [anon_sym_match] = ACTIONS(2769),
    [anon_sym_mod] = ACTIONS(2769),
    [anon_sym_pub] = ACTIONS(2769),
    [anon_sym_return] = ACTIONS(2769),
    [anon_sym_static] = ACTIONS(2769),
    [anon_sym_struct] = ACTIONS(2769),
    [anon_sym_trait] = ACTIONS(2769),
    [anon_sym_type] = ACTIONS(2769),
    [anon_sym_union] = ACTIONS(2769),
    [anon_sym_unsafe] = ACTIONS(2769),
    [anon_sym_use] = ACTIONS(2769),
    [anon_sym_while] = ACTIONS(2769),
    [anon_sym_extern] = ACTIONS(2769),
    [anon_sym_yield] = ACTIONS(2769),
    [anon_sym_move] = ACTIONS(2769),
    [anon_sym_try] = ACTIONS(2769),
    [sym_integer_literal] = ACTIONS(2767),
    [aux_sym_string_literal_token1] = ACTIONS(2767),
    [sym_char_literal] = ACTIONS(2767),
    [anon_sym_true] = ACTIONS(2769),
    [anon_sym_false] = ACTIONS(2769),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2769),
    [sym_super] = ACTIONS(2769),
    [sym_crate] = ACTIONS(2769),
    [sym_metavariable] = ACTIONS(2767),
    [sym__raw_string_literal_start] = ACTIONS(2767),
    [sym_float_literal] = ACTIONS(2767),
  },
  [716] = {
    [sym_line_comment] = STATE(716),
    [sym_block_comment] = STATE(716),
    [ts_builtin_sym_end] = ACTIONS(2771),
    [sym_identifier] = ACTIONS(2773),
    [anon_sym_SEMI] = ACTIONS(2771),
    [anon_sym_macro_rules_BANG] = ACTIONS(2771),
    [anon_sym_LPAREN] = ACTIONS(2771),
    [anon_sym_LBRACK] = ACTIONS(2771),
    [anon_sym_LBRACE] = ACTIONS(2771),
    [anon_sym_RBRACE] = ACTIONS(2771),
    [anon_sym_STAR] = ACTIONS(2771),
    [anon_sym_u8] = ACTIONS(2773),
    [anon_sym_i8] = ACTIONS(2773),
    [anon_sym_u16] = ACTIONS(2773),
    [anon_sym_i16] = ACTIONS(2773),
    [anon_sym_u32] = ACTIONS(2773),
    [anon_sym_i32] = ACTIONS(2773),
    [anon_sym_u64] = ACTIONS(2773),
    [anon_sym_i64] = ACTIONS(2773),
    [anon_sym_u128] = ACTIONS(2773),
    [anon_sym_i128] = ACTIONS(2773),
    [anon_sym_isize] = ACTIONS(2773),
    [anon_sym_usize] = ACTIONS(2773),
    [anon_sym_f32] = ACTIONS(2773),
    [anon_sym_f64] = ACTIONS(2773),
    [anon_sym_bool] = ACTIONS(2773),
    [anon_sym_str] = ACTIONS(2773),
    [anon_sym_char] = ACTIONS(2773),
    [anon_sym_DASH] = ACTIONS(2771),
    [anon_sym_BANG] = ACTIONS(2771),
    [anon_sym_AMP] = ACTIONS(2771),
    [anon_sym_PIPE] = ACTIONS(2771),
    [anon_sym_LT] = ACTIONS(2771),
    [anon_sym_DOT_DOT] = ACTIONS(2771),
    [anon_sym_COLON_COLON] = ACTIONS(2771),
    [anon_sym_POUND] = ACTIONS(2771),
    [anon_sym_SQUOTE] = ACTIONS(2773),
    [anon_sym_async] = ACTIONS(2773),
    [anon_sym_break] = ACTIONS(2773),
    [anon_sym_const] = ACTIONS(2773),
    [anon_sym_continue] = ACTIONS(2773),
    [anon_sym_default] = ACTIONS(2773),
    [anon_sym_enum] = ACTIONS(2773),
    [anon_sym_fn] = ACTIONS(2773),
    [anon_sym_for] = ACTIONS(2773),
    [anon_sym_if] = ACTIONS(2773),
    [anon_sym_impl] = ACTIONS(2773),
    [anon_sym_let] = ACTIONS(2773),
    [anon_sym_loop] = ACTIONS(2773),
    [anon_sym_match] = ACTIONS(2773),
    [anon_sym_mod] = ACTIONS(2773),
    [anon_sym_pub] = ACTIONS(2773),
    [anon_sym_return] = ACTIONS(2773),
    [anon_sym_static] = ACTIONS(2773),
    [anon_sym_struct] = ACTIONS(2773),
    [anon_sym_trait] = ACTIONS(2773),
    [anon_sym_type] = ACTIONS(2773),
    [anon_sym_union] = ACTIONS(2773),
    [anon_sym_unsafe] = ACTIONS(2773),
    [anon_sym_use] = ACTIONS(2773),
    [anon_sym_while] = ACTIONS(2773),
    [anon_sym_extern] = ACTIONS(2773),
    [anon_sym_yield] = ACTIONS(2773),
    [anon_sym_move] = ACTIONS(2773),
    [anon_sym_try] = ACTIONS(2773),
    [sym_integer_literal] = ACTIONS(2771),
    [aux_sym_string_literal_token1] = ACTIONS(2771),
    [sym_char_literal] = ACTIONS(2771),
    [anon_sym_true] = ACTIONS(2773),
    [anon_sym_false] = ACTIONS(2773),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2773),
    [sym_super] = ACTIONS(2773),
    [sym_crate] = ACTIONS(2773),
    [sym_metavariable] = ACTIONS(2771),
    [sym__raw_string_literal_start] = ACTIONS(2771),
    [sym_float_literal] = ACTIONS(2771),
  },
  [717] = {
    [sym_line_comment] = STATE(717),
    [sym_block_comment] = STATE(717),
    [ts_builtin_sym_end] = ACTIONS(2775),
    [sym_identifier] = ACTIONS(2777),
    [anon_sym_SEMI] = ACTIONS(2775),
    [anon_sym_macro_rules_BANG] = ACTIONS(2775),
    [anon_sym_LPAREN] = ACTIONS(2775),
    [anon_sym_LBRACK] = ACTIONS(2775),
    [anon_sym_LBRACE] = ACTIONS(2775),
    [anon_sym_RBRACE] = ACTIONS(2775),
    [anon_sym_STAR] = ACTIONS(2775),
    [anon_sym_u8] = ACTIONS(2777),
    [anon_sym_i8] = ACTIONS(2777),
    [anon_sym_u16] = ACTIONS(2777),
    [anon_sym_i16] = ACTIONS(2777),
    [anon_sym_u32] = ACTIONS(2777),
    [anon_sym_i32] = ACTIONS(2777),
    [anon_sym_u64] = ACTIONS(2777),
    [anon_sym_i64] = ACTIONS(2777),
    [anon_sym_u128] = ACTIONS(2777),
    [anon_sym_i128] = ACTIONS(2777),
    [anon_sym_isize] = ACTIONS(2777),
    [anon_sym_usize] = ACTIONS(2777),
    [anon_sym_f32] = ACTIONS(2777),
    [anon_sym_f64] = ACTIONS(2777),
    [anon_sym_bool] = ACTIONS(2777),
    [anon_sym_str] = ACTIONS(2777),
    [anon_sym_char] = ACTIONS(2777),
    [anon_sym_DASH] = ACTIONS(2775),
    [anon_sym_BANG] = ACTIONS(2775),
    [anon_sym_AMP] = ACTIONS(2775),
    [anon_sym_PIPE] = ACTIONS(2775),
    [anon_sym_LT] = ACTIONS(2775),
    [anon_sym_DOT_DOT] = ACTIONS(2775),
    [anon_sym_COLON_COLON] = ACTIONS(2775),
    [anon_sym_POUND] = ACTIONS(2775),
    [anon_sym_SQUOTE] = ACTIONS(2777),
    [anon_sym_async] = ACTIONS(2777),
    [anon_sym_break] = ACTIONS(2777),
    [anon_sym_const] = ACTIONS(2777),
    [anon_sym_continue] = ACTIONS(2777),
    [anon_sym_default] = ACTIONS(2777),
    [anon_sym_enum] = ACTIONS(2777),
    [anon_sym_fn] = ACTIONS(2777),
    [anon_sym_for] = ACTIONS(2777),
    [anon_sym_if] = ACTIONS(2777),
    [anon_sym_impl] = ACTIONS(2777),
    [anon_sym_let] = ACTIONS(2777),
    [anon_sym_loop] = ACTIONS(2777),
    [anon_sym_match] = ACTIONS(2777),
    [anon_sym_mod] = ACTIONS(2777),
    [anon_sym_pub] = ACTIONS(2777),
    [anon_sym_return] = ACTIONS(2777),
    [anon_sym_static] = ACTIONS(2777),
    [anon_sym_struct] = ACTIONS(2777),
    [anon_sym_trait] = ACTIONS(2777),
    [anon_sym_type] = ACTIONS(2777),
    [anon_sym_union] = ACTIONS(2777),
    [anon_sym_unsafe] = ACTIONS(2777),
    [anon_sym_use] = ACTIONS(2777),
    [anon_sym_while] = ACTIONS(2777),
    [anon_sym_extern] = ACTIONS(2777),
    [anon_sym_yield] = ACTIONS(2777),
    [anon_sym_move] = ACTIONS(2777),
    [anon_sym_try] = ACTIONS(2777),
    [sym_integer_literal] = ACTIONS(2775),
    [aux_sym_string_literal_token1] = ACTIONS(2775),
    [sym_char_literal] = ACTIONS(2775),
    [anon_sym_true] = ACTIONS(2777),
    [anon_sym_false] = ACTIONS(2777),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2777),
    [sym_super] = ACTIONS(2777),
    [sym_crate] = ACTIONS(2777),
    [sym_metavariable] = ACTIONS(2775),
    [sym__raw_string_literal_start] = ACTIONS(2775),
    [sym_float_literal] = ACTIONS(2775),
  },
  [718] = {
    [sym_line_comment] = STATE(718),
    [sym_block_comment] = STATE(718),
    [ts_builtin_sym_end] = ACTIONS(2779),
    [sym_identifier] = ACTIONS(2781),
    [anon_sym_SEMI] = ACTIONS(2779),
    [anon_sym_macro_rules_BANG] = ACTIONS(2779),
    [anon_sym_LPAREN] = ACTIONS(2779),
    [anon_sym_LBRACK] = ACTIONS(2779),
    [anon_sym_LBRACE] = ACTIONS(2779),
    [anon_sym_RBRACE] = ACTIONS(2779),
    [anon_sym_STAR] = ACTIONS(2779),
    [anon_sym_u8] = ACTIONS(2781),
    [anon_sym_i8] = ACTIONS(2781),
    [anon_sym_u16] = ACTIONS(2781),
    [anon_sym_i16] = ACTIONS(2781),
    [anon_sym_u32] = ACTIONS(2781),
    [anon_sym_i32] = ACTIONS(2781),
    [anon_sym_u64] = ACTIONS(2781),
    [anon_sym_i64] = ACTIONS(2781),
    [anon_sym_u128] = ACTIONS(2781),
    [anon_sym_i128] = ACTIONS(2781),
    [anon_sym_isize] = ACTIONS(2781),
    [anon_sym_usize] = ACTIONS(2781),
    [anon_sym_f32] = ACTIONS(2781),
    [anon_sym_f64] = ACTIONS(2781),
    [anon_sym_bool] = ACTIONS(2781),
    [anon_sym_str] = ACTIONS(2781),
    [anon_sym_char] = ACTIONS(2781),
    [anon_sym_DASH] = ACTIONS(2779),
    [anon_sym_BANG] = ACTIONS(2779),
    [anon_sym_AMP] = ACTIONS(2779),
    [anon_sym_PIPE] = ACTIONS(2779),
    [anon_sym_LT] = ACTIONS(2779),
    [anon_sym_DOT_DOT] = ACTIONS(2779),
    [anon_sym_COLON_COLON] = ACTIONS(2779),
    [anon_sym_POUND] = ACTIONS(2779),
    [anon_sym_SQUOTE] = ACTIONS(2781),
    [anon_sym_async] = ACTIONS(2781),
    [anon_sym_break] = ACTIONS(2781),
    [anon_sym_const] = ACTIONS(2781),
    [anon_sym_continue] = ACTIONS(2781),
    [anon_sym_default] = ACTIONS(2781),
    [anon_sym_enum] = ACTIONS(2781),
    [anon_sym_fn] = ACTIONS(2781),
    [anon_sym_for] = ACTIONS(2781),
    [anon_sym_if] = ACTIONS(2781),
    [anon_sym_impl] = ACTIONS(2781),
    [anon_sym_let] = ACTIONS(2781),
    [anon_sym_loop] = ACTIONS(2781),
    [anon_sym_match] = ACTIONS(2781),
    [anon_sym_mod] = ACTIONS(2781),
    [anon_sym_pub] = ACTIONS(2781),
    [anon_sym_return] = ACTIONS(2781),
    [anon_sym_static] = ACTIONS(2781),
    [anon_sym_struct] = ACTIONS(2781),
    [anon_sym_trait] = ACTIONS(2781),
    [anon_sym_type] = ACTIONS(2781),
    [anon_sym_union] = ACTIONS(2781),
    [anon_sym_unsafe] = ACTIONS(2781),
    [anon_sym_use] = ACTIONS(2781),
    [anon_sym_while] = ACTIONS(2781),
    [anon_sym_extern] = ACTIONS(2781),
    [anon_sym_yield] = ACTIONS(2781),
    [anon_sym_move] = ACTIONS(2781),
    [anon_sym_try] = ACTIONS(2781),
    [sym_integer_literal] = ACTIONS(2779),
    [aux_sym_string_literal_token1] = ACTIONS(2779),
    [sym_char_literal] = ACTIONS(2779),
    [anon_sym_true] = ACTIONS(2781),
    [anon_sym_false] = ACTIONS(2781),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2781),
    [sym_super] = ACTIONS(2781),
    [sym_crate] = ACTIONS(2781),
    [sym_metavariable] = ACTIONS(2779),
    [sym__raw_string_literal_start] = ACTIONS(2779),
    [sym_float_literal] = ACTIONS(2779),
  },
  [719] = {
    [sym_line_comment] = STATE(719),
    [sym_block_comment] = STATE(719),
    [ts_builtin_sym_end] = ACTIONS(2783),
    [sym_identifier] = ACTIONS(2785),
    [anon_sym_SEMI] = ACTIONS(2783),
    [anon_sym_macro_rules_BANG] = ACTIONS(2783),
    [anon_sym_LPAREN] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(2783),
    [anon_sym_LBRACE] = ACTIONS(2783),
    [anon_sym_RBRACE] = ACTIONS(2783),
    [anon_sym_STAR] = ACTIONS(2783),
    [anon_sym_u8] = ACTIONS(2785),
    [anon_sym_i8] = ACTIONS(2785),
    [anon_sym_u16] = ACTIONS(2785),
    [anon_sym_i16] = ACTIONS(2785),
    [anon_sym_u32] = ACTIONS(2785),
    [anon_sym_i32] = ACTIONS(2785),
    [anon_sym_u64] = ACTIONS(2785),
    [anon_sym_i64] = ACTIONS(2785),
    [anon_sym_u128] = ACTIONS(2785),
    [anon_sym_i128] = ACTIONS(2785),
    [anon_sym_isize] = ACTIONS(2785),
    [anon_sym_usize] = ACTIONS(2785),
    [anon_sym_f32] = ACTIONS(2785),
    [anon_sym_f64] = ACTIONS(2785),
    [anon_sym_bool] = ACTIONS(2785),
    [anon_sym_str] = ACTIONS(2785),
    [anon_sym_char] = ACTIONS(2785),
    [anon_sym_DASH] = ACTIONS(2783),
    [anon_sym_BANG] = ACTIONS(2783),
    [anon_sym_AMP] = ACTIONS(2783),
    [anon_sym_PIPE] = ACTIONS(2783),
    [anon_sym_LT] = ACTIONS(2783),
    [anon_sym_DOT_DOT] = ACTIONS(2783),
    [anon_sym_COLON_COLON] = ACTIONS(2783),
    [anon_sym_POUND] = ACTIONS(2783),
    [anon_sym_SQUOTE] = ACTIONS(2785),
    [anon_sym_async] = ACTIONS(2785),
    [anon_sym_break] = ACTIONS(2785),
    [anon_sym_const] = ACTIONS(2785),
    [anon_sym_continue] = ACTIONS(2785),
    [anon_sym_default] = ACTIONS(2785),
    [anon_sym_enum] = ACTIONS(2785),
    [anon_sym_fn] = ACTIONS(2785),
    [anon_sym_for] = ACTIONS(2785),
    [anon_sym_if] = ACTIONS(2785),
    [anon_sym_impl] = ACTIONS(2785),
    [anon_sym_let] = ACTIONS(2785),
    [anon_sym_loop] = ACTIONS(2785),
    [anon_sym_match] = ACTIONS(2785),
    [anon_sym_mod] = ACTIONS(2785),
    [anon_sym_pub] = ACTIONS(2785),
    [anon_sym_return] = ACTIONS(2785),
    [anon_sym_static] = ACTIONS(2785),
    [anon_sym_struct] = ACTIONS(2785),
    [anon_sym_trait] = ACTIONS(2785),
    [anon_sym_type] = ACTIONS(2785),
    [anon_sym_union] = ACTIONS(2785),
    [anon_sym_unsafe] = ACTIONS(2785),
    [anon_sym_use] = ACTIONS(2785),
    [anon_sym_while] = ACTIONS(2785),
    [anon_sym_extern] = ACTIONS(2785),
    [anon_sym_yield] = ACTIONS(2785),
    [anon_sym_move] = ACTIONS(2785),
    [anon_sym_try] = ACTIONS(2785),
    [sym_integer_literal] = ACTIONS(2783),
    [aux_sym_string_literal_token1] = ACTIONS(2783),
    [sym_char_literal] = ACTIONS(2783),
    [anon_sym_true] = ACTIONS(2785),
    [anon_sym_false] = ACTIONS(2785),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2785),
    [sym_super] = ACTIONS(2785),
    [sym_crate] = ACTIONS(2785),
    [sym_metavariable] = ACTIONS(2783),
    [sym__raw_string_literal_start] = ACTIONS(2783),
    [sym_float_literal] = ACTIONS(2783),
  },
  [720] = {
    [sym_line_comment] = STATE(720),
    [sym_block_comment] = STATE(720),
    [ts_builtin_sym_end] = ACTIONS(2787),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_SEMI] = ACTIONS(2787),
    [anon_sym_macro_rules_BANG] = ACTIONS(2787),
    [anon_sym_LPAREN] = ACTIONS(2787),
    [anon_sym_LBRACK] = ACTIONS(2787),
    [anon_sym_LBRACE] = ACTIONS(2787),
    [anon_sym_RBRACE] = ACTIONS(2787),
    [anon_sym_STAR] = ACTIONS(2787),
    [anon_sym_u8] = ACTIONS(2789),
    [anon_sym_i8] = ACTIONS(2789),
    [anon_sym_u16] = ACTIONS(2789),
    [anon_sym_i16] = ACTIONS(2789),
    [anon_sym_u32] = ACTIONS(2789),
    [anon_sym_i32] = ACTIONS(2789),
    [anon_sym_u64] = ACTIONS(2789),
    [anon_sym_i64] = ACTIONS(2789),
    [anon_sym_u128] = ACTIONS(2789),
    [anon_sym_i128] = ACTIONS(2789),
    [anon_sym_isize] = ACTIONS(2789),
    [anon_sym_usize] = ACTIONS(2789),
    [anon_sym_f32] = ACTIONS(2789),
    [anon_sym_f64] = ACTIONS(2789),
    [anon_sym_bool] = ACTIONS(2789),
    [anon_sym_str] = ACTIONS(2789),
    [anon_sym_char] = ACTIONS(2789),
    [anon_sym_DASH] = ACTIONS(2787),
    [anon_sym_BANG] = ACTIONS(2787),
    [anon_sym_AMP] = ACTIONS(2787),
    [anon_sym_PIPE] = ACTIONS(2787),
    [anon_sym_LT] = ACTIONS(2787),
    [anon_sym_DOT_DOT] = ACTIONS(2787),
    [anon_sym_COLON_COLON] = ACTIONS(2787),
    [anon_sym_POUND] = ACTIONS(2787),
    [anon_sym_SQUOTE] = ACTIONS(2789),
    [anon_sym_async] = ACTIONS(2789),
    [anon_sym_break] = ACTIONS(2789),
    [anon_sym_const] = ACTIONS(2789),
    [anon_sym_continue] = ACTIONS(2789),
    [anon_sym_default] = ACTIONS(2789),
    [anon_sym_enum] = ACTIONS(2789),
    [anon_sym_fn] = ACTIONS(2789),
    [anon_sym_for] = ACTIONS(2789),
    [anon_sym_if] = ACTIONS(2789),
    [anon_sym_impl] = ACTIONS(2789),
    [anon_sym_let] = ACTIONS(2789),
    [anon_sym_loop] = ACTIONS(2789),
    [anon_sym_match] = ACTIONS(2789),
    [anon_sym_mod] = ACTIONS(2789),
    [anon_sym_pub] = ACTIONS(2789),
    [anon_sym_return] = ACTIONS(2789),
    [anon_sym_static] = ACTIONS(2789),
    [anon_sym_struct] = ACTIONS(2789),
    [anon_sym_trait] = ACTIONS(2789),
    [anon_sym_type] = ACTIONS(2789),
    [anon_sym_union] = ACTIONS(2789),
    [anon_sym_unsafe] = ACTIONS(2789),
    [anon_sym_use] = ACTIONS(2789),
    [anon_sym_while] = ACTIONS(2789),
    [anon_sym_extern] = ACTIONS(2789),
    [anon_sym_yield] = ACTIONS(2789),
    [anon_sym_move] = ACTIONS(2789),
    [anon_sym_try] = ACTIONS(2789),
    [sym_integer_literal] = ACTIONS(2787),
    [aux_sym_string_literal_token1] = ACTIONS(2787),
    [sym_char_literal] = ACTIONS(2787),
    [anon_sym_true] = ACTIONS(2789),
    [anon_sym_false] = ACTIONS(2789),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2789),
    [sym_super] = ACTIONS(2789),
    [sym_crate] = ACTIONS(2789),
    [sym_metavariable] = ACTIONS(2787),
    [sym__raw_string_literal_start] = ACTIONS(2787),
    [sym_float_literal] = ACTIONS(2787),
  },
  [721] = {
    [sym_line_comment] = STATE(721),
    [sym_block_comment] = STATE(721),
    [ts_builtin_sym_end] = ACTIONS(2791),
    [sym_identifier] = ACTIONS(2793),
    [anon_sym_SEMI] = ACTIONS(2791),
    [anon_sym_macro_rules_BANG] = ACTIONS(2791),
    [anon_sym_LPAREN] = ACTIONS(2791),
    [anon_sym_LBRACK] = ACTIONS(2791),
    [anon_sym_LBRACE] = ACTIONS(2791),
    [anon_sym_RBRACE] = ACTIONS(2791),
    [anon_sym_STAR] = ACTIONS(2791),
    [anon_sym_u8] = ACTIONS(2793),
    [anon_sym_i8] = ACTIONS(2793),
    [anon_sym_u16] = ACTIONS(2793),
    [anon_sym_i16] = ACTIONS(2793),
    [anon_sym_u32] = ACTIONS(2793),
    [anon_sym_i32] = ACTIONS(2793),
    [anon_sym_u64] = ACTIONS(2793),
    [anon_sym_i64] = ACTIONS(2793),
    [anon_sym_u128] = ACTIONS(2793),
    [anon_sym_i128] = ACTIONS(2793),
    [anon_sym_isize] = ACTIONS(2793),
    [anon_sym_usize] = ACTIONS(2793),
    [anon_sym_f32] = ACTIONS(2793),
    [anon_sym_f64] = ACTIONS(2793),
    [anon_sym_bool] = ACTIONS(2793),
    [anon_sym_str] = ACTIONS(2793),
    [anon_sym_char] = ACTIONS(2793),
    [anon_sym_DASH] = ACTIONS(2791),
    [anon_sym_BANG] = ACTIONS(2791),
    [anon_sym_AMP] = ACTIONS(2791),
    [anon_sym_PIPE] = ACTIONS(2791),
    [anon_sym_LT] = ACTIONS(2791),
    [anon_sym_DOT_DOT] = ACTIONS(2791),
    [anon_sym_COLON_COLON] = ACTIONS(2791),
    [anon_sym_POUND] = ACTIONS(2791),
    [anon_sym_SQUOTE] = ACTIONS(2793),
    [anon_sym_async] = ACTIONS(2793),
    [anon_sym_break] = ACTIONS(2793),
    [anon_sym_const] = ACTIONS(2793),
    [anon_sym_continue] = ACTIONS(2793),
    [anon_sym_default] = ACTIONS(2793),
    [anon_sym_enum] = ACTIONS(2793),
    [anon_sym_fn] = ACTIONS(2793),
    [anon_sym_for] = ACTIONS(2793),
    [anon_sym_if] = ACTIONS(2793),
    [anon_sym_impl] = ACTIONS(2793),
    [anon_sym_let] = ACTIONS(2793),
    [anon_sym_loop] = ACTIONS(2793),
    [anon_sym_match] = ACTIONS(2793),
    [anon_sym_mod] = ACTIONS(2793),
    [anon_sym_pub] = ACTIONS(2793),
    [anon_sym_return] = ACTIONS(2793),
    [anon_sym_static] = ACTIONS(2793),
    [anon_sym_struct] = ACTIONS(2793),
    [anon_sym_trait] = ACTIONS(2793),
    [anon_sym_type] = ACTIONS(2793),
    [anon_sym_union] = ACTIONS(2793),
    [anon_sym_unsafe] = ACTIONS(2793),
    [anon_sym_use] = ACTIONS(2793),
    [anon_sym_while] = ACTIONS(2793),
    [anon_sym_extern] = ACTIONS(2793),
    [anon_sym_yield] = ACTIONS(2793),
    [anon_sym_move] = ACTIONS(2793),
    [anon_sym_try] = ACTIONS(2793),
    [sym_integer_literal] = ACTIONS(2791),
    [aux_sym_string_literal_token1] = ACTIONS(2791),
    [sym_char_literal] = ACTIONS(2791),
    [anon_sym_true] = ACTIONS(2793),
    [anon_sym_false] = ACTIONS(2793),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2793),
    [sym_super] = ACTIONS(2793),
    [sym_crate] = ACTIONS(2793),
    [sym_metavariable] = ACTIONS(2791),
    [sym__raw_string_literal_start] = ACTIONS(2791),
    [sym_float_literal] = ACTIONS(2791),
  },
  [722] = {
    [sym_line_comment] = STATE(722),
    [sym_block_comment] = STATE(722),
    [ts_builtin_sym_end] = ACTIONS(2795),
    [sym_identifier] = ACTIONS(2797),
    [anon_sym_SEMI] = ACTIONS(2795),
    [anon_sym_macro_rules_BANG] = ACTIONS(2795),
    [anon_sym_LPAREN] = ACTIONS(2795),
    [anon_sym_LBRACK] = ACTIONS(2795),
    [anon_sym_LBRACE] = ACTIONS(2795),
    [anon_sym_RBRACE] = ACTIONS(2795),
    [anon_sym_STAR] = ACTIONS(2795),
    [anon_sym_u8] = ACTIONS(2797),
    [anon_sym_i8] = ACTIONS(2797),
    [anon_sym_u16] = ACTIONS(2797),
    [anon_sym_i16] = ACTIONS(2797),
    [anon_sym_u32] = ACTIONS(2797),
    [anon_sym_i32] = ACTIONS(2797),
    [anon_sym_u64] = ACTIONS(2797),
    [anon_sym_i64] = ACTIONS(2797),
    [anon_sym_u128] = ACTIONS(2797),
    [anon_sym_i128] = ACTIONS(2797),
    [anon_sym_isize] = ACTIONS(2797),
    [anon_sym_usize] = ACTIONS(2797),
    [anon_sym_f32] = ACTIONS(2797),
    [anon_sym_f64] = ACTIONS(2797),
    [anon_sym_bool] = ACTIONS(2797),
    [anon_sym_str] = ACTIONS(2797),
    [anon_sym_char] = ACTIONS(2797),
    [anon_sym_DASH] = ACTIONS(2795),
    [anon_sym_BANG] = ACTIONS(2795),
    [anon_sym_AMP] = ACTIONS(2795),
    [anon_sym_PIPE] = ACTIONS(2795),
    [anon_sym_LT] = ACTIONS(2795),
    [anon_sym_DOT_DOT] = ACTIONS(2795),
    [anon_sym_COLON_COLON] = ACTIONS(2795),
    [anon_sym_POUND] = ACTIONS(2795),
    [anon_sym_SQUOTE] = ACTIONS(2797),
    [anon_sym_async] = ACTIONS(2797),
    [anon_sym_break] = ACTIONS(2797),
    [anon_sym_const] = ACTIONS(2797),
    [anon_sym_continue] = ACTIONS(2797),
    [anon_sym_default] = ACTIONS(2797),
    [anon_sym_enum] = ACTIONS(2797),
    [anon_sym_fn] = ACTIONS(2797),
    [anon_sym_for] = ACTIONS(2797),
    [anon_sym_if] = ACTIONS(2797),
    [anon_sym_impl] = ACTIONS(2797),
    [anon_sym_let] = ACTIONS(2797),
    [anon_sym_loop] = ACTIONS(2797),
    [anon_sym_match] = ACTIONS(2797),
    [anon_sym_mod] = ACTIONS(2797),
    [anon_sym_pub] = ACTIONS(2797),
    [anon_sym_return] = ACTIONS(2797),
    [anon_sym_static] = ACTIONS(2797),
    [anon_sym_struct] = ACTIONS(2797),
    [anon_sym_trait] = ACTIONS(2797),
    [anon_sym_type] = ACTIONS(2797),
    [anon_sym_union] = ACTIONS(2797),
    [anon_sym_unsafe] = ACTIONS(2797),
    [anon_sym_use] = ACTIONS(2797),
    [anon_sym_while] = ACTIONS(2797),
    [anon_sym_extern] = ACTIONS(2797),
    [anon_sym_yield] = ACTIONS(2797),
    [anon_sym_move] = ACTIONS(2797),
    [anon_sym_try] = ACTIONS(2797),
    [sym_integer_literal] = ACTIONS(2795),
    [aux_sym_string_literal_token1] = ACTIONS(2795),
    [sym_char_literal] = ACTIONS(2795),
    [anon_sym_true] = ACTIONS(2797),
    [anon_sym_false] = ACTIONS(2797),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2797),
    [sym_super] = ACTIONS(2797),
    [sym_crate] = ACTIONS(2797),
    [sym_metavariable] = ACTIONS(2795),
    [sym__raw_string_literal_start] = ACTIONS(2795),
    [sym_float_literal] = ACTIONS(2795),
  },
  [723] = {
    [sym_line_comment] = STATE(723),
    [sym_block_comment] = STATE(723),
    [ts_builtin_sym_end] = ACTIONS(2799),
    [sym_identifier] = ACTIONS(2801),
    [anon_sym_SEMI] = ACTIONS(2799),
    [anon_sym_macro_rules_BANG] = ACTIONS(2799),
    [anon_sym_LPAREN] = ACTIONS(2799),
    [anon_sym_LBRACK] = ACTIONS(2799),
    [anon_sym_LBRACE] = ACTIONS(2799),
    [anon_sym_RBRACE] = ACTIONS(2799),
    [anon_sym_STAR] = ACTIONS(2799),
    [anon_sym_u8] = ACTIONS(2801),
    [anon_sym_i8] = ACTIONS(2801),
    [anon_sym_u16] = ACTIONS(2801),
    [anon_sym_i16] = ACTIONS(2801),
    [anon_sym_u32] = ACTIONS(2801),
    [anon_sym_i32] = ACTIONS(2801),
    [anon_sym_u64] = ACTIONS(2801),
    [anon_sym_i64] = ACTIONS(2801),
    [anon_sym_u128] = ACTIONS(2801),
    [anon_sym_i128] = ACTIONS(2801),
    [anon_sym_isize] = ACTIONS(2801),
    [anon_sym_usize] = ACTIONS(2801),
    [anon_sym_f32] = ACTIONS(2801),
    [anon_sym_f64] = ACTIONS(2801),
    [anon_sym_bool] = ACTIONS(2801),
    [anon_sym_str] = ACTIONS(2801),
    [anon_sym_char] = ACTIONS(2801),
    [anon_sym_DASH] = ACTIONS(2799),
    [anon_sym_BANG] = ACTIONS(2799),
    [anon_sym_AMP] = ACTIONS(2799),
    [anon_sym_PIPE] = ACTIONS(2799),
    [anon_sym_LT] = ACTIONS(2799),
    [anon_sym_DOT_DOT] = ACTIONS(2799),
    [anon_sym_COLON_COLON] = ACTIONS(2799),
    [anon_sym_POUND] = ACTIONS(2799),
    [anon_sym_SQUOTE] = ACTIONS(2801),
    [anon_sym_async] = ACTIONS(2801),
    [anon_sym_break] = ACTIONS(2801),
    [anon_sym_const] = ACTIONS(2801),
    [anon_sym_continue] = ACTIONS(2801),
    [anon_sym_default] = ACTIONS(2801),
    [anon_sym_enum] = ACTIONS(2801),
    [anon_sym_fn] = ACTIONS(2801),
    [anon_sym_for] = ACTIONS(2801),
    [anon_sym_if] = ACTIONS(2801),
    [anon_sym_impl] = ACTIONS(2801),
    [anon_sym_let] = ACTIONS(2801),
    [anon_sym_loop] = ACTIONS(2801),
    [anon_sym_match] = ACTIONS(2801),
    [anon_sym_mod] = ACTIONS(2801),
    [anon_sym_pub] = ACTIONS(2801),
    [anon_sym_return] = ACTIONS(2801),
    [anon_sym_static] = ACTIONS(2801),
    [anon_sym_struct] = ACTIONS(2801),
    [anon_sym_trait] = ACTIONS(2801),
    [anon_sym_type] = ACTIONS(2801),
    [anon_sym_union] = ACTIONS(2801),
    [anon_sym_unsafe] = ACTIONS(2801),
    [anon_sym_use] = ACTIONS(2801),
    [anon_sym_while] = ACTIONS(2801),
    [anon_sym_extern] = ACTIONS(2801),
    [anon_sym_yield] = ACTIONS(2801),
    [anon_sym_move] = ACTIONS(2801),
    [anon_sym_try] = ACTIONS(2801),
    [sym_integer_literal] = ACTIONS(2799),
    [aux_sym_string_literal_token1] = ACTIONS(2799),
    [sym_char_literal] = ACTIONS(2799),
    [anon_sym_true] = ACTIONS(2801),
    [anon_sym_false] = ACTIONS(2801),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2801),
    [sym_super] = ACTIONS(2801),
    [sym_crate] = ACTIONS(2801),
    [sym_metavariable] = ACTIONS(2799),
    [sym__raw_string_literal_start] = ACTIONS(2799),
    [sym_float_literal] = ACTIONS(2799),
  },
  [724] = {
    [sym_line_comment] = STATE(724),
    [sym_block_comment] = STATE(724),
    [ts_builtin_sym_end] = ACTIONS(2803),
    [sym_identifier] = ACTIONS(2805),
    [anon_sym_SEMI] = ACTIONS(2803),
    [anon_sym_macro_rules_BANG] = ACTIONS(2803),
    [anon_sym_LPAREN] = ACTIONS(2803),
    [anon_sym_LBRACK] = ACTIONS(2803),
    [anon_sym_LBRACE] = ACTIONS(2803),
    [anon_sym_RBRACE] = ACTIONS(2803),
    [anon_sym_STAR] = ACTIONS(2803),
    [anon_sym_u8] = ACTIONS(2805),
    [anon_sym_i8] = ACTIONS(2805),
    [anon_sym_u16] = ACTIONS(2805),
    [anon_sym_i16] = ACTIONS(2805),
    [anon_sym_u32] = ACTIONS(2805),
    [anon_sym_i32] = ACTIONS(2805),
    [anon_sym_u64] = ACTIONS(2805),
    [anon_sym_i64] = ACTIONS(2805),
    [anon_sym_u128] = ACTIONS(2805),
    [anon_sym_i128] = ACTIONS(2805),
    [anon_sym_isize] = ACTIONS(2805),
    [anon_sym_usize] = ACTIONS(2805),
    [anon_sym_f32] = ACTIONS(2805),
    [anon_sym_f64] = ACTIONS(2805),
    [anon_sym_bool] = ACTIONS(2805),
    [anon_sym_str] = ACTIONS(2805),
    [anon_sym_char] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(2803),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_AMP] = ACTIONS(2803),
    [anon_sym_PIPE] = ACTIONS(2803),
    [anon_sym_LT] = ACTIONS(2803),
    [anon_sym_DOT_DOT] = ACTIONS(2803),
    [anon_sym_COLON_COLON] = ACTIONS(2803),
    [anon_sym_POUND] = ACTIONS(2803),
    [anon_sym_SQUOTE] = ACTIONS(2805),
    [anon_sym_async] = ACTIONS(2805),
    [anon_sym_break] = ACTIONS(2805),
    [anon_sym_const] = ACTIONS(2805),
    [anon_sym_continue] = ACTIONS(2805),
    [anon_sym_default] = ACTIONS(2805),
    [anon_sym_enum] = ACTIONS(2805),
    [anon_sym_fn] = ACTIONS(2805),
    [anon_sym_for] = ACTIONS(2805),
    [anon_sym_if] = ACTIONS(2805),
    [anon_sym_impl] = ACTIONS(2805),
    [anon_sym_let] = ACTIONS(2805),
    [anon_sym_loop] = ACTIONS(2805),
    [anon_sym_match] = ACTIONS(2805),
    [anon_sym_mod] = ACTIONS(2805),
    [anon_sym_pub] = ACTIONS(2805),
    [anon_sym_return] = ACTIONS(2805),
    [anon_sym_static] = ACTIONS(2805),
    [anon_sym_struct] = ACTIONS(2805),
    [anon_sym_trait] = ACTIONS(2805),
    [anon_sym_type] = ACTIONS(2805),
    [anon_sym_union] = ACTIONS(2805),
    [anon_sym_unsafe] = ACTIONS(2805),
    [anon_sym_use] = ACTIONS(2805),
    [anon_sym_while] = ACTIONS(2805),
    [anon_sym_extern] = ACTIONS(2805),
    [anon_sym_yield] = ACTIONS(2805),
    [anon_sym_move] = ACTIONS(2805),
    [anon_sym_try] = ACTIONS(2805),
    [sym_integer_literal] = ACTIONS(2803),
    [aux_sym_string_literal_token1] = ACTIONS(2803),
    [sym_char_literal] = ACTIONS(2803),
    [anon_sym_true] = ACTIONS(2805),
    [anon_sym_false] = ACTIONS(2805),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2805),
    [sym_super] = ACTIONS(2805),
    [sym_crate] = ACTIONS(2805),
    [sym_metavariable] = ACTIONS(2803),
    [sym__raw_string_literal_start] = ACTIONS(2803),
    [sym_float_literal] = ACTIONS(2803),
  },
  [725] = {
    [sym_line_comment] = STATE(725),
    [sym_block_comment] = STATE(725),
    [ts_builtin_sym_end] = ACTIONS(2807),
    [sym_identifier] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_macro_rules_BANG] = ACTIONS(2807),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_RBRACE] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2807),
    [anon_sym_u8] = ACTIONS(2809),
    [anon_sym_i8] = ACTIONS(2809),
    [anon_sym_u16] = ACTIONS(2809),
    [anon_sym_i16] = ACTIONS(2809),
    [anon_sym_u32] = ACTIONS(2809),
    [anon_sym_i32] = ACTIONS(2809),
    [anon_sym_u64] = ACTIONS(2809),
    [anon_sym_i64] = ACTIONS(2809),
    [anon_sym_u128] = ACTIONS(2809),
    [anon_sym_i128] = ACTIONS(2809),
    [anon_sym_isize] = ACTIONS(2809),
    [anon_sym_usize] = ACTIONS(2809),
    [anon_sym_f32] = ACTIONS(2809),
    [anon_sym_f64] = ACTIONS(2809),
    [anon_sym_bool] = ACTIONS(2809),
    [anon_sym_str] = ACTIONS(2809),
    [anon_sym_char] = ACTIONS(2809),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_BANG] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2807),
    [anon_sym_LT] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2807),
    [anon_sym_COLON_COLON] = ACTIONS(2807),
    [anon_sym_POUND] = ACTIONS(2807),
    [anon_sym_SQUOTE] = ACTIONS(2809),
    [anon_sym_async] = ACTIONS(2809),
    [anon_sym_break] = ACTIONS(2809),
    [anon_sym_const] = ACTIONS(2809),
    [anon_sym_continue] = ACTIONS(2809),
    [anon_sym_default] = ACTIONS(2809),
    [anon_sym_enum] = ACTIONS(2809),
    [anon_sym_fn] = ACTIONS(2809),
    [anon_sym_for] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(2809),
    [anon_sym_impl] = ACTIONS(2809),
    [anon_sym_let] = ACTIONS(2809),
    [anon_sym_loop] = ACTIONS(2809),
    [anon_sym_match] = ACTIONS(2809),
    [anon_sym_mod] = ACTIONS(2809),
    [anon_sym_pub] = ACTIONS(2809),
    [anon_sym_return] = ACTIONS(2809),
    [anon_sym_static] = ACTIONS(2809),
    [anon_sym_struct] = ACTIONS(2809),
    [anon_sym_trait] = ACTIONS(2809),
    [anon_sym_type] = ACTIONS(2809),
    [anon_sym_union] = ACTIONS(2809),
    [anon_sym_unsafe] = ACTIONS(2809),
    [anon_sym_use] = ACTIONS(2809),
    [anon_sym_while] = ACTIONS(2809),
    [anon_sym_extern] = ACTIONS(2809),
    [anon_sym_yield] = ACTIONS(2809),
    [anon_sym_move] = ACTIONS(2809),
    [anon_sym_try] = ACTIONS(2809),
    [sym_integer_literal] = ACTIONS(2807),
    [aux_sym_string_literal_token1] = ACTIONS(2807),
    [sym_char_literal] = ACTIONS(2807),
    [anon_sym_true] = ACTIONS(2809),
    [anon_sym_false] = ACTIONS(2809),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2809),
    [sym_super] = ACTIONS(2809),
    [sym_crate] = ACTIONS(2809),
    [sym_metavariable] = ACTIONS(2807),
    [sym__raw_string_literal_start] = ACTIONS(2807),
    [sym_float_literal] = ACTIONS(2807),
  },
  [726] = {
    [sym_line_comment] = STATE(726),
    [sym_block_comment] = STATE(726),
    [ts_builtin_sym_end] = ACTIONS(2811),
    [sym_identifier] = ACTIONS(2813),
    [anon_sym_SEMI] = ACTIONS(2811),
    [anon_sym_macro_rules_BANG] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(2811),
    [anon_sym_LBRACK] = ACTIONS(2811),
    [anon_sym_LBRACE] = ACTIONS(2811),
    [anon_sym_RBRACE] = ACTIONS(2811),
    [anon_sym_STAR] = ACTIONS(2811),
    [anon_sym_u8] = ACTIONS(2813),
    [anon_sym_i8] = ACTIONS(2813),
    [anon_sym_u16] = ACTIONS(2813),
    [anon_sym_i16] = ACTIONS(2813),
    [anon_sym_u32] = ACTIONS(2813),
    [anon_sym_i32] = ACTIONS(2813),
    [anon_sym_u64] = ACTIONS(2813),
    [anon_sym_i64] = ACTIONS(2813),
    [anon_sym_u128] = ACTIONS(2813),
    [anon_sym_i128] = ACTIONS(2813),
    [anon_sym_isize] = ACTIONS(2813),
    [anon_sym_usize] = ACTIONS(2813),
    [anon_sym_f32] = ACTIONS(2813),
    [anon_sym_f64] = ACTIONS(2813),
    [anon_sym_bool] = ACTIONS(2813),
    [anon_sym_str] = ACTIONS(2813),
    [anon_sym_char] = ACTIONS(2813),
    [anon_sym_DASH] = ACTIONS(2811),
    [anon_sym_BANG] = ACTIONS(2811),
    [anon_sym_AMP] = ACTIONS(2811),
    [anon_sym_PIPE] = ACTIONS(2811),
    [anon_sym_LT] = ACTIONS(2811),
    [anon_sym_DOT_DOT] = ACTIONS(2811),
    [anon_sym_COLON_COLON] = ACTIONS(2811),
    [anon_sym_POUND] = ACTIONS(2811),
    [anon_sym_SQUOTE] = ACTIONS(2813),
    [anon_sym_async] = ACTIONS(2813),
    [anon_sym_break] = ACTIONS(2813),
    [anon_sym_const] = ACTIONS(2813),
    [anon_sym_continue] = ACTIONS(2813),
    [anon_sym_default] = ACTIONS(2813),
    [anon_sym_enum] = ACTIONS(2813),
    [anon_sym_fn] = ACTIONS(2813),
    [anon_sym_for] = ACTIONS(2813),
    [anon_sym_if] = ACTIONS(2813),
    [anon_sym_impl] = ACTIONS(2813),
    [anon_sym_let] = ACTIONS(2813),
    [anon_sym_loop] = ACTIONS(2813),
    [anon_sym_match] = ACTIONS(2813),
    [anon_sym_mod] = ACTIONS(2813),
    [anon_sym_pub] = ACTIONS(2813),
    [anon_sym_return] = ACTIONS(2813),
    [anon_sym_static] = ACTIONS(2813),
    [anon_sym_struct] = ACTIONS(2813),
    [anon_sym_trait] = ACTIONS(2813),
    [anon_sym_type] = ACTIONS(2813),
    [anon_sym_union] = ACTIONS(2813),
    [anon_sym_unsafe] = ACTIONS(2813),
    [anon_sym_use] = ACTIONS(2813),
    [anon_sym_while] = ACTIONS(2813),
    [anon_sym_extern] = ACTIONS(2813),
    [anon_sym_yield] = ACTIONS(2813),
    [anon_sym_move] = ACTIONS(2813),
    [anon_sym_try] = ACTIONS(2813),
    [sym_integer_literal] = ACTIONS(2811),
    [aux_sym_string_literal_token1] = ACTIONS(2811),
    [sym_char_literal] = ACTIONS(2811),
    [anon_sym_true] = ACTIONS(2813),
    [anon_sym_false] = ACTIONS(2813),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2813),
    [sym_super] = ACTIONS(2813),
    [sym_crate] = ACTIONS(2813),
    [sym_metavariable] = ACTIONS(2811),
    [sym__raw_string_literal_start] = ACTIONS(2811),
    [sym_float_literal] = ACTIONS(2811),
  },
  [727] = {
    [sym_line_comment] = STATE(727),
    [sym_block_comment] = STATE(727),
    [ts_builtin_sym_end] = ACTIONS(2815),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_SEMI] = ACTIONS(2815),
    [anon_sym_macro_rules_BANG] = ACTIONS(2815),
    [anon_sym_LPAREN] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(2815),
    [anon_sym_LBRACE] = ACTIONS(2815),
    [anon_sym_RBRACE] = ACTIONS(2815),
    [anon_sym_STAR] = ACTIONS(2815),
    [anon_sym_u8] = ACTIONS(2817),
    [anon_sym_i8] = ACTIONS(2817),
    [anon_sym_u16] = ACTIONS(2817),
    [anon_sym_i16] = ACTIONS(2817),
    [anon_sym_u32] = ACTIONS(2817),
    [anon_sym_i32] = ACTIONS(2817),
    [anon_sym_u64] = ACTIONS(2817),
    [anon_sym_i64] = ACTIONS(2817),
    [anon_sym_u128] = ACTIONS(2817),
    [anon_sym_i128] = ACTIONS(2817),
    [anon_sym_isize] = ACTIONS(2817),
    [anon_sym_usize] = ACTIONS(2817),
    [anon_sym_f32] = ACTIONS(2817),
    [anon_sym_f64] = ACTIONS(2817),
    [anon_sym_bool] = ACTIONS(2817),
    [anon_sym_str] = ACTIONS(2817),
    [anon_sym_char] = ACTIONS(2817),
    [anon_sym_DASH] = ACTIONS(2815),
    [anon_sym_BANG] = ACTIONS(2815),
    [anon_sym_AMP] = ACTIONS(2815),
    [anon_sym_PIPE] = ACTIONS(2815),
    [anon_sym_LT] = ACTIONS(2815),
    [anon_sym_DOT_DOT] = ACTIONS(2815),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_POUND] = ACTIONS(2815),
    [anon_sym_SQUOTE] = ACTIONS(2817),
    [anon_sym_async] = ACTIONS(2817),
    [anon_sym_break] = ACTIONS(2817),
    [anon_sym_const] = ACTIONS(2817),
    [anon_sym_continue] = ACTIONS(2817),
    [anon_sym_default] = ACTIONS(2817),
    [anon_sym_enum] = ACTIONS(2817),
    [anon_sym_fn] = ACTIONS(2817),
    [anon_sym_for] = ACTIONS(2817),
    [anon_sym_if] = ACTIONS(2817),
    [anon_sym_impl] = ACTIONS(2817),
    [anon_sym_let] = ACTIONS(2817),
    [anon_sym_loop] = ACTIONS(2817),
    [anon_sym_match] = ACTIONS(2817),
    [anon_sym_mod] = ACTIONS(2817),
    [anon_sym_pub] = ACTIONS(2817),
    [anon_sym_return] = ACTIONS(2817),
    [anon_sym_static] = ACTIONS(2817),
    [anon_sym_struct] = ACTIONS(2817),
    [anon_sym_trait] = ACTIONS(2817),
    [anon_sym_type] = ACTIONS(2817),
    [anon_sym_union] = ACTIONS(2817),
    [anon_sym_unsafe] = ACTIONS(2817),
    [anon_sym_use] = ACTIONS(2817),
    [anon_sym_while] = ACTIONS(2817),
    [anon_sym_extern] = ACTIONS(2817),
    [anon_sym_yield] = ACTIONS(2817),
    [anon_sym_move] = ACTIONS(2817),
    [anon_sym_try] = ACTIONS(2817),
    [sym_integer_literal] = ACTIONS(2815),
    [aux_sym_string_literal_token1] = ACTIONS(2815),
    [sym_char_literal] = ACTIONS(2815),
    [anon_sym_true] = ACTIONS(2817),
    [anon_sym_false] = ACTIONS(2817),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2817),
    [sym_super] = ACTIONS(2817),
    [sym_crate] = ACTIONS(2817),
    [sym_metavariable] = ACTIONS(2815),
    [sym__raw_string_literal_start] = ACTIONS(2815),
    [sym_float_literal] = ACTIONS(2815),
  },
  [728] = {
    [sym_line_comment] = STATE(728),
    [sym_block_comment] = STATE(728),
    [ts_builtin_sym_end] = ACTIONS(2819),
    [sym_identifier] = ACTIONS(2821),
    [anon_sym_SEMI] = ACTIONS(2819),
    [anon_sym_macro_rules_BANG] = ACTIONS(2819),
    [anon_sym_LPAREN] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(2819),
    [anon_sym_LBRACE] = ACTIONS(2819),
    [anon_sym_RBRACE] = ACTIONS(2819),
    [anon_sym_STAR] = ACTIONS(2819),
    [anon_sym_u8] = ACTIONS(2821),
    [anon_sym_i8] = ACTIONS(2821),
    [anon_sym_u16] = ACTIONS(2821),
    [anon_sym_i16] = ACTIONS(2821),
    [anon_sym_u32] = ACTIONS(2821),
    [anon_sym_i32] = ACTIONS(2821),
    [anon_sym_u64] = ACTIONS(2821),
    [anon_sym_i64] = ACTIONS(2821),
    [anon_sym_u128] = ACTIONS(2821),
    [anon_sym_i128] = ACTIONS(2821),
    [anon_sym_isize] = ACTIONS(2821),
    [anon_sym_usize] = ACTIONS(2821),
    [anon_sym_f32] = ACTIONS(2821),
    [anon_sym_f64] = ACTIONS(2821),
    [anon_sym_bool] = ACTIONS(2821),
    [anon_sym_str] = ACTIONS(2821),
    [anon_sym_char] = ACTIONS(2821),
    [anon_sym_DASH] = ACTIONS(2819),
    [anon_sym_BANG] = ACTIONS(2819),
    [anon_sym_AMP] = ACTIONS(2819),
    [anon_sym_PIPE] = ACTIONS(2819),
    [anon_sym_LT] = ACTIONS(2819),
    [anon_sym_DOT_DOT] = ACTIONS(2819),
    [anon_sym_COLON_COLON] = ACTIONS(2819),
    [anon_sym_POUND] = ACTIONS(2819),
    [anon_sym_SQUOTE] = ACTIONS(2821),
    [anon_sym_async] = ACTIONS(2821),
    [anon_sym_break] = ACTIONS(2821),
    [anon_sym_const] = ACTIONS(2821),
    [anon_sym_continue] = ACTIONS(2821),
    [anon_sym_default] = ACTIONS(2821),
    [anon_sym_enum] = ACTIONS(2821),
    [anon_sym_fn] = ACTIONS(2821),
    [anon_sym_for] = ACTIONS(2821),
    [anon_sym_if] = ACTIONS(2821),
    [anon_sym_impl] = ACTIONS(2821),
    [anon_sym_let] = ACTIONS(2821),
    [anon_sym_loop] = ACTIONS(2821),
    [anon_sym_match] = ACTIONS(2821),
    [anon_sym_mod] = ACTIONS(2821),
    [anon_sym_pub] = ACTIONS(2821),
    [anon_sym_return] = ACTIONS(2821),
    [anon_sym_static] = ACTIONS(2821),
    [anon_sym_struct] = ACTIONS(2821),
    [anon_sym_trait] = ACTIONS(2821),
    [anon_sym_type] = ACTIONS(2821),
    [anon_sym_union] = ACTIONS(2821),
    [anon_sym_unsafe] = ACTIONS(2821),
    [anon_sym_use] = ACTIONS(2821),
    [anon_sym_while] = ACTIONS(2821),
    [anon_sym_extern] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2821),
    [anon_sym_move] = ACTIONS(2821),
    [anon_sym_try] = ACTIONS(2821),
    [sym_integer_literal] = ACTIONS(2819),
    [aux_sym_string_literal_token1] = ACTIONS(2819),
    [sym_char_literal] = ACTIONS(2819),
    [anon_sym_true] = ACTIONS(2821),
    [anon_sym_false] = ACTIONS(2821),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2821),
    [sym_super] = ACTIONS(2821),
    [sym_crate] = ACTIONS(2821),
    [sym_metavariable] = ACTIONS(2819),
    [sym__raw_string_literal_start] = ACTIONS(2819),
    [sym_float_literal] = ACTIONS(2819),
  },
  [729] = {
    [sym_line_comment] = STATE(729),
    [sym_block_comment] = STATE(729),
    [ts_builtin_sym_end] = ACTIONS(2823),
    [sym_identifier] = ACTIONS(2825),
    [anon_sym_SEMI] = ACTIONS(2823),
    [anon_sym_macro_rules_BANG] = ACTIONS(2823),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_LBRACK] = ACTIONS(2823),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_RBRACE] = ACTIONS(2823),
    [anon_sym_STAR] = ACTIONS(2823),
    [anon_sym_u8] = ACTIONS(2825),
    [anon_sym_i8] = ACTIONS(2825),
    [anon_sym_u16] = ACTIONS(2825),
    [anon_sym_i16] = ACTIONS(2825),
    [anon_sym_u32] = ACTIONS(2825),
    [anon_sym_i32] = ACTIONS(2825),
    [anon_sym_u64] = ACTIONS(2825),
    [anon_sym_i64] = ACTIONS(2825),
    [anon_sym_u128] = ACTIONS(2825),
    [anon_sym_i128] = ACTIONS(2825),
    [anon_sym_isize] = ACTIONS(2825),
    [anon_sym_usize] = ACTIONS(2825),
    [anon_sym_f32] = ACTIONS(2825),
    [anon_sym_f64] = ACTIONS(2825),
    [anon_sym_bool] = ACTIONS(2825),
    [anon_sym_str] = ACTIONS(2825),
    [anon_sym_char] = ACTIONS(2825),
    [anon_sym_DASH] = ACTIONS(2823),
    [anon_sym_BANG] = ACTIONS(2823),
    [anon_sym_AMP] = ACTIONS(2823),
    [anon_sym_PIPE] = ACTIONS(2823),
    [anon_sym_LT] = ACTIONS(2823),
    [anon_sym_DOT_DOT] = ACTIONS(2823),
    [anon_sym_COLON_COLON] = ACTIONS(2823),
    [anon_sym_POUND] = ACTIONS(2823),
    [anon_sym_SQUOTE] = ACTIONS(2825),
    [anon_sym_async] = ACTIONS(2825),
    [anon_sym_break] = ACTIONS(2825),
    [anon_sym_const] = ACTIONS(2825),
    [anon_sym_continue] = ACTIONS(2825),
    [anon_sym_default] = ACTIONS(2825),
    [anon_sym_enum] = ACTIONS(2825),
    [anon_sym_fn] = ACTIONS(2825),
    [anon_sym_for] = ACTIONS(2825),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_impl] = ACTIONS(2825),
    [anon_sym_let] = ACTIONS(2825),
    [anon_sym_loop] = ACTIONS(2825),
    [anon_sym_match] = ACTIONS(2825),
    [anon_sym_mod] = ACTIONS(2825),
    [anon_sym_pub] = ACTIONS(2825),
    [anon_sym_return] = ACTIONS(2825),
    [anon_sym_static] = ACTIONS(2825),
    [anon_sym_struct] = ACTIONS(2825),
    [anon_sym_trait] = ACTIONS(2825),
    [anon_sym_type] = ACTIONS(2825),
    [anon_sym_union] = ACTIONS(2825),
    [anon_sym_unsafe] = ACTIONS(2825),
    [anon_sym_use] = ACTIONS(2825),
    [anon_sym_while] = ACTIONS(2825),
    [anon_sym_extern] = ACTIONS(2825),
    [anon_sym_yield] = ACTIONS(2825),
    [anon_sym_move] = ACTIONS(2825),
    [anon_sym_try] = ACTIONS(2825),
    [sym_integer_literal] = ACTIONS(2823),
    [aux_sym_string_literal_token1] = ACTIONS(2823),
    [sym_char_literal] = ACTIONS(2823),
    [anon_sym_true] = ACTIONS(2825),
    [anon_sym_false] = ACTIONS(2825),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2825),
    [sym_super] = ACTIONS(2825),
    [sym_crate] = ACTIONS(2825),
    [sym_metavariable] = ACTIONS(2823),
    [sym__raw_string_literal_start] = ACTIONS(2823),
    [sym_float_literal] = ACTIONS(2823),
  },
  [730] = {
    [sym_line_comment] = STATE(730),
    [sym_block_comment] = STATE(730),
    [ts_builtin_sym_end] = ACTIONS(2827),
    [sym_identifier] = ACTIONS(2829),
    [anon_sym_SEMI] = ACTIONS(2827),
    [anon_sym_macro_rules_BANG] = ACTIONS(2827),
    [anon_sym_LPAREN] = ACTIONS(2827),
    [anon_sym_LBRACK] = ACTIONS(2827),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_RBRACE] = ACTIONS(2827),
    [anon_sym_STAR] = ACTIONS(2827),
    [anon_sym_u8] = ACTIONS(2829),
    [anon_sym_i8] = ACTIONS(2829),
    [anon_sym_u16] = ACTIONS(2829),
    [anon_sym_i16] = ACTIONS(2829),
    [anon_sym_u32] = ACTIONS(2829),
    [anon_sym_i32] = ACTIONS(2829),
    [anon_sym_u64] = ACTIONS(2829),
    [anon_sym_i64] = ACTIONS(2829),
    [anon_sym_u128] = ACTIONS(2829),
    [anon_sym_i128] = ACTIONS(2829),
    [anon_sym_isize] = ACTIONS(2829),
    [anon_sym_usize] = ACTIONS(2829),
    [anon_sym_f32] = ACTIONS(2829),
    [anon_sym_f64] = ACTIONS(2829),
    [anon_sym_bool] = ACTIONS(2829),
    [anon_sym_str] = ACTIONS(2829),
    [anon_sym_char] = ACTIONS(2829),
    [anon_sym_DASH] = ACTIONS(2827),
    [anon_sym_BANG] = ACTIONS(2827),
    [anon_sym_AMP] = ACTIONS(2827),
    [anon_sym_PIPE] = ACTIONS(2827),
    [anon_sym_LT] = ACTIONS(2827),
    [anon_sym_DOT_DOT] = ACTIONS(2827),
    [anon_sym_COLON_COLON] = ACTIONS(2827),
    [anon_sym_POUND] = ACTIONS(2827),
    [anon_sym_SQUOTE] = ACTIONS(2829),
    [anon_sym_async] = ACTIONS(2829),
    [anon_sym_break] = ACTIONS(2829),
    [anon_sym_const] = ACTIONS(2829),
    [anon_sym_continue] = ACTIONS(2829),
    [anon_sym_default] = ACTIONS(2829),
    [anon_sym_enum] = ACTIONS(2829),
    [anon_sym_fn] = ACTIONS(2829),
    [anon_sym_for] = ACTIONS(2829),
    [anon_sym_if] = ACTIONS(2829),
    [anon_sym_impl] = ACTIONS(2829),
    [anon_sym_let] = ACTIONS(2829),
    [anon_sym_loop] = ACTIONS(2829),
    [anon_sym_match] = ACTIONS(2829),
    [anon_sym_mod] = ACTIONS(2829),
    [anon_sym_pub] = ACTIONS(2829),
    [anon_sym_return] = ACTIONS(2829),
    [anon_sym_static] = ACTIONS(2829),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_trait] = ACTIONS(2829),
    [anon_sym_type] = ACTIONS(2829),
    [anon_sym_union] = ACTIONS(2829),
    [anon_sym_unsafe] = ACTIONS(2829),
    [anon_sym_use] = ACTIONS(2829),
    [anon_sym_while] = ACTIONS(2829),
    [anon_sym_extern] = ACTIONS(2829),
    [anon_sym_yield] = ACTIONS(2829),
    [anon_sym_move] = ACTIONS(2829),
    [anon_sym_try] = ACTIONS(2829),
    [sym_integer_literal] = ACTIONS(2827),
    [aux_sym_string_literal_token1] = ACTIONS(2827),
    [sym_char_literal] = ACTIONS(2827),
    [anon_sym_true] = ACTIONS(2829),
    [anon_sym_false] = ACTIONS(2829),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2829),
    [sym_super] = ACTIONS(2829),
    [sym_crate] = ACTIONS(2829),
    [sym_metavariable] = ACTIONS(2827),
    [sym__raw_string_literal_start] = ACTIONS(2827),
    [sym_float_literal] = ACTIONS(2827),
  },
  [731] = {
    [sym_line_comment] = STATE(731),
    [sym_block_comment] = STATE(731),
    [ts_builtin_sym_end] = ACTIONS(2831),
    [sym_identifier] = ACTIONS(2833),
    [anon_sym_SEMI] = ACTIONS(2831),
    [anon_sym_macro_rules_BANG] = ACTIONS(2831),
    [anon_sym_LPAREN] = ACTIONS(2831),
    [anon_sym_LBRACK] = ACTIONS(2831),
    [anon_sym_LBRACE] = ACTIONS(2831),
    [anon_sym_RBRACE] = ACTIONS(2831),
    [anon_sym_STAR] = ACTIONS(2831),
    [anon_sym_u8] = ACTIONS(2833),
    [anon_sym_i8] = ACTIONS(2833),
    [anon_sym_u16] = ACTIONS(2833),
    [anon_sym_i16] = ACTIONS(2833),
    [anon_sym_u32] = ACTIONS(2833),
    [anon_sym_i32] = ACTIONS(2833),
    [anon_sym_u64] = ACTIONS(2833),
    [anon_sym_i64] = ACTIONS(2833),
    [anon_sym_u128] = ACTIONS(2833),
    [anon_sym_i128] = ACTIONS(2833),
    [anon_sym_isize] = ACTIONS(2833),
    [anon_sym_usize] = ACTIONS(2833),
    [anon_sym_f32] = ACTIONS(2833),
    [anon_sym_f64] = ACTIONS(2833),
    [anon_sym_bool] = ACTIONS(2833),
    [anon_sym_str] = ACTIONS(2833),
    [anon_sym_char] = ACTIONS(2833),
    [anon_sym_DASH] = ACTIONS(2831),
    [anon_sym_BANG] = ACTIONS(2831),
    [anon_sym_AMP] = ACTIONS(2831),
    [anon_sym_PIPE] = ACTIONS(2831),
    [anon_sym_LT] = ACTIONS(2831),
    [anon_sym_DOT_DOT] = ACTIONS(2831),
    [anon_sym_COLON_COLON] = ACTIONS(2831),
    [anon_sym_POUND] = ACTIONS(2831),
    [anon_sym_SQUOTE] = ACTIONS(2833),
    [anon_sym_async] = ACTIONS(2833),
    [anon_sym_break] = ACTIONS(2833),
    [anon_sym_const] = ACTIONS(2833),
    [anon_sym_continue] = ACTIONS(2833),
    [anon_sym_default] = ACTIONS(2833),
    [anon_sym_enum] = ACTIONS(2833),
    [anon_sym_fn] = ACTIONS(2833),
    [anon_sym_for] = ACTIONS(2833),
    [anon_sym_if] = ACTIONS(2833),
    [anon_sym_impl] = ACTIONS(2833),
    [anon_sym_let] = ACTIONS(2833),
    [anon_sym_loop] = ACTIONS(2833),
    [anon_sym_match] = ACTIONS(2833),
    [anon_sym_mod] = ACTIONS(2833),
    [anon_sym_pub] = ACTIONS(2833),
    [anon_sym_return] = ACTIONS(2833),
    [anon_sym_static] = ACTIONS(2833),
    [anon_sym_struct] = ACTIONS(2833),
    [anon_sym_trait] = ACTIONS(2833),
    [anon_sym_type] = ACTIONS(2833),
    [anon_sym_union] = ACTIONS(2833),
    [anon_sym_unsafe] = ACTIONS(2833),
    [anon_sym_use] = ACTIONS(2833),
    [anon_sym_while] = ACTIONS(2833),
    [anon_sym_extern] = ACTIONS(2833),
    [anon_sym_yield] = ACTIONS(2833),
    [anon_sym_move] = ACTIONS(2833),
    [anon_sym_try] = ACTIONS(2833),
    [sym_integer_literal] = ACTIONS(2831),
    [aux_sym_string_literal_token1] = ACTIONS(2831),
    [sym_char_literal] = ACTIONS(2831),
    [anon_sym_true] = ACTIONS(2833),
    [anon_sym_false] = ACTIONS(2833),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2833),
    [sym_super] = ACTIONS(2833),
    [sym_crate] = ACTIONS(2833),
    [sym_metavariable] = ACTIONS(2831),
    [sym__raw_string_literal_start] = ACTIONS(2831),
    [sym_float_literal] = ACTIONS(2831),
  },
  [732] = {
    [sym_line_comment] = STATE(732),
    [sym_block_comment] = STATE(732),
    [ts_builtin_sym_end] = ACTIONS(2835),
    [sym_identifier] = ACTIONS(2837),
    [anon_sym_SEMI] = ACTIONS(2835),
    [anon_sym_macro_rules_BANG] = ACTIONS(2835),
    [anon_sym_LPAREN] = ACTIONS(2835),
    [anon_sym_LBRACK] = ACTIONS(2835),
    [anon_sym_LBRACE] = ACTIONS(2835),
    [anon_sym_RBRACE] = ACTIONS(2835),
    [anon_sym_STAR] = ACTIONS(2835),
    [anon_sym_u8] = ACTIONS(2837),
    [anon_sym_i8] = ACTIONS(2837),
    [anon_sym_u16] = ACTIONS(2837),
    [anon_sym_i16] = ACTIONS(2837),
    [anon_sym_u32] = ACTIONS(2837),
    [anon_sym_i32] = ACTIONS(2837),
    [anon_sym_u64] = ACTIONS(2837),
    [anon_sym_i64] = ACTIONS(2837),
    [anon_sym_u128] = ACTIONS(2837),
    [anon_sym_i128] = ACTIONS(2837),
    [anon_sym_isize] = ACTIONS(2837),
    [anon_sym_usize] = ACTIONS(2837),
    [anon_sym_f32] = ACTIONS(2837),
    [anon_sym_f64] = ACTIONS(2837),
    [anon_sym_bool] = ACTIONS(2837),
    [anon_sym_str] = ACTIONS(2837),
    [anon_sym_char] = ACTIONS(2837),
    [anon_sym_DASH] = ACTIONS(2835),
    [anon_sym_BANG] = ACTIONS(2835),
    [anon_sym_AMP] = ACTIONS(2835),
    [anon_sym_PIPE] = ACTIONS(2835),
    [anon_sym_LT] = ACTIONS(2835),
    [anon_sym_DOT_DOT] = ACTIONS(2835),
    [anon_sym_COLON_COLON] = ACTIONS(2835),
    [anon_sym_POUND] = ACTIONS(2835),
    [anon_sym_SQUOTE] = ACTIONS(2837),
    [anon_sym_async] = ACTIONS(2837),
    [anon_sym_break] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(2837),
    [anon_sym_continue] = ACTIONS(2837),
    [anon_sym_default] = ACTIONS(2837),
    [anon_sym_enum] = ACTIONS(2837),
    [anon_sym_fn] = ACTIONS(2837),
    [anon_sym_for] = ACTIONS(2837),
    [anon_sym_if] = ACTIONS(2837),
    [anon_sym_impl] = ACTIONS(2837),
    [anon_sym_let] = ACTIONS(2837),
    [anon_sym_loop] = ACTIONS(2837),
    [anon_sym_match] = ACTIONS(2837),
    [anon_sym_mod] = ACTIONS(2837),
    [anon_sym_pub] = ACTIONS(2837),
    [anon_sym_return] = ACTIONS(2837),
    [anon_sym_static] = ACTIONS(2837),
    [anon_sym_struct] = ACTIONS(2837),
    [anon_sym_trait] = ACTIONS(2837),
    [anon_sym_type] = ACTIONS(2837),
    [anon_sym_union] = ACTIONS(2837),
    [anon_sym_unsafe] = ACTIONS(2837),
    [anon_sym_use] = ACTIONS(2837),
    [anon_sym_while] = ACTIONS(2837),
    [anon_sym_extern] = ACTIONS(2837),
    [anon_sym_yield] = ACTIONS(2837),
    [anon_sym_move] = ACTIONS(2837),
    [anon_sym_try] = ACTIONS(2837),
    [sym_integer_literal] = ACTIONS(2835),
    [aux_sym_string_literal_token1] = ACTIONS(2835),
    [sym_char_literal] = ACTIONS(2835),
    [anon_sym_true] = ACTIONS(2837),
    [anon_sym_false] = ACTIONS(2837),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2837),
    [sym_super] = ACTIONS(2837),
    [sym_crate] = ACTIONS(2837),
    [sym_metavariable] = ACTIONS(2835),
    [sym__raw_string_literal_start] = ACTIONS(2835),
    [sym_float_literal] = ACTIONS(2835),
  },
  [733] = {
    [sym_line_comment] = STATE(733),
    [sym_block_comment] = STATE(733),
    [ts_builtin_sym_end] = ACTIONS(2839),
    [sym_identifier] = ACTIONS(2841),
    [anon_sym_SEMI] = ACTIONS(2839),
    [anon_sym_macro_rules_BANG] = ACTIONS(2839),
    [anon_sym_LPAREN] = ACTIONS(2839),
    [anon_sym_LBRACK] = ACTIONS(2839),
    [anon_sym_LBRACE] = ACTIONS(2839),
    [anon_sym_RBRACE] = ACTIONS(2839),
    [anon_sym_STAR] = ACTIONS(2839),
    [anon_sym_u8] = ACTIONS(2841),
    [anon_sym_i8] = ACTIONS(2841),
    [anon_sym_u16] = ACTIONS(2841),
    [anon_sym_i16] = ACTIONS(2841),
    [anon_sym_u32] = ACTIONS(2841),
    [anon_sym_i32] = ACTIONS(2841),
    [anon_sym_u64] = ACTIONS(2841),
    [anon_sym_i64] = ACTIONS(2841),
    [anon_sym_u128] = ACTIONS(2841),
    [anon_sym_i128] = ACTIONS(2841),
    [anon_sym_isize] = ACTIONS(2841),
    [anon_sym_usize] = ACTIONS(2841),
    [anon_sym_f32] = ACTIONS(2841),
    [anon_sym_f64] = ACTIONS(2841),
    [anon_sym_bool] = ACTIONS(2841),
    [anon_sym_str] = ACTIONS(2841),
    [anon_sym_char] = ACTIONS(2841),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_BANG] = ACTIONS(2839),
    [anon_sym_AMP] = ACTIONS(2839),
    [anon_sym_PIPE] = ACTIONS(2839),
    [anon_sym_LT] = ACTIONS(2839),
    [anon_sym_DOT_DOT] = ACTIONS(2839),
    [anon_sym_COLON_COLON] = ACTIONS(2839),
    [anon_sym_POUND] = ACTIONS(2839),
    [anon_sym_SQUOTE] = ACTIONS(2841),
    [anon_sym_async] = ACTIONS(2841),
    [anon_sym_break] = ACTIONS(2841),
    [anon_sym_const] = ACTIONS(2841),
    [anon_sym_continue] = ACTIONS(2841),
    [anon_sym_default] = ACTIONS(2841),
    [anon_sym_enum] = ACTIONS(2841),
    [anon_sym_fn] = ACTIONS(2841),
    [anon_sym_for] = ACTIONS(2841),
    [anon_sym_if] = ACTIONS(2841),
    [anon_sym_impl] = ACTIONS(2841),
    [anon_sym_let] = ACTIONS(2841),
    [anon_sym_loop] = ACTIONS(2841),
    [anon_sym_match] = ACTIONS(2841),
    [anon_sym_mod] = ACTIONS(2841),
    [anon_sym_pub] = ACTIONS(2841),
    [anon_sym_return] = ACTIONS(2841),
    [anon_sym_static] = ACTIONS(2841),
    [anon_sym_struct] = ACTIONS(2841),
    [anon_sym_trait] = ACTIONS(2841),
    [anon_sym_type] = ACTIONS(2841),
    [anon_sym_union] = ACTIONS(2841),
    [anon_sym_unsafe] = ACTIONS(2841),
    [anon_sym_use] = ACTIONS(2841),
    [anon_sym_while] = ACTIONS(2841),
    [anon_sym_extern] = ACTIONS(2841),
    [anon_sym_yield] = ACTIONS(2841),
    [anon_sym_move] = ACTIONS(2841),
    [anon_sym_try] = ACTIONS(2841),
    [sym_integer_literal] = ACTIONS(2839),
    [aux_sym_string_literal_token1] = ACTIONS(2839),
    [sym_char_literal] = ACTIONS(2839),
    [anon_sym_true] = ACTIONS(2841),
    [anon_sym_false] = ACTIONS(2841),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2841),
    [sym_super] = ACTIONS(2841),
    [sym_crate] = ACTIONS(2841),
    [sym_metavariable] = ACTIONS(2839),
    [sym__raw_string_literal_start] = ACTIONS(2839),
    [sym_float_literal] = ACTIONS(2839),
  },
  [734] = {
    [sym_line_comment] = STATE(734),
    [sym_block_comment] = STATE(734),
    [ts_builtin_sym_end] = ACTIONS(2843),
    [sym_identifier] = ACTIONS(2845),
    [anon_sym_SEMI] = ACTIONS(2843),
    [anon_sym_macro_rules_BANG] = ACTIONS(2843),
    [anon_sym_LPAREN] = ACTIONS(2843),
    [anon_sym_LBRACK] = ACTIONS(2843),
    [anon_sym_LBRACE] = ACTIONS(2843),
    [anon_sym_RBRACE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2843),
    [anon_sym_u8] = ACTIONS(2845),
    [anon_sym_i8] = ACTIONS(2845),
    [anon_sym_u16] = ACTIONS(2845),
    [anon_sym_i16] = ACTIONS(2845),
    [anon_sym_u32] = ACTIONS(2845),
    [anon_sym_i32] = ACTIONS(2845),
    [anon_sym_u64] = ACTIONS(2845),
    [anon_sym_i64] = ACTIONS(2845),
    [anon_sym_u128] = ACTIONS(2845),
    [anon_sym_i128] = ACTIONS(2845),
    [anon_sym_isize] = ACTIONS(2845),
    [anon_sym_usize] = ACTIONS(2845),
    [anon_sym_f32] = ACTIONS(2845),
    [anon_sym_f64] = ACTIONS(2845),
    [anon_sym_bool] = ACTIONS(2845),
    [anon_sym_str] = ACTIONS(2845),
    [anon_sym_char] = ACTIONS(2845),
    [anon_sym_DASH] = ACTIONS(2843),
    [anon_sym_BANG] = ACTIONS(2843),
    [anon_sym_AMP] = ACTIONS(2843),
    [anon_sym_PIPE] = ACTIONS(2843),
    [anon_sym_LT] = ACTIONS(2843),
    [anon_sym_DOT_DOT] = ACTIONS(2843),
    [anon_sym_COLON_COLON] = ACTIONS(2843),
    [anon_sym_POUND] = ACTIONS(2843),
    [anon_sym_SQUOTE] = ACTIONS(2845),
    [anon_sym_async] = ACTIONS(2845),
    [anon_sym_break] = ACTIONS(2845),
    [anon_sym_const] = ACTIONS(2845),
    [anon_sym_continue] = ACTIONS(2845),
    [anon_sym_default] = ACTIONS(2845),
    [anon_sym_enum] = ACTIONS(2845),
    [anon_sym_fn] = ACTIONS(2845),
    [anon_sym_for] = ACTIONS(2845),
    [anon_sym_if] = ACTIONS(2845),
    [anon_sym_impl] = ACTIONS(2845),
    [anon_sym_let] = ACTIONS(2845),
    [anon_sym_loop] = ACTIONS(2845),
    [anon_sym_match] = ACTIONS(2845),
    [anon_sym_mod] = ACTIONS(2845),
    [anon_sym_pub] = ACTIONS(2845),
    [anon_sym_return] = ACTIONS(2845),
    [anon_sym_static] = ACTIONS(2845),
    [anon_sym_struct] = ACTIONS(2845),
    [anon_sym_trait] = ACTIONS(2845),
    [anon_sym_type] = ACTIONS(2845),
    [anon_sym_union] = ACTIONS(2845),
    [anon_sym_unsafe] = ACTIONS(2845),
    [anon_sym_use] = ACTIONS(2845),
    [anon_sym_while] = ACTIONS(2845),
    [anon_sym_extern] = ACTIONS(2845),
    [anon_sym_yield] = ACTIONS(2845),
    [anon_sym_move] = ACTIONS(2845),
    [anon_sym_try] = ACTIONS(2845),
    [sym_integer_literal] = ACTIONS(2843),
    [aux_sym_string_literal_token1] = ACTIONS(2843),
    [sym_char_literal] = ACTIONS(2843),
    [anon_sym_true] = ACTIONS(2845),
    [anon_sym_false] = ACTIONS(2845),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2845),
    [sym_super] = ACTIONS(2845),
    [sym_crate] = ACTIONS(2845),
    [sym_metavariable] = ACTIONS(2843),
    [sym__raw_string_literal_start] = ACTIONS(2843),
    [sym_float_literal] = ACTIONS(2843),
  },
  [735] = {
    [sym_line_comment] = STATE(735),
    [sym_block_comment] = STATE(735),
    [ts_builtin_sym_end] = ACTIONS(2847),
    [sym_identifier] = ACTIONS(2849),
    [anon_sym_SEMI] = ACTIONS(2847),
    [anon_sym_macro_rules_BANG] = ACTIONS(2847),
    [anon_sym_LPAREN] = ACTIONS(2847),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_LBRACE] = ACTIONS(2847),
    [anon_sym_RBRACE] = ACTIONS(2847),
    [anon_sym_STAR] = ACTIONS(2847),
    [anon_sym_u8] = ACTIONS(2849),
    [anon_sym_i8] = ACTIONS(2849),
    [anon_sym_u16] = ACTIONS(2849),
    [anon_sym_i16] = ACTIONS(2849),
    [anon_sym_u32] = ACTIONS(2849),
    [anon_sym_i32] = ACTIONS(2849),
    [anon_sym_u64] = ACTIONS(2849),
    [anon_sym_i64] = ACTIONS(2849),
    [anon_sym_u128] = ACTIONS(2849),
    [anon_sym_i128] = ACTIONS(2849),
    [anon_sym_isize] = ACTIONS(2849),
    [anon_sym_usize] = ACTIONS(2849),
    [anon_sym_f32] = ACTIONS(2849),
    [anon_sym_f64] = ACTIONS(2849),
    [anon_sym_bool] = ACTIONS(2849),
    [anon_sym_str] = ACTIONS(2849),
    [anon_sym_char] = ACTIONS(2849),
    [anon_sym_DASH] = ACTIONS(2847),
    [anon_sym_BANG] = ACTIONS(2847),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym_PIPE] = ACTIONS(2847),
    [anon_sym_LT] = ACTIONS(2847),
    [anon_sym_DOT_DOT] = ACTIONS(2847),
    [anon_sym_COLON_COLON] = ACTIONS(2847),
    [anon_sym_POUND] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2849),
    [anon_sym_async] = ACTIONS(2849),
    [anon_sym_break] = ACTIONS(2849),
    [anon_sym_const] = ACTIONS(2849),
    [anon_sym_continue] = ACTIONS(2849),
    [anon_sym_default] = ACTIONS(2849),
    [anon_sym_enum] = ACTIONS(2849),
    [anon_sym_fn] = ACTIONS(2849),
    [anon_sym_for] = ACTIONS(2849),
    [anon_sym_if] = ACTIONS(2849),
    [anon_sym_impl] = ACTIONS(2849),
    [anon_sym_let] = ACTIONS(2849),
    [anon_sym_loop] = ACTIONS(2849),
    [anon_sym_match] = ACTIONS(2849),
    [anon_sym_mod] = ACTIONS(2849),
    [anon_sym_pub] = ACTIONS(2849),
    [anon_sym_return] = ACTIONS(2849),
    [anon_sym_static] = ACTIONS(2849),
    [anon_sym_struct] = ACTIONS(2849),
    [anon_sym_trait] = ACTIONS(2849),
    [anon_sym_type] = ACTIONS(2849),
    [anon_sym_union] = ACTIONS(2849),
    [anon_sym_unsafe] = ACTIONS(2849),
    [anon_sym_use] = ACTIONS(2849),
    [anon_sym_while] = ACTIONS(2849),
    [anon_sym_extern] = ACTIONS(2849),
    [anon_sym_yield] = ACTIONS(2849),
    [anon_sym_move] = ACTIONS(2849),
    [anon_sym_try] = ACTIONS(2849),
    [sym_integer_literal] = ACTIONS(2847),
    [aux_sym_string_literal_token1] = ACTIONS(2847),
    [sym_char_literal] = ACTIONS(2847),
    [anon_sym_true] = ACTIONS(2849),
    [anon_sym_false] = ACTIONS(2849),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2849),
    [sym_super] = ACTIONS(2849),
    [sym_crate] = ACTIONS(2849),
    [sym_metavariable] = ACTIONS(2847),
    [sym__raw_string_literal_start] = ACTIONS(2847),
    [sym_float_literal] = ACTIONS(2847),
  },
  [736] = {
    [sym_line_comment] = STATE(736),
    [sym_block_comment] = STATE(736),
    [ts_builtin_sym_end] = ACTIONS(2851),
    [sym_identifier] = ACTIONS(2853),
    [anon_sym_SEMI] = ACTIONS(2851),
    [anon_sym_macro_rules_BANG] = ACTIONS(2851),
    [anon_sym_LPAREN] = ACTIONS(2851),
    [anon_sym_LBRACK] = ACTIONS(2851),
    [anon_sym_LBRACE] = ACTIONS(2851),
    [anon_sym_RBRACE] = ACTIONS(2851),
    [anon_sym_STAR] = ACTIONS(2851),
    [anon_sym_u8] = ACTIONS(2853),
    [anon_sym_i8] = ACTIONS(2853),
    [anon_sym_u16] = ACTIONS(2853),
    [anon_sym_i16] = ACTIONS(2853),
    [anon_sym_u32] = ACTIONS(2853),
    [anon_sym_i32] = ACTIONS(2853),
    [anon_sym_u64] = ACTIONS(2853),
    [anon_sym_i64] = ACTIONS(2853),
    [anon_sym_u128] = ACTIONS(2853),
    [anon_sym_i128] = ACTIONS(2853),
    [anon_sym_isize] = ACTIONS(2853),
    [anon_sym_usize] = ACTIONS(2853),
    [anon_sym_f32] = ACTIONS(2853),
    [anon_sym_f64] = ACTIONS(2853),
    [anon_sym_bool] = ACTIONS(2853),
    [anon_sym_str] = ACTIONS(2853),
    [anon_sym_char] = ACTIONS(2853),
    [anon_sym_DASH] = ACTIONS(2851),
    [anon_sym_BANG] = ACTIONS(2851),
    [anon_sym_AMP] = ACTIONS(2851),
    [anon_sym_PIPE] = ACTIONS(2851),
    [anon_sym_LT] = ACTIONS(2851),
    [anon_sym_DOT_DOT] = ACTIONS(2851),
    [anon_sym_COLON_COLON] = ACTIONS(2851),
    [anon_sym_POUND] = ACTIONS(2851),
    [anon_sym_SQUOTE] = ACTIONS(2853),
    [anon_sym_async] = ACTIONS(2853),
    [anon_sym_break] = ACTIONS(2853),
    [anon_sym_const] = ACTIONS(2853),
    [anon_sym_continue] = ACTIONS(2853),
    [anon_sym_default] = ACTIONS(2853),
    [anon_sym_enum] = ACTIONS(2853),
    [anon_sym_fn] = ACTIONS(2853),
    [anon_sym_for] = ACTIONS(2853),
    [anon_sym_if] = ACTIONS(2853),
    [anon_sym_impl] = ACTIONS(2853),
    [anon_sym_let] = ACTIONS(2853),
    [anon_sym_loop] = ACTIONS(2853),
    [anon_sym_match] = ACTIONS(2853),
    [anon_sym_mod] = ACTIONS(2853),
    [anon_sym_pub] = ACTIONS(2853),
    [anon_sym_return] = ACTIONS(2853),
    [anon_sym_static] = ACTIONS(2853),
    [anon_sym_struct] = ACTIONS(2853),
    [anon_sym_trait] = ACTIONS(2853),
    [anon_sym_type] = ACTIONS(2853),
    [anon_sym_union] = ACTIONS(2853),
    [anon_sym_unsafe] = ACTIONS(2853),
    [anon_sym_use] = ACTIONS(2853),
    [anon_sym_while] = ACTIONS(2853),
    [anon_sym_extern] = ACTIONS(2853),
    [anon_sym_yield] = ACTIONS(2853),
    [anon_sym_move] = ACTIONS(2853),
    [anon_sym_try] = ACTIONS(2853),
    [sym_integer_literal] = ACTIONS(2851),
    [aux_sym_string_literal_token1] = ACTIONS(2851),
    [sym_char_literal] = ACTIONS(2851),
    [anon_sym_true] = ACTIONS(2853),
    [anon_sym_false] = ACTIONS(2853),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2853),
    [sym_super] = ACTIONS(2853),
    [sym_crate] = ACTIONS(2853),
    [sym_metavariable] = ACTIONS(2851),
    [sym__raw_string_literal_start] = ACTIONS(2851),
    [sym_float_literal] = ACTIONS(2851),
  },
  [737] = {
    [sym_line_comment] = STATE(737),
    [sym_block_comment] = STATE(737),
    [ts_builtin_sym_end] = ACTIONS(2855),
    [sym_identifier] = ACTIONS(2857),
    [anon_sym_SEMI] = ACTIONS(2855),
    [anon_sym_macro_rules_BANG] = ACTIONS(2855),
    [anon_sym_LPAREN] = ACTIONS(2855),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_LBRACE] = ACTIONS(2855),
    [anon_sym_RBRACE] = ACTIONS(2855),
    [anon_sym_STAR] = ACTIONS(2855),
    [anon_sym_u8] = ACTIONS(2857),
    [anon_sym_i8] = ACTIONS(2857),
    [anon_sym_u16] = ACTIONS(2857),
    [anon_sym_i16] = ACTIONS(2857),
    [anon_sym_u32] = ACTIONS(2857),
    [anon_sym_i32] = ACTIONS(2857),
    [anon_sym_u64] = ACTIONS(2857),
    [anon_sym_i64] = ACTIONS(2857),
    [anon_sym_u128] = ACTIONS(2857),
    [anon_sym_i128] = ACTIONS(2857),
    [anon_sym_isize] = ACTIONS(2857),
    [anon_sym_usize] = ACTIONS(2857),
    [anon_sym_f32] = ACTIONS(2857),
    [anon_sym_f64] = ACTIONS(2857),
    [anon_sym_bool] = ACTIONS(2857),
    [anon_sym_str] = ACTIONS(2857),
    [anon_sym_char] = ACTIONS(2857),
    [anon_sym_DASH] = ACTIONS(2855),
    [anon_sym_BANG] = ACTIONS(2855),
    [anon_sym_AMP] = ACTIONS(2855),
    [anon_sym_PIPE] = ACTIONS(2855),
    [anon_sym_LT] = ACTIONS(2855),
    [anon_sym_DOT_DOT] = ACTIONS(2855),
    [anon_sym_COLON_COLON] = ACTIONS(2855),
    [anon_sym_POUND] = ACTIONS(2855),
    [anon_sym_SQUOTE] = ACTIONS(2857),
    [anon_sym_async] = ACTIONS(2857),
    [anon_sym_break] = ACTIONS(2857),
    [anon_sym_const] = ACTIONS(2857),
    [anon_sym_continue] = ACTIONS(2857),
    [anon_sym_default] = ACTIONS(2857),
    [anon_sym_enum] = ACTIONS(2857),
    [anon_sym_fn] = ACTIONS(2857),
    [anon_sym_for] = ACTIONS(2857),
    [anon_sym_if] = ACTIONS(2857),
    [anon_sym_impl] = ACTIONS(2857),
    [anon_sym_let] = ACTIONS(2857),
    [anon_sym_loop] = ACTIONS(2857),
    [anon_sym_match] = ACTIONS(2857),
    [anon_sym_mod] = ACTIONS(2857),
    [anon_sym_pub] = ACTIONS(2857),
    [anon_sym_return] = ACTIONS(2857),
    [anon_sym_static] = ACTIONS(2857),
    [anon_sym_struct] = ACTIONS(2857),
    [anon_sym_trait] = ACTIONS(2857),
    [anon_sym_type] = ACTIONS(2857),
    [anon_sym_union] = ACTIONS(2857),
    [anon_sym_unsafe] = ACTIONS(2857),
    [anon_sym_use] = ACTIONS(2857),
    [anon_sym_while] = ACTIONS(2857),
    [anon_sym_extern] = ACTIONS(2857),
    [anon_sym_yield] = ACTIONS(2857),
    [anon_sym_move] = ACTIONS(2857),
    [anon_sym_try] = ACTIONS(2857),
    [sym_integer_literal] = ACTIONS(2855),
    [aux_sym_string_literal_token1] = ACTIONS(2855),
    [sym_char_literal] = ACTIONS(2855),
    [anon_sym_true] = ACTIONS(2857),
    [anon_sym_false] = ACTIONS(2857),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2857),
    [sym_super] = ACTIONS(2857),
    [sym_crate] = ACTIONS(2857),
    [sym_metavariable] = ACTIONS(2855),
    [sym__raw_string_literal_start] = ACTIONS(2855),
    [sym_float_literal] = ACTIONS(2855),
  },
  [738] = {
    [sym_line_comment] = STATE(738),
    [sym_block_comment] = STATE(738),
    [ts_builtin_sym_end] = ACTIONS(2859),
    [sym_identifier] = ACTIONS(2861),
    [anon_sym_SEMI] = ACTIONS(2859),
    [anon_sym_macro_rules_BANG] = ACTIONS(2859),
    [anon_sym_LPAREN] = ACTIONS(2859),
    [anon_sym_LBRACK] = ACTIONS(2859),
    [anon_sym_LBRACE] = ACTIONS(2859),
    [anon_sym_RBRACE] = ACTIONS(2859),
    [anon_sym_STAR] = ACTIONS(2859),
    [anon_sym_u8] = ACTIONS(2861),
    [anon_sym_i8] = ACTIONS(2861),
    [anon_sym_u16] = ACTIONS(2861),
    [anon_sym_i16] = ACTIONS(2861),
    [anon_sym_u32] = ACTIONS(2861),
    [anon_sym_i32] = ACTIONS(2861),
    [anon_sym_u64] = ACTIONS(2861),
    [anon_sym_i64] = ACTIONS(2861),
    [anon_sym_u128] = ACTIONS(2861),
    [anon_sym_i128] = ACTIONS(2861),
    [anon_sym_isize] = ACTIONS(2861),
    [anon_sym_usize] = ACTIONS(2861),
    [anon_sym_f32] = ACTIONS(2861),
    [anon_sym_f64] = ACTIONS(2861),
    [anon_sym_bool] = ACTIONS(2861),
    [anon_sym_str] = ACTIONS(2861),
    [anon_sym_char] = ACTIONS(2861),
    [anon_sym_DASH] = ACTIONS(2859),
    [anon_sym_BANG] = ACTIONS(2859),
    [anon_sym_AMP] = ACTIONS(2859),
    [anon_sym_PIPE] = ACTIONS(2859),
    [anon_sym_LT] = ACTIONS(2859),
    [anon_sym_DOT_DOT] = ACTIONS(2859),
    [anon_sym_COLON_COLON] = ACTIONS(2859),
    [anon_sym_POUND] = ACTIONS(2859),
    [anon_sym_SQUOTE] = ACTIONS(2861),
    [anon_sym_async] = ACTIONS(2861),
    [anon_sym_break] = ACTIONS(2861),
    [anon_sym_const] = ACTIONS(2861),
    [anon_sym_continue] = ACTIONS(2861),
    [anon_sym_default] = ACTIONS(2861),
    [anon_sym_enum] = ACTIONS(2861),
    [anon_sym_fn] = ACTIONS(2861),
    [anon_sym_for] = ACTIONS(2861),
    [anon_sym_if] = ACTIONS(2861),
    [anon_sym_impl] = ACTIONS(2861),
    [anon_sym_let] = ACTIONS(2861),
    [anon_sym_loop] = ACTIONS(2861),
    [anon_sym_match] = ACTIONS(2861),
    [anon_sym_mod] = ACTIONS(2861),
    [anon_sym_pub] = ACTIONS(2861),
    [anon_sym_return] = ACTIONS(2861),
    [anon_sym_static] = ACTIONS(2861),
    [anon_sym_struct] = ACTIONS(2861),
    [anon_sym_trait] = ACTIONS(2861),
    [anon_sym_type] = ACTIONS(2861),
    [anon_sym_union] = ACTIONS(2861),
    [anon_sym_unsafe] = ACTIONS(2861),
    [anon_sym_use] = ACTIONS(2861),
    [anon_sym_while] = ACTIONS(2861),
    [anon_sym_extern] = ACTIONS(2861),
    [anon_sym_yield] = ACTIONS(2861),
    [anon_sym_move] = ACTIONS(2861),
    [anon_sym_try] = ACTIONS(2861),
    [sym_integer_literal] = ACTIONS(2859),
    [aux_sym_string_literal_token1] = ACTIONS(2859),
    [sym_char_literal] = ACTIONS(2859),
    [anon_sym_true] = ACTIONS(2861),
    [anon_sym_false] = ACTIONS(2861),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2861),
    [sym_super] = ACTIONS(2861),
    [sym_crate] = ACTIONS(2861),
    [sym_metavariable] = ACTIONS(2859),
    [sym__raw_string_literal_start] = ACTIONS(2859),
    [sym_float_literal] = ACTIONS(2859),
  },
  [739] = {
    [sym_line_comment] = STATE(739),
    [sym_block_comment] = STATE(739),
    [ts_builtin_sym_end] = ACTIONS(2863),
    [sym_identifier] = ACTIONS(2865),
    [anon_sym_SEMI] = ACTIONS(2863),
    [anon_sym_macro_rules_BANG] = ACTIONS(2863),
    [anon_sym_LPAREN] = ACTIONS(2863),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [anon_sym_LBRACE] = ACTIONS(2863),
    [anon_sym_RBRACE] = ACTIONS(2863),
    [anon_sym_STAR] = ACTIONS(2863),
    [anon_sym_u8] = ACTIONS(2865),
    [anon_sym_i8] = ACTIONS(2865),
    [anon_sym_u16] = ACTIONS(2865),
    [anon_sym_i16] = ACTIONS(2865),
    [anon_sym_u32] = ACTIONS(2865),
    [anon_sym_i32] = ACTIONS(2865),
    [anon_sym_u64] = ACTIONS(2865),
    [anon_sym_i64] = ACTIONS(2865),
    [anon_sym_u128] = ACTIONS(2865),
    [anon_sym_i128] = ACTIONS(2865),
    [anon_sym_isize] = ACTIONS(2865),
    [anon_sym_usize] = ACTIONS(2865),
    [anon_sym_f32] = ACTIONS(2865),
    [anon_sym_f64] = ACTIONS(2865),
    [anon_sym_bool] = ACTIONS(2865),
    [anon_sym_str] = ACTIONS(2865),
    [anon_sym_char] = ACTIONS(2865),
    [anon_sym_DASH] = ACTIONS(2863),
    [anon_sym_BANG] = ACTIONS(2863),
    [anon_sym_AMP] = ACTIONS(2863),
    [anon_sym_PIPE] = ACTIONS(2863),
    [anon_sym_LT] = ACTIONS(2863),
    [anon_sym_DOT_DOT] = ACTIONS(2863),
    [anon_sym_COLON_COLON] = ACTIONS(2863),
    [anon_sym_POUND] = ACTIONS(2863),
    [anon_sym_SQUOTE] = ACTIONS(2865),
    [anon_sym_async] = ACTIONS(2865),
    [anon_sym_break] = ACTIONS(2865),
    [anon_sym_const] = ACTIONS(2865),
    [anon_sym_continue] = ACTIONS(2865),
    [anon_sym_default] = ACTIONS(2865),
    [anon_sym_enum] = ACTIONS(2865),
    [anon_sym_fn] = ACTIONS(2865),
    [anon_sym_for] = ACTIONS(2865),
    [anon_sym_if] = ACTIONS(2865),
    [anon_sym_impl] = ACTIONS(2865),
    [anon_sym_let] = ACTIONS(2865),
    [anon_sym_loop] = ACTIONS(2865),
    [anon_sym_match] = ACTIONS(2865),
    [anon_sym_mod] = ACTIONS(2865),
    [anon_sym_pub] = ACTIONS(2865),
    [anon_sym_return] = ACTIONS(2865),
    [anon_sym_static] = ACTIONS(2865),
    [anon_sym_struct] = ACTIONS(2865),
    [anon_sym_trait] = ACTIONS(2865),
    [anon_sym_type] = ACTIONS(2865),
    [anon_sym_union] = ACTIONS(2865),
    [anon_sym_unsafe] = ACTIONS(2865),
    [anon_sym_use] = ACTIONS(2865),
    [anon_sym_while] = ACTIONS(2865),
    [anon_sym_extern] = ACTIONS(2865),
    [anon_sym_yield] = ACTIONS(2865),
    [anon_sym_move] = ACTIONS(2865),
    [anon_sym_try] = ACTIONS(2865),
    [sym_integer_literal] = ACTIONS(2863),
    [aux_sym_string_literal_token1] = ACTIONS(2863),
    [sym_char_literal] = ACTIONS(2863),
    [anon_sym_true] = ACTIONS(2865),
    [anon_sym_false] = ACTIONS(2865),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2865),
    [sym_super] = ACTIONS(2865),
    [sym_crate] = ACTIONS(2865),
    [sym_metavariable] = ACTIONS(2863),
    [sym__raw_string_literal_start] = ACTIONS(2863),
    [sym_float_literal] = ACTIONS(2863),
  },
  [740] = {
    [sym_line_comment] = STATE(740),
    [sym_block_comment] = STATE(740),
    [ts_builtin_sym_end] = ACTIONS(2867),
    [sym_identifier] = ACTIONS(2869),
    [anon_sym_SEMI] = ACTIONS(2867),
    [anon_sym_macro_rules_BANG] = ACTIONS(2867),
    [anon_sym_LPAREN] = ACTIONS(2867),
    [anon_sym_LBRACK] = ACTIONS(2867),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_RBRACE] = ACTIONS(2867),
    [anon_sym_STAR] = ACTIONS(2867),
    [anon_sym_u8] = ACTIONS(2869),
    [anon_sym_i8] = ACTIONS(2869),
    [anon_sym_u16] = ACTIONS(2869),
    [anon_sym_i16] = ACTIONS(2869),
    [anon_sym_u32] = ACTIONS(2869),
    [anon_sym_i32] = ACTIONS(2869),
    [anon_sym_u64] = ACTIONS(2869),
    [anon_sym_i64] = ACTIONS(2869),
    [anon_sym_u128] = ACTIONS(2869),
    [anon_sym_i128] = ACTIONS(2869),
    [anon_sym_isize] = ACTIONS(2869),
    [anon_sym_usize] = ACTIONS(2869),
    [anon_sym_f32] = ACTIONS(2869),
    [anon_sym_f64] = ACTIONS(2869),
    [anon_sym_bool] = ACTIONS(2869),
    [anon_sym_str] = ACTIONS(2869),
    [anon_sym_char] = ACTIONS(2869),
    [anon_sym_DASH] = ACTIONS(2867),
    [anon_sym_BANG] = ACTIONS(2867),
    [anon_sym_AMP] = ACTIONS(2867),
    [anon_sym_PIPE] = ACTIONS(2867),
    [anon_sym_LT] = ACTIONS(2867),
    [anon_sym_DOT_DOT] = ACTIONS(2867),
    [anon_sym_COLON_COLON] = ACTIONS(2867),
    [anon_sym_POUND] = ACTIONS(2867),
    [anon_sym_SQUOTE] = ACTIONS(2869),
    [anon_sym_async] = ACTIONS(2869),
    [anon_sym_break] = ACTIONS(2869),
    [anon_sym_const] = ACTIONS(2869),
    [anon_sym_continue] = ACTIONS(2869),
    [anon_sym_default] = ACTIONS(2869),
    [anon_sym_enum] = ACTIONS(2869),
    [anon_sym_fn] = ACTIONS(2869),
    [anon_sym_for] = ACTIONS(2869),
    [anon_sym_if] = ACTIONS(2869),
    [anon_sym_impl] = ACTIONS(2869),
    [anon_sym_let] = ACTIONS(2869),
    [anon_sym_loop] = ACTIONS(2869),
    [anon_sym_match] = ACTIONS(2869),
    [anon_sym_mod] = ACTIONS(2869),
    [anon_sym_pub] = ACTIONS(2869),
    [anon_sym_return] = ACTIONS(2869),
    [anon_sym_static] = ACTIONS(2869),
    [anon_sym_struct] = ACTIONS(2869),
    [anon_sym_trait] = ACTIONS(2869),
    [anon_sym_type] = ACTIONS(2869),
    [anon_sym_union] = ACTIONS(2869),
    [anon_sym_unsafe] = ACTIONS(2869),
    [anon_sym_use] = ACTIONS(2869),
    [anon_sym_while] = ACTIONS(2869),
    [anon_sym_extern] = ACTIONS(2869),
    [anon_sym_yield] = ACTIONS(2869),
    [anon_sym_move] = ACTIONS(2869),
    [anon_sym_try] = ACTIONS(2869),
    [sym_integer_literal] = ACTIONS(2867),
    [aux_sym_string_literal_token1] = ACTIONS(2867),
    [sym_char_literal] = ACTIONS(2867),
    [anon_sym_true] = ACTIONS(2869),
    [anon_sym_false] = ACTIONS(2869),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2869),
    [sym_super] = ACTIONS(2869),
    [sym_crate] = ACTIONS(2869),
    [sym_metavariable] = ACTIONS(2867),
    [sym__raw_string_literal_start] = ACTIONS(2867),
    [sym_float_literal] = ACTIONS(2867),
  },
  [741] = {
    [sym_line_comment] = STATE(741),
    [sym_block_comment] = STATE(741),
    [ts_builtin_sym_end] = ACTIONS(2871),
    [sym_identifier] = ACTIONS(2873),
    [anon_sym_SEMI] = ACTIONS(2871),
    [anon_sym_macro_rules_BANG] = ACTIONS(2871),
    [anon_sym_LPAREN] = ACTIONS(2871),
    [anon_sym_LBRACK] = ACTIONS(2871),
    [anon_sym_LBRACE] = ACTIONS(2871),
    [anon_sym_RBRACE] = ACTIONS(2871),
    [anon_sym_STAR] = ACTIONS(2871),
    [anon_sym_u8] = ACTIONS(2873),
    [anon_sym_i8] = ACTIONS(2873),
    [anon_sym_u16] = ACTIONS(2873),
    [anon_sym_i16] = ACTIONS(2873),
    [anon_sym_u32] = ACTIONS(2873),
    [anon_sym_i32] = ACTIONS(2873),
    [anon_sym_u64] = ACTIONS(2873),
    [anon_sym_i64] = ACTIONS(2873),
    [anon_sym_u128] = ACTIONS(2873),
    [anon_sym_i128] = ACTIONS(2873),
    [anon_sym_isize] = ACTIONS(2873),
    [anon_sym_usize] = ACTIONS(2873),
    [anon_sym_f32] = ACTIONS(2873),
    [anon_sym_f64] = ACTIONS(2873),
    [anon_sym_bool] = ACTIONS(2873),
    [anon_sym_str] = ACTIONS(2873),
    [anon_sym_char] = ACTIONS(2873),
    [anon_sym_DASH] = ACTIONS(2871),
    [anon_sym_BANG] = ACTIONS(2871),
    [anon_sym_AMP] = ACTIONS(2871),
    [anon_sym_PIPE] = ACTIONS(2871),
    [anon_sym_LT] = ACTIONS(2871),
    [anon_sym_DOT_DOT] = ACTIONS(2871),
    [anon_sym_COLON_COLON] = ACTIONS(2871),
    [anon_sym_POUND] = ACTIONS(2871),
    [anon_sym_SQUOTE] = ACTIONS(2873),
    [anon_sym_async] = ACTIONS(2873),
    [anon_sym_break] = ACTIONS(2873),
    [anon_sym_const] = ACTIONS(2873),
    [anon_sym_continue] = ACTIONS(2873),
    [anon_sym_default] = ACTIONS(2873),
    [anon_sym_enum] = ACTIONS(2873),
    [anon_sym_fn] = ACTIONS(2873),
    [anon_sym_for] = ACTIONS(2873),
    [anon_sym_if] = ACTIONS(2873),
    [anon_sym_impl] = ACTIONS(2873),
    [anon_sym_let] = ACTIONS(2873),
    [anon_sym_loop] = ACTIONS(2873),
    [anon_sym_match] = ACTIONS(2873),
    [anon_sym_mod] = ACTIONS(2873),
    [anon_sym_pub] = ACTIONS(2873),
    [anon_sym_return] = ACTIONS(2873),
    [anon_sym_static] = ACTIONS(2873),
    [anon_sym_struct] = ACTIONS(2873),
    [anon_sym_trait] = ACTIONS(2873),
    [anon_sym_type] = ACTIONS(2873),
    [anon_sym_union] = ACTIONS(2873),
    [anon_sym_unsafe] = ACTIONS(2873),
    [anon_sym_use] = ACTIONS(2873),
    [anon_sym_while] = ACTIONS(2873),
    [anon_sym_extern] = ACTIONS(2873),
    [anon_sym_yield] = ACTIONS(2873),
    [anon_sym_move] = ACTIONS(2873),
    [anon_sym_try] = ACTIONS(2873),
    [sym_integer_literal] = ACTIONS(2871),
    [aux_sym_string_literal_token1] = ACTIONS(2871),
    [sym_char_literal] = ACTIONS(2871),
    [anon_sym_true] = ACTIONS(2873),
    [anon_sym_false] = ACTIONS(2873),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2873),
    [sym_super] = ACTIONS(2873),
    [sym_crate] = ACTIONS(2873),
    [sym_metavariable] = ACTIONS(2871),
    [sym__raw_string_literal_start] = ACTIONS(2871),
    [sym_float_literal] = ACTIONS(2871),
  },
  [742] = {
    [sym_line_comment] = STATE(742),
    [sym_block_comment] = STATE(742),
    [ts_builtin_sym_end] = ACTIONS(2875),
    [sym_identifier] = ACTIONS(2877),
    [anon_sym_SEMI] = ACTIONS(2875),
    [anon_sym_macro_rules_BANG] = ACTIONS(2875),
    [anon_sym_LPAREN] = ACTIONS(2875),
    [anon_sym_LBRACK] = ACTIONS(2875),
    [anon_sym_LBRACE] = ACTIONS(2875),
    [anon_sym_RBRACE] = ACTIONS(2875),
    [anon_sym_STAR] = ACTIONS(2875),
    [anon_sym_u8] = ACTIONS(2877),
    [anon_sym_i8] = ACTIONS(2877),
    [anon_sym_u16] = ACTIONS(2877),
    [anon_sym_i16] = ACTIONS(2877),
    [anon_sym_u32] = ACTIONS(2877),
    [anon_sym_i32] = ACTIONS(2877),
    [anon_sym_u64] = ACTIONS(2877),
    [anon_sym_i64] = ACTIONS(2877),
    [anon_sym_u128] = ACTIONS(2877),
    [anon_sym_i128] = ACTIONS(2877),
    [anon_sym_isize] = ACTIONS(2877),
    [anon_sym_usize] = ACTIONS(2877),
    [anon_sym_f32] = ACTIONS(2877),
    [anon_sym_f64] = ACTIONS(2877),
    [anon_sym_bool] = ACTIONS(2877),
    [anon_sym_str] = ACTIONS(2877),
    [anon_sym_char] = ACTIONS(2877),
    [anon_sym_DASH] = ACTIONS(2875),
    [anon_sym_BANG] = ACTIONS(2875),
    [anon_sym_AMP] = ACTIONS(2875),
    [anon_sym_PIPE] = ACTIONS(2875),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_DOT_DOT] = ACTIONS(2875),
    [anon_sym_COLON_COLON] = ACTIONS(2875),
    [anon_sym_POUND] = ACTIONS(2875),
    [anon_sym_SQUOTE] = ACTIONS(2877),
    [anon_sym_async] = ACTIONS(2877),
    [anon_sym_break] = ACTIONS(2877),
    [anon_sym_const] = ACTIONS(2877),
    [anon_sym_continue] = ACTIONS(2877),
    [anon_sym_default] = ACTIONS(2877),
    [anon_sym_enum] = ACTIONS(2877),
    [anon_sym_fn] = ACTIONS(2877),
    [anon_sym_for] = ACTIONS(2877),
    [anon_sym_if] = ACTIONS(2877),
    [anon_sym_impl] = ACTIONS(2877),
    [anon_sym_let] = ACTIONS(2877),
    [anon_sym_loop] = ACTIONS(2877),
    [anon_sym_match] = ACTIONS(2877),
    [anon_sym_mod] = ACTIONS(2877),
    [anon_sym_pub] = ACTIONS(2877),
    [anon_sym_return] = ACTIONS(2877),
    [anon_sym_static] = ACTIONS(2877),
    [anon_sym_struct] = ACTIONS(2877),
    [anon_sym_trait] = ACTIONS(2877),
    [anon_sym_type] = ACTIONS(2877),
    [anon_sym_union] = ACTIONS(2877),
    [anon_sym_unsafe] = ACTIONS(2877),
    [anon_sym_use] = ACTIONS(2877),
    [anon_sym_while] = ACTIONS(2877),
    [anon_sym_extern] = ACTIONS(2877),
    [anon_sym_yield] = ACTIONS(2877),
    [anon_sym_move] = ACTIONS(2877),
    [anon_sym_try] = ACTIONS(2877),
    [sym_integer_literal] = ACTIONS(2875),
    [aux_sym_string_literal_token1] = ACTIONS(2875),
    [sym_char_literal] = ACTIONS(2875),
    [anon_sym_true] = ACTIONS(2877),
    [anon_sym_false] = ACTIONS(2877),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2877),
    [sym_super] = ACTIONS(2877),
    [sym_crate] = ACTIONS(2877),
    [sym_metavariable] = ACTIONS(2875),
    [sym__raw_string_literal_start] = ACTIONS(2875),
    [sym_float_literal] = ACTIONS(2875),
  },
  [743] = {
    [sym_line_comment] = STATE(743),
    [sym_block_comment] = STATE(743),
    [ts_builtin_sym_end] = ACTIONS(2879),
    [sym_identifier] = ACTIONS(2881),
    [anon_sym_SEMI] = ACTIONS(2879),
    [anon_sym_macro_rules_BANG] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(2879),
    [anon_sym_LBRACK] = ACTIONS(2879),
    [anon_sym_LBRACE] = ACTIONS(2879),
    [anon_sym_RBRACE] = ACTIONS(2879),
    [anon_sym_STAR] = ACTIONS(2879),
    [anon_sym_u8] = ACTIONS(2881),
    [anon_sym_i8] = ACTIONS(2881),
    [anon_sym_u16] = ACTIONS(2881),
    [anon_sym_i16] = ACTIONS(2881),
    [anon_sym_u32] = ACTIONS(2881),
    [anon_sym_i32] = ACTIONS(2881),
    [anon_sym_u64] = ACTIONS(2881),
    [anon_sym_i64] = ACTIONS(2881),
    [anon_sym_u128] = ACTIONS(2881),
    [anon_sym_i128] = ACTIONS(2881),
    [anon_sym_isize] = ACTIONS(2881),
    [anon_sym_usize] = ACTIONS(2881),
    [anon_sym_f32] = ACTIONS(2881),
    [anon_sym_f64] = ACTIONS(2881),
    [anon_sym_bool] = ACTIONS(2881),
    [anon_sym_str] = ACTIONS(2881),
    [anon_sym_char] = ACTIONS(2881),
    [anon_sym_DASH] = ACTIONS(2879),
    [anon_sym_BANG] = ACTIONS(2879),
    [anon_sym_AMP] = ACTIONS(2879),
    [anon_sym_PIPE] = ACTIONS(2879),
    [anon_sym_LT] = ACTIONS(2879),
    [anon_sym_DOT_DOT] = ACTIONS(2879),
    [anon_sym_COLON_COLON] = ACTIONS(2879),
    [anon_sym_POUND] = ACTIONS(2879),
    [anon_sym_SQUOTE] = ACTIONS(2881),
    [anon_sym_async] = ACTIONS(2881),
    [anon_sym_break] = ACTIONS(2881),
    [anon_sym_const] = ACTIONS(2881),
    [anon_sym_continue] = ACTIONS(2881),
    [anon_sym_default] = ACTIONS(2881),
    [anon_sym_enum] = ACTIONS(2881),
    [anon_sym_fn] = ACTIONS(2881),
    [anon_sym_for] = ACTIONS(2881),
    [anon_sym_if] = ACTIONS(2881),
    [anon_sym_impl] = ACTIONS(2881),
    [anon_sym_let] = ACTIONS(2881),
    [anon_sym_loop] = ACTIONS(2881),
    [anon_sym_match] = ACTIONS(2881),
    [anon_sym_mod] = ACTIONS(2881),
    [anon_sym_pub] = ACTIONS(2881),
    [anon_sym_return] = ACTIONS(2881),
    [anon_sym_static] = ACTIONS(2881),
    [anon_sym_struct] = ACTIONS(2881),
    [anon_sym_trait] = ACTIONS(2881),
    [anon_sym_type] = ACTIONS(2881),
    [anon_sym_union] = ACTIONS(2881),
    [anon_sym_unsafe] = ACTIONS(2881),
    [anon_sym_use] = ACTIONS(2881),
    [anon_sym_while] = ACTIONS(2881),
    [anon_sym_extern] = ACTIONS(2881),
    [anon_sym_yield] = ACTIONS(2881),
    [anon_sym_move] = ACTIONS(2881),
    [anon_sym_try] = ACTIONS(2881),
    [sym_integer_literal] = ACTIONS(2879),
    [aux_sym_string_literal_token1] = ACTIONS(2879),
    [sym_char_literal] = ACTIONS(2879),
    [anon_sym_true] = ACTIONS(2881),
    [anon_sym_false] = ACTIONS(2881),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2881),
    [sym_super] = ACTIONS(2881),
    [sym_crate] = ACTIONS(2881),
    [sym_metavariable] = ACTIONS(2879),
    [sym__raw_string_literal_start] = ACTIONS(2879),
    [sym_float_literal] = ACTIONS(2879),
  },
  [744] = {
    [sym_line_comment] = STATE(744),
    [sym_block_comment] = STATE(744),
    [ts_builtin_sym_end] = ACTIONS(1442),
    [sym_identifier] = ACTIONS(1444),
    [anon_sym_SEMI] = ACTIONS(1442),
    [anon_sym_macro_rules_BANG] = ACTIONS(1442),
    [anon_sym_LPAREN] = ACTIONS(1442),
    [anon_sym_LBRACK] = ACTIONS(1442),
    [anon_sym_LBRACE] = ACTIONS(1442),
    [anon_sym_RBRACE] = ACTIONS(1442),
    [anon_sym_STAR] = ACTIONS(1442),
    [anon_sym_u8] = ACTIONS(1444),
    [anon_sym_i8] = ACTIONS(1444),
    [anon_sym_u16] = ACTIONS(1444),
    [anon_sym_i16] = ACTIONS(1444),
    [anon_sym_u32] = ACTIONS(1444),
    [anon_sym_i32] = ACTIONS(1444),
    [anon_sym_u64] = ACTIONS(1444),
    [anon_sym_i64] = ACTIONS(1444),
    [anon_sym_u128] = ACTIONS(1444),
    [anon_sym_i128] = ACTIONS(1444),
    [anon_sym_isize] = ACTIONS(1444),
    [anon_sym_usize] = ACTIONS(1444),
    [anon_sym_f32] = ACTIONS(1444),
    [anon_sym_f64] = ACTIONS(1444),
    [anon_sym_bool] = ACTIONS(1444),
    [anon_sym_str] = ACTIONS(1444),
    [anon_sym_char] = ACTIONS(1444),
    [anon_sym_DASH] = ACTIONS(1442),
    [anon_sym_BANG] = ACTIONS(1442),
    [anon_sym_AMP] = ACTIONS(1442),
    [anon_sym_PIPE] = ACTIONS(1442),
    [anon_sym_LT] = ACTIONS(1442),
    [anon_sym_DOT_DOT] = ACTIONS(1442),
    [anon_sym_COLON_COLON] = ACTIONS(1442),
    [anon_sym_POUND] = ACTIONS(1442),
    [anon_sym_SQUOTE] = ACTIONS(1444),
    [anon_sym_async] = ACTIONS(1444),
    [anon_sym_break] = ACTIONS(1444),
    [anon_sym_const] = ACTIONS(1444),
    [anon_sym_continue] = ACTIONS(1444),
    [anon_sym_default] = ACTIONS(1444),
    [anon_sym_enum] = ACTIONS(1444),
    [anon_sym_fn] = ACTIONS(1444),
    [anon_sym_for] = ACTIONS(1444),
    [anon_sym_if] = ACTIONS(1444),
    [anon_sym_impl] = ACTIONS(1444),
    [anon_sym_let] = ACTIONS(1444),
    [anon_sym_loop] = ACTIONS(1444),
    [anon_sym_match] = ACTIONS(1444),
    [anon_sym_mod] = ACTIONS(1444),
    [anon_sym_pub] = ACTIONS(1444),
    [anon_sym_return] = ACTIONS(1444),
    [anon_sym_static] = ACTIONS(1444),
    [anon_sym_struct] = ACTIONS(1444),
    [anon_sym_trait] = ACTIONS(1444),
    [anon_sym_type] = ACTIONS(1444),
    [anon_sym_union] = ACTIONS(1444),
    [anon_sym_unsafe] = ACTIONS(1444),
    [anon_sym_use] = ACTIONS(1444),
    [anon_sym_while] = ACTIONS(1444),
    [anon_sym_extern] = ACTIONS(1444),
    [anon_sym_yield] = ACTIONS(1444),
    [anon_sym_move] = ACTIONS(1444),
    [anon_sym_try] = ACTIONS(1444),
    [sym_integer_literal] = ACTIONS(1442),
    [aux_sym_string_literal_token1] = ACTIONS(1442),
    [sym_char_literal] = ACTIONS(1442),
    [anon_sym_true] = ACTIONS(1444),
    [anon_sym_false] = ACTIONS(1444),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1444),
    [sym_super] = ACTIONS(1444),
    [sym_crate] = ACTIONS(1444),
    [sym_metavariable] = ACTIONS(1442),
    [sym__raw_string_literal_start] = ACTIONS(1442),
    [sym_float_literal] = ACTIONS(1442),
  },
  [745] = {
    [sym_line_comment] = STATE(745),
    [sym_block_comment] = STATE(745),
    [ts_builtin_sym_end] = ACTIONS(2883),
    [sym_identifier] = ACTIONS(2885),
    [anon_sym_SEMI] = ACTIONS(2883),
    [anon_sym_macro_rules_BANG] = ACTIONS(2883),
    [anon_sym_LPAREN] = ACTIONS(2883),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_LBRACE] = ACTIONS(2883),
    [anon_sym_RBRACE] = ACTIONS(2883),
    [anon_sym_STAR] = ACTIONS(2883),
    [anon_sym_u8] = ACTIONS(2885),
    [anon_sym_i8] = ACTIONS(2885),
    [anon_sym_u16] = ACTIONS(2885),
    [anon_sym_i16] = ACTIONS(2885),
    [anon_sym_u32] = ACTIONS(2885),
    [anon_sym_i32] = ACTIONS(2885),
    [anon_sym_u64] = ACTIONS(2885),
    [anon_sym_i64] = ACTIONS(2885),
    [anon_sym_u128] = ACTIONS(2885),
    [anon_sym_i128] = ACTIONS(2885),
    [anon_sym_isize] = ACTIONS(2885),
    [anon_sym_usize] = ACTIONS(2885),
    [anon_sym_f32] = ACTIONS(2885),
    [anon_sym_f64] = ACTIONS(2885),
    [anon_sym_bool] = ACTIONS(2885),
    [anon_sym_str] = ACTIONS(2885),
    [anon_sym_char] = ACTIONS(2885),
    [anon_sym_DASH] = ACTIONS(2883),
    [anon_sym_BANG] = ACTIONS(2883),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_PIPE] = ACTIONS(2883),
    [anon_sym_LT] = ACTIONS(2883),
    [anon_sym_DOT_DOT] = ACTIONS(2883),
    [anon_sym_COLON_COLON] = ACTIONS(2883),
    [anon_sym_POUND] = ACTIONS(2883),
    [anon_sym_SQUOTE] = ACTIONS(2885),
    [anon_sym_async] = ACTIONS(2885),
    [anon_sym_break] = ACTIONS(2885),
    [anon_sym_const] = ACTIONS(2885),
    [anon_sym_continue] = ACTIONS(2885),
    [anon_sym_default] = ACTIONS(2885),
    [anon_sym_enum] = ACTIONS(2885),
    [anon_sym_fn] = ACTIONS(2885),
    [anon_sym_for] = ACTIONS(2885),
    [anon_sym_if] = ACTIONS(2885),
    [anon_sym_impl] = ACTIONS(2885),
    [anon_sym_let] = ACTIONS(2885),
    [anon_sym_loop] = ACTIONS(2885),
    [anon_sym_match] = ACTIONS(2885),
    [anon_sym_mod] = ACTIONS(2885),
    [anon_sym_pub] = ACTIONS(2885),
    [anon_sym_return] = ACTIONS(2885),
    [anon_sym_static] = ACTIONS(2885),
    [anon_sym_struct] = ACTIONS(2885),
    [anon_sym_trait] = ACTIONS(2885),
    [anon_sym_type] = ACTIONS(2885),
    [anon_sym_union] = ACTIONS(2885),
    [anon_sym_unsafe] = ACTIONS(2885),
    [anon_sym_use] = ACTIONS(2885),
    [anon_sym_while] = ACTIONS(2885),
    [anon_sym_extern] = ACTIONS(2885),
    [anon_sym_yield] = ACTIONS(2885),
    [anon_sym_move] = ACTIONS(2885),
    [anon_sym_try] = ACTIONS(2885),
    [sym_integer_literal] = ACTIONS(2883),
    [aux_sym_string_literal_token1] = ACTIONS(2883),
    [sym_char_literal] = ACTIONS(2883),
    [anon_sym_true] = ACTIONS(2885),
    [anon_sym_false] = ACTIONS(2885),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2885),
    [sym_super] = ACTIONS(2885),
    [sym_crate] = ACTIONS(2885),
    [sym_metavariable] = ACTIONS(2883),
    [sym__raw_string_literal_start] = ACTIONS(2883),
    [sym_float_literal] = ACTIONS(2883),
  },
  [746] = {
    [sym_line_comment] = STATE(746),
    [sym_block_comment] = STATE(746),
    [ts_builtin_sym_end] = ACTIONS(2887),
    [sym_identifier] = ACTIONS(2889),
    [anon_sym_SEMI] = ACTIONS(2887),
    [anon_sym_macro_rules_BANG] = ACTIONS(2887),
    [anon_sym_LPAREN] = ACTIONS(2887),
    [anon_sym_LBRACK] = ACTIONS(2887),
    [anon_sym_LBRACE] = ACTIONS(2887),
    [anon_sym_RBRACE] = ACTIONS(2887),
    [anon_sym_STAR] = ACTIONS(2887),
    [anon_sym_u8] = ACTIONS(2889),
    [anon_sym_i8] = ACTIONS(2889),
    [anon_sym_u16] = ACTIONS(2889),
    [anon_sym_i16] = ACTIONS(2889),
    [anon_sym_u32] = ACTIONS(2889),
    [anon_sym_i32] = ACTIONS(2889),
    [anon_sym_u64] = ACTIONS(2889),
    [anon_sym_i64] = ACTIONS(2889),
    [anon_sym_u128] = ACTIONS(2889),
    [anon_sym_i128] = ACTIONS(2889),
    [anon_sym_isize] = ACTIONS(2889),
    [anon_sym_usize] = ACTIONS(2889),
    [anon_sym_f32] = ACTIONS(2889),
    [anon_sym_f64] = ACTIONS(2889),
    [anon_sym_bool] = ACTIONS(2889),
    [anon_sym_str] = ACTIONS(2889),
    [anon_sym_char] = ACTIONS(2889),
    [anon_sym_DASH] = ACTIONS(2887),
    [anon_sym_BANG] = ACTIONS(2887),
    [anon_sym_AMP] = ACTIONS(2887),
    [anon_sym_PIPE] = ACTIONS(2887),
    [anon_sym_LT] = ACTIONS(2887),
    [anon_sym_DOT_DOT] = ACTIONS(2887),
    [anon_sym_COLON_COLON] = ACTIONS(2887),
    [anon_sym_POUND] = ACTIONS(2887),
    [anon_sym_SQUOTE] = ACTIONS(2889),
    [anon_sym_async] = ACTIONS(2889),
    [anon_sym_break] = ACTIONS(2889),
    [anon_sym_const] = ACTIONS(2889),
    [anon_sym_continue] = ACTIONS(2889),
    [anon_sym_default] = ACTIONS(2889),
    [anon_sym_enum] = ACTIONS(2889),
    [anon_sym_fn] = ACTIONS(2889),
    [anon_sym_for] = ACTIONS(2889),
    [anon_sym_if] = ACTIONS(2889),
    [anon_sym_impl] = ACTIONS(2889),
    [anon_sym_let] = ACTIONS(2889),
    [anon_sym_loop] = ACTIONS(2889),
    [anon_sym_match] = ACTIONS(2889),
    [anon_sym_mod] = ACTIONS(2889),
    [anon_sym_pub] = ACTIONS(2889),
    [anon_sym_return] = ACTIONS(2889),
    [anon_sym_static] = ACTIONS(2889),
    [anon_sym_struct] = ACTIONS(2889),
    [anon_sym_trait] = ACTIONS(2889),
    [anon_sym_type] = ACTIONS(2889),
    [anon_sym_union] = ACTIONS(2889),
    [anon_sym_unsafe] = ACTIONS(2889),
    [anon_sym_use] = ACTIONS(2889),
    [anon_sym_while] = ACTIONS(2889),
    [anon_sym_extern] = ACTIONS(2889),
    [anon_sym_yield] = ACTIONS(2889),
    [anon_sym_move] = ACTIONS(2889),
    [anon_sym_try] = ACTIONS(2889),
    [sym_integer_literal] = ACTIONS(2887),
    [aux_sym_string_literal_token1] = ACTIONS(2887),
    [sym_char_literal] = ACTIONS(2887),
    [anon_sym_true] = ACTIONS(2889),
    [anon_sym_false] = ACTIONS(2889),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2889),
    [sym_super] = ACTIONS(2889),
    [sym_crate] = ACTIONS(2889),
    [sym_metavariable] = ACTIONS(2887),
    [sym__raw_string_literal_start] = ACTIONS(2887),
    [sym_float_literal] = ACTIONS(2887),
  },
  [747] = {
    [sym_line_comment] = STATE(747),
    [sym_block_comment] = STATE(747),
    [ts_builtin_sym_end] = ACTIONS(2891),
    [sym_identifier] = ACTIONS(2893),
    [anon_sym_SEMI] = ACTIONS(2891),
    [anon_sym_macro_rules_BANG] = ACTIONS(2891),
    [anon_sym_LPAREN] = ACTIONS(2891),
    [anon_sym_LBRACK] = ACTIONS(2891),
    [anon_sym_LBRACE] = ACTIONS(2891),
    [anon_sym_RBRACE] = ACTIONS(2891),
    [anon_sym_STAR] = ACTIONS(2891),
    [anon_sym_u8] = ACTIONS(2893),
    [anon_sym_i8] = ACTIONS(2893),
    [anon_sym_u16] = ACTIONS(2893),
    [anon_sym_i16] = ACTIONS(2893),
    [anon_sym_u32] = ACTIONS(2893),
    [anon_sym_i32] = ACTIONS(2893),
    [anon_sym_u64] = ACTIONS(2893),
    [anon_sym_i64] = ACTIONS(2893),
    [anon_sym_u128] = ACTIONS(2893),
    [anon_sym_i128] = ACTIONS(2893),
    [anon_sym_isize] = ACTIONS(2893),
    [anon_sym_usize] = ACTIONS(2893),
    [anon_sym_f32] = ACTIONS(2893),
    [anon_sym_f64] = ACTIONS(2893),
    [anon_sym_bool] = ACTIONS(2893),
    [anon_sym_str] = ACTIONS(2893),
    [anon_sym_char] = ACTIONS(2893),
    [anon_sym_DASH] = ACTIONS(2891),
    [anon_sym_BANG] = ACTIONS(2891),
    [anon_sym_AMP] = ACTIONS(2891),
    [anon_sym_PIPE] = ACTIONS(2891),
    [anon_sym_LT] = ACTIONS(2891),
    [anon_sym_DOT_DOT] = ACTIONS(2891),
    [anon_sym_COLON_COLON] = ACTIONS(2891),
    [anon_sym_POUND] = ACTIONS(2891),
    [anon_sym_SQUOTE] = ACTIONS(2893),
    [anon_sym_async] = ACTIONS(2893),
    [anon_sym_break] = ACTIONS(2893),
    [anon_sym_const] = ACTIONS(2893),
    [anon_sym_continue] = ACTIONS(2893),
    [anon_sym_default] = ACTIONS(2893),
    [anon_sym_enum] = ACTIONS(2893),
    [anon_sym_fn] = ACTIONS(2893),
    [anon_sym_for] = ACTIONS(2893),
    [anon_sym_if] = ACTIONS(2893),
    [anon_sym_impl] = ACTIONS(2893),
    [anon_sym_let] = ACTIONS(2893),
    [anon_sym_loop] = ACTIONS(2893),
    [anon_sym_match] = ACTIONS(2893),
    [anon_sym_mod] = ACTIONS(2893),
    [anon_sym_pub] = ACTIONS(2893),
    [anon_sym_return] = ACTIONS(2893),
    [anon_sym_static] = ACTIONS(2893),
    [anon_sym_struct] = ACTIONS(2893),
    [anon_sym_trait] = ACTIONS(2893),
    [anon_sym_type] = ACTIONS(2893),
    [anon_sym_union] = ACTIONS(2893),
    [anon_sym_unsafe] = ACTIONS(2893),
    [anon_sym_use] = ACTIONS(2893),
    [anon_sym_while] = ACTIONS(2893),
    [anon_sym_extern] = ACTIONS(2893),
    [anon_sym_yield] = ACTIONS(2893),
    [anon_sym_move] = ACTIONS(2893),
    [anon_sym_try] = ACTIONS(2893),
    [sym_integer_literal] = ACTIONS(2891),
    [aux_sym_string_literal_token1] = ACTIONS(2891),
    [sym_char_literal] = ACTIONS(2891),
    [anon_sym_true] = ACTIONS(2893),
    [anon_sym_false] = ACTIONS(2893),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2893),
    [sym_super] = ACTIONS(2893),
    [sym_crate] = ACTIONS(2893),
    [sym_metavariable] = ACTIONS(2891),
    [sym__raw_string_literal_start] = ACTIONS(2891),
    [sym_float_literal] = ACTIONS(2891),
  },
  [748] = {
    [sym_line_comment] = STATE(748),
    [sym_block_comment] = STATE(748),
    [ts_builtin_sym_end] = ACTIONS(2895),
    [sym_identifier] = ACTIONS(2897),
    [anon_sym_SEMI] = ACTIONS(2895),
    [anon_sym_macro_rules_BANG] = ACTIONS(2895),
    [anon_sym_LPAREN] = ACTIONS(2895),
    [anon_sym_LBRACK] = ACTIONS(2895),
    [anon_sym_LBRACE] = ACTIONS(2895),
    [anon_sym_RBRACE] = ACTIONS(2895),
    [anon_sym_STAR] = ACTIONS(2895),
    [anon_sym_u8] = ACTIONS(2897),
    [anon_sym_i8] = ACTIONS(2897),
    [anon_sym_u16] = ACTIONS(2897),
    [anon_sym_i16] = ACTIONS(2897),
    [anon_sym_u32] = ACTIONS(2897),
    [anon_sym_i32] = ACTIONS(2897),
    [anon_sym_u64] = ACTIONS(2897),
    [anon_sym_i64] = ACTIONS(2897),
    [anon_sym_u128] = ACTIONS(2897),
    [anon_sym_i128] = ACTIONS(2897),
    [anon_sym_isize] = ACTIONS(2897),
    [anon_sym_usize] = ACTIONS(2897),
    [anon_sym_f32] = ACTIONS(2897),
    [anon_sym_f64] = ACTIONS(2897),
    [anon_sym_bool] = ACTIONS(2897),
    [anon_sym_str] = ACTIONS(2897),
    [anon_sym_char] = ACTIONS(2897),
    [anon_sym_DASH] = ACTIONS(2895),
    [anon_sym_BANG] = ACTIONS(2895),
    [anon_sym_AMP] = ACTIONS(2895),
    [anon_sym_PIPE] = ACTIONS(2895),
    [anon_sym_LT] = ACTIONS(2895),
    [anon_sym_DOT_DOT] = ACTIONS(2895),
    [anon_sym_COLON_COLON] = ACTIONS(2895),
    [anon_sym_POUND] = ACTIONS(2895),
    [anon_sym_SQUOTE] = ACTIONS(2897),
    [anon_sym_async] = ACTIONS(2897),
    [anon_sym_break] = ACTIONS(2897),
    [anon_sym_const] = ACTIONS(2897),
    [anon_sym_continue] = ACTIONS(2897),
    [anon_sym_default] = ACTIONS(2897),
    [anon_sym_enum] = ACTIONS(2897),
    [anon_sym_fn] = ACTIONS(2897),
    [anon_sym_for] = ACTIONS(2897),
    [anon_sym_if] = ACTIONS(2897),
    [anon_sym_impl] = ACTIONS(2897),
    [anon_sym_let] = ACTIONS(2897),
    [anon_sym_loop] = ACTIONS(2897),
    [anon_sym_match] = ACTIONS(2897),
    [anon_sym_mod] = ACTIONS(2897),
    [anon_sym_pub] = ACTIONS(2897),
    [anon_sym_return] = ACTIONS(2897),
    [anon_sym_static] = ACTIONS(2897),
    [anon_sym_struct] = ACTIONS(2897),
    [anon_sym_trait] = ACTIONS(2897),
    [anon_sym_type] = ACTIONS(2897),
    [anon_sym_union] = ACTIONS(2897),
    [anon_sym_unsafe] = ACTIONS(2897),
    [anon_sym_use] = ACTIONS(2897),
    [anon_sym_while] = ACTIONS(2897),
    [anon_sym_extern] = ACTIONS(2897),
    [anon_sym_yield] = ACTIONS(2897),
    [anon_sym_move] = ACTIONS(2897),
    [anon_sym_try] = ACTIONS(2897),
    [sym_integer_literal] = ACTIONS(2895),
    [aux_sym_string_literal_token1] = ACTIONS(2895),
    [sym_char_literal] = ACTIONS(2895),
    [anon_sym_true] = ACTIONS(2897),
    [anon_sym_false] = ACTIONS(2897),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2897),
    [sym_super] = ACTIONS(2897),
    [sym_crate] = ACTIONS(2897),
    [sym_metavariable] = ACTIONS(2895),
    [sym__raw_string_literal_start] = ACTIONS(2895),
    [sym_float_literal] = ACTIONS(2895),
  },
  [749] = {
    [sym_line_comment] = STATE(749),
    [sym_block_comment] = STATE(749),
    [ts_builtin_sym_end] = ACTIONS(2899),
    [sym_identifier] = ACTIONS(2901),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_macro_rules_BANG] = ACTIONS(2899),
    [anon_sym_LPAREN] = ACTIONS(2899),
    [anon_sym_LBRACK] = ACTIONS(2899),
    [anon_sym_LBRACE] = ACTIONS(2899),
    [anon_sym_RBRACE] = ACTIONS(2899),
    [anon_sym_STAR] = ACTIONS(2899),
    [anon_sym_u8] = ACTIONS(2901),
    [anon_sym_i8] = ACTIONS(2901),
    [anon_sym_u16] = ACTIONS(2901),
    [anon_sym_i16] = ACTIONS(2901),
    [anon_sym_u32] = ACTIONS(2901),
    [anon_sym_i32] = ACTIONS(2901),
    [anon_sym_u64] = ACTIONS(2901),
    [anon_sym_i64] = ACTIONS(2901),
    [anon_sym_u128] = ACTIONS(2901),
    [anon_sym_i128] = ACTIONS(2901),
    [anon_sym_isize] = ACTIONS(2901),
    [anon_sym_usize] = ACTIONS(2901),
    [anon_sym_f32] = ACTIONS(2901),
    [anon_sym_f64] = ACTIONS(2901),
    [anon_sym_bool] = ACTIONS(2901),
    [anon_sym_str] = ACTIONS(2901),
    [anon_sym_char] = ACTIONS(2901),
    [anon_sym_DASH] = ACTIONS(2899),
    [anon_sym_BANG] = ACTIONS(2899),
    [anon_sym_AMP] = ACTIONS(2899),
    [anon_sym_PIPE] = ACTIONS(2899),
    [anon_sym_LT] = ACTIONS(2899),
    [anon_sym_DOT_DOT] = ACTIONS(2899),
    [anon_sym_COLON_COLON] = ACTIONS(2899),
    [anon_sym_POUND] = ACTIONS(2899),
    [anon_sym_SQUOTE] = ACTIONS(2901),
    [anon_sym_async] = ACTIONS(2901),
    [anon_sym_break] = ACTIONS(2901),
    [anon_sym_const] = ACTIONS(2901),
    [anon_sym_continue] = ACTIONS(2901),
    [anon_sym_default] = ACTIONS(2901),
    [anon_sym_enum] = ACTIONS(2901),
    [anon_sym_fn] = ACTIONS(2901),
    [anon_sym_for] = ACTIONS(2901),
    [anon_sym_if] = ACTIONS(2901),
    [anon_sym_impl] = ACTIONS(2901),
    [anon_sym_let] = ACTIONS(2901),
    [anon_sym_loop] = ACTIONS(2901),
    [anon_sym_match] = ACTIONS(2901),
    [anon_sym_mod] = ACTIONS(2901),
    [anon_sym_pub] = ACTIONS(2901),
    [anon_sym_return] = ACTIONS(2901),
    [anon_sym_static] = ACTIONS(2901),
    [anon_sym_struct] = ACTIONS(2901),
    [anon_sym_trait] = ACTIONS(2901),
    [anon_sym_type] = ACTIONS(2901),
    [anon_sym_union] = ACTIONS(2901),
    [anon_sym_unsafe] = ACTIONS(2901),
    [anon_sym_use] = ACTIONS(2901),
    [anon_sym_while] = ACTIONS(2901),
    [anon_sym_extern] = ACTIONS(2901),
    [anon_sym_yield] = ACTIONS(2901),
    [anon_sym_move] = ACTIONS(2901),
    [anon_sym_try] = ACTIONS(2901),
    [sym_integer_literal] = ACTIONS(2899),
    [aux_sym_string_literal_token1] = ACTIONS(2899),
    [sym_char_literal] = ACTIONS(2899),
    [anon_sym_true] = ACTIONS(2901),
    [anon_sym_false] = ACTIONS(2901),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2901),
    [sym_super] = ACTIONS(2901),
    [sym_crate] = ACTIONS(2901),
    [sym_metavariable] = ACTIONS(2899),
    [sym__raw_string_literal_start] = ACTIONS(2899),
    [sym_float_literal] = ACTIONS(2899),
  },
  [750] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym_closure_expression] = STATE(2883),
    [sym_closure_parameters] = STATE(216),
    [sym__pattern] = STATE(2575),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(750),
    [sym_block_comment] = STATE(750),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_RPAREN] = ACTIONS(2907),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(1484),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_static] = ACTIONS(1486),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(1488),
    [anon_sym_move] = ACTIONS(1490),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2921),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [751] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym_closure_expression] = STATE(2992),
    [sym_closure_parameters] = STATE(216),
    [sym__pattern] = STATE(2667),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(751),
    [sym_block_comment] = STATE(751),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_RPAREN] = ACTIONS(2925),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(2927),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_static] = ACTIONS(1486),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(1488),
    [anon_sym_move] = ACTIONS(1490),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2921),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [752] = {
    [sym_attribute_item] = STATE(1471),
    [sym_inner_attribute_item] = STATE(1471),
    [sym_bracketed_type] = STATE(3513),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3115),
    [sym_macro_invocation] = STATE(2834),
    [sym_scoped_identifier] = STATE(2137),
    [sym_scoped_type_identifier] = STATE(2851),
    [sym_match_pattern] = STATE(3541),
    [sym_const_block] = STATE(2834),
    [sym__pattern] = STATE(2828),
    [sym_tuple_pattern] = STATE(2834),
    [sym_slice_pattern] = STATE(2834),
    [sym_tuple_struct_pattern] = STATE(2834),
    [sym_struct_pattern] = STATE(2834),
    [sym_remaining_field_pattern] = STATE(2834),
    [sym_mut_pattern] = STATE(2834),
    [sym_range_pattern] = STATE(2834),
    [sym_ref_pattern] = STATE(2834),
    [sym_captured_pattern] = STATE(2834),
    [sym_reference_pattern] = STATE(2834),
    [sym_or_pattern] = STATE(2834),
    [sym__literal_pattern] = STATE(2336),
    [sym_negative_literal] = STATE(2345),
    [sym_string_literal] = STATE(2345),
    [sym_raw_string_literal] = STATE(2345),
    [sym_boolean_literal] = STATE(2345),
    [sym_line_comment] = STATE(752),
    [sym_block_comment] = STATE(752),
    [aux_sym_match_arm_repeat1] = STATE(1036),
    [sym_identifier] = ACTIONS(1608),
    [anon_sym_LPAREN] = ACTIONS(1610),
    [anon_sym_LBRACK] = ACTIONS(1612),
    [anon_sym_u8] = ACTIONS(1616),
    [anon_sym_i8] = ACTIONS(1616),
    [anon_sym_u16] = ACTIONS(1616),
    [anon_sym_i16] = ACTIONS(1616),
    [anon_sym_u32] = ACTIONS(1616),
    [anon_sym_i32] = ACTIONS(1616),
    [anon_sym_u64] = ACTIONS(1616),
    [anon_sym_i64] = ACTIONS(1616),
    [anon_sym_u128] = ACTIONS(1616),
    [anon_sym_i128] = ACTIONS(1616),
    [anon_sym_isize] = ACTIONS(1616),
    [anon_sym_usize] = ACTIONS(1616),
    [anon_sym_f32] = ACTIONS(1616),
    [anon_sym_f64] = ACTIONS(1616),
    [anon_sym_bool] = ACTIONS(1616),
    [anon_sym_str] = ACTIONS(1616),
    [anon_sym_char] = ACTIONS(1616),
    [anon_sym_DASH] = ACTIONS(1618),
    [anon_sym_AMP] = ACTIONS(1620),
    [anon_sym_PIPE] = ACTIONS(1622),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1624),
    [anon_sym_DOT_DOT] = ACTIONS(1626),
    [anon_sym_COLON_COLON] = ACTIONS(1628),
    [anon_sym_POUND] = ACTIONS(1630),
    [anon_sym_const] = ACTIONS(1632),
    [anon_sym_default] = ACTIONS(1634),
    [anon_sym_union] = ACTIONS(1634),
    [anon_sym_ref] = ACTIONS(1636),
    [sym_mutable_specifier] = ACTIONS(1638),
    [sym_integer_literal] = ACTIONS(1640),
    [aux_sym_string_literal_token1] = ACTIONS(1642),
    [sym_char_literal] = ACTIONS(1640),
    [anon_sym_true] = ACTIONS(1644),
    [anon_sym_false] = ACTIONS(1644),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1646),
    [sym_super] = ACTIONS(1646),
    [sym_crate] = ACTIONS(1646),
    [sym_metavariable] = ACTIONS(1648),
    [sym__raw_string_literal_start] = ACTIONS(1650),
    [sym_float_literal] = ACTIONS(1640),
  },
  [753] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym_closure_expression] = STATE(3252),
    [sym_closure_parameters] = STATE(216),
    [sym__pattern] = STATE(2907),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(753),
    [sym_block_comment] = STATE(753),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_RPAREN] = ACTIONS(2929),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_static] = ACTIONS(1486),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(1488),
    [anon_sym_move] = ACTIONS(1490),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2921),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [754] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym_closure_expression] = STATE(3252),
    [sym_closure_parameters] = STATE(216),
    [sym__pattern] = STATE(2907),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(754),
    [sym_block_comment] = STATE(754),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_RPAREN] = ACTIONS(2931),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_static] = ACTIONS(1486),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(1488),
    [anon_sym_move] = ACTIONS(1490),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2921),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [755] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym_closure_expression] = STATE(3252),
    [sym_closure_parameters] = STATE(216),
    [sym__pattern] = STATE(2907),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(755),
    [sym_block_comment] = STATE(755),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_RPAREN] = ACTIONS(2933),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_static] = ACTIONS(1486),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(1488),
    [anon_sym_move] = ACTIONS(1490),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2921),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [756] = {
    [sym_attribute_item] = STATE(1471),
    [sym_inner_attribute_item] = STATE(1471),
    [sym_bracketed_type] = STATE(3513),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3115),
    [sym_macro_invocation] = STATE(2834),
    [sym_scoped_identifier] = STATE(2137),
    [sym_scoped_type_identifier] = STATE(2851),
    [sym_match_pattern] = STATE(3411),
    [sym_const_block] = STATE(2834),
    [sym__pattern] = STATE(2828),
    [sym_tuple_pattern] = STATE(2834),
    [sym_slice_pattern] = STATE(2834),
    [sym_tuple_struct_pattern] = STATE(2834),
    [sym_struct_pattern] = STATE(2834),
    [sym_remaining_field_pattern] = STATE(2834),
    [sym_mut_pattern] = STATE(2834),
    [sym_range_pattern] = STATE(2834),
    [sym_ref_pattern] = STATE(2834),
    [sym_captured_pattern] = STATE(2834),
    [sym_reference_pattern] = STATE(2834),
    [sym_or_pattern] = STATE(2834),
    [sym__literal_pattern] = STATE(2336),
    [sym_negative_literal] = STATE(2345),
    [sym_string_literal] = STATE(2345),
    [sym_raw_string_literal] = STATE(2345),
    [sym_boolean_literal] = STATE(2345),
    [sym_line_comment] = STATE(756),
    [sym_block_comment] = STATE(756),
    [aux_sym_match_arm_repeat1] = STATE(1036),
    [sym_identifier] = ACTIONS(1608),
    [anon_sym_LPAREN] = ACTIONS(1610),
    [anon_sym_LBRACK] = ACTIONS(1612),
    [anon_sym_u8] = ACTIONS(1616),
    [anon_sym_i8] = ACTIONS(1616),
    [anon_sym_u16] = ACTIONS(1616),
    [anon_sym_i16] = ACTIONS(1616),
    [anon_sym_u32] = ACTIONS(1616),
    [anon_sym_i32] = ACTIONS(1616),
    [anon_sym_u64] = ACTIONS(1616),
    [anon_sym_i64] = ACTIONS(1616),
    [anon_sym_u128] = ACTIONS(1616),
    [anon_sym_i128] = ACTIONS(1616),
    [anon_sym_isize] = ACTIONS(1616),
    [anon_sym_usize] = ACTIONS(1616),
    [anon_sym_f32] = ACTIONS(1616),
    [anon_sym_f64] = ACTIONS(1616),
    [anon_sym_bool] = ACTIONS(1616),
    [anon_sym_str] = ACTIONS(1616),
    [anon_sym_char] = ACTIONS(1616),
    [anon_sym_DASH] = ACTIONS(1618),
    [anon_sym_AMP] = ACTIONS(1620),
    [anon_sym_PIPE] = ACTIONS(1622),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1624),
    [anon_sym_DOT_DOT] = ACTIONS(1626),
    [anon_sym_COLON_COLON] = ACTIONS(1628),
    [anon_sym_POUND] = ACTIONS(1630),
    [anon_sym_const] = ACTIONS(1632),
    [anon_sym_default] = ACTIONS(1634),
    [anon_sym_union] = ACTIONS(1634),
    [anon_sym_ref] = ACTIONS(1636),
    [sym_mutable_specifier] = ACTIONS(1638),
    [sym_integer_literal] = ACTIONS(1640),
    [aux_sym_string_literal_token1] = ACTIONS(1642),
    [sym_char_literal] = ACTIONS(1640),
    [anon_sym_true] = ACTIONS(1644),
    [anon_sym_false] = ACTIONS(1644),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1646),
    [sym_super] = ACTIONS(1646),
    [sym_crate] = ACTIONS(1646),
    [sym_metavariable] = ACTIONS(1648),
    [sym__raw_string_literal_start] = ACTIONS(1650),
    [sym_float_literal] = ACTIONS(1640),
  },
  [757] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym_closure_expression] = STATE(3252),
    [sym_closure_parameters] = STATE(216),
    [sym__pattern] = STATE(2907),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(757),
    [sym_block_comment] = STATE(757),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_RPAREN] = ACTIONS(2935),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_static] = ACTIONS(1486),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(1488),
    [anon_sym_move] = ACTIONS(1490),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2921),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [758] = {
    [sym_attribute_item] = STATE(1468),
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym_visibility_modifier] = STATE(855),
    [sym__type] = STATE(2525),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(758),
    [sym_block_comment] = STATE(758),
    [aux_sym_enum_variant_list_repeat1] = STATE(772),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(2939),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COMMA] = ACTIONS(2941),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_POUND] = ACTIONS(2943),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_pub] = ACTIONS(2947),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(2949),
    [sym_metavariable] = ACTIONS(1584),
  },
  [759] = {
    [sym_attribute_item] = STATE(1468),
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_const_parameter] = STATE(2960),
    [sym_constrained_type_parameter] = STATE(2625),
    [sym_optional_type_parameter] = STATE(2960),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2807),
    [sym_bracketed_type] = STATE(3315),
    [sym_qualified_type] = STATE(3408),
    [sym_lifetime] = STATE(2353),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(759),
    [sym_block_comment] = STATE(759),
    [aux_sym_enum_variant_list_repeat1] = STATE(2047),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2951),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_POUND] = ACTIONS(2943),
    [anon_sym_SQUOTE] = ACTIONS(2953),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(2955),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(2957),
  },
  [760] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym_closure_expression] = STATE(3252),
    [sym_closure_parameters] = STATE(216),
    [sym__pattern] = STATE(2907),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(760),
    [sym_block_comment] = STATE(760),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_static] = ACTIONS(1486),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(1488),
    [anon_sym_move] = ACTIONS(1490),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2921),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [761] = {
    [sym_attribute_item] = STATE(1468),
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym_visibility_modifier] = STATE(986),
    [sym__type] = STATE(3000),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(761),
    [sym_block_comment] = STATE(761),
    [aux_sym_enum_variant_list_repeat1] = STATE(771),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(2959),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_POUND] = ACTIONS(2943),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_pub] = ACTIONS(2947),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(2949),
    [sym_metavariable] = ACTIONS(1584),
  },
  [762] = {
    [sym_attribute_item] = STATE(1468),
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym_visibility_modifier] = STATE(986),
    [sym__type] = STATE(3000),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(762),
    [sym_block_comment] = STATE(762),
    [aux_sym_enum_variant_list_repeat1] = STATE(771),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(2961),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_POUND] = ACTIONS(2943),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_pub] = ACTIONS(2947),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(2949),
    [sym_metavariable] = ACTIONS(1584),
  },
  [763] = {
    [sym_attribute_item] = STATE(1468),
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym_visibility_modifier] = STATE(986),
    [sym__type] = STATE(3000),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(763),
    [sym_block_comment] = STATE(763),
    [aux_sym_enum_variant_list_repeat1] = STATE(771),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(2963),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_POUND] = ACTIONS(2943),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_pub] = ACTIONS(2947),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(2949),
    [sym_metavariable] = ACTIONS(1584),
  },
  [764] = {
    [sym_attribute_item] = STATE(1468),
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym_visibility_modifier] = STATE(986),
    [sym__type] = STATE(3000),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(764),
    [sym_block_comment] = STATE(764),
    [aux_sym_enum_variant_list_repeat1] = STATE(771),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(2965),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_POUND] = ACTIONS(2943),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_pub] = ACTIONS(2947),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(2949),
    [sym_metavariable] = ACTIONS(1584),
  },
  [765] = {
    [sym_attribute_item] = STATE(1468),
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym_visibility_modifier] = STATE(986),
    [sym__type] = STATE(3000),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(765),
    [sym_block_comment] = STATE(765),
    [aux_sym_enum_variant_list_repeat1] = STATE(771),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(2967),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_POUND] = ACTIONS(2943),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_pub] = ACTIONS(2947),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(2949),
    [sym_metavariable] = ACTIONS(1584),
  },
  [766] = {
    [sym_attribute_item] = STATE(1468),
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym_visibility_modifier] = STATE(986),
    [sym__type] = STATE(3000),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(766),
    [sym_block_comment] = STATE(766),
    [aux_sym_enum_variant_list_repeat1] = STATE(771),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(2969),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_POUND] = ACTIONS(2943),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_pub] = ACTIONS(2947),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(2949),
    [sym_metavariable] = ACTIONS(1584),
  },
  [767] = {
    [sym_attribute_item] = STATE(1468),
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym_visibility_modifier] = STATE(986),
    [sym__type] = STATE(3000),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(767),
    [sym_block_comment] = STATE(767),
    [aux_sym_enum_variant_list_repeat1] = STATE(771),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_POUND] = ACTIONS(2943),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_pub] = ACTIONS(2947),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(2949),
    [sym_metavariable] = ACTIONS(1584),
  },
  [768] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2714),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(768),
    [sym_block_comment] = STATE(768),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_RPAREN] = ACTIONS(2971),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(2973),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2921),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [769] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2719),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(769),
    [sym_block_comment] = STATE(769),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_RPAREN] = ACTIONS(2975),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(2977),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2921),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [770] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2576),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(770),
    [sym_block_comment] = STATE(770),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_RBRACK] = ACTIONS(1508),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(1514),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2921),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [771] = {
    [sym_attribute_item] = STATE(1468),
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym_visibility_modifier] = STATE(946),
    [sym__type] = STATE(2914),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(771),
    [sym_block_comment] = STATE(771),
    [aux_sym_enum_variant_list_repeat1] = STATE(1041),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_POUND] = ACTIONS(2943),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_pub] = ACTIONS(2947),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(2949),
    [sym_metavariable] = ACTIONS(1584),
  },
  [772] = {
    [sym_attribute_item] = STATE(1468),
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym_visibility_modifier] = STATE(968),
    [sym__type] = STATE(2715),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(772),
    [sym_block_comment] = STATE(772),
    [aux_sym_enum_variant_list_repeat1] = STATE(1041),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_POUND] = ACTIONS(2943),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_pub] = ACTIONS(2947),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(2949),
    [sym_metavariable] = ACTIONS(1584),
  },
  [773] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2669),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(773),
    [sym_block_comment] = STATE(773),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_RBRACK] = ACTIONS(2979),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(2981),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2921),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [774] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2676),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(774),
    [sym_block_comment] = STATE(774),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_RPAREN] = ACTIONS(2983),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(2985),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2921),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [775] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2713),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(775),
    [sym_block_comment] = STATE(775),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_RPAREN] = ACTIONS(2987),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(2989),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2921),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [776] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2613),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(776),
    [sym_block_comment] = STATE(776),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_RBRACK] = ACTIONS(2991),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2921),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [777] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2613),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(777),
    [sym_block_comment] = STATE(777),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_RPAREN] = ACTIONS(2993),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2921),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [778] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2613),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(778),
    [sym_block_comment] = STATE(778),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_RPAREN] = ACTIONS(2995),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2921),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [779] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2657),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(779),
    [sym_block_comment] = STATE(779),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2997),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2999),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [780] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2613),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(780),
    [sym_block_comment] = STATE(780),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_RPAREN] = ACTIONS(3001),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2921),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [781] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2613),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(781),
    [sym_block_comment] = STATE(781),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_RPAREN] = ACTIONS(3003),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2921),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [782] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2613),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(782),
    [sym_block_comment] = STATE(782),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_RPAREN] = ACTIONS(3005),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2921),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [783] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2613),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(783),
    [sym_block_comment] = STATE(783),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_RBRACK] = ACTIONS(3007),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2921),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [784] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2613),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(784),
    [sym_block_comment] = STATE(784),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_RBRACK] = ACTIONS(3009),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2921),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [785] = {
    [sym_parameter] = STATE(2789),
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2410),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(785),
    [sym_block_comment] = STATE(785),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(3011),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(3013),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3015),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [786] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2613),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(786),
    [sym_block_comment] = STATE(786),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_RBRACK] = ACTIONS(3017),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2921),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [787] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2613),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(787),
    [sym_block_comment] = STATE(787),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_RPAREN] = ACTIONS(3019),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2921),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [788] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2613),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(788),
    [sym_block_comment] = STATE(788),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_RPAREN] = ACTIONS(3021),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2921),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [789] = {
    [sym_parameter] = STATE(3215),
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2905),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(789),
    [sym_block_comment] = STATE(789),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(3013),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3015),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [790] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2613),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(790),
    [sym_block_comment] = STATE(790),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_RPAREN] = ACTIONS(3023),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2921),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [791] = {
    [sym_parameter] = STATE(2789),
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2516),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(791),
    [sym_block_comment] = STATE(791),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(3011),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(3013),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3015),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [792] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2092),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(792),
    [sym_block_comment] = STATE(792),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2921),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [793] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(3121),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(793),
    [sym_block_comment] = STATE(793),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2921),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [794] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2613),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(794),
    [sym_block_comment] = STATE(794),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2921),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [795] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2391),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(795),
    [sym_block_comment] = STATE(795),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2921),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [796] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2872),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(796),
    [sym_block_comment] = STATE(796),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2921),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [797] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(3165),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(797),
    [sym_block_comment] = STATE(797),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2921),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [798] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2924),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(798),
    [sym_block_comment] = STATE(798),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2921),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [799] = {
    [sym_bracketed_type] = STATE(3513),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3115),
    [sym_macro_invocation] = STATE(2834),
    [sym_scoped_identifier] = STATE(2137),
    [sym_scoped_type_identifier] = STATE(2851),
    [sym_const_block] = STATE(2834),
    [sym__pattern] = STATE(2806),
    [sym_tuple_pattern] = STATE(2834),
    [sym_slice_pattern] = STATE(2834),
    [sym_tuple_struct_pattern] = STATE(2834),
    [sym_struct_pattern] = STATE(2834),
    [sym_remaining_field_pattern] = STATE(2834),
    [sym_mut_pattern] = STATE(2834),
    [sym_range_pattern] = STATE(2834),
    [sym_ref_pattern] = STATE(2834),
    [sym_captured_pattern] = STATE(2834),
    [sym_reference_pattern] = STATE(2834),
    [sym_or_pattern] = STATE(2834),
    [sym__literal_pattern] = STATE(2336),
    [sym_negative_literal] = STATE(2345),
    [sym_string_literal] = STATE(2345),
    [sym_raw_string_literal] = STATE(2345),
    [sym_boolean_literal] = STATE(2345),
    [sym_line_comment] = STATE(799),
    [sym_block_comment] = STATE(799),
    [sym_identifier] = ACTIONS(1608),
    [anon_sym_LPAREN] = ACTIONS(1610),
    [anon_sym_LBRACK] = ACTIONS(1612),
    [anon_sym_u8] = ACTIONS(1616),
    [anon_sym_i8] = ACTIONS(1616),
    [anon_sym_u16] = ACTIONS(1616),
    [anon_sym_i16] = ACTIONS(1616),
    [anon_sym_u32] = ACTIONS(1616),
    [anon_sym_i32] = ACTIONS(1616),
    [anon_sym_u64] = ACTIONS(1616),
    [anon_sym_i64] = ACTIONS(1616),
    [anon_sym_u128] = ACTIONS(1616),
    [anon_sym_i128] = ACTIONS(1616),
    [anon_sym_isize] = ACTIONS(1616),
    [anon_sym_usize] = ACTIONS(1616),
    [anon_sym_f32] = ACTIONS(1616),
    [anon_sym_f64] = ACTIONS(1616),
    [anon_sym_bool] = ACTIONS(1616),
    [anon_sym_str] = ACTIONS(1616),
    [anon_sym_char] = ACTIONS(1616),
    [anon_sym_DASH] = ACTIONS(1618),
    [anon_sym_AMP] = ACTIONS(1620),
    [anon_sym_PIPE] = ACTIONS(1622),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1624),
    [anon_sym_DOT_DOT] = ACTIONS(1626),
    [anon_sym_COLON_COLON] = ACTIONS(1628),
    [anon_sym_const] = ACTIONS(1632),
    [anon_sym_default] = ACTIONS(1634),
    [anon_sym_union] = ACTIONS(1634),
    [anon_sym_ref] = ACTIONS(1636),
    [sym_mutable_specifier] = ACTIONS(1638),
    [sym_integer_literal] = ACTIONS(1640),
    [aux_sym_string_literal_token1] = ACTIONS(1642),
    [sym_char_literal] = ACTIONS(1640),
    [anon_sym_true] = ACTIONS(1644),
    [anon_sym_false] = ACTIONS(1644),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1646),
    [sym_super] = ACTIONS(1646),
    [sym_crate] = ACTIONS(1646),
    [sym_metavariable] = ACTIONS(1648),
    [sym__raw_string_literal_start] = ACTIONS(1650),
    [sym_float_literal] = ACTIONS(1640),
  },
  [800] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(3079),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(800),
    [sym_block_comment] = STATE(800),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2921),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [801] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(3120),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(801),
    [sym_block_comment] = STATE(801),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2921),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [802] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2091),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(802),
    [sym_block_comment] = STATE(802),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2921),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [803] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2109),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(803),
    [sym_block_comment] = STATE(803),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(3025),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2921),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [804] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2098),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(804),
    [sym_block_comment] = STATE(804),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2921),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [805] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2113),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(805),
    [sym_block_comment] = STATE(805),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2921),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [806] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2965),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(806),
    [sym_block_comment] = STATE(806),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2921),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [807] = {
    [sym_bracketed_type] = STATE(3513),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3115),
    [sym_macro_invocation] = STATE(2834),
    [sym_scoped_identifier] = STATE(2137),
    [sym_scoped_type_identifier] = STATE(2851),
    [sym_const_block] = STATE(2834),
    [sym__pattern] = STATE(2821),
    [sym_tuple_pattern] = STATE(2834),
    [sym_slice_pattern] = STATE(2834),
    [sym_tuple_struct_pattern] = STATE(2834),
    [sym_struct_pattern] = STATE(2834),
    [sym_remaining_field_pattern] = STATE(2834),
    [sym_mut_pattern] = STATE(2834),
    [sym_range_pattern] = STATE(2834),
    [sym_ref_pattern] = STATE(2834),
    [sym_captured_pattern] = STATE(2834),
    [sym_reference_pattern] = STATE(2834),
    [sym_or_pattern] = STATE(2834),
    [sym__literal_pattern] = STATE(2336),
    [sym_negative_literal] = STATE(2345),
    [sym_string_literal] = STATE(2345),
    [sym_raw_string_literal] = STATE(2345),
    [sym_boolean_literal] = STATE(2345),
    [sym_line_comment] = STATE(807),
    [sym_block_comment] = STATE(807),
    [sym_identifier] = ACTIONS(1608),
    [anon_sym_LPAREN] = ACTIONS(1610),
    [anon_sym_LBRACK] = ACTIONS(1612),
    [anon_sym_u8] = ACTIONS(1616),
    [anon_sym_i8] = ACTIONS(1616),
    [anon_sym_u16] = ACTIONS(1616),
    [anon_sym_i16] = ACTIONS(1616),
    [anon_sym_u32] = ACTIONS(1616),
    [anon_sym_i32] = ACTIONS(1616),
    [anon_sym_u64] = ACTIONS(1616),
    [anon_sym_i64] = ACTIONS(1616),
    [anon_sym_u128] = ACTIONS(1616),
    [anon_sym_i128] = ACTIONS(1616),
    [anon_sym_isize] = ACTIONS(1616),
    [anon_sym_usize] = ACTIONS(1616),
    [anon_sym_f32] = ACTIONS(1616),
    [anon_sym_f64] = ACTIONS(1616),
    [anon_sym_bool] = ACTIONS(1616),
    [anon_sym_str] = ACTIONS(1616),
    [anon_sym_char] = ACTIONS(1616),
    [anon_sym_DASH] = ACTIONS(1618),
    [anon_sym_AMP] = ACTIONS(1620),
    [anon_sym_PIPE] = ACTIONS(1622),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1624),
    [anon_sym_DOT_DOT] = ACTIONS(1626),
    [anon_sym_COLON_COLON] = ACTIONS(1628),
    [anon_sym_const] = ACTIONS(1632),
    [anon_sym_default] = ACTIONS(1634),
    [anon_sym_union] = ACTIONS(1634),
    [anon_sym_ref] = ACTIONS(1636),
    [sym_mutable_specifier] = ACTIONS(1638),
    [sym_integer_literal] = ACTIONS(1640),
    [aux_sym_string_literal_token1] = ACTIONS(1642),
    [sym_char_literal] = ACTIONS(1640),
    [anon_sym_true] = ACTIONS(1644),
    [anon_sym_false] = ACTIONS(1644),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1646),
    [sym_super] = ACTIONS(1646),
    [sym_crate] = ACTIONS(1646),
    [sym_metavariable] = ACTIONS(1648),
    [sym__raw_string_literal_start] = ACTIONS(1650),
    [sym_float_literal] = ACTIONS(1640),
  },
  [808] = {
    [sym_bracketed_type] = STATE(3513),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3115),
    [sym_macro_invocation] = STATE(2834),
    [sym_scoped_identifier] = STATE(2137),
    [sym_scoped_type_identifier] = STATE(2851),
    [sym_const_block] = STATE(2834),
    [sym__pattern] = STATE(2823),
    [sym_tuple_pattern] = STATE(2834),
    [sym_slice_pattern] = STATE(2834),
    [sym_tuple_struct_pattern] = STATE(2834),
    [sym_struct_pattern] = STATE(2834),
    [sym_remaining_field_pattern] = STATE(2834),
    [sym_mut_pattern] = STATE(2834),
    [sym_range_pattern] = STATE(2834),
    [sym_ref_pattern] = STATE(2834),
    [sym_captured_pattern] = STATE(2834),
    [sym_reference_pattern] = STATE(2834),
    [sym_or_pattern] = STATE(2834),
    [sym__literal_pattern] = STATE(2336),
    [sym_negative_literal] = STATE(2345),
    [sym_string_literal] = STATE(2345),
    [sym_raw_string_literal] = STATE(2345),
    [sym_boolean_literal] = STATE(2345),
    [sym_line_comment] = STATE(808),
    [sym_block_comment] = STATE(808),
    [sym_identifier] = ACTIONS(1608),
    [anon_sym_LPAREN] = ACTIONS(1610),
    [anon_sym_LBRACK] = ACTIONS(1612),
    [anon_sym_u8] = ACTIONS(1616),
    [anon_sym_i8] = ACTIONS(1616),
    [anon_sym_u16] = ACTIONS(1616),
    [anon_sym_i16] = ACTIONS(1616),
    [anon_sym_u32] = ACTIONS(1616),
    [anon_sym_i32] = ACTIONS(1616),
    [anon_sym_u64] = ACTIONS(1616),
    [anon_sym_i64] = ACTIONS(1616),
    [anon_sym_u128] = ACTIONS(1616),
    [anon_sym_i128] = ACTIONS(1616),
    [anon_sym_isize] = ACTIONS(1616),
    [anon_sym_usize] = ACTIONS(1616),
    [anon_sym_f32] = ACTIONS(1616),
    [anon_sym_f64] = ACTIONS(1616),
    [anon_sym_bool] = ACTIONS(1616),
    [anon_sym_str] = ACTIONS(1616),
    [anon_sym_char] = ACTIONS(1616),
    [anon_sym_DASH] = ACTIONS(1618),
    [anon_sym_AMP] = ACTIONS(1620),
    [anon_sym_PIPE] = ACTIONS(1622),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1624),
    [anon_sym_DOT_DOT] = ACTIONS(1626),
    [anon_sym_COLON_COLON] = ACTIONS(1628),
    [anon_sym_const] = ACTIONS(1632),
    [anon_sym_default] = ACTIONS(1634),
    [anon_sym_union] = ACTIONS(1634),
    [anon_sym_ref] = ACTIONS(1636),
    [sym_mutable_specifier] = ACTIONS(1638),
    [sym_integer_literal] = ACTIONS(1640),
    [aux_sym_string_literal_token1] = ACTIONS(1642),
    [sym_char_literal] = ACTIONS(1640),
    [anon_sym_true] = ACTIONS(1644),
    [anon_sym_false] = ACTIONS(1644),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1646),
    [sym_super] = ACTIONS(1646),
    [sym_crate] = ACTIONS(1646),
    [sym_metavariable] = ACTIONS(1648),
    [sym__raw_string_literal_start] = ACTIONS(1650),
    [sym_float_literal] = ACTIONS(1640),
  },
  [809] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(3039),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(809),
    [sym_block_comment] = STATE(809),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2921),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [810] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2435),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(810),
    [sym_block_comment] = STATE(810),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(3027),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2921),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [811] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2484),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(811),
    [sym_block_comment] = STATE(811),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3029),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [812] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(3037),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(812),
    [sym_block_comment] = STATE(812),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2921),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [813] = {
    [sym_bracketed_type] = STATE(3513),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3115),
    [sym_macro_invocation] = STATE(2834),
    [sym_scoped_identifier] = STATE(2137),
    [sym_scoped_type_identifier] = STATE(2851),
    [sym_const_block] = STATE(2834),
    [sym__pattern] = STATE(2818),
    [sym_tuple_pattern] = STATE(2834),
    [sym_slice_pattern] = STATE(2834),
    [sym_tuple_struct_pattern] = STATE(2834),
    [sym_struct_pattern] = STATE(2834),
    [sym_remaining_field_pattern] = STATE(2834),
    [sym_mut_pattern] = STATE(2834),
    [sym_range_pattern] = STATE(2834),
    [sym_ref_pattern] = STATE(2834),
    [sym_captured_pattern] = STATE(2834),
    [sym_reference_pattern] = STATE(2834),
    [sym_or_pattern] = STATE(2834),
    [sym__literal_pattern] = STATE(2336),
    [sym_negative_literal] = STATE(2345),
    [sym_string_literal] = STATE(2345),
    [sym_raw_string_literal] = STATE(2345),
    [sym_boolean_literal] = STATE(2345),
    [sym_line_comment] = STATE(813),
    [sym_block_comment] = STATE(813),
    [sym_identifier] = ACTIONS(1608),
    [anon_sym_LPAREN] = ACTIONS(1610),
    [anon_sym_LBRACK] = ACTIONS(1612),
    [anon_sym_u8] = ACTIONS(1616),
    [anon_sym_i8] = ACTIONS(1616),
    [anon_sym_u16] = ACTIONS(1616),
    [anon_sym_i16] = ACTIONS(1616),
    [anon_sym_u32] = ACTIONS(1616),
    [anon_sym_i32] = ACTIONS(1616),
    [anon_sym_u64] = ACTIONS(1616),
    [anon_sym_i64] = ACTIONS(1616),
    [anon_sym_u128] = ACTIONS(1616),
    [anon_sym_i128] = ACTIONS(1616),
    [anon_sym_isize] = ACTIONS(1616),
    [anon_sym_usize] = ACTIONS(1616),
    [anon_sym_f32] = ACTIONS(1616),
    [anon_sym_f64] = ACTIONS(1616),
    [anon_sym_bool] = ACTIONS(1616),
    [anon_sym_str] = ACTIONS(1616),
    [anon_sym_char] = ACTIONS(1616),
    [anon_sym_DASH] = ACTIONS(1618),
    [anon_sym_AMP] = ACTIONS(1620),
    [anon_sym_PIPE] = ACTIONS(1622),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1624),
    [anon_sym_DOT_DOT] = ACTIONS(1626),
    [anon_sym_COLON_COLON] = ACTIONS(1628),
    [anon_sym_const] = ACTIONS(1632),
    [anon_sym_default] = ACTIONS(1634),
    [anon_sym_union] = ACTIONS(1634),
    [anon_sym_ref] = ACTIONS(1636),
    [sym_mutable_specifier] = ACTIONS(1638),
    [sym_integer_literal] = ACTIONS(1640),
    [aux_sym_string_literal_token1] = ACTIONS(1642),
    [sym_char_literal] = ACTIONS(1640),
    [anon_sym_true] = ACTIONS(1644),
    [anon_sym_false] = ACTIONS(1644),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1646),
    [sym_super] = ACTIONS(1646),
    [sym_crate] = ACTIONS(1646),
    [sym_metavariable] = ACTIONS(1648),
    [sym__raw_string_literal_start] = ACTIONS(1650),
    [sym_float_literal] = ACTIONS(1640),
  },
  [814] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2106),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(814),
    [sym_block_comment] = STATE(814),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2921),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [815] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2110),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(815),
    [sym_block_comment] = STATE(815),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2921),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [816] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(3047),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(816),
    [sym_block_comment] = STATE(816),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2921),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [817] = {
    [sym_bracketed_type] = STATE(3513),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3115),
    [sym_macro_invocation] = STATE(2834),
    [sym_scoped_identifier] = STATE(2137),
    [sym_scoped_type_identifier] = STATE(2851),
    [sym_const_block] = STATE(2834),
    [sym__pattern] = STATE(2774),
    [sym_tuple_pattern] = STATE(2834),
    [sym_slice_pattern] = STATE(2834),
    [sym_tuple_struct_pattern] = STATE(2834),
    [sym_struct_pattern] = STATE(2834),
    [sym_remaining_field_pattern] = STATE(2834),
    [sym_mut_pattern] = STATE(2834),
    [sym_range_pattern] = STATE(2834),
    [sym_ref_pattern] = STATE(2834),
    [sym_captured_pattern] = STATE(2834),
    [sym_reference_pattern] = STATE(2834),
    [sym_or_pattern] = STATE(2834),
    [sym__literal_pattern] = STATE(2336),
    [sym_negative_literal] = STATE(2345),
    [sym_string_literal] = STATE(2345),
    [sym_raw_string_literal] = STATE(2345),
    [sym_boolean_literal] = STATE(2345),
    [sym_line_comment] = STATE(817),
    [sym_block_comment] = STATE(817),
    [sym_identifier] = ACTIONS(1608),
    [anon_sym_LPAREN] = ACTIONS(1610),
    [anon_sym_LBRACK] = ACTIONS(1612),
    [anon_sym_u8] = ACTIONS(1616),
    [anon_sym_i8] = ACTIONS(1616),
    [anon_sym_u16] = ACTIONS(1616),
    [anon_sym_i16] = ACTIONS(1616),
    [anon_sym_u32] = ACTIONS(1616),
    [anon_sym_i32] = ACTIONS(1616),
    [anon_sym_u64] = ACTIONS(1616),
    [anon_sym_i64] = ACTIONS(1616),
    [anon_sym_u128] = ACTIONS(1616),
    [anon_sym_i128] = ACTIONS(1616),
    [anon_sym_isize] = ACTIONS(1616),
    [anon_sym_usize] = ACTIONS(1616),
    [anon_sym_f32] = ACTIONS(1616),
    [anon_sym_f64] = ACTIONS(1616),
    [anon_sym_bool] = ACTIONS(1616),
    [anon_sym_str] = ACTIONS(1616),
    [anon_sym_char] = ACTIONS(1616),
    [anon_sym_DASH] = ACTIONS(1618),
    [anon_sym_AMP] = ACTIONS(1620),
    [anon_sym_PIPE] = ACTIONS(1622),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1624),
    [anon_sym_DOT_DOT] = ACTIONS(1626),
    [anon_sym_COLON_COLON] = ACTIONS(1628),
    [anon_sym_const] = ACTIONS(1632),
    [anon_sym_default] = ACTIONS(1634),
    [anon_sym_union] = ACTIONS(1634),
    [anon_sym_ref] = ACTIONS(1636),
    [sym_mutable_specifier] = ACTIONS(1638),
    [sym_integer_literal] = ACTIONS(1640),
    [aux_sym_string_literal_token1] = ACTIONS(1642),
    [sym_char_literal] = ACTIONS(1640),
    [anon_sym_true] = ACTIONS(1644),
    [anon_sym_false] = ACTIONS(1644),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1646),
    [sym_super] = ACTIONS(1646),
    [sym_crate] = ACTIONS(1646),
    [sym_metavariable] = ACTIONS(1648),
    [sym__raw_string_literal_start] = ACTIONS(1650),
    [sym_float_literal] = ACTIONS(1640),
  },
  [818] = {
    [sym_bracketed_type] = STATE(3513),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3115),
    [sym_macro_invocation] = STATE(2834),
    [sym_scoped_identifier] = STATE(2137),
    [sym_scoped_type_identifier] = STATE(2851),
    [sym_const_block] = STATE(2834),
    [sym__pattern] = STATE(2795),
    [sym_tuple_pattern] = STATE(2834),
    [sym_slice_pattern] = STATE(2834),
    [sym_tuple_struct_pattern] = STATE(2834),
    [sym_struct_pattern] = STATE(2834),
    [sym_remaining_field_pattern] = STATE(2834),
    [sym_mut_pattern] = STATE(2834),
    [sym_range_pattern] = STATE(2834),
    [sym_ref_pattern] = STATE(2834),
    [sym_captured_pattern] = STATE(2834),
    [sym_reference_pattern] = STATE(2834),
    [sym_or_pattern] = STATE(2834),
    [sym__literal_pattern] = STATE(2336),
    [sym_negative_literal] = STATE(2345),
    [sym_string_literal] = STATE(2345),
    [sym_raw_string_literal] = STATE(2345),
    [sym_boolean_literal] = STATE(2345),
    [sym_line_comment] = STATE(818),
    [sym_block_comment] = STATE(818),
    [sym_identifier] = ACTIONS(1608),
    [anon_sym_LPAREN] = ACTIONS(1610),
    [anon_sym_LBRACK] = ACTIONS(1612),
    [anon_sym_u8] = ACTIONS(1616),
    [anon_sym_i8] = ACTIONS(1616),
    [anon_sym_u16] = ACTIONS(1616),
    [anon_sym_i16] = ACTIONS(1616),
    [anon_sym_u32] = ACTIONS(1616),
    [anon_sym_i32] = ACTIONS(1616),
    [anon_sym_u64] = ACTIONS(1616),
    [anon_sym_i64] = ACTIONS(1616),
    [anon_sym_u128] = ACTIONS(1616),
    [anon_sym_i128] = ACTIONS(1616),
    [anon_sym_isize] = ACTIONS(1616),
    [anon_sym_usize] = ACTIONS(1616),
    [anon_sym_f32] = ACTIONS(1616),
    [anon_sym_f64] = ACTIONS(1616),
    [anon_sym_bool] = ACTIONS(1616),
    [anon_sym_str] = ACTIONS(1616),
    [anon_sym_char] = ACTIONS(1616),
    [anon_sym_DASH] = ACTIONS(1618),
    [anon_sym_AMP] = ACTIONS(1620),
    [anon_sym_PIPE] = ACTIONS(1622),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1624),
    [anon_sym_DOT_DOT] = ACTIONS(1626),
    [anon_sym_COLON_COLON] = ACTIONS(1628),
    [anon_sym_const] = ACTIONS(1632),
    [anon_sym_default] = ACTIONS(1634),
    [anon_sym_union] = ACTIONS(1634),
    [anon_sym_ref] = ACTIONS(1636),
    [sym_mutable_specifier] = ACTIONS(1638),
    [sym_integer_literal] = ACTIONS(1640),
    [aux_sym_string_literal_token1] = ACTIONS(1642),
    [sym_char_literal] = ACTIONS(1640),
    [anon_sym_true] = ACTIONS(1644),
    [anon_sym_false] = ACTIONS(1644),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1646),
    [sym_super] = ACTIONS(1646),
    [sym_crate] = ACTIONS(1646),
    [sym_metavariable] = ACTIONS(1648),
    [sym__raw_string_literal_start] = ACTIONS(1650),
    [sym_float_literal] = ACTIONS(1640),
  },
  [819] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2429),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(819),
    [sym_block_comment] = STATE(819),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(3031),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2921),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [820] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(3043),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(820),
    [sym_block_comment] = STATE(820),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2921),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [821] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(2430),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(821),
    [sym_block_comment] = STATE(821),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2921),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [822] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(3040),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(822),
    [sym_block_comment] = STATE(822),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2921),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [823] = {
    [sym_bracketed_type] = STATE(3434),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3249),
    [sym_macro_invocation] = STATE(2103),
    [sym_scoped_identifier] = STATE(1934),
    [sym_scoped_type_identifier] = STATE(2797),
    [sym_const_block] = STATE(2103),
    [sym__pattern] = STATE(3191),
    [sym_tuple_pattern] = STATE(2103),
    [sym_slice_pattern] = STATE(2103),
    [sym_tuple_struct_pattern] = STATE(2103),
    [sym_struct_pattern] = STATE(2103),
    [sym_remaining_field_pattern] = STATE(2103),
    [sym_mut_pattern] = STATE(2103),
    [sym_range_pattern] = STATE(2103),
    [sym_ref_pattern] = STATE(2103),
    [sym_captured_pattern] = STATE(2103),
    [sym_reference_pattern] = STATE(2103),
    [sym_or_pattern] = STATE(2103),
    [sym__literal_pattern] = STATE(2001),
    [sym_negative_literal] = STATE(2006),
    [sym_string_literal] = STATE(2006),
    [sym_raw_string_literal] = STATE(2006),
    [sym_boolean_literal] = STATE(2006),
    [sym_line_comment] = STATE(823),
    [sym_block_comment] = STATE(823),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_u8] = ACTIONS(2911),
    [anon_sym_i8] = ACTIONS(2911),
    [anon_sym_u16] = ACTIONS(2911),
    [anon_sym_i16] = ACTIONS(2911),
    [anon_sym_u32] = ACTIONS(2911),
    [anon_sym_i32] = ACTIONS(2911),
    [anon_sym_u64] = ACTIONS(2911),
    [anon_sym_i64] = ACTIONS(2911),
    [anon_sym_u128] = ACTIONS(2911),
    [anon_sym_i128] = ACTIONS(2911),
    [anon_sym_isize] = ACTIONS(2911),
    [anon_sym_usize] = ACTIONS(2911),
    [anon_sym_f32] = ACTIONS(2911),
    [anon_sym_f64] = ACTIONS(2911),
    [anon_sym_bool] = ACTIONS(2911),
    [anon_sym_str] = ACTIONS(2911),
    [anon_sym_char] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1482),
    [anon_sym_COLON_COLON] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_union] = ACTIONS(2919),
    [anon_sym_ref] = ACTIONS(1316),
    [sym_mutable_specifier] = ACTIONS(1488),
    [sym_integer_literal] = ACTIONS(1322),
    [aux_sym_string_literal_token1] = ACTIONS(1324),
    [sym_char_literal] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1326),
    [anon_sym_false] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2921),
    [sym_super] = ACTIONS(2921),
    [sym_crate] = ACTIONS(2921),
    [sym_metavariable] = ACTIONS(2923),
    [sym__raw_string_literal_start] = ACTIONS(1334),
    [sym_float_literal] = ACTIONS(1322),
  },
  [824] = {
    [sym_bracketed_type] = STATE(3513),
    [sym_generic_type] = STATE(3432),
    [sym_generic_type_with_turbofish] = STATE(3115),
    [sym_macro_invocation] = STATE(2834),
    [sym_scoped_identifier] = STATE(2137),
    [sym_scoped_type_identifier] = STATE(2851),
    [sym_const_block] = STATE(2834),
    [sym__pattern] = STATE(2825),
    [sym_tuple_pattern] = STATE(2834),
    [sym_slice_pattern] = STATE(2834),
    [sym_tuple_struct_pattern] = STATE(2834),
    [sym_struct_pattern] = STATE(2834),
    [sym_remaining_field_pattern] = STATE(2834),
    [sym_mut_pattern] = STATE(2834),
    [sym_range_pattern] = STATE(2834),
    [sym_ref_pattern] = STATE(2834),
    [sym_captured_pattern] = STATE(2834),
    [sym_reference_pattern] = STATE(2834),
    [sym_or_pattern] = STATE(2834),
    [sym__literal_pattern] = STATE(2336),
    [sym_negative_literal] = STATE(2345),
    [sym_string_literal] = STATE(2345),
    [sym_raw_string_literal] = STATE(2345),
    [sym_boolean_literal] = STATE(2345),
    [sym_line_comment] = STATE(824),
    [sym_block_comment] = STATE(824),
    [sym_identifier] = ACTIONS(1608),
    [anon_sym_LPAREN] = ACTIONS(1610),
    [anon_sym_LBRACK] = ACTIONS(1612),
    [anon_sym_u8] = ACTIONS(1616),
    [anon_sym_i8] = ACTIONS(1616),
    [anon_sym_u16] = ACTIONS(1616),
    [anon_sym_i16] = ACTIONS(1616),
    [anon_sym_u32] = ACTIONS(1616),
    [anon_sym_i32] = ACTIONS(1616),
    [anon_sym_u64] = ACTIONS(1616),
    [anon_sym_i64] = ACTIONS(1616),
    [anon_sym_u128] = ACTIONS(1616),
    [anon_sym_i128] = ACTIONS(1616),
    [anon_sym_isize] = ACTIONS(1616),
    [anon_sym_usize] = ACTIONS(1616),
    [anon_sym_f32] = ACTIONS(1616),
    [anon_sym_f64] = ACTIONS(1616),
    [anon_sym_bool] = ACTIONS(1616),
    [anon_sym_str] = ACTIONS(1616),
    [anon_sym_char] = ACTIONS(1616),
    [anon_sym_DASH] = ACTIONS(1618),
    [anon_sym_AMP] = ACTIONS(1620),
    [anon_sym_PIPE] = ACTIONS(1622),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym__] = ACTIONS(1624),
    [anon_sym_DOT_DOT] = ACTIONS(1626),
    [anon_sym_COLON_COLON] = ACTIONS(1628),
    [anon_sym_const] = ACTIONS(1632),
    [anon_sym_default] = ACTIONS(1634),
    [anon_sym_union] = ACTIONS(1634),
    [anon_sym_ref] = ACTIONS(1636),
    [sym_mutable_specifier] = ACTIONS(3033),
    [sym_integer_literal] = ACTIONS(1640),
    [aux_sym_string_literal_token1] = ACTIONS(1642),
    [sym_char_literal] = ACTIONS(1640),
    [anon_sym_true] = ACTIONS(1644),
    [anon_sym_false] = ACTIONS(1644),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1646),
    [sym_super] = ACTIONS(1646),
    [sym_crate] = ACTIONS(1646),
    [sym_metavariable] = ACTIONS(1648),
    [sym__raw_string_literal_start] = ACTIONS(1650),
    [sym_float_literal] = ACTIONS(1640),
  },
  [825] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(3073),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(825),
    [sym_block_comment] = STATE(825),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_PLUS] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [sym_mutable_specifier] = ACTIONS(3037),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [826] = {
    [sym_function_modifiers] = STATE(3321),
    [sym_removed_trait_bound] = STATE(1215),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1227),
    [sym_bracketed_type] = STATE(3504),
    [sym_lifetime] = STATE(3465),
    [sym_array_type] = STATE(1215),
    [sym_for_lifetimes] = STATE(1614),
    [sym_function_type] = STATE(1215),
    [sym_tuple_type] = STATE(1215),
    [sym_unit_type] = STATE(1215),
    [sym_generic_type] = STATE(1082),
    [sym_generic_type_with_turbofish] = STATE(3494),
    [sym_bounded_type] = STATE(1215),
    [sym_reference_type] = STATE(1215),
    [sym_pointer_type] = STATE(1215),
    [sym_never_type] = STATE(1215),
    [sym_abstract_type] = STATE(1215),
    [sym_dynamic_type] = STATE(1215),
    [sym_macro_invocation] = STATE(1215),
    [sym_scoped_identifier] = STATE(3299),
    [sym_scoped_type_identifier] = STATE(1022),
    [sym_line_comment] = STATE(826),
    [sym_block_comment] = STATE(826),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(3039),
    [anon_sym_LPAREN] = ACTIONS(3041),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_PLUS] = ACTIONS(3045),
    [anon_sym_STAR] = ACTIONS(3047),
    [anon_sym_QMARK] = ACTIONS(3049),
    [anon_sym_u8] = ACTIONS(3051),
    [anon_sym_i8] = ACTIONS(3051),
    [anon_sym_u16] = ACTIONS(3051),
    [anon_sym_i16] = ACTIONS(3051),
    [anon_sym_u32] = ACTIONS(3051),
    [anon_sym_i32] = ACTIONS(3051),
    [anon_sym_u64] = ACTIONS(3051),
    [anon_sym_i64] = ACTIONS(3051),
    [anon_sym_u128] = ACTIONS(3051),
    [anon_sym_i128] = ACTIONS(3051),
    [anon_sym_isize] = ACTIONS(3051),
    [anon_sym_usize] = ACTIONS(3051),
    [anon_sym_f32] = ACTIONS(3051),
    [anon_sym_f64] = ACTIONS(3051),
    [anon_sym_bool] = ACTIONS(3051),
    [anon_sym_str] = ACTIONS(3051),
    [anon_sym_char] = ACTIONS(3051),
    [anon_sym_BANG] = ACTIONS(3053),
    [anon_sym_AMP] = ACTIONS(3055),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3057),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(3059),
    [anon_sym_fn] = ACTIONS(3061),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(3063),
    [anon_sym_union] = ACTIONS(3065),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(3067),
    [sym_mutable_specifier] = ACTIONS(3069),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3071),
    [sym_super] = ACTIONS(3071),
    [sym_crate] = ACTIONS(3071),
    [sym_metavariable] = ACTIONS(3073),
  },
  [827] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1960),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(827),
    [sym_block_comment] = STATE(827),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_PLUS] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [sym_mutable_specifier] = ACTIONS(3075),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3077),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [828] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1960),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(828),
    [sym_block_comment] = STATE(828),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_PLUS] = ACTIONS(3035),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [sym_mutable_specifier] = ACTIONS(3079),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [829] = {
    [sym_function_modifiers] = STATE(3462),
    [sym_removed_trait_bound] = STATE(1678),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1632),
    [sym_bracketed_type] = STATE(3519),
    [sym_lifetime] = STATE(3551),
    [sym_array_type] = STATE(1678),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1678),
    [sym_tuple_type] = STATE(1678),
    [sym_unit_type] = STATE(1678),
    [sym_generic_type] = STATE(1604),
    [sym_generic_type_with_turbofish] = STATE(3511),
    [sym_bounded_type] = STATE(1678),
    [sym_reference_type] = STATE(1678),
    [sym_pointer_type] = STATE(1678),
    [sym_never_type] = STATE(1678),
    [sym_abstract_type] = STATE(1678),
    [sym_dynamic_type] = STATE(1678),
    [sym_macro_invocation] = STATE(1678),
    [sym_scoped_identifier] = STATE(3113),
    [sym_scoped_type_identifier] = STATE(1520),
    [sym_line_comment] = STATE(829),
    [sym_block_comment] = STATE(829),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(3081),
    [anon_sym_LPAREN] = ACTIONS(3083),
    [anon_sym_LBRACK] = ACTIONS(3085),
    [anon_sym_PLUS] = ACTIONS(3087),
    [anon_sym_STAR] = ACTIONS(3089),
    [anon_sym_QMARK] = ACTIONS(3091),
    [anon_sym_u8] = ACTIONS(3093),
    [anon_sym_i8] = ACTIONS(3093),
    [anon_sym_u16] = ACTIONS(3093),
    [anon_sym_i16] = ACTIONS(3093),
    [anon_sym_u32] = ACTIONS(3093),
    [anon_sym_i32] = ACTIONS(3093),
    [anon_sym_u64] = ACTIONS(3093),
    [anon_sym_i64] = ACTIONS(3093),
    [anon_sym_u128] = ACTIONS(3093),
    [anon_sym_i128] = ACTIONS(3093),
    [anon_sym_isize] = ACTIONS(3093),
    [anon_sym_usize] = ACTIONS(3093),
    [anon_sym_f32] = ACTIONS(3093),
    [anon_sym_f64] = ACTIONS(3093),
    [anon_sym_bool] = ACTIONS(3093),
    [anon_sym_str] = ACTIONS(3093),
    [anon_sym_char] = ACTIONS(3093),
    [anon_sym_BANG] = ACTIONS(3095),
    [anon_sym_AMP] = ACTIONS(3097),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3099),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(3101),
    [anon_sym_fn] = ACTIONS(3103),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(3105),
    [anon_sym_union] = ACTIONS(3107),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(3109),
    [sym_mutable_specifier] = ACTIONS(3111),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3113),
    [sym_super] = ACTIONS(3113),
    [sym_crate] = ACTIONS(3113),
    [sym_metavariable] = ACTIONS(3115),
  },
  [830] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_higher_ranked_trait_bound] = STATE(2204),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2210),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(2209),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(830),
    [sym_block_comment] = STATE(830),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(3117),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [831] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(3017),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(831),
    [sym_block_comment] = STATE(831),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(3119),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [832] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_type_parameters] = STATE(987),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2332),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(2334),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(2133),
    [sym_line_comment] = STATE(832),
    [sym_block_comment] = STATE(832),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(3121),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(3123),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(3125),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [833] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2807),
    [sym_bracketed_type] = STATE(3315),
    [sym_qualified_type] = STATE(3408),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(833),
    [sym_block_comment] = STATE(833),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [834] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(3017),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(834),
    [sym_block_comment] = STATE(834),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(3127),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [835] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2630),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(835),
    [sym_block_comment] = STATE(835),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3129),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [836] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2680),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(836),
    [sym_block_comment] = STATE(836),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(3131),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [837] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(3017),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(837),
    [sym_block_comment] = STATE(837),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(3133),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [838] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(3017),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(838),
    [sym_block_comment] = STATE(838),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(3135),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [839] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_type_parameters] = STATE(974),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2319),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(2309),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(2150),
    [sym_line_comment] = STATE(839),
    [sym_block_comment] = STATE(839),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(3137),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(3125),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [840] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(3202),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(825),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(840),
    [sym_block_comment] = STATE(840),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [sym_mutable_specifier] = ACTIONS(3141),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [841] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1973),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(828),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(841),
    [sym_block_comment] = STATE(841),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [sym_mutable_specifier] = ACTIONS(3143),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [842] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2634),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(842),
    [sym_block_comment] = STATE(842),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(3145),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [843] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_higher_ranked_trait_bound] = STATE(2126),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2127),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(2132),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(843),
    [sym_block_comment] = STATE(843),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(3117),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [844] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_type_parameters] = STATE(939),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2373),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(2303),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(2144),
    [sym_line_comment] = STATE(844),
    [sym_block_comment] = STATE(844),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(3147),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(3149),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(3125),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [845] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(3017),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(845),
    [sym_block_comment] = STATE(845),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(3151),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [846] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(3017),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(846),
    [sym_block_comment] = STATE(846),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(3153),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [847] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_type_parameters] = STATE(890),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2283),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(2286),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(2130),
    [sym_line_comment] = STATE(847),
    [sym_block_comment] = STATE(847),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(3155),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(3157),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(3125),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [848] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_higher_ranked_trait_bound] = STATE(2204),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2210),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(2213),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(848),
    [sym_block_comment] = STATE(848),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(3117),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [849] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2590),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(849),
    [sym_block_comment] = STATE(849),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(3159),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [850] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_higher_ranked_trait_bound] = STATE(2204),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2208),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(2209),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(850),
    [sym_block_comment] = STATE(850),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(3117),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [851] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2692),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(851),
    [sym_block_comment] = STATE(851),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3161),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [852] = {
    [sym_function_modifiers] = STATE(3321),
    [sym_removed_trait_bound] = STATE(1215),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1390),
    [sym_bracketed_type] = STATE(3504),
    [sym_lifetime] = STATE(826),
    [sym_array_type] = STATE(1215),
    [sym_for_lifetimes] = STATE(1614),
    [sym_function_type] = STATE(1215),
    [sym_tuple_type] = STATE(1215),
    [sym_unit_type] = STATE(1215),
    [sym_generic_type] = STATE(1082),
    [sym_generic_type_with_turbofish] = STATE(3494),
    [sym_bounded_type] = STATE(1215),
    [sym_reference_type] = STATE(1215),
    [sym_pointer_type] = STATE(1215),
    [sym_never_type] = STATE(1215),
    [sym_abstract_type] = STATE(1215),
    [sym_dynamic_type] = STATE(1215),
    [sym_macro_invocation] = STATE(1215),
    [sym_scoped_identifier] = STATE(3299),
    [sym_scoped_type_identifier] = STATE(1022),
    [sym_line_comment] = STATE(852),
    [sym_block_comment] = STATE(852),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(3039),
    [anon_sym_LPAREN] = ACTIONS(3041),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_STAR] = ACTIONS(3047),
    [anon_sym_QMARK] = ACTIONS(3049),
    [anon_sym_u8] = ACTIONS(3051),
    [anon_sym_i8] = ACTIONS(3051),
    [anon_sym_u16] = ACTIONS(3051),
    [anon_sym_i16] = ACTIONS(3051),
    [anon_sym_u32] = ACTIONS(3051),
    [anon_sym_i32] = ACTIONS(3051),
    [anon_sym_u64] = ACTIONS(3051),
    [anon_sym_i64] = ACTIONS(3051),
    [anon_sym_u128] = ACTIONS(3051),
    [anon_sym_i128] = ACTIONS(3051),
    [anon_sym_isize] = ACTIONS(3051),
    [anon_sym_usize] = ACTIONS(3051),
    [anon_sym_f32] = ACTIONS(3051),
    [anon_sym_f64] = ACTIONS(3051),
    [anon_sym_bool] = ACTIONS(3051),
    [anon_sym_str] = ACTIONS(3051),
    [anon_sym_char] = ACTIONS(3051),
    [anon_sym_BANG] = ACTIONS(3053),
    [anon_sym_AMP] = ACTIONS(3055),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3057),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(3059),
    [anon_sym_fn] = ACTIONS(3061),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(3063),
    [anon_sym_union] = ACTIONS(3065),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(3067),
    [sym_mutable_specifier] = ACTIONS(3163),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3071),
    [sym_super] = ACTIONS(3071),
    [sym_crate] = ACTIONS(3071),
    [sym_metavariable] = ACTIONS(3073),
  },
  [853] = {
    [sym_function_modifiers] = STATE(3462),
    [sym_removed_trait_bound] = STATE(1678),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1690),
    [sym_bracketed_type] = STATE(3519),
    [sym_lifetime] = STATE(829),
    [sym_array_type] = STATE(1678),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1678),
    [sym_tuple_type] = STATE(1678),
    [sym_unit_type] = STATE(1678),
    [sym_generic_type] = STATE(1604),
    [sym_generic_type_with_turbofish] = STATE(3511),
    [sym_bounded_type] = STATE(1678),
    [sym_reference_type] = STATE(1678),
    [sym_pointer_type] = STATE(1678),
    [sym_never_type] = STATE(1678),
    [sym_abstract_type] = STATE(1678),
    [sym_dynamic_type] = STATE(1678),
    [sym_macro_invocation] = STATE(1678),
    [sym_scoped_identifier] = STATE(3113),
    [sym_scoped_type_identifier] = STATE(1520),
    [sym_line_comment] = STATE(853),
    [sym_block_comment] = STATE(853),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(3081),
    [anon_sym_LPAREN] = ACTIONS(3083),
    [anon_sym_LBRACK] = ACTIONS(3085),
    [anon_sym_STAR] = ACTIONS(3089),
    [anon_sym_QMARK] = ACTIONS(3091),
    [anon_sym_u8] = ACTIONS(3093),
    [anon_sym_i8] = ACTIONS(3093),
    [anon_sym_u16] = ACTIONS(3093),
    [anon_sym_i16] = ACTIONS(3093),
    [anon_sym_u32] = ACTIONS(3093),
    [anon_sym_i32] = ACTIONS(3093),
    [anon_sym_u64] = ACTIONS(3093),
    [anon_sym_i64] = ACTIONS(3093),
    [anon_sym_u128] = ACTIONS(3093),
    [anon_sym_i128] = ACTIONS(3093),
    [anon_sym_isize] = ACTIONS(3093),
    [anon_sym_usize] = ACTIONS(3093),
    [anon_sym_f32] = ACTIONS(3093),
    [anon_sym_f64] = ACTIONS(3093),
    [anon_sym_bool] = ACTIONS(3093),
    [anon_sym_str] = ACTIONS(3093),
    [anon_sym_char] = ACTIONS(3093),
    [anon_sym_BANG] = ACTIONS(3095),
    [anon_sym_AMP] = ACTIONS(3097),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3099),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(3101),
    [anon_sym_fn] = ACTIONS(3103),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(3105),
    [anon_sym_union] = ACTIONS(3107),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(3109),
    [sym_mutable_specifier] = ACTIONS(3165),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3113),
    [sym_super] = ACTIONS(3113),
    [sym_crate] = ACTIONS(3113),
    [sym_metavariable] = ACTIONS(3115),
  },
  [854] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(3080),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(854),
    [sym_block_comment] = STATE(854),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [855] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2715),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(855),
    [sym_block_comment] = STATE(855),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [856] = {
    [sym_function_modifiers] = STATE(3321),
    [sym_removed_trait_bound] = STATE(1215),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1424),
    [sym_bracketed_type] = STATE(3504),
    [sym_lifetime] = STATE(3465),
    [sym_array_type] = STATE(1215),
    [sym_for_lifetimes] = STATE(1614),
    [sym_function_type] = STATE(1215),
    [sym_tuple_type] = STATE(1215),
    [sym_unit_type] = STATE(1215),
    [sym_generic_type] = STATE(1082),
    [sym_generic_type_with_turbofish] = STATE(3494),
    [sym_bounded_type] = STATE(1215),
    [sym_reference_type] = STATE(1215),
    [sym_pointer_type] = STATE(1215),
    [sym_never_type] = STATE(1215),
    [sym_abstract_type] = STATE(1215),
    [sym_dynamic_type] = STATE(1215),
    [sym_macro_invocation] = STATE(1215),
    [sym_scoped_identifier] = STATE(3299),
    [sym_scoped_type_identifier] = STATE(1022),
    [sym_line_comment] = STATE(856),
    [sym_block_comment] = STATE(856),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(3039),
    [anon_sym_LPAREN] = ACTIONS(3041),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_STAR] = ACTIONS(3047),
    [anon_sym_QMARK] = ACTIONS(3049),
    [anon_sym_u8] = ACTIONS(3051),
    [anon_sym_i8] = ACTIONS(3051),
    [anon_sym_u16] = ACTIONS(3051),
    [anon_sym_i16] = ACTIONS(3051),
    [anon_sym_u32] = ACTIONS(3051),
    [anon_sym_i32] = ACTIONS(3051),
    [anon_sym_u64] = ACTIONS(3051),
    [anon_sym_i64] = ACTIONS(3051),
    [anon_sym_u128] = ACTIONS(3051),
    [anon_sym_i128] = ACTIONS(3051),
    [anon_sym_isize] = ACTIONS(3051),
    [anon_sym_usize] = ACTIONS(3051),
    [anon_sym_f32] = ACTIONS(3051),
    [anon_sym_f64] = ACTIONS(3051),
    [anon_sym_bool] = ACTIONS(3051),
    [anon_sym_str] = ACTIONS(3051),
    [anon_sym_char] = ACTIONS(3051),
    [anon_sym_BANG] = ACTIONS(3053),
    [anon_sym_AMP] = ACTIONS(3055),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3057),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(3059),
    [anon_sym_fn] = ACTIONS(3061),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(3063),
    [anon_sym_union] = ACTIONS(3065),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(3067),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3071),
    [sym_super] = ACTIONS(3071),
    [sym_crate] = ACTIONS(3071),
    [sym_metavariable] = ACTIONS(3073),
  },
  [857] = {
    [sym_function_modifiers] = STATE(3321),
    [sym_removed_trait_bound] = STATE(1215),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1126),
    [sym_bracketed_type] = STATE(3504),
    [sym_lifetime] = STATE(3465),
    [sym_array_type] = STATE(1215),
    [sym_for_lifetimes] = STATE(1614),
    [sym_function_type] = STATE(1215),
    [sym_tuple_type] = STATE(1215),
    [sym_unit_type] = STATE(1215),
    [sym_generic_type] = STATE(1082),
    [sym_generic_type_with_turbofish] = STATE(3494),
    [sym_bounded_type] = STATE(1215),
    [sym_reference_type] = STATE(1215),
    [sym_pointer_type] = STATE(1215),
    [sym_never_type] = STATE(1215),
    [sym_abstract_type] = STATE(1215),
    [sym_dynamic_type] = STATE(1215),
    [sym_macro_invocation] = STATE(1215),
    [sym_scoped_identifier] = STATE(3299),
    [sym_scoped_type_identifier] = STATE(1022),
    [sym_line_comment] = STATE(857),
    [sym_block_comment] = STATE(857),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(3039),
    [anon_sym_LPAREN] = ACTIONS(3041),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_STAR] = ACTIONS(3047),
    [anon_sym_QMARK] = ACTIONS(3049),
    [anon_sym_u8] = ACTIONS(3051),
    [anon_sym_i8] = ACTIONS(3051),
    [anon_sym_u16] = ACTIONS(3051),
    [anon_sym_i16] = ACTIONS(3051),
    [anon_sym_u32] = ACTIONS(3051),
    [anon_sym_i32] = ACTIONS(3051),
    [anon_sym_u64] = ACTIONS(3051),
    [anon_sym_i64] = ACTIONS(3051),
    [anon_sym_u128] = ACTIONS(3051),
    [anon_sym_i128] = ACTIONS(3051),
    [anon_sym_isize] = ACTIONS(3051),
    [anon_sym_usize] = ACTIONS(3051),
    [anon_sym_f32] = ACTIONS(3051),
    [anon_sym_f64] = ACTIONS(3051),
    [anon_sym_bool] = ACTIONS(3051),
    [anon_sym_str] = ACTIONS(3051),
    [anon_sym_char] = ACTIONS(3051),
    [anon_sym_BANG] = ACTIONS(3053),
    [anon_sym_AMP] = ACTIONS(3055),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3057),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(3059),
    [anon_sym_fn] = ACTIONS(3061),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(3063),
    [anon_sym_union] = ACTIONS(3065),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(3067),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3071),
    [sym_super] = ACTIONS(3071),
    [sym_crate] = ACTIONS(3071),
    [sym_metavariable] = ACTIONS(3073),
  },
  [858] = {
    [sym_function_modifiers] = STATE(3462),
    [sym_removed_trait_bound] = STATE(1678),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1714),
    [sym_bracketed_type] = STATE(3519),
    [sym_lifetime] = STATE(3551),
    [sym_array_type] = STATE(1678),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1678),
    [sym_tuple_type] = STATE(1678),
    [sym_unit_type] = STATE(1678),
    [sym_generic_type] = STATE(1604),
    [sym_generic_type_with_turbofish] = STATE(3511),
    [sym_bounded_type] = STATE(1678),
    [sym_reference_type] = STATE(1678),
    [sym_pointer_type] = STATE(1678),
    [sym_never_type] = STATE(1678),
    [sym_abstract_type] = STATE(1678),
    [sym_dynamic_type] = STATE(1678),
    [sym_macro_invocation] = STATE(1678),
    [sym_scoped_identifier] = STATE(3113),
    [sym_scoped_type_identifier] = STATE(1520),
    [sym_line_comment] = STATE(858),
    [sym_block_comment] = STATE(858),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(3081),
    [anon_sym_LPAREN] = ACTIONS(3083),
    [anon_sym_LBRACK] = ACTIONS(3085),
    [anon_sym_STAR] = ACTIONS(3089),
    [anon_sym_QMARK] = ACTIONS(3091),
    [anon_sym_u8] = ACTIONS(3093),
    [anon_sym_i8] = ACTIONS(3093),
    [anon_sym_u16] = ACTIONS(3093),
    [anon_sym_i16] = ACTIONS(3093),
    [anon_sym_u32] = ACTIONS(3093),
    [anon_sym_i32] = ACTIONS(3093),
    [anon_sym_u64] = ACTIONS(3093),
    [anon_sym_i64] = ACTIONS(3093),
    [anon_sym_u128] = ACTIONS(3093),
    [anon_sym_i128] = ACTIONS(3093),
    [anon_sym_isize] = ACTIONS(3093),
    [anon_sym_usize] = ACTIONS(3093),
    [anon_sym_f32] = ACTIONS(3093),
    [anon_sym_f64] = ACTIONS(3093),
    [anon_sym_bool] = ACTIONS(3093),
    [anon_sym_str] = ACTIONS(3093),
    [anon_sym_char] = ACTIONS(3093),
    [anon_sym_BANG] = ACTIONS(3095),
    [anon_sym_AMP] = ACTIONS(3097),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3099),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(3101),
    [anon_sym_fn] = ACTIONS(3103),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(3105),
    [anon_sym_union] = ACTIONS(3107),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(3109),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3113),
    [sym_super] = ACTIONS(3113),
    [sym_crate] = ACTIONS(3113),
    [sym_metavariable] = ACTIONS(3115),
  },
  [859] = {
    [sym_function_modifiers] = STATE(3321),
    [sym_removed_trait_bound] = STATE(1215),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1413),
    [sym_bracketed_type] = STATE(3504),
    [sym_lifetime] = STATE(3465),
    [sym_array_type] = STATE(1215),
    [sym_for_lifetimes] = STATE(1614),
    [sym_function_type] = STATE(1215),
    [sym_tuple_type] = STATE(1215),
    [sym_unit_type] = STATE(1215),
    [sym_generic_type] = STATE(1082),
    [sym_generic_type_with_turbofish] = STATE(3494),
    [sym_bounded_type] = STATE(1215),
    [sym_reference_type] = STATE(1215),
    [sym_pointer_type] = STATE(1215),
    [sym_never_type] = STATE(1215),
    [sym_abstract_type] = STATE(1215),
    [sym_dynamic_type] = STATE(1215),
    [sym_macro_invocation] = STATE(1215),
    [sym_scoped_identifier] = STATE(3299),
    [sym_scoped_type_identifier] = STATE(1022),
    [sym_line_comment] = STATE(859),
    [sym_block_comment] = STATE(859),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(3039),
    [anon_sym_LPAREN] = ACTIONS(3041),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_STAR] = ACTIONS(3047),
    [anon_sym_QMARK] = ACTIONS(3049),
    [anon_sym_u8] = ACTIONS(3051),
    [anon_sym_i8] = ACTIONS(3051),
    [anon_sym_u16] = ACTIONS(3051),
    [anon_sym_i16] = ACTIONS(3051),
    [anon_sym_u32] = ACTIONS(3051),
    [anon_sym_i32] = ACTIONS(3051),
    [anon_sym_u64] = ACTIONS(3051),
    [anon_sym_i64] = ACTIONS(3051),
    [anon_sym_u128] = ACTIONS(3051),
    [anon_sym_i128] = ACTIONS(3051),
    [anon_sym_isize] = ACTIONS(3051),
    [anon_sym_usize] = ACTIONS(3051),
    [anon_sym_f32] = ACTIONS(3051),
    [anon_sym_f64] = ACTIONS(3051),
    [anon_sym_bool] = ACTIONS(3051),
    [anon_sym_str] = ACTIONS(3051),
    [anon_sym_char] = ACTIONS(3051),
    [anon_sym_BANG] = ACTIONS(3053),
    [anon_sym_AMP] = ACTIONS(3055),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3057),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(3059),
    [anon_sym_fn] = ACTIONS(3061),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(3063),
    [anon_sym_union] = ACTIONS(3065),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(3067),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3071),
    [sym_super] = ACTIONS(3071),
    [sym_crate] = ACTIONS(3071),
    [sym_metavariable] = ACTIONS(3073),
  },
  [860] = {
    [sym_function_modifiers] = STATE(3462),
    [sym_removed_trait_bound] = STATE(1678),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1796),
    [sym_bracketed_type] = STATE(3519),
    [sym_lifetime] = STATE(3551),
    [sym_array_type] = STATE(1678),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1678),
    [sym_tuple_type] = STATE(1678),
    [sym_unit_type] = STATE(1678),
    [sym_generic_type] = STATE(1604),
    [sym_generic_type_with_turbofish] = STATE(3511),
    [sym_bounded_type] = STATE(1678),
    [sym_reference_type] = STATE(1678),
    [sym_pointer_type] = STATE(1678),
    [sym_never_type] = STATE(1678),
    [sym_abstract_type] = STATE(1678),
    [sym_dynamic_type] = STATE(1678),
    [sym_macro_invocation] = STATE(1678),
    [sym_scoped_identifier] = STATE(3113),
    [sym_scoped_type_identifier] = STATE(1520),
    [sym_line_comment] = STATE(860),
    [sym_block_comment] = STATE(860),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(3081),
    [anon_sym_LPAREN] = ACTIONS(3083),
    [anon_sym_LBRACK] = ACTIONS(3085),
    [anon_sym_STAR] = ACTIONS(3089),
    [anon_sym_QMARK] = ACTIONS(3091),
    [anon_sym_u8] = ACTIONS(3093),
    [anon_sym_i8] = ACTIONS(3093),
    [anon_sym_u16] = ACTIONS(3093),
    [anon_sym_i16] = ACTIONS(3093),
    [anon_sym_u32] = ACTIONS(3093),
    [anon_sym_i32] = ACTIONS(3093),
    [anon_sym_u64] = ACTIONS(3093),
    [anon_sym_i64] = ACTIONS(3093),
    [anon_sym_u128] = ACTIONS(3093),
    [anon_sym_i128] = ACTIONS(3093),
    [anon_sym_isize] = ACTIONS(3093),
    [anon_sym_usize] = ACTIONS(3093),
    [anon_sym_f32] = ACTIONS(3093),
    [anon_sym_f64] = ACTIONS(3093),
    [anon_sym_bool] = ACTIONS(3093),
    [anon_sym_str] = ACTIONS(3093),
    [anon_sym_char] = ACTIONS(3093),
    [anon_sym_BANG] = ACTIONS(3095),
    [anon_sym_AMP] = ACTIONS(3097),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3099),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(3101),
    [anon_sym_fn] = ACTIONS(3103),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(3105),
    [anon_sym_union] = ACTIONS(3107),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(3109),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3113),
    [sym_super] = ACTIONS(3113),
    [sym_crate] = ACTIONS(3113),
    [sym_metavariable] = ACTIONS(3115),
  },
  [861] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2362),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(861),
    [sym_block_comment] = STATE(861),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [862] = {
    [sym_function_modifiers] = STATE(3462),
    [sym_removed_trait_bound] = STATE(1678),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1633),
    [sym_bracketed_type] = STATE(3519),
    [sym_lifetime] = STATE(3551),
    [sym_array_type] = STATE(1678),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1678),
    [sym_tuple_type] = STATE(1678),
    [sym_unit_type] = STATE(1678),
    [sym_generic_type] = STATE(1604),
    [sym_generic_type_with_turbofish] = STATE(3511),
    [sym_bounded_type] = STATE(1678),
    [sym_reference_type] = STATE(1678),
    [sym_pointer_type] = STATE(1678),
    [sym_never_type] = STATE(1678),
    [sym_abstract_type] = STATE(1678),
    [sym_dynamic_type] = STATE(1678),
    [sym_macro_invocation] = STATE(1678),
    [sym_scoped_identifier] = STATE(3113),
    [sym_scoped_type_identifier] = STATE(1520),
    [sym_line_comment] = STATE(862),
    [sym_block_comment] = STATE(862),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(3081),
    [anon_sym_LPAREN] = ACTIONS(3083),
    [anon_sym_LBRACK] = ACTIONS(3085),
    [anon_sym_STAR] = ACTIONS(3089),
    [anon_sym_QMARK] = ACTIONS(3091),
    [anon_sym_u8] = ACTIONS(3093),
    [anon_sym_i8] = ACTIONS(3093),
    [anon_sym_u16] = ACTIONS(3093),
    [anon_sym_i16] = ACTIONS(3093),
    [anon_sym_u32] = ACTIONS(3093),
    [anon_sym_i32] = ACTIONS(3093),
    [anon_sym_u64] = ACTIONS(3093),
    [anon_sym_i64] = ACTIONS(3093),
    [anon_sym_u128] = ACTIONS(3093),
    [anon_sym_i128] = ACTIONS(3093),
    [anon_sym_isize] = ACTIONS(3093),
    [anon_sym_usize] = ACTIONS(3093),
    [anon_sym_f32] = ACTIONS(3093),
    [anon_sym_f64] = ACTIONS(3093),
    [anon_sym_bool] = ACTIONS(3093),
    [anon_sym_str] = ACTIONS(3093),
    [anon_sym_char] = ACTIONS(3093),
    [anon_sym_BANG] = ACTIONS(3095),
    [anon_sym_AMP] = ACTIONS(3097),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3099),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(3101),
    [anon_sym_fn] = ACTIONS(3103),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(3105),
    [anon_sym_union] = ACTIONS(3107),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(3109),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3113),
    [sym_super] = ACTIONS(3113),
    [sym_crate] = ACTIONS(3113),
    [sym_metavariable] = ACTIONS(3115),
  },
  [863] = {
    [sym_function_modifiers] = STATE(3321),
    [sym_removed_trait_bound] = STATE(1215),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1402),
    [sym_bracketed_type] = STATE(3504),
    [sym_lifetime] = STATE(3465),
    [sym_array_type] = STATE(1215),
    [sym_for_lifetimes] = STATE(1614),
    [sym_function_type] = STATE(1215),
    [sym_tuple_type] = STATE(1215),
    [sym_unit_type] = STATE(1215),
    [sym_generic_type] = STATE(1082),
    [sym_generic_type_with_turbofish] = STATE(3494),
    [sym_bounded_type] = STATE(1215),
    [sym_reference_type] = STATE(1215),
    [sym_pointer_type] = STATE(1215),
    [sym_never_type] = STATE(1215),
    [sym_abstract_type] = STATE(1215),
    [sym_dynamic_type] = STATE(1215),
    [sym_macro_invocation] = STATE(1215),
    [sym_scoped_identifier] = STATE(3299),
    [sym_scoped_type_identifier] = STATE(1022),
    [sym_line_comment] = STATE(863),
    [sym_block_comment] = STATE(863),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(3039),
    [anon_sym_LPAREN] = ACTIONS(3041),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_STAR] = ACTIONS(3047),
    [anon_sym_QMARK] = ACTIONS(3049),
    [anon_sym_u8] = ACTIONS(3051),
    [anon_sym_i8] = ACTIONS(3051),
    [anon_sym_u16] = ACTIONS(3051),
    [anon_sym_i16] = ACTIONS(3051),
    [anon_sym_u32] = ACTIONS(3051),
    [anon_sym_i32] = ACTIONS(3051),
    [anon_sym_u64] = ACTIONS(3051),
    [anon_sym_i64] = ACTIONS(3051),
    [anon_sym_u128] = ACTIONS(3051),
    [anon_sym_i128] = ACTIONS(3051),
    [anon_sym_isize] = ACTIONS(3051),
    [anon_sym_usize] = ACTIONS(3051),
    [anon_sym_f32] = ACTIONS(3051),
    [anon_sym_f64] = ACTIONS(3051),
    [anon_sym_bool] = ACTIONS(3051),
    [anon_sym_str] = ACTIONS(3051),
    [anon_sym_char] = ACTIONS(3051),
    [anon_sym_BANG] = ACTIONS(3053),
    [anon_sym_AMP] = ACTIONS(3055),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3057),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(3059),
    [anon_sym_fn] = ACTIONS(3061),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(3063),
    [anon_sym_union] = ACTIONS(3065),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(3067),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3071),
    [sym_super] = ACTIONS(3071),
    [sym_crate] = ACTIONS(3071),
    [sym_metavariable] = ACTIONS(3073),
  },
  [864] = {
    [sym_function_modifiers] = STATE(3462),
    [sym_removed_trait_bound] = STATE(1678),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1632),
    [sym_bracketed_type] = STATE(3519),
    [sym_lifetime] = STATE(3551),
    [sym_array_type] = STATE(1678),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1678),
    [sym_tuple_type] = STATE(1678),
    [sym_unit_type] = STATE(1678),
    [sym_generic_type] = STATE(1604),
    [sym_generic_type_with_turbofish] = STATE(3511),
    [sym_bounded_type] = STATE(1678),
    [sym_reference_type] = STATE(1678),
    [sym_pointer_type] = STATE(1678),
    [sym_never_type] = STATE(1678),
    [sym_abstract_type] = STATE(1678),
    [sym_dynamic_type] = STATE(1678),
    [sym_macro_invocation] = STATE(1678),
    [sym_scoped_identifier] = STATE(3113),
    [sym_scoped_type_identifier] = STATE(1520),
    [sym_line_comment] = STATE(864),
    [sym_block_comment] = STATE(864),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(3081),
    [anon_sym_LPAREN] = ACTIONS(3083),
    [anon_sym_LBRACK] = ACTIONS(3085),
    [anon_sym_STAR] = ACTIONS(3089),
    [anon_sym_QMARK] = ACTIONS(3091),
    [anon_sym_u8] = ACTIONS(3093),
    [anon_sym_i8] = ACTIONS(3093),
    [anon_sym_u16] = ACTIONS(3093),
    [anon_sym_i16] = ACTIONS(3093),
    [anon_sym_u32] = ACTIONS(3093),
    [anon_sym_i32] = ACTIONS(3093),
    [anon_sym_u64] = ACTIONS(3093),
    [anon_sym_i64] = ACTIONS(3093),
    [anon_sym_u128] = ACTIONS(3093),
    [anon_sym_i128] = ACTIONS(3093),
    [anon_sym_isize] = ACTIONS(3093),
    [anon_sym_usize] = ACTIONS(3093),
    [anon_sym_f32] = ACTIONS(3093),
    [anon_sym_f64] = ACTIONS(3093),
    [anon_sym_bool] = ACTIONS(3093),
    [anon_sym_str] = ACTIONS(3093),
    [anon_sym_char] = ACTIONS(3093),
    [anon_sym_BANG] = ACTIONS(3095),
    [anon_sym_AMP] = ACTIONS(3097),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3099),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(3101),
    [anon_sym_fn] = ACTIONS(3103),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(3105),
    [anon_sym_union] = ACTIONS(3107),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(3109),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3113),
    [sym_super] = ACTIONS(3113),
    [sym_crate] = ACTIONS(3113),
    [sym_metavariable] = ACTIONS(3115),
  },
  [865] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2292),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(865),
    [sym_block_comment] = STATE(865),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [866] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2626),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(866),
    [sym_block_comment] = STATE(866),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [867] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2177),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(867),
    [sym_block_comment] = STATE(867),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [868] = {
    [sym_function_modifiers] = STATE(3321),
    [sym_removed_trait_bound] = STATE(1215),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1373),
    [sym_bracketed_type] = STATE(3504),
    [sym_lifetime] = STATE(3465),
    [sym_array_type] = STATE(1215),
    [sym_for_lifetimes] = STATE(1614),
    [sym_function_type] = STATE(1215),
    [sym_tuple_type] = STATE(1215),
    [sym_unit_type] = STATE(1215),
    [sym_generic_type] = STATE(1082),
    [sym_generic_type_with_turbofish] = STATE(3494),
    [sym_bounded_type] = STATE(1215),
    [sym_reference_type] = STATE(1215),
    [sym_pointer_type] = STATE(1215),
    [sym_never_type] = STATE(1215),
    [sym_abstract_type] = STATE(1215),
    [sym_dynamic_type] = STATE(1215),
    [sym_macro_invocation] = STATE(1215),
    [sym_scoped_identifier] = STATE(3299),
    [sym_scoped_type_identifier] = STATE(1022),
    [sym_line_comment] = STATE(868),
    [sym_block_comment] = STATE(868),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(3039),
    [anon_sym_LPAREN] = ACTIONS(3041),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_STAR] = ACTIONS(3047),
    [anon_sym_QMARK] = ACTIONS(3049),
    [anon_sym_u8] = ACTIONS(3051),
    [anon_sym_i8] = ACTIONS(3051),
    [anon_sym_u16] = ACTIONS(3051),
    [anon_sym_i16] = ACTIONS(3051),
    [anon_sym_u32] = ACTIONS(3051),
    [anon_sym_i32] = ACTIONS(3051),
    [anon_sym_u64] = ACTIONS(3051),
    [anon_sym_i64] = ACTIONS(3051),
    [anon_sym_u128] = ACTIONS(3051),
    [anon_sym_i128] = ACTIONS(3051),
    [anon_sym_isize] = ACTIONS(3051),
    [anon_sym_usize] = ACTIONS(3051),
    [anon_sym_f32] = ACTIONS(3051),
    [anon_sym_f64] = ACTIONS(3051),
    [anon_sym_bool] = ACTIONS(3051),
    [anon_sym_str] = ACTIONS(3051),
    [anon_sym_char] = ACTIONS(3051),
    [anon_sym_BANG] = ACTIONS(3053),
    [anon_sym_AMP] = ACTIONS(3055),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3057),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(3059),
    [anon_sym_fn] = ACTIONS(3061),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(3063),
    [anon_sym_union] = ACTIONS(3065),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(3067),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3071),
    [sym_super] = ACTIONS(3071),
    [sym_crate] = ACTIONS(3071),
    [sym_metavariable] = ACTIONS(3073),
  },
  [869] = {
    [sym_function_modifiers] = STATE(3321),
    [sym_removed_trait_bound] = STATE(1215),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1410),
    [sym_bracketed_type] = STATE(3504),
    [sym_lifetime] = STATE(3465),
    [sym_array_type] = STATE(1215),
    [sym_for_lifetimes] = STATE(1614),
    [sym_function_type] = STATE(1215),
    [sym_tuple_type] = STATE(1215),
    [sym_unit_type] = STATE(1215),
    [sym_generic_type] = STATE(1082),
    [sym_generic_type_with_turbofish] = STATE(3494),
    [sym_bounded_type] = STATE(1215),
    [sym_reference_type] = STATE(1215),
    [sym_pointer_type] = STATE(1215),
    [sym_never_type] = STATE(1215),
    [sym_abstract_type] = STATE(1215),
    [sym_dynamic_type] = STATE(1215),
    [sym_macro_invocation] = STATE(1215),
    [sym_scoped_identifier] = STATE(3299),
    [sym_scoped_type_identifier] = STATE(1022),
    [sym_line_comment] = STATE(869),
    [sym_block_comment] = STATE(869),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(3039),
    [anon_sym_LPAREN] = ACTIONS(3041),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_STAR] = ACTIONS(3047),
    [anon_sym_QMARK] = ACTIONS(3049),
    [anon_sym_u8] = ACTIONS(3051),
    [anon_sym_i8] = ACTIONS(3051),
    [anon_sym_u16] = ACTIONS(3051),
    [anon_sym_i16] = ACTIONS(3051),
    [anon_sym_u32] = ACTIONS(3051),
    [anon_sym_i32] = ACTIONS(3051),
    [anon_sym_u64] = ACTIONS(3051),
    [anon_sym_i64] = ACTIONS(3051),
    [anon_sym_u128] = ACTIONS(3051),
    [anon_sym_i128] = ACTIONS(3051),
    [anon_sym_isize] = ACTIONS(3051),
    [anon_sym_usize] = ACTIONS(3051),
    [anon_sym_f32] = ACTIONS(3051),
    [anon_sym_f64] = ACTIONS(3051),
    [anon_sym_bool] = ACTIONS(3051),
    [anon_sym_str] = ACTIONS(3051),
    [anon_sym_char] = ACTIONS(3051),
    [anon_sym_BANG] = ACTIONS(3053),
    [anon_sym_AMP] = ACTIONS(3055),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3057),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(3059),
    [anon_sym_fn] = ACTIONS(3061),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(3063),
    [anon_sym_union] = ACTIONS(3065),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(3067),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3071),
    [sym_super] = ACTIONS(3071),
    [sym_crate] = ACTIONS(3071),
    [sym_metavariable] = ACTIONS(3073),
  },
  [870] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2510),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(870),
    [sym_block_comment] = STATE(870),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [871] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2296),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(871),
    [sym_block_comment] = STATE(871),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [872] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1963),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(872),
    [sym_block_comment] = STATE(872),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [873] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2684),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(873),
    [sym_block_comment] = STATE(873),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [874] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2317),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(874),
    [sym_block_comment] = STATE(874),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [875] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2318),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(875),
    [sym_block_comment] = STATE(875),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [876] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2322),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(876),
    [sym_block_comment] = STATE(876),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [877] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2297),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(877),
    [sym_block_comment] = STATE(877),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [878] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2697),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(878),
    [sym_block_comment] = STATE(878),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [879] = {
    [sym_function_modifiers] = STATE(3321),
    [sym_removed_trait_bound] = STATE(1215),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1423),
    [sym_bracketed_type] = STATE(3504),
    [sym_lifetime] = STATE(3465),
    [sym_array_type] = STATE(1215),
    [sym_for_lifetimes] = STATE(1614),
    [sym_function_type] = STATE(1215),
    [sym_tuple_type] = STATE(1215),
    [sym_unit_type] = STATE(1215),
    [sym_generic_type] = STATE(1082),
    [sym_generic_type_with_turbofish] = STATE(3494),
    [sym_bounded_type] = STATE(1215),
    [sym_reference_type] = STATE(1215),
    [sym_pointer_type] = STATE(1215),
    [sym_never_type] = STATE(1215),
    [sym_abstract_type] = STATE(1215),
    [sym_dynamic_type] = STATE(1215),
    [sym_macro_invocation] = STATE(1215),
    [sym_scoped_identifier] = STATE(3299),
    [sym_scoped_type_identifier] = STATE(1022),
    [sym_line_comment] = STATE(879),
    [sym_block_comment] = STATE(879),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(3039),
    [anon_sym_LPAREN] = ACTIONS(3041),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_STAR] = ACTIONS(3047),
    [anon_sym_QMARK] = ACTIONS(3049),
    [anon_sym_u8] = ACTIONS(3051),
    [anon_sym_i8] = ACTIONS(3051),
    [anon_sym_u16] = ACTIONS(3051),
    [anon_sym_i16] = ACTIONS(3051),
    [anon_sym_u32] = ACTIONS(3051),
    [anon_sym_i32] = ACTIONS(3051),
    [anon_sym_u64] = ACTIONS(3051),
    [anon_sym_i64] = ACTIONS(3051),
    [anon_sym_u128] = ACTIONS(3051),
    [anon_sym_i128] = ACTIONS(3051),
    [anon_sym_isize] = ACTIONS(3051),
    [anon_sym_usize] = ACTIONS(3051),
    [anon_sym_f32] = ACTIONS(3051),
    [anon_sym_f64] = ACTIONS(3051),
    [anon_sym_bool] = ACTIONS(3051),
    [anon_sym_str] = ACTIONS(3051),
    [anon_sym_char] = ACTIONS(3051),
    [anon_sym_BANG] = ACTIONS(3053),
    [anon_sym_AMP] = ACTIONS(3055),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3057),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(3059),
    [anon_sym_fn] = ACTIONS(3061),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(3063),
    [anon_sym_union] = ACTIONS(3065),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(3067),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3071),
    [sym_super] = ACTIONS(3071),
    [sym_crate] = ACTIONS(3071),
    [sym_metavariable] = ACTIONS(3073),
  },
  [880] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2790),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(880),
    [sym_block_comment] = STATE(880),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [881] = {
    [sym_function_modifiers] = STATE(3462),
    [sym_removed_trait_bound] = STATE(1678),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1715),
    [sym_bracketed_type] = STATE(3519),
    [sym_lifetime] = STATE(3551),
    [sym_array_type] = STATE(1678),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1678),
    [sym_tuple_type] = STATE(1678),
    [sym_unit_type] = STATE(1678),
    [sym_generic_type] = STATE(1604),
    [sym_generic_type_with_turbofish] = STATE(3511),
    [sym_bounded_type] = STATE(1678),
    [sym_reference_type] = STATE(1678),
    [sym_pointer_type] = STATE(1678),
    [sym_never_type] = STATE(1678),
    [sym_abstract_type] = STATE(1678),
    [sym_dynamic_type] = STATE(1678),
    [sym_macro_invocation] = STATE(1678),
    [sym_scoped_identifier] = STATE(3113),
    [sym_scoped_type_identifier] = STATE(1520),
    [sym_line_comment] = STATE(881),
    [sym_block_comment] = STATE(881),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(3081),
    [anon_sym_LPAREN] = ACTIONS(3083),
    [anon_sym_LBRACK] = ACTIONS(3085),
    [anon_sym_STAR] = ACTIONS(3089),
    [anon_sym_QMARK] = ACTIONS(3091),
    [anon_sym_u8] = ACTIONS(3093),
    [anon_sym_i8] = ACTIONS(3093),
    [anon_sym_u16] = ACTIONS(3093),
    [anon_sym_i16] = ACTIONS(3093),
    [anon_sym_u32] = ACTIONS(3093),
    [anon_sym_i32] = ACTIONS(3093),
    [anon_sym_u64] = ACTIONS(3093),
    [anon_sym_i64] = ACTIONS(3093),
    [anon_sym_u128] = ACTIONS(3093),
    [anon_sym_i128] = ACTIONS(3093),
    [anon_sym_isize] = ACTIONS(3093),
    [anon_sym_usize] = ACTIONS(3093),
    [anon_sym_f32] = ACTIONS(3093),
    [anon_sym_f64] = ACTIONS(3093),
    [anon_sym_bool] = ACTIONS(3093),
    [anon_sym_str] = ACTIONS(3093),
    [anon_sym_char] = ACTIONS(3093),
    [anon_sym_BANG] = ACTIONS(3095),
    [anon_sym_AMP] = ACTIONS(3097),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3099),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(3101),
    [anon_sym_fn] = ACTIONS(3103),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(3105),
    [anon_sym_union] = ACTIONS(3107),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(3109),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3113),
    [sym_super] = ACTIONS(3113),
    [sym_crate] = ACTIONS(3113),
    [sym_metavariable] = ACTIONS(3115),
  },
  [882] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2926),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(882),
    [sym_block_comment] = STATE(882),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [883] = {
    [sym_function_modifiers] = STATE(3462),
    [sym_removed_trait_bound] = STATE(1678),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1780),
    [sym_bracketed_type] = STATE(3519),
    [sym_lifetime] = STATE(3551),
    [sym_array_type] = STATE(1678),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1678),
    [sym_tuple_type] = STATE(1678),
    [sym_unit_type] = STATE(1678),
    [sym_generic_type] = STATE(1604),
    [sym_generic_type_with_turbofish] = STATE(3511),
    [sym_bounded_type] = STATE(1678),
    [sym_reference_type] = STATE(1678),
    [sym_pointer_type] = STATE(1678),
    [sym_never_type] = STATE(1678),
    [sym_abstract_type] = STATE(1678),
    [sym_dynamic_type] = STATE(1678),
    [sym_macro_invocation] = STATE(1678),
    [sym_scoped_identifier] = STATE(3113),
    [sym_scoped_type_identifier] = STATE(1520),
    [sym_line_comment] = STATE(883),
    [sym_block_comment] = STATE(883),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(3081),
    [anon_sym_LPAREN] = ACTIONS(3083),
    [anon_sym_LBRACK] = ACTIONS(3085),
    [anon_sym_STAR] = ACTIONS(3089),
    [anon_sym_QMARK] = ACTIONS(3091),
    [anon_sym_u8] = ACTIONS(3093),
    [anon_sym_i8] = ACTIONS(3093),
    [anon_sym_u16] = ACTIONS(3093),
    [anon_sym_i16] = ACTIONS(3093),
    [anon_sym_u32] = ACTIONS(3093),
    [anon_sym_i32] = ACTIONS(3093),
    [anon_sym_u64] = ACTIONS(3093),
    [anon_sym_i64] = ACTIONS(3093),
    [anon_sym_u128] = ACTIONS(3093),
    [anon_sym_i128] = ACTIONS(3093),
    [anon_sym_isize] = ACTIONS(3093),
    [anon_sym_usize] = ACTIONS(3093),
    [anon_sym_f32] = ACTIONS(3093),
    [anon_sym_f64] = ACTIONS(3093),
    [anon_sym_bool] = ACTIONS(3093),
    [anon_sym_str] = ACTIONS(3093),
    [anon_sym_char] = ACTIONS(3093),
    [anon_sym_BANG] = ACTIONS(3095),
    [anon_sym_AMP] = ACTIONS(3097),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3099),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(3101),
    [anon_sym_fn] = ACTIONS(3103),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(3105),
    [anon_sym_union] = ACTIONS(3107),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(3109),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3113),
    [sym_super] = ACTIONS(3113),
    [sym_crate] = ACTIONS(3113),
    [sym_metavariable] = ACTIONS(3115),
  },
  [884] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(3156),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(884),
    [sym_block_comment] = STATE(884),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [885] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1957),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(1980),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(885),
    [sym_block_comment] = STATE(885),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2953),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [886] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2323),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(886),
    [sym_block_comment] = STATE(886),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [887] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2439),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(887),
    [sym_block_comment] = STATE(887),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [888] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2194),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(888),
    [sym_block_comment] = STATE(888),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [889] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(3017),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(889),
    [sym_block_comment] = STATE(889),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [890] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2299),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(2300),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(2138),
    [sym_line_comment] = STATE(890),
    [sym_block_comment] = STATE(890),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(3167),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(3169),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [891] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1963),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(891),
    [sym_block_comment] = STATE(891),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3171),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [892] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2690),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(892),
    [sym_block_comment] = STATE(892),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [893] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2882),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(893),
    [sym_block_comment] = STATE(893),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [894] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2364),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(894),
    [sym_block_comment] = STATE(894),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [895] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(3073),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(895),
    [sym_block_comment] = STATE(895),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [896] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2692),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(896),
    [sym_block_comment] = STATE(896),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [897] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2649),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(897),
    [sym_block_comment] = STATE(897),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [898] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2425),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(898),
    [sym_block_comment] = STATE(898),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [899] = {
    [sym_function_modifiers] = STATE(3321),
    [sym_removed_trait_bound] = STATE(1215),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1425),
    [sym_bracketed_type] = STATE(3504),
    [sym_lifetime] = STATE(3465),
    [sym_array_type] = STATE(1215),
    [sym_for_lifetimes] = STATE(1614),
    [sym_function_type] = STATE(1215),
    [sym_tuple_type] = STATE(1215),
    [sym_unit_type] = STATE(1215),
    [sym_generic_type] = STATE(1082),
    [sym_generic_type_with_turbofish] = STATE(3494),
    [sym_bounded_type] = STATE(1215),
    [sym_reference_type] = STATE(1215),
    [sym_pointer_type] = STATE(1215),
    [sym_never_type] = STATE(1215),
    [sym_abstract_type] = STATE(1215),
    [sym_dynamic_type] = STATE(1215),
    [sym_macro_invocation] = STATE(1215),
    [sym_scoped_identifier] = STATE(3299),
    [sym_scoped_type_identifier] = STATE(1022),
    [sym_line_comment] = STATE(899),
    [sym_block_comment] = STATE(899),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(3039),
    [anon_sym_LPAREN] = ACTIONS(3041),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_STAR] = ACTIONS(3047),
    [anon_sym_QMARK] = ACTIONS(3049),
    [anon_sym_u8] = ACTIONS(3051),
    [anon_sym_i8] = ACTIONS(3051),
    [anon_sym_u16] = ACTIONS(3051),
    [anon_sym_i16] = ACTIONS(3051),
    [anon_sym_u32] = ACTIONS(3051),
    [anon_sym_i32] = ACTIONS(3051),
    [anon_sym_u64] = ACTIONS(3051),
    [anon_sym_i64] = ACTIONS(3051),
    [anon_sym_u128] = ACTIONS(3051),
    [anon_sym_i128] = ACTIONS(3051),
    [anon_sym_isize] = ACTIONS(3051),
    [anon_sym_usize] = ACTIONS(3051),
    [anon_sym_f32] = ACTIONS(3051),
    [anon_sym_f64] = ACTIONS(3051),
    [anon_sym_bool] = ACTIONS(3051),
    [anon_sym_str] = ACTIONS(3051),
    [anon_sym_char] = ACTIONS(3051),
    [anon_sym_BANG] = ACTIONS(3053),
    [anon_sym_AMP] = ACTIONS(3055),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3057),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(3059),
    [anon_sym_fn] = ACTIONS(3061),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(3063),
    [anon_sym_union] = ACTIONS(3065),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(3067),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3071),
    [sym_super] = ACTIONS(3071),
    [sym_crate] = ACTIONS(3071),
    [sym_metavariable] = ACTIONS(3073),
  },
  [900] = {
    [sym_function_modifiers] = STATE(3321),
    [sym_removed_trait_bound] = STATE(1215),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1226),
    [sym_bracketed_type] = STATE(3504),
    [sym_lifetime] = STATE(3465),
    [sym_array_type] = STATE(1215),
    [sym_for_lifetimes] = STATE(1614),
    [sym_function_type] = STATE(1215),
    [sym_tuple_type] = STATE(1215),
    [sym_unit_type] = STATE(1215),
    [sym_generic_type] = STATE(1082),
    [sym_generic_type_with_turbofish] = STATE(3494),
    [sym_bounded_type] = STATE(1215),
    [sym_reference_type] = STATE(1215),
    [sym_pointer_type] = STATE(1215),
    [sym_never_type] = STATE(1215),
    [sym_abstract_type] = STATE(1215),
    [sym_dynamic_type] = STATE(1215),
    [sym_macro_invocation] = STATE(1215),
    [sym_scoped_identifier] = STATE(3299),
    [sym_scoped_type_identifier] = STATE(1022),
    [sym_line_comment] = STATE(900),
    [sym_block_comment] = STATE(900),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(3039),
    [anon_sym_LPAREN] = ACTIONS(3041),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_STAR] = ACTIONS(3047),
    [anon_sym_QMARK] = ACTIONS(3049),
    [anon_sym_u8] = ACTIONS(3051),
    [anon_sym_i8] = ACTIONS(3051),
    [anon_sym_u16] = ACTIONS(3051),
    [anon_sym_i16] = ACTIONS(3051),
    [anon_sym_u32] = ACTIONS(3051),
    [anon_sym_i32] = ACTIONS(3051),
    [anon_sym_u64] = ACTIONS(3051),
    [anon_sym_i64] = ACTIONS(3051),
    [anon_sym_u128] = ACTIONS(3051),
    [anon_sym_i128] = ACTIONS(3051),
    [anon_sym_isize] = ACTIONS(3051),
    [anon_sym_usize] = ACTIONS(3051),
    [anon_sym_f32] = ACTIONS(3051),
    [anon_sym_f64] = ACTIONS(3051),
    [anon_sym_bool] = ACTIONS(3051),
    [anon_sym_str] = ACTIONS(3051),
    [anon_sym_char] = ACTIONS(3051),
    [anon_sym_BANG] = ACTIONS(3053),
    [anon_sym_AMP] = ACTIONS(3055),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3057),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(3059),
    [anon_sym_fn] = ACTIONS(3061),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(3063),
    [anon_sym_union] = ACTIONS(3065),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(3067),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3071),
    [sym_super] = ACTIONS(3071),
    [sym_crate] = ACTIONS(3071),
    [sym_metavariable] = ACTIONS(3073),
  },
  [901] = {
    [sym_function_modifiers] = STATE(3321),
    [sym_removed_trait_bound] = STATE(1215),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1427),
    [sym_bracketed_type] = STATE(3504),
    [sym_lifetime] = STATE(3465),
    [sym_array_type] = STATE(1215),
    [sym_for_lifetimes] = STATE(1614),
    [sym_function_type] = STATE(1215),
    [sym_tuple_type] = STATE(1215),
    [sym_unit_type] = STATE(1215),
    [sym_generic_type] = STATE(1082),
    [sym_generic_type_with_turbofish] = STATE(3494),
    [sym_bounded_type] = STATE(1215),
    [sym_reference_type] = STATE(1215),
    [sym_pointer_type] = STATE(1215),
    [sym_never_type] = STATE(1215),
    [sym_abstract_type] = STATE(1215),
    [sym_dynamic_type] = STATE(1215),
    [sym_macro_invocation] = STATE(1215),
    [sym_scoped_identifier] = STATE(3299),
    [sym_scoped_type_identifier] = STATE(1022),
    [sym_line_comment] = STATE(901),
    [sym_block_comment] = STATE(901),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(3039),
    [anon_sym_LPAREN] = ACTIONS(3041),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_STAR] = ACTIONS(3047),
    [anon_sym_QMARK] = ACTIONS(3049),
    [anon_sym_u8] = ACTIONS(3051),
    [anon_sym_i8] = ACTIONS(3051),
    [anon_sym_u16] = ACTIONS(3051),
    [anon_sym_i16] = ACTIONS(3051),
    [anon_sym_u32] = ACTIONS(3051),
    [anon_sym_i32] = ACTIONS(3051),
    [anon_sym_u64] = ACTIONS(3051),
    [anon_sym_i64] = ACTIONS(3051),
    [anon_sym_u128] = ACTIONS(3051),
    [anon_sym_i128] = ACTIONS(3051),
    [anon_sym_isize] = ACTIONS(3051),
    [anon_sym_usize] = ACTIONS(3051),
    [anon_sym_f32] = ACTIONS(3051),
    [anon_sym_f64] = ACTIONS(3051),
    [anon_sym_bool] = ACTIONS(3051),
    [anon_sym_str] = ACTIONS(3051),
    [anon_sym_char] = ACTIONS(3051),
    [anon_sym_BANG] = ACTIONS(3053),
    [anon_sym_AMP] = ACTIONS(3055),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3057),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(3059),
    [anon_sym_fn] = ACTIONS(3061),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(3063),
    [anon_sym_union] = ACTIONS(3065),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(3067),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3071),
    [sym_super] = ACTIONS(3071),
    [sym_crate] = ACTIONS(3071),
    [sym_metavariable] = ACTIONS(3073),
  },
  [902] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2707),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(902),
    [sym_block_comment] = STATE(902),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [903] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1976),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(903),
    [sym_block_comment] = STATE(903),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [904] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2680),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(904),
    [sym_block_comment] = STATE(904),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [905] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1957),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(1980),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(905),
    [sym_block_comment] = STATE(905),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [906] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2173),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(906),
    [sym_block_comment] = STATE(906),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [907] = {
    [sym_function_modifiers] = STATE(3321),
    [sym_removed_trait_bound] = STATE(1215),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1227),
    [sym_bracketed_type] = STATE(3504),
    [sym_lifetime] = STATE(3465),
    [sym_array_type] = STATE(1215),
    [sym_for_lifetimes] = STATE(1614),
    [sym_function_type] = STATE(1215),
    [sym_tuple_type] = STATE(1215),
    [sym_unit_type] = STATE(1215),
    [sym_generic_type] = STATE(1082),
    [sym_generic_type_with_turbofish] = STATE(3494),
    [sym_bounded_type] = STATE(1215),
    [sym_reference_type] = STATE(1215),
    [sym_pointer_type] = STATE(1215),
    [sym_never_type] = STATE(1215),
    [sym_abstract_type] = STATE(1215),
    [sym_dynamic_type] = STATE(1215),
    [sym_macro_invocation] = STATE(1215),
    [sym_scoped_identifier] = STATE(3299),
    [sym_scoped_type_identifier] = STATE(1022),
    [sym_line_comment] = STATE(907),
    [sym_block_comment] = STATE(907),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(3039),
    [anon_sym_LPAREN] = ACTIONS(3041),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_STAR] = ACTIONS(3047),
    [anon_sym_QMARK] = ACTIONS(3049),
    [anon_sym_u8] = ACTIONS(3051),
    [anon_sym_i8] = ACTIONS(3051),
    [anon_sym_u16] = ACTIONS(3051),
    [anon_sym_i16] = ACTIONS(3051),
    [anon_sym_u32] = ACTIONS(3051),
    [anon_sym_i32] = ACTIONS(3051),
    [anon_sym_u64] = ACTIONS(3051),
    [anon_sym_i64] = ACTIONS(3051),
    [anon_sym_u128] = ACTIONS(3051),
    [anon_sym_i128] = ACTIONS(3051),
    [anon_sym_isize] = ACTIONS(3051),
    [anon_sym_usize] = ACTIONS(3051),
    [anon_sym_f32] = ACTIONS(3051),
    [anon_sym_f64] = ACTIONS(3051),
    [anon_sym_bool] = ACTIONS(3051),
    [anon_sym_str] = ACTIONS(3051),
    [anon_sym_char] = ACTIONS(3051),
    [anon_sym_BANG] = ACTIONS(3053),
    [anon_sym_AMP] = ACTIONS(3055),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3057),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(3059),
    [anon_sym_fn] = ACTIONS(3061),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(3063),
    [anon_sym_union] = ACTIONS(3065),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(3067),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3071),
    [sym_super] = ACTIONS(3071),
    [sym_crate] = ACTIONS(3071),
    [sym_metavariable] = ACTIONS(3073),
  },
  [908] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2301),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(908),
    [sym_block_comment] = STATE(908),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [909] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2683),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(909),
    [sym_block_comment] = STATE(909),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [910] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2196),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(910),
    [sym_block_comment] = STATE(910),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [911] = {
    [sym_function_modifiers] = STATE(3321),
    [sym_removed_trait_bound] = STATE(1215),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1105),
    [sym_bracketed_type] = STATE(3504),
    [sym_lifetime] = STATE(3465),
    [sym_array_type] = STATE(1215),
    [sym_for_lifetimes] = STATE(1614),
    [sym_function_type] = STATE(1215),
    [sym_tuple_type] = STATE(1215),
    [sym_unit_type] = STATE(1215),
    [sym_generic_type] = STATE(1082),
    [sym_generic_type_with_turbofish] = STATE(3494),
    [sym_bounded_type] = STATE(1215),
    [sym_reference_type] = STATE(1215),
    [sym_pointer_type] = STATE(1215),
    [sym_never_type] = STATE(1215),
    [sym_abstract_type] = STATE(1215),
    [sym_dynamic_type] = STATE(1215),
    [sym_macro_invocation] = STATE(1215),
    [sym_scoped_identifier] = STATE(3299),
    [sym_scoped_type_identifier] = STATE(1022),
    [sym_line_comment] = STATE(911),
    [sym_block_comment] = STATE(911),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(3039),
    [anon_sym_LPAREN] = ACTIONS(3041),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_STAR] = ACTIONS(3047),
    [anon_sym_QMARK] = ACTIONS(3049),
    [anon_sym_u8] = ACTIONS(3051),
    [anon_sym_i8] = ACTIONS(3051),
    [anon_sym_u16] = ACTIONS(3051),
    [anon_sym_i16] = ACTIONS(3051),
    [anon_sym_u32] = ACTIONS(3051),
    [anon_sym_i32] = ACTIONS(3051),
    [anon_sym_u64] = ACTIONS(3051),
    [anon_sym_i64] = ACTIONS(3051),
    [anon_sym_u128] = ACTIONS(3051),
    [anon_sym_i128] = ACTIONS(3051),
    [anon_sym_isize] = ACTIONS(3051),
    [anon_sym_usize] = ACTIONS(3051),
    [anon_sym_f32] = ACTIONS(3051),
    [anon_sym_f64] = ACTIONS(3051),
    [anon_sym_bool] = ACTIONS(3051),
    [anon_sym_str] = ACTIONS(3051),
    [anon_sym_char] = ACTIONS(3051),
    [anon_sym_BANG] = ACTIONS(3053),
    [anon_sym_AMP] = ACTIONS(3055),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3057),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(3059),
    [anon_sym_fn] = ACTIONS(3061),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(3063),
    [anon_sym_union] = ACTIONS(3065),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(3067),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3071),
    [sym_super] = ACTIONS(3071),
    [sym_crate] = ACTIONS(3071),
    [sym_metavariable] = ACTIONS(3073),
  },
  [912] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2169),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(912),
    [sym_block_comment] = STATE(912),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [913] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2897),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(913),
    [sym_block_comment] = STATE(913),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [914] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2630),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(914),
    [sym_block_comment] = STATE(914),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [915] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2896),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(915),
    [sym_block_comment] = STATE(915),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [916] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1984),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(916),
    [sym_block_comment] = STATE(916),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [917] = {
    [sym_line_comment] = STATE(917),
    [sym_block_comment] = STATE(917),
    [sym_identifier] = ACTIONS(2729),
    [anon_sym_LPAREN] = ACTIONS(2727),
    [anon_sym_LBRACK] = ACTIONS(2727),
    [anon_sym_RBRACK] = ACTIONS(2727),
    [anon_sym_LBRACE] = ACTIONS(2727),
    [anon_sym_STAR] = ACTIONS(2727),
    [anon_sym_u8] = ACTIONS(2729),
    [anon_sym_i8] = ACTIONS(2729),
    [anon_sym_u16] = ACTIONS(2729),
    [anon_sym_i16] = ACTIONS(2729),
    [anon_sym_u32] = ACTIONS(2729),
    [anon_sym_i32] = ACTIONS(2729),
    [anon_sym_u64] = ACTIONS(2729),
    [anon_sym_i64] = ACTIONS(2729),
    [anon_sym_u128] = ACTIONS(2729),
    [anon_sym_i128] = ACTIONS(2729),
    [anon_sym_isize] = ACTIONS(2729),
    [anon_sym_usize] = ACTIONS(2729),
    [anon_sym_f32] = ACTIONS(2729),
    [anon_sym_f64] = ACTIONS(2729),
    [anon_sym_bool] = ACTIONS(2729),
    [anon_sym_str] = ACTIONS(2729),
    [anon_sym_char] = ACTIONS(2729),
    [anon_sym_DASH] = ACTIONS(2727),
    [anon_sym_BANG] = ACTIONS(2727),
    [anon_sym_AMP] = ACTIONS(2727),
    [anon_sym_PIPE] = ACTIONS(2727),
    [anon_sym_LT] = ACTIONS(2727),
    [anon_sym__] = ACTIONS(2729),
    [anon_sym_DOT_DOT] = ACTIONS(2727),
    [anon_sym_COMMA] = ACTIONS(2727),
    [anon_sym_COLON_COLON] = ACTIONS(2727),
    [anon_sym_POUND] = ACTIONS(2727),
    [anon_sym_SQUOTE] = ACTIONS(2729),
    [anon_sym_async] = ACTIONS(2729),
    [anon_sym_break] = ACTIONS(2729),
    [anon_sym_const] = ACTIONS(2729),
    [anon_sym_continue] = ACTIONS(2729),
    [anon_sym_default] = ACTIONS(2729),
    [anon_sym_for] = ACTIONS(2729),
    [anon_sym_if] = ACTIONS(2729),
    [anon_sym_loop] = ACTIONS(2729),
    [anon_sym_match] = ACTIONS(2729),
    [anon_sym_return] = ACTIONS(2729),
    [anon_sym_static] = ACTIONS(2729),
    [anon_sym_union] = ACTIONS(2729),
    [anon_sym_unsafe] = ACTIONS(2729),
    [anon_sym_while] = ACTIONS(2729),
    [anon_sym_ref] = ACTIONS(2729),
    [sym_mutable_specifier] = ACTIONS(2729),
    [anon_sym_yield] = ACTIONS(2729),
    [anon_sym_move] = ACTIONS(2729),
    [anon_sym_try] = ACTIONS(2729),
    [sym_integer_literal] = ACTIONS(2727),
    [aux_sym_string_literal_token1] = ACTIONS(2727),
    [sym_char_literal] = ACTIONS(2727),
    [anon_sym_true] = ACTIONS(2729),
    [anon_sym_false] = ACTIONS(2729),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(2729),
    [sym_super] = ACTIONS(2729),
    [sym_crate] = ACTIONS(2729),
    [sym_metavariable] = ACTIONS(2727),
    [sym__raw_string_literal_start] = ACTIONS(2727),
    [sym_float_literal] = ACTIONS(2727),
  },
  [918] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1988),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(918),
    [sym_block_comment] = STATE(918),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [919] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2192),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(919),
    [sym_block_comment] = STATE(919),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [920] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2983),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(920),
    [sym_block_comment] = STATE(920),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [921] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2433),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(921),
    [sym_block_comment] = STATE(921),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [922] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2681),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(922),
    [sym_block_comment] = STATE(922),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [923] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2181),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(923),
    [sym_block_comment] = STATE(923),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [924] = {
    [sym_function_modifiers] = STATE(3321),
    [sym_removed_trait_bound] = STATE(1215),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1222),
    [sym_bracketed_type] = STATE(3504),
    [sym_lifetime] = STATE(3465),
    [sym_array_type] = STATE(1215),
    [sym_for_lifetimes] = STATE(1614),
    [sym_function_type] = STATE(1215),
    [sym_tuple_type] = STATE(1215),
    [sym_unit_type] = STATE(1215),
    [sym_generic_type] = STATE(1082),
    [sym_generic_type_with_turbofish] = STATE(3494),
    [sym_bounded_type] = STATE(1215),
    [sym_reference_type] = STATE(1215),
    [sym_pointer_type] = STATE(1215),
    [sym_never_type] = STATE(1215),
    [sym_abstract_type] = STATE(1215),
    [sym_dynamic_type] = STATE(1215),
    [sym_macro_invocation] = STATE(1215),
    [sym_scoped_identifier] = STATE(3299),
    [sym_scoped_type_identifier] = STATE(1022),
    [sym_line_comment] = STATE(924),
    [sym_block_comment] = STATE(924),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(3039),
    [anon_sym_LPAREN] = ACTIONS(3041),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_STAR] = ACTIONS(3047),
    [anon_sym_QMARK] = ACTIONS(3049),
    [anon_sym_u8] = ACTIONS(3051),
    [anon_sym_i8] = ACTIONS(3051),
    [anon_sym_u16] = ACTIONS(3051),
    [anon_sym_i16] = ACTIONS(3051),
    [anon_sym_u32] = ACTIONS(3051),
    [anon_sym_i32] = ACTIONS(3051),
    [anon_sym_u64] = ACTIONS(3051),
    [anon_sym_i64] = ACTIONS(3051),
    [anon_sym_u128] = ACTIONS(3051),
    [anon_sym_i128] = ACTIONS(3051),
    [anon_sym_isize] = ACTIONS(3051),
    [anon_sym_usize] = ACTIONS(3051),
    [anon_sym_f32] = ACTIONS(3051),
    [anon_sym_f64] = ACTIONS(3051),
    [anon_sym_bool] = ACTIONS(3051),
    [anon_sym_str] = ACTIONS(3051),
    [anon_sym_char] = ACTIONS(3051),
    [anon_sym_BANG] = ACTIONS(3053),
    [anon_sym_AMP] = ACTIONS(3055),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3057),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(3059),
    [anon_sym_fn] = ACTIONS(3061),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(3063),
    [anon_sym_union] = ACTIONS(3065),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(3067),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3071),
    [sym_super] = ACTIONS(3071),
    [sym_crate] = ACTIONS(3071),
    [sym_metavariable] = ACTIONS(3073),
  },
  [925] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1979),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(925),
    [sym_block_comment] = STATE(925),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [926] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2590),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(926),
    [sym_block_comment] = STATE(926),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [927] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2193),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(927),
    [sym_block_comment] = STATE(927),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [928] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2819),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(928),
    [sym_block_comment] = STATE(928),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [929] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(3064),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(929),
    [sym_block_comment] = STATE(929),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [930] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2308),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(930),
    [sym_block_comment] = STATE(930),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [931] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2331),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(931),
    [sym_block_comment] = STATE(931),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [932] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2307),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(932),
    [sym_block_comment] = STATE(932),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [933] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2287),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(933),
    [sym_block_comment] = STATE(933),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [934] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2329),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(934),
    [sym_block_comment] = STATE(934),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [935] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2726),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(935),
    [sym_block_comment] = STATE(935),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [936] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2330),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(936),
    [sym_block_comment] = STATE(936),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [937] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2281),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(937),
    [sym_block_comment] = STATE(937),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [938] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2973),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(938),
    [sym_block_comment] = STATE(938),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [939] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2338),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(2294),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(2123),
    [sym_line_comment] = STATE(939),
    [sym_block_comment] = STATE(939),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(3173),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(3175),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [940] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2977),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(940),
    [sym_block_comment] = STATE(940),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [941] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(3056),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(941),
    [sym_block_comment] = STATE(941),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [942] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2305),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(942),
    [sym_block_comment] = STATE(942),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [943] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2634),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(943),
    [sym_block_comment] = STATE(943),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [944] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2293),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(944),
    [sym_block_comment] = STATE(944),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [945] = {
    [sym_function_modifiers] = STATE(3462),
    [sym_removed_trait_bound] = STATE(1678),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1819),
    [sym_bracketed_type] = STATE(3519),
    [sym_lifetime] = STATE(3551),
    [sym_array_type] = STATE(1678),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1678),
    [sym_tuple_type] = STATE(1678),
    [sym_unit_type] = STATE(1678),
    [sym_generic_type] = STATE(1604),
    [sym_generic_type_with_turbofish] = STATE(3511),
    [sym_bounded_type] = STATE(1678),
    [sym_reference_type] = STATE(1678),
    [sym_pointer_type] = STATE(1678),
    [sym_never_type] = STATE(1678),
    [sym_abstract_type] = STATE(1678),
    [sym_dynamic_type] = STATE(1678),
    [sym_macro_invocation] = STATE(1678),
    [sym_scoped_identifier] = STATE(3113),
    [sym_scoped_type_identifier] = STATE(1520),
    [sym_line_comment] = STATE(945),
    [sym_block_comment] = STATE(945),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(3081),
    [anon_sym_LPAREN] = ACTIONS(3083),
    [anon_sym_LBRACK] = ACTIONS(3085),
    [anon_sym_STAR] = ACTIONS(3089),
    [anon_sym_QMARK] = ACTIONS(3091),
    [anon_sym_u8] = ACTIONS(3093),
    [anon_sym_i8] = ACTIONS(3093),
    [anon_sym_u16] = ACTIONS(3093),
    [anon_sym_i16] = ACTIONS(3093),
    [anon_sym_u32] = ACTIONS(3093),
    [anon_sym_i32] = ACTIONS(3093),
    [anon_sym_u64] = ACTIONS(3093),
    [anon_sym_i64] = ACTIONS(3093),
    [anon_sym_u128] = ACTIONS(3093),
    [anon_sym_i128] = ACTIONS(3093),
    [anon_sym_isize] = ACTIONS(3093),
    [anon_sym_usize] = ACTIONS(3093),
    [anon_sym_f32] = ACTIONS(3093),
    [anon_sym_f64] = ACTIONS(3093),
    [anon_sym_bool] = ACTIONS(3093),
    [anon_sym_str] = ACTIONS(3093),
    [anon_sym_char] = ACTIONS(3093),
    [anon_sym_BANG] = ACTIONS(3095),
    [anon_sym_AMP] = ACTIONS(3097),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3099),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(3101),
    [anon_sym_fn] = ACTIONS(3103),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(3105),
    [anon_sym_union] = ACTIONS(3107),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(3109),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3113),
    [sym_super] = ACTIONS(3113),
    [sym_crate] = ACTIONS(3113),
    [sym_metavariable] = ACTIONS(3115),
  },
  [946] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2860),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(946),
    [sym_block_comment] = STATE(946),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [947] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2909),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(947),
    [sym_block_comment] = STATE(947),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [948] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1959),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(948),
    [sym_block_comment] = STATE(948),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [949] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1972),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(949),
    [sym_block_comment] = STATE(949),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [950] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2172),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(950),
    [sym_block_comment] = STATE(950),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [951] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2304),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(951),
    [sym_block_comment] = STATE(951),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [952] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2178),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(952),
    [sym_block_comment] = STATE(952),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [953] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2916),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(953),
    [sym_block_comment] = STATE(953),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [954] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2291),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(954),
    [sym_block_comment] = STATE(954),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [955] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2386),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(955),
    [sym_block_comment] = STATE(955),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [956] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2686),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(956),
    [sym_block_comment] = STATE(956),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [957] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2539),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(957),
    [sym_block_comment] = STATE(957),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [958] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2473),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(958),
    [sym_block_comment] = STATE(958),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [959] = {
    [sym_function_modifiers] = STATE(3462),
    [sym_removed_trait_bound] = STATE(1678),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1822),
    [sym_bracketed_type] = STATE(3519),
    [sym_lifetime] = STATE(3551),
    [sym_array_type] = STATE(1678),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1678),
    [sym_tuple_type] = STATE(1678),
    [sym_unit_type] = STATE(1678),
    [sym_generic_type] = STATE(1604),
    [sym_generic_type_with_turbofish] = STATE(3511),
    [sym_bounded_type] = STATE(1678),
    [sym_reference_type] = STATE(1678),
    [sym_pointer_type] = STATE(1678),
    [sym_never_type] = STATE(1678),
    [sym_abstract_type] = STATE(1678),
    [sym_dynamic_type] = STATE(1678),
    [sym_macro_invocation] = STATE(1678),
    [sym_scoped_identifier] = STATE(3113),
    [sym_scoped_type_identifier] = STATE(1520),
    [sym_line_comment] = STATE(959),
    [sym_block_comment] = STATE(959),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(3081),
    [anon_sym_LPAREN] = ACTIONS(3083),
    [anon_sym_LBRACK] = ACTIONS(3085),
    [anon_sym_STAR] = ACTIONS(3089),
    [anon_sym_QMARK] = ACTIONS(3091),
    [anon_sym_u8] = ACTIONS(3093),
    [anon_sym_i8] = ACTIONS(3093),
    [anon_sym_u16] = ACTIONS(3093),
    [anon_sym_i16] = ACTIONS(3093),
    [anon_sym_u32] = ACTIONS(3093),
    [anon_sym_i32] = ACTIONS(3093),
    [anon_sym_u64] = ACTIONS(3093),
    [anon_sym_i64] = ACTIONS(3093),
    [anon_sym_u128] = ACTIONS(3093),
    [anon_sym_i128] = ACTIONS(3093),
    [anon_sym_isize] = ACTIONS(3093),
    [anon_sym_usize] = ACTIONS(3093),
    [anon_sym_f32] = ACTIONS(3093),
    [anon_sym_f64] = ACTIONS(3093),
    [anon_sym_bool] = ACTIONS(3093),
    [anon_sym_str] = ACTIONS(3093),
    [anon_sym_char] = ACTIONS(3093),
    [anon_sym_BANG] = ACTIONS(3095),
    [anon_sym_AMP] = ACTIONS(3097),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3099),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(3101),
    [anon_sym_fn] = ACTIONS(3103),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(3105),
    [anon_sym_union] = ACTIONS(3107),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(3109),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3113),
    [sym_super] = ACTIONS(3113),
    [sym_crate] = ACTIONS(3113),
    [sym_metavariable] = ACTIONS(3115),
  },
  [960] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2751),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(960),
    [sym_block_comment] = STATE(960),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [961] = {
    [sym_function_modifiers] = STATE(3462),
    [sym_removed_trait_bound] = STATE(1678),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1824),
    [sym_bracketed_type] = STATE(3519),
    [sym_lifetime] = STATE(3551),
    [sym_array_type] = STATE(1678),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1678),
    [sym_tuple_type] = STATE(1678),
    [sym_unit_type] = STATE(1678),
    [sym_generic_type] = STATE(1604),
    [sym_generic_type_with_turbofish] = STATE(3511),
    [sym_bounded_type] = STATE(1678),
    [sym_reference_type] = STATE(1678),
    [sym_pointer_type] = STATE(1678),
    [sym_never_type] = STATE(1678),
    [sym_abstract_type] = STATE(1678),
    [sym_dynamic_type] = STATE(1678),
    [sym_macro_invocation] = STATE(1678),
    [sym_scoped_identifier] = STATE(3113),
    [sym_scoped_type_identifier] = STATE(1520),
    [sym_line_comment] = STATE(961),
    [sym_block_comment] = STATE(961),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(3081),
    [anon_sym_LPAREN] = ACTIONS(3083),
    [anon_sym_LBRACK] = ACTIONS(3085),
    [anon_sym_STAR] = ACTIONS(3089),
    [anon_sym_QMARK] = ACTIONS(3091),
    [anon_sym_u8] = ACTIONS(3093),
    [anon_sym_i8] = ACTIONS(3093),
    [anon_sym_u16] = ACTIONS(3093),
    [anon_sym_i16] = ACTIONS(3093),
    [anon_sym_u32] = ACTIONS(3093),
    [anon_sym_i32] = ACTIONS(3093),
    [anon_sym_u64] = ACTIONS(3093),
    [anon_sym_i64] = ACTIONS(3093),
    [anon_sym_u128] = ACTIONS(3093),
    [anon_sym_i128] = ACTIONS(3093),
    [anon_sym_isize] = ACTIONS(3093),
    [anon_sym_usize] = ACTIONS(3093),
    [anon_sym_f32] = ACTIONS(3093),
    [anon_sym_f64] = ACTIONS(3093),
    [anon_sym_bool] = ACTIONS(3093),
    [anon_sym_str] = ACTIONS(3093),
    [anon_sym_char] = ACTIONS(3093),
    [anon_sym_BANG] = ACTIONS(3095),
    [anon_sym_AMP] = ACTIONS(3097),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3099),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(3101),
    [anon_sym_fn] = ACTIONS(3103),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(3105),
    [anon_sym_union] = ACTIONS(3107),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(3109),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3113),
    [sym_super] = ACTIONS(3113),
    [sym_crate] = ACTIONS(3113),
    [sym_metavariable] = ACTIONS(3115),
  },
  [962] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2279),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(962),
    [sym_block_comment] = STATE(962),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [963] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2934),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(963),
    [sym_block_comment] = STATE(963),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [964] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2367),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(964),
    [sym_block_comment] = STATE(964),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [965] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2205),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(965),
    [sym_block_comment] = STATE(965),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [966] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(3004),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(966),
    [sym_block_comment] = STATE(966),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [967] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2813),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(967),
    [sym_block_comment] = STATE(967),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [968] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2663),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(968),
    [sym_block_comment] = STATE(968),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [969] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1960),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(969),
    [sym_block_comment] = STATE(969),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [970] = {
    [sym_function_modifiers] = STATE(3462),
    [sym_removed_trait_bound] = STATE(1678),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1665),
    [sym_bracketed_type] = STATE(3519),
    [sym_lifetime] = STATE(3551),
    [sym_array_type] = STATE(1678),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1678),
    [sym_tuple_type] = STATE(1678),
    [sym_unit_type] = STATE(1678),
    [sym_generic_type] = STATE(1604),
    [sym_generic_type_with_turbofish] = STATE(3511),
    [sym_bounded_type] = STATE(1678),
    [sym_reference_type] = STATE(1678),
    [sym_pointer_type] = STATE(1678),
    [sym_never_type] = STATE(1678),
    [sym_abstract_type] = STATE(1678),
    [sym_dynamic_type] = STATE(1678),
    [sym_macro_invocation] = STATE(1678),
    [sym_scoped_identifier] = STATE(3113),
    [sym_scoped_type_identifier] = STATE(1520),
    [sym_line_comment] = STATE(970),
    [sym_block_comment] = STATE(970),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(3081),
    [anon_sym_LPAREN] = ACTIONS(3083),
    [anon_sym_LBRACK] = ACTIONS(3085),
    [anon_sym_STAR] = ACTIONS(3089),
    [anon_sym_QMARK] = ACTIONS(3091),
    [anon_sym_u8] = ACTIONS(3093),
    [anon_sym_i8] = ACTIONS(3093),
    [anon_sym_u16] = ACTIONS(3093),
    [anon_sym_i16] = ACTIONS(3093),
    [anon_sym_u32] = ACTIONS(3093),
    [anon_sym_i32] = ACTIONS(3093),
    [anon_sym_u64] = ACTIONS(3093),
    [anon_sym_i64] = ACTIONS(3093),
    [anon_sym_u128] = ACTIONS(3093),
    [anon_sym_i128] = ACTIONS(3093),
    [anon_sym_isize] = ACTIONS(3093),
    [anon_sym_usize] = ACTIONS(3093),
    [anon_sym_f32] = ACTIONS(3093),
    [anon_sym_f64] = ACTIONS(3093),
    [anon_sym_bool] = ACTIONS(3093),
    [anon_sym_str] = ACTIONS(3093),
    [anon_sym_char] = ACTIONS(3093),
    [anon_sym_BANG] = ACTIONS(3095),
    [anon_sym_AMP] = ACTIONS(3097),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3099),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(3101),
    [anon_sym_fn] = ACTIONS(3103),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(3105),
    [anon_sym_union] = ACTIONS(3107),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(3109),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3113),
    [sym_super] = ACTIONS(3113),
    [sym_crate] = ACTIONS(3113),
    [sym_metavariable] = ACTIONS(3115),
  },
  [971] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2369),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(971),
    [sym_block_comment] = STATE(971),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [972] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1985),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(972),
    [sym_block_comment] = STATE(972),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [973] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2945),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(973),
    [sym_block_comment] = STATE(973),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [974] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2368),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(2306),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(2149),
    [sym_line_comment] = STATE(974),
    [sym_block_comment] = STATE(974),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(3177),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(3179),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [975] = {
    [sym_function_modifiers] = STATE(3462),
    [sym_removed_trait_bound] = STATE(1678),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1792),
    [sym_bracketed_type] = STATE(3519),
    [sym_lifetime] = STATE(3551),
    [sym_array_type] = STATE(1678),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1678),
    [sym_tuple_type] = STATE(1678),
    [sym_unit_type] = STATE(1678),
    [sym_generic_type] = STATE(1604),
    [sym_generic_type_with_turbofish] = STATE(3511),
    [sym_bounded_type] = STATE(1678),
    [sym_reference_type] = STATE(1678),
    [sym_pointer_type] = STATE(1678),
    [sym_never_type] = STATE(1678),
    [sym_abstract_type] = STATE(1678),
    [sym_dynamic_type] = STATE(1678),
    [sym_macro_invocation] = STATE(1678),
    [sym_scoped_identifier] = STATE(3113),
    [sym_scoped_type_identifier] = STATE(1520),
    [sym_line_comment] = STATE(975),
    [sym_block_comment] = STATE(975),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(3081),
    [anon_sym_LPAREN] = ACTIONS(3083),
    [anon_sym_LBRACK] = ACTIONS(3085),
    [anon_sym_STAR] = ACTIONS(3089),
    [anon_sym_QMARK] = ACTIONS(3091),
    [anon_sym_u8] = ACTIONS(3093),
    [anon_sym_i8] = ACTIONS(3093),
    [anon_sym_u16] = ACTIONS(3093),
    [anon_sym_i16] = ACTIONS(3093),
    [anon_sym_u32] = ACTIONS(3093),
    [anon_sym_i32] = ACTIONS(3093),
    [anon_sym_u64] = ACTIONS(3093),
    [anon_sym_i64] = ACTIONS(3093),
    [anon_sym_u128] = ACTIONS(3093),
    [anon_sym_i128] = ACTIONS(3093),
    [anon_sym_isize] = ACTIONS(3093),
    [anon_sym_usize] = ACTIONS(3093),
    [anon_sym_f32] = ACTIONS(3093),
    [anon_sym_f64] = ACTIONS(3093),
    [anon_sym_bool] = ACTIONS(3093),
    [anon_sym_str] = ACTIONS(3093),
    [anon_sym_char] = ACTIONS(3093),
    [anon_sym_BANG] = ACTIONS(3095),
    [anon_sym_AMP] = ACTIONS(3097),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3099),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(3101),
    [anon_sym_fn] = ACTIONS(3103),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(3105),
    [anon_sym_union] = ACTIONS(3107),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(3109),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3113),
    [sym_super] = ACTIONS(3113),
    [sym_crate] = ACTIONS(3113),
    [sym_metavariable] = ACTIONS(3115),
  },
  [976] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2700),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(976),
    [sym_block_comment] = STATE(976),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [977] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2343),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(977),
    [sym_block_comment] = STATE(977),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [978] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2670),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(978),
    [sym_block_comment] = STATE(978),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [979] = {
    [sym_function_modifiers] = STATE(3462),
    [sym_removed_trait_bound] = STATE(1678),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1703),
    [sym_bracketed_type] = STATE(3519),
    [sym_lifetime] = STATE(3551),
    [sym_array_type] = STATE(1678),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1678),
    [sym_tuple_type] = STATE(1678),
    [sym_unit_type] = STATE(1678),
    [sym_generic_type] = STATE(1604),
    [sym_generic_type_with_turbofish] = STATE(3511),
    [sym_bounded_type] = STATE(1678),
    [sym_reference_type] = STATE(1678),
    [sym_pointer_type] = STATE(1678),
    [sym_never_type] = STATE(1678),
    [sym_abstract_type] = STATE(1678),
    [sym_dynamic_type] = STATE(1678),
    [sym_macro_invocation] = STATE(1678),
    [sym_scoped_identifier] = STATE(3113),
    [sym_scoped_type_identifier] = STATE(1520),
    [sym_line_comment] = STATE(979),
    [sym_block_comment] = STATE(979),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(3081),
    [anon_sym_LPAREN] = ACTIONS(3083),
    [anon_sym_LBRACK] = ACTIONS(3085),
    [anon_sym_STAR] = ACTIONS(3089),
    [anon_sym_QMARK] = ACTIONS(3091),
    [anon_sym_u8] = ACTIONS(3093),
    [anon_sym_i8] = ACTIONS(3093),
    [anon_sym_u16] = ACTIONS(3093),
    [anon_sym_i16] = ACTIONS(3093),
    [anon_sym_u32] = ACTIONS(3093),
    [anon_sym_i32] = ACTIONS(3093),
    [anon_sym_u64] = ACTIONS(3093),
    [anon_sym_i64] = ACTIONS(3093),
    [anon_sym_u128] = ACTIONS(3093),
    [anon_sym_i128] = ACTIONS(3093),
    [anon_sym_isize] = ACTIONS(3093),
    [anon_sym_usize] = ACTIONS(3093),
    [anon_sym_f32] = ACTIONS(3093),
    [anon_sym_f64] = ACTIONS(3093),
    [anon_sym_bool] = ACTIONS(3093),
    [anon_sym_str] = ACTIONS(3093),
    [anon_sym_char] = ACTIONS(3093),
    [anon_sym_BANG] = ACTIONS(3095),
    [anon_sym_AMP] = ACTIONS(3097),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3099),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(3101),
    [anon_sym_fn] = ACTIONS(3103),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(3105),
    [anon_sym_union] = ACTIONS(3107),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(3109),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3113),
    [sym_super] = ACTIONS(3113),
    [sym_crate] = ACTIONS(3113),
    [sym_metavariable] = ACTIONS(3115),
  },
  [980] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2175),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(980),
    [sym_block_comment] = STATE(980),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [981] = {
    [sym_function_modifiers] = STATE(3462),
    [sym_removed_trait_bound] = STATE(1678),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1795),
    [sym_bracketed_type] = STATE(3519),
    [sym_lifetime] = STATE(3551),
    [sym_array_type] = STATE(1678),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1678),
    [sym_tuple_type] = STATE(1678),
    [sym_unit_type] = STATE(1678),
    [sym_generic_type] = STATE(1604),
    [sym_generic_type_with_turbofish] = STATE(3511),
    [sym_bounded_type] = STATE(1678),
    [sym_reference_type] = STATE(1678),
    [sym_pointer_type] = STATE(1678),
    [sym_never_type] = STATE(1678),
    [sym_abstract_type] = STATE(1678),
    [sym_dynamic_type] = STATE(1678),
    [sym_macro_invocation] = STATE(1678),
    [sym_scoped_identifier] = STATE(3113),
    [sym_scoped_type_identifier] = STATE(1520),
    [sym_line_comment] = STATE(981),
    [sym_block_comment] = STATE(981),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(3081),
    [anon_sym_LPAREN] = ACTIONS(3083),
    [anon_sym_LBRACK] = ACTIONS(3085),
    [anon_sym_STAR] = ACTIONS(3089),
    [anon_sym_QMARK] = ACTIONS(3091),
    [anon_sym_u8] = ACTIONS(3093),
    [anon_sym_i8] = ACTIONS(3093),
    [anon_sym_u16] = ACTIONS(3093),
    [anon_sym_i16] = ACTIONS(3093),
    [anon_sym_u32] = ACTIONS(3093),
    [anon_sym_i32] = ACTIONS(3093),
    [anon_sym_u64] = ACTIONS(3093),
    [anon_sym_i64] = ACTIONS(3093),
    [anon_sym_u128] = ACTIONS(3093),
    [anon_sym_i128] = ACTIONS(3093),
    [anon_sym_isize] = ACTIONS(3093),
    [anon_sym_usize] = ACTIONS(3093),
    [anon_sym_f32] = ACTIONS(3093),
    [anon_sym_f64] = ACTIONS(3093),
    [anon_sym_bool] = ACTIONS(3093),
    [anon_sym_str] = ACTIONS(3093),
    [anon_sym_char] = ACTIONS(3093),
    [anon_sym_BANG] = ACTIONS(3095),
    [anon_sym_AMP] = ACTIONS(3097),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3099),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(3101),
    [anon_sym_fn] = ACTIONS(3103),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(3105),
    [anon_sym_union] = ACTIONS(3107),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(3109),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3113),
    [sym_super] = ACTIONS(3113),
    [sym_crate] = ACTIONS(3113),
    [sym_metavariable] = ACTIONS(3115),
  },
  [982] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2997),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(982),
    [sym_block_comment] = STATE(982),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [983] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2344),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(983),
    [sym_block_comment] = STATE(983),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [984] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2375),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(984),
    [sym_block_comment] = STATE(984),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [985] = {
    [sym_function_modifiers] = STATE(3321),
    [sym_removed_trait_bound] = STATE(1215),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1245),
    [sym_bracketed_type] = STATE(3504),
    [sym_lifetime] = STATE(3465),
    [sym_array_type] = STATE(1215),
    [sym_for_lifetimes] = STATE(1614),
    [sym_function_type] = STATE(1215),
    [sym_tuple_type] = STATE(1215),
    [sym_unit_type] = STATE(1215),
    [sym_generic_type] = STATE(1082),
    [sym_generic_type_with_turbofish] = STATE(3494),
    [sym_bounded_type] = STATE(1215),
    [sym_reference_type] = STATE(1215),
    [sym_pointer_type] = STATE(1215),
    [sym_never_type] = STATE(1215),
    [sym_abstract_type] = STATE(1215),
    [sym_dynamic_type] = STATE(1215),
    [sym_macro_invocation] = STATE(1215),
    [sym_scoped_identifier] = STATE(3299),
    [sym_scoped_type_identifier] = STATE(1022),
    [sym_line_comment] = STATE(985),
    [sym_block_comment] = STATE(985),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(3039),
    [anon_sym_LPAREN] = ACTIONS(3041),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_STAR] = ACTIONS(3047),
    [anon_sym_QMARK] = ACTIONS(3049),
    [anon_sym_u8] = ACTIONS(3051),
    [anon_sym_i8] = ACTIONS(3051),
    [anon_sym_u16] = ACTIONS(3051),
    [anon_sym_i16] = ACTIONS(3051),
    [anon_sym_u32] = ACTIONS(3051),
    [anon_sym_i32] = ACTIONS(3051),
    [anon_sym_u64] = ACTIONS(3051),
    [anon_sym_i64] = ACTIONS(3051),
    [anon_sym_u128] = ACTIONS(3051),
    [anon_sym_i128] = ACTIONS(3051),
    [anon_sym_isize] = ACTIONS(3051),
    [anon_sym_usize] = ACTIONS(3051),
    [anon_sym_f32] = ACTIONS(3051),
    [anon_sym_f64] = ACTIONS(3051),
    [anon_sym_bool] = ACTIONS(3051),
    [anon_sym_str] = ACTIONS(3051),
    [anon_sym_char] = ACTIONS(3051),
    [anon_sym_BANG] = ACTIONS(3053),
    [anon_sym_AMP] = ACTIONS(3055),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3057),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(3059),
    [anon_sym_fn] = ACTIONS(3061),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(3063),
    [anon_sym_union] = ACTIONS(3065),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(3067),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3071),
    [sym_super] = ACTIONS(3071),
    [sym_crate] = ACTIONS(3071),
    [sym_metavariable] = ACTIONS(3073),
  },
  [986] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2914),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(986),
    [sym_block_comment] = STATE(986),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [987] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2350),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(2327),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(2148),
    [sym_line_comment] = STATE(987),
    [sym_block_comment] = STATE(987),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(3181),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(3183),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [988] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2485),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(988),
    [sym_block_comment] = STATE(988),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [989] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1969),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(989),
    [sym_block_comment] = STATE(989),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [990] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2378),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(990),
    [sym_block_comment] = STATE(990),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [991] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1971),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(991),
    [sym_block_comment] = STATE(991),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [992] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1957),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(992),
    [sym_block_comment] = STATE(992),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [993] = {
    [sym_function_modifiers] = STATE(3462),
    [sym_removed_trait_bound] = STATE(1678),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1833),
    [sym_bracketed_type] = STATE(3519),
    [sym_lifetime] = STATE(3551),
    [sym_array_type] = STATE(1678),
    [sym_for_lifetimes] = STATE(1587),
    [sym_function_type] = STATE(1678),
    [sym_tuple_type] = STATE(1678),
    [sym_unit_type] = STATE(1678),
    [sym_generic_type] = STATE(1604),
    [sym_generic_type_with_turbofish] = STATE(3511),
    [sym_bounded_type] = STATE(1678),
    [sym_reference_type] = STATE(1678),
    [sym_pointer_type] = STATE(1678),
    [sym_never_type] = STATE(1678),
    [sym_abstract_type] = STATE(1678),
    [sym_dynamic_type] = STATE(1678),
    [sym_macro_invocation] = STATE(1678),
    [sym_scoped_identifier] = STATE(3113),
    [sym_scoped_type_identifier] = STATE(1520),
    [sym_line_comment] = STATE(993),
    [sym_block_comment] = STATE(993),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(3081),
    [anon_sym_LPAREN] = ACTIONS(3083),
    [anon_sym_LBRACK] = ACTIONS(3085),
    [anon_sym_STAR] = ACTIONS(3089),
    [anon_sym_QMARK] = ACTIONS(3091),
    [anon_sym_u8] = ACTIONS(3093),
    [anon_sym_i8] = ACTIONS(3093),
    [anon_sym_u16] = ACTIONS(3093),
    [anon_sym_i16] = ACTIONS(3093),
    [anon_sym_u32] = ACTIONS(3093),
    [anon_sym_i32] = ACTIONS(3093),
    [anon_sym_u64] = ACTIONS(3093),
    [anon_sym_i64] = ACTIONS(3093),
    [anon_sym_u128] = ACTIONS(3093),
    [anon_sym_i128] = ACTIONS(3093),
    [anon_sym_isize] = ACTIONS(3093),
    [anon_sym_usize] = ACTIONS(3093),
    [anon_sym_f32] = ACTIONS(3093),
    [anon_sym_f64] = ACTIONS(3093),
    [anon_sym_bool] = ACTIONS(3093),
    [anon_sym_str] = ACTIONS(3093),
    [anon_sym_char] = ACTIONS(3093),
    [anon_sym_BANG] = ACTIONS(3095),
    [anon_sym_AMP] = ACTIONS(3097),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(3099),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(3101),
    [anon_sym_fn] = ACTIONS(3103),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(3105),
    [anon_sym_union] = ACTIONS(3107),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(3109),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3113),
    [sym_super] = ACTIONS(3113),
    [sym_crate] = ACTIONS(3113),
    [sym_metavariable] = ACTIONS(3115),
  },
  [994] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2998),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(994),
    [sym_block_comment] = STATE(994),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [995] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2376),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(995),
    [sym_block_comment] = STATE(995),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [996] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(2787),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(996),
    [sym_block_comment] = STATE(996),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [997] = {
    [sym_function_modifiers] = STATE(3416),
    [sym_removed_trait_bound] = STATE(1968),
    [sym_extern_modifier] = STATE(2324),
    [sym__type] = STATE(1974),
    [sym_bracketed_type] = STATE(3315),
    [sym_lifetime] = STATE(3407),
    [sym_array_type] = STATE(1968),
    [sym_for_lifetimes] = STATE(1622),
    [sym_function_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_unit_type] = STATE(1968),
    [sym_generic_type] = STATE(1938),
    [sym_generic_type_with_turbofish] = STATE(3404),
    [sym_bounded_type] = STATE(1968),
    [sym_reference_type] = STATE(1968),
    [sym_pointer_type] = STATE(1968),
    [sym_never_type] = STATE(1968),
    [sym_abstract_type] = STATE(1968),
    [sym_dynamic_type] = STATE(1968),
    [sym_macro_invocation] = STATE(1968),
    [sym_scoped_identifier] = STATE(3188),
    [sym_scoped_type_identifier] = STATE(1912),
    [sym_line_comment] = STATE(997),
    [sym_block_comment] = STATE(997),
    [aux_sym_function_modifiers_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_u8] = ACTIONS(1566),
    [anon_sym_i8] = ACTIONS(1566),
    [anon_sym_u16] = ACTIONS(1566),
    [anon_sym_i16] = ACTIONS(1566),
    [anon_sym_u32] = ACTIONS(1566),
    [anon_sym_i32] = ACTIONS(1566),
    [anon_sym_u64] = ACTIONS(1566),
    [anon_sym_i64] = ACTIONS(1566),
    [anon_sym_u128] = ACTIONS(1566),
    [anon_sym_i128] = ACTIONS(1566),
    [anon_sym_isize] = ACTIONS(1566),
    [anon_sym_usize] = ACTIONS(1566),
    [anon_sym_f32] = ACTIONS(1566),
    [anon_sym_f64] = ACTIONS(1566),
    [anon_sym_bool] = ACTIONS(1566),
    [anon_sym_str] = ACTIONS(1566),
    [anon_sym_char] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(29),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_const] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_impl] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1578),
    [anon_sym_unsafe] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym_dyn] = ACTIONS(1318),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(1582),
    [sym_super] = ACTIONS(1582),
    [sym_crate] = ACTIONS(1582),
    [sym_metavariable] = ACTIONS(1584),
  },
  [998] = {
    [sym_attribute_item] = STATE(999),
    [sym_line_comment] = STATE(998),
    [sym_block_comment] = STATE(998),
    [aux_sym_enum_variant_list_repeat1] = STATE(998),
    [sym_identifier] = ACTIONS(3185),
    [anon_sym_LPAREN] = ACTIONS(826),
    [anon_sym_LBRACK] = ACTIONS(826),
    [anon_sym_RBRACK] = ACTIONS(826),
    [anon_sym_LBRACE] = ACTIONS(826),
    [anon_sym_STAR] = ACTIONS(826),
    [anon_sym_u8] = ACTIONS(3185),
    [anon_sym_i8] = ACTIONS(3185),
    [anon_sym_u16] = ACTIONS(3185),
    [anon_sym_i16] = ACTIONS(3185),
    [anon_sym_u32] = ACTIONS(3185),
    [anon_sym_i32] = ACTIONS(3185),
    [anon_sym_u64] = ACTIONS(3185),
    [anon_sym_i64] = ACTIONS(3185),
    [anon_sym_u128] = ACTIONS(3185),
    [anon_sym_i128] = ACTIONS(3185),
    [anon_sym_isize] = ACTIONS(3185),
    [anon_sym_usize] = ACTIONS(3185),
    [anon_sym_f32] = ACTIONS(3185),
    [anon_sym_f64] = ACTIONS(3185),
    [anon_sym_bool] = ACTIONS(3185),
    [anon_sym_str] = ACTIONS(3185),
    [anon_sym_char] = ACTIONS(3185),
    [anon_sym_DASH] = ACTIONS(826),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_AMP] = ACTIONS(826),
    [anon_sym_PIPE] = ACTIONS(826),
    [anon_sym_LT] = ACTIONS(826),
    [anon_sym_DOT_DOT] = ACTIONS(826),
    [anon_sym_COMMA] = ACTIONS(826),
    [anon_sym_COLON_COLON] = ACTIONS(826),
    [anon_sym_POUND] = ACTIONS(852),
    [anon_sym_SQUOTE] = ACTIONS(3185),
    [anon_sym_async] = ACTIONS(3185),
    [anon_sym_break] = ACTIONS(3185),
    [anon_sym_const] = ACTIONS(3185),
    [anon_sym_continue] = ACTIONS(3185),
    [anon_sym_default] = ACTIONS(3185),
    [anon_sym_for] = ACTIONS(3185),
    [anon_sym_if] = ACTIONS(3185),
    [anon_sym_loop] = ACTIONS(3185),
    [anon_sym_match] = ACTIONS(3185),
    [anon_sym_return] = ACTIONS(3185),
    [anon_sym_static] = ACTIONS(3185),
    [anon_sym_union] = ACTIONS(3185),
    [anon_sym_unsafe] = ACTIONS(3185),
    [anon_sym_while] = ACTIONS(3185),
    [anon_sym_yield] = ACTIONS(3185),
    [anon_sym_move] = ACTIONS(3185),
    [anon_sym_try] = ACTIONS(3185),
    [sym_integer_literal] = ACTIONS(826),
    [aux_sym_string_literal_token1] = ACTIONS(826),
    [sym_char_literal] = ACTIONS(826),
    [anon_sym_true] = ACTIONS(3185),
    [anon_sym_false] = ACTIONS(3185),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3185),
    [sym_super] = ACTIONS(3185),
    [sym_crate] = ACTIONS(3185),
    [sym_metavariable] = ACTIONS(826),
    [sym__raw_string_literal_start] = ACTIONS(826),
    [sym_float_literal] = ACTIONS(826),
  },
  [999] = {
    [sym_line_comment] = STATE(999),
    [sym_block_comment] = STATE(999),
    [sym_identifier] = ACTIONS(3187),
    [anon_sym_LPAREN] = ACTIONS(3189),
    [anon_sym_LBRACK] = ACTIONS(3189),
    [anon_sym_RBRACK] = ACTIONS(3189),
    [anon_sym_LBRACE] = ACTIONS(3189),
    [anon_sym_STAR] = ACTIONS(3189),
    [anon_sym_u8] = ACTIONS(3187),
    [anon_sym_i8] = ACTIONS(3187),
    [anon_sym_u16] = ACTIONS(3187),
    [anon_sym_i16] = ACTIONS(3187),
    [anon_sym_u32] = ACTIONS(3187),
    [anon_sym_i32] = ACTIONS(3187),
    [anon_sym_u64] = ACTIONS(3187),
    [anon_sym_i64] = ACTIONS(3187),
    [anon_sym_u128] = ACTIONS(3187),
    [anon_sym_i128] = ACTIONS(3187),
    [anon_sym_isize] = ACTIONS(3187),
    [anon_sym_usize] = ACTIONS(3187),
    [anon_sym_f32] = ACTIONS(3187),
    [anon_sym_f64] = ACTIONS(3187),
    [anon_sym_bool] = ACTIONS(3187),
    [anon_sym_str] = ACTIONS(3187),
    [anon_sym_char] = ACTIONS(3187),
    [anon_sym_DASH] = ACTIONS(3189),
    [anon_sym_BANG] = ACTIONS(3189),
    [anon_sym_AMP] = ACTIONS(3189),
    [anon_sym_PIPE] = ACTIONS(3189),
    [anon_sym_LT] = ACTIONS(3189),
    [anon_sym_DOT_DOT] = ACTIONS(3189),
    [anon_sym_COMMA] = ACTIONS(3189),
    [anon_sym_COLON_COLON] = ACTIONS(3189),
    [anon_sym_POUND] = ACTIONS(3189),
    [anon_sym_SQUOTE] = ACTIONS(3187),
    [anon_sym_async] = ACTIONS(3187),
    [anon_sym_break] = ACTIONS(3187),
    [anon_sym_const] = ACTIONS(3187),
    [anon_sym_continue] = ACTIONS(3187),
    [anon_sym_default] = ACTIONS(3187),
    [anon_sym_for] = ACTIONS(3187),
    [anon_sym_if] = ACTIONS(3187),
    [anon_sym_loop] = ACTIONS(3187),
    [anon_sym_match] = ACTIONS(3187),
    [anon_sym_return] = ACTIONS(3187),
    [anon_sym_static] = ACTIONS(3187),
    [anon_sym_union] = ACTIONS(3187),
    [anon_sym_unsafe] = ACTIONS(3187),
    [anon_sym_while] = ACTIONS(3187),
    [anon_sym_yield] = ACTIONS(3187),
    [anon_sym_move] = ACTIONS(3187),
    [anon_sym_try] = ACTIONS(3187),
    [sym_integer_literal] = ACTIONS(3189),
    [aux_sym_string_literal_token1] = ACTIONS(3189),
    [sym_char_literal] = ACTIONS(3189),
    [anon_sym_true] = ACTIONS(3187),
    [anon_sym_false] = ACTIONS(3187),
    [anon_sym_SLASH_SLASH] = ACTIONS(101),
    [anon_sym_SLASH_STAR] = ACTIONS(103),
    [sym_self] = ACTIONS(3187),
    [sym_super] = ACTIONS(3187),
    [sym_crate] = ACTIONS(3187),
    [sym_metavariable] = ACTIONS(3189),
    [sym__raw_string_literal_start] = ACTIONS(3189),
    [sym_float_literal] = ACTIONS(3189),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1000), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3193), 17,
      sym__raw_string_literal_start,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(3191), 43,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_DASH,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_break,
      anon_sym_const,
      anon_sym_continue,
      anon_sym_default,
      anon_sym_for,
      anon_sym_if,
      anon_sym_loop,
      anon_sym_match,
      anon_sym_return,
      anon_sym_static,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_while,
      anon_sym_yield,
      anon_sym_move,
      anon_sym_try,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [75] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1001), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1556), 17,
      sym__raw_string_literal_start,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(1554), 43,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_DASH,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_break,
      anon_sym_const,
      anon_sym_continue,
      anon_sym_default,
      anon_sym_for,
      anon_sym_if,
      anon_sym_loop,
      anon_sym_match,
      anon_sym_return,
      anon_sym_static,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_while,
      anon_sym_yield,
      anon_sym_move,
      anon_sym_try,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [150] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1002), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1087), 18,
      sym__raw_string_literal_start,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(3195), 41,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_break,
      anon_sym_const,
      anon_sym_continue,
      anon_sym_default,
      anon_sym_for,
      anon_sym_if,
      anon_sym_loop,
      anon_sym_match,
      anon_sym_return,
      anon_sym_static,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_while,
      anon_sym_yield,
      anon_sym_move,
      anon_sym_try,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [224] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1003), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2727), 17,
      sym__raw_string_literal_start,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(2729), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym__,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_ref,
      anon_sym_dyn,
      sym_mutable_specifier,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [294] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1004), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3199), 20,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3197), 34,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_where,
      anon_sym_extern,
      anon_sym_else,
      anon_sym_dyn,
      sym_mutable_specifier,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [363] = 21,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1278), 1,
      anon_sym_DASH,
    ACTIONS(1324), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1334), 1,
      sym__raw_string_literal_start,
    ACTIONS(1856), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3201), 1,
      sym_identifier,
    ACTIONS(3211), 1,
      sym_metavariable,
    STATE(2027), 1,
      sym_scoped_identifier,
    STATE(2090), 1,
      sym__literal_pattern,
    STATE(3307), 1,
      sym_bracketed_type,
    STATE(3333), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(1326), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1005), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1322), 3,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    ACTIONS(3205), 3,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
    ACTIONS(3209), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2006), 4,
      sym_negative_literal,
      sym_string_literal,
      sym_raw_string_literal,
      sym_boolean_literal,
    ACTIONS(3203), 7,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
    ACTIONS(3207), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [462] = 21,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1278), 1,
      anon_sym_DASH,
    ACTIONS(1324), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1334), 1,
      sym__raw_string_literal_start,
    ACTIONS(1856), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3213), 1,
      sym_identifier,
    ACTIONS(3223), 1,
      sym_metavariable,
    STATE(2060), 1,
      sym_scoped_identifier,
    STATE(2111), 1,
      sym__literal_pattern,
    STATE(3307), 1,
      sym_bracketed_type,
    STATE(3333), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(1326), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1006), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1322), 3,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    ACTIONS(3217), 3,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
    ACTIONS(3221), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2006), 4,
      sym_negative_literal,
      sym_string_literal,
      sym_raw_string_literal,
      sym_boolean_literal,
    ACTIONS(3215), 7,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
    ACTIONS(3219), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [561] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3227), 1,
      anon_sym_LPAREN,
    ACTIONS(3231), 1,
      anon_sym_BANG,
    ACTIONS(3233), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3235), 1,
      anon_sym_LT2,
    STATE(1066), 1,
      sym_parameters,
    STATE(1075), 1,
      sym_type_arguments,
    STATE(1007), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3229), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3225), 27,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [638] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3227), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_LT2,
    ACTIONS(3241), 1,
      anon_sym_COLON_COLON,
    STATE(1066), 1,
      sym_parameters,
    STATE(1075), 1,
      sym_type_arguments,
    STATE(1008), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3239), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3237), 27,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [712] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3227), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_LT2,
    ACTIONS(3241), 1,
      anon_sym_COLON_COLON,
    STATE(1066), 1,
      sym_parameters,
    STATE(1075), 1,
      sym_type_arguments,
    STATE(1009), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3245), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3243), 27,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [786] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3227), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_LT2,
    ACTIONS(3241), 1,
      anon_sym_COLON_COLON,
    STATE(1066), 1,
      sym_parameters,
    STATE(1075), 1,
      sym_type_arguments,
    STATE(1010), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3249), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3247), 27,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [860] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3255), 1,
      anon_sym_BANG,
    ACTIONS(3257), 1,
      anon_sym_COLON_COLON,
    STATE(1011), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3253), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3251), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_LT2,
  [927] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1012), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(997), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(995), 39,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_if,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [990] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3227), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_LT2,
    STATE(1072), 1,
      sym_type_arguments,
    STATE(1079), 1,
      sym_parameters,
    STATE(1013), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3261), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3259), 27,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [1061] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3267), 1,
      anon_sym_BANG,
    ACTIONS(3269), 1,
      anon_sym_COLON_COLON,
    STATE(1014), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3265), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3263), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_LT2,
  [1128] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3227), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_LT2,
    STATE(1072), 1,
      sym_type_arguments,
    STATE(1079), 1,
      sym_parameters,
    STATE(1015), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3273), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3271), 27,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [1199] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1016), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1232), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1234), 39,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_if,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [1262] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3279), 1,
      anon_sym_BANG,
    ACTIONS(3281), 1,
      anon_sym_COLON_COLON,
    STATE(1017), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3277), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3275), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_LT2,
  [1329] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1018), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1228), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1230), 39,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_if,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [1392] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1019), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1001), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(999), 39,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_if,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [1455] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1020), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1236), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1238), 39,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_if,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [1518] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3287), 1,
      anon_sym_BANG,
    ACTIONS(3289), 1,
      anon_sym_COLON_COLON,
    STATE(1021), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3285), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3283), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_LT2,
  [1585] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3227), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_LT2,
    STATE(1072), 1,
      sym_type_arguments,
    STATE(1079), 1,
      sym_parameters,
    STATE(1022), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3293), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3291), 27,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [1656] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1023), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1244), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1246), 39,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_if,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [1719] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1024), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1352), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1354), 39,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_if,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [1782] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1025), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1240), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1242), 39,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_if,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [1845] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3227), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_LT2,
    STATE(1072), 1,
      sym_type_arguments,
    STATE(1079), 1,
      sym_parameters,
    STATE(1026), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3297), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3295), 27,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [1916] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1027), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1394), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1396), 39,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_if,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [1979] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3231), 1,
      anon_sym_BANG,
    ACTIONS(3299), 1,
      anon_sym_LBRACE,
    ACTIONS(3301), 1,
      anon_sym_COLON_COLON,
    STATE(1118), 1,
      sym_field_initializer_list,
    STATE(1028), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1344), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1346), 28,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_else,
  [2049] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1029), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2162), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2164), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [2111] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1030), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3279), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3281), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [2173] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1031), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2795), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2797), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [2235] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1032), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1830), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1832), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [2297] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1033), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3287), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3289), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [2359] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1034), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2743), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2745), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [2421] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3307), 1,
      anon_sym_BANG,
    ACTIONS(3309), 1,
      anon_sym_COLON_COLON,
    STATE(1035), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3311), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
    ACTIONS(3305), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
      anon_sym_as,
    ACTIONS(3303), 23,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [2489] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3317), 1,
      anon_sym_POUND,
    STATE(1471), 2,
      sym_attribute_item,
      sym_inner_attribute_item,
    STATE(1036), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_match_arm_repeat1,
    ACTIONS(3315), 14,
      sym__raw_string_literal_start,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(3313), 29,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym__,
      anon_sym_const,
      anon_sym_default,
      anon_sym_union,
      anon_sym_ref,
      sym_mutable_specifier,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [2555] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1037), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2022), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2024), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [2617] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1038), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3255), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3257), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [2679] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1039), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3267), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3269), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [2741] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1040), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3197), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3199), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [2802] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3320), 1,
      anon_sym_POUND,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(1041), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_enum_variant_list_repeat1,
    ACTIONS(826), 11,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_integer_literal,
      sym_metavariable,
    ACTIONS(3185), 32,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_pub,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [2867] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1042), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3325), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3323), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [2928] = 27,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1314), 1,
      anon_sym_extern,
    ACTIONS(3091), 1,
      anon_sym_QMARK,
    ACTIONS(3103), 1,
      anon_sym_fn,
    ACTIONS(3327), 1,
      sym_identifier,
    ACTIONS(3329), 1,
      anon_sym_LPAREN,
    ACTIONS(3333), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3335), 1,
      anon_sym_default,
    ACTIONS(3337), 1,
      anon_sym_for,
    ACTIONS(3339), 1,
      anon_sym_union,
    ACTIONS(3343), 1,
      sym_metavariable,
    STATE(1514), 1,
      sym_scoped_type_identifier,
    STATE(1587), 1,
      sym_for_lifetimes,
    STATE(1597), 1,
      sym_generic_type,
    STATE(2197), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2324), 1,
      sym_extern_modifier,
    STATE(3462), 1,
      sym_function_modifiers,
    STATE(3497), 1,
      sym_scoped_identifier,
    STATE(3514), 1,
      sym_generic_type_with_turbofish,
    STATE(3520), 1,
      sym_bracketed_type,
    STATE(1043), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1300), 3,
      anon_sym_async,
      anon_sym_const,
      anon_sym_unsafe,
    ACTIONS(3341), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(1720), 3,
      sym_removed_trait_bound,
      sym_function_type,
      sym_tuple_type,
    ACTIONS(3331), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [3033] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1044), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3347), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3345), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [3094] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1045), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3351), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3349), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [3155] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3353), 1,
      anon_sym_COLON_COLON,
    STATE(1046), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3297), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3295), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [3218] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3355), 1,
      anon_sym_LBRACE,
    STATE(1047), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3255), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3257), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_as,
      anon_sym_else,
  [3281] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    STATE(1048), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3267), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3269), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_as,
      anon_sym_else,
  [3344] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3359), 1,
      anon_sym_COLON_COLON,
    STATE(1049), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1344), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1346), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [3407] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3361), 1,
      anon_sym_else,
    STATE(1278), 1,
      sym_else_clause,
    STATE(1050), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1196), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1194), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
  [3472] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1051), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3365), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3363), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [3533] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1052), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3369), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3367), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [3594] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3375), 1,
      anon_sym_DASH_GT,
    STATE(1053), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3373), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3371), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [3657] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1054), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3379), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3377), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [3718] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    STATE(1165), 1,
      sym_arguments,
    STATE(1055), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3385), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3381), 29,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [3783] = 27,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1308), 1,
      anon_sym_for,
    ACTIONS(1314), 1,
      anon_sym_extern,
    ACTIONS(3049), 1,
      anon_sym_QMARK,
    ACTIONS(3061), 1,
      anon_sym_fn,
    ACTIONS(3387), 1,
      sym_identifier,
    ACTIONS(3389), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3395), 1,
      anon_sym_default,
    ACTIONS(3397), 1,
      anon_sym_union,
    ACTIONS(3401), 1,
      sym_metavariable,
    STATE(1015), 1,
      sym_scoped_type_identifier,
    STATE(1061), 1,
      sym_generic_type,
    STATE(1614), 1,
      sym_for_lifetimes,
    STATE(2197), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2324), 1,
      sym_extern_modifier,
    STATE(3321), 1,
      sym_function_modifiers,
    STATE(3472), 1,
      sym_scoped_identifier,
    STATE(3506), 1,
      sym_generic_type_with_turbofish,
    STATE(3516), 1,
      sym_bracketed_type,
    STATE(1056), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1300), 3,
      anon_sym_async,
      anon_sym_const,
      anon_sym_unsafe,
    ACTIONS(3399), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(1414), 3,
      sym_removed_trait_bound,
      sym_function_type,
      sym_tuple_type,
    ACTIONS(3391), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [3888] = 27,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1308), 1,
      anon_sym_for,
    ACTIONS(1314), 1,
      anon_sym_extern,
    ACTIONS(3091), 1,
      anon_sym_QMARK,
    ACTIONS(3103), 1,
      anon_sym_fn,
    ACTIONS(3329), 1,
      anon_sym_LPAREN,
    ACTIONS(3333), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3335), 1,
      anon_sym_default,
    ACTIONS(3339), 1,
      anon_sym_union,
    ACTIONS(3343), 1,
      sym_metavariable,
    ACTIONS(3403), 1,
      sym_identifier,
    STATE(1513), 1,
      sym_scoped_type_identifier,
    STATE(1577), 1,
      sym_generic_type,
    STATE(1587), 1,
      sym_for_lifetimes,
    STATE(2197), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2324), 1,
      sym_extern_modifier,
    STATE(3462), 1,
      sym_function_modifiers,
    STATE(3497), 1,
      sym_scoped_identifier,
    STATE(3514), 1,
      sym_generic_type_with_turbofish,
    STATE(3520), 1,
      sym_bracketed_type,
    STATE(1057), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1300), 3,
      anon_sym_async,
      anon_sym_const,
      anon_sym_unsafe,
    ACTIONS(3341), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(1793), 3,
      sym_removed_trait_bound,
      sym_function_type,
      sym_tuple_type,
    ACTIONS(3331), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [3993] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1058), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3407), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3405), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [4054] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1059), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3411), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3409), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [4115] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3417), 1,
      anon_sym_DASH_GT,
    STATE(1060), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3415), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3413), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [4178] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3353), 1,
      anon_sym_COLON_COLON,
    STATE(1061), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3273), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3271), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [4241] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1062), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3421), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3419), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [4302] = 27,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1314), 1,
      anon_sym_extern,
    ACTIONS(3049), 1,
      anon_sym_QMARK,
    ACTIONS(3061), 1,
      anon_sym_fn,
    ACTIONS(3389), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3395), 1,
      anon_sym_default,
    ACTIONS(3397), 1,
      anon_sym_union,
    ACTIONS(3401), 1,
      sym_metavariable,
    ACTIONS(3423), 1,
      sym_identifier,
    ACTIONS(3425), 1,
      anon_sym_for,
    STATE(1013), 1,
      sym_scoped_type_identifier,
    STATE(1070), 1,
      sym_generic_type,
    STATE(1614), 1,
      sym_for_lifetimes,
    STATE(2197), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2324), 1,
      sym_extern_modifier,
    STATE(3321), 1,
      sym_function_modifiers,
    STATE(3472), 1,
      sym_scoped_identifier,
    STATE(3506), 1,
      sym_generic_type_with_turbofish,
    STATE(3516), 1,
      sym_bracketed_type,
    STATE(1063), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1300), 3,
      anon_sym_async,
      anon_sym_const,
      anon_sym_unsafe,
    ACTIONS(3399), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(1317), 3,
      sym_removed_trait_bound,
      sym_function_type,
      sym_tuple_type,
    ACTIONS(3391), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [4407] = 27,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1274), 1,
      anon_sym_QMARK,
    ACTIONS(1306), 1,
      anon_sym_fn,
    ACTIONS(1308), 1,
      anon_sym_for,
    ACTIONS(1314), 1,
      anon_sym_extern,
    ACTIONS(3427), 1,
      sym_identifier,
    ACTIONS(3429), 1,
      anon_sym_LPAREN,
    ACTIONS(3433), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3435), 1,
      anon_sym_default,
    ACTIONS(3437), 1,
      anon_sym_union,
    ACTIONS(3441), 1,
      sym_metavariable,
    STATE(1622), 1,
      sym_for_lifetimes,
    STATE(1911), 1,
      sym_scoped_type_identifier,
    STATE(1937), 1,
      sym_generic_type,
    STATE(2197), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2324), 1,
      sym_extern_modifier,
    STATE(3323), 1,
      sym_generic_type_with_turbofish,
    STATE(3412), 1,
      sym_scoped_identifier,
    STATE(3416), 1,
      sym_function_modifiers,
    STATE(3458), 1,
      sym_bracketed_type,
    STATE(1064), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1300), 3,
      anon_sym_async,
      anon_sym_const,
      anon_sym_unsafe,
    ACTIONS(3439), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(1978), 3,
      sym_removed_trait_bound,
      sym_function_type,
      sym_tuple_type,
    ACTIONS(3431), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [4512] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1065), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3445), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3443), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [4573] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3451), 1,
      anon_sym_DASH_GT,
    STATE(1066), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3449), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3447), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [4636] = 24,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1562), 1,
      anon_sym_LBRACK,
    ACTIONS(3429), 1,
      anon_sym_LPAREN,
    ACTIONS(3433), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3441), 1,
      sym_metavariable,
    ACTIONS(3453), 1,
      sym_identifier,
    ACTIONS(3457), 1,
      anon_sym_STAR,
    ACTIONS(3461), 1,
      anon_sym_AMP,
    ACTIONS(3463), 1,
      anon_sym_SQUOTE,
    ACTIONS(3465), 1,
      anon_sym_for,
    STATE(2566), 1,
      sym_scoped_type_identifier,
    STATE(2671), 1,
      sym_where_predicate,
    STATE(2869), 1,
      sym_generic_type,
    STATE(3323), 1,
      sym_generic_type_with_turbofish,
    STATE(3412), 1,
      sym_scoped_identifier,
    STATE(3458), 1,
      sym_bracketed_type,
    ACTIONS(3437), 2,
      anon_sym_default,
      anon_sym_union,
    ACTIONS(3455), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(1067), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3439), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(3256), 6,
      sym_higher_ranked_trait_bound,
      sym_lifetime,
      sym_array_type,
      sym_tuple_type,
      sym_reference_type,
      sym_pointer_type,
    ACTIONS(3459), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [4735] = 27,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1274), 1,
      anon_sym_QMARK,
    ACTIONS(1306), 1,
      anon_sym_fn,
    ACTIONS(1314), 1,
      anon_sym_extern,
    ACTIONS(3429), 1,
      anon_sym_LPAREN,
    ACTIONS(3433), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3435), 1,
      anon_sym_default,
    ACTIONS(3437), 1,
      anon_sym_union,
    ACTIONS(3441), 1,
      sym_metavariable,
    ACTIONS(3467), 1,
      sym_identifier,
    ACTIONS(3469), 1,
      anon_sym_for,
    STATE(1622), 1,
      sym_for_lifetimes,
    STATE(1905), 1,
      sym_scoped_type_identifier,
    STATE(1948), 1,
      sym_generic_type,
    STATE(2197), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2324), 1,
      sym_extern_modifier,
    STATE(3323), 1,
      sym_generic_type_with_turbofish,
    STATE(3412), 1,
      sym_scoped_identifier,
    STATE(3416), 1,
      sym_function_modifiers,
    STATE(3458), 1,
      sym_bracketed_type,
    STATE(1068), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1300), 3,
      anon_sym_async,
      anon_sym_const,
      anon_sym_unsafe,
    ACTIONS(3439), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(1977), 3,
      sym_removed_trait_bound,
      sym_function_type,
      sym_tuple_type,
    ACTIONS(3431), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [4840] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3475), 1,
      anon_sym_DASH_GT,
    STATE(1069), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3473), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3471), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [4903] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3353), 1,
      anon_sym_COLON_COLON,
    STATE(1070), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3261), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3259), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [4966] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3481), 1,
      anon_sym_DASH_GT,
    STATE(1071), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3479), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3477), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [5029] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1072), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3485), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3483), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [5090] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3491), 1,
      anon_sym_DASH_GT,
    STATE(1073), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3489), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3487), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [5153] = 24,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1562), 1,
      anon_sym_LBRACK,
    ACTIONS(3429), 1,
      anon_sym_LPAREN,
    ACTIONS(3433), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3441), 1,
      sym_metavariable,
    ACTIONS(3453), 1,
      sym_identifier,
    ACTIONS(3457), 1,
      anon_sym_STAR,
    ACTIONS(3461), 1,
      anon_sym_AMP,
    ACTIONS(3463), 1,
      anon_sym_SQUOTE,
    ACTIONS(3465), 1,
      anon_sym_for,
    STATE(2566), 1,
      sym_scoped_type_identifier,
    STATE(2671), 1,
      sym_where_predicate,
    STATE(2869), 1,
      sym_generic_type,
    STATE(3323), 1,
      sym_generic_type_with_turbofish,
    STATE(3412), 1,
      sym_scoped_identifier,
    STATE(3458), 1,
      sym_bracketed_type,
    ACTIONS(3437), 2,
      anon_sym_default,
      anon_sym_union,
    ACTIONS(3493), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(1074), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3439), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(3256), 6,
      sym_higher_ranked_trait_bound,
      sym_lifetime,
      sym_array_type,
      sym_tuple_type,
      sym_reference_type,
      sym_pointer_type,
    ACTIONS(3459), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [5252] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1075), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3497), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3495), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [5313] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3499), 1,
      anon_sym_COLON_COLON,
    STATE(1076), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3293), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3291), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [5376] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1077), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3503), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3501), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [5437] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3505), 1,
      anon_sym_LBRACE,
    STATE(1078), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3279), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3281), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_as,
      anon_sym_else,
  [5500] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3511), 1,
      anon_sym_DASH_GT,
    STATE(1079), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3509), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3507), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [5563] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3513), 1,
      anon_sym_COLON_COLON,
    STATE(1080), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3293), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3291), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [5626] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3515), 1,
      anon_sym_LBRACE,
    STATE(1081), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3287), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3289), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_as,
      anon_sym_else,
  [5689] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3353), 1,
      anon_sym_COLON_COLON,
    STATE(1082), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3293), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3291), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [5752] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1083), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3253), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3251), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
      anon_sym_LT2,
  [5813] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1084), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1546), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1548), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [5874] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    STATE(1198), 1,
      sym_label,
    STATE(1085), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3519), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3517), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_else,
  [5939] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1086), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3525), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3523), 31,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [6000] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1087), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2615), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2617), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [6060] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1088), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2244), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2246), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [6120] = 21,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1618), 1,
      anon_sym_DASH,
    ACTIONS(1642), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1650), 1,
      sym__raw_string_literal_start,
    ACTIONS(3217), 1,
      anon_sym_if,
    ACTIONS(3527), 1,
      sym_identifier,
    ACTIONS(3531), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3535), 1,
      sym_metavariable,
    STATE(2500), 1,
      sym_scoped_identifier,
    STATE(2781), 1,
      sym__literal_pattern,
    STATE(3454), 1,
      sym_bracketed_type,
    STATE(3467), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(1644), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3215), 2,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
    STATE(1089), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1640), 3,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    ACTIONS(3533), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2345), 4,
      sym_negative_literal,
      sym_string_literal,
      sym_raw_string_literal,
      sym_boolean_literal,
    ACTIONS(3529), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [6212] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1090), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2170), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2172), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [6272] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1091), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1822), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1824), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [6332] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1092), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2569), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2571), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [6392] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1093), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1686), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1688), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [6452] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1094), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2691), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2693), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [6512] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1095), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1698), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1700), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [6572] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1096), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2188), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2190), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [6632] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1097), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3539), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3537), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [6692] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1098), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2687), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2689), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [6752] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1099), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1706), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1708), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [6812] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1100), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1754), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1756), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [6872] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1101), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2134), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2136), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [6932] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1102), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1338), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1336), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [6992] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1103), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1354), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1352), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [7052] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1104), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3543), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3541), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [7112] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1105), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3547), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3545), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [7172] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1106), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2679), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2681), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [7232] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1107), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2577), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2579), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [7292] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1108), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2573), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2575), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [7352] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1109), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1422), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1420), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [7412] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1110), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(793), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(795), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [7472] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1111), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1230), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1228), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [7532] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1112), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2470), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2472), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [7592] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1113), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2360), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2362), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [7652] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1114), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2675), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2677), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [7712] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1115), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1802), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1804), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [7772] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1116), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2438), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2440), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [7832] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1117), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2871), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2873), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [7892] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1118), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3551), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3549), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [7952] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1119), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2434), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2436), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [8012] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1120), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2006), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2008), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [8072] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3231), 1,
      anon_sym_BANG,
    ACTIONS(3553), 1,
      anon_sym_COLON_COLON,
    STATE(1121), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1344), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1346), 28,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_else,
  [8136] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1122), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2422), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2424), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [8196] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1123), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(749), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(751), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [8256] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1124), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3557), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3555), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [8316] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1125), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2352), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2354), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [8376] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1126), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3561), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3559), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [8436] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3565), 2,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
    STATE(1127), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3567), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3563), 28,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_else,
  [8498] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1128), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2635), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2637), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [8558] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1129), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2348), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2350), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [8618] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1130), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2414), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2416), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [8678] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1131), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3571), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3569), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [8738] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1132), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3575), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3573), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [8798] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1133), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2406), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2408), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [8858] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1134), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3579), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3577), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [8918] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1135), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2402), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2404), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [8978] = 21,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1618), 1,
      anon_sym_DASH,
    ACTIONS(1642), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1650), 1,
      sym__raw_string_literal_start,
    ACTIONS(3205), 1,
      anon_sym_if,
    ACTIONS(3531), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3581), 1,
      sym_identifier,
    ACTIONS(3587), 1,
      sym_metavariable,
    STATE(2521), 1,
      sym_scoped_identifier,
    STATE(2811), 1,
      sym__literal_pattern,
    STATE(3454), 1,
      sym_bracketed_type,
    STATE(3467), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(1644), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3203), 2,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
    STATE(1136), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1640), 3,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    ACTIONS(3585), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2345), 4,
      sym_negative_literal,
      sym_string_literal,
      sym_raw_string_literal,
      sym_boolean_literal,
    ACTIONS(3583), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [9070] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1137), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2631), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2633), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [9130] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1138), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2627), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2629), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [9190] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1139), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2394), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2396), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [9250] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1140), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3591), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3589), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [9310] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1141), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2390), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2392), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [9370] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1142), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2386), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2388), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [9430] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1143), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3595), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(3593), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [9490] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1144), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2344), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2346), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [9550] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1145), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3599), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3597), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [9610] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1146), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3603), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3601), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [9670] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1147), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2332), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2334), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [9730] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1148), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1234), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1232), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [9790] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1149), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2324), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2326), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [9850] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1150), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2320), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2322), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [9910] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1151), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3607), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3605), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [9970] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1152), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2370), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2372), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [10030] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1153), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1344), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1346), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [10090] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3613), 1,
      anon_sym_RBRACE,
    STATE(1154), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3611), 15,
      sym__raw_string_literal_start,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(3609), 29,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym__,
      anon_sym_const,
      anon_sym_default,
      anon_sym_union,
      anon_sym_ref,
      sym_mutable_specifier,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [10152] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1155), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3385), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3381), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [10212] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1156), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2316), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2318), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [10272] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1157), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3617), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3615), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [10332] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1158), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2340), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2342), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [10392] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1159), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1344), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1346), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [10452] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1160), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2312), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2314), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [10512] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1161), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2176), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2178), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [10572] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1162), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2154), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2156), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [10632] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1163), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2284), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2286), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [10692] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1164), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3621), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3619), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [10752] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1165), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3625), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3623), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [10812] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1166), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1452), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1450), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [10872] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1167), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2166), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2168), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [10932] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1168), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1448), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1446), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [10992] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1169), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2196), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2198), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [11052] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1170), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(813), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(815), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [11112] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1171), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1238), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1236), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [11172] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1172), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1384), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1382), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [11232] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1173), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3629), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3627), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [11292] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1174), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2707), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2709), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [11352] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1175), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3633), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3631), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [11412] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1176), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3637), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3635), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [11472] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1177), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2280), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2282), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [11532] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1178), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2715), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2717), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [11592] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1179), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2719), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2721), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [11652] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1180), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3641), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3639), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [11712] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1181), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2276), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2278), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [11772] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1182), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2723), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2725), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [11832] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1183), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2731), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2733), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [11892] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1184), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2735), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2737), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [11952] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1185), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3645), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3643), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [12012] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1186), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2771), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2773), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12072] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1187), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2308), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2310), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12132] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1188), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2775), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2777), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12192] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1189), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2783), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2785), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12252] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1190), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2304), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2306), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12312] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1191), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2300), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2302), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12372] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1192), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2296), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2298), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12432] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1193), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3649), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3647), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [12492] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1194), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2787), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2789), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12552] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1195), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1426), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1424), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [12612] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1196), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2831), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2833), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [12672] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1197), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1418), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1416), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [12732] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1198), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3653), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3651), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [12792] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1199), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1350), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1348), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [12852] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1200), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3657), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3655), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [12912] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    STATE(1201), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3663), 14,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3659), 27,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_else,
  [12980] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1202), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2292), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2294), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [13040] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1203), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2887), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2889), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [13100] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1204), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2883), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2885), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [13160] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1205), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1404), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1402), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [13220] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1206), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2288), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2290), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [13280] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1207), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2256), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2258), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [13340] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1208), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2252), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2254), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [13400] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1209), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3673), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3671), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [13460] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1210), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3677), 13,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3675), 32,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_where,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [13520] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1211), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3681), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3679), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [13580] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1212), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2248), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2250), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [13640] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1213), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3685), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3683), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [13700] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1214), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2130), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2132), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [13760] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1215), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3293), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3291), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [13820] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1216), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3689), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3687), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [13880] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1217), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3693), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3691), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [13940] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1218), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3297), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3295), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [14000] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1219), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2236), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2238), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [14060] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1220), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2879), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2881), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [14120] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1221), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3697), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3695), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [14180] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1222), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3701), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3699), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [14240] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1223), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1666), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1668), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [14300] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1224), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3705), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3703), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [14360] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1225), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3709), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3707), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [14420] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1226), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3713), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3711), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [14480] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1227), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3715), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [14540] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1228), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2727), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2729), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [14600] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1229), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2232), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2234), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [14660] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1230), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3721), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3719), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [14720] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3723), 2,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
    STATE(1231), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3567), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3563), 28,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_else,
  [14782] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1232), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2228), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2230), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [14842] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1233), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2272), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2274), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [14902] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1234), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2260), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2262), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [14962] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1235), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2867), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2869), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [15022] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1236), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2859), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2861), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [15082] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1237), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2208), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2210), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [15142] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1238), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2240), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2242), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [15202] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1239), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2146), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2148), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [15262] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1240), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2623), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2625), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [15322] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1241), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2619), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2621), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [15382] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1242), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2855), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2857), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [15442] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1243), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2220), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2222), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [15502] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1244), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3727), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3725), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [15562] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1245), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3731), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3729), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [15622] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1246), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3731), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3729), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [15682] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1247), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2607), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2609), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [15742] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1248), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2603), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2605), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [15802] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1249), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2200), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2202), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [15862] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1250), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3567), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3563), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [15922] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1251), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2703), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2705), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [15982] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1252), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2599), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2601), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [16042] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1253), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2843), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2845), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [16102] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1254), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2815), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2817), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [16162] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1255), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2811), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2813), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [16222] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1256), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2595), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2597), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [16282] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1257), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2585), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2587), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [16342] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1258), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2158), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2160), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [16402] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    STATE(1259), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3735), 14,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3733), 28,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [16468] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1260), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(999), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1001), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [16528] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1261), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2779), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2781), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [16588] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1262), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2216), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2218), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [16648] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1263), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2847), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2849), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [16708] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1264), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2851), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2853), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [16768] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1265), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2863), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2865), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [16828] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1266), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1246), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1244), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [16888] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1267), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2875), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2877), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [16948] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1268), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2212), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2214), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [17008] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1269), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2150), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2152), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [17068] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1270), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2204), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2206), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [17128] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1271), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2192), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2194), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [17188] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1272), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2138), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2140), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [17248] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1273), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2126), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2128), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [17308] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1274), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2122), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2124), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [17368] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1275), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2184), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2186), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [17428] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1276), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2374), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2376), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [17488] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1277), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2114), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2116), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [17548] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1278), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1392), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1390), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [17608] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1279), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2106), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2108), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [17668] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1280), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2803), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2805), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [17728] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1281), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1344), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1346), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [17788] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1282), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2180), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2182), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [17848] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1283), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2102), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2104), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [17908] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1284), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3739), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3737), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [17968] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1285), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2142), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2144), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [18028] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1286), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2098), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2100), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [18088] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1287), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2094), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2096), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [18148] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1288), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1250), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1248), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [18208] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1289), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2118), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2120), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [18268] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1290), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(785), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(787), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [18328] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1291), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2799), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2801), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [18388] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1292), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2839), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2841), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [18448] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1293), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2835), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2837), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [18508] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1294), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2090), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2092), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [18568] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1295), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2827), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2829), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [18628] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1296), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2823), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2825), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [18688] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1297), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2819), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2821), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [18748] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1298), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2086), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2088), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [18808] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1299), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1262), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1260), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [18868] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1300), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3743), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3741), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [18928] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1301), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2110), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2112), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [18988] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1302), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2014), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2016), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19048] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1303), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3747), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3745), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [19108] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1304), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1662), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1664), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19168] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3753), 1,
      anon_sym_RBRACE,
    STATE(1305), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3751), 15,
      sym__raw_string_literal_start,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(3749), 29,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym__,
      anon_sym_const,
      anon_sym_default,
      anon_sym_union,
      anon_sym_ref,
      sym_mutable_specifier,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19230] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1306), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2082), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2084), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19290] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1307), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3757), 13,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3755), 32,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_where,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19350] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1308), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2655), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2657), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19410] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1309), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3761), 13,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3759), 32,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_where,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19470] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1310), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3765), 13,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3763), 32,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_where,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19530] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1311), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2561), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2563), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19590] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1312), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2078), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2080), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19650] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1313), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2739), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2741), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19710] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1314), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2699), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2701), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19770] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1315), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2074), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2076), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19830] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1316), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2695), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2697), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19890] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1317), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3261), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3259), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [19950] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1318), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1254), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1252), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [20010] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1319), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2070), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2072), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20070] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1320), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2683), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2685), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20130] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1321), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1932), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1934), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20190] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1322), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2671), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2673), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20250] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1323), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2667), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2669), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20310] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1324), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2663), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2665), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20370] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1325), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2651), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2653), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20430] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1326), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2647), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2649), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20490] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1327), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1928), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1930), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20550] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1328), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3769), 13,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3767), 32,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_where,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20610] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1329), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2643), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2645), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20670] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1330), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2066), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2068), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20730] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1331), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2639), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2641), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20790] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1332), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3773), 13,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3771), 32,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_where,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20850] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1333), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1678), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1680), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20910] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1334), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3777), 13,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3775), 32,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_where,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20970] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1335), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2611), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2613), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21030] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1336), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2899), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2901), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21090] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1337), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2589), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2591), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21150] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1338), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2895), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2897), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21210] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1339), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2454), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2456), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21270] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1340), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3781), 13,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3779), 32,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_where,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21330] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1341), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2891), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2893), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21390] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1342), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1682), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1684), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21450] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1343), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1690), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1692), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21510] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1344), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3785), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3783), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [21570] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1345), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1702), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1704), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21630] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1346), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2711), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2713), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21690] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1347), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1714), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1716), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21750] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1348), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2659), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2661), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21810] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1349), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2466), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2468), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21870] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1350), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1722), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1724), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21930] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1351), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2450), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2452), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21990] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1352), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2581), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2583), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22050] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1353), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2410), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2412), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22110] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1354), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2565), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2567), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22170] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1355), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2398), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2400), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22230] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1356), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2382), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2384), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22290] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1357), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1674), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1676), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22350] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1358), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2002), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2004), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22410] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1359), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1734), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1736), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22470] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1360), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2366), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2368), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22530] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1361), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2356), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2358), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22590] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1362), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2474), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2476), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22650] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1363), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2462), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2464), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22710] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1364), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2224), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2226), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22770] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1365), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2458), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2460), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22830] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1366), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1778), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1780), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22890] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1367), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1670), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1672), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22950] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1368), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2378), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2380), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23010] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1369), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1694), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1696), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23070] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1370), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1710), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1712), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23130] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1371), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1718), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1720), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23190] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1372), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2062), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2064), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23250] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1373), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3789), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3787), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [23310] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1374), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2446), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2448), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23370] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1375), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1726), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1728), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23430] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1376), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1730), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1732), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23490] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1377), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1738), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1740), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23550] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1378), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2430), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2432), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23610] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1379), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2418), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2420), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23670] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1380), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1742), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1744), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23730] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1381), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1400), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1398), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [23790] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1382), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2328), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2330), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23850] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1383), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1746), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1748), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23910] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1384), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2264), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2266), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23970] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1385), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2791), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2793), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24030] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1386), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2058), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2060), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24090] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1387), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1750), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1752), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24150] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1388), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1758), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1760), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24210] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1389), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2767), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2769), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24270] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1390), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3793), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3791), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [24330] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1391), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3797), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3795), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [24390] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1392), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1762), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1764), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24450] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1393), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1242), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1240), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [24510] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1394), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1344), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1346), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [24570] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1395), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2763), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2765), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24630] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1396), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2759), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2761), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24690] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1397), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1766), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1768), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24750] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1398), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2755), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2757), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24810] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1399), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1770), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1772), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24870] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1400), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2751), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2753), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24930] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1401), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3801), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3799), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [24990] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1402), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3805), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3803), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [25050] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1403), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2747), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2749), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [25110] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1404), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1396), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1394), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [25170] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1405), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2336), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2338), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [25230] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1406), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2426), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2428), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [25290] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1407), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2054), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2056), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [25350] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1408), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1774), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1776), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [25410] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1409), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3809), 13,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3807), 32,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_where,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [25470] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1410), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3813), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3811), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [25530] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1411), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1786), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1788), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [25590] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1412), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1794), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1796), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [25650] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1413), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3817), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3815), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [25710] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1414), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3273), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3271), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [25770] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1415), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2050), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2052), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [25830] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1416), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1798), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1800), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [25890] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1417), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1258), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1256), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [25950] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1418), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1806), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1808), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26010] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1419), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1810), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1812), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26070] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1420), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1818), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1820), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26130] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1421), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1826), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1828), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26190] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1422), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2046), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2048), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26250] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1423), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3821), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3819), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [26310] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1424), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3825), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3823), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [26370] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1425), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3829), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3827), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [26430] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1426), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3833), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3831), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [26490] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1427), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3837), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3835), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [26550] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1428), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1924), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1926), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26610] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1429), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2042), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2044), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26670] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1430), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1838), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1840), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26730] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1431), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1920), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1922), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26790] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    STATE(1432), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3841), 14,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3839), 28,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [26856] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1433), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1408), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1406), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [26916] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1434), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1842), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1844), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26976] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1435), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1896), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1898), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [27036] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    STATE(1436), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3845), 14,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3843), 28,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [27102] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1437), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2442), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2444), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [27162] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1438), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3849), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3847), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [27222] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1439), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3853), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3851), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [27282] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1440), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1344), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1346), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [27342] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1441), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(763), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(765), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [27402] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1442), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(995), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(997), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [27462] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1443), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3857), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3855), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [27522] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1444), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3861), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3859), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [27582] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1445), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1900), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1902), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [27642] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1446), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1904), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1906), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [27702] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1447), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1916), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1918), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [27762] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1448), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1908), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1910), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [27822] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1449), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1834), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1836), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [27882] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1450), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1912), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1914), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [27942] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1451), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2038), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2040), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [28002] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1452), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2010), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2012), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [28062] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1453), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2018), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2020), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [28122] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1454), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2026), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2028), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [28182] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1455), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2030), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2032), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [28242] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1456), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2034), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(2036), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [28302] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1457), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3865), 13,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3863), 32,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_where,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [28362] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1458), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1782), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1784), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [28422] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1459), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1814), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1816), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [28482] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1460), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1440), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1438), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_else,
  [28542] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1461), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1790), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_metavariable,
    ACTIONS(1792), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [28602] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3309), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3867), 1,
      anon_sym_BANG,
    STATE(1462), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3305), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3303), 28,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_else,
  [28666] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1463), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3751), 15,
      sym__raw_string_literal_start,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(3749), 29,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym__,
      anon_sym_const,
      anon_sym_default,
      anon_sym_union,
      anon_sym_ref,
      sym_mutable_specifier,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [28725] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3869), 1,
      anon_sym_COLON_COLON,
    STATE(1464), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1344), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1346), 28,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_else,
  [28786] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3309), 1,
      anon_sym_COLON_COLON,
    STATE(1465), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3305), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3303), 28,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_else,
  [28847] = 23,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1562), 1,
      anon_sym_LBRACK,
    ACTIONS(3429), 1,
      anon_sym_LPAREN,
    ACTIONS(3433), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3441), 1,
      sym_metavariable,
    ACTIONS(3453), 1,
      sym_identifier,
    ACTIONS(3457), 1,
      anon_sym_STAR,
    ACTIONS(3461), 1,
      anon_sym_AMP,
    ACTIONS(3463), 1,
      anon_sym_SQUOTE,
    ACTIONS(3465), 1,
      anon_sym_for,
    STATE(2566), 1,
      sym_scoped_type_identifier,
    STATE(2671), 1,
      sym_where_predicate,
    STATE(2869), 1,
      sym_generic_type,
    STATE(3323), 1,
      sym_generic_type_with_turbofish,
    STATE(3412), 1,
      sym_scoped_identifier,
    STATE(3458), 1,
      sym_bracketed_type,
    ACTIONS(3437), 2,
      anon_sym_default,
      anon_sym_union,
    STATE(1466), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3439), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(3256), 6,
      sym_higher_ranked_trait_bound,
      sym_lifetime,
      sym_array_type,
      sym_tuple_type,
      sym_reference_type,
      sym_pointer_type,
    ACTIONS(3459), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [28942] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1467), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1924), 15,
      sym__raw_string_literal_start,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(1926), 29,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym__,
      anon_sym_const,
      anon_sym_default,
      anon_sym_union,
      anon_sym_ref,
      sym_mutable_specifier,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [29001] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1468), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3189), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      sym_integer_literal,
      sym_metavariable,
    ACTIONS(3187), 32,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_pub,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [29060] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1469), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2727), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_SQUOTE,
      sym_integer_literal,
      sym_metavariable,
    ACTIONS(2729), 32,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_pub,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [29119] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1470), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3611), 15,
      sym__raw_string_literal_start,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(3609), 29,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym__,
      anon_sym_const,
      anon_sym_default,
      anon_sym_union,
      anon_sym_ref,
      sym_mutable_specifier,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [29178] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1471), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3873), 15,
      sym__raw_string_literal_start,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(3871), 29,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym__,
      anon_sym_const,
      anon_sym_default,
      anon_sym_union,
      anon_sym_ref,
      sym_mutable_specifier,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [29237] = 23,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1562), 1,
      anon_sym_LBRACK,
    ACTIONS(3429), 1,
      anon_sym_LPAREN,
    ACTIONS(3433), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3441), 1,
      sym_metavariable,
    ACTIONS(3453), 1,
      sym_identifier,
    ACTIONS(3457), 1,
      anon_sym_STAR,
    ACTIONS(3461), 1,
      anon_sym_AMP,
    ACTIONS(3463), 1,
      anon_sym_SQUOTE,
    ACTIONS(3465), 1,
      anon_sym_for,
    STATE(2453), 1,
      sym_where_predicate,
    STATE(2566), 1,
      sym_scoped_type_identifier,
    STATE(2869), 1,
      sym_generic_type,
    STATE(3323), 1,
      sym_generic_type_with_turbofish,
    STATE(3412), 1,
      sym_scoped_identifier,
    STATE(3458), 1,
      sym_bracketed_type,
    ACTIONS(3437), 2,
      anon_sym_default,
      anon_sym_union,
    STATE(1472), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3439), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(3256), 6,
      sym_higher_ranked_trait_bound,
      sym_lifetime,
      sym_array_type,
      sym_tuple_type,
      sym_reference_type,
      sym_pointer_type,
    ACTIONS(3459), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [29332] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1473), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3877), 15,
      sym__raw_string_literal_start,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(3875), 29,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym__,
      anon_sym_const,
      anon_sym_default,
      anon_sym_union,
      anon_sym_ref,
      sym_mutable_specifier,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [29391] = 18,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3663), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(1474), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3659), 20,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
  [29475] = 19,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3901), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    STATE(1475), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3897), 19,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
  [29561] = 25,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1314), 1,
      anon_sym_extern,
    ACTIONS(3061), 1,
      anon_sym_fn,
    ACTIONS(3393), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3395), 1,
      anon_sym_default,
    ACTIONS(3397), 1,
      anon_sym_union,
    ACTIONS(3401), 1,
      sym_metavariable,
    ACTIONS(3903), 1,
      sym_identifier,
    ACTIONS(3905), 1,
      anon_sym_for,
    STATE(1026), 1,
      sym_scoped_type_identifier,
    STATE(1046), 1,
      sym_generic_type,
    STATE(1614), 1,
      sym_for_lifetimes,
    STATE(2197), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2324), 1,
      sym_extern_modifier,
    STATE(3321), 1,
      sym_function_modifiers,
    STATE(3472), 1,
      sym_scoped_identifier,
    STATE(3506), 1,
      sym_generic_type_with_turbofish,
    STATE(3516), 1,
      sym_bracketed_type,
    STATE(1218), 2,
      sym_higher_ranked_trait_bound,
      sym_function_type,
    STATE(1476), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1300), 3,
      anon_sym_async,
      anon_sym_const,
      anon_sym_unsafe,
    ACTIONS(3399), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(3391), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [29659] = 15,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1477), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3663), 4,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3659), 25,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
  [29737] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3911), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3913), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1478), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3569), 7,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_else,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [29829] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3911), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3917), 1,
      anon_sym_EQ,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3913), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1479), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3915), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
  [29919] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3911), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3913), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1480), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3605), 7,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_else,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [30011] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3299), 1,
      anon_sym_LBRACE,
    ACTIONS(3301), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3919), 1,
      anon_sym_BANG,
    STATE(1118), 1,
      sym_field_initializer_list,
    STATE(1481), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1344), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1346), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [30077] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3911), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3923), 1,
      anon_sym_EQ,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3913), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1482), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3921), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
  [30167] = 19,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(396), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(1483), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(394), 19,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
  [30253] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3925), 1,
      anon_sym_LPAREN,
    ACTIONS(3927), 1,
      anon_sym_BANG,
    ACTIONS(3929), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3931), 1,
      anon_sym_LT2,
    STATE(1576), 1,
      sym_parameters,
    STATE(1627), 1,
      sym_type_arguments,
    STATE(1484), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3229), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3225), 20,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [30323] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    STATE(1485), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3663), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3659), 25,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
  [30391] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1486), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3663), 9,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3659), 25,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
  [30461] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3911), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3935), 1,
      anon_sym_EQ,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3913), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1487), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3933), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
  [30551] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3911), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3939), 1,
      anon_sym_EQ,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3913), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1488), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3937), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
  [30641] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3911), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3943), 1,
      anon_sym_EQ,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3913), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1489), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3941), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
  [30731] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1490), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3663), 5,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3659), 25,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
  [30807] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(342), 1,
      anon_sym_EQ,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3911), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3913), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1491), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(336), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
  [30897] = 25,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1306), 1,
      anon_sym_fn,
    ACTIONS(1314), 1,
      anon_sym_extern,
    ACTIONS(3117), 1,
      anon_sym_for,
    ACTIONS(3433), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3435), 1,
      anon_sym_default,
    ACTIONS(3437), 1,
      anon_sym_union,
    ACTIONS(3441), 1,
      sym_metavariable,
    ACTIONS(3945), 1,
      sym_identifier,
    STATE(1622), 1,
      sym_for_lifetimes,
    STATE(1907), 1,
      sym_scoped_type_identifier,
    STATE(1939), 1,
      sym_generic_type,
    STATE(2197), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2324), 1,
      sym_extern_modifier,
    STATE(3323), 1,
      sym_generic_type_with_turbofish,
    STATE(3412), 1,
      sym_scoped_identifier,
    STATE(3416), 1,
      sym_function_modifiers,
    STATE(3458), 1,
      sym_bracketed_type,
    STATE(1492), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1983), 2,
      sym_higher_ranked_trait_bound,
      sym_function_type,
    ACTIONS(1300), 3,
      anon_sym_async,
      anon_sym_const,
      anon_sym_unsafe,
    ACTIONS(3439), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(3431), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [30995] = 13,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1493), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3663), 6,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3659), 25,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
  [31069] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3911), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3913), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1494), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3737), 7,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_else,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [31161] = 12,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1495), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3663), 7,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3659), 25,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
  [31233] = 17,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3663), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(1496), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3659), 21,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
  [31315] = 25,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1314), 1,
      anon_sym_extern,
    ACTIONS(3103), 1,
      anon_sym_fn,
    ACTIONS(3333), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3335), 1,
      anon_sym_default,
    ACTIONS(3339), 1,
      anon_sym_union,
    ACTIONS(3343), 1,
      sym_metavariable,
    ACTIONS(3947), 1,
      sym_identifier,
    ACTIONS(3949), 1,
      anon_sym_for,
    STATE(1508), 1,
      sym_scoped_type_identifier,
    STATE(1575), 1,
      sym_generic_type,
    STATE(1587), 1,
      sym_for_lifetimes,
    STATE(2197), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2324), 1,
      sym_extern_modifier,
    STATE(3462), 1,
      sym_function_modifiers,
    STATE(3497), 1,
      sym_scoped_identifier,
    STATE(3514), 1,
      sym_generic_type_with_turbofish,
    STATE(3520), 1,
      sym_bracketed_type,
    STATE(1497), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(1728), 2,
      sym_higher_ranked_trait_bound,
      sym_function_type,
    ACTIONS(1300), 3,
      anon_sym_async,
      anon_sym_const,
      anon_sym_unsafe,
    ACTIONS(3341), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(3331), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [31413] = 19,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1278), 1,
      anon_sym_DASH,
    ACTIONS(1324), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1334), 1,
      sym__raw_string_literal_start,
    ACTIONS(1856), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3213), 1,
      sym_identifier,
    ACTIONS(3223), 1,
      sym_metavariable,
    STATE(2060), 1,
      sym_scoped_identifier,
    STATE(2111), 1,
      sym__literal_pattern,
    STATE(3307), 1,
      sym_bracketed_type,
    STATE(3333), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(1326), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1498), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1322), 3,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    ACTIONS(3221), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2006), 4,
      sym_negative_literal,
      sym_string_literal,
      sym_raw_string_literal,
      sym_boolean_literal,
    ACTIONS(3219), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [31498] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3231), 1,
      anon_sym_BANG,
    ACTIONS(3951), 1,
      anon_sym_COLON_COLON,
    STATE(1118), 1,
      sym_field_initializer_list,
    STATE(1499), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1344), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1346), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
      anon_sym_as,
  [31561] = 19,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1278), 1,
      anon_sym_DASH,
    ACTIONS(1324), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1334), 1,
      sym__raw_string_literal_start,
    ACTIONS(1856), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3201), 1,
      sym_identifier,
    ACTIONS(3211), 1,
      sym_metavariable,
    STATE(2027), 1,
      sym_scoped_identifier,
    STATE(2090), 1,
      sym__literal_pattern,
    STATE(3307), 1,
      sym_bracketed_type,
    STATE(3333), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(1326), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1500), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1322), 3,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    ACTIONS(3209), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2006), 4,
      sym_negative_literal,
      sym_string_literal,
      sym_raw_string_literal,
      sym_boolean_literal,
    ACTIONS(3207), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [31646] = 19,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1618), 1,
      anon_sym_DASH,
    ACTIONS(1642), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1650), 1,
      sym__raw_string_literal_start,
    ACTIONS(3531), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3581), 1,
      sym_identifier,
    ACTIONS(3587), 1,
      sym_metavariable,
    STATE(2521), 1,
      sym_scoped_identifier,
    STATE(2811), 1,
      sym__literal_pattern,
    STATE(3454), 1,
      sym_bracketed_type,
    STATE(3467), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(1644), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1501), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1640), 3,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    ACTIONS(3585), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2345), 4,
      sym_negative_literal,
      sym_string_literal,
      sym_raw_string_literal,
      sym_boolean_literal,
    ACTIONS(3583), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [31731] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3927), 1,
      anon_sym_BANG,
    ACTIONS(3953), 1,
      anon_sym_LBRACE,
    ACTIONS(3955), 1,
      anon_sym_COLON_COLON,
    STATE(1738), 1,
      sym_field_initializer_list,
    STATE(1502), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1344), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1346), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [31796] = 19,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1618), 1,
      anon_sym_DASH,
    ACTIONS(1642), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1650), 1,
      sym__raw_string_literal_start,
    ACTIONS(3527), 1,
      sym_identifier,
    ACTIONS(3531), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3535), 1,
      sym_metavariable,
    STATE(2500), 1,
      sym_scoped_identifier,
    STATE(2781), 1,
      sym__literal_pattern,
    STATE(3454), 1,
      sym_bracketed_type,
    STATE(3467), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(1644), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1503), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1640), 3,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    ACTIONS(3533), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2345), 4,
      sym_negative_literal,
      sym_string_literal,
      sym_raw_string_literal,
      sym_boolean_literal,
    ACTIONS(3529), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [31881] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3925), 1,
      anon_sym_LPAREN,
    ACTIONS(3931), 1,
      anon_sym_LT2,
    ACTIONS(3957), 1,
      anon_sym_COLON_COLON,
    STATE(1576), 1,
      sym_parameters,
    STATE(1627), 1,
      sym_type_arguments,
    STATE(1504), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3249), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3247), 20,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [31948] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3307), 1,
      anon_sym_BANG,
    ACTIONS(3309), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3959), 1,
      sym_identifier,
    STATE(1505), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3305), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
      anon_sym_as,
    ACTIONS(3303), 23,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [32011] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3925), 1,
      anon_sym_LPAREN,
    ACTIONS(3931), 1,
      anon_sym_LT2,
    ACTIONS(3957), 1,
      anon_sym_COLON_COLON,
    STATE(1576), 1,
      sym_parameters,
    STATE(1627), 1,
      sym_type_arguments,
    STATE(1506), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3239), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3237), 20,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [32078] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3925), 1,
      anon_sym_LPAREN,
    ACTIONS(3931), 1,
      anon_sym_LT2,
    ACTIONS(3957), 1,
      anon_sym_COLON_COLON,
    STATE(1576), 1,
      sym_parameters,
    STATE(1627), 1,
      sym_type_arguments,
    STATE(1507), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3245), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3243), 20,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [32145] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3925), 1,
      anon_sym_LPAREN,
    ACTIONS(3931), 1,
      anon_sym_LT2,
    STATE(1578), 1,
      sym_parameters,
    STATE(1617), 1,
      sym_type_arguments,
    STATE(1508), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3297), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3295), 20,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [32209] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    STATE(1509), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3267), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3269), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_as,
  [32267] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3279), 1,
      anon_sym_BANG,
    ACTIONS(3281), 1,
      anon_sym_COLON_COLON,
    STATE(1510), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3277), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3275), 22,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
      anon_sym_LT2,
  [32327] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3255), 1,
      anon_sym_BANG,
    ACTIONS(3257), 1,
      anon_sym_COLON_COLON,
    STATE(1511), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3253), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3251), 22,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
      anon_sym_LT2,
  [32387] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3267), 1,
      anon_sym_BANG,
    ACTIONS(3269), 1,
      anon_sym_COLON_COLON,
    STATE(1512), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3265), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3263), 22,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
      anon_sym_LT2,
  [32447] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3925), 1,
      anon_sym_LPAREN,
    ACTIONS(3931), 1,
      anon_sym_LT2,
    STATE(1578), 1,
      sym_parameters,
    STATE(1617), 1,
      sym_type_arguments,
    STATE(1513), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3273), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3271), 20,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [32511] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3925), 1,
      anon_sym_LPAREN,
    ACTIONS(3931), 1,
      anon_sym_LT2,
    STATE(1578), 1,
      sym_parameters,
    STATE(1617), 1,
      sym_type_arguments,
    STATE(1514), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3261), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3259), 20,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [32575] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3355), 1,
      anon_sym_LBRACE,
    STATE(1515), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3255), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3257), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_as,
  [32633] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1516), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3963), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3961), 31,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [32689] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3231), 1,
      anon_sym_BANG,
    ACTIONS(3965), 1,
      anon_sym_COLON_COLON,
    STATE(1517), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1344), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1346), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
      anon_sym_as,
  [32749] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1518), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3769), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3767), 31,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [32805] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3553), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3919), 1,
      anon_sym_BANG,
    STATE(1519), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1344), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1346), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [32865] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3925), 1,
      anon_sym_LPAREN,
    ACTIONS(3931), 1,
      anon_sym_LT2,
    STATE(1578), 1,
      sym_parameters,
    STATE(1617), 1,
      sym_type_arguments,
    STATE(1520), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3293), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3291), 20,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [32929] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3287), 1,
      anon_sym_BANG,
    ACTIONS(3289), 1,
      anon_sym_COLON_COLON,
    STATE(1521), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3285), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3283), 22,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
      anon_sym_LT2,
  [32989] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3515), 1,
      anon_sym_LBRACE,
    STATE(1522), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3287), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3289), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_as,
  [33047] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1523), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3969), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3967), 31,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [33103] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1524), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3279), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3281), 25,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
  [33159] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1525), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3287), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3289), 25,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
  [33215] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1526), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3267), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3269), 25,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
  [33271] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    STATE(1527), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3976), 9,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3971), 31,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [33329] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1528), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3980), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3978), 31,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [33385] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3982), 1,
      anon_sym_COLON_COLON,
    STATE(1529), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3976), 9,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3971), 31,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [33443] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3505), 1,
      anon_sym_LBRACE,
    STATE(1530), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3279), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3281), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_as,
  [33501] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3867), 1,
      anon_sym_BANG,
    ACTIONS(3985), 1,
      anon_sym_COLON_COLON,
    STATE(1531), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3305), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3303), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
      anon_sym_as,
  [33561] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1532), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3865), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      sym_metavariable,
    ACTIONS(3863), 31,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [33617] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1533), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3255), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3257), 25,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
  [33673] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1534), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3255), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3257), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_as,
  [33728] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3987), 1,
      anon_sym_else,
    STATE(1630), 1,
      sym_else_clause,
    STATE(1535), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1196), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1194), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [33787] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3927), 1,
      anon_sym_BANG,
    ACTIONS(3989), 1,
      anon_sym_COLON_COLON,
    STATE(1536), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1344), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1346), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [33846] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1537), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3369), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3367), 25,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_as,
  [33901] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1538), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3407), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3405), 25,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_as,
  [33956] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3991), 1,
      anon_sym_BANG,
    ACTIONS(3993), 1,
      anon_sym_COLON_COLON,
    STATE(1539), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3305), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3303), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [34015] = 25,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(931), 1,
      anon_sym_RBRACK,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3995), 1,
      anon_sym_SEMI,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4001), 1,
      anon_sym_COMMA,
    STATE(2876), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1540), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [34110] = 25,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1013), 1,
      anon_sym_RBRACK,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4003), 1,
      anon_sym_SEMI,
    ACTIONS(4005), 1,
      anon_sym_COMMA,
    STATE(2755), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1541), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [34205] = 25,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(4011), 1,
      anon_sym_CARET,
    ACTIONS(4013), 1,
      anon_sym_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE,
    ACTIONS(4017), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4019), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4025), 1,
      anon_sym_EQ,
    ACTIONS(4031), 1,
      anon_sym_DOT_DOT,
    STATE(389), 1,
      sym_block,
    STATE(3398), 1,
      sym_label,
    ACTIONS(4007), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4021), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4029), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4033), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1542), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4009), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4027), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4023), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [34300] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1543), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3279), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3281), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_as,
  [34355] = 25,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1208), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(4011), 1,
      anon_sym_CARET,
    ACTIONS(4013), 1,
      anon_sym_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE,
    ACTIONS(4017), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4019), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4025), 1,
      anon_sym_EQ,
    ACTIONS(4031), 1,
      anon_sym_DOT_DOT,
    STATE(473), 1,
      sym_block,
    STATE(3580), 1,
      sym_label,
    ACTIONS(4007), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4021), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4029), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4033), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1544), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4009), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4027), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4023), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [34450] = 25,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(4011), 1,
      anon_sym_CARET,
    ACTIONS(4013), 1,
      anon_sym_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE,
    ACTIONS(4017), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4019), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4025), 1,
      anon_sym_EQ,
    ACTIONS(4031), 1,
      anon_sym_DOT_DOT,
    STATE(396), 1,
      sym_block,
    STATE(3398), 1,
      sym_label,
    ACTIONS(4007), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4021), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4029), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4033), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1545), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4009), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4027), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4023), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [34545] = 25,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(4011), 1,
      anon_sym_CARET,
    ACTIONS(4013), 1,
      anon_sym_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE,
    ACTIONS(4017), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4019), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4025), 1,
      anon_sym_EQ,
    ACTIONS(4031), 1,
      anon_sym_DOT_DOT,
    STATE(1460), 1,
      sym_block,
    STATE(3529), 1,
      sym_label,
    ACTIONS(4007), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4021), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4029), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4033), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1546), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4009), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4027), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4023), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [34640] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1547), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3445), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3443), 25,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_as,
  [34695] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3565), 1,
      anon_sym_COLON_COLON,
    STATE(1548), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3567), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3563), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
      anon_sym_as,
  [34752] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1198), 1,
      sym_label,
    STATE(1549), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3519), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3517), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
      anon_sym_as,
  [34809] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1550), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3287), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3289), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_as,
  [34864] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4035), 1,
      anon_sym_COLON_COLON,
    STATE(1551), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1344), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1346), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
      anon_sym_as,
  [34921] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3723), 2,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
    STATE(1552), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3567), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3563), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [34978] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1553), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3347), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3345), 25,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_as,
  [35033] = 25,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(4011), 1,
      anon_sym_CARET,
    ACTIONS(4013), 1,
      anon_sym_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE,
    ACTIONS(4017), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4019), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4025), 1,
      anon_sym_EQ,
    ACTIONS(4031), 1,
      anon_sym_DOT_DOT,
    STATE(1433), 1,
      sym_block,
    STATE(3529), 1,
      sym_label,
    ACTIONS(4007), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4021), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4029), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4033), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1554), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4009), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4027), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4023), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [35128] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3985), 1,
      anon_sym_COLON_COLON,
    STATE(1555), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3305), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3303), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
      anon_sym_as,
  [35185] = 25,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(975), 1,
      anon_sym_RBRACK,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4037), 1,
      anon_sym_SEMI,
    ACTIONS(4039), 1,
      anon_sym_COMMA,
    STATE(2780), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1556), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [35280] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1557), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3267), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3269), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_as,
  [35335] = 25,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(949), 1,
      anon_sym_RBRACK,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4041), 1,
      anon_sym_SEMI,
    ACTIONS(4043), 1,
      anon_sym_COMMA,
    STATE(3007), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1558), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [35430] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3565), 2,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
    STATE(1559), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3567), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3563), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [35487] = 25,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(400), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(4011), 1,
      anon_sym_CARET,
    ACTIONS(4013), 1,
      anon_sym_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE,
    ACTIONS(4017), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4019), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4025), 1,
      anon_sym_EQ,
    ACTIONS(4031), 1,
      anon_sym_DOT_DOT,
    STATE(1752), 1,
      sym_block,
    STATE(3581), 1,
      sym_label,
    ACTIONS(4007), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4021), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4029), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4033), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1560), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4009), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4027), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4023), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [35582] = 25,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(400), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(4011), 1,
      anon_sym_CARET,
    ACTIONS(4013), 1,
      anon_sym_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE,
    ACTIONS(4017), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4019), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4025), 1,
      anon_sym_EQ,
    ACTIONS(4031), 1,
      anon_sym_DOT_DOT,
    STATE(1830), 1,
      sym_block,
    STATE(3581), 1,
      sym_label,
    ACTIONS(4007), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4021), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4029), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4033), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1561), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4009), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4027), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4023), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [35677] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3723), 1,
      anon_sym_COLON_COLON,
    STATE(1562), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3567), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3563), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
      anon_sym_as,
  [35734] = 25,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1208), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(4011), 1,
      anon_sym_CARET,
    ACTIONS(4013), 1,
      anon_sym_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE,
    ACTIONS(4017), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4019), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4025), 1,
      anon_sym_EQ,
    ACTIONS(4031), 1,
      anon_sym_DOT_DOT,
    STATE(472), 1,
      sym_block,
    STATE(3580), 1,
      sym_label,
    ACTIONS(4007), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4021), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4029), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4033), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1563), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4009), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4027), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4023), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [35829] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4045), 1,
      anon_sym_SQUOTE,
    STATE(1727), 1,
      sym_label,
    STATE(1564), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3519), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3517), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [35888] = 24,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(993), 1,
      anon_sym_RPAREN,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4047), 1,
      anon_sym_COMMA,
    STATE(2886), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1565), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [35980] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3923), 1,
      anon_sym_EQ,
    ACTIONS(4011), 1,
      anon_sym_CARET,
    ACTIONS(4013), 1,
      anon_sym_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE,
    ACTIONS(4017), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4019), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4049), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4007), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4021), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4029), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4051), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1566), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4009), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4027), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3921), 13,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_SQUOTE,
  [36066] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3993), 1,
      anon_sym_COLON_COLON,
    STATE(1567), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3305), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3303), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [36122] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(4011), 1,
      anon_sym_CARET,
    ACTIONS(4013), 1,
      anon_sym_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE,
    ACTIONS(4017), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4019), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4025), 1,
      anon_sym_EQ,
    ACTIONS(4049), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4007), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4021), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4029), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4051), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1568), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3737), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
    ACTIONS(4009), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4027), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4023), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [36210] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1569), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1246), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1244), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
      anon_sym_else,
  [36264] = 24,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1003), 1,
      anon_sym_RBRACK,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4053), 1,
      anon_sym_COMMA,
    STATE(2888), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1570), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [36356] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1571), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1234), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1232), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
      anon_sym_else,
  [36410] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1572), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1238), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1236), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
      anon_sym_else,
  [36464] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1573), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1230), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1228), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
      anon_sym_else,
  [36518] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1574), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1242), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1240), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
      anon_sym_else,
  [36572] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4055), 1,
      anon_sym_COLON_COLON,
    STATE(1575), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3297), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3295), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [36628] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4057), 1,
      anon_sym_DASH_GT,
    STATE(1576), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3449), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3447), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [36684] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4055), 1,
      anon_sym_COLON_COLON,
    STATE(1577), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3273), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3271), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [36740] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4059), 1,
      anon_sym_DASH_GT,
    STATE(1578), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3509), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3507), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [36796] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3935), 1,
      anon_sym_EQ,
    ACTIONS(4011), 1,
      anon_sym_CARET,
    ACTIONS(4013), 1,
      anon_sym_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE,
    ACTIONS(4017), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4019), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4049), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4007), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4021), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4029), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4051), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1579), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4009), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4027), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3933), 13,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_SQUOTE,
  [36882] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4061), 1,
      anon_sym_LPAREN,
    STATE(1742), 1,
      sym_arguments,
    STATE(1580), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3385), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3381), 22,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [36940] = 24,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4063), 1,
      anon_sym_RPAREN,
    ACTIONS(4065), 1,
      anon_sym_COMMA,
    STATE(2791), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1581), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [37032] = 24,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(973), 1,
      anon_sym_RPAREN,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4067), 1,
      anon_sym_COMMA,
    STATE(2938), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1582), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [37124] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1583), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4069), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [37212] = 24,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(985), 1,
      anon_sym_RBRACK,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4071), 1,
      anon_sym_COMMA,
    STATE(2866), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1584), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [37304] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4073), 1,
      anon_sym_COLON_COLON,
    STATE(1585), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3293), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3291), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [37360] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1586), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3351), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3349), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DASH_GT,
      anon_sym_as,
  [37414] = 22,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1314), 1,
      anon_sym_extern,
    ACTIONS(3433), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3435), 1,
      anon_sym_default,
    ACTIONS(3437), 1,
      anon_sym_union,
    ACTIONS(3441), 1,
      sym_metavariable,
    ACTIONS(4075), 1,
      sym_identifier,
    ACTIONS(4077), 1,
      anon_sym_fn,
    STATE(2197), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2324), 1,
      sym_extern_modifier,
    STATE(2631), 1,
      sym_scoped_type_identifier,
    STATE(3323), 1,
      sym_generic_type_with_turbofish,
    STATE(3412), 1,
      sym_scoped_identifier,
    STATE(3432), 1,
      sym_generic_type,
    STATE(3458), 1,
      sym_bracketed_type,
    STATE(3473), 1,
      sym_function_modifiers,
    STATE(1587), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1300), 3,
      anon_sym_async,
      anon_sym_const,
      anon_sym_unsafe,
    ACTIONS(3439), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(3431), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [37502] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1588), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3421), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3419), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DASH_GT,
      anon_sym_as,
  [37556] = 19,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(4011), 1,
      anon_sym_CARET,
    ACTIONS(4013), 1,
      anon_sym_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE,
    ACTIONS(4017), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4019), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3901), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(4007), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4021), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4029), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(1589), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4009), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4027), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3897), 15,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
  [37638] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1590), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3379), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3377), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_as,
  [37692] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4079), 1,
      anon_sym_COLON_COLON,
    STATE(1591), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3293), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3291), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [37748] = 19,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(4011), 1,
      anon_sym_CARET,
    ACTIONS(4013), 1,
      anon_sym_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE,
    ACTIONS(4017), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4019), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(396), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(4007), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4021), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4029), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(1592), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4009), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4027), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(394), 15,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
  [37830] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(4011), 1,
      anon_sym_CARET,
    ACTIONS(4013), 1,
      anon_sym_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE,
    ACTIONS(4017), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4019), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4025), 1,
      anon_sym_EQ,
    ACTIONS(4049), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4007), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4021), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4029), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4051), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1593), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3605), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
    ACTIONS(4009), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4027), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4023), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [37918] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1594), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3365), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3363), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_as,
  [37972] = 15,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(4011), 1,
      anon_sym_CARET,
    ACTIONS(4013), 1,
      anon_sym_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE,
    ACTIONS(4007), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4021), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1595), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4009), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3663), 4,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3659), 21,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
  [38046] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4081), 1,
      anon_sym_DASH_GT,
    STATE(1596), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3479), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3477), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [38102] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4055), 1,
      anon_sym_COLON_COLON,
    STATE(1597), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3261), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3259), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [38158] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(342), 1,
      anon_sym_EQ,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(4011), 1,
      anon_sym_CARET,
    ACTIONS(4013), 1,
      anon_sym_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE,
    ACTIONS(4017), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4019), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4049), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4007), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4021), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4029), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4051), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1598), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4009), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4027), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(336), 13,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_SQUOTE,
  [38244] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3943), 1,
      anon_sym_EQ,
    ACTIONS(4011), 1,
      anon_sym_CARET,
    ACTIONS(4013), 1,
      anon_sym_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE,
    ACTIONS(4017), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4019), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4049), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4007), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4021), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4029), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4051), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1599), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4009), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4027), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3941), 13,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_SQUOTE,
  [38330] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(4007), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1600), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4009), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3663), 9,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3659), 21,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
  [38396] = 18,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(4011), 1,
      anon_sym_CARET,
    ACTIONS(4013), 1,
      anon_sym_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE,
    ACTIONS(4017), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3663), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(4007), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4021), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4029), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(1601), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4009), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4027), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3659), 16,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
  [38476] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1602), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4083), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [38564] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3917), 1,
      anon_sym_EQ,
    ACTIONS(4011), 1,
      anon_sym_CARET,
    ACTIONS(4013), 1,
      anon_sym_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE,
    ACTIONS(4017), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4019), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4049), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4007), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4021), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4029), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4051), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1603), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4009), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4027), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3915), 13,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_SQUOTE,
  [38650] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4055), 1,
      anon_sym_COLON_COLON,
    STATE(1604), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3293), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3291), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [38706] = 17,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(4011), 1,
      anon_sym_CARET,
    ACTIONS(4013), 1,
      anon_sym_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE,
    ACTIONS(3663), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(4007), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4021), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4029), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(1605), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4009), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4027), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3659), 17,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
  [38784] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(4011), 1,
      anon_sym_CARET,
    ACTIONS(4013), 1,
      anon_sym_AMP,
    ACTIONS(4007), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4021), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1606), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4009), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3663), 5,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3659), 21,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
  [38856] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4085), 1,
      anon_sym_DASH_GT,
    STATE(1607), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3373), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3371), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [38912] = 12,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(4007), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4021), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1608), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4009), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3663), 7,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3659), 21,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
  [38980] = 13,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(4013), 1,
      anon_sym_AMP,
    ACTIONS(4007), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4021), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1609), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4009), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3663), 6,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3659), 21,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
  [39050] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    STATE(1610), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4009), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3663), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3659), 21,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_SQUOTE,
  [39114] = 24,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4087), 1,
      anon_sym_RPAREN,
    ACTIONS(4089), 1,
      anon_sym_COMMA,
    STATE(2850), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1611), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [39206] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3939), 1,
      anon_sym_EQ,
    ACTIONS(4011), 1,
      anon_sym_CARET,
    ACTIONS(4013), 1,
      anon_sym_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE,
    ACTIONS(4017), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4019), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4049), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4007), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4021), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4029), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4051), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1612), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4009), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4027), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3937), 13,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_SQUOTE,
  [39292] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1613), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3253), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3251), 22,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
      anon_sym_LT2,
  [39346] = 22,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1314), 1,
      anon_sym_extern,
    ACTIONS(3433), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3435), 1,
      anon_sym_default,
    ACTIONS(3437), 1,
      anon_sym_union,
    ACTIONS(3441), 1,
      sym_metavariable,
    ACTIONS(4091), 1,
      sym_identifier,
    ACTIONS(4093), 1,
      anon_sym_fn,
    STATE(2197), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2324), 1,
      sym_extern_modifier,
    STATE(2694), 1,
      sym_scoped_type_identifier,
    STATE(3323), 1,
      sym_generic_type_with_turbofish,
    STATE(3354), 1,
      sym_function_modifiers,
    STATE(3412), 1,
      sym_scoped_identifier,
    STATE(3432), 1,
      sym_generic_type,
    STATE(3458), 1,
      sym_bracketed_type,
    STATE(1614), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1300), 3,
      anon_sym_async,
      anon_sym_const,
      anon_sym_unsafe,
    ACTIONS(3439), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(3431), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [39434] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4095), 1,
      anon_sym_DASH_GT,
    STATE(1615), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3473), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3471), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [39490] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1616), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3525), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3523), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_as,
  [39544] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1617), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3485), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3483), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_as,
  [39598] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(4011), 1,
      anon_sym_CARET,
    ACTIONS(4013), 1,
      anon_sym_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE,
    ACTIONS(4017), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4019), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4025), 1,
      anon_sym_EQ,
    ACTIONS(4049), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4007), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4021), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4029), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4051), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1618), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3569), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
    ACTIONS(4009), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4027), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4023), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [39686] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1619), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3411), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3409), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DASH_GT,
      anon_sym_as,
  [39740] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4097), 1,
      anon_sym_COLON_COLON,
    STATE(1620), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1344), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1346), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [39796] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1621), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3503), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3501), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DASH_GT,
      anon_sym_as,
  [39850] = 22,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1314), 1,
      anon_sym_extern,
    ACTIONS(3433), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3435), 1,
      anon_sym_default,
    ACTIONS(3437), 1,
      anon_sym_union,
    ACTIONS(3441), 1,
      sym_metavariable,
    ACTIONS(4099), 1,
      sym_identifier,
    ACTIONS(4101), 1,
      anon_sym_fn,
    STATE(2197), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2324), 1,
      sym_extern_modifier,
    STATE(2610), 1,
      sym_scoped_type_identifier,
    STATE(3323), 1,
      sym_generic_type_with_turbofish,
    STATE(3412), 1,
      sym_scoped_identifier,
    STATE(3427), 1,
      sym_function_modifiers,
    STATE(3432), 1,
      sym_generic_type,
    STATE(3458), 1,
      sym_bracketed_type,
    STATE(1622), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1300), 3,
      anon_sym_async,
      anon_sym_const,
      anon_sym_unsafe,
    ACTIONS(3439), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(3431), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [39938] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4103), 1,
      anon_sym_DASH_GT,
    STATE(1623), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3415), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3413), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [39994] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1624), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3325), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3323), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DASH_GT,
      anon_sym_as,
  [40048] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4105), 1,
      anon_sym_COLON_COLON,
    STATE(1625), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1344), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1346), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [40104] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4107), 1,
      anon_sym_DASH_GT,
    STATE(1626), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3489), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3487), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [40160] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1627), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3497), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3495), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_as,
  [40214] = 18,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4109), 1,
      anon_sym_LBRACK,
    ACTIONS(4115), 1,
      anon_sym_QMARK,
    ACTIONS(4117), 1,
      anon_sym_CARET,
    ACTIONS(4119), 1,
      anon_sym_AMP,
    ACTIONS(4121), 1,
      anon_sym_PIPE,
    ACTIONS(4123), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4131), 1,
      anon_sym_DOT,
    ACTIONS(4133), 1,
      anon_sym_as,
    ACTIONS(3663), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(4111), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4125), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4129), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(1628), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4127), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3659), 15,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [40293] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1629), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3629), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3627), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [40346] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1630), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1392), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1390), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [40399] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(314), 1,
      anon_sym_RBRACE,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4135), 1,
      anon_sym_SEMI,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1631), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [40488] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1632), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3717), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3715), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [40541] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1633), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3713), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3711), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [40594] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1634), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3693), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3691), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [40647] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4137), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(1635), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [40734] = 19,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4109), 1,
      anon_sym_LBRACK,
    ACTIONS(4115), 1,
      anon_sym_QMARK,
    ACTIONS(4117), 1,
      anon_sym_CARET,
    ACTIONS(4119), 1,
      anon_sym_AMP,
    ACTIONS(4121), 1,
      anon_sym_PIPE,
    ACTIONS(4123), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4131), 1,
      anon_sym_DOT,
    ACTIONS(4133), 1,
      anon_sym_as,
    ACTIONS(4139), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3901), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(4111), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4125), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4129), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(1636), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4127), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3897), 14,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [40815] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4141), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(1637), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [40902] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4143), 1,
      anon_sym_RBRACE,
    ACTIONS(4145), 1,
      anon_sym_COMMA,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1638), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [40991] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1639), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3861), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3859), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [41044] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3737), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1640), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [41131] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1641), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3857), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3855), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [41184] = 15,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4109), 1,
      anon_sym_LBRACK,
    ACTIONS(4115), 1,
      anon_sym_QMARK,
    ACTIONS(4117), 1,
      anon_sym_CARET,
    ACTIONS(4119), 1,
      anon_sym_AMP,
    ACTIONS(4121), 1,
      anon_sym_PIPE,
    ACTIONS(4131), 1,
      anon_sym_DOT,
    ACTIONS(4133), 1,
      anon_sym_as,
    ACTIONS(4111), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4125), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1642), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3663), 4,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3659), 20,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [41257] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1643), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1400), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1398), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [41310] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3923), 1,
      anon_sym_EQ,
    ACTIONS(4109), 1,
      anon_sym_LBRACK,
    ACTIONS(4115), 1,
      anon_sym_QMARK,
    ACTIONS(4117), 1,
      anon_sym_CARET,
    ACTIONS(4119), 1,
      anon_sym_AMP,
    ACTIONS(4121), 1,
      anon_sym_PIPE,
    ACTIONS(4123), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4131), 1,
      anon_sym_DOT,
    ACTIONS(4133), 1,
      anon_sym_as,
    ACTIONS(4139), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4147), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4111), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4125), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4129), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4149), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1644), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4127), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3921), 12,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [41395] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1645), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3689), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3687), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [41448] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4151), 1,
      anon_sym_SEMI,
    ACTIONS(4153), 1,
      anon_sym_else,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1646), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [41537] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4155), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(1647), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [41624] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4157), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(1648), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [41711] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1649), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3685), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3683), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [41764] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3943), 1,
      anon_sym_EQ,
    ACTIONS(4109), 1,
      anon_sym_LBRACK,
    ACTIONS(4115), 1,
      anon_sym_QMARK,
    ACTIONS(4117), 1,
      anon_sym_CARET,
    ACTIONS(4119), 1,
      anon_sym_AMP,
    ACTIONS(4121), 1,
      anon_sym_PIPE,
    ACTIONS(4123), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4131), 1,
      anon_sym_DOT,
    ACTIONS(4133), 1,
      anon_sym_as,
    ACTIONS(4139), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4147), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4111), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4125), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4129), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4149), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1650), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4127), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3941), 12,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [41849] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1651), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3657), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3655), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [41902] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4109), 1,
      anon_sym_LBRACK,
    ACTIONS(4115), 1,
      anon_sym_QMARK,
    ACTIONS(4131), 1,
      anon_sym_DOT,
    ACTIONS(4133), 1,
      anon_sym_as,
    ACTIONS(4111), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1652), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3663), 9,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3659), 20,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [41967] = 17,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4109), 1,
      anon_sym_LBRACK,
    ACTIONS(4115), 1,
      anon_sym_QMARK,
    ACTIONS(4117), 1,
      anon_sym_CARET,
    ACTIONS(4119), 1,
      anon_sym_AMP,
    ACTIONS(4121), 1,
      anon_sym_PIPE,
    ACTIONS(4131), 1,
      anon_sym_DOT,
    ACTIONS(4133), 1,
      anon_sym_as,
    ACTIONS(3663), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(4111), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4125), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4129), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(1653), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4127), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3659), 16,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [42044] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4159), 1,
      anon_sym_RPAREN,
    ACTIONS(4161), 1,
      anon_sym_COMMA,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1654), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [42133] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1655), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3785), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3783), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [42186] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(332), 1,
      anon_sym_RBRACE,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4135), 1,
      anon_sym_SEMI,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1656), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [42275] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4163), 1,
      anon_sym_SEMI,
    ACTIONS(4165), 1,
      anon_sym_else,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1657), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [42364] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4109), 1,
      anon_sym_LBRACK,
    ACTIONS(4115), 1,
      anon_sym_QMARK,
    ACTIONS(4117), 1,
      anon_sym_CARET,
    ACTIONS(4119), 1,
      anon_sym_AMP,
    ACTIONS(4131), 1,
      anon_sym_DOT,
    ACTIONS(4133), 1,
      anon_sym_as,
    ACTIONS(4111), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4125), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1658), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3663), 5,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3659), 20,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [42435] = 12,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4109), 1,
      anon_sym_LBRACK,
    ACTIONS(4115), 1,
      anon_sym_QMARK,
    ACTIONS(4131), 1,
      anon_sym_DOT,
    ACTIONS(4133), 1,
      anon_sym_as,
    ACTIONS(4111), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4125), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1659), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3663), 7,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3659), 20,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [42502] = 13,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4109), 1,
      anon_sym_LBRACK,
    ACTIONS(4115), 1,
      anon_sym_QMARK,
    ACTIONS(4119), 1,
      anon_sym_AMP,
    ACTIONS(4131), 1,
      anon_sym_DOT,
    ACTIONS(4133), 1,
      anon_sym_as,
    ACTIONS(4111), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4125), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1660), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3663), 6,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3659), 20,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [42571] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4167), 1,
      anon_sym_SEMI,
    ACTIONS(4169), 1,
      anon_sym_else,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1661), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [42660] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4171), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(1662), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [42747] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4173), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(1663), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [42834] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4109), 1,
      anon_sym_LBRACK,
    ACTIONS(4115), 1,
      anon_sym_QMARK,
    ACTIONS(4131), 1,
      anon_sym_DOT,
    ACTIONS(4133), 1,
      anon_sym_as,
    STATE(1664), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3663), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3659), 20,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [42897] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1665), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3805), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3803), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [42950] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4175), 1,
      anon_sym_RBRACE,
    ACTIONS(4177), 1,
      anon_sym_COMMA,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1666), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [43039] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1667), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3649), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3647), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [43092] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4179), 1,
      anon_sym_SEMI,
    ACTIONS(4181), 1,
      anon_sym_else,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1668), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [43181] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1669), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3833), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3831), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [43234] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1670), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1338), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1336), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [43287] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4183), 1,
      anon_sym_RPAREN,
    ACTIONS(4185), 1,
      anon_sym_COMMA,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1671), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [43376] = 19,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(4191), 1,
      anon_sym_CARET,
    ACTIONS(4193), 1,
      anon_sym_AMP,
    ACTIONS(4195), 1,
      anon_sym_PIPE,
    ACTIONS(4197), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4199), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(396), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(4187), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4201), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4205), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(1672), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4189), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4203), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(394), 14,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [43457] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4135), 1,
      anon_sym_SEMI,
    ACTIONS(4207), 1,
      anon_sym_RBRACE,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1673), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [43546] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4209), 1,
      anon_sym_SEMI,
    ACTIONS(4211), 1,
      anon_sym_else,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1674), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [43635] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3569), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1675), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [43722] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1676), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3617), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3615), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [43775] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1677), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3721), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3719), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [43828] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1678), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3293), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3291), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [43881] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(342), 1,
      anon_sym_EQ,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(4191), 1,
      anon_sym_CARET,
    ACTIONS(4193), 1,
      anon_sym_AMP,
    ACTIONS(4195), 1,
      anon_sym_PIPE,
    ACTIONS(4197), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4199), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4213), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4187), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4201), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4205), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4215), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1679), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4189), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4203), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(336), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [43966] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1680), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1404), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1402), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [44019] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3935), 1,
      anon_sym_EQ,
    ACTIONS(4109), 1,
      anon_sym_LBRACK,
    ACTIONS(4115), 1,
      anon_sym_QMARK,
    ACTIONS(4117), 1,
      anon_sym_CARET,
    ACTIONS(4119), 1,
      anon_sym_AMP,
    ACTIONS(4121), 1,
      anon_sym_PIPE,
    ACTIONS(4123), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4131), 1,
      anon_sym_DOT,
    ACTIONS(4133), 1,
      anon_sym_as,
    ACTIONS(4139), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4147), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4111), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4125), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4129), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4149), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1681), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4127), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3933), 12,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [44104] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(155), 1,
      anon_sym_RBRACE,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4135), 1,
      anon_sym_SEMI,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1682), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [44193] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4217), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(1683), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [44280] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(4191), 1,
      anon_sym_CARET,
    ACTIONS(4193), 1,
      anon_sym_AMP,
    ACTIONS(4195), 1,
      anon_sym_PIPE,
    ACTIONS(4197), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4199), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4219), 1,
      anon_sym_LBRACE,
    ACTIONS(4223), 1,
      anon_sym_EQ,
    ACTIONS(4225), 1,
      anon_sym_DOT_DOT,
    STATE(453), 1,
      sym_match_block,
    ACTIONS(4187), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4201), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4205), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4227), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1684), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4189), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4203), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4221), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [44369] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1685), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1344), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1346), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [44422] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3917), 1,
      anon_sym_EQ,
    ACTIONS(4191), 1,
      anon_sym_CARET,
    ACTIONS(4193), 1,
      anon_sym_AMP,
    ACTIONS(4195), 1,
      anon_sym_PIPE,
    ACTIONS(4197), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4199), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4213), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4187), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4201), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4205), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4215), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1686), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4189), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4203), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3915), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [44507] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1687), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1250), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1248), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [44560] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1065), 1,
      anon_sym_RPAREN,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4185), 1,
      anon_sym_COMMA,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1688), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [44649] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1689), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3385), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3381), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [44702] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1690), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3793), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3791), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [44755] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3939), 1,
      anon_sym_EQ,
    ACTIONS(4191), 1,
      anon_sym_CARET,
    ACTIONS(4193), 1,
      anon_sym_AMP,
    ACTIONS(4195), 1,
      anon_sym_PIPE,
    ACTIONS(4197), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4199), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4213), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4187), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4201), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4205), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4215), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1691), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4189), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4203), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3937), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [44840] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1692), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3849), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3847), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [44893] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(324), 1,
      anon_sym_RBRACE,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4135), 1,
      anon_sym_SEMI,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1693), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [44982] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(330), 1,
      anon_sym_RBRACE,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4135), 1,
      anon_sym_SEMI,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1694), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [45071] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1695), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1344), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1346), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [45124] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1696), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3853), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3851), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [45177] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4229), 1,
      anon_sym_SEMI,
    ACTIONS(4231), 1,
      anon_sym_else,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1697), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [45266] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4109), 1,
      anon_sym_LBRACK,
    ACTIONS(4115), 1,
      anon_sym_QMARK,
    ACTIONS(4131), 1,
      anon_sym_DOT,
    STATE(1698), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3845), 14,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3843), 21,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [45325] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1067), 1,
      anon_sym_RPAREN,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4185), 1,
      anon_sym_COMMA,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1699), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [45414] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4109), 1,
      anon_sym_LBRACK,
    ACTIONS(4115), 1,
      anon_sym_QMARK,
    ACTIONS(4131), 1,
      anon_sym_DOT,
    STATE(1700), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3841), 14,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3839), 21,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [45473] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1701), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3747), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3745), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [45526] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1702), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3743), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3741), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [45579] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1703), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3561), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3559), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [45632] = 19,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(4191), 1,
      anon_sym_CARET,
    ACTIONS(4193), 1,
      anon_sym_AMP,
    ACTIONS(4195), 1,
      anon_sym_PIPE,
    ACTIONS(4197), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4199), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3901), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(4187), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4201), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4205), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(1704), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4189), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4203), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3897), 14,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [45713] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1705), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3543), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3541), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [45766] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(141), 1,
      anon_sym_RBRACE,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4135), 1,
      anon_sym_SEMI,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1706), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [45855] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4135), 1,
      anon_sym_SEMI,
    ACTIONS(4233), 1,
      anon_sym_RBRACE,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1707), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [45944] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(137), 1,
      anon_sym_RBRACE,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4135), 1,
      anon_sym_SEMI,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1708), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [46033] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1075), 1,
      anon_sym_RPAREN,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4185), 1,
      anon_sym_COMMA,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1709), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [46122] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(4191), 1,
      anon_sym_CARET,
    ACTIONS(4193), 1,
      anon_sym_AMP,
    ACTIONS(4195), 1,
      anon_sym_PIPE,
    ACTIONS(4197), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4199), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4213), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4223), 1,
      anon_sym_EQ,
    ACTIONS(3605), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(4187), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4201), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4205), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4215), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1710), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4189), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4203), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4221), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [46209] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1711), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3567), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3563), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [46262] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(316), 1,
      anon_sym_RBRACE,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4135), 1,
      anon_sym_SEMI,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1712), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [46351] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1713), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3727), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3725), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [46404] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1714), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3829), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3827), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [46457] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1715), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3701), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3699), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [46510] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1716), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3197), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3199), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [46563] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4185), 1,
      anon_sym_COMMA,
    ACTIONS(4235), 1,
      anon_sym_RPAREN,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1717), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [46652] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(320), 1,
      anon_sym_RBRACE,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4135), 1,
      anon_sym_SEMI,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1718), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [46741] = 19,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4109), 1,
      anon_sym_LBRACK,
    ACTIONS(4115), 1,
      anon_sym_QMARK,
    ACTIONS(4117), 1,
      anon_sym_CARET,
    ACTIONS(4119), 1,
      anon_sym_AMP,
    ACTIONS(4121), 1,
      anon_sym_PIPE,
    ACTIONS(4123), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4131), 1,
      anon_sym_DOT,
    ACTIONS(4133), 1,
      anon_sym_as,
    ACTIONS(4139), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(396), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(4111), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4125), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4129), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(1719), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4127), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(394), 14,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [46822] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1720), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3261), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3259), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [46875] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4135), 1,
      anon_sym_SEMI,
    ACTIONS(4237), 1,
      anon_sym_RBRACE,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1721), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [46964] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3605), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1722), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [47051] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(139), 1,
      anon_sym_RBRACE,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4135), 1,
      anon_sym_SEMI,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1723), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [47140] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(342), 1,
      anon_sym_EQ,
    ACTIONS(4109), 1,
      anon_sym_LBRACK,
    ACTIONS(4115), 1,
      anon_sym_QMARK,
    ACTIONS(4117), 1,
      anon_sym_CARET,
    ACTIONS(4119), 1,
      anon_sym_AMP,
    ACTIONS(4121), 1,
      anon_sym_PIPE,
    ACTIONS(4123), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4131), 1,
      anon_sym_DOT,
    ACTIONS(4133), 1,
      anon_sym_as,
    ACTIONS(4139), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4147), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4111), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4125), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4129), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4149), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1724), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4127), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(336), 12,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [47225] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(129), 1,
      anon_sym_RBRACE,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4135), 1,
      anon_sym_SEMI,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1725), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [47314] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4135), 1,
      anon_sym_SEMI,
    ACTIONS(4239), 1,
      anon_sym_RBRACE,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1726), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [47403] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1727), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3653), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3651), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [47456] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1728), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3297), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3295), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [47509] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3935), 1,
      anon_sym_EQ,
    ACTIONS(4191), 1,
      anon_sym_CARET,
    ACTIONS(4193), 1,
      anon_sym_AMP,
    ACTIONS(4195), 1,
      anon_sym_PIPE,
    ACTIONS(4197), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4199), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4213), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4187), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4201), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4205), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4215), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1729), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4189), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4203), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3933), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [47594] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1730), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3673), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3671), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [47647] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(145), 1,
      anon_sym_RBRACE,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4135), 1,
      anon_sym_SEMI,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1731), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [47736] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3917), 1,
      anon_sym_EQ,
    ACTIONS(4109), 1,
      anon_sym_LBRACK,
    ACTIONS(4115), 1,
      anon_sym_QMARK,
    ACTIONS(4117), 1,
      anon_sym_CARET,
    ACTIONS(4119), 1,
      anon_sym_AMP,
    ACTIONS(4121), 1,
      anon_sym_PIPE,
    ACTIONS(4123), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4131), 1,
      anon_sym_DOT,
    ACTIONS(4133), 1,
      anon_sym_as,
    ACTIONS(4139), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4147), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4111), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4125), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4129), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4149), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1732), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4127), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3915), 12,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [47821] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(4191), 1,
      anon_sym_CARET,
    ACTIONS(4193), 1,
      anon_sym_AMP,
    ACTIONS(4195), 1,
      anon_sym_PIPE,
    ACTIONS(4197), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4199), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4223), 1,
      anon_sym_EQ,
    ACTIONS(4225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4241), 1,
      anon_sym_LBRACE,
    STATE(1680), 1,
      sym_match_block,
    ACTIONS(4187), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4201), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4205), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4227), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1733), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4189), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4203), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4221), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [47910] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(4191), 1,
      anon_sym_CARET,
    ACTIONS(4193), 1,
      anon_sym_AMP,
    ACTIONS(4195), 1,
      anon_sym_PIPE,
    ACTIONS(4197), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4199), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4213), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4223), 1,
      anon_sym_EQ,
    ACTIONS(3569), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(4187), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4201), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4205), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4215), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1734), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4189), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4203), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4221), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [47997] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3939), 1,
      anon_sym_EQ,
    ACTIONS(4109), 1,
      anon_sym_LBRACK,
    ACTIONS(4115), 1,
      anon_sym_QMARK,
    ACTIONS(4117), 1,
      anon_sym_CARET,
    ACTIONS(4119), 1,
      anon_sym_AMP,
    ACTIONS(4121), 1,
      anon_sym_PIPE,
    ACTIONS(4123), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4131), 1,
      anon_sym_DOT,
    ACTIONS(4133), 1,
      anon_sym_as,
    ACTIONS(4139), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4147), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4111), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4125), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4129), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4149), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1735), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4127), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3937), 12,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [48082] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(4011), 1,
      anon_sym_CARET,
    ACTIONS(4013), 1,
      anon_sym_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE,
    ACTIONS(4019), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4025), 1,
      anon_sym_EQ,
    ACTIONS(4031), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4245), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4007), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4021), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4029), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4033), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4243), 2,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
    STATE(1736), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4009), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4027), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4023), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [48169] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4135), 1,
      anon_sym_SEMI,
    ACTIONS(4247), 1,
      anon_sym_RBRACE,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1737), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [48258] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1738), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3551), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3549), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [48311] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(4191), 1,
      anon_sym_CARET,
    ACTIONS(4193), 1,
      anon_sym_AMP,
    ACTIONS(4195), 1,
      anon_sym_PIPE,
    ACTIONS(4197), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4199), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4223), 1,
      anon_sym_EQ,
    ACTIONS(4225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4249), 1,
      anon_sym_LBRACE,
    STATE(1205), 1,
      sym_match_block,
    ACTIONS(4187), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4201), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4205), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4227), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1739), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4189), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4203), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4221), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [48400] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(328), 1,
      anon_sym_RBRACE,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4135), 1,
      anon_sym_SEMI,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1740), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [48489] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1741), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3599), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3597), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [48542] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1742), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3625), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3623), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [48595] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(318), 1,
      anon_sym_RBRACE,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4135), 1,
      anon_sym_SEMI,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1743), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [48684] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4251), 1,
      anon_sym_RPAREN,
    ACTIONS(4253), 1,
      anon_sym_COMMA,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1744), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [48773] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1745), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3603), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3601), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [48826] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1746), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3575), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3573), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [48879] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1747), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3579), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3577), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [48932] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1073), 1,
      anon_sym_RPAREN,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4185), 1,
      anon_sym_COMMA,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1748), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [49021] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4255), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(1749), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [49108] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4257), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(1750), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [49195] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    STATE(1751), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4189), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3663), 11,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3659), 20,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [49258] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1752), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1408), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1406), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [49311] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1753), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1452), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1450), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [49364] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1754), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1448), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1446), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [49417] = 13,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(4193), 1,
      anon_sym_AMP,
    ACTIONS(4187), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4201), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1755), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4189), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3663), 6,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3659), 20,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [49486] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1756), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3591), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3589), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [49539] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1757), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3607), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3605), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [49592] = 12,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(4187), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4201), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1758), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4189), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3663), 7,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3659), 20,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [49659] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1759), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1344), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1346), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [49712] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1760), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3633), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3631), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [49765] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1761), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1262), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1260), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [49818] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(4191), 1,
      anon_sym_CARET,
    ACTIONS(4193), 1,
      anon_sym_AMP,
    ACTIONS(4187), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4201), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1762), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4189), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3663), 5,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3659), 20,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [49889] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1763), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3645), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3643), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [49942] = 17,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(4191), 1,
      anon_sym_CARET,
    ACTIONS(4193), 1,
      anon_sym_AMP,
    ACTIONS(4195), 1,
      anon_sym_PIPE,
    ACTIONS(3663), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(4187), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4201), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4205), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(1764), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4189), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4203), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3659), 16,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [50019] = 18,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(4191), 1,
      anon_sym_CARET,
    ACTIONS(4193), 1,
      anon_sym_AMP,
    ACTIONS(4195), 1,
      anon_sym_PIPE,
    ACTIONS(4197), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3663), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(4187), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4201), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4205), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(1765), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4189), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4203), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3659), 15,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [50098] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1766), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3637), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3635), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [50151] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4109), 1,
      anon_sym_LBRACK,
    ACTIONS(4115), 1,
      anon_sym_QMARK,
    ACTIONS(4131), 1,
      anon_sym_DOT,
    STATE(1767), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3735), 14,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3733), 21,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [50210] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(4187), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1768), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4189), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3663), 9,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3659), 20,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [50275] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3943), 1,
      anon_sym_EQ,
    ACTIONS(4191), 1,
      anon_sym_CARET,
    ACTIONS(4193), 1,
      anon_sym_AMP,
    ACTIONS(4195), 1,
      anon_sym_PIPE,
    ACTIONS(4197), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4199), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4213), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4187), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4201), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4205), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4215), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1769), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4189), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4203), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3941), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [50360] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3923), 1,
      anon_sym_EQ,
    ACTIONS(4191), 1,
      anon_sym_CARET,
    ACTIONS(4193), 1,
      anon_sym_AMP,
    ACTIONS(4195), 1,
      anon_sym_PIPE,
    ACTIONS(4197), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4199), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4213), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4187), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4201), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4205), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4215), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1770), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4189), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4203), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3921), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [50445] = 15,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(4191), 1,
      anon_sym_CARET,
    ACTIONS(4193), 1,
      anon_sym_AMP,
    ACTIONS(4195), 1,
      anon_sym_PIPE,
    ACTIONS(4187), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4201), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    STATE(1771), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4189), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3663), 4,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3659), 20,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [50518] = 18,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4259), 1,
      sym_identifier,
    ACTIONS(4261), 1,
      anon_sym_LBRACE,
    ACTIONS(4263), 1,
      anon_sym_RBRACE,
    ACTIONS(4265), 1,
      anon_sym_STAR,
    ACTIONS(4269), 1,
      anon_sym_COMMA,
    ACTIONS(4271), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4275), 1,
      sym_metavariable,
    STATE(2411), 1,
      sym_scoped_identifier,
    STATE(2986), 1,
      sym__use_clause,
    STATE(3341), 1,
      sym_generic_type_with_turbofish,
    STATE(3499), 1,
      sym_bracketed_type,
    STATE(1772), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4273), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2868), 4,
      sym_scoped_use_list,
      sym_use_list,
      sym_use_as_clause,
      sym_use_wildcard,
    ACTIONS(4267), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [50597] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1773), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3641), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3639), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [50650] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1774), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3705), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3703), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [50703] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1775), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3709), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3707), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [50756] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(322), 1,
      anon_sym_RBRACE,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4135), 1,
      anon_sym_SEMI,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1776), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [50845] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4135), 1,
      anon_sym_SEMI,
    ACTIONS(4277), 1,
      anon_sym_RBRACE,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1777), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [50934] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1778), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3681), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3679), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [50987] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(133), 1,
      anon_sym_RBRACE,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4135), 1,
      anon_sym_SEMI,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1779), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [51076] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1780), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3731), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3729), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [51129] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1781), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(995), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(997), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [51182] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1782), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3731), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3729), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [51235] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4279), 1,
      anon_sym_SEMI,
    ACTIONS(4281), 1,
      anon_sym_else,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1783), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [51324] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1784), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(999), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1001), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [51377] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(4191), 1,
      anon_sym_CARET,
    ACTIONS(4193), 1,
      anon_sym_AMP,
    ACTIONS(4195), 1,
      anon_sym_PIPE,
    ACTIONS(4197), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4199), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4223), 1,
      anon_sym_EQ,
    ACTIONS(4225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4283), 1,
      anon_sym_LBRACE,
    STATE(388), 1,
      sym_match_block,
    ACTIONS(4187), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4201), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4205), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4227), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1785), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4189), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4203), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4221), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [51466] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(4191), 1,
      anon_sym_CARET,
    ACTIONS(4193), 1,
      anon_sym_AMP,
    ACTIONS(4195), 1,
      anon_sym_PIPE,
    ACTIONS(4197), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4199), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4213), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4223), 1,
      anon_sym_EQ,
    ACTIONS(3737), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(4187), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4201), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4205), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4215), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1786), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4189), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4203), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4221), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [51553] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(4011), 1,
      anon_sym_CARET,
    ACTIONS(4013), 1,
      anon_sym_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE,
    ACTIONS(4019), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4025), 1,
      anon_sym_EQ,
    ACTIONS(4031), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4007), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4021), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4029), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4033), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1787), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4009), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4285), 3,
      anon_sym_LBRACE,
      anon_sym_AMP_AMP,
      anon_sym_SQUOTE,
    ACTIONS(4027), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4023), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [51638] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(123), 1,
      anon_sym_RBRACE,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4135), 1,
      anon_sym_SEMI,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1788), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [51727] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1789), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3801), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3799), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [51780] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4287), 1,
      anon_sym_SEMI,
    ACTIONS(4289), 1,
      anon_sym_else,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1790), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [51869] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4109), 1,
      anon_sym_LBRACK,
    ACTIONS(4115), 1,
      anon_sym_QMARK,
    ACTIONS(4117), 1,
      anon_sym_CARET,
    ACTIONS(4119), 1,
      anon_sym_AMP,
    ACTIONS(4121), 1,
      anon_sym_PIPE,
    ACTIONS(4123), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4131), 1,
      anon_sym_DOT,
    ACTIONS(4133), 1,
      anon_sym_as,
    ACTIONS(4139), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4147), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4293), 1,
      anon_sym_EQ,
    ACTIONS(3737), 2,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
    ACTIONS(4111), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4125), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4129), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4149), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1791), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4127), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4291), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [51956] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1792), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3817), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3815), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [52009] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1793), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3273), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3271), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [52062] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(4011), 1,
      anon_sym_CARET,
    ACTIONS(4013), 1,
      anon_sym_AMP,
    ACTIONS(4015), 1,
      anon_sym_PIPE,
    ACTIONS(4019), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4025), 1,
      anon_sym_EQ,
    ACTIONS(4031), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4007), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4021), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4029), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4033), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1794), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4009), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4295), 3,
      anon_sym_LBRACE,
      anon_sym_AMP_AMP,
      anon_sym_SQUOTE,
    ACTIONS(4027), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4023), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [52147] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1795), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3825), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3823), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [52200] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1796), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3837), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3835), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [52253] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1797), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1344), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1346), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [52306] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4109), 1,
      anon_sym_LBRACK,
    ACTIONS(4115), 1,
      anon_sym_QMARK,
    ACTIONS(4131), 1,
      anon_sym_DOT,
    ACTIONS(4133), 1,
      anon_sym_as,
    STATE(1798), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3663), 14,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
    ACTIONS(3659), 20,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [52367] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1799), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3739), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3737), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [52420] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(149), 1,
      anon_sym_RBRACE,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4135), 1,
      anon_sym_SEMI,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1800), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [52509] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1801), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1384), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1382), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [52562] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1802), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3621), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3619), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [52615] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1803), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1354), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1352), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [52668] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1804), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(749), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(751), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [52721] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4109), 1,
      anon_sym_LBRACK,
    ACTIONS(4115), 1,
      anon_sym_QMARK,
    ACTIONS(4117), 1,
      anon_sym_CARET,
    ACTIONS(4119), 1,
      anon_sym_AMP,
    ACTIONS(4121), 1,
      anon_sym_PIPE,
    ACTIONS(4123), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4131), 1,
      anon_sym_DOT,
    ACTIONS(4133), 1,
      anon_sym_as,
    ACTIONS(4139), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4147), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4293), 1,
      anon_sym_EQ,
    ACTIONS(3569), 2,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
    ACTIONS(4111), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4125), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4129), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4149), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1805), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4127), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4291), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [52808] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1806), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1396), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1394), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [52861] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1807), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1258), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1256), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [52914] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1808), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(813), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(815), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [52967] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1809), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3797), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3795), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [53020] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4109), 1,
      anon_sym_LBRACK,
    ACTIONS(4115), 1,
      anon_sym_QMARK,
    ACTIONS(4117), 1,
      anon_sym_CARET,
    ACTIONS(4119), 1,
      anon_sym_AMP,
    ACTIONS(4121), 1,
      anon_sym_PIPE,
    ACTIONS(4123), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4131), 1,
      anon_sym_DOT,
    ACTIONS(4133), 1,
      anon_sym_as,
    ACTIONS(4139), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4147), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4293), 1,
      anon_sym_EQ,
    ACTIONS(3605), 2,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
    ACTIONS(4111), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4125), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4129), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4149), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1810), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4127), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4291), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [53107] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(147), 1,
      anon_sym_RBRACE,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4135), 1,
      anon_sym_SEMI,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1811), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [53196] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1812), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1254), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1252), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [53249] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1813), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3539), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3537), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [53302] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4135), 1,
      anon_sym_SEMI,
    ACTIONS(4297), 1,
      anon_sym_RBRACE,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1814), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [53391] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1815), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1418), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1416), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [53444] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1816), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(793), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(795), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [53497] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(151), 1,
      anon_sym_RBRACE,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4135), 1,
      anon_sym_SEMI,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1817), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [53586] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1818), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3697), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3695), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [53639] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1819), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3789), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3787), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [53692] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1820), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1546), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1548), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [53745] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1821), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3571), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3569), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [53798] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1822), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3813), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3811), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [53851] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1823), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1344), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1346), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [53904] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1824), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3821), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3819), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [53957] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1825), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1422), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1420), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [54010] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1826), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1426), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1424), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [54063] = 23,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(326), 1,
      anon_sym_RBRACE,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4135), 1,
      anon_sym_SEMI,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1827), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [54152] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1828), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1350), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1348), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [54205] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1829), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(785), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(787), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [54258] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1830), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1440), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(1438), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [54311] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1831), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(763), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(765), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [54364] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1832), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3557), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3555), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [54417] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1833), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3547), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3545), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_as,
  [54470] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4299), 1,
      anon_sym_COMMA,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1834), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [54556] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4301), 1,
      anon_sym_SEMI,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1835), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [54642] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4303), 1,
      anon_sym_SEMI,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1836), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [54728] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4305), 1,
      anon_sym_COMMA,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1837), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [54814] = 17,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4259), 1,
      sym_identifier,
    ACTIONS(4261), 1,
      anon_sym_LBRACE,
    ACTIONS(4265), 1,
      anon_sym_STAR,
    ACTIONS(4271), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4275), 1,
      sym_metavariable,
    ACTIONS(4307), 1,
      anon_sym_RBRACE,
    STATE(2411), 1,
      sym_scoped_identifier,
    STATE(3168), 1,
      sym__use_clause,
    STATE(3341), 1,
      sym_generic_type_with_turbofish,
    STATE(3499), 1,
      sym_bracketed_type,
    STATE(1838), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4273), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2868), 4,
      sym_scoped_use_list,
      sym_use_list,
      sym_use_as_clause,
      sym_use_wildcard,
    ACTIONS(4267), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [54890] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4309), 1,
      anon_sym_SEMI,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1839), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [54976] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4311), 1,
      anon_sym_COMMA,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1840), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [55062] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4109), 1,
      anon_sym_LBRACK,
    ACTIONS(4115), 1,
      anon_sym_QMARK,
    ACTIONS(4117), 1,
      anon_sym_CARET,
    ACTIONS(4119), 1,
      anon_sym_AMP,
    ACTIONS(4121), 1,
      anon_sym_PIPE,
    ACTIONS(4131), 1,
      anon_sym_DOT,
    ACTIONS(4133), 1,
      anon_sym_as,
    ACTIONS(4139), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4293), 1,
      anon_sym_EQ,
    ACTIONS(4313), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4111), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4125), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4129), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4285), 2,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
    ACTIONS(4315), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1841), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4127), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4291), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [55146] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4317), 1,
      anon_sym_RBRACK,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1842), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [55232] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4319), 1,
      anon_sym_RBRACK,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1843), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [55318] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4321), 1,
      anon_sym_SEMI,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1844), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [55404] = 17,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4259), 1,
      sym_identifier,
    ACTIONS(4261), 1,
      anon_sym_LBRACE,
    ACTIONS(4265), 1,
      anon_sym_STAR,
    ACTIONS(4271), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4275), 1,
      sym_metavariable,
    ACTIONS(4323), 1,
      anon_sym_RBRACE,
    STATE(2411), 1,
      sym_scoped_identifier,
    STATE(3168), 1,
      sym__use_clause,
    STATE(3341), 1,
      sym_generic_type_with_turbofish,
    STATE(3499), 1,
      sym_bracketed_type,
    STATE(1845), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4273), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2868), 4,
      sym_scoped_use_list,
      sym_use_list,
      sym_use_as_clause,
      sym_use_wildcard,
    ACTIONS(4267), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [55480] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4325), 1,
      anon_sym_SEMI,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1846), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [55566] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4327), 1,
      anon_sym_SEMI,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1847), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [55652] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4329), 1,
      anon_sym_RBRACK,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1848), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [55738] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4331), 1,
      anon_sym_RBRACK,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1849), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [55824] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4333), 1,
      anon_sym_SEMI,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1850), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [55910] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4335), 1,
      anon_sym_SEMI,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1851), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [55996] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4135), 1,
      anon_sym_SEMI,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1852), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [56082] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4337), 1,
      anon_sym_SEMI,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1853), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [56168] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4109), 1,
      anon_sym_LBRACK,
    ACTIONS(4115), 1,
      anon_sym_QMARK,
    ACTIONS(4117), 1,
      anon_sym_CARET,
    ACTIONS(4119), 1,
      anon_sym_AMP,
    ACTIONS(4121), 1,
      anon_sym_PIPE,
    ACTIONS(4131), 1,
      anon_sym_DOT,
    ACTIONS(4133), 1,
      anon_sym_as,
    ACTIONS(4139), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4243), 1,
      anon_sym_EQ_GT,
    ACTIONS(4293), 1,
      anon_sym_EQ,
    ACTIONS(4313), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4339), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4111), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4125), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4129), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4315), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1854), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4127), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4291), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [56254] = 21,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4109), 1,
      anon_sym_LBRACK,
    ACTIONS(4115), 1,
      anon_sym_QMARK,
    ACTIONS(4117), 1,
      anon_sym_CARET,
    ACTIONS(4119), 1,
      anon_sym_AMP,
    ACTIONS(4121), 1,
      anon_sym_PIPE,
    ACTIONS(4131), 1,
      anon_sym_DOT,
    ACTIONS(4133), 1,
      anon_sym_as,
    ACTIONS(4139), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4293), 1,
      anon_sym_EQ,
    ACTIONS(4313), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4111), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4125), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4129), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(4295), 2,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
    ACTIONS(4315), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1855), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4127), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(4291), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [56338] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4341), 1,
      anon_sym_SEMI,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1856), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [56424] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4185), 1,
      anon_sym_COMMA,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1857), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [56510] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4343), 1,
      anon_sym_SEMI,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1858), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [56596] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4345), 1,
      anon_sym_RBRACK,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1859), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [56682] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4347), 1,
      anon_sym_RBRACK,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1860), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [56768] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4349), 1,
      anon_sym_RBRACK,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1861), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [56854] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4351), 1,
      anon_sym_RBRACK,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1862), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [56940] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4353), 1,
      anon_sym_SEMI,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1863), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [57026] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4355), 1,
      anon_sym_RBRACK,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1864), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [57112] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4357), 1,
      anon_sym_RBRACK,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1865), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [57198] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4359), 1,
      anon_sym_COMMA,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1866), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [57284] = 22,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3661), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    ACTIONS(3667), 1,
      anon_sym_DOT,
    ACTIONS(3669), 1,
      anon_sym_as,
    ACTIONS(3883), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_AMP,
    ACTIONS(3887), 1,
      anon_sym_PIPE,
    ACTIONS(3889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3899), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4361), 1,
      anon_sym_RBRACK,
    ACTIONS(3879), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3891), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3895), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3999), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1867), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3881), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3907), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [57370] = 16,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4259), 1,
      sym_identifier,
    ACTIONS(4261), 1,
      anon_sym_LBRACE,
    ACTIONS(4265), 1,
      anon_sym_STAR,
    ACTIONS(4271), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4275), 1,
      sym_metavariable,
    STATE(2411), 1,
      sym_scoped_identifier,
    STATE(3341), 1,
      sym_generic_type_with_turbofish,
    STATE(3499), 1,
      sym_bracketed_type,
    STATE(3532), 1,
      sym__use_clause,
    STATE(1868), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4273), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2868), 4,
      sym_scoped_use_list,
      sym_use_list,
      sym_use_as_clause,
      sym_use_wildcard,
    ACTIONS(4267), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [57443] = 16,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4259), 1,
      sym_identifier,
    ACTIONS(4261), 1,
      anon_sym_LBRACE,
    ACTIONS(4265), 1,
      anon_sym_STAR,
    ACTIONS(4271), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4275), 1,
      sym_metavariable,
    STATE(2411), 1,
      sym_scoped_identifier,
    STATE(3340), 1,
      sym__use_clause,
    STATE(3341), 1,
      sym_generic_type_with_turbofish,
    STATE(3499), 1,
      sym_bracketed_type,
    STATE(1869), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4273), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2868), 4,
      sym_scoped_use_list,
      sym_use_list,
      sym_use_as_clause,
      sym_use_wildcard,
    ACTIONS(4267), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [57516] = 16,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4259), 1,
      sym_identifier,
    ACTIONS(4261), 1,
      anon_sym_LBRACE,
    ACTIONS(4265), 1,
      anon_sym_STAR,
    ACTIONS(4271), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4275), 1,
      sym_metavariable,
    STATE(2411), 1,
      sym_scoped_identifier,
    STATE(3341), 1,
      sym_generic_type_with_turbofish,
    STATE(3348), 1,
      sym__use_clause,
    STATE(3499), 1,
      sym_bracketed_type,
    STATE(1870), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4273), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2868), 4,
      sym_scoped_use_list,
      sym_use_list,
      sym_use_as_clause,
      sym_use_wildcard,
    ACTIONS(4267), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [57589] = 16,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4259), 1,
      sym_identifier,
    ACTIONS(4261), 1,
      anon_sym_LBRACE,
    ACTIONS(4265), 1,
      anon_sym_STAR,
    ACTIONS(4271), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4275), 1,
      sym_metavariable,
    STATE(2411), 1,
      sym_scoped_identifier,
    STATE(3341), 1,
      sym_generic_type_with_turbofish,
    STATE(3499), 1,
      sym_bracketed_type,
    STATE(3584), 1,
      sym__use_clause,
    STATE(1871), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4273), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2868), 4,
      sym_scoped_use_list,
      sym_use_list,
      sym_use_as_clause,
      sym_use_wildcard,
    ACTIONS(4267), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [57662] = 16,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4259), 1,
      sym_identifier,
    ACTIONS(4261), 1,
      anon_sym_LBRACE,
    ACTIONS(4265), 1,
      anon_sym_STAR,
    ACTIONS(4271), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4275), 1,
      sym_metavariable,
    STATE(2411), 1,
      sym_scoped_identifier,
    STATE(3168), 1,
      sym__use_clause,
    STATE(3341), 1,
      sym_generic_type_with_turbofish,
    STATE(3499), 1,
      sym_bracketed_type,
    STATE(1872), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4273), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2868), 4,
      sym_scoped_use_list,
      sym_use_list,
      sym_use_as_clause,
      sym_use_wildcard,
    ACTIONS(4267), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [57735] = 17,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3721), 1,
      anon_sym_where,
    ACTIONS(4363), 1,
      sym_identifier,
    ACTIONS(4367), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4373), 1,
      sym_metavariable,
    STATE(2737), 1,
      sym_scoped_type_identifier,
    STATE(3045), 1,
      sym_generic_type,
    STATE(3353), 1,
      sym_scoped_identifier,
    STATE(3464), 1,
      sym_generic_type_with_turbofish,
    STATE(3491), 1,
      sym_bracketed_type,
    ACTIONS(4369), 2,
      anon_sym_default,
      anon_sym_union,
    STATE(1873), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3719), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
    ACTIONS(4371), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4365), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [57809] = 17,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3721), 1,
      anon_sym_where,
    ACTIONS(4367), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4373), 1,
      sym_metavariable,
    ACTIONS(4375), 1,
      sym_identifier,
    STATE(2849), 1,
      sym_scoped_type_identifier,
    STATE(3022), 1,
      sym_generic_type,
    STATE(3353), 1,
      sym_scoped_identifier,
    STATE(3464), 1,
      sym_generic_type_with_turbofish,
    STATE(3491), 1,
      sym_bracketed_type,
    ACTIONS(4369), 2,
      anon_sym_default,
      anon_sym_union,
    STATE(1874), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3719), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
    ACTIONS(4371), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4365), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [57883] = 17,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3721), 1,
      anon_sym_where,
    ACTIONS(4367), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4373), 1,
      sym_metavariable,
    ACTIONS(4377), 1,
      sym_identifier,
    STATE(2786), 1,
      sym_scoped_type_identifier,
    STATE(3133), 1,
      sym_generic_type,
    STATE(3353), 1,
      sym_scoped_identifier,
    STATE(3464), 1,
      sym_generic_type_with_turbofish,
    STATE(3491), 1,
      sym_bracketed_type,
    ACTIONS(4369), 2,
      anon_sym_default,
      anon_sym_union,
    STATE(1875), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3719), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
    ACTIONS(4371), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4365), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [57957] = 17,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3721), 1,
      anon_sym_where,
    ACTIONS(4367), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4373), 1,
      sym_metavariable,
    ACTIONS(4379), 1,
      sym_identifier,
    STATE(2740), 1,
      sym_scoped_type_identifier,
    STATE(3057), 1,
      sym_generic_type,
    STATE(3353), 1,
      sym_scoped_identifier,
    STATE(3464), 1,
      sym_generic_type_with_turbofish,
    STATE(3491), 1,
      sym_bracketed_type,
    ACTIONS(4369), 2,
      anon_sym_default,
      anon_sym_union,
    STATE(1876), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3719), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
    ACTIONS(4371), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4365), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [58031] = 17,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3721), 1,
      anon_sym_where,
    ACTIONS(4367), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4373), 1,
      sym_metavariable,
    ACTIONS(4381), 1,
      sym_identifier,
    STATE(2741), 1,
      sym_scoped_type_identifier,
    STATE(3059), 1,
      sym_generic_type,
    STATE(3353), 1,
      sym_scoped_identifier,
    STATE(3464), 1,
      sym_generic_type_with_turbofish,
    STATE(3491), 1,
      sym_bracketed_type,
    ACTIONS(4369), 2,
      anon_sym_default,
      anon_sym_union,
    STATE(1877), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3719), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
    ACTIONS(4371), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4365), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [58105] = 17,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3721), 1,
      anon_sym_where,
    ACTIONS(4367), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4373), 1,
      sym_metavariable,
    ACTIONS(4383), 1,
      sym_identifier,
    STATE(2749), 1,
      sym_scoped_type_identifier,
    STATE(3068), 1,
      sym_generic_type,
    STATE(3353), 1,
      sym_scoped_identifier,
    STATE(3464), 1,
      sym_generic_type_with_turbofish,
    STATE(3491), 1,
      sym_bracketed_type,
    ACTIONS(4369), 2,
      anon_sym_default,
      anon_sym_union,
    STATE(1878), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3719), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
    ACTIONS(4371), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4365), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [58179] = 17,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3721), 1,
      anon_sym_where,
    ACTIONS(4367), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4373), 1,
      sym_metavariable,
    ACTIONS(4385), 1,
      sym_identifier,
    STATE(2794), 1,
      sym_scoped_type_identifier,
    STATE(3144), 1,
      sym_generic_type,
    STATE(3353), 1,
      sym_scoped_identifier,
    STATE(3464), 1,
      sym_generic_type_with_turbofish,
    STATE(3491), 1,
      sym_bracketed_type,
    ACTIONS(4369), 2,
      anon_sym_default,
      anon_sym_union,
    STATE(1879), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3719), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
    ACTIONS(4371), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4365), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [58253] = 17,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3721), 1,
      anon_sym_where,
    ACTIONS(4367), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4373), 1,
      sym_metavariable,
    ACTIONS(4387), 1,
      sym_identifier,
    STATE(2952), 1,
      sym_scoped_type_identifier,
    STATE(3119), 1,
      sym_generic_type,
    STATE(3353), 1,
      sym_scoped_identifier,
    STATE(3464), 1,
      sym_generic_type_with_turbofish,
    STATE(3491), 1,
      sym_bracketed_type,
    ACTIONS(4369), 2,
      anon_sym_default,
      anon_sym_union,
    STATE(1880), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3719), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
    ACTIONS(4371), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4365), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [58327] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1881), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4391), 3,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(4389), 28,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [58373] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1882), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4395), 3,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(4393), 28,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [58419] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1883), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4399), 3,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(4397), 28,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [58465] = 13,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1856), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4401), 1,
      sym_identifier,
    ACTIONS(4407), 1,
      sym_metavariable,
    STATE(2248), 1,
      sym_scoped_identifier,
    STATE(3307), 1,
      sym_bracketed_type,
    STATE(3333), 1,
      sym_generic_type_with_turbofish,
    STATE(3413), 1,
      sym_attribute,
    STATE(1884), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4405), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4403), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [58526] = 13,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1856), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4401), 1,
      sym_identifier,
    ACTIONS(4407), 1,
      sym_metavariable,
    STATE(2248), 1,
      sym_scoped_identifier,
    STATE(3307), 1,
      sym_bracketed_type,
    STATE(3333), 1,
      sym_generic_type_with_turbofish,
    STATE(3380), 1,
      sym_attribute,
    STATE(1885), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4405), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4403), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [58587] = 13,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1856), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4401), 1,
      sym_identifier,
    ACTIONS(4407), 1,
      sym_metavariable,
    STATE(2248), 1,
      sym_scoped_identifier,
    STATE(3307), 1,
      sym_bracketed_type,
    STATE(3333), 1,
      sym_generic_type_with_turbofish,
    STATE(3459), 1,
      sym_attribute,
    STATE(1886), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4405), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4403), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [58648] = 13,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1856), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4401), 1,
      sym_identifier,
    ACTIONS(4407), 1,
      sym_metavariable,
    STATE(2248), 1,
      sym_scoped_identifier,
    STATE(3307), 1,
      sym_bracketed_type,
    STATE(3333), 1,
      sym_generic_type_with_turbofish,
    STATE(3440), 1,
      sym_attribute,
    STATE(1887), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4405), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4403), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [58709] = 13,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1856), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4401), 1,
      sym_identifier,
    ACTIONS(4407), 1,
      sym_metavariable,
    STATE(2248), 1,
      sym_scoped_identifier,
    STATE(3307), 1,
      sym_bracketed_type,
    STATE(3333), 1,
      sym_generic_type_with_turbofish,
    STATE(3487), 1,
      sym_attribute,
    STATE(1888), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4405), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4403), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [58770] = 13,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1856), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4401), 1,
      sym_identifier,
    ACTIONS(4407), 1,
      sym_metavariable,
    STATE(2248), 1,
      sym_scoped_identifier,
    STATE(3307), 1,
      sym_bracketed_type,
    STATE(3333), 1,
      sym_generic_type_with_turbofish,
    STATE(3386), 1,
      sym_attribute,
    STATE(1889), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4405), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4403), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [58831] = 13,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1856), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4401), 1,
      sym_identifier,
    ACTIONS(4407), 1,
      sym_metavariable,
    STATE(2248), 1,
      sym_scoped_identifier,
    STATE(3307), 1,
      sym_bracketed_type,
    STATE(3333), 1,
      sym_generic_type_with_turbofish,
    STATE(3450), 1,
      sym_attribute,
    STATE(1890), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4405), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4403), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [58892] = 13,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1856), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4401), 1,
      sym_identifier,
    ACTIONS(4407), 1,
      sym_metavariable,
    STATE(2248), 1,
      sym_scoped_identifier,
    STATE(3307), 1,
      sym_bracketed_type,
    STATE(3317), 1,
      sym_attribute,
    STATE(3333), 1,
      sym_generic_type_with_turbofish,
    STATE(1891), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4405), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4403), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [58953] = 12,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4409), 1,
      sym_identifier,
    ACTIONS(4413), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4417), 1,
      sym_metavariable,
    STATE(3200), 1,
      sym_scoped_identifier,
    STATE(3341), 1,
      sym_generic_type_with_turbofish,
    STATE(3499), 1,
      sym_bracketed_type,
    STATE(1892), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4415), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4411), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [59011] = 12,
    ACTIONS(29), 1,
      anon_sym_LT,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4413), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4419), 1,
      sym_identifier,
    ACTIONS(4425), 1,
      sym_metavariable,
    STATE(3196), 1,
      sym_scoped_identifier,
    STATE(3341), 1,
      sym_generic_type_with_turbofish,
    STATE(3499), 1,
      sym_bracketed_type,
    STATE(1893), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4423), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(4421), 19,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_default,
      anon_sym_union,
  [59069] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(793), 1,
      anon_sym_DOT_DOT,
    STATE(1894), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(795), 20,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_else,
      anon_sym_in,
  [59105] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(749), 1,
      anon_sym_DOT_DOT,
    STATE(1895), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(751), 20,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_else,
      anon_sym_in,
  [59141] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3229), 1,
      anon_sym_COLON,
    ACTIONS(4427), 1,
      anon_sym_LPAREN,
    ACTIONS(4429), 1,
      anon_sym_BANG,
    ACTIONS(4431), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    STATE(1922), 1,
      sym_type_arguments,
    STATE(1929), 1,
      sym_parameters,
    STATE(1896), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3225), 14,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [59189] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3265), 1,
      anon_sym_COLON,
    ACTIONS(3269), 2,
      anon_sym_BANG,
      anon_sym_COLON_COLON,
    STATE(1897), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3263), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_else,
      anon_sym_LT2,
  [59226] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3245), 1,
      anon_sym_COLON,
    ACTIONS(4427), 1,
      anon_sym_LPAREN,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(4435), 1,
      anon_sym_COLON_COLON,
    STATE(1922), 1,
      sym_type_arguments,
    STATE(1929), 1,
      sym_parameters,
    STATE(1898), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3243), 14,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [59271] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3249), 1,
      anon_sym_COLON,
    ACTIONS(4427), 1,
      anon_sym_LPAREN,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(4435), 1,
      anon_sym_COLON_COLON,
    STATE(1922), 1,
      sym_type_arguments,
    STATE(1929), 1,
      sym_parameters,
    STATE(1899), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3247), 14,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [59316] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3253), 1,
      anon_sym_COLON,
    ACTIONS(3257), 2,
      anon_sym_BANG,
      anon_sym_COLON_COLON,
    STATE(1900), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3251), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_else,
      anon_sym_LT2,
  [59353] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3277), 1,
      anon_sym_COLON,
    ACTIONS(3281), 2,
      anon_sym_BANG,
      anon_sym_COLON_COLON,
    STATE(1901), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3275), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_else,
      anon_sym_LT2,
  [59390] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3239), 1,
      anon_sym_COLON,
    ACTIONS(4427), 1,
      anon_sym_LPAREN,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(4435), 1,
      anon_sym_COLON_COLON,
    STATE(1922), 1,
      sym_type_arguments,
    STATE(1929), 1,
      sym_parameters,
    STATE(1902), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3237), 14,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [59435] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4429), 1,
      anon_sym_BANG,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(4439), 1,
      anon_sym_LPAREN,
    ACTIONS(4441), 1,
      anon_sym_LBRACE,
    ACTIONS(4443), 1,
      anon_sym_COLON,
    ACTIONS(4445), 1,
      anon_sym_AT,
    ACTIONS(4447), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4451), 1,
      anon_sym_COLON_COLON,
    STATE(1922), 1,
      sym_type_arguments,
    ACTIONS(4449), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1903), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4437), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [59488] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3285), 1,
      anon_sym_COLON,
    ACTIONS(3289), 2,
      anon_sym_BANG,
      anon_sym_COLON_COLON,
    STATE(1904), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3283), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_else,
      anon_sym_LT2,
  [59525] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4427), 1,
      anon_sym_LPAREN,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    STATE(1923), 1,
      sym_type_arguments,
    STATE(1942), 1,
      sym_parameters,
    STATE(1905), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3259), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [59565] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3279), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(1906), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3275), 3,
      anon_sym_LBRACE,
      anon_sym_for,
      anon_sym_LT2,
    ACTIONS(3281), 14,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_else,
      anon_sym_in,
  [59601] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4427), 1,
      anon_sym_LPAREN,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    STATE(1923), 1,
      sym_type_arguments,
    STATE(1942), 1,
      sym_parameters,
    STATE(1907), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3295), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [59641] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3287), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(1908), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3283), 3,
      anon_sym_LBRACE,
      anon_sym_for,
      anon_sym_LT2,
    ACTIONS(3289), 14,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_else,
      anon_sym_in,
  [59677] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3267), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(1909), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3263), 3,
      anon_sym_LBRACE,
      anon_sym_for,
      anon_sym_LT2,
    ACTIONS(3269), 14,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_else,
      anon_sym_in,
  [59713] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3255), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(1910), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3251), 3,
      anon_sym_LBRACE,
      anon_sym_for,
      anon_sym_LT2,
    ACTIONS(3257), 14,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_else,
      anon_sym_in,
  [59749] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4427), 1,
      anon_sym_LPAREN,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    STATE(1923), 1,
      sym_type_arguments,
    STATE(1942), 1,
      sym_parameters,
    STATE(1911), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3271), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [59789] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4427), 1,
      anon_sym_LPAREN,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    STATE(1923), 1,
      sym_type_arguments,
    STATE(1942), 1,
      sym_parameters,
    STATE(1912), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [59829] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3347), 1,
      anon_sym_COLON,
    STATE(1913), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3345), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_else,
  [59862] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1914), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3251), 18,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_else,
      anon_sym_LT2,
  [59893] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3267), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(1915), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3269), 16,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_else,
      anon_sym_in,
  [59926] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3445), 1,
      anon_sym_COLON,
    STATE(1916), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3443), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_else,
  [59959] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3255), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(1917), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3257), 16,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_else,
      anon_sym_in,
  [59992] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3279), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(1918), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3281), 16,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_else,
      anon_sym_in,
  [60025] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3369), 1,
      anon_sym_COLON,
    STATE(1919), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3367), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_else,
  [60058] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3287), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(1920), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3289), 16,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_else,
      anon_sym_in,
  [60091] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3407), 1,
      anon_sym_COLON,
    STATE(1921), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3405), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_else,
  [60124] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3497), 1,
      anon_sym_COLON,
    STATE(1922), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3495), 16,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_else,
  [60156] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3485), 1,
      anon_sym_COLON,
    STATE(1923), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3483), 16,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_else,
  [60188] = 12,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(4455), 1,
      anon_sym_COLON,
    ACTIONS(4457), 1,
      anon_sym_BANG,
    ACTIONS(4459), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4463), 1,
      anon_sym_COLON_COLON,
    STATE(1925), 1,
      sym_type_arguments,
    ACTIONS(4461), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1924), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4453), 3,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_COMMA,
    ACTIONS(3311), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [60234] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3525), 1,
      anon_sym_COLON,
    STATE(1925), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3523), 16,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_else,
  [60266] = 19,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4467), 1,
      anon_sym_const,
    ACTIONS(4469), 1,
      anon_sym_enum,
    ACTIONS(4471), 1,
      anon_sym_fn,
    ACTIONS(4473), 1,
      anon_sym_mod,
    ACTIONS(4475), 1,
      anon_sym_static,
    ACTIONS(4477), 1,
      anon_sym_struct,
    ACTIONS(4479), 1,
      anon_sym_trait,
    ACTIONS(4481), 1,
      anon_sym_type,
    ACTIONS(4483), 1,
      anon_sym_union,
    ACTIONS(4485), 1,
      anon_sym_unsafe,
    ACTIONS(4487), 1,
      anon_sym_use,
    ACTIONS(4489), 1,
      anon_sym_extern,
    STATE(2159), 1,
      sym_extern_modifier,
    STATE(2197), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(3316), 1,
      sym_function_modifiers,
    ACTIONS(4465), 2,
      anon_sym_async,
      anon_sym_default,
    STATE(1926), 2,
      sym_line_comment,
      sym_block_comment,
  [60326] = 19,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4491), 1,
      anon_sym_const,
    ACTIONS(4493), 1,
      anon_sym_enum,
    ACTIONS(4495), 1,
      anon_sym_fn,
    ACTIONS(4497), 1,
      anon_sym_mod,
    ACTIONS(4499), 1,
      anon_sym_static,
    ACTIONS(4501), 1,
      anon_sym_struct,
    ACTIONS(4503), 1,
      anon_sym_trait,
    ACTIONS(4505), 1,
      anon_sym_type,
    ACTIONS(4507), 1,
      anon_sym_union,
    ACTIONS(4509), 1,
      anon_sym_unsafe,
    ACTIONS(4511), 1,
      anon_sym_use,
    ACTIONS(4513), 1,
      anon_sym_extern,
    STATE(2140), 1,
      sym_extern_modifier,
    STATE(2197), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(3590), 1,
      sym_function_modifiers,
    ACTIONS(4465), 2,
      anon_sym_async,
      anon_sym_default,
    STATE(1927), 2,
      sym_line_comment,
      sym_block_comment,
  [60386] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(4455), 1,
      anon_sym_COLON,
    ACTIONS(4457), 1,
      anon_sym_BANG,
    ACTIONS(4459), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4515), 1,
      anon_sym_COLON_COLON,
    STATE(1925), 1,
      sym_type_arguments,
    ACTIONS(4461), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1928), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4453), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [60430] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4517), 1,
      anon_sym_DASH_GT,
    STATE(1929), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3447), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [60461] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3293), 1,
      anon_sym_COLON,
    ACTIONS(4519), 1,
      anon_sym_COLON_COLON,
    STATE(1930), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 14,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [60494] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1931), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1394), 16,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
      anon_sym_in,
  [60523] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1932), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1352), 16,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
      anon_sym_in,
  [60552] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1933), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3501), 16,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [60581] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4429), 1,
      anon_sym_BANG,
    ACTIONS(4439), 1,
      anon_sym_LPAREN,
    ACTIONS(4443), 1,
      anon_sym_COLON,
    ACTIONS(4447), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4521), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4449), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1934), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4437), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [60622] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4523), 1,
      anon_sym_DASH_GT,
    STATE(1935), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3413), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [60653] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1936), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(997), 16,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
      anon_sym_in,
  [60682] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3273), 1,
      anon_sym_COLON,
    ACTIONS(4525), 1,
      anon_sym_COLON_COLON,
    STATE(1937), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3271), 14,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [60715] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3293), 1,
      anon_sym_COLON,
    ACTIONS(4525), 1,
      anon_sym_COLON_COLON,
    STATE(1938), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 14,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [60748] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3297), 1,
      anon_sym_COLON,
    ACTIONS(4525), 1,
      anon_sym_COLON_COLON,
    STATE(1939), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3295), 14,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [60781] = 16,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4429), 1,
      anon_sym_BANG,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(4437), 1,
      anon_sym_PIPE,
    ACTIONS(4441), 1,
      anon_sym_LBRACE,
    ACTIONS(4443), 1,
      anon_sym_COLON,
    ACTIONS(4445), 1,
      anon_sym_AT,
    ACTIONS(4447), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4527), 1,
      anon_sym_LPAREN,
    ACTIONS(4529), 1,
      anon_sym_COLON_COLON,
    STATE(1922), 1,
      sym_type_arguments,
    STATE(1929), 1,
      sym_parameters,
    ACTIONS(4449), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1940), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3225), 3,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COMMA,
  [60834] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1941), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3349), 16,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [60863] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4531), 1,
      anon_sym_DASH_GT,
    STATE(1942), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3507), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [60894] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1943), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3323), 16,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [60923] = 16,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4429), 1,
      anon_sym_BANG,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(4441), 1,
      anon_sym_LBRACE,
    ACTIONS(4445), 1,
      anon_sym_AT,
    ACTIONS(4447), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4533), 1,
      anon_sym_LPAREN,
    ACTIONS(4535), 1,
      anon_sym_RBRACK,
    ACTIONS(4538), 1,
      anon_sym_COLON_COLON,
    STATE(1922), 1,
      sym_type_arguments,
    STATE(1929), 1,
      sym_parameters,
    ACTIONS(3225), 2,
      anon_sym_SEMI,
      anon_sym_PLUS,
    ACTIONS(4437), 2,
      anon_sym_PIPE,
      anon_sym_COMMA,
    ACTIONS(4449), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1944), 2,
      sym_line_comment,
      sym_block_comment,
  [60976] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4540), 1,
      anon_sym_LPAREN,
    STATE(1945), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3971), 15,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
  [61007] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1946), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1001), 16,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
      anon_sym_in,
  [61036] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1947), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3419), 16,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61065] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3261), 1,
      anon_sym_COLON,
    ACTIONS(4525), 1,
      anon_sym_COLON_COLON,
    STATE(1948), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3259), 14,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61098] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3293), 1,
      anon_sym_COLON,
    ACTIONS(4542), 1,
      anon_sym_COLON_COLON,
    STATE(1949), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 14,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61131] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1950), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3409), 16,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61160] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(4457), 1,
      anon_sym_BANG,
    ACTIONS(4459), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4544), 1,
      anon_sym_COLON_COLON,
    STATE(1925), 1,
      sym_type_arguments,
    ACTIONS(4461), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1951), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4453), 3,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_COMMA,
    ACTIONS(3311), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [61203] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4546), 1,
      anon_sym_DASH_GT,
    STATE(1952), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3371), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61234] = 17,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3225), 1,
      anon_sym_PLUS,
    ACTIONS(4429), 1,
      anon_sym_BANG,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(4437), 1,
      anon_sym_PIPE,
    ACTIONS(4441), 1,
      anon_sym_LBRACE,
    ACTIONS(4443), 1,
      anon_sym_COLON,
    ACTIONS(4445), 1,
      anon_sym_AT,
    ACTIONS(4447), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4548), 1,
      anon_sym_LPAREN,
    ACTIONS(4550), 1,
      anon_sym_COLON_COLON,
    STATE(1922), 1,
      sym_type_arguments,
    STATE(1929), 1,
      sym_parameters,
    ACTIONS(4449), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4535), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(1953), 2,
      sym_line_comment,
      sym_block_comment,
  [61289] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4552), 1,
      anon_sym_DASH_GT,
    STATE(1954), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3477), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61320] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4554), 1,
      anon_sym_DASH_GT,
    STATE(1955), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3487), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61351] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4556), 1,
      anon_sym_DASH_GT,
    STATE(1956), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3471), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61382] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1957), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3729), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61410] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1958), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3707), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61438] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1959), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3545), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61466] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1960), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3715), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61494] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1961), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3799), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61522] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3869), 1,
      anon_sym_COLON_COLON,
    STATE(1962), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3976), 14,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
  [61552] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1963), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3803), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61580] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1964), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3978), 15,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
  [61608] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1965), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3967), 15,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
  [61636] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4558), 1,
      anon_sym_COLON_COLON,
    STATE(1966), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3976), 14,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
  [61666] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1967), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3961), 15,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
  [61694] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1968), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61722] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1969), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3819), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61750] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1970), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3725), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61778] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1971), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3811), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61806] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1972), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3827), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61834] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1973), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3791), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61862] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1974), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3787), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61890] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1975), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3719), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61918] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1976), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3815), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61946] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1977), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3259), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [61974] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1978), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3271), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62002] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1979), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3835), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62030] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1980), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3729), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62058] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1981), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3695), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62086] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1982), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3537), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62114] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1983), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3295), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62142] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1984), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3559), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62170] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1985), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3711), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62198] = 12,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(4453), 1,
      anon_sym_PIPE,
    ACTIONS(4455), 1,
      anon_sym_COLON,
    ACTIONS(4457), 1,
      anon_sym_BANG,
    ACTIONS(4459), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4560), 1,
      anon_sym_COLON_COLON,
    STATE(1925), 1,
      sym_type_arguments,
    ACTIONS(4461), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1986), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3311), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [62242] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1987), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3703), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62270] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(1988), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3823), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_as,
      anon_sym_where,
      anon_sym_else,
  [62298] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(813), 1,
      anon_sym_DOT_DOT,
    STATE(1989), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(815), 13,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [62327] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4564), 1,
      anon_sym_pat,
    STATE(151), 1,
      sym_fragment_specifier,
    STATE(1990), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4562), 12,
      anon_sym_block,
      anon_sym_expr,
      anon_sym_ident,
      anon_sym_item,
      anon_sym_lifetime,
      anon_sym_literal,
      anon_sym_meta,
      anon_sym_path,
      anon_sym_stmt,
      anon_sym_tt,
      anon_sym_ty,
      anon_sym_vis,
  [62358] = 16,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4427), 1,
      anon_sym_LPAREN,
    ACTIONS(4429), 1,
      anon_sym_BANG,
    ACTIONS(4431), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(4566), 1,
      anon_sym_COLON,
    ACTIONS(4568), 1,
      anon_sym_EQ,
    ACTIONS(4570), 1,
      anon_sym_GT,
    ACTIONS(4572), 1,
      anon_sym_COMMA,
    STATE(1922), 1,
      sym_type_arguments,
    STATE(1929), 1,
      sym_parameters,
    STATE(2865), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2867), 1,
      sym_trait_bounds,
    ACTIONS(3225), 2,
      anon_sym_PLUS,
      anon_sym_as,
    STATE(1991), 2,
      sym_line_comment,
      sym_block_comment,
  [62409] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(785), 1,
      anon_sym_DOT_DOT,
    STATE(1992), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(787), 13,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [62438] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4455), 1,
      anon_sym_COLON,
    ACTIONS(4459), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4515), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4461), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1993), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4453), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [62473] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4574), 1,
      anon_sym_LPAREN,
    ACTIONS(3279), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(1994), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3275), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_LT2,
    ACTIONS(3281), 5,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
  [62505] = 13,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(4577), 1,
      anon_sym_LPAREN,
    ACTIONS(4579), 1,
      anon_sym_LBRACE,
    ACTIONS(4581), 1,
      anon_sym_BANG,
    ACTIONS(4583), 1,
      anon_sym_AT,
    ACTIONS(4585), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4589), 1,
      anon_sym_COLON_COLON,
    STATE(1922), 1,
      sym_type_arguments,
    ACTIONS(4587), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(1995), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4437), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [62549] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4591), 1,
      anon_sym_LPAREN,
    ACTIONS(3255), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(1996), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3251), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_LT2,
    ACTIONS(3257), 5,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
  [62581] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3287), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(1997), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3283), 3,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_LT2,
    ACTIONS(4594), 3,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3289), 5,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
  [62613] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4597), 1,
      anon_sym_LPAREN,
    ACTIONS(3267), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(1998), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3263), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_LT2,
    ACTIONS(3269), 5,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
  [62645] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3287), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4594), 2,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
    STATE(1999), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3283), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_LT2,
    ACTIONS(3289), 6,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [62677] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3267), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(2000), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3263), 3,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_LT2,
    ACTIONS(4597), 3,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3269), 5,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
  [62709] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4447), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4449), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2001), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4437), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [62739] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4594), 1,
      anon_sym_LPAREN,
    ACTIONS(3287), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(2002), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3283), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_LT2,
    ACTIONS(3289), 5,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
  [62771] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3255), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(2003), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3251), 3,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_LT2,
    ACTIONS(4591), 3,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3257), 5,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
  [62803] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3279), 2,
      anon_sym_COLON,
      anon_sym_DOT_DOT,
    STATE(2004), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3275), 3,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_LT2,
    ACTIONS(4574), 3,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3281), 5,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
  [62835] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4602), 1,
      anon_sym_DOT_DOT,
    STATE(2005), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4600), 12,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [62863] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4606), 1,
      anon_sym_DOT_DOT,
    STATE(2006), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4604), 12,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [62891] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3255), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4591), 2,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
    STATE(2007), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3251), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_LT2,
    ACTIONS(3257), 6,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [62923] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3267), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4597), 2,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
    STATE(2008), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3263), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_LT2,
    ACTIONS(3269), 6,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [62955] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3279), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4574), 2,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
    STATE(2009), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3275), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_LT2,
    ACTIONS(3281), 6,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [62987] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(2953), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      sym_identifier,
    ACTIONS(4610), 1,
      anon_sym_GT,
    ACTIONS(4612), 1,
      anon_sym_const,
    ACTIONS(4614), 1,
      sym_metavariable,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(2067), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2712), 1,
      sym_lifetime,
    STATE(2784), 1,
      sym_constrained_type_parameter,
    STATE(2010), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3118), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [63032] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(2953), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      sym_identifier,
    ACTIONS(4612), 1,
      anon_sym_const,
    ACTIONS(4614), 1,
      sym_metavariable,
    ACTIONS(4616), 1,
      anon_sym_GT,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(2067), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2712), 1,
      sym_lifetime,
    STATE(2784), 1,
      sym_constrained_type_parameter,
    STATE(2011), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3118), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [63077] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(2953), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      sym_identifier,
    ACTIONS(4612), 1,
      anon_sym_const,
    ACTIONS(4614), 1,
      sym_metavariable,
    ACTIONS(4618), 1,
      anon_sym_GT,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(2067), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2712), 1,
      sym_lifetime,
    STATE(2784), 1,
      sym_constrained_type_parameter,
    STATE(2012), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3118), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [63122] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(2953), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      sym_identifier,
    ACTIONS(4612), 1,
      anon_sym_const,
    ACTIONS(4614), 1,
      sym_metavariable,
    ACTIONS(4620), 1,
      anon_sym_GT,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(2067), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2712), 1,
      sym_lifetime,
    STATE(2784), 1,
      sym_constrained_type_parameter,
    STATE(2013), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3118), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [63167] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(2953), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      sym_identifier,
    ACTIONS(4612), 1,
      anon_sym_const,
    ACTIONS(4614), 1,
      sym_metavariable,
    ACTIONS(4622), 1,
      anon_sym_GT,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(2067), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2712), 1,
      sym_lifetime,
    STATE(2784), 1,
      sym_constrained_type_parameter,
    STATE(2014), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3118), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [63212] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(2953), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      sym_identifier,
    ACTIONS(4612), 1,
      anon_sym_const,
    ACTIONS(4614), 1,
      sym_metavariable,
    ACTIONS(4624), 1,
      anon_sym_GT,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(2067), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2712), 1,
      sym_lifetime,
    STATE(2784), 1,
      sym_constrained_type_parameter,
    STATE(2015), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3118), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [63257] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(2953), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      sym_identifier,
    ACTIONS(4612), 1,
      anon_sym_const,
    ACTIONS(4614), 1,
      sym_metavariable,
    ACTIONS(4626), 1,
      anon_sym_GT,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(2067), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2712), 1,
      sym_lifetime,
    STATE(2784), 1,
      sym_constrained_type_parameter,
    STATE(2016), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3118), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [63302] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(2953), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      sym_identifier,
    ACTIONS(4612), 1,
      anon_sym_const,
    ACTIONS(4614), 1,
      sym_metavariable,
    ACTIONS(4628), 1,
      anon_sym_GT,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(2067), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2712), 1,
      sym_lifetime,
    STATE(2784), 1,
      sym_constrained_type_parameter,
    STATE(2017), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3118), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [63347] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(2953), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      sym_identifier,
    ACTIONS(4612), 1,
      anon_sym_const,
    ACTIONS(4614), 1,
      sym_metavariable,
    ACTIONS(4630), 1,
      anon_sym_GT,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(2067), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2712), 1,
      sym_lifetime,
    STATE(2784), 1,
      sym_constrained_type_parameter,
    STATE(2018), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3118), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [63392] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(2953), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      sym_identifier,
    ACTIONS(4612), 1,
      anon_sym_const,
    ACTIONS(4614), 1,
      sym_metavariable,
    ACTIONS(4632), 1,
      anon_sym_GT,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(2067), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2712), 1,
      sym_lifetime,
    STATE(2784), 1,
      sym_constrained_type_parameter,
    STATE(2019), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3118), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [63437] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(2953), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      sym_identifier,
    ACTIONS(4612), 1,
      anon_sym_const,
    ACTIONS(4614), 1,
      sym_metavariable,
    ACTIONS(4634), 1,
      anon_sym_GT,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(2067), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2712), 1,
      sym_lifetime,
    STATE(2784), 1,
      sym_constrained_type_parameter,
    STATE(2020), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3118), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [63482] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(2953), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      sym_identifier,
    ACTIONS(4612), 1,
      anon_sym_const,
    ACTIONS(4614), 1,
      sym_metavariable,
    ACTIONS(4636), 1,
      anon_sym_GT,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(2067), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2633), 1,
      sym_lifetime,
    STATE(2784), 1,
      sym_constrained_type_parameter,
    STATE(2021), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3118), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [63527] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(2953), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      sym_identifier,
    ACTIONS(4612), 1,
      anon_sym_const,
    ACTIONS(4614), 1,
      sym_metavariable,
    ACTIONS(4638), 1,
      anon_sym_GT,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(2067), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2712), 1,
      sym_lifetime,
    STATE(2784), 1,
      sym_constrained_type_parameter,
    STATE(2022), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3118), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [63572] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(2953), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      sym_identifier,
    ACTIONS(4612), 1,
      anon_sym_const,
    ACTIONS(4614), 1,
      sym_metavariable,
    ACTIONS(4640), 1,
      anon_sym_GT,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(2067), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2712), 1,
      sym_lifetime,
    STATE(2784), 1,
      sym_constrained_type_parameter,
    STATE(2023), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3118), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [63617] = 14,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(2953), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      sym_identifier,
    ACTIONS(4612), 1,
      anon_sym_const,
    ACTIONS(4614), 1,
      sym_metavariable,
    ACTIONS(4642), 1,
      anon_sym_GT,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(2067), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2712), 1,
      sym_lifetime,
    STATE(2784), 1,
      sym_constrained_type_parameter,
    STATE(2024), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3118), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [63662] = 10,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4479), 1,
      anon_sym_trait,
    ACTIONS(4644), 1,
      anon_sym_impl,
    STATE(398), 1,
      sym_block,
    STATE(3398), 1,
      sym_label,
    STATE(2025), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3311), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [63699] = 13,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(2953), 1,
      anon_sym_SQUOTE,
    ACTIONS(4612), 1,
      anon_sym_const,
    ACTIONS(4646), 1,
      sym_identifier,
    ACTIONS(4648), 1,
      sym_metavariable,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(2047), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2451), 1,
      sym_lifetime,
    STATE(2625), 1,
      sym_constrained_type_parameter,
    STATE(2026), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2960), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [63741] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4652), 1,
      anon_sym_COLON,
    ACTIONS(4654), 1,
      anon_sym_COLON_COLON,
    STATE(2027), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4650), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [63769] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4427), 1,
      anon_sym_LPAREN,
    ACTIONS(4429), 1,
      anon_sym_BANG,
    ACTIONS(4431), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(4656), 1,
      anon_sym_for,
    STATE(1922), 1,
      sym_type_arguments,
    STATE(1929), 1,
      sym_parameters,
    STATE(2028), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3225), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [63807] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2029), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1228), 11,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [63831] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4427), 1,
      anon_sym_LPAREN,
    ACTIONS(4429), 1,
      anon_sym_BANG,
    ACTIONS(4431), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(4658), 1,
      anon_sym_for,
    STATE(1922), 1,
      sym_type_arguments,
    STATE(1929), 1,
      sym_parameters,
    STATE(2030), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3225), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [63869] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4427), 1,
      anon_sym_LPAREN,
    ACTIONS(4429), 1,
      anon_sym_BANG,
    ACTIONS(4431), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(4660), 1,
      anon_sym_for,
    STATE(1922), 1,
      sym_type_arguments,
    STATE(1929), 1,
      sym_parameters,
    STATE(2031), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3225), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [63907] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4427), 1,
      anon_sym_LPAREN,
    ACTIONS(4429), 1,
      anon_sym_BANG,
    ACTIONS(4431), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(4662), 1,
      anon_sym_for,
    STATE(1922), 1,
      sym_type_arguments,
    STATE(1929), 1,
      sym_parameters,
    STATE(2032), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3225), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [63945] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2033), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1240), 11,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [63969] = 12,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(4664), 1,
      sym_identifier,
    ACTIONS(4666), 1,
      anon_sym_RBRACE,
    ACTIONS(4668), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4670), 1,
      anon_sym_COMMA,
    ACTIONS(4672), 1,
      sym_integer_literal,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(2450), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2034), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2731), 3,
      sym_shorthand_field_initializer,
      sym_field_initializer,
      sym_base_field_initializer,
  [64009] = 9,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4674), 1,
      sym_identifier,
    STATE(393), 1,
      sym_block,
    STATE(3398), 1,
      sym_label,
    STATE(2035), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4676), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [64043] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1324), 1,
      aux_sym_string_literal_token1,
    ACTIONS(4680), 1,
      sym_crate,
    STATE(2215), 1,
      sym_string_literal,
    STATE(2036), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4678), 8,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [64073] = 9,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4682), 1,
      anon_sym_move,
    STATE(391), 1,
      sym_block,
    STATE(3398), 1,
      sym_label,
    STATE(2037), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3311), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [64107] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2038), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1236), 11,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [64131] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3267), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3263), 2,
      anon_sym_LBRACE,
      anon_sym_LT2,
    STATE(2039), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3269), 8,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_if,
  [64159] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3255), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3251), 2,
      anon_sym_LBRACE,
      anon_sym_LT2,
    STATE(2040), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3257), 8,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_if,
  [64187] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1324), 1,
      aux_sym_string_literal_token1,
    ACTIONS(4684), 1,
      sym_crate,
    STATE(2215), 1,
      sym_string_literal,
    STATE(2041), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4678), 8,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [64217] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4688), 1,
      anon_sym_COLON,
    ACTIONS(4690), 1,
      anon_sym_COLON_COLON,
    STATE(2042), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4686), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [64245] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2043), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1244), 11,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [64269] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4652), 1,
      anon_sym_COLON,
    ACTIONS(4692), 1,
      anon_sym_COLON_COLON,
    STATE(2044), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4650), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [64297] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4558), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4652), 1,
      anon_sym_COLON,
    STATE(2045), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4650), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [64325] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3279), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3275), 2,
      anon_sym_LBRACE,
      anon_sym_LT2,
    STATE(2046), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3281), 8,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_if,
  [64353] = 13,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(2953), 1,
      anon_sym_SQUOTE,
    ACTIONS(4612), 1,
      anon_sym_const,
    ACTIONS(4694), 1,
      sym_identifier,
    ACTIONS(4696), 1,
      sym_metavariable,
    STATE(1041), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(2480), 1,
      sym_lifetime,
    STATE(2553), 1,
      sym_constrained_type_parameter,
    STATE(2047), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2862), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [64395] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3287), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3283), 2,
      anon_sym_LBRACE,
      anon_sym_LT2,
    STATE(2048), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3289), 8,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_if,
  [64423] = 13,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(2953), 1,
      anon_sym_SQUOTE,
    ACTIONS(4608), 1,
      sym_identifier,
    ACTIONS(4612), 1,
      anon_sym_const,
    ACTIONS(4614), 1,
      sym_metavariable,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(2067), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2712), 1,
      sym_lifetime,
    STATE(2784), 1,
      sym_constrained_type_parameter,
    STATE(2049), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3118), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [64465] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4427), 1,
      anon_sym_LPAREN,
    ACTIONS(4429), 1,
      anon_sym_BANG,
    ACTIONS(4431), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(4698), 1,
      anon_sym_for,
    STATE(1922), 1,
      sym_type_arguments,
    STATE(1929), 1,
      sym_parameters,
    STATE(2050), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3225), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [64503] = 13,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(2953), 1,
      anon_sym_SQUOTE,
    ACTIONS(4612), 1,
      anon_sym_const,
    ACTIONS(4646), 1,
      sym_identifier,
    ACTIONS(4648), 1,
      sym_metavariable,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(2047), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2359), 1,
      sym_lifetime,
    STATE(2625), 1,
      sym_constrained_type_parameter,
    STATE(2051), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2960), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [64545] = 12,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3229), 1,
      anon_sym_COLON,
    ACTIONS(4427), 1,
      anon_sym_LPAREN,
    ACTIONS(4429), 1,
      anon_sym_BANG,
    ACTIONS(4431), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(4700), 1,
      anon_sym_EQ,
    STATE(1929), 1,
      sym_parameters,
    STATE(2315), 1,
      sym_type_arguments,
    STATE(2052), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3225), 3,
      anon_sym_PLUS,
      anon_sym_GT,
      anon_sym_COMMA,
  [64585] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2053), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1232), 11,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [64609] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4690), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4704), 1,
      anon_sym_COLON,
    STATE(2054), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4702), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [64637] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4427), 1,
      anon_sym_LPAREN,
    ACTIONS(4429), 1,
      anon_sym_BANG,
    ACTIONS(4431), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(4706), 1,
      anon_sym_for,
    STATE(1922), 1,
      sym_type_arguments,
    STATE(1929), 1,
      sym_parameters,
    STATE(2055), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3225), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [64675] = 12,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(4664), 1,
      sym_identifier,
    ACTIONS(4668), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4672), 1,
      sym_integer_literal,
    ACTIONS(4708), 1,
      anon_sym_RBRACE,
    ACTIONS(4710), 1,
      anon_sym_COMMA,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(2450), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2056), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2949), 3,
      sym_shorthand_field_initializer,
      sym_field_initializer,
      sym_base_field_initializer,
  [64715] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1324), 1,
      aux_sym_string_literal_token1,
    ACTIONS(4712), 1,
      sym_crate,
    STATE(2215), 1,
      sym_string_literal,
    STATE(2057), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4678), 8,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [64745] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4692), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4716), 1,
      anon_sym_COLON,
    STATE(2058), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4714), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [64773] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4558), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4716), 1,
      anon_sym_COLON,
    STATE(2059), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4714), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [64801] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4654), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4716), 1,
      anon_sym_COLON,
    STATE(2060), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4714), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [64829] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4427), 1,
      anon_sym_LPAREN,
    ACTIONS(4429), 1,
      anon_sym_BANG,
    ACTIONS(4431), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(4718), 1,
      anon_sym_for,
    STATE(1922), 1,
      sym_type_arguments,
    STATE(1929), 1,
      sym_parameters,
    STATE(2061), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3225), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [64867] = 13,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(2953), 1,
      anon_sym_SQUOTE,
    ACTIONS(4612), 1,
      anon_sym_const,
    ACTIONS(4720), 1,
      sym_identifier,
    ACTIONS(4722), 1,
      sym_metavariable,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(2066), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2420), 1,
      sym_lifetime,
    STATE(2706), 1,
      sym_constrained_type_parameter,
    STATE(2062), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2800), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [64909] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(4455), 1,
      anon_sym_COLON,
    ACTIONS(4457), 1,
      anon_sym_BANG,
    ACTIONS(4459), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4463), 1,
      anon_sym_COLON_COLON,
    STATE(1925), 1,
      sym_type_arguments,
    ACTIONS(4461), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2063), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4453), 3,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_COMMA,
  [64947] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1324), 1,
      aux_sym_string_literal_token1,
    ACTIONS(4724), 1,
      sym_crate,
    STATE(2215), 1,
      sym_string_literal,
    STATE(2064), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4678), 8,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [64977] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4427), 1,
      anon_sym_LPAREN,
    ACTIONS(4429), 1,
      anon_sym_BANG,
    ACTIONS(4431), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(4726), 1,
      anon_sym_for,
    STATE(1922), 1,
      sym_type_arguments,
    STATE(1929), 1,
      sym_parameters,
    STATE(2065), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3225), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [65015] = 13,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(2953), 1,
      anon_sym_SQUOTE,
    ACTIONS(4612), 1,
      anon_sym_const,
    ACTIONS(4728), 1,
      sym_identifier,
    ACTIONS(4730), 1,
      sym_metavariable,
    STATE(1041), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(2423), 1,
      sym_lifetime,
    STATE(2701), 1,
      sym_constrained_type_parameter,
    STATE(2066), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2805), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [65057] = 13,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(2953), 1,
      anon_sym_SQUOTE,
    ACTIONS(4612), 1,
      anon_sym_const,
    ACTIONS(4732), 1,
      sym_identifier,
    ACTIONS(4734), 1,
      sym_metavariable,
    STATE(1041), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(2666), 1,
      sym_lifetime,
    STATE(2984), 1,
      sym_constrained_type_parameter,
    STATE(2067), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3046), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [65099] = 13,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(4736), 1,
      sym_identifier,
    ACTIONS(4738), 1,
      anon_sym_RBRACE,
    ACTIONS(4740), 1,
      anon_sym_COMMA,
    ACTIONS(4742), 1,
      sym_crate,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(2174), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2792), 1,
      sym_enum_variant,
    STATE(3375), 1,
      sym_visibility_modifier,
    STATE(2068), 2,
      sym_line_comment,
      sym_block_comment,
  [65140] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1564), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    STATE(2076), 1,
      sym_block,
    STATE(3572), 1,
      sym_label,
    STATE(2069), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3311), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [65171] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2070), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4744), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65194] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2071), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4746), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65217] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2072), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4748), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65240] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2073), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4750), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65263] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2074), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4752), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65286] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(4664), 1,
      sym_identifier,
    ACTIONS(4668), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4672), 1,
      sym_integer_literal,
    ACTIONS(4754), 1,
      anon_sym_RBRACE,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(2450), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2075), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3204), 3,
      sym_shorthand_field_initializer,
      sym_field_initializer,
      sym_base_field_initializer,
  [65323] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2076), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1424), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65346] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(4664), 1,
      sym_identifier,
    ACTIONS(4668), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4672), 1,
      sym_integer_literal,
    ACTIONS(4756), 1,
      anon_sym_RBRACE,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(2450), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2077), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3204), 3,
      sym_shorthand_field_initializer,
      sym_field_initializer,
      sym_base_field_initializer,
  [65383] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2078), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4758), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65406] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3931), 1,
      anon_sym_LT2,
    ACTIONS(4073), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4760), 1,
      anon_sym_BANG,
    STATE(1616), 1,
      sym_type_arguments,
    STATE(2079), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3311), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [65437] = 13,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(4742), 1,
      sym_crate,
    ACTIONS(4762), 1,
      sym_identifier,
    ACTIONS(4764), 1,
      anon_sym_RBRACE,
    ACTIONS(4766), 1,
      anon_sym_COMMA,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(2182), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2812), 1,
      sym_field_declaration,
    STATE(3409), 1,
      sym_visibility_modifier,
    STATE(2080), 2,
      sym_line_comment,
      sym_block_comment,
  [65478] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(4664), 1,
      sym_identifier,
    ACTIONS(4668), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4672), 1,
      sym_integer_literal,
    ACTIONS(4768), 1,
      anon_sym_RBRACE,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(2450), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2081), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3204), 3,
      sym_shorthand_field_initializer,
      sym_field_initializer,
      sym_base_field_initializer,
  [65515] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(4664), 1,
      sym_identifier,
    ACTIONS(4668), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4672), 1,
      sym_integer_literal,
    ACTIONS(4770), 1,
      anon_sym_RBRACE,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(2450), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2082), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3204), 3,
      sym_shorthand_field_initializer,
      sym_field_initializer,
      sym_base_field_initializer,
  [65552] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2083), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4772), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65575] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2084), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4774), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65598] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2085), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4776), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65621] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2086), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4778), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65644] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2087), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4780), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65667] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2088), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4782), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65690] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2089), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4784), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65713] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2090), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4650), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65736] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2091), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4786), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65759] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2092), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4788), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65782] = 13,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(4736), 1,
      sym_identifier,
    ACTIONS(4742), 1,
      sym_crate,
    ACTIONS(4790), 1,
      anon_sym_RBRACE,
    ACTIONS(4792), 1,
      anon_sym_COMMA,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(2203), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2845), 1,
      sym_enum_variant,
    STATE(3375), 1,
      sym_visibility_modifier,
    STATE(2093), 2,
      sym_line_comment,
      sym_block_comment,
  [65823] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(4457), 1,
      anon_sym_BANG,
    ACTIONS(4459), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4544), 1,
      anon_sym_COLON_COLON,
    STATE(1925), 1,
      sym_type_arguments,
    ACTIONS(4461), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2094), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4453), 3,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_COMMA,
  [65858] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2095), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4794), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65881] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2096), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4796), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65904] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2097), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4798), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65927] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2098), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4800), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [65950] = 13,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(4742), 1,
      sym_crate,
    ACTIONS(4762), 1,
      sym_identifier,
    ACTIONS(4802), 1,
      anon_sym_RBRACE,
    ACTIONS(4804), 1,
      anon_sym_COMMA,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(2200), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2822), 1,
      sym_field_declaration,
    STATE(3409), 1,
      sym_visibility_modifier,
    STATE(2099), 2,
      sym_line_comment,
      sym_block_comment,
  [65991] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4427), 1,
      anon_sym_LPAREN,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(4806), 1,
      anon_sym_LBRACE,
    STATE(1923), 1,
      sym_type_arguments,
    STATE(1942), 1,
      sym_parameters,
    STATE(2100), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 5,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_PLUS,
      anon_sym_COMMA,
  [66024] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4429), 1,
      anon_sym_BANG,
    ACTIONS(4439), 1,
      anon_sym_LPAREN,
    ACTIONS(4443), 1,
      anon_sym_COLON,
    ACTIONS(4447), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4808), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4449), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2101), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4437), 3,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_COMMA,
  [66059] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3235), 1,
      anon_sym_LT2,
    ACTIONS(3499), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4810), 1,
      anon_sym_BANG,
    STATE(1086), 1,
      sym_type_arguments,
    STATE(2102), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3311), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [66090] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2103), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4437), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [66113] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2104), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4812), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [66136] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2105), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4814), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [66159] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2106), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4816), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [66182] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2107), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4818), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [66205] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(4457), 1,
      anon_sym_BANG,
    ACTIONS(4542), 1,
      anon_sym_COLON_COLON,
    STATE(1925), 1,
      sym_type_arguments,
    STATE(2108), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3311), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [66236] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2109), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4820), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [66259] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2110), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4822), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [66282] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2111), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4714), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [66305] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2112), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4824), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [66328] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2113), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4826), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [66351] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2114), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4828), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [66374] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2115), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4830), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [66397] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2116), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4832), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [66420] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2117), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4834), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [66443] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(4836), 1,
      anon_sym_BANG,
    ACTIONS(4838), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4842), 1,
      anon_sym_COLON_COLON,
    STATE(1925), 1,
      sym_type_arguments,
    ACTIONS(4840), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2118), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4453), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [66478] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2119), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4844), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_in,
  [66501] = 12,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(4736), 1,
      sym_identifier,
    ACTIONS(4742), 1,
      sym_crate,
    ACTIONS(4846), 1,
      anon_sym_RBRACE,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(2217), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3098), 1,
      sym_enum_variant,
    STATE(3375), 1,
      sym_visibility_modifier,
    STATE(2120), 2,
      sym_line_comment,
      sym_block_comment,
  [66539] = 12,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(4742), 1,
      sym_crate,
    ACTIONS(4762), 1,
      sym_identifier,
    ACTIONS(4848), 1,
      anon_sym_RBRACE,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(2201), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3030), 1,
      sym_field_declaration,
    STATE(3409), 1,
      sym_visibility_modifier,
    STATE(2121), 2,
      sym_line_comment,
      sym_block_comment,
  [66577] = 12,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4850), 1,
      anon_sym_SEMI,
    ACTIONS(4852), 1,
      anon_sym_LPAREN,
    ACTIONS(4854), 1,
      anon_sym_LBRACE,
    ACTIONS(4856), 1,
      anon_sym_LT,
    ACTIONS(4858), 1,
      anon_sym_where,
    STATE(651), 1,
      sym_field_declaration_list,
    STATE(2236), 1,
      sym_type_parameters,
    STATE(2861), 1,
      sym_ordered_field_declaration_list,
    STATE(3293), 1,
      sym_where_clause,
    STATE(2122), 2,
      sym_line_comment,
      sym_block_comment,
  [66615] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4427), 1,
      anon_sym_LPAREN,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(4860), 1,
      anon_sym_for,
    STATE(1923), 1,
      sym_type_arguments,
    STATE(1942), 1,
      sym_parameters,
    STATE(2123), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [66647] = 12,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(4736), 1,
      sym_identifier,
    ACTIONS(4742), 1,
      sym_crate,
    ACTIONS(4862), 1,
      anon_sym_RBRACE,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(2217), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3098), 1,
      sym_enum_variant,
    STATE(3375), 1,
      sym_visibility_modifier,
    STATE(2124), 2,
      sym_line_comment,
      sym_block_comment,
  [66685] = 12,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(4742), 1,
      sym_crate,
    ACTIONS(4762), 1,
      sym_identifier,
    ACTIONS(4864), 1,
      anon_sym_RBRACE,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(2201), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3030), 1,
      sym_field_declaration,
    STATE(3409), 1,
      sym_visibility_modifier,
    STATE(2125), 2,
      sym_line_comment,
      sym_block_comment,
  [66723] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4868), 1,
      anon_sym_PLUS,
    STATE(2154), 1,
      aux_sym_trait_bounds_repeat1,
    STATE(2126), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4866), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_where,
  [66749] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4870), 1,
      anon_sym_PLUS,
    STATE(2154), 1,
      aux_sym_trait_bounds_repeat1,
    STATE(2127), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4866), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_where,
  [66775] = 12,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4852), 1,
      anon_sym_LPAREN,
    ACTIONS(4856), 1,
      anon_sym_LT,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4872), 1,
      anon_sym_SEMI,
    ACTIONS(4874), 1,
      anon_sym_LBRACE,
    STATE(1092), 1,
      sym_field_declaration_list,
    STATE(2265), 1,
      sym_type_parameters,
    STATE(2779), 1,
      sym_ordered_field_declaration_list,
    STATE(3088), 1,
      sym_where_clause,
    STATE(2128), 2,
      sym_line_comment,
      sym_block_comment,
  [66813] = 12,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(4736), 1,
      sym_identifier,
    ACTIONS(4742), 1,
      sym_crate,
    ACTIONS(4876), 1,
      anon_sym_RBRACE,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(2217), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3098), 1,
      sym_enum_variant,
    STATE(3375), 1,
      sym_visibility_modifier,
    STATE(2129), 2,
      sym_line_comment,
      sym_block_comment,
  [66851] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4427), 1,
      anon_sym_LPAREN,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(4878), 1,
      anon_sym_for,
    STATE(1923), 1,
      sym_type_arguments,
    STATE(1942), 1,
      sym_parameters,
    STATE(2130), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [66883] = 12,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(4736), 1,
      sym_identifier,
    ACTIONS(4742), 1,
      sym_crate,
    ACTIONS(4880), 1,
      anon_sym_RBRACE,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(2217), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3098), 1,
      sym_enum_variant,
    STATE(3375), 1,
      sym_visibility_modifier,
    STATE(2131), 2,
      sym_line_comment,
      sym_block_comment,
  [66921] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4882), 1,
      anon_sym_PLUS,
    STATE(2154), 1,
      aux_sym_trait_bounds_repeat1,
    STATE(2132), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4866), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_where,
  [66947] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4427), 1,
      anon_sym_LPAREN,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(4884), 1,
      anon_sym_for,
    STATE(1923), 1,
      sym_type_arguments,
    STATE(1942), 1,
      sym_parameters,
    STATE(2133), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [66979] = 12,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(4742), 1,
      sym_crate,
    ACTIONS(4762), 1,
      sym_identifier,
    ACTIONS(4886), 1,
      anon_sym_RBRACE,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(2201), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3030), 1,
      sym_field_declaration,
    STATE(3409), 1,
      sym_visibility_modifier,
    STATE(2134), 2,
      sym_line_comment,
      sym_block_comment,
  [67017] = 12,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4852), 1,
      anon_sym_LPAREN,
    ACTIONS(4854), 1,
      anon_sym_LBRACE,
    ACTIONS(4856), 1,
      anon_sym_LT,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4888), 1,
      anon_sym_SEMI,
    STATE(662), 1,
      sym_field_declaration_list,
    STATE(2251), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_ordered_field_declaration_list,
    STATE(3061), 1,
      sym_where_clause,
    STATE(2135), 2,
      sym_line_comment,
      sym_block_comment,
  [67055] = 12,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(4742), 1,
      sym_crate,
    ACTIONS(4762), 1,
      sym_identifier,
    ACTIONS(4890), 1,
      anon_sym_RBRACE,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(2201), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3030), 1,
      sym_field_declaration,
    STATE(3409), 1,
      sym_visibility_modifier,
    STATE(2136), 2,
      sym_line_comment,
      sym_block_comment,
  [67093] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4577), 1,
      anon_sym_LPAREN,
    ACTIONS(4581), 1,
      anon_sym_BANG,
    ACTIONS(4585), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4892), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4587), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2137), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4437), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [67125] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4427), 1,
      anon_sym_LPAREN,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(4894), 1,
      anon_sym_for,
    STATE(1923), 1,
      sym_type_arguments,
    STATE(1942), 1,
      sym_parameters,
    STATE(2138), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [67157] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4898), 1,
      anon_sym_PLUS,
    STATE(2139), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_trait_bounds_repeat1,
    ACTIONS(4896), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_where,
  [67181] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4901), 1,
      anon_sym_SEMI,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    STATE(1120), 1,
      sym_declaration_list,
    STATE(2140), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3311), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [67209] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3267), 1,
      anon_sym_DOT_DOT,
    STATE(2141), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3269), 8,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_if,
  [67233] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4453), 1,
      anon_sym_PIPE,
    ACTIONS(4455), 1,
      anon_sym_COLON,
    ACTIONS(4459), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4560), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4461), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2142), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 3,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COMMA,
  [67265] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(4664), 1,
      sym_identifier,
    ACTIONS(4668), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4672), 1,
      sym_integer_literal,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(2450), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(2143), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3204), 3,
      sym_shorthand_field_initializer,
      sym_field_initializer,
      sym_base_field_initializer,
  [67299] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4427), 1,
      anon_sym_LPAREN,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(4905), 1,
      anon_sym_for,
    STATE(1923), 1,
      sym_type_arguments,
    STATE(1942), 1,
      sym_parameters,
    STATE(2144), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [67331] = 12,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(4742), 1,
      sym_crate,
    ACTIONS(4762), 1,
      sym_identifier,
    ACTIONS(4907), 1,
      anon_sym_RBRACE,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(2201), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3030), 1,
      sym_field_declaration,
    STATE(3409), 1,
      sym_visibility_modifier,
    STATE(2145), 2,
      sym_line_comment,
      sym_block_comment,
  [67369] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3255), 1,
      anon_sym_DOT_DOT,
    STATE(2146), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3257), 8,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_if,
  [67393] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3931), 1,
      anon_sym_LT2,
    ACTIONS(4909), 1,
      anon_sym_COLON_COLON,
    STATE(1616), 1,
      sym_type_arguments,
    STATE(2147), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3311), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [67421] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4427), 1,
      anon_sym_LPAREN,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(4911), 1,
      anon_sym_for,
    STATE(1923), 1,
      sym_type_arguments,
    STATE(1942), 1,
      sym_parameters,
    STATE(2148), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [67453] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4427), 1,
      anon_sym_LPAREN,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(4913), 1,
      anon_sym_for,
    STATE(1923), 1,
      sym_type_arguments,
    STATE(1942), 1,
      sym_parameters,
    STATE(2149), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [67485] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4427), 1,
      anon_sym_LPAREN,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(4915), 1,
      anon_sym_for,
    STATE(1923), 1,
      sym_type_arguments,
    STATE(1942), 1,
      sym_parameters,
    STATE(2150), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [67517] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(4453), 1,
      anon_sym_PIPE,
    ACTIONS(4455), 1,
      anon_sym_COLON,
    ACTIONS(4457), 1,
      anon_sym_BANG,
    ACTIONS(4459), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4560), 1,
      anon_sym_COLON_COLON,
    STATE(1925), 1,
      sym_type_arguments,
    ACTIONS(4461), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2151), 2,
      sym_line_comment,
      sym_block_comment,
  [67553] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3279), 1,
      anon_sym_DOT_DOT,
    STATE(2152), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3281), 8,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_if,
  [67577] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4917), 1,
      anon_sym_LPAREN,
    ACTIONS(4922), 1,
      anon_sym_LBRACK,
    ACTIONS(4925), 1,
      anon_sym_LBRACE,
    STATE(3311), 1,
      sym_token_tree_pattern,
    STATE(3377), 1,
      sym_macro_rule,
    ACTIONS(4920), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    STATE(2153), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_macro_definition_repeat1,
  [67609] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4868), 1,
      anon_sym_PLUS,
    STATE(2139), 1,
      aux_sym_trait_bounds_repeat1,
    STATE(2154), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4928), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_where,
  [67635] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4930), 1,
      anon_sym_SEMI,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    STATE(582), 1,
      sym_declaration_list,
    STATE(2155), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3311), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [67663] = 12,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(4736), 1,
      sym_identifier,
    ACTIONS(4742), 1,
      sym_crate,
    ACTIONS(4934), 1,
      anon_sym_RBRACE,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(2217), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3098), 1,
      sym_enum_variant,
    STATE(3375), 1,
      sym_visibility_modifier,
    STATE(2156), 2,
      sym_line_comment,
      sym_block_comment,
  [67701] = 12,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(4736), 1,
      sym_identifier,
    ACTIONS(4742), 1,
      sym_crate,
    ACTIONS(4936), 1,
      anon_sym_RBRACE,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(2217), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3098), 1,
      sym_enum_variant,
    STATE(3375), 1,
      sym_visibility_modifier,
    STATE(2157), 2,
      sym_line_comment,
      sym_block_comment,
  [67739] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3235), 1,
      anon_sym_LT2,
    ACTIONS(4938), 1,
      anon_sym_COLON_COLON,
    STATE(1086), 1,
      sym_type_arguments,
    STATE(2158), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3311), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [67767] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    ACTIONS(4940), 1,
      anon_sym_SEMI,
    STATE(538), 1,
      sym_declaration_list,
    STATE(2159), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3311), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [67795] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4429), 1,
      anon_sym_BANG,
    ACTIONS(4439), 1,
      anon_sym_LPAREN,
    ACTIONS(4447), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4942), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4449), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2160), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4437), 3,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_COMMA,
  [67827] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4459), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4544), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4944), 1,
      anon_sym_RBRACK,
    ACTIONS(3291), 2,
      anon_sym_SEMI,
      anon_sym_PLUS,
    ACTIONS(4453), 2,
      anon_sym_PIPE,
      anon_sym_COMMA,
    ACTIONS(4461), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2161), 2,
      sym_line_comment,
      sym_block_comment,
  [67859] = 12,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(4742), 1,
      sym_crate,
    ACTIONS(4762), 1,
      sym_identifier,
    ACTIONS(4947), 1,
      anon_sym_RBRACE,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(2201), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3030), 1,
      sym_field_declaration,
    STATE(3409), 1,
      sym_visibility_modifier,
    STATE(2162), 2,
      sym_line_comment,
      sym_block_comment,
  [67897] = 12,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4852), 1,
      anon_sym_LPAREN,
    ACTIONS(4856), 1,
      anon_sym_LT,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4874), 1,
      anon_sym_LBRACE,
    ACTIONS(4949), 1,
      anon_sym_SEMI,
    STATE(1374), 1,
      sym_field_declaration_list,
    STATE(2234), 1,
      sym_type_parameters,
    STATE(2842), 1,
      sym_ordered_field_declaration_list,
    STATE(3250), 1,
      sym_where_clause,
    STATE(2163), 2,
      sym_line_comment,
      sym_block_comment,
  [67935] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3291), 1,
      anon_sym_PLUS,
    ACTIONS(4453), 1,
      anon_sym_PIPE,
    ACTIONS(4455), 1,
      anon_sym_COLON,
    ACTIONS(4459), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4461), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4944), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2164), 2,
      sym_line_comment,
      sym_block_comment,
  [67969] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3287), 1,
      anon_sym_DOT_DOT,
    STATE(2165), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3289), 8,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_BANG,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_if,
  [67993] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(4951), 1,
      anon_sym_COLON_COLON,
    STATE(1925), 1,
      sym_type_arguments,
    STATE(2166), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3311), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [68021] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    ACTIONS(4953), 1,
      anon_sym_SEMI,
    STATE(1161), 1,
      sym_declaration_list,
    STATE(2167), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3311), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [68049] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4958), 1,
      anon_sym_fn,
    ACTIONS(4960), 1,
      anon_sym_extern,
    STATE(2324), 1,
      sym_extern_modifier,
    STATE(2168), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(4955), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
  [68076] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4963), 1,
      anon_sym_SEMI,
    ACTIONS(4965), 1,
      anon_sym_LBRACE,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    STATE(558), 1,
      sym_block,
    STATE(2397), 1,
      sym_where_clause,
    STATE(3576), 1,
      sym_label,
    STATE(2169), 2,
      sym_line_comment,
      sym_block_comment,
  [68111] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4969), 1,
      anon_sym_SEMI,
    ACTIONS(4971), 1,
      anon_sym_LBRACE,
    ACTIONS(4973), 1,
      anon_sym_DASH_GT,
    STATE(1094), 1,
      sym_block,
    STATE(2466), 1,
      sym_where_clause,
    STATE(3579), 1,
      sym_label,
    STATE(2170), 2,
      sym_line_comment,
      sym_block_comment,
  [68146] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4965), 1,
      anon_sym_LBRACE,
    ACTIONS(4975), 1,
      anon_sym_SEMI,
    ACTIONS(4977), 1,
      anon_sym_DASH_GT,
    STATE(517), 1,
      sym_block,
    STATE(2398), 1,
      sym_where_clause,
    STATE(3576), 1,
      sym_label,
    STATE(2171), 2,
      sym_line_comment,
      sym_block_comment,
  [68181] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4965), 1,
      anon_sym_LBRACE,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(4979), 1,
      anon_sym_SEMI,
    STATE(624), 1,
      sym_block,
    STATE(2389), 1,
      sym_where_clause,
    STATE(3576), 1,
      sym_label,
    STATE(2172), 2,
      sym_line_comment,
      sym_block_comment,
  [68216] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(4971), 1,
      anon_sym_LBRACE,
    ACTIONS(4981), 1,
      anon_sym_SEMI,
    STATE(1395), 1,
      sym_block,
    STATE(2458), 1,
      sym_where_clause,
    STATE(3579), 1,
      sym_label,
    STATE(2173), 2,
      sym_line_comment,
      sym_block_comment,
  [68251] = 11,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(4736), 1,
      sym_identifier,
    ACTIONS(4742), 1,
      sym_crate,
    STATE(1041), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(2891), 1,
      sym_enum_variant,
    STATE(3375), 1,
      sym_visibility_modifier,
    STATE(2174), 2,
      sym_line_comment,
      sym_block_comment,
  [68286] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(4971), 1,
      anon_sym_LBRACE,
    ACTIONS(4983), 1,
      anon_sym_SEMI,
    STATE(1306), 1,
      sym_block,
    STATE(2474), 1,
      sym_where_clause,
    STATE(3579), 1,
      sym_label,
    STATE(2175), 2,
      sym_line_comment,
      sym_block_comment,
  [68321] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4971), 1,
      anon_sym_LBRACE,
    ACTIONS(4985), 1,
      anon_sym_SEMI,
    ACTIONS(4987), 1,
      anon_sym_DASH_GT,
    STATE(1422), 1,
      sym_block,
    STATE(2477), 1,
      sym_where_clause,
    STATE(3579), 1,
      sym_label,
    STATE(2176), 2,
      sym_line_comment,
      sym_block_comment,
  [68356] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4965), 1,
      anon_sym_LBRACE,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(4989), 1,
      anon_sym_SEMI,
    STATE(508), 1,
      sym_block,
    STATE(2409), 1,
      sym_where_clause,
    STATE(3576), 1,
      sym_label,
    STATE(2177), 2,
      sym_line_comment,
      sym_block_comment,
  [68391] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4965), 1,
      anon_sym_LBRACE,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(4991), 1,
      anon_sym_SEMI,
    STATE(714), 1,
      sym_block,
    STATE(2464), 1,
      sym_where_clause,
    STATE(3576), 1,
      sym_label,
    STATE(2178), 2,
      sym_line_comment,
      sym_block_comment,
  [68426] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4965), 1,
      anon_sym_LBRACE,
    ACTIONS(4993), 1,
      anon_sym_SEMI,
    ACTIONS(4995), 1,
      anon_sym_DASH_GT,
    STATE(660), 1,
      sym_block,
    STATE(2426), 1,
      sym_where_clause,
    STATE(3576), 1,
      sym_label,
    STATE(2179), 2,
      sym_line_comment,
      sym_block_comment,
  [68461] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4971), 1,
      anon_sym_LBRACE,
    ACTIONS(4997), 1,
      anon_sym_SEMI,
    ACTIONS(4999), 1,
      anon_sym_DASH_GT,
    STATE(1267), 1,
      sym_block,
    STATE(2422), 1,
      sym_where_clause,
    STATE(3579), 1,
      sym_label,
    STATE(2180), 2,
      sym_line_comment,
      sym_block_comment,
  [68496] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4965), 1,
      anon_sym_LBRACE,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5001), 1,
      anon_sym_SEMI,
    STATE(500), 1,
      sym_block,
    STATE(2408), 1,
      sym_where_clause,
    STATE(3576), 1,
      sym_label,
    STATE(2181), 2,
      sym_line_comment,
      sym_block_comment,
  [68531] = 11,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(4742), 1,
      sym_crate,
    ACTIONS(4762), 1,
      sym_identifier,
    STATE(1041), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(2723), 1,
      sym_field_declaration,
    STATE(3409), 1,
      sym_visibility_modifier,
    STATE(2182), 2,
      sym_line_comment,
      sym_block_comment,
  [68566] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1324), 1,
      aux_sym_string_literal_token1,
    STATE(2215), 1,
      sym_string_literal,
    STATE(2183), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4678), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [68591] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4971), 1,
      anon_sym_LBRACE,
    ACTIONS(5003), 1,
      anon_sym_SEMI,
    ACTIONS(5005), 1,
      anon_sym_DASH_GT,
    STATE(1311), 1,
      sym_block,
    STATE(2469), 1,
      sym_where_clause,
    STATE(3579), 1,
      sym_label,
    STATE(2184), 2,
      sym_line_comment,
      sym_block_comment,
  [68626] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4503), 1,
      anon_sym_trait,
    ACTIONS(5007), 1,
      anon_sym_impl,
    STATE(2185), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3311), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [68651] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4690), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4836), 1,
      anon_sym_BANG,
    STATE(2186), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3311), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [68676] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1482), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5009), 1,
      sym_identifier,
    ACTIONS(5011), 1,
      anon_sym_RBRACE,
    ACTIONS(5013), 1,
      anon_sym_COMMA,
    ACTIONS(5015), 1,
      anon_sym_ref,
    ACTIONS(5017), 1,
      sym_mutable_specifier,
    STATE(2187), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2744), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [68709] = 11,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(4742), 1,
      sym_crate,
    ACTIONS(4762), 1,
      sym_identifier,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(2201), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3030), 1,
      sym_field_declaration,
    STATE(3409), 1,
      sym_visibility_modifier,
    STATE(2188), 2,
      sym_line_comment,
      sym_block_comment,
  [68744] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1482), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5009), 1,
      sym_identifier,
    ACTIONS(5015), 1,
      anon_sym_ref,
    ACTIONS(5017), 1,
      sym_mutable_specifier,
    ACTIONS(5019), 1,
      anon_sym_RBRACE,
    ACTIONS(5021), 1,
      anon_sym_COMMA,
    STATE(2189), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3008), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [68777] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    ACTIONS(5023), 1,
      anon_sym_COLON,
    ACTIONS(5025), 1,
      anon_sym_LT,
    STATE(1337), 1,
      sym_declaration_list,
    STATE(2337), 1,
      sym_type_parameters,
    STATE(2696), 1,
      sym_trait_bounds,
    STATE(3230), 1,
      sym_where_clause,
    STATE(2190), 2,
      sym_line_comment,
      sym_block_comment,
  [68812] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    ACTIONS(5023), 1,
      anon_sym_COLON,
    ACTIONS(5025), 1,
      anon_sym_LT,
    STATE(668), 1,
      sym_declaration_list,
    STATE(2302), 1,
      sym_type_parameters,
    STATE(2499), 1,
      sym_trait_bounds,
    STATE(3262), 1,
      sym_where_clause,
    STATE(2191), 2,
      sym_line_comment,
      sym_block_comment,
  [68847] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(4971), 1,
      anon_sym_LBRACE,
    ACTIONS(5027), 1,
      anon_sym_SEMI,
    STATE(1383), 1,
      sym_block,
    STATE(2479), 1,
      sym_where_clause,
    STATE(3579), 1,
      sym_label,
    STATE(2192), 2,
      sym_line_comment,
      sym_block_comment,
  [68882] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(4971), 1,
      anon_sym_LBRACE,
    ACTIONS(5029), 1,
      anon_sym_SEMI,
    STATE(1144), 1,
      sym_block,
    STATE(2471), 1,
      sym_where_clause,
    STATE(3579), 1,
      sym_label,
    STATE(2193), 2,
      sym_line_comment,
      sym_block_comment,
  [68917] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(4971), 1,
      anon_sym_LBRACE,
    ACTIONS(5031), 1,
      anon_sym_SEMI,
    STATE(1366), 1,
      sym_block,
    STATE(2481), 1,
      sym_where_clause,
    STATE(3579), 1,
      sym_label,
    STATE(2194), 2,
      sym_line_comment,
      sym_block_comment,
  [68952] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    ACTIONS(5023), 1,
      anon_sym_COLON,
    ACTIONS(5025), 1,
      anon_sym_LT,
    STATE(1093), 1,
      sym_declaration_list,
    STATE(2372), 1,
      sym_type_parameters,
    STATE(2717), 1,
      sym_trait_bounds,
    STATE(3069), 1,
      sym_where_clause,
    STATE(2195), 2,
      sym_line_comment,
      sym_block_comment,
  [68987] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(4971), 1,
      anon_sym_LBRACE,
    ACTIONS(5033), 1,
      anon_sym_SEMI,
    STATE(1351), 1,
      sym_block,
    STATE(2482), 1,
      sym_where_clause,
    STATE(3579), 1,
      sym_label,
    STATE(2196), 2,
      sym_line_comment,
      sym_block_comment,
  [69022] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5035), 1,
      anon_sym_fn,
    ACTIONS(5037), 1,
      anon_sym_extern,
    STATE(2168), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2324), 1,
      sym_extern_modifier,
    STATE(2197), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4465), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
  [69051] = 11,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(4736), 1,
      sym_identifier,
    ACTIONS(4742), 1,
      sym_crate,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(2217), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(3098), 1,
      sym_enum_variant,
    STATE(3375), 1,
      sym_visibility_modifier,
    STATE(2198), 2,
      sym_line_comment,
      sym_block_comment,
  [69086] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4965), 1,
      anon_sym_LBRACE,
    ACTIONS(5039), 1,
      anon_sym_SEMI,
    ACTIONS(5041), 1,
      anon_sym_DASH_GT,
    STATE(742), 1,
      sym_block,
    STATE(2483), 1,
      sym_where_clause,
    STATE(3576), 1,
      sym_label,
    STATE(2199), 2,
      sym_line_comment,
      sym_block_comment,
  [69121] = 11,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(4742), 1,
      sym_crate,
    ACTIONS(4762), 1,
      sym_identifier,
    STATE(1041), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(2913), 1,
      sym_field_declaration,
    STATE(3409), 1,
      sym_visibility_modifier,
    STATE(2200), 2,
      sym_line_comment,
      sym_block_comment,
  [69156] = 11,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(4742), 1,
      sym_crate,
    ACTIONS(4762), 1,
      sym_identifier,
    STATE(1041), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(3210), 1,
      sym_field_declaration,
    STATE(3409), 1,
      sym_visibility_modifier,
    STATE(2201), 2,
      sym_line_comment,
      sym_block_comment,
  [69191] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    ACTIONS(5023), 1,
      anon_sym_COLON,
    ACTIONS(5025), 1,
      anon_sym_LT,
    STATE(485), 1,
      sym_declaration_list,
    STATE(2333), 1,
      sym_type_parameters,
    STATE(2652), 1,
      sym_trait_bounds,
    STATE(3055), 1,
      sym_where_clause,
    STATE(2202), 2,
      sym_line_comment,
      sym_block_comment,
  [69226] = 11,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(4736), 1,
      sym_identifier,
    ACTIONS(4742), 1,
      sym_crate,
    STATE(1041), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(2829), 1,
      sym_enum_variant,
    STATE(3375), 1,
      sym_visibility_modifier,
    STATE(2203), 2,
      sym_line_comment,
      sym_block_comment,
  [69261] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2204), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4896), 8,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_where,
  [69282] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4965), 1,
      anon_sym_LBRACE,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5043), 1,
      anon_sym_SEMI,
    STATE(652), 1,
      sym_block,
    STATE(2414), 1,
      sym_where_clause,
    STATE(3576), 1,
      sym_label,
    STATE(2205), 2,
      sym_line_comment,
      sym_block_comment,
  [69317] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1482), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5009), 1,
      sym_identifier,
    ACTIONS(5015), 1,
      anon_sym_ref,
    ACTIONS(5017), 1,
      sym_mutable_specifier,
    ACTIONS(5045), 1,
      anon_sym_RBRACE,
    ACTIONS(5047), 1,
      anon_sym_COMMA,
    STATE(2206), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2771), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [69350] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1482), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5009), 1,
      sym_identifier,
    ACTIONS(5015), 1,
      anon_sym_ref,
    ACTIONS(5017), 1,
      sym_mutable_specifier,
    ACTIONS(5049), 1,
      anon_sym_RBRACE,
    ACTIONS(5051), 1,
      anon_sym_COMMA,
    STATE(2207), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2767), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [69383] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2208), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4896), 8,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_where,
  [69404] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2209), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4896), 8,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_where,
  [69425] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2210), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4896), 8,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_where,
  [69446] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    ACTIONS(5023), 1,
      anon_sym_COLON,
    ACTIONS(5025), 1,
      anon_sym_LT,
    STATE(649), 1,
      sym_declaration_list,
    STATE(2328), 1,
      sym_type_parameters,
    STATE(2688), 1,
      sym_trait_bounds,
    STATE(3246), 1,
      sym_where_clause,
    STATE(2211), 2,
      sym_line_comment,
      sym_block_comment,
  [69481] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4971), 1,
      anon_sym_LBRACE,
    ACTIONS(5053), 1,
      anon_sym_SEMI,
    ACTIONS(5055), 1,
      anon_sym_DASH_GT,
    STATE(1459), 1,
      sym_block,
    STATE(2436), 1,
      sym_where_clause,
    STATE(3579), 1,
      sym_label,
    STATE(2212), 2,
      sym_line_comment,
      sym_block_comment,
  [69516] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2213), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4896), 8,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_where,
  [69537] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4429), 1,
      anon_sym_BANG,
    ACTIONS(4437), 1,
      anon_sym_PIPE,
    ACTIONS(4439), 1,
      anon_sym_LPAREN,
    ACTIONS(4443), 1,
      anon_sym_COLON,
    ACTIONS(4447), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5057), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4449), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2214), 2,
      sym_line_comment,
      sym_block_comment,
  [69570] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2215), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5059), 8,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [69591] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4965), 1,
      anon_sym_LBRACE,
    ACTIONS(5061), 1,
      anon_sym_SEMI,
    ACTIONS(5063), 1,
      anon_sym_DASH_GT,
    STATE(696), 1,
      sym_block,
    STATE(2431), 1,
      sym_where_clause,
    STATE(3576), 1,
      sym_label,
    STATE(2216), 2,
      sym_line_comment,
      sym_block_comment,
  [69626] = 11,
    ACTIONS(67), 1,
      anon_sym_pub,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(4736), 1,
      sym_identifier,
    ACTIONS(4742), 1,
      sym_crate,
    STATE(1041), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(3132), 1,
      sym_enum_variant,
    STATE(3375), 1,
      sym_visibility_modifier,
    STATE(2217), 2,
      sym_line_comment,
      sym_block_comment,
  [69661] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4965), 1,
      anon_sym_LBRACE,
    ACTIONS(5065), 1,
      anon_sym_SEMI,
    ACTIONS(5067), 1,
      anon_sym_DASH_GT,
    STATE(548), 1,
      sym_block,
    STATE(2400), 1,
      sym_where_clause,
    STATE(3576), 1,
      sym_label,
    STATE(2218), 2,
      sym_line_comment,
      sym_block_comment,
  [69696] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4965), 1,
      anon_sym_LBRACE,
    ACTIONS(5069), 1,
      anon_sym_SEMI,
    ACTIONS(5071), 1,
      anon_sym_DASH_GT,
    STATE(632), 1,
      sym_block,
    STATE(2427), 1,
      sym_where_clause,
    STATE(3576), 1,
      sym_label,
    STATE(2219), 2,
      sym_line_comment,
      sym_block_comment,
  [69731] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4971), 1,
      anon_sym_LBRACE,
    ACTIONS(5073), 1,
      anon_sym_SEMI,
    ACTIONS(5075), 1,
      anon_sym_DASH_GT,
    STATE(1152), 1,
      sym_block,
    STATE(2441), 1,
      sym_where_clause,
    STATE(3579), 1,
      sym_label,
    STATE(2220), 2,
      sym_line_comment,
      sym_block_comment,
  [69766] = 11,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    ACTIONS(5023), 1,
      anon_sym_COLON,
    ACTIONS(5025), 1,
      anon_sym_LT,
    STATE(1116), 1,
      sym_declaration_list,
    STATE(2314), 1,
      sym_type_parameters,
    STATE(2679), 1,
      sym_trait_bounds,
    STATE(3141), 1,
      sym_where_clause,
    STATE(2221), 2,
      sym_line_comment,
      sym_block_comment,
  [69801] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4558), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5077), 1,
      anon_sym_LPAREN,
    ACTIONS(5079), 1,
      anon_sym_LBRACK,
    ACTIONS(5081), 1,
      anon_sym_RBRACK,
    ACTIONS(5083), 1,
      anon_sym_LBRACE,
    ACTIONS(5085), 1,
      anon_sym_EQ,
    STATE(3300), 1,
      sym_delim_token_tree,
    STATE(2222), 2,
      sym_line_comment,
      sym_block_comment,
  [69833] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5087), 1,
      anon_sym_LPAREN,
    ACTIONS(5089), 1,
      anon_sym_RPAREN,
    ACTIONS(5091), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_LBRACE,
    STATE(2153), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3183), 1,
      sym_macro_rule,
    STATE(3311), 1,
      sym_token_tree_pattern,
    STATE(2223), 2,
      sym_line_comment,
      sym_block_comment,
  [69865] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5087), 1,
      anon_sym_LPAREN,
    ACTIONS(5091), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_LBRACE,
    ACTIONS(5095), 1,
      anon_sym_RPAREN,
    STATE(2254), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3209), 1,
      sym_macro_rule,
    STATE(3311), 1,
      sym_token_tree_pattern,
    STATE(2224), 2,
      sym_line_comment,
      sym_block_comment,
  [69897] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5087), 1,
      anon_sym_LPAREN,
    ACTIONS(5091), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_LBRACE,
    ACTIONS(5097), 1,
      anon_sym_RBRACE,
    STATE(2260), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3067), 1,
      sym_macro_rule,
    STATE(3311), 1,
      sym_token_tree_pattern,
    STATE(2225), 2,
      sym_line_comment,
      sym_block_comment,
  [69929] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4852), 1,
      anon_sym_LPAREN,
    ACTIONS(4874), 1,
      anon_sym_LBRACE,
    ACTIONS(5101), 1,
      anon_sym_EQ,
    ACTIONS(5099), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2226), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2979), 2,
      sym_field_declaration_list,
      sym_ordered_field_declaration_list,
  [69957] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5087), 1,
      anon_sym_LPAREN,
    ACTIONS(5091), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_LBRACE,
    ACTIONS(5103), 1,
      anon_sym_RBRACK,
    STATE(2253), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3216), 1,
      sym_macro_rule,
    STATE(3311), 1,
      sym_token_tree_pattern,
    STATE(2227), 2,
      sym_line_comment,
      sym_block_comment,
  [69989] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5087), 1,
      anon_sym_LPAREN,
    ACTIONS(5091), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_LBRACE,
    ACTIONS(5095), 1,
      anon_sym_RBRACK,
    STATE(2257), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3208), 1,
      sym_macro_rule,
    STATE(3311), 1,
      sym_token_tree_pattern,
    STATE(2228), 2,
      sym_line_comment,
      sym_block_comment,
  [70021] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5087), 1,
      anon_sym_LPAREN,
    ACTIONS(5091), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_LBRACE,
    ACTIONS(5105), 1,
      anon_sym_RBRACK,
    STATE(2153), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3266), 1,
      sym_macro_rule,
    STATE(3311), 1,
      sym_token_tree_pattern,
    STATE(2229), 2,
      sym_line_comment,
      sym_block_comment,
  [70053] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5087), 1,
      anon_sym_LPAREN,
    ACTIONS(5091), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_LBRACE,
    ACTIONS(5105), 1,
      anon_sym_RPAREN,
    STATE(2153), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3167), 1,
      sym_macro_rule,
    STATE(3311), 1,
      sym_token_tree_pattern,
    STATE(2230), 2,
      sym_line_comment,
      sym_block_comment,
  [70085] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1482), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5009), 1,
      sym_identifier,
    ACTIONS(5015), 1,
      anon_sym_ref,
    ACTIONS(5017), 1,
      sym_mutable_specifier,
    ACTIONS(5107), 1,
      anon_sym_RBRACE,
    STATE(2231), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3139), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [70115] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1482), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5009), 1,
      sym_identifier,
    ACTIONS(5015), 1,
      anon_sym_ref,
    ACTIONS(5017), 1,
      sym_mutable_specifier,
    ACTIONS(5109), 1,
      anon_sym_RBRACE,
    STATE(2232), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3139), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [70145] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5087), 1,
      anon_sym_LPAREN,
    ACTIONS(5091), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_LBRACE,
    ACTIONS(5111), 1,
      anon_sym_RBRACE,
    STATE(2263), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3062), 1,
      sym_macro_rule,
    STATE(3311), 1,
      sym_token_tree_pattern,
    STATE(2233), 2,
      sym_line_comment,
      sym_block_comment,
  [70177] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4852), 1,
      anon_sym_LPAREN,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4874), 1,
      anon_sym_LBRACE,
    ACTIONS(5113), 1,
      anon_sym_SEMI,
    STATE(1130), 1,
      sym_field_declaration_list,
    STATE(2929), 1,
      sym_ordered_field_declaration_list,
    STATE(3151), 1,
      sym_where_clause,
    STATE(2234), 2,
      sym_line_comment,
      sym_block_comment,
  [70209] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5087), 1,
      anon_sym_LPAREN,
    ACTIONS(5091), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_LBRACE,
    ACTIONS(5103), 1,
      anon_sym_RPAREN,
    STATE(2223), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3219), 1,
      sym_macro_rule,
    STATE(3311), 1,
      sym_token_tree_pattern,
    STATE(2235), 2,
      sym_line_comment,
      sym_block_comment,
  [70241] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4852), 1,
      anon_sym_LPAREN,
    ACTIONS(4854), 1,
      anon_sym_LBRACE,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(5115), 1,
      anon_sym_SEMI,
    STATE(643), 1,
      sym_field_declaration_list,
    STATE(2847), 1,
      sym_ordered_field_declaration_list,
    STATE(3295), 1,
      sym_where_clause,
    STATE(2236), 2,
      sym_line_comment,
      sym_block_comment,
  [70273] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5087), 1,
      anon_sym_LPAREN,
    ACTIONS(5091), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_LBRACE,
    ACTIONS(5117), 1,
      anon_sym_RPAREN,
    STATE(2153), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3245), 1,
      sym_macro_rule,
    STATE(3311), 1,
      sym_token_tree_pattern,
    STATE(2237), 2,
      sym_line_comment,
      sym_block_comment,
  [70305] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4447), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5121), 1,
      anon_sym_COLON,
    ACTIONS(5123), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4449), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(5119), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2238), 2,
      sym_line_comment,
      sym_block_comment,
  [70333] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5087), 1,
      anon_sym_LPAREN,
    ACTIONS(5091), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_LBRACE,
    ACTIONS(5117), 1,
      anon_sym_RBRACK,
    STATE(2153), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3236), 1,
      sym_macro_rule,
    STATE(3311), 1,
      sym_token_tree_pattern,
    STATE(2239), 2,
      sym_line_comment,
      sym_block_comment,
  [70365] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5125), 1,
      anon_sym_trait,
    STATE(2240), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3311), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [70387] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5087), 1,
      anon_sym_LPAREN,
    ACTIONS(5091), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_LBRACE,
    ACTIONS(5127), 1,
      anon_sym_RBRACE,
    STATE(2153), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3233), 1,
      sym_macro_rule,
    STATE(3311), 1,
      sym_token_tree_pattern,
    STATE(2241), 2,
      sym_line_comment,
      sym_block_comment,
  [70419] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4838), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4842), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4840), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2242), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4453), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [70445] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1482), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5009), 1,
      sym_identifier,
    ACTIONS(5015), 1,
      anon_sym_ref,
    ACTIONS(5017), 1,
      sym_mutable_specifier,
    ACTIONS(5129), 1,
      anon_sym_RBRACE,
    STATE(2243), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3139), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [70475] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5131), 1,
      sym_identifier,
    STATE(2244), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4676), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [70497] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4852), 1,
      anon_sym_LPAREN,
    ACTIONS(4874), 1,
      anon_sym_LBRACE,
    ACTIONS(5135), 1,
      anon_sym_EQ,
    ACTIONS(5133), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2245), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(2810), 2,
      sym_field_declaration_list,
      sym_ordered_field_declaration_list,
  [70525] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5137), 1,
      sym_identifier,
    STATE(2246), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4676), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [70547] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4261), 1,
      anon_sym_LBRACE,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(5141), 1,
      anon_sym_STAR,
    STATE(2750), 1,
      sym_use_list,
    STATE(3025), 1,
      sym_type_arguments,
    ACTIONS(5139), 2,
      sym_identifier,
      sym_super,
    STATE(2247), 2,
      sym_line_comment,
      sym_block_comment,
  [70577] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4654), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5077), 1,
      anon_sym_LPAREN,
    ACTIONS(5079), 1,
      anon_sym_LBRACK,
    ACTIONS(5081), 1,
      anon_sym_RBRACK,
    ACTIONS(5083), 1,
      anon_sym_LBRACE,
    ACTIONS(5085), 1,
      anon_sym_EQ,
    STATE(3300), 1,
      sym_delim_token_tree,
    STATE(2248), 2,
      sym_line_comment,
      sym_block_comment,
  [70609] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5143), 1,
      anon_sym_trait,
    STATE(2249), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3311), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [70631] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4692), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5077), 1,
      anon_sym_LPAREN,
    ACTIONS(5079), 1,
      anon_sym_LBRACK,
    ACTIONS(5081), 1,
      anon_sym_RBRACK,
    ACTIONS(5083), 1,
      anon_sym_LBRACE,
    ACTIONS(5085), 1,
      anon_sym_EQ,
    STATE(3300), 1,
      sym_delim_token_tree,
    STATE(2250), 2,
      sym_line_comment,
      sym_block_comment,
  [70663] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4852), 1,
      anon_sym_LPAREN,
    ACTIONS(4854), 1,
      anon_sym_LBRACE,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(5145), 1,
      anon_sym_SEMI,
    STATE(694), 1,
      sym_field_declaration_list,
    STATE(2802), 1,
      sym_ordered_field_declaration_list,
    STATE(3157), 1,
      sym_where_clause,
    STATE(2251), 2,
      sym_line_comment,
      sym_block_comment,
  [70695] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1482), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5009), 1,
      sym_identifier,
    ACTIONS(5015), 1,
      anon_sym_ref,
    ACTIONS(5017), 1,
      sym_mutable_specifier,
    ACTIONS(5147), 1,
      anon_sym_RBRACE,
    STATE(2252), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3139), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [70725] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5087), 1,
      anon_sym_LPAREN,
    ACTIONS(5089), 1,
      anon_sym_RBRACK,
    ACTIONS(5091), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_LBRACE,
    STATE(2153), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3180), 1,
      sym_macro_rule,
    STATE(3311), 1,
      sym_token_tree_pattern,
    STATE(2253), 2,
      sym_line_comment,
      sym_block_comment,
  [70757] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5087), 1,
      anon_sym_LPAREN,
    ACTIONS(5091), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_LBRACE,
    ACTIONS(5149), 1,
      anon_sym_RPAREN,
    STATE(2153), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3178), 1,
      sym_macro_rule,
    STATE(3311), 1,
      sym_token_tree_pattern,
    STATE(2254), 2,
      sym_line_comment,
      sym_block_comment,
  [70789] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1482), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5009), 1,
      sym_identifier,
    ACTIONS(5015), 1,
      anon_sym_ref,
    ACTIONS(5017), 1,
      sym_mutable_specifier,
    ACTIONS(5151), 1,
      anon_sym_RBRACE,
    STATE(2255), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3139), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [70819] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4690), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5077), 1,
      anon_sym_LPAREN,
    ACTIONS(5079), 1,
      anon_sym_LBRACK,
    ACTIONS(5083), 1,
      anon_sym_LBRACE,
    ACTIONS(5153), 1,
      anon_sym_RBRACK,
    ACTIONS(5155), 1,
      anon_sym_EQ,
    STATE(3423), 1,
      sym_delim_token_tree,
    STATE(2256), 2,
      sym_line_comment,
      sym_block_comment,
  [70851] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5087), 1,
      anon_sym_LPAREN,
    ACTIONS(5091), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_LBRACE,
    ACTIONS(5149), 1,
      anon_sym_RBRACK,
    STATE(2153), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3177), 1,
      sym_macro_rule,
    STATE(3311), 1,
      sym_token_tree_pattern,
    STATE(2257), 2,
      sym_line_comment,
      sym_block_comment,
  [70883] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1482), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5009), 1,
      sym_identifier,
    ACTIONS(5015), 1,
      anon_sym_ref,
    ACTIONS(5017), 1,
      sym_mutable_specifier,
    ACTIONS(5157), 1,
      anon_sym_RBRACE,
    STATE(2258), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3139), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [70913] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4447), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5161), 1,
      anon_sym_COLON,
    ACTIONS(5163), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4449), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(5159), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2259), 2,
      sym_line_comment,
      sym_block_comment,
  [70941] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5087), 1,
      anon_sym_LPAREN,
    ACTIONS(5091), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_LBRACE,
    ACTIONS(5165), 1,
      anon_sym_RBRACE,
    STATE(2153), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3288), 1,
      sym_macro_rule,
    STATE(3311), 1,
      sym_token_tree_pattern,
    STATE(2260), 2,
      sym_line_comment,
      sym_block_comment,
  [70973] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5167), 1,
      sym_identifier,
    STATE(2261), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4676), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [70995] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4447), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5163), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4449), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2262), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 3,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COMMA,
  [71021] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5087), 1,
      anon_sym_LPAREN,
    ACTIONS(5091), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_LBRACE,
    ACTIONS(5169), 1,
      anon_sym_RBRACE,
    STATE(2153), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3289), 1,
      sym_macro_rule,
    STATE(3311), 1,
      sym_token_tree_pattern,
    STATE(2263), 2,
      sym_line_comment,
      sym_block_comment,
  [71053] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4447), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5171), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4449), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2264), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 3,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_PLUS,
  [71079] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4852), 1,
      anon_sym_LPAREN,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4874), 1,
      anon_sym_LBRACE,
    ACTIONS(5173), 1,
      anon_sym_SEMI,
    STATE(1320), 1,
      sym_field_declaration_list,
    STATE(2824), 1,
      sym_ordered_field_declaration_list,
    STATE(3212), 1,
      sym_where_clause,
    STATE(2265), 2,
      sym_line_comment,
      sym_block_comment,
  [71111] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4261), 1,
      anon_sym_LBRACE,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(5141), 1,
      anon_sym_STAR,
    STATE(2750), 1,
      sym_use_list,
    STATE(3234), 1,
      sym_type_arguments,
    ACTIONS(5139), 2,
      sym_identifier,
      sym_super,
    STATE(2266), 2,
      sym_line_comment,
      sym_block_comment,
  [71141] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5087), 1,
      anon_sym_LPAREN,
    ACTIONS(5091), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_LBRACE,
    ACTIONS(5175), 1,
      anon_sym_RBRACE,
    STATE(2153), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3298), 1,
      sym_macro_rule,
    STATE(3311), 1,
      sym_token_tree_pattern,
    STATE(2267), 2,
      sym_line_comment,
      sym_block_comment,
  [71173] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5087), 1,
      anon_sym_LPAREN,
    ACTIONS(5091), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_LBRACE,
    ACTIONS(5177), 1,
      anon_sym_RBRACE,
    STATE(2241), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3123), 1,
      sym_macro_rule,
    STATE(3311), 1,
      sym_token_tree_pattern,
    STATE(2268), 2,
      sym_line_comment,
      sym_block_comment,
  [71205] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1482), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5009), 1,
      sym_identifier,
    ACTIONS(5015), 1,
      anon_sym_ref,
    ACTIONS(5017), 1,
      sym_mutable_specifier,
    ACTIONS(5179), 1,
      anon_sym_RBRACE,
    STATE(2269), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3139), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [71235] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5087), 1,
      anon_sym_LPAREN,
    ACTIONS(5091), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_LBRACE,
    ACTIONS(5181), 1,
      anon_sym_RBRACK,
    STATE(2239), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3155), 1,
      sym_macro_rule,
    STATE(3311), 1,
      sym_token_tree_pattern,
    STATE(2270), 2,
      sym_line_comment,
      sym_block_comment,
  [71267] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5087), 1,
      anon_sym_LPAREN,
    ACTIONS(5091), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_LBRACE,
    ACTIONS(5181), 1,
      anon_sym_RPAREN,
    STATE(2237), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3163), 1,
      sym_macro_rule,
    STATE(3311), 1,
      sym_token_tree_pattern,
    STATE(2271), 2,
      sym_line_comment,
      sym_block_comment,
  [71299] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5183), 1,
      sym_identifier,
    STATE(2272), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4676), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [71321] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5087), 1,
      anon_sym_LPAREN,
    ACTIONS(5091), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_LBRACE,
    ACTIONS(5185), 1,
      anon_sym_RBRACE,
    STATE(2267), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3276), 1,
      sym_macro_rule,
    STATE(3311), 1,
      sym_token_tree_pattern,
    STATE(2273), 2,
      sym_line_comment,
      sym_block_comment,
  [71353] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5087), 1,
      anon_sym_LPAREN,
    ACTIONS(5091), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_LBRACE,
    ACTIONS(5187), 1,
      anon_sym_RBRACK,
    STATE(2229), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3218), 1,
      sym_macro_rule,
    STATE(3311), 1,
      sym_token_tree_pattern,
    STATE(2274), 2,
      sym_line_comment,
      sym_block_comment,
  [71385] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1482), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5009), 1,
      sym_identifier,
    ACTIONS(5015), 1,
      anon_sym_ref,
    ACTIONS(5017), 1,
      sym_mutable_specifier,
    ACTIONS(5189), 1,
      anon_sym_RBRACE,
    STATE(2275), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3139), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [71415] = 10,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5087), 1,
      anon_sym_LPAREN,
    ACTIONS(5091), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_LBRACE,
    ACTIONS(5187), 1,
      anon_sym_RPAREN,
    STATE(2230), 1,
      aux_sym_macro_definition_repeat1,
    STATE(3290), 1,
      sym_macro_rule,
    STATE(3311), 1,
      sym_token_tree_pattern,
    STATE(2276), 2,
      sym_line_comment,
      sym_block_comment,
  [71447] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4447), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5161), 1,
      anon_sym_COLON,
    ACTIONS(5191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4449), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(5159), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2277), 2,
      sym_line_comment,
      sym_block_comment,
  [71475] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4447), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4449), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2278), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 3,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COMMA,
  [71501] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5193), 1,
      anon_sym_SEMI,
    STATE(1279), 1,
      sym_declaration_list,
    STATE(2995), 1,
      sym_where_clause,
    STATE(2279), 2,
      sym_line_comment,
      sym_block_comment,
  [71530] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4856), 1,
      anon_sym_LT,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(5195), 1,
      anon_sym_LBRACE,
    STATE(622), 1,
      sym_enum_variant_list,
    STATE(2612), 1,
      sym_type_parameters,
    STATE(3131), 1,
      sym_where_clause,
    STATE(2280), 2,
      sym_line_comment,
      sym_block_comment,
  [71559] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5197), 1,
      anon_sym_SEMI,
    STATE(572), 1,
      sym_declaration_list,
    STATE(2893), 1,
      sym_where_clause,
    STATE(2281), 2,
      sym_line_comment,
      sym_block_comment,
  [71588] = 8,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(5199), 1,
      anon_sym_if,
    STATE(3398), 1,
      sym_label,
    STATE(373), 2,
      sym_if_expression,
      sym_block,
    STATE(2282), 2,
      sym_line_comment,
      sym_block_comment,
  [71615] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5201), 1,
      anon_sym_SEMI,
    STATE(674), 1,
      sym_declaration_list,
    STATE(2783), 1,
      sym_where_clause,
    STATE(2283), 2,
      sym_line_comment,
      sym_block_comment,
  [71644] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4568), 1,
      anon_sym_EQ,
    ACTIONS(5023), 1,
      anon_sym_COLON,
    ACTIONS(5203), 1,
      anon_sym_GT,
    ACTIONS(5205), 1,
      anon_sym_COMMA,
    STATE(2727), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2867), 1,
      sym_trait_bounds,
    STATE(2284), 2,
      sym_line_comment,
      sym_block_comment,
  [71673] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(749), 1,
      anon_sym_DOT_DOT,
    STATE(2285), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(751), 5,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_if,
  [71694] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4525), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4878), 1,
      anon_sym_for,
    STATE(2286), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [71717] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5207), 1,
      anon_sym_SEMI,
    STATE(494), 1,
      sym_declaration_list,
    STATE(2735), 1,
      sym_where_clause,
    STATE(2287), 2,
      sym_line_comment,
      sym_block_comment,
  [71746] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(813), 1,
      anon_sym_DOT_DOT,
    STATE(2288), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(815), 5,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_if,
  [71767] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(793), 1,
      anon_sym_DOT_DOT,
    STATE(2289), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(795), 5,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_if,
  [71788] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(785), 1,
      anon_sym_DOT_DOT,
    STATE(2290), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(787), 5,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_if,
  [71809] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5209), 1,
      anon_sym_SEMI,
    STATE(484), 1,
      sym_declaration_list,
    STATE(2736), 1,
      sym_where_clause,
    STATE(2291), 2,
      sym_line_comment,
      sym_block_comment,
  [71838] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5211), 1,
      anon_sym_SEMI,
    STATE(1408), 1,
      sym_declaration_list,
    STATE(3003), 1,
      sym_where_clause,
    STATE(2292), 2,
      sym_line_comment,
      sym_block_comment,
  [71867] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5213), 1,
      anon_sym_SEMI,
    STATE(1412), 1,
      sym_declaration_list,
    STATE(3002), 1,
      sym_where_clause,
    STATE(2293), 2,
      sym_line_comment,
      sym_block_comment,
  [71896] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4525), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4860), 1,
      anon_sym_for,
    STATE(2294), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [71919] = 9,
    ACTIONS(27), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5215), 1,
      sym_identifier,
    ACTIONS(5217), 1,
      anon_sym_ref,
    ACTIONS(5219), 1,
      sym_mutable_specifier,
    ACTIONS(5221), 1,
      anon_sym_move,
    STATE(236), 1,
      sym_closure_parameters,
    STATE(2295), 2,
      sym_line_comment,
      sym_block_comment,
  [71948] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5223), 1,
      anon_sym_SEMI,
    STATE(611), 1,
      sym_declaration_list,
    STATE(2931), 1,
      sym_where_clause,
    STATE(2296), 2,
      sym_line_comment,
      sym_block_comment,
  [71977] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5225), 1,
      anon_sym_SEMI,
    STATE(613), 1,
      sym_declaration_list,
    STATE(2933), 1,
      sym_where_clause,
    STATE(2297), 2,
      sym_line_comment,
      sym_block_comment,
  [72006] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3501), 2,
      anon_sym_PLUS,
      anon_sym_DASH_GT,
    ACTIONS(4794), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(5227), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2298), 2,
      sym_line_comment,
      sym_block_comment,
  [72029] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5230), 1,
      anon_sym_SEMI,
    STATE(598), 1,
      sym_declaration_list,
    STATE(2796), 1,
      sym_where_clause,
    STATE(2299), 2,
      sym_line_comment,
      sym_block_comment,
  [72058] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4525), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4894), 1,
      anon_sym_for,
    STATE(2300), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [72081] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5232), 1,
      anon_sym_SEMI,
    STATE(1286), 1,
      sym_declaration_list,
    STATE(2996), 1,
      sym_where_clause,
    STATE(2301), 2,
      sym_line_comment,
      sym_block_comment,
  [72110] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    ACTIONS(5023), 1,
      anon_sym_COLON,
    STATE(609), 1,
      sym_declaration_list,
    STATE(2704), 1,
      sym_trait_bounds,
    STATE(3161), 1,
      sym_where_clause,
    STATE(2302), 2,
      sym_line_comment,
      sym_block_comment,
  [72139] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4525), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4905), 1,
      anon_sym_for,
    STATE(2303), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [72162] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5234), 1,
      anon_sym_SEMI,
    STATE(1274), 1,
      sym_declaration_list,
    STATE(2994), 1,
      sym_where_clause,
    STATE(2304), 2,
      sym_line_comment,
      sym_block_comment,
  [72191] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5236), 1,
      anon_sym_SEMI,
    STATE(1272), 1,
      sym_declaration_list,
    STATE(2993), 1,
      sym_where_clause,
    STATE(2305), 2,
      sym_line_comment,
      sym_block_comment,
  [72220] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4525), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4913), 1,
      anon_sym_for,
    STATE(2306), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [72243] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5238), 1,
      anon_sym_SEMI,
    STATE(1202), 1,
      sym_declaration_list,
    STATE(2990), 1,
      sym_where_clause,
    STATE(2307), 2,
      sym_line_comment,
      sym_block_comment,
  [72272] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5240), 1,
      anon_sym_SEMI,
    STATE(1191), 1,
      sym_declaration_list,
    STATE(2989), 1,
      sym_where_clause,
    STATE(2308), 2,
      sym_line_comment,
      sym_block_comment,
  [72301] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4525), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4915), 1,
      anon_sym_for,
    STATE(2309), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [72324] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2310), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4920), 6,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [72343] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4794), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(2311), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3501), 4,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
  [72364] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4568), 1,
      anon_sym_EQ,
    ACTIONS(4570), 1,
      anon_sym_GT,
    ACTIONS(4572), 1,
      anon_sym_COMMA,
    ACTIONS(5023), 1,
      anon_sym_COLON,
    STATE(2865), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2867), 1,
      sym_trait_bounds,
    STATE(2312), 2,
      sym_line_comment,
      sym_block_comment,
  [72393] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4447), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4449), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(5242), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2313), 2,
      sym_line_comment,
      sym_block_comment,
  [72418] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    ACTIONS(5023), 1,
      anon_sym_COLON,
    STATE(1256), 1,
      sym_declaration_list,
    STATE(2668), 1,
      sym_trait_bounds,
    STATE(3027), 1,
      sym_where_clause,
    STATE(2314), 2,
      sym_line_comment,
      sym_block_comment,
  [72447] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3497), 1,
      anon_sym_COLON,
    ACTIONS(5244), 1,
      anon_sym_EQ,
    STATE(2315), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3495), 4,
      anon_sym_PLUS,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [72470] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4856), 1,
      anon_sym_LT,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(5246), 1,
      anon_sym_LBRACE,
    STATE(1405), 1,
      sym_enum_variant_list,
    STATE(2702), 1,
      sym_type_parameters,
    STATE(3176), 1,
      sym_where_clause,
    STATE(2316), 2,
      sym_line_comment,
      sym_block_comment,
  [72499] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5248), 1,
      anon_sym_SEMI,
    STATE(1235), 1,
      sym_declaration_list,
    STATE(2969), 1,
      sym_where_clause,
    STATE(2317), 2,
      sym_line_comment,
      sym_block_comment,
  [72528] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5250), 1,
      anon_sym_SEMI,
    STATE(1242), 1,
      sym_declaration_list,
    STATE(2968), 1,
      sym_where_clause,
    STATE(2318), 2,
      sym_line_comment,
      sym_block_comment,
  [72557] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5252), 1,
      anon_sym_SEMI,
    STATE(1090), 1,
      sym_declaration_list,
    STATE(2788), 1,
      sym_where_clause,
    STATE(2319), 2,
      sym_line_comment,
      sym_block_comment,
  [72586] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4856), 1,
      anon_sym_LT,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(5195), 1,
      anon_sym_LBRACE,
    STATE(658), 1,
      sym_enum_variant_list,
    STATE(2555), 1,
      sym_type_parameters,
    STATE(3269), 1,
      sym_where_clause,
    STATE(2320), 2,
      sym_line_comment,
      sym_block_comment,
  [72615] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4447), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5163), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4449), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(5242), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2321), 2,
      sym_line_comment,
      sym_block_comment,
  [72640] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5254), 1,
      anon_sym_SEMI,
    STATE(1280), 1,
      sym_declaration_list,
    STATE(2963), 1,
      sym_where_clause,
    STATE(2322), 2,
      sym_line_comment,
      sym_block_comment,
  [72669] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5256), 1,
      anon_sym_SEMI,
    STATE(1385), 1,
      sym_declaration_list,
    STATE(2962), 1,
      sym_where_clause,
    STATE(2323), 2,
      sym_line_comment,
      sym_block_comment,
  [72698] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2324), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3311), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [72717] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4447), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5163), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4449), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(5119), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2325), 2,
      sym_line_comment,
      sym_block_comment,
  [72742] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4854), 1,
      anon_sym_LBRACE,
    ACTIONS(4856), 1,
      anon_sym_LT,
    ACTIONS(4858), 1,
      anon_sym_where,
    STATE(647), 1,
      sym_field_declaration_list,
    STATE(2527), 1,
      sym_type_parameters,
    STATE(3190), 1,
      sym_where_clause,
    STATE(2326), 2,
      sym_line_comment,
      sym_block_comment,
  [72771] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4525), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4911), 1,
      anon_sym_for,
    STATE(2327), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [72794] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    ACTIONS(5023), 1,
      anon_sym_COLON,
    STATE(670), 1,
      sym_declaration_list,
    STATE(2632), 1,
      sym_trait_bounds,
    STATE(3107), 1,
      sym_where_clause,
    STATE(2328), 2,
      sym_line_comment,
      sym_block_comment,
  [72823] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5258), 1,
      anon_sym_SEMI,
    STATE(564), 1,
      sym_declaration_list,
    STATE(2892), 1,
      sym_where_clause,
    STATE(2329), 2,
      sym_line_comment,
      sym_block_comment,
  [72852] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5260), 1,
      anon_sym_SEMI,
    STATE(568), 1,
      sym_declaration_list,
    STATE(2837), 1,
      sym_where_clause,
    STATE(2330), 2,
      sym_line_comment,
      sym_block_comment,
  [72881] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5262), 1,
      anon_sym_SEMI,
    STATE(562), 1,
      sym_declaration_list,
    STATE(2889), 1,
      sym_where_clause,
    STATE(2331), 2,
      sym_line_comment,
      sym_block_comment,
  [72910] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5264), 1,
      anon_sym_SEMI,
    STATE(580), 1,
      sym_declaration_list,
    STATE(2964), 1,
      sym_where_clause,
    STATE(2332), 2,
      sym_line_comment,
      sym_block_comment,
  [72939] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    ACTIONS(5023), 1,
      anon_sym_COLON,
    STATE(689), 1,
      sym_declaration_list,
    STATE(2511), 1,
      sym_trait_bounds,
    STATE(3140), 1,
      sym_where_clause,
    STATE(2333), 2,
      sym_line_comment,
      sym_block_comment,
  [72968] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4525), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4884), 1,
      anon_sym_for,
    STATE(2334), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [72991] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4602), 1,
      anon_sym_DOT_DOT,
    STATE(2335), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4600), 5,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_if,
  [73012] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4585), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4587), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2336), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4437), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [73035] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    ACTIONS(5023), 1,
      anon_sym_COLON,
    STATE(1163), 1,
      sym_declaration_list,
    STATE(2682), 1,
      sym_trait_bounds,
    STATE(3181), 1,
      sym_where_clause,
    STATE(2337), 2,
      sym_line_comment,
      sym_block_comment,
  [73064] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5266), 1,
      anon_sym_SEMI,
    STATE(1238), 1,
      sym_declaration_list,
    STATE(2918), 1,
      sym_where_clause,
    STATE(2338), 2,
      sym_line_comment,
      sym_block_comment,
  [73093] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5023), 1,
      anon_sym_COLON,
    ACTIONS(5025), 1,
      anon_sym_LT,
    ACTIONS(5268), 1,
      anon_sym_SEMI,
    ACTIONS(5270), 1,
      anon_sym_EQ,
    STATE(2661), 1,
      sym_type_parameters,
    STATE(3563), 1,
      sym_trait_bounds,
    STATE(2339), 2,
      sym_line_comment,
      sym_block_comment,
  [73122] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4854), 1,
      anon_sym_LBRACE,
    ACTIONS(4856), 1,
      anon_sym_LT,
    ACTIONS(4858), 1,
      anon_sym_where,
    STATE(490), 1,
      sym_field_declaration_list,
    STATE(2662), 1,
      sym_type_parameters,
    STATE(3036), 1,
      sym_where_clause,
    STATE(2340), 2,
      sym_line_comment,
      sym_block_comment,
  [73151] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5023), 1,
      anon_sym_COLON,
    ACTIONS(5025), 1,
      anon_sym_LT,
    ACTIONS(5272), 1,
      anon_sym_SEMI,
    ACTIONS(5274), 1,
      anon_sym_EQ,
    STATE(2720), 1,
      sym_type_parameters,
    STATE(3424), 1,
      sym_trait_bounds,
    STATE(2341), 2,
      sym_line_comment,
      sym_block_comment,
  [73180] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4856), 1,
      anon_sym_LT,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4874), 1,
      anon_sym_LBRACE,
    STATE(1099), 1,
      sym_field_declaration_list,
    STATE(2722), 1,
      sym_type_parameters,
    STATE(3104), 1,
      sym_where_clause,
    STATE(2342), 2,
      sym_line_comment,
      sym_block_comment,
  [73209] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5276), 1,
      anon_sym_SEMI,
    STATE(1342), 1,
      sym_declaration_list,
    STATE(2904), 1,
      sym_where_clause,
    STATE(2343), 2,
      sym_line_comment,
      sym_block_comment,
  [73238] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5278), 1,
      anon_sym_SEMI,
    STATE(1350), 1,
      sym_declaration_list,
    STATE(2901), 1,
      sym_where_clause,
    STATE(2344), 2,
      sym_line_comment,
      sym_block_comment,
  [73267] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4606), 1,
      anon_sym_DOT_DOT,
    STATE(2345), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4604), 5,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_if,
  [73288] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4568), 1,
      anon_sym_EQ,
    ACTIONS(5023), 1,
      anon_sym_COLON,
    ACTIONS(5280), 1,
      anon_sym_GT,
    ACTIONS(5282), 1,
      anon_sym_COMMA,
    STATE(2867), 1,
      sym_trait_bounds,
    STATE(2899), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2346), 2,
      sym_line_comment,
      sym_block_comment,
  [73317] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1208), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(5284), 1,
      anon_sym_if,
    STATE(3580), 1,
      sym_label,
    STATE(471), 2,
      sym_if_expression,
      sym_block,
    STATE(2347), 2,
      sym_line_comment,
      sym_block_comment,
  [73344] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(5286), 1,
      anon_sym_if,
    STATE(3529), 1,
      sym_label,
    STATE(1417), 2,
      sym_if_expression,
      sym_block,
    STATE(2348), 2,
      sym_line_comment,
      sym_block_comment,
  [73371] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5288), 1,
      anon_sym_RBRACK,
    ACTIONS(4814), 2,
      anon_sym_PIPE,
      anon_sym_COMMA,
    STATE(2349), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3419), 3,
      anon_sym_SEMI,
      anon_sym_PLUS,
      anon_sym_DASH_GT,
  [73394] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5291), 1,
      anon_sym_SEMI,
    STATE(732), 1,
      sym_declaration_list,
    STATE(2793), 1,
      sym_where_clause,
    STATE(2350), 2,
      sym_line_comment,
      sym_block_comment,
  [73423] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4447), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4449), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(5119), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2351), 2,
      sym_line_comment,
      sym_block_comment,
  [73448] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4568), 1,
      anon_sym_EQ,
    ACTIONS(5023), 1,
      anon_sym_COLON,
    ACTIONS(5293), 1,
      anon_sym_GT,
    ACTIONS(5295), 1,
      anon_sym_COMMA,
    STATE(2801), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2867), 1,
      sym_trait_bounds,
    STATE(2352), 2,
      sym_line_comment,
      sym_block_comment,
  [73477] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3035), 1,
      anon_sym_PLUS,
    ACTIONS(5023), 1,
      anon_sym_COLON,
    ACTIONS(5297), 1,
      anon_sym_GT,
    ACTIONS(5299), 1,
      anon_sym_COMMA,
    STATE(2863), 1,
      sym_trait_bounds,
    STATE(2864), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2353), 2,
      sym_line_comment,
      sym_block_comment,
  [73506] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5023), 1,
      anon_sym_COLON,
    ACTIONS(5301), 1,
      anon_sym_PLUS,
    ACTIONS(5303), 1,
      anon_sym_GT,
    ACTIONS(5305), 1,
      anon_sym_COMMA,
    STATE(2943), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2944), 1,
      sym_trait_bounds,
    STATE(2354), 2,
      sym_line_comment,
      sym_block_comment,
  [73535] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5227), 1,
      anon_sym_RBRACK,
    ACTIONS(4794), 2,
      anon_sym_PIPE,
      anon_sym_COMMA,
    STATE(2355), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3501), 3,
      anon_sym_SEMI,
      anon_sym_PLUS,
      anon_sym_DASH_GT,
  [73558] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3419), 2,
      anon_sym_PLUS,
      anon_sym_DASH_GT,
    ACTIONS(4814), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(5288), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2356), 2,
      sym_line_comment,
      sym_block_comment,
  [73581] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1482), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5009), 1,
      sym_identifier,
    ACTIONS(5015), 1,
      anon_sym_ref,
    ACTIONS(5017), 1,
      sym_mutable_specifier,
    STATE(2357), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(3139), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [73608] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3035), 1,
      anon_sym_PLUS,
    ACTIONS(5023), 1,
      anon_sym_COLON,
    ACTIONS(5303), 1,
      anon_sym_GT,
    ACTIONS(5305), 1,
      anon_sym_COMMA,
    STATE(2943), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2944), 1,
      sym_trait_bounds,
    STATE(2358), 2,
      sym_line_comment,
      sym_block_comment,
  [73637] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5023), 1,
      anon_sym_COLON,
    ACTIONS(5307), 1,
      anon_sym_GT,
    ACTIONS(5309), 1,
      anon_sym_COMMA,
    STATE(2863), 1,
      sym_trait_bounds,
    STATE(2864), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2921), 1,
      aux_sym_for_lifetimes_repeat1,
    STATE(2359), 2,
      sym_line_comment,
      sym_block_comment,
  [73666] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3035), 1,
      anon_sym_PLUS,
    ACTIONS(5023), 1,
      anon_sym_COLON,
    ACTIONS(5311), 1,
      anon_sym_GT,
    ACTIONS(5313), 1,
      anon_sym_COMMA,
    STATE(2870), 1,
      sym_trait_bounds,
    STATE(2871), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2360), 2,
      sym_line_comment,
      sym_block_comment,
  [73695] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5023), 1,
      anon_sym_COLON,
    ACTIONS(5301), 1,
      anon_sym_PLUS,
    ACTIONS(5311), 1,
      anon_sym_GT,
    ACTIONS(5313), 1,
      anon_sym_COMMA,
    STATE(2870), 1,
      sym_trait_bounds,
    STATE(2871), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2361), 2,
      sym_line_comment,
      sym_block_comment,
  [73724] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5315), 1,
      anon_sym_SEMI,
    STATE(721), 1,
      sym_declaration_list,
    STATE(2981), 1,
      sym_where_clause,
    STATE(2362), 2,
      sym_line_comment,
      sym_block_comment,
  [73753] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4519), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5297), 1,
      anon_sym_GT,
    ACTIONS(5299), 1,
      anon_sym_COMMA,
    STATE(2864), 1,
      aux_sym_type_parameters_repeat1,
    ACTIONS(3291), 2,
      anon_sym_PLUS,
      anon_sym_as,
    STATE(2363), 2,
      sym_line_comment,
      sym_block_comment,
  [73780] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5317), 1,
      anon_sym_SEMI,
    STATE(724), 1,
      sym_declaration_list,
    STATE(2982), 1,
      sym_where_clause,
    STATE(2364), 2,
      sym_line_comment,
      sym_block_comment,
  [73809] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4814), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(2365), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3419), 4,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
  [73830] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5023), 1,
      anon_sym_COLON,
    ACTIONS(5301), 1,
      anon_sym_PLUS,
    ACTIONS(5319), 1,
      anon_sym_GT,
    ACTIONS(5321), 1,
      anon_sym_COMMA,
    STATE(2970), 1,
      sym_trait_bounds,
    STATE(2971), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2366), 2,
      sym_line_comment,
      sym_block_comment,
  [73859] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5323), 1,
      anon_sym_SEMI,
    STATE(507), 1,
      sym_declaration_list,
    STATE(2853), 1,
      sym_where_clause,
    STATE(2367), 2,
      sym_line_comment,
      sym_block_comment,
  [73888] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5325), 1,
      anon_sym_SEMI,
    STATE(1293), 1,
      sym_declaration_list,
    STATE(2809), 1,
      sym_where_clause,
    STATE(2368), 2,
      sym_line_comment,
      sym_block_comment,
  [73917] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5327), 1,
      anon_sym_SEMI,
    STATE(512), 1,
      sym_declaration_list,
    STATE(2857), 1,
      sym_where_clause,
    STATE(2369), 2,
      sym_line_comment,
      sym_block_comment,
  [73946] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3035), 1,
      anon_sym_PLUS,
    ACTIONS(5023), 1,
      anon_sym_COLON,
    ACTIONS(5319), 1,
      anon_sym_GT,
    ACTIONS(5321), 1,
      anon_sym_COMMA,
    STATE(2970), 1,
      sym_trait_bounds,
    STATE(2971), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2370), 2,
      sym_line_comment,
      sym_block_comment,
  [73975] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(400), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(5329), 1,
      anon_sym_if,
    STATE(3581), 1,
      sym_label,
    STATE(1807), 2,
      sym_if_expression,
      sym_block,
    STATE(2371), 2,
      sym_line_comment,
      sym_block_comment,
  [74002] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    ACTIONS(5023), 1,
      anon_sym_COLON,
    STATE(1324), 1,
      sym_declaration_list,
    STATE(2698), 1,
      sym_trait_bounds,
    STATE(3221), 1,
      sym_where_clause,
    STATE(2372), 2,
      sym_line_comment,
      sym_block_comment,
  [74031] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5331), 1,
      anon_sym_SEMI,
    STATE(1335), 1,
      sym_declaration_list,
    STATE(2833), 1,
      sym_where_clause,
    STATE(2373), 2,
      sym_line_comment,
      sym_block_comment,
  [74060] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4856), 1,
      anon_sym_LT,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(5246), 1,
      anon_sym_LBRACE,
    STATE(1362), 1,
      sym_enum_variant_list,
    STATE(2695), 1,
      sym_type_parameters,
    STATE(3248), 1,
      sym_where_clause,
    STATE(2374), 2,
      sym_line_comment,
      sym_block_comment,
  [74089] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5333), 1,
      anon_sym_SEMI,
    STATE(737), 1,
      sym_declaration_list,
    STATE(2987), 1,
      sym_where_clause,
    STATE(2375), 2,
      sym_line_comment,
      sym_block_comment,
  [74118] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5335), 1,
      anon_sym_SEMI,
    STATE(740), 1,
      sym_declaration_list,
    STATE(2988), 1,
      sym_where_clause,
    STATE(2376), 2,
      sym_line_comment,
      sym_block_comment,
  [74147] = 9,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4856), 1,
      anon_sym_LT,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4874), 1,
      anon_sym_LBRACE,
    STATE(1378), 1,
      sym_field_declaration_list,
    STATE(2693), 1,
      sym_type_parameters,
    STATE(3251), 1,
      sym_where_clause,
    STATE(2377), 2,
      sym_line_comment,
      sym_block_comment,
  [74176] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(400), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    STATE(1760), 1,
      sym_block,
    STATE(3581), 1,
      sym_label,
    STATE(2378), 2,
      sym_line_comment,
      sym_block_comment,
  [74202] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2379), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5337), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [74220] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2380), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5339), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [74238] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2381), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5341), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [74256] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4447), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5121), 1,
      anon_sym_COLON,
    ACTIONS(5123), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4449), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2382), 2,
      sym_line_comment,
      sym_block_comment,
  [74280] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1458), 1,
      anon_sym_RPAREN,
    ACTIONS(5343), 1,
      anon_sym_COMMA,
    STATE(2930), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(4437), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(2383), 2,
      sym_line_comment,
      sym_block_comment,
  [74304] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2384), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5345), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [74322] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5023), 1,
      anon_sym_COLON,
    ACTIONS(5319), 1,
      anon_sym_GT,
    ACTIONS(5321), 1,
      anon_sym_COMMA,
    STATE(2970), 1,
      sym_trait_bounds,
    STATE(2971), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2385), 2,
      sym_line_comment,
      sym_block_comment,
  [74348] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    STATE(1344), 1,
      sym_block,
    STATE(3529), 1,
      sym_label,
    STATE(2386), 2,
      sym_line_comment,
      sym_block_comment,
  [74374] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2387), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5347), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [74392] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5349), 1,
      anon_sym_RBRACK,
    ACTIONS(3725), 2,
      anon_sym_SEMI,
      anon_sym_PLUS,
    ACTIONS(4834), 2,
      anon_sym_PIPE,
      anon_sym_COMMA,
    STATE(2388), 2,
      sym_line_comment,
      sym_block_comment,
  [74414] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4965), 1,
      anon_sym_LBRACE,
    ACTIONS(5352), 1,
      anon_sym_SEMI,
    STATE(543), 1,
      sym_block,
    STATE(3576), 1,
      sym_label,
    STATE(2389), 2,
      sym_line_comment,
      sym_block_comment,
  [74440] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5354), 1,
      anon_sym_RBRACK,
    ACTIONS(3291), 2,
      anon_sym_SEMI,
      anon_sym_PLUS,
    ACTIONS(4437), 2,
      anon_sym_PIPE,
      anon_sym_COMMA,
    STATE(2390), 2,
      sym_line_comment,
      sym_block_comment,
  [74462] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4788), 1,
      anon_sym_PIPE,
    ACTIONS(5357), 1,
      anon_sym_SEMI,
    ACTIONS(5359), 1,
      anon_sym_COLON,
    ACTIONS(5361), 1,
      anon_sym_EQ,
    ACTIONS(5363), 1,
      anon_sym_else,
    STATE(2391), 2,
      sym_line_comment,
      sym_block_comment,
  [74488] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2392), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5365), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [74506] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4568), 1,
      anon_sym_EQ,
    ACTIONS(5023), 1,
      anon_sym_COLON,
    STATE(2867), 1,
      sym_trait_bounds,
    ACTIONS(5367), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    STATE(2393), 2,
      sym_line_comment,
      sym_block_comment,
  [74530] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5369), 1,
      anon_sym_STAR_SLASH,
    ACTIONS(5371), 1,
      sym__outer_block_doc_comment_marker,
    ACTIONS(5373), 1,
      sym__inner_block_doc_comment_marker,
    ACTIONS(5375), 1,
      sym__block_comment_content,
    STATE(3112), 1,
      sym__block_doc_comment_marker,
    STATE(2394), 2,
      sym_line_comment,
      sym_block_comment,
  [74556] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5377), 1,
      anon_sym_RPAREN,
    ACTIONS(5379), 1,
      anon_sym_COMMA,
    STATE(2942), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(4437), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(2395), 2,
      sym_line_comment,
      sym_block_comment,
  [74580] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5023), 1,
      anon_sym_COLON,
    ACTIONS(5303), 1,
      anon_sym_GT,
    ACTIONS(5305), 1,
      anon_sym_COMMA,
    STATE(2943), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2944), 1,
      sym_trait_bounds,
    STATE(2396), 2,
      sym_line_comment,
      sym_block_comment,
  [74606] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4965), 1,
      anon_sym_LBRACE,
    ACTIONS(5381), 1,
      anon_sym_SEMI,
    STATE(498), 1,
      sym_block,
    STATE(3576), 1,
      sym_label,
    STATE(2397), 2,
      sym_line_comment,
      sym_block_comment,
  [74632] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4965), 1,
      anon_sym_LBRACE,
    ACTIONS(5383), 1,
      anon_sym_SEMI,
    STATE(712), 1,
      sym_block,
    STATE(3576), 1,
      sym_label,
    STATE(2398), 2,
      sym_line_comment,
      sym_block_comment,
  [74658] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5385), 1,
      anon_sym_COMMA,
    STATE(2460), 1,
      aux_sym_where_clause_repeat1,
    STATE(2399), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3493), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
  [74680] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4965), 1,
      anon_sym_LBRACE,
    ACTIONS(5387), 1,
      anon_sym_SEMI,
    STATE(482), 1,
      sym_block,
    STATE(3576), 1,
      sym_label,
    STATE(2400), 2,
      sym_line_comment,
      sym_block_comment,
  [74706] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2401), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3777), 5,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
  [74724] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3227), 1,
      anon_sym_LPAREN,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(4435), 1,
      anon_sym_COLON_COLON,
    STATE(1071), 1,
      sym_parameters,
    STATE(1922), 1,
      sym_type_arguments,
    STATE(2402), 2,
      sym_line_comment,
      sym_block_comment,
  [74750] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2403), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3781), 5,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
  [74768] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2404), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5389), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [74786] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2405), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5391), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [74804] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2406), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5393), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [74822] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5023), 1,
      anon_sym_COLON,
    ACTIONS(5311), 1,
      anon_sym_GT,
    ACTIONS(5313), 1,
      anon_sym_COMMA,
    STATE(2870), 1,
      sym_trait_bounds,
    STATE(2871), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2407), 2,
      sym_line_comment,
      sym_block_comment,
  [74848] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4965), 1,
      anon_sym_LBRACE,
    ACTIONS(5395), 1,
      anon_sym_SEMI,
    STATE(639), 1,
      sym_block,
    STATE(3576), 1,
      sym_label,
    STATE(2408), 2,
      sym_line_comment,
      sym_block_comment,
  [74874] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4965), 1,
      anon_sym_LBRACE,
    ACTIONS(5397), 1,
      anon_sym_SEMI,
    STATE(688), 1,
      sym_block,
    STATE(3576), 1,
      sym_label,
    STATE(2409), 2,
      sym_line_comment,
      sym_block_comment,
  [74900] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4816), 1,
      anon_sym_RPAREN,
    ACTIONS(5399), 1,
      anon_sym_COLON,
    ACTIONS(5401), 1,
      anon_sym_PIPE,
    ACTIONS(5403), 1,
      anon_sym_COMMA,
    STATE(2906), 1,
      aux_sym_closure_parameters_repeat1,
    STATE(2410), 2,
      sym_line_comment,
      sym_block_comment,
  [74926] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5407), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5409), 1,
      anon_sym_as,
    STATE(2411), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5405), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [74948] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2412), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5411), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [74966] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5413), 1,
      anon_sym_RPAREN,
    ACTIONS(5415), 1,
      anon_sym_COMMA,
    STATE(2884), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(4437), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(2413), 2,
      sym_line_comment,
      sym_block_comment,
  [74990] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4965), 1,
      anon_sym_LBRACE,
    ACTIONS(5417), 1,
      anon_sym_SEMI,
    STATE(749), 1,
      sym_block,
    STATE(3576), 1,
      sym_label,
    STATE(2414), 2,
      sym_line_comment,
      sym_block_comment,
  [75016] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1454), 1,
      anon_sym_RPAREN,
    ACTIONS(5419), 1,
      anon_sym_COMMA,
    STATE(2958), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(4437), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(2415), 2,
      sym_line_comment,
      sym_block_comment,
  [75040] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5409), 1,
      anon_sym_as,
    ACTIONS(5421), 1,
      anon_sym_COLON_COLON,
    STATE(2416), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5405), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [75062] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5409), 1,
      anon_sym_as,
    ACTIONS(5423), 1,
      anon_sym_COLON_COLON,
    STATE(2417), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5405), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [75084] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5425), 1,
      anon_sym_RPAREN,
    ACTIONS(5427), 1,
      anon_sym_COMMA,
    STATE(3015), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(4437), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(2418), 2,
      sym_line_comment,
      sym_block_comment,
  [75108] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5431), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5433), 1,
      anon_sym_as,
    STATE(2419), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5429), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [75130] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5023), 1,
      anon_sym_COLON,
    ACTIONS(5435), 1,
      anon_sym_GT,
    ACTIONS(5437), 1,
      anon_sym_COMMA,
    STATE(2803), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2863), 1,
      sym_trait_bounds,
    STATE(2420), 2,
      sym_line_comment,
      sym_block_comment,
  [75156] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4834), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(2421), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3725), 3,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COMMA,
  [75176] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4971), 1,
      anon_sym_LBRACE,
    ACTIONS(5439), 1,
      anon_sym_SEMI,
    STATE(1458), 1,
      sym_block,
    STATE(3579), 1,
      sym_label,
    STATE(2422), 2,
      sym_line_comment,
      sym_block_comment,
  [75202] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4640), 1,
      anon_sym_GT,
    ACTIONS(5023), 1,
      anon_sym_COLON,
    ACTIONS(5441), 1,
      anon_sym_COMMA,
    STATE(2863), 1,
      sym_trait_bounds,
    STATE(2900), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2423), 2,
      sym_line_comment,
      sym_block_comment,
  [75228] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3925), 1,
      anon_sym_LPAREN,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(4435), 1,
      anon_sym_COLON_COLON,
    STATE(1596), 1,
      sym_parameters,
    STATE(1922), 1,
      sym_type_arguments,
    STATE(2424), 2,
      sym_line_comment,
      sym_block_comment,
  [75254] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(400), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    STATE(1705), 1,
      sym_block,
    STATE(3581), 1,
      sym_label,
    STATE(2425), 2,
      sym_line_comment,
      sym_block_comment,
  [75280] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4965), 1,
      anon_sym_LBRACE,
    ACTIONS(5443), 1,
      anon_sym_SEMI,
    STATE(546), 1,
      sym_block,
    STATE(3576), 1,
      sym_label,
    STATE(2426), 2,
      sym_line_comment,
      sym_block_comment,
  [75306] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4965), 1,
      anon_sym_LBRACE,
    ACTIONS(5445), 1,
      anon_sym_SEMI,
    STATE(693), 1,
      sym_block,
    STATE(3576), 1,
      sym_label,
    STATE(2427), 2,
      sym_line_comment,
      sym_block_comment,
  [75332] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4427), 1,
      anon_sym_LPAREN,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(4435), 1,
      anon_sym_COLON_COLON,
    STATE(1922), 1,
      sym_type_arguments,
    STATE(1954), 1,
      sym_parameters,
    STATE(2428), 2,
      sym_line_comment,
      sym_block_comment,
  [75358] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5447), 1,
      anon_sym_SEMI,
    ACTIONS(5449), 1,
      anon_sym_COLON,
    ACTIONS(5451), 1,
      anon_sym_PIPE,
    ACTIONS(5453), 1,
      anon_sym_EQ,
    ACTIONS(5455), 1,
      anon_sym_else,
    STATE(2429), 2,
      sym_line_comment,
      sym_block_comment,
  [75384] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4788), 1,
      anon_sym_PIPE,
    ACTIONS(5457), 1,
      anon_sym_SEMI,
    ACTIONS(5459), 1,
      anon_sym_COLON,
    ACTIONS(5461), 1,
      anon_sym_EQ,
    ACTIONS(5463), 1,
      anon_sym_else,
    STATE(2430), 2,
      sym_line_comment,
      sym_block_comment,
  [75410] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4965), 1,
      anon_sym_LBRACE,
    ACTIONS(5465), 1,
      anon_sym_SEMI,
    STATE(559), 1,
      sym_block,
    STATE(3576), 1,
      sym_label,
    STATE(2431), 2,
      sym_line_comment,
      sym_block_comment,
  [75436] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(400), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(5467), 1,
      anon_sym_move,
    STATE(1815), 1,
      sym_block,
    STATE(3581), 1,
      sym_label,
    STATE(2432), 2,
      sym_line_comment,
      sym_block_comment,
  [75462] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    STATE(1175), 1,
      sym_block,
    STATE(3529), 1,
      sym_label,
    STATE(2433), 2,
      sym_line_comment,
      sym_block_comment,
  [75488] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1466), 1,
      anon_sym_RPAREN,
    ACTIONS(5469), 1,
      anon_sym_COMMA,
    STATE(2956), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(4437), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(2434), 2,
      sym_line_comment,
      sym_block_comment,
  [75512] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5451), 1,
      anon_sym_PIPE,
    ACTIONS(5471), 1,
      anon_sym_SEMI,
    ACTIONS(5473), 1,
      anon_sym_COLON,
    ACTIONS(5475), 1,
      anon_sym_EQ,
    ACTIONS(5477), 1,
      anon_sym_else,
    STATE(2435), 2,
      sym_line_comment,
      sym_block_comment,
  [75538] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4971), 1,
      anon_sym_LBRACE,
    ACTIONS(5479), 1,
      anon_sym_SEMI,
    STATE(1398), 1,
      sym_block,
    STATE(3579), 1,
      sym_label,
    STATE(2436), 2,
      sym_line_comment,
      sym_block_comment,
  [75564] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5023), 1,
      anon_sym_COLON,
    ACTIONS(5301), 1,
      anon_sym_PLUS,
    STATE(3105), 1,
      sym_trait_bounds,
    ACTIONS(5481), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    STATE(2437), 2,
      sym_line_comment,
      sym_block_comment,
  [75588] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3035), 1,
      anon_sym_PLUS,
    ACTIONS(5023), 1,
      anon_sym_COLON,
    STATE(3105), 1,
      sym_trait_bounds,
    ACTIONS(5481), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    STATE(2438), 2,
      sym_line_comment,
      sym_block_comment,
  [75612] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(400), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    STATE(1655), 1,
      sym_block,
    STATE(3581), 1,
      sym_label,
    STATE(2439), 2,
      sym_line_comment,
      sym_block_comment,
  [75638] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4437), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(2440), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3291), 3,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COMMA,
  [75658] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4971), 1,
      anon_sym_LBRACE,
    ACTIONS(5483), 1,
      anon_sym_SEMI,
    STATE(1106), 1,
      sym_block,
    STATE(3579), 1,
      sym_label,
    STATE(2441), 2,
      sym_line_comment,
      sym_block_comment,
  [75684] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4447), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5123), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5161), 1,
      anon_sym_COLON,
    ACTIONS(4449), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2442), 2,
      sym_line_comment,
      sym_block_comment,
  [75708] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(5485), 1,
      anon_sym_move,
    STATE(1197), 1,
      sym_block,
    STATE(3529), 1,
      sym_label,
    STATE(2443), 2,
      sym_line_comment,
      sym_block_comment,
  [75734] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1208), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(5487), 1,
      anon_sym_move,
    STATE(461), 1,
      sym_block,
    STATE(3580), 1,
      sym_label,
    STATE(2444), 2,
      sym_line_comment,
      sym_block_comment,
  [75760] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5489), 1,
      aux_sym_line_comment_token1,
    ACTIONS(5491), 1,
      aux_sym_line_comment_token3,
    ACTIONS(5493), 1,
      sym__inner_line_doc_comment_marker,
    ACTIONS(5495), 1,
      sym__outer_line_doc_comment_marker,
    STATE(3478), 1,
      sym__line_doc_comment_marker,
    STATE(2445), 2,
      sym_line_comment,
      sym_block_comment,
  [75786] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5497), 1,
      anon_sym_RPAREN,
    ACTIONS(5500), 1,
      anon_sym_COMMA,
    STATE(3015), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(4437), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(2446), 2,
      sym_line_comment,
      sym_block_comment,
  [75810] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3291), 1,
      anon_sym_PLUS,
    ACTIONS(4437), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(5354), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2447), 2,
      sym_line_comment,
      sym_block_comment,
  [75832] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2448), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3765), 5,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
  [75850] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2449), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3761), 5,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
  [75868] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2943), 1,
      anon_sym_POUND,
    ACTIONS(5503), 1,
      sym_identifier,
    ACTIONS(5505), 1,
      sym_integer_literal,
    STATE(1041), 1,
      aux_sym_enum_variant_list_repeat1,
    STATE(1468), 1,
      sym_attribute_item,
    STATE(2450), 2,
      sym_line_comment,
      sym_block_comment,
  [75894] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5023), 1,
      anon_sym_COLON,
    ACTIONS(5297), 1,
      anon_sym_GT,
    ACTIONS(5299), 1,
      anon_sym_COMMA,
    STATE(2863), 1,
      sym_trait_bounds,
    STATE(2864), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2451), 2,
      sym_line_comment,
      sym_block_comment,
  [75920] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(4435), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4566), 1,
      anon_sym_COLON,
    STATE(1922), 1,
      sym_type_arguments,
    STATE(2703), 1,
      sym_trait_bounds,
    STATE(2452), 2,
      sym_line_comment,
      sym_block_comment,
  [75946] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5509), 1,
      anon_sym_COMMA,
    STATE(2399), 1,
      aux_sym_where_clause_repeat1,
    STATE(2453), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5507), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
  [75968] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2454), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3757), 5,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
  [75986] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5451), 1,
      anon_sym_PIPE,
    ACTIONS(5511), 1,
      anon_sym_RPAREN,
    ACTIONS(5513), 1,
      anon_sym_COLON,
    ACTIONS(5515), 1,
      anon_sym_COMMA,
    STATE(2972), 1,
      aux_sym_slice_pattern_repeat1,
    STATE(2455), 2,
      sym_line_comment,
      sym_block_comment,
  [76012] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2456), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3769), 5,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
  [76030] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2457), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3199), 5,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_as,
  [76048] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4971), 1,
      anon_sym_LBRACE,
    ACTIONS(5517), 1,
      anon_sym_SEMI,
    STATE(1149), 1,
      sym_block,
    STATE(3579), 1,
      sym_label,
    STATE(2458), 2,
      sym_line_comment,
      sym_block_comment,
  [76074] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4261), 1,
      anon_sym_LBRACE,
    ACTIONS(5141), 1,
      anon_sym_STAR,
    STATE(2750), 1,
      sym_use_list,
    ACTIONS(5139), 2,
      sym_identifier,
      sym_super,
    STATE(2459), 2,
      sym_line_comment,
      sym_block_comment,
  [76098] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5521), 1,
      anon_sym_COMMA,
    ACTIONS(5519), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
    STATE(2460), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_where_clause_repeat1,
  [76118] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3725), 1,
      anon_sym_PLUS,
    ACTIONS(4834), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(5349), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2461), 2,
      sym_line_comment,
      sym_block_comment,
  [76140] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2462), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3677), 5,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
  [76158] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2463), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3865), 5,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
  [76176] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4965), 1,
      anon_sym_LBRACE,
    ACTIONS(5524), 1,
      anon_sym_SEMI,
    STATE(619), 1,
      sym_block,
    STATE(3576), 1,
      sym_label,
    STATE(2464), 2,
      sym_line_comment,
      sym_block_comment,
  [76202] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2465), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3809), 5,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
  [76220] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4971), 1,
      anon_sym_LBRACE,
    ACTIONS(5526), 1,
      anon_sym_SEMI,
    STATE(1298), 1,
      sym_block,
    STATE(3579), 1,
      sym_label,
    STATE(2466), 2,
      sym_line_comment,
      sym_block_comment,
  [76246] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4568), 1,
      anon_sym_EQ,
    ACTIONS(5023), 1,
      anon_sym_COLON,
    STATE(2867), 1,
      sym_trait_bounds,
    ACTIONS(5528), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    STATE(2467), 2,
      sym_line_comment,
      sym_block_comment,
  [76270] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2468), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3773), 5,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_where,
  [76288] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4971), 1,
      anon_sym_LBRACE,
    ACTIONS(5530), 1,
      anon_sym_SEMI,
    STATE(1451), 1,
      sym_block,
    STATE(3579), 1,
      sym_label,
    STATE(2469), 2,
      sym_line_comment,
      sym_block_comment,
  [76314] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4261), 1,
      anon_sym_LBRACE,
    ACTIONS(5534), 1,
      anon_sym_STAR,
    STATE(2764), 1,
      sym_use_list,
    ACTIONS(5532), 2,
      sym_identifier,
      sym_super,
    STATE(2470), 2,
      sym_line_comment,
      sym_block_comment,
  [76338] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4971), 1,
      anon_sym_LBRACE,
    ACTIONS(5536), 1,
      anon_sym_SEMI,
    STATE(1454), 1,
      sym_block,
    STATE(3579), 1,
      sym_label,
    STATE(2471), 2,
      sym_line_comment,
      sym_block_comment,
  [76364] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2472), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5538), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [76382] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    STATE(1104), 1,
      sym_block,
    STATE(3529), 1,
      sym_label,
    STATE(2473), 2,
      sym_line_comment,
      sym_block_comment,
  [76408] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4971), 1,
      anon_sym_LBRACE,
    ACTIONS(5540), 1,
      anon_sym_SEMI,
    STATE(1377), 1,
      sym_block,
    STATE(3579), 1,
      sym_label,
    STATE(2474), 2,
      sym_line_comment,
      sym_block_comment,
  [76434] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2475), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5542), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [76452] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2476), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5544), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [76470] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4971), 1,
      anon_sym_LBRACE,
    ACTIONS(5546), 1,
      anon_sym_SEMI,
    STATE(1357), 1,
      sym_block,
    STATE(3579), 1,
      sym_label,
    STATE(2477), 2,
      sym_line_comment,
      sym_block_comment,
  [76496] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2478), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5548), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
  [76514] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4971), 1,
      anon_sym_LBRACE,
    ACTIONS(5550), 1,
      anon_sym_SEMI,
    STATE(1355), 1,
      sym_block,
    STATE(3579), 1,
      sym_label,
    STATE(2479), 2,
      sym_line_comment,
      sym_block_comment,
  [76540] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4624), 1,
      anon_sym_GT,
    ACTIONS(5023), 1,
      anon_sym_COLON,
    ACTIONS(5552), 1,
      anon_sym_COMMA,
    STATE(2733), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2863), 1,
      sym_trait_bounds,
    STATE(2480), 2,
      sym_line_comment,
      sym_block_comment,
  [76566] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4971), 1,
      anon_sym_LBRACE,
    ACTIONS(5554), 1,
      anon_sym_SEMI,
    STATE(1348), 1,
      sym_block,
    STATE(3579), 1,
      sym_label,
    STATE(2481), 2,
      sym_line_comment,
      sym_block_comment,
  [76592] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4971), 1,
      anon_sym_LBRACE,
    ACTIONS(5556), 1,
      anon_sym_SEMI,
    STATE(1336), 1,
      sym_block,
    STATE(3579), 1,
      sym_label,
    STATE(2482), 2,
      sym_line_comment,
      sym_block_comment,
  [76618] = 8,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4965), 1,
      anon_sym_LBRACE,
    ACTIONS(5558), 1,
      anon_sym_SEMI,
    STATE(509), 1,
      sym_block,
    STATE(3576), 1,
      sym_label,
    STATE(2483), 2,
      sym_line_comment,
      sym_block_comment,
  [76644] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5560), 1,
      anon_sym_COLON,
    STATE(2484), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4788), 3,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_COMMA,
  [76663] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5562), 1,
      anon_sym_SEMI,
    ACTIONS(5564), 1,
      anon_sym_EQ,
    ACTIONS(5566), 1,
      anon_sym_else,
    STATE(2485), 2,
      sym_line_comment,
      sym_block_comment,
  [76686] = 7,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    STATE(382), 1,
      sym_block,
    STATE(3398), 1,
      sym_label,
    STATE(2486), 2,
      sym_line_comment,
      sym_block_comment,
  [76709] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(5568), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5570), 1,
      anon_sym_for,
    STATE(1922), 1,
      sym_type_arguments,
    STATE(2487), 2,
      sym_line_comment,
      sym_block_comment,
  [76732] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(5568), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5572), 1,
      anon_sym_for,
    STATE(1922), 1,
      sym_type_arguments,
    STATE(2488), 2,
      sym_line_comment,
      sym_block_comment,
  [76755] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(5568), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5574), 1,
      anon_sym_for,
    STATE(1922), 1,
      sym_type_arguments,
    STATE(2489), 2,
      sym_line_comment,
      sym_block_comment,
  [76778] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(4658), 1,
      anon_sym_for,
    ACTIONS(5568), 1,
      anon_sym_COLON_COLON,
    STATE(1922), 1,
      sym_type_arguments,
    STATE(2490), 2,
      sym_line_comment,
      sym_block_comment,
  [76801] = 7,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    STATE(399), 1,
      sym_block,
    STATE(3398), 1,
      sym_label,
    STATE(2491), 2,
      sym_line_comment,
      sym_block_comment,
  [76824] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5576), 1,
      anon_sym_DQUOTE,
    STATE(2544), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(5578), 2,
      sym_string_content,
      sym_escape_sequence,
    STATE(2492), 2,
      sym_line_comment,
      sym_block_comment,
  [76845] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    STATE(3025), 1,
      sym_type_arguments,
    ACTIONS(5139), 2,
      sym_identifier,
      sym_super,
    STATE(2493), 2,
      sym_line_comment,
      sym_block_comment,
  [76866] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_for,
    ACTIONS(5584), 1,
      anon_sym_loop,
    ACTIONS(5586), 1,
      anon_sym_while,
    STATE(2494), 2,
      sym_line_comment,
      sym_block_comment,
  [76889] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    STATE(3234), 1,
      sym_type_arguments,
    ACTIONS(5139), 2,
      sym_identifier,
      sym_super,
    STATE(2495), 2,
      sym_line_comment,
      sym_block_comment,
  [76910] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4447), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5171), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4449), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2496), 2,
      sym_line_comment,
      sym_block_comment,
  [76931] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5588), 1,
      anon_sym_LBRACE,
    ACTIONS(5590), 1,
      anon_sym_for,
    ACTIONS(5592), 1,
      anon_sym_loop,
    ACTIONS(5594), 1,
      anon_sym_while,
    STATE(2497), 2,
      sym_line_comment,
      sym_block_comment,
  [76954] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4447), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5163), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4449), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2498), 2,
      sym_line_comment,
      sym_block_comment,
  [76975] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    STATE(608), 1,
      sym_declaration_list,
    STATE(3147), 1,
      sym_where_clause,
    STATE(2499), 2,
      sym_line_comment,
      sym_block_comment,
  [76998] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5596), 1,
      anon_sym_COLON_COLON,
    STATE(2500), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4714), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [77017] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    STATE(1195), 1,
      sym_block,
    STATE(3529), 1,
      sym_label,
    STATE(2501), 2,
      sym_line_comment,
      sym_block_comment,
  [77040] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    STATE(1168), 1,
      sym_block,
    STATE(3529), 1,
      sym_label,
    STATE(2502), 2,
      sym_line_comment,
      sym_block_comment,
  [77063] = 7,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    STATE(392), 1,
      sym_block,
    STATE(3398), 1,
      sym_label,
    STATE(2503), 2,
      sym_line_comment,
      sym_block_comment,
  [77086] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    STATE(3349), 1,
      sym_block,
    STATE(3529), 1,
      sym_label,
    STATE(2504), 2,
      sym_line_comment,
      sym_block_comment,
  [77109] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    STATE(3312), 1,
      sym_block,
    STATE(3529), 1,
      sym_label,
    STATE(2505), 2,
      sym_line_comment,
      sym_block_comment,
  [77132] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5598), 1,
      anon_sym_COLON_COLON,
    STATE(2506), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4714), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [77151] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(5568), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5600), 1,
      anon_sym_for,
    STATE(1922), 1,
      sym_type_arguments,
    STATE(2507), 2,
      sym_line_comment,
      sym_block_comment,
  [77174] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5602), 1,
      anon_sym_COLON_COLON,
    STATE(2508), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4714), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [77193] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5604), 1,
      anon_sym_COLON_COLON,
    STATE(2509), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4702), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [77212] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5606), 1,
      anon_sym_SEMI,
    STATE(3480), 1,
      sym_where_clause,
    STATE(2510), 2,
      sym_line_comment,
      sym_block_comment,
  [77235] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    STATE(586), 1,
      sym_declaration_list,
    STATE(3097), 1,
      sym_where_clause,
    STATE(2511), 2,
      sym_line_comment,
      sym_block_comment,
  [77258] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4447), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5123), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4449), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2512), 2,
      sym_line_comment,
      sym_block_comment,
  [77279] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    STATE(3529), 1,
      sym_label,
    STATE(3577), 1,
      sym_block,
    STATE(2513), 2,
      sym_line_comment,
      sym_block_comment,
  [77302] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    STATE(3529), 1,
      sym_label,
    STATE(3594), 1,
      sym_block,
    STATE(2514), 2,
      sym_line_comment,
      sym_block_comment,
  [77325] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4427), 1,
      anon_sym_LPAREN,
    ACTIONS(4856), 1,
      anon_sym_LT,
    STATE(2179), 1,
      sym_parameters,
    STATE(3240), 1,
      sym_type_parameters,
    STATE(2515), 2,
      sym_line_comment,
      sym_block_comment,
  [77348] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5399), 1,
      anon_sym_COLON,
    ACTIONS(5401), 1,
      anon_sym_PIPE,
    ACTIONS(5403), 1,
      anon_sym_COMMA,
    STATE(2906), 1,
      aux_sym_closure_parameters_repeat1,
    STATE(2516), 2,
      sym_line_comment,
      sym_block_comment,
  [77371] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    STATE(3485), 1,
      sym_block,
    STATE(3529), 1,
      sym_label,
    STATE(2517), 2,
      sym_line_comment,
      sym_block_comment,
  [77394] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    STATE(3476), 1,
      sym_block,
    STATE(3529), 1,
      sym_label,
    STATE(2518), 2,
      sym_line_comment,
      sym_block_comment,
  [77417] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(4457), 1,
      anon_sym_BANG,
    ACTIONS(4542), 1,
      anon_sym_COLON_COLON,
    STATE(1925), 1,
      sym_type_arguments,
    STATE(2519), 2,
      sym_line_comment,
      sym_block_comment,
  [77440] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4427), 1,
      anon_sym_LPAREN,
    ACTIONS(4856), 1,
      anon_sym_LT,
    STATE(2184), 1,
      sym_parameters,
    STATE(3150), 1,
      sym_type_parameters,
    STATE(2520), 2,
      sym_line_comment,
      sym_block_comment,
  [77463] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5596), 1,
      anon_sym_COLON_COLON,
    STATE(2521), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4650), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [77482] = 7,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    STATE(371), 1,
      sym_block,
    STATE(3398), 1,
      sym_label,
    STATE(2522), 2,
      sym_line_comment,
      sym_block_comment,
  [77505] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    STATE(3389), 1,
      sym_block,
    STATE(3529), 1,
      sym_label,
    STATE(2523), 2,
      sym_line_comment,
      sym_block_comment,
  [77528] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5608), 1,
      anon_sym_LPAREN,
    ACTIONS(5610), 1,
      anon_sym_LBRACK,
    ACTIONS(5612), 1,
      anon_sym_LBRACE,
    STATE(385), 1,
      sym_delim_token_tree,
    STATE(2524), 2,
      sym_line_comment,
      sym_block_comment,
  [77551] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5614), 1,
      anon_sym_RPAREN,
    ACTIONS(5616), 1,
      anon_sym_COMMA,
    STATE(2754), 1,
      aux_sym_ordered_field_declaration_list_repeat1,
    STATE(2525), 2,
      sym_line_comment,
      sym_block_comment,
  [77574] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5598), 1,
      anon_sym_COLON_COLON,
    STATE(2526), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4650), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [77593] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4854), 1,
      anon_sym_LBRACE,
    ACTIONS(4858), 1,
      anon_sym_where,
    STATE(648), 1,
      sym_field_declaration_list,
    STATE(3279), 1,
      sym_where_clause,
    STATE(2527), 2,
      sym_line_comment,
      sym_block_comment,
  [77616] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4427), 1,
      anon_sym_LPAREN,
    ACTIONS(4856), 1,
      anon_sym_LT,
    STATE(2199), 1,
      sym_parameters,
    STATE(3127), 1,
      sym_type_parameters,
    STATE(2528), 2,
      sym_line_comment,
      sym_block_comment,
  [77639] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5602), 1,
      anon_sym_COLON_COLON,
    STATE(2529), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4650), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [77658] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5604), 1,
      anon_sym_COLON_COLON,
    STATE(2530), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4686), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [77677] = 7,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    STATE(244), 1,
      sym_block,
    STATE(3398), 1,
      sym_label,
    STATE(2531), 2,
      sym_line_comment,
      sym_block_comment,
  [77700] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4427), 1,
      anon_sym_LPAREN,
    ACTIONS(4856), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_parameters,
    STATE(3185), 1,
      sym_type_parameters,
    STATE(2532), 2,
      sym_line_comment,
      sym_block_comment,
  [77723] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5618), 1,
      anon_sym_in,
    STATE(2533), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5620), 3,
      sym_self,
      sym_super,
      sym_crate,
  [77742] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    STATE(3403), 1,
      sym_block,
    STATE(3529), 1,
      sym_label,
    STATE(2534), 2,
      sym_line_comment,
      sym_block_comment,
  [77765] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4261), 1,
      anon_sym_LBRACE,
    STATE(2985), 1,
      sym_use_list,
    ACTIONS(5622), 2,
      sym_identifier,
      sym_super,
    STATE(2535), 2,
      sym_line_comment,
      sym_block_comment,
  [77786] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5624), 1,
      aux_sym_token_repetition_pattern_token1,
    STATE(2536), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5626), 3,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_QMARK,
  [77805] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5628), 1,
      aux_sym_token_repetition_pattern_token1,
    STATE(2537), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5630), 3,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_QMARK,
  [77824] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5632), 1,
      anon_sym_LBRACE,
    ACTIONS(5634), 1,
      anon_sym_for,
    ACTIONS(5636), 1,
      anon_sym_loop,
    ACTIONS(5638), 1,
      anon_sym_while,
    STATE(2538), 2,
      sym_line_comment,
      sym_block_comment,
  [77847] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5640), 1,
      anon_sym_SEMI,
    ACTIONS(5642), 1,
      anon_sym_EQ,
    ACTIONS(5644), 1,
      anon_sym_else,
    STATE(2539), 2,
      sym_line_comment,
      sym_block_comment,
  [77870] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    STATE(3529), 1,
      sym_label,
    STATE(3558), 1,
      sym_block,
    STATE(2540), 2,
      sym_line_comment,
      sym_block_comment,
  [77893] = 7,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    STATE(377), 1,
      sym_block,
    STATE(3398), 1,
      sym_label,
    STATE(2541), 2,
      sym_line_comment,
      sym_block_comment,
  [77916] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5646), 1,
      anon_sym_LPAREN,
    ACTIONS(5648), 1,
      anon_sym_LBRACK,
    ACTIONS(5650), 1,
      anon_sym_LBRACE,
    STATE(2672), 1,
      sym_token_tree,
    STATE(2542), 2,
      sym_line_comment,
      sym_block_comment,
  [77939] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5652), 1,
      anon_sym_in,
    STATE(2543), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5654), 3,
      sym_self,
      sym_super,
      sym_crate,
  [77958] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5656), 1,
      anon_sym_DQUOTE,
    STATE(2674), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(5578), 2,
      sym_string_content,
      sym_escape_sequence,
    STATE(2544), 2,
      sym_line_comment,
      sym_block_comment,
  [77979] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4427), 1,
      anon_sym_LPAREN,
    ACTIONS(4856), 1,
      anon_sym_LT,
    STATE(2180), 1,
      sym_parameters,
    STATE(3241), 1,
      sym_type_parameters,
    STATE(2545), 2,
      sym_line_comment,
      sym_block_comment,
  [78002] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5608), 1,
      anon_sym_LPAREN,
    ACTIONS(5610), 1,
      anon_sym_LBRACK,
    ACTIONS(5612), 1,
      anon_sym_LBRACE,
    STATE(380), 1,
      sym_delim_token_tree,
    STATE(2546), 2,
      sym_line_comment,
      sym_block_comment,
  [78025] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3235), 1,
      anon_sym_LT2,
    ACTIONS(5139), 1,
      sym_super,
    ACTIONS(5658), 1,
      sym_identifier,
    STATE(1127), 1,
      sym_type_arguments,
    STATE(2547), 2,
      sym_line_comment,
      sym_block_comment,
  [78048] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4447), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4449), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2548), 2,
      sym_line_comment,
      sym_block_comment,
  [78069] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(5568), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5660), 1,
      anon_sym_for,
    STATE(1922), 1,
      sym_type_arguments,
    STATE(2549), 2,
      sym_line_comment,
      sym_block_comment,
  [78092] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(5139), 1,
      sym_super,
    ACTIONS(5662), 1,
      sym_identifier,
    STATE(3025), 1,
      sym_type_arguments,
    STATE(2550), 2,
      sym_line_comment,
      sym_block_comment,
  [78115] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(5139), 1,
      sym_super,
    ACTIONS(5662), 1,
      sym_identifier,
    STATE(3234), 1,
      sym_type_arguments,
    STATE(2551), 2,
      sym_line_comment,
      sym_block_comment,
  [78138] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(5662), 1,
      sym_identifier,
    ACTIONS(5664), 1,
      sym_super,
    STATE(3025), 1,
      sym_type_arguments,
    STATE(2552), 2,
      sym_line_comment,
      sym_block_comment,
  [78161] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4624), 1,
      anon_sym_GT,
    ACTIONS(5552), 1,
      anon_sym_COMMA,
    ACTIONS(5666), 1,
      anon_sym_EQ,
    STATE(2733), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2553), 2,
      sym_line_comment,
      sym_block_comment,
  [78184] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(5662), 1,
      sym_identifier,
    ACTIONS(5664), 1,
      sym_super,
    STATE(3234), 1,
      sym_type_arguments,
    STATE(2554), 2,
      sym_line_comment,
      sym_block_comment,
  [78207] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(5195), 1,
      anon_sym_LBRACE,
    STATE(637), 1,
      sym_enum_variant_list,
    STATE(3243), 1,
      sym_where_clause,
    STATE(2555), 2,
      sym_line_comment,
      sym_block_comment,
  [78230] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(5664), 1,
      sym_super,
    ACTIONS(5668), 1,
      sym_identifier,
    STATE(3025), 1,
      sym_type_arguments,
    STATE(2556), 2,
      sym_line_comment,
      sym_block_comment,
  [78253] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(5664), 1,
      sym_super,
    ACTIONS(5668), 1,
      sym_identifier,
    STATE(3234), 1,
      sym_type_arguments,
    STATE(2557), 2,
      sym_line_comment,
      sym_block_comment,
  [78276] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(5664), 1,
      sym_super,
    ACTIONS(5670), 1,
      sym_identifier,
    STATE(3025), 1,
      sym_type_arguments,
    STATE(2558), 2,
      sym_line_comment,
      sym_block_comment,
  [78299] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(5664), 1,
      sym_super,
    ACTIONS(5670), 1,
      sym_identifier,
    STATE(3234), 1,
      sym_type_arguments,
    STATE(2559), 2,
      sym_line_comment,
      sym_block_comment,
  [78322] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(5139), 1,
      sym_super,
    ACTIONS(5672), 1,
      sym_identifier,
    STATE(3025), 1,
      sym_type_arguments,
    STATE(2560), 2,
      sym_line_comment,
      sym_block_comment,
  [78345] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(5139), 1,
      sym_super,
    ACTIONS(5672), 1,
      sym_identifier,
    STATE(3234), 1,
      sym_type_arguments,
    STATE(2561), 2,
      sym_line_comment,
      sym_block_comment,
  [78368] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2562), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4285), 4,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_SQUOTE,
  [78385] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3235), 1,
      anon_sym_LT2,
    ACTIONS(5139), 1,
      sym_super,
    ACTIONS(5658), 1,
      sym_identifier,
    STATE(1231), 1,
      sym_type_arguments,
    STATE(2563), 2,
      sym_line_comment,
      sym_block_comment,
  [78408] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5674), 1,
      anon_sym_LBRACE,
    ACTIONS(5676), 1,
      anon_sym_for,
    ACTIONS(5678), 1,
      anon_sym_loop,
    ACTIONS(5680), 1,
      anon_sym_while,
    STATE(2564), 2,
      sym_line_comment,
      sym_block_comment,
  [78431] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(5682), 1,
      sym_identifier,
    ACTIONS(5684), 1,
      sym_super,
    STATE(3025), 1,
      sym_type_arguments,
    STATE(2565), 2,
      sym_line_comment,
      sym_block_comment,
  [78454] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(5023), 1,
      anon_sym_COLON,
    STATE(1923), 1,
      sym_type_arguments,
    STATE(2699), 1,
      sym_trait_bounds,
    STATE(2566), 2,
      sym_line_comment,
      sym_block_comment,
  [78477] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(5682), 1,
      sym_identifier,
    ACTIONS(5684), 1,
      sym_super,
    STATE(3234), 1,
      sym_type_arguments,
    STATE(2567), 2,
      sym_line_comment,
      sym_block_comment,
  [78500] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    STATE(3378), 1,
      sym_block,
    STATE(3529), 1,
      sym_label,
    STATE(2568), 2,
      sym_line_comment,
      sym_block_comment,
  [78523] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2569), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(955), 4,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [78540] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5686), 1,
      aux_sym_token_repetition_pattern_token1,
    STATE(2570), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5688), 3,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_QMARK,
  [78559] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(5664), 1,
      sym_super,
    ACTIONS(5690), 1,
      sym_identifier,
    STATE(3025), 1,
      sym_type_arguments,
    STATE(2571), 2,
      sym_line_comment,
      sym_block_comment,
  [78582] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(5664), 1,
      sym_super,
    ACTIONS(5690), 1,
      sym_identifier,
    STATE(3234), 1,
      sym_type_arguments,
    STATE(2572), 2,
      sym_line_comment,
      sym_block_comment,
  [78605] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5692), 1,
      anon_sym_DQUOTE,
    STATE(2674), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(5578), 2,
      sym_string_content,
      sym_escape_sequence,
    STATE(2573), 2,
      sym_line_comment,
      sym_block_comment,
  [78626] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5694), 1,
      anon_sym_DQUOTE,
    STATE(2573), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(5578), 2,
      sym_string_content,
      sym_escape_sequence,
    STATE(2574), 2,
      sym_line_comment,
      sym_block_comment,
  [78647] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5451), 1,
      anon_sym_PIPE,
    ACTIONS(5696), 1,
      anon_sym_RPAREN,
    ACTIONS(5698), 1,
      anon_sym_COMMA,
    STATE(2772), 1,
      aux_sym_tuple_pattern_repeat1,
    STATE(2575), 2,
      sym_line_comment,
      sym_block_comment,
  [78670] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5451), 1,
      anon_sym_PIPE,
    ACTIONS(5700), 1,
      anon_sym_RBRACK,
    ACTIONS(5702), 1,
      anon_sym_COMMA,
    STATE(2757), 1,
      aux_sym_slice_pattern_repeat1,
    STATE(2576), 2,
      sym_line_comment,
      sym_block_comment,
  [78693] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(5664), 1,
      sym_super,
    ACTIONS(5672), 1,
      sym_identifier,
    STATE(3025), 1,
      sym_type_arguments,
    STATE(2577), 2,
      sym_line_comment,
      sym_block_comment,
  [78716] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(5664), 1,
      sym_super,
    ACTIONS(5672), 1,
      sym_identifier,
    STATE(3234), 1,
      sym_type_arguments,
    STATE(2578), 2,
      sym_line_comment,
      sym_block_comment,
  [78739] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5704), 1,
      anon_sym_LPAREN,
    ACTIONS(5706), 1,
      anon_sym_LBRACK,
    ACTIONS(5708), 1,
      anon_sym_LBRACE,
    STATE(1803), 1,
      sym_delim_token_tree,
    STATE(2579), 2,
      sym_line_comment,
      sym_block_comment,
  [78762] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5710), 1,
      anon_sym_DQUOTE,
    STATE(2674), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(5578), 2,
      sym_string_content,
      sym_escape_sequence,
    STATE(2580), 2,
      sym_line_comment,
      sym_block_comment,
  [78783] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5704), 1,
      anon_sym_LPAREN,
    ACTIONS(5706), 1,
      anon_sym_LBRACK,
    ACTIONS(5708), 1,
      anon_sym_LBRACE,
    STATE(1806), 1,
      sym_delim_token_tree,
    STATE(2581), 2,
      sym_line_comment,
      sym_block_comment,
  [78806] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(5664), 1,
      sym_super,
    ACTIONS(5712), 1,
      sym_identifier,
    STATE(3234), 1,
      sym_type_arguments,
    STATE(2582), 2,
      sym_line_comment,
      sym_block_comment,
  [78829] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(400), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    STATE(1826), 1,
      sym_block,
    STATE(3581), 1,
      sym_label,
    STATE(2583), 2,
      sym_line_comment,
      sym_block_comment,
  [78852] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5714), 1,
      anon_sym_DQUOTE,
    STATE(2580), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(5578), 2,
      sym_string_content,
      sym_escape_sequence,
    STATE(2584), 2,
      sym_line_comment,
      sym_block_comment,
  [78873] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(400), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    STATE(1825), 1,
      sym_block,
    STATE(3581), 1,
      sym_label,
    STATE(2585), 2,
      sym_line_comment,
      sym_block_comment,
  [78896] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    STATE(1172), 1,
      sym_block,
    STATE(3529), 1,
      sym_label,
    STATE(2586), 2,
      sym_line_comment,
      sym_block_comment,
  [78919] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(5664), 1,
      sym_super,
    ACTIONS(5712), 1,
      sym_identifier,
    STATE(3025), 1,
      sym_type_arguments,
    STATE(2587), 2,
      sym_line_comment,
      sym_block_comment,
  [78942] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    STATE(1166), 1,
      sym_block,
    STATE(3529), 1,
      sym_label,
    STATE(2588), 2,
      sym_line_comment,
      sym_block_comment,
  [78965] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5716), 1,
      anon_sym_DQUOTE,
    STATE(2642), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(5578), 2,
      sym_string_content,
      sym_escape_sequence,
    STATE(2589), 2,
      sym_line_comment,
      sym_block_comment,
  [78986] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5718), 1,
      anon_sym_RPAREN,
    ACTIONS(5720), 1,
      anon_sym_COMMA,
    STATE(3010), 1,
      aux_sym_tuple_type_repeat1,
    STATE(2590), 2,
      sym_line_comment,
      sym_block_comment,
  [79009] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(400), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    STATE(1643), 1,
      sym_block,
    STATE(3581), 1,
      sym_label,
    STATE(2591), 2,
      sym_line_comment,
      sym_block_comment,
  [79032] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(5139), 1,
      sym_super,
    ACTIONS(5712), 1,
      sym_identifier,
    STATE(3025), 1,
      sym_type_arguments,
    STATE(2592), 2,
      sym_line_comment,
      sym_block_comment,
  [79055] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(5139), 1,
      sym_super,
    ACTIONS(5712), 1,
      sym_identifier,
    STATE(3234), 1,
      sym_type_arguments,
    STATE(2593), 2,
      sym_line_comment,
      sym_block_comment,
  [79078] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5722), 1,
      anon_sym_LPAREN,
    ACTIONS(5724), 1,
      anon_sym_LBRACK,
    ACTIONS(5726), 1,
      anon_sym_LBRACE,
    STATE(1024), 1,
      sym_delim_token_tree,
    STATE(2594), 2,
      sym_line_comment,
      sym_block_comment,
  [79101] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1564), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    STATE(2076), 1,
      sym_block,
    STATE(3572), 1,
      sym_label,
    STATE(2595), 2,
      sym_line_comment,
      sym_block_comment,
  [79124] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5728), 1,
      anon_sym_DQUOTE,
    STATE(2674), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(5578), 2,
      sym_string_content,
      sym_escape_sequence,
    STATE(2596), 2,
      sym_line_comment,
      sym_block_comment,
  [79145] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1208), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    STATE(454), 1,
      sym_block,
    STATE(3580), 1,
      sym_label,
    STATE(2597), 2,
      sym_line_comment,
      sym_block_comment,
  [79168] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    STATE(3025), 1,
      sym_type_arguments,
    ACTIONS(5664), 2,
      sym_identifier,
      sym_super,
    STATE(2598), 2,
      sym_line_comment,
      sym_block_comment,
  [79189] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(400), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    STATE(1670), 1,
      sym_block,
    STATE(3581), 1,
      sym_label,
    STATE(2599), 2,
      sym_line_comment,
      sym_block_comment,
  [79212] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(400), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    STATE(1535), 1,
      sym_block,
    STATE(3581), 1,
      sym_label,
    STATE(2600), 2,
      sym_line_comment,
      sym_block_comment,
  [79235] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    STATE(3234), 1,
      sym_type_arguments,
    ACTIONS(5664), 2,
      sym_identifier,
      sym_super,
    STATE(2601), 2,
      sym_line_comment,
      sym_block_comment,
  [79256] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5722), 1,
      anon_sym_LPAREN,
    ACTIONS(5724), 1,
      anon_sym_LBRACK,
    ACTIONS(5726), 1,
      anon_sym_LBRACE,
    STATE(1027), 1,
      sym_delim_token_tree,
    STATE(2602), 2,
      sym_line_comment,
      sym_block_comment,
  [79279] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(400), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    STATE(1687), 1,
      sym_block,
    STATE(3581), 1,
      sym_label,
    STATE(2603), 2,
      sym_line_comment,
      sym_block_comment,
  [79302] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    STATE(3314), 1,
      sym_block,
    STATE(3529), 1,
      sym_label,
    STATE(2604), 2,
      sym_line_comment,
      sym_block_comment,
  [79325] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1208), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    STATE(457), 1,
      sym_block,
    STATE(3580), 1,
      sym_label,
    STATE(2605), 2,
      sym_line_comment,
      sym_block_comment,
  [79348] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5730), 1,
      anon_sym_DQUOTE,
    STATE(2596), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(5578), 2,
      sym_string_content,
      sym_escape_sequence,
    STATE(2606), 2,
      sym_line_comment,
      sym_block_comment,
  [79369] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(400), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    STATE(1753), 1,
      sym_block,
    STATE(3581), 1,
      sym_label,
    STATE(2607), 2,
      sym_line_comment,
      sym_block_comment,
  [79392] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(400), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    STATE(1801), 1,
      sym_block,
    STATE(3581), 1,
      sym_label,
    STATE(2608), 2,
      sym_line_comment,
      sym_block_comment,
  [79415] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4585), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5732), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4587), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    STATE(2609), 2,
      sym_line_comment,
      sym_block_comment,
  [79436] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4427), 1,
      anon_sym_LPAREN,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    STATE(1923), 1,
      sym_type_arguments,
    STATE(1956), 1,
      sym_parameters,
    STATE(2610), 2,
      sym_line_comment,
      sym_block_comment,
  [79459] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1458), 1,
      anon_sym_RPAREN,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5343), 1,
      anon_sym_COMMA,
    STATE(2930), 1,
      aux_sym_parameters_repeat1,
    STATE(2611), 2,
      sym_line_comment,
      sym_block_comment,
  [79482] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(5195), 1,
      anon_sym_LBRACE,
    STATE(736), 1,
      sym_enum_variant_list,
    STATE(3260), 1,
      sym_where_clause,
    STATE(2612), 2,
      sym_line_comment,
      sym_block_comment,
  [79505] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5451), 1,
      anon_sym_PIPE,
    STATE(2613), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5734), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [79524] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1208), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    STATE(459), 1,
      sym_block,
    STATE(3580), 1,
      sym_label,
    STATE(2614), 2,
      sym_line_comment,
      sym_block_comment,
  [79547] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5736), 1,
      anon_sym_COMMA,
    ACTIONS(5734), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    STATE(2615), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_slice_pattern_repeat1,
  [79566] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(4726), 1,
      anon_sym_for,
    ACTIONS(5568), 1,
      anon_sym_COLON_COLON,
    STATE(1922), 1,
      sym_type_arguments,
    STATE(2616), 2,
      sym_line_comment,
      sym_block_comment,
  [79589] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2617), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(3199), 4,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_GT,
      anon_sym_COMMA,
  [79606] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3235), 1,
      anon_sym_LT2,
    ACTIONS(3499), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4810), 1,
      anon_sym_BANG,
    STATE(1086), 1,
      sym_type_arguments,
    STATE(2618), 2,
      sym_line_comment,
      sym_block_comment,
  [79629] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5377), 1,
      anon_sym_RPAREN,
    ACTIONS(5379), 1,
      anon_sym_COMMA,
    STATE(2942), 1,
      aux_sym_parameters_repeat1,
    STATE(2619), 2,
      sym_line_comment,
      sym_block_comment,
  [79652] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4437), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(5739), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2620), 2,
      sym_line_comment,
      sym_block_comment,
  [79671] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5425), 1,
      anon_sym_RPAREN,
    ACTIONS(5427), 1,
      anon_sym_COMMA,
    STATE(3015), 1,
      aux_sym_parameters_repeat1,
    STATE(2621), 2,
      sym_line_comment,
      sym_block_comment,
  [79694] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    STATE(1288), 1,
      sym_block,
    STATE(3529), 1,
      sym_label,
    STATE(2622), 2,
      sym_line_comment,
      sym_block_comment,
  [79717] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1208), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    STATE(466), 1,
      sym_block,
    STATE(3580), 1,
      sym_label,
    STATE(2623), 2,
      sym_line_comment,
      sym_block_comment,
  [79740] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5077), 1,
      anon_sym_LPAREN,
    ACTIONS(5079), 1,
      anon_sym_LBRACK,
    ACTIONS(5083), 1,
      anon_sym_LBRACE,
    STATE(1404), 1,
      sym_delim_token_tree,
    STATE(2624), 2,
      sym_line_comment,
      sym_block_comment,
  [79763] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5297), 1,
      anon_sym_GT,
    ACTIONS(5299), 1,
      anon_sym_COMMA,
    ACTIONS(5666), 1,
      anon_sym_EQ,
    STATE(2864), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2625), 2,
      sym_line_comment,
      sym_block_comment,
  [79786] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5301), 1,
      anon_sym_PLUS,
    STATE(2626), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5741), 3,
      anon_sym_COLON,
      anon_sym_GT,
      anon_sym_COMMA,
  [79805] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2627), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(755), 4,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [79822] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    STATE(1050), 1,
      sym_block,
    STATE(3529), 1,
      sym_label,
    STATE(2628), 2,
      sym_line_comment,
      sym_block_comment,
  [79845] = 5,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5743), 1,
      aux_sym_token_repetition_pattern_token1,
    STATE(2629), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5745), 3,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_QMARK,
  [79864] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    STATE(2630), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5747), 3,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_COMMA,
  [79883] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3925), 1,
      anon_sym_LPAREN,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    STATE(1615), 1,
      sym_parameters,
    STATE(1923), 1,
      sym_type_arguments,
    STATE(2631), 2,
      sym_line_comment,
      sym_block_comment,
  [79906] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    STATE(552), 1,
      sym_declaration_list,
    STATE(3242), 1,
      sym_where_clause,
    STATE(2632), 2,
      sym_line_comment,
      sym_block_comment,
  [79929] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5023), 1,
      anon_sym_COLON,
    STATE(2863), 1,
      sym_trait_bounds,
    ACTIONS(5749), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    STATE(2633), 2,
      sym_line_comment,
      sym_block_comment,
  [79950] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5752), 1,
      anon_sym_RPAREN,
    ACTIONS(5754), 1,
      anon_sym_COMMA,
    STATE(2957), 1,
      aux_sym_tuple_type_repeat1,
    STATE(2634), 2,
      sym_line_comment,
      sym_block_comment,
  [79973] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(5139), 1,
      sym_super,
    ACTIONS(5756), 1,
      sym_identifier,
    STATE(3025), 1,
      sym_type_arguments,
    STATE(2635), 2,
      sym_line_comment,
      sym_block_comment,
  [79996] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(5139), 1,
      sym_super,
    ACTIONS(5756), 1,
      sym_identifier,
    STATE(3234), 1,
      sym_type_arguments,
    STATE(2636), 2,
      sym_line_comment,
      sym_block_comment,
  [80019] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    STATE(3345), 1,
      sym_block,
    STATE(3529), 1,
      sym_label,
    STATE(2637), 2,
      sym_line_comment,
      sym_block_comment,
  [80042] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3931), 1,
      anon_sym_LT2,
    ACTIONS(5758), 1,
      sym_identifier,
    ACTIONS(5760), 1,
      sym_super,
    STATE(1552), 1,
      sym_type_arguments,
    STATE(2638), 2,
      sym_line_comment,
      sym_block_comment,
  [80065] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3931), 1,
      anon_sym_LT2,
    ACTIONS(5758), 1,
      sym_identifier,
    ACTIONS(5760), 1,
      sym_super,
    STATE(1559), 1,
      sym_type_arguments,
    STATE(2639), 2,
      sym_line_comment,
      sym_block_comment,
  [80088] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    STATE(1102), 1,
      sym_block,
    STATE(3529), 1,
      sym_label,
    STATE(2640), 2,
      sym_line_comment,
      sym_block_comment,
  [80111] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5762), 1,
      anon_sym_LPAREN,
    ACTIONS(5764), 1,
      anon_sym_LBRACK,
    ACTIONS(5766), 1,
      anon_sym_LBRACE,
    STATE(1932), 1,
      sym_delim_token_tree,
    STATE(2641), 2,
      sym_line_comment,
      sym_block_comment,
  [80134] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5768), 1,
      anon_sym_DQUOTE,
    STATE(2674), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(5578), 2,
      sym_string_content,
      sym_escape_sequence,
    STATE(2642), 2,
      sym_line_comment,
      sym_block_comment,
  [80155] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5770), 1,
      anon_sym_DQUOTE,
    STATE(2674), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(5578), 2,
      sym_string_content,
      sym_escape_sequence,
    STATE(2643), 2,
      sym_line_comment,
      sym_block_comment,
  [80176] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5077), 1,
      anon_sym_LPAREN,
    ACTIONS(5079), 1,
      anon_sym_LBRACK,
    ACTIONS(5083), 1,
      anon_sym_LBRACE,
    STATE(1103), 1,
      sym_delim_token_tree,
    STATE(2644), 2,
      sym_line_comment,
      sym_block_comment,
  [80199] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3235), 1,
      anon_sym_LT2,
    ACTIONS(5139), 1,
      sym_super,
    ACTIONS(5772), 1,
      sym_identifier,
    STATE(1548), 1,
      sym_type_arguments,
    STATE(2645), 2,
      sym_line_comment,
      sym_block_comment,
  [80222] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1208), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    STATE(474), 1,
      sym_block,
    STATE(3580), 1,
      sym_label,
    STATE(2646), 2,
      sym_line_comment,
      sym_block_comment,
  [80245] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1208), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    STATE(446), 1,
      sym_block,
    STATE(3580), 1,
      sym_label,
    STATE(2647), 2,
      sym_line_comment,
      sym_block_comment,
  [80268] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5762), 1,
      anon_sym_LPAREN,
    ACTIONS(5764), 1,
      anon_sym_LBRACK,
    ACTIONS(5766), 1,
      anon_sym_LBRACE,
    STATE(1931), 1,
      sym_delim_token_tree,
    STATE(2648), 2,
      sym_line_comment,
      sym_block_comment,
  [80291] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5774), 1,
      anon_sym_SEMI,
    STATE(3361), 1,
      sym_where_clause,
    STATE(2649), 2,
      sym_line_comment,
      sym_block_comment,
  [80314] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1208), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    STATE(452), 1,
      sym_block,
    STATE(3580), 1,
      sym_label,
    STATE(2650), 2,
      sym_line_comment,
      sym_block_comment,
  [80337] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3931), 1,
      anon_sym_LT2,
    ACTIONS(4073), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4760), 1,
      anon_sym_BANG,
    STATE(1616), 1,
      sym_type_arguments,
    STATE(2651), 2,
      sym_line_comment,
      sym_block_comment,
  [80360] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    STATE(690), 1,
      sym_declaration_list,
    STATE(3143), 1,
      sym_where_clause,
    STATE(2652), 2,
      sym_line_comment,
      sym_block_comment,
  [80383] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(400), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    STATE(1754), 1,
      sym_block,
    STATE(3581), 1,
      sym_label,
    STATE(2653), 2,
      sym_line_comment,
      sym_block_comment,
  [80406] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3235), 1,
      anon_sym_LT2,
    ACTIONS(5139), 1,
      sym_super,
    ACTIONS(5772), 1,
      sym_identifier,
    STATE(1562), 1,
      sym_type_arguments,
    STATE(2654), 2,
      sym_line_comment,
      sym_block_comment,
  [80429] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    ACTIONS(4971), 1,
      anon_sym_LBRACE,
    STATE(2902), 1,
      sym_block,
    STATE(3579), 1,
      sym_label,
    STATE(2655), 2,
      sym_line_comment,
      sym_block_comment,
  [80452] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5776), 1,
      anon_sym_DQUOTE,
    STATE(2643), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(5578), 2,
      sym_string_content,
      sym_escape_sequence,
    STATE(2656), 2,
      sym_line_comment,
      sym_block_comment,
  [80473] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5778), 1,
      anon_sym_COLON,
    STATE(2657), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4788), 3,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_COMMA,
  [80492] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1208), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    STATE(468), 1,
      sym_block,
    STATE(3580), 1,
      sym_label,
    STATE(2658), 2,
      sym_line_comment,
      sym_block_comment,
  [80515] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1454), 1,
      anon_sym_RPAREN,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5419), 1,
      anon_sym_COMMA,
    STATE(2958), 1,
      aux_sym_parameters_repeat1,
    STATE(2659), 2,
      sym_line_comment,
      sym_block_comment,
  [80538] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1208), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    STATE(462), 1,
      sym_block,
    STATE(3580), 1,
      sym_label,
    STATE(2660), 2,
      sym_line_comment,
      sym_block_comment,
  [80561] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5023), 1,
      anon_sym_COLON,
    ACTIONS(5780), 1,
      anon_sym_SEMI,
    ACTIONS(5782), 1,
      anon_sym_EQ,
    STATE(3441), 1,
      sym_trait_bounds,
    STATE(2661), 2,
      sym_line_comment,
      sym_block_comment,
  [80584] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4854), 1,
      anon_sym_LBRACE,
    ACTIONS(4858), 1,
      anon_sym_where,
    STATE(682), 1,
      sym_field_declaration_list,
    STATE(3135), 1,
      sym_where_clause,
    STATE(2662), 2,
      sym_line_comment,
      sym_block_comment,
  [80607] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5784), 1,
      anon_sym_RPAREN,
    ACTIONS(5786), 1,
      anon_sym_COMMA,
    STATE(2908), 1,
      aux_sym_ordered_field_declaration_list_repeat1,
    STATE(2663), 2,
      sym_line_comment,
      sym_block_comment,
  [80630] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    STATE(3435), 1,
      sym_block,
    STATE(3529), 1,
      sym_label,
    STATE(2664), 2,
      sym_line_comment,
      sym_block_comment,
  [80653] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    STATE(3436), 1,
      sym_block,
    STATE(3529), 1,
      sym_label,
    STATE(2665), 2,
      sym_line_comment,
      sym_block_comment,
  [80676] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5023), 1,
      anon_sym_COLON,
    STATE(2863), 1,
      sym_trait_bounds,
    ACTIONS(5788), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    STATE(2666), 2,
      sym_line_comment,
      sym_block_comment,
  [80697] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5451), 1,
      anon_sym_PIPE,
    ACTIONS(5790), 1,
      anon_sym_RPAREN,
    ACTIONS(5792), 1,
      anon_sym_COMMA,
    STATE(2758), 1,
      aux_sym_tuple_pattern_repeat1,
    STATE(2667), 2,
      sym_line_comment,
      sym_block_comment,
  [80720] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    STATE(1386), 1,
      sym_declaration_list,
    STATE(3087), 1,
      sym_where_clause,
    STATE(2668), 2,
      sym_line_comment,
      sym_block_comment,
  [80743] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5451), 1,
      anon_sym_PIPE,
    ACTIONS(5794), 1,
      anon_sym_RBRACK,
    ACTIONS(5796), 1,
      anon_sym_COMMA,
    STATE(2760), 1,
      aux_sym_slice_pattern_repeat1,
    STATE(2669), 2,
      sym_line_comment,
      sym_block_comment,
  [80766] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5798), 1,
      anon_sym_SEMI,
    STATE(3522), 1,
      sym_where_clause,
    STATE(2670), 2,
      sym_line_comment,
      sym_block_comment,
  [80789] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2671), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5519), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
  [80806] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2672), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5800), 4,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [80823] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(5664), 1,
      sym_super,
    ACTIONS(5756), 1,
      sym_identifier,
    STATE(3234), 1,
      sym_type_arguments,
    STATE(2673), 2,
      sym_line_comment,
      sym_block_comment,
  [80846] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5802), 1,
      anon_sym_DQUOTE,
    ACTIONS(5804), 2,
      sym_string_content,
      sym_escape_sequence,
    STATE(2674), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_string_literal_repeat1,
  [80865] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4427), 1,
      anon_sym_LPAREN,
    ACTIONS(4856), 1,
      anon_sym_LT,
    STATE(2219), 1,
      sym_parameters,
    STATE(3261), 1,
      sym_type_parameters,
    STATE(2675), 2,
      sym_line_comment,
      sym_block_comment,
  [80888] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5451), 1,
      anon_sym_PIPE,
    ACTIONS(5807), 1,
      anon_sym_RPAREN,
    ACTIONS(5809), 1,
      anon_sym_COMMA,
    STATE(3019), 1,
      aux_sym_slice_pattern_repeat1,
    STATE(2676), 2,
      sym_line_comment,
      sym_block_comment,
  [80911] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4437), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(5811), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2677), 2,
      sym_line_comment,
      sym_block_comment,
  [80930] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(5664), 1,
      sym_super,
    ACTIONS(5756), 1,
      sym_identifier,
    STATE(3025), 1,
      sym_type_arguments,
    STATE(2678), 2,
      sym_line_comment,
      sym_block_comment,
  [80953] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    STATE(1252), 1,
      sym_declaration_list,
    STATE(3026), 1,
      sym_where_clause,
    STATE(2679), 2,
      sym_line_comment,
      sym_block_comment,
  [80976] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5813), 1,
      anon_sym_RPAREN,
    ACTIONS(5815), 1,
      anon_sym_COMMA,
    STATE(2773), 1,
      aux_sym_tuple_type_repeat1,
    STATE(2680), 2,
      sym_line_comment,
      sym_block_comment,
  [80999] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5817), 1,
      anon_sym_SEMI,
    STATE(3421), 1,
      sym_where_clause,
    STATE(2681), 2,
      sym_line_comment,
      sym_block_comment,
  [81022] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    STATE(1178), 1,
      sym_declaration_list,
    STATE(3063), 1,
      sym_where_clause,
    STATE(2682), 2,
      sym_line_comment,
      sym_block_comment,
  [81045] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5819), 1,
      anon_sym_SEMI,
    STATE(3505), 1,
      sym_where_clause,
    STATE(2683), 2,
      sym_line_comment,
      sym_block_comment,
  [81068] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5821), 1,
      anon_sym_SEMI,
    ACTIONS(5823), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_else,
    STATE(2684), 2,
      sym_line_comment,
      sym_block_comment,
  [81091] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5023), 1,
      anon_sym_COLON,
    STATE(3105), 1,
      sym_trait_bounds,
    ACTIONS(5481), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    STATE(2685), 2,
      sym_line_comment,
      sym_block_comment,
  [81112] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5301), 1,
      anon_sym_PLUS,
    STATE(2686), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5827), 3,
      anon_sym_COLON,
      anon_sym_GT,
      anon_sym_COMMA,
  [81131] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1466), 1,
      anon_sym_RPAREN,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5469), 1,
      anon_sym_COMMA,
    STATE(2956), 1,
      aux_sym_parameters_repeat1,
    STATE(2687), 2,
      sym_line_comment,
      sym_block_comment,
  [81154] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    STATE(671), 1,
      sym_declaration_list,
    STATE(3089), 1,
      sym_where_clause,
    STATE(2688), 2,
      sym_line_comment,
      sym_block_comment,
  [81177] = 7,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    STATE(387), 1,
      sym_block,
    STATE(3398), 1,
      sym_label,
    STATE(2689), 2,
      sym_line_comment,
      sym_block_comment,
  [81200] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5829), 1,
      anon_sym_SEMI,
    STATE(3443), 1,
      sym_where_clause,
    STATE(2690), 2,
      sym_line_comment,
      sym_block_comment,
  [81223] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    STATE(1109), 1,
      sym_block,
    STATE(3529), 1,
      sym_label,
    STATE(2691), 2,
      sym_line_comment,
      sym_block_comment,
  [81246] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    STATE(2692), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5831), 3,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_COMMA,
  [81265] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4874), 1,
      anon_sym_LBRACE,
    STATE(1119), 1,
      sym_field_declaration_list,
    STATE(3142), 1,
      sym_where_clause,
    STATE(2693), 2,
      sym_line_comment,
      sym_block_comment,
  [81288] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3227), 1,
      anon_sym_LPAREN,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    STATE(1069), 1,
      sym_parameters,
    STATE(1923), 1,
      sym_type_arguments,
    STATE(2694), 2,
      sym_line_comment,
      sym_block_comment,
  [81311] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(5246), 1,
      anon_sym_LBRACE,
    STATE(1141), 1,
      sym_enum_variant_list,
    STATE(3169), 1,
      sym_where_clause,
    STATE(2695), 2,
      sym_line_comment,
      sym_block_comment,
  [81334] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    STATE(1177), 1,
      sym_declaration_list,
    STATE(3187), 1,
      sym_where_clause,
    STATE(2696), 2,
      sym_line_comment,
      sym_block_comment,
  [81357] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5833), 1,
      anon_sym_SEMI,
    STATE(3406), 1,
      sym_where_clause,
    STATE(2697), 2,
      sym_line_comment,
      sym_block_comment,
  [81380] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    STATE(1271), 1,
      sym_declaration_list,
    STATE(3189), 1,
      sym_where_clause,
    STATE(2698), 2,
      sym_line_comment,
      sym_block_comment,
  [81403] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2699), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5835), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
  [81420] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5837), 1,
      anon_sym_SEMI,
    ACTIONS(5839), 1,
      anon_sym_EQ,
    ACTIONS(5841), 1,
      anon_sym_else,
    STATE(2700), 2,
      sym_line_comment,
      sym_block_comment,
  [81443] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4640), 1,
      anon_sym_GT,
    ACTIONS(5441), 1,
      anon_sym_COMMA,
    ACTIONS(5666), 1,
      anon_sym_EQ,
    STATE(2900), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2701), 2,
      sym_line_comment,
      sym_block_comment,
  [81466] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(5246), 1,
      anon_sym_LBRACE,
    STATE(1264), 1,
      sym_enum_variant_list,
    STATE(3145), 1,
      sym_where_clause,
    STATE(2702), 2,
      sym_line_comment,
      sym_block_comment,
  [81489] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2703), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5843), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
  [81506] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    STATE(702), 1,
      sym_declaration_list,
    STATE(3050), 1,
      sym_where_clause,
    STATE(2704), 2,
      sym_line_comment,
      sym_block_comment,
  [81529] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(5568), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5845), 1,
      anon_sym_for,
    STATE(1922), 1,
      sym_type_arguments,
    STATE(2705), 2,
      sym_line_comment,
      sym_block_comment,
  [81552] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5435), 1,
      anon_sym_GT,
    ACTIONS(5437), 1,
      anon_sym_COMMA,
    ACTIONS(5666), 1,
      anon_sym_EQ,
    STATE(2803), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2706), 2,
      sym_line_comment,
      sym_block_comment,
  [81575] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5847), 1,
      anon_sym_SEMI,
    STATE(3568), 1,
      sym_where_clause,
    STATE(2707), 2,
      sym_line_comment,
      sym_block_comment,
  [81598] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    STATE(3025), 1,
      sym_type_arguments,
    ACTIONS(5684), 2,
      sym_identifier,
      sym_super,
    STATE(2708), 2,
      sym_line_comment,
      sym_block_comment,
  [81619] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    STATE(3234), 1,
      sym_type_arguments,
    ACTIONS(5684), 2,
      sym_identifier,
      sym_super,
    STATE(2709), 2,
      sym_line_comment,
      sym_block_comment,
  [81640] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5849), 1,
      anon_sym_COMMA,
    ACTIONS(4069), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    STATE(2710), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_arguments_repeat1,
  [81659] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5413), 1,
      anon_sym_RPAREN,
    ACTIONS(5415), 1,
      anon_sym_COMMA,
    STATE(2884), 1,
      aux_sym_parameters_repeat1,
    STATE(2711), 2,
      sym_line_comment,
      sym_block_comment,
  [81682] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5023), 1,
      anon_sym_COLON,
    STATE(2863), 1,
      sym_trait_bounds,
    ACTIONS(5852), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    STATE(2712), 2,
      sym_line_comment,
      sym_block_comment,
  [81703] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5451), 1,
      anon_sym_PIPE,
    ACTIONS(5854), 1,
      anon_sym_RPAREN,
    ACTIONS(5856), 1,
      anon_sym_COMMA,
    STATE(2877), 1,
      aux_sym_slice_pattern_repeat1,
    STATE(2713), 2,
      sym_line_comment,
      sym_block_comment,
  [81726] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5451), 1,
      anon_sym_PIPE,
    ACTIONS(5858), 1,
      anon_sym_RPAREN,
    ACTIONS(5860), 1,
      anon_sym_COMMA,
    STATE(2873), 1,
      aux_sym_slice_pattern_repeat1,
    STATE(2714), 2,
      sym_line_comment,
      sym_block_comment,
  [81749] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5862), 1,
      anon_sym_RPAREN,
    ACTIONS(5864), 1,
      anon_sym_COMMA,
    STATE(2999), 1,
      aux_sym_ordered_field_declaration_list_repeat1,
    STATE(2715), 2,
      sym_line_comment,
      sym_block_comment,
  [81772] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    STATE(3529), 1,
      sym_label,
    STATE(3553), 1,
      sym_block,
    STATE(2716), 2,
      sym_line_comment,
      sym_block_comment,
  [81795] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    STATE(1323), 1,
      sym_declaration_list,
    STATE(3217), 1,
      sym_where_clause,
    STATE(2717), 2,
      sym_line_comment,
      sym_block_comment,
  [81818] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    STATE(3529), 1,
      sym_label,
    STATE(3559), 1,
      sym_block,
    STATE(2718), 2,
      sym_line_comment,
      sym_block_comment,
  [81841] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5451), 1,
      anon_sym_PIPE,
    ACTIONS(5511), 1,
      anon_sym_RPAREN,
    ACTIONS(5515), 1,
      anon_sym_COMMA,
    STATE(2972), 1,
      aux_sym_slice_pattern_repeat1,
    STATE(2719), 2,
      sym_line_comment,
      sym_block_comment,
  [81864] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5023), 1,
      anon_sym_COLON,
    ACTIONS(5866), 1,
      anon_sym_SEMI,
    ACTIONS(5868), 1,
      anon_sym_EQ,
    STATE(3366), 1,
      sym_trait_bounds,
    STATE(2720), 2,
      sym_line_comment,
      sym_block_comment,
  [81887] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(338), 1,
      anon_sym_LBRACE,
    ACTIONS(3521), 1,
      anon_sym_SQUOTE,
    STATE(1381), 1,
      sym_block,
    STATE(3529), 1,
      sym_label,
    STATE(2721), 2,
      sym_line_comment,
      sym_block_comment,
  [81910] = 7,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(4874), 1,
      anon_sym_LBRACE,
    STATE(1331), 1,
      sym_field_declaration_list,
    STATE(3229), 1,
      sym_where_clause,
    STATE(2722), 2,
      sym_line_comment,
      sym_block_comment,
  [81933] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4947), 1,
      anon_sym_RBRACE,
    ACTIONS(5870), 1,
      anon_sym_COMMA,
    STATE(3006), 1,
      aux_sym_field_declaration_list_repeat1,
    STATE(2723), 2,
      sym_line_comment,
      sym_block_comment,
  [81953] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5874), 1,
      anon_sym_COLON,
    ACTIONS(5872), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2724), 2,
      sym_line_comment,
      sym_block_comment,
  [81971] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2725), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4752), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [81987] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5876), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    STATE(2726), 2,
      sym_line_comment,
      sym_block_comment,
  [82005] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4634), 1,
      anon_sym_GT,
    ACTIONS(5878), 1,
      anon_sym_COMMA,
    STATE(2765), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2727), 2,
      sym_line_comment,
      sym_block_comment,
  [82025] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5880), 1,
      sym_identifier,
    ACTIONS(5882), 2,
      anon_sym_default,
      anon_sym_union,
    STATE(2728), 2,
      sym_line_comment,
      sym_block_comment,
  [82043] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5884), 1,
      sym_identifier,
    ACTIONS(5886), 1,
      anon_sym_ref,
    ACTIONS(5888), 1,
      sym_mutable_specifier,
    STATE(2729), 2,
      sym_line_comment,
      sym_block_comment,
  [82063] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2730), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4758), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [82079] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5890), 1,
      anon_sym_RBRACE,
    ACTIONS(5892), 1,
      anon_sym_COMMA,
    STATE(2838), 1,
      aux_sym_field_initializer_list_repeat1,
    STATE(2731), 2,
      sym_line_comment,
      sym_block_comment,
  [82099] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4756), 1,
      anon_sym_RBRACE,
    ACTIONS(5894), 1,
      anon_sym_COMMA,
    STATE(2832), 1,
      aux_sym_field_initializer_list_repeat1,
    STATE(2732), 2,
      sym_line_comment,
      sym_block_comment,
  [82119] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4638), 1,
      anon_sym_GT,
    ACTIONS(5896), 1,
      anon_sym_COMMA,
    STATE(2765), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2733), 2,
      sym_line_comment,
      sym_block_comment,
  [82139] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    ACTIONS(5898), 1,
      anon_sym_SEMI,
    STATE(1365), 1,
      sym_declaration_list,
    STATE(2734), 2,
      sym_line_comment,
      sym_block_comment,
  [82159] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    ACTIONS(5900), 1,
      anon_sym_SEMI,
    STATE(727), 1,
      sym_declaration_list,
    STATE(2735), 2,
      sym_line_comment,
      sym_block_comment,
  [82179] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    ACTIONS(5902), 1,
      anon_sym_SEMI,
    STATE(741), 1,
      sym_declaration_list,
    STATE(2736), 2,
      sym_line_comment,
      sym_block_comment,
  [82199] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(5904), 1,
      anon_sym_for,
    STATE(1923), 1,
      sym_type_arguments,
    STATE(2737), 2,
      sym_line_comment,
      sym_block_comment,
  [82219] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2738), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4748), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [82235] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2739), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4750), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [82251] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(5906), 1,
      anon_sym_for,
    STATE(1923), 1,
      sym_type_arguments,
    STATE(2740), 2,
      sym_line_comment,
      sym_block_comment,
  [82271] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(5908), 1,
      anon_sym_for,
    STATE(1923), 1,
      sym_type_arguments,
    STATE(2741), 2,
      sym_line_comment,
      sym_block_comment,
  [82291] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2742), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5910), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [82307] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4856), 1,
      anon_sym_LT,
    ACTIONS(5912), 1,
      anon_sym_EQ,
    STATE(3562), 1,
      sym_type_parameters,
    STATE(2743), 2,
      sym_line_comment,
      sym_block_comment,
  [82327] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5914), 1,
      anon_sym_RBRACE,
    ACTIONS(5916), 1,
      anon_sym_COMMA,
    STATE(3020), 1,
      aux_sym_struct_pattern_repeat1,
    STATE(2744), 2,
      sym_line_comment,
      sym_block_comment,
  [82347] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2745), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4832), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [82363] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2746), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4824), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [82379] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2747), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4818), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [82395] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2748), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4814), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [82411] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(4905), 1,
      anon_sym_for,
    STATE(1923), 1,
      sym_type_arguments,
    STATE(2749), 2,
      sym_line_comment,
      sym_block_comment,
  [82431] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2750), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5918), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [82447] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5920), 1,
      anon_sym_SEMI,
    ACTIONS(5922), 1,
      anon_sym_EQ,
    STATE(2751), 2,
      sym_line_comment,
      sym_block_comment,
  [82467] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2752), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4798), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [82483] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2753), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4784), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [82499] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5924), 1,
      anon_sym_RPAREN,
    ACTIONS(5926), 1,
      anon_sym_COMMA,
    STATE(3001), 1,
      aux_sym_ordered_field_declaration_list_repeat1,
    STATE(2754), 2,
      sym_line_comment,
      sym_block_comment,
  [82519] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(985), 1,
      anon_sym_RBRACK,
    ACTIONS(4071), 1,
      anon_sym_COMMA,
    STATE(2710), 1,
      aux_sym_arguments_repeat1,
    STATE(2755), 2,
      sym_line_comment,
      sym_block_comment,
  [82539] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2756), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5928), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [82555] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3007), 1,
      anon_sym_RBRACK,
    ACTIONS(5930), 1,
      anon_sym_COMMA,
    STATE(2615), 1,
      aux_sym_slice_pattern_repeat1,
    STATE(2757), 2,
      sym_line_comment,
      sym_block_comment,
  [82575] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2931), 1,
      anon_sym_RPAREN,
    ACTIONS(5932), 1,
      anon_sym_COMMA,
    STATE(2922), 1,
      aux_sym_tuple_pattern_repeat1,
    STATE(2758), 2,
      sym_line_comment,
      sym_block_comment,
  [82595] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2759), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5934), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [82611] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3017), 1,
      anon_sym_RBRACK,
    ACTIONS(5936), 1,
      anon_sym_COMMA,
    STATE(2615), 1,
      aux_sym_slice_pattern_repeat1,
    STATE(2760), 2,
      sym_line_comment,
      sym_block_comment,
  [82631] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4947), 1,
      anon_sym_RBRACE,
    ACTIONS(5870), 1,
      anon_sym_COMMA,
    STATE(3005), 1,
      aux_sym_field_declaration_list_repeat1,
    STATE(2761), 2,
      sym_line_comment,
      sym_block_comment,
  [82651] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5938), 1,
      sym_identifier,
    ACTIONS(5940), 2,
      anon_sym_default,
      anon_sym_union,
    STATE(2762), 2,
      sym_line_comment,
      sym_block_comment,
  [82669] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5944), 1,
      anon_sym_COLON,
    ACTIONS(5942), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2763), 2,
      sym_line_comment,
      sym_block_comment,
  [82687] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2764), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5946), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [82703] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5852), 1,
      anon_sym_GT,
    ACTIONS(5948), 1,
      anon_sym_COMMA,
    STATE(2765), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_type_parameters_repeat1,
  [82721] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2766), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5951), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [82737] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5953), 1,
      anon_sym_RBRACE,
    ACTIONS(5955), 1,
      anon_sym_COMMA,
    STATE(2875), 1,
      aux_sym_struct_pattern_repeat1,
    STATE(2767), 2,
      sym_line_comment,
      sym_block_comment,
  [82757] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3299), 1,
      anon_sym_LBRACE,
    ACTIONS(5957), 1,
      anon_sym_COLON_COLON,
    STATE(1145), 1,
      sym_field_initializer_list,
    STATE(2768), 2,
      sym_line_comment,
      sym_block_comment,
  [82777] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4307), 1,
      anon_sym_RBRACE,
    ACTIONS(5959), 1,
      anon_sym_COMMA,
    STATE(2808), 1,
      aux_sym_use_list_repeat1,
    STATE(2769), 2,
      sym_line_comment,
      sym_block_comment,
  [82797] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2770), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5961), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [82813] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5963), 1,
      anon_sym_RBRACE,
    ACTIONS(5965), 1,
      anon_sym_COMMA,
    STATE(2879), 1,
      aux_sym_struct_pattern_repeat1,
    STATE(2771), 2,
      sym_line_comment,
      sym_block_comment,
  [82833] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2933), 1,
      anon_sym_RPAREN,
    ACTIONS(5967), 1,
      anon_sym_COMMA,
    STATE(2922), 1,
      aux_sym_tuple_pattern_repeat1,
    STATE(2772), 2,
      sym_line_comment,
      sym_block_comment,
  [82853] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3133), 1,
      anon_sym_RPAREN,
    ACTIONS(5969), 1,
      anon_sym_COMMA,
    STATE(3016), 1,
      aux_sym_tuple_type_repeat1,
    STATE(2773), 2,
      sym_line_comment,
      sym_block_comment,
  [82873] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2774), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4822), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [82889] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2775), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4830), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [82905] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2776), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4746), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [82921] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5971), 1,
      anon_sym_LPAREN,
    ACTIONS(5973), 1,
      anon_sym_LBRACK,
    ACTIONS(5975), 1,
      anon_sym_LBRACE,
    STATE(2777), 2,
      sym_line_comment,
      sym_block_comment,
  [82941] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5413), 1,
      anon_sym_RPAREN,
    ACTIONS(5415), 1,
      anon_sym_COMMA,
    STATE(2884), 1,
      aux_sym_parameters_repeat1,
    STATE(2778), 2,
      sym_line_comment,
      sym_block_comment,
  [82961] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(5977), 1,
      anon_sym_SEMI,
    STATE(3382), 1,
      sym_where_clause,
    STATE(2779), 2,
      sym_line_comment,
      sym_block_comment,
  [82981] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1003), 1,
      anon_sym_RBRACK,
    ACTIONS(4053), 1,
      anon_sym_COMMA,
    STATE(2710), 1,
      aux_sym_arguments_repeat1,
    STATE(2780), 2,
      sym_line_comment,
      sym_block_comment,
  [83001] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2781), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4714), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [83017] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5979), 1,
      anon_sym_LPAREN,
    ACTIONS(5981), 1,
      anon_sym_LBRACK,
    ACTIONS(5983), 1,
      anon_sym_LBRACE,
    STATE(2782), 2,
      sym_line_comment,
      sym_block_comment,
  [83037] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    ACTIONS(5985), 1,
      anon_sym_SEMI,
    STATE(606), 1,
      sym_declaration_list,
    STATE(2783), 2,
      sym_line_comment,
      sym_block_comment,
  [83057] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5666), 1,
      anon_sym_EQ,
    ACTIONS(5852), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    STATE(2784), 2,
      sym_line_comment,
      sym_block_comment,
  [83075] = 6,
    ACTIONS(27), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5987), 1,
      anon_sym_move,
    STATE(236), 1,
      sym_closure_parameters,
    STATE(2785), 2,
      sym_line_comment,
      sym_block_comment,
  [83095] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(5989), 1,
      anon_sym_for,
    STATE(1923), 1,
      sym_type_arguments,
    STATE(2786), 2,
      sym_line_comment,
      sym_block_comment,
  [83115] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5991), 1,
      anon_sym_SEMI,
    ACTIONS(5993), 1,
      anon_sym_EQ,
    STATE(2787), 2,
      sym_line_comment,
      sym_block_comment,
  [83135] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    ACTIONS(5995), 1,
      anon_sym_SEMI,
    STATE(1296), 1,
      sym_declaration_list,
    STATE(2788), 2,
      sym_line_comment,
      sym_block_comment,
  [83155] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5403), 1,
      anon_sym_COMMA,
    ACTIONS(5997), 1,
      anon_sym_PIPE,
    STATE(2906), 1,
      aux_sym_closure_parameters_repeat1,
    STATE(2789), 2,
      sym_line_comment,
      sym_block_comment,
  [83175] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5999), 1,
      anon_sym_SEMI,
    ACTIONS(6001), 1,
      anon_sym_EQ,
    STATE(2790), 2,
      sym_line_comment,
      sym_block_comment,
  [83195] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(993), 1,
      anon_sym_RPAREN,
    ACTIONS(4047), 1,
      anon_sym_COMMA,
    STATE(2710), 1,
      aux_sym_arguments_repeat1,
    STATE(2791), 2,
      sym_line_comment,
      sym_block_comment,
  [83215] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6003), 1,
      anon_sym_RBRACE,
    ACTIONS(6005), 1,
      anon_sym_COMMA,
    STATE(2890), 1,
      aux_sym_enum_variant_list_repeat2,
    STATE(2792), 2,
      sym_line_comment,
      sym_block_comment,
  [83235] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    ACTIONS(6007), 1,
      anon_sym_SEMI,
    STATE(489), 1,
      sym_declaration_list,
    STATE(2793), 2,
      sym_line_comment,
      sym_block_comment,
  [83255] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(6009), 1,
      anon_sym_for,
    STATE(1923), 1,
      sym_type_arguments,
    STATE(2794), 2,
      sym_line_comment,
      sym_block_comment,
  [83275] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2795), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4826), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [83291] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    ACTIONS(6011), 1,
      anon_sym_SEMI,
    STATE(706), 1,
      sym_declaration_list,
    STATE(2796), 2,
      sym_line_comment,
      sym_block_comment,
  [83311] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(4806), 1,
      anon_sym_LBRACE,
    STATE(1923), 1,
      sym_type_arguments,
    STATE(2797), 2,
      sym_line_comment,
      sym_block_comment,
  [83331] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2798), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4796), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [83347] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2799), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4794), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [83363] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5435), 1,
      anon_sym_GT,
    ACTIONS(5437), 1,
      anon_sym_COMMA,
    STATE(2803), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2800), 2,
      sym_line_comment,
      sym_block_comment,
  [83383] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4626), 1,
      anon_sym_GT,
    ACTIONS(6013), 1,
      anon_sym_COMMA,
    STATE(2765), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2801), 2,
      sym_line_comment,
      sym_block_comment,
  [83403] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(6015), 1,
      anon_sym_SEMI,
    STATE(3490), 1,
      sym_where_clause,
    STATE(2802), 2,
      sym_line_comment,
      sym_block_comment,
  [83423] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4640), 1,
      anon_sym_GT,
    ACTIONS(5441), 1,
      anon_sym_COMMA,
    STATE(2765), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2803), 2,
      sym_line_comment,
      sym_block_comment,
  [83443] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2804), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6017), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [83459] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4640), 1,
      anon_sym_GT,
    ACTIONS(5441), 1,
      anon_sym_COMMA,
    STATE(2900), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2805), 2,
      sym_line_comment,
      sym_block_comment,
  [83479] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2806), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4786), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [83495] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5301), 1,
      anon_sym_PLUS,
    ACTIONS(6019), 1,
      anon_sym_GT,
    ACTIONS(6021), 1,
      anon_sym_as,
    STATE(2807), 2,
      sym_line_comment,
      sym_block_comment,
  [83515] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6023), 1,
      anon_sym_RBRACE,
    ACTIONS(6025), 1,
      anon_sym_COMMA,
    STATE(2808), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_use_list_repeat1,
  [83533] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    ACTIONS(6028), 1,
      anon_sym_SEMI,
    STATE(1345), 1,
      sym_declaration_list,
    STATE(2809), 2,
      sym_line_comment,
      sym_block_comment,
  [83553] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6032), 1,
      anon_sym_EQ,
    ACTIONS(6030), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2810), 2,
      sym_line_comment,
      sym_block_comment,
  [83571] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2811), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4650), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [83587] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6034), 1,
      anon_sym_RBRACE,
    ACTIONS(6036), 1,
      anon_sym_COMMA,
    STATE(2761), 1,
      aux_sym_field_declaration_list_repeat1,
    STATE(2812), 2,
      sym_line_comment,
      sym_block_comment,
  [83607] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(6038), 1,
      anon_sym_SEMI,
    ACTIONS(6040), 1,
      anon_sym_EQ,
    STATE(2813), 2,
      sym_line_comment,
      sym_block_comment,
  [83627] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4243), 2,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
    STATE(2814), 2,
      sym_line_comment,
      sym_block_comment,
  [83645] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6042), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6044), 2,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
    STATE(2815), 2,
      sym_line_comment,
      sym_block_comment,
  [83663] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2816), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4782), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [83679] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2817), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4780), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [83695] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2818), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4788), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [83711] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(6046), 1,
      anon_sym_SEMI,
    ACTIONS(6048), 1,
      anon_sym_EQ,
    STATE(2819), 2,
      sym_line_comment,
      sym_block_comment,
  [83731] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2820), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6050), 3,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_QMARK,
  [83747] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2821), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4800), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [83763] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6052), 1,
      anon_sym_RBRACE,
    ACTIONS(6054), 1,
      anon_sym_COMMA,
    STATE(2912), 1,
      aux_sym_field_declaration_list_repeat1,
    STATE(2822), 2,
      sym_line_comment,
      sym_block_comment,
  [83783] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2823), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4816), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [83799] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(6056), 1,
      anon_sym_SEMI,
    STATE(3395), 1,
      sym_where_clause,
    STATE(2824), 2,
      sym_line_comment,
      sym_block_comment,
  [83819] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2825), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4820), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [83835] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2826), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4828), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [83851] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    ACTIONS(6058), 1,
      anon_sym_SEMI,
    STATE(570), 1,
      sym_declaration_list,
    STATE(2827), 2,
      sym_line_comment,
      sym_block_comment,
  [83871] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6060), 1,
      anon_sym_EQ_GT,
    ACTIONS(6062), 1,
      anon_sym_PIPE,
    ACTIONS(6064), 1,
      anon_sym_if,
    STATE(2828), 2,
      sym_line_comment,
      sym_block_comment,
  [83891] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4936), 1,
      anon_sym_RBRACE,
    ACTIONS(6066), 1,
      anon_sym_COMMA,
    STATE(2980), 1,
      aux_sym_enum_variant_list_repeat2,
    STATE(2829), 2,
      sym_line_comment,
      sym_block_comment,
  [83911] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2830), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4834), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [83927] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2831), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4812), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [83943] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6068), 1,
      anon_sym_RBRACE,
    ACTIONS(6070), 1,
      anon_sym_COMMA,
    STATE(2832), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_field_initializer_list_repeat1,
  [83961] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    ACTIONS(6073), 1,
      anon_sym_SEMI,
    STATE(1233), 1,
      sym_declaration_list,
    STATE(2833), 2,
      sym_line_comment,
      sym_block_comment,
  [83981] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2834), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4437), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [83997] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2835), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(765), 3,
      anon_sym_COLON,
      anon_sym_GT,
      anon_sym_COMMA,
  [84013] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2836), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6075), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [84029] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    ACTIONS(6077), 1,
      anon_sym_SEMI,
    STATE(515), 1,
      sym_declaration_list,
    STATE(2837), 2,
      sym_line_comment,
      sym_block_comment,
  [84049] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4768), 1,
      anon_sym_RBRACE,
    ACTIONS(6079), 1,
      anon_sym_COMMA,
    STATE(2832), 1,
      aux_sym_field_initializer_list_repeat1,
    STATE(2838), 2,
      sym_line_comment,
      sym_block_comment,
  [84069] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2839), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6081), 3,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_QMARK,
  [84085] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2840), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4844), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [84101] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2841), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4772), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [84117] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(6083), 1,
      anon_sym_SEMI,
    STATE(3428), 1,
      sym_where_clause,
    STATE(2842), 2,
      sym_line_comment,
      sym_block_comment,
  [84137] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2843), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4774), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [84153] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2844), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4776), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [84169] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6085), 1,
      anon_sym_RBRACE,
    ACTIONS(6087), 1,
      anon_sym_COMMA,
    STATE(2854), 1,
      aux_sym_enum_variant_list_repeat2,
    STATE(2845), 2,
      sym_line_comment,
      sym_block_comment,
  [84189] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2846), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4778), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [84205] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(6089), 1,
      anon_sym_SEMI,
    STATE(3557), 1,
      sym_where_clause,
    STATE(2847), 2,
      sym_line_comment,
      sym_block_comment,
  [84225] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2848), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6091), 3,
      sym_string_content,
      anon_sym_DQUOTE,
      sym_escape_sequence,
  [84241] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(6093), 1,
      anon_sym_for,
    STATE(1923), 1,
      sym_type_arguments,
    STATE(2849), 2,
      sym_line_comment,
      sym_block_comment,
  [84261] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(973), 1,
      anon_sym_RPAREN,
    ACTIONS(4067), 1,
      anon_sym_COMMA,
    STATE(2710), 1,
      aux_sym_arguments_repeat1,
    STATE(2850), 2,
      sym_line_comment,
      sym_block_comment,
  [84281] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(6095), 1,
      anon_sym_LBRACE,
    STATE(1923), 1,
      sym_type_arguments,
    STATE(2851), 2,
      sym_line_comment,
      sym_block_comment,
  [84301] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2852), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6097), 3,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_QMARK,
  [84317] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    ACTIONS(6099), 1,
      anon_sym_SEMI,
    STATE(634), 1,
      sym_declaration_list,
    STATE(2853), 2,
      sym_line_comment,
      sym_block_comment,
  [84337] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4936), 1,
      anon_sym_RBRACE,
    ACTIONS(6066), 1,
      anon_sym_COMMA,
    STATE(2978), 1,
      aux_sym_enum_variant_list_repeat2,
    STATE(2854), 2,
      sym_line_comment,
      sym_block_comment,
  [84357] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6101), 1,
      anon_sym_LPAREN,
    ACTIONS(6103), 1,
      anon_sym_LBRACK,
    ACTIONS(6105), 1,
      anon_sym_LBRACE,
    STATE(2855), 2,
      sym_line_comment,
      sym_block_comment,
  [84377] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6107), 1,
      anon_sym_LPAREN,
    ACTIONS(6109), 1,
      anon_sym_LBRACK,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(2856), 2,
      sym_line_comment,
      sym_block_comment,
  [84397] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    ACTIONS(6113), 1,
      anon_sym_SEMI,
    STATE(631), 1,
      sym_declaration_list,
    STATE(2857), 2,
      sym_line_comment,
      sym_block_comment,
  [84417] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3299), 1,
      anon_sym_LBRACE,
    ACTIONS(6115), 1,
      anon_sym_COLON_COLON,
    STATE(1145), 1,
      sym_field_initializer_list,
    STATE(2858), 2,
      sym_line_comment,
      sym_block_comment,
  [84437] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6117), 1,
      sym_identifier,
    ACTIONS(6119), 1,
      anon_sym_ref,
    ACTIONS(6121), 1,
      sym_mutable_specifier,
    STATE(2859), 2,
      sym_line_comment,
      sym_block_comment,
  [84457] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(6123), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2860), 2,
      sym_line_comment,
      sym_block_comment,
  [84475] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(6125), 1,
      anon_sym_SEMI,
    STATE(3343), 1,
      sym_where_clause,
    STATE(2861), 2,
      sym_line_comment,
      sym_block_comment,
  [84495] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4624), 1,
      anon_sym_GT,
    ACTIONS(5552), 1,
      anon_sym_COMMA,
    STATE(2733), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2862), 2,
      sym_line_comment,
      sym_block_comment,
  [84515] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2863), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6127), 3,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
  [84531] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4624), 1,
      anon_sym_GT,
    ACTIONS(5552), 1,
      anon_sym_COMMA,
    STATE(2765), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2864), 2,
      sym_line_comment,
      sym_block_comment,
  [84551] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4620), 1,
      anon_sym_GT,
    ACTIONS(6129), 1,
      anon_sym_COMMA,
    STATE(2765), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2865), 2,
      sym_line_comment,
      sym_block_comment,
  [84571] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1033), 1,
      anon_sym_RBRACK,
    ACTIONS(6131), 1,
      anon_sym_COMMA,
    STATE(2710), 1,
      aux_sym_arguments_repeat1,
    STATE(2866), 2,
      sym_line_comment,
      sym_block_comment,
  [84591] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2867), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6133), 3,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_COMMA,
  [84607] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2868), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(5405), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [84623] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4525), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4566), 1,
      anon_sym_COLON,
    STATE(2699), 1,
      sym_trait_bounds,
    STATE(2869), 2,
      sym_line_comment,
      sym_block_comment,
  [84643] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1594), 1,
      anon_sym_GT,
    ACTIONS(6135), 1,
      anon_sym_COMMA,
    STATE(2948), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2870), 2,
      sym_line_comment,
      sym_block_comment,
  [84663] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1594), 1,
      anon_sym_GT,
    ACTIONS(6135), 1,
      anon_sym_COMMA,
    STATE(2911), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2871), 2,
      sym_line_comment,
      sym_block_comment,
  [84683] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5451), 1,
      anon_sym_PIPE,
    ACTIONS(6137), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2872), 2,
      sym_line_comment,
      sym_block_comment,
  [84701] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2995), 1,
      anon_sym_RPAREN,
    ACTIONS(6139), 1,
      anon_sym_COMMA,
    STATE(2615), 1,
      aux_sym_slice_pattern_repeat1,
    STATE(2873), 2,
      sym_line_comment,
      sym_block_comment,
  [84721] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2874), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6141), 3,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_QMARK,
  [84737] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5107), 1,
      anon_sym_RBRACE,
    ACTIONS(6143), 1,
      anon_sym_COMMA,
    STATE(2936), 1,
      aux_sym_struct_pattern_repeat1,
    STATE(2875), 2,
      sym_line_comment,
      sym_block_comment,
  [84757] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(975), 1,
      anon_sym_RBRACK,
    ACTIONS(4039), 1,
      anon_sym_COMMA,
    STATE(2710), 1,
      aux_sym_arguments_repeat1,
    STATE(2876), 2,
      sym_line_comment,
      sym_block_comment,
  [84777] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3005), 1,
      anon_sym_RPAREN,
    ACTIONS(6145), 1,
      anon_sym_COMMA,
    STATE(2615), 1,
      aux_sym_slice_pattern_repeat1,
    STATE(2877), 2,
      sym_line_comment,
      sym_block_comment,
  [84797] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(6147), 1,
      anon_sym_COLON_COLON,
    STATE(1925), 1,
      sym_type_arguments,
    STATE(2878), 2,
      sym_line_comment,
      sym_block_comment,
  [84817] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5109), 1,
      anon_sym_RBRACE,
    ACTIONS(6149), 1,
      anon_sym_COMMA,
    STATE(2936), 1,
      aux_sym_struct_pattern_repeat1,
    STATE(2879), 2,
      sym_line_comment,
      sym_block_comment,
  [84837] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4566), 1,
      anon_sym_COLON,
    ACTIONS(4951), 1,
      anon_sym_COLON_COLON,
    STATE(2699), 1,
      sym_trait_bounds,
    STATE(2880), 2,
      sym_line_comment,
      sym_block_comment,
  [84857] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4856), 1,
      anon_sym_LT,
    ACTIONS(6151), 1,
      anon_sym_EQ,
    STATE(3342), 1,
      sym_type_parameters,
    STATE(2881), 2,
      sym_line_comment,
      sym_block_comment,
  [84877] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(6153), 1,
      anon_sym_SEMI,
    ACTIONS(6155), 1,
      anon_sym_EQ,
    STATE(2882), 2,
      sym_line_comment,
      sym_block_comment,
  [84897] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5696), 1,
      anon_sym_RPAREN,
    ACTIONS(5698), 1,
      anon_sym_COMMA,
    STATE(2772), 1,
      aux_sym_tuple_pattern_repeat1,
    STATE(2883), 2,
      sym_line_comment,
      sym_block_comment,
  [84917] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1466), 1,
      anon_sym_RPAREN,
    ACTIONS(5469), 1,
      anon_sym_COMMA,
    STATE(2950), 1,
      aux_sym_parameters_repeat1,
    STATE(2884), 2,
      sym_line_comment,
      sym_block_comment,
  [84937] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    ACTIONS(6157), 1,
      anon_sym_SEMI,
    STATE(654), 1,
      sym_declaration_list,
    STATE(2885), 2,
      sym_line_comment,
      sym_block_comment,
  [84957] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(989), 1,
      anon_sym_RPAREN,
    ACTIONS(6159), 1,
      anon_sym_COMMA,
    STATE(2710), 1,
      aux_sym_arguments_repeat1,
    STATE(2886), 2,
      sym_line_comment,
      sym_block_comment,
  [84977] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1466), 1,
      anon_sym_RPAREN,
    ACTIONS(5469), 1,
      anon_sym_COMMA,
    STATE(2956), 1,
      aux_sym_parameters_repeat1,
    STATE(2887), 2,
      sym_line_comment,
      sym_block_comment,
  [84997] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1025), 1,
      anon_sym_RBRACK,
    ACTIONS(6161), 1,
      anon_sym_COMMA,
    STATE(2710), 1,
      aux_sym_arguments_repeat1,
    STATE(2888), 2,
      sym_line_comment,
      sym_block_comment,
  [85017] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    ACTIONS(6163), 1,
      anon_sym_SEMI,
    STATE(503), 1,
      sym_declaration_list,
    STATE(2889), 2,
      sym_line_comment,
      sym_block_comment,
  [85037] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4876), 1,
      anon_sym_RBRACE,
    ACTIONS(6165), 1,
      anon_sym_COMMA,
    STATE(2978), 1,
      aux_sym_enum_variant_list_repeat2,
    STATE(2890), 2,
      sym_line_comment,
      sym_block_comment,
  [85057] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4876), 1,
      anon_sym_RBRACE,
    ACTIONS(6165), 1,
      anon_sym_COMMA,
    STATE(2959), 1,
      aux_sym_enum_variant_list_repeat2,
    STATE(2891), 2,
      sym_line_comment,
      sym_block_comment,
  [85077] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    ACTIONS(6167), 1,
      anon_sym_SEMI,
    STATE(505), 1,
      sym_declaration_list,
    STATE(2892), 2,
      sym_line_comment,
      sym_block_comment,
  [85097] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    ACTIONS(6169), 1,
      anon_sym_SEMI,
    STATE(518), 1,
      sym_declaration_list,
    STATE(2893), 2,
      sym_line_comment,
      sym_block_comment,
  [85117] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6171), 1,
      sym_identifier,
    ACTIONS(6173), 1,
      anon_sym_await,
    ACTIONS(6175), 1,
      sym_integer_literal,
    STATE(2894), 2,
      sym_line_comment,
      sym_block_comment,
  [85137] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2895), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(4744), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [85153] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(6177), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    STATE(2896), 2,
      sym_line_comment,
      sym_block_comment,
  [85171] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(6179), 1,
      anon_sym_SEMI,
    ACTIONS(6181), 1,
      anon_sym_EQ,
    STATE(2897), 2,
      sym_line_comment,
      sym_block_comment,
  [85191] = 6,
    ACTIONS(27), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6183), 1,
      anon_sym_move,
    STATE(218), 1,
      sym_closure_parameters,
    STATE(2898), 2,
      sym_line_comment,
      sym_block_comment,
  [85211] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4628), 1,
      anon_sym_GT,
    ACTIONS(6185), 1,
      anon_sym_COMMA,
    STATE(2765), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2899), 2,
      sym_line_comment,
      sym_block_comment,
  [85231] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4630), 1,
      anon_sym_GT,
    ACTIONS(6187), 1,
      anon_sym_COMMA,
    STATE(2765), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2900), 2,
      sym_line_comment,
      sym_block_comment,
  [85251] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    ACTIONS(6189), 1,
      anon_sym_SEMI,
    STATE(1254), 1,
      sym_declaration_list,
    STATE(2901), 2,
      sym_line_comment,
      sym_block_comment,
  [85271] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2902), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1424), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_if,
  [85287] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6193), 1,
      anon_sym_COLON,
    ACTIONS(6191), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2903), 2,
      sym_line_comment,
      sym_block_comment,
  [85305] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    ACTIONS(6195), 1,
      anon_sym_SEMI,
    STATE(1117), 1,
      sym_declaration_list,
    STATE(2904), 2,
      sym_line_comment,
      sym_block_comment,
  [85325] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5399), 1,
      anon_sym_COLON,
    ACTIONS(6197), 2,
      anon_sym_PIPE,
      anon_sym_COMMA,
    STATE(2905), 2,
      sym_line_comment,
      sym_block_comment,
  [85343] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5403), 1,
      anon_sym_COMMA,
    ACTIONS(6199), 1,
      anon_sym_PIPE,
    STATE(2917), 1,
      aux_sym_closure_parameters_repeat1,
    STATE(2906), 2,
      sym_line_comment,
      sym_block_comment,
  [85363] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5451), 1,
      anon_sym_PIPE,
    ACTIONS(6201), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2907), 2,
      sym_line_comment,
      sym_block_comment,
  [85381] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6203), 1,
      anon_sym_RPAREN,
    ACTIONS(6205), 1,
      anon_sym_COMMA,
    STATE(3001), 1,
      aux_sym_ordered_field_declaration_list_repeat1,
    STATE(2908), 2,
      sym_line_comment,
      sym_block_comment,
  [85401] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(6207), 1,
      anon_sym_SEMI,
    ACTIONS(6209), 1,
      anon_sym_EQ,
    STATE(2909), 2,
      sym_line_comment,
      sym_block_comment,
  [85421] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1590), 1,
      anon_sym_GT,
    ACTIONS(6211), 1,
      anon_sym_COMMA,
    STATE(2911), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2910), 2,
      sym_line_comment,
      sym_block_comment,
  [85441] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5481), 1,
      anon_sym_GT,
    ACTIONS(6213), 1,
      anon_sym_COMMA,
    STATE(2911), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_type_arguments_repeat1,
  [85459] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4890), 1,
      anon_sym_RBRACE,
    ACTIONS(6216), 1,
      anon_sym_COMMA,
    STATE(3005), 1,
      aux_sym_field_declaration_list_repeat1,
    STATE(2912), 2,
      sym_line_comment,
      sym_block_comment,
  [85479] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4890), 1,
      anon_sym_RBRACE,
    ACTIONS(6216), 1,
      anon_sym_COMMA,
    STATE(2976), 1,
      aux_sym_field_declaration_list_repeat1,
    STATE(2913), 2,
      sym_line_comment,
      sym_block_comment,
  [85499] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(6218), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2914), 2,
      sym_line_comment,
      sym_block_comment,
  [85517] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3953), 1,
      anon_sym_LBRACE,
    ACTIONS(6220), 1,
      anon_sym_COLON_COLON,
    STATE(1741), 1,
      sym_field_initializer_list,
    STATE(2915), 2,
      sym_line_comment,
      sym_block_comment,
  [85537] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(6222), 1,
      anon_sym_SEMI,
    ACTIONS(6224), 1,
      anon_sym_RBRACK,
    STATE(2916), 2,
      sym_line_comment,
      sym_block_comment,
  [85557] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6197), 1,
      anon_sym_PIPE,
    ACTIONS(6226), 1,
      anon_sym_COMMA,
    STATE(2917), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_closure_parameters_repeat1,
  [85575] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    ACTIONS(6229), 1,
      anon_sym_SEMI,
    STATE(1183), 1,
      sym_declaration_list,
    STATE(2918), 2,
      sym_line_comment,
      sym_block_comment,
  [85595] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(4951), 1,
      anon_sym_COLON_COLON,
    STATE(1925), 1,
      sym_type_arguments,
    STATE(2919), 2,
      sym_line_comment,
      sym_block_comment,
  [85615] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3931), 1,
      anon_sym_LT2,
    ACTIONS(4909), 1,
      anon_sym_COLON_COLON,
    STATE(1616), 1,
      sym_type_arguments,
    STATE(2920), 2,
      sym_line_comment,
      sym_block_comment,
  [85635] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6231), 1,
      anon_sym_GT,
    ACTIONS(6233), 1,
      anon_sym_COMMA,
    STATE(2967), 1,
      aux_sym_for_lifetimes_repeat1,
    STATE(2921), 2,
      sym_line_comment,
      sym_block_comment,
  [85655] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6201), 1,
      anon_sym_RPAREN,
    ACTIONS(6235), 1,
      anon_sym_COMMA,
    STATE(2922), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_tuple_pattern_repeat1,
  [85673] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6240), 1,
      anon_sym_COLON,
    ACTIONS(6238), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2923), 2,
      sym_line_comment,
      sym_block_comment,
  [85691] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5451), 1,
      anon_sym_PIPE,
    ACTIONS(6242), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2924), 2,
      sym_line_comment,
      sym_block_comment,
  [85709] = 6,
    ACTIONS(27), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6244), 1,
      anon_sym_move,
    STATE(224), 1,
      sym_closure_parameters,
    STATE(2925), 2,
      sym_line_comment,
      sym_block_comment,
  [85729] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(6246), 1,
      anon_sym_SEMI,
    ACTIONS(6248), 1,
      anon_sym_EQ,
    STATE(2926), 2,
      sym_line_comment,
      sym_block_comment,
  [85749] = 6,
    ACTIONS(27), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6250), 1,
      anon_sym_move,
    STATE(215), 1,
      sym_closure_parameters,
    STATE(2927), 2,
      sym_line_comment,
      sym_block_comment,
  [85769] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6252), 1,
      anon_sym_GT,
    ACTIONS(6254), 1,
      anon_sym_COMMA,
    STATE(2921), 1,
      aux_sym_for_lifetimes_repeat1,
    STATE(2928), 2,
      sym_line_comment,
      sym_block_comment,
  [85789] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(6256), 1,
      anon_sym_SEMI,
    STATE(3550), 1,
      sym_where_clause,
    STATE(2929), 2,
      sym_line_comment,
      sym_block_comment,
  [85809] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1462), 1,
      anon_sym_RPAREN,
    ACTIONS(6258), 1,
      anon_sym_COMMA,
    STATE(2950), 1,
      aux_sym_parameters_repeat1,
    STATE(2930), 2,
      sym_line_comment,
      sym_block_comment,
  [85829] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    ACTIONS(6260), 1,
      anon_sym_SEMI,
    STATE(528), 1,
      sym_declaration_list,
    STATE(2931), 2,
      sym_line_comment,
      sym_block_comment,
  [85849] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1596), 1,
      anon_sym_GT,
    ACTIONS(6262), 1,
      anon_sym_COMMA,
    STATE(2911), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2932), 2,
      sym_line_comment,
      sym_block_comment,
  [85869] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    ACTIONS(6264), 1,
      anon_sym_SEMI,
    STATE(539), 1,
      sym_declaration_list,
    STATE(2933), 2,
      sym_line_comment,
      sym_block_comment,
  [85889] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(6266), 1,
      anon_sym_SEMI,
    ACTIONS(6268), 1,
      anon_sym_RBRACK,
    STATE(2934), 2,
      sym_line_comment,
      sym_block_comment,
  [85909] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1458), 1,
      anon_sym_RPAREN,
    ACTIONS(5343), 1,
      anon_sym_COMMA,
    STATE(2930), 1,
      aux_sym_parameters_repeat1,
    STATE(2935), 2,
      sym_line_comment,
      sym_block_comment,
  [85929] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6270), 1,
      anon_sym_RBRACE,
    ACTIONS(6272), 1,
      anon_sym_COMMA,
    STATE(2936), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_struct_pattern_repeat1,
  [85947] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4519), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5242), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2937), 2,
      sym_line_comment,
      sym_block_comment,
  [85965] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1035), 1,
      anon_sym_RPAREN,
    ACTIONS(6275), 1,
      anon_sym_COMMA,
    STATE(2710), 1,
      aux_sym_arguments_repeat1,
    STATE(2938), 2,
      sym_line_comment,
      sym_block_comment,
  [85985] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4690), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4836), 1,
      anon_sym_BANG,
    ACTIONS(6277), 1,
      sym_identifier,
    STATE(2939), 2,
      sym_line_comment,
      sym_block_comment,
  [86005] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6279), 1,
      sym_identifier,
    ACTIONS(6281), 1,
      anon_sym_ref,
    ACTIONS(6283), 1,
      sym_mutable_specifier,
    STATE(2940), 2,
      sym_line_comment,
      sym_block_comment,
  [86025] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2945), 1,
      anon_sym_SQUOTE,
    ACTIONS(6231), 1,
      anon_sym_GT,
    STATE(3239), 1,
      sym_lifetime,
    STATE(2941), 2,
      sym_line_comment,
      sym_block_comment,
  [86045] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1458), 1,
      anon_sym_RPAREN,
    ACTIONS(5343), 1,
      anon_sym_COMMA,
    STATE(2950), 1,
      aux_sym_parameters_repeat1,
    STATE(2942), 2,
      sym_line_comment,
      sym_block_comment,
  [86065] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1600), 1,
      anon_sym_GT,
    ACTIONS(6285), 1,
      anon_sym_COMMA,
    STATE(2911), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2943), 2,
      sym_line_comment,
      sym_block_comment,
  [86085] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1600), 1,
      anon_sym_GT,
    ACTIONS(6285), 1,
      anon_sym_COMMA,
    STATE(2932), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2944), 2,
      sym_line_comment,
      sym_block_comment,
  [86105] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(6287), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2945), 2,
      sym_line_comment,
      sym_block_comment,
  [86123] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3035), 1,
      anon_sym_PLUS,
    ACTIONS(6289), 1,
      sym_mutable_specifier,
    ACTIONS(6291), 1,
      sym_self,
    STATE(2946), 2,
      sym_line_comment,
      sym_block_comment,
  [86143] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5811), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2947), 2,
      sym_line_comment,
      sym_block_comment,
  [86161] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1586), 1,
      anon_sym_GT,
    ACTIONS(6293), 1,
      anon_sym_COMMA,
    STATE(2911), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2948), 2,
      sym_line_comment,
      sym_block_comment,
  [86181] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6295), 1,
      anon_sym_RBRACE,
    ACTIONS(6297), 1,
      anon_sym_COMMA,
    STATE(2732), 1,
      aux_sym_field_initializer_list_repeat1,
    STATE(2949), 2,
      sym_line_comment,
      sym_block_comment,
  [86201] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5811), 1,
      anon_sym_RPAREN,
    ACTIONS(6299), 1,
      anon_sym_COMMA,
    STATE(2950), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_parameters_repeat1,
  [86219] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6304), 1,
      anon_sym_COLON,
    ACTIONS(6302), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2951), 2,
      sym_line_comment,
      sym_block_comment,
  [86237] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4433), 1,
      anon_sym_LT2,
    ACTIONS(4878), 1,
      anon_sym_for,
    STATE(1923), 1,
      sym_type_arguments,
    STATE(2952), 2,
      sym_line_comment,
      sym_block_comment,
  [86257] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(5739), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2953), 2,
      sym_line_comment,
      sym_block_comment,
  [86275] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5377), 1,
      anon_sym_RPAREN,
    ACTIONS(5379), 1,
      anon_sym_COMMA,
    STATE(2942), 1,
      aux_sym_parameters_repeat1,
    STATE(2954), 2,
      sym_line_comment,
      sym_block_comment,
  [86295] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5425), 1,
      anon_sym_RPAREN,
    ACTIONS(5427), 1,
      anon_sym_COMMA,
    STATE(3015), 1,
      aux_sym_parameters_repeat1,
    STATE(2955), 2,
      sym_line_comment,
      sym_block_comment,
  [86315] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1472), 1,
      anon_sym_RPAREN,
    ACTIONS(6306), 1,
      anon_sym_COMMA,
    STATE(2950), 1,
      aux_sym_parameters_repeat1,
    STATE(2956), 2,
      sym_line_comment,
      sym_block_comment,
  [86335] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3135), 1,
      anon_sym_RPAREN,
    ACTIONS(6308), 1,
      anon_sym_COMMA,
    STATE(3016), 1,
      aux_sym_tuple_type_repeat1,
    STATE(2957), 2,
      sym_line_comment,
      sym_block_comment,
  [86355] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1460), 1,
      anon_sym_RPAREN,
    ACTIONS(6310), 1,
      anon_sym_COMMA,
    STATE(2950), 1,
      aux_sym_parameters_repeat1,
    STATE(2958), 2,
      sym_line_comment,
      sym_block_comment,
  [86375] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4880), 1,
      anon_sym_RBRACE,
    ACTIONS(6312), 1,
      anon_sym_COMMA,
    STATE(2978), 1,
      aux_sym_enum_variant_list_repeat2,
    STATE(2959), 2,
      sym_line_comment,
      sym_block_comment,
  [86395] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5297), 1,
      anon_sym_GT,
    ACTIONS(5299), 1,
      anon_sym_COMMA,
    STATE(2864), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2960), 2,
      sym_line_comment,
      sym_block_comment,
  [86415] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4519), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6314), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(2961), 2,
      sym_line_comment,
      sym_block_comment,
  [86433] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    ACTIONS(6316), 1,
      anon_sym_SEMI,
    STATE(1156), 1,
      sym_declaration_list,
    STATE(2962), 2,
      sym_line_comment,
      sym_block_comment,
  [86453] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    ACTIONS(6318), 1,
      anon_sym_SEMI,
    STATE(1187), 1,
      sym_declaration_list,
    STATE(2963), 2,
      sym_line_comment,
      sym_block_comment,
  [86473] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    ACTIONS(6320), 1,
      anon_sym_SEMI,
    STATE(729), 1,
      sym_declaration_list,
    STATE(2964), 2,
      sym_line_comment,
      sym_block_comment,
  [86493] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5451), 1,
      anon_sym_PIPE,
    ACTIONS(6322), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2965), 2,
      sym_line_comment,
      sym_block_comment,
  [86511] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2945), 1,
      anon_sym_SQUOTE,
    ACTIONS(6324), 1,
      anon_sym_GT,
    STATE(3239), 1,
      sym_lifetime,
    STATE(2966), 2,
      sym_line_comment,
      sym_block_comment,
  [86531] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6326), 1,
      anon_sym_GT,
    ACTIONS(6328), 1,
      anon_sym_COMMA,
    STATE(2967), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_for_lifetimes_repeat1,
  [86549] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    ACTIONS(6331), 1,
      anon_sym_SEMI,
    STATE(1207), 1,
      sym_declaration_list,
    STATE(2968), 2,
      sym_line_comment,
      sym_block_comment,
  [86569] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    ACTIONS(6333), 1,
      anon_sym_SEMI,
    STATE(1212), 1,
      sym_declaration_list,
    STATE(2969), 2,
      sym_line_comment,
      sym_block_comment,
  [86589] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1570), 1,
      anon_sym_GT,
    ACTIONS(6335), 1,
      anon_sym_COMMA,
    STATE(2910), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2970), 2,
      sym_line_comment,
      sym_block_comment,
  [86609] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1570), 1,
      anon_sym_GT,
    ACTIONS(6335), 1,
      anon_sym_COMMA,
    STATE(2911), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2971), 2,
      sym_line_comment,
      sym_block_comment,
  [86629] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3023), 1,
      anon_sym_RPAREN,
    ACTIONS(6337), 1,
      anon_sym_COMMA,
    STATE(2615), 1,
      aux_sym_slice_pattern_repeat1,
    STATE(2972), 2,
      sym_line_comment,
      sym_block_comment,
  [86649] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(6339), 1,
      anon_sym_SEMI,
    ACTIONS(6341), 1,
      anon_sym_EQ,
    STATE(2973), 2,
      sym_line_comment,
      sym_block_comment,
  [86669] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    ACTIONS(6343), 1,
      anon_sym_SEMI,
    STATE(1214), 1,
      sym_declaration_list,
    STATE(2974), 2,
      sym_line_comment,
      sym_block_comment,
  [86689] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3235), 1,
      anon_sym_LT2,
    ACTIONS(4938), 1,
      anon_sym_COLON_COLON,
    STATE(1086), 1,
      sym_type_arguments,
    STATE(2975), 2,
      sym_line_comment,
      sym_block_comment,
  [86709] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4907), 1,
      anon_sym_RBRACE,
    ACTIONS(6345), 1,
      anon_sym_COMMA,
    STATE(3005), 1,
      aux_sym_field_declaration_list_repeat1,
    STATE(2976), 2,
      sym_line_comment,
      sym_block_comment,
  [86729] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(6347), 1,
      anon_sym_SEMI,
    ACTIONS(6349), 1,
      anon_sym_RBRACK,
    STATE(2977), 2,
      sym_line_comment,
      sym_block_comment,
  [86749] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6351), 1,
      anon_sym_RBRACE,
    ACTIONS(6353), 1,
      anon_sym_COMMA,
    STATE(2978), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_enum_variant_list_repeat2,
  [86767] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6358), 1,
      anon_sym_EQ,
    ACTIONS(6356), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2979), 2,
      sym_line_comment,
      sym_block_comment,
  [86785] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4846), 1,
      anon_sym_RBRACE,
    ACTIONS(6360), 1,
      anon_sym_COMMA,
    STATE(2978), 1,
      aux_sym_enum_variant_list_repeat2,
    STATE(2980), 2,
      sym_line_comment,
      sym_block_comment,
  [86805] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    ACTIONS(6362), 1,
      anon_sym_SEMI,
    STATE(617), 1,
      sym_declaration_list,
    STATE(2981), 2,
      sym_line_comment,
      sym_block_comment,
  [86825] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    ACTIONS(6364), 1,
      anon_sym_SEMI,
    STATE(615), 1,
      sym_declaration_list,
    STATE(2982), 2,
      sym_line_comment,
      sym_block_comment,
  [86845] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(6366), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    STATE(2983), 2,
      sym_line_comment,
      sym_block_comment,
  [86863] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5666), 1,
      anon_sym_EQ,
    ACTIONS(5788), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    STATE(2984), 2,
      sym_line_comment,
      sym_block_comment,
  [86881] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2985), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6368), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [86897] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6370), 1,
      anon_sym_RBRACE,
    ACTIONS(6372), 1,
      anon_sym_COMMA,
    STATE(2769), 1,
      aux_sym_use_list_repeat1,
    STATE(2986), 2,
      sym_line_comment,
      sym_block_comment,
  [86917] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    ACTIONS(6374), 1,
      anon_sym_SEMI,
    STATE(602), 1,
      sym_declaration_list,
    STATE(2987), 2,
      sym_line_comment,
      sym_block_comment,
  [86937] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    ACTIONS(6376), 1,
      anon_sym_SEMI,
    STATE(600), 1,
      sym_declaration_list,
    STATE(2988), 2,
      sym_line_comment,
      sym_block_comment,
  [86957] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    ACTIONS(6378), 1,
      anon_sym_SEMI,
    STATE(1452), 1,
      sym_declaration_list,
    STATE(2989), 2,
      sym_line_comment,
      sym_block_comment,
  [86977] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    ACTIONS(6380), 1,
      anon_sym_SEMI,
    STATE(1446), 1,
      sym_declaration_list,
    STATE(2990), 2,
      sym_line_comment,
      sym_block_comment,
  [86997] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(2991), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6382), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [87013] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5790), 1,
      anon_sym_RPAREN,
    ACTIONS(5792), 1,
      anon_sym_COMMA,
    STATE(2758), 1,
      aux_sym_tuple_pattern_repeat1,
    STATE(2992), 2,
      sym_line_comment,
      sym_block_comment,
  [87033] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    ACTIONS(6384), 1,
      anon_sym_SEMI,
    STATE(1420), 1,
      sym_declaration_list,
    STATE(2993), 2,
      sym_line_comment,
      sym_block_comment,
  [87053] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    ACTIONS(6386), 1,
      anon_sym_SEMI,
    STATE(1418), 1,
      sym_declaration_list,
    STATE(2994), 2,
      sym_line_comment,
      sym_block_comment,
  [87073] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    ACTIONS(6388), 1,
      anon_sym_SEMI,
    STATE(1397), 1,
      sym_declaration_list,
    STATE(2995), 2,
      sym_line_comment,
      sym_block_comment,
  [87093] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    ACTIONS(6390), 1,
      anon_sym_SEMI,
    STATE(1388), 1,
      sym_declaration_list,
    STATE(2996), 2,
      sym_line_comment,
      sym_block_comment,
  [87113] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(6392), 1,
      anon_sym_SEMI,
    ACTIONS(6394), 1,
      anon_sym_EQ,
    STATE(2997), 2,
      sym_line_comment,
      sym_block_comment,
  [87133] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(6396), 1,
      anon_sym_SEMI,
    ACTIONS(6398), 1,
      anon_sym_EQ,
    STATE(2998), 2,
      sym_line_comment,
      sym_block_comment,
  [87153] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6400), 1,
      anon_sym_RPAREN,
    ACTIONS(6402), 1,
      anon_sym_COMMA,
    STATE(3001), 1,
      aux_sym_ordered_field_declaration_list_repeat1,
    STATE(2999), 2,
      sym_line_comment,
      sym_block_comment,
  [87173] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(6404), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(3000), 2,
      sym_line_comment,
      sym_block_comment,
  [87191] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6406), 1,
      anon_sym_RPAREN,
    ACTIONS(6408), 1,
      anon_sym_COMMA,
    STATE(3001), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_ordered_field_declaration_list_repeat1,
  [87209] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    ACTIONS(6411), 1,
      anon_sym_SEMI,
    STATE(1360), 1,
      sym_declaration_list,
    STATE(3002), 2,
      sym_line_comment,
      sym_block_comment,
  [87229] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    ACTIONS(6413), 1,
      anon_sym_SEMI,
    STATE(1368), 1,
      sym_declaration_list,
    STATE(3003), 2,
      sym_line_comment,
      sym_block_comment,
  [87249] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(6415), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(3004), 2,
      sym_line_comment,
      sym_block_comment,
  [87267] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6417), 1,
      anon_sym_RBRACE,
    ACTIONS(6419), 1,
      anon_sym_COMMA,
    STATE(3005), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_field_declaration_list_repeat1,
  [87285] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4886), 1,
      anon_sym_RBRACE,
    ACTIONS(6422), 1,
      anon_sym_COMMA,
    STATE(3005), 1,
      aux_sym_field_declaration_list_repeat1,
    STATE(3006), 2,
      sym_line_comment,
      sym_block_comment,
  [87305] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1013), 1,
      anon_sym_RBRACK,
    ACTIONS(4005), 1,
      anon_sym_COMMA,
    STATE(2710), 1,
      aux_sym_arguments_repeat1,
    STATE(3007), 2,
      sym_line_comment,
      sym_block_comment,
  [87325] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6424), 1,
      anon_sym_RBRACE,
    ACTIONS(6426), 1,
      anon_sym_COMMA,
    STATE(3018), 1,
      aux_sym_struct_pattern_repeat1,
    STATE(3008), 2,
      sym_line_comment,
      sym_block_comment,
  [87345] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1454), 1,
      anon_sym_RPAREN,
    ACTIONS(5419), 1,
      anon_sym_COMMA,
    STATE(2958), 1,
      aux_sym_parameters_repeat1,
    STATE(3009), 2,
      sym_line_comment,
      sym_block_comment,
  [87365] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3151), 1,
      anon_sym_RPAREN,
    ACTIONS(6428), 1,
      anon_sym_COMMA,
    STATE(3016), 1,
      aux_sym_tuple_type_repeat1,
    STATE(3010), 2,
      sym_line_comment,
      sym_block_comment,
  [87385] = 6,
    ACTIONS(27), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6430), 1,
      anon_sym_move,
    STATE(217), 1,
      sym_closure_parameters,
    STATE(3011), 2,
      sym_line_comment,
      sym_block_comment,
  [87405] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(3012), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(6432), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [87421] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6434), 1,
      sym_identifier,
    ACTIONS(6436), 1,
      anon_sym_await,
    ACTIONS(6438), 1,
      sym_integer_literal,
    STATE(3013), 2,
      sym_line_comment,
      sym_block_comment,
  [87441] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4858), 1,
      anon_sym_where,
    ACTIONS(6440), 1,
      anon_sym_SEMI,
    STATE(3420), 1,
      sym_where_clause,
    STATE(3014), 2,
      sym_line_comment,
      sym_block_comment,
  [87461] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1454), 1,
      anon_sym_RPAREN,
    ACTIONS(5419), 1,
      anon_sym_COMMA,
    STATE(2950), 1,
      aux_sym_parameters_repeat1,
    STATE(3015), 2,
      sym_line_comment,
      sym_block_comment,
  [87481] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6442), 1,
      anon_sym_RPAREN,
    ACTIONS(6444), 1,
      anon_sym_COMMA,
    STATE(3016), 3,
      sym_line_comment,
      sym_block_comment,
      aux_sym_tuple_type_repeat1,
  [87499] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(6442), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(3017), 2,
      sym_line_comment,
      sym_block_comment,
  [87517] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5129), 1,
      anon_sym_RBRACE,
    ACTIONS(6447), 1,
      anon_sym_COMMA,
    STATE(2936), 1,
      aux_sym_struct_pattern_repeat1,
    STATE(3018), 2,
      sym_line_comment,
      sym_block_comment,
  [87537] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2993), 1,
      anon_sym_RPAREN,
    ACTIONS(6449), 1,
      anon_sym_COMMA,
    STATE(2615), 1,
      aux_sym_slice_pattern_repeat1,
    STATE(3019), 2,
      sym_line_comment,
      sym_block_comment,
  [87557] = 6,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5157), 1,
      anon_sym_RBRACE,
    ACTIONS(6451), 1,
      anon_sym_COMMA,
    STATE(2936), 1,
      aux_sym_struct_pattern_repeat1,
    STATE(3020), 2,
      sym_line_comment,
      sym_block_comment,
  [87577] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6453), 2,
      sym_identifier,
      sym_super,
    STATE(3021), 2,
      sym_line_comment,
      sym_block_comment,
  [87592] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4525), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6093), 1,
      anon_sym_for,
    STATE(3022), 2,
      sym_line_comment,
      sym_block_comment,
  [87609] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6455), 2,
      sym_identifier,
      sym_super,
    STATE(3023), 2,
      sym_line_comment,
      sym_block_comment,
  [87624] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6457), 1,
      anon_sym_SEMI,
    ACTIONS(6459), 1,
      anon_sym_as,
    STATE(3024), 2,
      sym_line_comment,
      sym_block_comment,
  [87641] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3723), 2,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
    STATE(3025), 2,
      sym_line_comment,
      sym_block_comment,
  [87656] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    STATE(1330), 1,
      sym_declaration_list,
    STATE(3026), 2,
      sym_line_comment,
      sym_block_comment,
  [87673] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    STATE(1372), 1,
      sym_declaration_list,
    STATE(3027), 2,
      sym_line_comment,
      sym_block_comment,
  [87690] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5622), 1,
      sym_super,
    ACTIONS(6461), 1,
      sym_identifier,
    STATE(3028), 2,
      sym_line_comment,
      sym_block_comment,
  [87707] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6453), 1,
      sym_super,
    ACTIONS(6463), 1,
      sym_identifier,
    STATE(3029), 2,
      sym_line_comment,
      sym_block_comment,
  [87724] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6417), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(3030), 2,
      sym_line_comment,
      sym_block_comment,
  [87739] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6465), 1,
      anon_sym_LBRACK,
    ACTIONS(6467), 1,
      anon_sym_BANG,
    STATE(3031), 2,
      sym_line_comment,
      sym_block_comment,
  [87756] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6469), 1,
      sym_identifier,
    ACTIONS(6471), 1,
      sym_mutable_specifier,
    STATE(3032), 2,
      sym_line_comment,
      sym_block_comment,
  [87773] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6473), 2,
      sym_identifier,
      sym_metavariable,
    STATE(3033), 2,
      sym_line_comment,
      sym_block_comment,
  [87788] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5532), 1,
      sym_super,
    ACTIONS(6475), 1,
      sym_identifier,
    STATE(3034), 2,
      sym_line_comment,
      sym_block_comment,
  [87805] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5884), 1,
      sym_identifier,
    ACTIONS(5888), 1,
      sym_mutable_specifier,
    STATE(3035), 2,
      sym_line_comment,
      sym_block_comment,
  [87822] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4854), 1,
      anon_sym_LBRACE,
    STATE(683), 1,
      sym_field_declaration_list,
    STATE(3036), 2,
      sym_line_comment,
      sym_block_comment,
  [87839] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5451), 1,
      anon_sym_PIPE,
    ACTIONS(6477), 1,
      anon_sym_in,
    STATE(3037), 2,
      sym_line_comment,
      sym_block_comment,
  [87856] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6479), 1,
      sym_identifier,
    ACTIONS(6481), 1,
      sym_super,
    STATE(3038), 2,
      sym_line_comment,
      sym_block_comment,
  [87873] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5451), 1,
      anon_sym_PIPE,
    ACTIONS(6483), 1,
      anon_sym_in,
    STATE(3039), 2,
      sym_line_comment,
      sym_block_comment,
  [87890] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5451), 1,
      anon_sym_PIPE,
    ACTIONS(6485), 1,
      anon_sym_in,
    STATE(3040), 2,
      sym_line_comment,
      sym_block_comment,
  [87907] = 5,
    ACTIONS(27), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(217), 1,
      sym_closure_parameters,
    STATE(3041), 2,
      sym_line_comment,
      sym_block_comment,
  [87924] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5119), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(3042), 2,
      sym_line_comment,
      sym_block_comment,
  [87939] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5451), 1,
      anon_sym_PIPE,
    ACTIONS(6487), 1,
      anon_sym_in,
    STATE(3043), 2,
      sym_line_comment,
      sym_block_comment,
  [87956] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6489), 1,
      anon_sym_LBRACK,
    ACTIONS(6491), 1,
      anon_sym_BANG,
    STATE(3044), 2,
      sym_line_comment,
      sym_block_comment,
  [87973] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4525), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5904), 1,
      anon_sym_for,
    STATE(3045), 2,
      sym_line_comment,
      sym_block_comment,
  [87990] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5788), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    STATE(3046), 2,
      sym_line_comment,
      sym_block_comment,
  [88005] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5451), 1,
      anon_sym_PIPE,
    ACTIONS(6493), 1,
      anon_sym_in,
    STATE(3047), 2,
      sym_line_comment,
      sym_block_comment,
  [88022] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3931), 1,
      anon_sym_LT2,
    STATE(1711), 1,
      sym_type_arguments,
    STATE(3048), 2,
      sym_line_comment,
      sym_block_comment,
  [88039] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6495), 1,
      sym_identifier,
    ACTIONS(6497), 1,
      sym_mutable_specifier,
    STATE(3049), 2,
      sym_line_comment,
      sym_block_comment,
  [88056] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    STATE(561), 1,
      sym_declaration_list,
    STATE(3050), 2,
      sym_line_comment,
      sym_block_comment,
  [88073] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6499), 1,
      sym_identifier,
    ACTIONS(6501), 1,
      sym_super,
    STATE(3051), 2,
      sym_line_comment,
      sym_block_comment,
  [88090] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5622), 1,
      sym_super,
    ACTIONS(6503), 1,
      sym_identifier,
    STATE(3052), 2,
      sym_line_comment,
      sym_block_comment,
  [88107] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6505), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(3053), 2,
      sym_line_comment,
      sym_block_comment,
  [88122] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6507), 2,
      anon_sym_const,
      sym_mutable_specifier,
    STATE(3054), 2,
      sym_line_comment,
      sym_block_comment,
  [88137] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    STATE(691), 1,
      sym_declaration_list,
    STATE(3055), 2,
      sym_line_comment,
      sym_block_comment,
  [88154] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3559), 1,
      anon_sym_COLON,
    ACTIONS(5301), 1,
      anon_sym_PLUS,
    STATE(3056), 2,
      sym_line_comment,
      sym_block_comment,
  [88171] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4525), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5906), 1,
      anon_sym_for,
    STATE(3057), 2,
      sym_line_comment,
      sym_block_comment,
  [88188] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3925), 1,
      anon_sym_LPAREN,
    STATE(1607), 1,
      sym_parameters,
    STATE(3058), 2,
      sym_line_comment,
      sym_block_comment,
  [88205] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4525), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5908), 1,
      anon_sym_for,
    STATE(3059), 2,
      sym_line_comment,
      sym_block_comment,
  [88222] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6509), 2,
      sym_identifier,
      sym_metavariable,
    STATE(3060), 2,
      sym_line_comment,
      sym_block_comment,
  [88237] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4854), 1,
      anon_sym_LBRACE,
    STATE(698), 1,
      sym_field_declaration_list,
    STATE(3061), 2,
      sym_line_comment,
      sym_block_comment,
  [88254] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5169), 1,
      anon_sym_RBRACE,
    ACTIONS(6511), 1,
      anon_sym_SEMI,
    STATE(3062), 2,
      sym_line_comment,
      sym_block_comment,
  [88271] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    STATE(1287), 1,
      sym_declaration_list,
    STATE(3063), 2,
      sym_line_comment,
      sym_block_comment,
  [88288] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3803), 1,
      anon_sym_COLON,
    ACTIONS(5301), 1,
      anon_sym_PLUS,
    STATE(3064), 2,
      sym_line_comment,
      sym_block_comment,
  [88305] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6513), 1,
      sym_identifier,
    ACTIONS(6515), 1,
      sym_super,
    STATE(3065), 2,
      sym_line_comment,
      sym_block_comment,
  [88322] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5664), 2,
      sym_identifier,
      sym_super,
    STATE(3066), 2,
      sym_line_comment,
      sym_block_comment,
  [88337] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5165), 1,
      anon_sym_RBRACE,
    ACTIONS(6511), 1,
      anon_sym_SEMI,
    STATE(3067), 2,
      sym_line_comment,
      sym_block_comment,
  [88354] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4525), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4905), 1,
      anon_sym_for,
    STATE(3068), 2,
      sym_line_comment,
      sym_block_comment,
  [88371] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    STATE(1322), 1,
      sym_declaration_list,
    STATE(3069), 2,
      sym_line_comment,
      sym_block_comment,
  [88388] = 5,
    ACTIONS(27), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(242), 1,
      sym_closure_parameters,
    STATE(3070), 2,
      sym_line_comment,
      sym_block_comment,
  [88405] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6517), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(3071), 2,
      sym_line_comment,
      sym_block_comment,
  [88420] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6519), 2,
      sym_identifier,
      sym_metavariable,
    STATE(3072), 2,
      sym_line_comment,
      sym_block_comment,
  [88435] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3715), 1,
      anon_sym_COLON,
    ACTIONS(5301), 1,
      anon_sym_PLUS,
    STATE(3073), 2,
      sym_line_comment,
      sym_block_comment,
  [88452] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5622), 2,
      sym_identifier,
      sym_super,
    STATE(3074), 2,
      sym_line_comment,
      sym_block_comment,
  [88467] = 5,
    ACTIONS(27), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(236), 1,
      sym_closure_parameters,
    STATE(3075), 2,
      sym_line_comment,
      sym_block_comment,
  [88484] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5758), 1,
      sym_identifier,
    ACTIONS(5760), 1,
      sym_super,
    STATE(3076), 2,
      sym_line_comment,
      sym_block_comment,
  [88501] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5684), 2,
      sym_identifier,
      sym_super,
    STATE(3077), 2,
      sym_line_comment,
      sym_block_comment,
  [88516] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6521), 1,
      sym_identifier,
    ACTIONS(6523), 1,
      sym_super,
    STATE(3078), 2,
      sym_line_comment,
      sym_block_comment,
  [88533] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5451), 1,
      anon_sym_PIPE,
    ACTIONS(6525), 1,
      anon_sym_in,
    STATE(3079), 2,
      sym_line_comment,
      sym_block_comment,
  [88550] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3711), 1,
      anon_sym_COLON,
    ACTIONS(5301), 1,
      anon_sym_PLUS,
    STATE(3080), 2,
      sym_line_comment,
      sym_block_comment,
  [88567] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6453), 1,
      sym_super,
    ACTIONS(6475), 1,
      sym_identifier,
    STATE(3081), 2,
      sym_line_comment,
      sym_block_comment,
  [88584] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6527), 2,
      sym_identifier,
      sym_metavariable,
    STATE(3082), 2,
      sym_line_comment,
      sym_block_comment,
  [88599] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5139), 1,
      sym_super,
    ACTIONS(5756), 1,
      sym_identifier,
    STATE(3083), 2,
      sym_line_comment,
      sym_block_comment,
  [88616] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6529), 1,
      anon_sym_LBRACK,
    ACTIONS(6531), 1,
      anon_sym_BANG,
    STATE(3084), 2,
      sym_line_comment,
      sym_block_comment,
  [88633] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6515), 1,
      sym_super,
    ACTIONS(6533), 1,
      sym_identifier,
    STATE(3085), 2,
      sym_line_comment,
      sym_block_comment,
  [88650] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6535), 1,
      anon_sym_LPAREN,
    ACTIONS(6537), 1,
      anon_sym_COLON_COLON,
    STATE(3086), 2,
      sym_line_comment,
      sym_block_comment,
  [88667] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    STATE(1370), 1,
      sym_declaration_list,
    STATE(3087), 2,
      sym_line_comment,
      sym_block_comment,
  [88684] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4874), 1,
      anon_sym_LBRACE,
    STATE(1314), 1,
      sym_field_declaration_list,
    STATE(3088), 2,
      sym_line_comment,
      sym_block_comment,
  [88701] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    STATE(554), 1,
      sym_declaration_list,
    STATE(3089), 2,
      sym_line_comment,
      sym_block_comment,
  [88718] = 5,
    ACTIONS(27), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(219), 1,
      sym_closure_parameters,
    STATE(3090), 2,
      sym_line_comment,
      sym_block_comment,
  [88735] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6535), 1,
      anon_sym_LPAREN,
    ACTIONS(6539), 1,
      anon_sym_COLON_COLON,
    STATE(3091), 2,
      sym_line_comment,
      sym_block_comment,
  [88752] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5532), 2,
      sym_identifier,
      sym_super,
    STATE(3092), 2,
      sym_line_comment,
      sym_block_comment,
  [88767] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6541), 1,
      anon_sym_LT,
    STATE(979), 1,
      sym_type_parameters,
    STATE(3093), 2,
      sym_line_comment,
      sym_block_comment,
  [88784] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3925), 1,
      anon_sym_LPAREN,
    STATE(1626), 1,
      sym_parameters,
    STATE(3094), 2,
      sym_line_comment,
      sym_block_comment,
  [88801] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3299), 1,
      anon_sym_LBRACE,
    STATE(1145), 1,
      sym_field_initializer_list,
    STATE(3095), 2,
      sym_line_comment,
      sym_block_comment,
  [88818] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5664), 1,
      sym_super,
    ACTIONS(5756), 1,
      sym_identifier,
    STATE(3096), 2,
      sym_line_comment,
      sym_block_comment,
  [88835] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    STATE(719), 1,
      sym_declaration_list,
    STATE(3097), 2,
      sym_line_comment,
      sym_block_comment,
  [88852] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6351), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(3098), 2,
      sym_line_comment,
      sym_block_comment,
  [88867] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6543), 2,
      sym__block_comment_content,
      anon_sym_STAR_SLASH,
    STATE(3099), 2,
      sym_line_comment,
      sym_block_comment,
  [88882] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6545), 2,
      sym__block_comment_content,
      anon_sym_STAR_SLASH,
    STATE(3100), 2,
      sym_line_comment,
      sym_block_comment,
  [88897] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6044), 1,
      anon_sym_EQ_GT,
    ACTIONS(6547), 1,
      anon_sym_AMP_AMP,
    STATE(3101), 2,
      sym_line_comment,
      sym_block_comment,
  [88914] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6549), 2,
      sym_identifier,
      sym_super,
    STATE(3102), 2,
      sym_line_comment,
      sym_block_comment,
  [88929] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4243), 1,
      anon_sym_EQ_GT,
    ACTIONS(6547), 1,
      anon_sym_AMP_AMP,
    STATE(3103), 2,
      sym_line_comment,
      sym_block_comment,
  [88946] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4874), 1,
      anon_sym_LBRACE,
    STATE(1329), 1,
      sym_field_declaration_list,
    STATE(3104), 2,
      sym_line_comment,
      sym_block_comment,
  [88963] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6551), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    STATE(3105), 2,
      sym_line_comment,
      sym_block_comment,
  [88978] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6515), 2,
      sym_identifier,
      sym_super,
    STATE(3106), 2,
      sym_line_comment,
      sym_block_comment,
  [88993] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    STATE(553), 1,
      sym_declaration_list,
    STATE(3107), 2,
      sym_line_comment,
      sym_block_comment,
  [89010] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6553), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(3108), 2,
      sym_line_comment,
      sym_block_comment,
  [89025] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5242), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(3109), 2,
      sym_line_comment,
      sym_block_comment,
  [89040] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6541), 1,
      anon_sym_LT,
    STATE(1057), 1,
      sym_type_parameters,
    STATE(3110), 2,
      sym_line_comment,
      sym_block_comment,
  [89057] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5739), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(3111), 2,
      sym_line_comment,
      sym_block_comment,
  [89072] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6555), 1,
      anon_sym_STAR_SLASH,
    ACTIONS(6557), 1,
      sym__block_comment_content,
    STATE(3112), 2,
      sym_line_comment,
      sym_block_comment,
  [89089] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6559), 1,
      anon_sym_BANG,
    ACTIONS(6561), 1,
      anon_sym_COLON_COLON,
    STATE(3113), 2,
      sym_line_comment,
      sym_block_comment,
  [89106] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3227), 1,
      anon_sym_LPAREN,
    STATE(1060), 1,
      sym_parameters,
    STATE(3114), 2,
      sym_line_comment,
      sym_block_comment,
  [89123] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6563), 1,
      anon_sym_LPAREN,
    ACTIONS(6565), 1,
      anon_sym_COLON_COLON,
    STATE(3115), 2,
      sym_line_comment,
      sym_block_comment,
  [89140] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3925), 1,
      anon_sym_LPAREN,
    STATE(1623), 1,
      sym_parameters,
    STATE(3116), 2,
      sym_line_comment,
      sym_block_comment,
  [89157] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6567), 2,
      sym_identifier,
      sym_super,
    STATE(3117), 2,
      sym_line_comment,
      sym_block_comment,
  [89172] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5852), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    STATE(3118), 2,
      sym_line_comment,
      sym_block_comment,
  [89187] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4525), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4878), 1,
      anon_sym_for,
    STATE(3119), 2,
      sym_line_comment,
      sym_block_comment,
  [89204] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5451), 1,
      anon_sym_PIPE,
    ACTIONS(6569), 1,
      anon_sym_in,
    STATE(3120), 2,
      sym_line_comment,
      sym_block_comment,
  [89221] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5451), 1,
      anon_sym_PIPE,
    ACTIONS(6571), 1,
      anon_sym_EQ,
    STATE(3121), 2,
      sym_line_comment,
      sym_block_comment,
  [89238] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6573), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(3122), 2,
      sym_line_comment,
      sym_block_comment,
  [89253] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5127), 1,
      anon_sym_RBRACE,
    ACTIONS(6511), 1,
      anon_sym_SEMI,
    STATE(3123), 2,
      sym_line_comment,
      sym_block_comment,
  [89270] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2945), 1,
      anon_sym_SQUOTE,
    STATE(3239), 1,
      sym_lifetime,
    STATE(3124), 2,
      sym_line_comment,
      sym_block_comment,
  [89287] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5139), 1,
      sym_super,
    ACTIONS(5772), 1,
      sym_identifier,
    STATE(3125), 2,
      sym_line_comment,
      sym_block_comment,
  [89304] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3227), 1,
      anon_sym_LPAREN,
    STATE(1053), 1,
      sym_parameters,
    STATE(3126), 2,
      sym_line_comment,
      sym_block_comment,
  [89321] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4427), 1,
      anon_sym_LPAREN,
    STATE(2171), 1,
      sym_parameters,
    STATE(3127), 2,
      sym_line_comment,
      sym_block_comment,
  [89338] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6575), 1,
      anon_sym_SEMI,
    ACTIONS(6577), 1,
      anon_sym_as,
    STATE(3128), 2,
      sym_line_comment,
      sym_block_comment,
  [89355] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5532), 1,
      sym_super,
    ACTIONS(6579), 1,
      sym_identifier,
    STATE(3129), 2,
      sym_line_comment,
      sym_block_comment,
  [89372] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5622), 1,
      sym_super,
    ACTIONS(6581), 1,
      sym_identifier,
    STATE(3130), 2,
      sym_line_comment,
      sym_block_comment,
  [89389] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5195), 1,
      anon_sym_LBRACE,
    STATE(735), 1,
      sym_enum_variant_list,
    STATE(3131), 2,
      sym_line_comment,
      sym_block_comment,
  [89406] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6583), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(3132), 2,
      sym_line_comment,
      sym_block_comment,
  [89421] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4525), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5989), 1,
      anon_sym_for,
    STATE(3133), 2,
      sym_line_comment,
      sym_block_comment,
  [89438] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6585), 2,
      sym_float_literal,
      sym_integer_literal,
    STATE(3134), 2,
      sym_line_comment,
      sym_block_comment,
  [89453] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4854), 1,
      anon_sym_LBRACE,
    STATE(592), 1,
      sym_field_declaration_list,
    STATE(3135), 2,
      sym_line_comment,
      sym_block_comment,
  [89470] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5811), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(3136), 2,
      sym_line_comment,
      sym_block_comment,
  [89485] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5451), 1,
      anon_sym_PIPE,
    ACTIONS(5513), 1,
      anon_sym_COLON,
    STATE(3137), 2,
      sym_line_comment,
      sym_block_comment,
  [89502] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6587), 1,
      sym_identifier,
    ACTIONS(6589), 1,
      sym_super,
    STATE(3138), 2,
      sym_line_comment,
      sym_block_comment,
  [89519] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6270), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(3139), 2,
      sym_line_comment,
      sym_block_comment,
  [89534] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    STATE(584), 1,
      sym_declaration_list,
    STATE(3140), 2,
      sym_line_comment,
      sym_block_comment,
  [89551] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    STATE(1248), 1,
      sym_declaration_list,
    STATE(3141), 2,
      sym_line_comment,
      sym_block_comment,
  [89568] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4874), 1,
      anon_sym_LBRACE,
    STATE(1247), 1,
      sym_field_declaration_list,
    STATE(3142), 2,
      sym_line_comment,
      sym_block_comment,
  [89585] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    STATE(583), 1,
      sym_declaration_list,
    STATE(3143), 2,
      sym_line_comment,
      sym_block_comment,
  [89602] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4525), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6009), 1,
      anon_sym_for,
    STATE(3144), 2,
      sym_line_comment,
      sym_block_comment,
  [89619] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5246), 1,
      anon_sym_LBRACE,
    STATE(1448), 1,
      sym_enum_variant_list,
    STATE(3145), 2,
      sym_line_comment,
      sym_block_comment,
  [89636] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6589), 2,
      sym_identifier,
      sym_super,
    STATE(3146), 2,
      sym_line_comment,
      sym_block_comment,
  [89651] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    STATE(704), 1,
      sym_declaration_list,
    STATE(3147), 2,
      sym_line_comment,
      sym_block_comment,
  [89668] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5532), 1,
      sym_super,
    ACTIONS(6591), 1,
      sym_identifier,
    STATE(3148), 2,
      sym_line_comment,
      sym_block_comment,
  [89685] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6593), 2,
      anon_sym_const,
      sym_mutable_specifier,
    STATE(3149), 2,
      sym_line_comment,
      sym_block_comment,
  [89700] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4427), 1,
      anon_sym_LPAREN,
    STATE(2176), 1,
      sym_parameters,
    STATE(3150), 2,
      sym_line_comment,
      sym_block_comment,
  [89717] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4874), 1,
      anon_sym_LBRACE,
    STATE(1240), 1,
      sym_field_declaration_list,
    STATE(3151), 2,
      sym_line_comment,
      sym_block_comment,
  [89734] = 5,
    ACTIONS(27), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(215), 1,
      sym_closure_parameters,
    STATE(3152), 2,
      sym_line_comment,
      sym_block_comment,
  [89751] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6503), 1,
      sym_identifier,
    ACTIONS(6589), 1,
      sym_super,
    STATE(3153), 2,
      sym_line_comment,
      sym_block_comment,
  [89768] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6595), 2,
      sym_float_literal,
      sym_integer_literal,
    STATE(3154), 2,
      sym_line_comment,
      sym_block_comment,
  [89783] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5117), 1,
      anon_sym_RBRACK,
    ACTIONS(6511), 1,
      anon_sym_SEMI,
    STATE(3155), 2,
      sym_line_comment,
      sym_block_comment,
  [89800] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4967), 1,
      anon_sym_PLUS,
    ACTIONS(6597), 1,
      anon_sym_GT,
    STATE(3156), 2,
      sym_line_comment,
      sym_block_comment,
  [89817] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4854), 1,
      anon_sym_LBRACE,
    STATE(573), 1,
      sym_field_declaration_list,
    STATE(3157), 2,
      sym_line_comment,
      sym_block_comment,
  [89834] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6599), 2,
      anon_sym_const,
      sym_mutable_specifier,
    STATE(3158), 2,
      sym_line_comment,
      sym_block_comment,
  [89849] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4427), 1,
      anon_sym_LPAREN,
    STATE(1935), 1,
      sym_parameters,
    STATE(3159), 2,
      sym_line_comment,
      sym_block_comment,
  [89866] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5622), 1,
      sym_super,
    ACTIONS(6587), 1,
      sym_identifier,
    STATE(3160), 2,
      sym_line_comment,
      sym_block_comment,
  [89883] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    STATE(703), 1,
      sym_declaration_list,
    STATE(3161), 2,
      sym_line_comment,
      sym_block_comment,
  [89900] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5532), 1,
      sym_super,
    ACTIONS(6601), 1,
      sym_identifier,
    STATE(3162), 2,
      sym_line_comment,
      sym_block_comment,
  [89917] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5117), 1,
      anon_sym_RPAREN,
    ACTIONS(6511), 1,
      anon_sym_SEMI,
    STATE(3163), 2,
      sym_line_comment,
      sym_block_comment,
  [89934] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4427), 1,
      anon_sym_LPAREN,
    STATE(1952), 1,
      sym_parameters,
    STATE(3164), 2,
      sym_line_comment,
      sym_block_comment,
  [89951] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5451), 1,
      anon_sym_PIPE,
    ACTIONS(6603), 1,
      anon_sym_EQ,
    STATE(3165), 2,
      sym_line_comment,
      sym_block_comment,
  [89968] = 5,
    ACTIONS(27), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(230), 1,
      sym_closure_parameters,
    STATE(3166), 2,
      sym_line_comment,
      sym_block_comment,
  [89985] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6511), 1,
      anon_sym_SEMI,
    ACTIONS(6605), 1,
      anon_sym_RPAREN,
    STATE(3167), 2,
      sym_line_comment,
      sym_block_comment,
  [90002] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6023), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(3168), 2,
      sym_line_comment,
      sym_block_comment,
  [90017] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5246), 1,
      anon_sym_LBRACE,
    STATE(1128), 1,
      sym_enum_variant_list,
    STATE(3169), 2,
      sym_line_comment,
      sym_block_comment,
  [90034] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5760), 2,
      sym_identifier,
      sym_super,
    STATE(3170), 2,
      sym_line_comment,
      sym_block_comment,
  [90049] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4427), 1,
      anon_sym_LPAREN,
    STATE(1955), 1,
      sym_parameters,
    STATE(3171), 2,
      sym_line_comment,
      sym_block_comment,
  [90066] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6453), 1,
      sym_super,
    ACTIONS(6607), 1,
      sym_identifier,
    STATE(3172), 2,
      sym_line_comment,
      sym_block_comment,
  [90083] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5532), 1,
      sym_super,
    ACTIONS(6609), 1,
      sym_identifier,
    STATE(3173), 2,
      sym_line_comment,
      sym_block_comment,
  [90100] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5139), 1,
      sym_super,
    ACTIONS(5712), 1,
      sym_identifier,
    STATE(3174), 2,
      sym_line_comment,
      sym_block_comment,
  [90117] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6515), 1,
      sym_super,
    ACTIONS(6611), 1,
      sym_identifier,
    STATE(3175), 2,
      sym_line_comment,
      sym_block_comment,
  [90134] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5246), 1,
      anon_sym_LBRACE,
    STATE(1263), 1,
      sym_enum_variant_list,
    STATE(3176), 2,
      sym_line_comment,
      sym_block_comment,
  [90151] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6511), 1,
      anon_sym_SEMI,
    ACTIONS(6613), 1,
      anon_sym_RBRACK,
    STATE(3177), 2,
      sym_line_comment,
      sym_block_comment,
  [90168] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6511), 1,
      anon_sym_SEMI,
    ACTIONS(6613), 1,
      anon_sym_RPAREN,
    STATE(3178), 2,
      sym_line_comment,
      sym_block_comment,
  [90185] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6541), 1,
      anon_sym_LT,
    STATE(916), 1,
      sym_type_parameters,
    STATE(3179), 2,
      sym_line_comment,
      sym_block_comment,
  [90202] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6511), 1,
      anon_sym_SEMI,
    ACTIONS(6615), 1,
      anon_sym_RBRACK,
    STATE(3180), 2,
      sym_line_comment,
      sym_block_comment,
  [90219] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    STATE(1179), 1,
      sym_declaration_list,
    STATE(3181), 2,
      sym_line_comment,
      sym_block_comment,
  [90236] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6541), 1,
      anon_sym_LT,
    STATE(1064), 1,
      sym_type_parameters,
    STATE(3182), 2,
      sym_line_comment,
      sym_block_comment,
  [90253] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6511), 1,
      anon_sym_SEMI,
    ACTIONS(6615), 1,
      anon_sym_RPAREN,
    STATE(3183), 2,
      sym_line_comment,
      sym_block_comment,
  [90270] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3953), 1,
      anon_sym_LBRACE,
    STATE(1741), 1,
      sym_field_initializer_list,
    STATE(3184), 2,
      sym_line_comment,
      sym_block_comment,
  [90287] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4427), 1,
      anon_sym_LPAREN,
    STATE(2170), 1,
      sym_parameters,
    STATE(3185), 2,
      sym_line_comment,
      sym_block_comment,
  [90304] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(2945), 1,
      anon_sym_SQUOTE,
    STATE(2928), 1,
      sym_lifetime,
    STATE(3186), 2,
      sym_line_comment,
      sym_block_comment,
  [90321] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    STATE(1182), 1,
      sym_declaration_list,
    STATE(3187), 2,
      sym_line_comment,
      sym_block_comment,
  [90338] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4429), 1,
      anon_sym_BANG,
    ACTIONS(6617), 1,
      anon_sym_COLON_COLON,
    STATE(3188), 2,
      sym_line_comment,
      sym_block_comment,
  [90355] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    STATE(1189), 1,
      sym_declaration_list,
    STATE(3189), 2,
      sym_line_comment,
      sym_block_comment,
  [90372] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4854), 1,
      anon_sym_LBRACE,
    STATE(645), 1,
      sym_field_declaration_list,
    STATE(3190), 2,
      sym_line_comment,
      sym_block_comment,
  [90389] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5451), 1,
      anon_sym_PIPE,
    ACTIONS(6619), 1,
      anon_sym_in,
    STATE(3191), 2,
      sym_line_comment,
      sym_block_comment,
  [90406] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6621), 1,
      anon_sym_RPAREN,
    ACTIONS(6623), 1,
      anon_sym_COLON_COLON,
    STATE(3192), 2,
      sym_line_comment,
      sym_block_comment,
  [90423] = 5,
    ACTIONS(27), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(224), 1,
      sym_closure_parameters,
    STATE(3193), 2,
      sym_line_comment,
      sym_block_comment,
  [90440] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6625), 1,
      anon_sym_RPAREN,
    ACTIONS(6627), 1,
      anon_sym_COLON_COLON,
    STATE(3194), 2,
      sym_line_comment,
      sym_block_comment,
  [90457] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6455), 1,
      sym_super,
    ACTIONS(6611), 1,
      sym_identifier,
    STATE(3195), 2,
      sym_line_comment,
      sym_block_comment,
  [90474] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6629), 1,
      anon_sym_RPAREN,
    ACTIONS(6631), 1,
      anon_sym_COLON_COLON,
    STATE(3196), 2,
      sym_line_comment,
      sym_block_comment,
  [90491] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6625), 1,
      anon_sym_RPAREN,
    ACTIONS(6633), 1,
      anon_sym_COLON_COLON,
    STATE(3197), 2,
      sym_line_comment,
      sym_block_comment,
  [90508] = 5,
    ACTIONS(27), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(218), 1,
      sym_closure_parameters,
    STATE(3198), 2,
      sym_line_comment,
      sym_block_comment,
  [90525] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6629), 1,
      anon_sym_RPAREN,
    ACTIONS(6633), 1,
      anon_sym_COLON_COLON,
    STATE(3199), 2,
      sym_line_comment,
      sym_block_comment,
  [90542] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6625), 1,
      anon_sym_RPAREN,
    ACTIONS(6631), 1,
      anon_sym_COLON_COLON,
    STATE(3200), 2,
      sym_line_comment,
      sym_block_comment,
  [90559] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4581), 1,
      anon_sym_BANG,
    ACTIONS(4692), 1,
      anon_sym_COLON_COLON,
    STATE(3201), 2,
      sym_line_comment,
      sym_block_comment,
  [90576] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3791), 1,
      anon_sym_COLON,
    ACTIONS(5301), 1,
      anon_sym_PLUS,
    STATE(3202), 2,
      sym_line_comment,
      sym_block_comment,
  [90593] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5664), 1,
      sym_super,
    ACTIONS(5712), 1,
      sym_identifier,
    STATE(3203), 2,
      sym_line_comment,
      sym_block_comment,
  [90610] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6068), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(3204), 2,
      sym_line_comment,
      sym_block_comment,
  [90625] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6589), 1,
      sym_super,
    ACTIONS(6635), 1,
      sym_identifier,
    STATE(3205), 2,
      sym_line_comment,
      sym_block_comment,
  [90642] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4581), 1,
      anon_sym_BANG,
    ACTIONS(4654), 1,
      anon_sym_COLON_COLON,
    STATE(3206), 2,
      sym_line_comment,
      sym_block_comment,
  [90659] = 5,
    ACTIONS(27), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(229), 1,
      sym_closure_parameters,
    STATE(3207), 2,
      sym_line_comment,
      sym_block_comment,
  [90676] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5149), 1,
      anon_sym_RBRACK,
    ACTIONS(6511), 1,
      anon_sym_SEMI,
    STATE(3208), 2,
      sym_line_comment,
      sym_block_comment,
  [90693] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5149), 1,
      anon_sym_RPAREN,
    ACTIONS(6511), 1,
      anon_sym_SEMI,
    STATE(3209), 2,
      sym_line_comment,
      sym_block_comment,
  [90710] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6637), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(3210), 2,
      sym_line_comment,
      sym_block_comment,
  [90725] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6567), 1,
      sym_super,
    ACTIONS(6639), 1,
      sym_identifier,
    STATE(3211), 2,
      sym_line_comment,
      sym_block_comment,
  [90742] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4874), 1,
      anon_sym_LBRACE,
    STATE(1285), 1,
      sym_field_declaration_list,
    STATE(3212), 2,
      sym_line_comment,
      sym_block_comment,
  [90759] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5664), 1,
      sym_super,
    ACTIONS(5672), 1,
      sym_identifier,
    STATE(3213), 2,
      sym_line_comment,
      sym_block_comment,
  [90776] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6455), 1,
      sym_super,
    ACTIONS(6641), 1,
      sym_identifier,
    STATE(3214), 2,
      sym_line_comment,
      sym_block_comment,
  [90793] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6197), 2,
      anon_sym_PIPE,
      anon_sym_COMMA,
    STATE(3215), 2,
      sym_line_comment,
      sym_block_comment,
  [90808] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5089), 1,
      anon_sym_RBRACK,
    ACTIONS(6511), 1,
      anon_sym_SEMI,
    STATE(3216), 2,
      sym_line_comment,
      sym_block_comment,
  [90825] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    STATE(1282), 1,
      sym_declaration_list,
    STATE(3217), 2,
      sym_line_comment,
      sym_block_comment,
  [90842] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5105), 1,
      anon_sym_RBRACK,
    ACTIONS(6511), 1,
      anon_sym_SEMI,
    STATE(3218), 2,
      sym_line_comment,
      sym_block_comment,
  [90859] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5089), 1,
      anon_sym_RPAREN,
    ACTIONS(6511), 1,
      anon_sym_SEMI,
    STATE(3219), 2,
      sym_line_comment,
      sym_block_comment,
  [90876] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5532), 1,
      sym_super,
    ACTIONS(6463), 1,
      sym_identifier,
    STATE(3220), 2,
      sym_line_comment,
      sym_block_comment,
  [90893] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    STATE(1275), 1,
      sym_declaration_list,
    STATE(3221), 2,
      sym_line_comment,
      sym_block_comment,
  [90910] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6453), 1,
      sym_super,
    ACTIONS(6609), 1,
      sym_identifier,
    STATE(3222), 2,
      sym_line_comment,
      sym_block_comment,
  [90927] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6627), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6629), 1,
      anon_sym_RPAREN,
    STATE(3223), 2,
      sym_line_comment,
      sym_block_comment,
  [90944] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6455), 1,
      sym_super,
    ACTIONS(6533), 1,
      sym_identifier,
    STATE(3224), 2,
      sym_line_comment,
      sym_block_comment,
  [90961] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6623), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6643), 1,
      anon_sym_RPAREN,
    STATE(3225), 2,
      sym_line_comment,
      sym_block_comment,
  [90978] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6645), 1,
      anon_sym_SEMI,
    ACTIONS(6647), 1,
      anon_sym_as,
    STATE(3226), 2,
      sym_line_comment,
      sym_block_comment,
  [90995] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6117), 1,
      sym_identifier,
    ACTIONS(6121), 1,
      sym_mutable_specifier,
    STATE(3227), 2,
      sym_line_comment,
      sym_block_comment,
  [91012] = 5,
    ACTIONS(27), 1,
      anon_sym_PIPE,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    STATE(222), 1,
      sym_closure_parameters,
    STATE(3228), 2,
      sym_line_comment,
      sym_block_comment,
  [91029] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4874), 1,
      anon_sym_LBRACE,
    STATE(1262), 1,
      sym_field_declaration_list,
    STATE(3229), 2,
      sym_line_comment,
      sym_block_comment,
  [91046] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4903), 1,
      anon_sym_LBRACE,
    STATE(1181), 1,
      sym_declaration_list,
    STATE(3230), 2,
      sym_line_comment,
      sym_block_comment,
  [91063] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6649), 1,
      sym_identifier,
    ACTIONS(6651), 1,
      sym_mutable_specifier,
    STATE(3231), 2,
      sym_line_comment,
      sym_block_comment,
  [91080] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6589), 1,
      sym_super,
    ACTIONS(6653), 1,
      sym_identifier,
    STATE(3232), 2,
      sym_line_comment,
      sym_block_comment,
  [91097] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6511), 1,
      anon_sym_SEMI,
    ACTIONS(6655), 1,
      anon_sym_RBRACE,
    STATE(3233), 2,
      sym_line_comment,
      sym_block_comment,
  [91114] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3565), 2,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
    STATE(3234), 2,
      sym_line_comment,
      sym_block_comment,
  [91129] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6453), 1,
      sym_super,
    ACTIONS(6657), 1,
      sym_identifier,
    STATE(3235), 2,
      sym_line_comment,
      sym_block_comment,
  [91146] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6511), 1,
      anon_sym_SEMI,
    ACTIONS(6659), 1,
      anon_sym_RBRACK,
    STATE(3236), 2,
      sym_line_comment,
      sym_block_comment,
  [91163] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5664), 1,
      sym_super,
    ACTIONS(5690), 1,
      sym_identifier,
    STATE(3237), 2,
      sym_line_comment,
      sym_block_comment,
  [91180] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6455), 1,
      sym_super,
    ACTIONS(6661), 1,
      sym_identifier,
    STATE(3238), 2,
      sym_line_comment,
      sym_block_comment,
  [91197] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6326), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    STATE(3239), 2,
      sym_line_comment,
      sym_block_comment,
  [91212] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4427), 1,
      anon_sym_LPAREN,
    STATE(2218), 1,
      sym_parameters,
    STATE(3240), 2,
      sym_line_comment,
      sym_block_comment,
  [91229] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4427), 1,
      anon_sym_LPAREN,
    STATE(2212), 1,
      sym_parameters,
    STATE(3241), 2,
      sym_line_comment,
      sym_block_comment,
  [91246] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    STATE(491), 1,
      sym_declaration_list,
    STATE(3242), 2,
      sym_line_comment,
      sym_block_comment,
  [91263] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5195), 1,
      anon_sym_LBRACE,
    STATE(681), 1,
      sym_enum_variant_list,
    STATE(3243), 2,
      sym_line_comment,
      sym_block_comment,
  [91280] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4856), 1,
      anon_sym_LT,
    STATE(941), 1,
      sym_type_parameters,
    STATE(3244), 2,
      sym_line_comment,
      sym_block_comment,
  [91297] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6511), 1,
      anon_sym_SEMI,
    ACTIONS(6659), 1,
      anon_sym_RPAREN,
    STATE(3245), 2,
      sym_line_comment,
      sym_block_comment,
  [91314] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    STATE(672), 1,
      sym_declaration_list,
    STATE(3246), 2,
      sym_line_comment,
      sym_block_comment,
  [91331] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6541), 1,
      anon_sym_LT,
    STATE(1056), 1,
      sym_type_parameters,
    STATE(3247), 2,
      sym_line_comment,
      sym_block_comment,
  [91348] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5246), 1,
      anon_sym_LBRACE,
    STATE(1142), 1,
      sym_enum_variant_list,
    STATE(3248), 2,
      sym_line_comment,
      sym_block_comment,
  [91365] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6535), 1,
      anon_sym_LPAREN,
    ACTIONS(6663), 1,
      anon_sym_COLON_COLON,
    STATE(3249), 2,
      sym_line_comment,
      sym_block_comment,
  [91382] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4874), 1,
      anon_sym_LBRACE,
    STATE(1135), 1,
      sym_field_declaration_list,
    STATE(3250), 2,
      sym_line_comment,
      sym_block_comment,
  [91399] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4874), 1,
      anon_sym_LBRACE,
    STATE(1122), 1,
      sym_field_declaration_list,
    STATE(3251), 2,
      sym_line_comment,
      sym_block_comment,
  [91416] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6201), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(3252), 2,
      sym_line_comment,
      sym_block_comment,
  [91431] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6665), 1,
      sym_identifier,
    ACTIONS(6667), 1,
      sym_super,
    STATE(3253), 2,
      sym_line_comment,
      sym_block_comment,
  [91448] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3235), 1,
      anon_sym_LT2,
    STATE(1250), 1,
      sym_type_arguments,
    STATE(3254), 2,
      sym_line_comment,
      sym_block_comment,
  [91465] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6453), 1,
      sym_super,
    ACTIONS(6669), 1,
      sym_identifier,
    STATE(3255), 2,
      sym_line_comment,
      sym_block_comment,
  [91482] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5023), 1,
      anon_sym_COLON,
    STATE(2699), 1,
      sym_trait_bounds,
    STATE(3256), 2,
      sym_line_comment,
      sym_block_comment,
  [91499] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5682), 1,
      sym_identifier,
    ACTIONS(5684), 1,
      sym_super,
    STATE(3257), 2,
      sym_line_comment,
      sym_block_comment,
  [91516] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6549), 1,
      sym_super,
    ACTIONS(6671), 1,
      sym_identifier,
    STATE(3258), 2,
      sym_line_comment,
      sym_block_comment,
  [91533] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6667), 2,
      sym_identifier,
      sym_super,
    STATE(3259), 2,
      sym_line_comment,
      sym_block_comment,
  [91548] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5195), 1,
      anon_sym_LBRACE,
    STATE(529), 1,
      sym_enum_variant_list,
    STATE(3260), 2,
      sym_line_comment,
      sym_block_comment,
  [91565] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4427), 1,
      anon_sym_LPAREN,
    STATE(2216), 1,
      sym_parameters,
    STATE(3261), 2,
      sym_line_comment,
      sym_block_comment,
  [91582] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4932), 1,
      anon_sym_LBRACE,
    STATE(607), 1,
      sym_declaration_list,
    STATE(3262), 2,
      sym_line_comment,
      sym_block_comment,
  [91599] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6515), 1,
      sym_super,
    ACTIONS(6673), 1,
      sym_identifier,
    STATE(3263), 2,
      sym_line_comment,
      sym_block_comment,
  [91616] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5622), 1,
      sym_super,
    ACTIONS(6635), 1,
      sym_identifier,
    STATE(3264), 2,
      sym_line_comment,
      sym_block_comment,
  [91633] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6453), 1,
      sym_super,
    ACTIONS(6591), 1,
      sym_identifier,
    STATE(3265), 2,
      sym_line_comment,
      sym_block_comment,
  [91650] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6511), 1,
      anon_sym_SEMI,
    ACTIONS(6605), 1,
      anon_sym_RBRACK,
    STATE(3266), 2,
      sym_line_comment,
      sym_block_comment,
  [91667] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5139), 1,
      sym_super,
    ACTIONS(5672), 1,
      sym_identifier,
    STATE(3267), 2,
      sym_line_comment,
      sym_block_comment,
  [91684] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6515), 1,
      sym_super,
    ACTIONS(6641), 1,
      sym_identifier,
    STATE(3268), 2,
      sym_line_comment,
      sym_block_comment,
  [91701] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5195), 1,
      anon_sym_LBRACE,
    STATE(636), 1,
      sym_enum_variant_list,
    STATE(3269), 2,
      sym_line_comment,
      sym_block_comment,
  [91718] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6589), 1,
      sym_super,
    ACTIONS(6675), 1,
      sym_identifier,
    STATE(3270), 2,
      sym_line_comment,
      sym_block_comment,
  [91735] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6677), 1,
      anon_sym_SEMI,
    ACTIONS(6679), 1,
      anon_sym_as,
    STATE(3271), 2,
      sym_line_comment,
      sym_block_comment,
  [91752] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5664), 1,
      sym_super,
    ACTIONS(5670), 1,
      sym_identifier,
    STATE(3272), 2,
      sym_line_comment,
      sym_block_comment,
  [91769] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6455), 1,
      sym_super,
    ACTIONS(6681), 1,
      sym_identifier,
    STATE(3273), 2,
      sym_line_comment,
      sym_block_comment,
  [91786] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6683), 2,
      sym_identifier,
      sym_metavariable,
    STATE(3274), 2,
      sym_line_comment,
      sym_block_comment,
  [91801] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6589), 1,
      sym_super,
    ACTIONS(6685), 1,
      sym_identifier,
    STATE(3275), 2,
      sym_line_comment,
      sym_block_comment,
  [91818] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5175), 1,
      anon_sym_RBRACE,
    ACTIONS(6511), 1,
      anon_sym_SEMI,
    STATE(3276), 2,
      sym_line_comment,
      sym_block_comment,
  [91835] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5664), 1,
      sym_super,
    ACTIONS(5668), 1,
      sym_identifier,
    STATE(3277), 2,
      sym_line_comment,
      sym_block_comment,
  [91852] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6455), 1,
      sym_super,
    ACTIONS(6687), 1,
      sym_identifier,
    STATE(3278), 2,
      sym_line_comment,
      sym_block_comment,
  [91869] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4854), 1,
      anon_sym_LBRACE,
    STATE(673), 1,
      sym_field_declaration_list,
    STATE(3279), 2,
      sym_line_comment,
      sym_block_comment,
  [91886] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6589), 1,
      sym_super,
    ACTIONS(6689), 1,
      sym_identifier,
    STATE(3280), 2,
      sym_line_comment,
      sym_block_comment,
  [91903] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6541), 1,
      anon_sym_LT,
    STATE(857), 1,
      sym_type_parameters,
    STATE(3281), 2,
      sym_line_comment,
      sym_block_comment,
  [91920] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5662), 1,
      sym_identifier,
    ACTIONS(5664), 1,
      sym_super,
    STATE(3282), 2,
      sym_line_comment,
      sym_block_comment,
  [91937] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6455), 1,
      sym_super,
    ACTIONS(6691), 1,
      sym_identifier,
    STATE(3283), 2,
      sym_line_comment,
      sym_block_comment,
  [91954] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5622), 1,
      sym_super,
    ACTIONS(6689), 1,
      sym_identifier,
    STATE(3284), 2,
      sym_line_comment,
      sym_block_comment,
  [91971] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5139), 1,
      sym_super,
    ACTIONS(5662), 1,
      sym_identifier,
    STATE(3285), 2,
      sym_line_comment,
      sym_block_comment,
  [91988] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6515), 1,
      sym_super,
    ACTIONS(6691), 1,
      sym_identifier,
    STATE(3286), 2,
      sym_line_comment,
      sym_block_comment,
  [92005] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5139), 2,
      sym_identifier,
      sym_super,
    STATE(3287), 2,
      sym_line_comment,
      sym_block_comment,
  [92020] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6511), 1,
      anon_sym_SEMI,
    ACTIONS(6693), 1,
      anon_sym_RBRACE,
    STATE(3288), 2,
      sym_line_comment,
      sym_block_comment,
  [92037] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6511), 1,
      anon_sym_SEMI,
    ACTIONS(6695), 1,
      anon_sym_RBRACE,
    STATE(3289), 2,
      sym_line_comment,
      sym_block_comment,
  [92054] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5105), 1,
      anon_sym_RPAREN,
    ACTIONS(6511), 1,
      anon_sym_SEMI,
    STATE(3290), 2,
      sym_line_comment,
      sym_block_comment,
  [92071] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6697), 2,
      sym_identifier,
      sym_metavariable,
    STATE(3291), 2,
      sym_line_comment,
      sym_block_comment,
  [92086] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3227), 1,
      anon_sym_LPAREN,
    STATE(1073), 1,
      sym_parameters,
    STATE(3292), 2,
      sym_line_comment,
      sym_block_comment,
  [92103] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4854), 1,
      anon_sym_LBRACE,
    STATE(640), 1,
      sym_field_declaration_list,
    STATE(3293), 2,
      sym_line_comment,
      sym_block_comment,
  [92120] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6535), 1,
      anon_sym_LPAREN,
    ACTIONS(6699), 1,
      anon_sym_COLON_COLON,
    STATE(3294), 2,
      sym_line_comment,
      sym_block_comment,
  [92137] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4854), 1,
      anon_sym_LBRACE,
    STATE(677), 1,
      sym_field_declaration_list,
    STATE(3295), 2,
      sym_line_comment,
      sym_block_comment,
  [92154] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5139), 1,
      sym_super,
    ACTIONS(5658), 1,
      sym_identifier,
    STATE(3296), 2,
      sym_line_comment,
      sym_block_comment,
  [92171] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6701), 2,
      anon_sym_const,
      sym_mutable_specifier,
    STATE(3297), 2,
      sym_line_comment,
      sym_block_comment,
  [92186] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6511), 1,
      anon_sym_SEMI,
    ACTIONS(6703), 1,
      anon_sym_RBRACE,
    STATE(3298), 2,
      sym_line_comment,
      sym_block_comment,
  [92203] = 5,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6705), 1,
      anon_sym_BANG,
    ACTIONS(6707), 1,
      anon_sym_COLON_COLON,
    STATE(3299), 2,
      sym_line_comment,
      sym_block_comment,
  [92220] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6709), 1,
      anon_sym_RBRACK,
    STATE(3300), 2,
      sym_line_comment,
      sym_block_comment,
  [92234] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6655), 1,
      anon_sym_SEMI,
    STATE(3301), 2,
      sym_line_comment,
      sym_block_comment,
  [92248] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6711), 1,
      sym_identifier,
    STATE(3302), 2,
      sym_line_comment,
      sym_block_comment,
  [92262] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6693), 1,
      anon_sym_SEMI,
    STATE(3303), 2,
      sym_line_comment,
      sym_block_comment,
  [92276] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6713), 1,
      sym_identifier,
    STATE(3304), 2,
      sym_line_comment,
      sym_block_comment,
  [92290] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4035), 1,
      anon_sym_COLON_COLON,
    STATE(3305), 2,
      sym_line_comment,
      sym_block_comment,
  [92304] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6715), 1,
      sym_identifier,
    STATE(3306), 2,
      sym_line_comment,
      sym_block_comment,
  [92318] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4558), 1,
      anon_sym_COLON_COLON,
    STATE(3307), 2,
      sym_line_comment,
      sym_block_comment,
  [92332] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5175), 1,
      anon_sym_SEMI,
    STATE(3308), 2,
      sym_line_comment,
      sym_block_comment,
  [92346] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6695), 1,
      anon_sym_SEMI,
    STATE(3309), 2,
      sym_line_comment,
      sym_block_comment,
  [92360] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6717), 1,
      sym_raw_string_literal_content,
    STATE(3310), 2,
      sym_line_comment,
      sym_block_comment,
  [92374] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6719), 1,
      anon_sym_EQ_GT,
    STATE(3311), 2,
      sym_line_comment,
      sym_block_comment,
  [92388] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6721), 1,
      anon_sym_SEMI,
    STATE(3312), 2,
      sym_line_comment,
      sym_block_comment,
  [92402] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6723), 1,
      sym_identifier,
    STATE(3313), 2,
      sym_line_comment,
      sym_block_comment,
  [92416] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6725), 1,
      anon_sym_SEMI,
    STATE(3314), 2,
      sym_line_comment,
      sym_block_comment,
  [92430] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4519), 1,
      anon_sym_COLON_COLON,
    STATE(3315), 2,
      sym_line_comment,
      sym_block_comment,
  [92444] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6727), 1,
      anon_sym_fn,
    STATE(3316), 2,
      sym_line_comment,
      sym_block_comment,
  [92458] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6729), 1,
      anon_sym_RBRACK,
    STATE(3317), 2,
      sym_line_comment,
      sym_block_comment,
  [92472] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6731), 1,
      sym_identifier,
    STATE(3318), 2,
      sym_line_comment,
      sym_block_comment,
  [92486] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6733), 1,
      sym_identifier,
    STATE(3319), 2,
      sym_line_comment,
      sym_block_comment,
  [92500] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6735), 1,
      sym_identifier,
    STATE(3320), 2,
      sym_line_comment,
      sym_block_comment,
  [92514] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6737), 1,
      anon_sym_fn,
    STATE(3321), 2,
      sym_line_comment,
      sym_block_comment,
  [92528] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6739), 1,
      sym_identifier,
    STATE(3322), 2,
      sym_line_comment,
      sym_block_comment,
  [92542] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6741), 1,
      anon_sym_COLON_COLON,
    STATE(3323), 2,
      sym_line_comment,
      sym_block_comment,
  [92556] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6743), 1,
      sym_identifier,
    STATE(3324), 2,
      sym_line_comment,
      sym_block_comment,
  [92570] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6745), 1,
      sym_identifier,
    STATE(3325), 2,
      sym_line_comment,
      sym_block_comment,
  [92584] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6747), 1,
      sym_raw_string_literal_content,
    STATE(3326), 2,
      sym_line_comment,
      sym_block_comment,
  [92598] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6703), 1,
      anon_sym_SEMI,
    STATE(3327), 2,
      sym_line_comment,
      sym_block_comment,
  [92612] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4690), 1,
      anon_sym_COLON_COLON,
    STATE(3328), 2,
      sym_line_comment,
      sym_block_comment,
  [92626] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4063), 1,
      anon_sym_RPAREN,
    STATE(3329), 2,
      sym_line_comment,
      sym_block_comment,
  [92640] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6749), 1,
      anon_sym_COLON,
    STATE(3330), 2,
      sym_line_comment,
      sym_block_comment,
  [92654] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6751), 1,
      sym_identifier,
    STATE(3331), 2,
      sym_line_comment,
      sym_block_comment,
  [92668] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6753), 1,
      sym_identifier,
    STATE(3332), 2,
      sym_line_comment,
      sym_block_comment,
  [92682] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6755), 1,
      anon_sym_COLON_COLON,
    STATE(3333), 2,
      sym_line_comment,
      sym_block_comment,
  [92696] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6757), 1,
      sym_identifier,
    STATE(3334), 2,
      sym_line_comment,
      sym_block_comment,
  [92710] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6759), 1,
      sym_identifier,
    STATE(3335), 2,
      sym_line_comment,
      sym_block_comment,
  [92724] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6761), 1,
      sym_identifier,
    STATE(3336), 2,
      sym_line_comment,
      sym_block_comment,
  [92738] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6763), 1,
      sym_identifier,
    STATE(3337), 2,
      sym_line_comment,
      sym_block_comment,
  [92752] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6765), 1,
      sym_identifier,
    STATE(3338), 2,
      sym_line_comment,
      sym_block_comment,
  [92766] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6767), 1,
      sym_identifier,
    STATE(3339), 2,
      sym_line_comment,
      sym_block_comment,
  [92780] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6769), 1,
      anon_sym_SEMI,
    STATE(3340), 2,
      sym_line_comment,
      sym_block_comment,
  [92794] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6771), 1,
      anon_sym_COLON_COLON,
    STATE(3341), 2,
      sym_line_comment,
      sym_block_comment,
  [92808] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6773), 1,
      anon_sym_EQ,
    STATE(3342), 2,
      sym_line_comment,
      sym_block_comment,
  [92822] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6775), 1,
      anon_sym_SEMI,
    STATE(3343), 2,
      sym_line_comment,
      sym_block_comment,
  [92836] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6777), 1,
      sym_self,
    STATE(3344), 2,
      sym_line_comment,
      sym_block_comment,
  [92850] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6779), 1,
      anon_sym_SEMI,
    STATE(3345), 2,
      sym_line_comment,
      sym_block_comment,
  [92864] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5413), 1,
      anon_sym_RPAREN,
    STATE(3346), 2,
      sym_line_comment,
      sym_block_comment,
  [92878] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6781), 1,
      sym__raw_string_literal_end,
    STATE(3347), 2,
      sym_line_comment,
      sym_block_comment,
  [92892] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6783), 1,
      anon_sym_SEMI,
    STATE(3348), 2,
      sym_line_comment,
      sym_block_comment,
  [92906] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6785), 1,
      anon_sym_SEMI,
    STATE(3349), 2,
      sym_line_comment,
      sym_block_comment,
  [92920] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6787), 1,
      anon_sym_RBRACE,
    STATE(3350), 2,
      sym_line_comment,
      sym_block_comment,
  [92934] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4938), 1,
      anon_sym_COLON_COLON,
    STATE(3351), 2,
      sym_line_comment,
      sym_block_comment,
  [92948] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6789), 1,
      anon_sym_STAR_SLASH,
    STATE(3352), 2,
      sym_line_comment,
      sym_block_comment,
  [92962] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6791), 1,
      anon_sym_COLON_COLON,
    STATE(3353), 2,
      sym_line_comment,
      sym_block_comment,
  [92976] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6793), 1,
      anon_sym_fn,
    STATE(3354), 2,
      sym_line_comment,
      sym_block_comment,
  [92990] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6795), 1,
      anon_sym_EQ_GT,
    STATE(3355), 2,
      sym_line_comment,
      sym_block_comment,
  [93004] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5632), 1,
      anon_sym_LBRACE,
    STATE(3356), 2,
      sym_line_comment,
      sym_block_comment,
  [93018] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6797), 1,
      anon_sym_COLON,
    STATE(3357), 2,
      sym_line_comment,
      sym_block_comment,
  [93032] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6799), 1,
      sym_identifier,
    STATE(3358), 2,
      sym_line_comment,
      sym_block_comment,
  [93046] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6801), 1,
      sym_identifier,
    STATE(3359), 2,
      sym_line_comment,
      sym_block_comment,
  [93060] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6803), 1,
      sym_identifier,
    STATE(3360), 2,
      sym_line_comment,
      sym_block_comment,
  [93074] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6805), 1,
      anon_sym_SEMI,
    STATE(3361), 2,
      sym_line_comment,
      sym_block_comment,
  [93088] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6807), 1,
      sym_identifier,
    STATE(3362), 2,
      sym_line_comment,
      sym_block_comment,
  [93102] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(975), 1,
      anon_sym_RBRACK,
    STATE(3363), 2,
      sym_line_comment,
      sym_block_comment,
  [93116] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5696), 1,
      anon_sym_RPAREN,
    STATE(3364), 2,
      sym_line_comment,
      sym_block_comment,
  [93130] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6809), 1,
      anon_sym_COLON,
    STATE(3365), 2,
      sym_line_comment,
      sym_block_comment,
  [93144] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6811), 1,
      anon_sym_SEMI,
    STATE(3366), 2,
      sym_line_comment,
      sym_block_comment,
  [93158] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6813), 1,
      sym__raw_string_literal_end,
    STATE(3367), 2,
      sym_line_comment,
      sym_block_comment,
  [93172] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6815), 1,
      sym_identifier,
    STATE(3368), 2,
      sym_line_comment,
      sym_block_comment,
  [93186] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6817), 1,
      sym_identifier,
    STATE(3369), 2,
      sym_line_comment,
      sym_block_comment,
  [93200] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(769), 1,
      anon_sym_EQ_GT,
    STATE(3370), 2,
      sym_line_comment,
      sym_block_comment,
  [93214] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6819), 1,
      anon_sym_SEMI,
    STATE(3371), 2,
      sym_line_comment,
      sym_block_comment,
  [93228] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5700), 1,
      anon_sym_RBRACK,
    STATE(3372), 2,
      sym_line_comment,
      sym_block_comment,
  [93242] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6821), 1,
      sym_identifier,
    STATE(3373), 2,
      sym_line_comment,
      sym_block_comment,
  [93256] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6823), 1,
      sym_identifier,
    STATE(3374), 2,
      sym_line_comment,
      sym_block_comment,
  [93270] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6825), 1,
      sym_identifier,
    STATE(3375), 2,
      sym_line_comment,
      sym_block_comment,
  [93284] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6827), 1,
      anon_sym_SEMI,
    STATE(3376), 2,
      sym_line_comment,
      sym_block_comment,
  [93298] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6511), 1,
      anon_sym_SEMI,
    STATE(3377), 2,
      sym_line_comment,
      sym_block_comment,
  [93312] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6829), 1,
      anon_sym_SEMI,
    STATE(3378), 2,
      sym_line_comment,
      sym_block_comment,
  [93326] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6147), 1,
      anon_sym_COLON_COLON,
    STATE(3379), 2,
      sym_line_comment,
      sym_block_comment,
  [93340] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6831), 1,
      anon_sym_RBRACK,
    STATE(3380), 2,
      sym_line_comment,
      sym_block_comment,
  [93354] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3976), 1,
      sym_identifier,
    STATE(3381), 2,
      sym_line_comment,
      sym_block_comment,
  [93368] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6833), 1,
      anon_sym_SEMI,
    STATE(3382), 2,
      sym_line_comment,
      sym_block_comment,
  [93382] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6835), 1,
      anon_sym_COLON,
    STATE(3383), 2,
      sym_line_comment,
      sym_block_comment,
  [93396] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6052), 1,
      anon_sym_RBRACE,
    STATE(3384), 2,
      sym_line_comment,
      sym_block_comment,
  [93410] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6085), 1,
      anon_sym_RBRACE,
    STATE(3385), 2,
      sym_line_comment,
      sym_block_comment,
  [93424] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6837), 1,
      anon_sym_RBRACK,
    STATE(3386), 2,
      sym_line_comment,
      sym_block_comment,
  [93438] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6839), 1,
      sym__raw_string_literal_end,
    STATE(3387), 2,
      sym_line_comment,
      sym_block_comment,
  [93452] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6841), 1,
      sym_identifier,
    STATE(3388), 2,
      sym_line_comment,
      sym_block_comment,
  [93466] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6843), 1,
      anon_sym_SEMI,
    STATE(3389), 2,
      sym_line_comment,
      sym_block_comment,
  [93480] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6845), 1,
      sym_identifier,
    STATE(3390), 2,
      sym_line_comment,
      sym_block_comment,
  [93494] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6847), 1,
      anon_sym_COLON,
    STATE(3391), 2,
      sym_line_comment,
      sym_block_comment,
  [93508] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6849), 1,
      anon_sym_RBRACE,
    STATE(3392), 2,
      sym_line_comment,
      sym_block_comment,
  [93522] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6851), 1,
      anon_sym_RBRACE,
    STATE(3393), 2,
      sym_line_comment,
      sym_block_comment,
  [93536] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6853), 1,
      anon_sym_RBRACE,
    STATE(3394), 2,
      sym_line_comment,
      sym_block_comment,
  [93550] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6855), 1,
      anon_sym_SEMI,
    STATE(3395), 2,
      sym_line_comment,
      sym_block_comment,
  [93564] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6857), 1,
      anon_sym_RPAREN,
    STATE(3396), 2,
      sym_line_comment,
      sym_block_comment,
  [93578] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6859), 1,
      anon_sym_COLON,
    STATE(3397), 2,
      sym_line_comment,
      sym_block_comment,
  [93592] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6861), 1,
      anon_sym_COLON,
    STATE(3398), 2,
      sym_line_comment,
      sym_block_comment,
  [93606] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6034), 1,
      anon_sym_RBRACE,
    STATE(3399), 2,
      sym_line_comment,
      sym_block_comment,
  [93620] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6863), 1,
      anon_sym_COLON,
    STATE(3400), 2,
      sym_line_comment,
      sym_block_comment,
  [93634] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6865), 1,
      anon_sym_LBRACK,
    STATE(3401), 2,
      sym_line_comment,
      sym_block_comment,
  [93648] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6867), 1,
      anon_sym_RBRACE,
    STATE(3402), 2,
      sym_line_comment,
      sym_block_comment,
  [93662] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6869), 1,
      anon_sym_SEMI,
    STATE(3403), 2,
      sym_line_comment,
      sym_block_comment,
  [93676] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6871), 1,
      anon_sym_COLON_COLON,
    STATE(3404), 2,
      sym_line_comment,
      sym_block_comment,
  [93690] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6873), 1,
      sym_identifier,
    STATE(3405), 2,
      sym_line_comment,
      sym_block_comment,
  [93704] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6875), 1,
      anon_sym_SEMI,
    STATE(3406), 2,
      sym_line_comment,
      sym_block_comment,
  [93718] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3035), 1,
      anon_sym_PLUS,
    STATE(3407), 2,
      sym_line_comment,
      sym_block_comment,
  [93732] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6019), 1,
      anon_sym_GT,
    STATE(3408), 2,
      sym_line_comment,
      sym_block_comment,
  [93746] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6877), 1,
      sym_identifier,
    STATE(3409), 2,
      sym_line_comment,
      sym_block_comment,
  [93760] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4951), 1,
      anon_sym_COLON_COLON,
    STATE(3410), 2,
      sym_line_comment,
      sym_block_comment,
  [93774] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6879), 1,
      anon_sym_EQ_GT,
    STATE(3411), 2,
      sym_line_comment,
      sym_block_comment,
  [93788] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6881), 1,
      anon_sym_COLON_COLON,
    STATE(3412), 2,
      sym_line_comment,
      sym_block_comment,
  [93802] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6883), 1,
      anon_sym_RBRACK,
    STATE(3413), 2,
      sym_line_comment,
      sym_block_comment,
  [93816] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5127), 1,
      anon_sym_SEMI,
    STATE(3414), 2,
      sym_line_comment,
      sym_block_comment,
  [93830] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6885), 1,
      anon_sym_SEMI,
    STATE(3415), 2,
      sym_line_comment,
      sym_block_comment,
  [93844] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6887), 1,
      anon_sym_fn,
    STATE(3416), 2,
      sym_line_comment,
      sym_block_comment,
  [93858] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6889), 1,
      sym__raw_string_literal_end,
    STATE(3417), 2,
      sym_line_comment,
      sym_block_comment,
  [93872] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(949), 1,
      anon_sym_RBRACK,
    STATE(3418), 2,
      sym_line_comment,
      sym_block_comment,
  [93886] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6891), 1,
      anon_sym_LT,
    STATE(3419), 2,
      sym_line_comment,
      sym_block_comment,
  [93900] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6893), 1,
      anon_sym_SEMI,
    STATE(3420), 2,
      sym_line_comment,
      sym_block_comment,
  [93914] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6895), 1,
      anon_sym_SEMI,
    STATE(3421), 2,
      sym_line_comment,
      sym_block_comment,
  [93928] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6897), 1,
      anon_sym_COLON_COLON,
    STATE(3422), 2,
      sym_line_comment,
      sym_block_comment,
  [93942] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6899), 1,
      anon_sym_RBRACK,
    STATE(3423), 2,
      sym_line_comment,
      sym_block_comment,
  [93956] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6901), 1,
      anon_sym_SEMI,
    STATE(3424), 2,
      sym_line_comment,
      sym_block_comment,
  [93970] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6903), 1,
      sym_identifier,
    STATE(3425), 2,
      sym_line_comment,
      sym_block_comment,
  [93984] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6905), 1,
      sym_identifier,
    STATE(3426), 2,
      sym_line_comment,
      sym_block_comment,
  [93998] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6907), 1,
      anon_sym_fn,
    STATE(3427), 2,
      sym_line_comment,
      sym_block_comment,
  [94012] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6909), 1,
      anon_sym_SEMI,
    STATE(3428), 2,
      sym_line_comment,
      sym_block_comment,
  [94026] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6911), 1,
      anon_sym_STAR_SLASH,
    STATE(3429), 2,
      sym_line_comment,
      sym_block_comment,
  [94040] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6913), 1,
      sym_identifier,
    STATE(3430), 2,
      sym_line_comment,
      sym_block_comment,
  [94054] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6915), 1,
      sym_identifier,
    STATE(3431), 2,
      sym_line_comment,
      sym_block_comment,
  [94068] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4525), 1,
      anon_sym_COLON_COLON,
    STATE(3432), 2,
      sym_line_comment,
      sym_block_comment,
  [94082] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6917), 1,
      sym_identifier,
    STATE(3433), 2,
      sym_line_comment,
      sym_block_comment,
  [94096] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5123), 1,
      anon_sym_COLON_COLON,
    STATE(3434), 2,
      sym_line_comment,
      sym_block_comment,
  [94110] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6919), 1,
      anon_sym_SEMI,
    STATE(3435), 2,
      sym_line_comment,
      sym_block_comment,
  [94124] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6921), 1,
      anon_sym_SEMI,
    STATE(3436), 2,
      sym_line_comment,
      sym_block_comment,
  [94138] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6003), 1,
      anon_sym_RBRACE,
    STATE(3437), 2,
      sym_line_comment,
      sym_block_comment,
  [94152] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5807), 1,
      anon_sym_RPAREN,
    STATE(3438), 2,
      sym_line_comment,
      sym_block_comment,
  [94166] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6923), 1,
      anon_sym_RPAREN,
    STATE(3439), 2,
      sym_line_comment,
      sym_block_comment,
  [94180] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6925), 1,
      anon_sym_RBRACK,
    STATE(3440), 2,
      sym_line_comment,
      sym_block_comment,
  [94194] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6927), 1,
      anon_sym_SEMI,
    STATE(3441), 2,
      sym_line_comment,
      sym_block_comment,
  [94208] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6929), 1,
      anon_sym_RBRACE,
    STATE(3442), 2,
      sym_line_comment,
      sym_block_comment,
  [94222] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6931), 1,
      anon_sym_SEMI,
    STATE(3443), 2,
      sym_line_comment,
      sym_block_comment,
  [94236] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5674), 1,
      anon_sym_LBRACE,
    STATE(3444), 2,
      sym_line_comment,
      sym_block_comment,
  [94250] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6933), 1,
      anon_sym_SEMI,
    STATE(3445), 2,
      sym_line_comment,
      sym_block_comment,
  [94264] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(931), 1,
      anon_sym_RBRACK,
    STATE(3446), 2,
      sym_line_comment,
      sym_block_comment,
  [94278] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6935), 1,
      anon_sym_SEMI,
    STATE(3447), 2,
      sym_line_comment,
      sym_block_comment,
  [94292] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6937), 1,
      anon_sym_RBRACE,
    STATE(3448), 2,
      sym_line_comment,
      sym_block_comment,
  [94306] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6939), 1,
      sym_raw_string_literal_content,
    STATE(3449), 2,
      sym_line_comment,
      sym_block_comment,
  [94320] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6941), 1,
      anon_sym_RBRACK,
    STATE(3450), 2,
      sym_line_comment,
      sym_block_comment,
  [94334] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6943), 1,
      sym_identifier,
    STATE(3451), 2,
      sym_line_comment,
      sym_block_comment,
  [94348] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6945), 1,
      anon_sym_RPAREN,
    STATE(3452), 2,
      sym_line_comment,
      sym_block_comment,
  [94362] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4097), 1,
      anon_sym_COLON_COLON,
    STATE(3453), 2,
      sym_line_comment,
      sym_block_comment,
  [94376] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5598), 1,
      anon_sym_COLON_COLON,
    STATE(3454), 2,
      sym_line_comment,
      sym_block_comment,
  [94390] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6489), 1,
      anon_sym_LBRACK,
    STATE(3455), 2,
      sym_line_comment,
      sym_block_comment,
  [94404] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6947), 1,
      anon_sym_COLON,
    STATE(3456), 2,
      sym_line_comment,
      sym_block_comment,
  [94418] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6949), 1,
      anon_sym_COLON,
    STATE(3457), 2,
      sym_line_comment,
      sym_block_comment,
  [94432] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6951), 1,
      anon_sym_COLON_COLON,
    STATE(3458), 2,
      sym_line_comment,
      sym_block_comment,
  [94446] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6953), 1,
      anon_sym_RBRACK,
    STATE(3459), 2,
      sym_line_comment,
      sym_block_comment,
  [94460] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6295), 1,
      anon_sym_RBRACE,
    STATE(3460), 2,
      sym_line_comment,
      sym_block_comment,
  [94474] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6955), 1,
      anon_sym_RPAREN,
    STATE(3461), 2,
      sym_line_comment,
      sym_block_comment,
  [94488] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6957), 1,
      anon_sym_fn,
    STATE(3462), 2,
      sym_line_comment,
      sym_block_comment,
  [94502] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6959), 1,
      sym__raw_string_literal_end,
    STATE(3463), 2,
      sym_line_comment,
      sym_block_comment,
  [94516] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6961), 1,
      anon_sym_COLON_COLON,
    STATE(3464), 2,
      sym_line_comment,
      sym_block_comment,
  [94530] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3045), 1,
      anon_sym_PLUS,
    STATE(3465), 2,
      sym_line_comment,
      sym_block_comment,
  [94544] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6963), 1,
      anon_sym_RPAREN,
    STATE(3466), 2,
      sym_line_comment,
      sym_block_comment,
  [94558] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6965), 1,
      anon_sym_COLON_COLON,
    STATE(3467), 2,
      sym_line_comment,
      sym_block_comment,
  [94572] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(773), 1,
      anon_sym_EQ_GT,
    STATE(3468), 2,
      sym_line_comment,
      sym_block_comment,
  [94586] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6967), 1,
      anon_sym_SEMI,
    STATE(3469), 2,
      sym_line_comment,
      sym_block_comment,
  [94600] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4909), 1,
      anon_sym_COLON_COLON,
    STATE(3470), 2,
      sym_line_comment,
      sym_block_comment,
  [94614] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5377), 1,
      anon_sym_RPAREN,
    STATE(3471), 2,
      sym_line_comment,
      sym_block_comment,
  [94628] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6969), 1,
      anon_sym_COLON_COLON,
    STATE(3472), 2,
      sym_line_comment,
      sym_block_comment,
  [94642] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6971), 1,
      anon_sym_fn,
    STATE(3473), 2,
      sym_line_comment,
      sym_block_comment,
  [94656] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6370), 1,
      anon_sym_RBRACE,
    STATE(3474), 2,
      sym_line_comment,
      sym_block_comment,
  [94670] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6973), 1,
      anon_sym_LBRACE,
    STATE(3475), 2,
      sym_line_comment,
      sym_block_comment,
  [94684] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6975), 1,
      anon_sym_SEMI,
    STATE(3476), 2,
      sym_line_comment,
      sym_block_comment,
  [94698] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6977), 1,
      anon_sym_LPAREN,
    STATE(3477), 2,
      sym_line_comment,
      sym_block_comment,
  [94712] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6979), 1,
      sym__line_doc_content,
    STATE(3478), 2,
      sym_line_comment,
      sym_block_comment,
  [94726] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6981), 1,
      sym__line_doc_content,
    STATE(3479), 2,
      sym_line_comment,
      sym_block_comment,
  [94740] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6983), 1,
      anon_sym_SEMI,
    STATE(3480), 2,
      sym_line_comment,
      sym_block_comment,
  [94754] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6985), 1,
      sym__line_doc_content,
    STATE(3481), 2,
      sym_line_comment,
      sym_block_comment,
  [94768] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6987), 1,
      sym_identifier,
    STATE(3482), 2,
      sym_line_comment,
      sym_block_comment,
  [94782] = 4,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6989), 1,
      aux_sym_line_comment_token2,
    STATE(3483), 2,
      sym_line_comment,
      sym_block_comment,
  [94796] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6991), 1,
      sym_raw_string_literal_content,
    STATE(3484), 2,
      sym_line_comment,
      sym_block_comment,
  [94810] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6993), 1,
      anon_sym_SEMI,
    STATE(3485), 2,
      sym_line_comment,
      sym_block_comment,
  [94824] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6995), 1,
      anon_sym_COLON,
    STATE(3486), 2,
      sym_line_comment,
      sym_block_comment,
  [94838] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6997), 1,
      anon_sym_RBRACK,
    STATE(3487), 2,
      sym_line_comment,
      sym_block_comment,
  [94852] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6999), 1,
      anon_sym_COLON_COLON,
    STATE(3488), 2,
      sym_line_comment,
      sym_block_comment,
  [94866] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7001), 1,
      anon_sym_SEMI,
    STATE(3489), 2,
      sym_line_comment,
      sym_block_comment,
  [94880] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7003), 1,
      anon_sym_SEMI,
    STATE(3490), 2,
      sym_line_comment,
      sym_block_comment,
  [94894] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7005), 1,
      anon_sym_COLON_COLON,
    STATE(3491), 2,
      sym_line_comment,
      sym_block_comment,
  [94908] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7007), 1,
      anon_sym_SEMI,
    STATE(3492), 2,
      sym_line_comment,
      sym_block_comment,
  [94922] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5963), 1,
      anon_sym_RBRACE,
    STATE(3493), 2,
      sym_line_comment,
      sym_block_comment,
  [94936] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7009), 1,
      anon_sym_COLON_COLON,
    STATE(3494), 2,
      sym_line_comment,
      sym_block_comment,
  [94950] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7011), 1,
      sym_identifier,
    STATE(3495), 2,
      sym_line_comment,
      sym_block_comment,
  [94964] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5854), 1,
      anon_sym_RPAREN,
    STATE(3496), 2,
      sym_line_comment,
      sym_block_comment,
  [94978] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7013), 1,
      anon_sym_COLON_COLON,
    STATE(3497), 2,
      sym_line_comment,
      sym_block_comment,
  [94992] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7015), 1,
      anon_sym_LBRACE,
    STATE(3498), 2,
      sym_line_comment,
      sym_block_comment,
  [95006] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6633), 1,
      anon_sym_COLON_COLON,
    STATE(3499), 2,
      sym_line_comment,
      sym_block_comment,
  [95020] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5953), 1,
      anon_sym_RBRACE,
    STATE(3500), 2,
      sym_line_comment,
      sym_block_comment,
  [95034] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4471), 1,
      anon_sym_fn,
    STATE(3501), 2,
      sym_line_comment,
      sym_block_comment,
  [95048] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7017), 1,
      ts_builtin_sym_end,
    STATE(3502), 2,
      sym_line_comment,
      sym_block_comment,
  [95062] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7019), 1,
      sym_raw_string_literal_content,
    STATE(3503), 2,
      sym_line_comment,
      sym_block_comment,
  [95076] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3513), 1,
      anon_sym_COLON_COLON,
    STATE(3504), 2,
      sym_line_comment,
      sym_block_comment,
  [95090] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7021), 1,
      anon_sym_SEMI,
    STATE(3505), 2,
      sym_line_comment,
      sym_block_comment,
  [95104] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7023), 1,
      anon_sym_COLON_COLON,
    STATE(3506), 2,
      sym_line_comment,
      sym_block_comment,
  [95118] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3869), 1,
      anon_sym_COLON_COLON,
    STATE(3507), 2,
      sym_line_comment,
      sym_block_comment,
  [95132] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7025), 1,
      anon_sym_LBRACE,
    STATE(3508), 2,
      sym_line_comment,
      sym_block_comment,
  [95146] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7027), 1,
      sym_raw_string_literal_content,
    STATE(3509), 2,
      sym_line_comment,
      sym_block_comment,
  [95160] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5191), 1,
      anon_sym_COLON_COLON,
    STATE(3510), 2,
      sym_line_comment,
      sym_block_comment,
  [95174] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7029), 1,
      anon_sym_COLON_COLON,
    STATE(3511), 2,
      sym_line_comment,
      sym_block_comment,
  [95188] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5588), 1,
      anon_sym_LBRACE,
    STATE(3512), 2,
      sym_line_comment,
      sym_block_comment,
  [95202] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5732), 1,
      anon_sym_COLON_COLON,
    STATE(3513), 2,
      sym_line_comment,
      sym_block_comment,
  [95216] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7031), 1,
      anon_sym_COLON_COLON,
    STATE(3514), 2,
      sym_line_comment,
      sym_block_comment,
  [95230] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    STATE(3515), 2,
      sym_line_comment,
      sym_block_comment,
  [95244] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7033), 1,
      anon_sym_COLON_COLON,
    STATE(3516), 2,
      sym_line_comment,
      sym_block_comment,
  [95258] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5163), 1,
      anon_sym_COLON_COLON,
    STATE(3517), 2,
      sym_line_comment,
      sym_block_comment,
  [95272] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5171), 1,
      anon_sym_COLON_COLON,
    STATE(3518), 2,
      sym_line_comment,
      sym_block_comment,
  [95286] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4079), 1,
      anon_sym_COLON_COLON,
    STATE(3519), 2,
      sym_line_comment,
      sym_block_comment,
  [95300] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7035), 1,
      anon_sym_COLON_COLON,
    STATE(3520), 2,
      sym_line_comment,
      sym_block_comment,
  [95314] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5858), 1,
      anon_sym_RPAREN,
    STATE(3521), 2,
      sym_line_comment,
      sym_block_comment,
  [95328] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7037), 1,
      anon_sym_SEMI,
    STATE(3522), 2,
      sym_line_comment,
      sym_block_comment,
  [95342] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7039), 1,
      sym_identifier,
    STATE(3523), 2,
      sym_line_comment,
      sym_block_comment,
  [95356] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7041), 1,
      anon_sym_COLON,
    STATE(3524), 2,
      sym_line_comment,
      sym_block_comment,
  [95370] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7043), 1,
      anon_sym_COLON,
    STATE(3525), 2,
      sym_line_comment,
      sym_block_comment,
  [95384] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7045), 1,
      anon_sym_LBRACK,
    STATE(3526), 2,
      sym_line_comment,
      sym_block_comment,
  [95398] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5794), 1,
      anon_sym_RBRACK,
    STATE(3527), 2,
      sym_line_comment,
      sym_block_comment,
  [95412] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7047), 1,
      anon_sym_LBRACK,
    STATE(3528), 2,
      sym_line_comment,
      sym_block_comment,
  [95426] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7049), 1,
      anon_sym_COLON,
    STATE(3529), 2,
      sym_line_comment,
      sym_block_comment,
  [95440] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7051), 1,
      anon_sym_COLON,
    STATE(3530), 2,
      sym_line_comment,
      sym_block_comment,
  [95454] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7053), 1,
      sym_identifier,
    STATE(3531), 2,
      sym_line_comment,
      sym_block_comment,
  [95468] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7055), 1,
      anon_sym_SEMI,
    STATE(3532), 2,
      sym_line_comment,
      sym_block_comment,
  [95482] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7057), 1,
      anon_sym_EQ_GT,
    STATE(3533), 2,
      sym_line_comment,
      sym_block_comment,
  [95496] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5425), 1,
      anon_sym_RPAREN,
    STATE(3534), 2,
      sym_line_comment,
      sym_block_comment,
  [95510] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7059), 1,
      anon_sym_COLON,
    STATE(3535), 2,
      sym_line_comment,
      sym_block_comment,
  [95524] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7061), 1,
      sym_identifier,
    STATE(3536), 2,
      sym_line_comment,
      sym_block_comment,
  [95538] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7063), 1,
      sym_identifier,
    STATE(3537), 2,
      sym_line_comment,
      sym_block_comment,
  [95552] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7065), 1,
      sym_identifier,
    STATE(3538), 2,
      sym_line_comment,
      sym_block_comment,
  [95566] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7067), 1,
      anon_sym_RPAREN,
    STATE(3539), 2,
      sym_line_comment,
      sym_block_comment,
  [95580] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7069), 1,
      sym_identifier,
    STATE(3540), 2,
      sym_line_comment,
      sym_block_comment,
  [95594] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7071), 1,
      anon_sym_EQ_GT,
    STATE(3541), 2,
      sym_line_comment,
      sym_block_comment,
  [95608] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7073), 1,
      sym_identifier,
    STATE(3542), 2,
      sym_line_comment,
      sym_block_comment,
  [95622] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7075), 1,
      anon_sym_RBRACE,
    STATE(3543), 2,
      sym_line_comment,
      sym_block_comment,
  [95636] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7077), 1,
      anon_sym_COLON,
    STATE(3544), 2,
      sym_line_comment,
      sym_block_comment,
  [95650] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7079), 1,
      anon_sym_COLON,
    STATE(3545), 2,
      sym_line_comment,
      sym_block_comment,
  [95664] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7081), 1,
      sym_identifier,
    STATE(3546), 2,
      sym_line_comment,
      sym_block_comment,
  [95678] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5165), 1,
      anon_sym_SEMI,
    STATE(3547), 2,
      sym_line_comment,
      sym_block_comment,
  [95692] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7083), 1,
      anon_sym_EQ_GT,
    STATE(3548), 2,
      sym_line_comment,
      sym_block_comment,
  [95706] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7085), 1,
      anon_sym_COLON,
    STATE(3549), 2,
      sym_line_comment,
      sym_block_comment,
  [95720] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7087), 1,
      anon_sym_SEMI,
    STATE(3550), 2,
      sym_line_comment,
      sym_block_comment,
  [95734] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(3087), 1,
      anon_sym_PLUS,
    STATE(3551), 2,
      sym_line_comment,
      sym_block_comment,
  [95748] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5511), 1,
      anon_sym_RPAREN,
    STATE(3552), 2,
      sym_line_comment,
      sym_block_comment,
  [95762] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7089), 1,
      anon_sym_SEMI,
    STATE(3553), 2,
      sym_line_comment,
      sym_block_comment,
  [95776] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5169), 1,
      anon_sym_SEMI,
    STATE(3554), 2,
      sym_line_comment,
      sym_block_comment,
  [95790] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7091), 1,
      anon_sym_COLON,
    STATE(3555), 2,
      sym_line_comment,
      sym_block_comment,
  [95804] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7093), 1,
      sym_identifier,
    STATE(3556), 2,
      sym_line_comment,
      sym_block_comment,
  [95818] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7095), 1,
      anon_sym_SEMI,
    STATE(3557), 2,
      sym_line_comment,
      sym_block_comment,
  [95832] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7097), 1,
      anon_sym_SEMI,
    STATE(3558), 2,
      sym_line_comment,
      sym_block_comment,
  [95846] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7099), 1,
      anon_sym_SEMI,
    STATE(3559), 2,
      sym_line_comment,
      sym_block_comment,
  [95860] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5914), 1,
      anon_sym_RBRACE,
    STATE(3560), 2,
      sym_line_comment,
      sym_block_comment,
  [95874] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7101), 1,
      sym_identifier,
    STATE(3561), 2,
      sym_line_comment,
      sym_block_comment,
  [95888] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7103), 1,
      anon_sym_EQ,
    STATE(3562), 2,
      sym_line_comment,
      sym_block_comment,
  [95902] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7105), 1,
      anon_sym_SEMI,
    STATE(3563), 2,
      sym_line_comment,
      sym_block_comment,
  [95916] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7107), 1,
      anon_sym_LPAREN,
    STATE(3564), 2,
      sym_line_comment,
      sym_block_comment,
  [95930] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7109), 1,
      sym_identifier,
    STATE(3565), 2,
      sym_line_comment,
      sym_block_comment,
  [95944] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4087), 1,
      anon_sym_RPAREN,
    STATE(3566), 2,
      sym_line_comment,
      sym_block_comment,
  [95958] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7111), 1,
      anon_sym_COLON,
    STATE(3567), 2,
      sym_line_comment,
      sym_block_comment,
  [95972] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7113), 1,
      anon_sym_SEMI,
    STATE(3568), 2,
      sym_line_comment,
      sym_block_comment,
  [95986] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7115), 1,
      anon_sym_COLON,
    STATE(3569), 2,
      sym_line_comment,
      sym_block_comment,
  [96000] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7117), 1,
      anon_sym_LBRACK,
    STATE(3570), 2,
      sym_line_comment,
      sym_block_comment,
  [96014] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7119), 1,
      anon_sym_LBRACK,
    STATE(3571), 2,
      sym_line_comment,
      sym_block_comment,
  [96028] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7121), 1,
      anon_sym_COLON,
    STATE(3572), 2,
      sym_line_comment,
      sym_block_comment,
  [96042] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7123), 1,
      sym__raw_string_literal_end,
    STATE(3573), 2,
      sym_line_comment,
      sym_block_comment,
  [96056] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5790), 1,
      anon_sym_RPAREN,
    STATE(3574), 2,
      sym_line_comment,
      sym_block_comment,
  [96070] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7125), 1,
      anon_sym_COLON,
    STATE(3575), 2,
      sym_line_comment,
      sym_block_comment,
  [96084] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7127), 1,
      anon_sym_COLON,
    STATE(3576), 2,
      sym_line_comment,
      sym_block_comment,
  [96098] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7129), 1,
      anon_sym_SEMI,
    STATE(3577), 2,
      sym_line_comment,
      sym_block_comment,
  [96112] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7131), 1,
      sym_identifier,
    STATE(3578), 2,
      sym_line_comment,
      sym_block_comment,
  [96126] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7133), 1,
      anon_sym_COLON,
    STATE(3579), 2,
      sym_line_comment,
      sym_block_comment,
  [96140] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7135), 1,
      anon_sym_COLON,
    STATE(3580), 2,
      sym_line_comment,
      sym_block_comment,
  [96154] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7137), 1,
      anon_sym_COLON,
    STATE(3581), 2,
      sym_line_comment,
      sym_block_comment,
  [96168] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7139), 1,
      sym_identifier,
    STATE(3582), 2,
      sym_line_comment,
      sym_block_comment,
  [96182] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(4495), 1,
      anon_sym_fn,
    STATE(3583), 2,
      sym_line_comment,
      sym_block_comment,
  [96196] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7141), 1,
      anon_sym_SEMI,
    STATE(3584), 2,
      sym_line_comment,
      sym_block_comment,
  [96210] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1013), 1,
      anon_sym_RBRACK,
    STATE(3585), 2,
      sym_line_comment,
      sym_block_comment,
  [96224] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7143), 1,
      sym_identifier,
    STATE(3586), 2,
      sym_line_comment,
      sym_block_comment,
  [96238] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7145), 1,
      sym_identifier,
    STATE(3587), 2,
      sym_line_comment,
      sym_block_comment,
  [96252] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5890), 1,
      anon_sym_RBRACE,
    STATE(3588), 2,
      sym_line_comment,
      sym_block_comment,
  [96266] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7147), 1,
      sym_identifier,
    STATE(3589), 2,
      sym_line_comment,
      sym_block_comment,
  [96280] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7149), 1,
      anon_sym_fn,
    STATE(3590), 2,
      sym_line_comment,
      sym_block_comment,
  [96294] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(6424), 1,
      anon_sym_RBRACE,
    STATE(3591), 2,
      sym_line_comment,
      sym_block_comment,
  [96308] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7151), 1,
      sym_identifier,
    STATE(3592), 2,
      sym_line_comment,
      sym_block_comment,
  [96322] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7153), 1,
      sym_identifier,
    STATE(3593), 2,
      sym_line_comment,
      sym_block_comment,
  [96336] = 4,
    ACTIONS(101), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(103), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7155), 1,
      anon_sym_SEMI,
    STATE(3594), 2,
      sym_line_comment,
      sym_block_comment,
  [96350] = 1,
    ACTIONS(7157), 1,
      ts_builtin_sym_end,
  [96354] = 1,
    ACTIONS(7159), 1,
      ts_builtin_sym_end,
  [96358] = 1,
    ACTIONS(7161), 1,
      ts_builtin_sym_end,
  [96362] = 1,
    ACTIONS(7163), 1,
      ts_builtin_sym_end,
  [96366] = 1,
    ACTIONS(7165), 1,
      ts_builtin_sym_end,
  [96370] = 1,
    ACTIONS(7167), 1,
      ts_builtin_sym_end,
  [96374] = 1,
    ACTIONS(7169), 1,
      ts_builtin_sym_end,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(1000)] = 0,
  [SMALL_STATE(1001)] = 75,
  [SMALL_STATE(1002)] = 150,
  [SMALL_STATE(1003)] = 224,
  [SMALL_STATE(1004)] = 294,
  [SMALL_STATE(1005)] = 363,
  [SMALL_STATE(1006)] = 462,
  [SMALL_STATE(1007)] = 561,
  [SMALL_STATE(1008)] = 638,
  [SMALL_STATE(1009)] = 712,
  [SMALL_STATE(1010)] = 786,
  [SMALL_STATE(1011)] = 860,
  [SMALL_STATE(1012)] = 927,
  [SMALL_STATE(1013)] = 990,
  [SMALL_STATE(1014)] = 1061,
  [SMALL_STATE(1015)] = 1128,
  [SMALL_STATE(1016)] = 1199,
  [SMALL_STATE(1017)] = 1262,
  [SMALL_STATE(1018)] = 1329,
  [SMALL_STATE(1019)] = 1392,
  [SMALL_STATE(1020)] = 1455,
  [SMALL_STATE(1021)] = 1518,
  [SMALL_STATE(1022)] = 1585,
  [SMALL_STATE(1023)] = 1656,
  [SMALL_STATE(1024)] = 1719,
  [SMALL_STATE(1025)] = 1782,
  [SMALL_STATE(1026)] = 1845,
  [SMALL_STATE(1027)] = 1916,
  [SMALL_STATE(1028)] = 1979,
  [SMALL_STATE(1029)] = 2049,
  [SMALL_STATE(1030)] = 2111,
  [SMALL_STATE(1031)] = 2173,
  [SMALL_STATE(1032)] = 2235,
  [SMALL_STATE(1033)] = 2297,
  [SMALL_STATE(1034)] = 2359,
  [SMALL_STATE(1035)] = 2421,
  [SMALL_STATE(1036)] = 2489,
  [SMALL_STATE(1037)] = 2555,
  [SMALL_STATE(1038)] = 2617,
  [SMALL_STATE(1039)] = 2679,
  [SMALL_STATE(1040)] = 2741,
  [SMALL_STATE(1041)] = 2802,
  [SMALL_STATE(1042)] = 2867,
  [SMALL_STATE(1043)] = 2928,
  [SMALL_STATE(1044)] = 3033,
  [SMALL_STATE(1045)] = 3094,
  [SMALL_STATE(1046)] = 3155,
  [SMALL_STATE(1047)] = 3218,
  [SMALL_STATE(1048)] = 3281,
  [SMALL_STATE(1049)] = 3344,
  [SMALL_STATE(1050)] = 3407,
  [SMALL_STATE(1051)] = 3472,
  [SMALL_STATE(1052)] = 3533,
  [SMALL_STATE(1053)] = 3594,
  [SMALL_STATE(1054)] = 3657,
  [SMALL_STATE(1055)] = 3718,
  [SMALL_STATE(1056)] = 3783,
  [SMALL_STATE(1057)] = 3888,
  [SMALL_STATE(1058)] = 3993,
  [SMALL_STATE(1059)] = 4054,
  [SMALL_STATE(1060)] = 4115,
  [SMALL_STATE(1061)] = 4178,
  [SMALL_STATE(1062)] = 4241,
  [SMALL_STATE(1063)] = 4302,
  [SMALL_STATE(1064)] = 4407,
  [SMALL_STATE(1065)] = 4512,
  [SMALL_STATE(1066)] = 4573,
  [SMALL_STATE(1067)] = 4636,
  [SMALL_STATE(1068)] = 4735,
  [SMALL_STATE(1069)] = 4840,
  [SMALL_STATE(1070)] = 4903,
  [SMALL_STATE(1071)] = 4966,
  [SMALL_STATE(1072)] = 5029,
  [SMALL_STATE(1073)] = 5090,
  [SMALL_STATE(1074)] = 5153,
  [SMALL_STATE(1075)] = 5252,
  [SMALL_STATE(1076)] = 5313,
  [SMALL_STATE(1077)] = 5376,
  [SMALL_STATE(1078)] = 5437,
  [SMALL_STATE(1079)] = 5500,
  [SMALL_STATE(1080)] = 5563,
  [SMALL_STATE(1081)] = 5626,
  [SMALL_STATE(1082)] = 5689,
  [SMALL_STATE(1083)] = 5752,
  [SMALL_STATE(1084)] = 5813,
  [SMALL_STATE(1085)] = 5874,
  [SMALL_STATE(1086)] = 5939,
  [SMALL_STATE(1087)] = 6000,
  [SMALL_STATE(1088)] = 6060,
  [SMALL_STATE(1089)] = 6120,
  [SMALL_STATE(1090)] = 6212,
  [SMALL_STATE(1091)] = 6272,
  [SMALL_STATE(1092)] = 6332,
  [SMALL_STATE(1093)] = 6392,
  [SMALL_STATE(1094)] = 6452,
  [SMALL_STATE(1095)] = 6512,
  [SMALL_STATE(1096)] = 6572,
  [SMALL_STATE(1097)] = 6632,
  [SMALL_STATE(1098)] = 6692,
  [SMALL_STATE(1099)] = 6752,
  [SMALL_STATE(1100)] = 6812,
  [SMALL_STATE(1101)] = 6872,
  [SMALL_STATE(1102)] = 6932,
  [SMALL_STATE(1103)] = 6992,
  [SMALL_STATE(1104)] = 7052,
  [SMALL_STATE(1105)] = 7112,
  [SMALL_STATE(1106)] = 7172,
  [SMALL_STATE(1107)] = 7232,
  [SMALL_STATE(1108)] = 7292,
  [SMALL_STATE(1109)] = 7352,
  [SMALL_STATE(1110)] = 7412,
  [SMALL_STATE(1111)] = 7472,
  [SMALL_STATE(1112)] = 7532,
  [SMALL_STATE(1113)] = 7592,
  [SMALL_STATE(1114)] = 7652,
  [SMALL_STATE(1115)] = 7712,
  [SMALL_STATE(1116)] = 7772,
  [SMALL_STATE(1117)] = 7832,
  [SMALL_STATE(1118)] = 7892,
  [SMALL_STATE(1119)] = 7952,
  [SMALL_STATE(1120)] = 8012,
  [SMALL_STATE(1121)] = 8072,
  [SMALL_STATE(1122)] = 8136,
  [SMALL_STATE(1123)] = 8196,
  [SMALL_STATE(1124)] = 8256,
  [SMALL_STATE(1125)] = 8316,
  [SMALL_STATE(1126)] = 8376,
  [SMALL_STATE(1127)] = 8436,
  [SMALL_STATE(1128)] = 8498,
  [SMALL_STATE(1129)] = 8558,
  [SMALL_STATE(1130)] = 8618,
  [SMALL_STATE(1131)] = 8678,
  [SMALL_STATE(1132)] = 8738,
  [SMALL_STATE(1133)] = 8798,
  [SMALL_STATE(1134)] = 8858,
  [SMALL_STATE(1135)] = 8918,
  [SMALL_STATE(1136)] = 8978,
  [SMALL_STATE(1137)] = 9070,
  [SMALL_STATE(1138)] = 9130,
  [SMALL_STATE(1139)] = 9190,
  [SMALL_STATE(1140)] = 9250,
  [SMALL_STATE(1141)] = 9310,
  [SMALL_STATE(1142)] = 9370,
  [SMALL_STATE(1143)] = 9430,
  [SMALL_STATE(1144)] = 9490,
  [SMALL_STATE(1145)] = 9550,
  [SMALL_STATE(1146)] = 9610,
  [SMALL_STATE(1147)] = 9670,
  [SMALL_STATE(1148)] = 9730,
  [SMALL_STATE(1149)] = 9790,
  [SMALL_STATE(1150)] = 9850,
  [SMALL_STATE(1151)] = 9910,
  [SMALL_STATE(1152)] = 9970,
  [SMALL_STATE(1153)] = 10030,
  [SMALL_STATE(1154)] = 10090,
  [SMALL_STATE(1155)] = 10152,
  [SMALL_STATE(1156)] = 10212,
  [SMALL_STATE(1157)] = 10272,
  [SMALL_STATE(1158)] = 10332,
  [SMALL_STATE(1159)] = 10392,
  [SMALL_STATE(1160)] = 10452,
  [SMALL_STATE(1161)] = 10512,
  [SMALL_STATE(1162)] = 10572,
  [SMALL_STATE(1163)] = 10632,
  [SMALL_STATE(1164)] = 10692,
  [SMALL_STATE(1165)] = 10752,
  [SMALL_STATE(1166)] = 10812,
  [SMALL_STATE(1167)] = 10872,
  [SMALL_STATE(1168)] = 10932,
  [SMALL_STATE(1169)] = 10992,
  [SMALL_STATE(1170)] = 11052,
  [SMALL_STATE(1171)] = 11112,
  [SMALL_STATE(1172)] = 11172,
  [SMALL_STATE(1173)] = 11232,
  [SMALL_STATE(1174)] = 11292,
  [SMALL_STATE(1175)] = 11352,
  [SMALL_STATE(1176)] = 11412,
  [SMALL_STATE(1177)] = 11472,
  [SMALL_STATE(1178)] = 11532,
  [SMALL_STATE(1179)] = 11592,
  [SMALL_STATE(1180)] = 11652,
  [SMALL_STATE(1181)] = 11712,
  [SMALL_STATE(1182)] = 11772,
  [SMALL_STATE(1183)] = 11832,
  [SMALL_STATE(1184)] = 11892,
  [SMALL_STATE(1185)] = 11952,
  [SMALL_STATE(1186)] = 12012,
  [SMALL_STATE(1187)] = 12072,
  [SMALL_STATE(1188)] = 12132,
  [SMALL_STATE(1189)] = 12192,
  [SMALL_STATE(1190)] = 12252,
  [SMALL_STATE(1191)] = 12312,
  [SMALL_STATE(1192)] = 12372,
  [SMALL_STATE(1193)] = 12432,
  [SMALL_STATE(1194)] = 12492,
  [SMALL_STATE(1195)] = 12552,
  [SMALL_STATE(1196)] = 12612,
  [SMALL_STATE(1197)] = 12672,
  [SMALL_STATE(1198)] = 12732,
  [SMALL_STATE(1199)] = 12792,
  [SMALL_STATE(1200)] = 12852,
  [SMALL_STATE(1201)] = 12912,
  [SMALL_STATE(1202)] = 12980,
  [SMALL_STATE(1203)] = 13040,
  [SMALL_STATE(1204)] = 13100,
  [SMALL_STATE(1205)] = 13160,
  [SMALL_STATE(1206)] = 13220,
  [SMALL_STATE(1207)] = 13280,
  [SMALL_STATE(1208)] = 13340,
  [SMALL_STATE(1209)] = 13400,
  [SMALL_STATE(1210)] = 13460,
  [SMALL_STATE(1211)] = 13520,
  [SMALL_STATE(1212)] = 13580,
  [SMALL_STATE(1213)] = 13640,
  [SMALL_STATE(1214)] = 13700,
  [SMALL_STATE(1215)] = 13760,
  [SMALL_STATE(1216)] = 13820,
  [SMALL_STATE(1217)] = 13880,
  [SMALL_STATE(1218)] = 13940,
  [SMALL_STATE(1219)] = 14000,
  [SMALL_STATE(1220)] = 14060,
  [SMALL_STATE(1221)] = 14120,
  [SMALL_STATE(1222)] = 14180,
  [SMALL_STATE(1223)] = 14240,
  [SMALL_STATE(1224)] = 14300,
  [SMALL_STATE(1225)] = 14360,
  [SMALL_STATE(1226)] = 14420,
  [SMALL_STATE(1227)] = 14480,
  [SMALL_STATE(1228)] = 14540,
  [SMALL_STATE(1229)] = 14600,
  [SMALL_STATE(1230)] = 14660,
  [SMALL_STATE(1231)] = 14720,
  [SMALL_STATE(1232)] = 14782,
  [SMALL_STATE(1233)] = 14842,
  [SMALL_STATE(1234)] = 14902,
  [SMALL_STATE(1235)] = 14962,
  [SMALL_STATE(1236)] = 15022,
  [SMALL_STATE(1237)] = 15082,
  [SMALL_STATE(1238)] = 15142,
  [SMALL_STATE(1239)] = 15202,
  [SMALL_STATE(1240)] = 15262,
  [SMALL_STATE(1241)] = 15322,
  [SMALL_STATE(1242)] = 15382,
  [SMALL_STATE(1243)] = 15442,
  [SMALL_STATE(1244)] = 15502,
  [SMALL_STATE(1245)] = 15562,
  [SMALL_STATE(1246)] = 15622,
  [SMALL_STATE(1247)] = 15682,
  [SMALL_STATE(1248)] = 15742,
  [SMALL_STATE(1249)] = 15802,
  [SMALL_STATE(1250)] = 15862,
  [SMALL_STATE(1251)] = 15922,
  [SMALL_STATE(1252)] = 15982,
  [SMALL_STATE(1253)] = 16042,
  [SMALL_STATE(1254)] = 16102,
  [SMALL_STATE(1255)] = 16162,
  [SMALL_STATE(1256)] = 16222,
  [SMALL_STATE(1257)] = 16282,
  [SMALL_STATE(1258)] = 16342,
  [SMALL_STATE(1259)] = 16402,
  [SMALL_STATE(1260)] = 16468,
  [SMALL_STATE(1261)] = 16528,
  [SMALL_STATE(1262)] = 16588,
  [SMALL_STATE(1263)] = 16648,
  [SMALL_STATE(1264)] = 16708,
  [SMALL_STATE(1265)] = 16768,
  [SMALL_STATE(1266)] = 16828,
  [SMALL_STATE(1267)] = 16888,
  [SMALL_STATE(1268)] = 16948,
  [SMALL_STATE(1269)] = 17008,
  [SMALL_STATE(1270)] = 17068,
  [SMALL_STATE(1271)] = 17128,
  [SMALL_STATE(1272)] = 17188,
  [SMALL_STATE(1273)] = 17248,
  [SMALL_STATE(1274)] = 17308,
  [SMALL_STATE(1275)] = 17368,
  [SMALL_STATE(1276)] = 17428,
  [SMALL_STATE(1277)] = 17488,
  [SMALL_STATE(1278)] = 17548,
  [SMALL_STATE(1279)] = 17608,
  [SMALL_STATE(1280)] = 17668,
  [SMALL_STATE(1281)] = 17728,
  [SMALL_STATE(1282)] = 17788,
  [SMALL_STATE(1283)] = 17848,
  [SMALL_STATE(1284)] = 17908,
  [SMALL_STATE(1285)] = 17968,
  [SMALL_STATE(1286)] = 18028,
  [SMALL_STATE(1287)] = 18088,
  [SMALL_STATE(1288)] = 18148,
  [SMALL_STATE(1289)] = 18208,
  [SMALL_STATE(1290)] = 18268,
  [SMALL_STATE(1291)] = 18328,
  [SMALL_STATE(1292)] = 18388,
  [SMALL_STATE(1293)] = 18448,
  [SMALL_STATE(1294)] = 18508,
  [SMALL_STATE(1295)] = 18568,
  [SMALL_STATE(1296)] = 18628,
  [SMALL_STATE(1297)] = 18688,
  [SMALL_STATE(1298)] = 18748,
  [SMALL_STATE(1299)] = 18808,
  [SMALL_STATE(1300)] = 18868,
  [SMALL_STATE(1301)] = 18928,
  [SMALL_STATE(1302)] = 18988,
  [SMALL_STATE(1303)] = 19048,
  [SMALL_STATE(1304)] = 19108,
  [SMALL_STATE(1305)] = 19168,
  [SMALL_STATE(1306)] = 19230,
  [SMALL_STATE(1307)] = 19290,
  [SMALL_STATE(1308)] = 19350,
  [SMALL_STATE(1309)] = 19410,
  [SMALL_STATE(1310)] = 19470,
  [SMALL_STATE(1311)] = 19530,
  [SMALL_STATE(1312)] = 19590,
  [SMALL_STATE(1313)] = 19650,
  [SMALL_STATE(1314)] = 19710,
  [SMALL_STATE(1315)] = 19770,
  [SMALL_STATE(1316)] = 19830,
  [SMALL_STATE(1317)] = 19890,
  [SMALL_STATE(1318)] = 19950,
  [SMALL_STATE(1319)] = 20010,
  [SMALL_STATE(1320)] = 20070,
  [SMALL_STATE(1321)] = 20130,
  [SMALL_STATE(1322)] = 20190,
  [SMALL_STATE(1323)] = 20250,
  [SMALL_STATE(1324)] = 20310,
  [SMALL_STATE(1325)] = 20370,
  [SMALL_STATE(1326)] = 20430,
  [SMALL_STATE(1327)] = 20490,
  [SMALL_STATE(1328)] = 20550,
  [SMALL_STATE(1329)] = 20610,
  [SMALL_STATE(1330)] = 20670,
  [SMALL_STATE(1331)] = 20730,
  [SMALL_STATE(1332)] = 20790,
  [SMALL_STATE(1333)] = 20850,
  [SMALL_STATE(1334)] = 20910,
  [SMALL_STATE(1335)] = 20970,
  [SMALL_STATE(1336)] = 21030,
  [SMALL_STATE(1337)] = 21090,
  [SMALL_STATE(1338)] = 21150,
  [SMALL_STATE(1339)] = 21210,
  [SMALL_STATE(1340)] = 21270,
  [SMALL_STATE(1341)] = 21330,
  [SMALL_STATE(1342)] = 21390,
  [SMALL_STATE(1343)] = 21450,
  [SMALL_STATE(1344)] = 21510,
  [SMALL_STATE(1345)] = 21570,
  [SMALL_STATE(1346)] = 21630,
  [SMALL_STATE(1347)] = 21690,
  [SMALL_STATE(1348)] = 21750,
  [SMALL_STATE(1349)] = 21810,
  [SMALL_STATE(1350)] = 21870,
  [SMALL_STATE(1351)] = 21930,
  [SMALL_STATE(1352)] = 21990,
  [SMALL_STATE(1353)] = 22050,
  [SMALL_STATE(1354)] = 22110,
  [SMALL_STATE(1355)] = 22170,
  [SMALL_STATE(1356)] = 22230,
  [SMALL_STATE(1357)] = 22290,
  [SMALL_STATE(1358)] = 22350,
  [SMALL_STATE(1359)] = 22410,
  [SMALL_STATE(1360)] = 22470,
  [SMALL_STATE(1361)] = 22530,
  [SMALL_STATE(1362)] = 22590,
  [SMALL_STATE(1363)] = 22650,
  [SMALL_STATE(1364)] = 22710,
  [SMALL_STATE(1365)] = 22770,
  [SMALL_STATE(1366)] = 22830,
  [SMALL_STATE(1367)] = 22890,
  [SMALL_STATE(1368)] = 22950,
  [SMALL_STATE(1369)] = 23010,
  [SMALL_STATE(1370)] = 23070,
  [SMALL_STATE(1371)] = 23130,
  [SMALL_STATE(1372)] = 23190,
  [SMALL_STATE(1373)] = 23250,
  [SMALL_STATE(1374)] = 23310,
  [SMALL_STATE(1375)] = 23370,
  [SMALL_STATE(1376)] = 23430,
  [SMALL_STATE(1377)] = 23490,
  [SMALL_STATE(1378)] = 23550,
  [SMALL_STATE(1379)] = 23610,
  [SMALL_STATE(1380)] = 23670,
  [SMALL_STATE(1381)] = 23730,
  [SMALL_STATE(1382)] = 23790,
  [SMALL_STATE(1383)] = 23850,
  [SMALL_STATE(1384)] = 23910,
  [SMALL_STATE(1385)] = 23970,
  [SMALL_STATE(1386)] = 24030,
  [SMALL_STATE(1387)] = 24090,
  [SMALL_STATE(1388)] = 24150,
  [SMALL_STATE(1389)] = 24210,
  [SMALL_STATE(1390)] = 24270,
  [SMALL_STATE(1391)] = 24330,
  [SMALL_STATE(1392)] = 24390,
  [SMALL_STATE(1393)] = 24450,
  [SMALL_STATE(1394)] = 24510,
  [SMALL_STATE(1395)] = 24570,
  [SMALL_STATE(1396)] = 24630,
  [SMALL_STATE(1397)] = 24690,
  [SMALL_STATE(1398)] = 24750,
  [SMALL_STATE(1399)] = 24810,
  [SMALL_STATE(1400)] = 24870,
  [SMALL_STATE(1401)] = 24930,
  [SMALL_STATE(1402)] = 24990,
  [SMALL_STATE(1403)] = 25050,
  [SMALL_STATE(1404)] = 25110,
  [SMALL_STATE(1405)] = 25170,
  [SMALL_STATE(1406)] = 25230,
  [SMALL_STATE(1407)] = 25290,
  [SMALL_STATE(1408)] = 25350,
  [SMALL_STATE(1409)] = 25410,
  [SMALL_STATE(1410)] = 25470,
  [SMALL_STATE(1411)] = 25530,
  [SMALL_STATE(1412)] = 25590,
  [SMALL_STATE(1413)] = 25650,
  [SMALL_STATE(1414)] = 25710,
  [SMALL_STATE(1415)] = 25770,
  [SMALL_STATE(1416)] = 25830,
  [SMALL_STATE(1417)] = 25890,
  [SMALL_STATE(1418)] = 25950,
  [SMALL_STATE(1419)] = 26010,
  [SMALL_STATE(1420)] = 26070,
  [SMALL_STATE(1421)] = 26130,
  [SMALL_STATE(1422)] = 26190,
  [SMALL_STATE(1423)] = 26250,
  [SMALL_STATE(1424)] = 26310,
  [SMALL_STATE(1425)] = 26370,
  [SMALL_STATE(1426)] = 26430,
  [SMALL_STATE(1427)] = 26490,
  [SMALL_STATE(1428)] = 26550,
  [SMALL_STATE(1429)] = 26610,
  [SMALL_STATE(1430)] = 26670,
  [SMALL_STATE(1431)] = 26730,
  [SMALL_STATE(1432)] = 26790,
  [SMALL_STATE(1433)] = 26856,
  [SMALL_STATE(1434)] = 26916,
  [SMALL_STATE(1435)] = 26976,
  [SMALL_STATE(1436)] = 27036,
  [SMALL_STATE(1437)] = 27102,
  [SMALL_STATE(1438)] = 27162,
  [SMALL_STATE(1439)] = 27222,
  [SMALL_STATE(1440)] = 27282,
  [SMALL_STATE(1441)] = 27342,
  [SMALL_STATE(1442)] = 27402,
  [SMALL_STATE(1443)] = 27462,
  [SMALL_STATE(1444)] = 27522,
  [SMALL_STATE(1445)] = 27582,
  [SMALL_STATE(1446)] = 27642,
  [SMALL_STATE(1447)] = 27702,
  [SMALL_STATE(1448)] = 27762,
  [SMALL_STATE(1449)] = 27822,
  [SMALL_STATE(1450)] = 27882,
  [SMALL_STATE(1451)] = 27942,
  [SMALL_STATE(1452)] = 28002,
  [SMALL_STATE(1453)] = 28062,
  [SMALL_STATE(1454)] = 28122,
  [SMALL_STATE(1455)] = 28182,
  [SMALL_STATE(1456)] = 28242,
  [SMALL_STATE(1457)] = 28302,
  [SMALL_STATE(1458)] = 28362,
  [SMALL_STATE(1459)] = 28422,
  [SMALL_STATE(1460)] = 28482,
  [SMALL_STATE(1461)] = 28542,
  [SMALL_STATE(1462)] = 28602,
  [SMALL_STATE(1463)] = 28666,
  [SMALL_STATE(1464)] = 28725,
  [SMALL_STATE(1465)] = 28786,
  [SMALL_STATE(1466)] = 28847,
  [SMALL_STATE(1467)] = 28942,
  [SMALL_STATE(1468)] = 29001,
  [SMALL_STATE(1469)] = 29060,
  [SMALL_STATE(1470)] = 29119,
  [SMALL_STATE(1471)] = 29178,
  [SMALL_STATE(1472)] = 29237,
  [SMALL_STATE(1473)] = 29332,
  [SMALL_STATE(1474)] = 29391,
  [SMALL_STATE(1475)] = 29475,
  [SMALL_STATE(1476)] = 29561,
  [SMALL_STATE(1477)] = 29659,
  [SMALL_STATE(1478)] = 29737,
  [SMALL_STATE(1479)] = 29829,
  [SMALL_STATE(1480)] = 29919,
  [SMALL_STATE(1481)] = 30011,
  [SMALL_STATE(1482)] = 30077,
  [SMALL_STATE(1483)] = 30167,
  [SMALL_STATE(1484)] = 30253,
  [SMALL_STATE(1485)] = 30323,
  [SMALL_STATE(1486)] = 30391,
  [SMALL_STATE(1487)] = 30461,
  [SMALL_STATE(1488)] = 30551,
  [SMALL_STATE(1489)] = 30641,
  [SMALL_STATE(1490)] = 30731,
  [SMALL_STATE(1491)] = 30807,
  [SMALL_STATE(1492)] = 30897,
  [SMALL_STATE(1493)] = 30995,
  [SMALL_STATE(1494)] = 31069,
  [SMALL_STATE(1495)] = 31161,
  [SMALL_STATE(1496)] = 31233,
  [SMALL_STATE(1497)] = 31315,
  [SMALL_STATE(1498)] = 31413,
  [SMALL_STATE(1499)] = 31498,
  [SMALL_STATE(1500)] = 31561,
  [SMALL_STATE(1501)] = 31646,
  [SMALL_STATE(1502)] = 31731,
  [SMALL_STATE(1503)] = 31796,
  [SMALL_STATE(1504)] = 31881,
  [SMALL_STATE(1505)] = 31948,
  [SMALL_STATE(1506)] = 32011,
  [SMALL_STATE(1507)] = 32078,
  [SMALL_STATE(1508)] = 32145,
  [SMALL_STATE(1509)] = 32209,
  [SMALL_STATE(1510)] = 32267,
  [SMALL_STATE(1511)] = 32327,
  [SMALL_STATE(1512)] = 32387,
  [SMALL_STATE(1513)] = 32447,
  [SMALL_STATE(1514)] = 32511,
  [SMALL_STATE(1515)] = 32575,
  [SMALL_STATE(1516)] = 32633,
  [SMALL_STATE(1517)] = 32689,
  [SMALL_STATE(1518)] = 32749,
  [SMALL_STATE(1519)] = 32805,
  [SMALL_STATE(1520)] = 32865,
  [SMALL_STATE(1521)] = 32929,
  [SMALL_STATE(1522)] = 32989,
  [SMALL_STATE(1523)] = 33047,
  [SMALL_STATE(1524)] = 33103,
  [SMALL_STATE(1525)] = 33159,
  [SMALL_STATE(1526)] = 33215,
  [SMALL_STATE(1527)] = 33271,
  [SMALL_STATE(1528)] = 33329,
  [SMALL_STATE(1529)] = 33385,
  [SMALL_STATE(1530)] = 33443,
  [SMALL_STATE(1531)] = 33501,
  [SMALL_STATE(1532)] = 33561,
  [SMALL_STATE(1533)] = 33617,
  [SMALL_STATE(1534)] = 33673,
  [SMALL_STATE(1535)] = 33728,
  [SMALL_STATE(1536)] = 33787,
  [SMALL_STATE(1537)] = 33846,
  [SMALL_STATE(1538)] = 33901,
  [SMALL_STATE(1539)] = 33956,
  [SMALL_STATE(1540)] = 34015,
  [SMALL_STATE(1541)] = 34110,
  [SMALL_STATE(1542)] = 34205,
  [SMALL_STATE(1543)] = 34300,
  [SMALL_STATE(1544)] = 34355,
  [SMALL_STATE(1545)] = 34450,
  [SMALL_STATE(1546)] = 34545,
  [SMALL_STATE(1547)] = 34640,
  [SMALL_STATE(1548)] = 34695,
  [SMALL_STATE(1549)] = 34752,
  [SMALL_STATE(1550)] = 34809,
  [SMALL_STATE(1551)] = 34864,
  [SMALL_STATE(1552)] = 34921,
  [SMALL_STATE(1553)] = 34978,
  [SMALL_STATE(1554)] = 35033,
  [SMALL_STATE(1555)] = 35128,
  [SMALL_STATE(1556)] = 35185,
  [SMALL_STATE(1557)] = 35280,
  [SMALL_STATE(1558)] = 35335,
  [SMALL_STATE(1559)] = 35430,
  [SMALL_STATE(1560)] = 35487,
  [SMALL_STATE(1561)] = 35582,
  [SMALL_STATE(1562)] = 35677,
  [SMALL_STATE(1563)] = 35734,
  [SMALL_STATE(1564)] = 35829,
  [SMALL_STATE(1565)] = 35888,
  [SMALL_STATE(1566)] = 35980,
  [SMALL_STATE(1567)] = 36066,
  [SMALL_STATE(1568)] = 36122,
  [SMALL_STATE(1569)] = 36210,
  [SMALL_STATE(1570)] = 36264,
  [SMALL_STATE(1571)] = 36356,
  [SMALL_STATE(1572)] = 36410,
  [SMALL_STATE(1573)] = 36464,
  [SMALL_STATE(1574)] = 36518,
  [SMALL_STATE(1575)] = 36572,
  [SMALL_STATE(1576)] = 36628,
  [SMALL_STATE(1577)] = 36684,
  [SMALL_STATE(1578)] = 36740,
  [SMALL_STATE(1579)] = 36796,
  [SMALL_STATE(1580)] = 36882,
  [SMALL_STATE(1581)] = 36940,
  [SMALL_STATE(1582)] = 37032,
  [SMALL_STATE(1583)] = 37124,
  [SMALL_STATE(1584)] = 37212,
  [SMALL_STATE(1585)] = 37304,
  [SMALL_STATE(1586)] = 37360,
  [SMALL_STATE(1587)] = 37414,
  [SMALL_STATE(1588)] = 37502,
  [SMALL_STATE(1589)] = 37556,
  [SMALL_STATE(1590)] = 37638,
  [SMALL_STATE(1591)] = 37692,
  [SMALL_STATE(1592)] = 37748,
  [SMALL_STATE(1593)] = 37830,
  [SMALL_STATE(1594)] = 37918,
  [SMALL_STATE(1595)] = 37972,
  [SMALL_STATE(1596)] = 38046,
  [SMALL_STATE(1597)] = 38102,
  [SMALL_STATE(1598)] = 38158,
  [SMALL_STATE(1599)] = 38244,
  [SMALL_STATE(1600)] = 38330,
  [SMALL_STATE(1601)] = 38396,
  [SMALL_STATE(1602)] = 38476,
  [SMALL_STATE(1603)] = 38564,
  [SMALL_STATE(1604)] = 38650,
  [SMALL_STATE(1605)] = 38706,
  [SMALL_STATE(1606)] = 38784,
  [SMALL_STATE(1607)] = 38856,
  [SMALL_STATE(1608)] = 38912,
  [SMALL_STATE(1609)] = 38980,
  [SMALL_STATE(1610)] = 39050,
  [SMALL_STATE(1611)] = 39114,
  [SMALL_STATE(1612)] = 39206,
  [SMALL_STATE(1613)] = 39292,
  [SMALL_STATE(1614)] = 39346,
  [SMALL_STATE(1615)] = 39434,
  [SMALL_STATE(1616)] = 39490,
  [SMALL_STATE(1617)] = 39544,
  [SMALL_STATE(1618)] = 39598,
  [SMALL_STATE(1619)] = 39686,
  [SMALL_STATE(1620)] = 39740,
  [SMALL_STATE(1621)] = 39796,
  [SMALL_STATE(1622)] = 39850,
  [SMALL_STATE(1623)] = 39938,
  [SMALL_STATE(1624)] = 39994,
  [SMALL_STATE(1625)] = 40048,
  [SMALL_STATE(1626)] = 40104,
  [SMALL_STATE(1627)] = 40160,
  [SMALL_STATE(1628)] = 40214,
  [SMALL_STATE(1629)] = 40293,
  [SMALL_STATE(1630)] = 40346,
  [SMALL_STATE(1631)] = 40399,
  [SMALL_STATE(1632)] = 40488,
  [SMALL_STATE(1633)] = 40541,
  [SMALL_STATE(1634)] = 40594,
  [SMALL_STATE(1635)] = 40647,
  [SMALL_STATE(1636)] = 40734,
  [SMALL_STATE(1637)] = 40815,
  [SMALL_STATE(1638)] = 40902,
  [SMALL_STATE(1639)] = 40991,
  [SMALL_STATE(1640)] = 41044,
  [SMALL_STATE(1641)] = 41131,
  [SMALL_STATE(1642)] = 41184,
  [SMALL_STATE(1643)] = 41257,
  [SMALL_STATE(1644)] = 41310,
  [SMALL_STATE(1645)] = 41395,
  [SMALL_STATE(1646)] = 41448,
  [SMALL_STATE(1647)] = 41537,
  [SMALL_STATE(1648)] = 41624,
  [SMALL_STATE(1649)] = 41711,
  [SMALL_STATE(1650)] = 41764,
  [SMALL_STATE(1651)] = 41849,
  [SMALL_STATE(1652)] = 41902,
  [SMALL_STATE(1653)] = 41967,
  [SMALL_STATE(1654)] = 42044,
  [SMALL_STATE(1655)] = 42133,
  [SMALL_STATE(1656)] = 42186,
  [SMALL_STATE(1657)] = 42275,
  [SMALL_STATE(1658)] = 42364,
  [SMALL_STATE(1659)] = 42435,
  [SMALL_STATE(1660)] = 42502,
  [SMALL_STATE(1661)] = 42571,
  [SMALL_STATE(1662)] = 42660,
  [SMALL_STATE(1663)] = 42747,
  [SMALL_STATE(1664)] = 42834,
  [SMALL_STATE(1665)] = 42897,
  [SMALL_STATE(1666)] = 42950,
  [SMALL_STATE(1667)] = 43039,
  [SMALL_STATE(1668)] = 43092,
  [SMALL_STATE(1669)] = 43181,
  [SMALL_STATE(1670)] = 43234,
  [SMALL_STATE(1671)] = 43287,
  [SMALL_STATE(1672)] = 43376,
  [SMALL_STATE(1673)] = 43457,
  [SMALL_STATE(1674)] = 43546,
  [SMALL_STATE(1675)] = 43635,
  [SMALL_STATE(1676)] = 43722,
  [SMALL_STATE(1677)] = 43775,
  [SMALL_STATE(1678)] = 43828,
  [SMALL_STATE(1679)] = 43881,
  [SMALL_STATE(1680)] = 43966,
  [SMALL_STATE(1681)] = 44019,
  [SMALL_STATE(1682)] = 44104,
  [SMALL_STATE(1683)] = 44193,
  [SMALL_STATE(1684)] = 44280,
  [SMALL_STATE(1685)] = 44369,
  [SMALL_STATE(1686)] = 44422,
  [SMALL_STATE(1687)] = 44507,
  [SMALL_STATE(1688)] = 44560,
  [SMALL_STATE(1689)] = 44649,
  [SMALL_STATE(1690)] = 44702,
  [SMALL_STATE(1691)] = 44755,
  [SMALL_STATE(1692)] = 44840,
  [SMALL_STATE(1693)] = 44893,
  [SMALL_STATE(1694)] = 44982,
  [SMALL_STATE(1695)] = 45071,
  [SMALL_STATE(1696)] = 45124,
  [SMALL_STATE(1697)] = 45177,
  [SMALL_STATE(1698)] = 45266,
  [SMALL_STATE(1699)] = 45325,
  [SMALL_STATE(1700)] = 45414,
  [SMALL_STATE(1701)] = 45473,
  [SMALL_STATE(1702)] = 45526,
  [SMALL_STATE(1703)] = 45579,
  [SMALL_STATE(1704)] = 45632,
  [SMALL_STATE(1705)] = 45713,
  [SMALL_STATE(1706)] = 45766,
  [SMALL_STATE(1707)] = 45855,
  [SMALL_STATE(1708)] = 45944,
  [SMALL_STATE(1709)] = 46033,
  [SMALL_STATE(1710)] = 46122,
  [SMALL_STATE(1711)] = 46209,
  [SMALL_STATE(1712)] = 46262,
  [SMALL_STATE(1713)] = 46351,
  [SMALL_STATE(1714)] = 46404,
  [SMALL_STATE(1715)] = 46457,
  [SMALL_STATE(1716)] = 46510,
  [SMALL_STATE(1717)] = 46563,
  [SMALL_STATE(1718)] = 46652,
  [SMALL_STATE(1719)] = 46741,
  [SMALL_STATE(1720)] = 46822,
  [SMALL_STATE(1721)] = 46875,
  [SMALL_STATE(1722)] = 46964,
  [SMALL_STATE(1723)] = 47051,
  [SMALL_STATE(1724)] = 47140,
  [SMALL_STATE(1725)] = 47225,
  [SMALL_STATE(1726)] = 47314,
  [SMALL_STATE(1727)] = 47403,
  [SMALL_STATE(1728)] = 47456,
  [SMALL_STATE(1729)] = 47509,
  [SMALL_STATE(1730)] = 47594,
  [SMALL_STATE(1731)] = 47647,
  [SMALL_STATE(1732)] = 47736,
  [SMALL_STATE(1733)] = 47821,
  [SMALL_STATE(1734)] = 47910,
  [SMALL_STATE(1735)] = 47997,
  [SMALL_STATE(1736)] = 48082,
  [SMALL_STATE(1737)] = 48169,
  [SMALL_STATE(1738)] = 48258,
  [SMALL_STATE(1739)] = 48311,
  [SMALL_STATE(1740)] = 48400,
  [SMALL_STATE(1741)] = 48489,
  [SMALL_STATE(1742)] = 48542,
  [SMALL_STATE(1743)] = 48595,
  [SMALL_STATE(1744)] = 48684,
  [SMALL_STATE(1745)] = 48773,
  [SMALL_STATE(1746)] = 48826,
  [SMALL_STATE(1747)] = 48879,
  [SMALL_STATE(1748)] = 48932,
  [SMALL_STATE(1749)] = 49021,
  [SMALL_STATE(1750)] = 49108,
  [SMALL_STATE(1751)] = 49195,
  [SMALL_STATE(1752)] = 49258,
  [SMALL_STATE(1753)] = 49311,
  [SMALL_STATE(1754)] = 49364,
  [SMALL_STATE(1755)] = 49417,
  [SMALL_STATE(1756)] = 49486,
  [SMALL_STATE(1757)] = 49539,
  [SMALL_STATE(1758)] = 49592,
  [SMALL_STATE(1759)] = 49659,
  [SMALL_STATE(1760)] = 49712,
  [SMALL_STATE(1761)] = 49765,
  [SMALL_STATE(1762)] = 49818,
  [SMALL_STATE(1763)] = 49889,
  [SMALL_STATE(1764)] = 49942,
  [SMALL_STATE(1765)] = 50019,
  [SMALL_STATE(1766)] = 50098,
  [SMALL_STATE(1767)] = 50151,
  [SMALL_STATE(1768)] = 50210,
  [SMALL_STATE(1769)] = 50275,
  [SMALL_STATE(1770)] = 50360,
  [SMALL_STATE(1771)] = 50445,
  [SMALL_STATE(1772)] = 50518,
  [SMALL_STATE(1773)] = 50597,
  [SMALL_STATE(1774)] = 50650,
  [SMALL_STATE(1775)] = 50703,
  [SMALL_STATE(1776)] = 50756,
  [SMALL_STATE(1777)] = 50845,
  [SMALL_STATE(1778)] = 50934,
  [SMALL_STATE(1779)] = 50987,
  [SMALL_STATE(1780)] = 51076,
  [SMALL_STATE(1781)] = 51129,
  [SMALL_STATE(1782)] = 51182,
  [SMALL_STATE(1783)] = 51235,
  [SMALL_STATE(1784)] = 51324,
  [SMALL_STATE(1785)] = 51377,
  [SMALL_STATE(1786)] = 51466,
  [SMALL_STATE(1787)] = 51553,
  [SMALL_STATE(1788)] = 51638,
  [SMALL_STATE(1789)] = 51727,
  [SMALL_STATE(1790)] = 51780,
  [SMALL_STATE(1791)] = 51869,
  [SMALL_STATE(1792)] = 51956,
  [SMALL_STATE(1793)] = 52009,
  [SMALL_STATE(1794)] = 52062,
  [SMALL_STATE(1795)] = 52147,
  [SMALL_STATE(1796)] = 52200,
  [SMALL_STATE(1797)] = 52253,
  [SMALL_STATE(1798)] = 52306,
  [SMALL_STATE(1799)] = 52367,
  [SMALL_STATE(1800)] = 52420,
  [SMALL_STATE(1801)] = 52509,
  [SMALL_STATE(1802)] = 52562,
  [SMALL_STATE(1803)] = 52615,
  [SMALL_STATE(1804)] = 52668,
  [SMALL_STATE(1805)] = 52721,
  [SMALL_STATE(1806)] = 52808,
  [SMALL_STATE(1807)] = 52861,
  [SMALL_STATE(1808)] = 52914,
  [SMALL_STATE(1809)] = 52967,
  [SMALL_STATE(1810)] = 53020,
  [SMALL_STATE(1811)] = 53107,
  [SMALL_STATE(1812)] = 53196,
  [SMALL_STATE(1813)] = 53249,
  [SMALL_STATE(1814)] = 53302,
  [SMALL_STATE(1815)] = 53391,
  [SMALL_STATE(1816)] = 53444,
  [SMALL_STATE(1817)] = 53497,
  [SMALL_STATE(1818)] = 53586,
  [SMALL_STATE(1819)] = 53639,
  [SMALL_STATE(1820)] = 53692,
  [SMALL_STATE(1821)] = 53745,
  [SMALL_STATE(1822)] = 53798,
  [SMALL_STATE(1823)] = 53851,
  [SMALL_STATE(1824)] = 53904,
  [SMALL_STATE(1825)] = 53957,
  [SMALL_STATE(1826)] = 54010,
  [SMALL_STATE(1827)] = 54063,
  [SMALL_STATE(1828)] = 54152,
  [SMALL_STATE(1829)] = 54205,
  [SMALL_STATE(1830)] = 54258,
  [SMALL_STATE(1831)] = 54311,
  [SMALL_STATE(1832)] = 54364,
  [SMALL_STATE(1833)] = 54417,
  [SMALL_STATE(1834)] = 54470,
  [SMALL_STATE(1835)] = 54556,
  [SMALL_STATE(1836)] = 54642,
  [SMALL_STATE(1837)] = 54728,
  [SMALL_STATE(1838)] = 54814,
  [SMALL_STATE(1839)] = 54890,
  [SMALL_STATE(1840)] = 54976,
  [SMALL_STATE(1841)] = 55062,
  [SMALL_STATE(1842)] = 55146,
  [SMALL_STATE(1843)] = 55232,
  [SMALL_STATE(1844)] = 55318,
  [SMALL_STATE(1845)] = 55404,
  [SMALL_STATE(1846)] = 55480,
  [SMALL_STATE(1847)] = 55566,
  [SMALL_STATE(1848)] = 55652,
  [SMALL_STATE(1849)] = 55738,
  [SMALL_STATE(1850)] = 55824,
  [SMALL_STATE(1851)] = 55910,
  [SMALL_STATE(1852)] = 55996,
  [SMALL_STATE(1853)] = 56082,
  [SMALL_STATE(1854)] = 56168,
  [SMALL_STATE(1855)] = 56254,
  [SMALL_STATE(1856)] = 56338,
  [SMALL_STATE(1857)] = 56424,
  [SMALL_STATE(1858)] = 56510,
  [SMALL_STATE(1859)] = 56596,
  [SMALL_STATE(1860)] = 56682,
  [SMALL_STATE(1861)] = 56768,
  [SMALL_STATE(1862)] = 56854,
  [SMALL_STATE(1863)] = 56940,
  [SMALL_STATE(1864)] = 57026,
  [SMALL_STATE(1865)] = 57112,
  [SMALL_STATE(1866)] = 57198,
  [SMALL_STATE(1867)] = 57284,
  [SMALL_STATE(1868)] = 57370,
  [SMALL_STATE(1869)] = 57443,
  [SMALL_STATE(1870)] = 57516,
  [SMALL_STATE(1871)] = 57589,
  [SMALL_STATE(1872)] = 57662,
  [SMALL_STATE(1873)] = 57735,
  [SMALL_STATE(1874)] = 57809,
  [SMALL_STATE(1875)] = 57883,
  [SMALL_STATE(1876)] = 57957,
  [SMALL_STATE(1877)] = 58031,
  [SMALL_STATE(1878)] = 58105,
  [SMALL_STATE(1879)] = 58179,
  [SMALL_STATE(1880)] = 58253,
  [SMALL_STATE(1881)] = 58327,
  [SMALL_STATE(1882)] = 58373,
  [SMALL_STATE(1883)] = 58419,
  [SMALL_STATE(1884)] = 58465,
  [SMALL_STATE(1885)] = 58526,
  [SMALL_STATE(1886)] = 58587,
  [SMALL_STATE(1887)] = 58648,
  [SMALL_STATE(1888)] = 58709,
  [SMALL_STATE(1889)] = 58770,
  [SMALL_STATE(1890)] = 58831,
  [SMALL_STATE(1891)] = 58892,
  [SMALL_STATE(1892)] = 58953,
  [SMALL_STATE(1893)] = 59011,
  [SMALL_STATE(1894)] = 59069,
  [SMALL_STATE(1895)] = 59105,
  [SMALL_STATE(1896)] = 59141,
  [SMALL_STATE(1897)] = 59189,
  [SMALL_STATE(1898)] = 59226,
  [SMALL_STATE(1899)] = 59271,
  [SMALL_STATE(1900)] = 59316,
  [SMALL_STATE(1901)] = 59353,
  [SMALL_STATE(1902)] = 59390,
  [SMALL_STATE(1903)] = 59435,
  [SMALL_STATE(1904)] = 59488,
  [SMALL_STATE(1905)] = 59525,
  [SMALL_STATE(1906)] = 59565,
  [SMALL_STATE(1907)] = 59601,
  [SMALL_STATE(1908)] = 59641,
  [SMALL_STATE(1909)] = 59677,
  [SMALL_STATE(1910)] = 59713,
  [SMALL_STATE(1911)] = 59749,
  [SMALL_STATE(1912)] = 59789,
  [SMALL_STATE(1913)] = 59829,
  [SMALL_STATE(1914)] = 59862,
  [SMALL_STATE(1915)] = 59893,
  [SMALL_STATE(1916)] = 59926,
  [SMALL_STATE(1917)] = 59959,
  [SMALL_STATE(1918)] = 59992,
  [SMALL_STATE(1919)] = 60025,
  [SMALL_STATE(1920)] = 60058,
  [SMALL_STATE(1921)] = 60091,
  [SMALL_STATE(1922)] = 60124,
  [SMALL_STATE(1923)] = 60156,
  [SMALL_STATE(1924)] = 60188,
  [SMALL_STATE(1925)] = 60234,
  [SMALL_STATE(1926)] = 60266,
  [SMALL_STATE(1927)] = 60326,
  [SMALL_STATE(1928)] = 60386,
  [SMALL_STATE(1929)] = 60430,
  [SMALL_STATE(1930)] = 60461,
  [SMALL_STATE(1931)] = 60494,
  [SMALL_STATE(1932)] = 60523,
  [SMALL_STATE(1933)] = 60552,
  [SMALL_STATE(1934)] = 60581,
  [SMALL_STATE(1935)] = 60622,
  [SMALL_STATE(1936)] = 60653,
  [SMALL_STATE(1937)] = 60682,
  [SMALL_STATE(1938)] = 60715,
  [SMALL_STATE(1939)] = 60748,
  [SMALL_STATE(1940)] = 60781,
  [SMALL_STATE(1941)] = 60834,
  [SMALL_STATE(1942)] = 60863,
  [SMALL_STATE(1943)] = 60894,
  [SMALL_STATE(1944)] = 60923,
  [SMALL_STATE(1945)] = 60976,
  [SMALL_STATE(1946)] = 61007,
  [SMALL_STATE(1947)] = 61036,
  [SMALL_STATE(1948)] = 61065,
  [SMALL_STATE(1949)] = 61098,
  [SMALL_STATE(1950)] = 61131,
  [SMALL_STATE(1951)] = 61160,
  [SMALL_STATE(1952)] = 61203,
  [SMALL_STATE(1953)] = 61234,
  [SMALL_STATE(1954)] = 61289,
  [SMALL_STATE(1955)] = 61320,
  [SMALL_STATE(1956)] = 61351,
  [SMALL_STATE(1957)] = 61382,
  [SMALL_STATE(1958)] = 61410,
  [SMALL_STATE(1959)] = 61438,
  [SMALL_STATE(1960)] = 61466,
  [SMALL_STATE(1961)] = 61494,
  [SMALL_STATE(1962)] = 61522,
  [SMALL_STATE(1963)] = 61552,
  [SMALL_STATE(1964)] = 61580,
  [SMALL_STATE(1965)] = 61608,
  [SMALL_STATE(1966)] = 61636,
  [SMALL_STATE(1967)] = 61666,
  [SMALL_STATE(1968)] = 61694,
  [SMALL_STATE(1969)] = 61722,
  [SMALL_STATE(1970)] = 61750,
  [SMALL_STATE(1971)] = 61778,
  [SMALL_STATE(1972)] = 61806,
  [SMALL_STATE(1973)] = 61834,
  [SMALL_STATE(1974)] = 61862,
  [SMALL_STATE(1975)] = 61890,
  [SMALL_STATE(1976)] = 61918,
  [SMALL_STATE(1977)] = 61946,
  [SMALL_STATE(1978)] = 61974,
  [SMALL_STATE(1979)] = 62002,
  [SMALL_STATE(1980)] = 62030,
  [SMALL_STATE(1981)] = 62058,
  [SMALL_STATE(1982)] = 62086,
  [SMALL_STATE(1983)] = 62114,
  [SMALL_STATE(1984)] = 62142,
  [SMALL_STATE(1985)] = 62170,
  [SMALL_STATE(1986)] = 62198,
  [SMALL_STATE(1987)] = 62242,
  [SMALL_STATE(1988)] = 62270,
  [SMALL_STATE(1989)] = 62298,
  [SMALL_STATE(1990)] = 62327,
  [SMALL_STATE(1991)] = 62358,
  [SMALL_STATE(1992)] = 62409,
  [SMALL_STATE(1993)] = 62438,
  [SMALL_STATE(1994)] = 62473,
  [SMALL_STATE(1995)] = 62505,
  [SMALL_STATE(1996)] = 62549,
  [SMALL_STATE(1997)] = 62581,
  [SMALL_STATE(1998)] = 62613,
  [SMALL_STATE(1999)] = 62645,
  [SMALL_STATE(2000)] = 62677,
  [SMALL_STATE(2001)] = 62709,
  [SMALL_STATE(2002)] = 62739,
  [SMALL_STATE(2003)] = 62771,
  [SMALL_STATE(2004)] = 62803,
  [SMALL_STATE(2005)] = 62835,
  [SMALL_STATE(2006)] = 62863,
  [SMALL_STATE(2007)] = 62891,
  [SMALL_STATE(2008)] = 62923,
  [SMALL_STATE(2009)] = 62955,
  [SMALL_STATE(2010)] = 62987,
  [SMALL_STATE(2011)] = 63032,
  [SMALL_STATE(2012)] = 63077,
  [SMALL_STATE(2013)] = 63122,
  [SMALL_STATE(2014)] = 63167,
  [SMALL_STATE(2015)] = 63212,
  [SMALL_STATE(2016)] = 63257,
  [SMALL_STATE(2017)] = 63302,
  [SMALL_STATE(2018)] = 63347,
  [SMALL_STATE(2019)] = 63392,
  [SMALL_STATE(2020)] = 63437,
  [SMALL_STATE(2021)] = 63482,
  [SMALL_STATE(2022)] = 63527,
  [SMALL_STATE(2023)] = 63572,
  [SMALL_STATE(2024)] = 63617,
  [SMALL_STATE(2025)] = 63662,
  [SMALL_STATE(2026)] = 63699,
  [SMALL_STATE(2027)] = 63741,
  [SMALL_STATE(2028)] = 63769,
  [SMALL_STATE(2029)] = 63807,
  [SMALL_STATE(2030)] = 63831,
  [SMALL_STATE(2031)] = 63869,
  [SMALL_STATE(2032)] = 63907,
  [SMALL_STATE(2033)] = 63945,
  [SMALL_STATE(2034)] = 63969,
  [SMALL_STATE(2035)] = 64009,
  [SMALL_STATE(2036)] = 64043,
  [SMALL_STATE(2037)] = 64073,
  [SMALL_STATE(2038)] = 64107,
  [SMALL_STATE(2039)] = 64131,
  [SMALL_STATE(2040)] = 64159,
  [SMALL_STATE(2041)] = 64187,
  [SMALL_STATE(2042)] = 64217,
  [SMALL_STATE(2043)] = 64245,
  [SMALL_STATE(2044)] = 64269,
  [SMALL_STATE(2045)] = 64297,
  [SMALL_STATE(2046)] = 64325,
  [SMALL_STATE(2047)] = 64353,
  [SMALL_STATE(2048)] = 64395,
  [SMALL_STATE(2049)] = 64423,
  [SMALL_STATE(2050)] = 64465,
  [SMALL_STATE(2051)] = 64503,
  [SMALL_STATE(2052)] = 64545,
  [SMALL_STATE(2053)] = 64585,
  [SMALL_STATE(2054)] = 64609,
  [SMALL_STATE(2055)] = 64637,
  [SMALL_STATE(2056)] = 64675,
  [SMALL_STATE(2057)] = 64715,
  [SMALL_STATE(2058)] = 64745,
  [SMALL_STATE(2059)] = 64773,
  [SMALL_STATE(2060)] = 64801,
  [SMALL_STATE(2061)] = 64829,
  [SMALL_STATE(2062)] = 64867,
  [SMALL_STATE(2063)] = 64909,
  [SMALL_STATE(2064)] = 64947,
  [SMALL_STATE(2065)] = 64977,
  [SMALL_STATE(2066)] = 65015,
  [SMALL_STATE(2067)] = 65057,
  [SMALL_STATE(2068)] = 65099,
  [SMALL_STATE(2069)] = 65140,
  [SMALL_STATE(2070)] = 65171,
  [SMALL_STATE(2071)] = 65194,
  [SMALL_STATE(2072)] = 65217,
  [SMALL_STATE(2073)] = 65240,
  [SMALL_STATE(2074)] = 65263,
  [SMALL_STATE(2075)] = 65286,
  [SMALL_STATE(2076)] = 65323,
  [SMALL_STATE(2077)] = 65346,
  [SMALL_STATE(2078)] = 65383,
  [SMALL_STATE(2079)] = 65406,
  [SMALL_STATE(2080)] = 65437,
  [SMALL_STATE(2081)] = 65478,
  [SMALL_STATE(2082)] = 65515,
  [SMALL_STATE(2083)] = 65552,
  [SMALL_STATE(2084)] = 65575,
  [SMALL_STATE(2085)] = 65598,
  [SMALL_STATE(2086)] = 65621,
  [SMALL_STATE(2087)] = 65644,
  [SMALL_STATE(2088)] = 65667,
  [SMALL_STATE(2089)] = 65690,
  [SMALL_STATE(2090)] = 65713,
  [SMALL_STATE(2091)] = 65736,
  [SMALL_STATE(2092)] = 65759,
  [SMALL_STATE(2093)] = 65782,
  [SMALL_STATE(2094)] = 65823,
  [SMALL_STATE(2095)] = 65858,
  [SMALL_STATE(2096)] = 65881,
  [SMALL_STATE(2097)] = 65904,
  [SMALL_STATE(2098)] = 65927,
  [SMALL_STATE(2099)] = 65950,
  [SMALL_STATE(2100)] = 65991,
  [SMALL_STATE(2101)] = 66024,
  [SMALL_STATE(2102)] = 66059,
  [SMALL_STATE(2103)] = 66090,
  [SMALL_STATE(2104)] = 66113,
  [SMALL_STATE(2105)] = 66136,
  [SMALL_STATE(2106)] = 66159,
  [SMALL_STATE(2107)] = 66182,
  [SMALL_STATE(2108)] = 66205,
  [SMALL_STATE(2109)] = 66236,
  [SMALL_STATE(2110)] = 66259,
  [SMALL_STATE(2111)] = 66282,
  [SMALL_STATE(2112)] = 66305,
  [SMALL_STATE(2113)] = 66328,
  [SMALL_STATE(2114)] = 66351,
  [SMALL_STATE(2115)] = 66374,
  [SMALL_STATE(2116)] = 66397,
  [SMALL_STATE(2117)] = 66420,
  [SMALL_STATE(2118)] = 66443,
  [SMALL_STATE(2119)] = 66478,
  [SMALL_STATE(2120)] = 66501,
  [SMALL_STATE(2121)] = 66539,
  [SMALL_STATE(2122)] = 66577,
  [SMALL_STATE(2123)] = 66615,
  [SMALL_STATE(2124)] = 66647,
  [SMALL_STATE(2125)] = 66685,
  [SMALL_STATE(2126)] = 66723,
  [SMALL_STATE(2127)] = 66749,
  [SMALL_STATE(2128)] = 66775,
  [SMALL_STATE(2129)] = 66813,
  [SMALL_STATE(2130)] = 66851,
  [SMALL_STATE(2131)] = 66883,
  [SMALL_STATE(2132)] = 66921,
  [SMALL_STATE(2133)] = 66947,
  [SMALL_STATE(2134)] = 66979,
  [SMALL_STATE(2135)] = 67017,
  [SMALL_STATE(2136)] = 67055,
  [SMALL_STATE(2137)] = 67093,
  [SMALL_STATE(2138)] = 67125,
  [SMALL_STATE(2139)] = 67157,
  [SMALL_STATE(2140)] = 67181,
  [SMALL_STATE(2141)] = 67209,
  [SMALL_STATE(2142)] = 67233,
  [SMALL_STATE(2143)] = 67265,
  [SMALL_STATE(2144)] = 67299,
  [SMALL_STATE(2145)] = 67331,
  [SMALL_STATE(2146)] = 67369,
  [SMALL_STATE(2147)] = 67393,
  [SMALL_STATE(2148)] = 67421,
  [SMALL_STATE(2149)] = 67453,
  [SMALL_STATE(2150)] = 67485,
  [SMALL_STATE(2151)] = 67517,
  [SMALL_STATE(2152)] = 67553,
  [SMALL_STATE(2153)] = 67577,
  [SMALL_STATE(2154)] = 67609,
  [SMALL_STATE(2155)] = 67635,
  [SMALL_STATE(2156)] = 67663,
  [SMALL_STATE(2157)] = 67701,
  [SMALL_STATE(2158)] = 67739,
  [SMALL_STATE(2159)] = 67767,
  [SMALL_STATE(2160)] = 67795,
  [SMALL_STATE(2161)] = 67827,
  [SMALL_STATE(2162)] = 67859,
  [SMALL_STATE(2163)] = 67897,
  [SMALL_STATE(2164)] = 67935,
  [SMALL_STATE(2165)] = 67969,
  [SMALL_STATE(2166)] = 67993,
  [SMALL_STATE(2167)] = 68021,
  [SMALL_STATE(2168)] = 68049,
  [SMALL_STATE(2169)] = 68076,
  [SMALL_STATE(2170)] = 68111,
  [SMALL_STATE(2171)] = 68146,
  [SMALL_STATE(2172)] = 68181,
  [SMALL_STATE(2173)] = 68216,
  [SMALL_STATE(2174)] = 68251,
  [SMALL_STATE(2175)] = 68286,
  [SMALL_STATE(2176)] = 68321,
  [SMALL_STATE(2177)] = 68356,
  [SMALL_STATE(2178)] = 68391,
  [SMALL_STATE(2179)] = 68426,
  [SMALL_STATE(2180)] = 68461,
  [SMALL_STATE(2181)] = 68496,
  [SMALL_STATE(2182)] = 68531,
  [SMALL_STATE(2183)] = 68566,
  [SMALL_STATE(2184)] = 68591,
  [SMALL_STATE(2185)] = 68626,
  [SMALL_STATE(2186)] = 68651,
  [SMALL_STATE(2187)] = 68676,
  [SMALL_STATE(2188)] = 68709,
  [SMALL_STATE(2189)] = 68744,
  [SMALL_STATE(2190)] = 68777,
  [SMALL_STATE(2191)] = 68812,
  [SMALL_STATE(2192)] = 68847,
  [SMALL_STATE(2193)] = 68882,
  [SMALL_STATE(2194)] = 68917,
  [SMALL_STATE(2195)] = 68952,
  [SMALL_STATE(2196)] = 68987,
  [SMALL_STATE(2197)] = 69022,
  [SMALL_STATE(2198)] = 69051,
  [SMALL_STATE(2199)] = 69086,
  [SMALL_STATE(2200)] = 69121,
  [SMALL_STATE(2201)] = 69156,
  [SMALL_STATE(2202)] = 69191,
  [SMALL_STATE(2203)] = 69226,
  [SMALL_STATE(2204)] = 69261,
  [SMALL_STATE(2205)] = 69282,
  [SMALL_STATE(2206)] = 69317,
  [SMALL_STATE(2207)] = 69350,
  [SMALL_STATE(2208)] = 69383,
  [SMALL_STATE(2209)] = 69404,
  [SMALL_STATE(2210)] = 69425,
  [SMALL_STATE(2211)] = 69446,
  [SMALL_STATE(2212)] = 69481,
  [SMALL_STATE(2213)] = 69516,
  [SMALL_STATE(2214)] = 69537,
  [SMALL_STATE(2215)] = 69570,
  [SMALL_STATE(2216)] = 69591,
  [SMALL_STATE(2217)] = 69626,
  [SMALL_STATE(2218)] = 69661,
  [SMALL_STATE(2219)] = 69696,
  [SMALL_STATE(2220)] = 69731,
  [SMALL_STATE(2221)] = 69766,
  [SMALL_STATE(2222)] = 69801,
  [SMALL_STATE(2223)] = 69833,
  [SMALL_STATE(2224)] = 69865,
  [SMALL_STATE(2225)] = 69897,
  [SMALL_STATE(2226)] = 69929,
  [SMALL_STATE(2227)] = 69957,
  [SMALL_STATE(2228)] = 69989,
  [SMALL_STATE(2229)] = 70021,
  [SMALL_STATE(2230)] = 70053,
  [SMALL_STATE(2231)] = 70085,
  [SMALL_STATE(2232)] = 70115,
  [SMALL_STATE(2233)] = 70145,
  [SMALL_STATE(2234)] = 70177,
  [SMALL_STATE(2235)] = 70209,
  [SMALL_STATE(2236)] = 70241,
  [SMALL_STATE(2237)] = 70273,
  [SMALL_STATE(2238)] = 70305,
  [SMALL_STATE(2239)] = 70333,
  [SMALL_STATE(2240)] = 70365,
  [SMALL_STATE(2241)] = 70387,
  [SMALL_STATE(2242)] = 70419,
  [SMALL_STATE(2243)] = 70445,
  [SMALL_STATE(2244)] = 70475,
  [SMALL_STATE(2245)] = 70497,
  [SMALL_STATE(2246)] = 70525,
  [SMALL_STATE(2247)] = 70547,
  [SMALL_STATE(2248)] = 70577,
  [SMALL_STATE(2249)] = 70609,
  [SMALL_STATE(2250)] = 70631,
  [SMALL_STATE(2251)] = 70663,
  [SMALL_STATE(2252)] = 70695,
  [SMALL_STATE(2253)] = 70725,
  [SMALL_STATE(2254)] = 70757,
  [SMALL_STATE(2255)] = 70789,
  [SMALL_STATE(2256)] = 70819,
  [SMALL_STATE(2257)] = 70851,
  [SMALL_STATE(2258)] = 70883,
  [SMALL_STATE(2259)] = 70913,
  [SMALL_STATE(2260)] = 70941,
  [SMALL_STATE(2261)] = 70973,
  [SMALL_STATE(2262)] = 70995,
  [SMALL_STATE(2263)] = 71021,
  [SMALL_STATE(2264)] = 71053,
  [SMALL_STATE(2265)] = 71079,
  [SMALL_STATE(2266)] = 71111,
  [SMALL_STATE(2267)] = 71141,
  [SMALL_STATE(2268)] = 71173,
  [SMALL_STATE(2269)] = 71205,
  [SMALL_STATE(2270)] = 71235,
  [SMALL_STATE(2271)] = 71267,
  [SMALL_STATE(2272)] = 71299,
  [SMALL_STATE(2273)] = 71321,
  [SMALL_STATE(2274)] = 71353,
  [SMALL_STATE(2275)] = 71385,
  [SMALL_STATE(2276)] = 71415,
  [SMALL_STATE(2277)] = 71447,
  [SMALL_STATE(2278)] = 71475,
  [SMALL_STATE(2279)] = 71501,
  [SMALL_STATE(2280)] = 71530,
  [SMALL_STATE(2281)] = 71559,
  [SMALL_STATE(2282)] = 71588,
  [SMALL_STATE(2283)] = 71615,
  [SMALL_STATE(2284)] = 71644,
  [SMALL_STATE(2285)] = 71673,
  [SMALL_STATE(2286)] = 71694,
  [SMALL_STATE(2287)] = 71717,
  [SMALL_STATE(2288)] = 71746,
  [SMALL_STATE(2289)] = 71767,
  [SMALL_STATE(2290)] = 71788,
  [SMALL_STATE(2291)] = 71809,
  [SMALL_STATE(2292)] = 71838,
  [SMALL_STATE(2293)] = 71867,
  [SMALL_STATE(2294)] = 71896,
  [SMALL_STATE(2295)] = 71919,
  [SMALL_STATE(2296)] = 71948,
  [SMALL_STATE(2297)] = 71977,
  [SMALL_STATE(2298)] = 72006,
  [SMALL_STATE(2299)] = 72029,
  [SMALL_STATE(2300)] = 72058,
  [SMALL_STATE(2301)] = 72081,
  [SMALL_STATE(2302)] = 72110,
  [SMALL_STATE(2303)] = 72139,
  [SMALL_STATE(2304)] = 72162,
  [SMALL_STATE(2305)] = 72191,
  [SMALL_STATE(2306)] = 72220,
  [SMALL_STATE(2307)] = 72243,
  [SMALL_STATE(2308)] = 72272,
  [SMALL_STATE(2309)] = 72301,
  [SMALL_STATE(2310)] = 72324,
  [SMALL_STATE(2311)] = 72343,
  [SMALL_STATE(2312)] = 72364,
  [SMALL_STATE(2313)] = 72393,
  [SMALL_STATE(2314)] = 72418,
  [SMALL_STATE(2315)] = 72447,
  [SMALL_STATE(2316)] = 72470,
  [SMALL_STATE(2317)] = 72499,
  [SMALL_STATE(2318)] = 72528,
  [SMALL_STATE(2319)] = 72557,
  [SMALL_STATE(2320)] = 72586,
  [SMALL_STATE(2321)] = 72615,
  [SMALL_STATE(2322)] = 72640,
  [SMALL_STATE(2323)] = 72669,
  [SMALL_STATE(2324)] = 72698,
  [SMALL_STATE(2325)] = 72717,
  [SMALL_STATE(2326)] = 72742,
  [SMALL_STATE(2327)] = 72771,
  [SMALL_STATE(2328)] = 72794,
  [SMALL_STATE(2329)] = 72823,
  [SMALL_STATE(2330)] = 72852,
  [SMALL_STATE(2331)] = 72881,
  [SMALL_STATE(2332)] = 72910,
  [SMALL_STATE(2333)] = 72939,
  [SMALL_STATE(2334)] = 72968,
  [SMALL_STATE(2335)] = 72991,
  [SMALL_STATE(2336)] = 73012,
  [SMALL_STATE(2337)] = 73035,
  [SMALL_STATE(2338)] = 73064,
  [SMALL_STATE(2339)] = 73093,
  [SMALL_STATE(2340)] = 73122,
  [SMALL_STATE(2341)] = 73151,
  [SMALL_STATE(2342)] = 73180,
  [SMALL_STATE(2343)] = 73209,
  [SMALL_STATE(2344)] = 73238,
  [SMALL_STATE(2345)] = 73267,
  [SMALL_STATE(2346)] = 73288,
  [SMALL_STATE(2347)] = 73317,
  [SMALL_STATE(2348)] = 73344,
  [SMALL_STATE(2349)] = 73371,
  [SMALL_STATE(2350)] = 73394,
  [SMALL_STATE(2351)] = 73423,
  [SMALL_STATE(2352)] = 73448,
  [SMALL_STATE(2353)] = 73477,
  [SMALL_STATE(2354)] = 73506,
  [SMALL_STATE(2355)] = 73535,
  [SMALL_STATE(2356)] = 73558,
  [SMALL_STATE(2357)] = 73581,
  [SMALL_STATE(2358)] = 73608,
  [SMALL_STATE(2359)] = 73637,
  [SMALL_STATE(2360)] = 73666,
  [SMALL_STATE(2361)] = 73695,
  [SMALL_STATE(2362)] = 73724,
  [SMALL_STATE(2363)] = 73753,
  [SMALL_STATE(2364)] = 73780,
  [SMALL_STATE(2365)] = 73809,
  [SMALL_STATE(2366)] = 73830,
  [SMALL_STATE(2367)] = 73859,
  [SMALL_STATE(2368)] = 73888,
  [SMALL_STATE(2369)] = 73917,
  [SMALL_STATE(2370)] = 73946,
  [SMALL_STATE(2371)] = 73975,
  [SMALL_STATE(2372)] = 74002,
  [SMALL_STATE(2373)] = 74031,
  [SMALL_STATE(2374)] = 74060,
  [SMALL_STATE(2375)] = 74089,
  [SMALL_STATE(2376)] = 74118,
  [SMALL_STATE(2377)] = 74147,
  [SMALL_STATE(2378)] = 74176,
  [SMALL_STATE(2379)] = 74202,
  [SMALL_STATE(2380)] = 74220,
  [SMALL_STATE(2381)] = 74238,
  [SMALL_STATE(2382)] = 74256,
  [SMALL_STATE(2383)] = 74280,
  [SMALL_STATE(2384)] = 74304,
  [SMALL_STATE(2385)] = 74322,
  [SMALL_STATE(2386)] = 74348,
  [SMALL_STATE(2387)] = 74374,
  [SMALL_STATE(2388)] = 74392,
  [SMALL_STATE(2389)] = 74414,
  [SMALL_STATE(2390)] = 74440,
  [SMALL_STATE(2391)] = 74462,
  [SMALL_STATE(2392)] = 74488,
  [SMALL_STATE(2393)] = 74506,
  [SMALL_STATE(2394)] = 74530,
  [SMALL_STATE(2395)] = 74556,
  [SMALL_STATE(2396)] = 74580,
  [SMALL_STATE(2397)] = 74606,
  [SMALL_STATE(2398)] = 74632,
  [SMALL_STATE(2399)] = 74658,
  [SMALL_STATE(2400)] = 74680,
  [SMALL_STATE(2401)] = 74706,
  [SMALL_STATE(2402)] = 74724,
  [SMALL_STATE(2403)] = 74750,
  [SMALL_STATE(2404)] = 74768,
  [SMALL_STATE(2405)] = 74786,
  [SMALL_STATE(2406)] = 74804,
  [SMALL_STATE(2407)] = 74822,
  [SMALL_STATE(2408)] = 74848,
  [SMALL_STATE(2409)] = 74874,
  [SMALL_STATE(2410)] = 74900,
  [SMALL_STATE(2411)] = 74926,
  [SMALL_STATE(2412)] = 74948,
  [SMALL_STATE(2413)] = 74966,
  [SMALL_STATE(2414)] = 74990,
  [SMALL_STATE(2415)] = 75016,
  [SMALL_STATE(2416)] = 75040,
  [SMALL_STATE(2417)] = 75062,
  [SMALL_STATE(2418)] = 75084,
  [SMALL_STATE(2419)] = 75108,
  [SMALL_STATE(2420)] = 75130,
  [SMALL_STATE(2421)] = 75156,
  [SMALL_STATE(2422)] = 75176,
  [SMALL_STATE(2423)] = 75202,
  [SMALL_STATE(2424)] = 75228,
  [SMALL_STATE(2425)] = 75254,
  [SMALL_STATE(2426)] = 75280,
  [SMALL_STATE(2427)] = 75306,
  [SMALL_STATE(2428)] = 75332,
  [SMALL_STATE(2429)] = 75358,
  [SMALL_STATE(2430)] = 75384,
  [SMALL_STATE(2431)] = 75410,
  [SMALL_STATE(2432)] = 75436,
  [SMALL_STATE(2433)] = 75462,
  [SMALL_STATE(2434)] = 75488,
  [SMALL_STATE(2435)] = 75512,
  [SMALL_STATE(2436)] = 75538,
  [SMALL_STATE(2437)] = 75564,
  [SMALL_STATE(2438)] = 75588,
  [SMALL_STATE(2439)] = 75612,
  [SMALL_STATE(2440)] = 75638,
  [SMALL_STATE(2441)] = 75658,
  [SMALL_STATE(2442)] = 75684,
  [SMALL_STATE(2443)] = 75708,
  [SMALL_STATE(2444)] = 75734,
  [SMALL_STATE(2445)] = 75760,
  [SMALL_STATE(2446)] = 75786,
  [SMALL_STATE(2447)] = 75810,
  [SMALL_STATE(2448)] = 75832,
  [SMALL_STATE(2449)] = 75850,
  [SMALL_STATE(2450)] = 75868,
  [SMALL_STATE(2451)] = 75894,
  [SMALL_STATE(2452)] = 75920,
  [SMALL_STATE(2453)] = 75946,
  [SMALL_STATE(2454)] = 75968,
  [SMALL_STATE(2455)] = 75986,
  [SMALL_STATE(2456)] = 76012,
  [SMALL_STATE(2457)] = 76030,
  [SMALL_STATE(2458)] = 76048,
  [SMALL_STATE(2459)] = 76074,
  [SMALL_STATE(2460)] = 76098,
  [SMALL_STATE(2461)] = 76118,
  [SMALL_STATE(2462)] = 76140,
  [SMALL_STATE(2463)] = 76158,
  [SMALL_STATE(2464)] = 76176,
  [SMALL_STATE(2465)] = 76202,
  [SMALL_STATE(2466)] = 76220,
  [SMALL_STATE(2467)] = 76246,
  [SMALL_STATE(2468)] = 76270,
  [SMALL_STATE(2469)] = 76288,
  [SMALL_STATE(2470)] = 76314,
  [SMALL_STATE(2471)] = 76338,
  [SMALL_STATE(2472)] = 76364,
  [SMALL_STATE(2473)] = 76382,
  [SMALL_STATE(2474)] = 76408,
  [SMALL_STATE(2475)] = 76434,
  [SMALL_STATE(2476)] = 76452,
  [SMALL_STATE(2477)] = 76470,
  [SMALL_STATE(2478)] = 76496,
  [SMALL_STATE(2479)] = 76514,
  [SMALL_STATE(2480)] = 76540,
  [SMALL_STATE(2481)] = 76566,
  [SMALL_STATE(2482)] = 76592,
  [SMALL_STATE(2483)] = 76618,
  [SMALL_STATE(2484)] = 76644,
  [SMALL_STATE(2485)] = 76663,
  [SMALL_STATE(2486)] = 76686,
  [SMALL_STATE(2487)] = 76709,
  [SMALL_STATE(2488)] = 76732,
  [SMALL_STATE(2489)] = 76755,
  [SMALL_STATE(2490)] = 76778,
  [SMALL_STATE(2491)] = 76801,
  [SMALL_STATE(2492)] = 76824,
  [SMALL_STATE(2493)] = 76845,
  [SMALL_STATE(2494)] = 76866,
  [SMALL_STATE(2495)] = 76889,
  [SMALL_STATE(2496)] = 76910,
  [SMALL_STATE(2497)] = 76931,
  [SMALL_STATE(2498)] = 76954,
  [SMALL_STATE(2499)] = 76975,
  [SMALL_STATE(2500)] = 76998,
  [SMALL_STATE(2501)] = 77017,
  [SMALL_STATE(2502)] = 77040,
  [SMALL_STATE(2503)] = 77063,
  [SMALL_STATE(2504)] = 77086,
  [SMALL_STATE(2505)] = 77109,
  [SMALL_STATE(2506)] = 77132,
  [SMALL_STATE(2507)] = 77151,
  [SMALL_STATE(2508)] = 77174,
  [SMALL_STATE(2509)] = 77193,
  [SMALL_STATE(2510)] = 77212,
  [SMALL_STATE(2511)] = 77235,
  [SMALL_STATE(2512)] = 77258,
  [SMALL_STATE(2513)] = 77279,
  [SMALL_STATE(2514)] = 77302,
  [SMALL_STATE(2515)] = 77325,
  [SMALL_STATE(2516)] = 77348,
  [SMALL_STATE(2517)] = 77371,
  [SMALL_STATE(2518)] = 77394,
  [SMALL_STATE(2519)] = 77417,
  [SMALL_STATE(2520)] = 77440,
  [SMALL_STATE(2521)] = 77463,
  [SMALL_STATE(2522)] = 77482,
  [SMALL_STATE(2523)] = 77505,
  [SMALL_STATE(2524)] = 77528,
  [SMALL_STATE(2525)] = 77551,
  [SMALL_STATE(2526)] = 77574,
  [SMALL_STATE(2527)] = 77593,
  [SMALL_STATE(2528)] = 77616,
  [SMALL_STATE(2529)] = 77639,
  [SMALL_STATE(2530)] = 77658,
  [SMALL_STATE(2531)] = 77677,
  [SMALL_STATE(2532)] = 77700,
  [SMALL_STATE(2533)] = 77723,
  [SMALL_STATE(2534)] = 77742,
  [SMALL_STATE(2535)] = 77765,
  [SMALL_STATE(2536)] = 77786,
  [SMALL_STATE(2537)] = 77805,
  [SMALL_STATE(2538)] = 77824,
  [SMALL_STATE(2539)] = 77847,
  [SMALL_STATE(2540)] = 77870,
  [SMALL_STATE(2541)] = 77893,
  [SMALL_STATE(2542)] = 77916,
  [SMALL_STATE(2543)] = 77939,
  [SMALL_STATE(2544)] = 77958,
  [SMALL_STATE(2545)] = 77979,
  [SMALL_STATE(2546)] = 78002,
  [SMALL_STATE(2547)] = 78025,
  [SMALL_STATE(2548)] = 78048,
  [SMALL_STATE(2549)] = 78069,
  [SMALL_STATE(2550)] = 78092,
  [SMALL_STATE(2551)] = 78115,
  [SMALL_STATE(2552)] = 78138,
  [SMALL_STATE(2553)] = 78161,
  [SMALL_STATE(2554)] = 78184,
  [SMALL_STATE(2555)] = 78207,
  [SMALL_STATE(2556)] = 78230,
  [SMALL_STATE(2557)] = 78253,
  [SMALL_STATE(2558)] = 78276,
  [SMALL_STATE(2559)] = 78299,
  [SMALL_STATE(2560)] = 78322,
  [SMALL_STATE(2561)] = 78345,
  [SMALL_STATE(2562)] = 78368,
  [SMALL_STATE(2563)] = 78385,
  [SMALL_STATE(2564)] = 78408,
  [SMALL_STATE(2565)] = 78431,
  [SMALL_STATE(2566)] = 78454,
  [SMALL_STATE(2567)] = 78477,
  [SMALL_STATE(2568)] = 78500,
  [SMALL_STATE(2569)] = 78523,
  [SMALL_STATE(2570)] = 78540,
  [SMALL_STATE(2571)] = 78559,
  [SMALL_STATE(2572)] = 78582,
  [SMALL_STATE(2573)] = 78605,
  [SMALL_STATE(2574)] = 78626,
  [SMALL_STATE(2575)] = 78647,
  [SMALL_STATE(2576)] = 78670,
  [SMALL_STATE(2577)] = 78693,
  [SMALL_STATE(2578)] = 78716,
  [SMALL_STATE(2579)] = 78739,
  [SMALL_STATE(2580)] = 78762,
  [SMALL_STATE(2581)] = 78783,
  [SMALL_STATE(2582)] = 78806,
  [SMALL_STATE(2583)] = 78829,
  [SMALL_STATE(2584)] = 78852,
  [SMALL_STATE(2585)] = 78873,
  [SMALL_STATE(2586)] = 78896,
  [SMALL_STATE(2587)] = 78919,
  [SMALL_STATE(2588)] = 78942,
  [SMALL_STATE(2589)] = 78965,
  [SMALL_STATE(2590)] = 78986,
  [SMALL_STATE(2591)] = 79009,
  [SMALL_STATE(2592)] = 79032,
  [SMALL_STATE(2593)] = 79055,
  [SMALL_STATE(2594)] = 79078,
  [SMALL_STATE(2595)] = 79101,
  [SMALL_STATE(2596)] = 79124,
  [SMALL_STATE(2597)] = 79145,
  [SMALL_STATE(2598)] = 79168,
  [SMALL_STATE(2599)] = 79189,
  [SMALL_STATE(2600)] = 79212,
  [SMALL_STATE(2601)] = 79235,
  [SMALL_STATE(2602)] = 79256,
  [SMALL_STATE(2603)] = 79279,
  [SMALL_STATE(2604)] = 79302,
  [SMALL_STATE(2605)] = 79325,
  [SMALL_STATE(2606)] = 79348,
  [SMALL_STATE(2607)] = 79369,
  [SMALL_STATE(2608)] = 79392,
  [SMALL_STATE(2609)] = 79415,
  [SMALL_STATE(2610)] = 79436,
  [SMALL_STATE(2611)] = 79459,
  [SMALL_STATE(2612)] = 79482,
  [SMALL_STATE(2613)] = 79505,
  [SMALL_STATE(2614)] = 79524,
  [SMALL_STATE(2615)] = 79547,
  [SMALL_STATE(2616)] = 79566,
  [SMALL_STATE(2617)] = 79589,
  [SMALL_STATE(2618)] = 79606,
  [SMALL_STATE(2619)] = 79629,
  [SMALL_STATE(2620)] = 79652,
  [SMALL_STATE(2621)] = 79671,
  [SMALL_STATE(2622)] = 79694,
  [SMALL_STATE(2623)] = 79717,
  [SMALL_STATE(2624)] = 79740,
  [SMALL_STATE(2625)] = 79763,
  [SMALL_STATE(2626)] = 79786,
  [SMALL_STATE(2627)] = 79805,
  [SMALL_STATE(2628)] = 79822,
  [SMALL_STATE(2629)] = 79845,
  [SMALL_STATE(2630)] = 79864,
  [SMALL_STATE(2631)] = 79883,
  [SMALL_STATE(2632)] = 79906,
  [SMALL_STATE(2633)] = 79929,
  [SMALL_STATE(2634)] = 79950,
  [SMALL_STATE(2635)] = 79973,
  [SMALL_STATE(2636)] = 79996,
  [SMALL_STATE(2637)] = 80019,
  [SMALL_STATE(2638)] = 80042,
  [SMALL_STATE(2639)] = 80065,
  [SMALL_STATE(2640)] = 80088,
  [SMALL_STATE(2641)] = 80111,
  [SMALL_STATE(2642)] = 80134,
  [SMALL_STATE(2643)] = 80155,
  [SMALL_STATE(2644)] = 80176,
  [SMALL_STATE(2645)] = 80199,
  [SMALL_STATE(2646)] = 80222,
  [SMALL_STATE(2647)] = 80245,
  [SMALL_STATE(2648)] = 80268,
  [SMALL_STATE(2649)] = 80291,
  [SMALL_STATE(2650)] = 80314,
  [SMALL_STATE(2651)] = 80337,
  [SMALL_STATE(2652)] = 80360,
  [SMALL_STATE(2653)] = 80383,
  [SMALL_STATE(2654)] = 80406,
  [SMALL_STATE(2655)] = 80429,
  [SMALL_STATE(2656)] = 80452,
  [SMALL_STATE(2657)] = 80473,
  [SMALL_STATE(2658)] = 80492,
  [SMALL_STATE(2659)] = 80515,
  [SMALL_STATE(2660)] = 80538,
  [SMALL_STATE(2661)] = 80561,
  [SMALL_STATE(2662)] = 80584,
  [SMALL_STATE(2663)] = 80607,
  [SMALL_STATE(2664)] = 80630,
  [SMALL_STATE(2665)] = 80653,
  [SMALL_STATE(2666)] = 80676,
  [SMALL_STATE(2667)] = 80697,
  [SMALL_STATE(2668)] = 80720,
  [SMALL_STATE(2669)] = 80743,
  [SMALL_STATE(2670)] = 80766,
  [SMALL_STATE(2671)] = 80789,
  [SMALL_STATE(2672)] = 80806,
  [SMALL_STATE(2673)] = 80823,
  [SMALL_STATE(2674)] = 80846,
  [SMALL_STATE(2675)] = 80865,
  [SMALL_STATE(2676)] = 80888,
  [SMALL_STATE(2677)] = 80911,
  [SMALL_STATE(2678)] = 80930,
  [SMALL_STATE(2679)] = 80953,
  [SMALL_STATE(2680)] = 80976,
  [SMALL_STATE(2681)] = 80999,
  [SMALL_STATE(2682)] = 81022,
  [SMALL_STATE(2683)] = 81045,
  [SMALL_STATE(2684)] = 81068,
  [SMALL_STATE(2685)] = 81091,
  [SMALL_STATE(2686)] = 81112,
  [SMALL_STATE(2687)] = 81131,
  [SMALL_STATE(2688)] = 81154,
  [SMALL_STATE(2689)] = 81177,
  [SMALL_STATE(2690)] = 81200,
  [SMALL_STATE(2691)] = 81223,
  [SMALL_STATE(2692)] = 81246,
  [SMALL_STATE(2693)] = 81265,
  [SMALL_STATE(2694)] = 81288,
  [SMALL_STATE(2695)] = 81311,
  [SMALL_STATE(2696)] = 81334,
  [SMALL_STATE(2697)] = 81357,
  [SMALL_STATE(2698)] = 81380,
  [SMALL_STATE(2699)] = 81403,
  [SMALL_STATE(2700)] = 81420,
  [SMALL_STATE(2701)] = 81443,
  [SMALL_STATE(2702)] = 81466,
  [SMALL_STATE(2703)] = 81489,
  [SMALL_STATE(2704)] = 81506,
  [SMALL_STATE(2705)] = 81529,
  [SMALL_STATE(2706)] = 81552,
  [SMALL_STATE(2707)] = 81575,
  [SMALL_STATE(2708)] = 81598,
  [SMALL_STATE(2709)] = 81619,
  [SMALL_STATE(2710)] = 81640,
  [SMALL_STATE(2711)] = 81659,
  [SMALL_STATE(2712)] = 81682,
  [SMALL_STATE(2713)] = 81703,
  [SMALL_STATE(2714)] = 81726,
  [SMALL_STATE(2715)] = 81749,
  [SMALL_STATE(2716)] = 81772,
  [SMALL_STATE(2717)] = 81795,
  [SMALL_STATE(2718)] = 81818,
  [SMALL_STATE(2719)] = 81841,
  [SMALL_STATE(2720)] = 81864,
  [SMALL_STATE(2721)] = 81887,
  [SMALL_STATE(2722)] = 81910,
  [SMALL_STATE(2723)] = 81933,
  [SMALL_STATE(2724)] = 81953,
  [SMALL_STATE(2725)] = 81971,
  [SMALL_STATE(2726)] = 81987,
  [SMALL_STATE(2727)] = 82005,
  [SMALL_STATE(2728)] = 82025,
  [SMALL_STATE(2729)] = 82043,
  [SMALL_STATE(2730)] = 82063,
  [SMALL_STATE(2731)] = 82079,
  [SMALL_STATE(2732)] = 82099,
  [SMALL_STATE(2733)] = 82119,
  [SMALL_STATE(2734)] = 82139,
  [SMALL_STATE(2735)] = 82159,
  [SMALL_STATE(2736)] = 82179,
  [SMALL_STATE(2737)] = 82199,
  [SMALL_STATE(2738)] = 82219,
  [SMALL_STATE(2739)] = 82235,
  [SMALL_STATE(2740)] = 82251,
  [SMALL_STATE(2741)] = 82271,
  [SMALL_STATE(2742)] = 82291,
  [SMALL_STATE(2743)] = 82307,
  [SMALL_STATE(2744)] = 82327,
  [SMALL_STATE(2745)] = 82347,
  [SMALL_STATE(2746)] = 82363,
  [SMALL_STATE(2747)] = 82379,
  [SMALL_STATE(2748)] = 82395,
  [SMALL_STATE(2749)] = 82411,
  [SMALL_STATE(2750)] = 82431,
  [SMALL_STATE(2751)] = 82447,
  [SMALL_STATE(2752)] = 82467,
  [SMALL_STATE(2753)] = 82483,
  [SMALL_STATE(2754)] = 82499,
  [SMALL_STATE(2755)] = 82519,
  [SMALL_STATE(2756)] = 82539,
  [SMALL_STATE(2757)] = 82555,
  [SMALL_STATE(2758)] = 82575,
  [SMALL_STATE(2759)] = 82595,
  [SMALL_STATE(2760)] = 82611,
  [SMALL_STATE(2761)] = 82631,
  [SMALL_STATE(2762)] = 82651,
  [SMALL_STATE(2763)] = 82669,
  [SMALL_STATE(2764)] = 82687,
  [SMALL_STATE(2765)] = 82703,
  [SMALL_STATE(2766)] = 82721,
  [SMALL_STATE(2767)] = 82737,
  [SMALL_STATE(2768)] = 82757,
  [SMALL_STATE(2769)] = 82777,
  [SMALL_STATE(2770)] = 82797,
  [SMALL_STATE(2771)] = 82813,
  [SMALL_STATE(2772)] = 82833,
  [SMALL_STATE(2773)] = 82853,
  [SMALL_STATE(2774)] = 82873,
  [SMALL_STATE(2775)] = 82889,
  [SMALL_STATE(2776)] = 82905,
  [SMALL_STATE(2777)] = 82921,
  [SMALL_STATE(2778)] = 82941,
  [SMALL_STATE(2779)] = 82961,
  [SMALL_STATE(2780)] = 82981,
  [SMALL_STATE(2781)] = 83001,
  [SMALL_STATE(2782)] = 83017,
  [SMALL_STATE(2783)] = 83037,
  [SMALL_STATE(2784)] = 83057,
  [SMALL_STATE(2785)] = 83075,
  [SMALL_STATE(2786)] = 83095,
  [SMALL_STATE(2787)] = 83115,
  [SMALL_STATE(2788)] = 83135,
  [SMALL_STATE(2789)] = 83155,
  [SMALL_STATE(2790)] = 83175,
  [SMALL_STATE(2791)] = 83195,
  [SMALL_STATE(2792)] = 83215,
  [SMALL_STATE(2793)] = 83235,
  [SMALL_STATE(2794)] = 83255,
  [SMALL_STATE(2795)] = 83275,
  [SMALL_STATE(2796)] = 83291,
  [SMALL_STATE(2797)] = 83311,
  [SMALL_STATE(2798)] = 83331,
  [SMALL_STATE(2799)] = 83347,
  [SMALL_STATE(2800)] = 83363,
  [SMALL_STATE(2801)] = 83383,
  [SMALL_STATE(2802)] = 83403,
  [SMALL_STATE(2803)] = 83423,
  [SMALL_STATE(2804)] = 83443,
  [SMALL_STATE(2805)] = 83459,
  [SMALL_STATE(2806)] = 83479,
  [SMALL_STATE(2807)] = 83495,
  [SMALL_STATE(2808)] = 83515,
  [SMALL_STATE(2809)] = 83533,
  [SMALL_STATE(2810)] = 83553,
  [SMALL_STATE(2811)] = 83571,
  [SMALL_STATE(2812)] = 83587,
  [SMALL_STATE(2813)] = 83607,
  [SMALL_STATE(2814)] = 83627,
  [SMALL_STATE(2815)] = 83645,
  [SMALL_STATE(2816)] = 83663,
  [SMALL_STATE(2817)] = 83679,
  [SMALL_STATE(2818)] = 83695,
  [SMALL_STATE(2819)] = 83711,
  [SMALL_STATE(2820)] = 83731,
  [SMALL_STATE(2821)] = 83747,
  [SMALL_STATE(2822)] = 83763,
  [SMALL_STATE(2823)] = 83783,
  [SMALL_STATE(2824)] = 83799,
  [SMALL_STATE(2825)] = 83819,
  [SMALL_STATE(2826)] = 83835,
  [SMALL_STATE(2827)] = 83851,
  [SMALL_STATE(2828)] = 83871,
  [SMALL_STATE(2829)] = 83891,
  [SMALL_STATE(2830)] = 83911,
  [SMALL_STATE(2831)] = 83927,
  [SMALL_STATE(2832)] = 83943,
  [SMALL_STATE(2833)] = 83961,
  [SMALL_STATE(2834)] = 83981,
  [SMALL_STATE(2835)] = 83997,
  [SMALL_STATE(2836)] = 84013,
  [SMALL_STATE(2837)] = 84029,
  [SMALL_STATE(2838)] = 84049,
  [SMALL_STATE(2839)] = 84069,
  [SMALL_STATE(2840)] = 84085,
  [SMALL_STATE(2841)] = 84101,
  [SMALL_STATE(2842)] = 84117,
  [SMALL_STATE(2843)] = 84137,
  [SMALL_STATE(2844)] = 84153,
  [SMALL_STATE(2845)] = 84169,
  [SMALL_STATE(2846)] = 84189,
  [SMALL_STATE(2847)] = 84205,
  [SMALL_STATE(2848)] = 84225,
  [SMALL_STATE(2849)] = 84241,
  [SMALL_STATE(2850)] = 84261,
  [SMALL_STATE(2851)] = 84281,
  [SMALL_STATE(2852)] = 84301,
  [SMALL_STATE(2853)] = 84317,
  [SMALL_STATE(2854)] = 84337,
  [SMALL_STATE(2855)] = 84357,
  [SMALL_STATE(2856)] = 84377,
  [SMALL_STATE(2857)] = 84397,
  [SMALL_STATE(2858)] = 84417,
  [SMALL_STATE(2859)] = 84437,
  [SMALL_STATE(2860)] = 84457,
  [SMALL_STATE(2861)] = 84475,
  [SMALL_STATE(2862)] = 84495,
  [SMALL_STATE(2863)] = 84515,
  [SMALL_STATE(2864)] = 84531,
  [SMALL_STATE(2865)] = 84551,
  [SMALL_STATE(2866)] = 84571,
  [SMALL_STATE(2867)] = 84591,
  [SMALL_STATE(2868)] = 84607,
  [SMALL_STATE(2869)] = 84623,
  [SMALL_STATE(2870)] = 84643,
  [SMALL_STATE(2871)] = 84663,
  [SMALL_STATE(2872)] = 84683,
  [SMALL_STATE(2873)] = 84701,
  [SMALL_STATE(2874)] = 84721,
  [SMALL_STATE(2875)] = 84737,
  [SMALL_STATE(2876)] = 84757,
  [SMALL_STATE(2877)] = 84777,
  [SMALL_STATE(2878)] = 84797,
  [SMALL_STATE(2879)] = 84817,
  [SMALL_STATE(2880)] = 84837,
  [SMALL_STATE(2881)] = 84857,
  [SMALL_STATE(2882)] = 84877,
  [SMALL_STATE(2883)] = 84897,
  [SMALL_STATE(2884)] = 84917,
  [SMALL_STATE(2885)] = 84937,
  [SMALL_STATE(2886)] = 84957,
  [SMALL_STATE(2887)] = 84977,
  [SMALL_STATE(2888)] = 84997,
  [SMALL_STATE(2889)] = 85017,
  [SMALL_STATE(2890)] = 85037,
  [SMALL_STATE(2891)] = 85057,
  [SMALL_STATE(2892)] = 85077,
  [SMALL_STATE(2893)] = 85097,
  [SMALL_STATE(2894)] = 85117,
  [SMALL_STATE(2895)] = 85137,
  [SMALL_STATE(2896)] = 85153,
  [SMALL_STATE(2897)] = 85171,
  [SMALL_STATE(2898)] = 85191,
  [SMALL_STATE(2899)] = 85211,
  [SMALL_STATE(2900)] = 85231,
  [SMALL_STATE(2901)] = 85251,
  [SMALL_STATE(2902)] = 85271,
  [SMALL_STATE(2903)] = 85287,
  [SMALL_STATE(2904)] = 85305,
  [SMALL_STATE(2905)] = 85325,
  [SMALL_STATE(2906)] = 85343,
  [SMALL_STATE(2907)] = 85363,
  [SMALL_STATE(2908)] = 85381,
  [SMALL_STATE(2909)] = 85401,
  [SMALL_STATE(2910)] = 85421,
  [SMALL_STATE(2911)] = 85441,
  [SMALL_STATE(2912)] = 85459,
  [SMALL_STATE(2913)] = 85479,
  [SMALL_STATE(2914)] = 85499,
  [SMALL_STATE(2915)] = 85517,
  [SMALL_STATE(2916)] = 85537,
  [SMALL_STATE(2917)] = 85557,
  [SMALL_STATE(2918)] = 85575,
  [SMALL_STATE(2919)] = 85595,
  [SMALL_STATE(2920)] = 85615,
  [SMALL_STATE(2921)] = 85635,
  [SMALL_STATE(2922)] = 85655,
  [SMALL_STATE(2923)] = 85673,
  [SMALL_STATE(2924)] = 85691,
  [SMALL_STATE(2925)] = 85709,
  [SMALL_STATE(2926)] = 85729,
  [SMALL_STATE(2927)] = 85749,
  [SMALL_STATE(2928)] = 85769,
  [SMALL_STATE(2929)] = 85789,
  [SMALL_STATE(2930)] = 85809,
  [SMALL_STATE(2931)] = 85829,
  [SMALL_STATE(2932)] = 85849,
  [SMALL_STATE(2933)] = 85869,
  [SMALL_STATE(2934)] = 85889,
  [SMALL_STATE(2935)] = 85909,
  [SMALL_STATE(2936)] = 85929,
  [SMALL_STATE(2937)] = 85947,
  [SMALL_STATE(2938)] = 85965,
  [SMALL_STATE(2939)] = 85985,
  [SMALL_STATE(2940)] = 86005,
  [SMALL_STATE(2941)] = 86025,
  [SMALL_STATE(2942)] = 86045,
  [SMALL_STATE(2943)] = 86065,
  [SMALL_STATE(2944)] = 86085,
  [SMALL_STATE(2945)] = 86105,
  [SMALL_STATE(2946)] = 86123,
  [SMALL_STATE(2947)] = 86143,
  [SMALL_STATE(2948)] = 86161,
  [SMALL_STATE(2949)] = 86181,
  [SMALL_STATE(2950)] = 86201,
  [SMALL_STATE(2951)] = 86219,
  [SMALL_STATE(2952)] = 86237,
  [SMALL_STATE(2953)] = 86257,
  [SMALL_STATE(2954)] = 86275,
  [SMALL_STATE(2955)] = 86295,
  [SMALL_STATE(2956)] = 86315,
  [SMALL_STATE(2957)] = 86335,
  [SMALL_STATE(2958)] = 86355,
  [SMALL_STATE(2959)] = 86375,
  [SMALL_STATE(2960)] = 86395,
  [SMALL_STATE(2961)] = 86415,
  [SMALL_STATE(2962)] = 86433,
  [SMALL_STATE(2963)] = 86453,
  [SMALL_STATE(2964)] = 86473,
  [SMALL_STATE(2965)] = 86493,
  [SMALL_STATE(2966)] = 86511,
  [SMALL_STATE(2967)] = 86531,
  [SMALL_STATE(2968)] = 86549,
  [SMALL_STATE(2969)] = 86569,
  [SMALL_STATE(2970)] = 86589,
  [SMALL_STATE(2971)] = 86609,
  [SMALL_STATE(2972)] = 86629,
  [SMALL_STATE(2973)] = 86649,
  [SMALL_STATE(2974)] = 86669,
  [SMALL_STATE(2975)] = 86689,
  [SMALL_STATE(2976)] = 86709,
  [SMALL_STATE(2977)] = 86729,
  [SMALL_STATE(2978)] = 86749,
  [SMALL_STATE(2979)] = 86767,
  [SMALL_STATE(2980)] = 86785,
  [SMALL_STATE(2981)] = 86805,
  [SMALL_STATE(2982)] = 86825,
  [SMALL_STATE(2983)] = 86845,
  [SMALL_STATE(2984)] = 86863,
  [SMALL_STATE(2985)] = 86881,
  [SMALL_STATE(2986)] = 86897,
  [SMALL_STATE(2987)] = 86917,
  [SMALL_STATE(2988)] = 86937,
  [SMALL_STATE(2989)] = 86957,
  [SMALL_STATE(2990)] = 86977,
  [SMALL_STATE(2991)] = 86997,
  [SMALL_STATE(2992)] = 87013,
  [SMALL_STATE(2993)] = 87033,
  [SMALL_STATE(2994)] = 87053,
  [SMALL_STATE(2995)] = 87073,
  [SMALL_STATE(2996)] = 87093,
  [SMALL_STATE(2997)] = 87113,
  [SMALL_STATE(2998)] = 87133,
  [SMALL_STATE(2999)] = 87153,
  [SMALL_STATE(3000)] = 87173,
  [SMALL_STATE(3001)] = 87191,
  [SMALL_STATE(3002)] = 87209,
  [SMALL_STATE(3003)] = 87229,
  [SMALL_STATE(3004)] = 87249,
  [SMALL_STATE(3005)] = 87267,
  [SMALL_STATE(3006)] = 87285,
  [SMALL_STATE(3007)] = 87305,
  [SMALL_STATE(3008)] = 87325,
  [SMALL_STATE(3009)] = 87345,
  [SMALL_STATE(3010)] = 87365,
  [SMALL_STATE(3011)] = 87385,
  [SMALL_STATE(3012)] = 87405,
  [SMALL_STATE(3013)] = 87421,
  [SMALL_STATE(3014)] = 87441,
  [SMALL_STATE(3015)] = 87461,
  [SMALL_STATE(3016)] = 87481,
  [SMALL_STATE(3017)] = 87499,
  [SMALL_STATE(3018)] = 87517,
  [SMALL_STATE(3019)] = 87537,
  [SMALL_STATE(3020)] = 87557,
  [SMALL_STATE(3021)] = 87577,
  [SMALL_STATE(3022)] = 87592,
  [SMALL_STATE(3023)] = 87609,
  [SMALL_STATE(3024)] = 87624,
  [SMALL_STATE(3025)] = 87641,
  [SMALL_STATE(3026)] = 87656,
  [SMALL_STATE(3027)] = 87673,
  [SMALL_STATE(3028)] = 87690,
  [SMALL_STATE(3029)] = 87707,
  [SMALL_STATE(3030)] = 87724,
  [SMALL_STATE(3031)] = 87739,
  [SMALL_STATE(3032)] = 87756,
  [SMALL_STATE(3033)] = 87773,
  [SMALL_STATE(3034)] = 87788,
  [SMALL_STATE(3035)] = 87805,
  [SMALL_STATE(3036)] = 87822,
  [SMALL_STATE(3037)] = 87839,
  [SMALL_STATE(3038)] = 87856,
  [SMALL_STATE(3039)] = 87873,
  [SMALL_STATE(3040)] = 87890,
  [SMALL_STATE(3041)] = 87907,
  [SMALL_STATE(3042)] = 87924,
  [SMALL_STATE(3043)] = 87939,
  [SMALL_STATE(3044)] = 87956,
  [SMALL_STATE(3045)] = 87973,
  [SMALL_STATE(3046)] = 87990,
  [SMALL_STATE(3047)] = 88005,
  [SMALL_STATE(3048)] = 88022,
  [SMALL_STATE(3049)] = 88039,
  [SMALL_STATE(3050)] = 88056,
  [SMALL_STATE(3051)] = 88073,
  [SMALL_STATE(3052)] = 88090,
  [SMALL_STATE(3053)] = 88107,
  [SMALL_STATE(3054)] = 88122,
  [SMALL_STATE(3055)] = 88137,
  [SMALL_STATE(3056)] = 88154,
  [SMALL_STATE(3057)] = 88171,
  [SMALL_STATE(3058)] = 88188,
  [SMALL_STATE(3059)] = 88205,
  [SMALL_STATE(3060)] = 88222,
  [SMALL_STATE(3061)] = 88237,
  [SMALL_STATE(3062)] = 88254,
  [SMALL_STATE(3063)] = 88271,
  [SMALL_STATE(3064)] = 88288,
  [SMALL_STATE(3065)] = 88305,
  [SMALL_STATE(3066)] = 88322,
  [SMALL_STATE(3067)] = 88337,
  [SMALL_STATE(3068)] = 88354,
  [SMALL_STATE(3069)] = 88371,
  [SMALL_STATE(3070)] = 88388,
  [SMALL_STATE(3071)] = 88405,
  [SMALL_STATE(3072)] = 88420,
  [SMALL_STATE(3073)] = 88435,
  [SMALL_STATE(3074)] = 88452,
  [SMALL_STATE(3075)] = 88467,
  [SMALL_STATE(3076)] = 88484,
  [SMALL_STATE(3077)] = 88501,
  [SMALL_STATE(3078)] = 88516,
  [SMALL_STATE(3079)] = 88533,
  [SMALL_STATE(3080)] = 88550,
  [SMALL_STATE(3081)] = 88567,
  [SMALL_STATE(3082)] = 88584,
  [SMALL_STATE(3083)] = 88599,
  [SMALL_STATE(3084)] = 88616,
  [SMALL_STATE(3085)] = 88633,
  [SMALL_STATE(3086)] = 88650,
  [SMALL_STATE(3087)] = 88667,
  [SMALL_STATE(3088)] = 88684,
  [SMALL_STATE(3089)] = 88701,
  [SMALL_STATE(3090)] = 88718,
  [SMALL_STATE(3091)] = 88735,
  [SMALL_STATE(3092)] = 88752,
  [SMALL_STATE(3093)] = 88767,
  [SMALL_STATE(3094)] = 88784,
  [SMALL_STATE(3095)] = 88801,
  [SMALL_STATE(3096)] = 88818,
  [SMALL_STATE(3097)] = 88835,
  [SMALL_STATE(3098)] = 88852,
  [SMALL_STATE(3099)] = 88867,
  [SMALL_STATE(3100)] = 88882,
  [SMALL_STATE(3101)] = 88897,
  [SMALL_STATE(3102)] = 88914,
  [SMALL_STATE(3103)] = 88929,
  [SMALL_STATE(3104)] = 88946,
  [SMALL_STATE(3105)] = 88963,
  [SMALL_STATE(3106)] = 88978,
  [SMALL_STATE(3107)] = 88993,
  [SMALL_STATE(3108)] = 89010,
  [SMALL_STATE(3109)] = 89025,
  [SMALL_STATE(3110)] = 89040,
  [SMALL_STATE(3111)] = 89057,
  [SMALL_STATE(3112)] = 89072,
  [SMALL_STATE(3113)] = 89089,
  [SMALL_STATE(3114)] = 89106,
  [SMALL_STATE(3115)] = 89123,
  [SMALL_STATE(3116)] = 89140,
  [SMALL_STATE(3117)] = 89157,
  [SMALL_STATE(3118)] = 89172,
  [SMALL_STATE(3119)] = 89187,
  [SMALL_STATE(3120)] = 89204,
  [SMALL_STATE(3121)] = 89221,
  [SMALL_STATE(3122)] = 89238,
  [SMALL_STATE(3123)] = 89253,
  [SMALL_STATE(3124)] = 89270,
  [SMALL_STATE(3125)] = 89287,
  [SMALL_STATE(3126)] = 89304,
  [SMALL_STATE(3127)] = 89321,
  [SMALL_STATE(3128)] = 89338,
  [SMALL_STATE(3129)] = 89355,
  [SMALL_STATE(3130)] = 89372,
  [SMALL_STATE(3131)] = 89389,
  [SMALL_STATE(3132)] = 89406,
  [SMALL_STATE(3133)] = 89421,
  [SMALL_STATE(3134)] = 89438,
  [SMALL_STATE(3135)] = 89453,
  [SMALL_STATE(3136)] = 89470,
  [SMALL_STATE(3137)] = 89485,
  [SMALL_STATE(3138)] = 89502,
  [SMALL_STATE(3139)] = 89519,
  [SMALL_STATE(3140)] = 89534,
  [SMALL_STATE(3141)] = 89551,
  [SMALL_STATE(3142)] = 89568,
  [SMALL_STATE(3143)] = 89585,
  [SMALL_STATE(3144)] = 89602,
  [SMALL_STATE(3145)] = 89619,
  [SMALL_STATE(3146)] = 89636,
  [SMALL_STATE(3147)] = 89651,
  [SMALL_STATE(3148)] = 89668,
  [SMALL_STATE(3149)] = 89685,
  [SMALL_STATE(3150)] = 89700,
  [SMALL_STATE(3151)] = 89717,
  [SMALL_STATE(3152)] = 89734,
  [SMALL_STATE(3153)] = 89751,
  [SMALL_STATE(3154)] = 89768,
  [SMALL_STATE(3155)] = 89783,
  [SMALL_STATE(3156)] = 89800,
  [SMALL_STATE(3157)] = 89817,
  [SMALL_STATE(3158)] = 89834,
  [SMALL_STATE(3159)] = 89849,
  [SMALL_STATE(3160)] = 89866,
  [SMALL_STATE(3161)] = 89883,
  [SMALL_STATE(3162)] = 89900,
  [SMALL_STATE(3163)] = 89917,
  [SMALL_STATE(3164)] = 89934,
  [SMALL_STATE(3165)] = 89951,
  [SMALL_STATE(3166)] = 89968,
  [SMALL_STATE(3167)] = 89985,
  [SMALL_STATE(3168)] = 90002,
  [SMALL_STATE(3169)] = 90017,
  [SMALL_STATE(3170)] = 90034,
  [SMALL_STATE(3171)] = 90049,
  [SMALL_STATE(3172)] = 90066,
  [SMALL_STATE(3173)] = 90083,
  [SMALL_STATE(3174)] = 90100,
  [SMALL_STATE(3175)] = 90117,
  [SMALL_STATE(3176)] = 90134,
  [SMALL_STATE(3177)] = 90151,
  [SMALL_STATE(3178)] = 90168,
  [SMALL_STATE(3179)] = 90185,
  [SMALL_STATE(3180)] = 90202,
  [SMALL_STATE(3181)] = 90219,
  [SMALL_STATE(3182)] = 90236,
  [SMALL_STATE(3183)] = 90253,
  [SMALL_STATE(3184)] = 90270,
  [SMALL_STATE(3185)] = 90287,
  [SMALL_STATE(3186)] = 90304,
  [SMALL_STATE(3187)] = 90321,
  [SMALL_STATE(3188)] = 90338,
  [SMALL_STATE(3189)] = 90355,
  [SMALL_STATE(3190)] = 90372,
  [SMALL_STATE(3191)] = 90389,
  [SMALL_STATE(3192)] = 90406,
  [SMALL_STATE(3193)] = 90423,
  [SMALL_STATE(3194)] = 90440,
  [SMALL_STATE(3195)] = 90457,
  [SMALL_STATE(3196)] = 90474,
  [SMALL_STATE(3197)] = 90491,
  [SMALL_STATE(3198)] = 90508,
  [SMALL_STATE(3199)] = 90525,
  [SMALL_STATE(3200)] = 90542,
  [SMALL_STATE(3201)] = 90559,
  [SMALL_STATE(3202)] = 90576,
  [SMALL_STATE(3203)] = 90593,
  [SMALL_STATE(3204)] = 90610,
  [SMALL_STATE(3205)] = 90625,
  [SMALL_STATE(3206)] = 90642,
  [SMALL_STATE(3207)] = 90659,
  [SMALL_STATE(3208)] = 90676,
  [SMALL_STATE(3209)] = 90693,
  [SMALL_STATE(3210)] = 90710,
  [SMALL_STATE(3211)] = 90725,
  [SMALL_STATE(3212)] = 90742,
  [SMALL_STATE(3213)] = 90759,
  [SMALL_STATE(3214)] = 90776,
  [SMALL_STATE(3215)] = 90793,
  [SMALL_STATE(3216)] = 90808,
  [SMALL_STATE(3217)] = 90825,
  [SMALL_STATE(3218)] = 90842,
  [SMALL_STATE(3219)] = 90859,
  [SMALL_STATE(3220)] = 90876,
  [SMALL_STATE(3221)] = 90893,
  [SMALL_STATE(3222)] = 90910,
  [SMALL_STATE(3223)] = 90927,
  [SMALL_STATE(3224)] = 90944,
  [SMALL_STATE(3225)] = 90961,
  [SMALL_STATE(3226)] = 90978,
  [SMALL_STATE(3227)] = 90995,
  [SMALL_STATE(3228)] = 91012,
  [SMALL_STATE(3229)] = 91029,
  [SMALL_STATE(3230)] = 91046,
  [SMALL_STATE(3231)] = 91063,
  [SMALL_STATE(3232)] = 91080,
  [SMALL_STATE(3233)] = 91097,
  [SMALL_STATE(3234)] = 91114,
  [SMALL_STATE(3235)] = 91129,
  [SMALL_STATE(3236)] = 91146,
  [SMALL_STATE(3237)] = 91163,
  [SMALL_STATE(3238)] = 91180,
  [SMALL_STATE(3239)] = 91197,
  [SMALL_STATE(3240)] = 91212,
  [SMALL_STATE(3241)] = 91229,
  [SMALL_STATE(3242)] = 91246,
  [SMALL_STATE(3243)] = 91263,
  [SMALL_STATE(3244)] = 91280,
  [SMALL_STATE(3245)] = 91297,
  [SMALL_STATE(3246)] = 91314,
  [SMALL_STATE(3247)] = 91331,
  [SMALL_STATE(3248)] = 91348,
  [SMALL_STATE(3249)] = 91365,
  [SMALL_STATE(3250)] = 91382,
  [SMALL_STATE(3251)] = 91399,
  [SMALL_STATE(3252)] = 91416,
  [SMALL_STATE(3253)] = 91431,
  [SMALL_STATE(3254)] = 91448,
  [SMALL_STATE(3255)] = 91465,
  [SMALL_STATE(3256)] = 91482,
  [SMALL_STATE(3257)] = 91499,
  [SMALL_STATE(3258)] = 91516,
  [SMALL_STATE(3259)] = 91533,
  [SMALL_STATE(3260)] = 91548,
  [SMALL_STATE(3261)] = 91565,
  [SMALL_STATE(3262)] = 91582,
  [SMALL_STATE(3263)] = 91599,
  [SMALL_STATE(3264)] = 91616,
  [SMALL_STATE(3265)] = 91633,
  [SMALL_STATE(3266)] = 91650,
  [SMALL_STATE(3267)] = 91667,
  [SMALL_STATE(3268)] = 91684,
  [SMALL_STATE(3269)] = 91701,
  [SMALL_STATE(3270)] = 91718,
  [SMALL_STATE(3271)] = 91735,
  [SMALL_STATE(3272)] = 91752,
  [SMALL_STATE(3273)] = 91769,
  [SMALL_STATE(3274)] = 91786,
  [SMALL_STATE(3275)] = 91801,
  [SMALL_STATE(3276)] = 91818,
  [SMALL_STATE(3277)] = 91835,
  [SMALL_STATE(3278)] = 91852,
  [SMALL_STATE(3279)] = 91869,
  [SMALL_STATE(3280)] = 91886,
  [SMALL_STATE(3281)] = 91903,
  [SMALL_STATE(3282)] = 91920,
  [SMALL_STATE(3283)] = 91937,
  [SMALL_STATE(3284)] = 91954,
  [SMALL_STATE(3285)] = 91971,
  [SMALL_STATE(3286)] = 91988,
  [SMALL_STATE(3287)] = 92005,
  [SMALL_STATE(3288)] = 92020,
  [SMALL_STATE(3289)] = 92037,
  [SMALL_STATE(3290)] = 92054,
  [SMALL_STATE(3291)] = 92071,
  [SMALL_STATE(3292)] = 92086,
  [SMALL_STATE(3293)] = 92103,
  [SMALL_STATE(3294)] = 92120,
  [SMALL_STATE(3295)] = 92137,
  [SMALL_STATE(3296)] = 92154,
  [SMALL_STATE(3297)] = 92171,
  [SMALL_STATE(3298)] = 92186,
  [SMALL_STATE(3299)] = 92203,
  [SMALL_STATE(3300)] = 92220,
  [SMALL_STATE(3301)] = 92234,
  [SMALL_STATE(3302)] = 92248,
  [SMALL_STATE(3303)] = 92262,
  [SMALL_STATE(3304)] = 92276,
  [SMALL_STATE(3305)] = 92290,
  [SMALL_STATE(3306)] = 92304,
  [SMALL_STATE(3307)] = 92318,
  [SMALL_STATE(3308)] = 92332,
  [SMALL_STATE(3309)] = 92346,
  [SMALL_STATE(3310)] = 92360,
  [SMALL_STATE(3311)] = 92374,
  [SMALL_STATE(3312)] = 92388,
  [SMALL_STATE(3313)] = 92402,
  [SMALL_STATE(3314)] = 92416,
  [SMALL_STATE(3315)] = 92430,
  [SMALL_STATE(3316)] = 92444,
  [SMALL_STATE(3317)] = 92458,
  [SMALL_STATE(3318)] = 92472,
  [SMALL_STATE(3319)] = 92486,
  [SMALL_STATE(3320)] = 92500,
  [SMALL_STATE(3321)] = 92514,
  [SMALL_STATE(3322)] = 92528,
  [SMALL_STATE(3323)] = 92542,
  [SMALL_STATE(3324)] = 92556,
  [SMALL_STATE(3325)] = 92570,
  [SMALL_STATE(3326)] = 92584,
  [SMALL_STATE(3327)] = 92598,
  [SMALL_STATE(3328)] = 92612,
  [SMALL_STATE(3329)] = 92626,
  [SMALL_STATE(3330)] = 92640,
  [SMALL_STATE(3331)] = 92654,
  [SMALL_STATE(3332)] = 92668,
  [SMALL_STATE(3333)] = 92682,
  [SMALL_STATE(3334)] = 92696,
  [SMALL_STATE(3335)] = 92710,
  [SMALL_STATE(3336)] = 92724,
  [SMALL_STATE(3337)] = 92738,
  [SMALL_STATE(3338)] = 92752,
  [SMALL_STATE(3339)] = 92766,
  [SMALL_STATE(3340)] = 92780,
  [SMALL_STATE(3341)] = 92794,
  [SMALL_STATE(3342)] = 92808,
  [SMALL_STATE(3343)] = 92822,
  [SMALL_STATE(3344)] = 92836,
  [SMALL_STATE(3345)] = 92850,
  [SMALL_STATE(3346)] = 92864,
  [SMALL_STATE(3347)] = 92878,
  [SMALL_STATE(3348)] = 92892,
  [SMALL_STATE(3349)] = 92906,
  [SMALL_STATE(3350)] = 92920,
  [SMALL_STATE(3351)] = 92934,
  [SMALL_STATE(3352)] = 92948,
  [SMALL_STATE(3353)] = 92962,
  [SMALL_STATE(3354)] = 92976,
  [SMALL_STATE(3355)] = 92990,
  [SMALL_STATE(3356)] = 93004,
  [SMALL_STATE(3357)] = 93018,
  [SMALL_STATE(3358)] = 93032,
  [SMALL_STATE(3359)] = 93046,
  [SMALL_STATE(3360)] = 93060,
  [SMALL_STATE(3361)] = 93074,
  [SMALL_STATE(3362)] = 93088,
  [SMALL_STATE(3363)] = 93102,
  [SMALL_STATE(3364)] = 93116,
  [SMALL_STATE(3365)] = 93130,
  [SMALL_STATE(3366)] = 93144,
  [SMALL_STATE(3367)] = 93158,
  [SMALL_STATE(3368)] = 93172,
  [SMALL_STATE(3369)] = 93186,
  [SMALL_STATE(3370)] = 93200,
  [SMALL_STATE(3371)] = 93214,
  [SMALL_STATE(3372)] = 93228,
  [SMALL_STATE(3373)] = 93242,
  [SMALL_STATE(3374)] = 93256,
  [SMALL_STATE(3375)] = 93270,
  [SMALL_STATE(3376)] = 93284,
  [SMALL_STATE(3377)] = 93298,
  [SMALL_STATE(3378)] = 93312,
  [SMALL_STATE(3379)] = 93326,
  [SMALL_STATE(3380)] = 93340,
  [SMALL_STATE(3381)] = 93354,
  [SMALL_STATE(3382)] = 93368,
  [SMALL_STATE(3383)] = 93382,
  [SMALL_STATE(3384)] = 93396,
  [SMALL_STATE(3385)] = 93410,
  [SMALL_STATE(3386)] = 93424,
  [SMALL_STATE(3387)] = 93438,
  [SMALL_STATE(3388)] = 93452,
  [SMALL_STATE(3389)] = 93466,
  [SMALL_STATE(3390)] = 93480,
  [SMALL_STATE(3391)] = 93494,
  [SMALL_STATE(3392)] = 93508,
  [SMALL_STATE(3393)] = 93522,
  [SMALL_STATE(3394)] = 93536,
  [SMALL_STATE(3395)] = 93550,
  [SMALL_STATE(3396)] = 93564,
  [SMALL_STATE(3397)] = 93578,
  [SMALL_STATE(3398)] = 93592,
  [SMALL_STATE(3399)] = 93606,
  [SMALL_STATE(3400)] = 93620,
  [SMALL_STATE(3401)] = 93634,
  [SMALL_STATE(3402)] = 93648,
  [SMALL_STATE(3403)] = 93662,
  [SMALL_STATE(3404)] = 93676,
  [SMALL_STATE(3405)] = 93690,
  [SMALL_STATE(3406)] = 93704,
  [SMALL_STATE(3407)] = 93718,
  [SMALL_STATE(3408)] = 93732,
  [SMALL_STATE(3409)] = 93746,
  [SMALL_STATE(3410)] = 93760,
  [SMALL_STATE(3411)] = 93774,
  [SMALL_STATE(3412)] = 93788,
  [SMALL_STATE(3413)] = 93802,
  [SMALL_STATE(3414)] = 93816,
  [SMALL_STATE(3415)] = 93830,
  [SMALL_STATE(3416)] = 93844,
  [SMALL_STATE(3417)] = 93858,
  [SMALL_STATE(3418)] = 93872,
  [SMALL_STATE(3419)] = 93886,
  [SMALL_STATE(3420)] = 93900,
  [SMALL_STATE(3421)] = 93914,
  [SMALL_STATE(3422)] = 93928,
  [SMALL_STATE(3423)] = 93942,
  [SMALL_STATE(3424)] = 93956,
  [SMALL_STATE(3425)] = 93970,
  [SMALL_STATE(3426)] = 93984,
  [SMALL_STATE(3427)] = 93998,
  [SMALL_STATE(3428)] = 94012,
  [SMALL_STATE(3429)] = 94026,
  [SMALL_STATE(3430)] = 94040,
  [SMALL_STATE(3431)] = 94054,
  [SMALL_STATE(3432)] = 94068,
  [SMALL_STATE(3433)] = 94082,
  [SMALL_STATE(3434)] = 94096,
  [SMALL_STATE(3435)] = 94110,
  [SMALL_STATE(3436)] = 94124,
  [SMALL_STATE(3437)] = 94138,
  [SMALL_STATE(3438)] = 94152,
  [SMALL_STATE(3439)] = 94166,
  [SMALL_STATE(3440)] = 94180,
  [SMALL_STATE(3441)] = 94194,
  [SMALL_STATE(3442)] = 94208,
  [SMALL_STATE(3443)] = 94222,
  [SMALL_STATE(3444)] = 94236,
  [SMALL_STATE(3445)] = 94250,
  [SMALL_STATE(3446)] = 94264,
  [SMALL_STATE(3447)] = 94278,
  [SMALL_STATE(3448)] = 94292,
  [SMALL_STATE(3449)] = 94306,
  [SMALL_STATE(3450)] = 94320,
  [SMALL_STATE(3451)] = 94334,
  [SMALL_STATE(3452)] = 94348,
  [SMALL_STATE(3453)] = 94362,
  [SMALL_STATE(3454)] = 94376,
  [SMALL_STATE(3455)] = 94390,
  [SMALL_STATE(3456)] = 94404,
  [SMALL_STATE(3457)] = 94418,
  [SMALL_STATE(3458)] = 94432,
  [SMALL_STATE(3459)] = 94446,
  [SMALL_STATE(3460)] = 94460,
  [SMALL_STATE(3461)] = 94474,
  [SMALL_STATE(3462)] = 94488,
  [SMALL_STATE(3463)] = 94502,
  [SMALL_STATE(3464)] = 94516,
  [SMALL_STATE(3465)] = 94530,
  [SMALL_STATE(3466)] = 94544,
  [SMALL_STATE(3467)] = 94558,
  [SMALL_STATE(3468)] = 94572,
  [SMALL_STATE(3469)] = 94586,
  [SMALL_STATE(3470)] = 94600,
  [SMALL_STATE(3471)] = 94614,
  [SMALL_STATE(3472)] = 94628,
  [SMALL_STATE(3473)] = 94642,
  [SMALL_STATE(3474)] = 94656,
  [SMALL_STATE(3475)] = 94670,
  [SMALL_STATE(3476)] = 94684,
  [SMALL_STATE(3477)] = 94698,
  [SMALL_STATE(3478)] = 94712,
  [SMALL_STATE(3479)] = 94726,
  [SMALL_STATE(3480)] = 94740,
  [SMALL_STATE(3481)] = 94754,
  [SMALL_STATE(3482)] = 94768,
  [SMALL_STATE(3483)] = 94782,
  [SMALL_STATE(3484)] = 94796,
  [SMALL_STATE(3485)] = 94810,
  [SMALL_STATE(3486)] = 94824,
  [SMALL_STATE(3487)] = 94838,
  [SMALL_STATE(3488)] = 94852,
  [SMALL_STATE(3489)] = 94866,
  [SMALL_STATE(3490)] = 94880,
  [SMALL_STATE(3491)] = 94894,
  [SMALL_STATE(3492)] = 94908,
  [SMALL_STATE(3493)] = 94922,
  [SMALL_STATE(3494)] = 94936,
  [SMALL_STATE(3495)] = 94950,
  [SMALL_STATE(3496)] = 94964,
  [SMALL_STATE(3497)] = 94978,
  [SMALL_STATE(3498)] = 94992,
  [SMALL_STATE(3499)] = 95006,
  [SMALL_STATE(3500)] = 95020,
  [SMALL_STATE(3501)] = 95034,
  [SMALL_STATE(3502)] = 95048,
  [SMALL_STATE(3503)] = 95062,
  [SMALL_STATE(3504)] = 95076,
  [SMALL_STATE(3505)] = 95090,
  [SMALL_STATE(3506)] = 95104,
  [SMALL_STATE(3507)] = 95118,
  [SMALL_STATE(3508)] = 95132,
  [SMALL_STATE(3509)] = 95146,
  [SMALL_STATE(3510)] = 95160,
  [SMALL_STATE(3511)] = 95174,
  [SMALL_STATE(3512)] = 95188,
  [SMALL_STATE(3513)] = 95202,
  [SMALL_STATE(3514)] = 95216,
  [SMALL_STATE(3515)] = 95230,
  [SMALL_STATE(3516)] = 95244,
  [SMALL_STATE(3517)] = 95258,
  [SMALL_STATE(3518)] = 95272,
  [SMALL_STATE(3519)] = 95286,
  [SMALL_STATE(3520)] = 95300,
  [SMALL_STATE(3521)] = 95314,
  [SMALL_STATE(3522)] = 95328,
  [SMALL_STATE(3523)] = 95342,
  [SMALL_STATE(3524)] = 95356,
  [SMALL_STATE(3525)] = 95370,
  [SMALL_STATE(3526)] = 95384,
  [SMALL_STATE(3527)] = 95398,
  [SMALL_STATE(3528)] = 95412,
  [SMALL_STATE(3529)] = 95426,
  [SMALL_STATE(3530)] = 95440,
  [SMALL_STATE(3531)] = 95454,
  [SMALL_STATE(3532)] = 95468,
  [SMALL_STATE(3533)] = 95482,
  [SMALL_STATE(3534)] = 95496,
  [SMALL_STATE(3535)] = 95510,
  [SMALL_STATE(3536)] = 95524,
  [SMALL_STATE(3537)] = 95538,
  [SMALL_STATE(3538)] = 95552,
  [SMALL_STATE(3539)] = 95566,
  [SMALL_STATE(3540)] = 95580,
  [SMALL_STATE(3541)] = 95594,
  [SMALL_STATE(3542)] = 95608,
  [SMALL_STATE(3543)] = 95622,
  [SMALL_STATE(3544)] = 95636,
  [SMALL_STATE(3545)] = 95650,
  [SMALL_STATE(3546)] = 95664,
  [SMALL_STATE(3547)] = 95678,
  [SMALL_STATE(3548)] = 95692,
  [SMALL_STATE(3549)] = 95706,
  [SMALL_STATE(3550)] = 95720,
  [SMALL_STATE(3551)] = 95734,
  [SMALL_STATE(3552)] = 95748,
  [SMALL_STATE(3553)] = 95762,
  [SMALL_STATE(3554)] = 95776,
  [SMALL_STATE(3555)] = 95790,
  [SMALL_STATE(3556)] = 95804,
  [SMALL_STATE(3557)] = 95818,
  [SMALL_STATE(3558)] = 95832,
  [SMALL_STATE(3559)] = 95846,
  [SMALL_STATE(3560)] = 95860,
  [SMALL_STATE(3561)] = 95874,
  [SMALL_STATE(3562)] = 95888,
  [SMALL_STATE(3563)] = 95902,
  [SMALL_STATE(3564)] = 95916,
  [SMALL_STATE(3565)] = 95930,
  [SMALL_STATE(3566)] = 95944,
  [SMALL_STATE(3567)] = 95958,
  [SMALL_STATE(3568)] = 95972,
  [SMALL_STATE(3569)] = 95986,
  [SMALL_STATE(3570)] = 96000,
  [SMALL_STATE(3571)] = 96014,
  [SMALL_STATE(3572)] = 96028,
  [SMALL_STATE(3573)] = 96042,
  [SMALL_STATE(3574)] = 96056,
  [SMALL_STATE(3575)] = 96070,
  [SMALL_STATE(3576)] = 96084,
  [SMALL_STATE(3577)] = 96098,
  [SMALL_STATE(3578)] = 96112,
  [SMALL_STATE(3579)] = 96126,
  [SMALL_STATE(3580)] = 96140,
  [SMALL_STATE(3581)] = 96154,
  [SMALL_STATE(3582)] = 96168,
  [SMALL_STATE(3583)] = 96182,
  [SMALL_STATE(3584)] = 96196,
  [SMALL_STATE(3585)] = 96210,
  [SMALL_STATE(3586)] = 96224,
  [SMALL_STATE(3587)] = 96238,
  [SMALL_STATE(3588)] = 96252,
  [SMALL_STATE(3589)] = 96266,
  [SMALL_STATE(3590)] = 96280,
  [SMALL_STATE(3591)] = 96294,
  [SMALL_STATE(3592)] = 96308,
  [SMALL_STATE(3593)] = 96322,
  [SMALL_STATE(3594)] = 96336,
  [SMALL_STATE(3595)] = 96350,
  [SMALL_STATE(3596)] = 96354,
  [SMALL_STATE(3597)] = 96358,
  [SMALL_STATE(3598)] = 96362,
  [SMALL_STATE(3599)] = 96366,
  [SMALL_STATE(3600)] = 96370,
  [SMALL_STATE(3601)] = 96374,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2445),
  [5] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2394),
  [7] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_source_file, .child_count = 0),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1481),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2728),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1465),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [33] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3028),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3031),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3482),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2037),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(39),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2035),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1085),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1035),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3593),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3033),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(823),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(195),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(832),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(819),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2486),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(300),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3582),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1945),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(37),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2295),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3546),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3542),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3538),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1505),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2025),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1870),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(190),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2036),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(38),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3075),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2491),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1441),
  [97] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2492),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1290),
  [101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2445),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2394),
  [105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1464),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3507),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1962),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1464),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3326),
  [117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3031),
  [121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_source_file, .child_count = 2),
  [123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2043),
  [127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_source_file, .child_count = 1),
  [129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1266),
  [133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1016),
  [135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2029),
  [139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1573),
  [141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2053),
  [143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1018),
  [149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1569),
  [159] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 2), SHIFT_REPEAT(1481),
  [162] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 2), SHIFT_REPEAT(687),
  [165] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 2), SHIFT_REPEAT(2728),
  [168] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 2), SHIFT_REPEAT(194),
  [171] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 2), SHIFT_REPEAT(143),
  [174] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 2), SHIFT_REPEAT(10),
  [177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 2),
  [179] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 2), SHIFT_REPEAT(253),
  [182] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 2), SHIFT_REPEAT(1465),
  [185] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 2), SHIFT_REPEAT(246),
  [188] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 2), SHIFT_REPEAT(791),
  [191] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 2), SHIFT_REPEAT(833),
  [194] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 2), SHIFT_REPEAT(36),
  [197] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 2), SHIFT_REPEAT(3028),
  [200] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 2), SHIFT_REPEAT(3031),
  [203] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 2), SHIFT_REPEAT(3482),
  [206] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 2), SHIFT_REPEAT(2037),
  [209] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 2), SHIFT_REPEAT(39),
  [212] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 2), SHIFT_REPEAT(2035),
  [215] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 2), SHIFT_REPEAT(1085),
  [218] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 2), SHIFT_REPEAT(1035),
  [221] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 2), SHIFT_REPEAT(3593),
  [224] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 2), SHIFT_REPEAT(3033),
  [227] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 2), SHIFT_REPEAT(823),
  [230] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 2), SHIFT_REPEAT(195),
  [233] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 2), SHIFT_REPEAT(832),
  [236] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 2), SHIFT_REPEAT(819),
  [239] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 2), SHIFT_REPEAT(2486),
  [242] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 2), SHIFT_REPEAT(300),
  [245] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 2), SHIFT_REPEAT(3582),
  [248] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 2), SHIFT_REPEAT(1945),
  [251] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 2), SHIFT_REPEAT(37),
  [254] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 2), SHIFT_REPEAT(2295),
  [257] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 2), SHIFT_REPEAT(3546),
  [260] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 2), SHIFT_REPEAT(3542),
  [263] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 2), SHIFT_REPEAT(3538),
  [266] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 2), SHIFT_REPEAT(1505),
  [269] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 2), SHIFT_REPEAT(2025),
  [272] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 2), SHIFT_REPEAT(1870),
  [275] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 2), SHIFT_REPEAT(190),
  [278] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 2), SHIFT_REPEAT(2036),
  [281] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 2), SHIFT_REPEAT(38),
  [284] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 2), SHIFT_REPEAT(3075),
  [287] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 2), SHIFT_REPEAT(2491),
  [290] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 2), SHIFT_REPEAT(1441),
  [293] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 2), SHIFT_REPEAT(2492),
  [296] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 2), SHIFT_REPEAT(1290),
  [299] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 2), SHIFT_REPEAT(1464),
  [302] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 2), SHIFT_REPEAT(3507),
  [305] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 2), SHIFT_REPEAT(1962),
  [308] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 2), SHIFT_REPEAT(1464),
  [311] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 2), SHIFT_REPEAT(3326),
  [314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1571),
  [318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1148),
  [320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1572),
  [322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2038),
  [326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1111),
  [332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1028),
  [336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_break_expression, .child_count = 2),
  [338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2538),
  [342] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_break_expression, .child_count = 2),
  [344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(253),
  [346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2443),
  [348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2501),
  [350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1462),
  [352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(800),
  [354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(199),
  [356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2586),
  [358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(256),
  [360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2785),
  [362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2502),
  [364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(201),
  [366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2588),
  [368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_range_expression, .child_count = 1),
  [370] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_range_expression, .child_count = 1),
  [372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_return_expression, .child_count = 1),
  [374] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_return_expression, .child_count = 1),
  [376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(246),
  [378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(791),
  [380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(833),
  [382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(40),
  [384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_yield_expression, .child_count = 1),
  [386] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_yield_expression, .child_count = 1),
  [388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_break_expression, .child_count = 1),
  [390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_break_expression, .child_count = 1),
  [392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3388),
  [394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_range_expression, .child_count = 2),
  [396] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_range_expression, .child_count = 2),
  [398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1502),
  [400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2494),
  [404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1567),
  [406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(316),
  [408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3038),
  [410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2432),
  [412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(46),
  [414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2583),
  [416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1564),
  [418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1539),
  [420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(809),
  [422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(171),
  [424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2608),
  [426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(248),
  [428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(47),
  [430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2898),
  [432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2653),
  [434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(174),
  [436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(48),
  [438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3198),
  [440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2607),
  [442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1831),
  [444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2574),
  [446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1829),
  [448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1620),
  [450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3453),
  [452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1620),
  [454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3509),
  [456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1499),
  [458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1555),
  [460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(366),
  [462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3130),
  [464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(58),
  [466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1549),
  [468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1531),
  [470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(59),
  [472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2925),
  [474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(53),
  [476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3193),
  [478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1551),
  [480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3305),
  [482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1551),
  [484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3578),
  [486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(245),
  [492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(44),
  [494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(254),
  [496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(61),
  [498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(57),
  [500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3011),
  [502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(56),
  [504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3041),
  [506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(243),
  [508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(63),
  [510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(247),
  [512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(65),
  [514] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_token_tree_pattern_repeat1, .child_count = 2), SHIFT_REPEAT(163),
  [517] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_token_tree_pattern_repeat1, .child_count = 2), SHIFT_REPEAT(146),
  [520] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_token_tree_pattern_repeat1, .child_count = 2), SHIFT_REPEAT(71),
  [523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_token_tree_pattern_repeat1, .child_count = 2),
  [525] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_token_tree_pattern_repeat1, .child_count = 2), SHIFT_REPEAT(70),
  [528] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_token_tree_pattern_repeat1, .child_count = 2), SHIFT_REPEAT(68),
  [531] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_token_tree_pattern_repeat1, .child_count = 2), SHIFT_REPEAT(146),
  [534] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_token_tree_pattern_repeat1, .child_count = 2), SHIFT_REPEAT(3564),
  [537] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_token_tree_pattern_repeat1, .child_count = 2), SHIFT_REPEAT(140),
  [540] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_token_tree_pattern_repeat1, .child_count = 2), SHIFT_REPEAT(2584),
  [543] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_token_tree_pattern_repeat1, .child_count = 2), SHIFT_REPEAT(145),
  [546] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_token_tree_pattern_repeat1, .child_count = 2), SHIFT_REPEAT(160),
  [549] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_token_tree_pattern_repeat1, .child_count = 2), SHIFT_REPEAT(3503),
  [552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(163),
  [554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(146),
  [566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3564),
  [568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2584),
  [572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(145),
  [574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3503),
  [578] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_token_tree_repeat1, .child_count = 2), SHIFT_REPEAT(152),
  [581] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_token_tree_repeat1, .child_count = 2), SHIFT_REPEAT(146),
  [584] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_token_tree_repeat1, .child_count = 2), SHIFT_REPEAT(124),
  [587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_token_tree_repeat1, .child_count = 2),
  [589] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_token_tree_repeat1, .child_count = 2), SHIFT_REPEAT(125),
  [592] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_token_tree_repeat1, .child_count = 2), SHIFT_REPEAT(126),
  [595] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_token_tree_repeat1, .child_count = 2), SHIFT_REPEAT(146),
  [598] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_token_tree_repeat1, .child_count = 2), SHIFT_REPEAT(3477),
  [601] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_token_tree_repeat1, .child_count = 2), SHIFT_REPEAT(140),
  [604] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_token_tree_repeat1, .child_count = 2), SHIFT_REPEAT(2584),
  [607] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_token_tree_repeat1, .child_count = 2), SHIFT_REPEAT(145),
  [610] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_token_tree_repeat1, .child_count = 2), SHIFT_REPEAT(152),
  [613] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_token_tree_repeat1, .child_count = 2), SHIFT_REPEAT(3503),
  [616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2629),
  [618] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_delim_token_tree_repeat1, .child_count = 2), SHIFT_REPEAT(208),
  [621] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_delim_token_tree_repeat1, .child_count = 2), SHIFT_REPEAT(200),
  [624] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_delim_token_tree_repeat1, .child_count = 2), SHIFT_REPEAT(95),
  [627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_delim_token_tree_repeat1, .child_count = 2),
  [629] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_delim_token_tree_repeat1, .child_count = 2), SHIFT_REPEAT(96),
  [632] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_delim_token_tree_repeat1, .child_count = 2), SHIFT_REPEAT(101),
  [635] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_delim_token_tree_repeat1, .child_count = 2), SHIFT_REPEAT(200),
  [638] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_delim_token_tree_repeat1, .child_count = 2), SHIFT_REPEAT(208),
  [641] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_delim_token_tree_repeat1, .child_count = 2), SHIFT_REPEAT(188),
  [644] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_delim_token_tree_repeat1, .child_count = 2), SHIFT_REPEAT(2656),
  [647] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_delim_token_tree_repeat1, .child_count = 2), SHIFT_REPEAT(182),
  [650] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_delim_token_tree_repeat1, .child_count = 2), SHIFT_REPEAT(3449),
  [653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3468),
  [655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3370),
  [659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2570),
  [661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(208),
  [663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1784),
  [671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(200),
  [675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2656),
  [681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(182),
  [683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3449),
  [685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1260),
  [689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1781),
  [691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1936),
  [693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(152),
  [695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2627),
  [699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3477),
  [705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2569),
  [711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1012),
  [713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2537),
  [715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1946),
  [717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1442),
  [719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2536),
  [721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1019),
  [731] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = aux_sym__non_special_token_repeat1, .child_count = 2),
  [733] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym__non_special_token_repeat1, .child_count = 2), SHIFT_REPEAT(146),
  [736] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym__non_special_token_repeat1, .child_count = 2),
  [738] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym__non_special_token_repeat1, .child_count = 2), SHIFT_REPEAT(146),
  [741] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = aux_sym_token_tree_repeat1, .child_count = 1),
  [743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_token_tree_repeat1, .child_count = 1),
  [745] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym__token_pattern, .child_count = 1),
  [747] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym__token_pattern, .child_count = 1),
  [749] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_string_literal, .child_count = 3),
  [751] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_string_literal, .child_count = 3),
  [753] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_token_tree, .child_count = 2),
  [755] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_token_tree, .child_count = 2),
  [757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1696),
  [759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3418),
  [761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3455),
  [763] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym__literal, .child_count = 1),
  [765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym__literal, .child_count = 1),
  [767] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_token_tree_pattern, .child_count = 3),
  [769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_token_tree_pattern, .child_count = 3),
  [771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_token_tree_pattern, .child_count = 2),
  [773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_token_tree_pattern, .child_count = 2),
  [775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1439),
  [777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3446),
  [779] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym__non_special_token_repeat1, .child_count = 2), SHIFT_REPEAT(200),
  [782] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym__non_special_token_repeat1, .child_count = 2), SHIFT_REPEAT(200),
  [785] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_boolean_literal, .child_count = 1),
  [787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_boolean_literal, .child_count = 1),
  [789] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = aux_sym__non_special_token_repeat1, .child_count = 1),
  [791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym__non_special_token_repeat1, .child_count = 1),
  [793] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_string_literal, .child_count = 2),
  [795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_string_literal, .child_count = 2),
  [797] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym__non_delim_token, .child_count = 1),
  [799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym__non_delim_token, .child_count = 1),
  [801] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_fragment_specifier, .child_count = 1),
  [803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_fragment_specifier, .child_count = 1),
  [805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3329),
  [809] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_token_binding_pattern, .child_count = 3, .production_id = 197),
  [811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_token_binding_pattern, .child_count = 3, .production_id = 197),
  [813] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_raw_string_literal, .child_count = 3),
  [815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_raw_string_literal, .child_count = 3),
  [817] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_enum_variant_list_repeat1, .child_count = 2), SHIFT(1028),
  [820] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_enum_variant_list_repeat1, .child_count = 2), SHIFT(194),
  [823] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_enum_variant_list_repeat1, .child_count = 2), SHIFT(143),
  [826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_enum_variant_list_repeat1, .child_count = 2),
  [828] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_enum_variant_list_repeat1, .child_count = 2), SHIFT(8),
  [831] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_enum_variant_list_repeat1, .child_count = 2), SHIFT(253),
  [834] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_enum_variant_list_repeat1, .child_count = 2), SHIFT(1465),
  [837] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_enum_variant_list_repeat1, .child_count = 2), SHIFT(246),
  [840] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_enum_variant_list_repeat1, .child_count = 2), SHIFT(791),
  [843] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_enum_variant_list_repeat1, .child_count = 2), SHIFT(833),
  [846] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_enum_variant_list_repeat1, .child_count = 2), SHIFT(36),
  [849] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_enum_variant_list_repeat1, .child_count = 2), SHIFT(3028),
  [852] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_enum_variant_list_repeat1, .child_count = 2), SHIFT_REPEAT(3455),
  [855] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_enum_variant_list_repeat1, .child_count = 2), SHIFT(3482),
  [858] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_enum_variant_list_repeat1, .child_count = 2), SHIFT(2443),
  [861] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_enum_variant_list_repeat1, .child_count = 2), SHIFT(39),
  [864] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_enum_variant_list_repeat1, .child_count = 2), SHIFT(2501),
  [867] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_enum_variant_list_repeat1, .child_count = 2), SHIFT(1085),
  [870] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_enum_variant_list_repeat1, .child_count = 2), SHIFT(1462),
  [873] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_enum_variant_list_repeat1, .child_count = 2), SHIFT(800),
  [876] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_enum_variant_list_repeat1, .child_count = 2), SHIFT(199),
  [879] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_enum_variant_list_repeat1, .child_count = 2), SHIFT(2586),
  [882] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_enum_variant_list_repeat1, .child_count = 2), SHIFT(256),
  [885] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_enum_variant_list_repeat1, .child_count = 2), SHIFT(37),
  [888] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_enum_variant_list_repeat1, .child_count = 2), SHIFT(2785),
  [891] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_enum_variant_list_repeat1, .child_count = 2), SHIFT(2502),
  [894] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_enum_variant_list_repeat1, .child_count = 2), SHIFT(201),
  [897] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_enum_variant_list_repeat1, .child_count = 2), SHIFT(38),
  [900] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_enum_variant_list_repeat1, .child_count = 2), SHIFT(3075),
  [903] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_enum_variant_list_repeat1, .child_count = 2), SHIFT(2588),
  [906] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_enum_variant_list_repeat1, .child_count = 2), SHIFT(1441),
  [909] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_enum_variant_list_repeat1, .child_count = 2), SHIFT(2492),
  [912] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_enum_variant_list_repeat1, .child_count = 2), SHIFT(1290),
  [915] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_enum_variant_list_repeat1, .child_count = 2), SHIFT(1464),
  [918] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_enum_variant_list_repeat1, .child_count = 2), SHIFT(3507),
  [921] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_enum_variant_list_repeat1, .child_count = 2), SHIFT(1464),
  [924] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_enum_variant_list_repeat1, .child_count = 2), SHIFT(3326),
  [927] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = aux_sym_token_tree_pattern_repeat1, .child_count = 1),
  [929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_token_tree_pattern_repeat1, .child_count = 1),
  [931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3363),
  [935] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_token_repetition, .child_count = 6),
  [937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_token_repetition, .child_count = 6),
  [939] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_token_repetition, .child_count = 5),
  [941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_token_repetition, .child_count = 5),
  [943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1990),
  [945] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_token_repetition, .child_count = 4),
  [947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_token_repetition, .child_count = 4),
  [949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1763),
  [951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3585),
  [953] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_token_tree, .child_count = 3),
  [955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_token_tree, .child_count = 3),
  [957] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_token_repetition_pattern, .child_count = 6),
  [959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_token_repetition_pattern, .child_count = 6),
  [961] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_token_repetition_pattern, .child_count = 5),
  [963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_token_repetition_pattern, .child_count = 5),
  [965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1802),
  [967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3566),
  [969] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_token_repetition_pattern, .child_count = 4),
  [971] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_token_repetition_pattern, .child_count = 4),
  [973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1667),
  [975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1303),
  [977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(793),
  [985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1746),
  [987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1426),
  [991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1444),
  [993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1193),
  [995] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_delim_token_tree, .child_count = 3),
  [997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_delim_token_tree, .child_count = 3),
  [999] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_delim_token_tree, .child_count = 2),
  [1001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_delim_token_tree, .child_count = 2),
  [1003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [1005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [1007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [1009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [1011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(797),
  [1013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1701),
  [1015] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym__delim_tokens, .child_count = 1),
  [1017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym__delim_tokens, .child_count = 1),
  [1019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1438),
  [1021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1639),
  [1023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1692),
  [1025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [1027] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = aux_sym_delim_token_tree_repeat1, .child_count = 1),
  [1029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_delim_token_tree_repeat1, .child_count = 1),
  [1031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1651),
  [1033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1634),
  [1035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1669),
  [1037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1131),
  [1039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [1041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1151),
  [1043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [1045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [1047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [1049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [1051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1821),
  [1053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [1055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [1057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1284),
  [1059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [1061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [1063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [1065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1649),
  [1067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [1069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1799),
  [1071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [1073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [1075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1756),
  [1077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1702),
  [1079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1300),
  [1081] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_tuple_expression_repeat1, .child_count = 2), SHIFT_REPEAT(1028),
  [1084] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_tuple_expression_repeat1, .child_count = 2), SHIFT_REPEAT(194),
  [1087] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_tuple_expression_repeat1, .child_count = 2),
  [1089] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_tuple_expression_repeat1, .child_count = 2), SHIFT_REPEAT(143),
  [1092] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_tuple_expression_repeat1, .child_count = 2), SHIFT_REPEAT(8),
  [1095] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_tuple_expression_repeat1, .child_count = 2), SHIFT_REPEAT(253),
  [1098] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_tuple_expression_repeat1, .child_count = 2), SHIFT_REPEAT(1465),
  [1101] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_tuple_expression_repeat1, .child_count = 2), SHIFT_REPEAT(246),
  [1104] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_tuple_expression_repeat1, .child_count = 2), SHIFT_REPEAT(791),
  [1107] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_tuple_expression_repeat1, .child_count = 2), SHIFT_REPEAT(833),
  [1110] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_tuple_expression_repeat1, .child_count = 2), SHIFT_REPEAT(36),
  [1113] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_tuple_expression_repeat1, .child_count = 2), SHIFT_REPEAT(3028),
  [1116] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_tuple_expression_repeat1, .child_count = 2), SHIFT_REPEAT(3482),
  [1119] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_tuple_expression_repeat1, .child_count = 2), SHIFT_REPEAT(2443),
  [1122] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_tuple_expression_repeat1, .child_count = 2), SHIFT_REPEAT(39),
  [1125] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_tuple_expression_repeat1, .child_count = 2), SHIFT_REPEAT(2501),
  [1128] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_tuple_expression_repeat1, .child_count = 2), SHIFT_REPEAT(1085),
  [1131] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_tuple_expression_repeat1, .child_count = 2), SHIFT_REPEAT(1462),
  [1134] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_tuple_expression_repeat1, .child_count = 2), SHIFT_REPEAT(800),
  [1137] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_tuple_expression_repeat1, .child_count = 2), SHIFT_REPEAT(199),
  [1140] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_tuple_expression_repeat1, .child_count = 2), SHIFT_REPEAT(2586),
  [1143] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_tuple_expression_repeat1, .child_count = 2), SHIFT_REPEAT(256),
  [1146] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_tuple_expression_repeat1, .child_count = 2), SHIFT_REPEAT(37),
  [1149] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_tuple_expression_repeat1, .child_count = 2), SHIFT_REPEAT(2785),
  [1152] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_tuple_expression_repeat1, .child_count = 2), SHIFT_REPEAT(2502),
  [1155] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_tuple_expression_repeat1, .child_count = 2), SHIFT_REPEAT(201),
  [1158] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_tuple_expression_repeat1, .child_count = 2), SHIFT_REPEAT(38),
  [1161] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_tuple_expression_repeat1, .child_count = 2), SHIFT_REPEAT(3075),
  [1164] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_tuple_expression_repeat1, .child_count = 2), SHIFT_REPEAT(2588),
  [1167] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_tuple_expression_repeat1, .child_count = 2), SHIFT_REPEAT(1441),
  [1170] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_tuple_expression_repeat1, .child_count = 2), SHIFT_REPEAT(2492),
  [1173] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_tuple_expression_repeat1, .child_count = 2), SHIFT_REPEAT(1290),
  [1176] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_tuple_expression_repeat1, .child_count = 2), SHIFT_REPEAT(1464),
  [1179] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_tuple_expression_repeat1, .child_count = 2), SHIFT_REPEAT(3507),
  [1182] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_tuple_expression_repeat1, .child_count = 2), SHIFT_REPEAT(1464),
  [1185] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_tuple_expression_repeat1, .child_count = 2), SHIFT_REPEAT(3326),
  [1188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1757),
  [1190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [1192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(308),
  [1194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_if_expression, .child_count = 3, .production_id = 30),
  [1196] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_if_expression, .child_count = 3, .production_id = 30),
  [1198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2282),
  [1200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(330),
  [1202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(367),
  [1204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(349),
  [1206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [1208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [1210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2444),
  [1212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2605),
  [1214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(820),
  [1216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(175),
  [1218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2660),
  [1220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(359),
  [1222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2597),
  [1224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(173),
  [1226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2658),
  [1228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_block, .child_count = 5),
  [1230] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_block, .child_count = 5),
  [1232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_block, .child_count = 3),
  [1234] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_block, .child_count = 3),
  [1236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_block, .child_count = 4),
  [1238] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_block, .child_count = 4),
  [1240] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_block, .child_count = 6),
  [1242] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_block, .child_count = 6),
  [1244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_block, .child_count = 2),
  [1246] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_block, .child_count = 2),
  [1248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_async_block, .child_count = 3),
  [1250] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_async_block, .child_count = 3),
  [1252] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_match_block, .child_count = 3),
  [1254] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_match_block, .child_count = 3),
  [1256] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_else_clause, .child_count = 2),
  [1258] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_else_clause, .child_count = 2),
  [1260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_match_block, .child_count = 2),
  [1262] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_match_block, .child_count = 2),
  [1264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1940),
  [1266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [1268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1933),
  [1270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [1272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3158),
  [1274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [1276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2142),
  [1278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3134),
  [1280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1975),
  [1282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [1284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [1286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2418),
  [1288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2104),
  [1290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3071),
  [1292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3534),
  [1294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3232),
  [1296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3570),
  [1298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3425),
  [1300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2324),
  [1302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2069),
  [1304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1986),
  [1306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3164),
  [1308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3419),
  [1310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1068),
  [1312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2151),
  [1314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2183),
  [1316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(804),
  [1318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1492),
  [1320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(779),
  [1322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2006),
  [1324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2589),
  [1326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1992),
  [1328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2277),
  [1330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2548),
  [1332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2278),
  [1334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3310),
  [1336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_while_expression, .child_count = 3, .production_id = 38),
  [1338] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_while_expression, .child_count = 3, .production_id = 38),
  [1340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_expression_statement, .child_count = 1),
  [1342] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_expression_statement, .child_count = 1),
  [1344] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym__expression_except_range, .child_count = 1),
  [1346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym__expression_except_range, .child_count = 1),
  [1348] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_match_block, .child_count = 4),
  [1350] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_match_block, .child_count = 4),
  [1352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_macro_invocation, .child_count = 3, .production_id = 39),
  [1354] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_macro_invocation, .child_count = 3, .production_id = 39),
  [1356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1953),
  [1358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [1360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2311),
  [1362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2164),
  [1364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [1366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2446),
  [1368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3452),
  [1370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3270),
  [1372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1924),
  [1374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2063),
  [1376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2259),
  [1378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2498),
  [1380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2262),
  [1382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_loop_expression, .child_count = 2, .production_id = 8),
  [1384] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_loop_expression, .child_count = 2, .production_id = 8),
  [1386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2298),
  [1388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3466),
  [1390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_if_expression, .child_count = 4, .production_id = 75),
  [1392] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_if_expression, .child_count = 4, .production_id = 75),
  [1394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_macro_invocation, .child_count = 3, .production_id = 28),
  [1396] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_macro_invocation, .child_count = 3, .production_id = 28),
  [1398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_loop_expression, .child_count = 4, .production_id = 98),
  [1400] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_loop_expression, .child_count = 4, .production_id = 98),
  [1402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_match_expression, .child_count = 3, .production_id = 33),
  [1404] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_match_expression, .child_count = 3, .production_id = 33),
  [1406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_for_expression, .child_count = 5, .production_id = 115),
  [1408] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_for_expression, .child_count = 5, .production_id = 115),
  [1410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [1412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2413),
  [1414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3346),
  [1416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_async_block, .child_count = 2),
  [1418] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_async_block, .child_count = 2),
  [1420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_while_expression, .child_count = 5, .production_id = 145),
  [1422] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_while_expression, .child_count = 5, .production_id = 145),
  [1424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_const_block, .child_count = 2, .production_id = 8),
  [1426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_const_block, .child_count = 2, .production_id = 8),
  [1428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1621),
  [1430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2395),
  [1432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3471),
  [1434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2355),
  [1436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3439),
  [1438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_for_expression, .child_count = 7, .production_id = 241),
  [1440] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_for_expression, .child_count = 7, .production_id = 241),
  [1442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym__statement, .child_count = 1),
  [1444] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym__statement, .child_count = 1),
  [1446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_unsafe_block, .child_count = 2),
  [1448] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_unsafe_block, .child_count = 2),
  [1450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_try_block, .child_count = 2),
  [1452] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_try_block, .child_count = 2),
  [1454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1941),
  [1456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2677),
  [1458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1586),
  [1460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1943),
  [1462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1624),
  [1464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [1466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [1468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1950),
  [1470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1619),
  [1472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [1474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2388),
  [1476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [1478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [1480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2103),
  [1482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2104),
  [1484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3364),
  [1486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2927),
  [1488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(792),
  [1490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3152),
  [1492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2461),
  [1494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2421),
  [1496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2620),
  [1498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2434),
  [1500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2415),
  [1502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2383),
  [1504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1944),
  [1506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [1508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2114),
  [1510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2161),
  [1512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [1514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3372),
  [1516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3275),
  [1518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1951),
  [1520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2094),
  [1522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2496),
  [1524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2264),
  [1526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2321),
  [1528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [1530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(423),
  [1532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(424),
  [1534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(428),
  [1536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2313),
  [1538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(419),
  [1540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2325),
  [1542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(425),
  [1544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2351),
  [1546] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_label, .child_count = 2),
  [1548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_label, .child_count = 2),
  [1550] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_closure_parameters, .child_count = 2),
  [1552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_closure_parameters, .child_count = 2),
  [1554] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_closure_parameters, .child_count = 3),
  [1556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_closure_parameters, .child_count = 3),
  [1558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2052),
  [1560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [1562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [1564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [1566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1949),
  [1568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [1570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1913),
  [1572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3153),
  [1574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3537),
  [1576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2108),
  [1578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2519),
  [1580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2835),
  [1582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3315),
  [1584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1930),
  [1586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1052),
  [1588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1058),
  [1590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1919),
  [1592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1921),
  [1594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [1596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1537),
  [1598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1538),
  [1600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1553),
  [1602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2347),
  [1604] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_match_arm, .child_count = 4, .production_id = 116),
  [1606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_match_arm, .child_count = 4, .production_id = 116),
  [1608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1995),
  [1610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [1612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [1614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [1616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2242),
  [1618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3154),
  [1620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [1622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [1624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2834),
  [1626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2831),
  [1628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3253),
  [1630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3044),
  [1632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2655),
  [1634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2118),
  [1636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(807),
  [1638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(813),
  [1640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2345),
  [1642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2606),
  [1644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2290),
  [1646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2609),
  [1648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2609),
  [1650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3484),
  [1652] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_match_arm, .child_count = 3, .production_id = 172),
  [1654] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_match_arm, .child_count = 3, .production_id = 172),
  [1656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [1658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1761),
  [1660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [1662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_signature_item, .child_count = 7, .production_id = 231),
  [1664] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_signature_item, .child_count = 7, .production_id = 231),
  [1666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 6, .production_id = 123),
  [1668] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 6, .production_id = 123),
  [1670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_signature_item, .child_count = 8, .production_id = 266),
  [1672] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_signature_item, .child_count = 8, .production_id = 266),
  [1674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_item, .child_count = 8, .production_id = 265),
  [1676] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_item, .child_count = 8, .production_id = 265),
  [1678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_let_declaration, .child_count = 5, .production_id = 100),
  [1680] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_let_declaration, .child_count = 5, .production_id = 100),
  [1682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 5, .production_id = 124),
  [1684] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 5, .production_id = 124),
  [1686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_trait_item, .child_count = 3, .production_id = 29),
  [1688] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_trait_item, .child_count = 3, .production_id = 29),
  [1690] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 5, .production_id = 123),
  [1692] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 5, .production_id = 123),
  [1694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_signature_item, .child_count = 8, .production_id = 238),
  [1696] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_signature_item, .child_count = 8, .production_id = 238),
  [1698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_associated_type, .child_count = 3, .production_id = 7),
  [1700] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_associated_type, .child_count = 3, .production_id = 7),
  [1702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 5, .production_id = 122),
  [1704] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 5, .production_id = 122),
  [1706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_union_item, .child_count = 3, .production_id = 29),
  [1708] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_union_item, .child_count = 3, .production_id = 29),
  [1710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_trait_item, .child_count = 8, .production_id = 264),
  [1712] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_trait_item, .child_count = 8, .production_id = 264),
  [1714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 5, .production_id = 79),
  [1716] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 5, .production_id = 79),
  [1718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_type_item, .child_count = 8, .production_id = 233),
  [1720] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_type_item, .child_count = 8, .production_id = 233),
  [1722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 5, .production_id = 121),
  [1724] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 5, .production_id = 121),
  [1726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_static_item, .child_count = 8, .production_id = 263),
  [1728] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_static_item, .child_count = 8, .production_id = 263),
  [1730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_const_item, .child_count = 8, .production_id = 250),
  [1732] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_const_item, .child_count = 8, .production_id = 250),
  [1734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 5, .production_id = 120),
  [1736] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 5, .production_id = 120),
  [1738] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_item, .child_count = 8, .production_id = 262),
  [1740] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_item, .child_count = 8, .production_id = 262),
  [1742] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_signature_item, .child_count = 8, .production_id = 231),
  [1744] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_signature_item, .child_count = 8, .production_id = 231),
  [1746] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_item, .child_count = 8, .production_id = 261),
  [1748] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_item, .child_count = 8, .production_id = 261),
  [1750] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_signature_item, .child_count = 8, .production_id = 260),
  [1752] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_signature_item, .child_count = 8, .production_id = 260),
  [1754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_use_declaration, .child_count = 3, .production_id = 37),
  [1756] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_use_declaration, .child_count = 3, .production_id = 37),
  [1758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 8, .production_id = 259),
  [1760] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 8, .production_id = 259),
  [1762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 8, .production_id = 227),
  [1764] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 8, .production_id = 227),
  [1766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 8, .production_id = 258),
  [1768] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 8, .production_id = 258),
  [1770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 8, .production_id = 225),
  [1772] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 8, .production_id = 225),
  [1774] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 8, .production_id = 257),
  [1776] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 8, .production_id = 257),
  [1778] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_item, .child_count = 8, .production_id = 267),
  [1780] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_item, .child_count = 8, .production_id = 267),
  [1782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_item, .child_count = 5, .production_id = 114),
  [1784] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_item, .child_count = 5, .production_id = 114),
  [1786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 8, .production_id = 256),
  [1788] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 8, .production_id = 256),
  [1790] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_signature_item, .child_count = 5, .production_id = 73),
  [1792] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_signature_item, .child_count = 5, .production_id = 73),
  [1794] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 8, .production_id = 255),
  [1796] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 8, .production_id = 255),
  [1798] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 8, .production_id = 254),
  [1800] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 8, .production_id = 254),
  [1802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_declaration_list, .child_count = 2),
  [1804] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_declaration_list, .child_count = 2),
  [1806] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 8, .production_id = 253),
  [1808] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 8, .production_id = 253),
  [1810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 8, .production_id = 223),
  [1812] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 8, .production_id = 223),
  [1814] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_item, .child_count = 5, .production_id = 113),
  [1816] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_item, .child_count = 5, .production_id = 113),
  [1818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 8, .production_id = 252),
  [1820] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 8, .production_id = 252),
  [1822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_struct_item, .child_count = 3, .production_id = 7),
  [1824] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_struct_item, .child_count = 3, .production_id = 7),
  [1826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 8, .production_id = 221),
  [1828] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 8, .production_id = 221),
  [1830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_field_declaration_list, .child_count = 6),
  [1832] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_field_declaration_list, .child_count = 6),
  [1834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_signature_item, .child_count = 5, .production_id = 112),
  [1836] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_signature_item, .child_count = 5, .production_id = 112),
  [1838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_static_item, .child_count = 8, .production_id = 250),
  [1840] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_static_item, .child_count = 8, .production_id = 250),
  [1842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_let_declaration, .child_count = 8, .production_id = 249),
  [1844] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_let_declaration, .child_count = 8, .production_id = 249),
  [1846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3201),
  [1848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1308),
  [1850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2762),
  [1852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [1854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3328),
  [1856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3146),
  [1858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3084),
  [1860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2261),
  [1862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2186),
  [1864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3313),
  [1866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3082),
  [1868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(839),
  [1870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(810),
  [1872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3320),
  [1874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2940),
  [1876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3322),
  [1878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3324),
  [1880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3325),
  [1882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2939),
  [1884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2185),
  [1886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1868),
  [1888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2041),
  [1890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3307),
  [1892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1966),
  [1894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3307),
  [1896] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_let_declaration, .child_count = 8, .production_id = 248),
  [1898] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_let_declaration, .child_count = 8, .production_id = 248),
  [1900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_let_declaration, .child_count = 8, .production_id = 247),
  [1902] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_let_declaration, .child_count = 8, .production_id = 247),
  [1904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 8, .production_id = 246),
  [1906] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 8, .production_id = 246),
  [1908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_enum_item, .child_count = 5, .production_id = 111),
  [1910] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_enum_item, .child_count = 5, .production_id = 111),
  [1912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 8, .production_id = 211),
  [1914] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 8, .production_id = 211),
  [1916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_enum_variant_list, .child_count = 3),
  [1918] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_enum_variant_list, .child_count = 3),
  [1920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_const_item, .child_count = 5, .production_id = 110),
  [1922] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_const_item, .child_count = 5, .production_id = 110),
  [1924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_inner_attribute_item, .child_count = 5),
  [1926] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_inner_attribute_item, .child_count = 5),
  [1928] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_let_declaration, .child_count = 5, .production_id = 116),
  [1930] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_let_declaration, .child_count = 5, .production_id = 116),
  [1932] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_let_declaration, .child_count = 5, .production_id = 125),
  [1934] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_let_declaration, .child_count = 5, .production_id = 125),
  [1936] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_match_block_repeat1, .child_count = 2), SHIFT_REPEAT(1995),
  [1939] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_match_block_repeat1, .child_count = 2), SHIFT_REPEAT(751),
  [1942] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_match_block_repeat1, .child_count = 2), SHIFT_REPEAT(773),
  [1945] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_match_block_repeat1, .child_count = 2), SHIFT_REPEAT(2242),
  [1948] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_match_block_repeat1, .child_count = 2), SHIFT_REPEAT(3154),
  [1951] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_match_block_repeat1, .child_count = 2), SHIFT_REPEAT(824),
  [1954] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_match_block_repeat1, .child_count = 2), SHIFT_REPEAT(808),
  [1957] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_match_block_repeat1, .child_count = 2), SHIFT_REPEAT(833),
  [1960] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_match_block_repeat1, .child_count = 2), SHIFT_REPEAT(2834),
  [1963] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_match_block_repeat1, .child_count = 2), SHIFT_REPEAT(2831),
  [1966] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_match_block_repeat1, .child_count = 2), SHIFT_REPEAT(3253),
  [1969] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_match_block_repeat1, .child_count = 2), SHIFT_REPEAT(3044),
  [1972] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_match_block_repeat1, .child_count = 2), SHIFT_REPEAT(2655),
  [1975] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_match_block_repeat1, .child_count = 2), SHIFT_REPEAT(2118),
  [1978] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_match_block_repeat1, .child_count = 2), SHIFT_REPEAT(807),
  [1981] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_match_block_repeat1, .child_count = 2), SHIFT_REPEAT(813),
  [1984] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_match_block_repeat1, .child_count = 2), SHIFT_REPEAT(2345),
  [1987] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_match_block_repeat1, .child_count = 2), SHIFT_REPEAT(2606),
  [1990] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_match_block_repeat1, .child_count = 2), SHIFT_REPEAT(2290),
  [1993] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_match_block_repeat1, .child_count = 2), SHIFT_REPEAT(2609),
  [1996] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_match_block_repeat1, .child_count = 2), SHIFT_REPEAT(2609),
  [1999] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_match_block_repeat1, .child_count = 2), SHIFT_REPEAT(3484),
  [2002] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_foreign_mod_item, .child_count = 3),
  [2004] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_foreign_mod_item, .child_count = 3),
  [2006] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_foreign_mod_item, .child_count = 3, .production_id = 44),
  [2008] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_foreign_mod_item, .child_count = 3, .production_id = 44),
  [2010] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 8, .production_id = 245),
  [2012] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 8, .production_id = 245),
  [2014] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_static_item, .child_count = 5, .production_id = 110),
  [2016] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_static_item, .child_count = 5, .production_id = 110),
  [2018] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 8, .production_id = 209),
  [2020] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 8, .production_id = 209),
  [2022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_field_declaration_list, .child_count = 3),
  [2024] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_field_declaration_list, .child_count = 3),
  [2026] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_item, .child_count = 8, .production_id = 244),
  [2028] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_item, .child_count = 8, .production_id = 244),
  [2030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_signature_item, .child_count = 8, .production_id = 204),
  [2032] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_signature_item, .child_count = 8, .production_id = 204),
  [2034] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_enum_variant_list, .child_count = 6),
  [2036] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_enum_variant_list, .child_count = 6),
  [2038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_item, .child_count = 7, .production_id = 240),
  [2040] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_item, .child_count = 7, .production_id = 240),
  [2042] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_signature_item, .child_count = 7, .production_id = 195),
  [2044] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_signature_item, .child_count = 7, .production_id = 195),
  [2046] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_item, .child_count = 7, .production_id = 239),
  [2048] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_item, .child_count = 7, .production_id = 239),
  [2050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_signature_item, .child_count = 7, .production_id = 238),
  [2052] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_signature_item, .child_count = 7, .production_id = 238),
  [2054] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_extern_crate_declaration, .child_count = 7, .production_id = 237),
  [2056] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_extern_crate_declaration, .child_count = 7, .production_id = 237),
  [2058] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_trait_item, .child_count = 7, .production_id = 236),
  [2060] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_trait_item, .child_count = 7, .production_id = 236),
  [2062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_trait_item, .child_count = 7, .production_id = 235),
  [2064] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_trait_item, .child_count = 7, .production_id = 235),
  [2066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_trait_item, .child_count = 7, .production_id = 234),
  [2068] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_trait_item, .child_count = 7, .production_id = 234),
  [2070] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_type_item, .child_count = 7, .production_id = 233),
  [2072] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_type_item, .child_count = 7, .production_id = 233),
  [2074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_type_item, .child_count = 7, .production_id = 191),
  [2076] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_type_item, .child_count = 7, .production_id = 191),
  [2078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_struct_item, .child_count = 7, .production_id = 137),
  [2080] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_struct_item, .child_count = 7, .production_id = 137),
  [2082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_item, .child_count = 7, .production_id = 232),
  [2084] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_item, .child_count = 7, .production_id = 232),
  [2086] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_item, .child_count = 7, .production_id = 230),
  [2088] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_item, .child_count = 7, .production_id = 230),
  [2090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_signature_item, .child_count = 7, .production_id = 188),
  [2092] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_signature_item, .child_count = 7, .production_id = 188),
  [2094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_trait_item, .child_count = 7, .production_id = 229),
  [2096] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_trait_item, .child_count = 7, .production_id = 229),
  [2098] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 7, .production_id = 228),
  [2100] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 7, .production_id = 228),
  [2102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 7, .production_id = 227),
  [2104] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 7, .production_id = 227),
  [2106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 7, .production_id = 226),
  [2108] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 7, .production_id = 226),
  [2110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_struct_item, .child_count = 5, .production_id = 29),
  [2112] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_struct_item, .child_count = 5, .production_id = 29),
  [2114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 7, .production_id = 225),
  [2116] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 7, .production_id = 225),
  [2118] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_struct_item, .child_count = 5, .production_id = 72),
  [2120] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_struct_item, .child_count = 5, .production_id = 72),
  [2122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 7, .production_id = 224),
  [2124] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 7, .production_id = 224),
  [2126] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 7, .production_id = 223),
  [2128] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 7, .production_id = 223),
  [2130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_mod_item, .child_count = 3, .production_id = 34),
  [2132] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_mod_item, .child_count = 3, .production_id = 34),
  [2134] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_mod_item, .child_count = 3, .production_id = 6),
  [2136] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_mod_item, .child_count = 3, .production_id = 6),
  [2138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 7, .production_id = 222),
  [2140] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 7, .production_id = 222),
  [2142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_struct_item, .child_count = 5, .production_id = 111),
  [2144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_struct_item, .child_count = 5, .production_id = 111),
  [2146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_let_declaration, .child_count = 3, .production_id = 32),
  [2148] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_let_declaration, .child_count = 3, .production_id = 32),
  [2150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 7, .production_id = 221),
  [2152] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 7, .production_id = 221),
  [2154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_foreign_mod_item, .child_count = 2),
  [2156] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_foreign_mod_item, .child_count = 2),
  [2158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_type_item, .child_count = 7, .production_id = 180),
  [2160] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_type_item, .child_count = 7, .production_id = 180),
  [2162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_field_declaration_list, .child_count = 5),
  [2164] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_field_declaration_list, .child_count = 5),
  [2166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_macro_definition, .child_count = 4, .production_id = 54),
  [2168] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_macro_definition, .child_count = 4, .production_id = 54),
  [2170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 3, .production_id = 31),
  [2172] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 3, .production_id = 31),
  [2174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [2176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_foreign_mod_item, .child_count = 2, .production_id = 8),
  [2178] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_foreign_mod_item, .child_count = 2, .production_id = 8),
  [2180] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_trait_item, .child_count = 5, .production_id = 128),
  [2182] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_trait_item, .child_count = 5, .production_id = 128),
  [2184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_trait_item, .child_count = 5, .production_id = 111),
  [2186] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_trait_item, .child_count = 5, .production_id = 111),
  [2188] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 3, .production_id = 22),
  [2190] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 3, .production_id = 22),
  [2192] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_trait_item, .child_count = 5, .production_id = 129),
  [2194] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_trait_item, .child_count = 5, .production_id = 129),
  [2196] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_macro_definition, .child_count = 4, .production_id = 6),
  [2198] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_macro_definition, .child_count = 4, .production_id = 6),
  [2200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_static_item, .child_count = 7, .production_id = 201),
  [2202] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_static_item, .child_count = 7, .production_id = 201),
  [2204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_type_item, .child_count = 5, .production_id = 130),
  [2206] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_type_item, .child_count = 5, .production_id = 130),
  [2208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_static_item, .child_count = 7, .production_id = 218),
  [2210] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_static_item, .child_count = 7, .production_id = 218),
  [2212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_associated_type, .child_count = 5, .production_id = 131),
  [2214] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_associated_type, .child_count = 5, .production_id = 131),
  [2216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_union_item, .child_count = 5, .production_id = 111),
  [2218] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_union_item, .child_count = 5, .production_id = 111),
  [2220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 5, .production_id = 132),
  [2222] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 5, .production_id = 132),
  [2224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_let_declaration, .child_count = 9, .production_id = 268),
  [2226] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_let_declaration, .child_count = 9, .production_id = 268),
  [2228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_let_declaration, .child_count = 7, .production_id = 217),
  [2230] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_let_declaration, .child_count = 7, .production_id = 217),
  [2232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_let_declaration, .child_count = 7, .production_id = 216),
  [2234] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_let_declaration, .child_count = 7, .production_id = 216),
  [2236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_let_declaration, .child_count = 7, .production_id = 215),
  [2238] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_let_declaration, .child_count = 7, .production_id = 215),
  [2240] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 5, .production_id = 133),
  [2242] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 5, .production_id = 133),
  [2244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_static_item, .child_count = 9, .production_id = 269),
  [2246] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_static_item, .child_count = 9, .production_id = 269),
  [2248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 7, .production_id = 214),
  [2250] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 7, .production_id = 214),
  [2252] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 7, .production_id = 166),
  [2254] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 7, .production_id = 166),
  [2256] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 7, .production_id = 213),
  [2258] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 7, .production_id = 213),
  [2260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 5, .production_id = 63),
  [2262] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 5, .production_id = 63),
  [2264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_macro_definition, .child_count = 5, .production_id = 6),
  [2266] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_macro_definition, .child_count = 5, .production_id = 6),
  [2268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_expression_statement, .child_count = 2),
  [2270] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_expression_statement, .child_count = 2),
  [2272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 5, .production_id = 134),
  [2274] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 5, .production_id = 134),
  [2276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_trait_item, .child_count = 5, .production_id = 135),
  [2278] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_trait_item, .child_count = 5, .production_id = 135),
  [2280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_trait_item, .child_count = 5, .production_id = 136),
  [2282] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_trait_item, .child_count = 5, .production_id = 136),
  [2284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_trait_item, .child_count = 5, .production_id = 137),
  [2286] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_trait_item, .child_count = 5, .production_id = 137),
  [2288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 7, .production_id = 164),
  [2290] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 7, .production_id = 164),
  [2292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 7, .production_id = 212),
  [2294] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 7, .production_id = 212),
  [2296] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 7, .production_id = 211),
  [2298] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 7, .production_id = 211),
  [2300] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 7, .production_id = 210),
  [2302] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 7, .production_id = 210),
  [2304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 7, .production_id = 209),
  [2306] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 7, .production_id = 209),
  [2308] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 7, .production_id = 208),
  [2310] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 7, .production_id = 208),
  [2312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 7, .production_id = 161),
  [2314] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 7, .production_id = 161),
  [2316] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 7, .production_id = 207),
  [2318] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 7, .production_id = 207),
  [2320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 7, .production_id = 159),
  [2322] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 7, .production_id = 159),
  [2324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_item, .child_count = 7, .production_id = 206),
  [2326] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_item, .child_count = 7, .production_id = 206),
  [2328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_macro_definition, .child_count = 5, .production_id = 54),
  [2330] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_macro_definition, .child_count = 5, .production_id = 54),
  [2332] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_signature_item, .child_count = 7, .production_id = 157),
  [2334] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_signature_item, .child_count = 7, .production_id = 157),
  [2336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_enum_item, .child_count = 3, .production_id = 29),
  [2338] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_enum_item, .child_count = 3, .production_id = 29),
  [2340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_signature_item, .child_count = 5, .production_id = 140),
  [2342] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_signature_item, .child_count = 5, .production_id = 140),
  [2344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_item, .child_count = 7, .production_id = 205),
  [2346] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_item, .child_count = 7, .production_id = 205),
  [2348] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_signature_item, .child_count = 7, .production_id = 204),
  [2350] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_signature_item, .child_count = 7, .production_id = 204),
  [2352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_enum_variant_list, .child_count = 5),
  [2354] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_enum_variant_list, .child_count = 5),
  [2356] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 9, .production_id = 254),
  [2358] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 9, .production_id = 254),
  [2360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_const_item, .child_count = 7, .production_id = 201),
  [2362] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_const_item, .child_count = 7, .production_id = 201),
  [2364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [2366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 9, .production_id = 270),
  [2368] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 9, .production_id = 270),
  [2370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_item, .child_count = 5, .production_id = 141),
  [2372] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_item, .child_count = 5, .production_id = 141),
  [2374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 9, .production_id = 256),
  [2376] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 9, .production_id = 256),
  [2378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 9, .production_id = 271),
  [2380] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 9, .production_id = 271),
  [2382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_signature_item, .child_count = 9, .production_id = 260),
  [2384] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_signature_item, .child_count = 9, .production_id = 260),
  [2386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_enum_item, .child_count = 5, .production_id = 135),
  [2388] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_enum_item, .child_count = 5, .production_id = 135),
  [2390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_enum_item, .child_count = 5, .production_id = 137),
  [2392] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_enum_item, .child_count = 5, .production_id = 137),
  [2394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_struct_item, .child_count = 5, .production_id = 88),
  [2396] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_struct_item, .child_count = 5, .production_id = 88),
  [2398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_item, .child_count = 9, .production_id = 272),
  [2400] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_item, .child_count = 9, .production_id = 272),
  [2402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_struct_item, .child_count = 5, .production_id = 135),
  [2404] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_struct_item, .child_count = 5, .production_id = 135),
  [2406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_struct_item, .child_count = 5, .production_id = 142),
  [2408] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_struct_item, .child_count = 5, .production_id = 142),
  [2410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_signature_item, .child_count = 9, .production_id = 273),
  [2412] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_signature_item, .child_count = 9, .production_id = 273),
  [2414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_struct_item, .child_count = 5, .production_id = 137),
  [2416] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_struct_item, .child_count = 5, .production_id = 137),
  [2418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_use_declaration, .child_count = 4, .production_id = 96),
  [2420] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_use_declaration, .child_count = 4, .production_id = 96),
  [2422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_union_item, .child_count = 5, .production_id = 135),
  [2424] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_union_item, .child_count = 5, .production_id = 135),
  [2426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_macro_definition, .child_count = 7, .production_id = 6),
  [2428] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_macro_definition, .child_count = 7, .production_id = 6),
  [2430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_union_item, .child_count = 4, .production_id = 88),
  [2432] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_union_item, .child_count = 4, .production_id = 88),
  [2434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_union_item, .child_count = 5, .production_id = 137),
  [2436] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_union_item, .child_count = 5, .production_id = 137),
  [2438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_trait_item, .child_count = 5, .production_id = 143),
  [2440] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_trait_item, .child_count = 5, .production_id = 143),
  [2442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_macro_definition, .child_count = 7, .production_id = 54),
  [2444] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_macro_definition, .child_count = 7, .production_id = 54),
  [2446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_struct_item, .child_count = 4, .production_id = 88),
  [2448] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_struct_item, .child_count = 4, .production_id = 88),
  [2450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_item, .child_count = 9, .production_id = 274),
  [2452] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_item, .child_count = 9, .production_id = 274),
  [2454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_struct_item, .child_count = 4, .production_id = 95),
  [2456] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_struct_item, .child_count = 4, .production_id = 95),
  [2458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_mod_item, .child_count = 4, .production_id = 94),
  [2460] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_mod_item, .child_count = 4, .production_id = 94),
  [2462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_mod_item, .child_count = 4, .production_id = 93),
  [2464] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_mod_item, .child_count = 4, .production_id = 93),
  [2466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_signature_item, .child_count = 9, .production_id = 266),
  [2468] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_signature_item, .child_count = 9, .production_id = 266),
  [2470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_extern_crate_declaration, .child_count = 5, .production_id = 144),
  [2472] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_extern_crate_declaration, .child_count = 5, .production_id = 144),
  [2474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_enum_item, .child_count = 4, .production_id = 88),
  [2476] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_enum_item, .child_count = 4, .production_id = 88),
  [2478] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_declaration_list_repeat1, .child_count = 2), SHIFT_REPEAT(3201),
  [2481] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_declaration_list_repeat1, .child_count = 2), SHIFT_REPEAT(1308),
  [2484] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_declaration_list_repeat1, .child_count = 2), SHIFT_REPEAT(2762),
  [2487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_declaration_list_repeat1, .child_count = 2),
  [2489] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_declaration_list_repeat1, .child_count = 2), SHIFT_REPEAT(3328),
  [2492] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_declaration_list_repeat1, .child_count = 2), SHIFT_REPEAT(833),
  [2495] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_declaration_list_repeat1, .child_count = 2), SHIFT_REPEAT(3146),
  [2498] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_declaration_list_repeat1, .child_count = 2), SHIFT_REPEAT(3084),
  [2501] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_declaration_list_repeat1, .child_count = 2), SHIFT_REPEAT(2324),
  [2504] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_declaration_list_repeat1, .child_count = 2), SHIFT_REPEAT(2261),
  [2507] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_declaration_list_repeat1, .child_count = 2), SHIFT_REPEAT(2186),
  [2510] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_declaration_list_repeat1, .child_count = 2), SHIFT_REPEAT(3313),
  [2513] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_declaration_list_repeat1, .child_count = 2), SHIFT_REPEAT(3082),
  [2516] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_declaration_list_repeat1, .child_count = 2), SHIFT_REPEAT(839),
  [2519] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_declaration_list_repeat1, .child_count = 2), SHIFT_REPEAT(810),
  [2522] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_declaration_list_repeat1, .child_count = 2), SHIFT_REPEAT(3320),
  [2525] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_declaration_list_repeat1, .child_count = 2), SHIFT_REPEAT(1945),
  [2528] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_declaration_list_repeat1, .child_count = 2), SHIFT_REPEAT(2940),
  [2531] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_declaration_list_repeat1, .child_count = 2), SHIFT_REPEAT(3322),
  [2534] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_declaration_list_repeat1, .child_count = 2), SHIFT_REPEAT(3324),
  [2537] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_declaration_list_repeat1, .child_count = 2), SHIFT_REPEAT(3325),
  [2540] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_declaration_list_repeat1, .child_count = 2), SHIFT_REPEAT(2939),
  [2543] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_declaration_list_repeat1, .child_count = 2), SHIFT_REPEAT(2185),
  [2546] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_declaration_list_repeat1, .child_count = 2), SHIFT_REPEAT(1868),
  [2549] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_declaration_list_repeat1, .child_count = 2), SHIFT_REPEAT(2041),
  [2552] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_declaration_list_repeat1, .child_count = 2), SHIFT_REPEAT(3307),
  [2555] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_declaration_list_repeat1, .child_count = 2), SHIFT_REPEAT(1966),
  [2558] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_declaration_list_repeat1, .child_count = 2), SHIFT_REPEAT(3307),
  [2561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_item, .child_count = 6, .production_id = 196),
  [2563] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_item, .child_count = 6, .production_id = 196),
  [2565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_declaration_list, .child_count = 3),
  [2567] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_declaration_list, .child_count = 3),
  [2569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_struct_item, .child_count = 3, .production_id = 29),
  [2571] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_struct_item, .child_count = 3, .production_id = 29),
  [2573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_macro_definition, .child_count = 6, .production_id = 54),
  [2575] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_macro_definition, .child_count = 6, .production_id = 54),
  [2577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_macro_definition, .child_count = 6, .production_id = 6),
  [2579] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_macro_definition, .child_count = 6, .production_id = 6),
  [2581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_extern_crate_declaration, .child_count = 4, .production_id = 93),
  [2583] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_extern_crate_declaration, .child_count = 4, .production_id = 93),
  [2585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_signature_item, .child_count = 6, .production_id = 195),
  [2587] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_signature_item, .child_count = 6, .production_id = 195),
  [2589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_trait_item, .child_count = 4, .production_id = 88),
  [2591] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_trait_item, .child_count = 4, .production_id = 88),
  [2593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [2595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_trait_item, .child_count = 6, .production_id = 194),
  [2597] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_trait_item, .child_count = 6, .production_id = 194),
  [2599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_trait_item, .child_count = 6, .production_id = 193),
  [2601] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_trait_item, .child_count = 6, .production_id = 193),
  [2603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_trait_item, .child_count = 6, .production_id = 192),
  [2605] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_trait_item, .child_count = 6, .production_id = 192),
  [2607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_union_item, .child_count = 6, .production_id = 183),
  [2609] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_union_item, .child_count = 6, .production_id = 183),
  [2611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 4, .production_id = 87),
  [2613] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 4, .production_id = 87),
  [2615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 4, .production_id = 63),
  [2617] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 4, .production_id = 63),
  [2619] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_type_item, .child_count = 6, .production_id = 191),
  [2621] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_type_item, .child_count = 6, .production_id = 191),
  [2623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_struct_item, .child_count = 6, .production_id = 183),
  [2625] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_struct_item, .child_count = 6, .production_id = 183),
  [2627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_struct_item, .child_count = 6, .production_id = 137),
  [2629] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_struct_item, .child_count = 6, .production_id = 137),
  [2631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_struct_item, .child_count = 6, .production_id = 88),
  [2633] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_struct_item, .child_count = 6, .production_id = 88),
  [2635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_enum_item, .child_count = 6, .production_id = 183),
  [2637] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_enum_item, .child_count = 6, .production_id = 183),
  [2639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_union_item, .child_count = 4, .production_id = 72),
  [2641] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_union_item, .child_count = 4, .production_id = 72),
  [2643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_union_item, .child_count = 4, .production_id = 71),
  [2645] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_union_item, .child_count = 4, .production_id = 71),
  [2647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_associated_type, .child_count = 4, .production_id = 84),
  [2649] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_associated_type, .child_count = 4, .production_id = 84),
  [2651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_associated_type, .child_count = 4, .production_id = 86),
  [2653] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_associated_type, .child_count = 4, .production_id = 86),
  [2655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_empty_statement, .child_count = 1),
  [2657] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_empty_statement, .child_count = 1),
  [2659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_item, .child_count = 9, .production_id = 275),
  [2661] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_item, .child_count = 9, .production_id = 275),
  [2663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_trait_item, .child_count = 4, .production_id = 72),
  [2665] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_trait_item, .child_count = 4, .production_id = 72),
  [2667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_trait_item, .child_count = 4, .production_id = 85),
  [2669] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_trait_item, .child_count = 4, .production_id = 85),
  [2671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_trait_item, .child_count = 4, .production_id = 71),
  [2673] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_trait_item, .child_count = 4, .production_id = 71),
  [2675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_const_item, .child_count = 6, .production_id = 174),
  [2677] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_const_item, .child_count = 6, .production_id = 174),
  [2679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_item, .child_count = 6, .production_id = 190),
  [2681] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_item, .child_count = 6, .production_id = 190),
  [2683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_struct_item, .child_count = 4, .production_id = 72),
  [2685] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_struct_item, .child_count = 4, .production_id = 72),
  [2687] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_signature_item, .child_count = 6, .production_id = 140),
  [2689] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_signature_item, .child_count = 6, .production_id = 140),
  [2691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_item, .child_count = 6, .production_id = 189),
  [2693] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_item, .child_count = 6, .production_id = 189),
  [2695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_struct_item, .child_count = 4, .production_id = 84),
  [2697] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_struct_item, .child_count = 4, .production_id = 84),
  [2699] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_struct_item, .child_count = 4, .production_id = 71),
  [2701] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_struct_item, .child_count = 4, .production_id = 71),
  [2703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_signature_item, .child_count = 6, .production_id = 188),
  [2705] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_signature_item, .child_count = 6, .production_id = 188),
  [2707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_extern_crate_declaration, .child_count = 6, .production_id = 185),
  [2709] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_extern_crate_declaration, .child_count = 6, .production_id = 185),
  [2711] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_let_declaration, .child_count = 10, .production_id = 276),
  [2713] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_let_declaration, .child_count = 10, .production_id = 276),
  [2715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_trait_item, .child_count = 6, .production_id = 184),
  [2717] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_trait_item, .child_count = 6, .production_id = 184),
  [2719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_trait_item, .child_count = 6, .production_id = 183),
  [2721] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_trait_item, .child_count = 6, .production_id = 183),
  [2723] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_trait_item, .child_count = 6, .production_id = 182),
  [2725] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_trait_item, .child_count = 6, .production_id = 182),
  [2727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_attribute_item, .child_count = 4),
  [2729] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_attribute_item, .child_count = 4),
  [2731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 6, .production_id = 181),
  [2733] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 6, .production_id = 181),
  [2735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 6, .production_id = 132),
  [2737] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 6, .production_id = 132),
  [2739] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_struct_item, .child_count = 4, .production_id = 29),
  [2741] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_struct_item, .child_count = 4, .production_id = 29),
  [2743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_field_declaration_list, .child_count = 2),
  [2745] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_field_declaration_list, .child_count = 2),
  [2747] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_enum_variant_list, .child_count = 4),
  [2749] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_enum_variant_list, .child_count = 4),
  [2751] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_signature_item, .child_count = 6, .production_id = 112),
  [2753] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_signature_item, .child_count = 6, .production_id = 112),
  [2755] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_item, .child_count = 6, .production_id = 156),
  [2757] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_item, .child_count = 6, .production_id = 156),
  [2759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_signature_item, .child_count = 6, .production_id = 157),
  [2761] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_signature_item, .child_count = 6, .production_id = 157),
  [2763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_item, .child_count = 6, .production_id = 158),
  [2765] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_item, .child_count = 6, .production_id = 158),
  [2767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 6, .production_id = 159),
  [2769] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 6, .production_id = 159),
  [2771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_type_item, .child_count = 6, .production_id = 180),
  [2773] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_type_item, .child_count = 6, .production_id = 180),
  [2775] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_type_item, .child_count = 6, .production_id = 130),
  [2777] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_type_item, .child_count = 6, .production_id = 130),
  [2779] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_enum_variant_list, .child_count = 2),
  [2781] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_enum_variant_list, .child_count = 2),
  [2783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_trait_item, .child_count = 6, .production_id = 179),
  [2785] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_trait_item, .child_count = 6, .production_id = 179),
  [2787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_struct_item, .child_count = 6, .production_id = 72),
  [2789] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_struct_item, .child_count = 6, .production_id = 72),
  [2791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 6, .production_id = 160),
  [2793] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 6, .production_id = 160),
  [2795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_field_declaration_list, .child_count = 4),
  [2797] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_field_declaration_list, .child_count = 4),
  [2799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 6, .production_id = 161),
  [2801] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 6, .production_id = 161),
  [2803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 6, .production_id = 162),
  [2805] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 6, .production_id = 162),
  [2807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 1),
  [2809] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = aux_sym_source_file_repeat1, .child_count = 1),
  [2811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 6, .production_id = 120),
  [2813] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 6, .production_id = 120),
  [2815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 6, .production_id = 163),
  [2817] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 6, .production_id = 163),
  [2819] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_let_declaration, .child_count = 4, .production_id = 82),
  [2821] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_let_declaration, .child_count = 4, .production_id = 82),
  [2823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 4, .production_id = 81),
  [2825] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 4, .production_id = 81),
  [2827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 4, .production_id = 22),
  [2829] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 4, .production_id = 22),
  [2831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_static_item, .child_count = 6, .production_id = 174),
  [2833] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_static_item, .child_count = 6, .production_id = 174),
  [2835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 4, .production_id = 80),
  [2837] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 4, .production_id = 80),
  [2839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 4, .production_id = 79),
  [2841] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 4, .production_id = 79),
  [2843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 6, .production_id = 164),
  [2845] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 6, .production_id = 164),
  [2847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_enum_item, .child_count = 4, .production_id = 71),
  [2849] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_enum_item, .child_count = 4, .production_id = 71),
  [2851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_enum_item, .child_count = 4, .production_id = 72),
  [2853] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_enum_item, .child_count = 4, .production_id = 72),
  [2855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 6, .production_id = 165),
  [2857] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 6, .production_id = 165),
  [2859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 6, .production_id = 166),
  [2861] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 6, .production_id = 166),
  [2863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_signature_item, .child_count = 4, .production_id = 73),
  [2865] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_signature_item, .child_count = 4, .production_id = 73),
  [2867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 6, .production_id = 167),
  [2869] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 6, .production_id = 167),
  [2871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_impl_item, .child_count = 6, .production_id = 168),
  [2873] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_impl_item, .child_count = 6, .production_id = 168),
  [2875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_item, .child_count = 4, .production_id = 74),
  [2877] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_item, .child_count = 4, .production_id = 74),
  [2879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_let_declaration, .child_count = 6, .production_id = 169),
  [2881] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_let_declaration, .child_count = 6, .production_id = 169),
  [2883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_let_declaration, .child_count = 6, .production_id = 170),
  [2885] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_let_declaration, .child_count = 6, .production_id = 170),
  [2887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_let_declaration, .child_count = 6, .production_id = 171),
  [2889] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_let_declaration, .child_count = 6, .production_id = 171),
  [2891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_static_item, .child_count = 10, .production_id = 277),
  [2893] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_static_item, .child_count = 10, .production_id = 277),
  [2895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_signature_item, .child_count = 10, .production_id = 273),
  [2897] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_signature_item, .child_count = 10, .production_id = 273),
  [2899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_item, .child_count = 10, .production_id = 278),
  [2901] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_item, .child_count = 10, .production_id = 278),
  [2903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1903),
  [2905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [2907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2117),
  [2909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [2911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1993),
  [2913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [2915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3138),
  [2917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2595),
  [2919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1928),
  [2921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2512),
  [2923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2512),
  [2925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2830),
  [2927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3574),
  [2929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2738),
  [2931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2753),
  [2933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2089),
  [2935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2072),
  [2937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1896),
  [2939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2472),
  [2941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3396),
  [2943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3526),
  [2945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3425),
  [2947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1527),
  [2949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1529),
  [2951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1991),
  [2953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3536),
  [2955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2246),
  [2957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2363),
  [2959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2412),
  [2961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2380),
  [2963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2405),
  [2965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2404),
  [2967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2476),
  [2969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2381),
  [2971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2799),
  [2973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3521),
  [2975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2095),
  [2977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3552),
  [2979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2826),
  [2981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3527),
  [2983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2119),
  [2985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3438),
  [2987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2840),
  [2989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3496),
  [2991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2073),
  [2993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2070),
  [2995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2725),
  [2997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3053),
  [2999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2238),
  [3001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2083),
  [3003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2085),
  [3005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2895),
  [3007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2097),
  [3009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2739),
  [3011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [3013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(811),
  [3015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2442),
  [3017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2752),
  [3019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2844),
  [3021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2841),
  [3023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2074),
  [3025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(802),
  [3027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(795),
  [3029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2382),
  [3031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(821),
  [3033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(799),
  [3035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(992),
  [3037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(929),
  [3039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1007),
  [3041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [3043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [3045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [3047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3149),
  [3049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [3051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1076),
  [3053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1230),
  [3055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [3057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3205),
  [3059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2102),
  [3061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3126),
  [3063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1063),
  [3065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2618),
  [3067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1476),
  [3069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(863),
  [3071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3504),
  [3073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1080),
  [3075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(891),
  [3077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2937),
  [3079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(872),
  [3081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1484),
  [3083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [3085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [3087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [3089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3054),
  [3091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [3093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1585),
  [3095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1677),
  [3097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [3099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3280),
  [3101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2079),
  [3103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3058),
  [3105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1043),
  [3107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2651),
  [3109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1497),
  [3111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(970),
  [3113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3519),
  [3115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1591),
  [3117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3179),
  [3119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1813),
  [3121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2050),
  [3123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1880),
  [3125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [3127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1982),
  [3129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3122),
  [3131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1244),
  [3133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1401),
  [3135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1789),
  [3137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2055),
  [3139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1878),
  [3141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(895),
  [3143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(969),
  [3145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1713),
  [3147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2030),
  [3149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1876),
  [3151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1961),
  [3153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [3155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2065),
  [3157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1875),
  [3159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1970),
  [3161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3108),
  [3163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(907),
  [3165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(864),
  [3167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2061),
  [3169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1879),
  [3171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2961),
  [3173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2032),
  [3175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1873),
  [3177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2028),
  [3179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1877),
  [3181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2031),
  [3183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1874),
  [3185] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = aux_sym_enum_variant_list_repeat1, .child_count = 2),
  [3187] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = aux_sym_enum_variant_list_repeat1, .child_count = 1),
  [3189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_enum_variant_list_repeat1, .child_count = 1),
  [3191] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_closure_parameters, .child_count = 4),
  [3193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_closure_parameters, .child_count = 4),
  [3195] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = aux_sym_tuple_expression_repeat1, .child_count = 2),
  [3197] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_lifetime, .child_count = 2),
  [3199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_lifetime, .child_count = 2),
  [3201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2044),
  [3203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_range_pattern, .child_count = 2, .production_id = 1),
  [3205] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_range_pattern, .child_count = 2, .production_id = 1),
  [3207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2042),
  [3209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2045),
  [3211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2045),
  [3213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2058),
  [3215] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_range_pattern, .child_count = 2),
  [3217] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_range_pattern, .child_count = 2),
  [3219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2054),
  [3221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2059),
  [3223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2059),
  [3225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym__type, .child_count = 1, .production_id = 5),
  [3227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [3229] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym__type, .child_count = 1, .production_id = 5),
  [3231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2644),
  [3233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2578),
  [3235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [3237] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_abstract_type, .child_count = 4, .production_id = 104),
  [3239] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_abstract_type, .child_count = 4, .production_id = 104),
  [3241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2561),
  [3243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_abstract_type, .child_count = 2, .production_id = 24),
  [3245] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_abstract_type, .child_count = 2, .production_id = 24),
  [3247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_dynamic_type, .child_count = 2, .production_id = 24),
  [3249] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_dynamic_type, .child_count = 2, .production_id = 24),
  [3251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_scoped_type_identifier, .child_count = 3, .production_id = 41),
  [3253] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_scoped_type_identifier, .child_count = 3, .production_id = 41),
  [3255] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_scoped_identifier, .child_count = 3, .production_id = 40),
  [3257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_scoped_identifier, .child_count = 3, .production_id = 40),
  [3259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_abstract_type, .child_count = 2, .production_id = 25),
  [3261] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_abstract_type, .child_count = 2, .production_id = 25),
  [3263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_scoped_type_identifier, .child_count = 3, .production_id = 46),
  [3265] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_scoped_type_identifier, .child_count = 3, .production_id = 46),
  [3267] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_scoped_identifier, .child_count = 3, .production_id = 45),
  [3269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_scoped_identifier, .child_count = 3, .production_id = 45),
  [3271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_abstract_type, .child_count = 4, .production_id = 105),
  [3273] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_abstract_type, .child_count = 4, .production_id = 105),
  [3275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_scoped_type_identifier, .child_count = 3, .production_id = 17),
  [3277] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_scoped_type_identifier, .child_count = 3, .production_id = 17),
  [3279] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_scoped_identifier, .child_count = 3, .production_id = 16),
  [3281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_scoped_identifier, .child_count = 3, .production_id = 16),
  [3283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_scoped_type_identifier, .child_count = 2, .production_id = 7),
  [3285] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_scoped_type_identifier, .child_count = 2, .production_id = 7),
  [3287] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_scoped_identifier, .child_count = 2, .production_id = 6),
  [3289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_scoped_identifier, .child_count = 2, .production_id = 6),
  [3291] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym__type, .child_count = 1),
  [3293] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym__type, .child_count = 1),
  [3295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_dynamic_type, .child_count = 2, .production_id = 25),
  [3297] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_dynamic_type, .child_count = 2, .production_id = 25),
  [3299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2056),
  [3301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2547),
  [3303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym__expression_except_range, .child_count = 1, .production_id = 1),
  [3305] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym__expression_except_range, .child_count = 1, .production_id = 1),
  [3307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2524),
  [3309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3129),
  [3311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_function_modifiers_repeat1, .child_count = 1),
  [3313] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = aux_sym_match_arm_repeat1, .child_count = 2),
  [3315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_match_arm_repeat1, .child_count = 2),
  [3317] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_match_arm_repeat1, .child_count = 2), SHIFT_REPEAT(3044),
  [3320] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_enum_variant_list_repeat1, .child_count = 2), SHIFT_REPEAT(3526),
  [3323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_parameters, .child_count = 5),
  [3325] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_parameters, .child_count = 5),
  [3327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1507),
  [3329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [3331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3470),
  [3333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3284),
  [3335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2147),
  [3337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3110),
  [3339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2920),
  [3341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3520),
  [3343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3520),
  [3345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_type_arguments, .child_count = 4),
  [3347] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_type_arguments, .child_count = 4),
  [3349] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_parameters, .child_count = 4),
  [3351] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_parameters, .child_count = 4),
  [3353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3431),
  [3355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_scoped_type_identifier_in_expression_position, .child_count = 3, .production_id = 41),
  [3357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_scoped_type_identifier_in_expression_position, .child_count = 3, .production_id = 46),
  [3359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3254),
  [3361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2348),
  [3363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_field_expression, .child_count = 3, .production_id = 49),
  [3365] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_field_expression, .child_count = 3, .production_id = 49),
  [3367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_type_arguments, .child_count = 5),
  [3369] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_type_arguments, .child_count = 5),
  [3371] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_type, .child_count = 2, .production_id = 23),
  [3373] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_type, .child_count = 2, .production_id = 23),
  [3375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [3377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_field_expression, .child_count = 3, .production_id = 50),
  [3379] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_field_expression, .child_count = 3, .production_id = 50),
  [3381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym__expression, .child_count = 1),
  [3383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [3385] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym__expression, .child_count = 1),
  [3387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1008),
  [3389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [3391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3351),
  [3393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3264),
  [3395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2158),
  [3397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2975),
  [3399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3516),
  [3401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3516),
  [3403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1506),
  [3405] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_type_arguments, .child_count = 6),
  [3407] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_type_arguments, .child_count = 6),
  [3409] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_parameters, .child_count = 6),
  [3411] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_parameters, .child_count = 6),
  [3413] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_type, .child_count = 4, .production_id = 107),
  [3415] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_type, .child_count = 4, .production_id = 107),
  [3417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [3419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_parameters, .child_count = 3),
  [3421] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_parameters, .child_count = 3),
  [3423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1009),
  [3425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3247),
  [3427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1902),
  [3429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [3431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3410),
  [3433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3052),
  [3435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2166),
  [3437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2919),
  [3439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3458),
  [3441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3458),
  [3443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_type_arguments, .child_count = 3),
  [3445] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_type_arguments, .child_count = 3),
  [3447] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_type, .child_count = 2, .production_id = 26),
  [3449] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_type, .child_count = 2, .production_id = 26),
  [3451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [3453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2452),
  [3455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_where_clause, .child_count = 4),
  [3457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3297),
  [3459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2880),
  [3461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [3463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3561),
  [3465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3244),
  [3467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1898),
  [3469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3182),
  [3471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_type, .child_count = 3, .production_id = 67),
  [3473] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_type, .child_count = 3, .production_id = 67),
  [3475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [3477] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_type, .child_count = 3, .production_id = 66),
  [3479] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_type, .child_count = 3, .production_id = 66),
  [3481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [3483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_generic_type, .child_count = 2, .production_id = 21),
  [3485] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_generic_type, .child_count = 2, .production_id = 21),
  [3487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_type, .child_count = 3, .production_id = 64),
  [3489] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_type, .child_count = 3, .production_id = 64),
  [3491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [3493] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_where_clause, .child_count = 3),
  [3495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_generic_type, .child_count = 2, .production_id = 20),
  [3497] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_generic_type, .child_count = 2, .production_id = 20),
  [3499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3081),
  [3501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_parameters, .child_count = 2),
  [3503] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_parameters, .child_count = 2),
  [3505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_scoped_type_identifier_in_expression_position, .child_count = 3, .production_id = 17),
  [3507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_type, .child_count = 2, .production_id = 27),
  [3509] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_type, .child_count = 2, .production_id = 27),
  [3511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [3513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3213),
  [3515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_scoped_type_identifier_in_expression_position, .child_count = 2, .production_id = 7),
  [3517] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_continue_expression, .child_count = 1),
  [3519] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_continue_expression, .child_count = 1),
  [3521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3482),
  [3523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_generic_type, .child_count = 2, .production_id = 19),
  [3525] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_generic_type, .child_count = 2, .production_id = 19),
  [3527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2508),
  [3529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2509),
  [3531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3259),
  [3533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2506),
  [3535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2506),
  [3537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_tuple_type, .child_count = 5),
  [3539] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_tuple_type, .child_count = 5),
  [3541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_closure_expression, .child_count = 5, .production_id = 127),
  [3543] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_closure_expression, .child_count = 5, .production_id = 127),
  [3545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_type, .child_count = 6, .production_id = 200),
  [3547] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_type, .child_count = 6, .production_id = 200),
  [3549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_struct_expression, .child_count = 2, .production_id = 10),
  [3551] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_struct_expression, .child_count = 2, .production_id = 10),
  [3553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2563),
  [3555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_field_initializer_list, .child_count = 2),
  [3557] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_field_initializer_list, .child_count = 2),
  [3559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_higher_ranked_trait_bound, .child_count = 3, .production_id = 79),
  [3561] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_higher_ranked_trait_bound, .child_count = 3, .production_id = 79),
  [3563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_generic_function, .child_count = 3, .production_id = 42),
  [3565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_generic_type_with_turbofish, .child_count = 3, .production_id = 43),
  [3567] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_generic_function, .child_count = 3, .production_id = 42),
  [3569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_closure_expression, .child_count = 3, .production_id = 35),
  [3571] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_closure_expression, .child_count = 3, .production_id = 35),
  [3573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_array_expression, .child_count = 5),
  [3575] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_array_expression, .child_count = 5),
  [3577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_array_expression, .child_count = 5, .production_id = 99),
  [3579] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_array_expression, .child_count = 5, .production_id = 99),
  [3581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2529),
  [3583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2530),
  [3585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2526),
  [3587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2526),
  [3589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_tuple_expression, .child_count = 5),
  [3591] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_tuple_expression, .child_count = 5),
  [3593] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = aux_sym_declaration_list_repeat1, .child_count = 1),
  [3595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_declaration_list_repeat1, .child_count = 1),
  [3597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_struct_expression, .child_count = 2, .production_id = 11),
  [3599] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_struct_expression, .child_count = 2, .production_id = 11),
  [3601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_try_expression, .child_count = 2),
  [3603] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_try_expression, .child_count = 2),
  [3605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_closure_expression, .child_count = 2, .production_id = 13),
  [3607] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_closure_expression, .child_count = 2, .production_id = 13),
  [3609] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_match_arm, .child_count = 5, .production_id = 116),
  [3611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_match_arm, .child_count = 5, .production_id = 116),
  [3613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_last_match_arm, .child_count = 5, .production_id = 116),
  [3615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_field_initializer_list, .child_count = 4),
  [3617] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_field_initializer_list, .child_count = 4),
  [3619] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_arguments, .child_count = 2),
  [3621] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_arguments, .child_count = 2),
  [3623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_call_expression, .child_count = 2, .production_id = 12),
  [3625] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_call_expression, .child_count = 2, .production_id = 12),
  [3627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_parenthesized_expression, .child_count = 3),
  [3629] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_parenthesized_expression, .child_count = 3),
  [3631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_closure_expression, .child_count = 4, .production_id = 97),
  [3633] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_closure_expression, .child_count = 4, .production_id = 97),
  [3635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_index_expression, .child_count = 4),
  [3637] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_index_expression, .child_count = 4),
  [3639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_arguments, .child_count = 3),
  [3641] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_arguments, .child_count = 3),
  [3643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_array_expression, .child_count = 3),
  [3645] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_array_expression, .child_count = 3),
  [3647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_arguments, .child_count = 4),
  [3649] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_arguments, .child_count = 4),
  [3651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_continue_expression, .child_count = 2),
  [3653] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_continue_expression, .child_count = 2),
  [3655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_arguments, .child_count = 6),
  [3657] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_arguments, .child_count = 6),
  [3659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_binary_expression, .child_count = 3, .production_id = 47),
  [3661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [3663] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_binary_expression, .child_count = 3, .production_id = 47),
  [3665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1146),
  [3667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2894),
  [3669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [3671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_await_expression, .child_count = 3),
  [3673] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_await_expression, .child_count = 3),
  [3675] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_type_parameters, .child_count = 4, .production_id = 76),
  [3677] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_type_parameters, .child_count = 4, .production_id = 76),
  [3679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_field_initializer_list, .child_count = 3),
  [3681] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_field_initializer_list, .child_count = 3),
  [3683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_tuple_expression, .child_count = 6),
  [3685] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_tuple_expression, .child_count = 6),
  [3687] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_array_expression, .child_count = 6, .production_id = 146),
  [3689] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_array_expression, .child_count = 6, .production_id = 146),
  [3691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_array_expression, .child_count = 6),
  [3693] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_array_expression, .child_count = 6),
  [3695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_array_type, .child_count = 5, .production_id = 150),
  [3697] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_array_type, .child_count = 5, .production_id = 150),
  [3699] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_type_cast_expression, .child_count = 3, .production_id = 51),
  [3701] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_type_cast_expression, .child_count = 3, .production_id = 51),
  [3703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_tuple_type, .child_count = 3),
  [3705] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_tuple_type, .child_count = 3),
  [3707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_array_type, .child_count = 3, .production_id = 62),
  [3709] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_array_type, .child_count = 3, .production_id = 62),
  [3711] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_pointer_type, .child_count = 3, .production_id = 63),
  [3713] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_pointer_type, .child_count = 3, .production_id = 63),
  [3715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_reference_type, .child_count = 3, .production_id = 63),
  [3717] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_reference_type, .child_count = 3, .production_id = 63),
  [3719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_never_type, .child_count = 1),
  [3721] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_never_type, .child_count = 1),
  [3723] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_generic_type_with_turbofish, .child_count = 3, .production_id = 52),
  [3725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_unit_type, .child_count = 2),
  [3727] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_unit_type, .child_count = 2),
  [3729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_bounded_type, .child_count = 3),
  [3731] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_bounded_type, .child_count = 3),
  [3733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_reference_expression, .child_count = 3, .production_id = 18),
  [3735] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_reference_expression, .child_count = 3, .production_id = 18),
  [3737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_closure_expression, .child_count = 4, .production_id = 83),
  [3739] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_closure_expression, .child_count = 4, .production_id = 83),
  [3741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_tuple_expression, .child_count = 4),
  [3743] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_tuple_expression, .child_count = 4),
  [3745] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_array_expression, .child_count = 4),
  [3747] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_array_expression, .child_count = 4),
  [3749] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_match_arm, .child_count = 4, .production_id = 172),
  [3751] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_match_arm, .child_count = 4, .production_id = 172),
  [3753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_last_match_arm, .child_count = 4, .production_id = 172),
  [3755] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_type_parameters, .child_count = 5, .production_id = 76),
  [3757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_type_parameters, .child_count = 5, .production_id = 76),
  [3759] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_type_parameters, .child_count = 5),
  [3761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_type_parameters, .child_count = 5),
  [3763] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_type_parameters, .child_count = 5, .production_id = 119),
  [3765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_type_parameters, .child_count = 5, .production_id = 119),
  [3767] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_type_parameters, .child_count = 3),
  [3769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_type_parameters, .child_count = 3),
  [3771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_type_parameters, .child_count = 3, .production_id = 76),
  [3773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_type_parameters, .child_count = 3, .production_id = 76),
  [3775] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_type_parameters, .child_count = 6),
  [3777] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_type_parameters, .child_count = 6),
  [3779] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_type_parameters, .child_count = 6, .production_id = 119),
  [3781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_type_parameters, .child_count = 6, .production_id = 119),
  [3783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_closure_expression, .child_count = 6, .production_id = 175),
  [3785] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_closure_expression, .child_count = 6, .production_id = 175),
  [3787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_type, .child_count = 5, .production_id = 152),
  [3789] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_type, .child_count = 5, .production_id = 152),
  [3791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_reference_type, .child_count = 2, .production_id = 22),
  [3793] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_reference_type, .child_count = 2, .production_id = 22),
  [3795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_field_initializer_list, .child_count = 5),
  [3797] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_field_initializer_list, .child_count = 5),
  [3799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_tuple_type, .child_count = 4),
  [3801] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_tuple_type, .child_count = 4),
  [3803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_reference_type, .child_count = 4, .production_id = 102),
  [3805] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_reference_type, .child_count = 4, .production_id = 102),
  [3807] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_type_parameters, .child_count = 4, .production_id = 119),
  [3809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_type_parameters, .child_count = 4, .production_id = 119),
  [3811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_type, .child_count = 5, .production_id = 153),
  [3813] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_type, .child_count = 5, .production_id = 153),
  [3815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_type, .child_count = 4, .production_id = 103),
  [3817] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_type, .child_count = 4, .production_id = 103),
  [3819] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_type, .child_count = 5, .production_id = 154),
  [3821] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_type, .child_count = 5, .production_id = 154),
  [3823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_type, .child_count = 4, .production_id = 106),
  [3825] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_type, .child_count = 4, .production_id = 106),
  [3827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_removed_trait_bound, .child_count = 2),
  [3829] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_removed_trait_bound, .child_count = 2),
  [3831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_arguments, .child_count = 5),
  [3833] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_arguments, .child_count = 5),
  [3835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_type, .child_count = 4, .production_id = 108),
  [3837] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_type, .child_count = 4, .production_id = 108),
  [3839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_reference_expression, .child_count = 2, .production_id = 4),
  [3841] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_reference_expression, .child_count = 2, .production_id = 4),
  [3843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_unary_expression, .child_count = 2),
  [3845] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_unary_expression, .child_count = 2),
  [3847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_unit_expression, .child_count = 2),
  [3849] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_unit_expression, .child_count = 2),
  [3851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_array_expression, .child_count = 2),
  [3853] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_array_expression, .child_count = 2),
  [3855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_tuple_expression, .child_count = 7),
  [3857] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_tuple_expression, .child_count = 7),
  [3859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_array_expression, .child_count = 7),
  [3861] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_array_expression, .child_count = 7),
  [3863] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_type_parameters, .child_count = 4),
  [3865] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_type_parameters, .child_count = 4),
  [3867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2624),
  [3869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3296),
  [3871] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = aux_sym_match_arm_repeat1, .child_count = 1),
  [3873] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_match_arm_repeat1, .child_count = 1),
  [3875] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = aux_sym_match_block_repeat1, .child_count = 1),
  [3877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_match_block_repeat1, .child_count = 1),
  [3879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(268),
  [3881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(269),
  [3883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(271),
  [3885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(272),
  [3887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(273),
  [3889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [3891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(276),
  [3893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [3895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(279),
  [3897] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_range_expression, .child_count = 3),
  [3899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [3901] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_range_expression, .child_count = 3),
  [3903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1010),
  [3905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3281),
  [3907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [3909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(278),
  [3911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(41),
  [3913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [3915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_return_expression, .child_count = 2),
  [3917] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_return_expression, .child_count = 2),
  [3919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2546),
  [3921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_assignment_expression, .child_count = 3, .production_id = 48),
  [3923] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_assignment_expression, .child_count = 3, .production_id = 48),
  [3925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [3927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2579),
  [3929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2554),
  [3931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [3933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_break_expression, .child_count = 3),
  [3935] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_break_expression, .child_count = 3),
  [3937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_yield_expression, .child_count = 2),
  [3939] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_yield_expression, .child_count = 2),
  [3941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_compound_assignment_expr, .child_count = 3, .production_id = 47),
  [3943] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_compound_assignment_expr, .child_count = 3, .production_id = 47),
  [3945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1899),
  [3947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1504),
  [3949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3093),
  [3951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2645),
  [3953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2034),
  [3955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2639),
  [3957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2551),
  [3959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2340),
  [3961] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_visibility_modifier, .child_count = 4),
  [3963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_visibility_modifier, .child_count = 4),
  [3965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2654),
  [3967] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_visibility_modifier, .child_count = 5),
  [3969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_visibility_modifier, .child_count = 5),
  [3971] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_visibility_modifier, .child_count = 1),
  [3973] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = sym_visibility_modifier, .child_count = 1), SHIFT(2543),
  [3976] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_visibility_modifier, .child_count = 1),
  [3978] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_visibility_modifier, .child_count = 5, .production_id = 126),
  [3980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_visibility_modifier, .child_count = 5, .production_id = 126),
  [3982] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = sym_visibility_modifier, .child_count = 1), SHIFT(3096),
  [3985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3162),
  [3987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2371),
  [3989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2638),
  [3991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2581),
  [3993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3051),
  [3995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [3997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(42),
  [3999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [4001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [4003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [4005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [4007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(304),
  [4009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(303),
  [4011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(301),
  [4013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(298),
  [4015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(296),
  [4017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [4019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [4021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(292),
  [4023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [4025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(285),
  [4027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [4029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(281),
  [4031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(60),
  [4033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [4035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3125),
  [4037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [4039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [4041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [4043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [4045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3433),
  [4047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [4049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(66),
  [4051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [4053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [4055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3523),
  [4057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(981),
  [4059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [4061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [4063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1180),
  [4065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [4067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [4069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_arguments_repeat1, .child_count = 2),
  [4071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [4073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3265),
  [4075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2424),
  [4077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3094),
  [4079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3282),
  [4081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [4083] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_arguments_repeat1, .child_count = 3),
  [4085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [4087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1773),
  [4089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [4091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2402),
  [4093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3292),
  [4095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [4097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3076),
  [4099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2428),
  [4101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3171),
  [4103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [4105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3048),
  [4107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [4109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [4111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(364),
  [4113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(250),
  [4115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1745),
  [4117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(251),
  [4119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(252),
  [4121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(257),
  [4123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [4125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(261),
  [4127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [4129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(266),
  [4131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3013),
  [4133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [4135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [4137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_enum_variant, .child_count = 5, .production_id = 243),
  [4139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [4141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_base_field_initializer, .child_count = 2),
  [4143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_last_match_arm, .child_count = 4, .production_id = 116),
  [4145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [4147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(52),
  [4149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [4151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [4153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2568),
  [4155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_enum_variant, .child_count = 4, .production_id = 203),
  [4157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_enum_variant, .child_count = 4, .production_id = 202),
  [4159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [4161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [4163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1445),
  [4165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2504),
  [4167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1219),
  [4169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2505),
  [4171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_field_initializer, .child_count = 4, .production_id = 187),
  [4173] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_field_initializer, .child_count = 4, .production_id = 186),
  [4175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_last_match_arm, .child_count = 3, .production_id = 172),
  [4177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1305),
  [4179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [4181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2604),
  [4183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1641),
  [4185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [4187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(336),
  [4189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(333),
  [4191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(328),
  [4193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(325),
  [4195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(323),
  [4197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [4199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [4201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(317),
  [4203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [4205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(310),
  [4207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1393),
  [4209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1204),
  [4211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2513),
  [4213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(62),
  [4215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [4217] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_enum_variant, .child_count = 3, .production_id = 155),
  [4219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [4221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [4223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(311),
  [4225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(55),
  [4227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [4229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [4231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2517),
  [4233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [4235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1443),
  [4237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2033),
  [4239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [4241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [4243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym__condition, .child_count = 1),
  [4245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [4247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1574),
  [4249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [4251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1629),
  [4253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [4255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_field_initializer, .child_count = 3, .production_id = 139),
  [4257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_field_initializer, .child_count = 3, .production_id = 138),
  [4259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2417),
  [4261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1772),
  [4263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2991),
  [4265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2836),
  [4267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2419),
  [4269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3474),
  [4271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2535),
  [4273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2416),
  [4275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2416),
  [4277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [4279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [4281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2664),
  [4283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [4285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym__let_chain, .child_count = 3),
  [4287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [4289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2716),
  [4291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [4293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(265),
  [4295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_let_condition, .child_count = 4, .production_id = 116),
  [4297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [4299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1470),
  [4301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1376),
  [4303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [4305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [4307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2804),
  [4309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1088),
  [4311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1463),
  [4313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(50),
  [4315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [4317] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_attribute, .child_count = 3, .production_id = 109),
  [4319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_attribute, .child_count = 3, .production_id = 18),
  [4321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [4323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3012),
  [4325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [4327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [4329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1981),
  [4331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [4333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1341),
  [4335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1113),
  [4337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1430),
  [4339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [4341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1249),
  [4343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [4345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1766),
  [4347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1818),
  [4349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1747),
  [4351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1134),
  [4353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [4355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1645),
  [4357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [4359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [4361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [4363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2487),
  [4365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3379),
  [4367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3160),
  [4369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2878),
  [4371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3491),
  [4373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3491),
  [4375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2549),
  [4377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2507),
  [4379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2488),
  [4381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2489),
  [4383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2490),
  [4385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2705),
  [4387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2616),
  [4389] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_for_lifetimes, .child_count = 5),
  [4391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_for_lifetimes, .child_count = 5),
  [4393] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_for_lifetimes, .child_count = 4),
  [4395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_for_lifetimes, .child_count = 4),
  [4397] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_for_lifetimes, .child_count = 6),
  [4399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_for_lifetimes, .child_count = 6),
  [4401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2250),
  [4403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2256),
  [4405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2222),
  [4407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2222),
  [4409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3194),
  [4411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3192),
  [4413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3074),
  [4415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3197),
  [4417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3197),
  [4419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3223),
  [4421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3225),
  [4423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3199),
  [4425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3199),
  [4427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [4429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2641),
  [4431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2673),
  [4433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [4435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2636),
  [4437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym__pattern, .child_count = 1),
  [4439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [4441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2187),
  [4443] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym__pattern, .child_count = 1),
  [4445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [4447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1006),
  [4449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1498),
  [4451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2582),
  [4453] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym__pattern, .child_count = 1, .production_id = 1),
  [4455] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym__pattern, .child_count = 1, .production_id = 1),
  [4457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2648),
  [4459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1005),
  [4461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1500),
  [4463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3235),
  [4465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2324),
  [4467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2244),
  [4469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3306),
  [4471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3291),
  [4473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3304),
  [4475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2859),
  [4477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3302),
  [4479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3360),
  [4481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3451),
  [4483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3319),
  [4485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2249),
  [4487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1869),
  [4489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2057),
  [4491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2272),
  [4493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3335),
  [4495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3072),
  [4497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3336),
  [4499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2729),
  [4501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3337),
  [4503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3332),
  [4505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3589),
  [4507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3338),
  [4509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2240),
  [4511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1871),
  [4513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2064),
  [4515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3222),
  [4517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [4519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3096),
  [4521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2587),
  [4523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [4525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3390),
  [4527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [4529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2572),
  [4531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [4533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [4535] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = sym__type, .child_count = 1, .production_id = 5), REDUCE(.symbol = sym__pattern, .child_count = 1),
  [4538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2557),
  [4540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2533),
  [4542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3029),
  [4544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3255),
  [4546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [4548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [4550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2559),
  [4552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(991),
  [4554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [4556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [4558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3066),
  [4560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3172),
  [4562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [4564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(149),
  [4566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(843),
  [4568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [4570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1332),
  [4572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2013),
  [4574] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = sym_scoped_identifier, .child_count = 3, .production_id = 16), REDUCE(.symbol = sym_scoped_type_identifier, .child_count = 3, .production_id = 17),
  [4577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [4579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2207),
  [4581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2594),
  [4583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [4585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1089),
  [4587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1503),
  [4589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2567),
  [4591] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = sym_scoped_identifier, .child_count = 3, .production_id = 40), REDUCE(.symbol = sym_scoped_type_identifier, .child_count = 3, .production_id = 41),
  [4594] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = sym_scoped_identifier, .child_count = 2, .production_id = 6), REDUCE(.symbol = sym_scoped_type_identifier, .child_count = 2, .production_id = 7),
  [4597] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = sym_scoped_identifier, .child_count = 3, .production_id = 45), REDUCE(.symbol = sym_scoped_type_identifier, .child_count = 3, .production_id = 46),
  [4600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_negative_literal, .child_count = 2),
  [4602] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_negative_literal, .child_count = 2),
  [4604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym__literal_pattern, .child_count = 1),
  [4606] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym__literal_pattern, .child_count = 1),
  [4608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2393),
  [4610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2403),
  [4612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3369),
  [4614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3118),
  [4616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1334),
  [4618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2401),
  [4620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1210),
  [4622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1340),
  [4624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1457),
  [4626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2462),
  [4628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2448),
  [4630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2449),
  [4632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2454),
  [4634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1310),
  [4636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1532),
  [4638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [4640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2463),
  [4642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1307),
  [4644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [4646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2312),
  [4648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2960),
  [4650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_range_pattern, .child_count = 3, .production_id = 1),
  [4652] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_range_pattern, .child_count = 3, .production_id = 1),
  [4654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2598),
  [4656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [4658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [4660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [4662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [4664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2951),
  [4666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1832),
  [4668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [4670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3588),
  [4672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3456),
  [4674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3397),
  [4676] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = aux_sym_function_modifiers_repeat1, .child_count = 1),
  [4678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_extern_modifier, .child_count = 1),
  [4680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3331),
  [4682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2522),
  [4684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3334),
  [4686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_range_pattern, .child_count = 3, .production_id = 55),
  [4688] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_range_pattern, .child_count = 3, .production_id = 55),
  [4690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3021),
  [4692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2601),
  [4694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2284),
  [4696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2862),
  [4698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [4700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [4702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_range_pattern, .child_count = 3, .production_id = 59),
  [4704] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_range_pattern, .child_count = 3, .production_id = 59),
  [4706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [4708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1124),
  [4710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3460),
  [4712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3339),
  [4714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_range_pattern, .child_count = 3),
  [4716] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_range_pattern, .child_count = 3),
  [4718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [4720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2352),
  [4722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2800),
  [4724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3374),
  [4726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [4728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2346),
  [4730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2805),
  [4732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2467),
  [4734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3046),
  [4736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2245),
  [4738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1261),
  [4740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3437),
  [4742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3381),
  [4744] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_tuple_struct_pattern, .child_count = 5, .production_id = 61),
  [4746] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_struct_pattern, .child_count = 5, .production_id = 56),
  [4748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_tuple_pattern, .child_count = 5),
  [4750] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_slice_pattern, .child_count = 5),
  [4752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_tuple_struct_pattern, .child_count = 5, .production_id = 56),
  [4754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1809),
  [4756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1157),
  [4758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_struct_pattern, .child_count = 5, .production_id = 57),
  [4760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2581),
  [4762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3400),
  [4764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [4766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3399),
  [4768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1676),
  [4770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [4772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_tuple_struct_pattern, .child_count = 6, .production_id = 56),
  [4774] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_struct_pattern, .child_count = 6, .production_id = 57),
  [4776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_tuple_struct_pattern, .child_count = 6, .production_id = 61),
  [4778] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_struct_pattern, .child_count = 6, .production_id = 56),
  [4780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_tuple_pattern, .child_count = 3),
  [4782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_slice_pattern, .child_count = 3),
  [4784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_tuple_pattern, .child_count = 4),
  [4786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_reference_pattern, .child_count = 3),
  [4788] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_mut_pattern, .child_count = 2),
  [4790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [4792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3385),
  [4794] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_tuple_struct_pattern, .child_count = 3, .production_id = 56),
  [4796] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_struct_pattern, .child_count = 3, .production_id = 57),
  [4798] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_slice_pattern, .child_count = 4),
  [4800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_ref_pattern, .child_count = 2),
  [4802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1034),
  [4804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3384),
  [4806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2189),
  [4808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2558),
  [4810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2624),
  [4812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_remaining_field_pattern, .child_count = 1),
  [4814] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_tuple_struct_pattern, .child_count = 4, .production_id = 56),
  [4816] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_or_pattern, .child_count = 2),
  [4818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_struct_pattern, .child_count = 4, .production_id = 57),
  [4820] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_reference_pattern, .child_count = 2),
  [4822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_or_pattern, .child_count = 3),
  [4824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_tuple_struct_pattern, .child_count = 4, .production_id = 61),
  [4826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_captured_pattern, .child_count = 3),
  [4828] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_slice_pattern, .child_count = 2),
  [4830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_struct_pattern, .child_count = 3, .production_id = 56),
  [4832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_struct_pattern, .child_count = 4, .production_id = 56),
  [4834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_tuple_pattern, .child_count = 2),
  [4836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2602),
  [4838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1136),
  [4840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1501),
  [4842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3211),
  [4844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_tuple_struct_pattern, .child_count = 3, .production_id = 61),
  [4846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [4848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [4850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [4852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [4854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2080),
  [4856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2026),
  [4858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1472),
  [4860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [4862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1456),
  [4864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [4866] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_trait_bounds, .child_count = 2),
  [4868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [4870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [4872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1091),
  [4874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2099),
  [4876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1403),
  [4878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [4880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1125),
  [4882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [4884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [4886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [4888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [4890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1031),
  [4892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2565),
  [4894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [4896] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_trait_bounds_repeat1, .child_count = 2),
  [4898] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_trait_bounds_repeat1, .child_count = 2), SHIFT_REPEAT(850),
  [4901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1358),
  [4903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [4905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [4907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1029),
  [4909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3148),
  [4911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [4913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [4915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [4917] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_macro_definition_repeat1, .child_count = 2), SHIFT_REPEAT(74),
  [4920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_macro_definition_repeat1, .child_count = 2),
  [4922] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_macro_definition_repeat1, .child_count = 2), SHIFT_REPEAT(76),
  [4925] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_macro_definition_repeat1, .child_count = 2), SHIFT_REPEAT(77),
  [4928] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_trait_bounds, .child_count = 3),
  [4930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [4932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [4934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [4936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [4938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3034),
  [4940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [4942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2556),
  [4944] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = sym__type, .child_count = 1), REDUCE(.symbol = sym__pattern, .child_count = 1, .production_id = 1),
  [4947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [4949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1339),
  [4951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3220),
  [4953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1162),
  [4955] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_function_modifiers_repeat1, .child_count = 2), SHIFT_REPEAT(2324),
  [4958] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_function_modifiers_repeat1, .child_count = 2),
  [4960] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_function_modifiers_repeat1, .child_count = 2), SHIFT_REPEAT(2183),
  [4963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [4965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [4967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [4969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1251),
  [4971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [4973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [4975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [4977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [4979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [4981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [4983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [4985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1415),
  [4987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [4989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [4991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [4993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [4995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [4997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1265),
  [4999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [5001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [5003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [5005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [5007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [5009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2903),
  [5011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2096),
  [5013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3560),
  [5015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3049),
  [5017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3587),
  [5019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2115),
  [5021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3591),
  [5023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [5025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2062),
  [5027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1387),
  [5029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1129),
  [5031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1367),
  [5033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1353),
  [5035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_modifiers, .child_count = 1),
  [5037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2183),
  [5039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [5041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [5043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [5045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2775),
  [5047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3493),
  [5049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2798),
  [5051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3500),
  [5053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1449),
  [5055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [5057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2571),
  [5059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_extern_modifier, .child_count = 2),
  [5061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [5063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [5065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [5067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [5069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [5071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [5073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1158),
  [5075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [5077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [5079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [5081] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_attribute, .child_count = 1),
  [5083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [5085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [5087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [5089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3309),
  [5091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [5093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [5095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3547),
  [5097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [5099] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_enum_variant, .child_count = 2, .production_id = 6),
  [5101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [5103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3554),
  [5105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3327),
  [5107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2730),
  [5109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2776),
  [5111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [5113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [5115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [5117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3301),
  [5119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_self_parameter, .child_count = 2),
  [5121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(914),
  [5123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3203),
  [5125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3373),
  [5127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [5129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2071),
  [5131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3383),
  [5133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_enum_variant, .child_count = 1, .production_id = 70),
  [5135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [5137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3330),
  [5139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1038),
  [5141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2756),
  [5143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3359),
  [5145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [5147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2846),
  [5149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3303),
  [5151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2843),
  [5153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_attribute, .child_count = 1, .production_id = 1),
  [5155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [5157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2078),
  [5159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_self_parameter, .child_count = 1),
  [5161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(896),
  [5163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3272),
  [5165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1384),
  [5167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3530),
  [5169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1382),
  [5171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3277),
  [5173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1316),
  [5175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [5177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [5179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2086),
  [5181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3414),
  [5183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3549),
  [5185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [5187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3308),
  [5189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2084),
  [5191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3237),
  [5193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1277),
  [5195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2093),
  [5197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [5199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [5201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [5203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1409),
  [5205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2020),
  [5207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [5209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [5211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1411),
  [5213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1416),
  [5215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3365),
  [5217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3227),
  [5219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3368),
  [5221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3228),
  [5223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [5225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [5227] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = sym_parameters, .child_count = 2), REDUCE(.symbol = sym_tuple_struct_pattern, .child_count = 3, .production_id = 56),
  [5230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [5232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1283),
  [5234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1273),
  [5236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1269),
  [5238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [5240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1190),
  [5242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_self_parameter, .child_count = 3),
  [5244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [5246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2068),
  [5248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1236),
  [5250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [5252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1096),
  [5254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1291),
  [5256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1389),
  [5258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [5260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [5262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [5264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [5266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [5268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [5270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [5272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [5274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [5276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1343),
  [5278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1359),
  [5280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2465),
  [5282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2017),
  [5284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [5286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [5288] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = sym_parameters, .child_count = 3), REDUCE(.symbol = sym_tuple_struct_pattern, .child_count = 4, .production_id = 56),
  [5291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [5293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2468),
  [5295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2016),
  [5297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [5299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2015),
  [5301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [5303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1547),
  [5305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [5307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1518),
  [5309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2021),
  [5311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [5313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [5315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [5317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [5319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1916),
  [5321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [5323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [5325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1292),
  [5327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [5329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [5331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [5333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [5335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [5337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_ordered_field_declaration_list, .child_count = 5, .production_id = 219),
  [5339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_ordered_field_declaration_list, .child_count = 5, .production_id = 176),
  [5341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_ordered_field_declaration_list, .child_count = 5, .production_id = 63),
  [5343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [5345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_ordered_field_declaration_list, .child_count = 5, .production_id = 102),
  [5347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_ordered_field_declaration_list, .child_count = 3),
  [5349] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = sym_unit_type, .child_count = 2), REDUCE(.symbol = sym_tuple_pattern, .child_count = 2),
  [5352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [5354] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = sym__type, .child_count = 1), REDUCE(.symbol = sym__pattern, .child_count = 1),
  [5357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1297),
  [5359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [5361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [5363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2523),
  [5365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_ordered_field_declaration_list, .child_count = 3, .production_id = 22),
  [5367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_type_parameters_repeat1, .child_count = 2, .production_id = 76),
  [5369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3596),
  [5371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3099),
  [5373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3100),
  [5375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3429),
  [5377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1588),
  [5379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [5381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [5383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [5385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [5387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [5389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_ordered_field_declaration_list, .child_count = 6, .production_id = 219),
  [5391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_ordered_field_declaration_list, .child_count = 6, .production_id = 102),
  [5393] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_ordered_field_declaration_list, .child_count = 6, .production_id = 251),
  [5395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [5397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [5399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [5401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [5403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [5405] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym__use_clause, .child_count = 1),
  [5407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2247),
  [5409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3565),
  [5411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_ordered_field_declaration_list, .child_count = 7, .production_id = 251),
  [5413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1062),
  [5415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [5417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [5419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [5421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2459),
  [5423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2266),
  [5425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1947),
  [5427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [5429] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym__use_clause, .child_count = 1, .production_id = 1),
  [5431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2470),
  [5433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3531),
  [5435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2456),
  [5437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2023),
  [5439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1461),
  [5441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2018),
  [5443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [5445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [5447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [5449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(957),
  [5451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [5453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [5455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2637),
  [5457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [5459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [5461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [5463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2540),
  [5465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [5467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2603),
  [5469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [5471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [5473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [5475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [5477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2534),
  [5479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1400),
  [5481] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_type_arguments_repeat1, .child_count = 2),
  [5483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [5485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2622),
  [5487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2650),
  [5489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3483),
  [5491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3595),
  [5493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3481),
  [5495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3479),
  [5497] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = sym__pattern, .child_count = 1), SHIFT(1947),
  [5500] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = sym__pattern, .child_count = 1), SHIFT(400),
  [5503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2763),
  [5505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3457),
  [5507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_where_clause, .child_count = 2),
  [5509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [5511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2105),
  [5513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [5515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [5517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1147),
  [5519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_where_clause_repeat1, .child_count = 2),
  [5521] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_where_clause_repeat1, .child_count = 2), SHIFT_REPEAT(1466),
  [5524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [5526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1294),
  [5528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_type_parameters_repeat1, .child_count = 3, .production_id = 119),
  [5530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1429),
  [5532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1030),
  [5534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2766),
  [5536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1455),
  [5538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_ordered_field_declaration_list, .child_count = 2),
  [5540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [5542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_ordered_field_declaration_list, .child_count = 4, .production_id = 63),
  [5544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_ordered_field_declaration_list, .child_count = 4, .production_id = 22),
  [5546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1369),
  [5548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_ordered_field_declaration_list, .child_count = 4, .production_id = 176),
  [5550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1356),
  [5552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2022),
  [5554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1349),
  [5556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [5558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [5560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [5562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [5564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [5566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2665),
  [5568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2593),
  [5570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [5572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [5574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [5576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [5578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2848),
  [5580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [5582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [5584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2591),
  [5586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [5588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [5590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [5592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2623),
  [5594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [5596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2708),
  [5598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3077),
  [5600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [5602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2709),
  [5604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3117),
  [5606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [5608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [5610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [5612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [5614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2392),
  [5616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [5618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1893),
  [5620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3539),
  [5622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1033),
  [5624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2820),
  [5626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(159),
  [5628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2839),
  [5630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(161),
  [5632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [5634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [5636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2721),
  [5638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [5640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [5642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [5644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2718),
  [5646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [5648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [5650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [5652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1892),
  [5654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3461),
  [5656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1123),
  [5658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1047),
  [5660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [5662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1511),
  [5664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1917),
  [5666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [5668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2007),
  [5670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2003),
  [5672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1011),
  [5674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [5676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [5678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2689),
  [5680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [5682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2040),
  [5684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2146),
  [5686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2852),
  [5688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(166),
  [5690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1996),
  [5692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1804),
  [5694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1816),
  [5696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2087),
  [5698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [5700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2088),
  [5702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [5704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [5706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [5708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [5710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [5712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1910),
  [5714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [5716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1894),
  [5718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1987),
  [5720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [5722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [5724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [5726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [5728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2285),
  [5730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2289),
  [5732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3257),
  [5734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_slice_pattern_repeat1, .child_count = 2),
  [5736] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_slice_pattern_repeat1, .child_count = 2), SHIFT_REPEAT(794),
  [5739] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_parameters_repeat1, .child_count = 3),
  [5741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_type_binding, .child_count = 4, .production_id = 198),
  [5743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2874),
  [5745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(168),
  [5747] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_parameter, .child_count = 4, .production_id = 100),
  [5749] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_type_parameters_repeat1, .child_count = 2), REDUCE(.symbol = aux_sym_for_lifetimes_repeat1, .child_count = 2),
  [5752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1774),
  [5754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [5756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1900),
  [5758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1515),
  [5760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1534),
  [5762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [5764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [5766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [5768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1895),
  [5770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [5772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1533),
  [5774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [5776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [5778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [5780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [5782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [5784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2384),
  [5786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [5788] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_type_parameters_repeat1, .child_count = 3),
  [5790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2817),
  [5792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [5794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2816),
  [5796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [5798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1319),
  [5800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_macro_rule, .child_count = 3, .production_id = 48),
  [5802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_string_literal_repeat1, .child_count = 2),
  [5804] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_string_literal_repeat1, .child_count = 2), SHIFT_REPEAT(2848),
  [5807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2112),
  [5809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [5811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_parameters_repeat1, .child_count = 2),
  [5813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1224),
  [5815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [5817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1241),
  [5819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1186),
  [5821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1220),
  [5823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [5825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2514),
  [5827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_type_binding, .child_count = 3, .production_id = 147),
  [5829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [5831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_parameter, .child_count = 3, .production_id = 60),
  [5833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [5835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_where_predicate, .child_count = 2, .production_id = 78),
  [5837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1333),
  [5839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [5841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2518),
  [5843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_where_predicate, .child_count = 2, .production_id = 77),
  [5845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [5847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [5849] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_arguments_repeat1, .child_count = 2), SHIFT_REPEAT(209),
  [5852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_type_parameters_repeat1, .child_count = 2),
  [5854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2746),
  [5856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [5858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2748),
  [5860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [5862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2475),
  [5864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [5866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1326),
  [5868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [5870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2134),
  [5872] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_field_pattern, .child_count = 2, .production_id = 101),
  [5874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [5876] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_optional_type_parameter, .child_count = 3, .production_id = 118),
  [5878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2014),
  [5880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2782),
  [5882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2777),
  [5884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3545),
  [5886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3032),
  [5888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3592),
  [5890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1778),
  [5892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2081),
  [5894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2082),
  [5896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2011),
  [5898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1363),
  [5900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [5902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [5904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [5906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [5908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [5910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_use_as_clause, .child_count = 3, .production_id = 92),
  [5912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [5914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2107),
  [5916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2258),
  [5918] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_scoped_use_list, .child_count = 3, .production_id = 91),
  [5920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [5922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [5924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2478),
  [5926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [5928] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_use_wildcard, .child_count = 3),
  [5930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [5932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [5934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_use_as_clause, .child_count = 3, .production_id = 90),
  [5936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [5938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2855),
  [5940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2856),
  [5942] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_shorthand_field_initializer, .child_count = 2),
  [5944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [5946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_scoped_use_list, .child_count = 3, .production_id = 89),
  [5948] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_type_parameters_repeat1, .child_count = 2), SHIFT_REPEAT(2049),
  [5951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_use_wildcard, .child_count = 3, .production_id = 1),
  [5953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2747),
  [5955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2231),
  [5957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3263),
  [5959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1845),
  [5961] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_use_list, .child_count = 3),
  [5963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2745),
  [5965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2232),
  [5967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [5969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [5971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2276),
  [5973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2274),
  [5975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2273),
  [5977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1313),
  [5979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2271),
  [5981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2270),
  [5983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2268),
  [5985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [5987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3228),
  [5989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [5991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1431),
  [5993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [5995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1295),
  [5997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1001),
  [5999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [6001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [6003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1447),
  [6005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2129),
  [6007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [6009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [6011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [6013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2019),
  [6015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [6017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_use_list, .child_count = 4),
  [6019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3422),
  [6021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [6023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_use_list_repeat1, .child_count = 2),
  [6025] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_use_list_repeat1, .child_count = 2), SHIFT_REPEAT(1872),
  [6028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [6030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_enum_variant, .child_count = 2, .production_id = 11),
  [6032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [6034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [6036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2162),
  [6038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [6040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [6042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [6044] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym__condition, .child_count = 1, .production_id = 9),
  [6046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1302),
  [6048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [6050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [6052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1037),
  [6054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2136),
  [6056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1289),
  [6058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [6060] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_match_pattern, .child_count = 1),
  [6062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [6064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [6066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2120),
  [6068] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_field_initializer_list_repeat1, .child_count = 2),
  [6070] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_field_initializer_list_repeat1, .child_count = 2), SHIFT_REPEAT(2143),
  [6073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1234),
  [6075] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_use_wildcard, .child_count = 1),
  [6077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [6079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2075),
  [6081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [6083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1139),
  [6085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [6087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2157),
  [6089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [6091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_string_literal_repeat1, .child_count = 1),
  [6093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [6095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2206),
  [6097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [6099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [6101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2224),
  [6103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2228),
  [6105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2225),
  [6107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2235),
  [6109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2227),
  [6111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2233),
  [6113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [6115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3065),
  [6117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3544),
  [6119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3231),
  [6121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3540),
  [6123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_ordered_field_declaration_list_repeat1, .child_count = 4, .production_id = 102),
  [6125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [6127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_constrained_type_parameter, .child_count = 2, .production_id = 78),
  [6129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2024),
  [6131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [6133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_constrained_type_parameter, .child_count = 2, .production_id = 77),
  [6135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [6137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_field_pattern, .child_count = 5, .production_id = 242),
  [6139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [6141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [6143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2255),
  [6145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [6147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3173),
  [6149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2252),
  [6151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [6153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [6155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [6157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [6159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [6161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [6163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [6165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2131),
  [6167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [6169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [6171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1054),
  [6173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1209),
  [6175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [6177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_optional_type_parameter, .child_count = 3, .production_id = 117),
  [6179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [6181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [6183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3207),
  [6185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2010),
  [6187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2012),
  [6189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1255),
  [6191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_field_pattern, .child_count = 1, .production_id = 58),
  [6193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [6195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [6197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_closure_parameters_repeat1, .child_count = 2),
  [6199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [6201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_tuple_pattern_repeat1, .child_count = 2),
  [6203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2406),
  [6205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [6207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [6209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [6211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [6213] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_type_arguments_repeat1, .child_count = 2), SHIFT_REPEAT(442),
  [6216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2145),
  [6218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_ordered_field_declaration_list_repeat1, .child_count = 3, .production_id = 63),
  [6220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3078),
  [6222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [6224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1958),
  [6226] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_closure_parameters_repeat1, .child_count = 2), SHIFT_REPEAT(789),
  [6229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [6231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1881),
  [6233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2966),
  [6235] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_tuple_pattern_repeat1, .child_count = 2), SHIFT_REPEAT(760),
  [6238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_field_pattern, .child_count = 3, .production_id = 148),
  [6240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [6242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_field_pattern, .child_count = 3, .production_id = 149),
  [6244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3090),
  [6246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [6248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [6250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3166),
  [6252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1882),
  [6254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2941),
  [6256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1138),
  [6258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [6260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [6262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [6264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [6266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [6268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1225),
  [6270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_struct_pattern_repeat1, .child_count = 2),
  [6272] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_struct_pattern_repeat1, .child_count = 2), SHIFT_REPEAT(2357),
  [6275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [6277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2342),
  [6279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3535),
  [6281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3035),
  [6283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3586),
  [6285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [6287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_field_declaration, .child_count = 4, .production_id = 220),
  [6289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3344),
  [6291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3042),
  [6293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [6295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1211),
  [6297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2077),
  [6299] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_parameters_repeat1, .child_count = 2), SHIFT_REPEAT(412),
  [6302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_shorthand_field_initializer, .child_count = 1),
  [6304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [6306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [6308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [6310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [6312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2124),
  [6314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_self_parameter, .child_count = 4),
  [6316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1150),
  [6318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1160),
  [6320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [6322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_field_pattern, .child_count = 4, .production_id = 199),
  [6324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1883),
  [6326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_for_lifetimes_repeat1, .child_count = 2),
  [6328] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_for_lifetimes_repeat1, .child_count = 2), SHIFT_REPEAT(3124),
  [6331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [6333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1208),
  [6335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [6337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [6339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1237),
  [6341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [6343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1101),
  [6345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2125),
  [6347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [6349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1775),
  [6351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_enum_variant_list_repeat2, .child_count = 2),
  [6353] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_enum_variant_list_repeat2, .child_count = 2), SHIFT_REPEAT(2198),
  [6356] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_enum_variant, .child_count = 3, .production_id = 34),
  [6358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [6360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2156),
  [6362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [6364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [6366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_const_parameter, .child_count = 4, .production_id = 110),
  [6368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_scoped_use_list, .child_count = 2, .production_id = 36),
  [6370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2770),
  [6372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1838),
  [6374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [6376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [6378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1453),
  [6380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1450),
  [6382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_use_list, .child_count = 2),
  [6384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1421),
  [6386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1419),
  [6388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1399),
  [6390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1392),
  [6392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [6394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [6396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1375),
  [6398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [6400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2379),
  [6402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [6404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_ordered_field_declaration_list_repeat1, .child_count = 2, .production_id = 22),
  [6406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_ordered_field_declaration_list_repeat1, .child_count = 2, .production_id = 177),
  [6408] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_ordered_field_declaration_list_repeat1, .child_count = 2, .production_id = 177), SHIFT_REPEAT(767),
  [6411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1361),
  [6413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1276),
  [6415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_field_declaration, .child_count = 3, .production_id = 178),
  [6417] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_field_declaration_list_repeat1, .child_count = 2),
  [6419] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_field_declaration_list_repeat1, .child_count = 2), SHIFT_REPEAT(2188),
  [6422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2121),
  [6424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2116),
  [6426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2243),
  [6428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [6430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3070),
  [6432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_use_list, .child_count = 5),
  [6434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1590),
  [6436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1730),
  [6438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1594),
  [6440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [6442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_tuple_type_repeat1, .child_count = 2),
  [6444] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_tuple_type_repeat1, .child_count = 2), SHIFT_REPEAT(889),
  [6447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2269),
  [6449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [6451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2275),
  [6453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1918),
  [6455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1915),
  [6457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1352),
  [6459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3405),
  [6461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1081),
  [6463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1901),
  [6465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1887),
  [6467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3401),
  [6469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3555),
  [6471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3358),
  [6473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2528),
  [6475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1017),
  [6477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [6479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1522),
  [6481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1550),
  [6483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [6485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [6487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [6489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1891),
  [6491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3571),
  [6493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [6495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2724),
  [6497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3495),
  [6499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1530),
  [6501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1543),
  [6503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1904),
  [6505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_variadic_parameter, .child_count = 2),
  [6507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [6509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2520),
  [6511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2310),
  [6513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1526),
  [6515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1039),
  [6517] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_variadic_parameter, .child_count = 1),
  [6519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2532),
  [6521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1509),
  [6523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1557),
  [6525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [6527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2545),
  [6529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1884),
  [6531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3528),
  [6533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1897),
  [6535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [6537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3278),
  [6539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3273),
  [6541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2051),
  [6543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym__block_doc_comment_marker, .child_count = 1, .production_id = 3),
  [6545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym__block_doc_comment_marker, .child_count = 1, .production_id = 2),
  [6547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [6549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2141),
  [6551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_type_arguments_repeat1, .child_count = 3),
  [6553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_variadic_parameter, .child_count = 3, .production_id = 151),
  [6555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3597),
  [6557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3352),
  [6559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2579),
  [6561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2552),
  [6563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [6565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3258),
  [6567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2152),
  [6569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [6571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [6573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_variadic_parameter, .child_count = 4, .production_id = 32),
  [6575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [6577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3556),
  [6579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1078),
  [6581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1525),
  [6583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_enum_variant_list_repeat2, .child_count = 3),
  [6585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2005),
  [6587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1908),
  [6589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1920),
  [6591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1510),
  [6593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [6595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2335),
  [6597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_qualified_type, .child_count = 3, .production_id = 65),
  [6599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [6601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1524),
  [6603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [6605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3376),
  [6607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1994),
  [6609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1906),
  [6611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1909),
  [6613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3447),
  [6615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3445),
  [6617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2678),
  [6619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [6621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1528),
  [6623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3092),
  [6625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1523),
  [6627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2495),
  [6629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1965),
  [6631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2493),
  [6633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3287),
  [6635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1021),
  [6637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_field_declaration_list_repeat1, .child_count = 3),
  [6639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2046),
  [6641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1014),
  [6643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1964),
  [6645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [6647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3362),
  [6649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3391),
  [6651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3318),
  [6653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2002),
  [6655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [6657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2004),
  [6659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3492),
  [6661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1998),
  [6663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3195),
  [6665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2048),
  [6667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2165),
  [6669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2009),
  [6671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2039),
  [6673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1048),
  [6675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1997),
  [6677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1112),
  [6679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3430),
  [6681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2000),
  [6683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2515),
  [6685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1999),
  [6687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2008),
  [6689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1521),
  [6691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1512),
  [6693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [6695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [6697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2675),
  [6699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3238),
  [6701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [6703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [6705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2644),
  [6707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2577),
  [6709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_attribute, .child_count = 2, .production_id = 69),
  [6711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2122),
  [6713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2885),
  [6715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2320),
  [6717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3417),
  [6719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2542),
  [6721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [6723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2316),
  [6725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [6727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3274),
  [6729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [6731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3357),
  [6733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2326),
  [6735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2974),
  [6737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3292),
  [6739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2128),
  [6741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3085),
  [6743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2195),
  [6745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2341),
  [6747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3463),
  [6749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [6751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3128),
  [6753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2190),
  [6755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3023),
  [6757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3024),
  [6759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2374),
  [6761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2734),
  [6763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2163),
  [6765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2377),
  [6767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3226),
  [6769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [6771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3106),
  [6773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [6775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [6777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3109),
  [6779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [6781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2288),
  [6783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [6785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1346),
  [6787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [6789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3601),
  [6791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2592),
  [6793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3114),
  [6795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [6797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [6799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3567),
  [6801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2211),
  [6803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2191),
  [6805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [6807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3489),
  [6809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [6811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1268),
  [6813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1808),
  [6815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3544),
  [6817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3330),
  [6819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [6821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2221),
  [6823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3271),
  [6825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2226),
  [6827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [6829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [6831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [6833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1301),
  [6835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [6837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [6839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [6841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [6843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1203),
  [6845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1914),
  [6847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [6849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1828),
  [6851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [6853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1318),
  [6855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1194),
  [6857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2387),
  [6859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [6861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3444),
  [6863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [6865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1889),
  [6867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1812),
  [6869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1321),
  [6871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3224),
  [6873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3415),
  [6875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1188),
  [6877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3524),
  [6879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [6881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2635),
  [6883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [6885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [6887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3171),
  [6889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1989),
  [6891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3186),
  [6893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [6895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1315),
  [6897] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_bracketed_type, .child_count = 3),
  [6899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_attribute, .child_count = 2, .production_id = 68),
  [6901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [6903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1004),
  [6905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1716),
  [6907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3159),
  [6909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1137),
  [6911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3598),
  [6913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3469),
  [6915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1083),
  [6917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1820),
  [6919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [6921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [6923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2349),
  [6925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [6927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [6929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [6931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [6933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1437),
  [6935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1406),
  [6937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [6939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3573),
  [6941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1428),
  [6943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2881),
  [6945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2365),
  [6947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [6949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [6951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3083),
  [6953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1467),
  [6955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1516),
  [6957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3094),
  [6959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [6961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3175),
  [6963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2356),
  [6965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3102),
  [6967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1407),
  [6969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2560),
  [6971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3116),
  [6973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [6975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1229),
  [6977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [6979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3600),
  [6981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym__line_doc_comment_marker, .child_count = 1, .production_id = 3),
  [6983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [6985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym__line_doc_comment_marker, .child_count = 1, .production_id = 2),
  [6987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1084),
  [6989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3599),
  [6991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3347),
  [6993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1232),
  [6995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2564),
  [6997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1469),
  [6999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3170),
  [7001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [7003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [7005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3174),
  [7007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [7009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3214),
  [7011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2923),
  [7013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2550),
  [7015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [7017] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [7019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3387),
  [7021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1258),
  [7023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3268),
  [7025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [7027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3367),
  [7029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3283),
  [7031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3286),
  [7033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3267),
  [7035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3285),
  [7037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1371),
  [7039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1613),
  [7041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [7043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2538),
  [7045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1888),
  [7047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1890),
  [7049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3356),
  [7051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(996),
  [7053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2759),
  [7055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [7057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [7059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [7061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2457),
  [7063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2617),
  [7065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2339),
  [7067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1967),
  [7069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3391),
  [7071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [7073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2202),
  [7075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [7077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [7079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [7081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2135),
  [7083] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_match_pattern, .child_count = 3, .production_id = 173),
  [7085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [7087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1312),
  [7089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [7091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [7093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3371),
  [7095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [7097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [7099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [7101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [7103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(978),
  [7105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [7107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [7109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2742),
  [7111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(994),
  [7113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [7115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2497),
  [7117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1885),
  [7119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1886),
  [7121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3475),
  [7123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [7125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2494),
  [7127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3498),
  [7129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1434),
  [7131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [7133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3508),
  [7135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3512),
  [7137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3515),
  [7139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2827),
  [7141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [7143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3545),
  [7145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2724),
  [7147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2743),
  [7149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3060),
  [7151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3555),
  [7153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2280),
  [7155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1435),
  [7157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_line_comment, .child_count = 2),
  [7159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_block_comment, .child_count = 2),
  [7161] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_block_comment, .child_count = 3, .production_id = 15),
  [7163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_block_comment, .child_count = 3),
  [7165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_line_comment, .child_count = 3),
  [7167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_line_comment, .child_count = 3, .production_id = 14),
  [7169] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_block_comment, .child_count = 4, .production_id = 53),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token_string_content = 0,
  ts_external_token__raw_string_literal_start = 1,
  ts_external_token_raw_string_literal_content = 2,
  ts_external_token__raw_string_literal_end = 3,
  ts_external_token_float_literal = 4,
  ts_external_token__outer_block_doc_comment_marker = 5,
  ts_external_token__inner_block_doc_comment_marker = 6,
  ts_external_token__block_comment_content = 7,
  ts_external_token__line_doc_content = 8,
  ts_external_token__error_sentinel = 9,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token_string_content] = sym_string_content,
  [ts_external_token__raw_string_literal_start] = sym__raw_string_literal_start,
  [ts_external_token_raw_string_literal_content] = sym_raw_string_literal_content,
  [ts_external_token__raw_string_literal_end] = sym__raw_string_literal_end,
  [ts_external_token_float_literal] = sym_float_literal,
  [ts_external_token__outer_block_doc_comment_marker] = sym__outer_block_doc_comment_marker,
  [ts_external_token__inner_block_doc_comment_marker] = sym__inner_block_doc_comment_marker,
  [ts_external_token__block_comment_content] = sym__block_comment_content,
  [ts_external_token__line_doc_content] = sym__line_doc_content,
  [ts_external_token__error_sentinel] = sym__error_sentinel,
};

static const bool ts_external_scanner_states[10][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token_string_content] = true,
    [ts_external_token__raw_string_literal_start] = true,
    [ts_external_token_raw_string_literal_content] = true,
    [ts_external_token__raw_string_literal_end] = true,
    [ts_external_token_float_literal] = true,
    [ts_external_token__outer_block_doc_comment_marker] = true,
    [ts_external_token__inner_block_doc_comment_marker] = true,
    [ts_external_token__block_comment_content] = true,
    [ts_external_token__line_doc_content] = true,
    [ts_external_token__error_sentinel] = true,
  },
  [2] = {
    [ts_external_token__raw_string_literal_start] = true,
    [ts_external_token_float_literal] = true,
  },
  [3] = {
    [ts_external_token__outer_block_doc_comment_marker] = true,
    [ts_external_token__inner_block_doc_comment_marker] = true,
    [ts_external_token__block_comment_content] = true,
  },
  [4] = {
    [ts_external_token_string_content] = true,
  },
  [5] = {
    [ts_external_token__block_comment_content] = true,
  },
  [6] = {
    [ts_external_token_float_literal] = true,
  },
  [7] = {
    [ts_external_token_raw_string_literal_content] = true,
  },
  [8] = {
    [ts_external_token__raw_string_literal_end] = true,
  },
  [9] = {
    [ts_external_token__line_doc_content] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_rust_external_scanner_create(void);
void tree_sitter_rust_external_scanner_destroy(void *);
bool tree_sitter_rust_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_rust_external_scanner_serialize(void *, char *);
void tree_sitter_rust_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_rust() {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_rust_external_scanner_create,
      tree_sitter_rust_external_scanner_destroy,
      tree_sitter_rust_external_scanner_scan,
      tree_sitter_rust_external_scanner_serialize,
      tree_sitter_rust_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
